#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 5552
#define LARGE_STATE_COUNT 3425
#define SYMBOL_COUNT 656
#define ALIAS_COUNT 6
#define TOKEN_COUNT 364
#define EXTERNAL_TOKEN_COUNT 18
#define FIELD_COUNT 28
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 73

enum ts_symbol_identifiers {
  sym_identifier = 1,
  sym_comment = 2,
  anon_sym_LPAREN_STAR = 3,
  anon_sym_STAR_RPAREN = 4,
  aux_sym_block_comment_text_token1 = 5,
  aux_sym_block_comment_text_token2 = 6,
  aux_sym_block_comment_text_token3 = 7,
  aux_sym_block_comment_text_token4 = 8,
  anon_sym_MODULE = 9,
  anon_sym_DASH_DASH_DASH_DASH = 10,
  aux_sym_single_line_token1 = 11,
  anon_sym_EQ_EQ_EQ_EQ = 12,
  aux_sym_double_line_token1 = 13,
  anon_sym_EQ_EQ = 14,
  anon_sym_u225c = 15,
  anon_sym_BSLASHin = 16,
  anon_sym_u2208 = 17,
  anon_sym_LT_DASH = 18,
  anon_sym_u27f5 = 19,
  anon_sym_u2190 = 20,
  anon_sym_BSLASHA = 21,
  anon_sym_BSLASHforall = 22,
  anon_sym_u2200 = 23,
  anon_sym_BSLASHE = 24,
  anon_sym_BSLASHexists = 25,
  anon_sym_u2203 = 26,
  sym_temporal_forall = 27,
  sym_temporal_exists = 28,
  anon_sym_PIPE_DASH_GT = 29,
  anon_sym_u27fc = 30,
  anon_sym_u21a6 = 31,
  anon_sym_DASH_GT = 32,
  anon_sym_u27f6 = 33,
  anon_sym_u2192 = 34,
  anon_sym_LT_LT = 35,
  anon_sym_u3008 = 36,
  anon_sym_u27e8 = 37,
  anon_sym_GT_GT = 38,
  anon_sym_u3009 = 39,
  anon_sym_u27e9 = 40,
  anon_sym_GT_GT_ = 41,
  anon_sym_u3009_ = 42,
  anon_sym_u27e9_ = 43,
  anon_sym_LBRACK_RBRACK = 44,
  anon_sym_u25a1 = 45,
  anon_sym_COLON = 46,
  anon_sym_AT = 47,
  anon_sym_COLON_COLON = 48,
  anon_sym_u2237 = 49,
  sym_placeholder = 50,
  anon_sym_SLASH_BSLASH = 51,
  anon_sym_u2227 = 52,
  anon_sym_BSLASH_SLASH = 53,
  anon_sym_u2228 = 54,
  anon_sym_EXTENDS = 55,
  anon_sym_COMMA = 56,
  anon_sym_LOCAL = 57,
  anon_sym_VARIABLE = 58,
  anon_sym_VARIABLES = 59,
  anon_sym_CONSTANT = 60,
  anon_sym_CONSTANTS = 61,
  anon_sym_RECURSIVE = 62,
  anon_sym_LPAREN = 63,
  anon_sym_RPAREN = 64,
  anon_sym_LBRACK = 65,
  anon_sym_RBRACK = 66,
  anon_sym_INSTANCE = 67,
  anon_sym_WITH = 68,
  anon_sym_BANG = 69,
  aux_sym_child_id_token1 = 70,
  anon_sym_LAMBDA = 71,
  sym_real_number = 72,
  anon_sym_BSLASHb = 73,
  anon_sym_BSLASHB = 74,
  aux_sym_binary_number_token1 = 75,
  anon_sym_BSLASHo = 76,
  anon_sym_BSLASHO = 77,
  aux_sym_octal_number_token1 = 78,
  anon_sym_BSLASHh = 79,
  anon_sym_BSLASHH = 80,
  aux_sym_hex_number_token1 = 81,
  anon_sym_DQUOTE = 82,
  aux_sym_string_token1 = 83,
  anon_sym_DQUOTE2 = 84,
  sym_escape_char = 85,
  anon_sym_TRUE = 86,
  anon_sym_FALSE = 87,
  sym_string_set = 88,
  sym_boolean_set = 89,
  anon_sym_Nat = 90,
  anon_sym_u2115 = 91,
  anon_sym_Int = 92,
  anon_sym_u2124 = 93,
  anon_sym_Real = 94,
  anon_sym_u211d = 95,
  anon_sym_CHOOSE = 96,
  anon_sym_LBRACE = 97,
  anon_sym_RBRACE = 98,
  anon_sym_DOT = 99,
  anon_sym_EXCEPT = 100,
  anon_sym_EQ = 101,
  anon_sym_RBRACK_ = 102,
  anon_sym_WF_ = 103,
  anon_sym_SF_ = 104,
  anon_sym_IF = 105,
  anon_sym_THEN = 106,
  anon_sym_ELSE = 107,
  anon_sym_CASE = 108,
  anon_sym_OTHER = 109,
  anon_sym_LET = 110,
  anon_sym_IN = 111,
  anon_sym_BSLASHlnot = 112,
  anon_sym_BSLASHneg = 113,
  anon_sym_TILDE = 114,
  anon_sym_u00ac = 115,
  sym_union = 116,
  sym_powerset = 117,
  sym_domain = 118,
  anon_sym_DASH = 119,
  sym_negative_dot = 120,
  sym_enabled = 121,
  sym_unchanged = 122,
  anon_sym_LT_GT = 123,
  anon_sym_u22c4 = 124,
  anon_sym_u25c7 = 125,
  anon_sym_EQ_GT = 126,
  anon_sym_u27f9 = 127,
  anon_sym_u21d2 = 128,
  anon_sym_DASH_PLUS_DASH_GT = 129,
  anon_sym_u21f8 = 130,
  anon_sym_u2945 = 131,
  anon_sym_BSLASHequiv = 132,
  anon_sym_u2261 = 133,
  anon_sym_LT_EQ_GT = 134,
  anon_sym_u27fa = 135,
  anon_sym_u21d4 = 136,
  anon_sym_TILDE_GT = 137,
  anon_sym_u21dd = 138,
  anon_sym_u219d = 139,
  anon_sym_BSLASHland = 140,
  anon_sym_BSLASHlor = 141,
  anon_sym_COLON_EQ = 142,
  anon_sym_u2254 = 143,
  anon_sym_COLON_COLON_EQ = 144,
  anon_sym_u2a74 = 145,
  anon_sym_SLASH_EQ = 146,
  anon_sym_POUND = 147,
  anon_sym_u2260 = 148,
  anon_sym_LT = 149,
  sym_gt = 150,
  anon_sym_LT_EQ = 151,
  anon_sym_EQ_LT = 152,
  anon_sym_BSLASHleq = 153,
  anon_sym_u2264 = 154,
  anon_sym_GT_EQ = 155,
  anon_sym_BSLASHgeq = 156,
  anon_sym_u2265 = 157,
  anon_sym_BSLASHapprox = 158,
  anon_sym_u2248 = 159,
  anon_sym_PIPE_DASH = 160,
  anon_sym_u22a2 = 161,
  anon_sym_PIPE_EQ = 162,
  anon_sym_u22a8 = 163,
  anon_sym_DASH_PIPE = 164,
  anon_sym_u22a3 = 165,
  anon_sym_EQ_PIPE = 166,
  anon_sym_u2ae4 = 167,
  anon_sym_BSLASHasymp = 168,
  anon_sym_u224d = 169,
  anon_sym_BSLASHcong = 170,
  anon_sym_u2245 = 171,
  anon_sym_BSLASHdoteq = 172,
  anon_sym_u2250 = 173,
  anon_sym_BSLASHgg = 174,
  anon_sym_u226b = 175,
  anon_sym_BSLASHll = 176,
  anon_sym_u226a = 177,
  anon_sym_BSLASHnotin = 178,
  anon_sym_u2209 = 179,
  anon_sym_BSLASHprec = 180,
  anon_sym_u227a = 181,
  anon_sym_BSLASHsucc = 182,
  anon_sym_u227b = 183,
  anon_sym_BSLASHpreceq = 184,
  anon_sym_u2aaf = 185,
  anon_sym_BSLASHsucceq = 186,
  anon_sym_u2ab0 = 187,
  anon_sym_BSLASHpropto = 188,
  anon_sym_u221d = 189,
  anon_sym_BSLASHsim = 190,
  anon_sym_u223c = 191,
  anon_sym_BSLASHsimeq = 192,
  anon_sym_u2243 = 193,
  anon_sym_BSLASHsqsubset = 194,
  anon_sym_u228f = 195,
  anon_sym_BSLASHsqsupset = 196,
  anon_sym_u2290 = 197,
  anon_sym_BSLASHsqsubseteq = 198,
  anon_sym_u2291 = 199,
  anon_sym_BSLASHsqsupseteq = 200,
  anon_sym_u2292 = 201,
  anon_sym_BSLASHsubset = 202,
  anon_sym_u2282 = 203,
  anon_sym_BSLASHsupset = 204,
  anon_sym_u2283 = 205,
  anon_sym_BSLASHsubseteq = 206,
  anon_sym_u2286 = 207,
  anon_sym_BSLASHsupseteq = 208,
  anon_sym_u2287 = 209,
  sym_compose = 210,
  sym_map_to = 211,
  sym_map_from = 212,
  sym_setminus = 213,
  anon_sym_BSLASHcap = 214,
  anon_sym_BSLASHintersect = 215,
  anon_sym_u2229 = 216,
  anon_sym_BSLASHcup = 217,
  anon_sym_BSLASHunion = 218,
  anon_sym_u222a = 219,
  anon_sym_DOT_DOT = 220,
  anon_sym_u2025 = 221,
  anon_sym_DOT_DOT_DOT = 222,
  anon_sym_u2026 = 223,
  anon_sym_PLUS = 224,
  sym_plusplus = 225,
  anon_sym_BSLASHoplus = 226,
  anon_sym_LPAREN_PLUS_RPAREN = 227,
  anon_sym_u2295 = 228,
  anon_sym_BSLASHominus = 229,
  anon_sym_LPAREN_DASH_RPAREN = 230,
  anon_sym_u2296 = 231,
  sym_mod = 232,
  sym_modmod = 233,
  sym_vert = 234,
  anon_sym_PIPE_PIPE = 235,
  anon_sym_u2016 = 236,
  sym_minusminus = 237,
  sym_amp = 238,
  sym_ampamp = 239,
  anon_sym_BSLASHodot = 240,
  anon_sym_LPAREN_DOT_RPAREN = 241,
  anon_sym_u2299 = 242,
  anon_sym_BSLASHoslash = 243,
  anon_sym_LPAREN_SLASH_RPAREN = 244,
  anon_sym_u2298 = 245,
  anon_sym_BSLASHotimes = 246,
  anon_sym_LPAREN_BSLASHX_RPAREN = 247,
  anon_sym_u2297 = 248,
  sym_mul = 249,
  sym_mulmul = 250,
  sym_slash = 251,
  sym_slashslash = 252,
  anon_sym_BSLASHbigcirc = 253,
  anon_sym_u25ef = 254,
  anon_sym_BSLASHbullet = 255,
  anon_sym_u25cf = 256,
  anon_sym_BSLASHdiv = 257,
  anon_sym_u00f7 = 258,
  anon_sym_BSLASHcirc = 259,
  anon_sym_u2218 = 260,
  anon_sym_BSLASHstar = 261,
  anon_sym_u22c6 = 262,
  anon_sym_u203c = 263,
  sym_hashhash = 264,
  sym_dol = 265,
  sym_doldol = 266,
  anon_sym_QMARK_QMARK = 267,
  anon_sym_u2047 = 268,
  anon_sym_BSLASHsqcap = 269,
  anon_sym_u2293 = 270,
  anon_sym_BSLASHsqcup = 271,
  anon_sym_u2294 = 272,
  anon_sym_BSLASHuplus = 273,
  anon_sym_u228e = 274,
  anon_sym_BSLASHX = 275,
  anon_sym_BSLASHtimes = 276,
  anon_sym_u00d7 = 277,
  anon_sym_BSLASHwr = 278,
  anon_sym_u2240 = 279,
  anon_sym_BSLASHcdot = 280,
  anon_sym_u22c5 = 281,
  sym_pow = 282,
  sym_powpow = 283,
  anon_sym_CARET_PLUS = 284,
  anon_sym_u207a = 285,
  sym_asterisk = 286,
  sym_sup_hash = 287,
  sym_prime = 288,
  anon_sym_ASSUME = 289,
  anon_sym_ASSUMPTION = 290,
  anon_sym_AXIOM = 291,
  anon_sym_THEOREM = 292,
  anon_sym_PROPOSITION = 293,
  anon_sym_LEMMA = 294,
  anon_sym_COROLLARY = 295,
  anon_sym_PROVE = 296,
  anon_sym_NEW = 297,
  anon_sym_STATE = 298,
  anon_sym_ACTION = 299,
  anon_sym_TEMPORAL = 300,
  anon_sym_PROOF = 301,
  anon_sym_BY = 302,
  anon_sym_ONLY = 303,
  anon_sym_OBVIOUS = 304,
  anon_sym_OMITTED = 305,
  anon_sym_DEFINE = 306,
  anon_sym_HAVE = 307,
  anon_sym_WITNESS = 308,
  anon_sym_TAKE = 309,
  anon_sym_SUFFICES = 310,
  anon_sym_PICK = 311,
  anon_sym_QED = 312,
  anon_sym_USE = 313,
  anon_sym_HIDE = 314,
  anon_sym_DEF = 315,
  anon_sym_DEFS = 316,
  aux_sym_proof_step_id_token1 = 317,
  anon_sym_GT = 318,
  aux_sym_proof_step_id_token2 = 319,
  aux_sym_proof_step_id_token3 = 320,
  aux_sym_proof_step_ref_token1 = 321,
  aux_sym_proof_step_ref_token2 = 322,
  anon_sym_end = 323,
  anon_sym_algorithm = 324,
  anon_sym_SEMI = 325,
  anon_sym_DASH_DASHalgorithm = 326,
  anon_sym_DASH_DASHfair = 327,
  anon_sym_define = 328,
  anon_sym_macro = 329,
  anon_sym_procedure = 330,
  anon_sym_fair = 331,
  anon_sym_process = 332,
  anon_sym_variable = 333,
  anon_sym_variables = 334,
  anon_sym_begin = 335,
  anon_sym_if = 336,
  anon_sym_then = 337,
  anon_sym_elsif = 338,
  anon_sym_else = 339,
  anon_sym_while = 340,
  anon_sym_do = 341,
  anon_sym_either = 342,
  anon_sym_or = 343,
  anon_sym_with = 344,
  anon_sym_await = 345,
  anon_sym_when = 346,
  anon_sym_print = 347,
  anon_sym_assert = 348,
  sym_pcal_skip = 349,
  sym_pcal_return = 350,
  anon_sym_goto = 351,
  anon_sym_call = 352,
  sym_leading_extramodular_text = 353,
  sym_trailing_extramodular_text = 354,
  sym__indent = 355,
  sym__bullet = 356,
  sym__dedent = 357,
  sym__begin_proof = 358,
  sym__begin_proof_step = 359,
  sym__notify_pcal_algorithm_start = 360,
  sym__notify_pcal_algorithm_end = 361,
  sym__double_excl = 362,
  sym__error_sentinel = 363,
  sym_source_file = 364,
  sym_block_comment = 365,
  sym_block_comment_text = 366,
  sym_module = 367,
  sym_single_line = 368,
  sym_double_line = 369,
  sym_def_eq = 370,
  sym_set_in = 371,
  sym_gets = 372,
  sym_forall = 373,
  sym_exists = 374,
  sym_all_map_to = 375,
  sym_maps_to = 376,
  sym_langle_bracket = 377,
  sym_rangle_bracket = 378,
  sym_rangle_bracket_sub = 379,
  sym_case_box = 380,
  sym_case_arrow = 381,
  sym_colon = 382,
  sym_address = 383,
  sym_label_as = 384,
  sym_bullet_conj = 385,
  sym_bullet_disj = 386,
  sym_extends = 387,
  sym__unit = 388,
  sym_local_definition = 389,
  sym__definition = 390,
  sym_variable_declaration = 391,
  sym_constant_declaration = 392,
  sym_recursive_declaration = 393,
  sym_operator_declaration = 394,
  sym__id_or_op_declaration = 395,
  sym_operator_definition = 396,
  sym_function_definition = 397,
  sym_instance = 398,
  sym_substitution = 399,
  sym__op_or_expr = 400,
  sym__op = 401,
  sym_subexpr_prefix = 402,
  sym_subexpr_component = 403,
  sym_bound_op = 404,
  sym_bound_nonfix_op = 405,
  sym_subexpr_tree_nav = 406,
  sym_child_id = 407,
  sym_operator_args = 408,
  sym_lambda = 409,
  sym_module_definition = 410,
  sym__expr = 411,
  sym__subscript_expr = 412,
  sym_prefixed_op = 413,
  sym__number = 414,
  sym_nat_number = 415,
  sym_binary_number = 416,
  sym_octal_number = 417,
  sym_hex_number = 418,
  sym_string = 419,
  sym_boolean = 420,
  sym__number_set = 421,
  sym__primitive_value_set = 422,
  sym_nat_number_set = 423,
  sym_int_number_set = 424,
  sym_real_number_set = 425,
  sym_label = 426,
  sym_subexpression = 427,
  sym_parentheses = 428,
  sym_bounded_quantification = 429,
  sym_unbounded_quantification = 430,
  sym_choose = 431,
  sym_finite_set_literal = 432,
  sym_set_filter = 433,
  sym_set_map = 434,
  sym_quantifier_bound = 435,
  sym_restricted_quantifier_bound = 436,
  sym_tuple_of_identifiers = 437,
  sym_function_evaluation = 438,
  sym_function_literal = 439,
  sym_set_of_functions = 440,
  sym_record_literal = 441,
  sym_set_of_records = 442,
  sym_record_value = 443,
  sym_except = 444,
  sym_except_update = 445,
  sym_except_update_specifier = 446,
  sym_except_update_record_field = 447,
  sym_except_update_fn_appl = 448,
  sym_prev_func_val = 449,
  sym_tuple_literal = 450,
  sym_step_expr_or_stutter = 451,
  sym_step_expr_no_stutter = 452,
  sym_fairness = 453,
  sym_if_then_else = 454,
  sym_case = 455,
  sym_case_arm = 456,
  sym_other_arm = 457,
  sym_let_in = 458,
  sym_conj_list = 459,
  sym_conj_item = 460,
  sym_disj_list = 461,
  sym_disj_item = 462,
  sym_lnot = 463,
  sym_negative = 464,
  sym_always = 465,
  sym_eventually = 466,
  sym_prefix_op_symbol = 467,
  sym_bound_prefix_op = 468,
  sym_implies = 469,
  sym_plus_arrow = 470,
  sym_equiv = 471,
  sym_iff = 472,
  sym_leads_to = 473,
  sym_land = 474,
  sym_lor = 475,
  sym_assign = 476,
  sym_bnf_rule = 477,
  sym_eq = 478,
  sym_neq = 479,
  sym_lt = 480,
  sym_leq = 481,
  sym_geq = 482,
  sym_approx = 483,
  sym_rs_ttile = 484,
  sym_rd_ttile = 485,
  sym_ls_ttile = 486,
  sym_ld_ttile = 487,
  sym_asymp = 488,
  sym_cong = 489,
  sym_doteq = 490,
  sym_gg = 491,
  sym_ll = 492,
  sym_in = 493,
  sym_notin = 494,
  sym_prec = 495,
  sym_succ = 496,
  sym_preceq = 497,
  sym_succeq = 498,
  sym_propto = 499,
  sym_sim = 500,
  sym_simeq = 501,
  sym_sqsubset = 502,
  sym_sqsupset = 503,
  sym_sqsubseteq = 504,
  sym_sqsupseteq = 505,
  sym_subset = 506,
  sym_supset = 507,
  sym_subseteq = 508,
  sym_supseteq = 509,
  sym_cap = 510,
  sym_cup = 511,
  sym_dots_2 = 512,
  sym_dots_3 = 513,
  sym_plus = 514,
  sym_oplus = 515,
  sym_ominus = 516,
  sym_vertvert = 517,
  sym_minus = 518,
  sym_odot = 519,
  sym_oslash = 520,
  sym_otimes = 521,
  sym_bigcirc = 522,
  sym_bullet = 523,
  sym_div = 524,
  sym_circ = 525,
  sym_star = 526,
  sym_excl = 527,
  sym_qq = 528,
  sym_sqcap = 529,
  sym_sqcup = 530,
  sym_uplus = 531,
  sym_times = 532,
  sym_wr = 533,
  sym_cdot = 534,
  sym_infix_op_symbol = 535,
  sym_bound_infix_op = 536,
  sym_sup_plus = 537,
  sym_postfix_op_symbol = 538,
  sym_bound_postfix_op = 539,
  sym_assumption = 540,
  sym_theorem = 541,
  sym_assume_prove = 542,
  sym_inner_assume_prove = 543,
  sym_new = 544,
  sym_statement_level = 545,
  sym__proof = 546,
  sym_terminal_proof = 547,
  sym_non_terminal_proof = 548,
  sym_proof_step = 549,
  sym_definition_proof_step = 550,
  sym_have_proof_step = 551,
  sym_witness_proof_step = 552,
  sym_take_proof_step = 553,
  sym_suffices_proof_step = 554,
  sym_case_proof_step = 555,
  sym_pick_proof_step = 556,
  sym__bound_or_identifier_list = 557,
  sym_qed_step = 558,
  sym_use_or_hide = 559,
  sym_use_body = 560,
  sym_use_body_expr = 561,
  sym_use_body_def = 562,
  sym_module_ref = 563,
  sym_proof_step_id = 564,
  sym_proof_step_ref = 565,
  sym_pcal_algorithm = 566,
  sym__pcal_p_algorithm = 567,
  sym__pcal_c_algorithm = 568,
  sym_pcal_algorithm_start = 569,
  sym_fair = 570,
  sym_pcal_p_definitions = 571,
  sym_pcal_c_definitions = 572,
  sym_pcal_p_macro = 573,
  sym_pcal_c_macro = 574,
  sym_pcal_macro_decl = 575,
  sym_pcal_p_procedure = 576,
  sym_pcal_c_procedure = 577,
  sym_pcal_proc_decl = 578,
  sym_pcal_p_process = 579,
  sym_pcal_c_process = 580,
  sym_pcal_var_decls = 581,
  sym_pcal_var_decl = 582,
  sym_pcal_proc_var_decls = 583,
  sym_pcal_proc_var_decl = 584,
  sym_pcal_p_algorithm_body = 585,
  sym__pcal_p_stmts = 586,
  sym_pcal_c_algorithm_body = 587,
  sym__pcal_p_stmt = 588,
  sym__pcal_c_stmt = 589,
  sym__pcal_label = 590,
  sym__pcal_p_unlabeled_stmt = 591,
  sym__pcal_c_unlabeled_stmt = 592,
  sym_pcal_assign = 593,
  sym_pcal_lhs = 594,
  sym_pcal_p_if = 595,
  sym_pcal_c_if = 596,
  sym_pcal_p_while = 597,
  sym_pcal_c_while = 598,
  sym_pcal_p_either = 599,
  sym_pcal_c_either = 600,
  sym_pcal_p_with = 601,
  sym_pcal_c_with = 602,
  sym__pcal_with_vars = 603,
  sym_pcal_await = 604,
  sym_pcal_print = 605,
  sym_pcal_assert = 606,
  sym_pcal_goto = 607,
  sym_pcal_proc_call = 608,
  sym_pcal_macro_call = 609,
  aux_sym_source_file_repeat1 = 610,
  aux_sym_source_file_repeat2 = 611,
  aux_sym_block_comment_repeat1 = 612,
  aux_sym_block_comment_text_repeat1 = 613,
  aux_sym_extends_repeat1 = 614,
  aux_sym_variable_declaration_repeat1 = 615,
  aux_sym_constant_declaration_repeat1 = 616,
  aux_sym_operator_declaration_repeat1 = 617,
  aux_sym_function_definition_repeat1 = 618,
  aux_sym_instance_repeat1 = 619,
  aux_sym_subexpr_prefix_repeat1 = 620,
  aux_sym_bound_op_repeat1 = 621,
  aux_sym_string_repeat1 = 622,
  aux_sym_finite_set_literal_repeat1 = 623,
  aux_sym_record_literal_repeat1 = 624,
  aux_sym_set_of_records_repeat1 = 625,
  aux_sym_except_repeat1 = 626,
  aux_sym_except_update_specifier_repeat1 = 627,
  aux_sym_case_repeat1 = 628,
  aux_sym_let_in_repeat1 = 629,
  aux_sym_conj_list_repeat1 = 630,
  aux_sym_disj_list_repeat1 = 631,
  aux_sym_assume_prove_repeat1 = 632,
  aux_sym_non_terminal_proof_repeat1 = 633,
  aux_sym_definition_proof_step_repeat1 = 634,
  aux_sym_use_body_expr_repeat1 = 635,
  aux_sym_use_body_def_repeat1 = 636,
  aux_sym__pcal_p_algorithm_repeat1 = 637,
  aux_sym__pcal_p_algorithm_repeat2 = 638,
  aux_sym__pcal_p_algorithm_repeat3 = 639,
  aux_sym__pcal_c_algorithm_repeat1 = 640,
  aux_sym__pcal_c_algorithm_repeat2 = 641,
  aux_sym__pcal_c_algorithm_repeat3 = 642,
  aux_sym_pcal_p_definitions_repeat1 = 643,
  aux_sym_pcal_macro_decl_repeat1 = 644,
  aux_sym_pcal_proc_decl_repeat1 = 645,
  aux_sym_pcal_var_decls_repeat1 = 646,
  aux_sym_pcal_proc_var_decls_repeat1 = 647,
  aux_sym__pcal_p_stmts_repeat1 = 648,
  aux_sym_pcal_c_algorithm_body_repeat1 = 649,
  aux_sym_pcal_assign_repeat1 = 650,
  aux_sym_pcal_lhs_repeat1 = 651,
  aux_sym_pcal_p_if_repeat1 = 652,
  aux_sym_pcal_p_either_repeat1 = 653,
  aux_sym_pcal_c_either_repeat1 = 654,
  aux_sym__pcal_with_vars_repeat1 = 655,
  alias_sym_header_line = 656,
  alias_sym_identifier_ref = 657,
  alias_sym_pcal_end_either = 658,
  alias_sym_pcal_end_if = 659,
  alias_sym_pcal_end_while = 660,
  alias_sym_pcal_end_with = 661,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_comment] = "comment",
  [anon_sym_LPAREN_STAR] = "(*",
  [anon_sym_STAR_RPAREN] = "*)",
  [aux_sym_block_comment_text_token1] = "block_comment_text_token1",
  [aux_sym_block_comment_text_token2] = "block_comment_text_token2",
  [aux_sym_block_comment_text_token3] = "block_comment_text_token3",
  [aux_sym_block_comment_text_token4] = "block_comment_text_token4",
  [anon_sym_MODULE] = "MODULE",
  [anon_sym_DASH_DASH_DASH_DASH] = "----",
  [aux_sym_single_line_token1] = "single_line_token1",
  [anon_sym_EQ_EQ_EQ_EQ] = "====",
  [aux_sym_double_line_token1] = "double_line_token1",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_u225c] = "\u225c",
  [anon_sym_BSLASHin] = "\\in",
  [anon_sym_u2208] = "\u2208",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_u27f5] = "\u27f5",
  [anon_sym_u2190] = "\u2190",
  [anon_sym_BSLASHA] = "\\A",
  [anon_sym_BSLASHforall] = "\\forall",
  [anon_sym_u2200] = "\u2200",
  [anon_sym_BSLASHE] = "\\E",
  [anon_sym_BSLASHexists] = "\\exists",
  [anon_sym_u2203] = "\u2203",
  [sym_temporal_forall] = "temporal_forall",
  [sym_temporal_exists] = "temporal_exists",
  [anon_sym_PIPE_DASH_GT] = "|->",
  [anon_sym_u27fc] = "\u27fc",
  [anon_sym_u21a6] = "\u21a6",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_u27f6] = "\u27f6",
  [anon_sym_u2192] = "\u2192",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_u3008] = "\u3008",
  [anon_sym_u27e8] = "\u27e8",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_u3009] = "\u3009",
  [anon_sym_u27e9] = "\u27e9",
  [anon_sym_GT_GT_] = ">>_",
  [anon_sym_u3009_] = "\u3009_",
  [anon_sym_u27e9_] = "\u27e9_",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_u25a1] = "\u25a1",
  [anon_sym_COLON] = ":",
  [anon_sym_AT] = "@",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_u2237] = "\u2237",
  [sym_placeholder] = "placeholder",
  [anon_sym_SLASH_BSLASH] = "/\\",
  [anon_sym_u2227] = "\u2227",
  [anon_sym_BSLASH_SLASH] = "\\/",
  [anon_sym_u2228] = "\u2228",
  [anon_sym_EXTENDS] = "EXTENDS",
  [anon_sym_COMMA] = ",",
  [anon_sym_LOCAL] = "LOCAL",
  [anon_sym_VARIABLE] = "VARIABLE",
  [anon_sym_VARIABLES] = "VARIABLES",
  [anon_sym_CONSTANT] = "CONSTANT",
  [anon_sym_CONSTANTS] = "CONSTANTS",
  [anon_sym_RECURSIVE] = "RECURSIVE",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_INSTANCE] = "INSTANCE",
  [anon_sym_WITH] = "WITH",
  [anon_sym_BANG] = "!",
  [aux_sym_child_id_token1] = "child_id_token1",
  [anon_sym_LAMBDA] = "LAMBDA",
  [sym_real_number] = "real_number",
  [anon_sym_BSLASHb] = "format",
  [anon_sym_BSLASHB] = "format",
  [aux_sym_binary_number_token1] = "value",
  [anon_sym_BSLASHo] = "\\o",
  [anon_sym_BSLASHO] = "format",
  [aux_sym_octal_number_token1] = "value",
  [anon_sym_BSLASHh] = "format",
  [anon_sym_BSLASHH] = "format",
  [aux_sym_hex_number_token1] = "value",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_DQUOTE2] = "\"",
  [sym_escape_char] = "escape_char",
  [anon_sym_TRUE] = "TRUE",
  [anon_sym_FALSE] = "FALSE",
  [sym_string_set] = "string_set",
  [sym_boolean_set] = "boolean_set",
  [anon_sym_Nat] = "Nat",
  [anon_sym_u2115] = "\u2115",
  [anon_sym_Int] = "Int",
  [anon_sym_u2124] = "\u2124",
  [anon_sym_Real] = "Real",
  [anon_sym_u211d] = "\u211d",
  [anon_sym_CHOOSE] = "CHOOSE",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_DOT] = ".",
  [anon_sym_EXCEPT] = "EXCEPT",
  [anon_sym_EQ] = "=",
  [anon_sym_RBRACK_] = "]_",
  [anon_sym_WF_] = "WF_",
  [anon_sym_SF_] = "SF_",
  [anon_sym_IF] = "IF",
  [anon_sym_THEN] = "THEN",
  [anon_sym_ELSE] = "ELSE",
  [anon_sym_CASE] = "CASE",
  [anon_sym_OTHER] = "OTHER",
  [anon_sym_LET] = "LET",
  [anon_sym_IN] = "IN",
  [anon_sym_BSLASHlnot] = "\\lnot",
  [anon_sym_BSLASHneg] = "\\neg",
  [anon_sym_TILDE] = "~",
  [anon_sym_u00ac] = "\u00ac",
  [sym_union] = "union",
  [sym_powerset] = "powerset",
  [sym_domain] = "domain",
  [anon_sym_DASH] = "-",
  [sym_negative_dot] = "negative",
  [sym_enabled] = "enabled",
  [sym_unchanged] = "unchanged",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_u22c4] = "\u22c4",
  [anon_sym_u25c7] = "\u25c7",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_u27f9] = "\u27f9",
  [anon_sym_u21d2] = "\u21d2",
  [anon_sym_DASH_PLUS_DASH_GT] = "-+->",
  [anon_sym_u21f8] = "\u21f8",
  [anon_sym_u2945] = "\u2945",
  [anon_sym_BSLASHequiv] = "\\equiv",
  [anon_sym_u2261] = "\u2261",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_u27fa] = "\u27fa",
  [anon_sym_u21d4] = "\u21d4",
  [anon_sym_TILDE_GT] = "~>",
  [anon_sym_u21dd] = "\u21dd",
  [anon_sym_u219d] = "\u219d",
  [anon_sym_BSLASHland] = "\\land",
  [anon_sym_BSLASHlor] = "\\lor",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_u2254] = "\u2254",
  [anon_sym_COLON_COLON_EQ] = "::=",
  [anon_sym_u2a74] = "\u2a74",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_POUND] = "#",
  [anon_sym_u2260] = "\u2260",
  [anon_sym_LT] = "<",
  [sym_gt] = "gt",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_LT] = "=<",
  [anon_sym_BSLASHleq] = "\\leq",
  [anon_sym_u2264] = "\u2264",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_BSLASHgeq] = "\\geq",
  [anon_sym_u2265] = "\u2265",
  [anon_sym_BSLASHapprox] = "\\approx",
  [anon_sym_u2248] = "\u2248",
  [anon_sym_PIPE_DASH] = "|-",
  [anon_sym_u22a2] = "\u22a2",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_u22a8] = "\u22a8",
  [anon_sym_DASH_PIPE] = "-|",
  [anon_sym_u22a3] = "\u22a3",
  [anon_sym_EQ_PIPE] = "=|",
  [anon_sym_u2ae4] = "\u2ae4",
  [anon_sym_BSLASHasymp] = "\\asymp",
  [anon_sym_u224d] = "\u224d",
  [anon_sym_BSLASHcong] = "\\cong",
  [anon_sym_u2245] = "\u2245",
  [anon_sym_BSLASHdoteq] = "\\doteq",
  [anon_sym_u2250] = "\u2250",
  [anon_sym_BSLASHgg] = "\\gg",
  [anon_sym_u226b] = "\u226b",
  [anon_sym_BSLASHll] = "\\ll",
  [anon_sym_u226a] = "\u226a",
  [anon_sym_BSLASHnotin] = "\\notin",
  [anon_sym_u2209] = "\u2209",
  [anon_sym_BSLASHprec] = "\\prec",
  [anon_sym_u227a] = "\u227a",
  [anon_sym_BSLASHsucc] = "\\succ",
  [anon_sym_u227b] = "\u227b",
  [anon_sym_BSLASHpreceq] = "\\preceq",
  [anon_sym_u2aaf] = "\u2aaf",
  [anon_sym_BSLASHsucceq] = "\\succeq",
  [anon_sym_u2ab0] = "\u2ab0",
  [anon_sym_BSLASHpropto] = "\\propto",
  [anon_sym_u221d] = "\u221d",
  [anon_sym_BSLASHsim] = "\\sim",
  [anon_sym_u223c] = "\u223c",
  [anon_sym_BSLASHsimeq] = "\\simeq",
  [anon_sym_u2243] = "\u2243",
  [anon_sym_BSLASHsqsubset] = "\\sqsubset",
  [anon_sym_u228f] = "\u228f",
  [anon_sym_BSLASHsqsupset] = "\\sqsupset",
  [anon_sym_u2290] = "\u2290",
  [anon_sym_BSLASHsqsubseteq] = "\\sqsubseteq",
  [anon_sym_u2291] = "\u2291",
  [anon_sym_BSLASHsqsupseteq] = "\\sqsupseteq",
  [anon_sym_u2292] = "\u2292",
  [anon_sym_BSLASHsubset] = "\\subset",
  [anon_sym_u2282] = "\u2282",
  [anon_sym_BSLASHsupset] = "\\supset",
  [anon_sym_u2283] = "\u2283",
  [anon_sym_BSLASHsubseteq] = "\\subseteq",
  [anon_sym_u2286] = "\u2286",
  [anon_sym_BSLASHsupseteq] = "\\supseteq",
  [anon_sym_u2287] = "\u2287",
  [sym_compose] = "compose",
  [sym_map_to] = "map_to",
  [sym_map_from] = "map_from",
  [sym_setminus] = "setminus",
  [anon_sym_BSLASHcap] = "\\cap",
  [anon_sym_BSLASHintersect] = "\\intersect",
  [anon_sym_u2229] = "\u2229",
  [anon_sym_BSLASHcup] = "\\cup",
  [anon_sym_BSLASHunion] = "\\union",
  [anon_sym_u222a] = "\u222a",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_u2025] = "\u2025",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_u2026] = "\u2026",
  [anon_sym_PLUS] = "+",
  [sym_plusplus] = "plusplus",
  [anon_sym_BSLASHoplus] = "\\oplus",
  [anon_sym_LPAREN_PLUS_RPAREN] = "(+)",
  [anon_sym_u2295] = "\u2295",
  [anon_sym_BSLASHominus] = "\\ominus",
  [anon_sym_LPAREN_DASH_RPAREN] = "(-)",
  [anon_sym_u2296] = "\u2296",
  [sym_mod] = "mod",
  [sym_modmod] = "modmod",
  [sym_vert] = "vert",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_u2016] = "\u2016",
  [sym_minusminus] = "minusminus",
  [sym_amp] = "amp",
  [sym_ampamp] = "ampamp",
  [anon_sym_BSLASHodot] = "\\odot",
  [anon_sym_LPAREN_DOT_RPAREN] = "(.)",
  [anon_sym_u2299] = "\u2299",
  [anon_sym_BSLASHoslash] = "\\oslash",
  [anon_sym_LPAREN_SLASH_RPAREN] = "(/)",
  [anon_sym_u2298] = "\u2298",
  [anon_sym_BSLASHotimes] = "\\otimes",
  [anon_sym_LPAREN_BSLASHX_RPAREN] = "(\\X)",
  [anon_sym_u2297] = "\u2297",
  [sym_mul] = "mul",
  [sym_mulmul] = "mulmul",
  [sym_slash] = "slash",
  [sym_slashslash] = "slashslash",
  [anon_sym_BSLASHbigcirc] = "\\bigcirc",
  [anon_sym_u25ef] = "\u25ef",
  [anon_sym_BSLASHbullet] = "\\bullet",
  [anon_sym_u25cf] = "\u25cf",
  [anon_sym_BSLASHdiv] = "\\div",
  [anon_sym_u00f7] = "\u00f7",
  [anon_sym_BSLASHcirc] = "\\circ",
  [anon_sym_u2218] = "\u2218",
  [anon_sym_BSLASHstar] = "\\star",
  [anon_sym_u22c6] = "\u22c6",
  [anon_sym_u203c] = "\u203c",
  [sym_hashhash] = "hashhash",
  [sym_dol] = "dol",
  [sym_doldol] = "doldol",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_u2047] = "\u2047",
  [anon_sym_BSLASHsqcap] = "\\sqcap",
  [anon_sym_u2293] = "\u2293",
  [anon_sym_BSLASHsqcup] = "\\sqcup",
  [anon_sym_u2294] = "\u2294",
  [anon_sym_BSLASHuplus] = "\\uplus",
  [anon_sym_u228e] = "\u228e",
  [anon_sym_BSLASHX] = "\\X",
  [anon_sym_BSLASHtimes] = "\\times",
  [anon_sym_u00d7] = "\u00d7",
  [anon_sym_BSLASHwr] = "\\wr",
  [anon_sym_u2240] = "\u2240",
  [anon_sym_BSLASHcdot] = "\\cdot",
  [anon_sym_u22c5] = "\u22c5",
  [sym_pow] = "pow",
  [sym_powpow] = "powpow",
  [anon_sym_CARET_PLUS] = "^+",
  [anon_sym_u207a] = "\u207a",
  [sym_asterisk] = "asterisk",
  [sym_sup_hash] = "sup_hash",
  [sym_prime] = "prime",
  [anon_sym_ASSUME] = "ASSUME",
  [anon_sym_ASSUMPTION] = "ASSUMPTION",
  [anon_sym_AXIOM] = "AXIOM",
  [anon_sym_THEOREM] = "THEOREM",
  [anon_sym_PROPOSITION] = "PROPOSITION",
  [anon_sym_LEMMA] = "LEMMA",
  [anon_sym_COROLLARY] = "COROLLARY",
  [anon_sym_PROVE] = "PROVE",
  [anon_sym_NEW] = "NEW",
  [anon_sym_STATE] = "STATE",
  [anon_sym_ACTION] = "ACTION",
  [anon_sym_TEMPORAL] = "TEMPORAL",
  [anon_sym_PROOF] = "PROOF",
  [anon_sym_BY] = "BY",
  [anon_sym_ONLY] = "ONLY",
  [anon_sym_OBVIOUS] = "OBVIOUS",
  [anon_sym_OMITTED] = "OMITTED",
  [anon_sym_DEFINE] = "DEFINE",
  [anon_sym_HAVE] = "HAVE",
  [anon_sym_WITNESS] = "WITNESS",
  [anon_sym_TAKE] = "TAKE",
  [anon_sym_SUFFICES] = "SUFFICES",
  [anon_sym_PICK] = "PICK",
  [anon_sym_QED] = "QED",
  [anon_sym_USE] = "USE",
  [anon_sym_HIDE] = "HIDE",
  [anon_sym_DEF] = "DEF",
  [anon_sym_DEFS] = "DEFS",
  [aux_sym_proof_step_id_token1] = "level",
  [anon_sym_GT] = ">",
  [aux_sym_proof_step_id_token2] = "name",
  [aux_sym_proof_step_id_token3] = "proof_step_id_token3",
  [aux_sym_proof_step_ref_token1] = "level",
  [aux_sym_proof_step_ref_token2] = "name",
  [anon_sym_end] = "end",
  [anon_sym_algorithm] = "algorithm",
  [anon_sym_SEMI] = ";",
  [anon_sym_DASH_DASHalgorithm] = "--algorithm",
  [anon_sym_DASH_DASHfair] = "--fair",
  [anon_sym_define] = "define",
  [anon_sym_macro] = "macro",
  [anon_sym_procedure] = "procedure",
  [anon_sym_fair] = "fair",
  [anon_sym_process] = "process",
  [anon_sym_variable] = "variable",
  [anon_sym_variables] = "variables",
  [anon_sym_begin] = "begin",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_elsif] = "elsif",
  [anon_sym_else] = "else",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_either] = "either",
  [anon_sym_or] = "or",
  [anon_sym_with] = "with",
  [anon_sym_await] = "await",
  [anon_sym_when] = "when",
  [anon_sym_print] = "print",
  [anon_sym_assert] = "assert",
  [sym_pcal_skip] = "pcal_skip",
  [sym_pcal_return] = "pcal_return",
  [anon_sym_goto] = "goto",
  [anon_sym_call] = "call",
  [sym_leading_extramodular_text] = "extramodular_text",
  [sym_trailing_extramodular_text] = "extramodular_text",
  [sym__indent] = "_indent",
  [sym__bullet] = "_bullet",
  [sym__dedent] = "_dedent",
  [sym__begin_proof] = "_begin_proof",
  [sym__begin_proof_step] = "_begin_proof_step",
  [sym__notify_pcal_algorithm_start] = "_notify_pcal_algorithm_start",
  [sym__notify_pcal_algorithm_end] = "_notify_pcal_algorithm_end",
  [sym__double_excl] = "!!",
  [sym__error_sentinel] = "_error_sentinel",
  [sym_source_file] = "source_file",
  [sym_block_comment] = "block_comment",
  [sym_block_comment_text] = "block_comment_text",
  [sym_module] = "module",
  [sym_single_line] = "single_line",
  [sym_double_line] = "double_line",
  [sym_def_eq] = "def_eq",
  [sym_set_in] = "set_in",
  [sym_gets] = "gets",
  [sym_forall] = "forall",
  [sym_exists] = "exists",
  [sym_all_map_to] = "all_map_to",
  [sym_maps_to] = "maps_to",
  [sym_langle_bracket] = "langle_bracket",
  [sym_rangle_bracket] = "rangle_bracket",
  [sym_rangle_bracket_sub] = "rangle_bracket_sub",
  [sym_case_box] = "case_box",
  [sym_case_arrow] = "case_arrow",
  [sym_colon] = "colon",
  [sym_address] = "address",
  [sym_label_as] = "label_as",
  [sym_bullet_conj] = "bullet_conj",
  [sym_bullet_disj] = "bullet_disj",
  [sym_extends] = "extends",
  [sym__unit] = "_unit",
  [sym_local_definition] = "local_definition",
  [sym__definition] = "_definition",
  [sym_variable_declaration] = "variable_declaration",
  [sym_constant_declaration] = "constant_declaration",
  [sym_recursive_declaration] = "recursive_declaration",
  [sym_operator_declaration] = "operator_declaration",
  [sym__id_or_op_declaration] = "_id_or_op_declaration",
  [sym_operator_definition] = "operator_definition",
  [sym_function_definition] = "function_definition",
  [sym_instance] = "instance",
  [sym_substitution] = "substitution",
  [sym__op_or_expr] = "_op_or_expr",
  [sym__op] = "_op",
  [sym_subexpr_prefix] = "subexpr_prefix",
  [sym_subexpr_component] = "subexpr_component",
  [sym_bound_op] = "bound_op",
  [sym_bound_nonfix_op] = "bound_nonfix_op",
  [sym_subexpr_tree_nav] = "subexpr_tree_nav",
  [sym_child_id] = "child_id",
  [sym_operator_args] = "operator_args",
  [sym_lambda] = "lambda",
  [sym_module_definition] = "module_definition",
  [sym__expr] = "_expr",
  [sym__subscript_expr] = "_subscript_expr",
  [sym_prefixed_op] = "prefixed_op",
  [sym__number] = "_number",
  [sym_nat_number] = "nat_number",
  [sym_binary_number] = "binary_number",
  [sym_octal_number] = "octal_number",
  [sym_hex_number] = "hex_number",
  [sym_string] = "string",
  [sym_boolean] = "boolean",
  [sym__number_set] = "_number_set",
  [sym__primitive_value_set] = "_primitive_value_set",
  [sym_nat_number_set] = "nat_number_set",
  [sym_int_number_set] = "int_number_set",
  [sym_real_number_set] = "real_number_set",
  [sym_label] = "label",
  [sym_subexpression] = "subexpression",
  [sym_parentheses] = "parentheses",
  [sym_bounded_quantification] = "bounded_quantification",
  [sym_unbounded_quantification] = "unbounded_quantification",
  [sym_choose] = "choose",
  [sym_finite_set_literal] = "finite_set_literal",
  [sym_set_filter] = "set_filter",
  [sym_set_map] = "set_map",
  [sym_quantifier_bound] = "quantifier_bound",
  [sym_restricted_quantifier_bound] = "quantifier_bound",
  [sym_tuple_of_identifiers] = "tuple_of_identifiers",
  [sym_function_evaluation] = "function_evaluation",
  [sym_function_literal] = "function_literal",
  [sym_set_of_functions] = "set_of_functions",
  [sym_record_literal] = "record_literal",
  [sym_set_of_records] = "set_of_records",
  [sym_record_value] = "record_value",
  [sym_except] = "except",
  [sym_except_update] = "except_update",
  [sym_except_update_specifier] = "except_update_specifier",
  [sym_except_update_record_field] = "except_update_record_field",
  [sym_except_update_fn_appl] = "except_update_fn_appl",
  [sym_prev_func_val] = "prev_func_val",
  [sym_tuple_literal] = "tuple_literal",
  [sym_step_expr_or_stutter] = "step_expr_or_stutter",
  [sym_step_expr_no_stutter] = "step_expr_no_stutter",
  [sym_fairness] = "fairness",
  [sym_if_then_else] = "if_then_else",
  [sym_case] = "case",
  [sym_case_arm] = "case_arm",
  [sym_other_arm] = "other_arm",
  [sym_let_in] = "let_in",
  [sym_conj_list] = "conj_list",
  [sym_conj_item] = "conj_item",
  [sym_disj_list] = "disj_list",
  [sym_disj_item] = "disj_item",
  [sym_lnot] = "lnot",
  [sym_negative] = "negative",
  [sym_always] = "always",
  [sym_eventually] = "eventually",
  [sym_prefix_op_symbol] = "prefix_op_symbol",
  [sym_bound_prefix_op] = "bound_prefix_op",
  [sym_implies] = "implies",
  [sym_plus_arrow] = "plus_arrow",
  [sym_equiv] = "equiv",
  [sym_iff] = "iff",
  [sym_leads_to] = "leads_to",
  [sym_land] = "land",
  [sym_lor] = "lor",
  [sym_assign] = "assign",
  [sym_bnf_rule] = "bnf_rule",
  [sym_eq] = "eq",
  [sym_neq] = "neq",
  [sym_lt] = "lt",
  [sym_leq] = "leq",
  [sym_geq] = "geq",
  [sym_approx] = "approx",
  [sym_rs_ttile] = "rs_ttile",
  [sym_rd_ttile] = "rd_ttile",
  [sym_ls_ttile] = "ls_ttile",
  [sym_ld_ttile] = "ld_ttile",
  [sym_asymp] = "asymp",
  [sym_cong] = "cong",
  [sym_doteq] = "doteq",
  [sym_gg] = "gg",
  [sym_ll] = "ll",
  [sym_in] = "in",
  [sym_notin] = "notin",
  [sym_prec] = "prec",
  [sym_succ] = "succ",
  [sym_preceq] = "preceq",
  [sym_succeq] = "succeq",
  [sym_propto] = "propto",
  [sym_sim] = "sim",
  [sym_simeq] = "simeq",
  [sym_sqsubset] = "sqsubset",
  [sym_sqsupset] = "sqsupset",
  [sym_sqsubseteq] = "sqsubseteq",
  [sym_sqsupseteq] = "sqsupseteq",
  [sym_subset] = "subset",
  [sym_supset] = "supset",
  [sym_subseteq] = "subseteq",
  [sym_supseteq] = "supseteq",
  [sym_cap] = "cap",
  [sym_cup] = "cup",
  [sym_dots_2] = "dots_2",
  [sym_dots_3] = "dots_3",
  [sym_plus] = "plus",
  [sym_oplus] = "oplus",
  [sym_ominus] = "ominus",
  [sym_vertvert] = "vertvert",
  [sym_minus] = "minus",
  [sym_odot] = "odot",
  [sym_oslash] = "oslash",
  [sym_otimes] = "otimes",
  [sym_bigcirc] = "bigcirc",
  [sym_bullet] = "bullet",
  [sym_div] = "div",
  [sym_circ] = "circ",
  [sym_star] = "star",
  [sym_excl] = "excl",
  [sym_qq] = "qq",
  [sym_sqcap] = "sqcap",
  [sym_sqcup] = "sqcup",
  [sym_uplus] = "uplus",
  [sym_times] = "times",
  [sym_wr] = "wr",
  [sym_cdot] = "cdot",
  [sym_infix_op_symbol] = "infix_op_symbol",
  [sym_bound_infix_op] = "bound_infix_op",
  [sym_sup_plus] = "sup_plus",
  [sym_postfix_op_symbol] = "postfix_op_symbol",
  [sym_bound_postfix_op] = "bound_postfix_op",
  [sym_assumption] = "assumption",
  [sym_theorem] = "theorem",
  [sym_assume_prove] = "assume_prove",
  [sym_inner_assume_prove] = "inner_assume_prove",
  [sym_new] = "new",
  [sym_statement_level] = "statement_level",
  [sym__proof] = "_proof",
  [sym_terminal_proof] = "terminal_proof",
  [sym_non_terminal_proof] = "non_terminal_proof",
  [sym_proof_step] = "proof_step",
  [sym_definition_proof_step] = "definition_proof_step",
  [sym_have_proof_step] = "have_proof_step",
  [sym_witness_proof_step] = "witness_proof_step",
  [sym_take_proof_step] = "take_proof_step",
  [sym_suffices_proof_step] = "suffices_proof_step",
  [sym_case_proof_step] = "case_proof_step",
  [sym_pick_proof_step] = "pick_proof_step",
  [sym__bound_or_identifier_list] = "_bound_or_identifier_list",
  [sym_qed_step] = "qed_step",
  [sym_use_or_hide] = "use_or_hide",
  [sym_use_body] = "use_body",
  [sym_use_body_expr] = "use_body_expr",
  [sym_use_body_def] = "use_body_def",
  [sym_module_ref] = "module_ref",
  [sym_proof_step_id] = "proof_step_id",
  [sym_proof_step_ref] = "proof_step_ref",
  [sym_pcal_algorithm] = "pcal_algorithm",
  [sym__pcal_p_algorithm] = "_pcal_p_algorithm",
  [sym__pcal_c_algorithm] = "_pcal_c_algorithm",
  [sym_pcal_algorithm_start] = "pcal_algorithm_start",
  [sym_fair] = "fair",
  [sym_pcal_p_definitions] = "pcal_definitions",
  [sym_pcal_c_definitions] = "pcal_definitions",
  [sym_pcal_p_macro] = "pcal_macro",
  [sym_pcal_c_macro] = "pcal_macro",
  [sym_pcal_macro_decl] = "pcal_macro_decl",
  [sym_pcal_p_procedure] = "pcal_procedure",
  [sym_pcal_c_procedure] = "pcal_procedure",
  [sym_pcal_proc_decl] = "pcal_proc_decl",
  [sym_pcal_p_process] = "pcal_process",
  [sym_pcal_c_process] = "pcal_process",
  [sym_pcal_var_decls] = "pcal_var_decls",
  [sym_pcal_var_decl] = "pcal_var_decl",
  [sym_pcal_proc_var_decls] = "pcal_proc_var_decls",
  [sym_pcal_proc_var_decl] = "pcal_proc_var_decl",
  [sym_pcal_p_algorithm_body] = "pcal_algorithm_body",
  [sym__pcal_p_stmts] = "_pcal_p_stmts",
  [sym_pcal_c_algorithm_body] = "pcal_algorithm_body",
  [sym__pcal_p_stmt] = "_pcal_p_stmt",
  [sym__pcal_c_stmt] = "_pcal_c_stmt",
  [sym__pcal_label] = "_pcal_label",
  [sym__pcal_p_unlabeled_stmt] = "_pcal_p_unlabeled_stmt",
  [sym__pcal_c_unlabeled_stmt] = "_pcal_c_unlabeled_stmt",
  [sym_pcal_assign] = "pcal_assign",
  [sym_pcal_lhs] = "pcal_lhs",
  [sym_pcal_p_if] = "pcal_if",
  [sym_pcal_c_if] = "pcal_if",
  [sym_pcal_p_while] = "pcal_while",
  [sym_pcal_c_while] = "pcal_while",
  [sym_pcal_p_either] = "pcal_either",
  [sym_pcal_c_either] = "pcal_either",
  [sym_pcal_p_with] = "pcal_with",
  [sym_pcal_c_with] = "pcal_with",
  [sym__pcal_with_vars] = "_pcal_with_vars",
  [sym_pcal_await] = "pcal_await",
  [sym_pcal_print] = "pcal_print",
  [sym_pcal_assert] = "pcal_assert",
  [sym_pcal_goto] = "pcal_goto",
  [sym_pcal_proc_call] = "pcal_proc_call",
  [sym_pcal_macro_call] = "pcal_macro_call",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_source_file_repeat2] = "source_file_repeat2",
  [aux_sym_block_comment_repeat1] = "block_comment_repeat1",
  [aux_sym_block_comment_text_repeat1] = "block_comment_text_repeat1",
  [aux_sym_extends_repeat1] = "extends_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_constant_declaration_repeat1] = "constant_declaration_repeat1",
  [aux_sym_operator_declaration_repeat1] = "operator_declaration_repeat1",
  [aux_sym_function_definition_repeat1] = "function_definition_repeat1",
  [aux_sym_instance_repeat1] = "instance_repeat1",
  [aux_sym_subexpr_prefix_repeat1] = "subexpr_prefix_repeat1",
  [aux_sym_bound_op_repeat1] = "bound_op_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_finite_set_literal_repeat1] = "finite_set_literal_repeat1",
  [aux_sym_record_literal_repeat1] = "record_literal_repeat1",
  [aux_sym_set_of_records_repeat1] = "set_of_records_repeat1",
  [aux_sym_except_repeat1] = "except_repeat1",
  [aux_sym_except_update_specifier_repeat1] = "except_update_specifier_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_let_in_repeat1] = "let_in_repeat1",
  [aux_sym_conj_list_repeat1] = "conj_list_repeat1",
  [aux_sym_disj_list_repeat1] = "disj_list_repeat1",
  [aux_sym_assume_prove_repeat1] = "assume_prove_repeat1",
  [aux_sym_non_terminal_proof_repeat1] = "non_terminal_proof_repeat1",
  [aux_sym_definition_proof_step_repeat1] = "definition_proof_step_repeat1",
  [aux_sym_use_body_expr_repeat1] = "use_body_expr_repeat1",
  [aux_sym_use_body_def_repeat1] = "use_body_def_repeat1",
  [aux_sym__pcal_p_algorithm_repeat1] = "_pcal_p_algorithm_repeat1",
  [aux_sym__pcal_p_algorithm_repeat2] = "_pcal_p_algorithm_repeat2",
  [aux_sym__pcal_p_algorithm_repeat3] = "_pcal_p_algorithm_repeat3",
  [aux_sym__pcal_c_algorithm_repeat1] = "_pcal_c_algorithm_repeat1",
  [aux_sym__pcal_c_algorithm_repeat2] = "_pcal_c_algorithm_repeat2",
  [aux_sym__pcal_c_algorithm_repeat3] = "_pcal_c_algorithm_repeat3",
  [aux_sym_pcal_p_definitions_repeat1] = "pcal_p_definitions_repeat1",
  [aux_sym_pcal_macro_decl_repeat1] = "pcal_macro_decl_repeat1",
  [aux_sym_pcal_proc_decl_repeat1] = "pcal_proc_decl_repeat1",
  [aux_sym_pcal_var_decls_repeat1] = "pcal_var_decls_repeat1",
  [aux_sym_pcal_proc_var_decls_repeat1] = "pcal_proc_var_decls_repeat1",
  [aux_sym__pcal_p_stmts_repeat1] = "_pcal_p_stmts_repeat1",
  [aux_sym_pcal_c_algorithm_body_repeat1] = "pcal_c_algorithm_body_repeat1",
  [aux_sym_pcal_assign_repeat1] = "pcal_assign_repeat1",
  [aux_sym_pcal_lhs_repeat1] = "pcal_lhs_repeat1",
  [aux_sym_pcal_p_if_repeat1] = "pcal_p_if_repeat1",
  [aux_sym_pcal_p_either_repeat1] = "pcal_p_either_repeat1",
  [aux_sym_pcal_c_either_repeat1] = "pcal_c_either_repeat1",
  [aux_sym__pcal_with_vars_repeat1] = "_pcal_with_vars_repeat1",
  [alias_sym_header_line] = "header_line",
  [alias_sym_identifier_ref] = "identifier_ref",
  [alias_sym_pcal_end_either] = "pcal_end_either",
  [alias_sym_pcal_end_if] = "pcal_end_if",
  [alias_sym_pcal_end_while] = "pcal_end_while",
  [alias_sym_pcal_end_with] = "pcal_end_with",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_comment] = sym_comment,
  [anon_sym_LPAREN_STAR] = anon_sym_LPAREN_STAR,
  [anon_sym_STAR_RPAREN] = anon_sym_STAR_RPAREN,
  [aux_sym_block_comment_text_token1] = aux_sym_block_comment_text_token1,
  [aux_sym_block_comment_text_token2] = aux_sym_block_comment_text_token2,
  [aux_sym_block_comment_text_token3] = aux_sym_block_comment_text_token3,
  [aux_sym_block_comment_text_token4] = aux_sym_block_comment_text_token4,
  [anon_sym_MODULE] = anon_sym_MODULE,
  [anon_sym_DASH_DASH_DASH_DASH] = anon_sym_DASH_DASH_DASH_DASH,
  [aux_sym_single_line_token1] = aux_sym_single_line_token1,
  [anon_sym_EQ_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ_EQ,
  [aux_sym_double_line_token1] = aux_sym_double_line_token1,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_u225c] = anon_sym_u225c,
  [anon_sym_BSLASHin] = anon_sym_BSLASHin,
  [anon_sym_u2208] = anon_sym_u2208,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_u27f5] = anon_sym_u27f5,
  [anon_sym_u2190] = anon_sym_u2190,
  [anon_sym_BSLASHA] = anon_sym_BSLASHA,
  [anon_sym_BSLASHforall] = anon_sym_BSLASHforall,
  [anon_sym_u2200] = anon_sym_u2200,
  [anon_sym_BSLASHE] = anon_sym_BSLASHE,
  [anon_sym_BSLASHexists] = anon_sym_BSLASHexists,
  [anon_sym_u2203] = anon_sym_u2203,
  [sym_temporal_forall] = sym_temporal_forall,
  [sym_temporal_exists] = sym_temporal_exists,
  [anon_sym_PIPE_DASH_GT] = anon_sym_PIPE_DASH_GT,
  [anon_sym_u27fc] = anon_sym_u27fc,
  [anon_sym_u21a6] = anon_sym_u21a6,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_u27f6] = anon_sym_u27f6,
  [anon_sym_u2192] = anon_sym_u2192,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_u3008] = anon_sym_u3008,
  [anon_sym_u27e8] = anon_sym_u27e8,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_u3009] = anon_sym_u3009,
  [anon_sym_u27e9] = anon_sym_u27e9,
  [anon_sym_GT_GT_] = anon_sym_GT_GT_,
  [anon_sym_u3009_] = anon_sym_u3009_,
  [anon_sym_u27e9_] = anon_sym_u27e9_,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_u25a1] = anon_sym_u25a1,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_u2237] = anon_sym_u2237,
  [sym_placeholder] = sym_placeholder,
  [anon_sym_SLASH_BSLASH] = anon_sym_SLASH_BSLASH,
  [anon_sym_u2227] = anon_sym_u2227,
  [anon_sym_BSLASH_SLASH] = anon_sym_BSLASH_SLASH,
  [anon_sym_u2228] = anon_sym_u2228,
  [anon_sym_EXTENDS] = anon_sym_EXTENDS,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_LOCAL] = anon_sym_LOCAL,
  [anon_sym_VARIABLE] = anon_sym_VARIABLE,
  [anon_sym_VARIABLES] = anon_sym_VARIABLES,
  [anon_sym_CONSTANT] = anon_sym_CONSTANT,
  [anon_sym_CONSTANTS] = anon_sym_CONSTANTS,
  [anon_sym_RECURSIVE] = anon_sym_RECURSIVE,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_INSTANCE] = anon_sym_INSTANCE,
  [anon_sym_WITH] = anon_sym_WITH,
  [anon_sym_BANG] = anon_sym_BANG,
  [aux_sym_child_id_token1] = aux_sym_child_id_token1,
  [anon_sym_LAMBDA] = anon_sym_LAMBDA,
  [sym_real_number] = sym_real_number,
  [anon_sym_BSLASHb] = anon_sym_BSLASHb,
  [anon_sym_BSLASHB] = anon_sym_BSLASHb,
  [aux_sym_binary_number_token1] = aux_sym_binary_number_token1,
  [anon_sym_BSLASHo] = anon_sym_BSLASHo,
  [anon_sym_BSLASHO] = anon_sym_BSLASHb,
  [aux_sym_octal_number_token1] = aux_sym_binary_number_token1,
  [anon_sym_BSLASHh] = anon_sym_BSLASHb,
  [anon_sym_BSLASHH] = anon_sym_BSLASHb,
  [aux_sym_hex_number_token1] = aux_sym_binary_number_token1,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [sym_escape_char] = sym_escape_char,
  [anon_sym_TRUE] = anon_sym_TRUE,
  [anon_sym_FALSE] = anon_sym_FALSE,
  [sym_string_set] = sym_string_set,
  [sym_boolean_set] = sym_boolean_set,
  [anon_sym_Nat] = anon_sym_Nat,
  [anon_sym_u2115] = anon_sym_u2115,
  [anon_sym_Int] = anon_sym_Int,
  [anon_sym_u2124] = anon_sym_u2124,
  [anon_sym_Real] = anon_sym_Real,
  [anon_sym_u211d] = anon_sym_u211d,
  [anon_sym_CHOOSE] = anon_sym_CHOOSE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_EXCEPT] = anon_sym_EXCEPT,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_RBRACK_] = anon_sym_RBRACK_,
  [anon_sym_WF_] = anon_sym_WF_,
  [anon_sym_SF_] = anon_sym_SF_,
  [anon_sym_IF] = anon_sym_IF,
  [anon_sym_THEN] = anon_sym_THEN,
  [anon_sym_ELSE] = anon_sym_ELSE,
  [anon_sym_CASE] = anon_sym_CASE,
  [anon_sym_OTHER] = anon_sym_OTHER,
  [anon_sym_LET] = anon_sym_LET,
  [anon_sym_IN] = anon_sym_IN,
  [anon_sym_BSLASHlnot] = anon_sym_BSLASHlnot,
  [anon_sym_BSLASHneg] = anon_sym_BSLASHneg,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_u00ac] = anon_sym_u00ac,
  [sym_union] = sym_union,
  [sym_powerset] = sym_powerset,
  [sym_domain] = sym_domain,
  [anon_sym_DASH] = anon_sym_DASH,
  [sym_negative_dot] = sym_negative,
  [sym_enabled] = sym_enabled,
  [sym_unchanged] = sym_unchanged,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_u22c4] = anon_sym_u22c4,
  [anon_sym_u25c7] = anon_sym_u25c7,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_u27f9] = anon_sym_u27f9,
  [anon_sym_u21d2] = anon_sym_u21d2,
  [anon_sym_DASH_PLUS_DASH_GT] = anon_sym_DASH_PLUS_DASH_GT,
  [anon_sym_u21f8] = anon_sym_u21f8,
  [anon_sym_u2945] = anon_sym_u2945,
  [anon_sym_BSLASHequiv] = anon_sym_BSLASHequiv,
  [anon_sym_u2261] = anon_sym_u2261,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_u27fa] = anon_sym_u27fa,
  [anon_sym_u21d4] = anon_sym_u21d4,
  [anon_sym_TILDE_GT] = anon_sym_TILDE_GT,
  [anon_sym_u21dd] = anon_sym_u21dd,
  [anon_sym_u219d] = anon_sym_u219d,
  [anon_sym_BSLASHland] = anon_sym_BSLASHland,
  [anon_sym_BSLASHlor] = anon_sym_BSLASHlor,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_u2254] = anon_sym_u2254,
  [anon_sym_COLON_COLON_EQ] = anon_sym_COLON_COLON_EQ,
  [anon_sym_u2a74] = anon_sym_u2a74,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_u2260] = anon_sym_u2260,
  [anon_sym_LT] = anon_sym_LT,
  [sym_gt] = sym_gt,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_LT] = anon_sym_EQ_LT,
  [anon_sym_BSLASHleq] = anon_sym_BSLASHleq,
  [anon_sym_u2264] = anon_sym_u2264,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_BSLASHgeq] = anon_sym_BSLASHgeq,
  [anon_sym_u2265] = anon_sym_u2265,
  [anon_sym_BSLASHapprox] = anon_sym_BSLASHapprox,
  [anon_sym_u2248] = anon_sym_u2248,
  [anon_sym_PIPE_DASH] = anon_sym_PIPE_DASH,
  [anon_sym_u22a2] = anon_sym_u22a2,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_u22a8] = anon_sym_u22a8,
  [anon_sym_DASH_PIPE] = anon_sym_DASH_PIPE,
  [anon_sym_u22a3] = anon_sym_u22a3,
  [anon_sym_EQ_PIPE] = anon_sym_EQ_PIPE,
  [anon_sym_u2ae4] = anon_sym_u2ae4,
  [anon_sym_BSLASHasymp] = anon_sym_BSLASHasymp,
  [anon_sym_u224d] = anon_sym_u224d,
  [anon_sym_BSLASHcong] = anon_sym_BSLASHcong,
  [anon_sym_u2245] = anon_sym_u2245,
  [anon_sym_BSLASHdoteq] = anon_sym_BSLASHdoteq,
  [anon_sym_u2250] = anon_sym_u2250,
  [anon_sym_BSLASHgg] = anon_sym_BSLASHgg,
  [anon_sym_u226b] = anon_sym_u226b,
  [anon_sym_BSLASHll] = anon_sym_BSLASHll,
  [anon_sym_u226a] = anon_sym_u226a,
  [anon_sym_BSLASHnotin] = anon_sym_BSLASHnotin,
  [anon_sym_u2209] = anon_sym_u2209,
  [anon_sym_BSLASHprec] = anon_sym_BSLASHprec,
  [anon_sym_u227a] = anon_sym_u227a,
  [anon_sym_BSLASHsucc] = anon_sym_BSLASHsucc,
  [anon_sym_u227b] = anon_sym_u227b,
  [anon_sym_BSLASHpreceq] = anon_sym_BSLASHpreceq,
  [anon_sym_u2aaf] = anon_sym_u2aaf,
  [anon_sym_BSLASHsucceq] = anon_sym_BSLASHsucceq,
  [anon_sym_u2ab0] = anon_sym_u2ab0,
  [anon_sym_BSLASHpropto] = anon_sym_BSLASHpropto,
  [anon_sym_u221d] = anon_sym_u221d,
  [anon_sym_BSLASHsim] = anon_sym_BSLASHsim,
  [anon_sym_u223c] = anon_sym_u223c,
  [anon_sym_BSLASHsimeq] = anon_sym_BSLASHsimeq,
  [anon_sym_u2243] = anon_sym_u2243,
  [anon_sym_BSLASHsqsubset] = anon_sym_BSLASHsqsubset,
  [anon_sym_u228f] = anon_sym_u228f,
  [anon_sym_BSLASHsqsupset] = anon_sym_BSLASHsqsupset,
  [anon_sym_u2290] = anon_sym_u2290,
  [anon_sym_BSLASHsqsubseteq] = anon_sym_BSLASHsqsubseteq,
  [anon_sym_u2291] = anon_sym_u2291,
  [anon_sym_BSLASHsqsupseteq] = anon_sym_BSLASHsqsupseteq,
  [anon_sym_u2292] = anon_sym_u2292,
  [anon_sym_BSLASHsubset] = anon_sym_BSLASHsubset,
  [anon_sym_u2282] = anon_sym_u2282,
  [anon_sym_BSLASHsupset] = anon_sym_BSLASHsupset,
  [anon_sym_u2283] = anon_sym_u2283,
  [anon_sym_BSLASHsubseteq] = anon_sym_BSLASHsubseteq,
  [anon_sym_u2286] = anon_sym_u2286,
  [anon_sym_BSLASHsupseteq] = anon_sym_BSLASHsupseteq,
  [anon_sym_u2287] = anon_sym_u2287,
  [sym_compose] = sym_compose,
  [sym_map_to] = sym_map_to,
  [sym_map_from] = sym_map_from,
  [sym_setminus] = sym_setminus,
  [anon_sym_BSLASHcap] = anon_sym_BSLASHcap,
  [anon_sym_BSLASHintersect] = anon_sym_BSLASHintersect,
  [anon_sym_u2229] = anon_sym_u2229,
  [anon_sym_BSLASHcup] = anon_sym_BSLASHcup,
  [anon_sym_BSLASHunion] = anon_sym_BSLASHunion,
  [anon_sym_u222a] = anon_sym_u222a,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_u2025] = anon_sym_u2025,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_u2026] = anon_sym_u2026,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [sym_plusplus] = sym_plusplus,
  [anon_sym_BSLASHoplus] = anon_sym_BSLASHoplus,
  [anon_sym_LPAREN_PLUS_RPAREN] = anon_sym_LPAREN_PLUS_RPAREN,
  [anon_sym_u2295] = anon_sym_u2295,
  [anon_sym_BSLASHominus] = anon_sym_BSLASHominus,
  [anon_sym_LPAREN_DASH_RPAREN] = anon_sym_LPAREN_DASH_RPAREN,
  [anon_sym_u2296] = anon_sym_u2296,
  [sym_mod] = sym_mod,
  [sym_modmod] = sym_modmod,
  [sym_vert] = sym_vert,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_u2016] = anon_sym_u2016,
  [sym_minusminus] = sym_minusminus,
  [sym_amp] = sym_amp,
  [sym_ampamp] = sym_ampamp,
  [anon_sym_BSLASHodot] = anon_sym_BSLASHodot,
  [anon_sym_LPAREN_DOT_RPAREN] = anon_sym_LPAREN_DOT_RPAREN,
  [anon_sym_u2299] = anon_sym_u2299,
  [anon_sym_BSLASHoslash] = anon_sym_BSLASHoslash,
  [anon_sym_LPAREN_SLASH_RPAREN] = anon_sym_LPAREN_SLASH_RPAREN,
  [anon_sym_u2298] = anon_sym_u2298,
  [anon_sym_BSLASHotimes] = anon_sym_BSLASHotimes,
  [anon_sym_LPAREN_BSLASHX_RPAREN] = anon_sym_LPAREN_BSLASHX_RPAREN,
  [anon_sym_u2297] = anon_sym_u2297,
  [sym_mul] = sym_mul,
  [sym_mulmul] = sym_mulmul,
  [sym_slash] = sym_slash,
  [sym_slashslash] = sym_slashslash,
  [anon_sym_BSLASHbigcirc] = anon_sym_BSLASHbigcirc,
  [anon_sym_u25ef] = anon_sym_u25ef,
  [anon_sym_BSLASHbullet] = anon_sym_BSLASHbullet,
  [anon_sym_u25cf] = anon_sym_u25cf,
  [anon_sym_BSLASHdiv] = anon_sym_BSLASHdiv,
  [anon_sym_u00f7] = anon_sym_u00f7,
  [anon_sym_BSLASHcirc] = anon_sym_BSLASHcirc,
  [anon_sym_u2218] = anon_sym_u2218,
  [anon_sym_BSLASHstar] = anon_sym_BSLASHstar,
  [anon_sym_u22c6] = anon_sym_u22c6,
  [anon_sym_u203c] = anon_sym_u203c,
  [sym_hashhash] = sym_hashhash,
  [sym_dol] = sym_dol,
  [sym_doldol] = sym_doldol,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_u2047] = anon_sym_u2047,
  [anon_sym_BSLASHsqcap] = anon_sym_BSLASHsqcap,
  [anon_sym_u2293] = anon_sym_u2293,
  [anon_sym_BSLASHsqcup] = anon_sym_BSLASHsqcup,
  [anon_sym_u2294] = anon_sym_u2294,
  [anon_sym_BSLASHuplus] = anon_sym_BSLASHuplus,
  [anon_sym_u228e] = anon_sym_u228e,
  [anon_sym_BSLASHX] = anon_sym_BSLASHX,
  [anon_sym_BSLASHtimes] = anon_sym_BSLASHtimes,
  [anon_sym_u00d7] = anon_sym_u00d7,
  [anon_sym_BSLASHwr] = anon_sym_BSLASHwr,
  [anon_sym_u2240] = anon_sym_u2240,
  [anon_sym_BSLASHcdot] = anon_sym_BSLASHcdot,
  [anon_sym_u22c5] = anon_sym_u22c5,
  [sym_pow] = sym_pow,
  [sym_powpow] = sym_powpow,
  [anon_sym_CARET_PLUS] = anon_sym_CARET_PLUS,
  [anon_sym_u207a] = anon_sym_u207a,
  [sym_asterisk] = sym_asterisk,
  [sym_sup_hash] = sym_sup_hash,
  [sym_prime] = sym_prime,
  [anon_sym_ASSUME] = anon_sym_ASSUME,
  [anon_sym_ASSUMPTION] = anon_sym_ASSUMPTION,
  [anon_sym_AXIOM] = anon_sym_AXIOM,
  [anon_sym_THEOREM] = anon_sym_THEOREM,
  [anon_sym_PROPOSITION] = anon_sym_PROPOSITION,
  [anon_sym_LEMMA] = anon_sym_LEMMA,
  [anon_sym_COROLLARY] = anon_sym_COROLLARY,
  [anon_sym_PROVE] = anon_sym_PROVE,
  [anon_sym_NEW] = anon_sym_NEW,
  [anon_sym_STATE] = anon_sym_STATE,
  [anon_sym_ACTION] = anon_sym_ACTION,
  [anon_sym_TEMPORAL] = anon_sym_TEMPORAL,
  [anon_sym_PROOF] = anon_sym_PROOF,
  [anon_sym_BY] = anon_sym_BY,
  [anon_sym_ONLY] = anon_sym_ONLY,
  [anon_sym_OBVIOUS] = anon_sym_OBVIOUS,
  [anon_sym_OMITTED] = anon_sym_OMITTED,
  [anon_sym_DEFINE] = anon_sym_DEFINE,
  [anon_sym_HAVE] = anon_sym_HAVE,
  [anon_sym_WITNESS] = anon_sym_WITNESS,
  [anon_sym_TAKE] = anon_sym_TAKE,
  [anon_sym_SUFFICES] = anon_sym_SUFFICES,
  [anon_sym_PICK] = anon_sym_PICK,
  [anon_sym_QED] = anon_sym_QED,
  [anon_sym_USE] = anon_sym_USE,
  [anon_sym_HIDE] = anon_sym_HIDE,
  [anon_sym_DEF] = anon_sym_DEF,
  [anon_sym_DEFS] = anon_sym_DEFS,
  [aux_sym_proof_step_id_token1] = aux_sym_proof_step_id_token1,
  [anon_sym_GT] = anon_sym_GT,
  [aux_sym_proof_step_id_token2] = aux_sym_proof_step_id_token2,
  [aux_sym_proof_step_id_token3] = aux_sym_proof_step_id_token3,
  [aux_sym_proof_step_ref_token1] = aux_sym_proof_step_id_token1,
  [aux_sym_proof_step_ref_token2] = aux_sym_proof_step_id_token2,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_algorithm] = anon_sym_algorithm,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_DASH_DASHalgorithm] = anon_sym_DASH_DASHalgorithm,
  [anon_sym_DASH_DASHfair] = anon_sym_DASH_DASHfair,
  [anon_sym_define] = anon_sym_define,
  [anon_sym_macro] = anon_sym_macro,
  [anon_sym_procedure] = anon_sym_procedure,
  [anon_sym_fair] = anon_sym_fair,
  [anon_sym_process] = anon_sym_process,
  [anon_sym_variable] = anon_sym_variable,
  [anon_sym_variables] = anon_sym_variables,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_elsif] = anon_sym_elsif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_either] = anon_sym_either,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_print] = anon_sym_print,
  [anon_sym_assert] = anon_sym_assert,
  [sym_pcal_skip] = sym_pcal_skip,
  [sym_pcal_return] = sym_pcal_return,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_call] = anon_sym_call,
  [sym_leading_extramodular_text] = sym_leading_extramodular_text,
  [sym_trailing_extramodular_text] = sym_leading_extramodular_text,
  [sym__indent] = sym__indent,
  [sym__bullet] = sym__bullet,
  [sym__dedent] = sym__dedent,
  [sym__begin_proof] = sym__begin_proof,
  [sym__begin_proof_step] = sym__begin_proof_step,
  [sym__notify_pcal_algorithm_start] = sym__notify_pcal_algorithm_start,
  [sym__notify_pcal_algorithm_end] = sym__notify_pcal_algorithm_end,
  [sym__double_excl] = sym__double_excl,
  [sym__error_sentinel] = sym__error_sentinel,
  [sym_source_file] = sym_source_file,
  [sym_block_comment] = sym_block_comment,
  [sym_block_comment_text] = sym_block_comment_text,
  [sym_module] = sym_module,
  [sym_single_line] = sym_single_line,
  [sym_double_line] = sym_double_line,
  [sym_def_eq] = sym_def_eq,
  [sym_set_in] = sym_set_in,
  [sym_gets] = sym_gets,
  [sym_forall] = sym_forall,
  [sym_exists] = sym_exists,
  [sym_all_map_to] = sym_all_map_to,
  [sym_maps_to] = sym_maps_to,
  [sym_langle_bracket] = sym_langle_bracket,
  [sym_rangle_bracket] = sym_rangle_bracket,
  [sym_rangle_bracket_sub] = sym_rangle_bracket_sub,
  [sym_case_box] = sym_case_box,
  [sym_case_arrow] = sym_case_arrow,
  [sym_colon] = sym_colon,
  [sym_address] = sym_address,
  [sym_label_as] = sym_label_as,
  [sym_bullet_conj] = sym_bullet_conj,
  [sym_bullet_disj] = sym_bullet_disj,
  [sym_extends] = sym_extends,
  [sym__unit] = sym__unit,
  [sym_local_definition] = sym_local_definition,
  [sym__definition] = sym__definition,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_constant_declaration] = sym_constant_declaration,
  [sym_recursive_declaration] = sym_recursive_declaration,
  [sym_operator_declaration] = sym_operator_declaration,
  [sym__id_or_op_declaration] = sym__id_or_op_declaration,
  [sym_operator_definition] = sym_operator_definition,
  [sym_function_definition] = sym_function_definition,
  [sym_instance] = sym_instance,
  [sym_substitution] = sym_substitution,
  [sym__op_or_expr] = sym__op_or_expr,
  [sym__op] = sym__op,
  [sym_subexpr_prefix] = sym_subexpr_prefix,
  [sym_subexpr_component] = sym_subexpr_component,
  [sym_bound_op] = sym_bound_op,
  [sym_bound_nonfix_op] = sym_bound_nonfix_op,
  [sym_subexpr_tree_nav] = sym_subexpr_tree_nav,
  [sym_child_id] = sym_child_id,
  [sym_operator_args] = sym_operator_args,
  [sym_lambda] = sym_lambda,
  [sym_module_definition] = sym_module_definition,
  [sym__expr] = sym__expr,
  [sym__subscript_expr] = sym__subscript_expr,
  [sym_prefixed_op] = sym_prefixed_op,
  [sym__number] = sym__number,
  [sym_nat_number] = sym_nat_number,
  [sym_binary_number] = sym_binary_number,
  [sym_octal_number] = sym_octal_number,
  [sym_hex_number] = sym_hex_number,
  [sym_string] = sym_string,
  [sym_boolean] = sym_boolean,
  [sym__number_set] = sym__number_set,
  [sym__primitive_value_set] = sym__primitive_value_set,
  [sym_nat_number_set] = sym_nat_number_set,
  [sym_int_number_set] = sym_int_number_set,
  [sym_real_number_set] = sym_real_number_set,
  [sym_label] = sym_label,
  [sym_subexpression] = sym_subexpression,
  [sym_parentheses] = sym_parentheses,
  [sym_bounded_quantification] = sym_bounded_quantification,
  [sym_unbounded_quantification] = sym_unbounded_quantification,
  [sym_choose] = sym_choose,
  [sym_finite_set_literal] = sym_finite_set_literal,
  [sym_set_filter] = sym_set_filter,
  [sym_set_map] = sym_set_map,
  [sym_quantifier_bound] = sym_quantifier_bound,
  [sym_restricted_quantifier_bound] = sym_quantifier_bound,
  [sym_tuple_of_identifiers] = sym_tuple_of_identifiers,
  [sym_function_evaluation] = sym_function_evaluation,
  [sym_function_literal] = sym_function_literal,
  [sym_set_of_functions] = sym_set_of_functions,
  [sym_record_literal] = sym_record_literal,
  [sym_set_of_records] = sym_set_of_records,
  [sym_record_value] = sym_record_value,
  [sym_except] = sym_except,
  [sym_except_update] = sym_except_update,
  [sym_except_update_specifier] = sym_except_update_specifier,
  [sym_except_update_record_field] = sym_except_update_record_field,
  [sym_except_update_fn_appl] = sym_except_update_fn_appl,
  [sym_prev_func_val] = sym_prev_func_val,
  [sym_tuple_literal] = sym_tuple_literal,
  [sym_step_expr_or_stutter] = sym_step_expr_or_stutter,
  [sym_step_expr_no_stutter] = sym_step_expr_no_stutter,
  [sym_fairness] = sym_fairness,
  [sym_if_then_else] = sym_if_then_else,
  [sym_case] = sym_case,
  [sym_case_arm] = sym_case_arm,
  [sym_other_arm] = sym_other_arm,
  [sym_let_in] = sym_let_in,
  [sym_conj_list] = sym_conj_list,
  [sym_conj_item] = sym_conj_item,
  [sym_disj_list] = sym_disj_list,
  [sym_disj_item] = sym_disj_item,
  [sym_lnot] = sym_lnot,
  [sym_negative] = sym_negative,
  [sym_always] = sym_always,
  [sym_eventually] = sym_eventually,
  [sym_prefix_op_symbol] = sym_prefix_op_symbol,
  [sym_bound_prefix_op] = sym_bound_prefix_op,
  [sym_implies] = sym_implies,
  [sym_plus_arrow] = sym_plus_arrow,
  [sym_equiv] = sym_equiv,
  [sym_iff] = sym_iff,
  [sym_leads_to] = sym_leads_to,
  [sym_land] = sym_land,
  [sym_lor] = sym_lor,
  [sym_assign] = sym_assign,
  [sym_bnf_rule] = sym_bnf_rule,
  [sym_eq] = sym_eq,
  [sym_neq] = sym_neq,
  [sym_lt] = sym_lt,
  [sym_leq] = sym_leq,
  [sym_geq] = sym_geq,
  [sym_approx] = sym_approx,
  [sym_rs_ttile] = sym_rs_ttile,
  [sym_rd_ttile] = sym_rd_ttile,
  [sym_ls_ttile] = sym_ls_ttile,
  [sym_ld_ttile] = sym_ld_ttile,
  [sym_asymp] = sym_asymp,
  [sym_cong] = sym_cong,
  [sym_doteq] = sym_doteq,
  [sym_gg] = sym_gg,
  [sym_ll] = sym_ll,
  [sym_in] = sym_in,
  [sym_notin] = sym_notin,
  [sym_prec] = sym_prec,
  [sym_succ] = sym_succ,
  [sym_preceq] = sym_preceq,
  [sym_succeq] = sym_succeq,
  [sym_propto] = sym_propto,
  [sym_sim] = sym_sim,
  [sym_simeq] = sym_simeq,
  [sym_sqsubset] = sym_sqsubset,
  [sym_sqsupset] = sym_sqsupset,
  [sym_sqsubseteq] = sym_sqsubseteq,
  [sym_sqsupseteq] = sym_sqsupseteq,
  [sym_subset] = sym_subset,
  [sym_supset] = sym_supset,
  [sym_subseteq] = sym_subseteq,
  [sym_supseteq] = sym_supseteq,
  [sym_cap] = sym_cap,
  [sym_cup] = sym_cup,
  [sym_dots_2] = sym_dots_2,
  [sym_dots_3] = sym_dots_3,
  [sym_plus] = sym_plus,
  [sym_oplus] = sym_oplus,
  [sym_ominus] = sym_ominus,
  [sym_vertvert] = sym_vertvert,
  [sym_minus] = sym_minus,
  [sym_odot] = sym_odot,
  [sym_oslash] = sym_oslash,
  [sym_otimes] = sym_otimes,
  [sym_bigcirc] = sym_bigcirc,
  [sym_bullet] = sym_bullet,
  [sym_div] = sym_div,
  [sym_circ] = sym_circ,
  [sym_star] = sym_star,
  [sym_excl] = sym_excl,
  [sym_qq] = sym_qq,
  [sym_sqcap] = sym_sqcap,
  [sym_sqcup] = sym_sqcup,
  [sym_uplus] = sym_uplus,
  [sym_times] = sym_times,
  [sym_wr] = sym_wr,
  [sym_cdot] = sym_cdot,
  [sym_infix_op_symbol] = sym_infix_op_symbol,
  [sym_bound_infix_op] = sym_bound_infix_op,
  [sym_sup_plus] = sym_sup_plus,
  [sym_postfix_op_symbol] = sym_postfix_op_symbol,
  [sym_bound_postfix_op] = sym_bound_postfix_op,
  [sym_assumption] = sym_assumption,
  [sym_theorem] = sym_theorem,
  [sym_assume_prove] = sym_assume_prove,
  [sym_inner_assume_prove] = sym_inner_assume_prove,
  [sym_new] = sym_new,
  [sym_statement_level] = sym_statement_level,
  [sym__proof] = sym__proof,
  [sym_terminal_proof] = sym_terminal_proof,
  [sym_non_terminal_proof] = sym_non_terminal_proof,
  [sym_proof_step] = sym_proof_step,
  [sym_definition_proof_step] = sym_definition_proof_step,
  [sym_have_proof_step] = sym_have_proof_step,
  [sym_witness_proof_step] = sym_witness_proof_step,
  [sym_take_proof_step] = sym_take_proof_step,
  [sym_suffices_proof_step] = sym_suffices_proof_step,
  [sym_case_proof_step] = sym_case_proof_step,
  [sym_pick_proof_step] = sym_pick_proof_step,
  [sym__bound_or_identifier_list] = sym__bound_or_identifier_list,
  [sym_qed_step] = sym_qed_step,
  [sym_use_or_hide] = sym_use_or_hide,
  [sym_use_body] = sym_use_body,
  [sym_use_body_expr] = sym_use_body_expr,
  [sym_use_body_def] = sym_use_body_def,
  [sym_module_ref] = sym_module_ref,
  [sym_proof_step_id] = sym_proof_step_id,
  [sym_proof_step_ref] = sym_proof_step_ref,
  [sym_pcal_algorithm] = sym_pcal_algorithm,
  [sym__pcal_p_algorithm] = sym__pcal_p_algorithm,
  [sym__pcal_c_algorithm] = sym__pcal_c_algorithm,
  [sym_pcal_algorithm_start] = sym_pcal_algorithm_start,
  [sym_fair] = sym_fair,
  [sym_pcal_p_definitions] = sym_pcal_p_definitions,
  [sym_pcal_c_definitions] = sym_pcal_p_definitions,
  [sym_pcal_p_macro] = sym_pcal_p_macro,
  [sym_pcal_c_macro] = sym_pcal_p_macro,
  [sym_pcal_macro_decl] = sym_pcal_macro_decl,
  [sym_pcal_p_procedure] = sym_pcal_p_procedure,
  [sym_pcal_c_procedure] = sym_pcal_p_procedure,
  [sym_pcal_proc_decl] = sym_pcal_proc_decl,
  [sym_pcal_p_process] = sym_pcal_p_process,
  [sym_pcal_c_process] = sym_pcal_p_process,
  [sym_pcal_var_decls] = sym_pcal_var_decls,
  [sym_pcal_var_decl] = sym_pcal_var_decl,
  [sym_pcal_proc_var_decls] = sym_pcal_proc_var_decls,
  [sym_pcal_proc_var_decl] = sym_pcal_proc_var_decl,
  [sym_pcal_p_algorithm_body] = sym_pcal_p_algorithm_body,
  [sym__pcal_p_stmts] = sym__pcal_p_stmts,
  [sym_pcal_c_algorithm_body] = sym_pcal_p_algorithm_body,
  [sym__pcal_p_stmt] = sym__pcal_p_stmt,
  [sym__pcal_c_stmt] = sym__pcal_c_stmt,
  [sym__pcal_label] = sym__pcal_label,
  [sym__pcal_p_unlabeled_stmt] = sym__pcal_p_unlabeled_stmt,
  [sym__pcal_c_unlabeled_stmt] = sym__pcal_c_unlabeled_stmt,
  [sym_pcal_assign] = sym_pcal_assign,
  [sym_pcal_lhs] = sym_pcal_lhs,
  [sym_pcal_p_if] = sym_pcal_p_if,
  [sym_pcal_c_if] = sym_pcal_p_if,
  [sym_pcal_p_while] = sym_pcal_p_while,
  [sym_pcal_c_while] = sym_pcal_p_while,
  [sym_pcal_p_either] = sym_pcal_p_either,
  [sym_pcal_c_either] = sym_pcal_p_either,
  [sym_pcal_p_with] = sym_pcal_p_with,
  [sym_pcal_c_with] = sym_pcal_p_with,
  [sym__pcal_with_vars] = sym__pcal_with_vars,
  [sym_pcal_await] = sym_pcal_await,
  [sym_pcal_print] = sym_pcal_print,
  [sym_pcal_assert] = sym_pcal_assert,
  [sym_pcal_goto] = sym_pcal_goto,
  [sym_pcal_proc_call] = sym_pcal_proc_call,
  [sym_pcal_macro_call] = sym_pcal_macro_call,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_source_file_repeat2] = aux_sym_source_file_repeat2,
  [aux_sym_block_comment_repeat1] = aux_sym_block_comment_repeat1,
  [aux_sym_block_comment_text_repeat1] = aux_sym_block_comment_text_repeat1,
  [aux_sym_extends_repeat1] = aux_sym_extends_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_constant_declaration_repeat1] = aux_sym_constant_declaration_repeat1,
  [aux_sym_operator_declaration_repeat1] = aux_sym_operator_declaration_repeat1,
  [aux_sym_function_definition_repeat1] = aux_sym_function_definition_repeat1,
  [aux_sym_instance_repeat1] = aux_sym_instance_repeat1,
  [aux_sym_subexpr_prefix_repeat1] = aux_sym_subexpr_prefix_repeat1,
  [aux_sym_bound_op_repeat1] = aux_sym_bound_op_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_finite_set_literal_repeat1] = aux_sym_finite_set_literal_repeat1,
  [aux_sym_record_literal_repeat1] = aux_sym_record_literal_repeat1,
  [aux_sym_set_of_records_repeat1] = aux_sym_set_of_records_repeat1,
  [aux_sym_except_repeat1] = aux_sym_except_repeat1,
  [aux_sym_except_update_specifier_repeat1] = aux_sym_except_update_specifier_repeat1,
  [aux_sym_case_repeat1] = aux_sym_case_repeat1,
  [aux_sym_let_in_repeat1] = aux_sym_let_in_repeat1,
  [aux_sym_conj_list_repeat1] = aux_sym_conj_list_repeat1,
  [aux_sym_disj_list_repeat1] = aux_sym_disj_list_repeat1,
  [aux_sym_assume_prove_repeat1] = aux_sym_assume_prove_repeat1,
  [aux_sym_non_terminal_proof_repeat1] = aux_sym_non_terminal_proof_repeat1,
  [aux_sym_definition_proof_step_repeat1] = aux_sym_definition_proof_step_repeat1,
  [aux_sym_use_body_expr_repeat1] = aux_sym_use_body_expr_repeat1,
  [aux_sym_use_body_def_repeat1] = aux_sym_use_body_def_repeat1,
  [aux_sym__pcal_p_algorithm_repeat1] = aux_sym__pcal_p_algorithm_repeat1,
  [aux_sym__pcal_p_algorithm_repeat2] = aux_sym__pcal_p_algorithm_repeat2,
  [aux_sym__pcal_p_algorithm_repeat3] = aux_sym__pcal_p_algorithm_repeat3,
  [aux_sym__pcal_c_algorithm_repeat1] = aux_sym__pcal_c_algorithm_repeat1,
  [aux_sym__pcal_c_algorithm_repeat2] = aux_sym__pcal_c_algorithm_repeat2,
  [aux_sym__pcal_c_algorithm_repeat3] = aux_sym__pcal_c_algorithm_repeat3,
  [aux_sym_pcal_p_definitions_repeat1] = aux_sym_pcal_p_definitions_repeat1,
  [aux_sym_pcal_macro_decl_repeat1] = aux_sym_pcal_macro_decl_repeat1,
  [aux_sym_pcal_proc_decl_repeat1] = aux_sym_pcal_proc_decl_repeat1,
  [aux_sym_pcal_var_decls_repeat1] = aux_sym_pcal_var_decls_repeat1,
  [aux_sym_pcal_proc_var_decls_repeat1] = aux_sym_pcal_proc_var_decls_repeat1,
  [aux_sym__pcal_p_stmts_repeat1] = aux_sym__pcal_p_stmts_repeat1,
  [aux_sym_pcal_c_algorithm_body_repeat1] = aux_sym_pcal_c_algorithm_body_repeat1,
  [aux_sym_pcal_assign_repeat1] = aux_sym_pcal_assign_repeat1,
  [aux_sym_pcal_lhs_repeat1] = aux_sym_pcal_lhs_repeat1,
  [aux_sym_pcal_p_if_repeat1] = aux_sym_pcal_p_if_repeat1,
  [aux_sym_pcal_p_either_repeat1] = aux_sym_pcal_p_either_repeat1,
  [aux_sym_pcal_c_either_repeat1] = aux_sym_pcal_c_either_repeat1,
  [aux_sym__pcal_with_vars_repeat1] = aux_sym__pcal_with_vars_repeat1,
  [alias_sym_header_line] = alias_sym_header_line,
  [alias_sym_identifier_ref] = alias_sym_identifier_ref,
  [alias_sym_pcal_end_either] = alias_sym_pcal_end_either,
  [alias_sym_pcal_end_if] = alias_sym_pcal_end_if,
  [alias_sym_pcal_end_while] = alias_sym_pcal_end_while,
  [alias_sym_pcal_end_with] = alias_sym_pcal_end_with,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_block_comment_text_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_comment_text_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_comment_text_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_comment_text_token4] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_MODULE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_single_line_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_double_line_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u225c] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2208] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u27f5] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2190] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHforall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHexists] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2203] = {
    .visible = true,
    .named = false,
  },
  [sym_temporal_forall] = {
    .visible = true,
    .named = true,
  },
  [sym_temporal_exists] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u27fc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21a6] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u27f6] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u3008] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u27e8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u3009] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u27e9] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u3009_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u27e9_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u25a1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2237] = {
    .visible = true,
    .named = false,
  },
  [sym_placeholder] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SLASH_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2227] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2228] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EXTENDS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LOCAL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_VARIABLE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_VARIABLES] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CONSTANT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CONSTANTS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RECURSIVE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_INSTANCE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_WITH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_child_id_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LAMBDA] = {
    .visible = true,
    .named = false,
  },
  [sym_real_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHb] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHB] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_binary_number_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHO] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_octal_number_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHh] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHH] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_hex_number_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_char] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_TRUE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_FALSE] = {
    .visible = true,
    .named = false,
  },
  [sym_string_set] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_set] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_Nat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2115] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2124] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Real] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u211d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CHOOSE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EXCEPT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_WF_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SF_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_IF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_THEN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ELSE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CASE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_OTHER] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_IN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHlnot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHneg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u00ac] = {
    .visible = true,
    .named = false,
  },
  [sym_union] = {
    .visible = true,
    .named = true,
  },
  [sym_powerset] = {
    .visible = true,
    .named = true,
  },
  [sym_domain] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_negative_dot] = {
    .visible = true,
    .named = true,
  },
  [sym_enabled] = {
    .visible = true,
    .named = true,
  },
  [sym_unchanged] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22c4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u25c7] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u27f9] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21d2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_PLUS_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21f8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2945] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHequiv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2261] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u27fa] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21d4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21dd] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u219d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHland] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHlor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2254] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2a74] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2260] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [sym_gt] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHleq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2264] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHgeq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2265] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHapprox] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2248] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22a2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22a8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22a3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2ae4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHasymp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u224d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2245] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHdoteq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2250] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHgg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u226b] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHll] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u226a] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnotin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2209] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHprec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u227a] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsucc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u227b] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHpreceq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2aaf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsucceq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2ab0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHpropto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u221d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsim] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u223c] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsimeq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2243] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsqsubset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u228f] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsqsupset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2290] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsqsubseteq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2291] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsqsupseteq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2292] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2282] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsupset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2283] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubseteq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2286] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsupseteq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2287] = {
    .visible = true,
    .named = false,
  },
  [sym_compose] = {
    .visible = true,
    .named = true,
  },
  [sym_map_to] = {
    .visible = true,
    .named = true,
  },
  [sym_map_from] = {
    .visible = true,
    .named = true,
  },
  [sym_setminus] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHcap] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHintersect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2229] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcup] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHunion] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u222a] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2025] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2026] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [sym_plusplus] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHoplus] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_PLUS_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2295] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHominus] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_DASH_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2296] = {
    .visible = true,
    .named = false,
  },
  [sym_mod] = {
    .visible = true,
    .named = true,
  },
  [sym_modmod] = {
    .visible = true,
    .named = true,
  },
  [sym_vert] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2016] = {
    .visible = true,
    .named = false,
  },
  [sym_minusminus] = {
    .visible = true,
    .named = true,
  },
  [sym_amp] = {
    .visible = true,
    .named = true,
  },
  [sym_ampamp] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHodot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_DOT_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2299] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHoslash] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_SLASH_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2298] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHotimes] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_BSLASHX_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2297] = {
    .visible = true,
    .named = false,
  },
  [sym_mul] = {
    .visible = true,
    .named = true,
  },
  [sym_mulmul] = {
    .visible = true,
    .named = true,
  },
  [sym_slash] = {
    .visible = true,
    .named = true,
  },
  [sym_slashslash] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHbigcirc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u25ef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHbullet] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u25cf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHdiv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u00f7] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcirc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2218] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHstar] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22c6] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u203c] = {
    .visible = true,
    .named = false,
  },
  [sym_hashhash] = {
    .visible = true,
    .named = true,
  },
  [sym_dol] = {
    .visible = true,
    .named = true,
  },
  [sym_doldol] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2047] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsqcap] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2293] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsqcup] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2294] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHuplus] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u228e] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHX] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHtimes] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u00d7] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHwr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2240] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcdot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22c5] = {
    .visible = true,
    .named = false,
  },
  [sym_pow] = {
    .visible = true,
    .named = true,
  },
  [sym_powpow] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_CARET_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u207a] = {
    .visible = true,
    .named = false,
  },
  [sym_asterisk] = {
    .visible = true,
    .named = true,
  },
  [sym_sup_hash] = {
    .visible = true,
    .named = true,
  },
  [sym_prime] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_ASSUME] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ASSUMPTION] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AXIOM] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_THEOREM] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PROPOSITION] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LEMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COROLLARY] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PROVE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NEW] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STATE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ACTION] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TEMPORAL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PROOF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BY] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ONLY] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_OBVIOUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_OMITTED] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DEFINE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_HAVE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_WITNESS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TAKE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SUFFICES] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PICK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QED] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_USE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_HIDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DEF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DEFS] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_proof_step_id_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_proof_step_id_token2] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_proof_step_id_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_proof_step_ref_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_proof_step_ref_token2] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_algorithm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASHalgorithm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASHfair] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_define] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_macro] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_procedure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fair] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_process] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_variable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_variables] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elsif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_either] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [sym_pcal_skip] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_return] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_call] = {
    .visible = true,
    .named = false,
  },
  [sym_leading_extramodular_text] = {
    .visible = true,
    .named = true,
  },
  [sym_trailing_extramodular_text] = {
    .visible = true,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__bullet] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym__begin_proof] = {
    .visible = false,
    .named = true,
  },
  [sym__begin_proof_step] = {
    .visible = false,
    .named = true,
  },
  [sym__notify_pcal_algorithm_start] = {
    .visible = false,
    .named = true,
  },
  [sym__notify_pcal_algorithm_end] = {
    .visible = false,
    .named = true,
  },
  [sym__double_excl] = {
    .visible = true,
    .named = false,
  },
  [sym__error_sentinel] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment_text] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_single_line] = {
    .visible = true,
    .named = true,
  },
  [sym_double_line] = {
    .visible = true,
    .named = true,
  },
  [sym_def_eq] = {
    .visible = true,
    .named = true,
  },
  [sym_set_in] = {
    .visible = true,
    .named = true,
  },
  [sym_gets] = {
    .visible = true,
    .named = true,
  },
  [sym_forall] = {
    .visible = true,
    .named = true,
  },
  [sym_exists] = {
    .visible = true,
    .named = true,
  },
  [sym_all_map_to] = {
    .visible = true,
    .named = true,
  },
  [sym_maps_to] = {
    .visible = true,
    .named = true,
  },
  [sym_langle_bracket] = {
    .visible = true,
    .named = true,
  },
  [sym_rangle_bracket] = {
    .visible = true,
    .named = true,
  },
  [sym_rangle_bracket_sub] = {
    .visible = true,
    .named = true,
  },
  [sym_case_box] = {
    .visible = true,
    .named = true,
  },
  [sym_case_arrow] = {
    .visible = true,
    .named = true,
  },
  [sym_colon] = {
    .visible = true,
    .named = true,
  },
  [sym_address] = {
    .visible = true,
    .named = true,
  },
  [sym_label_as] = {
    .visible = true,
    .named = true,
  },
  [sym_bullet_conj] = {
    .visible = true,
    .named = true,
  },
  [sym_bullet_disj] = {
    .visible = true,
    .named = true,
  },
  [sym_extends] = {
    .visible = true,
    .named = true,
  },
  [sym__unit] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_local_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__definition] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_recursive_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__id_or_op_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_operator_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym__op_or_expr] = {
    .visible = false,
    .named = true,
  },
  [sym__op] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_subexpr_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_subexpr_component] = {
    .visible = true,
    .named = true,
  },
  [sym_bound_op] = {
    .visible = true,
    .named = true,
  },
  [sym_bound_nonfix_op] = {
    .visible = true,
    .named = true,
  },
  [sym_subexpr_tree_nav] = {
    .visible = true,
    .named = true,
  },
  [sym_child_id] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_args] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_module_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__expr] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__subscript_expr] = {
    .visible = false,
    .named = true,
  },
  [sym_prefixed_op] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_nat_number] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_number] = {
    .visible = true,
    .named = true,
  },
  [sym_octal_number] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_number] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym__number_set] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__primitive_value_set] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_nat_number_set] = {
    .visible = true,
    .named = true,
  },
  [sym_int_number_set] = {
    .visible = true,
    .named = true,
  },
  [sym_real_number_set] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym_subexpression] = {
    .visible = true,
    .named = true,
  },
  [sym_parentheses] = {
    .visible = true,
    .named = true,
  },
  [sym_bounded_quantification] = {
    .visible = true,
    .named = true,
  },
  [sym_unbounded_quantification] = {
    .visible = true,
    .named = true,
  },
  [sym_choose] = {
    .visible = true,
    .named = true,
  },
  [sym_finite_set_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_set_filter] = {
    .visible = true,
    .named = true,
  },
  [sym_set_map] = {
    .visible = true,
    .named = true,
  },
  [sym_quantifier_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_restricted_quantifier_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_of_identifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_function_evaluation] = {
    .visible = true,
    .named = true,
  },
  [sym_function_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_set_of_functions] = {
    .visible = true,
    .named = true,
  },
  [sym_record_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_set_of_records] = {
    .visible = true,
    .named = true,
  },
  [sym_record_value] = {
    .visible = true,
    .named = true,
  },
  [sym_except] = {
    .visible = true,
    .named = true,
  },
  [sym_except_update] = {
    .visible = true,
    .named = true,
  },
  [sym_except_update_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_except_update_record_field] = {
    .visible = true,
    .named = true,
  },
  [sym_except_update_fn_appl] = {
    .visible = true,
    .named = true,
  },
  [sym_prev_func_val] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_step_expr_or_stutter] = {
    .visible = true,
    .named = true,
  },
  [sym_step_expr_no_stutter] = {
    .visible = true,
    .named = true,
  },
  [sym_fairness] = {
    .visible = true,
    .named = true,
  },
  [sym_if_then_else] = {
    .visible = true,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_case_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_other_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_let_in] = {
    .visible = true,
    .named = true,
  },
  [sym_conj_list] = {
    .visible = true,
    .named = true,
  },
  [sym_conj_item] = {
    .visible = true,
    .named = true,
  },
  [sym_disj_list] = {
    .visible = true,
    .named = true,
  },
  [sym_disj_item] = {
    .visible = true,
    .named = true,
  },
  [sym_lnot] = {
    .visible = true,
    .named = true,
  },
  [sym_negative] = {
    .visible = true,
    .named = true,
  },
  [sym_always] = {
    .visible = true,
    .named = true,
  },
  [sym_eventually] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_op_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_bound_prefix_op] = {
    .visible = true,
    .named = true,
  },
  [sym_implies] = {
    .visible = true,
    .named = true,
  },
  [sym_plus_arrow] = {
    .visible = true,
    .named = true,
  },
  [sym_equiv] = {
    .visible = true,
    .named = true,
  },
  [sym_iff] = {
    .visible = true,
    .named = true,
  },
  [sym_leads_to] = {
    .visible = true,
    .named = true,
  },
  [sym_land] = {
    .visible = true,
    .named = true,
  },
  [sym_lor] = {
    .visible = true,
    .named = true,
  },
  [sym_assign] = {
    .visible = true,
    .named = true,
  },
  [sym_bnf_rule] = {
    .visible = true,
    .named = true,
  },
  [sym_eq] = {
    .visible = true,
    .named = true,
  },
  [sym_neq] = {
    .visible = true,
    .named = true,
  },
  [sym_lt] = {
    .visible = true,
    .named = true,
  },
  [sym_leq] = {
    .visible = true,
    .named = true,
  },
  [sym_geq] = {
    .visible = true,
    .named = true,
  },
  [sym_approx] = {
    .visible = true,
    .named = true,
  },
  [sym_rs_ttile] = {
    .visible = true,
    .named = true,
  },
  [sym_rd_ttile] = {
    .visible = true,
    .named = true,
  },
  [sym_ls_ttile] = {
    .visible = true,
    .named = true,
  },
  [sym_ld_ttile] = {
    .visible = true,
    .named = true,
  },
  [sym_asymp] = {
    .visible = true,
    .named = true,
  },
  [sym_cong] = {
    .visible = true,
    .named = true,
  },
  [sym_doteq] = {
    .visible = true,
    .named = true,
  },
  [sym_gg] = {
    .visible = true,
    .named = true,
  },
  [sym_ll] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym_notin] = {
    .visible = true,
    .named = true,
  },
  [sym_prec] = {
    .visible = true,
    .named = true,
  },
  [sym_succ] = {
    .visible = true,
    .named = true,
  },
  [sym_preceq] = {
    .visible = true,
    .named = true,
  },
  [sym_succeq] = {
    .visible = true,
    .named = true,
  },
  [sym_propto] = {
    .visible = true,
    .named = true,
  },
  [sym_sim] = {
    .visible = true,
    .named = true,
  },
  [sym_simeq] = {
    .visible = true,
    .named = true,
  },
  [sym_sqsubset] = {
    .visible = true,
    .named = true,
  },
  [sym_sqsupset] = {
    .visible = true,
    .named = true,
  },
  [sym_sqsubseteq] = {
    .visible = true,
    .named = true,
  },
  [sym_sqsupseteq] = {
    .visible = true,
    .named = true,
  },
  [sym_subset] = {
    .visible = true,
    .named = true,
  },
  [sym_supset] = {
    .visible = true,
    .named = true,
  },
  [sym_subseteq] = {
    .visible = true,
    .named = true,
  },
  [sym_supseteq] = {
    .visible = true,
    .named = true,
  },
  [sym_cap] = {
    .visible = true,
    .named = true,
  },
  [sym_cup] = {
    .visible = true,
    .named = true,
  },
  [sym_dots_2] = {
    .visible = true,
    .named = true,
  },
  [sym_dots_3] = {
    .visible = true,
    .named = true,
  },
  [sym_plus] = {
    .visible = true,
    .named = true,
  },
  [sym_oplus] = {
    .visible = true,
    .named = true,
  },
  [sym_ominus] = {
    .visible = true,
    .named = true,
  },
  [sym_vertvert] = {
    .visible = true,
    .named = true,
  },
  [sym_minus] = {
    .visible = true,
    .named = true,
  },
  [sym_odot] = {
    .visible = true,
    .named = true,
  },
  [sym_oslash] = {
    .visible = true,
    .named = true,
  },
  [sym_otimes] = {
    .visible = true,
    .named = true,
  },
  [sym_bigcirc] = {
    .visible = true,
    .named = true,
  },
  [sym_bullet] = {
    .visible = true,
    .named = true,
  },
  [sym_div] = {
    .visible = true,
    .named = true,
  },
  [sym_circ] = {
    .visible = true,
    .named = true,
  },
  [sym_star] = {
    .visible = true,
    .named = true,
  },
  [sym_excl] = {
    .visible = true,
    .named = true,
  },
  [sym_qq] = {
    .visible = true,
    .named = true,
  },
  [sym_sqcap] = {
    .visible = true,
    .named = true,
  },
  [sym_sqcup] = {
    .visible = true,
    .named = true,
  },
  [sym_uplus] = {
    .visible = true,
    .named = true,
  },
  [sym_times] = {
    .visible = true,
    .named = true,
  },
  [sym_wr] = {
    .visible = true,
    .named = true,
  },
  [sym_cdot] = {
    .visible = true,
    .named = true,
  },
  [sym_infix_op_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_bound_infix_op] = {
    .visible = true,
    .named = true,
  },
  [sym_sup_plus] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_op_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_bound_postfix_op] = {
    .visible = true,
    .named = true,
  },
  [sym_assumption] = {
    .visible = true,
    .named = true,
  },
  [sym_theorem] = {
    .visible = true,
    .named = true,
  },
  [sym_assume_prove] = {
    .visible = true,
    .named = true,
  },
  [sym_inner_assume_prove] = {
    .visible = true,
    .named = true,
  },
  [sym_new] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_level] = {
    .visible = true,
    .named = true,
  },
  [sym__proof] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_terminal_proof] = {
    .visible = true,
    .named = true,
  },
  [sym_non_terminal_proof] = {
    .visible = true,
    .named = true,
  },
  [sym_proof_step] = {
    .visible = true,
    .named = true,
  },
  [sym_definition_proof_step] = {
    .visible = true,
    .named = true,
  },
  [sym_have_proof_step] = {
    .visible = true,
    .named = true,
  },
  [sym_witness_proof_step] = {
    .visible = true,
    .named = true,
  },
  [sym_take_proof_step] = {
    .visible = true,
    .named = true,
  },
  [sym_suffices_proof_step] = {
    .visible = true,
    .named = true,
  },
  [sym_case_proof_step] = {
    .visible = true,
    .named = true,
  },
  [sym_pick_proof_step] = {
    .visible = true,
    .named = true,
  },
  [sym__bound_or_identifier_list] = {
    .visible = false,
    .named = true,
  },
  [sym_qed_step] = {
    .visible = true,
    .named = true,
  },
  [sym_use_or_hide] = {
    .visible = true,
    .named = true,
  },
  [sym_use_body] = {
    .visible = true,
    .named = true,
  },
  [sym_use_body_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_use_body_def] = {
    .visible = true,
    .named = true,
  },
  [sym_module_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_proof_step_id] = {
    .visible = true,
    .named = true,
  },
  [sym_proof_step_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_algorithm] = {
    .visible = true,
    .named = true,
  },
  [sym__pcal_p_algorithm] = {
    .visible = false,
    .named = true,
  },
  [sym__pcal_c_algorithm] = {
    .visible = false,
    .named = true,
  },
  [sym_pcal_algorithm_start] = {
    .visible = true,
    .named = true,
  },
  [sym_fair] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_p_definitions] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_c_definitions] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_p_macro] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_c_macro] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_macro_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_p_procedure] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_c_procedure] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_proc_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_p_process] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_c_process] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_var_decls] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_var_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_proc_var_decls] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_proc_var_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_p_algorithm_body] = {
    .visible = true,
    .named = true,
  },
  [sym__pcal_p_stmts] = {
    .visible = false,
    .named = true,
  },
  [sym_pcal_c_algorithm_body] = {
    .visible = true,
    .named = true,
  },
  [sym__pcal_p_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__pcal_c_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__pcal_label] = {
    .visible = false,
    .named = true,
  },
  [sym__pcal_p_unlabeled_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__pcal_c_unlabeled_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym_pcal_assign] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_lhs] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_p_if] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_c_if] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_p_while] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_c_while] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_p_either] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_c_either] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_p_with] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_c_with] = {
    .visible = true,
    .named = true,
  },
  [sym__pcal_with_vars] = {
    .visible = false,
    .named = true,
  },
  [sym_pcal_await] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_print] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_assert] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_goto] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_proc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_pcal_macro_call] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_source_file_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_comment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_comment_text_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constant_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operator_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instance_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subexpr_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bound_op_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_finite_set_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_set_of_records_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_except_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_except_update_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_let_in_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_conj_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_disj_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assume_prove_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_non_terminal_proof_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_definition_proof_step_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_body_expr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_body_def_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pcal_p_algorithm_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pcal_p_algorithm_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pcal_p_algorithm_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pcal_c_algorithm_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pcal_c_algorithm_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pcal_c_algorithm_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pcal_p_definitions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pcal_macro_decl_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pcal_proc_decl_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pcal_var_decls_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pcal_proc_var_decls_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pcal_p_stmts_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pcal_c_algorithm_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pcal_assign_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pcal_lhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pcal_p_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pcal_p_either_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pcal_c_either_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pcal_with_vars_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_header_line] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_identifier_ref] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pcal_end_either] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pcal_end_if] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pcal_end_while] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pcal_end_with] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_assumption = 1,
  field_bound = 2,
  field_conclusion = 3,
  field_definition = 4,
  field_definitions = 5,
  field_else = 6,
  field_expr_to_update = 7,
  field_expression = 8,
  field_filter = 9,
  field_generator = 10,
  field_if = 11,
  field_intro = 12,
  field_label = 13,
  field_lhs = 14,
  field_map = 15,
  field_name = 16,
  field_new_val = 17,
  field_op = 18,
  field_parameter = 19,
  field_prefix = 20,
  field_proof = 21,
  field_quantifier = 22,
  field_rhs = 23,
  field_set = 24,
  field_statement = 25,
  field_symbol = 26,
  field_then = 27,
  field_update_specifier = 28,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_assumption] = "assumption",
  [field_bound] = "bound",
  [field_conclusion] = "conclusion",
  [field_definition] = "definition",
  [field_definitions] = "definitions",
  [field_else] = "else",
  [field_expr_to_update] = "expr_to_update",
  [field_expression] = "expression",
  [field_filter] = "filter",
  [field_generator] = "generator",
  [field_if] = "if",
  [field_intro] = "intro",
  [field_label] = "label",
  [field_lhs] = "lhs",
  [field_map] = "map",
  [field_name] = "name",
  [field_new_val] = "new_val",
  [field_op] = "op",
  [field_parameter] = "parameter",
  [field_prefix] = "prefix",
  [field_proof] = "proof",
  [field_quantifier] = "quantifier",
  [field_rhs] = "rhs",
  [field_set] = "set",
  [field_statement] = "statement",
  [field_symbol] = "symbol",
  [field_then] = "then",
  [field_update_specifier] = "update_specifier",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [4] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 2},
  [6] = {.index = 4, .length = 1},
  [7] = {.index = 5, .length = 1},
  [9] = {.index = 6, .length = 2},
  [10] = {.index = 8, .length = 2},
  [11] = {.index = 8, .length = 2},
  [12] = {.index = 10, .length = 2},
  [13] = {.index = 12, .length = 2},
  [14] = {.index = 14, .length = 3},
  [15] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 3},
  [18] = {.index = 22, .length = 2},
  [19] = {.index = 24, .length = 3},
  [20] = {.index = 27, .length = 1},
  [21] = {.index = 28, .length = 1},
  [22] = {.index = 29, .length = 2},
  [23] = {.index = 31, .length = 4},
  [24] = {.index = 35, .length = 4},
  [25] = {.index = 39, .length = 3},
  [26] = {.index = 35, .length = 4},
  [27] = {.index = 42, .length = 2},
  [28] = {.index = 44, .length = 2},
  [29] = {.index = 46, .length = 3},
  [30] = {.index = 49, .length = 1},
  [31] = {.index = 50, .length = 3},
  [32] = {.index = 53, .length = 2},
  [33] = {.index = 55, .length = 1},
  [34] = {.index = 56, .length = 2},
  [35] = {.index = 58, .length = 2},
  [36] = {.index = 60, .length = 5},
  [37] = {.index = 65, .length = 3},
  [38] = {.index = 68, .length = 2},
  [39] = {.index = 70, .length = 5},
  [40] = {.index = 75, .length = 4},
  [41] = {.index = 70, .length = 5},
  [42] = {.index = 79, .length = 1},
  [43] = {.index = 80, .length = 2},
  [44] = {.index = 82, .length = 2},
  [45] = {.index = 84, .length = 4},
  [46] = {.index = 88, .length = 3},
  [47] = {.index = 91, .length = 6},
  [48] = {.index = 97, .length = 2},
  [49] = {.index = 99, .length = 5},
  [50] = {.index = 104, .length = 3},
  [51] = {.index = 107, .length = 3},
  [52] = {.index = 110, .length = 3},
  [53] = {.index = 113, .length = 2},
  [54] = {.index = 115, .length = 2},
  [55] = {.index = 117, .length = 6},
  [56] = {.index = 123, .length = 3},
  [57] = {.index = 126, .length = 1},
  [58] = {.index = 127, .length = 3},
  [59] = {.index = 130, .length = 2},
  [60] = {.index = 113, .length = 2},
  [61] = {.index = 132, .length = 1},
  [62] = {.index = 133, .length = 1},
  [63] = {.index = 133, .length = 1},
  [64] = {.index = 133, .length = 1},
  [65] = {.index = 55, .length = 1},
  [66] = {.index = 134, .length = 2},
  [67] = {.index = 136, .length = 2},
  [68] = {.index = 138, .length = 1},
  [69] = {.index = 133, .length = 1},
  [70] = {.index = 139, .length = 2},
  [71] = {.index = 141, .length = 1},
  [72] = {.index = 142, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0, .inherited = true},
  [1] =
    {field_statement, 1},
  [2] =
    {field_definition, 2},
    {field_name, 0},
  [4] =
    {field_name, 1},
  [5] =
    {field_name, 0},
  [6] =
    {field_rhs, 1},
    {field_symbol, 0},
  [8] =
    {field_op, 1},
    {field_prefix, 0},
  [10] =
    {field_lhs, 0},
    {field_symbol, 1},
  [12] =
    {field_proof, 2},
    {field_statement, 1},
  [14] =
    {field_definition, 3},
    {field_name, 1},
    {field_parameter, 0},
  [17] =
    {field_expression, 2},
    {field_name, 0},
  [19] =
    {field_lhs, 0},
    {field_rhs, 2},
    {field_symbol, 1},
  [22] =
    {field_name, 1},
    {field_statement, 3},
  [24] =
    {field_definition, 3},
    {field_name, 0},
    {field_parameter, 1},
  [27] =
    {field_label, 1, .inherited = true},
  [28] =
    {field_label, 0, .inherited = true},
  [29] =
    {field_intro, 0},
    {field_set, 2},
  [31] =
    {field_definition, 4},
    {field_name, 1},
    {field_parameter, 0},
    {field_parameter, 2},
  [35] =
    {field_name, 0},
    {field_parameter, 1},
    {field_parameter, 2},
    {field_parameter, 3},
  [39] =
    {field_expression, 3},
    {field_intro, 1},
    {field_quantifier, 0},
  [42] =
    {field_expression, 3},
    {field_intro, 1},
  [44] =
    {field_definitions, 1},
    {field_expression, 3},
  [46] =
    {field_bound, 1},
    {field_expression, 3},
    {field_quantifier, 0},
  [49] =
    {field_symbol, 0},
  [50] =
    {field_name, 1},
    {field_proof, 4},
    {field_statement, 3},
  [53] =
    {field_assumption, 1},
    {field_conclusion, 3},
  [55] =
    {field_name, 2},
  [56] =
    {field_label, 0},
    {field_label, 1},
  [58] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [60] =
    {field_definition, 5},
    {field_name, 0},
    {field_parameter, 1},
    {field_parameter, 2},
    {field_parameter, 3},
  [65] =
    {field_intro, 0},
    {field_intro, 1},
    {field_set, 3},
  [68] =
    {field_definition, 5},
    {field_name, 0},
  [70] =
    {field_name, 0},
    {field_parameter, 1},
    {field_parameter, 2},
    {field_parameter, 3},
    {field_parameter, 4},
  [75] =
    {field_expression, 4},
    {field_intro, 1},
    {field_intro, 2},
    {field_quantifier, 0},
  [79] =
    {field_expr_to_update, 1},
  [80] =
    {field_generator, 3},
    {field_map, 1},
  [82] =
    {field_filter, 3},
    {field_generator, 1},
  [84] =
    {field_bound, 1},
    {field_bound, 2},
    {field_expression, 4},
    {field_quantifier, 0},
  [88] =
    {field_assumption, 1},
    {field_assumption, 2},
    {field_conclusion, 4},
  [91] =
    {field_definition, 6},
    {field_name, 0},
    {field_parameter, 1},
    {field_parameter, 2},
    {field_parameter, 3},
    {field_parameter, 4},
  [97] =
    {field_definition, 6},
    {field_name, 0},
  [99] =
    {field_expression, 5},
    {field_name, 0},
    {field_parameter, 1},
    {field_parameter, 2},
    {field_parameter, 3},
  [104] =
    {field_expression, 5},
    {field_intro, 1},
    {field_set, 3},
  [107] =
    {field_generator, 3},
    {field_generator, 4},
    {field_map, 1},
  [110] =
    {field_else, 5},
    {field_if, 1},
    {field_then, 3},
  [113] =
    {field_label, 1, .inherited = true},
    {field_label, 2, .inherited = true},
  [115] =
    {field_name, 1},
    {field_parameter, 3},
  [117] =
    {field_expression, 6},
    {field_name, 0},
    {field_parameter, 1},
    {field_parameter, 2},
    {field_parameter, 3},
    {field_parameter, 4},
  [123] =
    {field_new_val, 3},
    {field_update_specifier, 0},
    {field_update_specifier, 1},
  [126] =
    {field_parameter, 1},
  [127] =
    {field_name, 1},
    {field_parameter, 3},
    {field_parameter, 4, .inherited = true},
  [130] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [132] =
    {field_label, 4, .inherited = true},
  [133] =
    {field_label, 3, .inherited = true},
  [134] =
    {field_label, 3, .inherited = true},
    {field_label, 4, .inherited = true},
  [136] =
    {field_label, 4, .inherited = true},
    {field_label, 6, .inherited = true},
  [138] =
    {field_name, 3},
  [139] =
    {field_label, 3, .inherited = true},
    {field_label, 5, .inherited = true},
  [141] =
    {field_name, 4},
  [142] =
    {field_label, 3, .inherited = true},
    {field_label, 4, .inherited = true},
    {field_label, 6, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [1] = alias_sym_identifier_ref,
  },
  [3] = {
    [0] = alias_sym_identifier_ref,
  },
  [8] = {
    [0] = anon_sym_BSLASHb,
  },
  [10] = {
    [1] = alias_sym_identifier_ref,
  },
  [16] = {
    [2] = alias_sym_identifier_ref,
  },
  [26] = {
    [0] = alias_sym_identifier_ref,
  },
  [33] = {
    [0] = alias_sym_header_line,
    [3] = alias_sym_header_line,
  },
  [41] = {
    [0] = alias_sym_identifier_ref,
  },
  [49] = {
    [2] = alias_sym_identifier_ref,
  },
  [55] = {
    [2] = alias_sym_identifier_ref,
  },
  [60] = {
    [3] = alias_sym_pcal_end_either,
  },
  [62] = {
    [4] = alias_sym_pcal_end_if,
  },
  [63] = {
    [4] = alias_sym_pcal_end_while,
  },
  [64] = {
    [4] = alias_sym_pcal_end_with,
  },
  [66] = {
    [5] = alias_sym_pcal_end_if,
  },
  [70] = {
    [6] = alias_sym_pcal_end_if,
  },
  [72] = {
    [7] = alias_sym_pcal_end_if,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_single_line, 2,
    sym_single_line,
    alias_sym_header_line,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 6,
  [9] = 9,
  [10] = 9,
  [11] = 7,
  [12] = 12,
  [13] = 13,
  [14] = 13,
  [15] = 13,
  [16] = 13,
  [17] = 17,
  [18] = 18,
  [19] = 17,
  [20] = 17,
  [21] = 18,
  [22] = 18,
  [23] = 23,
  [24] = 23,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 27,
  [29] = 27,
  [30] = 25,
  [31] = 23,
  [32] = 25,
  [33] = 33,
  [34] = 33,
  [35] = 35,
  [36] = 35,
  [37] = 33,
  [38] = 35,
  [39] = 7,
  [40] = 40,
  [41] = 9,
  [42] = 6,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 44,
  [48] = 46,
  [49] = 44,
  [50] = 43,
  [51] = 6,
  [52] = 7,
  [53] = 9,
  [54] = 54,
  [55] = 46,
  [56] = 44,
  [57] = 6,
  [58] = 7,
  [59] = 9,
  [60] = 60,
  [61] = 54,
  [62] = 45,
  [63] = 63,
  [64] = 63,
  [65] = 46,
  [66] = 54,
  [67] = 44,
  [68] = 54,
  [69] = 54,
  [70] = 54,
  [71] = 54,
  [72] = 54,
  [73] = 54,
  [74] = 54,
  [75] = 54,
  [76] = 54,
  [77] = 54,
  [78] = 54,
  [79] = 54,
  [80] = 54,
  [81] = 54,
  [82] = 82,
  [83] = 43,
  [84] = 63,
  [85] = 82,
  [86] = 43,
  [87] = 46,
  [88] = 82,
  [89] = 43,
  [90] = 63,
  [91] = 82,
  [92] = 43,
  [93] = 63,
  [94] = 82,
  [95] = 43,
  [96] = 63,
  [97] = 82,
  [98] = 43,
  [99] = 63,
  [100] = 82,
  [101] = 43,
  [102] = 63,
  [103] = 82,
  [104] = 43,
  [105] = 63,
  [106] = 82,
  [107] = 43,
  [108] = 63,
  [109] = 82,
  [110] = 43,
  [111] = 63,
  [112] = 82,
  [113] = 43,
  [114] = 63,
  [115] = 82,
  [116] = 43,
  [117] = 63,
  [118] = 82,
  [119] = 82,
  [120] = 63,
  [121] = 82,
  [122] = 43,
  [123] = 63,
  [124] = 82,
  [125] = 43,
  [126] = 63,
  [127] = 43,
  [128] = 46,
  [129] = 44,
  [130] = 63,
  [131] = 131,
  [132] = 7,
  [133] = 9,
  [134] = 134,
  [135] = 135,
  [136] = 131,
  [137] = 134,
  [138] = 135,
  [139] = 131,
  [140] = 134,
  [141] = 135,
  [142] = 134,
  [143] = 135,
  [144] = 131,
  [145] = 134,
  [146] = 134,
  [147] = 135,
  [148] = 131,
  [149] = 134,
  [150] = 135,
  [151] = 131,
  [152] = 134,
  [153] = 135,
  [154] = 131,
  [155] = 6,
  [156] = 135,
  [157] = 131,
  [158] = 134,
  [159] = 135,
  [160] = 131,
  [161] = 134,
  [162] = 135,
  [163] = 131,
  [164] = 134,
  [165] = 135,
  [166] = 131,
  [167] = 134,
  [168] = 135,
  [169] = 131,
  [170] = 134,
  [171] = 135,
  [172] = 131,
  [173] = 134,
  [174] = 135,
  [175] = 131,
  [176] = 134,
  [177] = 135,
  [178] = 131,
  [179] = 134,
  [180] = 131,
  [181] = 6,
  [182] = 7,
  [183] = 9,
  [184] = 135,
  [185] = 134,
  [186] = 186,
  [187] = 187,
  [188] = 186,
  [189] = 189,
  [190] = 190,
  [191] = 187,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 189,
  [196] = 190,
  [197] = 187,
  [198] = 198,
  [199] = 187,
  [200] = 189,
  [201] = 201,
  [202] = 194,
  [203] = 193,
  [204] = 189,
  [205] = 187,
  [206] = 194,
  [207] = 189,
  [208] = 190,
  [209] = 198,
  [210] = 190,
  [211] = 194,
  [212] = 194,
  [213] = 194,
  [214] = 190,
  [215] = 194,
  [216] = 194,
  [217] = 194,
  [218] = 194,
  [219] = 194,
  [220] = 194,
  [221] = 194,
  [222] = 194,
  [223] = 194,
  [224] = 194,
  [225] = 194,
  [226] = 198,
  [227] = 6,
  [228] = 6,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 9,
  [233] = 230,
  [234] = 234,
  [235] = 231,
  [236] = 6,
  [237] = 231,
  [238] = 231,
  [239] = 230,
  [240] = 231,
  [241] = 231,
  [242] = 230,
  [243] = 231,
  [244] = 231,
  [245] = 7,
  [246] = 230,
  [247] = 6,
  [248] = 7,
  [249] = 9,
  [250] = 6,
  [251] = 7,
  [252] = 9,
  [253] = 6,
  [254] = 7,
  [255] = 9,
  [256] = 6,
  [257] = 7,
  [258] = 9,
  [259] = 6,
  [260] = 7,
  [261] = 9,
  [262] = 6,
  [263] = 7,
  [264] = 9,
  [265] = 6,
  [266] = 7,
  [267] = 9,
  [268] = 9,
  [269] = 6,
  [270] = 7,
  [271] = 230,
  [272] = 6,
  [273] = 7,
  [274] = 9,
  [275] = 6,
  [276] = 7,
  [277] = 9,
  [278] = 6,
  [279] = 7,
  [280] = 9,
  [281] = 231,
  [282] = 230,
  [283] = 231,
  [284] = 6,
  [285] = 7,
  [286] = 9,
  [287] = 6,
  [288] = 231,
  [289] = 230,
  [290] = 7,
  [291] = 230,
  [292] = 9,
  [293] = 230,
  [294] = 294,
  [295] = 231,
  [296] = 230,
  [297] = 7,
  [298] = 230,
  [299] = 9,
  [300] = 300,
  [301] = 231,
  [302] = 231,
  [303] = 231,
  [304] = 230,
  [305] = 230,
  [306] = 230,
  [307] = 230,
  [308] = 231,
  [309] = 7,
  [310] = 9,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 314,
  [341] = 341,
  [342] = 342,
  [343] = 311,
  [344] = 344,
  [345] = 345,
  [346] = 312,
  [347] = 313,
  [348] = 316,
  [349] = 317,
  [350] = 318,
  [351] = 319,
  [352] = 321,
  [353] = 353,
  [354] = 354,
  [355] = 341,
  [356] = 325,
  [357] = 326,
  [358] = 327,
  [359] = 328,
  [360] = 329,
  [361] = 330,
  [362] = 331,
  [363] = 332,
  [364] = 333,
  [365] = 334,
  [366] = 335,
  [367] = 336,
  [368] = 337,
  [369] = 338,
  [370] = 339,
  [371] = 314,
  [372] = 341,
  [373] = 342,
  [374] = 311,
  [375] = 342,
  [376] = 312,
  [377] = 313,
  [378] = 316,
  [379] = 317,
  [380] = 318,
  [381] = 319,
  [382] = 321,
  [383] = 311,
  [384] = 325,
  [385] = 326,
  [386] = 327,
  [387] = 328,
  [388] = 329,
  [389] = 330,
  [390] = 331,
  [391] = 332,
  [392] = 333,
  [393] = 334,
  [394] = 335,
  [395] = 336,
  [396] = 337,
  [397] = 338,
  [398] = 339,
  [399] = 314,
  [400] = 341,
  [401] = 342,
  [402] = 311,
  [403] = 312,
  [404] = 313,
  [405] = 316,
  [406] = 317,
  [407] = 318,
  [408] = 319,
  [409] = 321,
  [410] = 325,
  [411] = 326,
  [412] = 327,
  [413] = 328,
  [414] = 329,
  [415] = 330,
  [416] = 331,
  [417] = 332,
  [418] = 333,
  [419] = 334,
  [420] = 335,
  [421] = 336,
  [422] = 337,
  [423] = 338,
  [424] = 339,
  [425] = 314,
  [426] = 341,
  [427] = 342,
  [428] = 311,
  [429] = 312,
  [430] = 313,
  [431] = 316,
  [432] = 317,
  [433] = 318,
  [434] = 319,
  [435] = 321,
  [436] = 325,
  [437] = 326,
  [438] = 327,
  [439] = 328,
  [440] = 329,
  [441] = 330,
  [442] = 331,
  [443] = 332,
  [444] = 333,
  [445] = 334,
  [446] = 335,
  [447] = 336,
  [448] = 337,
  [449] = 338,
  [450] = 339,
  [451] = 314,
  [452] = 341,
  [453] = 342,
  [454] = 311,
  [455] = 312,
  [456] = 313,
  [457] = 316,
  [458] = 317,
  [459] = 318,
  [460] = 319,
  [461] = 321,
  [462] = 325,
  [463] = 326,
  [464] = 327,
  [465] = 328,
  [466] = 329,
  [467] = 330,
  [468] = 331,
  [469] = 332,
  [470] = 333,
  [471] = 334,
  [472] = 335,
  [473] = 336,
  [474] = 337,
  [475] = 338,
  [476] = 339,
  [477] = 314,
  [478] = 341,
  [479] = 342,
  [480] = 311,
  [481] = 312,
  [482] = 313,
  [483] = 316,
  [484] = 317,
  [485] = 318,
  [486] = 319,
  [487] = 321,
  [488] = 488,
  [489] = 325,
  [490] = 326,
  [491] = 327,
  [492] = 328,
  [493] = 329,
  [494] = 330,
  [495] = 331,
  [496] = 332,
  [497] = 333,
  [498] = 334,
  [499] = 335,
  [500] = 336,
  [501] = 337,
  [502] = 338,
  [503] = 339,
  [504] = 314,
  [505] = 341,
  [506] = 342,
  [507] = 311,
  [508] = 312,
  [509] = 313,
  [510] = 316,
  [511] = 317,
  [512] = 318,
  [513] = 319,
  [514] = 321,
  [515] = 515,
  [516] = 516,
  [517] = 325,
  [518] = 326,
  [519] = 327,
  [520] = 328,
  [521] = 329,
  [522] = 330,
  [523] = 331,
  [524] = 332,
  [525] = 333,
  [526] = 334,
  [527] = 335,
  [528] = 336,
  [529] = 337,
  [530] = 338,
  [531] = 339,
  [532] = 314,
  [533] = 341,
  [534] = 342,
  [535] = 311,
  [536] = 312,
  [537] = 313,
  [538] = 316,
  [539] = 317,
  [540] = 318,
  [541] = 319,
  [542] = 321,
  [543] = 543,
  [544] = 325,
  [545] = 326,
  [546] = 327,
  [547] = 328,
  [548] = 329,
  [549] = 330,
  [550] = 331,
  [551] = 332,
  [552] = 333,
  [553] = 334,
  [554] = 335,
  [555] = 336,
  [556] = 337,
  [557] = 338,
  [558] = 339,
  [559] = 314,
  [560] = 341,
  [561] = 342,
  [562] = 311,
  [563] = 312,
  [564] = 313,
  [565] = 316,
  [566] = 317,
  [567] = 318,
  [568] = 319,
  [569] = 321,
  [570] = 570,
  [571] = 571,
  [572] = 325,
  [573] = 326,
  [574] = 327,
  [575] = 328,
  [576] = 329,
  [577] = 330,
  [578] = 331,
  [579] = 332,
  [580] = 333,
  [581] = 334,
  [582] = 335,
  [583] = 336,
  [584] = 337,
  [585] = 338,
  [586] = 339,
  [587] = 314,
  [588] = 341,
  [589] = 342,
  [590] = 311,
  [591] = 312,
  [592] = 313,
  [593] = 593,
  [594] = 316,
  [595] = 317,
  [596] = 318,
  [597] = 319,
  [598] = 321,
  [599] = 599,
  [600] = 600,
  [601] = 326,
  [602] = 325,
  [603] = 326,
  [604] = 327,
  [605] = 328,
  [606] = 329,
  [607] = 330,
  [608] = 331,
  [609] = 332,
  [610] = 333,
  [611] = 334,
  [612] = 335,
  [613] = 336,
  [614] = 337,
  [615] = 338,
  [616] = 339,
  [617] = 314,
  [618] = 341,
  [619] = 342,
  [620] = 311,
  [621] = 312,
  [622] = 313,
  [623] = 316,
  [624] = 317,
  [625] = 318,
  [626] = 319,
  [627] = 321,
  [628] = 628,
  [629] = 629,
  [630] = 325,
  [631] = 326,
  [632] = 327,
  [633] = 328,
  [634] = 329,
  [635] = 330,
  [636] = 331,
  [637] = 332,
  [638] = 333,
  [639] = 334,
  [640] = 335,
  [641] = 336,
  [642] = 337,
  [643] = 338,
  [644] = 339,
  [645] = 314,
  [646] = 341,
  [647] = 342,
  [648] = 648,
  [649] = 312,
  [650] = 313,
  [651] = 316,
  [652] = 317,
  [653] = 318,
  [654] = 319,
  [655] = 321,
  [656] = 325,
  [657] = 326,
  [658] = 327,
  [659] = 328,
  [660] = 329,
  [661] = 330,
  [662] = 331,
  [663] = 332,
  [664] = 333,
  [665] = 334,
  [666] = 335,
  [667] = 336,
  [668] = 337,
  [669] = 338,
  [670] = 339,
  [671] = 314,
  [672] = 341,
  [673] = 342,
  [674] = 311,
  [675] = 312,
  [676] = 313,
  [677] = 316,
  [678] = 317,
  [679] = 318,
  [680] = 319,
  [681] = 321,
  [682] = 312,
  [683] = 683,
  [684] = 313,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 315,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 327,
  [697] = 328,
  [698] = 698,
  [699] = 699,
  [700] = 324,
  [701] = 316,
  [702] = 702,
  [703] = 515,
  [704] = 628,
  [705] = 317,
  [706] = 687,
  [707] = 318,
  [708] = 319,
  [709] = 488,
  [710] = 516,
  [711] = 329,
  [712] = 712,
  [713] = 713,
  [714] = 629,
  [715] = 689,
  [716] = 716,
  [717] = 698,
  [718] = 718,
  [719] = 315,
  [720] = 320,
  [721] = 330,
  [722] = 722,
  [723] = 723,
  [724] = 331,
  [725] = 699,
  [726] = 324,
  [727] = 515,
  [728] = 628,
  [729] = 320,
  [730] = 687,
  [731] = 718,
  [732] = 732,
  [733] = 488,
  [734] = 516,
  [735] = 712,
  [736] = 713,
  [737] = 737,
  [738] = 629,
  [739] = 689,
  [740] = 740,
  [741] = 698,
  [742] = 718,
  [743] = 315,
  [744] = 320,
  [745] = 745,
  [746] = 332,
  [747] = 693,
  [748] = 321,
  [749] = 687,
  [750] = 750,
  [751] = 488,
  [752] = 516,
  [753] = 712,
  [754] = 713,
  [755] = 629,
  [756] = 689,
  [757] = 698,
  [758] = 718,
  [759] = 315,
  [760] = 320,
  [761] = 333,
  [762] = 334,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 315,
  [767] = 320,
  [768] = 335,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 336,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 337,
  [779] = 338,
  [780] = 325,
  [781] = 488,
  [782] = 516,
  [783] = 543,
  [784] = 326,
  [785] = 327,
  [786] = 328,
  [787] = 329,
  [788] = 330,
  [789] = 331,
  [790] = 332,
  [791] = 333,
  [792] = 334,
  [793] = 335,
  [794] = 336,
  [795] = 337,
  [796] = 338,
  [797] = 797,
  [798] = 648,
  [799] = 712,
  [800] = 713,
  [801] = 339,
  [802] = 314,
  [803] = 341,
  [804] = 342,
  [805] = 311,
  [806] = 345,
  [807] = 325,
  [808] = 808,
  [809] = 692,
  [810] = 797,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 322,
  [816] = 344,
  [817] = 353,
  [818] = 354,
  [819] = 683,
  [820] = 685,
  [821] = 345,
  [822] = 629,
  [823] = 692,
  [824] = 797,
  [825] = 811,
  [826] = 812,
  [827] = 813,
  [828] = 814,
  [829] = 322,
  [830] = 344,
  [831] = 712,
  [832] = 353,
  [833] = 354,
  [834] = 683,
  [835] = 685,
  [836] = 345,
  [837] = 699,
  [838] = 692,
  [839] = 797,
  [840] = 811,
  [841] = 812,
  [842] = 813,
  [843] = 814,
  [844] = 322,
  [845] = 344,
  [846] = 312,
  [847] = 353,
  [848] = 354,
  [849] = 683,
  [850] = 685,
  [851] = 345,
  [852] = 692,
  [853] = 797,
  [854] = 811,
  [855] = 812,
  [856] = 813,
  [857] = 814,
  [858] = 322,
  [859] = 344,
  [860] = 353,
  [861] = 354,
  [862] = 683,
  [863] = 685,
  [864] = 345,
  [865] = 313,
  [866] = 692,
  [867] = 797,
  [868] = 811,
  [869] = 812,
  [870] = 813,
  [871] = 814,
  [872] = 322,
  [873] = 344,
  [874] = 713,
  [875] = 353,
  [876] = 354,
  [877] = 683,
  [878] = 685,
  [879] = 345,
  [880] = 315,
  [881] = 689,
  [882] = 692,
  [883] = 797,
  [884] = 811,
  [885] = 812,
  [886] = 813,
  [887] = 814,
  [888] = 322,
  [889] = 344,
  [890] = 353,
  [891] = 354,
  [892] = 683,
  [893] = 685,
  [894] = 345,
  [895] = 698,
  [896] = 692,
  [897] = 797,
  [898] = 811,
  [899] = 812,
  [900] = 813,
  [901] = 814,
  [902] = 322,
  [903] = 344,
  [904] = 316,
  [905] = 353,
  [906] = 354,
  [907] = 683,
  [908] = 685,
  [909] = 345,
  [910] = 317,
  [911] = 318,
  [912] = 692,
  [913] = 797,
  [914] = 811,
  [915] = 812,
  [916] = 813,
  [917] = 814,
  [918] = 322,
  [919] = 344,
  [920] = 319,
  [921] = 353,
  [922] = 354,
  [923] = 683,
  [924] = 685,
  [925] = 345,
  [926] = 320,
  [927] = 692,
  [928] = 797,
  [929] = 811,
  [930] = 812,
  [931] = 813,
  [932] = 814,
  [933] = 322,
  [934] = 344,
  [935] = 718,
  [936] = 353,
  [937] = 354,
  [938] = 683,
  [939] = 685,
  [940] = 345,
  [941] = 321,
  [942] = 692,
  [943] = 797,
  [944] = 811,
  [945] = 812,
  [946] = 813,
  [947] = 814,
  [948] = 322,
  [949] = 344,
  [950] = 353,
  [951] = 354,
  [952] = 683,
  [953] = 685,
  [954] = 345,
  [955] = 692,
  [956] = 797,
  [957] = 811,
  [958] = 812,
  [959] = 813,
  [960] = 814,
  [961] = 322,
  [962] = 344,
  [963] = 353,
  [964] = 354,
  [965] = 683,
  [966] = 685,
  [967] = 345,
  [968] = 968,
  [969] = 969,
  [970] = 692,
  [971] = 797,
  [972] = 811,
  [973] = 812,
  [974] = 813,
  [975] = 814,
  [976] = 322,
  [977] = 344,
  [978] = 339,
  [979] = 353,
  [980] = 354,
  [981] = 683,
  [982] = 685,
  [983] = 345,
  [984] = 325,
  [985] = 692,
  [986] = 797,
  [987] = 811,
  [988] = 812,
  [989] = 813,
  [990] = 814,
  [991] = 322,
  [992] = 344,
  [993] = 326,
  [994] = 353,
  [995] = 354,
  [996] = 683,
  [997] = 685,
  [998] = 345,
  [999] = 327,
  [1000] = 692,
  [1001] = 797,
  [1002] = 811,
  [1003] = 812,
  [1004] = 813,
  [1005] = 814,
  [1006] = 322,
  [1007] = 344,
  [1008] = 328,
  [1009] = 353,
  [1010] = 354,
  [1011] = 683,
  [1012] = 685,
  [1013] = 345,
  [1014] = 329,
  [1015] = 330,
  [1016] = 692,
  [1017] = 797,
  [1018] = 811,
  [1019] = 812,
  [1020] = 813,
  [1021] = 814,
  [1022] = 322,
  [1023] = 344,
  [1024] = 331,
  [1025] = 353,
  [1026] = 354,
  [1027] = 683,
  [1028] = 685,
  [1029] = 345,
  [1030] = 332,
  [1031] = 797,
  [1032] = 811,
  [1033] = 812,
  [1034] = 813,
  [1035] = 814,
  [1036] = 344,
  [1037] = 683,
  [1038] = 685,
  [1039] = 333,
  [1040] = 334,
  [1041] = 335,
  [1042] = 336,
  [1043] = 337,
  [1044] = 338,
  [1045] = 339,
  [1046] = 314,
  [1047] = 341,
  [1048] = 342,
  [1049] = 311,
  [1050] = 811,
  [1051] = 812,
  [1052] = 813,
  [1053] = 814,
  [1054] = 808,
  [1055] = 648,
  [1056] = 808,
  [1057] = 648,
  [1058] = 808,
  [1059] = 648,
  [1060] = 808,
  [1061] = 648,
  [1062] = 808,
  [1063] = 648,
  [1064] = 808,
  [1065] = 648,
  [1066] = 808,
  [1067] = 648,
  [1068] = 808,
  [1069] = 648,
  [1070] = 808,
  [1071] = 648,
  [1072] = 808,
  [1073] = 648,
  [1074] = 808,
  [1075] = 648,
  [1076] = 808,
  [1077] = 648,
  [1078] = 808,
  [1079] = 648,
  [1080] = 808,
  [1081] = 648,
  [1082] = 808,
  [1083] = 648,
  [1084] = 515,
  [1085] = 1085,
  [1086] = 1085,
  [1087] = 1085,
  [1088] = 1085,
  [1089] = 1085,
  [1090] = 1085,
  [1091] = 1085,
  [1092] = 1085,
  [1093] = 1085,
  [1094] = 1085,
  [1095] = 1085,
  [1096] = 1085,
  [1097] = 1085,
  [1098] = 1085,
  [1099] = 1085,
  [1100] = 1085,
  [1101] = 1101,
  [1102] = 1101,
  [1103] = 1103,
  [1104] = 1103,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 1107,
  [1109] = 1105,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1112,
  [1113] = 1111,
  [1114] = 1112,
  [1115] = 1110,
  [1116] = 1111,
  [1117] = 1111,
  [1118] = 1111,
  [1119] = 1112,
  [1120] = 1112,
  [1121] = 1111,
  [1122] = 1112,
  [1123] = 1111,
  [1124] = 1112,
  [1125] = 1112,
  [1126] = 1112,
  [1127] = 1112,
  [1128] = 1111,
  [1129] = 1112,
  [1130] = 1111,
  [1131] = 1111,
  [1132] = 1112,
  [1133] = 1112,
  [1134] = 1112,
  [1135] = 1112,
  [1136] = 1111,
  [1137] = 1112,
  [1138] = 1111,
  [1139] = 1112,
  [1140] = 1111,
  [1141] = 1110,
  [1142] = 1110,
  [1143] = 1111,
  [1144] = 1110,
  [1145] = 1111,
  [1146] = 1110,
  [1147] = 1112,
  [1148] = 1110,
  [1149] = 1110,
  [1150] = 1110,
  [1151] = 1110,
  [1152] = 1111,
  [1153] = 1110,
  [1154] = 1110,
  [1155] = 1110,
  [1156] = 1110,
  [1157] = 1110,
  [1158] = 1110,
  [1159] = 1111,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1163,
  [1175] = 1175,
  [1176] = 1164,
  [1177] = 1165,
  [1178] = 1167,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 1186,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1172,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1168,
  [1194] = 1161,
  [1195] = 1162,
  [1196] = 1196,
  [1197] = 1180,
  [1198] = 1196,
  [1199] = 1199,
  [1200] = 1169,
  [1201] = 1170,
  [1202] = 1202,
  [1203] = 1191,
  [1204] = 1192,
  [1205] = 1171,
  [1206] = 1175,
  [1207] = 1166,
  [1208] = 1199,
  [1209] = 1160,
  [1210] = 1179,
  [1211] = 1181,
  [1212] = 1189,
  [1213] = 1182,
  [1214] = 1183,
  [1215] = 1173,
  [1216] = 1202,
  [1217] = 1184,
  [1218] = 1185,
  [1219] = 1186,
  [1220] = 1187,
  [1221] = 1188,
  [1222] = 1222,
  [1223] = 1222,
  [1224] = 1183,
  [1225] = 1165,
  [1226] = 1188,
  [1227] = 1187,
  [1228] = 1171,
  [1229] = 1189,
  [1230] = 1180,
  [1231] = 1188,
  [1232] = 1175,
  [1233] = 1166,
  [1234] = 1160,
  [1235] = 1166,
  [1236] = 1179,
  [1237] = 1237,
  [1238] = 1169,
  [1239] = 1173,
  [1240] = 1161,
  [1241] = 1163,
  [1242] = 1164,
  [1243] = 1165,
  [1244] = 1167,
  [1245] = 1189,
  [1246] = 1237,
  [1247] = 1172,
  [1248] = 1186,
  [1249] = 1169,
  [1250] = 1180,
  [1251] = 1175,
  [1252] = 1181,
  [1253] = 1184,
  [1254] = 1182,
  [1255] = 1187,
  [1256] = 1173,
  [1257] = 1185,
  [1258] = 1161,
  [1259] = 1160,
  [1260] = 1162,
  [1261] = 1179,
  [1262] = 1170,
  [1263] = 1191,
  [1264] = 1192,
  [1265] = 1191,
  [1266] = 1181,
  [1267] = 1192,
  [1268] = 1162,
  [1269] = 1172,
  [1270] = 1163,
  [1271] = 1171,
  [1272] = 1184,
  [1273] = 1185,
  [1274] = 1199,
  [1275] = 1199,
  [1276] = 1182,
  [1277] = 1202,
  [1278] = 1167,
  [1279] = 1186,
  [1280] = 1202,
  [1281] = 1170,
  [1282] = 1164,
  [1283] = 1183,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1284,
  [1287] = 1285,
  [1288] = 1288,
  [1289] = 1288,
  [1290] = 1290,
  [1291] = 1290,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 1294,
  [1295] = 1295,
  [1296] = 1293,
  [1297] = 1297,
  [1298] = 1298,
  [1299] = 1295,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1292,
  [1303] = 1298,
  [1304] = 1300,
  [1305] = 1301,
  [1306] = 1306,
  [1307] = 1297,
  [1308] = 1294,
  [1309] = 1306,
  [1310] = 1310,
  [1311] = 1310,
  [1312] = 1310,
  [1313] = 1310,
  [1314] = 1310,
  [1315] = 1310,
  [1316] = 1310,
  [1317] = 1310,
  [1318] = 1310,
  [1319] = 1310,
  [1320] = 1310,
  [1321] = 1310,
  [1322] = 1310,
  [1323] = 1310,
  [1324] = 1310,
  [1325] = 1310,
  [1326] = 1310,
  [1327] = 1166,
  [1328] = 1161,
  [1329] = 1162,
  [1330] = 1170,
  [1331] = 1171,
  [1332] = 1175,
  [1333] = 1160,
  [1334] = 1179,
  [1335] = 1181,
  [1336] = 1182,
  [1337] = 1183,
  [1338] = 1184,
  [1339] = 1185,
  [1340] = 1186,
  [1341] = 1187,
  [1342] = 1188,
  [1343] = 1189,
  [1344] = 1172,
  [1345] = 1180,
  [1346] = 1191,
  [1347] = 1192,
  [1348] = 1199,
  [1349] = 1202,
  [1350] = 1169,
  [1351] = 1173,
  [1352] = 1163,
  [1353] = 1164,
  [1354] = 1165,
  [1355] = 1288,
  [1356] = 1161,
  [1357] = 1162,
  [1358] = 1170,
  [1359] = 1171,
  [1360] = 1175,
  [1361] = 1160,
  [1362] = 1179,
  [1363] = 1181,
  [1364] = 1182,
  [1365] = 1183,
  [1366] = 1184,
  [1367] = 1185,
  [1368] = 1186,
  [1369] = 1187,
  [1370] = 1188,
  [1371] = 1189,
  [1372] = 1172,
  [1373] = 1180,
  [1374] = 1191,
  [1375] = 1192,
  [1376] = 1199,
  [1377] = 1202,
  [1378] = 1166,
  [1379] = 1169,
  [1380] = 1173,
  [1381] = 1163,
  [1382] = 1164,
  [1383] = 1165,
  [1384] = 1167,
  [1385] = 1285,
  [1386] = 1284,
  [1387] = 1167,
  [1388] = 1300,
  [1389] = 1175,
  [1390] = 1293,
  [1391] = 1160,
  [1392] = 1179,
  [1393] = 1181,
  [1394] = 1182,
  [1395] = 1183,
  [1396] = 1184,
  [1397] = 1185,
  [1398] = 1186,
  [1399] = 1187,
  [1400] = 1188,
  [1401] = 1189,
  [1402] = 1172,
  [1403] = 1180,
  [1404] = 1161,
  [1405] = 1295,
  [1406] = 1191,
  [1407] = 1192,
  [1408] = 1199,
  [1409] = 1202,
  [1410] = 1166,
  [1411] = 1292,
  [1412] = 1297,
  [1413] = 1169,
  [1414] = 1173,
  [1415] = 1288,
  [1416] = 1301,
  [1417] = 1163,
  [1418] = 1164,
  [1419] = 1165,
  [1420] = 1167,
  [1421] = 1290,
  [1422] = 1162,
  [1423] = 1170,
  [1424] = 1171,
  [1425] = 1285,
  [1426] = 1284,
  [1427] = 1298,
  [1428] = 1284,
  [1429] = 1295,
  [1430] = 1292,
  [1431] = 1297,
  [1432] = 1300,
  [1433] = 1301,
  [1434] = 1285,
  [1435] = 1290,
  [1436] = 1161,
  [1437] = 1162,
  [1438] = 1288,
  [1439] = 1170,
  [1440] = 1171,
  [1441] = 1175,
  [1442] = 1160,
  [1443] = 1179,
  [1444] = 1181,
  [1445] = 1182,
  [1446] = 1183,
  [1447] = 1184,
  [1448] = 1185,
  [1449] = 1186,
  [1450] = 1187,
  [1451] = 1188,
  [1452] = 1189,
  [1453] = 1172,
  [1454] = 1180,
  [1455] = 1191,
  [1456] = 1192,
  [1457] = 1199,
  [1458] = 1202,
  [1459] = 1166,
  [1460] = 1169,
  [1461] = 1173,
  [1462] = 1163,
  [1463] = 1164,
  [1464] = 1165,
  [1465] = 1167,
  [1466] = 1293,
  [1467] = 1298,
  [1468] = 1301,
  [1469] = 1290,
  [1470] = 1293,
  [1471] = 1298,
  [1472] = 1295,
  [1473] = 1292,
  [1474] = 1297,
  [1475] = 1300,
  [1476] = 1476,
  [1477] = 1477,
  [1478] = 1477,
  [1479] = 1476,
  [1480] = 1477,
  [1481] = 1476,
  [1482] = 1476,
  [1483] = 1476,
  [1484] = 1476,
  [1485] = 1477,
  [1486] = 1477,
  [1487] = 1477,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1165,
  [1491] = 1182,
  [1492] = 1166,
  [1493] = 1169,
  [1494] = 1173,
  [1495] = 1163,
  [1496] = 1164,
  [1497] = 1161,
  [1498] = 1183,
  [1499] = 1184,
  [1500] = 1167,
  [1501] = 1185,
  [1502] = 1186,
  [1503] = 1187,
  [1504] = 1188,
  [1505] = 1189,
  [1506] = 1172,
  [1507] = 1180,
  [1508] = 1191,
  [1509] = 1192,
  [1510] = 1162,
  [1511] = 1170,
  [1512] = 1171,
  [1513] = 1199,
  [1514] = 1175,
  [1515] = 1160,
  [1516] = 1179,
  [1517] = 1181,
  [1518] = 1202,
  [1519] = 1519,
  [1520] = 1519,
  [1521] = 1519,
  [1522] = 1519,
  [1523] = 1519,
  [1524] = 1519,
  [1525] = 1519,
  [1526] = 1519,
  [1527] = 1519,
  [1528] = 1519,
  [1529] = 1519,
  [1530] = 1519,
  [1531] = 1519,
  [1532] = 1519,
  [1533] = 1519,
  [1534] = 1519,
  [1535] = 1519,
  [1536] = 1164,
  [1537] = 1182,
  [1538] = 1183,
  [1539] = 1184,
  [1540] = 1185,
  [1541] = 1186,
  [1542] = 1187,
  [1543] = 1188,
  [1544] = 1189,
  [1545] = 1172,
  [1546] = 1162,
  [1547] = 1547,
  [1548] = 1180,
  [1549] = 1191,
  [1550] = 1192,
  [1551] = 1199,
  [1552] = 1202,
  [1553] = 1553,
  [1554] = 1170,
  [1555] = 1166,
  [1556] = 1169,
  [1557] = 1171,
  [1558] = 1161,
  [1559] = 1175,
  [1560] = 1173,
  [1561] = 1163,
  [1562] = 1160,
  [1563] = 1165,
  [1564] = 1167,
  [1565] = 1179,
  [1566] = 1181,
  [1567] = 1567,
  [1568] = 1568,
  [1569] = 1163,
  [1570] = 1160,
  [1571] = 1199,
  [1572] = 1202,
  [1573] = 1166,
  [1574] = 1169,
  [1575] = 1173,
  [1576] = 1164,
  [1577] = 1165,
  [1578] = 1167,
  [1579] = 1181,
  [1580] = 1182,
  [1581] = 1183,
  [1582] = 1184,
  [1583] = 1185,
  [1584] = 1186,
  [1585] = 1187,
  [1586] = 1188,
  [1587] = 1189,
  [1588] = 1172,
  [1589] = 1180,
  [1590] = 1191,
  [1591] = 1192,
  [1592] = 1161,
  [1593] = 1179,
  [1594] = 1162,
  [1595] = 1170,
  [1596] = 1171,
  [1597] = 1175,
  [1598] = 1165,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1602,
  [1603] = 1161,
  [1604] = 1162,
  [1605] = 1170,
  [1606] = 1171,
  [1607] = 1175,
  [1608] = 1160,
  [1609] = 1179,
  [1610] = 1181,
  [1611] = 1182,
  [1612] = 1183,
  [1613] = 1184,
  [1614] = 1599,
  [1615] = 1186,
  [1616] = 1187,
  [1617] = 1188,
  [1618] = 1189,
  [1619] = 1172,
  [1620] = 1180,
  [1621] = 1191,
  [1622] = 1192,
  [1623] = 1199,
  [1624] = 1202,
  [1625] = 1166,
  [1626] = 1169,
  [1627] = 1173,
  [1628] = 1163,
  [1629] = 1164,
  [1630] = 1167,
  [1631] = 1600,
  [1632] = 1601,
  [1633] = 1602,
  [1634] = 1634,
  [1635] = 1185,
  [1636] = 1636,
  [1637] = 1636,
  [1638] = 1187,
  [1639] = 1163,
  [1640] = 1181,
  [1641] = 1182,
  [1642] = 1188,
  [1643] = 1189,
  [1644] = 1172,
  [1645] = 1180,
  [1646] = 1191,
  [1647] = 1173,
  [1648] = 1192,
  [1649] = 1636,
  [1650] = 1168,
  [1651] = 1171,
  [1652] = 1199,
  [1653] = 1202,
  [1654] = 1166,
  [1655] = 1160,
  [1656] = 1196,
  [1657] = 1169,
  [1658] = 1173,
  [1659] = 1163,
  [1660] = 1160,
  [1661] = 1164,
  [1662] = 1165,
  [1663] = 1183,
  [1664] = 1167,
  [1665] = 1183,
  [1666] = 1184,
  [1667] = 1170,
  [1668] = 1185,
  [1669] = 1184,
  [1670] = 1186,
  [1671] = 1170,
  [1672] = 1672,
  [1673] = 1673,
  [1674] = 1185,
  [1675] = 1186,
  [1676] = 1636,
  [1677] = 1161,
  [1678] = 1162,
  [1679] = 1636,
  [1680] = 1187,
  [1681] = 1164,
  [1682] = 1165,
  [1683] = 1636,
  [1684] = 1188,
  [1685] = 1170,
  [1686] = 1171,
  [1687] = 1171,
  [1688] = 1175,
  [1689] = 1175,
  [1690] = 1160,
  [1691] = 1636,
  [1692] = 1179,
  [1693] = 1181,
  [1694] = 1182,
  [1695] = 1183,
  [1696] = 1184,
  [1697] = 1185,
  [1698] = 1186,
  [1699] = 1187,
  [1700] = 1188,
  [1701] = 1189,
  [1702] = 1172,
  [1703] = 1636,
  [1704] = 1180,
  [1705] = 1191,
  [1706] = 1192,
  [1707] = 1199,
  [1708] = 1202,
  [1709] = 1166,
  [1710] = 1169,
  [1711] = 1173,
  [1712] = 1636,
  [1713] = 1163,
  [1714] = 1164,
  [1715] = 1165,
  [1716] = 1167,
  [1717] = 1189,
  [1718] = 1172,
  [1719] = 1180,
  [1720] = 1636,
  [1721] = 1191,
  [1722] = 1167,
  [1723] = 1161,
  [1724] = 1162,
  [1725] = 1175,
  [1726] = 1192,
  [1727] = 1636,
  [1728] = 1199,
  [1729] = 1636,
  [1730] = 1202,
  [1731] = 1636,
  [1732] = 1166,
  [1733] = 1636,
  [1734] = 1179,
  [1735] = 1636,
  [1736] = 1636,
  [1737] = 1636,
  [1738] = 1181,
  [1739] = 1182,
  [1740] = 1740,
  [1741] = 1161,
  [1742] = 1162,
  [1743] = 1169,
  [1744] = 1744,
  [1745] = 1179,
  [1746] = 1746,
  [1747] = 1746,
  [1748] = 1748,
  [1749] = 1749,
  [1750] = 1746,
  [1751] = 1751,
  [1752] = 1752,
  [1753] = 1222,
  [1754] = 1746,
  [1755] = 1746,
  [1756] = 1202,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1757,
  [1760] = 1758,
  [1761] = 1757,
  [1762] = 1758,
  [1763] = 1757,
  [1764] = 1758,
  [1765] = 1757,
  [1766] = 1766,
  [1767] = 1758,
  [1768] = 1757,
  [1769] = 1758,
  [1770] = 1757,
  [1771] = 1758,
  [1772] = 1757,
  [1773] = 1758,
  [1774] = 1757,
  [1775] = 1775,
  [1776] = 1758,
  [1777] = 1757,
  [1778] = 1758,
  [1779] = 1757,
  [1780] = 1758,
  [1781] = 1757,
  [1782] = 1758,
  [1783] = 1757,
  [1784] = 1784,
  [1785] = 1758,
  [1786] = 1757,
  [1787] = 1758,
  [1788] = 1757,
  [1789] = 1758,
  [1790] = 1757,
  [1791] = 1758,
  [1792] = 1758,
  [1793] = 1775,
  [1794] = 1161,
  [1795] = 1162,
  [1796] = 1170,
  [1797] = 1171,
  [1798] = 1798,
  [1799] = 1175,
  [1800] = 1160,
  [1801] = 1179,
  [1802] = 1181,
  [1803] = 1182,
  [1804] = 1183,
  [1805] = 1184,
  [1806] = 1185,
  [1807] = 1186,
  [1808] = 1187,
  [1809] = 1188,
  [1810] = 1189,
  [1811] = 1172,
  [1812] = 1180,
  [1813] = 1237,
  [1814] = 1191,
  [1815] = 1192,
  [1816] = 1199,
  [1817] = 1166,
  [1818] = 1169,
  [1819] = 1766,
  [1820] = 1173,
  [1821] = 1163,
  [1822] = 1164,
  [1823] = 1165,
  [1824] = 1167,
  [1825] = 1798,
  [1826] = 1826,
  [1827] = 1827,
  [1828] = 1826,
  [1829] = 1827,
  [1830] = 1826,
  [1831] = 1827,
  [1832] = 1832,
  [1833] = 1826,
  [1834] = 1827,
  [1835] = 1832,
  [1836] = 1832,
  [1837] = 1826,
  [1838] = 1827,
  [1839] = 1832,
  [1840] = 1826,
  [1841] = 1826,
  [1842] = 1827,
  [1843] = 1832,
  [1844] = 1827,
  [1845] = 1827,
  [1846] = 1832,
  [1847] = 1847,
  [1848] = 1847,
  [1849] = 1847,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1832,
  [1854] = 1847,
  [1855] = 1855,
  [1856] = 1856,
  [1857] = 1826,
  [1858] = 1827,
  [1859] = 1832,
  [1860] = 1826,
  [1861] = 1827,
  [1862] = 1826,
  [1863] = 1827,
  [1864] = 1832,
  [1865] = 1832,
  [1866] = 1827,
  [1867] = 1826,
  [1868] = 1827,
  [1869] = 1832,
  [1870] = 1832,
  [1871] = 1826,
  [1872] = 1827,
  [1873] = 1832,
  [1874] = 1826,
  [1875] = 1826,
  [1876] = 1876,
  [1877] = 1827,
  [1878] = 1832,
  [1879] = 1827,
  [1880] = 1832,
  [1881] = 1826,
  [1882] = 1827,
  [1883] = 1826,
  [1884] = 1832,
  [1885] = 1832,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1888,
  [1889] = 1284,
  [1890] = 1288,
  [1891] = 1285,
  [1892] = 1284,
  [1893] = 1798,
  [1894] = 1168,
  [1895] = 1288,
  [1896] = 1766,
  [1897] = 1897,
  [1898] = 1285,
  [1899] = 1899,
  [1900] = 1196,
  [1901] = 1901,
  [1902] = 1902,
  [1903] = 1903,
  [1904] = 1775,
  [1905] = 1905,
  [1906] = 1906,
  [1907] = 1907,
  [1908] = 1908,
  [1909] = 1909,
  [1910] = 1910,
  [1911] = 1911,
  [1912] = 1907,
  [1913] = 1913,
  [1914] = 1914,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1906,
  [1918] = 1916,
  [1919] = 1906,
  [1920] = 1909,
  [1921] = 1905,
  [1922] = 1910,
  [1923] = 1911,
  [1924] = 1907,
  [1925] = 1913,
  [1926] = 1914,
  [1927] = 1915,
  [1928] = 1916,
  [1929] = 1905,
  [1930] = 1906,
  [1931] = 1931,
  [1932] = 1909,
  [1933] = 1909,
  [1934] = 1910,
  [1935] = 1911,
  [1936] = 1907,
  [1937] = 1913,
  [1938] = 1914,
  [1939] = 1915,
  [1940] = 1916,
  [1941] = 1905,
  [1942] = 1906,
  [1943] = 1911,
  [1944] = 1910,
  [1945] = 1910,
  [1946] = 1909,
  [1947] = 1911,
  [1948] = 1907,
  [1949] = 1910,
  [1950] = 1911,
  [1951] = 1907,
  [1952] = 1913,
  [1953] = 1914,
  [1954] = 1915,
  [1955] = 1916,
  [1956] = 1905,
  [1957] = 1906,
  [1958] = 1913,
  [1959] = 1914,
  [1960] = 1915,
  [1961] = 1909,
  [1962] = 1916,
  [1963] = 1910,
  [1964] = 1910,
  [1965] = 1911,
  [1966] = 1907,
  [1967] = 1913,
  [1968] = 1914,
  [1969] = 1915,
  [1970] = 1916,
  [1971] = 1905,
  [1972] = 1906,
  [1973] = 1905,
  [1974] = 1905,
  [1975] = 1909,
  [1976] = 1906,
  [1977] = 1911,
  [1978] = 1910,
  [1979] = 1911,
  [1980] = 1907,
  [1981] = 1913,
  [1982] = 1914,
  [1983] = 1915,
  [1984] = 1916,
  [1985] = 1906,
  [1986] = 1905,
  [1987] = 1906,
  [1988] = 1907,
  [1989] = 1909,
  [1990] = 1909,
  [1991] = 1913,
  [1992] = 1914,
  [1993] = 1910,
  [1994] = 1911,
  [1995] = 1907,
  [1996] = 1913,
  [1997] = 1914,
  [1998] = 1915,
  [1999] = 1916,
  [2000] = 1905,
  [2001] = 1906,
  [2002] = 1910,
  [2003] = 1911,
  [2004] = 1907,
  [2005] = 1909,
  [2006] = 1913,
  [2007] = 1914,
  [2008] = 1910,
  [2009] = 1911,
  [2010] = 1907,
  [2011] = 1913,
  [2012] = 1914,
  [2013] = 1915,
  [2014] = 1916,
  [2015] = 1913,
  [2016] = 1905,
  [2017] = 1906,
  [2018] = 1915,
  [2019] = 1909,
  [2020] = 1916,
  [2021] = 1905,
  [2022] = 1910,
  [2023] = 1911,
  [2024] = 1913,
  [2025] = 1916,
  [2026] = 1905,
  [2027] = 1906,
  [2028] = 1914,
  [2029] = 1915,
  [2030] = 1915,
  [2031] = 2031,
  [2032] = 1909,
  [2033] = 1906,
  [2034] = 1909,
  [2035] = 2035,
  [2036] = 1909,
  [2037] = 1909,
  [2038] = 1910,
  [2039] = 2039,
  [2040] = 1911,
  [2041] = 1907,
  [2042] = 1913,
  [2043] = 2043,
  [2044] = 2044,
  [2045] = 1914,
  [2046] = 1915,
  [2047] = 1916,
  [2048] = 1905,
  [2049] = 1906,
  [2050] = 1910,
  [2051] = 1911,
  [2052] = 1909,
  [2053] = 1907,
  [2054] = 1913,
  [2055] = 1910,
  [2056] = 1911,
  [2057] = 1907,
  [2058] = 1913,
  [2059] = 1914,
  [2060] = 1915,
  [2061] = 1916,
  [2062] = 1905,
  [2063] = 1906,
  [2064] = 1914,
  [2065] = 2065,
  [2066] = 1915,
  [2067] = 1909,
  [2068] = 1916,
  [2069] = 1906,
  [2070] = 1910,
  [2071] = 1911,
  [2072] = 1907,
  [2073] = 1913,
  [2074] = 1931,
  [2075] = 2035,
  [2076] = 1914,
  [2077] = 1931,
  [2078] = 2035,
  [2079] = 1915,
  [2080] = 1916,
  [2081] = 1931,
  [2082] = 2035,
  [2083] = 1931,
  [2084] = 2035,
  [2085] = 1931,
  [2086] = 2035,
  [2087] = 1931,
  [2088] = 2035,
  [2089] = 1931,
  [2090] = 2035,
  [2091] = 1931,
  [2092] = 2035,
  [2093] = 1931,
  [2094] = 2035,
  [2095] = 1931,
  [2096] = 2035,
  [2097] = 1931,
  [2098] = 2035,
  [2099] = 1931,
  [2100] = 2035,
  [2101] = 1931,
  [2102] = 2035,
  [2103] = 1931,
  [2104] = 2035,
  [2105] = 1931,
  [2106] = 2035,
  [2107] = 2035,
  [2108] = 1916,
  [2109] = 2109,
  [2110] = 1905,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2113,
  [2114] = 1905,
  [2115] = 2115,
  [2116] = 2115,
  [2117] = 2115,
  [2118] = 2118,
  [2119] = 2118,
  [2120] = 1601,
  [2121] = 1602,
  [2122] = 1600,
  [2123] = 1599,
  [2124] = 1599,
  [2125] = 1602,
  [2126] = 1600,
  [2127] = 1601,
  [2128] = 1600,
  [2129] = 1599,
  [2130] = 2130,
  [2131] = 1602,
  [2132] = 1601,
  [2133] = 1599,
  [2134] = 1599,
  [2135] = 2135,
  [2136] = 2136,
  [2137] = 2137,
  [2138] = 2138,
  [2139] = 2139,
  [2140] = 2140,
  [2141] = 2141,
  [2142] = 2142,
  [2143] = 2143,
  [2144] = 2144,
  [2145] = 2145,
  [2146] = 2146,
  [2147] = 2147,
  [2148] = 2148,
  [2149] = 2149,
  [2150] = 2150,
  [2151] = 2151,
  [2152] = 2152,
  [2153] = 2153,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 2156,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 2159,
  [2160] = 2160,
  [2161] = 2161,
  [2162] = 2162,
  [2163] = 2163,
  [2164] = 2164,
  [2165] = 2165,
  [2166] = 2166,
  [2167] = 2167,
  [2168] = 2168,
  [2169] = 2169,
  [2170] = 2170,
  [2171] = 2171,
  [2172] = 2172,
  [2173] = 2173,
  [2174] = 2174,
  [2175] = 2175,
  [2176] = 2176,
  [2177] = 2177,
  [2178] = 2178,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 2188,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2191,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 2201,
  [2202] = 2202,
  [2203] = 2203,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2211,
  [2213] = 2213,
  [2214] = 2213,
  [2215] = 2215,
  [2216] = 2213,
  [2217] = 2215,
  [2218] = 2213,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2220,
  [2223] = 2221,
  [2224] = 2224,
  [2225] = 2219,
  [2226] = 2224,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 2232,
  [2233] = 2232,
  [2234] = 2234,
  [2235] = 2229,
  [2236] = 2231,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2227,
  [2240] = 2228,
  [2241] = 2237,
  [2242] = 2230,
  [2243] = 2238,
  [2244] = 2234,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2219,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2224,
  [2261] = 2221,
  [2262] = 2130,
  [2263] = 2224,
  [2264] = 2264,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2220,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2219,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2273,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2258,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2255,
  [2293] = 2256,
  [2294] = 2257,
  [2295] = 2245,
  [2296] = 2221,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2291,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2246,
  [2305] = 2248,
  [2306] = 2306,
  [2307] = 2251,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2287,
  [2311] = 2254,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2266,
  [2316] = 2267,
  [2317] = 2317,
  [2318] = 2272,
  [2319] = 2282,
  [2320] = 2283,
  [2321] = 2290,
  [2322] = 2306,
  [2323] = 2308,
  [2324] = 2309,
  [2325] = 2312,
  [2326] = 2259,
  [2327] = 2247,
  [2328] = 2328,
  [2329] = 2313,
  [2330] = 2314,
  [2331] = 2317,
  [2332] = 2328,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2333,
  [2337] = 2334,
  [2338] = 2335,
  [2339] = 2297,
  [2340] = 2249,
  [2341] = 2252,
  [2342] = 2253,
  [2343] = 2264,
  [2344] = 2265,
  [2345] = 2303,
  [2346] = 2285,
  [2347] = 2288,
  [2348] = 2269,
  [2349] = 2270,
  [2350] = 2271,
  [2351] = 2275,
  [2352] = 2276,
  [2353] = 2277,
  [2354] = 2278,
  [2355] = 2279,
  [2356] = 2280,
  [2357] = 2281,
  [2358] = 2284,
  [2359] = 2298,
  [2360] = 2299,
  [2361] = 2300,
  [2362] = 2362,
  [2363] = 2302,
  [2364] = 2220,
  [2365] = 2365,
  [2366] = 2130,
  [2367] = 2365,
  [2368] = 2362,
  [2369] = 2234,
  [2370] = 2229,
  [2371] = 2230,
  [2372] = 2231,
  [2373] = 2238,
  [2374] = 2237,
  [2375] = 2232,
  [2376] = 2234,
  [2377] = 2228,
  [2378] = 2227,
  [2379] = 2237,
  [2380] = 2230,
  [2381] = 2238,
  [2382] = 2229,
  [2383] = 2228,
  [2384] = 2227,
  [2385] = 2232,
  [2386] = 2231,
  [2387] = 2333,
  [2388] = 2309,
  [2389] = 2246,
  [2390] = 2267,
  [2391] = 2259,
  [2392] = 2273,
  [2393] = 2247,
  [2394] = 2313,
  [2395] = 2314,
  [2396] = 2317,
  [2397] = 2283,
  [2398] = 2328,
  [2399] = 2287,
  [2400] = 2312,
  [2401] = 2334,
  [2402] = 2335,
  [2403] = 2288,
  [2404] = 2258,
  [2405] = 2291,
  [2406] = 2291,
  [2407] = 2297,
  [2408] = 2284,
  [2409] = 2290,
  [2410] = 2264,
  [2411] = 2255,
  [2412] = 2256,
  [2413] = 2257,
  [2414] = 2249,
  [2415] = 2245,
  [2416] = 2313,
  [2417] = 2252,
  [2418] = 2314,
  [2419] = 2253,
  [2420] = 2269,
  [2421] = 2270,
  [2422] = 2271,
  [2423] = 2264,
  [2424] = 2265,
  [2425] = 2297,
  [2426] = 2247,
  [2427] = 2317,
  [2428] = 2303,
  [2429] = 2269,
  [2430] = 2270,
  [2431] = 2271,
  [2432] = 2272,
  [2433] = 2275,
  [2434] = 2276,
  [2435] = 2277,
  [2436] = 2278,
  [2437] = 2279,
  [2438] = 2280,
  [2439] = 2281,
  [2440] = 2246,
  [2441] = 2248,
  [2442] = 2248,
  [2443] = 2284,
  [2444] = 2298,
  [2445] = 2299,
  [2446] = 2300,
  [2447] = 2362,
  [2448] = 2302,
  [2449] = 2251,
  [2450] = 2328,
  [2451] = 2254,
  [2452] = 2275,
  [2453] = 2365,
  [2454] = 2130,
  [2455] = 2303,
  [2456] = 2276,
  [2457] = 2254,
  [2458] = 2273,
  [2459] = 2287,
  [2460] = 2288,
  [2461] = 2265,
  [2462] = 2277,
  [2463] = 2258,
  [2464] = 2278,
  [2465] = 2279,
  [2466] = 2266,
  [2467] = 2267,
  [2468] = 2298,
  [2469] = 2299,
  [2470] = 2285,
  [2471] = 2300,
  [2472] = 2362,
  [2473] = 2302,
  [2474] = 2255,
  [2475] = 2272,
  [2476] = 2333,
  [2477] = 2251,
  [2478] = 2252,
  [2479] = 2249,
  [2480] = 2256,
  [2481] = 2257,
  [2482] = 2282,
  [2483] = 2245,
  [2484] = 2283,
  [2485] = 2290,
  [2486] = 2280,
  [2487] = 2306,
  [2488] = 2308,
  [2489] = 2309,
  [2490] = 2312,
  [2491] = 2259,
  [2492] = 2281,
  [2493] = 2253,
  [2494] = 2282,
  [2495] = 2266,
  [2496] = 2365,
  [2497] = 2334,
  [2498] = 2335,
  [2499] = 2130,
  [2500] = 2306,
  [2501] = 2308,
  [2502] = 2285,
  [2503] = 2213,
  [2504] = 2213,
  [2505] = 2505,
  [2506] = 2213,
  [2507] = 2213,
  [2508] = 2224,
  [2509] = 2219,
  [2510] = 2221,
  [2511] = 2221,
  [2512] = 2220,
  [2513] = 2219,
  [2514] = 2224,
  [2515] = 2220,
  [2516] = 2221,
  [2517] = 2232,
  [2518] = 2238,
  [2519] = 2229,
  [2520] = 2230,
  [2521] = 2227,
  [2522] = 2234,
  [2523] = 2219,
  [2524] = 2228,
  [2525] = 2227,
  [2526] = 2224,
  [2527] = 2231,
  [2528] = 2220,
  [2529] = 2231,
  [2530] = 2230,
  [2531] = 2228,
  [2532] = 2238,
  [2533] = 2237,
  [2534] = 2232,
  [2535] = 2234,
  [2536] = 2229,
  [2537] = 2237,
  [2538] = 2334,
  [2539] = 2228,
  [2540] = 2232,
  [2541] = 2234,
  [2542] = 2303,
  [2543] = 2238,
  [2544] = 2224,
  [2545] = 2264,
  [2546] = 2246,
  [2547] = 2248,
  [2548] = 2265,
  [2549] = 2249,
  [2550] = 2251,
  [2551] = 2252,
  [2552] = 2229,
  [2553] = 2220,
  [2554] = 2249,
  [2555] = 2269,
  [2556] = 2270,
  [2557] = 2271,
  [2558] = 2287,
  [2559] = 2253,
  [2560] = 2219,
  [2561] = 2258,
  [2562] = 2254,
  [2563] = 2275,
  [2564] = 2221,
  [2565] = 2276,
  [2566] = 2277,
  [2567] = 2278,
  [2568] = 2279,
  [2569] = 2280,
  [2570] = 2281,
  [2571] = 2264,
  [2572] = 2265,
  [2573] = 2266,
  [2574] = 2267,
  [2575] = 2284,
  [2576] = 2269,
  [2577] = 2270,
  [2578] = 2271,
  [2579] = 2272,
  [2580] = 2130,
  [2581] = 2255,
  [2582] = 2285,
  [2583] = 2273,
  [2584] = 2287,
  [2585] = 2288,
  [2586] = 2258,
  [2587] = 2298,
  [2588] = 2291,
  [2589] = 2299,
  [2590] = 2255,
  [2591] = 2256,
  [2592] = 2257,
  [2593] = 2245,
  [2594] = 2300,
  [2595] = 2362,
  [2596] = 2275,
  [2597] = 2276,
  [2598] = 2277,
  [2599] = 2278,
  [2600] = 2279,
  [2601] = 2280,
  [2602] = 2281,
  [2603] = 2282,
  [2604] = 2297,
  [2605] = 2283,
  [2606] = 2284,
  [2607] = 2290,
  [2608] = 2302,
  [2609] = 2303,
  [2610] = 2298,
  [2611] = 2299,
  [2612] = 2231,
  [2613] = 2246,
  [2614] = 2248,
  [2615] = 2300,
  [2616] = 2362,
  [2617] = 2251,
  [2618] = 2302,
  [2619] = 2252,
  [2620] = 2365,
  [2621] = 2254,
  [2622] = 2230,
  [2623] = 2306,
  [2624] = 2308,
  [2625] = 2309,
  [2626] = 2130,
  [2627] = 2256,
  [2628] = 2266,
  [2629] = 2267,
  [2630] = 2312,
  [2631] = 2365,
  [2632] = 2257,
  [2633] = 2245,
  [2634] = 2259,
  [2635] = 2272,
  [2636] = 2291,
  [2637] = 2282,
  [2638] = 2283,
  [2639] = 2290,
  [2640] = 2253,
  [2641] = 2313,
  [2642] = 2247,
  [2643] = 2314,
  [2644] = 2306,
  [2645] = 2308,
  [2646] = 2309,
  [2647] = 2312,
  [2648] = 2317,
  [2649] = 2259,
  [2650] = 2328,
  [2651] = 2227,
  [2652] = 2247,
  [2653] = 2313,
  [2654] = 2314,
  [2655] = 2317,
  [2656] = 2328,
  [2657] = 2333,
  [2658] = 2335,
  [2659] = 2333,
  [2660] = 2334,
  [2661] = 2335,
  [2662] = 2285,
  [2663] = 2273,
  [2664] = 2297,
  [2665] = 2237,
  [2666] = 2288,
  [2667] = 2234,
  [2668] = 2256,
  [2669] = 2306,
  [2670] = 2280,
  [2671] = 2308,
  [2672] = 2309,
  [2673] = 2312,
  [2674] = 2281,
  [2675] = 2275,
  [2676] = 2365,
  [2677] = 2228,
  [2678] = 2246,
  [2679] = 2266,
  [2680] = 2227,
  [2681] = 2248,
  [2682] = 2276,
  [2683] = 2277,
  [2684] = 2264,
  [2685] = 2267,
  [2686] = 2231,
  [2687] = 2259,
  [2688] = 2247,
  [2689] = 2251,
  [2690] = 2257,
  [2691] = 2230,
  [2692] = 2313,
  [2693] = 2314,
  [2694] = 2317,
  [2695] = 2328,
  [2696] = 2238,
  [2697] = 2333,
  [2698] = 2334,
  [2699] = 2335,
  [2700] = 2272,
  [2701] = 2232,
  [2702] = 2303,
  [2703] = 2279,
  [2704] = 2245,
  [2705] = 2284,
  [2706] = 2298,
  [2707] = 2265,
  [2708] = 2249,
  [2709] = 2282,
  [2710] = 2252,
  [2711] = 2283,
  [2712] = 2299,
  [2713] = 2300,
  [2714] = 2253,
  [2715] = 2290,
  [2716] = 2362,
  [2717] = 2237,
  [2718] = 2285,
  [2719] = 2273,
  [2720] = 2287,
  [2721] = 2288,
  [2722] = 2297,
  [2723] = 2302,
  [2724] = 2291,
  [2725] = 2254,
  [2726] = 2258,
  [2727] = 2269,
  [2728] = 2278,
  [2729] = 2255,
  [2730] = 2270,
  [2731] = 2271,
  [2732] = 2130,
  [2733] = 2229,
  [2734] = 2270,
  [2735] = 2253,
  [2736] = 2248,
  [2737] = 2303,
  [2738] = 2251,
  [2739] = 2264,
  [2740] = 2287,
  [2741] = 2288,
  [2742] = 2265,
  [2743] = 2266,
  [2744] = 2269,
  [2745] = 2271,
  [2746] = 2267,
  [2747] = 2258,
  [2748] = 2275,
  [2749] = 2276,
  [2750] = 2277,
  [2751] = 2255,
  [2752] = 2278,
  [2753] = 2279,
  [2754] = 2272,
  [2755] = 2280,
  [2756] = 2256,
  [2757] = 2282,
  [2758] = 2281,
  [2759] = 2283,
  [2760] = 2290,
  [2761] = 2259,
  [2762] = 2257,
  [2763] = 2284,
  [2764] = 2298,
  [2765] = 2299,
  [2766] = 2254,
  [2767] = 2300,
  [2768] = 2362,
  [2769] = 2302,
  [2770] = 2247,
  [2771] = 2313,
  [2772] = 2306,
  [2773] = 2308,
  [2774] = 2309,
  [2775] = 2312,
  [2776] = 2314,
  [2777] = 2285,
  [2778] = 2130,
  [2779] = 2365,
  [2780] = 2317,
  [2781] = 2328,
  [2782] = 2245,
  [2783] = 2291,
  [2784] = 2297,
  [2785] = 2333,
  [2786] = 2334,
  [2787] = 2335,
  [2788] = 2249,
  [2789] = 2246,
  [2790] = 2252,
  [2791] = 2273,
  [2792] = 2792,
  [2793] = 2793,
  [2794] = 2793,
  [2795] = 2793,
  [2796] = 2793,
  [2797] = 2793,
  [2798] = 2793,
  [2799] = 2793,
  [2800] = 2793,
  [2801] = 2793,
  [2802] = 2793,
  [2803] = 2793,
  [2804] = 2793,
  [2805] = 2793,
  [2806] = 2793,
  [2807] = 2793,
  [2808] = 2793,
  [2809] = 2793,
  [2810] = 2213,
  [2811] = 2213,
  [2812] = 2812,
  [2813] = 2213,
  [2814] = 2220,
  [2815] = 2221,
  [2816] = 2219,
  [2817] = 2224,
  [2818] = 2818,
  [2819] = 2213,
  [2820] = 2237,
  [2821] = 2229,
  [2822] = 2231,
  [2823] = 2227,
  [2824] = 2238,
  [2825] = 2234,
  [2826] = 2230,
  [2827] = 2232,
  [2828] = 2228,
  [2829] = 2251,
  [2830] = 2249,
  [2831] = 2254,
  [2832] = 2252,
  [2833] = 2253,
  [2834] = 2282,
  [2835] = 2264,
  [2836] = 2265,
  [2837] = 2269,
  [2838] = 2270,
  [2839] = 2271,
  [2840] = 2303,
  [2841] = 2275,
  [2842] = 2276,
  [2843] = 2277,
  [2844] = 2278,
  [2845] = 2279,
  [2846] = 2283,
  [2847] = 2280,
  [2848] = 2281,
  [2849] = 2284,
  [2850] = 2272,
  [2851] = 2298,
  [2852] = 2299,
  [2853] = 2300,
  [2854] = 2362,
  [2855] = 2302,
  [2856] = 2365,
  [2857] = 2130,
  [2858] = 2259,
  [2859] = 2290,
  [2860] = 2247,
  [2861] = 2224,
  [2862] = 2313,
  [2863] = 2220,
  [2864] = 2248,
  [2865] = 2317,
  [2866] = 2213,
  [2867] = 2328,
  [2868] = 2333,
  [2869] = 2219,
  [2870] = 2334,
  [2871] = 2221,
  [2872] = 2335,
  [2873] = 2266,
  [2874] = 2267,
  [2875] = 2246,
  [2876] = 2285,
  [2877] = 2273,
  [2878] = 2287,
  [2879] = 2288,
  [2880] = 2258,
  [2881] = 2306,
  [2882] = 2291,
  [2883] = 2213,
  [2884] = 2255,
  [2885] = 2256,
  [2886] = 2257,
  [2887] = 2245,
  [2888] = 2308,
  [2889] = 2309,
  [2890] = 2312,
  [2891] = 2213,
  [2892] = 2297,
  [2893] = 2314,
  [2894] = 2228,
  [2895] = 2224,
  [2896] = 2232,
  [2897] = 2221,
  [2898] = 2234,
  [2899] = 2229,
  [2900] = 2227,
  [2901] = 2901,
  [2902] = 2237,
  [2903] = 2219,
  [2904] = 2220,
  [2905] = 2231,
  [2906] = 2230,
  [2907] = 2238,
  [2908] = 2312,
  [2909] = 2271,
  [2910] = 2272,
  [2911] = 2258,
  [2912] = 2282,
  [2913] = 2283,
  [2914] = 2284,
  [2915] = 2290,
  [2916] = 2306,
  [2917] = 2308,
  [2918] = 2309,
  [2919] = 2230,
  [2920] = 2365,
  [2921] = 2213,
  [2922] = 2259,
  [2923] = 2220,
  [2924] = 2234,
  [2925] = 2247,
  [2926] = 2313,
  [2927] = 2314,
  [2928] = 2291,
  [2929] = 2335,
  [2930] = 2249,
  [2931] = 2252,
  [2932] = 2253,
  [2933] = 2306,
  [2934] = 2308,
  [2935] = 2309,
  [2936] = 2312,
  [2937] = 2228,
  [2938] = 2229,
  [2939] = 2264,
  [2940] = 2265,
  [2941] = 2255,
  [2942] = 2256,
  [2943] = 2269,
  [2944] = 2270,
  [2945] = 2257,
  [2946] = 2245,
  [2947] = 2275,
  [2948] = 2288,
  [2949] = 2277,
  [2950] = 2278,
  [2951] = 2279,
  [2952] = 2280,
  [2953] = 2281,
  [2954] = 2221,
  [2955] = 2298,
  [2956] = 2299,
  [2957] = 2300,
  [2958] = 2362,
  [2959] = 2302,
  [2960] = 2237,
  [2961] = 2238,
  [2962] = 2317,
  [2963] = 2328,
  [2964] = 2333,
  [2965] = 2334,
  [2966] = 2297,
  [2967] = 2303,
  [2968] = 2227,
  [2969] = 2246,
  [2970] = 2248,
  [2971] = 2251,
  [2972] = 2972,
  [2973] = 2254,
  [2974] = 2231,
  [2975] = 2219,
  [2976] = 2232,
  [2977] = 2130,
  [2978] = 2285,
  [2979] = 2273,
  [2980] = 2224,
  [2981] = 2287,
  [2982] = 2266,
  [2983] = 2267,
  [2984] = 2276,
  [2985] = 2314,
  [2986] = 2280,
  [2987] = 2281,
  [2988] = 2284,
  [2989] = 2266,
  [2990] = 2267,
  [2991] = 2298,
  [2992] = 2299,
  [2993] = 2224,
  [2994] = 2994,
  [2995] = 2300,
  [2996] = 2362,
  [2997] = 2302,
  [2998] = 2252,
  [2999] = 2246,
  [3000] = 2248,
  [3001] = 2231,
  [3002] = 2130,
  [3003] = 2994,
  [3004] = 2251,
  [3005] = 2238,
  [3006] = 2272,
  [3007] = 2994,
  [3008] = 2285,
  [3009] = 2273,
  [3010] = 2994,
  [3011] = 2220,
  [3012] = 2232,
  [3013] = 2219,
  [3014] = 2287,
  [3015] = 2288,
  [3016] = 2994,
  [3017] = 2258,
  [3018] = 2221,
  [3019] = 2253,
  [3020] = 2220,
  [3021] = 2994,
  [3022] = 2219,
  [3023] = 2221,
  [3024] = 2291,
  [3025] = 2224,
  [3026] = 2282,
  [3027] = 2994,
  [3028] = 2283,
  [3029] = 2234,
  [3030] = 2290,
  [3031] = 2303,
  [3032] = 2994,
  [3033] = 2994,
  [3034] = 2229,
  [3035] = 2994,
  [3036] = 2994,
  [3037] = 2264,
  [3038] = 2365,
  [3039] = 3039,
  [3040] = 2265,
  [3041] = 2297,
  [3042] = 2994,
  [3043] = 2994,
  [3044] = 2254,
  [3045] = 2994,
  [3046] = 2269,
  [3047] = 2230,
  [3048] = 2270,
  [3049] = 2271,
  [3050] = 2219,
  [3051] = 2255,
  [3052] = 2220,
  [3053] = 2256,
  [3054] = 2257,
  [3055] = 2245,
  [3056] = 2306,
  [3057] = 2237,
  [3058] = 2308,
  [3059] = 2309,
  [3060] = 2312,
  [3061] = 2259,
  [3062] = 2228,
  [3063] = 2249,
  [3064] = 2994,
  [3065] = 2247,
  [3066] = 2227,
  [3067] = 2275,
  [3068] = 2276,
  [3069] = 2221,
  [3070] = 2277,
  [3071] = 2224,
  [3072] = 2313,
  [3073] = 2278,
  [3074] = 2335,
  [3075] = 2317,
  [3076] = 2328,
  [3077] = 2279,
  [3078] = 2333,
  [3079] = 2334,
  [3080] = 2994,
  [3081] = 2232,
  [3082] = 2252,
  [3083] = 2280,
  [3084] = 2231,
  [3085] = 2237,
  [3086] = 2281,
  [3087] = 2229,
  [3088] = 2267,
  [3089] = 2303,
  [3090] = 2230,
  [3091] = 2227,
  [3092] = 2282,
  [3093] = 2283,
  [3094] = 2284,
  [3095] = 2290,
  [3096] = 2264,
  [3097] = 2234,
  [3098] = 2270,
  [3099] = 3099,
  [3100] = 2228,
  [3101] = 2229,
  [3102] = 2271,
  [3103] = 2298,
  [3104] = 2299,
  [3105] = 2228,
  [3106] = 2265,
  [3107] = 2285,
  [3108] = 2273,
  [3109] = 2287,
  [3110] = 2300,
  [3111] = 2362,
  [3112] = 2229,
  [3113] = 2333,
  [3114] = 2232,
  [3115] = 2253,
  [3116] = 2288,
  [3117] = 2272,
  [3118] = 2227,
  [3119] = 2258,
  [3120] = 2302,
  [3121] = 2231,
  [3122] = 2238,
  [3123] = 2335,
  [3124] = 2238,
  [3125] = 2266,
  [3126] = 2237,
  [3127] = 2234,
  [3128] = 2231,
  [3129] = 2254,
  [3130] = 2246,
  [3131] = 2230,
  [3132] = 2291,
  [3133] = 2238,
  [3134] = 2306,
  [3135] = 2308,
  [3136] = 2309,
  [3137] = 2247,
  [3138] = 2234,
  [3139] = 2248,
  [3140] = 2232,
  [3141] = 2269,
  [3142] = 2255,
  [3143] = 2256,
  [3144] = 2257,
  [3145] = 2245,
  [3146] = 2259,
  [3147] = 2249,
  [3148] = 2275,
  [3149] = 2312,
  [3150] = 2365,
  [3151] = 2228,
  [3152] = 2227,
  [3153] = 2251,
  [3154] = 2313,
  [3155] = 2276,
  [3156] = 2334,
  [3157] = 2328,
  [3158] = 2237,
  [3159] = 2314,
  [3160] = 2317,
  [3161] = 2277,
  [3162] = 2230,
  [3163] = 2278,
  [3164] = 2279,
  [3165] = 2297,
  [3166] = 2130,
  [3167] = 2303,
  [3168] = 2267,
  [3169] = 2273,
  [3170] = 2248,
  [3171] = 2333,
  [3172] = 2287,
  [3173] = 2306,
  [3174] = 2334,
  [3175] = 2335,
  [3176] = 2264,
  [3177] = 2285,
  [3178] = 2290,
  [3179] = 2259,
  [3180] = 2269,
  [3181] = 2270,
  [3182] = 2271,
  [3183] = 2283,
  [3184] = 2288,
  [3185] = 2258,
  [3186] = 2259,
  [3187] = 2275,
  [3188] = 2276,
  [3189] = 2265,
  [3190] = 2272,
  [3191] = 2269,
  [3192] = 2270,
  [3193] = 2271,
  [3194] = 2291,
  [3195] = 2275,
  [3196] = 2291,
  [3197] = 2276,
  [3198] = 2273,
  [3199] = 2255,
  [3200] = 2256,
  [3201] = 2277,
  [3202] = 2257,
  [3203] = 2277,
  [3204] = 2245,
  [3205] = 2259,
  [3206] = 2278,
  [3207] = 2279,
  [3208] = 2317,
  [3209] = 2280,
  [3210] = 2272,
  [3211] = 2278,
  [3212] = 2247,
  [3213] = 2281,
  [3214] = 2279,
  [3215] = 2308,
  [3216] = 2282,
  [3217] = 2275,
  [3218] = 2280,
  [3219] = 2254,
  [3220] = 2281,
  [3221] = 2276,
  [3222] = 2277,
  [3223] = 2278,
  [3224] = 2279,
  [3225] = 2284,
  [3226] = 2280,
  [3227] = 2281,
  [3228] = 2249,
  [3229] = 2313,
  [3230] = 2314,
  [3231] = 2283,
  [3232] = 2328,
  [3233] = 2297,
  [3234] = 2266,
  [3235] = 2290,
  [3236] = 2298,
  [3237] = 2264,
  [3238] = 2224,
  [3239] = 2290,
  [3240] = 2284,
  [3241] = 2299,
  [3242] = 2253,
  [3243] = 2300,
  [3244] = 2303,
  [3245] = 2362,
  [3246] = 2317,
  [3247] = 2302,
  [3248] = 2328,
  [3249] = 2252,
  [3250] = 2309,
  [3251] = 2335,
  [3252] = 2255,
  [3253] = 2328,
  [3254] = 2333,
  [3255] = 2298,
  [3256] = 2299,
  [3257] = 2334,
  [3258] = 2246,
  [3259] = 2248,
  [3260] = 2284,
  [3261] = 2335,
  [3262] = 2312,
  [3263] = 2130,
  [3264] = 2247,
  [3265] = 2300,
  [3266] = 2298,
  [3267] = 2299,
  [3268] = 2219,
  [3269] = 2251,
  [3270] = 2362,
  [3271] = 2297,
  [3272] = 2251,
  [3273] = 2300,
  [3274] = 2362,
  [3275] = 2266,
  [3276] = 2333,
  [3277] = 2302,
  [3278] = 2249,
  [3279] = 2256,
  [3280] = 2306,
  [3281] = 2302,
  [3282] = 2282,
  [3283] = 2282,
  [3284] = 2265,
  [3285] = 2306,
  [3286] = 2253,
  [3287] = 2308,
  [3288] = 2313,
  [3289] = 2257,
  [3290] = 2254,
  [3291] = 2246,
  [3292] = 2313,
  [3293] = 2314,
  [3294] = 2308,
  [3295] = 2264,
  [3296] = 2245,
  [3297] = 2265,
  [3298] = 2283,
  [3299] = 2309,
  [3300] = 2309,
  [3301] = 2312,
  [3302] = 2314,
  [3303] = 2312,
  [3304] = 2365,
  [3305] = 2365,
  [3306] = 2130,
  [3307] = 2252,
  [3308] = 2251,
  [3309] = 2365,
  [3310] = 2267,
  [3311] = 2288,
  [3312] = 2254,
  [3313] = 2287,
  [3314] = 2285,
  [3315] = 2249,
  [3316] = 2269,
  [3317] = 2273,
  [3318] = 2267,
  [3319] = 2287,
  [3320] = 2252,
  [3321] = 2270,
  [3322] = 2288,
  [3323] = 2258,
  [3324] = 2271,
  [3325] = 2247,
  [3326] = 2334,
  [3327] = 2291,
  [3328] = 2246,
  [3329] = 2130,
  [3330] = 2255,
  [3331] = 2256,
  [3332] = 2257,
  [3333] = 2245,
  [3334] = 2221,
  [3335] = 2253,
  [3336] = 2258,
  [3337] = 2297,
  [3338] = 2248,
  [3339] = 2272,
  [3340] = 2303,
  [3341] = 2266,
  [3342] = 2285,
  [3343] = 2317,
  [3344] = 2220,
  [3345] = 2229,
  [3346] = 2237,
  [3347] = 2238,
  [3348] = 2228,
  [3349] = 2227,
  [3350] = 2234,
  [3351] = 2232,
  [3352] = 2231,
  [3353] = 2230,
  [3354] = 2308,
  [3355] = 2302,
  [3356] = 2249,
  [3357] = 2266,
  [3358] = 2267,
  [3359] = 2269,
  [3360] = 2272,
  [3361] = 2300,
  [3362] = 2253,
  [3363] = 2285,
  [3364] = 2273,
  [3365] = 2287,
  [3366] = 2277,
  [3367] = 2288,
  [3368] = 2282,
  [3369] = 2283,
  [3370] = 2258,
  [3371] = 2290,
  [3372] = 2298,
  [3373] = 2299,
  [3374] = 2362,
  [3375] = 2291,
  [3376] = 2265,
  [3377] = 2254,
  [3378] = 2255,
  [3379] = 2306,
  [3380] = 2256,
  [3381] = 2257,
  [3382] = 2245,
  [3383] = 2284,
  [3384] = 2309,
  [3385] = 2281,
  [3386] = 2130,
  [3387] = 2365,
  [3388] = 2297,
  [3389] = 2278,
  [3390] = 2303,
  [3391] = 2280,
  [3392] = 2246,
  [3393] = 2259,
  [3394] = 2248,
  [3395] = 2270,
  [3396] = 2247,
  [3397] = 2252,
  [3398] = 2313,
  [3399] = 2314,
  [3400] = 2317,
  [3401] = 2328,
  [3402] = 2264,
  [3403] = 2333,
  [3404] = 2334,
  [3405] = 2335,
  [3406] = 2279,
  [3407] = 2251,
  [3408] = 2271,
  [3409] = 2275,
  [3410] = 2276,
  [3411] = 2312,
  [3412] = 3412,
  [3413] = 3412,
  [3414] = 3414,
  [3415] = 3415,
  [3416] = 3415,
  [3417] = 3417,
  [3418] = 3414,
  [3419] = 3417,
  [3420] = 3420,
  [3421] = 3421,
  [3422] = 3422,
  [3423] = 3421,
  [3424] = 3424,
  [3425] = 2365,
  [3426] = 3426,
  [3427] = 2164,
  [3428] = 2172,
  [3429] = 2140,
  [3430] = 2174,
  [3431] = 2142,
  [3432] = 2184,
  [3433] = 2149,
  [3434] = 2193,
  [3435] = 2173,
  [3436] = 2175,
  [3437] = 2194,
  [3438] = 2207,
  [3439] = 2151,
  [3440] = 2168,
  [3441] = 3441,
  [3442] = 2156,
  [3443] = 2196,
  [3444] = 2155,
  [3445] = 2163,
  [3446] = 2187,
  [3447] = 2176,
  [3448] = 2144,
  [3449] = 2148,
  [3450] = 2170,
  [3451] = 2179,
  [3452] = 2169,
  [3453] = 2171,
  [3454] = 2189,
  [3455] = 2195,
  [3456] = 2159,
  [3457] = 2180,
  [3458] = 2145,
  [3459] = 2167,
  [3460] = 2183,
  [3461] = 2190,
  [3462] = 2198,
  [3463] = 2199,
  [3464] = 2210,
  [3465] = 2191,
  [3466] = 2178,
  [3467] = 2188,
  [3468] = 2197,
  [3469] = 2206,
  [3470] = 2157,
  [3471] = 2152,
  [3472] = 3472,
  [3473] = 2186,
  [3474] = 2143,
  [3475] = 2139,
  [3476] = 2185,
  [3477] = 2204,
  [3478] = 2141,
  [3479] = 2200,
  [3480] = 2153,
  [3481] = 2165,
  [3482] = 2209,
  [3483] = 2146,
  [3484] = 2177,
  [3485] = 2181,
  [3486] = 2182,
  [3487] = 2166,
  [3488] = 2161,
  [3489] = 2192,
  [3490] = 2205,
  [3491] = 2147,
  [3492] = 2160,
  [3493] = 3493,
  [3494] = 3494,
  [3495] = 3495,
  [3496] = 3496,
  [3497] = 3495,
  [3498] = 3498,
  [3499] = 3498,
  [3500] = 3494,
  [3501] = 3501,
  [3502] = 3502,
  [3503] = 3503,
  [3504] = 3504,
  [3505] = 3505,
  [3506] = 3503,
  [3507] = 3505,
  [3508] = 3508,
  [3509] = 3509,
  [3510] = 3510,
  [3511] = 3511,
  [3512] = 3504,
  [3513] = 3513,
  [3514] = 3514,
  [3515] = 3511,
  [3516] = 3516,
  [3517] = 3517,
  [3518] = 3516,
  [3519] = 3519,
  [3520] = 3520,
  [3521] = 3521,
  [3522] = 3522,
  [3523] = 3523,
  [3524] = 3524,
  [3525] = 3525,
  [3526] = 3526,
  [3527] = 3527,
  [3528] = 3528,
  [3529] = 3529,
  [3530] = 3530,
  [3531] = 2365,
  [3532] = 3426,
  [3533] = 3533,
  [3534] = 3534,
  [3535] = 3535,
  [3536] = 3536,
  [3537] = 3535,
  [3538] = 3533,
  [3539] = 3539,
  [3540] = 3540,
  [3541] = 3541,
  [3542] = 3536,
  [3543] = 3541,
  [3544] = 3544,
  [3545] = 3545,
  [3546] = 3546,
  [3547] = 3547,
  [3548] = 3548,
  [3549] = 3549,
  [3550] = 3550,
  [3551] = 3551,
  [3552] = 3549,
  [3553] = 3553,
  [3554] = 3544,
  [3555] = 3550,
  [3556] = 3556,
  [3557] = 3557,
  [3558] = 3558,
  [3559] = 3556,
  [3560] = 3547,
  [3561] = 3546,
  [3562] = 3548,
  [3563] = 3563,
  [3564] = 3557,
  [3565] = 3565,
  [3566] = 3553,
  [3567] = 3551,
  [3568] = 3568,
  [3569] = 3569,
  [3570] = 3570,
  [3571] = 3571,
  [3572] = 3572,
  [3573] = 3573,
  [3574] = 3574,
  [3575] = 3575,
  [3576] = 3576,
  [3577] = 3569,
  [3578] = 3578,
  [3579] = 3579,
  [3580] = 3580,
  [3581] = 3581,
  [3582] = 3582,
  [3583] = 3583,
  [3584] = 3580,
  [3585] = 3585,
  [3586] = 3571,
  [3587] = 3587,
  [3588] = 3588,
  [3589] = 3589,
  [3590] = 3590,
  [3591] = 3591,
  [3592] = 3565,
  [3593] = 3593,
  [3594] = 3594,
  [3595] = 3582,
  [3596] = 3583,
  [3597] = 3597,
  [3598] = 3598,
  [3599] = 3599,
  [3600] = 3600,
  [3601] = 3601,
  [3602] = 3601,
  [3603] = 3601,
  [3604] = 3601,
  [3605] = 3601,
  [3606] = 3606,
  [3607] = 3601,
  [3608] = 3608,
  [3609] = 3601,
  [3610] = 3601,
  [3611] = 3601,
  [3612] = 3601,
  [3613] = 3601,
  [3614] = 3601,
  [3615] = 3601,
  [3616] = 3601,
  [3617] = 3601,
  [3618] = 3601,
  [3619] = 3619,
  [3620] = 3620,
  [3621] = 3621,
  [3622] = 3620,
  [3623] = 3620,
  [3624] = 3620,
  [3625] = 3620,
  [3626] = 3620,
  [3627] = 3620,
  [3628] = 3620,
  [3629] = 3620,
  [3630] = 3620,
  [3631] = 3620,
  [3632] = 3620,
  [3633] = 3620,
  [3634] = 3620,
  [3635] = 3621,
  [3636] = 3620,
  [3637] = 3620,
  [3638] = 3638,
  [3639] = 3639,
  [3640] = 3640,
  [3641] = 3641,
  [3642] = 3642,
  [3643] = 3643,
  [3644] = 3644,
  [3645] = 3645,
  [3646] = 3646,
  [3647] = 3647,
  [3648] = 3648,
  [3649] = 3649,
  [3650] = 3650,
  [3651] = 3651,
  [3652] = 3652,
  [3653] = 3653,
  [3654] = 3654,
  [3655] = 3655,
  [3656] = 3656,
  [3657] = 3657,
  [3658] = 3658,
  [3659] = 3659,
  [3660] = 3660,
  [3661] = 3661,
  [3662] = 3516,
  [3663] = 3511,
  [3664] = 3664,
  [3665] = 3536,
  [3666] = 3511,
  [3667] = 3667,
  [3668] = 3535,
  [3669] = 3516,
  [3670] = 3670,
  [3671] = 2204,
  [3672] = 2171,
  [3673] = 2139,
  [3674] = 2173,
  [3675] = 2174,
  [3676] = 2175,
  [3677] = 2176,
  [3678] = 2178,
  [3679] = 2179,
  [3680] = 2180,
  [3681] = 2182,
  [3682] = 2183,
  [3683] = 2186,
  [3684] = 2187,
  [3685] = 2188,
  [3686] = 2190,
  [3687] = 2191,
  [3688] = 2192,
  [3689] = 2193,
  [3690] = 2194,
  [3691] = 2195,
  [3692] = 2196,
  [3693] = 2197,
  [3694] = 2198,
  [3695] = 2199,
  [3696] = 3472,
  [3697] = 2205,
  [3698] = 2207,
  [3699] = 2209,
  [3700] = 2177,
  [3701] = 2200,
  [3702] = 2142,
  [3703] = 2143,
  [3704] = 2145,
  [3705] = 2147,
  [3706] = 2149,
  [3707] = 2153,
  [3708] = 2206,
  [3709] = 2140,
  [3710] = 2164,
  [3711] = 2170,
  [3712] = 2155,
  [3713] = 2148,
  [3714] = 2365,
  [3715] = 2146,
  [3716] = 3511,
  [3717] = 2156,
  [3718] = 3553,
  [3719] = 3441,
  [3720] = 2157,
  [3721] = 2168,
  [3722] = 2144,
  [3723] = 2161,
  [3724] = 2163,
  [3725] = 3544,
  [3726] = 2165,
  [3727] = 2166,
  [3728] = 3546,
  [3729] = 2210,
  [3730] = 3516,
  [3731] = 2181,
  [3732] = 2184,
  [3733] = 2141,
  [3734] = 2160,
  [3735] = 2152,
  [3736] = 3426,
  [3737] = 2185,
  [3738] = 3536,
  [3739] = 2189,
  [3740] = 2172,
  [3741] = 2159,
  [3742] = 3535,
  [3743] = 2167,
  [3744] = 2169,
  [3745] = 2151,
  [3746] = 2171,
  [3747] = 2168,
  [3748] = 2152,
  [3749] = 3551,
  [3750] = 2185,
  [3751] = 2189,
  [3752] = 2172,
  [3753] = 2159,
  [3754] = 2365,
  [3755] = 3755,
  [3756] = 2146,
  [3757] = 2167,
  [3758] = 3541,
  [3759] = 3553,
  [3760] = 2169,
  [3761] = 2170,
  [3762] = 2139,
  [3763] = 2173,
  [3764] = 2174,
  [3765] = 3544,
  [3766] = 2175,
  [3767] = 2176,
  [3768] = 2178,
  [3769] = 2179,
  [3770] = 2180,
  [3771] = 2182,
  [3772] = 2183,
  [3773] = 2144,
  [3774] = 2186,
  [3775] = 3546,
  [3776] = 2187,
  [3777] = 2188,
  [3778] = 2190,
  [3779] = 2191,
  [3780] = 2192,
  [3781] = 2193,
  [3782] = 2194,
  [3783] = 2195,
  [3784] = 2196,
  [3785] = 2197,
  [3786] = 2160,
  [3787] = 2198,
  [3788] = 2199,
  [3789] = 2163,
  [3790] = 2165,
  [3791] = 2204,
  [3792] = 2205,
  [3793] = 2207,
  [3794] = 2209,
  [3795] = 3472,
  [3796] = 2177,
  [3797] = 2200,
  [3798] = 2142,
  [3799] = 3441,
  [3800] = 3571,
  [3801] = 2156,
  [3802] = 3535,
  [3803] = 2143,
  [3804] = 2145,
  [3805] = 3508,
  [3806] = 2147,
  [3807] = 2149,
  [3808] = 2153,
  [3809] = 3426,
  [3810] = 3548,
  [3811] = 2206,
  [3812] = 2140,
  [3813] = 2164,
  [3814] = 2151,
  [3815] = 2155,
  [3816] = 2148,
  [3817] = 2166,
  [3818] = 2210,
  [3819] = 2181,
  [3820] = 2184,
  [3821] = 2141,
  [3822] = 2157,
  [3823] = 3536,
  [3824] = 2161,
  [3825] = 3521,
  [3826] = 3522,
  [3827] = 3510,
  [3828] = 3513,
  [3829] = 3509,
  [3830] = 3523,
  [3831] = 3530,
  [3832] = 3832,
  [3833] = 3519,
  [3834] = 3571,
  [3835] = 3517,
  [3836] = 3540,
  [3837] = 3501,
  [3838] = 3502,
  [3839] = 3546,
  [3840] = 3553,
  [3841] = 3544,
  [3842] = 3571,
  [3843] = 3501,
  [3844] = 3502,
  [3845] = 3509,
  [3846] = 3526,
  [3847] = 3525,
  [3848] = 3510,
  [3849] = 3849,
  [3850] = 3524,
  [3851] = 3513,
  [3852] = 3852,
  [3853] = 3853,
  [3854] = 3853,
  [3855] = 3852,
  [3856] = 3525,
  [3857] = 3852,
  [3858] = 3858,
  [3859] = 3859,
  [3860] = 3853,
  [3861] = 3858,
  [3862] = 3862,
  [3863] = 3853,
  [3864] = 3858,
  [3865] = 3852,
  [3866] = 3853,
  [3867] = 3867,
  [3868] = 3526,
  [3869] = 3524,
  [3870] = 3852,
  [3871] = 3859,
  [3872] = 3867,
  [3873] = 3859,
  [3874] = 3874,
  [3875] = 3875,
  [3876] = 3876,
  [3877] = 3876,
  [3878] = 3878,
  [3879] = 3878,
  [3880] = 3880,
  [3881] = 3881,
  [3882] = 3882,
  [3883] = 3883,
  [3884] = 3883,
  [3885] = 3885,
  [3886] = 3885,
  [3887] = 3887,
  [3888] = 3888,
  [3889] = 3889,
  [3890] = 3890,
  [3891] = 3891,
  [3892] = 3892,
  [3893] = 3893,
  [3894] = 3894,
  [3895] = 3895,
  [3896] = 3896,
  [3897] = 3897,
  [3898] = 3898,
  [3899] = 3893,
  [3900] = 3892,
  [3901] = 3896,
  [3902] = 3897,
  [3903] = 3898,
  [3904] = 3891,
  [3905] = 3905,
  [3906] = 3906,
  [3907] = 3907,
  [3908] = 3905,
  [3909] = 3906,
  [3910] = 3894,
  [3911] = 3895,
  [3912] = 3912,
  [3913] = 3913,
  [3914] = 3914,
  [3915] = 3915,
  [3916] = 3916,
  [3917] = 3917,
  [3918] = 3918,
  [3919] = 3919,
  [3920] = 3920,
  [3921] = 3919,
  [3922] = 3922,
  [3923] = 3914,
  [3924] = 3924,
  [3925] = 3925,
  [3926] = 3917,
  [3927] = 3927,
  [3928] = 3928,
  [3929] = 3924,
  [3930] = 3928,
  [3931] = 3931,
  [3932] = 3931,
  [3933] = 3920,
  [3934] = 3916,
  [3935] = 3935,
  [3936] = 3936,
  [3937] = 3498,
  [3938] = 3938,
  [3939] = 3939,
  [3940] = 3940,
  [3941] = 3941,
  [3942] = 3942,
  [3943] = 3943,
  [3944] = 3944,
  [3945] = 3945,
  [3946] = 3946,
  [3947] = 3947,
  [3948] = 3948,
  [3949] = 3949,
  [3950] = 3950,
  [3951] = 3951,
  [3952] = 3952,
  [3953] = 3953,
  [3954] = 3954,
  [3955] = 3955,
  [3956] = 3956,
  [3957] = 3957,
  [3958] = 3958,
  [3959] = 3959,
  [3960] = 3960,
  [3961] = 3961,
  [3962] = 3962,
  [3963] = 3963,
  [3964] = 3958,
  [3965] = 3965,
  [3966] = 3966,
  [3967] = 3958,
  [3968] = 3968,
  [3969] = 3961,
  [3970] = 3958,
  [3971] = 3958,
  [3972] = 3958,
  [3973] = 3958,
  [3974] = 3958,
  [3975] = 3956,
  [3976] = 3961,
  [3977] = 3977,
  [3978] = 3958,
  [3979] = 3961,
  [3980] = 3958,
  [3981] = 3961,
  [3982] = 3982,
  [3983] = 3961,
  [3984] = 3961,
  [3985] = 3985,
  [3986] = 3956,
  [3987] = 3958,
  [3988] = 3988,
  [3989] = 3956,
  [3990] = 3961,
  [3991] = 3956,
  [3992] = 3992,
  [3993] = 3993,
  [3994] = 3993,
  [3995] = 3961,
  [3996] = 3958,
  [3997] = 3958,
  [3998] = 3998,
  [3999] = 3958,
  [4000] = 3961,
  [4001] = 3961,
  [4002] = 3958,
  [4003] = 3961,
  [4004] = 3961,
  [4005] = 3961,
  [4006] = 3958,
  [4007] = 3961,
  [4008] = 3958,
  [4009] = 4009,
  [4010] = 3993,
  [4011] = 4011,
  [4012] = 4012,
  [4013] = 3961,
  [4014] = 4014,
  [4015] = 4015,
  [4016] = 4016,
  [4017] = 4017,
  [4018] = 4016,
  [4019] = 4019,
  [4020] = 4020,
  [4021] = 4020,
  [4022] = 4022,
  [4023] = 4023,
  [4024] = 4015,
  [4025] = 4016,
  [4026] = 4020,
  [4027] = 2158,
  [4028] = 4015,
  [4029] = 1601,
  [4030] = 4016,
  [4031] = 4016,
  [4032] = 1602,
  [4033] = 1600,
  [4034] = 4016,
  [4035] = 4017,
  [4036] = 4017,
  [4037] = 4037,
  [4038] = 4038,
  [4039] = 4020,
  [4040] = 4015,
  [4041] = 4016,
  [4042] = 4017,
  [4043] = 2150,
  [4044] = 4044,
  [4045] = 4016,
  [4046] = 4020,
  [4047] = 4016,
  [4048] = 4017,
  [4049] = 4015,
  [4050] = 4050,
  [4051] = 4051,
  [4052] = 4020,
  [4053] = 4017,
  [4054] = 4022,
  [4055] = 4016,
  [4056] = 4016,
  [4057] = 4015,
  [4058] = 4017,
  [4059] = 4059,
  [4060] = 4016,
  [4061] = 4015,
  [4062] = 4020,
  [4063] = 4016,
  [4064] = 4064,
  [4065] = 4020,
  [4066] = 4066,
  [4067] = 4067,
  [4068] = 4068,
  [4069] = 4015,
  [4070] = 4070,
  [4071] = 4071,
  [4072] = 4015,
  [4073] = 4071,
  [4074] = 4074,
  [4075] = 4075,
  [4076] = 4017,
  [4077] = 4015,
  [4078] = 4016,
  [4079] = 4075,
  [4080] = 4017,
  [4081] = 4020,
  [4082] = 4071,
  [4083] = 4075,
  [4084] = 4020,
  [4085] = 4071,
  [4086] = 4075,
  [4087] = 4087,
  [4088] = 4017,
  [4089] = 4071,
  [4090] = 4075,
  [4091] = 4071,
  [4092] = 4015,
  [4093] = 4075,
  [4094] = 4094,
  [4095] = 4071,
  [4096] = 4015,
  [4097] = 4075,
  [4098] = 4071,
  [4099] = 4075,
  [4100] = 4071,
  [4101] = 4075,
  [4102] = 4015,
  [4103] = 4020,
  [4104] = 4071,
  [4105] = 4075,
  [4106] = 4071,
  [4107] = 4075,
  [4108] = 4108,
  [4109] = 4071,
  [4110] = 4075,
  [4111] = 4111,
  [4112] = 4016,
  [4113] = 4071,
  [4114] = 4075,
  [4115] = 4071,
  [4116] = 4075,
  [4117] = 4071,
  [4118] = 4075,
  [4119] = 4071,
  [4120] = 4015,
  [4121] = 4075,
  [4122] = 4017,
  [4123] = 4071,
  [4124] = 4075,
  [4125] = 4017,
  [4126] = 4020,
  [4127] = 4017,
  [4128] = 4128,
  [4129] = 4020,
  [4130] = 4016,
  [4131] = 4020,
  [4132] = 4017,
  [4133] = 4133,
  [4134] = 4134,
  [4135] = 4020,
  [4136] = 4015,
  [4137] = 4015,
  [4138] = 4017,
  [4139] = 4051,
  [4140] = 4015,
  [4141] = 4020,
  [4142] = 4017,
  [4143] = 4143,
  [4144] = 4144,
  [4145] = 4145,
  [4146] = 4146,
  [4147] = 4147,
  [4148] = 4148,
  [4149] = 4149,
  [4150] = 4149,
  [4151] = 4151,
  [4152] = 4152,
  [4153] = 4153,
  [4154] = 4149,
  [4155] = 4149,
  [4156] = 4156,
  [4157] = 3516,
  [4158] = 4148,
  [4159] = 4159,
  [4160] = 4160,
  [4161] = 4144,
  [4162] = 3472,
  [4163] = 4159,
  [4164] = 4164,
  [4165] = 4165,
  [4166] = 3511,
  [4167] = 4167,
  [4168] = 4168,
  [4169] = 3516,
  [4170] = 4170,
  [4171] = 4171,
  [4172] = 4172,
  [4173] = 4173,
  [4174] = 4174,
  [4175] = 4175,
  [4176] = 4149,
  [4177] = 4149,
  [4178] = 4149,
  [4179] = 4179,
  [4180] = 4180,
  [4181] = 4149,
  [4182] = 3504,
  [4183] = 4183,
  [4184] = 4164,
  [4185] = 4171,
  [4186] = 4186,
  [4187] = 4187,
  [4188] = 4188,
  [4189] = 4189,
  [4190] = 4190,
  [4191] = 4191,
  [4192] = 4192,
  [4193] = 4188,
  [4194] = 4194,
  [4195] = 3505,
  [4196] = 4196,
  [4197] = 4197,
  [4198] = 4149,
  [4199] = 3503,
  [4200] = 4200,
  [4201] = 4151,
  [4202] = 4164,
  [4203] = 4153,
  [4204] = 4204,
  [4205] = 4149,
  [4206] = 4149,
  [4207] = 4207,
  [4208] = 4188,
  [4209] = 4209,
  [4210] = 4210,
  [4211] = 2313,
  [4212] = 4212,
  [4213] = 3493,
  [4214] = 4149,
  [4215] = 4215,
  [4216] = 4216,
  [4217] = 4217,
  [4218] = 4218,
  [4219] = 4149,
  [4220] = 4149,
  [4221] = 4221,
  [4222] = 4222,
  [4223] = 4149,
  [4224] = 4156,
  [4225] = 4225,
  [4226] = 4226,
  [4227] = 4227,
  [4228] = 4228,
  [4229] = 4229,
  [4230] = 4230,
  [4231] = 4170,
  [4232] = 4232,
  [4233] = 3511,
  [4234] = 4160,
  [4235] = 4235,
  [4236] = 4180,
  [4237] = 4192,
  [4238] = 4225,
  [4239] = 4149,
  [4240] = 4240,
  [4241] = 4240,
  [4242] = 3496,
  [4243] = 4243,
  [4244] = 4244,
  [4245] = 4245,
  [4246] = 4246,
  [4247] = 4247,
  [4248] = 4240,
  [4249] = 4249,
  [4250] = 4250,
  [4251] = 4245,
  [4252] = 4246,
  [4253] = 4243,
  [4254] = 4254,
  [4255] = 4247,
  [4256] = 4256,
  [4257] = 4257,
  [4258] = 4258,
  [4259] = 4259,
  [4260] = 4260,
  [4261] = 4261,
  [4262] = 4262,
  [4263] = 4263,
  [4264] = 4264,
  [4265] = 4265,
  [4266] = 4244,
  [4267] = 4262,
  [4268] = 4268,
  [4269] = 4269,
  [4270] = 3535,
  [4271] = 4271,
  [4272] = 4272,
  [4273] = 4262,
  [4274] = 4258,
  [4275] = 4245,
  [4276] = 4245,
  [4277] = 4262,
  [4278] = 4249,
  [4279] = 4250,
  [4280] = 4280,
  [4281] = 4263,
  [4282] = 4244,
  [4283] = 4283,
  [4284] = 3520,
  [4285] = 4240,
  [4286] = 4240,
  [4287] = 4287,
  [4288] = 4258,
  [4289] = 4289,
  [4290] = 4243,
  [4291] = 4240,
  [4292] = 4292,
  [4293] = 4258,
  [4294] = 4294,
  [4295] = 4243,
  [4296] = 4296,
  [4297] = 4246,
  [4298] = 4262,
  [4299] = 4299,
  [4300] = 4300,
  [4301] = 4262,
  [4302] = 4302,
  [4303] = 4283,
  [4304] = 4304,
  [4305] = 4263,
  [4306] = 4243,
  [4307] = 4244,
  [4308] = 4308,
  [4309] = 4309,
  [4310] = 4310,
  [4311] = 4287,
  [4312] = 4262,
  [4313] = 4263,
  [4314] = 4283,
  [4315] = 4240,
  [4316] = 4243,
  [4317] = 4247,
  [4318] = 4318,
  [4319] = 4319,
  [4320] = 4244,
  [4321] = 4246,
  [4322] = 4262,
  [4323] = 4240,
  [4324] = 4244,
  [4325] = 4243,
  [4326] = 4263,
  [4327] = 4327,
  [4328] = 4262,
  [4329] = 4258,
  [4330] = 4263,
  [4331] = 4244,
  [4332] = 4245,
  [4333] = 4333,
  [4334] = 4246,
  [4335] = 4240,
  [4336] = 4244,
  [4337] = 4319,
  [4338] = 4338,
  [4339] = 4339,
  [4340] = 4340,
  [4341] = 4240,
  [4342] = 4243,
  [4343] = 4258,
  [4344] = 4262,
  [4345] = 4345,
  [4346] = 4262,
  [4347] = 4258,
  [4348] = 4258,
  [4349] = 4249,
  [4350] = 4287,
  [4351] = 4351,
  [4352] = 4352,
  [4353] = 4263,
  [4354] = 4354,
  [4355] = 4258,
  [4356] = 4244,
  [4357] = 4357,
  [4358] = 4240,
  [4359] = 4243,
  [4360] = 4319,
  [4361] = 4262,
  [4362] = 4362,
  [4363] = 4363,
  [4364] = 4263,
  [4365] = 4262,
  [4366] = 4263,
  [4367] = 4244,
  [4368] = 4258,
  [4369] = 4263,
  [4370] = 4244,
  [4371] = 4245,
  [4372] = 4263,
  [4373] = 4244,
  [4374] = 3533,
  [4375] = 4375,
  [4376] = 4263,
  [4377] = 4244,
  [4378] = 4262,
  [4379] = 4379,
  [4380] = 3536,
  [4381] = 4243,
  [4382] = 4319,
  [4383] = 4250,
  [4384] = 4240,
  [4385] = 4243,
  [4386] = 4258,
  [4387] = 4258,
  [4388] = 4240,
  [4389] = 4258,
  [4390] = 4262,
  [4391] = 4258,
  [4392] = 4246,
  [4393] = 4240,
  [4394] = 4258,
  [4395] = 4243,
  [4396] = 4396,
  [4397] = 4263,
  [4398] = 4244,
  [4399] = 3514,
  [4400] = 4400,
  [4401] = 4243,
  [4402] = 4240,
  [4403] = 4403,
  [4404] = 4263,
  [4405] = 4244,
  [4406] = 4319,
  [4407] = 4407,
  [4408] = 4240,
  [4409] = 4243,
  [4410] = 3535,
  [4411] = 3536,
  [4412] = 4243,
  [4413] = 4413,
  [4414] = 4414,
  [4415] = 4415,
  [4416] = 4258,
  [4417] = 4417,
  [4418] = 4263,
  [4419] = 4263,
  [4420] = 4244,
  [4421] = 4262,
  [4422] = 4243,
  [4423] = 3511,
  [4424] = 4424,
  [4425] = 4425,
  [4426] = 4426,
  [4427] = 4427,
  [4428] = 4428,
  [4429] = 4429,
  [4430] = 4430,
  [4431] = 4431,
  [4432] = 4432,
  [4433] = 4433,
  [4434] = 4434,
  [4435] = 4435,
  [4436] = 4436,
  [4437] = 4437,
  [4438] = 4438,
  [4439] = 4439,
  [4440] = 4440,
  [4441] = 4426,
  [4442] = 4442,
  [4443] = 4427,
  [4444] = 4440,
  [4445] = 4440,
  [4446] = 4442,
  [4447] = 4447,
  [4448] = 4448,
  [4449] = 4449,
  [4450] = 4450,
  [4451] = 4442,
  [4452] = 4452,
  [4453] = 3511,
  [4454] = 4454,
  [4455] = 4455,
  [4456] = 4456,
  [4457] = 4447,
  [4458] = 4448,
  [4459] = 4449,
  [4460] = 4456,
  [4461] = 4428,
  [4462] = 4429,
  [4463] = 4430,
  [4464] = 4432,
  [4465] = 4452,
  [4466] = 4434,
  [4467] = 4436,
  [4468] = 4438,
  [4469] = 4439,
  [4470] = 4426,
  [4471] = 4427,
  [4472] = 4440,
  [4473] = 4442,
  [4474] = 4447,
  [4475] = 4448,
  [4476] = 4449,
  [4477] = 4450,
  [4478] = 4452,
  [4479] = 3511,
  [4480] = 4480,
  [4481] = 4456,
  [4482] = 4428,
  [4483] = 4429,
  [4484] = 4430,
  [4485] = 4432,
  [4486] = 4434,
  [4487] = 4436,
  [4488] = 4438,
  [4489] = 4439,
  [4490] = 4426,
  [4491] = 4427,
  [4492] = 4454,
  [4493] = 4440,
  [4494] = 4442,
  [4495] = 4447,
  [4496] = 4448,
  [4497] = 4449,
  [4498] = 4450,
  [4499] = 4452,
  [4500] = 3511,
  [4501] = 4501,
  [4502] = 4456,
  [4503] = 4428,
  [4504] = 4429,
  [4505] = 4430,
  [4506] = 4432,
  [4507] = 4425,
  [4508] = 4434,
  [4509] = 4436,
  [4510] = 4438,
  [4511] = 4439,
  [4512] = 4426,
  [4513] = 4427,
  [4514] = 4440,
  [4515] = 4442,
  [4516] = 4447,
  [4517] = 4448,
  [4518] = 4449,
  [4519] = 4450,
  [4520] = 4452,
  [4521] = 3511,
  [4522] = 3511,
  [4523] = 4456,
  [4524] = 3553,
  [4525] = 3550,
  [4526] = 4455,
  [4527] = 4428,
  [4528] = 4429,
  [4529] = 4430,
  [4530] = 4432,
  [4531] = 4434,
  [4532] = 4436,
  [4533] = 4438,
  [4534] = 4439,
  [4535] = 4426,
  [4536] = 4427,
  [4537] = 4537,
  [4538] = 4538,
  [4539] = 4539,
  [4540] = 4440,
  [4541] = 4442,
  [4542] = 4447,
  [4543] = 4448,
  [4544] = 4449,
  [4545] = 4450,
  [4546] = 2312,
  [4547] = 4452,
  [4548] = 4456,
  [4549] = 4447,
  [4550] = 4448,
  [4551] = 4449,
  [4552] = 4430,
  [4553] = 4432,
  [4554] = 4436,
  [4555] = 4450,
  [4556] = 4439,
  [4557] = 4426,
  [4558] = 4427,
  [4559] = 4559,
  [4560] = 4440,
  [4561] = 4448,
  [4562] = 4449,
  [4563] = 4450,
  [4564] = 4452,
  [4565] = 4452,
  [4566] = 4428,
  [4567] = 4567,
  [4568] = 4568,
  [4569] = 4539,
  [4570] = 4429,
  [4571] = 4571,
  [4572] = 4430,
  [4573] = 4573,
  [4574] = 4574,
  [4575] = 4575,
  [4576] = 4432,
  [4577] = 4577,
  [4578] = 4578,
  [4579] = 4579,
  [4580] = 4580,
  [4581] = 4581,
  [4582] = 4582,
  [4583] = 4434,
  [4584] = 4584,
  [4585] = 4436,
  [4586] = 4537,
  [4587] = 4559,
  [4588] = 4577,
  [4589] = 4578,
  [4590] = 4590,
  [4591] = 4591,
  [4592] = 4592,
  [4593] = 4593,
  [4594] = 4438,
  [4595] = 4439,
  [4596] = 4596,
  [4597] = 4426,
  [4598] = 4427,
  [4599] = 4440,
  [4600] = 4571,
  [4601] = 4442,
  [4602] = 4573,
  [4603] = 4574,
  [4604] = 4454,
  [4605] = 4455,
  [4606] = 4447,
  [4607] = 4448,
  [4608] = 4449,
  [4609] = 4450,
  [4610] = 4580,
  [4611] = 4581,
  [4612] = 4582,
  [4613] = 4584,
  [4614] = 4452,
  [4615] = 4615,
  [4616] = 4616,
  [4617] = 4617,
  [4618] = 3511,
  [4619] = 4537,
  [4620] = 4578,
  [4621] = 4592,
  [4622] = 4538,
  [4623] = 4539,
  [4624] = 4571,
  [4625] = 4573,
  [4626] = 4456,
  [4627] = 4580,
  [4628] = 4581,
  [4629] = 4582,
  [4630] = 4584,
  [4631] = 4631,
  [4632] = 4428,
  [4633] = 4456,
  [4634] = 4537,
  [4635] = 4578,
  [4636] = 4592,
  [4637] = 4637,
  [4638] = 4428,
  [4639] = 4429,
  [4640] = 4571,
  [4641] = 4573,
  [4642] = 4430,
  [4643] = 4643,
  [4644] = 4432,
  [4645] = 4581,
  [4646] = 4582,
  [4647] = 4584,
  [4648] = 4648,
  [4649] = 3557,
  [4650] = 4434,
  [4651] = 4436,
  [4652] = 4578,
  [4653] = 4592,
  [4654] = 4559,
  [4655] = 4438,
  [4656] = 4439,
  [4657] = 4426,
  [4658] = 4590,
  [4659] = 4574,
  [4660] = 4660,
  [4661] = 4427,
  [4662] = 4425,
  [4663] = 4663,
  [4664] = 4664,
  [4665] = 4592,
  [4666] = 4440,
  [4667] = 3511,
  [4668] = 4442,
  [4669] = 4591,
  [4670] = 4454,
  [4671] = 4447,
  [4672] = 4448,
  [4673] = 4449,
  [4674] = 4674,
  [4675] = 4450,
  [4676] = 4452,
  [4677] = 4428,
  [4678] = 4678,
  [4679] = 4679,
  [4680] = 4592,
  [4681] = 4438,
  [4682] = 4592,
  [4683] = 3511,
  [4684] = 4439,
  [4685] = 4685,
  [4686] = 4538,
  [4687] = 4426,
  [4688] = 4539,
  [4689] = 4456,
  [4690] = 3556,
  [4691] = 4456,
  [4692] = 4592,
  [4693] = 2306,
  [4694] = 4567,
  [4695] = 4428,
  [4696] = 4427,
  [4697] = 4429,
  [4698] = 4430,
  [4699] = 4225,
  [4700] = 2308,
  [4701] = 2309,
  [4702] = 4432,
  [4703] = 3544,
  [4704] = 4434,
  [4705] = 4592,
  [4706] = 4706,
  [4707] = 4436,
  [4708] = 4568,
  [4709] = 4559,
  [4710] = 4438,
  [4711] = 4439,
  [4712] = 4156,
  [4713] = 4580,
  [4714] = 4714,
  [4715] = 4426,
  [4716] = 4440,
  [4717] = 4428,
  [4718] = 4427,
  [4719] = 4442,
  [4720] = 4720,
  [4721] = 4567,
  [4722] = 4722,
  [4723] = 4592,
  [4724] = 4568,
  [4725] = 4429,
  [4726] = 4440,
  [4727] = 4442,
  [4728] = 4454,
  [4729] = 4447,
  [4730] = 4448,
  [4731] = 4449,
  [4732] = 4450,
  [4733] = 4430,
  [4734] = 4452,
  [4735] = 4429,
  [4736] = 4430,
  [4737] = 4592,
  [4738] = 3511,
  [4739] = 4739,
  [4740] = 4432,
  [4741] = 4741,
  [4742] = 4434,
  [4743] = 4743,
  [4744] = 4456,
  [4745] = 4454,
  [4746] = 4436,
  [4747] = 4434,
  [4748] = 4456,
  [4749] = 4559,
  [4750] = 4592,
  [4751] = 4577,
  [4752] = 4455,
  [4753] = 4590,
  [4754] = 4428,
  [4755] = 4429,
  [4756] = 4430,
  [4757] = 4432,
  [4758] = 4591,
  [4759] = 4432,
  [4760] = 4434,
  [4761] = 4436,
  [4762] = 4438,
  [4763] = 4763,
  [4764] = 4439,
  [4765] = 4592,
  [4766] = 4438,
  [4767] = 4439,
  [4768] = 4768,
  [4769] = 4426,
  [4770] = 4426,
  [4771] = 4771,
  [4772] = 4427,
  [4773] = 4575,
  [4774] = 4427,
  [4775] = 4775,
  [4776] = 4440,
  [4777] = 4442,
  [4778] = 4447,
  [4779] = 4592,
  [4780] = 4448,
  [4781] = 4781,
  [4782] = 4449,
  [4783] = 4450,
  [4784] = 4452,
  [4785] = 4440,
  [4786] = 3511,
  [4787] = 4442,
  [4788] = 4434,
  [4789] = 4454,
  [4790] = 4455,
  [4791] = 4447,
  [4792] = 4456,
  [4793] = 4448,
  [4794] = 4592,
  [4795] = 4449,
  [4796] = 4450,
  [4797] = 4797,
  [4798] = 4452,
  [4799] = 4436,
  [4800] = 3546,
  [4801] = 4428,
  [4802] = 4581,
  [4803] = 4429,
  [4804] = 4430,
  [4805] = 4432,
  [4806] = 4592,
  [4807] = 4434,
  [4808] = 4436,
  [4809] = 4438,
  [4810] = 4439,
  [4811] = 4426,
  [4812] = 3516,
  [4813] = 4436,
  [4814] = 4427,
  [4815] = 4815,
  [4816] = 4559,
  [4817] = 4817,
  [4818] = 4425,
  [4819] = 4440,
  [4820] = 4442,
  [4821] = 4447,
  [4822] = 4448,
  [4823] = 4449,
  [4824] = 4450,
  [4825] = 4452,
  [4826] = 3511,
  [4827] = 3511,
  [4828] = 4828,
  [4829] = 4425,
  [4830] = 4577,
  [4831] = 4538,
  [4832] = 4456,
  [4833] = 4539,
  [4834] = 4590,
  [4835] = 4456,
  [4836] = 4591,
  [4837] = 4428,
  [4838] = 3516,
  [4839] = 4429,
  [4840] = 4430,
  [4841] = 4432,
  [4842] = 4674,
  [4843] = 4843,
  [4844] = 3516,
  [4845] = 4434,
  [4846] = 4436,
  [4847] = 4847,
  [4848] = 4848,
  [4849] = 3516,
  [4850] = 4850,
  [4851] = 4573,
  [4852] = 4438,
  [4853] = 4439,
  [4854] = 3516,
  [4855] = 4855,
  [4856] = 4426,
  [4857] = 4438,
  [4858] = 4428,
  [4859] = 4447,
  [4860] = 3516,
  [4861] = 4427,
  [4862] = 4567,
  [4863] = 4863,
  [4864] = 3516,
  [4865] = 4582,
  [4866] = 4866,
  [4867] = 4448,
  [4868] = 3516,
  [4869] = 4440,
  [4870] = 4449,
  [4871] = 4442,
  [4872] = 4447,
  [4873] = 3516,
  [4874] = 4448,
  [4875] = 4875,
  [4876] = 4449,
  [4877] = 4450,
  [4878] = 4452,
  [4879] = 4567,
  [4880] = 4450,
  [4881] = 3516,
  [4882] = 3511,
  [4883] = 4568,
  [4884] = 4584,
  [4885] = 4568,
  [4886] = 4452,
  [4887] = 4439,
  [4888] = 4429,
  [4889] = 3516,
  [4890] = 4430,
  [4891] = 4781,
  [4892] = 4456,
  [4893] = 3516,
  [4894] = 4714,
  [4895] = 4432,
  [4896] = 4896,
  [4897] = 3516,
  [4898] = 4898,
  [4899] = 4428,
  [4900] = 4429,
  [4901] = 4430,
  [4902] = 4434,
  [4903] = 4432,
  [4904] = 4426,
  [4905] = 4436,
  [4906] = 4434,
  [4907] = 4907,
  [4908] = 4436,
  [4909] = 4909,
  [4910] = 4910,
  [4911] = 4438,
  [4912] = 4439,
  [4913] = 4432,
  [4914] = 4426,
  [4915] = 4571,
  [4916] = 4427,
  [4917] = 4538,
  [4918] = 4918,
  [4919] = 4559,
  [4920] = 4920,
  [4921] = 4440,
  [4922] = 4922,
  [4923] = 4442,
  [4924] = 4447,
  [4925] = 4448,
  [4926] = 4449,
  [4927] = 4450,
  [4928] = 4577,
  [4929] = 4452,
  [4930] = 4429,
  [4931] = 4430,
  [4932] = 4590,
  [4933] = 4933,
  [4934] = 4934,
  [4935] = 3511,
  [4936] = 4591,
  [4937] = 4937,
  [4938] = 4427,
  [4939] = 4438,
  [4940] = 4940,
  [4941] = 4439,
  [4942] = 4450,
  [4943] = 4943,
  [4944] = 4943,
  [4945] = 4945,
  [4946] = 4946,
  [4947] = 4943,
  [4948] = 3950,
  [4949] = 4949,
  [4950] = 4950,
  [4951] = 4951,
  [4952] = 4943,
  [4953] = 2221,
  [4954] = 4954,
  [4955] = 4955,
  [4956] = 3945,
  [4957] = 4950,
  [4958] = 4958,
  [4959] = 4943,
  [4960] = 4960,
  [4961] = 4961,
  [4962] = 4951,
  [4963] = 4951,
  [4964] = 4964,
  [4965] = 4943,
  [4966] = 3571,
  [4967] = 4967,
  [4968] = 3948,
  [4969] = 4951,
  [4970] = 4970,
  [4971] = 4971,
  [4972] = 4943,
  [4973] = 4973,
  [4974] = 4943,
  [4975] = 4975,
  [4976] = 4976,
  [4977] = 4943,
  [4978] = 4978,
  [4979] = 4951,
  [4980] = 4980,
  [4981] = 4951,
  [4982] = 4982,
  [4983] = 4943,
  [4984] = 4984,
  [4985] = 4951,
  [4986] = 3946,
  [4987] = 4987,
  [4988] = 4950,
  [4989] = 4943,
  [4990] = 4990,
  [4991] = 4991,
  [4992] = 4992,
  [4993] = 4993,
  [4994] = 4943,
  [4995] = 4951,
  [4996] = 4996,
  [4997] = 4997,
  [4998] = 4998,
  [4999] = 2231,
  [5000] = 5000,
  [5001] = 4951,
  [5002] = 5002,
  [5003] = 4951,
  [5004] = 5004,
  [5005] = 4951,
  [5006] = 2229,
  [5007] = 3947,
  [5008] = 4951,
  [5009] = 4943,
  [5010] = 5010,
  [5011] = 5011,
  [5012] = 4951,
  [5013] = 5013,
  [5014] = 5014,
  [5015] = 2237,
  [5016] = 5016,
  [5017] = 5017,
  [5018] = 4943,
  [5019] = 2234,
  [5020] = 3988,
  [5021] = 5021,
  [5022] = 5022,
  [5023] = 5023,
  [5024] = 5024,
  [5025] = 4951,
  [5026] = 2130,
  [5027] = 4943,
  [5028] = 4946,
  [5029] = 5029,
  [5030] = 5030,
  [5031] = 4951,
  [5032] = 5032,
  [5033] = 5033,
  [5034] = 4951,
  [5035] = 4943,
  [5036] = 5036,
  [5037] = 5037,
  [5038] = 5038,
  [5039] = 4951,
  [5040] = 4945,
  [5041] = 5041,
  [5042] = 2238,
  [5043] = 4945,
  [5044] = 4943,
  [5045] = 4945,
  [5046] = 4945,
  [5047] = 4945,
  [5048] = 4945,
  [5049] = 4945,
  [5050] = 4945,
  [5051] = 4945,
  [5052] = 4945,
  [5053] = 4945,
  [5054] = 4945,
  [5055] = 4945,
  [5056] = 4945,
  [5057] = 4945,
  [5058] = 4945,
  [5059] = 3558,
  [5060] = 5060,
  [5061] = 2191,
  [5062] = 5062,
  [5063] = 5063,
  [5064] = 5064,
  [5065] = 5065,
  [5066] = 5060,
  [5067] = 5067,
  [5068] = 2249,
  [5069] = 2192,
  [5070] = 5070,
  [5071] = 2193,
  [5072] = 5072,
  [5073] = 5073,
  [5074] = 5074,
  [5075] = 5075,
  [5076] = 5076,
  [5077] = 2194,
  [5078] = 5078,
  [5079] = 5070,
  [5080] = 5080,
  [5081] = 5081,
  [5082] = 2172,
  [5083] = 5083,
  [5084] = 5084,
  [5085] = 5085,
  [5086] = 5086,
  [5087] = 5087,
  [5088] = 2253,
  [5089] = 5089,
  [5090] = 5090,
  [5091] = 5091,
  [5092] = 5092,
  [5093] = 5060,
  [5094] = 5063,
  [5095] = 3957,
  [5096] = 2195,
  [5097] = 2196,
  [5098] = 5098,
  [5099] = 5099,
  [5100] = 5100,
  [5101] = 5089,
  [5102] = 5086,
  [5103] = 2159,
  [5104] = 5104,
  [5105] = 5105,
  [5106] = 5098,
  [5107] = 5107,
  [5108] = 2197,
  [5109] = 2198,
  [5110] = 2199,
  [5111] = 2167,
  [5112] = 2204,
  [5113] = 5086,
  [5114] = 5114,
  [5115] = 2205,
  [5116] = 5116,
  [5117] = 2298,
  [5118] = 5081,
  [5119] = 3593,
  [5120] = 5060,
  [5121] = 3594,
  [5122] = 5122,
  [5123] = 5123,
  [5124] = 2299,
  [5125] = 5081,
  [5126] = 5126,
  [5127] = 5063,
  [5128] = 5063,
  [5129] = 5084,
  [5130] = 5085,
  [5131] = 5131,
  [5132] = 5064,
  [5133] = 4011,
  [5134] = 2169,
  [5135] = 5067,
  [5136] = 2300,
  [5137] = 1601,
  [5138] = 5138,
  [5139] = 2362,
  [5140] = 5086,
  [5141] = 5141,
  [5142] = 2207,
  [5143] = 5143,
  [5144] = 5062,
  [5145] = 5145,
  [5146] = 5072,
  [5147] = 5060,
  [5148] = 5081,
  [5149] = 2264,
  [5150] = 5063,
  [5151] = 5151,
  [5152] = 5152,
  [5153] = 5153,
  [5154] = 5076,
  [5155] = 3572,
  [5156] = 5081,
  [5157] = 5084,
  [5158] = 5158,
  [5159] = 5159,
  [5160] = 5160,
  [5161] = 5085,
  [5162] = 2170,
  [5163] = 2302,
  [5164] = 2209,
  [5165] = 5165,
  [5166] = 5166,
  [5167] = 5086,
  [5168] = 5084,
  [5169] = 5169,
  [5170] = 5099,
  [5171] = 5099,
  [5172] = 5100,
  [5173] = 5081,
  [5174] = 5060,
  [5175] = 5175,
  [5176] = 5085,
  [5177] = 5084,
  [5178] = 5085,
  [5179] = 5086,
  [5180] = 5180,
  [5181] = 5181,
  [5182] = 2177,
  [5183] = 2161,
  [5184] = 5084,
  [5185] = 3998,
  [5186] = 5085,
  [5187] = 1600,
  [5188] = 5188,
  [5189] = 5189,
  [5190] = 5190,
  [5191] = 5060,
  [5192] = 3966,
  [5193] = 2200,
  [5194] = 5086,
  [5195] = 5060,
  [5196] = 5100,
  [5197] = 5197,
  [5198] = 5198,
  [5199] = 5199,
  [5200] = 5064,
  [5201] = 5060,
  [5202] = 2265,
  [5203] = 2142,
  [5204] = 2143,
  [5205] = 5205,
  [5206] = 5116,
  [5207] = 5207,
  [5208] = 5081,
  [5209] = 5116,
  [5210] = 5210,
  [5211] = 2171,
  [5212] = 5212,
  [5213] = 5063,
  [5214] = 5073,
  [5215] = 5215,
  [5216] = 5216,
  [5217] = 3959,
  [5218] = 5218,
  [5219] = 5083,
  [5220] = 5060,
  [5221] = 5221,
  [5222] = 5222,
  [5223] = 5223,
  [5224] = 5224,
  [5225] = 5151,
  [5226] = 5226,
  [5227] = 5227,
  [5228] = 5080,
  [5229] = 5229,
  [5230] = 2139,
  [5231] = 2145,
  [5232] = 5232,
  [5233] = 5078,
  [5234] = 5085,
  [5235] = 5235,
  [5236] = 2147,
  [5237] = 5063,
  [5238] = 4009,
  [5239] = 5239,
  [5240] = 5099,
  [5241] = 5100,
  [5242] = 5116,
  [5243] = 5243,
  [5244] = 5244,
  [5245] = 5074,
  [5246] = 5246,
  [5247] = 5247,
  [5248] = 5086,
  [5249] = 5249,
  [5250] = 5250,
  [5251] = 5251,
  [5252] = 5252,
  [5253] = 5175,
  [5254] = 5116,
  [5255] = 2149,
  [5256] = 1602,
  [5257] = 5250,
  [5258] = 2153,
  [5259] = 2206,
  [5260] = 5060,
  [5261] = 5081,
  [5262] = 5252,
  [5263] = 5116,
  [5264] = 5264,
  [5265] = 5265,
  [5266] = 5084,
  [5267] = 5267,
  [5268] = 5081,
  [5269] = 5269,
  [5270] = 5232,
  [5271] = 5084,
  [5272] = 5085,
  [5273] = 5085,
  [5274] = 5064,
  [5275] = 5275,
  [5276] = 5276,
  [5277] = 5090,
  [5278] = 5116,
  [5279] = 2140,
  [5280] = 2164,
  [5281] = 2158,
  [5282] = 3573,
  [5283] = 3575,
  [5284] = 2151,
  [5285] = 5285,
  [5286] = 5267,
  [5287] = 5243,
  [5288] = 5244,
  [5289] = 5289,
  [5290] = 5246,
  [5291] = 5063,
  [5292] = 3962,
  [5293] = 5293,
  [5294] = 2155,
  [5295] = 5275,
  [5296] = 5296,
  [5297] = 2148,
  [5298] = 2173,
  [5299] = 5116,
  [5300] = 5065,
  [5301] = 2271,
  [5302] = 5302,
  [5303] = 5243,
  [5304] = 5244,
  [5305] = 2146,
  [5306] = 5246,
  [5307] = 5307,
  [5308] = 2174,
  [5309] = 5063,
  [5310] = 5063,
  [5311] = 5296,
  [5312] = 5312,
  [5313] = 2163,
  [5314] = 5086,
  [5315] = 5315,
  [5316] = 5316,
  [5317] = 5243,
  [5318] = 5244,
  [5319] = 5063,
  [5320] = 5246,
  [5321] = 2175,
  [5322] = 5322,
  [5323] = 3597,
  [5324] = 5324,
  [5325] = 5060,
  [5326] = 2252,
  [5327] = 2232,
  [5328] = 5243,
  [5329] = 5244,
  [5330] = 2176,
  [5331] = 3581,
  [5332] = 5064,
  [5333] = 5249,
  [5334] = 5190,
  [5335] = 5081,
  [5336] = 5063,
  [5337] = 2165,
  [5338] = 2178,
  [5339] = 5243,
  [5340] = 5244,
  [5341] = 2269,
  [5342] = 5246,
  [5343] = 5343,
  [5344] = 5344,
  [5345] = 5345,
  [5346] = 5081,
  [5347] = 5081,
  [5348] = 5104,
  [5349] = 2270,
  [5350] = 5243,
  [5351] = 5244,
  [5352] = 2284,
  [5353] = 5246,
  [5354] = 5354,
  [5355] = 2179,
  [5356] = 5356,
  [5357] = 5357,
  [5358] = 2180,
  [5359] = 2166,
  [5360] = 5086,
  [5361] = 5243,
  [5362] = 5244,
  [5363] = 2210,
  [5364] = 5246,
  [5365] = 5365,
  [5366] = 5366,
  [5367] = 5116,
  [5368] = 5063,
  [5369] = 2182,
  [5370] = 2183,
  [5371] = 5084,
  [5372] = 5243,
  [5373] = 5244,
  [5374] = 5084,
  [5375] = 5246,
  [5376] = 5060,
  [5377] = 5377,
  [5378] = 5378,
  [5379] = 5085,
  [5380] = 5380,
  [5381] = 5381,
  [5382] = 5064,
  [5383] = 5243,
  [5384] = 5244,
  [5385] = 5244,
  [5386] = 5246,
  [5387] = 5084,
  [5388] = 2186,
  [5389] = 3963,
  [5390] = 5390,
  [5391] = 5085,
  [5392] = 2247,
  [5393] = 5085,
  [5394] = 5243,
  [5395] = 5244,
  [5396] = 5081,
  [5397] = 5246,
  [5398] = 5246,
  [5399] = 5399,
  [5400] = 5081,
  [5401] = 2181,
  [5402] = 5402,
  [5403] = 2184,
  [5404] = 5084,
  [5405] = 5243,
  [5406] = 5244,
  [5407] = 5087,
  [5408] = 5246,
  [5409] = 5085,
  [5410] = 2141,
  [5411] = 5411,
  [5412] = 2160,
  [5413] = 5086,
  [5414] = 5116,
  [5415] = 5084,
  [5416] = 5243,
  [5417] = 5244,
  [5418] = 5418,
  [5419] = 5246,
  [5420] = 5085,
  [5421] = 5275,
  [5422] = 5116,
  [5423] = 5075,
  [5424] = 5086,
  [5425] = 5060,
  [5426] = 2187,
  [5427] = 5243,
  [5428] = 5244,
  [5429] = 5429,
  [5430] = 5246,
  [5431] = 5431,
  [5432] = 2150,
  [5433] = 5239,
  [5434] = 2156,
  [5435] = 5435,
  [5436] = 5116,
  [5437] = 2259,
  [5438] = 5243,
  [5439] = 5244,
  [5440] = 5099,
  [5441] = 5246,
  [5442] = 5442,
  [5443] = 3589,
  [5444] = 5100,
  [5445] = 3590,
  [5446] = 5446,
  [5447] = 5063,
  [5448] = 5243,
  [5449] = 5246,
  [5450] = 2275,
  [5451] = 5275,
  [5452] = 5275,
  [5453] = 5116,
  [5454] = 5454,
  [5455] = 5086,
  [5456] = 5081,
  [5457] = 3992,
  [5458] = 3441,
  [5459] = 5063,
  [5460] = 3960,
  [5461] = 5461,
  [5462] = 5086,
  [5463] = 5084,
  [5464] = 5085,
  [5465] = 2152,
  [5466] = 5091,
  [5467] = 5116,
  [5468] = 2276,
  [5469] = 5461,
  [5470] = 5275,
  [5471] = 2314,
  [5472] = 5060,
  [5473] = 5473,
  [5474] = 5264,
  [5475] = 5475,
  [5476] = 2277,
  [5477] = 5473,
  [5478] = 5478,
  [5479] = 2278,
  [5480] = 2230,
  [5481] = 3965,
  [5482] = 2279,
  [5483] = 5153,
  [5484] = 2335,
  [5485] = 5485,
  [5486] = 5060,
  [5487] = 3977,
  [5488] = 2185,
  [5489] = 5489,
  [5490] = 5063,
  [5491] = 5084,
  [5492] = 5063,
  [5493] = 2188,
  [5494] = 5064,
  [5495] = 5495,
  [5496] = 5390,
  [5497] = 5497,
  [5498] = 5498,
  [5499] = 5243,
  [5500] = 5086,
  [5501] = 2280,
  [5502] = 2281,
  [5503] = 5229,
  [5504] = 5081,
  [5505] = 5105,
  [5506] = 5506,
  [5507] = 5084,
  [5508] = 5085,
  [5509] = 5509,
  [5510] = 5510,
  [5511] = 5060,
  [5512] = 2317,
  [5513] = 5478,
  [5514] = 2328,
  [5515] = 5399,
  [5516] = 2189,
  [5517] = 5116,
  [5518] = 5189,
  [5519] = 5399,
  [5520] = 2333,
  [5521] = 2334,
  [5522] = 5399,
  [5523] = 5523,
  [5524] = 5399,
  [5525] = 5525,
  [5526] = 5399,
  [5527] = 5116,
  [5528] = 5399,
  [5529] = 5529,
  [5530] = 5399,
  [5531] = 3585,
  [5532] = 5399,
  [5533] = 5210,
  [5534] = 5399,
  [5535] = 3587,
  [5536] = 5399,
  [5537] = 2157,
  [5538] = 5399,
  [5539] = 2168,
  [5540] = 5399,
  [5541] = 3579,
  [5542] = 5399,
  [5543] = 2190,
  [5544] = 5399,
  [5545] = 2144,
  [5546] = 5399,
  [5547] = 5086,
  [5548] = 5399,
  [5549] = 5246,
  [5550] = 5550,
  [5551] = 5551,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(233);
      if (lookahead == '\r') SKIP(225);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '"') ADVANCE(328);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(243);
      if (lookahead == ')') ADVANCE(245);
      if (lookahead == '*') ADVANCE(241);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(352);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(291);
      if (lookahead == ';') ADVANCE(546);
      if (lookahead == '<') ADVANCE(385);
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '>') ADVANCE(389);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(294);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(454);
      if (lookahead == ']') ADVANCE(311);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '_') ADVANCE(299);
      if (lookahead == '{') ADVANCE(336);
      if (lookahead == '|') ADVANCE(478);
      if (lookahead == '}') ADVANCE(337);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x2190) ADVANCE(261);
      if (lookahead == 0x2192) ADVANCE(275);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21a6) ADVANCE(272);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2200) ADVANCE(264);
      if (lookahead == 0x2203) ADVANCE(267);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x225c) ADVANCE(255);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27e8) ADVANCE(278);
      if (lookahead == 0x27e9) ADVANCE(284);
      if (lookahead == 0x27f5) ADVANCE(260);
      if (lookahead == 0x27f6) ADVANCE(274);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x27fc) ADVANCE(271);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (lookahead == 0x3008) ADVANCE(277);
      if (lookahead == 0x3009) ADVANCE(282);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(318);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(536);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(225);
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(322);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(32);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(32);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == '(') ADVANCE(43);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(30);
      if (lookahead == '\r') ADVANCE(329);
      if (lookahead == '"') ADVANCE(331);
      if (lookahead == '(') ADVANCE(329);
      if (lookahead == '\\') ADVANCE(330);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(329);
      if (lookahead != 0) ADVANCE(329);
      END_STATE();
    case 4:
      if (lookahead == '\r') SKIP(4);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '"') ADVANCE(328);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == ')') ADVANCE(308);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(354);
      if (lookahead == '.') ADVANCE(54);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(57);
      if (lookahead == '<') ADVANCE(385);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(294);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(454);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '_') ADVANCE(299);
      if (lookahead == '{') ADVANCE(336);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '}') ADVANCE(337);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2200) ADVANCE(264);
      if (lookahead == 0x2203) ADVANCE(267);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27e8) ADVANCE(278);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (lookahead == 0x3008) ADVANCE(277);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(4);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(313);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 5:
      if (lookahead == '\r') SKIP(5);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '"') ADVANCE(328);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(353);
      if (lookahead == '.') ADVANCE(54);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(57);
      if (lookahead == '<') ADVANCE(385);
      if (lookahead == '=') ADVANCE(343);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(294);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(454);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '_') ADVANCE(224);
      if (lookahead == '{') ADVANCE(336);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2200) ADVANCE(264);
      if (lookahead == 0x2203) ADVANCE(267);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27e8) ADVANCE(278);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (lookahead == 0x3008) ADVANCE(277);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(5);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(313);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 6:
      if (lookahead == '\r') SKIP(6);
      if (lookahead == '"') ADVANCE(328);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == '-') ADVANCE(354);
      if (lookahead == '.') ADVANCE(54);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(57);
      if (lookahead == '<') ADVANCE(385);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(390);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(294);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(454);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '_') ADVANCE(224);
      if (lookahead == '{') ADVANCE(336);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2200) ADVANCE(264);
      if (lookahead == 0x2203) ADVANCE(267);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27e8) ADVANCE(278);
      if (lookahead == 0x27e9) ADVANCE(283);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (lookahead == 0x3008) ADVANCE(277);
      if (lookahead == 0x3009) ADVANCE(281);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(6);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(313);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 7:
      if (lookahead == '\r') SKIP(7);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == '-') ADVANCE(354);
      if (lookahead == '.') ADVANCE(53);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(292);
      if (lookahead == '<') ADVANCE(385);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(390);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(294);
      if (lookahead == '[') ADVANCE(71);
      if (lookahead == '\\') ADVANCE(455);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '_') ADVANCE(224);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27e8) ADVANCE(278);
      if (lookahead == 0x27e9) ADVANCE(283);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (lookahead == 0x3008) ADVANCE(277);
      if (lookahead == 0x3009) ADVANCE(281);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(7);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(314);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 8:
      if (lookahead == '\r') SKIP(8);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(353);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(387);
      if (lookahead == '=') ADVANCE(343);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(455);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(8);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 9:
      if (lookahead == '\r') SKIP(9);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == '-') ADVANCE(354);
      if (lookahead == '.') ADVANCE(53);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(57);
      if (lookahead == '<') ADVANCE(385);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(455);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '{') ADVANCE(336);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27e8) ADVANCE(278);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (lookahead == 0x3008) ADVANCE(277);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(9);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 10:
      if (lookahead == '\r') SKIP(10);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(354);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(387);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(455);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '}') ADVANCE(337);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(10);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 11:
      if (lookahead == '\r') SKIP(11);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == ')') ADVANCE(308);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(356);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(292);
      if (lookahead == ';') ADVANCE(546);
      if (lookahead == '<') ADVANCE(386);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(456);
      if (lookahead == ']') ADVANCE(311);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '{') ADVANCE(336);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '}') ADVANCE(337);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(11);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 12:
      if (lookahead == '\r') SKIP(12);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == '-') ADVANCE(356);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(386);
      if (lookahead == '=') ADVANCE(342);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(309);
      if (lookahead == '\\') ADVANCE(456);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x225c) ADVANCE(255);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(12);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 13:
      if (lookahead == '\r') SKIP(13);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == '-') ADVANCE(355);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(386);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(456);
      if (lookahead == ']') ADVANCE(72);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2192) ADVANCE(275);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27f6) ADVANCE(274);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(13);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 14:
      if (lookahead == '\r') SKIP(15);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(356);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(386);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(389);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(456);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '_') ADVANCE(298);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27e9) ADVANCE(284);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (lookahead == 0x3009) ADVANCE(282);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(319);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(15);
      END_STATE();
    case 15:
      if (lookahead == '\r') SKIP(15);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(356);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(386);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(389);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(456);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '_') ADVANCE(298);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27e9) ADVANCE(284);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (lookahead == 0x3009) ADVANCE(282);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(15);
      END_STATE();
    case 16:
      if (lookahead == '\r') SKIP(16);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(356);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(386);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(390);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(456);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27e9) ADVANCE(283);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (lookahead == 0x3009) ADVANCE(281);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(16);
      END_STATE();
    case 17:
      if (lookahead == '\r') SKIP(16);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(356);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(386);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(390);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(456);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27e9) ADVANCE(283);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (lookahead == 0x3009) ADVANCE(281);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(16);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(324);
      END_STATE();
    case 18:
      if (lookahead == '\r') SKIP(18);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(356);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(386);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(456);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '|') ADVANCE(478);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21a6) ADVANCE(272);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x27fc) ADVANCE(271);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(18);
      END_STATE();
    case 19:
      if (lookahead == '\r') SKIP(18);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(356);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(386);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(456);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '|') ADVANCE(478);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21a6) ADVANCE(272);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x27fc) ADVANCE(271);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(18);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(327);
      END_STATE();
    case 20:
      if (lookahead == '\r') SKIP(20);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == '-') ADVANCE(353);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(387);
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(455);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x225c) ADVANCE(255);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 21:
      if (lookahead == '\r') SKIP(21);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == ')') ADVANCE(308);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(356);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(291);
      if (lookahead == ';') ADVANCE(546);
      if (lookahead == '<') ADVANCE(386);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(456);
      if (lookahead == ']') ADVANCE(311);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '{') ADVANCE(336);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '}') ADVANCE(337);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 22:
      if (lookahead == '\r') SKIP(22);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(355);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(291);
      if (lookahead == '<') ADVANCE(386);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(309);
      if (lookahead == '\\') ADVANCE(456);
      if (lookahead == ']') ADVANCE(72);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '|') ADVANCE(478);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2192) ADVANCE(275);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21a6) ADVANCE(272);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27f6) ADVANCE(274);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x27fc) ADVANCE(271);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 23:
      if (lookahead == '\r') SKIP(24);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '(') ADVANCE(306);
      if (lookahead == '*') ADVANCE(543);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(51);
      if (lookahead == ':') ADVANCE(56);
      if (lookahead == '<') ADVANCE(63);
      if (lookahead == '=') ADVANCE(62);
      if (lookahead == '[') ADVANCE(71);
      if (lookahead == '\\') ADVANCE(42);
      if (lookahead == '_') ADVANCE(224);
      if (lookahead == '~') ADVANCE(348);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(24);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(544);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 24:
      if (lookahead == '\r') SKIP(24);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '(') ADVANCE(306);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(51);
      if (lookahead == ':') ADVANCE(56);
      if (lookahead == '<') ADVANCE(63);
      if (lookahead == '=') ADVANCE(62);
      if (lookahead == '[') ADVANCE(71);
      if (lookahead == '\\') ADVANCE(42);
      if (lookahead == '~') ADVANCE(348);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 25:
      if (lookahead == '\r') SKIP(25);
      if (lookahead == '(') ADVANCE(38);
      if (lookahead == ')') ADVANCE(308);
      if (lookahead == '+') ADVANCE(467);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(351);
      if (lookahead == '.') ADVANCE(338);
      if (lookahead == ';') ADVANCE(546);
      if (lookahead == '<') ADVANCE(384);
      if (lookahead == '=') ADVANCE(340);
      if (lookahead == '[') ADVANCE(309);
      if (lookahead == '\\') ADVANCE(40);
      if (lookahead == '{') ADVANCE(336);
      if (lookahead == 0x2208) ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(25);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 26:
      if (lookahead == '\r') ADVANCE(238);
      if (lookahead == '(') ADVANCE(244);
      if (lookahead == ')') ADVANCE(246);
      if (lookahead == '*') ADVANCE(242);
      if (lookahead == '-') ADVANCE(240);
      if (lookahead == ';') ADVANCE(239);
      if (lookahead == '\\') ADVANCE(239);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(238);
      if (lookahead != 0) ADVANCE(239);
      END_STATE();
    case 27:
      if (lookahead == '\r') SKIP(27);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '(') ADVANCE(306);
      if (lookahead == ')') ADVANCE(308);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '\\') ADVANCE(39);
      if (lookahead == '_') ADVANCE(298);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(27);
      END_STATE();
    case 28:
      if (lookahead == '\r') SKIP(27);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '(') ADVANCE(306);
      if (lookahead == ')') ADVANCE(308);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '\\') ADVANCE(39);
      if (lookahead == '_') ADVANCE(298);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(27);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(324);
      END_STATE();
    case 29:
      if (lookahead == '\r') SKIP(30);
      if (lookahead == '(') ADVANCE(38);
      if (lookahead == '\\') ADVANCE(39);
      if (lookahead == '*' ||
          lookahead == '+') ADVANCE(535);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(30);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(537);
      END_STATE();
    case 30:
      if (lookahead == '\r') SKIP(30);
      if (lookahead == '(') ADVANCE(38);
      if (lookahead == '\\') ADVANCE(39);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(30);
      END_STATE();
    case 31:
      if (lookahead == '\r') SKIP(30);
      if (lookahead == '(') ADVANCE(38);
      if (lookahead == '\\') ADVANCE(39);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(30);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '|') ADVANCE(545);
      END_STATE();
    case 32:
      if (lookahead == '(') ADVANCE(43);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(32);
      END_STATE();
    case 33:
      if (lookahead == ')') ADVANCE(471);
      END_STATE();
    case 34:
      if (lookahead == ')') ADVANCE(474);
      END_STATE();
    case 35:
      if (lookahead == ')') ADVANCE(487);
      END_STATE();
    case 36:
      if (lookahead == ')') ADVANCE(490);
      END_STATE();
    case 37:
      if (lookahead == ')') ADVANCE(493);
      END_STATE();
    case 38:
      if (lookahead == '*') ADVANCE(235);
      END_STATE();
    case 39:
      if (lookahead == '*') ADVANCE(234);
      END_STATE();
    case 40:
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(142);
      END_STATE();
    case 41:
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(142);
      if (lookahead == 'l') ADVANCE(145);
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 42:
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(145);
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 43:
      if (lookahead == '*') ADVANCE(237);
      END_STATE();
    case 44:
      if (lookahead == '-') ADVANCE(66);
      END_STATE();
    case 45:
      if (lookahead == '-') ADVANCE(247);
      END_STATE();
    case 46:
      if (lookahead == '-') ADVANCE(50);
      if (lookahead == '.') ADVANCE(357);
      END_STATE();
    case 47:
      if (lookahead == '-') ADVANCE(259);
      if (lookahead == '<') ADVANCE(276);
      if (lookahead == '>') ADVANCE(358);
      END_STATE();
    case 48:
      if (lookahead == '-') ADVANCE(259);
      if (lookahead == '>') ADVANCE(358);
      END_STATE();
    case 49:
      if (lookahead == '-') ADVANCE(45);
      END_STATE();
    case 50:
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == 'a') ADVANCE(128);
      if (lookahead == 'f') ADVANCE(81);
      END_STATE();
    case 51:
      if (lookahead == '-') ADVANCE(49);
      if (lookahead == '.') ADVANCE(357);
      END_STATE();
    case 52:
      if (lookahead == '-') ADVANCE(65);
      if (lookahead == '|') ADVANCE(480);
      END_STATE();
    case 53:
      if (lookahead == '.') ADVANCE(463);
      END_STATE();
    case 54:
      if (lookahead == '.') ADVANCE(463);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(315);
      END_STATE();
    case 55:
      if (lookahead == ':') ADVANCE(296);
      if (lookahead == '=') ADVANCE(377);
      if (lookahead == '>') ADVANCE(452);
      END_STATE();
    case 56:
      if (lookahead == ':') ADVANCE(295);
      END_STATE();
    case 57:
      if (lookahead == ':') ADVANCE(58);
      if (lookahead == '=') ADVANCE(377);
      if (lookahead == '>') ADVANCE(452);
      END_STATE();
    case 58:
      if (lookahead == '=') ADVANCE(379);
      END_STATE();
    case 59:
      if (lookahead == '=') ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == '=') ADVANCE(250);
      END_STATE();
    case 61:
      if (lookahead == '=') ADVANCE(253);
      END_STATE();
    case 62:
      if (lookahead == '=') ADVANCE(59);
      END_STATE();
    case 63:
      if (lookahead == '>') ADVANCE(358);
      END_STATE();
    case 64:
      if (lookahead == '>') ADVANCE(372);
      END_STATE();
    case 65:
      if (lookahead == '>') ADVANCE(270);
      END_STATE();
    case 66:
      if (lookahead == '>') ADVANCE(364);
      END_STATE();
    case 67:
      if (lookahead == '>') ADVANCE(279);
      END_STATE();
    case 68:
      if (lookahead == '?') ADVANCE(513);
      END_STATE();
    case 69:
      if (lookahead == '@') ADVANCE(451);
      END_STATE();
    case 70:
      if (lookahead == 'X') ADVANCE(37);
      END_STATE();
    case 71:
      if (lookahead == ']') ADVANCE(288);
      END_STATE();
    case 72:
      if (lookahead == '_') ADVANCE(345);
      END_STATE();
    case 73:
      if (lookahead == 'a') ADVANCE(157);
      if (lookahead == 'd') ADVANCE(150);
      if (lookahead == 'i') ADVANCE(182);
      if (lookahead == 'o') ADVANCE(143);
      if (lookahead == 'u') ADVANCE(158);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(139);
      if (lookahead == 'e') ADVANCE(167);
      if (lookahead == 'l') ADVANCE(417);
      if (lookahead == 'n') ADVANCE(152);
      if (lookahead == 'o') ADVANCE(177);
      END_STATE();
    case 75:
      if (lookahead == 'a') ADVANCE(139);
      if (lookahead == 'e') ADVANCE(167);
      if (lookahead == 'l') ADVANCE(417);
      if (lookahead == 'o') ADVANCE(177);
      END_STATE();
    case 76:
      if (lookahead == 'a') ADVANCE(188);
      END_STATE();
    case 77:
      if (lookahead == 'a') ADVANCE(160);
      if (lookahead == 'u') ADVANCE(161);
      END_STATE();
    case 78:
      if (lookahead == 'a') ADVANCE(128);
      if (lookahead == 'f') ADVANCE(81);
      END_STATE();
    case 79:
      if (lookahead == 'a') ADVANCE(178);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(131);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(122);
      END_STATE();
    case 82:
      if (lookahead == 'b') ADVANCE(196);
      if (lookahead == 'c') ADVANCE(87);
      if (lookahead == 'p') ADVANCE(197);
      END_STATE();
    case 83:
      if (lookahead == 'b') ADVANCE(198);
      if (lookahead == 'p') ADVANCE(199);
      END_STATE();
    case 84:
      if (lookahead == 'c') ADVANCE(77);
      if (lookahead == 's') ADVANCE(214);
      END_STATE();
    case 85:
      if (lookahead == 'c') ADVANCE(505);
      END_STATE();
    case 86:
      if (lookahead == 'c') ADVANCE(421);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(423);
      END_STATE();
    case 88:
      if (lookahead == 'c') ADVANCE(499);
      END_STATE();
    case 89:
      if (lookahead == 'c') ADVANCE(121);
      END_STATE();
    case 90:
      if (lookahead == 'c') ADVANCE(209);
      END_STATE();
    case 91:
      if (lookahead == 'd') ADVANCE(375);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(166);
      if (lookahead == 'g') ADVANCE(415);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(213);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(168);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(86);
      if (lookahead == 'o') ADVANCE(163);
      END_STATE();
    case 97:
      if (lookahead == 'e') ADVANCE(189);
      END_STATE();
    case 98:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(193);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(206);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(207);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 106:
      if (lookahead == 'g') ADVANCE(89);
      END_STATE();
    case 107:
      if (lookahead == 'g') ADVANCE(347);
      END_STATE();
    case 108:
      if (lookahead == 'g') ADVANCE(411);
      END_STATE();
    case 109:
      if (lookahead == 'g') ADVANCE(155);
      END_STATE();
    case 110:
      if (lookahead == 'h') ADVANCE(489);
      END_STATE();
    case 111:
      if (lookahead == 'h') ADVANCE(134);
      END_STATE();
    case 112:
      if (lookahead == 'i') ADVANCE(106);
      if (lookahead == 'u') ADVANCE(129);
      END_STATE();
    case 113:
      if (lookahead == 'i') ADVANCE(219);
      if (lookahead == 'o') ADVANCE(200);
      END_STATE();
    case 114:
      if (lookahead == 'i') ADVANCE(133);
      if (lookahead == 'q') ADVANCE(84);
      if (lookahead == 't') ADVANCE(79);
      if (lookahead == 'u') ADVANCE(82);
      END_STATE();
    case 115:
      if (lookahead == 'i') ADVANCE(195);
      END_STATE();
    case 116:
      if (lookahead == 'i') ADVANCE(220);
      END_STATE();
    case 117:
      if (lookahead == 'i') ADVANCE(135);
      END_STATE();
    case 118:
      if (lookahead == 'i') ADVANCE(154);
      END_STATE();
    case 119:
      if (lookahead == 'i') ADVANCE(146);
      END_STATE();
    case 120:
      if (lookahead == 'i') ADVANCE(140);
      END_STATE();
    case 121:
      if (lookahead == 'i') ADVANCE(184);
      END_STATE();
    case 122:
      if (lookahead == 'i') ADVANCE(179);
      END_STATE();
    case 123:
      if (lookahead == 'i') ADVANCE(210);
      END_STATE();
    case 124:
      if (lookahead == 'i') ADVANCE(137);
      END_STATE();
    case 125:
      if (lookahead == 'l') ADVANCE(263);
      END_STATE();
    case 126:
      if (lookahead == 'l') ADVANCE(215);
      END_STATE();
    case 127:
      if (lookahead == 'l') ADVANCE(76);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(109);
      END_STATE();
    case 129:
      if (lookahead == 'l') ADVANCE(130);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(100);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(125);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(217);
      END_STATE();
    case 133:
      if (lookahead == 'm') ADVANCE(431);
      END_STATE();
    case 134:
      if (lookahead == 'm') ADVANCE(547);
      END_STATE();
    case 135:
      if (lookahead == 'm') ADVANCE(97);
      END_STATE();
    case 136:
      if (lookahead == 'm') ADVANCE(159);
      END_STATE();
    case 137:
      if (lookahead == 'm') ADVANCE(102);
      END_STATE();
    case 138:
      if (lookahead == 'n') ADVANCE(257);
      END_STATE();
    case 139:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 140:
      if (lookahead == 'n') ADVANCE(419);
      END_STATE();
    case 141:
      if (lookahead == 'n') ADVANCE(461);
      END_STATE();
    case 142:
      if (lookahead == 'n') ADVANCE(256);
      END_STATE();
    case 143:
      if (lookahead == 'n') ADVANCE(108);
      END_STATE();
    case 144:
      if (lookahead == 'n') ADVANCE(118);
      if (lookahead == 'p') ADVANCE(132);
      END_STATE();
    case 145:
      if (lookahead == 'n') ADVANCE(152);
      END_STATE();
    case 146:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 147:
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 148:
      if (lookahead == 'o') ADVANCE(429);
      END_STATE();
    case 149:
      if (lookahead == 'o') ADVANCE(213);
      END_STATE();
    case 150:
      if (lookahead == 'o') ADVANCE(201);
      END_STATE();
    case 151:
      if (lookahead == 'o') ADVANCE(181);
      END_STATE();
    case 152:
      if (lookahead == 'o') ADVANCE(202);
      END_STATE();
    case 153:
      if (lookahead == 'o') ADVANCE(203);
      END_STATE();
    case 154:
      if (lookahead == 'o') ADVANCE(141);
      END_STATE();
    case 155:
      if (lookahead == 'o') ADVANCE(185);
      END_STATE();
    case 156:
      if (lookahead == 'p') ADVANCE(162);
      if (lookahead == 's') ADVANCE(222);
      END_STATE();
    case 157:
      if (lookahead == 'p') ADVANCE(457);
      END_STATE();
    case 158:
      if (lookahead == 'p') ADVANCE(460);
      END_STATE();
    case 159:
      if (lookahead == 'p') ADVANCE(409);
      END_STATE();
    case 160:
      if (lookahead == 'p') ADVANCE(515);
      END_STATE();
    case 161:
      if (lookahead == 'p') ADVANCE(517);
      END_STATE();
    case 162:
      if (lookahead == 'p') ADVANCE(183);
      END_STATE();
    case 163:
      if (lookahead == 'p') ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'q') ADVANCE(216);
      END_STATE();
    case 165:
      if (lookahead == 'q') ADVANCE(216);
      if (lookahead == 'x') ADVANCE(115);
      END_STATE();
    case 166:
      if (lookahead == 'q') ADVANCE(396);
      END_STATE();
    case 167:
      if (lookahead == 'q') ADVANCE(393);
      END_STATE();
    case 168:
      if (lookahead == 'q') ADVANCE(413);
      END_STATE();
    case 169:
      if (lookahead == 'q') ADVANCE(433);
      END_STATE();
    case 170:
      if (lookahead == 'q') ADVANCE(425);
      END_STATE();
    case 171:
      if (lookahead == 'q') ADVANCE(427);
      END_STATE();
    case 172:
      if (lookahead == 'q') ADVANCE(447);
      END_STATE();
    case 173:
      if (lookahead == 'q') ADVANCE(449);
      END_STATE();
    case 174:
      if (lookahead == 'q') ADVANCE(439);
      END_STATE();
    case 175:
      if (lookahead == 'q') ADVANCE(441);
      END_STATE();
    case 176:
      if (lookahead == 'r') ADVANCE(524);
      END_STATE();
    case 177:
      if (lookahead == 'r') ADVANCE(376);
      END_STATE();
    case 178:
      if (lookahead == 'r') ADVANCE(507);
      END_STATE();
    case 179:
      if (lookahead == 'r') ADVANCE(548);
      END_STATE();
    case 180:
      if (lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 181:
      if (lookahead == 'r') ADVANCE(80);
      END_STATE();
    case 182:
      if (lookahead == 'r') ADVANCE(85);
      END_STATE();
    case 183:
      if (lookahead == 'r') ADVANCE(147);
      END_STATE();
    case 184:
      if (lookahead == 'r') ADVANCE(88);
      END_STATE();
    case 185:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 186:
      if (lookahead == 'r') ADVANCE(194);
      END_STATE();
    case 187:
      if (lookahead == 's') ADVANCE(470);
      END_STATE();
    case 188:
      if (lookahead == 's') ADVANCE(110);
      END_STATE();
    case 189:
      if (lookahead == 's') ADVANCE(522);
      END_STATE();
    case 190:
      if (lookahead == 's') ADVANCE(519);
      END_STATE();
    case 191:
      if (lookahead == 's') ADVANCE(266);
      END_STATE();
    case 192:
      if (lookahead == 's') ADVANCE(473);
      END_STATE();
    case 193:
      if (lookahead == 's') ADVANCE(492);
      END_STATE();
    case 194:
      if (lookahead == 's') ADVANCE(98);
      END_STATE();
    case 195:
      if (lookahead == 's') ADVANCE(212);
      END_STATE();
    case 196:
      if (lookahead == 's') ADVANCE(101);
      END_STATE();
    case 197:
      if (lookahead == 's') ADVANCE(103);
      END_STATE();
    case 198:
      if (lookahead == 's') ADVANCE(104);
      END_STATE();
    case 199:
      if (lookahead == 's') ADVANCE(105);
      END_STATE();
    case 200:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 201:
      if (lookahead == 't') ADVANCE(526);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(346);
      END_STATE();
    case 203:
      if (lookahead == 't') ADVANCE(486);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(501);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(443);
      END_STATE();
    case 206:
      if (lookahead == 't') ADVANCE(445);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(435);
      END_STATE();
    case 208:
      if (lookahead == 't') ADVANCE(437);
      END_STATE();
    case 209:
      if (lookahead == 't') ADVANCE(458);
      END_STATE();
    case 210:
      if (lookahead == 't') ADVANCE(111);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 212:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 213:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 214:
      if (lookahead == 'u') ADVANCE(83);
      END_STATE();
    case 215:
      if (lookahead == 'u') ADVANCE(187);
      END_STATE();
    case 216:
      if (lookahead == 'u') ADVANCE(116);
      END_STATE();
    case 217:
      if (lookahead == 'u') ADVANCE(190);
      END_STATE();
    case 218:
      if (lookahead == 'u') ADVANCE(192);
      END_STATE();
    case 219:
      if (lookahead == 'v') ADVANCE(503);
      END_STATE();
    case 220:
      if (lookahead == 'v') ADVANCE(367);
      END_STATE();
    case 221:
      if (lookahead == 'x') ADVANCE(398);
      END_STATE();
    case 222:
      if (lookahead == 'y') ADVANCE(136);
      END_STATE();
    case 223:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(315);
      END_STATE();
    case 224:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 225:
      if (eof) ADVANCE(233);
      if (lookahead == '\r') SKIP(225);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '"') ADVANCE(328);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(243);
      if (lookahead == ')') ADVANCE(245);
      if (lookahead == '*') ADVANCE(241);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(352);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(291);
      if (lookahead == ';') ADVANCE(546);
      if (lookahead == '<') ADVANCE(385);
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '>') ADVANCE(389);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(294);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(454);
      if (lookahead == ']') ADVANCE(311);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '_') ADVANCE(299);
      if (lookahead == '{') ADVANCE(336);
      if (lookahead == '|') ADVANCE(478);
      if (lookahead == '}') ADVANCE(337);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x2190) ADVANCE(261);
      if (lookahead == 0x2192) ADVANCE(275);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21a6) ADVANCE(272);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2200) ADVANCE(264);
      if (lookahead == 0x2203) ADVANCE(267);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x225c) ADVANCE(255);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27e8) ADVANCE(278);
      if (lookahead == 0x27e9) ADVANCE(284);
      if (lookahead == 0x27f5) ADVANCE(260);
      if (lookahead == 0x27f6) ADVANCE(274);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x27fc) ADVANCE(271);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (lookahead == 0x3008) ADVANCE(277);
      if (lookahead == 0x3009) ADVANCE(282);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(225);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(314);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 226:
      if (eof) ADVANCE(233);
      if (lookahead == '\r') SKIP(227);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '(') ADVANCE(306);
      if (lookahead == ')') ADVANCE(308);
      if (lookahead == '+') ADVANCE(467);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == ':') ADVANCE(290);
      if (lookahead == ';') ADVANCE(546);
      if (lookahead == '<') ADVANCE(47);
      if (lookahead == '=') ADVANCE(62);
      if (lookahead == '>') ADVANCE(67);
      if (lookahead == '[') ADVANCE(71);
      if (lookahead == '\\') ADVANCE(41);
      if (lookahead == ']') ADVANCE(311);
      if (lookahead == '_') ADVANCE(299);
      if (lookahead == '{') ADVANCE(336);
      if (lookahead == '|') ADVANCE(52);
      if (lookahead == '}') ADVANCE(337);
      if (lookahead == '~') ADVANCE(348);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x2190) ADVANCE(261);
      if (lookahead == 0x21a6) ADVANCE(272);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x27e8) ADVANCE(278);
      if (lookahead == 0x27e9) ADVANCE(283);
      if (lookahead == 0x27f5) ADVANCE(260);
      if (lookahead == 0x27fc) ADVANCE(271);
      if (lookahead == 0x3008) ADVANCE(277);
      if (lookahead == 0x3009) ADVANCE(281);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(224);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(227);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(323);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 227:
      if (eof) ADVANCE(233);
      if (lookahead == '\r') SKIP(227);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '(') ADVANCE(306);
      if (lookahead == ')') ADVANCE(308);
      if (lookahead == '+') ADVANCE(467);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == ':') ADVANCE(290);
      if (lookahead == ';') ADVANCE(546);
      if (lookahead == '<') ADVANCE(47);
      if (lookahead == '=') ADVANCE(62);
      if (lookahead == '>') ADVANCE(67);
      if (lookahead == '[') ADVANCE(71);
      if (lookahead == '\\') ADVANCE(41);
      if (lookahead == ']') ADVANCE(311);
      if (lookahead == '_') ADVANCE(299);
      if (lookahead == '{') ADVANCE(336);
      if (lookahead == '|') ADVANCE(52);
      if (lookahead == '}') ADVANCE(337);
      if (lookahead == '~') ADVANCE(348);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x2190) ADVANCE(261);
      if (lookahead == 0x21a6) ADVANCE(272);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x27e8) ADVANCE(278);
      if (lookahead == 0x27e9) ADVANCE(283);
      if (lookahead == 0x27f5) ADVANCE(260);
      if (lookahead == 0x27fc) ADVANCE(271);
      if (lookahead == 0x3008) ADVANCE(277);
      if (lookahead == 0x3009) ADVANCE(281);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(227);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 228:
      if (eof) ADVANCE(233);
      if (lookahead == '\r') SKIP(228);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '"') ADVANCE(328);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(353);
      if (lookahead == '.') ADVANCE(54);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(57);
      if (lookahead == '<') ADVANCE(385);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(294);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(454);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '_') ADVANCE(224);
      if (lookahead == '{') ADVANCE(336);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2200) ADVANCE(264);
      if (lookahead == 0x2203) ADVANCE(267);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27e8) ADVANCE(278);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (lookahead == 0x3008) ADVANCE(277);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(228);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(313);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 229:
      if (eof) ADVANCE(233);
      if (lookahead == '\r') SKIP(229);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(353);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(387);
      if (lookahead == '=') ADVANCE(344);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(455);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(229);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 230:
      if (eof) ADVANCE(233);
      if (lookahead == '\r') SKIP(230);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '#') ADVANCE(382);
      if (lookahead == '$') ADVANCE(511);
      if (lookahead == '%') ADVANCE(476);
      if (lookahead == '&') ADVANCE(484);
      if (lookahead == '\'') ADVANCE(534);
      if (lookahead == '(') ADVANCE(307);
      if (lookahead == '*') ADVANCE(495);
      if (lookahead == '+') ADVANCE(468);
      if (lookahead == '-') ADVANCE(353);
      if (lookahead == '.') ADVANCE(339);
      if (lookahead == '/') ADVANCE(497);
      if (lookahead == ':') ADVANCE(55);
      if (lookahead == '<') ADVANCE(387);
      if (lookahead == '=') ADVANCE(342);
      if (lookahead == '>') ADVANCE(388);
      if (lookahead == '?') ADVANCE(68);
      if (lookahead == '@') ADVANCE(69);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(455);
      if (lookahead == '^') ADVANCE(528);
      if (lookahead == '|') ADVANCE(479);
      if (lookahead == '~') ADVANCE(349);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0xd7) ADVANCE(523);
      if (lookahead == 0xf7) ADVANCE(504);
      if (lookahead == 0x2016) ADVANCE(481);
      if (lookahead == 0x2025) ADVANCE(464);
      if (lookahead == 0x2026) ADVANCE(466);
      if (lookahead == 0x203c) ADVANCE(509);
      if (lookahead == 0x2047) ADVANCE(514);
      if (lookahead == 0x207a) ADVANCE(531);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x219d) ADVANCE(374);
      if (lookahead == 0x21d2) ADVANCE(363);
      if (lookahead == 0x21d4) ADVANCE(371);
      if (lookahead == 0x21dd) ADVANCE(373);
      if (lookahead == 0x21f8) ADVANCE(365);
      if (lookahead == 0x2208) ADVANCE(258);
      if (lookahead == 0x2209) ADVANCE(420);
      if (lookahead == 0x2218) ADVANCE(506);
      if (lookahead == 0x221d) ADVANCE(430);
      if (lookahead == 0x2227) ADVANCE(301);
      if (lookahead == 0x2228) ADVANCE(303);
      if (lookahead == 0x2229) ADVANCE(459);
      if (lookahead == 0x222a) ADVANCE(462);
      if (lookahead == 0x2237) ADVANCE(297);
      if (lookahead == 0x223c) ADVANCE(432);
      if (lookahead == 0x2240) ADVANCE(525);
      if (lookahead == 0x2243) ADVANCE(434);
      if (lookahead == 0x2245) ADVANCE(412);
      if (lookahead == 0x2248) ADVANCE(399);
      if (lookahead == 0x224d) ADVANCE(410);
      if (lookahead == 0x2250) ADVANCE(414);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x225c) ADVANCE(255);
      if (lookahead == 0x2260) ADVANCE(383);
      if (lookahead == 0x2261) ADVANCE(368);
      if (lookahead == 0x2264) ADVANCE(394);
      if (lookahead == 0x2265) ADVANCE(397);
      if (lookahead == 0x226a) ADVANCE(418);
      if (lookahead == 0x226b) ADVANCE(416);
      if (lookahead == 0x227a) ADVANCE(422);
      if (lookahead == 0x227b) ADVANCE(424);
      if (lookahead == 0x2282) ADVANCE(444);
      if (lookahead == 0x2283) ADVANCE(446);
      if (lookahead == 0x2286) ADVANCE(448);
      if (lookahead == 0x2287) ADVANCE(450);
      if (lookahead == 0x228e) ADVANCE(520);
      if (lookahead == 0x228f) ADVANCE(436);
      if (lookahead == 0x2290) ADVANCE(438);
      if (lookahead == 0x2291) ADVANCE(440);
      if (lookahead == 0x2292) ADVANCE(442);
      if (lookahead == 0x2293) ADVANCE(516);
      if (lookahead == 0x2294) ADVANCE(518);
      if (lookahead == 0x2295) ADVANCE(472);
      if (lookahead == 0x2296) ADVANCE(475);
      if (lookahead == 0x2297) ADVANCE(494);
      if (lookahead == 0x2298) ADVANCE(491);
      if (lookahead == 0x2299) ADVANCE(488);
      if (lookahead == 0x22a2) ADVANCE(402);
      if (lookahead == 0x22a3) ADVANCE(406);
      if (lookahead == 0x22a8) ADVANCE(404);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x22c5) ADVANCE(527);
      if (lookahead == 0x22c6) ADVANCE(508);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x25cf) ADVANCE(502);
      if (lookahead == 0x25ef) ADVANCE(500);
      if (lookahead == 0x27f9) ADVANCE(362);
      if (lookahead == 0x27fa) ADVANCE(370);
      if (lookahead == 0x2945) ADVANCE(366);
      if (lookahead == 0x2a74) ADVANCE(380);
      if (lookahead == 0x2aaf) ADVANCE(426);
      if (lookahead == 0x2ab0) ADVANCE(428);
      if (lookahead == 0x2ae4) ADVANCE(408);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(230);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 231:
      if (eof) ADVANCE(233);
      if (lookahead == '\r') SKIP(232);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '(') ADVANCE(306);
      if (lookahead == ')') ADVANCE(308);
      if (lookahead == '*') ADVANCE(543);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(51);
      if (lookahead == '.') ADVANCE(338);
      if (lookahead == ':') ADVANCE(293);
      if (lookahead == '<') ADVANCE(48);
      if (lookahead == '=') ADVANCE(61);
      if (lookahead == '>') ADVANCE(538);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(42);
      if (lookahead == '_') ADVANCE(224);
      if (lookahead == '}') ADVANCE(337);
      if (lookahead == '~') ADVANCE(348);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x2190) ADVANCE(261);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x225c) ADVANCE(255);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x27f5) ADVANCE(260);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(232);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(544);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 232:
      if (eof) ADVANCE(233);
      if (lookahead == '\r') SKIP(232);
      if (lookahead == '!') ADVANCE(312);
      if (lookahead == '(') ADVANCE(306);
      if (lookahead == ')') ADVANCE(308);
      if (lookahead == ',') ADVANCE(305);
      if (lookahead == '-') ADVANCE(51);
      if (lookahead == '.') ADVANCE(338);
      if (lookahead == ':') ADVANCE(293);
      if (lookahead == '<') ADVANCE(48);
      if (lookahead == '=') ADVANCE(61);
      if (lookahead == '[') ADVANCE(310);
      if (lookahead == '\\') ADVANCE(42);
      if (lookahead == '}') ADVANCE(337);
      if (lookahead == '~') ADVANCE(348);
      if (lookahead == 0xac) ADVANCE(350);
      if (lookahead == 0x2115) ADVANCE(333);
      if (lookahead == 0x211d) ADVANCE(335);
      if (lookahead == 0x2124) ADVANCE(334);
      if (lookahead == 0x2190) ADVANCE(261);
      if (lookahead == 0x2254) ADVANCE(378);
      if (lookahead == 0x225c) ADVANCE(255);
      if (lookahead == 0x22c4) ADVANCE(359);
      if (lookahead == 0x25a1) ADVANCE(289);
      if (lookahead == 0x25c7) ADVANCE(360);
      if (lookahead == 0x27f5) ADVANCE(260);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(232);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(234);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_LPAREN_STAR);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_STAR_RPAREN);
      if (lookahead == '\n') ADVANCE(32);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == '(') ADVANCE(43);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(aux_sym_block_comment_text_token1);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym_block_comment_text_token1);
      if (lookahead == '\r') ADVANCE(238);
      if (lookahead == '(') ADVANCE(244);
      if (lookahead == ')') ADVANCE(239);
      if (lookahead == '*') ADVANCE(242);
      if (lookahead == '-') ADVANCE(240);
      if (lookahead == ';') ADVANCE(239);
      if (lookahead == '\\') ADVANCE(239);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(238);
      if (lookahead != 0) ADVANCE(239);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(aux_sym_block_comment_text_token1);
      if (lookahead == ')') ADVANCE(237);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(aux_sym_block_comment_text_token1);
      if (lookahead == ')') ADVANCE(237);
      if (lookahead == '-') ADVANCE(78);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(aux_sym_block_comment_text_token2);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(aux_sym_block_comment_text_token2);
      if (lookahead == ')') ADVANCE(236);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(aux_sym_block_comment_text_token3);
      if (lookahead == '*') ADVANCE(235);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(aux_sym_block_comment_text_token3);
      if (lookahead == '*') ADVANCE(235);
      if (lookahead != 0 &&
          lookahead != '(') ADVANCE(237);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(aux_sym_block_comment_text_token4);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(aux_sym_block_comment_text_token4);
      if (lookahead == ')') ADVANCE(237);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_DASH_DASH_DASH_DASH);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(aux_sym_single_line_token1);
      if (lookahead == '(') ADVANCE(38);
      if (lookahead == '-') ADVANCE(249);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(aux_sym_single_line_token1);
      if (lookahead == '-') ADVANCE(249);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ_EQ);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(aux_sym_double_line_token1);
      if (lookahead == '(') ADVANCE(38);
      if (lookahead == '=') ADVANCE(252);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(aux_sym_double_line_token1);
      if (lookahead == '=') ADVANCE(252);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(60);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_u225c);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_BSLASHin);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_BSLASHin);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_u2208);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_u27f5);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_u2190);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_BSLASHA);
      if (lookahead == 'A') ADVANCE(268);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_BSLASHforall);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_u2200);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_BSLASHE);
      if (lookahead == 'E') ADVANCE(269);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_BSLASHexists);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_u2203);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_temporal_forall);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_temporal_exists);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_PIPE_DASH_GT);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_u27fc);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_u21a6);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_u27f6);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_u2192);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_u3008);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_u27e8);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '_') ADVANCE(285);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_u3009);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_u3009);
      if (lookahead == '_') ADVANCE(286);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_u27e9);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_u27e9);
      if (lookahead == '_') ADVANCE(287);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_GT_GT_);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_u3009_);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_u27e9_);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_u25a1);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(296);
      if (lookahead == '=') ADVANCE(377);
      if (lookahead == '>') ADVANCE(452);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(58);
      if (lookahead == '=') ADVANCE(377);
      if (lookahead == '>') ADVANCE(452);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(377);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '@') ADVANCE(451);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      if (lookahead == '=') ADVANCE(379);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_u2237);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_placeholder);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(sym_placeholder);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_SLASH_BSLASH);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_u2227);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_BSLASH_SLASH);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_u2228);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '*') ADVANCE(235);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '*') ADVANCE(235);
      if (lookahead == '+') ADVANCE(33);
      if (lookahead == '-') ADVANCE(34);
      if (lookahead == '.') ADVANCE(35);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == '\\') ADVANCE(70);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(288);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(aux_sym_child_id_token1);
      if (lookahead == '.') ADVANCE(223);
      if (lookahead == '_') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(313);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(aux_sym_child_id_token1);
      if (lookahead == '_') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(314);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_real_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(315);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_BSLASHb);
      if (lookahead == 'i') ADVANCE(106);
      if (lookahead == 'u') ADVANCE(129);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(anon_sym_BSLASHB);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(aux_sym_binary_number_token1);
      if (lookahead == '_') ADVANCE(224);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(318);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(536);
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(322);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(aux_sym_binary_number_token1);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(319);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_BSLASHo);
      if (lookahead == 'd') ADVANCE(153);
      if (lookahead == 'm') ADVANCE(119);
      if (lookahead == 'p') ADVANCE(126);
      if (lookahead == 's') ADVANCE(127);
      if (lookahead == 't') ADVANCE(124);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_BSLASHO);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(aux_sym_octal_number_token1);
      if (lookahead == '_') ADVANCE(224);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(536);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(322);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(aux_sym_octal_number_token1);
      if (lookahead == '8' ||
          lookahead == '9' ||
          lookahead == '_') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(323);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(aux_sym_octal_number_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(324);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_BSLASHh);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_BSLASHH);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(aux_sym_hex_number_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(327);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(332);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(332);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym_escape_char);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_u2115);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_u2124);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_u211d);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(463);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '<') ADVANCE(392);
      if (lookahead == '=') ADVANCE(254);
      if (lookahead == '>') ADVANCE(361);
      if (lookahead == '|') ADVANCE(407);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '<') ADVANCE(392);
      if (lookahead == '=') ADVANCE(253);
      if (lookahead == '>') ADVANCE(361);
      if (lookahead == '|') ADVANCE(407);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '<') ADVANCE(392);
      if (lookahead == '=') ADVANCE(59);
      if (lookahead == '>') ADVANCE(361);
      if (lookahead == '|') ADVANCE(407);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '<') ADVANCE(392);
      if (lookahead == '>') ADVANCE(361);
      if (lookahead == '|') ADVANCE(407);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_RBRACK_);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_BSLASHlnot);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_BSLASHneg);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '>') ADVANCE(372);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_u00ac);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '+') ADVANCE(44);
      if (lookahead == '-') ADVANCE(483);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '>') ADVANCE(273);
      if (lookahead == '|') ADVANCE(405);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '+') ADVANCE(44);
      if (lookahead == '-') ADVANCE(483);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '|') ADVANCE(405);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '+') ADVANCE(44);
      if (lookahead == '-') ADVANCE(482);
      if (lookahead == '.') ADVANCE(357);
      if (lookahead == '|') ADVANCE(405);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '+') ADVANCE(44);
      if (lookahead == '-') ADVANCE(482);
      if (lookahead == '>') ADVANCE(273);
      if (lookahead == '|') ADVANCE(405);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '+') ADVANCE(44);
      if (lookahead == '-') ADVANCE(482);
      if (lookahead == '|') ADVANCE(405);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym_negative_dot);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_u22c4);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_u25c7);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_u27f9);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_u21d2);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_DASH_PLUS_DASH_GT);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_u21f8);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_u2945);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_BSLASHequiv);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_u2261);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_u27fa);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_u21d4);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_TILDE_GT);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_u21dd);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_u219d);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_BSLASHland);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_BSLASHlor);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym_u2254);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym_COLON_COLON_EQ);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(anon_sym_u2a74);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '#') ADVANCE(510);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_u2260);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == ':') ADVANCE(453);
      if (lookahead == '<') ADVANCE(276);
      if (lookahead == '=') ADVANCE(391);
      if (lookahead == '>') ADVANCE(358);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == ':') ADVANCE(453);
      if (lookahead == '=') ADVANCE(391);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == ':') ADVANCE(453);
      if (lookahead == '=') ADVANCE(391);
      if (lookahead == '>') ADVANCE(358);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_gt);
      if (lookahead == '=') ADVANCE(395);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_gt);
      if (lookahead == '=') ADVANCE(395);
      if (lookahead == '>') ADVANCE(280);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_gt);
      if (lookahead == '=') ADVANCE(395);
      if (lookahead == '>') ADVANCE(279);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(369);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_EQ_LT);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_BSLASHleq);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_u2264);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_BSLASHgeq);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_u2265);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_BSLASHapprox);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_u2248);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_PIPE_DASH);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_PIPE_DASH);
      if (lookahead == '>') ADVANCE(270);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_u22a2);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_u22a8);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_DASH_PIPE);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_u22a3);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_EQ_PIPE);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_u2ae4);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_BSLASHasymp);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_u224d);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_BSLASHcong);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_u2245);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_BSLASHdoteq);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_u2250);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_BSLASHgg);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_u226b);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_BSLASHll);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_u226a);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_BSLASHnotin);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_u2209);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_BSLASHprec);
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_u227a);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_BSLASHsucc);
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_u227b);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_BSLASHpreceq);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_u2aaf);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_BSLASHsucceq);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_u2ab0);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_BSLASHpropto);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_u221d);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_BSLASHsim);
      if (lookahead == 'e') ADVANCE(169);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_u223c);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_BSLASHsimeq);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_u2243);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_BSLASHsqsubset);
      if (lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_u228f);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_BSLASHsqsupset);
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_u2290);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_BSLASHsqsubseteq);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_u2291);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_BSLASHsqsupseteq);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_u2292);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_BSLASHsubset);
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_u2282);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_BSLASHsupset);
      if (lookahead == 'e') ADVANCE(173);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_u2283);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_BSLASHsubseteq);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_u2286);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_BSLASHsupseteq);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_u2287);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(sym_compose);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(sym_map_to);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(sym_map_from);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(sym_setminus);
      ADVANCE_MAP(
        '*', 234,
        '/', 302,
        'A', 262,
        'B', 317,
        'E', 265,
        'H', 326,
        'O', 321,
        'X', 521,
        'a', 156,
        'b', 316,
        'c', 73,
        'd', 113,
        'e', 165,
        'f', 151,
        'g', 92,
        'h', 325,
        'i', 138,
        'l', 74,
        'n', 94,
        'o', 320,
        'p', 180,
        's', 114,
        't', 117,
        'u', 144,
        'w', 176,
      );
      END_STATE();
    case 455:
      ACCEPT_TOKEN(sym_setminus);
      ADVANCE_MAP(
        '*', 234,
        '/', 302,
        'X', 521,
        'a', 156,
        'b', 112,
        'c', 73,
        'd', 113,
        'e', 164,
        'g', 92,
        'i', 138,
        'l', 74,
        'n', 94,
        'o', 320,
        'p', 180,
        's', 114,
        't', 117,
        'u', 144,
        'w', 176,
      );
      END_STATE();
    case 456:
      ACCEPT_TOKEN(sym_setminus);
      ADVANCE_MAP(
        '*', 234,
        '/', 302,
        'X', 521,
        'a', 156,
        'b', 112,
        'c', 73,
        'd', 113,
        'e', 164,
        'g', 92,
        'i', 138,
        'l', 75,
        'n', 149,
        'o', 320,
        'p', 180,
        's', 114,
        't', 117,
        'u', 144,
        'w', 176,
      );
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_BSLASHcap);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_BSLASHintersect);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_u2229);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_BSLASHcup);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_BSLASHunion);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_u222a);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(465);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_u2025);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_u2026);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(469);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(sym_plusplus);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_BSLASHoplus);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_LPAREN_PLUS_RPAREN);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_u2295);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_BSLASHominus);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_LPAREN_DASH_RPAREN);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_u2296);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(sym_mod);
      if (lookahead == '%') ADVANCE(477);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(sym_modmod);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(sym_vert);
      if (lookahead == '-') ADVANCE(401);
      if (lookahead == '=') ADVANCE(403);
      if (lookahead == '|') ADVANCE(480);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(sym_vert);
      if (lookahead == '-') ADVANCE(400);
      if (lookahead == '=') ADVANCE(403);
      if (lookahead == '|') ADVANCE(480);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_u2016);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(sym_minusminus);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(sym_minusminus);
      if (lookahead == '-') ADVANCE(45);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(sym_amp);
      if (lookahead == '&') ADVANCE(485);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(sym_ampamp);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_BSLASHodot);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_LPAREN_DOT_RPAREN);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_u2299);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_BSLASHoslash);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_LPAREN_SLASH_RPAREN);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_u2298);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_BSLASHotimes);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_LPAREN_BSLASHX_RPAREN);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_u2297);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(sym_mul);
      if (lookahead == '*') ADVANCE(496);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(sym_mulmul);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(sym_slash);
      if (lookahead == '/') ADVANCE(498);
      if (lookahead == '=') ADVANCE(381);
      if (lookahead == '\\') ADVANCE(300);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(sym_slashslash);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_BSLASHbigcirc);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_u25ef);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_BSLASHbullet);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_u25cf);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_BSLASHdiv);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_u00f7);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_BSLASHcirc);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_u2218);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_BSLASHstar);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_u22c6);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_u203c);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(sym_hashhash);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(sym_dol);
      if (lookahead == '$') ADVANCE(512);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(sym_doldol);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_u2047);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_BSLASHsqcap);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_u2293);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_BSLASHsqcup);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_u2294);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_BSLASHuplus);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_u228e);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_BSLASHX);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_BSLASHtimes);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_u00d7);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_BSLASHwr);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_u2240);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_BSLASHcdot);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_u22c5);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(sym_pow);
      if (lookahead == '#') ADVANCE(533);
      if (lookahead == '*') ADVANCE(532);
      if (lookahead == '+') ADVANCE(530);
      if (lookahead == '^') ADVANCE(529);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(sym_powpow);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_CARET_PLUS);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_u207a);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(sym_asterisk);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(sym_sup_hash);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(sym_prime);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(aux_sym_proof_step_id_token1);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(aux_sym_proof_step_id_token1);
      if (lookahead == '_') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(536);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(aux_sym_proof_step_id_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(537);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(aux_sym_proof_step_id_token2);
      if (lookahead == '(') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '|') ADVANCE(540);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(aux_sym_proof_step_id_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '|') ADVANCE(540);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(aux_sym_proof_step_id_token3);
      if (lookahead == '(') ADVANCE(38);
      if (lookahead == '.') ADVANCE(542);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(aux_sym_proof_step_id_token3);
      if (lookahead == '.') ADVANCE(542);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(aux_sym_proof_step_ref_token1);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(aux_sym_proof_step_ref_token1);
      if (lookahead == '_') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(544);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(304);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(aux_sym_proof_step_ref_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '|') ADVANCE(545);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_DASH_DASHalgorithm);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_DASH_DASHfair);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '\r') SKIP(0);
      if (lookahead == 'A') ADVANCE(1);
      if (lookahead == 'B') ADVANCE(2);
      if (lookahead == 'C') ADVANCE(3);
      if (lookahead == 'D') ADVANCE(4);
      if (lookahead == 'E') ADVANCE(5);
      if (lookahead == 'F') ADVANCE(6);
      if (lookahead == 'H') ADVANCE(7);
      if (lookahead == 'I') ADVANCE(8);
      if (lookahead == 'L') ADVANCE(9);
      if (lookahead == 'M') ADVANCE(10);
      if (lookahead == 'N') ADVANCE(11);
      if (lookahead == 'O') ADVANCE(12);
      if (lookahead == 'P') ADVANCE(13);
      if (lookahead == 'Q') ADVANCE(14);
      if (lookahead == 'R') ADVANCE(15);
      if (lookahead == 'S') ADVANCE(16);
      if (lookahead == 'T') ADVANCE(17);
      if (lookahead == 'U') ADVANCE(18);
      if (lookahead == 'V') ADVANCE(19);
      if (lookahead == 'W') ADVANCE(20);
      if (lookahead == 'a') ADVANCE(21);
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'c') ADVANCE(23);
      if (lookahead == 'd') ADVANCE(24);
      if (lookahead == 'e') ADVANCE(25);
      if (lookahead == 'f') ADVANCE(26);
      if (lookahead == 'g') ADVANCE(27);
      if (lookahead == 'i') ADVANCE(28);
      if (lookahead == 'm') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      if (lookahead == 'p') ADVANCE(31);
      if (lookahead == 'r') ADVANCE(32);
      if (lookahead == 's') ADVANCE(33);
      if (lookahead == 't') ADVANCE(34);
      if (lookahead == 'v') ADVANCE(35);
      if (lookahead == 'w') ADVANCE(36);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'C') ADVANCE(37);
      if (lookahead == 'S') ADVANCE(38);
      if (lookahead == 'X') ADVANCE(39);
      END_STATE();
    case 2:
      if (lookahead == 'O') ADVANCE(40);
      if (lookahead == 'Y') ADVANCE(41);
      END_STATE();
    case 3:
      if (lookahead == 'A') ADVANCE(42);
      if (lookahead == 'H') ADVANCE(43);
      if (lookahead == 'O') ADVANCE(44);
      END_STATE();
    case 4:
      if (lookahead == 'E') ADVANCE(45);
      if (lookahead == 'O') ADVANCE(46);
      END_STATE();
    case 5:
      if (lookahead == 'L') ADVANCE(47);
      if (lookahead == 'N') ADVANCE(48);
      if (lookahead == 'X') ADVANCE(49);
      END_STATE();
    case 6:
      if (lookahead == 'A') ADVANCE(50);
      END_STATE();
    case 7:
      if (lookahead == 'A') ADVANCE(51);
      if (lookahead == 'I') ADVANCE(52);
      END_STATE();
    case 8:
      if (lookahead == 'F') ADVANCE(53);
      if (lookahead == 'N') ADVANCE(54);
      if (lookahead == 'n') ADVANCE(55);
      END_STATE();
    case 9:
      if (lookahead == 'A') ADVANCE(56);
      if (lookahead == 'E') ADVANCE(57);
      if (lookahead == 'O') ADVANCE(58);
      END_STATE();
    case 10:
      if (lookahead == 'O') ADVANCE(59);
      END_STATE();
    case 11:
      if (lookahead == 'E') ADVANCE(60);
      if (lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 12:
      if (lookahead == 'B') ADVANCE(62);
      if (lookahead == 'M') ADVANCE(63);
      if (lookahead == 'N') ADVANCE(64);
      if (lookahead == 'T') ADVANCE(65);
      END_STATE();
    case 13:
      if (lookahead == 'I') ADVANCE(66);
      if (lookahead == 'R') ADVANCE(67);
      END_STATE();
    case 14:
      if (lookahead == 'E') ADVANCE(68);
      END_STATE();
    case 15:
      if (lookahead == 'E') ADVANCE(69);
      if (lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 16:
      if (lookahead == 'F') ADVANCE(71);
      if (lookahead == 'T') ADVANCE(72);
      if (lookahead == 'U') ADVANCE(73);
      END_STATE();
    case 17:
      if (lookahead == 'A') ADVANCE(74);
      if (lookahead == 'E') ADVANCE(75);
      if (lookahead == 'H') ADVANCE(76);
      if (lookahead == 'R') ADVANCE(77);
      END_STATE();
    case 18:
      if (lookahead == 'N') ADVANCE(78);
      if (lookahead == 'S') ADVANCE(79);
      END_STATE();
    case 19:
      if (lookahead == 'A') ADVANCE(80);
      END_STATE();
    case 20:
      if (lookahead == 'F') ADVANCE(81);
      if (lookahead == 'I') ADVANCE(82);
      END_STATE();
    case 21:
      if (lookahead == 'l') ADVANCE(83);
      if (lookahead == 's') ADVANCE(84);
      if (lookahead == 'w') ADVANCE(85);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(86);
      END_STATE();
    case 23:
      if (lookahead == 'a') ADVANCE(87);
      END_STATE();
    case 24:
      if (lookahead == 'e') ADVANCE(88);
      if (lookahead == 'o') ADVANCE(89);
      END_STATE();
    case 25:
      if (lookahead == 'i') ADVANCE(90);
      if (lookahead == 'l') ADVANCE(91);
      if (lookahead == 'n') ADVANCE(92);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(93);
      END_STATE();
    case 27:
      if (lookahead == 'o') ADVANCE(94);
      END_STATE();
    case 28:
      if (lookahead == 'f') ADVANCE(95);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(96);
      END_STATE();
    case 30:
      if (lookahead == 'r') ADVANCE(97);
      END_STATE();
    case 31:
      if (lookahead == 'r') ADVANCE(98);
      END_STATE();
    case 32:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 33:
      if (lookahead == 'k') ADVANCE(100);
      END_STATE();
    case 34:
      if (lookahead == 'h') ADVANCE(101);
      END_STATE();
    case 35:
      if (lookahead == 'a') ADVANCE(102);
      END_STATE();
    case 36:
      if (lookahead == 'h') ADVANCE(103);
      if (lookahead == 'i') ADVANCE(104);
      END_STATE();
    case 37:
      if (lookahead == 'T') ADVANCE(105);
      END_STATE();
    case 38:
      if (lookahead == 'S') ADVANCE(106);
      END_STATE();
    case 39:
      if (lookahead == 'I') ADVANCE(107);
      END_STATE();
    case 40:
      if (lookahead == 'O') ADVANCE(108);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_BY);
      END_STATE();
    case 42:
      if (lookahead == 'S') ADVANCE(109);
      END_STATE();
    case 43:
      if (lookahead == 'O') ADVANCE(110);
      END_STATE();
    case 44:
      if (lookahead == 'N') ADVANCE(111);
      if (lookahead == 'R') ADVANCE(112);
      END_STATE();
    case 45:
      if (lookahead == 'F') ADVANCE(113);
      END_STATE();
    case 46:
      if (lookahead == 'M') ADVANCE(114);
      END_STATE();
    case 47:
      if (lookahead == 'S') ADVANCE(115);
      END_STATE();
    case 48:
      if (lookahead == 'A') ADVANCE(116);
      END_STATE();
    case 49:
      if (lookahead == 'C') ADVANCE(117);
      if (lookahead == 'T') ADVANCE(118);
      END_STATE();
    case 50:
      if (lookahead == 'L') ADVANCE(119);
      END_STATE();
    case 51:
      if (lookahead == 'V') ADVANCE(120);
      END_STATE();
    case 52:
      if (lookahead == 'D') ADVANCE(121);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_IF);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_IN);
      if (lookahead == 'S') ADVANCE(122);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 56:
      if (lookahead == 'M') ADVANCE(124);
      END_STATE();
    case 57:
      if (lookahead == 'M') ADVANCE(125);
      if (lookahead == 'T') ADVANCE(126);
      END_STATE();
    case 58:
      if (lookahead == 'C') ADVANCE(127);
      END_STATE();
    case 59:
      if (lookahead == 'D') ADVANCE(128);
      END_STATE();
    case 60:
      if (lookahead == 'W') ADVANCE(129);
      END_STATE();
    case 61:
      if (lookahead == 't') ADVANCE(130);
      END_STATE();
    case 62:
      if (lookahead == 'V') ADVANCE(131);
      END_STATE();
    case 63:
      if (lookahead == 'I') ADVANCE(132);
      END_STATE();
    case 64:
      if (lookahead == 'L') ADVANCE(133);
      END_STATE();
    case 65:
      if (lookahead == 'H') ADVANCE(134);
      END_STATE();
    case 66:
      if (lookahead == 'C') ADVANCE(135);
      END_STATE();
    case 67:
      if (lookahead == 'O') ADVANCE(136);
      END_STATE();
    case 68:
      if (lookahead == 'D') ADVANCE(137);
      END_STATE();
    case 69:
      if (lookahead == 'C') ADVANCE(138);
      END_STATE();
    case 70:
      if (lookahead == 'a') ADVANCE(139);
      END_STATE();
    case 71:
      if (lookahead == '_') ADVANCE(140);
      END_STATE();
    case 72:
      if (lookahead == 'A') ADVANCE(141);
      if (lookahead == 'R') ADVANCE(142);
      END_STATE();
    case 73:
      if (lookahead == 'B') ADVANCE(143);
      if (lookahead == 'F') ADVANCE(144);
      END_STATE();
    case 74:
      if (lookahead == 'K') ADVANCE(145);
      END_STATE();
    case 75:
      if (lookahead == 'M') ADVANCE(146);
      END_STATE();
    case 76:
      if (lookahead == 'E') ADVANCE(147);
      END_STATE();
    case 77:
      if (lookahead == 'U') ADVANCE(148);
      END_STATE();
    case 78:
      if (lookahead == 'C') ADVANCE(149);
      if (lookahead == 'I') ADVANCE(150);
      END_STATE();
    case 79:
      if (lookahead == 'E') ADVANCE(151);
      END_STATE();
    case 80:
      if (lookahead == 'R') ADVANCE(152);
      END_STATE();
    case 81:
      if (lookahead == '_') ADVANCE(153);
      END_STATE();
    case 82:
      if (lookahead == 'T') ADVANCE(154);
      END_STATE();
    case 83:
      if (lookahead == 'g') ADVANCE(155);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(156);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(157);
      END_STATE();
    case 86:
      if (lookahead == 'g') ADVANCE(158);
      END_STATE();
    case 87:
      if (lookahead == 'l') ADVANCE(159);
      END_STATE();
    case 88:
      if (lookahead == 'f') ADVANCE(160);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 90:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 91:
      if (lookahead == 's') ADVANCE(162);
      END_STATE();
    case 92:
      if (lookahead == 'd') ADVANCE(163);
      END_STATE();
    case 93:
      if (lookahead == 'i') ADVANCE(164);
      END_STATE();
    case 94:
      if (lookahead == 't') ADVANCE(165);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 96:
      if (lookahead == 'c') ADVANCE(166);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 98:
      if (lookahead == 'i') ADVANCE(167);
      if (lookahead == 'o') ADVANCE(168);
      END_STATE();
    case 99:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 100:
      if (lookahead == 'i') ADVANCE(170);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 102:
      if (lookahead == 'r') ADVANCE(172);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(173);
      if (lookahead == 'i') ADVANCE(174);
      END_STATE();
    case 104:
      if (lookahead == 't') ADVANCE(175);
      END_STATE();
    case 105:
      if (lookahead == 'I') ADVANCE(176);
      END_STATE();
    case 106:
      if (lookahead == 'U') ADVANCE(177);
      END_STATE();
    case 107:
      if (lookahead == 'O') ADVANCE(178);
      END_STATE();
    case 108:
      if (lookahead == 'L') ADVANCE(179);
      END_STATE();
    case 109:
      if (lookahead == 'E') ADVANCE(180);
      END_STATE();
    case 110:
      if (lookahead == 'O') ADVANCE(181);
      END_STATE();
    case 111:
      if (lookahead == 'S') ADVANCE(182);
      END_STATE();
    case 112:
      if (lookahead == 'O') ADVANCE(183);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_DEF);
      if (lookahead == 'I') ADVANCE(184);
      if (lookahead == 'S') ADVANCE(185);
      END_STATE();
    case 114:
      if (lookahead == 'A') ADVANCE(186);
      END_STATE();
    case 115:
      if (lookahead == 'E') ADVANCE(187);
      END_STATE();
    case 116:
      if (lookahead == 'B') ADVANCE(188);
      END_STATE();
    case 117:
      if (lookahead == 'E') ADVANCE(189);
      END_STATE();
    case 118:
      if (lookahead == 'E') ADVANCE(190);
      END_STATE();
    case 119:
      if (lookahead == 'S') ADVANCE(191);
      END_STATE();
    case 120:
      if (lookahead == 'E') ADVANCE(192);
      END_STATE();
    case 121:
      if (lookahead == 'E') ADVANCE(193);
      END_STATE();
    case 122:
      if (lookahead == 'T') ADVANCE(194);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_Int);
      END_STATE();
    case 124:
      if (lookahead == 'B') ADVANCE(195);
      END_STATE();
    case 125:
      if (lookahead == 'M') ADVANCE(196);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LET);
      END_STATE();
    case 127:
      if (lookahead == 'A') ADVANCE(197);
      END_STATE();
    case 128:
      if (lookahead == 'U') ADVANCE(198);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_NEW);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_Nat);
      END_STATE();
    case 131:
      if (lookahead == 'I') ADVANCE(199);
      END_STATE();
    case 132:
      if (lookahead == 'T') ADVANCE(200);
      END_STATE();
    case 133:
      if (lookahead == 'Y') ADVANCE(201);
      END_STATE();
    case 134:
      if (lookahead == 'E') ADVANCE(202);
      END_STATE();
    case 135:
      if (lookahead == 'K') ADVANCE(203);
      END_STATE();
    case 136:
      if (lookahead == 'O') ADVANCE(204);
      if (lookahead == 'P') ADVANCE(205);
      if (lookahead == 'V') ADVANCE(206);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_QED);
      END_STATE();
    case 138:
      if (lookahead == 'U') ADVANCE(207);
      END_STATE();
    case 139:
      if (lookahead == 'l') ADVANCE(208);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_SF_);
      END_STATE();
    case 141:
      if (lookahead == 'T') ADVANCE(209);
      END_STATE();
    case 142:
      if (lookahead == 'I') ADVANCE(210);
      END_STATE();
    case 143:
      if (lookahead == 'S') ADVANCE(211);
      END_STATE();
    case 144:
      if (lookahead == 'F') ADVANCE(212);
      END_STATE();
    case 145:
      if (lookahead == 'E') ADVANCE(213);
      END_STATE();
    case 146:
      if (lookahead == 'P') ADVANCE(214);
      END_STATE();
    case 147:
      if (lookahead == 'N') ADVANCE(215);
      if (lookahead == 'O') ADVANCE(216);
      END_STATE();
    case 148:
      if (lookahead == 'E') ADVANCE(217);
      END_STATE();
    case 149:
      if (lookahead == 'H') ADVANCE(218);
      END_STATE();
    case 150:
      if (lookahead == 'O') ADVANCE(219);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_USE);
      END_STATE();
    case 152:
      if (lookahead == 'I') ADVANCE(220);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_WF_);
      END_STATE();
    case 154:
      if (lookahead == 'H') ADVANCE(221);
      if (lookahead == 'N') ADVANCE(222);
      END_STATE();
    case 155:
      if (lookahead == 'o') ADVANCE(223);
      END_STATE();
    case 156:
      if (lookahead == 'e') ADVANCE(224);
      END_STATE();
    case 157:
      if (lookahead == 'i') ADVANCE(225);
      END_STATE();
    case 158:
      if (lookahead == 'i') ADVANCE(226);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(227);
      END_STATE();
    case 160:
      if (lookahead == 'i') ADVANCE(228);
      END_STATE();
    case 161:
      if (lookahead == 'h') ADVANCE(229);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(230);
      if (lookahead == 'i') ADVANCE(231);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 165:
      if (lookahead == 'o') ADVANCE(233);
      END_STATE();
    case 166:
      if (lookahead == 'r') ADVANCE(234);
      END_STATE();
    case 167:
      if (lookahead == 'n') ADVANCE(235);
      END_STATE();
    case 168:
      if (lookahead == 'c') ADVANCE(236);
      END_STATE();
    case 169:
      if (lookahead == 'u') ADVANCE(237);
      END_STATE();
    case 170:
      if (lookahead == 'p') ADVANCE(238);
      END_STATE();
    case 171:
      if (lookahead == 'n') ADVANCE(239);
      END_STATE();
    case 172:
      if (lookahead == 'i') ADVANCE(240);
      END_STATE();
    case 173:
      if (lookahead == 'n') ADVANCE(241);
      END_STATE();
    case 174:
      if (lookahead == 'l') ADVANCE(242);
      END_STATE();
    case 175:
      if (lookahead == 'h') ADVANCE(243);
      END_STATE();
    case 176:
      if (lookahead == 'O') ADVANCE(244);
      END_STATE();
    case 177:
      if (lookahead == 'M') ADVANCE(245);
      END_STATE();
    case 178:
      if (lookahead == 'M') ADVANCE(246);
      END_STATE();
    case 179:
      if (lookahead == 'E') ADVANCE(247);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_CASE);
      END_STATE();
    case 181:
      if (lookahead == 'S') ADVANCE(248);
      END_STATE();
    case 182:
      if (lookahead == 'T') ADVANCE(249);
      END_STATE();
    case 183:
      if (lookahead == 'L') ADVANCE(250);
      END_STATE();
    case 184:
      if (lookahead == 'N') ADVANCE(251);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_DEFS);
      END_STATE();
    case 186:
      if (lookahead == 'I') ADVANCE(252);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_ELSE);
      END_STATE();
    case 188:
      if (lookahead == 'L') ADVANCE(253);
      END_STATE();
    case 189:
      if (lookahead == 'P') ADVANCE(254);
      END_STATE();
    case 190:
      if (lookahead == 'N') ADVANCE(255);
      END_STATE();
    case 191:
      if (lookahead == 'E') ADVANCE(256);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_HAVE);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_HIDE);
      END_STATE();
    case 194:
      if (lookahead == 'A') ADVANCE(257);
      END_STATE();
    case 195:
      if (lookahead == 'D') ADVANCE(258);
      END_STATE();
    case 196:
      if (lookahead == 'A') ADVANCE(259);
      END_STATE();
    case 197:
      if (lookahead == 'L') ADVANCE(260);
      END_STATE();
    case 198:
      if (lookahead == 'L') ADVANCE(261);
      END_STATE();
    case 199:
      if (lookahead == 'O') ADVANCE(262);
      END_STATE();
    case 200:
      if (lookahead == 'T') ADVANCE(263);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_ONLY);
      END_STATE();
    case 202:
      if (lookahead == 'R') ADVANCE(264);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_PICK);
      END_STATE();
    case 204:
      if (lookahead == 'F') ADVANCE(265);
      END_STATE();
    case 205:
      if (lookahead == 'O') ADVANCE(266);
      END_STATE();
    case 206:
      if (lookahead == 'E') ADVANCE(267);
      END_STATE();
    case 207:
      if (lookahead == 'R') ADVANCE(268);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_Real);
      END_STATE();
    case 209:
      if (lookahead == 'E') ADVANCE(269);
      END_STATE();
    case 210:
      if (lookahead == 'N') ADVANCE(270);
      END_STATE();
    case 211:
      if (lookahead == 'E') ADVANCE(271);
      END_STATE();
    case 212:
      if (lookahead == 'I') ADVANCE(272);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_TAKE);
      END_STATE();
    case 214:
      if (lookahead == 'O') ADVANCE(273);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_THEN);
      END_STATE();
    case 216:
      if (lookahead == 'R') ADVANCE(274);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_TRUE);
      END_STATE();
    case 218:
      if (lookahead == 'A') ADVANCE(275);
      END_STATE();
    case 219:
      if (lookahead == 'N') ADVANCE(276);
      END_STATE();
    case 220:
      if (lookahead == 'A') ADVANCE(277);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_WITH);
      END_STATE();
    case 222:
      if (lookahead == 'E') ADVANCE(278);
      END_STATE();
    case 223:
      if (lookahead == 'r') ADVANCE(279);
      END_STATE();
    case 224:
      if (lookahead == 'r') ADVANCE(280);
      END_STATE();
    case 225:
      if (lookahead == 't') ADVANCE(281);
      END_STATE();
    case 226:
      if (lookahead == 'n') ADVANCE(282);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_call);
      END_STATE();
    case 228:
      if (lookahead == 'n') ADVANCE(283);
      END_STATE();
    case 229:
      if (lookahead == 'e') ADVANCE(284);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 231:
      if (lookahead == 'f') ADVANCE(285);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_fair);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 234:
      if (lookahead == 'o') ADVANCE(286);
      END_STATE();
    case 235:
      if (lookahead == 't') ADVANCE(287);
      END_STATE();
    case 236:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 237:
      if (lookahead == 'r') ADVANCE(289);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_pcal_skip);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 240:
      if (lookahead == 'a') ADVANCE(290);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 242:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 244:
      if (lookahead == 'N') ADVANCE(292);
      END_STATE();
    case 245:
      if (lookahead == 'E') ADVANCE(293);
      if (lookahead == 'P') ADVANCE(294);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_AXIOM);
      END_STATE();
    case 247:
      if (lookahead == 'A') ADVANCE(295);
      END_STATE();
    case 248:
      if (lookahead == 'E') ADVANCE(296);
      END_STATE();
    case 249:
      if (lookahead == 'A') ADVANCE(297);
      END_STATE();
    case 250:
      if (lookahead == 'L') ADVANCE(298);
      END_STATE();
    case 251:
      if (lookahead == 'E') ADVANCE(299);
      END_STATE();
    case 252:
      if (lookahead == 'N') ADVANCE(300);
      END_STATE();
    case 253:
      if (lookahead == 'E') ADVANCE(301);
      END_STATE();
    case 254:
      if (lookahead == 'T') ADVANCE(302);
      END_STATE();
    case 255:
      if (lookahead == 'D') ADVANCE(303);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_FALSE);
      END_STATE();
    case 257:
      if (lookahead == 'N') ADVANCE(304);
      END_STATE();
    case 258:
      if (lookahead == 'A') ADVANCE(305);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_LEMMA);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_LOCAL);
      END_STATE();
    case 261:
      if (lookahead == 'E') ADVANCE(306);
      END_STATE();
    case 262:
      if (lookahead == 'U') ADVANCE(307);
      END_STATE();
    case 263:
      if (lookahead == 'E') ADVANCE(308);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_OTHER);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_PROOF);
      END_STATE();
    case 266:
      if (lookahead == 'S') ADVANCE(309);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_PROVE);
      END_STATE();
    case 268:
      if (lookahead == 'S') ADVANCE(310);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_STATE);
      END_STATE();
    case 270:
      if (lookahead == 'G') ADVANCE(311);
      END_STATE();
    case 271:
      if (lookahead == 'T') ADVANCE(312);
      END_STATE();
    case 272:
      if (lookahead == 'C') ADVANCE(313);
      END_STATE();
    case 273:
      if (lookahead == 'R') ADVANCE(314);
      END_STATE();
    case 274:
      if (lookahead == 'E') ADVANCE(315);
      END_STATE();
    case 275:
      if (lookahead == 'N') ADVANCE(316);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_union);
      END_STATE();
    case 277:
      if (lookahead == 'B') ADVANCE(317);
      END_STATE();
    case 278:
      if (lookahead == 'S') ADVANCE(318);
      END_STATE();
    case 279:
      if (lookahead == 'i') ADVANCE(319);
      END_STATE();
    case 280:
      if (lookahead == 't') ADVANCE(320);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 283:
      if (lookahead == 'e') ADVANCE(321);
      END_STATE();
    case 284:
      if (lookahead == 'r') ADVANCE(322);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_elsif);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_macro);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(323);
      if (lookahead == 's') ADVANCE(324);
      END_STATE();
    case 289:
      if (lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 290:
      if (lookahead == 'b') ADVANCE(326);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_ACTION);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_ASSUME);
      END_STATE();
    case 294:
      if (lookahead == 'T') ADVANCE(327);
      END_STATE();
    case 295:
      if (lookahead == 'N') ADVANCE(328);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_CHOOSE);
      END_STATE();
    case 297:
      if (lookahead == 'N') ADVANCE(329);
      END_STATE();
    case 298:
      if (lookahead == 'A') ADVANCE(330);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_DEFINE);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_domain);
      END_STATE();
    case 301:
      if (lookahead == 'D') ADVANCE(331);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_EXCEPT);
      END_STATE();
    case 303:
      if (lookahead == 'S') ADVANCE(332);
      END_STATE();
    case 304:
      if (lookahead == 'C') ADVANCE(333);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_LAMBDA);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_MODULE);
      END_STATE();
    case 307:
      if (lookahead == 'S') ADVANCE(334);
      END_STATE();
    case 308:
      if (lookahead == 'D') ADVANCE(335);
      END_STATE();
    case 309:
      if (lookahead == 'I') ADVANCE(336);
      END_STATE();
    case 310:
      if (lookahead == 'I') ADVANCE(337);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(sym_string_set);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_powerset);
      END_STATE();
    case 313:
      if (lookahead == 'E') ADVANCE(338);
      END_STATE();
    case 314:
      if (lookahead == 'A') ADVANCE(339);
      END_STATE();
    case 315:
      if (lookahead == 'M') ADVANCE(340);
      END_STATE();
    case 316:
      if (lookahead == 'G') ADVANCE(341);
      END_STATE();
    case 317:
      if (lookahead == 'L') ADVANCE(342);
      END_STATE();
    case 318:
      if (lookahead == 'S') ADVANCE(343);
      END_STATE();
    case 319:
      if (lookahead == 't') ADVANCE(344);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_define);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_either);
      END_STATE();
    case 323:
      if (lookahead == 'u') ADVANCE(345);
      END_STATE();
    case 324:
      if (lookahead == 's') ADVANCE(346);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym_pcal_return);
      END_STATE();
    case 326:
      if (lookahead == 'l') ADVANCE(347);
      END_STATE();
    case 327:
      if (lookahead == 'I') ADVANCE(348);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym_boolean_set);
      END_STATE();
    case 329:
      if (lookahead == 'T') ADVANCE(349);
      END_STATE();
    case 330:
      if (lookahead == 'R') ADVANCE(350);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(sym_enabled);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_EXTENDS);
      END_STATE();
    case 333:
      if (lookahead == 'E') ADVANCE(351);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_OBVIOUS);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_OMITTED);
      END_STATE();
    case 336:
      if (lookahead == 'T') ADVANCE(352);
      END_STATE();
    case 337:
      if (lookahead == 'V') ADVANCE(353);
      END_STATE();
    case 338:
      if (lookahead == 'S') ADVANCE(354);
      END_STATE();
    case 339:
      if (lookahead == 'L') ADVANCE(355);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_THEOREM);
      END_STATE();
    case 341:
      if (lookahead == 'E') ADVANCE(356);
      END_STATE();
    case 342:
      if (lookahead == 'E') ADVANCE(357);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_WITNESS);
      END_STATE();
    case 344:
      if (lookahead == 'h') ADVANCE(358);
      END_STATE();
    case 345:
      if (lookahead == 'r') ADVANCE(359);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_process);
      END_STATE();
    case 347:
      if (lookahead == 'e') ADVANCE(360);
      END_STATE();
    case 348:
      if (lookahead == 'O') ADVANCE(361);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_CONSTANT);
      if (lookahead == 'S') ADVANCE(362);
      END_STATE();
    case 350:
      if (lookahead == 'Y') ADVANCE(363);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_INSTANCE);
      END_STATE();
    case 352:
      if (lookahead == 'I') ADVANCE(364);
      END_STATE();
    case 353:
      if (lookahead == 'E') ADVANCE(365);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_SUFFICES);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_TEMPORAL);
      END_STATE();
    case 356:
      if (lookahead == 'D') ADVANCE(366);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_VARIABLE);
      if (lookahead == 'S') ADVANCE(367);
      END_STATE();
    case 358:
      if (lookahead == 'm') ADVANCE(368);
      END_STATE();
    case 359:
      if (lookahead == 'e') ADVANCE(369);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_variable);
      if (lookahead == 's') ADVANCE(370);
      END_STATE();
    case 361:
      if (lookahead == 'N') ADVANCE(371);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_CONSTANTS);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_COROLLARY);
      END_STATE();
    case 364:
      if (lookahead == 'O') ADVANCE(372);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_RECURSIVE);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_unchanged);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_VARIABLES);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_algorithm);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_procedure);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_variables);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_ASSUMPTION);
      END_STATE();
    case 372:
      if (lookahead == 'N') ADVANCE(373);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_PROPOSITION);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 226, .external_lex_state = 2},
  [2] = {.lex_state = 4, .external_lex_state = 3},
  [3] = {.lex_state = 4, .external_lex_state = 3},
  [4] = {.lex_state = 4, .external_lex_state = 3},
  [5] = {.lex_state = 4, .external_lex_state = 4},
  [6] = {.lex_state = 5, .external_lex_state = 4},
  [7] = {.lex_state = 5, .external_lex_state = 4},
  [8] = {.lex_state = 228, .external_lex_state = 4},
  [9] = {.lex_state = 5, .external_lex_state = 4},
  [10] = {.lex_state = 228, .external_lex_state = 4},
  [11] = {.lex_state = 228, .external_lex_state = 4},
  [12] = {.lex_state = 4, .external_lex_state = 4},
  [13] = {.lex_state = 4, .external_lex_state = 4},
  [14] = {.lex_state = 4, .external_lex_state = 4},
  [15] = {.lex_state = 4, .external_lex_state = 4},
  [16] = {.lex_state = 4, .external_lex_state = 4},
  [17] = {.lex_state = 4, .external_lex_state = 4},
  [18] = {.lex_state = 4, .external_lex_state = 4},
  [19] = {.lex_state = 4, .external_lex_state = 4},
  [20] = {.lex_state = 4, .external_lex_state = 4},
  [21] = {.lex_state = 4, .external_lex_state = 4},
  [22] = {.lex_state = 4, .external_lex_state = 4},
  [23] = {.lex_state = 4, .external_lex_state = 4},
  [24] = {.lex_state = 4, .external_lex_state = 4},
  [25] = {.lex_state = 4, .external_lex_state = 4},
  [26] = {.lex_state = 4, .external_lex_state = 4},
  [27] = {.lex_state = 4, .external_lex_state = 4},
  [28] = {.lex_state = 4, .external_lex_state = 4},
  [29] = {.lex_state = 4, .external_lex_state = 4},
  [30] = {.lex_state = 4, .external_lex_state = 4},
  [31] = {.lex_state = 4, .external_lex_state = 4},
  [32] = {.lex_state = 4, .external_lex_state = 4},
  [33] = {.lex_state = 4, .external_lex_state = 4},
  [34] = {.lex_state = 4, .external_lex_state = 4},
  [35] = {.lex_state = 4, .external_lex_state = 4},
  [36] = {.lex_state = 4, .external_lex_state = 4},
  [37] = {.lex_state = 4, .external_lex_state = 4},
  [38] = {.lex_state = 4, .external_lex_state = 4},
  [39] = {.lex_state = 4, .external_lex_state = 4},
  [40] = {.lex_state = 4, .external_lex_state = 4},
  [41] = {.lex_state = 4, .external_lex_state = 4},
  [42] = {.lex_state = 4, .external_lex_state = 4},
  [43] = {.lex_state = 4, .external_lex_state = 4},
  [44] = {.lex_state = 4, .external_lex_state = 4},
  [45] = {.lex_state = 6, .external_lex_state = 4},
  [46] = {.lex_state = 4, .external_lex_state = 4},
  [47] = {.lex_state = 4, .external_lex_state = 4},
  [48] = {.lex_state = 4, .external_lex_state = 4},
  [49] = {.lex_state = 4, .external_lex_state = 4},
  [50] = {.lex_state = 4, .external_lex_state = 4},
  [51] = {.lex_state = 4, .external_lex_state = 4},
  [52] = {.lex_state = 4, .external_lex_state = 4},
  [53] = {.lex_state = 4, .external_lex_state = 4},
  [54] = {.lex_state = 6, .external_lex_state = 4},
  [55] = {.lex_state = 4, .external_lex_state = 4},
  [56] = {.lex_state = 4, .external_lex_state = 4},
  [57] = {.lex_state = 4, .external_lex_state = 4},
  [58] = {.lex_state = 4, .external_lex_state = 4},
  [59] = {.lex_state = 4, .external_lex_state = 4},
  [60] = {.lex_state = 4, .external_lex_state = 4},
  [61] = {.lex_state = 6, .external_lex_state = 4},
  [62] = {.lex_state = 6, .external_lex_state = 4},
  [63] = {.lex_state = 4, .external_lex_state = 4},
  [64] = {.lex_state = 4, .external_lex_state = 4},
  [65] = {.lex_state = 4, .external_lex_state = 4},
  [66] = {.lex_state = 6, .external_lex_state = 4},
  [67] = {.lex_state = 4, .external_lex_state = 4},
  [68] = {.lex_state = 6, .external_lex_state = 4},
  [69] = {.lex_state = 6, .external_lex_state = 4},
  [70] = {.lex_state = 6, .external_lex_state = 4},
  [71] = {.lex_state = 6, .external_lex_state = 4},
  [72] = {.lex_state = 6, .external_lex_state = 4},
  [73] = {.lex_state = 6, .external_lex_state = 4},
  [74] = {.lex_state = 6, .external_lex_state = 4},
  [75] = {.lex_state = 6, .external_lex_state = 4},
  [76] = {.lex_state = 6, .external_lex_state = 4},
  [77] = {.lex_state = 6, .external_lex_state = 4},
  [78] = {.lex_state = 6, .external_lex_state = 4},
  [79] = {.lex_state = 6, .external_lex_state = 4},
  [80] = {.lex_state = 6, .external_lex_state = 4},
  [81] = {.lex_state = 6, .external_lex_state = 4},
  [82] = {.lex_state = 4, .external_lex_state = 4},
  [83] = {.lex_state = 4, .external_lex_state = 4},
  [84] = {.lex_state = 4, .external_lex_state = 4},
  [85] = {.lex_state = 4, .external_lex_state = 4},
  [86] = {.lex_state = 4, .external_lex_state = 4},
  [87] = {.lex_state = 4, .external_lex_state = 4},
  [88] = {.lex_state = 4, .external_lex_state = 4},
  [89] = {.lex_state = 4, .external_lex_state = 4},
  [90] = {.lex_state = 4, .external_lex_state = 4},
  [91] = {.lex_state = 4, .external_lex_state = 4},
  [92] = {.lex_state = 4, .external_lex_state = 4},
  [93] = {.lex_state = 4, .external_lex_state = 4},
  [94] = {.lex_state = 4, .external_lex_state = 4},
  [95] = {.lex_state = 4, .external_lex_state = 4},
  [96] = {.lex_state = 4, .external_lex_state = 4},
  [97] = {.lex_state = 4, .external_lex_state = 4},
  [98] = {.lex_state = 4, .external_lex_state = 4},
  [99] = {.lex_state = 4, .external_lex_state = 4},
  [100] = {.lex_state = 4, .external_lex_state = 4},
  [101] = {.lex_state = 4, .external_lex_state = 4},
  [102] = {.lex_state = 4, .external_lex_state = 4},
  [103] = {.lex_state = 4, .external_lex_state = 4},
  [104] = {.lex_state = 4, .external_lex_state = 4},
  [105] = {.lex_state = 4, .external_lex_state = 4},
  [106] = {.lex_state = 4, .external_lex_state = 4},
  [107] = {.lex_state = 4, .external_lex_state = 4},
  [108] = {.lex_state = 4, .external_lex_state = 4},
  [109] = {.lex_state = 4, .external_lex_state = 4},
  [110] = {.lex_state = 4, .external_lex_state = 4},
  [111] = {.lex_state = 4, .external_lex_state = 4},
  [112] = {.lex_state = 4, .external_lex_state = 4},
  [113] = {.lex_state = 4, .external_lex_state = 4},
  [114] = {.lex_state = 4, .external_lex_state = 4},
  [115] = {.lex_state = 4, .external_lex_state = 4},
  [116] = {.lex_state = 4, .external_lex_state = 4},
  [117] = {.lex_state = 4, .external_lex_state = 4},
  [118] = {.lex_state = 4, .external_lex_state = 4},
  [119] = {.lex_state = 4, .external_lex_state = 4},
  [120] = {.lex_state = 4, .external_lex_state = 4},
  [121] = {.lex_state = 4, .external_lex_state = 4},
  [122] = {.lex_state = 4, .external_lex_state = 4},
  [123] = {.lex_state = 4, .external_lex_state = 4},
  [124] = {.lex_state = 4, .external_lex_state = 4},
  [125] = {.lex_state = 4, .external_lex_state = 4},
  [126] = {.lex_state = 4, .external_lex_state = 4},
  [127] = {.lex_state = 4, .external_lex_state = 4},
  [128] = {.lex_state = 4, .external_lex_state = 4},
  [129] = {.lex_state = 4, .external_lex_state = 4},
  [130] = {.lex_state = 4, .external_lex_state = 4},
  [131] = {.lex_state = 4, .external_lex_state = 4},
  [132] = {.lex_state = 4, .external_lex_state = 5},
  [133] = {.lex_state = 4, .external_lex_state = 5},
  [134] = {.lex_state = 4, .external_lex_state = 4},
  [135] = {.lex_state = 4, .external_lex_state = 4},
  [136] = {.lex_state = 4, .external_lex_state = 4},
  [137] = {.lex_state = 4, .external_lex_state = 4},
  [138] = {.lex_state = 4, .external_lex_state = 4},
  [139] = {.lex_state = 4, .external_lex_state = 4},
  [140] = {.lex_state = 4, .external_lex_state = 4},
  [141] = {.lex_state = 4, .external_lex_state = 4},
  [142] = {.lex_state = 4, .external_lex_state = 4},
  [143] = {.lex_state = 4, .external_lex_state = 4},
  [144] = {.lex_state = 4, .external_lex_state = 4},
  [145] = {.lex_state = 4, .external_lex_state = 4},
  [146] = {.lex_state = 4, .external_lex_state = 4},
  [147] = {.lex_state = 4, .external_lex_state = 4},
  [148] = {.lex_state = 4, .external_lex_state = 4},
  [149] = {.lex_state = 4, .external_lex_state = 4},
  [150] = {.lex_state = 4, .external_lex_state = 4},
  [151] = {.lex_state = 4, .external_lex_state = 4},
  [152] = {.lex_state = 4, .external_lex_state = 4},
  [153] = {.lex_state = 4, .external_lex_state = 4},
  [154] = {.lex_state = 4, .external_lex_state = 4},
  [155] = {.lex_state = 4, .external_lex_state = 5},
  [156] = {.lex_state = 4, .external_lex_state = 4},
  [157] = {.lex_state = 4, .external_lex_state = 4},
  [158] = {.lex_state = 4, .external_lex_state = 4},
  [159] = {.lex_state = 4, .external_lex_state = 4},
  [160] = {.lex_state = 4, .external_lex_state = 4},
  [161] = {.lex_state = 4, .external_lex_state = 4},
  [162] = {.lex_state = 4, .external_lex_state = 4},
  [163] = {.lex_state = 4, .external_lex_state = 4},
  [164] = {.lex_state = 4, .external_lex_state = 4},
  [165] = {.lex_state = 4, .external_lex_state = 4},
  [166] = {.lex_state = 4, .external_lex_state = 4},
  [167] = {.lex_state = 4, .external_lex_state = 4},
  [168] = {.lex_state = 4, .external_lex_state = 4},
  [169] = {.lex_state = 4, .external_lex_state = 4},
  [170] = {.lex_state = 4, .external_lex_state = 4},
  [171] = {.lex_state = 4, .external_lex_state = 4},
  [172] = {.lex_state = 4, .external_lex_state = 4},
  [173] = {.lex_state = 4, .external_lex_state = 4},
  [174] = {.lex_state = 4, .external_lex_state = 4},
  [175] = {.lex_state = 4, .external_lex_state = 4},
  [176] = {.lex_state = 4, .external_lex_state = 4},
  [177] = {.lex_state = 4, .external_lex_state = 4},
  [178] = {.lex_state = 4, .external_lex_state = 4},
  [179] = {.lex_state = 4, .external_lex_state = 4},
  [180] = {.lex_state = 4, .external_lex_state = 4},
  [181] = {.lex_state = 4, .external_lex_state = 5},
  [182] = {.lex_state = 4, .external_lex_state = 5},
  [183] = {.lex_state = 4, .external_lex_state = 5},
  [184] = {.lex_state = 4, .external_lex_state = 4},
  [185] = {.lex_state = 4, .external_lex_state = 4},
  [186] = {.lex_state = 4, .external_lex_state = 4},
  [187] = {.lex_state = 4, .external_lex_state = 4},
  [188] = {.lex_state = 4, .external_lex_state = 4},
  [189] = {.lex_state = 4, .external_lex_state = 4},
  [190] = {.lex_state = 4, .external_lex_state = 4},
  [191] = {.lex_state = 4, .external_lex_state = 4},
  [192] = {.lex_state = 4, .external_lex_state = 4},
  [193] = {.lex_state = 4, .external_lex_state = 4},
  [194] = {.lex_state = 4, .external_lex_state = 4},
  [195] = {.lex_state = 4, .external_lex_state = 4},
  [196] = {.lex_state = 4, .external_lex_state = 4},
  [197] = {.lex_state = 4, .external_lex_state = 4},
  [198] = {.lex_state = 4, .external_lex_state = 4},
  [199] = {.lex_state = 4, .external_lex_state = 4},
  [200] = {.lex_state = 4, .external_lex_state = 4},
  [201] = {.lex_state = 4, .external_lex_state = 4},
  [202] = {.lex_state = 4, .external_lex_state = 4},
  [203] = {.lex_state = 4, .external_lex_state = 4},
  [204] = {.lex_state = 4, .external_lex_state = 4},
  [205] = {.lex_state = 4, .external_lex_state = 4},
  [206] = {.lex_state = 4, .external_lex_state = 4},
  [207] = {.lex_state = 4, .external_lex_state = 4},
  [208] = {.lex_state = 4, .external_lex_state = 4},
  [209] = {.lex_state = 4, .external_lex_state = 4},
  [210] = {.lex_state = 4, .external_lex_state = 4},
  [211] = {.lex_state = 4, .external_lex_state = 4},
  [212] = {.lex_state = 4, .external_lex_state = 4},
  [213] = {.lex_state = 4, .external_lex_state = 4},
  [214] = {.lex_state = 4, .external_lex_state = 4},
  [215] = {.lex_state = 4, .external_lex_state = 4},
  [216] = {.lex_state = 4, .external_lex_state = 4},
  [217] = {.lex_state = 4, .external_lex_state = 4},
  [218] = {.lex_state = 4, .external_lex_state = 4},
  [219] = {.lex_state = 4, .external_lex_state = 4},
  [220] = {.lex_state = 4, .external_lex_state = 4},
  [221] = {.lex_state = 4, .external_lex_state = 4},
  [222] = {.lex_state = 4, .external_lex_state = 4},
  [223] = {.lex_state = 4, .external_lex_state = 4},
  [224] = {.lex_state = 4, .external_lex_state = 4},
  [225] = {.lex_state = 4, .external_lex_state = 4},
  [226] = {.lex_state = 4, .external_lex_state = 4},
  [227] = {.lex_state = 4, .external_lex_state = 4},
  [228] = {.lex_state = 4, .external_lex_state = 4},
  [229] = {.lex_state = 4, .external_lex_state = 4},
  [230] = {.lex_state = 4, .external_lex_state = 4},
  [231] = {.lex_state = 4, .external_lex_state = 4},
  [232] = {.lex_state = 4, .external_lex_state = 4},
  [233] = {.lex_state = 4, .external_lex_state = 4},
  [234] = {.lex_state = 4, .external_lex_state = 4},
  [235] = {.lex_state = 4, .external_lex_state = 4},
  [236] = {.lex_state = 4, .external_lex_state = 4},
  [237] = {.lex_state = 4, .external_lex_state = 4},
  [238] = {.lex_state = 4, .external_lex_state = 4},
  [239] = {.lex_state = 4, .external_lex_state = 4},
  [240] = {.lex_state = 4, .external_lex_state = 4},
  [241] = {.lex_state = 4, .external_lex_state = 4},
  [242] = {.lex_state = 4, .external_lex_state = 4},
  [243] = {.lex_state = 4, .external_lex_state = 4},
  [244] = {.lex_state = 4, .external_lex_state = 4},
  [245] = {.lex_state = 4, .external_lex_state = 4},
  [246] = {.lex_state = 4, .external_lex_state = 4},
  [247] = {.lex_state = 4, .external_lex_state = 4},
  [248] = {.lex_state = 4, .external_lex_state = 4},
  [249] = {.lex_state = 4, .external_lex_state = 4},
  [250] = {.lex_state = 4, .external_lex_state = 4},
  [251] = {.lex_state = 4, .external_lex_state = 4},
  [252] = {.lex_state = 4, .external_lex_state = 4},
  [253] = {.lex_state = 4, .external_lex_state = 4},
  [254] = {.lex_state = 4, .external_lex_state = 4},
  [255] = {.lex_state = 4, .external_lex_state = 4},
  [256] = {.lex_state = 4, .external_lex_state = 4},
  [257] = {.lex_state = 4, .external_lex_state = 4},
  [258] = {.lex_state = 4, .external_lex_state = 4},
  [259] = {.lex_state = 4, .external_lex_state = 4},
  [260] = {.lex_state = 4, .external_lex_state = 4},
  [261] = {.lex_state = 4, .external_lex_state = 4},
  [262] = {.lex_state = 4, .external_lex_state = 4},
  [263] = {.lex_state = 4, .external_lex_state = 4},
  [264] = {.lex_state = 4, .external_lex_state = 4},
  [265] = {.lex_state = 4, .external_lex_state = 4},
  [266] = {.lex_state = 4, .external_lex_state = 4},
  [267] = {.lex_state = 4, .external_lex_state = 4},
  [268] = {.lex_state = 4, .external_lex_state = 4},
  [269] = {.lex_state = 4, .external_lex_state = 4},
  [270] = {.lex_state = 4, .external_lex_state = 4},
  [271] = {.lex_state = 4, .external_lex_state = 4},
  [272] = {.lex_state = 4, .external_lex_state = 4},
  [273] = {.lex_state = 4, .external_lex_state = 4},
  [274] = {.lex_state = 4, .external_lex_state = 4},
  [275] = {.lex_state = 4, .external_lex_state = 4},
  [276] = {.lex_state = 4, .external_lex_state = 4},
  [277] = {.lex_state = 4, .external_lex_state = 4},
  [278] = {.lex_state = 4, .external_lex_state = 4},
  [279] = {.lex_state = 4, .external_lex_state = 4},
  [280] = {.lex_state = 4, .external_lex_state = 4},
  [281] = {.lex_state = 4, .external_lex_state = 4},
  [282] = {.lex_state = 4, .external_lex_state = 4},
  [283] = {.lex_state = 4, .external_lex_state = 4},
  [284] = {.lex_state = 4, .external_lex_state = 4},
  [285] = {.lex_state = 4, .external_lex_state = 4},
  [286] = {.lex_state = 4, .external_lex_state = 4},
  [287] = {.lex_state = 4, .external_lex_state = 4},
  [288] = {.lex_state = 4, .external_lex_state = 4},
  [289] = {.lex_state = 4, .external_lex_state = 4},
  [290] = {.lex_state = 4, .external_lex_state = 4},
  [291] = {.lex_state = 4, .external_lex_state = 4},
  [292] = {.lex_state = 4, .external_lex_state = 4},
  [293] = {.lex_state = 4, .external_lex_state = 4},
  [294] = {.lex_state = 4, .external_lex_state = 4},
  [295] = {.lex_state = 4, .external_lex_state = 4},
  [296] = {.lex_state = 4, .external_lex_state = 4},
  [297] = {.lex_state = 4, .external_lex_state = 4},
  [298] = {.lex_state = 4, .external_lex_state = 4},
  [299] = {.lex_state = 4, .external_lex_state = 4},
  [300] = {.lex_state = 4, .external_lex_state = 4},
  [301] = {.lex_state = 4, .external_lex_state = 4},
  [302] = {.lex_state = 4, .external_lex_state = 4},
  [303] = {.lex_state = 4, .external_lex_state = 4},
  [304] = {.lex_state = 4, .external_lex_state = 4},
  [305] = {.lex_state = 4, .external_lex_state = 4},
  [306] = {.lex_state = 4, .external_lex_state = 4},
  [307] = {.lex_state = 4, .external_lex_state = 4},
  [308] = {.lex_state = 4, .external_lex_state = 4},
  [309] = {.lex_state = 4, .external_lex_state = 4},
  [310] = {.lex_state = 4, .external_lex_state = 4},
  [311] = {.lex_state = 4, .external_lex_state = 4},
  [312] = {.lex_state = 4, .external_lex_state = 4},
  [313] = {.lex_state = 4, .external_lex_state = 4},
  [314] = {.lex_state = 4, .external_lex_state = 4},
  [315] = {.lex_state = 4, .external_lex_state = 4},
  [316] = {.lex_state = 4, .external_lex_state = 4},
  [317] = {.lex_state = 4, .external_lex_state = 4},
  [318] = {.lex_state = 4, .external_lex_state = 4},
  [319] = {.lex_state = 4, .external_lex_state = 4},
  [320] = {.lex_state = 4, .external_lex_state = 4},
  [321] = {.lex_state = 4, .external_lex_state = 4},
  [322] = {.lex_state = 4, .external_lex_state = 4},
  [323] = {.lex_state = 4, .external_lex_state = 4},
  [324] = {.lex_state = 4, .external_lex_state = 4},
  [325] = {.lex_state = 4, .external_lex_state = 4},
  [326] = {.lex_state = 4, .external_lex_state = 4},
  [327] = {.lex_state = 4, .external_lex_state = 4},
  [328] = {.lex_state = 4, .external_lex_state = 4},
  [329] = {.lex_state = 4, .external_lex_state = 4},
  [330] = {.lex_state = 4, .external_lex_state = 4},
  [331] = {.lex_state = 4, .external_lex_state = 4},
  [332] = {.lex_state = 4, .external_lex_state = 4},
  [333] = {.lex_state = 4, .external_lex_state = 4},
  [334] = {.lex_state = 4, .external_lex_state = 4},
  [335] = {.lex_state = 4, .external_lex_state = 4},
  [336] = {.lex_state = 4, .external_lex_state = 4},
  [337] = {.lex_state = 4, .external_lex_state = 4},
  [338] = {.lex_state = 4, .external_lex_state = 4},
  [339] = {.lex_state = 4, .external_lex_state = 4},
  [340] = {.lex_state = 4, .external_lex_state = 4},
  [341] = {.lex_state = 4, .external_lex_state = 4},
  [342] = {.lex_state = 4, .external_lex_state = 4},
  [343] = {.lex_state = 4, .external_lex_state = 4},
  [344] = {.lex_state = 4, .external_lex_state = 4},
  [345] = {.lex_state = 4, .external_lex_state = 4},
  [346] = {.lex_state = 4, .external_lex_state = 4},
  [347] = {.lex_state = 4, .external_lex_state = 4},
  [348] = {.lex_state = 4, .external_lex_state = 4},
  [349] = {.lex_state = 4, .external_lex_state = 4},
  [350] = {.lex_state = 4, .external_lex_state = 4},
  [351] = {.lex_state = 4, .external_lex_state = 4},
  [352] = {.lex_state = 4, .external_lex_state = 4},
  [353] = {.lex_state = 4, .external_lex_state = 4},
  [354] = {.lex_state = 4, .external_lex_state = 4},
  [355] = {.lex_state = 4, .external_lex_state = 4},
  [356] = {.lex_state = 4, .external_lex_state = 4},
  [357] = {.lex_state = 4, .external_lex_state = 4},
  [358] = {.lex_state = 4, .external_lex_state = 4},
  [359] = {.lex_state = 4, .external_lex_state = 4},
  [360] = {.lex_state = 4, .external_lex_state = 4},
  [361] = {.lex_state = 4, .external_lex_state = 4},
  [362] = {.lex_state = 4, .external_lex_state = 4},
  [363] = {.lex_state = 4, .external_lex_state = 4},
  [364] = {.lex_state = 4, .external_lex_state = 4},
  [365] = {.lex_state = 4, .external_lex_state = 4},
  [366] = {.lex_state = 4, .external_lex_state = 4},
  [367] = {.lex_state = 4, .external_lex_state = 4},
  [368] = {.lex_state = 4, .external_lex_state = 4},
  [369] = {.lex_state = 4, .external_lex_state = 4},
  [370] = {.lex_state = 4, .external_lex_state = 4},
  [371] = {.lex_state = 4, .external_lex_state = 4},
  [372] = {.lex_state = 4, .external_lex_state = 4},
  [373] = {.lex_state = 4, .external_lex_state = 4},
  [374] = {.lex_state = 4, .external_lex_state = 4},
  [375] = {.lex_state = 4, .external_lex_state = 4},
  [376] = {.lex_state = 4, .external_lex_state = 4},
  [377] = {.lex_state = 4, .external_lex_state = 4},
  [378] = {.lex_state = 4, .external_lex_state = 4},
  [379] = {.lex_state = 4, .external_lex_state = 4},
  [380] = {.lex_state = 4, .external_lex_state = 4},
  [381] = {.lex_state = 4, .external_lex_state = 4},
  [382] = {.lex_state = 4, .external_lex_state = 4},
  [383] = {.lex_state = 4, .external_lex_state = 4},
  [384] = {.lex_state = 4, .external_lex_state = 4},
  [385] = {.lex_state = 4, .external_lex_state = 4},
  [386] = {.lex_state = 4, .external_lex_state = 4},
  [387] = {.lex_state = 4, .external_lex_state = 4},
  [388] = {.lex_state = 4, .external_lex_state = 4},
  [389] = {.lex_state = 4, .external_lex_state = 4},
  [390] = {.lex_state = 4, .external_lex_state = 4},
  [391] = {.lex_state = 4, .external_lex_state = 4},
  [392] = {.lex_state = 4, .external_lex_state = 4},
  [393] = {.lex_state = 4, .external_lex_state = 4},
  [394] = {.lex_state = 4, .external_lex_state = 4},
  [395] = {.lex_state = 4, .external_lex_state = 4},
  [396] = {.lex_state = 4, .external_lex_state = 4},
  [397] = {.lex_state = 4, .external_lex_state = 4},
  [398] = {.lex_state = 4, .external_lex_state = 4},
  [399] = {.lex_state = 4, .external_lex_state = 4},
  [400] = {.lex_state = 4, .external_lex_state = 4},
  [401] = {.lex_state = 4, .external_lex_state = 4},
  [402] = {.lex_state = 4, .external_lex_state = 4},
  [403] = {.lex_state = 4, .external_lex_state = 4},
  [404] = {.lex_state = 4, .external_lex_state = 4},
  [405] = {.lex_state = 4, .external_lex_state = 4},
  [406] = {.lex_state = 4, .external_lex_state = 4},
  [407] = {.lex_state = 4, .external_lex_state = 4},
  [408] = {.lex_state = 4, .external_lex_state = 4},
  [409] = {.lex_state = 4, .external_lex_state = 4},
  [410] = {.lex_state = 4, .external_lex_state = 4},
  [411] = {.lex_state = 4, .external_lex_state = 4},
  [412] = {.lex_state = 4, .external_lex_state = 4},
  [413] = {.lex_state = 4, .external_lex_state = 4},
  [414] = {.lex_state = 4, .external_lex_state = 4},
  [415] = {.lex_state = 4, .external_lex_state = 4},
  [416] = {.lex_state = 4, .external_lex_state = 4},
  [417] = {.lex_state = 4, .external_lex_state = 4},
  [418] = {.lex_state = 4, .external_lex_state = 4},
  [419] = {.lex_state = 4, .external_lex_state = 4},
  [420] = {.lex_state = 4, .external_lex_state = 4},
  [421] = {.lex_state = 4, .external_lex_state = 4},
  [422] = {.lex_state = 4, .external_lex_state = 4},
  [423] = {.lex_state = 4, .external_lex_state = 4},
  [424] = {.lex_state = 4, .external_lex_state = 4},
  [425] = {.lex_state = 4, .external_lex_state = 4},
  [426] = {.lex_state = 4, .external_lex_state = 4},
  [427] = {.lex_state = 4, .external_lex_state = 4},
  [428] = {.lex_state = 4, .external_lex_state = 4},
  [429] = {.lex_state = 4, .external_lex_state = 4},
  [430] = {.lex_state = 4, .external_lex_state = 4},
  [431] = {.lex_state = 4, .external_lex_state = 4},
  [432] = {.lex_state = 4, .external_lex_state = 4},
  [433] = {.lex_state = 4, .external_lex_state = 4},
  [434] = {.lex_state = 4, .external_lex_state = 4},
  [435] = {.lex_state = 4, .external_lex_state = 4},
  [436] = {.lex_state = 4, .external_lex_state = 4},
  [437] = {.lex_state = 4, .external_lex_state = 4},
  [438] = {.lex_state = 4, .external_lex_state = 4},
  [439] = {.lex_state = 4, .external_lex_state = 4},
  [440] = {.lex_state = 4, .external_lex_state = 4},
  [441] = {.lex_state = 4, .external_lex_state = 4},
  [442] = {.lex_state = 4, .external_lex_state = 4},
  [443] = {.lex_state = 4, .external_lex_state = 4},
  [444] = {.lex_state = 4, .external_lex_state = 4},
  [445] = {.lex_state = 4, .external_lex_state = 4},
  [446] = {.lex_state = 4, .external_lex_state = 4},
  [447] = {.lex_state = 4, .external_lex_state = 4},
  [448] = {.lex_state = 4, .external_lex_state = 4},
  [449] = {.lex_state = 4, .external_lex_state = 4},
  [450] = {.lex_state = 4, .external_lex_state = 4},
  [451] = {.lex_state = 4, .external_lex_state = 4},
  [452] = {.lex_state = 4, .external_lex_state = 4},
  [453] = {.lex_state = 4, .external_lex_state = 4},
  [454] = {.lex_state = 4, .external_lex_state = 4},
  [455] = {.lex_state = 4, .external_lex_state = 4},
  [456] = {.lex_state = 4, .external_lex_state = 4},
  [457] = {.lex_state = 4, .external_lex_state = 4},
  [458] = {.lex_state = 4, .external_lex_state = 4},
  [459] = {.lex_state = 4, .external_lex_state = 4},
  [460] = {.lex_state = 4, .external_lex_state = 4},
  [461] = {.lex_state = 4, .external_lex_state = 4},
  [462] = {.lex_state = 4, .external_lex_state = 4},
  [463] = {.lex_state = 4, .external_lex_state = 4},
  [464] = {.lex_state = 4, .external_lex_state = 4},
  [465] = {.lex_state = 4, .external_lex_state = 4},
  [466] = {.lex_state = 4, .external_lex_state = 4},
  [467] = {.lex_state = 4, .external_lex_state = 4},
  [468] = {.lex_state = 4, .external_lex_state = 4},
  [469] = {.lex_state = 4, .external_lex_state = 4},
  [470] = {.lex_state = 4, .external_lex_state = 4},
  [471] = {.lex_state = 4, .external_lex_state = 4},
  [472] = {.lex_state = 4, .external_lex_state = 4},
  [473] = {.lex_state = 4, .external_lex_state = 4},
  [474] = {.lex_state = 4, .external_lex_state = 4},
  [475] = {.lex_state = 4, .external_lex_state = 4},
  [476] = {.lex_state = 4, .external_lex_state = 4},
  [477] = {.lex_state = 4, .external_lex_state = 4},
  [478] = {.lex_state = 4, .external_lex_state = 4},
  [479] = {.lex_state = 4, .external_lex_state = 4},
  [480] = {.lex_state = 4, .external_lex_state = 4},
  [481] = {.lex_state = 4, .external_lex_state = 4},
  [482] = {.lex_state = 4, .external_lex_state = 4},
  [483] = {.lex_state = 4, .external_lex_state = 4},
  [484] = {.lex_state = 4, .external_lex_state = 4},
  [485] = {.lex_state = 4, .external_lex_state = 4},
  [486] = {.lex_state = 4, .external_lex_state = 4},
  [487] = {.lex_state = 4, .external_lex_state = 4},
  [488] = {.lex_state = 4, .external_lex_state = 4},
  [489] = {.lex_state = 4, .external_lex_state = 4},
  [490] = {.lex_state = 4, .external_lex_state = 4},
  [491] = {.lex_state = 4, .external_lex_state = 4},
  [492] = {.lex_state = 4, .external_lex_state = 4},
  [493] = {.lex_state = 4, .external_lex_state = 4},
  [494] = {.lex_state = 4, .external_lex_state = 4},
  [495] = {.lex_state = 4, .external_lex_state = 4},
  [496] = {.lex_state = 4, .external_lex_state = 4},
  [497] = {.lex_state = 4, .external_lex_state = 4},
  [498] = {.lex_state = 4, .external_lex_state = 4},
  [499] = {.lex_state = 4, .external_lex_state = 4},
  [500] = {.lex_state = 4, .external_lex_state = 4},
  [501] = {.lex_state = 4, .external_lex_state = 4},
  [502] = {.lex_state = 4, .external_lex_state = 4},
  [503] = {.lex_state = 4, .external_lex_state = 4},
  [504] = {.lex_state = 4, .external_lex_state = 4},
  [505] = {.lex_state = 4, .external_lex_state = 4},
  [506] = {.lex_state = 4, .external_lex_state = 4},
  [507] = {.lex_state = 4, .external_lex_state = 4},
  [508] = {.lex_state = 4, .external_lex_state = 4},
  [509] = {.lex_state = 4, .external_lex_state = 4},
  [510] = {.lex_state = 4, .external_lex_state = 4},
  [511] = {.lex_state = 4, .external_lex_state = 4},
  [512] = {.lex_state = 4, .external_lex_state = 4},
  [513] = {.lex_state = 4, .external_lex_state = 4},
  [514] = {.lex_state = 4, .external_lex_state = 4},
  [515] = {.lex_state = 4, .external_lex_state = 4},
  [516] = {.lex_state = 4, .external_lex_state = 4},
  [517] = {.lex_state = 4, .external_lex_state = 4},
  [518] = {.lex_state = 4, .external_lex_state = 4},
  [519] = {.lex_state = 4, .external_lex_state = 4},
  [520] = {.lex_state = 4, .external_lex_state = 4},
  [521] = {.lex_state = 4, .external_lex_state = 4},
  [522] = {.lex_state = 4, .external_lex_state = 4},
  [523] = {.lex_state = 4, .external_lex_state = 4},
  [524] = {.lex_state = 4, .external_lex_state = 4},
  [525] = {.lex_state = 4, .external_lex_state = 4},
  [526] = {.lex_state = 4, .external_lex_state = 4},
  [527] = {.lex_state = 4, .external_lex_state = 4},
  [528] = {.lex_state = 4, .external_lex_state = 4},
  [529] = {.lex_state = 4, .external_lex_state = 4},
  [530] = {.lex_state = 4, .external_lex_state = 4},
  [531] = {.lex_state = 4, .external_lex_state = 4},
  [532] = {.lex_state = 4, .external_lex_state = 4},
  [533] = {.lex_state = 4, .external_lex_state = 4},
  [534] = {.lex_state = 4, .external_lex_state = 4},
  [535] = {.lex_state = 4, .external_lex_state = 4},
  [536] = {.lex_state = 4, .external_lex_state = 4},
  [537] = {.lex_state = 4, .external_lex_state = 4},
  [538] = {.lex_state = 4, .external_lex_state = 4},
  [539] = {.lex_state = 4, .external_lex_state = 4},
  [540] = {.lex_state = 4, .external_lex_state = 4},
  [541] = {.lex_state = 4, .external_lex_state = 4},
  [542] = {.lex_state = 4, .external_lex_state = 4},
  [543] = {.lex_state = 4, .external_lex_state = 4},
  [544] = {.lex_state = 4, .external_lex_state = 4},
  [545] = {.lex_state = 4, .external_lex_state = 4},
  [546] = {.lex_state = 4, .external_lex_state = 4},
  [547] = {.lex_state = 4, .external_lex_state = 4},
  [548] = {.lex_state = 4, .external_lex_state = 4},
  [549] = {.lex_state = 4, .external_lex_state = 4},
  [550] = {.lex_state = 4, .external_lex_state = 4},
  [551] = {.lex_state = 4, .external_lex_state = 4},
  [552] = {.lex_state = 4, .external_lex_state = 4},
  [553] = {.lex_state = 4, .external_lex_state = 4},
  [554] = {.lex_state = 4, .external_lex_state = 4},
  [555] = {.lex_state = 4, .external_lex_state = 4},
  [556] = {.lex_state = 4, .external_lex_state = 4},
  [557] = {.lex_state = 4, .external_lex_state = 4},
  [558] = {.lex_state = 4, .external_lex_state = 4},
  [559] = {.lex_state = 4, .external_lex_state = 4},
  [560] = {.lex_state = 4, .external_lex_state = 4},
  [561] = {.lex_state = 4, .external_lex_state = 4},
  [562] = {.lex_state = 4, .external_lex_state = 4},
  [563] = {.lex_state = 4, .external_lex_state = 4},
  [564] = {.lex_state = 4, .external_lex_state = 4},
  [565] = {.lex_state = 4, .external_lex_state = 4},
  [566] = {.lex_state = 4, .external_lex_state = 4},
  [567] = {.lex_state = 4, .external_lex_state = 4},
  [568] = {.lex_state = 4, .external_lex_state = 4},
  [569] = {.lex_state = 4, .external_lex_state = 4},
  [570] = {.lex_state = 4, .external_lex_state = 4},
  [571] = {.lex_state = 4, .external_lex_state = 4},
  [572] = {.lex_state = 4, .external_lex_state = 4},
  [573] = {.lex_state = 4, .external_lex_state = 4},
  [574] = {.lex_state = 4, .external_lex_state = 4},
  [575] = {.lex_state = 4, .external_lex_state = 4},
  [576] = {.lex_state = 4, .external_lex_state = 4},
  [577] = {.lex_state = 4, .external_lex_state = 4},
  [578] = {.lex_state = 4, .external_lex_state = 4},
  [579] = {.lex_state = 4, .external_lex_state = 4},
  [580] = {.lex_state = 4, .external_lex_state = 4},
  [581] = {.lex_state = 4, .external_lex_state = 4},
  [582] = {.lex_state = 4, .external_lex_state = 4},
  [583] = {.lex_state = 4, .external_lex_state = 4},
  [584] = {.lex_state = 4, .external_lex_state = 4},
  [585] = {.lex_state = 4, .external_lex_state = 4},
  [586] = {.lex_state = 4, .external_lex_state = 4},
  [587] = {.lex_state = 4, .external_lex_state = 4},
  [588] = {.lex_state = 4, .external_lex_state = 4},
  [589] = {.lex_state = 4, .external_lex_state = 4},
  [590] = {.lex_state = 4, .external_lex_state = 4},
  [591] = {.lex_state = 4, .external_lex_state = 4},
  [592] = {.lex_state = 4, .external_lex_state = 4},
  [593] = {.lex_state = 4, .external_lex_state = 4},
  [594] = {.lex_state = 4, .external_lex_state = 4},
  [595] = {.lex_state = 4, .external_lex_state = 4},
  [596] = {.lex_state = 4, .external_lex_state = 4},
  [597] = {.lex_state = 4, .external_lex_state = 4},
  [598] = {.lex_state = 4, .external_lex_state = 4},
  [599] = {.lex_state = 4, .external_lex_state = 4},
  [600] = {.lex_state = 4, .external_lex_state = 4},
  [601] = {.lex_state = 4, .external_lex_state = 4},
  [602] = {.lex_state = 4, .external_lex_state = 4},
  [603] = {.lex_state = 4, .external_lex_state = 4},
  [604] = {.lex_state = 4, .external_lex_state = 4},
  [605] = {.lex_state = 4, .external_lex_state = 4},
  [606] = {.lex_state = 4, .external_lex_state = 4},
  [607] = {.lex_state = 4, .external_lex_state = 4},
  [608] = {.lex_state = 4, .external_lex_state = 4},
  [609] = {.lex_state = 4, .external_lex_state = 4},
  [610] = {.lex_state = 4, .external_lex_state = 4},
  [611] = {.lex_state = 4, .external_lex_state = 4},
  [612] = {.lex_state = 4, .external_lex_state = 4},
  [613] = {.lex_state = 4, .external_lex_state = 4},
  [614] = {.lex_state = 4, .external_lex_state = 4},
  [615] = {.lex_state = 4, .external_lex_state = 4},
  [616] = {.lex_state = 4, .external_lex_state = 4},
  [617] = {.lex_state = 4, .external_lex_state = 4},
  [618] = {.lex_state = 4, .external_lex_state = 4},
  [619] = {.lex_state = 4, .external_lex_state = 4},
  [620] = {.lex_state = 4, .external_lex_state = 4},
  [621] = {.lex_state = 4, .external_lex_state = 4},
  [622] = {.lex_state = 4, .external_lex_state = 4},
  [623] = {.lex_state = 4, .external_lex_state = 4},
  [624] = {.lex_state = 4, .external_lex_state = 4},
  [625] = {.lex_state = 4, .external_lex_state = 4},
  [626] = {.lex_state = 4, .external_lex_state = 4},
  [627] = {.lex_state = 4, .external_lex_state = 4},
  [628] = {.lex_state = 4, .external_lex_state = 4},
  [629] = {.lex_state = 4, .external_lex_state = 4},
  [630] = {.lex_state = 4, .external_lex_state = 4},
  [631] = {.lex_state = 4, .external_lex_state = 4},
  [632] = {.lex_state = 4, .external_lex_state = 4},
  [633] = {.lex_state = 4, .external_lex_state = 4},
  [634] = {.lex_state = 4, .external_lex_state = 4},
  [635] = {.lex_state = 4, .external_lex_state = 4},
  [636] = {.lex_state = 4, .external_lex_state = 4},
  [637] = {.lex_state = 4, .external_lex_state = 4},
  [638] = {.lex_state = 4, .external_lex_state = 4},
  [639] = {.lex_state = 4, .external_lex_state = 4},
  [640] = {.lex_state = 4, .external_lex_state = 4},
  [641] = {.lex_state = 4, .external_lex_state = 4},
  [642] = {.lex_state = 4, .external_lex_state = 4},
  [643] = {.lex_state = 4, .external_lex_state = 4},
  [644] = {.lex_state = 4, .external_lex_state = 4},
  [645] = {.lex_state = 4, .external_lex_state = 4},
  [646] = {.lex_state = 4, .external_lex_state = 4},
  [647] = {.lex_state = 4, .external_lex_state = 4},
  [648] = {.lex_state = 4, .external_lex_state = 4},
  [649] = {.lex_state = 4, .external_lex_state = 4},
  [650] = {.lex_state = 4, .external_lex_state = 4},
  [651] = {.lex_state = 4, .external_lex_state = 4},
  [652] = {.lex_state = 4, .external_lex_state = 4},
  [653] = {.lex_state = 4, .external_lex_state = 4},
  [654] = {.lex_state = 4, .external_lex_state = 4},
  [655] = {.lex_state = 4, .external_lex_state = 4},
  [656] = {.lex_state = 4, .external_lex_state = 4},
  [657] = {.lex_state = 4, .external_lex_state = 4},
  [658] = {.lex_state = 4, .external_lex_state = 4},
  [659] = {.lex_state = 4, .external_lex_state = 4},
  [660] = {.lex_state = 4, .external_lex_state = 4},
  [661] = {.lex_state = 4, .external_lex_state = 4},
  [662] = {.lex_state = 4, .external_lex_state = 4},
  [663] = {.lex_state = 4, .external_lex_state = 4},
  [664] = {.lex_state = 4, .external_lex_state = 4},
  [665] = {.lex_state = 4, .external_lex_state = 4},
  [666] = {.lex_state = 4, .external_lex_state = 4},
  [667] = {.lex_state = 4, .external_lex_state = 4},
  [668] = {.lex_state = 4, .external_lex_state = 4},
  [669] = {.lex_state = 4, .external_lex_state = 4},
  [670] = {.lex_state = 4, .external_lex_state = 4},
  [671] = {.lex_state = 4, .external_lex_state = 4},
  [672] = {.lex_state = 4, .external_lex_state = 4},
  [673] = {.lex_state = 4, .external_lex_state = 4},
  [674] = {.lex_state = 4, .external_lex_state = 4},
  [675] = {.lex_state = 4, .external_lex_state = 4},
  [676] = {.lex_state = 4, .external_lex_state = 4},
  [677] = {.lex_state = 4, .external_lex_state = 4},
  [678] = {.lex_state = 4, .external_lex_state = 4},
  [679] = {.lex_state = 4, .external_lex_state = 4},
  [680] = {.lex_state = 4, .external_lex_state = 4},
  [681] = {.lex_state = 4, .external_lex_state = 4},
  [682] = {.lex_state = 4, .external_lex_state = 4},
  [683] = {.lex_state = 4, .external_lex_state = 4},
  [684] = {.lex_state = 4, .external_lex_state = 4},
  [685] = {.lex_state = 4, .external_lex_state = 4},
  [686] = {.lex_state = 4, .external_lex_state = 4},
  [687] = {.lex_state = 4, .external_lex_state = 4},
  [688] = {.lex_state = 4, .external_lex_state = 4},
  [689] = {.lex_state = 4, .external_lex_state = 4},
  [690] = {.lex_state = 4, .external_lex_state = 4},
  [691] = {.lex_state = 4, .external_lex_state = 4},
  [692] = {.lex_state = 4, .external_lex_state = 4},
  [693] = {.lex_state = 4, .external_lex_state = 4},
  [694] = {.lex_state = 4, .external_lex_state = 4},
  [695] = {.lex_state = 4, .external_lex_state = 4},
  [696] = {.lex_state = 4, .external_lex_state = 4},
  [697] = {.lex_state = 4, .external_lex_state = 4},
  [698] = {.lex_state = 4, .external_lex_state = 4},
  [699] = {.lex_state = 4, .external_lex_state = 4},
  [700] = {.lex_state = 4, .external_lex_state = 4},
  [701] = {.lex_state = 4, .external_lex_state = 4},
  [702] = {.lex_state = 4, .external_lex_state = 4},
  [703] = {.lex_state = 4, .external_lex_state = 4},
  [704] = {.lex_state = 4, .external_lex_state = 4},
  [705] = {.lex_state = 4, .external_lex_state = 4},
  [706] = {.lex_state = 4, .external_lex_state = 4},
  [707] = {.lex_state = 4, .external_lex_state = 4},
  [708] = {.lex_state = 4, .external_lex_state = 4},
  [709] = {.lex_state = 4, .external_lex_state = 4},
  [710] = {.lex_state = 4, .external_lex_state = 4},
  [711] = {.lex_state = 4, .external_lex_state = 4},
  [712] = {.lex_state = 4, .external_lex_state = 4},
  [713] = {.lex_state = 4, .external_lex_state = 4},
  [714] = {.lex_state = 4, .external_lex_state = 4},
  [715] = {.lex_state = 4, .external_lex_state = 4},
  [716] = {.lex_state = 4, .external_lex_state = 4},
  [717] = {.lex_state = 4, .external_lex_state = 4},
  [718] = {.lex_state = 4, .external_lex_state = 4},
  [719] = {.lex_state = 4, .external_lex_state = 4},
  [720] = {.lex_state = 4, .external_lex_state = 4},
  [721] = {.lex_state = 4, .external_lex_state = 4},
  [722] = {.lex_state = 4, .external_lex_state = 4},
  [723] = {.lex_state = 4, .external_lex_state = 4},
  [724] = {.lex_state = 4, .external_lex_state = 4},
  [725] = {.lex_state = 4, .external_lex_state = 4},
  [726] = {.lex_state = 4, .external_lex_state = 4},
  [727] = {.lex_state = 4, .external_lex_state = 4},
  [728] = {.lex_state = 4, .external_lex_state = 4},
  [729] = {.lex_state = 4, .external_lex_state = 4},
  [730] = {.lex_state = 4, .external_lex_state = 4},
  [731] = {.lex_state = 4, .external_lex_state = 4},
  [732] = {.lex_state = 4, .external_lex_state = 4},
  [733] = {.lex_state = 4, .external_lex_state = 4},
  [734] = {.lex_state = 4, .external_lex_state = 4},
  [735] = {.lex_state = 4, .external_lex_state = 4},
  [736] = {.lex_state = 4, .external_lex_state = 4},
  [737] = {.lex_state = 4, .external_lex_state = 4},
  [738] = {.lex_state = 4, .external_lex_state = 4},
  [739] = {.lex_state = 4, .external_lex_state = 4},
  [740] = {.lex_state = 4, .external_lex_state = 4},
  [741] = {.lex_state = 4, .external_lex_state = 4},
  [742] = {.lex_state = 4, .external_lex_state = 4},
  [743] = {.lex_state = 4, .external_lex_state = 4},
  [744] = {.lex_state = 4, .external_lex_state = 4},
  [745] = {.lex_state = 4, .external_lex_state = 4},
  [746] = {.lex_state = 4, .external_lex_state = 4},
  [747] = {.lex_state = 4, .external_lex_state = 4},
  [748] = {.lex_state = 4, .external_lex_state = 4},
  [749] = {.lex_state = 4, .external_lex_state = 4},
  [750] = {.lex_state = 4, .external_lex_state = 4},
  [751] = {.lex_state = 4, .external_lex_state = 4},
  [752] = {.lex_state = 4, .external_lex_state = 4},
  [753] = {.lex_state = 4, .external_lex_state = 4},
  [754] = {.lex_state = 4, .external_lex_state = 4},
  [755] = {.lex_state = 4, .external_lex_state = 4},
  [756] = {.lex_state = 4, .external_lex_state = 4},
  [757] = {.lex_state = 4, .external_lex_state = 4},
  [758] = {.lex_state = 4, .external_lex_state = 4},
  [759] = {.lex_state = 4, .external_lex_state = 4},
  [760] = {.lex_state = 4, .external_lex_state = 4},
  [761] = {.lex_state = 4, .external_lex_state = 4},
  [762] = {.lex_state = 4, .external_lex_state = 4},
  [763] = {.lex_state = 4, .external_lex_state = 4},
  [764] = {.lex_state = 4, .external_lex_state = 4},
  [765] = {.lex_state = 4, .external_lex_state = 4},
  [766] = {.lex_state = 4, .external_lex_state = 4},
  [767] = {.lex_state = 4, .external_lex_state = 4},
  [768] = {.lex_state = 4, .external_lex_state = 4},
  [769] = {.lex_state = 4, .external_lex_state = 4},
  [770] = {.lex_state = 4, .external_lex_state = 4},
  [771] = {.lex_state = 4, .external_lex_state = 4},
  [772] = {.lex_state = 4, .external_lex_state = 4},
  [773] = {.lex_state = 4, .external_lex_state = 4},
  [774] = {.lex_state = 4, .external_lex_state = 4},
  [775] = {.lex_state = 4, .external_lex_state = 4},
  [776] = {.lex_state = 4, .external_lex_state = 4},
  [777] = {.lex_state = 4, .external_lex_state = 4},
  [778] = {.lex_state = 4, .external_lex_state = 4},
  [779] = {.lex_state = 4, .external_lex_state = 4},
  [780] = {.lex_state = 4, .external_lex_state = 4},
  [781] = {.lex_state = 4, .external_lex_state = 4},
  [782] = {.lex_state = 4, .external_lex_state = 4},
  [783] = {.lex_state = 4, .external_lex_state = 4},
  [784] = {.lex_state = 4, .external_lex_state = 4},
  [785] = {.lex_state = 4, .external_lex_state = 4},
  [786] = {.lex_state = 4, .external_lex_state = 4},
  [787] = {.lex_state = 4, .external_lex_state = 4},
  [788] = {.lex_state = 4, .external_lex_state = 4},
  [789] = {.lex_state = 4, .external_lex_state = 4},
  [790] = {.lex_state = 4, .external_lex_state = 4},
  [791] = {.lex_state = 4, .external_lex_state = 4},
  [792] = {.lex_state = 4, .external_lex_state = 4},
  [793] = {.lex_state = 4, .external_lex_state = 4},
  [794] = {.lex_state = 4, .external_lex_state = 4},
  [795] = {.lex_state = 4, .external_lex_state = 4},
  [796] = {.lex_state = 4, .external_lex_state = 4},
  [797] = {.lex_state = 4, .external_lex_state = 4},
  [798] = {.lex_state = 4, .external_lex_state = 4},
  [799] = {.lex_state = 4, .external_lex_state = 4},
  [800] = {.lex_state = 4, .external_lex_state = 4},
  [801] = {.lex_state = 4, .external_lex_state = 4},
  [802] = {.lex_state = 4, .external_lex_state = 4},
  [803] = {.lex_state = 4, .external_lex_state = 4},
  [804] = {.lex_state = 4, .external_lex_state = 4},
  [805] = {.lex_state = 4, .external_lex_state = 4},
  [806] = {.lex_state = 4, .external_lex_state = 4},
  [807] = {.lex_state = 4, .external_lex_state = 4},
  [808] = {.lex_state = 4, .external_lex_state = 4},
  [809] = {.lex_state = 4, .external_lex_state = 4},
  [810] = {.lex_state = 4, .external_lex_state = 4},
  [811] = {.lex_state = 4, .external_lex_state = 4},
  [812] = {.lex_state = 4, .external_lex_state = 4},
  [813] = {.lex_state = 4, .external_lex_state = 4},
  [814] = {.lex_state = 4, .external_lex_state = 4},
  [815] = {.lex_state = 4, .external_lex_state = 4},
  [816] = {.lex_state = 4, .external_lex_state = 4},
  [817] = {.lex_state = 4, .external_lex_state = 4},
  [818] = {.lex_state = 4, .external_lex_state = 4},
  [819] = {.lex_state = 4, .external_lex_state = 4},
  [820] = {.lex_state = 4, .external_lex_state = 4},
  [821] = {.lex_state = 4, .external_lex_state = 4},
  [822] = {.lex_state = 4, .external_lex_state = 4},
  [823] = {.lex_state = 4, .external_lex_state = 4},
  [824] = {.lex_state = 4, .external_lex_state = 4},
  [825] = {.lex_state = 4, .external_lex_state = 4},
  [826] = {.lex_state = 4, .external_lex_state = 4},
  [827] = {.lex_state = 4, .external_lex_state = 4},
  [828] = {.lex_state = 4, .external_lex_state = 4},
  [829] = {.lex_state = 4, .external_lex_state = 4},
  [830] = {.lex_state = 4, .external_lex_state = 4},
  [831] = {.lex_state = 4, .external_lex_state = 4},
  [832] = {.lex_state = 4, .external_lex_state = 4},
  [833] = {.lex_state = 4, .external_lex_state = 4},
  [834] = {.lex_state = 4, .external_lex_state = 4},
  [835] = {.lex_state = 4, .external_lex_state = 4},
  [836] = {.lex_state = 4, .external_lex_state = 4},
  [837] = {.lex_state = 4, .external_lex_state = 4},
  [838] = {.lex_state = 4, .external_lex_state = 4},
  [839] = {.lex_state = 4, .external_lex_state = 4},
  [840] = {.lex_state = 4, .external_lex_state = 4},
  [841] = {.lex_state = 4, .external_lex_state = 4},
  [842] = {.lex_state = 4, .external_lex_state = 4},
  [843] = {.lex_state = 4, .external_lex_state = 4},
  [844] = {.lex_state = 4, .external_lex_state = 4},
  [845] = {.lex_state = 4, .external_lex_state = 4},
  [846] = {.lex_state = 4, .external_lex_state = 4},
  [847] = {.lex_state = 4, .external_lex_state = 4},
  [848] = {.lex_state = 4, .external_lex_state = 4},
  [849] = {.lex_state = 4, .external_lex_state = 4},
  [850] = {.lex_state = 4, .external_lex_state = 4},
  [851] = {.lex_state = 4, .external_lex_state = 4},
  [852] = {.lex_state = 4, .external_lex_state = 4},
  [853] = {.lex_state = 4, .external_lex_state = 4},
  [854] = {.lex_state = 4, .external_lex_state = 4},
  [855] = {.lex_state = 4, .external_lex_state = 4},
  [856] = {.lex_state = 4, .external_lex_state = 4},
  [857] = {.lex_state = 4, .external_lex_state = 4},
  [858] = {.lex_state = 4, .external_lex_state = 4},
  [859] = {.lex_state = 4, .external_lex_state = 4},
  [860] = {.lex_state = 4, .external_lex_state = 4},
  [861] = {.lex_state = 4, .external_lex_state = 4},
  [862] = {.lex_state = 4, .external_lex_state = 4},
  [863] = {.lex_state = 4, .external_lex_state = 4},
  [864] = {.lex_state = 4, .external_lex_state = 4},
  [865] = {.lex_state = 4, .external_lex_state = 4},
  [866] = {.lex_state = 4, .external_lex_state = 4},
  [867] = {.lex_state = 4, .external_lex_state = 4},
  [868] = {.lex_state = 4, .external_lex_state = 4},
  [869] = {.lex_state = 4, .external_lex_state = 4},
  [870] = {.lex_state = 4, .external_lex_state = 4},
  [871] = {.lex_state = 4, .external_lex_state = 4},
  [872] = {.lex_state = 4, .external_lex_state = 4},
  [873] = {.lex_state = 4, .external_lex_state = 4},
  [874] = {.lex_state = 4, .external_lex_state = 4},
  [875] = {.lex_state = 4, .external_lex_state = 4},
  [876] = {.lex_state = 4, .external_lex_state = 4},
  [877] = {.lex_state = 4, .external_lex_state = 4},
  [878] = {.lex_state = 4, .external_lex_state = 4},
  [879] = {.lex_state = 4, .external_lex_state = 4},
  [880] = {.lex_state = 4, .external_lex_state = 4},
  [881] = {.lex_state = 4, .external_lex_state = 4},
  [882] = {.lex_state = 4, .external_lex_state = 4},
  [883] = {.lex_state = 4, .external_lex_state = 4},
  [884] = {.lex_state = 4, .external_lex_state = 4},
  [885] = {.lex_state = 4, .external_lex_state = 4},
  [886] = {.lex_state = 4, .external_lex_state = 4},
  [887] = {.lex_state = 4, .external_lex_state = 4},
  [888] = {.lex_state = 4, .external_lex_state = 4},
  [889] = {.lex_state = 4, .external_lex_state = 4},
  [890] = {.lex_state = 4, .external_lex_state = 4},
  [891] = {.lex_state = 4, .external_lex_state = 4},
  [892] = {.lex_state = 4, .external_lex_state = 4},
  [893] = {.lex_state = 4, .external_lex_state = 4},
  [894] = {.lex_state = 4, .external_lex_state = 4},
  [895] = {.lex_state = 4, .external_lex_state = 4},
  [896] = {.lex_state = 4, .external_lex_state = 4},
  [897] = {.lex_state = 4, .external_lex_state = 4},
  [898] = {.lex_state = 4, .external_lex_state = 4},
  [899] = {.lex_state = 4, .external_lex_state = 4},
  [900] = {.lex_state = 4, .external_lex_state = 4},
  [901] = {.lex_state = 4, .external_lex_state = 4},
  [902] = {.lex_state = 4, .external_lex_state = 4},
  [903] = {.lex_state = 4, .external_lex_state = 4},
  [904] = {.lex_state = 4, .external_lex_state = 4},
  [905] = {.lex_state = 4, .external_lex_state = 4},
  [906] = {.lex_state = 4, .external_lex_state = 4},
  [907] = {.lex_state = 4, .external_lex_state = 4},
  [908] = {.lex_state = 4, .external_lex_state = 4},
  [909] = {.lex_state = 4, .external_lex_state = 4},
  [910] = {.lex_state = 4, .external_lex_state = 4},
  [911] = {.lex_state = 4, .external_lex_state = 4},
  [912] = {.lex_state = 4, .external_lex_state = 4},
  [913] = {.lex_state = 4, .external_lex_state = 4},
  [914] = {.lex_state = 4, .external_lex_state = 4},
  [915] = {.lex_state = 4, .external_lex_state = 4},
  [916] = {.lex_state = 4, .external_lex_state = 4},
  [917] = {.lex_state = 4, .external_lex_state = 4},
  [918] = {.lex_state = 4, .external_lex_state = 4},
  [919] = {.lex_state = 4, .external_lex_state = 4},
  [920] = {.lex_state = 4, .external_lex_state = 4},
  [921] = {.lex_state = 4, .external_lex_state = 4},
  [922] = {.lex_state = 4, .external_lex_state = 4},
  [923] = {.lex_state = 4, .external_lex_state = 4},
  [924] = {.lex_state = 4, .external_lex_state = 4},
  [925] = {.lex_state = 4, .external_lex_state = 4},
  [926] = {.lex_state = 4, .external_lex_state = 4},
  [927] = {.lex_state = 4, .external_lex_state = 4},
  [928] = {.lex_state = 4, .external_lex_state = 4},
  [929] = {.lex_state = 4, .external_lex_state = 4},
  [930] = {.lex_state = 4, .external_lex_state = 4},
  [931] = {.lex_state = 4, .external_lex_state = 4},
  [932] = {.lex_state = 4, .external_lex_state = 4},
  [933] = {.lex_state = 4, .external_lex_state = 4},
  [934] = {.lex_state = 4, .external_lex_state = 4},
  [935] = {.lex_state = 4, .external_lex_state = 4},
  [936] = {.lex_state = 4, .external_lex_state = 4},
  [937] = {.lex_state = 4, .external_lex_state = 4},
  [938] = {.lex_state = 4, .external_lex_state = 4},
  [939] = {.lex_state = 4, .external_lex_state = 4},
  [940] = {.lex_state = 4, .external_lex_state = 4},
  [941] = {.lex_state = 4, .external_lex_state = 4},
  [942] = {.lex_state = 4, .external_lex_state = 4},
  [943] = {.lex_state = 4, .external_lex_state = 4},
  [944] = {.lex_state = 4, .external_lex_state = 4},
  [945] = {.lex_state = 4, .external_lex_state = 4},
  [946] = {.lex_state = 4, .external_lex_state = 4},
  [947] = {.lex_state = 4, .external_lex_state = 4},
  [948] = {.lex_state = 4, .external_lex_state = 4},
  [949] = {.lex_state = 4, .external_lex_state = 4},
  [950] = {.lex_state = 4, .external_lex_state = 4},
  [951] = {.lex_state = 4, .external_lex_state = 4},
  [952] = {.lex_state = 4, .external_lex_state = 4},
  [953] = {.lex_state = 4, .external_lex_state = 4},
  [954] = {.lex_state = 4, .external_lex_state = 4},
  [955] = {.lex_state = 4, .external_lex_state = 4},
  [956] = {.lex_state = 4, .external_lex_state = 4},
  [957] = {.lex_state = 4, .external_lex_state = 4},
  [958] = {.lex_state = 4, .external_lex_state = 4},
  [959] = {.lex_state = 4, .external_lex_state = 4},
  [960] = {.lex_state = 4, .external_lex_state = 4},
  [961] = {.lex_state = 4, .external_lex_state = 4},
  [962] = {.lex_state = 4, .external_lex_state = 4},
  [963] = {.lex_state = 4, .external_lex_state = 4},
  [964] = {.lex_state = 4, .external_lex_state = 4},
  [965] = {.lex_state = 4, .external_lex_state = 4},
  [966] = {.lex_state = 4, .external_lex_state = 4},
  [967] = {.lex_state = 4, .external_lex_state = 4},
  [968] = {.lex_state = 4, .external_lex_state = 4},
  [969] = {.lex_state = 4, .external_lex_state = 4},
  [970] = {.lex_state = 4, .external_lex_state = 4},
  [971] = {.lex_state = 4, .external_lex_state = 4},
  [972] = {.lex_state = 4, .external_lex_state = 4},
  [973] = {.lex_state = 4, .external_lex_state = 4},
  [974] = {.lex_state = 4, .external_lex_state = 4},
  [975] = {.lex_state = 4, .external_lex_state = 4},
  [976] = {.lex_state = 4, .external_lex_state = 4},
  [977] = {.lex_state = 4, .external_lex_state = 4},
  [978] = {.lex_state = 4, .external_lex_state = 4},
  [979] = {.lex_state = 4, .external_lex_state = 4},
  [980] = {.lex_state = 4, .external_lex_state = 4},
  [981] = {.lex_state = 4, .external_lex_state = 4},
  [982] = {.lex_state = 4, .external_lex_state = 4},
  [983] = {.lex_state = 4, .external_lex_state = 4},
  [984] = {.lex_state = 4, .external_lex_state = 4},
  [985] = {.lex_state = 4, .external_lex_state = 4},
  [986] = {.lex_state = 4, .external_lex_state = 4},
  [987] = {.lex_state = 4, .external_lex_state = 4},
  [988] = {.lex_state = 4, .external_lex_state = 4},
  [989] = {.lex_state = 4, .external_lex_state = 4},
  [990] = {.lex_state = 4, .external_lex_state = 4},
  [991] = {.lex_state = 4, .external_lex_state = 4},
  [992] = {.lex_state = 4, .external_lex_state = 4},
  [993] = {.lex_state = 4, .external_lex_state = 4},
  [994] = {.lex_state = 4, .external_lex_state = 4},
  [995] = {.lex_state = 4, .external_lex_state = 4},
  [996] = {.lex_state = 4, .external_lex_state = 4},
  [997] = {.lex_state = 4, .external_lex_state = 4},
  [998] = {.lex_state = 4, .external_lex_state = 4},
  [999] = {.lex_state = 4, .external_lex_state = 4},
  [1000] = {.lex_state = 4, .external_lex_state = 4},
  [1001] = {.lex_state = 4, .external_lex_state = 4},
  [1002] = {.lex_state = 4, .external_lex_state = 4},
  [1003] = {.lex_state = 4, .external_lex_state = 4},
  [1004] = {.lex_state = 4, .external_lex_state = 4},
  [1005] = {.lex_state = 4, .external_lex_state = 4},
  [1006] = {.lex_state = 4, .external_lex_state = 4},
  [1007] = {.lex_state = 4, .external_lex_state = 4},
  [1008] = {.lex_state = 4, .external_lex_state = 4},
  [1009] = {.lex_state = 4, .external_lex_state = 4},
  [1010] = {.lex_state = 4, .external_lex_state = 4},
  [1011] = {.lex_state = 4, .external_lex_state = 4},
  [1012] = {.lex_state = 4, .external_lex_state = 4},
  [1013] = {.lex_state = 4, .external_lex_state = 4},
  [1014] = {.lex_state = 4, .external_lex_state = 4},
  [1015] = {.lex_state = 4, .external_lex_state = 4},
  [1016] = {.lex_state = 4, .external_lex_state = 4},
  [1017] = {.lex_state = 4, .external_lex_state = 4},
  [1018] = {.lex_state = 4, .external_lex_state = 4},
  [1019] = {.lex_state = 4, .external_lex_state = 4},
  [1020] = {.lex_state = 4, .external_lex_state = 4},
  [1021] = {.lex_state = 4, .external_lex_state = 4},
  [1022] = {.lex_state = 4, .external_lex_state = 4},
  [1023] = {.lex_state = 4, .external_lex_state = 4},
  [1024] = {.lex_state = 4, .external_lex_state = 4},
  [1025] = {.lex_state = 4, .external_lex_state = 4},
  [1026] = {.lex_state = 4, .external_lex_state = 4},
  [1027] = {.lex_state = 4, .external_lex_state = 4},
  [1028] = {.lex_state = 4, .external_lex_state = 4},
  [1029] = {.lex_state = 4, .external_lex_state = 4},
  [1030] = {.lex_state = 4, .external_lex_state = 4},
  [1031] = {.lex_state = 4, .external_lex_state = 4},
  [1032] = {.lex_state = 4, .external_lex_state = 4},
  [1033] = {.lex_state = 4, .external_lex_state = 4},
  [1034] = {.lex_state = 4, .external_lex_state = 4},
  [1035] = {.lex_state = 4, .external_lex_state = 4},
  [1036] = {.lex_state = 4, .external_lex_state = 4},
  [1037] = {.lex_state = 4, .external_lex_state = 4},
  [1038] = {.lex_state = 4, .external_lex_state = 4},
  [1039] = {.lex_state = 4, .external_lex_state = 4},
  [1040] = {.lex_state = 4, .external_lex_state = 4},
  [1041] = {.lex_state = 4, .external_lex_state = 4},
  [1042] = {.lex_state = 4, .external_lex_state = 4},
  [1043] = {.lex_state = 4, .external_lex_state = 4},
  [1044] = {.lex_state = 4, .external_lex_state = 4},
  [1045] = {.lex_state = 4, .external_lex_state = 4},
  [1046] = {.lex_state = 4, .external_lex_state = 4},
  [1047] = {.lex_state = 4, .external_lex_state = 4},
  [1048] = {.lex_state = 4, .external_lex_state = 4},
  [1049] = {.lex_state = 4, .external_lex_state = 4},
  [1050] = {.lex_state = 4, .external_lex_state = 4},
  [1051] = {.lex_state = 4, .external_lex_state = 4},
  [1052] = {.lex_state = 4, .external_lex_state = 4},
  [1053] = {.lex_state = 4, .external_lex_state = 4},
  [1054] = {.lex_state = 4, .external_lex_state = 4},
  [1055] = {.lex_state = 4, .external_lex_state = 4},
  [1056] = {.lex_state = 4, .external_lex_state = 4},
  [1057] = {.lex_state = 4, .external_lex_state = 4},
  [1058] = {.lex_state = 4, .external_lex_state = 4},
  [1059] = {.lex_state = 4, .external_lex_state = 4},
  [1060] = {.lex_state = 4, .external_lex_state = 4},
  [1061] = {.lex_state = 4, .external_lex_state = 4},
  [1062] = {.lex_state = 4, .external_lex_state = 4},
  [1063] = {.lex_state = 4, .external_lex_state = 4},
  [1064] = {.lex_state = 4, .external_lex_state = 4},
  [1065] = {.lex_state = 4, .external_lex_state = 4},
  [1066] = {.lex_state = 4, .external_lex_state = 4},
  [1067] = {.lex_state = 4, .external_lex_state = 4},
  [1068] = {.lex_state = 4, .external_lex_state = 4},
  [1069] = {.lex_state = 4, .external_lex_state = 4},
  [1070] = {.lex_state = 4, .external_lex_state = 4},
  [1071] = {.lex_state = 4, .external_lex_state = 4},
  [1072] = {.lex_state = 4, .external_lex_state = 4},
  [1073] = {.lex_state = 4, .external_lex_state = 4},
  [1074] = {.lex_state = 4, .external_lex_state = 4},
  [1075] = {.lex_state = 4, .external_lex_state = 4},
  [1076] = {.lex_state = 4, .external_lex_state = 4},
  [1077] = {.lex_state = 4, .external_lex_state = 4},
  [1078] = {.lex_state = 4, .external_lex_state = 4},
  [1079] = {.lex_state = 4, .external_lex_state = 4},
  [1080] = {.lex_state = 4, .external_lex_state = 4},
  [1081] = {.lex_state = 4, .external_lex_state = 4},
  [1082] = {.lex_state = 4, .external_lex_state = 4},
  [1083] = {.lex_state = 4, .external_lex_state = 4},
  [1084] = {.lex_state = 4, .external_lex_state = 4},
  [1085] = {.lex_state = 7, .external_lex_state = 6},
  [1086] = {.lex_state = 7, .external_lex_state = 6},
  [1087] = {.lex_state = 7, .external_lex_state = 6},
  [1088] = {.lex_state = 7, .external_lex_state = 6},
  [1089] = {.lex_state = 7, .external_lex_state = 6},
  [1090] = {.lex_state = 7, .external_lex_state = 6},
  [1091] = {.lex_state = 7, .external_lex_state = 6},
  [1092] = {.lex_state = 7, .external_lex_state = 6},
  [1093] = {.lex_state = 7, .external_lex_state = 6},
  [1094] = {.lex_state = 7, .external_lex_state = 6},
  [1095] = {.lex_state = 7, .external_lex_state = 6},
  [1096] = {.lex_state = 7, .external_lex_state = 6},
  [1097] = {.lex_state = 7, .external_lex_state = 6},
  [1098] = {.lex_state = 7, .external_lex_state = 6},
  [1099] = {.lex_state = 7, .external_lex_state = 6},
  [1100] = {.lex_state = 7, .external_lex_state = 6},
  [1101] = {.lex_state = 8, .external_lex_state = 7},
  [1102] = {.lex_state = 229, .external_lex_state = 7},
  [1103] = {.lex_state = 229, .external_lex_state = 7},
  [1104] = {.lex_state = 8, .external_lex_state = 7},
  [1105] = {.lex_state = 7, .external_lex_state = 6},
  [1106] = {.lex_state = 7, .external_lex_state = 6},
  [1107] = {.lex_state = 7, .external_lex_state = 6},
  [1108] = {.lex_state = 7, .external_lex_state = 6},
  [1109] = {.lex_state = 7, .external_lex_state = 6},
  [1110] = {.lex_state = 9, .external_lex_state = 6},
  [1111] = {.lex_state = 9, .external_lex_state = 6},
  [1112] = {.lex_state = 9, .external_lex_state = 6},
  [1113] = {.lex_state = 9, .external_lex_state = 6},
  [1114] = {.lex_state = 9, .external_lex_state = 6},
  [1115] = {.lex_state = 9, .external_lex_state = 6},
  [1116] = {.lex_state = 9, .external_lex_state = 6},
  [1117] = {.lex_state = 9, .external_lex_state = 6},
  [1118] = {.lex_state = 9, .external_lex_state = 6},
  [1119] = {.lex_state = 9, .external_lex_state = 6},
  [1120] = {.lex_state = 9, .external_lex_state = 6},
  [1121] = {.lex_state = 9, .external_lex_state = 6},
  [1122] = {.lex_state = 9, .external_lex_state = 6},
  [1123] = {.lex_state = 9, .external_lex_state = 6},
  [1124] = {.lex_state = 9, .external_lex_state = 6},
  [1125] = {.lex_state = 9, .external_lex_state = 6},
  [1126] = {.lex_state = 9, .external_lex_state = 6},
  [1127] = {.lex_state = 9, .external_lex_state = 6},
  [1128] = {.lex_state = 9, .external_lex_state = 6},
  [1129] = {.lex_state = 9, .external_lex_state = 6},
  [1130] = {.lex_state = 9, .external_lex_state = 6},
  [1131] = {.lex_state = 9, .external_lex_state = 6},
  [1132] = {.lex_state = 9, .external_lex_state = 6},
  [1133] = {.lex_state = 9, .external_lex_state = 6},
  [1134] = {.lex_state = 9, .external_lex_state = 6},
  [1135] = {.lex_state = 9, .external_lex_state = 6},
  [1136] = {.lex_state = 9, .external_lex_state = 6},
  [1137] = {.lex_state = 9, .external_lex_state = 6},
  [1138] = {.lex_state = 9, .external_lex_state = 6},
  [1139] = {.lex_state = 9, .external_lex_state = 6},
  [1140] = {.lex_state = 9, .external_lex_state = 6},
  [1141] = {.lex_state = 9, .external_lex_state = 6},
  [1142] = {.lex_state = 9, .external_lex_state = 6},
  [1143] = {.lex_state = 9, .external_lex_state = 6},
  [1144] = {.lex_state = 9, .external_lex_state = 6},
  [1145] = {.lex_state = 9, .external_lex_state = 6},
  [1146] = {.lex_state = 9, .external_lex_state = 6},
  [1147] = {.lex_state = 9, .external_lex_state = 6},
  [1148] = {.lex_state = 9, .external_lex_state = 6},
  [1149] = {.lex_state = 9, .external_lex_state = 6},
  [1150] = {.lex_state = 9, .external_lex_state = 6},
  [1151] = {.lex_state = 9, .external_lex_state = 6},
  [1152] = {.lex_state = 9, .external_lex_state = 6},
  [1153] = {.lex_state = 9, .external_lex_state = 6},
  [1154] = {.lex_state = 9, .external_lex_state = 6},
  [1155] = {.lex_state = 9, .external_lex_state = 6},
  [1156] = {.lex_state = 9, .external_lex_state = 6},
  [1157] = {.lex_state = 9, .external_lex_state = 6},
  [1158] = {.lex_state = 9, .external_lex_state = 6},
  [1159] = {.lex_state = 9, .external_lex_state = 6},
  [1160] = {.lex_state = 229, .external_lex_state = 7},
  [1161] = {.lex_state = 229, .external_lex_state = 7},
  [1162] = {.lex_state = 229, .external_lex_state = 7},
  [1163] = {.lex_state = 229, .external_lex_state = 7},
  [1164] = {.lex_state = 229, .external_lex_state = 7},
  [1165] = {.lex_state = 229, .external_lex_state = 7},
  [1166] = {.lex_state = 229, .external_lex_state = 7},
  [1167] = {.lex_state = 229, .external_lex_state = 7},
  [1168] = {.lex_state = 229, .external_lex_state = 7},
  [1169] = {.lex_state = 8, .external_lex_state = 7},
  [1170] = {.lex_state = 229, .external_lex_state = 7},
  [1171] = {.lex_state = 229, .external_lex_state = 7},
  [1172] = {.lex_state = 8, .external_lex_state = 7},
  [1173] = {.lex_state = 8, .external_lex_state = 7},
  [1174] = {.lex_state = 8, .external_lex_state = 7},
  [1175] = {.lex_state = 229, .external_lex_state = 7},
  [1176] = {.lex_state = 8, .external_lex_state = 7},
  [1177] = {.lex_state = 8, .external_lex_state = 7},
  [1178] = {.lex_state = 8, .external_lex_state = 7},
  [1179] = {.lex_state = 229, .external_lex_state = 7},
  [1180] = {.lex_state = 8, .external_lex_state = 7},
  [1181] = {.lex_state = 229, .external_lex_state = 7},
  [1182] = {.lex_state = 229, .external_lex_state = 7},
  [1183] = {.lex_state = 229, .external_lex_state = 7},
  [1184] = {.lex_state = 229, .external_lex_state = 7},
  [1185] = {.lex_state = 229, .external_lex_state = 7},
  [1186] = {.lex_state = 229, .external_lex_state = 7},
  [1187] = {.lex_state = 229, .external_lex_state = 7},
  [1188] = {.lex_state = 229, .external_lex_state = 7},
  [1189] = {.lex_state = 229, .external_lex_state = 7},
  [1190] = {.lex_state = 229, .external_lex_state = 7},
  [1191] = {.lex_state = 8, .external_lex_state = 7},
  [1192] = {.lex_state = 8, .external_lex_state = 7},
  [1193] = {.lex_state = 8, .external_lex_state = 7},
  [1194] = {.lex_state = 8, .external_lex_state = 7},
  [1195] = {.lex_state = 8, .external_lex_state = 7},
  [1196] = {.lex_state = 8, .external_lex_state = 7},
  [1197] = {.lex_state = 229, .external_lex_state = 7},
  [1198] = {.lex_state = 229, .external_lex_state = 7},
  [1199] = {.lex_state = 8, .external_lex_state = 7},
  [1200] = {.lex_state = 229, .external_lex_state = 7},
  [1201] = {.lex_state = 8, .external_lex_state = 7},
  [1202] = {.lex_state = 8, .external_lex_state = 7},
  [1203] = {.lex_state = 229, .external_lex_state = 7},
  [1204] = {.lex_state = 229, .external_lex_state = 7},
  [1205] = {.lex_state = 8, .external_lex_state = 7},
  [1206] = {.lex_state = 8, .external_lex_state = 7},
  [1207] = {.lex_state = 8, .external_lex_state = 7},
  [1208] = {.lex_state = 229, .external_lex_state = 7},
  [1209] = {.lex_state = 8, .external_lex_state = 7},
  [1210] = {.lex_state = 8, .external_lex_state = 7},
  [1211] = {.lex_state = 8, .external_lex_state = 7},
  [1212] = {.lex_state = 8, .external_lex_state = 7},
  [1213] = {.lex_state = 8, .external_lex_state = 7},
  [1214] = {.lex_state = 8, .external_lex_state = 7},
  [1215] = {.lex_state = 229, .external_lex_state = 7},
  [1216] = {.lex_state = 229, .external_lex_state = 7},
  [1217] = {.lex_state = 8, .external_lex_state = 7},
  [1218] = {.lex_state = 8, .external_lex_state = 7},
  [1219] = {.lex_state = 8, .external_lex_state = 7},
  [1220] = {.lex_state = 8, .external_lex_state = 7},
  [1221] = {.lex_state = 8, .external_lex_state = 7},
  [1222] = {.lex_state = 8, .external_lex_state = 6},
  [1223] = {.lex_state = 229, .external_lex_state = 6},
  [1224] = {.lex_state = 8, .external_lex_state = 6},
  [1225] = {.lex_state = 229, .external_lex_state = 6},
  [1226] = {.lex_state = 8, .external_lex_state = 6},
  [1227] = {.lex_state = 229, .external_lex_state = 6},
  [1228] = {.lex_state = 8, .external_lex_state = 6},
  [1229] = {.lex_state = 8, .external_lex_state = 6},
  [1230] = {.lex_state = 229, .external_lex_state = 6},
  [1231] = {.lex_state = 229, .external_lex_state = 6},
  [1232] = {.lex_state = 8, .external_lex_state = 6},
  [1233] = {.lex_state = 8, .external_lex_state = 6},
  [1234] = {.lex_state = 229, .external_lex_state = 6},
  [1235] = {.lex_state = 229, .external_lex_state = 6},
  [1236] = {.lex_state = 229, .external_lex_state = 6},
  [1237] = {.lex_state = 8, .external_lex_state = 6},
  [1238] = {.lex_state = 8, .external_lex_state = 6},
  [1239] = {.lex_state = 8, .external_lex_state = 6},
  [1240] = {.lex_state = 229, .external_lex_state = 6},
  [1241] = {.lex_state = 8, .external_lex_state = 6},
  [1242] = {.lex_state = 8, .external_lex_state = 6},
  [1243] = {.lex_state = 8, .external_lex_state = 6},
  [1244] = {.lex_state = 8, .external_lex_state = 6},
  [1245] = {.lex_state = 229, .external_lex_state = 6},
  [1246] = {.lex_state = 229, .external_lex_state = 6},
  [1247] = {.lex_state = 8, .external_lex_state = 6},
  [1248] = {.lex_state = 8, .external_lex_state = 6},
  [1249] = {.lex_state = 229, .external_lex_state = 6},
  [1250] = {.lex_state = 8, .external_lex_state = 6},
  [1251] = {.lex_state = 229, .external_lex_state = 6},
  [1252] = {.lex_state = 229, .external_lex_state = 6},
  [1253] = {.lex_state = 8, .external_lex_state = 6},
  [1254] = {.lex_state = 229, .external_lex_state = 6},
  [1255] = {.lex_state = 8, .external_lex_state = 6},
  [1256] = {.lex_state = 229, .external_lex_state = 6},
  [1257] = {.lex_state = 8, .external_lex_state = 6},
  [1258] = {.lex_state = 8, .external_lex_state = 6},
  [1259] = {.lex_state = 8, .external_lex_state = 6},
  [1260] = {.lex_state = 8, .external_lex_state = 6},
  [1261] = {.lex_state = 8, .external_lex_state = 6},
  [1262] = {.lex_state = 229, .external_lex_state = 6},
  [1263] = {.lex_state = 229, .external_lex_state = 6},
  [1264] = {.lex_state = 229, .external_lex_state = 6},
  [1265] = {.lex_state = 8, .external_lex_state = 6},
  [1266] = {.lex_state = 8, .external_lex_state = 6},
  [1267] = {.lex_state = 8, .external_lex_state = 6},
  [1268] = {.lex_state = 229, .external_lex_state = 6},
  [1269] = {.lex_state = 229, .external_lex_state = 6},
  [1270] = {.lex_state = 229, .external_lex_state = 6},
  [1271] = {.lex_state = 229, .external_lex_state = 6},
  [1272] = {.lex_state = 229, .external_lex_state = 6},
  [1273] = {.lex_state = 229, .external_lex_state = 6},
  [1274] = {.lex_state = 8, .external_lex_state = 6},
  [1275] = {.lex_state = 229, .external_lex_state = 6},
  [1276] = {.lex_state = 8, .external_lex_state = 6},
  [1277] = {.lex_state = 8, .external_lex_state = 6},
  [1278] = {.lex_state = 229, .external_lex_state = 6},
  [1279] = {.lex_state = 229, .external_lex_state = 6},
  [1280] = {.lex_state = 229, .external_lex_state = 6},
  [1281] = {.lex_state = 8, .external_lex_state = 6},
  [1282] = {.lex_state = 229, .external_lex_state = 6},
  [1283] = {.lex_state = 229, .external_lex_state = 6},
  [1284] = {.lex_state = 8, .external_lex_state = 6},
  [1285] = {.lex_state = 8, .external_lex_state = 6},
  [1286] = {.lex_state = 229, .external_lex_state = 6},
  [1287] = {.lex_state = 229, .external_lex_state = 6},
  [1288] = {.lex_state = 8, .external_lex_state = 6},
  [1289] = {.lex_state = 229, .external_lex_state = 6},
  [1290] = {.lex_state = 229, .external_lex_state = 6},
  [1291] = {.lex_state = 8, .external_lex_state = 6},
  [1292] = {.lex_state = 229, .external_lex_state = 6},
  [1293] = {.lex_state = 8, .external_lex_state = 6},
  [1294] = {.lex_state = 229, .external_lex_state = 6},
  [1295] = {.lex_state = 229, .external_lex_state = 6},
  [1296] = {.lex_state = 229, .external_lex_state = 6},
  [1297] = {.lex_state = 229, .external_lex_state = 6},
  [1298] = {.lex_state = 8, .external_lex_state = 6},
  [1299] = {.lex_state = 8, .external_lex_state = 6},
  [1300] = {.lex_state = 8, .external_lex_state = 6},
  [1301] = {.lex_state = 8, .external_lex_state = 6},
  [1302] = {.lex_state = 8, .external_lex_state = 6},
  [1303] = {.lex_state = 229, .external_lex_state = 6},
  [1304] = {.lex_state = 229, .external_lex_state = 6},
  [1305] = {.lex_state = 229, .external_lex_state = 6},
  [1306] = {.lex_state = 229, .external_lex_state = 6},
  [1307] = {.lex_state = 8, .external_lex_state = 6},
  [1308] = {.lex_state = 8, .external_lex_state = 6},
  [1309] = {.lex_state = 8, .external_lex_state = 6},
  [1310] = {.lex_state = 10, .external_lex_state = 6},
  [1311] = {.lex_state = 10, .external_lex_state = 6},
  [1312] = {.lex_state = 10, .external_lex_state = 6},
  [1313] = {.lex_state = 10, .external_lex_state = 6},
  [1314] = {.lex_state = 10, .external_lex_state = 6},
  [1315] = {.lex_state = 10, .external_lex_state = 6},
  [1316] = {.lex_state = 10, .external_lex_state = 6},
  [1317] = {.lex_state = 10, .external_lex_state = 6},
  [1318] = {.lex_state = 10, .external_lex_state = 6},
  [1319] = {.lex_state = 10, .external_lex_state = 6},
  [1320] = {.lex_state = 10, .external_lex_state = 6},
  [1321] = {.lex_state = 10, .external_lex_state = 6},
  [1322] = {.lex_state = 10, .external_lex_state = 6},
  [1323] = {.lex_state = 10, .external_lex_state = 6},
  [1324] = {.lex_state = 10, .external_lex_state = 6},
  [1325] = {.lex_state = 10, .external_lex_state = 6},
  [1326] = {.lex_state = 10, .external_lex_state = 6},
  [1327] = {.lex_state = 10, .external_lex_state = 6},
  [1328] = {.lex_state = 10, .external_lex_state = 6},
  [1329] = {.lex_state = 10, .external_lex_state = 6},
  [1330] = {.lex_state = 10, .external_lex_state = 6},
  [1331] = {.lex_state = 10, .external_lex_state = 6},
  [1332] = {.lex_state = 10, .external_lex_state = 6},
  [1333] = {.lex_state = 10, .external_lex_state = 6},
  [1334] = {.lex_state = 10, .external_lex_state = 6},
  [1335] = {.lex_state = 10, .external_lex_state = 6},
  [1336] = {.lex_state = 10, .external_lex_state = 6},
  [1337] = {.lex_state = 10, .external_lex_state = 6},
  [1338] = {.lex_state = 10, .external_lex_state = 6},
  [1339] = {.lex_state = 10, .external_lex_state = 6},
  [1340] = {.lex_state = 10, .external_lex_state = 6},
  [1341] = {.lex_state = 10, .external_lex_state = 6},
  [1342] = {.lex_state = 10, .external_lex_state = 6},
  [1343] = {.lex_state = 10, .external_lex_state = 6},
  [1344] = {.lex_state = 10, .external_lex_state = 6},
  [1345] = {.lex_state = 10, .external_lex_state = 6},
  [1346] = {.lex_state = 10, .external_lex_state = 6},
  [1347] = {.lex_state = 10, .external_lex_state = 6},
  [1348] = {.lex_state = 10, .external_lex_state = 6},
  [1349] = {.lex_state = 10, .external_lex_state = 6},
  [1350] = {.lex_state = 10, .external_lex_state = 6},
  [1351] = {.lex_state = 10, .external_lex_state = 6},
  [1352] = {.lex_state = 10, .external_lex_state = 6},
  [1353] = {.lex_state = 10, .external_lex_state = 6},
  [1354] = {.lex_state = 10, .external_lex_state = 6},
  [1355] = {.lex_state = 10, .external_lex_state = 6},
  [1356] = {.lex_state = 11, .external_lex_state = 6},
  [1357] = {.lex_state = 11, .external_lex_state = 6},
  [1358] = {.lex_state = 11, .external_lex_state = 6},
  [1359] = {.lex_state = 11, .external_lex_state = 6},
  [1360] = {.lex_state = 11, .external_lex_state = 6},
  [1361] = {.lex_state = 11, .external_lex_state = 6},
  [1362] = {.lex_state = 11, .external_lex_state = 6},
  [1363] = {.lex_state = 11, .external_lex_state = 6},
  [1364] = {.lex_state = 11, .external_lex_state = 6},
  [1365] = {.lex_state = 11, .external_lex_state = 6},
  [1366] = {.lex_state = 11, .external_lex_state = 6},
  [1367] = {.lex_state = 11, .external_lex_state = 6},
  [1368] = {.lex_state = 11, .external_lex_state = 6},
  [1369] = {.lex_state = 11, .external_lex_state = 6},
  [1370] = {.lex_state = 11, .external_lex_state = 6},
  [1371] = {.lex_state = 11, .external_lex_state = 6},
  [1372] = {.lex_state = 11, .external_lex_state = 6},
  [1373] = {.lex_state = 11, .external_lex_state = 6},
  [1374] = {.lex_state = 11, .external_lex_state = 6},
  [1375] = {.lex_state = 11, .external_lex_state = 6},
  [1376] = {.lex_state = 11, .external_lex_state = 6},
  [1377] = {.lex_state = 11, .external_lex_state = 6},
  [1378] = {.lex_state = 11, .external_lex_state = 6},
  [1379] = {.lex_state = 11, .external_lex_state = 6},
  [1380] = {.lex_state = 11, .external_lex_state = 6},
  [1381] = {.lex_state = 11, .external_lex_state = 6},
  [1382] = {.lex_state = 11, .external_lex_state = 6},
  [1383] = {.lex_state = 11, .external_lex_state = 6},
  [1384] = {.lex_state = 11, .external_lex_state = 6},
  [1385] = {.lex_state = 10, .external_lex_state = 6},
  [1386] = {.lex_state = 10, .external_lex_state = 6},
  [1387] = {.lex_state = 10, .external_lex_state = 6},
  [1388] = {.lex_state = 10, .external_lex_state = 6},
  [1389] = {.lex_state = 10, .external_lex_state = 6},
  [1390] = {.lex_state = 10, .external_lex_state = 6},
  [1391] = {.lex_state = 10, .external_lex_state = 6},
  [1392] = {.lex_state = 10, .external_lex_state = 6},
  [1393] = {.lex_state = 10, .external_lex_state = 6},
  [1394] = {.lex_state = 10, .external_lex_state = 6},
  [1395] = {.lex_state = 10, .external_lex_state = 6},
  [1396] = {.lex_state = 10, .external_lex_state = 6},
  [1397] = {.lex_state = 10, .external_lex_state = 6},
  [1398] = {.lex_state = 10, .external_lex_state = 6},
  [1399] = {.lex_state = 10, .external_lex_state = 6},
  [1400] = {.lex_state = 10, .external_lex_state = 6},
  [1401] = {.lex_state = 10, .external_lex_state = 6},
  [1402] = {.lex_state = 10, .external_lex_state = 6},
  [1403] = {.lex_state = 10, .external_lex_state = 6},
  [1404] = {.lex_state = 10, .external_lex_state = 6},
  [1405] = {.lex_state = 10, .external_lex_state = 6},
  [1406] = {.lex_state = 10, .external_lex_state = 6},
  [1407] = {.lex_state = 10, .external_lex_state = 6},
  [1408] = {.lex_state = 10, .external_lex_state = 6},
  [1409] = {.lex_state = 10, .external_lex_state = 6},
  [1410] = {.lex_state = 10, .external_lex_state = 6},
  [1411] = {.lex_state = 10, .external_lex_state = 6},
  [1412] = {.lex_state = 10, .external_lex_state = 6},
  [1413] = {.lex_state = 10, .external_lex_state = 6},
  [1414] = {.lex_state = 10, .external_lex_state = 6},
  [1415] = {.lex_state = 10, .external_lex_state = 6},
  [1416] = {.lex_state = 10, .external_lex_state = 6},
  [1417] = {.lex_state = 10, .external_lex_state = 6},
  [1418] = {.lex_state = 10, .external_lex_state = 6},
  [1419] = {.lex_state = 10, .external_lex_state = 6},
  [1420] = {.lex_state = 10, .external_lex_state = 6},
  [1421] = {.lex_state = 10, .external_lex_state = 6},
  [1422] = {.lex_state = 10, .external_lex_state = 6},
  [1423] = {.lex_state = 10, .external_lex_state = 6},
  [1424] = {.lex_state = 10, .external_lex_state = 6},
  [1425] = {.lex_state = 10, .external_lex_state = 6},
  [1426] = {.lex_state = 10, .external_lex_state = 6},
  [1427] = {.lex_state = 10, .external_lex_state = 6},
  [1428] = {.lex_state = 10, .external_lex_state = 8},
  [1429] = {.lex_state = 10, .external_lex_state = 6},
  [1430] = {.lex_state = 10, .external_lex_state = 6},
  [1431] = {.lex_state = 10, .external_lex_state = 6},
  [1432] = {.lex_state = 10, .external_lex_state = 6},
  [1433] = {.lex_state = 10, .external_lex_state = 6},
  [1434] = {.lex_state = 10, .external_lex_state = 8},
  [1435] = {.lex_state = 10, .external_lex_state = 6},
  [1436] = {.lex_state = 10, .external_lex_state = 8},
  [1437] = {.lex_state = 10, .external_lex_state = 8},
  [1438] = {.lex_state = 10, .external_lex_state = 8},
  [1439] = {.lex_state = 10, .external_lex_state = 8},
  [1440] = {.lex_state = 10, .external_lex_state = 8},
  [1441] = {.lex_state = 10, .external_lex_state = 8},
  [1442] = {.lex_state = 10, .external_lex_state = 8},
  [1443] = {.lex_state = 10, .external_lex_state = 8},
  [1444] = {.lex_state = 10, .external_lex_state = 8},
  [1445] = {.lex_state = 10, .external_lex_state = 8},
  [1446] = {.lex_state = 10, .external_lex_state = 8},
  [1447] = {.lex_state = 10, .external_lex_state = 8},
  [1448] = {.lex_state = 10, .external_lex_state = 8},
  [1449] = {.lex_state = 10, .external_lex_state = 8},
  [1450] = {.lex_state = 10, .external_lex_state = 8},
  [1451] = {.lex_state = 10, .external_lex_state = 8},
  [1452] = {.lex_state = 10, .external_lex_state = 8},
  [1453] = {.lex_state = 10, .external_lex_state = 8},
  [1454] = {.lex_state = 10, .external_lex_state = 8},
  [1455] = {.lex_state = 10, .external_lex_state = 8},
  [1456] = {.lex_state = 10, .external_lex_state = 8},
  [1457] = {.lex_state = 10, .external_lex_state = 8},
  [1458] = {.lex_state = 10, .external_lex_state = 8},
  [1459] = {.lex_state = 10, .external_lex_state = 8},
  [1460] = {.lex_state = 10, .external_lex_state = 8},
  [1461] = {.lex_state = 10, .external_lex_state = 8},
  [1462] = {.lex_state = 10, .external_lex_state = 8},
  [1463] = {.lex_state = 10, .external_lex_state = 8},
  [1464] = {.lex_state = 10, .external_lex_state = 8},
  [1465] = {.lex_state = 10, .external_lex_state = 8},
  [1466] = {.lex_state = 10, .external_lex_state = 6},
  [1467] = {.lex_state = 10, .external_lex_state = 6},
  [1468] = {.lex_state = 10, .external_lex_state = 8},
  [1469] = {.lex_state = 10, .external_lex_state = 8},
  [1470] = {.lex_state = 10, .external_lex_state = 8},
  [1471] = {.lex_state = 10, .external_lex_state = 8},
  [1472] = {.lex_state = 10, .external_lex_state = 8},
  [1473] = {.lex_state = 10, .external_lex_state = 8},
  [1474] = {.lex_state = 10, .external_lex_state = 8},
  [1475] = {.lex_state = 10, .external_lex_state = 8},
  [1476] = {.lex_state = 10, .external_lex_state = 6},
  [1477] = {.lex_state = 10, .external_lex_state = 6},
  [1478] = {.lex_state = 10, .external_lex_state = 6},
  [1479] = {.lex_state = 10, .external_lex_state = 6},
  [1480] = {.lex_state = 10, .external_lex_state = 6},
  [1481] = {.lex_state = 10, .external_lex_state = 6},
  [1482] = {.lex_state = 10, .external_lex_state = 6},
  [1483] = {.lex_state = 10, .external_lex_state = 6},
  [1484] = {.lex_state = 10, .external_lex_state = 6},
  [1485] = {.lex_state = 10, .external_lex_state = 6},
  [1486] = {.lex_state = 10, .external_lex_state = 6},
  [1487] = {.lex_state = 10, .external_lex_state = 6},
  [1488] = {.lex_state = 12, .external_lex_state = 9},
  [1489] = {.lex_state = 13, .external_lex_state = 9},
  [1490] = {.lex_state = 13, .external_lex_state = 9},
  [1491] = {.lex_state = 13, .external_lex_state = 9},
  [1492] = {.lex_state = 13, .external_lex_state = 9},
  [1493] = {.lex_state = 13, .external_lex_state = 9},
  [1494] = {.lex_state = 13, .external_lex_state = 9},
  [1495] = {.lex_state = 13, .external_lex_state = 9},
  [1496] = {.lex_state = 13, .external_lex_state = 9},
  [1497] = {.lex_state = 13, .external_lex_state = 9},
  [1498] = {.lex_state = 13, .external_lex_state = 9},
  [1499] = {.lex_state = 13, .external_lex_state = 9},
  [1500] = {.lex_state = 13, .external_lex_state = 9},
  [1501] = {.lex_state = 13, .external_lex_state = 9},
  [1502] = {.lex_state = 13, .external_lex_state = 9},
  [1503] = {.lex_state = 13, .external_lex_state = 9},
  [1504] = {.lex_state = 13, .external_lex_state = 9},
  [1505] = {.lex_state = 13, .external_lex_state = 9},
  [1506] = {.lex_state = 13, .external_lex_state = 9},
  [1507] = {.lex_state = 13, .external_lex_state = 9},
  [1508] = {.lex_state = 13, .external_lex_state = 9},
  [1509] = {.lex_state = 13, .external_lex_state = 9},
  [1510] = {.lex_state = 13, .external_lex_state = 9},
  [1511] = {.lex_state = 13, .external_lex_state = 9},
  [1512] = {.lex_state = 13, .external_lex_state = 9},
  [1513] = {.lex_state = 13, .external_lex_state = 9},
  [1514] = {.lex_state = 13, .external_lex_state = 9},
  [1515] = {.lex_state = 13, .external_lex_state = 9},
  [1516] = {.lex_state = 13, .external_lex_state = 9},
  [1517] = {.lex_state = 13, .external_lex_state = 9},
  [1518] = {.lex_state = 13, .external_lex_state = 9},
  [1519] = {.lex_state = 14, .external_lex_state = 6},
  [1520] = {.lex_state = 14, .external_lex_state = 6},
  [1521] = {.lex_state = 14, .external_lex_state = 6},
  [1522] = {.lex_state = 14, .external_lex_state = 6},
  [1523] = {.lex_state = 14, .external_lex_state = 6},
  [1524] = {.lex_state = 14, .external_lex_state = 6},
  [1525] = {.lex_state = 14, .external_lex_state = 6},
  [1526] = {.lex_state = 14, .external_lex_state = 6},
  [1527] = {.lex_state = 14, .external_lex_state = 6},
  [1528] = {.lex_state = 14, .external_lex_state = 6},
  [1529] = {.lex_state = 14, .external_lex_state = 6},
  [1530] = {.lex_state = 14, .external_lex_state = 6},
  [1531] = {.lex_state = 14, .external_lex_state = 6},
  [1532] = {.lex_state = 14, .external_lex_state = 6},
  [1533] = {.lex_state = 14, .external_lex_state = 6},
  [1534] = {.lex_state = 14, .external_lex_state = 6},
  [1535] = {.lex_state = 14, .external_lex_state = 6},
  [1536] = {.lex_state = 14, .external_lex_state = 6},
  [1537] = {.lex_state = 14, .external_lex_state = 6},
  [1538] = {.lex_state = 14, .external_lex_state = 6},
  [1539] = {.lex_state = 14, .external_lex_state = 6},
  [1540] = {.lex_state = 14, .external_lex_state = 6},
  [1541] = {.lex_state = 14, .external_lex_state = 6},
  [1542] = {.lex_state = 14, .external_lex_state = 6},
  [1543] = {.lex_state = 14, .external_lex_state = 6},
  [1544] = {.lex_state = 14, .external_lex_state = 6},
  [1545] = {.lex_state = 14, .external_lex_state = 6},
  [1546] = {.lex_state = 14, .external_lex_state = 6},
  [1547] = {.lex_state = 11, .external_lex_state = 9},
  [1548] = {.lex_state = 14, .external_lex_state = 6},
  [1549] = {.lex_state = 14, .external_lex_state = 6},
  [1550] = {.lex_state = 14, .external_lex_state = 6},
  [1551] = {.lex_state = 14, .external_lex_state = 6},
  [1552] = {.lex_state = 14, .external_lex_state = 6},
  [1553] = {.lex_state = 11, .external_lex_state = 6},
  [1554] = {.lex_state = 14, .external_lex_state = 6},
  [1555] = {.lex_state = 14, .external_lex_state = 6},
  [1556] = {.lex_state = 14, .external_lex_state = 6},
  [1557] = {.lex_state = 14, .external_lex_state = 6},
  [1558] = {.lex_state = 14, .external_lex_state = 6},
  [1559] = {.lex_state = 14, .external_lex_state = 6},
  [1560] = {.lex_state = 14, .external_lex_state = 6},
  [1561] = {.lex_state = 14, .external_lex_state = 6},
  [1562] = {.lex_state = 14, .external_lex_state = 6},
  [1563] = {.lex_state = 14, .external_lex_state = 6},
  [1564] = {.lex_state = 14, .external_lex_state = 6},
  [1565] = {.lex_state = 14, .external_lex_state = 6},
  [1566] = {.lex_state = 14, .external_lex_state = 6},
  [1567] = {.lex_state = 11, .external_lex_state = 9},
  [1568] = {.lex_state = 11, .external_lex_state = 9},
  [1569] = {.lex_state = 11, .external_lex_state = 9},
  [1570] = {.lex_state = 11, .external_lex_state = 9},
  [1571] = {.lex_state = 11, .external_lex_state = 9},
  [1572] = {.lex_state = 11, .external_lex_state = 9},
  [1573] = {.lex_state = 11, .external_lex_state = 9},
  [1574] = {.lex_state = 11, .external_lex_state = 9},
  [1575] = {.lex_state = 11, .external_lex_state = 9},
  [1576] = {.lex_state = 11, .external_lex_state = 9},
  [1577] = {.lex_state = 11, .external_lex_state = 9},
  [1578] = {.lex_state = 11, .external_lex_state = 9},
  [1579] = {.lex_state = 11, .external_lex_state = 9},
  [1580] = {.lex_state = 11, .external_lex_state = 9},
  [1581] = {.lex_state = 11, .external_lex_state = 9},
  [1582] = {.lex_state = 11, .external_lex_state = 9},
  [1583] = {.lex_state = 11, .external_lex_state = 9},
  [1584] = {.lex_state = 11, .external_lex_state = 9},
  [1585] = {.lex_state = 11, .external_lex_state = 9},
  [1586] = {.lex_state = 11, .external_lex_state = 9},
  [1587] = {.lex_state = 11, .external_lex_state = 9},
  [1588] = {.lex_state = 11, .external_lex_state = 9},
  [1589] = {.lex_state = 11, .external_lex_state = 9},
  [1590] = {.lex_state = 11, .external_lex_state = 9},
  [1591] = {.lex_state = 11, .external_lex_state = 9},
  [1592] = {.lex_state = 11, .external_lex_state = 9},
  [1593] = {.lex_state = 11, .external_lex_state = 9},
  [1594] = {.lex_state = 11, .external_lex_state = 9},
  [1595] = {.lex_state = 11, .external_lex_state = 9},
  [1596] = {.lex_state = 11, .external_lex_state = 9},
  [1597] = {.lex_state = 11, .external_lex_state = 9},
  [1598] = {.lex_state = 13, .external_lex_state = 6},
  [1599] = {.lex_state = 5, .external_lex_state = 4},
  [1600] = {.lex_state = 228, .external_lex_state = 4},
  [1601] = {.lex_state = 228, .external_lex_state = 4},
  [1602] = {.lex_state = 228, .external_lex_state = 4},
  [1603] = {.lex_state = 13, .external_lex_state = 6},
  [1604] = {.lex_state = 13, .external_lex_state = 6},
  [1605] = {.lex_state = 13, .external_lex_state = 6},
  [1606] = {.lex_state = 13, .external_lex_state = 6},
  [1607] = {.lex_state = 13, .external_lex_state = 6},
  [1608] = {.lex_state = 13, .external_lex_state = 6},
  [1609] = {.lex_state = 13, .external_lex_state = 6},
  [1610] = {.lex_state = 13, .external_lex_state = 6},
  [1611] = {.lex_state = 13, .external_lex_state = 6},
  [1612] = {.lex_state = 13, .external_lex_state = 6},
  [1613] = {.lex_state = 13, .external_lex_state = 6},
  [1614] = {.lex_state = 228, .external_lex_state = 4},
  [1615] = {.lex_state = 13, .external_lex_state = 6},
  [1616] = {.lex_state = 13, .external_lex_state = 6},
  [1617] = {.lex_state = 13, .external_lex_state = 6},
  [1618] = {.lex_state = 13, .external_lex_state = 6},
  [1619] = {.lex_state = 13, .external_lex_state = 6},
  [1620] = {.lex_state = 13, .external_lex_state = 6},
  [1621] = {.lex_state = 13, .external_lex_state = 6},
  [1622] = {.lex_state = 13, .external_lex_state = 6},
  [1623] = {.lex_state = 13, .external_lex_state = 6},
  [1624] = {.lex_state = 13, .external_lex_state = 6},
  [1625] = {.lex_state = 13, .external_lex_state = 6},
  [1626] = {.lex_state = 13, .external_lex_state = 6},
  [1627] = {.lex_state = 13, .external_lex_state = 6},
  [1628] = {.lex_state = 13, .external_lex_state = 6},
  [1629] = {.lex_state = 13, .external_lex_state = 6},
  [1630] = {.lex_state = 13, .external_lex_state = 6},
  [1631] = {.lex_state = 5, .external_lex_state = 4},
  [1632] = {.lex_state = 5, .external_lex_state = 4},
  [1633] = {.lex_state = 5, .external_lex_state = 4},
  [1634] = {.lex_state = 11, .external_lex_state = 6},
  [1635] = {.lex_state = 13, .external_lex_state = 6},
  [1636] = {.lex_state = 13, .external_lex_state = 6},
  [1637] = {.lex_state = 13, .external_lex_state = 6},
  [1638] = {.lex_state = 17, .external_lex_state = 6},
  [1639] = {.lex_state = 19, .external_lex_state = 6},
  [1640] = {.lex_state = 19, .external_lex_state = 6},
  [1641] = {.lex_state = 19, .external_lex_state = 6},
  [1642] = {.lex_state = 17, .external_lex_state = 6},
  [1643] = {.lex_state = 17, .external_lex_state = 6},
  [1644] = {.lex_state = 17, .external_lex_state = 6},
  [1645] = {.lex_state = 17, .external_lex_state = 6},
  [1646] = {.lex_state = 17, .external_lex_state = 6},
  [1647] = {.lex_state = 19, .external_lex_state = 6},
  [1648] = {.lex_state = 17, .external_lex_state = 6},
  [1649] = {.lex_state = 13, .external_lex_state = 6},
  [1650] = {.lex_state = 11, .external_lex_state = 9},
  [1651] = {.lex_state = 19, .external_lex_state = 6},
  [1652] = {.lex_state = 17, .external_lex_state = 6},
  [1653] = {.lex_state = 17, .external_lex_state = 6},
  [1654] = {.lex_state = 17, .external_lex_state = 6},
  [1655] = {.lex_state = 17, .external_lex_state = 6},
  [1656] = {.lex_state = 11, .external_lex_state = 9},
  [1657] = {.lex_state = 17, .external_lex_state = 6},
  [1658] = {.lex_state = 17, .external_lex_state = 6},
  [1659] = {.lex_state = 17, .external_lex_state = 6},
  [1660] = {.lex_state = 19, .external_lex_state = 6},
  [1661] = {.lex_state = 17, .external_lex_state = 6},
  [1662] = {.lex_state = 17, .external_lex_state = 6},
  [1663] = {.lex_state = 19, .external_lex_state = 6},
  [1664] = {.lex_state = 17, .external_lex_state = 6},
  [1665] = {.lex_state = 17, .external_lex_state = 6},
  [1666] = {.lex_state = 17, .external_lex_state = 6},
  [1667] = {.lex_state = 17, .external_lex_state = 6},
  [1668] = {.lex_state = 17, .external_lex_state = 6},
  [1669] = {.lex_state = 19, .external_lex_state = 6},
  [1670] = {.lex_state = 17, .external_lex_state = 6},
  [1671] = {.lex_state = 19, .external_lex_state = 6},
  [1672] = {.lex_state = 11, .external_lex_state = 6},
  [1673] = {.lex_state = 11, .external_lex_state = 6},
  [1674] = {.lex_state = 19, .external_lex_state = 6},
  [1675] = {.lex_state = 19, .external_lex_state = 6},
  [1676] = {.lex_state = 13, .external_lex_state = 6},
  [1677] = {.lex_state = 11, .external_lex_state = 8},
  [1678] = {.lex_state = 11, .external_lex_state = 8},
  [1679] = {.lex_state = 13, .external_lex_state = 6},
  [1680] = {.lex_state = 19, .external_lex_state = 6},
  [1681] = {.lex_state = 19, .external_lex_state = 6},
  [1682] = {.lex_state = 19, .external_lex_state = 6},
  [1683] = {.lex_state = 13, .external_lex_state = 6},
  [1684] = {.lex_state = 19, .external_lex_state = 6},
  [1685] = {.lex_state = 11, .external_lex_state = 8},
  [1686] = {.lex_state = 11, .external_lex_state = 8},
  [1687] = {.lex_state = 17, .external_lex_state = 6},
  [1688] = {.lex_state = 11, .external_lex_state = 8},
  [1689] = {.lex_state = 19, .external_lex_state = 6},
  [1690] = {.lex_state = 11, .external_lex_state = 8},
  [1691] = {.lex_state = 13, .external_lex_state = 6},
  [1692] = {.lex_state = 11, .external_lex_state = 8},
  [1693] = {.lex_state = 11, .external_lex_state = 8},
  [1694] = {.lex_state = 11, .external_lex_state = 8},
  [1695] = {.lex_state = 11, .external_lex_state = 8},
  [1696] = {.lex_state = 11, .external_lex_state = 8},
  [1697] = {.lex_state = 11, .external_lex_state = 8},
  [1698] = {.lex_state = 11, .external_lex_state = 8},
  [1699] = {.lex_state = 11, .external_lex_state = 8},
  [1700] = {.lex_state = 11, .external_lex_state = 8},
  [1701] = {.lex_state = 11, .external_lex_state = 8},
  [1702] = {.lex_state = 11, .external_lex_state = 8},
  [1703] = {.lex_state = 13, .external_lex_state = 6},
  [1704] = {.lex_state = 11, .external_lex_state = 8},
  [1705] = {.lex_state = 11, .external_lex_state = 8},
  [1706] = {.lex_state = 11, .external_lex_state = 8},
  [1707] = {.lex_state = 11, .external_lex_state = 8},
  [1708] = {.lex_state = 11, .external_lex_state = 8},
  [1709] = {.lex_state = 11, .external_lex_state = 8},
  [1710] = {.lex_state = 11, .external_lex_state = 8},
  [1711] = {.lex_state = 11, .external_lex_state = 8},
  [1712] = {.lex_state = 13, .external_lex_state = 6},
  [1713] = {.lex_state = 11, .external_lex_state = 8},
  [1714] = {.lex_state = 11, .external_lex_state = 8},
  [1715] = {.lex_state = 11, .external_lex_state = 8},
  [1716] = {.lex_state = 11, .external_lex_state = 8},
  [1717] = {.lex_state = 19, .external_lex_state = 6},
  [1718] = {.lex_state = 19, .external_lex_state = 6},
  [1719] = {.lex_state = 19, .external_lex_state = 6},
  [1720] = {.lex_state = 13, .external_lex_state = 6},
  [1721] = {.lex_state = 19, .external_lex_state = 6},
  [1722] = {.lex_state = 19, .external_lex_state = 6},
  [1723] = {.lex_state = 17, .external_lex_state = 6},
  [1724] = {.lex_state = 17, .external_lex_state = 6},
  [1725] = {.lex_state = 17, .external_lex_state = 6},
  [1726] = {.lex_state = 19, .external_lex_state = 6},
  [1727] = {.lex_state = 13, .external_lex_state = 6},
  [1728] = {.lex_state = 19, .external_lex_state = 6},
  [1729] = {.lex_state = 13, .external_lex_state = 6},
  [1730] = {.lex_state = 19, .external_lex_state = 6},
  [1731] = {.lex_state = 13, .external_lex_state = 6},
  [1732] = {.lex_state = 19, .external_lex_state = 6},
  [1733] = {.lex_state = 13, .external_lex_state = 6},
  [1734] = {.lex_state = 17, .external_lex_state = 6},
  [1735] = {.lex_state = 13, .external_lex_state = 6},
  [1736] = {.lex_state = 13, .external_lex_state = 6},
  [1737] = {.lex_state = 13, .external_lex_state = 6},
  [1738] = {.lex_state = 17, .external_lex_state = 6},
  [1739] = {.lex_state = 17, .external_lex_state = 6},
  [1740] = {.lex_state = 11, .external_lex_state = 6},
  [1741] = {.lex_state = 19, .external_lex_state = 6},
  [1742] = {.lex_state = 19, .external_lex_state = 6},
  [1743] = {.lex_state = 19, .external_lex_state = 6},
  [1744] = {.lex_state = 11, .external_lex_state = 6},
  [1745] = {.lex_state = 19, .external_lex_state = 6},
  [1746] = {.lex_state = 12, .external_lex_state = 6},
  [1747] = {.lex_state = 12, .external_lex_state = 6},
  [1748] = {.lex_state = 11, .external_lex_state = 6},
  [1749] = {.lex_state = 11, .external_lex_state = 6},
  [1750] = {.lex_state = 12, .external_lex_state = 6},
  [1751] = {.lex_state = 11, .external_lex_state = 6},
  [1752] = {.lex_state = 11, .external_lex_state = 6},
  [1753] = {.lex_state = 11, .external_lex_state = 8},
  [1754] = {.lex_state = 12, .external_lex_state = 6},
  [1755] = {.lex_state = 12, .external_lex_state = 6},
  [1756] = {.lex_state = 11, .external_lex_state = 10},
  [1757] = {.lex_state = 13, .external_lex_state = 6},
  [1758] = {.lex_state = 11, .external_lex_state = 6},
  [1759] = {.lex_state = 13, .external_lex_state = 6},
  [1760] = {.lex_state = 11, .external_lex_state = 6},
  [1761] = {.lex_state = 13, .external_lex_state = 6},
  [1762] = {.lex_state = 11, .external_lex_state = 6},
  [1763] = {.lex_state = 13, .external_lex_state = 6},
  [1764] = {.lex_state = 11, .external_lex_state = 6},
  [1765] = {.lex_state = 13, .external_lex_state = 6},
  [1766] = {.lex_state = 11, .external_lex_state = 6},
  [1767] = {.lex_state = 11, .external_lex_state = 6},
  [1768] = {.lex_state = 13, .external_lex_state = 6},
  [1769] = {.lex_state = 11, .external_lex_state = 6},
  [1770] = {.lex_state = 13, .external_lex_state = 6},
  [1771] = {.lex_state = 11, .external_lex_state = 6},
  [1772] = {.lex_state = 13, .external_lex_state = 6},
  [1773] = {.lex_state = 11, .external_lex_state = 6},
  [1774] = {.lex_state = 13, .external_lex_state = 6},
  [1775] = {.lex_state = 11, .external_lex_state = 6},
  [1776] = {.lex_state = 11, .external_lex_state = 6},
  [1777] = {.lex_state = 13, .external_lex_state = 6},
  [1778] = {.lex_state = 11, .external_lex_state = 6},
  [1779] = {.lex_state = 13, .external_lex_state = 6},
  [1780] = {.lex_state = 11, .external_lex_state = 6},
  [1781] = {.lex_state = 13, .external_lex_state = 6},
  [1782] = {.lex_state = 11, .external_lex_state = 6},
  [1783] = {.lex_state = 13, .external_lex_state = 6},
  [1784] = {.lex_state = 11, .external_lex_state = 6},
  [1785] = {.lex_state = 11, .external_lex_state = 6},
  [1786] = {.lex_state = 13, .external_lex_state = 6},
  [1787] = {.lex_state = 11, .external_lex_state = 6},
  [1788] = {.lex_state = 13, .external_lex_state = 6},
  [1789] = {.lex_state = 11, .external_lex_state = 6},
  [1790] = {.lex_state = 13, .external_lex_state = 6},
  [1791] = {.lex_state = 11, .external_lex_state = 6},
  [1792] = {.lex_state = 11, .external_lex_state = 6},
  [1793] = {.lex_state = 17, .external_lex_state = 6},
  [1794] = {.lex_state = 11, .external_lex_state = 10},
  [1795] = {.lex_state = 11, .external_lex_state = 10},
  [1796] = {.lex_state = 11, .external_lex_state = 10},
  [1797] = {.lex_state = 11, .external_lex_state = 10},
  [1798] = {.lex_state = 11, .external_lex_state = 6},
  [1799] = {.lex_state = 11, .external_lex_state = 10},
  [1800] = {.lex_state = 11, .external_lex_state = 10},
  [1801] = {.lex_state = 11, .external_lex_state = 10},
  [1802] = {.lex_state = 11, .external_lex_state = 10},
  [1803] = {.lex_state = 11, .external_lex_state = 10},
  [1804] = {.lex_state = 11, .external_lex_state = 10},
  [1805] = {.lex_state = 11, .external_lex_state = 10},
  [1806] = {.lex_state = 11, .external_lex_state = 10},
  [1807] = {.lex_state = 11, .external_lex_state = 10},
  [1808] = {.lex_state = 11, .external_lex_state = 10},
  [1809] = {.lex_state = 11, .external_lex_state = 10},
  [1810] = {.lex_state = 11, .external_lex_state = 10},
  [1811] = {.lex_state = 11, .external_lex_state = 10},
  [1812] = {.lex_state = 11, .external_lex_state = 10},
  [1813] = {.lex_state = 11, .external_lex_state = 8},
  [1814] = {.lex_state = 11, .external_lex_state = 10},
  [1815] = {.lex_state = 11, .external_lex_state = 10},
  [1816] = {.lex_state = 11, .external_lex_state = 10},
  [1817] = {.lex_state = 11, .external_lex_state = 10},
  [1818] = {.lex_state = 11, .external_lex_state = 10},
  [1819] = {.lex_state = 19, .external_lex_state = 6},
  [1820] = {.lex_state = 11, .external_lex_state = 10},
  [1821] = {.lex_state = 11, .external_lex_state = 10},
  [1822] = {.lex_state = 11, .external_lex_state = 10},
  [1823] = {.lex_state = 11, .external_lex_state = 10},
  [1824] = {.lex_state = 11, .external_lex_state = 10},
  [1825] = {.lex_state = 19, .external_lex_state = 6},
  [1826] = {.lex_state = 11, .external_lex_state = 6},
  [1827] = {.lex_state = 11, .external_lex_state = 6},
  [1828] = {.lex_state = 11, .external_lex_state = 6},
  [1829] = {.lex_state = 11, .external_lex_state = 6},
  [1830] = {.lex_state = 11, .external_lex_state = 6},
  [1831] = {.lex_state = 11, .external_lex_state = 6},
  [1832] = {.lex_state = 11, .external_lex_state = 6},
  [1833] = {.lex_state = 11, .external_lex_state = 6},
  [1834] = {.lex_state = 11, .external_lex_state = 6},
  [1835] = {.lex_state = 11, .external_lex_state = 6},
  [1836] = {.lex_state = 11, .external_lex_state = 6},
  [1837] = {.lex_state = 11, .external_lex_state = 6},
  [1838] = {.lex_state = 11, .external_lex_state = 6},
  [1839] = {.lex_state = 11, .external_lex_state = 6},
  [1840] = {.lex_state = 11, .external_lex_state = 6},
  [1841] = {.lex_state = 11, .external_lex_state = 6},
  [1842] = {.lex_state = 11, .external_lex_state = 6},
  [1843] = {.lex_state = 11, .external_lex_state = 6},
  [1844] = {.lex_state = 11, .external_lex_state = 6},
  [1845] = {.lex_state = 11, .external_lex_state = 6},
  [1846] = {.lex_state = 11, .external_lex_state = 6},
  [1847] = {.lex_state = 11, .external_lex_state = 6},
  [1848] = {.lex_state = 11, .external_lex_state = 6},
  [1849] = {.lex_state = 11, .external_lex_state = 6},
  [1850] = {.lex_state = 11, .external_lex_state = 6},
  [1851] = {.lex_state = 11, .external_lex_state = 6},
  [1852] = {.lex_state = 11, .external_lex_state = 6},
  [1853] = {.lex_state = 11, .external_lex_state = 6},
  [1854] = {.lex_state = 11, .external_lex_state = 6},
  [1855] = {.lex_state = 11, .external_lex_state = 8},
  [1856] = {.lex_state = 11, .external_lex_state = 6},
  [1857] = {.lex_state = 11, .external_lex_state = 6},
  [1858] = {.lex_state = 11, .external_lex_state = 6},
  [1859] = {.lex_state = 11, .external_lex_state = 6},
  [1860] = {.lex_state = 11, .external_lex_state = 6},
  [1861] = {.lex_state = 11, .external_lex_state = 6},
  [1862] = {.lex_state = 11, .external_lex_state = 6},
  [1863] = {.lex_state = 11, .external_lex_state = 6},
  [1864] = {.lex_state = 11, .external_lex_state = 6},
  [1865] = {.lex_state = 11, .external_lex_state = 6},
  [1866] = {.lex_state = 11, .external_lex_state = 6},
  [1867] = {.lex_state = 11, .external_lex_state = 6},
  [1868] = {.lex_state = 11, .external_lex_state = 6},
  [1869] = {.lex_state = 11, .external_lex_state = 6},
  [1870] = {.lex_state = 11, .external_lex_state = 6},
  [1871] = {.lex_state = 11, .external_lex_state = 6},
  [1872] = {.lex_state = 11, .external_lex_state = 6},
  [1873] = {.lex_state = 11, .external_lex_state = 6},
  [1874] = {.lex_state = 11, .external_lex_state = 6},
  [1875] = {.lex_state = 11, .external_lex_state = 6},
  [1876] = {.lex_state = 11, .external_lex_state = 6},
  [1877] = {.lex_state = 11, .external_lex_state = 6},
  [1878] = {.lex_state = 11, .external_lex_state = 6},
  [1879] = {.lex_state = 11, .external_lex_state = 6},
  [1880] = {.lex_state = 11, .external_lex_state = 6},
  [1881] = {.lex_state = 11, .external_lex_state = 6},
  [1882] = {.lex_state = 11, .external_lex_state = 6},
  [1883] = {.lex_state = 11, .external_lex_state = 6},
  [1884] = {.lex_state = 11, .external_lex_state = 6},
  [1885] = {.lex_state = 11, .external_lex_state = 6},
  [1886] = {.lex_state = 11, .external_lex_state = 6},
  [1887] = {.lex_state = 11, .external_lex_state = 6},
  [1888] = {.lex_state = 11, .external_lex_state = 6},
  [1889] = {.lex_state = 11, .external_lex_state = 6},
  [1890] = {.lex_state = 11, .external_lex_state = 6},
  [1891] = {.lex_state = 11, .external_lex_state = 8},
  [1892] = {.lex_state = 11, .external_lex_state = 8},
  [1893] = {.lex_state = 11, .external_lex_state = 8},
  [1894] = {.lex_state = 11, .external_lex_state = 6},
  [1895] = {.lex_state = 11, .external_lex_state = 8},
  [1896] = {.lex_state = 11, .external_lex_state = 8},
  [1897] = {.lex_state = 11, .external_lex_state = 6},
  [1898] = {.lex_state = 11, .external_lex_state = 6},
  [1899] = {.lex_state = 11, .external_lex_state = 10},
  [1900] = {.lex_state = 11, .external_lex_state = 6},
  [1901] = {.lex_state = 11, .external_lex_state = 10},
  [1902] = {.lex_state = 11, .external_lex_state = 6},
  [1903] = {.lex_state = 11, .external_lex_state = 6},
  [1904] = {.lex_state = 11, .external_lex_state = 8},
  [1905] = {.lex_state = 11, .external_lex_state = 6},
  [1906] = {.lex_state = 11, .external_lex_state = 6},
  [1907] = {.lex_state = 11, .external_lex_state = 6},
  [1908] = {.lex_state = 11, .external_lex_state = 6},
  [1909] = {.lex_state = 11, .external_lex_state = 6},
  [1910] = {.lex_state = 11, .external_lex_state = 6},
  [1911] = {.lex_state = 11, .external_lex_state = 6},
  [1912] = {.lex_state = 11, .external_lex_state = 6},
  [1913] = {.lex_state = 11, .external_lex_state = 6},
  [1914] = {.lex_state = 11, .external_lex_state = 6},
  [1915] = {.lex_state = 11, .external_lex_state = 6},
  [1916] = {.lex_state = 11, .external_lex_state = 6},
  [1917] = {.lex_state = 11, .external_lex_state = 6},
  [1918] = {.lex_state = 11, .external_lex_state = 6},
  [1919] = {.lex_state = 11, .external_lex_state = 6},
  [1920] = {.lex_state = 11, .external_lex_state = 6},
  [1921] = {.lex_state = 11, .external_lex_state = 6},
  [1922] = {.lex_state = 11, .external_lex_state = 6},
  [1923] = {.lex_state = 11, .external_lex_state = 6},
  [1924] = {.lex_state = 11, .external_lex_state = 6},
  [1925] = {.lex_state = 11, .external_lex_state = 6},
  [1926] = {.lex_state = 11, .external_lex_state = 6},
  [1927] = {.lex_state = 11, .external_lex_state = 6},
  [1928] = {.lex_state = 11, .external_lex_state = 6},
  [1929] = {.lex_state = 11, .external_lex_state = 6},
  [1930] = {.lex_state = 11, .external_lex_state = 6},
  [1931] = {.lex_state = 11, .external_lex_state = 6},
  [1932] = {.lex_state = 11, .external_lex_state = 6},
  [1933] = {.lex_state = 11, .external_lex_state = 6},
  [1934] = {.lex_state = 11, .external_lex_state = 6},
  [1935] = {.lex_state = 11, .external_lex_state = 6},
  [1936] = {.lex_state = 11, .external_lex_state = 6},
  [1937] = {.lex_state = 11, .external_lex_state = 6},
  [1938] = {.lex_state = 11, .external_lex_state = 6},
  [1939] = {.lex_state = 11, .external_lex_state = 6},
  [1940] = {.lex_state = 11, .external_lex_state = 6},
  [1941] = {.lex_state = 11, .external_lex_state = 6},
  [1942] = {.lex_state = 11, .external_lex_state = 6},
  [1943] = {.lex_state = 11, .external_lex_state = 6},
  [1944] = {.lex_state = 11, .external_lex_state = 6},
  [1945] = {.lex_state = 11, .external_lex_state = 6},
  [1946] = {.lex_state = 11, .external_lex_state = 6},
  [1947] = {.lex_state = 11, .external_lex_state = 6},
  [1948] = {.lex_state = 11, .external_lex_state = 6},
  [1949] = {.lex_state = 11, .external_lex_state = 6},
  [1950] = {.lex_state = 11, .external_lex_state = 6},
  [1951] = {.lex_state = 11, .external_lex_state = 6},
  [1952] = {.lex_state = 11, .external_lex_state = 6},
  [1953] = {.lex_state = 11, .external_lex_state = 6},
  [1954] = {.lex_state = 11, .external_lex_state = 6},
  [1955] = {.lex_state = 11, .external_lex_state = 6},
  [1956] = {.lex_state = 11, .external_lex_state = 6},
  [1957] = {.lex_state = 11, .external_lex_state = 6},
  [1958] = {.lex_state = 11, .external_lex_state = 6},
  [1959] = {.lex_state = 11, .external_lex_state = 6},
  [1960] = {.lex_state = 11, .external_lex_state = 6},
  [1961] = {.lex_state = 11, .external_lex_state = 6},
  [1962] = {.lex_state = 11, .external_lex_state = 6},
  [1963] = {.lex_state = 11, .external_lex_state = 6},
  [1964] = {.lex_state = 11, .external_lex_state = 6},
  [1965] = {.lex_state = 11, .external_lex_state = 6},
  [1966] = {.lex_state = 11, .external_lex_state = 6},
  [1967] = {.lex_state = 11, .external_lex_state = 6},
  [1968] = {.lex_state = 11, .external_lex_state = 6},
  [1969] = {.lex_state = 11, .external_lex_state = 6},
  [1970] = {.lex_state = 11, .external_lex_state = 6},
  [1971] = {.lex_state = 11, .external_lex_state = 6},
  [1972] = {.lex_state = 11, .external_lex_state = 6},
  [1973] = {.lex_state = 11, .external_lex_state = 6},
  [1974] = {.lex_state = 11, .external_lex_state = 6},
  [1975] = {.lex_state = 11, .external_lex_state = 6},
  [1976] = {.lex_state = 11, .external_lex_state = 6},
  [1977] = {.lex_state = 11, .external_lex_state = 6},
  [1978] = {.lex_state = 11, .external_lex_state = 6},
  [1979] = {.lex_state = 11, .external_lex_state = 6},
  [1980] = {.lex_state = 11, .external_lex_state = 6},
  [1981] = {.lex_state = 11, .external_lex_state = 6},
  [1982] = {.lex_state = 11, .external_lex_state = 6},
  [1983] = {.lex_state = 11, .external_lex_state = 6},
  [1984] = {.lex_state = 11, .external_lex_state = 6},
  [1985] = {.lex_state = 11, .external_lex_state = 6},
  [1986] = {.lex_state = 11, .external_lex_state = 6},
  [1987] = {.lex_state = 11, .external_lex_state = 6},
  [1988] = {.lex_state = 11, .external_lex_state = 6},
  [1989] = {.lex_state = 11, .external_lex_state = 6},
  [1990] = {.lex_state = 11, .external_lex_state = 6},
  [1991] = {.lex_state = 11, .external_lex_state = 6},
  [1992] = {.lex_state = 11, .external_lex_state = 6},
  [1993] = {.lex_state = 11, .external_lex_state = 6},
  [1994] = {.lex_state = 11, .external_lex_state = 6},
  [1995] = {.lex_state = 11, .external_lex_state = 6},
  [1996] = {.lex_state = 11, .external_lex_state = 6},
  [1997] = {.lex_state = 11, .external_lex_state = 6},
  [1998] = {.lex_state = 11, .external_lex_state = 6},
  [1999] = {.lex_state = 11, .external_lex_state = 6},
  [2000] = {.lex_state = 11, .external_lex_state = 6},
  [2001] = {.lex_state = 11, .external_lex_state = 6},
  [2002] = {.lex_state = 11, .external_lex_state = 6},
  [2003] = {.lex_state = 11, .external_lex_state = 6},
  [2004] = {.lex_state = 11, .external_lex_state = 6},
  [2005] = {.lex_state = 11, .external_lex_state = 6},
  [2006] = {.lex_state = 11, .external_lex_state = 6},
  [2007] = {.lex_state = 11, .external_lex_state = 6},
  [2008] = {.lex_state = 11, .external_lex_state = 6},
  [2009] = {.lex_state = 11, .external_lex_state = 6},
  [2010] = {.lex_state = 11, .external_lex_state = 6},
  [2011] = {.lex_state = 11, .external_lex_state = 6},
  [2012] = {.lex_state = 11, .external_lex_state = 6},
  [2013] = {.lex_state = 11, .external_lex_state = 6},
  [2014] = {.lex_state = 11, .external_lex_state = 6},
  [2015] = {.lex_state = 11, .external_lex_state = 6},
  [2016] = {.lex_state = 11, .external_lex_state = 6},
  [2017] = {.lex_state = 11, .external_lex_state = 6},
  [2018] = {.lex_state = 11, .external_lex_state = 6},
  [2019] = {.lex_state = 11, .external_lex_state = 6},
  [2020] = {.lex_state = 11, .external_lex_state = 6},
  [2021] = {.lex_state = 11, .external_lex_state = 6},
  [2022] = {.lex_state = 11, .external_lex_state = 6},
  [2023] = {.lex_state = 11, .external_lex_state = 6},
  [2024] = {.lex_state = 11, .external_lex_state = 6},
  [2025] = {.lex_state = 11, .external_lex_state = 6},
  [2026] = {.lex_state = 11, .external_lex_state = 6},
  [2027] = {.lex_state = 11, .external_lex_state = 6},
  [2028] = {.lex_state = 11, .external_lex_state = 6},
  [2029] = {.lex_state = 11, .external_lex_state = 6},
  [2030] = {.lex_state = 11, .external_lex_state = 6},
  [2031] = {.lex_state = 11, .external_lex_state = 6},
  [2032] = {.lex_state = 11, .external_lex_state = 6},
  [2033] = {.lex_state = 11, .external_lex_state = 6},
  [2034] = {.lex_state = 11, .external_lex_state = 6},
  [2035] = {.lex_state = 11, .external_lex_state = 6},
  [2036] = {.lex_state = 11, .external_lex_state = 6},
  [2037] = {.lex_state = 11, .external_lex_state = 6},
  [2038] = {.lex_state = 11, .external_lex_state = 6},
  [2039] = {.lex_state = 11, .external_lex_state = 8},
  [2040] = {.lex_state = 11, .external_lex_state = 6},
  [2041] = {.lex_state = 11, .external_lex_state = 6},
  [2042] = {.lex_state = 11, .external_lex_state = 6},
  [2043] = {.lex_state = 11, .external_lex_state = 6},
  [2044] = {.lex_state = 11, .external_lex_state = 6},
  [2045] = {.lex_state = 11, .external_lex_state = 6},
  [2046] = {.lex_state = 11, .external_lex_state = 6},
  [2047] = {.lex_state = 11, .external_lex_state = 6},
  [2048] = {.lex_state = 11, .external_lex_state = 6},
  [2049] = {.lex_state = 11, .external_lex_state = 6},
  [2050] = {.lex_state = 11, .external_lex_state = 6},
  [2051] = {.lex_state = 11, .external_lex_state = 6},
  [2052] = {.lex_state = 11, .external_lex_state = 6},
  [2053] = {.lex_state = 11, .external_lex_state = 6},
  [2054] = {.lex_state = 11, .external_lex_state = 6},
  [2055] = {.lex_state = 11, .external_lex_state = 6},
  [2056] = {.lex_state = 11, .external_lex_state = 6},
  [2057] = {.lex_state = 11, .external_lex_state = 6},
  [2058] = {.lex_state = 11, .external_lex_state = 6},
  [2059] = {.lex_state = 11, .external_lex_state = 6},
  [2060] = {.lex_state = 11, .external_lex_state = 6},
  [2061] = {.lex_state = 11, .external_lex_state = 6},
  [2062] = {.lex_state = 11, .external_lex_state = 6},
  [2063] = {.lex_state = 11, .external_lex_state = 6},
  [2064] = {.lex_state = 11, .external_lex_state = 6},
  [2065] = {.lex_state = 11, .external_lex_state = 6},
  [2066] = {.lex_state = 11, .external_lex_state = 6},
  [2067] = {.lex_state = 11, .external_lex_state = 6},
  [2068] = {.lex_state = 11, .external_lex_state = 6},
  [2069] = {.lex_state = 11, .external_lex_state = 6},
  [2070] = {.lex_state = 11, .external_lex_state = 6},
  [2071] = {.lex_state = 11, .external_lex_state = 6},
  [2072] = {.lex_state = 11, .external_lex_state = 6},
  [2073] = {.lex_state = 11, .external_lex_state = 6},
  [2074] = {.lex_state = 11, .external_lex_state = 6},
  [2075] = {.lex_state = 11, .external_lex_state = 6},
  [2076] = {.lex_state = 11, .external_lex_state = 6},
  [2077] = {.lex_state = 11, .external_lex_state = 6},
  [2078] = {.lex_state = 11, .external_lex_state = 6},
  [2079] = {.lex_state = 11, .external_lex_state = 6},
  [2080] = {.lex_state = 11, .external_lex_state = 6},
  [2081] = {.lex_state = 11, .external_lex_state = 6},
  [2082] = {.lex_state = 11, .external_lex_state = 6},
  [2083] = {.lex_state = 11, .external_lex_state = 6},
  [2084] = {.lex_state = 11, .external_lex_state = 6},
  [2085] = {.lex_state = 11, .external_lex_state = 6},
  [2086] = {.lex_state = 11, .external_lex_state = 6},
  [2087] = {.lex_state = 11, .external_lex_state = 6},
  [2088] = {.lex_state = 11, .external_lex_state = 6},
  [2089] = {.lex_state = 11, .external_lex_state = 6},
  [2090] = {.lex_state = 11, .external_lex_state = 6},
  [2091] = {.lex_state = 11, .external_lex_state = 6},
  [2092] = {.lex_state = 11, .external_lex_state = 6},
  [2093] = {.lex_state = 11, .external_lex_state = 6},
  [2094] = {.lex_state = 11, .external_lex_state = 6},
  [2095] = {.lex_state = 11, .external_lex_state = 6},
  [2096] = {.lex_state = 11, .external_lex_state = 6},
  [2097] = {.lex_state = 11, .external_lex_state = 6},
  [2098] = {.lex_state = 11, .external_lex_state = 6},
  [2099] = {.lex_state = 11, .external_lex_state = 6},
  [2100] = {.lex_state = 11, .external_lex_state = 6},
  [2101] = {.lex_state = 11, .external_lex_state = 6},
  [2102] = {.lex_state = 11, .external_lex_state = 6},
  [2103] = {.lex_state = 11, .external_lex_state = 6},
  [2104] = {.lex_state = 11, .external_lex_state = 6},
  [2105] = {.lex_state = 11, .external_lex_state = 6},
  [2106] = {.lex_state = 11, .external_lex_state = 6},
  [2107] = {.lex_state = 11, .external_lex_state = 6},
  [2108] = {.lex_state = 11, .external_lex_state = 6},
  [2109] = {.lex_state = 11, .external_lex_state = 6},
  [2110] = {.lex_state = 11, .external_lex_state = 6},
  [2111] = {.lex_state = 11, .external_lex_state = 6},
  [2112] = {.lex_state = 11, .external_lex_state = 6},
  [2113] = {.lex_state = 11, .external_lex_state = 6},
  [2114] = {.lex_state = 11, .external_lex_state = 6},
  [2115] = {.lex_state = 11, .external_lex_state = 6},
  [2116] = {.lex_state = 11, .external_lex_state = 6},
  [2117] = {.lex_state = 11, .external_lex_state = 6},
  [2118] = {.lex_state = 4, .external_lex_state = 3},
  [2119] = {.lex_state = 4, .external_lex_state = 4},
  [2120] = {.lex_state = 4, .external_lex_state = 4},
  [2121] = {.lex_state = 4, .external_lex_state = 4},
  [2122] = {.lex_state = 4, .external_lex_state = 4},
  [2123] = {.lex_state = 4, .external_lex_state = 4},
  [2124] = {.lex_state = 4, .external_lex_state = 4},
  [2125] = {.lex_state = 4, .external_lex_state = 4},
  [2126] = {.lex_state = 4, .external_lex_state = 4},
  [2127] = {.lex_state = 4, .external_lex_state = 4},
  [2128] = {.lex_state = 4, .external_lex_state = 5},
  [2129] = {.lex_state = 4, .external_lex_state = 4},
  [2130] = {.lex_state = 6, .external_lex_state = 4},
  [2131] = {.lex_state = 4, .external_lex_state = 5},
  [2132] = {.lex_state = 4, .external_lex_state = 5},
  [2133] = {.lex_state = 4, .external_lex_state = 5},
  [2134] = {.lex_state = 4, .external_lex_state = 5},
  [2135] = {.lex_state = 4, .external_lex_state = 4},
  [2136] = {.lex_state = 4, .external_lex_state = 4},
  [2137] = {.lex_state = 4, .external_lex_state = 4},
  [2138] = {.lex_state = 4, .external_lex_state = 4},
  [2139] = {.lex_state = 4, .external_lex_state = 4},
  [2140] = {.lex_state = 4, .external_lex_state = 4},
  [2141] = {.lex_state = 4, .external_lex_state = 4},
  [2142] = {.lex_state = 4, .external_lex_state = 4},
  [2143] = {.lex_state = 4, .external_lex_state = 4},
  [2144] = {.lex_state = 4, .external_lex_state = 4},
  [2145] = {.lex_state = 4, .external_lex_state = 4},
  [2146] = {.lex_state = 4, .external_lex_state = 4},
  [2147] = {.lex_state = 4, .external_lex_state = 4},
  [2148] = {.lex_state = 4, .external_lex_state = 4},
  [2149] = {.lex_state = 4, .external_lex_state = 4},
  [2150] = {.lex_state = 4, .external_lex_state = 4},
  [2151] = {.lex_state = 4, .external_lex_state = 4},
  [2152] = {.lex_state = 4, .external_lex_state = 4},
  [2153] = {.lex_state = 4, .external_lex_state = 4},
  [2154] = {.lex_state = 4, .external_lex_state = 4},
  [2155] = {.lex_state = 4, .external_lex_state = 4},
  [2156] = {.lex_state = 4, .external_lex_state = 4},
  [2157] = {.lex_state = 4, .external_lex_state = 4},
  [2158] = {.lex_state = 4, .external_lex_state = 4},
  [2159] = {.lex_state = 4, .external_lex_state = 4},
  [2160] = {.lex_state = 4, .external_lex_state = 4},
  [2161] = {.lex_state = 4, .external_lex_state = 4},
  [2162] = {.lex_state = 4, .external_lex_state = 4},
  [2163] = {.lex_state = 4, .external_lex_state = 4},
  [2164] = {.lex_state = 4, .external_lex_state = 4},
  [2165] = {.lex_state = 4, .external_lex_state = 4},
  [2166] = {.lex_state = 4, .external_lex_state = 4},
  [2167] = {.lex_state = 4, .external_lex_state = 4},
  [2168] = {.lex_state = 4, .external_lex_state = 4},
  [2169] = {.lex_state = 4, .external_lex_state = 4},
  [2170] = {.lex_state = 4, .external_lex_state = 4},
  [2171] = {.lex_state = 4, .external_lex_state = 4},
  [2172] = {.lex_state = 4, .external_lex_state = 4},
  [2173] = {.lex_state = 4, .external_lex_state = 4},
  [2174] = {.lex_state = 4, .external_lex_state = 4},
  [2175] = {.lex_state = 4, .external_lex_state = 4},
  [2176] = {.lex_state = 4, .external_lex_state = 4},
  [2177] = {.lex_state = 4, .external_lex_state = 4},
  [2178] = {.lex_state = 4, .external_lex_state = 4},
  [2179] = {.lex_state = 4, .external_lex_state = 4},
  [2180] = {.lex_state = 4, .external_lex_state = 4},
  [2181] = {.lex_state = 4, .external_lex_state = 4},
  [2182] = {.lex_state = 4, .external_lex_state = 4},
  [2183] = {.lex_state = 4, .external_lex_state = 4},
  [2184] = {.lex_state = 4, .external_lex_state = 4},
  [2185] = {.lex_state = 4, .external_lex_state = 4},
  [2186] = {.lex_state = 4, .external_lex_state = 4},
  [2187] = {.lex_state = 4, .external_lex_state = 4},
  [2188] = {.lex_state = 4, .external_lex_state = 4},
  [2189] = {.lex_state = 4, .external_lex_state = 4},
  [2190] = {.lex_state = 4, .external_lex_state = 4},
  [2191] = {.lex_state = 4, .external_lex_state = 4},
  [2192] = {.lex_state = 4, .external_lex_state = 4},
  [2193] = {.lex_state = 4, .external_lex_state = 4},
  [2194] = {.lex_state = 4, .external_lex_state = 4},
  [2195] = {.lex_state = 4, .external_lex_state = 4},
  [2196] = {.lex_state = 4, .external_lex_state = 4},
  [2197] = {.lex_state = 4, .external_lex_state = 4},
  [2198] = {.lex_state = 4, .external_lex_state = 4},
  [2199] = {.lex_state = 4, .external_lex_state = 4},
  [2200] = {.lex_state = 4, .external_lex_state = 4},
  [2201] = {.lex_state = 4, .external_lex_state = 4},
  [2202] = {.lex_state = 4, .external_lex_state = 4},
  [2203] = {.lex_state = 4, .external_lex_state = 4},
  [2204] = {.lex_state = 4, .external_lex_state = 4},
  [2205] = {.lex_state = 4, .external_lex_state = 4},
  [2206] = {.lex_state = 4, .external_lex_state = 4},
  [2207] = {.lex_state = 4, .external_lex_state = 4},
  [2208] = {.lex_state = 4, .external_lex_state = 4},
  [2209] = {.lex_state = 4, .external_lex_state = 4},
  [2210] = {.lex_state = 4, .external_lex_state = 4},
  [2211] = {.lex_state = 20, .external_lex_state = 7},
  [2212] = {.lex_state = 230, .external_lex_state = 7},
  [2213] = {.lex_state = 8, .external_lex_state = 7},
  [2214] = {.lex_state = 229, .external_lex_state = 7},
  [2215] = {.lex_state = 20, .external_lex_state = 6},
  [2216] = {.lex_state = 229, .external_lex_state = 6},
  [2217] = {.lex_state = 230, .external_lex_state = 6},
  [2218] = {.lex_state = 8, .external_lex_state = 6},
  [2219] = {.lex_state = 229, .external_lex_state = 7},
  [2220] = {.lex_state = 8, .external_lex_state = 7},
  [2221] = {.lex_state = 229, .external_lex_state = 7},
  [2222] = {.lex_state = 229, .external_lex_state = 7},
  [2223] = {.lex_state = 8, .external_lex_state = 7},
  [2224] = {.lex_state = 229, .external_lex_state = 7},
  [2225] = {.lex_state = 8, .external_lex_state = 7},
  [2226] = {.lex_state = 8, .external_lex_state = 7},
  [2227] = {.lex_state = 8, .external_lex_state = 7},
  [2228] = {.lex_state = 8, .external_lex_state = 7},
  [2229] = {.lex_state = 229, .external_lex_state = 7},
  [2230] = {.lex_state = 229, .external_lex_state = 7},
  [2231] = {.lex_state = 229, .external_lex_state = 7},
  [2232] = {.lex_state = 229, .external_lex_state = 7},
  [2233] = {.lex_state = 8, .external_lex_state = 7},
  [2234] = {.lex_state = 229, .external_lex_state = 7},
  [2235] = {.lex_state = 8, .external_lex_state = 7},
  [2236] = {.lex_state = 8, .external_lex_state = 7},
  [2237] = {.lex_state = 229, .external_lex_state = 7},
  [2238] = {.lex_state = 8, .external_lex_state = 7},
  [2239] = {.lex_state = 229, .external_lex_state = 7},
  [2240] = {.lex_state = 229, .external_lex_state = 7},
  [2241] = {.lex_state = 8, .external_lex_state = 7},
  [2242] = {.lex_state = 8, .external_lex_state = 7},
  [2243] = {.lex_state = 229, .external_lex_state = 7},
  [2244] = {.lex_state = 8, .external_lex_state = 7},
  [2245] = {.lex_state = 229, .external_lex_state = 7},
  [2246] = {.lex_state = 229, .external_lex_state = 7},
  [2247] = {.lex_state = 229, .external_lex_state = 7},
  [2248] = {.lex_state = 229, .external_lex_state = 7},
  [2249] = {.lex_state = 229, .external_lex_state = 7},
  [2250] = {.lex_state = 229, .external_lex_state = 6},
  [2251] = {.lex_state = 229, .external_lex_state = 7},
  [2252] = {.lex_state = 229, .external_lex_state = 7},
  [2253] = {.lex_state = 229, .external_lex_state = 7},
  [2254] = {.lex_state = 229, .external_lex_state = 7},
  [2255] = {.lex_state = 229, .external_lex_state = 7},
  [2256] = {.lex_state = 229, .external_lex_state = 7},
  [2257] = {.lex_state = 229, .external_lex_state = 7},
  [2258] = {.lex_state = 229, .external_lex_state = 7},
  [2259] = {.lex_state = 229, .external_lex_state = 7},
  [2260] = {.lex_state = 229, .external_lex_state = 6},
  [2261] = {.lex_state = 229, .external_lex_state = 6},
  [2262] = {.lex_state = 229, .external_lex_state = 7},
  [2263] = {.lex_state = 8, .external_lex_state = 6},
  [2264] = {.lex_state = 229, .external_lex_state = 7},
  [2265] = {.lex_state = 229, .external_lex_state = 7},
  [2266] = {.lex_state = 229, .external_lex_state = 7},
  [2267] = {.lex_state = 229, .external_lex_state = 7},
  [2268] = {.lex_state = 8, .external_lex_state = 6},
  [2269] = {.lex_state = 229, .external_lex_state = 7},
  [2270] = {.lex_state = 229, .external_lex_state = 7},
  [2271] = {.lex_state = 229, .external_lex_state = 7},
  [2272] = {.lex_state = 229, .external_lex_state = 7},
  [2273] = {.lex_state = 229, .external_lex_state = 7},
  [2274] = {.lex_state = 8, .external_lex_state = 6},
  [2275] = {.lex_state = 229, .external_lex_state = 7},
  [2276] = {.lex_state = 229, .external_lex_state = 7},
  [2277] = {.lex_state = 229, .external_lex_state = 7},
  [2278] = {.lex_state = 229, .external_lex_state = 7},
  [2279] = {.lex_state = 229, .external_lex_state = 7},
  [2280] = {.lex_state = 229, .external_lex_state = 7},
  [2281] = {.lex_state = 229, .external_lex_state = 7},
  [2282] = {.lex_state = 229, .external_lex_state = 7},
  [2283] = {.lex_state = 229, .external_lex_state = 7},
  [2284] = {.lex_state = 229, .external_lex_state = 7},
  [2285] = {.lex_state = 8, .external_lex_state = 7},
  [2286] = {.lex_state = 8, .external_lex_state = 7},
  [2287] = {.lex_state = 8, .external_lex_state = 7},
  [2288] = {.lex_state = 8, .external_lex_state = 7},
  [2289] = {.lex_state = 8, .external_lex_state = 7},
  [2290] = {.lex_state = 229, .external_lex_state = 7},
  [2291] = {.lex_state = 8, .external_lex_state = 7},
  [2292] = {.lex_state = 8, .external_lex_state = 7},
  [2293] = {.lex_state = 8, .external_lex_state = 7},
  [2294] = {.lex_state = 8, .external_lex_state = 7},
  [2295] = {.lex_state = 8, .external_lex_state = 7},
  [2296] = {.lex_state = 8, .external_lex_state = 6},
  [2297] = {.lex_state = 8, .external_lex_state = 7},
  [2298] = {.lex_state = 229, .external_lex_state = 7},
  [2299] = {.lex_state = 229, .external_lex_state = 7},
  [2300] = {.lex_state = 229, .external_lex_state = 7},
  [2301] = {.lex_state = 229, .external_lex_state = 7},
  [2302] = {.lex_state = 229, .external_lex_state = 7},
  [2303] = {.lex_state = 8, .external_lex_state = 7},
  [2304] = {.lex_state = 8, .external_lex_state = 7},
  [2305] = {.lex_state = 8, .external_lex_state = 7},
  [2306] = {.lex_state = 229, .external_lex_state = 7},
  [2307] = {.lex_state = 8, .external_lex_state = 7},
  [2308] = {.lex_state = 229, .external_lex_state = 7},
  [2309] = {.lex_state = 229, .external_lex_state = 7},
  [2310] = {.lex_state = 229, .external_lex_state = 7},
  [2311] = {.lex_state = 8, .external_lex_state = 7},
  [2312] = {.lex_state = 229, .external_lex_state = 7},
  [2313] = {.lex_state = 229, .external_lex_state = 7},
  [2314] = {.lex_state = 229, .external_lex_state = 7},
  [2315] = {.lex_state = 8, .external_lex_state = 7},
  [2316] = {.lex_state = 8, .external_lex_state = 7},
  [2317] = {.lex_state = 229, .external_lex_state = 7},
  [2318] = {.lex_state = 8, .external_lex_state = 7},
  [2319] = {.lex_state = 8, .external_lex_state = 7},
  [2320] = {.lex_state = 8, .external_lex_state = 7},
  [2321] = {.lex_state = 8, .external_lex_state = 7},
  [2322] = {.lex_state = 8, .external_lex_state = 7},
  [2323] = {.lex_state = 8, .external_lex_state = 7},
  [2324] = {.lex_state = 8, .external_lex_state = 7},
  [2325] = {.lex_state = 8, .external_lex_state = 7},
  [2326] = {.lex_state = 8, .external_lex_state = 7},
  [2327] = {.lex_state = 8, .external_lex_state = 7},
  [2328] = {.lex_state = 229, .external_lex_state = 7},
  [2329] = {.lex_state = 8, .external_lex_state = 7},
  [2330] = {.lex_state = 8, .external_lex_state = 7},
  [2331] = {.lex_state = 8, .external_lex_state = 7},
  [2332] = {.lex_state = 8, .external_lex_state = 7},
  [2333] = {.lex_state = 8, .external_lex_state = 7},
  [2334] = {.lex_state = 8, .external_lex_state = 7},
  [2335] = {.lex_state = 8, .external_lex_state = 7},
  [2336] = {.lex_state = 229, .external_lex_state = 7},
  [2337] = {.lex_state = 229, .external_lex_state = 7},
  [2338] = {.lex_state = 229, .external_lex_state = 7},
  [2339] = {.lex_state = 229, .external_lex_state = 7},
  [2340] = {.lex_state = 8, .external_lex_state = 7},
  [2341] = {.lex_state = 8, .external_lex_state = 7},
  [2342] = {.lex_state = 8, .external_lex_state = 7},
  [2343] = {.lex_state = 8, .external_lex_state = 7},
  [2344] = {.lex_state = 8, .external_lex_state = 7},
  [2345] = {.lex_state = 229, .external_lex_state = 7},
  [2346] = {.lex_state = 229, .external_lex_state = 7},
  [2347] = {.lex_state = 229, .external_lex_state = 7},
  [2348] = {.lex_state = 8, .external_lex_state = 7},
  [2349] = {.lex_state = 8, .external_lex_state = 7},
  [2350] = {.lex_state = 8, .external_lex_state = 7},
  [2351] = {.lex_state = 8, .external_lex_state = 7},
  [2352] = {.lex_state = 8, .external_lex_state = 7},
  [2353] = {.lex_state = 8, .external_lex_state = 7},
  [2354] = {.lex_state = 8, .external_lex_state = 7},
  [2355] = {.lex_state = 8, .external_lex_state = 7},
  [2356] = {.lex_state = 8, .external_lex_state = 7},
  [2357] = {.lex_state = 8, .external_lex_state = 7},
  [2358] = {.lex_state = 8, .external_lex_state = 7},
  [2359] = {.lex_state = 8, .external_lex_state = 7},
  [2360] = {.lex_state = 8, .external_lex_state = 7},
  [2361] = {.lex_state = 8, .external_lex_state = 7},
  [2362] = {.lex_state = 8, .external_lex_state = 7},
  [2363] = {.lex_state = 8, .external_lex_state = 7},
  [2364] = {.lex_state = 229, .external_lex_state = 6},
  [2365] = {.lex_state = 8, .external_lex_state = 7},
  [2366] = {.lex_state = 8, .external_lex_state = 7},
  [2367] = {.lex_state = 229, .external_lex_state = 7},
  [2368] = {.lex_state = 229, .external_lex_state = 7},
  [2369] = {.lex_state = 8, .external_lex_state = 6},
  [2370] = {.lex_state = 8, .external_lex_state = 6},
  [2371] = {.lex_state = 8, .external_lex_state = 6},
  [2372] = {.lex_state = 229, .external_lex_state = 6},
  [2373] = {.lex_state = 229, .external_lex_state = 6},
  [2374] = {.lex_state = 8, .external_lex_state = 6},
  [2375] = {.lex_state = 229, .external_lex_state = 6},
  [2376] = {.lex_state = 229, .external_lex_state = 6},
  [2377] = {.lex_state = 8, .external_lex_state = 6},
  [2378] = {.lex_state = 8, .external_lex_state = 6},
  [2379] = {.lex_state = 229, .external_lex_state = 6},
  [2380] = {.lex_state = 229, .external_lex_state = 6},
  [2381] = {.lex_state = 8, .external_lex_state = 6},
  [2382] = {.lex_state = 229, .external_lex_state = 6},
  [2383] = {.lex_state = 229, .external_lex_state = 6},
  [2384] = {.lex_state = 229, .external_lex_state = 6},
  [2385] = {.lex_state = 8, .external_lex_state = 6},
  [2386] = {.lex_state = 8, .external_lex_state = 6},
  [2387] = {.lex_state = 8, .external_lex_state = 6},
  [2388] = {.lex_state = 229, .external_lex_state = 6},
  [2389] = {.lex_state = 229, .external_lex_state = 6},
  [2390] = {.lex_state = 229, .external_lex_state = 6},
  [2391] = {.lex_state = 8, .external_lex_state = 6},
  [2392] = {.lex_state = 8, .external_lex_state = 6},
  [2393] = {.lex_state = 8, .external_lex_state = 6},
  [2394] = {.lex_state = 8, .external_lex_state = 6},
  [2395] = {.lex_state = 8, .external_lex_state = 6},
  [2396] = {.lex_state = 8, .external_lex_state = 6},
  [2397] = {.lex_state = 229, .external_lex_state = 6},
  [2398] = {.lex_state = 8, .external_lex_state = 6},
  [2399] = {.lex_state = 8, .external_lex_state = 6},
  [2400] = {.lex_state = 229, .external_lex_state = 6},
  [2401] = {.lex_state = 8, .external_lex_state = 6},
  [2402] = {.lex_state = 8, .external_lex_state = 6},
  [2403] = {.lex_state = 8, .external_lex_state = 6},
  [2404] = {.lex_state = 8, .external_lex_state = 6},
  [2405] = {.lex_state = 8, .external_lex_state = 6},
  [2406] = {.lex_state = 229, .external_lex_state = 6},
  [2407] = {.lex_state = 229, .external_lex_state = 6},
  [2408] = {.lex_state = 229, .external_lex_state = 6},
  [2409] = {.lex_state = 229, .external_lex_state = 6},
  [2410] = {.lex_state = 229, .external_lex_state = 6},
  [2411] = {.lex_state = 8, .external_lex_state = 6},
  [2412] = {.lex_state = 8, .external_lex_state = 6},
  [2413] = {.lex_state = 8, .external_lex_state = 6},
  [2414] = {.lex_state = 8, .external_lex_state = 6},
  [2415] = {.lex_state = 8, .external_lex_state = 6},
  [2416] = {.lex_state = 229, .external_lex_state = 6},
  [2417] = {.lex_state = 8, .external_lex_state = 6},
  [2418] = {.lex_state = 229, .external_lex_state = 6},
  [2419] = {.lex_state = 8, .external_lex_state = 6},
  [2420] = {.lex_state = 229, .external_lex_state = 6},
  [2421] = {.lex_state = 229, .external_lex_state = 6},
  [2422] = {.lex_state = 229, .external_lex_state = 6},
  [2423] = {.lex_state = 8, .external_lex_state = 6},
  [2424] = {.lex_state = 8, .external_lex_state = 6},
  [2425] = {.lex_state = 8, .external_lex_state = 6},
  [2426] = {.lex_state = 229, .external_lex_state = 6},
  [2427] = {.lex_state = 229, .external_lex_state = 6},
  [2428] = {.lex_state = 8, .external_lex_state = 6},
  [2429] = {.lex_state = 8, .external_lex_state = 6},
  [2430] = {.lex_state = 8, .external_lex_state = 6},
  [2431] = {.lex_state = 8, .external_lex_state = 6},
  [2432] = {.lex_state = 229, .external_lex_state = 6},
  [2433] = {.lex_state = 8, .external_lex_state = 6},
  [2434] = {.lex_state = 8, .external_lex_state = 6},
  [2435] = {.lex_state = 8, .external_lex_state = 6},
  [2436] = {.lex_state = 8, .external_lex_state = 6},
  [2437] = {.lex_state = 8, .external_lex_state = 6},
  [2438] = {.lex_state = 8, .external_lex_state = 6},
  [2439] = {.lex_state = 8, .external_lex_state = 6},
  [2440] = {.lex_state = 8, .external_lex_state = 6},
  [2441] = {.lex_state = 229, .external_lex_state = 6},
  [2442] = {.lex_state = 8, .external_lex_state = 6},
  [2443] = {.lex_state = 8, .external_lex_state = 6},
  [2444] = {.lex_state = 8, .external_lex_state = 6},
  [2445] = {.lex_state = 8, .external_lex_state = 6},
  [2446] = {.lex_state = 8, .external_lex_state = 6},
  [2447] = {.lex_state = 8, .external_lex_state = 6},
  [2448] = {.lex_state = 8, .external_lex_state = 6},
  [2449] = {.lex_state = 8, .external_lex_state = 6},
  [2450] = {.lex_state = 229, .external_lex_state = 6},
  [2451] = {.lex_state = 229, .external_lex_state = 6},
  [2452] = {.lex_state = 229, .external_lex_state = 6},
  [2453] = {.lex_state = 8, .external_lex_state = 6},
  [2454] = {.lex_state = 8, .external_lex_state = 6},
  [2455] = {.lex_state = 229, .external_lex_state = 6},
  [2456] = {.lex_state = 229, .external_lex_state = 6},
  [2457] = {.lex_state = 8, .external_lex_state = 6},
  [2458] = {.lex_state = 229, .external_lex_state = 6},
  [2459] = {.lex_state = 229, .external_lex_state = 6},
  [2460] = {.lex_state = 229, .external_lex_state = 6},
  [2461] = {.lex_state = 229, .external_lex_state = 6},
  [2462] = {.lex_state = 229, .external_lex_state = 6},
  [2463] = {.lex_state = 229, .external_lex_state = 6},
  [2464] = {.lex_state = 229, .external_lex_state = 6},
  [2465] = {.lex_state = 229, .external_lex_state = 6},
  [2466] = {.lex_state = 8, .external_lex_state = 6},
  [2467] = {.lex_state = 8, .external_lex_state = 6},
  [2468] = {.lex_state = 229, .external_lex_state = 6},
  [2469] = {.lex_state = 229, .external_lex_state = 6},
  [2470] = {.lex_state = 229, .external_lex_state = 6},
  [2471] = {.lex_state = 229, .external_lex_state = 6},
  [2472] = {.lex_state = 229, .external_lex_state = 6},
  [2473] = {.lex_state = 229, .external_lex_state = 6},
  [2474] = {.lex_state = 229, .external_lex_state = 6},
  [2475] = {.lex_state = 8, .external_lex_state = 6},
  [2476] = {.lex_state = 229, .external_lex_state = 6},
  [2477] = {.lex_state = 229, .external_lex_state = 6},
  [2478] = {.lex_state = 229, .external_lex_state = 6},
  [2479] = {.lex_state = 229, .external_lex_state = 6},
  [2480] = {.lex_state = 229, .external_lex_state = 6},
  [2481] = {.lex_state = 229, .external_lex_state = 6},
  [2482] = {.lex_state = 8, .external_lex_state = 6},
  [2483] = {.lex_state = 229, .external_lex_state = 6},
  [2484] = {.lex_state = 8, .external_lex_state = 6},
  [2485] = {.lex_state = 8, .external_lex_state = 6},
  [2486] = {.lex_state = 229, .external_lex_state = 6},
  [2487] = {.lex_state = 8, .external_lex_state = 6},
  [2488] = {.lex_state = 8, .external_lex_state = 6},
  [2489] = {.lex_state = 8, .external_lex_state = 6},
  [2490] = {.lex_state = 8, .external_lex_state = 6},
  [2491] = {.lex_state = 229, .external_lex_state = 6},
  [2492] = {.lex_state = 229, .external_lex_state = 6},
  [2493] = {.lex_state = 229, .external_lex_state = 6},
  [2494] = {.lex_state = 229, .external_lex_state = 6},
  [2495] = {.lex_state = 229, .external_lex_state = 6},
  [2496] = {.lex_state = 229, .external_lex_state = 6},
  [2497] = {.lex_state = 229, .external_lex_state = 6},
  [2498] = {.lex_state = 229, .external_lex_state = 6},
  [2499] = {.lex_state = 229, .external_lex_state = 6},
  [2500] = {.lex_state = 229, .external_lex_state = 6},
  [2501] = {.lex_state = 229, .external_lex_state = 6},
  [2502] = {.lex_state = 8, .external_lex_state = 6},
  [2503] = {.lex_state = 10, .external_lex_state = 6},
  [2504] = {.lex_state = 21, .external_lex_state = 6},
  [2505] = {.lex_state = 7, .external_lex_state = 6},
  [2506] = {.lex_state = 10, .external_lex_state = 6},
  [2507] = {.lex_state = 10, .external_lex_state = 8},
  [2508] = {.lex_state = 11, .external_lex_state = 6},
  [2509] = {.lex_state = 11, .external_lex_state = 6},
  [2510] = {.lex_state = 10, .external_lex_state = 6},
  [2511] = {.lex_state = 11, .external_lex_state = 6},
  [2512] = {.lex_state = 10, .external_lex_state = 6},
  [2513] = {.lex_state = 10, .external_lex_state = 6},
  [2514] = {.lex_state = 10, .external_lex_state = 6},
  [2515] = {.lex_state = 11, .external_lex_state = 6},
  [2516] = {.lex_state = 10, .external_lex_state = 6},
  [2517] = {.lex_state = 10, .external_lex_state = 6},
  [2518] = {.lex_state = 11, .external_lex_state = 6},
  [2519] = {.lex_state = 11, .external_lex_state = 6},
  [2520] = {.lex_state = 11, .external_lex_state = 6},
  [2521] = {.lex_state = 11, .external_lex_state = 6},
  [2522] = {.lex_state = 11, .external_lex_state = 6},
  [2523] = {.lex_state = 10, .external_lex_state = 6},
  [2524] = {.lex_state = 10, .external_lex_state = 6},
  [2525] = {.lex_state = 10, .external_lex_state = 6},
  [2526] = {.lex_state = 10, .external_lex_state = 6},
  [2527] = {.lex_state = 11, .external_lex_state = 6},
  [2528] = {.lex_state = 10, .external_lex_state = 6},
  [2529] = {.lex_state = 10, .external_lex_state = 6},
  [2530] = {.lex_state = 10, .external_lex_state = 6},
  [2531] = {.lex_state = 11, .external_lex_state = 6},
  [2532] = {.lex_state = 10, .external_lex_state = 6},
  [2533] = {.lex_state = 10, .external_lex_state = 6},
  [2534] = {.lex_state = 11, .external_lex_state = 6},
  [2535] = {.lex_state = 10, .external_lex_state = 6},
  [2536] = {.lex_state = 10, .external_lex_state = 6},
  [2537] = {.lex_state = 11, .external_lex_state = 6},
  [2538] = {.lex_state = 10, .external_lex_state = 6},
  [2539] = {.lex_state = 10, .external_lex_state = 6},
  [2540] = {.lex_state = 10, .external_lex_state = 6},
  [2541] = {.lex_state = 10, .external_lex_state = 6},
  [2542] = {.lex_state = 11, .external_lex_state = 6},
  [2543] = {.lex_state = 10, .external_lex_state = 6},
  [2544] = {.lex_state = 10, .external_lex_state = 8},
  [2545] = {.lex_state = 10, .external_lex_state = 6},
  [2546] = {.lex_state = 11, .external_lex_state = 6},
  [2547] = {.lex_state = 11, .external_lex_state = 6},
  [2548] = {.lex_state = 10, .external_lex_state = 6},
  [2549] = {.lex_state = 11, .external_lex_state = 6},
  [2550] = {.lex_state = 11, .external_lex_state = 6},
  [2551] = {.lex_state = 11, .external_lex_state = 6},
  [2552] = {.lex_state = 10, .external_lex_state = 6},
  [2553] = {.lex_state = 10, .external_lex_state = 8},
  [2554] = {.lex_state = 10, .external_lex_state = 6},
  [2555] = {.lex_state = 10, .external_lex_state = 6},
  [2556] = {.lex_state = 10, .external_lex_state = 6},
  [2557] = {.lex_state = 10, .external_lex_state = 6},
  [2558] = {.lex_state = 11, .external_lex_state = 6},
  [2559] = {.lex_state = 11, .external_lex_state = 6},
  [2560] = {.lex_state = 10, .external_lex_state = 8},
  [2561] = {.lex_state = 11, .external_lex_state = 6},
  [2562] = {.lex_state = 11, .external_lex_state = 6},
  [2563] = {.lex_state = 10, .external_lex_state = 6},
  [2564] = {.lex_state = 10, .external_lex_state = 8},
  [2565] = {.lex_state = 10, .external_lex_state = 6},
  [2566] = {.lex_state = 10, .external_lex_state = 6},
  [2567] = {.lex_state = 10, .external_lex_state = 6},
  [2568] = {.lex_state = 10, .external_lex_state = 6},
  [2569] = {.lex_state = 10, .external_lex_state = 6},
  [2570] = {.lex_state = 10, .external_lex_state = 6},
  [2571] = {.lex_state = 11, .external_lex_state = 6},
  [2572] = {.lex_state = 11, .external_lex_state = 6},
  [2573] = {.lex_state = 11, .external_lex_state = 6},
  [2574] = {.lex_state = 11, .external_lex_state = 6},
  [2575] = {.lex_state = 10, .external_lex_state = 6},
  [2576] = {.lex_state = 11, .external_lex_state = 6},
  [2577] = {.lex_state = 11, .external_lex_state = 6},
  [2578] = {.lex_state = 11, .external_lex_state = 6},
  [2579] = {.lex_state = 11, .external_lex_state = 6},
  [2580] = {.lex_state = 11, .external_lex_state = 6},
  [2581] = {.lex_state = 11, .external_lex_state = 6},
  [2582] = {.lex_state = 10, .external_lex_state = 6},
  [2583] = {.lex_state = 10, .external_lex_state = 6},
  [2584] = {.lex_state = 10, .external_lex_state = 6},
  [2585] = {.lex_state = 10, .external_lex_state = 6},
  [2586] = {.lex_state = 10, .external_lex_state = 6},
  [2587] = {.lex_state = 10, .external_lex_state = 6},
  [2588] = {.lex_state = 10, .external_lex_state = 6},
  [2589] = {.lex_state = 10, .external_lex_state = 6},
  [2590] = {.lex_state = 10, .external_lex_state = 6},
  [2591] = {.lex_state = 10, .external_lex_state = 6},
  [2592] = {.lex_state = 10, .external_lex_state = 6},
  [2593] = {.lex_state = 10, .external_lex_state = 6},
  [2594] = {.lex_state = 10, .external_lex_state = 6},
  [2595] = {.lex_state = 10, .external_lex_state = 6},
  [2596] = {.lex_state = 11, .external_lex_state = 6},
  [2597] = {.lex_state = 11, .external_lex_state = 6},
  [2598] = {.lex_state = 11, .external_lex_state = 6},
  [2599] = {.lex_state = 11, .external_lex_state = 6},
  [2600] = {.lex_state = 11, .external_lex_state = 6},
  [2601] = {.lex_state = 11, .external_lex_state = 6},
  [2602] = {.lex_state = 11, .external_lex_state = 6},
  [2603] = {.lex_state = 11, .external_lex_state = 6},
  [2604] = {.lex_state = 10, .external_lex_state = 6},
  [2605] = {.lex_state = 11, .external_lex_state = 6},
  [2606] = {.lex_state = 11, .external_lex_state = 6},
  [2607] = {.lex_state = 11, .external_lex_state = 6},
  [2608] = {.lex_state = 10, .external_lex_state = 6},
  [2609] = {.lex_state = 10, .external_lex_state = 6},
  [2610] = {.lex_state = 11, .external_lex_state = 6},
  [2611] = {.lex_state = 11, .external_lex_state = 6},
  [2612] = {.lex_state = 10, .external_lex_state = 6},
  [2613] = {.lex_state = 10, .external_lex_state = 6},
  [2614] = {.lex_state = 10, .external_lex_state = 6},
  [2615] = {.lex_state = 11, .external_lex_state = 6},
  [2616] = {.lex_state = 11, .external_lex_state = 6},
  [2617] = {.lex_state = 10, .external_lex_state = 6},
  [2618] = {.lex_state = 11, .external_lex_state = 6},
  [2619] = {.lex_state = 10, .external_lex_state = 6},
  [2620] = {.lex_state = 10, .external_lex_state = 6},
  [2621] = {.lex_state = 10, .external_lex_state = 6},
  [2622] = {.lex_state = 10, .external_lex_state = 6},
  [2623] = {.lex_state = 11, .external_lex_state = 6},
  [2624] = {.lex_state = 11, .external_lex_state = 6},
  [2625] = {.lex_state = 11, .external_lex_state = 6},
  [2626] = {.lex_state = 10, .external_lex_state = 6},
  [2627] = {.lex_state = 11, .external_lex_state = 6},
  [2628] = {.lex_state = 10, .external_lex_state = 6},
  [2629] = {.lex_state = 10, .external_lex_state = 6},
  [2630] = {.lex_state = 11, .external_lex_state = 6},
  [2631] = {.lex_state = 11, .external_lex_state = 6},
  [2632] = {.lex_state = 11, .external_lex_state = 6},
  [2633] = {.lex_state = 11, .external_lex_state = 6},
  [2634] = {.lex_state = 11, .external_lex_state = 6},
  [2635] = {.lex_state = 10, .external_lex_state = 6},
  [2636] = {.lex_state = 11, .external_lex_state = 6},
  [2637] = {.lex_state = 10, .external_lex_state = 6},
  [2638] = {.lex_state = 10, .external_lex_state = 6},
  [2639] = {.lex_state = 10, .external_lex_state = 6},
  [2640] = {.lex_state = 10, .external_lex_state = 6},
  [2641] = {.lex_state = 11, .external_lex_state = 6},
  [2642] = {.lex_state = 11, .external_lex_state = 6},
  [2643] = {.lex_state = 11, .external_lex_state = 6},
  [2644] = {.lex_state = 10, .external_lex_state = 6},
  [2645] = {.lex_state = 10, .external_lex_state = 6},
  [2646] = {.lex_state = 10, .external_lex_state = 6},
  [2647] = {.lex_state = 10, .external_lex_state = 6},
  [2648] = {.lex_state = 11, .external_lex_state = 6},
  [2649] = {.lex_state = 10, .external_lex_state = 6},
  [2650] = {.lex_state = 11, .external_lex_state = 6},
  [2651] = {.lex_state = 10, .external_lex_state = 6},
  [2652] = {.lex_state = 10, .external_lex_state = 6},
  [2653] = {.lex_state = 10, .external_lex_state = 6},
  [2654] = {.lex_state = 10, .external_lex_state = 6},
  [2655] = {.lex_state = 10, .external_lex_state = 6},
  [2656] = {.lex_state = 10, .external_lex_state = 6},
  [2657] = {.lex_state = 10, .external_lex_state = 6},
  [2658] = {.lex_state = 10, .external_lex_state = 6},
  [2659] = {.lex_state = 11, .external_lex_state = 6},
  [2660] = {.lex_state = 11, .external_lex_state = 6},
  [2661] = {.lex_state = 11, .external_lex_state = 6},
  [2662] = {.lex_state = 11, .external_lex_state = 6},
  [2663] = {.lex_state = 11, .external_lex_state = 6},
  [2664] = {.lex_state = 11, .external_lex_state = 6},
  [2665] = {.lex_state = 10, .external_lex_state = 6},
  [2666] = {.lex_state = 11, .external_lex_state = 6},
  [2667] = {.lex_state = 10, .external_lex_state = 8},
  [2668] = {.lex_state = 10, .external_lex_state = 6},
  [2669] = {.lex_state = 10, .external_lex_state = 6},
  [2670] = {.lex_state = 10, .external_lex_state = 6},
  [2671] = {.lex_state = 10, .external_lex_state = 6},
  [2672] = {.lex_state = 10, .external_lex_state = 6},
  [2673] = {.lex_state = 10, .external_lex_state = 6},
  [2674] = {.lex_state = 10, .external_lex_state = 6},
  [2675] = {.lex_state = 10, .external_lex_state = 6},
  [2676] = {.lex_state = 10, .external_lex_state = 6},
  [2677] = {.lex_state = 10, .external_lex_state = 8},
  [2678] = {.lex_state = 10, .external_lex_state = 6},
  [2679] = {.lex_state = 10, .external_lex_state = 6},
  [2680] = {.lex_state = 10, .external_lex_state = 8},
  [2681] = {.lex_state = 10, .external_lex_state = 6},
  [2682] = {.lex_state = 10, .external_lex_state = 6},
  [2683] = {.lex_state = 10, .external_lex_state = 6},
  [2684] = {.lex_state = 10, .external_lex_state = 6},
  [2685] = {.lex_state = 10, .external_lex_state = 6},
  [2686] = {.lex_state = 10, .external_lex_state = 8},
  [2687] = {.lex_state = 10, .external_lex_state = 6},
  [2688] = {.lex_state = 10, .external_lex_state = 6},
  [2689] = {.lex_state = 10, .external_lex_state = 6},
  [2690] = {.lex_state = 10, .external_lex_state = 6},
  [2691] = {.lex_state = 10, .external_lex_state = 8},
  [2692] = {.lex_state = 10, .external_lex_state = 6},
  [2693] = {.lex_state = 10, .external_lex_state = 6},
  [2694] = {.lex_state = 10, .external_lex_state = 6},
  [2695] = {.lex_state = 10, .external_lex_state = 6},
  [2696] = {.lex_state = 10, .external_lex_state = 8},
  [2697] = {.lex_state = 10, .external_lex_state = 6},
  [2698] = {.lex_state = 10, .external_lex_state = 6},
  [2699] = {.lex_state = 10, .external_lex_state = 6},
  [2700] = {.lex_state = 10, .external_lex_state = 6},
  [2701] = {.lex_state = 10, .external_lex_state = 8},
  [2702] = {.lex_state = 10, .external_lex_state = 6},
  [2703] = {.lex_state = 10, .external_lex_state = 6},
  [2704] = {.lex_state = 10, .external_lex_state = 6},
  [2705] = {.lex_state = 10, .external_lex_state = 6},
  [2706] = {.lex_state = 10, .external_lex_state = 6},
  [2707] = {.lex_state = 10, .external_lex_state = 6},
  [2708] = {.lex_state = 10, .external_lex_state = 6},
  [2709] = {.lex_state = 10, .external_lex_state = 6},
  [2710] = {.lex_state = 10, .external_lex_state = 6},
  [2711] = {.lex_state = 10, .external_lex_state = 6},
  [2712] = {.lex_state = 10, .external_lex_state = 6},
  [2713] = {.lex_state = 10, .external_lex_state = 6},
  [2714] = {.lex_state = 10, .external_lex_state = 6},
  [2715] = {.lex_state = 10, .external_lex_state = 6},
  [2716] = {.lex_state = 10, .external_lex_state = 6},
  [2717] = {.lex_state = 10, .external_lex_state = 8},
  [2718] = {.lex_state = 10, .external_lex_state = 6},
  [2719] = {.lex_state = 10, .external_lex_state = 6},
  [2720] = {.lex_state = 10, .external_lex_state = 6},
  [2721] = {.lex_state = 10, .external_lex_state = 6},
  [2722] = {.lex_state = 10, .external_lex_state = 6},
  [2723] = {.lex_state = 10, .external_lex_state = 6},
  [2724] = {.lex_state = 10, .external_lex_state = 6},
  [2725] = {.lex_state = 10, .external_lex_state = 6},
  [2726] = {.lex_state = 10, .external_lex_state = 6},
  [2727] = {.lex_state = 10, .external_lex_state = 6},
  [2728] = {.lex_state = 10, .external_lex_state = 6},
  [2729] = {.lex_state = 10, .external_lex_state = 6},
  [2730] = {.lex_state = 10, .external_lex_state = 6},
  [2731] = {.lex_state = 10, .external_lex_state = 6},
  [2732] = {.lex_state = 10, .external_lex_state = 6},
  [2733] = {.lex_state = 10, .external_lex_state = 8},
  [2734] = {.lex_state = 10, .external_lex_state = 8},
  [2735] = {.lex_state = 10, .external_lex_state = 8},
  [2736] = {.lex_state = 10, .external_lex_state = 8},
  [2737] = {.lex_state = 10, .external_lex_state = 8},
  [2738] = {.lex_state = 10, .external_lex_state = 8},
  [2739] = {.lex_state = 10, .external_lex_state = 8},
  [2740] = {.lex_state = 10, .external_lex_state = 8},
  [2741] = {.lex_state = 10, .external_lex_state = 8},
  [2742] = {.lex_state = 10, .external_lex_state = 8},
  [2743] = {.lex_state = 10, .external_lex_state = 8},
  [2744] = {.lex_state = 10, .external_lex_state = 8},
  [2745] = {.lex_state = 10, .external_lex_state = 8},
  [2746] = {.lex_state = 10, .external_lex_state = 8},
  [2747] = {.lex_state = 10, .external_lex_state = 8},
  [2748] = {.lex_state = 10, .external_lex_state = 8},
  [2749] = {.lex_state = 10, .external_lex_state = 8},
  [2750] = {.lex_state = 10, .external_lex_state = 8},
  [2751] = {.lex_state = 10, .external_lex_state = 8},
  [2752] = {.lex_state = 10, .external_lex_state = 8},
  [2753] = {.lex_state = 10, .external_lex_state = 8},
  [2754] = {.lex_state = 10, .external_lex_state = 8},
  [2755] = {.lex_state = 10, .external_lex_state = 8},
  [2756] = {.lex_state = 10, .external_lex_state = 8},
  [2757] = {.lex_state = 10, .external_lex_state = 8},
  [2758] = {.lex_state = 10, .external_lex_state = 8},
  [2759] = {.lex_state = 10, .external_lex_state = 8},
  [2760] = {.lex_state = 10, .external_lex_state = 8},
  [2761] = {.lex_state = 10, .external_lex_state = 8},
  [2762] = {.lex_state = 10, .external_lex_state = 8},
  [2763] = {.lex_state = 10, .external_lex_state = 8},
  [2764] = {.lex_state = 10, .external_lex_state = 8},
  [2765] = {.lex_state = 10, .external_lex_state = 8},
  [2766] = {.lex_state = 10, .external_lex_state = 8},
  [2767] = {.lex_state = 10, .external_lex_state = 8},
  [2768] = {.lex_state = 10, .external_lex_state = 8},
  [2769] = {.lex_state = 10, .external_lex_state = 8},
  [2770] = {.lex_state = 10, .external_lex_state = 8},
  [2771] = {.lex_state = 10, .external_lex_state = 8},
  [2772] = {.lex_state = 10, .external_lex_state = 8},
  [2773] = {.lex_state = 10, .external_lex_state = 8},
  [2774] = {.lex_state = 10, .external_lex_state = 8},
  [2775] = {.lex_state = 10, .external_lex_state = 8},
  [2776] = {.lex_state = 10, .external_lex_state = 8},
  [2777] = {.lex_state = 10, .external_lex_state = 8},
  [2778] = {.lex_state = 10, .external_lex_state = 8},
  [2779] = {.lex_state = 10, .external_lex_state = 8},
  [2780] = {.lex_state = 10, .external_lex_state = 8},
  [2781] = {.lex_state = 10, .external_lex_state = 8},
  [2782] = {.lex_state = 10, .external_lex_state = 8},
  [2783] = {.lex_state = 10, .external_lex_state = 8},
  [2784] = {.lex_state = 10, .external_lex_state = 8},
  [2785] = {.lex_state = 10, .external_lex_state = 8},
  [2786] = {.lex_state = 10, .external_lex_state = 8},
  [2787] = {.lex_state = 10, .external_lex_state = 8},
  [2788] = {.lex_state = 10, .external_lex_state = 8},
  [2789] = {.lex_state = 10, .external_lex_state = 8},
  [2790] = {.lex_state = 10, .external_lex_state = 8},
  [2791] = {.lex_state = 10, .external_lex_state = 8},
  [2792] = {.lex_state = 9, .external_lex_state = 6},
  [2793] = {.lex_state = 22, .external_lex_state = 6},
  [2794] = {.lex_state = 22, .external_lex_state = 6},
  [2795] = {.lex_state = 22, .external_lex_state = 6},
  [2796] = {.lex_state = 22, .external_lex_state = 6},
  [2797] = {.lex_state = 22, .external_lex_state = 6},
  [2798] = {.lex_state = 22, .external_lex_state = 6},
  [2799] = {.lex_state = 22, .external_lex_state = 6},
  [2800] = {.lex_state = 22, .external_lex_state = 6},
  [2801] = {.lex_state = 22, .external_lex_state = 6},
  [2802] = {.lex_state = 22, .external_lex_state = 6},
  [2803] = {.lex_state = 22, .external_lex_state = 6},
  [2804] = {.lex_state = 22, .external_lex_state = 6},
  [2805] = {.lex_state = 22, .external_lex_state = 6},
  [2806] = {.lex_state = 22, .external_lex_state = 6},
  [2807] = {.lex_state = 22, .external_lex_state = 6},
  [2808] = {.lex_state = 22, .external_lex_state = 6},
  [2809] = {.lex_state = 22, .external_lex_state = 6},
  [2810] = {.lex_state = 13, .external_lex_state = 9},
  [2811] = {.lex_state = 14, .external_lex_state = 6},
  [2812] = {.lex_state = 14, .external_lex_state = 6},
  [2813] = {.lex_state = 21, .external_lex_state = 9},
  [2814] = {.lex_state = 13, .external_lex_state = 9},
  [2815] = {.lex_state = 13, .external_lex_state = 9},
  [2816] = {.lex_state = 13, .external_lex_state = 9},
  [2817] = {.lex_state = 13, .external_lex_state = 9},
  [2818] = {.lex_state = 21, .external_lex_state = 6},
  [2819] = {.lex_state = 13, .external_lex_state = 6},
  [2820] = {.lex_state = 13, .external_lex_state = 9},
  [2821] = {.lex_state = 13, .external_lex_state = 9},
  [2822] = {.lex_state = 13, .external_lex_state = 9},
  [2823] = {.lex_state = 13, .external_lex_state = 9},
  [2824] = {.lex_state = 13, .external_lex_state = 9},
  [2825] = {.lex_state = 13, .external_lex_state = 9},
  [2826] = {.lex_state = 13, .external_lex_state = 9},
  [2827] = {.lex_state = 13, .external_lex_state = 9},
  [2828] = {.lex_state = 13, .external_lex_state = 9},
  [2829] = {.lex_state = 13, .external_lex_state = 9},
  [2830] = {.lex_state = 13, .external_lex_state = 9},
  [2831] = {.lex_state = 13, .external_lex_state = 9},
  [2832] = {.lex_state = 13, .external_lex_state = 9},
  [2833] = {.lex_state = 13, .external_lex_state = 9},
  [2834] = {.lex_state = 13, .external_lex_state = 9},
  [2835] = {.lex_state = 13, .external_lex_state = 9},
  [2836] = {.lex_state = 13, .external_lex_state = 9},
  [2837] = {.lex_state = 13, .external_lex_state = 9},
  [2838] = {.lex_state = 13, .external_lex_state = 9},
  [2839] = {.lex_state = 13, .external_lex_state = 9},
  [2840] = {.lex_state = 13, .external_lex_state = 9},
  [2841] = {.lex_state = 13, .external_lex_state = 9},
  [2842] = {.lex_state = 13, .external_lex_state = 9},
  [2843] = {.lex_state = 13, .external_lex_state = 9},
  [2844] = {.lex_state = 13, .external_lex_state = 9},
  [2845] = {.lex_state = 13, .external_lex_state = 9},
  [2846] = {.lex_state = 13, .external_lex_state = 9},
  [2847] = {.lex_state = 13, .external_lex_state = 9},
  [2848] = {.lex_state = 13, .external_lex_state = 9},
  [2849] = {.lex_state = 13, .external_lex_state = 9},
  [2850] = {.lex_state = 13, .external_lex_state = 9},
  [2851] = {.lex_state = 13, .external_lex_state = 9},
  [2852] = {.lex_state = 13, .external_lex_state = 9},
  [2853] = {.lex_state = 13, .external_lex_state = 9},
  [2854] = {.lex_state = 13, .external_lex_state = 9},
  [2855] = {.lex_state = 13, .external_lex_state = 9},
  [2856] = {.lex_state = 13, .external_lex_state = 9},
  [2857] = {.lex_state = 13, .external_lex_state = 9},
  [2858] = {.lex_state = 13, .external_lex_state = 9},
  [2859] = {.lex_state = 13, .external_lex_state = 9},
  [2860] = {.lex_state = 13, .external_lex_state = 9},
  [2861] = {.lex_state = 14, .external_lex_state = 6},
  [2862] = {.lex_state = 13, .external_lex_state = 9},
  [2863] = {.lex_state = 14, .external_lex_state = 6},
  [2864] = {.lex_state = 13, .external_lex_state = 9},
  [2865] = {.lex_state = 13, .external_lex_state = 9},
  [2866] = {.lex_state = 17, .external_lex_state = 6},
  [2867] = {.lex_state = 13, .external_lex_state = 9},
  [2868] = {.lex_state = 13, .external_lex_state = 9},
  [2869] = {.lex_state = 14, .external_lex_state = 6},
  [2870] = {.lex_state = 13, .external_lex_state = 9},
  [2871] = {.lex_state = 14, .external_lex_state = 6},
  [2872] = {.lex_state = 13, .external_lex_state = 9},
  [2873] = {.lex_state = 13, .external_lex_state = 9},
  [2874] = {.lex_state = 13, .external_lex_state = 9},
  [2875] = {.lex_state = 13, .external_lex_state = 9},
  [2876] = {.lex_state = 13, .external_lex_state = 9},
  [2877] = {.lex_state = 13, .external_lex_state = 9},
  [2878] = {.lex_state = 13, .external_lex_state = 9},
  [2879] = {.lex_state = 13, .external_lex_state = 9},
  [2880] = {.lex_state = 13, .external_lex_state = 9},
  [2881] = {.lex_state = 13, .external_lex_state = 9},
  [2882] = {.lex_state = 13, .external_lex_state = 9},
  [2883] = {.lex_state = 21, .external_lex_state = 8},
  [2884] = {.lex_state = 13, .external_lex_state = 9},
  [2885] = {.lex_state = 13, .external_lex_state = 9},
  [2886] = {.lex_state = 13, .external_lex_state = 9},
  [2887] = {.lex_state = 13, .external_lex_state = 9},
  [2888] = {.lex_state = 13, .external_lex_state = 9},
  [2889] = {.lex_state = 13, .external_lex_state = 9},
  [2890] = {.lex_state = 13, .external_lex_state = 9},
  [2891] = {.lex_state = 19, .external_lex_state = 6},
  [2892] = {.lex_state = 13, .external_lex_state = 9},
  [2893] = {.lex_state = 13, .external_lex_state = 9},
  [2894] = {.lex_state = 14, .external_lex_state = 6},
  [2895] = {.lex_state = 11, .external_lex_state = 9},
  [2896] = {.lex_state = 14, .external_lex_state = 6},
  [2897] = {.lex_state = 11, .external_lex_state = 9},
  [2898] = {.lex_state = 14, .external_lex_state = 6},
  [2899] = {.lex_state = 14, .external_lex_state = 6},
  [2900] = {.lex_state = 14, .external_lex_state = 6},
  [2901] = {.lex_state = 12, .external_lex_state = 9},
  [2902] = {.lex_state = 14, .external_lex_state = 6},
  [2903] = {.lex_state = 11, .external_lex_state = 9},
  [2904] = {.lex_state = 11, .external_lex_state = 9},
  [2905] = {.lex_state = 14, .external_lex_state = 6},
  [2906] = {.lex_state = 14, .external_lex_state = 6},
  [2907] = {.lex_state = 14, .external_lex_state = 6},
  [2908] = {.lex_state = 14, .external_lex_state = 6},
  [2909] = {.lex_state = 14, .external_lex_state = 6},
  [2910] = {.lex_state = 14, .external_lex_state = 6},
  [2911] = {.lex_state = 14, .external_lex_state = 6},
  [2912] = {.lex_state = 14, .external_lex_state = 6},
  [2913] = {.lex_state = 14, .external_lex_state = 6},
  [2914] = {.lex_state = 14, .external_lex_state = 6},
  [2915] = {.lex_state = 14, .external_lex_state = 6},
  [2916] = {.lex_state = 14, .external_lex_state = 6},
  [2917] = {.lex_state = 14, .external_lex_state = 6},
  [2918] = {.lex_state = 14, .external_lex_state = 6},
  [2919] = {.lex_state = 11, .external_lex_state = 9},
  [2920] = {.lex_state = 14, .external_lex_state = 6},
  [2921] = {.lex_state = 21, .external_lex_state = 10},
  [2922] = {.lex_state = 14, .external_lex_state = 6},
  [2923] = {.lex_state = 13, .external_lex_state = 6},
  [2924] = {.lex_state = 11, .external_lex_state = 9},
  [2925] = {.lex_state = 14, .external_lex_state = 6},
  [2926] = {.lex_state = 14, .external_lex_state = 6},
  [2927] = {.lex_state = 14, .external_lex_state = 6},
  [2928] = {.lex_state = 14, .external_lex_state = 6},
  [2929] = {.lex_state = 14, .external_lex_state = 6},
  [2930] = {.lex_state = 14, .external_lex_state = 6},
  [2931] = {.lex_state = 14, .external_lex_state = 6},
  [2932] = {.lex_state = 14, .external_lex_state = 6},
  [2933] = {.lex_state = 12, .external_lex_state = 9},
  [2934] = {.lex_state = 12, .external_lex_state = 9},
  [2935] = {.lex_state = 12, .external_lex_state = 9},
  [2936] = {.lex_state = 12, .external_lex_state = 9},
  [2937] = {.lex_state = 11, .external_lex_state = 9},
  [2938] = {.lex_state = 11, .external_lex_state = 9},
  [2939] = {.lex_state = 14, .external_lex_state = 6},
  [2940] = {.lex_state = 14, .external_lex_state = 6},
  [2941] = {.lex_state = 14, .external_lex_state = 6},
  [2942] = {.lex_state = 14, .external_lex_state = 6},
  [2943] = {.lex_state = 14, .external_lex_state = 6},
  [2944] = {.lex_state = 14, .external_lex_state = 6},
  [2945] = {.lex_state = 14, .external_lex_state = 6},
  [2946] = {.lex_state = 14, .external_lex_state = 6},
  [2947] = {.lex_state = 14, .external_lex_state = 6},
  [2948] = {.lex_state = 14, .external_lex_state = 6},
  [2949] = {.lex_state = 14, .external_lex_state = 6},
  [2950] = {.lex_state = 14, .external_lex_state = 6},
  [2951] = {.lex_state = 14, .external_lex_state = 6},
  [2952] = {.lex_state = 14, .external_lex_state = 6},
  [2953] = {.lex_state = 14, .external_lex_state = 6},
  [2954] = {.lex_state = 13, .external_lex_state = 6},
  [2955] = {.lex_state = 14, .external_lex_state = 6},
  [2956] = {.lex_state = 14, .external_lex_state = 6},
  [2957] = {.lex_state = 14, .external_lex_state = 6},
  [2958] = {.lex_state = 14, .external_lex_state = 6},
  [2959] = {.lex_state = 14, .external_lex_state = 6},
  [2960] = {.lex_state = 11, .external_lex_state = 9},
  [2961] = {.lex_state = 11, .external_lex_state = 9},
  [2962] = {.lex_state = 14, .external_lex_state = 6},
  [2963] = {.lex_state = 14, .external_lex_state = 6},
  [2964] = {.lex_state = 14, .external_lex_state = 6},
  [2965] = {.lex_state = 14, .external_lex_state = 6},
  [2966] = {.lex_state = 14, .external_lex_state = 6},
  [2967] = {.lex_state = 14, .external_lex_state = 6},
  [2968] = {.lex_state = 11, .external_lex_state = 9},
  [2969] = {.lex_state = 14, .external_lex_state = 6},
  [2970] = {.lex_state = 14, .external_lex_state = 6},
  [2971] = {.lex_state = 14, .external_lex_state = 6},
  [2972] = {.lex_state = 21, .external_lex_state = 6},
  [2973] = {.lex_state = 14, .external_lex_state = 6},
  [2974] = {.lex_state = 11, .external_lex_state = 9},
  [2975] = {.lex_state = 13, .external_lex_state = 6},
  [2976] = {.lex_state = 11, .external_lex_state = 9},
  [2977] = {.lex_state = 14, .external_lex_state = 6},
  [2978] = {.lex_state = 14, .external_lex_state = 6},
  [2979] = {.lex_state = 14, .external_lex_state = 6},
  [2980] = {.lex_state = 13, .external_lex_state = 6},
  [2981] = {.lex_state = 14, .external_lex_state = 6},
  [2982] = {.lex_state = 14, .external_lex_state = 6},
  [2983] = {.lex_state = 14, .external_lex_state = 6},
  [2984] = {.lex_state = 14, .external_lex_state = 6},
  [2985] = {.lex_state = 11, .external_lex_state = 9},
  [2986] = {.lex_state = 11, .external_lex_state = 9},
  [2987] = {.lex_state = 11, .external_lex_state = 9},
  [2988] = {.lex_state = 11, .external_lex_state = 9},
  [2989] = {.lex_state = 11, .external_lex_state = 9},
  [2990] = {.lex_state = 11, .external_lex_state = 9},
  [2991] = {.lex_state = 11, .external_lex_state = 9},
  [2992] = {.lex_state = 11, .external_lex_state = 9},
  [2993] = {.lex_state = 11, .external_lex_state = 8},
  [2994] = {.lex_state = 21, .external_lex_state = 6},
  [2995] = {.lex_state = 11, .external_lex_state = 9},
  [2996] = {.lex_state = 11, .external_lex_state = 9},
  [2997] = {.lex_state = 11, .external_lex_state = 9},
  [2998] = {.lex_state = 11, .external_lex_state = 9},
  [2999] = {.lex_state = 11, .external_lex_state = 9},
  [3000] = {.lex_state = 11, .external_lex_state = 9},
  [3001] = {.lex_state = 13, .external_lex_state = 6},
  [3002] = {.lex_state = 11, .external_lex_state = 9},
  [3003] = {.lex_state = 21, .external_lex_state = 6},
  [3004] = {.lex_state = 11, .external_lex_state = 9},
  [3005] = {.lex_state = 13, .external_lex_state = 6},
  [3006] = {.lex_state = 11, .external_lex_state = 9},
  [3007] = {.lex_state = 21, .external_lex_state = 6},
  [3008] = {.lex_state = 11, .external_lex_state = 9},
  [3009] = {.lex_state = 11, .external_lex_state = 9},
  [3010] = {.lex_state = 21, .external_lex_state = 6},
  [3011] = {.lex_state = 19, .external_lex_state = 6},
  [3012] = {.lex_state = 13, .external_lex_state = 6},
  [3013] = {.lex_state = 17, .external_lex_state = 6},
  [3014] = {.lex_state = 11, .external_lex_state = 9},
  [3015] = {.lex_state = 11, .external_lex_state = 9},
  [3016] = {.lex_state = 21, .external_lex_state = 6},
  [3017] = {.lex_state = 11, .external_lex_state = 9},
  [3018] = {.lex_state = 11, .external_lex_state = 8},
  [3019] = {.lex_state = 11, .external_lex_state = 9},
  [3020] = {.lex_state = 11, .external_lex_state = 8},
  [3021] = {.lex_state = 21, .external_lex_state = 6},
  [3022] = {.lex_state = 11, .external_lex_state = 8},
  [3023] = {.lex_state = 17, .external_lex_state = 6},
  [3024] = {.lex_state = 11, .external_lex_state = 9},
  [3025] = {.lex_state = 17, .external_lex_state = 6},
  [3026] = {.lex_state = 11, .external_lex_state = 9},
  [3027] = {.lex_state = 21, .external_lex_state = 6},
  [3028] = {.lex_state = 11, .external_lex_state = 9},
  [3029] = {.lex_state = 13, .external_lex_state = 6},
  [3030] = {.lex_state = 11, .external_lex_state = 9},
  [3031] = {.lex_state = 11, .external_lex_state = 9},
  [3032] = {.lex_state = 21, .external_lex_state = 6},
  [3033] = {.lex_state = 21, .external_lex_state = 6},
  [3034] = {.lex_state = 13, .external_lex_state = 6},
  [3035] = {.lex_state = 21, .external_lex_state = 6},
  [3036] = {.lex_state = 21, .external_lex_state = 6},
  [3037] = {.lex_state = 11, .external_lex_state = 9},
  [3038] = {.lex_state = 11, .external_lex_state = 9},
  [3039] = {.lex_state = 21, .external_lex_state = 6},
  [3040] = {.lex_state = 11, .external_lex_state = 9},
  [3041] = {.lex_state = 11, .external_lex_state = 9},
  [3042] = {.lex_state = 21, .external_lex_state = 6},
  [3043] = {.lex_state = 21, .external_lex_state = 6},
  [3044] = {.lex_state = 11, .external_lex_state = 9},
  [3045] = {.lex_state = 21, .external_lex_state = 6},
  [3046] = {.lex_state = 11, .external_lex_state = 9},
  [3047] = {.lex_state = 13, .external_lex_state = 6},
  [3048] = {.lex_state = 11, .external_lex_state = 9},
  [3049] = {.lex_state = 11, .external_lex_state = 9},
  [3050] = {.lex_state = 19, .external_lex_state = 6},
  [3051] = {.lex_state = 11, .external_lex_state = 9},
  [3052] = {.lex_state = 17, .external_lex_state = 6},
  [3053] = {.lex_state = 11, .external_lex_state = 9},
  [3054] = {.lex_state = 11, .external_lex_state = 9},
  [3055] = {.lex_state = 11, .external_lex_state = 9},
  [3056] = {.lex_state = 11, .external_lex_state = 9},
  [3057] = {.lex_state = 13, .external_lex_state = 6},
  [3058] = {.lex_state = 11, .external_lex_state = 9},
  [3059] = {.lex_state = 11, .external_lex_state = 9},
  [3060] = {.lex_state = 11, .external_lex_state = 9},
  [3061] = {.lex_state = 11, .external_lex_state = 9},
  [3062] = {.lex_state = 13, .external_lex_state = 6},
  [3063] = {.lex_state = 11, .external_lex_state = 9},
  [3064] = {.lex_state = 21, .external_lex_state = 6},
  [3065] = {.lex_state = 11, .external_lex_state = 9},
  [3066] = {.lex_state = 13, .external_lex_state = 6},
  [3067] = {.lex_state = 11, .external_lex_state = 9},
  [3068] = {.lex_state = 11, .external_lex_state = 9},
  [3069] = {.lex_state = 19, .external_lex_state = 6},
  [3070] = {.lex_state = 11, .external_lex_state = 9},
  [3071] = {.lex_state = 19, .external_lex_state = 6},
  [3072] = {.lex_state = 11, .external_lex_state = 9},
  [3073] = {.lex_state = 11, .external_lex_state = 9},
  [3074] = {.lex_state = 11, .external_lex_state = 9},
  [3075] = {.lex_state = 11, .external_lex_state = 9},
  [3076] = {.lex_state = 11, .external_lex_state = 9},
  [3077] = {.lex_state = 11, .external_lex_state = 9},
  [3078] = {.lex_state = 11, .external_lex_state = 9},
  [3079] = {.lex_state = 11, .external_lex_state = 9},
  [3080] = {.lex_state = 21, .external_lex_state = 6},
  [3081] = {.lex_state = 19, .external_lex_state = 6},
  [3082] = {.lex_state = 13, .external_lex_state = 6},
  [3083] = {.lex_state = 13, .external_lex_state = 6},
  [3084] = {.lex_state = 11, .external_lex_state = 8},
  [3085] = {.lex_state = 11, .external_lex_state = 8},
  [3086] = {.lex_state = 13, .external_lex_state = 6},
  [3087] = {.lex_state = 19, .external_lex_state = 6},
  [3088] = {.lex_state = 13, .external_lex_state = 6},
  [3089] = {.lex_state = 13, .external_lex_state = 6},
  [3090] = {.lex_state = 19, .external_lex_state = 6},
  [3091] = {.lex_state = 11, .external_lex_state = 8},
  [3092] = {.lex_state = 13, .external_lex_state = 6},
  [3093] = {.lex_state = 13, .external_lex_state = 6},
  [3094] = {.lex_state = 13, .external_lex_state = 6},
  [3095] = {.lex_state = 13, .external_lex_state = 6},
  [3096] = {.lex_state = 13, .external_lex_state = 6},
  [3097] = {.lex_state = 11, .external_lex_state = 8},
  [3098] = {.lex_state = 13, .external_lex_state = 6},
  [3099] = {.lex_state = 21, .external_lex_state = 6},
  [3100] = {.lex_state = 17, .external_lex_state = 6},
  [3101] = {.lex_state = 17, .external_lex_state = 6},
  [3102] = {.lex_state = 13, .external_lex_state = 6},
  [3103] = {.lex_state = 13, .external_lex_state = 6},
  [3104] = {.lex_state = 13, .external_lex_state = 6},
  [3105] = {.lex_state = 11, .external_lex_state = 8},
  [3106] = {.lex_state = 13, .external_lex_state = 6},
  [3107] = {.lex_state = 13, .external_lex_state = 6},
  [3108] = {.lex_state = 13, .external_lex_state = 6},
  [3109] = {.lex_state = 13, .external_lex_state = 6},
  [3110] = {.lex_state = 13, .external_lex_state = 6},
  [3111] = {.lex_state = 13, .external_lex_state = 6},
  [3112] = {.lex_state = 11, .external_lex_state = 8},
  [3113] = {.lex_state = 13, .external_lex_state = 6},
  [3114] = {.lex_state = 17, .external_lex_state = 6},
  [3115] = {.lex_state = 13, .external_lex_state = 6},
  [3116] = {.lex_state = 13, .external_lex_state = 6},
  [3117] = {.lex_state = 13, .external_lex_state = 6},
  [3118] = {.lex_state = 17, .external_lex_state = 6},
  [3119] = {.lex_state = 13, .external_lex_state = 6},
  [3120] = {.lex_state = 13, .external_lex_state = 6},
  [3121] = {.lex_state = 19, .external_lex_state = 6},
  [3122] = {.lex_state = 19, .external_lex_state = 6},
  [3123] = {.lex_state = 13, .external_lex_state = 6},
  [3124] = {.lex_state = 11, .external_lex_state = 8},
  [3125] = {.lex_state = 13, .external_lex_state = 6},
  [3126] = {.lex_state = 19, .external_lex_state = 6},
  [3127] = {.lex_state = 17, .external_lex_state = 6},
  [3128] = {.lex_state = 17, .external_lex_state = 6},
  [3129] = {.lex_state = 13, .external_lex_state = 6},
  [3130] = {.lex_state = 13, .external_lex_state = 6},
  [3131] = {.lex_state = 17, .external_lex_state = 6},
  [3132] = {.lex_state = 13, .external_lex_state = 6},
  [3133] = {.lex_state = 17, .external_lex_state = 6},
  [3134] = {.lex_state = 13, .external_lex_state = 6},
  [3135] = {.lex_state = 13, .external_lex_state = 6},
  [3136] = {.lex_state = 13, .external_lex_state = 6},
  [3137] = {.lex_state = 13, .external_lex_state = 6},
  [3138] = {.lex_state = 19, .external_lex_state = 6},
  [3139] = {.lex_state = 13, .external_lex_state = 6},
  [3140] = {.lex_state = 11, .external_lex_state = 8},
  [3141] = {.lex_state = 13, .external_lex_state = 6},
  [3142] = {.lex_state = 13, .external_lex_state = 6},
  [3143] = {.lex_state = 13, .external_lex_state = 6},
  [3144] = {.lex_state = 13, .external_lex_state = 6},
  [3145] = {.lex_state = 13, .external_lex_state = 6},
  [3146] = {.lex_state = 13, .external_lex_state = 6},
  [3147] = {.lex_state = 13, .external_lex_state = 6},
  [3148] = {.lex_state = 13, .external_lex_state = 6},
  [3149] = {.lex_state = 13, .external_lex_state = 6},
  [3150] = {.lex_state = 13, .external_lex_state = 6},
  [3151] = {.lex_state = 19, .external_lex_state = 6},
  [3152] = {.lex_state = 19, .external_lex_state = 6},
  [3153] = {.lex_state = 13, .external_lex_state = 6},
  [3154] = {.lex_state = 13, .external_lex_state = 6},
  [3155] = {.lex_state = 13, .external_lex_state = 6},
  [3156] = {.lex_state = 13, .external_lex_state = 6},
  [3157] = {.lex_state = 13, .external_lex_state = 6},
  [3158] = {.lex_state = 17, .external_lex_state = 6},
  [3159] = {.lex_state = 13, .external_lex_state = 6},
  [3160] = {.lex_state = 13, .external_lex_state = 6},
  [3161] = {.lex_state = 13, .external_lex_state = 6},
  [3162] = {.lex_state = 11, .external_lex_state = 8},
  [3163] = {.lex_state = 13, .external_lex_state = 6},
  [3164] = {.lex_state = 13, .external_lex_state = 6},
  [3165] = {.lex_state = 13, .external_lex_state = 6},
  [3166] = {.lex_state = 13, .external_lex_state = 6},
  [3167] = {.lex_state = 11, .external_lex_state = 8},
  [3168] = {.lex_state = 11, .external_lex_state = 8},
  [3169] = {.lex_state = 17, .external_lex_state = 6},
  [3170] = {.lex_state = 19, .external_lex_state = 6},
  [3171] = {.lex_state = 17, .external_lex_state = 6},
  [3172] = {.lex_state = 17, .external_lex_state = 6},
  [3173] = {.lex_state = 17, .external_lex_state = 6},
  [3174] = {.lex_state = 17, .external_lex_state = 6},
  [3175] = {.lex_state = 17, .external_lex_state = 6},
  [3176] = {.lex_state = 11, .external_lex_state = 8},
  [3177] = {.lex_state = 11, .external_lex_state = 8},
  [3178] = {.lex_state = 17, .external_lex_state = 6},
  [3179] = {.lex_state = 19, .external_lex_state = 6},
  [3180] = {.lex_state = 17, .external_lex_state = 6},
  [3181] = {.lex_state = 17, .external_lex_state = 6},
  [3182] = {.lex_state = 17, .external_lex_state = 6},
  [3183] = {.lex_state = 19, .external_lex_state = 6},
  [3184] = {.lex_state = 17, .external_lex_state = 6},
  [3185] = {.lex_state = 17, .external_lex_state = 6},
  [3186] = {.lex_state = 17, .external_lex_state = 6},
  [3187] = {.lex_state = 11, .external_lex_state = 8},
  [3188] = {.lex_state = 11, .external_lex_state = 8},
  [3189] = {.lex_state = 11, .external_lex_state = 8},
  [3190] = {.lex_state = 11, .external_lex_state = 8},
  [3191] = {.lex_state = 19, .external_lex_state = 6},
  [3192] = {.lex_state = 19, .external_lex_state = 6},
  [3193] = {.lex_state = 19, .external_lex_state = 6},
  [3194] = {.lex_state = 11, .external_lex_state = 8},
  [3195] = {.lex_state = 17, .external_lex_state = 6},
  [3196] = {.lex_state = 17, .external_lex_state = 6},
  [3197] = {.lex_state = 17, .external_lex_state = 6},
  [3198] = {.lex_state = 11, .external_lex_state = 8},
  [3199] = {.lex_state = 17, .external_lex_state = 6},
  [3200] = {.lex_state = 17, .external_lex_state = 6},
  [3201] = {.lex_state = 11, .external_lex_state = 8},
  [3202] = {.lex_state = 17, .external_lex_state = 6},
  [3203] = {.lex_state = 17, .external_lex_state = 6},
  [3204] = {.lex_state = 17, .external_lex_state = 6},
  [3205] = {.lex_state = 11, .external_lex_state = 8},
  [3206] = {.lex_state = 11, .external_lex_state = 8},
  [3207] = {.lex_state = 11, .external_lex_state = 8},
  [3208] = {.lex_state = 19, .external_lex_state = 6},
  [3209] = {.lex_state = 11, .external_lex_state = 8},
  [3210] = {.lex_state = 19, .external_lex_state = 6},
  [3211] = {.lex_state = 17, .external_lex_state = 6},
  [3212] = {.lex_state = 11, .external_lex_state = 8},
  [3213] = {.lex_state = 11, .external_lex_state = 8},
  [3214] = {.lex_state = 17, .external_lex_state = 6},
  [3215] = {.lex_state = 17, .external_lex_state = 6},
  [3216] = {.lex_state = 11, .external_lex_state = 8},
  [3217] = {.lex_state = 19, .external_lex_state = 6},
  [3218] = {.lex_state = 17, .external_lex_state = 6},
  [3219] = {.lex_state = 19, .external_lex_state = 6},
  [3220] = {.lex_state = 17, .external_lex_state = 6},
  [3221] = {.lex_state = 19, .external_lex_state = 6},
  [3222] = {.lex_state = 19, .external_lex_state = 6},
  [3223] = {.lex_state = 19, .external_lex_state = 6},
  [3224] = {.lex_state = 19, .external_lex_state = 6},
  [3225] = {.lex_state = 17, .external_lex_state = 6},
  [3226] = {.lex_state = 19, .external_lex_state = 6},
  [3227] = {.lex_state = 19, .external_lex_state = 6},
  [3228] = {.lex_state = 19, .external_lex_state = 6},
  [3229] = {.lex_state = 11, .external_lex_state = 8},
  [3230] = {.lex_state = 11, .external_lex_state = 8},
  [3231] = {.lex_state = 11, .external_lex_state = 8},
  [3232] = {.lex_state = 19, .external_lex_state = 6},
  [3233] = {.lex_state = 17, .external_lex_state = 6},
  [3234] = {.lex_state = 17, .external_lex_state = 6},
  [3235] = {.lex_state = 19, .external_lex_state = 6},
  [3236] = {.lex_state = 17, .external_lex_state = 6},
  [3237] = {.lex_state = 19, .external_lex_state = 6},
  [3238] = {.lex_state = 11, .external_lex_state = 10},
  [3239] = {.lex_state = 11, .external_lex_state = 8},
  [3240] = {.lex_state = 19, .external_lex_state = 6},
  [3241] = {.lex_state = 17, .external_lex_state = 6},
  [3242] = {.lex_state = 17, .external_lex_state = 6},
  [3243] = {.lex_state = 17, .external_lex_state = 6},
  [3244] = {.lex_state = 17, .external_lex_state = 6},
  [3245] = {.lex_state = 17, .external_lex_state = 6},
  [3246] = {.lex_state = 11, .external_lex_state = 8},
  [3247] = {.lex_state = 17, .external_lex_state = 6},
  [3248] = {.lex_state = 11, .external_lex_state = 8},
  [3249] = {.lex_state = 19, .external_lex_state = 6},
  [3250] = {.lex_state = 17, .external_lex_state = 6},
  [3251] = {.lex_state = 19, .external_lex_state = 6},
  [3252] = {.lex_state = 11, .external_lex_state = 8},
  [3253] = {.lex_state = 17, .external_lex_state = 6},
  [3254] = {.lex_state = 11, .external_lex_state = 8},
  [3255] = {.lex_state = 19, .external_lex_state = 6},
  [3256] = {.lex_state = 19, .external_lex_state = 6},
  [3257] = {.lex_state = 11, .external_lex_state = 8},
  [3258] = {.lex_state = 17, .external_lex_state = 6},
  [3259] = {.lex_state = 17, .external_lex_state = 6},
  [3260] = {.lex_state = 11, .external_lex_state = 8},
  [3261] = {.lex_state = 11, .external_lex_state = 8},
  [3262] = {.lex_state = 17, .external_lex_state = 6},
  [3263] = {.lex_state = 17, .external_lex_state = 6},
  [3264] = {.lex_state = 17, .external_lex_state = 6},
  [3265] = {.lex_state = 19, .external_lex_state = 6},
  [3266] = {.lex_state = 11, .external_lex_state = 8},
  [3267] = {.lex_state = 11, .external_lex_state = 8},
  [3268] = {.lex_state = 11, .external_lex_state = 10},
  [3269] = {.lex_state = 17, .external_lex_state = 6},
  [3270] = {.lex_state = 19, .external_lex_state = 6},
  [3271] = {.lex_state = 11, .external_lex_state = 8},
  [3272] = {.lex_state = 19, .external_lex_state = 6},
  [3273] = {.lex_state = 11, .external_lex_state = 8},
  [3274] = {.lex_state = 11, .external_lex_state = 8},
  [3275] = {.lex_state = 19, .external_lex_state = 6},
  [3276] = {.lex_state = 19, .external_lex_state = 6},
  [3277] = {.lex_state = 11, .external_lex_state = 8},
  [3278] = {.lex_state = 17, .external_lex_state = 6},
  [3279] = {.lex_state = 11, .external_lex_state = 8},
  [3280] = {.lex_state = 19, .external_lex_state = 6},
  [3281] = {.lex_state = 19, .external_lex_state = 6},
  [3282] = {.lex_state = 19, .external_lex_state = 6},
  [3283] = {.lex_state = 17, .external_lex_state = 6},
  [3284] = {.lex_state = 19, .external_lex_state = 6},
  [3285] = {.lex_state = 11, .external_lex_state = 8},
  [3286] = {.lex_state = 19, .external_lex_state = 6},
  [3287] = {.lex_state = 19, .external_lex_state = 6},
  [3288] = {.lex_state = 19, .external_lex_state = 6},
  [3289] = {.lex_state = 11, .external_lex_state = 8},
  [3290] = {.lex_state = 17, .external_lex_state = 6},
  [3291] = {.lex_state = 19, .external_lex_state = 6},
  [3292] = {.lex_state = 17, .external_lex_state = 6},
  [3293] = {.lex_state = 17, .external_lex_state = 6},
  [3294] = {.lex_state = 11, .external_lex_state = 8},
  [3295] = {.lex_state = 17, .external_lex_state = 6},
  [3296] = {.lex_state = 11, .external_lex_state = 8},
  [3297] = {.lex_state = 17, .external_lex_state = 6},
  [3298] = {.lex_state = 17, .external_lex_state = 6},
  [3299] = {.lex_state = 11, .external_lex_state = 8},
  [3300] = {.lex_state = 19, .external_lex_state = 6},
  [3301] = {.lex_state = 19, .external_lex_state = 6},
  [3302] = {.lex_state = 19, .external_lex_state = 6},
  [3303] = {.lex_state = 11, .external_lex_state = 8},
  [3304] = {.lex_state = 11, .external_lex_state = 8},
  [3305] = {.lex_state = 19, .external_lex_state = 6},
  [3306] = {.lex_state = 11, .external_lex_state = 8},
  [3307] = {.lex_state = 17, .external_lex_state = 6},
  [3308] = {.lex_state = 11, .external_lex_state = 8},
  [3309] = {.lex_state = 17, .external_lex_state = 6},
  [3310] = {.lex_state = 17, .external_lex_state = 6},
  [3311] = {.lex_state = 11, .external_lex_state = 8},
  [3312] = {.lex_state = 11, .external_lex_state = 8},
  [3313] = {.lex_state = 11, .external_lex_state = 8},
  [3314] = {.lex_state = 19, .external_lex_state = 6},
  [3315] = {.lex_state = 11, .external_lex_state = 8},
  [3316] = {.lex_state = 11, .external_lex_state = 8},
  [3317] = {.lex_state = 19, .external_lex_state = 6},
  [3318] = {.lex_state = 19, .external_lex_state = 6},
  [3319] = {.lex_state = 19, .external_lex_state = 6},
  [3320] = {.lex_state = 11, .external_lex_state = 8},
  [3321] = {.lex_state = 11, .external_lex_state = 8},
  [3322] = {.lex_state = 19, .external_lex_state = 6},
  [3323] = {.lex_state = 19, .external_lex_state = 6},
  [3324] = {.lex_state = 11, .external_lex_state = 8},
  [3325] = {.lex_state = 19, .external_lex_state = 6},
  [3326] = {.lex_state = 19, .external_lex_state = 6},
  [3327] = {.lex_state = 19, .external_lex_state = 6},
  [3328] = {.lex_state = 11, .external_lex_state = 8},
  [3329] = {.lex_state = 19, .external_lex_state = 6},
  [3330] = {.lex_state = 19, .external_lex_state = 6},
  [3331] = {.lex_state = 19, .external_lex_state = 6},
  [3332] = {.lex_state = 19, .external_lex_state = 6},
  [3333] = {.lex_state = 19, .external_lex_state = 6},
  [3334] = {.lex_state = 11, .external_lex_state = 10},
  [3335] = {.lex_state = 11, .external_lex_state = 8},
  [3336] = {.lex_state = 11, .external_lex_state = 8},
  [3337] = {.lex_state = 19, .external_lex_state = 6},
  [3338] = {.lex_state = 11, .external_lex_state = 8},
  [3339] = {.lex_state = 17, .external_lex_state = 6},
  [3340] = {.lex_state = 19, .external_lex_state = 6},
  [3341] = {.lex_state = 11, .external_lex_state = 8},
  [3342] = {.lex_state = 17, .external_lex_state = 6},
  [3343] = {.lex_state = 17, .external_lex_state = 6},
  [3344] = {.lex_state = 11, .external_lex_state = 10},
  [3345] = {.lex_state = 11, .external_lex_state = 10},
  [3346] = {.lex_state = 11, .external_lex_state = 10},
  [3347] = {.lex_state = 11, .external_lex_state = 10},
  [3348] = {.lex_state = 11, .external_lex_state = 10},
  [3349] = {.lex_state = 11, .external_lex_state = 10},
  [3350] = {.lex_state = 11, .external_lex_state = 10},
  [3351] = {.lex_state = 11, .external_lex_state = 10},
  [3352] = {.lex_state = 11, .external_lex_state = 10},
  [3353] = {.lex_state = 11, .external_lex_state = 10},
  [3354] = {.lex_state = 11, .external_lex_state = 10},
  [3355] = {.lex_state = 11, .external_lex_state = 10},
  [3356] = {.lex_state = 11, .external_lex_state = 10},
  [3357] = {.lex_state = 11, .external_lex_state = 10},
  [3358] = {.lex_state = 11, .external_lex_state = 10},
  [3359] = {.lex_state = 11, .external_lex_state = 10},
  [3360] = {.lex_state = 11, .external_lex_state = 10},
  [3361] = {.lex_state = 11, .external_lex_state = 10},
  [3362] = {.lex_state = 11, .external_lex_state = 10},
  [3363] = {.lex_state = 11, .external_lex_state = 10},
  [3364] = {.lex_state = 11, .external_lex_state = 10},
  [3365] = {.lex_state = 11, .external_lex_state = 10},
  [3366] = {.lex_state = 11, .external_lex_state = 10},
  [3367] = {.lex_state = 11, .external_lex_state = 10},
  [3368] = {.lex_state = 11, .external_lex_state = 10},
  [3369] = {.lex_state = 11, .external_lex_state = 10},
  [3370] = {.lex_state = 11, .external_lex_state = 10},
  [3371] = {.lex_state = 11, .external_lex_state = 10},
  [3372] = {.lex_state = 11, .external_lex_state = 10},
  [3373] = {.lex_state = 11, .external_lex_state = 10},
  [3374] = {.lex_state = 11, .external_lex_state = 10},
  [3375] = {.lex_state = 11, .external_lex_state = 10},
  [3376] = {.lex_state = 11, .external_lex_state = 10},
  [3377] = {.lex_state = 11, .external_lex_state = 10},
  [3378] = {.lex_state = 11, .external_lex_state = 10},
  [3379] = {.lex_state = 11, .external_lex_state = 10},
  [3380] = {.lex_state = 11, .external_lex_state = 10},
  [3381] = {.lex_state = 11, .external_lex_state = 10},
  [3382] = {.lex_state = 11, .external_lex_state = 10},
  [3383] = {.lex_state = 11, .external_lex_state = 10},
  [3384] = {.lex_state = 11, .external_lex_state = 10},
  [3385] = {.lex_state = 11, .external_lex_state = 10},
  [3386] = {.lex_state = 11, .external_lex_state = 10},
  [3387] = {.lex_state = 11, .external_lex_state = 10},
  [3388] = {.lex_state = 11, .external_lex_state = 10},
  [3389] = {.lex_state = 11, .external_lex_state = 10},
  [3390] = {.lex_state = 11, .external_lex_state = 10},
  [3391] = {.lex_state = 11, .external_lex_state = 10},
  [3392] = {.lex_state = 11, .external_lex_state = 10},
  [3393] = {.lex_state = 11, .external_lex_state = 10},
  [3394] = {.lex_state = 11, .external_lex_state = 10},
  [3395] = {.lex_state = 11, .external_lex_state = 10},
  [3396] = {.lex_state = 11, .external_lex_state = 10},
  [3397] = {.lex_state = 11, .external_lex_state = 10},
  [3398] = {.lex_state = 11, .external_lex_state = 10},
  [3399] = {.lex_state = 11, .external_lex_state = 10},
  [3400] = {.lex_state = 11, .external_lex_state = 10},
  [3401] = {.lex_state = 11, .external_lex_state = 10},
  [3402] = {.lex_state = 11, .external_lex_state = 10},
  [3403] = {.lex_state = 11, .external_lex_state = 10},
  [3404] = {.lex_state = 11, .external_lex_state = 10},
  [3405] = {.lex_state = 11, .external_lex_state = 10},
  [3406] = {.lex_state = 11, .external_lex_state = 10},
  [3407] = {.lex_state = 11, .external_lex_state = 10},
  [3408] = {.lex_state = 11, .external_lex_state = 10},
  [3409] = {.lex_state = 11, .external_lex_state = 10},
  [3410] = {.lex_state = 11, .external_lex_state = 10},
  [3411] = {.lex_state = 11, .external_lex_state = 10},
  [3412] = {.lex_state = 226},
  [3413] = {.lex_state = 226},
  [3414] = {.lex_state = 226},
  [3415] = {.lex_state = 226},
  [3416] = {.lex_state = 226},
  [3417] = {.lex_state = 226},
  [3418] = {.lex_state = 226},
  [3419] = {.lex_state = 226},
  [3420] = {.lex_state = 226},
  [3421] = {.lex_state = 226},
  [3422] = {.lex_state = 226},
  [3423] = {.lex_state = 226},
  [3424] = {.lex_state = 226},
  [3425] = {.lex_state = 231},
  [3426] = {.lex_state = 231},
  [3427] = {.lex_state = 226},
  [3428] = {.lex_state = 226},
  [3429] = {.lex_state = 226},
  [3430] = {.lex_state = 226},
  [3431] = {.lex_state = 226},
  [3432] = {.lex_state = 226},
  [3433] = {.lex_state = 226},
  [3434] = {.lex_state = 226},
  [3435] = {.lex_state = 226},
  [3436] = {.lex_state = 226},
  [3437] = {.lex_state = 226},
  [3438] = {.lex_state = 226},
  [3439] = {.lex_state = 226},
  [3440] = {.lex_state = 226},
  [3441] = {.lex_state = 226},
  [3442] = {.lex_state = 226},
  [3443] = {.lex_state = 226},
  [3444] = {.lex_state = 226},
  [3445] = {.lex_state = 226},
  [3446] = {.lex_state = 226},
  [3447] = {.lex_state = 226},
  [3448] = {.lex_state = 226},
  [3449] = {.lex_state = 226},
  [3450] = {.lex_state = 226},
  [3451] = {.lex_state = 226},
  [3452] = {.lex_state = 226},
  [3453] = {.lex_state = 226},
  [3454] = {.lex_state = 226},
  [3455] = {.lex_state = 226},
  [3456] = {.lex_state = 226},
  [3457] = {.lex_state = 226},
  [3458] = {.lex_state = 226},
  [3459] = {.lex_state = 226},
  [3460] = {.lex_state = 226},
  [3461] = {.lex_state = 226},
  [3462] = {.lex_state = 226},
  [3463] = {.lex_state = 226},
  [3464] = {.lex_state = 226},
  [3465] = {.lex_state = 226},
  [3466] = {.lex_state = 226},
  [3467] = {.lex_state = 226},
  [3468] = {.lex_state = 226},
  [3469] = {.lex_state = 226},
  [3470] = {.lex_state = 226},
  [3471] = {.lex_state = 226},
  [3472] = {.lex_state = 226},
  [3473] = {.lex_state = 226},
  [3474] = {.lex_state = 226},
  [3475] = {.lex_state = 226},
  [3476] = {.lex_state = 226},
  [3477] = {.lex_state = 226},
  [3478] = {.lex_state = 226},
  [3479] = {.lex_state = 226},
  [3480] = {.lex_state = 226},
  [3481] = {.lex_state = 226},
  [3482] = {.lex_state = 226},
  [3483] = {.lex_state = 226},
  [3484] = {.lex_state = 226},
  [3485] = {.lex_state = 226},
  [3486] = {.lex_state = 226},
  [3487] = {.lex_state = 226},
  [3488] = {.lex_state = 226},
  [3489] = {.lex_state = 226},
  [3490] = {.lex_state = 226},
  [3491] = {.lex_state = 226},
  [3492] = {.lex_state = 226},
  [3493] = {.lex_state = 226},
  [3494] = {.lex_state = 226, .external_lex_state = 11},
  [3495] = {.lex_state = 226, .external_lex_state = 11},
  [3496] = {.lex_state = 226},
  [3497] = {.lex_state = 226, .external_lex_state = 11},
  [3498] = {.lex_state = 226, .external_lex_state = 11},
  [3499] = {.lex_state = 226, .external_lex_state = 11},
  [3500] = {.lex_state = 226, .external_lex_state = 11},
  [3501] = {.lex_state = 226},
  [3502] = {.lex_state = 226},
  [3503] = {.lex_state = 226},
  [3504] = {.lex_state = 226},
  [3505] = {.lex_state = 226},
  [3506] = {.lex_state = 226},
  [3507] = {.lex_state = 226},
  [3508] = {.lex_state = 226},
  [3509] = {.lex_state = 226},
  [3510] = {.lex_state = 226},
  [3511] = {.lex_state = 226},
  [3512] = {.lex_state = 226},
  [3513] = {.lex_state = 226},
  [3514] = {.lex_state = 226},
  [3515] = {.lex_state = 226},
  [3516] = {.lex_state = 231},
  [3517] = {.lex_state = 226},
  [3518] = {.lex_state = 23},
  [3519] = {.lex_state = 226},
  [3520] = {.lex_state = 226},
  [3521] = {.lex_state = 226},
  [3522] = {.lex_state = 226},
  [3523] = {.lex_state = 226},
  [3524] = {.lex_state = 226},
  [3525] = {.lex_state = 226},
  [3526] = {.lex_state = 226},
  [3527] = {.lex_state = 226},
  [3528] = {.lex_state = 226},
  [3529] = {.lex_state = 226},
  [3530] = {.lex_state = 226},
  [3531] = {.lex_state = 226},
  [3532] = {.lex_state = 226},
  [3533] = {.lex_state = 226},
  [3534] = {.lex_state = 226},
  [3535] = {.lex_state = 226},
  [3536] = {.lex_state = 226},
  [3537] = {.lex_state = 226},
  [3538] = {.lex_state = 226},
  [3539] = {.lex_state = 226},
  [3540] = {.lex_state = 226},
  [3541] = {.lex_state = 226},
  [3542] = {.lex_state = 226},
  [3543] = {.lex_state = 226},
  [3544] = {.lex_state = 226},
  [3545] = {.lex_state = 226},
  [3546] = {.lex_state = 226},
  [3547] = {.lex_state = 226},
  [3548] = {.lex_state = 226},
  [3549] = {.lex_state = 226},
  [3550] = {.lex_state = 226},
  [3551] = {.lex_state = 226},
  [3552] = {.lex_state = 226},
  [3553] = {.lex_state = 226},
  [3554] = {.lex_state = 226},
  [3555] = {.lex_state = 226},
  [3556] = {.lex_state = 226},
  [3557] = {.lex_state = 226},
  [3558] = {.lex_state = 226},
  [3559] = {.lex_state = 226},
  [3560] = {.lex_state = 226},
  [3561] = {.lex_state = 226},
  [3562] = {.lex_state = 226},
  [3563] = {.lex_state = 226},
  [3564] = {.lex_state = 226},
  [3565] = {.lex_state = 226},
  [3566] = {.lex_state = 226},
  [3567] = {.lex_state = 226},
  [3568] = {.lex_state = 226},
  [3569] = {.lex_state = 226, .external_lex_state = 12},
  [3570] = {.lex_state = 226},
  [3571] = {.lex_state = 226},
  [3572] = {.lex_state = 226},
  [3573] = {.lex_state = 226},
  [3574] = {.lex_state = 226},
  [3575] = {.lex_state = 226},
  [3576] = {.lex_state = 226},
  [3577] = {.lex_state = 226},
  [3578] = {.lex_state = 226},
  [3579] = {.lex_state = 226},
  [3580] = {.lex_state = 226, .external_lex_state = 12},
  [3581] = {.lex_state = 226},
  [3582] = {.lex_state = 226},
  [3583] = {.lex_state = 226},
  [3584] = {.lex_state = 226},
  [3585] = {.lex_state = 226},
  [3586] = {.lex_state = 226},
  [3587] = {.lex_state = 226},
  [3588] = {.lex_state = 226},
  [3589] = {.lex_state = 226},
  [3590] = {.lex_state = 226},
  [3591] = {.lex_state = 226, .external_lex_state = 12},
  [3592] = {.lex_state = 226},
  [3593] = {.lex_state = 226},
  [3594] = {.lex_state = 226},
  [3595] = {.lex_state = 226, .external_lex_state = 12},
  [3596] = {.lex_state = 226, .external_lex_state = 12},
  [3597] = {.lex_state = 226},
  [3598] = {.lex_state = 226},
  [3599] = {.lex_state = 226},
  [3600] = {.lex_state = 226},
  [3601] = {.lex_state = 226},
  [3602] = {.lex_state = 226},
  [3603] = {.lex_state = 226},
  [3604] = {.lex_state = 226},
  [3605] = {.lex_state = 226},
  [3606] = {.lex_state = 226},
  [3607] = {.lex_state = 226},
  [3608] = {.lex_state = 226},
  [3609] = {.lex_state = 226},
  [3610] = {.lex_state = 226},
  [3611] = {.lex_state = 226},
  [3612] = {.lex_state = 226},
  [3613] = {.lex_state = 226},
  [3614] = {.lex_state = 226},
  [3615] = {.lex_state = 226},
  [3616] = {.lex_state = 226},
  [3617] = {.lex_state = 226},
  [3618] = {.lex_state = 226},
  [3619] = {.lex_state = 226},
  [3620] = {.lex_state = 226},
  [3621] = {.lex_state = 226},
  [3622] = {.lex_state = 226},
  [3623] = {.lex_state = 226},
  [3624] = {.lex_state = 226},
  [3625] = {.lex_state = 226},
  [3626] = {.lex_state = 226},
  [3627] = {.lex_state = 226},
  [3628] = {.lex_state = 226},
  [3629] = {.lex_state = 226},
  [3630] = {.lex_state = 226},
  [3631] = {.lex_state = 226},
  [3632] = {.lex_state = 226},
  [3633] = {.lex_state = 226},
  [3634] = {.lex_state = 226},
  [3635] = {.lex_state = 226},
  [3636] = {.lex_state = 226},
  [3637] = {.lex_state = 226},
  [3638] = {.lex_state = 226, .external_lex_state = 13},
  [3639] = {.lex_state = 226, .external_lex_state = 13},
  [3640] = {.lex_state = 226, .external_lex_state = 13},
  [3641] = {.lex_state = 226},
  [3642] = {.lex_state = 226},
  [3643] = {.lex_state = 226},
  [3644] = {.lex_state = 226},
  [3645] = {.lex_state = 226},
  [3646] = {.lex_state = 226},
  [3647] = {.lex_state = 226},
  [3648] = {.lex_state = 226},
  [3649] = {.lex_state = 226},
  [3650] = {.lex_state = 226},
  [3651] = {.lex_state = 226},
  [3652] = {.lex_state = 226},
  [3653] = {.lex_state = 226},
  [3654] = {.lex_state = 226},
  [3655] = {.lex_state = 226},
  [3656] = {.lex_state = 226},
  [3657] = {.lex_state = 226},
  [3658] = {.lex_state = 226},
  [3659] = {.lex_state = 226},
  [3660] = {.lex_state = 226},
  [3661] = {.lex_state = 226},
  [3662] = {.lex_state = 231},
  [3663] = {.lex_state = 226},
  [3664] = {.lex_state = 226},
  [3665] = {.lex_state = 226},
  [3666] = {.lex_state = 226},
  [3667] = {.lex_state = 226},
  [3668] = {.lex_state = 226},
  [3669] = {.lex_state = 231},
  [3670] = {.lex_state = 226},
  [3671] = {.lex_state = 226},
  [3672] = {.lex_state = 226},
  [3673] = {.lex_state = 226},
  [3674] = {.lex_state = 226},
  [3675] = {.lex_state = 226},
  [3676] = {.lex_state = 226},
  [3677] = {.lex_state = 226},
  [3678] = {.lex_state = 226},
  [3679] = {.lex_state = 226},
  [3680] = {.lex_state = 226},
  [3681] = {.lex_state = 226},
  [3682] = {.lex_state = 226},
  [3683] = {.lex_state = 226},
  [3684] = {.lex_state = 226},
  [3685] = {.lex_state = 226},
  [3686] = {.lex_state = 226},
  [3687] = {.lex_state = 226},
  [3688] = {.lex_state = 226},
  [3689] = {.lex_state = 226},
  [3690] = {.lex_state = 226},
  [3691] = {.lex_state = 226},
  [3692] = {.lex_state = 226},
  [3693] = {.lex_state = 226},
  [3694] = {.lex_state = 226},
  [3695] = {.lex_state = 226},
  [3696] = {.lex_state = 226},
  [3697] = {.lex_state = 226},
  [3698] = {.lex_state = 226},
  [3699] = {.lex_state = 226},
  [3700] = {.lex_state = 226},
  [3701] = {.lex_state = 226},
  [3702] = {.lex_state = 226},
  [3703] = {.lex_state = 226},
  [3704] = {.lex_state = 226},
  [3705] = {.lex_state = 226},
  [3706] = {.lex_state = 226},
  [3707] = {.lex_state = 226},
  [3708] = {.lex_state = 226},
  [3709] = {.lex_state = 226},
  [3710] = {.lex_state = 226},
  [3711] = {.lex_state = 226},
  [3712] = {.lex_state = 226},
  [3713] = {.lex_state = 226},
  [3714] = {.lex_state = 226},
  [3715] = {.lex_state = 226},
  [3716] = {.lex_state = 226, .external_lex_state = 13},
  [3717] = {.lex_state = 226},
  [3718] = {.lex_state = 226},
  [3719] = {.lex_state = 226},
  [3720] = {.lex_state = 226},
  [3721] = {.lex_state = 226},
  [3722] = {.lex_state = 226},
  [3723] = {.lex_state = 226},
  [3724] = {.lex_state = 226},
  [3725] = {.lex_state = 226},
  [3726] = {.lex_state = 226},
  [3727] = {.lex_state = 226},
  [3728] = {.lex_state = 226},
  [3729] = {.lex_state = 226},
  [3730] = {.lex_state = 231, .external_lex_state = 13},
  [3731] = {.lex_state = 226},
  [3732] = {.lex_state = 226},
  [3733] = {.lex_state = 226},
  [3734] = {.lex_state = 226},
  [3735] = {.lex_state = 226},
  [3736] = {.lex_state = 226},
  [3737] = {.lex_state = 226},
  [3738] = {.lex_state = 226},
  [3739] = {.lex_state = 226},
  [3740] = {.lex_state = 226},
  [3741] = {.lex_state = 226},
  [3742] = {.lex_state = 226},
  [3743] = {.lex_state = 226},
  [3744] = {.lex_state = 226},
  [3745] = {.lex_state = 226},
  [3746] = {.lex_state = 226, .external_lex_state = 13},
  [3747] = {.lex_state = 226, .external_lex_state = 13},
  [3748] = {.lex_state = 226, .external_lex_state = 13},
  [3749] = {.lex_state = 226},
  [3750] = {.lex_state = 226, .external_lex_state = 13},
  [3751] = {.lex_state = 226, .external_lex_state = 13},
  [3752] = {.lex_state = 226, .external_lex_state = 13},
  [3753] = {.lex_state = 226, .external_lex_state = 13},
  [3754] = {.lex_state = 226, .external_lex_state = 13},
  [3755] = {.lex_state = 226},
  [3756] = {.lex_state = 226, .external_lex_state = 13},
  [3757] = {.lex_state = 226, .external_lex_state = 13},
  [3758] = {.lex_state = 226},
  [3759] = {.lex_state = 226},
  [3760] = {.lex_state = 226, .external_lex_state = 13},
  [3761] = {.lex_state = 226, .external_lex_state = 13},
  [3762] = {.lex_state = 226, .external_lex_state = 13},
  [3763] = {.lex_state = 226, .external_lex_state = 13},
  [3764] = {.lex_state = 226, .external_lex_state = 13},
  [3765] = {.lex_state = 226},
  [3766] = {.lex_state = 226, .external_lex_state = 13},
  [3767] = {.lex_state = 226, .external_lex_state = 13},
  [3768] = {.lex_state = 226, .external_lex_state = 13},
  [3769] = {.lex_state = 226, .external_lex_state = 13},
  [3770] = {.lex_state = 226, .external_lex_state = 13},
  [3771] = {.lex_state = 226, .external_lex_state = 13},
  [3772] = {.lex_state = 226, .external_lex_state = 13},
  [3773] = {.lex_state = 226, .external_lex_state = 13},
  [3774] = {.lex_state = 226, .external_lex_state = 13},
  [3775] = {.lex_state = 226},
  [3776] = {.lex_state = 226, .external_lex_state = 13},
  [3777] = {.lex_state = 226, .external_lex_state = 13},
  [3778] = {.lex_state = 226, .external_lex_state = 13},
  [3779] = {.lex_state = 226, .external_lex_state = 13},
  [3780] = {.lex_state = 226, .external_lex_state = 13},
  [3781] = {.lex_state = 226, .external_lex_state = 13},
  [3782] = {.lex_state = 226, .external_lex_state = 13},
  [3783] = {.lex_state = 226, .external_lex_state = 13},
  [3784] = {.lex_state = 226, .external_lex_state = 13},
  [3785] = {.lex_state = 226, .external_lex_state = 13},
  [3786] = {.lex_state = 226, .external_lex_state = 13},
  [3787] = {.lex_state = 226, .external_lex_state = 13},
  [3788] = {.lex_state = 226, .external_lex_state = 13},
  [3789] = {.lex_state = 226, .external_lex_state = 13},
  [3790] = {.lex_state = 226, .external_lex_state = 13},
  [3791] = {.lex_state = 226, .external_lex_state = 13},
  [3792] = {.lex_state = 226, .external_lex_state = 13},
  [3793] = {.lex_state = 226, .external_lex_state = 13},
  [3794] = {.lex_state = 226, .external_lex_state = 13},
  [3795] = {.lex_state = 226, .external_lex_state = 13},
  [3796] = {.lex_state = 226, .external_lex_state = 13},
  [3797] = {.lex_state = 226, .external_lex_state = 13},
  [3798] = {.lex_state = 226, .external_lex_state = 13},
  [3799] = {.lex_state = 226, .external_lex_state = 13},
  [3800] = {.lex_state = 226},
  [3801] = {.lex_state = 226, .external_lex_state = 13},
  [3802] = {.lex_state = 226, .external_lex_state = 13},
  [3803] = {.lex_state = 226, .external_lex_state = 13},
  [3804] = {.lex_state = 226, .external_lex_state = 13},
  [3805] = {.lex_state = 226},
  [3806] = {.lex_state = 226, .external_lex_state = 13},
  [3807] = {.lex_state = 226, .external_lex_state = 13},
  [3808] = {.lex_state = 226, .external_lex_state = 13},
  [3809] = {.lex_state = 226, .external_lex_state = 13},
  [3810] = {.lex_state = 226},
  [3811] = {.lex_state = 226, .external_lex_state = 13},
  [3812] = {.lex_state = 226, .external_lex_state = 13},
  [3813] = {.lex_state = 226, .external_lex_state = 13},
  [3814] = {.lex_state = 226, .external_lex_state = 13},
  [3815] = {.lex_state = 226, .external_lex_state = 13},
  [3816] = {.lex_state = 226, .external_lex_state = 13},
  [3817] = {.lex_state = 226, .external_lex_state = 13},
  [3818] = {.lex_state = 226, .external_lex_state = 13},
  [3819] = {.lex_state = 226, .external_lex_state = 13},
  [3820] = {.lex_state = 226, .external_lex_state = 13},
  [3821] = {.lex_state = 226, .external_lex_state = 13},
  [3822] = {.lex_state = 226, .external_lex_state = 13},
  [3823] = {.lex_state = 226, .external_lex_state = 13},
  [3824] = {.lex_state = 226, .external_lex_state = 13},
  [3825] = {.lex_state = 226},
  [3826] = {.lex_state = 226},
  [3827] = {.lex_state = 226},
  [3828] = {.lex_state = 226},
  [3829] = {.lex_state = 226},
  [3830] = {.lex_state = 226},
  [3831] = {.lex_state = 226},
  [3832] = {.lex_state = 226},
  [3833] = {.lex_state = 226},
  [3834] = {.lex_state = 226},
  [3835] = {.lex_state = 226},
  [3836] = {.lex_state = 226},
  [3837] = {.lex_state = 226},
  [3838] = {.lex_state = 226},
  [3839] = {.lex_state = 226, .external_lex_state = 13},
  [3840] = {.lex_state = 226, .external_lex_state = 13},
  [3841] = {.lex_state = 226, .external_lex_state = 13},
  [3842] = {.lex_state = 226, .external_lex_state = 13},
  [3843] = {.lex_state = 226, .external_lex_state = 13},
  [3844] = {.lex_state = 226, .external_lex_state = 13},
  [3845] = {.lex_state = 226, .external_lex_state = 13},
  [3846] = {.lex_state = 226},
  [3847] = {.lex_state = 226},
  [3848] = {.lex_state = 226, .external_lex_state = 13},
  [3849] = {.lex_state = 226},
  [3850] = {.lex_state = 226},
  [3851] = {.lex_state = 226, .external_lex_state = 13},
  [3852] = {.lex_state = 226},
  [3853] = {.lex_state = 226},
  [3854] = {.lex_state = 226},
  [3855] = {.lex_state = 226},
  [3856] = {.lex_state = 226, .external_lex_state = 13},
  [3857] = {.lex_state = 226},
  [3858] = {.lex_state = 226},
  [3859] = {.lex_state = 226},
  [3860] = {.lex_state = 226},
  [3861] = {.lex_state = 226},
  [3862] = {.lex_state = 226, .external_lex_state = 13},
  [3863] = {.lex_state = 226},
  [3864] = {.lex_state = 226},
  [3865] = {.lex_state = 226},
  [3866] = {.lex_state = 226},
  [3867] = {.lex_state = 226},
  [3868] = {.lex_state = 226, .external_lex_state = 13},
  [3869] = {.lex_state = 226, .external_lex_state = 13},
  [3870] = {.lex_state = 226},
  [3871] = {.lex_state = 226},
  [3872] = {.lex_state = 226},
  [3873] = {.lex_state = 226},
  [3874] = {.lex_state = 226},
  [3875] = {.lex_state = 226},
  [3876] = {.lex_state = 226},
  [3877] = {.lex_state = 226},
  [3878] = {.lex_state = 226},
  [3879] = {.lex_state = 226},
  [3880] = {.lex_state = 226},
  [3881] = {.lex_state = 226},
  [3882] = {.lex_state = 226},
  [3883] = {.lex_state = 226},
  [3884] = {.lex_state = 226},
  [3885] = {.lex_state = 226},
  [3886] = {.lex_state = 226},
  [3887] = {.lex_state = 25},
  [3888] = {.lex_state = 26},
  [3889] = {.lex_state = 26},
  [3890] = {.lex_state = 26},
  [3891] = {.lex_state = 226},
  [3892] = {.lex_state = 226},
  [3893] = {.lex_state = 226},
  [3894] = {.lex_state = 226},
  [3895] = {.lex_state = 226},
  [3896] = {.lex_state = 226},
  [3897] = {.lex_state = 226},
  [3898] = {.lex_state = 226},
  [3899] = {.lex_state = 226},
  [3900] = {.lex_state = 226},
  [3901] = {.lex_state = 226},
  [3902] = {.lex_state = 226},
  [3903] = {.lex_state = 226},
  [3904] = {.lex_state = 226},
  [3905] = {.lex_state = 226},
  [3906] = {.lex_state = 226},
  [3907] = {.lex_state = 226},
  [3908] = {.lex_state = 226},
  [3909] = {.lex_state = 226},
  [3910] = {.lex_state = 226},
  [3911] = {.lex_state = 226},
  [3912] = {.lex_state = 226},
  [3913] = {.lex_state = 25},
  [3914] = {.lex_state = 226},
  [3915] = {.lex_state = 226},
  [3916] = {.lex_state = 226},
  [3917] = {.lex_state = 226},
  [3918] = {.lex_state = 226},
  [3919] = {.lex_state = 226},
  [3920] = {.lex_state = 226},
  [3921] = {.lex_state = 226},
  [3922] = {.lex_state = 226},
  [3923] = {.lex_state = 226},
  [3924] = {.lex_state = 226},
  [3925] = {.lex_state = 226},
  [3926] = {.lex_state = 226},
  [3927] = {.lex_state = 226},
  [3928] = {.lex_state = 226},
  [3929] = {.lex_state = 226},
  [3930] = {.lex_state = 226},
  [3931] = {.lex_state = 226},
  [3932] = {.lex_state = 226},
  [3933] = {.lex_state = 226},
  [3934] = {.lex_state = 226},
  [3935] = {.lex_state = 226},
  [3936] = {.lex_state = 226},
  [3937] = {.lex_state = 226, .external_lex_state = 14},
  [3938] = {.lex_state = 226},
  [3939] = {.lex_state = 226},
  [3940] = {.lex_state = 226},
  [3941] = {.lex_state = 226},
  [3942] = {.lex_state = 226, .external_lex_state = 14},
  [3943] = {.lex_state = 226},
  [3944] = {.lex_state = 226, .external_lex_state = 14},
  [3945] = {.lex_state = 26},
  [3946] = {.lex_state = 26},
  [3947] = {.lex_state = 26},
  [3948] = {.lex_state = 26},
  [3949] = {.lex_state = 226},
  [3950] = {.lex_state = 26},
  [3951] = {.lex_state = 26},
  [3952] = {.lex_state = 226},
  [3953] = {.lex_state = 26},
  [3954] = {.lex_state = 226},
  [3955] = {.lex_state = 226},
  [3956] = {.lex_state = 226},
  [3957] = {.lex_state = 26},
  [3958] = {.lex_state = 226},
  [3959] = {.lex_state = 26},
  [3960] = {.lex_state = 26},
  [3961] = {.lex_state = 226},
  [3962] = {.lex_state = 26},
  [3963] = {.lex_state = 26},
  [3964] = {.lex_state = 226},
  [3965] = {.lex_state = 26},
  [3966] = {.lex_state = 26},
  [3967] = {.lex_state = 226},
  [3968] = {.lex_state = 226},
  [3969] = {.lex_state = 226},
  [3970] = {.lex_state = 226},
  [3971] = {.lex_state = 226},
  [3972] = {.lex_state = 226},
  [3973] = {.lex_state = 226},
  [3974] = {.lex_state = 226},
  [3975] = {.lex_state = 226},
  [3976] = {.lex_state = 226},
  [3977] = {.lex_state = 26},
  [3978] = {.lex_state = 226},
  [3979] = {.lex_state = 226},
  [3980] = {.lex_state = 226},
  [3981] = {.lex_state = 226},
  [3982] = {.lex_state = 226},
  [3983] = {.lex_state = 226},
  [3984] = {.lex_state = 226},
  [3985] = {.lex_state = 26},
  [3986] = {.lex_state = 226},
  [3987] = {.lex_state = 226},
  [3988] = {.lex_state = 226},
  [3989] = {.lex_state = 226},
  [3990] = {.lex_state = 226},
  [3991] = {.lex_state = 226},
  [3992] = {.lex_state = 26},
  [3993] = {.lex_state = 226},
  [3994] = {.lex_state = 226},
  [3995] = {.lex_state = 226},
  [3996] = {.lex_state = 226},
  [3997] = {.lex_state = 226},
  [3998] = {.lex_state = 26},
  [3999] = {.lex_state = 226},
  [4000] = {.lex_state = 226},
  [4001] = {.lex_state = 226},
  [4002] = {.lex_state = 226},
  [4003] = {.lex_state = 226},
  [4004] = {.lex_state = 226},
  [4005] = {.lex_state = 226},
  [4006] = {.lex_state = 226},
  [4007] = {.lex_state = 226},
  [4008] = {.lex_state = 226},
  [4009] = {.lex_state = 26},
  [4010] = {.lex_state = 226},
  [4011] = {.lex_state = 26},
  [4012] = {.lex_state = 231},
  [4013] = {.lex_state = 226},
  [4014] = {.lex_state = 26},
  [4015] = {.lex_state = 226},
  [4016] = {.lex_state = 226},
  [4017] = {.lex_state = 226},
  [4018] = {.lex_state = 226},
  [4019] = {.lex_state = 226},
  [4020] = {.lex_state = 226},
  [4021] = {.lex_state = 226},
  [4022] = {.lex_state = 226, .external_lex_state = 13},
  [4023] = {.lex_state = 0},
  [4024] = {.lex_state = 226},
  [4025] = {.lex_state = 226},
  [4026] = {.lex_state = 226},
  [4027] = {.lex_state = 226},
  [4028] = {.lex_state = 226},
  [4029] = {.lex_state = 226},
  [4030] = {.lex_state = 226},
  [4031] = {.lex_state = 226},
  [4032] = {.lex_state = 226},
  [4033] = {.lex_state = 226},
  [4034] = {.lex_state = 226},
  [4035] = {.lex_state = 226},
  [4036] = {.lex_state = 226},
  [4037] = {.lex_state = 226},
  [4038] = {.lex_state = 226},
  [4039] = {.lex_state = 226},
  [4040] = {.lex_state = 226},
  [4041] = {.lex_state = 226},
  [4042] = {.lex_state = 226},
  [4043] = {.lex_state = 226},
  [4044] = {.lex_state = 226},
  [4045] = {.lex_state = 226},
  [4046] = {.lex_state = 226},
  [4047] = {.lex_state = 226},
  [4048] = {.lex_state = 226},
  [4049] = {.lex_state = 226},
  [4050] = {.lex_state = 226},
  [4051] = {.lex_state = 226},
  [4052] = {.lex_state = 226},
  [4053] = {.lex_state = 226},
  [4054] = {.lex_state = 226},
  [4055] = {.lex_state = 226},
  [4056] = {.lex_state = 226},
  [4057] = {.lex_state = 226},
  [4058] = {.lex_state = 226},
  [4059] = {.lex_state = 226},
  [4060] = {.lex_state = 226},
  [4061] = {.lex_state = 226},
  [4062] = {.lex_state = 226},
  [4063] = {.lex_state = 226},
  [4064] = {.lex_state = 226},
  [4065] = {.lex_state = 226},
  [4066] = {.lex_state = 226},
  [4067] = {.lex_state = 226},
  [4068] = {.lex_state = 231},
  [4069] = {.lex_state = 226},
  [4070] = {.lex_state = 226},
  [4071] = {.lex_state = 0},
  [4072] = {.lex_state = 226},
  [4073] = {.lex_state = 0},
  [4074] = {.lex_state = 226},
  [4075] = {.lex_state = 0},
  [4076] = {.lex_state = 226},
  [4077] = {.lex_state = 226},
  [4078] = {.lex_state = 226},
  [4079] = {.lex_state = 0},
  [4080] = {.lex_state = 226},
  [4081] = {.lex_state = 226},
  [4082] = {.lex_state = 0},
  [4083] = {.lex_state = 0},
  [4084] = {.lex_state = 226},
  [4085] = {.lex_state = 0},
  [4086] = {.lex_state = 0},
  [4087] = {.lex_state = 226},
  [4088] = {.lex_state = 226},
  [4089] = {.lex_state = 0},
  [4090] = {.lex_state = 0},
  [4091] = {.lex_state = 0},
  [4092] = {.lex_state = 226},
  [4093] = {.lex_state = 0},
  [4094] = {.lex_state = 25},
  [4095] = {.lex_state = 0},
  [4096] = {.lex_state = 226},
  [4097] = {.lex_state = 0},
  [4098] = {.lex_state = 0},
  [4099] = {.lex_state = 0},
  [4100] = {.lex_state = 0},
  [4101] = {.lex_state = 0},
  [4102] = {.lex_state = 226},
  [4103] = {.lex_state = 226},
  [4104] = {.lex_state = 0},
  [4105] = {.lex_state = 0},
  [4106] = {.lex_state = 0},
  [4107] = {.lex_state = 0},
  [4108] = {.lex_state = 25},
  [4109] = {.lex_state = 0},
  [4110] = {.lex_state = 0},
  [4111] = {.lex_state = 226},
  [4112] = {.lex_state = 226},
  [4113] = {.lex_state = 0},
  [4114] = {.lex_state = 0},
  [4115] = {.lex_state = 0},
  [4116] = {.lex_state = 0},
  [4117] = {.lex_state = 0},
  [4118] = {.lex_state = 0},
  [4119] = {.lex_state = 0},
  [4120] = {.lex_state = 226},
  [4121] = {.lex_state = 0},
  [4122] = {.lex_state = 226},
  [4123] = {.lex_state = 0},
  [4124] = {.lex_state = 0},
  [4125] = {.lex_state = 226},
  [4126] = {.lex_state = 226},
  [4127] = {.lex_state = 226},
  [4128] = {.lex_state = 226},
  [4129] = {.lex_state = 226},
  [4130] = {.lex_state = 226},
  [4131] = {.lex_state = 226},
  [4132] = {.lex_state = 226},
  [4133] = {.lex_state = 226},
  [4134] = {.lex_state = 0},
  [4135] = {.lex_state = 226},
  [4136] = {.lex_state = 226},
  [4137] = {.lex_state = 226},
  [4138] = {.lex_state = 226},
  [4139] = {.lex_state = 226, .external_lex_state = 13},
  [4140] = {.lex_state = 226},
  [4141] = {.lex_state = 226},
  [4142] = {.lex_state = 226},
  [4143] = {.lex_state = 226},
  [4144] = {.lex_state = 226},
  [4145] = {.lex_state = 226},
  [4146] = {.lex_state = 226},
  [4147] = {.lex_state = 226},
  [4148] = {.lex_state = 226},
  [4149] = {.lex_state = 0, .external_lex_state = 15},
  [4150] = {.lex_state = 0, .external_lex_state = 15},
  [4151] = {.lex_state = 226},
  [4152] = {.lex_state = 226},
  [4153] = {.lex_state = 226},
  [4154] = {.lex_state = 0, .external_lex_state = 15},
  [4155] = {.lex_state = 0, .external_lex_state = 15},
  [4156] = {.lex_state = 226},
  [4157] = {.lex_state = 231},
  [4158] = {.lex_state = 226},
  [4159] = {.lex_state = 226},
  [4160] = {.lex_state = 226},
  [4161] = {.lex_state = 226},
  [4162] = {.lex_state = 28},
  [4163] = {.lex_state = 226},
  [4164] = {.lex_state = 226},
  [4165] = {.lex_state = 226},
  [4166] = {.lex_state = 28, .external_lex_state = 13},
  [4167] = {.lex_state = 226},
  [4168] = {.lex_state = 226},
  [4169] = {.lex_state = 231, .external_lex_state = 13},
  [4170] = {.lex_state = 226},
  [4171] = {.lex_state = 226},
  [4172] = {.lex_state = 226},
  [4173] = {.lex_state = 226},
  [4174] = {.lex_state = 226},
  [4175] = {.lex_state = 0},
  [4176] = {.lex_state = 0, .external_lex_state = 15},
  [4177] = {.lex_state = 0, .external_lex_state = 15},
  [4178] = {.lex_state = 0, .external_lex_state = 15},
  [4179] = {.lex_state = 0},
  [4180] = {.lex_state = 226},
  [4181] = {.lex_state = 0, .external_lex_state = 15},
  [4182] = {.lex_state = 226, .external_lex_state = 13},
  [4183] = {.lex_state = 226},
  [4184] = {.lex_state = 226},
  [4185] = {.lex_state = 226},
  [4186] = {.lex_state = 226},
  [4187] = {.lex_state = 226},
  [4188] = {.lex_state = 226},
  [4189] = {.lex_state = 226},
  [4190] = {.lex_state = 226},
  [4191] = {.lex_state = 226},
  [4192] = {.lex_state = 226},
  [4193] = {.lex_state = 226},
  [4194] = {.lex_state = 226},
  [4195] = {.lex_state = 226, .external_lex_state = 13},
  [4196] = {.lex_state = 226},
  [4197] = {.lex_state = 226},
  [4198] = {.lex_state = 0, .external_lex_state = 15},
  [4199] = {.lex_state = 226, .external_lex_state = 13},
  [4200] = {.lex_state = 226},
  [4201] = {.lex_state = 226},
  [4202] = {.lex_state = 226},
  [4203] = {.lex_state = 226},
  [4204] = {.lex_state = 226},
  [4205] = {.lex_state = 0, .external_lex_state = 15},
  [4206] = {.lex_state = 0, .external_lex_state = 15},
  [4207] = {.lex_state = 226},
  [4208] = {.lex_state = 226},
  [4209] = {.lex_state = 226},
  [4210] = {.lex_state = 226},
  [4211] = {.lex_state = 226},
  [4212] = {.lex_state = 0},
  [4213] = {.lex_state = 226, .external_lex_state = 13},
  [4214] = {.lex_state = 0, .external_lex_state = 15},
  [4215] = {.lex_state = 226},
  [4216] = {.lex_state = 226},
  [4217] = {.lex_state = 226},
  [4218] = {.lex_state = 226},
  [4219] = {.lex_state = 0, .external_lex_state = 15},
  [4220] = {.lex_state = 0, .external_lex_state = 15},
  [4221] = {.lex_state = 226},
  [4222] = {.lex_state = 226},
  [4223] = {.lex_state = 0, .external_lex_state = 15},
  [4224] = {.lex_state = 226},
  [4225] = {.lex_state = 226},
  [4226] = {.lex_state = 226},
  [4227] = {.lex_state = 0},
  [4228] = {.lex_state = 226},
  [4229] = {.lex_state = 0},
  [4230] = {.lex_state = 28},
  [4231] = {.lex_state = 226},
  [4232] = {.lex_state = 226},
  [4233] = {.lex_state = 28},
  [4234] = {.lex_state = 226},
  [4235] = {.lex_state = 0},
  [4236] = {.lex_state = 226},
  [4237] = {.lex_state = 226},
  [4238] = {.lex_state = 0},
  [4239] = {.lex_state = 0, .external_lex_state = 15},
  [4240] = {.lex_state = 3},
  [4241] = {.lex_state = 3},
  [4242] = {.lex_state = 226, .external_lex_state = 13},
  [4243] = {.lex_state = 226},
  [4244] = {.lex_state = 0, .external_lex_state = 16},
  [4245] = {.lex_state = 226},
  [4246] = {.lex_state = 226},
  [4247] = {.lex_state = 226, .external_lex_state = 17},
  [4248] = {.lex_state = 3},
  [4249] = {.lex_state = 0, .external_lex_state = 13},
  [4250] = {.lex_state = 0, .external_lex_state = 13},
  [4251] = {.lex_state = 226},
  [4252] = {.lex_state = 226},
  [4253] = {.lex_state = 226},
  [4254] = {.lex_state = 226},
  [4255] = {.lex_state = 226, .external_lex_state = 17},
  [4256] = {.lex_state = 0},
  [4257] = {.lex_state = 226},
  [4258] = {.lex_state = 3},
  [4259] = {.lex_state = 226},
  [4260] = {.lex_state = 25},
  [4261] = {.lex_state = 226},
  [4262] = {.lex_state = 0},
  [4263] = {.lex_state = 0, .external_lex_state = 16},
  [4264] = {.lex_state = 25},
  [4265] = {.lex_state = 25},
  [4266] = {.lex_state = 0, .external_lex_state = 16},
  [4267] = {.lex_state = 0},
  [4268] = {.lex_state = 226},
  [4269] = {.lex_state = 25},
  [4270] = {.lex_state = 226},
  [4271] = {.lex_state = 226},
  [4272] = {.lex_state = 226},
  [4273] = {.lex_state = 0},
  [4274] = {.lex_state = 3},
  [4275] = {.lex_state = 226},
  [4276] = {.lex_state = 226},
  [4277] = {.lex_state = 0},
  [4278] = {.lex_state = 0, .external_lex_state = 13},
  [4279] = {.lex_state = 0, .external_lex_state = 13},
  [4280] = {.lex_state = 226},
  [4281] = {.lex_state = 0, .external_lex_state = 16},
  [4282] = {.lex_state = 0, .external_lex_state = 16},
  [4283] = {.lex_state = 0, .external_lex_state = 13},
  [4284] = {.lex_state = 226, .external_lex_state = 13},
  [4285] = {.lex_state = 3},
  [4286] = {.lex_state = 3},
  [4287] = {.lex_state = 0, .external_lex_state = 13},
  [4288] = {.lex_state = 3},
  [4289] = {.lex_state = 226},
  [4290] = {.lex_state = 226},
  [4291] = {.lex_state = 3},
  [4292] = {.lex_state = 226},
  [4293] = {.lex_state = 3},
  [4294] = {.lex_state = 226},
  [4295] = {.lex_state = 226},
  [4296] = {.lex_state = 226},
  [4297] = {.lex_state = 226},
  [4298] = {.lex_state = 0},
  [4299] = {.lex_state = 0},
  [4300] = {.lex_state = 226},
  [4301] = {.lex_state = 0},
  [4302] = {.lex_state = 25},
  [4303] = {.lex_state = 0, .external_lex_state = 13},
  [4304] = {.lex_state = 0},
  [4305] = {.lex_state = 0, .external_lex_state = 16},
  [4306] = {.lex_state = 226},
  [4307] = {.lex_state = 0, .external_lex_state = 16},
  [4308] = {.lex_state = 25},
  [4309] = {.lex_state = 226},
  [4310] = {.lex_state = 226},
  [4311] = {.lex_state = 0, .external_lex_state = 13},
  [4312] = {.lex_state = 0},
  [4313] = {.lex_state = 0, .external_lex_state = 16},
  [4314] = {.lex_state = 0, .external_lex_state = 13},
  [4315] = {.lex_state = 3},
  [4316] = {.lex_state = 226},
  [4317] = {.lex_state = 226, .external_lex_state = 17},
  [4318] = {.lex_state = 3},
  [4319] = {.lex_state = 231},
  [4320] = {.lex_state = 0, .external_lex_state = 16},
  [4321] = {.lex_state = 226},
  [4322] = {.lex_state = 0},
  [4323] = {.lex_state = 3},
  [4324] = {.lex_state = 0, .external_lex_state = 16},
  [4325] = {.lex_state = 226},
  [4326] = {.lex_state = 0, .external_lex_state = 16},
  [4327] = {.lex_state = 226},
  [4328] = {.lex_state = 0},
  [4329] = {.lex_state = 3},
  [4330] = {.lex_state = 0, .external_lex_state = 16},
  [4331] = {.lex_state = 0, .external_lex_state = 16},
  [4332] = {.lex_state = 226},
  [4333] = {.lex_state = 226},
  [4334] = {.lex_state = 226},
  [4335] = {.lex_state = 3},
  [4336] = {.lex_state = 0, .external_lex_state = 16},
  [4337] = {.lex_state = 231},
  [4338] = {.lex_state = 226},
  [4339] = {.lex_state = 226},
  [4340] = {.lex_state = 226},
  [4341] = {.lex_state = 3},
  [4342] = {.lex_state = 226},
  [4343] = {.lex_state = 3},
  [4344] = {.lex_state = 0},
  [4345] = {.lex_state = 25},
  [4346] = {.lex_state = 0},
  [4347] = {.lex_state = 3},
  [4348] = {.lex_state = 3},
  [4349] = {.lex_state = 0, .external_lex_state = 13},
  [4350] = {.lex_state = 0, .external_lex_state = 13},
  [4351] = {.lex_state = 25},
  [4352] = {.lex_state = 226},
  [4353] = {.lex_state = 0, .external_lex_state = 16},
  [4354] = {.lex_state = 25},
  [4355] = {.lex_state = 3},
  [4356] = {.lex_state = 0, .external_lex_state = 16},
  [4357] = {.lex_state = 0},
  [4358] = {.lex_state = 3},
  [4359] = {.lex_state = 226},
  [4360] = {.lex_state = 231},
  [4361] = {.lex_state = 0},
  [4362] = {.lex_state = 226},
  [4363] = {.lex_state = 226},
  [4364] = {.lex_state = 0, .external_lex_state = 16},
  [4365] = {.lex_state = 0},
  [4366] = {.lex_state = 0, .external_lex_state = 16},
  [4367] = {.lex_state = 0, .external_lex_state = 16},
  [4368] = {.lex_state = 3},
  [4369] = {.lex_state = 0, .external_lex_state = 16},
  [4370] = {.lex_state = 0, .external_lex_state = 16},
  [4371] = {.lex_state = 226},
  [4372] = {.lex_state = 0, .external_lex_state = 16},
  [4373] = {.lex_state = 0, .external_lex_state = 16},
  [4374] = {.lex_state = 226, .external_lex_state = 13},
  [4375] = {.lex_state = 226},
  [4376] = {.lex_state = 0, .external_lex_state = 16},
  [4377] = {.lex_state = 0, .external_lex_state = 16},
  [4378] = {.lex_state = 0},
  [4379] = {.lex_state = 226},
  [4380] = {.lex_state = 226},
  [4381] = {.lex_state = 226},
  [4382] = {.lex_state = 231},
  [4383] = {.lex_state = 0, .external_lex_state = 13},
  [4384] = {.lex_state = 3},
  [4385] = {.lex_state = 226},
  [4386] = {.lex_state = 3},
  [4387] = {.lex_state = 3},
  [4388] = {.lex_state = 3},
  [4389] = {.lex_state = 3},
  [4390] = {.lex_state = 0},
  [4391] = {.lex_state = 3},
  [4392] = {.lex_state = 226},
  [4393] = {.lex_state = 3},
  [4394] = {.lex_state = 3},
  [4395] = {.lex_state = 226},
  [4396] = {.lex_state = 0},
  [4397] = {.lex_state = 0, .external_lex_state = 16},
  [4398] = {.lex_state = 0, .external_lex_state = 16},
  [4399] = {.lex_state = 226, .external_lex_state = 13},
  [4400] = {.lex_state = 0, .external_lex_state = 16},
  [4401] = {.lex_state = 226},
  [4402] = {.lex_state = 3},
  [4403] = {.lex_state = 226},
  [4404] = {.lex_state = 0, .external_lex_state = 16},
  [4405] = {.lex_state = 0, .external_lex_state = 16},
  [4406] = {.lex_state = 231},
  [4407] = {.lex_state = 0, .external_lex_state = 16},
  [4408] = {.lex_state = 3},
  [4409] = {.lex_state = 226},
  [4410] = {.lex_state = 226, .external_lex_state = 13},
  [4411] = {.lex_state = 226, .external_lex_state = 13},
  [4412] = {.lex_state = 226},
  [4413] = {.lex_state = 226},
  [4414] = {.lex_state = 226},
  [4415] = {.lex_state = 226},
  [4416] = {.lex_state = 3},
  [4417] = {.lex_state = 226},
  [4418] = {.lex_state = 0, .external_lex_state = 16},
  [4419] = {.lex_state = 0, .external_lex_state = 16},
  [4420] = {.lex_state = 0, .external_lex_state = 16},
  [4421] = {.lex_state = 0},
  [4422] = {.lex_state = 226},
  [4423] = {.lex_state = 28},
  [4424] = {.lex_state = 226},
  [4425] = {.lex_state = 12},
  [4426] = {.lex_state = 0},
  [4427] = {.lex_state = 0},
  [4428] = {.lex_state = 226},
  [4429] = {.lex_state = 226},
  [4430] = {.lex_state = 226},
  [4431] = {.lex_state = 226},
  [4432] = {.lex_state = 0},
  [4433] = {.lex_state = 226},
  [4434] = {.lex_state = 226},
  [4435] = {.lex_state = 226},
  [4436] = {.lex_state = 226},
  [4437] = {.lex_state = 226},
  [4438] = {.lex_state = 23},
  [4439] = {.lex_state = 226},
  [4440] = {.lex_state = 226},
  [4441] = {.lex_state = 0},
  [4442] = {.lex_state = 0},
  [4443] = {.lex_state = 0},
  [4444] = {.lex_state = 226},
  [4445] = {.lex_state = 226},
  [4446] = {.lex_state = 0},
  [4447] = {.lex_state = 23},
  [4448] = {.lex_state = 0},
  [4449] = {.lex_state = 0},
  [4450] = {.lex_state = 0},
  [4451] = {.lex_state = 0},
  [4452] = {.lex_state = 0},
  [4453] = {.lex_state = 28},
  [4454] = {.lex_state = 226},
  [4455] = {.lex_state = 12},
  [4456] = {.lex_state = 226},
  [4457] = {.lex_state = 23},
  [4458] = {.lex_state = 0},
  [4459] = {.lex_state = 0},
  [4460] = {.lex_state = 226},
  [4461] = {.lex_state = 226},
  [4462] = {.lex_state = 226},
  [4463] = {.lex_state = 226},
  [4464] = {.lex_state = 0},
  [4465] = {.lex_state = 0},
  [4466] = {.lex_state = 226},
  [4467] = {.lex_state = 226},
  [4468] = {.lex_state = 23},
  [4469] = {.lex_state = 226},
  [4470] = {.lex_state = 0},
  [4471] = {.lex_state = 0},
  [4472] = {.lex_state = 226},
  [4473] = {.lex_state = 0},
  [4474] = {.lex_state = 23},
  [4475] = {.lex_state = 0},
  [4476] = {.lex_state = 0},
  [4477] = {.lex_state = 0},
  [4478] = {.lex_state = 0},
  [4479] = {.lex_state = 28},
  [4480] = {.lex_state = 226},
  [4481] = {.lex_state = 226},
  [4482] = {.lex_state = 226},
  [4483] = {.lex_state = 226},
  [4484] = {.lex_state = 226},
  [4485] = {.lex_state = 0},
  [4486] = {.lex_state = 226},
  [4487] = {.lex_state = 226},
  [4488] = {.lex_state = 23},
  [4489] = {.lex_state = 226},
  [4490] = {.lex_state = 0},
  [4491] = {.lex_state = 0},
  [4492] = {.lex_state = 226},
  [4493] = {.lex_state = 226},
  [4494] = {.lex_state = 0},
  [4495] = {.lex_state = 23},
  [4496] = {.lex_state = 0},
  [4497] = {.lex_state = 0},
  [4498] = {.lex_state = 0},
  [4499] = {.lex_state = 0},
  [4500] = {.lex_state = 28},
  [4501] = {.lex_state = 226},
  [4502] = {.lex_state = 226},
  [4503] = {.lex_state = 226},
  [4504] = {.lex_state = 226},
  [4505] = {.lex_state = 226},
  [4506] = {.lex_state = 0},
  [4507] = {.lex_state = 12},
  [4508] = {.lex_state = 226},
  [4509] = {.lex_state = 226},
  [4510] = {.lex_state = 23},
  [4511] = {.lex_state = 226},
  [4512] = {.lex_state = 0},
  [4513] = {.lex_state = 0},
  [4514] = {.lex_state = 226},
  [4515] = {.lex_state = 0},
  [4516] = {.lex_state = 23},
  [4517] = {.lex_state = 0},
  [4518] = {.lex_state = 0},
  [4519] = {.lex_state = 0},
  [4520] = {.lex_state = 0},
  [4521] = {.lex_state = 28},
  [4522] = {.lex_state = 28},
  [4523] = {.lex_state = 226},
  [4524] = {.lex_state = 0, .external_lex_state = 13},
  [4525] = {.lex_state = 0, .external_lex_state = 13},
  [4526] = {.lex_state = 12},
  [4527] = {.lex_state = 226},
  [4528] = {.lex_state = 226},
  [4529] = {.lex_state = 226},
  [4530] = {.lex_state = 0},
  [4531] = {.lex_state = 226},
  [4532] = {.lex_state = 226},
  [4533] = {.lex_state = 23},
  [4534] = {.lex_state = 226},
  [4535] = {.lex_state = 0},
  [4536] = {.lex_state = 0},
  [4537] = {.lex_state = 226},
  [4538] = {.lex_state = 12},
  [4539] = {.lex_state = 12},
  [4540] = {.lex_state = 226},
  [4541] = {.lex_state = 0},
  [4542] = {.lex_state = 23},
  [4543] = {.lex_state = 0},
  [4544] = {.lex_state = 0},
  [4545] = {.lex_state = 0},
  [4546] = {.lex_state = 231},
  [4547] = {.lex_state = 0},
  [4548] = {.lex_state = 226},
  [4549] = {.lex_state = 23},
  [4550] = {.lex_state = 0},
  [4551] = {.lex_state = 0},
  [4552] = {.lex_state = 226},
  [4553] = {.lex_state = 0},
  [4554] = {.lex_state = 226},
  [4555] = {.lex_state = 0},
  [4556] = {.lex_state = 226},
  [4557] = {.lex_state = 0},
  [4558] = {.lex_state = 0},
  [4559] = {.lex_state = 226},
  [4560] = {.lex_state = 226},
  [4561] = {.lex_state = 0},
  [4562] = {.lex_state = 0},
  [4563] = {.lex_state = 0},
  [4564] = {.lex_state = 0},
  [4565] = {.lex_state = 0},
  [4566] = {.lex_state = 226},
  [4567] = {.lex_state = 12},
  [4568] = {.lex_state = 12},
  [4569] = {.lex_state = 12},
  [4570] = {.lex_state = 226},
  [4571] = {.lex_state = 226},
  [4572] = {.lex_state = 226},
  [4573] = {.lex_state = 0},
  [4574] = {.lex_state = 226},
  [4575] = {.lex_state = 0, .external_lex_state = 13},
  [4576] = {.lex_state = 0},
  [4577] = {.lex_state = 12},
  [4578] = {.lex_state = 226},
  [4579] = {.lex_state = 226},
  [4580] = {.lex_state = 226},
  [4581] = {.lex_state = 226},
  [4582] = {.lex_state = 226},
  [4583] = {.lex_state = 226},
  [4584] = {.lex_state = 0},
  [4585] = {.lex_state = 226},
  [4586] = {.lex_state = 226},
  [4587] = {.lex_state = 226},
  [4588] = {.lex_state = 12},
  [4589] = {.lex_state = 226},
  [4590] = {.lex_state = 12},
  [4591] = {.lex_state = 12},
  [4592] = {.lex_state = 226},
  [4593] = {.lex_state = 226},
  [4594] = {.lex_state = 23},
  [4595] = {.lex_state = 226},
  [4596] = {.lex_state = 0},
  [4597] = {.lex_state = 0},
  [4598] = {.lex_state = 0},
  [4599] = {.lex_state = 226},
  [4600] = {.lex_state = 226},
  [4601] = {.lex_state = 0},
  [4602] = {.lex_state = 0},
  [4603] = {.lex_state = 226},
  [4604] = {.lex_state = 226},
  [4605] = {.lex_state = 12},
  [4606] = {.lex_state = 23},
  [4607] = {.lex_state = 0},
  [4608] = {.lex_state = 0},
  [4609] = {.lex_state = 0},
  [4610] = {.lex_state = 226},
  [4611] = {.lex_state = 226},
  [4612] = {.lex_state = 226},
  [4613] = {.lex_state = 0},
  [4614] = {.lex_state = 0},
  [4615] = {.lex_state = 226},
  [4616] = {.lex_state = 25},
  [4617] = {.lex_state = 3},
  [4618] = {.lex_state = 28},
  [4619] = {.lex_state = 226},
  [4620] = {.lex_state = 226},
  [4621] = {.lex_state = 226},
  [4622] = {.lex_state = 12},
  [4623] = {.lex_state = 12},
  [4624] = {.lex_state = 226},
  [4625] = {.lex_state = 0},
  [4626] = {.lex_state = 226},
  [4627] = {.lex_state = 226},
  [4628] = {.lex_state = 226},
  [4629] = {.lex_state = 226},
  [4630] = {.lex_state = 0},
  [4631] = {.lex_state = 226},
  [4632] = {.lex_state = 226},
  [4633] = {.lex_state = 226},
  [4634] = {.lex_state = 226},
  [4635] = {.lex_state = 226},
  [4636] = {.lex_state = 226},
  [4637] = {.lex_state = 0},
  [4638] = {.lex_state = 226},
  [4639] = {.lex_state = 226},
  [4640] = {.lex_state = 226},
  [4641] = {.lex_state = 0},
  [4642] = {.lex_state = 226},
  [4643] = {.lex_state = 226},
  [4644] = {.lex_state = 0},
  [4645] = {.lex_state = 226},
  [4646] = {.lex_state = 226},
  [4647] = {.lex_state = 0},
  [4648] = {.lex_state = 0},
  [4649] = {.lex_state = 0, .external_lex_state = 13},
  [4650] = {.lex_state = 226},
  [4651] = {.lex_state = 226},
  [4652] = {.lex_state = 226},
  [4653] = {.lex_state = 226},
  [4654] = {.lex_state = 226},
  [4655] = {.lex_state = 23},
  [4656] = {.lex_state = 226},
  [4657] = {.lex_state = 0},
  [4658] = {.lex_state = 12},
  [4659] = {.lex_state = 226},
  [4660] = {.lex_state = 226},
  [4661] = {.lex_state = 0},
  [4662] = {.lex_state = 12},
  [4663] = {.lex_state = 226},
  [4664] = {.lex_state = 0},
  [4665] = {.lex_state = 226},
  [4666] = {.lex_state = 226},
  [4667] = {.lex_state = 28},
  [4668] = {.lex_state = 0},
  [4669] = {.lex_state = 12},
  [4670] = {.lex_state = 226},
  [4671] = {.lex_state = 23},
  [4672] = {.lex_state = 0},
  [4673] = {.lex_state = 0},
  [4674] = {.lex_state = 226},
  [4675] = {.lex_state = 0},
  [4676] = {.lex_state = 0},
  [4677] = {.lex_state = 226},
  [4678] = {.lex_state = 226},
  [4679] = {.lex_state = 0, .external_lex_state = 12},
  [4680] = {.lex_state = 226},
  [4681] = {.lex_state = 23},
  [4682] = {.lex_state = 226},
  [4683] = {.lex_state = 28},
  [4684] = {.lex_state = 226},
  [4685] = {.lex_state = 25},
  [4686] = {.lex_state = 12},
  [4687] = {.lex_state = 0},
  [4688] = {.lex_state = 12},
  [4689] = {.lex_state = 226},
  [4690] = {.lex_state = 0, .external_lex_state = 13},
  [4691] = {.lex_state = 226},
  [4692] = {.lex_state = 226},
  [4693] = {.lex_state = 231},
  [4694] = {.lex_state = 12},
  [4695] = {.lex_state = 226},
  [4696] = {.lex_state = 0},
  [4697] = {.lex_state = 226},
  [4698] = {.lex_state = 226},
  [4699] = {.lex_state = 0, .external_lex_state = 13},
  [4700] = {.lex_state = 231},
  [4701] = {.lex_state = 231},
  [4702] = {.lex_state = 0},
  [4703] = {.lex_state = 0, .external_lex_state = 13},
  [4704] = {.lex_state = 226},
  [4705] = {.lex_state = 226},
  [4706] = {.lex_state = 226},
  [4707] = {.lex_state = 226},
  [4708] = {.lex_state = 12},
  [4709] = {.lex_state = 226},
  [4710] = {.lex_state = 23},
  [4711] = {.lex_state = 226},
  [4712] = {.lex_state = 0, .external_lex_state = 13},
  [4713] = {.lex_state = 226},
  [4714] = {.lex_state = 226},
  [4715] = {.lex_state = 0},
  [4716] = {.lex_state = 226},
  [4717] = {.lex_state = 226},
  [4718] = {.lex_state = 0},
  [4719] = {.lex_state = 0},
  [4720] = {.lex_state = 0},
  [4721] = {.lex_state = 12},
  [4722] = {.lex_state = 226},
  [4723] = {.lex_state = 226},
  [4724] = {.lex_state = 12},
  [4725] = {.lex_state = 226},
  [4726] = {.lex_state = 226},
  [4727] = {.lex_state = 0},
  [4728] = {.lex_state = 226},
  [4729] = {.lex_state = 23},
  [4730] = {.lex_state = 0},
  [4731] = {.lex_state = 0},
  [4732] = {.lex_state = 0},
  [4733] = {.lex_state = 226},
  [4734] = {.lex_state = 0},
  [4735] = {.lex_state = 226},
  [4736] = {.lex_state = 226},
  [4737] = {.lex_state = 226},
  [4738] = {.lex_state = 28},
  [4739] = {.lex_state = 226},
  [4740] = {.lex_state = 0},
  [4741] = {.lex_state = 0, .external_lex_state = 13},
  [4742] = {.lex_state = 226},
  [4743] = {.lex_state = 226},
  [4744] = {.lex_state = 226},
  [4745] = {.lex_state = 226},
  [4746] = {.lex_state = 226},
  [4747] = {.lex_state = 226},
  [4748] = {.lex_state = 226},
  [4749] = {.lex_state = 226},
  [4750] = {.lex_state = 226},
  [4751] = {.lex_state = 12},
  [4752] = {.lex_state = 12},
  [4753] = {.lex_state = 12},
  [4754] = {.lex_state = 226},
  [4755] = {.lex_state = 226},
  [4756] = {.lex_state = 226},
  [4757] = {.lex_state = 0},
  [4758] = {.lex_state = 12},
  [4759] = {.lex_state = 0},
  [4760] = {.lex_state = 226},
  [4761] = {.lex_state = 226},
  [4762] = {.lex_state = 23},
  [4763] = {.lex_state = 0},
  [4764] = {.lex_state = 226},
  [4765] = {.lex_state = 226},
  [4766] = {.lex_state = 23},
  [4767] = {.lex_state = 226},
  [4768] = {.lex_state = 226},
  [4769] = {.lex_state = 0},
  [4770] = {.lex_state = 0},
  [4771] = {.lex_state = 0},
  [4772] = {.lex_state = 0},
  [4773] = {.lex_state = 226},
  [4774] = {.lex_state = 0},
  [4775] = {.lex_state = 226},
  [4776] = {.lex_state = 226},
  [4777] = {.lex_state = 0},
  [4778] = {.lex_state = 23},
  [4779] = {.lex_state = 226},
  [4780] = {.lex_state = 0},
  [4781] = {.lex_state = 226},
  [4782] = {.lex_state = 0},
  [4783] = {.lex_state = 0},
  [4784] = {.lex_state = 0},
  [4785] = {.lex_state = 226},
  [4786] = {.lex_state = 28},
  [4787] = {.lex_state = 0},
  [4788] = {.lex_state = 226},
  [4789] = {.lex_state = 226},
  [4790] = {.lex_state = 12},
  [4791] = {.lex_state = 23},
  [4792] = {.lex_state = 226},
  [4793] = {.lex_state = 0},
  [4794] = {.lex_state = 226},
  [4795] = {.lex_state = 0},
  [4796] = {.lex_state = 0},
  [4797] = {.lex_state = 226},
  [4798] = {.lex_state = 0},
  [4799] = {.lex_state = 226},
  [4800] = {.lex_state = 0, .external_lex_state = 13},
  [4801] = {.lex_state = 226},
  [4802] = {.lex_state = 226},
  [4803] = {.lex_state = 226},
  [4804] = {.lex_state = 226},
  [4805] = {.lex_state = 0},
  [4806] = {.lex_state = 226},
  [4807] = {.lex_state = 226},
  [4808] = {.lex_state = 226},
  [4809] = {.lex_state = 23},
  [4810] = {.lex_state = 226},
  [4811] = {.lex_state = 0},
  [4812] = {.lex_state = 231},
  [4813] = {.lex_state = 226},
  [4814] = {.lex_state = 0},
  [4815] = {.lex_state = 25},
  [4816] = {.lex_state = 226},
  [4817] = {.lex_state = 0},
  [4818] = {.lex_state = 12},
  [4819] = {.lex_state = 226},
  [4820] = {.lex_state = 0},
  [4821] = {.lex_state = 23},
  [4822] = {.lex_state = 0},
  [4823] = {.lex_state = 0},
  [4824] = {.lex_state = 0},
  [4825] = {.lex_state = 0},
  [4826] = {.lex_state = 28},
  [4827] = {.lex_state = 28},
  [4828] = {.lex_state = 0},
  [4829] = {.lex_state = 12},
  [4830] = {.lex_state = 12},
  [4831] = {.lex_state = 12},
  [4832] = {.lex_state = 226},
  [4833] = {.lex_state = 12},
  [4834] = {.lex_state = 12},
  [4835] = {.lex_state = 226},
  [4836] = {.lex_state = 12},
  [4837] = {.lex_state = 226},
  [4838] = {.lex_state = 231},
  [4839] = {.lex_state = 226},
  [4840] = {.lex_state = 226},
  [4841] = {.lex_state = 0},
  [4842] = {.lex_state = 226},
  [4843] = {.lex_state = 226},
  [4844] = {.lex_state = 231},
  [4845] = {.lex_state = 226},
  [4846] = {.lex_state = 226},
  [4847] = {.lex_state = 0, .external_lex_state = 13},
  [4848] = {.lex_state = 226},
  [4849] = {.lex_state = 231},
  [4850] = {.lex_state = 226},
  [4851] = {.lex_state = 0},
  [4852] = {.lex_state = 23},
  [4853] = {.lex_state = 226},
  [4854] = {.lex_state = 231},
  [4855] = {.lex_state = 226},
  [4856] = {.lex_state = 0},
  [4857] = {.lex_state = 23},
  [4858] = {.lex_state = 226},
  [4859] = {.lex_state = 23},
  [4860] = {.lex_state = 231},
  [4861] = {.lex_state = 0},
  [4862] = {.lex_state = 12},
  [4863] = {.lex_state = 226},
  [4864] = {.lex_state = 231},
  [4865] = {.lex_state = 226},
  [4866] = {.lex_state = 226},
  [4867] = {.lex_state = 0},
  [4868] = {.lex_state = 231},
  [4869] = {.lex_state = 226},
  [4870] = {.lex_state = 0},
  [4871] = {.lex_state = 0},
  [4872] = {.lex_state = 23},
  [4873] = {.lex_state = 231},
  [4874] = {.lex_state = 0},
  [4875] = {.lex_state = 25},
  [4876] = {.lex_state = 0},
  [4877] = {.lex_state = 0},
  [4878] = {.lex_state = 0},
  [4879] = {.lex_state = 12},
  [4880] = {.lex_state = 0},
  [4881] = {.lex_state = 231},
  [4882] = {.lex_state = 28},
  [4883] = {.lex_state = 12},
  [4884] = {.lex_state = 0},
  [4885] = {.lex_state = 12},
  [4886] = {.lex_state = 0},
  [4887] = {.lex_state = 226},
  [4888] = {.lex_state = 226},
  [4889] = {.lex_state = 231},
  [4890] = {.lex_state = 226},
  [4891] = {.lex_state = 0, .external_lex_state = 13},
  [4892] = {.lex_state = 226},
  [4893] = {.lex_state = 231},
  [4894] = {.lex_state = 226},
  [4895] = {.lex_state = 0},
  [4896] = {.lex_state = 226},
  [4897] = {.lex_state = 231},
  [4898] = {.lex_state = 226},
  [4899] = {.lex_state = 226},
  [4900] = {.lex_state = 226},
  [4901] = {.lex_state = 226},
  [4902] = {.lex_state = 226},
  [4903] = {.lex_state = 0},
  [4904] = {.lex_state = 0},
  [4905] = {.lex_state = 226},
  [4906] = {.lex_state = 226},
  [4907] = {.lex_state = 226},
  [4908] = {.lex_state = 226},
  [4909] = {.lex_state = 226},
  [4910] = {.lex_state = 226},
  [4911] = {.lex_state = 23},
  [4912] = {.lex_state = 226},
  [4913] = {.lex_state = 0},
  [4914] = {.lex_state = 0},
  [4915] = {.lex_state = 226},
  [4916] = {.lex_state = 0},
  [4917] = {.lex_state = 12},
  [4918] = {.lex_state = 0},
  [4919] = {.lex_state = 226},
  [4920] = {.lex_state = 0},
  [4921] = {.lex_state = 226},
  [4922] = {.lex_state = 226},
  [4923] = {.lex_state = 0},
  [4924] = {.lex_state = 23},
  [4925] = {.lex_state = 0},
  [4926] = {.lex_state = 0},
  [4927] = {.lex_state = 0},
  [4928] = {.lex_state = 12},
  [4929] = {.lex_state = 0},
  [4930] = {.lex_state = 226},
  [4931] = {.lex_state = 226},
  [4932] = {.lex_state = 12},
  [4933] = {.lex_state = 226},
  [4934] = {.lex_state = 0},
  [4935] = {.lex_state = 28},
  [4936] = {.lex_state = 12},
  [4937] = {.lex_state = 226},
  [4938] = {.lex_state = 0},
  [4939] = {.lex_state = 23},
  [4940] = {.lex_state = 226},
  [4941] = {.lex_state = 226},
  [4942] = {.lex_state = 0},
  [4943] = {.lex_state = 226},
  [4944] = {.lex_state = 226},
  [4945] = {.lex_state = 226},
  [4946] = {.lex_state = 0},
  [4947] = {.lex_state = 226},
  [4948] = {.lex_state = 0},
  [4949] = {.lex_state = 226},
  [4950] = {.lex_state = 25},
  [4951] = {.lex_state = 0},
  [4952] = {.lex_state = 226},
  [4953] = {.lex_state = 226},
  [4954] = {.lex_state = 226},
  [4955] = {.lex_state = 0},
  [4956] = {.lex_state = 0},
  [4957] = {.lex_state = 25},
  [4958] = {.lex_state = 226},
  [4959] = {.lex_state = 226},
  [4960] = {.lex_state = 226},
  [4961] = {.lex_state = 226},
  [4962] = {.lex_state = 0},
  [4963] = {.lex_state = 0},
  [4964] = {.lex_state = 0},
  [4965] = {.lex_state = 226},
  [4966] = {.lex_state = 226, .external_lex_state = 13},
  [4967] = {.lex_state = 0, .external_lex_state = 16},
  [4968] = {.lex_state = 0},
  [4969] = {.lex_state = 0},
  [4970] = {.lex_state = 0},
  [4971] = {.lex_state = 226},
  [4972] = {.lex_state = 226},
  [4973] = {.lex_state = 226},
  [4974] = {.lex_state = 226},
  [4975] = {.lex_state = 226},
  [4976] = {.lex_state = 226},
  [4977] = {.lex_state = 226},
  [4978] = {.lex_state = 226},
  [4979] = {.lex_state = 0},
  [4980] = {.lex_state = 0},
  [4981] = {.lex_state = 0},
  [4982] = {.lex_state = 226},
  [4983] = {.lex_state = 226},
  [4984] = {.lex_state = 226},
  [4985] = {.lex_state = 0},
  [4986] = {.lex_state = 0},
  [4987] = {.lex_state = 0},
  [4988] = {.lex_state = 25},
  [4989] = {.lex_state = 226},
  [4990] = {.lex_state = 226},
  [4991] = {.lex_state = 226},
  [4992] = {.lex_state = 0},
  [4993] = {.lex_state = 226},
  [4994] = {.lex_state = 226},
  [4995] = {.lex_state = 0},
  [4996] = {.lex_state = 226},
  [4997] = {.lex_state = 226},
  [4998] = {.lex_state = 226},
  [4999] = {.lex_state = 226},
  [5000] = {.lex_state = 0},
  [5001] = {.lex_state = 0},
  [5002] = {.lex_state = 226},
  [5003] = {.lex_state = 0},
  [5004] = {.lex_state = 226},
  [5005] = {.lex_state = 0},
  [5006] = {.lex_state = 226},
  [5007] = {.lex_state = 0},
  [5008] = {.lex_state = 0},
  [5009] = {.lex_state = 226},
  [5010] = {.lex_state = 226},
  [5011] = {.lex_state = 0},
  [5012] = {.lex_state = 0},
  [5013] = {.lex_state = 226},
  [5014] = {.lex_state = 226},
  [5015] = {.lex_state = 226},
  [5016] = {.lex_state = 0},
  [5017] = {.lex_state = 226},
  [5018] = {.lex_state = 226},
  [5019] = {.lex_state = 226},
  [5020] = {.lex_state = 0, .external_lex_state = 13},
  [5021] = {.lex_state = 226},
  [5022] = {.lex_state = 226},
  [5023] = {.lex_state = 25},
  [5024] = {.lex_state = 226},
  [5025] = {.lex_state = 0},
  [5026] = {.lex_state = 226},
  [5027] = {.lex_state = 226},
  [5028] = {.lex_state = 0},
  [5029] = {.lex_state = 0, .external_lex_state = 16},
  [5030] = {.lex_state = 226},
  [5031] = {.lex_state = 0},
  [5032] = {.lex_state = 226},
  [5033] = {.lex_state = 226},
  [5034] = {.lex_state = 0},
  [5035] = {.lex_state = 226},
  [5036] = {.lex_state = 226},
  [5037] = {.lex_state = 0},
  [5038] = {.lex_state = 226},
  [5039] = {.lex_state = 0},
  [5040] = {.lex_state = 226},
  [5041] = {.lex_state = 226},
  [5042] = {.lex_state = 226},
  [5043] = {.lex_state = 226},
  [5044] = {.lex_state = 226},
  [5045] = {.lex_state = 226},
  [5046] = {.lex_state = 226},
  [5047] = {.lex_state = 226},
  [5048] = {.lex_state = 226},
  [5049] = {.lex_state = 226},
  [5050] = {.lex_state = 226},
  [5051] = {.lex_state = 226},
  [5052] = {.lex_state = 226},
  [5053] = {.lex_state = 226},
  [5054] = {.lex_state = 226},
  [5055] = {.lex_state = 226},
  [5056] = {.lex_state = 226},
  [5057] = {.lex_state = 226},
  [5058] = {.lex_state = 226},
  [5059] = {.lex_state = 0, .external_lex_state = 13},
  [5060] = {.lex_state = 231},
  [5061] = {.lex_state = 14},
  [5062] = {.lex_state = 0},
  [5063] = {.lex_state = 31},
  [5064] = {.lex_state = 226},
  [5065] = {.lex_state = 226},
  [5066] = {.lex_state = 231},
  [5067] = {.lex_state = 14},
  [5068] = {.lex_state = 226},
  [5069] = {.lex_state = 14},
  [5070] = {.lex_state = 539},
  [5071] = {.lex_state = 14},
  [5072] = {.lex_state = 0},
  [5073] = {.lex_state = 0, .external_lex_state = 18},
  [5074] = {.lex_state = 226},
  [5075] = {.lex_state = 0},
  [5076] = {.lex_state = 226},
  [5077] = {.lex_state = 14},
  [5078] = {.lex_state = 226},
  [5079] = {.lex_state = 539},
  [5080] = {.lex_state = 0},
  [5081] = {.lex_state = 14},
  [5082] = {.lex_state = 14},
  [5083] = {.lex_state = 226},
  [5084] = {.lex_state = 17},
  [5085] = {.lex_state = 19},
  [5086] = {.lex_state = 226},
  [5087] = {.lex_state = 0},
  [5088] = {.lex_state = 226},
  [5089] = {.lex_state = 226},
  [5090] = {.lex_state = 541},
  [5091] = {.lex_state = 29},
  [5092] = {.lex_state = 0, .external_lex_state = 19},
  [5093] = {.lex_state = 231},
  [5094] = {.lex_state = 31},
  [5095] = {.lex_state = 0},
  [5096] = {.lex_state = 14},
  [5097] = {.lex_state = 14},
  [5098] = {.lex_state = 0, .external_lex_state = 18},
  [5099] = {.lex_state = 226},
  [5100] = {.lex_state = 226},
  [5101] = {.lex_state = 226},
  [5102] = {.lex_state = 226},
  [5103] = {.lex_state = 14},
  [5104] = {.lex_state = 0, .external_lex_state = 18},
  [5105] = {.lex_state = 251},
  [5106] = {.lex_state = 0, .external_lex_state = 18},
  [5107] = {.lex_state = 226},
  [5108] = {.lex_state = 14},
  [5109] = {.lex_state = 14},
  [5110] = {.lex_state = 14},
  [5111] = {.lex_state = 14},
  [5112] = {.lex_state = 14},
  [5113] = {.lex_state = 226},
  [5114] = {.lex_state = 226},
  [5115] = {.lex_state = 14},
  [5116] = {.lex_state = 226},
  [5117] = {.lex_state = 226},
  [5118] = {.lex_state = 14},
  [5119] = {.lex_state = 0, .external_lex_state = 13},
  [5120] = {.lex_state = 231},
  [5121] = {.lex_state = 0, .external_lex_state = 13},
  [5122] = {.lex_state = 226},
  [5123] = {.lex_state = 226},
  [5124] = {.lex_state = 226},
  [5125] = {.lex_state = 14},
  [5126] = {.lex_state = 226},
  [5127] = {.lex_state = 31},
  [5128] = {.lex_state = 31},
  [5129] = {.lex_state = 17},
  [5130] = {.lex_state = 19},
  [5131] = {.lex_state = 226},
  [5132] = {.lex_state = 226},
  [5133] = {.lex_state = 0},
  [5134] = {.lex_state = 14},
  [5135] = {.lex_state = 14},
  [5136] = {.lex_state = 226},
  [5137] = {.lex_state = 14},
  [5138] = {.lex_state = 226},
  [5139] = {.lex_state = 226},
  [5140] = {.lex_state = 226},
  [5141] = {.lex_state = 226},
  [5142] = {.lex_state = 14},
  [5143] = {.lex_state = 226},
  [5144] = {.lex_state = 0},
  [5145] = {.lex_state = 226},
  [5146] = {.lex_state = 0},
  [5147] = {.lex_state = 231},
  [5148] = {.lex_state = 14},
  [5149] = {.lex_state = 226},
  [5150] = {.lex_state = 31},
  [5151] = {.lex_state = 0, .external_lex_state = 18},
  [5152] = {.lex_state = 226},
  [5153] = {.lex_state = 0, .external_lex_state = 18},
  [5154] = {.lex_state = 226},
  [5155] = {.lex_state = 0, .external_lex_state = 13},
  [5156] = {.lex_state = 14},
  [5157] = {.lex_state = 17},
  [5158] = {.lex_state = 226},
  [5159] = {.lex_state = 226},
  [5160] = {.lex_state = 226},
  [5161] = {.lex_state = 19},
  [5162] = {.lex_state = 14},
  [5163] = {.lex_state = 226},
  [5164] = {.lex_state = 14},
  [5165] = {.lex_state = 226},
  [5166] = {.lex_state = 226},
  [5167] = {.lex_state = 226},
  [5168] = {.lex_state = 17},
  [5169] = {.lex_state = 0},
  [5170] = {.lex_state = 226},
  [5171] = {.lex_state = 226},
  [5172] = {.lex_state = 226},
  [5173] = {.lex_state = 14},
  [5174] = {.lex_state = 231},
  [5175] = {.lex_state = 0, .external_lex_state = 18},
  [5176] = {.lex_state = 19},
  [5177] = {.lex_state = 17},
  [5178] = {.lex_state = 19},
  [5179] = {.lex_state = 226},
  [5180] = {.lex_state = 226},
  [5181] = {.lex_state = 0, .external_lex_state = 13},
  [5182] = {.lex_state = 14},
  [5183] = {.lex_state = 14},
  [5184] = {.lex_state = 17},
  [5185] = {.lex_state = 0},
  [5186] = {.lex_state = 19},
  [5187] = {.lex_state = 14},
  [5188] = {.lex_state = 226},
  [5189] = {.lex_state = 226},
  [5190] = {.lex_state = 14},
  [5191] = {.lex_state = 231},
  [5192] = {.lex_state = 0},
  [5193] = {.lex_state = 14},
  [5194] = {.lex_state = 226},
  [5195] = {.lex_state = 231},
  [5196] = {.lex_state = 226},
  [5197] = {.lex_state = 226},
  [5198] = {.lex_state = 226},
  [5199] = {.lex_state = 226},
  [5200] = {.lex_state = 226},
  [5201] = {.lex_state = 231},
  [5202] = {.lex_state = 226},
  [5203] = {.lex_state = 14},
  [5204] = {.lex_state = 14},
  [5205] = {.lex_state = 0},
  [5206] = {.lex_state = 226},
  [5207] = {.lex_state = 226},
  [5208] = {.lex_state = 14},
  [5209] = {.lex_state = 226},
  [5210] = {.lex_state = 0, .external_lex_state = 18},
  [5211] = {.lex_state = 14},
  [5212] = {.lex_state = 226},
  [5213] = {.lex_state = 31},
  [5214] = {.lex_state = 0, .external_lex_state = 18},
  [5215] = {.lex_state = 226},
  [5216] = {.lex_state = 226},
  [5217] = {.lex_state = 0},
  [5218] = {.lex_state = 226},
  [5219] = {.lex_state = 226},
  [5220] = {.lex_state = 231},
  [5221] = {.lex_state = 226},
  [5222] = {.lex_state = 226},
  [5223] = {.lex_state = 226},
  [5224] = {.lex_state = 226},
  [5225] = {.lex_state = 0, .external_lex_state = 18},
  [5226] = {.lex_state = 226},
  [5227] = {.lex_state = 226},
  [5228] = {.lex_state = 0},
  [5229] = {.lex_state = 0, .external_lex_state = 18},
  [5230] = {.lex_state = 14},
  [5231] = {.lex_state = 14},
  [5232] = {.lex_state = 226},
  [5233] = {.lex_state = 226},
  [5234] = {.lex_state = 19},
  [5235] = {.lex_state = 0, .external_lex_state = 13},
  [5236] = {.lex_state = 14},
  [5237] = {.lex_state = 31},
  [5238] = {.lex_state = 0},
  [5239] = {.lex_state = 226},
  [5240] = {.lex_state = 226},
  [5241] = {.lex_state = 226},
  [5242] = {.lex_state = 226},
  [5243] = {.lex_state = 226},
  [5244] = {.lex_state = 226},
  [5245] = {.lex_state = 226},
  [5246] = {.lex_state = 226},
  [5247] = {.lex_state = 0},
  [5248] = {.lex_state = 226},
  [5249] = {.lex_state = 226},
  [5250] = {.lex_state = 226},
  [5251] = {.lex_state = 226},
  [5252] = {.lex_state = 226},
  [5253] = {.lex_state = 0, .external_lex_state = 18},
  [5254] = {.lex_state = 226},
  [5255] = {.lex_state = 14},
  [5256] = {.lex_state = 14},
  [5257] = {.lex_state = 226},
  [5258] = {.lex_state = 14},
  [5259] = {.lex_state = 14},
  [5260] = {.lex_state = 231},
  [5261] = {.lex_state = 14},
  [5262] = {.lex_state = 226},
  [5263] = {.lex_state = 226},
  [5264] = {.lex_state = 231},
  [5265] = {.lex_state = 226},
  [5266] = {.lex_state = 17},
  [5267] = {.lex_state = 226},
  [5268] = {.lex_state = 14},
  [5269] = {.lex_state = 226},
  [5270] = {.lex_state = 226},
  [5271] = {.lex_state = 17},
  [5272] = {.lex_state = 19},
  [5273] = {.lex_state = 19},
  [5274] = {.lex_state = 226},
  [5275] = {.lex_state = 226},
  [5276] = {.lex_state = 0},
  [5277] = {.lex_state = 541},
  [5278] = {.lex_state = 226},
  [5279] = {.lex_state = 14},
  [5280] = {.lex_state = 14},
  [5281] = {.lex_state = 14},
  [5282] = {.lex_state = 0, .external_lex_state = 13},
  [5283] = {.lex_state = 0, .external_lex_state = 13},
  [5284] = {.lex_state = 14},
  [5285] = {.lex_state = 226},
  [5286] = {.lex_state = 226},
  [5287] = {.lex_state = 226},
  [5288] = {.lex_state = 226},
  [5289] = {.lex_state = 226},
  [5290] = {.lex_state = 226},
  [5291] = {.lex_state = 31},
  [5292] = {.lex_state = 0},
  [5293] = {.lex_state = 0, .external_lex_state = 13},
  [5294] = {.lex_state = 14},
  [5295] = {.lex_state = 226},
  [5296] = {.lex_state = 0, .external_lex_state = 18},
  [5297] = {.lex_state = 14},
  [5298] = {.lex_state = 14},
  [5299] = {.lex_state = 226},
  [5300] = {.lex_state = 226},
  [5301] = {.lex_state = 0},
  [5302] = {.lex_state = 226},
  [5303] = {.lex_state = 226},
  [5304] = {.lex_state = 226},
  [5305] = {.lex_state = 14},
  [5306] = {.lex_state = 226},
  [5307] = {.lex_state = 226},
  [5308] = {.lex_state = 14},
  [5309] = {.lex_state = 31},
  [5310] = {.lex_state = 31},
  [5311] = {.lex_state = 0, .external_lex_state = 18},
  [5312] = {.lex_state = 226},
  [5313] = {.lex_state = 14},
  [5314] = {.lex_state = 226},
  [5315] = {.lex_state = 226},
  [5316] = {.lex_state = 226},
  [5317] = {.lex_state = 226},
  [5318] = {.lex_state = 226},
  [5319] = {.lex_state = 31},
  [5320] = {.lex_state = 226},
  [5321] = {.lex_state = 14},
  [5322] = {.lex_state = 226},
  [5323] = {.lex_state = 0, .external_lex_state = 13},
  [5324] = {.lex_state = 226},
  [5325] = {.lex_state = 231},
  [5326] = {.lex_state = 226},
  [5327] = {.lex_state = 0},
  [5328] = {.lex_state = 226},
  [5329] = {.lex_state = 226},
  [5330] = {.lex_state = 14},
  [5331] = {.lex_state = 0, .external_lex_state = 13},
  [5332] = {.lex_state = 226},
  [5333] = {.lex_state = 226},
  [5334] = {.lex_state = 14},
  [5335] = {.lex_state = 14},
  [5336] = {.lex_state = 31},
  [5337] = {.lex_state = 14},
  [5338] = {.lex_state = 14},
  [5339] = {.lex_state = 226},
  [5340] = {.lex_state = 226},
  [5341] = {.lex_state = 226},
  [5342] = {.lex_state = 226},
  [5343] = {.lex_state = 226},
  [5344] = {.lex_state = 226},
  [5345] = {.lex_state = 226},
  [5346] = {.lex_state = 14},
  [5347] = {.lex_state = 14},
  [5348] = {.lex_state = 0, .external_lex_state = 18},
  [5349] = {.lex_state = 226},
  [5350] = {.lex_state = 226},
  [5351] = {.lex_state = 226},
  [5352] = {.lex_state = 0},
  [5353] = {.lex_state = 226},
  [5354] = {.lex_state = 226},
  [5355] = {.lex_state = 14},
  [5356] = {.lex_state = 226},
  [5357] = {.lex_state = 0, .external_lex_state = 13},
  [5358] = {.lex_state = 14},
  [5359] = {.lex_state = 14},
  [5360] = {.lex_state = 226},
  [5361] = {.lex_state = 226},
  [5362] = {.lex_state = 226},
  [5363] = {.lex_state = 14},
  [5364] = {.lex_state = 226},
  [5365] = {.lex_state = 226},
  [5366] = {.lex_state = 226},
  [5367] = {.lex_state = 226},
  [5368] = {.lex_state = 31},
  [5369] = {.lex_state = 14},
  [5370] = {.lex_state = 14},
  [5371] = {.lex_state = 17},
  [5372] = {.lex_state = 226},
  [5373] = {.lex_state = 226},
  [5374] = {.lex_state = 17},
  [5375] = {.lex_state = 226},
  [5376] = {.lex_state = 231},
  [5377] = {.lex_state = 14},
  [5378] = {.lex_state = 226},
  [5379] = {.lex_state = 19},
  [5380] = {.lex_state = 226},
  [5381] = {.lex_state = 25},
  [5382] = {.lex_state = 226},
  [5383] = {.lex_state = 226},
  [5384] = {.lex_state = 226},
  [5385] = {.lex_state = 226},
  [5386] = {.lex_state = 226},
  [5387] = {.lex_state = 17},
  [5388] = {.lex_state = 14},
  [5389] = {.lex_state = 0},
  [5390] = {.lex_state = 0, .external_lex_state = 18},
  [5391] = {.lex_state = 19},
  [5392] = {.lex_state = 226},
  [5393] = {.lex_state = 19},
  [5394] = {.lex_state = 226},
  [5395] = {.lex_state = 226},
  [5396] = {.lex_state = 14},
  [5397] = {.lex_state = 226},
  [5398] = {.lex_state = 226},
  [5399] = {.lex_state = 226},
  [5400] = {.lex_state = 14},
  [5401] = {.lex_state = 14},
  [5402] = {.lex_state = 226},
  [5403] = {.lex_state = 14},
  [5404] = {.lex_state = 17},
  [5405] = {.lex_state = 226},
  [5406] = {.lex_state = 226},
  [5407] = {.lex_state = 0},
  [5408] = {.lex_state = 226},
  [5409] = {.lex_state = 19},
  [5410] = {.lex_state = 14},
  [5411] = {.lex_state = 0},
  [5412] = {.lex_state = 14},
  [5413] = {.lex_state = 226},
  [5414] = {.lex_state = 226},
  [5415] = {.lex_state = 17},
  [5416] = {.lex_state = 226},
  [5417] = {.lex_state = 226},
  [5418] = {.lex_state = 226},
  [5419] = {.lex_state = 226},
  [5420] = {.lex_state = 19},
  [5421] = {.lex_state = 226},
  [5422] = {.lex_state = 226},
  [5423] = {.lex_state = 0},
  [5424] = {.lex_state = 226},
  [5425] = {.lex_state = 231},
  [5426] = {.lex_state = 14},
  [5427] = {.lex_state = 226},
  [5428] = {.lex_state = 226},
  [5429] = {.lex_state = 0, .external_lex_state = 19},
  [5430] = {.lex_state = 226},
  [5431] = {.lex_state = 226},
  [5432] = {.lex_state = 14},
  [5433] = {.lex_state = 226},
  [5434] = {.lex_state = 14},
  [5435] = {.lex_state = 226},
  [5436] = {.lex_state = 226},
  [5437] = {.lex_state = 226},
  [5438] = {.lex_state = 226},
  [5439] = {.lex_state = 226},
  [5440] = {.lex_state = 226},
  [5441] = {.lex_state = 226},
  [5442] = {.lex_state = 0, .external_lex_state = 13},
  [5443] = {.lex_state = 0, .external_lex_state = 13},
  [5444] = {.lex_state = 226},
  [5445] = {.lex_state = 0, .external_lex_state = 13},
  [5446] = {.lex_state = 226},
  [5447] = {.lex_state = 31},
  [5448] = {.lex_state = 226},
  [5449] = {.lex_state = 226},
  [5450] = {.lex_state = 226},
  [5451] = {.lex_state = 226},
  [5452] = {.lex_state = 226},
  [5453] = {.lex_state = 226},
  [5454] = {.lex_state = 226},
  [5455] = {.lex_state = 226},
  [5456] = {.lex_state = 14},
  [5457] = {.lex_state = 0},
  [5458] = {.lex_state = 14},
  [5459] = {.lex_state = 31},
  [5460] = {.lex_state = 0},
  [5461] = {.lex_state = 0},
  [5462] = {.lex_state = 226},
  [5463] = {.lex_state = 17},
  [5464] = {.lex_state = 19},
  [5465] = {.lex_state = 14},
  [5466] = {.lex_state = 29},
  [5467] = {.lex_state = 226},
  [5468] = {.lex_state = 226},
  [5469] = {.lex_state = 0},
  [5470] = {.lex_state = 226},
  [5471] = {.lex_state = 226},
  [5472] = {.lex_state = 231},
  [5473] = {.lex_state = 14},
  [5474] = {.lex_state = 231},
  [5475] = {.lex_state = 226},
  [5476] = {.lex_state = 226},
  [5477] = {.lex_state = 14},
  [5478] = {.lex_state = 226},
  [5479] = {.lex_state = 226},
  [5480] = {.lex_state = 226},
  [5481] = {.lex_state = 0},
  [5482] = {.lex_state = 226},
  [5483] = {.lex_state = 0, .external_lex_state = 18},
  [5484] = {.lex_state = 226},
  [5485] = {.lex_state = 0, .external_lex_state = 13},
  [5486] = {.lex_state = 231},
  [5487] = {.lex_state = 0},
  [5488] = {.lex_state = 14},
  [5489] = {.lex_state = 0, .external_lex_state = 13},
  [5490] = {.lex_state = 31},
  [5491] = {.lex_state = 17},
  [5492] = {.lex_state = 31},
  [5493] = {.lex_state = 14},
  [5494] = {.lex_state = 226},
  [5495] = {.lex_state = 226},
  [5496] = {.lex_state = 0, .external_lex_state = 18},
  [5497] = {.lex_state = 226},
  [5498] = {.lex_state = 226},
  [5499] = {.lex_state = 226},
  [5500] = {.lex_state = 226},
  [5501] = {.lex_state = 226},
  [5502] = {.lex_state = 226},
  [5503] = {.lex_state = 0, .external_lex_state = 18},
  [5504] = {.lex_state = 14},
  [5505] = {.lex_state = 251},
  [5506] = {.lex_state = 226},
  [5507] = {.lex_state = 17},
  [5508] = {.lex_state = 19},
  [5509] = {.lex_state = 0},
  [5510] = {.lex_state = 226},
  [5511] = {.lex_state = 231},
  [5512] = {.lex_state = 0},
  [5513] = {.lex_state = 226},
  [5514] = {.lex_state = 0},
  [5515] = {.lex_state = 226},
  [5516] = {.lex_state = 14},
  [5517] = {.lex_state = 226},
  [5518] = {.lex_state = 226},
  [5519] = {.lex_state = 226},
  [5520] = {.lex_state = 0},
  [5521] = {.lex_state = 0},
  [5522] = {.lex_state = 226},
  [5523] = {.lex_state = 248},
  [5524] = {.lex_state = 226},
  [5525] = {.lex_state = 226},
  [5526] = {.lex_state = 226},
  [5527] = {.lex_state = 226},
  [5528] = {.lex_state = 226},
  [5529] = {.lex_state = 226},
  [5530] = {.lex_state = 226},
  [5531] = {.lex_state = 0, .external_lex_state = 13},
  [5532] = {.lex_state = 226},
  [5533] = {.lex_state = 0, .external_lex_state = 18},
  [5534] = {.lex_state = 226},
  [5535] = {.lex_state = 0, .external_lex_state = 13},
  [5536] = {.lex_state = 226},
  [5537] = {.lex_state = 14},
  [5538] = {.lex_state = 226},
  [5539] = {.lex_state = 14},
  [5540] = {.lex_state = 226},
  [5541] = {.lex_state = 0, .external_lex_state = 13},
  [5542] = {.lex_state = 226},
  [5543] = {.lex_state = 14},
  [5544] = {.lex_state = 226},
  [5545] = {.lex_state = 14},
  [5546] = {.lex_state = 226},
  [5547] = {.lex_state = 226},
  [5548] = {.lex_state = 226},
  [5549] = {.lex_state = 226},
  [5550] = {(TSStateId)(-1)},
  [5551] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_block_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [aux_sym_block_comment_text_token2] = ACTIONS(1),
    [aux_sym_block_comment_text_token3] = ACTIONS(1),
    [aux_sym_block_comment_text_token4] = ACTIONS(1),
    [anon_sym_MODULE] = ACTIONS(1),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_u225c] = ACTIONS(1),
    [anon_sym_BSLASHin] = ACTIONS(1),
    [anon_sym_u2208] = ACTIONS(1),
    [anon_sym_u27f5] = ACTIONS(1),
    [anon_sym_u2190] = ACTIONS(1),
    [anon_sym_BSLASHA] = ACTIONS(1),
    [anon_sym_BSLASHforall] = ACTIONS(1),
    [anon_sym_u2200] = ACTIONS(1),
    [anon_sym_BSLASHE] = ACTIONS(1),
    [anon_sym_BSLASHexists] = ACTIONS(1),
    [anon_sym_u2203] = ACTIONS(1),
    [sym_temporal_forall] = ACTIONS(1),
    [sym_temporal_exists] = ACTIONS(1),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(1),
    [anon_sym_u27fc] = ACTIONS(1),
    [anon_sym_u21a6] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_u27f6] = ACTIONS(1),
    [anon_sym_u2192] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_u3008] = ACTIONS(1),
    [anon_sym_u27e8] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_u3009] = ACTIONS(1),
    [anon_sym_u27e9] = ACTIONS(1),
    [anon_sym_GT_GT_] = ACTIONS(1),
    [anon_sym_u3009_] = ACTIONS(1),
    [anon_sym_u27e9_] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_u25a1] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_u2237] = ACTIONS(1),
    [sym_placeholder] = ACTIONS(1),
    [anon_sym_SLASH_BSLASH] = ACTIONS(1),
    [anon_sym_u2227] = ACTIONS(1),
    [anon_sym_BSLASH_SLASH] = ACTIONS(1),
    [anon_sym_u2228] = ACTIONS(1),
    [anon_sym_EXTENDS] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_LOCAL] = ACTIONS(1),
    [anon_sym_VARIABLE] = ACTIONS(1),
    [anon_sym_VARIABLES] = ACTIONS(1),
    [anon_sym_CONSTANT] = ACTIONS(1),
    [anon_sym_CONSTANTS] = ACTIONS(1),
    [anon_sym_RECURSIVE] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_INSTANCE] = ACTIONS(1),
    [anon_sym_WITH] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [aux_sym_child_id_token1] = ACTIONS(1),
    [anon_sym_LAMBDA] = ACTIONS(1),
    [anon_sym_BSLASHb] = ACTIONS(1),
    [anon_sym_BSLASHB] = ACTIONS(1),
    [aux_sym_binary_number_token1] = ACTIONS(1),
    [anon_sym_BSLASHo] = ACTIONS(1),
    [anon_sym_BSLASHO] = ACTIONS(1),
    [aux_sym_octal_number_token1] = ACTIONS(1),
    [anon_sym_BSLASHh] = ACTIONS(1),
    [anon_sym_BSLASHH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_TRUE] = ACTIONS(1),
    [anon_sym_FALSE] = ACTIONS(1),
    [sym_string_set] = ACTIONS(1),
    [sym_boolean_set] = ACTIONS(1),
    [anon_sym_Nat] = ACTIONS(1),
    [anon_sym_u2115] = ACTIONS(1),
    [anon_sym_Int] = ACTIONS(1),
    [anon_sym_u2124] = ACTIONS(1),
    [anon_sym_Real] = ACTIONS(1),
    [anon_sym_u211d] = ACTIONS(1),
    [anon_sym_CHOOSE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_EXCEPT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_WF_] = ACTIONS(1),
    [anon_sym_SF_] = ACTIONS(1),
    [anon_sym_IF] = ACTIONS(1),
    [anon_sym_THEN] = ACTIONS(1),
    [anon_sym_ELSE] = ACTIONS(1),
    [anon_sym_CASE] = ACTIONS(1),
    [anon_sym_OTHER] = ACTIONS(1),
    [anon_sym_LET] = ACTIONS(1),
    [anon_sym_IN] = ACTIONS(1),
    [anon_sym_BSLASHlnot] = ACTIONS(1),
    [anon_sym_BSLASHneg] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_u00ac] = ACTIONS(1),
    [sym_union] = ACTIONS(1),
    [sym_powerset] = ACTIONS(1),
    [sym_domain] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [sym_negative_dot] = ACTIONS(1),
    [sym_enabled] = ACTIONS(1),
    [sym_unchanged] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_u22c4] = ACTIONS(1),
    [anon_sym_u25c7] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_u27f9] = ACTIONS(1),
    [anon_sym_u21d2] = ACTIONS(1),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(1),
    [anon_sym_u21f8] = ACTIONS(1),
    [anon_sym_u2945] = ACTIONS(1),
    [anon_sym_BSLASHequiv] = ACTIONS(1),
    [anon_sym_u2261] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_u27fa] = ACTIONS(1),
    [anon_sym_u21d4] = ACTIONS(1),
    [anon_sym_TILDE_GT] = ACTIONS(1),
    [anon_sym_u21dd] = ACTIONS(1),
    [anon_sym_u219d] = ACTIONS(1),
    [anon_sym_BSLASHland] = ACTIONS(1),
    [anon_sym_BSLASHlor] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_u2254] = ACTIONS(1),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(1),
    [anon_sym_u2a74] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_u2260] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [sym_gt] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_LT] = ACTIONS(1),
    [anon_sym_BSLASHleq] = ACTIONS(1),
    [anon_sym_u2264] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_BSLASHgeq] = ACTIONS(1),
    [anon_sym_u2265] = ACTIONS(1),
    [anon_sym_BSLASHapprox] = ACTIONS(1),
    [anon_sym_u2248] = ACTIONS(1),
    [anon_sym_PIPE_DASH] = ACTIONS(1),
    [anon_sym_u22a2] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_u22a8] = ACTIONS(1),
    [anon_sym_DASH_PIPE] = ACTIONS(1),
    [anon_sym_u22a3] = ACTIONS(1),
    [anon_sym_EQ_PIPE] = ACTIONS(1),
    [anon_sym_u2ae4] = ACTIONS(1),
    [anon_sym_BSLASHasymp] = ACTIONS(1),
    [anon_sym_u224d] = ACTIONS(1),
    [anon_sym_BSLASHcong] = ACTIONS(1),
    [anon_sym_u2245] = ACTIONS(1),
    [anon_sym_BSLASHdoteq] = ACTIONS(1),
    [anon_sym_u2250] = ACTIONS(1),
    [anon_sym_BSLASHgg] = ACTIONS(1),
    [anon_sym_u226b] = ACTIONS(1),
    [anon_sym_BSLASHll] = ACTIONS(1),
    [anon_sym_u226a] = ACTIONS(1),
    [anon_sym_BSLASHnotin] = ACTIONS(1),
    [anon_sym_u2209] = ACTIONS(1),
    [anon_sym_BSLASHprec] = ACTIONS(1),
    [anon_sym_u227a] = ACTIONS(1),
    [anon_sym_BSLASHsucc] = ACTIONS(1),
    [anon_sym_u227b] = ACTIONS(1),
    [anon_sym_BSLASHpreceq] = ACTIONS(1),
    [anon_sym_u2aaf] = ACTIONS(1),
    [anon_sym_BSLASHsucceq] = ACTIONS(1),
    [anon_sym_u2ab0] = ACTIONS(1),
    [anon_sym_BSLASHpropto] = ACTIONS(1),
    [anon_sym_u221d] = ACTIONS(1),
    [anon_sym_BSLASHsim] = ACTIONS(1),
    [anon_sym_u223c] = ACTIONS(1),
    [anon_sym_BSLASHsimeq] = ACTIONS(1),
    [anon_sym_u2243] = ACTIONS(1),
    [anon_sym_BSLASHsqsubset] = ACTIONS(1),
    [anon_sym_u228f] = ACTIONS(1),
    [anon_sym_BSLASHsqsupset] = ACTIONS(1),
    [anon_sym_u2290] = ACTIONS(1),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(1),
    [anon_sym_u2291] = ACTIONS(1),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(1),
    [anon_sym_u2292] = ACTIONS(1),
    [anon_sym_BSLASHsubset] = ACTIONS(1),
    [anon_sym_u2282] = ACTIONS(1),
    [anon_sym_BSLASHsupset] = ACTIONS(1),
    [anon_sym_u2283] = ACTIONS(1),
    [anon_sym_BSLASHsubseteq] = ACTIONS(1),
    [anon_sym_u2286] = ACTIONS(1),
    [anon_sym_BSLASHsupseteq] = ACTIONS(1),
    [anon_sym_u2287] = ACTIONS(1),
    [sym_compose] = ACTIONS(1),
    [sym_map_to] = ACTIONS(1),
    [sym_map_from] = ACTIONS(1),
    [sym_setminus] = ACTIONS(1),
    [anon_sym_BSLASHcap] = ACTIONS(1),
    [anon_sym_BSLASHintersect] = ACTIONS(1),
    [anon_sym_u2229] = ACTIONS(1),
    [anon_sym_BSLASHcup] = ACTIONS(1),
    [anon_sym_BSLASHunion] = ACTIONS(1),
    [anon_sym_u222a] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_u2025] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_u2026] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [sym_plusplus] = ACTIONS(1),
    [anon_sym_BSLASHoplus] = ACTIONS(1),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(1),
    [anon_sym_u2295] = ACTIONS(1),
    [anon_sym_BSLASHominus] = ACTIONS(1),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(1),
    [anon_sym_u2296] = ACTIONS(1),
    [sym_mod] = ACTIONS(1),
    [sym_modmod] = ACTIONS(1),
    [sym_vert] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_u2016] = ACTIONS(1),
    [sym_minusminus] = ACTIONS(1),
    [sym_amp] = ACTIONS(1),
    [sym_ampamp] = ACTIONS(1),
    [anon_sym_BSLASHodot] = ACTIONS(1),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(1),
    [anon_sym_u2299] = ACTIONS(1),
    [anon_sym_BSLASHoslash] = ACTIONS(1),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(1),
    [anon_sym_u2298] = ACTIONS(1),
    [anon_sym_BSLASHotimes] = ACTIONS(1),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(1),
    [anon_sym_u2297] = ACTIONS(1),
    [sym_mul] = ACTIONS(1),
    [sym_mulmul] = ACTIONS(1),
    [sym_slash] = ACTIONS(1),
    [sym_slashslash] = ACTIONS(1),
    [anon_sym_BSLASHbigcirc] = ACTIONS(1),
    [anon_sym_u25ef] = ACTIONS(1),
    [anon_sym_BSLASHbullet] = ACTIONS(1),
    [anon_sym_u25cf] = ACTIONS(1),
    [anon_sym_BSLASHdiv] = ACTIONS(1),
    [anon_sym_u00f7] = ACTIONS(1),
    [anon_sym_BSLASHcirc] = ACTIONS(1),
    [anon_sym_u2218] = ACTIONS(1),
    [anon_sym_BSLASHstar] = ACTIONS(1),
    [anon_sym_u22c6] = ACTIONS(1),
    [anon_sym_u203c] = ACTIONS(1),
    [sym_hashhash] = ACTIONS(1),
    [sym_dol] = ACTIONS(1),
    [sym_doldol] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_u2047] = ACTIONS(1),
    [anon_sym_BSLASHsqcap] = ACTIONS(1),
    [anon_sym_u2293] = ACTIONS(1),
    [anon_sym_BSLASHsqcup] = ACTIONS(1),
    [anon_sym_u2294] = ACTIONS(1),
    [anon_sym_BSLASHuplus] = ACTIONS(1),
    [anon_sym_u228e] = ACTIONS(1),
    [anon_sym_BSLASHX] = ACTIONS(1),
    [anon_sym_BSLASHtimes] = ACTIONS(1),
    [anon_sym_u00d7] = ACTIONS(1),
    [anon_sym_BSLASHwr] = ACTIONS(1),
    [anon_sym_u2240] = ACTIONS(1),
    [anon_sym_BSLASHcdot] = ACTIONS(1),
    [anon_sym_u22c5] = ACTIONS(1),
    [sym_pow] = ACTIONS(1),
    [sym_powpow] = ACTIONS(1),
    [anon_sym_CARET_PLUS] = ACTIONS(1),
    [anon_sym_u207a] = ACTIONS(1),
    [sym_asterisk] = ACTIONS(1),
    [sym_sup_hash] = ACTIONS(1),
    [sym_prime] = ACTIONS(1),
    [anon_sym_ASSUME] = ACTIONS(1),
    [anon_sym_ASSUMPTION] = ACTIONS(1),
    [anon_sym_AXIOM] = ACTIONS(1),
    [anon_sym_THEOREM] = ACTIONS(1),
    [anon_sym_PROPOSITION] = ACTIONS(1),
    [anon_sym_LEMMA] = ACTIONS(1),
    [anon_sym_COROLLARY] = ACTIONS(1),
    [anon_sym_PROVE] = ACTIONS(1),
    [anon_sym_NEW] = ACTIONS(1),
    [anon_sym_STATE] = ACTIONS(1),
    [anon_sym_ACTION] = ACTIONS(1),
    [anon_sym_TEMPORAL] = ACTIONS(1),
    [anon_sym_PROOF] = ACTIONS(1),
    [anon_sym_BY] = ACTIONS(1),
    [anon_sym_ONLY] = ACTIONS(1),
    [anon_sym_OBVIOUS] = ACTIONS(1),
    [anon_sym_OMITTED] = ACTIONS(1),
    [anon_sym_DEFINE] = ACTIONS(1),
    [anon_sym_HAVE] = ACTIONS(1),
    [anon_sym_WITNESS] = ACTIONS(1),
    [anon_sym_TAKE] = ACTIONS(1),
    [anon_sym_SUFFICES] = ACTIONS(1),
    [anon_sym_PICK] = ACTIONS(1),
    [anon_sym_QED] = ACTIONS(1),
    [anon_sym_USE] = ACTIONS(1),
    [anon_sym_HIDE] = ACTIONS(1),
    [anon_sym_DEF] = ACTIONS(1),
    [anon_sym_DEFS] = ACTIONS(1),
    [aux_sym_proof_step_id_token1] = ACTIONS(1),
    [aux_sym_proof_step_ref_token1] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_algorithm] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_define] = ACTIONS(1),
    [anon_sym_macro] = ACTIONS(1),
    [anon_sym_procedure] = ACTIONS(1),
    [anon_sym_fair] = ACTIONS(1),
    [anon_sym_process] = ACTIONS(1),
    [anon_sym_variable] = ACTIONS(1),
    [anon_sym_variables] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_elsif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_either] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [sym_pcal_skip] = ACTIONS(1),
    [sym_pcal_return] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_call] = ACTIONS(1),
    [sym_leading_extramodular_text] = ACTIONS(1),
    [sym_trailing_extramodular_text] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__bullet] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym__begin_proof] = ACTIONS(1),
    [sym__begin_proof_step] = ACTIONS(1),
    [sym__notify_pcal_algorithm_start] = ACTIONS(1),
    [sym__notify_pcal_algorithm_end] = ACTIONS(1),
    [sym__double_excl] = ACTIONS(1),
    [sym__error_sentinel] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(5411),
    [sym_block_comment] = STATE(1),
    [sym_module] = STATE(3591),
    [sym_single_line] = STATE(3592),
    [sym_extends] = STATE(3424),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4382),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5171),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [sym_pcal_algorithm] = STATE(5205),
    [sym__pcal_p_algorithm] = STATE(5487),
    [sym__pcal_c_algorithm] = STATE(5457),
    [sym_pcal_algorithm_start] = STATE(5478),
    [sym_fair] = STATE(5092),
    [aux_sym_source_file_repeat1] = STATE(4179),
    [aux_sym_source_file_repeat2] = STATE(3422),
    [sym_identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(9),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_EXTENDS] = ACTIONS(13),
    [anon_sym_LOCAL] = ACTIONS(15),
    [anon_sym_VARIABLE] = ACTIONS(17),
    [anon_sym_VARIABLES] = ACTIONS(17),
    [anon_sym_CONSTANT] = ACTIONS(19),
    [anon_sym_CONSTANTS] = ACTIONS(19),
    [anon_sym_RECURSIVE] = ACTIONS(21),
    [anon_sym_INSTANCE] = ACTIONS(23),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_ASSUME] = ACTIONS(45),
    [anon_sym_ASSUMPTION] = ACTIONS(45),
    [anon_sym_AXIOM] = ACTIONS(45),
    [anon_sym_THEOREM] = ACTIONS(47),
    [anon_sym_PROPOSITION] = ACTIONS(47),
    [anon_sym_LEMMA] = ACTIONS(47),
    [anon_sym_COROLLARY] = ACTIONS(47),
    [anon_sym_USE] = ACTIONS(49),
    [anon_sym_HIDE] = ACTIONS(49),
    [anon_sym_DASH_DASHalgorithm] = ACTIONS(51),
    [anon_sym_DASH_DASHfair] = ACTIONS(53),
    [sym_leading_extramodular_text] = ACTIONS(55),
  },
  [2] = {
    [sym_block_comment] = STATE(2),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_operator_definition] = STATE(3862),
    [sym_function_definition] = STATE(3862),
    [sym_instance] = STATE(5485),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym_module_definition] = STATE(3862),
    [sym__expr] = STATE(1547),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(2901),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(2936),
    [sym_int_number_set] = STATE(2936),
    [sym_real_number_set] = STATE(2936),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(261),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(260),
    [sym_eventually] = STATE(260),
    [sym_prefix_op_symbol] = STATE(4922),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_assume_prove] = STATE(3944),
    [sym_definition_proof_step] = STATE(5485),
    [sym_have_proof_step] = STATE(5485),
    [sym_witness_proof_step] = STATE(5485),
    [sym_take_proof_step] = STATE(5485),
    [sym_suffices_proof_step] = STATE(5485),
    [sym_case_proof_step] = STATE(5485),
    [sym_pick_proof_step] = STATE(5485),
    [sym_use_or_hide] = STATE(5485),
    [sym_proof_step_ref] = STATE(2968),
    [aux_sym_definition_proof_step_repeat1] = STATE(3638),
    [sym_identifier] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [anon_sym_INSTANCE] = ACTIONS(87),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(109),
    [anon_sym_u2115] = ACTIONS(111),
    [anon_sym_Int] = ACTIONS(113),
    [anon_sym_u2124] = ACTIONS(115),
    [anon_sym_Real] = ACTIONS(117),
    [anon_sym_u211d] = ACTIONS(119),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(131),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(139),
    [sym_powerset] = ACTIONS(139),
    [sym_domain] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(143),
    [sym_unchanged] = ACTIONS(143),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(297),
    [anon_sym_DEFINE] = ACTIONS(299),
    [anon_sym_HAVE] = ACTIONS(301),
    [anon_sym_WITNESS] = ACTIONS(303),
    [anon_sym_TAKE] = ACTIONS(305),
    [anon_sym_SUFFICES] = ACTIONS(307),
    [anon_sym_PICK] = ACTIONS(309),
    [anon_sym_QED] = ACTIONS(311),
    [anon_sym_USE] = ACTIONS(313),
    [anon_sym_HIDE] = ACTIONS(313),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [3] = {
    [sym_block_comment] = STATE(3),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_operator_definition] = STATE(3862),
    [sym_function_definition] = STATE(3862),
    [sym_instance] = STATE(5485),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym_module_definition] = STATE(3862),
    [sym__expr] = STATE(1547),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(2901),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(2936),
    [sym_int_number_set] = STATE(2936),
    [sym_real_number_set] = STATE(2936),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(261),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(260),
    [sym_eventually] = STATE(260),
    [sym_prefix_op_symbol] = STATE(4922),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_assume_prove] = STATE(3944),
    [sym_definition_proof_step] = STATE(5485),
    [sym_have_proof_step] = STATE(5485),
    [sym_witness_proof_step] = STATE(5485),
    [sym_take_proof_step] = STATE(5485),
    [sym_suffices_proof_step] = STATE(5485),
    [sym_case_proof_step] = STATE(5485),
    [sym_pick_proof_step] = STATE(5485),
    [sym_use_or_hide] = STATE(5485),
    [sym_proof_step_ref] = STATE(2968),
    [aux_sym_definition_proof_step_repeat1] = STATE(3638),
    [sym_identifier] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [anon_sym_INSTANCE] = ACTIONS(87),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(109),
    [anon_sym_u2115] = ACTIONS(111),
    [anon_sym_Int] = ACTIONS(113),
    [anon_sym_u2124] = ACTIONS(115),
    [anon_sym_Real] = ACTIONS(117),
    [anon_sym_u211d] = ACTIONS(119),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(131),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(139),
    [sym_powerset] = ACTIONS(139),
    [sym_domain] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(143),
    [sym_unchanged] = ACTIONS(143),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(297),
    [anon_sym_DEFINE] = ACTIONS(299),
    [anon_sym_HAVE] = ACTIONS(301),
    [anon_sym_WITNESS] = ACTIONS(303),
    [anon_sym_TAKE] = ACTIONS(305),
    [anon_sym_SUFFICES] = ACTIONS(307),
    [anon_sym_PICK] = ACTIONS(309),
    [anon_sym_QED] = ACTIONS(317),
    [anon_sym_USE] = ACTIONS(313),
    [anon_sym_HIDE] = ACTIONS(313),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [4] = {
    [sym_block_comment] = STATE(4),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_operator_definition] = STATE(3862),
    [sym_function_definition] = STATE(3862),
    [sym_instance] = STATE(5485),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym_module_definition] = STATE(3862),
    [sym__expr] = STATE(1547),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(2901),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(2936),
    [sym_int_number_set] = STATE(2936),
    [sym_real_number_set] = STATE(2936),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(261),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(260),
    [sym_eventually] = STATE(260),
    [sym_prefix_op_symbol] = STATE(4922),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_assume_prove] = STATE(3944),
    [sym_definition_proof_step] = STATE(5485),
    [sym_have_proof_step] = STATE(5485),
    [sym_witness_proof_step] = STATE(5485),
    [sym_take_proof_step] = STATE(5485),
    [sym_suffices_proof_step] = STATE(5485),
    [sym_case_proof_step] = STATE(5485),
    [sym_pick_proof_step] = STATE(5485),
    [sym_use_or_hide] = STATE(5485),
    [sym_proof_step_ref] = STATE(2968),
    [aux_sym_definition_proof_step_repeat1] = STATE(3638),
    [sym_identifier] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [anon_sym_INSTANCE] = ACTIONS(87),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(109),
    [anon_sym_u2115] = ACTIONS(111),
    [anon_sym_Int] = ACTIONS(113),
    [anon_sym_u2124] = ACTIONS(115),
    [anon_sym_Real] = ACTIONS(117),
    [anon_sym_u211d] = ACTIONS(119),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(131),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(139),
    [sym_powerset] = ACTIONS(139),
    [sym_domain] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(143),
    [sym_unchanged] = ACTIONS(143),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(297),
    [anon_sym_DEFINE] = ACTIONS(299),
    [anon_sym_HAVE] = ACTIONS(301),
    [anon_sym_WITNESS] = ACTIONS(303),
    [anon_sym_TAKE] = ACTIONS(305),
    [anon_sym_SUFFICES] = ACTIONS(307),
    [anon_sym_PICK] = ACTIONS(309),
    [anon_sym_QED] = ACTIONS(319),
    [anon_sym_USE] = ACTIONS(313),
    [anon_sym_HIDE] = ACTIONS(313),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [5] = {
    [sym_block_comment] = STATE(5),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_operator_definition] = STATE(3862),
    [sym_function_definition] = STATE(3862),
    [sym_instance] = STATE(5485),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym_module_definition] = STATE(3862),
    [sym__expr] = STATE(1547),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(2901),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(2936),
    [sym_int_number_set] = STATE(2936),
    [sym_real_number_set] = STATE(2936),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(261),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(260),
    [sym_eventually] = STATE(260),
    [sym_prefix_op_symbol] = STATE(4922),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_assume_prove] = STATE(3944),
    [sym_definition_proof_step] = STATE(5485),
    [sym_have_proof_step] = STATE(5485),
    [sym_witness_proof_step] = STATE(5485),
    [sym_take_proof_step] = STATE(5485),
    [sym_suffices_proof_step] = STATE(5485),
    [sym_case_proof_step] = STATE(5485),
    [sym_pick_proof_step] = STATE(5485),
    [sym_use_or_hide] = STATE(5485),
    [sym_proof_step_ref] = STATE(2968),
    [aux_sym_definition_proof_step_repeat1] = STATE(3638),
    [sym_identifier] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [anon_sym_INSTANCE] = ACTIONS(87),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(109),
    [anon_sym_u2115] = ACTIONS(111),
    [anon_sym_Int] = ACTIONS(113),
    [anon_sym_u2124] = ACTIONS(115),
    [anon_sym_Real] = ACTIONS(117),
    [anon_sym_u211d] = ACTIONS(119),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(131),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(139),
    [sym_powerset] = ACTIONS(139),
    [sym_domain] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(143),
    [sym_unchanged] = ACTIONS(143),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(297),
    [anon_sym_DEFINE] = ACTIONS(299),
    [anon_sym_HAVE] = ACTIONS(301),
    [anon_sym_WITNESS] = ACTIONS(303),
    [anon_sym_TAKE] = ACTIONS(305),
    [anon_sym_SUFFICES] = ACTIONS(307),
    [anon_sym_PICK] = ACTIONS(309),
    [anon_sym_USE] = ACTIONS(313),
    [anon_sym_HIDE] = ACTIONS(313),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [6] = {
    [sym_block_comment] = STATE(6),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1258),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(324),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(324),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LOCAL] = ACTIONS(333),
    [anon_sym_VARIABLE] = ACTIONS(333),
    [anon_sym_VARIABLES] = ACTIONS(333),
    [anon_sym_CONSTANT] = ACTIONS(333),
    [anon_sym_CONSTANTS] = ACTIONS(333),
    [anon_sym_RECURSIVE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(338),
    [anon_sym_INSTANCE] = ACTIONS(333),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(360),
    [anon_sym_u2115] = ACTIONS(363),
    [anon_sym_Int] = ACTIONS(366),
    [anon_sym_u2124] = ACTIONS(369),
    [anon_sym_Real] = ACTIONS(372),
    [anon_sym_u211d] = ACTIONS(375),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(396),
    [sym_powerset] = ACTIONS(396),
    [sym_domain] = ACTIONS(396),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(402),
    [sym_unchanged] = ACTIONS(402),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(167),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(333),
    [anon_sym_ASSUMPTION] = ACTIONS(333),
    [anon_sym_AXIOM] = ACTIONS(333),
    [anon_sym_THEOREM] = ACTIONS(333),
    [anon_sym_PROPOSITION] = ACTIONS(333),
    [anon_sym_LEMMA] = ACTIONS(333),
    [anon_sym_COROLLARY] = ACTIONS(333),
    [anon_sym_USE] = ACTIONS(333),
    [anon_sym_HIDE] = ACTIONS(333),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [7] = {
    [sym_block_comment] = STATE(7),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1260),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(324),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(324),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LOCAL] = ACTIONS(333),
    [anon_sym_VARIABLE] = ACTIONS(333),
    [anon_sym_VARIABLES] = ACTIONS(333),
    [anon_sym_CONSTANT] = ACTIONS(333),
    [anon_sym_CONSTANTS] = ACTIONS(333),
    [anon_sym_RECURSIVE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(338),
    [anon_sym_INSTANCE] = ACTIONS(333),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(360),
    [anon_sym_u2115] = ACTIONS(363),
    [anon_sym_Int] = ACTIONS(366),
    [anon_sym_u2124] = ACTIONS(369),
    [anon_sym_Real] = ACTIONS(372),
    [anon_sym_u211d] = ACTIONS(375),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(396),
    [sym_powerset] = ACTIONS(396),
    [sym_domain] = ACTIONS(396),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(402),
    [sym_unchanged] = ACTIONS(402),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(167),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(333),
    [anon_sym_ASSUMPTION] = ACTIONS(333),
    [anon_sym_AXIOM] = ACTIONS(333),
    [anon_sym_THEOREM] = ACTIONS(333),
    [anon_sym_PROPOSITION] = ACTIONS(333),
    [anon_sym_LEMMA] = ACTIONS(333),
    [anon_sym_COROLLARY] = ACTIONS(333),
    [anon_sym_USE] = ACTIONS(333),
    [anon_sym_HIDE] = ACTIONS(333),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [8] = {
    [sym_block_comment] = STATE(8),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1240),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [ts_builtin_sym_end] = ACTIONS(324),
    [sym_identifier] = ACTIONS(412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(324),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LOCAL] = ACTIONS(333),
    [anon_sym_VARIABLE] = ACTIONS(333),
    [anon_sym_VARIABLES] = ACTIONS(333),
    [anon_sym_CONSTANT] = ACTIONS(333),
    [anon_sym_CONSTANTS] = ACTIONS(333),
    [anon_sym_RECURSIVE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(422),
    [anon_sym_INSTANCE] = ACTIONS(333),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(444),
    [anon_sym_u2115] = ACTIONS(447),
    [anon_sym_Int] = ACTIONS(450),
    [anon_sym_u2124] = ACTIONS(453),
    [anon_sym_Real] = ACTIONS(456),
    [anon_sym_u211d] = ACTIONS(459),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(474),
    [sym_powerset] = ACTIONS(474),
    [sym_domain] = ACTIONS(474),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(477),
    [sym_unchanged] = ACTIONS(477),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(167),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(333),
    [anon_sym_ASSUMPTION] = ACTIONS(333),
    [anon_sym_AXIOM] = ACTIONS(333),
    [anon_sym_THEOREM] = ACTIONS(333),
    [anon_sym_PROPOSITION] = ACTIONS(333),
    [anon_sym_LEMMA] = ACTIONS(333),
    [anon_sym_COROLLARY] = ACTIONS(333),
    [anon_sym_USE] = ACTIONS(333),
    [anon_sym_HIDE] = ACTIONS(333),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [9] = {
    [sym_block_comment] = STATE(9),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1281),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(324),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(324),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LOCAL] = ACTIONS(333),
    [anon_sym_VARIABLE] = ACTIONS(333),
    [anon_sym_VARIABLES] = ACTIONS(333),
    [anon_sym_CONSTANT] = ACTIONS(333),
    [anon_sym_CONSTANTS] = ACTIONS(333),
    [anon_sym_RECURSIVE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(338),
    [anon_sym_INSTANCE] = ACTIONS(333),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(360),
    [anon_sym_u2115] = ACTIONS(363),
    [anon_sym_Int] = ACTIONS(366),
    [anon_sym_u2124] = ACTIONS(369),
    [anon_sym_Real] = ACTIONS(372),
    [anon_sym_u211d] = ACTIONS(375),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(396),
    [sym_powerset] = ACTIONS(396),
    [sym_domain] = ACTIONS(396),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(402),
    [sym_unchanged] = ACTIONS(402),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(167),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(333),
    [anon_sym_ASSUMPTION] = ACTIONS(333),
    [anon_sym_AXIOM] = ACTIONS(333),
    [anon_sym_THEOREM] = ACTIONS(333),
    [anon_sym_PROPOSITION] = ACTIONS(333),
    [anon_sym_LEMMA] = ACTIONS(333),
    [anon_sym_COROLLARY] = ACTIONS(333),
    [anon_sym_USE] = ACTIONS(333),
    [anon_sym_HIDE] = ACTIONS(333),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [10] = {
    [sym_block_comment] = STATE(10),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1262),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [ts_builtin_sym_end] = ACTIONS(324),
    [sym_identifier] = ACTIONS(412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(324),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LOCAL] = ACTIONS(333),
    [anon_sym_VARIABLE] = ACTIONS(333),
    [anon_sym_VARIABLES] = ACTIONS(333),
    [anon_sym_CONSTANT] = ACTIONS(333),
    [anon_sym_CONSTANTS] = ACTIONS(333),
    [anon_sym_RECURSIVE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(422),
    [anon_sym_INSTANCE] = ACTIONS(333),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(444),
    [anon_sym_u2115] = ACTIONS(447),
    [anon_sym_Int] = ACTIONS(450),
    [anon_sym_u2124] = ACTIONS(453),
    [anon_sym_Real] = ACTIONS(456),
    [anon_sym_u211d] = ACTIONS(459),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(474),
    [sym_powerset] = ACTIONS(474),
    [sym_domain] = ACTIONS(474),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(477),
    [sym_unchanged] = ACTIONS(477),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(167),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(333),
    [anon_sym_ASSUMPTION] = ACTIONS(333),
    [anon_sym_AXIOM] = ACTIONS(333),
    [anon_sym_THEOREM] = ACTIONS(333),
    [anon_sym_PROPOSITION] = ACTIONS(333),
    [anon_sym_LEMMA] = ACTIONS(333),
    [anon_sym_COROLLARY] = ACTIONS(333),
    [anon_sym_USE] = ACTIONS(333),
    [anon_sym_HIDE] = ACTIONS(333),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [11] = {
    [sym_block_comment] = STATE(11),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1268),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [ts_builtin_sym_end] = ACTIONS(324),
    [sym_identifier] = ACTIONS(412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(324),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LOCAL] = ACTIONS(333),
    [anon_sym_VARIABLE] = ACTIONS(333),
    [anon_sym_VARIABLES] = ACTIONS(333),
    [anon_sym_CONSTANT] = ACTIONS(333),
    [anon_sym_CONSTANTS] = ACTIONS(333),
    [anon_sym_RECURSIVE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(422),
    [anon_sym_INSTANCE] = ACTIONS(333),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(444),
    [anon_sym_u2115] = ACTIONS(447),
    [anon_sym_Int] = ACTIONS(450),
    [anon_sym_u2124] = ACTIONS(453),
    [anon_sym_Real] = ACTIONS(456),
    [anon_sym_u211d] = ACTIONS(459),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(474),
    [sym_powerset] = ACTIONS(474),
    [sym_domain] = ACTIONS(474),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(477),
    [sym_unchanged] = ACTIONS(477),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(167),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(333),
    [anon_sym_ASSUMPTION] = ACTIONS(333),
    [anon_sym_AXIOM] = ACTIONS(333),
    [anon_sym_THEOREM] = ACTIONS(333),
    [anon_sym_PROPOSITION] = ACTIONS(333),
    [anon_sym_LEMMA] = ACTIONS(333),
    [anon_sym_COROLLARY] = ACTIONS(333),
    [anon_sym_USE] = ACTIONS(333),
    [anon_sym_HIDE] = ACTIONS(333),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [12] = {
    [sym_block_comment] = STATE(12),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1888),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_assume_prove] = STATE(4973),
    [sym_inner_assume_prove] = STATE(5014),
    [sym_new] = STATE(5014),
    [sym_statement_level] = STATE(3875),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_VARIABLE] = ACTIONS(490),
    [anon_sym_CONSTANT] = ACTIONS(490),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(546),
    [anon_sym_NEW] = ACTIONS(548),
    [anon_sym_STATE] = ACTIONS(490),
    [anon_sym_ACTION] = ACTIONS(490),
    [anon_sym_TEMPORAL] = ACTIONS(490),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [13] = {
    [sym_block_comment] = STATE(13),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1854),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_assume_prove] = STATE(4973),
    [sym_inner_assume_prove] = STATE(4713),
    [sym_new] = STATE(4713),
    [sym_statement_level] = STATE(3875),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_VARIABLE] = ACTIONS(490),
    [anon_sym_CONSTANT] = ACTIONS(490),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(546),
    [anon_sym_NEW] = ACTIONS(548),
    [anon_sym_STATE] = ACTIONS(490),
    [anon_sym_ACTION] = ACTIONS(490),
    [anon_sym_TEMPORAL] = ACTIONS(490),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [14] = {
    [sym_block_comment] = STATE(14),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1848),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_assume_prove] = STATE(4973),
    [sym_inner_assume_prove] = STATE(4610),
    [sym_new] = STATE(4610),
    [sym_statement_level] = STATE(3875),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_VARIABLE] = ACTIONS(490),
    [anon_sym_CONSTANT] = ACTIONS(490),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(546),
    [anon_sym_NEW] = ACTIONS(548),
    [anon_sym_STATE] = ACTIONS(490),
    [anon_sym_ACTION] = ACTIONS(490),
    [anon_sym_TEMPORAL] = ACTIONS(490),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [15] = {
    [sym_block_comment] = STATE(15),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1849),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_assume_prove] = STATE(4973),
    [sym_inner_assume_prove] = STATE(4627),
    [sym_new] = STATE(4627),
    [sym_statement_level] = STATE(3875),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_VARIABLE] = ACTIONS(490),
    [anon_sym_CONSTANT] = ACTIONS(490),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(546),
    [anon_sym_NEW] = ACTIONS(548),
    [anon_sym_STATE] = ACTIONS(490),
    [anon_sym_ACTION] = ACTIONS(490),
    [anon_sym_TEMPORAL] = ACTIONS(490),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [16] = {
    [sym_block_comment] = STATE(16),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1847),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_assume_prove] = STATE(4973),
    [sym_inner_assume_prove] = STATE(4580),
    [sym_new] = STATE(4580),
    [sym_statement_level] = STATE(3875),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_VARIABLE] = ACTIONS(490),
    [anon_sym_CONSTANT] = ACTIONS(490),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(546),
    [anon_sym_NEW] = ACTIONS(548),
    [anon_sym_STATE] = ACTIONS(490),
    [anon_sym_ACTION] = ACTIONS(490),
    [anon_sym_TEMPORAL] = ACTIONS(490),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [17] = {
    [sym_block_comment] = STATE(17),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1222),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_use_body] = STATE(3581),
    [sym_use_body_expr] = STATE(3533),
    [sym_use_body_def] = STATE(3587),
    [sym_module_ref] = STATE(3507),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ONLY] = ACTIONS(574),
    [anon_sym_DEF] = ACTIONS(576),
    [anon_sym_DEFS] = ACTIONS(576),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [18] = {
    [sym_block_comment] = STATE(18),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1223),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_use_body] = STATE(3590),
    [sym_use_body_expr] = STATE(3538),
    [sym_use_body_def] = STATE(3587),
    [sym_module_ref] = STATE(3505),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ONLY] = ACTIONS(598),
    [anon_sym_DEF] = ACTIONS(600),
    [anon_sym_DEFS] = ACTIONS(600),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [19] = {
    [sym_block_comment] = STATE(19),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1223),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_use_body] = STATE(3581),
    [sym_use_body_expr] = STATE(3538),
    [sym_use_body_def] = STATE(3587),
    [sym_module_ref] = STATE(3505),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ONLY] = ACTIONS(602),
    [anon_sym_DEF] = ACTIONS(600),
    [anon_sym_DEFS] = ACTIONS(600),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [20] = {
    [sym_block_comment] = STATE(20),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1753),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_use_body] = STATE(5331),
    [sym_use_body_expr] = STATE(4374),
    [sym_use_body_def] = STATE(5535),
    [sym_module_ref] = STATE(4195),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(606),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ONLY] = ACTIONS(666),
    [anon_sym_DEF] = ACTIONS(668),
    [anon_sym_DEFS] = ACTIONS(668),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [21] = {
    [sym_block_comment] = STATE(21),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1222),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_use_body] = STATE(3590),
    [sym_use_body_expr] = STATE(3533),
    [sym_use_body_def] = STATE(3587),
    [sym_module_ref] = STATE(3507),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ONLY] = ACTIONS(672),
    [anon_sym_DEF] = ACTIONS(576),
    [anon_sym_DEFS] = ACTIONS(576),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [22] = {
    [sym_block_comment] = STATE(22),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1753),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_use_body] = STATE(5445),
    [sym_use_body_expr] = STATE(4374),
    [sym_use_body_def] = STATE(5535),
    [sym_module_ref] = STATE(4195),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(606),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ONLY] = ACTIONS(674),
    [anon_sym_DEF] = ACTIONS(668),
    [anon_sym_DEFS] = ACTIONS(668),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [23] = {
    [sym_block_comment] = STATE(23),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1223),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_use_body] = STATE(3581),
    [sym_use_body_expr] = STATE(3538),
    [sym_use_body_def] = STATE(3587),
    [sym_module_ref] = STATE(3505),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_DEF] = ACTIONS(600),
    [anon_sym_DEFS] = ACTIONS(600),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [24] = {
    [sym_block_comment] = STATE(24),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1753),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_use_body] = STATE(5331),
    [sym_use_body_expr] = STATE(4374),
    [sym_use_body_def] = STATE(5535),
    [sym_module_ref] = STATE(4195),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(606),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_DEF] = ACTIONS(668),
    [anon_sym_DEFS] = ACTIONS(668),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [25] = {
    [sym_block_comment] = STATE(25),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1753),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_use_body] = STATE(5121),
    [sym_use_body_expr] = STATE(4374),
    [sym_use_body_def] = STATE(5535),
    [sym_module_ref] = STATE(4195),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(606),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_DEF] = ACTIONS(668),
    [anon_sym_DEFS] = ACTIONS(668),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [26] = {
    [sym_block_comment] = STATE(26),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_operator_declaration] = STATE(3530),
    [sym__id_or_op_declaration] = STATE(4640),
    [sym__op_or_expr] = STATE(4901),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4230),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [sym_placeholder] = ACTIONS(678),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(682),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [27] = {
    [sym_block_comment] = STATE(27),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1223),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_use_body] = STATE(3585),
    [sym_use_body_expr] = STATE(3538),
    [sym_use_body_def] = STATE(3587),
    [sym_module_ref] = STATE(3505),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_DEF] = ACTIONS(600),
    [anon_sym_DEFS] = ACTIONS(600),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [28] = {
    [sym_block_comment] = STATE(28),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1753),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_use_body] = STATE(5531),
    [sym_use_body_expr] = STATE(4374),
    [sym_use_body_def] = STATE(5535),
    [sym_module_ref] = STATE(4195),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(606),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_DEF] = ACTIONS(668),
    [anon_sym_DEFS] = ACTIONS(668),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [29] = {
    [sym_block_comment] = STATE(29),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1222),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_use_body] = STATE(3585),
    [sym_use_body_expr] = STATE(3533),
    [sym_use_body_def] = STATE(3587),
    [sym_module_ref] = STATE(3507),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_DEF] = ACTIONS(576),
    [anon_sym_DEFS] = ACTIONS(576),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [30] = {
    [sym_block_comment] = STATE(30),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1223),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_use_body] = STATE(3594),
    [sym_use_body_expr] = STATE(3538),
    [sym_use_body_def] = STATE(3587),
    [sym_module_ref] = STATE(3505),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_DEF] = ACTIONS(600),
    [anon_sym_DEFS] = ACTIONS(600),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [31] = {
    [sym_block_comment] = STATE(31),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1222),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_use_body] = STATE(3581),
    [sym_use_body_expr] = STATE(3533),
    [sym_use_body_def] = STATE(3587),
    [sym_module_ref] = STATE(3507),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_DEF] = ACTIONS(576),
    [anon_sym_DEFS] = ACTIONS(576),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [32] = {
    [sym_block_comment] = STATE(32),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1222),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_use_body] = STATE(3594),
    [sym_use_body_expr] = STATE(3533),
    [sym_use_body_def] = STATE(3587),
    [sym_module_ref] = STATE(3507),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_DEF] = ACTIONS(576),
    [anon_sym_DEFS] = ACTIONS(576),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [33] = {
    [sym_block_comment] = STATE(33),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym__op_or_expr] = STATE(4649),
    [sym__op] = STATE(3843),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym_lambda] = STATE(3844),
    [sym__expr] = STATE(1891),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(183),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(182),
    [sym_eventually] = STATE(182),
    [sym_prefix_op_symbol] = STATE(4410),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3799),
    [sym_plus_arrow] = STATE(3799),
    [sym_equiv] = STATE(3799),
    [sym_iff] = STATE(3799),
    [sym_leads_to] = STATE(3799),
    [sym_land] = STATE(3799),
    [sym_lor] = STATE(3799),
    [sym_assign] = STATE(3799),
    [sym_bnf_rule] = STATE(3799),
    [sym_eq] = STATE(3799),
    [sym_neq] = STATE(3799),
    [sym_lt] = STATE(3799),
    [sym_leq] = STATE(3799),
    [sym_geq] = STATE(3799),
    [sym_approx] = STATE(3799),
    [sym_rs_ttile] = STATE(3799),
    [sym_rd_ttile] = STATE(3799),
    [sym_ls_ttile] = STATE(3799),
    [sym_ld_ttile] = STATE(3799),
    [sym_asymp] = STATE(3799),
    [sym_cong] = STATE(3799),
    [sym_doteq] = STATE(3799),
    [sym_gg] = STATE(3799),
    [sym_ll] = STATE(3799),
    [sym_in] = STATE(3799),
    [sym_notin] = STATE(3799),
    [sym_prec] = STATE(3799),
    [sym_succ] = STATE(3799),
    [sym_preceq] = STATE(3799),
    [sym_succeq] = STATE(3799),
    [sym_propto] = STATE(3799),
    [sym_sim] = STATE(3799),
    [sym_simeq] = STATE(3799),
    [sym_sqsubset] = STATE(3799),
    [sym_sqsupset] = STATE(3799),
    [sym_sqsubseteq] = STATE(3799),
    [sym_sqsupseteq] = STATE(3799),
    [sym_subset] = STATE(3799),
    [sym_supset] = STATE(3799),
    [sym_subseteq] = STATE(3799),
    [sym_supseteq] = STATE(3799),
    [sym_cap] = STATE(3799),
    [sym_cup] = STATE(3799),
    [sym_dots_2] = STATE(3799),
    [sym_dots_3] = STATE(3799),
    [sym_plus] = STATE(3799),
    [sym_oplus] = STATE(3799),
    [sym_ominus] = STATE(3799),
    [sym_vertvert] = STATE(3799),
    [sym_minus] = STATE(3799),
    [sym_odot] = STATE(3799),
    [sym_oslash] = STATE(3799),
    [sym_otimes] = STATE(3799),
    [sym_bigcirc] = STATE(3799),
    [sym_bullet] = STATE(3799),
    [sym_div] = STATE(3799),
    [sym_circ] = STATE(3799),
    [sym_star] = STATE(3799),
    [sym_excl] = STATE(3799),
    [sym_qq] = STATE(3799),
    [sym_sqcap] = STATE(3799),
    [sym_sqcup] = STATE(3799),
    [sym_uplus] = STATE(3799),
    [sym_times] = STATE(3799),
    [sym_wr] = STATE(3799),
    [sym_cdot] = STATE(3799),
    [sym_infix_op_symbol] = STATE(4411),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3809),
    [sym_postfix_op_symbol] = STATE(4410),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_module_ref] = STATE(4649),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(606),
    [anon_sym_BSLASHin] = ACTIONS(684),
    [anon_sym_u2208] = ACTIONS(686),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(688),
    [anon_sym_u25a1] = ACTIONS(688),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(690),
    [anon_sym_u2227] = ACTIONS(690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(692),
    [anon_sym_u2228] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [anon_sym_LAMBDA] = ACTIONS(694),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(696),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(698),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(700),
    [anon_sym_BSLASHneg] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_u00ac] = ACTIONS(700),
    [sym_union] = ACTIONS(704),
    [sym_powerset] = ACTIONS(704),
    [sym_domain] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(706),
    [sym_negative_dot] = ACTIONS(708),
    [sym_enabled] = ACTIONS(710),
    [sym_unchanged] = ACTIONS(710),
    [anon_sym_LT_GT] = ACTIONS(712),
    [anon_sym_u22c4] = ACTIONS(712),
    [anon_sym_u25c7] = ACTIONS(712),
    [anon_sym_EQ_GT] = ACTIONS(714),
    [anon_sym_u27f9] = ACTIONS(714),
    [anon_sym_u21d2] = ACTIONS(714),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(716),
    [anon_sym_u21f8] = ACTIONS(716),
    [anon_sym_u2945] = ACTIONS(716),
    [anon_sym_BSLASHequiv] = ACTIONS(718),
    [anon_sym_u2261] = ACTIONS(718),
    [anon_sym_LT_EQ_GT] = ACTIONS(720),
    [anon_sym_u27fa] = ACTIONS(720),
    [anon_sym_u21d4] = ACTIONS(720),
    [anon_sym_TILDE_GT] = ACTIONS(722),
    [anon_sym_u21dd] = ACTIONS(722),
    [anon_sym_u219d] = ACTIONS(722),
    [anon_sym_BSLASHland] = ACTIONS(690),
    [anon_sym_BSLASHlor] = ACTIONS(692),
    [anon_sym_COLON_EQ] = ACTIONS(724),
    [anon_sym_u2254] = ACTIONS(724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(726),
    [anon_sym_u2a74] = ACTIONS(726),
    [anon_sym_SLASH_EQ] = ACTIONS(728),
    [anon_sym_POUND] = ACTIONS(730),
    [anon_sym_u2260] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(732),
    [sym_gt] = ACTIONS(734),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_EQ_LT] = ACTIONS(738),
    [anon_sym_BSLASHleq] = ACTIONS(738),
    [anon_sym_u2264] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_BSLASHgeq] = ACTIONS(740),
    [anon_sym_u2265] = ACTIONS(740),
    [anon_sym_BSLASHapprox] = ACTIONS(742),
    [anon_sym_u2248] = ACTIONS(742),
    [anon_sym_PIPE_DASH] = ACTIONS(744),
    [anon_sym_u22a2] = ACTIONS(744),
    [anon_sym_PIPE_EQ] = ACTIONS(746),
    [anon_sym_u22a8] = ACTIONS(746),
    [anon_sym_DASH_PIPE] = ACTIONS(748),
    [anon_sym_u22a3] = ACTIONS(748),
    [anon_sym_EQ_PIPE] = ACTIONS(750),
    [anon_sym_u2ae4] = ACTIONS(750),
    [anon_sym_BSLASHasymp] = ACTIONS(752),
    [anon_sym_u224d] = ACTIONS(752),
    [anon_sym_BSLASHcong] = ACTIONS(754),
    [anon_sym_u2245] = ACTIONS(754),
    [anon_sym_BSLASHdoteq] = ACTIONS(756),
    [anon_sym_u2250] = ACTIONS(756),
    [anon_sym_BSLASHgg] = ACTIONS(758),
    [anon_sym_u226b] = ACTIONS(758),
    [anon_sym_BSLASHll] = ACTIONS(760),
    [anon_sym_u226a] = ACTIONS(760),
    [anon_sym_BSLASHnotin] = ACTIONS(762),
    [anon_sym_u2209] = ACTIONS(762),
    [anon_sym_BSLASHprec] = ACTIONS(764),
    [anon_sym_u227a] = ACTIONS(766),
    [anon_sym_BSLASHsucc] = ACTIONS(768),
    [anon_sym_u227b] = ACTIONS(770),
    [anon_sym_BSLASHpreceq] = ACTIONS(772),
    [anon_sym_u2aaf] = ACTIONS(772),
    [anon_sym_BSLASHsucceq] = ACTIONS(774),
    [anon_sym_u2ab0] = ACTIONS(774),
    [anon_sym_BSLASHpropto] = ACTIONS(776),
    [anon_sym_u221d] = ACTIONS(776),
    [anon_sym_BSLASHsim] = ACTIONS(778),
    [anon_sym_u223c] = ACTIONS(780),
    [anon_sym_BSLASHsimeq] = ACTIONS(782),
    [anon_sym_u2243] = ACTIONS(782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(784),
    [anon_sym_u228f] = ACTIONS(786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(788),
    [anon_sym_u2290] = ACTIONS(790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(792),
    [anon_sym_u2291] = ACTIONS(792),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(794),
    [anon_sym_u2292] = ACTIONS(794),
    [anon_sym_BSLASHsubset] = ACTIONS(796),
    [anon_sym_u2282] = ACTIONS(798),
    [anon_sym_BSLASHsupset] = ACTIONS(800),
    [anon_sym_u2283] = ACTIONS(802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(804),
    [anon_sym_u2286] = ACTIONS(804),
    [anon_sym_BSLASHsupseteq] = ACTIONS(806),
    [anon_sym_u2287] = ACTIONS(806),
    [sym_compose] = ACTIONS(808),
    [sym_map_to] = ACTIONS(808),
    [sym_map_from] = ACTIONS(808),
    [sym_setminus] = ACTIONS(734),
    [anon_sym_BSLASHcap] = ACTIONS(810),
    [anon_sym_BSLASHintersect] = ACTIONS(810),
    [anon_sym_u2229] = ACTIONS(810),
    [anon_sym_BSLASHcup] = ACTIONS(812),
    [anon_sym_BSLASHunion] = ACTIONS(812),
    [anon_sym_u222a] = ACTIONS(812),
    [anon_sym_DOT_DOT] = ACTIONS(814),
    [anon_sym_u2025] = ACTIONS(816),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(818),
    [anon_sym_u2026] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [sym_plusplus] = ACTIONS(808),
    [anon_sym_BSLASHoplus] = ACTIONS(822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(822),
    [anon_sym_u2295] = ACTIONS(822),
    [anon_sym_BSLASHominus] = ACTIONS(824),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(824),
    [anon_sym_u2296] = ACTIONS(824),
    [sym_mod] = ACTIONS(734),
    [sym_modmod] = ACTIONS(808),
    [sym_vert] = ACTIONS(734),
    [anon_sym_PIPE_PIPE] = ACTIONS(826),
    [anon_sym_u2016] = ACTIONS(826),
    [sym_minusminus] = ACTIONS(808),
    [sym_amp] = ACTIONS(734),
    [sym_ampamp] = ACTIONS(808),
    [anon_sym_BSLASHodot] = ACTIONS(828),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(828),
    [anon_sym_u2299] = ACTIONS(828),
    [anon_sym_BSLASHoslash] = ACTIONS(830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(830),
    [anon_sym_u2298] = ACTIONS(830),
    [anon_sym_BSLASHotimes] = ACTIONS(832),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(832),
    [anon_sym_u2297] = ACTIONS(832),
    [sym_mul] = ACTIONS(734),
    [sym_mulmul] = ACTIONS(808),
    [sym_slash] = ACTIONS(734),
    [sym_slashslash] = ACTIONS(808),
    [anon_sym_BSLASHbigcirc] = ACTIONS(834),
    [anon_sym_u25ef] = ACTIONS(834),
    [anon_sym_BSLASHbullet] = ACTIONS(836),
    [anon_sym_u25cf] = ACTIONS(836),
    [anon_sym_BSLASHdiv] = ACTIONS(838),
    [anon_sym_u00f7] = ACTIONS(838),
    [anon_sym_BSLASHcirc] = ACTIONS(840),
    [anon_sym_u2218] = ACTIONS(840),
    [anon_sym_BSLASHstar] = ACTIONS(842),
    [anon_sym_u22c6] = ACTIONS(842),
    [anon_sym_u203c] = ACTIONS(844),
    [sym_hashhash] = ACTIONS(808),
    [sym_dol] = ACTIONS(734),
    [sym_doldol] = ACTIONS(808),
    [anon_sym_QMARK_QMARK] = ACTIONS(846),
    [anon_sym_u2047] = ACTIONS(846),
    [anon_sym_BSLASHsqcap] = ACTIONS(848),
    [anon_sym_u2293] = ACTIONS(848),
    [anon_sym_BSLASHsqcup] = ACTIONS(850),
    [anon_sym_u2294] = ACTIONS(850),
    [anon_sym_BSLASHuplus] = ACTIONS(852),
    [anon_sym_u228e] = ACTIONS(852),
    [anon_sym_BSLASHX] = ACTIONS(854),
    [anon_sym_BSLASHtimes] = ACTIONS(854),
    [anon_sym_u00d7] = ACTIONS(854),
    [anon_sym_BSLASHwr] = ACTIONS(856),
    [anon_sym_u2240] = ACTIONS(856),
    [anon_sym_BSLASHcdot] = ACTIONS(858),
    [anon_sym_u22c5] = ACTIONS(858),
    [sym_pow] = ACTIONS(734),
    [sym_powpow] = ACTIONS(808),
    [anon_sym_CARET_PLUS] = ACTIONS(860),
    [anon_sym_u207a] = ACTIONS(860),
    [sym_asterisk] = ACTIONS(862),
    [sym_sup_hash] = ACTIONS(862),
    [sym_prime] = ACTIONS(862),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(844),
  },
  [34] = {
    [sym_block_comment] = STATE(34),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym__op_or_expr] = STATE(3557),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1287),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(10),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(11),
    [sym_eventually] = STATE(11),
    [sym_prefix_op_symbol] = STATE(3535),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(3536),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(3535),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_module_ref] = STATE(3557),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(864),
    [anon_sym_u25a1] = ACTIONS(864),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [anon_sym_LAMBDA] = ACTIONS(866),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(868),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(870),
    [anon_sym_BSLASHneg] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_u00ac] = ACTIONS(870),
    [sym_union] = ACTIONS(874),
    [sym_powerset] = ACTIONS(874),
    [sym_domain] = ACTIONS(874),
    [anon_sym_DASH] = ACTIONS(876),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(878),
    [sym_unchanged] = ACTIONS(878),
    [anon_sym_LT_GT] = ACTIONS(880),
    [anon_sym_u22c4] = ACTIONS(880),
    [anon_sym_u25c7] = ACTIONS(880),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [35] = {
    [sym_block_comment] = STATE(35),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym__op_or_expr] = STATE(3558),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1287),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(10),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(11),
    [sym_eventually] = STATE(11),
    [sym_prefix_op_symbol] = STATE(3535),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(3536),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(3535),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_module_ref] = STATE(3558),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(864),
    [anon_sym_u25a1] = ACTIONS(864),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [anon_sym_LAMBDA] = ACTIONS(866),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(868),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(870),
    [anon_sym_BSLASHneg] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_u00ac] = ACTIONS(870),
    [sym_union] = ACTIONS(874),
    [sym_powerset] = ACTIONS(874),
    [sym_domain] = ACTIONS(874),
    [anon_sym_DASH] = ACTIONS(876),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(878),
    [sym_unchanged] = ACTIONS(878),
    [anon_sym_LT_GT] = ACTIONS(880),
    [anon_sym_u22c4] = ACTIONS(880),
    [anon_sym_u25c7] = ACTIONS(880),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [36] = {
    [sym_block_comment] = STATE(36),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym__op_or_expr] = STATE(3558),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1285),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(9),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(7),
    [sym_eventually] = STATE(7),
    [sym_prefix_op_symbol] = STATE(3537),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(3542),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3532),
    [sym_postfix_op_symbol] = STATE(3537),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_module_ref] = STATE(3558),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(882),
    [anon_sym_u25a1] = ACTIONS(882),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [anon_sym_LAMBDA] = ACTIONS(884),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(886),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(888),
    [anon_sym_BSLASHneg] = ACTIONS(888),
    [anon_sym_TILDE] = ACTIONS(890),
    [anon_sym_u00ac] = ACTIONS(888),
    [sym_union] = ACTIONS(892),
    [sym_powerset] = ACTIONS(892),
    [sym_domain] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(894),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(896),
    [sym_unchanged] = ACTIONS(896),
    [anon_sym_LT_GT] = ACTIONS(898),
    [anon_sym_u22c4] = ACTIONS(898),
    [anon_sym_u25c7] = ACTIONS(898),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(900),
    [anon_sym_u207a] = ACTIONS(900),
    [sym_asterisk] = ACTIONS(902),
    [sym_sup_hash] = ACTIONS(902),
    [sym_prime] = ACTIONS(902),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [37] = {
    [sym_block_comment] = STATE(37),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym__op_or_expr] = STATE(3564),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1285),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(9),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(7),
    [sym_eventually] = STATE(7),
    [sym_prefix_op_symbol] = STATE(3537),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(3542),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3532),
    [sym_postfix_op_symbol] = STATE(3537),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_module_ref] = STATE(3564),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(882),
    [anon_sym_u25a1] = ACTIONS(882),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [anon_sym_LAMBDA] = ACTIONS(884),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(886),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(888),
    [anon_sym_BSLASHneg] = ACTIONS(888),
    [anon_sym_TILDE] = ACTIONS(890),
    [anon_sym_u00ac] = ACTIONS(888),
    [sym_union] = ACTIONS(892),
    [sym_powerset] = ACTIONS(892),
    [sym_domain] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(894),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(896),
    [sym_unchanged] = ACTIONS(896),
    [anon_sym_LT_GT] = ACTIONS(898),
    [anon_sym_u22c4] = ACTIONS(898),
    [anon_sym_u25c7] = ACTIONS(898),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(900),
    [anon_sym_u207a] = ACTIONS(900),
    [sym_asterisk] = ACTIONS(902),
    [sym_sup_hash] = ACTIONS(902),
    [sym_prime] = ACTIONS(902),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [38] = {
    [sym_block_comment] = STATE(38),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym__op_or_expr] = STATE(5059),
    [sym__op] = STATE(3843),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym_lambda] = STATE(3844),
    [sym__expr] = STATE(1891),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(183),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(182),
    [sym_eventually] = STATE(182),
    [sym_prefix_op_symbol] = STATE(4410),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3799),
    [sym_plus_arrow] = STATE(3799),
    [sym_equiv] = STATE(3799),
    [sym_iff] = STATE(3799),
    [sym_leads_to] = STATE(3799),
    [sym_land] = STATE(3799),
    [sym_lor] = STATE(3799),
    [sym_assign] = STATE(3799),
    [sym_bnf_rule] = STATE(3799),
    [sym_eq] = STATE(3799),
    [sym_neq] = STATE(3799),
    [sym_lt] = STATE(3799),
    [sym_leq] = STATE(3799),
    [sym_geq] = STATE(3799),
    [sym_approx] = STATE(3799),
    [sym_rs_ttile] = STATE(3799),
    [sym_rd_ttile] = STATE(3799),
    [sym_ls_ttile] = STATE(3799),
    [sym_ld_ttile] = STATE(3799),
    [sym_asymp] = STATE(3799),
    [sym_cong] = STATE(3799),
    [sym_doteq] = STATE(3799),
    [sym_gg] = STATE(3799),
    [sym_ll] = STATE(3799),
    [sym_in] = STATE(3799),
    [sym_notin] = STATE(3799),
    [sym_prec] = STATE(3799),
    [sym_succ] = STATE(3799),
    [sym_preceq] = STATE(3799),
    [sym_succeq] = STATE(3799),
    [sym_propto] = STATE(3799),
    [sym_sim] = STATE(3799),
    [sym_simeq] = STATE(3799),
    [sym_sqsubset] = STATE(3799),
    [sym_sqsupset] = STATE(3799),
    [sym_sqsubseteq] = STATE(3799),
    [sym_sqsupseteq] = STATE(3799),
    [sym_subset] = STATE(3799),
    [sym_supset] = STATE(3799),
    [sym_subseteq] = STATE(3799),
    [sym_supseteq] = STATE(3799),
    [sym_cap] = STATE(3799),
    [sym_cup] = STATE(3799),
    [sym_dots_2] = STATE(3799),
    [sym_dots_3] = STATE(3799),
    [sym_plus] = STATE(3799),
    [sym_oplus] = STATE(3799),
    [sym_ominus] = STATE(3799),
    [sym_vertvert] = STATE(3799),
    [sym_minus] = STATE(3799),
    [sym_odot] = STATE(3799),
    [sym_oslash] = STATE(3799),
    [sym_otimes] = STATE(3799),
    [sym_bigcirc] = STATE(3799),
    [sym_bullet] = STATE(3799),
    [sym_div] = STATE(3799),
    [sym_circ] = STATE(3799),
    [sym_star] = STATE(3799),
    [sym_excl] = STATE(3799),
    [sym_qq] = STATE(3799),
    [sym_sqcap] = STATE(3799),
    [sym_sqcup] = STATE(3799),
    [sym_uplus] = STATE(3799),
    [sym_times] = STATE(3799),
    [sym_wr] = STATE(3799),
    [sym_cdot] = STATE(3799),
    [sym_infix_op_symbol] = STATE(4411),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3809),
    [sym_postfix_op_symbol] = STATE(4410),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_module_ref] = STATE(5059),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(606),
    [anon_sym_BSLASHin] = ACTIONS(684),
    [anon_sym_u2208] = ACTIONS(686),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(688),
    [anon_sym_u25a1] = ACTIONS(688),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(690),
    [anon_sym_u2227] = ACTIONS(690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(692),
    [anon_sym_u2228] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [anon_sym_LAMBDA] = ACTIONS(694),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(696),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(698),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(700),
    [anon_sym_BSLASHneg] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_u00ac] = ACTIONS(700),
    [sym_union] = ACTIONS(704),
    [sym_powerset] = ACTIONS(704),
    [sym_domain] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(706),
    [sym_negative_dot] = ACTIONS(708),
    [sym_enabled] = ACTIONS(710),
    [sym_unchanged] = ACTIONS(710),
    [anon_sym_LT_GT] = ACTIONS(712),
    [anon_sym_u22c4] = ACTIONS(712),
    [anon_sym_u25c7] = ACTIONS(712),
    [anon_sym_EQ_GT] = ACTIONS(714),
    [anon_sym_u27f9] = ACTIONS(714),
    [anon_sym_u21d2] = ACTIONS(714),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(716),
    [anon_sym_u21f8] = ACTIONS(716),
    [anon_sym_u2945] = ACTIONS(716),
    [anon_sym_BSLASHequiv] = ACTIONS(718),
    [anon_sym_u2261] = ACTIONS(718),
    [anon_sym_LT_EQ_GT] = ACTIONS(720),
    [anon_sym_u27fa] = ACTIONS(720),
    [anon_sym_u21d4] = ACTIONS(720),
    [anon_sym_TILDE_GT] = ACTIONS(722),
    [anon_sym_u21dd] = ACTIONS(722),
    [anon_sym_u219d] = ACTIONS(722),
    [anon_sym_BSLASHland] = ACTIONS(690),
    [anon_sym_BSLASHlor] = ACTIONS(692),
    [anon_sym_COLON_EQ] = ACTIONS(724),
    [anon_sym_u2254] = ACTIONS(724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(726),
    [anon_sym_u2a74] = ACTIONS(726),
    [anon_sym_SLASH_EQ] = ACTIONS(728),
    [anon_sym_POUND] = ACTIONS(730),
    [anon_sym_u2260] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(732),
    [sym_gt] = ACTIONS(734),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_EQ_LT] = ACTIONS(738),
    [anon_sym_BSLASHleq] = ACTIONS(738),
    [anon_sym_u2264] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_BSLASHgeq] = ACTIONS(740),
    [anon_sym_u2265] = ACTIONS(740),
    [anon_sym_BSLASHapprox] = ACTIONS(742),
    [anon_sym_u2248] = ACTIONS(742),
    [anon_sym_PIPE_DASH] = ACTIONS(744),
    [anon_sym_u22a2] = ACTIONS(744),
    [anon_sym_PIPE_EQ] = ACTIONS(746),
    [anon_sym_u22a8] = ACTIONS(746),
    [anon_sym_DASH_PIPE] = ACTIONS(748),
    [anon_sym_u22a3] = ACTIONS(748),
    [anon_sym_EQ_PIPE] = ACTIONS(750),
    [anon_sym_u2ae4] = ACTIONS(750),
    [anon_sym_BSLASHasymp] = ACTIONS(752),
    [anon_sym_u224d] = ACTIONS(752),
    [anon_sym_BSLASHcong] = ACTIONS(754),
    [anon_sym_u2245] = ACTIONS(754),
    [anon_sym_BSLASHdoteq] = ACTIONS(756),
    [anon_sym_u2250] = ACTIONS(756),
    [anon_sym_BSLASHgg] = ACTIONS(758),
    [anon_sym_u226b] = ACTIONS(758),
    [anon_sym_BSLASHll] = ACTIONS(760),
    [anon_sym_u226a] = ACTIONS(760),
    [anon_sym_BSLASHnotin] = ACTIONS(762),
    [anon_sym_u2209] = ACTIONS(762),
    [anon_sym_BSLASHprec] = ACTIONS(764),
    [anon_sym_u227a] = ACTIONS(766),
    [anon_sym_BSLASHsucc] = ACTIONS(768),
    [anon_sym_u227b] = ACTIONS(770),
    [anon_sym_BSLASHpreceq] = ACTIONS(772),
    [anon_sym_u2aaf] = ACTIONS(772),
    [anon_sym_BSLASHsucceq] = ACTIONS(774),
    [anon_sym_u2ab0] = ACTIONS(774),
    [anon_sym_BSLASHpropto] = ACTIONS(776),
    [anon_sym_u221d] = ACTIONS(776),
    [anon_sym_BSLASHsim] = ACTIONS(778),
    [anon_sym_u223c] = ACTIONS(780),
    [anon_sym_BSLASHsimeq] = ACTIONS(782),
    [anon_sym_u2243] = ACTIONS(782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(784),
    [anon_sym_u228f] = ACTIONS(786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(788),
    [anon_sym_u2290] = ACTIONS(790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(792),
    [anon_sym_u2291] = ACTIONS(792),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(794),
    [anon_sym_u2292] = ACTIONS(794),
    [anon_sym_BSLASHsubset] = ACTIONS(796),
    [anon_sym_u2282] = ACTIONS(798),
    [anon_sym_BSLASHsupset] = ACTIONS(800),
    [anon_sym_u2283] = ACTIONS(802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(804),
    [anon_sym_u2286] = ACTIONS(804),
    [anon_sym_BSLASHsupseteq] = ACTIONS(806),
    [anon_sym_u2287] = ACTIONS(806),
    [sym_compose] = ACTIONS(808),
    [sym_map_to] = ACTIONS(808),
    [sym_map_from] = ACTIONS(808),
    [sym_setminus] = ACTIONS(734),
    [anon_sym_BSLASHcap] = ACTIONS(810),
    [anon_sym_BSLASHintersect] = ACTIONS(810),
    [anon_sym_u2229] = ACTIONS(810),
    [anon_sym_BSLASHcup] = ACTIONS(812),
    [anon_sym_BSLASHunion] = ACTIONS(812),
    [anon_sym_u222a] = ACTIONS(812),
    [anon_sym_DOT_DOT] = ACTIONS(814),
    [anon_sym_u2025] = ACTIONS(816),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(818),
    [anon_sym_u2026] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [sym_plusplus] = ACTIONS(808),
    [anon_sym_BSLASHoplus] = ACTIONS(822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(822),
    [anon_sym_u2295] = ACTIONS(822),
    [anon_sym_BSLASHominus] = ACTIONS(824),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(824),
    [anon_sym_u2296] = ACTIONS(824),
    [sym_mod] = ACTIONS(734),
    [sym_modmod] = ACTIONS(808),
    [sym_vert] = ACTIONS(734),
    [anon_sym_PIPE_PIPE] = ACTIONS(826),
    [anon_sym_u2016] = ACTIONS(826),
    [sym_minusminus] = ACTIONS(808),
    [sym_amp] = ACTIONS(734),
    [sym_ampamp] = ACTIONS(808),
    [anon_sym_BSLASHodot] = ACTIONS(828),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(828),
    [anon_sym_u2299] = ACTIONS(828),
    [anon_sym_BSLASHoslash] = ACTIONS(830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(830),
    [anon_sym_u2298] = ACTIONS(830),
    [anon_sym_BSLASHotimes] = ACTIONS(832),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(832),
    [anon_sym_u2297] = ACTIONS(832),
    [sym_mul] = ACTIONS(734),
    [sym_mulmul] = ACTIONS(808),
    [sym_slash] = ACTIONS(734),
    [sym_slashslash] = ACTIONS(808),
    [anon_sym_BSLASHbigcirc] = ACTIONS(834),
    [anon_sym_u25ef] = ACTIONS(834),
    [anon_sym_BSLASHbullet] = ACTIONS(836),
    [anon_sym_u25cf] = ACTIONS(836),
    [anon_sym_BSLASHdiv] = ACTIONS(838),
    [anon_sym_u00f7] = ACTIONS(838),
    [anon_sym_BSLASHcirc] = ACTIONS(840),
    [anon_sym_u2218] = ACTIONS(840),
    [anon_sym_BSLASHstar] = ACTIONS(842),
    [anon_sym_u22c6] = ACTIONS(842),
    [anon_sym_u203c] = ACTIONS(844),
    [sym_hashhash] = ACTIONS(808),
    [sym_dol] = ACTIONS(734),
    [sym_doldol] = ACTIONS(808),
    [anon_sym_QMARK_QMARK] = ACTIONS(846),
    [anon_sym_u2047] = ACTIONS(846),
    [anon_sym_BSLASHsqcap] = ACTIONS(848),
    [anon_sym_u2293] = ACTIONS(848),
    [anon_sym_BSLASHsqcup] = ACTIONS(850),
    [anon_sym_u2294] = ACTIONS(850),
    [anon_sym_BSLASHuplus] = ACTIONS(852),
    [anon_sym_u228e] = ACTIONS(852),
    [anon_sym_BSLASHX] = ACTIONS(854),
    [anon_sym_BSLASHtimes] = ACTIONS(854),
    [anon_sym_u00d7] = ACTIONS(854),
    [anon_sym_BSLASHwr] = ACTIONS(856),
    [anon_sym_u2240] = ACTIONS(856),
    [anon_sym_BSLASHcdot] = ACTIONS(858),
    [anon_sym_u22c5] = ACTIONS(858),
    [sym_pow] = ACTIONS(734),
    [sym_powpow] = ACTIONS(808),
    [anon_sym_CARET_PLUS] = ACTIONS(860),
    [anon_sym_u207a] = ACTIONS(860),
    [sym_asterisk] = ACTIONS(862),
    [sym_sup_hash] = ACTIONS(862),
    [sym_prime] = ACTIONS(862),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(844),
  },
  [39] = {
    [sym_block_comment] = STATE(39),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1329),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_INSTANCE] = ACTIONS(333),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(936),
    [anon_sym_u2115] = ACTIONS(939),
    [anon_sym_Int] = ACTIONS(942),
    [anon_sym_u2124] = ACTIONS(945),
    [anon_sym_Real] = ACTIONS(948),
    [anon_sym_u211d] = ACTIONS(951),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_RBRACE] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(966),
    [sym_powerset] = ACTIONS(966),
    [sym_domain] = ACTIONS(966),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(969),
    [sym_unchanged] = ACTIONS(969),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_end] = ACTIONS(333),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [40] = {
    [sym_block_comment] = STATE(40),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4736),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [sym_placeholder] = ACTIONS(978),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [41] = {
    [sym_block_comment] = STATE(41),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1330),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_INSTANCE] = ACTIONS(333),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(936),
    [anon_sym_u2115] = ACTIONS(939),
    [anon_sym_Int] = ACTIONS(942),
    [anon_sym_u2124] = ACTIONS(945),
    [anon_sym_Real] = ACTIONS(948),
    [anon_sym_u211d] = ACTIONS(951),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_RBRACE] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(966),
    [sym_powerset] = ACTIONS(966),
    [sym_domain] = ACTIONS(966),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(969),
    [sym_unchanged] = ACTIONS(969),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_end] = ACTIONS(333),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [42] = {
    [sym_block_comment] = STATE(42),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1328),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_INSTANCE] = ACTIONS(333),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(936),
    [anon_sym_u2115] = ACTIONS(939),
    [anon_sym_Int] = ACTIONS(942),
    [anon_sym_u2124] = ACTIONS(945),
    [anon_sym_Real] = ACTIONS(948),
    [anon_sym_u211d] = ACTIONS(951),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_RBRACE] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(966),
    [sym_powerset] = ACTIONS(966),
    [sym_domain] = ACTIONS(966),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(969),
    [sym_unchanged] = ACTIONS(969),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_end] = ACTIONS(333),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [43] = {
    [sym_block_comment] = STATE(43),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4487),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [44] = {
    [sym_block_comment] = STATE(44),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym__op_or_expr] = STATE(3845),
    [sym__op] = STATE(3843),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym_lambda] = STATE(3844),
    [sym__expr] = STATE(1891),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(183),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(182),
    [sym_eventually] = STATE(182),
    [sym_prefix_op_symbol] = STATE(4410),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3799),
    [sym_plus_arrow] = STATE(3799),
    [sym_equiv] = STATE(3799),
    [sym_iff] = STATE(3799),
    [sym_leads_to] = STATE(3799),
    [sym_land] = STATE(3799),
    [sym_lor] = STATE(3799),
    [sym_assign] = STATE(3799),
    [sym_bnf_rule] = STATE(3799),
    [sym_eq] = STATE(3799),
    [sym_neq] = STATE(3799),
    [sym_lt] = STATE(3799),
    [sym_leq] = STATE(3799),
    [sym_geq] = STATE(3799),
    [sym_approx] = STATE(3799),
    [sym_rs_ttile] = STATE(3799),
    [sym_rd_ttile] = STATE(3799),
    [sym_ls_ttile] = STATE(3799),
    [sym_ld_ttile] = STATE(3799),
    [sym_asymp] = STATE(3799),
    [sym_cong] = STATE(3799),
    [sym_doteq] = STATE(3799),
    [sym_gg] = STATE(3799),
    [sym_ll] = STATE(3799),
    [sym_in] = STATE(3799),
    [sym_notin] = STATE(3799),
    [sym_prec] = STATE(3799),
    [sym_succ] = STATE(3799),
    [sym_preceq] = STATE(3799),
    [sym_succeq] = STATE(3799),
    [sym_propto] = STATE(3799),
    [sym_sim] = STATE(3799),
    [sym_simeq] = STATE(3799),
    [sym_sqsubset] = STATE(3799),
    [sym_sqsupset] = STATE(3799),
    [sym_sqsubseteq] = STATE(3799),
    [sym_sqsupseteq] = STATE(3799),
    [sym_subset] = STATE(3799),
    [sym_supset] = STATE(3799),
    [sym_subseteq] = STATE(3799),
    [sym_supseteq] = STATE(3799),
    [sym_cap] = STATE(3799),
    [sym_cup] = STATE(3799),
    [sym_dots_2] = STATE(3799),
    [sym_dots_3] = STATE(3799),
    [sym_plus] = STATE(3799),
    [sym_oplus] = STATE(3799),
    [sym_ominus] = STATE(3799),
    [sym_vertvert] = STATE(3799),
    [sym_minus] = STATE(3799),
    [sym_odot] = STATE(3799),
    [sym_oslash] = STATE(3799),
    [sym_otimes] = STATE(3799),
    [sym_bigcirc] = STATE(3799),
    [sym_bullet] = STATE(3799),
    [sym_div] = STATE(3799),
    [sym_circ] = STATE(3799),
    [sym_star] = STATE(3799),
    [sym_excl] = STATE(3799),
    [sym_qq] = STATE(3799),
    [sym_sqcap] = STATE(3799),
    [sym_sqcup] = STATE(3799),
    [sym_uplus] = STATE(3799),
    [sym_times] = STATE(3799),
    [sym_wr] = STATE(3799),
    [sym_cdot] = STATE(3799),
    [sym_infix_op_symbol] = STATE(4411),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3809),
    [sym_postfix_op_symbol] = STATE(4410),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(684),
    [anon_sym_u2208] = ACTIONS(686),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(688),
    [anon_sym_u25a1] = ACTIONS(688),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(690),
    [anon_sym_u2227] = ACTIONS(690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(692),
    [anon_sym_u2228] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [anon_sym_LAMBDA] = ACTIONS(694),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(696),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(698),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(700),
    [anon_sym_BSLASHneg] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_u00ac] = ACTIONS(700),
    [sym_union] = ACTIONS(704),
    [sym_powerset] = ACTIONS(704),
    [sym_domain] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(706),
    [sym_negative_dot] = ACTIONS(708),
    [sym_enabled] = ACTIONS(710),
    [sym_unchanged] = ACTIONS(710),
    [anon_sym_LT_GT] = ACTIONS(712),
    [anon_sym_u22c4] = ACTIONS(712),
    [anon_sym_u25c7] = ACTIONS(712),
    [anon_sym_EQ_GT] = ACTIONS(714),
    [anon_sym_u27f9] = ACTIONS(714),
    [anon_sym_u21d2] = ACTIONS(714),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(716),
    [anon_sym_u21f8] = ACTIONS(716),
    [anon_sym_u2945] = ACTIONS(716),
    [anon_sym_BSLASHequiv] = ACTIONS(718),
    [anon_sym_u2261] = ACTIONS(718),
    [anon_sym_LT_EQ_GT] = ACTIONS(720),
    [anon_sym_u27fa] = ACTIONS(720),
    [anon_sym_u21d4] = ACTIONS(720),
    [anon_sym_TILDE_GT] = ACTIONS(722),
    [anon_sym_u21dd] = ACTIONS(722),
    [anon_sym_u219d] = ACTIONS(722),
    [anon_sym_BSLASHland] = ACTIONS(690),
    [anon_sym_BSLASHlor] = ACTIONS(692),
    [anon_sym_COLON_EQ] = ACTIONS(724),
    [anon_sym_u2254] = ACTIONS(724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(726),
    [anon_sym_u2a74] = ACTIONS(726),
    [anon_sym_SLASH_EQ] = ACTIONS(728),
    [anon_sym_POUND] = ACTIONS(730),
    [anon_sym_u2260] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(732),
    [sym_gt] = ACTIONS(734),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_EQ_LT] = ACTIONS(738),
    [anon_sym_BSLASHleq] = ACTIONS(738),
    [anon_sym_u2264] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_BSLASHgeq] = ACTIONS(740),
    [anon_sym_u2265] = ACTIONS(740),
    [anon_sym_BSLASHapprox] = ACTIONS(742),
    [anon_sym_u2248] = ACTIONS(742),
    [anon_sym_PIPE_DASH] = ACTIONS(744),
    [anon_sym_u22a2] = ACTIONS(744),
    [anon_sym_PIPE_EQ] = ACTIONS(746),
    [anon_sym_u22a8] = ACTIONS(746),
    [anon_sym_DASH_PIPE] = ACTIONS(748),
    [anon_sym_u22a3] = ACTIONS(748),
    [anon_sym_EQ_PIPE] = ACTIONS(750),
    [anon_sym_u2ae4] = ACTIONS(750),
    [anon_sym_BSLASHasymp] = ACTIONS(752),
    [anon_sym_u224d] = ACTIONS(752),
    [anon_sym_BSLASHcong] = ACTIONS(754),
    [anon_sym_u2245] = ACTIONS(754),
    [anon_sym_BSLASHdoteq] = ACTIONS(756),
    [anon_sym_u2250] = ACTIONS(756),
    [anon_sym_BSLASHgg] = ACTIONS(758),
    [anon_sym_u226b] = ACTIONS(758),
    [anon_sym_BSLASHll] = ACTIONS(760),
    [anon_sym_u226a] = ACTIONS(760),
    [anon_sym_BSLASHnotin] = ACTIONS(762),
    [anon_sym_u2209] = ACTIONS(762),
    [anon_sym_BSLASHprec] = ACTIONS(764),
    [anon_sym_u227a] = ACTIONS(766),
    [anon_sym_BSLASHsucc] = ACTIONS(768),
    [anon_sym_u227b] = ACTIONS(770),
    [anon_sym_BSLASHpreceq] = ACTIONS(772),
    [anon_sym_u2aaf] = ACTIONS(772),
    [anon_sym_BSLASHsucceq] = ACTIONS(774),
    [anon_sym_u2ab0] = ACTIONS(774),
    [anon_sym_BSLASHpropto] = ACTIONS(776),
    [anon_sym_u221d] = ACTIONS(776),
    [anon_sym_BSLASHsim] = ACTIONS(778),
    [anon_sym_u223c] = ACTIONS(780),
    [anon_sym_BSLASHsimeq] = ACTIONS(782),
    [anon_sym_u2243] = ACTIONS(782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(784),
    [anon_sym_u228f] = ACTIONS(786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(788),
    [anon_sym_u2290] = ACTIONS(790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(792),
    [anon_sym_u2291] = ACTIONS(792),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(794),
    [anon_sym_u2292] = ACTIONS(794),
    [anon_sym_BSLASHsubset] = ACTIONS(796),
    [anon_sym_u2282] = ACTIONS(798),
    [anon_sym_BSLASHsupset] = ACTIONS(800),
    [anon_sym_u2283] = ACTIONS(802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(804),
    [anon_sym_u2286] = ACTIONS(804),
    [anon_sym_BSLASHsupseteq] = ACTIONS(806),
    [anon_sym_u2287] = ACTIONS(806),
    [sym_compose] = ACTIONS(808),
    [sym_map_to] = ACTIONS(808),
    [sym_map_from] = ACTIONS(808),
    [sym_setminus] = ACTIONS(734),
    [anon_sym_BSLASHcap] = ACTIONS(810),
    [anon_sym_BSLASHintersect] = ACTIONS(810),
    [anon_sym_u2229] = ACTIONS(810),
    [anon_sym_BSLASHcup] = ACTIONS(812),
    [anon_sym_BSLASHunion] = ACTIONS(812),
    [anon_sym_u222a] = ACTIONS(812),
    [anon_sym_DOT_DOT] = ACTIONS(814),
    [anon_sym_u2025] = ACTIONS(816),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(818),
    [anon_sym_u2026] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [sym_plusplus] = ACTIONS(808),
    [anon_sym_BSLASHoplus] = ACTIONS(822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(822),
    [anon_sym_u2295] = ACTIONS(822),
    [anon_sym_BSLASHominus] = ACTIONS(824),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(824),
    [anon_sym_u2296] = ACTIONS(824),
    [sym_mod] = ACTIONS(734),
    [sym_modmod] = ACTIONS(808),
    [sym_vert] = ACTIONS(734),
    [anon_sym_PIPE_PIPE] = ACTIONS(826),
    [anon_sym_u2016] = ACTIONS(826),
    [sym_minusminus] = ACTIONS(808),
    [sym_amp] = ACTIONS(734),
    [sym_ampamp] = ACTIONS(808),
    [anon_sym_BSLASHodot] = ACTIONS(828),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(828),
    [anon_sym_u2299] = ACTIONS(828),
    [anon_sym_BSLASHoslash] = ACTIONS(830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(830),
    [anon_sym_u2298] = ACTIONS(830),
    [anon_sym_BSLASHotimes] = ACTIONS(832),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(832),
    [anon_sym_u2297] = ACTIONS(832),
    [sym_mul] = ACTIONS(734),
    [sym_mulmul] = ACTIONS(808),
    [sym_slash] = ACTIONS(734),
    [sym_slashslash] = ACTIONS(808),
    [anon_sym_BSLASHbigcirc] = ACTIONS(834),
    [anon_sym_u25ef] = ACTIONS(834),
    [anon_sym_BSLASHbullet] = ACTIONS(836),
    [anon_sym_u25cf] = ACTIONS(836),
    [anon_sym_BSLASHdiv] = ACTIONS(838),
    [anon_sym_u00f7] = ACTIONS(838),
    [anon_sym_BSLASHcirc] = ACTIONS(840),
    [anon_sym_u2218] = ACTIONS(840),
    [anon_sym_BSLASHstar] = ACTIONS(842),
    [anon_sym_u22c6] = ACTIONS(842),
    [anon_sym_u203c] = ACTIONS(844),
    [sym_hashhash] = ACTIONS(808),
    [sym_dol] = ACTIONS(734),
    [sym_doldol] = ACTIONS(808),
    [anon_sym_QMARK_QMARK] = ACTIONS(846),
    [anon_sym_u2047] = ACTIONS(846),
    [anon_sym_BSLASHsqcap] = ACTIONS(848),
    [anon_sym_u2293] = ACTIONS(848),
    [anon_sym_BSLASHsqcup] = ACTIONS(850),
    [anon_sym_u2294] = ACTIONS(850),
    [anon_sym_BSLASHuplus] = ACTIONS(852),
    [anon_sym_u228e] = ACTIONS(852),
    [anon_sym_BSLASHX] = ACTIONS(854),
    [anon_sym_BSLASHtimes] = ACTIONS(854),
    [anon_sym_u00d7] = ACTIONS(854),
    [anon_sym_BSLASHwr] = ACTIONS(856),
    [anon_sym_u2240] = ACTIONS(856),
    [anon_sym_BSLASHcdot] = ACTIONS(858),
    [anon_sym_u22c5] = ACTIONS(858),
    [sym_pow] = ACTIONS(734),
    [sym_powpow] = ACTIONS(808),
    [anon_sym_CARET_PLUS] = ACTIONS(860),
    [anon_sym_u207a] = ACTIONS(860),
    [sym_asterisk] = ACTIONS(862),
    [sym_sup_hash] = ACTIONS(862),
    [sym_prime] = ACTIONS(862),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(844),
  },
  [45] = {
    [sym_block_comment] = STATE(45),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(3159),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1529),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(986),
    [anon_sym_u3009] = ACTIONS(986),
    [anon_sym_u27e9] = ACTIONS(986),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [46] = {
    [sym_block_comment] = STATE(46),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym__op_or_expr] = STATE(3510),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1385),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(41),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(39),
    [sym_eventually] = STATE(39),
    [sym_prefix_op_symbol] = STATE(3668),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(3665),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(3668),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [anon_sym_LAMBDA] = ACTIONS(1050),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(1052),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1066),
    [sym_powerset] = ACTIONS(1066),
    [sym_domain] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1068),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1070),
    [sym_unchanged] = ACTIONS(1070),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [47] = {
    [sym_block_comment] = STATE(47),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym__op_or_expr] = STATE(3509),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1385),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(41),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(39),
    [sym_eventually] = STATE(39),
    [sym_prefix_op_symbol] = STATE(3668),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(3665),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(3668),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [anon_sym_LAMBDA] = ACTIONS(1050),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(1052),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1066),
    [sym_powerset] = ACTIONS(1066),
    [sym_domain] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1068),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1070),
    [sym_unchanged] = ACTIONS(1070),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [48] = {
    [sym_block_comment] = STATE(48),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym__op_or_expr] = STATE(3848),
    [sym__op] = STATE(3843),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym_lambda] = STATE(3844),
    [sym__expr] = STATE(1434),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(133),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(132),
    [sym_eventually] = STATE(132),
    [sym_prefix_op_symbol] = STATE(3802),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3799),
    [sym_plus_arrow] = STATE(3799),
    [sym_equiv] = STATE(3799),
    [sym_iff] = STATE(3799),
    [sym_leads_to] = STATE(3799),
    [sym_land] = STATE(3799),
    [sym_lor] = STATE(3799),
    [sym_assign] = STATE(3799),
    [sym_bnf_rule] = STATE(3799),
    [sym_eq] = STATE(3799),
    [sym_neq] = STATE(3799),
    [sym_lt] = STATE(3799),
    [sym_leq] = STATE(3799),
    [sym_geq] = STATE(3799),
    [sym_approx] = STATE(3799),
    [sym_rs_ttile] = STATE(3799),
    [sym_rd_ttile] = STATE(3799),
    [sym_ls_ttile] = STATE(3799),
    [sym_ld_ttile] = STATE(3799),
    [sym_asymp] = STATE(3799),
    [sym_cong] = STATE(3799),
    [sym_doteq] = STATE(3799),
    [sym_gg] = STATE(3799),
    [sym_ll] = STATE(3799),
    [sym_in] = STATE(3799),
    [sym_notin] = STATE(3799),
    [sym_prec] = STATE(3799),
    [sym_succ] = STATE(3799),
    [sym_preceq] = STATE(3799),
    [sym_succeq] = STATE(3799),
    [sym_propto] = STATE(3799),
    [sym_sim] = STATE(3799),
    [sym_simeq] = STATE(3799),
    [sym_sqsubset] = STATE(3799),
    [sym_sqsupset] = STATE(3799),
    [sym_sqsubseteq] = STATE(3799),
    [sym_sqsupseteq] = STATE(3799),
    [sym_subset] = STATE(3799),
    [sym_supset] = STATE(3799),
    [sym_subseteq] = STATE(3799),
    [sym_supseteq] = STATE(3799),
    [sym_cap] = STATE(3799),
    [sym_cup] = STATE(3799),
    [sym_dots_2] = STATE(3799),
    [sym_dots_3] = STATE(3799),
    [sym_plus] = STATE(3799),
    [sym_oplus] = STATE(3799),
    [sym_ominus] = STATE(3799),
    [sym_vertvert] = STATE(3799),
    [sym_minus] = STATE(3799),
    [sym_odot] = STATE(3799),
    [sym_oslash] = STATE(3799),
    [sym_otimes] = STATE(3799),
    [sym_bigcirc] = STATE(3799),
    [sym_bullet] = STATE(3799),
    [sym_div] = STATE(3799),
    [sym_circ] = STATE(3799),
    [sym_star] = STATE(3799),
    [sym_excl] = STATE(3799),
    [sym_qq] = STATE(3799),
    [sym_sqcap] = STATE(3799),
    [sym_sqcup] = STATE(3799),
    [sym_uplus] = STATE(3799),
    [sym_times] = STATE(3799),
    [sym_wr] = STATE(3799),
    [sym_cdot] = STATE(3799),
    [sym_infix_op_symbol] = STATE(3823),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3809),
    [sym_postfix_op_symbol] = STATE(3802),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(684),
    [anon_sym_u2208] = ACTIONS(686),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(688),
    [anon_sym_u25a1] = ACTIONS(688),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(690),
    [anon_sym_u2227] = ACTIONS(690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(692),
    [anon_sym_u2228] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [anon_sym_LAMBDA] = ACTIONS(1084),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1092),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(698),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(700),
    [anon_sym_BSLASHneg] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_u00ac] = ACTIONS(700),
    [sym_union] = ACTIONS(1128),
    [sym_powerset] = ACTIONS(1128),
    [sym_domain] = ACTIONS(1128),
    [anon_sym_DASH] = ACTIONS(1130),
    [sym_negative_dot] = ACTIONS(708),
    [sym_enabled] = ACTIONS(1132),
    [sym_unchanged] = ACTIONS(1132),
    [anon_sym_LT_GT] = ACTIONS(712),
    [anon_sym_u22c4] = ACTIONS(712),
    [anon_sym_u25c7] = ACTIONS(712),
    [anon_sym_EQ_GT] = ACTIONS(714),
    [anon_sym_u27f9] = ACTIONS(714),
    [anon_sym_u21d2] = ACTIONS(714),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(716),
    [anon_sym_u21f8] = ACTIONS(716),
    [anon_sym_u2945] = ACTIONS(716),
    [anon_sym_BSLASHequiv] = ACTIONS(718),
    [anon_sym_u2261] = ACTIONS(718),
    [anon_sym_LT_EQ_GT] = ACTIONS(720),
    [anon_sym_u27fa] = ACTIONS(720),
    [anon_sym_u21d4] = ACTIONS(720),
    [anon_sym_TILDE_GT] = ACTIONS(722),
    [anon_sym_u21dd] = ACTIONS(722),
    [anon_sym_u219d] = ACTIONS(722),
    [anon_sym_BSLASHland] = ACTIONS(690),
    [anon_sym_BSLASHlor] = ACTIONS(692),
    [anon_sym_COLON_EQ] = ACTIONS(724),
    [anon_sym_u2254] = ACTIONS(724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(726),
    [anon_sym_u2a74] = ACTIONS(726),
    [anon_sym_SLASH_EQ] = ACTIONS(728),
    [anon_sym_POUND] = ACTIONS(730),
    [anon_sym_u2260] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(1134),
    [sym_gt] = ACTIONS(734),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_EQ_LT] = ACTIONS(738),
    [anon_sym_BSLASHleq] = ACTIONS(738),
    [anon_sym_u2264] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_BSLASHgeq] = ACTIONS(740),
    [anon_sym_u2265] = ACTIONS(740),
    [anon_sym_BSLASHapprox] = ACTIONS(742),
    [anon_sym_u2248] = ACTIONS(742),
    [anon_sym_PIPE_DASH] = ACTIONS(744),
    [anon_sym_u22a2] = ACTIONS(744),
    [anon_sym_PIPE_EQ] = ACTIONS(746),
    [anon_sym_u22a8] = ACTIONS(746),
    [anon_sym_DASH_PIPE] = ACTIONS(748),
    [anon_sym_u22a3] = ACTIONS(748),
    [anon_sym_EQ_PIPE] = ACTIONS(750),
    [anon_sym_u2ae4] = ACTIONS(750),
    [anon_sym_BSLASHasymp] = ACTIONS(752),
    [anon_sym_u224d] = ACTIONS(752),
    [anon_sym_BSLASHcong] = ACTIONS(754),
    [anon_sym_u2245] = ACTIONS(754),
    [anon_sym_BSLASHdoteq] = ACTIONS(756),
    [anon_sym_u2250] = ACTIONS(756),
    [anon_sym_BSLASHgg] = ACTIONS(758),
    [anon_sym_u226b] = ACTIONS(758),
    [anon_sym_BSLASHll] = ACTIONS(760),
    [anon_sym_u226a] = ACTIONS(760),
    [anon_sym_BSLASHnotin] = ACTIONS(762),
    [anon_sym_u2209] = ACTIONS(762),
    [anon_sym_BSLASHprec] = ACTIONS(764),
    [anon_sym_u227a] = ACTIONS(766),
    [anon_sym_BSLASHsucc] = ACTIONS(768),
    [anon_sym_u227b] = ACTIONS(770),
    [anon_sym_BSLASHpreceq] = ACTIONS(772),
    [anon_sym_u2aaf] = ACTIONS(772),
    [anon_sym_BSLASHsucceq] = ACTIONS(774),
    [anon_sym_u2ab0] = ACTIONS(774),
    [anon_sym_BSLASHpropto] = ACTIONS(776),
    [anon_sym_u221d] = ACTIONS(776),
    [anon_sym_BSLASHsim] = ACTIONS(778),
    [anon_sym_u223c] = ACTIONS(780),
    [anon_sym_BSLASHsimeq] = ACTIONS(782),
    [anon_sym_u2243] = ACTIONS(782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(784),
    [anon_sym_u228f] = ACTIONS(786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(788),
    [anon_sym_u2290] = ACTIONS(790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(792),
    [anon_sym_u2291] = ACTIONS(792),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(794),
    [anon_sym_u2292] = ACTIONS(794),
    [anon_sym_BSLASHsubset] = ACTIONS(796),
    [anon_sym_u2282] = ACTIONS(798),
    [anon_sym_BSLASHsupset] = ACTIONS(800),
    [anon_sym_u2283] = ACTIONS(802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(804),
    [anon_sym_u2286] = ACTIONS(804),
    [anon_sym_BSLASHsupseteq] = ACTIONS(806),
    [anon_sym_u2287] = ACTIONS(806),
    [sym_compose] = ACTIONS(808),
    [sym_map_to] = ACTIONS(808),
    [sym_map_from] = ACTIONS(808),
    [sym_setminus] = ACTIONS(734),
    [anon_sym_BSLASHcap] = ACTIONS(810),
    [anon_sym_BSLASHintersect] = ACTIONS(810),
    [anon_sym_u2229] = ACTIONS(810),
    [anon_sym_BSLASHcup] = ACTIONS(812),
    [anon_sym_BSLASHunion] = ACTIONS(812),
    [anon_sym_u222a] = ACTIONS(812),
    [anon_sym_DOT_DOT] = ACTIONS(814),
    [anon_sym_u2025] = ACTIONS(816),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(818),
    [anon_sym_u2026] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [sym_plusplus] = ACTIONS(808),
    [anon_sym_BSLASHoplus] = ACTIONS(822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(822),
    [anon_sym_u2295] = ACTIONS(822),
    [anon_sym_BSLASHominus] = ACTIONS(824),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(824),
    [anon_sym_u2296] = ACTIONS(824),
    [sym_mod] = ACTIONS(734),
    [sym_modmod] = ACTIONS(808),
    [sym_vert] = ACTIONS(734),
    [anon_sym_PIPE_PIPE] = ACTIONS(826),
    [anon_sym_u2016] = ACTIONS(826),
    [sym_minusminus] = ACTIONS(808),
    [sym_amp] = ACTIONS(734),
    [sym_ampamp] = ACTIONS(808),
    [anon_sym_BSLASHodot] = ACTIONS(828),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(828),
    [anon_sym_u2299] = ACTIONS(828),
    [anon_sym_BSLASHoslash] = ACTIONS(830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(830),
    [anon_sym_u2298] = ACTIONS(830),
    [anon_sym_BSLASHotimes] = ACTIONS(832),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(832),
    [anon_sym_u2297] = ACTIONS(832),
    [sym_mul] = ACTIONS(734),
    [sym_mulmul] = ACTIONS(808),
    [sym_slash] = ACTIONS(734),
    [sym_slashslash] = ACTIONS(808),
    [anon_sym_BSLASHbigcirc] = ACTIONS(834),
    [anon_sym_u25ef] = ACTIONS(834),
    [anon_sym_BSLASHbullet] = ACTIONS(836),
    [anon_sym_u25cf] = ACTIONS(836),
    [anon_sym_BSLASHdiv] = ACTIONS(838),
    [anon_sym_u00f7] = ACTIONS(838),
    [anon_sym_BSLASHcirc] = ACTIONS(840),
    [anon_sym_u2218] = ACTIONS(840),
    [anon_sym_BSLASHstar] = ACTIONS(842),
    [anon_sym_u22c6] = ACTIONS(842),
    [anon_sym_u203c] = ACTIONS(844),
    [sym_hashhash] = ACTIONS(808),
    [sym_dol] = ACTIONS(734),
    [sym_doldol] = ACTIONS(808),
    [anon_sym_QMARK_QMARK] = ACTIONS(846),
    [anon_sym_u2047] = ACTIONS(846),
    [anon_sym_BSLASHsqcap] = ACTIONS(848),
    [anon_sym_u2293] = ACTIONS(848),
    [anon_sym_BSLASHsqcup] = ACTIONS(850),
    [anon_sym_u2294] = ACTIONS(850),
    [anon_sym_BSLASHuplus] = ACTIONS(852),
    [anon_sym_u228e] = ACTIONS(852),
    [anon_sym_BSLASHX] = ACTIONS(854),
    [anon_sym_BSLASHtimes] = ACTIONS(854),
    [anon_sym_u00d7] = ACTIONS(854),
    [anon_sym_BSLASHwr] = ACTIONS(856),
    [anon_sym_u2240] = ACTIONS(856),
    [anon_sym_BSLASHcdot] = ACTIONS(858),
    [anon_sym_u22c5] = ACTIONS(858),
    [sym_pow] = ACTIONS(734),
    [sym_powpow] = ACTIONS(808),
    [anon_sym_CARET_PLUS] = ACTIONS(860),
    [anon_sym_u207a] = ACTIONS(860),
    [sym_asterisk] = ACTIONS(862),
    [sym_sup_hash] = ACTIONS(862),
    [sym_prime] = ACTIONS(862),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(844),
  },
  [49] = {
    [sym_block_comment] = STATE(49),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym__op_or_expr] = STATE(3845),
    [sym__op] = STATE(3843),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym_lambda] = STATE(3844),
    [sym__expr] = STATE(1434),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(133),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(132),
    [sym_eventually] = STATE(132),
    [sym_prefix_op_symbol] = STATE(3802),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3799),
    [sym_plus_arrow] = STATE(3799),
    [sym_equiv] = STATE(3799),
    [sym_iff] = STATE(3799),
    [sym_leads_to] = STATE(3799),
    [sym_land] = STATE(3799),
    [sym_lor] = STATE(3799),
    [sym_assign] = STATE(3799),
    [sym_bnf_rule] = STATE(3799),
    [sym_eq] = STATE(3799),
    [sym_neq] = STATE(3799),
    [sym_lt] = STATE(3799),
    [sym_leq] = STATE(3799),
    [sym_geq] = STATE(3799),
    [sym_approx] = STATE(3799),
    [sym_rs_ttile] = STATE(3799),
    [sym_rd_ttile] = STATE(3799),
    [sym_ls_ttile] = STATE(3799),
    [sym_ld_ttile] = STATE(3799),
    [sym_asymp] = STATE(3799),
    [sym_cong] = STATE(3799),
    [sym_doteq] = STATE(3799),
    [sym_gg] = STATE(3799),
    [sym_ll] = STATE(3799),
    [sym_in] = STATE(3799),
    [sym_notin] = STATE(3799),
    [sym_prec] = STATE(3799),
    [sym_succ] = STATE(3799),
    [sym_preceq] = STATE(3799),
    [sym_succeq] = STATE(3799),
    [sym_propto] = STATE(3799),
    [sym_sim] = STATE(3799),
    [sym_simeq] = STATE(3799),
    [sym_sqsubset] = STATE(3799),
    [sym_sqsupset] = STATE(3799),
    [sym_sqsubseteq] = STATE(3799),
    [sym_sqsupseteq] = STATE(3799),
    [sym_subset] = STATE(3799),
    [sym_supset] = STATE(3799),
    [sym_subseteq] = STATE(3799),
    [sym_supseteq] = STATE(3799),
    [sym_cap] = STATE(3799),
    [sym_cup] = STATE(3799),
    [sym_dots_2] = STATE(3799),
    [sym_dots_3] = STATE(3799),
    [sym_plus] = STATE(3799),
    [sym_oplus] = STATE(3799),
    [sym_ominus] = STATE(3799),
    [sym_vertvert] = STATE(3799),
    [sym_minus] = STATE(3799),
    [sym_odot] = STATE(3799),
    [sym_oslash] = STATE(3799),
    [sym_otimes] = STATE(3799),
    [sym_bigcirc] = STATE(3799),
    [sym_bullet] = STATE(3799),
    [sym_div] = STATE(3799),
    [sym_circ] = STATE(3799),
    [sym_star] = STATE(3799),
    [sym_excl] = STATE(3799),
    [sym_qq] = STATE(3799),
    [sym_sqcap] = STATE(3799),
    [sym_sqcup] = STATE(3799),
    [sym_uplus] = STATE(3799),
    [sym_times] = STATE(3799),
    [sym_wr] = STATE(3799),
    [sym_cdot] = STATE(3799),
    [sym_infix_op_symbol] = STATE(3823),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3809),
    [sym_postfix_op_symbol] = STATE(3802),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(684),
    [anon_sym_u2208] = ACTIONS(686),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(688),
    [anon_sym_u25a1] = ACTIONS(688),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(690),
    [anon_sym_u2227] = ACTIONS(690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(692),
    [anon_sym_u2228] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [anon_sym_LAMBDA] = ACTIONS(1084),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1092),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(698),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(700),
    [anon_sym_BSLASHneg] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_u00ac] = ACTIONS(700),
    [sym_union] = ACTIONS(1128),
    [sym_powerset] = ACTIONS(1128),
    [sym_domain] = ACTIONS(1128),
    [anon_sym_DASH] = ACTIONS(1130),
    [sym_negative_dot] = ACTIONS(708),
    [sym_enabled] = ACTIONS(1132),
    [sym_unchanged] = ACTIONS(1132),
    [anon_sym_LT_GT] = ACTIONS(712),
    [anon_sym_u22c4] = ACTIONS(712),
    [anon_sym_u25c7] = ACTIONS(712),
    [anon_sym_EQ_GT] = ACTIONS(714),
    [anon_sym_u27f9] = ACTIONS(714),
    [anon_sym_u21d2] = ACTIONS(714),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(716),
    [anon_sym_u21f8] = ACTIONS(716),
    [anon_sym_u2945] = ACTIONS(716),
    [anon_sym_BSLASHequiv] = ACTIONS(718),
    [anon_sym_u2261] = ACTIONS(718),
    [anon_sym_LT_EQ_GT] = ACTIONS(720),
    [anon_sym_u27fa] = ACTIONS(720),
    [anon_sym_u21d4] = ACTIONS(720),
    [anon_sym_TILDE_GT] = ACTIONS(722),
    [anon_sym_u21dd] = ACTIONS(722),
    [anon_sym_u219d] = ACTIONS(722),
    [anon_sym_BSLASHland] = ACTIONS(690),
    [anon_sym_BSLASHlor] = ACTIONS(692),
    [anon_sym_COLON_EQ] = ACTIONS(724),
    [anon_sym_u2254] = ACTIONS(724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(726),
    [anon_sym_u2a74] = ACTIONS(726),
    [anon_sym_SLASH_EQ] = ACTIONS(728),
    [anon_sym_POUND] = ACTIONS(730),
    [anon_sym_u2260] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(1134),
    [sym_gt] = ACTIONS(734),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_EQ_LT] = ACTIONS(738),
    [anon_sym_BSLASHleq] = ACTIONS(738),
    [anon_sym_u2264] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_BSLASHgeq] = ACTIONS(740),
    [anon_sym_u2265] = ACTIONS(740),
    [anon_sym_BSLASHapprox] = ACTIONS(742),
    [anon_sym_u2248] = ACTIONS(742),
    [anon_sym_PIPE_DASH] = ACTIONS(744),
    [anon_sym_u22a2] = ACTIONS(744),
    [anon_sym_PIPE_EQ] = ACTIONS(746),
    [anon_sym_u22a8] = ACTIONS(746),
    [anon_sym_DASH_PIPE] = ACTIONS(748),
    [anon_sym_u22a3] = ACTIONS(748),
    [anon_sym_EQ_PIPE] = ACTIONS(750),
    [anon_sym_u2ae4] = ACTIONS(750),
    [anon_sym_BSLASHasymp] = ACTIONS(752),
    [anon_sym_u224d] = ACTIONS(752),
    [anon_sym_BSLASHcong] = ACTIONS(754),
    [anon_sym_u2245] = ACTIONS(754),
    [anon_sym_BSLASHdoteq] = ACTIONS(756),
    [anon_sym_u2250] = ACTIONS(756),
    [anon_sym_BSLASHgg] = ACTIONS(758),
    [anon_sym_u226b] = ACTIONS(758),
    [anon_sym_BSLASHll] = ACTIONS(760),
    [anon_sym_u226a] = ACTIONS(760),
    [anon_sym_BSLASHnotin] = ACTIONS(762),
    [anon_sym_u2209] = ACTIONS(762),
    [anon_sym_BSLASHprec] = ACTIONS(764),
    [anon_sym_u227a] = ACTIONS(766),
    [anon_sym_BSLASHsucc] = ACTIONS(768),
    [anon_sym_u227b] = ACTIONS(770),
    [anon_sym_BSLASHpreceq] = ACTIONS(772),
    [anon_sym_u2aaf] = ACTIONS(772),
    [anon_sym_BSLASHsucceq] = ACTIONS(774),
    [anon_sym_u2ab0] = ACTIONS(774),
    [anon_sym_BSLASHpropto] = ACTIONS(776),
    [anon_sym_u221d] = ACTIONS(776),
    [anon_sym_BSLASHsim] = ACTIONS(778),
    [anon_sym_u223c] = ACTIONS(780),
    [anon_sym_BSLASHsimeq] = ACTIONS(782),
    [anon_sym_u2243] = ACTIONS(782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(784),
    [anon_sym_u228f] = ACTIONS(786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(788),
    [anon_sym_u2290] = ACTIONS(790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(792),
    [anon_sym_u2291] = ACTIONS(792),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(794),
    [anon_sym_u2292] = ACTIONS(794),
    [anon_sym_BSLASHsubset] = ACTIONS(796),
    [anon_sym_u2282] = ACTIONS(798),
    [anon_sym_BSLASHsupset] = ACTIONS(800),
    [anon_sym_u2283] = ACTIONS(802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(804),
    [anon_sym_u2286] = ACTIONS(804),
    [anon_sym_BSLASHsupseteq] = ACTIONS(806),
    [anon_sym_u2287] = ACTIONS(806),
    [sym_compose] = ACTIONS(808),
    [sym_map_to] = ACTIONS(808),
    [sym_map_from] = ACTIONS(808),
    [sym_setminus] = ACTIONS(734),
    [anon_sym_BSLASHcap] = ACTIONS(810),
    [anon_sym_BSLASHintersect] = ACTIONS(810),
    [anon_sym_u2229] = ACTIONS(810),
    [anon_sym_BSLASHcup] = ACTIONS(812),
    [anon_sym_BSLASHunion] = ACTIONS(812),
    [anon_sym_u222a] = ACTIONS(812),
    [anon_sym_DOT_DOT] = ACTIONS(814),
    [anon_sym_u2025] = ACTIONS(816),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(818),
    [anon_sym_u2026] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [sym_plusplus] = ACTIONS(808),
    [anon_sym_BSLASHoplus] = ACTIONS(822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(822),
    [anon_sym_u2295] = ACTIONS(822),
    [anon_sym_BSLASHominus] = ACTIONS(824),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(824),
    [anon_sym_u2296] = ACTIONS(824),
    [sym_mod] = ACTIONS(734),
    [sym_modmod] = ACTIONS(808),
    [sym_vert] = ACTIONS(734),
    [anon_sym_PIPE_PIPE] = ACTIONS(826),
    [anon_sym_u2016] = ACTIONS(826),
    [sym_minusminus] = ACTIONS(808),
    [sym_amp] = ACTIONS(734),
    [sym_ampamp] = ACTIONS(808),
    [anon_sym_BSLASHodot] = ACTIONS(828),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(828),
    [anon_sym_u2299] = ACTIONS(828),
    [anon_sym_BSLASHoslash] = ACTIONS(830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(830),
    [anon_sym_u2298] = ACTIONS(830),
    [anon_sym_BSLASHotimes] = ACTIONS(832),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(832),
    [anon_sym_u2297] = ACTIONS(832),
    [sym_mul] = ACTIONS(734),
    [sym_mulmul] = ACTIONS(808),
    [sym_slash] = ACTIONS(734),
    [sym_slashslash] = ACTIONS(808),
    [anon_sym_BSLASHbigcirc] = ACTIONS(834),
    [anon_sym_u25ef] = ACTIONS(834),
    [anon_sym_BSLASHbullet] = ACTIONS(836),
    [anon_sym_u25cf] = ACTIONS(836),
    [anon_sym_BSLASHdiv] = ACTIONS(838),
    [anon_sym_u00f7] = ACTIONS(838),
    [anon_sym_BSLASHcirc] = ACTIONS(840),
    [anon_sym_u2218] = ACTIONS(840),
    [anon_sym_BSLASHstar] = ACTIONS(842),
    [anon_sym_u22c6] = ACTIONS(842),
    [anon_sym_u203c] = ACTIONS(844),
    [sym_hashhash] = ACTIONS(808),
    [sym_dol] = ACTIONS(734),
    [sym_doldol] = ACTIONS(808),
    [anon_sym_QMARK_QMARK] = ACTIONS(846),
    [anon_sym_u2047] = ACTIONS(846),
    [anon_sym_BSLASHsqcap] = ACTIONS(848),
    [anon_sym_u2293] = ACTIONS(848),
    [anon_sym_BSLASHsqcup] = ACTIONS(850),
    [anon_sym_u2294] = ACTIONS(850),
    [anon_sym_BSLASHuplus] = ACTIONS(852),
    [anon_sym_u228e] = ACTIONS(852),
    [anon_sym_BSLASHX] = ACTIONS(854),
    [anon_sym_BSLASHtimes] = ACTIONS(854),
    [anon_sym_u00d7] = ACTIONS(854),
    [anon_sym_BSLASHwr] = ACTIONS(856),
    [anon_sym_u2240] = ACTIONS(856),
    [anon_sym_BSLASHcdot] = ACTIONS(858),
    [anon_sym_u22c5] = ACTIONS(858),
    [sym_pow] = ACTIONS(734),
    [sym_powpow] = ACTIONS(808),
    [anon_sym_CARET_PLUS] = ACTIONS(860),
    [anon_sym_u207a] = ACTIONS(860),
    [sym_asterisk] = ACTIONS(862),
    [sym_sup_hash] = ACTIONS(862),
    [sym_prime] = ACTIONS(862),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(844),
  },
  [50] = {
    [sym_block_comment] = STATE(50),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4813),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [51] = {
    [sym_block_comment] = STATE(51),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1356),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [sym_placeholder] = ACTIONS(333),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [anon_sym_RPAREN] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [52] = {
    [sym_block_comment] = STATE(52),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1357),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [sym_placeholder] = ACTIONS(333),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [anon_sym_RPAREN] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [53] = {
    [sym_block_comment] = STATE(53),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1358),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [sym_placeholder] = ACTIONS(333),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [anon_sym_RPAREN] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [54] = {
    [sym_block_comment] = STATE(54),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(2418),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1532),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1143),
    [anon_sym_u3009] = ACTIONS(1143),
    [anon_sym_u27e9] = ACTIONS(1143),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [55] = {
    [sym_block_comment] = STATE(55),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym__op_or_expr] = STATE(3510),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1287),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(10),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(11),
    [sym_eventually] = STATE(11),
    [sym_prefix_op_symbol] = STATE(3535),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(3536),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(3535),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(864),
    [anon_sym_u25a1] = ACTIONS(864),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [anon_sym_LAMBDA] = ACTIONS(866),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(868),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(870),
    [anon_sym_BSLASHneg] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_u00ac] = ACTIONS(870),
    [sym_union] = ACTIONS(874),
    [sym_powerset] = ACTIONS(874),
    [sym_domain] = ACTIONS(874),
    [anon_sym_DASH] = ACTIONS(876),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(878),
    [sym_unchanged] = ACTIONS(878),
    [anon_sym_LT_GT] = ACTIONS(880),
    [anon_sym_u22c4] = ACTIONS(880),
    [anon_sym_u25c7] = ACTIONS(880),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [56] = {
    [sym_block_comment] = STATE(56),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym__op_or_expr] = STATE(3509),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1287),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(10),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(11),
    [sym_eventually] = STATE(11),
    [sym_prefix_op_symbol] = STATE(3535),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(3536),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(3535),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(864),
    [anon_sym_u25a1] = ACTIONS(864),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [anon_sym_LAMBDA] = ACTIONS(866),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(868),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(870),
    [anon_sym_BSLASHneg] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_u00ac] = ACTIONS(870),
    [sym_union] = ACTIONS(874),
    [sym_powerset] = ACTIONS(874),
    [sym_domain] = ACTIONS(874),
    [anon_sym_DASH] = ACTIONS(876),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(878),
    [sym_unchanged] = ACTIONS(878),
    [anon_sym_LT_GT] = ACTIONS(880),
    [anon_sym_u22c4] = ACTIONS(880),
    [anon_sym_u25c7] = ACTIONS(880),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [57] = {
    [sym_block_comment] = STATE(57),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1404),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_RECURSIVE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(1152),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1177),
    [anon_sym_u2115] = ACTIONS(1180),
    [anon_sym_Int] = ACTIONS(1183),
    [anon_sym_u2124] = ACTIONS(1186),
    [anon_sym_Real] = ACTIONS(1189),
    [anon_sym_u211d] = ACTIONS(1192),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_IN] = ACTIONS(333),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(1207),
    [sym_powerset] = ACTIONS(1207),
    [sym_domain] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(1210),
    [sym_unchanged] = ACTIONS(1210),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [58] = {
    [sym_block_comment] = STATE(58),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1422),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_RECURSIVE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(1152),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1177),
    [anon_sym_u2115] = ACTIONS(1180),
    [anon_sym_Int] = ACTIONS(1183),
    [anon_sym_u2124] = ACTIONS(1186),
    [anon_sym_Real] = ACTIONS(1189),
    [anon_sym_u211d] = ACTIONS(1192),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_IN] = ACTIONS(333),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(1207),
    [sym_powerset] = ACTIONS(1207),
    [sym_domain] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(1210),
    [sym_unchanged] = ACTIONS(1210),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [59] = {
    [sym_block_comment] = STATE(59),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1423),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_RECURSIVE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(1152),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1177),
    [anon_sym_u2115] = ACTIONS(1180),
    [anon_sym_Int] = ACTIONS(1183),
    [anon_sym_u2124] = ACTIONS(1186),
    [anon_sym_Real] = ACTIONS(1189),
    [anon_sym_u211d] = ACTIONS(1192),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_IN] = ACTIONS(333),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(1207),
    [sym_powerset] = ACTIONS(1207),
    [sym_domain] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(1210),
    [sym_unchanged] = ACTIONS(1210),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [60] = {
    [sym_block_comment] = STATE(60),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(5002),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [61] = {
    [sym_block_comment] = STATE(61),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(2314),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1519),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1217),
    [anon_sym_u3009] = ACTIONS(1217),
    [anon_sym_u27e9] = ACTIONS(1217),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [62] = {
    [sym_block_comment] = STATE(62),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(2643),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1528),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1219),
    [anon_sym_u3009] = ACTIONS(1219),
    [anon_sym_u27e9] = ACTIONS(1219),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [63] = {
    [sym_block_comment] = STATE(63),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4931),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [64] = {
    [sym_block_comment] = STATE(64),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4572),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [65] = {
    [sym_block_comment] = STATE(65),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym__op_or_expr] = STATE(3827),
    [sym__op] = STATE(3837),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym_lambda] = STATE(3838),
    [sym__expr] = STATE(1425),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(59),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(58),
    [sym_eventually] = STATE(58),
    [sym_prefix_op_symbol] = STATE(3742),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3719),
    [sym_plus_arrow] = STATE(3719),
    [sym_equiv] = STATE(3719),
    [sym_iff] = STATE(3719),
    [sym_leads_to] = STATE(3719),
    [sym_land] = STATE(3719),
    [sym_lor] = STATE(3719),
    [sym_assign] = STATE(3719),
    [sym_bnf_rule] = STATE(3719),
    [sym_eq] = STATE(3719),
    [sym_neq] = STATE(3719),
    [sym_lt] = STATE(3719),
    [sym_leq] = STATE(3719),
    [sym_geq] = STATE(3719),
    [sym_approx] = STATE(3719),
    [sym_rs_ttile] = STATE(3719),
    [sym_rd_ttile] = STATE(3719),
    [sym_ls_ttile] = STATE(3719),
    [sym_ld_ttile] = STATE(3719),
    [sym_asymp] = STATE(3719),
    [sym_cong] = STATE(3719),
    [sym_doteq] = STATE(3719),
    [sym_gg] = STATE(3719),
    [sym_ll] = STATE(3719),
    [sym_in] = STATE(3719),
    [sym_notin] = STATE(3719),
    [sym_prec] = STATE(3719),
    [sym_succ] = STATE(3719),
    [sym_preceq] = STATE(3719),
    [sym_succeq] = STATE(3719),
    [sym_propto] = STATE(3719),
    [sym_sim] = STATE(3719),
    [sym_simeq] = STATE(3719),
    [sym_sqsubset] = STATE(3719),
    [sym_sqsupset] = STATE(3719),
    [sym_sqsubseteq] = STATE(3719),
    [sym_sqsupseteq] = STATE(3719),
    [sym_subset] = STATE(3719),
    [sym_supset] = STATE(3719),
    [sym_subseteq] = STATE(3719),
    [sym_supseteq] = STATE(3719),
    [sym_cap] = STATE(3719),
    [sym_cup] = STATE(3719),
    [sym_dots_2] = STATE(3719),
    [sym_dots_3] = STATE(3719),
    [sym_plus] = STATE(3719),
    [sym_oplus] = STATE(3719),
    [sym_ominus] = STATE(3719),
    [sym_vertvert] = STATE(3719),
    [sym_minus] = STATE(3719),
    [sym_odot] = STATE(3719),
    [sym_oslash] = STATE(3719),
    [sym_otimes] = STATE(3719),
    [sym_bigcirc] = STATE(3719),
    [sym_bullet] = STATE(3719),
    [sym_div] = STATE(3719),
    [sym_circ] = STATE(3719),
    [sym_star] = STATE(3719),
    [sym_excl] = STATE(3719),
    [sym_qq] = STATE(3719),
    [sym_sqcap] = STATE(3719),
    [sym_sqcup] = STATE(3719),
    [sym_uplus] = STATE(3719),
    [sym_times] = STATE(3719),
    [sym_wr] = STATE(3719),
    [sym_cdot] = STATE(3719),
    [sym_infix_op_symbol] = STATE(3738),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3736),
    [sym_postfix_op_symbol] = STATE(3742),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(1223),
    [anon_sym_u2208] = ACTIONS(1225),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1227),
    [anon_sym_u25a1] = ACTIONS(1227),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(1229),
    [anon_sym_u2227] = ACTIONS(1229),
    [anon_sym_BSLASH_SLASH] = ACTIONS(1231),
    [anon_sym_u2228] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [anon_sym_LAMBDA] = ACTIONS(1235),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1237),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(1251),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(1253),
    [anon_sym_BSLASHneg] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_u00ac] = ACTIONS(1253),
    [sym_union] = ACTIONS(1257),
    [sym_powerset] = ACTIONS(1257),
    [sym_domain] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1259),
    [sym_negative_dot] = ACTIONS(1261),
    [sym_enabled] = ACTIONS(1263),
    [sym_unchanged] = ACTIONS(1263),
    [anon_sym_LT_GT] = ACTIONS(1265),
    [anon_sym_u22c4] = ACTIONS(1265),
    [anon_sym_u25c7] = ACTIONS(1265),
    [anon_sym_EQ_GT] = ACTIONS(1267),
    [anon_sym_u27f9] = ACTIONS(1267),
    [anon_sym_u21d2] = ACTIONS(1267),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(1269),
    [anon_sym_u21f8] = ACTIONS(1269),
    [anon_sym_u2945] = ACTIONS(1269),
    [anon_sym_BSLASHequiv] = ACTIONS(1271),
    [anon_sym_u2261] = ACTIONS(1271),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_u27fa] = ACTIONS(1273),
    [anon_sym_u21d4] = ACTIONS(1273),
    [anon_sym_TILDE_GT] = ACTIONS(1275),
    [anon_sym_u21dd] = ACTIONS(1275),
    [anon_sym_u219d] = ACTIONS(1275),
    [anon_sym_BSLASHland] = ACTIONS(1229),
    [anon_sym_BSLASHlor] = ACTIONS(1231),
    [anon_sym_COLON_EQ] = ACTIONS(1277),
    [anon_sym_u2254] = ACTIONS(1277),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(1279),
    [anon_sym_u2a74] = ACTIONS(1279),
    [anon_sym_SLASH_EQ] = ACTIONS(1281),
    [anon_sym_POUND] = ACTIONS(1283),
    [anon_sym_u2260] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1285),
    [sym_gt] = ACTIONS(1287),
    [anon_sym_LT_EQ] = ACTIONS(1289),
    [anon_sym_EQ_LT] = ACTIONS(1291),
    [anon_sym_BSLASHleq] = ACTIONS(1291),
    [anon_sym_u2264] = ACTIONS(1291),
    [anon_sym_GT_EQ] = ACTIONS(1293),
    [anon_sym_BSLASHgeq] = ACTIONS(1293),
    [anon_sym_u2265] = ACTIONS(1293),
    [anon_sym_BSLASHapprox] = ACTIONS(1295),
    [anon_sym_u2248] = ACTIONS(1295),
    [anon_sym_PIPE_DASH] = ACTIONS(1297),
    [anon_sym_u22a2] = ACTIONS(1297),
    [anon_sym_PIPE_EQ] = ACTIONS(1299),
    [anon_sym_u22a8] = ACTIONS(1299),
    [anon_sym_DASH_PIPE] = ACTIONS(1301),
    [anon_sym_u22a3] = ACTIONS(1301),
    [anon_sym_EQ_PIPE] = ACTIONS(1303),
    [anon_sym_u2ae4] = ACTIONS(1303),
    [anon_sym_BSLASHasymp] = ACTIONS(1305),
    [anon_sym_u224d] = ACTIONS(1305),
    [anon_sym_BSLASHcong] = ACTIONS(1307),
    [anon_sym_u2245] = ACTIONS(1307),
    [anon_sym_BSLASHdoteq] = ACTIONS(1309),
    [anon_sym_u2250] = ACTIONS(1309),
    [anon_sym_BSLASHgg] = ACTIONS(1311),
    [anon_sym_u226b] = ACTIONS(1311),
    [anon_sym_BSLASHll] = ACTIONS(1313),
    [anon_sym_u226a] = ACTIONS(1313),
    [anon_sym_BSLASHnotin] = ACTIONS(1315),
    [anon_sym_u2209] = ACTIONS(1315),
    [anon_sym_BSLASHprec] = ACTIONS(1317),
    [anon_sym_u227a] = ACTIONS(1319),
    [anon_sym_BSLASHsucc] = ACTIONS(1321),
    [anon_sym_u227b] = ACTIONS(1323),
    [anon_sym_BSLASHpreceq] = ACTIONS(1325),
    [anon_sym_u2aaf] = ACTIONS(1325),
    [anon_sym_BSLASHsucceq] = ACTIONS(1327),
    [anon_sym_u2ab0] = ACTIONS(1327),
    [anon_sym_BSLASHpropto] = ACTIONS(1329),
    [anon_sym_u221d] = ACTIONS(1329),
    [anon_sym_BSLASHsim] = ACTIONS(1331),
    [anon_sym_u223c] = ACTIONS(1333),
    [anon_sym_BSLASHsimeq] = ACTIONS(1335),
    [anon_sym_u2243] = ACTIONS(1335),
    [anon_sym_BSLASHsqsubset] = ACTIONS(1337),
    [anon_sym_u228f] = ACTIONS(1339),
    [anon_sym_BSLASHsqsupset] = ACTIONS(1341),
    [anon_sym_u2290] = ACTIONS(1343),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(1345),
    [anon_sym_u2291] = ACTIONS(1345),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(1347),
    [anon_sym_u2292] = ACTIONS(1347),
    [anon_sym_BSLASHsubset] = ACTIONS(1349),
    [anon_sym_u2282] = ACTIONS(1351),
    [anon_sym_BSLASHsupset] = ACTIONS(1353),
    [anon_sym_u2283] = ACTIONS(1355),
    [anon_sym_BSLASHsubseteq] = ACTIONS(1357),
    [anon_sym_u2286] = ACTIONS(1357),
    [anon_sym_BSLASHsupseteq] = ACTIONS(1359),
    [anon_sym_u2287] = ACTIONS(1359),
    [sym_compose] = ACTIONS(1361),
    [sym_map_to] = ACTIONS(1361),
    [sym_map_from] = ACTIONS(1361),
    [sym_setminus] = ACTIONS(1287),
    [anon_sym_BSLASHcap] = ACTIONS(1363),
    [anon_sym_BSLASHintersect] = ACTIONS(1363),
    [anon_sym_u2229] = ACTIONS(1363),
    [anon_sym_BSLASHcup] = ACTIONS(1365),
    [anon_sym_BSLASHunion] = ACTIONS(1365),
    [anon_sym_u222a] = ACTIONS(1365),
    [anon_sym_DOT_DOT] = ACTIONS(1367),
    [anon_sym_u2025] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_u2026] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1373),
    [sym_plusplus] = ACTIONS(1361),
    [anon_sym_BSLASHoplus] = ACTIONS(1375),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(1375),
    [anon_sym_u2295] = ACTIONS(1375),
    [anon_sym_BSLASHominus] = ACTIONS(1377),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(1377),
    [anon_sym_u2296] = ACTIONS(1377),
    [sym_mod] = ACTIONS(1287),
    [sym_modmod] = ACTIONS(1361),
    [sym_vert] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1379),
    [anon_sym_u2016] = ACTIONS(1379),
    [sym_minusminus] = ACTIONS(1361),
    [sym_amp] = ACTIONS(1287),
    [sym_ampamp] = ACTIONS(1361),
    [anon_sym_BSLASHodot] = ACTIONS(1381),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(1381),
    [anon_sym_u2299] = ACTIONS(1381),
    [anon_sym_BSLASHoslash] = ACTIONS(1383),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(1383),
    [anon_sym_u2298] = ACTIONS(1383),
    [anon_sym_BSLASHotimes] = ACTIONS(1385),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(1385),
    [anon_sym_u2297] = ACTIONS(1385),
    [sym_mul] = ACTIONS(1287),
    [sym_mulmul] = ACTIONS(1361),
    [sym_slash] = ACTIONS(1287),
    [sym_slashslash] = ACTIONS(1361),
    [anon_sym_BSLASHbigcirc] = ACTIONS(1387),
    [anon_sym_u25ef] = ACTIONS(1387),
    [anon_sym_BSLASHbullet] = ACTIONS(1389),
    [anon_sym_u25cf] = ACTIONS(1389),
    [anon_sym_BSLASHdiv] = ACTIONS(1391),
    [anon_sym_u00f7] = ACTIONS(1391),
    [anon_sym_BSLASHcirc] = ACTIONS(1393),
    [anon_sym_u2218] = ACTIONS(1393),
    [anon_sym_BSLASHstar] = ACTIONS(1395),
    [anon_sym_u22c6] = ACTIONS(1395),
    [anon_sym_u203c] = ACTIONS(1397),
    [sym_hashhash] = ACTIONS(1361),
    [sym_dol] = ACTIONS(1287),
    [sym_doldol] = ACTIONS(1361),
    [anon_sym_QMARK_QMARK] = ACTIONS(1399),
    [anon_sym_u2047] = ACTIONS(1399),
    [anon_sym_BSLASHsqcap] = ACTIONS(1401),
    [anon_sym_u2293] = ACTIONS(1401),
    [anon_sym_BSLASHsqcup] = ACTIONS(1403),
    [anon_sym_u2294] = ACTIONS(1403),
    [anon_sym_BSLASHuplus] = ACTIONS(1405),
    [anon_sym_u228e] = ACTIONS(1405),
    [anon_sym_BSLASHX] = ACTIONS(1407),
    [anon_sym_BSLASHtimes] = ACTIONS(1407),
    [anon_sym_u00d7] = ACTIONS(1407),
    [anon_sym_BSLASHwr] = ACTIONS(1409),
    [anon_sym_u2240] = ACTIONS(1409),
    [anon_sym_BSLASHcdot] = ACTIONS(1411),
    [anon_sym_u22c5] = ACTIONS(1411),
    [sym_pow] = ACTIONS(1287),
    [sym_powpow] = ACTIONS(1361),
    [anon_sym_CARET_PLUS] = ACTIONS(1413),
    [anon_sym_u207a] = ACTIONS(1413),
    [sym_asterisk] = ACTIONS(1415),
    [sym_sup_hash] = ACTIONS(1415),
    [sym_prime] = ACTIONS(1415),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(1397),
  },
  [66] = {
    [sym_block_comment] = STATE(66),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(2643),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1528),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1219),
    [anon_sym_u3009] = ACTIONS(1219),
    [anon_sym_u27e9] = ACTIONS(1219),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [67] = {
    [sym_block_comment] = STATE(67),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym__op_or_expr] = STATE(3829),
    [sym__op] = STATE(3837),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym_lambda] = STATE(3838),
    [sym__expr] = STATE(1425),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(59),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(58),
    [sym_eventually] = STATE(58),
    [sym_prefix_op_symbol] = STATE(3742),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3719),
    [sym_plus_arrow] = STATE(3719),
    [sym_equiv] = STATE(3719),
    [sym_iff] = STATE(3719),
    [sym_leads_to] = STATE(3719),
    [sym_land] = STATE(3719),
    [sym_lor] = STATE(3719),
    [sym_assign] = STATE(3719),
    [sym_bnf_rule] = STATE(3719),
    [sym_eq] = STATE(3719),
    [sym_neq] = STATE(3719),
    [sym_lt] = STATE(3719),
    [sym_leq] = STATE(3719),
    [sym_geq] = STATE(3719),
    [sym_approx] = STATE(3719),
    [sym_rs_ttile] = STATE(3719),
    [sym_rd_ttile] = STATE(3719),
    [sym_ls_ttile] = STATE(3719),
    [sym_ld_ttile] = STATE(3719),
    [sym_asymp] = STATE(3719),
    [sym_cong] = STATE(3719),
    [sym_doteq] = STATE(3719),
    [sym_gg] = STATE(3719),
    [sym_ll] = STATE(3719),
    [sym_in] = STATE(3719),
    [sym_notin] = STATE(3719),
    [sym_prec] = STATE(3719),
    [sym_succ] = STATE(3719),
    [sym_preceq] = STATE(3719),
    [sym_succeq] = STATE(3719),
    [sym_propto] = STATE(3719),
    [sym_sim] = STATE(3719),
    [sym_simeq] = STATE(3719),
    [sym_sqsubset] = STATE(3719),
    [sym_sqsupset] = STATE(3719),
    [sym_sqsubseteq] = STATE(3719),
    [sym_sqsupseteq] = STATE(3719),
    [sym_subset] = STATE(3719),
    [sym_supset] = STATE(3719),
    [sym_subseteq] = STATE(3719),
    [sym_supseteq] = STATE(3719),
    [sym_cap] = STATE(3719),
    [sym_cup] = STATE(3719),
    [sym_dots_2] = STATE(3719),
    [sym_dots_3] = STATE(3719),
    [sym_plus] = STATE(3719),
    [sym_oplus] = STATE(3719),
    [sym_ominus] = STATE(3719),
    [sym_vertvert] = STATE(3719),
    [sym_minus] = STATE(3719),
    [sym_odot] = STATE(3719),
    [sym_oslash] = STATE(3719),
    [sym_otimes] = STATE(3719),
    [sym_bigcirc] = STATE(3719),
    [sym_bullet] = STATE(3719),
    [sym_div] = STATE(3719),
    [sym_circ] = STATE(3719),
    [sym_star] = STATE(3719),
    [sym_excl] = STATE(3719),
    [sym_qq] = STATE(3719),
    [sym_sqcap] = STATE(3719),
    [sym_sqcup] = STATE(3719),
    [sym_uplus] = STATE(3719),
    [sym_times] = STATE(3719),
    [sym_wr] = STATE(3719),
    [sym_cdot] = STATE(3719),
    [sym_infix_op_symbol] = STATE(3738),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3736),
    [sym_postfix_op_symbol] = STATE(3742),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(1223),
    [anon_sym_u2208] = ACTIONS(1225),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1227),
    [anon_sym_u25a1] = ACTIONS(1227),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(1229),
    [anon_sym_u2227] = ACTIONS(1229),
    [anon_sym_BSLASH_SLASH] = ACTIONS(1231),
    [anon_sym_u2228] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [anon_sym_LAMBDA] = ACTIONS(1235),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1237),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(1251),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(1253),
    [anon_sym_BSLASHneg] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_u00ac] = ACTIONS(1253),
    [sym_union] = ACTIONS(1257),
    [sym_powerset] = ACTIONS(1257),
    [sym_domain] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1259),
    [sym_negative_dot] = ACTIONS(1261),
    [sym_enabled] = ACTIONS(1263),
    [sym_unchanged] = ACTIONS(1263),
    [anon_sym_LT_GT] = ACTIONS(1265),
    [anon_sym_u22c4] = ACTIONS(1265),
    [anon_sym_u25c7] = ACTIONS(1265),
    [anon_sym_EQ_GT] = ACTIONS(1267),
    [anon_sym_u27f9] = ACTIONS(1267),
    [anon_sym_u21d2] = ACTIONS(1267),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(1269),
    [anon_sym_u21f8] = ACTIONS(1269),
    [anon_sym_u2945] = ACTIONS(1269),
    [anon_sym_BSLASHequiv] = ACTIONS(1271),
    [anon_sym_u2261] = ACTIONS(1271),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_u27fa] = ACTIONS(1273),
    [anon_sym_u21d4] = ACTIONS(1273),
    [anon_sym_TILDE_GT] = ACTIONS(1275),
    [anon_sym_u21dd] = ACTIONS(1275),
    [anon_sym_u219d] = ACTIONS(1275),
    [anon_sym_BSLASHland] = ACTIONS(1229),
    [anon_sym_BSLASHlor] = ACTIONS(1231),
    [anon_sym_COLON_EQ] = ACTIONS(1277),
    [anon_sym_u2254] = ACTIONS(1277),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(1279),
    [anon_sym_u2a74] = ACTIONS(1279),
    [anon_sym_SLASH_EQ] = ACTIONS(1281),
    [anon_sym_POUND] = ACTIONS(1283),
    [anon_sym_u2260] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1285),
    [sym_gt] = ACTIONS(1287),
    [anon_sym_LT_EQ] = ACTIONS(1289),
    [anon_sym_EQ_LT] = ACTIONS(1291),
    [anon_sym_BSLASHleq] = ACTIONS(1291),
    [anon_sym_u2264] = ACTIONS(1291),
    [anon_sym_GT_EQ] = ACTIONS(1293),
    [anon_sym_BSLASHgeq] = ACTIONS(1293),
    [anon_sym_u2265] = ACTIONS(1293),
    [anon_sym_BSLASHapprox] = ACTIONS(1295),
    [anon_sym_u2248] = ACTIONS(1295),
    [anon_sym_PIPE_DASH] = ACTIONS(1297),
    [anon_sym_u22a2] = ACTIONS(1297),
    [anon_sym_PIPE_EQ] = ACTIONS(1299),
    [anon_sym_u22a8] = ACTIONS(1299),
    [anon_sym_DASH_PIPE] = ACTIONS(1301),
    [anon_sym_u22a3] = ACTIONS(1301),
    [anon_sym_EQ_PIPE] = ACTIONS(1303),
    [anon_sym_u2ae4] = ACTIONS(1303),
    [anon_sym_BSLASHasymp] = ACTIONS(1305),
    [anon_sym_u224d] = ACTIONS(1305),
    [anon_sym_BSLASHcong] = ACTIONS(1307),
    [anon_sym_u2245] = ACTIONS(1307),
    [anon_sym_BSLASHdoteq] = ACTIONS(1309),
    [anon_sym_u2250] = ACTIONS(1309),
    [anon_sym_BSLASHgg] = ACTIONS(1311),
    [anon_sym_u226b] = ACTIONS(1311),
    [anon_sym_BSLASHll] = ACTIONS(1313),
    [anon_sym_u226a] = ACTIONS(1313),
    [anon_sym_BSLASHnotin] = ACTIONS(1315),
    [anon_sym_u2209] = ACTIONS(1315),
    [anon_sym_BSLASHprec] = ACTIONS(1317),
    [anon_sym_u227a] = ACTIONS(1319),
    [anon_sym_BSLASHsucc] = ACTIONS(1321),
    [anon_sym_u227b] = ACTIONS(1323),
    [anon_sym_BSLASHpreceq] = ACTIONS(1325),
    [anon_sym_u2aaf] = ACTIONS(1325),
    [anon_sym_BSLASHsucceq] = ACTIONS(1327),
    [anon_sym_u2ab0] = ACTIONS(1327),
    [anon_sym_BSLASHpropto] = ACTIONS(1329),
    [anon_sym_u221d] = ACTIONS(1329),
    [anon_sym_BSLASHsim] = ACTIONS(1331),
    [anon_sym_u223c] = ACTIONS(1333),
    [anon_sym_BSLASHsimeq] = ACTIONS(1335),
    [anon_sym_u2243] = ACTIONS(1335),
    [anon_sym_BSLASHsqsubset] = ACTIONS(1337),
    [anon_sym_u228f] = ACTIONS(1339),
    [anon_sym_BSLASHsqsupset] = ACTIONS(1341),
    [anon_sym_u2290] = ACTIONS(1343),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(1345),
    [anon_sym_u2291] = ACTIONS(1345),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(1347),
    [anon_sym_u2292] = ACTIONS(1347),
    [anon_sym_BSLASHsubset] = ACTIONS(1349),
    [anon_sym_u2282] = ACTIONS(1351),
    [anon_sym_BSLASHsupset] = ACTIONS(1353),
    [anon_sym_u2283] = ACTIONS(1355),
    [anon_sym_BSLASHsubseteq] = ACTIONS(1357),
    [anon_sym_u2286] = ACTIONS(1357),
    [anon_sym_BSLASHsupseteq] = ACTIONS(1359),
    [anon_sym_u2287] = ACTIONS(1359),
    [sym_compose] = ACTIONS(1361),
    [sym_map_to] = ACTIONS(1361),
    [sym_map_from] = ACTIONS(1361),
    [sym_setminus] = ACTIONS(1287),
    [anon_sym_BSLASHcap] = ACTIONS(1363),
    [anon_sym_BSLASHintersect] = ACTIONS(1363),
    [anon_sym_u2229] = ACTIONS(1363),
    [anon_sym_BSLASHcup] = ACTIONS(1365),
    [anon_sym_BSLASHunion] = ACTIONS(1365),
    [anon_sym_u222a] = ACTIONS(1365),
    [anon_sym_DOT_DOT] = ACTIONS(1367),
    [anon_sym_u2025] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_u2026] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1373),
    [sym_plusplus] = ACTIONS(1361),
    [anon_sym_BSLASHoplus] = ACTIONS(1375),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(1375),
    [anon_sym_u2295] = ACTIONS(1375),
    [anon_sym_BSLASHominus] = ACTIONS(1377),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(1377),
    [anon_sym_u2296] = ACTIONS(1377),
    [sym_mod] = ACTIONS(1287),
    [sym_modmod] = ACTIONS(1361),
    [sym_vert] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1379),
    [anon_sym_u2016] = ACTIONS(1379),
    [sym_minusminus] = ACTIONS(1361),
    [sym_amp] = ACTIONS(1287),
    [sym_ampamp] = ACTIONS(1361),
    [anon_sym_BSLASHodot] = ACTIONS(1381),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(1381),
    [anon_sym_u2299] = ACTIONS(1381),
    [anon_sym_BSLASHoslash] = ACTIONS(1383),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(1383),
    [anon_sym_u2298] = ACTIONS(1383),
    [anon_sym_BSLASHotimes] = ACTIONS(1385),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(1385),
    [anon_sym_u2297] = ACTIONS(1385),
    [sym_mul] = ACTIONS(1287),
    [sym_mulmul] = ACTIONS(1361),
    [sym_slash] = ACTIONS(1287),
    [sym_slashslash] = ACTIONS(1361),
    [anon_sym_BSLASHbigcirc] = ACTIONS(1387),
    [anon_sym_u25ef] = ACTIONS(1387),
    [anon_sym_BSLASHbullet] = ACTIONS(1389),
    [anon_sym_u25cf] = ACTIONS(1389),
    [anon_sym_BSLASHdiv] = ACTIONS(1391),
    [anon_sym_u00f7] = ACTIONS(1391),
    [anon_sym_BSLASHcirc] = ACTIONS(1393),
    [anon_sym_u2218] = ACTIONS(1393),
    [anon_sym_BSLASHstar] = ACTIONS(1395),
    [anon_sym_u22c6] = ACTIONS(1395),
    [anon_sym_u203c] = ACTIONS(1397),
    [sym_hashhash] = ACTIONS(1361),
    [sym_dol] = ACTIONS(1287),
    [sym_doldol] = ACTIONS(1361),
    [anon_sym_QMARK_QMARK] = ACTIONS(1399),
    [anon_sym_u2047] = ACTIONS(1399),
    [anon_sym_BSLASHsqcap] = ACTIONS(1401),
    [anon_sym_u2293] = ACTIONS(1401),
    [anon_sym_BSLASHsqcup] = ACTIONS(1403),
    [anon_sym_u2294] = ACTIONS(1403),
    [anon_sym_BSLASHuplus] = ACTIONS(1405),
    [anon_sym_u228e] = ACTIONS(1405),
    [anon_sym_BSLASHX] = ACTIONS(1407),
    [anon_sym_BSLASHtimes] = ACTIONS(1407),
    [anon_sym_u00d7] = ACTIONS(1407),
    [anon_sym_BSLASHwr] = ACTIONS(1409),
    [anon_sym_u2240] = ACTIONS(1409),
    [anon_sym_BSLASHcdot] = ACTIONS(1411),
    [anon_sym_u22c5] = ACTIONS(1411),
    [sym_pow] = ACTIONS(1287),
    [sym_powpow] = ACTIONS(1361),
    [anon_sym_CARET_PLUS] = ACTIONS(1413),
    [anon_sym_u207a] = ACTIONS(1413),
    [sym_asterisk] = ACTIONS(1415),
    [sym_sup_hash] = ACTIONS(1415),
    [sym_prime] = ACTIONS(1415),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(1397),
  },
  [68] = {
    [sym_block_comment] = STATE(68),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(5471),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1524),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1417),
    [anon_sym_u3009] = ACTIONS(1417),
    [anon_sym_u27e9] = ACTIONS(1417),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [69] = {
    [sym_block_comment] = STATE(69),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(3159),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1529),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(986),
    [anon_sym_u3009] = ACTIONS(986),
    [anon_sym_u27e9] = ACTIONS(986),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [70] = {
    [sym_block_comment] = STATE(70),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(2927),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1535),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1419),
    [anon_sym_u3009] = ACTIONS(1419),
    [anon_sym_u27e9] = ACTIONS(1419),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [71] = {
    [sym_block_comment] = STATE(71),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(3399),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1523),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1421),
    [anon_sym_u3009] = ACTIONS(1421),
    [anon_sym_u27e9] = ACTIONS(1421),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [72] = {
    [sym_block_comment] = STATE(72),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(3302),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1520),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1423),
    [anon_sym_u3009] = ACTIONS(1423),
    [anon_sym_u27e9] = ACTIONS(1423),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [73] = {
    [sym_block_comment] = STATE(73),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(2693),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1526),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1425),
    [anon_sym_u3009] = ACTIONS(1425),
    [anon_sym_u27e9] = ACTIONS(1425),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [74] = {
    [sym_block_comment] = STATE(74),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(3293),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1530),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1427),
    [anon_sym_u3009] = ACTIONS(1427),
    [anon_sym_u27e9] = ACTIONS(1427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [75] = {
    [sym_block_comment] = STATE(75),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(2985),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1525),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_u3009] = ACTIONS(1429),
    [anon_sym_u27e9] = ACTIONS(1429),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [76] = {
    [sym_block_comment] = STATE(76),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(2395),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1522),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1431),
    [anon_sym_u3009] = ACTIONS(1431),
    [anon_sym_u27e9] = ACTIONS(1431),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [77] = {
    [sym_block_comment] = STATE(77),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(2330),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1531),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1433),
    [anon_sym_u3009] = ACTIONS(1433),
    [anon_sym_u27e9] = ACTIONS(1433),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [78] = {
    [sym_block_comment] = STATE(78),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(2654),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1534),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_u3009] = ACTIONS(1435),
    [anon_sym_u27e9] = ACTIONS(1435),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [79] = {
    [sym_block_comment] = STATE(79),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(2893),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1527),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [anon_sym_u3009] = ACTIONS(1437),
    [anon_sym_u27e9] = ACTIONS(1437),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [80] = {
    [sym_block_comment] = STATE(80),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(3230),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1533),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_u3009] = ACTIONS(1439),
    [anon_sym_u27e9] = ACTIONS(1439),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [81] = {
    [sym_block_comment] = STATE(81),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_rangle_bracket] = STATE(2776),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1521),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_GT_GT] = ACTIONS(1441),
    [anon_sym_u3009] = ACTIONS(1441),
    [anon_sym_u27e9] = ACTIONS(1441),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [82] = {
    [sym_block_comment] = STATE(82),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4733),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [83] = {
    [sym_block_comment] = STATE(83),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4799),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [84] = {
    [sym_block_comment] = STATE(84),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4733),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [85] = {
    [sym_block_comment] = STATE(85),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4736),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [86] = {
    [sym_block_comment] = STATE(86),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4746),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [87] = {
    [sym_block_comment] = STATE(87),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym__op_or_expr] = STATE(3848),
    [sym__op] = STATE(3843),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym_lambda] = STATE(3844),
    [sym__expr] = STATE(1891),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(183),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(182),
    [sym_eventually] = STATE(182),
    [sym_prefix_op_symbol] = STATE(4410),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3799),
    [sym_plus_arrow] = STATE(3799),
    [sym_equiv] = STATE(3799),
    [sym_iff] = STATE(3799),
    [sym_leads_to] = STATE(3799),
    [sym_land] = STATE(3799),
    [sym_lor] = STATE(3799),
    [sym_assign] = STATE(3799),
    [sym_bnf_rule] = STATE(3799),
    [sym_eq] = STATE(3799),
    [sym_neq] = STATE(3799),
    [sym_lt] = STATE(3799),
    [sym_leq] = STATE(3799),
    [sym_geq] = STATE(3799),
    [sym_approx] = STATE(3799),
    [sym_rs_ttile] = STATE(3799),
    [sym_rd_ttile] = STATE(3799),
    [sym_ls_ttile] = STATE(3799),
    [sym_ld_ttile] = STATE(3799),
    [sym_asymp] = STATE(3799),
    [sym_cong] = STATE(3799),
    [sym_doteq] = STATE(3799),
    [sym_gg] = STATE(3799),
    [sym_ll] = STATE(3799),
    [sym_in] = STATE(3799),
    [sym_notin] = STATE(3799),
    [sym_prec] = STATE(3799),
    [sym_succ] = STATE(3799),
    [sym_preceq] = STATE(3799),
    [sym_succeq] = STATE(3799),
    [sym_propto] = STATE(3799),
    [sym_sim] = STATE(3799),
    [sym_simeq] = STATE(3799),
    [sym_sqsubset] = STATE(3799),
    [sym_sqsupset] = STATE(3799),
    [sym_sqsubseteq] = STATE(3799),
    [sym_sqsupseteq] = STATE(3799),
    [sym_subset] = STATE(3799),
    [sym_supset] = STATE(3799),
    [sym_subseteq] = STATE(3799),
    [sym_supseteq] = STATE(3799),
    [sym_cap] = STATE(3799),
    [sym_cup] = STATE(3799),
    [sym_dots_2] = STATE(3799),
    [sym_dots_3] = STATE(3799),
    [sym_plus] = STATE(3799),
    [sym_oplus] = STATE(3799),
    [sym_ominus] = STATE(3799),
    [sym_vertvert] = STATE(3799),
    [sym_minus] = STATE(3799),
    [sym_odot] = STATE(3799),
    [sym_oslash] = STATE(3799),
    [sym_otimes] = STATE(3799),
    [sym_bigcirc] = STATE(3799),
    [sym_bullet] = STATE(3799),
    [sym_div] = STATE(3799),
    [sym_circ] = STATE(3799),
    [sym_star] = STATE(3799),
    [sym_excl] = STATE(3799),
    [sym_qq] = STATE(3799),
    [sym_sqcap] = STATE(3799),
    [sym_sqcup] = STATE(3799),
    [sym_uplus] = STATE(3799),
    [sym_times] = STATE(3799),
    [sym_wr] = STATE(3799),
    [sym_cdot] = STATE(3799),
    [sym_infix_op_symbol] = STATE(4411),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3809),
    [sym_postfix_op_symbol] = STATE(4410),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(684),
    [anon_sym_u2208] = ACTIONS(686),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(688),
    [anon_sym_u25a1] = ACTIONS(688),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(690),
    [anon_sym_u2227] = ACTIONS(690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(692),
    [anon_sym_u2228] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [anon_sym_LAMBDA] = ACTIONS(694),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(696),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(698),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(700),
    [anon_sym_BSLASHneg] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_u00ac] = ACTIONS(700),
    [sym_union] = ACTIONS(704),
    [sym_powerset] = ACTIONS(704),
    [sym_domain] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(706),
    [sym_negative_dot] = ACTIONS(708),
    [sym_enabled] = ACTIONS(710),
    [sym_unchanged] = ACTIONS(710),
    [anon_sym_LT_GT] = ACTIONS(712),
    [anon_sym_u22c4] = ACTIONS(712),
    [anon_sym_u25c7] = ACTIONS(712),
    [anon_sym_EQ_GT] = ACTIONS(714),
    [anon_sym_u27f9] = ACTIONS(714),
    [anon_sym_u21d2] = ACTIONS(714),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(716),
    [anon_sym_u21f8] = ACTIONS(716),
    [anon_sym_u2945] = ACTIONS(716),
    [anon_sym_BSLASHequiv] = ACTIONS(718),
    [anon_sym_u2261] = ACTIONS(718),
    [anon_sym_LT_EQ_GT] = ACTIONS(720),
    [anon_sym_u27fa] = ACTIONS(720),
    [anon_sym_u21d4] = ACTIONS(720),
    [anon_sym_TILDE_GT] = ACTIONS(722),
    [anon_sym_u21dd] = ACTIONS(722),
    [anon_sym_u219d] = ACTIONS(722),
    [anon_sym_BSLASHland] = ACTIONS(690),
    [anon_sym_BSLASHlor] = ACTIONS(692),
    [anon_sym_COLON_EQ] = ACTIONS(724),
    [anon_sym_u2254] = ACTIONS(724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(726),
    [anon_sym_u2a74] = ACTIONS(726),
    [anon_sym_SLASH_EQ] = ACTIONS(728),
    [anon_sym_POUND] = ACTIONS(730),
    [anon_sym_u2260] = ACTIONS(728),
    [anon_sym_LT] = ACTIONS(732),
    [sym_gt] = ACTIONS(734),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_EQ_LT] = ACTIONS(738),
    [anon_sym_BSLASHleq] = ACTIONS(738),
    [anon_sym_u2264] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(740),
    [anon_sym_BSLASHgeq] = ACTIONS(740),
    [anon_sym_u2265] = ACTIONS(740),
    [anon_sym_BSLASHapprox] = ACTIONS(742),
    [anon_sym_u2248] = ACTIONS(742),
    [anon_sym_PIPE_DASH] = ACTIONS(744),
    [anon_sym_u22a2] = ACTIONS(744),
    [anon_sym_PIPE_EQ] = ACTIONS(746),
    [anon_sym_u22a8] = ACTIONS(746),
    [anon_sym_DASH_PIPE] = ACTIONS(748),
    [anon_sym_u22a3] = ACTIONS(748),
    [anon_sym_EQ_PIPE] = ACTIONS(750),
    [anon_sym_u2ae4] = ACTIONS(750),
    [anon_sym_BSLASHasymp] = ACTIONS(752),
    [anon_sym_u224d] = ACTIONS(752),
    [anon_sym_BSLASHcong] = ACTIONS(754),
    [anon_sym_u2245] = ACTIONS(754),
    [anon_sym_BSLASHdoteq] = ACTIONS(756),
    [anon_sym_u2250] = ACTIONS(756),
    [anon_sym_BSLASHgg] = ACTIONS(758),
    [anon_sym_u226b] = ACTIONS(758),
    [anon_sym_BSLASHll] = ACTIONS(760),
    [anon_sym_u226a] = ACTIONS(760),
    [anon_sym_BSLASHnotin] = ACTIONS(762),
    [anon_sym_u2209] = ACTIONS(762),
    [anon_sym_BSLASHprec] = ACTIONS(764),
    [anon_sym_u227a] = ACTIONS(766),
    [anon_sym_BSLASHsucc] = ACTIONS(768),
    [anon_sym_u227b] = ACTIONS(770),
    [anon_sym_BSLASHpreceq] = ACTIONS(772),
    [anon_sym_u2aaf] = ACTIONS(772),
    [anon_sym_BSLASHsucceq] = ACTIONS(774),
    [anon_sym_u2ab0] = ACTIONS(774),
    [anon_sym_BSLASHpropto] = ACTIONS(776),
    [anon_sym_u221d] = ACTIONS(776),
    [anon_sym_BSLASHsim] = ACTIONS(778),
    [anon_sym_u223c] = ACTIONS(780),
    [anon_sym_BSLASHsimeq] = ACTIONS(782),
    [anon_sym_u2243] = ACTIONS(782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(784),
    [anon_sym_u228f] = ACTIONS(786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(788),
    [anon_sym_u2290] = ACTIONS(790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(792),
    [anon_sym_u2291] = ACTIONS(792),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(794),
    [anon_sym_u2292] = ACTIONS(794),
    [anon_sym_BSLASHsubset] = ACTIONS(796),
    [anon_sym_u2282] = ACTIONS(798),
    [anon_sym_BSLASHsupset] = ACTIONS(800),
    [anon_sym_u2283] = ACTIONS(802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(804),
    [anon_sym_u2286] = ACTIONS(804),
    [anon_sym_BSLASHsupseteq] = ACTIONS(806),
    [anon_sym_u2287] = ACTIONS(806),
    [sym_compose] = ACTIONS(808),
    [sym_map_to] = ACTIONS(808),
    [sym_map_from] = ACTIONS(808),
    [sym_setminus] = ACTIONS(734),
    [anon_sym_BSLASHcap] = ACTIONS(810),
    [anon_sym_BSLASHintersect] = ACTIONS(810),
    [anon_sym_u2229] = ACTIONS(810),
    [anon_sym_BSLASHcup] = ACTIONS(812),
    [anon_sym_BSLASHunion] = ACTIONS(812),
    [anon_sym_u222a] = ACTIONS(812),
    [anon_sym_DOT_DOT] = ACTIONS(814),
    [anon_sym_u2025] = ACTIONS(816),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(818),
    [anon_sym_u2026] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [sym_plusplus] = ACTIONS(808),
    [anon_sym_BSLASHoplus] = ACTIONS(822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(822),
    [anon_sym_u2295] = ACTIONS(822),
    [anon_sym_BSLASHominus] = ACTIONS(824),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(824),
    [anon_sym_u2296] = ACTIONS(824),
    [sym_mod] = ACTIONS(734),
    [sym_modmod] = ACTIONS(808),
    [sym_vert] = ACTIONS(734),
    [anon_sym_PIPE_PIPE] = ACTIONS(826),
    [anon_sym_u2016] = ACTIONS(826),
    [sym_minusminus] = ACTIONS(808),
    [sym_amp] = ACTIONS(734),
    [sym_ampamp] = ACTIONS(808),
    [anon_sym_BSLASHodot] = ACTIONS(828),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(828),
    [anon_sym_u2299] = ACTIONS(828),
    [anon_sym_BSLASHoslash] = ACTIONS(830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(830),
    [anon_sym_u2298] = ACTIONS(830),
    [anon_sym_BSLASHotimes] = ACTIONS(832),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(832),
    [anon_sym_u2297] = ACTIONS(832),
    [sym_mul] = ACTIONS(734),
    [sym_mulmul] = ACTIONS(808),
    [sym_slash] = ACTIONS(734),
    [sym_slashslash] = ACTIONS(808),
    [anon_sym_BSLASHbigcirc] = ACTIONS(834),
    [anon_sym_u25ef] = ACTIONS(834),
    [anon_sym_BSLASHbullet] = ACTIONS(836),
    [anon_sym_u25cf] = ACTIONS(836),
    [anon_sym_BSLASHdiv] = ACTIONS(838),
    [anon_sym_u00f7] = ACTIONS(838),
    [anon_sym_BSLASHcirc] = ACTIONS(840),
    [anon_sym_u2218] = ACTIONS(840),
    [anon_sym_BSLASHstar] = ACTIONS(842),
    [anon_sym_u22c6] = ACTIONS(842),
    [anon_sym_u203c] = ACTIONS(844),
    [sym_hashhash] = ACTIONS(808),
    [sym_dol] = ACTIONS(734),
    [sym_doldol] = ACTIONS(808),
    [anon_sym_QMARK_QMARK] = ACTIONS(846),
    [anon_sym_u2047] = ACTIONS(846),
    [anon_sym_BSLASHsqcap] = ACTIONS(848),
    [anon_sym_u2293] = ACTIONS(848),
    [anon_sym_BSLASHsqcup] = ACTIONS(850),
    [anon_sym_u2294] = ACTIONS(850),
    [anon_sym_BSLASHuplus] = ACTIONS(852),
    [anon_sym_u228e] = ACTIONS(852),
    [anon_sym_BSLASHX] = ACTIONS(854),
    [anon_sym_BSLASHtimes] = ACTIONS(854),
    [anon_sym_u00d7] = ACTIONS(854),
    [anon_sym_BSLASHwr] = ACTIONS(856),
    [anon_sym_u2240] = ACTIONS(856),
    [anon_sym_BSLASHcdot] = ACTIONS(858),
    [anon_sym_u22c5] = ACTIONS(858),
    [sym_pow] = ACTIONS(734),
    [sym_powpow] = ACTIONS(808),
    [anon_sym_CARET_PLUS] = ACTIONS(860),
    [anon_sym_u207a] = ACTIONS(860),
    [sym_asterisk] = ACTIONS(862),
    [sym_sup_hash] = ACTIONS(862),
    [sym_prime] = ACTIONS(862),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(844),
  },
  [88] = {
    [sym_block_comment] = STATE(88),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4890),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [89] = {
    [sym_block_comment] = STATE(89),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4905),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [90] = {
    [sym_block_comment] = STATE(90),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4890),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [91] = {
    [sym_block_comment] = STATE(91),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4642),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [92] = {
    [sym_block_comment] = STATE(92),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4585),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [93] = {
    [sym_block_comment] = STATE(93),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4642),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [94] = {
    [sym_block_comment] = STATE(94),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4698),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [95] = {
    [sym_block_comment] = STATE(95),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4651),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [96] = {
    [sym_block_comment] = STATE(96),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4698),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [97] = {
    [sym_block_comment] = STATE(97),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4756),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [98] = {
    [sym_block_comment] = STATE(98),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4707),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [99] = {
    [sym_block_comment] = STATE(99),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4756),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [100] = {
    [sym_block_comment] = STATE(100),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4804),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [101] = {
    [sym_block_comment] = STATE(101),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4761),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [102] = {
    [sym_block_comment] = STATE(102),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4804),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [103] = {
    [sym_block_comment] = STATE(103),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4840),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [104] = {
    [sym_block_comment] = STATE(104),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4808),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [105] = {
    [sym_block_comment] = STATE(105),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4840),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [106] = {
    [sym_block_comment] = STATE(106),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4430),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [107] = {
    [sym_block_comment] = STATE(107),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4846),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [108] = {
    [sym_block_comment] = STATE(108),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4901),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [109] = {
    [sym_block_comment] = STATE(109),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4463),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [110] = {
    [sym_block_comment] = STATE(110),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4908),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [111] = {
    [sym_block_comment] = STATE(111),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4430),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [112] = {
    [sym_block_comment] = STATE(112),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4484),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [113] = {
    [sym_block_comment] = STATE(113),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4436),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [114] = {
    [sym_block_comment] = STATE(114),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4463),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [115] = {
    [sym_block_comment] = STATE(115),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4505),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [116] = {
    [sym_block_comment] = STATE(116),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4467),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [117] = {
    [sym_block_comment] = STATE(117),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4484),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [118] = {
    [sym_block_comment] = STATE(118),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4901),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [119] = {
    [sym_block_comment] = STATE(119),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4931),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [120] = {
    [sym_block_comment] = STATE(120),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4505),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [121] = {
    [sym_block_comment] = STATE(121),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4529),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [122] = {
    [sym_block_comment] = STATE(122),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4509),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [123] = {
    [sym_block_comment] = STATE(123),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4529),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [124] = {
    [sym_block_comment] = STATE(124),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4552),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [125] = {
    [sym_block_comment] = STATE(125),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4532),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [126] = {
    [sym_block_comment] = STATE(126),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4552),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [127] = {
    [sym_block_comment] = STATE(127),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4554),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [128] = {
    [sym_block_comment] = STATE(128),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym__op_or_expr] = STATE(3510),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1285),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(9),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(7),
    [sym_eventually] = STATE(7),
    [sym_prefix_op_symbol] = STATE(3537),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(3542),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3532),
    [sym_postfix_op_symbol] = STATE(3537),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(882),
    [anon_sym_u25a1] = ACTIONS(882),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [anon_sym_LAMBDA] = ACTIONS(884),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(886),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(888),
    [anon_sym_BSLASHneg] = ACTIONS(888),
    [anon_sym_TILDE] = ACTIONS(890),
    [anon_sym_u00ac] = ACTIONS(888),
    [sym_union] = ACTIONS(892),
    [sym_powerset] = ACTIONS(892),
    [sym_domain] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(894),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(896),
    [sym_unchanged] = ACTIONS(896),
    [anon_sym_LT_GT] = ACTIONS(898),
    [anon_sym_u22c4] = ACTIONS(898),
    [anon_sym_u25c7] = ACTIONS(898),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(900),
    [anon_sym_u207a] = ACTIONS(900),
    [sym_asterisk] = ACTIONS(902),
    [sym_sup_hash] = ACTIONS(902),
    [sym_prime] = ACTIONS(902),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [129] = {
    [sym_block_comment] = STATE(129),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym__op_or_expr] = STATE(3509),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1285),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(9),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(7),
    [sym_eventually] = STATE(7),
    [sym_prefix_op_symbol] = STATE(3537),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(3542),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3532),
    [sym_postfix_op_symbol] = STATE(3537),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(882),
    [anon_sym_u25a1] = ACTIONS(882),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [anon_sym_LAMBDA] = ACTIONS(884),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(886),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(888),
    [anon_sym_BSLASHneg] = ACTIONS(888),
    [anon_sym_TILDE] = ACTIONS(890),
    [anon_sym_u00ac] = ACTIONS(888),
    [sym_union] = ACTIONS(892),
    [sym_powerset] = ACTIONS(892),
    [sym_domain] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(894),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(896),
    [sym_unchanged] = ACTIONS(896),
    [anon_sym_LT_GT] = ACTIONS(898),
    [anon_sym_u22c4] = ACTIONS(898),
    [anon_sym_u25c7] = ACTIONS(898),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(900),
    [anon_sym_u207a] = ACTIONS(900),
    [sym_asterisk] = ACTIONS(902),
    [sym_sup_hash] = ACTIONS(902),
    [sym_prime] = ACTIONS(902),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [130] = {
    [sym_block_comment] = STATE(130),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym__op_or_expr] = STATE(4736),
    [sym__op] = STATE(3501),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym_lambda] = STATE(3502),
    [sym__expr] = STATE(1898),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4270),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4380),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4270),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [anon_sym_LAMBDA] = ACTIONS(680),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [131] = {
    [sym_block_comment] = STATE(131),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1763),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3125),
    [sym_other_arm] = STATE(3093),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1525),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [132] = {
    [sym_block_comment] = STATE(132),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1437),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1545),
    [anon_sym_u2115] = ACTIONS(1548),
    [anon_sym_Int] = ACTIONS(1551),
    [anon_sym_u2124] = ACTIONS(1554),
    [anon_sym_Real] = ACTIONS(1557),
    [anon_sym_u211d] = ACTIONS(1560),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(1563),
    [sym_powerset] = ACTIONS(1563),
    [sym_domain] = ACTIONS(1563),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(1566),
    [sym_unchanged] = ACTIONS(1566),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__begin_proof_step] = ACTIONS(324),
    [sym__double_excl] = ACTIONS(277),
  },
  [133] = {
    [sym_block_comment] = STATE(133),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1439),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1545),
    [anon_sym_u2115] = ACTIONS(1548),
    [anon_sym_Int] = ACTIONS(1551),
    [anon_sym_u2124] = ACTIONS(1554),
    [anon_sym_Real] = ACTIONS(1557),
    [anon_sym_u211d] = ACTIONS(1560),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(1563),
    [sym_powerset] = ACTIONS(1563),
    [sym_domain] = ACTIONS(1563),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(1566),
    [sym_unchanged] = ACTIONS(1566),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__begin_proof_step] = ACTIONS(324),
    [sym__double_excl] = ACTIONS(277),
  },
  [134] = {
    [sym_block_comment] = STATE(134),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1792),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5243),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1573),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [135] = {
    [sym_block_comment] = STATE(135),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1757),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2266),
    [sym_other_arm] = STATE(2267),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1575),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [136] = {
    [sym_block_comment] = STATE(136),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1757),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2266),
    [sym_other_arm] = STATE(2283),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1575),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [137] = {
    [sym_block_comment] = STATE(137),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1760),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5287),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [138] = {
    [sym_block_comment] = STATE(138),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1761),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2573),
    [sym_other_arm] = STATE(2574),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1579),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [139] = {
    [sym_block_comment] = STATE(139),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1761),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2573),
    [sym_other_arm] = STATE(2605),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1579),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [140] = {
    [sym_block_comment] = STATE(140),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1762),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5303),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1581),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [141] = {
    [sym_block_comment] = STATE(141),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1763),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3125),
    [sym_other_arm] = STATE(3088),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1525),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [142] = {
    [sym_block_comment] = STATE(142),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1764),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5317),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1583),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [143] = {
    [sym_block_comment] = STATE(143),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1765),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2982),
    [sym_other_arm] = STATE(2983),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1585),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [144] = {
    [sym_block_comment] = STATE(144),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1765),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2982),
    [sym_other_arm] = STATE(2913),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1585),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [145] = {
    [sym_block_comment] = STATE(145),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1767),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5328),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1587),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [146] = {
    [sym_block_comment] = STATE(146),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1758),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5499),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [147] = {
    [sym_block_comment] = STATE(147),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1768),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3357),
    [sym_other_arm] = STATE(3358),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1591),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [148] = {
    [sym_block_comment] = STATE(148),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1768),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3357),
    [sym_other_arm] = STATE(3369),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1591),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [149] = {
    [sym_block_comment] = STATE(149),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1769),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5339),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1593),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [150] = {
    [sym_block_comment] = STATE(150),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1770),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3275),
    [sym_other_arm] = STATE(3318),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1595),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [151] = {
    [sym_block_comment] = STATE(151),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1770),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3275),
    [sym_other_arm] = STATE(3183),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1595),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [152] = {
    [sym_block_comment] = STATE(152),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1771),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5350),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [153] = {
    [sym_block_comment] = STATE(153),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1772),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2679),
    [sym_other_arm] = STATE(2685),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1599),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [154] = {
    [sym_block_comment] = STATE(154),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1772),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2679),
    [sym_other_arm] = STATE(2711),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1599),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [155] = {
    [sym_block_comment] = STATE(155),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1436),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(328),
    [anon_sym_u25a1] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1545),
    [anon_sym_u2115] = ACTIONS(1548),
    [anon_sym_Int] = ACTIONS(1551),
    [anon_sym_u2124] = ACTIONS(1554),
    [anon_sym_Real] = ACTIONS(1557),
    [anon_sym_u211d] = ACTIONS(1560),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(390),
    [anon_sym_BSLASHneg] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_u00ac] = ACTIONS(390),
    [sym_union] = ACTIONS(1563),
    [sym_powerset] = ACTIONS(1563),
    [sym_domain] = ACTIONS(1563),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(399),
    [sym_enabled] = ACTIONS(1566),
    [sym_unchanged] = ACTIONS(1566),
    [anon_sym_LT_GT] = ACTIONS(405),
    [anon_sym_u22c4] = ACTIONS(405),
    [anon_sym_u25c7] = ACTIONS(405),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__begin_proof_step] = ACTIONS(324),
    [sym__double_excl] = ACTIONS(277),
  },
  [156] = {
    [sym_block_comment] = STATE(156),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1774),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3234),
    [sym_other_arm] = STATE(3310),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1601),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [157] = {
    [sym_block_comment] = STATE(157),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1774),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3234),
    [sym_other_arm] = STATE(3298),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1601),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [158] = {
    [sym_block_comment] = STATE(158),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1776),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5372),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [159] = {
    [sym_block_comment] = STATE(159),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1786),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2989),
    [sym_other_arm] = STATE(2990),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1605),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [160] = {
    [sym_block_comment] = STATE(160),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1786),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2989),
    [sym_other_arm] = STATE(3028),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1605),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [161] = {
    [sym_block_comment] = STATE(161),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1778),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5383),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1607),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [162] = {
    [sym_block_comment] = STATE(162),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1777),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2466),
    [sym_other_arm] = STATE(2467),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1609),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [163] = {
    [sym_block_comment] = STATE(163),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1777),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2466),
    [sym_other_arm] = STATE(2484),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1609),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [164] = {
    [sym_block_comment] = STATE(164),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1780),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5394),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [165] = {
    [sym_block_comment] = STATE(165),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1779),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2315),
    [sym_other_arm] = STATE(2316),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1613),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [166] = {
    [sym_block_comment] = STATE(166),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1779),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2315),
    [sym_other_arm] = STATE(2320),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1613),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [167] = {
    [sym_block_comment] = STATE(167),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1782),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5405),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1615),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [168] = {
    [sym_block_comment] = STATE(168),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1781),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2628),
    [sym_other_arm] = STATE(2629),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1617),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [169] = {
    [sym_block_comment] = STATE(169),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1781),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2628),
    [sym_other_arm] = STATE(2638),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1617),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [170] = {
    [sym_block_comment] = STATE(170),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1785),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5416),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1619),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [171] = {
    [sym_block_comment] = STATE(171),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1783),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2873),
    [sym_other_arm] = STATE(2874),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1621),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [172] = {
    [sym_block_comment] = STATE(172),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1783),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2873),
    [sym_other_arm] = STATE(2846),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1621),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [173] = {
    [sym_block_comment] = STATE(173),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1787),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5427),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1623),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [174] = {
    [sym_block_comment] = STATE(174),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1788),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3341),
    [sym_other_arm] = STATE(3168),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1625),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [175] = {
    [sym_block_comment] = STATE(175),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1788),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3341),
    [sym_other_arm] = STATE(3231),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1625),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [176] = {
    [sym_block_comment] = STATE(176),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1789),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5438),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [177] = {
    [sym_block_comment] = STATE(177),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1790),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2743),
    [sym_other_arm] = STATE(2746),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1629),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [178] = {
    [sym_block_comment] = STATE(178),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1790),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2743),
    [sym_other_arm] = STATE(2759),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1629),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [179] = {
    [sym_block_comment] = STATE(179),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1791),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5448),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1631),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [180] = {
    [sym_block_comment] = STATE(180),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1759),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2495),
    [sym_other_arm] = STATE(2397),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1633),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [181] = {
    [sym_block_comment] = STATE(181),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1677),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(614),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__begin_proof_step] = ACTIONS(324),
    [sym__double_excl] = ACTIONS(277),
  },
  [182] = {
    [sym_block_comment] = STATE(182),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1678),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(614),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__begin_proof_step] = ACTIONS(324),
    [sym__double_excl] = ACTIONS(277),
  },
  [183] = {
    [sym_block_comment] = STATE(183),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1685),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_COMMA] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(614),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__begin_proof_step] = ACTIONS(324),
    [sym__double_excl] = ACTIONS(277),
  },
  [184] = {
    [sym_block_comment] = STATE(184),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1759),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2495),
    [sym_other_arm] = STATE(2390),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_OTHER] = ACTIONS(1633),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [185] = {
    [sym_block_comment] = STATE(185),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(62),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1773),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_restricted_quantifier_bound] = STATE(5361),
    [sym_tuple_of_identifiers] = STATE(4866),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(1638),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [186] = {
    [sym_block_comment] = STATE(186),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1102),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_assume_prove] = STATE(3497),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(1700),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [187] = {
    [sym_block_comment] = STATE(187),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_instance] = STATE(3525),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1421),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_INSTANCE] = ACTIONS(1704),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [188] = {
    [sym_block_comment] = STATE(188),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1101),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_assume_prove] = STATE(3495),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(1770),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [189] = {
    [sym_block_comment] = STATE(189),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_instance] = STATE(3524),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1302),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [anon_sym_INSTANCE] = ACTIONS(1774),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [190] = {
    [sym_block_comment] = STATE(190),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_instance] = STATE(3526),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1300),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [anon_sym_INSTANCE] = ACTIONS(1774),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [191] = {
    [sym_block_comment] = STATE(191),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_instance] = STATE(3525),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1291),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [anon_sym_INSTANCE] = ACTIONS(1774),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [192] = {
    [sym_block_comment] = STATE(192),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1567),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_assume_prove] = STATE(3942),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(297),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [193] = {
    [sym_block_comment] = STATE(193),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1104),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_assume_prove] = STATE(3494),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(1770),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [194] = {
    [sym_block_comment] = STATE(194),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1737),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4123),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [195] = {
    [sym_block_comment] = STATE(195),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_instance] = STATE(3869),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1473),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_INSTANCE] = ACTIONS(1800),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [196] = {
    [sym_block_comment] = STATE(196),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_instance] = STATE(3868),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1475),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_INSTANCE] = ACTIONS(1800),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [197] = {
    [sym_block_comment] = STATE(197),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_instance] = STATE(3856),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1469),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_INSTANCE] = ACTIONS(1800),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [198] = {
    [sym_block_comment] = STATE(198),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1237),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_module_ref] = STATE(3520),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [199] = {
    [sym_block_comment] = STATE(199),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_instance] = STATE(3847),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1435),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_INSTANCE] = ACTIONS(1806),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [200] = {
    [sym_block_comment] = STATE(200),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_instance] = STATE(3524),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1292),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [anon_sym_INSTANCE] = ACTIONS(23),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [201] = {
    [sym_block_comment] = STATE(201),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1360),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_assume_prove] = STATE(4996),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(546),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [202] = {
    [sym_block_comment] = STATE(202),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1649),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4089),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [203] = {
    [sym_block_comment] = STATE(203),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1103),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_assume_prove] = STATE(3500),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [anon_sym_ASSUME] = ACTIONS(1700),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [204] = {
    [sym_block_comment] = STATE(204),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_instance] = STATE(3850),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1430),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_INSTANCE] = ACTIONS(1806),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [205] = {
    [sym_block_comment] = STATE(205),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_instance] = STATE(3525),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1290),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [anon_sym_INSTANCE] = ACTIONS(23),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [206] = {
    [sym_block_comment] = STATE(206),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1637),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4071),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [207] = {
    [sym_block_comment] = STATE(207),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_instance] = STATE(3524),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1411),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_INSTANCE] = ACTIONS(1704),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [208] = {
    [sym_block_comment] = STATE(208),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_instance] = STATE(3526),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1388),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_INSTANCE] = ACTIONS(1704),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [209] = {
    [sym_block_comment] = STATE(209),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1246),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_module_ref] = STATE(3520),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(554),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [210] = {
    [sym_block_comment] = STATE(210),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_instance] = STATE(3846),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1432),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_INSTANCE] = ACTIONS(1806),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [211] = {
    [sym_block_comment] = STATE(211),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1636),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4073),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [212] = {
    [sym_block_comment] = STATE(212),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1676),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4082),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [213] = {
    [sym_block_comment] = STATE(213),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1679),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4085),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [214] = {
    [sym_block_comment] = STATE(214),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_instance] = STATE(3526),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1304),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [anon_sym_INSTANCE] = ACTIONS(23),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [215] = {
    [sym_block_comment] = STATE(215),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1683),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4091),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [216] = {
    [sym_block_comment] = STATE(216),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1691),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4095),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [217] = {
    [sym_block_comment] = STATE(217),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1703),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4098),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [218] = {
    [sym_block_comment] = STATE(218),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1712),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4100),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [219] = {
    [sym_block_comment] = STATE(219),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1720),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4104),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [220] = {
    [sym_block_comment] = STATE(220),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1727),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4106),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [221] = {
    [sym_block_comment] = STATE(221),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1729),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4109),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [222] = {
    [sym_block_comment] = STATE(222),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1731),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4113),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [223] = {
    [sym_block_comment] = STATE(223),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1733),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4115),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [224] = {
    [sym_block_comment] = STATE(224),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1735),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4117),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [225] = {
    [sym_block_comment] = STATE(225),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(45),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1736),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_quantifier_bound] = STATE(4119),
    [sym_tuple_of_identifiers] = STATE(4574),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [226] = {
    [sym_block_comment] = STATE(226),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1813),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_module_ref] = STATE(4284),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_MODULE] = ACTIONS(606),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [227] = {
    [sym_block_comment] = STATE(227),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1404),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1152),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [228] = {
    [sym_block_comment] = STATE(228),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1240),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(422),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [229] = {
    [sym_block_comment] = STATE(229),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1856),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_RPAREN] = ACTIONS(1846),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [230] = {
    [sym_block_comment] = STATE(230),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1765),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2861),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [231] = {
    [sym_block_comment] = STATE(231),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1783),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2873),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [232] = {
    [sym_block_comment] = STATE(232),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1605),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [233] = {
    [sym_block_comment] = STATE(233),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1788),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2993),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [234] = {
    [sym_block_comment] = STATE(234),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1489),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_case_arm] = STATE(2895),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [235] = {
    [sym_block_comment] = STATE(235),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1759),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2495),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [236] = {
    [sym_block_comment] = STATE(236),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1603),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [237] = {
    [sym_block_comment] = STATE(237),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1788),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3341),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [238] = {
    [sym_block_comment] = STATE(238),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1765),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2982),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [239] = {
    [sym_block_comment] = STATE(239),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1790),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2544),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [240] = {
    [sym_block_comment] = STATE(240),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1774),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3234),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [241] = {
    [sym_block_comment] = STATE(241),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1761),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2573),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [242] = {
    [sym_block_comment] = STATE(242),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1768),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3238),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [243] = {
    [sym_block_comment] = STATE(243),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1790),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2743),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [244] = {
    [sym_block_comment] = STATE(244),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1757),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2266),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [245] = {
    [sym_block_comment] = STATE(245),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1268),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(422),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [246] = {
    [sym_block_comment] = STATE(246),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1777),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2263),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [247] = {
    [sym_block_comment] = STATE(247),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1794),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [248] = {
    [sym_block_comment] = STATE(248),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1795),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [249] = {
    [sym_block_comment] = STATE(249),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1796),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [250] = {
    [sym_block_comment] = STATE(250),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1741),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [251] = {
    [sym_block_comment] = STATE(251),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1742),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [252] = {
    [sym_block_comment] = STATE(252),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1671),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [253] = {
    [sym_block_comment] = STATE(253),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1161),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [254] = {
    [sym_block_comment] = STATE(254),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1422),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1152),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [255] = {
    [sym_block_comment] = STATE(255),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1423),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1152),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [256] = {
    [sym_block_comment] = STATE(256),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1723),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [257] = {
    [sym_block_comment] = STATE(257),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1724),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [258] = {
    [sym_block_comment] = STATE(258),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1667),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [259] = {
    [sym_block_comment] = STATE(259),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1592),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(2105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [260] = {
    [sym_block_comment] = STATE(260),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1594),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(2105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [261] = {
    [sym_block_comment] = STATE(261),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1595),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(2105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [262] = {
    [sym_block_comment] = STATE(262),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1258),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(338),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [263] = {
    [sym_block_comment] = STATE(263),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1260),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(338),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [264] = {
    [sym_block_comment] = STATE(264),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1281),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(338),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [265] = {
    [sym_block_comment] = STATE(265),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1194),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [266] = {
    [sym_block_comment] = STATE(266),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1195),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [267] = {
    [sym_block_comment] = STATE(267),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1201),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [268] = {
    [sym_block_comment] = STATE(268),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1554),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [269] = {
    [sym_block_comment] = STATE(269),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1328),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [270] = {
    [sym_block_comment] = STATE(270),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1329),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [271] = {
    [sym_block_comment] = STATE(271),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1786),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2895),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [272] = {
    [sym_block_comment] = STATE(272),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1497),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [273] = {
    [sym_block_comment] = STATE(273),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1510),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [274] = {
    [sym_block_comment] = STATE(274),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1511),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [275] = {
    [sym_block_comment] = STATE(275),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1592),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [276] = {
    [sym_block_comment] = STATE(276),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1594),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [277] = {
    [sym_block_comment] = STATE(277),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1595),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [278] = {
    [sym_block_comment] = STATE(278),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1677),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(614),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [279] = {
    [sym_block_comment] = STATE(279),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1678),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(614),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [280] = {
    [sym_block_comment] = STATE(280),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1685),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(614),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [281] = {
    [sym_block_comment] = STATE(281),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1770),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3275),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [282] = {
    [sym_block_comment] = STATE(282),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1772),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2526),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [283] = {
    [sym_block_comment] = STATE(283),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1786),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2989),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [284] = {
    [sym_block_comment] = STATE(284),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1436),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [285] = {
    [sym_block_comment] = STATE(285),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1437),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [286] = {
    [sym_block_comment] = STATE(286),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1439),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [287] = {
    [sym_block_comment] = STATE(287),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1558),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [288] = {
    [sym_block_comment] = STATE(288),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1768),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3357),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [289] = {
    [sym_block_comment] = STATE(289),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1779),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2226),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [290] = {
    [sym_block_comment] = STATE(290),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1162),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [291] = {
    [sym_block_comment] = STATE(291),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1761),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2508),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [292] = {
    [sym_block_comment] = STATE(292),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1262),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(422),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [293] = {
    [sym_block_comment] = STATE(293),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1763),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2980),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [294] = {
    [sym_block_comment] = STATE(294),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1850),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_RPAREN] = ACTIONS(2120),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [295] = {
    [sym_block_comment] = STATE(295),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1777),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2466),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [296] = {
    [sym_block_comment] = STATE(296),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1770),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3071),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [297] = {
    [sym_block_comment] = STATE(297),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1604),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [298] = {
    [sym_block_comment] = STATE(298),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1781),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2514),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [299] = {
    [sym_block_comment] = STATE(299),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1170),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [300] = {
    [sym_block_comment] = STATE(300),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1366),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_pcal_lhs] = STATE(4596),
    [sym_identifier] = ACTIONS(2122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [301] = {
    [sym_block_comment] = STATE(301),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1772),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2679),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [302] = {
    [sym_block_comment] = STATE(302),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1779),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2315),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [303] = {
    [sym_block_comment] = STATE(303),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1763),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3125),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [304] = {
    [sym_block_comment] = STATE(304),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1783),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2817),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [305] = {
    [sym_block_comment] = STATE(305),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1759),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2260),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [306] = {
    [sym_block_comment] = STATE(306),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1757),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2224),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [307] = {
    [sym_block_comment] = STATE(307),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1774),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(3025),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [308] = {
    [sym_block_comment] = STATE(308),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1781),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_case_arm] = STATE(2628),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [309] = {
    [sym_block_comment] = STATE(309),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1546),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [310] = {
    [sym_block_comment] = STATE(310),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1330),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(324),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [311] = {
    [sym_block_comment] = STATE(311),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1708),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [312] = {
    [sym_block_comment] = STATE(312),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1378),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [313] = {
    [sym_block_comment] = STATE(313),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1379),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [314] = {
    [sym_block_comment] = STATE(314),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1263),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [315] = {
    [sym_block_comment] = STATE(315),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1284),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [316] = {
    [sym_block_comment] = STATE(316),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1380),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [317] = {
    [sym_block_comment] = STATE(317),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1381),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [318] = {
    [sym_block_comment] = STATE(318),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1382),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [319] = {
    [sym_block_comment] = STATE(319),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1383),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [320] = {
    [sym_block_comment] = STATE(320),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1288),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [321] = {
    [sym_block_comment] = STATE(321),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1384),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [322] = {
    [sym_block_comment] = STATE(322),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1907),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [323] = {
    [sym_block_comment] = STATE(323),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2113),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [324] = {
    [sym_block_comment] = STATE(324),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1775),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [325] = {
    [sym_block_comment] = STATE(325),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1606),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [326] = {
    [sym_block_comment] = STATE(326),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1607),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [327] = {
    [sym_block_comment] = STATE(327),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1608),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [328] = {
    [sym_block_comment] = STATE(328),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1609),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [329] = {
    [sym_block_comment] = STATE(329),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1610),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [330] = {
    [sym_block_comment] = STATE(330),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1611),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [331] = {
    [sym_block_comment] = STATE(331),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1612),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [332] = {
    [sym_block_comment] = STATE(332),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1613),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [333] = {
    [sym_block_comment] = STATE(333),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1635),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [334] = {
    [sym_block_comment] = STATE(334),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1615),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [335] = {
    [sym_block_comment] = STATE(335),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1616),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [336] = {
    [sym_block_comment] = STATE(336),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1617),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [337] = {
    [sym_block_comment] = STATE(337),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1618),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [338] = {
    [sym_block_comment] = STATE(338),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1619),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [339] = {
    [sym_block_comment] = STATE(339),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1620),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [340] = {
    [sym_block_comment] = STATE(340),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1621),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [341] = {
    [sym_block_comment] = STATE(341),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1622),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [342] = {
    [sym_block_comment] = STATE(342),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1623),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [343] = {
    [sym_block_comment] = STATE(343),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1624),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [344] = {
    [sym_block_comment] = STATE(344),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2015),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [345] = {
    [sym_block_comment] = STATE(345),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2033),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [346] = {
    [sym_block_comment] = STATE(346),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1625),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [347] = {
    [sym_block_comment] = STATE(347),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1626),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [348] = {
    [sym_block_comment] = STATE(348),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1627),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [349] = {
    [sym_block_comment] = STATE(349),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1628),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [350] = {
    [sym_block_comment] = STATE(350),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1629),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [351] = {
    [sym_block_comment] = STATE(351),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1598),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [352] = {
    [sym_block_comment] = STATE(352),
    [sym_forall] = STATE(3995),
    [sym_exists] = STATE(3995),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1085),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3062),
    [sym_bound_nonfix_op] = STATE(3062),
    [sym__expr] = STATE(1630),
    [sym_prefixed_op] = STATE(3132),
    [sym__number] = STATE(3132),
    [sym_nat_number] = STATE(3109),
    [sym_binary_number] = STATE(3109),
    [sym_octal_number] = STATE(3109),
    [sym_hex_number] = STATE(3109),
    [sym_string] = STATE(3132),
    [sym_boolean] = STATE(3132),
    [sym__number_set] = STATE(3119),
    [sym__primitive_value_set] = STATE(3132),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_label] = STATE(3132),
    [sym_subexpression] = STATE(3132),
    [sym_parentheses] = STATE(3132),
    [sym_bounded_quantification] = STATE(3132),
    [sym_unbounded_quantification] = STATE(3132),
    [sym_choose] = STATE(3132),
    [sym_finite_set_literal] = STATE(3132),
    [sym_set_filter] = STATE(3132),
    [sym_set_map] = STATE(3132),
    [sym_function_evaluation] = STATE(3132),
    [sym_function_literal] = STATE(3132),
    [sym_set_of_functions] = STATE(3132),
    [sym_record_literal] = STATE(3132),
    [sym_set_of_records] = STATE(3132),
    [sym_record_value] = STATE(3132),
    [sym_except] = STATE(3132),
    [sym_prev_func_val] = STATE(3132),
    [sym_tuple_literal] = STATE(3132),
    [sym_step_expr_or_stutter] = STATE(3132),
    [sym_step_expr_no_stutter] = STATE(3132),
    [sym_fairness] = STATE(3132),
    [sym_if_then_else] = STATE(3132),
    [sym_case] = STATE(3132),
    [sym_let_in] = STATE(3132),
    [sym_conj_list] = STATE(3132),
    [sym_disj_list] = STATE(3132),
    [sym_lnot] = STATE(232),
    [sym_negative] = STATE(325),
    [sym_always] = STATE(297),
    [sym_eventually] = STATE(297),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_bound_prefix_op] = STATE(3132),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_bound_infix_op] = STATE(3132),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_bound_postfix_op] = STATE(3132),
    [sym_proof_step_ref] = STATE(3066),
    [sym_identifier] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1475),
    [sym_temporal_exists] = ACTIONS(1475),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [aux_sym_child_id_token1] = ACTIONS(1483),
    [sym_real_number] = ACTIONS(1485),
    [anon_sym_BSLASHb] = ACTIONS(1487),
    [anon_sym_BSLASHB] = ACTIONS(1489),
    [anon_sym_BSLASHo] = ACTIONS(1491),
    [anon_sym_BSLASHO] = ACTIONS(1493),
    [anon_sym_BSLASHh] = ACTIONS(1495),
    [anon_sym_BSLASHH] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [anon_sym_TRUE] = ACTIONS(1499),
    [anon_sym_FALSE] = ACTIONS(1499),
    [sym_string_set] = ACTIONS(1501),
    [sym_boolean_set] = ACTIONS(1501),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_CHOOSE] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1519),
    [anon_sym_SF_] = ACTIONS(1519),
    [anon_sym_IF] = ACTIONS(1521),
    [anon_sym_CASE] = ACTIONS(1523),
    [anon_sym_LET] = ACTIONS(1527),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1529),
    [sym_powerset] = ACTIONS(1529),
    [sym_domain] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1531),
    [sym_unchanged] = ACTIONS(1531),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1533),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1535),
    [sym__double_excl] = ACTIONS(277),
  },
  [353] = {
    [sym_block_comment] = STATE(353),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2028),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [354] = {
    [sym_block_comment] = STATE(354),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2030),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [355] = {
    [sym_block_comment] = STATE(355),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1264),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [356] = {
    [sym_block_comment] = STATE(356),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1557),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [357] = {
    [sym_block_comment] = STATE(357),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1559),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [358] = {
    [sym_block_comment] = STATE(358),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1562),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [359] = {
    [sym_block_comment] = STATE(359),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1565),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [360] = {
    [sym_block_comment] = STATE(360),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1566),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [361] = {
    [sym_block_comment] = STATE(361),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1537),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [362] = {
    [sym_block_comment] = STATE(362),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1538),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [363] = {
    [sym_block_comment] = STATE(363),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1539),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [364] = {
    [sym_block_comment] = STATE(364),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1540),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [365] = {
    [sym_block_comment] = STATE(365),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1541),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [366] = {
    [sym_block_comment] = STATE(366),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1542),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [367] = {
    [sym_block_comment] = STATE(367),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1543),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [368] = {
    [sym_block_comment] = STATE(368),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1544),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [369] = {
    [sym_block_comment] = STATE(369),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1545),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [370] = {
    [sym_block_comment] = STATE(370),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1548),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [371] = {
    [sym_block_comment] = STATE(371),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1549),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [372] = {
    [sym_block_comment] = STATE(372),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1550),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [373] = {
    [sym_block_comment] = STATE(373),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1551),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [374] = {
    [sym_block_comment] = STATE(374),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1552),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [375] = {
    [sym_block_comment] = STATE(375),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1275),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [376] = {
    [sym_block_comment] = STATE(376),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1555),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [377] = {
    [sym_block_comment] = STATE(377),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1556),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [378] = {
    [sym_block_comment] = STATE(378),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1560),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [379] = {
    [sym_block_comment] = STATE(379),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1561),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [380] = {
    [sym_block_comment] = STATE(380),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1536),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [381] = {
    [sym_block_comment] = STATE(381),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1563),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [382] = {
    [sym_block_comment] = STATE(382),
    [sym_forall] = STATE(3976),
    [sym_exists] = STATE(3976),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1086),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2894),
    [sym_bound_nonfix_op] = STATE(2894),
    [sym__expr] = STATE(1564),
    [sym_prefixed_op] = STATE(2928),
    [sym__number] = STATE(2928),
    [sym_nat_number] = STATE(2981),
    [sym_binary_number] = STATE(2981),
    [sym_octal_number] = STATE(2981),
    [sym_hex_number] = STATE(2981),
    [sym_string] = STATE(2928),
    [sym_boolean] = STATE(2928),
    [sym__number_set] = STATE(2911),
    [sym__primitive_value_set] = STATE(2928),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_label] = STATE(2928),
    [sym_subexpression] = STATE(2928),
    [sym_parentheses] = STATE(2928),
    [sym_bounded_quantification] = STATE(2928),
    [sym_unbounded_quantification] = STATE(2928),
    [sym_choose] = STATE(2928),
    [sym_finite_set_literal] = STATE(2928),
    [sym_set_filter] = STATE(2928),
    [sym_set_map] = STATE(2928),
    [sym_function_evaluation] = STATE(2928),
    [sym_function_literal] = STATE(2928),
    [sym_set_of_functions] = STATE(2928),
    [sym_record_literal] = STATE(2928),
    [sym_set_of_records] = STATE(2928),
    [sym_record_value] = STATE(2928),
    [sym_except] = STATE(2928),
    [sym_prev_func_val] = STATE(2928),
    [sym_tuple_literal] = STATE(2928),
    [sym_step_expr_or_stutter] = STATE(2928),
    [sym_step_expr_no_stutter] = STATE(2928),
    [sym_fairness] = STATE(2928),
    [sym_if_then_else] = STATE(2928),
    [sym_case] = STATE(2928),
    [sym_let_in] = STATE(2928),
    [sym_conj_list] = STATE(2928),
    [sym_disj_list] = STATE(2928),
    [sym_lnot] = STATE(268),
    [sym_negative] = STATE(356),
    [sym_always] = STATE(309),
    [sym_eventually] = STATE(309),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_bound_prefix_op] = STATE(2928),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_bound_infix_op] = STATE(2928),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_bound_postfix_op] = STATE(2928),
    [sym_proof_step_ref] = STATE(2900),
    [sym_identifier] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(984),
    [sym_temporal_exists] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [aux_sym_child_id_token1] = ACTIONS(994),
    [sym_real_number] = ACTIONS(996),
    [anon_sym_BSLASHb] = ACTIONS(998),
    [anon_sym_BSLASHB] = ACTIONS(1000),
    [anon_sym_BSLASHo] = ACTIONS(1002),
    [anon_sym_BSLASHO] = ACTIONS(1004),
    [anon_sym_BSLASHh] = ACTIONS(1006),
    [anon_sym_BSLASHH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_TRUE] = ACTIONS(1010),
    [anon_sym_FALSE] = ACTIONS(1010),
    [sym_string_set] = ACTIONS(1012),
    [sym_boolean_set] = ACTIONS(1012),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_CHOOSE] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1030),
    [anon_sym_SF_] = ACTIONS(1030),
    [anon_sym_IF] = ACTIONS(1032),
    [anon_sym_CASE] = ACTIONS(1034),
    [anon_sym_LET] = ACTIONS(1036),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1038),
    [sym_powerset] = ACTIONS(1038),
    [sym_domain] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1040),
    [sym_unchanged] = ACTIONS(1040),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1044),
    [sym__double_excl] = ACTIONS(277),
  },
  [383] = {
    [sym_block_comment] = STATE(383),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1280),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [384] = {
    [sym_block_comment] = STATE(384),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1797),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [385] = {
    [sym_block_comment] = STATE(385),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1799),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [386] = {
    [sym_block_comment] = STATE(386),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1800),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [387] = {
    [sym_block_comment] = STATE(387),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1801),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [388] = {
    [sym_block_comment] = STATE(388),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1802),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [389] = {
    [sym_block_comment] = STATE(389),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1803),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [390] = {
    [sym_block_comment] = STATE(390),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1804),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [391] = {
    [sym_block_comment] = STATE(391),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1805),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [392] = {
    [sym_block_comment] = STATE(392),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1806),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [393] = {
    [sym_block_comment] = STATE(393),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1807),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [394] = {
    [sym_block_comment] = STATE(394),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1808),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [395] = {
    [sym_block_comment] = STATE(395),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1809),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [396] = {
    [sym_block_comment] = STATE(396),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1810),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [397] = {
    [sym_block_comment] = STATE(397),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1811),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [398] = {
    [sym_block_comment] = STATE(398),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1812),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [399] = {
    [sym_block_comment] = STATE(399),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1814),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [400] = {
    [sym_block_comment] = STATE(400),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1815),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [401] = {
    [sym_block_comment] = STATE(401),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1816),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [402] = {
    [sym_block_comment] = STATE(402),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1756),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [403] = {
    [sym_block_comment] = STATE(403),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1817),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [404] = {
    [sym_block_comment] = STATE(404),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1818),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [405] = {
    [sym_block_comment] = STATE(405),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1820),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [406] = {
    [sym_block_comment] = STATE(406),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1821),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [407] = {
    [sym_block_comment] = STATE(407),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1822),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [408] = {
    [sym_block_comment] = STATE(408),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1823),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [409] = {
    [sym_block_comment] = STATE(409),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1824),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [410] = {
    [sym_block_comment] = STATE(410),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1651),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [411] = {
    [sym_block_comment] = STATE(411),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1689),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [412] = {
    [sym_block_comment] = STATE(412),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1660),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [413] = {
    [sym_block_comment] = STATE(413),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1745),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [414] = {
    [sym_block_comment] = STATE(414),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1640),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [415] = {
    [sym_block_comment] = STATE(415),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1641),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [416] = {
    [sym_block_comment] = STATE(416),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1663),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [417] = {
    [sym_block_comment] = STATE(417),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1669),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [418] = {
    [sym_block_comment] = STATE(418),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1674),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [419] = {
    [sym_block_comment] = STATE(419),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1675),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [420] = {
    [sym_block_comment] = STATE(420),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1680),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [421] = {
    [sym_block_comment] = STATE(421),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1684),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [422] = {
    [sym_block_comment] = STATE(422),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1717),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [423] = {
    [sym_block_comment] = STATE(423),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1718),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [424] = {
    [sym_block_comment] = STATE(424),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1719),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [425] = {
    [sym_block_comment] = STATE(425),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1721),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [426] = {
    [sym_block_comment] = STATE(426),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1726),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [427] = {
    [sym_block_comment] = STATE(427),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1728),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [428] = {
    [sym_block_comment] = STATE(428),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1730),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [429] = {
    [sym_block_comment] = STATE(429),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1732),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [430] = {
    [sym_block_comment] = STATE(430),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1743),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [431] = {
    [sym_block_comment] = STATE(431),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1647),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [432] = {
    [sym_block_comment] = STATE(432),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1639),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [433] = {
    [sym_block_comment] = STATE(433),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1681),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [434] = {
    [sym_block_comment] = STATE(434),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1682),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [435] = {
    [sym_block_comment] = STATE(435),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1722),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [436] = {
    [sym_block_comment] = STATE(436),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1424),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [437] = {
    [sym_block_comment] = STATE(437),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1389),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [438] = {
    [sym_block_comment] = STATE(438),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1391),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [439] = {
    [sym_block_comment] = STATE(439),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1392),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [440] = {
    [sym_block_comment] = STATE(440),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1393),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [441] = {
    [sym_block_comment] = STATE(441),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1394),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [442] = {
    [sym_block_comment] = STATE(442),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1395),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [443] = {
    [sym_block_comment] = STATE(443),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1396),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [444] = {
    [sym_block_comment] = STATE(444),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1397),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [445] = {
    [sym_block_comment] = STATE(445),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1398),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [446] = {
    [sym_block_comment] = STATE(446),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1399),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [447] = {
    [sym_block_comment] = STATE(447),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1400),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [448] = {
    [sym_block_comment] = STATE(448),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1401),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [449] = {
    [sym_block_comment] = STATE(449),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1402),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [450] = {
    [sym_block_comment] = STATE(450),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1403),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [451] = {
    [sym_block_comment] = STATE(451),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1406),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [452] = {
    [sym_block_comment] = STATE(452),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1407),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [453] = {
    [sym_block_comment] = STATE(453),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1408),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [454] = {
    [sym_block_comment] = STATE(454),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1409),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [455] = {
    [sym_block_comment] = STATE(455),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1410),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [456] = {
    [sym_block_comment] = STATE(456),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1413),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [457] = {
    [sym_block_comment] = STATE(457),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1414),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [458] = {
    [sym_block_comment] = STATE(458),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1417),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [459] = {
    [sym_block_comment] = STATE(459),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1418),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [460] = {
    [sym_block_comment] = STATE(460),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1419),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [461] = {
    [sym_block_comment] = STATE(461),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1420),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [462] = {
    [sym_block_comment] = STATE(462),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1687),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [463] = {
    [sym_block_comment] = STATE(463),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1725),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [464] = {
    [sym_block_comment] = STATE(464),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1655),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [465] = {
    [sym_block_comment] = STATE(465),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1734),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [466] = {
    [sym_block_comment] = STATE(466),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1738),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [467] = {
    [sym_block_comment] = STATE(467),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1739),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [468] = {
    [sym_block_comment] = STATE(468),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1665),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [469] = {
    [sym_block_comment] = STATE(469),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1666),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [470] = {
    [sym_block_comment] = STATE(470),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1668),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [471] = {
    [sym_block_comment] = STATE(471),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1670),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [472] = {
    [sym_block_comment] = STATE(472),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1638),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [473] = {
    [sym_block_comment] = STATE(473),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1642),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [474] = {
    [sym_block_comment] = STATE(474),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1643),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [475] = {
    [sym_block_comment] = STATE(475),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1644),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [476] = {
    [sym_block_comment] = STATE(476),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1645),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [477] = {
    [sym_block_comment] = STATE(477),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1646),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [478] = {
    [sym_block_comment] = STATE(478),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1648),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [479] = {
    [sym_block_comment] = STATE(479),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1652),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [480] = {
    [sym_block_comment] = STATE(480),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1653),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [481] = {
    [sym_block_comment] = STATE(481),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1654),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [482] = {
    [sym_block_comment] = STATE(482),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1657),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [483] = {
    [sym_block_comment] = STATE(483),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1658),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [484] = {
    [sym_block_comment] = STATE(484),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1659),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [485] = {
    [sym_block_comment] = STATE(485),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1661),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [486] = {
    [sym_block_comment] = STATE(486),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1662),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [487] = {
    [sym_block_comment] = STATE(487),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1664),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [488] = {
    [sym_block_comment] = STATE(488),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1290),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [489] = {
    [sym_block_comment] = STATE(489),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1596),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [490] = {
    [sym_block_comment] = STATE(490),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1597),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [491] = {
    [sym_block_comment] = STATE(491),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1570),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [492] = {
    [sym_block_comment] = STATE(492),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1593),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [493] = {
    [sym_block_comment] = STATE(493),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1579),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [494] = {
    [sym_block_comment] = STATE(494),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1580),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [495] = {
    [sym_block_comment] = STATE(495),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1581),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [496] = {
    [sym_block_comment] = STATE(496),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1582),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [497] = {
    [sym_block_comment] = STATE(497),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1583),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [498] = {
    [sym_block_comment] = STATE(498),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1584),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [499] = {
    [sym_block_comment] = STATE(499),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1585),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [500] = {
    [sym_block_comment] = STATE(500),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1586),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [501] = {
    [sym_block_comment] = STATE(501),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1587),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [502] = {
    [sym_block_comment] = STATE(502),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1588),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [503] = {
    [sym_block_comment] = STATE(503),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1589),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [504] = {
    [sym_block_comment] = STATE(504),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1590),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [505] = {
    [sym_block_comment] = STATE(505),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1591),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [506] = {
    [sym_block_comment] = STATE(506),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1571),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [507] = {
    [sym_block_comment] = STATE(507),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1572),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [508] = {
    [sym_block_comment] = STATE(508),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1573),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [509] = {
    [sym_block_comment] = STATE(509),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1574),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [510] = {
    [sym_block_comment] = STATE(510),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1575),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [511] = {
    [sym_block_comment] = STATE(511),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1569),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [512] = {
    [sym_block_comment] = STATE(512),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1576),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [513] = {
    [sym_block_comment] = STATE(513),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1577),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [514] = {
    [sym_block_comment] = STATE(514),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1578),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [515] = {
    [sym_block_comment] = STATE(515),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1168),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [516] = {
    [sym_block_comment] = STATE(516),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1296),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [517] = {
    [sym_block_comment] = STATE(517),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1228),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [518] = {
    [sym_block_comment] = STATE(518),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1232),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [519] = {
    [sym_block_comment] = STATE(519),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1259),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [520] = {
    [sym_block_comment] = STATE(520),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1261),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [521] = {
    [sym_block_comment] = STATE(521),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1266),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [522] = {
    [sym_block_comment] = STATE(522),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1276),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [523] = {
    [sym_block_comment] = STATE(523),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1224),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [524] = {
    [sym_block_comment] = STATE(524),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1253),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [525] = {
    [sym_block_comment] = STATE(525),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1257),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [526] = {
    [sym_block_comment] = STATE(526),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1248),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [527] = {
    [sym_block_comment] = STATE(527),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1255),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [528] = {
    [sym_block_comment] = STATE(528),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1226),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [529] = {
    [sym_block_comment] = STATE(529),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1229),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [530] = {
    [sym_block_comment] = STATE(530),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1247),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [531] = {
    [sym_block_comment] = STATE(531),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1250),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [532] = {
    [sym_block_comment] = STATE(532),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1265),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [533] = {
    [sym_block_comment] = STATE(533),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1267),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [534] = {
    [sym_block_comment] = STATE(534),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1274),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [535] = {
    [sym_block_comment] = STATE(535),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1277),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [536] = {
    [sym_block_comment] = STATE(536),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1233),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [537] = {
    [sym_block_comment] = STATE(537),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1238),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [538] = {
    [sym_block_comment] = STATE(538),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1239),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [539] = {
    [sym_block_comment] = STATE(539),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1241),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [540] = {
    [sym_block_comment] = STATE(540),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1242),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [541] = {
    [sym_block_comment] = STATE(541),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1243),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [542] = {
    [sym_block_comment] = STATE(542),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1244),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [543] = {
    [sym_block_comment] = STATE(543),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1294),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [544] = {
    [sym_block_comment] = STATE(544),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1205),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [545] = {
    [sym_block_comment] = STATE(545),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1206),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [546] = {
    [sym_block_comment] = STATE(546),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1209),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [547] = {
    [sym_block_comment] = STATE(547),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1210),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [548] = {
    [sym_block_comment] = STATE(548),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1211),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [549] = {
    [sym_block_comment] = STATE(549),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1213),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [550] = {
    [sym_block_comment] = STATE(550),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1214),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [551] = {
    [sym_block_comment] = STATE(551),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1217),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [552] = {
    [sym_block_comment] = STATE(552),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1218),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [553] = {
    [sym_block_comment] = STATE(553),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1219),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [554] = {
    [sym_block_comment] = STATE(554),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1220),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [555] = {
    [sym_block_comment] = STATE(555),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1221),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [556] = {
    [sym_block_comment] = STATE(556),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1212),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [557] = {
    [sym_block_comment] = STATE(557),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1172),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [558] = {
    [sym_block_comment] = STATE(558),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1180),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [559] = {
    [sym_block_comment] = STATE(559),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1191),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [560] = {
    [sym_block_comment] = STATE(560),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1192),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [561] = {
    [sym_block_comment] = STATE(561),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1199),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [562] = {
    [sym_block_comment] = STATE(562),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1202),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [563] = {
    [sym_block_comment] = STATE(563),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1207),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [564] = {
    [sym_block_comment] = STATE(564),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1169),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [565] = {
    [sym_block_comment] = STATE(565),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1173),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [566] = {
    [sym_block_comment] = STATE(566),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1174),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [567] = {
    [sym_block_comment] = STATE(567),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1176),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [568] = {
    [sym_block_comment] = STATE(568),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1177),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [569] = {
    [sym_block_comment] = STATE(569),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1178),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [570] = {
    [sym_block_comment] = STATE(570),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2031),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [571] = {
    [sym_block_comment] = STATE(571),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1908),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [572] = {
    [sym_block_comment] = STATE(572),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1331),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [573] = {
    [sym_block_comment] = STATE(573),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1332),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [574] = {
    [sym_block_comment] = STATE(574),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1333),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [575] = {
    [sym_block_comment] = STATE(575),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1334),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [576] = {
    [sym_block_comment] = STATE(576),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1335),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [577] = {
    [sym_block_comment] = STATE(577),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1336),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [578] = {
    [sym_block_comment] = STATE(578),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1337),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [579] = {
    [sym_block_comment] = STATE(579),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1338),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [580] = {
    [sym_block_comment] = STATE(580),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1339),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [581] = {
    [sym_block_comment] = STATE(581),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1340),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [582] = {
    [sym_block_comment] = STATE(582),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1341),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [583] = {
    [sym_block_comment] = STATE(583),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1342),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [584] = {
    [sym_block_comment] = STATE(584),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1343),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [585] = {
    [sym_block_comment] = STATE(585),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1344),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [586] = {
    [sym_block_comment] = STATE(586),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1345),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [587] = {
    [sym_block_comment] = STATE(587),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1346),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [588] = {
    [sym_block_comment] = STATE(588),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1347),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [589] = {
    [sym_block_comment] = STATE(589),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1348),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [590] = {
    [sym_block_comment] = STATE(590),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1349),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [591] = {
    [sym_block_comment] = STATE(591),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1327),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [592] = {
    [sym_block_comment] = STATE(592),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1350),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [593] = {
    [sym_block_comment] = STATE(593),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1672),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [594] = {
    [sym_block_comment] = STATE(594),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1351),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [595] = {
    [sym_block_comment] = STATE(595),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1352),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [596] = {
    [sym_block_comment] = STATE(596),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1353),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [597] = {
    [sym_block_comment] = STATE(597),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1354),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [598] = {
    [sym_block_comment] = STATE(598),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1387),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [599] = {
    [sym_block_comment] = STATE(599),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1673),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [600] = {
    [sym_block_comment] = STATE(600),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1740),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [601] = {
    [sym_block_comment] = STATE(601),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1251),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [602] = {
    [sym_block_comment] = STATE(602),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1512),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [603] = {
    [sym_block_comment] = STATE(603),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1514),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [604] = {
    [sym_block_comment] = STATE(604),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1515),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [605] = {
    [sym_block_comment] = STATE(605),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1516),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [606] = {
    [sym_block_comment] = STATE(606),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1517),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [607] = {
    [sym_block_comment] = STATE(607),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1491),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [608] = {
    [sym_block_comment] = STATE(608),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1498),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [609] = {
    [sym_block_comment] = STATE(609),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1499),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [610] = {
    [sym_block_comment] = STATE(610),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1501),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [611] = {
    [sym_block_comment] = STATE(611),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1502),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [612] = {
    [sym_block_comment] = STATE(612),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1503),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [613] = {
    [sym_block_comment] = STATE(613),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1504),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [614] = {
    [sym_block_comment] = STATE(614),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1505),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [615] = {
    [sym_block_comment] = STATE(615),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1506),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [616] = {
    [sym_block_comment] = STATE(616),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1507),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [617] = {
    [sym_block_comment] = STATE(617),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1508),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [618] = {
    [sym_block_comment] = STATE(618),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1509),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [619] = {
    [sym_block_comment] = STATE(619),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1513),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [620] = {
    [sym_block_comment] = STATE(620),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1518),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [621] = {
    [sym_block_comment] = STATE(621),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1492),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [622] = {
    [sym_block_comment] = STATE(622),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1493),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [623] = {
    [sym_block_comment] = STATE(623),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1494),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [624] = {
    [sym_block_comment] = STATE(624),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1495),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [625] = {
    [sym_block_comment] = STATE(625),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1496),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [626] = {
    [sym_block_comment] = STATE(626),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1490),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [627] = {
    [sym_block_comment] = STATE(627),
    [sym_forall] = STATE(3981),
    [sym_exists] = STATE(3981),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1096),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2828),
    [sym_bound_nonfix_op] = STATE(2828),
    [sym__expr] = STATE(1500),
    [sym_prefixed_op] = STATE(2882),
    [sym__number] = STATE(2882),
    [sym_nat_number] = STATE(2878),
    [sym_binary_number] = STATE(2878),
    [sym_octal_number] = STATE(2878),
    [sym_hex_number] = STATE(2878),
    [sym_string] = STATE(2882),
    [sym_boolean] = STATE(2882),
    [sym__number_set] = STATE(2880),
    [sym__primitive_value_set] = STATE(2882),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_label] = STATE(2882),
    [sym_subexpression] = STATE(2882),
    [sym_parentheses] = STATE(2882),
    [sym_bounded_quantification] = STATE(2882),
    [sym_unbounded_quantification] = STATE(2882),
    [sym_choose] = STATE(2882),
    [sym_finite_set_literal] = STATE(2882),
    [sym_set_filter] = STATE(2882),
    [sym_set_map] = STATE(2882),
    [sym_function_evaluation] = STATE(2882),
    [sym_function_literal] = STATE(2882),
    [sym_set_of_functions] = STATE(2882),
    [sym_record_literal] = STATE(2882),
    [sym_set_of_records] = STATE(2882),
    [sym_record_value] = STATE(2882),
    [sym_except] = STATE(2882),
    [sym_prev_func_val] = STATE(2882),
    [sym_tuple_literal] = STATE(2882),
    [sym_step_expr_or_stutter] = STATE(2882),
    [sym_step_expr_no_stutter] = STATE(2882),
    [sym_fairness] = STATE(2882),
    [sym_if_then_else] = STATE(2882),
    [sym_case] = STATE(2882),
    [sym_let_in] = STATE(2882),
    [sym_conj_list] = STATE(2882),
    [sym_disj_list] = STATE(2882),
    [sym_lnot] = STATE(274),
    [sym_negative] = STATE(602),
    [sym_always] = STATE(273),
    [sym_eventually] = STATE(273),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_bound_prefix_op] = STATE(2882),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_bound_infix_op] = STATE(2882),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_bound_postfix_op] = STATE(2882),
    [sym_proof_step_ref] = STATE(2823),
    [sym_identifier] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1853),
    [sym_temporal_exists] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1855),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_child_id_token1] = ACTIONS(1861),
    [sym_real_number] = ACTIONS(1863),
    [anon_sym_BSLASHb] = ACTIONS(1865),
    [anon_sym_BSLASHB] = ACTIONS(1867),
    [anon_sym_BSLASHo] = ACTIONS(1869),
    [anon_sym_BSLASHO] = ACTIONS(1871),
    [anon_sym_BSLASHh] = ACTIONS(1873),
    [anon_sym_BSLASHH] = ACTIONS(1873),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_TRUE] = ACTIONS(1877),
    [anon_sym_FALSE] = ACTIONS(1877),
    [sym_string_set] = ACTIONS(1879),
    [sym_boolean_set] = ACTIONS(1879),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_CHOOSE] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1897),
    [anon_sym_SF_] = ACTIONS(1897),
    [anon_sym_IF] = ACTIONS(1899),
    [anon_sym_CASE] = ACTIONS(1901),
    [anon_sym_LET] = ACTIONS(1903),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1905),
    [sym_powerset] = ACTIONS(1905),
    [sym_domain] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1907),
    [sym_unchanged] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1911),
    [sym__double_excl] = ACTIONS(277),
  },
  [628] = {
    [sym_block_comment] = STATE(628),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1766),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [629] = {
    [sym_block_comment] = STATE(629),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1297),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [630] = {
    [sym_block_comment] = STATE(630),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1686),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [631] = {
    [sym_block_comment] = STATE(631),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1688),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [632] = {
    [sym_block_comment] = STATE(632),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1690),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [633] = {
    [sym_block_comment] = STATE(633),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1692),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [634] = {
    [sym_block_comment] = STATE(634),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1693),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [635] = {
    [sym_block_comment] = STATE(635),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1694),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [636] = {
    [sym_block_comment] = STATE(636),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1695),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [637] = {
    [sym_block_comment] = STATE(637),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1696),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [638] = {
    [sym_block_comment] = STATE(638),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1697),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [639] = {
    [sym_block_comment] = STATE(639),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1698),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [640] = {
    [sym_block_comment] = STATE(640),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1699),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [641] = {
    [sym_block_comment] = STATE(641),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1700),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [642] = {
    [sym_block_comment] = STATE(642),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1701),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [643] = {
    [sym_block_comment] = STATE(643),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1702),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [644] = {
    [sym_block_comment] = STATE(644),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1704),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [645] = {
    [sym_block_comment] = STATE(645),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1705),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [646] = {
    [sym_block_comment] = STATE(646),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1706),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [647] = {
    [sym_block_comment] = STATE(647),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1707),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [648] = {
    [sym_block_comment] = STATE(648),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2107),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [649] = {
    [sym_block_comment] = STATE(649),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1709),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [650] = {
    [sym_block_comment] = STATE(650),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1710),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [651] = {
    [sym_block_comment] = STATE(651),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1711),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [652] = {
    [sym_block_comment] = STATE(652),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1713),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [653] = {
    [sym_block_comment] = STATE(653),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1714),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [654] = {
    [sym_block_comment] = STATE(654),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1715),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [655] = {
    [sym_block_comment] = STATE(655),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1716),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [656] = {
    [sym_block_comment] = STATE(656),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1440),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [657] = {
    [sym_block_comment] = STATE(657),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1441),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [658] = {
    [sym_block_comment] = STATE(658),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1442),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [659] = {
    [sym_block_comment] = STATE(659),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1443),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [660] = {
    [sym_block_comment] = STATE(660),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1444),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [661] = {
    [sym_block_comment] = STATE(661),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1445),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [662] = {
    [sym_block_comment] = STATE(662),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1446),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [663] = {
    [sym_block_comment] = STATE(663),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1447),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [664] = {
    [sym_block_comment] = STATE(664),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1448),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [665] = {
    [sym_block_comment] = STATE(665),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1449),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [666] = {
    [sym_block_comment] = STATE(666),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1450),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [667] = {
    [sym_block_comment] = STATE(667),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1451),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [668] = {
    [sym_block_comment] = STATE(668),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1452),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [669] = {
    [sym_block_comment] = STATE(669),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1453),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [670] = {
    [sym_block_comment] = STATE(670),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1454),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [671] = {
    [sym_block_comment] = STATE(671),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1455),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [672] = {
    [sym_block_comment] = STATE(672),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1456),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [673] = {
    [sym_block_comment] = STATE(673),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1457),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [674] = {
    [sym_block_comment] = STATE(674),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1458),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [675] = {
    [sym_block_comment] = STATE(675),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1459),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [676] = {
    [sym_block_comment] = STATE(676),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1460),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [677] = {
    [sym_block_comment] = STATE(677),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1461),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [678] = {
    [sym_block_comment] = STATE(678),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1462),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [679] = {
    [sym_block_comment] = STATE(679),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1463),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [680] = {
    [sym_block_comment] = STATE(680),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1464),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [681] = {
    [sym_block_comment] = STATE(681),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1465),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [682] = {
    [sym_block_comment] = STATE(682),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1235),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [683] = {
    [sym_block_comment] = STATE(683),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2108),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [684] = {
    [sym_block_comment] = STATE(684),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1249),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [685] = {
    [sym_block_comment] = STATE(685),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1974),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [686] = {
    [sym_block_comment] = STATE(686),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1902),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [687] = {
    [sym_block_comment] = STATE(687),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1198),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [688] = {
    [sym_block_comment] = STATE(688),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1286),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [689] = {
    [sym_block_comment] = STATE(689),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1292),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [690] = {
    [sym_block_comment] = STATE(690),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1749),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [691] = {
    [sym_block_comment] = STATE(691),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1553),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [692] = {
    [sym_block_comment] = STATE(692),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1883),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [693] = {
    [sym_block_comment] = STATE(693),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1309),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(2130),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [694] = {
    [sym_block_comment] = STATE(694),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1851),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [695] = {
    [sym_block_comment] = STATE(695),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1634),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [696] = {
    [sym_block_comment] = STATE(696),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1234),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [697] = {
    [sym_block_comment] = STATE(697),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1236),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [698] = {
    [sym_block_comment] = STATE(698),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1305),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [699] = {
    [sym_block_comment] = STATE(699),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1825),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [700] = {
    [sym_block_comment] = STATE(700),
    [sym_forall] = STATE(4004),
    [sym_exists] = STATE(4004),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1090),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3100),
    [sym_bound_nonfix_op] = STATE(3100),
    [sym__expr] = STATE(1793),
    [sym_prefixed_op] = STATE(3196),
    [sym__number] = STATE(3196),
    [sym_nat_number] = STATE(3172),
    [sym_binary_number] = STATE(3172),
    [sym_octal_number] = STATE(3172),
    [sym_hex_number] = STATE(3172),
    [sym_string] = STATE(3196),
    [sym_boolean] = STATE(3196),
    [sym__number_set] = STATE(3185),
    [sym__primitive_value_set] = STATE(3196),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_label] = STATE(3196),
    [sym_subexpression] = STATE(3196),
    [sym_parentheses] = STATE(3196),
    [sym_bounded_quantification] = STATE(3196),
    [sym_unbounded_quantification] = STATE(3196),
    [sym_choose] = STATE(3196),
    [sym_finite_set_literal] = STATE(3196),
    [sym_set_filter] = STATE(3196),
    [sym_set_map] = STATE(3196),
    [sym_function_evaluation] = STATE(3196),
    [sym_function_literal] = STATE(3196),
    [sym_set_of_functions] = STATE(3196),
    [sym_record_literal] = STATE(3196),
    [sym_set_of_records] = STATE(3196),
    [sym_record_value] = STATE(3196),
    [sym_except] = STATE(3196),
    [sym_prev_func_val] = STATE(3196),
    [sym_tuple_literal] = STATE(3196),
    [sym_step_expr_or_stutter] = STATE(3196),
    [sym_step_expr_no_stutter] = STATE(3196),
    [sym_fairness] = STATE(3196),
    [sym_if_then_else] = STATE(3196),
    [sym_case] = STATE(3196),
    [sym_let_in] = STATE(3196),
    [sym_conj_list] = STATE(3196),
    [sym_disj_list] = STATE(3196),
    [sym_lnot] = STATE(258),
    [sym_negative] = STATE(462),
    [sym_always] = STATE(257),
    [sym_eventually] = STATE(257),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_bound_prefix_op] = STATE(3196),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_bound_infix_op] = STATE(3196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_bound_postfix_op] = STATE(3196),
    [sym_proof_step_ref] = STATE(3118),
    [sym_identifier] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(2044),
    [sym_temporal_exists] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [aux_sym_child_id_token1] = ACTIONS(2053),
    [sym_real_number] = ACTIONS(2055),
    [anon_sym_BSLASHb] = ACTIONS(2057),
    [anon_sym_BSLASHB] = ACTIONS(2059),
    [anon_sym_BSLASHo] = ACTIONS(2061),
    [anon_sym_BSLASHO] = ACTIONS(2063),
    [anon_sym_BSLASHh] = ACTIONS(2065),
    [anon_sym_BSLASHH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_TRUE] = ACTIONS(2069),
    [anon_sym_FALSE] = ACTIONS(2069),
    [sym_string_set] = ACTIONS(2071),
    [sym_boolean_set] = ACTIONS(2071),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_CHOOSE] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2089),
    [anon_sym_SF_] = ACTIONS(2089),
    [anon_sym_IF] = ACTIONS(2091),
    [anon_sym_CASE] = ACTIONS(2093),
    [anon_sym_LET] = ACTIONS(2095),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2097),
    [sym_powerset] = ACTIONS(2097),
    [sym_domain] = ACTIONS(2097),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2099),
    [sym_unchanged] = ACTIONS(2099),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2101),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2103),
    [sym__double_excl] = ACTIONS(277),
  },
  [701] = {
    [sym_block_comment] = STATE(701),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1256),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [702] = {
    [sym_block_comment] = STATE(702),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1852),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [703] = {
    [sym_block_comment] = STATE(703),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1894),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [704] = {
    [sym_block_comment] = STATE(704),
    [sym_forall] = STATE(3990),
    [sym_exists] = STATE(3990),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1088),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3151),
    [sym_bound_nonfix_op] = STATE(3151),
    [sym__expr] = STATE(1819),
    [sym_prefixed_op] = STATE(3327),
    [sym__number] = STATE(3327),
    [sym_nat_number] = STATE(3319),
    [sym_binary_number] = STATE(3319),
    [sym_octal_number] = STATE(3319),
    [sym_hex_number] = STATE(3319),
    [sym_string] = STATE(3327),
    [sym_boolean] = STATE(3327),
    [sym__number_set] = STATE(3323),
    [sym__primitive_value_set] = STATE(3327),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_label] = STATE(3327),
    [sym_subexpression] = STATE(3327),
    [sym_parentheses] = STATE(3327),
    [sym_bounded_quantification] = STATE(3327),
    [sym_unbounded_quantification] = STATE(3327),
    [sym_choose] = STATE(3327),
    [sym_finite_set_literal] = STATE(3327),
    [sym_set_filter] = STATE(3327),
    [sym_set_map] = STATE(3327),
    [sym_function_evaluation] = STATE(3327),
    [sym_function_literal] = STATE(3327),
    [sym_set_of_functions] = STATE(3327),
    [sym_record_literal] = STATE(3327),
    [sym_set_of_records] = STATE(3327),
    [sym_record_value] = STATE(3327),
    [sym_except] = STATE(3327),
    [sym_prev_func_val] = STATE(3327),
    [sym_tuple_literal] = STATE(3327),
    [sym_step_expr_or_stutter] = STATE(3327),
    [sym_step_expr_no_stutter] = STATE(3327),
    [sym_fairness] = STATE(3327),
    [sym_if_then_else] = STATE(3327),
    [sym_case] = STATE(3327),
    [sym_let_in] = STATE(3327),
    [sym_conj_list] = STATE(3327),
    [sym_disj_list] = STATE(3327),
    [sym_lnot] = STATE(252),
    [sym_negative] = STATE(410),
    [sym_always] = STATE(251),
    [sym_eventually] = STATE(251),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_bound_prefix_op] = STATE(3327),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_bound_infix_op] = STATE(3327),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_bound_postfix_op] = STATE(3327),
    [sym_proof_step_ref] = STATE(3152),
    [sym_identifier] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1978),
    [sym_temporal_exists] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1980),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [aux_sym_child_id_token1] = ACTIONS(1987),
    [sym_real_number] = ACTIONS(1989),
    [anon_sym_BSLASHb] = ACTIONS(1991),
    [anon_sym_BSLASHB] = ACTIONS(1993),
    [anon_sym_BSLASHo] = ACTIONS(1995),
    [anon_sym_BSLASHO] = ACTIONS(1997),
    [anon_sym_BSLASHh] = ACTIONS(1999),
    [anon_sym_BSLASHH] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_TRUE] = ACTIONS(2003),
    [anon_sym_FALSE] = ACTIONS(2003),
    [sym_string_set] = ACTIONS(2005),
    [sym_boolean_set] = ACTIONS(2005),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_CHOOSE] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(2023),
    [anon_sym_SF_] = ACTIONS(2023),
    [anon_sym_IF] = ACTIONS(2025),
    [anon_sym_CASE] = ACTIONS(2027),
    [anon_sym_LET] = ACTIONS(2029),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(2031),
    [sym_powerset] = ACTIONS(2031),
    [sym_domain] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(2033),
    [sym_unchanged] = ACTIONS(2033),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2035),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(2037),
    [sym__double_excl] = ACTIONS(277),
  },
  [705] = {
    [sym_block_comment] = STATE(705),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1270),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [706] = {
    [sym_block_comment] = STATE(706),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1900),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [707] = {
    [sym_block_comment] = STATE(707),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1282),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [708] = {
    [sym_block_comment] = STATE(708),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1225),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [709] = {
    [sym_block_comment] = STATE(709),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1421),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [710] = {
    [sym_block_comment] = STATE(710),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1390),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [711] = {
    [sym_block_comment] = STATE(711),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1252),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [712] = {
    [sym_block_comment] = STATE(712),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1427),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [713] = {
    [sym_block_comment] = STATE(713),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1405),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [714] = {
    [sym_block_comment] = STATE(714),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1412),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [715] = {
    [sym_block_comment] = STATE(715),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1411),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [716] = {
    [sym_block_comment] = STATE(716),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1887),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [717] = {
    [sym_block_comment] = STATE(717),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1416),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [718] = {
    [sym_block_comment] = STATE(718),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1388),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [719] = {
    [sym_block_comment] = STATE(719),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1892),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [720] = {
    [sym_block_comment] = STATE(720),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1895),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [721] = {
    [sym_block_comment] = STATE(721),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1254),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [722] = {
    [sym_block_comment] = STATE(722),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(2039),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [723] = {
    [sym_block_comment] = STATE(723),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1855),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [724] = {
    [sym_block_comment] = STATE(724),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1283),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [725] = {
    [sym_block_comment] = STATE(725),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1893),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [726] = {
    [sym_block_comment] = STATE(726),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1904),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [727] = {
    [sym_block_comment] = STATE(727),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1650),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [728] = {
    [sym_block_comment] = STATE(728),
    [sym_forall] = STATE(4013),
    [sym_exists] = STATE(4013),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1094),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3105),
    [sym_bound_nonfix_op] = STATE(3105),
    [sym__expr] = STATE(1896),
    [sym_prefixed_op] = STATE(3194),
    [sym__number] = STATE(3194),
    [sym_nat_number] = STATE(3313),
    [sym_binary_number] = STATE(3313),
    [sym_octal_number] = STATE(3313),
    [sym_hex_number] = STATE(3313),
    [sym_string] = STATE(3194),
    [sym_boolean] = STATE(3194),
    [sym__number_set] = STATE(3336),
    [sym__primitive_value_set] = STATE(3194),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_label] = STATE(3194),
    [sym_subexpression] = STATE(3194),
    [sym_parentheses] = STATE(3194),
    [sym_bounded_quantification] = STATE(3194),
    [sym_unbounded_quantification] = STATE(3194),
    [sym_choose] = STATE(3194),
    [sym_finite_set_literal] = STATE(3194),
    [sym_set_filter] = STATE(3194),
    [sym_set_map] = STATE(3194),
    [sym_function_evaluation] = STATE(3194),
    [sym_function_literal] = STATE(3194),
    [sym_set_of_functions] = STATE(3194),
    [sym_record_literal] = STATE(3194),
    [sym_set_of_records] = STATE(3194),
    [sym_record_value] = STATE(3194),
    [sym_except] = STATE(3194),
    [sym_prev_func_val] = STATE(3194),
    [sym_tuple_literal] = STATE(3194),
    [sym_step_expr_or_stutter] = STATE(3194),
    [sym_step_expr_no_stutter] = STATE(3194),
    [sym_fairness] = STATE(3194),
    [sym_if_then_else] = STATE(3194),
    [sym_case] = STATE(3194),
    [sym_let_in] = STATE(3194),
    [sym_conj_list] = STATE(3194),
    [sym_disj_list] = STATE(3194),
    [sym_lnot] = STATE(280),
    [sym_negative] = STATE(630),
    [sym_always] = STATE(279),
    [sym_eventually] = STATE(279),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_bound_prefix_op] = STATE(3194),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_bound_infix_op] = STATE(3194),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_bound_postfix_op] = STATE(3194),
    [sym_proof_step_ref] = STATE(3091),
    [sym_identifier] = ACTIONS(604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(608),
    [sym_temporal_exists] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [aux_sym_child_id_token1] = ACTIONS(616),
    [sym_real_number] = ACTIONS(618),
    [anon_sym_BSLASHb] = ACTIONS(620),
    [anon_sym_BSLASHB] = ACTIONS(622),
    [anon_sym_BSLASHo] = ACTIONS(624),
    [anon_sym_BSLASHO] = ACTIONS(626),
    [anon_sym_BSLASHh] = ACTIONS(628),
    [anon_sym_BSLASHH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(630),
    [anon_sym_TRUE] = ACTIONS(632),
    [anon_sym_FALSE] = ACTIONS(632),
    [sym_string_set] = ACTIONS(634),
    [sym_boolean_set] = ACTIONS(634),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_CHOOSE] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(652),
    [anon_sym_SF_] = ACTIONS(652),
    [anon_sym_IF] = ACTIONS(654),
    [anon_sym_CASE] = ACTIONS(656),
    [anon_sym_LET] = ACTIONS(658),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(660),
    [sym_powerset] = ACTIONS(660),
    [sym_domain] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(662),
    [sym_unchanged] = ACTIONS(662),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(664),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(670),
    [sym__double_excl] = ACTIONS(277),
  },
  [729] = {
    [sym_block_comment] = STATE(729),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1289),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [730] = {
    [sym_block_comment] = STATE(730),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1656),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [731] = {
    [sym_block_comment] = STATE(731),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1304),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [732] = {
    [sym_block_comment] = STATE(732),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2043),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [733] = {
    [sym_block_comment] = STATE(733),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1291),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [734] = {
    [sym_block_comment] = STATE(734),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1293),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [735] = {
    [sym_block_comment] = STATE(735),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1298),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [736] = {
    [sym_block_comment] = STATE(736),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1299),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [737] = {
    [sym_block_comment] = STATE(737),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2044),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [738] = {
    [sym_block_comment] = STATE(738),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1307),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [739] = {
    [sym_block_comment] = STATE(739),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1302),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [740] = {
    [sym_block_comment] = STATE(740),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1751),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [741] = {
    [sym_block_comment] = STATE(741),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1301),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [742] = {
    [sym_block_comment] = STATE(742),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1300),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [743] = {
    [sym_block_comment] = STATE(743),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1386),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [744] = {
    [sym_block_comment] = STATE(744),
    [sym_forall] = STATE(3961),
    [sym_exists] = STATE(3961),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1095),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2524),
    [sym_bound_nonfix_op] = STATE(2524),
    [sym__expr] = STATE(1355),
    [sym_prefixed_op] = STATE(2588),
    [sym__number] = STATE(2588),
    [sym_nat_number] = STATE(2584),
    [sym_binary_number] = STATE(2584),
    [sym_octal_number] = STATE(2584),
    [sym_hex_number] = STATE(2584),
    [sym_string] = STATE(2588),
    [sym_boolean] = STATE(2588),
    [sym__number_set] = STATE(2586),
    [sym__primitive_value_set] = STATE(2588),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_label] = STATE(2588),
    [sym_subexpression] = STATE(2588),
    [sym_parentheses] = STATE(2588),
    [sym_bounded_quantification] = STATE(2588),
    [sym_unbounded_quantification] = STATE(2588),
    [sym_choose] = STATE(2588),
    [sym_finite_set_literal] = STATE(2588),
    [sym_set_filter] = STATE(2588),
    [sym_set_map] = STATE(2588),
    [sym_function_evaluation] = STATE(2588),
    [sym_function_literal] = STATE(2588),
    [sym_set_of_functions] = STATE(2588),
    [sym_record_literal] = STATE(2588),
    [sym_set_of_records] = STATE(2588),
    [sym_record_value] = STATE(2588),
    [sym_except] = STATE(2588),
    [sym_prev_func_val] = STATE(2588),
    [sym_tuple_literal] = STATE(2588),
    [sym_step_expr_or_stutter] = STATE(2588),
    [sym_step_expr_no_stutter] = STATE(2588),
    [sym_fairness] = STATE(2588),
    [sym_if_then_else] = STATE(2588),
    [sym_case] = STATE(2588),
    [sym_let_in] = STATE(2588),
    [sym_conj_list] = STATE(2588),
    [sym_disj_list] = STATE(2588),
    [sym_lnot] = STATE(310),
    [sym_negative] = STATE(572),
    [sym_always] = STATE(270),
    [sym_eventually] = STATE(270),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_bound_prefix_op] = STATE(2588),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_bound_infix_op] = STATE(2588),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_bound_postfix_op] = STATE(2588),
    [sym_proof_step_ref] = STATE(2525),
    [sym_identifier] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(907),
    [sym_temporal_exists] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [aux_sym_child_id_token1] = ACTIONS(916),
    [sym_real_number] = ACTIONS(918),
    [anon_sym_BSLASHb] = ACTIONS(920),
    [anon_sym_BSLASHB] = ACTIONS(922),
    [anon_sym_BSLASHo] = ACTIONS(924),
    [anon_sym_BSLASHO] = ACTIONS(926),
    [anon_sym_BSLASHh] = ACTIONS(928),
    [anon_sym_BSLASHH] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_TRUE] = ACTIONS(932),
    [anon_sym_FALSE] = ACTIONS(932),
    [sym_string_set] = ACTIONS(934),
    [sym_boolean_set] = ACTIONS(934),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_CHOOSE] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(958),
    [anon_sym_SF_] = ACTIONS(958),
    [anon_sym_IF] = ACTIONS(960),
    [anon_sym_CASE] = ACTIONS(962),
    [anon_sym_LET] = ACTIONS(964),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1706),
    [sym_powerset] = ACTIONS(1706),
    [sym_domain] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1708),
    [sym_unchanged] = ACTIONS(1708),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(974),
    [sym__double_excl] = ACTIONS(277),
  },
  [745] = {
    [sym_block_comment] = STATE(745),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1752),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [746] = {
    [sym_block_comment] = STATE(746),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1272),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [747] = {
    [sym_block_comment] = STATE(747),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1306),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(2132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [748] = {
    [sym_block_comment] = STATE(748),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1278),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [749] = {
    [sym_block_comment] = STATE(749),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1196),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [750] = {
    [sym_block_comment] = STATE(750),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1886),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [751] = {
    [sym_block_comment] = STATE(751),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1469),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [752] = {
    [sym_block_comment] = STATE(752),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1470),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [753] = {
    [sym_block_comment] = STATE(753),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1471),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [754] = {
    [sym_block_comment] = STATE(754),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1472),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [755] = {
    [sym_block_comment] = STATE(755),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1474),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [756] = {
    [sym_block_comment] = STATE(756),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1473),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [757] = {
    [sym_block_comment] = STATE(757),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1468),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [758] = {
    [sym_block_comment] = STATE(758),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1475),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [759] = {
    [sym_block_comment] = STATE(759),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1426),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [760] = {
    [sym_block_comment] = STATE(760),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1415),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [761] = {
    [sym_block_comment] = STATE(761),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1273),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [762] = {
    [sym_block_comment] = STATE(762),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1279),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [763] = {
    [sym_block_comment] = STATE(763),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2065),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [764] = {
    [sym_block_comment] = STATE(764),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1876),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [765] = {
    [sym_block_comment] = STATE(765),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1748),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [766] = {
    [sym_block_comment] = STATE(766),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1428),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [767] = {
    [sym_block_comment] = STATE(767),
    [sym_forall] = STATE(3969),
    [sym_exists] = STATE(3969),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1099),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2677),
    [sym_bound_nonfix_op] = STATE(2677),
    [sym__expr] = STATE(1438),
    [sym_prefixed_op] = STATE(2783),
    [sym__number] = STATE(2783),
    [sym_nat_number] = STATE(2740),
    [sym_binary_number] = STATE(2740),
    [sym_octal_number] = STATE(2740),
    [sym_hex_number] = STATE(2740),
    [sym_string] = STATE(2783),
    [sym_boolean] = STATE(2783),
    [sym__number_set] = STATE(2747),
    [sym__primitive_value_set] = STATE(2783),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_label] = STATE(2783),
    [sym_subexpression] = STATE(2783),
    [sym_parentheses] = STATE(2783),
    [sym_bounded_quantification] = STATE(2783),
    [sym_unbounded_quantification] = STATE(2783),
    [sym_choose] = STATE(2783),
    [sym_finite_set_literal] = STATE(2783),
    [sym_set_filter] = STATE(2783),
    [sym_set_map] = STATE(2783),
    [sym_function_evaluation] = STATE(2783),
    [sym_function_literal] = STATE(2783),
    [sym_set_of_functions] = STATE(2783),
    [sym_record_literal] = STATE(2783),
    [sym_set_of_records] = STATE(2783),
    [sym_record_value] = STATE(2783),
    [sym_except] = STATE(2783),
    [sym_prev_func_val] = STATE(2783),
    [sym_tuple_literal] = STATE(2783),
    [sym_step_expr_or_stutter] = STATE(2783),
    [sym_step_expr_no_stutter] = STATE(2783),
    [sym_fairness] = STATE(2783),
    [sym_if_then_else] = STATE(2783),
    [sym_case] = STATE(2783),
    [sym_let_in] = STATE(2783),
    [sym_conj_list] = STATE(2783),
    [sym_disj_list] = STATE(2783),
    [sym_lnot] = STATE(286),
    [sym_negative] = STATE(656),
    [sym_always] = STATE(285),
    [sym_eventually] = STATE(285),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_bound_prefix_op] = STATE(2783),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_bound_infix_op] = STATE(2783),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_bound_postfix_op] = STATE(2783),
    [sym_proof_step_ref] = STATE(2680),
    [sym_identifier] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1074),
    [sym_temporal_exists] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [aux_sym_child_id_token1] = ACTIONS(1082),
    [sym_real_number] = ACTIONS(1086),
    [anon_sym_BSLASHb] = ACTIONS(1088),
    [anon_sym_BSLASHB] = ACTIONS(1090),
    [anon_sym_BSLASHo] = ACTIONS(1543),
    [anon_sym_BSLASHO] = ACTIONS(1094),
    [anon_sym_BSLASHh] = ACTIONS(1096),
    [anon_sym_BSLASHH] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [anon_sym_TRUE] = ACTIONS(1100),
    [anon_sym_FALSE] = ACTIONS(1100),
    [sym_string_set] = ACTIONS(1102),
    [sym_boolean_set] = ACTIONS(1102),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_CHOOSE] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1120),
    [anon_sym_SF_] = ACTIONS(1120),
    [anon_sym_IF] = ACTIONS(1122),
    [anon_sym_CASE] = ACTIONS(1124),
    [anon_sym_LET] = ACTIONS(1126),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1802),
    [sym_powerset] = ACTIONS(1802),
    [sym_domain] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1804),
    [sym_unchanged] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1569),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1136),
    [sym__double_excl] = ACTIONS(277),
  },
  [768] = {
    [sym_block_comment] = STATE(768),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1227),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [769] = {
    [sym_block_comment] = STATE(769),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1897),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [770] = {
    [sym_block_comment] = STATE(770),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1903),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [771] = {
    [sym_block_comment] = STATE(771),
    [sym_forall] = STATE(4007),
    [sym_exists] = STATE(4007),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1091),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2937),
    [sym_bound_nonfix_op] = STATE(2937),
    [sym__expr] = STATE(1568),
    [sym_prefixed_op] = STATE(3024),
    [sym__number] = STATE(3024),
    [sym_nat_number] = STATE(3014),
    [sym_binary_number] = STATE(3014),
    [sym_octal_number] = STATE(3014),
    [sym_hex_number] = STATE(3014),
    [sym_string] = STATE(3024),
    [sym_boolean] = STATE(3024),
    [sym__number_set] = STATE(3017),
    [sym__primitive_value_set] = STATE(3024),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_label] = STATE(3024),
    [sym_subexpression] = STATE(3024),
    [sym_parentheses] = STATE(3024),
    [sym_bounded_quantification] = STATE(3024),
    [sym_unbounded_quantification] = STATE(3024),
    [sym_choose] = STATE(3024),
    [sym_finite_set_literal] = STATE(3024),
    [sym_set_filter] = STATE(3024),
    [sym_set_map] = STATE(3024),
    [sym_function_evaluation] = STATE(3024),
    [sym_function_literal] = STATE(3024),
    [sym_set_of_functions] = STATE(3024),
    [sym_record_literal] = STATE(3024),
    [sym_set_of_records] = STATE(3024),
    [sym_record_value] = STATE(3024),
    [sym_except] = STATE(3024),
    [sym_prev_func_val] = STATE(3024),
    [sym_tuple_literal] = STATE(3024),
    [sym_step_expr_or_stutter] = STATE(3024),
    [sym_step_expr_no_stutter] = STATE(3024),
    [sym_fairness] = STATE(3024),
    [sym_if_then_else] = STATE(3024),
    [sym_case] = STATE(3024),
    [sym_let_in] = STATE(3024),
    [sym_conj_list] = STATE(3024),
    [sym_disj_list] = STATE(3024),
    [sym_lnot] = STATE(277),
    [sym_negative] = STATE(489),
    [sym_always] = STATE(276),
    [sym_eventually] = STATE(276),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_bound_prefix_op] = STATE(3024),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_bound_infix_op] = STATE(3024),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_bound_postfix_op] = STATE(3024),
    [sym_proof_step_ref] = STATE(2968),
    [sym_identifier] = ACTIONS(1776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(71),
    [sym_temporal_exists] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [aux_sym_child_id_token1] = ACTIONS(89),
    [sym_real_number] = ACTIONS(91),
    [anon_sym_BSLASHb] = ACTIONS(93),
    [anon_sym_BSLASHB] = ACTIONS(95),
    [anon_sym_BSLASHo] = ACTIONS(97),
    [anon_sym_BSLASHO] = ACTIONS(99),
    [anon_sym_BSLASHh] = ACTIONS(101),
    [anon_sym_BSLASHH] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [anon_sym_TRUE] = ACTIONS(105),
    [anon_sym_FALSE] = ACTIONS(105),
    [sym_string_set] = ACTIONS(107),
    [sym_boolean_set] = ACTIONS(107),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_CHOOSE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(127),
    [anon_sym_SF_] = ACTIONS(127),
    [anon_sym_IF] = ACTIONS(129),
    [anon_sym_CASE] = ACTIONS(1790),
    [anon_sym_LET] = ACTIONS(133),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1792),
    [sym_powerset] = ACTIONS(1792),
    [sym_domain] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1794),
    [sym_unchanged] = ACTIONS(1794),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(165),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(315),
    [sym__double_excl] = ACTIONS(277),
  },
  [772] = {
    [sym_block_comment] = STATE(772),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2109),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [773] = {
    [sym_block_comment] = STATE(773),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2111),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [774] = {
    [sym_block_comment] = STATE(774),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1231),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [775] = {
    [sym_block_comment] = STATE(775),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2112),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [776] = {
    [sym_block_comment] = STATE(776),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1744),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [777] = {
    [sym_block_comment] = STATE(777),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1784),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [778] = {
    [sym_block_comment] = STATE(778),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1245),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [779] = {
    [sym_block_comment] = STATE(779),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1269),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [780] = {
    [sym_block_comment] = STATE(780),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1171),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [781] = {
    [sym_block_comment] = STATE(781),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1435),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [782] = {
    [sym_block_comment] = STATE(782),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1466),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [783] = {
    [sym_block_comment] = STATE(783),
    [sym_forall] = STATE(3984),
    [sym_exists] = STATE(3984),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1092),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2377),
    [sym_bound_nonfix_op] = STATE(2377),
    [sym__expr] = STATE(1308),
    [sym_prefixed_op] = STATE(2405),
    [sym__number] = STATE(2405),
    [sym_nat_number] = STATE(2399),
    [sym_binary_number] = STATE(2399),
    [sym_octal_number] = STATE(2399),
    [sym_hex_number] = STATE(2399),
    [sym_string] = STATE(2405),
    [sym_boolean] = STATE(2405),
    [sym__number_set] = STATE(2404),
    [sym__primitive_value_set] = STATE(2405),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_label] = STATE(2405),
    [sym_subexpression] = STATE(2405),
    [sym_parentheses] = STATE(2405),
    [sym_bounded_quantification] = STATE(2405),
    [sym_unbounded_quantification] = STATE(2405),
    [sym_choose] = STATE(2405),
    [sym_finite_set_literal] = STATE(2405),
    [sym_set_filter] = STATE(2405),
    [sym_set_map] = STATE(2405),
    [sym_function_evaluation] = STATE(2405),
    [sym_function_literal] = STATE(2405),
    [sym_set_of_functions] = STATE(2405),
    [sym_record_literal] = STATE(2405),
    [sym_set_of_records] = STATE(2405),
    [sym_record_value] = STATE(2405),
    [sym_except] = STATE(2405),
    [sym_prev_func_val] = STATE(2405),
    [sym_tuple_literal] = STATE(2405),
    [sym_step_expr_or_stutter] = STATE(2405),
    [sym_step_expr_no_stutter] = STATE(2405),
    [sym_fairness] = STATE(2405),
    [sym_if_then_else] = STATE(2405),
    [sym_case] = STATE(2405),
    [sym_let_in] = STATE(2405),
    [sym_conj_list] = STATE(2405),
    [sym_disj_list] = STATE(2405),
    [sym_lnot] = STATE(264),
    [sym_negative] = STATE(517),
    [sym_always] = STATE(263),
    [sym_eventually] = STATE(263),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_bound_prefix_op] = STATE(2405),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_bound_infix_op] = STATE(2405),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_bound_postfix_op] = STATE(2405),
    [sym_proof_step_ref] = STATE(2378),
    [sym_identifier] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(326),
    [sym_temporal_exists] = ACTIONS(326),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [aux_sym_child_id_token1] = ACTIONS(340),
    [sym_real_number] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(344),
    [anon_sym_BSLASHB] = ACTIONS(346),
    [anon_sym_BSLASHo] = ACTIONS(348),
    [anon_sym_BSLASHO] = ACTIONS(350),
    [anon_sym_BSLASHh] = ACTIONS(352),
    [anon_sym_BSLASHH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_TRUE] = ACTIONS(356),
    [anon_sym_FALSE] = ACTIONS(356),
    [sym_string_set] = ACTIONS(358),
    [sym_boolean_set] = ACTIONS(358),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_CHOOSE] = ACTIONS(378),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(382),
    [anon_sym_SF_] = ACTIONS(382),
    [anon_sym_IF] = ACTIONS(384),
    [anon_sym_CASE] = ACTIONS(386),
    [anon_sym_LET] = ACTIONS(388),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(570),
    [sym_powerset] = ACTIONS(570),
    [sym_domain] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(572),
    [sym_unchanged] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(408),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(410),
    [sym__double_excl] = ACTIONS(277),
  },
  [784] = {
    [sym_block_comment] = STATE(784),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1175),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [785] = {
    [sym_block_comment] = STATE(785),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1160),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [786] = {
    [sym_block_comment] = STATE(786),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1179),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [787] = {
    [sym_block_comment] = STATE(787),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1181),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [788] = {
    [sym_block_comment] = STATE(788),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1182),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [789] = {
    [sym_block_comment] = STATE(789),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1183),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [790] = {
    [sym_block_comment] = STATE(790),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1184),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [791] = {
    [sym_block_comment] = STATE(791),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1185),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [792] = {
    [sym_block_comment] = STATE(792),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1186),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [793] = {
    [sym_block_comment] = STATE(793),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1187),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [794] = {
    [sym_block_comment] = STATE(794),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1188),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [795] = {
    [sym_block_comment] = STATE(795),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1189),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [796] = {
    [sym_block_comment] = STATE(796),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1190),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [797] = {
    [sym_block_comment] = STATE(797),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2034),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [798] = {
    [sym_block_comment] = STATE(798),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2035),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [799] = {
    [sym_block_comment] = STATE(799),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1467),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [800] = {
    [sym_block_comment] = STATE(800),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1429),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [801] = {
    [sym_block_comment] = STATE(801),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1197),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [802] = {
    [sym_block_comment] = STATE(802),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1203),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [803] = {
    [sym_block_comment] = STATE(803),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1204),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [804] = {
    [sym_block_comment] = STATE(804),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1208),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [805] = {
    [sym_block_comment] = STATE(805),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1216),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [806] = {
    [sym_block_comment] = STATE(806),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2069),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [807] = {
    [sym_block_comment] = STATE(807),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1271),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [808] = {
    [sym_block_comment] = STATE(808),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1931),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [809] = {
    [sym_block_comment] = STATE(809),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1830),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [810] = {
    [sym_block_comment] = STATE(810),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2032),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [811] = {
    [sym_block_comment] = STATE(811),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1827),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [812] = {
    [sym_block_comment] = STATE(812),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1836),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [813] = {
    [sym_block_comment] = STATE(813),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1944),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [814] = {
    [sym_block_comment] = STATE(814),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1977),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [815] = {
    [sym_block_comment] = STATE(815),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1988),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [816] = {
    [sym_block_comment] = STATE(816),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1991),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [817] = {
    [sym_block_comment] = STATE(817),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1992),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [818] = {
    [sym_block_comment] = STATE(818),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2029),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [819] = {
    [sym_block_comment] = STATE(819),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1918),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [820] = {
    [sym_block_comment] = STATE(820),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1921),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [821] = {
    [sym_block_comment] = STATE(821),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1985),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [822] = {
    [sym_block_comment] = STATE(822),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1431),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [823] = {
    [sym_block_comment] = STATE(823),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1860),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [824] = {
    [sym_block_comment] = STATE(824),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2037),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [825] = {
    [sym_block_comment] = STATE(825),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1861),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [826] = {
    [sym_block_comment] = STATE(826),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1865),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [827] = {
    [sym_block_comment] = STATE(827),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2050),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [828] = {
    [sym_block_comment] = STATE(828),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2051),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [829] = {
    [sym_block_comment] = STATE(829),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2053),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [830] = {
    [sym_block_comment] = STATE(830),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2054),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [831] = {
    [sym_block_comment] = STATE(831),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1303),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [832] = {
    [sym_block_comment] = STATE(832),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2064),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [833] = {
    [sym_block_comment] = STATE(833),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2066),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [834] = {
    [sym_block_comment] = STATE(834),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2068),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [835] = {
    [sym_block_comment] = STATE(835),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1905),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [836] = {
    [sym_block_comment] = STATE(836),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1919),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [837] = {
    [sym_block_comment] = STATE(837),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1798),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [838] = {
    [sym_block_comment] = STATE(838),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1874),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [839] = {
    [sym_block_comment] = STATE(839),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1932),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [840] = {
    [sym_block_comment] = STATE(840),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1879),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [841] = {
    [sym_block_comment] = STATE(841),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1880),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [842] = {
    [sym_block_comment] = STATE(842),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1945),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [843] = {
    [sym_block_comment] = STATE(843),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1947),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [844] = {
    [sym_block_comment] = STATE(844),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1948),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [845] = {
    [sym_block_comment] = STATE(845),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1958),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [846] = {
    [sym_block_comment] = STATE(846),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1166),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [847] = {
    [sym_block_comment] = STATE(847),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1959),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [848] = {
    [sym_block_comment] = STATE(848),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1960),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [849] = {
    [sym_block_comment] = STATE(849),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1962),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [850] = {
    [sym_block_comment] = STATE(850),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1973),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [851] = {
    [sym_block_comment] = STATE(851),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1976),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [852] = {
    [sym_block_comment] = STATE(852),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1828),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [853] = {
    [sym_block_comment] = STATE(853),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1989),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [854] = {
    [sym_block_comment] = STATE(854),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1831),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [855] = {
    [sym_block_comment] = STATE(855),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1832),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [856] = {
    [sym_block_comment] = STATE(856),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2002),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [857] = {
    [sym_block_comment] = STATE(857),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2003),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [858] = {
    [sym_block_comment] = STATE(858),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2004),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [859] = {
    [sym_block_comment] = STATE(859),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2006),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [860] = {
    [sym_block_comment] = STATE(860),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2007),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [861] = {
    [sym_block_comment] = STATE(861),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2018),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [862] = {
    [sym_block_comment] = STATE(862),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2020),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [863] = {
    [sym_block_comment] = STATE(863),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2021),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [864] = {
    [sym_block_comment] = STATE(864),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2027),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [865] = {
    [sym_block_comment] = STATE(865),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1200),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [866] = {
    [sym_block_comment] = STATE(866),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1840),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [867] = {
    [sym_block_comment] = STATE(867),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2036),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [868] = {
    [sym_block_comment] = STATE(868),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1844),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [869] = {
    [sym_block_comment] = STATE(869),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1853),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [870] = {
    [sym_block_comment] = STATE(870),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2038),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [871] = {
    [sym_block_comment] = STATE(871),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2040),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [872] = {
    [sym_block_comment] = STATE(872),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2041),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [873] = {
    [sym_block_comment] = STATE(873),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2042),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [874] = {
    [sym_block_comment] = STATE(874),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1295),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [875] = {
    [sym_block_comment] = STATE(875),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2045),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [876] = {
    [sym_block_comment] = STATE(876),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2046),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [877] = {
    [sym_block_comment] = STATE(877),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2047),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [878] = {
    [sym_block_comment] = STATE(878),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2048),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [879] = {
    [sym_block_comment] = STATE(879),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2049),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [880] = {
    [sym_block_comment] = STATE(880),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1889),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [881] = {
    [sym_block_comment] = STATE(881),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1430),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [882] = {
    [sym_block_comment] = STATE(882),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1857),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [883] = {
    [sym_block_comment] = STATE(883),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2052),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [884] = {
    [sym_block_comment] = STATE(884),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1858),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [885] = {
    [sym_block_comment] = STATE(885),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1859),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [886] = {
    [sym_block_comment] = STATE(886),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2055),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [887] = {
    [sym_block_comment] = STATE(887),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2056),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [888] = {
    [sym_block_comment] = STATE(888),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2057),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [889] = {
    [sym_block_comment] = STATE(889),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2058),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [890] = {
    [sym_block_comment] = STATE(890),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2059),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [891] = {
    [sym_block_comment] = STATE(891),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2060),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [892] = {
    [sym_block_comment] = STATE(892),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2061),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [893] = {
    [sym_block_comment] = STATE(893),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2062),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [894] = {
    [sym_block_comment] = STATE(894),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2063),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [895] = {
    [sym_block_comment] = STATE(895),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1433),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [896] = {
    [sym_block_comment] = STATE(896),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1862),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [897] = {
    [sym_block_comment] = STATE(897),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2067),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [898] = {
    [sym_block_comment] = STATE(898),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1863),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [899] = {
    [sym_block_comment] = STATE(899),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1864),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [900] = {
    [sym_block_comment] = STATE(900),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2070),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [901] = {
    [sym_block_comment] = STATE(901),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2071),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [902] = {
    [sym_block_comment] = STATE(902),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2072),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [903] = {
    [sym_block_comment] = STATE(903),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2073),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [904] = {
    [sym_block_comment] = STATE(904),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1215),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [905] = {
    [sym_block_comment] = STATE(905),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2076),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [906] = {
    [sym_block_comment] = STATE(906),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2079),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [907] = {
    [sym_block_comment] = STATE(907),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2080),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [908] = {
    [sym_block_comment] = STATE(908),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2110),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [909] = {
    [sym_block_comment] = STATE(909),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1906),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [910] = {
    [sym_block_comment] = STATE(910),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1163),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [911] = {
    [sym_block_comment] = STATE(911),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1164),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [912] = {
    [sym_block_comment] = STATE(912),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1867),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [913] = {
    [sym_block_comment] = STATE(913),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1909),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [914] = {
    [sym_block_comment] = STATE(914),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1868),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [915] = {
    [sym_block_comment] = STATE(915),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1869),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [916] = {
    [sym_block_comment] = STATE(916),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1910),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [917] = {
    [sym_block_comment] = STATE(917),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1911),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [918] = {
    [sym_block_comment] = STATE(918),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1912),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [919] = {
    [sym_block_comment] = STATE(919),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1913),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [920] = {
    [sym_block_comment] = STATE(920),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1165),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [921] = {
    [sym_block_comment] = STATE(921),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1914),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [922] = {
    [sym_block_comment] = STATE(922),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1915),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [923] = {
    [sym_block_comment] = STATE(923),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1916),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [924] = {
    [sym_block_comment] = STATE(924),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2114),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [925] = {
    [sym_block_comment] = STATE(925),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1917),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [926] = {
    [sym_block_comment] = STATE(926),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1890),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [927] = {
    [sym_block_comment] = STATE(927),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1871),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [928] = {
    [sym_block_comment] = STATE(928),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1920),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [929] = {
    [sym_block_comment] = STATE(929),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1872),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [930] = {
    [sym_block_comment] = STATE(930),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1873),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [931] = {
    [sym_block_comment] = STATE(931),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1922),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [932] = {
    [sym_block_comment] = STATE(932),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1923),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [933] = {
    [sym_block_comment] = STATE(933),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1924),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [934] = {
    [sym_block_comment] = STATE(934),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1925),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [935] = {
    [sym_block_comment] = STATE(935),
    [sym_forall] = STATE(4000),
    [sym_exists] = STATE(4000),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1089),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2539),
    [sym_bound_nonfix_op] = STATE(2539),
    [sym__expr] = STATE(1432),
    [sym_prefixed_op] = STATE(2724),
    [sym__number] = STATE(2724),
    [sym_nat_number] = STATE(2720),
    [sym_binary_number] = STATE(2720),
    [sym_octal_number] = STATE(2720),
    [sym_hex_number] = STATE(2720),
    [sym_string] = STATE(2724),
    [sym_boolean] = STATE(2724),
    [sym__number_set] = STATE(2726),
    [sym__primitive_value_set] = STATE(2724),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_label] = STATE(2724),
    [sym_subexpression] = STATE(2724),
    [sym_parentheses] = STATE(2724),
    [sym_bounded_quantification] = STATE(2724),
    [sym_unbounded_quantification] = STATE(2724),
    [sym_choose] = STATE(2724),
    [sym_finite_set_literal] = STATE(2724),
    [sym_set_filter] = STATE(2724),
    [sym_set_map] = STATE(2724),
    [sym_function_evaluation] = STATE(2724),
    [sym_function_literal] = STATE(2724),
    [sym_set_of_functions] = STATE(2724),
    [sym_record_literal] = STATE(2724),
    [sym_set_of_records] = STATE(2724),
    [sym_record_value] = STATE(2724),
    [sym_except] = STATE(2724),
    [sym_prev_func_val] = STATE(2724),
    [sym_tuple_literal] = STATE(2724),
    [sym_step_expr_or_stutter] = STATE(2724),
    [sym_step_expr_no_stutter] = STATE(2724),
    [sym_fairness] = STATE(2724),
    [sym_if_then_else] = STATE(2724),
    [sym_case] = STATE(2724),
    [sym_let_in] = STATE(2724),
    [sym_conj_list] = STATE(2724),
    [sym_disj_list] = STATE(2724),
    [sym_lnot] = STATE(255),
    [sym_negative] = STATE(436),
    [sym_always] = STATE(254),
    [sym_eventually] = STATE(254),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_bound_prefix_op] = STATE(2724),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_bound_infix_op] = STATE(2724),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_bound_postfix_op] = STATE(2724),
    [sym_proof_step_ref] = STATE(2651),
    [sym_identifier] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1148),
    [sym_temporal_exists] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [aux_sym_child_id_token1] = ACTIONS(1157),
    [sym_real_number] = ACTIONS(1159),
    [anon_sym_BSLASHb] = ACTIONS(1161),
    [anon_sym_BSLASHB] = ACTIONS(1163),
    [anon_sym_BSLASHo] = ACTIONS(1165),
    [anon_sym_BSLASHO] = ACTIONS(1167),
    [anon_sym_BSLASHh] = ACTIONS(1169),
    [anon_sym_BSLASHH] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_TRUE] = ACTIONS(1173),
    [anon_sym_FALSE] = ACTIONS(1173),
    [sym_string_set] = ACTIONS(1175),
    [sym_boolean_set] = ACTIONS(1175),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_CHOOSE] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1199),
    [anon_sym_SF_] = ACTIONS(1199),
    [anon_sym_IF] = ACTIONS(1201),
    [anon_sym_CASE] = ACTIONS(1203),
    [anon_sym_LET] = ACTIONS(1205),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1808),
    [sym_powerset] = ACTIONS(1808),
    [sym_domain] = ACTIONS(1808),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1810),
    [sym_unchanged] = ACTIONS(1810),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1213),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1215),
    [sym__double_excl] = ACTIONS(277),
  },
  [936] = {
    [sym_block_comment] = STATE(936),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1926),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [937] = {
    [sym_block_comment] = STATE(937),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1927),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [938] = {
    [sym_block_comment] = STATE(938),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1928),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [939] = {
    [sym_block_comment] = STATE(939),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1929),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [940] = {
    [sym_block_comment] = STATE(940),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1930),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [941] = {
    [sym_block_comment] = STATE(941),
    [sym_forall] = STATE(4001),
    [sym_exists] = STATE(4001),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1097),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2240),
    [sym_bound_nonfix_op] = STATE(2240),
    [sym__expr] = STATE(1167),
    [sym_prefixed_op] = STATE(2301),
    [sym__number] = STATE(2301),
    [sym_nat_number] = STATE(2310),
    [sym_binary_number] = STATE(2310),
    [sym_octal_number] = STATE(2310),
    [sym_hex_number] = STATE(2310),
    [sym_string] = STATE(2301),
    [sym_boolean] = STATE(2301),
    [sym__number_set] = STATE(2258),
    [sym__primitive_value_set] = STATE(2301),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_label] = STATE(2301),
    [sym_subexpression] = STATE(2301),
    [sym_parentheses] = STATE(2301),
    [sym_bounded_quantification] = STATE(2301),
    [sym_unbounded_quantification] = STATE(2301),
    [sym_choose] = STATE(2301),
    [sym_finite_set_literal] = STATE(2301),
    [sym_set_filter] = STATE(2301),
    [sym_set_map] = STATE(2301),
    [sym_function_evaluation] = STATE(2301),
    [sym_function_literal] = STATE(2301),
    [sym_set_of_functions] = STATE(2301),
    [sym_record_literal] = STATE(2301),
    [sym_set_of_records] = STATE(2301),
    [sym_record_value] = STATE(2301),
    [sym_except] = STATE(2301),
    [sym_prev_func_val] = STATE(2301),
    [sym_tuple_literal] = STATE(2301),
    [sym_step_expr_or_stutter] = STATE(2301),
    [sym_step_expr_no_stutter] = STATE(2301),
    [sym_fairness] = STATE(2301),
    [sym_if_then_else] = STATE(2301),
    [sym_case] = STATE(2301),
    [sym_let_in] = STATE(2301),
    [sym_conj_list] = STATE(2301),
    [sym_disj_list] = STATE(2301),
    [sym_lnot] = STATE(299),
    [sym_negative] = STATE(780),
    [sym_always] = STATE(290),
    [sym_eventually] = STATE(290),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_bound_prefix_op] = STATE(2301),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_bound_infix_op] = STATE(2301),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_bound_postfix_op] = STATE(2301),
    [sym_proof_step_ref] = STATE(2239),
    [sym_identifier] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1642),
    [sym_temporal_exists] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1644),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [aux_sym_child_id_token1] = ACTIONS(1650),
    [sym_real_number] = ACTIONS(1652),
    [anon_sym_BSLASHb] = ACTIONS(1654),
    [anon_sym_BSLASHB] = ACTIONS(1656),
    [anon_sym_BSLASHo] = ACTIONS(1658),
    [anon_sym_BSLASHO] = ACTIONS(1660),
    [anon_sym_BSLASHh] = ACTIONS(1662),
    [anon_sym_BSLASHH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_TRUE] = ACTIONS(1666),
    [anon_sym_FALSE] = ACTIONS(1666),
    [sym_string_set] = ACTIONS(1668),
    [sym_boolean_set] = ACTIONS(1668),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_CHOOSE] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1686),
    [anon_sym_SF_] = ACTIONS(1686),
    [anon_sym_IF] = ACTIONS(1688),
    [anon_sym_CASE] = ACTIONS(1690),
    [anon_sym_LET] = ACTIONS(1692),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1694),
    [sym_powerset] = ACTIONS(1694),
    [sym_domain] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1696),
    [sym_unchanged] = ACTIONS(1696),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1698),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1702),
    [sym__double_excl] = ACTIONS(277),
  },
  [942] = {
    [sym_block_comment] = STATE(942),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1875),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [943] = {
    [sym_block_comment] = STATE(943),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1933),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [944] = {
    [sym_block_comment] = STATE(944),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1877),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [945] = {
    [sym_block_comment] = STATE(945),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1878),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [946] = {
    [sym_block_comment] = STATE(946),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1934),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [947] = {
    [sym_block_comment] = STATE(947),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1935),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [948] = {
    [sym_block_comment] = STATE(948),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1936),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [949] = {
    [sym_block_comment] = STATE(949),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1937),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [950] = {
    [sym_block_comment] = STATE(950),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1938),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [951] = {
    [sym_block_comment] = STATE(951),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1939),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [952] = {
    [sym_block_comment] = STATE(952),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1940),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [953] = {
    [sym_block_comment] = STATE(953),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1941),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [954] = {
    [sym_block_comment] = STATE(954),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1942),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [955] = {
    [sym_block_comment] = STATE(955),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1881),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [956] = {
    [sym_block_comment] = STATE(956),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1946),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [957] = {
    [sym_block_comment] = STATE(957),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1882),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [958] = {
    [sym_block_comment] = STATE(958),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1884),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [959] = {
    [sym_block_comment] = STATE(959),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1949),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [960] = {
    [sym_block_comment] = STATE(960),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1950),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [961] = {
    [sym_block_comment] = STATE(961),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1951),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [962] = {
    [sym_block_comment] = STATE(962),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1952),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [963] = {
    [sym_block_comment] = STATE(963),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1953),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [964] = {
    [sym_block_comment] = STATE(964),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1954),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [965] = {
    [sym_block_comment] = STATE(965),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1955),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [966] = {
    [sym_block_comment] = STATE(966),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1956),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [967] = {
    [sym_block_comment] = STATE(967),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1957),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [968] = {
    [sym_block_comment] = STATE(968),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1901),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [969] = {
    [sym_block_comment] = STATE(969),
    [sym_forall] = STATE(3983),
    [sym_exists] = STATE(3983),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1087),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(3348),
    [sym_bound_nonfix_op] = STATE(3348),
    [sym__expr] = STATE(1899),
    [sym_prefixed_op] = STATE(3375),
    [sym__number] = STATE(3375),
    [sym_nat_number] = STATE(3365),
    [sym_binary_number] = STATE(3365),
    [sym_octal_number] = STATE(3365),
    [sym_hex_number] = STATE(3365),
    [sym_string] = STATE(3375),
    [sym_boolean] = STATE(3375),
    [sym__number_set] = STATE(3370),
    [sym__primitive_value_set] = STATE(3375),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_label] = STATE(3375),
    [sym_subexpression] = STATE(3375),
    [sym_parentheses] = STATE(3375),
    [sym_bounded_quantification] = STATE(3375),
    [sym_unbounded_quantification] = STATE(3375),
    [sym_choose] = STATE(3375),
    [sym_finite_set_literal] = STATE(3375),
    [sym_set_filter] = STATE(3375),
    [sym_set_map] = STATE(3375),
    [sym_function_evaluation] = STATE(3375),
    [sym_function_literal] = STATE(3375),
    [sym_set_of_functions] = STATE(3375),
    [sym_record_literal] = STATE(3375),
    [sym_set_of_records] = STATE(3375),
    [sym_record_value] = STATE(3375),
    [sym_except] = STATE(3375),
    [sym_prev_func_val] = STATE(3375),
    [sym_tuple_literal] = STATE(3375),
    [sym_step_expr_or_stutter] = STATE(3375),
    [sym_step_expr_no_stutter] = STATE(3375),
    [sym_fairness] = STATE(3375),
    [sym_if_then_else] = STATE(3375),
    [sym_case] = STATE(3375),
    [sym_let_in] = STATE(3375),
    [sym_conj_list] = STATE(3375),
    [sym_disj_list] = STATE(3375),
    [sym_lnot] = STATE(249),
    [sym_negative] = STATE(384),
    [sym_always] = STATE(248),
    [sym_eventually] = STATE(248),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_bound_prefix_op] = STATE(3375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_bound_infix_op] = STATE(3375),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_bound_postfix_op] = STATE(3375),
    [sym_proof_step_ref] = STATE(3349),
    [sym_identifier] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1915),
    [sym_temporal_exists] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [aux_sym_child_id_token1] = ACTIONS(1924),
    [sym_real_number] = ACTIONS(1926),
    [anon_sym_BSLASHb] = ACTIONS(1928),
    [anon_sym_BSLASHB] = ACTIONS(1930),
    [anon_sym_BSLASHo] = ACTIONS(1932),
    [anon_sym_BSLASHO] = ACTIONS(1934),
    [anon_sym_BSLASHh] = ACTIONS(1936),
    [anon_sym_BSLASHH] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_TRUE] = ACTIONS(1940),
    [anon_sym_FALSE] = ACTIONS(1940),
    [sym_string_set] = ACTIONS(1942),
    [sym_boolean_set] = ACTIONS(1942),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_CHOOSE] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1960),
    [anon_sym_SF_] = ACTIONS(1960),
    [anon_sym_IF] = ACTIONS(1962),
    [anon_sym_CASE] = ACTIONS(1964),
    [anon_sym_LET] = ACTIONS(1966),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1968),
    [sym_powerset] = ACTIONS(1968),
    [sym_domain] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1970),
    [sym_unchanged] = ACTIONS(1970),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1972),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1974),
    [sym__double_excl] = ACTIONS(277),
  },
  [970] = {
    [sym_block_comment] = STATE(970),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1826),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [971] = {
    [sym_block_comment] = STATE(971),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1961),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [972] = {
    [sym_block_comment] = STATE(972),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1829),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [973] = {
    [sym_block_comment] = STATE(973),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1885),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [974] = {
    [sym_block_comment] = STATE(974),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1964),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [975] = {
    [sym_block_comment] = STATE(975),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1965),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [976] = {
    [sym_block_comment] = STATE(976),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1966),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [977] = {
    [sym_block_comment] = STATE(977),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1967),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [978] = {
    [sym_block_comment] = STATE(978),
    [sym_forall] = STATE(4003),
    [sym_exists] = STATE(4003),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1098),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2383),
    [sym_bound_nonfix_op] = STATE(2383),
    [sym__expr] = STATE(1230),
    [sym_prefixed_op] = STATE(2406),
    [sym__number] = STATE(2406),
    [sym_nat_number] = STATE(2459),
    [sym_binary_number] = STATE(2459),
    [sym_octal_number] = STATE(2459),
    [sym_hex_number] = STATE(2459),
    [sym_string] = STATE(2406),
    [sym_boolean] = STATE(2406),
    [sym__number_set] = STATE(2463),
    [sym__primitive_value_set] = STATE(2406),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_label] = STATE(2406),
    [sym_subexpression] = STATE(2406),
    [sym_parentheses] = STATE(2406),
    [sym_bounded_quantification] = STATE(2406),
    [sym_unbounded_quantification] = STATE(2406),
    [sym_choose] = STATE(2406),
    [sym_finite_set_literal] = STATE(2406),
    [sym_set_filter] = STATE(2406),
    [sym_set_map] = STATE(2406),
    [sym_function_evaluation] = STATE(2406),
    [sym_function_literal] = STATE(2406),
    [sym_set_of_functions] = STATE(2406),
    [sym_record_literal] = STATE(2406),
    [sym_set_of_records] = STATE(2406),
    [sym_record_value] = STATE(2406),
    [sym_except] = STATE(2406),
    [sym_prev_func_val] = STATE(2406),
    [sym_tuple_literal] = STATE(2406),
    [sym_step_expr_or_stutter] = STATE(2406),
    [sym_step_expr_no_stutter] = STATE(2406),
    [sym_fairness] = STATE(2406),
    [sym_if_then_else] = STATE(2406),
    [sym_case] = STATE(2406),
    [sym_let_in] = STATE(2406),
    [sym_conj_list] = STATE(2406),
    [sym_disj_list] = STATE(2406),
    [sym_lnot] = STATE(292),
    [sym_negative] = STATE(807),
    [sym_always] = STATE(245),
    [sym_eventually] = STATE(245),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_bound_prefix_op] = STATE(2406),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_bound_infix_op] = STATE(2406),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_bound_postfix_op] = STATE(2406),
    [sym_proof_step_ref] = STATE(2384),
    [sym_identifier] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(415),
    [sym_temporal_exists] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [aux_sym_child_id_token1] = ACTIONS(424),
    [sym_real_number] = ACTIONS(426),
    [anon_sym_BSLASHb] = ACTIONS(428),
    [anon_sym_BSLASHB] = ACTIONS(430),
    [anon_sym_BSLASHo] = ACTIONS(432),
    [anon_sym_BSLASHO] = ACTIONS(434),
    [anon_sym_BSLASHh] = ACTIONS(436),
    [anon_sym_BSLASHH] = ACTIONS(436),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_TRUE] = ACTIONS(440),
    [anon_sym_FALSE] = ACTIONS(440),
    [sym_string_set] = ACTIONS(442),
    [sym_boolean_set] = ACTIONS(442),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_CHOOSE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(466),
    [anon_sym_SF_] = ACTIONS(466),
    [anon_sym_IF] = ACTIONS(468),
    [anon_sym_CASE] = ACTIONS(470),
    [anon_sym_LET] = ACTIONS(472),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(594),
    [sym_powerset] = ACTIONS(594),
    [sym_domain] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(596),
    [sym_unchanged] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(480),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(482),
    [sym__double_excl] = ACTIONS(277),
  },
  [979] = {
    [sym_block_comment] = STATE(979),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1968),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [980] = {
    [sym_block_comment] = STATE(980),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1969),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [981] = {
    [sym_block_comment] = STATE(981),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1970),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [982] = {
    [sym_block_comment] = STATE(982),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1971),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [983] = {
    [sym_block_comment] = STATE(983),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1972),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [984] = {
    [sym_block_comment] = STATE(984),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1359),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [985] = {
    [sym_block_comment] = STATE(985),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1833),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [986] = {
    [sym_block_comment] = STATE(986),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1975),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [987] = {
    [sym_block_comment] = STATE(987),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1834),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [988] = {
    [sym_block_comment] = STATE(988),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1835),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [989] = {
    [sym_block_comment] = STATE(989),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1978),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [990] = {
    [sym_block_comment] = STATE(990),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1979),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [991] = {
    [sym_block_comment] = STATE(991),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1980),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [992] = {
    [sym_block_comment] = STATE(992),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1981),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [993] = {
    [sym_block_comment] = STATE(993),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1360),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [994] = {
    [sym_block_comment] = STATE(994),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1982),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [995] = {
    [sym_block_comment] = STATE(995),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1983),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [996] = {
    [sym_block_comment] = STATE(996),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1984),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [997] = {
    [sym_block_comment] = STATE(997),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1986),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [998] = {
    [sym_block_comment] = STATE(998),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1987),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [999] = {
    [sym_block_comment] = STATE(999),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1361),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1000] = {
    [sym_block_comment] = STATE(1000),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1837),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1001] = {
    [sym_block_comment] = STATE(1001),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1990),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1002] = {
    [sym_block_comment] = STATE(1002),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1838),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1003] = {
    [sym_block_comment] = STATE(1003),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1839),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1004] = {
    [sym_block_comment] = STATE(1004),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1993),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1005] = {
    [sym_block_comment] = STATE(1005),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1994),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1006] = {
    [sym_block_comment] = STATE(1006),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1995),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1007] = {
    [sym_block_comment] = STATE(1007),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1996),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1008] = {
    [sym_block_comment] = STATE(1008),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1362),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1009] = {
    [sym_block_comment] = STATE(1009),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1997),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1010] = {
    [sym_block_comment] = STATE(1010),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1998),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1011] = {
    [sym_block_comment] = STATE(1011),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1999),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1012] = {
    [sym_block_comment] = STATE(1012),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2000),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1013] = {
    [sym_block_comment] = STATE(1013),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2001),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1014] = {
    [sym_block_comment] = STATE(1014),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1363),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1015] = {
    [sym_block_comment] = STATE(1015),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1364),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1016] = {
    [sym_block_comment] = STATE(1016),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1841),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1017] = {
    [sym_block_comment] = STATE(1017),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2005),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1018] = {
    [sym_block_comment] = STATE(1018),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1842),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1019] = {
    [sym_block_comment] = STATE(1019),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1843),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1020] = {
    [sym_block_comment] = STATE(1020),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2008),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1021] = {
    [sym_block_comment] = STATE(1021),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2009),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1022] = {
    [sym_block_comment] = STATE(1022),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2010),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1023] = {
    [sym_block_comment] = STATE(1023),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2011),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1024] = {
    [sym_block_comment] = STATE(1024),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1365),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1025] = {
    [sym_block_comment] = STATE(1025),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2012),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1026] = {
    [sym_block_comment] = STATE(1026),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2013),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1027] = {
    [sym_block_comment] = STATE(1027),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2014),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1028] = {
    [sym_block_comment] = STATE(1028),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2016),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1029] = {
    [sym_block_comment] = STATE(1029),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2017),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1030] = {
    [sym_block_comment] = STATE(1030),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1366),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1031] = {
    [sym_block_comment] = STATE(1031),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2019),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1032] = {
    [sym_block_comment] = STATE(1032),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1845),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1033] = {
    [sym_block_comment] = STATE(1033),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1846),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1034] = {
    [sym_block_comment] = STATE(1034),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2022),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1035] = {
    [sym_block_comment] = STATE(1035),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2023),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1036] = {
    [sym_block_comment] = STATE(1036),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2024),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1037] = {
    [sym_block_comment] = STATE(1037),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2025),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1038] = {
    [sym_block_comment] = STATE(1038),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2026),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1039] = {
    [sym_block_comment] = STATE(1039),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1367),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1040] = {
    [sym_block_comment] = STATE(1040),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1368),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1041] = {
    [sym_block_comment] = STATE(1041),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1369),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1042] = {
    [sym_block_comment] = STATE(1042),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1370),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1043] = {
    [sym_block_comment] = STATE(1043),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1371),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1044] = {
    [sym_block_comment] = STATE(1044),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1372),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1045] = {
    [sym_block_comment] = STATE(1045),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1373),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1046] = {
    [sym_block_comment] = STATE(1046),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1374),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1047] = {
    [sym_block_comment] = STATE(1047),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1375),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1048] = {
    [sym_block_comment] = STATE(1048),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1376),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1049] = {
    [sym_block_comment] = STATE(1049),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1377),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1050] = {
    [sym_block_comment] = STATE(1050),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1866),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1051] = {
    [sym_block_comment] = STATE(1051),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1870),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1052] = {
    [sym_block_comment] = STATE(1052),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1963),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1053] = {
    [sym_block_comment] = STATE(1053),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(1943),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1054] = {
    [sym_block_comment] = STATE(1054),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2074),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1055] = {
    [sym_block_comment] = STATE(1055),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2075),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1056] = {
    [sym_block_comment] = STATE(1056),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2077),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1057] = {
    [sym_block_comment] = STATE(1057),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2078),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1058] = {
    [sym_block_comment] = STATE(1058),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2081),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1059] = {
    [sym_block_comment] = STATE(1059),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2082),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1060] = {
    [sym_block_comment] = STATE(1060),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2083),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1061] = {
    [sym_block_comment] = STATE(1061),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2084),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1062] = {
    [sym_block_comment] = STATE(1062),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2085),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1063] = {
    [sym_block_comment] = STATE(1063),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2086),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1064] = {
    [sym_block_comment] = STATE(1064),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2087),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1065] = {
    [sym_block_comment] = STATE(1065),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2088),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1066] = {
    [sym_block_comment] = STATE(1066),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2089),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1067] = {
    [sym_block_comment] = STATE(1067),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2090),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1068] = {
    [sym_block_comment] = STATE(1068),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2091),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1069] = {
    [sym_block_comment] = STATE(1069),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2092),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1070] = {
    [sym_block_comment] = STATE(1070),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2093),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1071] = {
    [sym_block_comment] = STATE(1071),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2094),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1072] = {
    [sym_block_comment] = STATE(1072),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2095),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1073] = {
    [sym_block_comment] = STATE(1073),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2096),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1074] = {
    [sym_block_comment] = STATE(1074),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2097),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1075] = {
    [sym_block_comment] = STATE(1075),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2098),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1076] = {
    [sym_block_comment] = STATE(1076),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2099),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1077] = {
    [sym_block_comment] = STATE(1077),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2100),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1078] = {
    [sym_block_comment] = STATE(1078),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2101),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1079] = {
    [sym_block_comment] = STATE(1079),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2102),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1080] = {
    [sym_block_comment] = STATE(1080),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2103),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1081] = {
    [sym_block_comment] = STATE(1081),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2104),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1082] = {
    [sym_block_comment] = STATE(1082),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2105),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1083] = {
    [sym_block_comment] = STATE(1083),
    [sym_forall] = STATE(3979),
    [sym_exists] = STATE(3979),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1100),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2531),
    [sym_bound_nonfix_op] = STATE(2531),
    [sym__expr] = STATE(2106),
    [sym_prefixed_op] = STATE(2636),
    [sym__number] = STATE(2636),
    [sym_nat_number] = STATE(2558),
    [sym_binary_number] = STATE(2558),
    [sym_octal_number] = STATE(2558),
    [sym_hex_number] = STATE(2558),
    [sym_string] = STATE(2636),
    [sym_boolean] = STATE(2636),
    [sym__number_set] = STATE(2561),
    [sym__primitive_value_set] = STATE(2636),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_label] = STATE(2636),
    [sym_subexpression] = STATE(2636),
    [sym_parentheses] = STATE(2636),
    [sym_bounded_quantification] = STATE(2636),
    [sym_unbounded_quantification] = STATE(2636),
    [sym_choose] = STATE(2636),
    [sym_finite_set_literal] = STATE(2636),
    [sym_set_filter] = STATE(2636),
    [sym_set_map] = STATE(2636),
    [sym_function_evaluation] = STATE(2636),
    [sym_function_literal] = STATE(2636),
    [sym_set_of_functions] = STATE(2636),
    [sym_record_literal] = STATE(2636),
    [sym_set_of_records] = STATE(2636),
    [sym_record_value] = STATE(2636),
    [sym_except] = STATE(2636),
    [sym_prev_func_val] = STATE(2636),
    [sym_tuple_literal] = STATE(2636),
    [sym_step_expr_or_stutter] = STATE(2636),
    [sym_step_expr_no_stutter] = STATE(2636),
    [sym_fairness] = STATE(2636),
    [sym_if_then_else] = STATE(2636),
    [sym_case] = STATE(2636),
    [sym_let_in] = STATE(2636),
    [sym_conj_list] = STATE(2636),
    [sym_disj_list] = STATE(2636),
    [sym_lnot] = STATE(53),
    [sym_negative] = STATE(984),
    [sym_always] = STATE(52),
    [sym_eventually] = STATE(52),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_bound_prefix_op] = STATE(2636),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_bound_infix_op] = STATE(2636),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_bound_postfix_op] = STATE(2636),
    [sym_proof_step_ref] = STATE(2521),
    [sym_identifier] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(486),
    [sym_temporal_exists] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [aux_sym_child_id_token1] = ACTIONS(496),
    [sym_real_number] = ACTIONS(498),
    [anon_sym_BSLASHb] = ACTIONS(500),
    [anon_sym_BSLASHB] = ACTIONS(502),
    [anon_sym_BSLASHo] = ACTIONS(504),
    [anon_sym_BSLASHO] = ACTIONS(506),
    [anon_sym_BSLASHh] = ACTIONS(508),
    [anon_sym_BSLASHH] = ACTIONS(508),
    [anon_sym_DQUOTE] = ACTIONS(510),
    [anon_sym_TRUE] = ACTIONS(512),
    [anon_sym_FALSE] = ACTIONS(512),
    [sym_string_set] = ACTIONS(514),
    [sym_boolean_set] = ACTIONS(514),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_CHOOSE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(532),
    [anon_sym_SF_] = ACTIONS(532),
    [anon_sym_IF] = ACTIONS(534),
    [anon_sym_CASE] = ACTIONS(536),
    [anon_sym_LET] = ACTIONS(538),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(540),
    [sym_powerset] = ACTIONS(540),
    [sym_domain] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(542),
    [sym_unchanged] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(544),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(550),
    [sym__double_excl] = ACTIONS(277),
  },
  [1084] = {
    [sym_block_comment] = STATE(1084),
    [sym_forall] = STATE(4005),
    [sym_exists] = STATE(4005),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1093),
    [sym_subexpr_component] = STATE(5469),
    [sym_bound_op] = STATE(2228),
    [sym_bound_nonfix_op] = STATE(2228),
    [sym__expr] = STATE(1193),
    [sym_prefixed_op] = STATE(2291),
    [sym__number] = STATE(2291),
    [sym_nat_number] = STATE(2287),
    [sym_binary_number] = STATE(2287),
    [sym_octal_number] = STATE(2287),
    [sym_hex_number] = STATE(2287),
    [sym_string] = STATE(2291),
    [sym_boolean] = STATE(2291),
    [sym__number_set] = STATE(2289),
    [sym__primitive_value_set] = STATE(2291),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_label] = STATE(2291),
    [sym_subexpression] = STATE(2291),
    [sym_parentheses] = STATE(2291),
    [sym_bounded_quantification] = STATE(2291),
    [sym_unbounded_quantification] = STATE(2291),
    [sym_choose] = STATE(2291),
    [sym_finite_set_literal] = STATE(2291),
    [sym_set_filter] = STATE(2291),
    [sym_set_map] = STATE(2291),
    [sym_function_evaluation] = STATE(2291),
    [sym_function_literal] = STATE(2291),
    [sym_set_of_functions] = STATE(2291),
    [sym_record_literal] = STATE(2291),
    [sym_set_of_records] = STATE(2291),
    [sym_record_value] = STATE(2291),
    [sym_except] = STATE(2291),
    [sym_prev_func_val] = STATE(2291),
    [sym_tuple_literal] = STATE(2291),
    [sym_step_expr_or_stutter] = STATE(2291),
    [sym_step_expr_no_stutter] = STATE(2291),
    [sym_fairness] = STATE(2291),
    [sym_if_then_else] = STATE(2291),
    [sym_case] = STATE(2291),
    [sym_let_in] = STATE(2291),
    [sym_conj_list] = STATE(2291),
    [sym_disj_list] = STATE(2291),
    [sym_lnot] = STATE(267),
    [sym_negative] = STATE(544),
    [sym_always] = STATE(266),
    [sym_eventually] = STATE(266),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_bound_prefix_op] = STATE(2291),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_bound_infix_op] = STATE(2291),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_bound_postfix_op] = STATE(2291),
    [sym_proof_step_ref] = STATE(2227),
    [sym_identifier] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_BSLASHA] = ACTIONS(63),
    [anon_sym_BSLASHforall] = ACTIONS(65),
    [anon_sym_u2200] = ACTIONS(65),
    [anon_sym_BSLASHE] = ACTIONS(67),
    [anon_sym_BSLASHexists] = ACTIONS(69),
    [anon_sym_u2203] = ACTIONS(69),
    [sym_temporal_forall] = ACTIONS(1712),
    [sym_temporal_exists] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(75),
    [anon_sym_u25a1] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(1714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [aux_sym_child_id_token1] = ACTIONS(1720),
    [sym_real_number] = ACTIONS(1722),
    [anon_sym_BSLASHb] = ACTIONS(1724),
    [anon_sym_BSLASHB] = ACTIONS(1726),
    [anon_sym_BSLASHo] = ACTIONS(1728),
    [anon_sym_BSLASHO] = ACTIONS(1730),
    [anon_sym_BSLASHh] = ACTIONS(1732),
    [anon_sym_BSLASHH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_TRUE] = ACTIONS(1736),
    [anon_sym_FALSE] = ACTIONS(1736),
    [sym_string_set] = ACTIONS(1738),
    [sym_boolean_set] = ACTIONS(1738),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_CHOOSE] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_WF_] = ACTIONS(1756),
    [anon_sym_SF_] = ACTIONS(1756),
    [anon_sym_IF] = ACTIONS(1758),
    [anon_sym_CASE] = ACTIONS(1760),
    [anon_sym_LET] = ACTIONS(1762),
    [anon_sym_BSLASHlnot] = ACTIONS(135),
    [anon_sym_BSLASHneg] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(137),
    [anon_sym_u00ac] = ACTIONS(135),
    [sym_union] = ACTIONS(1764),
    [sym_powerset] = ACTIONS(1764),
    [sym_domain] = ACTIONS(1764),
    [anon_sym_DASH] = ACTIONS(141),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(1766),
    [sym_unchanged] = ACTIONS(1766),
    [anon_sym_LT_GT] = ACTIONS(145),
    [anon_sym_u22c4] = ACTIONS(145),
    [anon_sym_u25c7] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(1768),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__indent] = ACTIONS(1772),
    [sym__double_excl] = ACTIONS(277),
  },
  [1085] = {
    [sym_block_comment] = STATE(1085),
    [sym_langle_bracket] = STATE(3156),
    [sym_rangle_bracket] = STATE(3156),
    [sym_colon] = STATE(3156),
    [sym_address] = STATE(3156),
    [sym_bound_op] = STATE(3123),
    [sym_bound_nonfix_op] = STATE(3123),
    [sym_subexpr_tree_nav] = STATE(3165),
    [sym_child_id] = STATE(3156),
    [sym_operator_args] = STATE(3156),
    [sym__number_set] = STATE(3123),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5306),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5522),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5306),
    [sym_identifier] = ACTIONS(2134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2136),
    [anon_sym_u3008] = ACTIONS(2136),
    [anon_sym_u27e8] = ACTIONS(2136),
    [anon_sym_GT_GT] = ACTIONS(986),
    [anon_sym_u3009] = ACTIONS(986),
    [anon_sym_u27e9] = ACTIONS(986),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2138),
    [anon_sym_AT] = ACTIONS(2140),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [aux_sym_child_id_token1] = ACTIONS(2144),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1086] = {
    [sym_block_comment] = STATE(1086),
    [sym_langle_bracket] = STATE(2965),
    [sym_rangle_bracket] = STATE(2965),
    [sym_colon] = STATE(2965),
    [sym_address] = STATE(2965),
    [sym_bound_op] = STATE(2929),
    [sym_bound_nonfix_op] = STATE(2929),
    [sym_subexpr_tree_nav] = STATE(2966),
    [sym_child_id] = STATE(2965),
    [sym_operator_args] = STATE(2965),
    [sym__number_set] = STATE(2929),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5549),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5526),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5549),
    [sym_identifier] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2156),
    [anon_sym_u3008] = ACTIONS(2156),
    [anon_sym_u27e8] = ACTIONS(2156),
    [anon_sym_GT_GT] = ACTIONS(1419),
    [anon_sym_u3009] = ACTIONS(1419),
    [anon_sym_u27e9] = ACTIONS(1419),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2162),
    [aux_sym_child_id_token1] = ACTIONS(2164),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1087] = {
    [sym_block_comment] = STATE(1087),
    [sym_langle_bracket] = STATE(3404),
    [sym_rangle_bracket] = STATE(3404),
    [sym_colon] = STATE(3404),
    [sym_address] = STATE(3404),
    [sym_bound_op] = STATE(3405),
    [sym_bound_nonfix_op] = STATE(3405),
    [sym_subexpr_tree_nav] = STATE(3388),
    [sym_child_id] = STATE(3404),
    [sym_operator_args] = STATE(3404),
    [sym__number_set] = STATE(3405),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5342),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5528),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5342),
    [sym_identifier] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2168),
    [anon_sym_u3008] = ACTIONS(2168),
    [anon_sym_u27e8] = ACTIONS(2168),
    [anon_sym_GT_GT] = ACTIONS(1421),
    [anon_sym_u3009] = ACTIONS(1421),
    [anon_sym_u27e9] = ACTIONS(1421),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2170),
    [anon_sym_AT] = ACTIONS(2172),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [aux_sym_child_id_token1] = ACTIONS(2176),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1088] = {
    [sym_block_comment] = STATE(1088),
    [sym_langle_bracket] = STATE(3326),
    [sym_rangle_bracket] = STATE(3326),
    [sym_colon] = STATE(3326),
    [sym_address] = STATE(3326),
    [sym_bound_op] = STATE(3251),
    [sym_bound_nonfix_op] = STATE(3251),
    [sym_subexpr_tree_nav] = STATE(3337),
    [sym_child_id] = STATE(3326),
    [sym_operator_args] = STATE(3326),
    [sym__number_set] = STATE(3251),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5353),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5530),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5353),
    [sym_identifier] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2180),
    [anon_sym_u3008] = ACTIONS(2180),
    [anon_sym_u27e8] = ACTIONS(2180),
    [anon_sym_GT_GT] = ACTIONS(1423),
    [anon_sym_u3009] = ACTIONS(1423),
    [anon_sym_u27e9] = ACTIONS(1423),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2184),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [aux_sym_child_id_token1] = ACTIONS(2188),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1089] = {
    [sym_block_comment] = STATE(1089),
    [sym_langle_bracket] = STATE(2698),
    [sym_rangle_bracket] = STATE(2698),
    [sym_colon] = STATE(2698),
    [sym_address] = STATE(2698),
    [sym_bound_op] = STATE(2699),
    [sym_bound_nonfix_op] = STATE(2699),
    [sym_subexpr_tree_nav] = STATE(2722),
    [sym_child_id] = STATE(2698),
    [sym_operator_args] = STATE(2698),
    [sym__number_set] = STATE(2699),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5364),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5532),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5364),
    [sym_identifier] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2192),
    [anon_sym_u3008] = ACTIONS(2192),
    [anon_sym_u27e8] = ACTIONS(2192),
    [anon_sym_GT_GT] = ACTIONS(1425),
    [anon_sym_u3009] = ACTIONS(1425),
    [anon_sym_u27e9] = ACTIONS(1425),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_AT] = ACTIONS(2196),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2198),
    [aux_sym_child_id_token1] = ACTIONS(2200),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1090] = {
    [sym_block_comment] = STATE(1090),
    [sym_langle_bracket] = STATE(3174),
    [sym_rangle_bracket] = STATE(3174),
    [sym_colon] = STATE(3174),
    [sym_address] = STATE(3174),
    [sym_bound_op] = STATE(3175),
    [sym_bound_nonfix_op] = STATE(3175),
    [sym_subexpr_tree_nav] = STATE(3233),
    [sym_child_id] = STATE(3174),
    [sym_operator_args] = STATE(3174),
    [sym__number_set] = STATE(3175),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5534),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5375),
    [sym_identifier] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_u3008] = ACTIONS(2204),
    [anon_sym_u27e8] = ACTIONS(2204),
    [anon_sym_GT_GT] = ACTIONS(1427),
    [anon_sym_u3009] = ACTIONS(1427),
    [anon_sym_u27e9] = ACTIONS(1427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2206),
    [anon_sym_AT] = ACTIONS(2208),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2210),
    [aux_sym_child_id_token1] = ACTIONS(2212),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1091] = {
    [sym_block_comment] = STATE(1091),
    [sym_langle_bracket] = STATE(3079),
    [sym_rangle_bracket] = STATE(3079),
    [sym_colon] = STATE(3079),
    [sym_address] = STATE(3079),
    [sym_bound_op] = STATE(3074),
    [sym_bound_nonfix_op] = STATE(3074),
    [sym_subexpr_tree_nav] = STATE(3041),
    [sym_child_id] = STATE(3079),
    [sym_operator_args] = STATE(3079),
    [sym__number_set] = STATE(3074),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5386),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5536),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5386),
    [sym_identifier] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2216),
    [anon_sym_u3008] = ACTIONS(2216),
    [anon_sym_u27e8] = ACTIONS(2216),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_u3009] = ACTIONS(1429),
    [anon_sym_u27e9] = ACTIONS(1429),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2218),
    [anon_sym_AT] = ACTIONS(2220),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [aux_sym_child_id_token1] = ACTIONS(2224),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1092] = {
    [sym_block_comment] = STATE(1092),
    [sym_langle_bracket] = STATE(2401),
    [sym_rangle_bracket] = STATE(2401),
    [sym_colon] = STATE(2401),
    [sym_address] = STATE(2401),
    [sym_bound_op] = STATE(2402),
    [sym_bound_nonfix_op] = STATE(2402),
    [sym_subexpr_tree_nav] = STATE(2425),
    [sym_child_id] = STATE(2401),
    [sym_operator_args] = STATE(2401),
    [sym__number_set] = STATE(2402),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5397),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5538),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5397),
    [sym_identifier] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_u3008] = ACTIONS(2228),
    [anon_sym_u27e8] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(1431),
    [anon_sym_u3009] = ACTIONS(1431),
    [anon_sym_u27e9] = ACTIONS(1431),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2230),
    [anon_sym_AT] = ACTIONS(2232),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [aux_sym_child_id_token1] = ACTIONS(2236),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1093] = {
    [sym_block_comment] = STATE(1093),
    [sym_langle_bracket] = STATE(2334),
    [sym_rangle_bracket] = STATE(2334),
    [sym_colon] = STATE(2334),
    [sym_address] = STATE(2334),
    [sym_bound_op] = STATE(2335),
    [sym_bound_nonfix_op] = STATE(2335),
    [sym_subexpr_tree_nav] = STATE(2297),
    [sym_child_id] = STATE(2334),
    [sym_operator_args] = STATE(2334),
    [sym__number_set] = STATE(2335),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5408),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5540),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5408),
    [sym_identifier] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2240),
    [anon_sym_u3008] = ACTIONS(2240),
    [anon_sym_u27e8] = ACTIONS(2240),
    [anon_sym_GT_GT] = ACTIONS(1433),
    [anon_sym_u3009] = ACTIONS(1433),
    [anon_sym_u27e9] = ACTIONS(1433),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(2244),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [aux_sym_child_id_token1] = ACTIONS(2248),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1094] = {
    [sym_block_comment] = STATE(1094),
    [sym_langle_bracket] = STATE(3257),
    [sym_rangle_bracket] = STATE(3257),
    [sym_colon] = STATE(3257),
    [sym_address] = STATE(3257),
    [sym_bound_op] = STATE(3261),
    [sym_bound_nonfix_op] = STATE(3261),
    [sym_subexpr_tree_nav] = STATE(3271),
    [sym_child_id] = STATE(3257),
    [sym_operator_args] = STATE(3257),
    [sym__number_set] = STATE(3261),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5441),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5546),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5441),
    [sym_identifier] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2252),
    [anon_sym_u3008] = ACTIONS(2252),
    [anon_sym_u27e8] = ACTIONS(2252),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_u3009] = ACTIONS(1439),
    [anon_sym_u27e9] = ACTIONS(1439),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2254),
    [anon_sym_AT] = ACTIONS(2256),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2258),
    [aux_sym_child_id_token1] = ACTIONS(2260),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1095] = {
    [sym_block_comment] = STATE(1095),
    [sym_langle_bracket] = STATE(2538),
    [sym_rangle_bracket] = STATE(2538),
    [sym_colon] = STATE(2538),
    [sym_address] = STATE(2538),
    [sym_bound_op] = STATE(2658),
    [sym_bound_nonfix_op] = STATE(2658),
    [sym_subexpr_tree_nav] = STATE(2604),
    [sym_child_id] = STATE(2538),
    [sym_operator_args] = STATE(2538),
    [sym__number_set] = STATE(2658),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5419),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5542),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5419),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_u3008] = ACTIONS(2264),
    [anon_sym_u27e8] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_u3009] = ACTIONS(1435),
    [anon_sym_u27e9] = ACTIONS(1435),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2266),
    [anon_sym_AT] = ACTIONS(2268),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2270),
    [aux_sym_child_id_token1] = ACTIONS(2272),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1096] = {
    [sym_block_comment] = STATE(1096),
    [sym_langle_bracket] = STATE(2870),
    [sym_rangle_bracket] = STATE(2870),
    [sym_colon] = STATE(2870),
    [sym_address] = STATE(2870),
    [sym_bound_op] = STATE(2872),
    [sym_bound_nonfix_op] = STATE(2872),
    [sym_subexpr_tree_nav] = STATE(2892),
    [sym_child_id] = STATE(2870),
    [sym_operator_args] = STATE(2870),
    [sym__number_set] = STATE(2872),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5430),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5544),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5430),
    [sym_identifier] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2276),
    [anon_sym_u3008] = ACTIONS(2276),
    [anon_sym_u27e8] = ACTIONS(2276),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [anon_sym_u3009] = ACTIONS(1437),
    [anon_sym_u27e9] = ACTIONS(1437),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2278),
    [anon_sym_AT] = ACTIONS(2280),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2282),
    [aux_sym_child_id_token1] = ACTIONS(2284),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1097] = {
    [sym_block_comment] = STATE(1097),
    [sym_langle_bracket] = STATE(2337),
    [sym_rangle_bracket] = STATE(2337),
    [sym_colon] = STATE(2337),
    [sym_address] = STATE(2337),
    [sym_bound_op] = STATE(2338),
    [sym_bound_nonfix_op] = STATE(2338),
    [sym_subexpr_tree_nav] = STATE(2339),
    [sym_child_id] = STATE(2337),
    [sym_operator_args] = STATE(2337),
    [sym__number_set] = STATE(2338),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5246),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5515),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5246),
    [sym_identifier] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_u3008] = ACTIONS(2288),
    [anon_sym_u27e8] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(1217),
    [anon_sym_u3009] = ACTIONS(1217),
    [anon_sym_u27e9] = ACTIONS(1217),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2290),
    [anon_sym_AT] = ACTIONS(2292),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [aux_sym_child_id_token1] = ACTIONS(2296),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1098] = {
    [sym_block_comment] = STATE(1098),
    [sym_langle_bracket] = STATE(2497),
    [sym_rangle_bracket] = STATE(2497),
    [sym_colon] = STATE(2497),
    [sym_address] = STATE(2497),
    [sym_bound_op] = STATE(2498),
    [sym_bound_nonfix_op] = STATE(2498),
    [sym_subexpr_tree_nav] = STATE(2407),
    [sym_child_id] = STATE(2497),
    [sym_operator_args] = STATE(2497),
    [sym__number_set] = STATE(2498),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5398),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5399),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5398),
    [sym_identifier] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_u3008] = ACTIONS(2300),
    [anon_sym_u27e8] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(1143),
    [anon_sym_u3009] = ACTIONS(1143),
    [anon_sym_u27e9] = ACTIONS(1143),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2302),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2306),
    [aux_sym_child_id_token1] = ACTIONS(2308),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1099] = {
    [sym_block_comment] = STATE(1099),
    [sym_langle_bracket] = STATE(2786),
    [sym_rangle_bracket] = STATE(2786),
    [sym_colon] = STATE(2786),
    [sym_address] = STATE(2786),
    [sym_bound_op] = STATE(2787),
    [sym_bound_nonfix_op] = STATE(2787),
    [sym_subexpr_tree_nav] = STATE(2784),
    [sym_child_id] = STATE(2786),
    [sym_operator_args] = STATE(2786),
    [sym__number_set] = STATE(2787),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5449),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5548),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5449),
    [sym_identifier] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2312),
    [anon_sym_u3008] = ACTIONS(2312),
    [anon_sym_u27e8] = ACTIONS(2312),
    [anon_sym_GT_GT] = ACTIONS(1441),
    [anon_sym_u3009] = ACTIONS(1441),
    [anon_sym_u27e9] = ACTIONS(1441),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2314),
    [anon_sym_AT] = ACTIONS(2316),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [aux_sym_child_id_token1] = ACTIONS(2320),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1100] = {
    [sym_block_comment] = STATE(1100),
    [sym_langle_bracket] = STATE(2660),
    [sym_rangle_bracket] = STATE(2660),
    [sym_colon] = STATE(2660),
    [sym_address] = STATE(2660),
    [sym_bound_op] = STATE(2661),
    [sym_bound_nonfix_op] = STATE(2661),
    [sym_subexpr_tree_nav] = STATE(2664),
    [sym_child_id] = STATE(2660),
    [sym_operator_args] = STATE(2660),
    [sym__number_set] = STATE(2661),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5290),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5519),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5290),
    [sym_identifier] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_u3008] = ACTIONS(2324),
    [anon_sym_u27e8] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(1219),
    [anon_sym_u3009] = ACTIONS(1219),
    [anon_sym_u27e9] = ACTIONS(1219),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_COLON] = ACTIONS(2326),
    [anon_sym_AT] = ACTIONS(2328),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2330),
    [aux_sym_child_id_token1] = ACTIONS(2332),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1101] = {
    [sym_block_comment] = STATE(1101),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym__proof] = STATE(3574),
    [sym_terminal_proof] = STATE(3575),
    [sym_non_terminal_proof] = STATE(3575),
    [sym_identifier] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(2336),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(2336),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2336),
    [anon_sym_u25a1] = ACTIONS(2336),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(2334),
    [anon_sym_VARIABLE] = ACTIONS(2334),
    [anon_sym_VARIABLES] = ACTIONS(2334),
    [anon_sym_CONSTANT] = ACTIONS(2334),
    [anon_sym_CONSTANTS] = ACTIONS(2334),
    [anon_sym_RECURSIVE] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(2334),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(2334),
    [anon_sym_u2115] = ACTIONS(2336),
    [anon_sym_Int] = ACTIONS(2334),
    [anon_sym_u2124] = ACTIONS(2336),
    [anon_sym_Real] = ACTIONS(2334),
    [anon_sym_u211d] = ACTIONS(2336),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(2336),
    [anon_sym_BSLASHneg] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2334),
    [anon_sym_u00ac] = ACTIONS(2336),
    [sym_union] = ACTIONS(2334),
    [sym_powerset] = ACTIONS(2334),
    [sym_domain] = ACTIONS(2334),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(2336),
    [sym_enabled] = ACTIONS(2334),
    [sym_unchanged] = ACTIONS(2334),
    [anon_sym_LT_GT] = ACTIONS(2336),
    [anon_sym_u22c4] = ACTIONS(2336),
    [anon_sym_u25c7] = ACTIONS(2336),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(2334),
    [anon_sym_ASSUMPTION] = ACTIONS(2334),
    [anon_sym_AXIOM] = ACTIONS(2334),
    [anon_sym_THEOREM] = ACTIONS(2334),
    [anon_sym_PROPOSITION] = ACTIONS(2334),
    [anon_sym_LEMMA] = ACTIONS(2334),
    [anon_sym_COROLLARY] = ACTIONS(2334),
    [anon_sym_PROOF] = ACTIONS(2524),
    [anon_sym_BY] = ACTIONS(2526),
    [anon_sym_OBVIOUS] = ACTIONS(2528),
    [anon_sym_OMITTED] = ACTIONS(2528),
    [anon_sym_USE] = ACTIONS(2334),
    [anon_sym_HIDE] = ACTIONS(2334),
    [sym__begin_proof] = ACTIONS(2530),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1102] = {
    [sym_block_comment] = STATE(1102),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [sym__proof] = STATE(3574),
    [sym_terminal_proof] = STATE(3575),
    [sym_non_terminal_proof] = STATE(3575),
    [ts_builtin_sym_end] = ACTIONS(2336),
    [sym_identifier] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(2336),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2336),
    [anon_sym_u25a1] = ACTIONS(2336),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(2334),
    [anon_sym_VARIABLE] = ACTIONS(2334),
    [anon_sym_VARIABLES] = ACTIONS(2334),
    [anon_sym_CONSTANT] = ACTIONS(2334),
    [anon_sym_CONSTANTS] = ACTIONS(2334),
    [anon_sym_RECURSIVE] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(2334),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(2334),
    [anon_sym_u2115] = ACTIONS(2336),
    [anon_sym_Int] = ACTIONS(2334),
    [anon_sym_u2124] = ACTIONS(2336),
    [anon_sym_Real] = ACTIONS(2334),
    [anon_sym_u211d] = ACTIONS(2336),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(2336),
    [anon_sym_BSLASHneg] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2334),
    [anon_sym_u00ac] = ACTIONS(2336),
    [sym_union] = ACTIONS(2334),
    [sym_powerset] = ACTIONS(2334),
    [sym_domain] = ACTIONS(2334),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(2336),
    [sym_enabled] = ACTIONS(2334),
    [sym_unchanged] = ACTIONS(2334),
    [anon_sym_LT_GT] = ACTIONS(2336),
    [anon_sym_u22c4] = ACTIONS(2336),
    [anon_sym_u25c7] = ACTIONS(2336),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(2334),
    [anon_sym_ASSUMPTION] = ACTIONS(2334),
    [anon_sym_AXIOM] = ACTIONS(2334),
    [anon_sym_THEOREM] = ACTIONS(2334),
    [anon_sym_PROPOSITION] = ACTIONS(2334),
    [anon_sym_LEMMA] = ACTIONS(2334),
    [anon_sym_COROLLARY] = ACTIONS(2334),
    [anon_sym_PROOF] = ACTIONS(2562),
    [anon_sym_BY] = ACTIONS(2564),
    [anon_sym_OBVIOUS] = ACTIONS(2528),
    [anon_sym_OMITTED] = ACTIONS(2528),
    [anon_sym_USE] = ACTIONS(2334),
    [anon_sym_HIDE] = ACTIONS(2334),
    [sym__begin_proof] = ACTIONS(2566),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1103] = {
    [sym_block_comment] = STATE(1103),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [sym__proof] = STATE(3576),
    [sym_terminal_proof] = STATE(3575),
    [sym_non_terminal_proof] = STATE(3575),
    [ts_builtin_sym_end] = ACTIONS(2568),
    [sym_identifier] = ACTIONS(2570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(2568),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2568),
    [anon_sym_u25a1] = ACTIONS(2568),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(2570),
    [anon_sym_VARIABLE] = ACTIONS(2570),
    [anon_sym_VARIABLES] = ACTIONS(2570),
    [anon_sym_CONSTANT] = ACTIONS(2570),
    [anon_sym_CONSTANTS] = ACTIONS(2570),
    [anon_sym_RECURSIVE] = ACTIONS(2570),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(2570),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(2570),
    [anon_sym_u2115] = ACTIONS(2568),
    [anon_sym_Int] = ACTIONS(2570),
    [anon_sym_u2124] = ACTIONS(2568),
    [anon_sym_Real] = ACTIONS(2570),
    [anon_sym_u211d] = ACTIONS(2568),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(2568),
    [anon_sym_BSLASHneg] = ACTIONS(2568),
    [anon_sym_TILDE] = ACTIONS(2570),
    [anon_sym_u00ac] = ACTIONS(2568),
    [sym_union] = ACTIONS(2570),
    [sym_powerset] = ACTIONS(2570),
    [sym_domain] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(2568),
    [sym_enabled] = ACTIONS(2570),
    [sym_unchanged] = ACTIONS(2570),
    [anon_sym_LT_GT] = ACTIONS(2568),
    [anon_sym_u22c4] = ACTIONS(2568),
    [anon_sym_u25c7] = ACTIONS(2568),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(2570),
    [anon_sym_ASSUMPTION] = ACTIONS(2570),
    [anon_sym_AXIOM] = ACTIONS(2570),
    [anon_sym_THEOREM] = ACTIONS(2570),
    [anon_sym_PROPOSITION] = ACTIONS(2570),
    [anon_sym_LEMMA] = ACTIONS(2570),
    [anon_sym_COROLLARY] = ACTIONS(2570),
    [anon_sym_PROOF] = ACTIONS(2562),
    [anon_sym_BY] = ACTIONS(2564),
    [anon_sym_OBVIOUS] = ACTIONS(2528),
    [anon_sym_OMITTED] = ACTIONS(2528),
    [anon_sym_USE] = ACTIONS(2570),
    [anon_sym_HIDE] = ACTIONS(2570),
    [sym__begin_proof] = ACTIONS(2566),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1104] = {
    [sym_block_comment] = STATE(1104),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym__proof] = STATE(3576),
    [sym_terminal_proof] = STATE(3575),
    [sym_non_terminal_proof] = STATE(3575),
    [sym_identifier] = ACTIONS(2570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(2568),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(2568),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2568),
    [anon_sym_u25a1] = ACTIONS(2568),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(2570),
    [anon_sym_VARIABLE] = ACTIONS(2570),
    [anon_sym_VARIABLES] = ACTIONS(2570),
    [anon_sym_CONSTANT] = ACTIONS(2570),
    [anon_sym_CONSTANTS] = ACTIONS(2570),
    [anon_sym_RECURSIVE] = ACTIONS(2570),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(2570),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(2570),
    [anon_sym_u2115] = ACTIONS(2568),
    [anon_sym_Int] = ACTIONS(2570),
    [anon_sym_u2124] = ACTIONS(2568),
    [anon_sym_Real] = ACTIONS(2570),
    [anon_sym_u211d] = ACTIONS(2568),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(2568),
    [anon_sym_BSLASHneg] = ACTIONS(2568),
    [anon_sym_TILDE] = ACTIONS(2570),
    [anon_sym_u00ac] = ACTIONS(2568),
    [sym_union] = ACTIONS(2570),
    [sym_powerset] = ACTIONS(2570),
    [sym_domain] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(2568),
    [sym_enabled] = ACTIONS(2570),
    [sym_unchanged] = ACTIONS(2570),
    [anon_sym_LT_GT] = ACTIONS(2568),
    [anon_sym_u22c4] = ACTIONS(2568),
    [anon_sym_u25c7] = ACTIONS(2568),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(2570),
    [anon_sym_ASSUMPTION] = ACTIONS(2570),
    [anon_sym_AXIOM] = ACTIONS(2570),
    [anon_sym_THEOREM] = ACTIONS(2570),
    [anon_sym_PROPOSITION] = ACTIONS(2570),
    [anon_sym_LEMMA] = ACTIONS(2570),
    [anon_sym_COROLLARY] = ACTIONS(2570),
    [anon_sym_PROOF] = ACTIONS(2524),
    [anon_sym_BY] = ACTIONS(2526),
    [anon_sym_OBVIOUS] = ACTIONS(2528),
    [anon_sym_OMITTED] = ACTIONS(2528),
    [anon_sym_USE] = ACTIONS(2570),
    [anon_sym_HIDE] = ACTIONS(2570),
    [sym__begin_proof] = ACTIONS(2530),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1105] = {
    [sym_block_comment] = STATE(1105),
    [sym_langle_bracket] = STATE(5521),
    [sym_rangle_bracket] = STATE(5521),
    [sym_colon] = STATE(5521),
    [sym_address] = STATE(5521),
    [sym_subexpr_component] = STATE(5247),
    [sym_bound_op] = STATE(5276),
    [sym_bound_nonfix_op] = STATE(5276),
    [sym_subexpr_tree_nav] = STATE(5247),
    [sym_child_id] = STATE(5521),
    [sym_operator_args] = STATE(5521),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [aux_sym_subexpr_prefix_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2575),
    [anon_sym_u2208] = ACTIONS(2578),
    [anon_sym_LT_LT] = ACTIONS(2581),
    [anon_sym_u3008] = ACTIONS(2581),
    [anon_sym_u27e8] = ACTIONS(2581),
    [anon_sym_GT_GT] = ACTIONS(1417),
    [anon_sym_u3009] = ACTIONS(1417),
    [anon_sym_u27e9] = ACTIONS(1417),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2583),
    [anon_sym_u25a1] = ACTIONS(2583),
    [anon_sym_COLON] = ACTIONS(2586),
    [anon_sym_AT] = ACTIONS(2588),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2590),
    [anon_sym_u2227] = ACTIONS(2590),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2593),
    [anon_sym_u2228] = ACTIONS(2593),
    [anon_sym_LPAREN] = ACTIONS(2596),
    [aux_sym_child_id_token1] = ACTIONS(2598),
    [anon_sym_BSLASHo] = ACTIONS(2600),
    [anon_sym_Nat] = ACTIONS(2603),
    [anon_sym_u2115] = ACTIONS(2605),
    [anon_sym_Int] = ACTIONS(2603),
    [anon_sym_u2124] = ACTIONS(2605),
    [anon_sym_Real] = ACTIONS(2603),
    [anon_sym_u211d] = ACTIONS(2605),
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_BSLASHlnot] = ACTIONS(2610),
    [anon_sym_BSLASHneg] = ACTIONS(2610),
    [anon_sym_TILDE] = ACTIONS(2613),
    [anon_sym_u00ac] = ACTIONS(2610),
    [sym_union] = ACTIONS(2616),
    [sym_powerset] = ACTIONS(2616),
    [sym_domain] = ACTIONS(2616),
    [anon_sym_DASH] = ACTIONS(2619),
    [sym_negative_dot] = ACTIONS(2622),
    [sym_enabled] = ACTIONS(2616),
    [sym_unchanged] = ACTIONS(2616),
    [anon_sym_LT_GT] = ACTIONS(2625),
    [anon_sym_u22c4] = ACTIONS(2625),
    [anon_sym_u25c7] = ACTIONS(2625),
    [anon_sym_EQ_GT] = ACTIONS(2628),
    [anon_sym_u27f9] = ACTIONS(2628),
    [anon_sym_u21d2] = ACTIONS(2628),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2631),
    [anon_sym_u21f8] = ACTIONS(2631),
    [anon_sym_u2945] = ACTIONS(2631),
    [anon_sym_BSLASHequiv] = ACTIONS(2634),
    [anon_sym_u2261] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2637),
    [anon_sym_u27fa] = ACTIONS(2637),
    [anon_sym_u21d4] = ACTIONS(2637),
    [anon_sym_TILDE_GT] = ACTIONS(2640),
    [anon_sym_u21dd] = ACTIONS(2640),
    [anon_sym_u219d] = ACTIONS(2640),
    [anon_sym_BSLASHland] = ACTIONS(2590),
    [anon_sym_BSLASHlor] = ACTIONS(2593),
    [anon_sym_COLON_EQ] = ACTIONS(2643),
    [anon_sym_u2254] = ACTIONS(2643),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2646),
    [anon_sym_u2a74] = ACTIONS(2646),
    [anon_sym_SLASH_EQ] = ACTIONS(2649),
    [anon_sym_POUND] = ACTIONS(2652),
    [anon_sym_u2260] = ACTIONS(2649),
    [anon_sym_LT] = ACTIONS(2655),
    [sym_gt] = ACTIONS(2658),
    [anon_sym_LT_EQ] = ACTIONS(2661),
    [anon_sym_EQ_LT] = ACTIONS(2664),
    [anon_sym_BSLASHleq] = ACTIONS(2664),
    [anon_sym_u2264] = ACTIONS(2664),
    [anon_sym_GT_EQ] = ACTIONS(2667),
    [anon_sym_BSLASHgeq] = ACTIONS(2667),
    [anon_sym_u2265] = ACTIONS(2667),
    [anon_sym_BSLASHapprox] = ACTIONS(2670),
    [anon_sym_u2248] = ACTIONS(2670),
    [anon_sym_PIPE_DASH] = ACTIONS(2673),
    [anon_sym_u22a2] = ACTIONS(2673),
    [anon_sym_PIPE_EQ] = ACTIONS(2676),
    [anon_sym_u22a8] = ACTIONS(2676),
    [anon_sym_DASH_PIPE] = ACTIONS(2679),
    [anon_sym_u22a3] = ACTIONS(2679),
    [anon_sym_EQ_PIPE] = ACTIONS(2682),
    [anon_sym_u2ae4] = ACTIONS(2682),
    [anon_sym_BSLASHasymp] = ACTIONS(2685),
    [anon_sym_u224d] = ACTIONS(2685),
    [anon_sym_BSLASHcong] = ACTIONS(2688),
    [anon_sym_u2245] = ACTIONS(2688),
    [anon_sym_BSLASHdoteq] = ACTIONS(2691),
    [anon_sym_u2250] = ACTIONS(2691),
    [anon_sym_BSLASHgg] = ACTIONS(2694),
    [anon_sym_u226b] = ACTIONS(2694),
    [anon_sym_BSLASHll] = ACTIONS(2697),
    [anon_sym_u226a] = ACTIONS(2697),
    [anon_sym_BSLASHnotin] = ACTIONS(2700),
    [anon_sym_u2209] = ACTIONS(2700),
    [anon_sym_BSLASHprec] = ACTIONS(2703),
    [anon_sym_u227a] = ACTIONS(2706),
    [anon_sym_BSLASHsucc] = ACTIONS(2709),
    [anon_sym_u227b] = ACTIONS(2712),
    [anon_sym_BSLASHpreceq] = ACTIONS(2715),
    [anon_sym_u2aaf] = ACTIONS(2715),
    [anon_sym_BSLASHsucceq] = ACTIONS(2718),
    [anon_sym_u2ab0] = ACTIONS(2718),
    [anon_sym_BSLASHpropto] = ACTIONS(2721),
    [anon_sym_u221d] = ACTIONS(2721),
    [anon_sym_BSLASHsim] = ACTIONS(2724),
    [anon_sym_u223c] = ACTIONS(2727),
    [anon_sym_BSLASHsimeq] = ACTIONS(2730),
    [anon_sym_u2243] = ACTIONS(2730),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2733),
    [anon_sym_u228f] = ACTIONS(2736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2739),
    [anon_sym_u2290] = ACTIONS(2742),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2745),
    [anon_sym_u2291] = ACTIONS(2745),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2748),
    [anon_sym_u2292] = ACTIONS(2748),
    [anon_sym_BSLASHsubset] = ACTIONS(2751),
    [anon_sym_u2282] = ACTIONS(2754),
    [anon_sym_BSLASHsupset] = ACTIONS(2757),
    [anon_sym_u2283] = ACTIONS(2760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2763),
    [anon_sym_u2286] = ACTIONS(2763),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2766),
    [anon_sym_u2287] = ACTIONS(2766),
    [sym_compose] = ACTIONS(2769),
    [sym_map_to] = ACTIONS(2769),
    [sym_map_from] = ACTIONS(2769),
    [sym_setminus] = ACTIONS(2658),
    [anon_sym_BSLASHcap] = ACTIONS(2772),
    [anon_sym_BSLASHintersect] = ACTIONS(2772),
    [anon_sym_u2229] = ACTIONS(2772),
    [anon_sym_BSLASHcup] = ACTIONS(2775),
    [anon_sym_BSLASHunion] = ACTIONS(2775),
    [anon_sym_u222a] = ACTIONS(2775),
    [anon_sym_DOT_DOT] = ACTIONS(2778),
    [anon_sym_u2025] = ACTIONS(2781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2784),
    [anon_sym_u2026] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2787),
    [sym_plusplus] = ACTIONS(2769),
    [anon_sym_BSLASHoplus] = ACTIONS(2790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2790),
    [anon_sym_u2295] = ACTIONS(2790),
    [anon_sym_BSLASHominus] = ACTIONS(2793),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2793),
    [anon_sym_u2296] = ACTIONS(2793),
    [sym_mod] = ACTIONS(2658),
    [sym_modmod] = ACTIONS(2769),
    [sym_vert] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2796),
    [anon_sym_u2016] = ACTIONS(2796),
    [sym_minusminus] = ACTIONS(2769),
    [sym_amp] = ACTIONS(2658),
    [sym_ampamp] = ACTIONS(2769),
    [anon_sym_BSLASHodot] = ACTIONS(2799),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2799),
    [anon_sym_u2299] = ACTIONS(2799),
    [anon_sym_BSLASHoslash] = ACTIONS(2802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2802),
    [anon_sym_u2298] = ACTIONS(2802),
    [anon_sym_BSLASHotimes] = ACTIONS(2805),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2805),
    [anon_sym_u2297] = ACTIONS(2805),
    [sym_mul] = ACTIONS(2658),
    [sym_mulmul] = ACTIONS(2769),
    [sym_slash] = ACTIONS(2658),
    [sym_slashslash] = ACTIONS(2769),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2808),
    [anon_sym_u25ef] = ACTIONS(2808),
    [anon_sym_BSLASHbullet] = ACTIONS(2811),
    [anon_sym_u25cf] = ACTIONS(2811),
    [anon_sym_BSLASHdiv] = ACTIONS(2814),
    [anon_sym_u00f7] = ACTIONS(2814),
    [anon_sym_BSLASHcirc] = ACTIONS(2817),
    [anon_sym_u2218] = ACTIONS(2817),
    [anon_sym_BSLASHstar] = ACTIONS(2820),
    [anon_sym_u22c6] = ACTIONS(2820),
    [anon_sym_u203c] = ACTIONS(2823),
    [sym_hashhash] = ACTIONS(2769),
    [sym_dol] = ACTIONS(2658),
    [sym_doldol] = ACTIONS(2769),
    [anon_sym_QMARK_QMARK] = ACTIONS(2826),
    [anon_sym_u2047] = ACTIONS(2826),
    [anon_sym_BSLASHsqcap] = ACTIONS(2829),
    [anon_sym_u2293] = ACTIONS(2829),
    [anon_sym_BSLASHsqcup] = ACTIONS(2832),
    [anon_sym_u2294] = ACTIONS(2832),
    [anon_sym_BSLASHuplus] = ACTIONS(2835),
    [anon_sym_u228e] = ACTIONS(2835),
    [anon_sym_BSLASHX] = ACTIONS(2838),
    [anon_sym_BSLASHtimes] = ACTIONS(2838),
    [anon_sym_u00d7] = ACTIONS(2838),
    [anon_sym_BSLASHwr] = ACTIONS(2841),
    [anon_sym_u2240] = ACTIONS(2841),
    [anon_sym_BSLASHcdot] = ACTIONS(2844),
    [anon_sym_u22c5] = ACTIONS(2844),
    [sym_pow] = ACTIONS(2658),
    [sym_powpow] = ACTIONS(2769),
    [anon_sym_CARET_PLUS] = ACTIONS(2847),
    [anon_sym_u207a] = ACTIONS(2847),
    [sym_asterisk] = ACTIONS(2850),
    [sym_sup_hash] = ACTIONS(2850),
    [sym_prime] = ACTIONS(2850),
    [sym__double_excl] = ACTIONS(2823),
  },
  [1106] = {
    [sym_block_comment] = STATE(1106),
    [sym_langle_bracket] = STATE(5521),
    [sym_rangle_bracket] = STATE(5521),
    [sym_colon] = STATE(5521),
    [sym_address] = STATE(5521),
    [sym_subexpr_component] = STATE(5247),
    [sym_bound_op] = STATE(5276),
    [sym_bound_nonfix_op] = STATE(5276),
    [sym_subexpr_tree_nav] = STATE(5247),
    [sym_child_id] = STATE(5521),
    [sym_operator_args] = STATE(5521),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [aux_sym_subexpr_prefix_repeat1] = STATE(1106),
    [sym_identifier] = ACTIONS(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2856),
    [anon_sym_u2208] = ACTIONS(2859),
    [anon_sym_LT_LT] = ACTIONS(2862),
    [anon_sym_u3008] = ACTIONS(2862),
    [anon_sym_u27e8] = ACTIONS(2862),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_u3009] = ACTIONS(2865),
    [anon_sym_u27e9] = ACTIONS(2865),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2868),
    [anon_sym_u25a1] = ACTIONS(2868),
    [anon_sym_COLON] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2874),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2877),
    [anon_sym_u2227] = ACTIONS(2877),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2880),
    [anon_sym_u2228] = ACTIONS(2880),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [aux_sym_child_id_token1] = ACTIONS(2886),
    [anon_sym_BSLASHo] = ACTIONS(2889),
    [anon_sym_Nat] = ACTIONS(2892),
    [anon_sym_u2115] = ACTIONS(2894),
    [anon_sym_Int] = ACTIONS(2892),
    [anon_sym_u2124] = ACTIONS(2894),
    [anon_sym_Real] = ACTIONS(2892),
    [anon_sym_u211d] = ACTIONS(2894),
    [anon_sym_EQ] = ACTIONS(2896),
    [anon_sym_BSLASHlnot] = ACTIONS(2899),
    [anon_sym_BSLASHneg] = ACTIONS(2899),
    [anon_sym_TILDE] = ACTIONS(2902),
    [anon_sym_u00ac] = ACTIONS(2899),
    [sym_union] = ACTIONS(2905),
    [sym_powerset] = ACTIONS(2905),
    [sym_domain] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2908),
    [sym_negative_dot] = ACTIONS(2911),
    [sym_enabled] = ACTIONS(2905),
    [sym_unchanged] = ACTIONS(2905),
    [anon_sym_LT_GT] = ACTIONS(2914),
    [anon_sym_u22c4] = ACTIONS(2914),
    [anon_sym_u25c7] = ACTIONS(2914),
    [anon_sym_EQ_GT] = ACTIONS(2917),
    [anon_sym_u27f9] = ACTIONS(2917),
    [anon_sym_u21d2] = ACTIONS(2917),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2920),
    [anon_sym_u21f8] = ACTIONS(2920),
    [anon_sym_u2945] = ACTIONS(2920),
    [anon_sym_BSLASHequiv] = ACTIONS(2923),
    [anon_sym_u2261] = ACTIONS(2923),
    [anon_sym_LT_EQ_GT] = ACTIONS(2926),
    [anon_sym_u27fa] = ACTIONS(2926),
    [anon_sym_u21d4] = ACTIONS(2926),
    [anon_sym_TILDE_GT] = ACTIONS(2929),
    [anon_sym_u21dd] = ACTIONS(2929),
    [anon_sym_u219d] = ACTIONS(2929),
    [anon_sym_BSLASHland] = ACTIONS(2877),
    [anon_sym_BSLASHlor] = ACTIONS(2880),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_u2254] = ACTIONS(2932),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2935),
    [anon_sym_u2a74] = ACTIONS(2935),
    [anon_sym_SLASH_EQ] = ACTIONS(2938),
    [anon_sym_POUND] = ACTIONS(2941),
    [anon_sym_u2260] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2944),
    [sym_gt] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2950),
    [anon_sym_EQ_LT] = ACTIONS(2953),
    [anon_sym_BSLASHleq] = ACTIONS(2953),
    [anon_sym_u2264] = ACTIONS(2953),
    [anon_sym_GT_EQ] = ACTIONS(2956),
    [anon_sym_BSLASHgeq] = ACTIONS(2956),
    [anon_sym_u2265] = ACTIONS(2956),
    [anon_sym_BSLASHapprox] = ACTIONS(2959),
    [anon_sym_u2248] = ACTIONS(2959),
    [anon_sym_PIPE_DASH] = ACTIONS(2962),
    [anon_sym_u22a2] = ACTIONS(2962),
    [anon_sym_PIPE_EQ] = ACTIONS(2965),
    [anon_sym_u22a8] = ACTIONS(2965),
    [anon_sym_DASH_PIPE] = ACTIONS(2968),
    [anon_sym_u22a3] = ACTIONS(2968),
    [anon_sym_EQ_PIPE] = ACTIONS(2971),
    [anon_sym_u2ae4] = ACTIONS(2971),
    [anon_sym_BSLASHasymp] = ACTIONS(2974),
    [anon_sym_u224d] = ACTIONS(2974),
    [anon_sym_BSLASHcong] = ACTIONS(2977),
    [anon_sym_u2245] = ACTIONS(2977),
    [anon_sym_BSLASHdoteq] = ACTIONS(2980),
    [anon_sym_u2250] = ACTIONS(2980),
    [anon_sym_BSLASHgg] = ACTIONS(2983),
    [anon_sym_u226b] = ACTIONS(2983),
    [anon_sym_BSLASHll] = ACTIONS(2986),
    [anon_sym_u226a] = ACTIONS(2986),
    [anon_sym_BSLASHnotin] = ACTIONS(2989),
    [anon_sym_u2209] = ACTIONS(2989),
    [anon_sym_BSLASHprec] = ACTIONS(2992),
    [anon_sym_u227a] = ACTIONS(2995),
    [anon_sym_BSLASHsucc] = ACTIONS(2998),
    [anon_sym_u227b] = ACTIONS(3001),
    [anon_sym_BSLASHpreceq] = ACTIONS(3004),
    [anon_sym_u2aaf] = ACTIONS(3004),
    [anon_sym_BSLASHsucceq] = ACTIONS(3007),
    [anon_sym_u2ab0] = ACTIONS(3007),
    [anon_sym_BSLASHpropto] = ACTIONS(3010),
    [anon_sym_u221d] = ACTIONS(3010),
    [anon_sym_BSLASHsim] = ACTIONS(3013),
    [anon_sym_u223c] = ACTIONS(3016),
    [anon_sym_BSLASHsimeq] = ACTIONS(3019),
    [anon_sym_u2243] = ACTIONS(3019),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3022),
    [anon_sym_u228f] = ACTIONS(3025),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3028),
    [anon_sym_u2290] = ACTIONS(3031),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3034),
    [anon_sym_u2291] = ACTIONS(3034),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3037),
    [anon_sym_u2292] = ACTIONS(3037),
    [anon_sym_BSLASHsubset] = ACTIONS(3040),
    [anon_sym_u2282] = ACTIONS(3043),
    [anon_sym_BSLASHsupset] = ACTIONS(3046),
    [anon_sym_u2283] = ACTIONS(3049),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3052),
    [anon_sym_u2286] = ACTIONS(3052),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3055),
    [anon_sym_u2287] = ACTIONS(3055),
    [sym_compose] = ACTIONS(3058),
    [sym_map_to] = ACTIONS(3058),
    [sym_map_from] = ACTIONS(3058),
    [sym_setminus] = ACTIONS(2947),
    [anon_sym_BSLASHcap] = ACTIONS(3061),
    [anon_sym_BSLASHintersect] = ACTIONS(3061),
    [anon_sym_u2229] = ACTIONS(3061),
    [anon_sym_BSLASHcup] = ACTIONS(3064),
    [anon_sym_BSLASHunion] = ACTIONS(3064),
    [anon_sym_u222a] = ACTIONS(3064),
    [anon_sym_DOT_DOT] = ACTIONS(3067),
    [anon_sym_u2025] = ACTIONS(3070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_u2026] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(3076),
    [sym_plusplus] = ACTIONS(3058),
    [anon_sym_BSLASHoplus] = ACTIONS(3079),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3079),
    [anon_sym_u2295] = ACTIONS(3079),
    [anon_sym_BSLASHominus] = ACTIONS(3082),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3082),
    [anon_sym_u2296] = ACTIONS(3082),
    [sym_mod] = ACTIONS(2947),
    [sym_modmod] = ACTIONS(3058),
    [sym_vert] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_u2016] = ACTIONS(3085),
    [sym_minusminus] = ACTIONS(3058),
    [sym_amp] = ACTIONS(2947),
    [sym_ampamp] = ACTIONS(3058),
    [anon_sym_BSLASHodot] = ACTIONS(3088),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3088),
    [anon_sym_u2299] = ACTIONS(3088),
    [anon_sym_BSLASHoslash] = ACTIONS(3091),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3091),
    [anon_sym_u2298] = ACTIONS(3091),
    [anon_sym_BSLASHotimes] = ACTIONS(3094),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3094),
    [anon_sym_u2297] = ACTIONS(3094),
    [sym_mul] = ACTIONS(2947),
    [sym_mulmul] = ACTIONS(3058),
    [sym_slash] = ACTIONS(2947),
    [sym_slashslash] = ACTIONS(3058),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3097),
    [anon_sym_u25ef] = ACTIONS(3097),
    [anon_sym_BSLASHbullet] = ACTIONS(3100),
    [anon_sym_u25cf] = ACTIONS(3100),
    [anon_sym_BSLASHdiv] = ACTIONS(3103),
    [anon_sym_u00f7] = ACTIONS(3103),
    [anon_sym_BSLASHcirc] = ACTIONS(3106),
    [anon_sym_u2218] = ACTIONS(3106),
    [anon_sym_BSLASHstar] = ACTIONS(3109),
    [anon_sym_u22c6] = ACTIONS(3109),
    [anon_sym_u203c] = ACTIONS(3112),
    [sym_hashhash] = ACTIONS(3058),
    [sym_dol] = ACTIONS(2947),
    [sym_doldol] = ACTIONS(3058),
    [anon_sym_QMARK_QMARK] = ACTIONS(3115),
    [anon_sym_u2047] = ACTIONS(3115),
    [anon_sym_BSLASHsqcap] = ACTIONS(3118),
    [anon_sym_u2293] = ACTIONS(3118),
    [anon_sym_BSLASHsqcup] = ACTIONS(3121),
    [anon_sym_u2294] = ACTIONS(3121),
    [anon_sym_BSLASHuplus] = ACTIONS(3124),
    [anon_sym_u228e] = ACTIONS(3124),
    [anon_sym_BSLASHX] = ACTIONS(3127),
    [anon_sym_BSLASHtimes] = ACTIONS(3127),
    [anon_sym_u00d7] = ACTIONS(3127),
    [anon_sym_BSLASHwr] = ACTIONS(3130),
    [anon_sym_u2240] = ACTIONS(3130),
    [anon_sym_BSLASHcdot] = ACTIONS(3133),
    [anon_sym_u22c5] = ACTIONS(3133),
    [sym_pow] = ACTIONS(2947),
    [sym_powpow] = ACTIONS(3058),
    [anon_sym_CARET_PLUS] = ACTIONS(3136),
    [anon_sym_u207a] = ACTIONS(3136),
    [sym_asterisk] = ACTIONS(3139),
    [sym_sup_hash] = ACTIONS(3139),
    [sym_prime] = ACTIONS(3139),
    [sym__double_excl] = ACTIONS(3112),
  },
  [1107] = {
    [sym_block_comment] = STATE(1107),
    [sym_langle_bracket] = STATE(5521),
    [sym_rangle_bracket] = STATE(5521),
    [sym_colon] = STATE(5521),
    [sym_address] = STATE(5521),
    [sym_subexpr_component] = STATE(5247),
    [sym_bound_op] = STATE(5276),
    [sym_bound_nonfix_op] = STATE(5276),
    [sym_subexpr_tree_nav] = STATE(5247),
    [sym_child_id] = STATE(5521),
    [sym_operator_args] = STATE(5521),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [aux_sym_subexpr_prefix_repeat1] = STATE(1106),
    [sym_identifier] = ACTIONS(3142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3145),
    [anon_sym_u2208] = ACTIONS(3148),
    [anon_sym_LT_LT] = ACTIONS(3151),
    [anon_sym_u3008] = ACTIONS(3151),
    [anon_sym_u27e8] = ACTIONS(3151),
    [anon_sym_GT_GT] = ACTIONS(3154),
    [anon_sym_u3009] = ACTIONS(3154),
    [anon_sym_u27e9] = ACTIONS(3154),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3157),
    [anon_sym_u25a1] = ACTIONS(3157),
    [anon_sym_COLON] = ACTIONS(3160),
    [anon_sym_AT] = ACTIONS(3163),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3166),
    [anon_sym_u2227] = ACTIONS(3166),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3169),
    [anon_sym_u2228] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3172),
    [aux_sym_child_id_token1] = ACTIONS(3175),
    [anon_sym_BSLASHo] = ACTIONS(3178),
    [anon_sym_Nat] = ACTIONS(3181),
    [anon_sym_u2115] = ACTIONS(3183),
    [anon_sym_Int] = ACTIONS(3181),
    [anon_sym_u2124] = ACTIONS(3183),
    [anon_sym_Real] = ACTIONS(3181),
    [anon_sym_u211d] = ACTIONS(3183),
    [anon_sym_EQ] = ACTIONS(3185),
    [anon_sym_BSLASHlnot] = ACTIONS(3188),
    [anon_sym_BSLASHneg] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_u00ac] = ACTIONS(3188),
    [sym_union] = ACTIONS(3194),
    [sym_powerset] = ACTIONS(3194),
    [sym_domain] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3197),
    [sym_negative_dot] = ACTIONS(3200),
    [sym_enabled] = ACTIONS(3194),
    [sym_unchanged] = ACTIONS(3194),
    [anon_sym_LT_GT] = ACTIONS(3203),
    [anon_sym_u22c4] = ACTIONS(3203),
    [anon_sym_u25c7] = ACTIONS(3203),
    [anon_sym_EQ_GT] = ACTIONS(3206),
    [anon_sym_u27f9] = ACTIONS(3206),
    [anon_sym_u21d2] = ACTIONS(3206),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3209),
    [anon_sym_u21f8] = ACTIONS(3209),
    [anon_sym_u2945] = ACTIONS(3209),
    [anon_sym_BSLASHequiv] = ACTIONS(3212),
    [anon_sym_u2261] = ACTIONS(3212),
    [anon_sym_LT_EQ_GT] = ACTIONS(3215),
    [anon_sym_u27fa] = ACTIONS(3215),
    [anon_sym_u21d4] = ACTIONS(3215),
    [anon_sym_TILDE_GT] = ACTIONS(3218),
    [anon_sym_u21dd] = ACTIONS(3218),
    [anon_sym_u219d] = ACTIONS(3218),
    [anon_sym_BSLASHland] = ACTIONS(3166),
    [anon_sym_BSLASHlor] = ACTIONS(3169),
    [anon_sym_COLON_EQ] = ACTIONS(3221),
    [anon_sym_u2254] = ACTIONS(3221),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3224),
    [anon_sym_u2a74] = ACTIONS(3224),
    [anon_sym_SLASH_EQ] = ACTIONS(3227),
    [anon_sym_POUND] = ACTIONS(3230),
    [anon_sym_u2260] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(3233),
    [sym_gt] = ACTIONS(3236),
    [anon_sym_LT_EQ] = ACTIONS(3239),
    [anon_sym_EQ_LT] = ACTIONS(3242),
    [anon_sym_BSLASHleq] = ACTIONS(3242),
    [anon_sym_u2264] = ACTIONS(3242),
    [anon_sym_GT_EQ] = ACTIONS(3245),
    [anon_sym_BSLASHgeq] = ACTIONS(3245),
    [anon_sym_u2265] = ACTIONS(3245),
    [anon_sym_BSLASHapprox] = ACTIONS(3248),
    [anon_sym_u2248] = ACTIONS(3248),
    [anon_sym_PIPE_DASH] = ACTIONS(3251),
    [anon_sym_u22a2] = ACTIONS(3251),
    [anon_sym_PIPE_EQ] = ACTIONS(3254),
    [anon_sym_u22a8] = ACTIONS(3254),
    [anon_sym_DASH_PIPE] = ACTIONS(3257),
    [anon_sym_u22a3] = ACTIONS(3257),
    [anon_sym_EQ_PIPE] = ACTIONS(3260),
    [anon_sym_u2ae4] = ACTIONS(3260),
    [anon_sym_BSLASHasymp] = ACTIONS(3263),
    [anon_sym_u224d] = ACTIONS(3263),
    [anon_sym_BSLASHcong] = ACTIONS(3266),
    [anon_sym_u2245] = ACTIONS(3266),
    [anon_sym_BSLASHdoteq] = ACTIONS(3269),
    [anon_sym_u2250] = ACTIONS(3269),
    [anon_sym_BSLASHgg] = ACTIONS(3272),
    [anon_sym_u226b] = ACTIONS(3272),
    [anon_sym_BSLASHll] = ACTIONS(3275),
    [anon_sym_u226a] = ACTIONS(3275),
    [anon_sym_BSLASHnotin] = ACTIONS(3278),
    [anon_sym_u2209] = ACTIONS(3278),
    [anon_sym_BSLASHprec] = ACTIONS(3281),
    [anon_sym_u227a] = ACTIONS(3284),
    [anon_sym_BSLASHsucc] = ACTIONS(3287),
    [anon_sym_u227b] = ACTIONS(3290),
    [anon_sym_BSLASHpreceq] = ACTIONS(3293),
    [anon_sym_u2aaf] = ACTIONS(3293),
    [anon_sym_BSLASHsucceq] = ACTIONS(3296),
    [anon_sym_u2ab0] = ACTIONS(3296),
    [anon_sym_BSLASHpropto] = ACTIONS(3299),
    [anon_sym_u221d] = ACTIONS(3299),
    [anon_sym_BSLASHsim] = ACTIONS(3302),
    [anon_sym_u223c] = ACTIONS(3305),
    [anon_sym_BSLASHsimeq] = ACTIONS(3308),
    [anon_sym_u2243] = ACTIONS(3308),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3311),
    [anon_sym_u228f] = ACTIONS(3314),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3317),
    [anon_sym_u2290] = ACTIONS(3320),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3323),
    [anon_sym_u2291] = ACTIONS(3323),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3326),
    [anon_sym_u2292] = ACTIONS(3326),
    [anon_sym_BSLASHsubset] = ACTIONS(3329),
    [anon_sym_u2282] = ACTIONS(3332),
    [anon_sym_BSLASHsupset] = ACTIONS(3335),
    [anon_sym_u2283] = ACTIONS(3338),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3341),
    [anon_sym_u2286] = ACTIONS(3341),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3344),
    [anon_sym_u2287] = ACTIONS(3344),
    [sym_compose] = ACTIONS(3347),
    [sym_map_to] = ACTIONS(3347),
    [sym_map_from] = ACTIONS(3347),
    [sym_setminus] = ACTIONS(3236),
    [anon_sym_BSLASHcap] = ACTIONS(3350),
    [anon_sym_BSLASHintersect] = ACTIONS(3350),
    [anon_sym_u2229] = ACTIONS(3350),
    [anon_sym_BSLASHcup] = ACTIONS(3353),
    [anon_sym_BSLASHunion] = ACTIONS(3353),
    [anon_sym_u222a] = ACTIONS(3353),
    [anon_sym_DOT_DOT] = ACTIONS(3356),
    [anon_sym_u2025] = ACTIONS(3359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3362),
    [anon_sym_u2026] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3365),
    [sym_plusplus] = ACTIONS(3347),
    [anon_sym_BSLASHoplus] = ACTIONS(3368),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3368),
    [anon_sym_u2295] = ACTIONS(3368),
    [anon_sym_BSLASHominus] = ACTIONS(3371),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3371),
    [anon_sym_u2296] = ACTIONS(3371),
    [sym_mod] = ACTIONS(3236),
    [sym_modmod] = ACTIONS(3347),
    [sym_vert] = ACTIONS(3236),
    [anon_sym_PIPE_PIPE] = ACTIONS(3374),
    [anon_sym_u2016] = ACTIONS(3374),
    [sym_minusminus] = ACTIONS(3347),
    [sym_amp] = ACTIONS(3236),
    [sym_ampamp] = ACTIONS(3347),
    [anon_sym_BSLASHodot] = ACTIONS(3377),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3377),
    [anon_sym_u2299] = ACTIONS(3377),
    [anon_sym_BSLASHoslash] = ACTIONS(3380),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3380),
    [anon_sym_u2298] = ACTIONS(3380),
    [anon_sym_BSLASHotimes] = ACTIONS(3383),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3383),
    [anon_sym_u2297] = ACTIONS(3383),
    [sym_mul] = ACTIONS(3236),
    [sym_mulmul] = ACTIONS(3347),
    [sym_slash] = ACTIONS(3236),
    [sym_slashslash] = ACTIONS(3347),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3386),
    [anon_sym_u25ef] = ACTIONS(3386),
    [anon_sym_BSLASHbullet] = ACTIONS(3389),
    [anon_sym_u25cf] = ACTIONS(3389),
    [anon_sym_BSLASHdiv] = ACTIONS(3392),
    [anon_sym_u00f7] = ACTIONS(3392),
    [anon_sym_BSLASHcirc] = ACTIONS(3395),
    [anon_sym_u2218] = ACTIONS(3395),
    [anon_sym_BSLASHstar] = ACTIONS(3398),
    [anon_sym_u22c6] = ACTIONS(3398),
    [anon_sym_u203c] = ACTIONS(3401),
    [sym_hashhash] = ACTIONS(3347),
    [sym_dol] = ACTIONS(3236),
    [sym_doldol] = ACTIONS(3347),
    [anon_sym_QMARK_QMARK] = ACTIONS(3404),
    [anon_sym_u2047] = ACTIONS(3404),
    [anon_sym_BSLASHsqcap] = ACTIONS(3407),
    [anon_sym_u2293] = ACTIONS(3407),
    [anon_sym_BSLASHsqcup] = ACTIONS(3410),
    [anon_sym_u2294] = ACTIONS(3410),
    [anon_sym_BSLASHuplus] = ACTIONS(3413),
    [anon_sym_u228e] = ACTIONS(3413),
    [anon_sym_BSLASHX] = ACTIONS(3416),
    [anon_sym_BSLASHtimes] = ACTIONS(3416),
    [anon_sym_u00d7] = ACTIONS(3416),
    [anon_sym_BSLASHwr] = ACTIONS(3419),
    [anon_sym_u2240] = ACTIONS(3419),
    [anon_sym_BSLASHcdot] = ACTIONS(3422),
    [anon_sym_u22c5] = ACTIONS(3422),
    [sym_pow] = ACTIONS(3236),
    [sym_powpow] = ACTIONS(3347),
    [anon_sym_CARET_PLUS] = ACTIONS(3425),
    [anon_sym_u207a] = ACTIONS(3425),
    [sym_asterisk] = ACTIONS(3428),
    [sym_sup_hash] = ACTIONS(3428),
    [sym_prime] = ACTIONS(3428),
    [sym__double_excl] = ACTIONS(3401),
  },
  [1108] = {
    [sym_block_comment] = STATE(1108),
    [sym_langle_bracket] = STATE(5521),
    [sym_rangle_bracket] = STATE(5521),
    [sym_colon] = STATE(5521),
    [sym_address] = STATE(5521),
    [sym_subexpr_component] = STATE(5247),
    [sym_bound_op] = STATE(5276),
    [sym_bound_nonfix_op] = STATE(5276),
    [sym_subexpr_tree_nav] = STATE(5247),
    [sym_child_id] = STATE(5521),
    [sym_operator_args] = STATE(5521),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [aux_sym_subexpr_prefix_repeat1] = STATE(1106),
    [sym_identifier] = ACTIONS(3142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3145),
    [anon_sym_u2208] = ACTIONS(3148),
    [anon_sym_LT_LT] = ACTIONS(2581),
    [anon_sym_u3008] = ACTIONS(2581),
    [anon_sym_u27e8] = ACTIONS(2581),
    [anon_sym_GT_GT] = ACTIONS(1417),
    [anon_sym_u3009] = ACTIONS(1417),
    [anon_sym_u27e9] = ACTIONS(1417),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3157),
    [anon_sym_u25a1] = ACTIONS(3157),
    [anon_sym_COLON] = ACTIONS(2586),
    [anon_sym_AT] = ACTIONS(2588),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3166),
    [anon_sym_u2227] = ACTIONS(3166),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3169),
    [anon_sym_u2228] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(2596),
    [aux_sym_child_id_token1] = ACTIONS(2598),
    [anon_sym_BSLASHo] = ACTIONS(3178),
    [anon_sym_Nat] = ACTIONS(3181),
    [anon_sym_u2115] = ACTIONS(3183),
    [anon_sym_Int] = ACTIONS(3181),
    [anon_sym_u2124] = ACTIONS(3183),
    [anon_sym_Real] = ACTIONS(3181),
    [anon_sym_u211d] = ACTIONS(3183),
    [anon_sym_EQ] = ACTIONS(3185),
    [anon_sym_BSLASHlnot] = ACTIONS(3188),
    [anon_sym_BSLASHneg] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_u00ac] = ACTIONS(3188),
    [sym_union] = ACTIONS(3194),
    [sym_powerset] = ACTIONS(3194),
    [sym_domain] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3197),
    [sym_negative_dot] = ACTIONS(3200),
    [sym_enabled] = ACTIONS(3194),
    [sym_unchanged] = ACTIONS(3194),
    [anon_sym_LT_GT] = ACTIONS(3203),
    [anon_sym_u22c4] = ACTIONS(3203),
    [anon_sym_u25c7] = ACTIONS(3203),
    [anon_sym_EQ_GT] = ACTIONS(3206),
    [anon_sym_u27f9] = ACTIONS(3206),
    [anon_sym_u21d2] = ACTIONS(3206),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3209),
    [anon_sym_u21f8] = ACTIONS(3209),
    [anon_sym_u2945] = ACTIONS(3209),
    [anon_sym_BSLASHequiv] = ACTIONS(3212),
    [anon_sym_u2261] = ACTIONS(3212),
    [anon_sym_LT_EQ_GT] = ACTIONS(3215),
    [anon_sym_u27fa] = ACTIONS(3215),
    [anon_sym_u21d4] = ACTIONS(3215),
    [anon_sym_TILDE_GT] = ACTIONS(3218),
    [anon_sym_u21dd] = ACTIONS(3218),
    [anon_sym_u219d] = ACTIONS(3218),
    [anon_sym_BSLASHland] = ACTIONS(3166),
    [anon_sym_BSLASHlor] = ACTIONS(3169),
    [anon_sym_COLON_EQ] = ACTIONS(3221),
    [anon_sym_u2254] = ACTIONS(3221),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3224),
    [anon_sym_u2a74] = ACTIONS(3224),
    [anon_sym_SLASH_EQ] = ACTIONS(3227),
    [anon_sym_POUND] = ACTIONS(3230),
    [anon_sym_u2260] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(3233),
    [sym_gt] = ACTIONS(3236),
    [anon_sym_LT_EQ] = ACTIONS(3239),
    [anon_sym_EQ_LT] = ACTIONS(3242),
    [anon_sym_BSLASHleq] = ACTIONS(3242),
    [anon_sym_u2264] = ACTIONS(3242),
    [anon_sym_GT_EQ] = ACTIONS(3245),
    [anon_sym_BSLASHgeq] = ACTIONS(3245),
    [anon_sym_u2265] = ACTIONS(3245),
    [anon_sym_BSLASHapprox] = ACTIONS(3248),
    [anon_sym_u2248] = ACTIONS(3248),
    [anon_sym_PIPE_DASH] = ACTIONS(3251),
    [anon_sym_u22a2] = ACTIONS(3251),
    [anon_sym_PIPE_EQ] = ACTIONS(3254),
    [anon_sym_u22a8] = ACTIONS(3254),
    [anon_sym_DASH_PIPE] = ACTIONS(3257),
    [anon_sym_u22a3] = ACTIONS(3257),
    [anon_sym_EQ_PIPE] = ACTIONS(3260),
    [anon_sym_u2ae4] = ACTIONS(3260),
    [anon_sym_BSLASHasymp] = ACTIONS(3263),
    [anon_sym_u224d] = ACTIONS(3263),
    [anon_sym_BSLASHcong] = ACTIONS(3266),
    [anon_sym_u2245] = ACTIONS(3266),
    [anon_sym_BSLASHdoteq] = ACTIONS(3269),
    [anon_sym_u2250] = ACTIONS(3269),
    [anon_sym_BSLASHgg] = ACTIONS(3272),
    [anon_sym_u226b] = ACTIONS(3272),
    [anon_sym_BSLASHll] = ACTIONS(3275),
    [anon_sym_u226a] = ACTIONS(3275),
    [anon_sym_BSLASHnotin] = ACTIONS(3278),
    [anon_sym_u2209] = ACTIONS(3278),
    [anon_sym_BSLASHprec] = ACTIONS(3281),
    [anon_sym_u227a] = ACTIONS(3284),
    [anon_sym_BSLASHsucc] = ACTIONS(3287),
    [anon_sym_u227b] = ACTIONS(3290),
    [anon_sym_BSLASHpreceq] = ACTIONS(3293),
    [anon_sym_u2aaf] = ACTIONS(3293),
    [anon_sym_BSLASHsucceq] = ACTIONS(3296),
    [anon_sym_u2ab0] = ACTIONS(3296),
    [anon_sym_BSLASHpropto] = ACTIONS(3299),
    [anon_sym_u221d] = ACTIONS(3299),
    [anon_sym_BSLASHsim] = ACTIONS(3302),
    [anon_sym_u223c] = ACTIONS(3305),
    [anon_sym_BSLASHsimeq] = ACTIONS(3308),
    [anon_sym_u2243] = ACTIONS(3308),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3311),
    [anon_sym_u228f] = ACTIONS(3314),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3317),
    [anon_sym_u2290] = ACTIONS(3320),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3323),
    [anon_sym_u2291] = ACTIONS(3323),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3326),
    [anon_sym_u2292] = ACTIONS(3326),
    [anon_sym_BSLASHsubset] = ACTIONS(3329),
    [anon_sym_u2282] = ACTIONS(3332),
    [anon_sym_BSLASHsupset] = ACTIONS(3335),
    [anon_sym_u2283] = ACTIONS(3338),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3341),
    [anon_sym_u2286] = ACTIONS(3341),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3344),
    [anon_sym_u2287] = ACTIONS(3344),
    [sym_compose] = ACTIONS(3347),
    [sym_map_to] = ACTIONS(3347),
    [sym_map_from] = ACTIONS(3347),
    [sym_setminus] = ACTIONS(3236),
    [anon_sym_BSLASHcap] = ACTIONS(3350),
    [anon_sym_BSLASHintersect] = ACTIONS(3350),
    [anon_sym_u2229] = ACTIONS(3350),
    [anon_sym_BSLASHcup] = ACTIONS(3353),
    [anon_sym_BSLASHunion] = ACTIONS(3353),
    [anon_sym_u222a] = ACTIONS(3353),
    [anon_sym_DOT_DOT] = ACTIONS(3356),
    [anon_sym_u2025] = ACTIONS(3359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3362),
    [anon_sym_u2026] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3365),
    [sym_plusplus] = ACTIONS(3347),
    [anon_sym_BSLASHoplus] = ACTIONS(3368),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3368),
    [anon_sym_u2295] = ACTIONS(3368),
    [anon_sym_BSLASHominus] = ACTIONS(3371),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3371),
    [anon_sym_u2296] = ACTIONS(3371),
    [sym_mod] = ACTIONS(3236),
    [sym_modmod] = ACTIONS(3347),
    [sym_vert] = ACTIONS(3236),
    [anon_sym_PIPE_PIPE] = ACTIONS(3374),
    [anon_sym_u2016] = ACTIONS(3374),
    [sym_minusminus] = ACTIONS(3347),
    [sym_amp] = ACTIONS(3236),
    [sym_ampamp] = ACTIONS(3347),
    [anon_sym_BSLASHodot] = ACTIONS(3377),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3377),
    [anon_sym_u2299] = ACTIONS(3377),
    [anon_sym_BSLASHoslash] = ACTIONS(3380),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3380),
    [anon_sym_u2298] = ACTIONS(3380),
    [anon_sym_BSLASHotimes] = ACTIONS(3383),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3383),
    [anon_sym_u2297] = ACTIONS(3383),
    [sym_mul] = ACTIONS(3236),
    [sym_mulmul] = ACTIONS(3347),
    [sym_slash] = ACTIONS(3236),
    [sym_slashslash] = ACTIONS(3347),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3386),
    [anon_sym_u25ef] = ACTIONS(3386),
    [anon_sym_BSLASHbullet] = ACTIONS(3389),
    [anon_sym_u25cf] = ACTIONS(3389),
    [anon_sym_BSLASHdiv] = ACTIONS(3392),
    [anon_sym_u00f7] = ACTIONS(3392),
    [anon_sym_BSLASHcirc] = ACTIONS(3395),
    [anon_sym_u2218] = ACTIONS(3395),
    [anon_sym_BSLASHstar] = ACTIONS(3398),
    [anon_sym_u22c6] = ACTIONS(3398),
    [anon_sym_u203c] = ACTIONS(3401),
    [sym_hashhash] = ACTIONS(3347),
    [sym_dol] = ACTIONS(3236),
    [sym_doldol] = ACTIONS(3347),
    [anon_sym_QMARK_QMARK] = ACTIONS(3404),
    [anon_sym_u2047] = ACTIONS(3404),
    [anon_sym_BSLASHsqcap] = ACTIONS(3407),
    [anon_sym_u2293] = ACTIONS(3407),
    [anon_sym_BSLASHsqcup] = ACTIONS(3410),
    [anon_sym_u2294] = ACTIONS(3410),
    [anon_sym_BSLASHuplus] = ACTIONS(3413),
    [anon_sym_u228e] = ACTIONS(3413),
    [anon_sym_BSLASHX] = ACTIONS(3416),
    [anon_sym_BSLASHtimes] = ACTIONS(3416),
    [anon_sym_u00d7] = ACTIONS(3416),
    [anon_sym_BSLASHwr] = ACTIONS(3419),
    [anon_sym_u2240] = ACTIONS(3419),
    [anon_sym_BSLASHcdot] = ACTIONS(3422),
    [anon_sym_u22c5] = ACTIONS(3422),
    [sym_pow] = ACTIONS(3236),
    [sym_powpow] = ACTIONS(3347),
    [anon_sym_CARET_PLUS] = ACTIONS(3425),
    [anon_sym_u207a] = ACTIONS(3425),
    [sym_asterisk] = ACTIONS(3428),
    [sym_sup_hash] = ACTIONS(3428),
    [sym_prime] = ACTIONS(3428),
    [sym__double_excl] = ACTIONS(3401),
  },
  [1109] = {
    [sym_block_comment] = STATE(1109),
    [sym_langle_bracket] = STATE(5521),
    [sym_rangle_bracket] = STATE(5521),
    [sym_colon] = STATE(5521),
    [sym_address] = STATE(5521),
    [sym_subexpr_component] = STATE(5247),
    [sym_bound_op] = STATE(5276),
    [sym_bound_nonfix_op] = STATE(5276),
    [sym_subexpr_tree_nav] = STATE(5247),
    [sym_child_id] = STATE(5521),
    [sym_operator_args] = STATE(5521),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [aux_sym_subexpr_prefix_repeat1] = STATE(1107),
    [sym_identifier] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2575),
    [anon_sym_u2208] = ACTIONS(2578),
    [anon_sym_LT_LT] = ACTIONS(3431),
    [anon_sym_u3008] = ACTIONS(3431),
    [anon_sym_u27e8] = ACTIONS(3431),
    [anon_sym_GT_GT] = ACTIONS(3434),
    [anon_sym_u3009] = ACTIONS(3434),
    [anon_sym_u27e9] = ACTIONS(3434),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2583),
    [anon_sym_u25a1] = ACTIONS(2583),
    [anon_sym_COLON] = ACTIONS(3437),
    [anon_sym_AT] = ACTIONS(3440),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2590),
    [anon_sym_u2227] = ACTIONS(2590),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2593),
    [anon_sym_u2228] = ACTIONS(2593),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [aux_sym_child_id_token1] = ACTIONS(3446),
    [anon_sym_BSLASHo] = ACTIONS(2600),
    [anon_sym_Nat] = ACTIONS(2603),
    [anon_sym_u2115] = ACTIONS(2605),
    [anon_sym_Int] = ACTIONS(2603),
    [anon_sym_u2124] = ACTIONS(2605),
    [anon_sym_Real] = ACTIONS(2603),
    [anon_sym_u211d] = ACTIONS(2605),
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_BSLASHlnot] = ACTIONS(2610),
    [anon_sym_BSLASHneg] = ACTIONS(2610),
    [anon_sym_TILDE] = ACTIONS(2613),
    [anon_sym_u00ac] = ACTIONS(2610),
    [sym_union] = ACTIONS(2616),
    [sym_powerset] = ACTIONS(2616),
    [sym_domain] = ACTIONS(2616),
    [anon_sym_DASH] = ACTIONS(2619),
    [sym_negative_dot] = ACTIONS(2622),
    [sym_enabled] = ACTIONS(2616),
    [sym_unchanged] = ACTIONS(2616),
    [anon_sym_LT_GT] = ACTIONS(2625),
    [anon_sym_u22c4] = ACTIONS(2625),
    [anon_sym_u25c7] = ACTIONS(2625),
    [anon_sym_EQ_GT] = ACTIONS(2628),
    [anon_sym_u27f9] = ACTIONS(2628),
    [anon_sym_u21d2] = ACTIONS(2628),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2631),
    [anon_sym_u21f8] = ACTIONS(2631),
    [anon_sym_u2945] = ACTIONS(2631),
    [anon_sym_BSLASHequiv] = ACTIONS(2634),
    [anon_sym_u2261] = ACTIONS(2634),
    [anon_sym_LT_EQ_GT] = ACTIONS(2637),
    [anon_sym_u27fa] = ACTIONS(2637),
    [anon_sym_u21d4] = ACTIONS(2637),
    [anon_sym_TILDE_GT] = ACTIONS(2640),
    [anon_sym_u21dd] = ACTIONS(2640),
    [anon_sym_u219d] = ACTIONS(2640),
    [anon_sym_BSLASHland] = ACTIONS(2590),
    [anon_sym_BSLASHlor] = ACTIONS(2593),
    [anon_sym_COLON_EQ] = ACTIONS(2643),
    [anon_sym_u2254] = ACTIONS(2643),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2646),
    [anon_sym_u2a74] = ACTIONS(2646),
    [anon_sym_SLASH_EQ] = ACTIONS(2649),
    [anon_sym_POUND] = ACTIONS(2652),
    [anon_sym_u2260] = ACTIONS(2649),
    [anon_sym_LT] = ACTIONS(2655),
    [sym_gt] = ACTIONS(2658),
    [anon_sym_LT_EQ] = ACTIONS(2661),
    [anon_sym_EQ_LT] = ACTIONS(2664),
    [anon_sym_BSLASHleq] = ACTIONS(2664),
    [anon_sym_u2264] = ACTIONS(2664),
    [anon_sym_GT_EQ] = ACTIONS(2667),
    [anon_sym_BSLASHgeq] = ACTIONS(2667),
    [anon_sym_u2265] = ACTIONS(2667),
    [anon_sym_BSLASHapprox] = ACTIONS(2670),
    [anon_sym_u2248] = ACTIONS(2670),
    [anon_sym_PIPE_DASH] = ACTIONS(2673),
    [anon_sym_u22a2] = ACTIONS(2673),
    [anon_sym_PIPE_EQ] = ACTIONS(2676),
    [anon_sym_u22a8] = ACTIONS(2676),
    [anon_sym_DASH_PIPE] = ACTIONS(2679),
    [anon_sym_u22a3] = ACTIONS(2679),
    [anon_sym_EQ_PIPE] = ACTIONS(2682),
    [anon_sym_u2ae4] = ACTIONS(2682),
    [anon_sym_BSLASHasymp] = ACTIONS(2685),
    [anon_sym_u224d] = ACTIONS(2685),
    [anon_sym_BSLASHcong] = ACTIONS(2688),
    [anon_sym_u2245] = ACTIONS(2688),
    [anon_sym_BSLASHdoteq] = ACTIONS(2691),
    [anon_sym_u2250] = ACTIONS(2691),
    [anon_sym_BSLASHgg] = ACTIONS(2694),
    [anon_sym_u226b] = ACTIONS(2694),
    [anon_sym_BSLASHll] = ACTIONS(2697),
    [anon_sym_u226a] = ACTIONS(2697),
    [anon_sym_BSLASHnotin] = ACTIONS(2700),
    [anon_sym_u2209] = ACTIONS(2700),
    [anon_sym_BSLASHprec] = ACTIONS(2703),
    [anon_sym_u227a] = ACTIONS(2706),
    [anon_sym_BSLASHsucc] = ACTIONS(2709),
    [anon_sym_u227b] = ACTIONS(2712),
    [anon_sym_BSLASHpreceq] = ACTIONS(2715),
    [anon_sym_u2aaf] = ACTIONS(2715),
    [anon_sym_BSLASHsucceq] = ACTIONS(2718),
    [anon_sym_u2ab0] = ACTIONS(2718),
    [anon_sym_BSLASHpropto] = ACTIONS(2721),
    [anon_sym_u221d] = ACTIONS(2721),
    [anon_sym_BSLASHsim] = ACTIONS(2724),
    [anon_sym_u223c] = ACTIONS(2727),
    [anon_sym_BSLASHsimeq] = ACTIONS(2730),
    [anon_sym_u2243] = ACTIONS(2730),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2733),
    [anon_sym_u228f] = ACTIONS(2736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2739),
    [anon_sym_u2290] = ACTIONS(2742),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2745),
    [anon_sym_u2291] = ACTIONS(2745),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2748),
    [anon_sym_u2292] = ACTIONS(2748),
    [anon_sym_BSLASHsubset] = ACTIONS(2751),
    [anon_sym_u2282] = ACTIONS(2754),
    [anon_sym_BSLASHsupset] = ACTIONS(2757),
    [anon_sym_u2283] = ACTIONS(2760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2763),
    [anon_sym_u2286] = ACTIONS(2763),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2766),
    [anon_sym_u2287] = ACTIONS(2766),
    [sym_compose] = ACTIONS(2769),
    [sym_map_to] = ACTIONS(2769),
    [sym_map_from] = ACTIONS(2769),
    [sym_setminus] = ACTIONS(2658),
    [anon_sym_BSLASHcap] = ACTIONS(2772),
    [anon_sym_BSLASHintersect] = ACTIONS(2772),
    [anon_sym_u2229] = ACTIONS(2772),
    [anon_sym_BSLASHcup] = ACTIONS(2775),
    [anon_sym_BSLASHunion] = ACTIONS(2775),
    [anon_sym_u222a] = ACTIONS(2775),
    [anon_sym_DOT_DOT] = ACTIONS(2778),
    [anon_sym_u2025] = ACTIONS(2781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2784),
    [anon_sym_u2026] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2787),
    [sym_plusplus] = ACTIONS(2769),
    [anon_sym_BSLASHoplus] = ACTIONS(2790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2790),
    [anon_sym_u2295] = ACTIONS(2790),
    [anon_sym_BSLASHominus] = ACTIONS(2793),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2793),
    [anon_sym_u2296] = ACTIONS(2793),
    [sym_mod] = ACTIONS(2658),
    [sym_modmod] = ACTIONS(2769),
    [sym_vert] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2796),
    [anon_sym_u2016] = ACTIONS(2796),
    [sym_minusminus] = ACTIONS(2769),
    [sym_amp] = ACTIONS(2658),
    [sym_ampamp] = ACTIONS(2769),
    [anon_sym_BSLASHodot] = ACTIONS(2799),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2799),
    [anon_sym_u2299] = ACTIONS(2799),
    [anon_sym_BSLASHoslash] = ACTIONS(2802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2802),
    [anon_sym_u2298] = ACTIONS(2802),
    [anon_sym_BSLASHotimes] = ACTIONS(2805),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2805),
    [anon_sym_u2297] = ACTIONS(2805),
    [sym_mul] = ACTIONS(2658),
    [sym_mulmul] = ACTIONS(2769),
    [sym_slash] = ACTIONS(2658),
    [sym_slashslash] = ACTIONS(2769),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2808),
    [anon_sym_u25ef] = ACTIONS(2808),
    [anon_sym_BSLASHbullet] = ACTIONS(2811),
    [anon_sym_u25cf] = ACTIONS(2811),
    [anon_sym_BSLASHdiv] = ACTIONS(2814),
    [anon_sym_u00f7] = ACTIONS(2814),
    [anon_sym_BSLASHcirc] = ACTIONS(2817),
    [anon_sym_u2218] = ACTIONS(2817),
    [anon_sym_BSLASHstar] = ACTIONS(2820),
    [anon_sym_u22c6] = ACTIONS(2820),
    [anon_sym_u203c] = ACTIONS(2823),
    [sym_hashhash] = ACTIONS(2769),
    [sym_dol] = ACTIONS(2658),
    [sym_doldol] = ACTIONS(2769),
    [anon_sym_QMARK_QMARK] = ACTIONS(2826),
    [anon_sym_u2047] = ACTIONS(2826),
    [anon_sym_BSLASHsqcap] = ACTIONS(2829),
    [anon_sym_u2293] = ACTIONS(2829),
    [anon_sym_BSLASHsqcup] = ACTIONS(2832),
    [anon_sym_u2294] = ACTIONS(2832),
    [anon_sym_BSLASHuplus] = ACTIONS(2835),
    [anon_sym_u228e] = ACTIONS(2835),
    [anon_sym_BSLASHX] = ACTIONS(2838),
    [anon_sym_BSLASHtimes] = ACTIONS(2838),
    [anon_sym_u00d7] = ACTIONS(2838),
    [anon_sym_BSLASHwr] = ACTIONS(2841),
    [anon_sym_u2240] = ACTIONS(2841),
    [anon_sym_BSLASHcdot] = ACTIONS(2844),
    [anon_sym_u22c5] = ACTIONS(2844),
    [sym_pow] = ACTIONS(2658),
    [sym_powpow] = ACTIONS(2769),
    [anon_sym_CARET_PLUS] = ACTIONS(2847),
    [anon_sym_u207a] = ACTIONS(2847),
    [sym_asterisk] = ACTIONS(2850),
    [sym_sup_hash] = ACTIONS(2850),
    [sym_prime] = ACTIONS(2850),
    [sym__double_excl] = ACTIONS(2823),
  },
  [1110] = {
    [sym_block_comment] = STATE(1110),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5362),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1111] = {
    [sym_block_comment] = STATE(1111),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1312),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(3121),
    [sym_bound_nonfix_op] = STATE(3121),
    [sym__subscript_expr] = STATE(3237),
    [sym_prefixed_op] = STATE(3325),
    [sym_parentheses] = STATE(3325),
    [sym_finite_set_literal] = STATE(3325),
    [sym_set_filter] = STATE(3325),
    [sym_set_map] = STATE(3325),
    [sym_function_literal] = STATE(3325),
    [sym_set_of_functions] = STATE(3325),
    [sym_record_literal] = STATE(3325),
    [sym_set_of_records] = STATE(3325),
    [sym_except] = STATE(3325),
    [sym_tuple_literal] = STATE(3325),
    [sym_step_expr_or_stutter] = STATE(3325),
    [sym_step_expr_no_stutter] = STATE(3325),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1112] = {
    [sym_block_comment] = STATE(1112),
    [sym_langle_bracket] = STATE(72),
    [sym_subexpr_prefix] = STATE(1312),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(3121),
    [sym_bound_nonfix_op] = STATE(3121),
    [sym__subscript_expr] = STATE(3191),
    [sym_prefixed_op] = STATE(3325),
    [sym_parentheses] = STATE(3325),
    [sym_finite_set_literal] = STATE(3325),
    [sym_set_filter] = STATE(3325),
    [sym_set_map] = STATE(3325),
    [sym_function_literal] = STATE(3325),
    [sym_set_of_functions] = STATE(3325),
    [sym_record_literal] = STATE(3325),
    [sym_set_of_records] = STATE(3325),
    [sym_except] = STATE(3325),
    [sym_tuple_literal] = STATE(3325),
    [sym_step_expr_or_stutter] = STATE(3325),
    [sym_step_expr_no_stutter] = STATE(3325),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5044),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5049),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5044),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1113] = {
    [sym_block_comment] = STATE(1113),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1316),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2236),
    [sym_bound_nonfix_op] = STATE(2236),
    [sym__subscript_expr] = STATE(2343),
    [sym_prefixed_op] = STATE(2327),
    [sym_parentheses] = STATE(2327),
    [sym_finite_set_literal] = STATE(2327),
    [sym_set_filter] = STATE(2327),
    [sym_set_map] = STATE(2327),
    [sym_function_literal] = STATE(2327),
    [sym_set_of_functions] = STATE(2327),
    [sym_record_literal] = STATE(2327),
    [sym_set_of_records] = STATE(2327),
    [sym_except] = STATE(2327),
    [sym_tuple_literal] = STATE(2327),
    [sym_step_expr_or_stutter] = STATE(2327),
    [sym_step_expr_no_stutter] = STATE(2327),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1114] = {
    [sym_block_comment] = STATE(1114),
    [sym_langle_bracket] = STATE(77),
    [sym_subexpr_prefix] = STATE(1316),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2236),
    [sym_bound_nonfix_op] = STATE(2236),
    [sym__subscript_expr] = STATE(2348),
    [sym_prefixed_op] = STATE(2327),
    [sym_parentheses] = STATE(2327),
    [sym_finite_set_literal] = STATE(2327),
    [sym_set_filter] = STATE(2327),
    [sym_set_map] = STATE(2327),
    [sym_function_literal] = STATE(2327),
    [sym_set_of_functions] = STATE(2327),
    [sym_record_literal] = STATE(2327),
    [sym_set_of_records] = STATE(2327),
    [sym_except] = STATE(2327),
    [sym_tuple_literal] = STATE(2327),
    [sym_step_expr_or_stutter] = STATE(2327),
    [sym_step_expr_no_stutter] = STATE(2327),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4972),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5054),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4972),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1115] = {
    [sym_block_comment] = STATE(1115),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5385),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1116] = {
    [sym_block_comment] = STATE(1116),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1310),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2905),
    [sym_bound_nonfix_op] = STATE(2905),
    [sym__subscript_expr] = STATE(2939),
    [sym_prefixed_op] = STATE(2925),
    [sym_parentheses] = STATE(2925),
    [sym_finite_set_literal] = STATE(2925),
    [sym_set_filter] = STATE(2925),
    [sym_set_map] = STATE(2925),
    [sym_function_literal] = STATE(2925),
    [sym_set_of_functions] = STATE(2925),
    [sym_record_literal] = STATE(2925),
    [sym_set_of_records] = STATE(2925),
    [sym_except] = STATE(2925),
    [sym_tuple_literal] = STATE(2925),
    [sym_step_expr_or_stutter] = STATE(2925),
    [sym_step_expr_no_stutter] = STATE(2925),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1117] = {
    [sym_block_comment] = STATE(1117),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1318),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2612),
    [sym_bound_nonfix_op] = STATE(2612),
    [sym__subscript_expr] = STATE(2684),
    [sym_prefixed_op] = STATE(2688),
    [sym_parentheses] = STATE(2688),
    [sym_finite_set_literal] = STATE(2688),
    [sym_set_filter] = STATE(2688),
    [sym_set_map] = STATE(2688),
    [sym_function_literal] = STATE(2688),
    [sym_set_of_functions] = STATE(2688),
    [sym_record_literal] = STATE(2688),
    [sym_set_of_records] = STATE(2688),
    [sym_except] = STATE(2688),
    [sym_tuple_literal] = STATE(2688),
    [sym_step_expr_or_stutter] = STATE(2688),
    [sym_step_expr_no_stutter] = STATE(2688),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1118] = {
    [sym_block_comment] = STATE(1118),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1319),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2529),
    [sym_bound_nonfix_op] = STATE(2529),
    [sym__subscript_expr] = STATE(2545),
    [sym_prefixed_op] = STATE(2652),
    [sym_parentheses] = STATE(2652),
    [sym_finite_set_literal] = STATE(2652),
    [sym_set_filter] = STATE(2652),
    [sym_set_map] = STATE(2652),
    [sym_function_literal] = STATE(2652),
    [sym_set_of_functions] = STATE(2652),
    [sym_record_literal] = STATE(2652),
    [sym_set_of_records] = STATE(2652),
    [sym_except] = STATE(2652),
    [sym_tuple_literal] = STATE(2652),
    [sym_step_expr_or_stutter] = STATE(2652),
    [sym_step_expr_no_stutter] = STATE(2652),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1119] = {
    [sym_block_comment] = STATE(1119),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1326),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2372),
    [sym_bound_nonfix_op] = STATE(2372),
    [sym__subscript_expr] = STATE(2420),
    [sym_prefixed_op] = STATE(2426),
    [sym_parentheses] = STATE(2426),
    [sym_finite_set_literal] = STATE(2426),
    [sym_set_filter] = STATE(2426),
    [sym_set_map] = STATE(2426),
    [sym_function_literal] = STATE(2426),
    [sym_set_of_functions] = STATE(2426),
    [sym_record_literal] = STATE(2426),
    [sym_set_of_records] = STATE(2426),
    [sym_except] = STATE(2426),
    [sym_tuple_literal] = STATE(2426),
    [sym_step_expr_or_stutter] = STATE(2426),
    [sym_step_expr_no_stutter] = STATE(2426),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1120] = {
    [sym_block_comment] = STATE(1120),
    [sym_langle_bracket] = STATE(78),
    [sym_subexpr_prefix] = STATE(1319),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2529),
    [sym_bound_nonfix_op] = STATE(2529),
    [sym__subscript_expr] = STATE(2555),
    [sym_prefixed_op] = STATE(2652),
    [sym_parentheses] = STATE(2652),
    [sym_finite_set_literal] = STATE(2652),
    [sym_set_filter] = STATE(2652),
    [sym_set_map] = STATE(2652),
    [sym_function_literal] = STATE(2652),
    [sym_set_of_functions] = STATE(2652),
    [sym_record_literal] = STATE(2652),
    [sym_set_of_records] = STATE(2652),
    [sym_except] = STATE(2652),
    [sym_tuple_literal] = STATE(2652),
    [sym_step_expr_or_stutter] = STATE(2652),
    [sym_step_expr_no_stutter] = STATE(2652),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4977),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5055),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4977),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(914),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1121] = {
    [sym_block_comment] = STATE(1121),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5149),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1122] = {
    [sym_block_comment] = STATE(1122),
    [sym_langle_bracket] = STATE(73),
    [sym_subexpr_prefix] = STATE(1318),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2612),
    [sym_bound_nonfix_op] = STATE(2612),
    [sym__subscript_expr] = STATE(2727),
    [sym_prefixed_op] = STATE(2688),
    [sym_parentheses] = STATE(2688),
    [sym_finite_set_literal] = STATE(2688),
    [sym_set_filter] = STATE(2688),
    [sym_set_map] = STATE(2688),
    [sym_function_literal] = STATE(2688),
    [sym_set_of_functions] = STATE(2688),
    [sym_record_literal] = STATE(2688),
    [sym_set_of_records] = STATE(2688),
    [sym_except] = STATE(2688),
    [sym_tuple_literal] = STATE(2688),
    [sym_step_expr_or_stutter] = STATE(2688),
    [sym_step_expr_no_stutter] = STATE(2688),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4947),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5050),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4947),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1123] = {
    [sym_block_comment] = STATE(1123),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1325),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2822),
    [sym_bound_nonfix_op] = STATE(2822),
    [sym__subscript_expr] = STATE(2835),
    [sym_prefixed_op] = STATE(2860),
    [sym_parentheses] = STATE(2860),
    [sym_finite_set_literal] = STATE(2860),
    [sym_set_filter] = STATE(2860),
    [sym_set_map] = STATE(2860),
    [sym_function_literal] = STATE(2860),
    [sym_set_of_functions] = STATE(2860),
    [sym_record_literal] = STATE(2860),
    [sym_set_of_records] = STATE(2860),
    [sym_except] = STATE(2860),
    [sym_tuple_literal] = STATE(2860),
    [sym_step_expr_or_stutter] = STATE(2860),
    [sym_step_expr_no_stutter] = STATE(2860),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1124] = {
    [sym_block_comment] = STATE(1124),
    [sym_langle_bracket] = STATE(79),
    [sym_subexpr_prefix] = STATE(1325),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2822),
    [sym_bound_nonfix_op] = STATE(2822),
    [sym__subscript_expr] = STATE(2837),
    [sym_prefixed_op] = STATE(2860),
    [sym_parentheses] = STATE(2860),
    [sym_finite_set_literal] = STATE(2860),
    [sym_set_filter] = STATE(2860),
    [sym_set_map] = STATE(2860),
    [sym_function_literal] = STATE(2860),
    [sym_set_of_functions] = STATE(2860),
    [sym_record_literal] = STATE(2860),
    [sym_set_of_records] = STATE(2860),
    [sym_except] = STATE(2860),
    [sym_tuple_literal] = STATE(2860),
    [sym_step_expr_or_stutter] = STATE(2860),
    [sym_step_expr_no_stutter] = STATE(2860),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4983),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5056),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4983),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1125] = {
    [sym_block_comment] = STATE(1125),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5341),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1126] = {
    [sym_block_comment] = STATE(1126),
    [sym_langle_bracket] = STATE(70),
    [sym_subexpr_prefix] = STATE(1310),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2905),
    [sym_bound_nonfix_op] = STATE(2905),
    [sym__subscript_expr] = STATE(2943),
    [sym_prefixed_op] = STATE(2925),
    [sym_parentheses] = STATE(2925),
    [sym_finite_set_literal] = STATE(2925),
    [sym_set_filter] = STATE(2925),
    [sym_set_map] = STATE(2925),
    [sym_function_literal] = STATE(2925),
    [sym_set_of_functions] = STATE(2925),
    [sym_record_literal] = STATE(2925),
    [sym_set_of_records] = STATE(2925),
    [sym_except] = STATE(2925),
    [sym_tuple_literal] = STATE(2925),
    [sym_step_expr_or_stutter] = STATE(2925),
    [sym_step_expr_no_stutter] = STATE(2925),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5027),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5047),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5027),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1127] = {
    [sym_block_comment] = STATE(1127),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1322),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(3001),
    [sym_bound_nonfix_op] = STATE(3001),
    [sym__subscript_expr] = STATE(3141),
    [sym_prefixed_op] = STATE(3137),
    [sym_parentheses] = STATE(3137),
    [sym_finite_set_literal] = STATE(3137),
    [sym_set_filter] = STATE(3137),
    [sym_set_map] = STATE(3137),
    [sym_function_literal] = STATE(3137),
    [sym_set_of_functions] = STATE(3137),
    [sym_record_literal] = STATE(3137),
    [sym_set_of_records] = STATE(3137),
    [sym_except] = STATE(3137),
    [sym_tuple_literal] = STATE(3137),
    [sym_step_expr_or_stutter] = STATE(3137),
    [sym_step_expr_no_stutter] = STATE(3137),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1128] = {
    [sym_block_comment] = STATE(1128),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1314),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(3084),
    [sym_bound_nonfix_op] = STATE(3084),
    [sym__subscript_expr] = STATE(3176),
    [sym_prefixed_op] = STATE(3212),
    [sym_parentheses] = STATE(3212),
    [sym_finite_set_literal] = STATE(3212),
    [sym_set_filter] = STATE(3212),
    [sym_set_map] = STATE(3212),
    [sym_function_literal] = STATE(3212),
    [sym_set_of_functions] = STATE(3212),
    [sym_record_literal] = STATE(3212),
    [sym_set_of_records] = STATE(3212),
    [sym_except] = STATE(3212),
    [sym_tuple_literal] = STATE(3212),
    [sym_step_expr_or_stutter] = STATE(3212),
    [sym_step_expr_no_stutter] = STATE(3212),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1129] = {
    [sym_block_comment] = STATE(1129),
    [sym_langle_bracket] = STATE(80),
    [sym_subexpr_prefix] = STATE(1314),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(3084),
    [sym_bound_nonfix_op] = STATE(3084),
    [sym__subscript_expr] = STATE(3316),
    [sym_prefixed_op] = STATE(3212),
    [sym_parentheses] = STATE(3212),
    [sym_finite_set_literal] = STATE(3212),
    [sym_set_filter] = STATE(3212),
    [sym_set_map] = STATE(3212),
    [sym_function_literal] = STATE(3212),
    [sym_set_of_functions] = STATE(3212),
    [sym_record_literal] = STATE(3212),
    [sym_set_of_records] = STATE(3212),
    [sym_except] = STATE(3212),
    [sym_tuple_literal] = STATE(3212),
    [sym_step_expr_or_stutter] = STATE(3212),
    [sym_step_expr_no_stutter] = STATE(3212),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4989),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5057),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4989),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(614),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1130] = {
    [sym_block_comment] = STATE(1130),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1317),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(3128),
    [sym_bound_nonfix_op] = STATE(3128),
    [sym__subscript_expr] = STATE(3295),
    [sym_prefixed_op] = STATE(3264),
    [sym_parentheses] = STATE(3264),
    [sym_finite_set_literal] = STATE(3264),
    [sym_set_filter] = STATE(3264),
    [sym_set_map] = STATE(3264),
    [sym_function_literal] = STATE(3264),
    [sym_set_of_functions] = STATE(3264),
    [sym_record_literal] = STATE(3264),
    [sym_set_of_records] = STATE(3264),
    [sym_except] = STATE(3264),
    [sym_tuple_literal] = STATE(3264),
    [sym_step_expr_or_stutter] = STATE(3264),
    [sym_step_expr_no_stutter] = STATE(3264),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1131] = {
    [sym_block_comment] = STATE(1131),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1320),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2686),
    [sym_bound_nonfix_op] = STATE(2686),
    [sym__subscript_expr] = STATE(2739),
    [sym_prefixed_op] = STATE(2770),
    [sym_parentheses] = STATE(2770),
    [sym_finite_set_literal] = STATE(2770),
    [sym_set_filter] = STATE(2770),
    [sym_set_map] = STATE(2770),
    [sym_function_literal] = STATE(2770),
    [sym_set_of_functions] = STATE(2770),
    [sym_record_literal] = STATE(2770),
    [sym_set_of_records] = STATE(2770),
    [sym_except] = STATE(2770),
    [sym_tuple_literal] = STATE(2770),
    [sym_step_expr_or_stutter] = STATE(2770),
    [sym_step_expr_no_stutter] = STATE(2770),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1132] = {
    [sym_block_comment] = STATE(1132),
    [sym_langle_bracket] = STATE(81),
    [sym_subexpr_prefix] = STATE(1320),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2686),
    [sym_bound_nonfix_op] = STATE(2686),
    [sym__subscript_expr] = STATE(2744),
    [sym_prefixed_op] = STATE(2770),
    [sym_parentheses] = STATE(2770),
    [sym_finite_set_literal] = STATE(2770),
    [sym_set_filter] = STATE(2770),
    [sym_set_map] = STATE(2770),
    [sym_function_literal] = STATE(2770),
    [sym_set_of_functions] = STATE(2770),
    [sym_record_literal] = STATE(2770),
    [sym_set_of_records] = STATE(2770),
    [sym_except] = STATE(2770),
    [sym_tuple_literal] = STATE(2770),
    [sym_step_expr_or_stutter] = STATE(2770),
    [sym_step_expr_no_stutter] = STATE(2770),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4994),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5058),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4994),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1133] = {
    [sym_block_comment] = STATE(1133),
    [sym_langle_bracket] = STATE(74),
    [sym_subexpr_prefix] = STATE(1317),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(3128),
    [sym_bound_nonfix_op] = STATE(3128),
    [sym__subscript_expr] = STATE(3180),
    [sym_prefixed_op] = STATE(3264),
    [sym_parentheses] = STATE(3264),
    [sym_finite_set_literal] = STATE(3264),
    [sym_set_filter] = STATE(3264),
    [sym_set_map] = STATE(3264),
    [sym_function_literal] = STATE(3264),
    [sym_set_of_functions] = STATE(3264),
    [sym_record_literal] = STATE(3264),
    [sym_set_of_records] = STATE(3264),
    [sym_except] = STATE(3264),
    [sym_tuple_literal] = STATE(3264),
    [sym_step_expr_or_stutter] = STATE(3264),
    [sym_step_expr_no_stutter] = STATE(3264),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4952),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5051),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4952),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2051),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1134] = {
    [sym_block_comment] = STATE(1134),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1315),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2386),
    [sym_bound_nonfix_op] = STATE(2386),
    [sym__subscript_expr] = STATE(2429),
    [sym_prefixed_op] = STATE(2393),
    [sym_parentheses] = STATE(2393),
    [sym_finite_set_literal] = STATE(2393),
    [sym_set_filter] = STATE(2393),
    [sym_set_map] = STATE(2393),
    [sym_function_literal] = STATE(2393),
    [sym_set_of_functions] = STATE(2393),
    [sym_record_literal] = STATE(2393),
    [sym_set_of_records] = STATE(2393),
    [sym_except] = STATE(2393),
    [sym_tuple_literal] = STATE(2393),
    [sym_step_expr_or_stutter] = STATE(2393),
    [sym_step_expr_no_stutter] = STATE(2393),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1135] = {
    [sym_block_comment] = STATE(1135),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1321),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(3352),
    [sym_bound_nonfix_op] = STATE(3352),
    [sym__subscript_expr] = STATE(3359),
    [sym_prefixed_op] = STATE(3396),
    [sym_parentheses] = STATE(3396),
    [sym_finite_set_literal] = STATE(3396),
    [sym_set_filter] = STATE(3396),
    [sym_set_map] = STATE(3396),
    [sym_function_literal] = STATE(3396),
    [sym_set_of_functions] = STATE(3396),
    [sym_record_literal] = STATE(3396),
    [sym_set_of_records] = STATE(3396),
    [sym_except] = STATE(3396),
    [sym_tuple_literal] = STATE(3396),
    [sym_step_expr_or_stutter] = STATE(3396),
    [sym_step_expr_no_stutter] = STATE(3396),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1136] = {
    [sym_block_comment] = STATE(1136),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1323),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2231),
    [sym_bound_nonfix_op] = STATE(2231),
    [sym__subscript_expr] = STATE(2264),
    [sym_prefixed_op] = STATE(2247),
    [sym_parentheses] = STATE(2247),
    [sym_finite_set_literal] = STATE(2247),
    [sym_set_filter] = STATE(2247),
    [sym_set_map] = STATE(2247),
    [sym_function_literal] = STATE(2247),
    [sym_set_of_functions] = STATE(2247),
    [sym_record_literal] = STATE(2247),
    [sym_set_of_records] = STATE(2247),
    [sym_except] = STATE(2247),
    [sym_tuple_literal] = STATE(2247),
    [sym_step_expr_or_stutter] = STATE(2247),
    [sym_step_expr_no_stutter] = STATE(2247),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1137] = {
    [sym_block_comment] = STATE(1137),
    [sym_langle_bracket] = STATE(61),
    [sym_subexpr_prefix] = STATE(1323),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2231),
    [sym_bound_nonfix_op] = STATE(2231),
    [sym__subscript_expr] = STATE(2269),
    [sym_prefixed_op] = STATE(2247),
    [sym_parentheses] = STATE(2247),
    [sym_finite_set_literal] = STATE(2247),
    [sym_set_filter] = STATE(2247),
    [sym_set_map] = STATE(2247),
    [sym_function_literal] = STATE(2247),
    [sym_set_of_functions] = STATE(2247),
    [sym_record_literal] = STATE(2247),
    [sym_set_of_records] = STATE(2247),
    [sym_except] = STATE(2247),
    [sym_tuple_literal] = STATE(2247),
    [sym_step_expr_or_stutter] = STATE(2247),
    [sym_step_expr_no_stutter] = STATE(2247),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4974),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5040),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4974),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1138] = {
    [sym_block_comment] = STATE(1138),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1311),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2974),
    [sym_bound_nonfix_op] = STATE(2974),
    [sym__subscript_expr] = STATE(3037),
    [sym_prefixed_op] = STATE(3065),
    [sym_parentheses] = STATE(3065),
    [sym_finite_set_literal] = STATE(3065),
    [sym_set_filter] = STATE(3065),
    [sym_set_map] = STATE(3065),
    [sym_function_literal] = STATE(3065),
    [sym_set_of_functions] = STATE(3065),
    [sym_record_literal] = STATE(3065),
    [sym_set_of_records] = STATE(3065),
    [sym_except] = STATE(3065),
    [sym_tuple_literal] = STATE(3065),
    [sym_step_expr_or_stutter] = STATE(3065),
    [sym_step_expr_no_stutter] = STATE(3065),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1139] = {
    [sym_block_comment] = STATE(1139),
    [sym_langle_bracket] = STATE(75),
    [sym_subexpr_prefix] = STATE(1311),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2974),
    [sym_bound_nonfix_op] = STATE(2974),
    [sym__subscript_expr] = STATE(3046),
    [sym_prefixed_op] = STATE(3065),
    [sym_parentheses] = STATE(3065),
    [sym_finite_set_literal] = STATE(3065),
    [sym_set_filter] = STATE(3065),
    [sym_set_map] = STATE(3065),
    [sym_function_literal] = STATE(3065),
    [sym_set_of_functions] = STATE(3065),
    [sym_record_literal] = STATE(3065),
    [sym_set_of_records] = STATE(3065),
    [sym_except] = STATE(3065),
    [sym_tuple_literal] = STATE(3065),
    [sym_step_expr_or_stutter] = STATE(3065),
    [sym_step_expr_no_stutter] = STATE(3065),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4959),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5052),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4959),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(85),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1140] = {
    [sym_block_comment] = STATE(1140),
    [sym_langle_bracket] = STATE(54),
    [sym_subexpr_prefix] = STATE(1326),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2372),
    [sym_bound_nonfix_op] = STATE(2372),
    [sym__subscript_expr] = STATE(2410),
    [sym_prefixed_op] = STATE(2426),
    [sym_parentheses] = STATE(2426),
    [sym_finite_set_literal] = STATE(2426),
    [sym_set_filter] = STATE(2426),
    [sym_set_map] = STATE(2426),
    [sym_function_literal] = STATE(2426),
    [sym_set_of_functions] = STATE(2426),
    [sym_record_literal] = STATE(2426),
    [sym_set_of_records] = STATE(2426),
    [sym_except] = STATE(2426),
    [sym_tuple_literal] = STATE(2426),
    [sym_step_expr_or_stutter] = STATE(2426),
    [sym_step_expr_no_stutter] = STATE(2426),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4944),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4945),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4944),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(422),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1141] = {
    [sym_block_comment] = STATE(1141),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5244),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1142] = {
    [sym_block_comment] = STATE(1142),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5288),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1143] = {
    [sym_block_comment] = STATE(1143),
    [sym_langle_bracket] = STATE(69),
    [sym_subexpr_prefix] = STATE(1322),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(3001),
    [sym_bound_nonfix_op] = STATE(3001),
    [sym__subscript_expr] = STATE(3096),
    [sym_prefixed_op] = STATE(3137),
    [sym_parentheses] = STATE(3137),
    [sym_finite_set_literal] = STATE(3137),
    [sym_set_filter] = STATE(3137),
    [sym_set_map] = STATE(3137),
    [sym_function_literal] = STATE(3137),
    [sym_set_of_functions] = STATE(3137),
    [sym_record_literal] = STATE(3137),
    [sym_set_of_records] = STATE(3137),
    [sym_except] = STATE(3137),
    [sym_tuple_literal] = STATE(3137),
    [sym_step_expr_or_stutter] = STATE(3137),
    [sym_step_expr_no_stutter] = STATE(3137),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5009),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5045),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5009),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1144] = {
    [sym_block_comment] = STATE(1144),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5304),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1145] = {
    [sym_block_comment] = STATE(1145),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1313),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2527),
    [sym_bound_nonfix_op] = STATE(2527),
    [sym__subscript_expr] = STATE(2571),
    [sym_prefixed_op] = STATE(2642),
    [sym_parentheses] = STATE(2642),
    [sym_finite_set_literal] = STATE(2642),
    [sym_set_filter] = STATE(2642),
    [sym_set_map] = STATE(2642),
    [sym_function_literal] = STATE(2642),
    [sym_set_of_functions] = STATE(2642),
    [sym_record_literal] = STATE(2642),
    [sym_set_of_records] = STATE(2642),
    [sym_except] = STATE(2642),
    [sym_tuple_literal] = STATE(2642),
    [sym_step_expr_or_stutter] = STATE(2642),
    [sym_step_expr_no_stutter] = STATE(2642),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1146] = {
    [sym_block_comment] = STATE(1146),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5318),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1147] = {
    [sym_block_comment] = STATE(1147),
    [sym_langle_bracket] = STATE(66),
    [sym_subexpr_prefix] = STATE(1313),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2527),
    [sym_bound_nonfix_op] = STATE(2527),
    [sym__subscript_expr] = STATE(2576),
    [sym_prefixed_op] = STATE(2642),
    [sym_parentheses] = STATE(2642),
    [sym_finite_set_literal] = STATE(2642),
    [sym_set_filter] = STATE(2642),
    [sym_set_map] = STATE(2642),
    [sym_function_literal] = STATE(2642),
    [sym_set_of_functions] = STATE(2642),
    [sym_record_literal] = STATE(2642),
    [sym_set_of_records] = STATE(2642),
    [sym_except] = STATE(2642),
    [sym_tuple_literal] = STATE(2642),
    [sym_step_expr_or_stutter] = STATE(2642),
    [sym_step_expr_no_stutter] = STATE(2642),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4943),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5043),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4943),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1148] = {
    [sym_block_comment] = STATE(1148),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5329),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1149] = {
    [sym_block_comment] = STATE(1149),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5340),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1150] = {
    [sym_block_comment] = STATE(1150),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5351),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1151] = {
    [sym_block_comment] = STATE(1151),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5439),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1152] = {
    [sym_block_comment] = STATE(1152),
    [sym_langle_bracket] = STATE(76),
    [sym_subexpr_prefix] = STATE(1315),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(2386),
    [sym_bound_nonfix_op] = STATE(2386),
    [sym__subscript_expr] = STATE(2423),
    [sym_prefixed_op] = STATE(2393),
    [sym_parentheses] = STATE(2393),
    [sym_finite_set_literal] = STATE(2393),
    [sym_set_filter] = STATE(2393),
    [sym_set_map] = STATE(2393),
    [sym_function_literal] = STATE(2393),
    [sym_set_of_functions] = STATE(2393),
    [sym_record_literal] = STATE(2393),
    [sym_set_of_records] = STATE(2393),
    [sym_except] = STATE(2393),
    [sym_tuple_literal] = STATE(2393),
    [sym_step_expr_or_stutter] = STATE(2393),
    [sym_step_expr_no_stutter] = STATE(2393),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4965),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5053),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4965),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(338),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1153] = {
    [sym_block_comment] = STATE(1153),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5373),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1154] = {
    [sym_block_comment] = STATE(1154),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5384),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1155] = {
    [sym_block_comment] = STATE(1155),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5395),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1156] = {
    [sym_block_comment] = STATE(1156),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5406),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1157] = {
    [sym_block_comment] = STATE(1157),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5417),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1158] = {
    [sym_block_comment] = STATE(1158),
    [sym_langle_bracket] = STATE(68),
    [sym_subexpr_prefix] = STATE(1324),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(4999),
    [sym_bound_nonfix_op] = STATE(4999),
    [sym__subscript_expr] = STATE(5428),
    [sym_prefixed_op] = STATE(5392),
    [sym_parentheses] = STATE(5392),
    [sym_finite_set_literal] = STATE(5392),
    [sym_set_filter] = STATE(5392),
    [sym_set_map] = STATE(5392),
    [sym_function_literal] = STATE(5392),
    [sym_set_of_functions] = STATE(5392),
    [sym_record_literal] = STATE(5392),
    [sym_set_of_records] = STATE(5392),
    [sym_except] = STATE(5392),
    [sym_tuple_literal] = STATE(5392),
    [sym_step_expr_or_stutter] = STATE(5392),
    [sym_step_expr_no_stutter] = STATE(5392),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5018),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5046),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5018),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1159] = {
    [sym_block_comment] = STATE(1159),
    [sym_langle_bracket] = STATE(71),
    [sym_subexpr_prefix] = STATE(1321),
    [sym_subexpr_component] = STATE(5461),
    [sym_bound_op] = STATE(3352),
    [sym_bound_nonfix_op] = STATE(3352),
    [sym__subscript_expr] = STATE(3402),
    [sym_prefixed_op] = STATE(3396),
    [sym_parentheses] = STATE(3396),
    [sym_finite_set_literal] = STATE(3396),
    [sym_set_filter] = STATE(3396),
    [sym_set_map] = STATE(3396),
    [sym_function_literal] = STATE(3396),
    [sym_set_of_functions] = STATE(3396),
    [sym_record_literal] = STATE(3396),
    [sym_set_of_records] = STATE(3396),
    [sym_except] = STATE(3396),
    [sym_tuple_literal] = STATE(3396),
    [sym_step_expr_or_stutter] = STATE(3396),
    [sym_step_expr_no_stutter] = STATE(3396),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5035),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5048),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5035),
    [sym_proof_step_ref] = STATE(5461),
    [sym_identifier] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LT_LT] = ACTIONS(73),
    [anon_sym_u3008] = ACTIONS(73),
    [anon_sym_u27e8] = ACTIONS(73),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1160] = {
    [sym_block_comment] = STATE(1160),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1161] = {
    [sym_block_comment] = STATE(1161),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3497),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_PROOF] = ACTIONS(3497),
    [anon_sym_BY] = ACTIONS(3497),
    [anon_sym_OBVIOUS] = ACTIONS(3497),
    [anon_sym_OMITTED] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1162] = {
    [sym_block_comment] = STATE(1162),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3497),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_PROOF] = ACTIONS(3497),
    [anon_sym_BY] = ACTIONS(3497),
    [anon_sym_OBVIOUS] = ACTIONS(3497),
    [anon_sym_OMITTED] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1163] = {
    [sym_block_comment] = STATE(1163),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3499),
    [sym_identifier] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3499),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3501),
    [anon_sym_VARIABLE] = ACTIONS(3501),
    [anon_sym_VARIABLES] = ACTIONS(3501),
    [anon_sym_CONSTANT] = ACTIONS(3501),
    [anon_sym_CONSTANTS] = ACTIONS(3501),
    [anon_sym_RECURSIVE] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3501),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3501),
    [anon_sym_u2115] = ACTIONS(3499),
    [anon_sym_Int] = ACTIONS(3501),
    [anon_sym_u2124] = ACTIONS(3499),
    [anon_sym_Real] = ACTIONS(3501),
    [anon_sym_u211d] = ACTIONS(3499),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3499),
    [anon_sym_BSLASHneg] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_u00ac] = ACTIONS(3499),
    [sym_union] = ACTIONS(3501),
    [sym_powerset] = ACTIONS(3501),
    [sym_domain] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3499),
    [sym_enabled] = ACTIONS(3501),
    [sym_unchanged] = ACTIONS(3501),
    [anon_sym_LT_GT] = ACTIONS(3499),
    [anon_sym_u22c4] = ACTIONS(3499),
    [anon_sym_u25c7] = ACTIONS(3499),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3501),
    [anon_sym_ASSUMPTION] = ACTIONS(3501),
    [anon_sym_AXIOM] = ACTIONS(3501),
    [anon_sym_THEOREM] = ACTIONS(3501),
    [anon_sym_PROPOSITION] = ACTIONS(3501),
    [anon_sym_LEMMA] = ACTIONS(3501),
    [anon_sym_COROLLARY] = ACTIONS(3501),
    [anon_sym_PROOF] = ACTIONS(3501),
    [anon_sym_BY] = ACTIONS(3501),
    [anon_sym_OBVIOUS] = ACTIONS(3501),
    [anon_sym_OMITTED] = ACTIONS(3501),
    [anon_sym_USE] = ACTIONS(3501),
    [anon_sym_HIDE] = ACTIONS(3501),
    [sym__begin_proof] = ACTIONS(3499),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1164] = {
    [sym_block_comment] = STATE(1164),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3503),
    [sym_identifier] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3503),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3505),
    [anon_sym_VARIABLE] = ACTIONS(3505),
    [anon_sym_VARIABLES] = ACTIONS(3505),
    [anon_sym_CONSTANT] = ACTIONS(3505),
    [anon_sym_CONSTANTS] = ACTIONS(3505),
    [anon_sym_RECURSIVE] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3505),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3505),
    [anon_sym_u2115] = ACTIONS(3503),
    [anon_sym_Int] = ACTIONS(3505),
    [anon_sym_u2124] = ACTIONS(3503),
    [anon_sym_Real] = ACTIONS(3505),
    [anon_sym_u211d] = ACTIONS(3503),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3503),
    [anon_sym_BSLASHneg] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_u00ac] = ACTIONS(3503),
    [sym_union] = ACTIONS(3505),
    [sym_powerset] = ACTIONS(3505),
    [sym_domain] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3503),
    [sym_enabled] = ACTIONS(3505),
    [sym_unchanged] = ACTIONS(3505),
    [anon_sym_LT_GT] = ACTIONS(3503),
    [anon_sym_u22c4] = ACTIONS(3503),
    [anon_sym_u25c7] = ACTIONS(3503),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3505),
    [anon_sym_ASSUMPTION] = ACTIONS(3505),
    [anon_sym_AXIOM] = ACTIONS(3505),
    [anon_sym_THEOREM] = ACTIONS(3505),
    [anon_sym_PROPOSITION] = ACTIONS(3505),
    [anon_sym_LEMMA] = ACTIONS(3505),
    [anon_sym_COROLLARY] = ACTIONS(3505),
    [anon_sym_PROOF] = ACTIONS(3505),
    [anon_sym_BY] = ACTIONS(3505),
    [anon_sym_OBVIOUS] = ACTIONS(3505),
    [anon_sym_OMITTED] = ACTIONS(3505),
    [anon_sym_USE] = ACTIONS(3505),
    [anon_sym_HIDE] = ACTIONS(3505),
    [sym__begin_proof] = ACTIONS(3503),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1165] = {
    [sym_block_comment] = STATE(1165),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3507),
    [sym_identifier] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3507),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3509),
    [anon_sym_VARIABLE] = ACTIONS(3509),
    [anon_sym_VARIABLES] = ACTIONS(3509),
    [anon_sym_CONSTANT] = ACTIONS(3509),
    [anon_sym_CONSTANTS] = ACTIONS(3509),
    [anon_sym_RECURSIVE] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3509),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3509),
    [anon_sym_u2115] = ACTIONS(3507),
    [anon_sym_Int] = ACTIONS(3509),
    [anon_sym_u2124] = ACTIONS(3507),
    [anon_sym_Real] = ACTIONS(3509),
    [anon_sym_u211d] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3507),
    [anon_sym_BSLASHneg] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [anon_sym_u00ac] = ACTIONS(3507),
    [sym_union] = ACTIONS(3509),
    [sym_powerset] = ACTIONS(3509),
    [sym_domain] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3507),
    [sym_enabled] = ACTIONS(3509),
    [sym_unchanged] = ACTIONS(3509),
    [anon_sym_LT_GT] = ACTIONS(3507),
    [anon_sym_u22c4] = ACTIONS(3507),
    [anon_sym_u25c7] = ACTIONS(3507),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3509),
    [anon_sym_ASSUMPTION] = ACTIONS(3509),
    [anon_sym_AXIOM] = ACTIONS(3509),
    [anon_sym_THEOREM] = ACTIONS(3509),
    [anon_sym_PROPOSITION] = ACTIONS(3509),
    [anon_sym_LEMMA] = ACTIONS(3509),
    [anon_sym_COROLLARY] = ACTIONS(3509),
    [anon_sym_PROOF] = ACTIONS(3509),
    [anon_sym_BY] = ACTIONS(3509),
    [anon_sym_OBVIOUS] = ACTIONS(3509),
    [anon_sym_OMITTED] = ACTIONS(3509),
    [anon_sym_USE] = ACTIONS(3509),
    [anon_sym_HIDE] = ACTIONS(3509),
    [sym__begin_proof] = ACTIONS(3507),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1166] = {
    [sym_block_comment] = STATE(1166),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3511),
    [sym_identifier] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3511),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3513),
    [anon_sym_VARIABLE] = ACTIONS(3513),
    [anon_sym_VARIABLES] = ACTIONS(3513),
    [anon_sym_CONSTANT] = ACTIONS(3513),
    [anon_sym_CONSTANTS] = ACTIONS(3513),
    [anon_sym_RECURSIVE] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3513),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3513),
    [anon_sym_u2115] = ACTIONS(3511),
    [anon_sym_Int] = ACTIONS(3513),
    [anon_sym_u2124] = ACTIONS(3511),
    [anon_sym_Real] = ACTIONS(3513),
    [anon_sym_u211d] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3511),
    [anon_sym_BSLASHneg] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3513),
    [anon_sym_u00ac] = ACTIONS(3511),
    [sym_union] = ACTIONS(3513),
    [sym_powerset] = ACTIONS(3513),
    [sym_domain] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3511),
    [sym_enabled] = ACTIONS(3513),
    [sym_unchanged] = ACTIONS(3513),
    [anon_sym_LT_GT] = ACTIONS(3511),
    [anon_sym_u22c4] = ACTIONS(3511),
    [anon_sym_u25c7] = ACTIONS(3511),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3513),
    [anon_sym_ASSUMPTION] = ACTIONS(3513),
    [anon_sym_AXIOM] = ACTIONS(3513),
    [anon_sym_THEOREM] = ACTIONS(3513),
    [anon_sym_PROPOSITION] = ACTIONS(3513),
    [anon_sym_LEMMA] = ACTIONS(3513),
    [anon_sym_COROLLARY] = ACTIONS(3513),
    [anon_sym_PROOF] = ACTIONS(3513),
    [anon_sym_BY] = ACTIONS(3513),
    [anon_sym_OBVIOUS] = ACTIONS(3513),
    [anon_sym_OMITTED] = ACTIONS(3513),
    [anon_sym_USE] = ACTIONS(3513),
    [anon_sym_HIDE] = ACTIONS(3513),
    [sym__begin_proof] = ACTIONS(3511),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1167] = {
    [sym_block_comment] = STATE(1167),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3515),
    [sym_identifier] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3515),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3517),
    [anon_sym_VARIABLE] = ACTIONS(3517),
    [anon_sym_VARIABLES] = ACTIONS(3517),
    [anon_sym_CONSTANT] = ACTIONS(3517),
    [anon_sym_CONSTANTS] = ACTIONS(3517),
    [anon_sym_RECURSIVE] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3517),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3517),
    [anon_sym_u2115] = ACTIONS(3515),
    [anon_sym_Int] = ACTIONS(3517),
    [anon_sym_u2124] = ACTIONS(3515),
    [anon_sym_Real] = ACTIONS(3517),
    [anon_sym_u211d] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3515),
    [anon_sym_BSLASHneg] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3517),
    [anon_sym_u00ac] = ACTIONS(3515),
    [sym_union] = ACTIONS(3517),
    [sym_powerset] = ACTIONS(3517),
    [sym_domain] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3515),
    [sym_enabled] = ACTIONS(3517),
    [sym_unchanged] = ACTIONS(3517),
    [anon_sym_LT_GT] = ACTIONS(3515),
    [anon_sym_u22c4] = ACTIONS(3515),
    [anon_sym_u25c7] = ACTIONS(3515),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3517),
    [anon_sym_ASSUMPTION] = ACTIONS(3517),
    [anon_sym_AXIOM] = ACTIONS(3517),
    [anon_sym_THEOREM] = ACTIONS(3517),
    [anon_sym_PROPOSITION] = ACTIONS(3517),
    [anon_sym_LEMMA] = ACTIONS(3517),
    [anon_sym_COROLLARY] = ACTIONS(3517),
    [anon_sym_PROOF] = ACTIONS(3517),
    [anon_sym_BY] = ACTIONS(3517),
    [anon_sym_OBVIOUS] = ACTIONS(3517),
    [anon_sym_OMITTED] = ACTIONS(3517),
    [anon_sym_USE] = ACTIONS(3517),
    [anon_sym_HIDE] = ACTIONS(3517),
    [sym__begin_proof] = ACTIONS(3515),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1168] = {
    [sym_block_comment] = STATE(1168),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3519),
    [sym_identifier] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3519),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3519),
    [anon_sym_u25a1] = ACTIONS(3519),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3521),
    [anon_sym_VARIABLE] = ACTIONS(3521),
    [anon_sym_VARIABLES] = ACTIONS(3521),
    [anon_sym_CONSTANT] = ACTIONS(3521),
    [anon_sym_CONSTANTS] = ACTIONS(3521),
    [anon_sym_RECURSIVE] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3521),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3521),
    [anon_sym_u2115] = ACTIONS(3519),
    [anon_sym_Int] = ACTIONS(3521),
    [anon_sym_u2124] = ACTIONS(3519),
    [anon_sym_Real] = ACTIONS(3521),
    [anon_sym_u211d] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3519),
    [anon_sym_BSLASHneg] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3521),
    [anon_sym_u00ac] = ACTIONS(3519),
    [sym_union] = ACTIONS(3521),
    [sym_powerset] = ACTIONS(3521),
    [sym_domain] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3519),
    [sym_enabled] = ACTIONS(3521),
    [sym_unchanged] = ACTIONS(3521),
    [anon_sym_LT_GT] = ACTIONS(3519),
    [anon_sym_u22c4] = ACTIONS(3519),
    [anon_sym_u25c7] = ACTIONS(3519),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3521),
    [anon_sym_ASSUMPTION] = ACTIONS(3521),
    [anon_sym_AXIOM] = ACTIONS(3521),
    [anon_sym_THEOREM] = ACTIONS(3521),
    [anon_sym_PROPOSITION] = ACTIONS(3521),
    [anon_sym_LEMMA] = ACTIONS(3521),
    [anon_sym_COROLLARY] = ACTIONS(3521),
    [anon_sym_PROOF] = ACTIONS(3521),
    [anon_sym_BY] = ACTIONS(3521),
    [anon_sym_OBVIOUS] = ACTIONS(3521),
    [anon_sym_OMITTED] = ACTIONS(3521),
    [anon_sym_USE] = ACTIONS(3521),
    [anon_sym_HIDE] = ACTIONS(3521),
    [sym__begin_proof] = ACTIONS(3519),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1169] = {
    [sym_block_comment] = STATE(1169),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3525),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3525),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3523),
    [anon_sym_VARIABLE] = ACTIONS(3523),
    [anon_sym_VARIABLES] = ACTIONS(3523),
    [anon_sym_CONSTANT] = ACTIONS(3523),
    [anon_sym_CONSTANTS] = ACTIONS(3523),
    [anon_sym_RECURSIVE] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3523),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3523),
    [anon_sym_u2115] = ACTIONS(3525),
    [anon_sym_Int] = ACTIONS(3523),
    [anon_sym_u2124] = ACTIONS(3525),
    [anon_sym_Real] = ACTIONS(3523),
    [anon_sym_u211d] = ACTIONS(3525),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3525),
    [anon_sym_BSLASHneg] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_u00ac] = ACTIONS(3525),
    [sym_union] = ACTIONS(3523),
    [sym_powerset] = ACTIONS(3523),
    [sym_domain] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3525),
    [sym_enabled] = ACTIONS(3523),
    [sym_unchanged] = ACTIONS(3523),
    [anon_sym_LT_GT] = ACTIONS(3525),
    [anon_sym_u22c4] = ACTIONS(3525),
    [anon_sym_u25c7] = ACTIONS(3525),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3523),
    [anon_sym_ASSUMPTION] = ACTIONS(3523),
    [anon_sym_AXIOM] = ACTIONS(3523),
    [anon_sym_THEOREM] = ACTIONS(3523),
    [anon_sym_PROPOSITION] = ACTIONS(3523),
    [anon_sym_LEMMA] = ACTIONS(3523),
    [anon_sym_COROLLARY] = ACTIONS(3523),
    [anon_sym_PROOF] = ACTIONS(3523),
    [anon_sym_BY] = ACTIONS(3523),
    [anon_sym_OBVIOUS] = ACTIONS(3523),
    [anon_sym_OMITTED] = ACTIONS(3523),
    [anon_sym_USE] = ACTIONS(3523),
    [anon_sym_HIDE] = ACTIONS(3523),
    [sym__begin_proof] = ACTIONS(3525),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1170] = {
    [sym_block_comment] = STATE(1170),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_PROOF] = ACTIONS(3497),
    [anon_sym_BY] = ACTIONS(3497),
    [anon_sym_OBVIOUS] = ACTIONS(3497),
    [anon_sym_OMITTED] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1171] = {
    [sym_block_comment] = STATE(1171),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3497),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_PROOF] = ACTIONS(3497),
    [anon_sym_BY] = ACTIONS(3497),
    [anon_sym_OBVIOUS] = ACTIONS(3497),
    [anon_sym_OMITTED] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1172] = {
    [sym_block_comment] = STATE(1172),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1173] = {
    [sym_block_comment] = STATE(1173),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3529),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3529),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3527),
    [anon_sym_VARIABLE] = ACTIONS(3527),
    [anon_sym_VARIABLES] = ACTIONS(3527),
    [anon_sym_CONSTANT] = ACTIONS(3527),
    [anon_sym_CONSTANTS] = ACTIONS(3527),
    [anon_sym_RECURSIVE] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3527),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3527),
    [anon_sym_u2115] = ACTIONS(3529),
    [anon_sym_Int] = ACTIONS(3527),
    [anon_sym_u2124] = ACTIONS(3529),
    [anon_sym_Real] = ACTIONS(3527),
    [anon_sym_u211d] = ACTIONS(3529),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3529),
    [anon_sym_BSLASHneg] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_u00ac] = ACTIONS(3529),
    [sym_union] = ACTIONS(3527),
    [sym_powerset] = ACTIONS(3527),
    [sym_domain] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3529),
    [sym_enabled] = ACTIONS(3527),
    [sym_unchanged] = ACTIONS(3527),
    [anon_sym_LT_GT] = ACTIONS(3529),
    [anon_sym_u22c4] = ACTIONS(3529),
    [anon_sym_u25c7] = ACTIONS(3529),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3527),
    [anon_sym_ASSUMPTION] = ACTIONS(3527),
    [anon_sym_AXIOM] = ACTIONS(3527),
    [anon_sym_THEOREM] = ACTIONS(3527),
    [anon_sym_PROPOSITION] = ACTIONS(3527),
    [anon_sym_LEMMA] = ACTIONS(3527),
    [anon_sym_COROLLARY] = ACTIONS(3527),
    [anon_sym_PROOF] = ACTIONS(3527),
    [anon_sym_BY] = ACTIONS(3527),
    [anon_sym_OBVIOUS] = ACTIONS(3527),
    [anon_sym_OMITTED] = ACTIONS(3527),
    [anon_sym_USE] = ACTIONS(3527),
    [anon_sym_HIDE] = ACTIONS(3527),
    [sym__begin_proof] = ACTIONS(3529),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1174] = {
    [sym_block_comment] = STATE(1174),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3499),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3499),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3501),
    [anon_sym_VARIABLE] = ACTIONS(3501),
    [anon_sym_VARIABLES] = ACTIONS(3501),
    [anon_sym_CONSTANT] = ACTIONS(3501),
    [anon_sym_CONSTANTS] = ACTIONS(3501),
    [anon_sym_RECURSIVE] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3501),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3501),
    [anon_sym_u2115] = ACTIONS(3499),
    [anon_sym_Int] = ACTIONS(3501),
    [anon_sym_u2124] = ACTIONS(3499),
    [anon_sym_Real] = ACTIONS(3501),
    [anon_sym_u211d] = ACTIONS(3499),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3499),
    [anon_sym_BSLASHneg] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_u00ac] = ACTIONS(3499),
    [sym_union] = ACTIONS(3501),
    [sym_powerset] = ACTIONS(3501),
    [sym_domain] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3499),
    [sym_enabled] = ACTIONS(3501),
    [sym_unchanged] = ACTIONS(3501),
    [anon_sym_LT_GT] = ACTIONS(3499),
    [anon_sym_u22c4] = ACTIONS(3499),
    [anon_sym_u25c7] = ACTIONS(3499),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3501),
    [anon_sym_ASSUMPTION] = ACTIONS(3501),
    [anon_sym_AXIOM] = ACTIONS(3501),
    [anon_sym_THEOREM] = ACTIONS(3501),
    [anon_sym_PROPOSITION] = ACTIONS(3501),
    [anon_sym_LEMMA] = ACTIONS(3501),
    [anon_sym_COROLLARY] = ACTIONS(3501),
    [anon_sym_PROOF] = ACTIONS(3501),
    [anon_sym_BY] = ACTIONS(3501),
    [anon_sym_OBVIOUS] = ACTIONS(3501),
    [anon_sym_OMITTED] = ACTIONS(3501),
    [anon_sym_USE] = ACTIONS(3501),
    [anon_sym_HIDE] = ACTIONS(3501),
    [sym__begin_proof] = ACTIONS(3499),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1175] = {
    [sym_block_comment] = STATE(1175),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3531),
    [sym_identifier] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3531),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3533),
    [anon_sym_VARIABLE] = ACTIONS(3533),
    [anon_sym_VARIABLES] = ACTIONS(3533),
    [anon_sym_CONSTANT] = ACTIONS(3533),
    [anon_sym_CONSTANTS] = ACTIONS(3533),
    [anon_sym_RECURSIVE] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3533),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3533),
    [anon_sym_u2115] = ACTIONS(3531),
    [anon_sym_Int] = ACTIONS(3533),
    [anon_sym_u2124] = ACTIONS(3531),
    [anon_sym_Real] = ACTIONS(3533),
    [anon_sym_u211d] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3531),
    [anon_sym_BSLASHneg] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_u00ac] = ACTIONS(3531),
    [sym_union] = ACTIONS(3533),
    [sym_powerset] = ACTIONS(3533),
    [sym_domain] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3531),
    [sym_enabled] = ACTIONS(3533),
    [sym_unchanged] = ACTIONS(3533),
    [anon_sym_LT_GT] = ACTIONS(3531),
    [anon_sym_u22c4] = ACTIONS(3531),
    [anon_sym_u25c7] = ACTIONS(3531),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3533),
    [anon_sym_ASSUMPTION] = ACTIONS(3533),
    [anon_sym_AXIOM] = ACTIONS(3533),
    [anon_sym_THEOREM] = ACTIONS(3533),
    [anon_sym_PROPOSITION] = ACTIONS(3533),
    [anon_sym_LEMMA] = ACTIONS(3533),
    [anon_sym_COROLLARY] = ACTIONS(3533),
    [anon_sym_PROOF] = ACTIONS(3533),
    [anon_sym_BY] = ACTIONS(3533),
    [anon_sym_OBVIOUS] = ACTIONS(3533),
    [anon_sym_OMITTED] = ACTIONS(3533),
    [anon_sym_USE] = ACTIONS(3533),
    [anon_sym_HIDE] = ACTIONS(3533),
    [sym__begin_proof] = ACTIONS(3531),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1176] = {
    [sym_block_comment] = STATE(1176),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3503),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3503),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3505),
    [anon_sym_VARIABLE] = ACTIONS(3505),
    [anon_sym_VARIABLES] = ACTIONS(3505),
    [anon_sym_CONSTANT] = ACTIONS(3505),
    [anon_sym_CONSTANTS] = ACTIONS(3505),
    [anon_sym_RECURSIVE] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3505),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3505),
    [anon_sym_u2115] = ACTIONS(3503),
    [anon_sym_Int] = ACTIONS(3505),
    [anon_sym_u2124] = ACTIONS(3503),
    [anon_sym_Real] = ACTIONS(3505),
    [anon_sym_u211d] = ACTIONS(3503),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3503),
    [anon_sym_BSLASHneg] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_u00ac] = ACTIONS(3503),
    [sym_union] = ACTIONS(3505),
    [sym_powerset] = ACTIONS(3505),
    [sym_domain] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3503),
    [sym_enabled] = ACTIONS(3505),
    [sym_unchanged] = ACTIONS(3505),
    [anon_sym_LT_GT] = ACTIONS(3503),
    [anon_sym_u22c4] = ACTIONS(3503),
    [anon_sym_u25c7] = ACTIONS(3503),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3505),
    [anon_sym_ASSUMPTION] = ACTIONS(3505),
    [anon_sym_AXIOM] = ACTIONS(3505),
    [anon_sym_THEOREM] = ACTIONS(3505),
    [anon_sym_PROPOSITION] = ACTIONS(3505),
    [anon_sym_LEMMA] = ACTIONS(3505),
    [anon_sym_COROLLARY] = ACTIONS(3505),
    [anon_sym_PROOF] = ACTIONS(3505),
    [anon_sym_BY] = ACTIONS(3505),
    [anon_sym_OBVIOUS] = ACTIONS(3505),
    [anon_sym_OMITTED] = ACTIONS(3505),
    [anon_sym_USE] = ACTIONS(3505),
    [anon_sym_HIDE] = ACTIONS(3505),
    [sym__begin_proof] = ACTIONS(3503),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1177] = {
    [sym_block_comment] = STATE(1177),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3507),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3507),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3509),
    [anon_sym_VARIABLE] = ACTIONS(3509),
    [anon_sym_VARIABLES] = ACTIONS(3509),
    [anon_sym_CONSTANT] = ACTIONS(3509),
    [anon_sym_CONSTANTS] = ACTIONS(3509),
    [anon_sym_RECURSIVE] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3509),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3509),
    [anon_sym_u2115] = ACTIONS(3507),
    [anon_sym_Int] = ACTIONS(3509),
    [anon_sym_u2124] = ACTIONS(3507),
    [anon_sym_Real] = ACTIONS(3509),
    [anon_sym_u211d] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3507),
    [anon_sym_BSLASHneg] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [anon_sym_u00ac] = ACTIONS(3507),
    [sym_union] = ACTIONS(3509),
    [sym_powerset] = ACTIONS(3509),
    [sym_domain] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3507),
    [sym_enabled] = ACTIONS(3509),
    [sym_unchanged] = ACTIONS(3509),
    [anon_sym_LT_GT] = ACTIONS(3507),
    [anon_sym_u22c4] = ACTIONS(3507),
    [anon_sym_u25c7] = ACTIONS(3507),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3509),
    [anon_sym_ASSUMPTION] = ACTIONS(3509),
    [anon_sym_AXIOM] = ACTIONS(3509),
    [anon_sym_THEOREM] = ACTIONS(3509),
    [anon_sym_PROPOSITION] = ACTIONS(3509),
    [anon_sym_LEMMA] = ACTIONS(3509),
    [anon_sym_COROLLARY] = ACTIONS(3509),
    [anon_sym_PROOF] = ACTIONS(3509),
    [anon_sym_BY] = ACTIONS(3509),
    [anon_sym_OBVIOUS] = ACTIONS(3509),
    [anon_sym_OMITTED] = ACTIONS(3509),
    [anon_sym_USE] = ACTIONS(3509),
    [anon_sym_HIDE] = ACTIONS(3509),
    [sym__begin_proof] = ACTIONS(3507),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1178] = {
    [sym_block_comment] = STATE(1178),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3515),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3515),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3517),
    [anon_sym_VARIABLE] = ACTIONS(3517),
    [anon_sym_VARIABLES] = ACTIONS(3517),
    [anon_sym_CONSTANT] = ACTIONS(3517),
    [anon_sym_CONSTANTS] = ACTIONS(3517),
    [anon_sym_RECURSIVE] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3517),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3517),
    [anon_sym_u2115] = ACTIONS(3515),
    [anon_sym_Int] = ACTIONS(3517),
    [anon_sym_u2124] = ACTIONS(3515),
    [anon_sym_Real] = ACTIONS(3517),
    [anon_sym_u211d] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3515),
    [anon_sym_BSLASHneg] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3517),
    [anon_sym_u00ac] = ACTIONS(3515),
    [sym_union] = ACTIONS(3517),
    [sym_powerset] = ACTIONS(3517),
    [sym_domain] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3515),
    [sym_enabled] = ACTIONS(3517),
    [sym_unchanged] = ACTIONS(3517),
    [anon_sym_LT_GT] = ACTIONS(3515),
    [anon_sym_u22c4] = ACTIONS(3515),
    [anon_sym_u25c7] = ACTIONS(3515),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3517),
    [anon_sym_ASSUMPTION] = ACTIONS(3517),
    [anon_sym_AXIOM] = ACTIONS(3517),
    [anon_sym_THEOREM] = ACTIONS(3517),
    [anon_sym_PROPOSITION] = ACTIONS(3517),
    [anon_sym_LEMMA] = ACTIONS(3517),
    [anon_sym_COROLLARY] = ACTIONS(3517),
    [anon_sym_PROOF] = ACTIONS(3517),
    [anon_sym_BY] = ACTIONS(3517),
    [anon_sym_OBVIOUS] = ACTIONS(3517),
    [anon_sym_OMITTED] = ACTIONS(3517),
    [anon_sym_USE] = ACTIONS(3517),
    [anon_sym_HIDE] = ACTIONS(3517),
    [sym__begin_proof] = ACTIONS(3515),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1179] = {
    [sym_block_comment] = STATE(1179),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1180] = {
    [sym_block_comment] = STATE(1180),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3537),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3537),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3535),
    [anon_sym_VARIABLE] = ACTIONS(3535),
    [anon_sym_VARIABLES] = ACTIONS(3535),
    [anon_sym_CONSTANT] = ACTIONS(3535),
    [anon_sym_CONSTANTS] = ACTIONS(3535),
    [anon_sym_RECURSIVE] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3535),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3535),
    [anon_sym_u2115] = ACTIONS(3537),
    [anon_sym_Int] = ACTIONS(3535),
    [anon_sym_u2124] = ACTIONS(3537),
    [anon_sym_Real] = ACTIONS(3535),
    [anon_sym_u211d] = ACTIONS(3537),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3537),
    [anon_sym_BSLASHneg] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3535),
    [anon_sym_u00ac] = ACTIONS(3537),
    [sym_union] = ACTIONS(3535),
    [sym_powerset] = ACTIONS(3535),
    [sym_domain] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3537),
    [sym_enabled] = ACTIONS(3535),
    [sym_unchanged] = ACTIONS(3535),
    [anon_sym_LT_GT] = ACTIONS(3537),
    [anon_sym_u22c4] = ACTIONS(3537),
    [anon_sym_u25c7] = ACTIONS(3537),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3535),
    [anon_sym_ASSUMPTION] = ACTIONS(3535),
    [anon_sym_AXIOM] = ACTIONS(3535),
    [anon_sym_THEOREM] = ACTIONS(3535),
    [anon_sym_PROPOSITION] = ACTIONS(3535),
    [anon_sym_LEMMA] = ACTIONS(3535),
    [anon_sym_COROLLARY] = ACTIONS(3535),
    [anon_sym_PROOF] = ACTIONS(3535),
    [anon_sym_BY] = ACTIONS(3535),
    [anon_sym_OBVIOUS] = ACTIONS(3535),
    [anon_sym_OMITTED] = ACTIONS(3535),
    [anon_sym_USE] = ACTIONS(3535),
    [anon_sym_HIDE] = ACTIONS(3535),
    [sym__begin_proof] = ACTIONS(3537),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1181] = {
    [sym_block_comment] = STATE(1181),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1182] = {
    [sym_block_comment] = STATE(1182),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1183] = {
    [sym_block_comment] = STATE(1183),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1184] = {
    [sym_block_comment] = STATE(1184),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3493),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1185] = {
    [sym_block_comment] = STATE(1185),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3493),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1186] = {
    [sym_block_comment] = STATE(1186),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3493),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1187] = {
    [sym_block_comment] = STATE(1187),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1188] = {
    [sym_block_comment] = STATE(1188),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1189] = {
    [sym_block_comment] = STATE(1189),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1190] = {
    [sym_block_comment] = STATE(1190),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1191] = {
    [sym_block_comment] = STATE(1191),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3541),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3541),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3539),
    [anon_sym_VARIABLE] = ACTIONS(3539),
    [anon_sym_VARIABLES] = ACTIONS(3539),
    [anon_sym_CONSTANT] = ACTIONS(3539),
    [anon_sym_CONSTANTS] = ACTIONS(3539),
    [anon_sym_RECURSIVE] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3539),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3539),
    [anon_sym_u2115] = ACTIONS(3541),
    [anon_sym_Int] = ACTIONS(3539),
    [anon_sym_u2124] = ACTIONS(3541),
    [anon_sym_Real] = ACTIONS(3539),
    [anon_sym_u211d] = ACTIONS(3541),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3541),
    [anon_sym_BSLASHneg] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_u00ac] = ACTIONS(3541),
    [sym_union] = ACTIONS(3539),
    [sym_powerset] = ACTIONS(3539),
    [sym_domain] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3541),
    [sym_enabled] = ACTIONS(3539),
    [sym_unchanged] = ACTIONS(3539),
    [anon_sym_LT_GT] = ACTIONS(3541),
    [anon_sym_u22c4] = ACTIONS(3541),
    [anon_sym_u25c7] = ACTIONS(3541),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3539),
    [anon_sym_ASSUMPTION] = ACTIONS(3539),
    [anon_sym_AXIOM] = ACTIONS(3539),
    [anon_sym_THEOREM] = ACTIONS(3539),
    [anon_sym_PROPOSITION] = ACTIONS(3539),
    [anon_sym_LEMMA] = ACTIONS(3539),
    [anon_sym_COROLLARY] = ACTIONS(3539),
    [anon_sym_PROOF] = ACTIONS(3539),
    [anon_sym_BY] = ACTIONS(3539),
    [anon_sym_OBVIOUS] = ACTIONS(3539),
    [anon_sym_OMITTED] = ACTIONS(3539),
    [anon_sym_USE] = ACTIONS(3539),
    [anon_sym_HIDE] = ACTIONS(3539),
    [sym__begin_proof] = ACTIONS(3541),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1192] = {
    [sym_block_comment] = STATE(1192),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3545),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3545),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3543),
    [anon_sym_VARIABLE] = ACTIONS(3543),
    [anon_sym_VARIABLES] = ACTIONS(3543),
    [anon_sym_CONSTANT] = ACTIONS(3543),
    [anon_sym_CONSTANTS] = ACTIONS(3543),
    [anon_sym_RECURSIVE] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3543),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3543),
    [anon_sym_u2115] = ACTIONS(3545),
    [anon_sym_Int] = ACTIONS(3543),
    [anon_sym_u2124] = ACTIONS(3545),
    [anon_sym_Real] = ACTIONS(3543),
    [anon_sym_u211d] = ACTIONS(3545),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3545),
    [anon_sym_BSLASHneg] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3543),
    [anon_sym_u00ac] = ACTIONS(3545),
    [sym_union] = ACTIONS(3543),
    [sym_powerset] = ACTIONS(3543),
    [sym_domain] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3545),
    [sym_enabled] = ACTIONS(3543),
    [sym_unchanged] = ACTIONS(3543),
    [anon_sym_LT_GT] = ACTIONS(3545),
    [anon_sym_u22c4] = ACTIONS(3545),
    [anon_sym_u25c7] = ACTIONS(3545),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3543),
    [anon_sym_ASSUMPTION] = ACTIONS(3543),
    [anon_sym_AXIOM] = ACTIONS(3543),
    [anon_sym_THEOREM] = ACTIONS(3543),
    [anon_sym_PROPOSITION] = ACTIONS(3543),
    [anon_sym_LEMMA] = ACTIONS(3543),
    [anon_sym_COROLLARY] = ACTIONS(3543),
    [anon_sym_PROOF] = ACTIONS(3543),
    [anon_sym_BY] = ACTIONS(3543),
    [anon_sym_OBVIOUS] = ACTIONS(3543),
    [anon_sym_OMITTED] = ACTIONS(3543),
    [anon_sym_USE] = ACTIONS(3543),
    [anon_sym_HIDE] = ACTIONS(3543),
    [sym__begin_proof] = ACTIONS(3545),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1193] = {
    [sym_block_comment] = STATE(1193),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3519),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3519),
    [anon_sym_u25a1] = ACTIONS(3519),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3521),
    [anon_sym_VARIABLE] = ACTIONS(3521),
    [anon_sym_VARIABLES] = ACTIONS(3521),
    [anon_sym_CONSTANT] = ACTIONS(3521),
    [anon_sym_CONSTANTS] = ACTIONS(3521),
    [anon_sym_RECURSIVE] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3521),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3521),
    [anon_sym_u2115] = ACTIONS(3519),
    [anon_sym_Int] = ACTIONS(3521),
    [anon_sym_u2124] = ACTIONS(3519),
    [anon_sym_Real] = ACTIONS(3521),
    [anon_sym_u211d] = ACTIONS(3519),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3519),
    [anon_sym_BSLASHneg] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3521),
    [anon_sym_u00ac] = ACTIONS(3519),
    [sym_union] = ACTIONS(3521),
    [sym_powerset] = ACTIONS(3521),
    [sym_domain] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3519),
    [sym_enabled] = ACTIONS(3521),
    [sym_unchanged] = ACTIONS(3521),
    [anon_sym_LT_GT] = ACTIONS(3519),
    [anon_sym_u22c4] = ACTIONS(3519),
    [anon_sym_u25c7] = ACTIONS(3519),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3521),
    [anon_sym_ASSUMPTION] = ACTIONS(3521),
    [anon_sym_AXIOM] = ACTIONS(3521),
    [anon_sym_THEOREM] = ACTIONS(3521),
    [anon_sym_PROPOSITION] = ACTIONS(3521),
    [anon_sym_LEMMA] = ACTIONS(3521),
    [anon_sym_COROLLARY] = ACTIONS(3521),
    [anon_sym_PROOF] = ACTIONS(3521),
    [anon_sym_BY] = ACTIONS(3521),
    [anon_sym_OBVIOUS] = ACTIONS(3521),
    [anon_sym_OMITTED] = ACTIONS(3521),
    [anon_sym_USE] = ACTIONS(3521),
    [anon_sym_HIDE] = ACTIONS(3521),
    [sym__begin_proof] = ACTIONS(3519),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1194] = {
    [sym_block_comment] = STATE(1194),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3497),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_PROOF] = ACTIONS(3497),
    [anon_sym_BY] = ACTIONS(3497),
    [anon_sym_OBVIOUS] = ACTIONS(3497),
    [anon_sym_OMITTED] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1195] = {
    [sym_block_comment] = STATE(1195),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3497),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_PROOF] = ACTIONS(3497),
    [anon_sym_BY] = ACTIONS(3497),
    [anon_sym_OBVIOUS] = ACTIONS(3497),
    [anon_sym_OMITTED] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1196] = {
    [sym_block_comment] = STATE(1196),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3549),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_u25a1] = ACTIONS(3549),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3547),
    [anon_sym_VARIABLE] = ACTIONS(3547),
    [anon_sym_VARIABLES] = ACTIONS(3547),
    [anon_sym_CONSTANT] = ACTIONS(3547),
    [anon_sym_CONSTANTS] = ACTIONS(3547),
    [anon_sym_RECURSIVE] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3547),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3547),
    [anon_sym_u2115] = ACTIONS(3549),
    [anon_sym_Int] = ACTIONS(3547),
    [anon_sym_u2124] = ACTIONS(3549),
    [anon_sym_Real] = ACTIONS(3547),
    [anon_sym_u211d] = ACTIONS(3549),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3549),
    [anon_sym_BSLASHneg] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3547),
    [anon_sym_u00ac] = ACTIONS(3549),
    [sym_union] = ACTIONS(3547),
    [sym_powerset] = ACTIONS(3547),
    [sym_domain] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3549),
    [sym_enabled] = ACTIONS(3547),
    [sym_unchanged] = ACTIONS(3547),
    [anon_sym_LT_GT] = ACTIONS(3549),
    [anon_sym_u22c4] = ACTIONS(3549),
    [anon_sym_u25c7] = ACTIONS(3549),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3547),
    [anon_sym_ASSUMPTION] = ACTIONS(3547),
    [anon_sym_AXIOM] = ACTIONS(3547),
    [anon_sym_THEOREM] = ACTIONS(3547),
    [anon_sym_PROPOSITION] = ACTIONS(3547),
    [anon_sym_LEMMA] = ACTIONS(3547),
    [anon_sym_COROLLARY] = ACTIONS(3547),
    [anon_sym_PROOF] = ACTIONS(3547),
    [anon_sym_BY] = ACTIONS(3547),
    [anon_sym_OBVIOUS] = ACTIONS(3547),
    [anon_sym_OMITTED] = ACTIONS(3547),
    [anon_sym_USE] = ACTIONS(3547),
    [anon_sym_HIDE] = ACTIONS(3547),
    [sym__begin_proof] = ACTIONS(3549),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1197] = {
    [sym_block_comment] = STATE(1197),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3537),
    [sym_identifier] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3537),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3535),
    [anon_sym_VARIABLE] = ACTIONS(3535),
    [anon_sym_VARIABLES] = ACTIONS(3535),
    [anon_sym_CONSTANT] = ACTIONS(3535),
    [anon_sym_CONSTANTS] = ACTIONS(3535),
    [anon_sym_RECURSIVE] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3535),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3535),
    [anon_sym_u2115] = ACTIONS(3537),
    [anon_sym_Int] = ACTIONS(3535),
    [anon_sym_u2124] = ACTIONS(3537),
    [anon_sym_Real] = ACTIONS(3535),
    [anon_sym_u211d] = ACTIONS(3537),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3537),
    [anon_sym_BSLASHneg] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3535),
    [anon_sym_u00ac] = ACTIONS(3537),
    [sym_union] = ACTIONS(3535),
    [sym_powerset] = ACTIONS(3535),
    [sym_domain] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3537),
    [sym_enabled] = ACTIONS(3535),
    [sym_unchanged] = ACTIONS(3535),
    [anon_sym_LT_GT] = ACTIONS(3537),
    [anon_sym_u22c4] = ACTIONS(3537),
    [anon_sym_u25c7] = ACTIONS(3537),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3535),
    [anon_sym_ASSUMPTION] = ACTIONS(3535),
    [anon_sym_AXIOM] = ACTIONS(3535),
    [anon_sym_THEOREM] = ACTIONS(3535),
    [anon_sym_PROPOSITION] = ACTIONS(3535),
    [anon_sym_LEMMA] = ACTIONS(3535),
    [anon_sym_COROLLARY] = ACTIONS(3535),
    [anon_sym_PROOF] = ACTIONS(3535),
    [anon_sym_BY] = ACTIONS(3535),
    [anon_sym_OBVIOUS] = ACTIONS(3535),
    [anon_sym_OMITTED] = ACTIONS(3535),
    [anon_sym_USE] = ACTIONS(3535),
    [anon_sym_HIDE] = ACTIONS(3535),
    [sym__begin_proof] = ACTIONS(3537),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1198] = {
    [sym_block_comment] = STATE(1198),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3549),
    [sym_identifier] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3549),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3549),
    [anon_sym_u25a1] = ACTIONS(3549),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3547),
    [anon_sym_VARIABLE] = ACTIONS(3547),
    [anon_sym_VARIABLES] = ACTIONS(3547),
    [anon_sym_CONSTANT] = ACTIONS(3547),
    [anon_sym_CONSTANTS] = ACTIONS(3547),
    [anon_sym_RECURSIVE] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3547),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3547),
    [anon_sym_u2115] = ACTIONS(3549),
    [anon_sym_Int] = ACTIONS(3547),
    [anon_sym_u2124] = ACTIONS(3549),
    [anon_sym_Real] = ACTIONS(3547),
    [anon_sym_u211d] = ACTIONS(3549),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3549),
    [anon_sym_BSLASHneg] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3547),
    [anon_sym_u00ac] = ACTIONS(3549),
    [sym_union] = ACTIONS(3547),
    [sym_powerset] = ACTIONS(3547),
    [sym_domain] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3549),
    [sym_enabled] = ACTIONS(3547),
    [sym_unchanged] = ACTIONS(3547),
    [anon_sym_LT_GT] = ACTIONS(3549),
    [anon_sym_u22c4] = ACTIONS(3549),
    [anon_sym_u25c7] = ACTIONS(3549),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3547),
    [anon_sym_ASSUMPTION] = ACTIONS(3547),
    [anon_sym_AXIOM] = ACTIONS(3547),
    [anon_sym_THEOREM] = ACTIONS(3547),
    [anon_sym_PROPOSITION] = ACTIONS(3547),
    [anon_sym_LEMMA] = ACTIONS(3547),
    [anon_sym_COROLLARY] = ACTIONS(3547),
    [anon_sym_PROOF] = ACTIONS(3547),
    [anon_sym_BY] = ACTIONS(3547),
    [anon_sym_OBVIOUS] = ACTIONS(3547),
    [anon_sym_OMITTED] = ACTIONS(3547),
    [anon_sym_USE] = ACTIONS(3547),
    [anon_sym_HIDE] = ACTIONS(3547),
    [sym__begin_proof] = ACTIONS(3549),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1199] = {
    [sym_block_comment] = STATE(1199),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3553),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3553),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3551),
    [anon_sym_VARIABLE] = ACTIONS(3551),
    [anon_sym_VARIABLES] = ACTIONS(3551),
    [anon_sym_CONSTANT] = ACTIONS(3551),
    [anon_sym_CONSTANTS] = ACTIONS(3551),
    [anon_sym_RECURSIVE] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3551),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3551),
    [anon_sym_u2115] = ACTIONS(3553),
    [anon_sym_Int] = ACTIONS(3551),
    [anon_sym_u2124] = ACTIONS(3553),
    [anon_sym_Real] = ACTIONS(3551),
    [anon_sym_u211d] = ACTIONS(3553),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3553),
    [anon_sym_BSLASHneg] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3551),
    [anon_sym_u00ac] = ACTIONS(3553),
    [sym_union] = ACTIONS(3551),
    [sym_powerset] = ACTIONS(3551),
    [sym_domain] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3553),
    [sym_enabled] = ACTIONS(3551),
    [sym_unchanged] = ACTIONS(3551),
    [anon_sym_LT_GT] = ACTIONS(3553),
    [anon_sym_u22c4] = ACTIONS(3553),
    [anon_sym_u25c7] = ACTIONS(3553),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3551),
    [anon_sym_ASSUMPTION] = ACTIONS(3551),
    [anon_sym_AXIOM] = ACTIONS(3551),
    [anon_sym_THEOREM] = ACTIONS(3551),
    [anon_sym_PROPOSITION] = ACTIONS(3551),
    [anon_sym_LEMMA] = ACTIONS(3551),
    [anon_sym_COROLLARY] = ACTIONS(3551),
    [anon_sym_PROOF] = ACTIONS(3551),
    [anon_sym_BY] = ACTIONS(3551),
    [anon_sym_OBVIOUS] = ACTIONS(3551),
    [anon_sym_OMITTED] = ACTIONS(3551),
    [anon_sym_USE] = ACTIONS(3551),
    [anon_sym_HIDE] = ACTIONS(3551),
    [sym__begin_proof] = ACTIONS(3553),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1200] = {
    [sym_block_comment] = STATE(1200),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3525),
    [sym_identifier] = ACTIONS(3523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3525),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3523),
    [anon_sym_VARIABLE] = ACTIONS(3523),
    [anon_sym_VARIABLES] = ACTIONS(3523),
    [anon_sym_CONSTANT] = ACTIONS(3523),
    [anon_sym_CONSTANTS] = ACTIONS(3523),
    [anon_sym_RECURSIVE] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3523),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3523),
    [anon_sym_u2115] = ACTIONS(3525),
    [anon_sym_Int] = ACTIONS(3523),
    [anon_sym_u2124] = ACTIONS(3525),
    [anon_sym_Real] = ACTIONS(3523),
    [anon_sym_u211d] = ACTIONS(3525),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3525),
    [anon_sym_BSLASHneg] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_u00ac] = ACTIONS(3525),
    [sym_union] = ACTIONS(3523),
    [sym_powerset] = ACTIONS(3523),
    [sym_domain] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3525),
    [sym_enabled] = ACTIONS(3523),
    [sym_unchanged] = ACTIONS(3523),
    [anon_sym_LT_GT] = ACTIONS(3525),
    [anon_sym_u22c4] = ACTIONS(3525),
    [anon_sym_u25c7] = ACTIONS(3525),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3523),
    [anon_sym_ASSUMPTION] = ACTIONS(3523),
    [anon_sym_AXIOM] = ACTIONS(3523),
    [anon_sym_THEOREM] = ACTIONS(3523),
    [anon_sym_PROPOSITION] = ACTIONS(3523),
    [anon_sym_LEMMA] = ACTIONS(3523),
    [anon_sym_COROLLARY] = ACTIONS(3523),
    [anon_sym_PROOF] = ACTIONS(3523),
    [anon_sym_BY] = ACTIONS(3523),
    [anon_sym_OBVIOUS] = ACTIONS(3523),
    [anon_sym_OMITTED] = ACTIONS(3523),
    [anon_sym_USE] = ACTIONS(3523),
    [anon_sym_HIDE] = ACTIONS(3523),
    [sym__begin_proof] = ACTIONS(3525),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1201] = {
    [sym_block_comment] = STATE(1201),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_PROOF] = ACTIONS(3497),
    [anon_sym_BY] = ACTIONS(3497),
    [anon_sym_OBVIOUS] = ACTIONS(3497),
    [anon_sym_OMITTED] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1202] = {
    [sym_block_comment] = STATE(1202),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3557),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3557),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3555),
    [anon_sym_VARIABLE] = ACTIONS(3555),
    [anon_sym_VARIABLES] = ACTIONS(3555),
    [anon_sym_CONSTANT] = ACTIONS(3555),
    [anon_sym_CONSTANTS] = ACTIONS(3555),
    [anon_sym_RECURSIVE] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3555),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3555),
    [anon_sym_u2115] = ACTIONS(3557),
    [anon_sym_Int] = ACTIONS(3555),
    [anon_sym_u2124] = ACTIONS(3557),
    [anon_sym_Real] = ACTIONS(3555),
    [anon_sym_u211d] = ACTIONS(3557),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3557),
    [anon_sym_BSLASHneg] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3555),
    [anon_sym_u00ac] = ACTIONS(3557),
    [sym_union] = ACTIONS(3555),
    [sym_powerset] = ACTIONS(3555),
    [sym_domain] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3557),
    [sym_enabled] = ACTIONS(3555),
    [sym_unchanged] = ACTIONS(3555),
    [anon_sym_LT_GT] = ACTIONS(3557),
    [anon_sym_u22c4] = ACTIONS(3557),
    [anon_sym_u25c7] = ACTIONS(3557),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3555),
    [anon_sym_ASSUMPTION] = ACTIONS(3555),
    [anon_sym_AXIOM] = ACTIONS(3555),
    [anon_sym_THEOREM] = ACTIONS(3555),
    [anon_sym_PROPOSITION] = ACTIONS(3555),
    [anon_sym_LEMMA] = ACTIONS(3555),
    [anon_sym_COROLLARY] = ACTIONS(3555),
    [anon_sym_PROOF] = ACTIONS(3555),
    [anon_sym_BY] = ACTIONS(3555),
    [anon_sym_OBVIOUS] = ACTIONS(3555),
    [anon_sym_OMITTED] = ACTIONS(3555),
    [anon_sym_USE] = ACTIONS(3555),
    [anon_sym_HIDE] = ACTIONS(3555),
    [sym__begin_proof] = ACTIONS(3557),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1203] = {
    [sym_block_comment] = STATE(1203),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3541),
    [sym_identifier] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3541),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3539),
    [anon_sym_VARIABLE] = ACTIONS(3539),
    [anon_sym_VARIABLES] = ACTIONS(3539),
    [anon_sym_CONSTANT] = ACTIONS(3539),
    [anon_sym_CONSTANTS] = ACTIONS(3539),
    [anon_sym_RECURSIVE] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3539),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3539),
    [anon_sym_u2115] = ACTIONS(3541),
    [anon_sym_Int] = ACTIONS(3539),
    [anon_sym_u2124] = ACTIONS(3541),
    [anon_sym_Real] = ACTIONS(3539),
    [anon_sym_u211d] = ACTIONS(3541),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3541),
    [anon_sym_BSLASHneg] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_u00ac] = ACTIONS(3541),
    [sym_union] = ACTIONS(3539),
    [sym_powerset] = ACTIONS(3539),
    [sym_domain] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3541),
    [sym_enabled] = ACTIONS(3539),
    [sym_unchanged] = ACTIONS(3539),
    [anon_sym_LT_GT] = ACTIONS(3541),
    [anon_sym_u22c4] = ACTIONS(3541),
    [anon_sym_u25c7] = ACTIONS(3541),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3539),
    [anon_sym_ASSUMPTION] = ACTIONS(3539),
    [anon_sym_AXIOM] = ACTIONS(3539),
    [anon_sym_THEOREM] = ACTIONS(3539),
    [anon_sym_PROPOSITION] = ACTIONS(3539),
    [anon_sym_LEMMA] = ACTIONS(3539),
    [anon_sym_COROLLARY] = ACTIONS(3539),
    [anon_sym_PROOF] = ACTIONS(3539),
    [anon_sym_BY] = ACTIONS(3539),
    [anon_sym_OBVIOUS] = ACTIONS(3539),
    [anon_sym_OMITTED] = ACTIONS(3539),
    [anon_sym_USE] = ACTIONS(3539),
    [anon_sym_HIDE] = ACTIONS(3539),
    [sym__begin_proof] = ACTIONS(3541),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1204] = {
    [sym_block_comment] = STATE(1204),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3545),
    [sym_identifier] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3545),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3543),
    [anon_sym_VARIABLE] = ACTIONS(3543),
    [anon_sym_VARIABLES] = ACTIONS(3543),
    [anon_sym_CONSTANT] = ACTIONS(3543),
    [anon_sym_CONSTANTS] = ACTIONS(3543),
    [anon_sym_RECURSIVE] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3543),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3543),
    [anon_sym_u2115] = ACTIONS(3545),
    [anon_sym_Int] = ACTIONS(3543),
    [anon_sym_u2124] = ACTIONS(3545),
    [anon_sym_Real] = ACTIONS(3543),
    [anon_sym_u211d] = ACTIONS(3545),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3545),
    [anon_sym_BSLASHneg] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3543),
    [anon_sym_u00ac] = ACTIONS(3545),
    [sym_union] = ACTIONS(3543),
    [sym_powerset] = ACTIONS(3543),
    [sym_domain] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3545),
    [sym_enabled] = ACTIONS(3543),
    [sym_unchanged] = ACTIONS(3543),
    [anon_sym_LT_GT] = ACTIONS(3545),
    [anon_sym_u22c4] = ACTIONS(3545),
    [anon_sym_u25c7] = ACTIONS(3545),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3543),
    [anon_sym_ASSUMPTION] = ACTIONS(3543),
    [anon_sym_AXIOM] = ACTIONS(3543),
    [anon_sym_THEOREM] = ACTIONS(3543),
    [anon_sym_PROPOSITION] = ACTIONS(3543),
    [anon_sym_LEMMA] = ACTIONS(3543),
    [anon_sym_COROLLARY] = ACTIONS(3543),
    [anon_sym_PROOF] = ACTIONS(3543),
    [anon_sym_BY] = ACTIONS(3543),
    [anon_sym_OBVIOUS] = ACTIONS(3543),
    [anon_sym_OMITTED] = ACTIONS(3543),
    [anon_sym_USE] = ACTIONS(3543),
    [anon_sym_HIDE] = ACTIONS(3543),
    [sym__begin_proof] = ACTIONS(3545),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1205] = {
    [sym_block_comment] = STATE(1205),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3497),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_PROOF] = ACTIONS(3497),
    [anon_sym_BY] = ACTIONS(3497),
    [anon_sym_OBVIOUS] = ACTIONS(3497),
    [anon_sym_OMITTED] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1206] = {
    [sym_block_comment] = STATE(1206),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3533),
    [anon_sym_VARIABLE] = ACTIONS(3533),
    [anon_sym_VARIABLES] = ACTIONS(3533),
    [anon_sym_CONSTANT] = ACTIONS(3533),
    [anon_sym_CONSTANTS] = ACTIONS(3533),
    [anon_sym_RECURSIVE] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3533),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3533),
    [anon_sym_u2115] = ACTIONS(3531),
    [anon_sym_Int] = ACTIONS(3533),
    [anon_sym_u2124] = ACTIONS(3531),
    [anon_sym_Real] = ACTIONS(3533),
    [anon_sym_u211d] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3531),
    [anon_sym_BSLASHneg] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_u00ac] = ACTIONS(3531),
    [sym_union] = ACTIONS(3533),
    [sym_powerset] = ACTIONS(3533),
    [sym_domain] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3531),
    [sym_enabled] = ACTIONS(3533),
    [sym_unchanged] = ACTIONS(3533),
    [anon_sym_LT_GT] = ACTIONS(3531),
    [anon_sym_u22c4] = ACTIONS(3531),
    [anon_sym_u25c7] = ACTIONS(3531),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3533),
    [anon_sym_ASSUMPTION] = ACTIONS(3533),
    [anon_sym_AXIOM] = ACTIONS(3533),
    [anon_sym_THEOREM] = ACTIONS(3533),
    [anon_sym_PROPOSITION] = ACTIONS(3533),
    [anon_sym_LEMMA] = ACTIONS(3533),
    [anon_sym_COROLLARY] = ACTIONS(3533),
    [anon_sym_PROOF] = ACTIONS(3533),
    [anon_sym_BY] = ACTIONS(3533),
    [anon_sym_OBVIOUS] = ACTIONS(3533),
    [anon_sym_OMITTED] = ACTIONS(3533),
    [anon_sym_USE] = ACTIONS(3533),
    [anon_sym_HIDE] = ACTIONS(3533),
    [sym__begin_proof] = ACTIONS(3531),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1207] = {
    [sym_block_comment] = STATE(1207),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3511),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3511),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3513),
    [anon_sym_VARIABLE] = ACTIONS(3513),
    [anon_sym_VARIABLES] = ACTIONS(3513),
    [anon_sym_CONSTANT] = ACTIONS(3513),
    [anon_sym_CONSTANTS] = ACTIONS(3513),
    [anon_sym_RECURSIVE] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3513),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3513),
    [anon_sym_u2115] = ACTIONS(3511),
    [anon_sym_Int] = ACTIONS(3513),
    [anon_sym_u2124] = ACTIONS(3511),
    [anon_sym_Real] = ACTIONS(3513),
    [anon_sym_u211d] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3511),
    [anon_sym_BSLASHneg] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3513),
    [anon_sym_u00ac] = ACTIONS(3511),
    [sym_union] = ACTIONS(3513),
    [sym_powerset] = ACTIONS(3513),
    [sym_domain] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3511),
    [sym_enabled] = ACTIONS(3513),
    [sym_unchanged] = ACTIONS(3513),
    [anon_sym_LT_GT] = ACTIONS(3511),
    [anon_sym_u22c4] = ACTIONS(3511),
    [anon_sym_u25c7] = ACTIONS(3511),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3513),
    [anon_sym_ASSUMPTION] = ACTIONS(3513),
    [anon_sym_AXIOM] = ACTIONS(3513),
    [anon_sym_THEOREM] = ACTIONS(3513),
    [anon_sym_PROPOSITION] = ACTIONS(3513),
    [anon_sym_LEMMA] = ACTIONS(3513),
    [anon_sym_COROLLARY] = ACTIONS(3513),
    [anon_sym_PROOF] = ACTIONS(3513),
    [anon_sym_BY] = ACTIONS(3513),
    [anon_sym_OBVIOUS] = ACTIONS(3513),
    [anon_sym_OMITTED] = ACTIONS(3513),
    [anon_sym_USE] = ACTIONS(3513),
    [anon_sym_HIDE] = ACTIONS(3513),
    [sym__begin_proof] = ACTIONS(3511),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1208] = {
    [sym_block_comment] = STATE(1208),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3553),
    [sym_identifier] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3553),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3551),
    [anon_sym_VARIABLE] = ACTIONS(3551),
    [anon_sym_VARIABLES] = ACTIONS(3551),
    [anon_sym_CONSTANT] = ACTIONS(3551),
    [anon_sym_CONSTANTS] = ACTIONS(3551),
    [anon_sym_RECURSIVE] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3551),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3551),
    [anon_sym_u2115] = ACTIONS(3553),
    [anon_sym_Int] = ACTIONS(3551),
    [anon_sym_u2124] = ACTIONS(3553),
    [anon_sym_Real] = ACTIONS(3551),
    [anon_sym_u211d] = ACTIONS(3553),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3553),
    [anon_sym_BSLASHneg] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3551),
    [anon_sym_u00ac] = ACTIONS(3553),
    [sym_union] = ACTIONS(3551),
    [sym_powerset] = ACTIONS(3551),
    [sym_domain] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3553),
    [sym_enabled] = ACTIONS(3551),
    [sym_unchanged] = ACTIONS(3551),
    [anon_sym_LT_GT] = ACTIONS(3553),
    [anon_sym_u22c4] = ACTIONS(3553),
    [anon_sym_u25c7] = ACTIONS(3553),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3551),
    [anon_sym_ASSUMPTION] = ACTIONS(3551),
    [anon_sym_AXIOM] = ACTIONS(3551),
    [anon_sym_THEOREM] = ACTIONS(3551),
    [anon_sym_PROPOSITION] = ACTIONS(3551),
    [anon_sym_LEMMA] = ACTIONS(3551),
    [anon_sym_COROLLARY] = ACTIONS(3551),
    [anon_sym_PROOF] = ACTIONS(3551),
    [anon_sym_BY] = ACTIONS(3551),
    [anon_sym_OBVIOUS] = ACTIONS(3551),
    [anon_sym_OMITTED] = ACTIONS(3551),
    [anon_sym_USE] = ACTIONS(3551),
    [anon_sym_HIDE] = ACTIONS(3551),
    [sym__begin_proof] = ACTIONS(3553),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1209] = {
    [sym_block_comment] = STATE(1209),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1210] = {
    [sym_block_comment] = STATE(1210),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1211] = {
    [sym_block_comment] = STATE(1211),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1212] = {
    [sym_block_comment] = STATE(1212),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1213] = {
    [sym_block_comment] = STATE(1213),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1214] = {
    [sym_block_comment] = STATE(1214),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1215] = {
    [sym_block_comment] = STATE(1215),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3529),
    [sym_identifier] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3529),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3527),
    [anon_sym_VARIABLE] = ACTIONS(3527),
    [anon_sym_VARIABLES] = ACTIONS(3527),
    [anon_sym_CONSTANT] = ACTIONS(3527),
    [anon_sym_CONSTANTS] = ACTIONS(3527),
    [anon_sym_RECURSIVE] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3527),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3527),
    [anon_sym_u2115] = ACTIONS(3529),
    [anon_sym_Int] = ACTIONS(3527),
    [anon_sym_u2124] = ACTIONS(3529),
    [anon_sym_Real] = ACTIONS(3527),
    [anon_sym_u211d] = ACTIONS(3529),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3529),
    [anon_sym_BSLASHneg] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_u00ac] = ACTIONS(3529),
    [sym_union] = ACTIONS(3527),
    [sym_powerset] = ACTIONS(3527),
    [sym_domain] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3529),
    [sym_enabled] = ACTIONS(3527),
    [sym_unchanged] = ACTIONS(3527),
    [anon_sym_LT_GT] = ACTIONS(3529),
    [anon_sym_u22c4] = ACTIONS(3529),
    [anon_sym_u25c7] = ACTIONS(3529),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3527),
    [anon_sym_ASSUMPTION] = ACTIONS(3527),
    [anon_sym_AXIOM] = ACTIONS(3527),
    [anon_sym_THEOREM] = ACTIONS(3527),
    [anon_sym_PROPOSITION] = ACTIONS(3527),
    [anon_sym_LEMMA] = ACTIONS(3527),
    [anon_sym_COROLLARY] = ACTIONS(3527),
    [anon_sym_PROOF] = ACTIONS(3527),
    [anon_sym_BY] = ACTIONS(3527),
    [anon_sym_OBVIOUS] = ACTIONS(3527),
    [anon_sym_OMITTED] = ACTIONS(3527),
    [anon_sym_USE] = ACTIONS(3527),
    [anon_sym_HIDE] = ACTIONS(3527),
    [sym__begin_proof] = ACTIONS(3529),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1216] = {
    [sym_block_comment] = STATE(1216),
    [sym_implies] = STATE(793),
    [sym_plus_arrow] = STATE(794),
    [sym_equiv] = STATE(794),
    [sym_iff] = STATE(794),
    [sym_leads_to] = STATE(794),
    [sym_land] = STATE(795),
    [sym_lor] = STATE(795),
    [sym_assign] = STATE(785),
    [sym_bnf_rule] = STATE(785),
    [sym_eq] = STATE(785),
    [sym_neq] = STATE(785),
    [sym_lt] = STATE(785),
    [sym_leq] = STATE(785),
    [sym_geq] = STATE(785),
    [sym_approx] = STATE(785),
    [sym_rs_ttile] = STATE(785),
    [sym_rd_ttile] = STATE(785),
    [sym_ls_ttile] = STATE(785),
    [sym_ld_ttile] = STATE(785),
    [sym_asymp] = STATE(785),
    [sym_cong] = STATE(785),
    [sym_doteq] = STATE(785),
    [sym_gg] = STATE(785),
    [sym_ll] = STATE(785),
    [sym_in] = STATE(785),
    [sym_notin] = STATE(785),
    [sym_prec] = STATE(785),
    [sym_succ] = STATE(785),
    [sym_preceq] = STATE(785),
    [sym_succeq] = STATE(785),
    [sym_propto] = STATE(785),
    [sym_sim] = STATE(785),
    [sym_simeq] = STATE(785),
    [sym_sqsubset] = STATE(785),
    [sym_sqsupset] = STATE(785),
    [sym_sqsubseteq] = STATE(785),
    [sym_sqsupseteq] = STATE(785),
    [sym_subset] = STATE(785),
    [sym_supset] = STATE(785),
    [sym_subseteq] = STATE(785),
    [sym_supseteq] = STATE(785),
    [sym_cap] = STATE(788),
    [sym_cup] = STATE(788),
    [sym_dots_2] = STATE(796),
    [sym_dots_3] = STATE(796),
    [sym_plus] = STATE(789),
    [sym_oplus] = STATE(789),
    [sym_ominus] = STATE(790),
    [sym_vertvert] = STATE(790),
    [sym_minus] = STATE(790),
    [sym_odot] = STATE(791),
    [sym_oslash] = STATE(791),
    [sym_otimes] = STATE(791),
    [sym_bigcirc] = STATE(791),
    [sym_bullet] = STATE(791),
    [sym_div] = STATE(791),
    [sym_circ] = STATE(791),
    [sym_star] = STATE(791),
    [sym_excl] = STATE(791),
    [sym_qq] = STATE(791),
    [sym_sqcap] = STATE(791),
    [sym_sqcup] = STATE(791),
    [sym_uplus] = STATE(791),
    [sym_times] = STATE(791),
    [sym_wr] = STATE(792),
    [sym_cdot] = STATE(792),
    [sym_sup_plus] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(3557),
    [sym_identifier] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3557),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3555),
    [anon_sym_VARIABLE] = ACTIONS(3555),
    [anon_sym_VARIABLES] = ACTIONS(3555),
    [anon_sym_CONSTANT] = ACTIONS(3555),
    [anon_sym_CONSTANTS] = ACTIONS(3555),
    [anon_sym_RECURSIVE] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_INSTANCE] = ACTIONS(3555),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3555),
    [anon_sym_u2115] = ACTIONS(3557),
    [anon_sym_Int] = ACTIONS(3555),
    [anon_sym_u2124] = ACTIONS(3557),
    [anon_sym_Real] = ACTIONS(3555),
    [anon_sym_u211d] = ACTIONS(3557),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3557),
    [anon_sym_BSLASHneg] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3555),
    [anon_sym_u00ac] = ACTIONS(3557),
    [sym_union] = ACTIONS(3555),
    [sym_powerset] = ACTIONS(3555),
    [sym_domain] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3557),
    [sym_enabled] = ACTIONS(3555),
    [sym_unchanged] = ACTIONS(3555),
    [anon_sym_LT_GT] = ACTIONS(3557),
    [anon_sym_u22c4] = ACTIONS(3557),
    [anon_sym_u25c7] = ACTIONS(3557),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2538),
    [sym_map_to] = ACTIONS(2540),
    [sym_map_from] = ACTIONS(2540),
    [sym_setminus] = ACTIONS(2542),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2544),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2546),
    [sym_modmod] = ACTIONS(2548),
    [sym_vert] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2546),
    [sym_amp] = ACTIONS(2550),
    [sym_ampamp] = ACTIONS(2552),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2550),
    [sym_mulmul] = ACTIONS(2552),
    [sym_slash] = ACTIONS(2550),
    [sym_slashslash] = ACTIONS(2552),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2552),
    [sym_dol] = ACTIONS(2550),
    [sym_doldol] = ACTIONS(2552),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2554),
    [sym_powpow] = ACTIONS(2556),
    [anon_sym_CARET_PLUS] = ACTIONS(2558),
    [anon_sym_u207a] = ACTIONS(2558),
    [sym_asterisk] = ACTIONS(2560),
    [sym_sup_hash] = ACTIONS(2560),
    [sym_prime] = ACTIONS(2560),
    [anon_sym_ASSUME] = ACTIONS(3555),
    [anon_sym_ASSUMPTION] = ACTIONS(3555),
    [anon_sym_AXIOM] = ACTIONS(3555),
    [anon_sym_THEOREM] = ACTIONS(3555),
    [anon_sym_PROPOSITION] = ACTIONS(3555),
    [anon_sym_LEMMA] = ACTIONS(3555),
    [anon_sym_COROLLARY] = ACTIONS(3555),
    [anon_sym_PROOF] = ACTIONS(3555),
    [anon_sym_BY] = ACTIONS(3555),
    [anon_sym_OBVIOUS] = ACTIONS(3555),
    [anon_sym_OMITTED] = ACTIONS(3555),
    [anon_sym_USE] = ACTIONS(3555),
    [anon_sym_HIDE] = ACTIONS(3555),
    [sym__begin_proof] = ACTIONS(3557),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1217] = {
    [sym_block_comment] = STATE(1217),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3493),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1218] = {
    [sym_block_comment] = STATE(1218),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3493),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1219] = {
    [sym_block_comment] = STATE(1219),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3493),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1220] = {
    [sym_block_comment] = STATE(1220),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1221] = {
    [sym_block_comment] = STATE(1221),
    [sym_implies] = STATE(554),
    [sym_plus_arrow] = STATE(555),
    [sym_equiv] = STATE(555),
    [sym_iff] = STATE(555),
    [sym_leads_to] = STATE(555),
    [sym_land] = STATE(556),
    [sym_lor] = STATE(556),
    [sym_assign] = STATE(546),
    [sym_bnf_rule] = STATE(546),
    [sym_eq] = STATE(546),
    [sym_neq] = STATE(546),
    [sym_lt] = STATE(546),
    [sym_leq] = STATE(546),
    [sym_geq] = STATE(546),
    [sym_approx] = STATE(546),
    [sym_rs_ttile] = STATE(546),
    [sym_rd_ttile] = STATE(546),
    [sym_ls_ttile] = STATE(546),
    [sym_ld_ttile] = STATE(546),
    [sym_asymp] = STATE(546),
    [sym_cong] = STATE(546),
    [sym_doteq] = STATE(546),
    [sym_gg] = STATE(546),
    [sym_ll] = STATE(546),
    [sym_in] = STATE(546),
    [sym_notin] = STATE(546),
    [sym_prec] = STATE(546),
    [sym_succ] = STATE(546),
    [sym_preceq] = STATE(546),
    [sym_succeq] = STATE(546),
    [sym_propto] = STATE(546),
    [sym_sim] = STATE(546),
    [sym_simeq] = STATE(546),
    [sym_sqsubset] = STATE(546),
    [sym_sqsupset] = STATE(546),
    [sym_sqsubseteq] = STATE(546),
    [sym_sqsupseteq] = STATE(546),
    [sym_subset] = STATE(546),
    [sym_supset] = STATE(546),
    [sym_subseteq] = STATE(546),
    [sym_supseteq] = STATE(546),
    [sym_cap] = STATE(549),
    [sym_cup] = STATE(549),
    [sym_dots_2] = STATE(557),
    [sym_dots_3] = STATE(557),
    [sym_plus] = STATE(550),
    [sym_oplus] = STATE(550),
    [sym_ominus] = STATE(551),
    [sym_vertvert] = STATE(551),
    [sym_minus] = STATE(551),
    [sym_odot] = STATE(552),
    [sym_oslash] = STATE(552),
    [sym_otimes] = STATE(552),
    [sym_bigcirc] = STATE(552),
    [sym_bullet] = STATE(552),
    [sym_div] = STATE(552),
    [sym_circ] = STATE(552),
    [sym_star] = STATE(552),
    [sym_excl] = STATE(552),
    [sym_qq] = STATE(552),
    [sym_sqcap] = STATE(552),
    [sym_sqcup] = STATE(552),
    [sym_uplus] = STATE(552),
    [sym_times] = STATE(552),
    [sym_wr] = STATE(553),
    [sym_cdot] = STATE(553),
    [sym_sup_plus] = STATE(2303),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(2376),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(2450),
    [sym_map_to] = ACTIONS(2452),
    [sym_map_from] = ACTIONS(2452),
    [sym_setminus] = ACTIONS(2454),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(2468),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(2474),
    [sym_modmod] = ACTIONS(2476),
    [sym_vert] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(2474),
    [sym_amp] = ACTIONS(2480),
    [sym_ampamp] = ACTIONS(2482),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(2480),
    [sym_mulmul] = ACTIONS(2482),
    [sym_slash] = ACTIONS(2480),
    [sym_slashslash] = ACTIONS(2482),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(2482),
    [sym_dol] = ACTIONS(2480),
    [sym_doldol] = ACTIONS(2482),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(2516),
    [sym_powpow] = ACTIONS(2518),
    [anon_sym_CARET_PLUS] = ACTIONS(2520),
    [anon_sym_u207a] = ACTIONS(2520),
    [sym_asterisk] = ACTIONS(2522),
    [sym_sup_hash] = ACTIONS(2522),
    [sym_prime] = ACTIONS(2522),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_PROOF] = ACTIONS(3493),
    [anon_sym_BY] = ACTIONS(3493),
    [anon_sym_OBVIOUS] = ACTIONS(3493),
    [anon_sym_OMITTED] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1222] = {
    [sym_block_comment] = STATE(1222),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [aux_sym_use_body_expr_repeat1] = STATE(3504),
    [sym_identifier] = ACTIONS(3559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3561),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3561),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3561),
    [anon_sym_u25a1] = ACTIONS(3561),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3563),
    [anon_sym_LOCAL] = ACTIONS(3559),
    [anon_sym_VARIABLE] = ACTIONS(3559),
    [anon_sym_VARIABLES] = ACTIONS(3559),
    [anon_sym_CONSTANT] = ACTIONS(3559),
    [anon_sym_CONSTANTS] = ACTIONS(3559),
    [anon_sym_RECURSIVE] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3559),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3559),
    [anon_sym_u2115] = ACTIONS(3561),
    [anon_sym_Int] = ACTIONS(3559),
    [anon_sym_u2124] = ACTIONS(3561),
    [anon_sym_Real] = ACTIONS(3559),
    [anon_sym_u211d] = ACTIONS(3561),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3561),
    [anon_sym_BSLASHneg] = ACTIONS(3561),
    [anon_sym_TILDE] = ACTIONS(3559),
    [anon_sym_u00ac] = ACTIONS(3561),
    [sym_union] = ACTIONS(3559),
    [sym_powerset] = ACTIONS(3559),
    [sym_domain] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3561),
    [sym_enabled] = ACTIONS(3559),
    [sym_unchanged] = ACTIONS(3559),
    [anon_sym_LT_GT] = ACTIONS(3561),
    [anon_sym_u22c4] = ACTIONS(3561),
    [anon_sym_u25c7] = ACTIONS(3561),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3559),
    [anon_sym_ASSUMPTION] = ACTIONS(3559),
    [anon_sym_AXIOM] = ACTIONS(3559),
    [anon_sym_THEOREM] = ACTIONS(3559),
    [anon_sym_PROPOSITION] = ACTIONS(3559),
    [anon_sym_LEMMA] = ACTIONS(3559),
    [anon_sym_COROLLARY] = ACTIONS(3559),
    [anon_sym_USE] = ACTIONS(3559),
    [anon_sym_HIDE] = ACTIONS(3559),
    [anon_sym_DEF] = ACTIONS(3559),
    [anon_sym_DEFS] = ACTIONS(3559),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1223] = {
    [sym_block_comment] = STATE(1223),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [aux_sym_use_body_expr_repeat1] = STATE(3512),
    [ts_builtin_sym_end] = ACTIONS(3561),
    [sym_identifier] = ACTIONS(3559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3561),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3561),
    [anon_sym_u25a1] = ACTIONS(3561),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3595),
    [anon_sym_LOCAL] = ACTIONS(3559),
    [anon_sym_VARIABLE] = ACTIONS(3559),
    [anon_sym_VARIABLES] = ACTIONS(3559),
    [anon_sym_CONSTANT] = ACTIONS(3559),
    [anon_sym_CONSTANTS] = ACTIONS(3559),
    [anon_sym_RECURSIVE] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3559),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3559),
    [anon_sym_u2115] = ACTIONS(3561),
    [anon_sym_Int] = ACTIONS(3559),
    [anon_sym_u2124] = ACTIONS(3561),
    [anon_sym_Real] = ACTIONS(3559),
    [anon_sym_u211d] = ACTIONS(3561),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3561),
    [anon_sym_BSLASHneg] = ACTIONS(3561),
    [anon_sym_TILDE] = ACTIONS(3559),
    [anon_sym_u00ac] = ACTIONS(3561),
    [sym_union] = ACTIONS(3559),
    [sym_powerset] = ACTIONS(3559),
    [sym_domain] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3561),
    [sym_enabled] = ACTIONS(3559),
    [sym_unchanged] = ACTIONS(3559),
    [anon_sym_LT_GT] = ACTIONS(3561),
    [anon_sym_u22c4] = ACTIONS(3561),
    [anon_sym_u25c7] = ACTIONS(3561),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3559),
    [anon_sym_ASSUMPTION] = ACTIONS(3559),
    [anon_sym_AXIOM] = ACTIONS(3559),
    [anon_sym_THEOREM] = ACTIONS(3559),
    [anon_sym_PROPOSITION] = ACTIONS(3559),
    [anon_sym_LEMMA] = ACTIONS(3559),
    [anon_sym_COROLLARY] = ACTIONS(3559),
    [anon_sym_USE] = ACTIONS(3559),
    [anon_sym_HIDE] = ACTIONS(3559),
    [anon_sym_DEF] = ACTIONS(3559),
    [anon_sym_DEFS] = ACTIONS(3559),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1224] = {
    [sym_block_comment] = STATE(1224),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1225] = {
    [sym_block_comment] = STATE(1225),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3507),
    [sym_identifier] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3507),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3507),
    [anon_sym_LOCAL] = ACTIONS(3509),
    [anon_sym_VARIABLE] = ACTIONS(3509),
    [anon_sym_VARIABLES] = ACTIONS(3509),
    [anon_sym_CONSTANT] = ACTIONS(3509),
    [anon_sym_CONSTANTS] = ACTIONS(3509),
    [anon_sym_RECURSIVE] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3509),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3509),
    [anon_sym_u2115] = ACTIONS(3507),
    [anon_sym_Int] = ACTIONS(3509),
    [anon_sym_u2124] = ACTIONS(3507),
    [anon_sym_Real] = ACTIONS(3509),
    [anon_sym_u211d] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3507),
    [anon_sym_BSLASHneg] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [anon_sym_u00ac] = ACTIONS(3507),
    [sym_union] = ACTIONS(3509),
    [sym_powerset] = ACTIONS(3509),
    [sym_domain] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3507),
    [sym_enabled] = ACTIONS(3509),
    [sym_unchanged] = ACTIONS(3509),
    [anon_sym_LT_GT] = ACTIONS(3507),
    [anon_sym_u22c4] = ACTIONS(3507),
    [anon_sym_u25c7] = ACTIONS(3507),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3509),
    [anon_sym_ASSUMPTION] = ACTIONS(3509),
    [anon_sym_AXIOM] = ACTIONS(3509),
    [anon_sym_THEOREM] = ACTIONS(3509),
    [anon_sym_PROPOSITION] = ACTIONS(3509),
    [anon_sym_LEMMA] = ACTIONS(3509),
    [anon_sym_COROLLARY] = ACTIONS(3509),
    [anon_sym_USE] = ACTIONS(3509),
    [anon_sym_HIDE] = ACTIONS(3509),
    [anon_sym_DEF] = ACTIONS(3509),
    [anon_sym_DEFS] = ACTIONS(3509),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1226] = {
    [sym_block_comment] = STATE(1226),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1227] = {
    [sym_block_comment] = STATE(1227),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1228] = {
    [sym_block_comment] = STATE(1228),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3497),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [anon_sym_DEF] = ACTIONS(3497),
    [anon_sym_DEFS] = ACTIONS(3497),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1229] = {
    [sym_block_comment] = STATE(1229),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1230] = {
    [sym_block_comment] = STATE(1230),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3537),
    [sym_identifier] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3537),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_LOCAL] = ACTIONS(3535),
    [anon_sym_VARIABLE] = ACTIONS(3535),
    [anon_sym_VARIABLES] = ACTIONS(3535),
    [anon_sym_CONSTANT] = ACTIONS(3535),
    [anon_sym_CONSTANTS] = ACTIONS(3535),
    [anon_sym_RECURSIVE] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3535),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3535),
    [anon_sym_u2115] = ACTIONS(3537),
    [anon_sym_Int] = ACTIONS(3535),
    [anon_sym_u2124] = ACTIONS(3537),
    [anon_sym_Real] = ACTIONS(3535),
    [anon_sym_u211d] = ACTIONS(3537),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3537),
    [anon_sym_BSLASHneg] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3535),
    [anon_sym_u00ac] = ACTIONS(3537),
    [sym_union] = ACTIONS(3535),
    [sym_powerset] = ACTIONS(3535),
    [sym_domain] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3537),
    [sym_enabled] = ACTIONS(3535),
    [sym_unchanged] = ACTIONS(3535),
    [anon_sym_LT_GT] = ACTIONS(3537),
    [anon_sym_u22c4] = ACTIONS(3537),
    [anon_sym_u25c7] = ACTIONS(3537),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3535),
    [anon_sym_ASSUMPTION] = ACTIONS(3535),
    [anon_sym_AXIOM] = ACTIONS(3535),
    [anon_sym_THEOREM] = ACTIONS(3535),
    [anon_sym_PROPOSITION] = ACTIONS(3535),
    [anon_sym_LEMMA] = ACTIONS(3535),
    [anon_sym_COROLLARY] = ACTIONS(3535),
    [anon_sym_USE] = ACTIONS(3535),
    [anon_sym_HIDE] = ACTIONS(3535),
    [anon_sym_DEF] = ACTIONS(3535),
    [anon_sym_DEFS] = ACTIONS(3535),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1231] = {
    [sym_block_comment] = STATE(1231),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1232] = {
    [sym_block_comment] = STATE(1232),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3531),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_LOCAL] = ACTIONS(3533),
    [anon_sym_VARIABLE] = ACTIONS(3533),
    [anon_sym_VARIABLES] = ACTIONS(3533),
    [anon_sym_CONSTANT] = ACTIONS(3533),
    [anon_sym_CONSTANTS] = ACTIONS(3533),
    [anon_sym_RECURSIVE] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3533),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3533),
    [anon_sym_u2115] = ACTIONS(3531),
    [anon_sym_Int] = ACTIONS(3533),
    [anon_sym_u2124] = ACTIONS(3531),
    [anon_sym_Real] = ACTIONS(3533),
    [anon_sym_u211d] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3531),
    [anon_sym_BSLASHneg] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_u00ac] = ACTIONS(3531),
    [sym_union] = ACTIONS(3533),
    [sym_powerset] = ACTIONS(3533),
    [sym_domain] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3531),
    [sym_enabled] = ACTIONS(3533),
    [sym_unchanged] = ACTIONS(3533),
    [anon_sym_LT_GT] = ACTIONS(3531),
    [anon_sym_u22c4] = ACTIONS(3531),
    [anon_sym_u25c7] = ACTIONS(3531),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3533),
    [anon_sym_ASSUMPTION] = ACTIONS(3533),
    [anon_sym_AXIOM] = ACTIONS(3533),
    [anon_sym_THEOREM] = ACTIONS(3533),
    [anon_sym_PROPOSITION] = ACTIONS(3533),
    [anon_sym_LEMMA] = ACTIONS(3533),
    [anon_sym_COROLLARY] = ACTIONS(3533),
    [anon_sym_USE] = ACTIONS(3533),
    [anon_sym_HIDE] = ACTIONS(3533),
    [anon_sym_DEF] = ACTIONS(3533),
    [anon_sym_DEFS] = ACTIONS(3533),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1233] = {
    [sym_block_comment] = STATE(1233),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3511),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3511),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3511),
    [anon_sym_LOCAL] = ACTIONS(3513),
    [anon_sym_VARIABLE] = ACTIONS(3513),
    [anon_sym_VARIABLES] = ACTIONS(3513),
    [anon_sym_CONSTANT] = ACTIONS(3513),
    [anon_sym_CONSTANTS] = ACTIONS(3513),
    [anon_sym_RECURSIVE] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3513),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3513),
    [anon_sym_u2115] = ACTIONS(3511),
    [anon_sym_Int] = ACTIONS(3513),
    [anon_sym_u2124] = ACTIONS(3511),
    [anon_sym_Real] = ACTIONS(3513),
    [anon_sym_u211d] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3511),
    [anon_sym_BSLASHneg] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3513),
    [anon_sym_u00ac] = ACTIONS(3511),
    [sym_union] = ACTIONS(3513),
    [sym_powerset] = ACTIONS(3513),
    [sym_domain] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3511),
    [sym_enabled] = ACTIONS(3513),
    [sym_unchanged] = ACTIONS(3513),
    [anon_sym_LT_GT] = ACTIONS(3511),
    [anon_sym_u22c4] = ACTIONS(3511),
    [anon_sym_u25c7] = ACTIONS(3511),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3513),
    [anon_sym_ASSUMPTION] = ACTIONS(3513),
    [anon_sym_AXIOM] = ACTIONS(3513),
    [anon_sym_THEOREM] = ACTIONS(3513),
    [anon_sym_PROPOSITION] = ACTIONS(3513),
    [anon_sym_LEMMA] = ACTIONS(3513),
    [anon_sym_COROLLARY] = ACTIONS(3513),
    [anon_sym_USE] = ACTIONS(3513),
    [anon_sym_HIDE] = ACTIONS(3513),
    [anon_sym_DEF] = ACTIONS(3513),
    [anon_sym_DEFS] = ACTIONS(3513),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1234] = {
    [sym_block_comment] = STATE(1234),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1235] = {
    [sym_block_comment] = STATE(1235),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3511),
    [sym_identifier] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3511),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3511),
    [anon_sym_LOCAL] = ACTIONS(3513),
    [anon_sym_VARIABLE] = ACTIONS(3513),
    [anon_sym_VARIABLES] = ACTIONS(3513),
    [anon_sym_CONSTANT] = ACTIONS(3513),
    [anon_sym_CONSTANTS] = ACTIONS(3513),
    [anon_sym_RECURSIVE] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3513),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3513),
    [anon_sym_u2115] = ACTIONS(3511),
    [anon_sym_Int] = ACTIONS(3513),
    [anon_sym_u2124] = ACTIONS(3511),
    [anon_sym_Real] = ACTIONS(3513),
    [anon_sym_u211d] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3511),
    [anon_sym_BSLASHneg] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3513),
    [anon_sym_u00ac] = ACTIONS(3511),
    [sym_union] = ACTIONS(3513),
    [sym_powerset] = ACTIONS(3513),
    [sym_domain] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3511),
    [sym_enabled] = ACTIONS(3513),
    [sym_unchanged] = ACTIONS(3513),
    [anon_sym_LT_GT] = ACTIONS(3511),
    [anon_sym_u22c4] = ACTIONS(3511),
    [anon_sym_u25c7] = ACTIONS(3511),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3513),
    [anon_sym_ASSUMPTION] = ACTIONS(3513),
    [anon_sym_AXIOM] = ACTIONS(3513),
    [anon_sym_THEOREM] = ACTIONS(3513),
    [anon_sym_PROPOSITION] = ACTIONS(3513),
    [anon_sym_LEMMA] = ACTIONS(3513),
    [anon_sym_COROLLARY] = ACTIONS(3513),
    [anon_sym_USE] = ACTIONS(3513),
    [anon_sym_HIDE] = ACTIONS(3513),
    [anon_sym_DEF] = ACTIONS(3513),
    [anon_sym_DEFS] = ACTIONS(3513),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1236] = {
    [sym_block_comment] = STATE(1236),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1237] = {
    [sym_block_comment] = STATE(1237),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3629),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3629),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3629),
    [anon_sym_u25a1] = ACTIONS(3629),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_LOCAL] = ACTIONS(3627),
    [anon_sym_VARIABLE] = ACTIONS(3627),
    [anon_sym_VARIABLES] = ACTIONS(3627),
    [anon_sym_CONSTANT] = ACTIONS(3627),
    [anon_sym_CONSTANTS] = ACTIONS(3627),
    [anon_sym_RECURSIVE] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3627),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3627),
    [anon_sym_u2115] = ACTIONS(3629),
    [anon_sym_Int] = ACTIONS(3627),
    [anon_sym_u2124] = ACTIONS(3629),
    [anon_sym_Real] = ACTIONS(3627),
    [anon_sym_u211d] = ACTIONS(3629),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3629),
    [anon_sym_BSLASHneg] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3627),
    [anon_sym_u00ac] = ACTIONS(3629),
    [sym_union] = ACTIONS(3627),
    [sym_powerset] = ACTIONS(3627),
    [sym_domain] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3629),
    [sym_enabled] = ACTIONS(3627),
    [sym_unchanged] = ACTIONS(3627),
    [anon_sym_LT_GT] = ACTIONS(3629),
    [anon_sym_u22c4] = ACTIONS(3629),
    [anon_sym_u25c7] = ACTIONS(3629),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3627),
    [anon_sym_ASSUMPTION] = ACTIONS(3627),
    [anon_sym_AXIOM] = ACTIONS(3627),
    [anon_sym_THEOREM] = ACTIONS(3627),
    [anon_sym_PROPOSITION] = ACTIONS(3627),
    [anon_sym_LEMMA] = ACTIONS(3627),
    [anon_sym_COROLLARY] = ACTIONS(3627),
    [anon_sym_USE] = ACTIONS(3627),
    [anon_sym_HIDE] = ACTIONS(3627),
    [anon_sym_DEF] = ACTIONS(3627),
    [anon_sym_DEFS] = ACTIONS(3627),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1238] = {
    [sym_block_comment] = STATE(1238),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3525),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3525),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_LOCAL] = ACTIONS(3523),
    [anon_sym_VARIABLE] = ACTIONS(3523),
    [anon_sym_VARIABLES] = ACTIONS(3523),
    [anon_sym_CONSTANT] = ACTIONS(3523),
    [anon_sym_CONSTANTS] = ACTIONS(3523),
    [anon_sym_RECURSIVE] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3523),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3523),
    [anon_sym_u2115] = ACTIONS(3525),
    [anon_sym_Int] = ACTIONS(3523),
    [anon_sym_u2124] = ACTIONS(3525),
    [anon_sym_Real] = ACTIONS(3523),
    [anon_sym_u211d] = ACTIONS(3525),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3525),
    [anon_sym_BSLASHneg] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_u00ac] = ACTIONS(3525),
    [sym_union] = ACTIONS(3523),
    [sym_powerset] = ACTIONS(3523),
    [sym_domain] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3525),
    [sym_enabled] = ACTIONS(3523),
    [sym_unchanged] = ACTIONS(3523),
    [anon_sym_LT_GT] = ACTIONS(3525),
    [anon_sym_u22c4] = ACTIONS(3525),
    [anon_sym_u25c7] = ACTIONS(3525),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3523),
    [anon_sym_ASSUMPTION] = ACTIONS(3523),
    [anon_sym_AXIOM] = ACTIONS(3523),
    [anon_sym_THEOREM] = ACTIONS(3523),
    [anon_sym_PROPOSITION] = ACTIONS(3523),
    [anon_sym_LEMMA] = ACTIONS(3523),
    [anon_sym_COROLLARY] = ACTIONS(3523),
    [anon_sym_USE] = ACTIONS(3523),
    [anon_sym_HIDE] = ACTIONS(3523),
    [anon_sym_DEF] = ACTIONS(3523),
    [anon_sym_DEFS] = ACTIONS(3523),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1239] = {
    [sym_block_comment] = STATE(1239),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3529),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3529),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_LOCAL] = ACTIONS(3527),
    [anon_sym_VARIABLE] = ACTIONS(3527),
    [anon_sym_VARIABLES] = ACTIONS(3527),
    [anon_sym_CONSTANT] = ACTIONS(3527),
    [anon_sym_CONSTANTS] = ACTIONS(3527),
    [anon_sym_RECURSIVE] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3527),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3527),
    [anon_sym_u2115] = ACTIONS(3529),
    [anon_sym_Int] = ACTIONS(3527),
    [anon_sym_u2124] = ACTIONS(3529),
    [anon_sym_Real] = ACTIONS(3527),
    [anon_sym_u211d] = ACTIONS(3529),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3529),
    [anon_sym_BSLASHneg] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_u00ac] = ACTIONS(3529),
    [sym_union] = ACTIONS(3527),
    [sym_powerset] = ACTIONS(3527),
    [sym_domain] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3529),
    [sym_enabled] = ACTIONS(3527),
    [sym_unchanged] = ACTIONS(3527),
    [anon_sym_LT_GT] = ACTIONS(3529),
    [anon_sym_u22c4] = ACTIONS(3529),
    [anon_sym_u25c7] = ACTIONS(3529),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3527),
    [anon_sym_ASSUMPTION] = ACTIONS(3527),
    [anon_sym_AXIOM] = ACTIONS(3527),
    [anon_sym_THEOREM] = ACTIONS(3527),
    [anon_sym_PROPOSITION] = ACTIONS(3527),
    [anon_sym_LEMMA] = ACTIONS(3527),
    [anon_sym_COROLLARY] = ACTIONS(3527),
    [anon_sym_USE] = ACTIONS(3527),
    [anon_sym_HIDE] = ACTIONS(3527),
    [anon_sym_DEF] = ACTIONS(3527),
    [anon_sym_DEFS] = ACTIONS(3527),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1240] = {
    [sym_block_comment] = STATE(1240),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3497),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [anon_sym_DEF] = ACTIONS(3497),
    [anon_sym_DEFS] = ACTIONS(3497),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1241] = {
    [sym_block_comment] = STATE(1241),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3499),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3499),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym_LOCAL] = ACTIONS(3501),
    [anon_sym_VARIABLE] = ACTIONS(3501),
    [anon_sym_VARIABLES] = ACTIONS(3501),
    [anon_sym_CONSTANT] = ACTIONS(3501),
    [anon_sym_CONSTANTS] = ACTIONS(3501),
    [anon_sym_RECURSIVE] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3501),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3501),
    [anon_sym_u2115] = ACTIONS(3499),
    [anon_sym_Int] = ACTIONS(3501),
    [anon_sym_u2124] = ACTIONS(3499),
    [anon_sym_Real] = ACTIONS(3501),
    [anon_sym_u211d] = ACTIONS(3499),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3499),
    [anon_sym_BSLASHneg] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_u00ac] = ACTIONS(3499),
    [sym_union] = ACTIONS(3501),
    [sym_powerset] = ACTIONS(3501),
    [sym_domain] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3499),
    [sym_enabled] = ACTIONS(3501),
    [sym_unchanged] = ACTIONS(3501),
    [anon_sym_LT_GT] = ACTIONS(3499),
    [anon_sym_u22c4] = ACTIONS(3499),
    [anon_sym_u25c7] = ACTIONS(3499),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3501),
    [anon_sym_ASSUMPTION] = ACTIONS(3501),
    [anon_sym_AXIOM] = ACTIONS(3501),
    [anon_sym_THEOREM] = ACTIONS(3501),
    [anon_sym_PROPOSITION] = ACTIONS(3501),
    [anon_sym_LEMMA] = ACTIONS(3501),
    [anon_sym_COROLLARY] = ACTIONS(3501),
    [anon_sym_USE] = ACTIONS(3501),
    [anon_sym_HIDE] = ACTIONS(3501),
    [anon_sym_DEF] = ACTIONS(3501),
    [anon_sym_DEFS] = ACTIONS(3501),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1242] = {
    [sym_block_comment] = STATE(1242),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3503),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3503),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_LOCAL] = ACTIONS(3505),
    [anon_sym_VARIABLE] = ACTIONS(3505),
    [anon_sym_VARIABLES] = ACTIONS(3505),
    [anon_sym_CONSTANT] = ACTIONS(3505),
    [anon_sym_CONSTANTS] = ACTIONS(3505),
    [anon_sym_RECURSIVE] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3505),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3505),
    [anon_sym_u2115] = ACTIONS(3503),
    [anon_sym_Int] = ACTIONS(3505),
    [anon_sym_u2124] = ACTIONS(3503),
    [anon_sym_Real] = ACTIONS(3505),
    [anon_sym_u211d] = ACTIONS(3503),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3503),
    [anon_sym_BSLASHneg] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_u00ac] = ACTIONS(3503),
    [sym_union] = ACTIONS(3505),
    [sym_powerset] = ACTIONS(3505),
    [sym_domain] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3503),
    [sym_enabled] = ACTIONS(3505),
    [sym_unchanged] = ACTIONS(3505),
    [anon_sym_LT_GT] = ACTIONS(3503),
    [anon_sym_u22c4] = ACTIONS(3503),
    [anon_sym_u25c7] = ACTIONS(3503),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3505),
    [anon_sym_ASSUMPTION] = ACTIONS(3505),
    [anon_sym_AXIOM] = ACTIONS(3505),
    [anon_sym_THEOREM] = ACTIONS(3505),
    [anon_sym_PROPOSITION] = ACTIONS(3505),
    [anon_sym_LEMMA] = ACTIONS(3505),
    [anon_sym_COROLLARY] = ACTIONS(3505),
    [anon_sym_USE] = ACTIONS(3505),
    [anon_sym_HIDE] = ACTIONS(3505),
    [anon_sym_DEF] = ACTIONS(3505),
    [anon_sym_DEFS] = ACTIONS(3505),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1243] = {
    [sym_block_comment] = STATE(1243),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3507),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3507),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3507),
    [anon_sym_LOCAL] = ACTIONS(3509),
    [anon_sym_VARIABLE] = ACTIONS(3509),
    [anon_sym_VARIABLES] = ACTIONS(3509),
    [anon_sym_CONSTANT] = ACTIONS(3509),
    [anon_sym_CONSTANTS] = ACTIONS(3509),
    [anon_sym_RECURSIVE] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3509),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3509),
    [anon_sym_u2115] = ACTIONS(3507),
    [anon_sym_Int] = ACTIONS(3509),
    [anon_sym_u2124] = ACTIONS(3507),
    [anon_sym_Real] = ACTIONS(3509),
    [anon_sym_u211d] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3507),
    [anon_sym_BSLASHneg] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [anon_sym_u00ac] = ACTIONS(3507),
    [sym_union] = ACTIONS(3509),
    [sym_powerset] = ACTIONS(3509),
    [sym_domain] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3507),
    [sym_enabled] = ACTIONS(3509),
    [sym_unchanged] = ACTIONS(3509),
    [anon_sym_LT_GT] = ACTIONS(3507),
    [anon_sym_u22c4] = ACTIONS(3507),
    [anon_sym_u25c7] = ACTIONS(3507),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3509),
    [anon_sym_ASSUMPTION] = ACTIONS(3509),
    [anon_sym_AXIOM] = ACTIONS(3509),
    [anon_sym_THEOREM] = ACTIONS(3509),
    [anon_sym_PROPOSITION] = ACTIONS(3509),
    [anon_sym_LEMMA] = ACTIONS(3509),
    [anon_sym_COROLLARY] = ACTIONS(3509),
    [anon_sym_USE] = ACTIONS(3509),
    [anon_sym_HIDE] = ACTIONS(3509),
    [anon_sym_DEF] = ACTIONS(3509),
    [anon_sym_DEFS] = ACTIONS(3509),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1244] = {
    [sym_block_comment] = STATE(1244),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3515),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3515),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_LOCAL] = ACTIONS(3517),
    [anon_sym_VARIABLE] = ACTIONS(3517),
    [anon_sym_VARIABLES] = ACTIONS(3517),
    [anon_sym_CONSTANT] = ACTIONS(3517),
    [anon_sym_CONSTANTS] = ACTIONS(3517),
    [anon_sym_RECURSIVE] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3517),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3517),
    [anon_sym_u2115] = ACTIONS(3515),
    [anon_sym_Int] = ACTIONS(3517),
    [anon_sym_u2124] = ACTIONS(3515),
    [anon_sym_Real] = ACTIONS(3517),
    [anon_sym_u211d] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3515),
    [anon_sym_BSLASHneg] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3517),
    [anon_sym_u00ac] = ACTIONS(3515),
    [sym_union] = ACTIONS(3517),
    [sym_powerset] = ACTIONS(3517),
    [sym_domain] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3515),
    [sym_enabled] = ACTIONS(3517),
    [sym_unchanged] = ACTIONS(3517),
    [anon_sym_LT_GT] = ACTIONS(3515),
    [anon_sym_u22c4] = ACTIONS(3515),
    [anon_sym_u25c7] = ACTIONS(3515),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3517),
    [anon_sym_ASSUMPTION] = ACTIONS(3517),
    [anon_sym_AXIOM] = ACTIONS(3517),
    [anon_sym_THEOREM] = ACTIONS(3517),
    [anon_sym_PROPOSITION] = ACTIONS(3517),
    [anon_sym_LEMMA] = ACTIONS(3517),
    [anon_sym_COROLLARY] = ACTIONS(3517),
    [anon_sym_USE] = ACTIONS(3517),
    [anon_sym_HIDE] = ACTIONS(3517),
    [anon_sym_DEF] = ACTIONS(3517),
    [anon_sym_DEFS] = ACTIONS(3517),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1245] = {
    [sym_block_comment] = STATE(1245),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1246] = {
    [sym_block_comment] = STATE(1246),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3629),
    [sym_identifier] = ACTIONS(3627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3629),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3629),
    [anon_sym_u25a1] = ACTIONS(3629),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_LOCAL] = ACTIONS(3627),
    [anon_sym_VARIABLE] = ACTIONS(3627),
    [anon_sym_VARIABLES] = ACTIONS(3627),
    [anon_sym_CONSTANT] = ACTIONS(3627),
    [anon_sym_CONSTANTS] = ACTIONS(3627),
    [anon_sym_RECURSIVE] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3627),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3627),
    [anon_sym_u2115] = ACTIONS(3629),
    [anon_sym_Int] = ACTIONS(3627),
    [anon_sym_u2124] = ACTIONS(3629),
    [anon_sym_Real] = ACTIONS(3627),
    [anon_sym_u211d] = ACTIONS(3629),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3629),
    [anon_sym_BSLASHneg] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3627),
    [anon_sym_u00ac] = ACTIONS(3629),
    [sym_union] = ACTIONS(3627),
    [sym_powerset] = ACTIONS(3627),
    [sym_domain] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3629),
    [sym_enabled] = ACTIONS(3627),
    [sym_unchanged] = ACTIONS(3627),
    [anon_sym_LT_GT] = ACTIONS(3629),
    [anon_sym_u22c4] = ACTIONS(3629),
    [anon_sym_u25c7] = ACTIONS(3629),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3627),
    [anon_sym_ASSUMPTION] = ACTIONS(3627),
    [anon_sym_AXIOM] = ACTIONS(3627),
    [anon_sym_THEOREM] = ACTIONS(3627),
    [anon_sym_PROPOSITION] = ACTIONS(3627),
    [anon_sym_LEMMA] = ACTIONS(3627),
    [anon_sym_COROLLARY] = ACTIONS(3627),
    [anon_sym_USE] = ACTIONS(3627),
    [anon_sym_HIDE] = ACTIONS(3627),
    [anon_sym_DEF] = ACTIONS(3627),
    [anon_sym_DEFS] = ACTIONS(3627),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1247] = {
    [sym_block_comment] = STATE(1247),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1248] = {
    [sym_block_comment] = STATE(1248),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3493),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1249] = {
    [sym_block_comment] = STATE(1249),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3525),
    [sym_identifier] = ACTIONS(3523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3525),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_LOCAL] = ACTIONS(3523),
    [anon_sym_VARIABLE] = ACTIONS(3523),
    [anon_sym_VARIABLES] = ACTIONS(3523),
    [anon_sym_CONSTANT] = ACTIONS(3523),
    [anon_sym_CONSTANTS] = ACTIONS(3523),
    [anon_sym_RECURSIVE] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3523),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3523),
    [anon_sym_u2115] = ACTIONS(3525),
    [anon_sym_Int] = ACTIONS(3523),
    [anon_sym_u2124] = ACTIONS(3525),
    [anon_sym_Real] = ACTIONS(3523),
    [anon_sym_u211d] = ACTIONS(3525),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3525),
    [anon_sym_BSLASHneg] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_u00ac] = ACTIONS(3525),
    [sym_union] = ACTIONS(3523),
    [sym_powerset] = ACTIONS(3523),
    [sym_domain] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3525),
    [sym_enabled] = ACTIONS(3523),
    [sym_unchanged] = ACTIONS(3523),
    [anon_sym_LT_GT] = ACTIONS(3525),
    [anon_sym_u22c4] = ACTIONS(3525),
    [anon_sym_u25c7] = ACTIONS(3525),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3523),
    [anon_sym_ASSUMPTION] = ACTIONS(3523),
    [anon_sym_AXIOM] = ACTIONS(3523),
    [anon_sym_THEOREM] = ACTIONS(3523),
    [anon_sym_PROPOSITION] = ACTIONS(3523),
    [anon_sym_LEMMA] = ACTIONS(3523),
    [anon_sym_COROLLARY] = ACTIONS(3523),
    [anon_sym_USE] = ACTIONS(3523),
    [anon_sym_HIDE] = ACTIONS(3523),
    [anon_sym_DEF] = ACTIONS(3523),
    [anon_sym_DEFS] = ACTIONS(3523),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1250] = {
    [sym_block_comment] = STATE(1250),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3537),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3537),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_LOCAL] = ACTIONS(3535),
    [anon_sym_VARIABLE] = ACTIONS(3535),
    [anon_sym_VARIABLES] = ACTIONS(3535),
    [anon_sym_CONSTANT] = ACTIONS(3535),
    [anon_sym_CONSTANTS] = ACTIONS(3535),
    [anon_sym_RECURSIVE] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3535),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3535),
    [anon_sym_u2115] = ACTIONS(3537),
    [anon_sym_Int] = ACTIONS(3535),
    [anon_sym_u2124] = ACTIONS(3537),
    [anon_sym_Real] = ACTIONS(3535),
    [anon_sym_u211d] = ACTIONS(3537),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3537),
    [anon_sym_BSLASHneg] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3535),
    [anon_sym_u00ac] = ACTIONS(3537),
    [sym_union] = ACTIONS(3535),
    [sym_powerset] = ACTIONS(3535),
    [sym_domain] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3537),
    [sym_enabled] = ACTIONS(3535),
    [sym_unchanged] = ACTIONS(3535),
    [anon_sym_LT_GT] = ACTIONS(3537),
    [anon_sym_u22c4] = ACTIONS(3537),
    [anon_sym_u25c7] = ACTIONS(3537),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3535),
    [anon_sym_ASSUMPTION] = ACTIONS(3535),
    [anon_sym_AXIOM] = ACTIONS(3535),
    [anon_sym_THEOREM] = ACTIONS(3535),
    [anon_sym_PROPOSITION] = ACTIONS(3535),
    [anon_sym_LEMMA] = ACTIONS(3535),
    [anon_sym_COROLLARY] = ACTIONS(3535),
    [anon_sym_USE] = ACTIONS(3535),
    [anon_sym_HIDE] = ACTIONS(3535),
    [anon_sym_DEF] = ACTIONS(3535),
    [anon_sym_DEFS] = ACTIONS(3535),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1251] = {
    [sym_block_comment] = STATE(1251),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3531),
    [sym_identifier] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3531),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_LOCAL] = ACTIONS(3533),
    [anon_sym_VARIABLE] = ACTIONS(3533),
    [anon_sym_VARIABLES] = ACTIONS(3533),
    [anon_sym_CONSTANT] = ACTIONS(3533),
    [anon_sym_CONSTANTS] = ACTIONS(3533),
    [anon_sym_RECURSIVE] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3533),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3533),
    [anon_sym_u2115] = ACTIONS(3531),
    [anon_sym_Int] = ACTIONS(3533),
    [anon_sym_u2124] = ACTIONS(3531),
    [anon_sym_Real] = ACTIONS(3533),
    [anon_sym_u211d] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3531),
    [anon_sym_BSLASHneg] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_u00ac] = ACTIONS(3531),
    [sym_union] = ACTIONS(3533),
    [sym_powerset] = ACTIONS(3533),
    [sym_domain] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3531),
    [sym_enabled] = ACTIONS(3533),
    [sym_unchanged] = ACTIONS(3533),
    [anon_sym_LT_GT] = ACTIONS(3531),
    [anon_sym_u22c4] = ACTIONS(3531),
    [anon_sym_u25c7] = ACTIONS(3531),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3533),
    [anon_sym_ASSUMPTION] = ACTIONS(3533),
    [anon_sym_AXIOM] = ACTIONS(3533),
    [anon_sym_THEOREM] = ACTIONS(3533),
    [anon_sym_PROPOSITION] = ACTIONS(3533),
    [anon_sym_LEMMA] = ACTIONS(3533),
    [anon_sym_COROLLARY] = ACTIONS(3533),
    [anon_sym_USE] = ACTIONS(3533),
    [anon_sym_HIDE] = ACTIONS(3533),
    [anon_sym_DEF] = ACTIONS(3533),
    [anon_sym_DEFS] = ACTIONS(3533),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1252] = {
    [sym_block_comment] = STATE(1252),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1253] = {
    [sym_block_comment] = STATE(1253),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3493),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1254] = {
    [sym_block_comment] = STATE(1254),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1255] = {
    [sym_block_comment] = STATE(1255),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1256] = {
    [sym_block_comment] = STATE(1256),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3529),
    [sym_identifier] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3529),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_LOCAL] = ACTIONS(3527),
    [anon_sym_VARIABLE] = ACTIONS(3527),
    [anon_sym_VARIABLES] = ACTIONS(3527),
    [anon_sym_CONSTANT] = ACTIONS(3527),
    [anon_sym_CONSTANTS] = ACTIONS(3527),
    [anon_sym_RECURSIVE] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3527),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3527),
    [anon_sym_u2115] = ACTIONS(3529),
    [anon_sym_Int] = ACTIONS(3527),
    [anon_sym_u2124] = ACTIONS(3529),
    [anon_sym_Real] = ACTIONS(3527),
    [anon_sym_u211d] = ACTIONS(3529),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3529),
    [anon_sym_BSLASHneg] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_u00ac] = ACTIONS(3529),
    [sym_union] = ACTIONS(3527),
    [sym_powerset] = ACTIONS(3527),
    [sym_domain] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3529),
    [sym_enabled] = ACTIONS(3527),
    [sym_unchanged] = ACTIONS(3527),
    [anon_sym_LT_GT] = ACTIONS(3529),
    [anon_sym_u22c4] = ACTIONS(3529),
    [anon_sym_u25c7] = ACTIONS(3529),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3527),
    [anon_sym_ASSUMPTION] = ACTIONS(3527),
    [anon_sym_AXIOM] = ACTIONS(3527),
    [anon_sym_THEOREM] = ACTIONS(3527),
    [anon_sym_PROPOSITION] = ACTIONS(3527),
    [anon_sym_LEMMA] = ACTIONS(3527),
    [anon_sym_COROLLARY] = ACTIONS(3527),
    [anon_sym_USE] = ACTIONS(3527),
    [anon_sym_HIDE] = ACTIONS(3527),
    [anon_sym_DEF] = ACTIONS(3527),
    [anon_sym_DEFS] = ACTIONS(3527),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1257] = {
    [sym_block_comment] = STATE(1257),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3493),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1258] = {
    [sym_block_comment] = STATE(1258),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3497),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [anon_sym_DEF] = ACTIONS(3497),
    [anon_sym_DEFS] = ACTIONS(3497),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1259] = {
    [sym_block_comment] = STATE(1259),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1260] = {
    [sym_block_comment] = STATE(1260),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3497),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [anon_sym_DEF] = ACTIONS(3497),
    [anon_sym_DEFS] = ACTIONS(3497),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1261] = {
    [sym_block_comment] = STATE(1261),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1262] = {
    [sym_block_comment] = STATE(1262),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [anon_sym_DEF] = ACTIONS(3497),
    [anon_sym_DEFS] = ACTIONS(3497),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1263] = {
    [sym_block_comment] = STATE(1263),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3541),
    [sym_identifier] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3541),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_LOCAL] = ACTIONS(3539),
    [anon_sym_VARIABLE] = ACTIONS(3539),
    [anon_sym_VARIABLES] = ACTIONS(3539),
    [anon_sym_CONSTANT] = ACTIONS(3539),
    [anon_sym_CONSTANTS] = ACTIONS(3539),
    [anon_sym_RECURSIVE] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3539),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3539),
    [anon_sym_u2115] = ACTIONS(3541),
    [anon_sym_Int] = ACTIONS(3539),
    [anon_sym_u2124] = ACTIONS(3541),
    [anon_sym_Real] = ACTIONS(3539),
    [anon_sym_u211d] = ACTIONS(3541),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3541),
    [anon_sym_BSLASHneg] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_u00ac] = ACTIONS(3541),
    [sym_union] = ACTIONS(3539),
    [sym_powerset] = ACTIONS(3539),
    [sym_domain] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3541),
    [sym_enabled] = ACTIONS(3539),
    [sym_unchanged] = ACTIONS(3539),
    [anon_sym_LT_GT] = ACTIONS(3541),
    [anon_sym_u22c4] = ACTIONS(3541),
    [anon_sym_u25c7] = ACTIONS(3541),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3539),
    [anon_sym_ASSUMPTION] = ACTIONS(3539),
    [anon_sym_AXIOM] = ACTIONS(3539),
    [anon_sym_THEOREM] = ACTIONS(3539),
    [anon_sym_PROPOSITION] = ACTIONS(3539),
    [anon_sym_LEMMA] = ACTIONS(3539),
    [anon_sym_COROLLARY] = ACTIONS(3539),
    [anon_sym_USE] = ACTIONS(3539),
    [anon_sym_HIDE] = ACTIONS(3539),
    [anon_sym_DEF] = ACTIONS(3539),
    [anon_sym_DEFS] = ACTIONS(3539),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1264] = {
    [sym_block_comment] = STATE(1264),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3545),
    [sym_identifier] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3545),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_LOCAL] = ACTIONS(3543),
    [anon_sym_VARIABLE] = ACTIONS(3543),
    [anon_sym_VARIABLES] = ACTIONS(3543),
    [anon_sym_CONSTANT] = ACTIONS(3543),
    [anon_sym_CONSTANTS] = ACTIONS(3543),
    [anon_sym_RECURSIVE] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3543),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3543),
    [anon_sym_u2115] = ACTIONS(3545),
    [anon_sym_Int] = ACTIONS(3543),
    [anon_sym_u2124] = ACTIONS(3545),
    [anon_sym_Real] = ACTIONS(3543),
    [anon_sym_u211d] = ACTIONS(3545),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3545),
    [anon_sym_BSLASHneg] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3543),
    [anon_sym_u00ac] = ACTIONS(3545),
    [sym_union] = ACTIONS(3543),
    [sym_powerset] = ACTIONS(3543),
    [sym_domain] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3545),
    [sym_enabled] = ACTIONS(3543),
    [sym_unchanged] = ACTIONS(3543),
    [anon_sym_LT_GT] = ACTIONS(3545),
    [anon_sym_u22c4] = ACTIONS(3545),
    [anon_sym_u25c7] = ACTIONS(3545),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3543),
    [anon_sym_ASSUMPTION] = ACTIONS(3543),
    [anon_sym_AXIOM] = ACTIONS(3543),
    [anon_sym_THEOREM] = ACTIONS(3543),
    [anon_sym_PROPOSITION] = ACTIONS(3543),
    [anon_sym_LEMMA] = ACTIONS(3543),
    [anon_sym_COROLLARY] = ACTIONS(3543),
    [anon_sym_USE] = ACTIONS(3543),
    [anon_sym_HIDE] = ACTIONS(3543),
    [anon_sym_DEF] = ACTIONS(3543),
    [anon_sym_DEFS] = ACTIONS(3543),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1265] = {
    [sym_block_comment] = STATE(1265),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3541),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3541),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_LOCAL] = ACTIONS(3539),
    [anon_sym_VARIABLE] = ACTIONS(3539),
    [anon_sym_VARIABLES] = ACTIONS(3539),
    [anon_sym_CONSTANT] = ACTIONS(3539),
    [anon_sym_CONSTANTS] = ACTIONS(3539),
    [anon_sym_RECURSIVE] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3539),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3539),
    [anon_sym_u2115] = ACTIONS(3541),
    [anon_sym_Int] = ACTIONS(3539),
    [anon_sym_u2124] = ACTIONS(3541),
    [anon_sym_Real] = ACTIONS(3539),
    [anon_sym_u211d] = ACTIONS(3541),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3541),
    [anon_sym_BSLASHneg] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_u00ac] = ACTIONS(3541),
    [sym_union] = ACTIONS(3539),
    [sym_powerset] = ACTIONS(3539),
    [sym_domain] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3541),
    [sym_enabled] = ACTIONS(3539),
    [sym_unchanged] = ACTIONS(3539),
    [anon_sym_LT_GT] = ACTIONS(3541),
    [anon_sym_u22c4] = ACTIONS(3541),
    [anon_sym_u25c7] = ACTIONS(3541),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3539),
    [anon_sym_ASSUMPTION] = ACTIONS(3539),
    [anon_sym_AXIOM] = ACTIONS(3539),
    [anon_sym_THEOREM] = ACTIONS(3539),
    [anon_sym_PROPOSITION] = ACTIONS(3539),
    [anon_sym_LEMMA] = ACTIONS(3539),
    [anon_sym_COROLLARY] = ACTIONS(3539),
    [anon_sym_USE] = ACTIONS(3539),
    [anon_sym_HIDE] = ACTIONS(3539),
    [anon_sym_DEF] = ACTIONS(3539),
    [anon_sym_DEFS] = ACTIONS(3539),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1266] = {
    [sym_block_comment] = STATE(1266),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1267] = {
    [sym_block_comment] = STATE(1267),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3545),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3545),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_LOCAL] = ACTIONS(3543),
    [anon_sym_VARIABLE] = ACTIONS(3543),
    [anon_sym_VARIABLES] = ACTIONS(3543),
    [anon_sym_CONSTANT] = ACTIONS(3543),
    [anon_sym_CONSTANTS] = ACTIONS(3543),
    [anon_sym_RECURSIVE] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3543),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3543),
    [anon_sym_u2115] = ACTIONS(3545),
    [anon_sym_Int] = ACTIONS(3543),
    [anon_sym_u2124] = ACTIONS(3545),
    [anon_sym_Real] = ACTIONS(3543),
    [anon_sym_u211d] = ACTIONS(3545),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3545),
    [anon_sym_BSLASHneg] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3543),
    [anon_sym_u00ac] = ACTIONS(3545),
    [sym_union] = ACTIONS(3543),
    [sym_powerset] = ACTIONS(3543),
    [sym_domain] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3545),
    [sym_enabled] = ACTIONS(3543),
    [sym_unchanged] = ACTIONS(3543),
    [anon_sym_LT_GT] = ACTIONS(3545),
    [anon_sym_u22c4] = ACTIONS(3545),
    [anon_sym_u25c7] = ACTIONS(3545),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3543),
    [anon_sym_ASSUMPTION] = ACTIONS(3543),
    [anon_sym_AXIOM] = ACTIONS(3543),
    [anon_sym_THEOREM] = ACTIONS(3543),
    [anon_sym_PROPOSITION] = ACTIONS(3543),
    [anon_sym_LEMMA] = ACTIONS(3543),
    [anon_sym_COROLLARY] = ACTIONS(3543),
    [anon_sym_USE] = ACTIONS(3543),
    [anon_sym_HIDE] = ACTIONS(3543),
    [anon_sym_DEF] = ACTIONS(3543),
    [anon_sym_DEFS] = ACTIONS(3543),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1268] = {
    [sym_block_comment] = STATE(1268),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3497),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [anon_sym_DEF] = ACTIONS(3497),
    [anon_sym_DEFS] = ACTIONS(3497),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1269] = {
    [sym_block_comment] = STATE(1269),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1270] = {
    [sym_block_comment] = STATE(1270),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3499),
    [sym_identifier] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3499),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym_LOCAL] = ACTIONS(3501),
    [anon_sym_VARIABLE] = ACTIONS(3501),
    [anon_sym_VARIABLES] = ACTIONS(3501),
    [anon_sym_CONSTANT] = ACTIONS(3501),
    [anon_sym_CONSTANTS] = ACTIONS(3501),
    [anon_sym_RECURSIVE] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3501),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3501),
    [anon_sym_u2115] = ACTIONS(3499),
    [anon_sym_Int] = ACTIONS(3501),
    [anon_sym_u2124] = ACTIONS(3499),
    [anon_sym_Real] = ACTIONS(3501),
    [anon_sym_u211d] = ACTIONS(3499),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3499),
    [anon_sym_BSLASHneg] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_u00ac] = ACTIONS(3499),
    [sym_union] = ACTIONS(3501),
    [sym_powerset] = ACTIONS(3501),
    [sym_domain] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3499),
    [sym_enabled] = ACTIONS(3501),
    [sym_unchanged] = ACTIONS(3501),
    [anon_sym_LT_GT] = ACTIONS(3499),
    [anon_sym_u22c4] = ACTIONS(3499),
    [anon_sym_u25c7] = ACTIONS(3499),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3501),
    [anon_sym_ASSUMPTION] = ACTIONS(3501),
    [anon_sym_AXIOM] = ACTIONS(3501),
    [anon_sym_THEOREM] = ACTIONS(3501),
    [anon_sym_PROPOSITION] = ACTIONS(3501),
    [anon_sym_LEMMA] = ACTIONS(3501),
    [anon_sym_COROLLARY] = ACTIONS(3501),
    [anon_sym_USE] = ACTIONS(3501),
    [anon_sym_HIDE] = ACTIONS(3501),
    [anon_sym_DEF] = ACTIONS(3501),
    [anon_sym_DEFS] = ACTIONS(3501),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1271] = {
    [sym_block_comment] = STATE(1271),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3497),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [anon_sym_DEF] = ACTIONS(3497),
    [anon_sym_DEFS] = ACTIONS(3497),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1272] = {
    [sym_block_comment] = STATE(1272),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3493),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1273] = {
    [sym_block_comment] = STATE(1273),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3493),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1274] = {
    [sym_block_comment] = STATE(1274),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3553),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3553),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_LOCAL] = ACTIONS(3551),
    [anon_sym_VARIABLE] = ACTIONS(3551),
    [anon_sym_VARIABLES] = ACTIONS(3551),
    [anon_sym_CONSTANT] = ACTIONS(3551),
    [anon_sym_CONSTANTS] = ACTIONS(3551),
    [anon_sym_RECURSIVE] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3551),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3551),
    [anon_sym_u2115] = ACTIONS(3553),
    [anon_sym_Int] = ACTIONS(3551),
    [anon_sym_u2124] = ACTIONS(3553),
    [anon_sym_Real] = ACTIONS(3551),
    [anon_sym_u211d] = ACTIONS(3553),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3553),
    [anon_sym_BSLASHneg] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3551),
    [anon_sym_u00ac] = ACTIONS(3553),
    [sym_union] = ACTIONS(3551),
    [sym_powerset] = ACTIONS(3551),
    [sym_domain] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3553),
    [sym_enabled] = ACTIONS(3551),
    [sym_unchanged] = ACTIONS(3551),
    [anon_sym_LT_GT] = ACTIONS(3553),
    [anon_sym_u22c4] = ACTIONS(3553),
    [anon_sym_u25c7] = ACTIONS(3553),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3551),
    [anon_sym_ASSUMPTION] = ACTIONS(3551),
    [anon_sym_AXIOM] = ACTIONS(3551),
    [anon_sym_THEOREM] = ACTIONS(3551),
    [anon_sym_PROPOSITION] = ACTIONS(3551),
    [anon_sym_LEMMA] = ACTIONS(3551),
    [anon_sym_COROLLARY] = ACTIONS(3551),
    [anon_sym_USE] = ACTIONS(3551),
    [anon_sym_HIDE] = ACTIONS(3551),
    [anon_sym_DEF] = ACTIONS(3551),
    [anon_sym_DEFS] = ACTIONS(3551),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1275] = {
    [sym_block_comment] = STATE(1275),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3553),
    [sym_identifier] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3553),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_LOCAL] = ACTIONS(3551),
    [anon_sym_VARIABLE] = ACTIONS(3551),
    [anon_sym_VARIABLES] = ACTIONS(3551),
    [anon_sym_CONSTANT] = ACTIONS(3551),
    [anon_sym_CONSTANTS] = ACTIONS(3551),
    [anon_sym_RECURSIVE] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3551),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3551),
    [anon_sym_u2115] = ACTIONS(3553),
    [anon_sym_Int] = ACTIONS(3551),
    [anon_sym_u2124] = ACTIONS(3553),
    [anon_sym_Real] = ACTIONS(3551),
    [anon_sym_u211d] = ACTIONS(3553),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3553),
    [anon_sym_BSLASHneg] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3551),
    [anon_sym_u00ac] = ACTIONS(3553),
    [sym_union] = ACTIONS(3551),
    [sym_powerset] = ACTIONS(3551),
    [sym_domain] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3553),
    [sym_enabled] = ACTIONS(3551),
    [sym_unchanged] = ACTIONS(3551),
    [anon_sym_LT_GT] = ACTIONS(3553),
    [anon_sym_u22c4] = ACTIONS(3553),
    [anon_sym_u25c7] = ACTIONS(3553),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3551),
    [anon_sym_ASSUMPTION] = ACTIONS(3551),
    [anon_sym_AXIOM] = ACTIONS(3551),
    [anon_sym_THEOREM] = ACTIONS(3551),
    [anon_sym_PROPOSITION] = ACTIONS(3551),
    [anon_sym_LEMMA] = ACTIONS(3551),
    [anon_sym_COROLLARY] = ACTIONS(3551),
    [anon_sym_USE] = ACTIONS(3551),
    [anon_sym_HIDE] = ACTIONS(3551),
    [anon_sym_DEF] = ACTIONS(3551),
    [anon_sym_DEFS] = ACTIONS(3551),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1276] = {
    [sym_block_comment] = STATE(1276),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1277] = {
    [sym_block_comment] = STATE(1277),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3557),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3557),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3557),
    [anon_sym_LOCAL] = ACTIONS(3555),
    [anon_sym_VARIABLE] = ACTIONS(3555),
    [anon_sym_VARIABLES] = ACTIONS(3555),
    [anon_sym_CONSTANT] = ACTIONS(3555),
    [anon_sym_CONSTANTS] = ACTIONS(3555),
    [anon_sym_RECURSIVE] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3555),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3555),
    [anon_sym_u2115] = ACTIONS(3557),
    [anon_sym_Int] = ACTIONS(3555),
    [anon_sym_u2124] = ACTIONS(3557),
    [anon_sym_Real] = ACTIONS(3555),
    [anon_sym_u211d] = ACTIONS(3557),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3557),
    [anon_sym_BSLASHneg] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3555),
    [anon_sym_u00ac] = ACTIONS(3557),
    [sym_union] = ACTIONS(3555),
    [sym_powerset] = ACTIONS(3555),
    [sym_domain] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3557),
    [sym_enabled] = ACTIONS(3555),
    [sym_unchanged] = ACTIONS(3555),
    [anon_sym_LT_GT] = ACTIONS(3557),
    [anon_sym_u22c4] = ACTIONS(3557),
    [anon_sym_u25c7] = ACTIONS(3557),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3555),
    [anon_sym_ASSUMPTION] = ACTIONS(3555),
    [anon_sym_AXIOM] = ACTIONS(3555),
    [anon_sym_THEOREM] = ACTIONS(3555),
    [anon_sym_PROPOSITION] = ACTIONS(3555),
    [anon_sym_LEMMA] = ACTIONS(3555),
    [anon_sym_COROLLARY] = ACTIONS(3555),
    [anon_sym_USE] = ACTIONS(3555),
    [anon_sym_HIDE] = ACTIONS(3555),
    [anon_sym_DEF] = ACTIONS(3555),
    [anon_sym_DEFS] = ACTIONS(3555),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1278] = {
    [sym_block_comment] = STATE(1278),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3515),
    [sym_identifier] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3515),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_LOCAL] = ACTIONS(3517),
    [anon_sym_VARIABLE] = ACTIONS(3517),
    [anon_sym_VARIABLES] = ACTIONS(3517),
    [anon_sym_CONSTANT] = ACTIONS(3517),
    [anon_sym_CONSTANTS] = ACTIONS(3517),
    [anon_sym_RECURSIVE] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3517),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3517),
    [anon_sym_u2115] = ACTIONS(3515),
    [anon_sym_Int] = ACTIONS(3517),
    [anon_sym_u2124] = ACTIONS(3515),
    [anon_sym_Real] = ACTIONS(3517),
    [anon_sym_u211d] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3515),
    [anon_sym_BSLASHneg] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3517),
    [anon_sym_u00ac] = ACTIONS(3515),
    [sym_union] = ACTIONS(3517),
    [sym_powerset] = ACTIONS(3517),
    [sym_domain] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3515),
    [sym_enabled] = ACTIONS(3517),
    [sym_unchanged] = ACTIONS(3517),
    [anon_sym_LT_GT] = ACTIONS(3515),
    [anon_sym_u22c4] = ACTIONS(3515),
    [anon_sym_u25c7] = ACTIONS(3515),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3517),
    [anon_sym_ASSUMPTION] = ACTIONS(3517),
    [anon_sym_AXIOM] = ACTIONS(3517),
    [anon_sym_THEOREM] = ACTIONS(3517),
    [anon_sym_PROPOSITION] = ACTIONS(3517),
    [anon_sym_LEMMA] = ACTIONS(3517),
    [anon_sym_COROLLARY] = ACTIONS(3517),
    [anon_sym_USE] = ACTIONS(3517),
    [anon_sym_HIDE] = ACTIONS(3517),
    [anon_sym_DEF] = ACTIONS(3517),
    [anon_sym_DEFS] = ACTIONS(3517),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1279] = {
    [sym_block_comment] = STATE(1279),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3493),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1280] = {
    [sym_block_comment] = STATE(1280),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3557),
    [sym_identifier] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3557),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3557),
    [anon_sym_LOCAL] = ACTIONS(3555),
    [anon_sym_VARIABLE] = ACTIONS(3555),
    [anon_sym_VARIABLES] = ACTIONS(3555),
    [anon_sym_CONSTANT] = ACTIONS(3555),
    [anon_sym_CONSTANTS] = ACTIONS(3555),
    [anon_sym_RECURSIVE] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3555),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3555),
    [anon_sym_u2115] = ACTIONS(3557),
    [anon_sym_Int] = ACTIONS(3555),
    [anon_sym_u2124] = ACTIONS(3557),
    [anon_sym_Real] = ACTIONS(3555),
    [anon_sym_u211d] = ACTIONS(3557),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3557),
    [anon_sym_BSLASHneg] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3555),
    [anon_sym_u00ac] = ACTIONS(3557),
    [sym_union] = ACTIONS(3555),
    [sym_powerset] = ACTIONS(3555),
    [sym_domain] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3557),
    [sym_enabled] = ACTIONS(3555),
    [sym_unchanged] = ACTIONS(3555),
    [anon_sym_LT_GT] = ACTIONS(3557),
    [anon_sym_u22c4] = ACTIONS(3557),
    [anon_sym_u25c7] = ACTIONS(3557),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3555),
    [anon_sym_ASSUMPTION] = ACTIONS(3555),
    [anon_sym_AXIOM] = ACTIONS(3555),
    [anon_sym_THEOREM] = ACTIONS(3555),
    [anon_sym_PROPOSITION] = ACTIONS(3555),
    [anon_sym_LEMMA] = ACTIONS(3555),
    [anon_sym_COROLLARY] = ACTIONS(3555),
    [anon_sym_USE] = ACTIONS(3555),
    [anon_sym_HIDE] = ACTIONS(3555),
    [anon_sym_DEF] = ACTIONS(3555),
    [anon_sym_DEFS] = ACTIONS(3555),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1281] = {
    [sym_block_comment] = STATE(1281),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3495),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LOCAL] = ACTIONS(3497),
    [anon_sym_VARIABLE] = ACTIONS(3497),
    [anon_sym_VARIABLES] = ACTIONS(3497),
    [anon_sym_CONSTANT] = ACTIONS(3497),
    [anon_sym_CONSTANTS] = ACTIONS(3497),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3497),
    [anon_sym_ASSUMPTION] = ACTIONS(3497),
    [anon_sym_AXIOM] = ACTIONS(3497),
    [anon_sym_THEOREM] = ACTIONS(3497),
    [anon_sym_PROPOSITION] = ACTIONS(3497),
    [anon_sym_LEMMA] = ACTIONS(3497),
    [anon_sym_COROLLARY] = ACTIONS(3497),
    [anon_sym_USE] = ACTIONS(3497),
    [anon_sym_HIDE] = ACTIONS(3497),
    [anon_sym_DEF] = ACTIONS(3497),
    [anon_sym_DEFS] = ACTIONS(3497),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1282] = {
    [sym_block_comment] = STATE(1282),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3503),
    [sym_identifier] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3503),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_LOCAL] = ACTIONS(3505),
    [anon_sym_VARIABLE] = ACTIONS(3505),
    [anon_sym_VARIABLES] = ACTIONS(3505),
    [anon_sym_CONSTANT] = ACTIONS(3505),
    [anon_sym_CONSTANTS] = ACTIONS(3505),
    [anon_sym_RECURSIVE] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3505),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3505),
    [anon_sym_u2115] = ACTIONS(3503),
    [anon_sym_Int] = ACTIONS(3505),
    [anon_sym_u2124] = ACTIONS(3503),
    [anon_sym_Real] = ACTIONS(3505),
    [anon_sym_u211d] = ACTIONS(3503),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3503),
    [anon_sym_BSLASHneg] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_u00ac] = ACTIONS(3503),
    [sym_union] = ACTIONS(3505),
    [sym_powerset] = ACTIONS(3505),
    [sym_domain] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3503),
    [sym_enabled] = ACTIONS(3505),
    [sym_unchanged] = ACTIONS(3505),
    [anon_sym_LT_GT] = ACTIONS(3503),
    [anon_sym_u22c4] = ACTIONS(3503),
    [anon_sym_u25c7] = ACTIONS(3503),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3505),
    [anon_sym_ASSUMPTION] = ACTIONS(3505),
    [anon_sym_AXIOM] = ACTIONS(3505),
    [anon_sym_THEOREM] = ACTIONS(3505),
    [anon_sym_PROPOSITION] = ACTIONS(3505),
    [anon_sym_LEMMA] = ACTIONS(3505),
    [anon_sym_COROLLARY] = ACTIONS(3505),
    [anon_sym_USE] = ACTIONS(3505),
    [anon_sym_HIDE] = ACTIONS(3505),
    [anon_sym_DEF] = ACTIONS(3505),
    [anon_sym_DEFS] = ACTIONS(3505),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1283] = {
    [sym_block_comment] = STATE(1283),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3491),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LOCAL] = ACTIONS(3493),
    [anon_sym_VARIABLE] = ACTIONS(3493),
    [anon_sym_VARIABLES] = ACTIONS(3493),
    [anon_sym_CONSTANT] = ACTIONS(3493),
    [anon_sym_CONSTANTS] = ACTIONS(3493),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3493),
    [anon_sym_ASSUMPTION] = ACTIONS(3493),
    [anon_sym_AXIOM] = ACTIONS(3493),
    [anon_sym_THEOREM] = ACTIONS(3493),
    [anon_sym_PROPOSITION] = ACTIONS(3493),
    [anon_sym_LEMMA] = ACTIONS(3493),
    [anon_sym_COROLLARY] = ACTIONS(3493),
    [anon_sym_USE] = ACTIONS(3493),
    [anon_sym_HIDE] = ACTIONS(3493),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1284] = {
    [sym_block_comment] = STATE(1284),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3633),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3633),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3633),
    [anon_sym_u25a1] = ACTIONS(3633),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_LOCAL] = ACTIONS(3631),
    [anon_sym_VARIABLE] = ACTIONS(3631),
    [anon_sym_VARIABLES] = ACTIONS(3631),
    [anon_sym_CONSTANT] = ACTIONS(3631),
    [anon_sym_CONSTANTS] = ACTIONS(3631),
    [anon_sym_RECURSIVE] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3631),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3631),
    [anon_sym_u2115] = ACTIONS(3633),
    [anon_sym_Int] = ACTIONS(3631),
    [anon_sym_u2124] = ACTIONS(3633),
    [anon_sym_Real] = ACTIONS(3631),
    [anon_sym_u211d] = ACTIONS(3633),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3633),
    [anon_sym_BSLASHneg] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_u00ac] = ACTIONS(3633),
    [sym_union] = ACTIONS(3631),
    [sym_powerset] = ACTIONS(3631),
    [sym_domain] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3633),
    [sym_enabled] = ACTIONS(3631),
    [sym_unchanged] = ACTIONS(3631),
    [anon_sym_LT_GT] = ACTIONS(3633),
    [anon_sym_u22c4] = ACTIONS(3633),
    [anon_sym_u25c7] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3631),
    [anon_sym_ASSUMPTION] = ACTIONS(3631),
    [anon_sym_AXIOM] = ACTIONS(3631),
    [anon_sym_THEOREM] = ACTIONS(3631),
    [anon_sym_PROPOSITION] = ACTIONS(3631),
    [anon_sym_LEMMA] = ACTIONS(3631),
    [anon_sym_COROLLARY] = ACTIONS(3631),
    [anon_sym_USE] = ACTIONS(3631),
    [anon_sym_HIDE] = ACTIONS(3631),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1285] = {
    [sym_block_comment] = STATE(1285),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3637),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3637),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3637),
    [anon_sym_u25a1] = ACTIONS(3637),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_LOCAL] = ACTIONS(3635),
    [anon_sym_VARIABLE] = ACTIONS(3635),
    [anon_sym_VARIABLES] = ACTIONS(3635),
    [anon_sym_CONSTANT] = ACTIONS(3635),
    [anon_sym_CONSTANTS] = ACTIONS(3635),
    [anon_sym_RECURSIVE] = ACTIONS(3635),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3635),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3635),
    [anon_sym_u2115] = ACTIONS(3637),
    [anon_sym_Int] = ACTIONS(3635),
    [anon_sym_u2124] = ACTIONS(3637),
    [anon_sym_Real] = ACTIONS(3635),
    [anon_sym_u211d] = ACTIONS(3637),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3637),
    [anon_sym_BSLASHneg] = ACTIONS(3637),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_u00ac] = ACTIONS(3637),
    [sym_union] = ACTIONS(3635),
    [sym_powerset] = ACTIONS(3635),
    [sym_domain] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3637),
    [sym_enabled] = ACTIONS(3635),
    [sym_unchanged] = ACTIONS(3635),
    [anon_sym_LT_GT] = ACTIONS(3637),
    [anon_sym_u22c4] = ACTIONS(3637),
    [anon_sym_u25c7] = ACTIONS(3637),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3635),
    [anon_sym_ASSUMPTION] = ACTIONS(3635),
    [anon_sym_AXIOM] = ACTIONS(3635),
    [anon_sym_THEOREM] = ACTIONS(3635),
    [anon_sym_PROPOSITION] = ACTIONS(3635),
    [anon_sym_LEMMA] = ACTIONS(3635),
    [anon_sym_COROLLARY] = ACTIONS(3635),
    [anon_sym_USE] = ACTIONS(3635),
    [anon_sym_HIDE] = ACTIONS(3635),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1286] = {
    [sym_block_comment] = STATE(1286),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3633),
    [sym_identifier] = ACTIONS(3631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3633),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3633),
    [anon_sym_u25a1] = ACTIONS(3633),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_LOCAL] = ACTIONS(3631),
    [anon_sym_VARIABLE] = ACTIONS(3631),
    [anon_sym_VARIABLES] = ACTIONS(3631),
    [anon_sym_CONSTANT] = ACTIONS(3631),
    [anon_sym_CONSTANTS] = ACTIONS(3631),
    [anon_sym_RECURSIVE] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3631),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3631),
    [anon_sym_u2115] = ACTIONS(3633),
    [anon_sym_Int] = ACTIONS(3631),
    [anon_sym_u2124] = ACTIONS(3633),
    [anon_sym_Real] = ACTIONS(3631),
    [anon_sym_u211d] = ACTIONS(3633),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3633),
    [anon_sym_BSLASHneg] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_u00ac] = ACTIONS(3633),
    [sym_union] = ACTIONS(3631),
    [sym_powerset] = ACTIONS(3631),
    [sym_domain] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3633),
    [sym_enabled] = ACTIONS(3631),
    [sym_unchanged] = ACTIONS(3631),
    [anon_sym_LT_GT] = ACTIONS(3633),
    [anon_sym_u22c4] = ACTIONS(3633),
    [anon_sym_u25c7] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3631),
    [anon_sym_ASSUMPTION] = ACTIONS(3631),
    [anon_sym_AXIOM] = ACTIONS(3631),
    [anon_sym_THEOREM] = ACTIONS(3631),
    [anon_sym_PROPOSITION] = ACTIONS(3631),
    [anon_sym_LEMMA] = ACTIONS(3631),
    [anon_sym_COROLLARY] = ACTIONS(3631),
    [anon_sym_USE] = ACTIONS(3631),
    [anon_sym_HIDE] = ACTIONS(3631),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1287] = {
    [sym_block_comment] = STATE(1287),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3637),
    [sym_identifier] = ACTIONS(3635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3637),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3637),
    [anon_sym_u25a1] = ACTIONS(3637),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_LOCAL] = ACTIONS(3635),
    [anon_sym_VARIABLE] = ACTIONS(3635),
    [anon_sym_VARIABLES] = ACTIONS(3635),
    [anon_sym_CONSTANT] = ACTIONS(3635),
    [anon_sym_CONSTANTS] = ACTIONS(3635),
    [anon_sym_RECURSIVE] = ACTIONS(3635),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3635),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3635),
    [anon_sym_u2115] = ACTIONS(3637),
    [anon_sym_Int] = ACTIONS(3635),
    [anon_sym_u2124] = ACTIONS(3637),
    [anon_sym_Real] = ACTIONS(3635),
    [anon_sym_u211d] = ACTIONS(3637),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3637),
    [anon_sym_BSLASHneg] = ACTIONS(3637),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_u00ac] = ACTIONS(3637),
    [sym_union] = ACTIONS(3635),
    [sym_powerset] = ACTIONS(3635),
    [sym_domain] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3637),
    [sym_enabled] = ACTIONS(3635),
    [sym_unchanged] = ACTIONS(3635),
    [anon_sym_LT_GT] = ACTIONS(3637),
    [anon_sym_u22c4] = ACTIONS(3637),
    [anon_sym_u25c7] = ACTIONS(3637),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3635),
    [anon_sym_ASSUMPTION] = ACTIONS(3635),
    [anon_sym_AXIOM] = ACTIONS(3635),
    [anon_sym_THEOREM] = ACTIONS(3635),
    [anon_sym_PROPOSITION] = ACTIONS(3635),
    [anon_sym_LEMMA] = ACTIONS(3635),
    [anon_sym_COROLLARY] = ACTIONS(3635),
    [anon_sym_USE] = ACTIONS(3635),
    [anon_sym_HIDE] = ACTIONS(3635),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1288] = {
    [sym_block_comment] = STATE(1288),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3641),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3641),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3641),
    [anon_sym_u25a1] = ACTIONS(3641),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_LOCAL] = ACTIONS(3639),
    [anon_sym_VARIABLE] = ACTIONS(3639),
    [anon_sym_VARIABLES] = ACTIONS(3639),
    [anon_sym_CONSTANT] = ACTIONS(3639),
    [anon_sym_CONSTANTS] = ACTIONS(3639),
    [anon_sym_RECURSIVE] = ACTIONS(3639),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3639),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3639),
    [anon_sym_u2115] = ACTIONS(3641),
    [anon_sym_Int] = ACTIONS(3639),
    [anon_sym_u2124] = ACTIONS(3641),
    [anon_sym_Real] = ACTIONS(3639),
    [anon_sym_u211d] = ACTIONS(3641),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3641),
    [anon_sym_BSLASHneg] = ACTIONS(3641),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_u00ac] = ACTIONS(3641),
    [sym_union] = ACTIONS(3639),
    [sym_powerset] = ACTIONS(3639),
    [sym_domain] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3641),
    [sym_enabled] = ACTIONS(3639),
    [sym_unchanged] = ACTIONS(3639),
    [anon_sym_LT_GT] = ACTIONS(3641),
    [anon_sym_u22c4] = ACTIONS(3641),
    [anon_sym_u25c7] = ACTIONS(3641),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3639),
    [anon_sym_ASSUMPTION] = ACTIONS(3639),
    [anon_sym_AXIOM] = ACTIONS(3639),
    [anon_sym_THEOREM] = ACTIONS(3639),
    [anon_sym_PROPOSITION] = ACTIONS(3639),
    [anon_sym_LEMMA] = ACTIONS(3639),
    [anon_sym_COROLLARY] = ACTIONS(3639),
    [anon_sym_USE] = ACTIONS(3639),
    [anon_sym_HIDE] = ACTIONS(3639),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1289] = {
    [sym_block_comment] = STATE(1289),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3641),
    [sym_identifier] = ACTIONS(3639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3641),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3641),
    [anon_sym_u25a1] = ACTIONS(3641),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_LOCAL] = ACTIONS(3639),
    [anon_sym_VARIABLE] = ACTIONS(3639),
    [anon_sym_VARIABLES] = ACTIONS(3639),
    [anon_sym_CONSTANT] = ACTIONS(3639),
    [anon_sym_CONSTANTS] = ACTIONS(3639),
    [anon_sym_RECURSIVE] = ACTIONS(3639),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3639),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3639),
    [anon_sym_u2115] = ACTIONS(3641),
    [anon_sym_Int] = ACTIONS(3639),
    [anon_sym_u2124] = ACTIONS(3641),
    [anon_sym_Real] = ACTIONS(3639),
    [anon_sym_u211d] = ACTIONS(3641),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3641),
    [anon_sym_BSLASHneg] = ACTIONS(3641),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_u00ac] = ACTIONS(3641),
    [sym_union] = ACTIONS(3639),
    [sym_powerset] = ACTIONS(3639),
    [sym_domain] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3641),
    [sym_enabled] = ACTIONS(3639),
    [sym_unchanged] = ACTIONS(3639),
    [anon_sym_LT_GT] = ACTIONS(3641),
    [anon_sym_u22c4] = ACTIONS(3641),
    [anon_sym_u25c7] = ACTIONS(3641),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3639),
    [anon_sym_ASSUMPTION] = ACTIONS(3639),
    [anon_sym_AXIOM] = ACTIONS(3639),
    [anon_sym_THEOREM] = ACTIONS(3639),
    [anon_sym_PROPOSITION] = ACTIONS(3639),
    [anon_sym_LEMMA] = ACTIONS(3639),
    [anon_sym_COROLLARY] = ACTIONS(3639),
    [anon_sym_USE] = ACTIONS(3639),
    [anon_sym_HIDE] = ACTIONS(3639),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1290] = {
    [sym_block_comment] = STATE(1290),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3643),
    [sym_identifier] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3643),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3643),
    [anon_sym_u25a1] = ACTIONS(3643),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3645),
    [anon_sym_VARIABLE] = ACTIONS(3645),
    [anon_sym_VARIABLES] = ACTIONS(3645),
    [anon_sym_CONSTANT] = ACTIONS(3645),
    [anon_sym_CONSTANTS] = ACTIONS(3645),
    [anon_sym_RECURSIVE] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3645),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3645),
    [anon_sym_u2115] = ACTIONS(3643),
    [anon_sym_Int] = ACTIONS(3645),
    [anon_sym_u2124] = ACTIONS(3643),
    [anon_sym_Real] = ACTIONS(3645),
    [anon_sym_u211d] = ACTIONS(3643),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3643),
    [anon_sym_BSLASHneg] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3645),
    [anon_sym_u00ac] = ACTIONS(3643),
    [sym_union] = ACTIONS(3645),
    [sym_powerset] = ACTIONS(3645),
    [sym_domain] = ACTIONS(3645),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3643),
    [sym_enabled] = ACTIONS(3645),
    [sym_unchanged] = ACTIONS(3645),
    [anon_sym_LT_GT] = ACTIONS(3643),
    [anon_sym_u22c4] = ACTIONS(3643),
    [anon_sym_u25c7] = ACTIONS(3643),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3645),
    [anon_sym_ASSUMPTION] = ACTIONS(3645),
    [anon_sym_AXIOM] = ACTIONS(3645),
    [anon_sym_THEOREM] = ACTIONS(3645),
    [anon_sym_PROPOSITION] = ACTIONS(3645),
    [anon_sym_LEMMA] = ACTIONS(3645),
    [anon_sym_COROLLARY] = ACTIONS(3645),
    [anon_sym_USE] = ACTIONS(3645),
    [anon_sym_HIDE] = ACTIONS(3645),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1291] = {
    [sym_block_comment] = STATE(1291),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3643),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3643),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3643),
    [anon_sym_u25a1] = ACTIONS(3643),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3645),
    [anon_sym_VARIABLE] = ACTIONS(3645),
    [anon_sym_VARIABLES] = ACTIONS(3645),
    [anon_sym_CONSTANT] = ACTIONS(3645),
    [anon_sym_CONSTANTS] = ACTIONS(3645),
    [anon_sym_RECURSIVE] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3645),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3645),
    [anon_sym_u2115] = ACTIONS(3643),
    [anon_sym_Int] = ACTIONS(3645),
    [anon_sym_u2124] = ACTIONS(3643),
    [anon_sym_Real] = ACTIONS(3645),
    [anon_sym_u211d] = ACTIONS(3643),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3643),
    [anon_sym_BSLASHneg] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3645),
    [anon_sym_u00ac] = ACTIONS(3643),
    [sym_union] = ACTIONS(3645),
    [sym_powerset] = ACTIONS(3645),
    [sym_domain] = ACTIONS(3645),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3643),
    [sym_enabled] = ACTIONS(3645),
    [sym_unchanged] = ACTIONS(3645),
    [anon_sym_LT_GT] = ACTIONS(3643),
    [anon_sym_u22c4] = ACTIONS(3643),
    [anon_sym_u25c7] = ACTIONS(3643),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3645),
    [anon_sym_ASSUMPTION] = ACTIONS(3645),
    [anon_sym_AXIOM] = ACTIONS(3645),
    [anon_sym_THEOREM] = ACTIONS(3645),
    [anon_sym_PROPOSITION] = ACTIONS(3645),
    [anon_sym_LEMMA] = ACTIONS(3645),
    [anon_sym_COROLLARY] = ACTIONS(3645),
    [anon_sym_USE] = ACTIONS(3645),
    [anon_sym_HIDE] = ACTIONS(3645),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1292] = {
    [sym_block_comment] = STATE(1292),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3647),
    [sym_identifier] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3647),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3647),
    [anon_sym_u25a1] = ACTIONS(3647),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3649),
    [anon_sym_VARIABLE] = ACTIONS(3649),
    [anon_sym_VARIABLES] = ACTIONS(3649),
    [anon_sym_CONSTANT] = ACTIONS(3649),
    [anon_sym_CONSTANTS] = ACTIONS(3649),
    [anon_sym_RECURSIVE] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3649),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3649),
    [anon_sym_u2115] = ACTIONS(3647),
    [anon_sym_Int] = ACTIONS(3649),
    [anon_sym_u2124] = ACTIONS(3647),
    [anon_sym_Real] = ACTIONS(3649),
    [anon_sym_u211d] = ACTIONS(3647),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3647),
    [anon_sym_BSLASHneg] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3649),
    [anon_sym_u00ac] = ACTIONS(3647),
    [sym_union] = ACTIONS(3649),
    [sym_powerset] = ACTIONS(3649),
    [sym_domain] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3647),
    [sym_enabled] = ACTIONS(3649),
    [sym_unchanged] = ACTIONS(3649),
    [anon_sym_LT_GT] = ACTIONS(3647),
    [anon_sym_u22c4] = ACTIONS(3647),
    [anon_sym_u25c7] = ACTIONS(3647),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3649),
    [anon_sym_ASSUMPTION] = ACTIONS(3649),
    [anon_sym_AXIOM] = ACTIONS(3649),
    [anon_sym_THEOREM] = ACTIONS(3649),
    [anon_sym_PROPOSITION] = ACTIONS(3649),
    [anon_sym_LEMMA] = ACTIONS(3649),
    [anon_sym_COROLLARY] = ACTIONS(3649),
    [anon_sym_USE] = ACTIONS(3649),
    [anon_sym_HIDE] = ACTIONS(3649),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1293] = {
    [sym_block_comment] = STATE(1293),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3653),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3653),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3653),
    [anon_sym_u25a1] = ACTIONS(3653),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3651),
    [anon_sym_VARIABLE] = ACTIONS(3651),
    [anon_sym_VARIABLES] = ACTIONS(3651),
    [anon_sym_CONSTANT] = ACTIONS(3651),
    [anon_sym_CONSTANTS] = ACTIONS(3651),
    [anon_sym_RECURSIVE] = ACTIONS(3651),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3651),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3651),
    [anon_sym_u2115] = ACTIONS(3653),
    [anon_sym_Int] = ACTIONS(3651),
    [anon_sym_u2124] = ACTIONS(3653),
    [anon_sym_Real] = ACTIONS(3651),
    [anon_sym_u211d] = ACTIONS(3653),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3653),
    [anon_sym_BSLASHneg] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_u00ac] = ACTIONS(3653),
    [sym_union] = ACTIONS(3651),
    [sym_powerset] = ACTIONS(3651),
    [sym_domain] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3653),
    [sym_enabled] = ACTIONS(3651),
    [sym_unchanged] = ACTIONS(3651),
    [anon_sym_LT_GT] = ACTIONS(3653),
    [anon_sym_u22c4] = ACTIONS(3653),
    [anon_sym_u25c7] = ACTIONS(3653),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3651),
    [anon_sym_ASSUMPTION] = ACTIONS(3651),
    [anon_sym_AXIOM] = ACTIONS(3651),
    [anon_sym_THEOREM] = ACTIONS(3651),
    [anon_sym_PROPOSITION] = ACTIONS(3651),
    [anon_sym_LEMMA] = ACTIONS(3651),
    [anon_sym_COROLLARY] = ACTIONS(3651),
    [anon_sym_USE] = ACTIONS(3651),
    [anon_sym_HIDE] = ACTIONS(3651),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1294] = {
    [sym_block_comment] = STATE(1294),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3655),
    [sym_identifier] = ACTIONS(3657),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3655),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3655),
    [anon_sym_u25a1] = ACTIONS(3655),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3657),
    [anon_sym_VARIABLE] = ACTIONS(3657),
    [anon_sym_VARIABLES] = ACTIONS(3657),
    [anon_sym_CONSTANT] = ACTIONS(3657),
    [anon_sym_CONSTANTS] = ACTIONS(3657),
    [anon_sym_RECURSIVE] = ACTIONS(3657),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3657),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3657),
    [anon_sym_u2115] = ACTIONS(3655),
    [anon_sym_Int] = ACTIONS(3657),
    [anon_sym_u2124] = ACTIONS(3655),
    [anon_sym_Real] = ACTIONS(3657),
    [anon_sym_u211d] = ACTIONS(3655),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3655),
    [anon_sym_BSLASHneg] = ACTIONS(3655),
    [anon_sym_TILDE] = ACTIONS(3657),
    [anon_sym_u00ac] = ACTIONS(3655),
    [sym_union] = ACTIONS(3657),
    [sym_powerset] = ACTIONS(3657),
    [sym_domain] = ACTIONS(3657),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3655),
    [sym_enabled] = ACTIONS(3657),
    [sym_unchanged] = ACTIONS(3657),
    [anon_sym_LT_GT] = ACTIONS(3655),
    [anon_sym_u22c4] = ACTIONS(3655),
    [anon_sym_u25c7] = ACTIONS(3655),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3657),
    [anon_sym_ASSUMPTION] = ACTIONS(3657),
    [anon_sym_AXIOM] = ACTIONS(3657),
    [anon_sym_THEOREM] = ACTIONS(3657),
    [anon_sym_PROPOSITION] = ACTIONS(3657),
    [anon_sym_LEMMA] = ACTIONS(3657),
    [anon_sym_COROLLARY] = ACTIONS(3657),
    [anon_sym_USE] = ACTIONS(3657),
    [anon_sym_HIDE] = ACTIONS(3657),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1295] = {
    [sym_block_comment] = STATE(1295),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3659),
    [sym_identifier] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3659),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3659),
    [anon_sym_u25a1] = ACTIONS(3659),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3661),
    [anon_sym_VARIABLE] = ACTIONS(3661),
    [anon_sym_VARIABLES] = ACTIONS(3661),
    [anon_sym_CONSTANT] = ACTIONS(3661),
    [anon_sym_CONSTANTS] = ACTIONS(3661),
    [anon_sym_RECURSIVE] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3661),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3661),
    [anon_sym_u2115] = ACTIONS(3659),
    [anon_sym_Int] = ACTIONS(3661),
    [anon_sym_u2124] = ACTIONS(3659),
    [anon_sym_Real] = ACTIONS(3661),
    [anon_sym_u211d] = ACTIONS(3659),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3659),
    [anon_sym_BSLASHneg] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [anon_sym_u00ac] = ACTIONS(3659),
    [sym_union] = ACTIONS(3661),
    [sym_powerset] = ACTIONS(3661),
    [sym_domain] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3659),
    [sym_enabled] = ACTIONS(3661),
    [sym_unchanged] = ACTIONS(3661),
    [anon_sym_LT_GT] = ACTIONS(3659),
    [anon_sym_u22c4] = ACTIONS(3659),
    [anon_sym_u25c7] = ACTIONS(3659),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3661),
    [anon_sym_ASSUMPTION] = ACTIONS(3661),
    [anon_sym_AXIOM] = ACTIONS(3661),
    [anon_sym_THEOREM] = ACTIONS(3661),
    [anon_sym_PROPOSITION] = ACTIONS(3661),
    [anon_sym_LEMMA] = ACTIONS(3661),
    [anon_sym_COROLLARY] = ACTIONS(3661),
    [anon_sym_USE] = ACTIONS(3661),
    [anon_sym_HIDE] = ACTIONS(3661),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1296] = {
    [sym_block_comment] = STATE(1296),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3653),
    [sym_identifier] = ACTIONS(3651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3653),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3653),
    [anon_sym_u25a1] = ACTIONS(3653),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3651),
    [anon_sym_VARIABLE] = ACTIONS(3651),
    [anon_sym_VARIABLES] = ACTIONS(3651),
    [anon_sym_CONSTANT] = ACTIONS(3651),
    [anon_sym_CONSTANTS] = ACTIONS(3651),
    [anon_sym_RECURSIVE] = ACTIONS(3651),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3651),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3651),
    [anon_sym_u2115] = ACTIONS(3653),
    [anon_sym_Int] = ACTIONS(3651),
    [anon_sym_u2124] = ACTIONS(3653),
    [anon_sym_Real] = ACTIONS(3651),
    [anon_sym_u211d] = ACTIONS(3653),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3653),
    [anon_sym_BSLASHneg] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_u00ac] = ACTIONS(3653),
    [sym_union] = ACTIONS(3651),
    [sym_powerset] = ACTIONS(3651),
    [sym_domain] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3653),
    [sym_enabled] = ACTIONS(3651),
    [sym_unchanged] = ACTIONS(3651),
    [anon_sym_LT_GT] = ACTIONS(3653),
    [anon_sym_u22c4] = ACTIONS(3653),
    [anon_sym_u25c7] = ACTIONS(3653),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3651),
    [anon_sym_ASSUMPTION] = ACTIONS(3651),
    [anon_sym_AXIOM] = ACTIONS(3651),
    [anon_sym_THEOREM] = ACTIONS(3651),
    [anon_sym_PROPOSITION] = ACTIONS(3651),
    [anon_sym_LEMMA] = ACTIONS(3651),
    [anon_sym_COROLLARY] = ACTIONS(3651),
    [anon_sym_USE] = ACTIONS(3651),
    [anon_sym_HIDE] = ACTIONS(3651),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1297] = {
    [sym_block_comment] = STATE(1297),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3663),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3663),
    [anon_sym_u25a1] = ACTIONS(3663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3665),
    [anon_sym_VARIABLE] = ACTIONS(3665),
    [anon_sym_VARIABLES] = ACTIONS(3665),
    [anon_sym_CONSTANT] = ACTIONS(3665),
    [anon_sym_CONSTANTS] = ACTIONS(3665),
    [anon_sym_RECURSIVE] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3665),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3665),
    [anon_sym_u2115] = ACTIONS(3663),
    [anon_sym_Int] = ACTIONS(3665),
    [anon_sym_u2124] = ACTIONS(3663),
    [anon_sym_Real] = ACTIONS(3665),
    [anon_sym_u211d] = ACTIONS(3663),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3663),
    [anon_sym_BSLASHneg] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3665),
    [anon_sym_u00ac] = ACTIONS(3663),
    [sym_union] = ACTIONS(3665),
    [sym_powerset] = ACTIONS(3665),
    [sym_domain] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3663),
    [sym_enabled] = ACTIONS(3665),
    [sym_unchanged] = ACTIONS(3665),
    [anon_sym_LT_GT] = ACTIONS(3663),
    [anon_sym_u22c4] = ACTIONS(3663),
    [anon_sym_u25c7] = ACTIONS(3663),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3665),
    [anon_sym_ASSUMPTION] = ACTIONS(3665),
    [anon_sym_AXIOM] = ACTIONS(3665),
    [anon_sym_THEOREM] = ACTIONS(3665),
    [anon_sym_PROPOSITION] = ACTIONS(3665),
    [anon_sym_LEMMA] = ACTIONS(3665),
    [anon_sym_COROLLARY] = ACTIONS(3665),
    [anon_sym_USE] = ACTIONS(3665),
    [anon_sym_HIDE] = ACTIONS(3665),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1298] = {
    [sym_block_comment] = STATE(1298),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3669),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3669),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3669),
    [anon_sym_u25a1] = ACTIONS(3669),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3667),
    [anon_sym_VARIABLE] = ACTIONS(3667),
    [anon_sym_VARIABLES] = ACTIONS(3667),
    [anon_sym_CONSTANT] = ACTIONS(3667),
    [anon_sym_CONSTANTS] = ACTIONS(3667),
    [anon_sym_RECURSIVE] = ACTIONS(3667),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3667),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3667),
    [anon_sym_u2115] = ACTIONS(3669),
    [anon_sym_Int] = ACTIONS(3667),
    [anon_sym_u2124] = ACTIONS(3669),
    [anon_sym_Real] = ACTIONS(3667),
    [anon_sym_u211d] = ACTIONS(3669),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3669),
    [anon_sym_BSLASHneg] = ACTIONS(3669),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_u00ac] = ACTIONS(3669),
    [sym_union] = ACTIONS(3667),
    [sym_powerset] = ACTIONS(3667),
    [sym_domain] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3669),
    [sym_enabled] = ACTIONS(3667),
    [sym_unchanged] = ACTIONS(3667),
    [anon_sym_LT_GT] = ACTIONS(3669),
    [anon_sym_u22c4] = ACTIONS(3669),
    [anon_sym_u25c7] = ACTIONS(3669),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3667),
    [anon_sym_ASSUMPTION] = ACTIONS(3667),
    [anon_sym_AXIOM] = ACTIONS(3667),
    [anon_sym_THEOREM] = ACTIONS(3667),
    [anon_sym_PROPOSITION] = ACTIONS(3667),
    [anon_sym_LEMMA] = ACTIONS(3667),
    [anon_sym_COROLLARY] = ACTIONS(3667),
    [anon_sym_USE] = ACTIONS(3667),
    [anon_sym_HIDE] = ACTIONS(3667),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1299] = {
    [sym_block_comment] = STATE(1299),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3659),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3659),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3659),
    [anon_sym_u25a1] = ACTIONS(3659),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3661),
    [anon_sym_VARIABLE] = ACTIONS(3661),
    [anon_sym_VARIABLES] = ACTIONS(3661),
    [anon_sym_CONSTANT] = ACTIONS(3661),
    [anon_sym_CONSTANTS] = ACTIONS(3661),
    [anon_sym_RECURSIVE] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3661),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3661),
    [anon_sym_u2115] = ACTIONS(3659),
    [anon_sym_Int] = ACTIONS(3661),
    [anon_sym_u2124] = ACTIONS(3659),
    [anon_sym_Real] = ACTIONS(3661),
    [anon_sym_u211d] = ACTIONS(3659),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3659),
    [anon_sym_BSLASHneg] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [anon_sym_u00ac] = ACTIONS(3659),
    [sym_union] = ACTIONS(3661),
    [sym_powerset] = ACTIONS(3661),
    [sym_domain] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3659),
    [sym_enabled] = ACTIONS(3661),
    [sym_unchanged] = ACTIONS(3661),
    [anon_sym_LT_GT] = ACTIONS(3659),
    [anon_sym_u22c4] = ACTIONS(3659),
    [anon_sym_u25c7] = ACTIONS(3659),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3661),
    [anon_sym_ASSUMPTION] = ACTIONS(3661),
    [anon_sym_AXIOM] = ACTIONS(3661),
    [anon_sym_THEOREM] = ACTIONS(3661),
    [anon_sym_PROPOSITION] = ACTIONS(3661),
    [anon_sym_LEMMA] = ACTIONS(3661),
    [anon_sym_COROLLARY] = ACTIONS(3661),
    [anon_sym_USE] = ACTIONS(3661),
    [anon_sym_HIDE] = ACTIONS(3661),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1300] = {
    [sym_block_comment] = STATE(1300),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3673),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3673),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3673),
    [anon_sym_u25a1] = ACTIONS(3673),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3671),
    [anon_sym_VARIABLE] = ACTIONS(3671),
    [anon_sym_VARIABLES] = ACTIONS(3671),
    [anon_sym_CONSTANT] = ACTIONS(3671),
    [anon_sym_CONSTANTS] = ACTIONS(3671),
    [anon_sym_RECURSIVE] = ACTIONS(3671),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3671),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3671),
    [anon_sym_u2115] = ACTIONS(3673),
    [anon_sym_Int] = ACTIONS(3671),
    [anon_sym_u2124] = ACTIONS(3673),
    [anon_sym_Real] = ACTIONS(3671),
    [anon_sym_u211d] = ACTIONS(3673),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3673),
    [anon_sym_BSLASHneg] = ACTIONS(3673),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_u00ac] = ACTIONS(3673),
    [sym_union] = ACTIONS(3671),
    [sym_powerset] = ACTIONS(3671),
    [sym_domain] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3673),
    [sym_enabled] = ACTIONS(3671),
    [sym_unchanged] = ACTIONS(3671),
    [anon_sym_LT_GT] = ACTIONS(3673),
    [anon_sym_u22c4] = ACTIONS(3673),
    [anon_sym_u25c7] = ACTIONS(3673),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3671),
    [anon_sym_ASSUMPTION] = ACTIONS(3671),
    [anon_sym_AXIOM] = ACTIONS(3671),
    [anon_sym_THEOREM] = ACTIONS(3671),
    [anon_sym_PROPOSITION] = ACTIONS(3671),
    [anon_sym_LEMMA] = ACTIONS(3671),
    [anon_sym_COROLLARY] = ACTIONS(3671),
    [anon_sym_USE] = ACTIONS(3671),
    [anon_sym_HIDE] = ACTIONS(3671),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1301] = {
    [sym_block_comment] = STATE(1301),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3677),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3677),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3677),
    [anon_sym_u25a1] = ACTIONS(3677),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3675),
    [anon_sym_VARIABLE] = ACTIONS(3675),
    [anon_sym_VARIABLES] = ACTIONS(3675),
    [anon_sym_CONSTANT] = ACTIONS(3675),
    [anon_sym_CONSTANTS] = ACTIONS(3675),
    [anon_sym_RECURSIVE] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3675),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3675),
    [anon_sym_u2115] = ACTIONS(3677),
    [anon_sym_Int] = ACTIONS(3675),
    [anon_sym_u2124] = ACTIONS(3677),
    [anon_sym_Real] = ACTIONS(3675),
    [anon_sym_u211d] = ACTIONS(3677),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3677),
    [anon_sym_BSLASHneg] = ACTIONS(3677),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_u00ac] = ACTIONS(3677),
    [sym_union] = ACTIONS(3675),
    [sym_powerset] = ACTIONS(3675),
    [sym_domain] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3677),
    [sym_enabled] = ACTIONS(3675),
    [sym_unchanged] = ACTIONS(3675),
    [anon_sym_LT_GT] = ACTIONS(3677),
    [anon_sym_u22c4] = ACTIONS(3677),
    [anon_sym_u25c7] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3675),
    [anon_sym_ASSUMPTION] = ACTIONS(3675),
    [anon_sym_AXIOM] = ACTIONS(3675),
    [anon_sym_THEOREM] = ACTIONS(3675),
    [anon_sym_PROPOSITION] = ACTIONS(3675),
    [anon_sym_LEMMA] = ACTIONS(3675),
    [anon_sym_COROLLARY] = ACTIONS(3675),
    [anon_sym_USE] = ACTIONS(3675),
    [anon_sym_HIDE] = ACTIONS(3675),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1302] = {
    [sym_block_comment] = STATE(1302),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3647),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3647),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3647),
    [anon_sym_u25a1] = ACTIONS(3647),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3649),
    [anon_sym_VARIABLE] = ACTIONS(3649),
    [anon_sym_VARIABLES] = ACTIONS(3649),
    [anon_sym_CONSTANT] = ACTIONS(3649),
    [anon_sym_CONSTANTS] = ACTIONS(3649),
    [anon_sym_RECURSIVE] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3649),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3649),
    [anon_sym_u2115] = ACTIONS(3647),
    [anon_sym_Int] = ACTIONS(3649),
    [anon_sym_u2124] = ACTIONS(3647),
    [anon_sym_Real] = ACTIONS(3649),
    [anon_sym_u211d] = ACTIONS(3647),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3647),
    [anon_sym_BSLASHneg] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3649),
    [anon_sym_u00ac] = ACTIONS(3647),
    [sym_union] = ACTIONS(3649),
    [sym_powerset] = ACTIONS(3649),
    [sym_domain] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3647),
    [sym_enabled] = ACTIONS(3649),
    [sym_unchanged] = ACTIONS(3649),
    [anon_sym_LT_GT] = ACTIONS(3647),
    [anon_sym_u22c4] = ACTIONS(3647),
    [anon_sym_u25c7] = ACTIONS(3647),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3649),
    [anon_sym_ASSUMPTION] = ACTIONS(3649),
    [anon_sym_AXIOM] = ACTIONS(3649),
    [anon_sym_THEOREM] = ACTIONS(3649),
    [anon_sym_PROPOSITION] = ACTIONS(3649),
    [anon_sym_LEMMA] = ACTIONS(3649),
    [anon_sym_COROLLARY] = ACTIONS(3649),
    [anon_sym_USE] = ACTIONS(3649),
    [anon_sym_HIDE] = ACTIONS(3649),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1303] = {
    [sym_block_comment] = STATE(1303),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3669),
    [sym_identifier] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3669),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3669),
    [anon_sym_u25a1] = ACTIONS(3669),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3667),
    [anon_sym_VARIABLE] = ACTIONS(3667),
    [anon_sym_VARIABLES] = ACTIONS(3667),
    [anon_sym_CONSTANT] = ACTIONS(3667),
    [anon_sym_CONSTANTS] = ACTIONS(3667),
    [anon_sym_RECURSIVE] = ACTIONS(3667),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3667),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3667),
    [anon_sym_u2115] = ACTIONS(3669),
    [anon_sym_Int] = ACTIONS(3667),
    [anon_sym_u2124] = ACTIONS(3669),
    [anon_sym_Real] = ACTIONS(3667),
    [anon_sym_u211d] = ACTIONS(3669),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3669),
    [anon_sym_BSLASHneg] = ACTIONS(3669),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_u00ac] = ACTIONS(3669),
    [sym_union] = ACTIONS(3667),
    [sym_powerset] = ACTIONS(3667),
    [sym_domain] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3669),
    [sym_enabled] = ACTIONS(3667),
    [sym_unchanged] = ACTIONS(3667),
    [anon_sym_LT_GT] = ACTIONS(3669),
    [anon_sym_u22c4] = ACTIONS(3669),
    [anon_sym_u25c7] = ACTIONS(3669),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3667),
    [anon_sym_ASSUMPTION] = ACTIONS(3667),
    [anon_sym_AXIOM] = ACTIONS(3667),
    [anon_sym_THEOREM] = ACTIONS(3667),
    [anon_sym_PROPOSITION] = ACTIONS(3667),
    [anon_sym_LEMMA] = ACTIONS(3667),
    [anon_sym_COROLLARY] = ACTIONS(3667),
    [anon_sym_USE] = ACTIONS(3667),
    [anon_sym_HIDE] = ACTIONS(3667),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1304] = {
    [sym_block_comment] = STATE(1304),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3673),
    [sym_identifier] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3673),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3673),
    [anon_sym_u25a1] = ACTIONS(3673),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3671),
    [anon_sym_VARIABLE] = ACTIONS(3671),
    [anon_sym_VARIABLES] = ACTIONS(3671),
    [anon_sym_CONSTANT] = ACTIONS(3671),
    [anon_sym_CONSTANTS] = ACTIONS(3671),
    [anon_sym_RECURSIVE] = ACTIONS(3671),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3671),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3671),
    [anon_sym_u2115] = ACTIONS(3673),
    [anon_sym_Int] = ACTIONS(3671),
    [anon_sym_u2124] = ACTIONS(3673),
    [anon_sym_Real] = ACTIONS(3671),
    [anon_sym_u211d] = ACTIONS(3673),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3673),
    [anon_sym_BSLASHneg] = ACTIONS(3673),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_u00ac] = ACTIONS(3673),
    [sym_union] = ACTIONS(3671),
    [sym_powerset] = ACTIONS(3671),
    [sym_domain] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3673),
    [sym_enabled] = ACTIONS(3671),
    [sym_unchanged] = ACTIONS(3671),
    [anon_sym_LT_GT] = ACTIONS(3673),
    [anon_sym_u22c4] = ACTIONS(3673),
    [anon_sym_u25c7] = ACTIONS(3673),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3671),
    [anon_sym_ASSUMPTION] = ACTIONS(3671),
    [anon_sym_AXIOM] = ACTIONS(3671),
    [anon_sym_THEOREM] = ACTIONS(3671),
    [anon_sym_PROPOSITION] = ACTIONS(3671),
    [anon_sym_LEMMA] = ACTIONS(3671),
    [anon_sym_COROLLARY] = ACTIONS(3671),
    [anon_sym_USE] = ACTIONS(3671),
    [anon_sym_HIDE] = ACTIONS(3671),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1305] = {
    [sym_block_comment] = STATE(1305),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3677),
    [sym_identifier] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3677),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3677),
    [anon_sym_u25a1] = ACTIONS(3677),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3675),
    [anon_sym_VARIABLE] = ACTIONS(3675),
    [anon_sym_VARIABLES] = ACTIONS(3675),
    [anon_sym_CONSTANT] = ACTIONS(3675),
    [anon_sym_CONSTANTS] = ACTIONS(3675),
    [anon_sym_RECURSIVE] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3675),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3675),
    [anon_sym_u2115] = ACTIONS(3677),
    [anon_sym_Int] = ACTIONS(3675),
    [anon_sym_u2124] = ACTIONS(3677),
    [anon_sym_Real] = ACTIONS(3675),
    [anon_sym_u211d] = ACTIONS(3677),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3677),
    [anon_sym_BSLASHneg] = ACTIONS(3677),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_u00ac] = ACTIONS(3677),
    [sym_union] = ACTIONS(3675),
    [sym_powerset] = ACTIONS(3675),
    [sym_domain] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3677),
    [sym_enabled] = ACTIONS(3675),
    [sym_unchanged] = ACTIONS(3675),
    [anon_sym_LT_GT] = ACTIONS(3677),
    [anon_sym_u22c4] = ACTIONS(3677),
    [anon_sym_u25c7] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3675),
    [anon_sym_ASSUMPTION] = ACTIONS(3675),
    [anon_sym_AXIOM] = ACTIONS(3675),
    [anon_sym_THEOREM] = ACTIONS(3675),
    [anon_sym_PROPOSITION] = ACTIONS(3675),
    [anon_sym_LEMMA] = ACTIONS(3675),
    [anon_sym_COROLLARY] = ACTIONS(3675),
    [anon_sym_USE] = ACTIONS(3675),
    [anon_sym_HIDE] = ACTIONS(3675),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1306] = {
    [sym_block_comment] = STATE(1306),
    [sym_implies] = STATE(768),
    [sym_plus_arrow] = STATE(774),
    [sym_equiv] = STATE(774),
    [sym_iff] = STATE(774),
    [sym_leads_to] = STATE(774),
    [sym_land] = STATE(778),
    [sym_lor] = STATE(778),
    [sym_assign] = STATE(696),
    [sym_bnf_rule] = STATE(696),
    [sym_eq] = STATE(696),
    [sym_neq] = STATE(696),
    [sym_lt] = STATE(696),
    [sym_leq] = STATE(696),
    [sym_geq] = STATE(696),
    [sym_approx] = STATE(696),
    [sym_rs_ttile] = STATE(696),
    [sym_rd_ttile] = STATE(696),
    [sym_ls_ttile] = STATE(696),
    [sym_ld_ttile] = STATE(696),
    [sym_asymp] = STATE(696),
    [sym_cong] = STATE(696),
    [sym_doteq] = STATE(696),
    [sym_gg] = STATE(696),
    [sym_ll] = STATE(696),
    [sym_in] = STATE(696),
    [sym_notin] = STATE(696),
    [sym_prec] = STATE(696),
    [sym_succ] = STATE(696),
    [sym_preceq] = STATE(696),
    [sym_succeq] = STATE(696),
    [sym_propto] = STATE(696),
    [sym_sim] = STATE(696),
    [sym_simeq] = STATE(696),
    [sym_sqsubset] = STATE(696),
    [sym_sqsupset] = STATE(696),
    [sym_sqsubseteq] = STATE(696),
    [sym_sqsupseteq] = STATE(696),
    [sym_subset] = STATE(696),
    [sym_supset] = STATE(696),
    [sym_subseteq] = STATE(696),
    [sym_supseteq] = STATE(696),
    [sym_cap] = STATE(721),
    [sym_cup] = STATE(721),
    [sym_dots_2] = STATE(779),
    [sym_dots_3] = STATE(779),
    [sym_plus] = STATE(724),
    [sym_oplus] = STATE(724),
    [sym_ominus] = STATE(746),
    [sym_vertvert] = STATE(746),
    [sym_minus] = STATE(746),
    [sym_odot] = STATE(761),
    [sym_oslash] = STATE(761),
    [sym_otimes] = STATE(761),
    [sym_bigcirc] = STATE(761),
    [sym_bullet] = STATE(761),
    [sym_div] = STATE(761),
    [sym_circ] = STATE(761),
    [sym_star] = STATE(761),
    [sym_excl] = STATE(761),
    [sym_qq] = STATE(761),
    [sym_sqcap] = STATE(761),
    [sym_sqcup] = STATE(761),
    [sym_uplus] = STATE(761),
    [sym_times] = STATE(761),
    [sym_wr] = STATE(762),
    [sym_cdot] = STATE(762),
    [sym_sup_plus] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3679),
    [sym_identifier] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3679),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3679),
    [anon_sym_u25a1] = ACTIONS(3679),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3681),
    [anon_sym_VARIABLE] = ACTIONS(3681),
    [anon_sym_VARIABLES] = ACTIONS(3681),
    [anon_sym_CONSTANT] = ACTIONS(3681),
    [anon_sym_CONSTANTS] = ACTIONS(3681),
    [anon_sym_RECURSIVE] = ACTIONS(3681),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_INSTANCE] = ACTIONS(3681),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3681),
    [anon_sym_u2115] = ACTIONS(3679),
    [anon_sym_Int] = ACTIONS(3681),
    [anon_sym_u2124] = ACTIONS(3679),
    [anon_sym_Real] = ACTIONS(3681),
    [anon_sym_u211d] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3599),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3679),
    [anon_sym_BSLASHneg] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3681),
    [anon_sym_u00ac] = ACTIONS(3679),
    [sym_union] = ACTIONS(3681),
    [sym_powerset] = ACTIONS(3681),
    [sym_domain] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3679),
    [sym_enabled] = ACTIONS(3681),
    [sym_unchanged] = ACTIONS(3681),
    [anon_sym_LT_GT] = ACTIONS(3679),
    [anon_sym_u22c4] = ACTIONS(3679),
    [anon_sym_u25c7] = ACTIONS(3679),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3601),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3603),
    [sym_map_to] = ACTIONS(3605),
    [sym_map_from] = ACTIONS(3605),
    [sym_setminus] = ACTIONS(3607),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3609),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3611),
    [sym_modmod] = ACTIONS(3613),
    [sym_vert] = ACTIONS(3611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3611),
    [sym_amp] = ACTIONS(3615),
    [sym_ampamp] = ACTIONS(3617),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3615),
    [sym_mulmul] = ACTIONS(3617),
    [sym_slash] = ACTIONS(3615),
    [sym_slashslash] = ACTIONS(3617),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3617),
    [sym_dol] = ACTIONS(3615),
    [sym_doldol] = ACTIONS(3617),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3619),
    [sym_powpow] = ACTIONS(3621),
    [anon_sym_CARET_PLUS] = ACTIONS(3623),
    [anon_sym_u207a] = ACTIONS(3623),
    [sym_asterisk] = ACTIONS(3625),
    [sym_sup_hash] = ACTIONS(3625),
    [sym_prime] = ACTIONS(3625),
    [anon_sym_ASSUME] = ACTIONS(3681),
    [anon_sym_ASSUMPTION] = ACTIONS(3681),
    [anon_sym_AXIOM] = ACTIONS(3681),
    [anon_sym_THEOREM] = ACTIONS(3681),
    [anon_sym_PROPOSITION] = ACTIONS(3681),
    [anon_sym_LEMMA] = ACTIONS(3681),
    [anon_sym_COROLLARY] = ACTIONS(3681),
    [anon_sym_USE] = ACTIONS(3681),
    [anon_sym_HIDE] = ACTIONS(3681),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1307] = {
    [sym_block_comment] = STATE(1307),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3663),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3663),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3663),
    [anon_sym_u25a1] = ACTIONS(3663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3665),
    [anon_sym_VARIABLE] = ACTIONS(3665),
    [anon_sym_VARIABLES] = ACTIONS(3665),
    [anon_sym_CONSTANT] = ACTIONS(3665),
    [anon_sym_CONSTANTS] = ACTIONS(3665),
    [anon_sym_RECURSIVE] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3665),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3665),
    [anon_sym_u2115] = ACTIONS(3663),
    [anon_sym_Int] = ACTIONS(3665),
    [anon_sym_u2124] = ACTIONS(3663),
    [anon_sym_Real] = ACTIONS(3665),
    [anon_sym_u211d] = ACTIONS(3663),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3663),
    [anon_sym_BSLASHneg] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3665),
    [anon_sym_u00ac] = ACTIONS(3663),
    [sym_union] = ACTIONS(3665),
    [sym_powerset] = ACTIONS(3665),
    [sym_domain] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3663),
    [sym_enabled] = ACTIONS(3665),
    [sym_unchanged] = ACTIONS(3665),
    [anon_sym_LT_GT] = ACTIONS(3663),
    [anon_sym_u22c4] = ACTIONS(3663),
    [anon_sym_u25c7] = ACTIONS(3663),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3665),
    [anon_sym_ASSUMPTION] = ACTIONS(3665),
    [anon_sym_AXIOM] = ACTIONS(3665),
    [anon_sym_THEOREM] = ACTIONS(3665),
    [anon_sym_PROPOSITION] = ACTIONS(3665),
    [anon_sym_LEMMA] = ACTIONS(3665),
    [anon_sym_COROLLARY] = ACTIONS(3665),
    [anon_sym_USE] = ACTIONS(3665),
    [anon_sym_HIDE] = ACTIONS(3665),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1308] = {
    [sym_block_comment] = STATE(1308),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3657),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3655),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3655),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3655),
    [anon_sym_u25a1] = ACTIONS(3655),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3657),
    [anon_sym_VARIABLE] = ACTIONS(3657),
    [anon_sym_VARIABLES] = ACTIONS(3657),
    [anon_sym_CONSTANT] = ACTIONS(3657),
    [anon_sym_CONSTANTS] = ACTIONS(3657),
    [anon_sym_RECURSIVE] = ACTIONS(3657),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3657),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3657),
    [anon_sym_u2115] = ACTIONS(3655),
    [anon_sym_Int] = ACTIONS(3657),
    [anon_sym_u2124] = ACTIONS(3655),
    [anon_sym_Real] = ACTIONS(3657),
    [anon_sym_u211d] = ACTIONS(3655),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3655),
    [anon_sym_BSLASHneg] = ACTIONS(3655),
    [anon_sym_TILDE] = ACTIONS(3657),
    [anon_sym_u00ac] = ACTIONS(3655),
    [sym_union] = ACTIONS(3657),
    [sym_powerset] = ACTIONS(3657),
    [sym_domain] = ACTIONS(3657),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3655),
    [sym_enabled] = ACTIONS(3657),
    [sym_unchanged] = ACTIONS(3657),
    [anon_sym_LT_GT] = ACTIONS(3655),
    [anon_sym_u22c4] = ACTIONS(3655),
    [anon_sym_u25c7] = ACTIONS(3655),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3657),
    [anon_sym_ASSUMPTION] = ACTIONS(3657),
    [anon_sym_AXIOM] = ACTIONS(3657),
    [anon_sym_THEOREM] = ACTIONS(3657),
    [anon_sym_PROPOSITION] = ACTIONS(3657),
    [anon_sym_LEMMA] = ACTIONS(3657),
    [anon_sym_COROLLARY] = ACTIONS(3657),
    [anon_sym_USE] = ACTIONS(3657),
    [anon_sym_HIDE] = ACTIONS(3657),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1309] = {
    [sym_block_comment] = STATE(1309),
    [sym_implies] = STATE(527),
    [sym_plus_arrow] = STATE(528),
    [sym_equiv] = STATE(528),
    [sym_iff] = STATE(528),
    [sym_leads_to] = STATE(528),
    [sym_land] = STATE(529),
    [sym_lor] = STATE(529),
    [sym_assign] = STATE(519),
    [sym_bnf_rule] = STATE(519),
    [sym_eq] = STATE(519),
    [sym_neq] = STATE(519),
    [sym_lt] = STATE(519),
    [sym_leq] = STATE(519),
    [sym_geq] = STATE(519),
    [sym_approx] = STATE(519),
    [sym_rs_ttile] = STATE(519),
    [sym_rd_ttile] = STATE(519),
    [sym_ls_ttile] = STATE(519),
    [sym_ld_ttile] = STATE(519),
    [sym_asymp] = STATE(519),
    [sym_cong] = STATE(519),
    [sym_doteq] = STATE(519),
    [sym_gg] = STATE(519),
    [sym_ll] = STATE(519),
    [sym_in] = STATE(519),
    [sym_notin] = STATE(519),
    [sym_prec] = STATE(519),
    [sym_succ] = STATE(519),
    [sym_preceq] = STATE(519),
    [sym_succeq] = STATE(519),
    [sym_propto] = STATE(519),
    [sym_sim] = STATE(519),
    [sym_simeq] = STATE(519),
    [sym_sqsubset] = STATE(519),
    [sym_sqsupset] = STATE(519),
    [sym_sqsubseteq] = STATE(519),
    [sym_sqsupseteq] = STATE(519),
    [sym_subset] = STATE(519),
    [sym_supset] = STATE(519),
    [sym_subseteq] = STATE(519),
    [sym_supseteq] = STATE(519),
    [sym_cap] = STATE(522),
    [sym_cup] = STATE(522),
    [sym_dots_2] = STATE(530),
    [sym_dots_3] = STATE(530),
    [sym_plus] = STATE(523),
    [sym_oplus] = STATE(523),
    [sym_ominus] = STATE(524),
    [sym_vertvert] = STATE(524),
    [sym_minus] = STATE(524),
    [sym_odot] = STATE(525),
    [sym_oslash] = STATE(525),
    [sym_otimes] = STATE(525),
    [sym_bigcirc] = STATE(525),
    [sym_bullet] = STATE(525),
    [sym_div] = STATE(525),
    [sym_circ] = STATE(525),
    [sym_star] = STATE(525),
    [sym_excl] = STATE(525),
    [sym_qq] = STATE(525),
    [sym_sqcap] = STATE(525),
    [sym_sqcup] = STATE(525),
    [sym_uplus] = STATE(525),
    [sym_times] = STATE(525),
    [sym_wr] = STATE(526),
    [sym_cdot] = STATE(526),
    [sym_sup_plus] = STATE(2428),
    [sym_identifier] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(3679),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(3679),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3679),
    [anon_sym_u25a1] = ACTIONS(3679),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LOCAL] = ACTIONS(3681),
    [anon_sym_VARIABLE] = ACTIONS(3681),
    [anon_sym_VARIABLES] = ACTIONS(3681),
    [anon_sym_CONSTANT] = ACTIONS(3681),
    [anon_sym_CONSTANTS] = ACTIONS(3681),
    [anon_sym_RECURSIVE] = ACTIONS(3681),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_INSTANCE] = ACTIONS(3681),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3681),
    [anon_sym_u2115] = ACTIONS(3679),
    [anon_sym_Int] = ACTIONS(3681),
    [anon_sym_u2124] = ACTIONS(3679),
    [anon_sym_Real] = ACTIONS(3681),
    [anon_sym_u211d] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3567),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3679),
    [anon_sym_BSLASHneg] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3681),
    [anon_sym_u00ac] = ACTIONS(3679),
    [sym_union] = ACTIONS(3681),
    [sym_powerset] = ACTIONS(3681),
    [sym_domain] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3679),
    [sym_enabled] = ACTIONS(3681),
    [sym_unchanged] = ACTIONS(3681),
    [anon_sym_LT_GT] = ACTIONS(3679),
    [anon_sym_u22c4] = ACTIONS(3679),
    [anon_sym_u25c7] = ACTIONS(3679),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3569),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3571),
    [sym_map_to] = ACTIONS(3573),
    [sym_map_from] = ACTIONS(3573),
    [sym_setminus] = ACTIONS(3575),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3577),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3579),
    [sym_modmod] = ACTIONS(3581),
    [sym_vert] = ACTIONS(3579),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3579),
    [sym_amp] = ACTIONS(3583),
    [sym_ampamp] = ACTIONS(3585),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3583),
    [sym_mulmul] = ACTIONS(3585),
    [sym_slash] = ACTIONS(3583),
    [sym_slashslash] = ACTIONS(3585),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3585),
    [sym_dol] = ACTIONS(3583),
    [sym_doldol] = ACTIONS(3585),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3587),
    [sym_powpow] = ACTIONS(3589),
    [anon_sym_CARET_PLUS] = ACTIONS(3591),
    [anon_sym_u207a] = ACTIONS(3591),
    [sym_asterisk] = ACTIONS(3593),
    [sym_sup_hash] = ACTIONS(3593),
    [sym_prime] = ACTIONS(3593),
    [anon_sym_ASSUME] = ACTIONS(3681),
    [anon_sym_ASSUMPTION] = ACTIONS(3681),
    [anon_sym_AXIOM] = ACTIONS(3681),
    [anon_sym_THEOREM] = ACTIONS(3681),
    [anon_sym_PROPOSITION] = ACTIONS(3681),
    [anon_sym_LEMMA] = ACTIONS(3681),
    [anon_sym_COROLLARY] = ACTIONS(3681),
    [anon_sym_USE] = ACTIONS(3681),
    [anon_sym_HIDE] = ACTIONS(3681),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1310] = {
    [sym_block_comment] = STATE(1310),
    [sym_bound_op] = STATE(2929),
    [sym_bound_nonfix_op] = STATE(2929),
    [sym__number_set] = STATE(2929),
    [sym_nat_number_set] = STATE(2908),
    [sym_int_number_set] = STATE(2908),
    [sym_real_number_set] = STATE(2908),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5549),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5526),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5549),
    [sym_identifier] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1014),
    [anon_sym_u2115] = ACTIONS(1016),
    [anon_sym_Int] = ACTIONS(1018),
    [anon_sym_u2124] = ACTIONS(1020),
    [anon_sym_Real] = ACTIONS(1022),
    [anon_sym_u211d] = ACTIONS(1024),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1311] = {
    [sym_block_comment] = STATE(1311),
    [sym_bound_op] = STATE(3074),
    [sym_bound_nonfix_op] = STATE(3074),
    [sym__number_set] = STATE(3074),
    [sym_nat_number_set] = STATE(3060),
    [sym_int_number_set] = STATE(3060),
    [sym_real_number_set] = STATE(3060),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5386),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5536),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5386),
    [sym_identifier] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1778),
    [anon_sym_u2115] = ACTIONS(1780),
    [anon_sym_Int] = ACTIONS(1782),
    [anon_sym_u2124] = ACTIONS(1784),
    [anon_sym_Real] = ACTIONS(1786),
    [anon_sym_u211d] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1312] = {
    [sym_block_comment] = STATE(1312),
    [sym_bound_op] = STATE(3251),
    [sym_bound_nonfix_op] = STATE(3251),
    [sym__number_set] = STATE(3251),
    [sym_nat_number_set] = STATE(3301),
    [sym_int_number_set] = STATE(3301),
    [sym_real_number_set] = STATE(3301),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5353),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5530),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5353),
    [sym_identifier] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(2007),
    [anon_sym_u2115] = ACTIONS(2009),
    [anon_sym_Int] = ACTIONS(2011),
    [anon_sym_u2124] = ACTIONS(2013),
    [anon_sym_Real] = ACTIONS(2015),
    [anon_sym_u211d] = ACTIONS(2017),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1313] = {
    [sym_block_comment] = STATE(1313),
    [sym_bound_op] = STATE(2661),
    [sym_bound_nonfix_op] = STATE(2661),
    [sym__number_set] = STATE(2661),
    [sym_nat_number_set] = STATE(2630),
    [sym_int_number_set] = STATE(2630),
    [sym_real_number_set] = STATE(2630),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5290),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5519),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5290),
    [sym_identifier] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(516),
    [anon_sym_u2115] = ACTIONS(518),
    [anon_sym_Int] = ACTIONS(520),
    [anon_sym_u2124] = ACTIONS(522),
    [anon_sym_Real] = ACTIONS(524),
    [anon_sym_u211d] = ACTIONS(526),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1314] = {
    [sym_block_comment] = STATE(1314),
    [sym_bound_op] = STATE(3261),
    [sym_bound_nonfix_op] = STATE(3261),
    [sym__number_set] = STATE(3261),
    [sym_nat_number_set] = STATE(3303),
    [sym_int_number_set] = STATE(3303),
    [sym_real_number_set] = STATE(3303),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5441),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5546),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5441),
    [sym_identifier] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(636),
    [anon_sym_u2115] = ACTIONS(638),
    [anon_sym_Int] = ACTIONS(640),
    [anon_sym_u2124] = ACTIONS(642),
    [anon_sym_Real] = ACTIONS(644),
    [anon_sym_u211d] = ACTIONS(646),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1315] = {
    [sym_block_comment] = STATE(1315),
    [sym_bound_op] = STATE(2402),
    [sym_bound_nonfix_op] = STATE(2402),
    [sym__number_set] = STATE(2402),
    [sym_nat_number_set] = STATE(2490),
    [sym_int_number_set] = STATE(2490),
    [sym_real_number_set] = STATE(2490),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5397),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5538),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5397),
    [sym_identifier] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(558),
    [anon_sym_u2115] = ACTIONS(560),
    [anon_sym_Int] = ACTIONS(562),
    [anon_sym_u2124] = ACTIONS(564),
    [anon_sym_Real] = ACTIONS(566),
    [anon_sym_u211d] = ACTIONS(568),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1316] = {
    [sym_block_comment] = STATE(1316),
    [sym_bound_op] = STATE(2335),
    [sym_bound_nonfix_op] = STATE(2335),
    [sym__number_set] = STATE(2335),
    [sym_nat_number_set] = STATE(2325),
    [sym_int_number_set] = STATE(2325),
    [sym_real_number_set] = STATE(2325),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5408),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5540),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5408),
    [sym_identifier] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1740),
    [anon_sym_u2115] = ACTIONS(1742),
    [anon_sym_Int] = ACTIONS(1744),
    [anon_sym_u2124] = ACTIONS(1746),
    [anon_sym_Real] = ACTIONS(1748),
    [anon_sym_u211d] = ACTIONS(1750),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1317] = {
    [sym_block_comment] = STATE(1317),
    [sym_bound_op] = STATE(3175),
    [sym_bound_nonfix_op] = STATE(3175),
    [sym__number_set] = STATE(3175),
    [sym_nat_number_set] = STATE(3262),
    [sym_int_number_set] = STATE(3262),
    [sym_real_number_set] = STATE(3262),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5375),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5534),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5375),
    [sym_identifier] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(2073),
    [anon_sym_u2115] = ACTIONS(2075),
    [anon_sym_Int] = ACTIONS(2077),
    [anon_sym_u2124] = ACTIONS(2079),
    [anon_sym_Real] = ACTIONS(2081),
    [anon_sym_u211d] = ACTIONS(2083),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1318] = {
    [sym_block_comment] = STATE(1318),
    [sym_bound_op] = STATE(2699),
    [sym_bound_nonfix_op] = STATE(2699),
    [sym__number_set] = STATE(2699),
    [sym_nat_number_set] = STATE(2673),
    [sym_int_number_set] = STATE(2673),
    [sym_real_number_set] = STATE(2673),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5364),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5532),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5364),
    [sym_identifier] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1239),
    [anon_sym_u2115] = ACTIONS(1241),
    [anon_sym_Int] = ACTIONS(1243),
    [anon_sym_u2124] = ACTIONS(1245),
    [anon_sym_Real] = ACTIONS(1247),
    [anon_sym_u211d] = ACTIONS(1249),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1319] = {
    [sym_block_comment] = STATE(1319),
    [sym_bound_op] = STATE(2658),
    [sym_bound_nonfix_op] = STATE(2658),
    [sym__number_set] = STATE(2658),
    [sym_nat_number_set] = STATE(2647),
    [sym_int_number_set] = STATE(2647),
    [sym_real_number_set] = STATE(2647),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5419),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5542),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5419),
    [sym_identifier] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1054),
    [anon_sym_u2115] = ACTIONS(1056),
    [anon_sym_Int] = ACTIONS(1058),
    [anon_sym_u2124] = ACTIONS(1060),
    [anon_sym_Real] = ACTIONS(1062),
    [anon_sym_u211d] = ACTIONS(1064),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1320] = {
    [sym_block_comment] = STATE(1320),
    [sym_bound_op] = STATE(2787),
    [sym_bound_nonfix_op] = STATE(2787),
    [sym__number_set] = STATE(2787),
    [sym_nat_number_set] = STATE(2775),
    [sym_int_number_set] = STATE(2775),
    [sym_real_number_set] = STATE(2775),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5449),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5548),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5449),
    [sym_identifier] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1104),
    [anon_sym_u2115] = ACTIONS(1106),
    [anon_sym_Int] = ACTIONS(1108),
    [anon_sym_u2124] = ACTIONS(1110),
    [anon_sym_Real] = ACTIONS(1112),
    [anon_sym_u211d] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1321] = {
    [sym_block_comment] = STATE(1321),
    [sym_bound_op] = STATE(3405),
    [sym_bound_nonfix_op] = STATE(3405),
    [sym__number_set] = STATE(3405),
    [sym_nat_number_set] = STATE(3411),
    [sym_int_number_set] = STATE(3411),
    [sym_real_number_set] = STATE(3411),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5342),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5528),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5342),
    [sym_identifier] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1944),
    [anon_sym_u2115] = ACTIONS(1946),
    [anon_sym_Int] = ACTIONS(1948),
    [anon_sym_u2124] = ACTIONS(1950),
    [anon_sym_Real] = ACTIONS(1952),
    [anon_sym_u211d] = ACTIONS(1954),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1322] = {
    [sym_block_comment] = STATE(1322),
    [sym_bound_op] = STATE(3123),
    [sym_bound_nonfix_op] = STATE(3123),
    [sym__number_set] = STATE(3123),
    [sym_nat_number_set] = STATE(3149),
    [sym_int_number_set] = STATE(3149),
    [sym_real_number_set] = STATE(3149),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5306),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5522),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5306),
    [sym_identifier] = ACTIONS(2134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1503),
    [anon_sym_u2115] = ACTIONS(1505),
    [anon_sym_Int] = ACTIONS(1507),
    [anon_sym_u2124] = ACTIONS(1509),
    [anon_sym_Real] = ACTIONS(1511),
    [anon_sym_u211d] = ACTIONS(1513),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1323] = {
    [sym_block_comment] = STATE(1323),
    [sym_bound_op] = STATE(2338),
    [sym_bound_nonfix_op] = STATE(2338),
    [sym__number_set] = STATE(2338),
    [sym_nat_number_set] = STATE(2312),
    [sym_int_number_set] = STATE(2312),
    [sym_real_number_set] = STATE(2312),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5246),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5515),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5246),
    [sym_identifier] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1670),
    [anon_sym_u2115] = ACTIONS(1672),
    [anon_sym_Int] = ACTIONS(1674),
    [anon_sym_u2124] = ACTIONS(1676),
    [anon_sym_Real] = ACTIONS(1678),
    [anon_sym_u211d] = ACTIONS(1680),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1324] = {
    [sym_block_comment] = STATE(1324),
    [sym_bound_op] = STATE(5484),
    [sym_bound_nonfix_op] = STATE(5484),
    [sym__number_set] = STATE(5484),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5320),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5524),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5320),
    [sym_identifier] = ACTIONS(3683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1325] = {
    [sym_block_comment] = STATE(1325),
    [sym_bound_op] = STATE(2872),
    [sym_bound_nonfix_op] = STATE(2872),
    [sym__number_set] = STATE(2872),
    [sym_nat_number_set] = STATE(2890),
    [sym_int_number_set] = STATE(2890),
    [sym_real_number_set] = STATE(2890),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5430),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5544),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5430),
    [sym_identifier] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(1881),
    [anon_sym_u2115] = ACTIONS(1883),
    [anon_sym_Int] = ACTIONS(1885),
    [anon_sym_u2124] = ACTIONS(1887),
    [anon_sym_Real] = ACTIONS(1889),
    [anon_sym_u211d] = ACTIONS(1891),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1326] = {
    [sym_block_comment] = STATE(1326),
    [sym_bound_op] = STATE(2498),
    [sym_bound_nonfix_op] = STATE(2498),
    [sym__number_set] = STATE(2498),
    [sym_nat_number_set] = STATE(2400),
    [sym_int_number_set] = STATE(2400),
    [sym_real_number_set] = STATE(2400),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5398),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5399),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(5398),
    [sym_identifier] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_Nat] = ACTIONS(582),
    [anon_sym_u2115] = ACTIONS(584),
    [anon_sym_Int] = ACTIONS(586),
    [anon_sym_u2124] = ACTIONS(588),
    [anon_sym_Real] = ACTIONS(590),
    [anon_sym_u211d] = ACTIONS(592),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1327] = {
    [sym_block_comment] = STATE(1327),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3513),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3513),
    [anon_sym_u2115] = ACTIONS(3511),
    [anon_sym_Int] = ACTIONS(3513),
    [anon_sym_u2124] = ACTIONS(3511),
    [anon_sym_Real] = ACTIONS(3513),
    [anon_sym_u211d] = ACTIONS(3511),
    [anon_sym_RBRACE] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3511),
    [anon_sym_BSLASHneg] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3513),
    [anon_sym_u00ac] = ACTIONS(3511),
    [sym_union] = ACTIONS(3513),
    [sym_powerset] = ACTIONS(3513),
    [sym_domain] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3511),
    [sym_enabled] = ACTIONS(3513),
    [sym_unchanged] = ACTIONS(3513),
    [anon_sym_LT_GT] = ACTIONS(3511),
    [anon_sym_u22c4] = ACTIONS(3511),
    [anon_sym_u25c7] = ACTIONS(3511),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3513),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1328] = {
    [sym_block_comment] = STATE(1328),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3497),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1329] = {
    [sym_block_comment] = STATE(1329),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [anon_sym_end] = ACTIONS(3497),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1330] = {
    [sym_block_comment] = STATE(1330),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3497),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1331] = {
    [sym_block_comment] = STATE(1331),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3497),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3497),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1332] = {
    [sym_block_comment] = STATE(1332),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3533),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3533),
    [anon_sym_u2115] = ACTIONS(3531),
    [anon_sym_Int] = ACTIONS(3533),
    [anon_sym_u2124] = ACTIONS(3531),
    [anon_sym_Real] = ACTIONS(3533),
    [anon_sym_u211d] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3531),
    [anon_sym_BSLASHneg] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_u00ac] = ACTIONS(3531),
    [sym_union] = ACTIONS(3533),
    [sym_powerset] = ACTIONS(3533),
    [sym_domain] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3531),
    [sym_enabled] = ACTIONS(3533),
    [sym_unchanged] = ACTIONS(3533),
    [anon_sym_LT_GT] = ACTIONS(3531),
    [anon_sym_u22c4] = ACTIONS(3531),
    [anon_sym_u25c7] = ACTIONS(3531),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3533),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1333] = {
    [sym_block_comment] = STATE(1333),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1334] = {
    [sym_block_comment] = STATE(1334),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1335] = {
    [sym_block_comment] = STATE(1335),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1336] = {
    [sym_block_comment] = STATE(1336),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1337] = {
    [sym_block_comment] = STATE(1337),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1338] = {
    [sym_block_comment] = STATE(1338),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1339] = {
    [sym_block_comment] = STATE(1339),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1340] = {
    [sym_block_comment] = STATE(1340),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1341] = {
    [sym_block_comment] = STATE(1341),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1342] = {
    [sym_block_comment] = STATE(1342),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1343] = {
    [sym_block_comment] = STATE(1343),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1344] = {
    [sym_block_comment] = STATE(1344),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3493),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1345] = {
    [sym_block_comment] = STATE(1345),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3535),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3535),
    [anon_sym_u2115] = ACTIONS(3537),
    [anon_sym_Int] = ACTIONS(3535),
    [anon_sym_u2124] = ACTIONS(3537),
    [anon_sym_Real] = ACTIONS(3535),
    [anon_sym_u211d] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3537),
    [anon_sym_BSLASHneg] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3535),
    [anon_sym_u00ac] = ACTIONS(3537),
    [sym_union] = ACTIONS(3535),
    [sym_powerset] = ACTIONS(3535),
    [sym_domain] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3537),
    [sym_enabled] = ACTIONS(3535),
    [sym_unchanged] = ACTIONS(3535),
    [anon_sym_LT_GT] = ACTIONS(3537),
    [anon_sym_u22c4] = ACTIONS(3537),
    [anon_sym_u25c7] = ACTIONS(3537),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3535),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1346] = {
    [sym_block_comment] = STATE(1346),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3539),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3539),
    [anon_sym_u2115] = ACTIONS(3541),
    [anon_sym_Int] = ACTIONS(3539),
    [anon_sym_u2124] = ACTIONS(3541),
    [anon_sym_Real] = ACTIONS(3539),
    [anon_sym_u211d] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(3541),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3541),
    [anon_sym_BSLASHneg] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_u00ac] = ACTIONS(3541),
    [sym_union] = ACTIONS(3539),
    [sym_powerset] = ACTIONS(3539),
    [sym_domain] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3541),
    [sym_enabled] = ACTIONS(3539),
    [sym_unchanged] = ACTIONS(3539),
    [anon_sym_LT_GT] = ACTIONS(3541),
    [anon_sym_u22c4] = ACTIONS(3541),
    [anon_sym_u25c7] = ACTIONS(3541),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3539),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1347] = {
    [sym_block_comment] = STATE(1347),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3543),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3543),
    [anon_sym_u2115] = ACTIONS(3545),
    [anon_sym_Int] = ACTIONS(3543),
    [anon_sym_u2124] = ACTIONS(3545),
    [anon_sym_Real] = ACTIONS(3543),
    [anon_sym_u211d] = ACTIONS(3545),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3545),
    [anon_sym_BSLASHneg] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3543),
    [anon_sym_u00ac] = ACTIONS(3545),
    [sym_union] = ACTIONS(3543),
    [sym_powerset] = ACTIONS(3543),
    [sym_domain] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3545),
    [sym_enabled] = ACTIONS(3543),
    [sym_unchanged] = ACTIONS(3543),
    [anon_sym_LT_GT] = ACTIONS(3545),
    [anon_sym_u22c4] = ACTIONS(3545),
    [anon_sym_u25c7] = ACTIONS(3545),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3543),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1348] = {
    [sym_block_comment] = STATE(1348),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3551),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3551),
    [anon_sym_u2115] = ACTIONS(3553),
    [anon_sym_Int] = ACTIONS(3551),
    [anon_sym_u2124] = ACTIONS(3553),
    [anon_sym_Real] = ACTIONS(3551),
    [anon_sym_u211d] = ACTIONS(3553),
    [anon_sym_RBRACE] = ACTIONS(3553),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3553),
    [anon_sym_BSLASHneg] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3551),
    [anon_sym_u00ac] = ACTIONS(3553),
    [sym_union] = ACTIONS(3551),
    [sym_powerset] = ACTIONS(3551),
    [sym_domain] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3553),
    [sym_enabled] = ACTIONS(3551),
    [sym_unchanged] = ACTIONS(3551),
    [anon_sym_LT_GT] = ACTIONS(3553),
    [anon_sym_u22c4] = ACTIONS(3553),
    [anon_sym_u25c7] = ACTIONS(3553),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3551),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1349] = {
    [sym_block_comment] = STATE(1349),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3555),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3555),
    [anon_sym_u2115] = ACTIONS(3557),
    [anon_sym_Int] = ACTIONS(3555),
    [anon_sym_u2124] = ACTIONS(3557),
    [anon_sym_Real] = ACTIONS(3555),
    [anon_sym_u211d] = ACTIONS(3557),
    [anon_sym_RBRACE] = ACTIONS(3557),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3557),
    [anon_sym_BSLASHneg] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3555),
    [anon_sym_u00ac] = ACTIONS(3557),
    [sym_union] = ACTIONS(3555),
    [sym_powerset] = ACTIONS(3555),
    [sym_domain] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3557),
    [sym_enabled] = ACTIONS(3555),
    [sym_unchanged] = ACTIONS(3555),
    [anon_sym_LT_GT] = ACTIONS(3557),
    [anon_sym_u22c4] = ACTIONS(3557),
    [anon_sym_u25c7] = ACTIONS(3557),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3555),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1350] = {
    [sym_block_comment] = STATE(1350),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3523),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3523),
    [anon_sym_u2115] = ACTIONS(3525),
    [anon_sym_Int] = ACTIONS(3523),
    [anon_sym_u2124] = ACTIONS(3525),
    [anon_sym_Real] = ACTIONS(3523),
    [anon_sym_u211d] = ACTIONS(3525),
    [anon_sym_RBRACE] = ACTIONS(3525),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3525),
    [anon_sym_BSLASHneg] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_u00ac] = ACTIONS(3525),
    [sym_union] = ACTIONS(3523),
    [sym_powerset] = ACTIONS(3523),
    [sym_domain] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3525),
    [sym_enabled] = ACTIONS(3523),
    [sym_unchanged] = ACTIONS(3523),
    [anon_sym_LT_GT] = ACTIONS(3525),
    [anon_sym_u22c4] = ACTIONS(3525),
    [anon_sym_u25c7] = ACTIONS(3525),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3523),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1351] = {
    [sym_block_comment] = STATE(1351),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3527),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3527),
    [anon_sym_u2115] = ACTIONS(3529),
    [anon_sym_Int] = ACTIONS(3527),
    [anon_sym_u2124] = ACTIONS(3529),
    [anon_sym_Real] = ACTIONS(3527),
    [anon_sym_u211d] = ACTIONS(3529),
    [anon_sym_RBRACE] = ACTIONS(3529),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3529),
    [anon_sym_BSLASHneg] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_u00ac] = ACTIONS(3529),
    [sym_union] = ACTIONS(3527),
    [sym_powerset] = ACTIONS(3527),
    [sym_domain] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3529),
    [sym_enabled] = ACTIONS(3527),
    [sym_unchanged] = ACTIONS(3527),
    [anon_sym_LT_GT] = ACTIONS(3529),
    [anon_sym_u22c4] = ACTIONS(3529),
    [anon_sym_u25c7] = ACTIONS(3529),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3527),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1352] = {
    [sym_block_comment] = STATE(1352),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3501),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3501),
    [anon_sym_u2115] = ACTIONS(3499),
    [anon_sym_Int] = ACTIONS(3501),
    [anon_sym_u2124] = ACTIONS(3499),
    [anon_sym_Real] = ACTIONS(3501),
    [anon_sym_u211d] = ACTIONS(3499),
    [anon_sym_RBRACE] = ACTIONS(3499),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3499),
    [anon_sym_BSLASHneg] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_u00ac] = ACTIONS(3499),
    [sym_union] = ACTIONS(3501),
    [sym_powerset] = ACTIONS(3501),
    [sym_domain] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3499),
    [sym_enabled] = ACTIONS(3501),
    [sym_unchanged] = ACTIONS(3501),
    [anon_sym_LT_GT] = ACTIONS(3499),
    [anon_sym_u22c4] = ACTIONS(3499),
    [anon_sym_u25c7] = ACTIONS(3499),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3501),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1353] = {
    [sym_block_comment] = STATE(1353),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3505),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3505),
    [anon_sym_u2115] = ACTIONS(3503),
    [anon_sym_Int] = ACTIONS(3505),
    [anon_sym_u2124] = ACTIONS(3503),
    [anon_sym_Real] = ACTIONS(3505),
    [anon_sym_u211d] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3503),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3503),
    [anon_sym_BSLASHneg] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_u00ac] = ACTIONS(3503),
    [sym_union] = ACTIONS(3505),
    [sym_powerset] = ACTIONS(3505),
    [sym_domain] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3503),
    [sym_enabled] = ACTIONS(3505),
    [sym_unchanged] = ACTIONS(3505),
    [anon_sym_LT_GT] = ACTIONS(3503),
    [anon_sym_u22c4] = ACTIONS(3503),
    [anon_sym_u25c7] = ACTIONS(3503),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3505),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1354] = {
    [sym_block_comment] = STATE(1354),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3509),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3509),
    [anon_sym_u2115] = ACTIONS(3507),
    [anon_sym_Int] = ACTIONS(3509),
    [anon_sym_u2124] = ACTIONS(3507),
    [anon_sym_Real] = ACTIONS(3509),
    [anon_sym_u211d] = ACTIONS(3507),
    [anon_sym_RBRACE] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3507),
    [anon_sym_BSLASHneg] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [anon_sym_u00ac] = ACTIONS(3507),
    [sym_union] = ACTIONS(3509),
    [sym_powerset] = ACTIONS(3509),
    [sym_domain] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3507),
    [sym_enabled] = ACTIONS(3509),
    [sym_unchanged] = ACTIONS(3509),
    [anon_sym_LT_GT] = ACTIONS(3507),
    [anon_sym_u22c4] = ACTIONS(3507),
    [anon_sym_u25c7] = ACTIONS(3507),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3509),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1355] = {
    [sym_block_comment] = STATE(1355),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3641),
    [anon_sym_u25a1] = ACTIONS(3641),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3639),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3639),
    [anon_sym_u2115] = ACTIONS(3641),
    [anon_sym_Int] = ACTIONS(3639),
    [anon_sym_u2124] = ACTIONS(3641),
    [anon_sym_Real] = ACTIONS(3639),
    [anon_sym_u211d] = ACTIONS(3641),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3641),
    [anon_sym_BSLASHneg] = ACTIONS(3641),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_u00ac] = ACTIONS(3641),
    [sym_union] = ACTIONS(3639),
    [sym_powerset] = ACTIONS(3639),
    [sym_domain] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3641),
    [sym_enabled] = ACTIONS(3639),
    [sym_unchanged] = ACTIONS(3639),
    [anon_sym_LT_GT] = ACTIONS(3641),
    [anon_sym_u22c4] = ACTIONS(3641),
    [anon_sym_u25c7] = ACTIONS(3641),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3639),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1356] = {
    [sym_block_comment] = STATE(1356),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3497),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_RPAREN] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3495),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3495),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_THEN] = ACTIONS(3495),
    [anon_sym_ELSE] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3495),
    [anon_sym_end] = ACTIONS(3495),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym_define] = ACTIONS(3495),
    [anon_sym_macro] = ACTIONS(3495),
    [anon_sym_procedure] = ACTIONS(3495),
    [anon_sym_fair] = ACTIONS(3495),
    [anon_sym_process] = ACTIONS(3495),
    [anon_sym_variable] = ACTIONS(3497),
    [anon_sym_variables] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3495),
    [anon_sym_then] = ACTIONS(3495),
    [anon_sym_elsif] = ACTIONS(3495),
    [anon_sym_else] = ACTIONS(3495),
    [anon_sym_do] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1357] = {
    [sym_block_comment] = STATE(1357),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3497),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_RPAREN] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3495),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3495),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_THEN] = ACTIONS(3495),
    [anon_sym_ELSE] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [anon_sym_PROVE] = ACTIONS(3495),
    [anon_sym_end] = ACTIONS(3495),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym_define] = ACTIONS(3495),
    [anon_sym_macro] = ACTIONS(3495),
    [anon_sym_procedure] = ACTIONS(3495),
    [anon_sym_fair] = ACTIONS(3495),
    [anon_sym_process] = ACTIONS(3495),
    [anon_sym_variable] = ACTIONS(3497),
    [anon_sym_variables] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3495),
    [anon_sym_then] = ACTIONS(3495),
    [anon_sym_elsif] = ACTIONS(3495),
    [anon_sym_else] = ACTIONS(3495),
    [anon_sym_do] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1358] = {
    [sym_block_comment] = STATE(1358),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3497),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_RPAREN] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3495),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3495),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3495),
    [anon_sym_ELSE] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3495),
    [anon_sym_end] = ACTIONS(3495),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym_define] = ACTIONS(3495),
    [anon_sym_macro] = ACTIONS(3495),
    [anon_sym_procedure] = ACTIONS(3495),
    [anon_sym_fair] = ACTIONS(3495),
    [anon_sym_process] = ACTIONS(3495),
    [anon_sym_variable] = ACTIONS(3497),
    [anon_sym_variables] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3495),
    [anon_sym_then] = ACTIONS(3495),
    [anon_sym_elsif] = ACTIONS(3495),
    [anon_sym_else] = ACTIONS(3495),
    [anon_sym_do] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1359] = {
    [sym_block_comment] = STATE(1359),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_COLON] = ACTIONS(3497),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_RPAREN] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3495),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3495),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_THEN] = ACTIONS(3495),
    [anon_sym_ELSE] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3495),
    [anon_sym_end] = ACTIONS(3495),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym_define] = ACTIONS(3495),
    [anon_sym_macro] = ACTIONS(3495),
    [anon_sym_procedure] = ACTIONS(3495),
    [anon_sym_fair] = ACTIONS(3495),
    [anon_sym_process] = ACTIONS(3495),
    [anon_sym_variable] = ACTIONS(3497),
    [anon_sym_variables] = ACTIONS(3495),
    [anon_sym_begin] = ACTIONS(3495),
    [anon_sym_then] = ACTIONS(3495),
    [anon_sym_elsif] = ACTIONS(3495),
    [anon_sym_else] = ACTIONS(3495),
    [anon_sym_do] = ACTIONS(3495),
    [anon_sym_or] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1360] = {
    [sym_block_comment] = STATE(1360),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_COLON] = ACTIONS(3533),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_RPAREN] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3531),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3531),
    [anon_sym_ELSE] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3531),
    [anon_sym_end] = ACTIONS(3531),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_define] = ACTIONS(3531),
    [anon_sym_macro] = ACTIONS(3531),
    [anon_sym_procedure] = ACTIONS(3531),
    [anon_sym_fair] = ACTIONS(3531),
    [anon_sym_process] = ACTIONS(3531),
    [anon_sym_variable] = ACTIONS(3533),
    [anon_sym_variables] = ACTIONS(3531),
    [anon_sym_begin] = ACTIONS(3531),
    [anon_sym_then] = ACTIONS(3531),
    [anon_sym_elsif] = ACTIONS(3531),
    [anon_sym_else] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_or] = ACTIONS(3531),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1361] = {
    [sym_block_comment] = STATE(1361),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3491),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_THEN] = ACTIONS(3491),
    [anon_sym_ELSE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3491),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_define] = ACTIONS(3491),
    [anon_sym_macro] = ACTIONS(3491),
    [anon_sym_procedure] = ACTIONS(3491),
    [anon_sym_fair] = ACTIONS(3491),
    [anon_sym_process] = ACTIONS(3491),
    [anon_sym_variable] = ACTIONS(3493),
    [anon_sym_variables] = ACTIONS(3491),
    [anon_sym_begin] = ACTIONS(3491),
    [anon_sym_then] = ACTIONS(3491),
    [anon_sym_elsif] = ACTIONS(3491),
    [anon_sym_else] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_or] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1362] = {
    [sym_block_comment] = STATE(1362),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3491),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_THEN] = ACTIONS(3491),
    [anon_sym_ELSE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3491),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_define] = ACTIONS(3491),
    [anon_sym_macro] = ACTIONS(3491),
    [anon_sym_procedure] = ACTIONS(3491),
    [anon_sym_fair] = ACTIONS(3491),
    [anon_sym_process] = ACTIONS(3491),
    [anon_sym_variable] = ACTIONS(3493),
    [anon_sym_variables] = ACTIONS(3491),
    [anon_sym_begin] = ACTIONS(3491),
    [anon_sym_then] = ACTIONS(3491),
    [anon_sym_elsif] = ACTIONS(3491),
    [anon_sym_else] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_or] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1363] = {
    [sym_block_comment] = STATE(1363),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3491),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_THEN] = ACTIONS(3491),
    [anon_sym_ELSE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3491),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_define] = ACTIONS(3491),
    [anon_sym_macro] = ACTIONS(3491),
    [anon_sym_procedure] = ACTIONS(3491),
    [anon_sym_fair] = ACTIONS(3491),
    [anon_sym_process] = ACTIONS(3491),
    [anon_sym_variable] = ACTIONS(3493),
    [anon_sym_variables] = ACTIONS(3491),
    [anon_sym_begin] = ACTIONS(3491),
    [anon_sym_then] = ACTIONS(3491),
    [anon_sym_elsif] = ACTIONS(3491),
    [anon_sym_else] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_or] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1364] = {
    [sym_block_comment] = STATE(1364),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3491),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_THEN] = ACTIONS(3491),
    [anon_sym_ELSE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3491),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_define] = ACTIONS(3491),
    [anon_sym_macro] = ACTIONS(3491),
    [anon_sym_procedure] = ACTIONS(3491),
    [anon_sym_fair] = ACTIONS(3491),
    [anon_sym_process] = ACTIONS(3491),
    [anon_sym_variable] = ACTIONS(3493),
    [anon_sym_variables] = ACTIONS(3491),
    [anon_sym_begin] = ACTIONS(3491),
    [anon_sym_then] = ACTIONS(3491),
    [anon_sym_elsif] = ACTIONS(3491),
    [anon_sym_else] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_or] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1365] = {
    [sym_block_comment] = STATE(1365),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3491),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_THEN] = ACTIONS(3491),
    [anon_sym_ELSE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3491),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_define] = ACTIONS(3491),
    [anon_sym_macro] = ACTIONS(3491),
    [anon_sym_procedure] = ACTIONS(3491),
    [anon_sym_fair] = ACTIONS(3491),
    [anon_sym_process] = ACTIONS(3491),
    [anon_sym_variable] = ACTIONS(3493),
    [anon_sym_variables] = ACTIONS(3491),
    [anon_sym_begin] = ACTIONS(3491),
    [anon_sym_then] = ACTIONS(3491),
    [anon_sym_elsif] = ACTIONS(3491),
    [anon_sym_else] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_or] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1366] = {
    [sym_block_comment] = STATE(1366),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3491),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_THEN] = ACTIONS(3491),
    [anon_sym_ELSE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3491),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_define] = ACTIONS(3491),
    [anon_sym_macro] = ACTIONS(3491),
    [anon_sym_procedure] = ACTIONS(3491),
    [anon_sym_fair] = ACTIONS(3491),
    [anon_sym_process] = ACTIONS(3491),
    [anon_sym_variable] = ACTIONS(3493),
    [anon_sym_variables] = ACTIONS(3491),
    [anon_sym_begin] = ACTIONS(3491),
    [anon_sym_then] = ACTIONS(3491),
    [anon_sym_elsif] = ACTIONS(3491),
    [anon_sym_else] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_or] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1367] = {
    [sym_block_comment] = STATE(1367),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3491),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_THEN] = ACTIONS(3491),
    [anon_sym_ELSE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3491),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_define] = ACTIONS(3491),
    [anon_sym_macro] = ACTIONS(3491),
    [anon_sym_procedure] = ACTIONS(3491),
    [anon_sym_fair] = ACTIONS(3491),
    [anon_sym_process] = ACTIONS(3491),
    [anon_sym_variable] = ACTIONS(3493),
    [anon_sym_variables] = ACTIONS(3491),
    [anon_sym_begin] = ACTIONS(3491),
    [anon_sym_then] = ACTIONS(3491),
    [anon_sym_elsif] = ACTIONS(3491),
    [anon_sym_else] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_or] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1368] = {
    [sym_block_comment] = STATE(1368),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3491),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_THEN] = ACTIONS(3491),
    [anon_sym_ELSE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3491),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_define] = ACTIONS(3491),
    [anon_sym_macro] = ACTIONS(3491),
    [anon_sym_procedure] = ACTIONS(3491),
    [anon_sym_fair] = ACTIONS(3491),
    [anon_sym_process] = ACTIONS(3491),
    [anon_sym_variable] = ACTIONS(3493),
    [anon_sym_variables] = ACTIONS(3491),
    [anon_sym_begin] = ACTIONS(3491),
    [anon_sym_then] = ACTIONS(3491),
    [anon_sym_elsif] = ACTIONS(3491),
    [anon_sym_else] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_or] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1369] = {
    [sym_block_comment] = STATE(1369),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3491),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3491),
    [anon_sym_ELSE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3491),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_define] = ACTIONS(3491),
    [anon_sym_macro] = ACTIONS(3491),
    [anon_sym_procedure] = ACTIONS(3491),
    [anon_sym_fair] = ACTIONS(3491),
    [anon_sym_process] = ACTIONS(3491),
    [anon_sym_variable] = ACTIONS(3493),
    [anon_sym_variables] = ACTIONS(3491),
    [anon_sym_begin] = ACTIONS(3491),
    [anon_sym_then] = ACTIONS(3491),
    [anon_sym_elsif] = ACTIONS(3491),
    [anon_sym_else] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_or] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1370] = {
    [sym_block_comment] = STATE(1370),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3491),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3491),
    [anon_sym_ELSE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3491),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_define] = ACTIONS(3491),
    [anon_sym_macro] = ACTIONS(3491),
    [anon_sym_procedure] = ACTIONS(3491),
    [anon_sym_fair] = ACTIONS(3491),
    [anon_sym_process] = ACTIONS(3491),
    [anon_sym_variable] = ACTIONS(3493),
    [anon_sym_variables] = ACTIONS(3491),
    [anon_sym_begin] = ACTIONS(3491),
    [anon_sym_then] = ACTIONS(3491),
    [anon_sym_elsif] = ACTIONS(3491),
    [anon_sym_else] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_or] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1371] = {
    [sym_block_comment] = STATE(1371),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3491),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3491),
    [anon_sym_ELSE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3491),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_define] = ACTIONS(3491),
    [anon_sym_macro] = ACTIONS(3491),
    [anon_sym_procedure] = ACTIONS(3491),
    [anon_sym_fair] = ACTIONS(3491),
    [anon_sym_process] = ACTIONS(3491),
    [anon_sym_variable] = ACTIONS(3493),
    [anon_sym_variables] = ACTIONS(3491),
    [anon_sym_begin] = ACTIONS(3491),
    [anon_sym_then] = ACTIONS(3491),
    [anon_sym_elsif] = ACTIONS(3491),
    [anon_sym_else] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_or] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1372] = {
    [sym_block_comment] = STATE(1372),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3491),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3491),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_THEN] = ACTIONS(3491),
    [anon_sym_ELSE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3491),
    [anon_sym_end] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_define] = ACTIONS(3491),
    [anon_sym_macro] = ACTIONS(3491),
    [anon_sym_procedure] = ACTIONS(3491),
    [anon_sym_fair] = ACTIONS(3491),
    [anon_sym_process] = ACTIONS(3491),
    [anon_sym_variable] = ACTIONS(3493),
    [anon_sym_variables] = ACTIONS(3491),
    [anon_sym_begin] = ACTIONS(3491),
    [anon_sym_then] = ACTIONS(3491),
    [anon_sym_elsif] = ACTIONS(3491),
    [anon_sym_else] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_or] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1373] = {
    [sym_block_comment] = STATE(1373),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3535),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3537),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3537),
    [anon_sym_ELSE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3537),
    [anon_sym_end] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_define] = ACTIONS(3537),
    [anon_sym_macro] = ACTIONS(3537),
    [anon_sym_procedure] = ACTIONS(3537),
    [anon_sym_fair] = ACTIONS(3537),
    [anon_sym_process] = ACTIONS(3537),
    [anon_sym_variable] = ACTIONS(3535),
    [anon_sym_variables] = ACTIONS(3537),
    [anon_sym_begin] = ACTIONS(3537),
    [anon_sym_then] = ACTIONS(3537),
    [anon_sym_elsif] = ACTIONS(3537),
    [anon_sym_else] = ACTIONS(3537),
    [anon_sym_do] = ACTIONS(3537),
    [anon_sym_or] = ACTIONS(3537),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1374] = {
    [sym_block_comment] = STATE(1374),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_RPAREN] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3541),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(3541),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3541),
    [anon_sym_ELSE] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3541),
    [anon_sym_end] = ACTIONS(3541),
    [anon_sym_SEMI] = ACTIONS(3541),
    [anon_sym_define] = ACTIONS(3541),
    [anon_sym_macro] = ACTIONS(3541),
    [anon_sym_procedure] = ACTIONS(3541),
    [anon_sym_fair] = ACTIONS(3541),
    [anon_sym_process] = ACTIONS(3541),
    [anon_sym_variable] = ACTIONS(3539),
    [anon_sym_variables] = ACTIONS(3541),
    [anon_sym_begin] = ACTIONS(3541),
    [anon_sym_then] = ACTIONS(3541),
    [anon_sym_elsif] = ACTIONS(3541),
    [anon_sym_else] = ACTIONS(3541),
    [anon_sym_do] = ACTIONS(3541),
    [anon_sym_or] = ACTIONS(3541),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1375] = {
    [sym_block_comment] = STATE(1375),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_RPAREN] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3545),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3545),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3545),
    [anon_sym_ELSE] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3545),
    [anon_sym_end] = ACTIONS(3545),
    [anon_sym_SEMI] = ACTIONS(3545),
    [anon_sym_define] = ACTIONS(3545),
    [anon_sym_macro] = ACTIONS(3545),
    [anon_sym_procedure] = ACTIONS(3545),
    [anon_sym_fair] = ACTIONS(3545),
    [anon_sym_process] = ACTIONS(3545),
    [anon_sym_variable] = ACTIONS(3543),
    [anon_sym_variables] = ACTIONS(3545),
    [anon_sym_begin] = ACTIONS(3545),
    [anon_sym_then] = ACTIONS(3545),
    [anon_sym_elsif] = ACTIONS(3545),
    [anon_sym_else] = ACTIONS(3545),
    [anon_sym_do] = ACTIONS(3545),
    [anon_sym_or] = ACTIONS(3545),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1376] = {
    [sym_block_comment] = STATE(1376),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(3553),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3553),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3553),
    [anon_sym_RBRACE] = ACTIONS(3553),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3553),
    [anon_sym_ELSE] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3553),
    [anon_sym_end] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3553),
    [anon_sym_define] = ACTIONS(3553),
    [anon_sym_macro] = ACTIONS(3553),
    [anon_sym_procedure] = ACTIONS(3553),
    [anon_sym_fair] = ACTIONS(3553),
    [anon_sym_process] = ACTIONS(3553),
    [anon_sym_variable] = ACTIONS(3551),
    [anon_sym_variables] = ACTIONS(3553),
    [anon_sym_begin] = ACTIONS(3553),
    [anon_sym_then] = ACTIONS(3553),
    [anon_sym_elsif] = ACTIONS(3553),
    [anon_sym_else] = ACTIONS(3553),
    [anon_sym_do] = ACTIONS(3553),
    [anon_sym_or] = ACTIONS(3553),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1377] = {
    [sym_block_comment] = STATE(1377),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_COLON] = ACTIONS(3555),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3557),
    [anon_sym_RPAREN] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3557),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3557),
    [anon_sym_RBRACE] = ACTIONS(3557),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3557),
    [anon_sym_ELSE] = ACTIONS(3557),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3557),
    [anon_sym_end] = ACTIONS(3557),
    [anon_sym_SEMI] = ACTIONS(3557),
    [anon_sym_define] = ACTIONS(3557),
    [anon_sym_macro] = ACTIONS(3557),
    [anon_sym_procedure] = ACTIONS(3557),
    [anon_sym_fair] = ACTIONS(3557),
    [anon_sym_process] = ACTIONS(3557),
    [anon_sym_variable] = ACTIONS(3555),
    [anon_sym_variables] = ACTIONS(3557),
    [anon_sym_begin] = ACTIONS(3557),
    [anon_sym_then] = ACTIONS(3557),
    [anon_sym_elsif] = ACTIONS(3557),
    [anon_sym_else] = ACTIONS(3557),
    [anon_sym_do] = ACTIONS(3557),
    [anon_sym_or] = ACTIONS(3557),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1378] = {
    [sym_block_comment] = STATE(1378),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_COLON] = ACTIONS(3513),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3511),
    [anon_sym_RPAREN] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3511),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3511),
    [anon_sym_RBRACE] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3511),
    [anon_sym_ELSE] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3511),
    [anon_sym_end] = ACTIONS(3511),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym_define] = ACTIONS(3511),
    [anon_sym_macro] = ACTIONS(3511),
    [anon_sym_procedure] = ACTIONS(3511),
    [anon_sym_fair] = ACTIONS(3511),
    [anon_sym_process] = ACTIONS(3511),
    [anon_sym_variable] = ACTIONS(3513),
    [anon_sym_variables] = ACTIONS(3511),
    [anon_sym_begin] = ACTIONS(3511),
    [anon_sym_then] = ACTIONS(3511),
    [anon_sym_elsif] = ACTIONS(3511),
    [anon_sym_else] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_or] = ACTIONS(3511),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1379] = {
    [sym_block_comment] = STATE(1379),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_RPAREN] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3525),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3525),
    [anon_sym_RBRACE] = ACTIONS(3525),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3525),
    [anon_sym_ELSE] = ACTIONS(3525),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3525),
    [anon_sym_end] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3525),
    [anon_sym_define] = ACTIONS(3525),
    [anon_sym_macro] = ACTIONS(3525),
    [anon_sym_procedure] = ACTIONS(3525),
    [anon_sym_fair] = ACTIONS(3525),
    [anon_sym_process] = ACTIONS(3525),
    [anon_sym_variable] = ACTIONS(3523),
    [anon_sym_variables] = ACTIONS(3525),
    [anon_sym_begin] = ACTIONS(3525),
    [anon_sym_then] = ACTIONS(3525),
    [anon_sym_elsif] = ACTIONS(3525),
    [anon_sym_else] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_or] = ACTIONS(3525),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1380] = {
    [sym_block_comment] = STATE(1380),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_RPAREN] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3529),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3529),
    [anon_sym_RBRACE] = ACTIONS(3529),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3529),
    [anon_sym_ELSE] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3529),
    [anon_sym_end] = ACTIONS(3529),
    [anon_sym_SEMI] = ACTIONS(3529),
    [anon_sym_define] = ACTIONS(3529),
    [anon_sym_macro] = ACTIONS(3529),
    [anon_sym_procedure] = ACTIONS(3529),
    [anon_sym_fair] = ACTIONS(3529),
    [anon_sym_process] = ACTIONS(3529),
    [anon_sym_variable] = ACTIONS(3527),
    [anon_sym_variables] = ACTIONS(3529),
    [anon_sym_begin] = ACTIONS(3529),
    [anon_sym_then] = ACTIONS(3529),
    [anon_sym_elsif] = ACTIONS(3529),
    [anon_sym_else] = ACTIONS(3529),
    [anon_sym_do] = ACTIONS(3529),
    [anon_sym_or] = ACTIONS(3529),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1381] = {
    [sym_block_comment] = STATE(1381),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_COLON] = ACTIONS(3501),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym_RPAREN] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3499),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3499),
    [anon_sym_RBRACE] = ACTIONS(3499),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3499),
    [anon_sym_ELSE] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3499),
    [anon_sym_end] = ACTIONS(3499),
    [anon_sym_SEMI] = ACTIONS(3499),
    [anon_sym_define] = ACTIONS(3499),
    [anon_sym_macro] = ACTIONS(3499),
    [anon_sym_procedure] = ACTIONS(3499),
    [anon_sym_fair] = ACTIONS(3499),
    [anon_sym_process] = ACTIONS(3499),
    [anon_sym_variable] = ACTIONS(3501),
    [anon_sym_variables] = ACTIONS(3499),
    [anon_sym_begin] = ACTIONS(3499),
    [anon_sym_then] = ACTIONS(3499),
    [anon_sym_elsif] = ACTIONS(3499),
    [anon_sym_else] = ACTIONS(3499),
    [anon_sym_do] = ACTIONS(3499),
    [anon_sym_or] = ACTIONS(3499),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1382] = {
    [sym_block_comment] = STATE(1382),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_RPAREN] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3503),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3503),
    [anon_sym_ELSE] = ACTIONS(3503),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3503),
    [anon_sym_end] = ACTIONS(3503),
    [anon_sym_SEMI] = ACTIONS(3503),
    [anon_sym_define] = ACTIONS(3503),
    [anon_sym_macro] = ACTIONS(3503),
    [anon_sym_procedure] = ACTIONS(3503),
    [anon_sym_fair] = ACTIONS(3503),
    [anon_sym_process] = ACTIONS(3503),
    [anon_sym_variable] = ACTIONS(3505),
    [anon_sym_variables] = ACTIONS(3503),
    [anon_sym_begin] = ACTIONS(3503),
    [anon_sym_then] = ACTIONS(3503),
    [anon_sym_elsif] = ACTIONS(3503),
    [anon_sym_else] = ACTIONS(3503),
    [anon_sym_do] = ACTIONS(3503),
    [anon_sym_or] = ACTIONS(3503),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1383] = {
    [sym_block_comment] = STATE(1383),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_COLON] = ACTIONS(3509),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3507),
    [anon_sym_RPAREN] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3507),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_RBRACE] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3507),
    [anon_sym_ELSE] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3507),
    [anon_sym_end] = ACTIONS(3507),
    [anon_sym_SEMI] = ACTIONS(3507),
    [anon_sym_define] = ACTIONS(3507),
    [anon_sym_macro] = ACTIONS(3507),
    [anon_sym_procedure] = ACTIONS(3507),
    [anon_sym_fair] = ACTIONS(3507),
    [anon_sym_process] = ACTIONS(3507),
    [anon_sym_variable] = ACTIONS(3509),
    [anon_sym_variables] = ACTIONS(3507),
    [anon_sym_begin] = ACTIONS(3507),
    [anon_sym_then] = ACTIONS(3507),
    [anon_sym_elsif] = ACTIONS(3507),
    [anon_sym_else] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_or] = ACTIONS(3507),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1384] = {
    [sym_block_comment] = STATE(1384),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_COLON] = ACTIONS(3517),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_RPAREN] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3515),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(3515),
    [anon_sym_ELSE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3515),
    [anon_sym_end] = ACTIONS(3515),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym_define] = ACTIONS(3515),
    [anon_sym_macro] = ACTIONS(3515),
    [anon_sym_procedure] = ACTIONS(3515),
    [anon_sym_fair] = ACTIONS(3515),
    [anon_sym_process] = ACTIONS(3515),
    [anon_sym_variable] = ACTIONS(3517),
    [anon_sym_variables] = ACTIONS(3515),
    [anon_sym_begin] = ACTIONS(3515),
    [anon_sym_then] = ACTIONS(3515),
    [anon_sym_elsif] = ACTIONS(3515),
    [anon_sym_else] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_or] = ACTIONS(3515),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1385] = {
    [sym_block_comment] = STATE(1385),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3637),
    [anon_sym_u25a1] = ACTIONS(3637),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3635),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3635),
    [anon_sym_u2115] = ACTIONS(3637),
    [anon_sym_Int] = ACTIONS(3635),
    [anon_sym_u2124] = ACTIONS(3637),
    [anon_sym_Real] = ACTIONS(3635),
    [anon_sym_u211d] = ACTIONS(3637),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3637),
    [anon_sym_BSLASHneg] = ACTIONS(3637),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_u00ac] = ACTIONS(3637),
    [sym_union] = ACTIONS(3635),
    [sym_powerset] = ACTIONS(3635),
    [sym_domain] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3637),
    [sym_enabled] = ACTIONS(3635),
    [sym_unchanged] = ACTIONS(3635),
    [anon_sym_LT_GT] = ACTIONS(3637),
    [anon_sym_u22c4] = ACTIONS(3637),
    [anon_sym_u25c7] = ACTIONS(3637),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3635),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1386] = {
    [sym_block_comment] = STATE(1386),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3633),
    [anon_sym_u25a1] = ACTIONS(3633),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3631),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3631),
    [anon_sym_u2115] = ACTIONS(3633),
    [anon_sym_Int] = ACTIONS(3631),
    [anon_sym_u2124] = ACTIONS(3633),
    [anon_sym_Real] = ACTIONS(3631),
    [anon_sym_u211d] = ACTIONS(3633),
    [anon_sym_RBRACE] = ACTIONS(3633),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3633),
    [anon_sym_BSLASHneg] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_u00ac] = ACTIONS(3633),
    [sym_union] = ACTIONS(3631),
    [sym_powerset] = ACTIONS(3631),
    [sym_domain] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3633),
    [sym_enabled] = ACTIONS(3631),
    [sym_unchanged] = ACTIONS(3631),
    [anon_sym_LT_GT] = ACTIONS(3633),
    [anon_sym_u22c4] = ACTIONS(3633),
    [anon_sym_u25c7] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3631),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1387] = {
    [sym_block_comment] = STATE(1387),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3517),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3517),
    [anon_sym_u2115] = ACTIONS(3515),
    [anon_sym_Int] = ACTIONS(3517),
    [anon_sym_u2124] = ACTIONS(3515),
    [anon_sym_Real] = ACTIONS(3517),
    [anon_sym_u211d] = ACTIONS(3515),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3515),
    [anon_sym_BSLASHneg] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3517),
    [anon_sym_u00ac] = ACTIONS(3515),
    [sym_union] = ACTIONS(3517),
    [sym_powerset] = ACTIONS(3517),
    [sym_domain] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3515),
    [sym_enabled] = ACTIONS(3517),
    [sym_unchanged] = ACTIONS(3517),
    [anon_sym_LT_GT] = ACTIONS(3515),
    [anon_sym_u22c4] = ACTIONS(3515),
    [anon_sym_u25c7] = ACTIONS(3515),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3517),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1388] = {
    [sym_block_comment] = STATE(1388),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3673),
    [anon_sym_u25a1] = ACTIONS(3673),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3671),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3671),
    [anon_sym_u2115] = ACTIONS(3673),
    [anon_sym_Int] = ACTIONS(3671),
    [anon_sym_u2124] = ACTIONS(3673),
    [anon_sym_Real] = ACTIONS(3671),
    [anon_sym_u211d] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3673),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3673),
    [anon_sym_BSLASHneg] = ACTIONS(3673),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_u00ac] = ACTIONS(3673),
    [sym_union] = ACTIONS(3671),
    [sym_powerset] = ACTIONS(3671),
    [sym_domain] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3673),
    [sym_enabled] = ACTIONS(3671),
    [sym_unchanged] = ACTIONS(3671),
    [anon_sym_LT_GT] = ACTIONS(3673),
    [anon_sym_u22c4] = ACTIONS(3673),
    [anon_sym_u25c7] = ACTIONS(3673),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3671),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1389] = {
    [sym_block_comment] = STATE(1389),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_RECURSIVE] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3533),
    [anon_sym_u2115] = ACTIONS(3531),
    [anon_sym_Int] = ACTIONS(3533),
    [anon_sym_u2124] = ACTIONS(3531),
    [anon_sym_Real] = ACTIONS(3533),
    [anon_sym_u211d] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3533),
    [anon_sym_BSLASHlnot] = ACTIONS(3531),
    [anon_sym_BSLASHneg] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_u00ac] = ACTIONS(3531),
    [sym_union] = ACTIONS(3533),
    [sym_powerset] = ACTIONS(3533),
    [sym_domain] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3531),
    [sym_enabled] = ACTIONS(3533),
    [sym_unchanged] = ACTIONS(3533),
    [anon_sym_LT_GT] = ACTIONS(3531),
    [anon_sym_u22c4] = ACTIONS(3531),
    [anon_sym_u25c7] = ACTIONS(3531),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1390] = {
    [sym_block_comment] = STATE(1390),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3653),
    [anon_sym_u25a1] = ACTIONS(3653),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3651),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3651),
    [anon_sym_u2115] = ACTIONS(3653),
    [anon_sym_Int] = ACTIONS(3651),
    [anon_sym_u2124] = ACTIONS(3653),
    [anon_sym_Real] = ACTIONS(3651),
    [anon_sym_u211d] = ACTIONS(3653),
    [anon_sym_RBRACE] = ACTIONS(3653),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3653),
    [anon_sym_BSLASHneg] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_u00ac] = ACTIONS(3653),
    [sym_union] = ACTIONS(3651),
    [sym_powerset] = ACTIONS(3651),
    [sym_domain] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3653),
    [sym_enabled] = ACTIONS(3651),
    [sym_unchanged] = ACTIONS(3651),
    [anon_sym_LT_GT] = ACTIONS(3653),
    [anon_sym_u22c4] = ACTIONS(3653),
    [anon_sym_u25c7] = ACTIONS(3653),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3651),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1391] = {
    [sym_block_comment] = STATE(1391),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_IN] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1392] = {
    [sym_block_comment] = STATE(1392),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_IN] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1393] = {
    [sym_block_comment] = STATE(1393),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_IN] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1394] = {
    [sym_block_comment] = STATE(1394),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_IN] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1395] = {
    [sym_block_comment] = STATE(1395),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_IN] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1396] = {
    [sym_block_comment] = STATE(1396),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_IN] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1397] = {
    [sym_block_comment] = STATE(1397),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_IN] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1398] = {
    [sym_block_comment] = STATE(1398),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_IN] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1399] = {
    [sym_block_comment] = STATE(1399),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1400] = {
    [sym_block_comment] = STATE(1400),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1401] = {
    [sym_block_comment] = STATE(1401),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1402] = {
    [sym_block_comment] = STATE(1402),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_RECURSIVE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_IN] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1403] = {
    [sym_block_comment] = STATE(1403),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RECURSIVE] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3535),
    [anon_sym_u2115] = ACTIONS(3537),
    [anon_sym_Int] = ACTIONS(3535),
    [anon_sym_u2124] = ACTIONS(3537),
    [anon_sym_Real] = ACTIONS(3535),
    [anon_sym_u211d] = ACTIONS(3537),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3535),
    [anon_sym_BSLASHlnot] = ACTIONS(3537),
    [anon_sym_BSLASHneg] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3535),
    [anon_sym_u00ac] = ACTIONS(3537),
    [sym_union] = ACTIONS(3535),
    [sym_powerset] = ACTIONS(3535),
    [sym_domain] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3537),
    [sym_enabled] = ACTIONS(3535),
    [sym_unchanged] = ACTIONS(3535),
    [anon_sym_LT_GT] = ACTIONS(3537),
    [anon_sym_u22c4] = ACTIONS(3537),
    [anon_sym_u25c7] = ACTIONS(3537),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1404] = {
    [sym_block_comment] = STATE(1404),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_IN] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1405] = {
    [sym_block_comment] = STATE(1405),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3659),
    [anon_sym_u25a1] = ACTIONS(3659),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3661),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3661),
    [anon_sym_u2115] = ACTIONS(3659),
    [anon_sym_Int] = ACTIONS(3661),
    [anon_sym_u2124] = ACTIONS(3659),
    [anon_sym_Real] = ACTIONS(3661),
    [anon_sym_u211d] = ACTIONS(3659),
    [anon_sym_RBRACE] = ACTIONS(3659),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3659),
    [anon_sym_BSLASHneg] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [anon_sym_u00ac] = ACTIONS(3659),
    [sym_union] = ACTIONS(3661),
    [sym_powerset] = ACTIONS(3661),
    [sym_domain] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3659),
    [sym_enabled] = ACTIONS(3661),
    [sym_unchanged] = ACTIONS(3661),
    [anon_sym_LT_GT] = ACTIONS(3659),
    [anon_sym_u22c4] = ACTIONS(3659),
    [anon_sym_u25c7] = ACTIONS(3659),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3661),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1406] = {
    [sym_block_comment] = STATE(1406),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_RECURSIVE] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3539),
    [anon_sym_u2115] = ACTIONS(3541),
    [anon_sym_Int] = ACTIONS(3539),
    [anon_sym_u2124] = ACTIONS(3541),
    [anon_sym_Real] = ACTIONS(3539),
    [anon_sym_u211d] = ACTIONS(3541),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3539),
    [anon_sym_BSLASHlnot] = ACTIONS(3541),
    [anon_sym_BSLASHneg] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_u00ac] = ACTIONS(3541),
    [sym_union] = ACTIONS(3539),
    [sym_powerset] = ACTIONS(3539),
    [sym_domain] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3541),
    [sym_enabled] = ACTIONS(3539),
    [sym_unchanged] = ACTIONS(3539),
    [anon_sym_LT_GT] = ACTIONS(3541),
    [anon_sym_u22c4] = ACTIONS(3541),
    [anon_sym_u25c7] = ACTIONS(3541),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1407] = {
    [sym_block_comment] = STATE(1407),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_RECURSIVE] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3543),
    [anon_sym_u2115] = ACTIONS(3545),
    [anon_sym_Int] = ACTIONS(3543),
    [anon_sym_u2124] = ACTIONS(3545),
    [anon_sym_Real] = ACTIONS(3543),
    [anon_sym_u211d] = ACTIONS(3545),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3543),
    [anon_sym_BSLASHlnot] = ACTIONS(3545),
    [anon_sym_BSLASHneg] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3543),
    [anon_sym_u00ac] = ACTIONS(3545),
    [sym_union] = ACTIONS(3543),
    [sym_powerset] = ACTIONS(3543),
    [sym_domain] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3545),
    [sym_enabled] = ACTIONS(3543),
    [sym_unchanged] = ACTIONS(3543),
    [anon_sym_LT_GT] = ACTIONS(3545),
    [anon_sym_u22c4] = ACTIONS(3545),
    [anon_sym_u25c7] = ACTIONS(3545),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1408] = {
    [sym_block_comment] = STATE(1408),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_RECURSIVE] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3551),
    [anon_sym_u2115] = ACTIONS(3553),
    [anon_sym_Int] = ACTIONS(3551),
    [anon_sym_u2124] = ACTIONS(3553),
    [anon_sym_Real] = ACTIONS(3551),
    [anon_sym_u211d] = ACTIONS(3553),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3551),
    [anon_sym_BSLASHlnot] = ACTIONS(3553),
    [anon_sym_BSLASHneg] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3551),
    [anon_sym_u00ac] = ACTIONS(3553),
    [sym_union] = ACTIONS(3551),
    [sym_powerset] = ACTIONS(3551),
    [sym_domain] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3553),
    [sym_enabled] = ACTIONS(3551),
    [sym_unchanged] = ACTIONS(3551),
    [anon_sym_LT_GT] = ACTIONS(3553),
    [anon_sym_u22c4] = ACTIONS(3553),
    [anon_sym_u25c7] = ACTIONS(3553),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1409] = {
    [sym_block_comment] = STATE(1409),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3557),
    [anon_sym_RECURSIVE] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3555),
    [anon_sym_u2115] = ACTIONS(3557),
    [anon_sym_Int] = ACTIONS(3555),
    [anon_sym_u2124] = ACTIONS(3557),
    [anon_sym_Real] = ACTIONS(3555),
    [anon_sym_u211d] = ACTIONS(3557),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3555),
    [anon_sym_BSLASHlnot] = ACTIONS(3557),
    [anon_sym_BSLASHneg] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3555),
    [anon_sym_u00ac] = ACTIONS(3557),
    [sym_union] = ACTIONS(3555),
    [sym_powerset] = ACTIONS(3555),
    [sym_domain] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3557),
    [sym_enabled] = ACTIONS(3555),
    [sym_unchanged] = ACTIONS(3555),
    [anon_sym_LT_GT] = ACTIONS(3557),
    [anon_sym_u22c4] = ACTIONS(3557),
    [anon_sym_u25c7] = ACTIONS(3557),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1410] = {
    [sym_block_comment] = STATE(1410),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3511),
    [anon_sym_RECURSIVE] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3513),
    [anon_sym_u2115] = ACTIONS(3511),
    [anon_sym_Int] = ACTIONS(3513),
    [anon_sym_u2124] = ACTIONS(3511),
    [anon_sym_Real] = ACTIONS(3513),
    [anon_sym_u211d] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3513),
    [anon_sym_BSLASHlnot] = ACTIONS(3511),
    [anon_sym_BSLASHneg] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3513),
    [anon_sym_u00ac] = ACTIONS(3511),
    [sym_union] = ACTIONS(3513),
    [sym_powerset] = ACTIONS(3513),
    [sym_domain] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3511),
    [sym_enabled] = ACTIONS(3513),
    [sym_unchanged] = ACTIONS(3513),
    [anon_sym_LT_GT] = ACTIONS(3511),
    [anon_sym_u22c4] = ACTIONS(3511),
    [anon_sym_u25c7] = ACTIONS(3511),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1411] = {
    [sym_block_comment] = STATE(1411),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3647),
    [anon_sym_u25a1] = ACTIONS(3647),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3649),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3649),
    [anon_sym_u2115] = ACTIONS(3647),
    [anon_sym_Int] = ACTIONS(3649),
    [anon_sym_u2124] = ACTIONS(3647),
    [anon_sym_Real] = ACTIONS(3649),
    [anon_sym_u211d] = ACTIONS(3647),
    [anon_sym_RBRACE] = ACTIONS(3647),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3647),
    [anon_sym_BSLASHneg] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3649),
    [anon_sym_u00ac] = ACTIONS(3647),
    [sym_union] = ACTIONS(3649),
    [sym_powerset] = ACTIONS(3649),
    [sym_domain] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3647),
    [sym_enabled] = ACTIONS(3649),
    [sym_unchanged] = ACTIONS(3649),
    [anon_sym_LT_GT] = ACTIONS(3647),
    [anon_sym_u22c4] = ACTIONS(3647),
    [anon_sym_u25c7] = ACTIONS(3647),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3649),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1412] = {
    [sym_block_comment] = STATE(1412),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3663),
    [anon_sym_u25a1] = ACTIONS(3663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3665),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3665),
    [anon_sym_u2115] = ACTIONS(3663),
    [anon_sym_Int] = ACTIONS(3665),
    [anon_sym_u2124] = ACTIONS(3663),
    [anon_sym_Real] = ACTIONS(3665),
    [anon_sym_u211d] = ACTIONS(3663),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3663),
    [anon_sym_BSLASHneg] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3665),
    [anon_sym_u00ac] = ACTIONS(3663),
    [sym_union] = ACTIONS(3665),
    [sym_powerset] = ACTIONS(3665),
    [sym_domain] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3663),
    [sym_enabled] = ACTIONS(3665),
    [sym_unchanged] = ACTIONS(3665),
    [anon_sym_LT_GT] = ACTIONS(3663),
    [anon_sym_u22c4] = ACTIONS(3663),
    [anon_sym_u25c7] = ACTIONS(3663),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3665),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1413] = {
    [sym_block_comment] = STATE(1413),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_RECURSIVE] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3523),
    [anon_sym_u2115] = ACTIONS(3525),
    [anon_sym_Int] = ACTIONS(3523),
    [anon_sym_u2124] = ACTIONS(3525),
    [anon_sym_Real] = ACTIONS(3523),
    [anon_sym_u211d] = ACTIONS(3525),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3523),
    [anon_sym_BSLASHlnot] = ACTIONS(3525),
    [anon_sym_BSLASHneg] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_u00ac] = ACTIONS(3525),
    [sym_union] = ACTIONS(3523),
    [sym_powerset] = ACTIONS(3523),
    [sym_domain] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3525),
    [sym_enabled] = ACTIONS(3523),
    [sym_unchanged] = ACTIONS(3523),
    [anon_sym_LT_GT] = ACTIONS(3525),
    [anon_sym_u22c4] = ACTIONS(3525),
    [anon_sym_u25c7] = ACTIONS(3525),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1414] = {
    [sym_block_comment] = STATE(1414),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_RECURSIVE] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3527),
    [anon_sym_u2115] = ACTIONS(3529),
    [anon_sym_Int] = ACTIONS(3527),
    [anon_sym_u2124] = ACTIONS(3529),
    [anon_sym_Real] = ACTIONS(3527),
    [anon_sym_u211d] = ACTIONS(3529),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3527),
    [anon_sym_BSLASHlnot] = ACTIONS(3529),
    [anon_sym_BSLASHneg] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_u00ac] = ACTIONS(3529),
    [sym_union] = ACTIONS(3527),
    [sym_powerset] = ACTIONS(3527),
    [sym_domain] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3529),
    [sym_enabled] = ACTIONS(3527),
    [sym_unchanged] = ACTIONS(3527),
    [anon_sym_LT_GT] = ACTIONS(3529),
    [anon_sym_u22c4] = ACTIONS(3529),
    [anon_sym_u25c7] = ACTIONS(3529),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1415] = {
    [sym_block_comment] = STATE(1415),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3641),
    [anon_sym_u25a1] = ACTIONS(3641),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_RECURSIVE] = ACTIONS(3639),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3639),
    [anon_sym_u2115] = ACTIONS(3641),
    [anon_sym_Int] = ACTIONS(3639),
    [anon_sym_u2124] = ACTIONS(3641),
    [anon_sym_Real] = ACTIONS(3639),
    [anon_sym_u211d] = ACTIONS(3641),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3639),
    [anon_sym_BSLASHlnot] = ACTIONS(3641),
    [anon_sym_BSLASHneg] = ACTIONS(3641),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_u00ac] = ACTIONS(3641),
    [sym_union] = ACTIONS(3639),
    [sym_powerset] = ACTIONS(3639),
    [sym_domain] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3641),
    [sym_enabled] = ACTIONS(3639),
    [sym_unchanged] = ACTIONS(3639),
    [anon_sym_LT_GT] = ACTIONS(3641),
    [anon_sym_u22c4] = ACTIONS(3641),
    [anon_sym_u25c7] = ACTIONS(3641),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1416] = {
    [sym_block_comment] = STATE(1416),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3677),
    [anon_sym_u25a1] = ACTIONS(3677),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3675),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3675),
    [anon_sym_u2115] = ACTIONS(3677),
    [anon_sym_Int] = ACTIONS(3675),
    [anon_sym_u2124] = ACTIONS(3677),
    [anon_sym_Real] = ACTIONS(3675),
    [anon_sym_u211d] = ACTIONS(3677),
    [anon_sym_RBRACE] = ACTIONS(3677),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3677),
    [anon_sym_BSLASHneg] = ACTIONS(3677),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_u00ac] = ACTIONS(3677),
    [sym_union] = ACTIONS(3675),
    [sym_powerset] = ACTIONS(3675),
    [sym_domain] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3677),
    [sym_enabled] = ACTIONS(3675),
    [sym_unchanged] = ACTIONS(3675),
    [anon_sym_LT_GT] = ACTIONS(3677),
    [anon_sym_u22c4] = ACTIONS(3677),
    [anon_sym_u25c7] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3675),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1417] = {
    [sym_block_comment] = STATE(1417),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym_RECURSIVE] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3501),
    [anon_sym_u2115] = ACTIONS(3499),
    [anon_sym_Int] = ACTIONS(3501),
    [anon_sym_u2124] = ACTIONS(3499),
    [anon_sym_Real] = ACTIONS(3501),
    [anon_sym_u211d] = ACTIONS(3499),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3501),
    [anon_sym_BSLASHlnot] = ACTIONS(3499),
    [anon_sym_BSLASHneg] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_u00ac] = ACTIONS(3499),
    [sym_union] = ACTIONS(3501),
    [sym_powerset] = ACTIONS(3501),
    [sym_domain] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3499),
    [sym_enabled] = ACTIONS(3501),
    [sym_unchanged] = ACTIONS(3501),
    [anon_sym_LT_GT] = ACTIONS(3499),
    [anon_sym_u22c4] = ACTIONS(3499),
    [anon_sym_u25c7] = ACTIONS(3499),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1418] = {
    [sym_block_comment] = STATE(1418),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_RECURSIVE] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3505),
    [anon_sym_u2115] = ACTIONS(3503),
    [anon_sym_Int] = ACTIONS(3505),
    [anon_sym_u2124] = ACTIONS(3503),
    [anon_sym_Real] = ACTIONS(3505),
    [anon_sym_u211d] = ACTIONS(3503),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3505),
    [anon_sym_BSLASHlnot] = ACTIONS(3503),
    [anon_sym_BSLASHneg] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_u00ac] = ACTIONS(3503),
    [sym_union] = ACTIONS(3505),
    [sym_powerset] = ACTIONS(3505),
    [sym_domain] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3503),
    [sym_enabled] = ACTIONS(3505),
    [sym_unchanged] = ACTIONS(3505),
    [anon_sym_LT_GT] = ACTIONS(3503),
    [anon_sym_u22c4] = ACTIONS(3503),
    [anon_sym_u25c7] = ACTIONS(3503),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1419] = {
    [sym_block_comment] = STATE(1419),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3507),
    [anon_sym_RECURSIVE] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3509),
    [anon_sym_u2115] = ACTIONS(3507),
    [anon_sym_Int] = ACTIONS(3509),
    [anon_sym_u2124] = ACTIONS(3507),
    [anon_sym_Real] = ACTIONS(3509),
    [anon_sym_u211d] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3509),
    [anon_sym_BSLASHlnot] = ACTIONS(3507),
    [anon_sym_BSLASHneg] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [anon_sym_u00ac] = ACTIONS(3507),
    [sym_union] = ACTIONS(3509),
    [sym_powerset] = ACTIONS(3509),
    [sym_domain] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3507),
    [sym_enabled] = ACTIONS(3509),
    [sym_unchanged] = ACTIONS(3509),
    [anon_sym_LT_GT] = ACTIONS(3507),
    [anon_sym_u22c4] = ACTIONS(3507),
    [anon_sym_u25c7] = ACTIONS(3507),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1420] = {
    [sym_block_comment] = STATE(1420),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_RECURSIVE] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3517),
    [anon_sym_u2115] = ACTIONS(3515),
    [anon_sym_Int] = ACTIONS(3517),
    [anon_sym_u2124] = ACTIONS(3515),
    [anon_sym_Real] = ACTIONS(3517),
    [anon_sym_u211d] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3517),
    [anon_sym_BSLASHlnot] = ACTIONS(3515),
    [anon_sym_BSLASHneg] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3517),
    [anon_sym_u00ac] = ACTIONS(3515),
    [sym_union] = ACTIONS(3517),
    [sym_powerset] = ACTIONS(3517),
    [sym_domain] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3515),
    [sym_enabled] = ACTIONS(3517),
    [sym_unchanged] = ACTIONS(3517),
    [anon_sym_LT_GT] = ACTIONS(3515),
    [anon_sym_u22c4] = ACTIONS(3515),
    [anon_sym_u25c7] = ACTIONS(3515),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1421] = {
    [sym_block_comment] = STATE(1421),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3643),
    [anon_sym_u25a1] = ACTIONS(3643),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3645),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3645),
    [anon_sym_u2115] = ACTIONS(3643),
    [anon_sym_Int] = ACTIONS(3645),
    [anon_sym_u2124] = ACTIONS(3643),
    [anon_sym_Real] = ACTIONS(3645),
    [anon_sym_u211d] = ACTIONS(3643),
    [anon_sym_RBRACE] = ACTIONS(3643),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3643),
    [anon_sym_BSLASHneg] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3645),
    [anon_sym_u00ac] = ACTIONS(3643),
    [sym_union] = ACTIONS(3645),
    [sym_powerset] = ACTIONS(3645),
    [sym_domain] = ACTIONS(3645),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3643),
    [sym_enabled] = ACTIONS(3645),
    [sym_unchanged] = ACTIONS(3645),
    [anon_sym_LT_GT] = ACTIONS(3643),
    [anon_sym_u22c4] = ACTIONS(3643),
    [anon_sym_u25c7] = ACTIONS(3643),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3645),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1422] = {
    [sym_block_comment] = STATE(1422),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_IN] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1423] = {
    [sym_block_comment] = STATE(1423),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1424] = {
    [sym_block_comment] = STATE(1424),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_RECURSIVE] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_IN] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1425] = {
    [sym_block_comment] = STATE(1425),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3637),
    [anon_sym_u25a1] = ACTIONS(3637),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_RECURSIVE] = ACTIONS(3635),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3635),
    [anon_sym_u2115] = ACTIONS(3637),
    [anon_sym_Int] = ACTIONS(3635),
    [anon_sym_u2124] = ACTIONS(3637),
    [anon_sym_Real] = ACTIONS(3635),
    [anon_sym_u211d] = ACTIONS(3637),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3635),
    [anon_sym_BSLASHlnot] = ACTIONS(3637),
    [anon_sym_BSLASHneg] = ACTIONS(3637),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_u00ac] = ACTIONS(3637),
    [sym_union] = ACTIONS(3635),
    [sym_powerset] = ACTIONS(3635),
    [sym_domain] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3637),
    [sym_enabled] = ACTIONS(3635),
    [sym_unchanged] = ACTIONS(3635),
    [anon_sym_LT_GT] = ACTIONS(3637),
    [anon_sym_u22c4] = ACTIONS(3637),
    [anon_sym_u25c7] = ACTIONS(3637),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1426] = {
    [sym_block_comment] = STATE(1426),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3633),
    [anon_sym_u25a1] = ACTIONS(3633),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_RECURSIVE] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3631),
    [anon_sym_u2115] = ACTIONS(3633),
    [anon_sym_Int] = ACTIONS(3631),
    [anon_sym_u2124] = ACTIONS(3633),
    [anon_sym_Real] = ACTIONS(3631),
    [anon_sym_u211d] = ACTIONS(3633),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3631),
    [anon_sym_BSLASHlnot] = ACTIONS(3633),
    [anon_sym_BSLASHneg] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_u00ac] = ACTIONS(3633),
    [sym_union] = ACTIONS(3631),
    [sym_powerset] = ACTIONS(3631),
    [sym_domain] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3633),
    [sym_enabled] = ACTIONS(3631),
    [sym_unchanged] = ACTIONS(3631),
    [anon_sym_LT_GT] = ACTIONS(3633),
    [anon_sym_u22c4] = ACTIONS(3633),
    [anon_sym_u25c7] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1427] = {
    [sym_block_comment] = STATE(1427),
    [sym_implies] = STATE(582),
    [sym_plus_arrow] = STATE(583),
    [sym_equiv] = STATE(583),
    [sym_iff] = STATE(583),
    [sym_leads_to] = STATE(583),
    [sym_land] = STATE(584),
    [sym_lor] = STATE(584),
    [sym_assign] = STATE(574),
    [sym_bnf_rule] = STATE(574),
    [sym_eq] = STATE(574),
    [sym_neq] = STATE(574),
    [sym_lt] = STATE(574),
    [sym_leq] = STATE(574),
    [sym_geq] = STATE(574),
    [sym_approx] = STATE(574),
    [sym_rs_ttile] = STATE(574),
    [sym_rd_ttile] = STATE(574),
    [sym_ls_ttile] = STATE(574),
    [sym_ld_ttile] = STATE(574),
    [sym_asymp] = STATE(574),
    [sym_cong] = STATE(574),
    [sym_doteq] = STATE(574),
    [sym_gg] = STATE(574),
    [sym_ll] = STATE(574),
    [sym_in] = STATE(574),
    [sym_notin] = STATE(574),
    [sym_prec] = STATE(574),
    [sym_succ] = STATE(574),
    [sym_preceq] = STATE(574),
    [sym_succeq] = STATE(574),
    [sym_propto] = STATE(574),
    [sym_sim] = STATE(574),
    [sym_simeq] = STATE(574),
    [sym_sqsubset] = STATE(574),
    [sym_sqsupset] = STATE(574),
    [sym_sqsubseteq] = STATE(574),
    [sym_sqsupseteq] = STATE(574),
    [sym_subset] = STATE(574),
    [sym_supset] = STATE(574),
    [sym_subseteq] = STATE(574),
    [sym_supseteq] = STATE(574),
    [sym_cap] = STATE(577),
    [sym_cup] = STATE(577),
    [sym_dots_2] = STATE(585),
    [sym_dots_3] = STATE(585),
    [sym_plus] = STATE(578),
    [sym_oplus] = STATE(578),
    [sym_ominus] = STATE(579),
    [sym_vertvert] = STATE(579),
    [sym_minus] = STATE(579),
    [sym_odot] = STATE(580),
    [sym_oslash] = STATE(580),
    [sym_otimes] = STATE(580),
    [sym_bigcirc] = STATE(580),
    [sym_bullet] = STATE(580),
    [sym_div] = STATE(580),
    [sym_circ] = STATE(580),
    [sym_star] = STATE(580),
    [sym_excl] = STATE(580),
    [sym_qq] = STATE(580),
    [sym_sqcap] = STATE(580),
    [sym_sqcup] = STATE(580),
    [sym_uplus] = STATE(580),
    [sym_times] = STATE(580),
    [sym_wr] = STATE(581),
    [sym_cdot] = STATE(581),
    [sym_sup_plus] = STATE(2609),
    [sym_identifier] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3669),
    [anon_sym_u25a1] = ACTIONS(3669),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_INSTANCE] = ACTIONS(3667),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3667),
    [anon_sym_u2115] = ACTIONS(3669),
    [anon_sym_Int] = ACTIONS(3667),
    [anon_sym_u2124] = ACTIONS(3669),
    [anon_sym_Real] = ACTIONS(3667),
    [anon_sym_u211d] = ACTIONS(3669),
    [anon_sym_RBRACE] = ACTIONS(3669),
    [anon_sym_DOT] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3669),
    [anon_sym_BSLASHneg] = ACTIONS(3669),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_u00ac] = ACTIONS(3669),
    [sym_union] = ACTIONS(3667),
    [sym_powerset] = ACTIONS(3667),
    [sym_domain] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3669),
    [sym_enabled] = ACTIONS(3667),
    [sym_unchanged] = ACTIONS(3667),
    [anon_sym_LT_GT] = ACTIONS(3669),
    [anon_sym_u22c4] = ACTIONS(3669),
    [anon_sym_u25c7] = ACTIONS(3669),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3691),
    [sym_map_to] = ACTIONS(3693),
    [sym_map_from] = ACTIONS(3693),
    [sym_setminus] = ACTIONS(3695),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3697),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3699),
    [sym_modmod] = ACTIONS(3701),
    [sym_vert] = ACTIONS(3699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3701),
    [sym_amp] = ACTIONS(3703),
    [sym_ampamp] = ACTIONS(3705),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3703),
    [sym_mulmul] = ACTIONS(3705),
    [sym_slash] = ACTIONS(3703),
    [sym_slashslash] = ACTIONS(3705),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3705),
    [sym_dol] = ACTIONS(3703),
    [sym_doldol] = ACTIONS(3705),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3707),
    [sym_powpow] = ACTIONS(3709),
    [anon_sym_CARET_PLUS] = ACTIONS(3711),
    [anon_sym_u207a] = ACTIONS(3711),
    [sym_asterisk] = ACTIONS(3713),
    [sym_sup_hash] = ACTIONS(3713),
    [sym_prime] = ACTIONS(3713),
    [anon_sym_end] = ACTIONS(3667),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1428] = {
    [sym_block_comment] = STATE(1428),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3633),
    [anon_sym_u25a1] = ACTIONS(3633),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3631),
    [anon_sym_u2115] = ACTIONS(3633),
    [anon_sym_Int] = ACTIONS(3631),
    [anon_sym_u2124] = ACTIONS(3633),
    [anon_sym_Real] = ACTIONS(3631),
    [anon_sym_u211d] = ACTIONS(3633),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3633),
    [anon_sym_BSLASHneg] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_u00ac] = ACTIONS(3633),
    [sym_union] = ACTIONS(3631),
    [sym_powerset] = ACTIONS(3631),
    [sym_domain] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3633),
    [sym_enabled] = ACTIONS(3631),
    [sym_unchanged] = ACTIONS(3631),
    [anon_sym_LT_GT] = ACTIONS(3633),
    [anon_sym_u22c4] = ACTIONS(3633),
    [anon_sym_u25c7] = ACTIONS(3633),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3633),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1429] = {
    [sym_block_comment] = STATE(1429),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3659),
    [anon_sym_u25a1] = ACTIONS(3659),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RECURSIVE] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3661),
    [anon_sym_u2115] = ACTIONS(3659),
    [anon_sym_Int] = ACTIONS(3661),
    [anon_sym_u2124] = ACTIONS(3659),
    [anon_sym_Real] = ACTIONS(3661),
    [anon_sym_u211d] = ACTIONS(3659),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3661),
    [anon_sym_BSLASHlnot] = ACTIONS(3659),
    [anon_sym_BSLASHneg] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [anon_sym_u00ac] = ACTIONS(3659),
    [sym_union] = ACTIONS(3661),
    [sym_powerset] = ACTIONS(3661),
    [sym_domain] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3659),
    [sym_enabled] = ACTIONS(3661),
    [sym_unchanged] = ACTIONS(3661),
    [anon_sym_LT_GT] = ACTIONS(3659),
    [anon_sym_u22c4] = ACTIONS(3659),
    [anon_sym_u25c7] = ACTIONS(3659),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1430] = {
    [sym_block_comment] = STATE(1430),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3647),
    [anon_sym_u25a1] = ACTIONS(3647),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RECURSIVE] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3649),
    [anon_sym_u2115] = ACTIONS(3647),
    [anon_sym_Int] = ACTIONS(3649),
    [anon_sym_u2124] = ACTIONS(3647),
    [anon_sym_Real] = ACTIONS(3649),
    [anon_sym_u211d] = ACTIONS(3647),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3649),
    [anon_sym_BSLASHlnot] = ACTIONS(3647),
    [anon_sym_BSLASHneg] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3649),
    [anon_sym_u00ac] = ACTIONS(3647),
    [sym_union] = ACTIONS(3649),
    [sym_powerset] = ACTIONS(3649),
    [sym_domain] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3647),
    [sym_enabled] = ACTIONS(3649),
    [sym_unchanged] = ACTIONS(3649),
    [anon_sym_LT_GT] = ACTIONS(3647),
    [anon_sym_u22c4] = ACTIONS(3647),
    [anon_sym_u25c7] = ACTIONS(3647),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1431] = {
    [sym_block_comment] = STATE(1431),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3663),
    [anon_sym_u25a1] = ACTIONS(3663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RECURSIVE] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3665),
    [anon_sym_u2115] = ACTIONS(3663),
    [anon_sym_Int] = ACTIONS(3665),
    [anon_sym_u2124] = ACTIONS(3663),
    [anon_sym_Real] = ACTIONS(3665),
    [anon_sym_u211d] = ACTIONS(3663),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3665),
    [anon_sym_BSLASHlnot] = ACTIONS(3663),
    [anon_sym_BSLASHneg] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3665),
    [anon_sym_u00ac] = ACTIONS(3663),
    [sym_union] = ACTIONS(3665),
    [sym_powerset] = ACTIONS(3665),
    [sym_domain] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3663),
    [sym_enabled] = ACTIONS(3665),
    [sym_unchanged] = ACTIONS(3665),
    [anon_sym_LT_GT] = ACTIONS(3663),
    [anon_sym_u22c4] = ACTIONS(3663),
    [anon_sym_u25c7] = ACTIONS(3663),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1432] = {
    [sym_block_comment] = STATE(1432),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3673),
    [anon_sym_u25a1] = ACTIONS(3673),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RECURSIVE] = ACTIONS(3671),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3671),
    [anon_sym_u2115] = ACTIONS(3673),
    [anon_sym_Int] = ACTIONS(3671),
    [anon_sym_u2124] = ACTIONS(3673),
    [anon_sym_Real] = ACTIONS(3671),
    [anon_sym_u211d] = ACTIONS(3673),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3671),
    [anon_sym_BSLASHlnot] = ACTIONS(3673),
    [anon_sym_BSLASHneg] = ACTIONS(3673),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_u00ac] = ACTIONS(3673),
    [sym_union] = ACTIONS(3671),
    [sym_powerset] = ACTIONS(3671),
    [sym_domain] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3673),
    [sym_enabled] = ACTIONS(3671),
    [sym_unchanged] = ACTIONS(3671),
    [anon_sym_LT_GT] = ACTIONS(3673),
    [anon_sym_u22c4] = ACTIONS(3673),
    [anon_sym_u25c7] = ACTIONS(3673),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1433] = {
    [sym_block_comment] = STATE(1433),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3677),
    [anon_sym_u25a1] = ACTIONS(3677),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RECURSIVE] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3675),
    [anon_sym_u2115] = ACTIONS(3677),
    [anon_sym_Int] = ACTIONS(3675),
    [anon_sym_u2124] = ACTIONS(3677),
    [anon_sym_Real] = ACTIONS(3675),
    [anon_sym_u211d] = ACTIONS(3677),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3675),
    [anon_sym_BSLASHlnot] = ACTIONS(3677),
    [anon_sym_BSLASHneg] = ACTIONS(3677),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_u00ac] = ACTIONS(3677),
    [sym_union] = ACTIONS(3675),
    [sym_powerset] = ACTIONS(3675),
    [sym_domain] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3677),
    [sym_enabled] = ACTIONS(3675),
    [sym_unchanged] = ACTIONS(3675),
    [anon_sym_LT_GT] = ACTIONS(3677),
    [anon_sym_u22c4] = ACTIONS(3677),
    [anon_sym_u25c7] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1434] = {
    [sym_block_comment] = STATE(1434),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3637),
    [anon_sym_u25a1] = ACTIONS(3637),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3635),
    [anon_sym_u2115] = ACTIONS(3637),
    [anon_sym_Int] = ACTIONS(3635),
    [anon_sym_u2124] = ACTIONS(3637),
    [anon_sym_Real] = ACTIONS(3635),
    [anon_sym_u211d] = ACTIONS(3637),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3637),
    [anon_sym_BSLASHneg] = ACTIONS(3637),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_u00ac] = ACTIONS(3637),
    [sym_union] = ACTIONS(3635),
    [sym_powerset] = ACTIONS(3635),
    [sym_domain] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3637),
    [sym_enabled] = ACTIONS(3635),
    [sym_unchanged] = ACTIONS(3635),
    [anon_sym_LT_GT] = ACTIONS(3637),
    [anon_sym_u22c4] = ACTIONS(3637),
    [anon_sym_u25c7] = ACTIONS(3637),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3637),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1435] = {
    [sym_block_comment] = STATE(1435),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3643),
    [anon_sym_u25a1] = ACTIONS(3643),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RECURSIVE] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3645),
    [anon_sym_u2115] = ACTIONS(3643),
    [anon_sym_Int] = ACTIONS(3645),
    [anon_sym_u2124] = ACTIONS(3643),
    [anon_sym_Real] = ACTIONS(3645),
    [anon_sym_u211d] = ACTIONS(3643),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3645),
    [anon_sym_BSLASHlnot] = ACTIONS(3643),
    [anon_sym_BSLASHneg] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3645),
    [anon_sym_u00ac] = ACTIONS(3643),
    [sym_union] = ACTIONS(3645),
    [sym_powerset] = ACTIONS(3645),
    [sym_domain] = ACTIONS(3645),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3643),
    [sym_enabled] = ACTIONS(3645),
    [sym_unchanged] = ACTIONS(3645),
    [anon_sym_LT_GT] = ACTIONS(3643),
    [anon_sym_u22c4] = ACTIONS(3643),
    [anon_sym_u25c7] = ACTIONS(3643),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1436] = {
    [sym_block_comment] = STATE(1436),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1437] = {
    [sym_block_comment] = STATE(1437),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1438] = {
    [sym_block_comment] = STATE(1438),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3641),
    [anon_sym_u25a1] = ACTIONS(3641),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3639),
    [anon_sym_u2115] = ACTIONS(3641),
    [anon_sym_Int] = ACTIONS(3639),
    [anon_sym_u2124] = ACTIONS(3641),
    [anon_sym_Real] = ACTIONS(3639),
    [anon_sym_u211d] = ACTIONS(3641),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3641),
    [anon_sym_BSLASHneg] = ACTIONS(3641),
    [anon_sym_TILDE] = ACTIONS(3639),
    [anon_sym_u00ac] = ACTIONS(3641),
    [sym_union] = ACTIONS(3639),
    [sym_powerset] = ACTIONS(3639),
    [sym_domain] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3641),
    [sym_enabled] = ACTIONS(3639),
    [sym_unchanged] = ACTIONS(3639),
    [anon_sym_LT_GT] = ACTIONS(3641),
    [anon_sym_u22c4] = ACTIONS(3641),
    [anon_sym_u25c7] = ACTIONS(3641),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3641),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1439] = {
    [sym_block_comment] = STATE(1439),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1440] = {
    [sym_block_comment] = STATE(1440),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3497),
    [anon_sym_u2115] = ACTIONS(3495),
    [anon_sym_Int] = ACTIONS(3497),
    [anon_sym_u2124] = ACTIONS(3495),
    [anon_sym_Real] = ACTIONS(3497),
    [anon_sym_u211d] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_BSLASHlnot] = ACTIONS(3495),
    [anon_sym_BSLASHneg] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_u00ac] = ACTIONS(3495),
    [sym_union] = ACTIONS(3497),
    [sym_powerset] = ACTIONS(3497),
    [sym_domain] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [sym_negative_dot] = ACTIONS(3495),
    [sym_enabled] = ACTIONS(3497),
    [sym_unchanged] = ACTIONS(3497),
    [anon_sym_LT_GT] = ACTIONS(3495),
    [anon_sym_u22c4] = ACTIONS(3495),
    [anon_sym_u25c7] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1441] = {
    [sym_block_comment] = STATE(1441),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3533),
    [anon_sym_u2115] = ACTIONS(3531),
    [anon_sym_Int] = ACTIONS(3533),
    [anon_sym_u2124] = ACTIONS(3531),
    [anon_sym_Real] = ACTIONS(3533),
    [anon_sym_u211d] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3531),
    [anon_sym_BSLASHneg] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_u00ac] = ACTIONS(3531),
    [sym_union] = ACTIONS(3533),
    [sym_powerset] = ACTIONS(3533),
    [sym_domain] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3531),
    [sym_enabled] = ACTIONS(3533),
    [sym_unchanged] = ACTIONS(3533),
    [anon_sym_LT_GT] = ACTIONS(3531),
    [anon_sym_u22c4] = ACTIONS(3531),
    [anon_sym_u25c7] = ACTIONS(3531),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3531),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1442] = {
    [sym_block_comment] = STATE(1442),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1443] = {
    [sym_block_comment] = STATE(1443),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1444] = {
    [sym_block_comment] = STATE(1444),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1445] = {
    [sym_block_comment] = STATE(1445),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1446] = {
    [sym_block_comment] = STATE(1446),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1447] = {
    [sym_block_comment] = STATE(1447),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1448] = {
    [sym_block_comment] = STATE(1448),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1449] = {
    [sym_block_comment] = STATE(1449),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1450] = {
    [sym_block_comment] = STATE(1450),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1451] = {
    [sym_block_comment] = STATE(1451),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1452] = {
    [sym_block_comment] = STATE(1452),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1453] = {
    [sym_block_comment] = STATE(1453),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3493),
    [anon_sym_u2115] = ACTIONS(3491),
    [anon_sym_Int] = ACTIONS(3493),
    [anon_sym_u2124] = ACTIONS(3491),
    [anon_sym_Real] = ACTIONS(3493),
    [anon_sym_u211d] = ACTIONS(3491),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_BSLASHlnot] = ACTIONS(3491),
    [anon_sym_BSLASHneg] = ACTIONS(3491),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_u00ac] = ACTIONS(3491),
    [sym_union] = ACTIONS(3493),
    [sym_powerset] = ACTIONS(3493),
    [sym_domain] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3491),
    [sym_enabled] = ACTIONS(3493),
    [sym_unchanged] = ACTIONS(3493),
    [anon_sym_LT_GT] = ACTIONS(3491),
    [anon_sym_u22c4] = ACTIONS(3491),
    [anon_sym_u25c7] = ACTIONS(3491),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1454] = {
    [sym_block_comment] = STATE(1454),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3535),
    [anon_sym_u2115] = ACTIONS(3537),
    [anon_sym_Int] = ACTIONS(3535),
    [anon_sym_u2124] = ACTIONS(3537),
    [anon_sym_Real] = ACTIONS(3535),
    [anon_sym_u211d] = ACTIONS(3537),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3537),
    [anon_sym_BSLASHneg] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3535),
    [anon_sym_u00ac] = ACTIONS(3537),
    [sym_union] = ACTIONS(3535),
    [sym_powerset] = ACTIONS(3535),
    [sym_domain] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3537),
    [sym_enabled] = ACTIONS(3535),
    [sym_unchanged] = ACTIONS(3535),
    [anon_sym_LT_GT] = ACTIONS(3537),
    [anon_sym_u22c4] = ACTIONS(3537),
    [anon_sym_u25c7] = ACTIONS(3537),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3537),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1455] = {
    [sym_block_comment] = STATE(1455),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3539),
    [anon_sym_u2115] = ACTIONS(3541),
    [anon_sym_Int] = ACTIONS(3539),
    [anon_sym_u2124] = ACTIONS(3541),
    [anon_sym_Real] = ACTIONS(3539),
    [anon_sym_u211d] = ACTIONS(3541),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3541),
    [anon_sym_BSLASHneg] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_u00ac] = ACTIONS(3541),
    [sym_union] = ACTIONS(3539),
    [sym_powerset] = ACTIONS(3539),
    [sym_domain] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3541),
    [sym_enabled] = ACTIONS(3539),
    [sym_unchanged] = ACTIONS(3539),
    [anon_sym_LT_GT] = ACTIONS(3541),
    [anon_sym_u22c4] = ACTIONS(3541),
    [anon_sym_u25c7] = ACTIONS(3541),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3541),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1456] = {
    [sym_block_comment] = STATE(1456),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3543),
    [anon_sym_u2115] = ACTIONS(3545),
    [anon_sym_Int] = ACTIONS(3543),
    [anon_sym_u2124] = ACTIONS(3545),
    [anon_sym_Real] = ACTIONS(3543),
    [anon_sym_u211d] = ACTIONS(3545),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3545),
    [anon_sym_BSLASHneg] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3543),
    [anon_sym_u00ac] = ACTIONS(3545),
    [sym_union] = ACTIONS(3543),
    [sym_powerset] = ACTIONS(3543),
    [sym_domain] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3545),
    [sym_enabled] = ACTIONS(3543),
    [sym_unchanged] = ACTIONS(3543),
    [anon_sym_LT_GT] = ACTIONS(3545),
    [anon_sym_u22c4] = ACTIONS(3545),
    [anon_sym_u25c7] = ACTIONS(3545),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3545),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1457] = {
    [sym_block_comment] = STATE(1457),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3551),
    [anon_sym_u2115] = ACTIONS(3553),
    [anon_sym_Int] = ACTIONS(3551),
    [anon_sym_u2124] = ACTIONS(3553),
    [anon_sym_Real] = ACTIONS(3551),
    [anon_sym_u211d] = ACTIONS(3553),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3553),
    [anon_sym_BSLASHneg] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3551),
    [anon_sym_u00ac] = ACTIONS(3553),
    [sym_union] = ACTIONS(3551),
    [sym_powerset] = ACTIONS(3551),
    [sym_domain] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3553),
    [sym_enabled] = ACTIONS(3551),
    [sym_unchanged] = ACTIONS(3551),
    [anon_sym_LT_GT] = ACTIONS(3553),
    [anon_sym_u22c4] = ACTIONS(3553),
    [anon_sym_u25c7] = ACTIONS(3553),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3553),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1458] = {
    [sym_block_comment] = STATE(1458),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3555),
    [anon_sym_u2115] = ACTIONS(3557),
    [anon_sym_Int] = ACTIONS(3555),
    [anon_sym_u2124] = ACTIONS(3557),
    [anon_sym_Real] = ACTIONS(3555),
    [anon_sym_u211d] = ACTIONS(3557),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3557),
    [anon_sym_BSLASHneg] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3555),
    [anon_sym_u00ac] = ACTIONS(3557),
    [sym_union] = ACTIONS(3555),
    [sym_powerset] = ACTIONS(3555),
    [sym_domain] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3557),
    [sym_enabled] = ACTIONS(3555),
    [sym_unchanged] = ACTIONS(3555),
    [anon_sym_LT_GT] = ACTIONS(3557),
    [anon_sym_u22c4] = ACTIONS(3557),
    [anon_sym_u25c7] = ACTIONS(3557),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3557),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1459] = {
    [sym_block_comment] = STATE(1459),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3513),
    [anon_sym_u2115] = ACTIONS(3511),
    [anon_sym_Int] = ACTIONS(3513),
    [anon_sym_u2124] = ACTIONS(3511),
    [anon_sym_Real] = ACTIONS(3513),
    [anon_sym_u211d] = ACTIONS(3511),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3511),
    [anon_sym_BSLASHneg] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3513),
    [anon_sym_u00ac] = ACTIONS(3511),
    [sym_union] = ACTIONS(3513),
    [sym_powerset] = ACTIONS(3513),
    [sym_domain] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3511),
    [sym_enabled] = ACTIONS(3513),
    [sym_unchanged] = ACTIONS(3513),
    [anon_sym_LT_GT] = ACTIONS(3511),
    [anon_sym_u22c4] = ACTIONS(3511),
    [anon_sym_u25c7] = ACTIONS(3511),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3511),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1460] = {
    [sym_block_comment] = STATE(1460),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3523),
    [anon_sym_u2115] = ACTIONS(3525),
    [anon_sym_Int] = ACTIONS(3523),
    [anon_sym_u2124] = ACTIONS(3525),
    [anon_sym_Real] = ACTIONS(3523),
    [anon_sym_u211d] = ACTIONS(3525),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3525),
    [anon_sym_BSLASHneg] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_u00ac] = ACTIONS(3525),
    [sym_union] = ACTIONS(3523),
    [sym_powerset] = ACTIONS(3523),
    [sym_domain] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3525),
    [sym_enabled] = ACTIONS(3523),
    [sym_unchanged] = ACTIONS(3523),
    [anon_sym_LT_GT] = ACTIONS(3525),
    [anon_sym_u22c4] = ACTIONS(3525),
    [anon_sym_u25c7] = ACTIONS(3525),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3525),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1461] = {
    [sym_block_comment] = STATE(1461),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3527),
    [anon_sym_u2115] = ACTIONS(3529),
    [anon_sym_Int] = ACTIONS(3527),
    [anon_sym_u2124] = ACTIONS(3529),
    [anon_sym_Real] = ACTIONS(3527),
    [anon_sym_u211d] = ACTIONS(3529),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3529),
    [anon_sym_BSLASHneg] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_u00ac] = ACTIONS(3529),
    [sym_union] = ACTIONS(3527),
    [sym_powerset] = ACTIONS(3527),
    [sym_domain] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3529),
    [sym_enabled] = ACTIONS(3527),
    [sym_unchanged] = ACTIONS(3527),
    [anon_sym_LT_GT] = ACTIONS(3529),
    [anon_sym_u22c4] = ACTIONS(3529),
    [anon_sym_u25c7] = ACTIONS(3529),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3529),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1462] = {
    [sym_block_comment] = STATE(1462),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3501),
    [anon_sym_u2115] = ACTIONS(3499),
    [anon_sym_Int] = ACTIONS(3501),
    [anon_sym_u2124] = ACTIONS(3499),
    [anon_sym_Real] = ACTIONS(3501),
    [anon_sym_u211d] = ACTIONS(3499),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3499),
    [anon_sym_BSLASHneg] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_u00ac] = ACTIONS(3499),
    [sym_union] = ACTIONS(3501),
    [sym_powerset] = ACTIONS(3501),
    [sym_domain] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3499),
    [sym_enabled] = ACTIONS(3501),
    [sym_unchanged] = ACTIONS(3501),
    [anon_sym_LT_GT] = ACTIONS(3499),
    [anon_sym_u22c4] = ACTIONS(3499),
    [anon_sym_u25c7] = ACTIONS(3499),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3499),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1463] = {
    [sym_block_comment] = STATE(1463),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3505),
    [anon_sym_u2115] = ACTIONS(3503),
    [anon_sym_Int] = ACTIONS(3505),
    [anon_sym_u2124] = ACTIONS(3503),
    [anon_sym_Real] = ACTIONS(3505),
    [anon_sym_u211d] = ACTIONS(3503),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3503),
    [anon_sym_BSLASHneg] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_u00ac] = ACTIONS(3503),
    [sym_union] = ACTIONS(3505),
    [sym_powerset] = ACTIONS(3505),
    [sym_domain] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3503),
    [sym_enabled] = ACTIONS(3505),
    [sym_unchanged] = ACTIONS(3505),
    [anon_sym_LT_GT] = ACTIONS(3503),
    [anon_sym_u22c4] = ACTIONS(3503),
    [anon_sym_u25c7] = ACTIONS(3503),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3503),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1464] = {
    [sym_block_comment] = STATE(1464),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3509),
    [anon_sym_u2115] = ACTIONS(3507),
    [anon_sym_Int] = ACTIONS(3509),
    [anon_sym_u2124] = ACTIONS(3507),
    [anon_sym_Real] = ACTIONS(3509),
    [anon_sym_u211d] = ACTIONS(3507),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3507),
    [anon_sym_BSLASHneg] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [anon_sym_u00ac] = ACTIONS(3507),
    [sym_union] = ACTIONS(3509),
    [sym_powerset] = ACTIONS(3509),
    [sym_domain] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3507),
    [sym_enabled] = ACTIONS(3509),
    [sym_unchanged] = ACTIONS(3509),
    [anon_sym_LT_GT] = ACTIONS(3507),
    [anon_sym_u22c4] = ACTIONS(3507),
    [anon_sym_u25c7] = ACTIONS(3507),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3507),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1465] = {
    [sym_block_comment] = STATE(1465),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3517),
    [anon_sym_u2115] = ACTIONS(3515),
    [anon_sym_Int] = ACTIONS(3517),
    [anon_sym_u2124] = ACTIONS(3515),
    [anon_sym_Real] = ACTIONS(3517),
    [anon_sym_u211d] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3515),
    [anon_sym_BSLASHneg] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3517),
    [anon_sym_u00ac] = ACTIONS(3515),
    [sym_union] = ACTIONS(3517),
    [sym_powerset] = ACTIONS(3517),
    [sym_domain] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3515),
    [sym_enabled] = ACTIONS(3517),
    [sym_unchanged] = ACTIONS(3517),
    [anon_sym_LT_GT] = ACTIONS(3515),
    [anon_sym_u22c4] = ACTIONS(3515),
    [anon_sym_u25c7] = ACTIONS(3515),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3515),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1466] = {
    [sym_block_comment] = STATE(1466),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3653),
    [anon_sym_u25a1] = ACTIONS(3653),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RECURSIVE] = ACTIONS(3651),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3651),
    [anon_sym_u2115] = ACTIONS(3653),
    [anon_sym_Int] = ACTIONS(3651),
    [anon_sym_u2124] = ACTIONS(3653),
    [anon_sym_Real] = ACTIONS(3651),
    [anon_sym_u211d] = ACTIONS(3653),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3651),
    [anon_sym_BSLASHlnot] = ACTIONS(3653),
    [anon_sym_BSLASHneg] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_u00ac] = ACTIONS(3653),
    [sym_union] = ACTIONS(3651),
    [sym_powerset] = ACTIONS(3651),
    [sym_domain] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3653),
    [sym_enabled] = ACTIONS(3651),
    [sym_unchanged] = ACTIONS(3651),
    [anon_sym_LT_GT] = ACTIONS(3653),
    [anon_sym_u22c4] = ACTIONS(3653),
    [anon_sym_u25c7] = ACTIONS(3653),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1467] = {
    [sym_block_comment] = STATE(1467),
    [sym_implies] = STATE(446),
    [sym_plus_arrow] = STATE(447),
    [sym_equiv] = STATE(447),
    [sym_iff] = STATE(447),
    [sym_leads_to] = STATE(447),
    [sym_land] = STATE(448),
    [sym_lor] = STATE(448),
    [sym_assign] = STATE(438),
    [sym_bnf_rule] = STATE(438),
    [sym_eq] = STATE(438),
    [sym_neq] = STATE(438),
    [sym_lt] = STATE(438),
    [sym_leq] = STATE(438),
    [sym_geq] = STATE(438),
    [sym_approx] = STATE(438),
    [sym_rs_ttile] = STATE(438),
    [sym_rd_ttile] = STATE(438),
    [sym_ls_ttile] = STATE(438),
    [sym_ld_ttile] = STATE(438),
    [sym_asymp] = STATE(438),
    [sym_cong] = STATE(438),
    [sym_doteq] = STATE(438),
    [sym_gg] = STATE(438),
    [sym_ll] = STATE(438),
    [sym_in] = STATE(438),
    [sym_notin] = STATE(438),
    [sym_prec] = STATE(438),
    [sym_succ] = STATE(438),
    [sym_preceq] = STATE(438),
    [sym_succeq] = STATE(438),
    [sym_propto] = STATE(438),
    [sym_sim] = STATE(438),
    [sym_simeq] = STATE(438),
    [sym_sqsubset] = STATE(438),
    [sym_sqsupset] = STATE(438),
    [sym_sqsubseteq] = STATE(438),
    [sym_sqsupseteq] = STATE(438),
    [sym_subset] = STATE(438),
    [sym_supset] = STATE(438),
    [sym_subseteq] = STATE(438),
    [sym_supseteq] = STATE(438),
    [sym_cap] = STATE(441),
    [sym_cup] = STATE(441),
    [sym_dots_2] = STATE(449),
    [sym_dots_3] = STATE(449),
    [sym_plus] = STATE(442),
    [sym_oplus] = STATE(442),
    [sym_ominus] = STATE(443),
    [sym_vertvert] = STATE(443),
    [sym_minus] = STATE(443),
    [sym_odot] = STATE(444),
    [sym_oslash] = STATE(444),
    [sym_otimes] = STATE(444),
    [sym_bigcirc] = STATE(444),
    [sym_bullet] = STATE(444),
    [sym_div] = STATE(444),
    [sym_circ] = STATE(444),
    [sym_star] = STATE(444),
    [sym_excl] = STATE(444),
    [sym_qq] = STATE(444),
    [sym_sqcap] = STATE(444),
    [sym_sqcup] = STATE(444),
    [sym_uplus] = STATE(444),
    [sym_times] = STATE(444),
    [sym_wr] = STATE(445),
    [sym_cdot] = STATE(445),
    [sym_sup_plus] = STATE(2702),
    [sym_identifier] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3669),
    [anon_sym_u25a1] = ACTIONS(3669),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RECURSIVE] = ACTIONS(3667),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3667),
    [anon_sym_u2115] = ACTIONS(3669),
    [anon_sym_Int] = ACTIONS(3667),
    [anon_sym_u2124] = ACTIONS(3669),
    [anon_sym_Real] = ACTIONS(3667),
    [anon_sym_u211d] = ACTIONS(3669),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_IN] = ACTIONS(3667),
    [anon_sym_BSLASHlnot] = ACTIONS(3669),
    [anon_sym_BSLASHneg] = ACTIONS(3669),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_u00ac] = ACTIONS(3669),
    [sym_union] = ACTIONS(3667),
    [sym_powerset] = ACTIONS(3667),
    [sym_domain] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3669),
    [sym_enabled] = ACTIONS(3667),
    [sym_unchanged] = ACTIONS(3667),
    [anon_sym_LT_GT] = ACTIONS(3669),
    [anon_sym_u22c4] = ACTIONS(3669),
    [anon_sym_u25c7] = ACTIONS(3669),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3751),
    [sym_map_to] = ACTIONS(3753),
    [sym_map_from] = ACTIONS(3753),
    [sym_setminus] = ACTIONS(3755),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3757),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3759),
    [sym_modmod] = ACTIONS(3761),
    [sym_vert] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3761),
    [sym_amp] = ACTIONS(3763),
    [sym_ampamp] = ACTIONS(3765),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3763),
    [sym_mulmul] = ACTIONS(3765),
    [sym_slash] = ACTIONS(3763),
    [sym_slashslash] = ACTIONS(3765),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3765),
    [sym_dol] = ACTIONS(3763),
    [sym_doldol] = ACTIONS(3765),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3767),
    [sym_powpow] = ACTIONS(3769),
    [anon_sym_CARET_PLUS] = ACTIONS(3771),
    [anon_sym_u207a] = ACTIONS(3771),
    [sym_asterisk] = ACTIONS(3773),
    [sym_sup_hash] = ACTIONS(3773),
    [sym_prime] = ACTIONS(3773),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1468] = {
    [sym_block_comment] = STATE(1468),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3677),
    [anon_sym_u25a1] = ACTIONS(3677),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3675),
    [anon_sym_u2115] = ACTIONS(3677),
    [anon_sym_Int] = ACTIONS(3675),
    [anon_sym_u2124] = ACTIONS(3677),
    [anon_sym_Real] = ACTIONS(3675),
    [anon_sym_u211d] = ACTIONS(3677),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3677),
    [anon_sym_BSLASHneg] = ACTIONS(3677),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_u00ac] = ACTIONS(3677),
    [sym_union] = ACTIONS(3675),
    [sym_powerset] = ACTIONS(3675),
    [sym_domain] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3677),
    [sym_enabled] = ACTIONS(3675),
    [sym_unchanged] = ACTIONS(3675),
    [anon_sym_LT_GT] = ACTIONS(3677),
    [anon_sym_u22c4] = ACTIONS(3677),
    [anon_sym_u25c7] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3677),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1469] = {
    [sym_block_comment] = STATE(1469),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3643),
    [anon_sym_u25a1] = ACTIONS(3643),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3645),
    [anon_sym_u2115] = ACTIONS(3643),
    [anon_sym_Int] = ACTIONS(3645),
    [anon_sym_u2124] = ACTIONS(3643),
    [anon_sym_Real] = ACTIONS(3645),
    [anon_sym_u211d] = ACTIONS(3643),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3643),
    [anon_sym_BSLASHneg] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3645),
    [anon_sym_u00ac] = ACTIONS(3643),
    [sym_union] = ACTIONS(3645),
    [sym_powerset] = ACTIONS(3645),
    [sym_domain] = ACTIONS(3645),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3643),
    [sym_enabled] = ACTIONS(3645),
    [sym_unchanged] = ACTIONS(3645),
    [anon_sym_LT_GT] = ACTIONS(3643),
    [anon_sym_u22c4] = ACTIONS(3643),
    [anon_sym_u25c7] = ACTIONS(3643),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3643),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1470] = {
    [sym_block_comment] = STATE(1470),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3653),
    [anon_sym_u25a1] = ACTIONS(3653),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3651),
    [anon_sym_u2115] = ACTIONS(3653),
    [anon_sym_Int] = ACTIONS(3651),
    [anon_sym_u2124] = ACTIONS(3653),
    [anon_sym_Real] = ACTIONS(3651),
    [anon_sym_u211d] = ACTIONS(3653),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3653),
    [anon_sym_BSLASHneg] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_u00ac] = ACTIONS(3653),
    [sym_union] = ACTIONS(3651),
    [sym_powerset] = ACTIONS(3651),
    [sym_domain] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3653),
    [sym_enabled] = ACTIONS(3651),
    [sym_unchanged] = ACTIONS(3651),
    [anon_sym_LT_GT] = ACTIONS(3653),
    [anon_sym_u22c4] = ACTIONS(3653),
    [anon_sym_u25c7] = ACTIONS(3653),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3653),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1471] = {
    [sym_block_comment] = STATE(1471),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3669),
    [anon_sym_u25a1] = ACTIONS(3669),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3667),
    [anon_sym_u2115] = ACTIONS(3669),
    [anon_sym_Int] = ACTIONS(3667),
    [anon_sym_u2124] = ACTIONS(3669),
    [anon_sym_Real] = ACTIONS(3667),
    [anon_sym_u211d] = ACTIONS(3669),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3669),
    [anon_sym_BSLASHneg] = ACTIONS(3669),
    [anon_sym_TILDE] = ACTIONS(3667),
    [anon_sym_u00ac] = ACTIONS(3669),
    [sym_union] = ACTIONS(3667),
    [sym_powerset] = ACTIONS(3667),
    [sym_domain] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3669),
    [sym_enabled] = ACTIONS(3667),
    [sym_unchanged] = ACTIONS(3667),
    [anon_sym_LT_GT] = ACTIONS(3669),
    [anon_sym_u22c4] = ACTIONS(3669),
    [anon_sym_u25c7] = ACTIONS(3669),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3669),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1472] = {
    [sym_block_comment] = STATE(1472),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3659),
    [anon_sym_u25a1] = ACTIONS(3659),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3661),
    [anon_sym_u2115] = ACTIONS(3659),
    [anon_sym_Int] = ACTIONS(3661),
    [anon_sym_u2124] = ACTIONS(3659),
    [anon_sym_Real] = ACTIONS(3661),
    [anon_sym_u211d] = ACTIONS(3659),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3659),
    [anon_sym_BSLASHneg] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [anon_sym_u00ac] = ACTIONS(3659),
    [sym_union] = ACTIONS(3661),
    [sym_powerset] = ACTIONS(3661),
    [sym_domain] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3659),
    [sym_enabled] = ACTIONS(3661),
    [sym_unchanged] = ACTIONS(3661),
    [anon_sym_LT_GT] = ACTIONS(3659),
    [anon_sym_u22c4] = ACTIONS(3659),
    [anon_sym_u25c7] = ACTIONS(3659),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3659),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1473] = {
    [sym_block_comment] = STATE(1473),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3647),
    [anon_sym_u25a1] = ACTIONS(3647),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3649),
    [anon_sym_u2115] = ACTIONS(3647),
    [anon_sym_Int] = ACTIONS(3649),
    [anon_sym_u2124] = ACTIONS(3647),
    [anon_sym_Real] = ACTIONS(3649),
    [anon_sym_u211d] = ACTIONS(3647),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3647),
    [anon_sym_BSLASHneg] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3649),
    [anon_sym_u00ac] = ACTIONS(3647),
    [sym_union] = ACTIONS(3649),
    [sym_powerset] = ACTIONS(3649),
    [sym_domain] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3647),
    [sym_enabled] = ACTIONS(3649),
    [sym_unchanged] = ACTIONS(3649),
    [anon_sym_LT_GT] = ACTIONS(3647),
    [anon_sym_u22c4] = ACTIONS(3647),
    [anon_sym_u25c7] = ACTIONS(3647),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3647),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1474] = {
    [sym_block_comment] = STATE(1474),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3663),
    [anon_sym_u25a1] = ACTIONS(3663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3665),
    [anon_sym_u2115] = ACTIONS(3663),
    [anon_sym_Int] = ACTIONS(3665),
    [anon_sym_u2124] = ACTIONS(3663),
    [anon_sym_Real] = ACTIONS(3665),
    [anon_sym_u211d] = ACTIONS(3663),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3663),
    [anon_sym_BSLASHneg] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3665),
    [anon_sym_u00ac] = ACTIONS(3663),
    [sym_union] = ACTIONS(3665),
    [sym_powerset] = ACTIONS(3665),
    [sym_domain] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3663),
    [sym_enabled] = ACTIONS(3665),
    [sym_unchanged] = ACTIONS(3665),
    [anon_sym_LT_GT] = ACTIONS(3663),
    [anon_sym_u22c4] = ACTIONS(3663),
    [anon_sym_u25c7] = ACTIONS(3663),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3663),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1475] = {
    [sym_block_comment] = STATE(1475),
    [sym_implies] = STATE(666),
    [sym_plus_arrow] = STATE(667),
    [sym_equiv] = STATE(667),
    [sym_iff] = STATE(667),
    [sym_leads_to] = STATE(667),
    [sym_land] = STATE(668),
    [sym_lor] = STATE(668),
    [sym_assign] = STATE(658),
    [sym_bnf_rule] = STATE(658),
    [sym_eq] = STATE(658),
    [sym_neq] = STATE(658),
    [sym_lt] = STATE(658),
    [sym_leq] = STATE(658),
    [sym_geq] = STATE(658),
    [sym_approx] = STATE(658),
    [sym_rs_ttile] = STATE(658),
    [sym_rd_ttile] = STATE(658),
    [sym_ls_ttile] = STATE(658),
    [sym_ld_ttile] = STATE(658),
    [sym_asymp] = STATE(658),
    [sym_cong] = STATE(658),
    [sym_doteq] = STATE(658),
    [sym_gg] = STATE(658),
    [sym_ll] = STATE(658),
    [sym_in] = STATE(658),
    [sym_notin] = STATE(658),
    [sym_prec] = STATE(658),
    [sym_succ] = STATE(658),
    [sym_preceq] = STATE(658),
    [sym_succeq] = STATE(658),
    [sym_propto] = STATE(658),
    [sym_sim] = STATE(658),
    [sym_simeq] = STATE(658),
    [sym_sqsubset] = STATE(658),
    [sym_sqsupset] = STATE(658),
    [sym_sqsubseteq] = STATE(658),
    [sym_sqsupseteq] = STATE(658),
    [sym_subset] = STATE(658),
    [sym_supset] = STATE(658),
    [sym_subseteq] = STATE(658),
    [sym_supseteq] = STATE(658),
    [sym_cap] = STATE(661),
    [sym_cup] = STATE(661),
    [sym_dots_2] = STATE(669),
    [sym_dots_3] = STATE(669),
    [sym_plus] = STATE(662),
    [sym_oplus] = STATE(662),
    [sym_ominus] = STATE(663),
    [sym_vertvert] = STATE(663),
    [sym_minus] = STATE(663),
    [sym_odot] = STATE(664),
    [sym_oslash] = STATE(664),
    [sym_otimes] = STATE(664),
    [sym_bigcirc] = STATE(664),
    [sym_bullet] = STATE(664),
    [sym_div] = STATE(664),
    [sym_circ] = STATE(664),
    [sym_star] = STATE(664),
    [sym_excl] = STATE(664),
    [sym_qq] = STATE(664),
    [sym_sqcap] = STATE(664),
    [sym_sqcup] = STATE(664),
    [sym_uplus] = STATE(664),
    [sym_times] = STATE(664),
    [sym_wr] = STATE(665),
    [sym_cdot] = STATE(665),
    [sym_sup_plus] = STATE(2737),
    [sym_identifier] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3673),
    [anon_sym_u25a1] = ACTIONS(3673),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(3775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_Nat] = ACTIONS(3671),
    [anon_sym_u2115] = ACTIONS(3673),
    [anon_sym_Int] = ACTIONS(3671),
    [anon_sym_u2124] = ACTIONS(3673),
    [anon_sym_Real] = ACTIONS(3671),
    [anon_sym_u211d] = ACTIONS(3673),
    [anon_sym_DOT] = ACTIONS(3777),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_BSLASHlnot] = ACTIONS(3673),
    [anon_sym_BSLASHneg] = ACTIONS(3673),
    [anon_sym_TILDE] = ACTIONS(3671),
    [anon_sym_u00ac] = ACTIONS(3673),
    [sym_union] = ACTIONS(3671),
    [sym_powerset] = ACTIONS(3671),
    [sym_domain] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(2354),
    [sym_negative_dot] = ACTIONS(3673),
    [sym_enabled] = ACTIONS(3671),
    [sym_unchanged] = ACTIONS(3671),
    [anon_sym_LT_GT] = ACTIONS(3673),
    [anon_sym_u22c4] = ACTIONS(3673),
    [anon_sym_u25c7] = ACTIONS(3673),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3779),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3781),
    [sym_map_to] = ACTIONS(3783),
    [sym_map_from] = ACTIONS(3783),
    [sym_setminus] = ACTIONS(3785),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3787),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3789),
    [sym_modmod] = ACTIONS(3791),
    [sym_vert] = ACTIONS(3789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3791),
    [sym_amp] = ACTIONS(3793),
    [sym_ampamp] = ACTIONS(3795),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3793),
    [sym_mulmul] = ACTIONS(3795),
    [sym_slash] = ACTIONS(3793),
    [sym_slashslash] = ACTIONS(3795),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3795),
    [sym_dol] = ACTIONS(3793),
    [sym_doldol] = ACTIONS(3795),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3797),
    [sym_powpow] = ACTIONS(3799),
    [anon_sym_CARET_PLUS] = ACTIONS(3801),
    [anon_sym_u207a] = ACTIONS(3801),
    [sym_asterisk] = ACTIONS(3803),
    [sym_sup_hash] = ACTIONS(3803),
    [sym_prime] = ACTIONS(3803),
    [sym__begin_proof_step] = ACTIONS(3673),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1476] = {
    [sym_block_comment] = STATE(1476),
    [sym_substitution] = STATE(3513),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4392),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4392),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4392),
    [sym_identifier] = ACTIONS(3805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1477] = {
    [sym_block_comment] = STATE(1477),
    [sym_substitution] = STATE(3566),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4392),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4392),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4392),
    [sym_identifier] = ACTIONS(3805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1478] = {
    [sym_block_comment] = STATE(1478),
    [sym_substitution] = STATE(3759),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4321),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4321),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4321),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1479] = {
    [sym_block_comment] = STATE(1479),
    [sym_substitution] = STATE(3513),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4297),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4297),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4297),
    [sym_identifier] = ACTIONS(3809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1480] = {
    [sym_block_comment] = STATE(1480),
    [sym_substitution] = STATE(4524),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4246),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4246),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4246),
    [sym_identifier] = ACTIONS(3811),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1481] = {
    [sym_block_comment] = STATE(1481),
    [sym_substitution] = STATE(3828),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4321),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4321),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4321),
    [sym_identifier] = ACTIONS(3807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1482] = {
    [sym_block_comment] = STATE(1482),
    [sym_substitution] = STATE(3513),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4252),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4252),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4252),
    [sym_identifier] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1483] = {
    [sym_block_comment] = STATE(1483),
    [sym_substitution] = STATE(3851),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4246),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4246),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4246),
    [sym_identifier] = ACTIONS(3811),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1484] = {
    [sym_block_comment] = STATE(1484),
    [sym_substitution] = STATE(3851),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4334),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4334),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4334),
    [sym_identifier] = ACTIONS(3815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1485] = {
    [sym_block_comment] = STATE(1485),
    [sym_substitution] = STATE(3840),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4334),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4334),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4334),
    [sym_identifier] = ACTIONS(3815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1486] = {
    [sym_block_comment] = STATE(1486),
    [sym_substitution] = STATE(3718),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4297),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4297),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4297),
    [sym_identifier] = ACTIONS(3809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1487] = {
    [sym_block_comment] = STATE(1487),
    [sym_substitution] = STATE(3553),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(4252),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(4252),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4252),
    [sym_identifier] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(2150),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1488] = {
    [sym_block_comment] = STATE(1488),
    [sym_def_eq] = STATE(197),
    [sym_label_as] = STATE(490),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5241),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_EQ_EQ] = ACTIONS(3817),
    [anon_sym_u225c] = ACTIONS(3817),
    [anon_sym_BSLASHin] = ACTIONS(3819),
    [anon_sym_u2208] = ACTIONS(3822),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3829),
    [anon_sym_u2227] = ACTIONS(3829),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3832),
    [anon_sym_u2228] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3835),
    [anon_sym_LBRACK] = ACTIONS(3837),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3842),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_EQ_GT] = ACTIONS(3853),
    [anon_sym_u27f9] = ACTIONS(3853),
    [anon_sym_u21d2] = ACTIONS(3853),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3856),
    [anon_sym_u21f8] = ACTIONS(3856),
    [anon_sym_u2945] = ACTIONS(3856),
    [anon_sym_BSLASHequiv] = ACTIONS(3859),
    [anon_sym_u2261] = ACTIONS(3859),
    [anon_sym_LT_EQ_GT] = ACTIONS(3862),
    [anon_sym_u27fa] = ACTIONS(3862),
    [anon_sym_u21d4] = ACTIONS(3862),
    [anon_sym_TILDE_GT] = ACTIONS(3865),
    [anon_sym_u21dd] = ACTIONS(3865),
    [anon_sym_u219d] = ACTIONS(3865),
    [anon_sym_BSLASHland] = ACTIONS(3829),
    [anon_sym_BSLASHlor] = ACTIONS(3832),
    [anon_sym_COLON_EQ] = ACTIONS(3868),
    [anon_sym_u2254] = ACTIONS(3868),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3871),
    [anon_sym_u2a74] = ACTIONS(3871),
    [anon_sym_SLASH_EQ] = ACTIONS(3874),
    [anon_sym_POUND] = ACTIONS(3877),
    [anon_sym_u2260] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(3880),
    [sym_gt] = ACTIONS(3883),
    [anon_sym_LT_EQ] = ACTIONS(3886),
    [anon_sym_EQ_LT] = ACTIONS(3889),
    [anon_sym_BSLASHleq] = ACTIONS(3889),
    [anon_sym_u2264] = ACTIONS(3889),
    [anon_sym_GT_EQ] = ACTIONS(3892),
    [anon_sym_BSLASHgeq] = ACTIONS(3892),
    [anon_sym_u2265] = ACTIONS(3892),
    [anon_sym_BSLASHapprox] = ACTIONS(3895),
    [anon_sym_u2248] = ACTIONS(3895),
    [anon_sym_PIPE_DASH] = ACTIONS(3898),
    [anon_sym_u22a2] = ACTIONS(3898),
    [anon_sym_PIPE_EQ] = ACTIONS(3901),
    [anon_sym_u22a8] = ACTIONS(3901),
    [anon_sym_DASH_PIPE] = ACTIONS(3904),
    [anon_sym_u22a3] = ACTIONS(3904),
    [anon_sym_EQ_PIPE] = ACTIONS(3907),
    [anon_sym_u2ae4] = ACTIONS(3907),
    [anon_sym_BSLASHasymp] = ACTIONS(3910),
    [anon_sym_u224d] = ACTIONS(3910),
    [anon_sym_BSLASHcong] = ACTIONS(3913),
    [anon_sym_u2245] = ACTIONS(3913),
    [anon_sym_BSLASHdoteq] = ACTIONS(3916),
    [anon_sym_u2250] = ACTIONS(3916),
    [anon_sym_BSLASHgg] = ACTIONS(3919),
    [anon_sym_u226b] = ACTIONS(3919),
    [anon_sym_BSLASHll] = ACTIONS(3922),
    [anon_sym_u226a] = ACTIONS(3922),
    [anon_sym_BSLASHnotin] = ACTIONS(3925),
    [anon_sym_u2209] = ACTIONS(3925),
    [anon_sym_BSLASHprec] = ACTIONS(3928),
    [anon_sym_u227a] = ACTIONS(3931),
    [anon_sym_BSLASHsucc] = ACTIONS(3934),
    [anon_sym_u227b] = ACTIONS(3937),
    [anon_sym_BSLASHpreceq] = ACTIONS(3940),
    [anon_sym_u2aaf] = ACTIONS(3940),
    [anon_sym_BSLASHsucceq] = ACTIONS(3943),
    [anon_sym_u2ab0] = ACTIONS(3943),
    [anon_sym_BSLASHpropto] = ACTIONS(3946),
    [anon_sym_u221d] = ACTIONS(3946),
    [anon_sym_BSLASHsim] = ACTIONS(3949),
    [anon_sym_u223c] = ACTIONS(3952),
    [anon_sym_BSLASHsimeq] = ACTIONS(3955),
    [anon_sym_u2243] = ACTIONS(3955),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3958),
    [anon_sym_u228f] = ACTIONS(3961),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3964),
    [anon_sym_u2290] = ACTIONS(3967),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3970),
    [anon_sym_u2291] = ACTIONS(3970),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3973),
    [anon_sym_u2292] = ACTIONS(3973),
    [anon_sym_BSLASHsubset] = ACTIONS(3976),
    [anon_sym_u2282] = ACTIONS(3979),
    [anon_sym_BSLASHsupset] = ACTIONS(3982),
    [anon_sym_u2283] = ACTIONS(3985),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3988),
    [anon_sym_u2286] = ACTIONS(3988),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3991),
    [anon_sym_u2287] = ACTIONS(3991),
    [sym_compose] = ACTIONS(3994),
    [sym_map_to] = ACTIONS(3994),
    [sym_map_from] = ACTIONS(3994),
    [sym_setminus] = ACTIONS(3883),
    [anon_sym_BSLASHcap] = ACTIONS(3997),
    [anon_sym_BSLASHintersect] = ACTIONS(3997),
    [anon_sym_u2229] = ACTIONS(3997),
    [anon_sym_BSLASHcup] = ACTIONS(4000),
    [anon_sym_BSLASHunion] = ACTIONS(4000),
    [anon_sym_u222a] = ACTIONS(4000),
    [anon_sym_DOT_DOT] = ACTIONS(4003),
    [anon_sym_u2025] = ACTIONS(4006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4009),
    [anon_sym_u2026] = ACTIONS(4009),
    [anon_sym_PLUS] = ACTIONS(4012),
    [sym_plusplus] = ACTIONS(3994),
    [anon_sym_BSLASHoplus] = ACTIONS(4015),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4015),
    [anon_sym_u2295] = ACTIONS(4015),
    [anon_sym_BSLASHominus] = ACTIONS(4018),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4018),
    [anon_sym_u2296] = ACTIONS(4018),
    [sym_mod] = ACTIONS(3883),
    [sym_modmod] = ACTIONS(3994),
    [sym_vert] = ACTIONS(3883),
    [anon_sym_PIPE_PIPE] = ACTIONS(4021),
    [anon_sym_u2016] = ACTIONS(4021),
    [sym_minusminus] = ACTIONS(3994),
    [sym_amp] = ACTIONS(3883),
    [sym_ampamp] = ACTIONS(3994),
    [anon_sym_BSLASHodot] = ACTIONS(4024),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4024),
    [anon_sym_u2299] = ACTIONS(4024),
    [anon_sym_BSLASHoslash] = ACTIONS(4027),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4027),
    [anon_sym_u2298] = ACTIONS(4027),
    [anon_sym_BSLASHotimes] = ACTIONS(4030),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4030),
    [anon_sym_u2297] = ACTIONS(4030),
    [sym_mul] = ACTIONS(3883),
    [sym_mulmul] = ACTIONS(3994),
    [sym_slash] = ACTIONS(3883),
    [sym_slashslash] = ACTIONS(3994),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4033),
    [anon_sym_u25ef] = ACTIONS(4033),
    [anon_sym_BSLASHbullet] = ACTIONS(4036),
    [anon_sym_u25cf] = ACTIONS(4036),
    [anon_sym_BSLASHdiv] = ACTIONS(4039),
    [anon_sym_u00f7] = ACTIONS(4039),
    [anon_sym_BSLASHcirc] = ACTIONS(4042),
    [anon_sym_u2218] = ACTIONS(4042),
    [anon_sym_BSLASHstar] = ACTIONS(4045),
    [anon_sym_u22c6] = ACTIONS(4045),
    [anon_sym_u203c] = ACTIONS(4048),
    [sym_hashhash] = ACTIONS(3994),
    [sym_dol] = ACTIONS(3883),
    [sym_doldol] = ACTIONS(3994),
    [anon_sym_QMARK_QMARK] = ACTIONS(4051),
    [anon_sym_u2047] = ACTIONS(4051),
    [anon_sym_BSLASHsqcap] = ACTIONS(4054),
    [anon_sym_u2293] = ACTIONS(4054),
    [anon_sym_BSLASHsqcup] = ACTIONS(4057),
    [anon_sym_u2294] = ACTIONS(4057),
    [anon_sym_BSLASHuplus] = ACTIONS(4060),
    [anon_sym_u228e] = ACTIONS(4060),
    [anon_sym_BSLASHX] = ACTIONS(4063),
    [anon_sym_BSLASHtimes] = ACTIONS(4063),
    [anon_sym_u00d7] = ACTIONS(4063),
    [anon_sym_BSLASHwr] = ACTIONS(4066),
    [anon_sym_u2240] = ACTIONS(4066),
    [anon_sym_BSLASHcdot] = ACTIONS(4069),
    [anon_sym_u22c5] = ACTIONS(4069),
    [sym_pow] = ACTIONS(3883),
    [sym_powpow] = ACTIONS(3994),
    [anon_sym_CARET_PLUS] = ACTIONS(4072),
    [anon_sym_u207a] = ACTIONS(4072),
    [sym_asterisk] = ACTIONS(4075),
    [sym_sup_hash] = ACTIONS(4075),
    [sym_prime] = ACTIONS(4075),
    [anon_sym_PROOF] = ACTIONS(4078),
    [anon_sym_BY] = ACTIONS(4078),
    [anon_sym_OBVIOUS] = ACTIONS(4078),
    [anon_sym_OMITTED] = ACTIONS(4078),
    [sym__begin_proof] = ACTIONS(4078),
    [sym__begin_proof_step] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4048),
  },
  [1489] = {
    [sym_block_comment] = STATE(1489),
    [sym_case_arrow] = STATE(505),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym__proof] = STATE(5293),
    [sym_terminal_proof] = STATE(5283),
    [sym_non_terminal_proof] = STATE(5283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(4112),
    [anon_sym_BY] = ACTIONS(4114),
    [anon_sym_OBVIOUS] = ACTIONS(4116),
    [anon_sym_OMITTED] = ACTIONS(4116),
    [sym__begin_proof] = ACTIONS(4118),
    [sym__begin_proof_step] = ACTIONS(4120),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1490] = {
    [sym_block_comment] = STATE(1490),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3507),
    [anon_sym_u27f6] = ACTIONS(3507),
    [anon_sym_u2192] = ACTIONS(3507),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3507),
    [anon_sym_BY] = ACTIONS(3507),
    [anon_sym_OBVIOUS] = ACTIONS(3507),
    [anon_sym_OMITTED] = ACTIONS(3507),
    [sym__begin_proof] = ACTIONS(3507),
    [sym__begin_proof_step] = ACTIONS(3507),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1491] = {
    [sym_block_comment] = STATE(1491),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1492] = {
    [sym_block_comment] = STATE(1492),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_u27f6] = ACTIONS(3511),
    [anon_sym_u2192] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3511),
    [anon_sym_BY] = ACTIONS(3511),
    [anon_sym_OBVIOUS] = ACTIONS(3511),
    [anon_sym_OMITTED] = ACTIONS(3511),
    [sym__begin_proof] = ACTIONS(3511),
    [sym__begin_proof_step] = ACTIONS(3511),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1493] = {
    [sym_block_comment] = STATE(1493),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3525),
    [anon_sym_u27f6] = ACTIONS(3525),
    [anon_sym_u2192] = ACTIONS(3525),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3525),
    [anon_sym_BY] = ACTIONS(3525),
    [anon_sym_OBVIOUS] = ACTIONS(3525),
    [anon_sym_OMITTED] = ACTIONS(3525),
    [sym__begin_proof] = ACTIONS(3525),
    [sym__begin_proof_step] = ACTIONS(3525),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1494] = {
    [sym_block_comment] = STATE(1494),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3529),
    [anon_sym_u27f6] = ACTIONS(3529),
    [anon_sym_u2192] = ACTIONS(3529),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3529),
    [anon_sym_BY] = ACTIONS(3529),
    [anon_sym_OBVIOUS] = ACTIONS(3529),
    [anon_sym_OMITTED] = ACTIONS(3529),
    [sym__begin_proof] = ACTIONS(3529),
    [sym__begin_proof_step] = ACTIONS(3529),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1495] = {
    [sym_block_comment] = STATE(1495),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3499),
    [anon_sym_u27f6] = ACTIONS(3499),
    [anon_sym_u2192] = ACTIONS(3499),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3499),
    [anon_sym_BY] = ACTIONS(3499),
    [anon_sym_OBVIOUS] = ACTIONS(3499),
    [anon_sym_OMITTED] = ACTIONS(3499),
    [sym__begin_proof] = ACTIONS(3499),
    [sym__begin_proof_step] = ACTIONS(3499),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1496] = {
    [sym_block_comment] = STATE(1496),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3503),
    [anon_sym_u27f6] = ACTIONS(3503),
    [anon_sym_u2192] = ACTIONS(3503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3503),
    [anon_sym_BY] = ACTIONS(3503),
    [anon_sym_OBVIOUS] = ACTIONS(3503),
    [anon_sym_OMITTED] = ACTIONS(3503),
    [sym__begin_proof] = ACTIONS(3503),
    [sym__begin_proof_step] = ACTIONS(3503),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1497] = {
    [sym_block_comment] = STATE(1497),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_DASH_GT] = ACTIONS(3495),
    [anon_sym_u27f6] = ACTIONS(3495),
    [anon_sym_u2192] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3495),
    [anon_sym_BY] = ACTIONS(3495),
    [anon_sym_OBVIOUS] = ACTIONS(3495),
    [anon_sym_OMITTED] = ACTIONS(3495),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1498] = {
    [sym_block_comment] = STATE(1498),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1499] = {
    [sym_block_comment] = STATE(1499),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1500] = {
    [sym_block_comment] = STATE(1500),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_u27f6] = ACTIONS(3515),
    [anon_sym_u2192] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3515),
    [anon_sym_BY] = ACTIONS(3515),
    [anon_sym_OBVIOUS] = ACTIONS(3515),
    [anon_sym_OMITTED] = ACTIONS(3515),
    [sym__begin_proof] = ACTIONS(3515),
    [sym__begin_proof_step] = ACTIONS(3515),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1501] = {
    [sym_block_comment] = STATE(1501),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1502] = {
    [sym_block_comment] = STATE(1502),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1503] = {
    [sym_block_comment] = STATE(1503),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1504] = {
    [sym_block_comment] = STATE(1504),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1505] = {
    [sym_block_comment] = STATE(1505),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1506] = {
    [sym_block_comment] = STATE(1506),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1507] = {
    [sym_block_comment] = STATE(1507),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3537),
    [anon_sym_u27f6] = ACTIONS(3537),
    [anon_sym_u2192] = ACTIONS(3537),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3537),
    [anon_sym_BY] = ACTIONS(3537),
    [anon_sym_OBVIOUS] = ACTIONS(3537),
    [anon_sym_OMITTED] = ACTIONS(3537),
    [sym__begin_proof] = ACTIONS(3537),
    [sym__begin_proof_step] = ACTIONS(3537),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1508] = {
    [sym_block_comment] = STATE(1508),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3541),
    [anon_sym_u27f6] = ACTIONS(3541),
    [anon_sym_u2192] = ACTIONS(3541),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3541),
    [anon_sym_BY] = ACTIONS(3541),
    [anon_sym_OBVIOUS] = ACTIONS(3541),
    [anon_sym_OMITTED] = ACTIONS(3541),
    [sym__begin_proof] = ACTIONS(3541),
    [sym__begin_proof_step] = ACTIONS(3541),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1509] = {
    [sym_block_comment] = STATE(1509),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3545),
    [anon_sym_u27f6] = ACTIONS(3545),
    [anon_sym_u2192] = ACTIONS(3545),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3545),
    [anon_sym_BY] = ACTIONS(3545),
    [anon_sym_OBVIOUS] = ACTIONS(3545),
    [anon_sym_OMITTED] = ACTIONS(3545),
    [sym__begin_proof] = ACTIONS(3545),
    [sym__begin_proof_step] = ACTIONS(3545),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1510] = {
    [sym_block_comment] = STATE(1510),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_DASH_GT] = ACTIONS(3495),
    [anon_sym_u27f6] = ACTIONS(3495),
    [anon_sym_u2192] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [anon_sym_PROOF] = ACTIONS(3495),
    [anon_sym_BY] = ACTIONS(3495),
    [anon_sym_OBVIOUS] = ACTIONS(3495),
    [anon_sym_OMITTED] = ACTIONS(3495),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1511] = {
    [sym_block_comment] = STATE(1511),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3495),
    [anon_sym_u27f6] = ACTIONS(3495),
    [anon_sym_u2192] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3495),
    [anon_sym_BY] = ACTIONS(3495),
    [anon_sym_OBVIOUS] = ACTIONS(3495),
    [anon_sym_OMITTED] = ACTIONS(3495),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1512] = {
    [sym_block_comment] = STATE(1512),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_DASH_GT] = ACTIONS(3495),
    [anon_sym_u27f6] = ACTIONS(3495),
    [anon_sym_u2192] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3495),
    [anon_sym_BY] = ACTIONS(3495),
    [anon_sym_OBVIOUS] = ACTIONS(3495),
    [anon_sym_OMITTED] = ACTIONS(3495),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1513] = {
    [sym_block_comment] = STATE(1513),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3553),
    [anon_sym_u27f6] = ACTIONS(3553),
    [anon_sym_u2192] = ACTIONS(3553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3553),
    [anon_sym_BY] = ACTIONS(3553),
    [anon_sym_OBVIOUS] = ACTIONS(3553),
    [anon_sym_OMITTED] = ACTIONS(3553),
    [sym__begin_proof] = ACTIONS(3553),
    [sym__begin_proof_step] = ACTIONS(3553),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1514] = {
    [sym_block_comment] = STATE(1514),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_u27f6] = ACTIONS(3531),
    [anon_sym_u2192] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3531),
    [anon_sym_BY] = ACTIONS(3531),
    [anon_sym_OBVIOUS] = ACTIONS(3531),
    [anon_sym_OMITTED] = ACTIONS(3531),
    [sym__begin_proof] = ACTIONS(3531),
    [sym__begin_proof_step] = ACTIONS(3531),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1515] = {
    [sym_block_comment] = STATE(1515),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1516] = {
    [sym_block_comment] = STATE(1516),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1517] = {
    [sym_block_comment] = STATE(1517),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1518] = {
    [sym_block_comment] = STATE(1518),
    [sym_implies] = STATE(612),
    [sym_plus_arrow] = STATE(613),
    [sym_equiv] = STATE(613),
    [sym_iff] = STATE(613),
    [sym_leads_to] = STATE(613),
    [sym_land] = STATE(614),
    [sym_lor] = STATE(614),
    [sym_assign] = STATE(604),
    [sym_bnf_rule] = STATE(604),
    [sym_eq] = STATE(604),
    [sym_neq] = STATE(604),
    [sym_lt] = STATE(604),
    [sym_leq] = STATE(604),
    [sym_geq] = STATE(604),
    [sym_approx] = STATE(604),
    [sym_rs_ttile] = STATE(604),
    [sym_rd_ttile] = STATE(604),
    [sym_ls_ttile] = STATE(604),
    [sym_ld_ttile] = STATE(604),
    [sym_asymp] = STATE(604),
    [sym_cong] = STATE(604),
    [sym_doteq] = STATE(604),
    [sym_gg] = STATE(604),
    [sym_ll] = STATE(604),
    [sym_in] = STATE(604),
    [sym_notin] = STATE(604),
    [sym_prec] = STATE(604),
    [sym_succ] = STATE(604),
    [sym_preceq] = STATE(604),
    [sym_succeq] = STATE(604),
    [sym_propto] = STATE(604),
    [sym_sim] = STATE(604),
    [sym_simeq] = STATE(604),
    [sym_sqsubset] = STATE(604),
    [sym_sqsupset] = STATE(604),
    [sym_sqsubseteq] = STATE(604),
    [sym_sqsupseteq] = STATE(604),
    [sym_subset] = STATE(604),
    [sym_supset] = STATE(604),
    [sym_subseteq] = STATE(604),
    [sym_supseteq] = STATE(604),
    [sym_cap] = STATE(607),
    [sym_cup] = STATE(607),
    [sym_dots_2] = STATE(615),
    [sym_dots_3] = STATE(615),
    [sym_plus] = STATE(608),
    [sym_oplus] = STATE(608),
    [sym_ominus] = STATE(609),
    [sym_vertvert] = STATE(609),
    [sym_minus] = STATE(609),
    [sym_odot] = STATE(610),
    [sym_oslash] = STATE(610),
    [sym_otimes] = STATE(610),
    [sym_bigcirc] = STATE(610),
    [sym_bullet] = STATE(610),
    [sym_div] = STATE(610),
    [sym_circ] = STATE(610),
    [sym_star] = STATE(610),
    [sym_excl] = STATE(610),
    [sym_qq] = STATE(610),
    [sym_sqcap] = STATE(610),
    [sym_sqcup] = STATE(610),
    [sym_uplus] = STATE(610),
    [sym_times] = STATE(610),
    [sym_wr] = STATE(611),
    [sym_cdot] = STATE(611),
    [sym_sup_plus] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3557),
    [anon_sym_u27f6] = ACTIONS(3557),
    [anon_sym_u2192] = ACTIONS(3557),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4084),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4088),
    [sym_map_to] = ACTIONS(4090),
    [sym_map_from] = ACTIONS(4090),
    [sym_setminus] = ACTIONS(4092),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4094),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4096),
    [sym_modmod] = ACTIONS(4098),
    [sym_vert] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4098),
    [sym_amp] = ACTIONS(4100),
    [sym_ampamp] = ACTIONS(4102),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4100),
    [sym_mulmul] = ACTIONS(4102),
    [sym_slash] = ACTIONS(4100),
    [sym_slashslash] = ACTIONS(4102),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4102),
    [sym_dol] = ACTIONS(4100),
    [sym_doldol] = ACTIONS(4102),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4104),
    [sym_powpow] = ACTIONS(4106),
    [anon_sym_CARET_PLUS] = ACTIONS(4108),
    [anon_sym_u207a] = ACTIONS(4108),
    [sym_asterisk] = ACTIONS(4110),
    [sym_sup_hash] = ACTIONS(4110),
    [sym_prime] = ACTIONS(4110),
    [anon_sym_PROOF] = ACTIONS(3557),
    [anon_sym_BY] = ACTIONS(3557),
    [anon_sym_OBVIOUS] = ACTIONS(3557),
    [anon_sym_OMITTED] = ACTIONS(3557),
    [sym__begin_proof] = ACTIONS(3557),
    [sym__begin_proof_step] = ACTIONS(3557),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1519] = {
    [sym_block_comment] = STATE(1519),
    [sym_rangle_bracket] = STATE(2253),
    [sym_rangle_bracket_sub] = STATE(1137),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4124),
    [anon_sym_u3009] = ACTIONS(4124),
    [anon_sym_u27e9] = ACTIONS(4124),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1520] = {
    [sym_block_comment] = STATE(1520),
    [sym_rangle_bracket] = STATE(3286),
    [sym_rangle_bracket_sub] = STATE(1112),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4160),
    [anon_sym_u3009] = ACTIONS(4160),
    [anon_sym_u27e9] = ACTIONS(4160),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1521] = {
    [sym_block_comment] = STATE(1521),
    [sym_rangle_bracket] = STATE(2735),
    [sym_rangle_bracket_sub] = STATE(1132),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4162),
    [anon_sym_u3009] = ACTIONS(4162),
    [anon_sym_u27e9] = ACTIONS(4162),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1522] = {
    [sym_block_comment] = STATE(1522),
    [sym_rangle_bracket] = STATE(2419),
    [sym_rangle_bracket_sub] = STATE(1134),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4164),
    [anon_sym_u3009] = ACTIONS(4164),
    [anon_sym_u27e9] = ACTIONS(4164),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1523] = {
    [sym_block_comment] = STATE(1523),
    [sym_rangle_bracket] = STATE(3362),
    [sym_rangle_bracket_sub] = STATE(1135),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4166),
    [anon_sym_u3009] = ACTIONS(4166),
    [anon_sym_u27e9] = ACTIONS(4166),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1524] = {
    [sym_block_comment] = STATE(1524),
    [sym_rangle_bracket] = STATE(5088),
    [sym_rangle_bracket_sub] = STATE(1125),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4168),
    [anon_sym_u3009] = ACTIONS(4168),
    [anon_sym_u27e9] = ACTIONS(4168),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1525] = {
    [sym_block_comment] = STATE(1525),
    [sym_rangle_bracket] = STATE(3019),
    [sym_rangle_bracket_sub] = STATE(1139),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4170),
    [anon_sym_u3009] = ACTIONS(4170),
    [anon_sym_u27e9] = ACTIONS(4170),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1526] = {
    [sym_block_comment] = STATE(1526),
    [sym_rangle_bracket] = STATE(2714),
    [sym_rangle_bracket_sub] = STATE(1122),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4172),
    [anon_sym_u3009] = ACTIONS(4172),
    [anon_sym_u27e9] = ACTIONS(4172),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1527] = {
    [sym_block_comment] = STATE(1527),
    [sym_rangle_bracket] = STATE(2833),
    [sym_rangle_bracket_sub] = STATE(1124),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4174),
    [anon_sym_u3009] = ACTIONS(4174),
    [anon_sym_u27e9] = ACTIONS(4174),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1528] = {
    [sym_block_comment] = STATE(1528),
    [sym_rangle_bracket] = STATE(2559),
    [sym_rangle_bracket_sub] = STATE(1147),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4176),
    [anon_sym_u3009] = ACTIONS(4176),
    [anon_sym_u27e9] = ACTIONS(4176),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1529] = {
    [sym_block_comment] = STATE(1529),
    [sym_rangle_bracket] = STATE(3115),
    [sym_rangle_bracket_sub] = STATE(1127),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4178),
    [anon_sym_u3009] = ACTIONS(4178),
    [anon_sym_u27e9] = ACTIONS(4178),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1530] = {
    [sym_block_comment] = STATE(1530),
    [sym_rangle_bracket] = STATE(3242),
    [sym_rangle_bracket_sub] = STATE(1133),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_u3009] = ACTIONS(4180),
    [anon_sym_u27e9] = ACTIONS(4180),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1531] = {
    [sym_block_comment] = STATE(1531),
    [sym_rangle_bracket] = STATE(2342),
    [sym_rangle_bracket_sub] = STATE(1114),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_u3009] = ACTIONS(4182),
    [anon_sym_u27e9] = ACTIONS(4182),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1532] = {
    [sym_block_comment] = STATE(1532),
    [sym_rangle_bracket] = STATE(2493),
    [sym_rangle_bracket_sub] = STATE(1119),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4184),
    [anon_sym_u3009] = ACTIONS(4184),
    [anon_sym_u27e9] = ACTIONS(4184),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1533] = {
    [sym_block_comment] = STATE(1533),
    [sym_rangle_bracket] = STATE(3335),
    [sym_rangle_bracket_sub] = STATE(1129),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4186),
    [anon_sym_u3009] = ACTIONS(4186),
    [anon_sym_u27e9] = ACTIONS(4186),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1534] = {
    [sym_block_comment] = STATE(1534),
    [sym_rangle_bracket] = STATE(2640),
    [sym_rangle_bracket_sub] = STATE(1120),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_u3009] = ACTIONS(4188),
    [anon_sym_u27e9] = ACTIONS(4188),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1535] = {
    [sym_block_comment] = STATE(1535),
    [sym_rangle_bracket] = STATE(2932),
    [sym_rangle_bracket_sub] = STATE(1126),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [aux_sym_finite_set_literal_repeat1] = STATE(4069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_u3009] = ACTIONS(4190),
    [anon_sym_u27e9] = ACTIONS(4190),
    [anon_sym_GT_GT_] = ACTIONS(4126),
    [anon_sym_u3009_] = ACTIONS(4126),
    [anon_sym_u27e9_] = ACTIONS(4126),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1536] = {
    [sym_block_comment] = STATE(1536),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3505),
    [anon_sym_u3009] = ACTIONS(3505),
    [anon_sym_u27e9] = ACTIONS(3505),
    [anon_sym_GT_GT_] = ACTIONS(3503),
    [anon_sym_u3009_] = ACTIONS(3503),
    [anon_sym_u27e9_] = ACTIONS(3503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1537] = {
    [sym_block_comment] = STATE(1537),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_u3009] = ACTIONS(3493),
    [anon_sym_u27e9] = ACTIONS(3493),
    [anon_sym_GT_GT_] = ACTIONS(3491),
    [anon_sym_u3009_] = ACTIONS(3491),
    [anon_sym_u27e9_] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1538] = {
    [sym_block_comment] = STATE(1538),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_u3009] = ACTIONS(3493),
    [anon_sym_u27e9] = ACTIONS(3493),
    [anon_sym_GT_GT_] = ACTIONS(3491),
    [anon_sym_u3009_] = ACTIONS(3491),
    [anon_sym_u27e9_] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1539] = {
    [sym_block_comment] = STATE(1539),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_u3009] = ACTIONS(3493),
    [anon_sym_u27e9] = ACTIONS(3493),
    [anon_sym_GT_GT_] = ACTIONS(3491),
    [anon_sym_u3009_] = ACTIONS(3491),
    [anon_sym_u27e9_] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1540] = {
    [sym_block_comment] = STATE(1540),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_u3009] = ACTIONS(3493),
    [anon_sym_u27e9] = ACTIONS(3493),
    [anon_sym_GT_GT_] = ACTIONS(3491),
    [anon_sym_u3009_] = ACTIONS(3491),
    [anon_sym_u27e9_] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1541] = {
    [sym_block_comment] = STATE(1541),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_u3009] = ACTIONS(3493),
    [anon_sym_u27e9] = ACTIONS(3493),
    [anon_sym_GT_GT_] = ACTIONS(3491),
    [anon_sym_u3009_] = ACTIONS(3491),
    [anon_sym_u27e9_] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1542] = {
    [sym_block_comment] = STATE(1542),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_u3009] = ACTIONS(3493),
    [anon_sym_u27e9] = ACTIONS(3493),
    [anon_sym_GT_GT_] = ACTIONS(3491),
    [anon_sym_u3009_] = ACTIONS(3491),
    [anon_sym_u27e9_] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1543] = {
    [sym_block_comment] = STATE(1543),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_u3009] = ACTIONS(3493),
    [anon_sym_u27e9] = ACTIONS(3493),
    [anon_sym_GT_GT_] = ACTIONS(3491),
    [anon_sym_u3009_] = ACTIONS(3491),
    [anon_sym_u27e9_] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1544] = {
    [sym_block_comment] = STATE(1544),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_u3009] = ACTIONS(3493),
    [anon_sym_u27e9] = ACTIONS(3493),
    [anon_sym_GT_GT_] = ACTIONS(3491),
    [anon_sym_u3009_] = ACTIONS(3491),
    [anon_sym_u27e9_] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1545] = {
    [sym_block_comment] = STATE(1545),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_u3009] = ACTIONS(3493),
    [anon_sym_u27e9] = ACTIONS(3493),
    [anon_sym_GT_GT_] = ACTIONS(3491),
    [anon_sym_u3009_] = ACTIONS(3491),
    [anon_sym_u27e9_] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1546] = {
    [sym_block_comment] = STATE(1546),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_GT_GT] = ACTIONS(3497),
    [anon_sym_u3009] = ACTIONS(3497),
    [anon_sym_u27e9] = ACTIONS(3497),
    [anon_sym_GT_GT_] = ACTIONS(3495),
    [anon_sym_u3009_] = ACTIONS(3495),
    [anon_sym_u27e9_] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1547] = {
    [sym_block_comment] = STATE(1547),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym__proof] = STATE(5235),
    [sym_terminal_proof] = STATE(5283),
    [sym_non_terminal_proof] = STATE(5283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4194),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(4112),
    [anon_sym_BY] = ACTIONS(4114),
    [anon_sym_OBVIOUS] = ACTIONS(4116),
    [anon_sym_OMITTED] = ACTIONS(4116),
    [sym__begin_proof] = ACTIONS(4118),
    [sym__begin_proof_step] = ACTIONS(4224),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1548] = {
    [sym_block_comment] = STATE(1548),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_u3009] = ACTIONS(3535),
    [anon_sym_u27e9] = ACTIONS(3535),
    [anon_sym_GT_GT_] = ACTIONS(3537),
    [anon_sym_u3009_] = ACTIONS(3537),
    [anon_sym_u27e9_] = ACTIONS(3537),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1549] = {
    [sym_block_comment] = STATE(1549),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_u3009] = ACTIONS(3539),
    [anon_sym_u27e9] = ACTIONS(3539),
    [anon_sym_GT_GT_] = ACTIONS(3541),
    [anon_sym_u3009_] = ACTIONS(3541),
    [anon_sym_u27e9_] = ACTIONS(3541),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1550] = {
    [sym_block_comment] = STATE(1550),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3543),
    [anon_sym_u3009] = ACTIONS(3543),
    [anon_sym_u27e9] = ACTIONS(3543),
    [anon_sym_GT_GT_] = ACTIONS(3545),
    [anon_sym_u3009_] = ACTIONS(3545),
    [anon_sym_u27e9_] = ACTIONS(3545),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1551] = {
    [sym_block_comment] = STATE(1551),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [anon_sym_u3009] = ACTIONS(3551),
    [anon_sym_u27e9] = ACTIONS(3551),
    [anon_sym_GT_GT_] = ACTIONS(3553),
    [anon_sym_u3009_] = ACTIONS(3553),
    [anon_sym_u27e9_] = ACTIONS(3553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1552] = {
    [sym_block_comment] = STATE(1552),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3555),
    [anon_sym_u3009] = ACTIONS(3555),
    [anon_sym_u27e9] = ACTIONS(3555),
    [anon_sym_GT_GT_] = ACTIONS(3557),
    [anon_sym_u3009_] = ACTIONS(3557),
    [anon_sym_u27e9_] = ACTIONS(3557),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1553] = {
    [sym_block_comment] = STATE(1553),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(4226),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_SEMI] = ACTIONS(4226),
    [anon_sym_define] = ACTIONS(4226),
    [anon_sym_macro] = ACTIONS(4226),
    [anon_sym_procedure] = ACTIONS(4226),
    [anon_sym_fair] = ACTIONS(4226),
    [anon_sym_process] = ACTIONS(4226),
    [anon_sym_begin] = ACTIONS(4226),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1554] = {
    [sym_block_comment] = STATE(1554),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3497),
    [anon_sym_u3009] = ACTIONS(3497),
    [anon_sym_u27e9] = ACTIONS(3497),
    [anon_sym_GT_GT_] = ACTIONS(3495),
    [anon_sym_u3009_] = ACTIONS(3495),
    [anon_sym_u27e9_] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1555] = {
    [sym_block_comment] = STATE(1555),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3513),
    [anon_sym_u3009] = ACTIONS(3513),
    [anon_sym_u27e9] = ACTIONS(3513),
    [anon_sym_GT_GT_] = ACTIONS(3511),
    [anon_sym_u3009_] = ACTIONS(3511),
    [anon_sym_u27e9_] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1556] = {
    [sym_block_comment] = STATE(1556),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3523),
    [anon_sym_u3009] = ACTIONS(3523),
    [anon_sym_u27e9] = ACTIONS(3523),
    [anon_sym_GT_GT_] = ACTIONS(3525),
    [anon_sym_u3009_] = ACTIONS(3525),
    [anon_sym_u27e9_] = ACTIONS(3525),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1557] = {
    [sym_block_comment] = STATE(1557),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_GT_GT] = ACTIONS(3497),
    [anon_sym_u3009] = ACTIONS(3497),
    [anon_sym_u27e9] = ACTIONS(3497),
    [anon_sym_GT_GT_] = ACTIONS(3495),
    [anon_sym_u3009_] = ACTIONS(3495),
    [anon_sym_u27e9_] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1558] = {
    [sym_block_comment] = STATE(1558),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_GT_GT] = ACTIONS(3497),
    [anon_sym_u3009] = ACTIONS(3497),
    [anon_sym_u27e9] = ACTIONS(3497),
    [anon_sym_GT_GT_] = ACTIONS(3495),
    [anon_sym_u3009_] = ACTIONS(3495),
    [anon_sym_u27e9_] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1559] = {
    [sym_block_comment] = STATE(1559),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3533),
    [anon_sym_u3009] = ACTIONS(3533),
    [anon_sym_u27e9] = ACTIONS(3533),
    [anon_sym_GT_GT_] = ACTIONS(3531),
    [anon_sym_u3009_] = ACTIONS(3531),
    [anon_sym_u27e9_] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1560] = {
    [sym_block_comment] = STATE(1560),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3527),
    [anon_sym_u3009] = ACTIONS(3527),
    [anon_sym_u27e9] = ACTIONS(3527),
    [anon_sym_GT_GT_] = ACTIONS(3529),
    [anon_sym_u3009_] = ACTIONS(3529),
    [anon_sym_u27e9_] = ACTIONS(3529),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1561] = {
    [sym_block_comment] = STATE(1561),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_u3009] = ACTIONS(3501),
    [anon_sym_u27e9] = ACTIONS(3501),
    [anon_sym_GT_GT_] = ACTIONS(3499),
    [anon_sym_u3009_] = ACTIONS(3499),
    [anon_sym_u27e9_] = ACTIONS(3499),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1562] = {
    [sym_block_comment] = STATE(1562),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_u3009] = ACTIONS(3493),
    [anon_sym_u27e9] = ACTIONS(3493),
    [anon_sym_GT_GT_] = ACTIONS(3491),
    [anon_sym_u3009_] = ACTIONS(3491),
    [anon_sym_u27e9_] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1563] = {
    [sym_block_comment] = STATE(1563),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3509),
    [anon_sym_u3009] = ACTIONS(3509),
    [anon_sym_u27e9] = ACTIONS(3509),
    [anon_sym_GT_GT_] = ACTIONS(3507),
    [anon_sym_u3009_] = ACTIONS(3507),
    [anon_sym_u27e9_] = ACTIONS(3507),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1564] = {
    [sym_block_comment] = STATE(1564),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3517),
    [anon_sym_u3009] = ACTIONS(3517),
    [anon_sym_u27e9] = ACTIONS(3517),
    [anon_sym_GT_GT_] = ACTIONS(3515),
    [anon_sym_u3009_] = ACTIONS(3515),
    [anon_sym_u27e9_] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4134),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4136),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1565] = {
    [sym_block_comment] = STATE(1565),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_u3009] = ACTIONS(3493),
    [anon_sym_u27e9] = ACTIONS(3493),
    [anon_sym_GT_GT_] = ACTIONS(3491),
    [anon_sym_u3009_] = ACTIONS(3491),
    [anon_sym_u27e9_] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(4138),
    [sym_map_from] = ACTIONS(4138),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1566] = {
    [sym_block_comment] = STATE(1566),
    [sym_implies] = STATE(366),
    [sym_plus_arrow] = STATE(367),
    [sym_equiv] = STATE(367),
    [sym_iff] = STATE(367),
    [sym_leads_to] = STATE(367),
    [sym_land] = STATE(368),
    [sym_lor] = STATE(368),
    [sym_assign] = STATE(358),
    [sym_bnf_rule] = STATE(358),
    [sym_eq] = STATE(358),
    [sym_neq] = STATE(358),
    [sym_lt] = STATE(358),
    [sym_leq] = STATE(358),
    [sym_geq] = STATE(358),
    [sym_approx] = STATE(358),
    [sym_rs_ttile] = STATE(358),
    [sym_rd_ttile] = STATE(358),
    [sym_ls_ttile] = STATE(358),
    [sym_ld_ttile] = STATE(358),
    [sym_asymp] = STATE(358),
    [sym_cong] = STATE(358),
    [sym_doteq] = STATE(358),
    [sym_gg] = STATE(358),
    [sym_ll] = STATE(358),
    [sym_in] = STATE(358),
    [sym_notin] = STATE(358),
    [sym_prec] = STATE(358),
    [sym_succ] = STATE(358),
    [sym_preceq] = STATE(358),
    [sym_succeq] = STATE(358),
    [sym_propto] = STATE(358),
    [sym_sim] = STATE(358),
    [sym_simeq] = STATE(358),
    [sym_sqsubset] = STATE(358),
    [sym_sqsupset] = STATE(358),
    [sym_sqsubseteq] = STATE(358),
    [sym_sqsupseteq] = STATE(358),
    [sym_subset] = STATE(358),
    [sym_supset] = STATE(358),
    [sym_subseteq] = STATE(358),
    [sym_supseteq] = STATE(358),
    [sym_cap] = STATE(361),
    [sym_cup] = STATE(361),
    [sym_dots_2] = STATE(369),
    [sym_dots_3] = STATE(369),
    [sym_plus] = STATE(362),
    [sym_oplus] = STATE(362),
    [sym_ominus] = STATE(363),
    [sym_vertvert] = STATE(363),
    [sym_minus] = STATE(363),
    [sym_odot] = STATE(364),
    [sym_oslash] = STATE(364),
    [sym_otimes] = STATE(364),
    [sym_bigcirc] = STATE(364),
    [sym_bullet] = STATE(364),
    [sym_div] = STATE(364),
    [sym_circ] = STATE(364),
    [sym_star] = STATE(364),
    [sym_excl] = STATE(364),
    [sym_qq] = STATE(364),
    [sym_sqcap] = STATE(364),
    [sym_sqcup] = STATE(364),
    [sym_uplus] = STATE(364),
    [sym_times] = STATE(364),
    [sym_wr] = STATE(365),
    [sym_cdot] = STATE(365),
    [sym_sup_plus] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_u3009] = ACTIONS(3493),
    [anon_sym_u27e9] = ACTIONS(3493),
    [anon_sym_GT_GT_] = ACTIONS(3491),
    [anon_sym_u3009_] = ACTIONS(3491),
    [anon_sym_u27e9_] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(4140),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4142),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4144),
    [sym_modmod] = ACTIONS(4146),
    [sym_vert] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4146),
    [sym_amp] = ACTIONS(4148),
    [sym_ampamp] = ACTIONS(4150),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4148),
    [sym_mulmul] = ACTIONS(4150),
    [sym_slash] = ACTIONS(4148),
    [sym_slashslash] = ACTIONS(4150),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4150),
    [sym_dol] = ACTIONS(4148),
    [sym_doldol] = ACTIONS(4150),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4152),
    [sym_powpow] = ACTIONS(4154),
    [anon_sym_CARET_PLUS] = ACTIONS(4156),
    [anon_sym_u207a] = ACTIONS(4156),
    [sym_asterisk] = ACTIONS(4158),
    [sym_sup_hash] = ACTIONS(4158),
    [sym_prime] = ACTIONS(4158),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1567] = {
    [sym_block_comment] = STATE(1567),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym__proof] = STATE(5442),
    [sym_terminal_proof] = STATE(5283),
    [sym_non_terminal_proof] = STATE(5283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4194),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(4112),
    [anon_sym_BY] = ACTIONS(4114),
    [anon_sym_OBVIOUS] = ACTIONS(4116),
    [anon_sym_OMITTED] = ACTIONS(4116),
    [sym__begin_proof] = ACTIONS(4118),
    [sym__begin_proof_step] = ACTIONS(4230),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1568] = {
    [sym_block_comment] = STATE(1568),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym__proof] = STATE(5489),
    [sym_terminal_proof] = STATE(5283),
    [sym_non_terminal_proof] = STATE(5283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4194),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(4112),
    [anon_sym_BY] = ACTIONS(4114),
    [anon_sym_OBVIOUS] = ACTIONS(4116),
    [anon_sym_OMITTED] = ACTIONS(4116),
    [sym__begin_proof] = ACTIONS(4118),
    [sym__begin_proof_step] = ACTIONS(4232),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1569] = {
    [sym_block_comment] = STATE(1569),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3499),
    [anon_sym_BY] = ACTIONS(3499),
    [anon_sym_OBVIOUS] = ACTIONS(3499),
    [anon_sym_OMITTED] = ACTIONS(3499),
    [sym__begin_proof] = ACTIONS(3499),
    [sym__begin_proof_step] = ACTIONS(3499),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1570] = {
    [sym_block_comment] = STATE(1570),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1571] = {
    [sym_block_comment] = STATE(1571),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3553),
    [anon_sym_BY] = ACTIONS(3553),
    [anon_sym_OBVIOUS] = ACTIONS(3553),
    [anon_sym_OMITTED] = ACTIONS(3553),
    [sym__begin_proof] = ACTIONS(3553),
    [sym__begin_proof_step] = ACTIONS(3553),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1572] = {
    [sym_block_comment] = STATE(1572),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3557),
    [anon_sym_BY] = ACTIONS(3557),
    [anon_sym_OBVIOUS] = ACTIONS(3557),
    [anon_sym_OMITTED] = ACTIONS(3557),
    [sym__begin_proof] = ACTIONS(3557),
    [sym__begin_proof_step] = ACTIONS(3557),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1573] = {
    [sym_block_comment] = STATE(1573),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3511),
    [anon_sym_BY] = ACTIONS(3511),
    [anon_sym_OBVIOUS] = ACTIONS(3511),
    [anon_sym_OMITTED] = ACTIONS(3511),
    [sym__begin_proof] = ACTIONS(3511),
    [sym__begin_proof_step] = ACTIONS(3511),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1574] = {
    [sym_block_comment] = STATE(1574),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3525),
    [anon_sym_BY] = ACTIONS(3525),
    [anon_sym_OBVIOUS] = ACTIONS(3525),
    [anon_sym_OMITTED] = ACTIONS(3525),
    [sym__begin_proof] = ACTIONS(3525),
    [sym__begin_proof_step] = ACTIONS(3525),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1575] = {
    [sym_block_comment] = STATE(1575),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3529),
    [anon_sym_BY] = ACTIONS(3529),
    [anon_sym_OBVIOUS] = ACTIONS(3529),
    [anon_sym_OMITTED] = ACTIONS(3529),
    [sym__begin_proof] = ACTIONS(3529),
    [sym__begin_proof_step] = ACTIONS(3529),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1576] = {
    [sym_block_comment] = STATE(1576),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3503),
    [anon_sym_BY] = ACTIONS(3503),
    [anon_sym_OBVIOUS] = ACTIONS(3503),
    [anon_sym_OMITTED] = ACTIONS(3503),
    [sym__begin_proof] = ACTIONS(3503),
    [sym__begin_proof_step] = ACTIONS(3503),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1577] = {
    [sym_block_comment] = STATE(1577),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3507),
    [anon_sym_BY] = ACTIONS(3507),
    [anon_sym_OBVIOUS] = ACTIONS(3507),
    [anon_sym_OMITTED] = ACTIONS(3507),
    [sym__begin_proof] = ACTIONS(3507),
    [sym__begin_proof_step] = ACTIONS(3507),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1578] = {
    [sym_block_comment] = STATE(1578),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3515),
    [anon_sym_BY] = ACTIONS(3515),
    [anon_sym_OBVIOUS] = ACTIONS(3515),
    [anon_sym_OMITTED] = ACTIONS(3515),
    [sym__begin_proof] = ACTIONS(3515),
    [sym__begin_proof_step] = ACTIONS(3515),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1579] = {
    [sym_block_comment] = STATE(1579),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1580] = {
    [sym_block_comment] = STATE(1580),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1581] = {
    [sym_block_comment] = STATE(1581),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1582] = {
    [sym_block_comment] = STATE(1582),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1583] = {
    [sym_block_comment] = STATE(1583),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1584] = {
    [sym_block_comment] = STATE(1584),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1585] = {
    [sym_block_comment] = STATE(1585),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1586] = {
    [sym_block_comment] = STATE(1586),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1587] = {
    [sym_block_comment] = STATE(1587),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1588] = {
    [sym_block_comment] = STATE(1588),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1589] = {
    [sym_block_comment] = STATE(1589),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3537),
    [anon_sym_BY] = ACTIONS(3537),
    [anon_sym_OBVIOUS] = ACTIONS(3537),
    [anon_sym_OMITTED] = ACTIONS(3537),
    [sym__begin_proof] = ACTIONS(3537),
    [sym__begin_proof_step] = ACTIONS(3537),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1590] = {
    [sym_block_comment] = STATE(1590),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3541),
    [anon_sym_BY] = ACTIONS(3541),
    [anon_sym_OBVIOUS] = ACTIONS(3541),
    [anon_sym_OMITTED] = ACTIONS(3541),
    [sym__begin_proof] = ACTIONS(3541),
    [sym__begin_proof_step] = ACTIONS(3541),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1591] = {
    [sym_block_comment] = STATE(1591),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3545),
    [anon_sym_BY] = ACTIONS(3545),
    [anon_sym_OBVIOUS] = ACTIONS(3545),
    [anon_sym_OMITTED] = ACTIONS(3545),
    [sym__begin_proof] = ACTIONS(3545),
    [sym__begin_proof_step] = ACTIONS(3545),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1592] = {
    [sym_block_comment] = STATE(1592),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3495),
    [anon_sym_BY] = ACTIONS(3495),
    [anon_sym_OBVIOUS] = ACTIONS(3495),
    [anon_sym_OMITTED] = ACTIONS(3495),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1593] = {
    [sym_block_comment] = STATE(1593),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3491),
    [anon_sym_BY] = ACTIONS(3491),
    [anon_sym_OBVIOUS] = ACTIONS(3491),
    [anon_sym_OMITTED] = ACTIONS(3491),
    [sym__begin_proof] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1594] = {
    [sym_block_comment] = STATE(1594),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [anon_sym_PROOF] = ACTIONS(3495),
    [anon_sym_BY] = ACTIONS(3495),
    [anon_sym_OBVIOUS] = ACTIONS(3495),
    [anon_sym_OMITTED] = ACTIONS(3495),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1595] = {
    [sym_block_comment] = STATE(1595),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3495),
    [anon_sym_BY] = ACTIONS(3495),
    [anon_sym_OBVIOUS] = ACTIONS(3495),
    [anon_sym_OMITTED] = ACTIONS(3495),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1596] = {
    [sym_block_comment] = STATE(1596),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3495),
    [anon_sym_BY] = ACTIONS(3495),
    [anon_sym_OBVIOUS] = ACTIONS(3495),
    [anon_sym_OMITTED] = ACTIONS(3495),
    [sym__begin_proof] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1597] = {
    [sym_block_comment] = STATE(1597),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3531),
    [anon_sym_BY] = ACTIONS(3531),
    [anon_sym_OBVIOUS] = ACTIONS(3531),
    [anon_sym_OMITTED] = ACTIONS(3531),
    [sym__begin_proof] = ACTIONS(3531),
    [sym__begin_proof_step] = ACTIONS(3531),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1598] = {
    [sym_block_comment] = STATE(1598),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3507),
    [anon_sym_u27f6] = ACTIONS(3507),
    [anon_sym_u2192] = ACTIONS(3507),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1599] = {
    [sym_block_comment] = STATE(1599),
    [sym_identifier] = ACTIONS(4266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4269),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(4269),
    [anon_sym_BSLASHin] = ACTIONS(4271),
    [anon_sym_u2208] = ACTIONS(4273),
    [anon_sym_BSLASHA] = ACTIONS(4271),
    [anon_sym_BSLASHforall] = ACTIONS(4273),
    [anon_sym_u2200] = ACTIONS(4273),
    [anon_sym_BSLASHE] = ACTIONS(4271),
    [anon_sym_BSLASHexists] = ACTIONS(4273),
    [anon_sym_u2203] = ACTIONS(4273),
    [sym_temporal_forall] = ACTIONS(4273),
    [sym_temporal_exists] = ACTIONS(4273),
    [anon_sym_LT_LT] = ACTIONS(4273),
    [anon_sym_u3008] = ACTIONS(4273),
    [anon_sym_u27e8] = ACTIONS(4273),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4275),
    [anon_sym_u25a1] = ACTIONS(4275),
    [anon_sym_AT] = ACTIONS(4271),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4273),
    [anon_sym_u2227] = ACTIONS(4273),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4273),
    [anon_sym_u2228] = ACTIONS(4273),
    [anon_sym_COMMA] = ACTIONS(4269),
    [anon_sym_LOCAL] = ACTIONS(4278),
    [anon_sym_VARIABLE] = ACTIONS(4278),
    [anon_sym_VARIABLES] = ACTIONS(4278),
    [anon_sym_CONSTANT] = ACTIONS(4278),
    [anon_sym_CONSTANTS] = ACTIONS(4278),
    [anon_sym_RECURSIVE] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [anon_sym_LBRACK] = ACTIONS(4271),
    [anon_sym_INSTANCE] = ACTIONS(4278),
    [anon_sym_BANG] = ACTIONS(4269),
    [aux_sym_child_id_token1] = ACTIONS(4271),
    [sym_real_number] = ACTIONS(4273),
    [anon_sym_BSLASHb] = ACTIONS(4271),
    [anon_sym_BSLASHB] = ACTIONS(4273),
    [anon_sym_BSLASHo] = ACTIONS(4271),
    [anon_sym_BSLASHO] = ACTIONS(4273),
    [anon_sym_BSLASHh] = ACTIONS(4273),
    [anon_sym_BSLASHH] = ACTIONS(4273),
    [anon_sym_DQUOTE] = ACTIONS(4273),
    [anon_sym_TRUE] = ACTIONS(4271),
    [anon_sym_FALSE] = ACTIONS(4271),
    [sym_string_set] = ACTIONS(4271),
    [sym_boolean_set] = ACTIONS(4271),
    [anon_sym_Nat] = ACTIONS(4266),
    [anon_sym_u2115] = ACTIONS(4275),
    [anon_sym_Int] = ACTIONS(4266),
    [anon_sym_u2124] = ACTIONS(4275),
    [anon_sym_Real] = ACTIONS(4266),
    [anon_sym_u211d] = ACTIONS(4275),
    [anon_sym_CHOOSE] = ACTIONS(4271),
    [anon_sym_LBRACE] = ACTIONS(4273),
    [anon_sym_EQ] = ACTIONS(4271),
    [anon_sym_WF_] = ACTIONS(4271),
    [anon_sym_SF_] = ACTIONS(4271),
    [anon_sym_IF] = ACTIONS(4271),
    [anon_sym_CASE] = ACTIONS(4271),
    [anon_sym_LET] = ACTIONS(4271),
    [anon_sym_BSLASHlnot] = ACTIONS(4275),
    [anon_sym_BSLASHneg] = ACTIONS(4275),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_u00ac] = ACTIONS(4275),
    [sym_union] = ACTIONS(4266),
    [sym_powerset] = ACTIONS(4266),
    [sym_domain] = ACTIONS(4266),
    [anon_sym_DASH] = ACTIONS(4271),
    [sym_negative_dot] = ACTIONS(4275),
    [sym_enabled] = ACTIONS(4266),
    [sym_unchanged] = ACTIONS(4266),
    [anon_sym_LT_GT] = ACTIONS(4275),
    [anon_sym_u22c4] = ACTIONS(4275),
    [anon_sym_u25c7] = ACTIONS(4275),
    [anon_sym_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27f9] = ACTIONS(4273),
    [anon_sym_u21d2] = ACTIONS(4273),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4273),
    [anon_sym_u21f8] = ACTIONS(4273),
    [anon_sym_u2945] = ACTIONS(4273),
    [anon_sym_BSLASHequiv] = ACTIONS(4273),
    [anon_sym_u2261] = ACTIONS(4273),
    [anon_sym_LT_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27fa] = ACTIONS(4273),
    [anon_sym_u21d4] = ACTIONS(4273),
    [anon_sym_TILDE_GT] = ACTIONS(4273),
    [anon_sym_u21dd] = ACTIONS(4273),
    [anon_sym_u219d] = ACTIONS(4273),
    [anon_sym_BSLASHland] = ACTIONS(4273),
    [anon_sym_BSLASHlor] = ACTIONS(4273),
    [anon_sym_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2254] = ACTIONS(4273),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2a74] = ACTIONS(4273),
    [anon_sym_SLASH_EQ] = ACTIONS(4273),
    [anon_sym_POUND] = ACTIONS(4271),
    [anon_sym_u2260] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4271),
    [sym_gt] = ACTIONS(4271),
    [anon_sym_LT_EQ] = ACTIONS(4271),
    [anon_sym_EQ_LT] = ACTIONS(4273),
    [anon_sym_BSLASHleq] = ACTIONS(4273),
    [anon_sym_u2264] = ACTIONS(4273),
    [anon_sym_GT_EQ] = ACTIONS(4273),
    [anon_sym_BSLASHgeq] = ACTIONS(4273),
    [anon_sym_u2265] = ACTIONS(4273),
    [anon_sym_BSLASHapprox] = ACTIONS(4273),
    [anon_sym_u2248] = ACTIONS(4273),
    [anon_sym_PIPE_DASH] = ACTIONS(4273),
    [anon_sym_u22a2] = ACTIONS(4273),
    [anon_sym_PIPE_EQ] = ACTIONS(4273),
    [anon_sym_u22a8] = ACTIONS(4273),
    [anon_sym_DASH_PIPE] = ACTIONS(4273),
    [anon_sym_u22a3] = ACTIONS(4273),
    [anon_sym_EQ_PIPE] = ACTIONS(4273),
    [anon_sym_u2ae4] = ACTIONS(4273),
    [anon_sym_BSLASHasymp] = ACTIONS(4273),
    [anon_sym_u224d] = ACTIONS(4273),
    [anon_sym_BSLASHcong] = ACTIONS(4273),
    [anon_sym_u2245] = ACTIONS(4273),
    [anon_sym_BSLASHdoteq] = ACTIONS(4273),
    [anon_sym_u2250] = ACTIONS(4273),
    [anon_sym_BSLASHgg] = ACTIONS(4273),
    [anon_sym_u226b] = ACTIONS(4273),
    [anon_sym_BSLASHll] = ACTIONS(4273),
    [anon_sym_u226a] = ACTIONS(4273),
    [anon_sym_BSLASHnotin] = ACTIONS(4273),
    [anon_sym_u2209] = ACTIONS(4273),
    [anon_sym_BSLASHprec] = ACTIONS(4271),
    [anon_sym_u227a] = ACTIONS(4273),
    [anon_sym_BSLASHsucc] = ACTIONS(4271),
    [anon_sym_u227b] = ACTIONS(4273),
    [anon_sym_BSLASHpreceq] = ACTIONS(4273),
    [anon_sym_u2aaf] = ACTIONS(4273),
    [anon_sym_BSLASHsucceq] = ACTIONS(4273),
    [anon_sym_u2ab0] = ACTIONS(4273),
    [anon_sym_BSLASHpropto] = ACTIONS(4273),
    [anon_sym_u221d] = ACTIONS(4273),
    [anon_sym_BSLASHsim] = ACTIONS(4271),
    [anon_sym_u223c] = ACTIONS(4273),
    [anon_sym_BSLASHsimeq] = ACTIONS(4273),
    [anon_sym_u2243] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4271),
    [anon_sym_u228f] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4271),
    [anon_sym_u2290] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4273),
    [anon_sym_u2291] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4273),
    [anon_sym_u2292] = ACTIONS(4273),
    [anon_sym_BSLASHsubset] = ACTIONS(4271),
    [anon_sym_u2282] = ACTIONS(4273),
    [anon_sym_BSLASHsupset] = ACTIONS(4271),
    [anon_sym_u2283] = ACTIONS(4273),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4273),
    [anon_sym_u2286] = ACTIONS(4273),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4273),
    [anon_sym_u2287] = ACTIONS(4273),
    [sym_compose] = ACTIONS(4273),
    [sym_map_to] = ACTIONS(4273),
    [sym_map_from] = ACTIONS(4273),
    [sym_setminus] = ACTIONS(4271),
    [anon_sym_BSLASHcap] = ACTIONS(4273),
    [anon_sym_BSLASHintersect] = ACTIONS(4273),
    [anon_sym_u2229] = ACTIONS(4273),
    [anon_sym_BSLASHcup] = ACTIONS(4273),
    [anon_sym_BSLASHunion] = ACTIONS(4273),
    [anon_sym_u222a] = ACTIONS(4273),
    [anon_sym_DOT_DOT] = ACTIONS(4271),
    [anon_sym_u2025] = ACTIONS(4273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4273),
    [anon_sym_u2026] = ACTIONS(4273),
    [anon_sym_PLUS] = ACTIONS(4271),
    [sym_plusplus] = ACTIONS(4273),
    [anon_sym_BSLASHoplus] = ACTIONS(4273),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4273),
    [anon_sym_u2295] = ACTIONS(4273),
    [anon_sym_BSLASHominus] = ACTIONS(4273),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2296] = ACTIONS(4273),
    [sym_mod] = ACTIONS(4271),
    [sym_modmod] = ACTIONS(4273),
    [sym_vert] = ACTIONS(4271),
    [anon_sym_PIPE_PIPE] = ACTIONS(4273),
    [anon_sym_u2016] = ACTIONS(4273),
    [sym_minusminus] = ACTIONS(4271),
    [sym_amp] = ACTIONS(4271),
    [sym_ampamp] = ACTIONS(4273),
    [anon_sym_BSLASHodot] = ACTIONS(4273),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4273),
    [anon_sym_u2299] = ACTIONS(4273),
    [anon_sym_BSLASHoslash] = ACTIONS(4273),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2298] = ACTIONS(4273),
    [anon_sym_BSLASHotimes] = ACTIONS(4273),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4273),
    [anon_sym_u2297] = ACTIONS(4273),
    [sym_mul] = ACTIONS(4271),
    [sym_mulmul] = ACTIONS(4273),
    [sym_slash] = ACTIONS(4271),
    [sym_slashslash] = ACTIONS(4273),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4273),
    [anon_sym_u25ef] = ACTIONS(4273),
    [anon_sym_BSLASHbullet] = ACTIONS(4273),
    [anon_sym_u25cf] = ACTIONS(4273),
    [anon_sym_BSLASHdiv] = ACTIONS(4273),
    [anon_sym_u00f7] = ACTIONS(4273),
    [anon_sym_BSLASHcirc] = ACTIONS(4273),
    [anon_sym_u2218] = ACTIONS(4273),
    [anon_sym_BSLASHstar] = ACTIONS(4273),
    [anon_sym_u22c6] = ACTIONS(4273),
    [anon_sym_u203c] = ACTIONS(4273),
    [sym_hashhash] = ACTIONS(4273),
    [sym_dol] = ACTIONS(4271),
    [sym_doldol] = ACTIONS(4273),
    [anon_sym_QMARK_QMARK] = ACTIONS(4273),
    [anon_sym_u2047] = ACTIONS(4273),
    [anon_sym_BSLASHsqcap] = ACTIONS(4273),
    [anon_sym_u2293] = ACTIONS(4273),
    [anon_sym_BSLASHsqcup] = ACTIONS(4273),
    [anon_sym_u2294] = ACTIONS(4273),
    [anon_sym_BSLASHuplus] = ACTIONS(4273),
    [anon_sym_u228e] = ACTIONS(4273),
    [anon_sym_BSLASHX] = ACTIONS(4273),
    [anon_sym_BSLASHtimes] = ACTIONS(4273),
    [anon_sym_u00d7] = ACTIONS(4273),
    [anon_sym_BSLASHwr] = ACTIONS(4273),
    [anon_sym_u2240] = ACTIONS(4273),
    [anon_sym_BSLASHcdot] = ACTIONS(4273),
    [anon_sym_u22c5] = ACTIONS(4273),
    [sym_pow] = ACTIONS(4271),
    [sym_powpow] = ACTIONS(4273),
    [anon_sym_CARET_PLUS] = ACTIONS(4273),
    [anon_sym_u207a] = ACTIONS(4273),
    [sym_asterisk] = ACTIONS(4273),
    [sym_sup_hash] = ACTIONS(4273),
    [sym_prime] = ACTIONS(4273),
    [anon_sym_ASSUME] = ACTIONS(4278),
    [anon_sym_ASSUMPTION] = ACTIONS(4278),
    [anon_sym_AXIOM] = ACTIONS(4278),
    [anon_sym_THEOREM] = ACTIONS(4278),
    [anon_sym_PROPOSITION] = ACTIONS(4278),
    [anon_sym_LEMMA] = ACTIONS(4278),
    [anon_sym_COROLLARY] = ACTIONS(4278),
    [anon_sym_USE] = ACTIONS(4278),
    [anon_sym_HIDE] = ACTIONS(4278),
    [sym__indent] = ACTIONS(4273),
    [sym__double_excl] = ACTIONS(4273),
  },
  [1600] = {
    [sym_block_comment] = STATE(1600),
    [ts_builtin_sym_end] = ACTIONS(4280),
    [sym_identifier] = ACTIONS(4282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4280),
    [anon_sym_BSLASHin] = ACTIONS(4282),
    [anon_sym_u2208] = ACTIONS(4280),
    [anon_sym_BSLASHA] = ACTIONS(4282),
    [anon_sym_BSLASHforall] = ACTIONS(4280),
    [anon_sym_u2200] = ACTIONS(4280),
    [anon_sym_BSLASHE] = ACTIONS(4282),
    [anon_sym_BSLASHexists] = ACTIONS(4280),
    [anon_sym_u2203] = ACTIONS(4280),
    [sym_temporal_forall] = ACTIONS(4280),
    [sym_temporal_exists] = ACTIONS(4280),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_u3008] = ACTIONS(4280),
    [anon_sym_u27e8] = ACTIONS(4280),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4280),
    [anon_sym_u25a1] = ACTIONS(4280),
    [anon_sym_AT] = ACTIONS(4282),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4280),
    [anon_sym_u2227] = ACTIONS(4280),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4280),
    [anon_sym_u2228] = ACTIONS(4280),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_LOCAL] = ACTIONS(4282),
    [anon_sym_VARIABLE] = ACTIONS(4282),
    [anon_sym_VARIABLES] = ACTIONS(4282),
    [anon_sym_CONSTANT] = ACTIONS(4282),
    [anon_sym_CONSTANTS] = ACTIONS(4282),
    [anon_sym_RECURSIVE] = ACTIONS(4282),
    [anon_sym_LPAREN] = ACTIONS(4282),
    [anon_sym_LBRACK] = ACTIONS(4282),
    [anon_sym_INSTANCE] = ACTIONS(4282),
    [anon_sym_BANG] = ACTIONS(4280),
    [aux_sym_child_id_token1] = ACTIONS(4282),
    [sym_real_number] = ACTIONS(4280),
    [anon_sym_BSLASHb] = ACTIONS(4282),
    [anon_sym_BSLASHB] = ACTIONS(4280),
    [anon_sym_BSLASHo] = ACTIONS(4282),
    [anon_sym_BSLASHO] = ACTIONS(4280),
    [anon_sym_BSLASHh] = ACTIONS(4280),
    [anon_sym_BSLASHH] = ACTIONS(4280),
    [anon_sym_DQUOTE] = ACTIONS(4280),
    [anon_sym_TRUE] = ACTIONS(4282),
    [anon_sym_FALSE] = ACTIONS(4282),
    [sym_string_set] = ACTIONS(4282),
    [sym_boolean_set] = ACTIONS(4282),
    [anon_sym_Nat] = ACTIONS(4282),
    [anon_sym_u2115] = ACTIONS(4280),
    [anon_sym_Int] = ACTIONS(4282),
    [anon_sym_u2124] = ACTIONS(4280),
    [anon_sym_Real] = ACTIONS(4282),
    [anon_sym_u211d] = ACTIONS(4280),
    [anon_sym_CHOOSE] = ACTIONS(4282),
    [anon_sym_LBRACE] = ACTIONS(4280),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_WF_] = ACTIONS(4282),
    [anon_sym_SF_] = ACTIONS(4282),
    [anon_sym_IF] = ACTIONS(4282),
    [anon_sym_CASE] = ACTIONS(4282),
    [anon_sym_LET] = ACTIONS(4282),
    [anon_sym_BSLASHlnot] = ACTIONS(4280),
    [anon_sym_BSLASHneg] = ACTIONS(4280),
    [anon_sym_TILDE] = ACTIONS(4282),
    [anon_sym_u00ac] = ACTIONS(4280),
    [sym_union] = ACTIONS(4282),
    [sym_powerset] = ACTIONS(4282),
    [sym_domain] = ACTIONS(4282),
    [anon_sym_DASH] = ACTIONS(4282),
    [sym_negative_dot] = ACTIONS(4280),
    [sym_enabled] = ACTIONS(4282),
    [sym_unchanged] = ACTIONS(4282),
    [anon_sym_LT_GT] = ACTIONS(4280),
    [anon_sym_u22c4] = ACTIONS(4280),
    [anon_sym_u25c7] = ACTIONS(4280),
    [anon_sym_EQ_GT] = ACTIONS(4280),
    [anon_sym_u27f9] = ACTIONS(4280),
    [anon_sym_u21d2] = ACTIONS(4280),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4280),
    [anon_sym_u21f8] = ACTIONS(4280),
    [anon_sym_u2945] = ACTIONS(4280),
    [anon_sym_BSLASHequiv] = ACTIONS(4280),
    [anon_sym_u2261] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4280),
    [anon_sym_u27fa] = ACTIONS(4280),
    [anon_sym_u21d4] = ACTIONS(4280),
    [anon_sym_TILDE_GT] = ACTIONS(4280),
    [anon_sym_u21dd] = ACTIONS(4280),
    [anon_sym_u219d] = ACTIONS(4280),
    [anon_sym_BSLASHland] = ACTIONS(4280),
    [anon_sym_BSLASHlor] = ACTIONS(4280),
    [anon_sym_COLON_EQ] = ACTIONS(4280),
    [anon_sym_u2254] = ACTIONS(4280),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4280),
    [anon_sym_u2a74] = ACTIONS(4280),
    [anon_sym_SLASH_EQ] = ACTIONS(4280),
    [anon_sym_POUND] = ACTIONS(4282),
    [anon_sym_u2260] = ACTIONS(4280),
    [anon_sym_LT] = ACTIONS(4282),
    [sym_gt] = ACTIONS(4282),
    [anon_sym_LT_EQ] = ACTIONS(4282),
    [anon_sym_EQ_LT] = ACTIONS(4280),
    [anon_sym_BSLASHleq] = ACTIONS(4280),
    [anon_sym_u2264] = ACTIONS(4280),
    [anon_sym_GT_EQ] = ACTIONS(4280),
    [anon_sym_BSLASHgeq] = ACTIONS(4280),
    [anon_sym_u2265] = ACTIONS(4280),
    [anon_sym_BSLASHapprox] = ACTIONS(4280),
    [anon_sym_u2248] = ACTIONS(4280),
    [anon_sym_PIPE_DASH] = ACTIONS(4280),
    [anon_sym_u22a2] = ACTIONS(4280),
    [anon_sym_PIPE_EQ] = ACTIONS(4280),
    [anon_sym_u22a8] = ACTIONS(4280),
    [anon_sym_DASH_PIPE] = ACTIONS(4280),
    [anon_sym_u22a3] = ACTIONS(4280),
    [anon_sym_EQ_PIPE] = ACTIONS(4280),
    [anon_sym_u2ae4] = ACTIONS(4280),
    [anon_sym_BSLASHasymp] = ACTIONS(4280),
    [anon_sym_u224d] = ACTIONS(4280),
    [anon_sym_BSLASHcong] = ACTIONS(4280),
    [anon_sym_u2245] = ACTIONS(4280),
    [anon_sym_BSLASHdoteq] = ACTIONS(4280),
    [anon_sym_u2250] = ACTIONS(4280),
    [anon_sym_BSLASHgg] = ACTIONS(4280),
    [anon_sym_u226b] = ACTIONS(4280),
    [anon_sym_BSLASHll] = ACTIONS(4280),
    [anon_sym_u226a] = ACTIONS(4280),
    [anon_sym_BSLASHnotin] = ACTIONS(4280),
    [anon_sym_u2209] = ACTIONS(4280),
    [anon_sym_BSLASHprec] = ACTIONS(4282),
    [anon_sym_u227a] = ACTIONS(4280),
    [anon_sym_BSLASHsucc] = ACTIONS(4282),
    [anon_sym_u227b] = ACTIONS(4280),
    [anon_sym_BSLASHpreceq] = ACTIONS(4280),
    [anon_sym_u2aaf] = ACTIONS(4280),
    [anon_sym_BSLASHsucceq] = ACTIONS(4280),
    [anon_sym_u2ab0] = ACTIONS(4280),
    [anon_sym_BSLASHpropto] = ACTIONS(4280),
    [anon_sym_u221d] = ACTIONS(4280),
    [anon_sym_BSLASHsim] = ACTIONS(4282),
    [anon_sym_u223c] = ACTIONS(4280),
    [anon_sym_BSLASHsimeq] = ACTIONS(4280),
    [anon_sym_u2243] = ACTIONS(4280),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4282),
    [anon_sym_u228f] = ACTIONS(4280),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4282),
    [anon_sym_u2290] = ACTIONS(4280),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4280),
    [anon_sym_u2291] = ACTIONS(4280),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4280),
    [anon_sym_u2292] = ACTIONS(4280),
    [anon_sym_BSLASHsubset] = ACTIONS(4282),
    [anon_sym_u2282] = ACTIONS(4280),
    [anon_sym_BSLASHsupset] = ACTIONS(4282),
    [anon_sym_u2283] = ACTIONS(4280),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4280),
    [anon_sym_u2286] = ACTIONS(4280),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4280),
    [anon_sym_u2287] = ACTIONS(4280),
    [sym_compose] = ACTIONS(4280),
    [sym_map_to] = ACTIONS(4280),
    [sym_map_from] = ACTIONS(4280),
    [sym_setminus] = ACTIONS(4282),
    [anon_sym_BSLASHcap] = ACTIONS(4280),
    [anon_sym_BSLASHintersect] = ACTIONS(4280),
    [anon_sym_u2229] = ACTIONS(4280),
    [anon_sym_BSLASHcup] = ACTIONS(4280),
    [anon_sym_BSLASHunion] = ACTIONS(4280),
    [anon_sym_u222a] = ACTIONS(4280),
    [anon_sym_DOT_DOT] = ACTIONS(4282),
    [anon_sym_u2025] = ACTIONS(4280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4280),
    [anon_sym_u2026] = ACTIONS(4280),
    [anon_sym_PLUS] = ACTIONS(4282),
    [sym_plusplus] = ACTIONS(4280),
    [anon_sym_BSLASHoplus] = ACTIONS(4280),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4280),
    [anon_sym_u2295] = ACTIONS(4280),
    [anon_sym_BSLASHominus] = ACTIONS(4280),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4280),
    [anon_sym_u2296] = ACTIONS(4280),
    [sym_mod] = ACTIONS(4282),
    [sym_modmod] = ACTIONS(4280),
    [sym_vert] = ACTIONS(4282),
    [anon_sym_PIPE_PIPE] = ACTIONS(4280),
    [anon_sym_u2016] = ACTIONS(4280),
    [sym_minusminus] = ACTIONS(4282),
    [sym_amp] = ACTIONS(4282),
    [sym_ampamp] = ACTIONS(4280),
    [anon_sym_BSLASHodot] = ACTIONS(4280),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4280),
    [anon_sym_u2299] = ACTIONS(4280),
    [anon_sym_BSLASHoslash] = ACTIONS(4280),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4280),
    [anon_sym_u2298] = ACTIONS(4280),
    [anon_sym_BSLASHotimes] = ACTIONS(4280),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4280),
    [anon_sym_u2297] = ACTIONS(4280),
    [sym_mul] = ACTIONS(4282),
    [sym_mulmul] = ACTIONS(4280),
    [sym_slash] = ACTIONS(4282),
    [sym_slashslash] = ACTIONS(4280),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4280),
    [anon_sym_u25ef] = ACTIONS(4280),
    [anon_sym_BSLASHbullet] = ACTIONS(4280),
    [anon_sym_u25cf] = ACTIONS(4280),
    [anon_sym_BSLASHdiv] = ACTIONS(4280),
    [anon_sym_u00f7] = ACTIONS(4280),
    [anon_sym_BSLASHcirc] = ACTIONS(4280),
    [anon_sym_u2218] = ACTIONS(4280),
    [anon_sym_BSLASHstar] = ACTIONS(4280),
    [anon_sym_u22c6] = ACTIONS(4280),
    [anon_sym_u203c] = ACTIONS(4280),
    [sym_hashhash] = ACTIONS(4280),
    [sym_dol] = ACTIONS(4282),
    [sym_doldol] = ACTIONS(4280),
    [anon_sym_QMARK_QMARK] = ACTIONS(4280),
    [anon_sym_u2047] = ACTIONS(4280),
    [anon_sym_BSLASHsqcap] = ACTIONS(4280),
    [anon_sym_u2293] = ACTIONS(4280),
    [anon_sym_BSLASHsqcup] = ACTIONS(4280),
    [anon_sym_u2294] = ACTIONS(4280),
    [anon_sym_BSLASHuplus] = ACTIONS(4280),
    [anon_sym_u228e] = ACTIONS(4280),
    [anon_sym_BSLASHX] = ACTIONS(4280),
    [anon_sym_BSLASHtimes] = ACTIONS(4280),
    [anon_sym_u00d7] = ACTIONS(4280),
    [anon_sym_BSLASHwr] = ACTIONS(4280),
    [anon_sym_u2240] = ACTIONS(4280),
    [anon_sym_BSLASHcdot] = ACTIONS(4280),
    [anon_sym_u22c5] = ACTIONS(4280),
    [sym_pow] = ACTIONS(4282),
    [sym_powpow] = ACTIONS(4280),
    [anon_sym_CARET_PLUS] = ACTIONS(4280),
    [anon_sym_u207a] = ACTIONS(4280),
    [sym_asterisk] = ACTIONS(4280),
    [sym_sup_hash] = ACTIONS(4280),
    [sym_prime] = ACTIONS(4280),
    [anon_sym_ASSUME] = ACTIONS(4282),
    [anon_sym_ASSUMPTION] = ACTIONS(4282),
    [anon_sym_AXIOM] = ACTIONS(4282),
    [anon_sym_THEOREM] = ACTIONS(4282),
    [anon_sym_PROPOSITION] = ACTIONS(4282),
    [anon_sym_LEMMA] = ACTIONS(4282),
    [anon_sym_COROLLARY] = ACTIONS(4282),
    [anon_sym_USE] = ACTIONS(4282),
    [anon_sym_HIDE] = ACTIONS(4282),
    [sym__indent] = ACTIONS(4280),
    [sym__double_excl] = ACTIONS(4280),
  },
  [1601] = {
    [sym_block_comment] = STATE(1601),
    [ts_builtin_sym_end] = ACTIONS(4284),
    [sym_identifier] = ACTIONS(4286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4284),
    [anon_sym_BSLASHin] = ACTIONS(4286),
    [anon_sym_u2208] = ACTIONS(4284),
    [anon_sym_BSLASHA] = ACTIONS(4286),
    [anon_sym_BSLASHforall] = ACTIONS(4284),
    [anon_sym_u2200] = ACTIONS(4284),
    [anon_sym_BSLASHE] = ACTIONS(4286),
    [anon_sym_BSLASHexists] = ACTIONS(4284),
    [anon_sym_u2203] = ACTIONS(4284),
    [sym_temporal_forall] = ACTIONS(4284),
    [sym_temporal_exists] = ACTIONS(4284),
    [anon_sym_LT_LT] = ACTIONS(4284),
    [anon_sym_u3008] = ACTIONS(4284),
    [anon_sym_u27e8] = ACTIONS(4284),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4284),
    [anon_sym_u25a1] = ACTIONS(4284),
    [anon_sym_AT] = ACTIONS(4286),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4284),
    [anon_sym_u2227] = ACTIONS(4284),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4284),
    [anon_sym_u2228] = ACTIONS(4284),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_LOCAL] = ACTIONS(4286),
    [anon_sym_VARIABLE] = ACTIONS(4286),
    [anon_sym_VARIABLES] = ACTIONS(4286),
    [anon_sym_CONSTANT] = ACTIONS(4286),
    [anon_sym_CONSTANTS] = ACTIONS(4286),
    [anon_sym_RECURSIVE] = ACTIONS(4286),
    [anon_sym_LPAREN] = ACTIONS(4286),
    [anon_sym_LBRACK] = ACTIONS(4286),
    [anon_sym_INSTANCE] = ACTIONS(4286),
    [anon_sym_BANG] = ACTIONS(4284),
    [aux_sym_child_id_token1] = ACTIONS(4286),
    [sym_real_number] = ACTIONS(4284),
    [anon_sym_BSLASHb] = ACTIONS(4286),
    [anon_sym_BSLASHB] = ACTIONS(4284),
    [anon_sym_BSLASHo] = ACTIONS(4286),
    [anon_sym_BSLASHO] = ACTIONS(4284),
    [anon_sym_BSLASHh] = ACTIONS(4284),
    [anon_sym_BSLASHH] = ACTIONS(4284),
    [anon_sym_DQUOTE] = ACTIONS(4284),
    [anon_sym_TRUE] = ACTIONS(4286),
    [anon_sym_FALSE] = ACTIONS(4286),
    [sym_string_set] = ACTIONS(4286),
    [sym_boolean_set] = ACTIONS(4286),
    [anon_sym_Nat] = ACTIONS(4286),
    [anon_sym_u2115] = ACTIONS(4284),
    [anon_sym_Int] = ACTIONS(4286),
    [anon_sym_u2124] = ACTIONS(4284),
    [anon_sym_Real] = ACTIONS(4286),
    [anon_sym_u211d] = ACTIONS(4284),
    [anon_sym_CHOOSE] = ACTIONS(4286),
    [anon_sym_LBRACE] = ACTIONS(4284),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_WF_] = ACTIONS(4286),
    [anon_sym_SF_] = ACTIONS(4286),
    [anon_sym_IF] = ACTIONS(4286),
    [anon_sym_CASE] = ACTIONS(4286),
    [anon_sym_LET] = ACTIONS(4286),
    [anon_sym_BSLASHlnot] = ACTIONS(4284),
    [anon_sym_BSLASHneg] = ACTIONS(4284),
    [anon_sym_TILDE] = ACTIONS(4286),
    [anon_sym_u00ac] = ACTIONS(4284),
    [sym_union] = ACTIONS(4286),
    [sym_powerset] = ACTIONS(4286),
    [sym_domain] = ACTIONS(4286),
    [anon_sym_DASH] = ACTIONS(4286),
    [sym_negative_dot] = ACTIONS(4284),
    [sym_enabled] = ACTIONS(4286),
    [sym_unchanged] = ACTIONS(4286),
    [anon_sym_LT_GT] = ACTIONS(4284),
    [anon_sym_u22c4] = ACTIONS(4284),
    [anon_sym_u25c7] = ACTIONS(4284),
    [anon_sym_EQ_GT] = ACTIONS(4284),
    [anon_sym_u27f9] = ACTIONS(4284),
    [anon_sym_u21d2] = ACTIONS(4284),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4284),
    [anon_sym_u21f8] = ACTIONS(4284),
    [anon_sym_u2945] = ACTIONS(4284),
    [anon_sym_BSLASHequiv] = ACTIONS(4284),
    [anon_sym_u2261] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4284),
    [anon_sym_u27fa] = ACTIONS(4284),
    [anon_sym_u21d4] = ACTIONS(4284),
    [anon_sym_TILDE_GT] = ACTIONS(4284),
    [anon_sym_u21dd] = ACTIONS(4284),
    [anon_sym_u219d] = ACTIONS(4284),
    [anon_sym_BSLASHland] = ACTIONS(4284),
    [anon_sym_BSLASHlor] = ACTIONS(4284),
    [anon_sym_COLON_EQ] = ACTIONS(4284),
    [anon_sym_u2254] = ACTIONS(4284),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4284),
    [anon_sym_u2a74] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_POUND] = ACTIONS(4286),
    [anon_sym_u2260] = ACTIONS(4284),
    [anon_sym_LT] = ACTIONS(4286),
    [sym_gt] = ACTIONS(4286),
    [anon_sym_LT_EQ] = ACTIONS(4286),
    [anon_sym_EQ_LT] = ACTIONS(4284),
    [anon_sym_BSLASHleq] = ACTIONS(4284),
    [anon_sym_u2264] = ACTIONS(4284),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_BSLASHgeq] = ACTIONS(4284),
    [anon_sym_u2265] = ACTIONS(4284),
    [anon_sym_BSLASHapprox] = ACTIONS(4284),
    [anon_sym_u2248] = ACTIONS(4284),
    [anon_sym_PIPE_DASH] = ACTIONS(4284),
    [anon_sym_u22a2] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_u22a8] = ACTIONS(4284),
    [anon_sym_DASH_PIPE] = ACTIONS(4284),
    [anon_sym_u22a3] = ACTIONS(4284),
    [anon_sym_EQ_PIPE] = ACTIONS(4284),
    [anon_sym_u2ae4] = ACTIONS(4284),
    [anon_sym_BSLASHasymp] = ACTIONS(4284),
    [anon_sym_u224d] = ACTIONS(4284),
    [anon_sym_BSLASHcong] = ACTIONS(4284),
    [anon_sym_u2245] = ACTIONS(4284),
    [anon_sym_BSLASHdoteq] = ACTIONS(4284),
    [anon_sym_u2250] = ACTIONS(4284),
    [anon_sym_BSLASHgg] = ACTIONS(4284),
    [anon_sym_u226b] = ACTIONS(4284),
    [anon_sym_BSLASHll] = ACTIONS(4284),
    [anon_sym_u226a] = ACTIONS(4284),
    [anon_sym_BSLASHnotin] = ACTIONS(4284),
    [anon_sym_u2209] = ACTIONS(4284),
    [anon_sym_BSLASHprec] = ACTIONS(4286),
    [anon_sym_u227a] = ACTIONS(4284),
    [anon_sym_BSLASHsucc] = ACTIONS(4286),
    [anon_sym_u227b] = ACTIONS(4284),
    [anon_sym_BSLASHpreceq] = ACTIONS(4284),
    [anon_sym_u2aaf] = ACTIONS(4284),
    [anon_sym_BSLASHsucceq] = ACTIONS(4284),
    [anon_sym_u2ab0] = ACTIONS(4284),
    [anon_sym_BSLASHpropto] = ACTIONS(4284),
    [anon_sym_u221d] = ACTIONS(4284),
    [anon_sym_BSLASHsim] = ACTIONS(4286),
    [anon_sym_u223c] = ACTIONS(4284),
    [anon_sym_BSLASHsimeq] = ACTIONS(4284),
    [anon_sym_u2243] = ACTIONS(4284),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4286),
    [anon_sym_u228f] = ACTIONS(4284),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4286),
    [anon_sym_u2290] = ACTIONS(4284),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4284),
    [anon_sym_u2291] = ACTIONS(4284),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4284),
    [anon_sym_u2292] = ACTIONS(4284),
    [anon_sym_BSLASHsubset] = ACTIONS(4286),
    [anon_sym_u2282] = ACTIONS(4284),
    [anon_sym_BSLASHsupset] = ACTIONS(4286),
    [anon_sym_u2283] = ACTIONS(4284),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4284),
    [anon_sym_u2286] = ACTIONS(4284),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4284),
    [anon_sym_u2287] = ACTIONS(4284),
    [sym_compose] = ACTIONS(4284),
    [sym_map_to] = ACTIONS(4284),
    [sym_map_from] = ACTIONS(4284),
    [sym_setminus] = ACTIONS(4286),
    [anon_sym_BSLASHcap] = ACTIONS(4284),
    [anon_sym_BSLASHintersect] = ACTIONS(4284),
    [anon_sym_u2229] = ACTIONS(4284),
    [anon_sym_BSLASHcup] = ACTIONS(4284),
    [anon_sym_BSLASHunion] = ACTIONS(4284),
    [anon_sym_u222a] = ACTIONS(4284),
    [anon_sym_DOT_DOT] = ACTIONS(4286),
    [anon_sym_u2025] = ACTIONS(4284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4284),
    [anon_sym_u2026] = ACTIONS(4284),
    [anon_sym_PLUS] = ACTIONS(4286),
    [sym_plusplus] = ACTIONS(4284),
    [anon_sym_BSLASHoplus] = ACTIONS(4284),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4284),
    [anon_sym_u2295] = ACTIONS(4284),
    [anon_sym_BSLASHominus] = ACTIONS(4284),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4284),
    [anon_sym_u2296] = ACTIONS(4284),
    [sym_mod] = ACTIONS(4286),
    [sym_modmod] = ACTIONS(4284),
    [sym_vert] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_u2016] = ACTIONS(4284),
    [sym_minusminus] = ACTIONS(4286),
    [sym_amp] = ACTIONS(4286),
    [sym_ampamp] = ACTIONS(4284),
    [anon_sym_BSLASHodot] = ACTIONS(4284),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4284),
    [anon_sym_u2299] = ACTIONS(4284),
    [anon_sym_BSLASHoslash] = ACTIONS(4284),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4284),
    [anon_sym_u2298] = ACTIONS(4284),
    [anon_sym_BSLASHotimes] = ACTIONS(4284),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4284),
    [anon_sym_u2297] = ACTIONS(4284),
    [sym_mul] = ACTIONS(4286),
    [sym_mulmul] = ACTIONS(4284),
    [sym_slash] = ACTIONS(4286),
    [sym_slashslash] = ACTIONS(4284),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4284),
    [anon_sym_u25ef] = ACTIONS(4284),
    [anon_sym_BSLASHbullet] = ACTIONS(4284),
    [anon_sym_u25cf] = ACTIONS(4284),
    [anon_sym_BSLASHdiv] = ACTIONS(4284),
    [anon_sym_u00f7] = ACTIONS(4284),
    [anon_sym_BSLASHcirc] = ACTIONS(4284),
    [anon_sym_u2218] = ACTIONS(4284),
    [anon_sym_BSLASHstar] = ACTIONS(4284),
    [anon_sym_u22c6] = ACTIONS(4284),
    [anon_sym_u203c] = ACTIONS(4284),
    [sym_hashhash] = ACTIONS(4284),
    [sym_dol] = ACTIONS(4286),
    [sym_doldol] = ACTIONS(4284),
    [anon_sym_QMARK_QMARK] = ACTIONS(4284),
    [anon_sym_u2047] = ACTIONS(4284),
    [anon_sym_BSLASHsqcap] = ACTIONS(4284),
    [anon_sym_u2293] = ACTIONS(4284),
    [anon_sym_BSLASHsqcup] = ACTIONS(4284),
    [anon_sym_u2294] = ACTIONS(4284),
    [anon_sym_BSLASHuplus] = ACTIONS(4284),
    [anon_sym_u228e] = ACTIONS(4284),
    [anon_sym_BSLASHX] = ACTIONS(4284),
    [anon_sym_BSLASHtimes] = ACTIONS(4284),
    [anon_sym_u00d7] = ACTIONS(4284),
    [anon_sym_BSLASHwr] = ACTIONS(4284),
    [anon_sym_u2240] = ACTIONS(4284),
    [anon_sym_BSLASHcdot] = ACTIONS(4284),
    [anon_sym_u22c5] = ACTIONS(4284),
    [sym_pow] = ACTIONS(4286),
    [sym_powpow] = ACTIONS(4284),
    [anon_sym_CARET_PLUS] = ACTIONS(4284),
    [anon_sym_u207a] = ACTIONS(4284),
    [sym_asterisk] = ACTIONS(4284),
    [sym_sup_hash] = ACTIONS(4284),
    [sym_prime] = ACTIONS(4284),
    [anon_sym_ASSUME] = ACTIONS(4286),
    [anon_sym_ASSUMPTION] = ACTIONS(4286),
    [anon_sym_AXIOM] = ACTIONS(4286),
    [anon_sym_THEOREM] = ACTIONS(4286),
    [anon_sym_PROPOSITION] = ACTIONS(4286),
    [anon_sym_LEMMA] = ACTIONS(4286),
    [anon_sym_COROLLARY] = ACTIONS(4286),
    [anon_sym_USE] = ACTIONS(4286),
    [anon_sym_HIDE] = ACTIONS(4286),
    [sym__indent] = ACTIONS(4284),
    [sym__double_excl] = ACTIONS(4284),
  },
  [1602] = {
    [sym_block_comment] = STATE(1602),
    [ts_builtin_sym_end] = ACTIONS(4288),
    [sym_identifier] = ACTIONS(4290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4288),
    [anon_sym_BSLASHin] = ACTIONS(4290),
    [anon_sym_u2208] = ACTIONS(4288),
    [anon_sym_BSLASHA] = ACTIONS(4290),
    [anon_sym_BSLASHforall] = ACTIONS(4288),
    [anon_sym_u2200] = ACTIONS(4288),
    [anon_sym_BSLASHE] = ACTIONS(4290),
    [anon_sym_BSLASHexists] = ACTIONS(4288),
    [anon_sym_u2203] = ACTIONS(4288),
    [sym_temporal_forall] = ACTIONS(4288),
    [sym_temporal_exists] = ACTIONS(4288),
    [anon_sym_LT_LT] = ACTIONS(4288),
    [anon_sym_u3008] = ACTIONS(4288),
    [anon_sym_u27e8] = ACTIONS(4288),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4288),
    [anon_sym_u25a1] = ACTIONS(4288),
    [anon_sym_AT] = ACTIONS(4290),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4288),
    [anon_sym_u2227] = ACTIONS(4288),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4288),
    [anon_sym_u2228] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_LOCAL] = ACTIONS(4290),
    [anon_sym_VARIABLE] = ACTIONS(4290),
    [anon_sym_VARIABLES] = ACTIONS(4290),
    [anon_sym_CONSTANT] = ACTIONS(4290),
    [anon_sym_CONSTANTS] = ACTIONS(4290),
    [anon_sym_RECURSIVE] = ACTIONS(4290),
    [anon_sym_LPAREN] = ACTIONS(4290),
    [anon_sym_LBRACK] = ACTIONS(4290),
    [anon_sym_INSTANCE] = ACTIONS(4290),
    [anon_sym_BANG] = ACTIONS(4288),
    [aux_sym_child_id_token1] = ACTIONS(4290),
    [sym_real_number] = ACTIONS(4288),
    [anon_sym_BSLASHb] = ACTIONS(4290),
    [anon_sym_BSLASHB] = ACTIONS(4288),
    [anon_sym_BSLASHo] = ACTIONS(4290),
    [anon_sym_BSLASHO] = ACTIONS(4288),
    [anon_sym_BSLASHh] = ACTIONS(4288),
    [anon_sym_BSLASHH] = ACTIONS(4288),
    [anon_sym_DQUOTE] = ACTIONS(4288),
    [anon_sym_TRUE] = ACTIONS(4290),
    [anon_sym_FALSE] = ACTIONS(4290),
    [sym_string_set] = ACTIONS(4290),
    [sym_boolean_set] = ACTIONS(4290),
    [anon_sym_Nat] = ACTIONS(4290),
    [anon_sym_u2115] = ACTIONS(4288),
    [anon_sym_Int] = ACTIONS(4290),
    [anon_sym_u2124] = ACTIONS(4288),
    [anon_sym_Real] = ACTIONS(4290),
    [anon_sym_u211d] = ACTIONS(4288),
    [anon_sym_CHOOSE] = ACTIONS(4290),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_WF_] = ACTIONS(4290),
    [anon_sym_SF_] = ACTIONS(4290),
    [anon_sym_IF] = ACTIONS(4290),
    [anon_sym_CASE] = ACTIONS(4290),
    [anon_sym_LET] = ACTIONS(4290),
    [anon_sym_BSLASHlnot] = ACTIONS(4288),
    [anon_sym_BSLASHneg] = ACTIONS(4288),
    [anon_sym_TILDE] = ACTIONS(4290),
    [anon_sym_u00ac] = ACTIONS(4288),
    [sym_union] = ACTIONS(4290),
    [sym_powerset] = ACTIONS(4290),
    [sym_domain] = ACTIONS(4290),
    [anon_sym_DASH] = ACTIONS(4290),
    [sym_negative_dot] = ACTIONS(4288),
    [sym_enabled] = ACTIONS(4290),
    [sym_unchanged] = ACTIONS(4290),
    [anon_sym_LT_GT] = ACTIONS(4288),
    [anon_sym_u22c4] = ACTIONS(4288),
    [anon_sym_u25c7] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_u27f9] = ACTIONS(4288),
    [anon_sym_u21d2] = ACTIONS(4288),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4288),
    [anon_sym_u21f8] = ACTIONS(4288),
    [anon_sym_u2945] = ACTIONS(4288),
    [anon_sym_BSLASHequiv] = ACTIONS(4288),
    [anon_sym_u2261] = ACTIONS(4288),
    [anon_sym_LT_EQ_GT] = ACTIONS(4288),
    [anon_sym_u27fa] = ACTIONS(4288),
    [anon_sym_u21d4] = ACTIONS(4288),
    [anon_sym_TILDE_GT] = ACTIONS(4288),
    [anon_sym_u21dd] = ACTIONS(4288),
    [anon_sym_u219d] = ACTIONS(4288),
    [anon_sym_BSLASHland] = ACTIONS(4288),
    [anon_sym_BSLASHlor] = ACTIONS(4288),
    [anon_sym_COLON_EQ] = ACTIONS(4288),
    [anon_sym_u2254] = ACTIONS(4288),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4288),
    [anon_sym_u2a74] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_POUND] = ACTIONS(4290),
    [anon_sym_u2260] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4290),
    [sym_gt] = ACTIONS(4290),
    [anon_sym_LT_EQ] = ACTIONS(4290),
    [anon_sym_EQ_LT] = ACTIONS(4288),
    [anon_sym_BSLASHleq] = ACTIONS(4288),
    [anon_sym_u2264] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(4288),
    [anon_sym_BSLASHgeq] = ACTIONS(4288),
    [anon_sym_u2265] = ACTIONS(4288),
    [anon_sym_BSLASHapprox] = ACTIONS(4288),
    [anon_sym_u2248] = ACTIONS(4288),
    [anon_sym_PIPE_DASH] = ACTIONS(4288),
    [anon_sym_u22a2] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_u22a8] = ACTIONS(4288),
    [anon_sym_DASH_PIPE] = ACTIONS(4288),
    [anon_sym_u22a3] = ACTIONS(4288),
    [anon_sym_EQ_PIPE] = ACTIONS(4288),
    [anon_sym_u2ae4] = ACTIONS(4288),
    [anon_sym_BSLASHasymp] = ACTIONS(4288),
    [anon_sym_u224d] = ACTIONS(4288),
    [anon_sym_BSLASHcong] = ACTIONS(4288),
    [anon_sym_u2245] = ACTIONS(4288),
    [anon_sym_BSLASHdoteq] = ACTIONS(4288),
    [anon_sym_u2250] = ACTIONS(4288),
    [anon_sym_BSLASHgg] = ACTIONS(4288),
    [anon_sym_u226b] = ACTIONS(4288),
    [anon_sym_BSLASHll] = ACTIONS(4288),
    [anon_sym_u226a] = ACTIONS(4288),
    [anon_sym_BSLASHnotin] = ACTIONS(4288),
    [anon_sym_u2209] = ACTIONS(4288),
    [anon_sym_BSLASHprec] = ACTIONS(4290),
    [anon_sym_u227a] = ACTIONS(4288),
    [anon_sym_BSLASHsucc] = ACTIONS(4290),
    [anon_sym_u227b] = ACTIONS(4288),
    [anon_sym_BSLASHpreceq] = ACTIONS(4288),
    [anon_sym_u2aaf] = ACTIONS(4288),
    [anon_sym_BSLASHsucceq] = ACTIONS(4288),
    [anon_sym_u2ab0] = ACTIONS(4288),
    [anon_sym_BSLASHpropto] = ACTIONS(4288),
    [anon_sym_u221d] = ACTIONS(4288),
    [anon_sym_BSLASHsim] = ACTIONS(4290),
    [anon_sym_u223c] = ACTIONS(4288),
    [anon_sym_BSLASHsimeq] = ACTIONS(4288),
    [anon_sym_u2243] = ACTIONS(4288),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4290),
    [anon_sym_u228f] = ACTIONS(4288),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4290),
    [anon_sym_u2290] = ACTIONS(4288),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4288),
    [anon_sym_u2291] = ACTIONS(4288),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4288),
    [anon_sym_u2292] = ACTIONS(4288),
    [anon_sym_BSLASHsubset] = ACTIONS(4290),
    [anon_sym_u2282] = ACTIONS(4288),
    [anon_sym_BSLASHsupset] = ACTIONS(4290),
    [anon_sym_u2283] = ACTIONS(4288),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4288),
    [anon_sym_u2286] = ACTIONS(4288),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4288),
    [anon_sym_u2287] = ACTIONS(4288),
    [sym_compose] = ACTIONS(4288),
    [sym_map_to] = ACTIONS(4288),
    [sym_map_from] = ACTIONS(4288),
    [sym_setminus] = ACTIONS(4290),
    [anon_sym_BSLASHcap] = ACTIONS(4288),
    [anon_sym_BSLASHintersect] = ACTIONS(4288),
    [anon_sym_u2229] = ACTIONS(4288),
    [anon_sym_BSLASHcup] = ACTIONS(4288),
    [anon_sym_BSLASHunion] = ACTIONS(4288),
    [anon_sym_u222a] = ACTIONS(4288),
    [anon_sym_DOT_DOT] = ACTIONS(4290),
    [anon_sym_u2025] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4288),
    [anon_sym_u2026] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(4290),
    [sym_plusplus] = ACTIONS(4288),
    [anon_sym_BSLASHoplus] = ACTIONS(4288),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4288),
    [anon_sym_u2295] = ACTIONS(4288),
    [anon_sym_BSLASHominus] = ACTIONS(4288),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4288),
    [anon_sym_u2296] = ACTIONS(4288),
    [sym_mod] = ACTIONS(4290),
    [sym_modmod] = ACTIONS(4288),
    [sym_vert] = ACTIONS(4290),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_u2016] = ACTIONS(4288),
    [sym_minusminus] = ACTIONS(4290),
    [sym_amp] = ACTIONS(4290),
    [sym_ampamp] = ACTIONS(4288),
    [anon_sym_BSLASHodot] = ACTIONS(4288),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4288),
    [anon_sym_u2299] = ACTIONS(4288),
    [anon_sym_BSLASHoslash] = ACTIONS(4288),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4288),
    [anon_sym_u2298] = ACTIONS(4288),
    [anon_sym_BSLASHotimes] = ACTIONS(4288),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4288),
    [anon_sym_u2297] = ACTIONS(4288),
    [sym_mul] = ACTIONS(4290),
    [sym_mulmul] = ACTIONS(4288),
    [sym_slash] = ACTIONS(4290),
    [sym_slashslash] = ACTIONS(4288),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4288),
    [anon_sym_u25ef] = ACTIONS(4288),
    [anon_sym_BSLASHbullet] = ACTIONS(4288),
    [anon_sym_u25cf] = ACTIONS(4288),
    [anon_sym_BSLASHdiv] = ACTIONS(4288),
    [anon_sym_u00f7] = ACTIONS(4288),
    [anon_sym_BSLASHcirc] = ACTIONS(4288),
    [anon_sym_u2218] = ACTIONS(4288),
    [anon_sym_BSLASHstar] = ACTIONS(4288),
    [anon_sym_u22c6] = ACTIONS(4288),
    [anon_sym_u203c] = ACTIONS(4288),
    [sym_hashhash] = ACTIONS(4288),
    [sym_dol] = ACTIONS(4290),
    [sym_doldol] = ACTIONS(4288),
    [anon_sym_QMARK_QMARK] = ACTIONS(4288),
    [anon_sym_u2047] = ACTIONS(4288),
    [anon_sym_BSLASHsqcap] = ACTIONS(4288),
    [anon_sym_u2293] = ACTIONS(4288),
    [anon_sym_BSLASHsqcup] = ACTIONS(4288),
    [anon_sym_u2294] = ACTIONS(4288),
    [anon_sym_BSLASHuplus] = ACTIONS(4288),
    [anon_sym_u228e] = ACTIONS(4288),
    [anon_sym_BSLASHX] = ACTIONS(4288),
    [anon_sym_BSLASHtimes] = ACTIONS(4288),
    [anon_sym_u00d7] = ACTIONS(4288),
    [anon_sym_BSLASHwr] = ACTIONS(4288),
    [anon_sym_u2240] = ACTIONS(4288),
    [anon_sym_BSLASHcdot] = ACTIONS(4288),
    [anon_sym_u22c5] = ACTIONS(4288),
    [sym_pow] = ACTIONS(4290),
    [sym_powpow] = ACTIONS(4288),
    [anon_sym_CARET_PLUS] = ACTIONS(4288),
    [anon_sym_u207a] = ACTIONS(4288),
    [sym_asterisk] = ACTIONS(4288),
    [sym_sup_hash] = ACTIONS(4288),
    [sym_prime] = ACTIONS(4288),
    [anon_sym_ASSUME] = ACTIONS(4290),
    [anon_sym_ASSUMPTION] = ACTIONS(4290),
    [anon_sym_AXIOM] = ACTIONS(4290),
    [anon_sym_THEOREM] = ACTIONS(4290),
    [anon_sym_PROPOSITION] = ACTIONS(4290),
    [anon_sym_LEMMA] = ACTIONS(4290),
    [anon_sym_COROLLARY] = ACTIONS(4290),
    [anon_sym_USE] = ACTIONS(4290),
    [anon_sym_HIDE] = ACTIONS(4290),
    [sym__indent] = ACTIONS(4288),
    [sym__double_excl] = ACTIONS(4288),
  },
  [1603] = {
    [sym_block_comment] = STATE(1603),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_DASH_GT] = ACTIONS(3495),
    [anon_sym_u27f6] = ACTIONS(3495),
    [anon_sym_u2192] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_RBRACK_] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1604] = {
    [sym_block_comment] = STATE(1604),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_DASH_GT] = ACTIONS(3495),
    [anon_sym_u27f6] = ACTIONS(3495),
    [anon_sym_u2192] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_RBRACK_] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1605] = {
    [sym_block_comment] = STATE(1605),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3495),
    [anon_sym_u27f6] = ACTIONS(3495),
    [anon_sym_u2192] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1606] = {
    [sym_block_comment] = STATE(1606),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_DASH_GT] = ACTIONS(3495),
    [anon_sym_u27f6] = ACTIONS(3495),
    [anon_sym_u2192] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3495),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_RBRACK_] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1607] = {
    [sym_block_comment] = STATE(1607),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3531),
    [anon_sym_u27f6] = ACTIONS(3531),
    [anon_sym_u2192] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1608] = {
    [sym_block_comment] = STATE(1608),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3491),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_RBRACK_] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1609] = {
    [sym_block_comment] = STATE(1609),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3491),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_RBRACK_] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1610] = {
    [sym_block_comment] = STATE(1610),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3491),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_RBRACK_] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1611] = {
    [sym_block_comment] = STATE(1611),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3491),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_RBRACK_] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1612] = {
    [sym_block_comment] = STATE(1612),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3491),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_RBRACK_] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1613] = {
    [sym_block_comment] = STATE(1613),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3491),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_RBRACK_] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1614] = {
    [sym_block_comment] = STATE(1614),
    [ts_builtin_sym_end] = ACTIONS(4269),
    [sym_identifier] = ACTIONS(4266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4269),
    [anon_sym_BSLASHin] = ACTIONS(4271),
    [anon_sym_u2208] = ACTIONS(4273),
    [anon_sym_BSLASHA] = ACTIONS(4271),
    [anon_sym_BSLASHforall] = ACTIONS(4273),
    [anon_sym_u2200] = ACTIONS(4273),
    [anon_sym_BSLASHE] = ACTIONS(4271),
    [anon_sym_BSLASHexists] = ACTIONS(4273),
    [anon_sym_u2203] = ACTIONS(4273),
    [sym_temporal_forall] = ACTIONS(4273),
    [sym_temporal_exists] = ACTIONS(4273),
    [anon_sym_LT_LT] = ACTIONS(4273),
    [anon_sym_u3008] = ACTIONS(4273),
    [anon_sym_u27e8] = ACTIONS(4273),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4275),
    [anon_sym_u25a1] = ACTIONS(4275),
    [anon_sym_AT] = ACTIONS(4271),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4273),
    [anon_sym_u2227] = ACTIONS(4273),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4273),
    [anon_sym_u2228] = ACTIONS(4273),
    [anon_sym_COMMA] = ACTIONS(4269),
    [anon_sym_LOCAL] = ACTIONS(4278),
    [anon_sym_VARIABLE] = ACTIONS(4278),
    [anon_sym_VARIABLES] = ACTIONS(4278),
    [anon_sym_CONSTANT] = ACTIONS(4278),
    [anon_sym_CONSTANTS] = ACTIONS(4278),
    [anon_sym_RECURSIVE] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [anon_sym_LBRACK] = ACTIONS(4271),
    [anon_sym_INSTANCE] = ACTIONS(4278),
    [anon_sym_BANG] = ACTIONS(4269),
    [aux_sym_child_id_token1] = ACTIONS(4271),
    [sym_real_number] = ACTIONS(4273),
    [anon_sym_BSLASHb] = ACTIONS(4271),
    [anon_sym_BSLASHB] = ACTIONS(4273),
    [anon_sym_BSLASHo] = ACTIONS(4271),
    [anon_sym_BSLASHO] = ACTIONS(4273),
    [anon_sym_BSLASHh] = ACTIONS(4273),
    [anon_sym_BSLASHH] = ACTIONS(4273),
    [anon_sym_DQUOTE] = ACTIONS(4273),
    [anon_sym_TRUE] = ACTIONS(4271),
    [anon_sym_FALSE] = ACTIONS(4271),
    [sym_string_set] = ACTIONS(4271),
    [sym_boolean_set] = ACTIONS(4271),
    [anon_sym_Nat] = ACTIONS(4266),
    [anon_sym_u2115] = ACTIONS(4275),
    [anon_sym_Int] = ACTIONS(4266),
    [anon_sym_u2124] = ACTIONS(4275),
    [anon_sym_Real] = ACTIONS(4266),
    [anon_sym_u211d] = ACTIONS(4275),
    [anon_sym_CHOOSE] = ACTIONS(4271),
    [anon_sym_LBRACE] = ACTIONS(4273),
    [anon_sym_EQ] = ACTIONS(4271),
    [anon_sym_WF_] = ACTIONS(4271),
    [anon_sym_SF_] = ACTIONS(4271),
    [anon_sym_IF] = ACTIONS(4271),
    [anon_sym_CASE] = ACTIONS(4271),
    [anon_sym_LET] = ACTIONS(4271),
    [anon_sym_BSLASHlnot] = ACTIONS(4275),
    [anon_sym_BSLASHneg] = ACTIONS(4275),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_u00ac] = ACTIONS(4275),
    [sym_union] = ACTIONS(4266),
    [sym_powerset] = ACTIONS(4266),
    [sym_domain] = ACTIONS(4266),
    [anon_sym_DASH] = ACTIONS(4271),
    [sym_negative_dot] = ACTIONS(4275),
    [sym_enabled] = ACTIONS(4266),
    [sym_unchanged] = ACTIONS(4266),
    [anon_sym_LT_GT] = ACTIONS(4275),
    [anon_sym_u22c4] = ACTIONS(4275),
    [anon_sym_u25c7] = ACTIONS(4275),
    [anon_sym_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27f9] = ACTIONS(4273),
    [anon_sym_u21d2] = ACTIONS(4273),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4273),
    [anon_sym_u21f8] = ACTIONS(4273),
    [anon_sym_u2945] = ACTIONS(4273),
    [anon_sym_BSLASHequiv] = ACTIONS(4273),
    [anon_sym_u2261] = ACTIONS(4273),
    [anon_sym_LT_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27fa] = ACTIONS(4273),
    [anon_sym_u21d4] = ACTIONS(4273),
    [anon_sym_TILDE_GT] = ACTIONS(4273),
    [anon_sym_u21dd] = ACTIONS(4273),
    [anon_sym_u219d] = ACTIONS(4273),
    [anon_sym_BSLASHland] = ACTIONS(4273),
    [anon_sym_BSLASHlor] = ACTIONS(4273),
    [anon_sym_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2254] = ACTIONS(4273),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2a74] = ACTIONS(4273),
    [anon_sym_SLASH_EQ] = ACTIONS(4273),
    [anon_sym_POUND] = ACTIONS(4271),
    [anon_sym_u2260] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4271),
    [sym_gt] = ACTIONS(4271),
    [anon_sym_LT_EQ] = ACTIONS(4271),
    [anon_sym_EQ_LT] = ACTIONS(4273),
    [anon_sym_BSLASHleq] = ACTIONS(4273),
    [anon_sym_u2264] = ACTIONS(4273),
    [anon_sym_GT_EQ] = ACTIONS(4273),
    [anon_sym_BSLASHgeq] = ACTIONS(4273),
    [anon_sym_u2265] = ACTIONS(4273),
    [anon_sym_BSLASHapprox] = ACTIONS(4273),
    [anon_sym_u2248] = ACTIONS(4273),
    [anon_sym_PIPE_DASH] = ACTIONS(4273),
    [anon_sym_u22a2] = ACTIONS(4273),
    [anon_sym_PIPE_EQ] = ACTIONS(4273),
    [anon_sym_u22a8] = ACTIONS(4273),
    [anon_sym_DASH_PIPE] = ACTIONS(4273),
    [anon_sym_u22a3] = ACTIONS(4273),
    [anon_sym_EQ_PIPE] = ACTIONS(4273),
    [anon_sym_u2ae4] = ACTIONS(4273),
    [anon_sym_BSLASHasymp] = ACTIONS(4273),
    [anon_sym_u224d] = ACTIONS(4273),
    [anon_sym_BSLASHcong] = ACTIONS(4273),
    [anon_sym_u2245] = ACTIONS(4273),
    [anon_sym_BSLASHdoteq] = ACTIONS(4273),
    [anon_sym_u2250] = ACTIONS(4273),
    [anon_sym_BSLASHgg] = ACTIONS(4273),
    [anon_sym_u226b] = ACTIONS(4273),
    [anon_sym_BSLASHll] = ACTIONS(4273),
    [anon_sym_u226a] = ACTIONS(4273),
    [anon_sym_BSLASHnotin] = ACTIONS(4273),
    [anon_sym_u2209] = ACTIONS(4273),
    [anon_sym_BSLASHprec] = ACTIONS(4271),
    [anon_sym_u227a] = ACTIONS(4273),
    [anon_sym_BSLASHsucc] = ACTIONS(4271),
    [anon_sym_u227b] = ACTIONS(4273),
    [anon_sym_BSLASHpreceq] = ACTIONS(4273),
    [anon_sym_u2aaf] = ACTIONS(4273),
    [anon_sym_BSLASHsucceq] = ACTIONS(4273),
    [anon_sym_u2ab0] = ACTIONS(4273),
    [anon_sym_BSLASHpropto] = ACTIONS(4273),
    [anon_sym_u221d] = ACTIONS(4273),
    [anon_sym_BSLASHsim] = ACTIONS(4271),
    [anon_sym_u223c] = ACTIONS(4273),
    [anon_sym_BSLASHsimeq] = ACTIONS(4273),
    [anon_sym_u2243] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4271),
    [anon_sym_u228f] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4271),
    [anon_sym_u2290] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4273),
    [anon_sym_u2291] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4273),
    [anon_sym_u2292] = ACTIONS(4273),
    [anon_sym_BSLASHsubset] = ACTIONS(4271),
    [anon_sym_u2282] = ACTIONS(4273),
    [anon_sym_BSLASHsupset] = ACTIONS(4271),
    [anon_sym_u2283] = ACTIONS(4273),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4273),
    [anon_sym_u2286] = ACTIONS(4273),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4273),
    [anon_sym_u2287] = ACTIONS(4273),
    [sym_compose] = ACTIONS(4273),
    [sym_map_to] = ACTIONS(4273),
    [sym_map_from] = ACTIONS(4273),
    [sym_setminus] = ACTIONS(4271),
    [anon_sym_BSLASHcap] = ACTIONS(4273),
    [anon_sym_BSLASHintersect] = ACTIONS(4273),
    [anon_sym_u2229] = ACTIONS(4273),
    [anon_sym_BSLASHcup] = ACTIONS(4273),
    [anon_sym_BSLASHunion] = ACTIONS(4273),
    [anon_sym_u222a] = ACTIONS(4273),
    [anon_sym_DOT_DOT] = ACTIONS(4271),
    [anon_sym_u2025] = ACTIONS(4273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4273),
    [anon_sym_u2026] = ACTIONS(4273),
    [anon_sym_PLUS] = ACTIONS(4271),
    [sym_plusplus] = ACTIONS(4273),
    [anon_sym_BSLASHoplus] = ACTIONS(4273),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4273),
    [anon_sym_u2295] = ACTIONS(4273),
    [anon_sym_BSLASHominus] = ACTIONS(4273),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2296] = ACTIONS(4273),
    [sym_mod] = ACTIONS(4271),
    [sym_modmod] = ACTIONS(4273),
    [sym_vert] = ACTIONS(4271),
    [anon_sym_PIPE_PIPE] = ACTIONS(4273),
    [anon_sym_u2016] = ACTIONS(4273),
    [sym_minusminus] = ACTIONS(4271),
    [sym_amp] = ACTIONS(4271),
    [sym_ampamp] = ACTIONS(4273),
    [anon_sym_BSLASHodot] = ACTIONS(4273),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4273),
    [anon_sym_u2299] = ACTIONS(4273),
    [anon_sym_BSLASHoslash] = ACTIONS(4273),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2298] = ACTIONS(4273),
    [anon_sym_BSLASHotimes] = ACTIONS(4273),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4273),
    [anon_sym_u2297] = ACTIONS(4273),
    [sym_mul] = ACTIONS(4271),
    [sym_mulmul] = ACTIONS(4273),
    [sym_slash] = ACTIONS(4271),
    [sym_slashslash] = ACTIONS(4273),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4273),
    [anon_sym_u25ef] = ACTIONS(4273),
    [anon_sym_BSLASHbullet] = ACTIONS(4273),
    [anon_sym_u25cf] = ACTIONS(4273),
    [anon_sym_BSLASHdiv] = ACTIONS(4273),
    [anon_sym_u00f7] = ACTIONS(4273),
    [anon_sym_BSLASHcirc] = ACTIONS(4273),
    [anon_sym_u2218] = ACTIONS(4273),
    [anon_sym_BSLASHstar] = ACTIONS(4273),
    [anon_sym_u22c6] = ACTIONS(4273),
    [anon_sym_u203c] = ACTIONS(4273),
    [sym_hashhash] = ACTIONS(4273),
    [sym_dol] = ACTIONS(4271),
    [sym_doldol] = ACTIONS(4273),
    [anon_sym_QMARK_QMARK] = ACTIONS(4273),
    [anon_sym_u2047] = ACTIONS(4273),
    [anon_sym_BSLASHsqcap] = ACTIONS(4273),
    [anon_sym_u2293] = ACTIONS(4273),
    [anon_sym_BSLASHsqcup] = ACTIONS(4273),
    [anon_sym_u2294] = ACTIONS(4273),
    [anon_sym_BSLASHuplus] = ACTIONS(4273),
    [anon_sym_u228e] = ACTIONS(4273),
    [anon_sym_BSLASHX] = ACTIONS(4273),
    [anon_sym_BSLASHtimes] = ACTIONS(4273),
    [anon_sym_u00d7] = ACTIONS(4273),
    [anon_sym_BSLASHwr] = ACTIONS(4273),
    [anon_sym_u2240] = ACTIONS(4273),
    [anon_sym_BSLASHcdot] = ACTIONS(4273),
    [anon_sym_u22c5] = ACTIONS(4273),
    [sym_pow] = ACTIONS(4271),
    [sym_powpow] = ACTIONS(4273),
    [anon_sym_CARET_PLUS] = ACTIONS(4273),
    [anon_sym_u207a] = ACTIONS(4273),
    [sym_asterisk] = ACTIONS(4273),
    [sym_sup_hash] = ACTIONS(4273),
    [sym_prime] = ACTIONS(4273),
    [anon_sym_ASSUME] = ACTIONS(4278),
    [anon_sym_ASSUMPTION] = ACTIONS(4278),
    [anon_sym_AXIOM] = ACTIONS(4278),
    [anon_sym_THEOREM] = ACTIONS(4278),
    [anon_sym_PROPOSITION] = ACTIONS(4278),
    [anon_sym_LEMMA] = ACTIONS(4278),
    [anon_sym_COROLLARY] = ACTIONS(4278),
    [anon_sym_USE] = ACTIONS(4278),
    [anon_sym_HIDE] = ACTIONS(4278),
    [sym__indent] = ACTIONS(4273),
    [sym__double_excl] = ACTIONS(4273),
  },
  [1615] = {
    [sym_block_comment] = STATE(1615),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3491),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_RBRACK_] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1616] = {
    [sym_block_comment] = STATE(1616),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3491),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1617] = {
    [sym_block_comment] = STATE(1617),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3491),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1618] = {
    [sym_block_comment] = STATE(1618),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3491),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1619] = {
    [sym_block_comment] = STATE(1619),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3491),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_RBRACK_] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1620] = {
    [sym_block_comment] = STATE(1620),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3537),
    [anon_sym_u27f6] = ACTIONS(3537),
    [anon_sym_u2192] = ACTIONS(3537),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3537),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1621] = {
    [sym_block_comment] = STATE(1621),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3541),
    [anon_sym_u27f6] = ACTIONS(3541),
    [anon_sym_u2192] = ACTIONS(3541),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3541),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1622] = {
    [sym_block_comment] = STATE(1622),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3545),
    [anon_sym_u27f6] = ACTIONS(3545),
    [anon_sym_u2192] = ACTIONS(3545),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3545),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1623] = {
    [sym_block_comment] = STATE(1623),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3553),
    [anon_sym_u27f6] = ACTIONS(3553),
    [anon_sym_u2192] = ACTIONS(3553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3553),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1624] = {
    [sym_block_comment] = STATE(1624),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3557),
    [anon_sym_u27f6] = ACTIONS(3557),
    [anon_sym_u2192] = ACTIONS(3557),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3557),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3557),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1625] = {
    [sym_block_comment] = STATE(1625),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3511),
    [anon_sym_u27f6] = ACTIONS(3511),
    [anon_sym_u2192] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3511),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1626] = {
    [sym_block_comment] = STATE(1626),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3525),
    [anon_sym_u27f6] = ACTIONS(3525),
    [anon_sym_u2192] = ACTIONS(3525),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3525),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3525),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1627] = {
    [sym_block_comment] = STATE(1627),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3529),
    [anon_sym_u27f6] = ACTIONS(3529),
    [anon_sym_u2192] = ACTIONS(3529),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3529),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1628] = {
    [sym_block_comment] = STATE(1628),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3499),
    [anon_sym_u27f6] = ACTIONS(3499),
    [anon_sym_u2192] = ACTIONS(3499),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3499),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1629] = {
    [sym_block_comment] = STATE(1629),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3503),
    [anon_sym_u27f6] = ACTIONS(3503),
    [anon_sym_u2192] = ACTIONS(3503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3503),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1630] = {
    [sym_block_comment] = STATE(1630),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(3515),
    [anon_sym_u27f6] = ACTIONS(3515),
    [anon_sym_u2192] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1631] = {
    [sym_block_comment] = STATE(1631),
    [sym_identifier] = ACTIONS(4282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4280),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(4280),
    [anon_sym_BSLASHin] = ACTIONS(4282),
    [anon_sym_u2208] = ACTIONS(4280),
    [anon_sym_BSLASHA] = ACTIONS(4282),
    [anon_sym_BSLASHforall] = ACTIONS(4280),
    [anon_sym_u2200] = ACTIONS(4280),
    [anon_sym_BSLASHE] = ACTIONS(4282),
    [anon_sym_BSLASHexists] = ACTIONS(4280),
    [anon_sym_u2203] = ACTIONS(4280),
    [sym_temporal_forall] = ACTIONS(4280),
    [sym_temporal_exists] = ACTIONS(4280),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_u3008] = ACTIONS(4280),
    [anon_sym_u27e8] = ACTIONS(4280),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4280),
    [anon_sym_u25a1] = ACTIONS(4280),
    [anon_sym_AT] = ACTIONS(4282),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4280),
    [anon_sym_u2227] = ACTIONS(4280),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4280),
    [anon_sym_u2228] = ACTIONS(4280),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_LOCAL] = ACTIONS(4282),
    [anon_sym_VARIABLE] = ACTIONS(4282),
    [anon_sym_VARIABLES] = ACTIONS(4282),
    [anon_sym_CONSTANT] = ACTIONS(4282),
    [anon_sym_CONSTANTS] = ACTIONS(4282),
    [anon_sym_RECURSIVE] = ACTIONS(4282),
    [anon_sym_LPAREN] = ACTIONS(4282),
    [anon_sym_LBRACK] = ACTIONS(4282),
    [anon_sym_INSTANCE] = ACTIONS(4282),
    [anon_sym_BANG] = ACTIONS(4280),
    [aux_sym_child_id_token1] = ACTIONS(4282),
    [sym_real_number] = ACTIONS(4280),
    [anon_sym_BSLASHb] = ACTIONS(4282),
    [anon_sym_BSLASHB] = ACTIONS(4280),
    [anon_sym_BSLASHo] = ACTIONS(4282),
    [anon_sym_BSLASHO] = ACTIONS(4280),
    [anon_sym_BSLASHh] = ACTIONS(4280),
    [anon_sym_BSLASHH] = ACTIONS(4280),
    [anon_sym_DQUOTE] = ACTIONS(4280),
    [anon_sym_TRUE] = ACTIONS(4282),
    [anon_sym_FALSE] = ACTIONS(4282),
    [sym_string_set] = ACTIONS(4282),
    [sym_boolean_set] = ACTIONS(4282),
    [anon_sym_Nat] = ACTIONS(4282),
    [anon_sym_u2115] = ACTIONS(4280),
    [anon_sym_Int] = ACTIONS(4282),
    [anon_sym_u2124] = ACTIONS(4280),
    [anon_sym_Real] = ACTIONS(4282),
    [anon_sym_u211d] = ACTIONS(4280),
    [anon_sym_CHOOSE] = ACTIONS(4282),
    [anon_sym_LBRACE] = ACTIONS(4280),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_WF_] = ACTIONS(4282),
    [anon_sym_SF_] = ACTIONS(4282),
    [anon_sym_IF] = ACTIONS(4282),
    [anon_sym_CASE] = ACTIONS(4282),
    [anon_sym_LET] = ACTIONS(4282),
    [anon_sym_BSLASHlnot] = ACTIONS(4280),
    [anon_sym_BSLASHneg] = ACTIONS(4280),
    [anon_sym_TILDE] = ACTIONS(4282),
    [anon_sym_u00ac] = ACTIONS(4280),
    [sym_union] = ACTIONS(4282),
    [sym_powerset] = ACTIONS(4282),
    [sym_domain] = ACTIONS(4282),
    [anon_sym_DASH] = ACTIONS(4282),
    [sym_negative_dot] = ACTIONS(4280),
    [sym_enabled] = ACTIONS(4282),
    [sym_unchanged] = ACTIONS(4282),
    [anon_sym_LT_GT] = ACTIONS(4280),
    [anon_sym_u22c4] = ACTIONS(4280),
    [anon_sym_u25c7] = ACTIONS(4280),
    [anon_sym_EQ_GT] = ACTIONS(4280),
    [anon_sym_u27f9] = ACTIONS(4280),
    [anon_sym_u21d2] = ACTIONS(4280),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4280),
    [anon_sym_u21f8] = ACTIONS(4280),
    [anon_sym_u2945] = ACTIONS(4280),
    [anon_sym_BSLASHequiv] = ACTIONS(4280),
    [anon_sym_u2261] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4280),
    [anon_sym_u27fa] = ACTIONS(4280),
    [anon_sym_u21d4] = ACTIONS(4280),
    [anon_sym_TILDE_GT] = ACTIONS(4280),
    [anon_sym_u21dd] = ACTIONS(4280),
    [anon_sym_u219d] = ACTIONS(4280),
    [anon_sym_BSLASHland] = ACTIONS(4280),
    [anon_sym_BSLASHlor] = ACTIONS(4280),
    [anon_sym_COLON_EQ] = ACTIONS(4280),
    [anon_sym_u2254] = ACTIONS(4280),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4280),
    [anon_sym_u2a74] = ACTIONS(4280),
    [anon_sym_SLASH_EQ] = ACTIONS(4280),
    [anon_sym_POUND] = ACTIONS(4282),
    [anon_sym_u2260] = ACTIONS(4280),
    [anon_sym_LT] = ACTIONS(4282),
    [sym_gt] = ACTIONS(4282),
    [anon_sym_LT_EQ] = ACTIONS(4282),
    [anon_sym_EQ_LT] = ACTIONS(4280),
    [anon_sym_BSLASHleq] = ACTIONS(4280),
    [anon_sym_u2264] = ACTIONS(4280),
    [anon_sym_GT_EQ] = ACTIONS(4280),
    [anon_sym_BSLASHgeq] = ACTIONS(4280),
    [anon_sym_u2265] = ACTIONS(4280),
    [anon_sym_BSLASHapprox] = ACTIONS(4280),
    [anon_sym_u2248] = ACTIONS(4280),
    [anon_sym_PIPE_DASH] = ACTIONS(4280),
    [anon_sym_u22a2] = ACTIONS(4280),
    [anon_sym_PIPE_EQ] = ACTIONS(4280),
    [anon_sym_u22a8] = ACTIONS(4280),
    [anon_sym_DASH_PIPE] = ACTIONS(4280),
    [anon_sym_u22a3] = ACTIONS(4280),
    [anon_sym_EQ_PIPE] = ACTIONS(4280),
    [anon_sym_u2ae4] = ACTIONS(4280),
    [anon_sym_BSLASHasymp] = ACTIONS(4280),
    [anon_sym_u224d] = ACTIONS(4280),
    [anon_sym_BSLASHcong] = ACTIONS(4280),
    [anon_sym_u2245] = ACTIONS(4280),
    [anon_sym_BSLASHdoteq] = ACTIONS(4280),
    [anon_sym_u2250] = ACTIONS(4280),
    [anon_sym_BSLASHgg] = ACTIONS(4280),
    [anon_sym_u226b] = ACTIONS(4280),
    [anon_sym_BSLASHll] = ACTIONS(4280),
    [anon_sym_u226a] = ACTIONS(4280),
    [anon_sym_BSLASHnotin] = ACTIONS(4280),
    [anon_sym_u2209] = ACTIONS(4280),
    [anon_sym_BSLASHprec] = ACTIONS(4282),
    [anon_sym_u227a] = ACTIONS(4280),
    [anon_sym_BSLASHsucc] = ACTIONS(4282),
    [anon_sym_u227b] = ACTIONS(4280),
    [anon_sym_BSLASHpreceq] = ACTIONS(4280),
    [anon_sym_u2aaf] = ACTIONS(4280),
    [anon_sym_BSLASHsucceq] = ACTIONS(4280),
    [anon_sym_u2ab0] = ACTIONS(4280),
    [anon_sym_BSLASHpropto] = ACTIONS(4280),
    [anon_sym_u221d] = ACTIONS(4280),
    [anon_sym_BSLASHsim] = ACTIONS(4282),
    [anon_sym_u223c] = ACTIONS(4280),
    [anon_sym_BSLASHsimeq] = ACTIONS(4280),
    [anon_sym_u2243] = ACTIONS(4280),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4282),
    [anon_sym_u228f] = ACTIONS(4280),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4282),
    [anon_sym_u2290] = ACTIONS(4280),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4280),
    [anon_sym_u2291] = ACTIONS(4280),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4280),
    [anon_sym_u2292] = ACTIONS(4280),
    [anon_sym_BSLASHsubset] = ACTIONS(4282),
    [anon_sym_u2282] = ACTIONS(4280),
    [anon_sym_BSLASHsupset] = ACTIONS(4282),
    [anon_sym_u2283] = ACTIONS(4280),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4280),
    [anon_sym_u2286] = ACTIONS(4280),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4280),
    [anon_sym_u2287] = ACTIONS(4280),
    [sym_compose] = ACTIONS(4280),
    [sym_map_to] = ACTIONS(4280),
    [sym_map_from] = ACTIONS(4280),
    [sym_setminus] = ACTIONS(4282),
    [anon_sym_BSLASHcap] = ACTIONS(4280),
    [anon_sym_BSLASHintersect] = ACTIONS(4280),
    [anon_sym_u2229] = ACTIONS(4280),
    [anon_sym_BSLASHcup] = ACTIONS(4280),
    [anon_sym_BSLASHunion] = ACTIONS(4280),
    [anon_sym_u222a] = ACTIONS(4280),
    [anon_sym_DOT_DOT] = ACTIONS(4282),
    [anon_sym_u2025] = ACTIONS(4280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4280),
    [anon_sym_u2026] = ACTIONS(4280),
    [anon_sym_PLUS] = ACTIONS(4282),
    [sym_plusplus] = ACTIONS(4280),
    [anon_sym_BSLASHoplus] = ACTIONS(4280),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4280),
    [anon_sym_u2295] = ACTIONS(4280),
    [anon_sym_BSLASHominus] = ACTIONS(4280),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4280),
    [anon_sym_u2296] = ACTIONS(4280),
    [sym_mod] = ACTIONS(4282),
    [sym_modmod] = ACTIONS(4280),
    [sym_vert] = ACTIONS(4282),
    [anon_sym_PIPE_PIPE] = ACTIONS(4280),
    [anon_sym_u2016] = ACTIONS(4280),
    [sym_minusminus] = ACTIONS(4282),
    [sym_amp] = ACTIONS(4282),
    [sym_ampamp] = ACTIONS(4280),
    [anon_sym_BSLASHodot] = ACTIONS(4280),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4280),
    [anon_sym_u2299] = ACTIONS(4280),
    [anon_sym_BSLASHoslash] = ACTIONS(4280),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4280),
    [anon_sym_u2298] = ACTIONS(4280),
    [anon_sym_BSLASHotimes] = ACTIONS(4280),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4280),
    [anon_sym_u2297] = ACTIONS(4280),
    [sym_mul] = ACTIONS(4282),
    [sym_mulmul] = ACTIONS(4280),
    [sym_slash] = ACTIONS(4282),
    [sym_slashslash] = ACTIONS(4280),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4280),
    [anon_sym_u25ef] = ACTIONS(4280),
    [anon_sym_BSLASHbullet] = ACTIONS(4280),
    [anon_sym_u25cf] = ACTIONS(4280),
    [anon_sym_BSLASHdiv] = ACTIONS(4280),
    [anon_sym_u00f7] = ACTIONS(4280),
    [anon_sym_BSLASHcirc] = ACTIONS(4280),
    [anon_sym_u2218] = ACTIONS(4280),
    [anon_sym_BSLASHstar] = ACTIONS(4280),
    [anon_sym_u22c6] = ACTIONS(4280),
    [anon_sym_u203c] = ACTIONS(4280),
    [sym_hashhash] = ACTIONS(4280),
    [sym_dol] = ACTIONS(4282),
    [sym_doldol] = ACTIONS(4280),
    [anon_sym_QMARK_QMARK] = ACTIONS(4280),
    [anon_sym_u2047] = ACTIONS(4280),
    [anon_sym_BSLASHsqcap] = ACTIONS(4280),
    [anon_sym_u2293] = ACTIONS(4280),
    [anon_sym_BSLASHsqcup] = ACTIONS(4280),
    [anon_sym_u2294] = ACTIONS(4280),
    [anon_sym_BSLASHuplus] = ACTIONS(4280),
    [anon_sym_u228e] = ACTIONS(4280),
    [anon_sym_BSLASHX] = ACTIONS(4280),
    [anon_sym_BSLASHtimes] = ACTIONS(4280),
    [anon_sym_u00d7] = ACTIONS(4280),
    [anon_sym_BSLASHwr] = ACTIONS(4280),
    [anon_sym_u2240] = ACTIONS(4280),
    [anon_sym_BSLASHcdot] = ACTIONS(4280),
    [anon_sym_u22c5] = ACTIONS(4280),
    [sym_pow] = ACTIONS(4282),
    [sym_powpow] = ACTIONS(4280),
    [anon_sym_CARET_PLUS] = ACTIONS(4280),
    [anon_sym_u207a] = ACTIONS(4280),
    [sym_asterisk] = ACTIONS(4280),
    [sym_sup_hash] = ACTIONS(4280),
    [sym_prime] = ACTIONS(4280),
    [anon_sym_ASSUME] = ACTIONS(4282),
    [anon_sym_ASSUMPTION] = ACTIONS(4282),
    [anon_sym_AXIOM] = ACTIONS(4282),
    [anon_sym_THEOREM] = ACTIONS(4282),
    [anon_sym_PROPOSITION] = ACTIONS(4282),
    [anon_sym_LEMMA] = ACTIONS(4282),
    [anon_sym_COROLLARY] = ACTIONS(4282),
    [anon_sym_USE] = ACTIONS(4282),
    [anon_sym_HIDE] = ACTIONS(4282),
    [sym__indent] = ACTIONS(4280),
    [sym__double_excl] = ACTIONS(4280),
  },
  [1632] = {
    [sym_block_comment] = STATE(1632),
    [sym_identifier] = ACTIONS(4286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4284),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(4284),
    [anon_sym_BSLASHin] = ACTIONS(4286),
    [anon_sym_u2208] = ACTIONS(4284),
    [anon_sym_BSLASHA] = ACTIONS(4286),
    [anon_sym_BSLASHforall] = ACTIONS(4284),
    [anon_sym_u2200] = ACTIONS(4284),
    [anon_sym_BSLASHE] = ACTIONS(4286),
    [anon_sym_BSLASHexists] = ACTIONS(4284),
    [anon_sym_u2203] = ACTIONS(4284),
    [sym_temporal_forall] = ACTIONS(4284),
    [sym_temporal_exists] = ACTIONS(4284),
    [anon_sym_LT_LT] = ACTIONS(4284),
    [anon_sym_u3008] = ACTIONS(4284),
    [anon_sym_u27e8] = ACTIONS(4284),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4284),
    [anon_sym_u25a1] = ACTIONS(4284),
    [anon_sym_AT] = ACTIONS(4286),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4284),
    [anon_sym_u2227] = ACTIONS(4284),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4284),
    [anon_sym_u2228] = ACTIONS(4284),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_LOCAL] = ACTIONS(4286),
    [anon_sym_VARIABLE] = ACTIONS(4286),
    [anon_sym_VARIABLES] = ACTIONS(4286),
    [anon_sym_CONSTANT] = ACTIONS(4286),
    [anon_sym_CONSTANTS] = ACTIONS(4286),
    [anon_sym_RECURSIVE] = ACTIONS(4286),
    [anon_sym_LPAREN] = ACTIONS(4286),
    [anon_sym_LBRACK] = ACTIONS(4286),
    [anon_sym_INSTANCE] = ACTIONS(4286),
    [anon_sym_BANG] = ACTIONS(4284),
    [aux_sym_child_id_token1] = ACTIONS(4286),
    [sym_real_number] = ACTIONS(4284),
    [anon_sym_BSLASHb] = ACTIONS(4286),
    [anon_sym_BSLASHB] = ACTIONS(4284),
    [anon_sym_BSLASHo] = ACTIONS(4286),
    [anon_sym_BSLASHO] = ACTIONS(4284),
    [anon_sym_BSLASHh] = ACTIONS(4284),
    [anon_sym_BSLASHH] = ACTIONS(4284),
    [anon_sym_DQUOTE] = ACTIONS(4284),
    [anon_sym_TRUE] = ACTIONS(4286),
    [anon_sym_FALSE] = ACTIONS(4286),
    [sym_string_set] = ACTIONS(4286),
    [sym_boolean_set] = ACTIONS(4286),
    [anon_sym_Nat] = ACTIONS(4286),
    [anon_sym_u2115] = ACTIONS(4284),
    [anon_sym_Int] = ACTIONS(4286),
    [anon_sym_u2124] = ACTIONS(4284),
    [anon_sym_Real] = ACTIONS(4286),
    [anon_sym_u211d] = ACTIONS(4284),
    [anon_sym_CHOOSE] = ACTIONS(4286),
    [anon_sym_LBRACE] = ACTIONS(4284),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_WF_] = ACTIONS(4286),
    [anon_sym_SF_] = ACTIONS(4286),
    [anon_sym_IF] = ACTIONS(4286),
    [anon_sym_CASE] = ACTIONS(4286),
    [anon_sym_LET] = ACTIONS(4286),
    [anon_sym_BSLASHlnot] = ACTIONS(4284),
    [anon_sym_BSLASHneg] = ACTIONS(4284),
    [anon_sym_TILDE] = ACTIONS(4286),
    [anon_sym_u00ac] = ACTIONS(4284),
    [sym_union] = ACTIONS(4286),
    [sym_powerset] = ACTIONS(4286),
    [sym_domain] = ACTIONS(4286),
    [anon_sym_DASH] = ACTIONS(4286),
    [sym_negative_dot] = ACTIONS(4284),
    [sym_enabled] = ACTIONS(4286),
    [sym_unchanged] = ACTIONS(4286),
    [anon_sym_LT_GT] = ACTIONS(4284),
    [anon_sym_u22c4] = ACTIONS(4284),
    [anon_sym_u25c7] = ACTIONS(4284),
    [anon_sym_EQ_GT] = ACTIONS(4284),
    [anon_sym_u27f9] = ACTIONS(4284),
    [anon_sym_u21d2] = ACTIONS(4284),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4284),
    [anon_sym_u21f8] = ACTIONS(4284),
    [anon_sym_u2945] = ACTIONS(4284),
    [anon_sym_BSLASHequiv] = ACTIONS(4284),
    [anon_sym_u2261] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4284),
    [anon_sym_u27fa] = ACTIONS(4284),
    [anon_sym_u21d4] = ACTIONS(4284),
    [anon_sym_TILDE_GT] = ACTIONS(4284),
    [anon_sym_u21dd] = ACTIONS(4284),
    [anon_sym_u219d] = ACTIONS(4284),
    [anon_sym_BSLASHland] = ACTIONS(4284),
    [anon_sym_BSLASHlor] = ACTIONS(4284),
    [anon_sym_COLON_EQ] = ACTIONS(4284),
    [anon_sym_u2254] = ACTIONS(4284),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4284),
    [anon_sym_u2a74] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_POUND] = ACTIONS(4286),
    [anon_sym_u2260] = ACTIONS(4284),
    [anon_sym_LT] = ACTIONS(4286),
    [sym_gt] = ACTIONS(4286),
    [anon_sym_LT_EQ] = ACTIONS(4286),
    [anon_sym_EQ_LT] = ACTIONS(4284),
    [anon_sym_BSLASHleq] = ACTIONS(4284),
    [anon_sym_u2264] = ACTIONS(4284),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_BSLASHgeq] = ACTIONS(4284),
    [anon_sym_u2265] = ACTIONS(4284),
    [anon_sym_BSLASHapprox] = ACTIONS(4284),
    [anon_sym_u2248] = ACTIONS(4284),
    [anon_sym_PIPE_DASH] = ACTIONS(4284),
    [anon_sym_u22a2] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_u22a8] = ACTIONS(4284),
    [anon_sym_DASH_PIPE] = ACTIONS(4284),
    [anon_sym_u22a3] = ACTIONS(4284),
    [anon_sym_EQ_PIPE] = ACTIONS(4284),
    [anon_sym_u2ae4] = ACTIONS(4284),
    [anon_sym_BSLASHasymp] = ACTIONS(4284),
    [anon_sym_u224d] = ACTIONS(4284),
    [anon_sym_BSLASHcong] = ACTIONS(4284),
    [anon_sym_u2245] = ACTIONS(4284),
    [anon_sym_BSLASHdoteq] = ACTIONS(4284),
    [anon_sym_u2250] = ACTIONS(4284),
    [anon_sym_BSLASHgg] = ACTIONS(4284),
    [anon_sym_u226b] = ACTIONS(4284),
    [anon_sym_BSLASHll] = ACTIONS(4284),
    [anon_sym_u226a] = ACTIONS(4284),
    [anon_sym_BSLASHnotin] = ACTIONS(4284),
    [anon_sym_u2209] = ACTIONS(4284),
    [anon_sym_BSLASHprec] = ACTIONS(4286),
    [anon_sym_u227a] = ACTIONS(4284),
    [anon_sym_BSLASHsucc] = ACTIONS(4286),
    [anon_sym_u227b] = ACTIONS(4284),
    [anon_sym_BSLASHpreceq] = ACTIONS(4284),
    [anon_sym_u2aaf] = ACTIONS(4284),
    [anon_sym_BSLASHsucceq] = ACTIONS(4284),
    [anon_sym_u2ab0] = ACTIONS(4284),
    [anon_sym_BSLASHpropto] = ACTIONS(4284),
    [anon_sym_u221d] = ACTIONS(4284),
    [anon_sym_BSLASHsim] = ACTIONS(4286),
    [anon_sym_u223c] = ACTIONS(4284),
    [anon_sym_BSLASHsimeq] = ACTIONS(4284),
    [anon_sym_u2243] = ACTIONS(4284),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4286),
    [anon_sym_u228f] = ACTIONS(4284),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4286),
    [anon_sym_u2290] = ACTIONS(4284),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4284),
    [anon_sym_u2291] = ACTIONS(4284),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4284),
    [anon_sym_u2292] = ACTIONS(4284),
    [anon_sym_BSLASHsubset] = ACTIONS(4286),
    [anon_sym_u2282] = ACTIONS(4284),
    [anon_sym_BSLASHsupset] = ACTIONS(4286),
    [anon_sym_u2283] = ACTIONS(4284),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4284),
    [anon_sym_u2286] = ACTIONS(4284),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4284),
    [anon_sym_u2287] = ACTIONS(4284),
    [sym_compose] = ACTIONS(4284),
    [sym_map_to] = ACTIONS(4284),
    [sym_map_from] = ACTIONS(4284),
    [sym_setminus] = ACTIONS(4286),
    [anon_sym_BSLASHcap] = ACTIONS(4284),
    [anon_sym_BSLASHintersect] = ACTIONS(4284),
    [anon_sym_u2229] = ACTIONS(4284),
    [anon_sym_BSLASHcup] = ACTIONS(4284),
    [anon_sym_BSLASHunion] = ACTIONS(4284),
    [anon_sym_u222a] = ACTIONS(4284),
    [anon_sym_DOT_DOT] = ACTIONS(4286),
    [anon_sym_u2025] = ACTIONS(4284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4284),
    [anon_sym_u2026] = ACTIONS(4284),
    [anon_sym_PLUS] = ACTIONS(4286),
    [sym_plusplus] = ACTIONS(4284),
    [anon_sym_BSLASHoplus] = ACTIONS(4284),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4284),
    [anon_sym_u2295] = ACTIONS(4284),
    [anon_sym_BSLASHominus] = ACTIONS(4284),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4284),
    [anon_sym_u2296] = ACTIONS(4284),
    [sym_mod] = ACTIONS(4286),
    [sym_modmod] = ACTIONS(4284),
    [sym_vert] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_u2016] = ACTIONS(4284),
    [sym_minusminus] = ACTIONS(4286),
    [sym_amp] = ACTIONS(4286),
    [sym_ampamp] = ACTIONS(4284),
    [anon_sym_BSLASHodot] = ACTIONS(4284),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4284),
    [anon_sym_u2299] = ACTIONS(4284),
    [anon_sym_BSLASHoslash] = ACTIONS(4284),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4284),
    [anon_sym_u2298] = ACTIONS(4284),
    [anon_sym_BSLASHotimes] = ACTIONS(4284),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4284),
    [anon_sym_u2297] = ACTIONS(4284),
    [sym_mul] = ACTIONS(4286),
    [sym_mulmul] = ACTIONS(4284),
    [sym_slash] = ACTIONS(4286),
    [sym_slashslash] = ACTIONS(4284),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4284),
    [anon_sym_u25ef] = ACTIONS(4284),
    [anon_sym_BSLASHbullet] = ACTIONS(4284),
    [anon_sym_u25cf] = ACTIONS(4284),
    [anon_sym_BSLASHdiv] = ACTIONS(4284),
    [anon_sym_u00f7] = ACTIONS(4284),
    [anon_sym_BSLASHcirc] = ACTIONS(4284),
    [anon_sym_u2218] = ACTIONS(4284),
    [anon_sym_BSLASHstar] = ACTIONS(4284),
    [anon_sym_u22c6] = ACTIONS(4284),
    [anon_sym_u203c] = ACTIONS(4284),
    [sym_hashhash] = ACTIONS(4284),
    [sym_dol] = ACTIONS(4286),
    [sym_doldol] = ACTIONS(4284),
    [anon_sym_QMARK_QMARK] = ACTIONS(4284),
    [anon_sym_u2047] = ACTIONS(4284),
    [anon_sym_BSLASHsqcap] = ACTIONS(4284),
    [anon_sym_u2293] = ACTIONS(4284),
    [anon_sym_BSLASHsqcup] = ACTIONS(4284),
    [anon_sym_u2294] = ACTIONS(4284),
    [anon_sym_BSLASHuplus] = ACTIONS(4284),
    [anon_sym_u228e] = ACTIONS(4284),
    [anon_sym_BSLASHX] = ACTIONS(4284),
    [anon_sym_BSLASHtimes] = ACTIONS(4284),
    [anon_sym_u00d7] = ACTIONS(4284),
    [anon_sym_BSLASHwr] = ACTIONS(4284),
    [anon_sym_u2240] = ACTIONS(4284),
    [anon_sym_BSLASHcdot] = ACTIONS(4284),
    [anon_sym_u22c5] = ACTIONS(4284),
    [sym_pow] = ACTIONS(4286),
    [sym_powpow] = ACTIONS(4284),
    [anon_sym_CARET_PLUS] = ACTIONS(4284),
    [anon_sym_u207a] = ACTIONS(4284),
    [sym_asterisk] = ACTIONS(4284),
    [sym_sup_hash] = ACTIONS(4284),
    [sym_prime] = ACTIONS(4284),
    [anon_sym_ASSUME] = ACTIONS(4286),
    [anon_sym_ASSUMPTION] = ACTIONS(4286),
    [anon_sym_AXIOM] = ACTIONS(4286),
    [anon_sym_THEOREM] = ACTIONS(4286),
    [anon_sym_PROPOSITION] = ACTIONS(4286),
    [anon_sym_LEMMA] = ACTIONS(4286),
    [anon_sym_COROLLARY] = ACTIONS(4286),
    [anon_sym_USE] = ACTIONS(4286),
    [anon_sym_HIDE] = ACTIONS(4286),
    [sym__indent] = ACTIONS(4284),
    [sym__double_excl] = ACTIONS(4284),
  },
  [1633] = {
    [sym_block_comment] = STATE(1633),
    [sym_identifier] = ACTIONS(4290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4288),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(4288),
    [anon_sym_BSLASHin] = ACTIONS(4290),
    [anon_sym_u2208] = ACTIONS(4288),
    [anon_sym_BSLASHA] = ACTIONS(4290),
    [anon_sym_BSLASHforall] = ACTIONS(4288),
    [anon_sym_u2200] = ACTIONS(4288),
    [anon_sym_BSLASHE] = ACTIONS(4290),
    [anon_sym_BSLASHexists] = ACTIONS(4288),
    [anon_sym_u2203] = ACTIONS(4288),
    [sym_temporal_forall] = ACTIONS(4288),
    [sym_temporal_exists] = ACTIONS(4288),
    [anon_sym_LT_LT] = ACTIONS(4288),
    [anon_sym_u3008] = ACTIONS(4288),
    [anon_sym_u27e8] = ACTIONS(4288),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4288),
    [anon_sym_u25a1] = ACTIONS(4288),
    [anon_sym_AT] = ACTIONS(4290),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4288),
    [anon_sym_u2227] = ACTIONS(4288),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4288),
    [anon_sym_u2228] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_LOCAL] = ACTIONS(4290),
    [anon_sym_VARIABLE] = ACTIONS(4290),
    [anon_sym_VARIABLES] = ACTIONS(4290),
    [anon_sym_CONSTANT] = ACTIONS(4290),
    [anon_sym_CONSTANTS] = ACTIONS(4290),
    [anon_sym_RECURSIVE] = ACTIONS(4290),
    [anon_sym_LPAREN] = ACTIONS(4290),
    [anon_sym_LBRACK] = ACTIONS(4290),
    [anon_sym_INSTANCE] = ACTIONS(4290),
    [anon_sym_BANG] = ACTIONS(4288),
    [aux_sym_child_id_token1] = ACTIONS(4290),
    [sym_real_number] = ACTIONS(4288),
    [anon_sym_BSLASHb] = ACTIONS(4290),
    [anon_sym_BSLASHB] = ACTIONS(4288),
    [anon_sym_BSLASHo] = ACTIONS(4290),
    [anon_sym_BSLASHO] = ACTIONS(4288),
    [anon_sym_BSLASHh] = ACTIONS(4288),
    [anon_sym_BSLASHH] = ACTIONS(4288),
    [anon_sym_DQUOTE] = ACTIONS(4288),
    [anon_sym_TRUE] = ACTIONS(4290),
    [anon_sym_FALSE] = ACTIONS(4290),
    [sym_string_set] = ACTIONS(4290),
    [sym_boolean_set] = ACTIONS(4290),
    [anon_sym_Nat] = ACTIONS(4290),
    [anon_sym_u2115] = ACTIONS(4288),
    [anon_sym_Int] = ACTIONS(4290),
    [anon_sym_u2124] = ACTIONS(4288),
    [anon_sym_Real] = ACTIONS(4290),
    [anon_sym_u211d] = ACTIONS(4288),
    [anon_sym_CHOOSE] = ACTIONS(4290),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_WF_] = ACTIONS(4290),
    [anon_sym_SF_] = ACTIONS(4290),
    [anon_sym_IF] = ACTIONS(4290),
    [anon_sym_CASE] = ACTIONS(4290),
    [anon_sym_LET] = ACTIONS(4290),
    [anon_sym_BSLASHlnot] = ACTIONS(4288),
    [anon_sym_BSLASHneg] = ACTIONS(4288),
    [anon_sym_TILDE] = ACTIONS(4290),
    [anon_sym_u00ac] = ACTIONS(4288),
    [sym_union] = ACTIONS(4290),
    [sym_powerset] = ACTIONS(4290),
    [sym_domain] = ACTIONS(4290),
    [anon_sym_DASH] = ACTIONS(4290),
    [sym_negative_dot] = ACTIONS(4288),
    [sym_enabled] = ACTIONS(4290),
    [sym_unchanged] = ACTIONS(4290),
    [anon_sym_LT_GT] = ACTIONS(4288),
    [anon_sym_u22c4] = ACTIONS(4288),
    [anon_sym_u25c7] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_u27f9] = ACTIONS(4288),
    [anon_sym_u21d2] = ACTIONS(4288),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4288),
    [anon_sym_u21f8] = ACTIONS(4288),
    [anon_sym_u2945] = ACTIONS(4288),
    [anon_sym_BSLASHequiv] = ACTIONS(4288),
    [anon_sym_u2261] = ACTIONS(4288),
    [anon_sym_LT_EQ_GT] = ACTIONS(4288),
    [anon_sym_u27fa] = ACTIONS(4288),
    [anon_sym_u21d4] = ACTIONS(4288),
    [anon_sym_TILDE_GT] = ACTIONS(4288),
    [anon_sym_u21dd] = ACTIONS(4288),
    [anon_sym_u219d] = ACTIONS(4288),
    [anon_sym_BSLASHland] = ACTIONS(4288),
    [anon_sym_BSLASHlor] = ACTIONS(4288),
    [anon_sym_COLON_EQ] = ACTIONS(4288),
    [anon_sym_u2254] = ACTIONS(4288),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4288),
    [anon_sym_u2a74] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_POUND] = ACTIONS(4290),
    [anon_sym_u2260] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4290),
    [sym_gt] = ACTIONS(4290),
    [anon_sym_LT_EQ] = ACTIONS(4290),
    [anon_sym_EQ_LT] = ACTIONS(4288),
    [anon_sym_BSLASHleq] = ACTIONS(4288),
    [anon_sym_u2264] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(4288),
    [anon_sym_BSLASHgeq] = ACTIONS(4288),
    [anon_sym_u2265] = ACTIONS(4288),
    [anon_sym_BSLASHapprox] = ACTIONS(4288),
    [anon_sym_u2248] = ACTIONS(4288),
    [anon_sym_PIPE_DASH] = ACTIONS(4288),
    [anon_sym_u22a2] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_u22a8] = ACTIONS(4288),
    [anon_sym_DASH_PIPE] = ACTIONS(4288),
    [anon_sym_u22a3] = ACTIONS(4288),
    [anon_sym_EQ_PIPE] = ACTIONS(4288),
    [anon_sym_u2ae4] = ACTIONS(4288),
    [anon_sym_BSLASHasymp] = ACTIONS(4288),
    [anon_sym_u224d] = ACTIONS(4288),
    [anon_sym_BSLASHcong] = ACTIONS(4288),
    [anon_sym_u2245] = ACTIONS(4288),
    [anon_sym_BSLASHdoteq] = ACTIONS(4288),
    [anon_sym_u2250] = ACTIONS(4288),
    [anon_sym_BSLASHgg] = ACTIONS(4288),
    [anon_sym_u226b] = ACTIONS(4288),
    [anon_sym_BSLASHll] = ACTIONS(4288),
    [anon_sym_u226a] = ACTIONS(4288),
    [anon_sym_BSLASHnotin] = ACTIONS(4288),
    [anon_sym_u2209] = ACTIONS(4288),
    [anon_sym_BSLASHprec] = ACTIONS(4290),
    [anon_sym_u227a] = ACTIONS(4288),
    [anon_sym_BSLASHsucc] = ACTIONS(4290),
    [anon_sym_u227b] = ACTIONS(4288),
    [anon_sym_BSLASHpreceq] = ACTIONS(4288),
    [anon_sym_u2aaf] = ACTIONS(4288),
    [anon_sym_BSLASHsucceq] = ACTIONS(4288),
    [anon_sym_u2ab0] = ACTIONS(4288),
    [anon_sym_BSLASHpropto] = ACTIONS(4288),
    [anon_sym_u221d] = ACTIONS(4288),
    [anon_sym_BSLASHsim] = ACTIONS(4290),
    [anon_sym_u223c] = ACTIONS(4288),
    [anon_sym_BSLASHsimeq] = ACTIONS(4288),
    [anon_sym_u2243] = ACTIONS(4288),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4290),
    [anon_sym_u228f] = ACTIONS(4288),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4290),
    [anon_sym_u2290] = ACTIONS(4288),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4288),
    [anon_sym_u2291] = ACTIONS(4288),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4288),
    [anon_sym_u2292] = ACTIONS(4288),
    [anon_sym_BSLASHsubset] = ACTIONS(4290),
    [anon_sym_u2282] = ACTIONS(4288),
    [anon_sym_BSLASHsupset] = ACTIONS(4290),
    [anon_sym_u2283] = ACTIONS(4288),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4288),
    [anon_sym_u2286] = ACTIONS(4288),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4288),
    [anon_sym_u2287] = ACTIONS(4288),
    [sym_compose] = ACTIONS(4288),
    [sym_map_to] = ACTIONS(4288),
    [sym_map_from] = ACTIONS(4288),
    [sym_setminus] = ACTIONS(4290),
    [anon_sym_BSLASHcap] = ACTIONS(4288),
    [anon_sym_BSLASHintersect] = ACTIONS(4288),
    [anon_sym_u2229] = ACTIONS(4288),
    [anon_sym_BSLASHcup] = ACTIONS(4288),
    [anon_sym_BSLASHunion] = ACTIONS(4288),
    [anon_sym_u222a] = ACTIONS(4288),
    [anon_sym_DOT_DOT] = ACTIONS(4290),
    [anon_sym_u2025] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4288),
    [anon_sym_u2026] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(4290),
    [sym_plusplus] = ACTIONS(4288),
    [anon_sym_BSLASHoplus] = ACTIONS(4288),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4288),
    [anon_sym_u2295] = ACTIONS(4288),
    [anon_sym_BSLASHominus] = ACTIONS(4288),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4288),
    [anon_sym_u2296] = ACTIONS(4288),
    [sym_mod] = ACTIONS(4290),
    [sym_modmod] = ACTIONS(4288),
    [sym_vert] = ACTIONS(4290),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_u2016] = ACTIONS(4288),
    [sym_minusminus] = ACTIONS(4290),
    [sym_amp] = ACTIONS(4290),
    [sym_ampamp] = ACTIONS(4288),
    [anon_sym_BSLASHodot] = ACTIONS(4288),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4288),
    [anon_sym_u2299] = ACTIONS(4288),
    [anon_sym_BSLASHoslash] = ACTIONS(4288),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4288),
    [anon_sym_u2298] = ACTIONS(4288),
    [anon_sym_BSLASHotimes] = ACTIONS(4288),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4288),
    [anon_sym_u2297] = ACTIONS(4288),
    [sym_mul] = ACTIONS(4290),
    [sym_mulmul] = ACTIONS(4288),
    [sym_slash] = ACTIONS(4290),
    [sym_slashslash] = ACTIONS(4288),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4288),
    [anon_sym_u25ef] = ACTIONS(4288),
    [anon_sym_BSLASHbullet] = ACTIONS(4288),
    [anon_sym_u25cf] = ACTIONS(4288),
    [anon_sym_BSLASHdiv] = ACTIONS(4288),
    [anon_sym_u00f7] = ACTIONS(4288),
    [anon_sym_BSLASHcirc] = ACTIONS(4288),
    [anon_sym_u2218] = ACTIONS(4288),
    [anon_sym_BSLASHstar] = ACTIONS(4288),
    [anon_sym_u22c6] = ACTIONS(4288),
    [anon_sym_u203c] = ACTIONS(4288),
    [sym_hashhash] = ACTIONS(4288),
    [sym_dol] = ACTIONS(4290),
    [sym_doldol] = ACTIONS(4288),
    [anon_sym_QMARK_QMARK] = ACTIONS(4288),
    [anon_sym_u2047] = ACTIONS(4288),
    [anon_sym_BSLASHsqcap] = ACTIONS(4288),
    [anon_sym_u2293] = ACTIONS(4288),
    [anon_sym_BSLASHsqcup] = ACTIONS(4288),
    [anon_sym_u2294] = ACTIONS(4288),
    [anon_sym_BSLASHuplus] = ACTIONS(4288),
    [anon_sym_u228e] = ACTIONS(4288),
    [anon_sym_BSLASHX] = ACTIONS(4288),
    [anon_sym_BSLASHtimes] = ACTIONS(4288),
    [anon_sym_u00d7] = ACTIONS(4288),
    [anon_sym_BSLASHwr] = ACTIONS(4288),
    [anon_sym_u2240] = ACTIONS(4288),
    [anon_sym_BSLASHcdot] = ACTIONS(4288),
    [anon_sym_u22c5] = ACTIONS(4288),
    [sym_pow] = ACTIONS(4290),
    [sym_powpow] = ACTIONS(4288),
    [anon_sym_CARET_PLUS] = ACTIONS(4288),
    [anon_sym_u207a] = ACTIONS(4288),
    [sym_asterisk] = ACTIONS(4288),
    [sym_sup_hash] = ACTIONS(4288),
    [sym_prime] = ACTIONS(4288),
    [anon_sym_ASSUME] = ACTIONS(4290),
    [anon_sym_ASSUMPTION] = ACTIONS(4290),
    [anon_sym_AXIOM] = ACTIONS(4290),
    [anon_sym_THEOREM] = ACTIONS(4290),
    [anon_sym_PROPOSITION] = ACTIONS(4290),
    [anon_sym_LEMMA] = ACTIONS(4290),
    [anon_sym_COROLLARY] = ACTIONS(4290),
    [anon_sym_USE] = ACTIONS(4290),
    [anon_sym_HIDE] = ACTIONS(4290),
    [sym__indent] = ACTIONS(4288),
    [sym__double_excl] = ACTIONS(4288),
  },
  [1634] = {
    [sym_block_comment] = STATE(1634),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(300),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_pcal_assign_repeat1] = STATE(3915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4292),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_end] = ACTIONS(4292),
    [anon_sym_SEMI] = ACTIONS(4292),
    [anon_sym_elsif] = ACTIONS(4292),
    [anon_sym_else] = ACTIONS(4292),
    [anon_sym_or] = ACTIONS(4292),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1635] = {
    [sym_block_comment] = STATE(1635),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27f6] = ACTIONS(3491),
    [anon_sym_u2192] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4236),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(3491),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_RBRACK_] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1636] = {
    [sym_block_comment] = STATE(1636),
    [sym_maps_to] = STATE(813),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4298),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4300),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1637] = {
    [sym_block_comment] = STATE(1637),
    [sym_maps_to] = STATE(1052),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4302),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4304),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1638] = {
    [sym_block_comment] = STATE(1638),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_u3009] = ACTIONS(3491),
    [anon_sym_u27e9] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1639] = {
    [sym_block_comment] = STATE(1639),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3499),
    [anon_sym_u27fc] = ACTIONS(3499),
    [anon_sym_u21a6] = ACTIONS(3499),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1640] = {
    [sym_block_comment] = STATE(1640),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27fc] = ACTIONS(3491),
    [anon_sym_u21a6] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3493),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1641] = {
    [sym_block_comment] = STATE(1641),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27fc] = ACTIONS(3491),
    [anon_sym_u21a6] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3493),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1642] = {
    [sym_block_comment] = STATE(1642),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_u3009] = ACTIONS(3491),
    [anon_sym_u27e9] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1643] = {
    [sym_block_comment] = STATE(1643),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_u3009] = ACTIONS(3491),
    [anon_sym_u27e9] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1644] = {
    [sym_block_comment] = STATE(1644),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_u3009] = ACTIONS(3491),
    [anon_sym_u27e9] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1645] = {
    [sym_block_comment] = STATE(1645),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3537),
    [anon_sym_u3009] = ACTIONS(3537),
    [anon_sym_u27e9] = ACTIONS(3537),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1646] = {
    [sym_block_comment] = STATE(1646),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3541),
    [anon_sym_u3009] = ACTIONS(3541),
    [anon_sym_u27e9] = ACTIONS(3541),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1647] = {
    [sym_block_comment] = STATE(1647),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3529),
    [anon_sym_u27fc] = ACTIONS(3529),
    [anon_sym_u21a6] = ACTIONS(3529),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1648] = {
    [sym_block_comment] = STATE(1648),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3545),
    [anon_sym_u3009] = ACTIONS(3545),
    [anon_sym_u27e9] = ACTIONS(3545),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1649] = {
    [sym_block_comment] = STATE(1649),
    [sym_maps_to] = STATE(856),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4368),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4370),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1650] = {
    [sym_block_comment] = STATE(1650),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4194),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3519),
    [anon_sym_BY] = ACTIONS(3519),
    [anon_sym_OBVIOUS] = ACTIONS(3519),
    [anon_sym_OMITTED] = ACTIONS(3519),
    [sym__begin_proof] = ACTIONS(3519),
    [sym__begin_proof_step] = ACTIONS(3519),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1651] = {
    [sym_block_comment] = STATE(1651),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3495),
    [anon_sym_u27fc] = ACTIONS(3495),
    [anon_sym_u21a6] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3497),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1652] = {
    [sym_block_comment] = STATE(1652),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3553),
    [anon_sym_u3009] = ACTIONS(3553),
    [anon_sym_u27e9] = ACTIONS(3553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1653] = {
    [sym_block_comment] = STATE(1653),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3557),
    [anon_sym_u3009] = ACTIONS(3557),
    [anon_sym_u27e9] = ACTIONS(3557),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1654] = {
    [sym_block_comment] = STATE(1654),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_u3009] = ACTIONS(3511),
    [anon_sym_u27e9] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1655] = {
    [sym_block_comment] = STATE(1655),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_u3009] = ACTIONS(3491),
    [anon_sym_u27e9] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1656] = {
    [sym_block_comment] = STATE(1656),
    [sym_implies] = STATE(499),
    [sym_plus_arrow] = STATE(500),
    [sym_equiv] = STATE(500),
    [sym_iff] = STATE(500),
    [sym_leads_to] = STATE(500),
    [sym_land] = STATE(501),
    [sym_lor] = STATE(501),
    [sym_assign] = STATE(491),
    [sym_bnf_rule] = STATE(491),
    [sym_eq] = STATE(491),
    [sym_neq] = STATE(491),
    [sym_lt] = STATE(491),
    [sym_leq] = STATE(491),
    [sym_geq] = STATE(491),
    [sym_approx] = STATE(491),
    [sym_rs_ttile] = STATE(491),
    [sym_rd_ttile] = STATE(491),
    [sym_ls_ttile] = STATE(491),
    [sym_ld_ttile] = STATE(491),
    [sym_asymp] = STATE(491),
    [sym_cong] = STATE(491),
    [sym_doteq] = STATE(491),
    [sym_gg] = STATE(491),
    [sym_ll] = STATE(491),
    [sym_in] = STATE(491),
    [sym_notin] = STATE(491),
    [sym_prec] = STATE(491),
    [sym_succ] = STATE(491),
    [sym_preceq] = STATE(491),
    [sym_succeq] = STATE(491),
    [sym_propto] = STATE(491),
    [sym_sim] = STATE(491),
    [sym_simeq] = STATE(491),
    [sym_sqsubset] = STATE(491),
    [sym_sqsupset] = STATE(491),
    [sym_sqsubseteq] = STATE(491),
    [sym_sqsupseteq] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_supset] = STATE(491),
    [sym_subseteq] = STATE(491),
    [sym_supseteq] = STATE(491),
    [sym_cap] = STATE(494),
    [sym_cup] = STATE(494),
    [sym_dots_2] = STATE(502),
    [sym_dots_3] = STATE(502),
    [sym_plus] = STATE(495),
    [sym_oplus] = STATE(495),
    [sym_ominus] = STATE(496),
    [sym_vertvert] = STATE(496),
    [sym_minus] = STATE(496),
    [sym_odot] = STATE(497),
    [sym_oslash] = STATE(497),
    [sym_otimes] = STATE(497),
    [sym_bigcirc] = STATE(497),
    [sym_bullet] = STATE(497),
    [sym_div] = STATE(497),
    [sym_circ] = STATE(497),
    [sym_star] = STATE(497),
    [sym_excl] = STATE(497),
    [sym_qq] = STATE(497),
    [sym_sqcap] = STATE(497),
    [sym_sqcup] = STATE(497),
    [sym_uplus] = STATE(497),
    [sym_times] = STATE(497),
    [sym_wr] = STATE(498),
    [sym_cdot] = STATE(498),
    [sym_sup_plus] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4194),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4196),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4198),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4200),
    [sym_map_to] = ACTIONS(4202),
    [sym_map_from] = ACTIONS(4202),
    [sym_setminus] = ACTIONS(4204),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4206),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4208),
    [sym_modmod] = ACTIONS(4210),
    [sym_vert] = ACTIONS(4208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4210),
    [sym_amp] = ACTIONS(4212),
    [sym_ampamp] = ACTIONS(4214),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4212),
    [sym_mulmul] = ACTIONS(4214),
    [sym_slash] = ACTIONS(4212),
    [sym_slashslash] = ACTIONS(4214),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4214),
    [sym_dol] = ACTIONS(4212),
    [sym_doldol] = ACTIONS(4214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4216),
    [sym_powpow] = ACTIONS(4218),
    [anon_sym_CARET_PLUS] = ACTIONS(4220),
    [anon_sym_u207a] = ACTIONS(4220),
    [sym_asterisk] = ACTIONS(4222),
    [sym_sup_hash] = ACTIONS(4222),
    [sym_prime] = ACTIONS(4222),
    [anon_sym_PROOF] = ACTIONS(3549),
    [anon_sym_BY] = ACTIONS(3549),
    [anon_sym_OBVIOUS] = ACTIONS(3549),
    [anon_sym_OMITTED] = ACTIONS(3549),
    [sym__begin_proof] = ACTIONS(3549),
    [sym__begin_proof_step] = ACTIONS(3549),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1657] = {
    [sym_block_comment] = STATE(1657),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_u3009] = ACTIONS(3525),
    [anon_sym_u27e9] = ACTIONS(3525),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1658] = {
    [sym_block_comment] = STATE(1658),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_u3009] = ACTIONS(3529),
    [anon_sym_u27e9] = ACTIONS(3529),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1659] = {
    [sym_block_comment] = STATE(1659),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3499),
    [anon_sym_u3009] = ACTIONS(3499),
    [anon_sym_u27e9] = ACTIONS(3499),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1660] = {
    [sym_block_comment] = STATE(1660),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27fc] = ACTIONS(3491),
    [anon_sym_u21a6] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3493),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1661] = {
    [sym_block_comment] = STATE(1661),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3503),
    [anon_sym_u3009] = ACTIONS(3503),
    [anon_sym_u27e9] = ACTIONS(3503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1662] = {
    [sym_block_comment] = STATE(1662),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3507),
    [anon_sym_u3009] = ACTIONS(3507),
    [anon_sym_u27e9] = ACTIONS(3507),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1663] = {
    [sym_block_comment] = STATE(1663),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27fc] = ACTIONS(3491),
    [anon_sym_u21a6] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3493),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1664] = {
    [sym_block_comment] = STATE(1664),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3515),
    [anon_sym_u3009] = ACTIONS(3515),
    [anon_sym_u27e9] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1665] = {
    [sym_block_comment] = STATE(1665),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_u3009] = ACTIONS(3491),
    [anon_sym_u27e9] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1666] = {
    [sym_block_comment] = STATE(1666),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_u3009] = ACTIONS(3491),
    [anon_sym_u27e9] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1667] = {
    [sym_block_comment] = STATE(1667),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3495),
    [anon_sym_u3009] = ACTIONS(3495),
    [anon_sym_u27e9] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1668] = {
    [sym_block_comment] = STATE(1668),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_u3009] = ACTIONS(3491),
    [anon_sym_u27e9] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1669] = {
    [sym_block_comment] = STATE(1669),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27fc] = ACTIONS(3491),
    [anon_sym_u21a6] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3493),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1670] = {
    [sym_block_comment] = STATE(1670),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_u3009] = ACTIONS(3491),
    [anon_sym_u27e9] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1671] = {
    [sym_block_comment] = STATE(1671),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3495),
    [anon_sym_u27fc] = ACTIONS(3495),
    [anon_sym_u21a6] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1672] = {
    [sym_block_comment] = STATE(1672),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4372),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_end] = ACTIONS(4372),
    [anon_sym_SEMI] = ACTIONS(4372),
    [anon_sym_elsif] = ACTIONS(4372),
    [anon_sym_else] = ACTIONS(4372),
    [anon_sym_or] = ACTIONS(4372),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1673] = {
    [sym_block_comment] = STATE(1673),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4374),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_end] = ACTIONS(4374),
    [anon_sym_SEMI] = ACTIONS(4374),
    [anon_sym_elsif] = ACTIONS(4374),
    [anon_sym_else] = ACTIONS(4374),
    [anon_sym_or] = ACTIONS(4374),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1674] = {
    [sym_block_comment] = STATE(1674),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27fc] = ACTIONS(3491),
    [anon_sym_u21a6] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3493),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1675] = {
    [sym_block_comment] = STATE(1675),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27fc] = ACTIONS(3491),
    [anon_sym_u21a6] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3493),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1676] = {
    [sym_block_comment] = STATE(1676),
    [sym_maps_to] = STATE(827),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4376),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4378),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1677] = {
    [sym_block_comment] = STATE(1677),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3497),
    [anon_sym_DEFS] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1678] = {
    [sym_block_comment] = STATE(1678),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [anon_sym_DEF] = ACTIONS(3497),
    [anon_sym_DEFS] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1679] = {
    [sym_block_comment] = STATE(1679),
    [sym_maps_to] = STATE(842),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4392),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4394),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1680] = {
    [sym_block_comment] = STATE(1680),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27fc] = ACTIONS(3491),
    [anon_sym_u21a6] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1681] = {
    [sym_block_comment] = STATE(1681),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3503),
    [anon_sym_u27fc] = ACTIONS(3503),
    [anon_sym_u21a6] = ACTIONS(3503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1682] = {
    [sym_block_comment] = STATE(1682),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3507),
    [anon_sym_u27fc] = ACTIONS(3507),
    [anon_sym_u21a6] = ACTIONS(3507),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1683] = {
    [sym_block_comment] = STATE(1683),
    [sym_maps_to] = STATE(870),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4396),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4398),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1684] = {
    [sym_block_comment] = STATE(1684),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27fc] = ACTIONS(3491),
    [anon_sym_u21a6] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1685] = {
    [sym_block_comment] = STATE(1685),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3497),
    [anon_sym_DEFS] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1686] = {
    [sym_block_comment] = STATE(1686),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3497),
    [anon_sym_DEFS] = ACTIONS(3495),
    [sym__begin_proof_step] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1687] = {
    [sym_block_comment] = STATE(1687),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_GT_GT] = ACTIONS(3495),
    [anon_sym_u3009] = ACTIONS(3495),
    [anon_sym_u27e9] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1688] = {
    [sym_block_comment] = STATE(1688),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3533),
    [anon_sym_DEFS] = ACTIONS(3531),
    [sym__begin_proof_step] = ACTIONS(3531),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1689] = {
    [sym_block_comment] = STATE(1689),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3531),
    [anon_sym_u27fc] = ACTIONS(3531),
    [anon_sym_u21a6] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1690] = {
    [sym_block_comment] = STATE(1690),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1691] = {
    [sym_block_comment] = STATE(1691),
    [sym_maps_to] = STATE(886),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4418),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1692] = {
    [sym_block_comment] = STATE(1692),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1693] = {
    [sym_block_comment] = STATE(1693),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1694] = {
    [sym_block_comment] = STATE(1694),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1695] = {
    [sym_block_comment] = STATE(1695),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1696] = {
    [sym_block_comment] = STATE(1696),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1697] = {
    [sym_block_comment] = STATE(1697),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1698] = {
    [sym_block_comment] = STATE(1698),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1699] = {
    [sym_block_comment] = STATE(1699),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1700] = {
    [sym_block_comment] = STATE(1700),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1701] = {
    [sym_block_comment] = STATE(1701),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1702] = {
    [sym_block_comment] = STATE(1702),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3493),
    [anon_sym_DEFS] = ACTIONS(3491),
    [sym__begin_proof_step] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1703] = {
    [sym_block_comment] = STATE(1703),
    [sym_maps_to] = STATE(900),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4422),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4424),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1704] = {
    [sym_block_comment] = STATE(1704),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3535),
    [anon_sym_DEFS] = ACTIONS(3537),
    [sym__begin_proof_step] = ACTIONS(3537),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1705] = {
    [sym_block_comment] = STATE(1705),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3539),
    [anon_sym_DEFS] = ACTIONS(3541),
    [sym__begin_proof_step] = ACTIONS(3541),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1706] = {
    [sym_block_comment] = STATE(1706),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3543),
    [anon_sym_DEFS] = ACTIONS(3545),
    [sym__begin_proof_step] = ACTIONS(3545),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1707] = {
    [sym_block_comment] = STATE(1707),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3551),
    [anon_sym_DEFS] = ACTIONS(3553),
    [sym__begin_proof_step] = ACTIONS(3553),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1708] = {
    [sym_block_comment] = STATE(1708),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3555),
    [anon_sym_DEFS] = ACTIONS(3557),
    [sym__begin_proof_step] = ACTIONS(3557),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1709] = {
    [sym_block_comment] = STATE(1709),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3513),
    [anon_sym_DEFS] = ACTIONS(3511),
    [sym__begin_proof_step] = ACTIONS(3511),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1710] = {
    [sym_block_comment] = STATE(1710),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3523),
    [anon_sym_DEFS] = ACTIONS(3525),
    [sym__begin_proof_step] = ACTIONS(3525),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1711] = {
    [sym_block_comment] = STATE(1711),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3527),
    [anon_sym_DEFS] = ACTIONS(3529),
    [sym__begin_proof_step] = ACTIONS(3529),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1712] = {
    [sym_block_comment] = STATE(1712),
    [sym_maps_to] = STATE(916),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4426),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4428),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1713] = {
    [sym_block_comment] = STATE(1713),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3501),
    [anon_sym_DEFS] = ACTIONS(3499),
    [sym__begin_proof_step] = ACTIONS(3499),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1714] = {
    [sym_block_comment] = STATE(1714),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3505),
    [anon_sym_DEFS] = ACTIONS(3503),
    [sym__begin_proof_step] = ACTIONS(3503),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1715] = {
    [sym_block_comment] = STATE(1715),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3509),
    [anon_sym_DEFS] = ACTIONS(3507),
    [sym__begin_proof_step] = ACTIONS(3507),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1716] = {
    [sym_block_comment] = STATE(1716),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3517),
    [anon_sym_DEFS] = ACTIONS(3515),
    [sym__begin_proof_step] = ACTIONS(3515),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1717] = {
    [sym_block_comment] = STATE(1717),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27fc] = ACTIONS(3491),
    [anon_sym_u21a6] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1718] = {
    [sym_block_comment] = STATE(1718),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27fc] = ACTIONS(3491),
    [anon_sym_u21a6] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3493),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1719] = {
    [sym_block_comment] = STATE(1719),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3537),
    [anon_sym_u27fc] = ACTIONS(3537),
    [anon_sym_u21a6] = ACTIONS(3537),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1720] = {
    [sym_block_comment] = STATE(1720),
    [sym_maps_to] = STATE(931),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4430),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4432),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1721] = {
    [sym_block_comment] = STATE(1721),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3541),
    [anon_sym_u27fc] = ACTIONS(3541),
    [anon_sym_u21a6] = ACTIONS(3541),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1722] = {
    [sym_block_comment] = STATE(1722),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3515),
    [anon_sym_u27fc] = ACTIONS(3515),
    [anon_sym_u21a6] = ACTIONS(3515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1723] = {
    [sym_block_comment] = STATE(1723),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_GT_GT] = ACTIONS(3495),
    [anon_sym_u3009] = ACTIONS(3495),
    [anon_sym_u27e9] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1724] = {
    [sym_block_comment] = STATE(1724),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_GT_GT] = ACTIONS(3495),
    [anon_sym_u3009] = ACTIONS(3495),
    [anon_sym_u27e9] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1725] = {
    [sym_block_comment] = STATE(1725),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(3531),
    [anon_sym_u3009] = ACTIONS(3531),
    [anon_sym_u27e9] = ACTIONS(3531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1726] = {
    [sym_block_comment] = STATE(1726),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3545),
    [anon_sym_u27fc] = ACTIONS(3545),
    [anon_sym_u21a6] = ACTIONS(3545),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1727] = {
    [sym_block_comment] = STATE(1727),
    [sym_maps_to] = STATE(946),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4434),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4436),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1728] = {
    [sym_block_comment] = STATE(1728),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3553),
    [anon_sym_u27fc] = ACTIONS(3553),
    [anon_sym_u21a6] = ACTIONS(3553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3553),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1729] = {
    [sym_block_comment] = STATE(1729),
    [sym_maps_to] = STATE(959),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4438),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4440),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1730] = {
    [sym_block_comment] = STATE(1730),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3557),
    [anon_sym_u27fc] = ACTIONS(3557),
    [anon_sym_u21a6] = ACTIONS(3557),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1731] = {
    [sym_block_comment] = STATE(1731),
    [sym_maps_to] = STATE(974),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4442),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4444),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1732] = {
    [sym_block_comment] = STATE(1732),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3511),
    [anon_sym_u27fc] = ACTIONS(3511),
    [anon_sym_u21a6] = ACTIONS(3511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1733] = {
    [sym_block_comment] = STATE(1733),
    [sym_maps_to] = STATE(989),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4446),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4448),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1734] = {
    [sym_block_comment] = STATE(1734),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_u3009] = ACTIONS(3491),
    [anon_sym_u27e9] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1735] = {
    [sym_block_comment] = STATE(1735),
    [sym_maps_to] = STATE(1004),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4450),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4452),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1736] = {
    [sym_block_comment] = STATE(1736),
    [sym_maps_to] = STATE(1020),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4454),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4456),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1737] = {
    [sym_block_comment] = STATE(1737),
    [sym_maps_to] = STATE(1034),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4294),
    [anon_sym_u27f6] = ACTIONS(4294),
    [anon_sym_u2192] = ACTIONS(4294),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EXCEPT] = ACTIONS(4458),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_RBRACK_] = ACTIONS(4460),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1738] = {
    [sym_block_comment] = STATE(1738),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_u3009] = ACTIONS(3491),
    [anon_sym_u27e9] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1739] = {
    [sym_block_comment] = STATE(1739),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_u3009] = ACTIONS(3491),
    [anon_sym_u27e9] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1740] = {
    [sym_block_comment] = STATE(1740),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4462),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_end] = ACTIONS(4462),
    [anon_sym_SEMI] = ACTIONS(4462),
    [anon_sym_elsif] = ACTIONS(4462),
    [anon_sym_else] = ACTIONS(4462),
    [anon_sym_or] = ACTIONS(4462),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1741] = {
    [sym_block_comment] = STATE(1741),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3495),
    [anon_sym_u27fc] = ACTIONS(3495),
    [anon_sym_u21a6] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3497),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1742] = {
    [sym_block_comment] = STATE(1742),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3495),
    [anon_sym_u27fc] = ACTIONS(3495),
    [anon_sym_u21a6] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3497),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1743] = {
    [sym_block_comment] = STATE(1743),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3525),
    [anon_sym_u27fc] = ACTIONS(3525),
    [anon_sym_u21a6] = ACTIONS(3525),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1744] = {
    [sym_block_comment] = STATE(1744),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4464),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(4466),
    [anon_sym_u2016] = ACTIONS(4466),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_end] = ACTIONS(4464),
    [anon_sym_SEMI] = ACTIONS(4464),
    [anon_sym_elsif] = ACTIONS(4464),
    [anon_sym_else] = ACTIONS(4464),
    [anon_sym_or] = ACTIONS(4464),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1745] = {
    [sym_block_comment] = STATE(1745),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(3491),
    [anon_sym_u27fc] = ACTIONS(3491),
    [anon_sym_u21a6] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_COMMA] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3493),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1746] = {
    [sym_block_comment] = STATE(1746),
    [sym_def_eq] = STATE(187),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5100),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_EQ_EQ] = ACTIONS(3817),
    [anon_sym_u225c] = ACTIONS(3817),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(4469),
    [anon_sym_LBRACK] = ACTIONS(4471),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1747] = {
    [sym_block_comment] = STATE(1747),
    [sym_def_eq] = STATE(197),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5241),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_EQ_EQ] = ACTIONS(3817),
    [anon_sym_u225c] = ACTIONS(3817),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(4473),
    [anon_sym_LBRACK] = ACTIONS(4475),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1748] = {
    [sym_block_comment] = STATE(1748),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_pcal_var_decls] = STATE(4990),
    [sym_pcal_p_algorithm_body] = STATE(5312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_variable] = ACTIONS(4477),
    [anon_sym_variables] = ACTIONS(4479),
    [anon_sym_begin] = ACTIONS(4481),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1749] = {
    [sym_block_comment] = STATE(1749),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_pcal_var_decls] = STATE(4954),
    [sym_pcal_p_algorithm_body] = STATE(5123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_variable] = ACTIONS(4477),
    [anon_sym_variables] = ACTIONS(4479),
    [anon_sym_begin] = ACTIONS(4481),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1750] = {
    [sym_block_comment] = STATE(1750),
    [sym_def_eq] = STATE(191),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5172),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_EQ_EQ] = ACTIONS(3817),
    [anon_sym_u225c] = ACTIONS(3817),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(4483),
    [anon_sym_LBRACK] = ACTIONS(4485),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1751] = {
    [sym_block_comment] = STATE(1751),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_pcal_var_decls] = STATE(5036),
    [sym_pcal_p_algorithm_body] = STATE(5497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_variable] = ACTIONS(4477),
    [anon_sym_variables] = ACTIONS(4479),
    [anon_sym_begin] = ACTIONS(4481),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1752] = {
    [sym_block_comment] = STATE(1752),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym__pcal_with_vars_repeat1] = STATE(4232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4487),
    [anon_sym_RPAREN] = ACTIONS(4489),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_SEMI] = ACTIONS(4487),
    [anon_sym_do] = ACTIONS(4489),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1753] = {
    [sym_block_comment] = STATE(1753),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [aux_sym_use_body_expr_repeat1] = STATE(4182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4491),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3559),
    [anon_sym_DEFS] = ACTIONS(3561),
    [sym__begin_proof_step] = ACTIONS(3561),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1754] = {
    [sym_block_comment] = STATE(1754),
    [sym_def_eq] = STATE(199),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5444),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_EQ_EQ] = ACTIONS(3817),
    [anon_sym_u225c] = ACTIONS(3817),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(4495),
    [anon_sym_LBRACK] = ACTIONS(4497),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1755] = {
    [sym_block_comment] = STATE(1755),
    [sym_def_eq] = STATE(205),
    [sym_implies] = STATE(3441),
    [sym_plus_arrow] = STATE(3441),
    [sym_equiv] = STATE(3441),
    [sym_iff] = STATE(3441),
    [sym_leads_to] = STATE(3441),
    [sym_land] = STATE(3441),
    [sym_lor] = STATE(3441),
    [sym_assign] = STATE(3441),
    [sym_bnf_rule] = STATE(3441),
    [sym_eq] = STATE(3441),
    [sym_neq] = STATE(3441),
    [sym_lt] = STATE(3441),
    [sym_leq] = STATE(3441),
    [sym_geq] = STATE(3441),
    [sym_approx] = STATE(3441),
    [sym_rs_ttile] = STATE(3441),
    [sym_rd_ttile] = STATE(3441),
    [sym_ls_ttile] = STATE(3441),
    [sym_ld_ttile] = STATE(3441),
    [sym_asymp] = STATE(3441),
    [sym_cong] = STATE(3441),
    [sym_doteq] = STATE(3441),
    [sym_gg] = STATE(3441),
    [sym_ll] = STATE(3441),
    [sym_in] = STATE(3441),
    [sym_notin] = STATE(3441),
    [sym_prec] = STATE(3441),
    [sym_succ] = STATE(3441),
    [sym_preceq] = STATE(3441),
    [sym_succeq] = STATE(3441),
    [sym_propto] = STATE(3441),
    [sym_sim] = STATE(3441),
    [sym_simeq] = STATE(3441),
    [sym_sqsubset] = STATE(3441),
    [sym_sqsupset] = STATE(3441),
    [sym_sqsubseteq] = STATE(3441),
    [sym_sqsupseteq] = STATE(3441),
    [sym_subset] = STATE(3441),
    [sym_supset] = STATE(3441),
    [sym_subseteq] = STATE(3441),
    [sym_supseteq] = STATE(3441),
    [sym_cap] = STATE(3441),
    [sym_cup] = STATE(3441),
    [sym_dots_2] = STATE(3441),
    [sym_dots_3] = STATE(3441),
    [sym_plus] = STATE(3441),
    [sym_oplus] = STATE(3441),
    [sym_ominus] = STATE(3441),
    [sym_vertvert] = STATE(3441),
    [sym_minus] = STATE(3441),
    [sym_odot] = STATE(3441),
    [sym_oslash] = STATE(3441),
    [sym_otimes] = STATE(3441),
    [sym_bigcirc] = STATE(3441),
    [sym_bullet] = STATE(3441),
    [sym_div] = STATE(3441),
    [sym_circ] = STATE(3441),
    [sym_star] = STATE(3441),
    [sym_excl] = STATE(3441),
    [sym_qq] = STATE(3441),
    [sym_sqcap] = STATE(3441),
    [sym_sqcup] = STATE(3441),
    [sym_uplus] = STATE(3441),
    [sym_times] = STATE(3441),
    [sym_wr] = STATE(3441),
    [sym_cdot] = STATE(3441),
    [sym_infix_op_symbol] = STATE(5196),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(4829),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_EQ_EQ] = ACTIONS(3817),
    [anon_sym_u225c] = ACTIONS(3817),
    [anon_sym_BSLASHin] = ACTIONS(59),
    [anon_sym_u2208] = ACTIONS(61),
    [anon_sym_SLASH_BSLASH] = ACTIONS(79),
    [anon_sym_u2227] = ACTIONS(79),
    [anon_sym_BSLASH_SLASH] = ACTIONS(81),
    [anon_sym_u2228] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(4499),
    [anon_sym_LBRACK] = ACTIONS(4501),
    [anon_sym_BSLASHo] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_u27f9] = ACTIONS(147),
    [anon_sym_u21d2] = ACTIONS(147),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(149),
    [anon_sym_u21f8] = ACTIONS(149),
    [anon_sym_u2945] = ACTIONS(149),
    [anon_sym_BSLASHequiv] = ACTIONS(151),
    [anon_sym_u2261] = ACTIONS(151),
    [anon_sym_LT_EQ_GT] = ACTIONS(153),
    [anon_sym_u27fa] = ACTIONS(153),
    [anon_sym_u21d4] = ACTIONS(153),
    [anon_sym_TILDE_GT] = ACTIONS(155),
    [anon_sym_u21dd] = ACTIONS(155),
    [anon_sym_u219d] = ACTIONS(155),
    [anon_sym_BSLASHland] = ACTIONS(79),
    [anon_sym_BSLASHlor] = ACTIONS(81),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_u2254] = ACTIONS(157),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(159),
    [anon_sym_u2a74] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(161),
    [anon_sym_POUND] = ACTIONS(163),
    [anon_sym_u2260] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(2152),
    [sym_gt] = ACTIONS(167),
    [anon_sym_LT_EQ] = ACTIONS(169),
    [anon_sym_EQ_LT] = ACTIONS(171),
    [anon_sym_BSLASHleq] = ACTIONS(171),
    [anon_sym_u2264] = ACTIONS(171),
    [anon_sym_GT_EQ] = ACTIONS(173),
    [anon_sym_BSLASHgeq] = ACTIONS(173),
    [anon_sym_u2265] = ACTIONS(173),
    [anon_sym_BSLASHapprox] = ACTIONS(175),
    [anon_sym_u2248] = ACTIONS(175),
    [anon_sym_PIPE_DASH] = ACTIONS(177),
    [anon_sym_u22a2] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(179),
    [anon_sym_u22a8] = ACTIONS(179),
    [anon_sym_DASH_PIPE] = ACTIONS(181),
    [anon_sym_u22a3] = ACTIONS(181),
    [anon_sym_EQ_PIPE] = ACTIONS(183),
    [anon_sym_u2ae4] = ACTIONS(183),
    [anon_sym_BSLASHasymp] = ACTIONS(185),
    [anon_sym_u224d] = ACTIONS(185),
    [anon_sym_BSLASHcong] = ACTIONS(187),
    [anon_sym_u2245] = ACTIONS(187),
    [anon_sym_BSLASHdoteq] = ACTIONS(189),
    [anon_sym_u2250] = ACTIONS(189),
    [anon_sym_BSLASHgg] = ACTIONS(191),
    [anon_sym_u226b] = ACTIONS(191),
    [anon_sym_BSLASHll] = ACTIONS(193),
    [anon_sym_u226a] = ACTIONS(193),
    [anon_sym_BSLASHnotin] = ACTIONS(195),
    [anon_sym_u2209] = ACTIONS(195),
    [anon_sym_BSLASHprec] = ACTIONS(197),
    [anon_sym_u227a] = ACTIONS(199),
    [anon_sym_BSLASHsucc] = ACTIONS(201),
    [anon_sym_u227b] = ACTIONS(203),
    [anon_sym_BSLASHpreceq] = ACTIONS(205),
    [anon_sym_u2aaf] = ACTIONS(205),
    [anon_sym_BSLASHsucceq] = ACTIONS(207),
    [anon_sym_u2ab0] = ACTIONS(207),
    [anon_sym_BSLASHpropto] = ACTIONS(209),
    [anon_sym_u221d] = ACTIONS(209),
    [anon_sym_BSLASHsim] = ACTIONS(211),
    [anon_sym_u223c] = ACTIONS(213),
    [anon_sym_BSLASHsimeq] = ACTIONS(215),
    [anon_sym_u2243] = ACTIONS(215),
    [anon_sym_BSLASHsqsubset] = ACTIONS(217),
    [anon_sym_u228f] = ACTIONS(219),
    [anon_sym_BSLASHsqsupset] = ACTIONS(221),
    [anon_sym_u2290] = ACTIONS(223),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(225),
    [anon_sym_u2291] = ACTIONS(225),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(227),
    [anon_sym_u2292] = ACTIONS(227),
    [anon_sym_BSLASHsubset] = ACTIONS(229),
    [anon_sym_u2282] = ACTIONS(231),
    [anon_sym_BSLASHsupset] = ACTIONS(233),
    [anon_sym_u2283] = ACTIONS(235),
    [anon_sym_BSLASHsubseteq] = ACTIONS(237),
    [anon_sym_u2286] = ACTIONS(237),
    [anon_sym_BSLASHsupseteq] = ACTIONS(239),
    [anon_sym_u2287] = ACTIONS(239),
    [sym_compose] = ACTIONS(241),
    [sym_map_to] = ACTIONS(241),
    [sym_map_from] = ACTIONS(241),
    [sym_setminus] = ACTIONS(167),
    [anon_sym_BSLASHcap] = ACTIONS(243),
    [anon_sym_BSLASHintersect] = ACTIONS(243),
    [anon_sym_u2229] = ACTIONS(243),
    [anon_sym_BSLASHcup] = ACTIONS(245),
    [anon_sym_BSLASHunion] = ACTIONS(245),
    [anon_sym_u222a] = ACTIONS(245),
    [anon_sym_DOT_DOT] = ACTIONS(247),
    [anon_sym_u2025] = ACTIONS(249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(251),
    [anon_sym_u2026] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(253),
    [sym_plusplus] = ACTIONS(241),
    [anon_sym_BSLASHoplus] = ACTIONS(255),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(255),
    [anon_sym_u2295] = ACTIONS(255),
    [anon_sym_BSLASHominus] = ACTIONS(257),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(257),
    [anon_sym_u2296] = ACTIONS(257),
    [sym_mod] = ACTIONS(167),
    [sym_modmod] = ACTIONS(241),
    [sym_vert] = ACTIONS(167),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_u2016] = ACTIONS(259),
    [sym_minusminus] = ACTIONS(241),
    [sym_amp] = ACTIONS(167),
    [sym_ampamp] = ACTIONS(241),
    [anon_sym_BSLASHodot] = ACTIONS(261),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(261),
    [anon_sym_u2299] = ACTIONS(261),
    [anon_sym_BSLASHoslash] = ACTIONS(263),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(263),
    [anon_sym_u2298] = ACTIONS(263),
    [anon_sym_BSLASHotimes] = ACTIONS(265),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(265),
    [anon_sym_u2297] = ACTIONS(265),
    [sym_mul] = ACTIONS(167),
    [sym_mulmul] = ACTIONS(241),
    [sym_slash] = ACTIONS(167),
    [sym_slashslash] = ACTIONS(241),
    [anon_sym_BSLASHbigcirc] = ACTIONS(267),
    [anon_sym_u25ef] = ACTIONS(267),
    [anon_sym_BSLASHbullet] = ACTIONS(269),
    [anon_sym_u25cf] = ACTIONS(269),
    [anon_sym_BSLASHdiv] = ACTIONS(271),
    [anon_sym_u00f7] = ACTIONS(271),
    [anon_sym_BSLASHcirc] = ACTIONS(273),
    [anon_sym_u2218] = ACTIONS(273),
    [anon_sym_BSLASHstar] = ACTIONS(275),
    [anon_sym_u22c6] = ACTIONS(275),
    [anon_sym_u203c] = ACTIONS(277),
    [sym_hashhash] = ACTIONS(241),
    [sym_dol] = ACTIONS(167),
    [sym_doldol] = ACTIONS(241),
    [anon_sym_QMARK_QMARK] = ACTIONS(279),
    [anon_sym_u2047] = ACTIONS(279),
    [anon_sym_BSLASHsqcap] = ACTIONS(281),
    [anon_sym_u2293] = ACTIONS(281),
    [anon_sym_BSLASHsqcup] = ACTIONS(283),
    [anon_sym_u2294] = ACTIONS(283),
    [anon_sym_BSLASHuplus] = ACTIONS(285),
    [anon_sym_u228e] = ACTIONS(285),
    [anon_sym_BSLASHX] = ACTIONS(287),
    [anon_sym_BSLASHtimes] = ACTIONS(287),
    [anon_sym_u00d7] = ACTIONS(287),
    [anon_sym_BSLASHwr] = ACTIONS(289),
    [anon_sym_u2240] = ACTIONS(289),
    [anon_sym_BSLASHcdot] = ACTIONS(291),
    [anon_sym_u22c5] = ACTIONS(291),
    [sym_pow] = ACTIONS(167),
    [sym_powpow] = ACTIONS(241),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(277),
  },
  [1756] = {
    [sym_block_comment] = STATE(1756),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3557),
    [anon_sym_u25a1] = ACTIONS(3557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3557),
    [sym__dedent] = ACTIONS(3557),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1757] = {
    [sym_block_comment] = STATE(1757),
    [sym_case_arrow] = STATE(803),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1758] = {
    [sym_block_comment] = STATE(1758),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4533),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4537),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1759] = {
    [sym_block_comment] = STATE(1759),
    [sym_case_arrow] = STATE(355),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1760] = {
    [sym_block_comment] = STATE(1760),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4539),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4541),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1761] = {
    [sym_block_comment] = STATE(1761),
    [sym_case_arrow] = STATE(1047),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1762] = {
    [sym_block_comment] = STATE(1762),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4543),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4545),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1763] = {
    [sym_block_comment] = STATE(1763),
    [sym_case_arrow] = STATE(341),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1764] = {
    [sym_block_comment] = STATE(1764),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4576),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4547),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4549),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1765] = {
    [sym_block_comment] = STATE(1765),
    [sym_case_arrow] = STATE(372),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1766] = {
    [sym_block_comment] = STATE(1766),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4551),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4553),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4553),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1767] = {
    [sym_block_comment] = STATE(1767),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4555),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1768] = {
    [sym_block_comment] = STATE(1768),
    [sym_case_arrow] = STATE(400),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1769] = {
    [sym_block_comment] = STATE(1769),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4559),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1770] = {
    [sym_block_comment] = STATE(1770),
    [sym_case_arrow] = STATE(426),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1771] = {
    [sym_block_comment] = STATE(1771),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4563),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4565),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1772] = {
    [sym_block_comment] = STATE(1772),
    [sym_case_arrow] = STATE(452),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1773] = {
    [sym_block_comment] = STATE(1773),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4567),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1774] = {
    [sym_block_comment] = STATE(1774),
    [sym_case_arrow] = STATE(478),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1775] = {
    [sym_block_comment] = STATE(1775),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4571),
    [anon_sym_RPAREN] = ACTIONS(4571),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4571),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4571),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1776] = {
    [sym_block_comment] = STATE(1776),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4573),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4575),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1777] = {
    [sym_block_comment] = STATE(1777),
    [sym_case_arrow] = STATE(533),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1778] = {
    [sym_block_comment] = STATE(1778),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4577),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4579),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1779] = {
    [sym_block_comment] = STATE(1779),
    [sym_case_arrow] = STATE(560),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1780] = {
    [sym_block_comment] = STATE(1780),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4581),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4583),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1781] = {
    [sym_block_comment] = STATE(1781),
    [sym_case_arrow] = STATE(588),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1782] = {
    [sym_block_comment] = STATE(1782),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4585),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4587),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1783] = {
    [sym_block_comment] = STATE(1783),
    [sym_case_arrow] = STATE(618),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1784] = {
    [sym_block_comment] = STATE(1784),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4589),
    [anon_sym_RPAREN] = ACTIONS(4589),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_SEMI] = ACTIONS(4589),
    [anon_sym_do] = ACTIONS(4589),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1785] = {
    [sym_block_comment] = STATE(1785),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4591),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4593),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1786] = {
    [sym_block_comment] = STATE(1786),
    [sym_case_arrow] = STATE(505),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1787] = {
    [sym_block_comment] = STATE(1787),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4595),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4597),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1788] = {
    [sym_block_comment] = STATE(1788),
    [sym_case_arrow] = STATE(646),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1789] = {
    [sym_block_comment] = STATE(1789),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4599),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4601),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1790] = {
    [sym_block_comment] = STATE(1790),
    [sym_case_arrow] = STATE(672),
    [sym_implies] = STATE(335),
    [sym_plus_arrow] = STATE(336),
    [sym_equiv] = STATE(336),
    [sym_iff] = STATE(336),
    [sym_leads_to] = STATE(336),
    [sym_land] = STATE(337),
    [sym_lor] = STATE(337),
    [sym_assign] = STATE(327),
    [sym_bnf_rule] = STATE(327),
    [sym_eq] = STATE(327),
    [sym_neq] = STATE(327),
    [sym_lt] = STATE(327),
    [sym_leq] = STATE(327),
    [sym_geq] = STATE(327),
    [sym_approx] = STATE(327),
    [sym_rs_ttile] = STATE(327),
    [sym_rd_ttile] = STATE(327),
    [sym_ls_ttile] = STATE(327),
    [sym_ld_ttile] = STATE(327),
    [sym_asymp] = STATE(327),
    [sym_cong] = STATE(327),
    [sym_doteq] = STATE(327),
    [sym_gg] = STATE(327),
    [sym_ll] = STATE(327),
    [sym_in] = STATE(327),
    [sym_notin] = STATE(327),
    [sym_prec] = STATE(327),
    [sym_succ] = STATE(327),
    [sym_preceq] = STATE(327),
    [sym_succeq] = STATE(327),
    [sym_propto] = STATE(327),
    [sym_sim] = STATE(327),
    [sym_simeq] = STATE(327),
    [sym_sqsubset] = STATE(327),
    [sym_sqsupset] = STATE(327),
    [sym_sqsubseteq] = STATE(327),
    [sym_sqsupseteq] = STATE(327),
    [sym_subset] = STATE(327),
    [sym_supset] = STATE(327),
    [sym_subseteq] = STATE(327),
    [sym_supseteq] = STATE(327),
    [sym_cap] = STATE(330),
    [sym_cup] = STATE(330),
    [sym_dots_2] = STATE(338),
    [sym_dots_3] = STATE(338),
    [sym_plus] = STATE(331),
    [sym_oplus] = STATE(331),
    [sym_ominus] = STATE(332),
    [sym_vertvert] = STATE(332),
    [sym_minus] = STATE(332),
    [sym_odot] = STATE(333),
    [sym_oslash] = STATE(333),
    [sym_otimes] = STATE(333),
    [sym_bigcirc] = STATE(333),
    [sym_bullet] = STATE(333),
    [sym_div] = STATE(333),
    [sym_circ] = STATE(333),
    [sym_star] = STATE(333),
    [sym_excl] = STATE(333),
    [sym_qq] = STATE(333),
    [sym_sqcap] = STATE(333),
    [sym_sqcup] = STATE(333),
    [sym_uplus] = STATE(333),
    [sym_times] = STATE(333),
    [sym_wr] = STATE(334),
    [sym_cdot] = STATE(334),
    [sym_sup_plus] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(4080),
    [anon_sym_u27f6] = ACTIONS(4080),
    [anon_sym_u2192] = ACTIONS(4080),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4242),
    [sym_map_to] = ACTIONS(4244),
    [sym_map_from] = ACTIONS(4244),
    [sym_setminus] = ACTIONS(4246),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4248),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4250),
    [sym_modmod] = ACTIONS(4252),
    [sym_vert] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4252),
    [sym_amp] = ACTIONS(4254),
    [sym_ampamp] = ACTIONS(4256),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4254),
    [sym_mulmul] = ACTIONS(4256),
    [sym_slash] = ACTIONS(4254),
    [sym_slashslash] = ACTIONS(4256),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4256),
    [sym_dol] = ACTIONS(4254),
    [sym_doldol] = ACTIONS(4256),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4258),
    [sym_powpow] = ACTIONS(4260),
    [anon_sym_CARET_PLUS] = ACTIONS(4262),
    [anon_sym_u207a] = ACTIONS(4262),
    [sym_asterisk] = ACTIONS(4264),
    [sym_sup_hash] = ACTIONS(4264),
    [sym_prime] = ACTIONS(4264),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1791] = {
    [sym_block_comment] = STATE(1791),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4603),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4605),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1792] = {
    [sym_block_comment] = STATE(1792),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4607),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4609),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1793] = {
    [sym_block_comment] = STATE(1793),
    [sym_implies] = STATE(472),
    [sym_plus_arrow] = STATE(473),
    [sym_equiv] = STATE(473),
    [sym_iff] = STATE(473),
    [sym_leads_to] = STATE(473),
    [sym_land] = STATE(474),
    [sym_lor] = STATE(474),
    [sym_assign] = STATE(464),
    [sym_bnf_rule] = STATE(464),
    [sym_eq] = STATE(464),
    [sym_neq] = STATE(464),
    [sym_lt] = STATE(464),
    [sym_leq] = STATE(464),
    [sym_geq] = STATE(464),
    [sym_approx] = STATE(464),
    [sym_rs_ttile] = STATE(464),
    [sym_rd_ttile] = STATE(464),
    [sym_ls_ttile] = STATE(464),
    [sym_ld_ttile] = STATE(464),
    [sym_asymp] = STATE(464),
    [sym_cong] = STATE(464),
    [sym_doteq] = STATE(464),
    [sym_gg] = STATE(464),
    [sym_ll] = STATE(464),
    [sym_in] = STATE(464),
    [sym_notin] = STATE(464),
    [sym_prec] = STATE(464),
    [sym_succ] = STATE(464),
    [sym_preceq] = STATE(464),
    [sym_succeq] = STATE(464),
    [sym_propto] = STATE(464),
    [sym_sim] = STATE(464),
    [sym_simeq] = STATE(464),
    [sym_sqsubset] = STATE(464),
    [sym_sqsupset] = STATE(464),
    [sym_sqsubseteq] = STATE(464),
    [sym_sqsupseteq] = STATE(464),
    [sym_subset] = STATE(464),
    [sym_supset] = STATE(464),
    [sym_subseteq] = STATE(464),
    [sym_supseteq] = STATE(464),
    [sym_cap] = STATE(467),
    [sym_cup] = STATE(467),
    [sym_dots_2] = STATE(475),
    [sym_dots_3] = STATE(475),
    [sym_plus] = STATE(468),
    [sym_oplus] = STATE(468),
    [sym_ominus] = STATE(469),
    [sym_vertvert] = STATE(469),
    [sym_minus] = STATE(469),
    [sym_odot] = STATE(470),
    [sym_oslash] = STATE(470),
    [sym_otimes] = STATE(470),
    [sym_bigcirc] = STATE(470),
    [sym_bullet] = STATE(470),
    [sym_div] = STATE(470),
    [sym_circ] = STATE(470),
    [sym_star] = STATE(470),
    [sym_excl] = STATE(470),
    [sym_qq] = STATE(470),
    [sym_sqcap] = STATE(470),
    [sym_sqcup] = STATE(470),
    [sym_uplus] = STATE(470),
    [sym_times] = STATE(470),
    [sym_wr] = STATE(471),
    [sym_cdot] = STATE(471),
    [sym_sup_plus] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_GT_GT] = ACTIONS(4571),
    [anon_sym_u3009] = ACTIONS(4571),
    [anon_sym_u27e9] = ACTIONS(4571),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4571),
    [anon_sym_LBRACK] = ACTIONS(4611),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4312),
    [sym_map_to] = ACTIONS(4314),
    [sym_map_from] = ACTIONS(4314),
    [sym_setminus] = ACTIONS(4316),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4318),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4320),
    [sym_modmod] = ACTIONS(4322),
    [sym_vert] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4322),
    [sym_amp] = ACTIONS(4324),
    [sym_ampamp] = ACTIONS(4326),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4324),
    [sym_mulmul] = ACTIONS(4326),
    [sym_slash] = ACTIONS(4324),
    [sym_slashslash] = ACTIONS(4326),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4326),
    [sym_dol] = ACTIONS(4324),
    [sym_doldol] = ACTIONS(4326),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4328),
    [sym_powpow] = ACTIONS(4330),
    [anon_sym_CARET_PLUS] = ACTIONS(4332),
    [anon_sym_u207a] = ACTIONS(4332),
    [sym_asterisk] = ACTIONS(4334),
    [sym_sup_hash] = ACTIONS(4334),
    [sym_prime] = ACTIONS(4334),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1794] = {
    [sym_block_comment] = STATE(1794),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3495),
    [sym__dedent] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1795] = {
    [sym_block_comment] = STATE(1795),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(3497),
    [sym_ampamp] = ACTIONS(3495),
    [anon_sym_BSLASHodot] = ACTIONS(3495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3495),
    [anon_sym_u2299] = ACTIONS(3495),
    [anon_sym_BSLASHoslash] = ACTIONS(3495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2298] = ACTIONS(3495),
    [anon_sym_BSLASHotimes] = ACTIONS(3495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3495),
    [anon_sym_u2297] = ACTIONS(3495),
    [sym_mul] = ACTIONS(3497),
    [sym_mulmul] = ACTIONS(3495),
    [sym_slash] = ACTIONS(3497),
    [sym_slashslash] = ACTIONS(3495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3495),
    [anon_sym_u25ef] = ACTIONS(3495),
    [anon_sym_BSLASHbullet] = ACTIONS(3495),
    [anon_sym_u25cf] = ACTIONS(3495),
    [anon_sym_BSLASHdiv] = ACTIONS(3495),
    [anon_sym_u00f7] = ACTIONS(3495),
    [anon_sym_BSLASHcirc] = ACTIONS(3495),
    [anon_sym_u2218] = ACTIONS(3495),
    [anon_sym_BSLASHstar] = ACTIONS(3495),
    [anon_sym_u22c6] = ACTIONS(3495),
    [anon_sym_u203c] = ACTIONS(3495),
    [sym_hashhash] = ACTIONS(3495),
    [sym_dol] = ACTIONS(3497),
    [sym_doldol] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_u2047] = ACTIONS(3495),
    [anon_sym_BSLASHsqcap] = ACTIONS(3495),
    [anon_sym_u2293] = ACTIONS(3495),
    [anon_sym_BSLASHsqcup] = ACTIONS(3495),
    [anon_sym_u2294] = ACTIONS(3495),
    [anon_sym_BSLASHuplus] = ACTIONS(3495),
    [anon_sym_u228e] = ACTIONS(3495),
    [anon_sym_BSLASHX] = ACTIONS(3495),
    [anon_sym_BSLASHtimes] = ACTIONS(3495),
    [anon_sym_u00d7] = ACTIONS(3495),
    [anon_sym_BSLASHwr] = ACTIONS(3495),
    [anon_sym_u2240] = ACTIONS(3495),
    [anon_sym_BSLASHcdot] = ACTIONS(3495),
    [anon_sym_u22c5] = ACTIONS(3495),
    [sym_pow] = ACTIONS(3497),
    [sym_powpow] = ACTIONS(3495),
    [anon_sym_CARET_PLUS] = ACTIONS(3495),
    [anon_sym_u207a] = ACTIONS(3495),
    [sym_asterisk] = ACTIONS(3495),
    [sym_sup_hash] = ACTIONS(3495),
    [sym_prime] = ACTIONS(3495),
    [sym__bullet] = ACTIONS(3495),
    [sym__dedent] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(3495),
  },
  [1796] = {
    [sym_block_comment] = STATE(1796),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3495),
    [sym__dedent] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1797] = {
    [sym_block_comment] = STATE(1797),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3497),
    [anon_sym_u2208] = ACTIONS(3495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3495),
    [anon_sym_u25a1] = ACTIONS(3495),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3495),
    [anon_sym_u2227] = ACTIONS(3495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3495),
    [anon_sym_u2228] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27f9] = ACTIONS(3495),
    [anon_sym_u21d2] = ACTIONS(3495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3495),
    [anon_sym_u21f8] = ACTIONS(3495),
    [anon_sym_u2945] = ACTIONS(3495),
    [anon_sym_BSLASHequiv] = ACTIONS(3495),
    [anon_sym_u2261] = ACTIONS(3495),
    [anon_sym_LT_EQ_GT] = ACTIONS(3495),
    [anon_sym_u27fa] = ACTIONS(3495),
    [anon_sym_u21d4] = ACTIONS(3495),
    [anon_sym_TILDE_GT] = ACTIONS(3495),
    [anon_sym_u21dd] = ACTIONS(3495),
    [anon_sym_u219d] = ACTIONS(3495),
    [anon_sym_BSLASHland] = ACTIONS(3495),
    [anon_sym_BSLASHlor] = ACTIONS(3495),
    [anon_sym_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2254] = ACTIONS(3495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3495),
    [anon_sym_u2a74] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_u2260] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3497),
    [sym_gt] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3497),
    [anon_sym_EQ_LT] = ACTIONS(3495),
    [anon_sym_BSLASHleq] = ACTIONS(3495),
    [anon_sym_u2264] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_BSLASHgeq] = ACTIONS(3495),
    [anon_sym_u2265] = ACTIONS(3495),
    [anon_sym_BSLASHapprox] = ACTIONS(3495),
    [anon_sym_u2248] = ACTIONS(3495),
    [anon_sym_PIPE_DASH] = ACTIONS(3495),
    [anon_sym_u22a2] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_u22a8] = ACTIONS(3495),
    [anon_sym_DASH_PIPE] = ACTIONS(3495),
    [anon_sym_u22a3] = ACTIONS(3495),
    [anon_sym_EQ_PIPE] = ACTIONS(3495),
    [anon_sym_u2ae4] = ACTIONS(3495),
    [anon_sym_BSLASHasymp] = ACTIONS(3495),
    [anon_sym_u224d] = ACTIONS(3495),
    [anon_sym_BSLASHcong] = ACTIONS(3495),
    [anon_sym_u2245] = ACTIONS(3495),
    [anon_sym_BSLASHdoteq] = ACTIONS(3495),
    [anon_sym_u2250] = ACTIONS(3495),
    [anon_sym_BSLASHgg] = ACTIONS(3495),
    [anon_sym_u226b] = ACTIONS(3495),
    [anon_sym_BSLASHll] = ACTIONS(3495),
    [anon_sym_u226a] = ACTIONS(3495),
    [anon_sym_BSLASHnotin] = ACTIONS(3495),
    [anon_sym_u2209] = ACTIONS(3495),
    [anon_sym_BSLASHprec] = ACTIONS(3497),
    [anon_sym_u227a] = ACTIONS(3495),
    [anon_sym_BSLASHsucc] = ACTIONS(3497),
    [anon_sym_u227b] = ACTIONS(3495),
    [anon_sym_BSLASHpreceq] = ACTIONS(3495),
    [anon_sym_u2aaf] = ACTIONS(3495),
    [anon_sym_BSLASHsucceq] = ACTIONS(3495),
    [anon_sym_u2ab0] = ACTIONS(3495),
    [anon_sym_BSLASHpropto] = ACTIONS(3495),
    [anon_sym_u221d] = ACTIONS(3495),
    [anon_sym_BSLASHsim] = ACTIONS(3497),
    [anon_sym_u223c] = ACTIONS(3495),
    [anon_sym_BSLASHsimeq] = ACTIONS(3495),
    [anon_sym_u2243] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3497),
    [anon_sym_u228f] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3497),
    [anon_sym_u2290] = ACTIONS(3495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3495),
    [anon_sym_u2291] = ACTIONS(3495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3495),
    [anon_sym_u2292] = ACTIONS(3495),
    [anon_sym_BSLASHsubset] = ACTIONS(3497),
    [anon_sym_u2282] = ACTIONS(3495),
    [anon_sym_BSLASHsupset] = ACTIONS(3497),
    [anon_sym_u2283] = ACTIONS(3495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3495),
    [anon_sym_u2286] = ACTIONS(3495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3495),
    [anon_sym_u2287] = ACTIONS(3495),
    [sym_compose] = ACTIONS(3495),
    [sym_map_to] = ACTIONS(3495),
    [sym_map_from] = ACTIONS(3495),
    [sym_setminus] = ACTIONS(3497),
    [anon_sym_BSLASHcap] = ACTIONS(3495),
    [anon_sym_BSLASHintersect] = ACTIONS(3495),
    [anon_sym_u2229] = ACTIONS(3495),
    [anon_sym_BSLASHcup] = ACTIONS(3495),
    [anon_sym_BSLASHunion] = ACTIONS(3495),
    [anon_sym_u222a] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_u2025] = ACTIONS(3495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3495),
    [anon_sym_u2026] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3497),
    [sym_plusplus] = ACTIONS(3495),
    [anon_sym_BSLASHoplus] = ACTIONS(3495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3495),
    [anon_sym_u2295] = ACTIONS(3495),
    [anon_sym_BSLASHominus] = ACTIONS(3495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3495),
    [anon_sym_u2296] = ACTIONS(3495),
    [sym_mod] = ACTIONS(3497),
    [sym_modmod] = ACTIONS(3495),
    [sym_vert] = ACTIONS(3497),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_u2016] = ACTIONS(3495),
    [sym_minusminus] = ACTIONS(3495),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3495),
    [sym__dedent] = ACTIONS(3495),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1798] = {
    [sym_block_comment] = STATE(1798),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4613),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4615),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4615),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4615),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1799] = {
    [sym_block_comment] = STATE(1799),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3531),
    [anon_sym_u25a1] = ACTIONS(3531),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3531),
    [sym__dedent] = ACTIONS(3531),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1800] = {
    [sym_block_comment] = STATE(1800),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3491),
    [sym__dedent] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1801] = {
    [sym_block_comment] = STATE(1801),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3491),
    [sym__dedent] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1802] = {
    [sym_block_comment] = STATE(1802),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3491),
    [sym__dedent] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1803] = {
    [sym_block_comment] = STATE(1803),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3491),
    [sym__dedent] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1804] = {
    [sym_block_comment] = STATE(1804),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3491),
    [sym__dedent] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1805] = {
    [sym_block_comment] = STATE(1805),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3491),
    [sym__dedent] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1806] = {
    [sym_block_comment] = STATE(1806),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3491),
    [sym__dedent] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1807] = {
    [sym_block_comment] = STATE(1807),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3493),
    [sym_plusplus] = ACTIONS(3491),
    [anon_sym_BSLASHoplus] = ACTIONS(3491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(3491),
    [anon_sym_u2295] = ACTIONS(3491),
    [anon_sym_BSLASHominus] = ACTIONS(3491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2296] = ACTIONS(3491),
    [sym_mod] = ACTIONS(3493),
    [sym_modmod] = ACTIONS(3491),
    [sym_vert] = ACTIONS(3493),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_u2016] = ACTIONS(3491),
    [sym_minusminus] = ACTIONS(3491),
    [sym_amp] = ACTIONS(3493),
    [sym_ampamp] = ACTIONS(3491),
    [anon_sym_BSLASHodot] = ACTIONS(3491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(3491),
    [anon_sym_u2299] = ACTIONS(3491),
    [anon_sym_BSLASHoslash] = ACTIONS(3491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(3491),
    [anon_sym_u2298] = ACTIONS(3491),
    [anon_sym_BSLASHotimes] = ACTIONS(3491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(3491),
    [anon_sym_u2297] = ACTIONS(3491),
    [sym_mul] = ACTIONS(3493),
    [sym_mulmul] = ACTIONS(3491),
    [sym_slash] = ACTIONS(3493),
    [sym_slashslash] = ACTIONS(3491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(3491),
    [anon_sym_u25ef] = ACTIONS(3491),
    [anon_sym_BSLASHbullet] = ACTIONS(3491),
    [anon_sym_u25cf] = ACTIONS(3491),
    [anon_sym_BSLASHdiv] = ACTIONS(3491),
    [anon_sym_u00f7] = ACTIONS(3491),
    [anon_sym_BSLASHcirc] = ACTIONS(3491),
    [anon_sym_u2218] = ACTIONS(3491),
    [anon_sym_BSLASHstar] = ACTIONS(3491),
    [anon_sym_u22c6] = ACTIONS(3491),
    [anon_sym_u203c] = ACTIONS(3491),
    [sym_hashhash] = ACTIONS(3491),
    [sym_dol] = ACTIONS(3493),
    [sym_doldol] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_u2047] = ACTIONS(3491),
    [anon_sym_BSLASHsqcap] = ACTIONS(3491),
    [anon_sym_u2293] = ACTIONS(3491),
    [anon_sym_BSLASHsqcup] = ACTIONS(3491),
    [anon_sym_u2294] = ACTIONS(3491),
    [anon_sym_BSLASHuplus] = ACTIONS(3491),
    [anon_sym_u228e] = ACTIONS(3491),
    [anon_sym_BSLASHX] = ACTIONS(3491),
    [anon_sym_BSLASHtimes] = ACTIONS(3491),
    [anon_sym_u00d7] = ACTIONS(3491),
    [anon_sym_BSLASHwr] = ACTIONS(3491),
    [anon_sym_u2240] = ACTIONS(3491),
    [anon_sym_BSLASHcdot] = ACTIONS(3491),
    [anon_sym_u22c5] = ACTIONS(3491),
    [sym_pow] = ACTIONS(3493),
    [sym_powpow] = ACTIONS(3491),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3491),
    [sym__dedent] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(3491),
  },
  [1808] = {
    [sym_block_comment] = STATE(1808),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3491),
    [sym__dedent] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1809] = {
    [sym_block_comment] = STATE(1809),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3491),
    [sym__dedent] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1810] = {
    [sym_block_comment] = STATE(1810),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3491),
    [sym__dedent] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1811] = {
    [sym_block_comment] = STATE(1811),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3493),
    [anon_sym_u2208] = ACTIONS(3491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3491),
    [anon_sym_u25a1] = ACTIONS(3491),
    [anon_sym_SLASH_BSLASH] = ACTIONS(3491),
    [anon_sym_u2227] = ACTIONS(3491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(3491),
    [anon_sym_u2228] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27f9] = ACTIONS(3491),
    [anon_sym_u21d2] = ACTIONS(3491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(3491),
    [anon_sym_u21f8] = ACTIONS(3491),
    [anon_sym_u2945] = ACTIONS(3491),
    [anon_sym_BSLASHequiv] = ACTIONS(3491),
    [anon_sym_u2261] = ACTIONS(3491),
    [anon_sym_LT_EQ_GT] = ACTIONS(3491),
    [anon_sym_u27fa] = ACTIONS(3491),
    [anon_sym_u21d4] = ACTIONS(3491),
    [anon_sym_TILDE_GT] = ACTIONS(3491),
    [anon_sym_u21dd] = ACTIONS(3491),
    [anon_sym_u219d] = ACTIONS(3491),
    [anon_sym_BSLASHland] = ACTIONS(3491),
    [anon_sym_BSLASHlor] = ACTIONS(3491),
    [anon_sym_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2254] = ACTIONS(3491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(3491),
    [anon_sym_u2a74] = ACTIONS(3491),
    [anon_sym_SLASH_EQ] = ACTIONS(3491),
    [anon_sym_POUND] = ACTIONS(3493),
    [anon_sym_u2260] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [sym_gt] = ACTIONS(3493),
    [anon_sym_LT_EQ] = ACTIONS(3493),
    [anon_sym_EQ_LT] = ACTIONS(3491),
    [anon_sym_BSLASHleq] = ACTIONS(3491),
    [anon_sym_u2264] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_BSLASHgeq] = ACTIONS(3491),
    [anon_sym_u2265] = ACTIONS(3491),
    [anon_sym_BSLASHapprox] = ACTIONS(3491),
    [anon_sym_u2248] = ACTIONS(3491),
    [anon_sym_PIPE_DASH] = ACTIONS(3491),
    [anon_sym_u22a2] = ACTIONS(3491),
    [anon_sym_PIPE_EQ] = ACTIONS(3491),
    [anon_sym_u22a8] = ACTIONS(3491),
    [anon_sym_DASH_PIPE] = ACTIONS(3491),
    [anon_sym_u22a3] = ACTIONS(3491),
    [anon_sym_EQ_PIPE] = ACTIONS(3491),
    [anon_sym_u2ae4] = ACTIONS(3491),
    [anon_sym_BSLASHasymp] = ACTIONS(3491),
    [anon_sym_u224d] = ACTIONS(3491),
    [anon_sym_BSLASHcong] = ACTIONS(3491),
    [anon_sym_u2245] = ACTIONS(3491),
    [anon_sym_BSLASHdoteq] = ACTIONS(3491),
    [anon_sym_u2250] = ACTIONS(3491),
    [anon_sym_BSLASHgg] = ACTIONS(3491),
    [anon_sym_u226b] = ACTIONS(3491),
    [anon_sym_BSLASHll] = ACTIONS(3491),
    [anon_sym_u226a] = ACTIONS(3491),
    [anon_sym_BSLASHnotin] = ACTIONS(3491),
    [anon_sym_u2209] = ACTIONS(3491),
    [anon_sym_BSLASHprec] = ACTIONS(3493),
    [anon_sym_u227a] = ACTIONS(3491),
    [anon_sym_BSLASHsucc] = ACTIONS(3493),
    [anon_sym_u227b] = ACTIONS(3491),
    [anon_sym_BSLASHpreceq] = ACTIONS(3491),
    [anon_sym_u2aaf] = ACTIONS(3491),
    [anon_sym_BSLASHsucceq] = ACTIONS(3491),
    [anon_sym_u2ab0] = ACTIONS(3491),
    [anon_sym_BSLASHpropto] = ACTIONS(3491),
    [anon_sym_u221d] = ACTIONS(3491),
    [anon_sym_BSLASHsim] = ACTIONS(3493),
    [anon_sym_u223c] = ACTIONS(3491),
    [anon_sym_BSLASHsimeq] = ACTIONS(3491),
    [anon_sym_u2243] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3493),
    [anon_sym_u228f] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3493),
    [anon_sym_u2290] = ACTIONS(3491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(3491),
    [anon_sym_u2291] = ACTIONS(3491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(3491),
    [anon_sym_u2292] = ACTIONS(3491),
    [anon_sym_BSLASHsubset] = ACTIONS(3493),
    [anon_sym_u2282] = ACTIONS(3491),
    [anon_sym_BSLASHsupset] = ACTIONS(3493),
    [anon_sym_u2283] = ACTIONS(3491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(3491),
    [anon_sym_u2286] = ACTIONS(3491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(3491),
    [anon_sym_u2287] = ACTIONS(3491),
    [sym_compose] = ACTIONS(3491),
    [sym_map_to] = ACTIONS(3491),
    [sym_map_from] = ACTIONS(3491),
    [sym_setminus] = ACTIONS(3493),
    [anon_sym_BSLASHcap] = ACTIONS(3491),
    [anon_sym_BSLASHintersect] = ACTIONS(3491),
    [anon_sym_u2229] = ACTIONS(3491),
    [anon_sym_BSLASHcup] = ACTIONS(3491),
    [anon_sym_BSLASHunion] = ACTIONS(3491),
    [anon_sym_u222a] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_u2025] = ACTIONS(3491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3491),
    [anon_sym_u2026] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3491),
    [sym__dedent] = ACTIONS(3491),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1812] = {
    [sym_block_comment] = STATE(1812),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3537),
    [anon_sym_u25a1] = ACTIONS(3537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3537),
    [sym__dedent] = ACTIONS(3537),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1813] = {
    [sym_block_comment] = STATE(1813),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [anon_sym_DEF] = ACTIONS(3627),
    [anon_sym_DEFS] = ACTIONS(3629),
    [sym__begin_proof_step] = ACTIONS(3629),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1814] = {
    [sym_block_comment] = STATE(1814),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3541),
    [anon_sym_u25a1] = ACTIONS(3541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3541),
    [sym__dedent] = ACTIONS(3541),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1815] = {
    [sym_block_comment] = STATE(1815),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3545),
    [anon_sym_u25a1] = ACTIONS(3545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3545),
    [sym__dedent] = ACTIONS(3545),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1816] = {
    [sym_block_comment] = STATE(1816),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_u25a1] = ACTIONS(3553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3553),
    [sym__dedent] = ACTIONS(3553),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1817] = {
    [sym_block_comment] = STATE(1817),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3511),
    [anon_sym_u25a1] = ACTIONS(3511),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3511),
    [sym__dedent] = ACTIONS(3511),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1818] = {
    [sym_block_comment] = STATE(1818),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3525),
    [anon_sym_u25a1] = ACTIONS(3525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3525),
    [sym__dedent] = ACTIONS(3525),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1819] = {
    [sym_block_comment] = STATE(1819),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(4553),
    [anon_sym_u27fc] = ACTIONS(4553),
    [anon_sym_u21a6] = ACTIONS(4553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(4617),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1820] = {
    [sym_block_comment] = STATE(1820),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3529),
    [anon_sym_u25a1] = ACTIONS(3529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3529),
    [sym__dedent] = ACTIONS(3529),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1821] = {
    [sym_block_comment] = STATE(1821),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3499),
    [anon_sym_u25a1] = ACTIONS(3499),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3499),
    [sym__dedent] = ACTIONS(3499),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1822] = {
    [sym_block_comment] = STATE(1822),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3503),
    [anon_sym_u25a1] = ACTIONS(3503),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3503),
    [sym__dedent] = ACTIONS(3503),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1823] = {
    [sym_block_comment] = STATE(1823),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3507),
    [anon_sym_u25a1] = ACTIONS(3507),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3507),
    [sym__dedent] = ACTIONS(3507),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1824] = {
    [sym_block_comment] = STATE(1824),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3515),
    [anon_sym_u25a1] = ACTIONS(3515),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4503),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(3515),
    [sym__dedent] = ACTIONS(3515),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1825] = {
    [sym_block_comment] = STATE(1825),
    [sym_implies] = STATE(420),
    [sym_plus_arrow] = STATE(421),
    [sym_equiv] = STATE(421),
    [sym_iff] = STATE(421),
    [sym_leads_to] = STATE(421),
    [sym_land] = STATE(422),
    [sym_lor] = STATE(422),
    [sym_assign] = STATE(412),
    [sym_bnf_rule] = STATE(412),
    [sym_eq] = STATE(412),
    [sym_neq] = STATE(412),
    [sym_lt] = STATE(412),
    [sym_leq] = STATE(412),
    [sym_geq] = STATE(412),
    [sym_approx] = STATE(412),
    [sym_rs_ttile] = STATE(412),
    [sym_rd_ttile] = STATE(412),
    [sym_ls_ttile] = STATE(412),
    [sym_ld_ttile] = STATE(412),
    [sym_asymp] = STATE(412),
    [sym_cong] = STATE(412),
    [sym_doteq] = STATE(412),
    [sym_gg] = STATE(412),
    [sym_ll] = STATE(412),
    [sym_in] = STATE(412),
    [sym_notin] = STATE(412),
    [sym_prec] = STATE(412),
    [sym_succ] = STATE(412),
    [sym_preceq] = STATE(412),
    [sym_succeq] = STATE(412),
    [sym_propto] = STATE(412),
    [sym_sim] = STATE(412),
    [sym_simeq] = STATE(412),
    [sym_sqsubset] = STATE(412),
    [sym_sqsupset] = STATE(412),
    [sym_sqsubseteq] = STATE(412),
    [sym_sqsupseteq] = STATE(412),
    [sym_subset] = STATE(412),
    [sym_supset] = STATE(412),
    [sym_subseteq] = STATE(412),
    [sym_supseteq] = STATE(412),
    [sym_cap] = STATE(415),
    [sym_cup] = STATE(415),
    [sym_dots_2] = STATE(423),
    [sym_dots_3] = STATE(423),
    [sym_plus] = STATE(416),
    [sym_oplus] = STATE(416),
    [sym_ominus] = STATE(417),
    [sym_vertvert] = STATE(417),
    [sym_minus] = STATE(417),
    [sym_odot] = STATE(418),
    [sym_oslash] = STATE(418),
    [sym_otimes] = STATE(418),
    [sym_bigcirc] = STATE(418),
    [sym_bullet] = STATE(418),
    [sym_div] = STATE(418),
    [sym_circ] = STATE(418),
    [sym_star] = STATE(418),
    [sym_excl] = STATE(418),
    [sym_qq] = STATE(418),
    [sym_sqcap] = STATE(418),
    [sym_sqcup] = STATE(418),
    [sym_uplus] = STATE(418),
    [sym_times] = STATE(418),
    [sym_wr] = STATE(419),
    [sym_cdot] = STATE(419),
    [sym_sup_plus] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(4615),
    [anon_sym_u27fc] = ACTIONS(4615),
    [anon_sym_u21a6] = ACTIONS(4615),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4615),
    [anon_sym_LBRACK] = ACTIONS(4617),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4340),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(4342),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4344),
    [sym_map_to] = ACTIONS(4346),
    [sym_map_from] = ACTIONS(4346),
    [sym_setminus] = ACTIONS(4348),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4350),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4352),
    [sym_modmod] = ACTIONS(4354),
    [sym_vert] = ACTIONS(4352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4354),
    [sym_amp] = ACTIONS(4356),
    [sym_ampamp] = ACTIONS(4358),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4356),
    [sym_mulmul] = ACTIONS(4358),
    [sym_slash] = ACTIONS(4356),
    [sym_slashslash] = ACTIONS(4358),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4358),
    [sym_dol] = ACTIONS(4356),
    [sym_doldol] = ACTIONS(4358),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4360),
    [sym_powpow] = ACTIONS(4362),
    [anon_sym_CARET_PLUS] = ACTIONS(4364),
    [anon_sym_u207a] = ACTIONS(4364),
    [sym_asterisk] = ACTIONS(4366),
    [sym_sup_hash] = ACTIONS(4366),
    [sym_prime] = ACTIONS(4366),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1826] = {
    [sym_block_comment] = STATE(1826),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4619),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1827] = {
    [sym_block_comment] = STATE(1827),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4623),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1828] = {
    [sym_block_comment] = STATE(1828),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4625),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1829] = {
    [sym_block_comment] = STATE(1829),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4627),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1830] = {
    [sym_block_comment] = STATE(1830),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4629),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1831] = {
    [sym_block_comment] = STATE(1831),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4631),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1832] = {
    [sym_block_comment] = STATE(1832),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4635),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1833] = {
    [sym_block_comment] = STATE(1833),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4637),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1834] = {
    [sym_block_comment] = STATE(1834),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4639),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1835] = {
    [sym_block_comment] = STATE(1835),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4641),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1836] = {
    [sym_block_comment] = STATE(1836),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4643),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1837] = {
    [sym_block_comment] = STATE(1837),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4645),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1838] = {
    [sym_block_comment] = STATE(1838),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4647),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1839] = {
    [sym_block_comment] = STATE(1839),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4649),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1840] = {
    [sym_block_comment] = STATE(1840),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4651),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1841] = {
    [sym_block_comment] = STATE(1841),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4653),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1842] = {
    [sym_block_comment] = STATE(1842),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4655),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1843] = {
    [sym_block_comment] = STATE(1843),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4657),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1844] = {
    [sym_block_comment] = STATE(1844),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4659),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1845] = {
    [sym_block_comment] = STATE(1845),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4661),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1846] = {
    [sym_block_comment] = STATE(1846),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4663),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1847] = {
    [sym_block_comment] = STATE(1847),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_assume_prove_repeat1] = STATE(4586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4665),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(4667),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1848] = {
    [sym_block_comment] = STATE(1848),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_assume_prove_repeat1] = STATE(4619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4665),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(4669),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1849] = {
    [sym_block_comment] = STATE(1849),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_assume_prove_repeat1] = STATE(4634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4665),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(4671),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1850] = {
    [sym_block_comment] = STATE(1850),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_RPAREN] = ACTIONS(4673),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1851] = {
    [sym_block_comment] = STATE(1851),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4771),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4675),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1852] = {
    [sym_block_comment] = STATE(1852),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4677),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1853] = {
    [sym_block_comment] = STATE(1853),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4679),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1854] = {
    [sym_block_comment] = STATE(1854),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_assume_prove_repeat1] = STATE(4537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4665),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(4681),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1855] = {
    [sym_block_comment] = STATE(1855),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [aux_sym_finite_set_literal_repeat1] = STATE(4847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [sym__begin_proof_step] = ACTIONS(4685),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1856] = {
    [sym_block_comment] = STATE(1856),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_RPAREN] = ACTIONS(4687),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1857] = {
    [sym_block_comment] = STATE(1857),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4689),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1858] = {
    [sym_block_comment] = STATE(1858),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4691),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1859] = {
    [sym_block_comment] = STATE(1859),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4693),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1860] = {
    [sym_block_comment] = STATE(1860),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4695),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1861] = {
    [sym_block_comment] = STATE(1861),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4697),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1862] = {
    [sym_block_comment] = STATE(1862),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4699),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1863] = {
    [sym_block_comment] = STATE(1863),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4701),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1864] = {
    [sym_block_comment] = STATE(1864),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4703),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1865] = {
    [sym_block_comment] = STATE(1865),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4705),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1866] = {
    [sym_block_comment] = STATE(1866),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4707),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1867] = {
    [sym_block_comment] = STATE(1867),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4709),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1868] = {
    [sym_block_comment] = STATE(1868),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4711),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1869] = {
    [sym_block_comment] = STATE(1869),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4713),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1870] = {
    [sym_block_comment] = STATE(1870),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4870),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4715),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1871] = {
    [sym_block_comment] = STATE(1871),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4717),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1872] = {
    [sym_block_comment] = STATE(1872),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4719),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1873] = {
    [sym_block_comment] = STATE(1873),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4721),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1874] = {
    [sym_block_comment] = STATE(1874),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4723),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1875] = {
    [sym_block_comment] = STATE(1875),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4725),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1876] = {
    [sym_block_comment] = STATE(1876),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4727),
    [anon_sym_RPAREN] = ACTIONS(4727),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_SEMI] = ACTIONS(4727),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1877] = {
    [sym_block_comment] = STATE(1877),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4729),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1878] = {
    [sym_block_comment] = STATE(1878),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4731),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1879] = {
    [sym_block_comment] = STATE(1879),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4733),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1880] = {
    [sym_block_comment] = STATE(1880),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4735),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1881] = {
    [sym_block_comment] = STATE(1881),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4737),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1882] = {
    [sym_block_comment] = STATE(1882),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_set_of_records_repeat1] = STATE(4448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4621),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4739),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1883] = {
    [sym_block_comment] = STATE(1883),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_finite_set_literal_repeat1] = STATE(4719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4741),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1884] = {
    [sym_block_comment] = STATE(1884),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4743),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1885] = {
    [sym_block_comment] = STATE(1885),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [aux_sym_record_literal_repeat1] = STATE(4476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4745),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1886] = {
    [sym_block_comment] = STATE(1886),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4747),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4747),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1887] = {
    [sym_block_comment] = STATE(1887),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4749),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(4749),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1888] = {
    [sym_block_comment] = STATE(1888),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4751),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(4751),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1889] = {
    [sym_block_comment] = STATE(1889),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_RPAREN] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1890] = {
    [sym_block_comment] = STATE(1890),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_RPAREN] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1891] = {
    [sym_block_comment] = STATE(1891),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [sym__begin_proof_step] = ACTIONS(3637),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1892] = {
    [sym_block_comment] = STATE(1892),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [sym__begin_proof_step] = ACTIONS(3633),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1893] = {
    [sym_block_comment] = STATE(1893),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4615),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [sym__begin_proof_step] = ACTIONS(4615),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1894] = {
    [sym_block_comment] = STATE(1894),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3519),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1895] = {
    [sym_block_comment] = STATE(1895),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [sym__begin_proof_step] = ACTIONS(3641),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1896] = {
    [sym_block_comment] = STATE(1896),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [sym__begin_proof_step] = ACTIONS(4553),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1897] = {
    [sym_block_comment] = STATE(1897),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4753),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4753),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1898] = {
    [sym_block_comment] = STATE(1898),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3637),
    [anon_sym_RPAREN] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1899] = {
    [sym_block_comment] = STATE(1899),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4755),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(4757),
    [sym__dedent] = ACTIONS(4757),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1900] = {
    [sym_block_comment] = STATE(1900),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(3549),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1901] = {
    [sym_block_comment] = STATE(1901),
    [sym_implies] = STATE(394),
    [sym_plus_arrow] = STATE(395),
    [sym_equiv] = STATE(395),
    [sym_iff] = STATE(395),
    [sym_leads_to] = STATE(395),
    [sym_land] = STATE(396),
    [sym_lor] = STATE(396),
    [sym_assign] = STATE(386),
    [sym_bnf_rule] = STATE(386),
    [sym_eq] = STATE(386),
    [sym_neq] = STATE(386),
    [sym_lt] = STATE(386),
    [sym_leq] = STATE(386),
    [sym_geq] = STATE(386),
    [sym_approx] = STATE(386),
    [sym_rs_ttile] = STATE(386),
    [sym_rd_ttile] = STATE(386),
    [sym_ls_ttile] = STATE(386),
    [sym_ld_ttile] = STATE(386),
    [sym_asymp] = STATE(386),
    [sym_cong] = STATE(386),
    [sym_doteq] = STATE(386),
    [sym_gg] = STATE(386),
    [sym_ll] = STATE(386),
    [sym_in] = STATE(386),
    [sym_notin] = STATE(386),
    [sym_prec] = STATE(386),
    [sym_succ] = STATE(386),
    [sym_preceq] = STATE(386),
    [sym_succeq] = STATE(386),
    [sym_propto] = STATE(386),
    [sym_sim] = STATE(386),
    [sym_simeq] = STATE(386),
    [sym_sqsubset] = STATE(386),
    [sym_sqsupset] = STATE(386),
    [sym_sqsubseteq] = STATE(386),
    [sym_sqsupseteq] = STATE(386),
    [sym_subset] = STATE(386),
    [sym_supset] = STATE(386),
    [sym_subseteq] = STATE(386),
    [sym_supseteq] = STATE(386),
    [sym_cap] = STATE(389),
    [sym_cup] = STATE(389),
    [sym_dots_2] = STATE(397),
    [sym_dots_3] = STATE(397),
    [sym_plus] = STATE(390),
    [sym_oplus] = STATE(390),
    [sym_ominus] = STATE(391),
    [sym_vertvert] = STATE(391),
    [sym_minus] = STATE(391),
    [sym_odot] = STATE(392),
    [sym_oslash] = STATE(392),
    [sym_otimes] = STATE(392),
    [sym_bigcirc] = STATE(392),
    [sym_bullet] = STATE(392),
    [sym_div] = STATE(392),
    [sym_circ] = STATE(392),
    [sym_star] = STATE(392),
    [sym_excl] = STATE(392),
    [sym_qq] = STATE(392),
    [sym_sqcap] = STATE(392),
    [sym_sqcup] = STATE(392),
    [sym_uplus] = STATE(392),
    [sym_times] = STATE(392),
    [sym_wr] = STATE(393),
    [sym_cdot] = STATE(393),
    [sym_sup_plus] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4755),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4509),
    [sym_map_to] = ACTIONS(4511),
    [sym_map_from] = ACTIONS(4511),
    [sym_setminus] = ACTIONS(4513),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4515),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4517),
    [sym_modmod] = ACTIONS(4519),
    [sym_vert] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4519),
    [sym_amp] = ACTIONS(4521),
    [sym_ampamp] = ACTIONS(4523),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4521),
    [sym_mulmul] = ACTIONS(4523),
    [sym_slash] = ACTIONS(4521),
    [sym_slashslash] = ACTIONS(4523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4523),
    [sym_dol] = ACTIONS(4521),
    [sym_doldol] = ACTIONS(4523),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4525),
    [sym_powpow] = ACTIONS(4527),
    [anon_sym_CARET_PLUS] = ACTIONS(4529),
    [anon_sym_u207a] = ACTIONS(4529),
    [sym_asterisk] = ACTIONS(4531),
    [sym_sup_hash] = ACTIONS(4531),
    [sym_prime] = ACTIONS(4531),
    [sym__bullet] = ACTIONS(4759),
    [sym__dedent] = ACTIONS(4759),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1902] = {
    [sym_block_comment] = STATE(1902),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4761),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_PROVE] = ACTIONS(4761),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1903] = {
    [sym_block_comment] = STATE(1903),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4763),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4763),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1904] = {
    [sym_block_comment] = STATE(1904),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(4571),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [sym__begin_proof_step] = ACTIONS(4571),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1905] = {
    [sym_block_comment] = STATE(1905),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4765),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1906] = {
    [sym_block_comment] = STATE(1906),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4767),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1907] = {
    [sym_block_comment] = STATE(1907),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4769),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1908] = {
    [sym_block_comment] = STATE(1908),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_do] = ACTIONS(4771),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1909] = {
    [sym_block_comment] = STATE(1909),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4773),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1910] = {
    [sym_block_comment] = STATE(1910),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4775),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1911] = {
    [sym_block_comment] = STATE(1911),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4777),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1912] = {
    [sym_block_comment] = STATE(1912),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4779),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1913] = {
    [sym_block_comment] = STATE(1913),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4781),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1914] = {
    [sym_block_comment] = STATE(1914),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4783),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1915] = {
    [sym_block_comment] = STATE(1915),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(4785),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1916] = {
    [sym_block_comment] = STATE(1916),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4787),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1917] = {
    [sym_block_comment] = STATE(1917),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4789),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1918] = {
    [sym_block_comment] = STATE(1918),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4791),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1919] = {
    [sym_block_comment] = STATE(1919),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4793),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1920] = {
    [sym_block_comment] = STATE(1920),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4795),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1921] = {
    [sym_block_comment] = STATE(1921),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4797),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1922] = {
    [sym_block_comment] = STATE(1922),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4799),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1923] = {
    [sym_block_comment] = STATE(1923),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4801),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1924] = {
    [sym_block_comment] = STATE(1924),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4803),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1925] = {
    [sym_block_comment] = STATE(1925),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4805),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1926] = {
    [sym_block_comment] = STATE(1926),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4807),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1927] = {
    [sym_block_comment] = STATE(1927),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(4809),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1928] = {
    [sym_block_comment] = STATE(1928),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4811),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1929] = {
    [sym_block_comment] = STATE(1929),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4813),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1930] = {
    [sym_block_comment] = STATE(1930),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4815),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1931] = {
    [sym_block_comment] = STATE(1931),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(4817),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1932] = {
    [sym_block_comment] = STATE(1932),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4819),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1933] = {
    [sym_block_comment] = STATE(1933),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4821),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1934] = {
    [sym_block_comment] = STATE(1934),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4823),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1935] = {
    [sym_block_comment] = STATE(1935),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4825),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1936] = {
    [sym_block_comment] = STATE(1936),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1937] = {
    [sym_block_comment] = STATE(1937),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4829),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1938] = {
    [sym_block_comment] = STATE(1938),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4831),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1939] = {
    [sym_block_comment] = STATE(1939),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(4833),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1940] = {
    [sym_block_comment] = STATE(1940),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4835),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1941] = {
    [sym_block_comment] = STATE(1941),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1942] = {
    [sym_block_comment] = STATE(1942),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4839),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1943] = {
    [sym_block_comment] = STATE(1943),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4841),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1944] = {
    [sym_block_comment] = STATE(1944),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4843),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1945] = {
    [sym_block_comment] = STATE(1945),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4845),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1946] = {
    [sym_block_comment] = STATE(1946),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4847),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1947] = {
    [sym_block_comment] = STATE(1947),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4849),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1948] = {
    [sym_block_comment] = STATE(1948),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4851),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1949] = {
    [sym_block_comment] = STATE(1949),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4853),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1950] = {
    [sym_block_comment] = STATE(1950),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4855),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1951] = {
    [sym_block_comment] = STATE(1951),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4857),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1952] = {
    [sym_block_comment] = STATE(1952),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4859),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1953] = {
    [sym_block_comment] = STATE(1953),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4861),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1954] = {
    [sym_block_comment] = STATE(1954),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(4863),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1955] = {
    [sym_block_comment] = STATE(1955),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4865),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1956] = {
    [sym_block_comment] = STATE(1956),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4867),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1957] = {
    [sym_block_comment] = STATE(1957),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4869),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1958] = {
    [sym_block_comment] = STATE(1958),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1959] = {
    [sym_block_comment] = STATE(1959),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4873),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1960] = {
    [sym_block_comment] = STATE(1960),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(4875),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1961] = {
    [sym_block_comment] = STATE(1961),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4877),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1962] = {
    [sym_block_comment] = STATE(1962),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4879),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1963] = {
    [sym_block_comment] = STATE(1963),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4881),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1964] = {
    [sym_block_comment] = STATE(1964),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4883),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1965] = {
    [sym_block_comment] = STATE(1965),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4885),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1966] = {
    [sym_block_comment] = STATE(1966),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4887),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1967] = {
    [sym_block_comment] = STATE(1967),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4889),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1968] = {
    [sym_block_comment] = STATE(1968),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4891),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1969] = {
    [sym_block_comment] = STATE(1969),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(4893),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1970] = {
    [sym_block_comment] = STATE(1970),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4895),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1971] = {
    [sym_block_comment] = STATE(1971),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4897),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1972] = {
    [sym_block_comment] = STATE(1972),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4899),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1973] = {
    [sym_block_comment] = STATE(1973),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4901),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1974] = {
    [sym_block_comment] = STATE(1974),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4903),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1975] = {
    [sym_block_comment] = STATE(1975),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1976] = {
    [sym_block_comment] = STATE(1976),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4907),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1977] = {
    [sym_block_comment] = STATE(1977),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4909),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1978] = {
    [sym_block_comment] = STATE(1978),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4911),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1979] = {
    [sym_block_comment] = STATE(1979),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4913),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1980] = {
    [sym_block_comment] = STATE(1980),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4915),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1981] = {
    [sym_block_comment] = STATE(1981),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4917),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1982] = {
    [sym_block_comment] = STATE(1982),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4919),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1983] = {
    [sym_block_comment] = STATE(1983),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(4921),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1984] = {
    [sym_block_comment] = STATE(1984),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4923),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1985] = {
    [sym_block_comment] = STATE(1985),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4925),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1986] = {
    [sym_block_comment] = STATE(1986),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4927),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1987] = {
    [sym_block_comment] = STATE(1987),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4929),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1988] = {
    [sym_block_comment] = STATE(1988),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4931),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1989] = {
    [sym_block_comment] = STATE(1989),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4933),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1990] = {
    [sym_block_comment] = STATE(1990),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4935),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1991] = {
    [sym_block_comment] = STATE(1991),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4937),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1992] = {
    [sym_block_comment] = STATE(1992),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1993] = {
    [sym_block_comment] = STATE(1993),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4941),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1994] = {
    [sym_block_comment] = STATE(1994),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4943),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1995] = {
    [sym_block_comment] = STATE(1995),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4945),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1996] = {
    [sym_block_comment] = STATE(1996),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4947),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1997] = {
    [sym_block_comment] = STATE(1997),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4949),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1998] = {
    [sym_block_comment] = STATE(1998),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(4951),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [1999] = {
    [sym_block_comment] = STATE(1999),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4953),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2000] = {
    [sym_block_comment] = STATE(2000),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2001] = {
    [sym_block_comment] = STATE(2001),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4957),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2002] = {
    [sym_block_comment] = STATE(2002),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4959),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2003] = {
    [sym_block_comment] = STATE(2003),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4961),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2004] = {
    [sym_block_comment] = STATE(2004),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4963),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2005] = {
    [sym_block_comment] = STATE(2005),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2006] = {
    [sym_block_comment] = STATE(2006),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4967),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2007] = {
    [sym_block_comment] = STATE(2007),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4969),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2008] = {
    [sym_block_comment] = STATE(2008),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4971),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2009] = {
    [sym_block_comment] = STATE(2009),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4973),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2010] = {
    [sym_block_comment] = STATE(2010),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(4975),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2011] = {
    [sym_block_comment] = STATE(2011),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4977),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2012] = {
    [sym_block_comment] = STATE(2012),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4979),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2013] = {
    [sym_block_comment] = STATE(2013),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2014] = {
    [sym_block_comment] = STATE(2014),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4983),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2015] = {
    [sym_block_comment] = STATE(2015),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(4985),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2016] = {
    [sym_block_comment] = STATE(2016),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4987),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2017] = {
    [sym_block_comment] = STATE(2017),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2018] = {
    [sym_block_comment] = STATE(2018),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(4991),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2019] = {
    [sym_block_comment] = STATE(2019),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2020] = {
    [sym_block_comment] = STATE(2020),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4995),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2021] = {
    [sym_block_comment] = STATE(2021),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(4997),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2022] = {
    [sym_block_comment] = STATE(2022),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(4999),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2023] = {
    [sym_block_comment] = STATE(2023),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5001),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2024] = {
    [sym_block_comment] = STATE(2024),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2025] = {
    [sym_block_comment] = STATE(2025),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5005),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2026] = {
    [sym_block_comment] = STATE(2026),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5007),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2027] = {
    [sym_block_comment] = STATE(2027),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5009),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2028] = {
    [sym_block_comment] = STATE(2028),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5011),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2029] = {
    [sym_block_comment] = STATE(2029),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(5013),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2030] = {
    [sym_block_comment] = STATE(2030),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(5015),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2031] = {
    [sym_block_comment] = STATE(2031),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_then] = ACTIONS(5017),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2032] = {
    [sym_block_comment] = STATE(2032),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5019),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2033] = {
    [sym_block_comment] = STATE(2033),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5021),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2034] = {
    [sym_block_comment] = STATE(2034),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5023),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2035] = {
    [sym_block_comment] = STATE(2035),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5025),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2036] = {
    [sym_block_comment] = STATE(2036),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5027),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2037] = {
    [sym_block_comment] = STATE(2037),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5029),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2038] = {
    [sym_block_comment] = STATE(2038),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5031),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2039] = {
    [sym_block_comment] = STATE(2039),
    [sym_implies] = STATE(640),
    [sym_plus_arrow] = STATE(641),
    [sym_equiv] = STATE(641),
    [sym_iff] = STATE(641),
    [sym_leads_to] = STATE(641),
    [sym_land] = STATE(642),
    [sym_lor] = STATE(642),
    [sym_assign] = STATE(632),
    [sym_bnf_rule] = STATE(632),
    [sym_eq] = STATE(632),
    [sym_neq] = STATE(632),
    [sym_lt] = STATE(632),
    [sym_leq] = STATE(632),
    [sym_geq] = STATE(632),
    [sym_approx] = STATE(632),
    [sym_rs_ttile] = STATE(632),
    [sym_rd_ttile] = STATE(632),
    [sym_ls_ttile] = STATE(632),
    [sym_ld_ttile] = STATE(632),
    [sym_asymp] = STATE(632),
    [sym_cong] = STATE(632),
    [sym_doteq] = STATE(632),
    [sym_gg] = STATE(632),
    [sym_ll] = STATE(632),
    [sym_in] = STATE(632),
    [sym_notin] = STATE(632),
    [sym_prec] = STATE(632),
    [sym_succ] = STATE(632),
    [sym_preceq] = STATE(632),
    [sym_succeq] = STATE(632),
    [sym_propto] = STATE(632),
    [sym_sim] = STATE(632),
    [sym_simeq] = STATE(632),
    [sym_sqsubset] = STATE(632),
    [sym_sqsupset] = STATE(632),
    [sym_sqsubseteq] = STATE(632),
    [sym_sqsupseteq] = STATE(632),
    [sym_subset] = STATE(632),
    [sym_supset] = STATE(632),
    [sym_subseteq] = STATE(632),
    [sym_supseteq] = STATE(632),
    [sym_cap] = STATE(635),
    [sym_cup] = STATE(635),
    [sym_dots_2] = STATE(643),
    [sym_dots_3] = STATE(643),
    [sym_plus] = STATE(636),
    [sym_oplus] = STATE(636),
    [sym_ominus] = STATE(637),
    [sym_vertvert] = STATE(637),
    [sym_minus] = STATE(637),
    [sym_odot] = STATE(638),
    [sym_oslash] = STATE(638),
    [sym_otimes] = STATE(638),
    [sym_bigcirc] = STATE(638),
    [sym_bullet] = STATE(638),
    [sym_div] = STATE(638),
    [sym_circ] = STATE(638),
    [sym_star] = STATE(638),
    [sym_excl] = STATE(638),
    [sym_qq] = STATE(638),
    [sym_sqcap] = STATE(638),
    [sym_sqcup] = STATE(638),
    [sym_uplus] = STATE(638),
    [sym_times] = STATE(638),
    [sym_wr] = STATE(639),
    [sym_cdot] = STATE(639),
    [sym_sup_plus] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4493),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(4400),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(4402),
    [sym_map_to] = ACTIONS(4404),
    [sym_map_from] = ACTIONS(4404),
    [sym_setminus] = ACTIONS(4406),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(4408),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(4410),
    [sym_modmod] = ACTIONS(4412),
    [sym_vert] = ACTIONS(4410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(4412),
    [sym_amp] = ACTIONS(4414),
    [sym_ampamp] = ACTIONS(4416),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(4414),
    [sym_mulmul] = ACTIONS(4416),
    [sym_slash] = ACTIONS(4414),
    [sym_slashslash] = ACTIONS(4416),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(4416),
    [sym_dol] = ACTIONS(4414),
    [sym_doldol] = ACTIONS(4416),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(4384),
    [sym_powpow] = ACTIONS(4386),
    [anon_sym_CARET_PLUS] = ACTIONS(4388),
    [anon_sym_u207a] = ACTIONS(4388),
    [sym_asterisk] = ACTIONS(4390),
    [sym_sup_hash] = ACTIONS(4390),
    [sym_prime] = ACTIONS(4390),
    [sym__begin_proof_step] = ACTIONS(5033),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2040] = {
    [sym_block_comment] = STATE(2040),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5035),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2041] = {
    [sym_block_comment] = STATE(2041),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(5037),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2042] = {
    [sym_block_comment] = STATE(2042),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(5039),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2043] = {
    [sym_block_comment] = STATE(2043),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5041),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2044] = {
    [sym_block_comment] = STATE(2044),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2045] = {
    [sym_block_comment] = STATE(2045),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5045),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2046] = {
    [sym_block_comment] = STATE(2046),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(5047),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2047] = {
    [sym_block_comment] = STATE(2047),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5049),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2048] = {
    [sym_block_comment] = STATE(2048),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5051),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2049] = {
    [sym_block_comment] = STATE(2049),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5053),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2050] = {
    [sym_block_comment] = STATE(2050),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5055),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2051] = {
    [sym_block_comment] = STATE(2051),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5057),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2052] = {
    [sym_block_comment] = STATE(2052),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5059),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2053] = {
    [sym_block_comment] = STATE(2053),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(5061),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2054] = {
    [sym_block_comment] = STATE(2054),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2055] = {
    [sym_block_comment] = STATE(2055),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5065),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2056] = {
    [sym_block_comment] = STATE(2056),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5067),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2057] = {
    [sym_block_comment] = STATE(2057),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(5069),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2058] = {
    [sym_block_comment] = STATE(2058),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(5071),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2059] = {
    [sym_block_comment] = STATE(2059),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5073),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2060] = {
    [sym_block_comment] = STATE(2060),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(5075),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2061] = {
    [sym_block_comment] = STATE(2061),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5077),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2062] = {
    [sym_block_comment] = STATE(2062),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5079),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2063] = {
    [sym_block_comment] = STATE(2063),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5081),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2064] = {
    [sym_block_comment] = STATE(2064),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5083),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2065] = {
    [sym_block_comment] = STATE(2065),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5085),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2066] = {
    [sym_block_comment] = STATE(2066),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(5087),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2067] = {
    [sym_block_comment] = STATE(2067),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5089),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2068] = {
    [sym_block_comment] = STATE(2068),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5091),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2069] = {
    [sym_block_comment] = STATE(2069),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5093),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2070] = {
    [sym_block_comment] = STATE(2070),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5095),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2071] = {
    [sym_block_comment] = STATE(2071),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5097),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2072] = {
    [sym_block_comment] = STATE(2072),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(5099),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2073] = {
    [sym_block_comment] = STATE(2073),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(5101),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2074] = {
    [sym_block_comment] = STATE(2074),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5103),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2075] = {
    [sym_block_comment] = STATE(2075),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5105),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2076] = {
    [sym_block_comment] = STATE(2076),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5107),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2077] = {
    [sym_block_comment] = STATE(2077),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5109),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2078] = {
    [sym_block_comment] = STATE(2078),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2079] = {
    [sym_block_comment] = STATE(2079),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_ELSE] = ACTIONS(5113),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2080] = {
    [sym_block_comment] = STATE(2080),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5115),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2081] = {
    [sym_block_comment] = STATE(2081),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5117),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2082] = {
    [sym_block_comment] = STATE(2082),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2083] = {
    [sym_block_comment] = STATE(2083),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5121),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2084] = {
    [sym_block_comment] = STATE(2084),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2085] = {
    [sym_block_comment] = STATE(2085),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5125),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2086] = {
    [sym_block_comment] = STATE(2086),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2087] = {
    [sym_block_comment] = STATE(2087),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5129),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2088] = {
    [sym_block_comment] = STATE(2088),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2089] = {
    [sym_block_comment] = STATE(2089),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5133),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2090] = {
    [sym_block_comment] = STATE(2090),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5135),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2091] = {
    [sym_block_comment] = STATE(2091),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5137),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2092] = {
    [sym_block_comment] = STATE(2092),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5139),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2093] = {
    [sym_block_comment] = STATE(2093),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5141),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2094] = {
    [sym_block_comment] = STATE(2094),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5143),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2095] = {
    [sym_block_comment] = STATE(2095),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5145),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2096] = {
    [sym_block_comment] = STATE(2096),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5147),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2097] = {
    [sym_block_comment] = STATE(2097),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5149),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2098] = {
    [sym_block_comment] = STATE(2098),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5151),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2099] = {
    [sym_block_comment] = STATE(2099),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5153),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2100] = {
    [sym_block_comment] = STATE(2100),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5155),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2101] = {
    [sym_block_comment] = STATE(2101),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5157),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2102] = {
    [sym_block_comment] = STATE(2102),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5159),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2103] = {
    [sym_block_comment] = STATE(2103),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5161),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2104] = {
    [sym_block_comment] = STATE(2104),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5163),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2105] = {
    [sym_block_comment] = STATE(2105),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_THEN] = ACTIONS(5165),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2106] = {
    [sym_block_comment] = STATE(2106),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2107] = {
    [sym_block_comment] = STATE(2107),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(5169),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2108] = {
    [sym_block_comment] = STATE(2108),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_RBRACK] = ACTIONS(5171),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2109] = {
    [sym_block_comment] = STATE(2109),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5173),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2110] = {
    [sym_block_comment] = STATE(2110),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5175),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2111] = {
    [sym_block_comment] = STATE(2111),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [anon_sym_then] = ACTIONS(5177),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2112] = {
    [sym_block_comment] = STATE(2112),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2113] = {
    [sym_block_comment] = STATE(2113),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(5181),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2114] = {
    [sym_block_comment] = STATE(2114),
    [sym_implies] = STATE(1041),
    [sym_plus_arrow] = STATE(1042),
    [sym_equiv] = STATE(1042),
    [sym_iff] = STATE(1042),
    [sym_leads_to] = STATE(1042),
    [sym_land] = STATE(1043),
    [sym_lor] = STATE(1043),
    [sym_assign] = STATE(999),
    [sym_bnf_rule] = STATE(999),
    [sym_eq] = STATE(999),
    [sym_neq] = STATE(999),
    [sym_lt] = STATE(999),
    [sym_leq] = STATE(999),
    [sym_geq] = STATE(999),
    [sym_approx] = STATE(999),
    [sym_rs_ttile] = STATE(999),
    [sym_rd_ttile] = STATE(999),
    [sym_ls_ttile] = STATE(999),
    [sym_ld_ttile] = STATE(999),
    [sym_asymp] = STATE(999),
    [sym_cong] = STATE(999),
    [sym_doteq] = STATE(999),
    [sym_gg] = STATE(999),
    [sym_ll] = STATE(999),
    [sym_in] = STATE(999),
    [sym_notin] = STATE(999),
    [sym_prec] = STATE(999),
    [sym_succ] = STATE(999),
    [sym_preceq] = STATE(999),
    [sym_succeq] = STATE(999),
    [sym_propto] = STATE(999),
    [sym_sim] = STATE(999),
    [sym_simeq] = STATE(999),
    [sym_sqsubset] = STATE(999),
    [sym_sqsupset] = STATE(999),
    [sym_sqsubseteq] = STATE(999),
    [sym_sqsupseteq] = STATE(999),
    [sym_subset] = STATE(999),
    [sym_supset] = STATE(999),
    [sym_subseteq] = STATE(999),
    [sym_supseteq] = STATE(999),
    [sym_cap] = STATE(1015),
    [sym_cup] = STATE(1015),
    [sym_dots_2] = STATE(1044),
    [sym_dots_3] = STATE(1044),
    [sym_plus] = STATE(1024),
    [sym_oplus] = STATE(1024),
    [sym_ominus] = STATE(1030),
    [sym_vertvert] = STATE(1030),
    [sym_minus] = STATE(1030),
    [sym_odot] = STATE(1039),
    [sym_oslash] = STATE(1039),
    [sym_otimes] = STATE(1039),
    [sym_bigcirc] = STATE(1039),
    [sym_bullet] = STATE(1039),
    [sym_div] = STATE(1039),
    [sym_circ] = STATE(1039),
    [sym_star] = STATE(1039),
    [sym_excl] = STATE(1039),
    [sym_qq] = STATE(1039),
    [sym_sqcap] = STATE(1039),
    [sym_sqcup] = STATE(1039),
    [sym_uplus] = STATE(1039),
    [sym_times] = STATE(1039),
    [sym_wr] = STATE(1040),
    [sym_cdot] = STATE(1040),
    [sym_sup_plus] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2338),
    [anon_sym_u2208] = ACTIONS(2340),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2342),
    [anon_sym_u2227] = ACTIONS(2342),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2344),
    [anon_sym_u2228] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(5183),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_BSLASHo] = ACTIONS(2348),
    [anon_sym_DOT] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_EQ_GT] = ACTIONS(2356),
    [anon_sym_u27f9] = ACTIONS(2356),
    [anon_sym_u21d2] = ACTIONS(2356),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2358),
    [anon_sym_u21f8] = ACTIONS(2358),
    [anon_sym_u2945] = ACTIONS(2358),
    [anon_sym_BSLASHequiv] = ACTIONS(2360),
    [anon_sym_u2261] = ACTIONS(2360),
    [anon_sym_LT_EQ_GT] = ACTIONS(2362),
    [anon_sym_u27fa] = ACTIONS(2362),
    [anon_sym_u21d4] = ACTIONS(2362),
    [anon_sym_TILDE_GT] = ACTIONS(2364),
    [anon_sym_u21dd] = ACTIONS(2364),
    [anon_sym_u219d] = ACTIONS(2364),
    [anon_sym_BSLASHland] = ACTIONS(2342),
    [anon_sym_BSLASHlor] = ACTIONS(2344),
    [anon_sym_COLON_EQ] = ACTIONS(2366),
    [anon_sym_u2254] = ACTIONS(2366),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2368),
    [anon_sym_u2a74] = ACTIONS(2368),
    [anon_sym_SLASH_EQ] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2372),
    [anon_sym_u2260] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2374),
    [sym_gt] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(2378),
    [anon_sym_EQ_LT] = ACTIONS(2380),
    [anon_sym_BSLASHleq] = ACTIONS(2380),
    [anon_sym_u2264] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2382),
    [anon_sym_BSLASHgeq] = ACTIONS(2382),
    [anon_sym_u2265] = ACTIONS(2382),
    [anon_sym_BSLASHapprox] = ACTIONS(2384),
    [anon_sym_u2248] = ACTIONS(2384),
    [anon_sym_PIPE_DASH] = ACTIONS(2386),
    [anon_sym_u22a2] = ACTIONS(2386),
    [anon_sym_PIPE_EQ] = ACTIONS(2388),
    [anon_sym_u22a8] = ACTIONS(2388),
    [anon_sym_DASH_PIPE] = ACTIONS(2390),
    [anon_sym_u22a3] = ACTIONS(2390),
    [anon_sym_EQ_PIPE] = ACTIONS(2392),
    [anon_sym_u2ae4] = ACTIONS(2392),
    [anon_sym_BSLASHasymp] = ACTIONS(2394),
    [anon_sym_u224d] = ACTIONS(2394),
    [anon_sym_BSLASHcong] = ACTIONS(2396),
    [anon_sym_u2245] = ACTIONS(2396),
    [anon_sym_BSLASHdoteq] = ACTIONS(2398),
    [anon_sym_u2250] = ACTIONS(2398),
    [anon_sym_BSLASHgg] = ACTIONS(2400),
    [anon_sym_u226b] = ACTIONS(2400),
    [anon_sym_BSLASHll] = ACTIONS(2402),
    [anon_sym_u226a] = ACTIONS(2402),
    [anon_sym_BSLASHnotin] = ACTIONS(2404),
    [anon_sym_u2209] = ACTIONS(2404),
    [anon_sym_BSLASHprec] = ACTIONS(2406),
    [anon_sym_u227a] = ACTIONS(2408),
    [anon_sym_BSLASHsucc] = ACTIONS(2410),
    [anon_sym_u227b] = ACTIONS(2412),
    [anon_sym_BSLASHpreceq] = ACTIONS(2414),
    [anon_sym_u2aaf] = ACTIONS(2414),
    [anon_sym_BSLASHsucceq] = ACTIONS(2416),
    [anon_sym_u2ab0] = ACTIONS(2416),
    [anon_sym_BSLASHpropto] = ACTIONS(2418),
    [anon_sym_u221d] = ACTIONS(2418),
    [anon_sym_BSLASHsim] = ACTIONS(2420),
    [anon_sym_u223c] = ACTIONS(2422),
    [anon_sym_BSLASHsimeq] = ACTIONS(2424),
    [anon_sym_u2243] = ACTIONS(2424),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2426),
    [anon_sym_u228f] = ACTIONS(2428),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2430),
    [anon_sym_u2290] = ACTIONS(2432),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2434),
    [anon_sym_u2291] = ACTIONS(2434),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2436),
    [anon_sym_u2292] = ACTIONS(2436),
    [anon_sym_BSLASHsubset] = ACTIONS(2438),
    [anon_sym_u2282] = ACTIONS(2440),
    [anon_sym_BSLASHsupset] = ACTIONS(2442),
    [anon_sym_u2283] = ACTIONS(2444),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2446),
    [anon_sym_u2286] = ACTIONS(2446),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2448),
    [anon_sym_u2287] = ACTIONS(2448),
    [sym_compose] = ACTIONS(3729),
    [sym_map_to] = ACTIONS(3731),
    [sym_map_from] = ACTIONS(3731),
    [sym_setminus] = ACTIONS(3733),
    [anon_sym_BSLASHcap] = ACTIONS(2456),
    [anon_sym_BSLASHintersect] = ACTIONS(2456),
    [anon_sym_u2229] = ACTIONS(2456),
    [anon_sym_BSLASHcup] = ACTIONS(2458),
    [anon_sym_BSLASHunion] = ACTIONS(2458),
    [anon_sym_u222a] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym_u2025] = ACTIONS(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_u2026] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [sym_plusplus] = ACTIONS(3735),
    [anon_sym_BSLASHoplus] = ACTIONS(2470),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2470),
    [anon_sym_u2295] = ACTIONS(2470),
    [anon_sym_BSLASHominus] = ACTIONS(2472),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2472),
    [anon_sym_u2296] = ACTIONS(2472),
    [sym_mod] = ACTIONS(3737),
    [sym_modmod] = ACTIONS(3739),
    [sym_vert] = ACTIONS(3737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_u2016] = ACTIONS(2478),
    [sym_minusminus] = ACTIONS(3739),
    [sym_amp] = ACTIONS(3741),
    [sym_ampamp] = ACTIONS(3743),
    [anon_sym_BSLASHodot] = ACTIONS(2484),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2484),
    [anon_sym_u2299] = ACTIONS(2484),
    [anon_sym_BSLASHoslash] = ACTIONS(2486),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2486),
    [anon_sym_u2298] = ACTIONS(2486),
    [anon_sym_BSLASHotimes] = ACTIONS(2488),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2488),
    [anon_sym_u2297] = ACTIONS(2488),
    [sym_mul] = ACTIONS(3741),
    [sym_mulmul] = ACTIONS(3743),
    [sym_slash] = ACTIONS(3741),
    [sym_slashslash] = ACTIONS(3743),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2490),
    [anon_sym_u25ef] = ACTIONS(2490),
    [anon_sym_BSLASHbullet] = ACTIONS(2492),
    [anon_sym_u25cf] = ACTIONS(2492),
    [anon_sym_BSLASHdiv] = ACTIONS(2494),
    [anon_sym_u00f7] = ACTIONS(2494),
    [anon_sym_BSLASHcirc] = ACTIONS(2496),
    [anon_sym_u2218] = ACTIONS(2496),
    [anon_sym_BSLASHstar] = ACTIONS(2498),
    [anon_sym_u22c6] = ACTIONS(2498),
    [anon_sym_u203c] = ACTIONS(2500),
    [sym_hashhash] = ACTIONS(3743),
    [sym_dol] = ACTIONS(3741),
    [sym_doldol] = ACTIONS(3743),
    [anon_sym_QMARK_QMARK] = ACTIONS(2502),
    [anon_sym_u2047] = ACTIONS(2502),
    [anon_sym_BSLASHsqcap] = ACTIONS(2504),
    [anon_sym_u2293] = ACTIONS(2504),
    [anon_sym_BSLASHsqcup] = ACTIONS(2506),
    [anon_sym_u2294] = ACTIONS(2506),
    [anon_sym_BSLASHuplus] = ACTIONS(2508),
    [anon_sym_u228e] = ACTIONS(2508),
    [anon_sym_BSLASHX] = ACTIONS(2510),
    [anon_sym_BSLASHtimes] = ACTIONS(2510),
    [anon_sym_u00d7] = ACTIONS(2510),
    [anon_sym_BSLASHwr] = ACTIONS(2512),
    [anon_sym_u2240] = ACTIONS(2512),
    [anon_sym_BSLASHcdot] = ACTIONS(2514),
    [anon_sym_u22c5] = ACTIONS(2514),
    [sym_pow] = ACTIONS(3719),
    [sym_powpow] = ACTIONS(3721),
    [anon_sym_CARET_PLUS] = ACTIONS(3723),
    [anon_sym_u207a] = ACTIONS(3723),
    [sym_asterisk] = ACTIONS(3725),
    [sym_sup_hash] = ACTIONS(3725),
    [sym_prime] = ACTIONS(3725),
    [sym__double_excl] = ACTIONS(2500),
  },
  [2115] = {
    [sym_block_comment] = STATE(2115),
    [sym_implies] = STATE(5458),
    [sym_plus_arrow] = STATE(5458),
    [sym_equiv] = STATE(5458),
    [sym_iff] = STATE(5458),
    [sym_leads_to] = STATE(5458),
    [sym_land] = STATE(5458),
    [sym_lor] = STATE(5458),
    [sym_assign] = STATE(5458),
    [sym_bnf_rule] = STATE(5458),
    [sym_eq] = STATE(5458),
    [sym_neq] = STATE(5458),
    [sym_lt] = STATE(5458),
    [sym_leq] = STATE(5458),
    [sym_geq] = STATE(5458),
    [sym_approx] = STATE(5458),
    [sym_rs_ttile] = STATE(5458),
    [sym_rd_ttile] = STATE(5458),
    [sym_ls_ttile] = STATE(5458),
    [sym_ld_ttile] = STATE(5458),
    [sym_asymp] = STATE(5458),
    [sym_cong] = STATE(5458),
    [sym_doteq] = STATE(5458),
    [sym_gg] = STATE(5458),
    [sym_ll] = STATE(5458),
    [sym_in] = STATE(5458),
    [sym_notin] = STATE(5458),
    [sym_prec] = STATE(5458),
    [sym_succ] = STATE(5458),
    [sym_preceq] = STATE(5458),
    [sym_succeq] = STATE(5458),
    [sym_propto] = STATE(5458),
    [sym_sim] = STATE(5458),
    [sym_simeq] = STATE(5458),
    [sym_sqsubset] = STATE(5458),
    [sym_sqsupset] = STATE(5458),
    [sym_sqsubseteq] = STATE(5458),
    [sym_sqsupseteq] = STATE(5458),
    [sym_subset] = STATE(5458),
    [sym_supset] = STATE(5458),
    [sym_subseteq] = STATE(5458),
    [sym_supseteq] = STATE(5458),
    [sym_cap] = STATE(5458),
    [sym_cup] = STATE(5458),
    [sym_dots_2] = STATE(5458),
    [sym_dots_3] = STATE(5458),
    [sym_plus] = STATE(5458),
    [sym_oplus] = STATE(5458),
    [sym_ominus] = STATE(5458),
    [sym_vertvert] = STATE(5458),
    [sym_minus] = STATE(5458),
    [sym_odot] = STATE(5458),
    [sym_oslash] = STATE(5458),
    [sym_otimes] = STATE(5458),
    [sym_bigcirc] = STATE(5458),
    [sym_bullet] = STATE(5458),
    [sym_div] = STATE(5458),
    [sym_circ] = STATE(5458),
    [sym_star] = STATE(5458),
    [sym_excl] = STATE(5458),
    [sym_qq] = STATE(5458),
    [sym_sqcap] = STATE(5458),
    [sym_sqcup] = STATE(5458),
    [sym_uplus] = STATE(5458),
    [sym_times] = STATE(5458),
    [sym_wr] = STATE(5458),
    [sym_cdot] = STATE(5458),
    [sym_infix_op_symbol] = STATE(5334),
    [sym_sup_plus] = STATE(3532),
    [sym_postfix_op_symbol] = STATE(3523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5185),
    [anon_sym_u2208] = ACTIONS(5187),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5189),
    [anon_sym_u2227] = ACTIONS(5189),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5191),
    [anon_sym_u2228] = ACTIONS(5191),
    [anon_sym_BSLASHo] = ACTIONS(5193),
    [anon_sym_EQ] = ACTIONS(5195),
    [anon_sym_DASH] = ACTIONS(5197),
    [anon_sym_EQ_GT] = ACTIONS(5199),
    [anon_sym_u27f9] = ACTIONS(5199),
    [anon_sym_u21d2] = ACTIONS(5199),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5201),
    [anon_sym_u21f8] = ACTIONS(5201),
    [anon_sym_u2945] = ACTIONS(5201),
    [anon_sym_BSLASHequiv] = ACTIONS(5203),
    [anon_sym_u2261] = ACTIONS(5203),
    [anon_sym_LT_EQ_GT] = ACTIONS(5205),
    [anon_sym_u27fa] = ACTIONS(5205),
    [anon_sym_u21d4] = ACTIONS(5205),
    [anon_sym_TILDE_GT] = ACTIONS(5207),
    [anon_sym_u21dd] = ACTIONS(5207),
    [anon_sym_u219d] = ACTIONS(5207),
    [anon_sym_BSLASHland] = ACTIONS(5189),
    [anon_sym_BSLASHlor] = ACTIONS(5191),
    [anon_sym_COLON_EQ] = ACTIONS(5209),
    [anon_sym_u2254] = ACTIONS(5209),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5211),
    [anon_sym_u2a74] = ACTIONS(5211),
    [anon_sym_SLASH_EQ] = ACTIONS(5213),
    [anon_sym_POUND] = ACTIONS(5215),
    [anon_sym_u2260] = ACTIONS(5213),
    [anon_sym_LT] = ACTIONS(5217),
    [sym_gt] = ACTIONS(5219),
    [anon_sym_LT_EQ] = ACTIONS(5221),
    [anon_sym_EQ_LT] = ACTIONS(5223),
    [anon_sym_BSLASHleq] = ACTIONS(5223),
    [anon_sym_u2264] = ACTIONS(5223),
    [anon_sym_GT_EQ] = ACTIONS(5225),
    [anon_sym_BSLASHgeq] = ACTIONS(5225),
    [anon_sym_u2265] = ACTIONS(5225),
    [anon_sym_BSLASHapprox] = ACTIONS(5227),
    [anon_sym_u2248] = ACTIONS(5227),
    [anon_sym_PIPE_DASH] = ACTIONS(5229),
    [anon_sym_u22a2] = ACTIONS(5229),
    [anon_sym_PIPE_EQ] = ACTIONS(5231),
    [anon_sym_u22a8] = ACTIONS(5231),
    [anon_sym_DASH_PIPE] = ACTIONS(5233),
    [anon_sym_u22a3] = ACTIONS(5233),
    [anon_sym_EQ_PIPE] = ACTIONS(5235),
    [anon_sym_u2ae4] = ACTIONS(5235),
    [anon_sym_BSLASHasymp] = ACTIONS(5237),
    [anon_sym_u224d] = ACTIONS(5237),
    [anon_sym_BSLASHcong] = ACTIONS(5239),
    [anon_sym_u2245] = ACTIONS(5239),
    [anon_sym_BSLASHdoteq] = ACTIONS(5241),
    [anon_sym_u2250] = ACTIONS(5241),
    [anon_sym_BSLASHgg] = ACTIONS(5243),
    [anon_sym_u226b] = ACTIONS(5243),
    [anon_sym_BSLASHll] = ACTIONS(5245),
    [anon_sym_u226a] = ACTIONS(5245),
    [anon_sym_BSLASHnotin] = ACTIONS(5247),
    [anon_sym_u2209] = ACTIONS(5247),
    [anon_sym_BSLASHprec] = ACTIONS(5249),
    [anon_sym_u227a] = ACTIONS(5251),
    [anon_sym_BSLASHsucc] = ACTIONS(5253),
    [anon_sym_u227b] = ACTIONS(5255),
    [anon_sym_BSLASHpreceq] = ACTIONS(5257),
    [anon_sym_u2aaf] = ACTIONS(5257),
    [anon_sym_BSLASHsucceq] = ACTIONS(5259),
    [anon_sym_u2ab0] = ACTIONS(5259),
    [anon_sym_BSLASHpropto] = ACTIONS(5261),
    [anon_sym_u221d] = ACTIONS(5261),
    [anon_sym_BSLASHsim] = ACTIONS(5263),
    [anon_sym_u223c] = ACTIONS(5265),
    [anon_sym_BSLASHsimeq] = ACTIONS(5267),
    [anon_sym_u2243] = ACTIONS(5267),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5269),
    [anon_sym_u228f] = ACTIONS(5271),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5273),
    [anon_sym_u2290] = ACTIONS(5275),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5277),
    [anon_sym_u2291] = ACTIONS(5277),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5279),
    [anon_sym_u2292] = ACTIONS(5279),
    [anon_sym_BSLASHsubset] = ACTIONS(5281),
    [anon_sym_u2282] = ACTIONS(5283),
    [anon_sym_BSLASHsupset] = ACTIONS(5285),
    [anon_sym_u2283] = ACTIONS(5287),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5289),
    [anon_sym_u2286] = ACTIONS(5289),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5291),
    [anon_sym_u2287] = ACTIONS(5291),
    [sym_compose] = ACTIONS(5293),
    [sym_map_to] = ACTIONS(5293),
    [sym_map_from] = ACTIONS(5293),
    [sym_setminus] = ACTIONS(5219),
    [anon_sym_BSLASHcap] = ACTIONS(5295),
    [anon_sym_BSLASHintersect] = ACTIONS(5295),
    [anon_sym_u2229] = ACTIONS(5295),
    [anon_sym_BSLASHcup] = ACTIONS(5297),
    [anon_sym_BSLASHunion] = ACTIONS(5297),
    [anon_sym_u222a] = ACTIONS(5297),
    [anon_sym_DOT_DOT] = ACTIONS(5299),
    [anon_sym_u2025] = ACTIONS(5301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5303),
    [anon_sym_u2026] = ACTIONS(5303),
    [anon_sym_PLUS] = ACTIONS(5305),
    [sym_plusplus] = ACTIONS(5293),
    [anon_sym_BSLASHoplus] = ACTIONS(5307),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5307),
    [anon_sym_u2295] = ACTIONS(5307),
    [anon_sym_BSLASHominus] = ACTIONS(5309),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5309),
    [anon_sym_u2296] = ACTIONS(5309),
    [sym_mod] = ACTIONS(5219),
    [sym_modmod] = ACTIONS(5293),
    [sym_vert] = ACTIONS(5219),
    [anon_sym_PIPE_PIPE] = ACTIONS(5311),
    [anon_sym_u2016] = ACTIONS(5311),
    [sym_minusminus] = ACTIONS(5293),
    [sym_amp] = ACTIONS(5219),
    [sym_ampamp] = ACTIONS(5293),
    [anon_sym_BSLASHodot] = ACTIONS(5313),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5313),
    [anon_sym_u2299] = ACTIONS(5313),
    [anon_sym_BSLASHoslash] = ACTIONS(5315),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5315),
    [anon_sym_u2298] = ACTIONS(5315),
    [anon_sym_BSLASHotimes] = ACTIONS(5317),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5317),
    [anon_sym_u2297] = ACTIONS(5317),
    [sym_mul] = ACTIONS(5219),
    [sym_mulmul] = ACTIONS(5293),
    [sym_slash] = ACTIONS(5219),
    [sym_slashslash] = ACTIONS(5293),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5319),
    [anon_sym_u25ef] = ACTIONS(5319),
    [anon_sym_BSLASHbullet] = ACTIONS(5321),
    [anon_sym_u25cf] = ACTIONS(5321),
    [anon_sym_BSLASHdiv] = ACTIONS(5323),
    [anon_sym_u00f7] = ACTIONS(5323),
    [anon_sym_BSLASHcirc] = ACTIONS(5325),
    [anon_sym_u2218] = ACTIONS(5325),
    [anon_sym_BSLASHstar] = ACTIONS(5327),
    [anon_sym_u22c6] = ACTIONS(5327),
    [anon_sym_u203c] = ACTIONS(5329),
    [sym_hashhash] = ACTIONS(5293),
    [sym_dol] = ACTIONS(5219),
    [sym_doldol] = ACTIONS(5293),
    [anon_sym_QMARK_QMARK] = ACTIONS(5331),
    [anon_sym_u2047] = ACTIONS(5331),
    [anon_sym_BSLASHsqcap] = ACTIONS(5333),
    [anon_sym_u2293] = ACTIONS(5333),
    [anon_sym_BSLASHsqcup] = ACTIONS(5335),
    [anon_sym_u2294] = ACTIONS(5335),
    [anon_sym_BSLASHuplus] = ACTIONS(5337),
    [anon_sym_u228e] = ACTIONS(5337),
    [anon_sym_BSLASHX] = ACTIONS(5339),
    [anon_sym_BSLASHtimes] = ACTIONS(5339),
    [anon_sym_u00d7] = ACTIONS(5339),
    [anon_sym_BSLASHwr] = ACTIONS(5341),
    [anon_sym_u2240] = ACTIONS(5341),
    [anon_sym_BSLASHcdot] = ACTIONS(5343),
    [anon_sym_u22c5] = ACTIONS(5343),
    [sym_pow] = ACTIONS(5219),
    [sym_powpow] = ACTIONS(5293),
    [anon_sym_CARET_PLUS] = ACTIONS(900),
    [anon_sym_u207a] = ACTIONS(900),
    [sym_asterisk] = ACTIONS(902),
    [sym_sup_hash] = ACTIONS(902),
    [sym_prime] = ACTIONS(902),
    [sym__double_excl] = ACTIONS(5329),
  },
  [2116] = {
    [sym_block_comment] = STATE(2116),
    [sym_implies] = STATE(5458),
    [sym_plus_arrow] = STATE(5458),
    [sym_equiv] = STATE(5458),
    [sym_iff] = STATE(5458),
    [sym_leads_to] = STATE(5458),
    [sym_land] = STATE(5458),
    [sym_lor] = STATE(5458),
    [sym_assign] = STATE(5458),
    [sym_bnf_rule] = STATE(5458),
    [sym_eq] = STATE(5458),
    [sym_neq] = STATE(5458),
    [sym_lt] = STATE(5458),
    [sym_leq] = STATE(5458),
    [sym_geq] = STATE(5458),
    [sym_approx] = STATE(5458),
    [sym_rs_ttile] = STATE(5458),
    [sym_rd_ttile] = STATE(5458),
    [sym_ls_ttile] = STATE(5458),
    [sym_ld_ttile] = STATE(5458),
    [sym_asymp] = STATE(5458),
    [sym_cong] = STATE(5458),
    [sym_doteq] = STATE(5458),
    [sym_gg] = STATE(5458),
    [sym_ll] = STATE(5458),
    [sym_in] = STATE(5458),
    [sym_notin] = STATE(5458),
    [sym_prec] = STATE(5458),
    [sym_succ] = STATE(5458),
    [sym_preceq] = STATE(5458),
    [sym_succeq] = STATE(5458),
    [sym_propto] = STATE(5458),
    [sym_sim] = STATE(5458),
    [sym_simeq] = STATE(5458),
    [sym_sqsubset] = STATE(5458),
    [sym_sqsupset] = STATE(5458),
    [sym_sqsubseteq] = STATE(5458),
    [sym_sqsupseteq] = STATE(5458),
    [sym_subset] = STATE(5458),
    [sym_supset] = STATE(5458),
    [sym_subseteq] = STATE(5458),
    [sym_supseteq] = STATE(5458),
    [sym_cap] = STATE(5458),
    [sym_cup] = STATE(5458),
    [sym_dots_2] = STATE(5458),
    [sym_dots_3] = STATE(5458),
    [sym_plus] = STATE(5458),
    [sym_oplus] = STATE(5458),
    [sym_ominus] = STATE(5458),
    [sym_vertvert] = STATE(5458),
    [sym_minus] = STATE(5458),
    [sym_odot] = STATE(5458),
    [sym_oslash] = STATE(5458),
    [sym_otimes] = STATE(5458),
    [sym_bigcirc] = STATE(5458),
    [sym_bullet] = STATE(5458),
    [sym_div] = STATE(5458),
    [sym_circ] = STATE(5458),
    [sym_star] = STATE(5458),
    [sym_excl] = STATE(5458),
    [sym_qq] = STATE(5458),
    [sym_sqcap] = STATE(5458),
    [sym_sqcup] = STATE(5458),
    [sym_uplus] = STATE(5458),
    [sym_times] = STATE(5458),
    [sym_wr] = STATE(5458),
    [sym_cdot] = STATE(5458),
    [sym_infix_op_symbol] = STATE(5190),
    [sym_sup_plus] = STATE(3736),
    [sym_postfix_op_symbol] = STATE(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5185),
    [anon_sym_u2208] = ACTIONS(5187),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5189),
    [anon_sym_u2227] = ACTIONS(5189),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5191),
    [anon_sym_u2228] = ACTIONS(5191),
    [anon_sym_BSLASHo] = ACTIONS(5193),
    [anon_sym_EQ] = ACTIONS(5195),
    [anon_sym_DASH] = ACTIONS(5197),
    [anon_sym_EQ_GT] = ACTIONS(5199),
    [anon_sym_u27f9] = ACTIONS(5199),
    [anon_sym_u21d2] = ACTIONS(5199),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5201),
    [anon_sym_u21f8] = ACTIONS(5201),
    [anon_sym_u2945] = ACTIONS(5201),
    [anon_sym_BSLASHequiv] = ACTIONS(5203),
    [anon_sym_u2261] = ACTIONS(5203),
    [anon_sym_LT_EQ_GT] = ACTIONS(5205),
    [anon_sym_u27fa] = ACTIONS(5205),
    [anon_sym_u21d4] = ACTIONS(5205),
    [anon_sym_TILDE_GT] = ACTIONS(5207),
    [anon_sym_u21dd] = ACTIONS(5207),
    [anon_sym_u219d] = ACTIONS(5207),
    [anon_sym_BSLASHland] = ACTIONS(5189),
    [anon_sym_BSLASHlor] = ACTIONS(5191),
    [anon_sym_COLON_EQ] = ACTIONS(5209),
    [anon_sym_u2254] = ACTIONS(5209),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5211),
    [anon_sym_u2a74] = ACTIONS(5211),
    [anon_sym_SLASH_EQ] = ACTIONS(5213),
    [anon_sym_POUND] = ACTIONS(5215),
    [anon_sym_u2260] = ACTIONS(5213),
    [anon_sym_LT] = ACTIONS(5217),
    [sym_gt] = ACTIONS(5219),
    [anon_sym_LT_EQ] = ACTIONS(5221),
    [anon_sym_EQ_LT] = ACTIONS(5223),
    [anon_sym_BSLASHleq] = ACTIONS(5223),
    [anon_sym_u2264] = ACTIONS(5223),
    [anon_sym_GT_EQ] = ACTIONS(5225),
    [anon_sym_BSLASHgeq] = ACTIONS(5225),
    [anon_sym_u2265] = ACTIONS(5225),
    [anon_sym_BSLASHapprox] = ACTIONS(5227),
    [anon_sym_u2248] = ACTIONS(5227),
    [anon_sym_PIPE_DASH] = ACTIONS(5229),
    [anon_sym_u22a2] = ACTIONS(5229),
    [anon_sym_PIPE_EQ] = ACTIONS(5231),
    [anon_sym_u22a8] = ACTIONS(5231),
    [anon_sym_DASH_PIPE] = ACTIONS(5233),
    [anon_sym_u22a3] = ACTIONS(5233),
    [anon_sym_EQ_PIPE] = ACTIONS(5235),
    [anon_sym_u2ae4] = ACTIONS(5235),
    [anon_sym_BSLASHasymp] = ACTIONS(5237),
    [anon_sym_u224d] = ACTIONS(5237),
    [anon_sym_BSLASHcong] = ACTIONS(5239),
    [anon_sym_u2245] = ACTIONS(5239),
    [anon_sym_BSLASHdoteq] = ACTIONS(5241),
    [anon_sym_u2250] = ACTIONS(5241),
    [anon_sym_BSLASHgg] = ACTIONS(5243),
    [anon_sym_u226b] = ACTIONS(5243),
    [anon_sym_BSLASHll] = ACTIONS(5245),
    [anon_sym_u226a] = ACTIONS(5245),
    [anon_sym_BSLASHnotin] = ACTIONS(5247),
    [anon_sym_u2209] = ACTIONS(5247),
    [anon_sym_BSLASHprec] = ACTIONS(5249),
    [anon_sym_u227a] = ACTIONS(5251),
    [anon_sym_BSLASHsucc] = ACTIONS(5253),
    [anon_sym_u227b] = ACTIONS(5255),
    [anon_sym_BSLASHpreceq] = ACTIONS(5257),
    [anon_sym_u2aaf] = ACTIONS(5257),
    [anon_sym_BSLASHsucceq] = ACTIONS(5259),
    [anon_sym_u2ab0] = ACTIONS(5259),
    [anon_sym_BSLASHpropto] = ACTIONS(5261),
    [anon_sym_u221d] = ACTIONS(5261),
    [anon_sym_BSLASHsim] = ACTIONS(5263),
    [anon_sym_u223c] = ACTIONS(5265),
    [anon_sym_BSLASHsimeq] = ACTIONS(5267),
    [anon_sym_u2243] = ACTIONS(5267),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5269),
    [anon_sym_u228f] = ACTIONS(5271),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5273),
    [anon_sym_u2290] = ACTIONS(5275),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5277),
    [anon_sym_u2291] = ACTIONS(5277),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5279),
    [anon_sym_u2292] = ACTIONS(5279),
    [anon_sym_BSLASHsubset] = ACTIONS(5281),
    [anon_sym_u2282] = ACTIONS(5283),
    [anon_sym_BSLASHsupset] = ACTIONS(5285),
    [anon_sym_u2283] = ACTIONS(5287),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5289),
    [anon_sym_u2286] = ACTIONS(5289),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5291),
    [anon_sym_u2287] = ACTIONS(5291),
    [sym_compose] = ACTIONS(5293),
    [sym_map_to] = ACTIONS(5293),
    [sym_map_from] = ACTIONS(5293),
    [sym_setminus] = ACTIONS(5219),
    [anon_sym_BSLASHcap] = ACTIONS(5295),
    [anon_sym_BSLASHintersect] = ACTIONS(5295),
    [anon_sym_u2229] = ACTIONS(5295),
    [anon_sym_BSLASHcup] = ACTIONS(5297),
    [anon_sym_BSLASHunion] = ACTIONS(5297),
    [anon_sym_u222a] = ACTIONS(5297),
    [anon_sym_DOT_DOT] = ACTIONS(5299),
    [anon_sym_u2025] = ACTIONS(5301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5303),
    [anon_sym_u2026] = ACTIONS(5303),
    [anon_sym_PLUS] = ACTIONS(5305),
    [sym_plusplus] = ACTIONS(5293),
    [anon_sym_BSLASHoplus] = ACTIONS(5307),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5307),
    [anon_sym_u2295] = ACTIONS(5307),
    [anon_sym_BSLASHominus] = ACTIONS(5309),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5309),
    [anon_sym_u2296] = ACTIONS(5309),
    [sym_mod] = ACTIONS(5219),
    [sym_modmod] = ACTIONS(5293),
    [sym_vert] = ACTIONS(5219),
    [anon_sym_PIPE_PIPE] = ACTIONS(5311),
    [anon_sym_u2016] = ACTIONS(5311),
    [sym_minusminus] = ACTIONS(5293),
    [sym_amp] = ACTIONS(5219),
    [sym_ampamp] = ACTIONS(5293),
    [anon_sym_BSLASHodot] = ACTIONS(5313),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5313),
    [anon_sym_u2299] = ACTIONS(5313),
    [anon_sym_BSLASHoslash] = ACTIONS(5315),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5315),
    [anon_sym_u2298] = ACTIONS(5315),
    [anon_sym_BSLASHotimes] = ACTIONS(5317),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5317),
    [anon_sym_u2297] = ACTIONS(5317),
    [sym_mul] = ACTIONS(5219),
    [sym_mulmul] = ACTIONS(5293),
    [sym_slash] = ACTIONS(5219),
    [sym_slashslash] = ACTIONS(5293),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5319),
    [anon_sym_u25ef] = ACTIONS(5319),
    [anon_sym_BSLASHbullet] = ACTIONS(5321),
    [anon_sym_u25cf] = ACTIONS(5321),
    [anon_sym_BSLASHdiv] = ACTIONS(5323),
    [anon_sym_u00f7] = ACTIONS(5323),
    [anon_sym_BSLASHcirc] = ACTIONS(5325),
    [anon_sym_u2218] = ACTIONS(5325),
    [anon_sym_BSLASHstar] = ACTIONS(5327),
    [anon_sym_u22c6] = ACTIONS(5327),
    [anon_sym_u203c] = ACTIONS(5329),
    [sym_hashhash] = ACTIONS(5293),
    [sym_dol] = ACTIONS(5219),
    [sym_doldol] = ACTIONS(5293),
    [anon_sym_QMARK_QMARK] = ACTIONS(5331),
    [anon_sym_u2047] = ACTIONS(5331),
    [anon_sym_BSLASHsqcap] = ACTIONS(5333),
    [anon_sym_u2293] = ACTIONS(5333),
    [anon_sym_BSLASHsqcup] = ACTIONS(5335),
    [anon_sym_u2294] = ACTIONS(5335),
    [anon_sym_BSLASHuplus] = ACTIONS(5337),
    [anon_sym_u228e] = ACTIONS(5337),
    [anon_sym_BSLASHX] = ACTIONS(5339),
    [anon_sym_BSLASHtimes] = ACTIONS(5339),
    [anon_sym_u00d7] = ACTIONS(5339),
    [anon_sym_BSLASHwr] = ACTIONS(5341),
    [anon_sym_u2240] = ACTIONS(5341),
    [anon_sym_BSLASHcdot] = ACTIONS(5343),
    [anon_sym_u22c5] = ACTIONS(5343),
    [sym_pow] = ACTIONS(5219),
    [sym_powpow] = ACTIONS(5293),
    [anon_sym_CARET_PLUS] = ACTIONS(1413),
    [anon_sym_u207a] = ACTIONS(1413),
    [sym_asterisk] = ACTIONS(1415),
    [sym_sup_hash] = ACTIONS(1415),
    [sym_prime] = ACTIONS(1415),
    [sym__double_excl] = ACTIONS(5329),
  },
  [2117] = {
    [sym_block_comment] = STATE(2117),
    [sym_implies] = STATE(5458),
    [sym_plus_arrow] = STATE(5458),
    [sym_equiv] = STATE(5458),
    [sym_iff] = STATE(5458),
    [sym_leads_to] = STATE(5458),
    [sym_land] = STATE(5458),
    [sym_lor] = STATE(5458),
    [sym_assign] = STATE(5458),
    [sym_bnf_rule] = STATE(5458),
    [sym_eq] = STATE(5458),
    [sym_neq] = STATE(5458),
    [sym_lt] = STATE(5458),
    [sym_leq] = STATE(5458),
    [sym_geq] = STATE(5458),
    [sym_approx] = STATE(5458),
    [sym_rs_ttile] = STATE(5458),
    [sym_rd_ttile] = STATE(5458),
    [sym_ls_ttile] = STATE(5458),
    [sym_ld_ttile] = STATE(5458),
    [sym_asymp] = STATE(5458),
    [sym_cong] = STATE(5458),
    [sym_doteq] = STATE(5458),
    [sym_gg] = STATE(5458),
    [sym_ll] = STATE(5458),
    [sym_in] = STATE(5458),
    [sym_notin] = STATE(5458),
    [sym_prec] = STATE(5458),
    [sym_succ] = STATE(5458),
    [sym_preceq] = STATE(5458),
    [sym_succeq] = STATE(5458),
    [sym_propto] = STATE(5458),
    [sym_sim] = STATE(5458),
    [sym_simeq] = STATE(5458),
    [sym_sqsubset] = STATE(5458),
    [sym_sqsupset] = STATE(5458),
    [sym_sqsubseteq] = STATE(5458),
    [sym_sqsupseteq] = STATE(5458),
    [sym_subset] = STATE(5458),
    [sym_supset] = STATE(5458),
    [sym_subseteq] = STATE(5458),
    [sym_supseteq] = STATE(5458),
    [sym_cap] = STATE(5458),
    [sym_cup] = STATE(5458),
    [sym_dots_2] = STATE(5458),
    [sym_dots_3] = STATE(5458),
    [sym_plus] = STATE(5458),
    [sym_oplus] = STATE(5458),
    [sym_ominus] = STATE(5458),
    [sym_vertvert] = STATE(5458),
    [sym_minus] = STATE(5458),
    [sym_odot] = STATE(5458),
    [sym_oslash] = STATE(5458),
    [sym_otimes] = STATE(5458),
    [sym_bigcirc] = STATE(5458),
    [sym_bullet] = STATE(5458),
    [sym_div] = STATE(5458),
    [sym_circ] = STATE(5458),
    [sym_star] = STATE(5458),
    [sym_excl] = STATE(5458),
    [sym_qq] = STATE(5458),
    [sym_sqcap] = STATE(5458),
    [sym_sqcup] = STATE(5458),
    [sym_uplus] = STATE(5458),
    [sym_times] = STATE(5458),
    [sym_wr] = STATE(5458),
    [sym_cdot] = STATE(5458),
    [sym_infix_op_symbol] = STATE(5334),
    [sym_sup_plus] = STATE(3426),
    [sym_postfix_op_symbol] = STATE(3523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5185),
    [anon_sym_u2208] = ACTIONS(5187),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5189),
    [anon_sym_u2227] = ACTIONS(5189),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5191),
    [anon_sym_u2228] = ACTIONS(5191),
    [anon_sym_BSLASHo] = ACTIONS(5193),
    [anon_sym_EQ] = ACTIONS(5195),
    [anon_sym_DASH] = ACTIONS(5197),
    [anon_sym_EQ_GT] = ACTIONS(5199),
    [anon_sym_u27f9] = ACTIONS(5199),
    [anon_sym_u21d2] = ACTIONS(5199),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5201),
    [anon_sym_u21f8] = ACTIONS(5201),
    [anon_sym_u2945] = ACTIONS(5201),
    [anon_sym_BSLASHequiv] = ACTIONS(5203),
    [anon_sym_u2261] = ACTIONS(5203),
    [anon_sym_LT_EQ_GT] = ACTIONS(5205),
    [anon_sym_u27fa] = ACTIONS(5205),
    [anon_sym_u21d4] = ACTIONS(5205),
    [anon_sym_TILDE_GT] = ACTIONS(5207),
    [anon_sym_u21dd] = ACTIONS(5207),
    [anon_sym_u219d] = ACTIONS(5207),
    [anon_sym_BSLASHland] = ACTIONS(5189),
    [anon_sym_BSLASHlor] = ACTIONS(5191),
    [anon_sym_COLON_EQ] = ACTIONS(5209),
    [anon_sym_u2254] = ACTIONS(5209),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5211),
    [anon_sym_u2a74] = ACTIONS(5211),
    [anon_sym_SLASH_EQ] = ACTIONS(5213),
    [anon_sym_POUND] = ACTIONS(5215),
    [anon_sym_u2260] = ACTIONS(5213),
    [anon_sym_LT] = ACTIONS(5217),
    [sym_gt] = ACTIONS(5219),
    [anon_sym_LT_EQ] = ACTIONS(5221),
    [anon_sym_EQ_LT] = ACTIONS(5223),
    [anon_sym_BSLASHleq] = ACTIONS(5223),
    [anon_sym_u2264] = ACTIONS(5223),
    [anon_sym_GT_EQ] = ACTIONS(5225),
    [anon_sym_BSLASHgeq] = ACTIONS(5225),
    [anon_sym_u2265] = ACTIONS(5225),
    [anon_sym_BSLASHapprox] = ACTIONS(5227),
    [anon_sym_u2248] = ACTIONS(5227),
    [anon_sym_PIPE_DASH] = ACTIONS(5229),
    [anon_sym_u22a2] = ACTIONS(5229),
    [anon_sym_PIPE_EQ] = ACTIONS(5231),
    [anon_sym_u22a8] = ACTIONS(5231),
    [anon_sym_DASH_PIPE] = ACTIONS(5233),
    [anon_sym_u22a3] = ACTIONS(5233),
    [anon_sym_EQ_PIPE] = ACTIONS(5235),
    [anon_sym_u2ae4] = ACTIONS(5235),
    [anon_sym_BSLASHasymp] = ACTIONS(5237),
    [anon_sym_u224d] = ACTIONS(5237),
    [anon_sym_BSLASHcong] = ACTIONS(5239),
    [anon_sym_u2245] = ACTIONS(5239),
    [anon_sym_BSLASHdoteq] = ACTIONS(5241),
    [anon_sym_u2250] = ACTIONS(5241),
    [anon_sym_BSLASHgg] = ACTIONS(5243),
    [anon_sym_u226b] = ACTIONS(5243),
    [anon_sym_BSLASHll] = ACTIONS(5245),
    [anon_sym_u226a] = ACTIONS(5245),
    [anon_sym_BSLASHnotin] = ACTIONS(5247),
    [anon_sym_u2209] = ACTIONS(5247),
    [anon_sym_BSLASHprec] = ACTIONS(5249),
    [anon_sym_u227a] = ACTIONS(5251),
    [anon_sym_BSLASHsucc] = ACTIONS(5253),
    [anon_sym_u227b] = ACTIONS(5255),
    [anon_sym_BSLASHpreceq] = ACTIONS(5257),
    [anon_sym_u2aaf] = ACTIONS(5257),
    [anon_sym_BSLASHsucceq] = ACTIONS(5259),
    [anon_sym_u2ab0] = ACTIONS(5259),
    [anon_sym_BSLASHpropto] = ACTIONS(5261),
    [anon_sym_u221d] = ACTIONS(5261),
    [anon_sym_BSLASHsim] = ACTIONS(5263),
    [anon_sym_u223c] = ACTIONS(5265),
    [anon_sym_BSLASHsimeq] = ACTIONS(5267),
    [anon_sym_u2243] = ACTIONS(5267),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5269),
    [anon_sym_u228f] = ACTIONS(5271),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5273),
    [anon_sym_u2290] = ACTIONS(5275),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5277),
    [anon_sym_u2291] = ACTIONS(5277),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5279),
    [anon_sym_u2292] = ACTIONS(5279),
    [anon_sym_BSLASHsubset] = ACTIONS(5281),
    [anon_sym_u2282] = ACTIONS(5283),
    [anon_sym_BSLASHsupset] = ACTIONS(5285),
    [anon_sym_u2283] = ACTIONS(5287),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5289),
    [anon_sym_u2286] = ACTIONS(5289),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5291),
    [anon_sym_u2287] = ACTIONS(5291),
    [sym_compose] = ACTIONS(5293),
    [sym_map_to] = ACTIONS(5293),
    [sym_map_from] = ACTIONS(5293),
    [sym_setminus] = ACTIONS(5219),
    [anon_sym_BSLASHcap] = ACTIONS(5295),
    [anon_sym_BSLASHintersect] = ACTIONS(5295),
    [anon_sym_u2229] = ACTIONS(5295),
    [anon_sym_BSLASHcup] = ACTIONS(5297),
    [anon_sym_BSLASHunion] = ACTIONS(5297),
    [anon_sym_u222a] = ACTIONS(5297),
    [anon_sym_DOT_DOT] = ACTIONS(5299),
    [anon_sym_u2025] = ACTIONS(5301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5303),
    [anon_sym_u2026] = ACTIONS(5303),
    [anon_sym_PLUS] = ACTIONS(5305),
    [sym_plusplus] = ACTIONS(5293),
    [anon_sym_BSLASHoplus] = ACTIONS(5307),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5307),
    [anon_sym_u2295] = ACTIONS(5307),
    [anon_sym_BSLASHominus] = ACTIONS(5309),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5309),
    [anon_sym_u2296] = ACTIONS(5309),
    [sym_mod] = ACTIONS(5219),
    [sym_modmod] = ACTIONS(5293),
    [sym_vert] = ACTIONS(5219),
    [anon_sym_PIPE_PIPE] = ACTIONS(5311),
    [anon_sym_u2016] = ACTIONS(5311),
    [sym_minusminus] = ACTIONS(5293),
    [sym_amp] = ACTIONS(5219),
    [sym_ampamp] = ACTIONS(5293),
    [anon_sym_BSLASHodot] = ACTIONS(5313),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5313),
    [anon_sym_u2299] = ACTIONS(5313),
    [anon_sym_BSLASHoslash] = ACTIONS(5315),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5315),
    [anon_sym_u2298] = ACTIONS(5315),
    [anon_sym_BSLASHotimes] = ACTIONS(5317),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5317),
    [anon_sym_u2297] = ACTIONS(5317),
    [sym_mul] = ACTIONS(5219),
    [sym_mulmul] = ACTIONS(5293),
    [sym_slash] = ACTIONS(5219),
    [sym_slashslash] = ACTIONS(5293),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5319),
    [anon_sym_u25ef] = ACTIONS(5319),
    [anon_sym_BSLASHbullet] = ACTIONS(5321),
    [anon_sym_u25cf] = ACTIONS(5321),
    [anon_sym_BSLASHdiv] = ACTIONS(5323),
    [anon_sym_u00f7] = ACTIONS(5323),
    [anon_sym_BSLASHcirc] = ACTIONS(5325),
    [anon_sym_u2218] = ACTIONS(5325),
    [anon_sym_BSLASHstar] = ACTIONS(5327),
    [anon_sym_u22c6] = ACTIONS(5327),
    [anon_sym_u203c] = ACTIONS(5329),
    [sym_hashhash] = ACTIONS(5293),
    [sym_dol] = ACTIONS(5219),
    [sym_doldol] = ACTIONS(5293),
    [anon_sym_QMARK_QMARK] = ACTIONS(5331),
    [anon_sym_u2047] = ACTIONS(5331),
    [anon_sym_BSLASHsqcap] = ACTIONS(5333),
    [anon_sym_u2293] = ACTIONS(5333),
    [anon_sym_BSLASHsqcup] = ACTIONS(5335),
    [anon_sym_u2294] = ACTIONS(5335),
    [anon_sym_BSLASHuplus] = ACTIONS(5337),
    [anon_sym_u228e] = ACTIONS(5337),
    [anon_sym_BSLASHX] = ACTIONS(5339),
    [anon_sym_BSLASHtimes] = ACTIONS(5339),
    [anon_sym_u00d7] = ACTIONS(5339),
    [anon_sym_BSLASHwr] = ACTIONS(5341),
    [anon_sym_u2240] = ACTIONS(5341),
    [anon_sym_BSLASHcdot] = ACTIONS(5343),
    [anon_sym_u22c5] = ACTIONS(5343),
    [sym_pow] = ACTIONS(5219),
    [sym_powpow] = ACTIONS(5293),
    [anon_sym_CARET_PLUS] = ACTIONS(293),
    [anon_sym_u207a] = ACTIONS(293),
    [sym_asterisk] = ACTIONS(295),
    [sym_sup_hash] = ACTIONS(295),
    [sym_prime] = ACTIONS(295),
    [sym__double_excl] = ACTIONS(5329),
  },
  [2118] = {
    [sym_block_comment] = STATE(2118),
    [sym_identifier] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5345),
    [anon_sym_u2208] = ACTIONS(5347),
    [anon_sym_BSLASHA] = ACTIONS(5345),
    [anon_sym_BSLASHforall] = ACTIONS(5347),
    [anon_sym_u2200] = ACTIONS(5347),
    [anon_sym_BSLASHE] = ACTIONS(5345),
    [anon_sym_BSLASHexists] = ACTIONS(5347),
    [anon_sym_u2203] = ACTIONS(5347),
    [sym_temporal_forall] = ACTIONS(5347),
    [sym_temporal_exists] = ACTIONS(5347),
    [anon_sym_LT_LT] = ACTIONS(5347),
    [anon_sym_u3008] = ACTIONS(5347),
    [anon_sym_u27e8] = ACTIONS(5347),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5347),
    [anon_sym_u25a1] = ACTIONS(5347),
    [anon_sym_AT] = ACTIONS(5345),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5347),
    [anon_sym_u2227] = ACTIONS(5347),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5347),
    [anon_sym_u2228] = ACTIONS(5347),
    [anon_sym_LPAREN] = ACTIONS(5345),
    [anon_sym_LBRACK] = ACTIONS(5345),
    [anon_sym_INSTANCE] = ACTIONS(5345),
    [aux_sym_child_id_token1] = ACTIONS(5345),
    [sym_real_number] = ACTIONS(5347),
    [anon_sym_BSLASHb] = ACTIONS(5345),
    [anon_sym_BSLASHB] = ACTIONS(5347),
    [anon_sym_BSLASHo] = ACTIONS(5345),
    [anon_sym_BSLASHO] = ACTIONS(5347),
    [anon_sym_BSLASHh] = ACTIONS(5347),
    [anon_sym_BSLASHH] = ACTIONS(5347),
    [anon_sym_DQUOTE] = ACTIONS(5347),
    [anon_sym_TRUE] = ACTIONS(5345),
    [anon_sym_FALSE] = ACTIONS(5345),
    [sym_string_set] = ACTIONS(5345),
    [sym_boolean_set] = ACTIONS(5345),
    [anon_sym_Nat] = ACTIONS(5345),
    [anon_sym_u2115] = ACTIONS(5347),
    [anon_sym_Int] = ACTIONS(5345),
    [anon_sym_u2124] = ACTIONS(5347),
    [anon_sym_Real] = ACTIONS(5345),
    [anon_sym_u211d] = ACTIONS(5347),
    [anon_sym_CHOOSE] = ACTIONS(5345),
    [anon_sym_LBRACE] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5345),
    [anon_sym_WF_] = ACTIONS(5345),
    [anon_sym_SF_] = ACTIONS(5345),
    [anon_sym_IF] = ACTIONS(5345),
    [anon_sym_CASE] = ACTIONS(5345),
    [anon_sym_LET] = ACTIONS(5345),
    [anon_sym_BSLASHlnot] = ACTIONS(5347),
    [anon_sym_BSLASHneg] = ACTIONS(5347),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_u00ac] = ACTIONS(5347),
    [sym_union] = ACTIONS(5345),
    [sym_powerset] = ACTIONS(5345),
    [sym_domain] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5345),
    [sym_negative_dot] = ACTIONS(5347),
    [sym_enabled] = ACTIONS(5345),
    [sym_unchanged] = ACTIONS(5345),
    [anon_sym_LT_GT] = ACTIONS(5347),
    [anon_sym_u22c4] = ACTIONS(5347),
    [anon_sym_u25c7] = ACTIONS(5347),
    [anon_sym_EQ_GT] = ACTIONS(5347),
    [anon_sym_u27f9] = ACTIONS(5347),
    [anon_sym_u21d2] = ACTIONS(5347),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5347),
    [anon_sym_u21f8] = ACTIONS(5347),
    [anon_sym_u2945] = ACTIONS(5347),
    [anon_sym_BSLASHequiv] = ACTIONS(5347),
    [anon_sym_u2261] = ACTIONS(5347),
    [anon_sym_LT_EQ_GT] = ACTIONS(5347),
    [anon_sym_u27fa] = ACTIONS(5347),
    [anon_sym_u21d4] = ACTIONS(5347),
    [anon_sym_TILDE_GT] = ACTIONS(5347),
    [anon_sym_u21dd] = ACTIONS(5347),
    [anon_sym_u219d] = ACTIONS(5347),
    [anon_sym_BSLASHland] = ACTIONS(5347),
    [anon_sym_BSLASHlor] = ACTIONS(5347),
    [anon_sym_COLON_EQ] = ACTIONS(5347),
    [anon_sym_u2254] = ACTIONS(5347),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5347),
    [anon_sym_u2a74] = ACTIONS(5347),
    [anon_sym_SLASH_EQ] = ACTIONS(5347),
    [anon_sym_POUND] = ACTIONS(5345),
    [anon_sym_u2260] = ACTIONS(5347),
    [anon_sym_LT] = ACTIONS(5345),
    [sym_gt] = ACTIONS(5345),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_LT] = ACTIONS(5347),
    [anon_sym_BSLASHleq] = ACTIONS(5347),
    [anon_sym_u2264] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5347),
    [anon_sym_BSLASHgeq] = ACTIONS(5347),
    [anon_sym_u2265] = ACTIONS(5347),
    [anon_sym_BSLASHapprox] = ACTIONS(5347),
    [anon_sym_u2248] = ACTIONS(5347),
    [anon_sym_PIPE_DASH] = ACTIONS(5347),
    [anon_sym_u22a2] = ACTIONS(5347),
    [anon_sym_PIPE_EQ] = ACTIONS(5347),
    [anon_sym_u22a8] = ACTIONS(5347),
    [anon_sym_DASH_PIPE] = ACTIONS(5347),
    [anon_sym_u22a3] = ACTIONS(5347),
    [anon_sym_EQ_PIPE] = ACTIONS(5347),
    [anon_sym_u2ae4] = ACTIONS(5347),
    [anon_sym_BSLASHasymp] = ACTIONS(5347),
    [anon_sym_u224d] = ACTIONS(5347),
    [anon_sym_BSLASHcong] = ACTIONS(5347),
    [anon_sym_u2245] = ACTIONS(5347),
    [anon_sym_BSLASHdoteq] = ACTIONS(5347),
    [anon_sym_u2250] = ACTIONS(5347),
    [anon_sym_BSLASHgg] = ACTIONS(5347),
    [anon_sym_u226b] = ACTIONS(5347),
    [anon_sym_BSLASHll] = ACTIONS(5347),
    [anon_sym_u226a] = ACTIONS(5347),
    [anon_sym_BSLASHnotin] = ACTIONS(5347),
    [anon_sym_u2209] = ACTIONS(5347),
    [anon_sym_BSLASHprec] = ACTIONS(5345),
    [anon_sym_u227a] = ACTIONS(5347),
    [anon_sym_BSLASHsucc] = ACTIONS(5345),
    [anon_sym_u227b] = ACTIONS(5347),
    [anon_sym_BSLASHpreceq] = ACTIONS(5347),
    [anon_sym_u2aaf] = ACTIONS(5347),
    [anon_sym_BSLASHsucceq] = ACTIONS(5347),
    [anon_sym_u2ab0] = ACTIONS(5347),
    [anon_sym_BSLASHpropto] = ACTIONS(5347),
    [anon_sym_u221d] = ACTIONS(5347),
    [anon_sym_BSLASHsim] = ACTIONS(5345),
    [anon_sym_u223c] = ACTIONS(5347),
    [anon_sym_BSLASHsimeq] = ACTIONS(5347),
    [anon_sym_u2243] = ACTIONS(5347),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5345),
    [anon_sym_u228f] = ACTIONS(5347),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5345),
    [anon_sym_u2290] = ACTIONS(5347),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5347),
    [anon_sym_u2291] = ACTIONS(5347),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5347),
    [anon_sym_u2292] = ACTIONS(5347),
    [anon_sym_BSLASHsubset] = ACTIONS(5345),
    [anon_sym_u2282] = ACTIONS(5347),
    [anon_sym_BSLASHsupset] = ACTIONS(5345),
    [anon_sym_u2283] = ACTIONS(5347),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5347),
    [anon_sym_u2286] = ACTIONS(5347),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5347),
    [anon_sym_u2287] = ACTIONS(5347),
    [sym_compose] = ACTIONS(5347),
    [sym_map_to] = ACTIONS(5347),
    [sym_map_from] = ACTIONS(5347),
    [sym_setminus] = ACTIONS(5345),
    [anon_sym_BSLASHcap] = ACTIONS(5347),
    [anon_sym_BSLASHintersect] = ACTIONS(5347),
    [anon_sym_u2229] = ACTIONS(5347),
    [anon_sym_BSLASHcup] = ACTIONS(5347),
    [anon_sym_BSLASHunion] = ACTIONS(5347),
    [anon_sym_u222a] = ACTIONS(5347),
    [anon_sym_DOT_DOT] = ACTIONS(5345),
    [anon_sym_u2025] = ACTIONS(5347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5347),
    [anon_sym_u2026] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [sym_plusplus] = ACTIONS(5347),
    [anon_sym_BSLASHoplus] = ACTIONS(5347),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5347),
    [anon_sym_u2295] = ACTIONS(5347),
    [anon_sym_BSLASHominus] = ACTIONS(5347),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5347),
    [anon_sym_u2296] = ACTIONS(5347),
    [sym_mod] = ACTIONS(5345),
    [sym_modmod] = ACTIONS(5347),
    [sym_vert] = ACTIONS(5345),
    [anon_sym_PIPE_PIPE] = ACTIONS(5347),
    [anon_sym_u2016] = ACTIONS(5347),
    [sym_minusminus] = ACTIONS(5347),
    [sym_amp] = ACTIONS(5345),
    [sym_ampamp] = ACTIONS(5347),
    [anon_sym_BSLASHodot] = ACTIONS(5347),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5347),
    [anon_sym_u2299] = ACTIONS(5347),
    [anon_sym_BSLASHoslash] = ACTIONS(5347),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5347),
    [anon_sym_u2298] = ACTIONS(5347),
    [anon_sym_BSLASHotimes] = ACTIONS(5347),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5347),
    [anon_sym_u2297] = ACTIONS(5347),
    [sym_mul] = ACTIONS(5345),
    [sym_mulmul] = ACTIONS(5347),
    [sym_slash] = ACTIONS(5345),
    [sym_slashslash] = ACTIONS(5347),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5347),
    [anon_sym_u25ef] = ACTIONS(5347),
    [anon_sym_BSLASHbullet] = ACTIONS(5347),
    [anon_sym_u25cf] = ACTIONS(5347),
    [anon_sym_BSLASHdiv] = ACTIONS(5347),
    [anon_sym_u00f7] = ACTIONS(5347),
    [anon_sym_BSLASHcirc] = ACTIONS(5347),
    [anon_sym_u2218] = ACTIONS(5347),
    [anon_sym_BSLASHstar] = ACTIONS(5347),
    [anon_sym_u22c6] = ACTIONS(5347),
    [anon_sym_u203c] = ACTIONS(5347),
    [sym_hashhash] = ACTIONS(5347),
    [sym_dol] = ACTIONS(5345),
    [sym_doldol] = ACTIONS(5347),
    [anon_sym_QMARK_QMARK] = ACTIONS(5347),
    [anon_sym_u2047] = ACTIONS(5347),
    [anon_sym_BSLASHsqcap] = ACTIONS(5347),
    [anon_sym_u2293] = ACTIONS(5347),
    [anon_sym_BSLASHsqcup] = ACTIONS(5347),
    [anon_sym_u2294] = ACTIONS(5347),
    [anon_sym_BSLASHuplus] = ACTIONS(5347),
    [anon_sym_u228e] = ACTIONS(5347),
    [anon_sym_BSLASHX] = ACTIONS(5347),
    [anon_sym_BSLASHtimes] = ACTIONS(5347),
    [anon_sym_u00d7] = ACTIONS(5347),
    [anon_sym_BSLASHwr] = ACTIONS(5347),
    [anon_sym_u2240] = ACTIONS(5347),
    [anon_sym_BSLASHcdot] = ACTIONS(5347),
    [anon_sym_u22c5] = ACTIONS(5347),
    [sym_pow] = ACTIONS(5345),
    [sym_powpow] = ACTIONS(5347),
    [anon_sym_CARET_PLUS] = ACTIONS(5347),
    [anon_sym_u207a] = ACTIONS(5347),
    [sym_asterisk] = ACTIONS(5347),
    [sym_sup_hash] = ACTIONS(5347),
    [sym_prime] = ACTIONS(5347),
    [anon_sym_ASSUME] = ACTIONS(5345),
    [anon_sym_DEFINE] = ACTIONS(5345),
    [anon_sym_HAVE] = ACTIONS(5345),
    [anon_sym_WITNESS] = ACTIONS(5345),
    [anon_sym_TAKE] = ACTIONS(5345),
    [anon_sym_SUFFICES] = ACTIONS(5345),
    [anon_sym_PICK] = ACTIONS(5345),
    [anon_sym_QED] = ACTIONS(5345),
    [anon_sym_USE] = ACTIONS(5345),
    [anon_sym_HIDE] = ACTIONS(5345),
    [sym__indent] = ACTIONS(5347),
    [sym__double_excl] = ACTIONS(5347),
  },
  [2119] = {
    [sym_block_comment] = STATE(2119),
    [sym_identifier] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5345),
    [anon_sym_u2208] = ACTIONS(5347),
    [anon_sym_BSLASHA] = ACTIONS(5345),
    [anon_sym_BSLASHforall] = ACTIONS(5347),
    [anon_sym_u2200] = ACTIONS(5347),
    [anon_sym_BSLASHE] = ACTIONS(5345),
    [anon_sym_BSLASHexists] = ACTIONS(5347),
    [anon_sym_u2203] = ACTIONS(5347),
    [sym_temporal_forall] = ACTIONS(5347),
    [sym_temporal_exists] = ACTIONS(5347),
    [anon_sym_LT_LT] = ACTIONS(5347),
    [anon_sym_u3008] = ACTIONS(5347),
    [anon_sym_u27e8] = ACTIONS(5347),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5347),
    [anon_sym_u25a1] = ACTIONS(5347),
    [anon_sym_AT] = ACTIONS(5345),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5347),
    [anon_sym_u2227] = ACTIONS(5347),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5347),
    [anon_sym_u2228] = ACTIONS(5347),
    [anon_sym_LPAREN] = ACTIONS(5345),
    [anon_sym_LBRACK] = ACTIONS(5345),
    [anon_sym_INSTANCE] = ACTIONS(5345),
    [aux_sym_child_id_token1] = ACTIONS(5345),
    [sym_real_number] = ACTIONS(5347),
    [anon_sym_BSLASHb] = ACTIONS(5345),
    [anon_sym_BSLASHB] = ACTIONS(5347),
    [anon_sym_BSLASHo] = ACTIONS(5345),
    [anon_sym_BSLASHO] = ACTIONS(5347),
    [anon_sym_BSLASHh] = ACTIONS(5347),
    [anon_sym_BSLASHH] = ACTIONS(5347),
    [anon_sym_DQUOTE] = ACTIONS(5347),
    [anon_sym_TRUE] = ACTIONS(5345),
    [anon_sym_FALSE] = ACTIONS(5345),
    [sym_string_set] = ACTIONS(5345),
    [sym_boolean_set] = ACTIONS(5345),
    [anon_sym_Nat] = ACTIONS(5345),
    [anon_sym_u2115] = ACTIONS(5347),
    [anon_sym_Int] = ACTIONS(5345),
    [anon_sym_u2124] = ACTIONS(5347),
    [anon_sym_Real] = ACTIONS(5345),
    [anon_sym_u211d] = ACTIONS(5347),
    [anon_sym_CHOOSE] = ACTIONS(5345),
    [anon_sym_LBRACE] = ACTIONS(5347),
    [anon_sym_EQ] = ACTIONS(5345),
    [anon_sym_WF_] = ACTIONS(5345),
    [anon_sym_SF_] = ACTIONS(5345),
    [anon_sym_IF] = ACTIONS(5345),
    [anon_sym_CASE] = ACTIONS(5345),
    [anon_sym_LET] = ACTIONS(5345),
    [anon_sym_BSLASHlnot] = ACTIONS(5347),
    [anon_sym_BSLASHneg] = ACTIONS(5347),
    [anon_sym_TILDE] = ACTIONS(5345),
    [anon_sym_u00ac] = ACTIONS(5347),
    [sym_union] = ACTIONS(5345),
    [sym_powerset] = ACTIONS(5345),
    [sym_domain] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5345),
    [sym_negative_dot] = ACTIONS(5347),
    [sym_enabled] = ACTIONS(5345),
    [sym_unchanged] = ACTIONS(5345),
    [anon_sym_LT_GT] = ACTIONS(5347),
    [anon_sym_u22c4] = ACTIONS(5347),
    [anon_sym_u25c7] = ACTIONS(5347),
    [anon_sym_EQ_GT] = ACTIONS(5347),
    [anon_sym_u27f9] = ACTIONS(5347),
    [anon_sym_u21d2] = ACTIONS(5347),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5347),
    [anon_sym_u21f8] = ACTIONS(5347),
    [anon_sym_u2945] = ACTIONS(5347),
    [anon_sym_BSLASHequiv] = ACTIONS(5347),
    [anon_sym_u2261] = ACTIONS(5347),
    [anon_sym_LT_EQ_GT] = ACTIONS(5347),
    [anon_sym_u27fa] = ACTIONS(5347),
    [anon_sym_u21d4] = ACTIONS(5347),
    [anon_sym_TILDE_GT] = ACTIONS(5347),
    [anon_sym_u21dd] = ACTIONS(5347),
    [anon_sym_u219d] = ACTIONS(5347),
    [anon_sym_BSLASHland] = ACTIONS(5347),
    [anon_sym_BSLASHlor] = ACTIONS(5347),
    [anon_sym_COLON_EQ] = ACTIONS(5347),
    [anon_sym_u2254] = ACTIONS(5347),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5347),
    [anon_sym_u2a74] = ACTIONS(5347),
    [anon_sym_SLASH_EQ] = ACTIONS(5347),
    [anon_sym_POUND] = ACTIONS(5345),
    [anon_sym_u2260] = ACTIONS(5347),
    [anon_sym_LT] = ACTIONS(5345),
    [sym_gt] = ACTIONS(5345),
    [anon_sym_LT_EQ] = ACTIONS(5345),
    [anon_sym_EQ_LT] = ACTIONS(5347),
    [anon_sym_BSLASHleq] = ACTIONS(5347),
    [anon_sym_u2264] = ACTIONS(5347),
    [anon_sym_GT_EQ] = ACTIONS(5347),
    [anon_sym_BSLASHgeq] = ACTIONS(5347),
    [anon_sym_u2265] = ACTIONS(5347),
    [anon_sym_BSLASHapprox] = ACTIONS(5347),
    [anon_sym_u2248] = ACTIONS(5347),
    [anon_sym_PIPE_DASH] = ACTIONS(5347),
    [anon_sym_u22a2] = ACTIONS(5347),
    [anon_sym_PIPE_EQ] = ACTIONS(5347),
    [anon_sym_u22a8] = ACTIONS(5347),
    [anon_sym_DASH_PIPE] = ACTIONS(5347),
    [anon_sym_u22a3] = ACTIONS(5347),
    [anon_sym_EQ_PIPE] = ACTIONS(5347),
    [anon_sym_u2ae4] = ACTIONS(5347),
    [anon_sym_BSLASHasymp] = ACTIONS(5347),
    [anon_sym_u224d] = ACTIONS(5347),
    [anon_sym_BSLASHcong] = ACTIONS(5347),
    [anon_sym_u2245] = ACTIONS(5347),
    [anon_sym_BSLASHdoteq] = ACTIONS(5347),
    [anon_sym_u2250] = ACTIONS(5347),
    [anon_sym_BSLASHgg] = ACTIONS(5347),
    [anon_sym_u226b] = ACTIONS(5347),
    [anon_sym_BSLASHll] = ACTIONS(5347),
    [anon_sym_u226a] = ACTIONS(5347),
    [anon_sym_BSLASHnotin] = ACTIONS(5347),
    [anon_sym_u2209] = ACTIONS(5347),
    [anon_sym_BSLASHprec] = ACTIONS(5345),
    [anon_sym_u227a] = ACTIONS(5347),
    [anon_sym_BSLASHsucc] = ACTIONS(5345),
    [anon_sym_u227b] = ACTIONS(5347),
    [anon_sym_BSLASHpreceq] = ACTIONS(5347),
    [anon_sym_u2aaf] = ACTIONS(5347),
    [anon_sym_BSLASHsucceq] = ACTIONS(5347),
    [anon_sym_u2ab0] = ACTIONS(5347),
    [anon_sym_BSLASHpropto] = ACTIONS(5347),
    [anon_sym_u221d] = ACTIONS(5347),
    [anon_sym_BSLASHsim] = ACTIONS(5345),
    [anon_sym_u223c] = ACTIONS(5347),
    [anon_sym_BSLASHsimeq] = ACTIONS(5347),
    [anon_sym_u2243] = ACTIONS(5347),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5345),
    [anon_sym_u228f] = ACTIONS(5347),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5345),
    [anon_sym_u2290] = ACTIONS(5347),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5347),
    [anon_sym_u2291] = ACTIONS(5347),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5347),
    [anon_sym_u2292] = ACTIONS(5347),
    [anon_sym_BSLASHsubset] = ACTIONS(5345),
    [anon_sym_u2282] = ACTIONS(5347),
    [anon_sym_BSLASHsupset] = ACTIONS(5345),
    [anon_sym_u2283] = ACTIONS(5347),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5347),
    [anon_sym_u2286] = ACTIONS(5347),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5347),
    [anon_sym_u2287] = ACTIONS(5347),
    [sym_compose] = ACTIONS(5347),
    [sym_map_to] = ACTIONS(5347),
    [sym_map_from] = ACTIONS(5347),
    [sym_setminus] = ACTIONS(5345),
    [anon_sym_BSLASHcap] = ACTIONS(5347),
    [anon_sym_BSLASHintersect] = ACTIONS(5347),
    [anon_sym_u2229] = ACTIONS(5347),
    [anon_sym_BSLASHcup] = ACTIONS(5347),
    [anon_sym_BSLASHunion] = ACTIONS(5347),
    [anon_sym_u222a] = ACTIONS(5347),
    [anon_sym_DOT_DOT] = ACTIONS(5345),
    [anon_sym_u2025] = ACTIONS(5347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5347),
    [anon_sym_u2026] = ACTIONS(5347),
    [anon_sym_PLUS] = ACTIONS(5345),
    [sym_plusplus] = ACTIONS(5347),
    [anon_sym_BSLASHoplus] = ACTIONS(5347),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5347),
    [anon_sym_u2295] = ACTIONS(5347),
    [anon_sym_BSLASHominus] = ACTIONS(5347),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5347),
    [anon_sym_u2296] = ACTIONS(5347),
    [sym_mod] = ACTIONS(5345),
    [sym_modmod] = ACTIONS(5347),
    [sym_vert] = ACTIONS(5345),
    [anon_sym_PIPE_PIPE] = ACTIONS(5347),
    [anon_sym_u2016] = ACTIONS(5347),
    [sym_minusminus] = ACTIONS(5347),
    [sym_amp] = ACTIONS(5345),
    [sym_ampamp] = ACTIONS(5347),
    [anon_sym_BSLASHodot] = ACTIONS(5347),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5347),
    [anon_sym_u2299] = ACTIONS(5347),
    [anon_sym_BSLASHoslash] = ACTIONS(5347),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5347),
    [anon_sym_u2298] = ACTIONS(5347),
    [anon_sym_BSLASHotimes] = ACTIONS(5347),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5347),
    [anon_sym_u2297] = ACTIONS(5347),
    [sym_mul] = ACTIONS(5345),
    [sym_mulmul] = ACTIONS(5347),
    [sym_slash] = ACTIONS(5345),
    [sym_slashslash] = ACTIONS(5347),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5347),
    [anon_sym_u25ef] = ACTIONS(5347),
    [anon_sym_BSLASHbullet] = ACTIONS(5347),
    [anon_sym_u25cf] = ACTIONS(5347),
    [anon_sym_BSLASHdiv] = ACTIONS(5347),
    [anon_sym_u00f7] = ACTIONS(5347),
    [anon_sym_BSLASHcirc] = ACTIONS(5347),
    [anon_sym_u2218] = ACTIONS(5347),
    [anon_sym_BSLASHstar] = ACTIONS(5347),
    [anon_sym_u22c6] = ACTIONS(5347),
    [anon_sym_u203c] = ACTIONS(5347),
    [sym_hashhash] = ACTIONS(5347),
    [sym_dol] = ACTIONS(5345),
    [sym_doldol] = ACTIONS(5347),
    [anon_sym_QMARK_QMARK] = ACTIONS(5347),
    [anon_sym_u2047] = ACTIONS(5347),
    [anon_sym_BSLASHsqcap] = ACTIONS(5347),
    [anon_sym_u2293] = ACTIONS(5347),
    [anon_sym_BSLASHsqcup] = ACTIONS(5347),
    [anon_sym_u2294] = ACTIONS(5347),
    [anon_sym_BSLASHuplus] = ACTIONS(5347),
    [anon_sym_u228e] = ACTIONS(5347),
    [anon_sym_BSLASHX] = ACTIONS(5347),
    [anon_sym_BSLASHtimes] = ACTIONS(5347),
    [anon_sym_u00d7] = ACTIONS(5347),
    [anon_sym_BSLASHwr] = ACTIONS(5347),
    [anon_sym_u2240] = ACTIONS(5347),
    [anon_sym_BSLASHcdot] = ACTIONS(5347),
    [anon_sym_u22c5] = ACTIONS(5347),
    [sym_pow] = ACTIONS(5345),
    [sym_powpow] = ACTIONS(5347),
    [anon_sym_CARET_PLUS] = ACTIONS(5347),
    [anon_sym_u207a] = ACTIONS(5347),
    [sym_asterisk] = ACTIONS(5347),
    [sym_sup_hash] = ACTIONS(5347),
    [sym_prime] = ACTIONS(5347),
    [anon_sym_ASSUME] = ACTIONS(5345),
    [anon_sym_DEFINE] = ACTIONS(5345),
    [anon_sym_HAVE] = ACTIONS(5345),
    [anon_sym_WITNESS] = ACTIONS(5345),
    [anon_sym_TAKE] = ACTIONS(5345),
    [anon_sym_SUFFICES] = ACTIONS(5345),
    [anon_sym_PICK] = ACTIONS(5345),
    [anon_sym_USE] = ACTIONS(5345),
    [anon_sym_HIDE] = ACTIONS(5345),
    [sym__indent] = ACTIONS(5347),
    [sym__double_excl] = ACTIONS(5347),
  },
  [2120] = {
    [sym_block_comment] = STATE(2120),
    [sym_identifier] = ACTIONS(4286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4286),
    [anon_sym_u2208] = ACTIONS(4284),
    [anon_sym_BSLASHA] = ACTIONS(4286),
    [anon_sym_BSLASHforall] = ACTIONS(4284),
    [anon_sym_u2200] = ACTIONS(4284),
    [anon_sym_BSLASHE] = ACTIONS(4286),
    [anon_sym_BSLASHexists] = ACTIONS(4284),
    [anon_sym_u2203] = ACTIONS(4284),
    [sym_temporal_forall] = ACTIONS(4284),
    [sym_temporal_exists] = ACTIONS(4284),
    [anon_sym_LT_LT] = ACTIONS(4284),
    [anon_sym_u3008] = ACTIONS(4284),
    [anon_sym_u27e8] = ACTIONS(4284),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4284),
    [anon_sym_u25a1] = ACTIONS(4284),
    [anon_sym_AT] = ACTIONS(4286),
    [sym_placeholder] = ACTIONS(4286),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4284),
    [anon_sym_u2227] = ACTIONS(4284),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4284),
    [anon_sym_u2228] = ACTIONS(4284),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_LPAREN] = ACTIONS(4286),
    [anon_sym_RPAREN] = ACTIONS(4284),
    [anon_sym_LBRACK] = ACTIONS(4286),
    [anon_sym_INSTANCE] = ACTIONS(4286),
    [anon_sym_BANG] = ACTIONS(4284),
    [aux_sym_child_id_token1] = ACTIONS(4286),
    [sym_real_number] = ACTIONS(4284),
    [anon_sym_BSLASHb] = ACTIONS(4286),
    [anon_sym_BSLASHB] = ACTIONS(4284),
    [anon_sym_BSLASHo] = ACTIONS(4286),
    [anon_sym_BSLASHO] = ACTIONS(4284),
    [anon_sym_BSLASHh] = ACTIONS(4284),
    [anon_sym_BSLASHH] = ACTIONS(4284),
    [anon_sym_DQUOTE] = ACTIONS(4284),
    [anon_sym_TRUE] = ACTIONS(4286),
    [anon_sym_FALSE] = ACTIONS(4286),
    [sym_string_set] = ACTIONS(4286),
    [sym_boolean_set] = ACTIONS(4286),
    [anon_sym_Nat] = ACTIONS(4286),
    [anon_sym_u2115] = ACTIONS(4284),
    [anon_sym_Int] = ACTIONS(4286),
    [anon_sym_u2124] = ACTIONS(4284),
    [anon_sym_Real] = ACTIONS(4286),
    [anon_sym_u211d] = ACTIONS(4284),
    [anon_sym_CHOOSE] = ACTIONS(4286),
    [anon_sym_LBRACE] = ACTIONS(4284),
    [anon_sym_RBRACE] = ACTIONS(4284),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_WF_] = ACTIONS(4286),
    [anon_sym_SF_] = ACTIONS(4286),
    [anon_sym_IF] = ACTIONS(4286),
    [anon_sym_CASE] = ACTIONS(4286),
    [anon_sym_LET] = ACTIONS(4286),
    [anon_sym_BSLASHlnot] = ACTIONS(4284),
    [anon_sym_BSLASHneg] = ACTIONS(4284),
    [anon_sym_TILDE] = ACTIONS(4286),
    [anon_sym_u00ac] = ACTIONS(4284),
    [sym_union] = ACTIONS(4286),
    [sym_powerset] = ACTIONS(4286),
    [sym_domain] = ACTIONS(4286),
    [anon_sym_DASH] = ACTIONS(4286),
    [sym_negative_dot] = ACTIONS(4284),
    [sym_enabled] = ACTIONS(4286),
    [sym_unchanged] = ACTIONS(4286),
    [anon_sym_LT_GT] = ACTIONS(4284),
    [anon_sym_u22c4] = ACTIONS(4284),
    [anon_sym_u25c7] = ACTIONS(4284),
    [anon_sym_EQ_GT] = ACTIONS(4284),
    [anon_sym_u27f9] = ACTIONS(4284),
    [anon_sym_u21d2] = ACTIONS(4284),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4284),
    [anon_sym_u21f8] = ACTIONS(4284),
    [anon_sym_u2945] = ACTIONS(4284),
    [anon_sym_BSLASHequiv] = ACTIONS(4284),
    [anon_sym_u2261] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4284),
    [anon_sym_u27fa] = ACTIONS(4284),
    [anon_sym_u21d4] = ACTIONS(4284),
    [anon_sym_TILDE_GT] = ACTIONS(4284),
    [anon_sym_u21dd] = ACTIONS(4284),
    [anon_sym_u219d] = ACTIONS(4284),
    [anon_sym_BSLASHland] = ACTIONS(4284),
    [anon_sym_BSLASHlor] = ACTIONS(4284),
    [anon_sym_COLON_EQ] = ACTIONS(4284),
    [anon_sym_u2254] = ACTIONS(4284),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4284),
    [anon_sym_u2a74] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_POUND] = ACTIONS(4286),
    [anon_sym_u2260] = ACTIONS(4284),
    [anon_sym_LT] = ACTIONS(4286),
    [sym_gt] = ACTIONS(4286),
    [anon_sym_LT_EQ] = ACTIONS(4286),
    [anon_sym_EQ_LT] = ACTIONS(4284),
    [anon_sym_BSLASHleq] = ACTIONS(4284),
    [anon_sym_u2264] = ACTIONS(4284),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_BSLASHgeq] = ACTIONS(4284),
    [anon_sym_u2265] = ACTIONS(4284),
    [anon_sym_BSLASHapprox] = ACTIONS(4284),
    [anon_sym_u2248] = ACTIONS(4284),
    [anon_sym_PIPE_DASH] = ACTIONS(4284),
    [anon_sym_u22a2] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_u22a8] = ACTIONS(4284),
    [anon_sym_DASH_PIPE] = ACTIONS(4284),
    [anon_sym_u22a3] = ACTIONS(4284),
    [anon_sym_EQ_PIPE] = ACTIONS(4284),
    [anon_sym_u2ae4] = ACTIONS(4284),
    [anon_sym_BSLASHasymp] = ACTIONS(4284),
    [anon_sym_u224d] = ACTIONS(4284),
    [anon_sym_BSLASHcong] = ACTIONS(4284),
    [anon_sym_u2245] = ACTIONS(4284),
    [anon_sym_BSLASHdoteq] = ACTIONS(4284),
    [anon_sym_u2250] = ACTIONS(4284),
    [anon_sym_BSLASHgg] = ACTIONS(4284),
    [anon_sym_u226b] = ACTIONS(4284),
    [anon_sym_BSLASHll] = ACTIONS(4284),
    [anon_sym_u226a] = ACTIONS(4284),
    [anon_sym_BSLASHnotin] = ACTIONS(4284),
    [anon_sym_u2209] = ACTIONS(4284),
    [anon_sym_BSLASHprec] = ACTIONS(4286),
    [anon_sym_u227a] = ACTIONS(4284),
    [anon_sym_BSLASHsucc] = ACTIONS(4286),
    [anon_sym_u227b] = ACTIONS(4284),
    [anon_sym_BSLASHpreceq] = ACTIONS(4284),
    [anon_sym_u2aaf] = ACTIONS(4284),
    [anon_sym_BSLASHsucceq] = ACTIONS(4284),
    [anon_sym_u2ab0] = ACTIONS(4284),
    [anon_sym_BSLASHpropto] = ACTIONS(4284),
    [anon_sym_u221d] = ACTIONS(4284),
    [anon_sym_BSLASHsim] = ACTIONS(4286),
    [anon_sym_u223c] = ACTIONS(4284),
    [anon_sym_BSLASHsimeq] = ACTIONS(4284),
    [anon_sym_u2243] = ACTIONS(4284),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4286),
    [anon_sym_u228f] = ACTIONS(4284),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4286),
    [anon_sym_u2290] = ACTIONS(4284),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4284),
    [anon_sym_u2291] = ACTIONS(4284),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4284),
    [anon_sym_u2292] = ACTIONS(4284),
    [anon_sym_BSLASHsubset] = ACTIONS(4286),
    [anon_sym_u2282] = ACTIONS(4284),
    [anon_sym_BSLASHsupset] = ACTIONS(4286),
    [anon_sym_u2283] = ACTIONS(4284),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4284),
    [anon_sym_u2286] = ACTIONS(4284),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4284),
    [anon_sym_u2287] = ACTIONS(4284),
    [sym_compose] = ACTIONS(4284),
    [sym_map_to] = ACTIONS(4284),
    [sym_map_from] = ACTIONS(4284),
    [sym_setminus] = ACTIONS(4286),
    [anon_sym_BSLASHcap] = ACTIONS(4284),
    [anon_sym_BSLASHintersect] = ACTIONS(4284),
    [anon_sym_u2229] = ACTIONS(4284),
    [anon_sym_BSLASHcup] = ACTIONS(4284),
    [anon_sym_BSLASHunion] = ACTIONS(4284),
    [anon_sym_u222a] = ACTIONS(4284),
    [anon_sym_DOT_DOT] = ACTIONS(4286),
    [anon_sym_u2025] = ACTIONS(4284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4284),
    [anon_sym_u2026] = ACTIONS(4284),
    [anon_sym_PLUS] = ACTIONS(4286),
    [sym_plusplus] = ACTIONS(4284),
    [anon_sym_BSLASHoplus] = ACTIONS(4284),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4284),
    [anon_sym_u2295] = ACTIONS(4284),
    [anon_sym_BSLASHominus] = ACTIONS(4284),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4284),
    [anon_sym_u2296] = ACTIONS(4284),
    [sym_mod] = ACTIONS(4286),
    [sym_modmod] = ACTIONS(4284),
    [sym_vert] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_u2016] = ACTIONS(4284),
    [sym_minusminus] = ACTIONS(4284),
    [sym_amp] = ACTIONS(4286),
    [sym_ampamp] = ACTIONS(4284),
    [anon_sym_BSLASHodot] = ACTIONS(4284),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4284),
    [anon_sym_u2299] = ACTIONS(4284),
    [anon_sym_BSLASHoslash] = ACTIONS(4284),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4284),
    [anon_sym_u2298] = ACTIONS(4284),
    [anon_sym_BSLASHotimes] = ACTIONS(4284),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4284),
    [anon_sym_u2297] = ACTIONS(4284),
    [sym_mul] = ACTIONS(4286),
    [sym_mulmul] = ACTIONS(4284),
    [sym_slash] = ACTIONS(4286),
    [sym_slashslash] = ACTIONS(4284),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4284),
    [anon_sym_u25ef] = ACTIONS(4284),
    [anon_sym_BSLASHbullet] = ACTIONS(4284),
    [anon_sym_u25cf] = ACTIONS(4284),
    [anon_sym_BSLASHdiv] = ACTIONS(4284),
    [anon_sym_u00f7] = ACTIONS(4284),
    [anon_sym_BSLASHcirc] = ACTIONS(4284),
    [anon_sym_u2218] = ACTIONS(4284),
    [anon_sym_BSLASHstar] = ACTIONS(4284),
    [anon_sym_u22c6] = ACTIONS(4284),
    [anon_sym_u203c] = ACTIONS(4284),
    [sym_hashhash] = ACTIONS(4284),
    [sym_dol] = ACTIONS(4286),
    [sym_doldol] = ACTIONS(4284),
    [anon_sym_QMARK_QMARK] = ACTIONS(4284),
    [anon_sym_u2047] = ACTIONS(4284),
    [anon_sym_BSLASHsqcap] = ACTIONS(4284),
    [anon_sym_u2293] = ACTIONS(4284),
    [anon_sym_BSLASHsqcup] = ACTIONS(4284),
    [anon_sym_u2294] = ACTIONS(4284),
    [anon_sym_BSLASHuplus] = ACTIONS(4284),
    [anon_sym_u228e] = ACTIONS(4284),
    [anon_sym_BSLASHX] = ACTIONS(4284),
    [anon_sym_BSLASHtimes] = ACTIONS(4284),
    [anon_sym_u00d7] = ACTIONS(4284),
    [anon_sym_BSLASHwr] = ACTIONS(4284),
    [anon_sym_u2240] = ACTIONS(4284),
    [anon_sym_BSLASHcdot] = ACTIONS(4284),
    [anon_sym_u22c5] = ACTIONS(4284),
    [sym_pow] = ACTIONS(4286),
    [sym_powpow] = ACTIONS(4284),
    [anon_sym_CARET_PLUS] = ACTIONS(4284),
    [anon_sym_u207a] = ACTIONS(4284),
    [sym_asterisk] = ACTIONS(4284),
    [sym_sup_hash] = ACTIONS(4284),
    [sym_prime] = ACTIONS(4284),
    [anon_sym_end] = ACTIONS(4286),
    [sym__indent] = ACTIONS(4284),
    [sym__double_excl] = ACTIONS(4284),
  },
  [2121] = {
    [sym_block_comment] = STATE(2121),
    [sym_identifier] = ACTIONS(4290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4290),
    [anon_sym_u2208] = ACTIONS(4288),
    [anon_sym_BSLASHA] = ACTIONS(4290),
    [anon_sym_BSLASHforall] = ACTIONS(4288),
    [anon_sym_u2200] = ACTIONS(4288),
    [anon_sym_BSLASHE] = ACTIONS(4290),
    [anon_sym_BSLASHexists] = ACTIONS(4288),
    [anon_sym_u2203] = ACTIONS(4288),
    [sym_temporal_forall] = ACTIONS(4288),
    [sym_temporal_exists] = ACTIONS(4288),
    [anon_sym_LT_LT] = ACTIONS(4288),
    [anon_sym_u3008] = ACTIONS(4288),
    [anon_sym_u27e8] = ACTIONS(4288),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4288),
    [anon_sym_u25a1] = ACTIONS(4288),
    [anon_sym_AT] = ACTIONS(4290),
    [sym_placeholder] = ACTIONS(4290),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4288),
    [anon_sym_u2227] = ACTIONS(4288),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4288),
    [anon_sym_u2228] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_LPAREN] = ACTIONS(4290),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4290),
    [anon_sym_INSTANCE] = ACTIONS(4290),
    [anon_sym_BANG] = ACTIONS(4288),
    [aux_sym_child_id_token1] = ACTIONS(4290),
    [sym_real_number] = ACTIONS(4288),
    [anon_sym_BSLASHb] = ACTIONS(4290),
    [anon_sym_BSLASHB] = ACTIONS(4288),
    [anon_sym_BSLASHo] = ACTIONS(4290),
    [anon_sym_BSLASHO] = ACTIONS(4288),
    [anon_sym_BSLASHh] = ACTIONS(4288),
    [anon_sym_BSLASHH] = ACTIONS(4288),
    [anon_sym_DQUOTE] = ACTIONS(4288),
    [anon_sym_TRUE] = ACTIONS(4290),
    [anon_sym_FALSE] = ACTIONS(4290),
    [sym_string_set] = ACTIONS(4290),
    [sym_boolean_set] = ACTIONS(4290),
    [anon_sym_Nat] = ACTIONS(4290),
    [anon_sym_u2115] = ACTIONS(4288),
    [anon_sym_Int] = ACTIONS(4290),
    [anon_sym_u2124] = ACTIONS(4288),
    [anon_sym_Real] = ACTIONS(4290),
    [anon_sym_u211d] = ACTIONS(4288),
    [anon_sym_CHOOSE] = ACTIONS(4290),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_RBRACE] = ACTIONS(4288),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_WF_] = ACTIONS(4290),
    [anon_sym_SF_] = ACTIONS(4290),
    [anon_sym_IF] = ACTIONS(4290),
    [anon_sym_CASE] = ACTIONS(4290),
    [anon_sym_LET] = ACTIONS(4290),
    [anon_sym_BSLASHlnot] = ACTIONS(4288),
    [anon_sym_BSLASHneg] = ACTIONS(4288),
    [anon_sym_TILDE] = ACTIONS(4290),
    [anon_sym_u00ac] = ACTIONS(4288),
    [sym_union] = ACTIONS(4290),
    [sym_powerset] = ACTIONS(4290),
    [sym_domain] = ACTIONS(4290),
    [anon_sym_DASH] = ACTIONS(4290),
    [sym_negative_dot] = ACTIONS(4288),
    [sym_enabled] = ACTIONS(4290),
    [sym_unchanged] = ACTIONS(4290),
    [anon_sym_LT_GT] = ACTIONS(4288),
    [anon_sym_u22c4] = ACTIONS(4288),
    [anon_sym_u25c7] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_u27f9] = ACTIONS(4288),
    [anon_sym_u21d2] = ACTIONS(4288),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4288),
    [anon_sym_u21f8] = ACTIONS(4288),
    [anon_sym_u2945] = ACTIONS(4288),
    [anon_sym_BSLASHequiv] = ACTIONS(4288),
    [anon_sym_u2261] = ACTIONS(4288),
    [anon_sym_LT_EQ_GT] = ACTIONS(4288),
    [anon_sym_u27fa] = ACTIONS(4288),
    [anon_sym_u21d4] = ACTIONS(4288),
    [anon_sym_TILDE_GT] = ACTIONS(4288),
    [anon_sym_u21dd] = ACTIONS(4288),
    [anon_sym_u219d] = ACTIONS(4288),
    [anon_sym_BSLASHland] = ACTIONS(4288),
    [anon_sym_BSLASHlor] = ACTIONS(4288),
    [anon_sym_COLON_EQ] = ACTIONS(4288),
    [anon_sym_u2254] = ACTIONS(4288),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4288),
    [anon_sym_u2a74] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_POUND] = ACTIONS(4290),
    [anon_sym_u2260] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4290),
    [sym_gt] = ACTIONS(4290),
    [anon_sym_LT_EQ] = ACTIONS(4290),
    [anon_sym_EQ_LT] = ACTIONS(4288),
    [anon_sym_BSLASHleq] = ACTIONS(4288),
    [anon_sym_u2264] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(4288),
    [anon_sym_BSLASHgeq] = ACTIONS(4288),
    [anon_sym_u2265] = ACTIONS(4288),
    [anon_sym_BSLASHapprox] = ACTIONS(4288),
    [anon_sym_u2248] = ACTIONS(4288),
    [anon_sym_PIPE_DASH] = ACTIONS(4288),
    [anon_sym_u22a2] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_u22a8] = ACTIONS(4288),
    [anon_sym_DASH_PIPE] = ACTIONS(4288),
    [anon_sym_u22a3] = ACTIONS(4288),
    [anon_sym_EQ_PIPE] = ACTIONS(4288),
    [anon_sym_u2ae4] = ACTIONS(4288),
    [anon_sym_BSLASHasymp] = ACTIONS(4288),
    [anon_sym_u224d] = ACTIONS(4288),
    [anon_sym_BSLASHcong] = ACTIONS(4288),
    [anon_sym_u2245] = ACTIONS(4288),
    [anon_sym_BSLASHdoteq] = ACTIONS(4288),
    [anon_sym_u2250] = ACTIONS(4288),
    [anon_sym_BSLASHgg] = ACTIONS(4288),
    [anon_sym_u226b] = ACTIONS(4288),
    [anon_sym_BSLASHll] = ACTIONS(4288),
    [anon_sym_u226a] = ACTIONS(4288),
    [anon_sym_BSLASHnotin] = ACTIONS(4288),
    [anon_sym_u2209] = ACTIONS(4288),
    [anon_sym_BSLASHprec] = ACTIONS(4290),
    [anon_sym_u227a] = ACTIONS(4288),
    [anon_sym_BSLASHsucc] = ACTIONS(4290),
    [anon_sym_u227b] = ACTIONS(4288),
    [anon_sym_BSLASHpreceq] = ACTIONS(4288),
    [anon_sym_u2aaf] = ACTIONS(4288),
    [anon_sym_BSLASHsucceq] = ACTIONS(4288),
    [anon_sym_u2ab0] = ACTIONS(4288),
    [anon_sym_BSLASHpropto] = ACTIONS(4288),
    [anon_sym_u221d] = ACTIONS(4288),
    [anon_sym_BSLASHsim] = ACTIONS(4290),
    [anon_sym_u223c] = ACTIONS(4288),
    [anon_sym_BSLASHsimeq] = ACTIONS(4288),
    [anon_sym_u2243] = ACTIONS(4288),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4290),
    [anon_sym_u228f] = ACTIONS(4288),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4290),
    [anon_sym_u2290] = ACTIONS(4288),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4288),
    [anon_sym_u2291] = ACTIONS(4288),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4288),
    [anon_sym_u2292] = ACTIONS(4288),
    [anon_sym_BSLASHsubset] = ACTIONS(4290),
    [anon_sym_u2282] = ACTIONS(4288),
    [anon_sym_BSLASHsupset] = ACTIONS(4290),
    [anon_sym_u2283] = ACTIONS(4288),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4288),
    [anon_sym_u2286] = ACTIONS(4288),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4288),
    [anon_sym_u2287] = ACTIONS(4288),
    [sym_compose] = ACTIONS(4288),
    [sym_map_to] = ACTIONS(4288),
    [sym_map_from] = ACTIONS(4288),
    [sym_setminus] = ACTIONS(4290),
    [anon_sym_BSLASHcap] = ACTIONS(4288),
    [anon_sym_BSLASHintersect] = ACTIONS(4288),
    [anon_sym_u2229] = ACTIONS(4288),
    [anon_sym_BSLASHcup] = ACTIONS(4288),
    [anon_sym_BSLASHunion] = ACTIONS(4288),
    [anon_sym_u222a] = ACTIONS(4288),
    [anon_sym_DOT_DOT] = ACTIONS(4290),
    [anon_sym_u2025] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4288),
    [anon_sym_u2026] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(4290),
    [sym_plusplus] = ACTIONS(4288),
    [anon_sym_BSLASHoplus] = ACTIONS(4288),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4288),
    [anon_sym_u2295] = ACTIONS(4288),
    [anon_sym_BSLASHominus] = ACTIONS(4288),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4288),
    [anon_sym_u2296] = ACTIONS(4288),
    [sym_mod] = ACTIONS(4290),
    [sym_modmod] = ACTIONS(4288),
    [sym_vert] = ACTIONS(4290),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_u2016] = ACTIONS(4288),
    [sym_minusminus] = ACTIONS(4288),
    [sym_amp] = ACTIONS(4290),
    [sym_ampamp] = ACTIONS(4288),
    [anon_sym_BSLASHodot] = ACTIONS(4288),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4288),
    [anon_sym_u2299] = ACTIONS(4288),
    [anon_sym_BSLASHoslash] = ACTIONS(4288),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4288),
    [anon_sym_u2298] = ACTIONS(4288),
    [anon_sym_BSLASHotimes] = ACTIONS(4288),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4288),
    [anon_sym_u2297] = ACTIONS(4288),
    [sym_mul] = ACTIONS(4290),
    [sym_mulmul] = ACTIONS(4288),
    [sym_slash] = ACTIONS(4290),
    [sym_slashslash] = ACTIONS(4288),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4288),
    [anon_sym_u25ef] = ACTIONS(4288),
    [anon_sym_BSLASHbullet] = ACTIONS(4288),
    [anon_sym_u25cf] = ACTIONS(4288),
    [anon_sym_BSLASHdiv] = ACTIONS(4288),
    [anon_sym_u00f7] = ACTIONS(4288),
    [anon_sym_BSLASHcirc] = ACTIONS(4288),
    [anon_sym_u2218] = ACTIONS(4288),
    [anon_sym_BSLASHstar] = ACTIONS(4288),
    [anon_sym_u22c6] = ACTIONS(4288),
    [anon_sym_u203c] = ACTIONS(4288),
    [sym_hashhash] = ACTIONS(4288),
    [sym_dol] = ACTIONS(4290),
    [sym_doldol] = ACTIONS(4288),
    [anon_sym_QMARK_QMARK] = ACTIONS(4288),
    [anon_sym_u2047] = ACTIONS(4288),
    [anon_sym_BSLASHsqcap] = ACTIONS(4288),
    [anon_sym_u2293] = ACTIONS(4288),
    [anon_sym_BSLASHsqcup] = ACTIONS(4288),
    [anon_sym_u2294] = ACTIONS(4288),
    [anon_sym_BSLASHuplus] = ACTIONS(4288),
    [anon_sym_u228e] = ACTIONS(4288),
    [anon_sym_BSLASHX] = ACTIONS(4288),
    [anon_sym_BSLASHtimes] = ACTIONS(4288),
    [anon_sym_u00d7] = ACTIONS(4288),
    [anon_sym_BSLASHwr] = ACTIONS(4288),
    [anon_sym_u2240] = ACTIONS(4288),
    [anon_sym_BSLASHcdot] = ACTIONS(4288),
    [anon_sym_u22c5] = ACTIONS(4288),
    [sym_pow] = ACTIONS(4290),
    [sym_powpow] = ACTIONS(4288),
    [anon_sym_CARET_PLUS] = ACTIONS(4288),
    [anon_sym_u207a] = ACTIONS(4288),
    [sym_asterisk] = ACTIONS(4288),
    [sym_sup_hash] = ACTIONS(4288),
    [sym_prime] = ACTIONS(4288),
    [anon_sym_end] = ACTIONS(4290),
    [sym__indent] = ACTIONS(4288),
    [sym__double_excl] = ACTIONS(4288),
  },
  [2122] = {
    [sym_block_comment] = STATE(2122),
    [sym_identifier] = ACTIONS(4282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4282),
    [anon_sym_u2208] = ACTIONS(4280),
    [anon_sym_BSLASHA] = ACTIONS(4282),
    [anon_sym_BSLASHforall] = ACTIONS(4280),
    [anon_sym_u2200] = ACTIONS(4280),
    [anon_sym_BSLASHE] = ACTIONS(4282),
    [anon_sym_BSLASHexists] = ACTIONS(4280),
    [anon_sym_u2203] = ACTIONS(4280),
    [sym_temporal_forall] = ACTIONS(4280),
    [sym_temporal_exists] = ACTIONS(4280),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_u3008] = ACTIONS(4280),
    [anon_sym_u27e8] = ACTIONS(4280),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4280),
    [anon_sym_u25a1] = ACTIONS(4280),
    [anon_sym_AT] = ACTIONS(4282),
    [sym_placeholder] = ACTIONS(4282),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4280),
    [anon_sym_u2227] = ACTIONS(4280),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4280),
    [anon_sym_u2228] = ACTIONS(4280),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_LPAREN] = ACTIONS(4282),
    [anon_sym_RPAREN] = ACTIONS(4280),
    [anon_sym_LBRACK] = ACTIONS(4282),
    [anon_sym_INSTANCE] = ACTIONS(4282),
    [anon_sym_BANG] = ACTIONS(4280),
    [aux_sym_child_id_token1] = ACTIONS(4282),
    [sym_real_number] = ACTIONS(4280),
    [anon_sym_BSLASHb] = ACTIONS(4282),
    [anon_sym_BSLASHB] = ACTIONS(4280),
    [anon_sym_BSLASHo] = ACTIONS(4282),
    [anon_sym_BSLASHO] = ACTIONS(4280),
    [anon_sym_BSLASHh] = ACTIONS(4280),
    [anon_sym_BSLASHH] = ACTIONS(4280),
    [anon_sym_DQUOTE] = ACTIONS(4280),
    [anon_sym_TRUE] = ACTIONS(4282),
    [anon_sym_FALSE] = ACTIONS(4282),
    [sym_string_set] = ACTIONS(4282),
    [sym_boolean_set] = ACTIONS(4282),
    [anon_sym_Nat] = ACTIONS(4282),
    [anon_sym_u2115] = ACTIONS(4280),
    [anon_sym_Int] = ACTIONS(4282),
    [anon_sym_u2124] = ACTIONS(4280),
    [anon_sym_Real] = ACTIONS(4282),
    [anon_sym_u211d] = ACTIONS(4280),
    [anon_sym_CHOOSE] = ACTIONS(4282),
    [anon_sym_LBRACE] = ACTIONS(4280),
    [anon_sym_RBRACE] = ACTIONS(4280),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_WF_] = ACTIONS(4282),
    [anon_sym_SF_] = ACTIONS(4282),
    [anon_sym_IF] = ACTIONS(4282),
    [anon_sym_CASE] = ACTIONS(4282),
    [anon_sym_LET] = ACTIONS(4282),
    [anon_sym_BSLASHlnot] = ACTIONS(4280),
    [anon_sym_BSLASHneg] = ACTIONS(4280),
    [anon_sym_TILDE] = ACTIONS(4282),
    [anon_sym_u00ac] = ACTIONS(4280),
    [sym_union] = ACTIONS(4282),
    [sym_powerset] = ACTIONS(4282),
    [sym_domain] = ACTIONS(4282),
    [anon_sym_DASH] = ACTIONS(4282),
    [sym_negative_dot] = ACTIONS(4280),
    [sym_enabled] = ACTIONS(4282),
    [sym_unchanged] = ACTIONS(4282),
    [anon_sym_LT_GT] = ACTIONS(4280),
    [anon_sym_u22c4] = ACTIONS(4280),
    [anon_sym_u25c7] = ACTIONS(4280),
    [anon_sym_EQ_GT] = ACTIONS(4280),
    [anon_sym_u27f9] = ACTIONS(4280),
    [anon_sym_u21d2] = ACTIONS(4280),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4280),
    [anon_sym_u21f8] = ACTIONS(4280),
    [anon_sym_u2945] = ACTIONS(4280),
    [anon_sym_BSLASHequiv] = ACTIONS(4280),
    [anon_sym_u2261] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4280),
    [anon_sym_u27fa] = ACTIONS(4280),
    [anon_sym_u21d4] = ACTIONS(4280),
    [anon_sym_TILDE_GT] = ACTIONS(4280),
    [anon_sym_u21dd] = ACTIONS(4280),
    [anon_sym_u219d] = ACTIONS(4280),
    [anon_sym_BSLASHland] = ACTIONS(4280),
    [anon_sym_BSLASHlor] = ACTIONS(4280),
    [anon_sym_COLON_EQ] = ACTIONS(4280),
    [anon_sym_u2254] = ACTIONS(4280),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4280),
    [anon_sym_u2a74] = ACTIONS(4280),
    [anon_sym_SLASH_EQ] = ACTIONS(4280),
    [anon_sym_POUND] = ACTIONS(4282),
    [anon_sym_u2260] = ACTIONS(4280),
    [anon_sym_LT] = ACTIONS(4282),
    [sym_gt] = ACTIONS(4282),
    [anon_sym_LT_EQ] = ACTIONS(4282),
    [anon_sym_EQ_LT] = ACTIONS(4280),
    [anon_sym_BSLASHleq] = ACTIONS(4280),
    [anon_sym_u2264] = ACTIONS(4280),
    [anon_sym_GT_EQ] = ACTIONS(4280),
    [anon_sym_BSLASHgeq] = ACTIONS(4280),
    [anon_sym_u2265] = ACTIONS(4280),
    [anon_sym_BSLASHapprox] = ACTIONS(4280),
    [anon_sym_u2248] = ACTIONS(4280),
    [anon_sym_PIPE_DASH] = ACTIONS(4280),
    [anon_sym_u22a2] = ACTIONS(4280),
    [anon_sym_PIPE_EQ] = ACTIONS(4280),
    [anon_sym_u22a8] = ACTIONS(4280),
    [anon_sym_DASH_PIPE] = ACTIONS(4280),
    [anon_sym_u22a3] = ACTIONS(4280),
    [anon_sym_EQ_PIPE] = ACTIONS(4280),
    [anon_sym_u2ae4] = ACTIONS(4280),
    [anon_sym_BSLASHasymp] = ACTIONS(4280),
    [anon_sym_u224d] = ACTIONS(4280),
    [anon_sym_BSLASHcong] = ACTIONS(4280),
    [anon_sym_u2245] = ACTIONS(4280),
    [anon_sym_BSLASHdoteq] = ACTIONS(4280),
    [anon_sym_u2250] = ACTIONS(4280),
    [anon_sym_BSLASHgg] = ACTIONS(4280),
    [anon_sym_u226b] = ACTIONS(4280),
    [anon_sym_BSLASHll] = ACTIONS(4280),
    [anon_sym_u226a] = ACTIONS(4280),
    [anon_sym_BSLASHnotin] = ACTIONS(4280),
    [anon_sym_u2209] = ACTIONS(4280),
    [anon_sym_BSLASHprec] = ACTIONS(4282),
    [anon_sym_u227a] = ACTIONS(4280),
    [anon_sym_BSLASHsucc] = ACTIONS(4282),
    [anon_sym_u227b] = ACTIONS(4280),
    [anon_sym_BSLASHpreceq] = ACTIONS(4280),
    [anon_sym_u2aaf] = ACTIONS(4280),
    [anon_sym_BSLASHsucceq] = ACTIONS(4280),
    [anon_sym_u2ab0] = ACTIONS(4280),
    [anon_sym_BSLASHpropto] = ACTIONS(4280),
    [anon_sym_u221d] = ACTIONS(4280),
    [anon_sym_BSLASHsim] = ACTIONS(4282),
    [anon_sym_u223c] = ACTIONS(4280),
    [anon_sym_BSLASHsimeq] = ACTIONS(4280),
    [anon_sym_u2243] = ACTIONS(4280),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4282),
    [anon_sym_u228f] = ACTIONS(4280),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4282),
    [anon_sym_u2290] = ACTIONS(4280),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4280),
    [anon_sym_u2291] = ACTIONS(4280),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4280),
    [anon_sym_u2292] = ACTIONS(4280),
    [anon_sym_BSLASHsubset] = ACTIONS(4282),
    [anon_sym_u2282] = ACTIONS(4280),
    [anon_sym_BSLASHsupset] = ACTIONS(4282),
    [anon_sym_u2283] = ACTIONS(4280),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4280),
    [anon_sym_u2286] = ACTIONS(4280),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4280),
    [anon_sym_u2287] = ACTIONS(4280),
    [sym_compose] = ACTIONS(4280),
    [sym_map_to] = ACTIONS(4280),
    [sym_map_from] = ACTIONS(4280),
    [sym_setminus] = ACTIONS(4282),
    [anon_sym_BSLASHcap] = ACTIONS(4280),
    [anon_sym_BSLASHintersect] = ACTIONS(4280),
    [anon_sym_u2229] = ACTIONS(4280),
    [anon_sym_BSLASHcup] = ACTIONS(4280),
    [anon_sym_BSLASHunion] = ACTIONS(4280),
    [anon_sym_u222a] = ACTIONS(4280),
    [anon_sym_DOT_DOT] = ACTIONS(4282),
    [anon_sym_u2025] = ACTIONS(4280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4280),
    [anon_sym_u2026] = ACTIONS(4280),
    [anon_sym_PLUS] = ACTIONS(4282),
    [sym_plusplus] = ACTIONS(4280),
    [anon_sym_BSLASHoplus] = ACTIONS(4280),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4280),
    [anon_sym_u2295] = ACTIONS(4280),
    [anon_sym_BSLASHominus] = ACTIONS(4280),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4280),
    [anon_sym_u2296] = ACTIONS(4280),
    [sym_mod] = ACTIONS(4282),
    [sym_modmod] = ACTIONS(4280),
    [sym_vert] = ACTIONS(4282),
    [anon_sym_PIPE_PIPE] = ACTIONS(4280),
    [anon_sym_u2016] = ACTIONS(4280),
    [sym_minusminus] = ACTIONS(4280),
    [sym_amp] = ACTIONS(4282),
    [sym_ampamp] = ACTIONS(4280),
    [anon_sym_BSLASHodot] = ACTIONS(4280),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4280),
    [anon_sym_u2299] = ACTIONS(4280),
    [anon_sym_BSLASHoslash] = ACTIONS(4280),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4280),
    [anon_sym_u2298] = ACTIONS(4280),
    [anon_sym_BSLASHotimes] = ACTIONS(4280),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4280),
    [anon_sym_u2297] = ACTIONS(4280),
    [sym_mul] = ACTIONS(4282),
    [sym_mulmul] = ACTIONS(4280),
    [sym_slash] = ACTIONS(4282),
    [sym_slashslash] = ACTIONS(4280),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4280),
    [anon_sym_u25ef] = ACTIONS(4280),
    [anon_sym_BSLASHbullet] = ACTIONS(4280),
    [anon_sym_u25cf] = ACTIONS(4280),
    [anon_sym_BSLASHdiv] = ACTIONS(4280),
    [anon_sym_u00f7] = ACTIONS(4280),
    [anon_sym_BSLASHcirc] = ACTIONS(4280),
    [anon_sym_u2218] = ACTIONS(4280),
    [anon_sym_BSLASHstar] = ACTIONS(4280),
    [anon_sym_u22c6] = ACTIONS(4280),
    [anon_sym_u203c] = ACTIONS(4280),
    [sym_hashhash] = ACTIONS(4280),
    [sym_dol] = ACTIONS(4282),
    [sym_doldol] = ACTIONS(4280),
    [anon_sym_QMARK_QMARK] = ACTIONS(4280),
    [anon_sym_u2047] = ACTIONS(4280),
    [anon_sym_BSLASHsqcap] = ACTIONS(4280),
    [anon_sym_u2293] = ACTIONS(4280),
    [anon_sym_BSLASHsqcup] = ACTIONS(4280),
    [anon_sym_u2294] = ACTIONS(4280),
    [anon_sym_BSLASHuplus] = ACTIONS(4280),
    [anon_sym_u228e] = ACTIONS(4280),
    [anon_sym_BSLASHX] = ACTIONS(4280),
    [anon_sym_BSLASHtimes] = ACTIONS(4280),
    [anon_sym_u00d7] = ACTIONS(4280),
    [anon_sym_BSLASHwr] = ACTIONS(4280),
    [anon_sym_u2240] = ACTIONS(4280),
    [anon_sym_BSLASHcdot] = ACTIONS(4280),
    [anon_sym_u22c5] = ACTIONS(4280),
    [sym_pow] = ACTIONS(4282),
    [sym_powpow] = ACTIONS(4280),
    [anon_sym_CARET_PLUS] = ACTIONS(4280),
    [anon_sym_u207a] = ACTIONS(4280),
    [sym_asterisk] = ACTIONS(4280),
    [sym_sup_hash] = ACTIONS(4280),
    [sym_prime] = ACTIONS(4280),
    [anon_sym_end] = ACTIONS(4282),
    [sym__indent] = ACTIONS(4280),
    [sym__double_excl] = ACTIONS(4280),
  },
  [2123] = {
    [sym_block_comment] = STATE(2123),
    [sym_identifier] = ACTIONS(4266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4271),
    [anon_sym_u2208] = ACTIONS(4273),
    [anon_sym_BSLASHA] = ACTIONS(4271),
    [anon_sym_BSLASHforall] = ACTIONS(4273),
    [anon_sym_u2200] = ACTIONS(4273),
    [anon_sym_BSLASHE] = ACTIONS(4271),
    [anon_sym_BSLASHexists] = ACTIONS(4273),
    [anon_sym_u2203] = ACTIONS(4273),
    [sym_temporal_forall] = ACTIONS(4273),
    [sym_temporal_exists] = ACTIONS(4273),
    [anon_sym_LT_LT] = ACTIONS(4273),
    [anon_sym_u3008] = ACTIONS(4273),
    [anon_sym_u27e8] = ACTIONS(4273),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4275),
    [anon_sym_u25a1] = ACTIONS(4275),
    [anon_sym_AT] = ACTIONS(4271),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4273),
    [anon_sym_u2227] = ACTIONS(4273),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4273),
    [anon_sym_u2228] = ACTIONS(4273),
    [anon_sym_COMMA] = ACTIONS(4269),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [anon_sym_LBRACK] = ACTIONS(4271),
    [anon_sym_INSTANCE] = ACTIONS(4278),
    [anon_sym_BANG] = ACTIONS(4269),
    [aux_sym_child_id_token1] = ACTIONS(4271),
    [sym_real_number] = ACTIONS(4273),
    [anon_sym_BSLASHb] = ACTIONS(4271),
    [anon_sym_BSLASHB] = ACTIONS(4273),
    [anon_sym_BSLASHo] = ACTIONS(4271),
    [anon_sym_BSLASHO] = ACTIONS(4273),
    [anon_sym_BSLASHh] = ACTIONS(4273),
    [anon_sym_BSLASHH] = ACTIONS(4273),
    [anon_sym_DQUOTE] = ACTIONS(4273),
    [anon_sym_TRUE] = ACTIONS(4271),
    [anon_sym_FALSE] = ACTIONS(4271),
    [sym_string_set] = ACTIONS(4271),
    [sym_boolean_set] = ACTIONS(4271),
    [anon_sym_Nat] = ACTIONS(4266),
    [anon_sym_u2115] = ACTIONS(4275),
    [anon_sym_Int] = ACTIONS(4266),
    [anon_sym_u2124] = ACTIONS(4275),
    [anon_sym_Real] = ACTIONS(4266),
    [anon_sym_u211d] = ACTIONS(4275),
    [anon_sym_CHOOSE] = ACTIONS(4271),
    [anon_sym_LBRACE] = ACTIONS(4273),
    [anon_sym_RBRACE] = ACTIONS(4269),
    [anon_sym_EQ] = ACTIONS(4271),
    [anon_sym_WF_] = ACTIONS(4271),
    [anon_sym_SF_] = ACTIONS(4271),
    [anon_sym_IF] = ACTIONS(4271),
    [anon_sym_CASE] = ACTIONS(4271),
    [anon_sym_LET] = ACTIONS(4271),
    [anon_sym_BSLASHlnot] = ACTIONS(4275),
    [anon_sym_BSLASHneg] = ACTIONS(4275),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_u00ac] = ACTIONS(4275),
    [sym_union] = ACTIONS(4266),
    [sym_powerset] = ACTIONS(4266),
    [sym_domain] = ACTIONS(4266),
    [anon_sym_DASH] = ACTIONS(4271),
    [sym_negative_dot] = ACTIONS(4275),
    [sym_enabled] = ACTIONS(4266),
    [sym_unchanged] = ACTIONS(4266),
    [anon_sym_LT_GT] = ACTIONS(4275),
    [anon_sym_u22c4] = ACTIONS(4275),
    [anon_sym_u25c7] = ACTIONS(4275),
    [anon_sym_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27f9] = ACTIONS(4273),
    [anon_sym_u21d2] = ACTIONS(4273),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4273),
    [anon_sym_u21f8] = ACTIONS(4273),
    [anon_sym_u2945] = ACTIONS(4273),
    [anon_sym_BSLASHequiv] = ACTIONS(4273),
    [anon_sym_u2261] = ACTIONS(4273),
    [anon_sym_LT_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27fa] = ACTIONS(4273),
    [anon_sym_u21d4] = ACTIONS(4273),
    [anon_sym_TILDE_GT] = ACTIONS(4273),
    [anon_sym_u21dd] = ACTIONS(4273),
    [anon_sym_u219d] = ACTIONS(4273),
    [anon_sym_BSLASHland] = ACTIONS(4273),
    [anon_sym_BSLASHlor] = ACTIONS(4273),
    [anon_sym_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2254] = ACTIONS(4273),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2a74] = ACTIONS(4273),
    [anon_sym_SLASH_EQ] = ACTIONS(4273),
    [anon_sym_POUND] = ACTIONS(4271),
    [anon_sym_u2260] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4271),
    [sym_gt] = ACTIONS(4271),
    [anon_sym_LT_EQ] = ACTIONS(4271),
    [anon_sym_EQ_LT] = ACTIONS(4273),
    [anon_sym_BSLASHleq] = ACTIONS(4273),
    [anon_sym_u2264] = ACTIONS(4273),
    [anon_sym_GT_EQ] = ACTIONS(4273),
    [anon_sym_BSLASHgeq] = ACTIONS(4273),
    [anon_sym_u2265] = ACTIONS(4273),
    [anon_sym_BSLASHapprox] = ACTIONS(4273),
    [anon_sym_u2248] = ACTIONS(4273),
    [anon_sym_PIPE_DASH] = ACTIONS(4273),
    [anon_sym_u22a2] = ACTIONS(4273),
    [anon_sym_PIPE_EQ] = ACTIONS(4273),
    [anon_sym_u22a8] = ACTIONS(4273),
    [anon_sym_DASH_PIPE] = ACTIONS(4273),
    [anon_sym_u22a3] = ACTIONS(4273),
    [anon_sym_EQ_PIPE] = ACTIONS(4273),
    [anon_sym_u2ae4] = ACTIONS(4273),
    [anon_sym_BSLASHasymp] = ACTIONS(4273),
    [anon_sym_u224d] = ACTIONS(4273),
    [anon_sym_BSLASHcong] = ACTIONS(4273),
    [anon_sym_u2245] = ACTIONS(4273),
    [anon_sym_BSLASHdoteq] = ACTIONS(4273),
    [anon_sym_u2250] = ACTIONS(4273),
    [anon_sym_BSLASHgg] = ACTIONS(4273),
    [anon_sym_u226b] = ACTIONS(4273),
    [anon_sym_BSLASHll] = ACTIONS(4273),
    [anon_sym_u226a] = ACTIONS(4273),
    [anon_sym_BSLASHnotin] = ACTIONS(4273),
    [anon_sym_u2209] = ACTIONS(4273),
    [anon_sym_BSLASHprec] = ACTIONS(4271),
    [anon_sym_u227a] = ACTIONS(4273),
    [anon_sym_BSLASHsucc] = ACTIONS(4271),
    [anon_sym_u227b] = ACTIONS(4273),
    [anon_sym_BSLASHpreceq] = ACTIONS(4273),
    [anon_sym_u2aaf] = ACTIONS(4273),
    [anon_sym_BSLASHsucceq] = ACTIONS(4273),
    [anon_sym_u2ab0] = ACTIONS(4273),
    [anon_sym_BSLASHpropto] = ACTIONS(4273),
    [anon_sym_u221d] = ACTIONS(4273),
    [anon_sym_BSLASHsim] = ACTIONS(4271),
    [anon_sym_u223c] = ACTIONS(4273),
    [anon_sym_BSLASHsimeq] = ACTIONS(4273),
    [anon_sym_u2243] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4271),
    [anon_sym_u228f] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4271),
    [anon_sym_u2290] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4273),
    [anon_sym_u2291] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4273),
    [anon_sym_u2292] = ACTIONS(4273),
    [anon_sym_BSLASHsubset] = ACTIONS(4271),
    [anon_sym_u2282] = ACTIONS(4273),
    [anon_sym_BSLASHsupset] = ACTIONS(4271),
    [anon_sym_u2283] = ACTIONS(4273),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4273),
    [anon_sym_u2286] = ACTIONS(4273),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4273),
    [anon_sym_u2287] = ACTIONS(4273),
    [sym_compose] = ACTIONS(4273),
    [sym_map_to] = ACTIONS(4273),
    [sym_map_from] = ACTIONS(4273),
    [sym_setminus] = ACTIONS(4271),
    [anon_sym_BSLASHcap] = ACTIONS(4273),
    [anon_sym_BSLASHintersect] = ACTIONS(4273),
    [anon_sym_u2229] = ACTIONS(4273),
    [anon_sym_BSLASHcup] = ACTIONS(4273),
    [anon_sym_BSLASHunion] = ACTIONS(4273),
    [anon_sym_u222a] = ACTIONS(4273),
    [anon_sym_DOT_DOT] = ACTIONS(4271),
    [anon_sym_u2025] = ACTIONS(4273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4273),
    [anon_sym_u2026] = ACTIONS(4273),
    [anon_sym_PLUS] = ACTIONS(4271),
    [sym_plusplus] = ACTIONS(4273),
    [anon_sym_BSLASHoplus] = ACTIONS(4273),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4273),
    [anon_sym_u2295] = ACTIONS(4273),
    [anon_sym_BSLASHominus] = ACTIONS(4273),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2296] = ACTIONS(4273),
    [sym_mod] = ACTIONS(4271),
    [sym_modmod] = ACTIONS(4273),
    [sym_vert] = ACTIONS(4271),
    [anon_sym_PIPE_PIPE] = ACTIONS(4273),
    [anon_sym_u2016] = ACTIONS(4273),
    [sym_minusminus] = ACTIONS(4273),
    [sym_amp] = ACTIONS(4271),
    [sym_ampamp] = ACTIONS(4273),
    [anon_sym_BSLASHodot] = ACTIONS(4273),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4273),
    [anon_sym_u2299] = ACTIONS(4273),
    [anon_sym_BSLASHoslash] = ACTIONS(4273),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2298] = ACTIONS(4273),
    [anon_sym_BSLASHotimes] = ACTIONS(4273),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4273),
    [anon_sym_u2297] = ACTIONS(4273),
    [sym_mul] = ACTIONS(4271),
    [sym_mulmul] = ACTIONS(4273),
    [sym_slash] = ACTIONS(4271),
    [sym_slashslash] = ACTIONS(4273),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4273),
    [anon_sym_u25ef] = ACTIONS(4273),
    [anon_sym_BSLASHbullet] = ACTIONS(4273),
    [anon_sym_u25cf] = ACTIONS(4273),
    [anon_sym_BSLASHdiv] = ACTIONS(4273),
    [anon_sym_u00f7] = ACTIONS(4273),
    [anon_sym_BSLASHcirc] = ACTIONS(4273),
    [anon_sym_u2218] = ACTIONS(4273),
    [anon_sym_BSLASHstar] = ACTIONS(4273),
    [anon_sym_u22c6] = ACTIONS(4273),
    [anon_sym_u203c] = ACTIONS(4273),
    [sym_hashhash] = ACTIONS(4273),
    [sym_dol] = ACTIONS(4271),
    [sym_doldol] = ACTIONS(4273),
    [anon_sym_QMARK_QMARK] = ACTIONS(4273),
    [anon_sym_u2047] = ACTIONS(4273),
    [anon_sym_BSLASHsqcap] = ACTIONS(4273),
    [anon_sym_u2293] = ACTIONS(4273),
    [anon_sym_BSLASHsqcup] = ACTIONS(4273),
    [anon_sym_u2294] = ACTIONS(4273),
    [anon_sym_BSLASHuplus] = ACTIONS(4273),
    [anon_sym_u228e] = ACTIONS(4273),
    [anon_sym_BSLASHX] = ACTIONS(4273),
    [anon_sym_BSLASHtimes] = ACTIONS(4273),
    [anon_sym_u00d7] = ACTIONS(4273),
    [anon_sym_BSLASHwr] = ACTIONS(4273),
    [anon_sym_u2240] = ACTIONS(4273),
    [anon_sym_BSLASHcdot] = ACTIONS(4273),
    [anon_sym_u22c5] = ACTIONS(4273),
    [sym_pow] = ACTIONS(4271),
    [sym_powpow] = ACTIONS(4273),
    [anon_sym_CARET_PLUS] = ACTIONS(4273),
    [anon_sym_u207a] = ACTIONS(4273),
    [sym_asterisk] = ACTIONS(4273),
    [sym_sup_hash] = ACTIONS(4273),
    [sym_prime] = ACTIONS(4273),
    [anon_sym_end] = ACTIONS(4278),
    [sym__indent] = ACTIONS(4273),
    [sym__double_excl] = ACTIONS(4273),
  },
  [2124] = {
    [sym_block_comment] = STATE(2124),
    [sym_identifier] = ACTIONS(4266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4271),
    [anon_sym_u2208] = ACTIONS(4273),
    [anon_sym_BSLASHA] = ACTIONS(4271),
    [anon_sym_BSLASHforall] = ACTIONS(4273),
    [anon_sym_u2200] = ACTIONS(4273),
    [anon_sym_BSLASHE] = ACTIONS(4271),
    [anon_sym_BSLASHexists] = ACTIONS(4273),
    [anon_sym_u2203] = ACTIONS(4273),
    [sym_temporal_forall] = ACTIONS(4273),
    [sym_temporal_exists] = ACTIONS(4273),
    [anon_sym_LT_LT] = ACTIONS(4273),
    [anon_sym_u3008] = ACTIONS(4273),
    [anon_sym_u27e8] = ACTIONS(4273),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4275),
    [anon_sym_u25a1] = ACTIONS(4275),
    [anon_sym_AT] = ACTIONS(4271),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4273),
    [anon_sym_u2227] = ACTIONS(4273),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4273),
    [anon_sym_u2228] = ACTIONS(4273),
    [anon_sym_COMMA] = ACTIONS(4269),
    [anon_sym_RECURSIVE] = ACTIONS(4278),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [anon_sym_LBRACK] = ACTIONS(4271),
    [anon_sym_BANG] = ACTIONS(4269),
    [aux_sym_child_id_token1] = ACTIONS(4271),
    [sym_real_number] = ACTIONS(4273),
    [anon_sym_BSLASHb] = ACTIONS(4271),
    [anon_sym_BSLASHB] = ACTIONS(4273),
    [anon_sym_BSLASHo] = ACTIONS(4271),
    [anon_sym_BSLASHO] = ACTIONS(4273),
    [anon_sym_BSLASHh] = ACTIONS(4273),
    [anon_sym_BSLASHH] = ACTIONS(4273),
    [anon_sym_DQUOTE] = ACTIONS(4273),
    [anon_sym_TRUE] = ACTIONS(4271),
    [anon_sym_FALSE] = ACTIONS(4271),
    [sym_string_set] = ACTIONS(4271),
    [sym_boolean_set] = ACTIONS(4271),
    [anon_sym_Nat] = ACTIONS(4266),
    [anon_sym_u2115] = ACTIONS(4275),
    [anon_sym_Int] = ACTIONS(4266),
    [anon_sym_u2124] = ACTIONS(4275),
    [anon_sym_Real] = ACTIONS(4266),
    [anon_sym_u211d] = ACTIONS(4275),
    [anon_sym_CHOOSE] = ACTIONS(4271),
    [anon_sym_LBRACE] = ACTIONS(4273),
    [anon_sym_EQ] = ACTIONS(4271),
    [anon_sym_WF_] = ACTIONS(4271),
    [anon_sym_SF_] = ACTIONS(4271),
    [anon_sym_IF] = ACTIONS(4271),
    [anon_sym_CASE] = ACTIONS(4271),
    [anon_sym_LET] = ACTIONS(4271),
    [anon_sym_IN] = ACTIONS(4278),
    [anon_sym_BSLASHlnot] = ACTIONS(4275),
    [anon_sym_BSLASHneg] = ACTIONS(4275),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_u00ac] = ACTIONS(4275),
    [sym_union] = ACTIONS(4266),
    [sym_powerset] = ACTIONS(4266),
    [sym_domain] = ACTIONS(4266),
    [anon_sym_DASH] = ACTIONS(4271),
    [sym_negative_dot] = ACTIONS(4275),
    [sym_enabled] = ACTIONS(4266),
    [sym_unchanged] = ACTIONS(4266),
    [anon_sym_LT_GT] = ACTIONS(4275),
    [anon_sym_u22c4] = ACTIONS(4275),
    [anon_sym_u25c7] = ACTIONS(4275),
    [anon_sym_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27f9] = ACTIONS(4273),
    [anon_sym_u21d2] = ACTIONS(4273),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4273),
    [anon_sym_u21f8] = ACTIONS(4273),
    [anon_sym_u2945] = ACTIONS(4273),
    [anon_sym_BSLASHequiv] = ACTIONS(4273),
    [anon_sym_u2261] = ACTIONS(4273),
    [anon_sym_LT_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27fa] = ACTIONS(4273),
    [anon_sym_u21d4] = ACTIONS(4273),
    [anon_sym_TILDE_GT] = ACTIONS(4273),
    [anon_sym_u21dd] = ACTIONS(4273),
    [anon_sym_u219d] = ACTIONS(4273),
    [anon_sym_BSLASHland] = ACTIONS(4273),
    [anon_sym_BSLASHlor] = ACTIONS(4273),
    [anon_sym_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2254] = ACTIONS(4273),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2a74] = ACTIONS(4273),
    [anon_sym_SLASH_EQ] = ACTIONS(4273),
    [anon_sym_POUND] = ACTIONS(4271),
    [anon_sym_u2260] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4271),
    [sym_gt] = ACTIONS(4271),
    [anon_sym_LT_EQ] = ACTIONS(4271),
    [anon_sym_EQ_LT] = ACTIONS(4273),
    [anon_sym_BSLASHleq] = ACTIONS(4273),
    [anon_sym_u2264] = ACTIONS(4273),
    [anon_sym_GT_EQ] = ACTIONS(4273),
    [anon_sym_BSLASHgeq] = ACTIONS(4273),
    [anon_sym_u2265] = ACTIONS(4273),
    [anon_sym_BSLASHapprox] = ACTIONS(4273),
    [anon_sym_u2248] = ACTIONS(4273),
    [anon_sym_PIPE_DASH] = ACTIONS(4273),
    [anon_sym_u22a2] = ACTIONS(4273),
    [anon_sym_PIPE_EQ] = ACTIONS(4273),
    [anon_sym_u22a8] = ACTIONS(4273),
    [anon_sym_DASH_PIPE] = ACTIONS(4273),
    [anon_sym_u22a3] = ACTIONS(4273),
    [anon_sym_EQ_PIPE] = ACTIONS(4273),
    [anon_sym_u2ae4] = ACTIONS(4273),
    [anon_sym_BSLASHasymp] = ACTIONS(4273),
    [anon_sym_u224d] = ACTIONS(4273),
    [anon_sym_BSLASHcong] = ACTIONS(4273),
    [anon_sym_u2245] = ACTIONS(4273),
    [anon_sym_BSLASHdoteq] = ACTIONS(4273),
    [anon_sym_u2250] = ACTIONS(4273),
    [anon_sym_BSLASHgg] = ACTIONS(4273),
    [anon_sym_u226b] = ACTIONS(4273),
    [anon_sym_BSLASHll] = ACTIONS(4273),
    [anon_sym_u226a] = ACTIONS(4273),
    [anon_sym_BSLASHnotin] = ACTIONS(4273),
    [anon_sym_u2209] = ACTIONS(4273),
    [anon_sym_BSLASHprec] = ACTIONS(4271),
    [anon_sym_u227a] = ACTIONS(4273),
    [anon_sym_BSLASHsucc] = ACTIONS(4271),
    [anon_sym_u227b] = ACTIONS(4273),
    [anon_sym_BSLASHpreceq] = ACTIONS(4273),
    [anon_sym_u2aaf] = ACTIONS(4273),
    [anon_sym_BSLASHsucceq] = ACTIONS(4273),
    [anon_sym_u2ab0] = ACTIONS(4273),
    [anon_sym_BSLASHpropto] = ACTIONS(4273),
    [anon_sym_u221d] = ACTIONS(4273),
    [anon_sym_BSLASHsim] = ACTIONS(4271),
    [anon_sym_u223c] = ACTIONS(4273),
    [anon_sym_BSLASHsimeq] = ACTIONS(4273),
    [anon_sym_u2243] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4271),
    [anon_sym_u228f] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4271),
    [anon_sym_u2290] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4273),
    [anon_sym_u2291] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4273),
    [anon_sym_u2292] = ACTIONS(4273),
    [anon_sym_BSLASHsubset] = ACTIONS(4271),
    [anon_sym_u2282] = ACTIONS(4273),
    [anon_sym_BSLASHsupset] = ACTIONS(4271),
    [anon_sym_u2283] = ACTIONS(4273),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4273),
    [anon_sym_u2286] = ACTIONS(4273),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4273),
    [anon_sym_u2287] = ACTIONS(4273),
    [sym_compose] = ACTIONS(4273),
    [sym_map_to] = ACTIONS(4273),
    [sym_map_from] = ACTIONS(4273),
    [sym_setminus] = ACTIONS(4271),
    [anon_sym_BSLASHcap] = ACTIONS(4273),
    [anon_sym_BSLASHintersect] = ACTIONS(4273),
    [anon_sym_u2229] = ACTIONS(4273),
    [anon_sym_BSLASHcup] = ACTIONS(4273),
    [anon_sym_BSLASHunion] = ACTIONS(4273),
    [anon_sym_u222a] = ACTIONS(4273),
    [anon_sym_DOT_DOT] = ACTIONS(4271),
    [anon_sym_u2025] = ACTIONS(4273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4273),
    [anon_sym_u2026] = ACTIONS(4273),
    [anon_sym_PLUS] = ACTIONS(4271),
    [sym_plusplus] = ACTIONS(4273),
    [anon_sym_BSLASHoplus] = ACTIONS(4273),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4273),
    [anon_sym_u2295] = ACTIONS(4273),
    [anon_sym_BSLASHominus] = ACTIONS(4273),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2296] = ACTIONS(4273),
    [sym_mod] = ACTIONS(4271),
    [sym_modmod] = ACTIONS(4273),
    [sym_vert] = ACTIONS(4271),
    [anon_sym_PIPE_PIPE] = ACTIONS(4273),
    [anon_sym_u2016] = ACTIONS(4273),
    [sym_minusminus] = ACTIONS(4273),
    [sym_amp] = ACTIONS(4271),
    [sym_ampamp] = ACTIONS(4273),
    [anon_sym_BSLASHodot] = ACTIONS(4273),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4273),
    [anon_sym_u2299] = ACTIONS(4273),
    [anon_sym_BSLASHoslash] = ACTIONS(4273),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2298] = ACTIONS(4273),
    [anon_sym_BSLASHotimes] = ACTIONS(4273),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4273),
    [anon_sym_u2297] = ACTIONS(4273),
    [sym_mul] = ACTIONS(4271),
    [sym_mulmul] = ACTIONS(4273),
    [sym_slash] = ACTIONS(4271),
    [sym_slashslash] = ACTIONS(4273),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4273),
    [anon_sym_u25ef] = ACTIONS(4273),
    [anon_sym_BSLASHbullet] = ACTIONS(4273),
    [anon_sym_u25cf] = ACTIONS(4273),
    [anon_sym_BSLASHdiv] = ACTIONS(4273),
    [anon_sym_u00f7] = ACTIONS(4273),
    [anon_sym_BSLASHcirc] = ACTIONS(4273),
    [anon_sym_u2218] = ACTIONS(4273),
    [anon_sym_BSLASHstar] = ACTIONS(4273),
    [anon_sym_u22c6] = ACTIONS(4273),
    [anon_sym_u203c] = ACTIONS(4273),
    [sym_hashhash] = ACTIONS(4273),
    [sym_dol] = ACTIONS(4271),
    [sym_doldol] = ACTIONS(4273),
    [anon_sym_QMARK_QMARK] = ACTIONS(4273),
    [anon_sym_u2047] = ACTIONS(4273),
    [anon_sym_BSLASHsqcap] = ACTIONS(4273),
    [anon_sym_u2293] = ACTIONS(4273),
    [anon_sym_BSLASHsqcup] = ACTIONS(4273),
    [anon_sym_u2294] = ACTIONS(4273),
    [anon_sym_BSLASHuplus] = ACTIONS(4273),
    [anon_sym_u228e] = ACTIONS(4273),
    [anon_sym_BSLASHX] = ACTIONS(4273),
    [anon_sym_BSLASHtimes] = ACTIONS(4273),
    [anon_sym_u00d7] = ACTIONS(4273),
    [anon_sym_BSLASHwr] = ACTIONS(4273),
    [anon_sym_u2240] = ACTIONS(4273),
    [anon_sym_BSLASHcdot] = ACTIONS(4273),
    [anon_sym_u22c5] = ACTIONS(4273),
    [sym_pow] = ACTIONS(4271),
    [sym_powpow] = ACTIONS(4273),
    [anon_sym_CARET_PLUS] = ACTIONS(4273),
    [anon_sym_u207a] = ACTIONS(4273),
    [sym_asterisk] = ACTIONS(4273),
    [sym_sup_hash] = ACTIONS(4273),
    [sym_prime] = ACTIONS(4273),
    [sym__indent] = ACTIONS(4273),
    [sym__double_excl] = ACTIONS(4273),
  },
  [2125] = {
    [sym_block_comment] = STATE(2125),
    [sym_identifier] = ACTIONS(4290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4290),
    [anon_sym_u2208] = ACTIONS(4288),
    [anon_sym_BSLASHA] = ACTIONS(4290),
    [anon_sym_BSLASHforall] = ACTIONS(4288),
    [anon_sym_u2200] = ACTIONS(4288),
    [anon_sym_BSLASHE] = ACTIONS(4290),
    [anon_sym_BSLASHexists] = ACTIONS(4288),
    [anon_sym_u2203] = ACTIONS(4288),
    [sym_temporal_forall] = ACTIONS(4288),
    [sym_temporal_exists] = ACTIONS(4288),
    [anon_sym_LT_LT] = ACTIONS(4288),
    [anon_sym_u3008] = ACTIONS(4288),
    [anon_sym_u27e8] = ACTIONS(4288),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4288),
    [anon_sym_u25a1] = ACTIONS(4288),
    [anon_sym_AT] = ACTIONS(4290),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4288),
    [anon_sym_u2227] = ACTIONS(4288),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4288),
    [anon_sym_u2228] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_RECURSIVE] = ACTIONS(4290),
    [anon_sym_LPAREN] = ACTIONS(4290),
    [anon_sym_LBRACK] = ACTIONS(4290),
    [anon_sym_BANG] = ACTIONS(4288),
    [aux_sym_child_id_token1] = ACTIONS(4290),
    [sym_real_number] = ACTIONS(4288),
    [anon_sym_BSLASHb] = ACTIONS(4290),
    [anon_sym_BSLASHB] = ACTIONS(4288),
    [anon_sym_BSLASHo] = ACTIONS(4290),
    [anon_sym_BSLASHO] = ACTIONS(4288),
    [anon_sym_BSLASHh] = ACTIONS(4288),
    [anon_sym_BSLASHH] = ACTIONS(4288),
    [anon_sym_DQUOTE] = ACTIONS(4288),
    [anon_sym_TRUE] = ACTIONS(4290),
    [anon_sym_FALSE] = ACTIONS(4290),
    [sym_string_set] = ACTIONS(4290),
    [sym_boolean_set] = ACTIONS(4290),
    [anon_sym_Nat] = ACTIONS(4290),
    [anon_sym_u2115] = ACTIONS(4288),
    [anon_sym_Int] = ACTIONS(4290),
    [anon_sym_u2124] = ACTIONS(4288),
    [anon_sym_Real] = ACTIONS(4290),
    [anon_sym_u211d] = ACTIONS(4288),
    [anon_sym_CHOOSE] = ACTIONS(4290),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_WF_] = ACTIONS(4290),
    [anon_sym_SF_] = ACTIONS(4290),
    [anon_sym_IF] = ACTIONS(4290),
    [anon_sym_CASE] = ACTIONS(4290),
    [anon_sym_LET] = ACTIONS(4290),
    [anon_sym_IN] = ACTIONS(4290),
    [anon_sym_BSLASHlnot] = ACTIONS(4288),
    [anon_sym_BSLASHneg] = ACTIONS(4288),
    [anon_sym_TILDE] = ACTIONS(4290),
    [anon_sym_u00ac] = ACTIONS(4288),
    [sym_union] = ACTIONS(4290),
    [sym_powerset] = ACTIONS(4290),
    [sym_domain] = ACTIONS(4290),
    [anon_sym_DASH] = ACTIONS(4290),
    [sym_negative_dot] = ACTIONS(4288),
    [sym_enabled] = ACTIONS(4290),
    [sym_unchanged] = ACTIONS(4290),
    [anon_sym_LT_GT] = ACTIONS(4288),
    [anon_sym_u22c4] = ACTIONS(4288),
    [anon_sym_u25c7] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_u27f9] = ACTIONS(4288),
    [anon_sym_u21d2] = ACTIONS(4288),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4288),
    [anon_sym_u21f8] = ACTIONS(4288),
    [anon_sym_u2945] = ACTIONS(4288),
    [anon_sym_BSLASHequiv] = ACTIONS(4288),
    [anon_sym_u2261] = ACTIONS(4288),
    [anon_sym_LT_EQ_GT] = ACTIONS(4288),
    [anon_sym_u27fa] = ACTIONS(4288),
    [anon_sym_u21d4] = ACTIONS(4288),
    [anon_sym_TILDE_GT] = ACTIONS(4288),
    [anon_sym_u21dd] = ACTIONS(4288),
    [anon_sym_u219d] = ACTIONS(4288),
    [anon_sym_BSLASHland] = ACTIONS(4288),
    [anon_sym_BSLASHlor] = ACTIONS(4288),
    [anon_sym_COLON_EQ] = ACTIONS(4288),
    [anon_sym_u2254] = ACTIONS(4288),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4288),
    [anon_sym_u2a74] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_POUND] = ACTIONS(4290),
    [anon_sym_u2260] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4290),
    [sym_gt] = ACTIONS(4290),
    [anon_sym_LT_EQ] = ACTIONS(4290),
    [anon_sym_EQ_LT] = ACTIONS(4288),
    [anon_sym_BSLASHleq] = ACTIONS(4288),
    [anon_sym_u2264] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(4288),
    [anon_sym_BSLASHgeq] = ACTIONS(4288),
    [anon_sym_u2265] = ACTIONS(4288),
    [anon_sym_BSLASHapprox] = ACTIONS(4288),
    [anon_sym_u2248] = ACTIONS(4288),
    [anon_sym_PIPE_DASH] = ACTIONS(4288),
    [anon_sym_u22a2] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_u22a8] = ACTIONS(4288),
    [anon_sym_DASH_PIPE] = ACTIONS(4288),
    [anon_sym_u22a3] = ACTIONS(4288),
    [anon_sym_EQ_PIPE] = ACTIONS(4288),
    [anon_sym_u2ae4] = ACTIONS(4288),
    [anon_sym_BSLASHasymp] = ACTIONS(4288),
    [anon_sym_u224d] = ACTIONS(4288),
    [anon_sym_BSLASHcong] = ACTIONS(4288),
    [anon_sym_u2245] = ACTIONS(4288),
    [anon_sym_BSLASHdoteq] = ACTIONS(4288),
    [anon_sym_u2250] = ACTIONS(4288),
    [anon_sym_BSLASHgg] = ACTIONS(4288),
    [anon_sym_u226b] = ACTIONS(4288),
    [anon_sym_BSLASHll] = ACTIONS(4288),
    [anon_sym_u226a] = ACTIONS(4288),
    [anon_sym_BSLASHnotin] = ACTIONS(4288),
    [anon_sym_u2209] = ACTIONS(4288),
    [anon_sym_BSLASHprec] = ACTIONS(4290),
    [anon_sym_u227a] = ACTIONS(4288),
    [anon_sym_BSLASHsucc] = ACTIONS(4290),
    [anon_sym_u227b] = ACTIONS(4288),
    [anon_sym_BSLASHpreceq] = ACTIONS(4288),
    [anon_sym_u2aaf] = ACTIONS(4288),
    [anon_sym_BSLASHsucceq] = ACTIONS(4288),
    [anon_sym_u2ab0] = ACTIONS(4288),
    [anon_sym_BSLASHpropto] = ACTIONS(4288),
    [anon_sym_u221d] = ACTIONS(4288),
    [anon_sym_BSLASHsim] = ACTIONS(4290),
    [anon_sym_u223c] = ACTIONS(4288),
    [anon_sym_BSLASHsimeq] = ACTIONS(4288),
    [anon_sym_u2243] = ACTIONS(4288),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4290),
    [anon_sym_u228f] = ACTIONS(4288),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4290),
    [anon_sym_u2290] = ACTIONS(4288),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4288),
    [anon_sym_u2291] = ACTIONS(4288),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4288),
    [anon_sym_u2292] = ACTIONS(4288),
    [anon_sym_BSLASHsubset] = ACTIONS(4290),
    [anon_sym_u2282] = ACTIONS(4288),
    [anon_sym_BSLASHsupset] = ACTIONS(4290),
    [anon_sym_u2283] = ACTIONS(4288),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4288),
    [anon_sym_u2286] = ACTIONS(4288),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4288),
    [anon_sym_u2287] = ACTIONS(4288),
    [sym_compose] = ACTIONS(4288),
    [sym_map_to] = ACTIONS(4288),
    [sym_map_from] = ACTIONS(4288),
    [sym_setminus] = ACTIONS(4290),
    [anon_sym_BSLASHcap] = ACTIONS(4288),
    [anon_sym_BSLASHintersect] = ACTIONS(4288),
    [anon_sym_u2229] = ACTIONS(4288),
    [anon_sym_BSLASHcup] = ACTIONS(4288),
    [anon_sym_BSLASHunion] = ACTIONS(4288),
    [anon_sym_u222a] = ACTIONS(4288),
    [anon_sym_DOT_DOT] = ACTIONS(4290),
    [anon_sym_u2025] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4288),
    [anon_sym_u2026] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(4290),
    [sym_plusplus] = ACTIONS(4288),
    [anon_sym_BSLASHoplus] = ACTIONS(4288),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4288),
    [anon_sym_u2295] = ACTIONS(4288),
    [anon_sym_BSLASHominus] = ACTIONS(4288),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4288),
    [anon_sym_u2296] = ACTIONS(4288),
    [sym_mod] = ACTIONS(4290),
    [sym_modmod] = ACTIONS(4288),
    [sym_vert] = ACTIONS(4290),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_u2016] = ACTIONS(4288),
    [sym_minusminus] = ACTIONS(4288),
    [sym_amp] = ACTIONS(4290),
    [sym_ampamp] = ACTIONS(4288),
    [anon_sym_BSLASHodot] = ACTIONS(4288),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4288),
    [anon_sym_u2299] = ACTIONS(4288),
    [anon_sym_BSLASHoslash] = ACTIONS(4288),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4288),
    [anon_sym_u2298] = ACTIONS(4288),
    [anon_sym_BSLASHotimes] = ACTIONS(4288),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4288),
    [anon_sym_u2297] = ACTIONS(4288),
    [sym_mul] = ACTIONS(4290),
    [sym_mulmul] = ACTIONS(4288),
    [sym_slash] = ACTIONS(4290),
    [sym_slashslash] = ACTIONS(4288),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4288),
    [anon_sym_u25ef] = ACTIONS(4288),
    [anon_sym_BSLASHbullet] = ACTIONS(4288),
    [anon_sym_u25cf] = ACTIONS(4288),
    [anon_sym_BSLASHdiv] = ACTIONS(4288),
    [anon_sym_u00f7] = ACTIONS(4288),
    [anon_sym_BSLASHcirc] = ACTIONS(4288),
    [anon_sym_u2218] = ACTIONS(4288),
    [anon_sym_BSLASHstar] = ACTIONS(4288),
    [anon_sym_u22c6] = ACTIONS(4288),
    [anon_sym_u203c] = ACTIONS(4288),
    [sym_hashhash] = ACTIONS(4288),
    [sym_dol] = ACTIONS(4290),
    [sym_doldol] = ACTIONS(4288),
    [anon_sym_QMARK_QMARK] = ACTIONS(4288),
    [anon_sym_u2047] = ACTIONS(4288),
    [anon_sym_BSLASHsqcap] = ACTIONS(4288),
    [anon_sym_u2293] = ACTIONS(4288),
    [anon_sym_BSLASHsqcup] = ACTIONS(4288),
    [anon_sym_u2294] = ACTIONS(4288),
    [anon_sym_BSLASHuplus] = ACTIONS(4288),
    [anon_sym_u228e] = ACTIONS(4288),
    [anon_sym_BSLASHX] = ACTIONS(4288),
    [anon_sym_BSLASHtimes] = ACTIONS(4288),
    [anon_sym_u00d7] = ACTIONS(4288),
    [anon_sym_BSLASHwr] = ACTIONS(4288),
    [anon_sym_u2240] = ACTIONS(4288),
    [anon_sym_BSLASHcdot] = ACTIONS(4288),
    [anon_sym_u22c5] = ACTIONS(4288),
    [sym_pow] = ACTIONS(4290),
    [sym_powpow] = ACTIONS(4288),
    [anon_sym_CARET_PLUS] = ACTIONS(4288),
    [anon_sym_u207a] = ACTIONS(4288),
    [sym_asterisk] = ACTIONS(4288),
    [sym_sup_hash] = ACTIONS(4288),
    [sym_prime] = ACTIONS(4288),
    [sym__indent] = ACTIONS(4288),
    [sym__double_excl] = ACTIONS(4288),
  },
  [2126] = {
    [sym_block_comment] = STATE(2126),
    [sym_identifier] = ACTIONS(4282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4282),
    [anon_sym_u2208] = ACTIONS(4280),
    [anon_sym_BSLASHA] = ACTIONS(4282),
    [anon_sym_BSLASHforall] = ACTIONS(4280),
    [anon_sym_u2200] = ACTIONS(4280),
    [anon_sym_BSLASHE] = ACTIONS(4282),
    [anon_sym_BSLASHexists] = ACTIONS(4280),
    [anon_sym_u2203] = ACTIONS(4280),
    [sym_temporal_forall] = ACTIONS(4280),
    [sym_temporal_exists] = ACTIONS(4280),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_u3008] = ACTIONS(4280),
    [anon_sym_u27e8] = ACTIONS(4280),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4280),
    [anon_sym_u25a1] = ACTIONS(4280),
    [anon_sym_AT] = ACTIONS(4282),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4280),
    [anon_sym_u2227] = ACTIONS(4280),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4280),
    [anon_sym_u2228] = ACTIONS(4280),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_RECURSIVE] = ACTIONS(4282),
    [anon_sym_LPAREN] = ACTIONS(4282),
    [anon_sym_LBRACK] = ACTIONS(4282),
    [anon_sym_BANG] = ACTIONS(4280),
    [aux_sym_child_id_token1] = ACTIONS(4282),
    [sym_real_number] = ACTIONS(4280),
    [anon_sym_BSLASHb] = ACTIONS(4282),
    [anon_sym_BSLASHB] = ACTIONS(4280),
    [anon_sym_BSLASHo] = ACTIONS(4282),
    [anon_sym_BSLASHO] = ACTIONS(4280),
    [anon_sym_BSLASHh] = ACTIONS(4280),
    [anon_sym_BSLASHH] = ACTIONS(4280),
    [anon_sym_DQUOTE] = ACTIONS(4280),
    [anon_sym_TRUE] = ACTIONS(4282),
    [anon_sym_FALSE] = ACTIONS(4282),
    [sym_string_set] = ACTIONS(4282),
    [sym_boolean_set] = ACTIONS(4282),
    [anon_sym_Nat] = ACTIONS(4282),
    [anon_sym_u2115] = ACTIONS(4280),
    [anon_sym_Int] = ACTIONS(4282),
    [anon_sym_u2124] = ACTIONS(4280),
    [anon_sym_Real] = ACTIONS(4282),
    [anon_sym_u211d] = ACTIONS(4280),
    [anon_sym_CHOOSE] = ACTIONS(4282),
    [anon_sym_LBRACE] = ACTIONS(4280),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_WF_] = ACTIONS(4282),
    [anon_sym_SF_] = ACTIONS(4282),
    [anon_sym_IF] = ACTIONS(4282),
    [anon_sym_CASE] = ACTIONS(4282),
    [anon_sym_LET] = ACTIONS(4282),
    [anon_sym_IN] = ACTIONS(4282),
    [anon_sym_BSLASHlnot] = ACTIONS(4280),
    [anon_sym_BSLASHneg] = ACTIONS(4280),
    [anon_sym_TILDE] = ACTIONS(4282),
    [anon_sym_u00ac] = ACTIONS(4280),
    [sym_union] = ACTIONS(4282),
    [sym_powerset] = ACTIONS(4282),
    [sym_domain] = ACTIONS(4282),
    [anon_sym_DASH] = ACTIONS(4282),
    [sym_negative_dot] = ACTIONS(4280),
    [sym_enabled] = ACTIONS(4282),
    [sym_unchanged] = ACTIONS(4282),
    [anon_sym_LT_GT] = ACTIONS(4280),
    [anon_sym_u22c4] = ACTIONS(4280),
    [anon_sym_u25c7] = ACTIONS(4280),
    [anon_sym_EQ_GT] = ACTIONS(4280),
    [anon_sym_u27f9] = ACTIONS(4280),
    [anon_sym_u21d2] = ACTIONS(4280),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4280),
    [anon_sym_u21f8] = ACTIONS(4280),
    [anon_sym_u2945] = ACTIONS(4280),
    [anon_sym_BSLASHequiv] = ACTIONS(4280),
    [anon_sym_u2261] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4280),
    [anon_sym_u27fa] = ACTIONS(4280),
    [anon_sym_u21d4] = ACTIONS(4280),
    [anon_sym_TILDE_GT] = ACTIONS(4280),
    [anon_sym_u21dd] = ACTIONS(4280),
    [anon_sym_u219d] = ACTIONS(4280),
    [anon_sym_BSLASHland] = ACTIONS(4280),
    [anon_sym_BSLASHlor] = ACTIONS(4280),
    [anon_sym_COLON_EQ] = ACTIONS(4280),
    [anon_sym_u2254] = ACTIONS(4280),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4280),
    [anon_sym_u2a74] = ACTIONS(4280),
    [anon_sym_SLASH_EQ] = ACTIONS(4280),
    [anon_sym_POUND] = ACTIONS(4282),
    [anon_sym_u2260] = ACTIONS(4280),
    [anon_sym_LT] = ACTIONS(4282),
    [sym_gt] = ACTIONS(4282),
    [anon_sym_LT_EQ] = ACTIONS(4282),
    [anon_sym_EQ_LT] = ACTIONS(4280),
    [anon_sym_BSLASHleq] = ACTIONS(4280),
    [anon_sym_u2264] = ACTIONS(4280),
    [anon_sym_GT_EQ] = ACTIONS(4280),
    [anon_sym_BSLASHgeq] = ACTIONS(4280),
    [anon_sym_u2265] = ACTIONS(4280),
    [anon_sym_BSLASHapprox] = ACTIONS(4280),
    [anon_sym_u2248] = ACTIONS(4280),
    [anon_sym_PIPE_DASH] = ACTIONS(4280),
    [anon_sym_u22a2] = ACTIONS(4280),
    [anon_sym_PIPE_EQ] = ACTIONS(4280),
    [anon_sym_u22a8] = ACTIONS(4280),
    [anon_sym_DASH_PIPE] = ACTIONS(4280),
    [anon_sym_u22a3] = ACTIONS(4280),
    [anon_sym_EQ_PIPE] = ACTIONS(4280),
    [anon_sym_u2ae4] = ACTIONS(4280),
    [anon_sym_BSLASHasymp] = ACTIONS(4280),
    [anon_sym_u224d] = ACTIONS(4280),
    [anon_sym_BSLASHcong] = ACTIONS(4280),
    [anon_sym_u2245] = ACTIONS(4280),
    [anon_sym_BSLASHdoteq] = ACTIONS(4280),
    [anon_sym_u2250] = ACTIONS(4280),
    [anon_sym_BSLASHgg] = ACTIONS(4280),
    [anon_sym_u226b] = ACTIONS(4280),
    [anon_sym_BSLASHll] = ACTIONS(4280),
    [anon_sym_u226a] = ACTIONS(4280),
    [anon_sym_BSLASHnotin] = ACTIONS(4280),
    [anon_sym_u2209] = ACTIONS(4280),
    [anon_sym_BSLASHprec] = ACTIONS(4282),
    [anon_sym_u227a] = ACTIONS(4280),
    [anon_sym_BSLASHsucc] = ACTIONS(4282),
    [anon_sym_u227b] = ACTIONS(4280),
    [anon_sym_BSLASHpreceq] = ACTIONS(4280),
    [anon_sym_u2aaf] = ACTIONS(4280),
    [anon_sym_BSLASHsucceq] = ACTIONS(4280),
    [anon_sym_u2ab0] = ACTIONS(4280),
    [anon_sym_BSLASHpropto] = ACTIONS(4280),
    [anon_sym_u221d] = ACTIONS(4280),
    [anon_sym_BSLASHsim] = ACTIONS(4282),
    [anon_sym_u223c] = ACTIONS(4280),
    [anon_sym_BSLASHsimeq] = ACTIONS(4280),
    [anon_sym_u2243] = ACTIONS(4280),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4282),
    [anon_sym_u228f] = ACTIONS(4280),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4282),
    [anon_sym_u2290] = ACTIONS(4280),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4280),
    [anon_sym_u2291] = ACTIONS(4280),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4280),
    [anon_sym_u2292] = ACTIONS(4280),
    [anon_sym_BSLASHsubset] = ACTIONS(4282),
    [anon_sym_u2282] = ACTIONS(4280),
    [anon_sym_BSLASHsupset] = ACTIONS(4282),
    [anon_sym_u2283] = ACTIONS(4280),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4280),
    [anon_sym_u2286] = ACTIONS(4280),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4280),
    [anon_sym_u2287] = ACTIONS(4280),
    [sym_compose] = ACTIONS(4280),
    [sym_map_to] = ACTIONS(4280),
    [sym_map_from] = ACTIONS(4280),
    [sym_setminus] = ACTIONS(4282),
    [anon_sym_BSLASHcap] = ACTIONS(4280),
    [anon_sym_BSLASHintersect] = ACTIONS(4280),
    [anon_sym_u2229] = ACTIONS(4280),
    [anon_sym_BSLASHcup] = ACTIONS(4280),
    [anon_sym_BSLASHunion] = ACTIONS(4280),
    [anon_sym_u222a] = ACTIONS(4280),
    [anon_sym_DOT_DOT] = ACTIONS(4282),
    [anon_sym_u2025] = ACTIONS(4280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4280),
    [anon_sym_u2026] = ACTIONS(4280),
    [anon_sym_PLUS] = ACTIONS(4282),
    [sym_plusplus] = ACTIONS(4280),
    [anon_sym_BSLASHoplus] = ACTIONS(4280),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4280),
    [anon_sym_u2295] = ACTIONS(4280),
    [anon_sym_BSLASHominus] = ACTIONS(4280),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4280),
    [anon_sym_u2296] = ACTIONS(4280),
    [sym_mod] = ACTIONS(4282),
    [sym_modmod] = ACTIONS(4280),
    [sym_vert] = ACTIONS(4282),
    [anon_sym_PIPE_PIPE] = ACTIONS(4280),
    [anon_sym_u2016] = ACTIONS(4280),
    [sym_minusminus] = ACTIONS(4280),
    [sym_amp] = ACTIONS(4282),
    [sym_ampamp] = ACTIONS(4280),
    [anon_sym_BSLASHodot] = ACTIONS(4280),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4280),
    [anon_sym_u2299] = ACTIONS(4280),
    [anon_sym_BSLASHoslash] = ACTIONS(4280),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4280),
    [anon_sym_u2298] = ACTIONS(4280),
    [anon_sym_BSLASHotimes] = ACTIONS(4280),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4280),
    [anon_sym_u2297] = ACTIONS(4280),
    [sym_mul] = ACTIONS(4282),
    [sym_mulmul] = ACTIONS(4280),
    [sym_slash] = ACTIONS(4282),
    [sym_slashslash] = ACTIONS(4280),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4280),
    [anon_sym_u25ef] = ACTIONS(4280),
    [anon_sym_BSLASHbullet] = ACTIONS(4280),
    [anon_sym_u25cf] = ACTIONS(4280),
    [anon_sym_BSLASHdiv] = ACTIONS(4280),
    [anon_sym_u00f7] = ACTIONS(4280),
    [anon_sym_BSLASHcirc] = ACTIONS(4280),
    [anon_sym_u2218] = ACTIONS(4280),
    [anon_sym_BSLASHstar] = ACTIONS(4280),
    [anon_sym_u22c6] = ACTIONS(4280),
    [anon_sym_u203c] = ACTIONS(4280),
    [sym_hashhash] = ACTIONS(4280),
    [sym_dol] = ACTIONS(4282),
    [sym_doldol] = ACTIONS(4280),
    [anon_sym_QMARK_QMARK] = ACTIONS(4280),
    [anon_sym_u2047] = ACTIONS(4280),
    [anon_sym_BSLASHsqcap] = ACTIONS(4280),
    [anon_sym_u2293] = ACTIONS(4280),
    [anon_sym_BSLASHsqcup] = ACTIONS(4280),
    [anon_sym_u2294] = ACTIONS(4280),
    [anon_sym_BSLASHuplus] = ACTIONS(4280),
    [anon_sym_u228e] = ACTIONS(4280),
    [anon_sym_BSLASHX] = ACTIONS(4280),
    [anon_sym_BSLASHtimes] = ACTIONS(4280),
    [anon_sym_u00d7] = ACTIONS(4280),
    [anon_sym_BSLASHwr] = ACTIONS(4280),
    [anon_sym_u2240] = ACTIONS(4280),
    [anon_sym_BSLASHcdot] = ACTIONS(4280),
    [anon_sym_u22c5] = ACTIONS(4280),
    [sym_pow] = ACTIONS(4282),
    [sym_powpow] = ACTIONS(4280),
    [anon_sym_CARET_PLUS] = ACTIONS(4280),
    [anon_sym_u207a] = ACTIONS(4280),
    [sym_asterisk] = ACTIONS(4280),
    [sym_sup_hash] = ACTIONS(4280),
    [sym_prime] = ACTIONS(4280),
    [sym__indent] = ACTIONS(4280),
    [sym__double_excl] = ACTIONS(4280),
  },
  [2127] = {
    [sym_block_comment] = STATE(2127),
    [sym_identifier] = ACTIONS(4286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4286),
    [anon_sym_u2208] = ACTIONS(4284),
    [anon_sym_BSLASHA] = ACTIONS(4286),
    [anon_sym_BSLASHforall] = ACTIONS(4284),
    [anon_sym_u2200] = ACTIONS(4284),
    [anon_sym_BSLASHE] = ACTIONS(4286),
    [anon_sym_BSLASHexists] = ACTIONS(4284),
    [anon_sym_u2203] = ACTIONS(4284),
    [sym_temporal_forall] = ACTIONS(4284),
    [sym_temporal_exists] = ACTIONS(4284),
    [anon_sym_LT_LT] = ACTIONS(4284),
    [anon_sym_u3008] = ACTIONS(4284),
    [anon_sym_u27e8] = ACTIONS(4284),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4284),
    [anon_sym_u25a1] = ACTIONS(4284),
    [anon_sym_AT] = ACTIONS(4286),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4284),
    [anon_sym_u2227] = ACTIONS(4284),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4284),
    [anon_sym_u2228] = ACTIONS(4284),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_RECURSIVE] = ACTIONS(4286),
    [anon_sym_LPAREN] = ACTIONS(4286),
    [anon_sym_LBRACK] = ACTIONS(4286),
    [anon_sym_BANG] = ACTIONS(4284),
    [aux_sym_child_id_token1] = ACTIONS(4286),
    [sym_real_number] = ACTIONS(4284),
    [anon_sym_BSLASHb] = ACTIONS(4286),
    [anon_sym_BSLASHB] = ACTIONS(4284),
    [anon_sym_BSLASHo] = ACTIONS(4286),
    [anon_sym_BSLASHO] = ACTIONS(4284),
    [anon_sym_BSLASHh] = ACTIONS(4284),
    [anon_sym_BSLASHH] = ACTIONS(4284),
    [anon_sym_DQUOTE] = ACTIONS(4284),
    [anon_sym_TRUE] = ACTIONS(4286),
    [anon_sym_FALSE] = ACTIONS(4286),
    [sym_string_set] = ACTIONS(4286),
    [sym_boolean_set] = ACTIONS(4286),
    [anon_sym_Nat] = ACTIONS(4286),
    [anon_sym_u2115] = ACTIONS(4284),
    [anon_sym_Int] = ACTIONS(4286),
    [anon_sym_u2124] = ACTIONS(4284),
    [anon_sym_Real] = ACTIONS(4286),
    [anon_sym_u211d] = ACTIONS(4284),
    [anon_sym_CHOOSE] = ACTIONS(4286),
    [anon_sym_LBRACE] = ACTIONS(4284),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_WF_] = ACTIONS(4286),
    [anon_sym_SF_] = ACTIONS(4286),
    [anon_sym_IF] = ACTIONS(4286),
    [anon_sym_CASE] = ACTIONS(4286),
    [anon_sym_LET] = ACTIONS(4286),
    [anon_sym_IN] = ACTIONS(4286),
    [anon_sym_BSLASHlnot] = ACTIONS(4284),
    [anon_sym_BSLASHneg] = ACTIONS(4284),
    [anon_sym_TILDE] = ACTIONS(4286),
    [anon_sym_u00ac] = ACTIONS(4284),
    [sym_union] = ACTIONS(4286),
    [sym_powerset] = ACTIONS(4286),
    [sym_domain] = ACTIONS(4286),
    [anon_sym_DASH] = ACTIONS(4286),
    [sym_negative_dot] = ACTIONS(4284),
    [sym_enabled] = ACTIONS(4286),
    [sym_unchanged] = ACTIONS(4286),
    [anon_sym_LT_GT] = ACTIONS(4284),
    [anon_sym_u22c4] = ACTIONS(4284),
    [anon_sym_u25c7] = ACTIONS(4284),
    [anon_sym_EQ_GT] = ACTIONS(4284),
    [anon_sym_u27f9] = ACTIONS(4284),
    [anon_sym_u21d2] = ACTIONS(4284),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4284),
    [anon_sym_u21f8] = ACTIONS(4284),
    [anon_sym_u2945] = ACTIONS(4284),
    [anon_sym_BSLASHequiv] = ACTIONS(4284),
    [anon_sym_u2261] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4284),
    [anon_sym_u27fa] = ACTIONS(4284),
    [anon_sym_u21d4] = ACTIONS(4284),
    [anon_sym_TILDE_GT] = ACTIONS(4284),
    [anon_sym_u21dd] = ACTIONS(4284),
    [anon_sym_u219d] = ACTIONS(4284),
    [anon_sym_BSLASHland] = ACTIONS(4284),
    [anon_sym_BSLASHlor] = ACTIONS(4284),
    [anon_sym_COLON_EQ] = ACTIONS(4284),
    [anon_sym_u2254] = ACTIONS(4284),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4284),
    [anon_sym_u2a74] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_POUND] = ACTIONS(4286),
    [anon_sym_u2260] = ACTIONS(4284),
    [anon_sym_LT] = ACTIONS(4286),
    [sym_gt] = ACTIONS(4286),
    [anon_sym_LT_EQ] = ACTIONS(4286),
    [anon_sym_EQ_LT] = ACTIONS(4284),
    [anon_sym_BSLASHleq] = ACTIONS(4284),
    [anon_sym_u2264] = ACTIONS(4284),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_BSLASHgeq] = ACTIONS(4284),
    [anon_sym_u2265] = ACTIONS(4284),
    [anon_sym_BSLASHapprox] = ACTIONS(4284),
    [anon_sym_u2248] = ACTIONS(4284),
    [anon_sym_PIPE_DASH] = ACTIONS(4284),
    [anon_sym_u22a2] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_u22a8] = ACTIONS(4284),
    [anon_sym_DASH_PIPE] = ACTIONS(4284),
    [anon_sym_u22a3] = ACTIONS(4284),
    [anon_sym_EQ_PIPE] = ACTIONS(4284),
    [anon_sym_u2ae4] = ACTIONS(4284),
    [anon_sym_BSLASHasymp] = ACTIONS(4284),
    [anon_sym_u224d] = ACTIONS(4284),
    [anon_sym_BSLASHcong] = ACTIONS(4284),
    [anon_sym_u2245] = ACTIONS(4284),
    [anon_sym_BSLASHdoteq] = ACTIONS(4284),
    [anon_sym_u2250] = ACTIONS(4284),
    [anon_sym_BSLASHgg] = ACTIONS(4284),
    [anon_sym_u226b] = ACTIONS(4284),
    [anon_sym_BSLASHll] = ACTIONS(4284),
    [anon_sym_u226a] = ACTIONS(4284),
    [anon_sym_BSLASHnotin] = ACTIONS(4284),
    [anon_sym_u2209] = ACTIONS(4284),
    [anon_sym_BSLASHprec] = ACTIONS(4286),
    [anon_sym_u227a] = ACTIONS(4284),
    [anon_sym_BSLASHsucc] = ACTIONS(4286),
    [anon_sym_u227b] = ACTIONS(4284),
    [anon_sym_BSLASHpreceq] = ACTIONS(4284),
    [anon_sym_u2aaf] = ACTIONS(4284),
    [anon_sym_BSLASHsucceq] = ACTIONS(4284),
    [anon_sym_u2ab0] = ACTIONS(4284),
    [anon_sym_BSLASHpropto] = ACTIONS(4284),
    [anon_sym_u221d] = ACTIONS(4284),
    [anon_sym_BSLASHsim] = ACTIONS(4286),
    [anon_sym_u223c] = ACTIONS(4284),
    [anon_sym_BSLASHsimeq] = ACTIONS(4284),
    [anon_sym_u2243] = ACTIONS(4284),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4286),
    [anon_sym_u228f] = ACTIONS(4284),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4286),
    [anon_sym_u2290] = ACTIONS(4284),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4284),
    [anon_sym_u2291] = ACTIONS(4284),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4284),
    [anon_sym_u2292] = ACTIONS(4284),
    [anon_sym_BSLASHsubset] = ACTIONS(4286),
    [anon_sym_u2282] = ACTIONS(4284),
    [anon_sym_BSLASHsupset] = ACTIONS(4286),
    [anon_sym_u2283] = ACTIONS(4284),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4284),
    [anon_sym_u2286] = ACTIONS(4284),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4284),
    [anon_sym_u2287] = ACTIONS(4284),
    [sym_compose] = ACTIONS(4284),
    [sym_map_to] = ACTIONS(4284),
    [sym_map_from] = ACTIONS(4284),
    [sym_setminus] = ACTIONS(4286),
    [anon_sym_BSLASHcap] = ACTIONS(4284),
    [anon_sym_BSLASHintersect] = ACTIONS(4284),
    [anon_sym_u2229] = ACTIONS(4284),
    [anon_sym_BSLASHcup] = ACTIONS(4284),
    [anon_sym_BSLASHunion] = ACTIONS(4284),
    [anon_sym_u222a] = ACTIONS(4284),
    [anon_sym_DOT_DOT] = ACTIONS(4286),
    [anon_sym_u2025] = ACTIONS(4284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4284),
    [anon_sym_u2026] = ACTIONS(4284),
    [anon_sym_PLUS] = ACTIONS(4286),
    [sym_plusplus] = ACTIONS(4284),
    [anon_sym_BSLASHoplus] = ACTIONS(4284),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4284),
    [anon_sym_u2295] = ACTIONS(4284),
    [anon_sym_BSLASHominus] = ACTIONS(4284),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4284),
    [anon_sym_u2296] = ACTIONS(4284),
    [sym_mod] = ACTIONS(4286),
    [sym_modmod] = ACTIONS(4284),
    [sym_vert] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_u2016] = ACTIONS(4284),
    [sym_minusminus] = ACTIONS(4284),
    [sym_amp] = ACTIONS(4286),
    [sym_ampamp] = ACTIONS(4284),
    [anon_sym_BSLASHodot] = ACTIONS(4284),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4284),
    [anon_sym_u2299] = ACTIONS(4284),
    [anon_sym_BSLASHoslash] = ACTIONS(4284),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4284),
    [anon_sym_u2298] = ACTIONS(4284),
    [anon_sym_BSLASHotimes] = ACTIONS(4284),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4284),
    [anon_sym_u2297] = ACTIONS(4284),
    [sym_mul] = ACTIONS(4286),
    [sym_mulmul] = ACTIONS(4284),
    [sym_slash] = ACTIONS(4286),
    [sym_slashslash] = ACTIONS(4284),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4284),
    [anon_sym_u25ef] = ACTIONS(4284),
    [anon_sym_BSLASHbullet] = ACTIONS(4284),
    [anon_sym_u25cf] = ACTIONS(4284),
    [anon_sym_BSLASHdiv] = ACTIONS(4284),
    [anon_sym_u00f7] = ACTIONS(4284),
    [anon_sym_BSLASHcirc] = ACTIONS(4284),
    [anon_sym_u2218] = ACTIONS(4284),
    [anon_sym_BSLASHstar] = ACTIONS(4284),
    [anon_sym_u22c6] = ACTIONS(4284),
    [anon_sym_u203c] = ACTIONS(4284),
    [sym_hashhash] = ACTIONS(4284),
    [sym_dol] = ACTIONS(4286),
    [sym_doldol] = ACTIONS(4284),
    [anon_sym_QMARK_QMARK] = ACTIONS(4284),
    [anon_sym_u2047] = ACTIONS(4284),
    [anon_sym_BSLASHsqcap] = ACTIONS(4284),
    [anon_sym_u2293] = ACTIONS(4284),
    [anon_sym_BSLASHsqcup] = ACTIONS(4284),
    [anon_sym_u2294] = ACTIONS(4284),
    [anon_sym_BSLASHuplus] = ACTIONS(4284),
    [anon_sym_u228e] = ACTIONS(4284),
    [anon_sym_BSLASHX] = ACTIONS(4284),
    [anon_sym_BSLASHtimes] = ACTIONS(4284),
    [anon_sym_u00d7] = ACTIONS(4284),
    [anon_sym_BSLASHwr] = ACTIONS(4284),
    [anon_sym_u2240] = ACTIONS(4284),
    [anon_sym_BSLASHcdot] = ACTIONS(4284),
    [anon_sym_u22c5] = ACTIONS(4284),
    [sym_pow] = ACTIONS(4286),
    [sym_powpow] = ACTIONS(4284),
    [anon_sym_CARET_PLUS] = ACTIONS(4284),
    [anon_sym_u207a] = ACTIONS(4284),
    [sym_asterisk] = ACTIONS(4284),
    [sym_sup_hash] = ACTIONS(4284),
    [sym_prime] = ACTIONS(4284),
    [sym__indent] = ACTIONS(4284),
    [sym__double_excl] = ACTIONS(4284),
  },
  [2128] = {
    [sym_block_comment] = STATE(2128),
    [sym_identifier] = ACTIONS(4282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4282),
    [anon_sym_u2208] = ACTIONS(4280),
    [anon_sym_BSLASHA] = ACTIONS(4282),
    [anon_sym_BSLASHforall] = ACTIONS(4280),
    [anon_sym_u2200] = ACTIONS(4280),
    [anon_sym_BSLASHE] = ACTIONS(4282),
    [anon_sym_BSLASHexists] = ACTIONS(4280),
    [anon_sym_u2203] = ACTIONS(4280),
    [sym_temporal_forall] = ACTIONS(4280),
    [sym_temporal_exists] = ACTIONS(4280),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_u3008] = ACTIONS(4280),
    [anon_sym_u27e8] = ACTIONS(4280),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4280),
    [anon_sym_u25a1] = ACTIONS(4280),
    [anon_sym_AT] = ACTIONS(4282),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4280),
    [anon_sym_u2227] = ACTIONS(4280),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4280),
    [anon_sym_u2228] = ACTIONS(4280),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_LPAREN] = ACTIONS(4282),
    [anon_sym_LBRACK] = ACTIONS(4282),
    [anon_sym_BANG] = ACTIONS(4280),
    [aux_sym_child_id_token1] = ACTIONS(4282),
    [sym_real_number] = ACTIONS(4280),
    [anon_sym_BSLASHb] = ACTIONS(4282),
    [anon_sym_BSLASHB] = ACTIONS(4280),
    [anon_sym_BSLASHo] = ACTIONS(4282),
    [anon_sym_BSLASHO] = ACTIONS(4280),
    [anon_sym_BSLASHh] = ACTIONS(4280),
    [anon_sym_BSLASHH] = ACTIONS(4280),
    [anon_sym_DQUOTE] = ACTIONS(4280),
    [anon_sym_TRUE] = ACTIONS(4282),
    [anon_sym_FALSE] = ACTIONS(4282),
    [sym_string_set] = ACTIONS(4282),
    [sym_boolean_set] = ACTIONS(4282),
    [anon_sym_Nat] = ACTIONS(4282),
    [anon_sym_u2115] = ACTIONS(4280),
    [anon_sym_Int] = ACTIONS(4282),
    [anon_sym_u2124] = ACTIONS(4280),
    [anon_sym_Real] = ACTIONS(4282),
    [anon_sym_u211d] = ACTIONS(4280),
    [anon_sym_CHOOSE] = ACTIONS(4282),
    [anon_sym_LBRACE] = ACTIONS(4280),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_WF_] = ACTIONS(4282),
    [anon_sym_SF_] = ACTIONS(4282),
    [anon_sym_IF] = ACTIONS(4282),
    [anon_sym_CASE] = ACTIONS(4282),
    [anon_sym_LET] = ACTIONS(4282),
    [anon_sym_BSLASHlnot] = ACTIONS(4280),
    [anon_sym_BSLASHneg] = ACTIONS(4280),
    [anon_sym_TILDE] = ACTIONS(4282),
    [anon_sym_u00ac] = ACTIONS(4280),
    [sym_union] = ACTIONS(4282),
    [sym_powerset] = ACTIONS(4282),
    [sym_domain] = ACTIONS(4282),
    [anon_sym_DASH] = ACTIONS(4282),
    [sym_negative_dot] = ACTIONS(4280),
    [sym_enabled] = ACTIONS(4282),
    [sym_unchanged] = ACTIONS(4282),
    [anon_sym_LT_GT] = ACTIONS(4280),
    [anon_sym_u22c4] = ACTIONS(4280),
    [anon_sym_u25c7] = ACTIONS(4280),
    [anon_sym_EQ_GT] = ACTIONS(4280),
    [anon_sym_u27f9] = ACTIONS(4280),
    [anon_sym_u21d2] = ACTIONS(4280),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4280),
    [anon_sym_u21f8] = ACTIONS(4280),
    [anon_sym_u2945] = ACTIONS(4280),
    [anon_sym_BSLASHequiv] = ACTIONS(4280),
    [anon_sym_u2261] = ACTIONS(4280),
    [anon_sym_LT_EQ_GT] = ACTIONS(4280),
    [anon_sym_u27fa] = ACTIONS(4280),
    [anon_sym_u21d4] = ACTIONS(4280),
    [anon_sym_TILDE_GT] = ACTIONS(4280),
    [anon_sym_u21dd] = ACTIONS(4280),
    [anon_sym_u219d] = ACTIONS(4280),
    [anon_sym_BSLASHland] = ACTIONS(4280),
    [anon_sym_BSLASHlor] = ACTIONS(4280),
    [anon_sym_COLON_EQ] = ACTIONS(4280),
    [anon_sym_u2254] = ACTIONS(4280),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4280),
    [anon_sym_u2a74] = ACTIONS(4280),
    [anon_sym_SLASH_EQ] = ACTIONS(4280),
    [anon_sym_POUND] = ACTIONS(4282),
    [anon_sym_u2260] = ACTIONS(4280),
    [anon_sym_LT] = ACTIONS(4282),
    [sym_gt] = ACTIONS(4282),
    [anon_sym_LT_EQ] = ACTIONS(4282),
    [anon_sym_EQ_LT] = ACTIONS(4280),
    [anon_sym_BSLASHleq] = ACTIONS(4280),
    [anon_sym_u2264] = ACTIONS(4280),
    [anon_sym_GT_EQ] = ACTIONS(4280),
    [anon_sym_BSLASHgeq] = ACTIONS(4280),
    [anon_sym_u2265] = ACTIONS(4280),
    [anon_sym_BSLASHapprox] = ACTIONS(4280),
    [anon_sym_u2248] = ACTIONS(4280),
    [anon_sym_PIPE_DASH] = ACTIONS(4280),
    [anon_sym_u22a2] = ACTIONS(4280),
    [anon_sym_PIPE_EQ] = ACTIONS(4280),
    [anon_sym_u22a8] = ACTIONS(4280),
    [anon_sym_DASH_PIPE] = ACTIONS(4280),
    [anon_sym_u22a3] = ACTIONS(4280),
    [anon_sym_EQ_PIPE] = ACTIONS(4280),
    [anon_sym_u2ae4] = ACTIONS(4280),
    [anon_sym_BSLASHasymp] = ACTIONS(4280),
    [anon_sym_u224d] = ACTIONS(4280),
    [anon_sym_BSLASHcong] = ACTIONS(4280),
    [anon_sym_u2245] = ACTIONS(4280),
    [anon_sym_BSLASHdoteq] = ACTIONS(4280),
    [anon_sym_u2250] = ACTIONS(4280),
    [anon_sym_BSLASHgg] = ACTIONS(4280),
    [anon_sym_u226b] = ACTIONS(4280),
    [anon_sym_BSLASHll] = ACTIONS(4280),
    [anon_sym_u226a] = ACTIONS(4280),
    [anon_sym_BSLASHnotin] = ACTIONS(4280),
    [anon_sym_u2209] = ACTIONS(4280),
    [anon_sym_BSLASHprec] = ACTIONS(4282),
    [anon_sym_u227a] = ACTIONS(4280),
    [anon_sym_BSLASHsucc] = ACTIONS(4282),
    [anon_sym_u227b] = ACTIONS(4280),
    [anon_sym_BSLASHpreceq] = ACTIONS(4280),
    [anon_sym_u2aaf] = ACTIONS(4280),
    [anon_sym_BSLASHsucceq] = ACTIONS(4280),
    [anon_sym_u2ab0] = ACTIONS(4280),
    [anon_sym_BSLASHpropto] = ACTIONS(4280),
    [anon_sym_u221d] = ACTIONS(4280),
    [anon_sym_BSLASHsim] = ACTIONS(4282),
    [anon_sym_u223c] = ACTIONS(4280),
    [anon_sym_BSLASHsimeq] = ACTIONS(4280),
    [anon_sym_u2243] = ACTIONS(4280),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4282),
    [anon_sym_u228f] = ACTIONS(4280),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4282),
    [anon_sym_u2290] = ACTIONS(4280),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4280),
    [anon_sym_u2291] = ACTIONS(4280),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4280),
    [anon_sym_u2292] = ACTIONS(4280),
    [anon_sym_BSLASHsubset] = ACTIONS(4282),
    [anon_sym_u2282] = ACTIONS(4280),
    [anon_sym_BSLASHsupset] = ACTIONS(4282),
    [anon_sym_u2283] = ACTIONS(4280),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4280),
    [anon_sym_u2286] = ACTIONS(4280),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4280),
    [anon_sym_u2287] = ACTIONS(4280),
    [sym_compose] = ACTIONS(4280),
    [sym_map_to] = ACTIONS(4280),
    [sym_map_from] = ACTIONS(4280),
    [sym_setminus] = ACTIONS(4282),
    [anon_sym_BSLASHcap] = ACTIONS(4280),
    [anon_sym_BSLASHintersect] = ACTIONS(4280),
    [anon_sym_u2229] = ACTIONS(4280),
    [anon_sym_BSLASHcup] = ACTIONS(4280),
    [anon_sym_BSLASHunion] = ACTIONS(4280),
    [anon_sym_u222a] = ACTIONS(4280),
    [anon_sym_DOT_DOT] = ACTIONS(4282),
    [anon_sym_u2025] = ACTIONS(4280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4280),
    [anon_sym_u2026] = ACTIONS(4280),
    [anon_sym_PLUS] = ACTIONS(4282),
    [sym_plusplus] = ACTIONS(4280),
    [anon_sym_BSLASHoplus] = ACTIONS(4280),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4280),
    [anon_sym_u2295] = ACTIONS(4280),
    [anon_sym_BSLASHominus] = ACTIONS(4280),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4280),
    [anon_sym_u2296] = ACTIONS(4280),
    [sym_mod] = ACTIONS(4282),
    [sym_modmod] = ACTIONS(4280),
    [sym_vert] = ACTIONS(4282),
    [anon_sym_PIPE_PIPE] = ACTIONS(4280),
    [anon_sym_u2016] = ACTIONS(4280),
    [sym_minusminus] = ACTIONS(4280),
    [sym_amp] = ACTIONS(4282),
    [sym_ampamp] = ACTIONS(4280),
    [anon_sym_BSLASHodot] = ACTIONS(4280),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4280),
    [anon_sym_u2299] = ACTIONS(4280),
    [anon_sym_BSLASHoslash] = ACTIONS(4280),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4280),
    [anon_sym_u2298] = ACTIONS(4280),
    [anon_sym_BSLASHotimes] = ACTIONS(4280),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4280),
    [anon_sym_u2297] = ACTIONS(4280),
    [sym_mul] = ACTIONS(4282),
    [sym_mulmul] = ACTIONS(4280),
    [sym_slash] = ACTIONS(4282),
    [sym_slashslash] = ACTIONS(4280),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4280),
    [anon_sym_u25ef] = ACTIONS(4280),
    [anon_sym_BSLASHbullet] = ACTIONS(4280),
    [anon_sym_u25cf] = ACTIONS(4280),
    [anon_sym_BSLASHdiv] = ACTIONS(4280),
    [anon_sym_u00f7] = ACTIONS(4280),
    [anon_sym_BSLASHcirc] = ACTIONS(4280),
    [anon_sym_u2218] = ACTIONS(4280),
    [anon_sym_BSLASHstar] = ACTIONS(4280),
    [anon_sym_u22c6] = ACTIONS(4280),
    [anon_sym_u203c] = ACTIONS(4280),
    [sym_hashhash] = ACTIONS(4280),
    [sym_dol] = ACTIONS(4282),
    [sym_doldol] = ACTIONS(4280),
    [anon_sym_QMARK_QMARK] = ACTIONS(4280),
    [anon_sym_u2047] = ACTIONS(4280),
    [anon_sym_BSLASHsqcap] = ACTIONS(4280),
    [anon_sym_u2293] = ACTIONS(4280),
    [anon_sym_BSLASHsqcup] = ACTIONS(4280),
    [anon_sym_u2294] = ACTIONS(4280),
    [anon_sym_BSLASHuplus] = ACTIONS(4280),
    [anon_sym_u228e] = ACTIONS(4280),
    [anon_sym_BSLASHX] = ACTIONS(4280),
    [anon_sym_BSLASHtimes] = ACTIONS(4280),
    [anon_sym_u00d7] = ACTIONS(4280),
    [anon_sym_BSLASHwr] = ACTIONS(4280),
    [anon_sym_u2240] = ACTIONS(4280),
    [anon_sym_BSLASHcdot] = ACTIONS(4280),
    [anon_sym_u22c5] = ACTIONS(4280),
    [sym_pow] = ACTIONS(4282),
    [sym_powpow] = ACTIONS(4280),
    [anon_sym_CARET_PLUS] = ACTIONS(4280),
    [anon_sym_u207a] = ACTIONS(4280),
    [sym_asterisk] = ACTIONS(4280),
    [sym_sup_hash] = ACTIONS(4280),
    [sym_prime] = ACTIONS(4280),
    [sym__indent] = ACTIONS(4280),
    [sym__begin_proof_step] = ACTIONS(4280),
    [sym__double_excl] = ACTIONS(4280),
  },
  [2129] = {
    [sym_block_comment] = STATE(2129),
    [sym_identifier] = ACTIONS(4271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4271),
    [anon_sym_u2208] = ACTIONS(4273),
    [anon_sym_BSLASHA] = ACTIONS(4271),
    [anon_sym_BSLASHforall] = ACTIONS(4273),
    [anon_sym_u2200] = ACTIONS(4273),
    [anon_sym_BSLASHE] = ACTIONS(4271),
    [anon_sym_BSLASHexists] = ACTIONS(4273),
    [anon_sym_u2203] = ACTIONS(4273),
    [sym_temporal_forall] = ACTIONS(4273),
    [sym_temporal_exists] = ACTIONS(4273),
    [anon_sym_LT_LT] = ACTIONS(4273),
    [anon_sym_u3008] = ACTIONS(4273),
    [anon_sym_u27e8] = ACTIONS(4273),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4273),
    [anon_sym_u25a1] = ACTIONS(4273),
    [anon_sym_AT] = ACTIONS(4271),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4273),
    [anon_sym_u2227] = ACTIONS(4273),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4273),
    [anon_sym_u2228] = ACTIONS(4273),
    [anon_sym_COMMA] = ACTIONS(4269),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [anon_sym_RPAREN] = ACTIONS(4269),
    [anon_sym_LBRACK] = ACTIONS(4271),
    [anon_sym_BANG] = ACTIONS(4269),
    [aux_sym_child_id_token1] = ACTIONS(4271),
    [sym_real_number] = ACTIONS(4273),
    [anon_sym_BSLASHb] = ACTIONS(4271),
    [anon_sym_BSLASHB] = ACTIONS(4273),
    [anon_sym_BSLASHo] = ACTIONS(4271),
    [anon_sym_BSLASHO] = ACTIONS(4273),
    [anon_sym_BSLASHh] = ACTIONS(4273),
    [anon_sym_BSLASHH] = ACTIONS(4273),
    [anon_sym_DQUOTE] = ACTIONS(4273),
    [anon_sym_TRUE] = ACTIONS(4271),
    [anon_sym_FALSE] = ACTIONS(4271),
    [sym_string_set] = ACTIONS(4271),
    [sym_boolean_set] = ACTIONS(4271),
    [anon_sym_Nat] = ACTIONS(4271),
    [anon_sym_u2115] = ACTIONS(4273),
    [anon_sym_Int] = ACTIONS(4271),
    [anon_sym_u2124] = ACTIONS(4273),
    [anon_sym_Real] = ACTIONS(4271),
    [anon_sym_u211d] = ACTIONS(4273),
    [anon_sym_CHOOSE] = ACTIONS(4271),
    [anon_sym_LBRACE] = ACTIONS(4273),
    [anon_sym_EQ] = ACTIONS(4271),
    [anon_sym_WF_] = ACTIONS(4271),
    [anon_sym_SF_] = ACTIONS(4271),
    [anon_sym_IF] = ACTIONS(4271),
    [anon_sym_CASE] = ACTIONS(4271),
    [anon_sym_LET] = ACTIONS(4271),
    [anon_sym_BSLASHlnot] = ACTIONS(4273),
    [anon_sym_BSLASHneg] = ACTIONS(4273),
    [anon_sym_TILDE] = ACTIONS(4271),
    [anon_sym_u00ac] = ACTIONS(4273),
    [sym_union] = ACTIONS(4271),
    [sym_powerset] = ACTIONS(4271),
    [sym_domain] = ACTIONS(4271),
    [anon_sym_DASH] = ACTIONS(4271),
    [sym_negative_dot] = ACTIONS(4273),
    [sym_enabled] = ACTIONS(4271),
    [sym_unchanged] = ACTIONS(4271),
    [anon_sym_LT_GT] = ACTIONS(4273),
    [anon_sym_u22c4] = ACTIONS(4273),
    [anon_sym_u25c7] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27f9] = ACTIONS(4273),
    [anon_sym_u21d2] = ACTIONS(4273),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4273),
    [anon_sym_u21f8] = ACTIONS(4273),
    [anon_sym_u2945] = ACTIONS(4273),
    [anon_sym_BSLASHequiv] = ACTIONS(4273),
    [anon_sym_u2261] = ACTIONS(4273),
    [anon_sym_LT_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27fa] = ACTIONS(4273),
    [anon_sym_u21d4] = ACTIONS(4273),
    [anon_sym_TILDE_GT] = ACTIONS(4273),
    [anon_sym_u21dd] = ACTIONS(4273),
    [anon_sym_u219d] = ACTIONS(4273),
    [anon_sym_BSLASHland] = ACTIONS(4273),
    [anon_sym_BSLASHlor] = ACTIONS(4273),
    [anon_sym_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2254] = ACTIONS(4273),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2a74] = ACTIONS(4273),
    [anon_sym_SLASH_EQ] = ACTIONS(4273),
    [anon_sym_POUND] = ACTIONS(4271),
    [anon_sym_u2260] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4271),
    [sym_gt] = ACTIONS(4271),
    [anon_sym_LT_EQ] = ACTIONS(4271),
    [anon_sym_EQ_LT] = ACTIONS(4273),
    [anon_sym_BSLASHleq] = ACTIONS(4273),
    [anon_sym_u2264] = ACTIONS(4273),
    [anon_sym_GT_EQ] = ACTIONS(4273),
    [anon_sym_BSLASHgeq] = ACTIONS(4273),
    [anon_sym_u2265] = ACTIONS(4273),
    [anon_sym_BSLASHapprox] = ACTIONS(4273),
    [anon_sym_u2248] = ACTIONS(4273),
    [anon_sym_PIPE_DASH] = ACTIONS(4273),
    [anon_sym_u22a2] = ACTIONS(4273),
    [anon_sym_PIPE_EQ] = ACTIONS(4273),
    [anon_sym_u22a8] = ACTIONS(4273),
    [anon_sym_DASH_PIPE] = ACTIONS(4273),
    [anon_sym_u22a3] = ACTIONS(4273),
    [anon_sym_EQ_PIPE] = ACTIONS(4273),
    [anon_sym_u2ae4] = ACTIONS(4273),
    [anon_sym_BSLASHasymp] = ACTIONS(4273),
    [anon_sym_u224d] = ACTIONS(4273),
    [anon_sym_BSLASHcong] = ACTIONS(4273),
    [anon_sym_u2245] = ACTIONS(4273),
    [anon_sym_BSLASHdoteq] = ACTIONS(4273),
    [anon_sym_u2250] = ACTIONS(4273),
    [anon_sym_BSLASHgg] = ACTIONS(4273),
    [anon_sym_u226b] = ACTIONS(4273),
    [anon_sym_BSLASHll] = ACTIONS(4273),
    [anon_sym_u226a] = ACTIONS(4273),
    [anon_sym_BSLASHnotin] = ACTIONS(4273),
    [anon_sym_u2209] = ACTIONS(4273),
    [anon_sym_BSLASHprec] = ACTIONS(4271),
    [anon_sym_u227a] = ACTIONS(4273),
    [anon_sym_BSLASHsucc] = ACTIONS(4271),
    [anon_sym_u227b] = ACTIONS(4273),
    [anon_sym_BSLASHpreceq] = ACTIONS(4273),
    [anon_sym_u2aaf] = ACTIONS(4273),
    [anon_sym_BSLASHsucceq] = ACTIONS(4273),
    [anon_sym_u2ab0] = ACTIONS(4273),
    [anon_sym_BSLASHpropto] = ACTIONS(4273),
    [anon_sym_u221d] = ACTIONS(4273),
    [anon_sym_BSLASHsim] = ACTIONS(4271),
    [anon_sym_u223c] = ACTIONS(4273),
    [anon_sym_BSLASHsimeq] = ACTIONS(4273),
    [anon_sym_u2243] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4271),
    [anon_sym_u228f] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4271),
    [anon_sym_u2290] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4273),
    [anon_sym_u2291] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4273),
    [anon_sym_u2292] = ACTIONS(4273),
    [anon_sym_BSLASHsubset] = ACTIONS(4271),
    [anon_sym_u2282] = ACTIONS(4273),
    [anon_sym_BSLASHsupset] = ACTIONS(4271),
    [anon_sym_u2283] = ACTIONS(4273),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4273),
    [anon_sym_u2286] = ACTIONS(4273),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4273),
    [anon_sym_u2287] = ACTIONS(4273),
    [sym_compose] = ACTIONS(4273),
    [sym_map_to] = ACTIONS(4273),
    [sym_map_from] = ACTIONS(4273),
    [sym_setminus] = ACTIONS(4271),
    [anon_sym_BSLASHcap] = ACTIONS(4273),
    [anon_sym_BSLASHintersect] = ACTIONS(4273),
    [anon_sym_u2229] = ACTIONS(4273),
    [anon_sym_BSLASHcup] = ACTIONS(4273),
    [anon_sym_BSLASHunion] = ACTIONS(4273),
    [anon_sym_u222a] = ACTIONS(4273),
    [anon_sym_DOT_DOT] = ACTIONS(4271),
    [anon_sym_u2025] = ACTIONS(4273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4273),
    [anon_sym_u2026] = ACTIONS(4273),
    [anon_sym_PLUS] = ACTIONS(4271),
    [sym_plusplus] = ACTIONS(4273),
    [anon_sym_BSLASHoplus] = ACTIONS(4273),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4273),
    [anon_sym_u2295] = ACTIONS(4273),
    [anon_sym_BSLASHominus] = ACTIONS(4273),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2296] = ACTIONS(4273),
    [sym_mod] = ACTIONS(4271),
    [sym_modmod] = ACTIONS(4273),
    [sym_vert] = ACTIONS(4271),
    [anon_sym_PIPE_PIPE] = ACTIONS(4273),
    [anon_sym_u2016] = ACTIONS(4273),
    [sym_minusminus] = ACTIONS(4273),
    [sym_amp] = ACTIONS(4271),
    [sym_ampamp] = ACTIONS(4273),
    [anon_sym_BSLASHodot] = ACTIONS(4273),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4273),
    [anon_sym_u2299] = ACTIONS(4273),
    [anon_sym_BSLASHoslash] = ACTIONS(4273),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2298] = ACTIONS(4273),
    [anon_sym_BSLASHotimes] = ACTIONS(4273),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4273),
    [anon_sym_u2297] = ACTIONS(4273),
    [sym_mul] = ACTIONS(4271),
    [sym_mulmul] = ACTIONS(4273),
    [sym_slash] = ACTIONS(4271),
    [sym_slashslash] = ACTIONS(4273),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4273),
    [anon_sym_u25ef] = ACTIONS(4273),
    [anon_sym_BSLASHbullet] = ACTIONS(4273),
    [anon_sym_u25cf] = ACTIONS(4273),
    [anon_sym_BSLASHdiv] = ACTIONS(4273),
    [anon_sym_u00f7] = ACTIONS(4273),
    [anon_sym_BSLASHcirc] = ACTIONS(4273),
    [anon_sym_u2218] = ACTIONS(4273),
    [anon_sym_BSLASHstar] = ACTIONS(4273),
    [anon_sym_u22c6] = ACTIONS(4273),
    [anon_sym_u203c] = ACTIONS(4273),
    [sym_hashhash] = ACTIONS(4273),
    [sym_dol] = ACTIONS(4271),
    [sym_doldol] = ACTIONS(4273),
    [anon_sym_QMARK_QMARK] = ACTIONS(4273),
    [anon_sym_u2047] = ACTIONS(4273),
    [anon_sym_BSLASHsqcap] = ACTIONS(4273),
    [anon_sym_u2293] = ACTIONS(4273),
    [anon_sym_BSLASHsqcup] = ACTIONS(4273),
    [anon_sym_u2294] = ACTIONS(4273),
    [anon_sym_BSLASHuplus] = ACTIONS(4273),
    [anon_sym_u228e] = ACTIONS(4273),
    [anon_sym_BSLASHX] = ACTIONS(4273),
    [anon_sym_BSLASHtimes] = ACTIONS(4273),
    [anon_sym_u00d7] = ACTIONS(4273),
    [anon_sym_BSLASHwr] = ACTIONS(4273),
    [anon_sym_u2240] = ACTIONS(4273),
    [anon_sym_BSLASHcdot] = ACTIONS(4273),
    [anon_sym_u22c5] = ACTIONS(4273),
    [sym_pow] = ACTIONS(4271),
    [sym_powpow] = ACTIONS(4273),
    [anon_sym_CARET_PLUS] = ACTIONS(4273),
    [anon_sym_u207a] = ACTIONS(4273),
    [sym_asterisk] = ACTIONS(4273),
    [sym_sup_hash] = ACTIONS(4273),
    [sym_prime] = ACTIONS(4273),
    [sym__indent] = ACTIONS(4273),
    [sym__double_excl] = ACTIONS(4273),
  },
  [2130] = {
    [sym_block_comment] = STATE(2130),
    [sym_identifier] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_BSLASHA] = ACTIONS(5349),
    [anon_sym_BSLASHforall] = ACTIONS(5351),
    [anon_sym_u2200] = ACTIONS(5351),
    [anon_sym_BSLASHE] = ACTIONS(5349),
    [anon_sym_BSLASHexists] = ACTIONS(5351),
    [anon_sym_u2203] = ACTIONS(5351),
    [sym_temporal_forall] = ACTIONS(5351),
    [sym_temporal_exists] = ACTIONS(5351),
    [anon_sym_LT_LT] = ACTIONS(5351),
    [anon_sym_u3008] = ACTIONS(5351),
    [anon_sym_u27e8] = ACTIONS(5351),
    [anon_sym_GT_GT] = ACTIONS(5351),
    [anon_sym_u3009] = ACTIONS(5351),
    [anon_sym_u27e9] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_AT] = ACTIONS(5349),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [aux_sym_child_id_token1] = ACTIONS(5349),
    [sym_real_number] = ACTIONS(5351),
    [anon_sym_BSLASHb] = ACTIONS(5349),
    [anon_sym_BSLASHB] = ACTIONS(5351),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_BSLASHO] = ACTIONS(5351),
    [anon_sym_BSLASHh] = ACTIONS(5351),
    [anon_sym_BSLASHH] = ACTIONS(5351),
    [anon_sym_DQUOTE] = ACTIONS(5351),
    [anon_sym_TRUE] = ACTIONS(5349),
    [anon_sym_FALSE] = ACTIONS(5349),
    [sym_string_set] = ACTIONS(5349),
    [sym_boolean_set] = ACTIONS(5349),
    [anon_sym_Nat] = ACTIONS(5349),
    [anon_sym_u2115] = ACTIONS(5351),
    [anon_sym_Int] = ACTIONS(5349),
    [anon_sym_u2124] = ACTIONS(5351),
    [anon_sym_Real] = ACTIONS(5349),
    [anon_sym_u211d] = ACTIONS(5351),
    [anon_sym_CHOOSE] = ACTIONS(5349),
    [anon_sym_LBRACE] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_WF_] = ACTIONS(5349),
    [anon_sym_SF_] = ACTIONS(5349),
    [anon_sym_IF] = ACTIONS(5349),
    [anon_sym_CASE] = ACTIONS(5349),
    [anon_sym_LET] = ACTIONS(5349),
    [anon_sym_BSLASHlnot] = ACTIONS(5351),
    [anon_sym_BSLASHneg] = ACTIONS(5351),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_u00ac] = ACTIONS(5351),
    [sym_union] = ACTIONS(5349),
    [sym_powerset] = ACTIONS(5349),
    [sym_domain] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [sym_negative_dot] = ACTIONS(5351),
    [sym_enabled] = ACTIONS(5349),
    [sym_unchanged] = ACTIONS(5349),
    [anon_sym_LT_GT] = ACTIONS(5351),
    [anon_sym_u22c4] = ACTIONS(5351),
    [anon_sym_u25c7] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [sym__indent] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [2131] = {
    [sym_block_comment] = STATE(2131),
    [sym_identifier] = ACTIONS(4290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4290),
    [anon_sym_u2208] = ACTIONS(4288),
    [anon_sym_BSLASHA] = ACTIONS(4290),
    [anon_sym_BSLASHforall] = ACTIONS(4288),
    [anon_sym_u2200] = ACTIONS(4288),
    [anon_sym_BSLASHE] = ACTIONS(4290),
    [anon_sym_BSLASHexists] = ACTIONS(4288),
    [anon_sym_u2203] = ACTIONS(4288),
    [sym_temporal_forall] = ACTIONS(4288),
    [sym_temporal_exists] = ACTIONS(4288),
    [anon_sym_LT_LT] = ACTIONS(4288),
    [anon_sym_u3008] = ACTIONS(4288),
    [anon_sym_u27e8] = ACTIONS(4288),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4288),
    [anon_sym_u25a1] = ACTIONS(4288),
    [anon_sym_AT] = ACTIONS(4290),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4288),
    [anon_sym_u2227] = ACTIONS(4288),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4288),
    [anon_sym_u2228] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [anon_sym_LPAREN] = ACTIONS(4290),
    [anon_sym_LBRACK] = ACTIONS(4290),
    [anon_sym_BANG] = ACTIONS(4288),
    [aux_sym_child_id_token1] = ACTIONS(4290),
    [sym_real_number] = ACTIONS(4288),
    [anon_sym_BSLASHb] = ACTIONS(4290),
    [anon_sym_BSLASHB] = ACTIONS(4288),
    [anon_sym_BSLASHo] = ACTIONS(4290),
    [anon_sym_BSLASHO] = ACTIONS(4288),
    [anon_sym_BSLASHh] = ACTIONS(4288),
    [anon_sym_BSLASHH] = ACTIONS(4288),
    [anon_sym_DQUOTE] = ACTIONS(4288),
    [anon_sym_TRUE] = ACTIONS(4290),
    [anon_sym_FALSE] = ACTIONS(4290),
    [sym_string_set] = ACTIONS(4290),
    [sym_boolean_set] = ACTIONS(4290),
    [anon_sym_Nat] = ACTIONS(4290),
    [anon_sym_u2115] = ACTIONS(4288),
    [anon_sym_Int] = ACTIONS(4290),
    [anon_sym_u2124] = ACTIONS(4288),
    [anon_sym_Real] = ACTIONS(4290),
    [anon_sym_u211d] = ACTIONS(4288),
    [anon_sym_CHOOSE] = ACTIONS(4290),
    [anon_sym_LBRACE] = ACTIONS(4288),
    [anon_sym_EQ] = ACTIONS(4290),
    [anon_sym_WF_] = ACTIONS(4290),
    [anon_sym_SF_] = ACTIONS(4290),
    [anon_sym_IF] = ACTIONS(4290),
    [anon_sym_CASE] = ACTIONS(4290),
    [anon_sym_LET] = ACTIONS(4290),
    [anon_sym_BSLASHlnot] = ACTIONS(4288),
    [anon_sym_BSLASHneg] = ACTIONS(4288),
    [anon_sym_TILDE] = ACTIONS(4290),
    [anon_sym_u00ac] = ACTIONS(4288),
    [sym_union] = ACTIONS(4290),
    [sym_powerset] = ACTIONS(4290),
    [sym_domain] = ACTIONS(4290),
    [anon_sym_DASH] = ACTIONS(4290),
    [sym_negative_dot] = ACTIONS(4288),
    [sym_enabled] = ACTIONS(4290),
    [sym_unchanged] = ACTIONS(4290),
    [anon_sym_LT_GT] = ACTIONS(4288),
    [anon_sym_u22c4] = ACTIONS(4288),
    [anon_sym_u25c7] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(4288),
    [anon_sym_u27f9] = ACTIONS(4288),
    [anon_sym_u21d2] = ACTIONS(4288),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4288),
    [anon_sym_u21f8] = ACTIONS(4288),
    [anon_sym_u2945] = ACTIONS(4288),
    [anon_sym_BSLASHequiv] = ACTIONS(4288),
    [anon_sym_u2261] = ACTIONS(4288),
    [anon_sym_LT_EQ_GT] = ACTIONS(4288),
    [anon_sym_u27fa] = ACTIONS(4288),
    [anon_sym_u21d4] = ACTIONS(4288),
    [anon_sym_TILDE_GT] = ACTIONS(4288),
    [anon_sym_u21dd] = ACTIONS(4288),
    [anon_sym_u219d] = ACTIONS(4288),
    [anon_sym_BSLASHland] = ACTIONS(4288),
    [anon_sym_BSLASHlor] = ACTIONS(4288),
    [anon_sym_COLON_EQ] = ACTIONS(4288),
    [anon_sym_u2254] = ACTIONS(4288),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4288),
    [anon_sym_u2a74] = ACTIONS(4288),
    [anon_sym_SLASH_EQ] = ACTIONS(4288),
    [anon_sym_POUND] = ACTIONS(4290),
    [anon_sym_u2260] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4290),
    [sym_gt] = ACTIONS(4290),
    [anon_sym_LT_EQ] = ACTIONS(4290),
    [anon_sym_EQ_LT] = ACTIONS(4288),
    [anon_sym_BSLASHleq] = ACTIONS(4288),
    [anon_sym_u2264] = ACTIONS(4288),
    [anon_sym_GT_EQ] = ACTIONS(4288),
    [anon_sym_BSLASHgeq] = ACTIONS(4288),
    [anon_sym_u2265] = ACTIONS(4288),
    [anon_sym_BSLASHapprox] = ACTIONS(4288),
    [anon_sym_u2248] = ACTIONS(4288),
    [anon_sym_PIPE_DASH] = ACTIONS(4288),
    [anon_sym_u22a2] = ACTIONS(4288),
    [anon_sym_PIPE_EQ] = ACTIONS(4288),
    [anon_sym_u22a8] = ACTIONS(4288),
    [anon_sym_DASH_PIPE] = ACTIONS(4288),
    [anon_sym_u22a3] = ACTIONS(4288),
    [anon_sym_EQ_PIPE] = ACTIONS(4288),
    [anon_sym_u2ae4] = ACTIONS(4288),
    [anon_sym_BSLASHasymp] = ACTIONS(4288),
    [anon_sym_u224d] = ACTIONS(4288),
    [anon_sym_BSLASHcong] = ACTIONS(4288),
    [anon_sym_u2245] = ACTIONS(4288),
    [anon_sym_BSLASHdoteq] = ACTIONS(4288),
    [anon_sym_u2250] = ACTIONS(4288),
    [anon_sym_BSLASHgg] = ACTIONS(4288),
    [anon_sym_u226b] = ACTIONS(4288),
    [anon_sym_BSLASHll] = ACTIONS(4288),
    [anon_sym_u226a] = ACTIONS(4288),
    [anon_sym_BSLASHnotin] = ACTIONS(4288),
    [anon_sym_u2209] = ACTIONS(4288),
    [anon_sym_BSLASHprec] = ACTIONS(4290),
    [anon_sym_u227a] = ACTIONS(4288),
    [anon_sym_BSLASHsucc] = ACTIONS(4290),
    [anon_sym_u227b] = ACTIONS(4288),
    [anon_sym_BSLASHpreceq] = ACTIONS(4288),
    [anon_sym_u2aaf] = ACTIONS(4288),
    [anon_sym_BSLASHsucceq] = ACTIONS(4288),
    [anon_sym_u2ab0] = ACTIONS(4288),
    [anon_sym_BSLASHpropto] = ACTIONS(4288),
    [anon_sym_u221d] = ACTIONS(4288),
    [anon_sym_BSLASHsim] = ACTIONS(4290),
    [anon_sym_u223c] = ACTIONS(4288),
    [anon_sym_BSLASHsimeq] = ACTIONS(4288),
    [anon_sym_u2243] = ACTIONS(4288),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4290),
    [anon_sym_u228f] = ACTIONS(4288),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4290),
    [anon_sym_u2290] = ACTIONS(4288),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4288),
    [anon_sym_u2291] = ACTIONS(4288),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4288),
    [anon_sym_u2292] = ACTIONS(4288),
    [anon_sym_BSLASHsubset] = ACTIONS(4290),
    [anon_sym_u2282] = ACTIONS(4288),
    [anon_sym_BSLASHsupset] = ACTIONS(4290),
    [anon_sym_u2283] = ACTIONS(4288),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4288),
    [anon_sym_u2286] = ACTIONS(4288),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4288),
    [anon_sym_u2287] = ACTIONS(4288),
    [sym_compose] = ACTIONS(4288),
    [sym_map_to] = ACTIONS(4288),
    [sym_map_from] = ACTIONS(4288),
    [sym_setminus] = ACTIONS(4290),
    [anon_sym_BSLASHcap] = ACTIONS(4288),
    [anon_sym_BSLASHintersect] = ACTIONS(4288),
    [anon_sym_u2229] = ACTIONS(4288),
    [anon_sym_BSLASHcup] = ACTIONS(4288),
    [anon_sym_BSLASHunion] = ACTIONS(4288),
    [anon_sym_u222a] = ACTIONS(4288),
    [anon_sym_DOT_DOT] = ACTIONS(4290),
    [anon_sym_u2025] = ACTIONS(4288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4288),
    [anon_sym_u2026] = ACTIONS(4288),
    [anon_sym_PLUS] = ACTIONS(4290),
    [sym_plusplus] = ACTIONS(4288),
    [anon_sym_BSLASHoplus] = ACTIONS(4288),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4288),
    [anon_sym_u2295] = ACTIONS(4288),
    [anon_sym_BSLASHominus] = ACTIONS(4288),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4288),
    [anon_sym_u2296] = ACTIONS(4288),
    [sym_mod] = ACTIONS(4290),
    [sym_modmod] = ACTIONS(4288),
    [sym_vert] = ACTIONS(4290),
    [anon_sym_PIPE_PIPE] = ACTIONS(4288),
    [anon_sym_u2016] = ACTIONS(4288),
    [sym_minusminus] = ACTIONS(4288),
    [sym_amp] = ACTIONS(4290),
    [sym_ampamp] = ACTIONS(4288),
    [anon_sym_BSLASHodot] = ACTIONS(4288),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4288),
    [anon_sym_u2299] = ACTIONS(4288),
    [anon_sym_BSLASHoslash] = ACTIONS(4288),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4288),
    [anon_sym_u2298] = ACTIONS(4288),
    [anon_sym_BSLASHotimes] = ACTIONS(4288),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4288),
    [anon_sym_u2297] = ACTIONS(4288),
    [sym_mul] = ACTIONS(4290),
    [sym_mulmul] = ACTIONS(4288),
    [sym_slash] = ACTIONS(4290),
    [sym_slashslash] = ACTIONS(4288),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4288),
    [anon_sym_u25ef] = ACTIONS(4288),
    [anon_sym_BSLASHbullet] = ACTIONS(4288),
    [anon_sym_u25cf] = ACTIONS(4288),
    [anon_sym_BSLASHdiv] = ACTIONS(4288),
    [anon_sym_u00f7] = ACTIONS(4288),
    [anon_sym_BSLASHcirc] = ACTIONS(4288),
    [anon_sym_u2218] = ACTIONS(4288),
    [anon_sym_BSLASHstar] = ACTIONS(4288),
    [anon_sym_u22c6] = ACTIONS(4288),
    [anon_sym_u203c] = ACTIONS(4288),
    [sym_hashhash] = ACTIONS(4288),
    [sym_dol] = ACTIONS(4290),
    [sym_doldol] = ACTIONS(4288),
    [anon_sym_QMARK_QMARK] = ACTIONS(4288),
    [anon_sym_u2047] = ACTIONS(4288),
    [anon_sym_BSLASHsqcap] = ACTIONS(4288),
    [anon_sym_u2293] = ACTIONS(4288),
    [anon_sym_BSLASHsqcup] = ACTIONS(4288),
    [anon_sym_u2294] = ACTIONS(4288),
    [anon_sym_BSLASHuplus] = ACTIONS(4288),
    [anon_sym_u228e] = ACTIONS(4288),
    [anon_sym_BSLASHX] = ACTIONS(4288),
    [anon_sym_BSLASHtimes] = ACTIONS(4288),
    [anon_sym_u00d7] = ACTIONS(4288),
    [anon_sym_BSLASHwr] = ACTIONS(4288),
    [anon_sym_u2240] = ACTIONS(4288),
    [anon_sym_BSLASHcdot] = ACTIONS(4288),
    [anon_sym_u22c5] = ACTIONS(4288),
    [sym_pow] = ACTIONS(4290),
    [sym_powpow] = ACTIONS(4288),
    [anon_sym_CARET_PLUS] = ACTIONS(4288),
    [anon_sym_u207a] = ACTIONS(4288),
    [sym_asterisk] = ACTIONS(4288),
    [sym_sup_hash] = ACTIONS(4288),
    [sym_prime] = ACTIONS(4288),
    [sym__indent] = ACTIONS(4288),
    [sym__begin_proof_step] = ACTIONS(4288),
    [sym__double_excl] = ACTIONS(4288),
  },
  [2132] = {
    [sym_block_comment] = STATE(2132),
    [sym_identifier] = ACTIONS(4286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4286),
    [anon_sym_u2208] = ACTIONS(4284),
    [anon_sym_BSLASHA] = ACTIONS(4286),
    [anon_sym_BSLASHforall] = ACTIONS(4284),
    [anon_sym_u2200] = ACTIONS(4284),
    [anon_sym_BSLASHE] = ACTIONS(4286),
    [anon_sym_BSLASHexists] = ACTIONS(4284),
    [anon_sym_u2203] = ACTIONS(4284),
    [sym_temporal_forall] = ACTIONS(4284),
    [sym_temporal_exists] = ACTIONS(4284),
    [anon_sym_LT_LT] = ACTIONS(4284),
    [anon_sym_u3008] = ACTIONS(4284),
    [anon_sym_u27e8] = ACTIONS(4284),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4284),
    [anon_sym_u25a1] = ACTIONS(4284),
    [anon_sym_AT] = ACTIONS(4286),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4284),
    [anon_sym_u2227] = ACTIONS(4284),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4284),
    [anon_sym_u2228] = ACTIONS(4284),
    [anon_sym_COMMA] = ACTIONS(4284),
    [anon_sym_LPAREN] = ACTIONS(4286),
    [anon_sym_LBRACK] = ACTIONS(4286),
    [anon_sym_BANG] = ACTIONS(4284),
    [aux_sym_child_id_token1] = ACTIONS(4286),
    [sym_real_number] = ACTIONS(4284),
    [anon_sym_BSLASHb] = ACTIONS(4286),
    [anon_sym_BSLASHB] = ACTIONS(4284),
    [anon_sym_BSLASHo] = ACTIONS(4286),
    [anon_sym_BSLASHO] = ACTIONS(4284),
    [anon_sym_BSLASHh] = ACTIONS(4284),
    [anon_sym_BSLASHH] = ACTIONS(4284),
    [anon_sym_DQUOTE] = ACTIONS(4284),
    [anon_sym_TRUE] = ACTIONS(4286),
    [anon_sym_FALSE] = ACTIONS(4286),
    [sym_string_set] = ACTIONS(4286),
    [sym_boolean_set] = ACTIONS(4286),
    [anon_sym_Nat] = ACTIONS(4286),
    [anon_sym_u2115] = ACTIONS(4284),
    [anon_sym_Int] = ACTIONS(4286),
    [anon_sym_u2124] = ACTIONS(4284),
    [anon_sym_Real] = ACTIONS(4286),
    [anon_sym_u211d] = ACTIONS(4284),
    [anon_sym_CHOOSE] = ACTIONS(4286),
    [anon_sym_LBRACE] = ACTIONS(4284),
    [anon_sym_EQ] = ACTIONS(4286),
    [anon_sym_WF_] = ACTIONS(4286),
    [anon_sym_SF_] = ACTIONS(4286),
    [anon_sym_IF] = ACTIONS(4286),
    [anon_sym_CASE] = ACTIONS(4286),
    [anon_sym_LET] = ACTIONS(4286),
    [anon_sym_BSLASHlnot] = ACTIONS(4284),
    [anon_sym_BSLASHneg] = ACTIONS(4284),
    [anon_sym_TILDE] = ACTIONS(4286),
    [anon_sym_u00ac] = ACTIONS(4284),
    [sym_union] = ACTIONS(4286),
    [sym_powerset] = ACTIONS(4286),
    [sym_domain] = ACTIONS(4286),
    [anon_sym_DASH] = ACTIONS(4286),
    [sym_negative_dot] = ACTIONS(4284),
    [sym_enabled] = ACTIONS(4286),
    [sym_unchanged] = ACTIONS(4286),
    [anon_sym_LT_GT] = ACTIONS(4284),
    [anon_sym_u22c4] = ACTIONS(4284),
    [anon_sym_u25c7] = ACTIONS(4284),
    [anon_sym_EQ_GT] = ACTIONS(4284),
    [anon_sym_u27f9] = ACTIONS(4284),
    [anon_sym_u21d2] = ACTIONS(4284),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4284),
    [anon_sym_u21f8] = ACTIONS(4284),
    [anon_sym_u2945] = ACTIONS(4284),
    [anon_sym_BSLASHequiv] = ACTIONS(4284),
    [anon_sym_u2261] = ACTIONS(4284),
    [anon_sym_LT_EQ_GT] = ACTIONS(4284),
    [anon_sym_u27fa] = ACTIONS(4284),
    [anon_sym_u21d4] = ACTIONS(4284),
    [anon_sym_TILDE_GT] = ACTIONS(4284),
    [anon_sym_u21dd] = ACTIONS(4284),
    [anon_sym_u219d] = ACTIONS(4284),
    [anon_sym_BSLASHland] = ACTIONS(4284),
    [anon_sym_BSLASHlor] = ACTIONS(4284),
    [anon_sym_COLON_EQ] = ACTIONS(4284),
    [anon_sym_u2254] = ACTIONS(4284),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4284),
    [anon_sym_u2a74] = ACTIONS(4284),
    [anon_sym_SLASH_EQ] = ACTIONS(4284),
    [anon_sym_POUND] = ACTIONS(4286),
    [anon_sym_u2260] = ACTIONS(4284),
    [anon_sym_LT] = ACTIONS(4286),
    [sym_gt] = ACTIONS(4286),
    [anon_sym_LT_EQ] = ACTIONS(4286),
    [anon_sym_EQ_LT] = ACTIONS(4284),
    [anon_sym_BSLASHleq] = ACTIONS(4284),
    [anon_sym_u2264] = ACTIONS(4284),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_BSLASHgeq] = ACTIONS(4284),
    [anon_sym_u2265] = ACTIONS(4284),
    [anon_sym_BSLASHapprox] = ACTIONS(4284),
    [anon_sym_u2248] = ACTIONS(4284),
    [anon_sym_PIPE_DASH] = ACTIONS(4284),
    [anon_sym_u22a2] = ACTIONS(4284),
    [anon_sym_PIPE_EQ] = ACTIONS(4284),
    [anon_sym_u22a8] = ACTIONS(4284),
    [anon_sym_DASH_PIPE] = ACTIONS(4284),
    [anon_sym_u22a3] = ACTIONS(4284),
    [anon_sym_EQ_PIPE] = ACTIONS(4284),
    [anon_sym_u2ae4] = ACTIONS(4284),
    [anon_sym_BSLASHasymp] = ACTIONS(4284),
    [anon_sym_u224d] = ACTIONS(4284),
    [anon_sym_BSLASHcong] = ACTIONS(4284),
    [anon_sym_u2245] = ACTIONS(4284),
    [anon_sym_BSLASHdoteq] = ACTIONS(4284),
    [anon_sym_u2250] = ACTIONS(4284),
    [anon_sym_BSLASHgg] = ACTIONS(4284),
    [anon_sym_u226b] = ACTIONS(4284),
    [anon_sym_BSLASHll] = ACTIONS(4284),
    [anon_sym_u226a] = ACTIONS(4284),
    [anon_sym_BSLASHnotin] = ACTIONS(4284),
    [anon_sym_u2209] = ACTIONS(4284),
    [anon_sym_BSLASHprec] = ACTIONS(4286),
    [anon_sym_u227a] = ACTIONS(4284),
    [anon_sym_BSLASHsucc] = ACTIONS(4286),
    [anon_sym_u227b] = ACTIONS(4284),
    [anon_sym_BSLASHpreceq] = ACTIONS(4284),
    [anon_sym_u2aaf] = ACTIONS(4284),
    [anon_sym_BSLASHsucceq] = ACTIONS(4284),
    [anon_sym_u2ab0] = ACTIONS(4284),
    [anon_sym_BSLASHpropto] = ACTIONS(4284),
    [anon_sym_u221d] = ACTIONS(4284),
    [anon_sym_BSLASHsim] = ACTIONS(4286),
    [anon_sym_u223c] = ACTIONS(4284),
    [anon_sym_BSLASHsimeq] = ACTIONS(4284),
    [anon_sym_u2243] = ACTIONS(4284),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4286),
    [anon_sym_u228f] = ACTIONS(4284),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4286),
    [anon_sym_u2290] = ACTIONS(4284),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4284),
    [anon_sym_u2291] = ACTIONS(4284),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4284),
    [anon_sym_u2292] = ACTIONS(4284),
    [anon_sym_BSLASHsubset] = ACTIONS(4286),
    [anon_sym_u2282] = ACTIONS(4284),
    [anon_sym_BSLASHsupset] = ACTIONS(4286),
    [anon_sym_u2283] = ACTIONS(4284),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4284),
    [anon_sym_u2286] = ACTIONS(4284),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4284),
    [anon_sym_u2287] = ACTIONS(4284),
    [sym_compose] = ACTIONS(4284),
    [sym_map_to] = ACTIONS(4284),
    [sym_map_from] = ACTIONS(4284),
    [sym_setminus] = ACTIONS(4286),
    [anon_sym_BSLASHcap] = ACTIONS(4284),
    [anon_sym_BSLASHintersect] = ACTIONS(4284),
    [anon_sym_u2229] = ACTIONS(4284),
    [anon_sym_BSLASHcup] = ACTIONS(4284),
    [anon_sym_BSLASHunion] = ACTIONS(4284),
    [anon_sym_u222a] = ACTIONS(4284),
    [anon_sym_DOT_DOT] = ACTIONS(4286),
    [anon_sym_u2025] = ACTIONS(4284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4284),
    [anon_sym_u2026] = ACTIONS(4284),
    [anon_sym_PLUS] = ACTIONS(4286),
    [sym_plusplus] = ACTIONS(4284),
    [anon_sym_BSLASHoplus] = ACTIONS(4284),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4284),
    [anon_sym_u2295] = ACTIONS(4284),
    [anon_sym_BSLASHominus] = ACTIONS(4284),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4284),
    [anon_sym_u2296] = ACTIONS(4284),
    [sym_mod] = ACTIONS(4286),
    [sym_modmod] = ACTIONS(4284),
    [sym_vert] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(4284),
    [anon_sym_u2016] = ACTIONS(4284),
    [sym_minusminus] = ACTIONS(4284),
    [sym_amp] = ACTIONS(4286),
    [sym_ampamp] = ACTIONS(4284),
    [anon_sym_BSLASHodot] = ACTIONS(4284),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4284),
    [anon_sym_u2299] = ACTIONS(4284),
    [anon_sym_BSLASHoslash] = ACTIONS(4284),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4284),
    [anon_sym_u2298] = ACTIONS(4284),
    [anon_sym_BSLASHotimes] = ACTIONS(4284),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4284),
    [anon_sym_u2297] = ACTIONS(4284),
    [sym_mul] = ACTIONS(4286),
    [sym_mulmul] = ACTIONS(4284),
    [sym_slash] = ACTIONS(4286),
    [sym_slashslash] = ACTIONS(4284),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4284),
    [anon_sym_u25ef] = ACTIONS(4284),
    [anon_sym_BSLASHbullet] = ACTIONS(4284),
    [anon_sym_u25cf] = ACTIONS(4284),
    [anon_sym_BSLASHdiv] = ACTIONS(4284),
    [anon_sym_u00f7] = ACTIONS(4284),
    [anon_sym_BSLASHcirc] = ACTIONS(4284),
    [anon_sym_u2218] = ACTIONS(4284),
    [anon_sym_BSLASHstar] = ACTIONS(4284),
    [anon_sym_u22c6] = ACTIONS(4284),
    [anon_sym_u203c] = ACTIONS(4284),
    [sym_hashhash] = ACTIONS(4284),
    [sym_dol] = ACTIONS(4286),
    [sym_doldol] = ACTIONS(4284),
    [anon_sym_QMARK_QMARK] = ACTIONS(4284),
    [anon_sym_u2047] = ACTIONS(4284),
    [anon_sym_BSLASHsqcap] = ACTIONS(4284),
    [anon_sym_u2293] = ACTIONS(4284),
    [anon_sym_BSLASHsqcup] = ACTIONS(4284),
    [anon_sym_u2294] = ACTIONS(4284),
    [anon_sym_BSLASHuplus] = ACTIONS(4284),
    [anon_sym_u228e] = ACTIONS(4284),
    [anon_sym_BSLASHX] = ACTIONS(4284),
    [anon_sym_BSLASHtimes] = ACTIONS(4284),
    [anon_sym_u00d7] = ACTIONS(4284),
    [anon_sym_BSLASHwr] = ACTIONS(4284),
    [anon_sym_u2240] = ACTIONS(4284),
    [anon_sym_BSLASHcdot] = ACTIONS(4284),
    [anon_sym_u22c5] = ACTIONS(4284),
    [sym_pow] = ACTIONS(4286),
    [sym_powpow] = ACTIONS(4284),
    [anon_sym_CARET_PLUS] = ACTIONS(4284),
    [anon_sym_u207a] = ACTIONS(4284),
    [sym_asterisk] = ACTIONS(4284),
    [sym_sup_hash] = ACTIONS(4284),
    [sym_prime] = ACTIONS(4284),
    [sym__indent] = ACTIONS(4284),
    [sym__begin_proof_step] = ACTIONS(4284),
    [sym__double_excl] = ACTIONS(4284),
  },
  [2133] = {
    [sym_block_comment] = STATE(2133),
    [sym_identifier] = ACTIONS(4271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4271),
    [anon_sym_u2208] = ACTIONS(4273),
    [anon_sym_BSLASHA] = ACTIONS(4271),
    [anon_sym_BSLASHforall] = ACTIONS(4273),
    [anon_sym_u2200] = ACTIONS(4273),
    [anon_sym_BSLASHE] = ACTIONS(4271),
    [anon_sym_BSLASHexists] = ACTIONS(4273),
    [anon_sym_u2203] = ACTIONS(4273),
    [sym_temporal_forall] = ACTIONS(4273),
    [sym_temporal_exists] = ACTIONS(4273),
    [anon_sym_LT_LT] = ACTIONS(4273),
    [anon_sym_u3008] = ACTIONS(4273),
    [anon_sym_u27e8] = ACTIONS(4273),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4273),
    [anon_sym_u25a1] = ACTIONS(4273),
    [anon_sym_AT] = ACTIONS(4271),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4273),
    [anon_sym_u2227] = ACTIONS(4273),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4273),
    [anon_sym_u2228] = ACTIONS(4273),
    [anon_sym_COMMA] = ACTIONS(4269),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [anon_sym_LBRACK] = ACTIONS(4271),
    [anon_sym_BANG] = ACTIONS(4269),
    [aux_sym_child_id_token1] = ACTIONS(4271),
    [sym_real_number] = ACTIONS(4273),
    [anon_sym_BSLASHb] = ACTIONS(4271),
    [anon_sym_BSLASHB] = ACTIONS(4273),
    [anon_sym_BSLASHo] = ACTIONS(4271),
    [anon_sym_BSLASHO] = ACTIONS(4273),
    [anon_sym_BSLASHh] = ACTIONS(4273),
    [anon_sym_BSLASHH] = ACTIONS(4273),
    [anon_sym_DQUOTE] = ACTIONS(4273),
    [anon_sym_TRUE] = ACTIONS(4271),
    [anon_sym_FALSE] = ACTIONS(4271),
    [sym_string_set] = ACTIONS(4271),
    [sym_boolean_set] = ACTIONS(4271),
    [anon_sym_Nat] = ACTIONS(4271),
    [anon_sym_u2115] = ACTIONS(4273),
    [anon_sym_Int] = ACTIONS(4271),
    [anon_sym_u2124] = ACTIONS(4273),
    [anon_sym_Real] = ACTIONS(4271),
    [anon_sym_u211d] = ACTIONS(4273),
    [anon_sym_CHOOSE] = ACTIONS(4271),
    [anon_sym_LBRACE] = ACTIONS(4273),
    [anon_sym_EQ] = ACTIONS(4271),
    [anon_sym_WF_] = ACTIONS(4271),
    [anon_sym_SF_] = ACTIONS(4271),
    [anon_sym_IF] = ACTIONS(4271),
    [anon_sym_CASE] = ACTIONS(4271),
    [anon_sym_LET] = ACTIONS(4271),
    [anon_sym_BSLASHlnot] = ACTIONS(4273),
    [anon_sym_BSLASHneg] = ACTIONS(4273),
    [anon_sym_TILDE] = ACTIONS(4271),
    [anon_sym_u00ac] = ACTIONS(4273),
    [sym_union] = ACTIONS(4271),
    [sym_powerset] = ACTIONS(4271),
    [sym_domain] = ACTIONS(4271),
    [anon_sym_DASH] = ACTIONS(4271),
    [sym_negative_dot] = ACTIONS(4273),
    [sym_enabled] = ACTIONS(4271),
    [sym_unchanged] = ACTIONS(4271),
    [anon_sym_LT_GT] = ACTIONS(4273),
    [anon_sym_u22c4] = ACTIONS(4273),
    [anon_sym_u25c7] = ACTIONS(4273),
    [anon_sym_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27f9] = ACTIONS(4273),
    [anon_sym_u21d2] = ACTIONS(4273),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4273),
    [anon_sym_u21f8] = ACTIONS(4273),
    [anon_sym_u2945] = ACTIONS(4273),
    [anon_sym_BSLASHequiv] = ACTIONS(4273),
    [anon_sym_u2261] = ACTIONS(4273),
    [anon_sym_LT_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27fa] = ACTIONS(4273),
    [anon_sym_u21d4] = ACTIONS(4273),
    [anon_sym_TILDE_GT] = ACTIONS(4273),
    [anon_sym_u21dd] = ACTIONS(4273),
    [anon_sym_u219d] = ACTIONS(4273),
    [anon_sym_BSLASHland] = ACTIONS(4273),
    [anon_sym_BSLASHlor] = ACTIONS(4273),
    [anon_sym_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2254] = ACTIONS(4273),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2a74] = ACTIONS(4273),
    [anon_sym_SLASH_EQ] = ACTIONS(4273),
    [anon_sym_POUND] = ACTIONS(4271),
    [anon_sym_u2260] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4271),
    [sym_gt] = ACTIONS(4271),
    [anon_sym_LT_EQ] = ACTIONS(4271),
    [anon_sym_EQ_LT] = ACTIONS(4273),
    [anon_sym_BSLASHleq] = ACTIONS(4273),
    [anon_sym_u2264] = ACTIONS(4273),
    [anon_sym_GT_EQ] = ACTIONS(4273),
    [anon_sym_BSLASHgeq] = ACTIONS(4273),
    [anon_sym_u2265] = ACTIONS(4273),
    [anon_sym_BSLASHapprox] = ACTIONS(4273),
    [anon_sym_u2248] = ACTIONS(4273),
    [anon_sym_PIPE_DASH] = ACTIONS(4273),
    [anon_sym_u22a2] = ACTIONS(4273),
    [anon_sym_PIPE_EQ] = ACTIONS(4273),
    [anon_sym_u22a8] = ACTIONS(4273),
    [anon_sym_DASH_PIPE] = ACTIONS(4273),
    [anon_sym_u22a3] = ACTIONS(4273),
    [anon_sym_EQ_PIPE] = ACTIONS(4273),
    [anon_sym_u2ae4] = ACTIONS(4273),
    [anon_sym_BSLASHasymp] = ACTIONS(4273),
    [anon_sym_u224d] = ACTIONS(4273),
    [anon_sym_BSLASHcong] = ACTIONS(4273),
    [anon_sym_u2245] = ACTIONS(4273),
    [anon_sym_BSLASHdoteq] = ACTIONS(4273),
    [anon_sym_u2250] = ACTIONS(4273),
    [anon_sym_BSLASHgg] = ACTIONS(4273),
    [anon_sym_u226b] = ACTIONS(4273),
    [anon_sym_BSLASHll] = ACTIONS(4273),
    [anon_sym_u226a] = ACTIONS(4273),
    [anon_sym_BSLASHnotin] = ACTIONS(4273),
    [anon_sym_u2209] = ACTIONS(4273),
    [anon_sym_BSLASHprec] = ACTIONS(4271),
    [anon_sym_u227a] = ACTIONS(4273),
    [anon_sym_BSLASHsucc] = ACTIONS(4271),
    [anon_sym_u227b] = ACTIONS(4273),
    [anon_sym_BSLASHpreceq] = ACTIONS(4273),
    [anon_sym_u2aaf] = ACTIONS(4273),
    [anon_sym_BSLASHsucceq] = ACTIONS(4273),
    [anon_sym_u2ab0] = ACTIONS(4273),
    [anon_sym_BSLASHpropto] = ACTIONS(4273),
    [anon_sym_u221d] = ACTIONS(4273),
    [anon_sym_BSLASHsim] = ACTIONS(4271),
    [anon_sym_u223c] = ACTIONS(4273),
    [anon_sym_BSLASHsimeq] = ACTIONS(4273),
    [anon_sym_u2243] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4271),
    [anon_sym_u228f] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4271),
    [anon_sym_u2290] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4273),
    [anon_sym_u2291] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4273),
    [anon_sym_u2292] = ACTIONS(4273),
    [anon_sym_BSLASHsubset] = ACTIONS(4271),
    [anon_sym_u2282] = ACTIONS(4273),
    [anon_sym_BSLASHsupset] = ACTIONS(4271),
    [anon_sym_u2283] = ACTIONS(4273),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4273),
    [anon_sym_u2286] = ACTIONS(4273),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4273),
    [anon_sym_u2287] = ACTIONS(4273),
    [sym_compose] = ACTIONS(4273),
    [sym_map_to] = ACTIONS(4273),
    [sym_map_from] = ACTIONS(4273),
    [sym_setminus] = ACTIONS(4271),
    [anon_sym_BSLASHcap] = ACTIONS(4273),
    [anon_sym_BSLASHintersect] = ACTIONS(4273),
    [anon_sym_u2229] = ACTIONS(4273),
    [anon_sym_BSLASHcup] = ACTIONS(4273),
    [anon_sym_BSLASHunion] = ACTIONS(4273),
    [anon_sym_u222a] = ACTIONS(4273),
    [anon_sym_DOT_DOT] = ACTIONS(4271),
    [anon_sym_u2025] = ACTIONS(4273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4273),
    [anon_sym_u2026] = ACTIONS(4273),
    [anon_sym_PLUS] = ACTIONS(4271),
    [sym_plusplus] = ACTIONS(4273),
    [anon_sym_BSLASHoplus] = ACTIONS(4273),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4273),
    [anon_sym_u2295] = ACTIONS(4273),
    [anon_sym_BSLASHominus] = ACTIONS(4273),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2296] = ACTIONS(4273),
    [sym_mod] = ACTIONS(4271),
    [sym_modmod] = ACTIONS(4273),
    [sym_vert] = ACTIONS(4271),
    [anon_sym_PIPE_PIPE] = ACTIONS(4273),
    [anon_sym_u2016] = ACTIONS(4273),
    [sym_minusminus] = ACTIONS(4273),
    [sym_amp] = ACTIONS(4271),
    [sym_ampamp] = ACTIONS(4273),
    [anon_sym_BSLASHodot] = ACTIONS(4273),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4273),
    [anon_sym_u2299] = ACTIONS(4273),
    [anon_sym_BSLASHoslash] = ACTIONS(4273),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2298] = ACTIONS(4273),
    [anon_sym_BSLASHotimes] = ACTIONS(4273),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4273),
    [anon_sym_u2297] = ACTIONS(4273),
    [sym_mul] = ACTIONS(4271),
    [sym_mulmul] = ACTIONS(4273),
    [sym_slash] = ACTIONS(4271),
    [sym_slashslash] = ACTIONS(4273),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4273),
    [anon_sym_u25ef] = ACTIONS(4273),
    [anon_sym_BSLASHbullet] = ACTIONS(4273),
    [anon_sym_u25cf] = ACTIONS(4273),
    [anon_sym_BSLASHdiv] = ACTIONS(4273),
    [anon_sym_u00f7] = ACTIONS(4273),
    [anon_sym_BSLASHcirc] = ACTIONS(4273),
    [anon_sym_u2218] = ACTIONS(4273),
    [anon_sym_BSLASHstar] = ACTIONS(4273),
    [anon_sym_u22c6] = ACTIONS(4273),
    [anon_sym_u203c] = ACTIONS(4273),
    [sym_hashhash] = ACTIONS(4273),
    [sym_dol] = ACTIONS(4271),
    [sym_doldol] = ACTIONS(4273),
    [anon_sym_QMARK_QMARK] = ACTIONS(4273),
    [anon_sym_u2047] = ACTIONS(4273),
    [anon_sym_BSLASHsqcap] = ACTIONS(4273),
    [anon_sym_u2293] = ACTIONS(4273),
    [anon_sym_BSLASHsqcup] = ACTIONS(4273),
    [anon_sym_u2294] = ACTIONS(4273),
    [anon_sym_BSLASHuplus] = ACTIONS(4273),
    [anon_sym_u228e] = ACTIONS(4273),
    [anon_sym_BSLASHX] = ACTIONS(4273),
    [anon_sym_BSLASHtimes] = ACTIONS(4273),
    [anon_sym_u00d7] = ACTIONS(4273),
    [anon_sym_BSLASHwr] = ACTIONS(4273),
    [anon_sym_u2240] = ACTIONS(4273),
    [anon_sym_BSLASHcdot] = ACTIONS(4273),
    [anon_sym_u22c5] = ACTIONS(4273),
    [sym_pow] = ACTIONS(4271),
    [sym_powpow] = ACTIONS(4273),
    [anon_sym_CARET_PLUS] = ACTIONS(4273),
    [anon_sym_u207a] = ACTIONS(4273),
    [sym_asterisk] = ACTIONS(4273),
    [sym_sup_hash] = ACTIONS(4273),
    [sym_prime] = ACTIONS(4273),
    [sym__indent] = ACTIONS(4273),
    [sym__begin_proof_step] = ACTIONS(4269),
    [sym__double_excl] = ACTIONS(4273),
  },
  [2134] = {
    [sym_block_comment] = STATE(2134),
    [sym_identifier] = ACTIONS(4266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4271),
    [anon_sym_u2208] = ACTIONS(4273),
    [anon_sym_BSLASHA] = ACTIONS(4271),
    [anon_sym_BSLASHforall] = ACTIONS(4273),
    [anon_sym_u2200] = ACTIONS(4273),
    [anon_sym_BSLASHE] = ACTIONS(4271),
    [anon_sym_BSLASHexists] = ACTIONS(4273),
    [anon_sym_u2203] = ACTIONS(4273),
    [sym_temporal_forall] = ACTIONS(4273),
    [sym_temporal_exists] = ACTIONS(4273),
    [anon_sym_LT_LT] = ACTIONS(4273),
    [anon_sym_u3008] = ACTIONS(4273),
    [anon_sym_u27e8] = ACTIONS(4273),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4275),
    [anon_sym_u25a1] = ACTIONS(4275),
    [anon_sym_AT] = ACTIONS(4271),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4273),
    [anon_sym_u2227] = ACTIONS(4273),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4273),
    [anon_sym_u2228] = ACTIONS(4273),
    [anon_sym_COMMA] = ACTIONS(4269),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [anon_sym_LBRACK] = ACTIONS(4271),
    [anon_sym_BANG] = ACTIONS(4269),
    [aux_sym_child_id_token1] = ACTIONS(4271),
    [sym_real_number] = ACTIONS(4273),
    [anon_sym_BSLASHb] = ACTIONS(4271),
    [anon_sym_BSLASHB] = ACTIONS(4273),
    [anon_sym_BSLASHo] = ACTIONS(4271),
    [anon_sym_BSLASHO] = ACTIONS(4273),
    [anon_sym_BSLASHh] = ACTIONS(4273),
    [anon_sym_BSLASHH] = ACTIONS(4273),
    [anon_sym_DQUOTE] = ACTIONS(4273),
    [anon_sym_TRUE] = ACTIONS(4271),
    [anon_sym_FALSE] = ACTIONS(4271),
    [sym_string_set] = ACTIONS(4271),
    [sym_boolean_set] = ACTIONS(4271),
    [anon_sym_Nat] = ACTIONS(4266),
    [anon_sym_u2115] = ACTIONS(4275),
    [anon_sym_Int] = ACTIONS(4266),
    [anon_sym_u2124] = ACTIONS(4275),
    [anon_sym_Real] = ACTIONS(4266),
    [anon_sym_u211d] = ACTIONS(4275),
    [anon_sym_CHOOSE] = ACTIONS(4271),
    [anon_sym_LBRACE] = ACTIONS(4273),
    [anon_sym_EQ] = ACTIONS(4271),
    [anon_sym_WF_] = ACTIONS(4271),
    [anon_sym_SF_] = ACTIONS(4271),
    [anon_sym_IF] = ACTIONS(4271),
    [anon_sym_CASE] = ACTIONS(4271),
    [anon_sym_LET] = ACTIONS(4271),
    [anon_sym_BSLASHlnot] = ACTIONS(4275),
    [anon_sym_BSLASHneg] = ACTIONS(4275),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_u00ac] = ACTIONS(4275),
    [sym_union] = ACTIONS(4266),
    [sym_powerset] = ACTIONS(4266),
    [sym_domain] = ACTIONS(4266),
    [anon_sym_DASH] = ACTIONS(4271),
    [sym_negative_dot] = ACTIONS(4275),
    [sym_enabled] = ACTIONS(4266),
    [sym_unchanged] = ACTIONS(4266),
    [anon_sym_LT_GT] = ACTIONS(4275),
    [anon_sym_u22c4] = ACTIONS(4275),
    [anon_sym_u25c7] = ACTIONS(4275),
    [anon_sym_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27f9] = ACTIONS(4273),
    [anon_sym_u21d2] = ACTIONS(4273),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4273),
    [anon_sym_u21f8] = ACTIONS(4273),
    [anon_sym_u2945] = ACTIONS(4273),
    [anon_sym_BSLASHequiv] = ACTIONS(4273),
    [anon_sym_u2261] = ACTIONS(4273),
    [anon_sym_LT_EQ_GT] = ACTIONS(4273),
    [anon_sym_u27fa] = ACTIONS(4273),
    [anon_sym_u21d4] = ACTIONS(4273),
    [anon_sym_TILDE_GT] = ACTIONS(4273),
    [anon_sym_u21dd] = ACTIONS(4273),
    [anon_sym_u219d] = ACTIONS(4273),
    [anon_sym_BSLASHland] = ACTIONS(4273),
    [anon_sym_BSLASHlor] = ACTIONS(4273),
    [anon_sym_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2254] = ACTIONS(4273),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4273),
    [anon_sym_u2a74] = ACTIONS(4273),
    [anon_sym_SLASH_EQ] = ACTIONS(4273),
    [anon_sym_POUND] = ACTIONS(4271),
    [anon_sym_u2260] = ACTIONS(4273),
    [anon_sym_LT] = ACTIONS(4271),
    [sym_gt] = ACTIONS(4271),
    [anon_sym_LT_EQ] = ACTIONS(4271),
    [anon_sym_EQ_LT] = ACTIONS(4273),
    [anon_sym_BSLASHleq] = ACTIONS(4273),
    [anon_sym_u2264] = ACTIONS(4273),
    [anon_sym_GT_EQ] = ACTIONS(4273),
    [anon_sym_BSLASHgeq] = ACTIONS(4273),
    [anon_sym_u2265] = ACTIONS(4273),
    [anon_sym_BSLASHapprox] = ACTIONS(4273),
    [anon_sym_u2248] = ACTIONS(4273),
    [anon_sym_PIPE_DASH] = ACTIONS(4273),
    [anon_sym_u22a2] = ACTIONS(4273),
    [anon_sym_PIPE_EQ] = ACTIONS(4273),
    [anon_sym_u22a8] = ACTIONS(4273),
    [anon_sym_DASH_PIPE] = ACTIONS(4273),
    [anon_sym_u22a3] = ACTIONS(4273),
    [anon_sym_EQ_PIPE] = ACTIONS(4273),
    [anon_sym_u2ae4] = ACTIONS(4273),
    [anon_sym_BSLASHasymp] = ACTIONS(4273),
    [anon_sym_u224d] = ACTIONS(4273),
    [anon_sym_BSLASHcong] = ACTIONS(4273),
    [anon_sym_u2245] = ACTIONS(4273),
    [anon_sym_BSLASHdoteq] = ACTIONS(4273),
    [anon_sym_u2250] = ACTIONS(4273),
    [anon_sym_BSLASHgg] = ACTIONS(4273),
    [anon_sym_u226b] = ACTIONS(4273),
    [anon_sym_BSLASHll] = ACTIONS(4273),
    [anon_sym_u226a] = ACTIONS(4273),
    [anon_sym_BSLASHnotin] = ACTIONS(4273),
    [anon_sym_u2209] = ACTIONS(4273),
    [anon_sym_BSLASHprec] = ACTIONS(4271),
    [anon_sym_u227a] = ACTIONS(4273),
    [anon_sym_BSLASHsucc] = ACTIONS(4271),
    [anon_sym_u227b] = ACTIONS(4273),
    [anon_sym_BSLASHpreceq] = ACTIONS(4273),
    [anon_sym_u2aaf] = ACTIONS(4273),
    [anon_sym_BSLASHsucceq] = ACTIONS(4273),
    [anon_sym_u2ab0] = ACTIONS(4273),
    [anon_sym_BSLASHpropto] = ACTIONS(4273),
    [anon_sym_u221d] = ACTIONS(4273),
    [anon_sym_BSLASHsim] = ACTIONS(4271),
    [anon_sym_u223c] = ACTIONS(4273),
    [anon_sym_BSLASHsimeq] = ACTIONS(4273),
    [anon_sym_u2243] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4271),
    [anon_sym_u228f] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4271),
    [anon_sym_u2290] = ACTIONS(4273),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4273),
    [anon_sym_u2291] = ACTIONS(4273),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4273),
    [anon_sym_u2292] = ACTIONS(4273),
    [anon_sym_BSLASHsubset] = ACTIONS(4271),
    [anon_sym_u2282] = ACTIONS(4273),
    [anon_sym_BSLASHsupset] = ACTIONS(4271),
    [anon_sym_u2283] = ACTIONS(4273),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4273),
    [anon_sym_u2286] = ACTIONS(4273),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4273),
    [anon_sym_u2287] = ACTIONS(4273),
    [sym_compose] = ACTIONS(4273),
    [sym_map_to] = ACTIONS(4273),
    [sym_map_from] = ACTIONS(4273),
    [sym_setminus] = ACTIONS(4271),
    [anon_sym_BSLASHcap] = ACTIONS(4273),
    [anon_sym_BSLASHintersect] = ACTIONS(4273),
    [anon_sym_u2229] = ACTIONS(4273),
    [anon_sym_BSLASHcup] = ACTIONS(4273),
    [anon_sym_BSLASHunion] = ACTIONS(4273),
    [anon_sym_u222a] = ACTIONS(4273),
    [anon_sym_DOT_DOT] = ACTIONS(4271),
    [anon_sym_u2025] = ACTIONS(4273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4273),
    [anon_sym_u2026] = ACTIONS(4273),
    [anon_sym_PLUS] = ACTIONS(4271),
    [sym_plusplus] = ACTIONS(4273),
    [anon_sym_BSLASHoplus] = ACTIONS(4273),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4273),
    [anon_sym_u2295] = ACTIONS(4273),
    [anon_sym_BSLASHominus] = ACTIONS(4273),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2296] = ACTIONS(4273),
    [sym_mod] = ACTIONS(4271),
    [sym_modmod] = ACTIONS(4273),
    [sym_vert] = ACTIONS(4271),
    [anon_sym_PIPE_PIPE] = ACTIONS(4273),
    [anon_sym_u2016] = ACTIONS(4273),
    [sym_minusminus] = ACTIONS(4273),
    [sym_amp] = ACTIONS(4271),
    [sym_ampamp] = ACTIONS(4273),
    [anon_sym_BSLASHodot] = ACTIONS(4273),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4273),
    [anon_sym_u2299] = ACTIONS(4273),
    [anon_sym_BSLASHoslash] = ACTIONS(4273),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4273),
    [anon_sym_u2298] = ACTIONS(4273),
    [anon_sym_BSLASHotimes] = ACTIONS(4273),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4273),
    [anon_sym_u2297] = ACTIONS(4273),
    [sym_mul] = ACTIONS(4271),
    [sym_mulmul] = ACTIONS(4273),
    [sym_slash] = ACTIONS(4271),
    [sym_slashslash] = ACTIONS(4273),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4273),
    [anon_sym_u25ef] = ACTIONS(4273),
    [anon_sym_BSLASHbullet] = ACTIONS(4273),
    [anon_sym_u25cf] = ACTIONS(4273),
    [anon_sym_BSLASHdiv] = ACTIONS(4273),
    [anon_sym_u00f7] = ACTIONS(4273),
    [anon_sym_BSLASHcirc] = ACTIONS(4273),
    [anon_sym_u2218] = ACTIONS(4273),
    [anon_sym_BSLASHstar] = ACTIONS(4273),
    [anon_sym_u22c6] = ACTIONS(4273),
    [anon_sym_u203c] = ACTIONS(4273),
    [sym_hashhash] = ACTIONS(4273),
    [sym_dol] = ACTIONS(4271),
    [sym_doldol] = ACTIONS(4273),
    [anon_sym_QMARK_QMARK] = ACTIONS(4273),
    [anon_sym_u2047] = ACTIONS(4273),
    [anon_sym_BSLASHsqcap] = ACTIONS(4273),
    [anon_sym_u2293] = ACTIONS(4273),
    [anon_sym_BSLASHsqcup] = ACTIONS(4273),
    [anon_sym_u2294] = ACTIONS(4273),
    [anon_sym_BSLASHuplus] = ACTIONS(4273),
    [anon_sym_u228e] = ACTIONS(4273),
    [anon_sym_BSLASHX] = ACTIONS(4273),
    [anon_sym_BSLASHtimes] = ACTIONS(4273),
    [anon_sym_u00d7] = ACTIONS(4273),
    [anon_sym_BSLASHwr] = ACTIONS(4273),
    [anon_sym_u2240] = ACTIONS(4273),
    [anon_sym_BSLASHcdot] = ACTIONS(4273),
    [anon_sym_u22c5] = ACTIONS(4273),
    [sym_pow] = ACTIONS(4271),
    [sym_powpow] = ACTIONS(4273),
    [anon_sym_CARET_PLUS] = ACTIONS(4273),
    [anon_sym_u207a] = ACTIONS(4273),
    [sym_asterisk] = ACTIONS(4273),
    [sym_sup_hash] = ACTIONS(4273),
    [sym_prime] = ACTIONS(4273),
    [sym__indent] = ACTIONS(4273),
    [sym__begin_proof_step] = ACTIONS(4269),
    [sym__double_excl] = ACTIONS(4273),
  },
  [2135] = {
    [sym_block_comment] = STATE(2135),
    [sym_identifier] = ACTIONS(5353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5353),
    [anon_sym_u2208] = ACTIONS(5355),
    [anon_sym_BSLASHA] = ACTIONS(5353),
    [anon_sym_BSLASHforall] = ACTIONS(5355),
    [anon_sym_u2200] = ACTIONS(5355),
    [anon_sym_BSLASHE] = ACTIONS(5353),
    [anon_sym_BSLASHexists] = ACTIONS(5355),
    [anon_sym_u2203] = ACTIONS(5355),
    [sym_temporal_forall] = ACTIONS(5355),
    [sym_temporal_exists] = ACTIONS(5355),
    [anon_sym_LT_LT] = ACTIONS(5355),
    [anon_sym_u3008] = ACTIONS(5355),
    [anon_sym_u27e8] = ACTIONS(5355),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5355),
    [anon_sym_u25a1] = ACTIONS(5355),
    [anon_sym_AT] = ACTIONS(5353),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5355),
    [anon_sym_u2227] = ACTIONS(5355),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5355),
    [anon_sym_u2228] = ACTIONS(5355),
    [anon_sym_LPAREN] = ACTIONS(5353),
    [anon_sym_LBRACK] = ACTIONS(5353),
    [anon_sym_INSTANCE] = ACTIONS(5353),
    [aux_sym_child_id_token1] = ACTIONS(5353),
    [sym_real_number] = ACTIONS(5355),
    [anon_sym_BSLASHb] = ACTIONS(5353),
    [anon_sym_BSLASHB] = ACTIONS(5355),
    [anon_sym_BSLASHo] = ACTIONS(5353),
    [anon_sym_BSLASHO] = ACTIONS(5355),
    [anon_sym_BSLASHh] = ACTIONS(5355),
    [anon_sym_BSLASHH] = ACTIONS(5355),
    [anon_sym_DQUOTE] = ACTIONS(5355),
    [anon_sym_TRUE] = ACTIONS(5353),
    [anon_sym_FALSE] = ACTIONS(5353),
    [sym_string_set] = ACTIONS(5353),
    [sym_boolean_set] = ACTIONS(5353),
    [anon_sym_Nat] = ACTIONS(5353),
    [anon_sym_u2115] = ACTIONS(5355),
    [anon_sym_Int] = ACTIONS(5353),
    [anon_sym_u2124] = ACTIONS(5355),
    [anon_sym_Real] = ACTIONS(5353),
    [anon_sym_u211d] = ACTIONS(5355),
    [anon_sym_CHOOSE] = ACTIONS(5353),
    [anon_sym_LBRACE] = ACTIONS(5355),
    [anon_sym_EQ] = ACTIONS(5353),
    [anon_sym_WF_] = ACTIONS(5353),
    [anon_sym_SF_] = ACTIONS(5353),
    [anon_sym_IF] = ACTIONS(5353),
    [anon_sym_CASE] = ACTIONS(5353),
    [anon_sym_LET] = ACTIONS(5353),
    [anon_sym_BSLASHlnot] = ACTIONS(5355),
    [anon_sym_BSLASHneg] = ACTIONS(5355),
    [anon_sym_TILDE] = ACTIONS(5353),
    [anon_sym_u00ac] = ACTIONS(5355),
    [sym_union] = ACTIONS(5353),
    [sym_powerset] = ACTIONS(5353),
    [sym_domain] = ACTIONS(5353),
    [anon_sym_DASH] = ACTIONS(5353),
    [sym_negative_dot] = ACTIONS(5355),
    [sym_enabled] = ACTIONS(5353),
    [sym_unchanged] = ACTIONS(5353),
    [anon_sym_LT_GT] = ACTIONS(5355),
    [anon_sym_u22c4] = ACTIONS(5355),
    [anon_sym_u25c7] = ACTIONS(5355),
    [anon_sym_EQ_GT] = ACTIONS(5355),
    [anon_sym_u27f9] = ACTIONS(5355),
    [anon_sym_u21d2] = ACTIONS(5355),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5355),
    [anon_sym_u21f8] = ACTIONS(5355),
    [anon_sym_u2945] = ACTIONS(5355),
    [anon_sym_BSLASHequiv] = ACTIONS(5355),
    [anon_sym_u2261] = ACTIONS(5355),
    [anon_sym_LT_EQ_GT] = ACTIONS(5355),
    [anon_sym_u27fa] = ACTIONS(5355),
    [anon_sym_u21d4] = ACTIONS(5355),
    [anon_sym_TILDE_GT] = ACTIONS(5355),
    [anon_sym_u21dd] = ACTIONS(5355),
    [anon_sym_u219d] = ACTIONS(5355),
    [anon_sym_BSLASHland] = ACTIONS(5355),
    [anon_sym_BSLASHlor] = ACTIONS(5355),
    [anon_sym_COLON_EQ] = ACTIONS(5355),
    [anon_sym_u2254] = ACTIONS(5355),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5355),
    [anon_sym_u2a74] = ACTIONS(5355),
    [anon_sym_SLASH_EQ] = ACTIONS(5355),
    [anon_sym_POUND] = ACTIONS(5353),
    [anon_sym_u2260] = ACTIONS(5355),
    [anon_sym_LT] = ACTIONS(5353),
    [sym_gt] = ACTIONS(5353),
    [anon_sym_LT_EQ] = ACTIONS(5353),
    [anon_sym_EQ_LT] = ACTIONS(5355),
    [anon_sym_BSLASHleq] = ACTIONS(5355),
    [anon_sym_u2264] = ACTIONS(5355),
    [anon_sym_GT_EQ] = ACTIONS(5355),
    [anon_sym_BSLASHgeq] = ACTIONS(5355),
    [anon_sym_u2265] = ACTIONS(5355),
    [anon_sym_BSLASHapprox] = ACTIONS(5355),
    [anon_sym_u2248] = ACTIONS(5355),
    [anon_sym_PIPE_DASH] = ACTIONS(5355),
    [anon_sym_u22a2] = ACTIONS(5355),
    [anon_sym_PIPE_EQ] = ACTIONS(5355),
    [anon_sym_u22a8] = ACTIONS(5355),
    [anon_sym_DASH_PIPE] = ACTIONS(5355),
    [anon_sym_u22a3] = ACTIONS(5355),
    [anon_sym_EQ_PIPE] = ACTIONS(5355),
    [anon_sym_u2ae4] = ACTIONS(5355),
    [anon_sym_BSLASHasymp] = ACTIONS(5355),
    [anon_sym_u224d] = ACTIONS(5355),
    [anon_sym_BSLASHcong] = ACTIONS(5355),
    [anon_sym_u2245] = ACTIONS(5355),
    [anon_sym_BSLASHdoteq] = ACTIONS(5355),
    [anon_sym_u2250] = ACTIONS(5355),
    [anon_sym_BSLASHgg] = ACTIONS(5355),
    [anon_sym_u226b] = ACTIONS(5355),
    [anon_sym_BSLASHll] = ACTIONS(5355),
    [anon_sym_u226a] = ACTIONS(5355),
    [anon_sym_BSLASHnotin] = ACTIONS(5355),
    [anon_sym_u2209] = ACTIONS(5355),
    [anon_sym_BSLASHprec] = ACTIONS(5353),
    [anon_sym_u227a] = ACTIONS(5355),
    [anon_sym_BSLASHsucc] = ACTIONS(5353),
    [anon_sym_u227b] = ACTIONS(5355),
    [anon_sym_BSLASHpreceq] = ACTIONS(5355),
    [anon_sym_u2aaf] = ACTIONS(5355),
    [anon_sym_BSLASHsucceq] = ACTIONS(5355),
    [anon_sym_u2ab0] = ACTIONS(5355),
    [anon_sym_BSLASHpropto] = ACTIONS(5355),
    [anon_sym_u221d] = ACTIONS(5355),
    [anon_sym_BSLASHsim] = ACTIONS(5353),
    [anon_sym_u223c] = ACTIONS(5355),
    [anon_sym_BSLASHsimeq] = ACTIONS(5355),
    [anon_sym_u2243] = ACTIONS(5355),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5353),
    [anon_sym_u228f] = ACTIONS(5355),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5353),
    [anon_sym_u2290] = ACTIONS(5355),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5355),
    [anon_sym_u2291] = ACTIONS(5355),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5355),
    [anon_sym_u2292] = ACTIONS(5355),
    [anon_sym_BSLASHsubset] = ACTIONS(5353),
    [anon_sym_u2282] = ACTIONS(5355),
    [anon_sym_BSLASHsupset] = ACTIONS(5353),
    [anon_sym_u2283] = ACTIONS(5355),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5355),
    [anon_sym_u2286] = ACTIONS(5355),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5355),
    [anon_sym_u2287] = ACTIONS(5355),
    [sym_compose] = ACTIONS(5355),
    [sym_map_to] = ACTIONS(5355),
    [sym_map_from] = ACTIONS(5355),
    [sym_setminus] = ACTIONS(5353),
    [anon_sym_BSLASHcap] = ACTIONS(5355),
    [anon_sym_BSLASHintersect] = ACTIONS(5355),
    [anon_sym_u2229] = ACTIONS(5355),
    [anon_sym_BSLASHcup] = ACTIONS(5355),
    [anon_sym_BSLASHunion] = ACTIONS(5355),
    [anon_sym_u222a] = ACTIONS(5355),
    [anon_sym_DOT_DOT] = ACTIONS(5353),
    [anon_sym_u2025] = ACTIONS(5355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5355),
    [anon_sym_u2026] = ACTIONS(5355),
    [anon_sym_PLUS] = ACTIONS(5353),
    [sym_plusplus] = ACTIONS(5355),
    [anon_sym_BSLASHoplus] = ACTIONS(5355),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5355),
    [anon_sym_u2295] = ACTIONS(5355),
    [anon_sym_BSLASHominus] = ACTIONS(5355),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5355),
    [anon_sym_u2296] = ACTIONS(5355),
    [sym_mod] = ACTIONS(5353),
    [sym_modmod] = ACTIONS(5355),
    [sym_vert] = ACTIONS(5353),
    [anon_sym_PIPE_PIPE] = ACTIONS(5355),
    [anon_sym_u2016] = ACTIONS(5355),
    [sym_minusminus] = ACTIONS(5355),
    [sym_amp] = ACTIONS(5353),
    [sym_ampamp] = ACTIONS(5355),
    [anon_sym_BSLASHodot] = ACTIONS(5355),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5355),
    [anon_sym_u2299] = ACTIONS(5355),
    [anon_sym_BSLASHoslash] = ACTIONS(5355),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5355),
    [anon_sym_u2298] = ACTIONS(5355),
    [anon_sym_BSLASHotimes] = ACTIONS(5355),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5355),
    [anon_sym_u2297] = ACTIONS(5355),
    [sym_mul] = ACTIONS(5353),
    [sym_mulmul] = ACTIONS(5355),
    [sym_slash] = ACTIONS(5353),
    [sym_slashslash] = ACTIONS(5355),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5355),
    [anon_sym_u25ef] = ACTIONS(5355),
    [anon_sym_BSLASHbullet] = ACTIONS(5355),
    [anon_sym_u25cf] = ACTIONS(5355),
    [anon_sym_BSLASHdiv] = ACTIONS(5355),
    [anon_sym_u00f7] = ACTIONS(5355),
    [anon_sym_BSLASHcirc] = ACTIONS(5355),
    [anon_sym_u2218] = ACTIONS(5355),
    [anon_sym_BSLASHstar] = ACTIONS(5355),
    [anon_sym_u22c6] = ACTIONS(5355),
    [anon_sym_u203c] = ACTIONS(5355),
    [sym_hashhash] = ACTIONS(5355),
    [sym_dol] = ACTIONS(5353),
    [sym_doldol] = ACTIONS(5355),
    [anon_sym_QMARK_QMARK] = ACTIONS(5355),
    [anon_sym_u2047] = ACTIONS(5355),
    [anon_sym_BSLASHsqcap] = ACTIONS(5355),
    [anon_sym_u2293] = ACTIONS(5355),
    [anon_sym_BSLASHsqcup] = ACTIONS(5355),
    [anon_sym_u2294] = ACTIONS(5355),
    [anon_sym_BSLASHuplus] = ACTIONS(5355),
    [anon_sym_u228e] = ACTIONS(5355),
    [anon_sym_BSLASHX] = ACTIONS(5355),
    [anon_sym_BSLASHtimes] = ACTIONS(5355),
    [anon_sym_u00d7] = ACTIONS(5355),
    [anon_sym_BSLASHwr] = ACTIONS(5355),
    [anon_sym_u2240] = ACTIONS(5355),
    [anon_sym_BSLASHcdot] = ACTIONS(5355),
    [anon_sym_u22c5] = ACTIONS(5355),
    [sym_pow] = ACTIONS(5353),
    [sym_powpow] = ACTIONS(5355),
    [anon_sym_CARET_PLUS] = ACTIONS(5355),
    [anon_sym_u207a] = ACTIONS(5355),
    [sym_asterisk] = ACTIONS(5355),
    [sym_sup_hash] = ACTIONS(5355),
    [sym_prime] = ACTIONS(5355),
    [anon_sym_ASSUME] = ACTIONS(5353),
    [sym__indent] = ACTIONS(5355),
    [sym__double_excl] = ACTIONS(5355),
  },
  [2136] = {
    [sym_block_comment] = STATE(2136),
    [sym_identifier] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5357),
    [anon_sym_u2208] = ACTIONS(5359),
    [anon_sym_BSLASHA] = ACTIONS(5357),
    [anon_sym_BSLASHforall] = ACTIONS(5359),
    [anon_sym_u2200] = ACTIONS(5359),
    [anon_sym_BSLASHE] = ACTIONS(5357),
    [anon_sym_BSLASHexists] = ACTIONS(5359),
    [anon_sym_u2203] = ACTIONS(5359),
    [sym_temporal_forall] = ACTIONS(5359),
    [sym_temporal_exists] = ACTIONS(5359),
    [anon_sym_LT_LT] = ACTIONS(5359),
    [anon_sym_u3008] = ACTIONS(5359),
    [anon_sym_u27e8] = ACTIONS(5359),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5359),
    [anon_sym_u25a1] = ACTIONS(5359),
    [anon_sym_AT] = ACTIONS(5357),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5359),
    [anon_sym_u2227] = ACTIONS(5359),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5359),
    [anon_sym_u2228] = ACTIONS(5359),
    [anon_sym_LPAREN] = ACTIONS(5357),
    [anon_sym_LBRACK] = ACTIONS(5357),
    [aux_sym_child_id_token1] = ACTIONS(5357),
    [sym_real_number] = ACTIONS(5359),
    [anon_sym_BSLASHb] = ACTIONS(5357),
    [anon_sym_BSLASHB] = ACTIONS(5359),
    [anon_sym_BSLASHo] = ACTIONS(5357),
    [anon_sym_BSLASHO] = ACTIONS(5359),
    [anon_sym_BSLASHh] = ACTIONS(5359),
    [anon_sym_BSLASHH] = ACTIONS(5359),
    [anon_sym_DQUOTE] = ACTIONS(5359),
    [anon_sym_TRUE] = ACTIONS(5357),
    [anon_sym_FALSE] = ACTIONS(5357),
    [sym_string_set] = ACTIONS(5357),
    [sym_boolean_set] = ACTIONS(5357),
    [anon_sym_Nat] = ACTIONS(5357),
    [anon_sym_u2115] = ACTIONS(5359),
    [anon_sym_Int] = ACTIONS(5357),
    [anon_sym_u2124] = ACTIONS(5359),
    [anon_sym_Real] = ACTIONS(5357),
    [anon_sym_u211d] = ACTIONS(5359),
    [anon_sym_CHOOSE] = ACTIONS(5357),
    [anon_sym_LBRACE] = ACTIONS(5359),
    [anon_sym_EQ] = ACTIONS(5357),
    [anon_sym_WF_] = ACTIONS(5357),
    [anon_sym_SF_] = ACTIONS(5357),
    [anon_sym_IF] = ACTIONS(5357),
    [anon_sym_CASE] = ACTIONS(5357),
    [anon_sym_OTHER] = ACTIONS(5357),
    [anon_sym_LET] = ACTIONS(5357),
    [anon_sym_BSLASHlnot] = ACTIONS(5359),
    [anon_sym_BSLASHneg] = ACTIONS(5359),
    [anon_sym_TILDE] = ACTIONS(5357),
    [anon_sym_u00ac] = ACTIONS(5359),
    [sym_union] = ACTIONS(5357),
    [sym_powerset] = ACTIONS(5357),
    [sym_domain] = ACTIONS(5357),
    [anon_sym_DASH] = ACTIONS(5357),
    [sym_negative_dot] = ACTIONS(5359),
    [sym_enabled] = ACTIONS(5357),
    [sym_unchanged] = ACTIONS(5357),
    [anon_sym_LT_GT] = ACTIONS(5359),
    [anon_sym_u22c4] = ACTIONS(5359),
    [anon_sym_u25c7] = ACTIONS(5359),
    [anon_sym_EQ_GT] = ACTIONS(5359),
    [anon_sym_u27f9] = ACTIONS(5359),
    [anon_sym_u21d2] = ACTIONS(5359),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5359),
    [anon_sym_u21f8] = ACTIONS(5359),
    [anon_sym_u2945] = ACTIONS(5359),
    [anon_sym_BSLASHequiv] = ACTIONS(5359),
    [anon_sym_u2261] = ACTIONS(5359),
    [anon_sym_LT_EQ_GT] = ACTIONS(5359),
    [anon_sym_u27fa] = ACTIONS(5359),
    [anon_sym_u21d4] = ACTIONS(5359),
    [anon_sym_TILDE_GT] = ACTIONS(5359),
    [anon_sym_u21dd] = ACTIONS(5359),
    [anon_sym_u219d] = ACTIONS(5359),
    [anon_sym_BSLASHland] = ACTIONS(5359),
    [anon_sym_BSLASHlor] = ACTIONS(5359),
    [anon_sym_COLON_EQ] = ACTIONS(5359),
    [anon_sym_u2254] = ACTIONS(5359),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5359),
    [anon_sym_u2a74] = ACTIONS(5359),
    [anon_sym_SLASH_EQ] = ACTIONS(5359),
    [anon_sym_POUND] = ACTIONS(5357),
    [anon_sym_u2260] = ACTIONS(5359),
    [anon_sym_LT] = ACTIONS(5357),
    [sym_gt] = ACTIONS(5357),
    [anon_sym_LT_EQ] = ACTIONS(5357),
    [anon_sym_EQ_LT] = ACTIONS(5359),
    [anon_sym_BSLASHleq] = ACTIONS(5359),
    [anon_sym_u2264] = ACTIONS(5359),
    [anon_sym_GT_EQ] = ACTIONS(5359),
    [anon_sym_BSLASHgeq] = ACTIONS(5359),
    [anon_sym_u2265] = ACTIONS(5359),
    [anon_sym_BSLASHapprox] = ACTIONS(5359),
    [anon_sym_u2248] = ACTIONS(5359),
    [anon_sym_PIPE_DASH] = ACTIONS(5359),
    [anon_sym_u22a2] = ACTIONS(5359),
    [anon_sym_PIPE_EQ] = ACTIONS(5359),
    [anon_sym_u22a8] = ACTIONS(5359),
    [anon_sym_DASH_PIPE] = ACTIONS(5359),
    [anon_sym_u22a3] = ACTIONS(5359),
    [anon_sym_EQ_PIPE] = ACTIONS(5359),
    [anon_sym_u2ae4] = ACTIONS(5359),
    [anon_sym_BSLASHasymp] = ACTIONS(5359),
    [anon_sym_u224d] = ACTIONS(5359),
    [anon_sym_BSLASHcong] = ACTIONS(5359),
    [anon_sym_u2245] = ACTIONS(5359),
    [anon_sym_BSLASHdoteq] = ACTIONS(5359),
    [anon_sym_u2250] = ACTIONS(5359),
    [anon_sym_BSLASHgg] = ACTIONS(5359),
    [anon_sym_u226b] = ACTIONS(5359),
    [anon_sym_BSLASHll] = ACTIONS(5359),
    [anon_sym_u226a] = ACTIONS(5359),
    [anon_sym_BSLASHnotin] = ACTIONS(5359),
    [anon_sym_u2209] = ACTIONS(5359),
    [anon_sym_BSLASHprec] = ACTIONS(5357),
    [anon_sym_u227a] = ACTIONS(5359),
    [anon_sym_BSLASHsucc] = ACTIONS(5357),
    [anon_sym_u227b] = ACTIONS(5359),
    [anon_sym_BSLASHpreceq] = ACTIONS(5359),
    [anon_sym_u2aaf] = ACTIONS(5359),
    [anon_sym_BSLASHsucceq] = ACTIONS(5359),
    [anon_sym_u2ab0] = ACTIONS(5359),
    [anon_sym_BSLASHpropto] = ACTIONS(5359),
    [anon_sym_u221d] = ACTIONS(5359),
    [anon_sym_BSLASHsim] = ACTIONS(5357),
    [anon_sym_u223c] = ACTIONS(5359),
    [anon_sym_BSLASHsimeq] = ACTIONS(5359),
    [anon_sym_u2243] = ACTIONS(5359),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5357),
    [anon_sym_u228f] = ACTIONS(5359),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5357),
    [anon_sym_u2290] = ACTIONS(5359),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5359),
    [anon_sym_u2291] = ACTIONS(5359),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5359),
    [anon_sym_u2292] = ACTIONS(5359),
    [anon_sym_BSLASHsubset] = ACTIONS(5357),
    [anon_sym_u2282] = ACTIONS(5359),
    [anon_sym_BSLASHsupset] = ACTIONS(5357),
    [anon_sym_u2283] = ACTIONS(5359),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5359),
    [anon_sym_u2286] = ACTIONS(5359),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5359),
    [anon_sym_u2287] = ACTIONS(5359),
    [sym_compose] = ACTIONS(5359),
    [sym_map_to] = ACTIONS(5359),
    [sym_map_from] = ACTIONS(5359),
    [sym_setminus] = ACTIONS(5357),
    [anon_sym_BSLASHcap] = ACTIONS(5359),
    [anon_sym_BSLASHintersect] = ACTIONS(5359),
    [anon_sym_u2229] = ACTIONS(5359),
    [anon_sym_BSLASHcup] = ACTIONS(5359),
    [anon_sym_BSLASHunion] = ACTIONS(5359),
    [anon_sym_u222a] = ACTIONS(5359),
    [anon_sym_DOT_DOT] = ACTIONS(5357),
    [anon_sym_u2025] = ACTIONS(5359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5359),
    [anon_sym_u2026] = ACTIONS(5359),
    [anon_sym_PLUS] = ACTIONS(5357),
    [sym_plusplus] = ACTIONS(5359),
    [anon_sym_BSLASHoplus] = ACTIONS(5359),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5359),
    [anon_sym_u2295] = ACTIONS(5359),
    [anon_sym_BSLASHominus] = ACTIONS(5359),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5359),
    [anon_sym_u2296] = ACTIONS(5359),
    [sym_mod] = ACTIONS(5357),
    [sym_modmod] = ACTIONS(5359),
    [sym_vert] = ACTIONS(5357),
    [anon_sym_PIPE_PIPE] = ACTIONS(5359),
    [anon_sym_u2016] = ACTIONS(5359),
    [sym_minusminus] = ACTIONS(5359),
    [sym_amp] = ACTIONS(5357),
    [sym_ampamp] = ACTIONS(5359),
    [anon_sym_BSLASHodot] = ACTIONS(5359),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5359),
    [anon_sym_u2299] = ACTIONS(5359),
    [anon_sym_BSLASHoslash] = ACTIONS(5359),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5359),
    [anon_sym_u2298] = ACTIONS(5359),
    [anon_sym_BSLASHotimes] = ACTIONS(5359),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5359),
    [anon_sym_u2297] = ACTIONS(5359),
    [sym_mul] = ACTIONS(5357),
    [sym_mulmul] = ACTIONS(5359),
    [sym_slash] = ACTIONS(5357),
    [sym_slashslash] = ACTIONS(5359),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5359),
    [anon_sym_u25ef] = ACTIONS(5359),
    [anon_sym_BSLASHbullet] = ACTIONS(5359),
    [anon_sym_u25cf] = ACTIONS(5359),
    [anon_sym_BSLASHdiv] = ACTIONS(5359),
    [anon_sym_u00f7] = ACTIONS(5359),
    [anon_sym_BSLASHcirc] = ACTIONS(5359),
    [anon_sym_u2218] = ACTIONS(5359),
    [anon_sym_BSLASHstar] = ACTIONS(5359),
    [anon_sym_u22c6] = ACTIONS(5359),
    [anon_sym_u203c] = ACTIONS(5359),
    [sym_hashhash] = ACTIONS(5359),
    [sym_dol] = ACTIONS(5357),
    [sym_doldol] = ACTIONS(5359),
    [anon_sym_QMARK_QMARK] = ACTIONS(5359),
    [anon_sym_u2047] = ACTIONS(5359),
    [anon_sym_BSLASHsqcap] = ACTIONS(5359),
    [anon_sym_u2293] = ACTIONS(5359),
    [anon_sym_BSLASHsqcup] = ACTIONS(5359),
    [anon_sym_u2294] = ACTIONS(5359),
    [anon_sym_BSLASHuplus] = ACTIONS(5359),
    [anon_sym_u228e] = ACTIONS(5359),
    [anon_sym_BSLASHX] = ACTIONS(5359),
    [anon_sym_BSLASHtimes] = ACTIONS(5359),
    [anon_sym_u00d7] = ACTIONS(5359),
    [anon_sym_BSLASHwr] = ACTIONS(5359),
    [anon_sym_u2240] = ACTIONS(5359),
    [anon_sym_BSLASHcdot] = ACTIONS(5359),
    [anon_sym_u22c5] = ACTIONS(5359),
    [sym_pow] = ACTIONS(5357),
    [sym_powpow] = ACTIONS(5359),
    [anon_sym_CARET_PLUS] = ACTIONS(5359),
    [anon_sym_u207a] = ACTIONS(5359),
    [sym_asterisk] = ACTIONS(5359),
    [sym_sup_hash] = ACTIONS(5359),
    [sym_prime] = ACTIONS(5359),
    [sym__indent] = ACTIONS(5359),
    [sym__double_excl] = ACTIONS(5359),
  },
  [2137] = {
    [sym_block_comment] = STATE(2137),
    [sym_identifier] = ACTIONS(5361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5361),
    [anon_sym_u2208] = ACTIONS(5363),
    [anon_sym_BSLASHA] = ACTIONS(5361),
    [anon_sym_BSLASHforall] = ACTIONS(5363),
    [anon_sym_u2200] = ACTIONS(5363),
    [anon_sym_BSLASHE] = ACTIONS(5361),
    [anon_sym_BSLASHexists] = ACTIONS(5363),
    [anon_sym_u2203] = ACTIONS(5363),
    [sym_temporal_forall] = ACTIONS(5363),
    [sym_temporal_exists] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_u3008] = ACTIONS(5363),
    [anon_sym_u27e8] = ACTIONS(5363),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5363),
    [anon_sym_u25a1] = ACTIONS(5363),
    [anon_sym_AT] = ACTIONS(5361),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5363),
    [anon_sym_u2227] = ACTIONS(5363),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5363),
    [anon_sym_u2228] = ACTIONS(5363),
    [anon_sym_LPAREN] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [aux_sym_child_id_token1] = ACTIONS(5361),
    [sym_real_number] = ACTIONS(5363),
    [anon_sym_BSLASHb] = ACTIONS(5361),
    [anon_sym_BSLASHB] = ACTIONS(5363),
    [anon_sym_BSLASHo] = ACTIONS(5361),
    [anon_sym_BSLASHO] = ACTIONS(5363),
    [anon_sym_BSLASHh] = ACTIONS(5363),
    [anon_sym_BSLASHH] = ACTIONS(5363),
    [anon_sym_DQUOTE] = ACTIONS(5363),
    [anon_sym_TRUE] = ACTIONS(5361),
    [anon_sym_FALSE] = ACTIONS(5361),
    [sym_string_set] = ACTIONS(5361),
    [sym_boolean_set] = ACTIONS(5361),
    [anon_sym_Nat] = ACTIONS(5361),
    [anon_sym_u2115] = ACTIONS(5363),
    [anon_sym_Int] = ACTIONS(5361),
    [anon_sym_u2124] = ACTIONS(5363),
    [anon_sym_Real] = ACTIONS(5361),
    [anon_sym_u211d] = ACTIONS(5363),
    [anon_sym_CHOOSE] = ACTIONS(5361),
    [anon_sym_LBRACE] = ACTIONS(5363),
    [anon_sym_EQ] = ACTIONS(5361),
    [anon_sym_WF_] = ACTIONS(5361),
    [anon_sym_SF_] = ACTIONS(5361),
    [anon_sym_IF] = ACTIONS(5361),
    [anon_sym_CASE] = ACTIONS(5361),
    [anon_sym_LET] = ACTIONS(5361),
    [anon_sym_BSLASHlnot] = ACTIONS(5363),
    [anon_sym_BSLASHneg] = ACTIONS(5363),
    [anon_sym_TILDE] = ACTIONS(5361),
    [anon_sym_u00ac] = ACTIONS(5363),
    [sym_union] = ACTIONS(5361),
    [sym_powerset] = ACTIONS(5361),
    [sym_domain] = ACTIONS(5361),
    [anon_sym_DASH] = ACTIONS(5361),
    [sym_negative_dot] = ACTIONS(5363),
    [sym_enabled] = ACTIONS(5361),
    [sym_unchanged] = ACTIONS(5361),
    [anon_sym_LT_GT] = ACTIONS(5363),
    [anon_sym_u22c4] = ACTIONS(5363),
    [anon_sym_u25c7] = ACTIONS(5363),
    [anon_sym_EQ_GT] = ACTIONS(5363),
    [anon_sym_u27f9] = ACTIONS(5363),
    [anon_sym_u21d2] = ACTIONS(5363),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5363),
    [anon_sym_u21f8] = ACTIONS(5363),
    [anon_sym_u2945] = ACTIONS(5363),
    [anon_sym_BSLASHequiv] = ACTIONS(5363),
    [anon_sym_u2261] = ACTIONS(5363),
    [anon_sym_LT_EQ_GT] = ACTIONS(5363),
    [anon_sym_u27fa] = ACTIONS(5363),
    [anon_sym_u21d4] = ACTIONS(5363),
    [anon_sym_TILDE_GT] = ACTIONS(5363),
    [anon_sym_u21dd] = ACTIONS(5363),
    [anon_sym_u219d] = ACTIONS(5363),
    [anon_sym_BSLASHland] = ACTIONS(5363),
    [anon_sym_BSLASHlor] = ACTIONS(5363),
    [anon_sym_COLON_EQ] = ACTIONS(5363),
    [anon_sym_u2254] = ACTIONS(5363),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5363),
    [anon_sym_u2a74] = ACTIONS(5363),
    [anon_sym_SLASH_EQ] = ACTIONS(5363),
    [anon_sym_POUND] = ACTIONS(5361),
    [anon_sym_u2260] = ACTIONS(5363),
    [anon_sym_LT] = ACTIONS(5361),
    [sym_gt] = ACTIONS(5361),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_EQ_LT] = ACTIONS(5363),
    [anon_sym_BSLASHleq] = ACTIONS(5363),
    [anon_sym_u2264] = ACTIONS(5363),
    [anon_sym_GT_EQ] = ACTIONS(5363),
    [anon_sym_BSLASHgeq] = ACTIONS(5363),
    [anon_sym_u2265] = ACTIONS(5363),
    [anon_sym_BSLASHapprox] = ACTIONS(5363),
    [anon_sym_u2248] = ACTIONS(5363),
    [anon_sym_PIPE_DASH] = ACTIONS(5363),
    [anon_sym_u22a2] = ACTIONS(5363),
    [anon_sym_PIPE_EQ] = ACTIONS(5363),
    [anon_sym_u22a8] = ACTIONS(5363),
    [anon_sym_DASH_PIPE] = ACTIONS(5363),
    [anon_sym_u22a3] = ACTIONS(5363),
    [anon_sym_EQ_PIPE] = ACTIONS(5363),
    [anon_sym_u2ae4] = ACTIONS(5363),
    [anon_sym_BSLASHasymp] = ACTIONS(5363),
    [anon_sym_u224d] = ACTIONS(5363),
    [anon_sym_BSLASHcong] = ACTIONS(5363),
    [anon_sym_u2245] = ACTIONS(5363),
    [anon_sym_BSLASHdoteq] = ACTIONS(5363),
    [anon_sym_u2250] = ACTIONS(5363),
    [anon_sym_BSLASHgg] = ACTIONS(5363),
    [anon_sym_u226b] = ACTIONS(5363),
    [anon_sym_BSLASHll] = ACTIONS(5363),
    [anon_sym_u226a] = ACTIONS(5363),
    [anon_sym_BSLASHnotin] = ACTIONS(5363),
    [anon_sym_u2209] = ACTIONS(5363),
    [anon_sym_BSLASHprec] = ACTIONS(5361),
    [anon_sym_u227a] = ACTIONS(5363),
    [anon_sym_BSLASHsucc] = ACTIONS(5361),
    [anon_sym_u227b] = ACTIONS(5363),
    [anon_sym_BSLASHpreceq] = ACTIONS(5363),
    [anon_sym_u2aaf] = ACTIONS(5363),
    [anon_sym_BSLASHsucceq] = ACTIONS(5363),
    [anon_sym_u2ab0] = ACTIONS(5363),
    [anon_sym_BSLASHpropto] = ACTIONS(5363),
    [anon_sym_u221d] = ACTIONS(5363),
    [anon_sym_BSLASHsim] = ACTIONS(5361),
    [anon_sym_u223c] = ACTIONS(5363),
    [anon_sym_BSLASHsimeq] = ACTIONS(5363),
    [anon_sym_u2243] = ACTIONS(5363),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5361),
    [anon_sym_u228f] = ACTIONS(5363),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5361),
    [anon_sym_u2290] = ACTIONS(5363),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5363),
    [anon_sym_u2291] = ACTIONS(5363),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5363),
    [anon_sym_u2292] = ACTIONS(5363),
    [anon_sym_BSLASHsubset] = ACTIONS(5361),
    [anon_sym_u2282] = ACTIONS(5363),
    [anon_sym_BSLASHsupset] = ACTIONS(5361),
    [anon_sym_u2283] = ACTIONS(5363),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5363),
    [anon_sym_u2286] = ACTIONS(5363),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5363),
    [anon_sym_u2287] = ACTIONS(5363),
    [sym_compose] = ACTIONS(5363),
    [sym_map_to] = ACTIONS(5363),
    [sym_map_from] = ACTIONS(5363),
    [sym_setminus] = ACTIONS(5361),
    [anon_sym_BSLASHcap] = ACTIONS(5363),
    [anon_sym_BSLASHintersect] = ACTIONS(5363),
    [anon_sym_u2229] = ACTIONS(5363),
    [anon_sym_BSLASHcup] = ACTIONS(5363),
    [anon_sym_BSLASHunion] = ACTIONS(5363),
    [anon_sym_u222a] = ACTIONS(5363),
    [anon_sym_DOT_DOT] = ACTIONS(5361),
    [anon_sym_u2025] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5363),
    [anon_sym_u2026] = ACTIONS(5363),
    [anon_sym_PLUS] = ACTIONS(5361),
    [sym_plusplus] = ACTIONS(5363),
    [anon_sym_BSLASHoplus] = ACTIONS(5363),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5363),
    [anon_sym_u2295] = ACTIONS(5363),
    [anon_sym_BSLASHominus] = ACTIONS(5363),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5363),
    [anon_sym_u2296] = ACTIONS(5363),
    [sym_mod] = ACTIONS(5361),
    [sym_modmod] = ACTIONS(5363),
    [sym_vert] = ACTIONS(5361),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_u2016] = ACTIONS(5363),
    [sym_minusminus] = ACTIONS(5363),
    [sym_amp] = ACTIONS(5361),
    [sym_ampamp] = ACTIONS(5363),
    [anon_sym_BSLASHodot] = ACTIONS(5363),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5363),
    [anon_sym_u2299] = ACTIONS(5363),
    [anon_sym_BSLASHoslash] = ACTIONS(5363),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5363),
    [anon_sym_u2298] = ACTIONS(5363),
    [anon_sym_BSLASHotimes] = ACTIONS(5363),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5363),
    [anon_sym_u2297] = ACTIONS(5363),
    [sym_mul] = ACTIONS(5361),
    [sym_mulmul] = ACTIONS(5363),
    [sym_slash] = ACTIONS(5361),
    [sym_slashslash] = ACTIONS(5363),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5363),
    [anon_sym_u25ef] = ACTIONS(5363),
    [anon_sym_BSLASHbullet] = ACTIONS(5363),
    [anon_sym_u25cf] = ACTIONS(5363),
    [anon_sym_BSLASHdiv] = ACTIONS(5363),
    [anon_sym_u00f7] = ACTIONS(5363),
    [anon_sym_BSLASHcirc] = ACTIONS(5363),
    [anon_sym_u2218] = ACTIONS(5363),
    [anon_sym_BSLASHstar] = ACTIONS(5363),
    [anon_sym_u22c6] = ACTIONS(5363),
    [anon_sym_u203c] = ACTIONS(5363),
    [sym_hashhash] = ACTIONS(5363),
    [sym_dol] = ACTIONS(5361),
    [sym_doldol] = ACTIONS(5363),
    [anon_sym_QMARK_QMARK] = ACTIONS(5363),
    [anon_sym_u2047] = ACTIONS(5363),
    [anon_sym_BSLASHsqcap] = ACTIONS(5363),
    [anon_sym_u2293] = ACTIONS(5363),
    [anon_sym_BSLASHsqcup] = ACTIONS(5363),
    [anon_sym_u2294] = ACTIONS(5363),
    [anon_sym_BSLASHuplus] = ACTIONS(5363),
    [anon_sym_u228e] = ACTIONS(5363),
    [anon_sym_BSLASHX] = ACTIONS(5363),
    [anon_sym_BSLASHtimes] = ACTIONS(5363),
    [anon_sym_u00d7] = ACTIONS(5363),
    [anon_sym_BSLASHwr] = ACTIONS(5363),
    [anon_sym_u2240] = ACTIONS(5363),
    [anon_sym_BSLASHcdot] = ACTIONS(5363),
    [anon_sym_u22c5] = ACTIONS(5363),
    [sym_pow] = ACTIONS(5361),
    [sym_powpow] = ACTIONS(5363),
    [anon_sym_CARET_PLUS] = ACTIONS(5363),
    [anon_sym_u207a] = ACTIONS(5363),
    [sym_asterisk] = ACTIONS(5363),
    [sym_sup_hash] = ACTIONS(5363),
    [sym_prime] = ACTIONS(5363),
    [anon_sym_ASSUME] = ACTIONS(5361),
    [sym__indent] = ACTIONS(5363),
    [sym__double_excl] = ACTIONS(5363),
  },
  [2138] = {
    [sym_block_comment] = STATE(2138),
    [sym_identifier] = ACTIONS(5365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5365),
    [anon_sym_u2208] = ACTIONS(5367),
    [anon_sym_BSLASHA] = ACTIONS(5365),
    [anon_sym_BSLASHforall] = ACTIONS(5367),
    [anon_sym_u2200] = ACTIONS(5367),
    [anon_sym_BSLASHE] = ACTIONS(5365),
    [anon_sym_BSLASHexists] = ACTIONS(5367),
    [anon_sym_u2203] = ACTIONS(5367),
    [sym_temporal_forall] = ACTIONS(5367),
    [sym_temporal_exists] = ACTIONS(5367),
    [anon_sym_LT_LT] = ACTIONS(5367),
    [anon_sym_u3008] = ACTIONS(5367),
    [anon_sym_u27e8] = ACTIONS(5367),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5367),
    [anon_sym_u25a1] = ACTIONS(5367),
    [anon_sym_AT] = ACTIONS(5365),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5367),
    [anon_sym_u2227] = ACTIONS(5367),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5367),
    [anon_sym_u2228] = ACTIONS(5367),
    [anon_sym_LPAREN] = ACTIONS(5365),
    [anon_sym_LBRACK] = ACTIONS(5365),
    [aux_sym_child_id_token1] = ACTIONS(5365),
    [anon_sym_LAMBDA] = ACTIONS(5365),
    [sym_real_number] = ACTIONS(5367),
    [anon_sym_BSLASHb] = ACTIONS(5365),
    [anon_sym_BSLASHB] = ACTIONS(5367),
    [anon_sym_BSLASHo] = ACTIONS(5365),
    [anon_sym_BSLASHO] = ACTIONS(5367),
    [anon_sym_BSLASHh] = ACTIONS(5367),
    [anon_sym_BSLASHH] = ACTIONS(5367),
    [anon_sym_DQUOTE] = ACTIONS(5367),
    [anon_sym_TRUE] = ACTIONS(5365),
    [anon_sym_FALSE] = ACTIONS(5365),
    [sym_string_set] = ACTIONS(5365),
    [sym_boolean_set] = ACTIONS(5365),
    [anon_sym_Nat] = ACTIONS(5365),
    [anon_sym_u2115] = ACTIONS(5367),
    [anon_sym_Int] = ACTIONS(5365),
    [anon_sym_u2124] = ACTIONS(5367),
    [anon_sym_Real] = ACTIONS(5365),
    [anon_sym_u211d] = ACTIONS(5367),
    [anon_sym_CHOOSE] = ACTIONS(5365),
    [anon_sym_LBRACE] = ACTIONS(5367),
    [anon_sym_EQ] = ACTIONS(5365),
    [anon_sym_WF_] = ACTIONS(5365),
    [anon_sym_SF_] = ACTIONS(5365),
    [anon_sym_IF] = ACTIONS(5365),
    [anon_sym_CASE] = ACTIONS(5365),
    [anon_sym_LET] = ACTIONS(5365),
    [anon_sym_BSLASHlnot] = ACTIONS(5367),
    [anon_sym_BSLASHneg] = ACTIONS(5367),
    [anon_sym_TILDE] = ACTIONS(5365),
    [anon_sym_u00ac] = ACTIONS(5367),
    [sym_union] = ACTIONS(5365),
    [sym_powerset] = ACTIONS(5365),
    [sym_domain] = ACTIONS(5365),
    [anon_sym_DASH] = ACTIONS(5365),
    [sym_negative_dot] = ACTIONS(5367),
    [sym_enabled] = ACTIONS(5365),
    [sym_unchanged] = ACTIONS(5365),
    [anon_sym_LT_GT] = ACTIONS(5367),
    [anon_sym_u22c4] = ACTIONS(5367),
    [anon_sym_u25c7] = ACTIONS(5367),
    [anon_sym_EQ_GT] = ACTIONS(5367),
    [anon_sym_u27f9] = ACTIONS(5367),
    [anon_sym_u21d2] = ACTIONS(5367),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5367),
    [anon_sym_u21f8] = ACTIONS(5367),
    [anon_sym_u2945] = ACTIONS(5367),
    [anon_sym_BSLASHequiv] = ACTIONS(5367),
    [anon_sym_u2261] = ACTIONS(5367),
    [anon_sym_LT_EQ_GT] = ACTIONS(5367),
    [anon_sym_u27fa] = ACTIONS(5367),
    [anon_sym_u21d4] = ACTIONS(5367),
    [anon_sym_TILDE_GT] = ACTIONS(5367),
    [anon_sym_u21dd] = ACTIONS(5367),
    [anon_sym_u219d] = ACTIONS(5367),
    [anon_sym_BSLASHland] = ACTIONS(5367),
    [anon_sym_BSLASHlor] = ACTIONS(5367),
    [anon_sym_COLON_EQ] = ACTIONS(5367),
    [anon_sym_u2254] = ACTIONS(5367),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5367),
    [anon_sym_u2a74] = ACTIONS(5367),
    [anon_sym_SLASH_EQ] = ACTIONS(5367),
    [anon_sym_POUND] = ACTIONS(5365),
    [anon_sym_u2260] = ACTIONS(5367),
    [anon_sym_LT] = ACTIONS(5365),
    [sym_gt] = ACTIONS(5365),
    [anon_sym_LT_EQ] = ACTIONS(5365),
    [anon_sym_EQ_LT] = ACTIONS(5367),
    [anon_sym_BSLASHleq] = ACTIONS(5367),
    [anon_sym_u2264] = ACTIONS(5367),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_BSLASHgeq] = ACTIONS(5367),
    [anon_sym_u2265] = ACTIONS(5367),
    [anon_sym_BSLASHapprox] = ACTIONS(5367),
    [anon_sym_u2248] = ACTIONS(5367),
    [anon_sym_PIPE_DASH] = ACTIONS(5367),
    [anon_sym_u22a2] = ACTIONS(5367),
    [anon_sym_PIPE_EQ] = ACTIONS(5367),
    [anon_sym_u22a8] = ACTIONS(5367),
    [anon_sym_DASH_PIPE] = ACTIONS(5367),
    [anon_sym_u22a3] = ACTIONS(5367),
    [anon_sym_EQ_PIPE] = ACTIONS(5367),
    [anon_sym_u2ae4] = ACTIONS(5367),
    [anon_sym_BSLASHasymp] = ACTIONS(5367),
    [anon_sym_u224d] = ACTIONS(5367),
    [anon_sym_BSLASHcong] = ACTIONS(5367),
    [anon_sym_u2245] = ACTIONS(5367),
    [anon_sym_BSLASHdoteq] = ACTIONS(5367),
    [anon_sym_u2250] = ACTIONS(5367),
    [anon_sym_BSLASHgg] = ACTIONS(5367),
    [anon_sym_u226b] = ACTIONS(5367),
    [anon_sym_BSLASHll] = ACTIONS(5367),
    [anon_sym_u226a] = ACTIONS(5367),
    [anon_sym_BSLASHnotin] = ACTIONS(5367),
    [anon_sym_u2209] = ACTIONS(5367),
    [anon_sym_BSLASHprec] = ACTIONS(5365),
    [anon_sym_u227a] = ACTIONS(5367),
    [anon_sym_BSLASHsucc] = ACTIONS(5365),
    [anon_sym_u227b] = ACTIONS(5367),
    [anon_sym_BSLASHpreceq] = ACTIONS(5367),
    [anon_sym_u2aaf] = ACTIONS(5367),
    [anon_sym_BSLASHsucceq] = ACTIONS(5367),
    [anon_sym_u2ab0] = ACTIONS(5367),
    [anon_sym_BSLASHpropto] = ACTIONS(5367),
    [anon_sym_u221d] = ACTIONS(5367),
    [anon_sym_BSLASHsim] = ACTIONS(5365),
    [anon_sym_u223c] = ACTIONS(5367),
    [anon_sym_BSLASHsimeq] = ACTIONS(5367),
    [anon_sym_u2243] = ACTIONS(5367),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5365),
    [anon_sym_u228f] = ACTIONS(5367),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5365),
    [anon_sym_u2290] = ACTIONS(5367),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5367),
    [anon_sym_u2291] = ACTIONS(5367),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5367),
    [anon_sym_u2292] = ACTIONS(5367),
    [anon_sym_BSLASHsubset] = ACTIONS(5365),
    [anon_sym_u2282] = ACTIONS(5367),
    [anon_sym_BSLASHsupset] = ACTIONS(5365),
    [anon_sym_u2283] = ACTIONS(5367),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5367),
    [anon_sym_u2286] = ACTIONS(5367),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5367),
    [anon_sym_u2287] = ACTIONS(5367),
    [sym_compose] = ACTIONS(5367),
    [sym_map_to] = ACTIONS(5367),
    [sym_map_from] = ACTIONS(5367),
    [sym_setminus] = ACTIONS(5365),
    [anon_sym_BSLASHcap] = ACTIONS(5367),
    [anon_sym_BSLASHintersect] = ACTIONS(5367),
    [anon_sym_u2229] = ACTIONS(5367),
    [anon_sym_BSLASHcup] = ACTIONS(5367),
    [anon_sym_BSLASHunion] = ACTIONS(5367),
    [anon_sym_u222a] = ACTIONS(5367),
    [anon_sym_DOT_DOT] = ACTIONS(5365),
    [anon_sym_u2025] = ACTIONS(5367),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5367),
    [anon_sym_u2026] = ACTIONS(5367),
    [anon_sym_PLUS] = ACTIONS(5365),
    [sym_plusplus] = ACTIONS(5367),
    [anon_sym_BSLASHoplus] = ACTIONS(5367),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5367),
    [anon_sym_u2295] = ACTIONS(5367),
    [anon_sym_BSLASHominus] = ACTIONS(5367),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5367),
    [anon_sym_u2296] = ACTIONS(5367),
    [sym_mod] = ACTIONS(5365),
    [sym_modmod] = ACTIONS(5367),
    [sym_vert] = ACTIONS(5365),
    [anon_sym_PIPE_PIPE] = ACTIONS(5367),
    [anon_sym_u2016] = ACTIONS(5367),
    [sym_minusminus] = ACTIONS(5367),
    [sym_amp] = ACTIONS(5365),
    [sym_ampamp] = ACTIONS(5367),
    [anon_sym_BSLASHodot] = ACTIONS(5367),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5367),
    [anon_sym_u2299] = ACTIONS(5367),
    [anon_sym_BSLASHoslash] = ACTIONS(5367),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5367),
    [anon_sym_u2298] = ACTIONS(5367),
    [anon_sym_BSLASHotimes] = ACTIONS(5367),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5367),
    [anon_sym_u2297] = ACTIONS(5367),
    [sym_mul] = ACTIONS(5365),
    [sym_mulmul] = ACTIONS(5367),
    [sym_slash] = ACTIONS(5365),
    [sym_slashslash] = ACTIONS(5367),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5367),
    [anon_sym_u25ef] = ACTIONS(5367),
    [anon_sym_BSLASHbullet] = ACTIONS(5367),
    [anon_sym_u25cf] = ACTIONS(5367),
    [anon_sym_BSLASHdiv] = ACTIONS(5367),
    [anon_sym_u00f7] = ACTIONS(5367),
    [anon_sym_BSLASHcirc] = ACTIONS(5367),
    [anon_sym_u2218] = ACTIONS(5367),
    [anon_sym_BSLASHstar] = ACTIONS(5367),
    [anon_sym_u22c6] = ACTIONS(5367),
    [anon_sym_u203c] = ACTIONS(5367),
    [sym_hashhash] = ACTIONS(5367),
    [sym_dol] = ACTIONS(5365),
    [sym_doldol] = ACTIONS(5367),
    [anon_sym_QMARK_QMARK] = ACTIONS(5367),
    [anon_sym_u2047] = ACTIONS(5367),
    [anon_sym_BSLASHsqcap] = ACTIONS(5367),
    [anon_sym_u2293] = ACTIONS(5367),
    [anon_sym_BSLASHsqcup] = ACTIONS(5367),
    [anon_sym_u2294] = ACTIONS(5367),
    [anon_sym_BSLASHuplus] = ACTIONS(5367),
    [anon_sym_u228e] = ACTIONS(5367),
    [anon_sym_BSLASHX] = ACTIONS(5367),
    [anon_sym_BSLASHtimes] = ACTIONS(5367),
    [anon_sym_u00d7] = ACTIONS(5367),
    [anon_sym_BSLASHwr] = ACTIONS(5367),
    [anon_sym_u2240] = ACTIONS(5367),
    [anon_sym_BSLASHcdot] = ACTIONS(5367),
    [anon_sym_u22c5] = ACTIONS(5367),
    [sym_pow] = ACTIONS(5365),
    [sym_powpow] = ACTIONS(5367),
    [anon_sym_CARET_PLUS] = ACTIONS(5367),
    [anon_sym_u207a] = ACTIONS(5367),
    [sym_asterisk] = ACTIONS(5367),
    [sym_sup_hash] = ACTIONS(5367),
    [sym_prime] = ACTIONS(5367),
    [sym__indent] = ACTIONS(5367),
    [sym__double_excl] = ACTIONS(5367),
  },
  [2139] = {
    [sym_block_comment] = STATE(2139),
    [sym_identifier] = ACTIONS(5369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5369),
    [anon_sym_u2208] = ACTIONS(5371),
    [anon_sym_BSLASHA] = ACTIONS(5369),
    [anon_sym_BSLASHforall] = ACTIONS(5371),
    [anon_sym_u2200] = ACTIONS(5371),
    [anon_sym_BSLASHE] = ACTIONS(5369),
    [anon_sym_BSLASHexists] = ACTIONS(5371),
    [anon_sym_u2203] = ACTIONS(5371),
    [sym_temporal_forall] = ACTIONS(5371),
    [sym_temporal_exists] = ACTIONS(5371),
    [anon_sym_LT_LT] = ACTIONS(5371),
    [anon_sym_u3008] = ACTIONS(5371),
    [anon_sym_u27e8] = ACTIONS(5371),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5371),
    [anon_sym_u25a1] = ACTIONS(5371),
    [anon_sym_AT] = ACTIONS(5369),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5371),
    [anon_sym_u2227] = ACTIONS(5371),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5371),
    [anon_sym_u2228] = ACTIONS(5371),
    [anon_sym_LPAREN] = ACTIONS(5369),
    [anon_sym_LBRACK] = ACTIONS(5369),
    [aux_sym_child_id_token1] = ACTIONS(5369),
    [sym_real_number] = ACTIONS(5371),
    [anon_sym_BSLASHb] = ACTIONS(5369),
    [anon_sym_BSLASHB] = ACTIONS(5371),
    [anon_sym_BSLASHo] = ACTIONS(5369),
    [anon_sym_BSLASHO] = ACTIONS(5371),
    [anon_sym_BSLASHh] = ACTIONS(5371),
    [anon_sym_BSLASHH] = ACTIONS(5371),
    [anon_sym_DQUOTE] = ACTIONS(5371),
    [anon_sym_TRUE] = ACTIONS(5369),
    [anon_sym_FALSE] = ACTIONS(5369),
    [sym_string_set] = ACTIONS(5369),
    [sym_boolean_set] = ACTIONS(5369),
    [anon_sym_Nat] = ACTIONS(5369),
    [anon_sym_u2115] = ACTIONS(5371),
    [anon_sym_Int] = ACTIONS(5369),
    [anon_sym_u2124] = ACTIONS(5371),
    [anon_sym_Real] = ACTIONS(5369),
    [anon_sym_u211d] = ACTIONS(5371),
    [anon_sym_CHOOSE] = ACTIONS(5369),
    [anon_sym_LBRACE] = ACTIONS(5371),
    [anon_sym_EQ] = ACTIONS(5369),
    [anon_sym_WF_] = ACTIONS(5369),
    [anon_sym_SF_] = ACTIONS(5369),
    [anon_sym_IF] = ACTIONS(5369),
    [anon_sym_CASE] = ACTIONS(5369),
    [anon_sym_LET] = ACTIONS(5369),
    [anon_sym_BSLASHlnot] = ACTIONS(5371),
    [anon_sym_BSLASHneg] = ACTIONS(5371),
    [anon_sym_TILDE] = ACTIONS(5369),
    [anon_sym_u00ac] = ACTIONS(5371),
    [sym_union] = ACTIONS(5369),
    [sym_powerset] = ACTIONS(5369),
    [sym_domain] = ACTIONS(5369),
    [anon_sym_DASH] = ACTIONS(5369),
    [sym_negative_dot] = ACTIONS(5371),
    [sym_enabled] = ACTIONS(5369),
    [sym_unchanged] = ACTIONS(5369),
    [anon_sym_LT_GT] = ACTIONS(5371),
    [anon_sym_u22c4] = ACTIONS(5371),
    [anon_sym_u25c7] = ACTIONS(5371),
    [anon_sym_EQ_GT] = ACTIONS(5371),
    [anon_sym_u27f9] = ACTIONS(5371),
    [anon_sym_u21d2] = ACTIONS(5371),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5371),
    [anon_sym_u21f8] = ACTIONS(5371),
    [anon_sym_u2945] = ACTIONS(5371),
    [anon_sym_BSLASHequiv] = ACTIONS(5371),
    [anon_sym_u2261] = ACTIONS(5371),
    [anon_sym_LT_EQ_GT] = ACTIONS(5371),
    [anon_sym_u27fa] = ACTIONS(5371),
    [anon_sym_u21d4] = ACTIONS(5371),
    [anon_sym_TILDE_GT] = ACTIONS(5371),
    [anon_sym_u21dd] = ACTIONS(5371),
    [anon_sym_u219d] = ACTIONS(5371),
    [anon_sym_BSLASHland] = ACTIONS(5371),
    [anon_sym_BSLASHlor] = ACTIONS(5371),
    [anon_sym_COLON_EQ] = ACTIONS(5371),
    [anon_sym_u2254] = ACTIONS(5371),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5371),
    [anon_sym_u2a74] = ACTIONS(5371),
    [anon_sym_SLASH_EQ] = ACTIONS(5371),
    [anon_sym_POUND] = ACTIONS(5369),
    [anon_sym_u2260] = ACTIONS(5371),
    [anon_sym_LT] = ACTIONS(5369),
    [sym_gt] = ACTIONS(5369),
    [anon_sym_LT_EQ] = ACTIONS(5369),
    [anon_sym_EQ_LT] = ACTIONS(5371),
    [anon_sym_BSLASHleq] = ACTIONS(5371),
    [anon_sym_u2264] = ACTIONS(5371),
    [anon_sym_GT_EQ] = ACTIONS(5371),
    [anon_sym_BSLASHgeq] = ACTIONS(5371),
    [anon_sym_u2265] = ACTIONS(5371),
    [anon_sym_BSLASHapprox] = ACTIONS(5371),
    [anon_sym_u2248] = ACTIONS(5371),
    [anon_sym_PIPE_DASH] = ACTIONS(5371),
    [anon_sym_u22a2] = ACTIONS(5371),
    [anon_sym_PIPE_EQ] = ACTIONS(5371),
    [anon_sym_u22a8] = ACTIONS(5371),
    [anon_sym_DASH_PIPE] = ACTIONS(5371),
    [anon_sym_u22a3] = ACTIONS(5371),
    [anon_sym_EQ_PIPE] = ACTIONS(5371),
    [anon_sym_u2ae4] = ACTIONS(5371),
    [anon_sym_BSLASHasymp] = ACTIONS(5371),
    [anon_sym_u224d] = ACTIONS(5371),
    [anon_sym_BSLASHcong] = ACTIONS(5371),
    [anon_sym_u2245] = ACTIONS(5371),
    [anon_sym_BSLASHdoteq] = ACTIONS(5371),
    [anon_sym_u2250] = ACTIONS(5371),
    [anon_sym_BSLASHgg] = ACTIONS(5371),
    [anon_sym_u226b] = ACTIONS(5371),
    [anon_sym_BSLASHll] = ACTIONS(5371),
    [anon_sym_u226a] = ACTIONS(5371),
    [anon_sym_BSLASHnotin] = ACTIONS(5371),
    [anon_sym_u2209] = ACTIONS(5371),
    [anon_sym_BSLASHprec] = ACTIONS(5369),
    [anon_sym_u227a] = ACTIONS(5371),
    [anon_sym_BSLASHsucc] = ACTIONS(5369),
    [anon_sym_u227b] = ACTIONS(5371),
    [anon_sym_BSLASHpreceq] = ACTIONS(5371),
    [anon_sym_u2aaf] = ACTIONS(5371),
    [anon_sym_BSLASHsucceq] = ACTIONS(5371),
    [anon_sym_u2ab0] = ACTIONS(5371),
    [anon_sym_BSLASHpropto] = ACTIONS(5371),
    [anon_sym_u221d] = ACTIONS(5371),
    [anon_sym_BSLASHsim] = ACTIONS(5369),
    [anon_sym_u223c] = ACTIONS(5371),
    [anon_sym_BSLASHsimeq] = ACTIONS(5371),
    [anon_sym_u2243] = ACTIONS(5371),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5369),
    [anon_sym_u228f] = ACTIONS(5371),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5369),
    [anon_sym_u2290] = ACTIONS(5371),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5371),
    [anon_sym_u2291] = ACTIONS(5371),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5371),
    [anon_sym_u2292] = ACTIONS(5371),
    [anon_sym_BSLASHsubset] = ACTIONS(5369),
    [anon_sym_u2282] = ACTIONS(5371),
    [anon_sym_BSLASHsupset] = ACTIONS(5369),
    [anon_sym_u2283] = ACTIONS(5371),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5371),
    [anon_sym_u2286] = ACTIONS(5371),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5371),
    [anon_sym_u2287] = ACTIONS(5371),
    [sym_compose] = ACTIONS(5371),
    [sym_map_to] = ACTIONS(5371),
    [sym_map_from] = ACTIONS(5371),
    [sym_setminus] = ACTIONS(5369),
    [anon_sym_BSLASHcap] = ACTIONS(5371),
    [anon_sym_BSLASHintersect] = ACTIONS(5371),
    [anon_sym_u2229] = ACTIONS(5371),
    [anon_sym_BSLASHcup] = ACTIONS(5371),
    [anon_sym_BSLASHunion] = ACTIONS(5371),
    [anon_sym_u222a] = ACTIONS(5371),
    [anon_sym_DOT_DOT] = ACTIONS(5369),
    [anon_sym_u2025] = ACTIONS(5371),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5371),
    [anon_sym_u2026] = ACTIONS(5371),
    [anon_sym_PLUS] = ACTIONS(5369),
    [sym_plusplus] = ACTIONS(5371),
    [anon_sym_BSLASHoplus] = ACTIONS(5371),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5371),
    [anon_sym_u2295] = ACTIONS(5371),
    [anon_sym_BSLASHominus] = ACTIONS(5371),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5371),
    [anon_sym_u2296] = ACTIONS(5371),
    [sym_mod] = ACTIONS(5369),
    [sym_modmod] = ACTIONS(5371),
    [sym_vert] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5371),
    [anon_sym_u2016] = ACTIONS(5371),
    [sym_minusminus] = ACTIONS(5371),
    [sym_amp] = ACTIONS(5369),
    [sym_ampamp] = ACTIONS(5371),
    [anon_sym_BSLASHodot] = ACTIONS(5371),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5371),
    [anon_sym_u2299] = ACTIONS(5371),
    [anon_sym_BSLASHoslash] = ACTIONS(5371),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5371),
    [anon_sym_u2298] = ACTIONS(5371),
    [anon_sym_BSLASHotimes] = ACTIONS(5371),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5371),
    [anon_sym_u2297] = ACTIONS(5371),
    [sym_mul] = ACTIONS(5369),
    [sym_mulmul] = ACTIONS(5371),
    [sym_slash] = ACTIONS(5369),
    [sym_slashslash] = ACTIONS(5371),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5371),
    [anon_sym_u25ef] = ACTIONS(5371),
    [anon_sym_BSLASHbullet] = ACTIONS(5371),
    [anon_sym_u25cf] = ACTIONS(5371),
    [anon_sym_BSLASHdiv] = ACTIONS(5371),
    [anon_sym_u00f7] = ACTIONS(5371),
    [anon_sym_BSLASHcirc] = ACTIONS(5371),
    [anon_sym_u2218] = ACTIONS(5371),
    [anon_sym_BSLASHstar] = ACTIONS(5371),
    [anon_sym_u22c6] = ACTIONS(5371),
    [anon_sym_u203c] = ACTIONS(5371),
    [sym_hashhash] = ACTIONS(5371),
    [sym_dol] = ACTIONS(5369),
    [sym_doldol] = ACTIONS(5371),
    [anon_sym_QMARK_QMARK] = ACTIONS(5371),
    [anon_sym_u2047] = ACTIONS(5371),
    [anon_sym_BSLASHsqcap] = ACTIONS(5371),
    [anon_sym_u2293] = ACTIONS(5371),
    [anon_sym_BSLASHsqcup] = ACTIONS(5371),
    [anon_sym_u2294] = ACTIONS(5371),
    [anon_sym_BSLASHuplus] = ACTIONS(5371),
    [anon_sym_u228e] = ACTIONS(5371),
    [anon_sym_BSLASHX] = ACTIONS(5371),
    [anon_sym_BSLASHtimes] = ACTIONS(5371),
    [anon_sym_u00d7] = ACTIONS(5371),
    [anon_sym_BSLASHwr] = ACTIONS(5371),
    [anon_sym_u2240] = ACTIONS(5371),
    [anon_sym_BSLASHcdot] = ACTIONS(5371),
    [anon_sym_u22c5] = ACTIONS(5371),
    [sym_pow] = ACTIONS(5369),
    [sym_powpow] = ACTIONS(5371),
    [anon_sym_CARET_PLUS] = ACTIONS(5371),
    [anon_sym_u207a] = ACTIONS(5371),
    [sym_asterisk] = ACTIONS(5371),
    [sym_sup_hash] = ACTIONS(5371),
    [sym_prime] = ACTIONS(5371),
    [sym__indent] = ACTIONS(5371),
    [sym__double_excl] = ACTIONS(5371),
  },
  [2140] = {
    [sym_block_comment] = STATE(2140),
    [sym_identifier] = ACTIONS(5373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5373),
    [anon_sym_u2208] = ACTIONS(5375),
    [anon_sym_BSLASHA] = ACTIONS(5373),
    [anon_sym_BSLASHforall] = ACTIONS(5375),
    [anon_sym_u2200] = ACTIONS(5375),
    [anon_sym_BSLASHE] = ACTIONS(5373),
    [anon_sym_BSLASHexists] = ACTIONS(5375),
    [anon_sym_u2203] = ACTIONS(5375),
    [sym_temporal_forall] = ACTIONS(5375),
    [sym_temporal_exists] = ACTIONS(5375),
    [anon_sym_LT_LT] = ACTIONS(5375),
    [anon_sym_u3008] = ACTIONS(5375),
    [anon_sym_u27e8] = ACTIONS(5375),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5375),
    [anon_sym_u25a1] = ACTIONS(5375),
    [anon_sym_AT] = ACTIONS(5373),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5375),
    [anon_sym_u2227] = ACTIONS(5375),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5375),
    [anon_sym_u2228] = ACTIONS(5375),
    [anon_sym_LPAREN] = ACTIONS(5373),
    [anon_sym_LBRACK] = ACTIONS(5373),
    [aux_sym_child_id_token1] = ACTIONS(5373),
    [sym_real_number] = ACTIONS(5375),
    [anon_sym_BSLASHb] = ACTIONS(5373),
    [anon_sym_BSLASHB] = ACTIONS(5375),
    [anon_sym_BSLASHo] = ACTIONS(5373),
    [anon_sym_BSLASHO] = ACTIONS(5375),
    [anon_sym_BSLASHh] = ACTIONS(5375),
    [anon_sym_BSLASHH] = ACTIONS(5375),
    [anon_sym_DQUOTE] = ACTIONS(5375),
    [anon_sym_TRUE] = ACTIONS(5373),
    [anon_sym_FALSE] = ACTIONS(5373),
    [sym_string_set] = ACTIONS(5373),
    [sym_boolean_set] = ACTIONS(5373),
    [anon_sym_Nat] = ACTIONS(5373),
    [anon_sym_u2115] = ACTIONS(5375),
    [anon_sym_Int] = ACTIONS(5373),
    [anon_sym_u2124] = ACTIONS(5375),
    [anon_sym_Real] = ACTIONS(5373),
    [anon_sym_u211d] = ACTIONS(5375),
    [anon_sym_CHOOSE] = ACTIONS(5373),
    [anon_sym_LBRACE] = ACTIONS(5375),
    [anon_sym_EQ] = ACTIONS(5373),
    [anon_sym_WF_] = ACTIONS(5373),
    [anon_sym_SF_] = ACTIONS(5373),
    [anon_sym_IF] = ACTIONS(5373),
    [anon_sym_CASE] = ACTIONS(5373),
    [anon_sym_LET] = ACTIONS(5373),
    [anon_sym_BSLASHlnot] = ACTIONS(5375),
    [anon_sym_BSLASHneg] = ACTIONS(5375),
    [anon_sym_TILDE] = ACTIONS(5373),
    [anon_sym_u00ac] = ACTIONS(5375),
    [sym_union] = ACTIONS(5373),
    [sym_powerset] = ACTIONS(5373),
    [sym_domain] = ACTIONS(5373),
    [anon_sym_DASH] = ACTIONS(5373),
    [sym_negative_dot] = ACTIONS(5375),
    [sym_enabled] = ACTIONS(5373),
    [sym_unchanged] = ACTIONS(5373),
    [anon_sym_LT_GT] = ACTIONS(5375),
    [anon_sym_u22c4] = ACTIONS(5375),
    [anon_sym_u25c7] = ACTIONS(5375),
    [anon_sym_EQ_GT] = ACTIONS(5375),
    [anon_sym_u27f9] = ACTIONS(5375),
    [anon_sym_u21d2] = ACTIONS(5375),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5375),
    [anon_sym_u21f8] = ACTIONS(5375),
    [anon_sym_u2945] = ACTIONS(5375),
    [anon_sym_BSLASHequiv] = ACTIONS(5375),
    [anon_sym_u2261] = ACTIONS(5375),
    [anon_sym_LT_EQ_GT] = ACTIONS(5375),
    [anon_sym_u27fa] = ACTIONS(5375),
    [anon_sym_u21d4] = ACTIONS(5375),
    [anon_sym_TILDE_GT] = ACTIONS(5375),
    [anon_sym_u21dd] = ACTIONS(5375),
    [anon_sym_u219d] = ACTIONS(5375),
    [anon_sym_BSLASHland] = ACTIONS(5375),
    [anon_sym_BSLASHlor] = ACTIONS(5375),
    [anon_sym_COLON_EQ] = ACTIONS(5375),
    [anon_sym_u2254] = ACTIONS(5375),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5375),
    [anon_sym_u2a74] = ACTIONS(5375),
    [anon_sym_SLASH_EQ] = ACTIONS(5375),
    [anon_sym_POUND] = ACTIONS(5373),
    [anon_sym_u2260] = ACTIONS(5375),
    [anon_sym_LT] = ACTIONS(5373),
    [sym_gt] = ACTIONS(5373),
    [anon_sym_LT_EQ] = ACTIONS(5373),
    [anon_sym_EQ_LT] = ACTIONS(5375),
    [anon_sym_BSLASHleq] = ACTIONS(5375),
    [anon_sym_u2264] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5375),
    [anon_sym_BSLASHgeq] = ACTIONS(5375),
    [anon_sym_u2265] = ACTIONS(5375),
    [anon_sym_BSLASHapprox] = ACTIONS(5375),
    [anon_sym_u2248] = ACTIONS(5375),
    [anon_sym_PIPE_DASH] = ACTIONS(5375),
    [anon_sym_u22a2] = ACTIONS(5375),
    [anon_sym_PIPE_EQ] = ACTIONS(5375),
    [anon_sym_u22a8] = ACTIONS(5375),
    [anon_sym_DASH_PIPE] = ACTIONS(5375),
    [anon_sym_u22a3] = ACTIONS(5375),
    [anon_sym_EQ_PIPE] = ACTIONS(5375),
    [anon_sym_u2ae4] = ACTIONS(5375),
    [anon_sym_BSLASHasymp] = ACTIONS(5375),
    [anon_sym_u224d] = ACTIONS(5375),
    [anon_sym_BSLASHcong] = ACTIONS(5375),
    [anon_sym_u2245] = ACTIONS(5375),
    [anon_sym_BSLASHdoteq] = ACTIONS(5375),
    [anon_sym_u2250] = ACTIONS(5375),
    [anon_sym_BSLASHgg] = ACTIONS(5375),
    [anon_sym_u226b] = ACTIONS(5375),
    [anon_sym_BSLASHll] = ACTIONS(5375),
    [anon_sym_u226a] = ACTIONS(5375),
    [anon_sym_BSLASHnotin] = ACTIONS(5375),
    [anon_sym_u2209] = ACTIONS(5375),
    [anon_sym_BSLASHprec] = ACTIONS(5373),
    [anon_sym_u227a] = ACTIONS(5375),
    [anon_sym_BSLASHsucc] = ACTIONS(5373),
    [anon_sym_u227b] = ACTIONS(5375),
    [anon_sym_BSLASHpreceq] = ACTIONS(5375),
    [anon_sym_u2aaf] = ACTIONS(5375),
    [anon_sym_BSLASHsucceq] = ACTIONS(5375),
    [anon_sym_u2ab0] = ACTIONS(5375),
    [anon_sym_BSLASHpropto] = ACTIONS(5375),
    [anon_sym_u221d] = ACTIONS(5375),
    [anon_sym_BSLASHsim] = ACTIONS(5373),
    [anon_sym_u223c] = ACTIONS(5375),
    [anon_sym_BSLASHsimeq] = ACTIONS(5375),
    [anon_sym_u2243] = ACTIONS(5375),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5373),
    [anon_sym_u228f] = ACTIONS(5375),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5373),
    [anon_sym_u2290] = ACTIONS(5375),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5375),
    [anon_sym_u2291] = ACTIONS(5375),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5375),
    [anon_sym_u2292] = ACTIONS(5375),
    [anon_sym_BSLASHsubset] = ACTIONS(5373),
    [anon_sym_u2282] = ACTIONS(5375),
    [anon_sym_BSLASHsupset] = ACTIONS(5373),
    [anon_sym_u2283] = ACTIONS(5375),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5375),
    [anon_sym_u2286] = ACTIONS(5375),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5375),
    [anon_sym_u2287] = ACTIONS(5375),
    [sym_compose] = ACTIONS(5375),
    [sym_map_to] = ACTIONS(5375),
    [sym_map_from] = ACTIONS(5375),
    [sym_setminus] = ACTIONS(5373),
    [anon_sym_BSLASHcap] = ACTIONS(5375),
    [anon_sym_BSLASHintersect] = ACTIONS(5375),
    [anon_sym_u2229] = ACTIONS(5375),
    [anon_sym_BSLASHcup] = ACTIONS(5375),
    [anon_sym_BSLASHunion] = ACTIONS(5375),
    [anon_sym_u222a] = ACTIONS(5375),
    [anon_sym_DOT_DOT] = ACTIONS(5373),
    [anon_sym_u2025] = ACTIONS(5375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5375),
    [anon_sym_u2026] = ACTIONS(5375),
    [anon_sym_PLUS] = ACTIONS(5373),
    [sym_plusplus] = ACTIONS(5375),
    [anon_sym_BSLASHoplus] = ACTIONS(5375),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5375),
    [anon_sym_u2295] = ACTIONS(5375),
    [anon_sym_BSLASHominus] = ACTIONS(5375),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5375),
    [anon_sym_u2296] = ACTIONS(5375),
    [sym_mod] = ACTIONS(5373),
    [sym_modmod] = ACTIONS(5375),
    [sym_vert] = ACTIONS(5373),
    [anon_sym_PIPE_PIPE] = ACTIONS(5375),
    [anon_sym_u2016] = ACTIONS(5375),
    [sym_minusminus] = ACTIONS(5375),
    [sym_amp] = ACTIONS(5373),
    [sym_ampamp] = ACTIONS(5375),
    [anon_sym_BSLASHodot] = ACTIONS(5375),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5375),
    [anon_sym_u2299] = ACTIONS(5375),
    [anon_sym_BSLASHoslash] = ACTIONS(5375),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5375),
    [anon_sym_u2298] = ACTIONS(5375),
    [anon_sym_BSLASHotimes] = ACTIONS(5375),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5375),
    [anon_sym_u2297] = ACTIONS(5375),
    [sym_mul] = ACTIONS(5373),
    [sym_mulmul] = ACTIONS(5375),
    [sym_slash] = ACTIONS(5373),
    [sym_slashslash] = ACTIONS(5375),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5375),
    [anon_sym_u25ef] = ACTIONS(5375),
    [anon_sym_BSLASHbullet] = ACTIONS(5375),
    [anon_sym_u25cf] = ACTIONS(5375),
    [anon_sym_BSLASHdiv] = ACTIONS(5375),
    [anon_sym_u00f7] = ACTIONS(5375),
    [anon_sym_BSLASHcirc] = ACTIONS(5375),
    [anon_sym_u2218] = ACTIONS(5375),
    [anon_sym_BSLASHstar] = ACTIONS(5375),
    [anon_sym_u22c6] = ACTIONS(5375),
    [anon_sym_u203c] = ACTIONS(5375),
    [sym_hashhash] = ACTIONS(5375),
    [sym_dol] = ACTIONS(5373),
    [sym_doldol] = ACTIONS(5375),
    [anon_sym_QMARK_QMARK] = ACTIONS(5375),
    [anon_sym_u2047] = ACTIONS(5375),
    [anon_sym_BSLASHsqcap] = ACTIONS(5375),
    [anon_sym_u2293] = ACTIONS(5375),
    [anon_sym_BSLASHsqcup] = ACTIONS(5375),
    [anon_sym_u2294] = ACTIONS(5375),
    [anon_sym_BSLASHuplus] = ACTIONS(5375),
    [anon_sym_u228e] = ACTIONS(5375),
    [anon_sym_BSLASHX] = ACTIONS(5375),
    [anon_sym_BSLASHtimes] = ACTIONS(5375),
    [anon_sym_u00d7] = ACTIONS(5375),
    [anon_sym_BSLASHwr] = ACTIONS(5375),
    [anon_sym_u2240] = ACTIONS(5375),
    [anon_sym_BSLASHcdot] = ACTIONS(5375),
    [anon_sym_u22c5] = ACTIONS(5375),
    [sym_pow] = ACTIONS(5373),
    [sym_powpow] = ACTIONS(5375),
    [anon_sym_CARET_PLUS] = ACTIONS(5375),
    [anon_sym_u207a] = ACTIONS(5375),
    [sym_asterisk] = ACTIONS(5375),
    [sym_sup_hash] = ACTIONS(5375),
    [sym_prime] = ACTIONS(5375),
    [sym__indent] = ACTIONS(5375),
    [sym__double_excl] = ACTIONS(5375),
  },
  [2141] = {
    [sym_block_comment] = STATE(2141),
    [sym_identifier] = ACTIONS(5377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5377),
    [anon_sym_u2208] = ACTIONS(5379),
    [anon_sym_BSLASHA] = ACTIONS(5377),
    [anon_sym_BSLASHforall] = ACTIONS(5379),
    [anon_sym_u2200] = ACTIONS(5379),
    [anon_sym_BSLASHE] = ACTIONS(5377),
    [anon_sym_BSLASHexists] = ACTIONS(5379),
    [anon_sym_u2203] = ACTIONS(5379),
    [sym_temporal_forall] = ACTIONS(5379),
    [sym_temporal_exists] = ACTIONS(5379),
    [anon_sym_LT_LT] = ACTIONS(5379),
    [anon_sym_u3008] = ACTIONS(5379),
    [anon_sym_u27e8] = ACTIONS(5379),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5379),
    [anon_sym_u25a1] = ACTIONS(5379),
    [anon_sym_AT] = ACTIONS(5377),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5379),
    [anon_sym_u2227] = ACTIONS(5379),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5379),
    [anon_sym_u2228] = ACTIONS(5379),
    [anon_sym_LPAREN] = ACTIONS(5377),
    [anon_sym_LBRACK] = ACTIONS(5377),
    [aux_sym_child_id_token1] = ACTIONS(5377),
    [sym_real_number] = ACTIONS(5379),
    [anon_sym_BSLASHb] = ACTIONS(5377),
    [anon_sym_BSLASHB] = ACTIONS(5379),
    [anon_sym_BSLASHo] = ACTIONS(5377),
    [anon_sym_BSLASHO] = ACTIONS(5379),
    [anon_sym_BSLASHh] = ACTIONS(5379),
    [anon_sym_BSLASHH] = ACTIONS(5379),
    [anon_sym_DQUOTE] = ACTIONS(5379),
    [anon_sym_TRUE] = ACTIONS(5377),
    [anon_sym_FALSE] = ACTIONS(5377),
    [sym_string_set] = ACTIONS(5377),
    [sym_boolean_set] = ACTIONS(5377),
    [anon_sym_Nat] = ACTIONS(5377),
    [anon_sym_u2115] = ACTIONS(5379),
    [anon_sym_Int] = ACTIONS(5377),
    [anon_sym_u2124] = ACTIONS(5379),
    [anon_sym_Real] = ACTIONS(5377),
    [anon_sym_u211d] = ACTIONS(5379),
    [anon_sym_CHOOSE] = ACTIONS(5377),
    [anon_sym_LBRACE] = ACTIONS(5379),
    [anon_sym_EQ] = ACTIONS(5377),
    [anon_sym_WF_] = ACTIONS(5377),
    [anon_sym_SF_] = ACTIONS(5377),
    [anon_sym_IF] = ACTIONS(5377),
    [anon_sym_CASE] = ACTIONS(5377),
    [anon_sym_LET] = ACTIONS(5377),
    [anon_sym_BSLASHlnot] = ACTIONS(5379),
    [anon_sym_BSLASHneg] = ACTIONS(5379),
    [anon_sym_TILDE] = ACTIONS(5377),
    [anon_sym_u00ac] = ACTIONS(5379),
    [sym_union] = ACTIONS(5377),
    [sym_powerset] = ACTIONS(5377),
    [sym_domain] = ACTIONS(5377),
    [anon_sym_DASH] = ACTIONS(5377),
    [sym_negative_dot] = ACTIONS(5379),
    [sym_enabled] = ACTIONS(5377),
    [sym_unchanged] = ACTIONS(5377),
    [anon_sym_LT_GT] = ACTIONS(5379),
    [anon_sym_u22c4] = ACTIONS(5379),
    [anon_sym_u25c7] = ACTIONS(5379),
    [anon_sym_EQ_GT] = ACTIONS(5379),
    [anon_sym_u27f9] = ACTIONS(5379),
    [anon_sym_u21d2] = ACTIONS(5379),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5379),
    [anon_sym_u21f8] = ACTIONS(5379),
    [anon_sym_u2945] = ACTIONS(5379),
    [anon_sym_BSLASHequiv] = ACTIONS(5379),
    [anon_sym_u2261] = ACTIONS(5379),
    [anon_sym_LT_EQ_GT] = ACTIONS(5379),
    [anon_sym_u27fa] = ACTIONS(5379),
    [anon_sym_u21d4] = ACTIONS(5379),
    [anon_sym_TILDE_GT] = ACTIONS(5379),
    [anon_sym_u21dd] = ACTIONS(5379),
    [anon_sym_u219d] = ACTIONS(5379),
    [anon_sym_BSLASHland] = ACTIONS(5379),
    [anon_sym_BSLASHlor] = ACTIONS(5379),
    [anon_sym_COLON_EQ] = ACTIONS(5379),
    [anon_sym_u2254] = ACTIONS(5379),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5379),
    [anon_sym_u2a74] = ACTIONS(5379),
    [anon_sym_SLASH_EQ] = ACTIONS(5379),
    [anon_sym_POUND] = ACTIONS(5377),
    [anon_sym_u2260] = ACTIONS(5379),
    [anon_sym_LT] = ACTIONS(5377),
    [sym_gt] = ACTIONS(5377),
    [anon_sym_LT_EQ] = ACTIONS(5377),
    [anon_sym_EQ_LT] = ACTIONS(5379),
    [anon_sym_BSLASHleq] = ACTIONS(5379),
    [anon_sym_u2264] = ACTIONS(5379),
    [anon_sym_GT_EQ] = ACTIONS(5379),
    [anon_sym_BSLASHgeq] = ACTIONS(5379),
    [anon_sym_u2265] = ACTIONS(5379),
    [anon_sym_BSLASHapprox] = ACTIONS(5379),
    [anon_sym_u2248] = ACTIONS(5379),
    [anon_sym_PIPE_DASH] = ACTIONS(5379),
    [anon_sym_u22a2] = ACTIONS(5379),
    [anon_sym_PIPE_EQ] = ACTIONS(5379),
    [anon_sym_u22a8] = ACTIONS(5379),
    [anon_sym_DASH_PIPE] = ACTIONS(5379),
    [anon_sym_u22a3] = ACTIONS(5379),
    [anon_sym_EQ_PIPE] = ACTIONS(5379),
    [anon_sym_u2ae4] = ACTIONS(5379),
    [anon_sym_BSLASHasymp] = ACTIONS(5379),
    [anon_sym_u224d] = ACTIONS(5379),
    [anon_sym_BSLASHcong] = ACTIONS(5379),
    [anon_sym_u2245] = ACTIONS(5379),
    [anon_sym_BSLASHdoteq] = ACTIONS(5379),
    [anon_sym_u2250] = ACTIONS(5379),
    [anon_sym_BSLASHgg] = ACTIONS(5379),
    [anon_sym_u226b] = ACTIONS(5379),
    [anon_sym_BSLASHll] = ACTIONS(5379),
    [anon_sym_u226a] = ACTIONS(5379),
    [anon_sym_BSLASHnotin] = ACTIONS(5379),
    [anon_sym_u2209] = ACTIONS(5379),
    [anon_sym_BSLASHprec] = ACTIONS(5377),
    [anon_sym_u227a] = ACTIONS(5379),
    [anon_sym_BSLASHsucc] = ACTIONS(5377),
    [anon_sym_u227b] = ACTIONS(5379),
    [anon_sym_BSLASHpreceq] = ACTIONS(5379),
    [anon_sym_u2aaf] = ACTIONS(5379),
    [anon_sym_BSLASHsucceq] = ACTIONS(5379),
    [anon_sym_u2ab0] = ACTIONS(5379),
    [anon_sym_BSLASHpropto] = ACTIONS(5379),
    [anon_sym_u221d] = ACTIONS(5379),
    [anon_sym_BSLASHsim] = ACTIONS(5377),
    [anon_sym_u223c] = ACTIONS(5379),
    [anon_sym_BSLASHsimeq] = ACTIONS(5379),
    [anon_sym_u2243] = ACTIONS(5379),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5377),
    [anon_sym_u228f] = ACTIONS(5379),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5377),
    [anon_sym_u2290] = ACTIONS(5379),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5379),
    [anon_sym_u2291] = ACTIONS(5379),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5379),
    [anon_sym_u2292] = ACTIONS(5379),
    [anon_sym_BSLASHsubset] = ACTIONS(5377),
    [anon_sym_u2282] = ACTIONS(5379),
    [anon_sym_BSLASHsupset] = ACTIONS(5377),
    [anon_sym_u2283] = ACTIONS(5379),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5379),
    [anon_sym_u2286] = ACTIONS(5379),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5379),
    [anon_sym_u2287] = ACTIONS(5379),
    [sym_compose] = ACTIONS(5379),
    [sym_map_to] = ACTIONS(5379),
    [sym_map_from] = ACTIONS(5379),
    [sym_setminus] = ACTIONS(5377),
    [anon_sym_BSLASHcap] = ACTIONS(5379),
    [anon_sym_BSLASHintersect] = ACTIONS(5379),
    [anon_sym_u2229] = ACTIONS(5379),
    [anon_sym_BSLASHcup] = ACTIONS(5379),
    [anon_sym_BSLASHunion] = ACTIONS(5379),
    [anon_sym_u222a] = ACTIONS(5379),
    [anon_sym_DOT_DOT] = ACTIONS(5377),
    [anon_sym_u2025] = ACTIONS(5379),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5379),
    [anon_sym_u2026] = ACTIONS(5379),
    [anon_sym_PLUS] = ACTIONS(5377),
    [sym_plusplus] = ACTIONS(5379),
    [anon_sym_BSLASHoplus] = ACTIONS(5379),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5379),
    [anon_sym_u2295] = ACTIONS(5379),
    [anon_sym_BSLASHominus] = ACTIONS(5379),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5379),
    [anon_sym_u2296] = ACTIONS(5379),
    [sym_mod] = ACTIONS(5377),
    [sym_modmod] = ACTIONS(5379),
    [sym_vert] = ACTIONS(5377),
    [anon_sym_PIPE_PIPE] = ACTIONS(5379),
    [anon_sym_u2016] = ACTIONS(5379),
    [sym_minusminus] = ACTIONS(5379),
    [sym_amp] = ACTIONS(5377),
    [sym_ampamp] = ACTIONS(5379),
    [anon_sym_BSLASHodot] = ACTIONS(5379),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5379),
    [anon_sym_u2299] = ACTIONS(5379),
    [anon_sym_BSLASHoslash] = ACTIONS(5379),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5379),
    [anon_sym_u2298] = ACTIONS(5379),
    [anon_sym_BSLASHotimes] = ACTIONS(5379),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5379),
    [anon_sym_u2297] = ACTIONS(5379),
    [sym_mul] = ACTIONS(5377),
    [sym_mulmul] = ACTIONS(5379),
    [sym_slash] = ACTIONS(5377),
    [sym_slashslash] = ACTIONS(5379),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5379),
    [anon_sym_u25ef] = ACTIONS(5379),
    [anon_sym_BSLASHbullet] = ACTIONS(5379),
    [anon_sym_u25cf] = ACTIONS(5379),
    [anon_sym_BSLASHdiv] = ACTIONS(5379),
    [anon_sym_u00f7] = ACTIONS(5379),
    [anon_sym_BSLASHcirc] = ACTIONS(5379),
    [anon_sym_u2218] = ACTIONS(5379),
    [anon_sym_BSLASHstar] = ACTIONS(5379),
    [anon_sym_u22c6] = ACTIONS(5379),
    [anon_sym_u203c] = ACTIONS(5379),
    [sym_hashhash] = ACTIONS(5379),
    [sym_dol] = ACTIONS(5377),
    [sym_doldol] = ACTIONS(5379),
    [anon_sym_QMARK_QMARK] = ACTIONS(5379),
    [anon_sym_u2047] = ACTIONS(5379),
    [anon_sym_BSLASHsqcap] = ACTIONS(5379),
    [anon_sym_u2293] = ACTIONS(5379),
    [anon_sym_BSLASHsqcup] = ACTIONS(5379),
    [anon_sym_u2294] = ACTIONS(5379),
    [anon_sym_BSLASHuplus] = ACTIONS(5379),
    [anon_sym_u228e] = ACTIONS(5379),
    [anon_sym_BSLASHX] = ACTIONS(5379),
    [anon_sym_BSLASHtimes] = ACTIONS(5379),
    [anon_sym_u00d7] = ACTIONS(5379),
    [anon_sym_BSLASHwr] = ACTIONS(5379),
    [anon_sym_u2240] = ACTIONS(5379),
    [anon_sym_BSLASHcdot] = ACTIONS(5379),
    [anon_sym_u22c5] = ACTIONS(5379),
    [sym_pow] = ACTIONS(5377),
    [sym_powpow] = ACTIONS(5379),
    [anon_sym_CARET_PLUS] = ACTIONS(5379),
    [anon_sym_u207a] = ACTIONS(5379),
    [sym_asterisk] = ACTIONS(5379),
    [sym_sup_hash] = ACTIONS(5379),
    [sym_prime] = ACTIONS(5379),
    [sym__indent] = ACTIONS(5379),
    [sym__double_excl] = ACTIONS(5379),
  },
  [2142] = {
    [sym_block_comment] = STATE(2142),
    [sym_identifier] = ACTIONS(5381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5381),
    [anon_sym_u2208] = ACTIONS(5383),
    [anon_sym_BSLASHA] = ACTIONS(5381),
    [anon_sym_BSLASHforall] = ACTIONS(5383),
    [anon_sym_u2200] = ACTIONS(5383),
    [anon_sym_BSLASHE] = ACTIONS(5381),
    [anon_sym_BSLASHexists] = ACTIONS(5383),
    [anon_sym_u2203] = ACTIONS(5383),
    [sym_temporal_forall] = ACTIONS(5383),
    [sym_temporal_exists] = ACTIONS(5383),
    [anon_sym_LT_LT] = ACTIONS(5383),
    [anon_sym_u3008] = ACTIONS(5383),
    [anon_sym_u27e8] = ACTIONS(5383),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5383),
    [anon_sym_u25a1] = ACTIONS(5383),
    [anon_sym_AT] = ACTIONS(5381),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5383),
    [anon_sym_u2227] = ACTIONS(5383),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5383),
    [anon_sym_u2228] = ACTIONS(5383),
    [anon_sym_LPAREN] = ACTIONS(5381),
    [anon_sym_LBRACK] = ACTIONS(5381),
    [aux_sym_child_id_token1] = ACTIONS(5381),
    [sym_real_number] = ACTIONS(5383),
    [anon_sym_BSLASHb] = ACTIONS(5381),
    [anon_sym_BSLASHB] = ACTIONS(5383),
    [anon_sym_BSLASHo] = ACTIONS(5381),
    [anon_sym_BSLASHO] = ACTIONS(5383),
    [anon_sym_BSLASHh] = ACTIONS(5383),
    [anon_sym_BSLASHH] = ACTIONS(5383),
    [anon_sym_DQUOTE] = ACTIONS(5383),
    [anon_sym_TRUE] = ACTIONS(5381),
    [anon_sym_FALSE] = ACTIONS(5381),
    [sym_string_set] = ACTIONS(5381),
    [sym_boolean_set] = ACTIONS(5381),
    [anon_sym_Nat] = ACTIONS(5381),
    [anon_sym_u2115] = ACTIONS(5383),
    [anon_sym_Int] = ACTIONS(5381),
    [anon_sym_u2124] = ACTIONS(5383),
    [anon_sym_Real] = ACTIONS(5381),
    [anon_sym_u211d] = ACTIONS(5383),
    [anon_sym_CHOOSE] = ACTIONS(5381),
    [anon_sym_LBRACE] = ACTIONS(5383),
    [anon_sym_EQ] = ACTIONS(5381),
    [anon_sym_WF_] = ACTIONS(5381),
    [anon_sym_SF_] = ACTIONS(5381),
    [anon_sym_IF] = ACTIONS(5381),
    [anon_sym_CASE] = ACTIONS(5381),
    [anon_sym_LET] = ACTIONS(5381),
    [anon_sym_BSLASHlnot] = ACTIONS(5383),
    [anon_sym_BSLASHneg] = ACTIONS(5383),
    [anon_sym_TILDE] = ACTIONS(5381),
    [anon_sym_u00ac] = ACTIONS(5383),
    [sym_union] = ACTIONS(5381),
    [sym_powerset] = ACTIONS(5381),
    [sym_domain] = ACTIONS(5381),
    [anon_sym_DASH] = ACTIONS(5381),
    [sym_negative_dot] = ACTIONS(5383),
    [sym_enabled] = ACTIONS(5381),
    [sym_unchanged] = ACTIONS(5381),
    [anon_sym_LT_GT] = ACTIONS(5383),
    [anon_sym_u22c4] = ACTIONS(5383),
    [anon_sym_u25c7] = ACTIONS(5383),
    [anon_sym_EQ_GT] = ACTIONS(5383),
    [anon_sym_u27f9] = ACTIONS(5383),
    [anon_sym_u21d2] = ACTIONS(5383),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5383),
    [anon_sym_u21f8] = ACTIONS(5383),
    [anon_sym_u2945] = ACTIONS(5383),
    [anon_sym_BSLASHequiv] = ACTIONS(5383),
    [anon_sym_u2261] = ACTIONS(5383),
    [anon_sym_LT_EQ_GT] = ACTIONS(5383),
    [anon_sym_u27fa] = ACTIONS(5383),
    [anon_sym_u21d4] = ACTIONS(5383),
    [anon_sym_TILDE_GT] = ACTIONS(5383),
    [anon_sym_u21dd] = ACTIONS(5383),
    [anon_sym_u219d] = ACTIONS(5383),
    [anon_sym_BSLASHland] = ACTIONS(5383),
    [anon_sym_BSLASHlor] = ACTIONS(5383),
    [anon_sym_COLON_EQ] = ACTIONS(5383),
    [anon_sym_u2254] = ACTIONS(5383),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5383),
    [anon_sym_u2a74] = ACTIONS(5383),
    [anon_sym_SLASH_EQ] = ACTIONS(5383),
    [anon_sym_POUND] = ACTIONS(5381),
    [anon_sym_u2260] = ACTIONS(5383),
    [anon_sym_LT] = ACTIONS(5381),
    [sym_gt] = ACTIONS(5381),
    [anon_sym_LT_EQ] = ACTIONS(5381),
    [anon_sym_EQ_LT] = ACTIONS(5383),
    [anon_sym_BSLASHleq] = ACTIONS(5383),
    [anon_sym_u2264] = ACTIONS(5383),
    [anon_sym_GT_EQ] = ACTIONS(5383),
    [anon_sym_BSLASHgeq] = ACTIONS(5383),
    [anon_sym_u2265] = ACTIONS(5383),
    [anon_sym_BSLASHapprox] = ACTIONS(5383),
    [anon_sym_u2248] = ACTIONS(5383),
    [anon_sym_PIPE_DASH] = ACTIONS(5383),
    [anon_sym_u22a2] = ACTIONS(5383),
    [anon_sym_PIPE_EQ] = ACTIONS(5383),
    [anon_sym_u22a8] = ACTIONS(5383),
    [anon_sym_DASH_PIPE] = ACTIONS(5383),
    [anon_sym_u22a3] = ACTIONS(5383),
    [anon_sym_EQ_PIPE] = ACTIONS(5383),
    [anon_sym_u2ae4] = ACTIONS(5383),
    [anon_sym_BSLASHasymp] = ACTIONS(5383),
    [anon_sym_u224d] = ACTIONS(5383),
    [anon_sym_BSLASHcong] = ACTIONS(5383),
    [anon_sym_u2245] = ACTIONS(5383),
    [anon_sym_BSLASHdoteq] = ACTIONS(5383),
    [anon_sym_u2250] = ACTIONS(5383),
    [anon_sym_BSLASHgg] = ACTIONS(5383),
    [anon_sym_u226b] = ACTIONS(5383),
    [anon_sym_BSLASHll] = ACTIONS(5383),
    [anon_sym_u226a] = ACTIONS(5383),
    [anon_sym_BSLASHnotin] = ACTIONS(5383),
    [anon_sym_u2209] = ACTIONS(5383),
    [anon_sym_BSLASHprec] = ACTIONS(5381),
    [anon_sym_u227a] = ACTIONS(5383),
    [anon_sym_BSLASHsucc] = ACTIONS(5381),
    [anon_sym_u227b] = ACTIONS(5383),
    [anon_sym_BSLASHpreceq] = ACTIONS(5383),
    [anon_sym_u2aaf] = ACTIONS(5383),
    [anon_sym_BSLASHsucceq] = ACTIONS(5383),
    [anon_sym_u2ab0] = ACTIONS(5383),
    [anon_sym_BSLASHpropto] = ACTIONS(5383),
    [anon_sym_u221d] = ACTIONS(5383),
    [anon_sym_BSLASHsim] = ACTIONS(5381),
    [anon_sym_u223c] = ACTIONS(5383),
    [anon_sym_BSLASHsimeq] = ACTIONS(5383),
    [anon_sym_u2243] = ACTIONS(5383),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5381),
    [anon_sym_u228f] = ACTIONS(5383),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5381),
    [anon_sym_u2290] = ACTIONS(5383),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5383),
    [anon_sym_u2291] = ACTIONS(5383),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5383),
    [anon_sym_u2292] = ACTIONS(5383),
    [anon_sym_BSLASHsubset] = ACTIONS(5381),
    [anon_sym_u2282] = ACTIONS(5383),
    [anon_sym_BSLASHsupset] = ACTIONS(5381),
    [anon_sym_u2283] = ACTIONS(5383),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5383),
    [anon_sym_u2286] = ACTIONS(5383),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5383),
    [anon_sym_u2287] = ACTIONS(5383),
    [sym_compose] = ACTIONS(5383),
    [sym_map_to] = ACTIONS(5383),
    [sym_map_from] = ACTIONS(5383),
    [sym_setminus] = ACTIONS(5381),
    [anon_sym_BSLASHcap] = ACTIONS(5383),
    [anon_sym_BSLASHintersect] = ACTIONS(5383),
    [anon_sym_u2229] = ACTIONS(5383),
    [anon_sym_BSLASHcup] = ACTIONS(5383),
    [anon_sym_BSLASHunion] = ACTIONS(5383),
    [anon_sym_u222a] = ACTIONS(5383),
    [anon_sym_DOT_DOT] = ACTIONS(5381),
    [anon_sym_u2025] = ACTIONS(5383),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5383),
    [anon_sym_u2026] = ACTIONS(5383),
    [anon_sym_PLUS] = ACTIONS(5381),
    [sym_plusplus] = ACTIONS(5383),
    [anon_sym_BSLASHoplus] = ACTIONS(5383),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5383),
    [anon_sym_u2295] = ACTIONS(5383),
    [anon_sym_BSLASHominus] = ACTIONS(5383),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5383),
    [anon_sym_u2296] = ACTIONS(5383),
    [sym_mod] = ACTIONS(5381),
    [sym_modmod] = ACTIONS(5383),
    [sym_vert] = ACTIONS(5381),
    [anon_sym_PIPE_PIPE] = ACTIONS(5383),
    [anon_sym_u2016] = ACTIONS(5383),
    [sym_minusminus] = ACTIONS(5383),
    [sym_amp] = ACTIONS(5381),
    [sym_ampamp] = ACTIONS(5383),
    [anon_sym_BSLASHodot] = ACTIONS(5383),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5383),
    [anon_sym_u2299] = ACTIONS(5383),
    [anon_sym_BSLASHoslash] = ACTIONS(5383),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5383),
    [anon_sym_u2298] = ACTIONS(5383),
    [anon_sym_BSLASHotimes] = ACTIONS(5383),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5383),
    [anon_sym_u2297] = ACTIONS(5383),
    [sym_mul] = ACTIONS(5381),
    [sym_mulmul] = ACTIONS(5383),
    [sym_slash] = ACTIONS(5381),
    [sym_slashslash] = ACTIONS(5383),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5383),
    [anon_sym_u25ef] = ACTIONS(5383),
    [anon_sym_BSLASHbullet] = ACTIONS(5383),
    [anon_sym_u25cf] = ACTIONS(5383),
    [anon_sym_BSLASHdiv] = ACTIONS(5383),
    [anon_sym_u00f7] = ACTIONS(5383),
    [anon_sym_BSLASHcirc] = ACTIONS(5383),
    [anon_sym_u2218] = ACTIONS(5383),
    [anon_sym_BSLASHstar] = ACTIONS(5383),
    [anon_sym_u22c6] = ACTIONS(5383),
    [anon_sym_u203c] = ACTIONS(5383),
    [sym_hashhash] = ACTIONS(5383),
    [sym_dol] = ACTIONS(5381),
    [sym_doldol] = ACTIONS(5383),
    [anon_sym_QMARK_QMARK] = ACTIONS(5383),
    [anon_sym_u2047] = ACTIONS(5383),
    [anon_sym_BSLASHsqcap] = ACTIONS(5383),
    [anon_sym_u2293] = ACTIONS(5383),
    [anon_sym_BSLASHsqcup] = ACTIONS(5383),
    [anon_sym_u2294] = ACTIONS(5383),
    [anon_sym_BSLASHuplus] = ACTIONS(5383),
    [anon_sym_u228e] = ACTIONS(5383),
    [anon_sym_BSLASHX] = ACTIONS(5383),
    [anon_sym_BSLASHtimes] = ACTIONS(5383),
    [anon_sym_u00d7] = ACTIONS(5383),
    [anon_sym_BSLASHwr] = ACTIONS(5383),
    [anon_sym_u2240] = ACTIONS(5383),
    [anon_sym_BSLASHcdot] = ACTIONS(5383),
    [anon_sym_u22c5] = ACTIONS(5383),
    [sym_pow] = ACTIONS(5381),
    [sym_powpow] = ACTIONS(5383),
    [anon_sym_CARET_PLUS] = ACTIONS(5383),
    [anon_sym_u207a] = ACTIONS(5383),
    [sym_asterisk] = ACTIONS(5383),
    [sym_sup_hash] = ACTIONS(5383),
    [sym_prime] = ACTIONS(5383),
    [sym__indent] = ACTIONS(5383),
    [sym__double_excl] = ACTIONS(5383),
  },
  [2143] = {
    [sym_block_comment] = STATE(2143),
    [sym_identifier] = ACTIONS(5385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5385),
    [anon_sym_u2208] = ACTIONS(5387),
    [anon_sym_BSLASHA] = ACTIONS(5385),
    [anon_sym_BSLASHforall] = ACTIONS(5387),
    [anon_sym_u2200] = ACTIONS(5387),
    [anon_sym_BSLASHE] = ACTIONS(5385),
    [anon_sym_BSLASHexists] = ACTIONS(5387),
    [anon_sym_u2203] = ACTIONS(5387),
    [sym_temporal_forall] = ACTIONS(5387),
    [sym_temporal_exists] = ACTIONS(5387),
    [anon_sym_LT_LT] = ACTIONS(5387),
    [anon_sym_u3008] = ACTIONS(5387),
    [anon_sym_u27e8] = ACTIONS(5387),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5387),
    [anon_sym_u25a1] = ACTIONS(5387),
    [anon_sym_AT] = ACTIONS(5385),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5387),
    [anon_sym_u2227] = ACTIONS(5387),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5387),
    [anon_sym_u2228] = ACTIONS(5387),
    [anon_sym_LPAREN] = ACTIONS(5385),
    [anon_sym_LBRACK] = ACTIONS(5385),
    [aux_sym_child_id_token1] = ACTIONS(5385),
    [sym_real_number] = ACTIONS(5387),
    [anon_sym_BSLASHb] = ACTIONS(5385),
    [anon_sym_BSLASHB] = ACTIONS(5387),
    [anon_sym_BSLASHo] = ACTIONS(5385),
    [anon_sym_BSLASHO] = ACTIONS(5387),
    [anon_sym_BSLASHh] = ACTIONS(5387),
    [anon_sym_BSLASHH] = ACTIONS(5387),
    [anon_sym_DQUOTE] = ACTIONS(5387),
    [anon_sym_TRUE] = ACTIONS(5385),
    [anon_sym_FALSE] = ACTIONS(5385),
    [sym_string_set] = ACTIONS(5385),
    [sym_boolean_set] = ACTIONS(5385),
    [anon_sym_Nat] = ACTIONS(5385),
    [anon_sym_u2115] = ACTIONS(5387),
    [anon_sym_Int] = ACTIONS(5385),
    [anon_sym_u2124] = ACTIONS(5387),
    [anon_sym_Real] = ACTIONS(5385),
    [anon_sym_u211d] = ACTIONS(5387),
    [anon_sym_CHOOSE] = ACTIONS(5385),
    [anon_sym_LBRACE] = ACTIONS(5387),
    [anon_sym_EQ] = ACTIONS(5385),
    [anon_sym_WF_] = ACTIONS(5385),
    [anon_sym_SF_] = ACTIONS(5385),
    [anon_sym_IF] = ACTIONS(5385),
    [anon_sym_CASE] = ACTIONS(5385),
    [anon_sym_LET] = ACTIONS(5385),
    [anon_sym_BSLASHlnot] = ACTIONS(5387),
    [anon_sym_BSLASHneg] = ACTIONS(5387),
    [anon_sym_TILDE] = ACTIONS(5385),
    [anon_sym_u00ac] = ACTIONS(5387),
    [sym_union] = ACTIONS(5385),
    [sym_powerset] = ACTIONS(5385),
    [sym_domain] = ACTIONS(5385),
    [anon_sym_DASH] = ACTIONS(5385),
    [sym_negative_dot] = ACTIONS(5387),
    [sym_enabled] = ACTIONS(5385),
    [sym_unchanged] = ACTIONS(5385),
    [anon_sym_LT_GT] = ACTIONS(5387),
    [anon_sym_u22c4] = ACTIONS(5387),
    [anon_sym_u25c7] = ACTIONS(5387),
    [anon_sym_EQ_GT] = ACTIONS(5387),
    [anon_sym_u27f9] = ACTIONS(5387),
    [anon_sym_u21d2] = ACTIONS(5387),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5387),
    [anon_sym_u21f8] = ACTIONS(5387),
    [anon_sym_u2945] = ACTIONS(5387),
    [anon_sym_BSLASHequiv] = ACTIONS(5387),
    [anon_sym_u2261] = ACTIONS(5387),
    [anon_sym_LT_EQ_GT] = ACTIONS(5387),
    [anon_sym_u27fa] = ACTIONS(5387),
    [anon_sym_u21d4] = ACTIONS(5387),
    [anon_sym_TILDE_GT] = ACTIONS(5387),
    [anon_sym_u21dd] = ACTIONS(5387),
    [anon_sym_u219d] = ACTIONS(5387),
    [anon_sym_BSLASHland] = ACTIONS(5387),
    [anon_sym_BSLASHlor] = ACTIONS(5387),
    [anon_sym_COLON_EQ] = ACTIONS(5387),
    [anon_sym_u2254] = ACTIONS(5387),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5387),
    [anon_sym_u2a74] = ACTIONS(5387),
    [anon_sym_SLASH_EQ] = ACTIONS(5387),
    [anon_sym_POUND] = ACTIONS(5385),
    [anon_sym_u2260] = ACTIONS(5387),
    [anon_sym_LT] = ACTIONS(5385),
    [sym_gt] = ACTIONS(5385),
    [anon_sym_LT_EQ] = ACTIONS(5385),
    [anon_sym_EQ_LT] = ACTIONS(5387),
    [anon_sym_BSLASHleq] = ACTIONS(5387),
    [anon_sym_u2264] = ACTIONS(5387),
    [anon_sym_GT_EQ] = ACTIONS(5387),
    [anon_sym_BSLASHgeq] = ACTIONS(5387),
    [anon_sym_u2265] = ACTIONS(5387),
    [anon_sym_BSLASHapprox] = ACTIONS(5387),
    [anon_sym_u2248] = ACTIONS(5387),
    [anon_sym_PIPE_DASH] = ACTIONS(5387),
    [anon_sym_u22a2] = ACTIONS(5387),
    [anon_sym_PIPE_EQ] = ACTIONS(5387),
    [anon_sym_u22a8] = ACTIONS(5387),
    [anon_sym_DASH_PIPE] = ACTIONS(5387),
    [anon_sym_u22a3] = ACTIONS(5387),
    [anon_sym_EQ_PIPE] = ACTIONS(5387),
    [anon_sym_u2ae4] = ACTIONS(5387),
    [anon_sym_BSLASHasymp] = ACTIONS(5387),
    [anon_sym_u224d] = ACTIONS(5387),
    [anon_sym_BSLASHcong] = ACTIONS(5387),
    [anon_sym_u2245] = ACTIONS(5387),
    [anon_sym_BSLASHdoteq] = ACTIONS(5387),
    [anon_sym_u2250] = ACTIONS(5387),
    [anon_sym_BSLASHgg] = ACTIONS(5387),
    [anon_sym_u226b] = ACTIONS(5387),
    [anon_sym_BSLASHll] = ACTIONS(5387),
    [anon_sym_u226a] = ACTIONS(5387),
    [anon_sym_BSLASHnotin] = ACTIONS(5387),
    [anon_sym_u2209] = ACTIONS(5387),
    [anon_sym_BSLASHprec] = ACTIONS(5385),
    [anon_sym_u227a] = ACTIONS(5387),
    [anon_sym_BSLASHsucc] = ACTIONS(5385),
    [anon_sym_u227b] = ACTIONS(5387),
    [anon_sym_BSLASHpreceq] = ACTIONS(5387),
    [anon_sym_u2aaf] = ACTIONS(5387),
    [anon_sym_BSLASHsucceq] = ACTIONS(5387),
    [anon_sym_u2ab0] = ACTIONS(5387),
    [anon_sym_BSLASHpropto] = ACTIONS(5387),
    [anon_sym_u221d] = ACTIONS(5387),
    [anon_sym_BSLASHsim] = ACTIONS(5385),
    [anon_sym_u223c] = ACTIONS(5387),
    [anon_sym_BSLASHsimeq] = ACTIONS(5387),
    [anon_sym_u2243] = ACTIONS(5387),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5385),
    [anon_sym_u228f] = ACTIONS(5387),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5385),
    [anon_sym_u2290] = ACTIONS(5387),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5387),
    [anon_sym_u2291] = ACTIONS(5387),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5387),
    [anon_sym_u2292] = ACTIONS(5387),
    [anon_sym_BSLASHsubset] = ACTIONS(5385),
    [anon_sym_u2282] = ACTIONS(5387),
    [anon_sym_BSLASHsupset] = ACTIONS(5385),
    [anon_sym_u2283] = ACTIONS(5387),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5387),
    [anon_sym_u2286] = ACTIONS(5387),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5387),
    [anon_sym_u2287] = ACTIONS(5387),
    [sym_compose] = ACTIONS(5387),
    [sym_map_to] = ACTIONS(5387),
    [sym_map_from] = ACTIONS(5387),
    [sym_setminus] = ACTIONS(5385),
    [anon_sym_BSLASHcap] = ACTIONS(5387),
    [anon_sym_BSLASHintersect] = ACTIONS(5387),
    [anon_sym_u2229] = ACTIONS(5387),
    [anon_sym_BSLASHcup] = ACTIONS(5387),
    [anon_sym_BSLASHunion] = ACTIONS(5387),
    [anon_sym_u222a] = ACTIONS(5387),
    [anon_sym_DOT_DOT] = ACTIONS(5385),
    [anon_sym_u2025] = ACTIONS(5387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5387),
    [anon_sym_u2026] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5385),
    [sym_plusplus] = ACTIONS(5387),
    [anon_sym_BSLASHoplus] = ACTIONS(5387),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5387),
    [anon_sym_u2295] = ACTIONS(5387),
    [anon_sym_BSLASHominus] = ACTIONS(5387),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5387),
    [anon_sym_u2296] = ACTIONS(5387),
    [sym_mod] = ACTIONS(5385),
    [sym_modmod] = ACTIONS(5387),
    [sym_vert] = ACTIONS(5385),
    [anon_sym_PIPE_PIPE] = ACTIONS(5387),
    [anon_sym_u2016] = ACTIONS(5387),
    [sym_minusminus] = ACTIONS(5387),
    [sym_amp] = ACTIONS(5385),
    [sym_ampamp] = ACTIONS(5387),
    [anon_sym_BSLASHodot] = ACTIONS(5387),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5387),
    [anon_sym_u2299] = ACTIONS(5387),
    [anon_sym_BSLASHoslash] = ACTIONS(5387),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5387),
    [anon_sym_u2298] = ACTIONS(5387),
    [anon_sym_BSLASHotimes] = ACTIONS(5387),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5387),
    [anon_sym_u2297] = ACTIONS(5387),
    [sym_mul] = ACTIONS(5385),
    [sym_mulmul] = ACTIONS(5387),
    [sym_slash] = ACTIONS(5385),
    [sym_slashslash] = ACTIONS(5387),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5387),
    [anon_sym_u25ef] = ACTIONS(5387),
    [anon_sym_BSLASHbullet] = ACTIONS(5387),
    [anon_sym_u25cf] = ACTIONS(5387),
    [anon_sym_BSLASHdiv] = ACTIONS(5387),
    [anon_sym_u00f7] = ACTIONS(5387),
    [anon_sym_BSLASHcirc] = ACTIONS(5387),
    [anon_sym_u2218] = ACTIONS(5387),
    [anon_sym_BSLASHstar] = ACTIONS(5387),
    [anon_sym_u22c6] = ACTIONS(5387),
    [anon_sym_u203c] = ACTIONS(5387),
    [sym_hashhash] = ACTIONS(5387),
    [sym_dol] = ACTIONS(5385),
    [sym_doldol] = ACTIONS(5387),
    [anon_sym_QMARK_QMARK] = ACTIONS(5387),
    [anon_sym_u2047] = ACTIONS(5387),
    [anon_sym_BSLASHsqcap] = ACTIONS(5387),
    [anon_sym_u2293] = ACTIONS(5387),
    [anon_sym_BSLASHsqcup] = ACTIONS(5387),
    [anon_sym_u2294] = ACTIONS(5387),
    [anon_sym_BSLASHuplus] = ACTIONS(5387),
    [anon_sym_u228e] = ACTIONS(5387),
    [anon_sym_BSLASHX] = ACTIONS(5387),
    [anon_sym_BSLASHtimes] = ACTIONS(5387),
    [anon_sym_u00d7] = ACTIONS(5387),
    [anon_sym_BSLASHwr] = ACTIONS(5387),
    [anon_sym_u2240] = ACTIONS(5387),
    [anon_sym_BSLASHcdot] = ACTIONS(5387),
    [anon_sym_u22c5] = ACTIONS(5387),
    [sym_pow] = ACTIONS(5385),
    [sym_powpow] = ACTIONS(5387),
    [anon_sym_CARET_PLUS] = ACTIONS(5387),
    [anon_sym_u207a] = ACTIONS(5387),
    [sym_asterisk] = ACTIONS(5387),
    [sym_sup_hash] = ACTIONS(5387),
    [sym_prime] = ACTIONS(5387),
    [sym__indent] = ACTIONS(5387),
    [sym__double_excl] = ACTIONS(5387),
  },
  [2144] = {
    [sym_block_comment] = STATE(2144),
    [sym_identifier] = ACTIONS(5389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5389),
    [anon_sym_u2208] = ACTIONS(5391),
    [anon_sym_BSLASHA] = ACTIONS(5389),
    [anon_sym_BSLASHforall] = ACTIONS(5391),
    [anon_sym_u2200] = ACTIONS(5391),
    [anon_sym_BSLASHE] = ACTIONS(5389),
    [anon_sym_BSLASHexists] = ACTIONS(5391),
    [anon_sym_u2203] = ACTIONS(5391),
    [sym_temporal_forall] = ACTIONS(5391),
    [sym_temporal_exists] = ACTIONS(5391),
    [anon_sym_LT_LT] = ACTIONS(5391),
    [anon_sym_u3008] = ACTIONS(5391),
    [anon_sym_u27e8] = ACTIONS(5391),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5391),
    [anon_sym_u25a1] = ACTIONS(5391),
    [anon_sym_AT] = ACTIONS(5389),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5391),
    [anon_sym_u2227] = ACTIONS(5391),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5391),
    [anon_sym_u2228] = ACTIONS(5391),
    [anon_sym_LPAREN] = ACTIONS(5389),
    [anon_sym_LBRACK] = ACTIONS(5389),
    [aux_sym_child_id_token1] = ACTIONS(5389),
    [sym_real_number] = ACTIONS(5391),
    [anon_sym_BSLASHb] = ACTIONS(5389),
    [anon_sym_BSLASHB] = ACTIONS(5391),
    [anon_sym_BSLASHo] = ACTIONS(5389),
    [anon_sym_BSLASHO] = ACTIONS(5391),
    [anon_sym_BSLASHh] = ACTIONS(5391),
    [anon_sym_BSLASHH] = ACTIONS(5391),
    [anon_sym_DQUOTE] = ACTIONS(5391),
    [anon_sym_TRUE] = ACTIONS(5389),
    [anon_sym_FALSE] = ACTIONS(5389),
    [sym_string_set] = ACTIONS(5389),
    [sym_boolean_set] = ACTIONS(5389),
    [anon_sym_Nat] = ACTIONS(5389),
    [anon_sym_u2115] = ACTIONS(5391),
    [anon_sym_Int] = ACTIONS(5389),
    [anon_sym_u2124] = ACTIONS(5391),
    [anon_sym_Real] = ACTIONS(5389),
    [anon_sym_u211d] = ACTIONS(5391),
    [anon_sym_CHOOSE] = ACTIONS(5389),
    [anon_sym_LBRACE] = ACTIONS(5391),
    [anon_sym_EQ] = ACTIONS(5389),
    [anon_sym_WF_] = ACTIONS(5389),
    [anon_sym_SF_] = ACTIONS(5389),
    [anon_sym_IF] = ACTIONS(5389),
    [anon_sym_CASE] = ACTIONS(5389),
    [anon_sym_LET] = ACTIONS(5389),
    [anon_sym_BSLASHlnot] = ACTIONS(5391),
    [anon_sym_BSLASHneg] = ACTIONS(5391),
    [anon_sym_TILDE] = ACTIONS(5389),
    [anon_sym_u00ac] = ACTIONS(5391),
    [sym_union] = ACTIONS(5389),
    [sym_powerset] = ACTIONS(5389),
    [sym_domain] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5389),
    [sym_negative_dot] = ACTIONS(5391),
    [sym_enabled] = ACTIONS(5389),
    [sym_unchanged] = ACTIONS(5389),
    [anon_sym_LT_GT] = ACTIONS(5391),
    [anon_sym_u22c4] = ACTIONS(5391),
    [anon_sym_u25c7] = ACTIONS(5391),
    [anon_sym_EQ_GT] = ACTIONS(5391),
    [anon_sym_u27f9] = ACTIONS(5391),
    [anon_sym_u21d2] = ACTIONS(5391),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5391),
    [anon_sym_u21f8] = ACTIONS(5391),
    [anon_sym_u2945] = ACTIONS(5391),
    [anon_sym_BSLASHequiv] = ACTIONS(5391),
    [anon_sym_u2261] = ACTIONS(5391),
    [anon_sym_LT_EQ_GT] = ACTIONS(5391),
    [anon_sym_u27fa] = ACTIONS(5391),
    [anon_sym_u21d4] = ACTIONS(5391),
    [anon_sym_TILDE_GT] = ACTIONS(5391),
    [anon_sym_u21dd] = ACTIONS(5391),
    [anon_sym_u219d] = ACTIONS(5391),
    [anon_sym_BSLASHland] = ACTIONS(5391),
    [anon_sym_BSLASHlor] = ACTIONS(5391),
    [anon_sym_COLON_EQ] = ACTIONS(5391),
    [anon_sym_u2254] = ACTIONS(5391),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5391),
    [anon_sym_u2a74] = ACTIONS(5391),
    [anon_sym_SLASH_EQ] = ACTIONS(5391),
    [anon_sym_POUND] = ACTIONS(5389),
    [anon_sym_u2260] = ACTIONS(5391),
    [anon_sym_LT] = ACTIONS(5389),
    [sym_gt] = ACTIONS(5389),
    [anon_sym_LT_EQ] = ACTIONS(5389),
    [anon_sym_EQ_LT] = ACTIONS(5391),
    [anon_sym_BSLASHleq] = ACTIONS(5391),
    [anon_sym_u2264] = ACTIONS(5391),
    [anon_sym_GT_EQ] = ACTIONS(5391),
    [anon_sym_BSLASHgeq] = ACTIONS(5391),
    [anon_sym_u2265] = ACTIONS(5391),
    [anon_sym_BSLASHapprox] = ACTIONS(5391),
    [anon_sym_u2248] = ACTIONS(5391),
    [anon_sym_PIPE_DASH] = ACTIONS(5391),
    [anon_sym_u22a2] = ACTIONS(5391),
    [anon_sym_PIPE_EQ] = ACTIONS(5391),
    [anon_sym_u22a8] = ACTIONS(5391),
    [anon_sym_DASH_PIPE] = ACTIONS(5391),
    [anon_sym_u22a3] = ACTIONS(5391),
    [anon_sym_EQ_PIPE] = ACTIONS(5391),
    [anon_sym_u2ae4] = ACTIONS(5391),
    [anon_sym_BSLASHasymp] = ACTIONS(5391),
    [anon_sym_u224d] = ACTIONS(5391),
    [anon_sym_BSLASHcong] = ACTIONS(5391),
    [anon_sym_u2245] = ACTIONS(5391),
    [anon_sym_BSLASHdoteq] = ACTIONS(5391),
    [anon_sym_u2250] = ACTIONS(5391),
    [anon_sym_BSLASHgg] = ACTIONS(5391),
    [anon_sym_u226b] = ACTIONS(5391),
    [anon_sym_BSLASHll] = ACTIONS(5391),
    [anon_sym_u226a] = ACTIONS(5391),
    [anon_sym_BSLASHnotin] = ACTIONS(5391),
    [anon_sym_u2209] = ACTIONS(5391),
    [anon_sym_BSLASHprec] = ACTIONS(5389),
    [anon_sym_u227a] = ACTIONS(5391),
    [anon_sym_BSLASHsucc] = ACTIONS(5389),
    [anon_sym_u227b] = ACTIONS(5391),
    [anon_sym_BSLASHpreceq] = ACTIONS(5391),
    [anon_sym_u2aaf] = ACTIONS(5391),
    [anon_sym_BSLASHsucceq] = ACTIONS(5391),
    [anon_sym_u2ab0] = ACTIONS(5391),
    [anon_sym_BSLASHpropto] = ACTIONS(5391),
    [anon_sym_u221d] = ACTIONS(5391),
    [anon_sym_BSLASHsim] = ACTIONS(5389),
    [anon_sym_u223c] = ACTIONS(5391),
    [anon_sym_BSLASHsimeq] = ACTIONS(5391),
    [anon_sym_u2243] = ACTIONS(5391),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5389),
    [anon_sym_u228f] = ACTIONS(5391),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5389),
    [anon_sym_u2290] = ACTIONS(5391),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5391),
    [anon_sym_u2291] = ACTIONS(5391),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5391),
    [anon_sym_u2292] = ACTIONS(5391),
    [anon_sym_BSLASHsubset] = ACTIONS(5389),
    [anon_sym_u2282] = ACTIONS(5391),
    [anon_sym_BSLASHsupset] = ACTIONS(5389),
    [anon_sym_u2283] = ACTIONS(5391),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5391),
    [anon_sym_u2286] = ACTIONS(5391),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5391),
    [anon_sym_u2287] = ACTIONS(5391),
    [sym_compose] = ACTIONS(5391),
    [sym_map_to] = ACTIONS(5391),
    [sym_map_from] = ACTIONS(5391),
    [sym_setminus] = ACTIONS(5389),
    [anon_sym_BSLASHcap] = ACTIONS(5391),
    [anon_sym_BSLASHintersect] = ACTIONS(5391),
    [anon_sym_u2229] = ACTIONS(5391),
    [anon_sym_BSLASHcup] = ACTIONS(5391),
    [anon_sym_BSLASHunion] = ACTIONS(5391),
    [anon_sym_u222a] = ACTIONS(5391),
    [anon_sym_DOT_DOT] = ACTIONS(5389),
    [anon_sym_u2025] = ACTIONS(5391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5391),
    [anon_sym_u2026] = ACTIONS(5391),
    [anon_sym_PLUS] = ACTIONS(5389),
    [sym_plusplus] = ACTIONS(5391),
    [anon_sym_BSLASHoplus] = ACTIONS(5391),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5391),
    [anon_sym_u2295] = ACTIONS(5391),
    [anon_sym_BSLASHominus] = ACTIONS(5391),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5391),
    [anon_sym_u2296] = ACTIONS(5391),
    [sym_mod] = ACTIONS(5389),
    [sym_modmod] = ACTIONS(5391),
    [sym_vert] = ACTIONS(5389),
    [anon_sym_PIPE_PIPE] = ACTIONS(5391),
    [anon_sym_u2016] = ACTIONS(5391),
    [sym_minusminus] = ACTIONS(5391),
    [sym_amp] = ACTIONS(5389),
    [sym_ampamp] = ACTIONS(5391),
    [anon_sym_BSLASHodot] = ACTIONS(5391),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5391),
    [anon_sym_u2299] = ACTIONS(5391),
    [anon_sym_BSLASHoslash] = ACTIONS(5391),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5391),
    [anon_sym_u2298] = ACTIONS(5391),
    [anon_sym_BSLASHotimes] = ACTIONS(5391),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5391),
    [anon_sym_u2297] = ACTIONS(5391),
    [sym_mul] = ACTIONS(5389),
    [sym_mulmul] = ACTIONS(5391),
    [sym_slash] = ACTIONS(5389),
    [sym_slashslash] = ACTIONS(5391),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5391),
    [anon_sym_u25ef] = ACTIONS(5391),
    [anon_sym_BSLASHbullet] = ACTIONS(5391),
    [anon_sym_u25cf] = ACTIONS(5391),
    [anon_sym_BSLASHdiv] = ACTIONS(5391),
    [anon_sym_u00f7] = ACTIONS(5391),
    [anon_sym_BSLASHcirc] = ACTIONS(5391),
    [anon_sym_u2218] = ACTIONS(5391),
    [anon_sym_BSLASHstar] = ACTIONS(5391),
    [anon_sym_u22c6] = ACTIONS(5391),
    [anon_sym_u203c] = ACTIONS(5391),
    [sym_hashhash] = ACTIONS(5391),
    [sym_dol] = ACTIONS(5389),
    [sym_doldol] = ACTIONS(5391),
    [anon_sym_QMARK_QMARK] = ACTIONS(5391),
    [anon_sym_u2047] = ACTIONS(5391),
    [anon_sym_BSLASHsqcap] = ACTIONS(5391),
    [anon_sym_u2293] = ACTIONS(5391),
    [anon_sym_BSLASHsqcup] = ACTIONS(5391),
    [anon_sym_u2294] = ACTIONS(5391),
    [anon_sym_BSLASHuplus] = ACTIONS(5391),
    [anon_sym_u228e] = ACTIONS(5391),
    [anon_sym_BSLASHX] = ACTIONS(5391),
    [anon_sym_BSLASHtimes] = ACTIONS(5391),
    [anon_sym_u00d7] = ACTIONS(5391),
    [anon_sym_BSLASHwr] = ACTIONS(5391),
    [anon_sym_u2240] = ACTIONS(5391),
    [anon_sym_BSLASHcdot] = ACTIONS(5391),
    [anon_sym_u22c5] = ACTIONS(5391),
    [sym_pow] = ACTIONS(5389),
    [sym_powpow] = ACTIONS(5391),
    [anon_sym_CARET_PLUS] = ACTIONS(5391),
    [anon_sym_u207a] = ACTIONS(5391),
    [sym_asterisk] = ACTIONS(5391),
    [sym_sup_hash] = ACTIONS(5391),
    [sym_prime] = ACTIONS(5391),
    [sym__indent] = ACTIONS(5391),
    [sym__double_excl] = ACTIONS(5391),
  },
  [2145] = {
    [sym_block_comment] = STATE(2145),
    [sym_identifier] = ACTIONS(5393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5393),
    [anon_sym_u2208] = ACTIONS(5395),
    [anon_sym_BSLASHA] = ACTIONS(5393),
    [anon_sym_BSLASHforall] = ACTIONS(5395),
    [anon_sym_u2200] = ACTIONS(5395),
    [anon_sym_BSLASHE] = ACTIONS(5393),
    [anon_sym_BSLASHexists] = ACTIONS(5395),
    [anon_sym_u2203] = ACTIONS(5395),
    [sym_temporal_forall] = ACTIONS(5395),
    [sym_temporal_exists] = ACTIONS(5395),
    [anon_sym_LT_LT] = ACTIONS(5395),
    [anon_sym_u3008] = ACTIONS(5395),
    [anon_sym_u27e8] = ACTIONS(5395),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5395),
    [anon_sym_u25a1] = ACTIONS(5395),
    [anon_sym_AT] = ACTIONS(5393),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5395),
    [anon_sym_u2227] = ACTIONS(5395),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5395),
    [anon_sym_u2228] = ACTIONS(5395),
    [anon_sym_LPAREN] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [aux_sym_child_id_token1] = ACTIONS(5393),
    [sym_real_number] = ACTIONS(5395),
    [anon_sym_BSLASHb] = ACTIONS(5393),
    [anon_sym_BSLASHB] = ACTIONS(5395),
    [anon_sym_BSLASHo] = ACTIONS(5393),
    [anon_sym_BSLASHO] = ACTIONS(5395),
    [anon_sym_BSLASHh] = ACTIONS(5395),
    [anon_sym_BSLASHH] = ACTIONS(5395),
    [anon_sym_DQUOTE] = ACTIONS(5395),
    [anon_sym_TRUE] = ACTIONS(5393),
    [anon_sym_FALSE] = ACTIONS(5393),
    [sym_string_set] = ACTIONS(5393),
    [sym_boolean_set] = ACTIONS(5393),
    [anon_sym_Nat] = ACTIONS(5393),
    [anon_sym_u2115] = ACTIONS(5395),
    [anon_sym_Int] = ACTIONS(5393),
    [anon_sym_u2124] = ACTIONS(5395),
    [anon_sym_Real] = ACTIONS(5393),
    [anon_sym_u211d] = ACTIONS(5395),
    [anon_sym_CHOOSE] = ACTIONS(5393),
    [anon_sym_LBRACE] = ACTIONS(5395),
    [anon_sym_EQ] = ACTIONS(5393),
    [anon_sym_WF_] = ACTIONS(5393),
    [anon_sym_SF_] = ACTIONS(5393),
    [anon_sym_IF] = ACTIONS(5393),
    [anon_sym_CASE] = ACTIONS(5393),
    [anon_sym_LET] = ACTIONS(5393),
    [anon_sym_BSLASHlnot] = ACTIONS(5395),
    [anon_sym_BSLASHneg] = ACTIONS(5395),
    [anon_sym_TILDE] = ACTIONS(5393),
    [anon_sym_u00ac] = ACTIONS(5395),
    [sym_union] = ACTIONS(5393),
    [sym_powerset] = ACTIONS(5393),
    [sym_domain] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5393),
    [sym_negative_dot] = ACTIONS(5395),
    [sym_enabled] = ACTIONS(5393),
    [sym_unchanged] = ACTIONS(5393),
    [anon_sym_LT_GT] = ACTIONS(5395),
    [anon_sym_u22c4] = ACTIONS(5395),
    [anon_sym_u25c7] = ACTIONS(5395),
    [anon_sym_EQ_GT] = ACTIONS(5395),
    [anon_sym_u27f9] = ACTIONS(5395),
    [anon_sym_u21d2] = ACTIONS(5395),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5395),
    [anon_sym_u21f8] = ACTIONS(5395),
    [anon_sym_u2945] = ACTIONS(5395),
    [anon_sym_BSLASHequiv] = ACTIONS(5395),
    [anon_sym_u2261] = ACTIONS(5395),
    [anon_sym_LT_EQ_GT] = ACTIONS(5395),
    [anon_sym_u27fa] = ACTIONS(5395),
    [anon_sym_u21d4] = ACTIONS(5395),
    [anon_sym_TILDE_GT] = ACTIONS(5395),
    [anon_sym_u21dd] = ACTIONS(5395),
    [anon_sym_u219d] = ACTIONS(5395),
    [anon_sym_BSLASHland] = ACTIONS(5395),
    [anon_sym_BSLASHlor] = ACTIONS(5395),
    [anon_sym_COLON_EQ] = ACTIONS(5395),
    [anon_sym_u2254] = ACTIONS(5395),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5395),
    [anon_sym_u2a74] = ACTIONS(5395),
    [anon_sym_SLASH_EQ] = ACTIONS(5395),
    [anon_sym_POUND] = ACTIONS(5393),
    [anon_sym_u2260] = ACTIONS(5395),
    [anon_sym_LT] = ACTIONS(5393),
    [sym_gt] = ACTIONS(5393),
    [anon_sym_LT_EQ] = ACTIONS(5393),
    [anon_sym_EQ_LT] = ACTIONS(5395),
    [anon_sym_BSLASHleq] = ACTIONS(5395),
    [anon_sym_u2264] = ACTIONS(5395),
    [anon_sym_GT_EQ] = ACTIONS(5395),
    [anon_sym_BSLASHgeq] = ACTIONS(5395),
    [anon_sym_u2265] = ACTIONS(5395),
    [anon_sym_BSLASHapprox] = ACTIONS(5395),
    [anon_sym_u2248] = ACTIONS(5395),
    [anon_sym_PIPE_DASH] = ACTIONS(5395),
    [anon_sym_u22a2] = ACTIONS(5395),
    [anon_sym_PIPE_EQ] = ACTIONS(5395),
    [anon_sym_u22a8] = ACTIONS(5395),
    [anon_sym_DASH_PIPE] = ACTIONS(5395),
    [anon_sym_u22a3] = ACTIONS(5395),
    [anon_sym_EQ_PIPE] = ACTIONS(5395),
    [anon_sym_u2ae4] = ACTIONS(5395),
    [anon_sym_BSLASHasymp] = ACTIONS(5395),
    [anon_sym_u224d] = ACTIONS(5395),
    [anon_sym_BSLASHcong] = ACTIONS(5395),
    [anon_sym_u2245] = ACTIONS(5395),
    [anon_sym_BSLASHdoteq] = ACTIONS(5395),
    [anon_sym_u2250] = ACTIONS(5395),
    [anon_sym_BSLASHgg] = ACTIONS(5395),
    [anon_sym_u226b] = ACTIONS(5395),
    [anon_sym_BSLASHll] = ACTIONS(5395),
    [anon_sym_u226a] = ACTIONS(5395),
    [anon_sym_BSLASHnotin] = ACTIONS(5395),
    [anon_sym_u2209] = ACTIONS(5395),
    [anon_sym_BSLASHprec] = ACTIONS(5393),
    [anon_sym_u227a] = ACTIONS(5395),
    [anon_sym_BSLASHsucc] = ACTIONS(5393),
    [anon_sym_u227b] = ACTIONS(5395),
    [anon_sym_BSLASHpreceq] = ACTIONS(5395),
    [anon_sym_u2aaf] = ACTIONS(5395),
    [anon_sym_BSLASHsucceq] = ACTIONS(5395),
    [anon_sym_u2ab0] = ACTIONS(5395),
    [anon_sym_BSLASHpropto] = ACTIONS(5395),
    [anon_sym_u221d] = ACTIONS(5395),
    [anon_sym_BSLASHsim] = ACTIONS(5393),
    [anon_sym_u223c] = ACTIONS(5395),
    [anon_sym_BSLASHsimeq] = ACTIONS(5395),
    [anon_sym_u2243] = ACTIONS(5395),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5393),
    [anon_sym_u228f] = ACTIONS(5395),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5393),
    [anon_sym_u2290] = ACTIONS(5395),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5395),
    [anon_sym_u2291] = ACTIONS(5395),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5395),
    [anon_sym_u2292] = ACTIONS(5395),
    [anon_sym_BSLASHsubset] = ACTIONS(5393),
    [anon_sym_u2282] = ACTIONS(5395),
    [anon_sym_BSLASHsupset] = ACTIONS(5393),
    [anon_sym_u2283] = ACTIONS(5395),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5395),
    [anon_sym_u2286] = ACTIONS(5395),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5395),
    [anon_sym_u2287] = ACTIONS(5395),
    [sym_compose] = ACTIONS(5395),
    [sym_map_to] = ACTIONS(5395),
    [sym_map_from] = ACTIONS(5395),
    [sym_setminus] = ACTIONS(5393),
    [anon_sym_BSLASHcap] = ACTIONS(5395),
    [anon_sym_BSLASHintersect] = ACTIONS(5395),
    [anon_sym_u2229] = ACTIONS(5395),
    [anon_sym_BSLASHcup] = ACTIONS(5395),
    [anon_sym_BSLASHunion] = ACTIONS(5395),
    [anon_sym_u222a] = ACTIONS(5395),
    [anon_sym_DOT_DOT] = ACTIONS(5393),
    [anon_sym_u2025] = ACTIONS(5395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5395),
    [anon_sym_u2026] = ACTIONS(5395),
    [anon_sym_PLUS] = ACTIONS(5393),
    [sym_plusplus] = ACTIONS(5395),
    [anon_sym_BSLASHoplus] = ACTIONS(5395),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5395),
    [anon_sym_u2295] = ACTIONS(5395),
    [anon_sym_BSLASHominus] = ACTIONS(5395),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5395),
    [anon_sym_u2296] = ACTIONS(5395),
    [sym_mod] = ACTIONS(5393),
    [sym_modmod] = ACTIONS(5395),
    [sym_vert] = ACTIONS(5393),
    [anon_sym_PIPE_PIPE] = ACTIONS(5395),
    [anon_sym_u2016] = ACTIONS(5395),
    [sym_minusminus] = ACTIONS(5395),
    [sym_amp] = ACTIONS(5393),
    [sym_ampamp] = ACTIONS(5395),
    [anon_sym_BSLASHodot] = ACTIONS(5395),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5395),
    [anon_sym_u2299] = ACTIONS(5395),
    [anon_sym_BSLASHoslash] = ACTIONS(5395),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5395),
    [anon_sym_u2298] = ACTIONS(5395),
    [anon_sym_BSLASHotimes] = ACTIONS(5395),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5395),
    [anon_sym_u2297] = ACTIONS(5395),
    [sym_mul] = ACTIONS(5393),
    [sym_mulmul] = ACTIONS(5395),
    [sym_slash] = ACTIONS(5393),
    [sym_slashslash] = ACTIONS(5395),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5395),
    [anon_sym_u25ef] = ACTIONS(5395),
    [anon_sym_BSLASHbullet] = ACTIONS(5395),
    [anon_sym_u25cf] = ACTIONS(5395),
    [anon_sym_BSLASHdiv] = ACTIONS(5395),
    [anon_sym_u00f7] = ACTIONS(5395),
    [anon_sym_BSLASHcirc] = ACTIONS(5395),
    [anon_sym_u2218] = ACTIONS(5395),
    [anon_sym_BSLASHstar] = ACTIONS(5395),
    [anon_sym_u22c6] = ACTIONS(5395),
    [anon_sym_u203c] = ACTIONS(5395),
    [sym_hashhash] = ACTIONS(5395),
    [sym_dol] = ACTIONS(5393),
    [sym_doldol] = ACTIONS(5395),
    [anon_sym_QMARK_QMARK] = ACTIONS(5395),
    [anon_sym_u2047] = ACTIONS(5395),
    [anon_sym_BSLASHsqcap] = ACTIONS(5395),
    [anon_sym_u2293] = ACTIONS(5395),
    [anon_sym_BSLASHsqcup] = ACTIONS(5395),
    [anon_sym_u2294] = ACTIONS(5395),
    [anon_sym_BSLASHuplus] = ACTIONS(5395),
    [anon_sym_u228e] = ACTIONS(5395),
    [anon_sym_BSLASHX] = ACTIONS(5395),
    [anon_sym_BSLASHtimes] = ACTIONS(5395),
    [anon_sym_u00d7] = ACTIONS(5395),
    [anon_sym_BSLASHwr] = ACTIONS(5395),
    [anon_sym_u2240] = ACTIONS(5395),
    [anon_sym_BSLASHcdot] = ACTIONS(5395),
    [anon_sym_u22c5] = ACTIONS(5395),
    [sym_pow] = ACTIONS(5393),
    [sym_powpow] = ACTIONS(5395),
    [anon_sym_CARET_PLUS] = ACTIONS(5395),
    [anon_sym_u207a] = ACTIONS(5395),
    [sym_asterisk] = ACTIONS(5395),
    [sym_sup_hash] = ACTIONS(5395),
    [sym_prime] = ACTIONS(5395),
    [sym__indent] = ACTIONS(5395),
    [sym__double_excl] = ACTIONS(5395),
  },
  [2146] = {
    [sym_block_comment] = STATE(2146),
    [sym_identifier] = ACTIONS(5397),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5397),
    [anon_sym_u2208] = ACTIONS(5399),
    [anon_sym_BSLASHA] = ACTIONS(5397),
    [anon_sym_BSLASHforall] = ACTIONS(5399),
    [anon_sym_u2200] = ACTIONS(5399),
    [anon_sym_BSLASHE] = ACTIONS(5397),
    [anon_sym_BSLASHexists] = ACTIONS(5399),
    [anon_sym_u2203] = ACTIONS(5399),
    [sym_temporal_forall] = ACTIONS(5399),
    [sym_temporal_exists] = ACTIONS(5399),
    [anon_sym_LT_LT] = ACTIONS(5399),
    [anon_sym_u3008] = ACTIONS(5399),
    [anon_sym_u27e8] = ACTIONS(5399),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5399),
    [anon_sym_u25a1] = ACTIONS(5399),
    [anon_sym_AT] = ACTIONS(5397),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5399),
    [anon_sym_u2227] = ACTIONS(5399),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5399),
    [anon_sym_u2228] = ACTIONS(5399),
    [anon_sym_LPAREN] = ACTIONS(5397),
    [anon_sym_LBRACK] = ACTIONS(5397),
    [aux_sym_child_id_token1] = ACTIONS(5397),
    [sym_real_number] = ACTIONS(5399),
    [anon_sym_BSLASHb] = ACTIONS(5397),
    [anon_sym_BSLASHB] = ACTIONS(5399),
    [anon_sym_BSLASHo] = ACTIONS(5397),
    [anon_sym_BSLASHO] = ACTIONS(5399),
    [anon_sym_BSLASHh] = ACTIONS(5399),
    [anon_sym_BSLASHH] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(5399),
    [anon_sym_TRUE] = ACTIONS(5397),
    [anon_sym_FALSE] = ACTIONS(5397),
    [sym_string_set] = ACTIONS(5397),
    [sym_boolean_set] = ACTIONS(5397),
    [anon_sym_Nat] = ACTIONS(5397),
    [anon_sym_u2115] = ACTIONS(5399),
    [anon_sym_Int] = ACTIONS(5397),
    [anon_sym_u2124] = ACTIONS(5399),
    [anon_sym_Real] = ACTIONS(5397),
    [anon_sym_u211d] = ACTIONS(5399),
    [anon_sym_CHOOSE] = ACTIONS(5397),
    [anon_sym_LBRACE] = ACTIONS(5399),
    [anon_sym_EQ] = ACTIONS(5397),
    [anon_sym_WF_] = ACTIONS(5397),
    [anon_sym_SF_] = ACTIONS(5397),
    [anon_sym_IF] = ACTIONS(5397),
    [anon_sym_CASE] = ACTIONS(5397),
    [anon_sym_LET] = ACTIONS(5397),
    [anon_sym_BSLASHlnot] = ACTIONS(5399),
    [anon_sym_BSLASHneg] = ACTIONS(5399),
    [anon_sym_TILDE] = ACTIONS(5397),
    [anon_sym_u00ac] = ACTIONS(5399),
    [sym_union] = ACTIONS(5397),
    [sym_powerset] = ACTIONS(5397),
    [sym_domain] = ACTIONS(5397),
    [anon_sym_DASH] = ACTIONS(5397),
    [sym_negative_dot] = ACTIONS(5399),
    [sym_enabled] = ACTIONS(5397),
    [sym_unchanged] = ACTIONS(5397),
    [anon_sym_LT_GT] = ACTIONS(5399),
    [anon_sym_u22c4] = ACTIONS(5399),
    [anon_sym_u25c7] = ACTIONS(5399),
    [anon_sym_EQ_GT] = ACTIONS(5399),
    [anon_sym_u27f9] = ACTIONS(5399),
    [anon_sym_u21d2] = ACTIONS(5399),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5399),
    [anon_sym_u21f8] = ACTIONS(5399),
    [anon_sym_u2945] = ACTIONS(5399),
    [anon_sym_BSLASHequiv] = ACTIONS(5399),
    [anon_sym_u2261] = ACTIONS(5399),
    [anon_sym_LT_EQ_GT] = ACTIONS(5399),
    [anon_sym_u27fa] = ACTIONS(5399),
    [anon_sym_u21d4] = ACTIONS(5399),
    [anon_sym_TILDE_GT] = ACTIONS(5399),
    [anon_sym_u21dd] = ACTIONS(5399),
    [anon_sym_u219d] = ACTIONS(5399),
    [anon_sym_BSLASHland] = ACTIONS(5399),
    [anon_sym_BSLASHlor] = ACTIONS(5399),
    [anon_sym_COLON_EQ] = ACTIONS(5399),
    [anon_sym_u2254] = ACTIONS(5399),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5399),
    [anon_sym_u2a74] = ACTIONS(5399),
    [anon_sym_SLASH_EQ] = ACTIONS(5399),
    [anon_sym_POUND] = ACTIONS(5397),
    [anon_sym_u2260] = ACTIONS(5399),
    [anon_sym_LT] = ACTIONS(5397),
    [sym_gt] = ACTIONS(5397),
    [anon_sym_LT_EQ] = ACTIONS(5397),
    [anon_sym_EQ_LT] = ACTIONS(5399),
    [anon_sym_BSLASHleq] = ACTIONS(5399),
    [anon_sym_u2264] = ACTIONS(5399),
    [anon_sym_GT_EQ] = ACTIONS(5399),
    [anon_sym_BSLASHgeq] = ACTIONS(5399),
    [anon_sym_u2265] = ACTIONS(5399),
    [anon_sym_BSLASHapprox] = ACTIONS(5399),
    [anon_sym_u2248] = ACTIONS(5399),
    [anon_sym_PIPE_DASH] = ACTIONS(5399),
    [anon_sym_u22a2] = ACTIONS(5399),
    [anon_sym_PIPE_EQ] = ACTIONS(5399),
    [anon_sym_u22a8] = ACTIONS(5399),
    [anon_sym_DASH_PIPE] = ACTIONS(5399),
    [anon_sym_u22a3] = ACTIONS(5399),
    [anon_sym_EQ_PIPE] = ACTIONS(5399),
    [anon_sym_u2ae4] = ACTIONS(5399),
    [anon_sym_BSLASHasymp] = ACTIONS(5399),
    [anon_sym_u224d] = ACTIONS(5399),
    [anon_sym_BSLASHcong] = ACTIONS(5399),
    [anon_sym_u2245] = ACTIONS(5399),
    [anon_sym_BSLASHdoteq] = ACTIONS(5399),
    [anon_sym_u2250] = ACTIONS(5399),
    [anon_sym_BSLASHgg] = ACTIONS(5399),
    [anon_sym_u226b] = ACTIONS(5399),
    [anon_sym_BSLASHll] = ACTIONS(5399),
    [anon_sym_u226a] = ACTIONS(5399),
    [anon_sym_BSLASHnotin] = ACTIONS(5399),
    [anon_sym_u2209] = ACTIONS(5399),
    [anon_sym_BSLASHprec] = ACTIONS(5397),
    [anon_sym_u227a] = ACTIONS(5399),
    [anon_sym_BSLASHsucc] = ACTIONS(5397),
    [anon_sym_u227b] = ACTIONS(5399),
    [anon_sym_BSLASHpreceq] = ACTIONS(5399),
    [anon_sym_u2aaf] = ACTIONS(5399),
    [anon_sym_BSLASHsucceq] = ACTIONS(5399),
    [anon_sym_u2ab0] = ACTIONS(5399),
    [anon_sym_BSLASHpropto] = ACTIONS(5399),
    [anon_sym_u221d] = ACTIONS(5399),
    [anon_sym_BSLASHsim] = ACTIONS(5397),
    [anon_sym_u223c] = ACTIONS(5399),
    [anon_sym_BSLASHsimeq] = ACTIONS(5399),
    [anon_sym_u2243] = ACTIONS(5399),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5397),
    [anon_sym_u228f] = ACTIONS(5399),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5397),
    [anon_sym_u2290] = ACTIONS(5399),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5399),
    [anon_sym_u2291] = ACTIONS(5399),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5399),
    [anon_sym_u2292] = ACTIONS(5399),
    [anon_sym_BSLASHsubset] = ACTIONS(5397),
    [anon_sym_u2282] = ACTIONS(5399),
    [anon_sym_BSLASHsupset] = ACTIONS(5397),
    [anon_sym_u2283] = ACTIONS(5399),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5399),
    [anon_sym_u2286] = ACTIONS(5399),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5399),
    [anon_sym_u2287] = ACTIONS(5399),
    [sym_compose] = ACTIONS(5399),
    [sym_map_to] = ACTIONS(5399),
    [sym_map_from] = ACTIONS(5399),
    [sym_setminus] = ACTIONS(5397),
    [anon_sym_BSLASHcap] = ACTIONS(5399),
    [anon_sym_BSLASHintersect] = ACTIONS(5399),
    [anon_sym_u2229] = ACTIONS(5399),
    [anon_sym_BSLASHcup] = ACTIONS(5399),
    [anon_sym_BSLASHunion] = ACTIONS(5399),
    [anon_sym_u222a] = ACTIONS(5399),
    [anon_sym_DOT_DOT] = ACTIONS(5397),
    [anon_sym_u2025] = ACTIONS(5399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5399),
    [anon_sym_u2026] = ACTIONS(5399),
    [anon_sym_PLUS] = ACTIONS(5397),
    [sym_plusplus] = ACTIONS(5399),
    [anon_sym_BSLASHoplus] = ACTIONS(5399),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5399),
    [anon_sym_u2295] = ACTIONS(5399),
    [anon_sym_BSLASHominus] = ACTIONS(5399),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5399),
    [anon_sym_u2296] = ACTIONS(5399),
    [sym_mod] = ACTIONS(5397),
    [sym_modmod] = ACTIONS(5399),
    [sym_vert] = ACTIONS(5397),
    [anon_sym_PIPE_PIPE] = ACTIONS(5399),
    [anon_sym_u2016] = ACTIONS(5399),
    [sym_minusminus] = ACTIONS(5399),
    [sym_amp] = ACTIONS(5397),
    [sym_ampamp] = ACTIONS(5399),
    [anon_sym_BSLASHodot] = ACTIONS(5399),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5399),
    [anon_sym_u2299] = ACTIONS(5399),
    [anon_sym_BSLASHoslash] = ACTIONS(5399),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5399),
    [anon_sym_u2298] = ACTIONS(5399),
    [anon_sym_BSLASHotimes] = ACTIONS(5399),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5399),
    [anon_sym_u2297] = ACTIONS(5399),
    [sym_mul] = ACTIONS(5397),
    [sym_mulmul] = ACTIONS(5399),
    [sym_slash] = ACTIONS(5397),
    [sym_slashslash] = ACTIONS(5399),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5399),
    [anon_sym_u25ef] = ACTIONS(5399),
    [anon_sym_BSLASHbullet] = ACTIONS(5399),
    [anon_sym_u25cf] = ACTIONS(5399),
    [anon_sym_BSLASHdiv] = ACTIONS(5399),
    [anon_sym_u00f7] = ACTIONS(5399),
    [anon_sym_BSLASHcirc] = ACTIONS(5399),
    [anon_sym_u2218] = ACTIONS(5399),
    [anon_sym_BSLASHstar] = ACTIONS(5399),
    [anon_sym_u22c6] = ACTIONS(5399),
    [anon_sym_u203c] = ACTIONS(5399),
    [sym_hashhash] = ACTIONS(5399),
    [sym_dol] = ACTIONS(5397),
    [sym_doldol] = ACTIONS(5399),
    [anon_sym_QMARK_QMARK] = ACTIONS(5399),
    [anon_sym_u2047] = ACTIONS(5399),
    [anon_sym_BSLASHsqcap] = ACTIONS(5399),
    [anon_sym_u2293] = ACTIONS(5399),
    [anon_sym_BSLASHsqcup] = ACTIONS(5399),
    [anon_sym_u2294] = ACTIONS(5399),
    [anon_sym_BSLASHuplus] = ACTIONS(5399),
    [anon_sym_u228e] = ACTIONS(5399),
    [anon_sym_BSLASHX] = ACTIONS(5399),
    [anon_sym_BSLASHtimes] = ACTIONS(5399),
    [anon_sym_u00d7] = ACTIONS(5399),
    [anon_sym_BSLASHwr] = ACTIONS(5399),
    [anon_sym_u2240] = ACTIONS(5399),
    [anon_sym_BSLASHcdot] = ACTIONS(5399),
    [anon_sym_u22c5] = ACTIONS(5399),
    [sym_pow] = ACTIONS(5397),
    [sym_powpow] = ACTIONS(5399),
    [anon_sym_CARET_PLUS] = ACTIONS(5399),
    [anon_sym_u207a] = ACTIONS(5399),
    [sym_asterisk] = ACTIONS(5399),
    [sym_sup_hash] = ACTIONS(5399),
    [sym_prime] = ACTIONS(5399),
    [sym__indent] = ACTIONS(5399),
    [sym__double_excl] = ACTIONS(5399),
  },
  [2147] = {
    [sym_block_comment] = STATE(2147),
    [sym_identifier] = ACTIONS(5401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5401),
    [anon_sym_u2208] = ACTIONS(5403),
    [anon_sym_BSLASHA] = ACTIONS(5401),
    [anon_sym_BSLASHforall] = ACTIONS(5403),
    [anon_sym_u2200] = ACTIONS(5403),
    [anon_sym_BSLASHE] = ACTIONS(5401),
    [anon_sym_BSLASHexists] = ACTIONS(5403),
    [anon_sym_u2203] = ACTIONS(5403),
    [sym_temporal_forall] = ACTIONS(5403),
    [sym_temporal_exists] = ACTIONS(5403),
    [anon_sym_LT_LT] = ACTIONS(5403),
    [anon_sym_u3008] = ACTIONS(5403),
    [anon_sym_u27e8] = ACTIONS(5403),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5403),
    [anon_sym_u25a1] = ACTIONS(5403),
    [anon_sym_AT] = ACTIONS(5401),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5403),
    [anon_sym_u2227] = ACTIONS(5403),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5403),
    [anon_sym_u2228] = ACTIONS(5403),
    [anon_sym_LPAREN] = ACTIONS(5401),
    [anon_sym_LBRACK] = ACTIONS(5401),
    [aux_sym_child_id_token1] = ACTIONS(5401),
    [sym_real_number] = ACTIONS(5403),
    [anon_sym_BSLASHb] = ACTIONS(5401),
    [anon_sym_BSLASHB] = ACTIONS(5403),
    [anon_sym_BSLASHo] = ACTIONS(5401),
    [anon_sym_BSLASHO] = ACTIONS(5403),
    [anon_sym_BSLASHh] = ACTIONS(5403),
    [anon_sym_BSLASHH] = ACTIONS(5403),
    [anon_sym_DQUOTE] = ACTIONS(5403),
    [anon_sym_TRUE] = ACTIONS(5401),
    [anon_sym_FALSE] = ACTIONS(5401),
    [sym_string_set] = ACTIONS(5401),
    [sym_boolean_set] = ACTIONS(5401),
    [anon_sym_Nat] = ACTIONS(5401),
    [anon_sym_u2115] = ACTIONS(5403),
    [anon_sym_Int] = ACTIONS(5401),
    [anon_sym_u2124] = ACTIONS(5403),
    [anon_sym_Real] = ACTIONS(5401),
    [anon_sym_u211d] = ACTIONS(5403),
    [anon_sym_CHOOSE] = ACTIONS(5401),
    [anon_sym_LBRACE] = ACTIONS(5403),
    [anon_sym_EQ] = ACTIONS(5401),
    [anon_sym_WF_] = ACTIONS(5401),
    [anon_sym_SF_] = ACTIONS(5401),
    [anon_sym_IF] = ACTIONS(5401),
    [anon_sym_CASE] = ACTIONS(5401),
    [anon_sym_LET] = ACTIONS(5401),
    [anon_sym_BSLASHlnot] = ACTIONS(5403),
    [anon_sym_BSLASHneg] = ACTIONS(5403),
    [anon_sym_TILDE] = ACTIONS(5401),
    [anon_sym_u00ac] = ACTIONS(5403),
    [sym_union] = ACTIONS(5401),
    [sym_powerset] = ACTIONS(5401),
    [sym_domain] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5401),
    [sym_negative_dot] = ACTIONS(5403),
    [sym_enabled] = ACTIONS(5401),
    [sym_unchanged] = ACTIONS(5401),
    [anon_sym_LT_GT] = ACTIONS(5403),
    [anon_sym_u22c4] = ACTIONS(5403),
    [anon_sym_u25c7] = ACTIONS(5403),
    [anon_sym_EQ_GT] = ACTIONS(5403),
    [anon_sym_u27f9] = ACTIONS(5403),
    [anon_sym_u21d2] = ACTIONS(5403),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5403),
    [anon_sym_u21f8] = ACTIONS(5403),
    [anon_sym_u2945] = ACTIONS(5403),
    [anon_sym_BSLASHequiv] = ACTIONS(5403),
    [anon_sym_u2261] = ACTIONS(5403),
    [anon_sym_LT_EQ_GT] = ACTIONS(5403),
    [anon_sym_u27fa] = ACTIONS(5403),
    [anon_sym_u21d4] = ACTIONS(5403),
    [anon_sym_TILDE_GT] = ACTIONS(5403),
    [anon_sym_u21dd] = ACTIONS(5403),
    [anon_sym_u219d] = ACTIONS(5403),
    [anon_sym_BSLASHland] = ACTIONS(5403),
    [anon_sym_BSLASHlor] = ACTIONS(5403),
    [anon_sym_COLON_EQ] = ACTIONS(5403),
    [anon_sym_u2254] = ACTIONS(5403),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5403),
    [anon_sym_u2a74] = ACTIONS(5403),
    [anon_sym_SLASH_EQ] = ACTIONS(5403),
    [anon_sym_POUND] = ACTIONS(5401),
    [anon_sym_u2260] = ACTIONS(5403),
    [anon_sym_LT] = ACTIONS(5401),
    [sym_gt] = ACTIONS(5401),
    [anon_sym_LT_EQ] = ACTIONS(5401),
    [anon_sym_EQ_LT] = ACTIONS(5403),
    [anon_sym_BSLASHleq] = ACTIONS(5403),
    [anon_sym_u2264] = ACTIONS(5403),
    [anon_sym_GT_EQ] = ACTIONS(5403),
    [anon_sym_BSLASHgeq] = ACTIONS(5403),
    [anon_sym_u2265] = ACTIONS(5403),
    [anon_sym_BSLASHapprox] = ACTIONS(5403),
    [anon_sym_u2248] = ACTIONS(5403),
    [anon_sym_PIPE_DASH] = ACTIONS(5403),
    [anon_sym_u22a2] = ACTIONS(5403),
    [anon_sym_PIPE_EQ] = ACTIONS(5403),
    [anon_sym_u22a8] = ACTIONS(5403),
    [anon_sym_DASH_PIPE] = ACTIONS(5403),
    [anon_sym_u22a3] = ACTIONS(5403),
    [anon_sym_EQ_PIPE] = ACTIONS(5403),
    [anon_sym_u2ae4] = ACTIONS(5403),
    [anon_sym_BSLASHasymp] = ACTIONS(5403),
    [anon_sym_u224d] = ACTIONS(5403),
    [anon_sym_BSLASHcong] = ACTIONS(5403),
    [anon_sym_u2245] = ACTIONS(5403),
    [anon_sym_BSLASHdoteq] = ACTIONS(5403),
    [anon_sym_u2250] = ACTIONS(5403),
    [anon_sym_BSLASHgg] = ACTIONS(5403),
    [anon_sym_u226b] = ACTIONS(5403),
    [anon_sym_BSLASHll] = ACTIONS(5403),
    [anon_sym_u226a] = ACTIONS(5403),
    [anon_sym_BSLASHnotin] = ACTIONS(5403),
    [anon_sym_u2209] = ACTIONS(5403),
    [anon_sym_BSLASHprec] = ACTIONS(5401),
    [anon_sym_u227a] = ACTIONS(5403),
    [anon_sym_BSLASHsucc] = ACTIONS(5401),
    [anon_sym_u227b] = ACTIONS(5403),
    [anon_sym_BSLASHpreceq] = ACTIONS(5403),
    [anon_sym_u2aaf] = ACTIONS(5403),
    [anon_sym_BSLASHsucceq] = ACTIONS(5403),
    [anon_sym_u2ab0] = ACTIONS(5403),
    [anon_sym_BSLASHpropto] = ACTIONS(5403),
    [anon_sym_u221d] = ACTIONS(5403),
    [anon_sym_BSLASHsim] = ACTIONS(5401),
    [anon_sym_u223c] = ACTIONS(5403),
    [anon_sym_BSLASHsimeq] = ACTIONS(5403),
    [anon_sym_u2243] = ACTIONS(5403),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5401),
    [anon_sym_u228f] = ACTIONS(5403),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5401),
    [anon_sym_u2290] = ACTIONS(5403),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5403),
    [anon_sym_u2291] = ACTIONS(5403),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5403),
    [anon_sym_u2292] = ACTIONS(5403),
    [anon_sym_BSLASHsubset] = ACTIONS(5401),
    [anon_sym_u2282] = ACTIONS(5403),
    [anon_sym_BSLASHsupset] = ACTIONS(5401),
    [anon_sym_u2283] = ACTIONS(5403),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5403),
    [anon_sym_u2286] = ACTIONS(5403),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5403),
    [anon_sym_u2287] = ACTIONS(5403),
    [sym_compose] = ACTIONS(5403),
    [sym_map_to] = ACTIONS(5403),
    [sym_map_from] = ACTIONS(5403),
    [sym_setminus] = ACTIONS(5401),
    [anon_sym_BSLASHcap] = ACTIONS(5403),
    [anon_sym_BSLASHintersect] = ACTIONS(5403),
    [anon_sym_u2229] = ACTIONS(5403),
    [anon_sym_BSLASHcup] = ACTIONS(5403),
    [anon_sym_BSLASHunion] = ACTIONS(5403),
    [anon_sym_u222a] = ACTIONS(5403),
    [anon_sym_DOT_DOT] = ACTIONS(5401),
    [anon_sym_u2025] = ACTIONS(5403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5403),
    [anon_sym_u2026] = ACTIONS(5403),
    [anon_sym_PLUS] = ACTIONS(5401),
    [sym_plusplus] = ACTIONS(5403),
    [anon_sym_BSLASHoplus] = ACTIONS(5403),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5403),
    [anon_sym_u2295] = ACTIONS(5403),
    [anon_sym_BSLASHominus] = ACTIONS(5403),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5403),
    [anon_sym_u2296] = ACTIONS(5403),
    [sym_mod] = ACTIONS(5401),
    [sym_modmod] = ACTIONS(5403),
    [sym_vert] = ACTIONS(5401),
    [anon_sym_PIPE_PIPE] = ACTIONS(5403),
    [anon_sym_u2016] = ACTIONS(5403),
    [sym_minusminus] = ACTIONS(5403),
    [sym_amp] = ACTIONS(5401),
    [sym_ampamp] = ACTIONS(5403),
    [anon_sym_BSLASHodot] = ACTIONS(5403),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5403),
    [anon_sym_u2299] = ACTIONS(5403),
    [anon_sym_BSLASHoslash] = ACTIONS(5403),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5403),
    [anon_sym_u2298] = ACTIONS(5403),
    [anon_sym_BSLASHotimes] = ACTIONS(5403),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5403),
    [anon_sym_u2297] = ACTIONS(5403),
    [sym_mul] = ACTIONS(5401),
    [sym_mulmul] = ACTIONS(5403),
    [sym_slash] = ACTIONS(5401),
    [sym_slashslash] = ACTIONS(5403),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5403),
    [anon_sym_u25ef] = ACTIONS(5403),
    [anon_sym_BSLASHbullet] = ACTIONS(5403),
    [anon_sym_u25cf] = ACTIONS(5403),
    [anon_sym_BSLASHdiv] = ACTIONS(5403),
    [anon_sym_u00f7] = ACTIONS(5403),
    [anon_sym_BSLASHcirc] = ACTIONS(5403),
    [anon_sym_u2218] = ACTIONS(5403),
    [anon_sym_BSLASHstar] = ACTIONS(5403),
    [anon_sym_u22c6] = ACTIONS(5403),
    [anon_sym_u203c] = ACTIONS(5403),
    [sym_hashhash] = ACTIONS(5403),
    [sym_dol] = ACTIONS(5401),
    [sym_doldol] = ACTIONS(5403),
    [anon_sym_QMARK_QMARK] = ACTIONS(5403),
    [anon_sym_u2047] = ACTIONS(5403),
    [anon_sym_BSLASHsqcap] = ACTIONS(5403),
    [anon_sym_u2293] = ACTIONS(5403),
    [anon_sym_BSLASHsqcup] = ACTIONS(5403),
    [anon_sym_u2294] = ACTIONS(5403),
    [anon_sym_BSLASHuplus] = ACTIONS(5403),
    [anon_sym_u228e] = ACTIONS(5403),
    [anon_sym_BSLASHX] = ACTIONS(5403),
    [anon_sym_BSLASHtimes] = ACTIONS(5403),
    [anon_sym_u00d7] = ACTIONS(5403),
    [anon_sym_BSLASHwr] = ACTIONS(5403),
    [anon_sym_u2240] = ACTIONS(5403),
    [anon_sym_BSLASHcdot] = ACTIONS(5403),
    [anon_sym_u22c5] = ACTIONS(5403),
    [sym_pow] = ACTIONS(5401),
    [sym_powpow] = ACTIONS(5403),
    [anon_sym_CARET_PLUS] = ACTIONS(5403),
    [anon_sym_u207a] = ACTIONS(5403),
    [sym_asterisk] = ACTIONS(5403),
    [sym_sup_hash] = ACTIONS(5403),
    [sym_prime] = ACTIONS(5403),
    [sym__indent] = ACTIONS(5403),
    [sym__double_excl] = ACTIONS(5403),
  },
  [2148] = {
    [sym_block_comment] = STATE(2148),
    [sym_identifier] = ACTIONS(5405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5405),
    [anon_sym_u2208] = ACTIONS(5407),
    [anon_sym_BSLASHA] = ACTIONS(5405),
    [anon_sym_BSLASHforall] = ACTIONS(5407),
    [anon_sym_u2200] = ACTIONS(5407),
    [anon_sym_BSLASHE] = ACTIONS(5405),
    [anon_sym_BSLASHexists] = ACTIONS(5407),
    [anon_sym_u2203] = ACTIONS(5407),
    [sym_temporal_forall] = ACTIONS(5407),
    [sym_temporal_exists] = ACTIONS(5407),
    [anon_sym_LT_LT] = ACTIONS(5407),
    [anon_sym_u3008] = ACTIONS(5407),
    [anon_sym_u27e8] = ACTIONS(5407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5407),
    [anon_sym_u25a1] = ACTIONS(5407),
    [anon_sym_AT] = ACTIONS(5405),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5407),
    [anon_sym_u2227] = ACTIONS(5407),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5407),
    [anon_sym_u2228] = ACTIONS(5407),
    [anon_sym_LPAREN] = ACTIONS(5405),
    [anon_sym_LBRACK] = ACTIONS(5405),
    [aux_sym_child_id_token1] = ACTIONS(5405),
    [sym_real_number] = ACTIONS(5407),
    [anon_sym_BSLASHb] = ACTIONS(5405),
    [anon_sym_BSLASHB] = ACTIONS(5407),
    [anon_sym_BSLASHo] = ACTIONS(5405),
    [anon_sym_BSLASHO] = ACTIONS(5407),
    [anon_sym_BSLASHh] = ACTIONS(5407),
    [anon_sym_BSLASHH] = ACTIONS(5407),
    [anon_sym_DQUOTE] = ACTIONS(5407),
    [anon_sym_TRUE] = ACTIONS(5405),
    [anon_sym_FALSE] = ACTIONS(5405),
    [sym_string_set] = ACTIONS(5405),
    [sym_boolean_set] = ACTIONS(5405),
    [anon_sym_Nat] = ACTIONS(5405),
    [anon_sym_u2115] = ACTIONS(5407),
    [anon_sym_Int] = ACTIONS(5405),
    [anon_sym_u2124] = ACTIONS(5407),
    [anon_sym_Real] = ACTIONS(5405),
    [anon_sym_u211d] = ACTIONS(5407),
    [anon_sym_CHOOSE] = ACTIONS(5405),
    [anon_sym_LBRACE] = ACTIONS(5407),
    [anon_sym_EQ] = ACTIONS(5405),
    [anon_sym_WF_] = ACTIONS(5405),
    [anon_sym_SF_] = ACTIONS(5405),
    [anon_sym_IF] = ACTIONS(5405),
    [anon_sym_CASE] = ACTIONS(5405),
    [anon_sym_LET] = ACTIONS(5405),
    [anon_sym_BSLASHlnot] = ACTIONS(5407),
    [anon_sym_BSLASHneg] = ACTIONS(5407),
    [anon_sym_TILDE] = ACTIONS(5405),
    [anon_sym_u00ac] = ACTIONS(5407),
    [sym_union] = ACTIONS(5405),
    [sym_powerset] = ACTIONS(5405),
    [sym_domain] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [sym_negative_dot] = ACTIONS(5407),
    [sym_enabled] = ACTIONS(5405),
    [sym_unchanged] = ACTIONS(5405),
    [anon_sym_LT_GT] = ACTIONS(5407),
    [anon_sym_u22c4] = ACTIONS(5407),
    [anon_sym_u25c7] = ACTIONS(5407),
    [anon_sym_EQ_GT] = ACTIONS(5407),
    [anon_sym_u27f9] = ACTIONS(5407),
    [anon_sym_u21d2] = ACTIONS(5407),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5407),
    [anon_sym_u21f8] = ACTIONS(5407),
    [anon_sym_u2945] = ACTIONS(5407),
    [anon_sym_BSLASHequiv] = ACTIONS(5407),
    [anon_sym_u2261] = ACTIONS(5407),
    [anon_sym_LT_EQ_GT] = ACTIONS(5407),
    [anon_sym_u27fa] = ACTIONS(5407),
    [anon_sym_u21d4] = ACTIONS(5407),
    [anon_sym_TILDE_GT] = ACTIONS(5407),
    [anon_sym_u21dd] = ACTIONS(5407),
    [anon_sym_u219d] = ACTIONS(5407),
    [anon_sym_BSLASHland] = ACTIONS(5407),
    [anon_sym_BSLASHlor] = ACTIONS(5407),
    [anon_sym_COLON_EQ] = ACTIONS(5407),
    [anon_sym_u2254] = ACTIONS(5407),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5407),
    [anon_sym_u2a74] = ACTIONS(5407),
    [anon_sym_SLASH_EQ] = ACTIONS(5407),
    [anon_sym_POUND] = ACTIONS(5405),
    [anon_sym_u2260] = ACTIONS(5407),
    [anon_sym_LT] = ACTIONS(5405),
    [sym_gt] = ACTIONS(5405),
    [anon_sym_LT_EQ] = ACTIONS(5405),
    [anon_sym_EQ_LT] = ACTIONS(5407),
    [anon_sym_BSLASHleq] = ACTIONS(5407),
    [anon_sym_u2264] = ACTIONS(5407),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_BSLASHgeq] = ACTIONS(5407),
    [anon_sym_u2265] = ACTIONS(5407),
    [anon_sym_BSLASHapprox] = ACTIONS(5407),
    [anon_sym_u2248] = ACTIONS(5407),
    [anon_sym_PIPE_DASH] = ACTIONS(5407),
    [anon_sym_u22a2] = ACTIONS(5407),
    [anon_sym_PIPE_EQ] = ACTIONS(5407),
    [anon_sym_u22a8] = ACTIONS(5407),
    [anon_sym_DASH_PIPE] = ACTIONS(5407),
    [anon_sym_u22a3] = ACTIONS(5407),
    [anon_sym_EQ_PIPE] = ACTIONS(5407),
    [anon_sym_u2ae4] = ACTIONS(5407),
    [anon_sym_BSLASHasymp] = ACTIONS(5407),
    [anon_sym_u224d] = ACTIONS(5407),
    [anon_sym_BSLASHcong] = ACTIONS(5407),
    [anon_sym_u2245] = ACTIONS(5407),
    [anon_sym_BSLASHdoteq] = ACTIONS(5407),
    [anon_sym_u2250] = ACTIONS(5407),
    [anon_sym_BSLASHgg] = ACTIONS(5407),
    [anon_sym_u226b] = ACTIONS(5407),
    [anon_sym_BSLASHll] = ACTIONS(5407),
    [anon_sym_u226a] = ACTIONS(5407),
    [anon_sym_BSLASHnotin] = ACTIONS(5407),
    [anon_sym_u2209] = ACTIONS(5407),
    [anon_sym_BSLASHprec] = ACTIONS(5405),
    [anon_sym_u227a] = ACTIONS(5407),
    [anon_sym_BSLASHsucc] = ACTIONS(5405),
    [anon_sym_u227b] = ACTIONS(5407),
    [anon_sym_BSLASHpreceq] = ACTIONS(5407),
    [anon_sym_u2aaf] = ACTIONS(5407),
    [anon_sym_BSLASHsucceq] = ACTIONS(5407),
    [anon_sym_u2ab0] = ACTIONS(5407),
    [anon_sym_BSLASHpropto] = ACTIONS(5407),
    [anon_sym_u221d] = ACTIONS(5407),
    [anon_sym_BSLASHsim] = ACTIONS(5405),
    [anon_sym_u223c] = ACTIONS(5407),
    [anon_sym_BSLASHsimeq] = ACTIONS(5407),
    [anon_sym_u2243] = ACTIONS(5407),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5405),
    [anon_sym_u228f] = ACTIONS(5407),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5405),
    [anon_sym_u2290] = ACTIONS(5407),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5407),
    [anon_sym_u2291] = ACTIONS(5407),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5407),
    [anon_sym_u2292] = ACTIONS(5407),
    [anon_sym_BSLASHsubset] = ACTIONS(5405),
    [anon_sym_u2282] = ACTIONS(5407),
    [anon_sym_BSLASHsupset] = ACTIONS(5405),
    [anon_sym_u2283] = ACTIONS(5407),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5407),
    [anon_sym_u2286] = ACTIONS(5407),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5407),
    [anon_sym_u2287] = ACTIONS(5407),
    [sym_compose] = ACTIONS(5407),
    [sym_map_to] = ACTIONS(5407),
    [sym_map_from] = ACTIONS(5407),
    [sym_setminus] = ACTIONS(5405),
    [anon_sym_BSLASHcap] = ACTIONS(5407),
    [anon_sym_BSLASHintersect] = ACTIONS(5407),
    [anon_sym_u2229] = ACTIONS(5407),
    [anon_sym_BSLASHcup] = ACTIONS(5407),
    [anon_sym_BSLASHunion] = ACTIONS(5407),
    [anon_sym_u222a] = ACTIONS(5407),
    [anon_sym_DOT_DOT] = ACTIONS(5405),
    [anon_sym_u2025] = ACTIONS(5407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5407),
    [anon_sym_u2026] = ACTIONS(5407),
    [anon_sym_PLUS] = ACTIONS(5405),
    [sym_plusplus] = ACTIONS(5407),
    [anon_sym_BSLASHoplus] = ACTIONS(5407),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5407),
    [anon_sym_u2295] = ACTIONS(5407),
    [anon_sym_BSLASHominus] = ACTIONS(5407),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5407),
    [anon_sym_u2296] = ACTIONS(5407),
    [sym_mod] = ACTIONS(5405),
    [sym_modmod] = ACTIONS(5407),
    [sym_vert] = ACTIONS(5405),
    [anon_sym_PIPE_PIPE] = ACTIONS(5407),
    [anon_sym_u2016] = ACTIONS(5407),
    [sym_minusminus] = ACTIONS(5407),
    [sym_amp] = ACTIONS(5405),
    [sym_ampamp] = ACTIONS(5407),
    [anon_sym_BSLASHodot] = ACTIONS(5407),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5407),
    [anon_sym_u2299] = ACTIONS(5407),
    [anon_sym_BSLASHoslash] = ACTIONS(5407),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5407),
    [anon_sym_u2298] = ACTIONS(5407),
    [anon_sym_BSLASHotimes] = ACTIONS(5407),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5407),
    [anon_sym_u2297] = ACTIONS(5407),
    [sym_mul] = ACTIONS(5405),
    [sym_mulmul] = ACTIONS(5407),
    [sym_slash] = ACTIONS(5405),
    [sym_slashslash] = ACTIONS(5407),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5407),
    [anon_sym_u25ef] = ACTIONS(5407),
    [anon_sym_BSLASHbullet] = ACTIONS(5407),
    [anon_sym_u25cf] = ACTIONS(5407),
    [anon_sym_BSLASHdiv] = ACTIONS(5407),
    [anon_sym_u00f7] = ACTIONS(5407),
    [anon_sym_BSLASHcirc] = ACTIONS(5407),
    [anon_sym_u2218] = ACTIONS(5407),
    [anon_sym_BSLASHstar] = ACTIONS(5407),
    [anon_sym_u22c6] = ACTIONS(5407),
    [anon_sym_u203c] = ACTIONS(5407),
    [sym_hashhash] = ACTIONS(5407),
    [sym_dol] = ACTIONS(5405),
    [sym_doldol] = ACTIONS(5407),
    [anon_sym_QMARK_QMARK] = ACTIONS(5407),
    [anon_sym_u2047] = ACTIONS(5407),
    [anon_sym_BSLASHsqcap] = ACTIONS(5407),
    [anon_sym_u2293] = ACTIONS(5407),
    [anon_sym_BSLASHsqcup] = ACTIONS(5407),
    [anon_sym_u2294] = ACTIONS(5407),
    [anon_sym_BSLASHuplus] = ACTIONS(5407),
    [anon_sym_u228e] = ACTIONS(5407),
    [anon_sym_BSLASHX] = ACTIONS(5407),
    [anon_sym_BSLASHtimes] = ACTIONS(5407),
    [anon_sym_u00d7] = ACTIONS(5407),
    [anon_sym_BSLASHwr] = ACTIONS(5407),
    [anon_sym_u2240] = ACTIONS(5407),
    [anon_sym_BSLASHcdot] = ACTIONS(5407),
    [anon_sym_u22c5] = ACTIONS(5407),
    [sym_pow] = ACTIONS(5405),
    [sym_powpow] = ACTIONS(5407),
    [anon_sym_CARET_PLUS] = ACTIONS(5407),
    [anon_sym_u207a] = ACTIONS(5407),
    [sym_asterisk] = ACTIONS(5407),
    [sym_sup_hash] = ACTIONS(5407),
    [sym_prime] = ACTIONS(5407),
    [sym__indent] = ACTIONS(5407),
    [sym__double_excl] = ACTIONS(5407),
  },
  [2149] = {
    [sym_block_comment] = STATE(2149),
    [sym_identifier] = ACTIONS(5409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5409),
    [anon_sym_u2208] = ACTIONS(5411),
    [anon_sym_BSLASHA] = ACTIONS(5409),
    [anon_sym_BSLASHforall] = ACTIONS(5411),
    [anon_sym_u2200] = ACTIONS(5411),
    [anon_sym_BSLASHE] = ACTIONS(5409),
    [anon_sym_BSLASHexists] = ACTIONS(5411),
    [anon_sym_u2203] = ACTIONS(5411),
    [sym_temporal_forall] = ACTIONS(5411),
    [sym_temporal_exists] = ACTIONS(5411),
    [anon_sym_LT_LT] = ACTIONS(5411),
    [anon_sym_u3008] = ACTIONS(5411),
    [anon_sym_u27e8] = ACTIONS(5411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5411),
    [anon_sym_u25a1] = ACTIONS(5411),
    [anon_sym_AT] = ACTIONS(5409),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5411),
    [anon_sym_u2227] = ACTIONS(5411),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5411),
    [anon_sym_u2228] = ACTIONS(5411),
    [anon_sym_LPAREN] = ACTIONS(5409),
    [anon_sym_LBRACK] = ACTIONS(5409),
    [aux_sym_child_id_token1] = ACTIONS(5409),
    [sym_real_number] = ACTIONS(5411),
    [anon_sym_BSLASHb] = ACTIONS(5409),
    [anon_sym_BSLASHB] = ACTIONS(5411),
    [anon_sym_BSLASHo] = ACTIONS(5409),
    [anon_sym_BSLASHO] = ACTIONS(5411),
    [anon_sym_BSLASHh] = ACTIONS(5411),
    [anon_sym_BSLASHH] = ACTIONS(5411),
    [anon_sym_DQUOTE] = ACTIONS(5411),
    [anon_sym_TRUE] = ACTIONS(5409),
    [anon_sym_FALSE] = ACTIONS(5409),
    [sym_string_set] = ACTIONS(5409),
    [sym_boolean_set] = ACTIONS(5409),
    [anon_sym_Nat] = ACTIONS(5409),
    [anon_sym_u2115] = ACTIONS(5411),
    [anon_sym_Int] = ACTIONS(5409),
    [anon_sym_u2124] = ACTIONS(5411),
    [anon_sym_Real] = ACTIONS(5409),
    [anon_sym_u211d] = ACTIONS(5411),
    [anon_sym_CHOOSE] = ACTIONS(5409),
    [anon_sym_LBRACE] = ACTIONS(5411),
    [anon_sym_EQ] = ACTIONS(5409),
    [anon_sym_WF_] = ACTIONS(5409),
    [anon_sym_SF_] = ACTIONS(5409),
    [anon_sym_IF] = ACTIONS(5409),
    [anon_sym_CASE] = ACTIONS(5409),
    [anon_sym_LET] = ACTIONS(5409),
    [anon_sym_BSLASHlnot] = ACTIONS(5411),
    [anon_sym_BSLASHneg] = ACTIONS(5411),
    [anon_sym_TILDE] = ACTIONS(5409),
    [anon_sym_u00ac] = ACTIONS(5411),
    [sym_union] = ACTIONS(5409),
    [sym_powerset] = ACTIONS(5409),
    [sym_domain] = ACTIONS(5409),
    [anon_sym_DASH] = ACTIONS(5409),
    [sym_negative_dot] = ACTIONS(5411),
    [sym_enabled] = ACTIONS(5409),
    [sym_unchanged] = ACTIONS(5409),
    [anon_sym_LT_GT] = ACTIONS(5411),
    [anon_sym_u22c4] = ACTIONS(5411),
    [anon_sym_u25c7] = ACTIONS(5411),
    [anon_sym_EQ_GT] = ACTIONS(5411),
    [anon_sym_u27f9] = ACTIONS(5411),
    [anon_sym_u21d2] = ACTIONS(5411),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5411),
    [anon_sym_u21f8] = ACTIONS(5411),
    [anon_sym_u2945] = ACTIONS(5411),
    [anon_sym_BSLASHequiv] = ACTIONS(5411),
    [anon_sym_u2261] = ACTIONS(5411),
    [anon_sym_LT_EQ_GT] = ACTIONS(5411),
    [anon_sym_u27fa] = ACTIONS(5411),
    [anon_sym_u21d4] = ACTIONS(5411),
    [anon_sym_TILDE_GT] = ACTIONS(5411),
    [anon_sym_u21dd] = ACTIONS(5411),
    [anon_sym_u219d] = ACTIONS(5411),
    [anon_sym_BSLASHland] = ACTIONS(5411),
    [anon_sym_BSLASHlor] = ACTIONS(5411),
    [anon_sym_COLON_EQ] = ACTIONS(5411),
    [anon_sym_u2254] = ACTIONS(5411),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5411),
    [anon_sym_u2a74] = ACTIONS(5411),
    [anon_sym_SLASH_EQ] = ACTIONS(5411),
    [anon_sym_POUND] = ACTIONS(5409),
    [anon_sym_u2260] = ACTIONS(5411),
    [anon_sym_LT] = ACTIONS(5409),
    [sym_gt] = ACTIONS(5409),
    [anon_sym_LT_EQ] = ACTIONS(5409),
    [anon_sym_EQ_LT] = ACTIONS(5411),
    [anon_sym_BSLASHleq] = ACTIONS(5411),
    [anon_sym_u2264] = ACTIONS(5411),
    [anon_sym_GT_EQ] = ACTIONS(5411),
    [anon_sym_BSLASHgeq] = ACTIONS(5411),
    [anon_sym_u2265] = ACTIONS(5411),
    [anon_sym_BSLASHapprox] = ACTIONS(5411),
    [anon_sym_u2248] = ACTIONS(5411),
    [anon_sym_PIPE_DASH] = ACTIONS(5411),
    [anon_sym_u22a2] = ACTIONS(5411),
    [anon_sym_PIPE_EQ] = ACTIONS(5411),
    [anon_sym_u22a8] = ACTIONS(5411),
    [anon_sym_DASH_PIPE] = ACTIONS(5411),
    [anon_sym_u22a3] = ACTIONS(5411),
    [anon_sym_EQ_PIPE] = ACTIONS(5411),
    [anon_sym_u2ae4] = ACTIONS(5411),
    [anon_sym_BSLASHasymp] = ACTIONS(5411),
    [anon_sym_u224d] = ACTIONS(5411),
    [anon_sym_BSLASHcong] = ACTIONS(5411),
    [anon_sym_u2245] = ACTIONS(5411),
    [anon_sym_BSLASHdoteq] = ACTIONS(5411),
    [anon_sym_u2250] = ACTIONS(5411),
    [anon_sym_BSLASHgg] = ACTIONS(5411),
    [anon_sym_u226b] = ACTIONS(5411),
    [anon_sym_BSLASHll] = ACTIONS(5411),
    [anon_sym_u226a] = ACTIONS(5411),
    [anon_sym_BSLASHnotin] = ACTIONS(5411),
    [anon_sym_u2209] = ACTIONS(5411),
    [anon_sym_BSLASHprec] = ACTIONS(5409),
    [anon_sym_u227a] = ACTIONS(5411),
    [anon_sym_BSLASHsucc] = ACTIONS(5409),
    [anon_sym_u227b] = ACTIONS(5411),
    [anon_sym_BSLASHpreceq] = ACTIONS(5411),
    [anon_sym_u2aaf] = ACTIONS(5411),
    [anon_sym_BSLASHsucceq] = ACTIONS(5411),
    [anon_sym_u2ab0] = ACTIONS(5411),
    [anon_sym_BSLASHpropto] = ACTIONS(5411),
    [anon_sym_u221d] = ACTIONS(5411),
    [anon_sym_BSLASHsim] = ACTIONS(5409),
    [anon_sym_u223c] = ACTIONS(5411),
    [anon_sym_BSLASHsimeq] = ACTIONS(5411),
    [anon_sym_u2243] = ACTIONS(5411),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5409),
    [anon_sym_u228f] = ACTIONS(5411),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5409),
    [anon_sym_u2290] = ACTIONS(5411),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5411),
    [anon_sym_u2291] = ACTIONS(5411),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5411),
    [anon_sym_u2292] = ACTIONS(5411),
    [anon_sym_BSLASHsubset] = ACTIONS(5409),
    [anon_sym_u2282] = ACTIONS(5411),
    [anon_sym_BSLASHsupset] = ACTIONS(5409),
    [anon_sym_u2283] = ACTIONS(5411),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5411),
    [anon_sym_u2286] = ACTIONS(5411),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5411),
    [anon_sym_u2287] = ACTIONS(5411),
    [sym_compose] = ACTIONS(5411),
    [sym_map_to] = ACTIONS(5411),
    [sym_map_from] = ACTIONS(5411),
    [sym_setminus] = ACTIONS(5409),
    [anon_sym_BSLASHcap] = ACTIONS(5411),
    [anon_sym_BSLASHintersect] = ACTIONS(5411),
    [anon_sym_u2229] = ACTIONS(5411),
    [anon_sym_BSLASHcup] = ACTIONS(5411),
    [anon_sym_BSLASHunion] = ACTIONS(5411),
    [anon_sym_u222a] = ACTIONS(5411),
    [anon_sym_DOT_DOT] = ACTIONS(5409),
    [anon_sym_u2025] = ACTIONS(5411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5411),
    [anon_sym_u2026] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5409),
    [sym_plusplus] = ACTIONS(5411),
    [anon_sym_BSLASHoplus] = ACTIONS(5411),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5411),
    [anon_sym_u2295] = ACTIONS(5411),
    [anon_sym_BSLASHominus] = ACTIONS(5411),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5411),
    [anon_sym_u2296] = ACTIONS(5411),
    [sym_mod] = ACTIONS(5409),
    [sym_modmod] = ACTIONS(5411),
    [sym_vert] = ACTIONS(5409),
    [anon_sym_PIPE_PIPE] = ACTIONS(5411),
    [anon_sym_u2016] = ACTIONS(5411),
    [sym_minusminus] = ACTIONS(5411),
    [sym_amp] = ACTIONS(5409),
    [sym_ampamp] = ACTIONS(5411),
    [anon_sym_BSLASHodot] = ACTIONS(5411),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5411),
    [anon_sym_u2299] = ACTIONS(5411),
    [anon_sym_BSLASHoslash] = ACTIONS(5411),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5411),
    [anon_sym_u2298] = ACTIONS(5411),
    [anon_sym_BSLASHotimes] = ACTIONS(5411),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5411),
    [anon_sym_u2297] = ACTIONS(5411),
    [sym_mul] = ACTIONS(5409),
    [sym_mulmul] = ACTIONS(5411),
    [sym_slash] = ACTIONS(5409),
    [sym_slashslash] = ACTIONS(5411),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5411),
    [anon_sym_u25ef] = ACTIONS(5411),
    [anon_sym_BSLASHbullet] = ACTIONS(5411),
    [anon_sym_u25cf] = ACTIONS(5411),
    [anon_sym_BSLASHdiv] = ACTIONS(5411),
    [anon_sym_u00f7] = ACTIONS(5411),
    [anon_sym_BSLASHcirc] = ACTIONS(5411),
    [anon_sym_u2218] = ACTIONS(5411),
    [anon_sym_BSLASHstar] = ACTIONS(5411),
    [anon_sym_u22c6] = ACTIONS(5411),
    [anon_sym_u203c] = ACTIONS(5411),
    [sym_hashhash] = ACTIONS(5411),
    [sym_dol] = ACTIONS(5409),
    [sym_doldol] = ACTIONS(5411),
    [anon_sym_QMARK_QMARK] = ACTIONS(5411),
    [anon_sym_u2047] = ACTIONS(5411),
    [anon_sym_BSLASHsqcap] = ACTIONS(5411),
    [anon_sym_u2293] = ACTIONS(5411),
    [anon_sym_BSLASHsqcup] = ACTIONS(5411),
    [anon_sym_u2294] = ACTIONS(5411),
    [anon_sym_BSLASHuplus] = ACTIONS(5411),
    [anon_sym_u228e] = ACTIONS(5411),
    [anon_sym_BSLASHX] = ACTIONS(5411),
    [anon_sym_BSLASHtimes] = ACTIONS(5411),
    [anon_sym_u00d7] = ACTIONS(5411),
    [anon_sym_BSLASHwr] = ACTIONS(5411),
    [anon_sym_u2240] = ACTIONS(5411),
    [anon_sym_BSLASHcdot] = ACTIONS(5411),
    [anon_sym_u22c5] = ACTIONS(5411),
    [sym_pow] = ACTIONS(5409),
    [sym_powpow] = ACTIONS(5411),
    [anon_sym_CARET_PLUS] = ACTIONS(5411),
    [anon_sym_u207a] = ACTIONS(5411),
    [sym_asterisk] = ACTIONS(5411),
    [sym_sup_hash] = ACTIONS(5411),
    [sym_prime] = ACTIONS(5411),
    [sym__indent] = ACTIONS(5411),
    [sym__double_excl] = ACTIONS(5411),
  },
  [2150] = {
    [sym_block_comment] = STATE(2150),
    [sym_identifier] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5413),
    [anon_sym_u2208] = ACTIONS(5415),
    [anon_sym_BSLASHA] = ACTIONS(5413),
    [anon_sym_BSLASHforall] = ACTIONS(5415),
    [anon_sym_u2200] = ACTIONS(5415),
    [anon_sym_BSLASHE] = ACTIONS(5413),
    [anon_sym_BSLASHexists] = ACTIONS(5415),
    [anon_sym_u2203] = ACTIONS(5415),
    [sym_temporal_forall] = ACTIONS(5415),
    [sym_temporal_exists] = ACTIONS(5415),
    [anon_sym_LT_LT] = ACTIONS(5415),
    [anon_sym_u3008] = ACTIONS(5415),
    [anon_sym_u27e8] = ACTIONS(5415),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5415),
    [anon_sym_u25a1] = ACTIONS(5415),
    [anon_sym_AT] = ACTIONS(5413),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5415),
    [anon_sym_u2227] = ACTIONS(5415),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5415),
    [anon_sym_u2228] = ACTIONS(5415),
    [anon_sym_LPAREN] = ACTIONS(5413),
    [anon_sym_LBRACK] = ACTIONS(5413),
    [aux_sym_child_id_token1] = ACTIONS(5413),
    [sym_real_number] = ACTIONS(5415),
    [anon_sym_BSLASHb] = ACTIONS(5413),
    [anon_sym_BSLASHB] = ACTIONS(5415),
    [anon_sym_BSLASHo] = ACTIONS(5413),
    [anon_sym_BSLASHO] = ACTIONS(5415),
    [anon_sym_BSLASHh] = ACTIONS(5415),
    [anon_sym_BSLASHH] = ACTIONS(5415),
    [anon_sym_DQUOTE] = ACTIONS(5415),
    [anon_sym_TRUE] = ACTIONS(5413),
    [anon_sym_FALSE] = ACTIONS(5413),
    [sym_string_set] = ACTIONS(5413),
    [sym_boolean_set] = ACTIONS(5413),
    [anon_sym_Nat] = ACTIONS(5413),
    [anon_sym_u2115] = ACTIONS(5415),
    [anon_sym_Int] = ACTIONS(5413),
    [anon_sym_u2124] = ACTIONS(5415),
    [anon_sym_Real] = ACTIONS(5413),
    [anon_sym_u211d] = ACTIONS(5415),
    [anon_sym_CHOOSE] = ACTIONS(5413),
    [anon_sym_LBRACE] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5413),
    [anon_sym_WF_] = ACTIONS(5413),
    [anon_sym_SF_] = ACTIONS(5413),
    [anon_sym_IF] = ACTIONS(5413),
    [anon_sym_CASE] = ACTIONS(5413),
    [anon_sym_LET] = ACTIONS(5413),
    [anon_sym_BSLASHlnot] = ACTIONS(5415),
    [anon_sym_BSLASHneg] = ACTIONS(5415),
    [anon_sym_TILDE] = ACTIONS(5413),
    [anon_sym_u00ac] = ACTIONS(5415),
    [sym_union] = ACTIONS(5413),
    [sym_powerset] = ACTIONS(5413),
    [sym_domain] = ACTIONS(5413),
    [anon_sym_DASH] = ACTIONS(5413),
    [sym_negative_dot] = ACTIONS(5415),
    [sym_enabled] = ACTIONS(5413),
    [sym_unchanged] = ACTIONS(5413),
    [anon_sym_LT_GT] = ACTIONS(5415),
    [anon_sym_u22c4] = ACTIONS(5415),
    [anon_sym_u25c7] = ACTIONS(5415),
    [anon_sym_EQ_GT] = ACTIONS(5415),
    [anon_sym_u27f9] = ACTIONS(5415),
    [anon_sym_u21d2] = ACTIONS(5415),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5415),
    [anon_sym_u21f8] = ACTIONS(5415),
    [anon_sym_u2945] = ACTIONS(5415),
    [anon_sym_BSLASHequiv] = ACTIONS(5415),
    [anon_sym_u2261] = ACTIONS(5415),
    [anon_sym_LT_EQ_GT] = ACTIONS(5415),
    [anon_sym_u27fa] = ACTIONS(5415),
    [anon_sym_u21d4] = ACTIONS(5415),
    [anon_sym_TILDE_GT] = ACTIONS(5415),
    [anon_sym_u21dd] = ACTIONS(5415),
    [anon_sym_u219d] = ACTIONS(5415),
    [anon_sym_BSLASHland] = ACTIONS(5415),
    [anon_sym_BSLASHlor] = ACTIONS(5415),
    [anon_sym_COLON_EQ] = ACTIONS(5415),
    [anon_sym_u2254] = ACTIONS(5415),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5415),
    [anon_sym_u2a74] = ACTIONS(5415),
    [anon_sym_SLASH_EQ] = ACTIONS(5415),
    [anon_sym_POUND] = ACTIONS(5413),
    [anon_sym_u2260] = ACTIONS(5415),
    [anon_sym_LT] = ACTIONS(5413),
    [sym_gt] = ACTIONS(5413),
    [anon_sym_LT_EQ] = ACTIONS(5413),
    [anon_sym_EQ_LT] = ACTIONS(5415),
    [anon_sym_BSLASHleq] = ACTIONS(5415),
    [anon_sym_u2264] = ACTIONS(5415),
    [anon_sym_GT_EQ] = ACTIONS(5415),
    [anon_sym_BSLASHgeq] = ACTIONS(5415),
    [anon_sym_u2265] = ACTIONS(5415),
    [anon_sym_BSLASHapprox] = ACTIONS(5415),
    [anon_sym_u2248] = ACTIONS(5415),
    [anon_sym_PIPE_DASH] = ACTIONS(5415),
    [anon_sym_u22a2] = ACTIONS(5415),
    [anon_sym_PIPE_EQ] = ACTIONS(5415),
    [anon_sym_u22a8] = ACTIONS(5415),
    [anon_sym_DASH_PIPE] = ACTIONS(5415),
    [anon_sym_u22a3] = ACTIONS(5415),
    [anon_sym_EQ_PIPE] = ACTIONS(5415),
    [anon_sym_u2ae4] = ACTIONS(5415),
    [anon_sym_BSLASHasymp] = ACTIONS(5415),
    [anon_sym_u224d] = ACTIONS(5415),
    [anon_sym_BSLASHcong] = ACTIONS(5415),
    [anon_sym_u2245] = ACTIONS(5415),
    [anon_sym_BSLASHdoteq] = ACTIONS(5415),
    [anon_sym_u2250] = ACTIONS(5415),
    [anon_sym_BSLASHgg] = ACTIONS(5415),
    [anon_sym_u226b] = ACTIONS(5415),
    [anon_sym_BSLASHll] = ACTIONS(5415),
    [anon_sym_u226a] = ACTIONS(5415),
    [anon_sym_BSLASHnotin] = ACTIONS(5415),
    [anon_sym_u2209] = ACTIONS(5415),
    [anon_sym_BSLASHprec] = ACTIONS(5413),
    [anon_sym_u227a] = ACTIONS(5415),
    [anon_sym_BSLASHsucc] = ACTIONS(5413),
    [anon_sym_u227b] = ACTIONS(5415),
    [anon_sym_BSLASHpreceq] = ACTIONS(5415),
    [anon_sym_u2aaf] = ACTIONS(5415),
    [anon_sym_BSLASHsucceq] = ACTIONS(5415),
    [anon_sym_u2ab0] = ACTIONS(5415),
    [anon_sym_BSLASHpropto] = ACTIONS(5415),
    [anon_sym_u221d] = ACTIONS(5415),
    [anon_sym_BSLASHsim] = ACTIONS(5413),
    [anon_sym_u223c] = ACTIONS(5415),
    [anon_sym_BSLASHsimeq] = ACTIONS(5415),
    [anon_sym_u2243] = ACTIONS(5415),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5413),
    [anon_sym_u228f] = ACTIONS(5415),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5413),
    [anon_sym_u2290] = ACTIONS(5415),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5415),
    [anon_sym_u2291] = ACTIONS(5415),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5415),
    [anon_sym_u2292] = ACTIONS(5415),
    [anon_sym_BSLASHsubset] = ACTIONS(5413),
    [anon_sym_u2282] = ACTIONS(5415),
    [anon_sym_BSLASHsupset] = ACTIONS(5413),
    [anon_sym_u2283] = ACTIONS(5415),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5415),
    [anon_sym_u2286] = ACTIONS(5415),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5415),
    [anon_sym_u2287] = ACTIONS(5415),
    [sym_compose] = ACTIONS(5415),
    [sym_map_to] = ACTIONS(5415),
    [sym_map_from] = ACTIONS(5415),
    [sym_setminus] = ACTIONS(5413),
    [anon_sym_BSLASHcap] = ACTIONS(5415),
    [anon_sym_BSLASHintersect] = ACTIONS(5415),
    [anon_sym_u2229] = ACTIONS(5415),
    [anon_sym_BSLASHcup] = ACTIONS(5415),
    [anon_sym_BSLASHunion] = ACTIONS(5415),
    [anon_sym_u222a] = ACTIONS(5415),
    [anon_sym_DOT_DOT] = ACTIONS(5413),
    [anon_sym_u2025] = ACTIONS(5415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5415),
    [anon_sym_u2026] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5413),
    [sym_plusplus] = ACTIONS(5415),
    [anon_sym_BSLASHoplus] = ACTIONS(5415),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5415),
    [anon_sym_u2295] = ACTIONS(5415),
    [anon_sym_BSLASHominus] = ACTIONS(5415),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5415),
    [anon_sym_u2296] = ACTIONS(5415),
    [sym_mod] = ACTIONS(5413),
    [sym_modmod] = ACTIONS(5415),
    [sym_vert] = ACTIONS(5413),
    [anon_sym_PIPE_PIPE] = ACTIONS(5415),
    [anon_sym_u2016] = ACTIONS(5415),
    [sym_minusminus] = ACTIONS(5415),
    [sym_amp] = ACTIONS(5413),
    [sym_ampamp] = ACTIONS(5415),
    [anon_sym_BSLASHodot] = ACTIONS(5415),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5415),
    [anon_sym_u2299] = ACTIONS(5415),
    [anon_sym_BSLASHoslash] = ACTIONS(5415),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5415),
    [anon_sym_u2298] = ACTIONS(5415),
    [anon_sym_BSLASHotimes] = ACTIONS(5415),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5415),
    [anon_sym_u2297] = ACTIONS(5415),
    [sym_mul] = ACTIONS(5413),
    [sym_mulmul] = ACTIONS(5415),
    [sym_slash] = ACTIONS(5413),
    [sym_slashslash] = ACTIONS(5415),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5415),
    [anon_sym_u25ef] = ACTIONS(5415),
    [anon_sym_BSLASHbullet] = ACTIONS(5415),
    [anon_sym_u25cf] = ACTIONS(5415),
    [anon_sym_BSLASHdiv] = ACTIONS(5415),
    [anon_sym_u00f7] = ACTIONS(5415),
    [anon_sym_BSLASHcirc] = ACTIONS(5415),
    [anon_sym_u2218] = ACTIONS(5415),
    [anon_sym_BSLASHstar] = ACTIONS(5415),
    [anon_sym_u22c6] = ACTIONS(5415),
    [anon_sym_u203c] = ACTIONS(5415),
    [sym_hashhash] = ACTIONS(5415),
    [sym_dol] = ACTIONS(5413),
    [sym_doldol] = ACTIONS(5415),
    [anon_sym_QMARK_QMARK] = ACTIONS(5415),
    [anon_sym_u2047] = ACTIONS(5415),
    [anon_sym_BSLASHsqcap] = ACTIONS(5415),
    [anon_sym_u2293] = ACTIONS(5415),
    [anon_sym_BSLASHsqcup] = ACTIONS(5415),
    [anon_sym_u2294] = ACTIONS(5415),
    [anon_sym_BSLASHuplus] = ACTIONS(5415),
    [anon_sym_u228e] = ACTIONS(5415),
    [anon_sym_BSLASHX] = ACTIONS(5415),
    [anon_sym_BSLASHtimes] = ACTIONS(5415),
    [anon_sym_u00d7] = ACTIONS(5415),
    [anon_sym_BSLASHwr] = ACTIONS(5415),
    [anon_sym_u2240] = ACTIONS(5415),
    [anon_sym_BSLASHcdot] = ACTIONS(5415),
    [anon_sym_u22c5] = ACTIONS(5415),
    [sym_pow] = ACTIONS(5413),
    [sym_powpow] = ACTIONS(5415),
    [anon_sym_CARET_PLUS] = ACTIONS(5415),
    [anon_sym_u207a] = ACTIONS(5415),
    [sym_asterisk] = ACTIONS(5415),
    [sym_sup_hash] = ACTIONS(5415),
    [sym_prime] = ACTIONS(5415),
    [sym__indent] = ACTIONS(5415),
    [sym__double_excl] = ACTIONS(5415),
  },
  [2151] = {
    [sym_block_comment] = STATE(2151),
    [sym_identifier] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5417),
    [anon_sym_u2208] = ACTIONS(5419),
    [anon_sym_BSLASHA] = ACTIONS(5417),
    [anon_sym_BSLASHforall] = ACTIONS(5419),
    [anon_sym_u2200] = ACTIONS(5419),
    [anon_sym_BSLASHE] = ACTIONS(5417),
    [anon_sym_BSLASHexists] = ACTIONS(5419),
    [anon_sym_u2203] = ACTIONS(5419),
    [sym_temporal_forall] = ACTIONS(5419),
    [sym_temporal_exists] = ACTIONS(5419),
    [anon_sym_LT_LT] = ACTIONS(5419),
    [anon_sym_u3008] = ACTIONS(5419),
    [anon_sym_u27e8] = ACTIONS(5419),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5419),
    [anon_sym_u25a1] = ACTIONS(5419),
    [anon_sym_AT] = ACTIONS(5417),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5419),
    [anon_sym_u2227] = ACTIONS(5419),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5419),
    [anon_sym_u2228] = ACTIONS(5419),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5417),
    [aux_sym_child_id_token1] = ACTIONS(5417),
    [sym_real_number] = ACTIONS(5419),
    [anon_sym_BSLASHb] = ACTIONS(5417),
    [anon_sym_BSLASHB] = ACTIONS(5419),
    [anon_sym_BSLASHo] = ACTIONS(5417),
    [anon_sym_BSLASHO] = ACTIONS(5419),
    [anon_sym_BSLASHh] = ACTIONS(5419),
    [anon_sym_BSLASHH] = ACTIONS(5419),
    [anon_sym_DQUOTE] = ACTIONS(5419),
    [anon_sym_TRUE] = ACTIONS(5417),
    [anon_sym_FALSE] = ACTIONS(5417),
    [sym_string_set] = ACTIONS(5417),
    [sym_boolean_set] = ACTIONS(5417),
    [anon_sym_Nat] = ACTIONS(5417),
    [anon_sym_u2115] = ACTIONS(5419),
    [anon_sym_Int] = ACTIONS(5417),
    [anon_sym_u2124] = ACTIONS(5419),
    [anon_sym_Real] = ACTIONS(5417),
    [anon_sym_u211d] = ACTIONS(5419),
    [anon_sym_CHOOSE] = ACTIONS(5417),
    [anon_sym_LBRACE] = ACTIONS(5419),
    [anon_sym_EQ] = ACTIONS(5417),
    [anon_sym_WF_] = ACTIONS(5417),
    [anon_sym_SF_] = ACTIONS(5417),
    [anon_sym_IF] = ACTIONS(5417),
    [anon_sym_CASE] = ACTIONS(5417),
    [anon_sym_LET] = ACTIONS(5417),
    [anon_sym_BSLASHlnot] = ACTIONS(5419),
    [anon_sym_BSLASHneg] = ACTIONS(5419),
    [anon_sym_TILDE] = ACTIONS(5417),
    [anon_sym_u00ac] = ACTIONS(5419),
    [sym_union] = ACTIONS(5417),
    [sym_powerset] = ACTIONS(5417),
    [sym_domain] = ACTIONS(5417),
    [anon_sym_DASH] = ACTIONS(5417),
    [sym_negative_dot] = ACTIONS(5419),
    [sym_enabled] = ACTIONS(5417),
    [sym_unchanged] = ACTIONS(5417),
    [anon_sym_LT_GT] = ACTIONS(5419),
    [anon_sym_u22c4] = ACTIONS(5419),
    [anon_sym_u25c7] = ACTIONS(5419),
    [anon_sym_EQ_GT] = ACTIONS(5419),
    [anon_sym_u27f9] = ACTIONS(5419),
    [anon_sym_u21d2] = ACTIONS(5419),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5419),
    [anon_sym_u21f8] = ACTIONS(5419),
    [anon_sym_u2945] = ACTIONS(5419),
    [anon_sym_BSLASHequiv] = ACTIONS(5419),
    [anon_sym_u2261] = ACTIONS(5419),
    [anon_sym_LT_EQ_GT] = ACTIONS(5419),
    [anon_sym_u27fa] = ACTIONS(5419),
    [anon_sym_u21d4] = ACTIONS(5419),
    [anon_sym_TILDE_GT] = ACTIONS(5419),
    [anon_sym_u21dd] = ACTIONS(5419),
    [anon_sym_u219d] = ACTIONS(5419),
    [anon_sym_BSLASHland] = ACTIONS(5419),
    [anon_sym_BSLASHlor] = ACTIONS(5419),
    [anon_sym_COLON_EQ] = ACTIONS(5419),
    [anon_sym_u2254] = ACTIONS(5419),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5419),
    [anon_sym_u2a74] = ACTIONS(5419),
    [anon_sym_SLASH_EQ] = ACTIONS(5419),
    [anon_sym_POUND] = ACTIONS(5417),
    [anon_sym_u2260] = ACTIONS(5419),
    [anon_sym_LT] = ACTIONS(5417),
    [sym_gt] = ACTIONS(5417),
    [anon_sym_LT_EQ] = ACTIONS(5417),
    [anon_sym_EQ_LT] = ACTIONS(5419),
    [anon_sym_BSLASHleq] = ACTIONS(5419),
    [anon_sym_u2264] = ACTIONS(5419),
    [anon_sym_GT_EQ] = ACTIONS(5419),
    [anon_sym_BSLASHgeq] = ACTIONS(5419),
    [anon_sym_u2265] = ACTIONS(5419),
    [anon_sym_BSLASHapprox] = ACTIONS(5419),
    [anon_sym_u2248] = ACTIONS(5419),
    [anon_sym_PIPE_DASH] = ACTIONS(5419),
    [anon_sym_u22a2] = ACTIONS(5419),
    [anon_sym_PIPE_EQ] = ACTIONS(5419),
    [anon_sym_u22a8] = ACTIONS(5419),
    [anon_sym_DASH_PIPE] = ACTIONS(5419),
    [anon_sym_u22a3] = ACTIONS(5419),
    [anon_sym_EQ_PIPE] = ACTIONS(5419),
    [anon_sym_u2ae4] = ACTIONS(5419),
    [anon_sym_BSLASHasymp] = ACTIONS(5419),
    [anon_sym_u224d] = ACTIONS(5419),
    [anon_sym_BSLASHcong] = ACTIONS(5419),
    [anon_sym_u2245] = ACTIONS(5419),
    [anon_sym_BSLASHdoteq] = ACTIONS(5419),
    [anon_sym_u2250] = ACTIONS(5419),
    [anon_sym_BSLASHgg] = ACTIONS(5419),
    [anon_sym_u226b] = ACTIONS(5419),
    [anon_sym_BSLASHll] = ACTIONS(5419),
    [anon_sym_u226a] = ACTIONS(5419),
    [anon_sym_BSLASHnotin] = ACTIONS(5419),
    [anon_sym_u2209] = ACTIONS(5419),
    [anon_sym_BSLASHprec] = ACTIONS(5417),
    [anon_sym_u227a] = ACTIONS(5419),
    [anon_sym_BSLASHsucc] = ACTIONS(5417),
    [anon_sym_u227b] = ACTIONS(5419),
    [anon_sym_BSLASHpreceq] = ACTIONS(5419),
    [anon_sym_u2aaf] = ACTIONS(5419),
    [anon_sym_BSLASHsucceq] = ACTIONS(5419),
    [anon_sym_u2ab0] = ACTIONS(5419),
    [anon_sym_BSLASHpropto] = ACTIONS(5419),
    [anon_sym_u221d] = ACTIONS(5419),
    [anon_sym_BSLASHsim] = ACTIONS(5417),
    [anon_sym_u223c] = ACTIONS(5419),
    [anon_sym_BSLASHsimeq] = ACTIONS(5419),
    [anon_sym_u2243] = ACTIONS(5419),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5417),
    [anon_sym_u228f] = ACTIONS(5419),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5417),
    [anon_sym_u2290] = ACTIONS(5419),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5419),
    [anon_sym_u2291] = ACTIONS(5419),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5419),
    [anon_sym_u2292] = ACTIONS(5419),
    [anon_sym_BSLASHsubset] = ACTIONS(5417),
    [anon_sym_u2282] = ACTIONS(5419),
    [anon_sym_BSLASHsupset] = ACTIONS(5417),
    [anon_sym_u2283] = ACTIONS(5419),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5419),
    [anon_sym_u2286] = ACTIONS(5419),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5419),
    [anon_sym_u2287] = ACTIONS(5419),
    [sym_compose] = ACTIONS(5419),
    [sym_map_to] = ACTIONS(5419),
    [sym_map_from] = ACTIONS(5419),
    [sym_setminus] = ACTIONS(5417),
    [anon_sym_BSLASHcap] = ACTIONS(5419),
    [anon_sym_BSLASHintersect] = ACTIONS(5419),
    [anon_sym_u2229] = ACTIONS(5419),
    [anon_sym_BSLASHcup] = ACTIONS(5419),
    [anon_sym_BSLASHunion] = ACTIONS(5419),
    [anon_sym_u222a] = ACTIONS(5419),
    [anon_sym_DOT_DOT] = ACTIONS(5417),
    [anon_sym_u2025] = ACTIONS(5419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5419),
    [anon_sym_u2026] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5417),
    [sym_plusplus] = ACTIONS(5419),
    [anon_sym_BSLASHoplus] = ACTIONS(5419),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5419),
    [anon_sym_u2295] = ACTIONS(5419),
    [anon_sym_BSLASHominus] = ACTIONS(5419),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5419),
    [anon_sym_u2296] = ACTIONS(5419),
    [sym_mod] = ACTIONS(5417),
    [sym_modmod] = ACTIONS(5419),
    [sym_vert] = ACTIONS(5417),
    [anon_sym_PIPE_PIPE] = ACTIONS(5419),
    [anon_sym_u2016] = ACTIONS(5419),
    [sym_minusminus] = ACTIONS(5419),
    [sym_amp] = ACTIONS(5417),
    [sym_ampamp] = ACTIONS(5419),
    [anon_sym_BSLASHodot] = ACTIONS(5419),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5419),
    [anon_sym_u2299] = ACTIONS(5419),
    [anon_sym_BSLASHoslash] = ACTIONS(5419),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5419),
    [anon_sym_u2298] = ACTIONS(5419),
    [anon_sym_BSLASHotimes] = ACTIONS(5419),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5419),
    [anon_sym_u2297] = ACTIONS(5419),
    [sym_mul] = ACTIONS(5417),
    [sym_mulmul] = ACTIONS(5419),
    [sym_slash] = ACTIONS(5417),
    [sym_slashslash] = ACTIONS(5419),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5419),
    [anon_sym_u25ef] = ACTIONS(5419),
    [anon_sym_BSLASHbullet] = ACTIONS(5419),
    [anon_sym_u25cf] = ACTIONS(5419),
    [anon_sym_BSLASHdiv] = ACTIONS(5419),
    [anon_sym_u00f7] = ACTIONS(5419),
    [anon_sym_BSLASHcirc] = ACTIONS(5419),
    [anon_sym_u2218] = ACTIONS(5419),
    [anon_sym_BSLASHstar] = ACTIONS(5419),
    [anon_sym_u22c6] = ACTIONS(5419),
    [anon_sym_u203c] = ACTIONS(5419),
    [sym_hashhash] = ACTIONS(5419),
    [sym_dol] = ACTIONS(5417),
    [sym_doldol] = ACTIONS(5419),
    [anon_sym_QMARK_QMARK] = ACTIONS(5419),
    [anon_sym_u2047] = ACTIONS(5419),
    [anon_sym_BSLASHsqcap] = ACTIONS(5419),
    [anon_sym_u2293] = ACTIONS(5419),
    [anon_sym_BSLASHsqcup] = ACTIONS(5419),
    [anon_sym_u2294] = ACTIONS(5419),
    [anon_sym_BSLASHuplus] = ACTIONS(5419),
    [anon_sym_u228e] = ACTIONS(5419),
    [anon_sym_BSLASHX] = ACTIONS(5419),
    [anon_sym_BSLASHtimes] = ACTIONS(5419),
    [anon_sym_u00d7] = ACTIONS(5419),
    [anon_sym_BSLASHwr] = ACTIONS(5419),
    [anon_sym_u2240] = ACTIONS(5419),
    [anon_sym_BSLASHcdot] = ACTIONS(5419),
    [anon_sym_u22c5] = ACTIONS(5419),
    [sym_pow] = ACTIONS(5417),
    [sym_powpow] = ACTIONS(5419),
    [anon_sym_CARET_PLUS] = ACTIONS(5419),
    [anon_sym_u207a] = ACTIONS(5419),
    [sym_asterisk] = ACTIONS(5419),
    [sym_sup_hash] = ACTIONS(5419),
    [sym_prime] = ACTIONS(5419),
    [sym__indent] = ACTIONS(5419),
    [sym__double_excl] = ACTIONS(5419),
  },
  [2152] = {
    [sym_block_comment] = STATE(2152),
    [sym_identifier] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5421),
    [anon_sym_u2208] = ACTIONS(5423),
    [anon_sym_BSLASHA] = ACTIONS(5421),
    [anon_sym_BSLASHforall] = ACTIONS(5423),
    [anon_sym_u2200] = ACTIONS(5423),
    [anon_sym_BSLASHE] = ACTIONS(5421),
    [anon_sym_BSLASHexists] = ACTIONS(5423),
    [anon_sym_u2203] = ACTIONS(5423),
    [sym_temporal_forall] = ACTIONS(5423),
    [sym_temporal_exists] = ACTIONS(5423),
    [anon_sym_LT_LT] = ACTIONS(5423),
    [anon_sym_u3008] = ACTIONS(5423),
    [anon_sym_u27e8] = ACTIONS(5423),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5423),
    [anon_sym_u25a1] = ACTIONS(5423),
    [anon_sym_AT] = ACTIONS(5421),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5423),
    [anon_sym_u2227] = ACTIONS(5423),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5423),
    [anon_sym_u2228] = ACTIONS(5423),
    [anon_sym_LPAREN] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5421),
    [aux_sym_child_id_token1] = ACTIONS(5421),
    [sym_real_number] = ACTIONS(5423),
    [anon_sym_BSLASHb] = ACTIONS(5421),
    [anon_sym_BSLASHB] = ACTIONS(5423),
    [anon_sym_BSLASHo] = ACTIONS(5421),
    [anon_sym_BSLASHO] = ACTIONS(5423),
    [anon_sym_BSLASHh] = ACTIONS(5423),
    [anon_sym_BSLASHH] = ACTIONS(5423),
    [anon_sym_DQUOTE] = ACTIONS(5423),
    [anon_sym_TRUE] = ACTIONS(5421),
    [anon_sym_FALSE] = ACTIONS(5421),
    [sym_string_set] = ACTIONS(5421),
    [sym_boolean_set] = ACTIONS(5421),
    [anon_sym_Nat] = ACTIONS(5421),
    [anon_sym_u2115] = ACTIONS(5423),
    [anon_sym_Int] = ACTIONS(5421),
    [anon_sym_u2124] = ACTIONS(5423),
    [anon_sym_Real] = ACTIONS(5421),
    [anon_sym_u211d] = ACTIONS(5423),
    [anon_sym_CHOOSE] = ACTIONS(5421),
    [anon_sym_LBRACE] = ACTIONS(5423),
    [anon_sym_EQ] = ACTIONS(5421),
    [anon_sym_WF_] = ACTIONS(5421),
    [anon_sym_SF_] = ACTIONS(5421),
    [anon_sym_IF] = ACTIONS(5421),
    [anon_sym_CASE] = ACTIONS(5421),
    [anon_sym_LET] = ACTIONS(5421),
    [anon_sym_BSLASHlnot] = ACTIONS(5423),
    [anon_sym_BSLASHneg] = ACTIONS(5423),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_u00ac] = ACTIONS(5423),
    [sym_union] = ACTIONS(5421),
    [sym_powerset] = ACTIONS(5421),
    [sym_domain] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5421),
    [sym_negative_dot] = ACTIONS(5423),
    [sym_enabled] = ACTIONS(5421),
    [sym_unchanged] = ACTIONS(5421),
    [anon_sym_LT_GT] = ACTIONS(5423),
    [anon_sym_u22c4] = ACTIONS(5423),
    [anon_sym_u25c7] = ACTIONS(5423),
    [anon_sym_EQ_GT] = ACTIONS(5423),
    [anon_sym_u27f9] = ACTIONS(5423),
    [anon_sym_u21d2] = ACTIONS(5423),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5423),
    [anon_sym_u21f8] = ACTIONS(5423),
    [anon_sym_u2945] = ACTIONS(5423),
    [anon_sym_BSLASHequiv] = ACTIONS(5423),
    [anon_sym_u2261] = ACTIONS(5423),
    [anon_sym_LT_EQ_GT] = ACTIONS(5423),
    [anon_sym_u27fa] = ACTIONS(5423),
    [anon_sym_u21d4] = ACTIONS(5423),
    [anon_sym_TILDE_GT] = ACTIONS(5423),
    [anon_sym_u21dd] = ACTIONS(5423),
    [anon_sym_u219d] = ACTIONS(5423),
    [anon_sym_BSLASHland] = ACTIONS(5423),
    [anon_sym_BSLASHlor] = ACTIONS(5423),
    [anon_sym_COLON_EQ] = ACTIONS(5423),
    [anon_sym_u2254] = ACTIONS(5423),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5423),
    [anon_sym_u2a74] = ACTIONS(5423),
    [anon_sym_SLASH_EQ] = ACTIONS(5423),
    [anon_sym_POUND] = ACTIONS(5421),
    [anon_sym_u2260] = ACTIONS(5423),
    [anon_sym_LT] = ACTIONS(5421),
    [sym_gt] = ACTIONS(5421),
    [anon_sym_LT_EQ] = ACTIONS(5421),
    [anon_sym_EQ_LT] = ACTIONS(5423),
    [anon_sym_BSLASHleq] = ACTIONS(5423),
    [anon_sym_u2264] = ACTIONS(5423),
    [anon_sym_GT_EQ] = ACTIONS(5423),
    [anon_sym_BSLASHgeq] = ACTIONS(5423),
    [anon_sym_u2265] = ACTIONS(5423),
    [anon_sym_BSLASHapprox] = ACTIONS(5423),
    [anon_sym_u2248] = ACTIONS(5423),
    [anon_sym_PIPE_DASH] = ACTIONS(5423),
    [anon_sym_u22a2] = ACTIONS(5423),
    [anon_sym_PIPE_EQ] = ACTIONS(5423),
    [anon_sym_u22a8] = ACTIONS(5423),
    [anon_sym_DASH_PIPE] = ACTIONS(5423),
    [anon_sym_u22a3] = ACTIONS(5423),
    [anon_sym_EQ_PIPE] = ACTIONS(5423),
    [anon_sym_u2ae4] = ACTIONS(5423),
    [anon_sym_BSLASHasymp] = ACTIONS(5423),
    [anon_sym_u224d] = ACTIONS(5423),
    [anon_sym_BSLASHcong] = ACTIONS(5423),
    [anon_sym_u2245] = ACTIONS(5423),
    [anon_sym_BSLASHdoteq] = ACTIONS(5423),
    [anon_sym_u2250] = ACTIONS(5423),
    [anon_sym_BSLASHgg] = ACTIONS(5423),
    [anon_sym_u226b] = ACTIONS(5423),
    [anon_sym_BSLASHll] = ACTIONS(5423),
    [anon_sym_u226a] = ACTIONS(5423),
    [anon_sym_BSLASHnotin] = ACTIONS(5423),
    [anon_sym_u2209] = ACTIONS(5423),
    [anon_sym_BSLASHprec] = ACTIONS(5421),
    [anon_sym_u227a] = ACTIONS(5423),
    [anon_sym_BSLASHsucc] = ACTIONS(5421),
    [anon_sym_u227b] = ACTIONS(5423),
    [anon_sym_BSLASHpreceq] = ACTIONS(5423),
    [anon_sym_u2aaf] = ACTIONS(5423),
    [anon_sym_BSLASHsucceq] = ACTIONS(5423),
    [anon_sym_u2ab0] = ACTIONS(5423),
    [anon_sym_BSLASHpropto] = ACTIONS(5423),
    [anon_sym_u221d] = ACTIONS(5423),
    [anon_sym_BSLASHsim] = ACTIONS(5421),
    [anon_sym_u223c] = ACTIONS(5423),
    [anon_sym_BSLASHsimeq] = ACTIONS(5423),
    [anon_sym_u2243] = ACTIONS(5423),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5421),
    [anon_sym_u228f] = ACTIONS(5423),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5421),
    [anon_sym_u2290] = ACTIONS(5423),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5423),
    [anon_sym_u2291] = ACTIONS(5423),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5423),
    [anon_sym_u2292] = ACTIONS(5423),
    [anon_sym_BSLASHsubset] = ACTIONS(5421),
    [anon_sym_u2282] = ACTIONS(5423),
    [anon_sym_BSLASHsupset] = ACTIONS(5421),
    [anon_sym_u2283] = ACTIONS(5423),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5423),
    [anon_sym_u2286] = ACTIONS(5423),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5423),
    [anon_sym_u2287] = ACTIONS(5423),
    [sym_compose] = ACTIONS(5423),
    [sym_map_to] = ACTIONS(5423),
    [sym_map_from] = ACTIONS(5423),
    [sym_setminus] = ACTIONS(5421),
    [anon_sym_BSLASHcap] = ACTIONS(5423),
    [anon_sym_BSLASHintersect] = ACTIONS(5423),
    [anon_sym_u2229] = ACTIONS(5423),
    [anon_sym_BSLASHcup] = ACTIONS(5423),
    [anon_sym_BSLASHunion] = ACTIONS(5423),
    [anon_sym_u222a] = ACTIONS(5423),
    [anon_sym_DOT_DOT] = ACTIONS(5421),
    [anon_sym_u2025] = ACTIONS(5423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5423),
    [anon_sym_u2026] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5421),
    [sym_plusplus] = ACTIONS(5423),
    [anon_sym_BSLASHoplus] = ACTIONS(5423),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5423),
    [anon_sym_u2295] = ACTIONS(5423),
    [anon_sym_BSLASHominus] = ACTIONS(5423),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5423),
    [anon_sym_u2296] = ACTIONS(5423),
    [sym_mod] = ACTIONS(5421),
    [sym_modmod] = ACTIONS(5423),
    [sym_vert] = ACTIONS(5421),
    [anon_sym_PIPE_PIPE] = ACTIONS(5423),
    [anon_sym_u2016] = ACTIONS(5423),
    [sym_minusminus] = ACTIONS(5423),
    [sym_amp] = ACTIONS(5421),
    [sym_ampamp] = ACTIONS(5423),
    [anon_sym_BSLASHodot] = ACTIONS(5423),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5423),
    [anon_sym_u2299] = ACTIONS(5423),
    [anon_sym_BSLASHoslash] = ACTIONS(5423),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5423),
    [anon_sym_u2298] = ACTIONS(5423),
    [anon_sym_BSLASHotimes] = ACTIONS(5423),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5423),
    [anon_sym_u2297] = ACTIONS(5423),
    [sym_mul] = ACTIONS(5421),
    [sym_mulmul] = ACTIONS(5423),
    [sym_slash] = ACTIONS(5421),
    [sym_slashslash] = ACTIONS(5423),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5423),
    [anon_sym_u25ef] = ACTIONS(5423),
    [anon_sym_BSLASHbullet] = ACTIONS(5423),
    [anon_sym_u25cf] = ACTIONS(5423),
    [anon_sym_BSLASHdiv] = ACTIONS(5423),
    [anon_sym_u00f7] = ACTIONS(5423),
    [anon_sym_BSLASHcirc] = ACTIONS(5423),
    [anon_sym_u2218] = ACTIONS(5423),
    [anon_sym_BSLASHstar] = ACTIONS(5423),
    [anon_sym_u22c6] = ACTIONS(5423),
    [anon_sym_u203c] = ACTIONS(5423),
    [sym_hashhash] = ACTIONS(5423),
    [sym_dol] = ACTIONS(5421),
    [sym_doldol] = ACTIONS(5423),
    [anon_sym_QMARK_QMARK] = ACTIONS(5423),
    [anon_sym_u2047] = ACTIONS(5423),
    [anon_sym_BSLASHsqcap] = ACTIONS(5423),
    [anon_sym_u2293] = ACTIONS(5423),
    [anon_sym_BSLASHsqcup] = ACTIONS(5423),
    [anon_sym_u2294] = ACTIONS(5423),
    [anon_sym_BSLASHuplus] = ACTIONS(5423),
    [anon_sym_u228e] = ACTIONS(5423),
    [anon_sym_BSLASHX] = ACTIONS(5423),
    [anon_sym_BSLASHtimes] = ACTIONS(5423),
    [anon_sym_u00d7] = ACTIONS(5423),
    [anon_sym_BSLASHwr] = ACTIONS(5423),
    [anon_sym_u2240] = ACTIONS(5423),
    [anon_sym_BSLASHcdot] = ACTIONS(5423),
    [anon_sym_u22c5] = ACTIONS(5423),
    [sym_pow] = ACTIONS(5421),
    [sym_powpow] = ACTIONS(5423),
    [anon_sym_CARET_PLUS] = ACTIONS(5423),
    [anon_sym_u207a] = ACTIONS(5423),
    [sym_asterisk] = ACTIONS(5423),
    [sym_sup_hash] = ACTIONS(5423),
    [sym_prime] = ACTIONS(5423),
    [sym__indent] = ACTIONS(5423),
    [sym__double_excl] = ACTIONS(5423),
  },
  [2153] = {
    [sym_block_comment] = STATE(2153),
    [sym_identifier] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5425),
    [anon_sym_u2208] = ACTIONS(5427),
    [anon_sym_BSLASHA] = ACTIONS(5425),
    [anon_sym_BSLASHforall] = ACTIONS(5427),
    [anon_sym_u2200] = ACTIONS(5427),
    [anon_sym_BSLASHE] = ACTIONS(5425),
    [anon_sym_BSLASHexists] = ACTIONS(5427),
    [anon_sym_u2203] = ACTIONS(5427),
    [sym_temporal_forall] = ACTIONS(5427),
    [sym_temporal_exists] = ACTIONS(5427),
    [anon_sym_LT_LT] = ACTIONS(5427),
    [anon_sym_u3008] = ACTIONS(5427),
    [anon_sym_u27e8] = ACTIONS(5427),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5427),
    [anon_sym_u25a1] = ACTIONS(5427),
    [anon_sym_AT] = ACTIONS(5425),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5427),
    [anon_sym_u2227] = ACTIONS(5427),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5427),
    [anon_sym_u2228] = ACTIONS(5427),
    [anon_sym_LPAREN] = ACTIONS(5425),
    [anon_sym_LBRACK] = ACTIONS(5425),
    [aux_sym_child_id_token1] = ACTIONS(5425),
    [sym_real_number] = ACTIONS(5427),
    [anon_sym_BSLASHb] = ACTIONS(5425),
    [anon_sym_BSLASHB] = ACTIONS(5427),
    [anon_sym_BSLASHo] = ACTIONS(5425),
    [anon_sym_BSLASHO] = ACTIONS(5427),
    [anon_sym_BSLASHh] = ACTIONS(5427),
    [anon_sym_BSLASHH] = ACTIONS(5427),
    [anon_sym_DQUOTE] = ACTIONS(5427),
    [anon_sym_TRUE] = ACTIONS(5425),
    [anon_sym_FALSE] = ACTIONS(5425),
    [sym_string_set] = ACTIONS(5425),
    [sym_boolean_set] = ACTIONS(5425),
    [anon_sym_Nat] = ACTIONS(5425),
    [anon_sym_u2115] = ACTIONS(5427),
    [anon_sym_Int] = ACTIONS(5425),
    [anon_sym_u2124] = ACTIONS(5427),
    [anon_sym_Real] = ACTIONS(5425),
    [anon_sym_u211d] = ACTIONS(5427),
    [anon_sym_CHOOSE] = ACTIONS(5425),
    [anon_sym_LBRACE] = ACTIONS(5427),
    [anon_sym_EQ] = ACTIONS(5425),
    [anon_sym_WF_] = ACTIONS(5425),
    [anon_sym_SF_] = ACTIONS(5425),
    [anon_sym_IF] = ACTIONS(5425),
    [anon_sym_CASE] = ACTIONS(5425),
    [anon_sym_LET] = ACTIONS(5425),
    [anon_sym_BSLASHlnot] = ACTIONS(5427),
    [anon_sym_BSLASHneg] = ACTIONS(5427),
    [anon_sym_TILDE] = ACTIONS(5425),
    [anon_sym_u00ac] = ACTIONS(5427),
    [sym_union] = ACTIONS(5425),
    [sym_powerset] = ACTIONS(5425),
    [sym_domain] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(5425),
    [sym_negative_dot] = ACTIONS(5427),
    [sym_enabled] = ACTIONS(5425),
    [sym_unchanged] = ACTIONS(5425),
    [anon_sym_LT_GT] = ACTIONS(5427),
    [anon_sym_u22c4] = ACTIONS(5427),
    [anon_sym_u25c7] = ACTIONS(5427),
    [anon_sym_EQ_GT] = ACTIONS(5427),
    [anon_sym_u27f9] = ACTIONS(5427),
    [anon_sym_u21d2] = ACTIONS(5427),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5427),
    [anon_sym_u21f8] = ACTIONS(5427),
    [anon_sym_u2945] = ACTIONS(5427),
    [anon_sym_BSLASHequiv] = ACTIONS(5427),
    [anon_sym_u2261] = ACTIONS(5427),
    [anon_sym_LT_EQ_GT] = ACTIONS(5427),
    [anon_sym_u27fa] = ACTIONS(5427),
    [anon_sym_u21d4] = ACTIONS(5427),
    [anon_sym_TILDE_GT] = ACTIONS(5427),
    [anon_sym_u21dd] = ACTIONS(5427),
    [anon_sym_u219d] = ACTIONS(5427),
    [anon_sym_BSLASHland] = ACTIONS(5427),
    [anon_sym_BSLASHlor] = ACTIONS(5427),
    [anon_sym_COLON_EQ] = ACTIONS(5427),
    [anon_sym_u2254] = ACTIONS(5427),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5427),
    [anon_sym_u2a74] = ACTIONS(5427),
    [anon_sym_SLASH_EQ] = ACTIONS(5427),
    [anon_sym_POUND] = ACTIONS(5425),
    [anon_sym_u2260] = ACTIONS(5427),
    [anon_sym_LT] = ACTIONS(5425),
    [sym_gt] = ACTIONS(5425),
    [anon_sym_LT_EQ] = ACTIONS(5425),
    [anon_sym_EQ_LT] = ACTIONS(5427),
    [anon_sym_BSLASHleq] = ACTIONS(5427),
    [anon_sym_u2264] = ACTIONS(5427),
    [anon_sym_GT_EQ] = ACTIONS(5427),
    [anon_sym_BSLASHgeq] = ACTIONS(5427),
    [anon_sym_u2265] = ACTIONS(5427),
    [anon_sym_BSLASHapprox] = ACTIONS(5427),
    [anon_sym_u2248] = ACTIONS(5427),
    [anon_sym_PIPE_DASH] = ACTIONS(5427),
    [anon_sym_u22a2] = ACTIONS(5427),
    [anon_sym_PIPE_EQ] = ACTIONS(5427),
    [anon_sym_u22a8] = ACTIONS(5427),
    [anon_sym_DASH_PIPE] = ACTIONS(5427),
    [anon_sym_u22a3] = ACTIONS(5427),
    [anon_sym_EQ_PIPE] = ACTIONS(5427),
    [anon_sym_u2ae4] = ACTIONS(5427),
    [anon_sym_BSLASHasymp] = ACTIONS(5427),
    [anon_sym_u224d] = ACTIONS(5427),
    [anon_sym_BSLASHcong] = ACTIONS(5427),
    [anon_sym_u2245] = ACTIONS(5427),
    [anon_sym_BSLASHdoteq] = ACTIONS(5427),
    [anon_sym_u2250] = ACTIONS(5427),
    [anon_sym_BSLASHgg] = ACTIONS(5427),
    [anon_sym_u226b] = ACTIONS(5427),
    [anon_sym_BSLASHll] = ACTIONS(5427),
    [anon_sym_u226a] = ACTIONS(5427),
    [anon_sym_BSLASHnotin] = ACTIONS(5427),
    [anon_sym_u2209] = ACTIONS(5427),
    [anon_sym_BSLASHprec] = ACTIONS(5425),
    [anon_sym_u227a] = ACTIONS(5427),
    [anon_sym_BSLASHsucc] = ACTIONS(5425),
    [anon_sym_u227b] = ACTIONS(5427),
    [anon_sym_BSLASHpreceq] = ACTIONS(5427),
    [anon_sym_u2aaf] = ACTIONS(5427),
    [anon_sym_BSLASHsucceq] = ACTIONS(5427),
    [anon_sym_u2ab0] = ACTIONS(5427),
    [anon_sym_BSLASHpropto] = ACTIONS(5427),
    [anon_sym_u221d] = ACTIONS(5427),
    [anon_sym_BSLASHsim] = ACTIONS(5425),
    [anon_sym_u223c] = ACTIONS(5427),
    [anon_sym_BSLASHsimeq] = ACTIONS(5427),
    [anon_sym_u2243] = ACTIONS(5427),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5425),
    [anon_sym_u228f] = ACTIONS(5427),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5425),
    [anon_sym_u2290] = ACTIONS(5427),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5427),
    [anon_sym_u2291] = ACTIONS(5427),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5427),
    [anon_sym_u2292] = ACTIONS(5427),
    [anon_sym_BSLASHsubset] = ACTIONS(5425),
    [anon_sym_u2282] = ACTIONS(5427),
    [anon_sym_BSLASHsupset] = ACTIONS(5425),
    [anon_sym_u2283] = ACTIONS(5427),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5427),
    [anon_sym_u2286] = ACTIONS(5427),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5427),
    [anon_sym_u2287] = ACTIONS(5427),
    [sym_compose] = ACTIONS(5427),
    [sym_map_to] = ACTIONS(5427),
    [sym_map_from] = ACTIONS(5427),
    [sym_setminus] = ACTIONS(5425),
    [anon_sym_BSLASHcap] = ACTIONS(5427),
    [anon_sym_BSLASHintersect] = ACTIONS(5427),
    [anon_sym_u2229] = ACTIONS(5427),
    [anon_sym_BSLASHcup] = ACTIONS(5427),
    [anon_sym_BSLASHunion] = ACTIONS(5427),
    [anon_sym_u222a] = ACTIONS(5427),
    [anon_sym_DOT_DOT] = ACTIONS(5425),
    [anon_sym_u2025] = ACTIONS(5427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5427),
    [anon_sym_u2026] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5425),
    [sym_plusplus] = ACTIONS(5427),
    [anon_sym_BSLASHoplus] = ACTIONS(5427),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5427),
    [anon_sym_u2295] = ACTIONS(5427),
    [anon_sym_BSLASHominus] = ACTIONS(5427),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5427),
    [anon_sym_u2296] = ACTIONS(5427),
    [sym_mod] = ACTIONS(5425),
    [sym_modmod] = ACTIONS(5427),
    [sym_vert] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(5427),
    [anon_sym_u2016] = ACTIONS(5427),
    [sym_minusminus] = ACTIONS(5427),
    [sym_amp] = ACTIONS(5425),
    [sym_ampamp] = ACTIONS(5427),
    [anon_sym_BSLASHodot] = ACTIONS(5427),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5427),
    [anon_sym_u2299] = ACTIONS(5427),
    [anon_sym_BSLASHoslash] = ACTIONS(5427),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5427),
    [anon_sym_u2298] = ACTIONS(5427),
    [anon_sym_BSLASHotimes] = ACTIONS(5427),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5427),
    [anon_sym_u2297] = ACTIONS(5427),
    [sym_mul] = ACTIONS(5425),
    [sym_mulmul] = ACTIONS(5427),
    [sym_slash] = ACTIONS(5425),
    [sym_slashslash] = ACTIONS(5427),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5427),
    [anon_sym_u25ef] = ACTIONS(5427),
    [anon_sym_BSLASHbullet] = ACTIONS(5427),
    [anon_sym_u25cf] = ACTIONS(5427),
    [anon_sym_BSLASHdiv] = ACTIONS(5427),
    [anon_sym_u00f7] = ACTIONS(5427),
    [anon_sym_BSLASHcirc] = ACTIONS(5427),
    [anon_sym_u2218] = ACTIONS(5427),
    [anon_sym_BSLASHstar] = ACTIONS(5427),
    [anon_sym_u22c6] = ACTIONS(5427),
    [anon_sym_u203c] = ACTIONS(5427),
    [sym_hashhash] = ACTIONS(5427),
    [sym_dol] = ACTIONS(5425),
    [sym_doldol] = ACTIONS(5427),
    [anon_sym_QMARK_QMARK] = ACTIONS(5427),
    [anon_sym_u2047] = ACTIONS(5427),
    [anon_sym_BSLASHsqcap] = ACTIONS(5427),
    [anon_sym_u2293] = ACTIONS(5427),
    [anon_sym_BSLASHsqcup] = ACTIONS(5427),
    [anon_sym_u2294] = ACTIONS(5427),
    [anon_sym_BSLASHuplus] = ACTIONS(5427),
    [anon_sym_u228e] = ACTIONS(5427),
    [anon_sym_BSLASHX] = ACTIONS(5427),
    [anon_sym_BSLASHtimes] = ACTIONS(5427),
    [anon_sym_u00d7] = ACTIONS(5427),
    [anon_sym_BSLASHwr] = ACTIONS(5427),
    [anon_sym_u2240] = ACTIONS(5427),
    [anon_sym_BSLASHcdot] = ACTIONS(5427),
    [anon_sym_u22c5] = ACTIONS(5427),
    [sym_pow] = ACTIONS(5425),
    [sym_powpow] = ACTIONS(5427),
    [anon_sym_CARET_PLUS] = ACTIONS(5427),
    [anon_sym_u207a] = ACTIONS(5427),
    [sym_asterisk] = ACTIONS(5427),
    [sym_sup_hash] = ACTIONS(5427),
    [sym_prime] = ACTIONS(5427),
    [sym__indent] = ACTIONS(5427),
    [sym__double_excl] = ACTIONS(5427),
  },
  [2154] = {
    [sym_block_comment] = STATE(2154),
    [sym_identifier] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5429),
    [anon_sym_u2208] = ACTIONS(5431),
    [anon_sym_BSLASHA] = ACTIONS(5429),
    [anon_sym_BSLASHforall] = ACTIONS(5431),
    [anon_sym_u2200] = ACTIONS(5431),
    [anon_sym_BSLASHE] = ACTIONS(5429),
    [anon_sym_BSLASHexists] = ACTIONS(5431),
    [anon_sym_u2203] = ACTIONS(5431),
    [sym_temporal_forall] = ACTIONS(5431),
    [sym_temporal_exists] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5431),
    [anon_sym_u3008] = ACTIONS(5431),
    [anon_sym_u27e8] = ACTIONS(5431),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5431),
    [anon_sym_u25a1] = ACTIONS(5431),
    [anon_sym_AT] = ACTIONS(5429),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5431),
    [anon_sym_u2227] = ACTIONS(5431),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5431),
    [anon_sym_u2228] = ACTIONS(5431),
    [anon_sym_LPAREN] = ACTIONS(5429),
    [anon_sym_LBRACK] = ACTIONS(5429),
    [aux_sym_child_id_token1] = ACTIONS(5429),
    [sym_real_number] = ACTIONS(5431),
    [anon_sym_BSLASHb] = ACTIONS(5429),
    [anon_sym_BSLASHB] = ACTIONS(5431),
    [anon_sym_BSLASHo] = ACTIONS(5429),
    [anon_sym_BSLASHO] = ACTIONS(5431),
    [anon_sym_BSLASHh] = ACTIONS(5431),
    [anon_sym_BSLASHH] = ACTIONS(5431),
    [anon_sym_DQUOTE] = ACTIONS(5431),
    [anon_sym_TRUE] = ACTIONS(5429),
    [anon_sym_FALSE] = ACTIONS(5429),
    [sym_string_set] = ACTIONS(5429),
    [sym_boolean_set] = ACTIONS(5429),
    [anon_sym_Nat] = ACTIONS(5429),
    [anon_sym_u2115] = ACTIONS(5431),
    [anon_sym_Int] = ACTIONS(5429),
    [anon_sym_u2124] = ACTIONS(5431),
    [anon_sym_Real] = ACTIONS(5429),
    [anon_sym_u211d] = ACTIONS(5431),
    [anon_sym_CHOOSE] = ACTIONS(5429),
    [anon_sym_LBRACE] = ACTIONS(5431),
    [anon_sym_EQ] = ACTIONS(5429),
    [anon_sym_WF_] = ACTIONS(5429),
    [anon_sym_SF_] = ACTIONS(5429),
    [anon_sym_IF] = ACTIONS(5429),
    [anon_sym_CASE] = ACTIONS(5429),
    [anon_sym_LET] = ACTIONS(5429),
    [anon_sym_BSLASHlnot] = ACTIONS(5431),
    [anon_sym_BSLASHneg] = ACTIONS(5431),
    [anon_sym_TILDE] = ACTIONS(5429),
    [anon_sym_u00ac] = ACTIONS(5431),
    [sym_union] = ACTIONS(5429),
    [sym_powerset] = ACTIONS(5429),
    [sym_domain] = ACTIONS(5429),
    [anon_sym_DASH] = ACTIONS(5429),
    [sym_negative_dot] = ACTIONS(5431),
    [sym_enabled] = ACTIONS(5429),
    [sym_unchanged] = ACTIONS(5429),
    [anon_sym_LT_GT] = ACTIONS(5431),
    [anon_sym_u22c4] = ACTIONS(5431),
    [anon_sym_u25c7] = ACTIONS(5431),
    [anon_sym_EQ_GT] = ACTIONS(5431),
    [anon_sym_u27f9] = ACTIONS(5431),
    [anon_sym_u21d2] = ACTIONS(5431),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5431),
    [anon_sym_u21f8] = ACTIONS(5431),
    [anon_sym_u2945] = ACTIONS(5431),
    [anon_sym_BSLASHequiv] = ACTIONS(5431),
    [anon_sym_u2261] = ACTIONS(5431),
    [anon_sym_LT_EQ_GT] = ACTIONS(5431),
    [anon_sym_u27fa] = ACTIONS(5431),
    [anon_sym_u21d4] = ACTIONS(5431),
    [anon_sym_TILDE_GT] = ACTIONS(5431),
    [anon_sym_u21dd] = ACTIONS(5431),
    [anon_sym_u219d] = ACTIONS(5431),
    [anon_sym_BSLASHland] = ACTIONS(5431),
    [anon_sym_BSLASHlor] = ACTIONS(5431),
    [anon_sym_COLON_EQ] = ACTIONS(5431),
    [anon_sym_u2254] = ACTIONS(5431),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5431),
    [anon_sym_u2a74] = ACTIONS(5431),
    [anon_sym_SLASH_EQ] = ACTIONS(5431),
    [anon_sym_POUND] = ACTIONS(5429),
    [anon_sym_u2260] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5429),
    [sym_gt] = ACTIONS(5429),
    [anon_sym_LT_EQ] = ACTIONS(5429),
    [anon_sym_EQ_LT] = ACTIONS(5431),
    [anon_sym_BSLASHleq] = ACTIONS(5431),
    [anon_sym_u2264] = ACTIONS(5431),
    [anon_sym_GT_EQ] = ACTIONS(5431),
    [anon_sym_BSLASHgeq] = ACTIONS(5431),
    [anon_sym_u2265] = ACTIONS(5431),
    [anon_sym_BSLASHapprox] = ACTIONS(5431),
    [anon_sym_u2248] = ACTIONS(5431),
    [anon_sym_PIPE_DASH] = ACTIONS(5431),
    [anon_sym_u22a2] = ACTIONS(5431),
    [anon_sym_PIPE_EQ] = ACTIONS(5431),
    [anon_sym_u22a8] = ACTIONS(5431),
    [anon_sym_DASH_PIPE] = ACTIONS(5431),
    [anon_sym_u22a3] = ACTIONS(5431),
    [anon_sym_EQ_PIPE] = ACTIONS(5431),
    [anon_sym_u2ae4] = ACTIONS(5431),
    [anon_sym_BSLASHasymp] = ACTIONS(5431),
    [anon_sym_u224d] = ACTIONS(5431),
    [anon_sym_BSLASHcong] = ACTIONS(5431),
    [anon_sym_u2245] = ACTIONS(5431),
    [anon_sym_BSLASHdoteq] = ACTIONS(5431),
    [anon_sym_u2250] = ACTIONS(5431),
    [anon_sym_BSLASHgg] = ACTIONS(5431),
    [anon_sym_u226b] = ACTIONS(5431),
    [anon_sym_BSLASHll] = ACTIONS(5431),
    [anon_sym_u226a] = ACTIONS(5431),
    [anon_sym_BSLASHnotin] = ACTIONS(5431),
    [anon_sym_u2209] = ACTIONS(5431),
    [anon_sym_BSLASHprec] = ACTIONS(5429),
    [anon_sym_u227a] = ACTIONS(5431),
    [anon_sym_BSLASHsucc] = ACTIONS(5429),
    [anon_sym_u227b] = ACTIONS(5431),
    [anon_sym_BSLASHpreceq] = ACTIONS(5431),
    [anon_sym_u2aaf] = ACTIONS(5431),
    [anon_sym_BSLASHsucceq] = ACTIONS(5431),
    [anon_sym_u2ab0] = ACTIONS(5431),
    [anon_sym_BSLASHpropto] = ACTIONS(5431),
    [anon_sym_u221d] = ACTIONS(5431),
    [anon_sym_BSLASHsim] = ACTIONS(5429),
    [anon_sym_u223c] = ACTIONS(5431),
    [anon_sym_BSLASHsimeq] = ACTIONS(5431),
    [anon_sym_u2243] = ACTIONS(5431),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5429),
    [anon_sym_u228f] = ACTIONS(5431),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5429),
    [anon_sym_u2290] = ACTIONS(5431),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5431),
    [anon_sym_u2291] = ACTIONS(5431),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5431),
    [anon_sym_u2292] = ACTIONS(5431),
    [anon_sym_BSLASHsubset] = ACTIONS(5429),
    [anon_sym_u2282] = ACTIONS(5431),
    [anon_sym_BSLASHsupset] = ACTIONS(5429),
    [anon_sym_u2283] = ACTIONS(5431),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5431),
    [anon_sym_u2286] = ACTIONS(5431),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5431),
    [anon_sym_u2287] = ACTIONS(5431),
    [sym_compose] = ACTIONS(5431),
    [sym_map_to] = ACTIONS(5431),
    [sym_map_from] = ACTIONS(5431),
    [sym_setminus] = ACTIONS(5429),
    [anon_sym_BSLASHcap] = ACTIONS(5431),
    [anon_sym_BSLASHintersect] = ACTIONS(5431),
    [anon_sym_u2229] = ACTIONS(5431),
    [anon_sym_BSLASHcup] = ACTIONS(5431),
    [anon_sym_BSLASHunion] = ACTIONS(5431),
    [anon_sym_u222a] = ACTIONS(5431),
    [anon_sym_DOT_DOT] = ACTIONS(5429),
    [anon_sym_u2025] = ACTIONS(5431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5431),
    [anon_sym_u2026] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5429),
    [sym_plusplus] = ACTIONS(5431),
    [anon_sym_BSLASHoplus] = ACTIONS(5431),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5431),
    [anon_sym_u2295] = ACTIONS(5431),
    [anon_sym_BSLASHominus] = ACTIONS(5431),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5431),
    [anon_sym_u2296] = ACTIONS(5431),
    [sym_mod] = ACTIONS(5429),
    [sym_modmod] = ACTIONS(5431),
    [sym_vert] = ACTIONS(5429),
    [anon_sym_PIPE_PIPE] = ACTIONS(5431),
    [anon_sym_u2016] = ACTIONS(5431),
    [sym_minusminus] = ACTIONS(5431),
    [sym_amp] = ACTIONS(5429),
    [sym_ampamp] = ACTIONS(5431),
    [anon_sym_BSLASHodot] = ACTIONS(5431),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5431),
    [anon_sym_u2299] = ACTIONS(5431),
    [anon_sym_BSLASHoslash] = ACTIONS(5431),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5431),
    [anon_sym_u2298] = ACTIONS(5431),
    [anon_sym_BSLASHotimes] = ACTIONS(5431),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5431),
    [anon_sym_u2297] = ACTIONS(5431),
    [sym_mul] = ACTIONS(5429),
    [sym_mulmul] = ACTIONS(5431),
    [sym_slash] = ACTIONS(5429),
    [sym_slashslash] = ACTIONS(5431),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5431),
    [anon_sym_u25ef] = ACTIONS(5431),
    [anon_sym_BSLASHbullet] = ACTIONS(5431),
    [anon_sym_u25cf] = ACTIONS(5431),
    [anon_sym_BSLASHdiv] = ACTIONS(5431),
    [anon_sym_u00f7] = ACTIONS(5431),
    [anon_sym_BSLASHcirc] = ACTIONS(5431),
    [anon_sym_u2218] = ACTIONS(5431),
    [anon_sym_BSLASHstar] = ACTIONS(5431),
    [anon_sym_u22c6] = ACTIONS(5431),
    [anon_sym_u203c] = ACTIONS(5431),
    [sym_hashhash] = ACTIONS(5431),
    [sym_dol] = ACTIONS(5429),
    [sym_doldol] = ACTIONS(5431),
    [anon_sym_QMARK_QMARK] = ACTIONS(5431),
    [anon_sym_u2047] = ACTIONS(5431),
    [anon_sym_BSLASHsqcap] = ACTIONS(5431),
    [anon_sym_u2293] = ACTIONS(5431),
    [anon_sym_BSLASHsqcup] = ACTIONS(5431),
    [anon_sym_u2294] = ACTIONS(5431),
    [anon_sym_BSLASHuplus] = ACTIONS(5431),
    [anon_sym_u228e] = ACTIONS(5431),
    [anon_sym_BSLASHX] = ACTIONS(5431),
    [anon_sym_BSLASHtimes] = ACTIONS(5431),
    [anon_sym_u00d7] = ACTIONS(5431),
    [anon_sym_BSLASHwr] = ACTIONS(5431),
    [anon_sym_u2240] = ACTIONS(5431),
    [anon_sym_BSLASHcdot] = ACTIONS(5431),
    [anon_sym_u22c5] = ACTIONS(5431),
    [sym_pow] = ACTIONS(5429),
    [sym_powpow] = ACTIONS(5431),
    [anon_sym_CARET_PLUS] = ACTIONS(5431),
    [anon_sym_u207a] = ACTIONS(5431),
    [sym_asterisk] = ACTIONS(5431),
    [sym_sup_hash] = ACTIONS(5431),
    [sym_prime] = ACTIONS(5431),
    [sym__indent] = ACTIONS(5431),
    [sym__double_excl] = ACTIONS(5431),
  },
  [2155] = {
    [sym_block_comment] = STATE(2155),
    [sym_identifier] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5433),
    [anon_sym_u2208] = ACTIONS(5435),
    [anon_sym_BSLASHA] = ACTIONS(5433),
    [anon_sym_BSLASHforall] = ACTIONS(5435),
    [anon_sym_u2200] = ACTIONS(5435),
    [anon_sym_BSLASHE] = ACTIONS(5433),
    [anon_sym_BSLASHexists] = ACTIONS(5435),
    [anon_sym_u2203] = ACTIONS(5435),
    [sym_temporal_forall] = ACTIONS(5435),
    [sym_temporal_exists] = ACTIONS(5435),
    [anon_sym_LT_LT] = ACTIONS(5435),
    [anon_sym_u3008] = ACTIONS(5435),
    [anon_sym_u27e8] = ACTIONS(5435),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5435),
    [anon_sym_u25a1] = ACTIONS(5435),
    [anon_sym_AT] = ACTIONS(5433),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5435),
    [anon_sym_u2227] = ACTIONS(5435),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5435),
    [anon_sym_u2228] = ACTIONS(5435),
    [anon_sym_LPAREN] = ACTIONS(5433),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [aux_sym_child_id_token1] = ACTIONS(5433),
    [sym_real_number] = ACTIONS(5435),
    [anon_sym_BSLASHb] = ACTIONS(5433),
    [anon_sym_BSLASHB] = ACTIONS(5435),
    [anon_sym_BSLASHo] = ACTIONS(5433),
    [anon_sym_BSLASHO] = ACTIONS(5435),
    [anon_sym_BSLASHh] = ACTIONS(5435),
    [anon_sym_BSLASHH] = ACTIONS(5435),
    [anon_sym_DQUOTE] = ACTIONS(5435),
    [anon_sym_TRUE] = ACTIONS(5433),
    [anon_sym_FALSE] = ACTIONS(5433),
    [sym_string_set] = ACTIONS(5433),
    [sym_boolean_set] = ACTIONS(5433),
    [anon_sym_Nat] = ACTIONS(5433),
    [anon_sym_u2115] = ACTIONS(5435),
    [anon_sym_Int] = ACTIONS(5433),
    [anon_sym_u2124] = ACTIONS(5435),
    [anon_sym_Real] = ACTIONS(5433),
    [anon_sym_u211d] = ACTIONS(5435),
    [anon_sym_CHOOSE] = ACTIONS(5433),
    [anon_sym_LBRACE] = ACTIONS(5435),
    [anon_sym_EQ] = ACTIONS(5433),
    [anon_sym_WF_] = ACTIONS(5433),
    [anon_sym_SF_] = ACTIONS(5433),
    [anon_sym_IF] = ACTIONS(5433),
    [anon_sym_CASE] = ACTIONS(5433),
    [anon_sym_LET] = ACTIONS(5433),
    [anon_sym_BSLASHlnot] = ACTIONS(5435),
    [anon_sym_BSLASHneg] = ACTIONS(5435),
    [anon_sym_TILDE] = ACTIONS(5433),
    [anon_sym_u00ac] = ACTIONS(5435),
    [sym_union] = ACTIONS(5433),
    [sym_powerset] = ACTIONS(5433),
    [sym_domain] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5433),
    [sym_negative_dot] = ACTIONS(5435),
    [sym_enabled] = ACTIONS(5433),
    [sym_unchanged] = ACTIONS(5433),
    [anon_sym_LT_GT] = ACTIONS(5435),
    [anon_sym_u22c4] = ACTIONS(5435),
    [anon_sym_u25c7] = ACTIONS(5435),
    [anon_sym_EQ_GT] = ACTIONS(5435),
    [anon_sym_u27f9] = ACTIONS(5435),
    [anon_sym_u21d2] = ACTIONS(5435),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5435),
    [anon_sym_u21f8] = ACTIONS(5435),
    [anon_sym_u2945] = ACTIONS(5435),
    [anon_sym_BSLASHequiv] = ACTIONS(5435),
    [anon_sym_u2261] = ACTIONS(5435),
    [anon_sym_LT_EQ_GT] = ACTIONS(5435),
    [anon_sym_u27fa] = ACTIONS(5435),
    [anon_sym_u21d4] = ACTIONS(5435),
    [anon_sym_TILDE_GT] = ACTIONS(5435),
    [anon_sym_u21dd] = ACTIONS(5435),
    [anon_sym_u219d] = ACTIONS(5435),
    [anon_sym_BSLASHland] = ACTIONS(5435),
    [anon_sym_BSLASHlor] = ACTIONS(5435),
    [anon_sym_COLON_EQ] = ACTIONS(5435),
    [anon_sym_u2254] = ACTIONS(5435),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5435),
    [anon_sym_u2a74] = ACTIONS(5435),
    [anon_sym_SLASH_EQ] = ACTIONS(5435),
    [anon_sym_POUND] = ACTIONS(5433),
    [anon_sym_u2260] = ACTIONS(5435),
    [anon_sym_LT] = ACTIONS(5433),
    [sym_gt] = ACTIONS(5433),
    [anon_sym_LT_EQ] = ACTIONS(5433),
    [anon_sym_EQ_LT] = ACTIONS(5435),
    [anon_sym_BSLASHleq] = ACTIONS(5435),
    [anon_sym_u2264] = ACTIONS(5435),
    [anon_sym_GT_EQ] = ACTIONS(5435),
    [anon_sym_BSLASHgeq] = ACTIONS(5435),
    [anon_sym_u2265] = ACTIONS(5435),
    [anon_sym_BSLASHapprox] = ACTIONS(5435),
    [anon_sym_u2248] = ACTIONS(5435),
    [anon_sym_PIPE_DASH] = ACTIONS(5435),
    [anon_sym_u22a2] = ACTIONS(5435),
    [anon_sym_PIPE_EQ] = ACTIONS(5435),
    [anon_sym_u22a8] = ACTIONS(5435),
    [anon_sym_DASH_PIPE] = ACTIONS(5435),
    [anon_sym_u22a3] = ACTIONS(5435),
    [anon_sym_EQ_PIPE] = ACTIONS(5435),
    [anon_sym_u2ae4] = ACTIONS(5435),
    [anon_sym_BSLASHasymp] = ACTIONS(5435),
    [anon_sym_u224d] = ACTIONS(5435),
    [anon_sym_BSLASHcong] = ACTIONS(5435),
    [anon_sym_u2245] = ACTIONS(5435),
    [anon_sym_BSLASHdoteq] = ACTIONS(5435),
    [anon_sym_u2250] = ACTIONS(5435),
    [anon_sym_BSLASHgg] = ACTIONS(5435),
    [anon_sym_u226b] = ACTIONS(5435),
    [anon_sym_BSLASHll] = ACTIONS(5435),
    [anon_sym_u226a] = ACTIONS(5435),
    [anon_sym_BSLASHnotin] = ACTIONS(5435),
    [anon_sym_u2209] = ACTIONS(5435),
    [anon_sym_BSLASHprec] = ACTIONS(5433),
    [anon_sym_u227a] = ACTIONS(5435),
    [anon_sym_BSLASHsucc] = ACTIONS(5433),
    [anon_sym_u227b] = ACTIONS(5435),
    [anon_sym_BSLASHpreceq] = ACTIONS(5435),
    [anon_sym_u2aaf] = ACTIONS(5435),
    [anon_sym_BSLASHsucceq] = ACTIONS(5435),
    [anon_sym_u2ab0] = ACTIONS(5435),
    [anon_sym_BSLASHpropto] = ACTIONS(5435),
    [anon_sym_u221d] = ACTIONS(5435),
    [anon_sym_BSLASHsim] = ACTIONS(5433),
    [anon_sym_u223c] = ACTIONS(5435),
    [anon_sym_BSLASHsimeq] = ACTIONS(5435),
    [anon_sym_u2243] = ACTIONS(5435),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5433),
    [anon_sym_u228f] = ACTIONS(5435),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5433),
    [anon_sym_u2290] = ACTIONS(5435),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5435),
    [anon_sym_u2291] = ACTIONS(5435),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5435),
    [anon_sym_u2292] = ACTIONS(5435),
    [anon_sym_BSLASHsubset] = ACTIONS(5433),
    [anon_sym_u2282] = ACTIONS(5435),
    [anon_sym_BSLASHsupset] = ACTIONS(5433),
    [anon_sym_u2283] = ACTIONS(5435),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5435),
    [anon_sym_u2286] = ACTIONS(5435),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5435),
    [anon_sym_u2287] = ACTIONS(5435),
    [sym_compose] = ACTIONS(5435),
    [sym_map_to] = ACTIONS(5435),
    [sym_map_from] = ACTIONS(5435),
    [sym_setminus] = ACTIONS(5433),
    [anon_sym_BSLASHcap] = ACTIONS(5435),
    [anon_sym_BSLASHintersect] = ACTIONS(5435),
    [anon_sym_u2229] = ACTIONS(5435),
    [anon_sym_BSLASHcup] = ACTIONS(5435),
    [anon_sym_BSLASHunion] = ACTIONS(5435),
    [anon_sym_u222a] = ACTIONS(5435),
    [anon_sym_DOT_DOT] = ACTIONS(5433),
    [anon_sym_u2025] = ACTIONS(5435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5435),
    [anon_sym_u2026] = ACTIONS(5435),
    [anon_sym_PLUS] = ACTIONS(5433),
    [sym_plusplus] = ACTIONS(5435),
    [anon_sym_BSLASHoplus] = ACTIONS(5435),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5435),
    [anon_sym_u2295] = ACTIONS(5435),
    [anon_sym_BSLASHominus] = ACTIONS(5435),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5435),
    [anon_sym_u2296] = ACTIONS(5435),
    [sym_mod] = ACTIONS(5433),
    [sym_modmod] = ACTIONS(5435),
    [sym_vert] = ACTIONS(5433),
    [anon_sym_PIPE_PIPE] = ACTIONS(5435),
    [anon_sym_u2016] = ACTIONS(5435),
    [sym_minusminus] = ACTIONS(5435),
    [sym_amp] = ACTIONS(5433),
    [sym_ampamp] = ACTIONS(5435),
    [anon_sym_BSLASHodot] = ACTIONS(5435),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5435),
    [anon_sym_u2299] = ACTIONS(5435),
    [anon_sym_BSLASHoslash] = ACTIONS(5435),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5435),
    [anon_sym_u2298] = ACTIONS(5435),
    [anon_sym_BSLASHotimes] = ACTIONS(5435),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5435),
    [anon_sym_u2297] = ACTIONS(5435),
    [sym_mul] = ACTIONS(5433),
    [sym_mulmul] = ACTIONS(5435),
    [sym_slash] = ACTIONS(5433),
    [sym_slashslash] = ACTIONS(5435),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5435),
    [anon_sym_u25ef] = ACTIONS(5435),
    [anon_sym_BSLASHbullet] = ACTIONS(5435),
    [anon_sym_u25cf] = ACTIONS(5435),
    [anon_sym_BSLASHdiv] = ACTIONS(5435),
    [anon_sym_u00f7] = ACTIONS(5435),
    [anon_sym_BSLASHcirc] = ACTIONS(5435),
    [anon_sym_u2218] = ACTIONS(5435),
    [anon_sym_BSLASHstar] = ACTIONS(5435),
    [anon_sym_u22c6] = ACTIONS(5435),
    [anon_sym_u203c] = ACTIONS(5435),
    [sym_hashhash] = ACTIONS(5435),
    [sym_dol] = ACTIONS(5433),
    [sym_doldol] = ACTIONS(5435),
    [anon_sym_QMARK_QMARK] = ACTIONS(5435),
    [anon_sym_u2047] = ACTIONS(5435),
    [anon_sym_BSLASHsqcap] = ACTIONS(5435),
    [anon_sym_u2293] = ACTIONS(5435),
    [anon_sym_BSLASHsqcup] = ACTIONS(5435),
    [anon_sym_u2294] = ACTIONS(5435),
    [anon_sym_BSLASHuplus] = ACTIONS(5435),
    [anon_sym_u228e] = ACTIONS(5435),
    [anon_sym_BSLASHX] = ACTIONS(5435),
    [anon_sym_BSLASHtimes] = ACTIONS(5435),
    [anon_sym_u00d7] = ACTIONS(5435),
    [anon_sym_BSLASHwr] = ACTIONS(5435),
    [anon_sym_u2240] = ACTIONS(5435),
    [anon_sym_BSLASHcdot] = ACTIONS(5435),
    [anon_sym_u22c5] = ACTIONS(5435),
    [sym_pow] = ACTIONS(5433),
    [sym_powpow] = ACTIONS(5435),
    [anon_sym_CARET_PLUS] = ACTIONS(5435),
    [anon_sym_u207a] = ACTIONS(5435),
    [sym_asterisk] = ACTIONS(5435),
    [sym_sup_hash] = ACTIONS(5435),
    [sym_prime] = ACTIONS(5435),
    [sym__indent] = ACTIONS(5435),
    [sym__double_excl] = ACTIONS(5435),
  },
  [2156] = {
    [sym_block_comment] = STATE(2156),
    [sym_identifier] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5437),
    [anon_sym_u2208] = ACTIONS(5439),
    [anon_sym_BSLASHA] = ACTIONS(5437),
    [anon_sym_BSLASHforall] = ACTIONS(5439),
    [anon_sym_u2200] = ACTIONS(5439),
    [anon_sym_BSLASHE] = ACTIONS(5437),
    [anon_sym_BSLASHexists] = ACTIONS(5439),
    [anon_sym_u2203] = ACTIONS(5439),
    [sym_temporal_forall] = ACTIONS(5439),
    [sym_temporal_exists] = ACTIONS(5439),
    [anon_sym_LT_LT] = ACTIONS(5439),
    [anon_sym_u3008] = ACTIONS(5439),
    [anon_sym_u27e8] = ACTIONS(5439),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5439),
    [anon_sym_u25a1] = ACTIONS(5439),
    [anon_sym_AT] = ACTIONS(5437),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5439),
    [anon_sym_u2227] = ACTIONS(5439),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5439),
    [anon_sym_u2228] = ACTIONS(5439),
    [anon_sym_LPAREN] = ACTIONS(5437),
    [anon_sym_LBRACK] = ACTIONS(5437),
    [aux_sym_child_id_token1] = ACTIONS(5437),
    [sym_real_number] = ACTIONS(5439),
    [anon_sym_BSLASHb] = ACTIONS(5437),
    [anon_sym_BSLASHB] = ACTIONS(5439),
    [anon_sym_BSLASHo] = ACTIONS(5437),
    [anon_sym_BSLASHO] = ACTIONS(5439),
    [anon_sym_BSLASHh] = ACTIONS(5439),
    [anon_sym_BSLASHH] = ACTIONS(5439),
    [anon_sym_DQUOTE] = ACTIONS(5439),
    [anon_sym_TRUE] = ACTIONS(5437),
    [anon_sym_FALSE] = ACTIONS(5437),
    [sym_string_set] = ACTIONS(5437),
    [sym_boolean_set] = ACTIONS(5437),
    [anon_sym_Nat] = ACTIONS(5437),
    [anon_sym_u2115] = ACTIONS(5439),
    [anon_sym_Int] = ACTIONS(5437),
    [anon_sym_u2124] = ACTIONS(5439),
    [anon_sym_Real] = ACTIONS(5437),
    [anon_sym_u211d] = ACTIONS(5439),
    [anon_sym_CHOOSE] = ACTIONS(5437),
    [anon_sym_LBRACE] = ACTIONS(5439),
    [anon_sym_EQ] = ACTIONS(5437),
    [anon_sym_WF_] = ACTIONS(5437),
    [anon_sym_SF_] = ACTIONS(5437),
    [anon_sym_IF] = ACTIONS(5437),
    [anon_sym_CASE] = ACTIONS(5437),
    [anon_sym_LET] = ACTIONS(5437),
    [anon_sym_BSLASHlnot] = ACTIONS(5439),
    [anon_sym_BSLASHneg] = ACTIONS(5439),
    [anon_sym_TILDE] = ACTIONS(5437),
    [anon_sym_u00ac] = ACTIONS(5439),
    [sym_union] = ACTIONS(5437),
    [sym_powerset] = ACTIONS(5437),
    [sym_domain] = ACTIONS(5437),
    [anon_sym_DASH] = ACTIONS(5437),
    [sym_negative_dot] = ACTIONS(5439),
    [sym_enabled] = ACTIONS(5437),
    [sym_unchanged] = ACTIONS(5437),
    [anon_sym_LT_GT] = ACTIONS(5439),
    [anon_sym_u22c4] = ACTIONS(5439),
    [anon_sym_u25c7] = ACTIONS(5439),
    [anon_sym_EQ_GT] = ACTIONS(5439),
    [anon_sym_u27f9] = ACTIONS(5439),
    [anon_sym_u21d2] = ACTIONS(5439),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5439),
    [anon_sym_u21f8] = ACTIONS(5439),
    [anon_sym_u2945] = ACTIONS(5439),
    [anon_sym_BSLASHequiv] = ACTIONS(5439),
    [anon_sym_u2261] = ACTIONS(5439),
    [anon_sym_LT_EQ_GT] = ACTIONS(5439),
    [anon_sym_u27fa] = ACTIONS(5439),
    [anon_sym_u21d4] = ACTIONS(5439),
    [anon_sym_TILDE_GT] = ACTIONS(5439),
    [anon_sym_u21dd] = ACTIONS(5439),
    [anon_sym_u219d] = ACTIONS(5439),
    [anon_sym_BSLASHland] = ACTIONS(5439),
    [anon_sym_BSLASHlor] = ACTIONS(5439),
    [anon_sym_COLON_EQ] = ACTIONS(5439),
    [anon_sym_u2254] = ACTIONS(5439),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5439),
    [anon_sym_u2a74] = ACTIONS(5439),
    [anon_sym_SLASH_EQ] = ACTIONS(5439),
    [anon_sym_POUND] = ACTIONS(5437),
    [anon_sym_u2260] = ACTIONS(5439),
    [anon_sym_LT] = ACTIONS(5437),
    [sym_gt] = ACTIONS(5437),
    [anon_sym_LT_EQ] = ACTIONS(5437),
    [anon_sym_EQ_LT] = ACTIONS(5439),
    [anon_sym_BSLASHleq] = ACTIONS(5439),
    [anon_sym_u2264] = ACTIONS(5439),
    [anon_sym_GT_EQ] = ACTIONS(5439),
    [anon_sym_BSLASHgeq] = ACTIONS(5439),
    [anon_sym_u2265] = ACTIONS(5439),
    [anon_sym_BSLASHapprox] = ACTIONS(5439),
    [anon_sym_u2248] = ACTIONS(5439),
    [anon_sym_PIPE_DASH] = ACTIONS(5439),
    [anon_sym_u22a2] = ACTIONS(5439),
    [anon_sym_PIPE_EQ] = ACTIONS(5439),
    [anon_sym_u22a8] = ACTIONS(5439),
    [anon_sym_DASH_PIPE] = ACTIONS(5439),
    [anon_sym_u22a3] = ACTIONS(5439),
    [anon_sym_EQ_PIPE] = ACTIONS(5439),
    [anon_sym_u2ae4] = ACTIONS(5439),
    [anon_sym_BSLASHasymp] = ACTIONS(5439),
    [anon_sym_u224d] = ACTIONS(5439),
    [anon_sym_BSLASHcong] = ACTIONS(5439),
    [anon_sym_u2245] = ACTIONS(5439),
    [anon_sym_BSLASHdoteq] = ACTIONS(5439),
    [anon_sym_u2250] = ACTIONS(5439),
    [anon_sym_BSLASHgg] = ACTIONS(5439),
    [anon_sym_u226b] = ACTIONS(5439),
    [anon_sym_BSLASHll] = ACTIONS(5439),
    [anon_sym_u226a] = ACTIONS(5439),
    [anon_sym_BSLASHnotin] = ACTIONS(5439),
    [anon_sym_u2209] = ACTIONS(5439),
    [anon_sym_BSLASHprec] = ACTIONS(5437),
    [anon_sym_u227a] = ACTIONS(5439),
    [anon_sym_BSLASHsucc] = ACTIONS(5437),
    [anon_sym_u227b] = ACTIONS(5439),
    [anon_sym_BSLASHpreceq] = ACTIONS(5439),
    [anon_sym_u2aaf] = ACTIONS(5439),
    [anon_sym_BSLASHsucceq] = ACTIONS(5439),
    [anon_sym_u2ab0] = ACTIONS(5439),
    [anon_sym_BSLASHpropto] = ACTIONS(5439),
    [anon_sym_u221d] = ACTIONS(5439),
    [anon_sym_BSLASHsim] = ACTIONS(5437),
    [anon_sym_u223c] = ACTIONS(5439),
    [anon_sym_BSLASHsimeq] = ACTIONS(5439),
    [anon_sym_u2243] = ACTIONS(5439),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5437),
    [anon_sym_u228f] = ACTIONS(5439),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5437),
    [anon_sym_u2290] = ACTIONS(5439),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5439),
    [anon_sym_u2291] = ACTIONS(5439),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5439),
    [anon_sym_u2292] = ACTIONS(5439),
    [anon_sym_BSLASHsubset] = ACTIONS(5437),
    [anon_sym_u2282] = ACTIONS(5439),
    [anon_sym_BSLASHsupset] = ACTIONS(5437),
    [anon_sym_u2283] = ACTIONS(5439),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5439),
    [anon_sym_u2286] = ACTIONS(5439),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5439),
    [anon_sym_u2287] = ACTIONS(5439),
    [sym_compose] = ACTIONS(5439),
    [sym_map_to] = ACTIONS(5439),
    [sym_map_from] = ACTIONS(5439),
    [sym_setminus] = ACTIONS(5437),
    [anon_sym_BSLASHcap] = ACTIONS(5439),
    [anon_sym_BSLASHintersect] = ACTIONS(5439),
    [anon_sym_u2229] = ACTIONS(5439),
    [anon_sym_BSLASHcup] = ACTIONS(5439),
    [anon_sym_BSLASHunion] = ACTIONS(5439),
    [anon_sym_u222a] = ACTIONS(5439),
    [anon_sym_DOT_DOT] = ACTIONS(5437),
    [anon_sym_u2025] = ACTIONS(5439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5439),
    [anon_sym_u2026] = ACTIONS(5439),
    [anon_sym_PLUS] = ACTIONS(5437),
    [sym_plusplus] = ACTIONS(5439),
    [anon_sym_BSLASHoplus] = ACTIONS(5439),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5439),
    [anon_sym_u2295] = ACTIONS(5439),
    [anon_sym_BSLASHominus] = ACTIONS(5439),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5439),
    [anon_sym_u2296] = ACTIONS(5439),
    [sym_mod] = ACTIONS(5437),
    [sym_modmod] = ACTIONS(5439),
    [sym_vert] = ACTIONS(5437),
    [anon_sym_PIPE_PIPE] = ACTIONS(5439),
    [anon_sym_u2016] = ACTIONS(5439),
    [sym_minusminus] = ACTIONS(5439),
    [sym_amp] = ACTIONS(5437),
    [sym_ampamp] = ACTIONS(5439),
    [anon_sym_BSLASHodot] = ACTIONS(5439),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5439),
    [anon_sym_u2299] = ACTIONS(5439),
    [anon_sym_BSLASHoslash] = ACTIONS(5439),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5439),
    [anon_sym_u2298] = ACTIONS(5439),
    [anon_sym_BSLASHotimes] = ACTIONS(5439),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5439),
    [anon_sym_u2297] = ACTIONS(5439),
    [sym_mul] = ACTIONS(5437),
    [sym_mulmul] = ACTIONS(5439),
    [sym_slash] = ACTIONS(5437),
    [sym_slashslash] = ACTIONS(5439),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5439),
    [anon_sym_u25ef] = ACTIONS(5439),
    [anon_sym_BSLASHbullet] = ACTIONS(5439),
    [anon_sym_u25cf] = ACTIONS(5439),
    [anon_sym_BSLASHdiv] = ACTIONS(5439),
    [anon_sym_u00f7] = ACTIONS(5439),
    [anon_sym_BSLASHcirc] = ACTIONS(5439),
    [anon_sym_u2218] = ACTIONS(5439),
    [anon_sym_BSLASHstar] = ACTIONS(5439),
    [anon_sym_u22c6] = ACTIONS(5439),
    [anon_sym_u203c] = ACTIONS(5439),
    [sym_hashhash] = ACTIONS(5439),
    [sym_dol] = ACTIONS(5437),
    [sym_doldol] = ACTIONS(5439),
    [anon_sym_QMARK_QMARK] = ACTIONS(5439),
    [anon_sym_u2047] = ACTIONS(5439),
    [anon_sym_BSLASHsqcap] = ACTIONS(5439),
    [anon_sym_u2293] = ACTIONS(5439),
    [anon_sym_BSLASHsqcup] = ACTIONS(5439),
    [anon_sym_u2294] = ACTIONS(5439),
    [anon_sym_BSLASHuplus] = ACTIONS(5439),
    [anon_sym_u228e] = ACTIONS(5439),
    [anon_sym_BSLASHX] = ACTIONS(5439),
    [anon_sym_BSLASHtimes] = ACTIONS(5439),
    [anon_sym_u00d7] = ACTIONS(5439),
    [anon_sym_BSLASHwr] = ACTIONS(5439),
    [anon_sym_u2240] = ACTIONS(5439),
    [anon_sym_BSLASHcdot] = ACTIONS(5439),
    [anon_sym_u22c5] = ACTIONS(5439),
    [sym_pow] = ACTIONS(5437),
    [sym_powpow] = ACTIONS(5439),
    [anon_sym_CARET_PLUS] = ACTIONS(5439),
    [anon_sym_u207a] = ACTIONS(5439),
    [sym_asterisk] = ACTIONS(5439),
    [sym_sup_hash] = ACTIONS(5439),
    [sym_prime] = ACTIONS(5439),
    [sym__indent] = ACTIONS(5439),
    [sym__double_excl] = ACTIONS(5439),
  },
  [2157] = {
    [sym_block_comment] = STATE(2157),
    [sym_identifier] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5441),
    [anon_sym_u2208] = ACTIONS(5443),
    [anon_sym_BSLASHA] = ACTIONS(5441),
    [anon_sym_BSLASHforall] = ACTIONS(5443),
    [anon_sym_u2200] = ACTIONS(5443),
    [anon_sym_BSLASHE] = ACTIONS(5441),
    [anon_sym_BSLASHexists] = ACTIONS(5443),
    [anon_sym_u2203] = ACTIONS(5443),
    [sym_temporal_forall] = ACTIONS(5443),
    [sym_temporal_exists] = ACTIONS(5443),
    [anon_sym_LT_LT] = ACTIONS(5443),
    [anon_sym_u3008] = ACTIONS(5443),
    [anon_sym_u27e8] = ACTIONS(5443),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5443),
    [anon_sym_u25a1] = ACTIONS(5443),
    [anon_sym_AT] = ACTIONS(5441),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5443),
    [anon_sym_u2227] = ACTIONS(5443),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5443),
    [anon_sym_u2228] = ACTIONS(5443),
    [anon_sym_LPAREN] = ACTIONS(5441),
    [anon_sym_LBRACK] = ACTIONS(5441),
    [aux_sym_child_id_token1] = ACTIONS(5441),
    [sym_real_number] = ACTIONS(5443),
    [anon_sym_BSLASHb] = ACTIONS(5441),
    [anon_sym_BSLASHB] = ACTIONS(5443),
    [anon_sym_BSLASHo] = ACTIONS(5441),
    [anon_sym_BSLASHO] = ACTIONS(5443),
    [anon_sym_BSLASHh] = ACTIONS(5443),
    [anon_sym_BSLASHH] = ACTIONS(5443),
    [anon_sym_DQUOTE] = ACTIONS(5443),
    [anon_sym_TRUE] = ACTIONS(5441),
    [anon_sym_FALSE] = ACTIONS(5441),
    [sym_string_set] = ACTIONS(5441),
    [sym_boolean_set] = ACTIONS(5441),
    [anon_sym_Nat] = ACTIONS(5441),
    [anon_sym_u2115] = ACTIONS(5443),
    [anon_sym_Int] = ACTIONS(5441),
    [anon_sym_u2124] = ACTIONS(5443),
    [anon_sym_Real] = ACTIONS(5441),
    [anon_sym_u211d] = ACTIONS(5443),
    [anon_sym_CHOOSE] = ACTIONS(5441),
    [anon_sym_LBRACE] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5441),
    [anon_sym_WF_] = ACTIONS(5441),
    [anon_sym_SF_] = ACTIONS(5441),
    [anon_sym_IF] = ACTIONS(5441),
    [anon_sym_CASE] = ACTIONS(5441),
    [anon_sym_LET] = ACTIONS(5441),
    [anon_sym_BSLASHlnot] = ACTIONS(5443),
    [anon_sym_BSLASHneg] = ACTIONS(5443),
    [anon_sym_TILDE] = ACTIONS(5441),
    [anon_sym_u00ac] = ACTIONS(5443),
    [sym_union] = ACTIONS(5441),
    [sym_powerset] = ACTIONS(5441),
    [sym_domain] = ACTIONS(5441),
    [anon_sym_DASH] = ACTIONS(5441),
    [sym_negative_dot] = ACTIONS(5443),
    [sym_enabled] = ACTIONS(5441),
    [sym_unchanged] = ACTIONS(5441),
    [anon_sym_LT_GT] = ACTIONS(5443),
    [anon_sym_u22c4] = ACTIONS(5443),
    [anon_sym_u25c7] = ACTIONS(5443),
    [anon_sym_EQ_GT] = ACTIONS(5443),
    [anon_sym_u27f9] = ACTIONS(5443),
    [anon_sym_u21d2] = ACTIONS(5443),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5443),
    [anon_sym_u21f8] = ACTIONS(5443),
    [anon_sym_u2945] = ACTIONS(5443),
    [anon_sym_BSLASHequiv] = ACTIONS(5443),
    [anon_sym_u2261] = ACTIONS(5443),
    [anon_sym_LT_EQ_GT] = ACTIONS(5443),
    [anon_sym_u27fa] = ACTIONS(5443),
    [anon_sym_u21d4] = ACTIONS(5443),
    [anon_sym_TILDE_GT] = ACTIONS(5443),
    [anon_sym_u21dd] = ACTIONS(5443),
    [anon_sym_u219d] = ACTIONS(5443),
    [anon_sym_BSLASHland] = ACTIONS(5443),
    [anon_sym_BSLASHlor] = ACTIONS(5443),
    [anon_sym_COLON_EQ] = ACTIONS(5443),
    [anon_sym_u2254] = ACTIONS(5443),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5443),
    [anon_sym_u2a74] = ACTIONS(5443),
    [anon_sym_SLASH_EQ] = ACTIONS(5443),
    [anon_sym_POUND] = ACTIONS(5441),
    [anon_sym_u2260] = ACTIONS(5443),
    [anon_sym_LT] = ACTIONS(5441),
    [sym_gt] = ACTIONS(5441),
    [anon_sym_LT_EQ] = ACTIONS(5441),
    [anon_sym_EQ_LT] = ACTIONS(5443),
    [anon_sym_BSLASHleq] = ACTIONS(5443),
    [anon_sym_u2264] = ACTIONS(5443),
    [anon_sym_GT_EQ] = ACTIONS(5443),
    [anon_sym_BSLASHgeq] = ACTIONS(5443),
    [anon_sym_u2265] = ACTIONS(5443),
    [anon_sym_BSLASHapprox] = ACTIONS(5443),
    [anon_sym_u2248] = ACTIONS(5443),
    [anon_sym_PIPE_DASH] = ACTIONS(5443),
    [anon_sym_u22a2] = ACTIONS(5443),
    [anon_sym_PIPE_EQ] = ACTIONS(5443),
    [anon_sym_u22a8] = ACTIONS(5443),
    [anon_sym_DASH_PIPE] = ACTIONS(5443),
    [anon_sym_u22a3] = ACTIONS(5443),
    [anon_sym_EQ_PIPE] = ACTIONS(5443),
    [anon_sym_u2ae4] = ACTIONS(5443),
    [anon_sym_BSLASHasymp] = ACTIONS(5443),
    [anon_sym_u224d] = ACTIONS(5443),
    [anon_sym_BSLASHcong] = ACTIONS(5443),
    [anon_sym_u2245] = ACTIONS(5443),
    [anon_sym_BSLASHdoteq] = ACTIONS(5443),
    [anon_sym_u2250] = ACTIONS(5443),
    [anon_sym_BSLASHgg] = ACTIONS(5443),
    [anon_sym_u226b] = ACTIONS(5443),
    [anon_sym_BSLASHll] = ACTIONS(5443),
    [anon_sym_u226a] = ACTIONS(5443),
    [anon_sym_BSLASHnotin] = ACTIONS(5443),
    [anon_sym_u2209] = ACTIONS(5443),
    [anon_sym_BSLASHprec] = ACTIONS(5441),
    [anon_sym_u227a] = ACTIONS(5443),
    [anon_sym_BSLASHsucc] = ACTIONS(5441),
    [anon_sym_u227b] = ACTIONS(5443),
    [anon_sym_BSLASHpreceq] = ACTIONS(5443),
    [anon_sym_u2aaf] = ACTIONS(5443),
    [anon_sym_BSLASHsucceq] = ACTIONS(5443),
    [anon_sym_u2ab0] = ACTIONS(5443),
    [anon_sym_BSLASHpropto] = ACTIONS(5443),
    [anon_sym_u221d] = ACTIONS(5443),
    [anon_sym_BSLASHsim] = ACTIONS(5441),
    [anon_sym_u223c] = ACTIONS(5443),
    [anon_sym_BSLASHsimeq] = ACTIONS(5443),
    [anon_sym_u2243] = ACTIONS(5443),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5441),
    [anon_sym_u228f] = ACTIONS(5443),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5441),
    [anon_sym_u2290] = ACTIONS(5443),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5443),
    [anon_sym_u2291] = ACTIONS(5443),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5443),
    [anon_sym_u2292] = ACTIONS(5443),
    [anon_sym_BSLASHsubset] = ACTIONS(5441),
    [anon_sym_u2282] = ACTIONS(5443),
    [anon_sym_BSLASHsupset] = ACTIONS(5441),
    [anon_sym_u2283] = ACTIONS(5443),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5443),
    [anon_sym_u2286] = ACTIONS(5443),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5443),
    [anon_sym_u2287] = ACTIONS(5443),
    [sym_compose] = ACTIONS(5443),
    [sym_map_to] = ACTIONS(5443),
    [sym_map_from] = ACTIONS(5443),
    [sym_setminus] = ACTIONS(5441),
    [anon_sym_BSLASHcap] = ACTIONS(5443),
    [anon_sym_BSLASHintersect] = ACTIONS(5443),
    [anon_sym_u2229] = ACTIONS(5443),
    [anon_sym_BSLASHcup] = ACTIONS(5443),
    [anon_sym_BSLASHunion] = ACTIONS(5443),
    [anon_sym_u222a] = ACTIONS(5443),
    [anon_sym_DOT_DOT] = ACTIONS(5441),
    [anon_sym_u2025] = ACTIONS(5443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5443),
    [anon_sym_u2026] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5441),
    [sym_plusplus] = ACTIONS(5443),
    [anon_sym_BSLASHoplus] = ACTIONS(5443),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5443),
    [anon_sym_u2295] = ACTIONS(5443),
    [anon_sym_BSLASHominus] = ACTIONS(5443),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5443),
    [anon_sym_u2296] = ACTIONS(5443),
    [sym_mod] = ACTIONS(5441),
    [sym_modmod] = ACTIONS(5443),
    [sym_vert] = ACTIONS(5441),
    [anon_sym_PIPE_PIPE] = ACTIONS(5443),
    [anon_sym_u2016] = ACTIONS(5443),
    [sym_minusminus] = ACTIONS(5443),
    [sym_amp] = ACTIONS(5441),
    [sym_ampamp] = ACTIONS(5443),
    [anon_sym_BSLASHodot] = ACTIONS(5443),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5443),
    [anon_sym_u2299] = ACTIONS(5443),
    [anon_sym_BSLASHoslash] = ACTIONS(5443),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5443),
    [anon_sym_u2298] = ACTIONS(5443),
    [anon_sym_BSLASHotimes] = ACTIONS(5443),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5443),
    [anon_sym_u2297] = ACTIONS(5443),
    [sym_mul] = ACTIONS(5441),
    [sym_mulmul] = ACTIONS(5443),
    [sym_slash] = ACTIONS(5441),
    [sym_slashslash] = ACTIONS(5443),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5443),
    [anon_sym_u25ef] = ACTIONS(5443),
    [anon_sym_BSLASHbullet] = ACTIONS(5443),
    [anon_sym_u25cf] = ACTIONS(5443),
    [anon_sym_BSLASHdiv] = ACTIONS(5443),
    [anon_sym_u00f7] = ACTIONS(5443),
    [anon_sym_BSLASHcirc] = ACTIONS(5443),
    [anon_sym_u2218] = ACTIONS(5443),
    [anon_sym_BSLASHstar] = ACTIONS(5443),
    [anon_sym_u22c6] = ACTIONS(5443),
    [anon_sym_u203c] = ACTIONS(5443),
    [sym_hashhash] = ACTIONS(5443),
    [sym_dol] = ACTIONS(5441),
    [sym_doldol] = ACTIONS(5443),
    [anon_sym_QMARK_QMARK] = ACTIONS(5443),
    [anon_sym_u2047] = ACTIONS(5443),
    [anon_sym_BSLASHsqcap] = ACTIONS(5443),
    [anon_sym_u2293] = ACTIONS(5443),
    [anon_sym_BSLASHsqcup] = ACTIONS(5443),
    [anon_sym_u2294] = ACTIONS(5443),
    [anon_sym_BSLASHuplus] = ACTIONS(5443),
    [anon_sym_u228e] = ACTIONS(5443),
    [anon_sym_BSLASHX] = ACTIONS(5443),
    [anon_sym_BSLASHtimes] = ACTIONS(5443),
    [anon_sym_u00d7] = ACTIONS(5443),
    [anon_sym_BSLASHwr] = ACTIONS(5443),
    [anon_sym_u2240] = ACTIONS(5443),
    [anon_sym_BSLASHcdot] = ACTIONS(5443),
    [anon_sym_u22c5] = ACTIONS(5443),
    [sym_pow] = ACTIONS(5441),
    [sym_powpow] = ACTIONS(5443),
    [anon_sym_CARET_PLUS] = ACTIONS(5443),
    [anon_sym_u207a] = ACTIONS(5443),
    [sym_asterisk] = ACTIONS(5443),
    [sym_sup_hash] = ACTIONS(5443),
    [sym_prime] = ACTIONS(5443),
    [sym__indent] = ACTIONS(5443),
    [sym__double_excl] = ACTIONS(5443),
  },
  [2158] = {
    [sym_block_comment] = STATE(2158),
    [sym_identifier] = ACTIONS(4278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(4278),
    [anon_sym_u2208] = ACTIONS(4269),
    [anon_sym_BSLASHA] = ACTIONS(4278),
    [anon_sym_BSLASHforall] = ACTIONS(4269),
    [anon_sym_u2200] = ACTIONS(4269),
    [anon_sym_BSLASHE] = ACTIONS(4278),
    [anon_sym_BSLASHexists] = ACTIONS(4269),
    [anon_sym_u2203] = ACTIONS(4269),
    [sym_temporal_forall] = ACTIONS(4269),
    [sym_temporal_exists] = ACTIONS(4269),
    [anon_sym_LT_LT] = ACTIONS(4269),
    [anon_sym_u3008] = ACTIONS(4269),
    [anon_sym_u27e8] = ACTIONS(4269),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4269),
    [anon_sym_u25a1] = ACTIONS(4269),
    [anon_sym_AT] = ACTIONS(4278),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4269),
    [anon_sym_u2227] = ACTIONS(4269),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4269),
    [anon_sym_u2228] = ACTIONS(4269),
    [anon_sym_LPAREN] = ACTIONS(4278),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [aux_sym_child_id_token1] = ACTIONS(4278),
    [sym_real_number] = ACTIONS(4269),
    [anon_sym_BSLASHb] = ACTIONS(4278),
    [anon_sym_BSLASHB] = ACTIONS(4269),
    [anon_sym_BSLASHo] = ACTIONS(4278),
    [anon_sym_BSLASHO] = ACTIONS(4269),
    [anon_sym_BSLASHh] = ACTIONS(4269),
    [anon_sym_BSLASHH] = ACTIONS(4269),
    [anon_sym_DQUOTE] = ACTIONS(4269),
    [anon_sym_TRUE] = ACTIONS(4278),
    [anon_sym_FALSE] = ACTIONS(4278),
    [sym_string_set] = ACTIONS(4278),
    [sym_boolean_set] = ACTIONS(4278),
    [anon_sym_Nat] = ACTIONS(4278),
    [anon_sym_u2115] = ACTIONS(4269),
    [anon_sym_Int] = ACTIONS(4278),
    [anon_sym_u2124] = ACTIONS(4269),
    [anon_sym_Real] = ACTIONS(4278),
    [anon_sym_u211d] = ACTIONS(4269),
    [anon_sym_CHOOSE] = ACTIONS(4278),
    [anon_sym_LBRACE] = ACTIONS(4269),
    [anon_sym_EQ] = ACTIONS(4278),
    [anon_sym_WF_] = ACTIONS(4278),
    [anon_sym_SF_] = ACTIONS(4278),
    [anon_sym_IF] = ACTIONS(4278),
    [anon_sym_CASE] = ACTIONS(4278),
    [anon_sym_LET] = ACTIONS(4278),
    [anon_sym_BSLASHlnot] = ACTIONS(4269),
    [anon_sym_BSLASHneg] = ACTIONS(4269),
    [anon_sym_TILDE] = ACTIONS(4278),
    [anon_sym_u00ac] = ACTIONS(4269),
    [sym_union] = ACTIONS(4278),
    [sym_powerset] = ACTIONS(4278),
    [sym_domain] = ACTIONS(4278),
    [anon_sym_DASH] = ACTIONS(4278),
    [sym_negative_dot] = ACTIONS(4269),
    [sym_enabled] = ACTIONS(4278),
    [sym_unchanged] = ACTIONS(4278),
    [anon_sym_LT_GT] = ACTIONS(4269),
    [anon_sym_u22c4] = ACTIONS(4269),
    [anon_sym_u25c7] = ACTIONS(4269),
    [anon_sym_EQ_GT] = ACTIONS(4269),
    [anon_sym_u27f9] = ACTIONS(4269),
    [anon_sym_u21d2] = ACTIONS(4269),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4269),
    [anon_sym_u21f8] = ACTIONS(4269),
    [anon_sym_u2945] = ACTIONS(4269),
    [anon_sym_BSLASHequiv] = ACTIONS(4269),
    [anon_sym_u2261] = ACTIONS(4269),
    [anon_sym_LT_EQ_GT] = ACTIONS(4269),
    [anon_sym_u27fa] = ACTIONS(4269),
    [anon_sym_u21d4] = ACTIONS(4269),
    [anon_sym_TILDE_GT] = ACTIONS(4269),
    [anon_sym_u21dd] = ACTIONS(4269),
    [anon_sym_u219d] = ACTIONS(4269),
    [anon_sym_BSLASHland] = ACTIONS(4269),
    [anon_sym_BSLASHlor] = ACTIONS(4269),
    [anon_sym_COLON_EQ] = ACTIONS(4269),
    [anon_sym_u2254] = ACTIONS(4269),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4269),
    [anon_sym_u2a74] = ACTIONS(4269),
    [anon_sym_SLASH_EQ] = ACTIONS(4269),
    [anon_sym_POUND] = ACTIONS(4278),
    [anon_sym_u2260] = ACTIONS(4269),
    [anon_sym_LT] = ACTIONS(4278),
    [sym_gt] = ACTIONS(4278),
    [anon_sym_LT_EQ] = ACTIONS(4278),
    [anon_sym_EQ_LT] = ACTIONS(4269),
    [anon_sym_BSLASHleq] = ACTIONS(4269),
    [anon_sym_u2264] = ACTIONS(4269),
    [anon_sym_GT_EQ] = ACTIONS(4269),
    [anon_sym_BSLASHgeq] = ACTIONS(4269),
    [anon_sym_u2265] = ACTIONS(4269),
    [anon_sym_BSLASHapprox] = ACTIONS(4269),
    [anon_sym_u2248] = ACTIONS(4269),
    [anon_sym_PIPE_DASH] = ACTIONS(4269),
    [anon_sym_u22a2] = ACTIONS(4269),
    [anon_sym_PIPE_EQ] = ACTIONS(4269),
    [anon_sym_u22a8] = ACTIONS(4269),
    [anon_sym_DASH_PIPE] = ACTIONS(4269),
    [anon_sym_u22a3] = ACTIONS(4269),
    [anon_sym_EQ_PIPE] = ACTIONS(4269),
    [anon_sym_u2ae4] = ACTIONS(4269),
    [anon_sym_BSLASHasymp] = ACTIONS(4269),
    [anon_sym_u224d] = ACTIONS(4269),
    [anon_sym_BSLASHcong] = ACTIONS(4269),
    [anon_sym_u2245] = ACTIONS(4269),
    [anon_sym_BSLASHdoteq] = ACTIONS(4269),
    [anon_sym_u2250] = ACTIONS(4269),
    [anon_sym_BSLASHgg] = ACTIONS(4269),
    [anon_sym_u226b] = ACTIONS(4269),
    [anon_sym_BSLASHll] = ACTIONS(4269),
    [anon_sym_u226a] = ACTIONS(4269),
    [anon_sym_BSLASHnotin] = ACTIONS(4269),
    [anon_sym_u2209] = ACTIONS(4269),
    [anon_sym_BSLASHprec] = ACTIONS(4278),
    [anon_sym_u227a] = ACTIONS(4269),
    [anon_sym_BSLASHsucc] = ACTIONS(4278),
    [anon_sym_u227b] = ACTIONS(4269),
    [anon_sym_BSLASHpreceq] = ACTIONS(4269),
    [anon_sym_u2aaf] = ACTIONS(4269),
    [anon_sym_BSLASHsucceq] = ACTIONS(4269),
    [anon_sym_u2ab0] = ACTIONS(4269),
    [anon_sym_BSLASHpropto] = ACTIONS(4269),
    [anon_sym_u221d] = ACTIONS(4269),
    [anon_sym_BSLASHsim] = ACTIONS(4278),
    [anon_sym_u223c] = ACTIONS(4269),
    [anon_sym_BSLASHsimeq] = ACTIONS(4269),
    [anon_sym_u2243] = ACTIONS(4269),
    [anon_sym_BSLASHsqsubset] = ACTIONS(4278),
    [anon_sym_u228f] = ACTIONS(4269),
    [anon_sym_BSLASHsqsupset] = ACTIONS(4278),
    [anon_sym_u2290] = ACTIONS(4269),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4269),
    [anon_sym_u2291] = ACTIONS(4269),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4269),
    [anon_sym_u2292] = ACTIONS(4269),
    [anon_sym_BSLASHsubset] = ACTIONS(4278),
    [anon_sym_u2282] = ACTIONS(4269),
    [anon_sym_BSLASHsupset] = ACTIONS(4278),
    [anon_sym_u2283] = ACTIONS(4269),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4269),
    [anon_sym_u2286] = ACTIONS(4269),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4269),
    [anon_sym_u2287] = ACTIONS(4269),
    [sym_compose] = ACTIONS(4269),
    [sym_map_to] = ACTIONS(4269),
    [sym_map_from] = ACTIONS(4269),
    [sym_setminus] = ACTIONS(4278),
    [anon_sym_BSLASHcap] = ACTIONS(4269),
    [anon_sym_BSLASHintersect] = ACTIONS(4269),
    [anon_sym_u2229] = ACTIONS(4269),
    [anon_sym_BSLASHcup] = ACTIONS(4269),
    [anon_sym_BSLASHunion] = ACTIONS(4269),
    [anon_sym_u222a] = ACTIONS(4269),
    [anon_sym_DOT_DOT] = ACTIONS(4278),
    [anon_sym_u2025] = ACTIONS(4269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4269),
    [anon_sym_u2026] = ACTIONS(4269),
    [anon_sym_PLUS] = ACTIONS(4278),
    [sym_plusplus] = ACTIONS(4269),
    [anon_sym_BSLASHoplus] = ACTIONS(4269),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4269),
    [anon_sym_u2295] = ACTIONS(4269),
    [anon_sym_BSLASHominus] = ACTIONS(4269),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4269),
    [anon_sym_u2296] = ACTIONS(4269),
    [sym_mod] = ACTIONS(4278),
    [sym_modmod] = ACTIONS(4269),
    [sym_vert] = ACTIONS(4278),
    [anon_sym_PIPE_PIPE] = ACTIONS(4269),
    [anon_sym_u2016] = ACTIONS(4269),
    [sym_minusminus] = ACTIONS(4269),
    [sym_amp] = ACTIONS(4278),
    [sym_ampamp] = ACTIONS(4269),
    [anon_sym_BSLASHodot] = ACTIONS(4269),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4269),
    [anon_sym_u2299] = ACTIONS(4269),
    [anon_sym_BSLASHoslash] = ACTIONS(4269),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4269),
    [anon_sym_u2298] = ACTIONS(4269),
    [anon_sym_BSLASHotimes] = ACTIONS(4269),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4269),
    [anon_sym_u2297] = ACTIONS(4269),
    [sym_mul] = ACTIONS(4278),
    [sym_mulmul] = ACTIONS(4269),
    [sym_slash] = ACTIONS(4278),
    [sym_slashslash] = ACTIONS(4269),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4269),
    [anon_sym_u25ef] = ACTIONS(4269),
    [anon_sym_BSLASHbullet] = ACTIONS(4269),
    [anon_sym_u25cf] = ACTIONS(4269),
    [anon_sym_BSLASHdiv] = ACTIONS(4269),
    [anon_sym_u00f7] = ACTIONS(4269),
    [anon_sym_BSLASHcirc] = ACTIONS(4269),
    [anon_sym_u2218] = ACTIONS(4269),
    [anon_sym_BSLASHstar] = ACTIONS(4269),
    [anon_sym_u22c6] = ACTIONS(4269),
    [anon_sym_u203c] = ACTIONS(4269),
    [sym_hashhash] = ACTIONS(4269),
    [sym_dol] = ACTIONS(4278),
    [sym_doldol] = ACTIONS(4269),
    [anon_sym_QMARK_QMARK] = ACTIONS(4269),
    [anon_sym_u2047] = ACTIONS(4269),
    [anon_sym_BSLASHsqcap] = ACTIONS(4269),
    [anon_sym_u2293] = ACTIONS(4269),
    [anon_sym_BSLASHsqcup] = ACTIONS(4269),
    [anon_sym_u2294] = ACTIONS(4269),
    [anon_sym_BSLASHuplus] = ACTIONS(4269),
    [anon_sym_u228e] = ACTIONS(4269),
    [anon_sym_BSLASHX] = ACTIONS(4269),
    [anon_sym_BSLASHtimes] = ACTIONS(4269),
    [anon_sym_u00d7] = ACTIONS(4269),
    [anon_sym_BSLASHwr] = ACTIONS(4269),
    [anon_sym_u2240] = ACTIONS(4269),
    [anon_sym_BSLASHcdot] = ACTIONS(4269),
    [anon_sym_u22c5] = ACTIONS(4269),
    [sym_pow] = ACTIONS(4278),
    [sym_powpow] = ACTIONS(4269),
    [anon_sym_CARET_PLUS] = ACTIONS(4269),
    [anon_sym_u207a] = ACTIONS(4269),
    [sym_asterisk] = ACTIONS(4269),
    [sym_sup_hash] = ACTIONS(4269),
    [sym_prime] = ACTIONS(4269),
    [sym__indent] = ACTIONS(4269),
    [sym__double_excl] = ACTIONS(4269),
  },
  [2159] = {
    [sym_block_comment] = STATE(2159),
    [sym_identifier] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5445),
    [anon_sym_u2208] = ACTIONS(5447),
    [anon_sym_BSLASHA] = ACTIONS(5445),
    [anon_sym_BSLASHforall] = ACTIONS(5447),
    [anon_sym_u2200] = ACTIONS(5447),
    [anon_sym_BSLASHE] = ACTIONS(5445),
    [anon_sym_BSLASHexists] = ACTIONS(5447),
    [anon_sym_u2203] = ACTIONS(5447),
    [sym_temporal_forall] = ACTIONS(5447),
    [sym_temporal_exists] = ACTIONS(5447),
    [anon_sym_LT_LT] = ACTIONS(5447),
    [anon_sym_u3008] = ACTIONS(5447),
    [anon_sym_u27e8] = ACTIONS(5447),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5447),
    [anon_sym_u25a1] = ACTIONS(5447),
    [anon_sym_AT] = ACTIONS(5445),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5447),
    [anon_sym_u2227] = ACTIONS(5447),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5447),
    [anon_sym_u2228] = ACTIONS(5447),
    [anon_sym_LPAREN] = ACTIONS(5445),
    [anon_sym_LBRACK] = ACTIONS(5445),
    [aux_sym_child_id_token1] = ACTIONS(5445),
    [sym_real_number] = ACTIONS(5447),
    [anon_sym_BSLASHb] = ACTIONS(5445),
    [anon_sym_BSLASHB] = ACTIONS(5447),
    [anon_sym_BSLASHo] = ACTIONS(5445),
    [anon_sym_BSLASHO] = ACTIONS(5447),
    [anon_sym_BSLASHh] = ACTIONS(5447),
    [anon_sym_BSLASHH] = ACTIONS(5447),
    [anon_sym_DQUOTE] = ACTIONS(5447),
    [anon_sym_TRUE] = ACTIONS(5445),
    [anon_sym_FALSE] = ACTIONS(5445),
    [sym_string_set] = ACTIONS(5445),
    [sym_boolean_set] = ACTIONS(5445),
    [anon_sym_Nat] = ACTIONS(5445),
    [anon_sym_u2115] = ACTIONS(5447),
    [anon_sym_Int] = ACTIONS(5445),
    [anon_sym_u2124] = ACTIONS(5447),
    [anon_sym_Real] = ACTIONS(5445),
    [anon_sym_u211d] = ACTIONS(5447),
    [anon_sym_CHOOSE] = ACTIONS(5445),
    [anon_sym_LBRACE] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5445),
    [anon_sym_WF_] = ACTIONS(5445),
    [anon_sym_SF_] = ACTIONS(5445),
    [anon_sym_IF] = ACTIONS(5445),
    [anon_sym_CASE] = ACTIONS(5445),
    [anon_sym_LET] = ACTIONS(5445),
    [anon_sym_BSLASHlnot] = ACTIONS(5447),
    [anon_sym_BSLASHneg] = ACTIONS(5447),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_u00ac] = ACTIONS(5447),
    [sym_union] = ACTIONS(5445),
    [sym_powerset] = ACTIONS(5445),
    [sym_domain] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5445),
    [sym_negative_dot] = ACTIONS(5447),
    [sym_enabled] = ACTIONS(5445),
    [sym_unchanged] = ACTIONS(5445),
    [anon_sym_LT_GT] = ACTIONS(5447),
    [anon_sym_u22c4] = ACTIONS(5447),
    [anon_sym_u25c7] = ACTIONS(5447),
    [anon_sym_EQ_GT] = ACTIONS(5447),
    [anon_sym_u27f9] = ACTIONS(5447),
    [anon_sym_u21d2] = ACTIONS(5447),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5447),
    [anon_sym_u21f8] = ACTIONS(5447),
    [anon_sym_u2945] = ACTIONS(5447),
    [anon_sym_BSLASHequiv] = ACTIONS(5447),
    [anon_sym_u2261] = ACTIONS(5447),
    [anon_sym_LT_EQ_GT] = ACTIONS(5447),
    [anon_sym_u27fa] = ACTIONS(5447),
    [anon_sym_u21d4] = ACTIONS(5447),
    [anon_sym_TILDE_GT] = ACTIONS(5447),
    [anon_sym_u21dd] = ACTIONS(5447),
    [anon_sym_u219d] = ACTIONS(5447),
    [anon_sym_BSLASHland] = ACTIONS(5447),
    [anon_sym_BSLASHlor] = ACTIONS(5447),
    [anon_sym_COLON_EQ] = ACTIONS(5447),
    [anon_sym_u2254] = ACTIONS(5447),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5447),
    [anon_sym_u2a74] = ACTIONS(5447),
    [anon_sym_SLASH_EQ] = ACTIONS(5447),
    [anon_sym_POUND] = ACTIONS(5445),
    [anon_sym_u2260] = ACTIONS(5447),
    [anon_sym_LT] = ACTIONS(5445),
    [sym_gt] = ACTIONS(5445),
    [anon_sym_LT_EQ] = ACTIONS(5445),
    [anon_sym_EQ_LT] = ACTIONS(5447),
    [anon_sym_BSLASHleq] = ACTIONS(5447),
    [anon_sym_u2264] = ACTIONS(5447),
    [anon_sym_GT_EQ] = ACTIONS(5447),
    [anon_sym_BSLASHgeq] = ACTIONS(5447),
    [anon_sym_u2265] = ACTIONS(5447),
    [anon_sym_BSLASHapprox] = ACTIONS(5447),
    [anon_sym_u2248] = ACTIONS(5447),
    [anon_sym_PIPE_DASH] = ACTIONS(5447),
    [anon_sym_u22a2] = ACTIONS(5447),
    [anon_sym_PIPE_EQ] = ACTIONS(5447),
    [anon_sym_u22a8] = ACTIONS(5447),
    [anon_sym_DASH_PIPE] = ACTIONS(5447),
    [anon_sym_u22a3] = ACTIONS(5447),
    [anon_sym_EQ_PIPE] = ACTIONS(5447),
    [anon_sym_u2ae4] = ACTIONS(5447),
    [anon_sym_BSLASHasymp] = ACTIONS(5447),
    [anon_sym_u224d] = ACTIONS(5447),
    [anon_sym_BSLASHcong] = ACTIONS(5447),
    [anon_sym_u2245] = ACTIONS(5447),
    [anon_sym_BSLASHdoteq] = ACTIONS(5447),
    [anon_sym_u2250] = ACTIONS(5447),
    [anon_sym_BSLASHgg] = ACTIONS(5447),
    [anon_sym_u226b] = ACTIONS(5447),
    [anon_sym_BSLASHll] = ACTIONS(5447),
    [anon_sym_u226a] = ACTIONS(5447),
    [anon_sym_BSLASHnotin] = ACTIONS(5447),
    [anon_sym_u2209] = ACTIONS(5447),
    [anon_sym_BSLASHprec] = ACTIONS(5445),
    [anon_sym_u227a] = ACTIONS(5447),
    [anon_sym_BSLASHsucc] = ACTIONS(5445),
    [anon_sym_u227b] = ACTIONS(5447),
    [anon_sym_BSLASHpreceq] = ACTIONS(5447),
    [anon_sym_u2aaf] = ACTIONS(5447),
    [anon_sym_BSLASHsucceq] = ACTIONS(5447),
    [anon_sym_u2ab0] = ACTIONS(5447),
    [anon_sym_BSLASHpropto] = ACTIONS(5447),
    [anon_sym_u221d] = ACTIONS(5447),
    [anon_sym_BSLASHsim] = ACTIONS(5445),
    [anon_sym_u223c] = ACTIONS(5447),
    [anon_sym_BSLASHsimeq] = ACTIONS(5447),
    [anon_sym_u2243] = ACTIONS(5447),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5445),
    [anon_sym_u228f] = ACTIONS(5447),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5445),
    [anon_sym_u2290] = ACTIONS(5447),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5447),
    [anon_sym_u2291] = ACTIONS(5447),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5447),
    [anon_sym_u2292] = ACTIONS(5447),
    [anon_sym_BSLASHsubset] = ACTIONS(5445),
    [anon_sym_u2282] = ACTIONS(5447),
    [anon_sym_BSLASHsupset] = ACTIONS(5445),
    [anon_sym_u2283] = ACTIONS(5447),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5447),
    [anon_sym_u2286] = ACTIONS(5447),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5447),
    [anon_sym_u2287] = ACTIONS(5447),
    [sym_compose] = ACTIONS(5447),
    [sym_map_to] = ACTIONS(5447),
    [sym_map_from] = ACTIONS(5447),
    [sym_setminus] = ACTIONS(5445),
    [anon_sym_BSLASHcap] = ACTIONS(5447),
    [anon_sym_BSLASHintersect] = ACTIONS(5447),
    [anon_sym_u2229] = ACTIONS(5447),
    [anon_sym_BSLASHcup] = ACTIONS(5447),
    [anon_sym_BSLASHunion] = ACTIONS(5447),
    [anon_sym_u222a] = ACTIONS(5447),
    [anon_sym_DOT_DOT] = ACTIONS(5445),
    [anon_sym_u2025] = ACTIONS(5447),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5447),
    [anon_sym_u2026] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5445),
    [sym_plusplus] = ACTIONS(5447),
    [anon_sym_BSLASHoplus] = ACTIONS(5447),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5447),
    [anon_sym_u2295] = ACTIONS(5447),
    [anon_sym_BSLASHominus] = ACTIONS(5447),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5447),
    [anon_sym_u2296] = ACTIONS(5447),
    [sym_mod] = ACTIONS(5445),
    [sym_modmod] = ACTIONS(5447),
    [sym_vert] = ACTIONS(5445),
    [anon_sym_PIPE_PIPE] = ACTIONS(5447),
    [anon_sym_u2016] = ACTIONS(5447),
    [sym_minusminus] = ACTIONS(5447),
    [sym_amp] = ACTIONS(5445),
    [sym_ampamp] = ACTIONS(5447),
    [anon_sym_BSLASHodot] = ACTIONS(5447),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5447),
    [anon_sym_u2299] = ACTIONS(5447),
    [anon_sym_BSLASHoslash] = ACTIONS(5447),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5447),
    [anon_sym_u2298] = ACTIONS(5447),
    [anon_sym_BSLASHotimes] = ACTIONS(5447),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5447),
    [anon_sym_u2297] = ACTIONS(5447),
    [sym_mul] = ACTIONS(5445),
    [sym_mulmul] = ACTIONS(5447),
    [sym_slash] = ACTIONS(5445),
    [sym_slashslash] = ACTIONS(5447),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5447),
    [anon_sym_u25ef] = ACTIONS(5447),
    [anon_sym_BSLASHbullet] = ACTIONS(5447),
    [anon_sym_u25cf] = ACTIONS(5447),
    [anon_sym_BSLASHdiv] = ACTIONS(5447),
    [anon_sym_u00f7] = ACTIONS(5447),
    [anon_sym_BSLASHcirc] = ACTIONS(5447),
    [anon_sym_u2218] = ACTIONS(5447),
    [anon_sym_BSLASHstar] = ACTIONS(5447),
    [anon_sym_u22c6] = ACTIONS(5447),
    [anon_sym_u203c] = ACTIONS(5447),
    [sym_hashhash] = ACTIONS(5447),
    [sym_dol] = ACTIONS(5445),
    [sym_doldol] = ACTIONS(5447),
    [anon_sym_QMARK_QMARK] = ACTIONS(5447),
    [anon_sym_u2047] = ACTIONS(5447),
    [anon_sym_BSLASHsqcap] = ACTIONS(5447),
    [anon_sym_u2293] = ACTIONS(5447),
    [anon_sym_BSLASHsqcup] = ACTIONS(5447),
    [anon_sym_u2294] = ACTIONS(5447),
    [anon_sym_BSLASHuplus] = ACTIONS(5447),
    [anon_sym_u228e] = ACTIONS(5447),
    [anon_sym_BSLASHX] = ACTIONS(5447),
    [anon_sym_BSLASHtimes] = ACTIONS(5447),
    [anon_sym_u00d7] = ACTIONS(5447),
    [anon_sym_BSLASHwr] = ACTIONS(5447),
    [anon_sym_u2240] = ACTIONS(5447),
    [anon_sym_BSLASHcdot] = ACTIONS(5447),
    [anon_sym_u22c5] = ACTIONS(5447),
    [sym_pow] = ACTIONS(5445),
    [sym_powpow] = ACTIONS(5447),
    [anon_sym_CARET_PLUS] = ACTIONS(5447),
    [anon_sym_u207a] = ACTIONS(5447),
    [sym_asterisk] = ACTIONS(5447),
    [sym_sup_hash] = ACTIONS(5447),
    [sym_prime] = ACTIONS(5447),
    [sym__indent] = ACTIONS(5447),
    [sym__double_excl] = ACTIONS(5447),
  },
  [2160] = {
    [sym_block_comment] = STATE(2160),
    [sym_identifier] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5449),
    [anon_sym_u2208] = ACTIONS(5451),
    [anon_sym_BSLASHA] = ACTIONS(5449),
    [anon_sym_BSLASHforall] = ACTIONS(5451),
    [anon_sym_u2200] = ACTIONS(5451),
    [anon_sym_BSLASHE] = ACTIONS(5449),
    [anon_sym_BSLASHexists] = ACTIONS(5451),
    [anon_sym_u2203] = ACTIONS(5451),
    [sym_temporal_forall] = ACTIONS(5451),
    [sym_temporal_exists] = ACTIONS(5451),
    [anon_sym_LT_LT] = ACTIONS(5451),
    [anon_sym_u3008] = ACTIONS(5451),
    [anon_sym_u27e8] = ACTIONS(5451),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5451),
    [anon_sym_u25a1] = ACTIONS(5451),
    [anon_sym_AT] = ACTIONS(5449),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5451),
    [anon_sym_u2227] = ACTIONS(5451),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5451),
    [anon_sym_u2228] = ACTIONS(5451),
    [anon_sym_LPAREN] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(5449),
    [aux_sym_child_id_token1] = ACTIONS(5449),
    [sym_real_number] = ACTIONS(5451),
    [anon_sym_BSLASHb] = ACTIONS(5449),
    [anon_sym_BSLASHB] = ACTIONS(5451),
    [anon_sym_BSLASHo] = ACTIONS(5449),
    [anon_sym_BSLASHO] = ACTIONS(5451),
    [anon_sym_BSLASHh] = ACTIONS(5451),
    [anon_sym_BSLASHH] = ACTIONS(5451),
    [anon_sym_DQUOTE] = ACTIONS(5451),
    [anon_sym_TRUE] = ACTIONS(5449),
    [anon_sym_FALSE] = ACTIONS(5449),
    [sym_string_set] = ACTIONS(5449),
    [sym_boolean_set] = ACTIONS(5449),
    [anon_sym_Nat] = ACTIONS(5449),
    [anon_sym_u2115] = ACTIONS(5451),
    [anon_sym_Int] = ACTIONS(5449),
    [anon_sym_u2124] = ACTIONS(5451),
    [anon_sym_Real] = ACTIONS(5449),
    [anon_sym_u211d] = ACTIONS(5451),
    [anon_sym_CHOOSE] = ACTIONS(5449),
    [anon_sym_LBRACE] = ACTIONS(5451),
    [anon_sym_EQ] = ACTIONS(5449),
    [anon_sym_WF_] = ACTIONS(5449),
    [anon_sym_SF_] = ACTIONS(5449),
    [anon_sym_IF] = ACTIONS(5449),
    [anon_sym_CASE] = ACTIONS(5449),
    [anon_sym_LET] = ACTIONS(5449),
    [anon_sym_BSLASHlnot] = ACTIONS(5451),
    [anon_sym_BSLASHneg] = ACTIONS(5451),
    [anon_sym_TILDE] = ACTIONS(5449),
    [anon_sym_u00ac] = ACTIONS(5451),
    [sym_union] = ACTIONS(5449),
    [sym_powerset] = ACTIONS(5449),
    [sym_domain] = ACTIONS(5449),
    [anon_sym_DASH] = ACTIONS(5449),
    [sym_negative_dot] = ACTIONS(5451),
    [sym_enabled] = ACTIONS(5449),
    [sym_unchanged] = ACTIONS(5449),
    [anon_sym_LT_GT] = ACTIONS(5451),
    [anon_sym_u22c4] = ACTIONS(5451),
    [anon_sym_u25c7] = ACTIONS(5451),
    [anon_sym_EQ_GT] = ACTIONS(5451),
    [anon_sym_u27f9] = ACTIONS(5451),
    [anon_sym_u21d2] = ACTIONS(5451),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5451),
    [anon_sym_u21f8] = ACTIONS(5451),
    [anon_sym_u2945] = ACTIONS(5451),
    [anon_sym_BSLASHequiv] = ACTIONS(5451),
    [anon_sym_u2261] = ACTIONS(5451),
    [anon_sym_LT_EQ_GT] = ACTIONS(5451),
    [anon_sym_u27fa] = ACTIONS(5451),
    [anon_sym_u21d4] = ACTIONS(5451),
    [anon_sym_TILDE_GT] = ACTIONS(5451),
    [anon_sym_u21dd] = ACTIONS(5451),
    [anon_sym_u219d] = ACTIONS(5451),
    [anon_sym_BSLASHland] = ACTIONS(5451),
    [anon_sym_BSLASHlor] = ACTIONS(5451),
    [anon_sym_COLON_EQ] = ACTIONS(5451),
    [anon_sym_u2254] = ACTIONS(5451),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5451),
    [anon_sym_u2a74] = ACTIONS(5451),
    [anon_sym_SLASH_EQ] = ACTIONS(5451),
    [anon_sym_POUND] = ACTIONS(5449),
    [anon_sym_u2260] = ACTIONS(5451),
    [anon_sym_LT] = ACTIONS(5449),
    [sym_gt] = ACTIONS(5449),
    [anon_sym_LT_EQ] = ACTIONS(5449),
    [anon_sym_EQ_LT] = ACTIONS(5451),
    [anon_sym_BSLASHleq] = ACTIONS(5451),
    [anon_sym_u2264] = ACTIONS(5451),
    [anon_sym_GT_EQ] = ACTIONS(5451),
    [anon_sym_BSLASHgeq] = ACTIONS(5451),
    [anon_sym_u2265] = ACTIONS(5451),
    [anon_sym_BSLASHapprox] = ACTIONS(5451),
    [anon_sym_u2248] = ACTIONS(5451),
    [anon_sym_PIPE_DASH] = ACTIONS(5451),
    [anon_sym_u22a2] = ACTIONS(5451),
    [anon_sym_PIPE_EQ] = ACTIONS(5451),
    [anon_sym_u22a8] = ACTIONS(5451),
    [anon_sym_DASH_PIPE] = ACTIONS(5451),
    [anon_sym_u22a3] = ACTIONS(5451),
    [anon_sym_EQ_PIPE] = ACTIONS(5451),
    [anon_sym_u2ae4] = ACTIONS(5451),
    [anon_sym_BSLASHasymp] = ACTIONS(5451),
    [anon_sym_u224d] = ACTIONS(5451),
    [anon_sym_BSLASHcong] = ACTIONS(5451),
    [anon_sym_u2245] = ACTIONS(5451),
    [anon_sym_BSLASHdoteq] = ACTIONS(5451),
    [anon_sym_u2250] = ACTIONS(5451),
    [anon_sym_BSLASHgg] = ACTIONS(5451),
    [anon_sym_u226b] = ACTIONS(5451),
    [anon_sym_BSLASHll] = ACTIONS(5451),
    [anon_sym_u226a] = ACTIONS(5451),
    [anon_sym_BSLASHnotin] = ACTIONS(5451),
    [anon_sym_u2209] = ACTIONS(5451),
    [anon_sym_BSLASHprec] = ACTIONS(5449),
    [anon_sym_u227a] = ACTIONS(5451),
    [anon_sym_BSLASHsucc] = ACTIONS(5449),
    [anon_sym_u227b] = ACTIONS(5451),
    [anon_sym_BSLASHpreceq] = ACTIONS(5451),
    [anon_sym_u2aaf] = ACTIONS(5451),
    [anon_sym_BSLASHsucceq] = ACTIONS(5451),
    [anon_sym_u2ab0] = ACTIONS(5451),
    [anon_sym_BSLASHpropto] = ACTIONS(5451),
    [anon_sym_u221d] = ACTIONS(5451),
    [anon_sym_BSLASHsim] = ACTIONS(5449),
    [anon_sym_u223c] = ACTIONS(5451),
    [anon_sym_BSLASHsimeq] = ACTIONS(5451),
    [anon_sym_u2243] = ACTIONS(5451),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5449),
    [anon_sym_u228f] = ACTIONS(5451),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5449),
    [anon_sym_u2290] = ACTIONS(5451),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5451),
    [anon_sym_u2291] = ACTIONS(5451),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5451),
    [anon_sym_u2292] = ACTIONS(5451),
    [anon_sym_BSLASHsubset] = ACTIONS(5449),
    [anon_sym_u2282] = ACTIONS(5451),
    [anon_sym_BSLASHsupset] = ACTIONS(5449),
    [anon_sym_u2283] = ACTIONS(5451),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5451),
    [anon_sym_u2286] = ACTIONS(5451),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5451),
    [anon_sym_u2287] = ACTIONS(5451),
    [sym_compose] = ACTIONS(5451),
    [sym_map_to] = ACTIONS(5451),
    [sym_map_from] = ACTIONS(5451),
    [sym_setminus] = ACTIONS(5449),
    [anon_sym_BSLASHcap] = ACTIONS(5451),
    [anon_sym_BSLASHintersect] = ACTIONS(5451),
    [anon_sym_u2229] = ACTIONS(5451),
    [anon_sym_BSLASHcup] = ACTIONS(5451),
    [anon_sym_BSLASHunion] = ACTIONS(5451),
    [anon_sym_u222a] = ACTIONS(5451),
    [anon_sym_DOT_DOT] = ACTIONS(5449),
    [anon_sym_u2025] = ACTIONS(5451),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5451),
    [anon_sym_u2026] = ACTIONS(5451),
    [anon_sym_PLUS] = ACTIONS(5449),
    [sym_plusplus] = ACTIONS(5451),
    [anon_sym_BSLASHoplus] = ACTIONS(5451),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5451),
    [anon_sym_u2295] = ACTIONS(5451),
    [anon_sym_BSLASHominus] = ACTIONS(5451),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5451),
    [anon_sym_u2296] = ACTIONS(5451),
    [sym_mod] = ACTIONS(5449),
    [sym_modmod] = ACTIONS(5451),
    [sym_vert] = ACTIONS(5449),
    [anon_sym_PIPE_PIPE] = ACTIONS(5451),
    [anon_sym_u2016] = ACTIONS(5451),
    [sym_minusminus] = ACTIONS(5451),
    [sym_amp] = ACTIONS(5449),
    [sym_ampamp] = ACTIONS(5451),
    [anon_sym_BSLASHodot] = ACTIONS(5451),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5451),
    [anon_sym_u2299] = ACTIONS(5451),
    [anon_sym_BSLASHoslash] = ACTIONS(5451),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5451),
    [anon_sym_u2298] = ACTIONS(5451),
    [anon_sym_BSLASHotimes] = ACTIONS(5451),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5451),
    [anon_sym_u2297] = ACTIONS(5451),
    [sym_mul] = ACTIONS(5449),
    [sym_mulmul] = ACTIONS(5451),
    [sym_slash] = ACTIONS(5449),
    [sym_slashslash] = ACTIONS(5451),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5451),
    [anon_sym_u25ef] = ACTIONS(5451),
    [anon_sym_BSLASHbullet] = ACTIONS(5451),
    [anon_sym_u25cf] = ACTIONS(5451),
    [anon_sym_BSLASHdiv] = ACTIONS(5451),
    [anon_sym_u00f7] = ACTIONS(5451),
    [anon_sym_BSLASHcirc] = ACTIONS(5451),
    [anon_sym_u2218] = ACTIONS(5451),
    [anon_sym_BSLASHstar] = ACTIONS(5451),
    [anon_sym_u22c6] = ACTIONS(5451),
    [anon_sym_u203c] = ACTIONS(5451),
    [sym_hashhash] = ACTIONS(5451),
    [sym_dol] = ACTIONS(5449),
    [sym_doldol] = ACTIONS(5451),
    [anon_sym_QMARK_QMARK] = ACTIONS(5451),
    [anon_sym_u2047] = ACTIONS(5451),
    [anon_sym_BSLASHsqcap] = ACTIONS(5451),
    [anon_sym_u2293] = ACTIONS(5451),
    [anon_sym_BSLASHsqcup] = ACTIONS(5451),
    [anon_sym_u2294] = ACTIONS(5451),
    [anon_sym_BSLASHuplus] = ACTIONS(5451),
    [anon_sym_u228e] = ACTIONS(5451),
    [anon_sym_BSLASHX] = ACTIONS(5451),
    [anon_sym_BSLASHtimes] = ACTIONS(5451),
    [anon_sym_u00d7] = ACTIONS(5451),
    [anon_sym_BSLASHwr] = ACTIONS(5451),
    [anon_sym_u2240] = ACTIONS(5451),
    [anon_sym_BSLASHcdot] = ACTIONS(5451),
    [anon_sym_u22c5] = ACTIONS(5451),
    [sym_pow] = ACTIONS(5449),
    [sym_powpow] = ACTIONS(5451),
    [anon_sym_CARET_PLUS] = ACTIONS(5451),
    [anon_sym_u207a] = ACTIONS(5451),
    [sym_asterisk] = ACTIONS(5451),
    [sym_sup_hash] = ACTIONS(5451),
    [sym_prime] = ACTIONS(5451),
    [sym__indent] = ACTIONS(5451),
    [sym__double_excl] = ACTIONS(5451),
  },
  [2161] = {
    [sym_block_comment] = STATE(2161),
    [sym_identifier] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5453),
    [anon_sym_u2208] = ACTIONS(5455),
    [anon_sym_BSLASHA] = ACTIONS(5453),
    [anon_sym_BSLASHforall] = ACTIONS(5455),
    [anon_sym_u2200] = ACTIONS(5455),
    [anon_sym_BSLASHE] = ACTIONS(5453),
    [anon_sym_BSLASHexists] = ACTIONS(5455),
    [anon_sym_u2203] = ACTIONS(5455),
    [sym_temporal_forall] = ACTIONS(5455),
    [sym_temporal_exists] = ACTIONS(5455),
    [anon_sym_LT_LT] = ACTIONS(5455),
    [anon_sym_u3008] = ACTIONS(5455),
    [anon_sym_u27e8] = ACTIONS(5455),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5455),
    [anon_sym_u25a1] = ACTIONS(5455),
    [anon_sym_AT] = ACTIONS(5453),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5455),
    [anon_sym_u2227] = ACTIONS(5455),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5455),
    [anon_sym_u2228] = ACTIONS(5455),
    [anon_sym_LPAREN] = ACTIONS(5453),
    [anon_sym_LBRACK] = ACTIONS(5453),
    [aux_sym_child_id_token1] = ACTIONS(5453),
    [sym_real_number] = ACTIONS(5455),
    [anon_sym_BSLASHb] = ACTIONS(5453),
    [anon_sym_BSLASHB] = ACTIONS(5455),
    [anon_sym_BSLASHo] = ACTIONS(5453),
    [anon_sym_BSLASHO] = ACTIONS(5455),
    [anon_sym_BSLASHh] = ACTIONS(5455),
    [anon_sym_BSLASHH] = ACTIONS(5455),
    [anon_sym_DQUOTE] = ACTIONS(5455),
    [anon_sym_TRUE] = ACTIONS(5453),
    [anon_sym_FALSE] = ACTIONS(5453),
    [sym_string_set] = ACTIONS(5453),
    [sym_boolean_set] = ACTIONS(5453),
    [anon_sym_Nat] = ACTIONS(5453),
    [anon_sym_u2115] = ACTIONS(5455),
    [anon_sym_Int] = ACTIONS(5453),
    [anon_sym_u2124] = ACTIONS(5455),
    [anon_sym_Real] = ACTIONS(5453),
    [anon_sym_u211d] = ACTIONS(5455),
    [anon_sym_CHOOSE] = ACTIONS(5453),
    [anon_sym_LBRACE] = ACTIONS(5455),
    [anon_sym_EQ] = ACTIONS(5453),
    [anon_sym_WF_] = ACTIONS(5453),
    [anon_sym_SF_] = ACTIONS(5453),
    [anon_sym_IF] = ACTIONS(5453),
    [anon_sym_CASE] = ACTIONS(5453),
    [anon_sym_LET] = ACTIONS(5453),
    [anon_sym_BSLASHlnot] = ACTIONS(5455),
    [anon_sym_BSLASHneg] = ACTIONS(5455),
    [anon_sym_TILDE] = ACTIONS(5453),
    [anon_sym_u00ac] = ACTIONS(5455),
    [sym_union] = ACTIONS(5453),
    [sym_powerset] = ACTIONS(5453),
    [sym_domain] = ACTIONS(5453),
    [anon_sym_DASH] = ACTIONS(5453),
    [sym_negative_dot] = ACTIONS(5455),
    [sym_enabled] = ACTIONS(5453),
    [sym_unchanged] = ACTIONS(5453),
    [anon_sym_LT_GT] = ACTIONS(5455),
    [anon_sym_u22c4] = ACTIONS(5455),
    [anon_sym_u25c7] = ACTIONS(5455),
    [anon_sym_EQ_GT] = ACTIONS(5455),
    [anon_sym_u27f9] = ACTIONS(5455),
    [anon_sym_u21d2] = ACTIONS(5455),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5455),
    [anon_sym_u21f8] = ACTIONS(5455),
    [anon_sym_u2945] = ACTIONS(5455),
    [anon_sym_BSLASHequiv] = ACTIONS(5455),
    [anon_sym_u2261] = ACTIONS(5455),
    [anon_sym_LT_EQ_GT] = ACTIONS(5455),
    [anon_sym_u27fa] = ACTIONS(5455),
    [anon_sym_u21d4] = ACTIONS(5455),
    [anon_sym_TILDE_GT] = ACTIONS(5455),
    [anon_sym_u21dd] = ACTIONS(5455),
    [anon_sym_u219d] = ACTIONS(5455),
    [anon_sym_BSLASHland] = ACTIONS(5455),
    [anon_sym_BSLASHlor] = ACTIONS(5455),
    [anon_sym_COLON_EQ] = ACTIONS(5455),
    [anon_sym_u2254] = ACTIONS(5455),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5455),
    [anon_sym_u2a74] = ACTIONS(5455),
    [anon_sym_SLASH_EQ] = ACTIONS(5455),
    [anon_sym_POUND] = ACTIONS(5453),
    [anon_sym_u2260] = ACTIONS(5455),
    [anon_sym_LT] = ACTIONS(5453),
    [sym_gt] = ACTIONS(5453),
    [anon_sym_LT_EQ] = ACTIONS(5453),
    [anon_sym_EQ_LT] = ACTIONS(5455),
    [anon_sym_BSLASHleq] = ACTIONS(5455),
    [anon_sym_u2264] = ACTIONS(5455),
    [anon_sym_GT_EQ] = ACTIONS(5455),
    [anon_sym_BSLASHgeq] = ACTIONS(5455),
    [anon_sym_u2265] = ACTIONS(5455),
    [anon_sym_BSLASHapprox] = ACTIONS(5455),
    [anon_sym_u2248] = ACTIONS(5455),
    [anon_sym_PIPE_DASH] = ACTIONS(5455),
    [anon_sym_u22a2] = ACTIONS(5455),
    [anon_sym_PIPE_EQ] = ACTIONS(5455),
    [anon_sym_u22a8] = ACTIONS(5455),
    [anon_sym_DASH_PIPE] = ACTIONS(5455),
    [anon_sym_u22a3] = ACTIONS(5455),
    [anon_sym_EQ_PIPE] = ACTIONS(5455),
    [anon_sym_u2ae4] = ACTIONS(5455),
    [anon_sym_BSLASHasymp] = ACTIONS(5455),
    [anon_sym_u224d] = ACTIONS(5455),
    [anon_sym_BSLASHcong] = ACTIONS(5455),
    [anon_sym_u2245] = ACTIONS(5455),
    [anon_sym_BSLASHdoteq] = ACTIONS(5455),
    [anon_sym_u2250] = ACTIONS(5455),
    [anon_sym_BSLASHgg] = ACTIONS(5455),
    [anon_sym_u226b] = ACTIONS(5455),
    [anon_sym_BSLASHll] = ACTIONS(5455),
    [anon_sym_u226a] = ACTIONS(5455),
    [anon_sym_BSLASHnotin] = ACTIONS(5455),
    [anon_sym_u2209] = ACTIONS(5455),
    [anon_sym_BSLASHprec] = ACTIONS(5453),
    [anon_sym_u227a] = ACTIONS(5455),
    [anon_sym_BSLASHsucc] = ACTIONS(5453),
    [anon_sym_u227b] = ACTIONS(5455),
    [anon_sym_BSLASHpreceq] = ACTIONS(5455),
    [anon_sym_u2aaf] = ACTIONS(5455),
    [anon_sym_BSLASHsucceq] = ACTIONS(5455),
    [anon_sym_u2ab0] = ACTIONS(5455),
    [anon_sym_BSLASHpropto] = ACTIONS(5455),
    [anon_sym_u221d] = ACTIONS(5455),
    [anon_sym_BSLASHsim] = ACTIONS(5453),
    [anon_sym_u223c] = ACTIONS(5455),
    [anon_sym_BSLASHsimeq] = ACTIONS(5455),
    [anon_sym_u2243] = ACTIONS(5455),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5453),
    [anon_sym_u228f] = ACTIONS(5455),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5453),
    [anon_sym_u2290] = ACTIONS(5455),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5455),
    [anon_sym_u2291] = ACTIONS(5455),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5455),
    [anon_sym_u2292] = ACTIONS(5455),
    [anon_sym_BSLASHsubset] = ACTIONS(5453),
    [anon_sym_u2282] = ACTIONS(5455),
    [anon_sym_BSLASHsupset] = ACTIONS(5453),
    [anon_sym_u2283] = ACTIONS(5455),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5455),
    [anon_sym_u2286] = ACTIONS(5455),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5455),
    [anon_sym_u2287] = ACTIONS(5455),
    [sym_compose] = ACTIONS(5455),
    [sym_map_to] = ACTIONS(5455),
    [sym_map_from] = ACTIONS(5455),
    [sym_setminus] = ACTIONS(5453),
    [anon_sym_BSLASHcap] = ACTIONS(5455),
    [anon_sym_BSLASHintersect] = ACTIONS(5455),
    [anon_sym_u2229] = ACTIONS(5455),
    [anon_sym_BSLASHcup] = ACTIONS(5455),
    [anon_sym_BSLASHunion] = ACTIONS(5455),
    [anon_sym_u222a] = ACTIONS(5455),
    [anon_sym_DOT_DOT] = ACTIONS(5453),
    [anon_sym_u2025] = ACTIONS(5455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5455),
    [anon_sym_u2026] = ACTIONS(5455),
    [anon_sym_PLUS] = ACTIONS(5453),
    [sym_plusplus] = ACTIONS(5455),
    [anon_sym_BSLASHoplus] = ACTIONS(5455),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5455),
    [anon_sym_u2295] = ACTIONS(5455),
    [anon_sym_BSLASHominus] = ACTIONS(5455),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5455),
    [anon_sym_u2296] = ACTIONS(5455),
    [sym_mod] = ACTIONS(5453),
    [sym_modmod] = ACTIONS(5455),
    [sym_vert] = ACTIONS(5453),
    [anon_sym_PIPE_PIPE] = ACTIONS(5455),
    [anon_sym_u2016] = ACTIONS(5455),
    [sym_minusminus] = ACTIONS(5455),
    [sym_amp] = ACTIONS(5453),
    [sym_ampamp] = ACTIONS(5455),
    [anon_sym_BSLASHodot] = ACTIONS(5455),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5455),
    [anon_sym_u2299] = ACTIONS(5455),
    [anon_sym_BSLASHoslash] = ACTIONS(5455),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5455),
    [anon_sym_u2298] = ACTIONS(5455),
    [anon_sym_BSLASHotimes] = ACTIONS(5455),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5455),
    [anon_sym_u2297] = ACTIONS(5455),
    [sym_mul] = ACTIONS(5453),
    [sym_mulmul] = ACTIONS(5455),
    [sym_slash] = ACTIONS(5453),
    [sym_slashslash] = ACTIONS(5455),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5455),
    [anon_sym_u25ef] = ACTIONS(5455),
    [anon_sym_BSLASHbullet] = ACTIONS(5455),
    [anon_sym_u25cf] = ACTIONS(5455),
    [anon_sym_BSLASHdiv] = ACTIONS(5455),
    [anon_sym_u00f7] = ACTIONS(5455),
    [anon_sym_BSLASHcirc] = ACTIONS(5455),
    [anon_sym_u2218] = ACTIONS(5455),
    [anon_sym_BSLASHstar] = ACTIONS(5455),
    [anon_sym_u22c6] = ACTIONS(5455),
    [anon_sym_u203c] = ACTIONS(5455),
    [sym_hashhash] = ACTIONS(5455),
    [sym_dol] = ACTIONS(5453),
    [sym_doldol] = ACTIONS(5455),
    [anon_sym_QMARK_QMARK] = ACTIONS(5455),
    [anon_sym_u2047] = ACTIONS(5455),
    [anon_sym_BSLASHsqcap] = ACTIONS(5455),
    [anon_sym_u2293] = ACTIONS(5455),
    [anon_sym_BSLASHsqcup] = ACTIONS(5455),
    [anon_sym_u2294] = ACTIONS(5455),
    [anon_sym_BSLASHuplus] = ACTIONS(5455),
    [anon_sym_u228e] = ACTIONS(5455),
    [anon_sym_BSLASHX] = ACTIONS(5455),
    [anon_sym_BSLASHtimes] = ACTIONS(5455),
    [anon_sym_u00d7] = ACTIONS(5455),
    [anon_sym_BSLASHwr] = ACTIONS(5455),
    [anon_sym_u2240] = ACTIONS(5455),
    [anon_sym_BSLASHcdot] = ACTIONS(5455),
    [anon_sym_u22c5] = ACTIONS(5455),
    [sym_pow] = ACTIONS(5453),
    [sym_powpow] = ACTIONS(5455),
    [anon_sym_CARET_PLUS] = ACTIONS(5455),
    [anon_sym_u207a] = ACTIONS(5455),
    [sym_asterisk] = ACTIONS(5455),
    [sym_sup_hash] = ACTIONS(5455),
    [sym_prime] = ACTIONS(5455),
    [sym__indent] = ACTIONS(5455),
    [sym__double_excl] = ACTIONS(5455),
  },
  [2162] = {
    [sym_block_comment] = STATE(2162),
    [sym_identifier] = ACTIONS(5457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5457),
    [anon_sym_u2208] = ACTIONS(5459),
    [anon_sym_BSLASHA] = ACTIONS(5457),
    [anon_sym_BSLASHforall] = ACTIONS(5459),
    [anon_sym_u2200] = ACTIONS(5459),
    [anon_sym_BSLASHE] = ACTIONS(5457),
    [anon_sym_BSLASHexists] = ACTIONS(5459),
    [anon_sym_u2203] = ACTIONS(5459),
    [sym_temporal_forall] = ACTIONS(5459),
    [sym_temporal_exists] = ACTIONS(5459),
    [anon_sym_LT_LT] = ACTIONS(5459),
    [anon_sym_u3008] = ACTIONS(5459),
    [anon_sym_u27e8] = ACTIONS(5459),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5459),
    [anon_sym_u25a1] = ACTIONS(5459),
    [anon_sym_AT] = ACTIONS(5457),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5459),
    [anon_sym_u2227] = ACTIONS(5459),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5459),
    [anon_sym_u2228] = ACTIONS(5459),
    [anon_sym_LPAREN] = ACTIONS(5457),
    [anon_sym_LBRACK] = ACTIONS(5457),
    [aux_sym_child_id_token1] = ACTIONS(5457),
    [sym_real_number] = ACTIONS(5459),
    [anon_sym_BSLASHb] = ACTIONS(5457),
    [anon_sym_BSLASHB] = ACTIONS(5459),
    [anon_sym_BSLASHo] = ACTIONS(5457),
    [anon_sym_BSLASHO] = ACTIONS(5459),
    [anon_sym_BSLASHh] = ACTIONS(5459),
    [anon_sym_BSLASHH] = ACTIONS(5459),
    [anon_sym_DQUOTE] = ACTIONS(5459),
    [anon_sym_TRUE] = ACTIONS(5457),
    [anon_sym_FALSE] = ACTIONS(5457),
    [sym_string_set] = ACTIONS(5457),
    [sym_boolean_set] = ACTIONS(5457),
    [anon_sym_Nat] = ACTIONS(5457),
    [anon_sym_u2115] = ACTIONS(5459),
    [anon_sym_Int] = ACTIONS(5457),
    [anon_sym_u2124] = ACTIONS(5459),
    [anon_sym_Real] = ACTIONS(5457),
    [anon_sym_u211d] = ACTIONS(5459),
    [anon_sym_CHOOSE] = ACTIONS(5457),
    [anon_sym_LBRACE] = ACTIONS(5459),
    [anon_sym_EQ] = ACTIONS(5457),
    [anon_sym_WF_] = ACTIONS(5457),
    [anon_sym_SF_] = ACTIONS(5457),
    [anon_sym_IF] = ACTIONS(5457),
    [anon_sym_CASE] = ACTIONS(5457),
    [anon_sym_LET] = ACTIONS(5457),
    [anon_sym_BSLASHlnot] = ACTIONS(5459),
    [anon_sym_BSLASHneg] = ACTIONS(5459),
    [anon_sym_TILDE] = ACTIONS(5457),
    [anon_sym_u00ac] = ACTIONS(5459),
    [sym_union] = ACTIONS(5457),
    [sym_powerset] = ACTIONS(5457),
    [sym_domain] = ACTIONS(5457),
    [anon_sym_DASH] = ACTIONS(5457),
    [sym_negative_dot] = ACTIONS(5459),
    [sym_enabled] = ACTIONS(5457),
    [sym_unchanged] = ACTIONS(5457),
    [anon_sym_LT_GT] = ACTIONS(5459),
    [anon_sym_u22c4] = ACTIONS(5459),
    [anon_sym_u25c7] = ACTIONS(5459),
    [anon_sym_EQ_GT] = ACTIONS(5459),
    [anon_sym_u27f9] = ACTIONS(5459),
    [anon_sym_u21d2] = ACTIONS(5459),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5459),
    [anon_sym_u21f8] = ACTIONS(5459),
    [anon_sym_u2945] = ACTIONS(5459),
    [anon_sym_BSLASHequiv] = ACTIONS(5459),
    [anon_sym_u2261] = ACTIONS(5459),
    [anon_sym_LT_EQ_GT] = ACTIONS(5459),
    [anon_sym_u27fa] = ACTIONS(5459),
    [anon_sym_u21d4] = ACTIONS(5459),
    [anon_sym_TILDE_GT] = ACTIONS(5459),
    [anon_sym_u21dd] = ACTIONS(5459),
    [anon_sym_u219d] = ACTIONS(5459),
    [anon_sym_BSLASHland] = ACTIONS(5459),
    [anon_sym_BSLASHlor] = ACTIONS(5459),
    [anon_sym_COLON_EQ] = ACTIONS(5459),
    [anon_sym_u2254] = ACTIONS(5459),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5459),
    [anon_sym_u2a74] = ACTIONS(5459),
    [anon_sym_SLASH_EQ] = ACTIONS(5459),
    [anon_sym_POUND] = ACTIONS(5457),
    [anon_sym_u2260] = ACTIONS(5459),
    [anon_sym_LT] = ACTIONS(5457),
    [sym_gt] = ACTIONS(5457),
    [anon_sym_LT_EQ] = ACTIONS(5457),
    [anon_sym_EQ_LT] = ACTIONS(5459),
    [anon_sym_BSLASHleq] = ACTIONS(5459),
    [anon_sym_u2264] = ACTIONS(5459),
    [anon_sym_GT_EQ] = ACTIONS(5459),
    [anon_sym_BSLASHgeq] = ACTIONS(5459),
    [anon_sym_u2265] = ACTIONS(5459),
    [anon_sym_BSLASHapprox] = ACTIONS(5459),
    [anon_sym_u2248] = ACTIONS(5459),
    [anon_sym_PIPE_DASH] = ACTIONS(5459),
    [anon_sym_u22a2] = ACTIONS(5459),
    [anon_sym_PIPE_EQ] = ACTIONS(5459),
    [anon_sym_u22a8] = ACTIONS(5459),
    [anon_sym_DASH_PIPE] = ACTIONS(5459),
    [anon_sym_u22a3] = ACTIONS(5459),
    [anon_sym_EQ_PIPE] = ACTIONS(5459),
    [anon_sym_u2ae4] = ACTIONS(5459),
    [anon_sym_BSLASHasymp] = ACTIONS(5459),
    [anon_sym_u224d] = ACTIONS(5459),
    [anon_sym_BSLASHcong] = ACTIONS(5459),
    [anon_sym_u2245] = ACTIONS(5459),
    [anon_sym_BSLASHdoteq] = ACTIONS(5459),
    [anon_sym_u2250] = ACTIONS(5459),
    [anon_sym_BSLASHgg] = ACTIONS(5459),
    [anon_sym_u226b] = ACTIONS(5459),
    [anon_sym_BSLASHll] = ACTIONS(5459),
    [anon_sym_u226a] = ACTIONS(5459),
    [anon_sym_BSLASHnotin] = ACTIONS(5459),
    [anon_sym_u2209] = ACTIONS(5459),
    [anon_sym_BSLASHprec] = ACTIONS(5457),
    [anon_sym_u227a] = ACTIONS(5459),
    [anon_sym_BSLASHsucc] = ACTIONS(5457),
    [anon_sym_u227b] = ACTIONS(5459),
    [anon_sym_BSLASHpreceq] = ACTIONS(5459),
    [anon_sym_u2aaf] = ACTIONS(5459),
    [anon_sym_BSLASHsucceq] = ACTIONS(5459),
    [anon_sym_u2ab0] = ACTIONS(5459),
    [anon_sym_BSLASHpropto] = ACTIONS(5459),
    [anon_sym_u221d] = ACTIONS(5459),
    [anon_sym_BSLASHsim] = ACTIONS(5457),
    [anon_sym_u223c] = ACTIONS(5459),
    [anon_sym_BSLASHsimeq] = ACTIONS(5459),
    [anon_sym_u2243] = ACTIONS(5459),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5457),
    [anon_sym_u228f] = ACTIONS(5459),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5457),
    [anon_sym_u2290] = ACTIONS(5459),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5459),
    [anon_sym_u2291] = ACTIONS(5459),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5459),
    [anon_sym_u2292] = ACTIONS(5459),
    [anon_sym_BSLASHsubset] = ACTIONS(5457),
    [anon_sym_u2282] = ACTIONS(5459),
    [anon_sym_BSLASHsupset] = ACTIONS(5457),
    [anon_sym_u2283] = ACTIONS(5459),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5459),
    [anon_sym_u2286] = ACTIONS(5459),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5459),
    [anon_sym_u2287] = ACTIONS(5459),
    [sym_compose] = ACTIONS(5459),
    [sym_map_to] = ACTIONS(5459),
    [sym_map_from] = ACTIONS(5459),
    [sym_setminus] = ACTIONS(5457),
    [anon_sym_BSLASHcap] = ACTIONS(5459),
    [anon_sym_BSLASHintersect] = ACTIONS(5459),
    [anon_sym_u2229] = ACTIONS(5459),
    [anon_sym_BSLASHcup] = ACTIONS(5459),
    [anon_sym_BSLASHunion] = ACTIONS(5459),
    [anon_sym_u222a] = ACTIONS(5459),
    [anon_sym_DOT_DOT] = ACTIONS(5457),
    [anon_sym_u2025] = ACTIONS(5459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5459),
    [anon_sym_u2026] = ACTIONS(5459),
    [anon_sym_PLUS] = ACTIONS(5457),
    [sym_plusplus] = ACTIONS(5459),
    [anon_sym_BSLASHoplus] = ACTIONS(5459),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5459),
    [anon_sym_u2295] = ACTIONS(5459),
    [anon_sym_BSLASHominus] = ACTIONS(5459),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5459),
    [anon_sym_u2296] = ACTIONS(5459),
    [sym_mod] = ACTIONS(5457),
    [sym_modmod] = ACTIONS(5459),
    [sym_vert] = ACTIONS(5457),
    [anon_sym_PIPE_PIPE] = ACTIONS(5459),
    [anon_sym_u2016] = ACTIONS(5459),
    [sym_minusminus] = ACTIONS(5459),
    [sym_amp] = ACTIONS(5457),
    [sym_ampamp] = ACTIONS(5459),
    [anon_sym_BSLASHodot] = ACTIONS(5459),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5459),
    [anon_sym_u2299] = ACTIONS(5459),
    [anon_sym_BSLASHoslash] = ACTIONS(5459),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5459),
    [anon_sym_u2298] = ACTIONS(5459),
    [anon_sym_BSLASHotimes] = ACTIONS(5459),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5459),
    [anon_sym_u2297] = ACTIONS(5459),
    [sym_mul] = ACTIONS(5457),
    [sym_mulmul] = ACTIONS(5459),
    [sym_slash] = ACTIONS(5457),
    [sym_slashslash] = ACTIONS(5459),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5459),
    [anon_sym_u25ef] = ACTIONS(5459),
    [anon_sym_BSLASHbullet] = ACTIONS(5459),
    [anon_sym_u25cf] = ACTIONS(5459),
    [anon_sym_BSLASHdiv] = ACTIONS(5459),
    [anon_sym_u00f7] = ACTIONS(5459),
    [anon_sym_BSLASHcirc] = ACTIONS(5459),
    [anon_sym_u2218] = ACTIONS(5459),
    [anon_sym_BSLASHstar] = ACTIONS(5459),
    [anon_sym_u22c6] = ACTIONS(5459),
    [anon_sym_u203c] = ACTIONS(5459),
    [sym_hashhash] = ACTIONS(5459),
    [sym_dol] = ACTIONS(5457),
    [sym_doldol] = ACTIONS(5459),
    [anon_sym_QMARK_QMARK] = ACTIONS(5459),
    [anon_sym_u2047] = ACTIONS(5459),
    [anon_sym_BSLASHsqcap] = ACTIONS(5459),
    [anon_sym_u2293] = ACTIONS(5459),
    [anon_sym_BSLASHsqcup] = ACTIONS(5459),
    [anon_sym_u2294] = ACTIONS(5459),
    [anon_sym_BSLASHuplus] = ACTIONS(5459),
    [anon_sym_u228e] = ACTIONS(5459),
    [anon_sym_BSLASHX] = ACTIONS(5459),
    [anon_sym_BSLASHtimes] = ACTIONS(5459),
    [anon_sym_u00d7] = ACTIONS(5459),
    [anon_sym_BSLASHwr] = ACTIONS(5459),
    [anon_sym_u2240] = ACTIONS(5459),
    [anon_sym_BSLASHcdot] = ACTIONS(5459),
    [anon_sym_u22c5] = ACTIONS(5459),
    [sym_pow] = ACTIONS(5457),
    [sym_powpow] = ACTIONS(5459),
    [anon_sym_CARET_PLUS] = ACTIONS(5459),
    [anon_sym_u207a] = ACTIONS(5459),
    [sym_asterisk] = ACTIONS(5459),
    [sym_sup_hash] = ACTIONS(5459),
    [sym_prime] = ACTIONS(5459),
    [sym__indent] = ACTIONS(5459),
    [sym__double_excl] = ACTIONS(5459),
  },
  [2163] = {
    [sym_block_comment] = STATE(2163),
    [sym_identifier] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5461),
    [anon_sym_u2208] = ACTIONS(5463),
    [anon_sym_BSLASHA] = ACTIONS(5461),
    [anon_sym_BSLASHforall] = ACTIONS(5463),
    [anon_sym_u2200] = ACTIONS(5463),
    [anon_sym_BSLASHE] = ACTIONS(5461),
    [anon_sym_BSLASHexists] = ACTIONS(5463),
    [anon_sym_u2203] = ACTIONS(5463),
    [sym_temporal_forall] = ACTIONS(5463),
    [sym_temporal_exists] = ACTIONS(5463),
    [anon_sym_LT_LT] = ACTIONS(5463),
    [anon_sym_u3008] = ACTIONS(5463),
    [anon_sym_u27e8] = ACTIONS(5463),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5463),
    [anon_sym_u25a1] = ACTIONS(5463),
    [anon_sym_AT] = ACTIONS(5461),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5463),
    [anon_sym_u2227] = ACTIONS(5463),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5463),
    [anon_sym_u2228] = ACTIONS(5463),
    [anon_sym_LPAREN] = ACTIONS(5461),
    [anon_sym_LBRACK] = ACTIONS(5461),
    [aux_sym_child_id_token1] = ACTIONS(5461),
    [sym_real_number] = ACTIONS(5463),
    [anon_sym_BSLASHb] = ACTIONS(5461),
    [anon_sym_BSLASHB] = ACTIONS(5463),
    [anon_sym_BSLASHo] = ACTIONS(5461),
    [anon_sym_BSLASHO] = ACTIONS(5463),
    [anon_sym_BSLASHh] = ACTIONS(5463),
    [anon_sym_BSLASHH] = ACTIONS(5463),
    [anon_sym_DQUOTE] = ACTIONS(5463),
    [anon_sym_TRUE] = ACTIONS(5461),
    [anon_sym_FALSE] = ACTIONS(5461),
    [sym_string_set] = ACTIONS(5461),
    [sym_boolean_set] = ACTIONS(5461),
    [anon_sym_Nat] = ACTIONS(5461),
    [anon_sym_u2115] = ACTIONS(5463),
    [anon_sym_Int] = ACTIONS(5461),
    [anon_sym_u2124] = ACTIONS(5463),
    [anon_sym_Real] = ACTIONS(5461),
    [anon_sym_u211d] = ACTIONS(5463),
    [anon_sym_CHOOSE] = ACTIONS(5461),
    [anon_sym_LBRACE] = ACTIONS(5463),
    [anon_sym_EQ] = ACTIONS(5461),
    [anon_sym_WF_] = ACTIONS(5461),
    [anon_sym_SF_] = ACTIONS(5461),
    [anon_sym_IF] = ACTIONS(5461),
    [anon_sym_CASE] = ACTIONS(5461),
    [anon_sym_LET] = ACTIONS(5461),
    [anon_sym_BSLASHlnot] = ACTIONS(5463),
    [anon_sym_BSLASHneg] = ACTIONS(5463),
    [anon_sym_TILDE] = ACTIONS(5461),
    [anon_sym_u00ac] = ACTIONS(5463),
    [sym_union] = ACTIONS(5461),
    [sym_powerset] = ACTIONS(5461),
    [sym_domain] = ACTIONS(5461),
    [anon_sym_DASH] = ACTIONS(5461),
    [sym_negative_dot] = ACTIONS(5463),
    [sym_enabled] = ACTIONS(5461),
    [sym_unchanged] = ACTIONS(5461),
    [anon_sym_LT_GT] = ACTIONS(5463),
    [anon_sym_u22c4] = ACTIONS(5463),
    [anon_sym_u25c7] = ACTIONS(5463),
    [anon_sym_EQ_GT] = ACTIONS(5463),
    [anon_sym_u27f9] = ACTIONS(5463),
    [anon_sym_u21d2] = ACTIONS(5463),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5463),
    [anon_sym_u21f8] = ACTIONS(5463),
    [anon_sym_u2945] = ACTIONS(5463),
    [anon_sym_BSLASHequiv] = ACTIONS(5463),
    [anon_sym_u2261] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5463),
    [anon_sym_u27fa] = ACTIONS(5463),
    [anon_sym_u21d4] = ACTIONS(5463),
    [anon_sym_TILDE_GT] = ACTIONS(5463),
    [anon_sym_u21dd] = ACTIONS(5463),
    [anon_sym_u219d] = ACTIONS(5463),
    [anon_sym_BSLASHland] = ACTIONS(5463),
    [anon_sym_BSLASHlor] = ACTIONS(5463),
    [anon_sym_COLON_EQ] = ACTIONS(5463),
    [anon_sym_u2254] = ACTIONS(5463),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5463),
    [anon_sym_u2a74] = ACTIONS(5463),
    [anon_sym_SLASH_EQ] = ACTIONS(5463),
    [anon_sym_POUND] = ACTIONS(5461),
    [anon_sym_u2260] = ACTIONS(5463),
    [anon_sym_LT] = ACTIONS(5461),
    [sym_gt] = ACTIONS(5461),
    [anon_sym_LT_EQ] = ACTIONS(5461),
    [anon_sym_EQ_LT] = ACTIONS(5463),
    [anon_sym_BSLASHleq] = ACTIONS(5463),
    [anon_sym_u2264] = ACTIONS(5463),
    [anon_sym_GT_EQ] = ACTIONS(5463),
    [anon_sym_BSLASHgeq] = ACTIONS(5463),
    [anon_sym_u2265] = ACTIONS(5463),
    [anon_sym_BSLASHapprox] = ACTIONS(5463),
    [anon_sym_u2248] = ACTIONS(5463),
    [anon_sym_PIPE_DASH] = ACTIONS(5463),
    [anon_sym_u22a2] = ACTIONS(5463),
    [anon_sym_PIPE_EQ] = ACTIONS(5463),
    [anon_sym_u22a8] = ACTIONS(5463),
    [anon_sym_DASH_PIPE] = ACTIONS(5463),
    [anon_sym_u22a3] = ACTIONS(5463),
    [anon_sym_EQ_PIPE] = ACTIONS(5463),
    [anon_sym_u2ae4] = ACTIONS(5463),
    [anon_sym_BSLASHasymp] = ACTIONS(5463),
    [anon_sym_u224d] = ACTIONS(5463),
    [anon_sym_BSLASHcong] = ACTIONS(5463),
    [anon_sym_u2245] = ACTIONS(5463),
    [anon_sym_BSLASHdoteq] = ACTIONS(5463),
    [anon_sym_u2250] = ACTIONS(5463),
    [anon_sym_BSLASHgg] = ACTIONS(5463),
    [anon_sym_u226b] = ACTIONS(5463),
    [anon_sym_BSLASHll] = ACTIONS(5463),
    [anon_sym_u226a] = ACTIONS(5463),
    [anon_sym_BSLASHnotin] = ACTIONS(5463),
    [anon_sym_u2209] = ACTIONS(5463),
    [anon_sym_BSLASHprec] = ACTIONS(5461),
    [anon_sym_u227a] = ACTIONS(5463),
    [anon_sym_BSLASHsucc] = ACTIONS(5461),
    [anon_sym_u227b] = ACTIONS(5463),
    [anon_sym_BSLASHpreceq] = ACTIONS(5463),
    [anon_sym_u2aaf] = ACTIONS(5463),
    [anon_sym_BSLASHsucceq] = ACTIONS(5463),
    [anon_sym_u2ab0] = ACTIONS(5463),
    [anon_sym_BSLASHpropto] = ACTIONS(5463),
    [anon_sym_u221d] = ACTIONS(5463),
    [anon_sym_BSLASHsim] = ACTIONS(5461),
    [anon_sym_u223c] = ACTIONS(5463),
    [anon_sym_BSLASHsimeq] = ACTIONS(5463),
    [anon_sym_u2243] = ACTIONS(5463),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5461),
    [anon_sym_u228f] = ACTIONS(5463),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5461),
    [anon_sym_u2290] = ACTIONS(5463),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5463),
    [anon_sym_u2291] = ACTIONS(5463),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5463),
    [anon_sym_u2292] = ACTIONS(5463),
    [anon_sym_BSLASHsubset] = ACTIONS(5461),
    [anon_sym_u2282] = ACTIONS(5463),
    [anon_sym_BSLASHsupset] = ACTIONS(5461),
    [anon_sym_u2283] = ACTIONS(5463),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5463),
    [anon_sym_u2286] = ACTIONS(5463),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5463),
    [anon_sym_u2287] = ACTIONS(5463),
    [sym_compose] = ACTIONS(5463),
    [sym_map_to] = ACTIONS(5463),
    [sym_map_from] = ACTIONS(5463),
    [sym_setminus] = ACTIONS(5461),
    [anon_sym_BSLASHcap] = ACTIONS(5463),
    [anon_sym_BSLASHintersect] = ACTIONS(5463),
    [anon_sym_u2229] = ACTIONS(5463),
    [anon_sym_BSLASHcup] = ACTIONS(5463),
    [anon_sym_BSLASHunion] = ACTIONS(5463),
    [anon_sym_u222a] = ACTIONS(5463),
    [anon_sym_DOT_DOT] = ACTIONS(5461),
    [anon_sym_u2025] = ACTIONS(5463),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5463),
    [anon_sym_u2026] = ACTIONS(5463),
    [anon_sym_PLUS] = ACTIONS(5461),
    [sym_plusplus] = ACTIONS(5463),
    [anon_sym_BSLASHoplus] = ACTIONS(5463),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5463),
    [anon_sym_u2295] = ACTIONS(5463),
    [anon_sym_BSLASHominus] = ACTIONS(5463),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5463),
    [anon_sym_u2296] = ACTIONS(5463),
    [sym_mod] = ACTIONS(5461),
    [sym_modmod] = ACTIONS(5463),
    [sym_vert] = ACTIONS(5461),
    [anon_sym_PIPE_PIPE] = ACTIONS(5463),
    [anon_sym_u2016] = ACTIONS(5463),
    [sym_minusminus] = ACTIONS(5463),
    [sym_amp] = ACTIONS(5461),
    [sym_ampamp] = ACTIONS(5463),
    [anon_sym_BSLASHodot] = ACTIONS(5463),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5463),
    [anon_sym_u2299] = ACTIONS(5463),
    [anon_sym_BSLASHoslash] = ACTIONS(5463),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5463),
    [anon_sym_u2298] = ACTIONS(5463),
    [anon_sym_BSLASHotimes] = ACTIONS(5463),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5463),
    [anon_sym_u2297] = ACTIONS(5463),
    [sym_mul] = ACTIONS(5461),
    [sym_mulmul] = ACTIONS(5463),
    [sym_slash] = ACTIONS(5461),
    [sym_slashslash] = ACTIONS(5463),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5463),
    [anon_sym_u25ef] = ACTIONS(5463),
    [anon_sym_BSLASHbullet] = ACTIONS(5463),
    [anon_sym_u25cf] = ACTIONS(5463),
    [anon_sym_BSLASHdiv] = ACTIONS(5463),
    [anon_sym_u00f7] = ACTIONS(5463),
    [anon_sym_BSLASHcirc] = ACTIONS(5463),
    [anon_sym_u2218] = ACTIONS(5463),
    [anon_sym_BSLASHstar] = ACTIONS(5463),
    [anon_sym_u22c6] = ACTIONS(5463),
    [anon_sym_u203c] = ACTIONS(5463),
    [sym_hashhash] = ACTIONS(5463),
    [sym_dol] = ACTIONS(5461),
    [sym_doldol] = ACTIONS(5463),
    [anon_sym_QMARK_QMARK] = ACTIONS(5463),
    [anon_sym_u2047] = ACTIONS(5463),
    [anon_sym_BSLASHsqcap] = ACTIONS(5463),
    [anon_sym_u2293] = ACTIONS(5463),
    [anon_sym_BSLASHsqcup] = ACTIONS(5463),
    [anon_sym_u2294] = ACTIONS(5463),
    [anon_sym_BSLASHuplus] = ACTIONS(5463),
    [anon_sym_u228e] = ACTIONS(5463),
    [anon_sym_BSLASHX] = ACTIONS(5463),
    [anon_sym_BSLASHtimes] = ACTIONS(5463),
    [anon_sym_u00d7] = ACTIONS(5463),
    [anon_sym_BSLASHwr] = ACTIONS(5463),
    [anon_sym_u2240] = ACTIONS(5463),
    [anon_sym_BSLASHcdot] = ACTIONS(5463),
    [anon_sym_u22c5] = ACTIONS(5463),
    [sym_pow] = ACTIONS(5461),
    [sym_powpow] = ACTIONS(5463),
    [anon_sym_CARET_PLUS] = ACTIONS(5463),
    [anon_sym_u207a] = ACTIONS(5463),
    [sym_asterisk] = ACTIONS(5463),
    [sym_sup_hash] = ACTIONS(5463),
    [sym_prime] = ACTIONS(5463),
    [sym__indent] = ACTIONS(5463),
    [sym__double_excl] = ACTIONS(5463),
  },
  [2164] = {
    [sym_block_comment] = STATE(2164),
    [sym_identifier] = ACTIONS(5465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5465),
    [anon_sym_u2208] = ACTIONS(5467),
    [anon_sym_BSLASHA] = ACTIONS(5465),
    [anon_sym_BSLASHforall] = ACTIONS(5467),
    [anon_sym_u2200] = ACTIONS(5467),
    [anon_sym_BSLASHE] = ACTIONS(5465),
    [anon_sym_BSLASHexists] = ACTIONS(5467),
    [anon_sym_u2203] = ACTIONS(5467),
    [sym_temporal_forall] = ACTIONS(5467),
    [sym_temporal_exists] = ACTIONS(5467),
    [anon_sym_LT_LT] = ACTIONS(5467),
    [anon_sym_u3008] = ACTIONS(5467),
    [anon_sym_u27e8] = ACTIONS(5467),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5467),
    [anon_sym_u25a1] = ACTIONS(5467),
    [anon_sym_AT] = ACTIONS(5465),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5467),
    [anon_sym_u2227] = ACTIONS(5467),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5467),
    [anon_sym_u2228] = ACTIONS(5467),
    [anon_sym_LPAREN] = ACTIONS(5465),
    [anon_sym_LBRACK] = ACTIONS(5465),
    [aux_sym_child_id_token1] = ACTIONS(5465),
    [sym_real_number] = ACTIONS(5467),
    [anon_sym_BSLASHb] = ACTIONS(5465),
    [anon_sym_BSLASHB] = ACTIONS(5467),
    [anon_sym_BSLASHo] = ACTIONS(5465),
    [anon_sym_BSLASHO] = ACTIONS(5467),
    [anon_sym_BSLASHh] = ACTIONS(5467),
    [anon_sym_BSLASHH] = ACTIONS(5467),
    [anon_sym_DQUOTE] = ACTIONS(5467),
    [anon_sym_TRUE] = ACTIONS(5465),
    [anon_sym_FALSE] = ACTIONS(5465),
    [sym_string_set] = ACTIONS(5465),
    [sym_boolean_set] = ACTIONS(5465),
    [anon_sym_Nat] = ACTIONS(5465),
    [anon_sym_u2115] = ACTIONS(5467),
    [anon_sym_Int] = ACTIONS(5465),
    [anon_sym_u2124] = ACTIONS(5467),
    [anon_sym_Real] = ACTIONS(5465),
    [anon_sym_u211d] = ACTIONS(5467),
    [anon_sym_CHOOSE] = ACTIONS(5465),
    [anon_sym_LBRACE] = ACTIONS(5467),
    [anon_sym_EQ] = ACTIONS(5465),
    [anon_sym_WF_] = ACTIONS(5465),
    [anon_sym_SF_] = ACTIONS(5465),
    [anon_sym_IF] = ACTIONS(5465),
    [anon_sym_CASE] = ACTIONS(5465),
    [anon_sym_LET] = ACTIONS(5465),
    [anon_sym_BSLASHlnot] = ACTIONS(5467),
    [anon_sym_BSLASHneg] = ACTIONS(5467),
    [anon_sym_TILDE] = ACTIONS(5465),
    [anon_sym_u00ac] = ACTIONS(5467),
    [sym_union] = ACTIONS(5465),
    [sym_powerset] = ACTIONS(5465),
    [sym_domain] = ACTIONS(5465),
    [anon_sym_DASH] = ACTIONS(5465),
    [sym_negative_dot] = ACTIONS(5467),
    [sym_enabled] = ACTIONS(5465),
    [sym_unchanged] = ACTIONS(5465),
    [anon_sym_LT_GT] = ACTIONS(5467),
    [anon_sym_u22c4] = ACTIONS(5467),
    [anon_sym_u25c7] = ACTIONS(5467),
    [anon_sym_EQ_GT] = ACTIONS(5467),
    [anon_sym_u27f9] = ACTIONS(5467),
    [anon_sym_u21d2] = ACTIONS(5467),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5467),
    [anon_sym_u21f8] = ACTIONS(5467),
    [anon_sym_u2945] = ACTIONS(5467),
    [anon_sym_BSLASHequiv] = ACTIONS(5467),
    [anon_sym_u2261] = ACTIONS(5467),
    [anon_sym_LT_EQ_GT] = ACTIONS(5467),
    [anon_sym_u27fa] = ACTIONS(5467),
    [anon_sym_u21d4] = ACTIONS(5467),
    [anon_sym_TILDE_GT] = ACTIONS(5467),
    [anon_sym_u21dd] = ACTIONS(5467),
    [anon_sym_u219d] = ACTIONS(5467),
    [anon_sym_BSLASHland] = ACTIONS(5467),
    [anon_sym_BSLASHlor] = ACTIONS(5467),
    [anon_sym_COLON_EQ] = ACTIONS(5467),
    [anon_sym_u2254] = ACTIONS(5467),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5467),
    [anon_sym_u2a74] = ACTIONS(5467),
    [anon_sym_SLASH_EQ] = ACTIONS(5467),
    [anon_sym_POUND] = ACTIONS(5465),
    [anon_sym_u2260] = ACTIONS(5467),
    [anon_sym_LT] = ACTIONS(5465),
    [sym_gt] = ACTIONS(5465),
    [anon_sym_LT_EQ] = ACTIONS(5465),
    [anon_sym_EQ_LT] = ACTIONS(5467),
    [anon_sym_BSLASHleq] = ACTIONS(5467),
    [anon_sym_u2264] = ACTIONS(5467),
    [anon_sym_GT_EQ] = ACTIONS(5467),
    [anon_sym_BSLASHgeq] = ACTIONS(5467),
    [anon_sym_u2265] = ACTIONS(5467),
    [anon_sym_BSLASHapprox] = ACTIONS(5467),
    [anon_sym_u2248] = ACTIONS(5467),
    [anon_sym_PIPE_DASH] = ACTIONS(5467),
    [anon_sym_u22a2] = ACTIONS(5467),
    [anon_sym_PIPE_EQ] = ACTIONS(5467),
    [anon_sym_u22a8] = ACTIONS(5467),
    [anon_sym_DASH_PIPE] = ACTIONS(5467),
    [anon_sym_u22a3] = ACTIONS(5467),
    [anon_sym_EQ_PIPE] = ACTIONS(5467),
    [anon_sym_u2ae4] = ACTIONS(5467),
    [anon_sym_BSLASHasymp] = ACTIONS(5467),
    [anon_sym_u224d] = ACTIONS(5467),
    [anon_sym_BSLASHcong] = ACTIONS(5467),
    [anon_sym_u2245] = ACTIONS(5467),
    [anon_sym_BSLASHdoteq] = ACTIONS(5467),
    [anon_sym_u2250] = ACTIONS(5467),
    [anon_sym_BSLASHgg] = ACTIONS(5467),
    [anon_sym_u226b] = ACTIONS(5467),
    [anon_sym_BSLASHll] = ACTIONS(5467),
    [anon_sym_u226a] = ACTIONS(5467),
    [anon_sym_BSLASHnotin] = ACTIONS(5467),
    [anon_sym_u2209] = ACTIONS(5467),
    [anon_sym_BSLASHprec] = ACTIONS(5465),
    [anon_sym_u227a] = ACTIONS(5467),
    [anon_sym_BSLASHsucc] = ACTIONS(5465),
    [anon_sym_u227b] = ACTIONS(5467),
    [anon_sym_BSLASHpreceq] = ACTIONS(5467),
    [anon_sym_u2aaf] = ACTIONS(5467),
    [anon_sym_BSLASHsucceq] = ACTIONS(5467),
    [anon_sym_u2ab0] = ACTIONS(5467),
    [anon_sym_BSLASHpropto] = ACTIONS(5467),
    [anon_sym_u221d] = ACTIONS(5467),
    [anon_sym_BSLASHsim] = ACTIONS(5465),
    [anon_sym_u223c] = ACTIONS(5467),
    [anon_sym_BSLASHsimeq] = ACTIONS(5467),
    [anon_sym_u2243] = ACTIONS(5467),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5465),
    [anon_sym_u228f] = ACTIONS(5467),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5465),
    [anon_sym_u2290] = ACTIONS(5467),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5467),
    [anon_sym_u2291] = ACTIONS(5467),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5467),
    [anon_sym_u2292] = ACTIONS(5467),
    [anon_sym_BSLASHsubset] = ACTIONS(5465),
    [anon_sym_u2282] = ACTIONS(5467),
    [anon_sym_BSLASHsupset] = ACTIONS(5465),
    [anon_sym_u2283] = ACTIONS(5467),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5467),
    [anon_sym_u2286] = ACTIONS(5467),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5467),
    [anon_sym_u2287] = ACTIONS(5467),
    [sym_compose] = ACTIONS(5467),
    [sym_map_to] = ACTIONS(5467),
    [sym_map_from] = ACTIONS(5467),
    [sym_setminus] = ACTIONS(5465),
    [anon_sym_BSLASHcap] = ACTIONS(5467),
    [anon_sym_BSLASHintersect] = ACTIONS(5467),
    [anon_sym_u2229] = ACTIONS(5467),
    [anon_sym_BSLASHcup] = ACTIONS(5467),
    [anon_sym_BSLASHunion] = ACTIONS(5467),
    [anon_sym_u222a] = ACTIONS(5467),
    [anon_sym_DOT_DOT] = ACTIONS(5465),
    [anon_sym_u2025] = ACTIONS(5467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5467),
    [anon_sym_u2026] = ACTIONS(5467),
    [anon_sym_PLUS] = ACTIONS(5465),
    [sym_plusplus] = ACTIONS(5467),
    [anon_sym_BSLASHoplus] = ACTIONS(5467),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5467),
    [anon_sym_u2295] = ACTIONS(5467),
    [anon_sym_BSLASHominus] = ACTIONS(5467),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5467),
    [anon_sym_u2296] = ACTIONS(5467),
    [sym_mod] = ACTIONS(5465),
    [sym_modmod] = ACTIONS(5467),
    [sym_vert] = ACTIONS(5465),
    [anon_sym_PIPE_PIPE] = ACTIONS(5467),
    [anon_sym_u2016] = ACTIONS(5467),
    [sym_minusminus] = ACTIONS(5467),
    [sym_amp] = ACTIONS(5465),
    [sym_ampamp] = ACTIONS(5467),
    [anon_sym_BSLASHodot] = ACTIONS(5467),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5467),
    [anon_sym_u2299] = ACTIONS(5467),
    [anon_sym_BSLASHoslash] = ACTIONS(5467),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5467),
    [anon_sym_u2298] = ACTIONS(5467),
    [anon_sym_BSLASHotimes] = ACTIONS(5467),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5467),
    [anon_sym_u2297] = ACTIONS(5467),
    [sym_mul] = ACTIONS(5465),
    [sym_mulmul] = ACTIONS(5467),
    [sym_slash] = ACTIONS(5465),
    [sym_slashslash] = ACTIONS(5467),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5467),
    [anon_sym_u25ef] = ACTIONS(5467),
    [anon_sym_BSLASHbullet] = ACTIONS(5467),
    [anon_sym_u25cf] = ACTIONS(5467),
    [anon_sym_BSLASHdiv] = ACTIONS(5467),
    [anon_sym_u00f7] = ACTIONS(5467),
    [anon_sym_BSLASHcirc] = ACTIONS(5467),
    [anon_sym_u2218] = ACTIONS(5467),
    [anon_sym_BSLASHstar] = ACTIONS(5467),
    [anon_sym_u22c6] = ACTIONS(5467),
    [anon_sym_u203c] = ACTIONS(5467),
    [sym_hashhash] = ACTIONS(5467),
    [sym_dol] = ACTIONS(5465),
    [sym_doldol] = ACTIONS(5467),
    [anon_sym_QMARK_QMARK] = ACTIONS(5467),
    [anon_sym_u2047] = ACTIONS(5467),
    [anon_sym_BSLASHsqcap] = ACTIONS(5467),
    [anon_sym_u2293] = ACTIONS(5467),
    [anon_sym_BSLASHsqcup] = ACTIONS(5467),
    [anon_sym_u2294] = ACTIONS(5467),
    [anon_sym_BSLASHuplus] = ACTIONS(5467),
    [anon_sym_u228e] = ACTIONS(5467),
    [anon_sym_BSLASHX] = ACTIONS(5467),
    [anon_sym_BSLASHtimes] = ACTIONS(5467),
    [anon_sym_u00d7] = ACTIONS(5467),
    [anon_sym_BSLASHwr] = ACTIONS(5467),
    [anon_sym_u2240] = ACTIONS(5467),
    [anon_sym_BSLASHcdot] = ACTIONS(5467),
    [anon_sym_u22c5] = ACTIONS(5467),
    [sym_pow] = ACTIONS(5465),
    [sym_powpow] = ACTIONS(5467),
    [anon_sym_CARET_PLUS] = ACTIONS(5467),
    [anon_sym_u207a] = ACTIONS(5467),
    [sym_asterisk] = ACTIONS(5467),
    [sym_sup_hash] = ACTIONS(5467),
    [sym_prime] = ACTIONS(5467),
    [sym__indent] = ACTIONS(5467),
    [sym__double_excl] = ACTIONS(5467),
  },
  [2165] = {
    [sym_block_comment] = STATE(2165),
    [sym_identifier] = ACTIONS(5469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5469),
    [anon_sym_u2208] = ACTIONS(5471),
    [anon_sym_BSLASHA] = ACTIONS(5469),
    [anon_sym_BSLASHforall] = ACTIONS(5471),
    [anon_sym_u2200] = ACTIONS(5471),
    [anon_sym_BSLASHE] = ACTIONS(5469),
    [anon_sym_BSLASHexists] = ACTIONS(5471),
    [anon_sym_u2203] = ACTIONS(5471),
    [sym_temporal_forall] = ACTIONS(5471),
    [sym_temporal_exists] = ACTIONS(5471),
    [anon_sym_LT_LT] = ACTIONS(5471),
    [anon_sym_u3008] = ACTIONS(5471),
    [anon_sym_u27e8] = ACTIONS(5471),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5471),
    [anon_sym_u25a1] = ACTIONS(5471),
    [anon_sym_AT] = ACTIONS(5469),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5471),
    [anon_sym_u2227] = ACTIONS(5471),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5471),
    [anon_sym_u2228] = ACTIONS(5471),
    [anon_sym_LPAREN] = ACTIONS(5469),
    [anon_sym_LBRACK] = ACTIONS(5469),
    [aux_sym_child_id_token1] = ACTIONS(5469),
    [sym_real_number] = ACTIONS(5471),
    [anon_sym_BSLASHb] = ACTIONS(5469),
    [anon_sym_BSLASHB] = ACTIONS(5471),
    [anon_sym_BSLASHo] = ACTIONS(5469),
    [anon_sym_BSLASHO] = ACTIONS(5471),
    [anon_sym_BSLASHh] = ACTIONS(5471),
    [anon_sym_BSLASHH] = ACTIONS(5471),
    [anon_sym_DQUOTE] = ACTIONS(5471),
    [anon_sym_TRUE] = ACTIONS(5469),
    [anon_sym_FALSE] = ACTIONS(5469),
    [sym_string_set] = ACTIONS(5469),
    [sym_boolean_set] = ACTIONS(5469),
    [anon_sym_Nat] = ACTIONS(5469),
    [anon_sym_u2115] = ACTIONS(5471),
    [anon_sym_Int] = ACTIONS(5469),
    [anon_sym_u2124] = ACTIONS(5471),
    [anon_sym_Real] = ACTIONS(5469),
    [anon_sym_u211d] = ACTIONS(5471),
    [anon_sym_CHOOSE] = ACTIONS(5469),
    [anon_sym_LBRACE] = ACTIONS(5471),
    [anon_sym_EQ] = ACTIONS(5469),
    [anon_sym_WF_] = ACTIONS(5469),
    [anon_sym_SF_] = ACTIONS(5469),
    [anon_sym_IF] = ACTIONS(5469),
    [anon_sym_CASE] = ACTIONS(5469),
    [anon_sym_LET] = ACTIONS(5469),
    [anon_sym_BSLASHlnot] = ACTIONS(5471),
    [anon_sym_BSLASHneg] = ACTIONS(5471),
    [anon_sym_TILDE] = ACTIONS(5469),
    [anon_sym_u00ac] = ACTIONS(5471),
    [sym_union] = ACTIONS(5469),
    [sym_powerset] = ACTIONS(5469),
    [sym_domain] = ACTIONS(5469),
    [anon_sym_DASH] = ACTIONS(5469),
    [sym_negative_dot] = ACTIONS(5471),
    [sym_enabled] = ACTIONS(5469),
    [sym_unchanged] = ACTIONS(5469),
    [anon_sym_LT_GT] = ACTIONS(5471),
    [anon_sym_u22c4] = ACTIONS(5471),
    [anon_sym_u25c7] = ACTIONS(5471),
    [anon_sym_EQ_GT] = ACTIONS(5471),
    [anon_sym_u27f9] = ACTIONS(5471),
    [anon_sym_u21d2] = ACTIONS(5471),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5471),
    [anon_sym_u21f8] = ACTIONS(5471),
    [anon_sym_u2945] = ACTIONS(5471),
    [anon_sym_BSLASHequiv] = ACTIONS(5471),
    [anon_sym_u2261] = ACTIONS(5471),
    [anon_sym_LT_EQ_GT] = ACTIONS(5471),
    [anon_sym_u27fa] = ACTIONS(5471),
    [anon_sym_u21d4] = ACTIONS(5471),
    [anon_sym_TILDE_GT] = ACTIONS(5471),
    [anon_sym_u21dd] = ACTIONS(5471),
    [anon_sym_u219d] = ACTIONS(5471),
    [anon_sym_BSLASHland] = ACTIONS(5471),
    [anon_sym_BSLASHlor] = ACTIONS(5471),
    [anon_sym_COLON_EQ] = ACTIONS(5471),
    [anon_sym_u2254] = ACTIONS(5471),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5471),
    [anon_sym_u2a74] = ACTIONS(5471),
    [anon_sym_SLASH_EQ] = ACTIONS(5471),
    [anon_sym_POUND] = ACTIONS(5469),
    [anon_sym_u2260] = ACTIONS(5471),
    [anon_sym_LT] = ACTIONS(5469),
    [sym_gt] = ACTIONS(5469),
    [anon_sym_LT_EQ] = ACTIONS(5469),
    [anon_sym_EQ_LT] = ACTIONS(5471),
    [anon_sym_BSLASHleq] = ACTIONS(5471),
    [anon_sym_u2264] = ACTIONS(5471),
    [anon_sym_GT_EQ] = ACTIONS(5471),
    [anon_sym_BSLASHgeq] = ACTIONS(5471),
    [anon_sym_u2265] = ACTIONS(5471),
    [anon_sym_BSLASHapprox] = ACTIONS(5471),
    [anon_sym_u2248] = ACTIONS(5471),
    [anon_sym_PIPE_DASH] = ACTIONS(5471),
    [anon_sym_u22a2] = ACTIONS(5471),
    [anon_sym_PIPE_EQ] = ACTIONS(5471),
    [anon_sym_u22a8] = ACTIONS(5471),
    [anon_sym_DASH_PIPE] = ACTIONS(5471),
    [anon_sym_u22a3] = ACTIONS(5471),
    [anon_sym_EQ_PIPE] = ACTIONS(5471),
    [anon_sym_u2ae4] = ACTIONS(5471),
    [anon_sym_BSLASHasymp] = ACTIONS(5471),
    [anon_sym_u224d] = ACTIONS(5471),
    [anon_sym_BSLASHcong] = ACTIONS(5471),
    [anon_sym_u2245] = ACTIONS(5471),
    [anon_sym_BSLASHdoteq] = ACTIONS(5471),
    [anon_sym_u2250] = ACTIONS(5471),
    [anon_sym_BSLASHgg] = ACTIONS(5471),
    [anon_sym_u226b] = ACTIONS(5471),
    [anon_sym_BSLASHll] = ACTIONS(5471),
    [anon_sym_u226a] = ACTIONS(5471),
    [anon_sym_BSLASHnotin] = ACTIONS(5471),
    [anon_sym_u2209] = ACTIONS(5471),
    [anon_sym_BSLASHprec] = ACTIONS(5469),
    [anon_sym_u227a] = ACTIONS(5471),
    [anon_sym_BSLASHsucc] = ACTIONS(5469),
    [anon_sym_u227b] = ACTIONS(5471),
    [anon_sym_BSLASHpreceq] = ACTIONS(5471),
    [anon_sym_u2aaf] = ACTIONS(5471),
    [anon_sym_BSLASHsucceq] = ACTIONS(5471),
    [anon_sym_u2ab0] = ACTIONS(5471),
    [anon_sym_BSLASHpropto] = ACTIONS(5471),
    [anon_sym_u221d] = ACTIONS(5471),
    [anon_sym_BSLASHsim] = ACTIONS(5469),
    [anon_sym_u223c] = ACTIONS(5471),
    [anon_sym_BSLASHsimeq] = ACTIONS(5471),
    [anon_sym_u2243] = ACTIONS(5471),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5469),
    [anon_sym_u228f] = ACTIONS(5471),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5469),
    [anon_sym_u2290] = ACTIONS(5471),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5471),
    [anon_sym_u2291] = ACTIONS(5471),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5471),
    [anon_sym_u2292] = ACTIONS(5471),
    [anon_sym_BSLASHsubset] = ACTIONS(5469),
    [anon_sym_u2282] = ACTIONS(5471),
    [anon_sym_BSLASHsupset] = ACTIONS(5469),
    [anon_sym_u2283] = ACTIONS(5471),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5471),
    [anon_sym_u2286] = ACTIONS(5471),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5471),
    [anon_sym_u2287] = ACTIONS(5471),
    [sym_compose] = ACTIONS(5471),
    [sym_map_to] = ACTIONS(5471),
    [sym_map_from] = ACTIONS(5471),
    [sym_setminus] = ACTIONS(5469),
    [anon_sym_BSLASHcap] = ACTIONS(5471),
    [anon_sym_BSLASHintersect] = ACTIONS(5471),
    [anon_sym_u2229] = ACTIONS(5471),
    [anon_sym_BSLASHcup] = ACTIONS(5471),
    [anon_sym_BSLASHunion] = ACTIONS(5471),
    [anon_sym_u222a] = ACTIONS(5471),
    [anon_sym_DOT_DOT] = ACTIONS(5469),
    [anon_sym_u2025] = ACTIONS(5471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5471),
    [anon_sym_u2026] = ACTIONS(5471),
    [anon_sym_PLUS] = ACTIONS(5469),
    [sym_plusplus] = ACTIONS(5471),
    [anon_sym_BSLASHoplus] = ACTIONS(5471),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5471),
    [anon_sym_u2295] = ACTIONS(5471),
    [anon_sym_BSLASHominus] = ACTIONS(5471),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5471),
    [anon_sym_u2296] = ACTIONS(5471),
    [sym_mod] = ACTIONS(5469),
    [sym_modmod] = ACTIONS(5471),
    [sym_vert] = ACTIONS(5469),
    [anon_sym_PIPE_PIPE] = ACTIONS(5471),
    [anon_sym_u2016] = ACTIONS(5471),
    [sym_minusminus] = ACTIONS(5471),
    [sym_amp] = ACTIONS(5469),
    [sym_ampamp] = ACTIONS(5471),
    [anon_sym_BSLASHodot] = ACTIONS(5471),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5471),
    [anon_sym_u2299] = ACTIONS(5471),
    [anon_sym_BSLASHoslash] = ACTIONS(5471),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5471),
    [anon_sym_u2298] = ACTIONS(5471),
    [anon_sym_BSLASHotimes] = ACTIONS(5471),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5471),
    [anon_sym_u2297] = ACTIONS(5471),
    [sym_mul] = ACTIONS(5469),
    [sym_mulmul] = ACTIONS(5471),
    [sym_slash] = ACTIONS(5469),
    [sym_slashslash] = ACTIONS(5471),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5471),
    [anon_sym_u25ef] = ACTIONS(5471),
    [anon_sym_BSLASHbullet] = ACTIONS(5471),
    [anon_sym_u25cf] = ACTIONS(5471),
    [anon_sym_BSLASHdiv] = ACTIONS(5471),
    [anon_sym_u00f7] = ACTIONS(5471),
    [anon_sym_BSLASHcirc] = ACTIONS(5471),
    [anon_sym_u2218] = ACTIONS(5471),
    [anon_sym_BSLASHstar] = ACTIONS(5471),
    [anon_sym_u22c6] = ACTIONS(5471),
    [anon_sym_u203c] = ACTIONS(5471),
    [sym_hashhash] = ACTIONS(5471),
    [sym_dol] = ACTIONS(5469),
    [sym_doldol] = ACTIONS(5471),
    [anon_sym_QMARK_QMARK] = ACTIONS(5471),
    [anon_sym_u2047] = ACTIONS(5471),
    [anon_sym_BSLASHsqcap] = ACTIONS(5471),
    [anon_sym_u2293] = ACTIONS(5471),
    [anon_sym_BSLASHsqcup] = ACTIONS(5471),
    [anon_sym_u2294] = ACTIONS(5471),
    [anon_sym_BSLASHuplus] = ACTIONS(5471),
    [anon_sym_u228e] = ACTIONS(5471),
    [anon_sym_BSLASHX] = ACTIONS(5471),
    [anon_sym_BSLASHtimes] = ACTIONS(5471),
    [anon_sym_u00d7] = ACTIONS(5471),
    [anon_sym_BSLASHwr] = ACTIONS(5471),
    [anon_sym_u2240] = ACTIONS(5471),
    [anon_sym_BSLASHcdot] = ACTIONS(5471),
    [anon_sym_u22c5] = ACTIONS(5471),
    [sym_pow] = ACTIONS(5469),
    [sym_powpow] = ACTIONS(5471),
    [anon_sym_CARET_PLUS] = ACTIONS(5471),
    [anon_sym_u207a] = ACTIONS(5471),
    [sym_asterisk] = ACTIONS(5471),
    [sym_sup_hash] = ACTIONS(5471),
    [sym_prime] = ACTIONS(5471),
    [sym__indent] = ACTIONS(5471),
    [sym__double_excl] = ACTIONS(5471),
  },
  [2166] = {
    [sym_block_comment] = STATE(2166),
    [sym_identifier] = ACTIONS(5473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5473),
    [anon_sym_u2208] = ACTIONS(5475),
    [anon_sym_BSLASHA] = ACTIONS(5473),
    [anon_sym_BSLASHforall] = ACTIONS(5475),
    [anon_sym_u2200] = ACTIONS(5475),
    [anon_sym_BSLASHE] = ACTIONS(5473),
    [anon_sym_BSLASHexists] = ACTIONS(5475),
    [anon_sym_u2203] = ACTIONS(5475),
    [sym_temporal_forall] = ACTIONS(5475),
    [sym_temporal_exists] = ACTIONS(5475),
    [anon_sym_LT_LT] = ACTIONS(5475),
    [anon_sym_u3008] = ACTIONS(5475),
    [anon_sym_u27e8] = ACTIONS(5475),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5475),
    [anon_sym_u25a1] = ACTIONS(5475),
    [anon_sym_AT] = ACTIONS(5473),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5475),
    [anon_sym_u2227] = ACTIONS(5475),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5475),
    [anon_sym_u2228] = ACTIONS(5475),
    [anon_sym_LPAREN] = ACTIONS(5473),
    [anon_sym_LBRACK] = ACTIONS(5473),
    [aux_sym_child_id_token1] = ACTIONS(5473),
    [sym_real_number] = ACTIONS(5475),
    [anon_sym_BSLASHb] = ACTIONS(5473),
    [anon_sym_BSLASHB] = ACTIONS(5475),
    [anon_sym_BSLASHo] = ACTIONS(5473),
    [anon_sym_BSLASHO] = ACTIONS(5475),
    [anon_sym_BSLASHh] = ACTIONS(5475),
    [anon_sym_BSLASHH] = ACTIONS(5475),
    [anon_sym_DQUOTE] = ACTIONS(5475),
    [anon_sym_TRUE] = ACTIONS(5473),
    [anon_sym_FALSE] = ACTIONS(5473),
    [sym_string_set] = ACTIONS(5473),
    [sym_boolean_set] = ACTIONS(5473),
    [anon_sym_Nat] = ACTIONS(5473),
    [anon_sym_u2115] = ACTIONS(5475),
    [anon_sym_Int] = ACTIONS(5473),
    [anon_sym_u2124] = ACTIONS(5475),
    [anon_sym_Real] = ACTIONS(5473),
    [anon_sym_u211d] = ACTIONS(5475),
    [anon_sym_CHOOSE] = ACTIONS(5473),
    [anon_sym_LBRACE] = ACTIONS(5475),
    [anon_sym_EQ] = ACTIONS(5473),
    [anon_sym_WF_] = ACTIONS(5473),
    [anon_sym_SF_] = ACTIONS(5473),
    [anon_sym_IF] = ACTIONS(5473),
    [anon_sym_CASE] = ACTIONS(5473),
    [anon_sym_LET] = ACTIONS(5473),
    [anon_sym_BSLASHlnot] = ACTIONS(5475),
    [anon_sym_BSLASHneg] = ACTIONS(5475),
    [anon_sym_TILDE] = ACTIONS(5473),
    [anon_sym_u00ac] = ACTIONS(5475),
    [sym_union] = ACTIONS(5473),
    [sym_powerset] = ACTIONS(5473),
    [sym_domain] = ACTIONS(5473),
    [anon_sym_DASH] = ACTIONS(5473),
    [sym_negative_dot] = ACTIONS(5475),
    [sym_enabled] = ACTIONS(5473),
    [sym_unchanged] = ACTIONS(5473),
    [anon_sym_LT_GT] = ACTIONS(5475),
    [anon_sym_u22c4] = ACTIONS(5475),
    [anon_sym_u25c7] = ACTIONS(5475),
    [anon_sym_EQ_GT] = ACTIONS(5475),
    [anon_sym_u27f9] = ACTIONS(5475),
    [anon_sym_u21d2] = ACTIONS(5475),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5475),
    [anon_sym_u21f8] = ACTIONS(5475),
    [anon_sym_u2945] = ACTIONS(5475),
    [anon_sym_BSLASHequiv] = ACTIONS(5475),
    [anon_sym_u2261] = ACTIONS(5475),
    [anon_sym_LT_EQ_GT] = ACTIONS(5475),
    [anon_sym_u27fa] = ACTIONS(5475),
    [anon_sym_u21d4] = ACTIONS(5475),
    [anon_sym_TILDE_GT] = ACTIONS(5475),
    [anon_sym_u21dd] = ACTIONS(5475),
    [anon_sym_u219d] = ACTIONS(5475),
    [anon_sym_BSLASHland] = ACTIONS(5475),
    [anon_sym_BSLASHlor] = ACTIONS(5475),
    [anon_sym_COLON_EQ] = ACTIONS(5475),
    [anon_sym_u2254] = ACTIONS(5475),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5475),
    [anon_sym_u2a74] = ACTIONS(5475),
    [anon_sym_SLASH_EQ] = ACTIONS(5475),
    [anon_sym_POUND] = ACTIONS(5473),
    [anon_sym_u2260] = ACTIONS(5475),
    [anon_sym_LT] = ACTIONS(5473),
    [sym_gt] = ACTIONS(5473),
    [anon_sym_LT_EQ] = ACTIONS(5473),
    [anon_sym_EQ_LT] = ACTIONS(5475),
    [anon_sym_BSLASHleq] = ACTIONS(5475),
    [anon_sym_u2264] = ACTIONS(5475),
    [anon_sym_GT_EQ] = ACTIONS(5475),
    [anon_sym_BSLASHgeq] = ACTIONS(5475),
    [anon_sym_u2265] = ACTIONS(5475),
    [anon_sym_BSLASHapprox] = ACTIONS(5475),
    [anon_sym_u2248] = ACTIONS(5475),
    [anon_sym_PIPE_DASH] = ACTIONS(5475),
    [anon_sym_u22a2] = ACTIONS(5475),
    [anon_sym_PIPE_EQ] = ACTIONS(5475),
    [anon_sym_u22a8] = ACTIONS(5475),
    [anon_sym_DASH_PIPE] = ACTIONS(5475),
    [anon_sym_u22a3] = ACTIONS(5475),
    [anon_sym_EQ_PIPE] = ACTIONS(5475),
    [anon_sym_u2ae4] = ACTIONS(5475),
    [anon_sym_BSLASHasymp] = ACTIONS(5475),
    [anon_sym_u224d] = ACTIONS(5475),
    [anon_sym_BSLASHcong] = ACTIONS(5475),
    [anon_sym_u2245] = ACTIONS(5475),
    [anon_sym_BSLASHdoteq] = ACTIONS(5475),
    [anon_sym_u2250] = ACTIONS(5475),
    [anon_sym_BSLASHgg] = ACTIONS(5475),
    [anon_sym_u226b] = ACTIONS(5475),
    [anon_sym_BSLASHll] = ACTIONS(5475),
    [anon_sym_u226a] = ACTIONS(5475),
    [anon_sym_BSLASHnotin] = ACTIONS(5475),
    [anon_sym_u2209] = ACTIONS(5475),
    [anon_sym_BSLASHprec] = ACTIONS(5473),
    [anon_sym_u227a] = ACTIONS(5475),
    [anon_sym_BSLASHsucc] = ACTIONS(5473),
    [anon_sym_u227b] = ACTIONS(5475),
    [anon_sym_BSLASHpreceq] = ACTIONS(5475),
    [anon_sym_u2aaf] = ACTIONS(5475),
    [anon_sym_BSLASHsucceq] = ACTIONS(5475),
    [anon_sym_u2ab0] = ACTIONS(5475),
    [anon_sym_BSLASHpropto] = ACTIONS(5475),
    [anon_sym_u221d] = ACTIONS(5475),
    [anon_sym_BSLASHsim] = ACTIONS(5473),
    [anon_sym_u223c] = ACTIONS(5475),
    [anon_sym_BSLASHsimeq] = ACTIONS(5475),
    [anon_sym_u2243] = ACTIONS(5475),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5473),
    [anon_sym_u228f] = ACTIONS(5475),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5473),
    [anon_sym_u2290] = ACTIONS(5475),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5475),
    [anon_sym_u2291] = ACTIONS(5475),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5475),
    [anon_sym_u2292] = ACTIONS(5475),
    [anon_sym_BSLASHsubset] = ACTIONS(5473),
    [anon_sym_u2282] = ACTIONS(5475),
    [anon_sym_BSLASHsupset] = ACTIONS(5473),
    [anon_sym_u2283] = ACTIONS(5475),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5475),
    [anon_sym_u2286] = ACTIONS(5475),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5475),
    [anon_sym_u2287] = ACTIONS(5475),
    [sym_compose] = ACTIONS(5475),
    [sym_map_to] = ACTIONS(5475),
    [sym_map_from] = ACTIONS(5475),
    [sym_setminus] = ACTIONS(5473),
    [anon_sym_BSLASHcap] = ACTIONS(5475),
    [anon_sym_BSLASHintersect] = ACTIONS(5475),
    [anon_sym_u2229] = ACTIONS(5475),
    [anon_sym_BSLASHcup] = ACTIONS(5475),
    [anon_sym_BSLASHunion] = ACTIONS(5475),
    [anon_sym_u222a] = ACTIONS(5475),
    [anon_sym_DOT_DOT] = ACTIONS(5473),
    [anon_sym_u2025] = ACTIONS(5475),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5475),
    [anon_sym_u2026] = ACTIONS(5475),
    [anon_sym_PLUS] = ACTIONS(5473),
    [sym_plusplus] = ACTIONS(5475),
    [anon_sym_BSLASHoplus] = ACTIONS(5475),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5475),
    [anon_sym_u2295] = ACTIONS(5475),
    [anon_sym_BSLASHominus] = ACTIONS(5475),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5475),
    [anon_sym_u2296] = ACTIONS(5475),
    [sym_mod] = ACTIONS(5473),
    [sym_modmod] = ACTIONS(5475),
    [sym_vert] = ACTIONS(5473),
    [anon_sym_PIPE_PIPE] = ACTIONS(5475),
    [anon_sym_u2016] = ACTIONS(5475),
    [sym_minusminus] = ACTIONS(5475),
    [sym_amp] = ACTIONS(5473),
    [sym_ampamp] = ACTIONS(5475),
    [anon_sym_BSLASHodot] = ACTIONS(5475),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5475),
    [anon_sym_u2299] = ACTIONS(5475),
    [anon_sym_BSLASHoslash] = ACTIONS(5475),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5475),
    [anon_sym_u2298] = ACTIONS(5475),
    [anon_sym_BSLASHotimes] = ACTIONS(5475),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5475),
    [anon_sym_u2297] = ACTIONS(5475),
    [sym_mul] = ACTIONS(5473),
    [sym_mulmul] = ACTIONS(5475),
    [sym_slash] = ACTIONS(5473),
    [sym_slashslash] = ACTIONS(5475),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5475),
    [anon_sym_u25ef] = ACTIONS(5475),
    [anon_sym_BSLASHbullet] = ACTIONS(5475),
    [anon_sym_u25cf] = ACTIONS(5475),
    [anon_sym_BSLASHdiv] = ACTIONS(5475),
    [anon_sym_u00f7] = ACTIONS(5475),
    [anon_sym_BSLASHcirc] = ACTIONS(5475),
    [anon_sym_u2218] = ACTIONS(5475),
    [anon_sym_BSLASHstar] = ACTIONS(5475),
    [anon_sym_u22c6] = ACTIONS(5475),
    [anon_sym_u203c] = ACTIONS(5475),
    [sym_hashhash] = ACTIONS(5475),
    [sym_dol] = ACTIONS(5473),
    [sym_doldol] = ACTIONS(5475),
    [anon_sym_QMARK_QMARK] = ACTIONS(5475),
    [anon_sym_u2047] = ACTIONS(5475),
    [anon_sym_BSLASHsqcap] = ACTIONS(5475),
    [anon_sym_u2293] = ACTIONS(5475),
    [anon_sym_BSLASHsqcup] = ACTIONS(5475),
    [anon_sym_u2294] = ACTIONS(5475),
    [anon_sym_BSLASHuplus] = ACTIONS(5475),
    [anon_sym_u228e] = ACTIONS(5475),
    [anon_sym_BSLASHX] = ACTIONS(5475),
    [anon_sym_BSLASHtimes] = ACTIONS(5475),
    [anon_sym_u00d7] = ACTIONS(5475),
    [anon_sym_BSLASHwr] = ACTIONS(5475),
    [anon_sym_u2240] = ACTIONS(5475),
    [anon_sym_BSLASHcdot] = ACTIONS(5475),
    [anon_sym_u22c5] = ACTIONS(5475),
    [sym_pow] = ACTIONS(5473),
    [sym_powpow] = ACTIONS(5475),
    [anon_sym_CARET_PLUS] = ACTIONS(5475),
    [anon_sym_u207a] = ACTIONS(5475),
    [sym_asterisk] = ACTIONS(5475),
    [sym_sup_hash] = ACTIONS(5475),
    [sym_prime] = ACTIONS(5475),
    [sym__indent] = ACTIONS(5475),
    [sym__double_excl] = ACTIONS(5475),
  },
  [2167] = {
    [sym_block_comment] = STATE(2167),
    [sym_identifier] = ACTIONS(5477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5477),
    [anon_sym_u2208] = ACTIONS(5479),
    [anon_sym_BSLASHA] = ACTIONS(5477),
    [anon_sym_BSLASHforall] = ACTIONS(5479),
    [anon_sym_u2200] = ACTIONS(5479),
    [anon_sym_BSLASHE] = ACTIONS(5477),
    [anon_sym_BSLASHexists] = ACTIONS(5479),
    [anon_sym_u2203] = ACTIONS(5479),
    [sym_temporal_forall] = ACTIONS(5479),
    [sym_temporal_exists] = ACTIONS(5479),
    [anon_sym_LT_LT] = ACTIONS(5479),
    [anon_sym_u3008] = ACTIONS(5479),
    [anon_sym_u27e8] = ACTIONS(5479),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5479),
    [anon_sym_u25a1] = ACTIONS(5479),
    [anon_sym_AT] = ACTIONS(5477),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5479),
    [anon_sym_u2227] = ACTIONS(5479),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5479),
    [anon_sym_u2228] = ACTIONS(5479),
    [anon_sym_LPAREN] = ACTIONS(5477),
    [anon_sym_LBRACK] = ACTIONS(5477),
    [aux_sym_child_id_token1] = ACTIONS(5477),
    [sym_real_number] = ACTIONS(5479),
    [anon_sym_BSLASHb] = ACTIONS(5477),
    [anon_sym_BSLASHB] = ACTIONS(5479),
    [anon_sym_BSLASHo] = ACTIONS(5477),
    [anon_sym_BSLASHO] = ACTIONS(5479),
    [anon_sym_BSLASHh] = ACTIONS(5479),
    [anon_sym_BSLASHH] = ACTIONS(5479),
    [anon_sym_DQUOTE] = ACTIONS(5479),
    [anon_sym_TRUE] = ACTIONS(5477),
    [anon_sym_FALSE] = ACTIONS(5477),
    [sym_string_set] = ACTIONS(5477),
    [sym_boolean_set] = ACTIONS(5477),
    [anon_sym_Nat] = ACTIONS(5477),
    [anon_sym_u2115] = ACTIONS(5479),
    [anon_sym_Int] = ACTIONS(5477),
    [anon_sym_u2124] = ACTIONS(5479),
    [anon_sym_Real] = ACTIONS(5477),
    [anon_sym_u211d] = ACTIONS(5479),
    [anon_sym_CHOOSE] = ACTIONS(5477),
    [anon_sym_LBRACE] = ACTIONS(5479),
    [anon_sym_EQ] = ACTIONS(5477),
    [anon_sym_WF_] = ACTIONS(5477),
    [anon_sym_SF_] = ACTIONS(5477),
    [anon_sym_IF] = ACTIONS(5477),
    [anon_sym_CASE] = ACTIONS(5477),
    [anon_sym_LET] = ACTIONS(5477),
    [anon_sym_BSLASHlnot] = ACTIONS(5479),
    [anon_sym_BSLASHneg] = ACTIONS(5479),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_u00ac] = ACTIONS(5479),
    [sym_union] = ACTIONS(5477),
    [sym_powerset] = ACTIONS(5477),
    [sym_domain] = ACTIONS(5477),
    [anon_sym_DASH] = ACTIONS(5477),
    [sym_negative_dot] = ACTIONS(5479),
    [sym_enabled] = ACTIONS(5477),
    [sym_unchanged] = ACTIONS(5477),
    [anon_sym_LT_GT] = ACTIONS(5479),
    [anon_sym_u22c4] = ACTIONS(5479),
    [anon_sym_u25c7] = ACTIONS(5479),
    [anon_sym_EQ_GT] = ACTIONS(5479),
    [anon_sym_u27f9] = ACTIONS(5479),
    [anon_sym_u21d2] = ACTIONS(5479),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5479),
    [anon_sym_u21f8] = ACTIONS(5479),
    [anon_sym_u2945] = ACTIONS(5479),
    [anon_sym_BSLASHequiv] = ACTIONS(5479),
    [anon_sym_u2261] = ACTIONS(5479),
    [anon_sym_LT_EQ_GT] = ACTIONS(5479),
    [anon_sym_u27fa] = ACTIONS(5479),
    [anon_sym_u21d4] = ACTIONS(5479),
    [anon_sym_TILDE_GT] = ACTIONS(5479),
    [anon_sym_u21dd] = ACTIONS(5479),
    [anon_sym_u219d] = ACTIONS(5479),
    [anon_sym_BSLASHland] = ACTIONS(5479),
    [anon_sym_BSLASHlor] = ACTIONS(5479),
    [anon_sym_COLON_EQ] = ACTIONS(5479),
    [anon_sym_u2254] = ACTIONS(5479),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5479),
    [anon_sym_u2a74] = ACTIONS(5479),
    [anon_sym_SLASH_EQ] = ACTIONS(5479),
    [anon_sym_POUND] = ACTIONS(5477),
    [anon_sym_u2260] = ACTIONS(5479),
    [anon_sym_LT] = ACTIONS(5477),
    [sym_gt] = ACTIONS(5477),
    [anon_sym_LT_EQ] = ACTIONS(5477),
    [anon_sym_EQ_LT] = ACTIONS(5479),
    [anon_sym_BSLASHleq] = ACTIONS(5479),
    [anon_sym_u2264] = ACTIONS(5479),
    [anon_sym_GT_EQ] = ACTIONS(5479),
    [anon_sym_BSLASHgeq] = ACTIONS(5479),
    [anon_sym_u2265] = ACTIONS(5479),
    [anon_sym_BSLASHapprox] = ACTIONS(5479),
    [anon_sym_u2248] = ACTIONS(5479),
    [anon_sym_PIPE_DASH] = ACTIONS(5479),
    [anon_sym_u22a2] = ACTIONS(5479),
    [anon_sym_PIPE_EQ] = ACTIONS(5479),
    [anon_sym_u22a8] = ACTIONS(5479),
    [anon_sym_DASH_PIPE] = ACTIONS(5479),
    [anon_sym_u22a3] = ACTIONS(5479),
    [anon_sym_EQ_PIPE] = ACTIONS(5479),
    [anon_sym_u2ae4] = ACTIONS(5479),
    [anon_sym_BSLASHasymp] = ACTIONS(5479),
    [anon_sym_u224d] = ACTIONS(5479),
    [anon_sym_BSLASHcong] = ACTIONS(5479),
    [anon_sym_u2245] = ACTIONS(5479),
    [anon_sym_BSLASHdoteq] = ACTIONS(5479),
    [anon_sym_u2250] = ACTIONS(5479),
    [anon_sym_BSLASHgg] = ACTIONS(5479),
    [anon_sym_u226b] = ACTIONS(5479),
    [anon_sym_BSLASHll] = ACTIONS(5479),
    [anon_sym_u226a] = ACTIONS(5479),
    [anon_sym_BSLASHnotin] = ACTIONS(5479),
    [anon_sym_u2209] = ACTIONS(5479),
    [anon_sym_BSLASHprec] = ACTIONS(5477),
    [anon_sym_u227a] = ACTIONS(5479),
    [anon_sym_BSLASHsucc] = ACTIONS(5477),
    [anon_sym_u227b] = ACTIONS(5479),
    [anon_sym_BSLASHpreceq] = ACTIONS(5479),
    [anon_sym_u2aaf] = ACTIONS(5479),
    [anon_sym_BSLASHsucceq] = ACTIONS(5479),
    [anon_sym_u2ab0] = ACTIONS(5479),
    [anon_sym_BSLASHpropto] = ACTIONS(5479),
    [anon_sym_u221d] = ACTIONS(5479),
    [anon_sym_BSLASHsim] = ACTIONS(5477),
    [anon_sym_u223c] = ACTIONS(5479),
    [anon_sym_BSLASHsimeq] = ACTIONS(5479),
    [anon_sym_u2243] = ACTIONS(5479),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5477),
    [anon_sym_u228f] = ACTIONS(5479),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5477),
    [anon_sym_u2290] = ACTIONS(5479),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5479),
    [anon_sym_u2291] = ACTIONS(5479),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5479),
    [anon_sym_u2292] = ACTIONS(5479),
    [anon_sym_BSLASHsubset] = ACTIONS(5477),
    [anon_sym_u2282] = ACTIONS(5479),
    [anon_sym_BSLASHsupset] = ACTIONS(5477),
    [anon_sym_u2283] = ACTIONS(5479),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5479),
    [anon_sym_u2286] = ACTIONS(5479),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5479),
    [anon_sym_u2287] = ACTIONS(5479),
    [sym_compose] = ACTIONS(5479),
    [sym_map_to] = ACTIONS(5479),
    [sym_map_from] = ACTIONS(5479),
    [sym_setminus] = ACTIONS(5477),
    [anon_sym_BSLASHcap] = ACTIONS(5479),
    [anon_sym_BSLASHintersect] = ACTIONS(5479),
    [anon_sym_u2229] = ACTIONS(5479),
    [anon_sym_BSLASHcup] = ACTIONS(5479),
    [anon_sym_BSLASHunion] = ACTIONS(5479),
    [anon_sym_u222a] = ACTIONS(5479),
    [anon_sym_DOT_DOT] = ACTIONS(5477),
    [anon_sym_u2025] = ACTIONS(5479),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5479),
    [anon_sym_u2026] = ACTIONS(5479),
    [anon_sym_PLUS] = ACTIONS(5477),
    [sym_plusplus] = ACTIONS(5479),
    [anon_sym_BSLASHoplus] = ACTIONS(5479),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5479),
    [anon_sym_u2295] = ACTIONS(5479),
    [anon_sym_BSLASHominus] = ACTIONS(5479),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5479),
    [anon_sym_u2296] = ACTIONS(5479),
    [sym_mod] = ACTIONS(5477),
    [sym_modmod] = ACTIONS(5479),
    [sym_vert] = ACTIONS(5477),
    [anon_sym_PIPE_PIPE] = ACTIONS(5479),
    [anon_sym_u2016] = ACTIONS(5479),
    [sym_minusminus] = ACTIONS(5479),
    [sym_amp] = ACTIONS(5477),
    [sym_ampamp] = ACTIONS(5479),
    [anon_sym_BSLASHodot] = ACTIONS(5479),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5479),
    [anon_sym_u2299] = ACTIONS(5479),
    [anon_sym_BSLASHoslash] = ACTIONS(5479),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5479),
    [anon_sym_u2298] = ACTIONS(5479),
    [anon_sym_BSLASHotimes] = ACTIONS(5479),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5479),
    [anon_sym_u2297] = ACTIONS(5479),
    [sym_mul] = ACTIONS(5477),
    [sym_mulmul] = ACTIONS(5479),
    [sym_slash] = ACTIONS(5477),
    [sym_slashslash] = ACTIONS(5479),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5479),
    [anon_sym_u25ef] = ACTIONS(5479),
    [anon_sym_BSLASHbullet] = ACTIONS(5479),
    [anon_sym_u25cf] = ACTIONS(5479),
    [anon_sym_BSLASHdiv] = ACTIONS(5479),
    [anon_sym_u00f7] = ACTIONS(5479),
    [anon_sym_BSLASHcirc] = ACTIONS(5479),
    [anon_sym_u2218] = ACTIONS(5479),
    [anon_sym_BSLASHstar] = ACTIONS(5479),
    [anon_sym_u22c6] = ACTIONS(5479),
    [anon_sym_u203c] = ACTIONS(5479),
    [sym_hashhash] = ACTIONS(5479),
    [sym_dol] = ACTIONS(5477),
    [sym_doldol] = ACTIONS(5479),
    [anon_sym_QMARK_QMARK] = ACTIONS(5479),
    [anon_sym_u2047] = ACTIONS(5479),
    [anon_sym_BSLASHsqcap] = ACTIONS(5479),
    [anon_sym_u2293] = ACTIONS(5479),
    [anon_sym_BSLASHsqcup] = ACTIONS(5479),
    [anon_sym_u2294] = ACTIONS(5479),
    [anon_sym_BSLASHuplus] = ACTIONS(5479),
    [anon_sym_u228e] = ACTIONS(5479),
    [anon_sym_BSLASHX] = ACTIONS(5479),
    [anon_sym_BSLASHtimes] = ACTIONS(5479),
    [anon_sym_u00d7] = ACTIONS(5479),
    [anon_sym_BSLASHwr] = ACTIONS(5479),
    [anon_sym_u2240] = ACTIONS(5479),
    [anon_sym_BSLASHcdot] = ACTIONS(5479),
    [anon_sym_u22c5] = ACTIONS(5479),
    [sym_pow] = ACTIONS(5477),
    [sym_powpow] = ACTIONS(5479),
    [anon_sym_CARET_PLUS] = ACTIONS(5479),
    [anon_sym_u207a] = ACTIONS(5479),
    [sym_asterisk] = ACTIONS(5479),
    [sym_sup_hash] = ACTIONS(5479),
    [sym_prime] = ACTIONS(5479),
    [sym__indent] = ACTIONS(5479),
    [sym__double_excl] = ACTIONS(5479),
  },
  [2168] = {
    [sym_block_comment] = STATE(2168),
    [sym_identifier] = ACTIONS(5481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5481),
    [anon_sym_u2208] = ACTIONS(5483),
    [anon_sym_BSLASHA] = ACTIONS(5481),
    [anon_sym_BSLASHforall] = ACTIONS(5483),
    [anon_sym_u2200] = ACTIONS(5483),
    [anon_sym_BSLASHE] = ACTIONS(5481),
    [anon_sym_BSLASHexists] = ACTIONS(5483),
    [anon_sym_u2203] = ACTIONS(5483),
    [sym_temporal_forall] = ACTIONS(5483),
    [sym_temporal_exists] = ACTIONS(5483),
    [anon_sym_LT_LT] = ACTIONS(5483),
    [anon_sym_u3008] = ACTIONS(5483),
    [anon_sym_u27e8] = ACTIONS(5483),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5483),
    [anon_sym_u25a1] = ACTIONS(5483),
    [anon_sym_AT] = ACTIONS(5481),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5483),
    [anon_sym_u2227] = ACTIONS(5483),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5483),
    [anon_sym_u2228] = ACTIONS(5483),
    [anon_sym_LPAREN] = ACTIONS(5481),
    [anon_sym_LBRACK] = ACTIONS(5481),
    [aux_sym_child_id_token1] = ACTIONS(5481),
    [sym_real_number] = ACTIONS(5483),
    [anon_sym_BSLASHb] = ACTIONS(5481),
    [anon_sym_BSLASHB] = ACTIONS(5483),
    [anon_sym_BSLASHo] = ACTIONS(5481),
    [anon_sym_BSLASHO] = ACTIONS(5483),
    [anon_sym_BSLASHh] = ACTIONS(5483),
    [anon_sym_BSLASHH] = ACTIONS(5483),
    [anon_sym_DQUOTE] = ACTIONS(5483),
    [anon_sym_TRUE] = ACTIONS(5481),
    [anon_sym_FALSE] = ACTIONS(5481),
    [sym_string_set] = ACTIONS(5481),
    [sym_boolean_set] = ACTIONS(5481),
    [anon_sym_Nat] = ACTIONS(5481),
    [anon_sym_u2115] = ACTIONS(5483),
    [anon_sym_Int] = ACTIONS(5481),
    [anon_sym_u2124] = ACTIONS(5483),
    [anon_sym_Real] = ACTIONS(5481),
    [anon_sym_u211d] = ACTIONS(5483),
    [anon_sym_CHOOSE] = ACTIONS(5481),
    [anon_sym_LBRACE] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5481),
    [anon_sym_WF_] = ACTIONS(5481),
    [anon_sym_SF_] = ACTIONS(5481),
    [anon_sym_IF] = ACTIONS(5481),
    [anon_sym_CASE] = ACTIONS(5481),
    [anon_sym_LET] = ACTIONS(5481),
    [anon_sym_BSLASHlnot] = ACTIONS(5483),
    [anon_sym_BSLASHneg] = ACTIONS(5483),
    [anon_sym_TILDE] = ACTIONS(5481),
    [anon_sym_u00ac] = ACTIONS(5483),
    [sym_union] = ACTIONS(5481),
    [sym_powerset] = ACTIONS(5481),
    [sym_domain] = ACTIONS(5481),
    [anon_sym_DASH] = ACTIONS(5481),
    [sym_negative_dot] = ACTIONS(5483),
    [sym_enabled] = ACTIONS(5481),
    [sym_unchanged] = ACTIONS(5481),
    [anon_sym_LT_GT] = ACTIONS(5483),
    [anon_sym_u22c4] = ACTIONS(5483),
    [anon_sym_u25c7] = ACTIONS(5483),
    [anon_sym_EQ_GT] = ACTIONS(5483),
    [anon_sym_u27f9] = ACTIONS(5483),
    [anon_sym_u21d2] = ACTIONS(5483),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5483),
    [anon_sym_u21f8] = ACTIONS(5483),
    [anon_sym_u2945] = ACTIONS(5483),
    [anon_sym_BSLASHequiv] = ACTIONS(5483),
    [anon_sym_u2261] = ACTIONS(5483),
    [anon_sym_LT_EQ_GT] = ACTIONS(5483),
    [anon_sym_u27fa] = ACTIONS(5483),
    [anon_sym_u21d4] = ACTIONS(5483),
    [anon_sym_TILDE_GT] = ACTIONS(5483),
    [anon_sym_u21dd] = ACTIONS(5483),
    [anon_sym_u219d] = ACTIONS(5483),
    [anon_sym_BSLASHland] = ACTIONS(5483),
    [anon_sym_BSLASHlor] = ACTIONS(5483),
    [anon_sym_COLON_EQ] = ACTIONS(5483),
    [anon_sym_u2254] = ACTIONS(5483),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5483),
    [anon_sym_u2a74] = ACTIONS(5483),
    [anon_sym_SLASH_EQ] = ACTIONS(5483),
    [anon_sym_POUND] = ACTIONS(5481),
    [anon_sym_u2260] = ACTIONS(5483),
    [anon_sym_LT] = ACTIONS(5481),
    [sym_gt] = ACTIONS(5481),
    [anon_sym_LT_EQ] = ACTIONS(5481),
    [anon_sym_EQ_LT] = ACTIONS(5483),
    [anon_sym_BSLASHleq] = ACTIONS(5483),
    [anon_sym_u2264] = ACTIONS(5483),
    [anon_sym_GT_EQ] = ACTIONS(5483),
    [anon_sym_BSLASHgeq] = ACTIONS(5483),
    [anon_sym_u2265] = ACTIONS(5483),
    [anon_sym_BSLASHapprox] = ACTIONS(5483),
    [anon_sym_u2248] = ACTIONS(5483),
    [anon_sym_PIPE_DASH] = ACTIONS(5483),
    [anon_sym_u22a2] = ACTIONS(5483),
    [anon_sym_PIPE_EQ] = ACTIONS(5483),
    [anon_sym_u22a8] = ACTIONS(5483),
    [anon_sym_DASH_PIPE] = ACTIONS(5483),
    [anon_sym_u22a3] = ACTIONS(5483),
    [anon_sym_EQ_PIPE] = ACTIONS(5483),
    [anon_sym_u2ae4] = ACTIONS(5483),
    [anon_sym_BSLASHasymp] = ACTIONS(5483),
    [anon_sym_u224d] = ACTIONS(5483),
    [anon_sym_BSLASHcong] = ACTIONS(5483),
    [anon_sym_u2245] = ACTIONS(5483),
    [anon_sym_BSLASHdoteq] = ACTIONS(5483),
    [anon_sym_u2250] = ACTIONS(5483),
    [anon_sym_BSLASHgg] = ACTIONS(5483),
    [anon_sym_u226b] = ACTIONS(5483),
    [anon_sym_BSLASHll] = ACTIONS(5483),
    [anon_sym_u226a] = ACTIONS(5483),
    [anon_sym_BSLASHnotin] = ACTIONS(5483),
    [anon_sym_u2209] = ACTIONS(5483),
    [anon_sym_BSLASHprec] = ACTIONS(5481),
    [anon_sym_u227a] = ACTIONS(5483),
    [anon_sym_BSLASHsucc] = ACTIONS(5481),
    [anon_sym_u227b] = ACTIONS(5483),
    [anon_sym_BSLASHpreceq] = ACTIONS(5483),
    [anon_sym_u2aaf] = ACTIONS(5483),
    [anon_sym_BSLASHsucceq] = ACTIONS(5483),
    [anon_sym_u2ab0] = ACTIONS(5483),
    [anon_sym_BSLASHpropto] = ACTIONS(5483),
    [anon_sym_u221d] = ACTIONS(5483),
    [anon_sym_BSLASHsim] = ACTIONS(5481),
    [anon_sym_u223c] = ACTIONS(5483),
    [anon_sym_BSLASHsimeq] = ACTIONS(5483),
    [anon_sym_u2243] = ACTIONS(5483),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5481),
    [anon_sym_u228f] = ACTIONS(5483),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5481),
    [anon_sym_u2290] = ACTIONS(5483),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5483),
    [anon_sym_u2291] = ACTIONS(5483),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5483),
    [anon_sym_u2292] = ACTIONS(5483),
    [anon_sym_BSLASHsubset] = ACTIONS(5481),
    [anon_sym_u2282] = ACTIONS(5483),
    [anon_sym_BSLASHsupset] = ACTIONS(5481),
    [anon_sym_u2283] = ACTIONS(5483),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5483),
    [anon_sym_u2286] = ACTIONS(5483),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5483),
    [anon_sym_u2287] = ACTIONS(5483),
    [sym_compose] = ACTIONS(5483),
    [sym_map_to] = ACTIONS(5483),
    [sym_map_from] = ACTIONS(5483),
    [sym_setminus] = ACTIONS(5481),
    [anon_sym_BSLASHcap] = ACTIONS(5483),
    [anon_sym_BSLASHintersect] = ACTIONS(5483),
    [anon_sym_u2229] = ACTIONS(5483),
    [anon_sym_BSLASHcup] = ACTIONS(5483),
    [anon_sym_BSLASHunion] = ACTIONS(5483),
    [anon_sym_u222a] = ACTIONS(5483),
    [anon_sym_DOT_DOT] = ACTIONS(5481),
    [anon_sym_u2025] = ACTIONS(5483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5483),
    [anon_sym_u2026] = ACTIONS(5483),
    [anon_sym_PLUS] = ACTIONS(5481),
    [sym_plusplus] = ACTIONS(5483),
    [anon_sym_BSLASHoplus] = ACTIONS(5483),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5483),
    [anon_sym_u2295] = ACTIONS(5483),
    [anon_sym_BSLASHominus] = ACTIONS(5483),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5483),
    [anon_sym_u2296] = ACTIONS(5483),
    [sym_mod] = ACTIONS(5481),
    [sym_modmod] = ACTIONS(5483),
    [sym_vert] = ACTIONS(5481),
    [anon_sym_PIPE_PIPE] = ACTIONS(5483),
    [anon_sym_u2016] = ACTIONS(5483),
    [sym_minusminus] = ACTIONS(5483),
    [sym_amp] = ACTIONS(5481),
    [sym_ampamp] = ACTIONS(5483),
    [anon_sym_BSLASHodot] = ACTIONS(5483),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5483),
    [anon_sym_u2299] = ACTIONS(5483),
    [anon_sym_BSLASHoslash] = ACTIONS(5483),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5483),
    [anon_sym_u2298] = ACTIONS(5483),
    [anon_sym_BSLASHotimes] = ACTIONS(5483),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5483),
    [anon_sym_u2297] = ACTIONS(5483),
    [sym_mul] = ACTIONS(5481),
    [sym_mulmul] = ACTIONS(5483),
    [sym_slash] = ACTIONS(5481),
    [sym_slashslash] = ACTIONS(5483),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5483),
    [anon_sym_u25ef] = ACTIONS(5483),
    [anon_sym_BSLASHbullet] = ACTIONS(5483),
    [anon_sym_u25cf] = ACTIONS(5483),
    [anon_sym_BSLASHdiv] = ACTIONS(5483),
    [anon_sym_u00f7] = ACTIONS(5483),
    [anon_sym_BSLASHcirc] = ACTIONS(5483),
    [anon_sym_u2218] = ACTIONS(5483),
    [anon_sym_BSLASHstar] = ACTIONS(5483),
    [anon_sym_u22c6] = ACTIONS(5483),
    [anon_sym_u203c] = ACTIONS(5483),
    [sym_hashhash] = ACTIONS(5483),
    [sym_dol] = ACTIONS(5481),
    [sym_doldol] = ACTIONS(5483),
    [anon_sym_QMARK_QMARK] = ACTIONS(5483),
    [anon_sym_u2047] = ACTIONS(5483),
    [anon_sym_BSLASHsqcap] = ACTIONS(5483),
    [anon_sym_u2293] = ACTIONS(5483),
    [anon_sym_BSLASHsqcup] = ACTIONS(5483),
    [anon_sym_u2294] = ACTIONS(5483),
    [anon_sym_BSLASHuplus] = ACTIONS(5483),
    [anon_sym_u228e] = ACTIONS(5483),
    [anon_sym_BSLASHX] = ACTIONS(5483),
    [anon_sym_BSLASHtimes] = ACTIONS(5483),
    [anon_sym_u00d7] = ACTIONS(5483),
    [anon_sym_BSLASHwr] = ACTIONS(5483),
    [anon_sym_u2240] = ACTIONS(5483),
    [anon_sym_BSLASHcdot] = ACTIONS(5483),
    [anon_sym_u22c5] = ACTIONS(5483),
    [sym_pow] = ACTIONS(5481),
    [sym_powpow] = ACTIONS(5483),
    [anon_sym_CARET_PLUS] = ACTIONS(5483),
    [anon_sym_u207a] = ACTIONS(5483),
    [sym_asterisk] = ACTIONS(5483),
    [sym_sup_hash] = ACTIONS(5483),
    [sym_prime] = ACTIONS(5483),
    [sym__indent] = ACTIONS(5483),
    [sym__double_excl] = ACTIONS(5483),
  },
  [2169] = {
    [sym_block_comment] = STATE(2169),
    [sym_identifier] = ACTIONS(5485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5485),
    [anon_sym_u2208] = ACTIONS(5487),
    [anon_sym_BSLASHA] = ACTIONS(5485),
    [anon_sym_BSLASHforall] = ACTIONS(5487),
    [anon_sym_u2200] = ACTIONS(5487),
    [anon_sym_BSLASHE] = ACTIONS(5485),
    [anon_sym_BSLASHexists] = ACTIONS(5487),
    [anon_sym_u2203] = ACTIONS(5487),
    [sym_temporal_forall] = ACTIONS(5487),
    [sym_temporal_exists] = ACTIONS(5487),
    [anon_sym_LT_LT] = ACTIONS(5487),
    [anon_sym_u3008] = ACTIONS(5487),
    [anon_sym_u27e8] = ACTIONS(5487),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5487),
    [anon_sym_u25a1] = ACTIONS(5487),
    [anon_sym_AT] = ACTIONS(5485),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5487),
    [anon_sym_u2227] = ACTIONS(5487),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5487),
    [anon_sym_u2228] = ACTIONS(5487),
    [anon_sym_LPAREN] = ACTIONS(5485),
    [anon_sym_LBRACK] = ACTIONS(5485),
    [aux_sym_child_id_token1] = ACTIONS(5485),
    [sym_real_number] = ACTIONS(5487),
    [anon_sym_BSLASHb] = ACTIONS(5485),
    [anon_sym_BSLASHB] = ACTIONS(5487),
    [anon_sym_BSLASHo] = ACTIONS(5485),
    [anon_sym_BSLASHO] = ACTIONS(5487),
    [anon_sym_BSLASHh] = ACTIONS(5487),
    [anon_sym_BSLASHH] = ACTIONS(5487),
    [anon_sym_DQUOTE] = ACTIONS(5487),
    [anon_sym_TRUE] = ACTIONS(5485),
    [anon_sym_FALSE] = ACTIONS(5485),
    [sym_string_set] = ACTIONS(5485),
    [sym_boolean_set] = ACTIONS(5485),
    [anon_sym_Nat] = ACTIONS(5485),
    [anon_sym_u2115] = ACTIONS(5487),
    [anon_sym_Int] = ACTIONS(5485),
    [anon_sym_u2124] = ACTIONS(5487),
    [anon_sym_Real] = ACTIONS(5485),
    [anon_sym_u211d] = ACTIONS(5487),
    [anon_sym_CHOOSE] = ACTIONS(5485),
    [anon_sym_LBRACE] = ACTIONS(5487),
    [anon_sym_EQ] = ACTIONS(5485),
    [anon_sym_WF_] = ACTIONS(5485),
    [anon_sym_SF_] = ACTIONS(5485),
    [anon_sym_IF] = ACTIONS(5485),
    [anon_sym_CASE] = ACTIONS(5485),
    [anon_sym_LET] = ACTIONS(5485),
    [anon_sym_BSLASHlnot] = ACTIONS(5487),
    [anon_sym_BSLASHneg] = ACTIONS(5487),
    [anon_sym_TILDE] = ACTIONS(5485),
    [anon_sym_u00ac] = ACTIONS(5487),
    [sym_union] = ACTIONS(5485),
    [sym_powerset] = ACTIONS(5485),
    [sym_domain] = ACTIONS(5485),
    [anon_sym_DASH] = ACTIONS(5485),
    [sym_negative_dot] = ACTIONS(5487),
    [sym_enabled] = ACTIONS(5485),
    [sym_unchanged] = ACTIONS(5485),
    [anon_sym_LT_GT] = ACTIONS(5487),
    [anon_sym_u22c4] = ACTIONS(5487),
    [anon_sym_u25c7] = ACTIONS(5487),
    [anon_sym_EQ_GT] = ACTIONS(5487),
    [anon_sym_u27f9] = ACTIONS(5487),
    [anon_sym_u21d2] = ACTIONS(5487),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5487),
    [anon_sym_u21f8] = ACTIONS(5487),
    [anon_sym_u2945] = ACTIONS(5487),
    [anon_sym_BSLASHequiv] = ACTIONS(5487),
    [anon_sym_u2261] = ACTIONS(5487),
    [anon_sym_LT_EQ_GT] = ACTIONS(5487),
    [anon_sym_u27fa] = ACTIONS(5487),
    [anon_sym_u21d4] = ACTIONS(5487),
    [anon_sym_TILDE_GT] = ACTIONS(5487),
    [anon_sym_u21dd] = ACTIONS(5487),
    [anon_sym_u219d] = ACTIONS(5487),
    [anon_sym_BSLASHland] = ACTIONS(5487),
    [anon_sym_BSLASHlor] = ACTIONS(5487),
    [anon_sym_COLON_EQ] = ACTIONS(5487),
    [anon_sym_u2254] = ACTIONS(5487),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5487),
    [anon_sym_u2a74] = ACTIONS(5487),
    [anon_sym_SLASH_EQ] = ACTIONS(5487),
    [anon_sym_POUND] = ACTIONS(5485),
    [anon_sym_u2260] = ACTIONS(5487),
    [anon_sym_LT] = ACTIONS(5485),
    [sym_gt] = ACTIONS(5485),
    [anon_sym_LT_EQ] = ACTIONS(5485),
    [anon_sym_EQ_LT] = ACTIONS(5487),
    [anon_sym_BSLASHleq] = ACTIONS(5487),
    [anon_sym_u2264] = ACTIONS(5487),
    [anon_sym_GT_EQ] = ACTIONS(5487),
    [anon_sym_BSLASHgeq] = ACTIONS(5487),
    [anon_sym_u2265] = ACTIONS(5487),
    [anon_sym_BSLASHapprox] = ACTIONS(5487),
    [anon_sym_u2248] = ACTIONS(5487),
    [anon_sym_PIPE_DASH] = ACTIONS(5487),
    [anon_sym_u22a2] = ACTIONS(5487),
    [anon_sym_PIPE_EQ] = ACTIONS(5487),
    [anon_sym_u22a8] = ACTIONS(5487),
    [anon_sym_DASH_PIPE] = ACTIONS(5487),
    [anon_sym_u22a3] = ACTIONS(5487),
    [anon_sym_EQ_PIPE] = ACTIONS(5487),
    [anon_sym_u2ae4] = ACTIONS(5487),
    [anon_sym_BSLASHasymp] = ACTIONS(5487),
    [anon_sym_u224d] = ACTIONS(5487),
    [anon_sym_BSLASHcong] = ACTIONS(5487),
    [anon_sym_u2245] = ACTIONS(5487),
    [anon_sym_BSLASHdoteq] = ACTIONS(5487),
    [anon_sym_u2250] = ACTIONS(5487),
    [anon_sym_BSLASHgg] = ACTIONS(5487),
    [anon_sym_u226b] = ACTIONS(5487),
    [anon_sym_BSLASHll] = ACTIONS(5487),
    [anon_sym_u226a] = ACTIONS(5487),
    [anon_sym_BSLASHnotin] = ACTIONS(5487),
    [anon_sym_u2209] = ACTIONS(5487),
    [anon_sym_BSLASHprec] = ACTIONS(5485),
    [anon_sym_u227a] = ACTIONS(5487),
    [anon_sym_BSLASHsucc] = ACTIONS(5485),
    [anon_sym_u227b] = ACTIONS(5487),
    [anon_sym_BSLASHpreceq] = ACTIONS(5487),
    [anon_sym_u2aaf] = ACTIONS(5487),
    [anon_sym_BSLASHsucceq] = ACTIONS(5487),
    [anon_sym_u2ab0] = ACTIONS(5487),
    [anon_sym_BSLASHpropto] = ACTIONS(5487),
    [anon_sym_u221d] = ACTIONS(5487),
    [anon_sym_BSLASHsim] = ACTIONS(5485),
    [anon_sym_u223c] = ACTIONS(5487),
    [anon_sym_BSLASHsimeq] = ACTIONS(5487),
    [anon_sym_u2243] = ACTIONS(5487),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5485),
    [anon_sym_u228f] = ACTIONS(5487),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5485),
    [anon_sym_u2290] = ACTIONS(5487),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5487),
    [anon_sym_u2291] = ACTIONS(5487),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5487),
    [anon_sym_u2292] = ACTIONS(5487),
    [anon_sym_BSLASHsubset] = ACTIONS(5485),
    [anon_sym_u2282] = ACTIONS(5487),
    [anon_sym_BSLASHsupset] = ACTIONS(5485),
    [anon_sym_u2283] = ACTIONS(5487),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5487),
    [anon_sym_u2286] = ACTIONS(5487),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5487),
    [anon_sym_u2287] = ACTIONS(5487),
    [sym_compose] = ACTIONS(5487),
    [sym_map_to] = ACTIONS(5487),
    [sym_map_from] = ACTIONS(5487),
    [sym_setminus] = ACTIONS(5485),
    [anon_sym_BSLASHcap] = ACTIONS(5487),
    [anon_sym_BSLASHintersect] = ACTIONS(5487),
    [anon_sym_u2229] = ACTIONS(5487),
    [anon_sym_BSLASHcup] = ACTIONS(5487),
    [anon_sym_BSLASHunion] = ACTIONS(5487),
    [anon_sym_u222a] = ACTIONS(5487),
    [anon_sym_DOT_DOT] = ACTIONS(5485),
    [anon_sym_u2025] = ACTIONS(5487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5487),
    [anon_sym_u2026] = ACTIONS(5487),
    [anon_sym_PLUS] = ACTIONS(5485),
    [sym_plusplus] = ACTIONS(5487),
    [anon_sym_BSLASHoplus] = ACTIONS(5487),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5487),
    [anon_sym_u2295] = ACTIONS(5487),
    [anon_sym_BSLASHominus] = ACTIONS(5487),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5487),
    [anon_sym_u2296] = ACTIONS(5487),
    [sym_mod] = ACTIONS(5485),
    [sym_modmod] = ACTIONS(5487),
    [sym_vert] = ACTIONS(5485),
    [anon_sym_PIPE_PIPE] = ACTIONS(5487),
    [anon_sym_u2016] = ACTIONS(5487),
    [sym_minusminus] = ACTIONS(5487),
    [sym_amp] = ACTIONS(5485),
    [sym_ampamp] = ACTIONS(5487),
    [anon_sym_BSLASHodot] = ACTIONS(5487),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5487),
    [anon_sym_u2299] = ACTIONS(5487),
    [anon_sym_BSLASHoslash] = ACTIONS(5487),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5487),
    [anon_sym_u2298] = ACTIONS(5487),
    [anon_sym_BSLASHotimes] = ACTIONS(5487),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5487),
    [anon_sym_u2297] = ACTIONS(5487),
    [sym_mul] = ACTIONS(5485),
    [sym_mulmul] = ACTIONS(5487),
    [sym_slash] = ACTIONS(5485),
    [sym_slashslash] = ACTIONS(5487),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5487),
    [anon_sym_u25ef] = ACTIONS(5487),
    [anon_sym_BSLASHbullet] = ACTIONS(5487),
    [anon_sym_u25cf] = ACTIONS(5487),
    [anon_sym_BSLASHdiv] = ACTIONS(5487),
    [anon_sym_u00f7] = ACTIONS(5487),
    [anon_sym_BSLASHcirc] = ACTIONS(5487),
    [anon_sym_u2218] = ACTIONS(5487),
    [anon_sym_BSLASHstar] = ACTIONS(5487),
    [anon_sym_u22c6] = ACTIONS(5487),
    [anon_sym_u203c] = ACTIONS(5487),
    [sym_hashhash] = ACTIONS(5487),
    [sym_dol] = ACTIONS(5485),
    [sym_doldol] = ACTIONS(5487),
    [anon_sym_QMARK_QMARK] = ACTIONS(5487),
    [anon_sym_u2047] = ACTIONS(5487),
    [anon_sym_BSLASHsqcap] = ACTIONS(5487),
    [anon_sym_u2293] = ACTIONS(5487),
    [anon_sym_BSLASHsqcup] = ACTIONS(5487),
    [anon_sym_u2294] = ACTIONS(5487),
    [anon_sym_BSLASHuplus] = ACTIONS(5487),
    [anon_sym_u228e] = ACTIONS(5487),
    [anon_sym_BSLASHX] = ACTIONS(5487),
    [anon_sym_BSLASHtimes] = ACTIONS(5487),
    [anon_sym_u00d7] = ACTIONS(5487),
    [anon_sym_BSLASHwr] = ACTIONS(5487),
    [anon_sym_u2240] = ACTIONS(5487),
    [anon_sym_BSLASHcdot] = ACTIONS(5487),
    [anon_sym_u22c5] = ACTIONS(5487),
    [sym_pow] = ACTIONS(5485),
    [sym_powpow] = ACTIONS(5487),
    [anon_sym_CARET_PLUS] = ACTIONS(5487),
    [anon_sym_u207a] = ACTIONS(5487),
    [sym_asterisk] = ACTIONS(5487),
    [sym_sup_hash] = ACTIONS(5487),
    [sym_prime] = ACTIONS(5487),
    [sym__indent] = ACTIONS(5487),
    [sym__double_excl] = ACTIONS(5487),
  },
  [2170] = {
    [sym_block_comment] = STATE(2170),
    [sym_identifier] = ACTIONS(5489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5489),
    [anon_sym_u2208] = ACTIONS(5491),
    [anon_sym_BSLASHA] = ACTIONS(5489),
    [anon_sym_BSLASHforall] = ACTIONS(5491),
    [anon_sym_u2200] = ACTIONS(5491),
    [anon_sym_BSLASHE] = ACTIONS(5489),
    [anon_sym_BSLASHexists] = ACTIONS(5491),
    [anon_sym_u2203] = ACTIONS(5491),
    [sym_temporal_forall] = ACTIONS(5491),
    [sym_temporal_exists] = ACTIONS(5491),
    [anon_sym_LT_LT] = ACTIONS(5491),
    [anon_sym_u3008] = ACTIONS(5491),
    [anon_sym_u27e8] = ACTIONS(5491),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5491),
    [anon_sym_u25a1] = ACTIONS(5491),
    [anon_sym_AT] = ACTIONS(5489),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5491),
    [anon_sym_u2227] = ACTIONS(5491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5491),
    [anon_sym_u2228] = ACTIONS(5491),
    [anon_sym_LPAREN] = ACTIONS(5489),
    [anon_sym_LBRACK] = ACTIONS(5489),
    [aux_sym_child_id_token1] = ACTIONS(5489),
    [sym_real_number] = ACTIONS(5491),
    [anon_sym_BSLASHb] = ACTIONS(5489),
    [anon_sym_BSLASHB] = ACTIONS(5491),
    [anon_sym_BSLASHo] = ACTIONS(5489),
    [anon_sym_BSLASHO] = ACTIONS(5491),
    [anon_sym_BSLASHh] = ACTIONS(5491),
    [anon_sym_BSLASHH] = ACTIONS(5491),
    [anon_sym_DQUOTE] = ACTIONS(5491),
    [anon_sym_TRUE] = ACTIONS(5489),
    [anon_sym_FALSE] = ACTIONS(5489),
    [sym_string_set] = ACTIONS(5489),
    [sym_boolean_set] = ACTIONS(5489),
    [anon_sym_Nat] = ACTIONS(5489),
    [anon_sym_u2115] = ACTIONS(5491),
    [anon_sym_Int] = ACTIONS(5489),
    [anon_sym_u2124] = ACTIONS(5491),
    [anon_sym_Real] = ACTIONS(5489),
    [anon_sym_u211d] = ACTIONS(5491),
    [anon_sym_CHOOSE] = ACTIONS(5489),
    [anon_sym_LBRACE] = ACTIONS(5491),
    [anon_sym_EQ] = ACTIONS(5489),
    [anon_sym_WF_] = ACTIONS(5489),
    [anon_sym_SF_] = ACTIONS(5489),
    [anon_sym_IF] = ACTIONS(5489),
    [anon_sym_CASE] = ACTIONS(5489),
    [anon_sym_LET] = ACTIONS(5489),
    [anon_sym_BSLASHlnot] = ACTIONS(5491),
    [anon_sym_BSLASHneg] = ACTIONS(5491),
    [anon_sym_TILDE] = ACTIONS(5489),
    [anon_sym_u00ac] = ACTIONS(5491),
    [sym_union] = ACTIONS(5489),
    [sym_powerset] = ACTIONS(5489),
    [sym_domain] = ACTIONS(5489),
    [anon_sym_DASH] = ACTIONS(5489),
    [sym_negative_dot] = ACTIONS(5491),
    [sym_enabled] = ACTIONS(5489),
    [sym_unchanged] = ACTIONS(5489),
    [anon_sym_LT_GT] = ACTIONS(5491),
    [anon_sym_u22c4] = ACTIONS(5491),
    [anon_sym_u25c7] = ACTIONS(5491),
    [anon_sym_EQ_GT] = ACTIONS(5491),
    [anon_sym_u27f9] = ACTIONS(5491),
    [anon_sym_u21d2] = ACTIONS(5491),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5491),
    [anon_sym_u21f8] = ACTIONS(5491),
    [anon_sym_u2945] = ACTIONS(5491),
    [anon_sym_BSLASHequiv] = ACTIONS(5491),
    [anon_sym_u2261] = ACTIONS(5491),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_u27fa] = ACTIONS(5491),
    [anon_sym_u21d4] = ACTIONS(5491),
    [anon_sym_TILDE_GT] = ACTIONS(5491),
    [anon_sym_u21dd] = ACTIONS(5491),
    [anon_sym_u219d] = ACTIONS(5491),
    [anon_sym_BSLASHland] = ACTIONS(5491),
    [anon_sym_BSLASHlor] = ACTIONS(5491),
    [anon_sym_COLON_EQ] = ACTIONS(5491),
    [anon_sym_u2254] = ACTIONS(5491),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5491),
    [anon_sym_u2a74] = ACTIONS(5491),
    [anon_sym_SLASH_EQ] = ACTIONS(5491),
    [anon_sym_POUND] = ACTIONS(5489),
    [anon_sym_u2260] = ACTIONS(5491),
    [anon_sym_LT] = ACTIONS(5489),
    [sym_gt] = ACTIONS(5489),
    [anon_sym_LT_EQ] = ACTIONS(5489),
    [anon_sym_EQ_LT] = ACTIONS(5491),
    [anon_sym_BSLASHleq] = ACTIONS(5491),
    [anon_sym_u2264] = ACTIONS(5491),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_BSLASHgeq] = ACTIONS(5491),
    [anon_sym_u2265] = ACTIONS(5491),
    [anon_sym_BSLASHapprox] = ACTIONS(5491),
    [anon_sym_u2248] = ACTIONS(5491),
    [anon_sym_PIPE_DASH] = ACTIONS(5491),
    [anon_sym_u22a2] = ACTIONS(5491),
    [anon_sym_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_u22a8] = ACTIONS(5491),
    [anon_sym_DASH_PIPE] = ACTIONS(5491),
    [anon_sym_u22a3] = ACTIONS(5491),
    [anon_sym_EQ_PIPE] = ACTIONS(5491),
    [anon_sym_u2ae4] = ACTIONS(5491),
    [anon_sym_BSLASHasymp] = ACTIONS(5491),
    [anon_sym_u224d] = ACTIONS(5491),
    [anon_sym_BSLASHcong] = ACTIONS(5491),
    [anon_sym_u2245] = ACTIONS(5491),
    [anon_sym_BSLASHdoteq] = ACTIONS(5491),
    [anon_sym_u2250] = ACTIONS(5491),
    [anon_sym_BSLASHgg] = ACTIONS(5491),
    [anon_sym_u226b] = ACTIONS(5491),
    [anon_sym_BSLASHll] = ACTIONS(5491),
    [anon_sym_u226a] = ACTIONS(5491),
    [anon_sym_BSLASHnotin] = ACTIONS(5491),
    [anon_sym_u2209] = ACTIONS(5491),
    [anon_sym_BSLASHprec] = ACTIONS(5489),
    [anon_sym_u227a] = ACTIONS(5491),
    [anon_sym_BSLASHsucc] = ACTIONS(5489),
    [anon_sym_u227b] = ACTIONS(5491),
    [anon_sym_BSLASHpreceq] = ACTIONS(5491),
    [anon_sym_u2aaf] = ACTIONS(5491),
    [anon_sym_BSLASHsucceq] = ACTIONS(5491),
    [anon_sym_u2ab0] = ACTIONS(5491),
    [anon_sym_BSLASHpropto] = ACTIONS(5491),
    [anon_sym_u221d] = ACTIONS(5491),
    [anon_sym_BSLASHsim] = ACTIONS(5489),
    [anon_sym_u223c] = ACTIONS(5491),
    [anon_sym_BSLASHsimeq] = ACTIONS(5491),
    [anon_sym_u2243] = ACTIONS(5491),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5489),
    [anon_sym_u228f] = ACTIONS(5491),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5489),
    [anon_sym_u2290] = ACTIONS(5491),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5491),
    [anon_sym_u2291] = ACTIONS(5491),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5491),
    [anon_sym_u2292] = ACTIONS(5491),
    [anon_sym_BSLASHsubset] = ACTIONS(5489),
    [anon_sym_u2282] = ACTIONS(5491),
    [anon_sym_BSLASHsupset] = ACTIONS(5489),
    [anon_sym_u2283] = ACTIONS(5491),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5491),
    [anon_sym_u2286] = ACTIONS(5491),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5491),
    [anon_sym_u2287] = ACTIONS(5491),
    [sym_compose] = ACTIONS(5491),
    [sym_map_to] = ACTIONS(5491),
    [sym_map_from] = ACTIONS(5491),
    [sym_setminus] = ACTIONS(5489),
    [anon_sym_BSLASHcap] = ACTIONS(5491),
    [anon_sym_BSLASHintersect] = ACTIONS(5491),
    [anon_sym_u2229] = ACTIONS(5491),
    [anon_sym_BSLASHcup] = ACTIONS(5491),
    [anon_sym_BSLASHunion] = ACTIONS(5491),
    [anon_sym_u222a] = ACTIONS(5491),
    [anon_sym_DOT_DOT] = ACTIONS(5489),
    [anon_sym_u2025] = ACTIONS(5491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_u2026] = ACTIONS(5491),
    [anon_sym_PLUS] = ACTIONS(5489),
    [sym_plusplus] = ACTIONS(5491),
    [anon_sym_BSLASHoplus] = ACTIONS(5491),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5491),
    [anon_sym_u2295] = ACTIONS(5491),
    [anon_sym_BSLASHominus] = ACTIONS(5491),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5491),
    [anon_sym_u2296] = ACTIONS(5491),
    [sym_mod] = ACTIONS(5489),
    [sym_modmod] = ACTIONS(5491),
    [sym_vert] = ACTIONS(5489),
    [anon_sym_PIPE_PIPE] = ACTIONS(5491),
    [anon_sym_u2016] = ACTIONS(5491),
    [sym_minusminus] = ACTIONS(5491),
    [sym_amp] = ACTIONS(5489),
    [sym_ampamp] = ACTIONS(5491),
    [anon_sym_BSLASHodot] = ACTIONS(5491),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5491),
    [anon_sym_u2299] = ACTIONS(5491),
    [anon_sym_BSLASHoslash] = ACTIONS(5491),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5491),
    [anon_sym_u2298] = ACTIONS(5491),
    [anon_sym_BSLASHotimes] = ACTIONS(5491),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5491),
    [anon_sym_u2297] = ACTIONS(5491),
    [sym_mul] = ACTIONS(5489),
    [sym_mulmul] = ACTIONS(5491),
    [sym_slash] = ACTIONS(5489),
    [sym_slashslash] = ACTIONS(5491),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5491),
    [anon_sym_u25ef] = ACTIONS(5491),
    [anon_sym_BSLASHbullet] = ACTIONS(5491),
    [anon_sym_u25cf] = ACTIONS(5491),
    [anon_sym_BSLASHdiv] = ACTIONS(5491),
    [anon_sym_u00f7] = ACTIONS(5491),
    [anon_sym_BSLASHcirc] = ACTIONS(5491),
    [anon_sym_u2218] = ACTIONS(5491),
    [anon_sym_BSLASHstar] = ACTIONS(5491),
    [anon_sym_u22c6] = ACTIONS(5491),
    [anon_sym_u203c] = ACTIONS(5491),
    [sym_hashhash] = ACTIONS(5491),
    [sym_dol] = ACTIONS(5489),
    [sym_doldol] = ACTIONS(5491),
    [anon_sym_QMARK_QMARK] = ACTIONS(5491),
    [anon_sym_u2047] = ACTIONS(5491),
    [anon_sym_BSLASHsqcap] = ACTIONS(5491),
    [anon_sym_u2293] = ACTIONS(5491),
    [anon_sym_BSLASHsqcup] = ACTIONS(5491),
    [anon_sym_u2294] = ACTIONS(5491),
    [anon_sym_BSLASHuplus] = ACTIONS(5491),
    [anon_sym_u228e] = ACTIONS(5491),
    [anon_sym_BSLASHX] = ACTIONS(5491),
    [anon_sym_BSLASHtimes] = ACTIONS(5491),
    [anon_sym_u00d7] = ACTIONS(5491),
    [anon_sym_BSLASHwr] = ACTIONS(5491),
    [anon_sym_u2240] = ACTIONS(5491),
    [anon_sym_BSLASHcdot] = ACTIONS(5491),
    [anon_sym_u22c5] = ACTIONS(5491),
    [sym_pow] = ACTIONS(5489),
    [sym_powpow] = ACTIONS(5491),
    [anon_sym_CARET_PLUS] = ACTIONS(5491),
    [anon_sym_u207a] = ACTIONS(5491),
    [sym_asterisk] = ACTIONS(5491),
    [sym_sup_hash] = ACTIONS(5491),
    [sym_prime] = ACTIONS(5491),
    [sym__indent] = ACTIONS(5491),
    [sym__double_excl] = ACTIONS(5491),
  },
  [2171] = {
    [sym_block_comment] = STATE(2171),
    [sym_identifier] = ACTIONS(5493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5493),
    [anon_sym_u2208] = ACTIONS(5495),
    [anon_sym_BSLASHA] = ACTIONS(5493),
    [anon_sym_BSLASHforall] = ACTIONS(5495),
    [anon_sym_u2200] = ACTIONS(5495),
    [anon_sym_BSLASHE] = ACTIONS(5493),
    [anon_sym_BSLASHexists] = ACTIONS(5495),
    [anon_sym_u2203] = ACTIONS(5495),
    [sym_temporal_forall] = ACTIONS(5495),
    [sym_temporal_exists] = ACTIONS(5495),
    [anon_sym_LT_LT] = ACTIONS(5495),
    [anon_sym_u3008] = ACTIONS(5495),
    [anon_sym_u27e8] = ACTIONS(5495),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5495),
    [anon_sym_u25a1] = ACTIONS(5495),
    [anon_sym_AT] = ACTIONS(5493),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5495),
    [anon_sym_u2227] = ACTIONS(5495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5495),
    [anon_sym_u2228] = ACTIONS(5495),
    [anon_sym_LPAREN] = ACTIONS(5493),
    [anon_sym_LBRACK] = ACTIONS(5493),
    [aux_sym_child_id_token1] = ACTIONS(5493),
    [sym_real_number] = ACTIONS(5495),
    [anon_sym_BSLASHb] = ACTIONS(5493),
    [anon_sym_BSLASHB] = ACTIONS(5495),
    [anon_sym_BSLASHo] = ACTIONS(5493),
    [anon_sym_BSLASHO] = ACTIONS(5495),
    [anon_sym_BSLASHh] = ACTIONS(5495),
    [anon_sym_BSLASHH] = ACTIONS(5495),
    [anon_sym_DQUOTE] = ACTIONS(5495),
    [anon_sym_TRUE] = ACTIONS(5493),
    [anon_sym_FALSE] = ACTIONS(5493),
    [sym_string_set] = ACTIONS(5493),
    [sym_boolean_set] = ACTIONS(5493),
    [anon_sym_Nat] = ACTIONS(5493),
    [anon_sym_u2115] = ACTIONS(5495),
    [anon_sym_Int] = ACTIONS(5493),
    [anon_sym_u2124] = ACTIONS(5495),
    [anon_sym_Real] = ACTIONS(5493),
    [anon_sym_u211d] = ACTIONS(5495),
    [anon_sym_CHOOSE] = ACTIONS(5493),
    [anon_sym_LBRACE] = ACTIONS(5495),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_WF_] = ACTIONS(5493),
    [anon_sym_SF_] = ACTIONS(5493),
    [anon_sym_IF] = ACTIONS(5493),
    [anon_sym_CASE] = ACTIONS(5493),
    [anon_sym_LET] = ACTIONS(5493),
    [anon_sym_BSLASHlnot] = ACTIONS(5495),
    [anon_sym_BSLASHneg] = ACTIONS(5495),
    [anon_sym_TILDE] = ACTIONS(5493),
    [anon_sym_u00ac] = ACTIONS(5495),
    [sym_union] = ACTIONS(5493),
    [sym_powerset] = ACTIONS(5493),
    [sym_domain] = ACTIONS(5493),
    [anon_sym_DASH] = ACTIONS(5493),
    [sym_negative_dot] = ACTIONS(5495),
    [sym_enabled] = ACTIONS(5493),
    [sym_unchanged] = ACTIONS(5493),
    [anon_sym_LT_GT] = ACTIONS(5495),
    [anon_sym_u22c4] = ACTIONS(5495),
    [anon_sym_u25c7] = ACTIONS(5495),
    [anon_sym_EQ_GT] = ACTIONS(5495),
    [anon_sym_u27f9] = ACTIONS(5495),
    [anon_sym_u21d2] = ACTIONS(5495),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5495),
    [anon_sym_u21f8] = ACTIONS(5495),
    [anon_sym_u2945] = ACTIONS(5495),
    [anon_sym_BSLASHequiv] = ACTIONS(5495),
    [anon_sym_u2261] = ACTIONS(5495),
    [anon_sym_LT_EQ_GT] = ACTIONS(5495),
    [anon_sym_u27fa] = ACTIONS(5495),
    [anon_sym_u21d4] = ACTIONS(5495),
    [anon_sym_TILDE_GT] = ACTIONS(5495),
    [anon_sym_u21dd] = ACTIONS(5495),
    [anon_sym_u219d] = ACTIONS(5495),
    [anon_sym_BSLASHland] = ACTIONS(5495),
    [anon_sym_BSLASHlor] = ACTIONS(5495),
    [anon_sym_COLON_EQ] = ACTIONS(5495),
    [anon_sym_u2254] = ACTIONS(5495),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5495),
    [anon_sym_u2a74] = ACTIONS(5495),
    [anon_sym_SLASH_EQ] = ACTIONS(5495),
    [anon_sym_POUND] = ACTIONS(5493),
    [anon_sym_u2260] = ACTIONS(5495),
    [anon_sym_LT] = ACTIONS(5493),
    [sym_gt] = ACTIONS(5493),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_EQ_LT] = ACTIONS(5495),
    [anon_sym_BSLASHleq] = ACTIONS(5495),
    [anon_sym_u2264] = ACTIONS(5495),
    [anon_sym_GT_EQ] = ACTIONS(5495),
    [anon_sym_BSLASHgeq] = ACTIONS(5495),
    [anon_sym_u2265] = ACTIONS(5495),
    [anon_sym_BSLASHapprox] = ACTIONS(5495),
    [anon_sym_u2248] = ACTIONS(5495),
    [anon_sym_PIPE_DASH] = ACTIONS(5495),
    [anon_sym_u22a2] = ACTIONS(5495),
    [anon_sym_PIPE_EQ] = ACTIONS(5495),
    [anon_sym_u22a8] = ACTIONS(5495),
    [anon_sym_DASH_PIPE] = ACTIONS(5495),
    [anon_sym_u22a3] = ACTIONS(5495),
    [anon_sym_EQ_PIPE] = ACTIONS(5495),
    [anon_sym_u2ae4] = ACTIONS(5495),
    [anon_sym_BSLASHasymp] = ACTIONS(5495),
    [anon_sym_u224d] = ACTIONS(5495),
    [anon_sym_BSLASHcong] = ACTIONS(5495),
    [anon_sym_u2245] = ACTIONS(5495),
    [anon_sym_BSLASHdoteq] = ACTIONS(5495),
    [anon_sym_u2250] = ACTIONS(5495),
    [anon_sym_BSLASHgg] = ACTIONS(5495),
    [anon_sym_u226b] = ACTIONS(5495),
    [anon_sym_BSLASHll] = ACTIONS(5495),
    [anon_sym_u226a] = ACTIONS(5495),
    [anon_sym_BSLASHnotin] = ACTIONS(5495),
    [anon_sym_u2209] = ACTIONS(5495),
    [anon_sym_BSLASHprec] = ACTIONS(5493),
    [anon_sym_u227a] = ACTIONS(5495),
    [anon_sym_BSLASHsucc] = ACTIONS(5493),
    [anon_sym_u227b] = ACTIONS(5495),
    [anon_sym_BSLASHpreceq] = ACTIONS(5495),
    [anon_sym_u2aaf] = ACTIONS(5495),
    [anon_sym_BSLASHsucceq] = ACTIONS(5495),
    [anon_sym_u2ab0] = ACTIONS(5495),
    [anon_sym_BSLASHpropto] = ACTIONS(5495),
    [anon_sym_u221d] = ACTIONS(5495),
    [anon_sym_BSLASHsim] = ACTIONS(5493),
    [anon_sym_u223c] = ACTIONS(5495),
    [anon_sym_BSLASHsimeq] = ACTIONS(5495),
    [anon_sym_u2243] = ACTIONS(5495),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5493),
    [anon_sym_u228f] = ACTIONS(5495),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5493),
    [anon_sym_u2290] = ACTIONS(5495),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5495),
    [anon_sym_u2291] = ACTIONS(5495),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5495),
    [anon_sym_u2292] = ACTIONS(5495),
    [anon_sym_BSLASHsubset] = ACTIONS(5493),
    [anon_sym_u2282] = ACTIONS(5495),
    [anon_sym_BSLASHsupset] = ACTIONS(5493),
    [anon_sym_u2283] = ACTIONS(5495),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5495),
    [anon_sym_u2286] = ACTIONS(5495),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5495),
    [anon_sym_u2287] = ACTIONS(5495),
    [sym_compose] = ACTIONS(5495),
    [sym_map_to] = ACTIONS(5495),
    [sym_map_from] = ACTIONS(5495),
    [sym_setminus] = ACTIONS(5493),
    [anon_sym_BSLASHcap] = ACTIONS(5495),
    [anon_sym_BSLASHintersect] = ACTIONS(5495),
    [anon_sym_u2229] = ACTIONS(5495),
    [anon_sym_BSLASHcup] = ACTIONS(5495),
    [anon_sym_BSLASHunion] = ACTIONS(5495),
    [anon_sym_u222a] = ACTIONS(5495),
    [anon_sym_DOT_DOT] = ACTIONS(5493),
    [anon_sym_u2025] = ACTIONS(5495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5495),
    [anon_sym_u2026] = ACTIONS(5495),
    [anon_sym_PLUS] = ACTIONS(5493),
    [sym_plusplus] = ACTIONS(5495),
    [anon_sym_BSLASHoplus] = ACTIONS(5495),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5495),
    [anon_sym_u2295] = ACTIONS(5495),
    [anon_sym_BSLASHominus] = ACTIONS(5495),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5495),
    [anon_sym_u2296] = ACTIONS(5495),
    [sym_mod] = ACTIONS(5493),
    [sym_modmod] = ACTIONS(5495),
    [sym_vert] = ACTIONS(5493),
    [anon_sym_PIPE_PIPE] = ACTIONS(5495),
    [anon_sym_u2016] = ACTIONS(5495),
    [sym_minusminus] = ACTIONS(5495),
    [sym_amp] = ACTIONS(5493),
    [sym_ampamp] = ACTIONS(5495),
    [anon_sym_BSLASHodot] = ACTIONS(5495),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5495),
    [anon_sym_u2299] = ACTIONS(5495),
    [anon_sym_BSLASHoslash] = ACTIONS(5495),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5495),
    [anon_sym_u2298] = ACTIONS(5495),
    [anon_sym_BSLASHotimes] = ACTIONS(5495),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5495),
    [anon_sym_u2297] = ACTIONS(5495),
    [sym_mul] = ACTIONS(5493),
    [sym_mulmul] = ACTIONS(5495),
    [sym_slash] = ACTIONS(5493),
    [sym_slashslash] = ACTIONS(5495),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5495),
    [anon_sym_u25ef] = ACTIONS(5495),
    [anon_sym_BSLASHbullet] = ACTIONS(5495),
    [anon_sym_u25cf] = ACTIONS(5495),
    [anon_sym_BSLASHdiv] = ACTIONS(5495),
    [anon_sym_u00f7] = ACTIONS(5495),
    [anon_sym_BSLASHcirc] = ACTIONS(5495),
    [anon_sym_u2218] = ACTIONS(5495),
    [anon_sym_BSLASHstar] = ACTIONS(5495),
    [anon_sym_u22c6] = ACTIONS(5495),
    [anon_sym_u203c] = ACTIONS(5495),
    [sym_hashhash] = ACTIONS(5495),
    [sym_dol] = ACTIONS(5493),
    [sym_doldol] = ACTIONS(5495),
    [anon_sym_QMARK_QMARK] = ACTIONS(5495),
    [anon_sym_u2047] = ACTIONS(5495),
    [anon_sym_BSLASHsqcap] = ACTIONS(5495),
    [anon_sym_u2293] = ACTIONS(5495),
    [anon_sym_BSLASHsqcup] = ACTIONS(5495),
    [anon_sym_u2294] = ACTIONS(5495),
    [anon_sym_BSLASHuplus] = ACTIONS(5495),
    [anon_sym_u228e] = ACTIONS(5495),
    [anon_sym_BSLASHX] = ACTIONS(5495),
    [anon_sym_BSLASHtimes] = ACTIONS(5495),
    [anon_sym_u00d7] = ACTIONS(5495),
    [anon_sym_BSLASHwr] = ACTIONS(5495),
    [anon_sym_u2240] = ACTIONS(5495),
    [anon_sym_BSLASHcdot] = ACTIONS(5495),
    [anon_sym_u22c5] = ACTIONS(5495),
    [sym_pow] = ACTIONS(5493),
    [sym_powpow] = ACTIONS(5495),
    [anon_sym_CARET_PLUS] = ACTIONS(5495),
    [anon_sym_u207a] = ACTIONS(5495),
    [sym_asterisk] = ACTIONS(5495),
    [sym_sup_hash] = ACTIONS(5495),
    [sym_prime] = ACTIONS(5495),
    [sym__indent] = ACTIONS(5495),
    [sym__double_excl] = ACTIONS(5495),
  },
  [2172] = {
    [sym_block_comment] = STATE(2172),
    [sym_identifier] = ACTIONS(5497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5497),
    [anon_sym_u2208] = ACTIONS(5499),
    [anon_sym_BSLASHA] = ACTIONS(5497),
    [anon_sym_BSLASHforall] = ACTIONS(5499),
    [anon_sym_u2200] = ACTIONS(5499),
    [anon_sym_BSLASHE] = ACTIONS(5497),
    [anon_sym_BSLASHexists] = ACTIONS(5499),
    [anon_sym_u2203] = ACTIONS(5499),
    [sym_temporal_forall] = ACTIONS(5499),
    [sym_temporal_exists] = ACTIONS(5499),
    [anon_sym_LT_LT] = ACTIONS(5499),
    [anon_sym_u3008] = ACTIONS(5499),
    [anon_sym_u27e8] = ACTIONS(5499),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5499),
    [anon_sym_u25a1] = ACTIONS(5499),
    [anon_sym_AT] = ACTIONS(5497),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5499),
    [anon_sym_u2227] = ACTIONS(5499),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5499),
    [anon_sym_u2228] = ACTIONS(5499),
    [anon_sym_LPAREN] = ACTIONS(5497),
    [anon_sym_LBRACK] = ACTIONS(5497),
    [aux_sym_child_id_token1] = ACTIONS(5497),
    [sym_real_number] = ACTIONS(5499),
    [anon_sym_BSLASHb] = ACTIONS(5497),
    [anon_sym_BSLASHB] = ACTIONS(5499),
    [anon_sym_BSLASHo] = ACTIONS(5497),
    [anon_sym_BSLASHO] = ACTIONS(5499),
    [anon_sym_BSLASHh] = ACTIONS(5499),
    [anon_sym_BSLASHH] = ACTIONS(5499),
    [anon_sym_DQUOTE] = ACTIONS(5499),
    [anon_sym_TRUE] = ACTIONS(5497),
    [anon_sym_FALSE] = ACTIONS(5497),
    [sym_string_set] = ACTIONS(5497),
    [sym_boolean_set] = ACTIONS(5497),
    [anon_sym_Nat] = ACTIONS(5497),
    [anon_sym_u2115] = ACTIONS(5499),
    [anon_sym_Int] = ACTIONS(5497),
    [anon_sym_u2124] = ACTIONS(5499),
    [anon_sym_Real] = ACTIONS(5497),
    [anon_sym_u211d] = ACTIONS(5499),
    [anon_sym_CHOOSE] = ACTIONS(5497),
    [anon_sym_LBRACE] = ACTIONS(5499),
    [anon_sym_EQ] = ACTIONS(5497),
    [anon_sym_WF_] = ACTIONS(5497),
    [anon_sym_SF_] = ACTIONS(5497),
    [anon_sym_IF] = ACTIONS(5497),
    [anon_sym_CASE] = ACTIONS(5497),
    [anon_sym_LET] = ACTIONS(5497),
    [anon_sym_BSLASHlnot] = ACTIONS(5499),
    [anon_sym_BSLASHneg] = ACTIONS(5499),
    [anon_sym_TILDE] = ACTIONS(5497),
    [anon_sym_u00ac] = ACTIONS(5499),
    [sym_union] = ACTIONS(5497),
    [sym_powerset] = ACTIONS(5497),
    [sym_domain] = ACTIONS(5497),
    [anon_sym_DASH] = ACTIONS(5497),
    [sym_negative_dot] = ACTIONS(5499),
    [sym_enabled] = ACTIONS(5497),
    [sym_unchanged] = ACTIONS(5497),
    [anon_sym_LT_GT] = ACTIONS(5499),
    [anon_sym_u22c4] = ACTIONS(5499),
    [anon_sym_u25c7] = ACTIONS(5499),
    [anon_sym_EQ_GT] = ACTIONS(5499),
    [anon_sym_u27f9] = ACTIONS(5499),
    [anon_sym_u21d2] = ACTIONS(5499),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5499),
    [anon_sym_u21f8] = ACTIONS(5499),
    [anon_sym_u2945] = ACTIONS(5499),
    [anon_sym_BSLASHequiv] = ACTIONS(5499),
    [anon_sym_u2261] = ACTIONS(5499),
    [anon_sym_LT_EQ_GT] = ACTIONS(5499),
    [anon_sym_u27fa] = ACTIONS(5499),
    [anon_sym_u21d4] = ACTIONS(5499),
    [anon_sym_TILDE_GT] = ACTIONS(5499),
    [anon_sym_u21dd] = ACTIONS(5499),
    [anon_sym_u219d] = ACTIONS(5499),
    [anon_sym_BSLASHland] = ACTIONS(5499),
    [anon_sym_BSLASHlor] = ACTIONS(5499),
    [anon_sym_COLON_EQ] = ACTIONS(5499),
    [anon_sym_u2254] = ACTIONS(5499),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5499),
    [anon_sym_u2a74] = ACTIONS(5499),
    [anon_sym_SLASH_EQ] = ACTIONS(5499),
    [anon_sym_POUND] = ACTIONS(5497),
    [anon_sym_u2260] = ACTIONS(5499),
    [anon_sym_LT] = ACTIONS(5497),
    [sym_gt] = ACTIONS(5497),
    [anon_sym_LT_EQ] = ACTIONS(5497),
    [anon_sym_EQ_LT] = ACTIONS(5499),
    [anon_sym_BSLASHleq] = ACTIONS(5499),
    [anon_sym_u2264] = ACTIONS(5499),
    [anon_sym_GT_EQ] = ACTIONS(5499),
    [anon_sym_BSLASHgeq] = ACTIONS(5499),
    [anon_sym_u2265] = ACTIONS(5499),
    [anon_sym_BSLASHapprox] = ACTIONS(5499),
    [anon_sym_u2248] = ACTIONS(5499),
    [anon_sym_PIPE_DASH] = ACTIONS(5499),
    [anon_sym_u22a2] = ACTIONS(5499),
    [anon_sym_PIPE_EQ] = ACTIONS(5499),
    [anon_sym_u22a8] = ACTIONS(5499),
    [anon_sym_DASH_PIPE] = ACTIONS(5499),
    [anon_sym_u22a3] = ACTIONS(5499),
    [anon_sym_EQ_PIPE] = ACTIONS(5499),
    [anon_sym_u2ae4] = ACTIONS(5499),
    [anon_sym_BSLASHasymp] = ACTIONS(5499),
    [anon_sym_u224d] = ACTIONS(5499),
    [anon_sym_BSLASHcong] = ACTIONS(5499),
    [anon_sym_u2245] = ACTIONS(5499),
    [anon_sym_BSLASHdoteq] = ACTIONS(5499),
    [anon_sym_u2250] = ACTIONS(5499),
    [anon_sym_BSLASHgg] = ACTIONS(5499),
    [anon_sym_u226b] = ACTIONS(5499),
    [anon_sym_BSLASHll] = ACTIONS(5499),
    [anon_sym_u226a] = ACTIONS(5499),
    [anon_sym_BSLASHnotin] = ACTIONS(5499),
    [anon_sym_u2209] = ACTIONS(5499),
    [anon_sym_BSLASHprec] = ACTIONS(5497),
    [anon_sym_u227a] = ACTIONS(5499),
    [anon_sym_BSLASHsucc] = ACTIONS(5497),
    [anon_sym_u227b] = ACTIONS(5499),
    [anon_sym_BSLASHpreceq] = ACTIONS(5499),
    [anon_sym_u2aaf] = ACTIONS(5499),
    [anon_sym_BSLASHsucceq] = ACTIONS(5499),
    [anon_sym_u2ab0] = ACTIONS(5499),
    [anon_sym_BSLASHpropto] = ACTIONS(5499),
    [anon_sym_u221d] = ACTIONS(5499),
    [anon_sym_BSLASHsim] = ACTIONS(5497),
    [anon_sym_u223c] = ACTIONS(5499),
    [anon_sym_BSLASHsimeq] = ACTIONS(5499),
    [anon_sym_u2243] = ACTIONS(5499),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5497),
    [anon_sym_u228f] = ACTIONS(5499),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5497),
    [anon_sym_u2290] = ACTIONS(5499),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5499),
    [anon_sym_u2291] = ACTIONS(5499),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5499),
    [anon_sym_u2292] = ACTIONS(5499),
    [anon_sym_BSLASHsubset] = ACTIONS(5497),
    [anon_sym_u2282] = ACTIONS(5499),
    [anon_sym_BSLASHsupset] = ACTIONS(5497),
    [anon_sym_u2283] = ACTIONS(5499),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5499),
    [anon_sym_u2286] = ACTIONS(5499),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5499),
    [anon_sym_u2287] = ACTIONS(5499),
    [sym_compose] = ACTIONS(5499),
    [sym_map_to] = ACTIONS(5499),
    [sym_map_from] = ACTIONS(5499),
    [sym_setminus] = ACTIONS(5497),
    [anon_sym_BSLASHcap] = ACTIONS(5499),
    [anon_sym_BSLASHintersect] = ACTIONS(5499),
    [anon_sym_u2229] = ACTIONS(5499),
    [anon_sym_BSLASHcup] = ACTIONS(5499),
    [anon_sym_BSLASHunion] = ACTIONS(5499),
    [anon_sym_u222a] = ACTIONS(5499),
    [anon_sym_DOT_DOT] = ACTIONS(5497),
    [anon_sym_u2025] = ACTIONS(5499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5499),
    [anon_sym_u2026] = ACTIONS(5499),
    [anon_sym_PLUS] = ACTIONS(5497),
    [sym_plusplus] = ACTIONS(5499),
    [anon_sym_BSLASHoplus] = ACTIONS(5499),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5499),
    [anon_sym_u2295] = ACTIONS(5499),
    [anon_sym_BSLASHominus] = ACTIONS(5499),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5499),
    [anon_sym_u2296] = ACTIONS(5499),
    [sym_mod] = ACTIONS(5497),
    [sym_modmod] = ACTIONS(5499),
    [sym_vert] = ACTIONS(5497),
    [anon_sym_PIPE_PIPE] = ACTIONS(5499),
    [anon_sym_u2016] = ACTIONS(5499),
    [sym_minusminus] = ACTIONS(5499),
    [sym_amp] = ACTIONS(5497),
    [sym_ampamp] = ACTIONS(5499),
    [anon_sym_BSLASHodot] = ACTIONS(5499),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5499),
    [anon_sym_u2299] = ACTIONS(5499),
    [anon_sym_BSLASHoslash] = ACTIONS(5499),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5499),
    [anon_sym_u2298] = ACTIONS(5499),
    [anon_sym_BSLASHotimes] = ACTIONS(5499),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5499),
    [anon_sym_u2297] = ACTIONS(5499),
    [sym_mul] = ACTIONS(5497),
    [sym_mulmul] = ACTIONS(5499),
    [sym_slash] = ACTIONS(5497),
    [sym_slashslash] = ACTIONS(5499),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5499),
    [anon_sym_u25ef] = ACTIONS(5499),
    [anon_sym_BSLASHbullet] = ACTIONS(5499),
    [anon_sym_u25cf] = ACTIONS(5499),
    [anon_sym_BSLASHdiv] = ACTIONS(5499),
    [anon_sym_u00f7] = ACTIONS(5499),
    [anon_sym_BSLASHcirc] = ACTIONS(5499),
    [anon_sym_u2218] = ACTIONS(5499),
    [anon_sym_BSLASHstar] = ACTIONS(5499),
    [anon_sym_u22c6] = ACTIONS(5499),
    [anon_sym_u203c] = ACTIONS(5499),
    [sym_hashhash] = ACTIONS(5499),
    [sym_dol] = ACTIONS(5497),
    [sym_doldol] = ACTIONS(5499),
    [anon_sym_QMARK_QMARK] = ACTIONS(5499),
    [anon_sym_u2047] = ACTIONS(5499),
    [anon_sym_BSLASHsqcap] = ACTIONS(5499),
    [anon_sym_u2293] = ACTIONS(5499),
    [anon_sym_BSLASHsqcup] = ACTIONS(5499),
    [anon_sym_u2294] = ACTIONS(5499),
    [anon_sym_BSLASHuplus] = ACTIONS(5499),
    [anon_sym_u228e] = ACTIONS(5499),
    [anon_sym_BSLASHX] = ACTIONS(5499),
    [anon_sym_BSLASHtimes] = ACTIONS(5499),
    [anon_sym_u00d7] = ACTIONS(5499),
    [anon_sym_BSLASHwr] = ACTIONS(5499),
    [anon_sym_u2240] = ACTIONS(5499),
    [anon_sym_BSLASHcdot] = ACTIONS(5499),
    [anon_sym_u22c5] = ACTIONS(5499),
    [sym_pow] = ACTIONS(5497),
    [sym_powpow] = ACTIONS(5499),
    [anon_sym_CARET_PLUS] = ACTIONS(5499),
    [anon_sym_u207a] = ACTIONS(5499),
    [sym_asterisk] = ACTIONS(5499),
    [sym_sup_hash] = ACTIONS(5499),
    [sym_prime] = ACTIONS(5499),
    [sym__indent] = ACTIONS(5499),
    [sym__double_excl] = ACTIONS(5499),
  },
  [2173] = {
    [sym_block_comment] = STATE(2173),
    [sym_identifier] = ACTIONS(5501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5501),
    [anon_sym_u2208] = ACTIONS(5503),
    [anon_sym_BSLASHA] = ACTIONS(5501),
    [anon_sym_BSLASHforall] = ACTIONS(5503),
    [anon_sym_u2200] = ACTIONS(5503),
    [anon_sym_BSLASHE] = ACTIONS(5501),
    [anon_sym_BSLASHexists] = ACTIONS(5503),
    [anon_sym_u2203] = ACTIONS(5503),
    [sym_temporal_forall] = ACTIONS(5503),
    [sym_temporal_exists] = ACTIONS(5503),
    [anon_sym_LT_LT] = ACTIONS(5503),
    [anon_sym_u3008] = ACTIONS(5503),
    [anon_sym_u27e8] = ACTIONS(5503),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5503),
    [anon_sym_u25a1] = ACTIONS(5503),
    [anon_sym_AT] = ACTIONS(5501),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5503),
    [anon_sym_u2227] = ACTIONS(5503),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5503),
    [anon_sym_u2228] = ACTIONS(5503),
    [anon_sym_LPAREN] = ACTIONS(5501),
    [anon_sym_LBRACK] = ACTIONS(5501),
    [aux_sym_child_id_token1] = ACTIONS(5501),
    [sym_real_number] = ACTIONS(5503),
    [anon_sym_BSLASHb] = ACTIONS(5501),
    [anon_sym_BSLASHB] = ACTIONS(5503),
    [anon_sym_BSLASHo] = ACTIONS(5501),
    [anon_sym_BSLASHO] = ACTIONS(5503),
    [anon_sym_BSLASHh] = ACTIONS(5503),
    [anon_sym_BSLASHH] = ACTIONS(5503),
    [anon_sym_DQUOTE] = ACTIONS(5503),
    [anon_sym_TRUE] = ACTIONS(5501),
    [anon_sym_FALSE] = ACTIONS(5501),
    [sym_string_set] = ACTIONS(5501),
    [sym_boolean_set] = ACTIONS(5501),
    [anon_sym_Nat] = ACTIONS(5501),
    [anon_sym_u2115] = ACTIONS(5503),
    [anon_sym_Int] = ACTIONS(5501),
    [anon_sym_u2124] = ACTIONS(5503),
    [anon_sym_Real] = ACTIONS(5501),
    [anon_sym_u211d] = ACTIONS(5503),
    [anon_sym_CHOOSE] = ACTIONS(5501),
    [anon_sym_LBRACE] = ACTIONS(5503),
    [anon_sym_EQ] = ACTIONS(5501),
    [anon_sym_WF_] = ACTIONS(5501),
    [anon_sym_SF_] = ACTIONS(5501),
    [anon_sym_IF] = ACTIONS(5501),
    [anon_sym_CASE] = ACTIONS(5501),
    [anon_sym_LET] = ACTIONS(5501),
    [anon_sym_BSLASHlnot] = ACTIONS(5503),
    [anon_sym_BSLASHneg] = ACTIONS(5503),
    [anon_sym_TILDE] = ACTIONS(5501),
    [anon_sym_u00ac] = ACTIONS(5503),
    [sym_union] = ACTIONS(5501),
    [sym_powerset] = ACTIONS(5501),
    [sym_domain] = ACTIONS(5501),
    [anon_sym_DASH] = ACTIONS(5501),
    [sym_negative_dot] = ACTIONS(5503),
    [sym_enabled] = ACTIONS(5501),
    [sym_unchanged] = ACTIONS(5501),
    [anon_sym_LT_GT] = ACTIONS(5503),
    [anon_sym_u22c4] = ACTIONS(5503),
    [anon_sym_u25c7] = ACTIONS(5503),
    [anon_sym_EQ_GT] = ACTIONS(5503),
    [anon_sym_u27f9] = ACTIONS(5503),
    [anon_sym_u21d2] = ACTIONS(5503),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5503),
    [anon_sym_u21f8] = ACTIONS(5503),
    [anon_sym_u2945] = ACTIONS(5503),
    [anon_sym_BSLASHequiv] = ACTIONS(5503),
    [anon_sym_u2261] = ACTIONS(5503),
    [anon_sym_LT_EQ_GT] = ACTIONS(5503),
    [anon_sym_u27fa] = ACTIONS(5503),
    [anon_sym_u21d4] = ACTIONS(5503),
    [anon_sym_TILDE_GT] = ACTIONS(5503),
    [anon_sym_u21dd] = ACTIONS(5503),
    [anon_sym_u219d] = ACTIONS(5503),
    [anon_sym_BSLASHland] = ACTIONS(5503),
    [anon_sym_BSLASHlor] = ACTIONS(5503),
    [anon_sym_COLON_EQ] = ACTIONS(5503),
    [anon_sym_u2254] = ACTIONS(5503),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5503),
    [anon_sym_u2a74] = ACTIONS(5503),
    [anon_sym_SLASH_EQ] = ACTIONS(5503),
    [anon_sym_POUND] = ACTIONS(5501),
    [anon_sym_u2260] = ACTIONS(5503),
    [anon_sym_LT] = ACTIONS(5501),
    [sym_gt] = ACTIONS(5501),
    [anon_sym_LT_EQ] = ACTIONS(5501),
    [anon_sym_EQ_LT] = ACTIONS(5503),
    [anon_sym_BSLASHleq] = ACTIONS(5503),
    [anon_sym_u2264] = ACTIONS(5503),
    [anon_sym_GT_EQ] = ACTIONS(5503),
    [anon_sym_BSLASHgeq] = ACTIONS(5503),
    [anon_sym_u2265] = ACTIONS(5503),
    [anon_sym_BSLASHapprox] = ACTIONS(5503),
    [anon_sym_u2248] = ACTIONS(5503),
    [anon_sym_PIPE_DASH] = ACTIONS(5503),
    [anon_sym_u22a2] = ACTIONS(5503),
    [anon_sym_PIPE_EQ] = ACTIONS(5503),
    [anon_sym_u22a8] = ACTIONS(5503),
    [anon_sym_DASH_PIPE] = ACTIONS(5503),
    [anon_sym_u22a3] = ACTIONS(5503),
    [anon_sym_EQ_PIPE] = ACTIONS(5503),
    [anon_sym_u2ae4] = ACTIONS(5503),
    [anon_sym_BSLASHasymp] = ACTIONS(5503),
    [anon_sym_u224d] = ACTIONS(5503),
    [anon_sym_BSLASHcong] = ACTIONS(5503),
    [anon_sym_u2245] = ACTIONS(5503),
    [anon_sym_BSLASHdoteq] = ACTIONS(5503),
    [anon_sym_u2250] = ACTIONS(5503),
    [anon_sym_BSLASHgg] = ACTIONS(5503),
    [anon_sym_u226b] = ACTIONS(5503),
    [anon_sym_BSLASHll] = ACTIONS(5503),
    [anon_sym_u226a] = ACTIONS(5503),
    [anon_sym_BSLASHnotin] = ACTIONS(5503),
    [anon_sym_u2209] = ACTIONS(5503),
    [anon_sym_BSLASHprec] = ACTIONS(5501),
    [anon_sym_u227a] = ACTIONS(5503),
    [anon_sym_BSLASHsucc] = ACTIONS(5501),
    [anon_sym_u227b] = ACTIONS(5503),
    [anon_sym_BSLASHpreceq] = ACTIONS(5503),
    [anon_sym_u2aaf] = ACTIONS(5503),
    [anon_sym_BSLASHsucceq] = ACTIONS(5503),
    [anon_sym_u2ab0] = ACTIONS(5503),
    [anon_sym_BSLASHpropto] = ACTIONS(5503),
    [anon_sym_u221d] = ACTIONS(5503),
    [anon_sym_BSLASHsim] = ACTIONS(5501),
    [anon_sym_u223c] = ACTIONS(5503),
    [anon_sym_BSLASHsimeq] = ACTIONS(5503),
    [anon_sym_u2243] = ACTIONS(5503),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5501),
    [anon_sym_u228f] = ACTIONS(5503),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5501),
    [anon_sym_u2290] = ACTIONS(5503),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5503),
    [anon_sym_u2291] = ACTIONS(5503),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5503),
    [anon_sym_u2292] = ACTIONS(5503),
    [anon_sym_BSLASHsubset] = ACTIONS(5501),
    [anon_sym_u2282] = ACTIONS(5503),
    [anon_sym_BSLASHsupset] = ACTIONS(5501),
    [anon_sym_u2283] = ACTIONS(5503),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5503),
    [anon_sym_u2286] = ACTIONS(5503),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5503),
    [anon_sym_u2287] = ACTIONS(5503),
    [sym_compose] = ACTIONS(5503),
    [sym_map_to] = ACTIONS(5503),
    [sym_map_from] = ACTIONS(5503),
    [sym_setminus] = ACTIONS(5501),
    [anon_sym_BSLASHcap] = ACTIONS(5503),
    [anon_sym_BSLASHintersect] = ACTIONS(5503),
    [anon_sym_u2229] = ACTIONS(5503),
    [anon_sym_BSLASHcup] = ACTIONS(5503),
    [anon_sym_BSLASHunion] = ACTIONS(5503),
    [anon_sym_u222a] = ACTIONS(5503),
    [anon_sym_DOT_DOT] = ACTIONS(5501),
    [anon_sym_u2025] = ACTIONS(5503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5503),
    [anon_sym_u2026] = ACTIONS(5503),
    [anon_sym_PLUS] = ACTIONS(5501),
    [sym_plusplus] = ACTIONS(5503),
    [anon_sym_BSLASHoplus] = ACTIONS(5503),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5503),
    [anon_sym_u2295] = ACTIONS(5503),
    [anon_sym_BSLASHominus] = ACTIONS(5503),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5503),
    [anon_sym_u2296] = ACTIONS(5503),
    [sym_mod] = ACTIONS(5501),
    [sym_modmod] = ACTIONS(5503),
    [sym_vert] = ACTIONS(5501),
    [anon_sym_PIPE_PIPE] = ACTIONS(5503),
    [anon_sym_u2016] = ACTIONS(5503),
    [sym_minusminus] = ACTIONS(5503),
    [sym_amp] = ACTIONS(5501),
    [sym_ampamp] = ACTIONS(5503),
    [anon_sym_BSLASHodot] = ACTIONS(5503),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5503),
    [anon_sym_u2299] = ACTIONS(5503),
    [anon_sym_BSLASHoslash] = ACTIONS(5503),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5503),
    [anon_sym_u2298] = ACTIONS(5503),
    [anon_sym_BSLASHotimes] = ACTIONS(5503),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5503),
    [anon_sym_u2297] = ACTIONS(5503),
    [sym_mul] = ACTIONS(5501),
    [sym_mulmul] = ACTIONS(5503),
    [sym_slash] = ACTIONS(5501),
    [sym_slashslash] = ACTIONS(5503),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5503),
    [anon_sym_u25ef] = ACTIONS(5503),
    [anon_sym_BSLASHbullet] = ACTIONS(5503),
    [anon_sym_u25cf] = ACTIONS(5503),
    [anon_sym_BSLASHdiv] = ACTIONS(5503),
    [anon_sym_u00f7] = ACTIONS(5503),
    [anon_sym_BSLASHcirc] = ACTIONS(5503),
    [anon_sym_u2218] = ACTIONS(5503),
    [anon_sym_BSLASHstar] = ACTIONS(5503),
    [anon_sym_u22c6] = ACTIONS(5503),
    [anon_sym_u203c] = ACTIONS(5503),
    [sym_hashhash] = ACTIONS(5503),
    [sym_dol] = ACTIONS(5501),
    [sym_doldol] = ACTIONS(5503),
    [anon_sym_QMARK_QMARK] = ACTIONS(5503),
    [anon_sym_u2047] = ACTIONS(5503),
    [anon_sym_BSLASHsqcap] = ACTIONS(5503),
    [anon_sym_u2293] = ACTIONS(5503),
    [anon_sym_BSLASHsqcup] = ACTIONS(5503),
    [anon_sym_u2294] = ACTIONS(5503),
    [anon_sym_BSLASHuplus] = ACTIONS(5503),
    [anon_sym_u228e] = ACTIONS(5503),
    [anon_sym_BSLASHX] = ACTIONS(5503),
    [anon_sym_BSLASHtimes] = ACTIONS(5503),
    [anon_sym_u00d7] = ACTIONS(5503),
    [anon_sym_BSLASHwr] = ACTIONS(5503),
    [anon_sym_u2240] = ACTIONS(5503),
    [anon_sym_BSLASHcdot] = ACTIONS(5503),
    [anon_sym_u22c5] = ACTIONS(5503),
    [sym_pow] = ACTIONS(5501),
    [sym_powpow] = ACTIONS(5503),
    [anon_sym_CARET_PLUS] = ACTIONS(5503),
    [anon_sym_u207a] = ACTIONS(5503),
    [sym_asterisk] = ACTIONS(5503),
    [sym_sup_hash] = ACTIONS(5503),
    [sym_prime] = ACTIONS(5503),
    [sym__indent] = ACTIONS(5503),
    [sym__double_excl] = ACTIONS(5503),
  },
  [2174] = {
    [sym_block_comment] = STATE(2174),
    [sym_identifier] = ACTIONS(5505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5505),
    [anon_sym_u2208] = ACTIONS(5507),
    [anon_sym_BSLASHA] = ACTIONS(5505),
    [anon_sym_BSLASHforall] = ACTIONS(5507),
    [anon_sym_u2200] = ACTIONS(5507),
    [anon_sym_BSLASHE] = ACTIONS(5505),
    [anon_sym_BSLASHexists] = ACTIONS(5507),
    [anon_sym_u2203] = ACTIONS(5507),
    [sym_temporal_forall] = ACTIONS(5507),
    [sym_temporal_exists] = ACTIONS(5507),
    [anon_sym_LT_LT] = ACTIONS(5507),
    [anon_sym_u3008] = ACTIONS(5507),
    [anon_sym_u27e8] = ACTIONS(5507),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5507),
    [anon_sym_u25a1] = ACTIONS(5507),
    [anon_sym_AT] = ACTIONS(5505),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5507),
    [anon_sym_u2227] = ACTIONS(5507),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5507),
    [anon_sym_u2228] = ACTIONS(5507),
    [anon_sym_LPAREN] = ACTIONS(5505),
    [anon_sym_LBRACK] = ACTIONS(5505),
    [aux_sym_child_id_token1] = ACTIONS(5505),
    [sym_real_number] = ACTIONS(5507),
    [anon_sym_BSLASHb] = ACTIONS(5505),
    [anon_sym_BSLASHB] = ACTIONS(5507),
    [anon_sym_BSLASHo] = ACTIONS(5505),
    [anon_sym_BSLASHO] = ACTIONS(5507),
    [anon_sym_BSLASHh] = ACTIONS(5507),
    [anon_sym_BSLASHH] = ACTIONS(5507),
    [anon_sym_DQUOTE] = ACTIONS(5507),
    [anon_sym_TRUE] = ACTIONS(5505),
    [anon_sym_FALSE] = ACTIONS(5505),
    [sym_string_set] = ACTIONS(5505),
    [sym_boolean_set] = ACTIONS(5505),
    [anon_sym_Nat] = ACTIONS(5505),
    [anon_sym_u2115] = ACTIONS(5507),
    [anon_sym_Int] = ACTIONS(5505),
    [anon_sym_u2124] = ACTIONS(5507),
    [anon_sym_Real] = ACTIONS(5505),
    [anon_sym_u211d] = ACTIONS(5507),
    [anon_sym_CHOOSE] = ACTIONS(5505),
    [anon_sym_LBRACE] = ACTIONS(5507),
    [anon_sym_EQ] = ACTIONS(5505),
    [anon_sym_WF_] = ACTIONS(5505),
    [anon_sym_SF_] = ACTIONS(5505),
    [anon_sym_IF] = ACTIONS(5505),
    [anon_sym_CASE] = ACTIONS(5505),
    [anon_sym_LET] = ACTIONS(5505),
    [anon_sym_BSLASHlnot] = ACTIONS(5507),
    [anon_sym_BSLASHneg] = ACTIONS(5507),
    [anon_sym_TILDE] = ACTIONS(5505),
    [anon_sym_u00ac] = ACTIONS(5507),
    [sym_union] = ACTIONS(5505),
    [sym_powerset] = ACTIONS(5505),
    [sym_domain] = ACTIONS(5505),
    [anon_sym_DASH] = ACTIONS(5505),
    [sym_negative_dot] = ACTIONS(5507),
    [sym_enabled] = ACTIONS(5505),
    [sym_unchanged] = ACTIONS(5505),
    [anon_sym_LT_GT] = ACTIONS(5507),
    [anon_sym_u22c4] = ACTIONS(5507),
    [anon_sym_u25c7] = ACTIONS(5507),
    [anon_sym_EQ_GT] = ACTIONS(5507),
    [anon_sym_u27f9] = ACTIONS(5507),
    [anon_sym_u21d2] = ACTIONS(5507),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5507),
    [anon_sym_u21f8] = ACTIONS(5507),
    [anon_sym_u2945] = ACTIONS(5507),
    [anon_sym_BSLASHequiv] = ACTIONS(5507),
    [anon_sym_u2261] = ACTIONS(5507),
    [anon_sym_LT_EQ_GT] = ACTIONS(5507),
    [anon_sym_u27fa] = ACTIONS(5507),
    [anon_sym_u21d4] = ACTIONS(5507),
    [anon_sym_TILDE_GT] = ACTIONS(5507),
    [anon_sym_u21dd] = ACTIONS(5507),
    [anon_sym_u219d] = ACTIONS(5507),
    [anon_sym_BSLASHland] = ACTIONS(5507),
    [anon_sym_BSLASHlor] = ACTIONS(5507),
    [anon_sym_COLON_EQ] = ACTIONS(5507),
    [anon_sym_u2254] = ACTIONS(5507),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5507),
    [anon_sym_u2a74] = ACTIONS(5507),
    [anon_sym_SLASH_EQ] = ACTIONS(5507),
    [anon_sym_POUND] = ACTIONS(5505),
    [anon_sym_u2260] = ACTIONS(5507),
    [anon_sym_LT] = ACTIONS(5505),
    [sym_gt] = ACTIONS(5505),
    [anon_sym_LT_EQ] = ACTIONS(5505),
    [anon_sym_EQ_LT] = ACTIONS(5507),
    [anon_sym_BSLASHleq] = ACTIONS(5507),
    [anon_sym_u2264] = ACTIONS(5507),
    [anon_sym_GT_EQ] = ACTIONS(5507),
    [anon_sym_BSLASHgeq] = ACTIONS(5507),
    [anon_sym_u2265] = ACTIONS(5507),
    [anon_sym_BSLASHapprox] = ACTIONS(5507),
    [anon_sym_u2248] = ACTIONS(5507),
    [anon_sym_PIPE_DASH] = ACTIONS(5507),
    [anon_sym_u22a2] = ACTIONS(5507),
    [anon_sym_PIPE_EQ] = ACTIONS(5507),
    [anon_sym_u22a8] = ACTIONS(5507),
    [anon_sym_DASH_PIPE] = ACTIONS(5507),
    [anon_sym_u22a3] = ACTIONS(5507),
    [anon_sym_EQ_PIPE] = ACTIONS(5507),
    [anon_sym_u2ae4] = ACTIONS(5507),
    [anon_sym_BSLASHasymp] = ACTIONS(5507),
    [anon_sym_u224d] = ACTIONS(5507),
    [anon_sym_BSLASHcong] = ACTIONS(5507),
    [anon_sym_u2245] = ACTIONS(5507),
    [anon_sym_BSLASHdoteq] = ACTIONS(5507),
    [anon_sym_u2250] = ACTIONS(5507),
    [anon_sym_BSLASHgg] = ACTIONS(5507),
    [anon_sym_u226b] = ACTIONS(5507),
    [anon_sym_BSLASHll] = ACTIONS(5507),
    [anon_sym_u226a] = ACTIONS(5507),
    [anon_sym_BSLASHnotin] = ACTIONS(5507),
    [anon_sym_u2209] = ACTIONS(5507),
    [anon_sym_BSLASHprec] = ACTIONS(5505),
    [anon_sym_u227a] = ACTIONS(5507),
    [anon_sym_BSLASHsucc] = ACTIONS(5505),
    [anon_sym_u227b] = ACTIONS(5507),
    [anon_sym_BSLASHpreceq] = ACTIONS(5507),
    [anon_sym_u2aaf] = ACTIONS(5507),
    [anon_sym_BSLASHsucceq] = ACTIONS(5507),
    [anon_sym_u2ab0] = ACTIONS(5507),
    [anon_sym_BSLASHpropto] = ACTIONS(5507),
    [anon_sym_u221d] = ACTIONS(5507),
    [anon_sym_BSLASHsim] = ACTIONS(5505),
    [anon_sym_u223c] = ACTIONS(5507),
    [anon_sym_BSLASHsimeq] = ACTIONS(5507),
    [anon_sym_u2243] = ACTIONS(5507),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5505),
    [anon_sym_u228f] = ACTIONS(5507),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5505),
    [anon_sym_u2290] = ACTIONS(5507),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5507),
    [anon_sym_u2291] = ACTIONS(5507),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5507),
    [anon_sym_u2292] = ACTIONS(5507),
    [anon_sym_BSLASHsubset] = ACTIONS(5505),
    [anon_sym_u2282] = ACTIONS(5507),
    [anon_sym_BSLASHsupset] = ACTIONS(5505),
    [anon_sym_u2283] = ACTIONS(5507),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5507),
    [anon_sym_u2286] = ACTIONS(5507),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5507),
    [anon_sym_u2287] = ACTIONS(5507),
    [sym_compose] = ACTIONS(5507),
    [sym_map_to] = ACTIONS(5507),
    [sym_map_from] = ACTIONS(5507),
    [sym_setminus] = ACTIONS(5505),
    [anon_sym_BSLASHcap] = ACTIONS(5507),
    [anon_sym_BSLASHintersect] = ACTIONS(5507),
    [anon_sym_u2229] = ACTIONS(5507),
    [anon_sym_BSLASHcup] = ACTIONS(5507),
    [anon_sym_BSLASHunion] = ACTIONS(5507),
    [anon_sym_u222a] = ACTIONS(5507),
    [anon_sym_DOT_DOT] = ACTIONS(5505),
    [anon_sym_u2025] = ACTIONS(5507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5507),
    [anon_sym_u2026] = ACTIONS(5507),
    [anon_sym_PLUS] = ACTIONS(5505),
    [sym_plusplus] = ACTIONS(5507),
    [anon_sym_BSLASHoplus] = ACTIONS(5507),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5507),
    [anon_sym_u2295] = ACTIONS(5507),
    [anon_sym_BSLASHominus] = ACTIONS(5507),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5507),
    [anon_sym_u2296] = ACTIONS(5507),
    [sym_mod] = ACTIONS(5505),
    [sym_modmod] = ACTIONS(5507),
    [sym_vert] = ACTIONS(5505),
    [anon_sym_PIPE_PIPE] = ACTIONS(5507),
    [anon_sym_u2016] = ACTIONS(5507),
    [sym_minusminus] = ACTIONS(5507),
    [sym_amp] = ACTIONS(5505),
    [sym_ampamp] = ACTIONS(5507),
    [anon_sym_BSLASHodot] = ACTIONS(5507),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5507),
    [anon_sym_u2299] = ACTIONS(5507),
    [anon_sym_BSLASHoslash] = ACTIONS(5507),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5507),
    [anon_sym_u2298] = ACTIONS(5507),
    [anon_sym_BSLASHotimes] = ACTIONS(5507),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5507),
    [anon_sym_u2297] = ACTIONS(5507),
    [sym_mul] = ACTIONS(5505),
    [sym_mulmul] = ACTIONS(5507),
    [sym_slash] = ACTIONS(5505),
    [sym_slashslash] = ACTIONS(5507),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5507),
    [anon_sym_u25ef] = ACTIONS(5507),
    [anon_sym_BSLASHbullet] = ACTIONS(5507),
    [anon_sym_u25cf] = ACTIONS(5507),
    [anon_sym_BSLASHdiv] = ACTIONS(5507),
    [anon_sym_u00f7] = ACTIONS(5507),
    [anon_sym_BSLASHcirc] = ACTIONS(5507),
    [anon_sym_u2218] = ACTIONS(5507),
    [anon_sym_BSLASHstar] = ACTIONS(5507),
    [anon_sym_u22c6] = ACTIONS(5507),
    [anon_sym_u203c] = ACTIONS(5507),
    [sym_hashhash] = ACTIONS(5507),
    [sym_dol] = ACTIONS(5505),
    [sym_doldol] = ACTIONS(5507),
    [anon_sym_QMARK_QMARK] = ACTIONS(5507),
    [anon_sym_u2047] = ACTIONS(5507),
    [anon_sym_BSLASHsqcap] = ACTIONS(5507),
    [anon_sym_u2293] = ACTIONS(5507),
    [anon_sym_BSLASHsqcup] = ACTIONS(5507),
    [anon_sym_u2294] = ACTIONS(5507),
    [anon_sym_BSLASHuplus] = ACTIONS(5507),
    [anon_sym_u228e] = ACTIONS(5507),
    [anon_sym_BSLASHX] = ACTIONS(5507),
    [anon_sym_BSLASHtimes] = ACTIONS(5507),
    [anon_sym_u00d7] = ACTIONS(5507),
    [anon_sym_BSLASHwr] = ACTIONS(5507),
    [anon_sym_u2240] = ACTIONS(5507),
    [anon_sym_BSLASHcdot] = ACTIONS(5507),
    [anon_sym_u22c5] = ACTIONS(5507),
    [sym_pow] = ACTIONS(5505),
    [sym_powpow] = ACTIONS(5507),
    [anon_sym_CARET_PLUS] = ACTIONS(5507),
    [anon_sym_u207a] = ACTIONS(5507),
    [sym_asterisk] = ACTIONS(5507),
    [sym_sup_hash] = ACTIONS(5507),
    [sym_prime] = ACTIONS(5507),
    [sym__indent] = ACTIONS(5507),
    [sym__double_excl] = ACTIONS(5507),
  },
  [2175] = {
    [sym_block_comment] = STATE(2175),
    [sym_identifier] = ACTIONS(5509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5509),
    [anon_sym_u2208] = ACTIONS(5511),
    [anon_sym_BSLASHA] = ACTIONS(5509),
    [anon_sym_BSLASHforall] = ACTIONS(5511),
    [anon_sym_u2200] = ACTIONS(5511),
    [anon_sym_BSLASHE] = ACTIONS(5509),
    [anon_sym_BSLASHexists] = ACTIONS(5511),
    [anon_sym_u2203] = ACTIONS(5511),
    [sym_temporal_forall] = ACTIONS(5511),
    [sym_temporal_exists] = ACTIONS(5511),
    [anon_sym_LT_LT] = ACTIONS(5511),
    [anon_sym_u3008] = ACTIONS(5511),
    [anon_sym_u27e8] = ACTIONS(5511),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5511),
    [anon_sym_u25a1] = ACTIONS(5511),
    [anon_sym_AT] = ACTIONS(5509),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5511),
    [anon_sym_u2227] = ACTIONS(5511),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5511),
    [anon_sym_u2228] = ACTIONS(5511),
    [anon_sym_LPAREN] = ACTIONS(5509),
    [anon_sym_LBRACK] = ACTIONS(5509),
    [aux_sym_child_id_token1] = ACTIONS(5509),
    [sym_real_number] = ACTIONS(5511),
    [anon_sym_BSLASHb] = ACTIONS(5509),
    [anon_sym_BSLASHB] = ACTIONS(5511),
    [anon_sym_BSLASHo] = ACTIONS(5509),
    [anon_sym_BSLASHO] = ACTIONS(5511),
    [anon_sym_BSLASHh] = ACTIONS(5511),
    [anon_sym_BSLASHH] = ACTIONS(5511),
    [anon_sym_DQUOTE] = ACTIONS(5511),
    [anon_sym_TRUE] = ACTIONS(5509),
    [anon_sym_FALSE] = ACTIONS(5509),
    [sym_string_set] = ACTIONS(5509),
    [sym_boolean_set] = ACTIONS(5509),
    [anon_sym_Nat] = ACTIONS(5509),
    [anon_sym_u2115] = ACTIONS(5511),
    [anon_sym_Int] = ACTIONS(5509),
    [anon_sym_u2124] = ACTIONS(5511),
    [anon_sym_Real] = ACTIONS(5509),
    [anon_sym_u211d] = ACTIONS(5511),
    [anon_sym_CHOOSE] = ACTIONS(5509),
    [anon_sym_LBRACE] = ACTIONS(5511),
    [anon_sym_EQ] = ACTIONS(5509),
    [anon_sym_WF_] = ACTIONS(5509),
    [anon_sym_SF_] = ACTIONS(5509),
    [anon_sym_IF] = ACTIONS(5509),
    [anon_sym_CASE] = ACTIONS(5509),
    [anon_sym_LET] = ACTIONS(5509),
    [anon_sym_BSLASHlnot] = ACTIONS(5511),
    [anon_sym_BSLASHneg] = ACTIONS(5511),
    [anon_sym_TILDE] = ACTIONS(5509),
    [anon_sym_u00ac] = ACTIONS(5511),
    [sym_union] = ACTIONS(5509),
    [sym_powerset] = ACTIONS(5509),
    [sym_domain] = ACTIONS(5509),
    [anon_sym_DASH] = ACTIONS(5509),
    [sym_negative_dot] = ACTIONS(5511),
    [sym_enabled] = ACTIONS(5509),
    [sym_unchanged] = ACTIONS(5509),
    [anon_sym_LT_GT] = ACTIONS(5511),
    [anon_sym_u22c4] = ACTIONS(5511),
    [anon_sym_u25c7] = ACTIONS(5511),
    [anon_sym_EQ_GT] = ACTIONS(5511),
    [anon_sym_u27f9] = ACTIONS(5511),
    [anon_sym_u21d2] = ACTIONS(5511),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5511),
    [anon_sym_u21f8] = ACTIONS(5511),
    [anon_sym_u2945] = ACTIONS(5511),
    [anon_sym_BSLASHequiv] = ACTIONS(5511),
    [anon_sym_u2261] = ACTIONS(5511),
    [anon_sym_LT_EQ_GT] = ACTIONS(5511),
    [anon_sym_u27fa] = ACTIONS(5511),
    [anon_sym_u21d4] = ACTIONS(5511),
    [anon_sym_TILDE_GT] = ACTIONS(5511),
    [anon_sym_u21dd] = ACTIONS(5511),
    [anon_sym_u219d] = ACTIONS(5511),
    [anon_sym_BSLASHland] = ACTIONS(5511),
    [anon_sym_BSLASHlor] = ACTIONS(5511),
    [anon_sym_COLON_EQ] = ACTIONS(5511),
    [anon_sym_u2254] = ACTIONS(5511),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5511),
    [anon_sym_u2a74] = ACTIONS(5511),
    [anon_sym_SLASH_EQ] = ACTIONS(5511),
    [anon_sym_POUND] = ACTIONS(5509),
    [anon_sym_u2260] = ACTIONS(5511),
    [anon_sym_LT] = ACTIONS(5509),
    [sym_gt] = ACTIONS(5509),
    [anon_sym_LT_EQ] = ACTIONS(5509),
    [anon_sym_EQ_LT] = ACTIONS(5511),
    [anon_sym_BSLASHleq] = ACTIONS(5511),
    [anon_sym_u2264] = ACTIONS(5511),
    [anon_sym_GT_EQ] = ACTIONS(5511),
    [anon_sym_BSLASHgeq] = ACTIONS(5511),
    [anon_sym_u2265] = ACTIONS(5511),
    [anon_sym_BSLASHapprox] = ACTIONS(5511),
    [anon_sym_u2248] = ACTIONS(5511),
    [anon_sym_PIPE_DASH] = ACTIONS(5511),
    [anon_sym_u22a2] = ACTIONS(5511),
    [anon_sym_PIPE_EQ] = ACTIONS(5511),
    [anon_sym_u22a8] = ACTIONS(5511),
    [anon_sym_DASH_PIPE] = ACTIONS(5511),
    [anon_sym_u22a3] = ACTIONS(5511),
    [anon_sym_EQ_PIPE] = ACTIONS(5511),
    [anon_sym_u2ae4] = ACTIONS(5511),
    [anon_sym_BSLASHasymp] = ACTIONS(5511),
    [anon_sym_u224d] = ACTIONS(5511),
    [anon_sym_BSLASHcong] = ACTIONS(5511),
    [anon_sym_u2245] = ACTIONS(5511),
    [anon_sym_BSLASHdoteq] = ACTIONS(5511),
    [anon_sym_u2250] = ACTIONS(5511),
    [anon_sym_BSLASHgg] = ACTIONS(5511),
    [anon_sym_u226b] = ACTIONS(5511),
    [anon_sym_BSLASHll] = ACTIONS(5511),
    [anon_sym_u226a] = ACTIONS(5511),
    [anon_sym_BSLASHnotin] = ACTIONS(5511),
    [anon_sym_u2209] = ACTIONS(5511),
    [anon_sym_BSLASHprec] = ACTIONS(5509),
    [anon_sym_u227a] = ACTIONS(5511),
    [anon_sym_BSLASHsucc] = ACTIONS(5509),
    [anon_sym_u227b] = ACTIONS(5511),
    [anon_sym_BSLASHpreceq] = ACTIONS(5511),
    [anon_sym_u2aaf] = ACTIONS(5511),
    [anon_sym_BSLASHsucceq] = ACTIONS(5511),
    [anon_sym_u2ab0] = ACTIONS(5511),
    [anon_sym_BSLASHpropto] = ACTIONS(5511),
    [anon_sym_u221d] = ACTIONS(5511),
    [anon_sym_BSLASHsim] = ACTIONS(5509),
    [anon_sym_u223c] = ACTIONS(5511),
    [anon_sym_BSLASHsimeq] = ACTIONS(5511),
    [anon_sym_u2243] = ACTIONS(5511),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5509),
    [anon_sym_u228f] = ACTIONS(5511),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5509),
    [anon_sym_u2290] = ACTIONS(5511),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5511),
    [anon_sym_u2291] = ACTIONS(5511),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5511),
    [anon_sym_u2292] = ACTIONS(5511),
    [anon_sym_BSLASHsubset] = ACTIONS(5509),
    [anon_sym_u2282] = ACTIONS(5511),
    [anon_sym_BSLASHsupset] = ACTIONS(5509),
    [anon_sym_u2283] = ACTIONS(5511),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5511),
    [anon_sym_u2286] = ACTIONS(5511),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5511),
    [anon_sym_u2287] = ACTIONS(5511),
    [sym_compose] = ACTIONS(5511),
    [sym_map_to] = ACTIONS(5511),
    [sym_map_from] = ACTIONS(5511),
    [sym_setminus] = ACTIONS(5509),
    [anon_sym_BSLASHcap] = ACTIONS(5511),
    [anon_sym_BSLASHintersect] = ACTIONS(5511),
    [anon_sym_u2229] = ACTIONS(5511),
    [anon_sym_BSLASHcup] = ACTIONS(5511),
    [anon_sym_BSLASHunion] = ACTIONS(5511),
    [anon_sym_u222a] = ACTIONS(5511),
    [anon_sym_DOT_DOT] = ACTIONS(5509),
    [anon_sym_u2025] = ACTIONS(5511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5511),
    [anon_sym_u2026] = ACTIONS(5511),
    [anon_sym_PLUS] = ACTIONS(5509),
    [sym_plusplus] = ACTIONS(5511),
    [anon_sym_BSLASHoplus] = ACTIONS(5511),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5511),
    [anon_sym_u2295] = ACTIONS(5511),
    [anon_sym_BSLASHominus] = ACTIONS(5511),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5511),
    [anon_sym_u2296] = ACTIONS(5511),
    [sym_mod] = ACTIONS(5509),
    [sym_modmod] = ACTIONS(5511),
    [sym_vert] = ACTIONS(5509),
    [anon_sym_PIPE_PIPE] = ACTIONS(5511),
    [anon_sym_u2016] = ACTIONS(5511),
    [sym_minusminus] = ACTIONS(5511),
    [sym_amp] = ACTIONS(5509),
    [sym_ampamp] = ACTIONS(5511),
    [anon_sym_BSLASHodot] = ACTIONS(5511),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5511),
    [anon_sym_u2299] = ACTIONS(5511),
    [anon_sym_BSLASHoslash] = ACTIONS(5511),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5511),
    [anon_sym_u2298] = ACTIONS(5511),
    [anon_sym_BSLASHotimes] = ACTIONS(5511),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5511),
    [anon_sym_u2297] = ACTIONS(5511),
    [sym_mul] = ACTIONS(5509),
    [sym_mulmul] = ACTIONS(5511),
    [sym_slash] = ACTIONS(5509),
    [sym_slashslash] = ACTIONS(5511),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5511),
    [anon_sym_u25ef] = ACTIONS(5511),
    [anon_sym_BSLASHbullet] = ACTIONS(5511),
    [anon_sym_u25cf] = ACTIONS(5511),
    [anon_sym_BSLASHdiv] = ACTIONS(5511),
    [anon_sym_u00f7] = ACTIONS(5511),
    [anon_sym_BSLASHcirc] = ACTIONS(5511),
    [anon_sym_u2218] = ACTIONS(5511),
    [anon_sym_BSLASHstar] = ACTIONS(5511),
    [anon_sym_u22c6] = ACTIONS(5511),
    [anon_sym_u203c] = ACTIONS(5511),
    [sym_hashhash] = ACTIONS(5511),
    [sym_dol] = ACTIONS(5509),
    [sym_doldol] = ACTIONS(5511),
    [anon_sym_QMARK_QMARK] = ACTIONS(5511),
    [anon_sym_u2047] = ACTIONS(5511),
    [anon_sym_BSLASHsqcap] = ACTIONS(5511),
    [anon_sym_u2293] = ACTIONS(5511),
    [anon_sym_BSLASHsqcup] = ACTIONS(5511),
    [anon_sym_u2294] = ACTIONS(5511),
    [anon_sym_BSLASHuplus] = ACTIONS(5511),
    [anon_sym_u228e] = ACTIONS(5511),
    [anon_sym_BSLASHX] = ACTIONS(5511),
    [anon_sym_BSLASHtimes] = ACTIONS(5511),
    [anon_sym_u00d7] = ACTIONS(5511),
    [anon_sym_BSLASHwr] = ACTIONS(5511),
    [anon_sym_u2240] = ACTIONS(5511),
    [anon_sym_BSLASHcdot] = ACTIONS(5511),
    [anon_sym_u22c5] = ACTIONS(5511),
    [sym_pow] = ACTIONS(5509),
    [sym_powpow] = ACTIONS(5511),
    [anon_sym_CARET_PLUS] = ACTIONS(5511),
    [anon_sym_u207a] = ACTIONS(5511),
    [sym_asterisk] = ACTIONS(5511),
    [sym_sup_hash] = ACTIONS(5511),
    [sym_prime] = ACTIONS(5511),
    [sym__indent] = ACTIONS(5511),
    [sym__double_excl] = ACTIONS(5511),
  },
  [2176] = {
    [sym_block_comment] = STATE(2176),
    [sym_identifier] = ACTIONS(5513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5513),
    [anon_sym_u2208] = ACTIONS(5515),
    [anon_sym_BSLASHA] = ACTIONS(5513),
    [anon_sym_BSLASHforall] = ACTIONS(5515),
    [anon_sym_u2200] = ACTIONS(5515),
    [anon_sym_BSLASHE] = ACTIONS(5513),
    [anon_sym_BSLASHexists] = ACTIONS(5515),
    [anon_sym_u2203] = ACTIONS(5515),
    [sym_temporal_forall] = ACTIONS(5515),
    [sym_temporal_exists] = ACTIONS(5515),
    [anon_sym_LT_LT] = ACTIONS(5515),
    [anon_sym_u3008] = ACTIONS(5515),
    [anon_sym_u27e8] = ACTIONS(5515),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5515),
    [anon_sym_u25a1] = ACTIONS(5515),
    [anon_sym_AT] = ACTIONS(5513),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5515),
    [anon_sym_u2227] = ACTIONS(5515),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5515),
    [anon_sym_u2228] = ACTIONS(5515),
    [anon_sym_LPAREN] = ACTIONS(5513),
    [anon_sym_LBRACK] = ACTIONS(5513),
    [aux_sym_child_id_token1] = ACTIONS(5513),
    [sym_real_number] = ACTIONS(5515),
    [anon_sym_BSLASHb] = ACTIONS(5513),
    [anon_sym_BSLASHB] = ACTIONS(5515),
    [anon_sym_BSLASHo] = ACTIONS(5513),
    [anon_sym_BSLASHO] = ACTIONS(5515),
    [anon_sym_BSLASHh] = ACTIONS(5515),
    [anon_sym_BSLASHH] = ACTIONS(5515),
    [anon_sym_DQUOTE] = ACTIONS(5515),
    [anon_sym_TRUE] = ACTIONS(5513),
    [anon_sym_FALSE] = ACTIONS(5513),
    [sym_string_set] = ACTIONS(5513),
    [sym_boolean_set] = ACTIONS(5513),
    [anon_sym_Nat] = ACTIONS(5513),
    [anon_sym_u2115] = ACTIONS(5515),
    [anon_sym_Int] = ACTIONS(5513),
    [anon_sym_u2124] = ACTIONS(5515),
    [anon_sym_Real] = ACTIONS(5513),
    [anon_sym_u211d] = ACTIONS(5515),
    [anon_sym_CHOOSE] = ACTIONS(5513),
    [anon_sym_LBRACE] = ACTIONS(5515),
    [anon_sym_EQ] = ACTIONS(5513),
    [anon_sym_WF_] = ACTIONS(5513),
    [anon_sym_SF_] = ACTIONS(5513),
    [anon_sym_IF] = ACTIONS(5513),
    [anon_sym_CASE] = ACTIONS(5513),
    [anon_sym_LET] = ACTIONS(5513),
    [anon_sym_BSLASHlnot] = ACTIONS(5515),
    [anon_sym_BSLASHneg] = ACTIONS(5515),
    [anon_sym_TILDE] = ACTIONS(5513),
    [anon_sym_u00ac] = ACTIONS(5515),
    [sym_union] = ACTIONS(5513),
    [sym_powerset] = ACTIONS(5513),
    [sym_domain] = ACTIONS(5513),
    [anon_sym_DASH] = ACTIONS(5513),
    [sym_negative_dot] = ACTIONS(5515),
    [sym_enabled] = ACTIONS(5513),
    [sym_unchanged] = ACTIONS(5513),
    [anon_sym_LT_GT] = ACTIONS(5515),
    [anon_sym_u22c4] = ACTIONS(5515),
    [anon_sym_u25c7] = ACTIONS(5515),
    [anon_sym_EQ_GT] = ACTIONS(5515),
    [anon_sym_u27f9] = ACTIONS(5515),
    [anon_sym_u21d2] = ACTIONS(5515),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5515),
    [anon_sym_u21f8] = ACTIONS(5515),
    [anon_sym_u2945] = ACTIONS(5515),
    [anon_sym_BSLASHequiv] = ACTIONS(5515),
    [anon_sym_u2261] = ACTIONS(5515),
    [anon_sym_LT_EQ_GT] = ACTIONS(5515),
    [anon_sym_u27fa] = ACTIONS(5515),
    [anon_sym_u21d4] = ACTIONS(5515),
    [anon_sym_TILDE_GT] = ACTIONS(5515),
    [anon_sym_u21dd] = ACTIONS(5515),
    [anon_sym_u219d] = ACTIONS(5515),
    [anon_sym_BSLASHland] = ACTIONS(5515),
    [anon_sym_BSLASHlor] = ACTIONS(5515),
    [anon_sym_COLON_EQ] = ACTIONS(5515),
    [anon_sym_u2254] = ACTIONS(5515),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5515),
    [anon_sym_u2a74] = ACTIONS(5515),
    [anon_sym_SLASH_EQ] = ACTIONS(5515),
    [anon_sym_POUND] = ACTIONS(5513),
    [anon_sym_u2260] = ACTIONS(5515),
    [anon_sym_LT] = ACTIONS(5513),
    [sym_gt] = ACTIONS(5513),
    [anon_sym_LT_EQ] = ACTIONS(5513),
    [anon_sym_EQ_LT] = ACTIONS(5515),
    [anon_sym_BSLASHleq] = ACTIONS(5515),
    [anon_sym_u2264] = ACTIONS(5515),
    [anon_sym_GT_EQ] = ACTIONS(5515),
    [anon_sym_BSLASHgeq] = ACTIONS(5515),
    [anon_sym_u2265] = ACTIONS(5515),
    [anon_sym_BSLASHapprox] = ACTIONS(5515),
    [anon_sym_u2248] = ACTIONS(5515),
    [anon_sym_PIPE_DASH] = ACTIONS(5515),
    [anon_sym_u22a2] = ACTIONS(5515),
    [anon_sym_PIPE_EQ] = ACTIONS(5515),
    [anon_sym_u22a8] = ACTIONS(5515),
    [anon_sym_DASH_PIPE] = ACTIONS(5515),
    [anon_sym_u22a3] = ACTIONS(5515),
    [anon_sym_EQ_PIPE] = ACTIONS(5515),
    [anon_sym_u2ae4] = ACTIONS(5515),
    [anon_sym_BSLASHasymp] = ACTIONS(5515),
    [anon_sym_u224d] = ACTIONS(5515),
    [anon_sym_BSLASHcong] = ACTIONS(5515),
    [anon_sym_u2245] = ACTIONS(5515),
    [anon_sym_BSLASHdoteq] = ACTIONS(5515),
    [anon_sym_u2250] = ACTIONS(5515),
    [anon_sym_BSLASHgg] = ACTIONS(5515),
    [anon_sym_u226b] = ACTIONS(5515),
    [anon_sym_BSLASHll] = ACTIONS(5515),
    [anon_sym_u226a] = ACTIONS(5515),
    [anon_sym_BSLASHnotin] = ACTIONS(5515),
    [anon_sym_u2209] = ACTIONS(5515),
    [anon_sym_BSLASHprec] = ACTIONS(5513),
    [anon_sym_u227a] = ACTIONS(5515),
    [anon_sym_BSLASHsucc] = ACTIONS(5513),
    [anon_sym_u227b] = ACTIONS(5515),
    [anon_sym_BSLASHpreceq] = ACTIONS(5515),
    [anon_sym_u2aaf] = ACTIONS(5515),
    [anon_sym_BSLASHsucceq] = ACTIONS(5515),
    [anon_sym_u2ab0] = ACTIONS(5515),
    [anon_sym_BSLASHpropto] = ACTIONS(5515),
    [anon_sym_u221d] = ACTIONS(5515),
    [anon_sym_BSLASHsim] = ACTIONS(5513),
    [anon_sym_u223c] = ACTIONS(5515),
    [anon_sym_BSLASHsimeq] = ACTIONS(5515),
    [anon_sym_u2243] = ACTIONS(5515),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5513),
    [anon_sym_u228f] = ACTIONS(5515),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5513),
    [anon_sym_u2290] = ACTIONS(5515),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5515),
    [anon_sym_u2291] = ACTIONS(5515),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5515),
    [anon_sym_u2292] = ACTIONS(5515),
    [anon_sym_BSLASHsubset] = ACTIONS(5513),
    [anon_sym_u2282] = ACTIONS(5515),
    [anon_sym_BSLASHsupset] = ACTIONS(5513),
    [anon_sym_u2283] = ACTIONS(5515),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5515),
    [anon_sym_u2286] = ACTIONS(5515),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5515),
    [anon_sym_u2287] = ACTIONS(5515),
    [sym_compose] = ACTIONS(5515),
    [sym_map_to] = ACTIONS(5515),
    [sym_map_from] = ACTIONS(5515),
    [sym_setminus] = ACTIONS(5513),
    [anon_sym_BSLASHcap] = ACTIONS(5515),
    [anon_sym_BSLASHintersect] = ACTIONS(5515),
    [anon_sym_u2229] = ACTIONS(5515),
    [anon_sym_BSLASHcup] = ACTIONS(5515),
    [anon_sym_BSLASHunion] = ACTIONS(5515),
    [anon_sym_u222a] = ACTIONS(5515),
    [anon_sym_DOT_DOT] = ACTIONS(5513),
    [anon_sym_u2025] = ACTIONS(5515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5515),
    [anon_sym_u2026] = ACTIONS(5515),
    [anon_sym_PLUS] = ACTIONS(5513),
    [sym_plusplus] = ACTIONS(5515),
    [anon_sym_BSLASHoplus] = ACTIONS(5515),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5515),
    [anon_sym_u2295] = ACTIONS(5515),
    [anon_sym_BSLASHominus] = ACTIONS(5515),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5515),
    [anon_sym_u2296] = ACTIONS(5515),
    [sym_mod] = ACTIONS(5513),
    [sym_modmod] = ACTIONS(5515),
    [sym_vert] = ACTIONS(5513),
    [anon_sym_PIPE_PIPE] = ACTIONS(5515),
    [anon_sym_u2016] = ACTIONS(5515),
    [sym_minusminus] = ACTIONS(5515),
    [sym_amp] = ACTIONS(5513),
    [sym_ampamp] = ACTIONS(5515),
    [anon_sym_BSLASHodot] = ACTIONS(5515),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5515),
    [anon_sym_u2299] = ACTIONS(5515),
    [anon_sym_BSLASHoslash] = ACTIONS(5515),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5515),
    [anon_sym_u2298] = ACTIONS(5515),
    [anon_sym_BSLASHotimes] = ACTIONS(5515),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5515),
    [anon_sym_u2297] = ACTIONS(5515),
    [sym_mul] = ACTIONS(5513),
    [sym_mulmul] = ACTIONS(5515),
    [sym_slash] = ACTIONS(5513),
    [sym_slashslash] = ACTIONS(5515),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5515),
    [anon_sym_u25ef] = ACTIONS(5515),
    [anon_sym_BSLASHbullet] = ACTIONS(5515),
    [anon_sym_u25cf] = ACTIONS(5515),
    [anon_sym_BSLASHdiv] = ACTIONS(5515),
    [anon_sym_u00f7] = ACTIONS(5515),
    [anon_sym_BSLASHcirc] = ACTIONS(5515),
    [anon_sym_u2218] = ACTIONS(5515),
    [anon_sym_BSLASHstar] = ACTIONS(5515),
    [anon_sym_u22c6] = ACTIONS(5515),
    [anon_sym_u203c] = ACTIONS(5515),
    [sym_hashhash] = ACTIONS(5515),
    [sym_dol] = ACTIONS(5513),
    [sym_doldol] = ACTIONS(5515),
    [anon_sym_QMARK_QMARK] = ACTIONS(5515),
    [anon_sym_u2047] = ACTIONS(5515),
    [anon_sym_BSLASHsqcap] = ACTIONS(5515),
    [anon_sym_u2293] = ACTIONS(5515),
    [anon_sym_BSLASHsqcup] = ACTIONS(5515),
    [anon_sym_u2294] = ACTIONS(5515),
    [anon_sym_BSLASHuplus] = ACTIONS(5515),
    [anon_sym_u228e] = ACTIONS(5515),
    [anon_sym_BSLASHX] = ACTIONS(5515),
    [anon_sym_BSLASHtimes] = ACTIONS(5515),
    [anon_sym_u00d7] = ACTIONS(5515),
    [anon_sym_BSLASHwr] = ACTIONS(5515),
    [anon_sym_u2240] = ACTIONS(5515),
    [anon_sym_BSLASHcdot] = ACTIONS(5515),
    [anon_sym_u22c5] = ACTIONS(5515),
    [sym_pow] = ACTIONS(5513),
    [sym_powpow] = ACTIONS(5515),
    [anon_sym_CARET_PLUS] = ACTIONS(5515),
    [anon_sym_u207a] = ACTIONS(5515),
    [sym_asterisk] = ACTIONS(5515),
    [sym_sup_hash] = ACTIONS(5515),
    [sym_prime] = ACTIONS(5515),
    [sym__indent] = ACTIONS(5515),
    [sym__double_excl] = ACTIONS(5515),
  },
  [2177] = {
    [sym_block_comment] = STATE(2177),
    [sym_identifier] = ACTIONS(5517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5517),
    [anon_sym_u2208] = ACTIONS(5519),
    [anon_sym_BSLASHA] = ACTIONS(5517),
    [anon_sym_BSLASHforall] = ACTIONS(5519),
    [anon_sym_u2200] = ACTIONS(5519),
    [anon_sym_BSLASHE] = ACTIONS(5517),
    [anon_sym_BSLASHexists] = ACTIONS(5519),
    [anon_sym_u2203] = ACTIONS(5519),
    [sym_temporal_forall] = ACTIONS(5519),
    [sym_temporal_exists] = ACTIONS(5519),
    [anon_sym_LT_LT] = ACTIONS(5519),
    [anon_sym_u3008] = ACTIONS(5519),
    [anon_sym_u27e8] = ACTIONS(5519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5519),
    [anon_sym_u25a1] = ACTIONS(5519),
    [anon_sym_AT] = ACTIONS(5517),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5519),
    [anon_sym_u2227] = ACTIONS(5519),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5519),
    [anon_sym_u2228] = ACTIONS(5519),
    [anon_sym_LPAREN] = ACTIONS(5517),
    [anon_sym_LBRACK] = ACTIONS(5517),
    [aux_sym_child_id_token1] = ACTIONS(5517),
    [sym_real_number] = ACTIONS(5519),
    [anon_sym_BSLASHb] = ACTIONS(5517),
    [anon_sym_BSLASHB] = ACTIONS(5519),
    [anon_sym_BSLASHo] = ACTIONS(5517),
    [anon_sym_BSLASHO] = ACTIONS(5519),
    [anon_sym_BSLASHh] = ACTIONS(5519),
    [anon_sym_BSLASHH] = ACTIONS(5519),
    [anon_sym_DQUOTE] = ACTIONS(5519),
    [anon_sym_TRUE] = ACTIONS(5517),
    [anon_sym_FALSE] = ACTIONS(5517),
    [sym_string_set] = ACTIONS(5517),
    [sym_boolean_set] = ACTIONS(5517),
    [anon_sym_Nat] = ACTIONS(5517),
    [anon_sym_u2115] = ACTIONS(5519),
    [anon_sym_Int] = ACTIONS(5517),
    [anon_sym_u2124] = ACTIONS(5519),
    [anon_sym_Real] = ACTIONS(5517),
    [anon_sym_u211d] = ACTIONS(5519),
    [anon_sym_CHOOSE] = ACTIONS(5517),
    [anon_sym_LBRACE] = ACTIONS(5519),
    [anon_sym_EQ] = ACTIONS(5517),
    [anon_sym_WF_] = ACTIONS(5517),
    [anon_sym_SF_] = ACTIONS(5517),
    [anon_sym_IF] = ACTIONS(5517),
    [anon_sym_CASE] = ACTIONS(5517),
    [anon_sym_LET] = ACTIONS(5517),
    [anon_sym_BSLASHlnot] = ACTIONS(5519),
    [anon_sym_BSLASHneg] = ACTIONS(5519),
    [anon_sym_TILDE] = ACTIONS(5517),
    [anon_sym_u00ac] = ACTIONS(5519),
    [sym_union] = ACTIONS(5517),
    [sym_powerset] = ACTIONS(5517),
    [sym_domain] = ACTIONS(5517),
    [anon_sym_DASH] = ACTIONS(5517),
    [sym_negative_dot] = ACTIONS(5519),
    [sym_enabled] = ACTIONS(5517),
    [sym_unchanged] = ACTIONS(5517),
    [anon_sym_LT_GT] = ACTIONS(5519),
    [anon_sym_u22c4] = ACTIONS(5519),
    [anon_sym_u25c7] = ACTIONS(5519),
    [anon_sym_EQ_GT] = ACTIONS(5519),
    [anon_sym_u27f9] = ACTIONS(5519),
    [anon_sym_u21d2] = ACTIONS(5519),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5519),
    [anon_sym_u21f8] = ACTIONS(5519),
    [anon_sym_u2945] = ACTIONS(5519),
    [anon_sym_BSLASHequiv] = ACTIONS(5519),
    [anon_sym_u2261] = ACTIONS(5519),
    [anon_sym_LT_EQ_GT] = ACTIONS(5519),
    [anon_sym_u27fa] = ACTIONS(5519),
    [anon_sym_u21d4] = ACTIONS(5519),
    [anon_sym_TILDE_GT] = ACTIONS(5519),
    [anon_sym_u21dd] = ACTIONS(5519),
    [anon_sym_u219d] = ACTIONS(5519),
    [anon_sym_BSLASHland] = ACTIONS(5519),
    [anon_sym_BSLASHlor] = ACTIONS(5519),
    [anon_sym_COLON_EQ] = ACTIONS(5519),
    [anon_sym_u2254] = ACTIONS(5519),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5519),
    [anon_sym_u2a74] = ACTIONS(5519),
    [anon_sym_SLASH_EQ] = ACTIONS(5519),
    [anon_sym_POUND] = ACTIONS(5517),
    [anon_sym_u2260] = ACTIONS(5519),
    [anon_sym_LT] = ACTIONS(5517),
    [sym_gt] = ACTIONS(5517),
    [anon_sym_LT_EQ] = ACTIONS(5517),
    [anon_sym_EQ_LT] = ACTIONS(5519),
    [anon_sym_BSLASHleq] = ACTIONS(5519),
    [anon_sym_u2264] = ACTIONS(5519),
    [anon_sym_GT_EQ] = ACTIONS(5519),
    [anon_sym_BSLASHgeq] = ACTIONS(5519),
    [anon_sym_u2265] = ACTIONS(5519),
    [anon_sym_BSLASHapprox] = ACTIONS(5519),
    [anon_sym_u2248] = ACTIONS(5519),
    [anon_sym_PIPE_DASH] = ACTIONS(5519),
    [anon_sym_u22a2] = ACTIONS(5519),
    [anon_sym_PIPE_EQ] = ACTIONS(5519),
    [anon_sym_u22a8] = ACTIONS(5519),
    [anon_sym_DASH_PIPE] = ACTIONS(5519),
    [anon_sym_u22a3] = ACTIONS(5519),
    [anon_sym_EQ_PIPE] = ACTIONS(5519),
    [anon_sym_u2ae4] = ACTIONS(5519),
    [anon_sym_BSLASHasymp] = ACTIONS(5519),
    [anon_sym_u224d] = ACTIONS(5519),
    [anon_sym_BSLASHcong] = ACTIONS(5519),
    [anon_sym_u2245] = ACTIONS(5519),
    [anon_sym_BSLASHdoteq] = ACTIONS(5519),
    [anon_sym_u2250] = ACTIONS(5519),
    [anon_sym_BSLASHgg] = ACTIONS(5519),
    [anon_sym_u226b] = ACTIONS(5519),
    [anon_sym_BSLASHll] = ACTIONS(5519),
    [anon_sym_u226a] = ACTIONS(5519),
    [anon_sym_BSLASHnotin] = ACTIONS(5519),
    [anon_sym_u2209] = ACTIONS(5519),
    [anon_sym_BSLASHprec] = ACTIONS(5517),
    [anon_sym_u227a] = ACTIONS(5519),
    [anon_sym_BSLASHsucc] = ACTIONS(5517),
    [anon_sym_u227b] = ACTIONS(5519),
    [anon_sym_BSLASHpreceq] = ACTIONS(5519),
    [anon_sym_u2aaf] = ACTIONS(5519),
    [anon_sym_BSLASHsucceq] = ACTIONS(5519),
    [anon_sym_u2ab0] = ACTIONS(5519),
    [anon_sym_BSLASHpropto] = ACTIONS(5519),
    [anon_sym_u221d] = ACTIONS(5519),
    [anon_sym_BSLASHsim] = ACTIONS(5517),
    [anon_sym_u223c] = ACTIONS(5519),
    [anon_sym_BSLASHsimeq] = ACTIONS(5519),
    [anon_sym_u2243] = ACTIONS(5519),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5517),
    [anon_sym_u228f] = ACTIONS(5519),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5517),
    [anon_sym_u2290] = ACTIONS(5519),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5519),
    [anon_sym_u2291] = ACTIONS(5519),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5519),
    [anon_sym_u2292] = ACTIONS(5519),
    [anon_sym_BSLASHsubset] = ACTIONS(5517),
    [anon_sym_u2282] = ACTIONS(5519),
    [anon_sym_BSLASHsupset] = ACTIONS(5517),
    [anon_sym_u2283] = ACTIONS(5519),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5519),
    [anon_sym_u2286] = ACTIONS(5519),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5519),
    [anon_sym_u2287] = ACTIONS(5519),
    [sym_compose] = ACTIONS(5519),
    [sym_map_to] = ACTIONS(5519),
    [sym_map_from] = ACTIONS(5519),
    [sym_setminus] = ACTIONS(5517),
    [anon_sym_BSLASHcap] = ACTIONS(5519),
    [anon_sym_BSLASHintersect] = ACTIONS(5519),
    [anon_sym_u2229] = ACTIONS(5519),
    [anon_sym_BSLASHcup] = ACTIONS(5519),
    [anon_sym_BSLASHunion] = ACTIONS(5519),
    [anon_sym_u222a] = ACTIONS(5519),
    [anon_sym_DOT_DOT] = ACTIONS(5517),
    [anon_sym_u2025] = ACTIONS(5519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5519),
    [anon_sym_u2026] = ACTIONS(5519),
    [anon_sym_PLUS] = ACTIONS(5517),
    [sym_plusplus] = ACTIONS(5519),
    [anon_sym_BSLASHoplus] = ACTIONS(5519),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5519),
    [anon_sym_u2295] = ACTIONS(5519),
    [anon_sym_BSLASHominus] = ACTIONS(5519),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5519),
    [anon_sym_u2296] = ACTIONS(5519),
    [sym_mod] = ACTIONS(5517),
    [sym_modmod] = ACTIONS(5519),
    [sym_vert] = ACTIONS(5517),
    [anon_sym_PIPE_PIPE] = ACTIONS(5519),
    [anon_sym_u2016] = ACTIONS(5519),
    [sym_minusminus] = ACTIONS(5519),
    [sym_amp] = ACTIONS(5517),
    [sym_ampamp] = ACTIONS(5519),
    [anon_sym_BSLASHodot] = ACTIONS(5519),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5519),
    [anon_sym_u2299] = ACTIONS(5519),
    [anon_sym_BSLASHoslash] = ACTIONS(5519),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5519),
    [anon_sym_u2298] = ACTIONS(5519),
    [anon_sym_BSLASHotimes] = ACTIONS(5519),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5519),
    [anon_sym_u2297] = ACTIONS(5519),
    [sym_mul] = ACTIONS(5517),
    [sym_mulmul] = ACTIONS(5519),
    [sym_slash] = ACTIONS(5517),
    [sym_slashslash] = ACTIONS(5519),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5519),
    [anon_sym_u25ef] = ACTIONS(5519),
    [anon_sym_BSLASHbullet] = ACTIONS(5519),
    [anon_sym_u25cf] = ACTIONS(5519),
    [anon_sym_BSLASHdiv] = ACTIONS(5519),
    [anon_sym_u00f7] = ACTIONS(5519),
    [anon_sym_BSLASHcirc] = ACTIONS(5519),
    [anon_sym_u2218] = ACTIONS(5519),
    [anon_sym_BSLASHstar] = ACTIONS(5519),
    [anon_sym_u22c6] = ACTIONS(5519),
    [anon_sym_u203c] = ACTIONS(5519),
    [sym_hashhash] = ACTIONS(5519),
    [sym_dol] = ACTIONS(5517),
    [sym_doldol] = ACTIONS(5519),
    [anon_sym_QMARK_QMARK] = ACTIONS(5519),
    [anon_sym_u2047] = ACTIONS(5519),
    [anon_sym_BSLASHsqcap] = ACTIONS(5519),
    [anon_sym_u2293] = ACTIONS(5519),
    [anon_sym_BSLASHsqcup] = ACTIONS(5519),
    [anon_sym_u2294] = ACTIONS(5519),
    [anon_sym_BSLASHuplus] = ACTIONS(5519),
    [anon_sym_u228e] = ACTIONS(5519),
    [anon_sym_BSLASHX] = ACTIONS(5519),
    [anon_sym_BSLASHtimes] = ACTIONS(5519),
    [anon_sym_u00d7] = ACTIONS(5519),
    [anon_sym_BSLASHwr] = ACTIONS(5519),
    [anon_sym_u2240] = ACTIONS(5519),
    [anon_sym_BSLASHcdot] = ACTIONS(5519),
    [anon_sym_u22c5] = ACTIONS(5519),
    [sym_pow] = ACTIONS(5517),
    [sym_powpow] = ACTIONS(5519),
    [anon_sym_CARET_PLUS] = ACTIONS(5519),
    [anon_sym_u207a] = ACTIONS(5519),
    [sym_asterisk] = ACTIONS(5519),
    [sym_sup_hash] = ACTIONS(5519),
    [sym_prime] = ACTIONS(5519),
    [sym__indent] = ACTIONS(5519),
    [sym__double_excl] = ACTIONS(5519),
  },
  [2178] = {
    [sym_block_comment] = STATE(2178),
    [sym_identifier] = ACTIONS(5521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5521),
    [anon_sym_u2208] = ACTIONS(5523),
    [anon_sym_BSLASHA] = ACTIONS(5521),
    [anon_sym_BSLASHforall] = ACTIONS(5523),
    [anon_sym_u2200] = ACTIONS(5523),
    [anon_sym_BSLASHE] = ACTIONS(5521),
    [anon_sym_BSLASHexists] = ACTIONS(5523),
    [anon_sym_u2203] = ACTIONS(5523),
    [sym_temporal_forall] = ACTIONS(5523),
    [sym_temporal_exists] = ACTIONS(5523),
    [anon_sym_LT_LT] = ACTIONS(5523),
    [anon_sym_u3008] = ACTIONS(5523),
    [anon_sym_u27e8] = ACTIONS(5523),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5523),
    [anon_sym_u25a1] = ACTIONS(5523),
    [anon_sym_AT] = ACTIONS(5521),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5523),
    [anon_sym_u2227] = ACTIONS(5523),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5523),
    [anon_sym_u2228] = ACTIONS(5523),
    [anon_sym_LPAREN] = ACTIONS(5521),
    [anon_sym_LBRACK] = ACTIONS(5521),
    [aux_sym_child_id_token1] = ACTIONS(5521),
    [sym_real_number] = ACTIONS(5523),
    [anon_sym_BSLASHb] = ACTIONS(5521),
    [anon_sym_BSLASHB] = ACTIONS(5523),
    [anon_sym_BSLASHo] = ACTIONS(5521),
    [anon_sym_BSLASHO] = ACTIONS(5523),
    [anon_sym_BSLASHh] = ACTIONS(5523),
    [anon_sym_BSLASHH] = ACTIONS(5523),
    [anon_sym_DQUOTE] = ACTIONS(5523),
    [anon_sym_TRUE] = ACTIONS(5521),
    [anon_sym_FALSE] = ACTIONS(5521),
    [sym_string_set] = ACTIONS(5521),
    [sym_boolean_set] = ACTIONS(5521),
    [anon_sym_Nat] = ACTIONS(5521),
    [anon_sym_u2115] = ACTIONS(5523),
    [anon_sym_Int] = ACTIONS(5521),
    [anon_sym_u2124] = ACTIONS(5523),
    [anon_sym_Real] = ACTIONS(5521),
    [anon_sym_u211d] = ACTIONS(5523),
    [anon_sym_CHOOSE] = ACTIONS(5521),
    [anon_sym_LBRACE] = ACTIONS(5523),
    [anon_sym_EQ] = ACTIONS(5521),
    [anon_sym_WF_] = ACTIONS(5521),
    [anon_sym_SF_] = ACTIONS(5521),
    [anon_sym_IF] = ACTIONS(5521),
    [anon_sym_CASE] = ACTIONS(5521),
    [anon_sym_LET] = ACTIONS(5521),
    [anon_sym_BSLASHlnot] = ACTIONS(5523),
    [anon_sym_BSLASHneg] = ACTIONS(5523),
    [anon_sym_TILDE] = ACTIONS(5521),
    [anon_sym_u00ac] = ACTIONS(5523),
    [sym_union] = ACTIONS(5521),
    [sym_powerset] = ACTIONS(5521),
    [sym_domain] = ACTIONS(5521),
    [anon_sym_DASH] = ACTIONS(5521),
    [sym_negative_dot] = ACTIONS(5523),
    [sym_enabled] = ACTIONS(5521),
    [sym_unchanged] = ACTIONS(5521),
    [anon_sym_LT_GT] = ACTIONS(5523),
    [anon_sym_u22c4] = ACTIONS(5523),
    [anon_sym_u25c7] = ACTIONS(5523),
    [anon_sym_EQ_GT] = ACTIONS(5523),
    [anon_sym_u27f9] = ACTIONS(5523),
    [anon_sym_u21d2] = ACTIONS(5523),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5523),
    [anon_sym_u21f8] = ACTIONS(5523),
    [anon_sym_u2945] = ACTIONS(5523),
    [anon_sym_BSLASHequiv] = ACTIONS(5523),
    [anon_sym_u2261] = ACTIONS(5523),
    [anon_sym_LT_EQ_GT] = ACTIONS(5523),
    [anon_sym_u27fa] = ACTIONS(5523),
    [anon_sym_u21d4] = ACTIONS(5523),
    [anon_sym_TILDE_GT] = ACTIONS(5523),
    [anon_sym_u21dd] = ACTIONS(5523),
    [anon_sym_u219d] = ACTIONS(5523),
    [anon_sym_BSLASHland] = ACTIONS(5523),
    [anon_sym_BSLASHlor] = ACTIONS(5523),
    [anon_sym_COLON_EQ] = ACTIONS(5523),
    [anon_sym_u2254] = ACTIONS(5523),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5523),
    [anon_sym_u2a74] = ACTIONS(5523),
    [anon_sym_SLASH_EQ] = ACTIONS(5523),
    [anon_sym_POUND] = ACTIONS(5521),
    [anon_sym_u2260] = ACTIONS(5523),
    [anon_sym_LT] = ACTIONS(5521),
    [sym_gt] = ACTIONS(5521),
    [anon_sym_LT_EQ] = ACTIONS(5521),
    [anon_sym_EQ_LT] = ACTIONS(5523),
    [anon_sym_BSLASHleq] = ACTIONS(5523),
    [anon_sym_u2264] = ACTIONS(5523),
    [anon_sym_GT_EQ] = ACTIONS(5523),
    [anon_sym_BSLASHgeq] = ACTIONS(5523),
    [anon_sym_u2265] = ACTIONS(5523),
    [anon_sym_BSLASHapprox] = ACTIONS(5523),
    [anon_sym_u2248] = ACTIONS(5523),
    [anon_sym_PIPE_DASH] = ACTIONS(5523),
    [anon_sym_u22a2] = ACTIONS(5523),
    [anon_sym_PIPE_EQ] = ACTIONS(5523),
    [anon_sym_u22a8] = ACTIONS(5523),
    [anon_sym_DASH_PIPE] = ACTIONS(5523),
    [anon_sym_u22a3] = ACTIONS(5523),
    [anon_sym_EQ_PIPE] = ACTIONS(5523),
    [anon_sym_u2ae4] = ACTIONS(5523),
    [anon_sym_BSLASHasymp] = ACTIONS(5523),
    [anon_sym_u224d] = ACTIONS(5523),
    [anon_sym_BSLASHcong] = ACTIONS(5523),
    [anon_sym_u2245] = ACTIONS(5523),
    [anon_sym_BSLASHdoteq] = ACTIONS(5523),
    [anon_sym_u2250] = ACTIONS(5523),
    [anon_sym_BSLASHgg] = ACTIONS(5523),
    [anon_sym_u226b] = ACTIONS(5523),
    [anon_sym_BSLASHll] = ACTIONS(5523),
    [anon_sym_u226a] = ACTIONS(5523),
    [anon_sym_BSLASHnotin] = ACTIONS(5523),
    [anon_sym_u2209] = ACTIONS(5523),
    [anon_sym_BSLASHprec] = ACTIONS(5521),
    [anon_sym_u227a] = ACTIONS(5523),
    [anon_sym_BSLASHsucc] = ACTIONS(5521),
    [anon_sym_u227b] = ACTIONS(5523),
    [anon_sym_BSLASHpreceq] = ACTIONS(5523),
    [anon_sym_u2aaf] = ACTIONS(5523),
    [anon_sym_BSLASHsucceq] = ACTIONS(5523),
    [anon_sym_u2ab0] = ACTIONS(5523),
    [anon_sym_BSLASHpropto] = ACTIONS(5523),
    [anon_sym_u221d] = ACTIONS(5523),
    [anon_sym_BSLASHsim] = ACTIONS(5521),
    [anon_sym_u223c] = ACTIONS(5523),
    [anon_sym_BSLASHsimeq] = ACTIONS(5523),
    [anon_sym_u2243] = ACTIONS(5523),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5521),
    [anon_sym_u228f] = ACTIONS(5523),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5521),
    [anon_sym_u2290] = ACTIONS(5523),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5523),
    [anon_sym_u2291] = ACTIONS(5523),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5523),
    [anon_sym_u2292] = ACTIONS(5523),
    [anon_sym_BSLASHsubset] = ACTIONS(5521),
    [anon_sym_u2282] = ACTIONS(5523),
    [anon_sym_BSLASHsupset] = ACTIONS(5521),
    [anon_sym_u2283] = ACTIONS(5523),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5523),
    [anon_sym_u2286] = ACTIONS(5523),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5523),
    [anon_sym_u2287] = ACTIONS(5523),
    [sym_compose] = ACTIONS(5523),
    [sym_map_to] = ACTIONS(5523),
    [sym_map_from] = ACTIONS(5523),
    [sym_setminus] = ACTIONS(5521),
    [anon_sym_BSLASHcap] = ACTIONS(5523),
    [anon_sym_BSLASHintersect] = ACTIONS(5523),
    [anon_sym_u2229] = ACTIONS(5523),
    [anon_sym_BSLASHcup] = ACTIONS(5523),
    [anon_sym_BSLASHunion] = ACTIONS(5523),
    [anon_sym_u222a] = ACTIONS(5523),
    [anon_sym_DOT_DOT] = ACTIONS(5521),
    [anon_sym_u2025] = ACTIONS(5523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5523),
    [anon_sym_u2026] = ACTIONS(5523),
    [anon_sym_PLUS] = ACTIONS(5521),
    [sym_plusplus] = ACTIONS(5523),
    [anon_sym_BSLASHoplus] = ACTIONS(5523),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5523),
    [anon_sym_u2295] = ACTIONS(5523),
    [anon_sym_BSLASHominus] = ACTIONS(5523),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5523),
    [anon_sym_u2296] = ACTIONS(5523),
    [sym_mod] = ACTIONS(5521),
    [sym_modmod] = ACTIONS(5523),
    [sym_vert] = ACTIONS(5521),
    [anon_sym_PIPE_PIPE] = ACTIONS(5523),
    [anon_sym_u2016] = ACTIONS(5523),
    [sym_minusminus] = ACTIONS(5523),
    [sym_amp] = ACTIONS(5521),
    [sym_ampamp] = ACTIONS(5523),
    [anon_sym_BSLASHodot] = ACTIONS(5523),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5523),
    [anon_sym_u2299] = ACTIONS(5523),
    [anon_sym_BSLASHoslash] = ACTIONS(5523),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5523),
    [anon_sym_u2298] = ACTIONS(5523),
    [anon_sym_BSLASHotimes] = ACTIONS(5523),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5523),
    [anon_sym_u2297] = ACTIONS(5523),
    [sym_mul] = ACTIONS(5521),
    [sym_mulmul] = ACTIONS(5523),
    [sym_slash] = ACTIONS(5521),
    [sym_slashslash] = ACTIONS(5523),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5523),
    [anon_sym_u25ef] = ACTIONS(5523),
    [anon_sym_BSLASHbullet] = ACTIONS(5523),
    [anon_sym_u25cf] = ACTIONS(5523),
    [anon_sym_BSLASHdiv] = ACTIONS(5523),
    [anon_sym_u00f7] = ACTIONS(5523),
    [anon_sym_BSLASHcirc] = ACTIONS(5523),
    [anon_sym_u2218] = ACTIONS(5523),
    [anon_sym_BSLASHstar] = ACTIONS(5523),
    [anon_sym_u22c6] = ACTIONS(5523),
    [anon_sym_u203c] = ACTIONS(5523),
    [sym_hashhash] = ACTIONS(5523),
    [sym_dol] = ACTIONS(5521),
    [sym_doldol] = ACTIONS(5523),
    [anon_sym_QMARK_QMARK] = ACTIONS(5523),
    [anon_sym_u2047] = ACTIONS(5523),
    [anon_sym_BSLASHsqcap] = ACTIONS(5523),
    [anon_sym_u2293] = ACTIONS(5523),
    [anon_sym_BSLASHsqcup] = ACTIONS(5523),
    [anon_sym_u2294] = ACTIONS(5523),
    [anon_sym_BSLASHuplus] = ACTIONS(5523),
    [anon_sym_u228e] = ACTIONS(5523),
    [anon_sym_BSLASHX] = ACTIONS(5523),
    [anon_sym_BSLASHtimes] = ACTIONS(5523),
    [anon_sym_u00d7] = ACTIONS(5523),
    [anon_sym_BSLASHwr] = ACTIONS(5523),
    [anon_sym_u2240] = ACTIONS(5523),
    [anon_sym_BSLASHcdot] = ACTIONS(5523),
    [anon_sym_u22c5] = ACTIONS(5523),
    [sym_pow] = ACTIONS(5521),
    [sym_powpow] = ACTIONS(5523),
    [anon_sym_CARET_PLUS] = ACTIONS(5523),
    [anon_sym_u207a] = ACTIONS(5523),
    [sym_asterisk] = ACTIONS(5523),
    [sym_sup_hash] = ACTIONS(5523),
    [sym_prime] = ACTIONS(5523),
    [sym__indent] = ACTIONS(5523),
    [sym__double_excl] = ACTIONS(5523),
  },
  [2179] = {
    [sym_block_comment] = STATE(2179),
    [sym_identifier] = ACTIONS(5525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5525),
    [anon_sym_u2208] = ACTIONS(5527),
    [anon_sym_BSLASHA] = ACTIONS(5525),
    [anon_sym_BSLASHforall] = ACTIONS(5527),
    [anon_sym_u2200] = ACTIONS(5527),
    [anon_sym_BSLASHE] = ACTIONS(5525),
    [anon_sym_BSLASHexists] = ACTIONS(5527),
    [anon_sym_u2203] = ACTIONS(5527),
    [sym_temporal_forall] = ACTIONS(5527),
    [sym_temporal_exists] = ACTIONS(5527),
    [anon_sym_LT_LT] = ACTIONS(5527),
    [anon_sym_u3008] = ACTIONS(5527),
    [anon_sym_u27e8] = ACTIONS(5527),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5527),
    [anon_sym_u25a1] = ACTIONS(5527),
    [anon_sym_AT] = ACTIONS(5525),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5527),
    [anon_sym_u2227] = ACTIONS(5527),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5527),
    [anon_sym_u2228] = ACTIONS(5527),
    [anon_sym_LPAREN] = ACTIONS(5525),
    [anon_sym_LBRACK] = ACTIONS(5525),
    [aux_sym_child_id_token1] = ACTIONS(5525),
    [sym_real_number] = ACTIONS(5527),
    [anon_sym_BSLASHb] = ACTIONS(5525),
    [anon_sym_BSLASHB] = ACTIONS(5527),
    [anon_sym_BSLASHo] = ACTIONS(5525),
    [anon_sym_BSLASHO] = ACTIONS(5527),
    [anon_sym_BSLASHh] = ACTIONS(5527),
    [anon_sym_BSLASHH] = ACTIONS(5527),
    [anon_sym_DQUOTE] = ACTIONS(5527),
    [anon_sym_TRUE] = ACTIONS(5525),
    [anon_sym_FALSE] = ACTIONS(5525),
    [sym_string_set] = ACTIONS(5525),
    [sym_boolean_set] = ACTIONS(5525),
    [anon_sym_Nat] = ACTIONS(5525),
    [anon_sym_u2115] = ACTIONS(5527),
    [anon_sym_Int] = ACTIONS(5525),
    [anon_sym_u2124] = ACTIONS(5527),
    [anon_sym_Real] = ACTIONS(5525),
    [anon_sym_u211d] = ACTIONS(5527),
    [anon_sym_CHOOSE] = ACTIONS(5525),
    [anon_sym_LBRACE] = ACTIONS(5527),
    [anon_sym_EQ] = ACTIONS(5525),
    [anon_sym_WF_] = ACTIONS(5525),
    [anon_sym_SF_] = ACTIONS(5525),
    [anon_sym_IF] = ACTIONS(5525),
    [anon_sym_CASE] = ACTIONS(5525),
    [anon_sym_LET] = ACTIONS(5525),
    [anon_sym_BSLASHlnot] = ACTIONS(5527),
    [anon_sym_BSLASHneg] = ACTIONS(5527),
    [anon_sym_TILDE] = ACTIONS(5525),
    [anon_sym_u00ac] = ACTIONS(5527),
    [sym_union] = ACTIONS(5525),
    [sym_powerset] = ACTIONS(5525),
    [sym_domain] = ACTIONS(5525),
    [anon_sym_DASH] = ACTIONS(5525),
    [sym_negative_dot] = ACTIONS(5527),
    [sym_enabled] = ACTIONS(5525),
    [sym_unchanged] = ACTIONS(5525),
    [anon_sym_LT_GT] = ACTIONS(5527),
    [anon_sym_u22c4] = ACTIONS(5527),
    [anon_sym_u25c7] = ACTIONS(5527),
    [anon_sym_EQ_GT] = ACTIONS(5527),
    [anon_sym_u27f9] = ACTIONS(5527),
    [anon_sym_u21d2] = ACTIONS(5527),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5527),
    [anon_sym_u21f8] = ACTIONS(5527),
    [anon_sym_u2945] = ACTIONS(5527),
    [anon_sym_BSLASHequiv] = ACTIONS(5527),
    [anon_sym_u2261] = ACTIONS(5527),
    [anon_sym_LT_EQ_GT] = ACTIONS(5527),
    [anon_sym_u27fa] = ACTIONS(5527),
    [anon_sym_u21d4] = ACTIONS(5527),
    [anon_sym_TILDE_GT] = ACTIONS(5527),
    [anon_sym_u21dd] = ACTIONS(5527),
    [anon_sym_u219d] = ACTIONS(5527),
    [anon_sym_BSLASHland] = ACTIONS(5527),
    [anon_sym_BSLASHlor] = ACTIONS(5527),
    [anon_sym_COLON_EQ] = ACTIONS(5527),
    [anon_sym_u2254] = ACTIONS(5527),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5527),
    [anon_sym_u2a74] = ACTIONS(5527),
    [anon_sym_SLASH_EQ] = ACTIONS(5527),
    [anon_sym_POUND] = ACTIONS(5525),
    [anon_sym_u2260] = ACTIONS(5527),
    [anon_sym_LT] = ACTIONS(5525),
    [sym_gt] = ACTIONS(5525),
    [anon_sym_LT_EQ] = ACTIONS(5525),
    [anon_sym_EQ_LT] = ACTIONS(5527),
    [anon_sym_BSLASHleq] = ACTIONS(5527),
    [anon_sym_u2264] = ACTIONS(5527),
    [anon_sym_GT_EQ] = ACTIONS(5527),
    [anon_sym_BSLASHgeq] = ACTIONS(5527),
    [anon_sym_u2265] = ACTIONS(5527),
    [anon_sym_BSLASHapprox] = ACTIONS(5527),
    [anon_sym_u2248] = ACTIONS(5527),
    [anon_sym_PIPE_DASH] = ACTIONS(5527),
    [anon_sym_u22a2] = ACTIONS(5527),
    [anon_sym_PIPE_EQ] = ACTIONS(5527),
    [anon_sym_u22a8] = ACTIONS(5527),
    [anon_sym_DASH_PIPE] = ACTIONS(5527),
    [anon_sym_u22a3] = ACTIONS(5527),
    [anon_sym_EQ_PIPE] = ACTIONS(5527),
    [anon_sym_u2ae4] = ACTIONS(5527),
    [anon_sym_BSLASHasymp] = ACTIONS(5527),
    [anon_sym_u224d] = ACTIONS(5527),
    [anon_sym_BSLASHcong] = ACTIONS(5527),
    [anon_sym_u2245] = ACTIONS(5527),
    [anon_sym_BSLASHdoteq] = ACTIONS(5527),
    [anon_sym_u2250] = ACTIONS(5527),
    [anon_sym_BSLASHgg] = ACTIONS(5527),
    [anon_sym_u226b] = ACTIONS(5527),
    [anon_sym_BSLASHll] = ACTIONS(5527),
    [anon_sym_u226a] = ACTIONS(5527),
    [anon_sym_BSLASHnotin] = ACTIONS(5527),
    [anon_sym_u2209] = ACTIONS(5527),
    [anon_sym_BSLASHprec] = ACTIONS(5525),
    [anon_sym_u227a] = ACTIONS(5527),
    [anon_sym_BSLASHsucc] = ACTIONS(5525),
    [anon_sym_u227b] = ACTIONS(5527),
    [anon_sym_BSLASHpreceq] = ACTIONS(5527),
    [anon_sym_u2aaf] = ACTIONS(5527),
    [anon_sym_BSLASHsucceq] = ACTIONS(5527),
    [anon_sym_u2ab0] = ACTIONS(5527),
    [anon_sym_BSLASHpropto] = ACTIONS(5527),
    [anon_sym_u221d] = ACTIONS(5527),
    [anon_sym_BSLASHsim] = ACTIONS(5525),
    [anon_sym_u223c] = ACTIONS(5527),
    [anon_sym_BSLASHsimeq] = ACTIONS(5527),
    [anon_sym_u2243] = ACTIONS(5527),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5525),
    [anon_sym_u228f] = ACTIONS(5527),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5525),
    [anon_sym_u2290] = ACTIONS(5527),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5527),
    [anon_sym_u2291] = ACTIONS(5527),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5527),
    [anon_sym_u2292] = ACTIONS(5527),
    [anon_sym_BSLASHsubset] = ACTIONS(5525),
    [anon_sym_u2282] = ACTIONS(5527),
    [anon_sym_BSLASHsupset] = ACTIONS(5525),
    [anon_sym_u2283] = ACTIONS(5527),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5527),
    [anon_sym_u2286] = ACTIONS(5527),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5527),
    [anon_sym_u2287] = ACTIONS(5527),
    [sym_compose] = ACTIONS(5527),
    [sym_map_to] = ACTIONS(5527),
    [sym_map_from] = ACTIONS(5527),
    [sym_setminus] = ACTIONS(5525),
    [anon_sym_BSLASHcap] = ACTIONS(5527),
    [anon_sym_BSLASHintersect] = ACTIONS(5527),
    [anon_sym_u2229] = ACTIONS(5527),
    [anon_sym_BSLASHcup] = ACTIONS(5527),
    [anon_sym_BSLASHunion] = ACTIONS(5527),
    [anon_sym_u222a] = ACTIONS(5527),
    [anon_sym_DOT_DOT] = ACTIONS(5525),
    [anon_sym_u2025] = ACTIONS(5527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5527),
    [anon_sym_u2026] = ACTIONS(5527),
    [anon_sym_PLUS] = ACTIONS(5525),
    [sym_plusplus] = ACTIONS(5527),
    [anon_sym_BSLASHoplus] = ACTIONS(5527),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5527),
    [anon_sym_u2295] = ACTIONS(5527),
    [anon_sym_BSLASHominus] = ACTIONS(5527),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5527),
    [anon_sym_u2296] = ACTIONS(5527),
    [sym_mod] = ACTIONS(5525),
    [sym_modmod] = ACTIONS(5527),
    [sym_vert] = ACTIONS(5525),
    [anon_sym_PIPE_PIPE] = ACTIONS(5527),
    [anon_sym_u2016] = ACTIONS(5527),
    [sym_minusminus] = ACTIONS(5527),
    [sym_amp] = ACTIONS(5525),
    [sym_ampamp] = ACTIONS(5527),
    [anon_sym_BSLASHodot] = ACTIONS(5527),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5527),
    [anon_sym_u2299] = ACTIONS(5527),
    [anon_sym_BSLASHoslash] = ACTIONS(5527),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5527),
    [anon_sym_u2298] = ACTIONS(5527),
    [anon_sym_BSLASHotimes] = ACTIONS(5527),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5527),
    [anon_sym_u2297] = ACTIONS(5527),
    [sym_mul] = ACTIONS(5525),
    [sym_mulmul] = ACTIONS(5527),
    [sym_slash] = ACTIONS(5525),
    [sym_slashslash] = ACTIONS(5527),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5527),
    [anon_sym_u25ef] = ACTIONS(5527),
    [anon_sym_BSLASHbullet] = ACTIONS(5527),
    [anon_sym_u25cf] = ACTIONS(5527),
    [anon_sym_BSLASHdiv] = ACTIONS(5527),
    [anon_sym_u00f7] = ACTIONS(5527),
    [anon_sym_BSLASHcirc] = ACTIONS(5527),
    [anon_sym_u2218] = ACTIONS(5527),
    [anon_sym_BSLASHstar] = ACTIONS(5527),
    [anon_sym_u22c6] = ACTIONS(5527),
    [anon_sym_u203c] = ACTIONS(5527),
    [sym_hashhash] = ACTIONS(5527),
    [sym_dol] = ACTIONS(5525),
    [sym_doldol] = ACTIONS(5527),
    [anon_sym_QMARK_QMARK] = ACTIONS(5527),
    [anon_sym_u2047] = ACTIONS(5527),
    [anon_sym_BSLASHsqcap] = ACTIONS(5527),
    [anon_sym_u2293] = ACTIONS(5527),
    [anon_sym_BSLASHsqcup] = ACTIONS(5527),
    [anon_sym_u2294] = ACTIONS(5527),
    [anon_sym_BSLASHuplus] = ACTIONS(5527),
    [anon_sym_u228e] = ACTIONS(5527),
    [anon_sym_BSLASHX] = ACTIONS(5527),
    [anon_sym_BSLASHtimes] = ACTIONS(5527),
    [anon_sym_u00d7] = ACTIONS(5527),
    [anon_sym_BSLASHwr] = ACTIONS(5527),
    [anon_sym_u2240] = ACTIONS(5527),
    [anon_sym_BSLASHcdot] = ACTIONS(5527),
    [anon_sym_u22c5] = ACTIONS(5527),
    [sym_pow] = ACTIONS(5525),
    [sym_powpow] = ACTIONS(5527),
    [anon_sym_CARET_PLUS] = ACTIONS(5527),
    [anon_sym_u207a] = ACTIONS(5527),
    [sym_asterisk] = ACTIONS(5527),
    [sym_sup_hash] = ACTIONS(5527),
    [sym_prime] = ACTIONS(5527),
    [sym__indent] = ACTIONS(5527),
    [sym__double_excl] = ACTIONS(5527),
  },
  [2180] = {
    [sym_block_comment] = STATE(2180),
    [sym_identifier] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5529),
    [anon_sym_u2208] = ACTIONS(5531),
    [anon_sym_BSLASHA] = ACTIONS(5529),
    [anon_sym_BSLASHforall] = ACTIONS(5531),
    [anon_sym_u2200] = ACTIONS(5531),
    [anon_sym_BSLASHE] = ACTIONS(5529),
    [anon_sym_BSLASHexists] = ACTIONS(5531),
    [anon_sym_u2203] = ACTIONS(5531),
    [sym_temporal_forall] = ACTIONS(5531),
    [sym_temporal_exists] = ACTIONS(5531),
    [anon_sym_LT_LT] = ACTIONS(5531),
    [anon_sym_u3008] = ACTIONS(5531),
    [anon_sym_u27e8] = ACTIONS(5531),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5531),
    [anon_sym_u25a1] = ACTIONS(5531),
    [anon_sym_AT] = ACTIONS(5529),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5531),
    [anon_sym_u2227] = ACTIONS(5531),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5531),
    [anon_sym_u2228] = ACTIONS(5531),
    [anon_sym_LPAREN] = ACTIONS(5529),
    [anon_sym_LBRACK] = ACTIONS(5529),
    [aux_sym_child_id_token1] = ACTIONS(5529),
    [sym_real_number] = ACTIONS(5531),
    [anon_sym_BSLASHb] = ACTIONS(5529),
    [anon_sym_BSLASHB] = ACTIONS(5531),
    [anon_sym_BSLASHo] = ACTIONS(5529),
    [anon_sym_BSLASHO] = ACTIONS(5531),
    [anon_sym_BSLASHh] = ACTIONS(5531),
    [anon_sym_BSLASHH] = ACTIONS(5531),
    [anon_sym_DQUOTE] = ACTIONS(5531),
    [anon_sym_TRUE] = ACTIONS(5529),
    [anon_sym_FALSE] = ACTIONS(5529),
    [sym_string_set] = ACTIONS(5529),
    [sym_boolean_set] = ACTIONS(5529),
    [anon_sym_Nat] = ACTIONS(5529),
    [anon_sym_u2115] = ACTIONS(5531),
    [anon_sym_Int] = ACTIONS(5529),
    [anon_sym_u2124] = ACTIONS(5531),
    [anon_sym_Real] = ACTIONS(5529),
    [anon_sym_u211d] = ACTIONS(5531),
    [anon_sym_CHOOSE] = ACTIONS(5529),
    [anon_sym_LBRACE] = ACTIONS(5531),
    [anon_sym_EQ] = ACTIONS(5529),
    [anon_sym_WF_] = ACTIONS(5529),
    [anon_sym_SF_] = ACTIONS(5529),
    [anon_sym_IF] = ACTIONS(5529),
    [anon_sym_CASE] = ACTIONS(5529),
    [anon_sym_LET] = ACTIONS(5529),
    [anon_sym_BSLASHlnot] = ACTIONS(5531),
    [anon_sym_BSLASHneg] = ACTIONS(5531),
    [anon_sym_TILDE] = ACTIONS(5529),
    [anon_sym_u00ac] = ACTIONS(5531),
    [sym_union] = ACTIONS(5529),
    [sym_powerset] = ACTIONS(5529),
    [sym_domain] = ACTIONS(5529),
    [anon_sym_DASH] = ACTIONS(5529),
    [sym_negative_dot] = ACTIONS(5531),
    [sym_enabled] = ACTIONS(5529),
    [sym_unchanged] = ACTIONS(5529),
    [anon_sym_LT_GT] = ACTIONS(5531),
    [anon_sym_u22c4] = ACTIONS(5531),
    [anon_sym_u25c7] = ACTIONS(5531),
    [anon_sym_EQ_GT] = ACTIONS(5531),
    [anon_sym_u27f9] = ACTIONS(5531),
    [anon_sym_u21d2] = ACTIONS(5531),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5531),
    [anon_sym_u21f8] = ACTIONS(5531),
    [anon_sym_u2945] = ACTIONS(5531),
    [anon_sym_BSLASHequiv] = ACTIONS(5531),
    [anon_sym_u2261] = ACTIONS(5531),
    [anon_sym_LT_EQ_GT] = ACTIONS(5531),
    [anon_sym_u27fa] = ACTIONS(5531),
    [anon_sym_u21d4] = ACTIONS(5531),
    [anon_sym_TILDE_GT] = ACTIONS(5531),
    [anon_sym_u21dd] = ACTIONS(5531),
    [anon_sym_u219d] = ACTIONS(5531),
    [anon_sym_BSLASHland] = ACTIONS(5531),
    [anon_sym_BSLASHlor] = ACTIONS(5531),
    [anon_sym_COLON_EQ] = ACTIONS(5531),
    [anon_sym_u2254] = ACTIONS(5531),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5531),
    [anon_sym_u2a74] = ACTIONS(5531),
    [anon_sym_SLASH_EQ] = ACTIONS(5531),
    [anon_sym_POUND] = ACTIONS(5529),
    [anon_sym_u2260] = ACTIONS(5531),
    [anon_sym_LT] = ACTIONS(5529),
    [sym_gt] = ACTIONS(5529),
    [anon_sym_LT_EQ] = ACTIONS(5529),
    [anon_sym_EQ_LT] = ACTIONS(5531),
    [anon_sym_BSLASHleq] = ACTIONS(5531),
    [anon_sym_u2264] = ACTIONS(5531),
    [anon_sym_GT_EQ] = ACTIONS(5531),
    [anon_sym_BSLASHgeq] = ACTIONS(5531),
    [anon_sym_u2265] = ACTIONS(5531),
    [anon_sym_BSLASHapprox] = ACTIONS(5531),
    [anon_sym_u2248] = ACTIONS(5531),
    [anon_sym_PIPE_DASH] = ACTIONS(5531),
    [anon_sym_u22a2] = ACTIONS(5531),
    [anon_sym_PIPE_EQ] = ACTIONS(5531),
    [anon_sym_u22a8] = ACTIONS(5531),
    [anon_sym_DASH_PIPE] = ACTIONS(5531),
    [anon_sym_u22a3] = ACTIONS(5531),
    [anon_sym_EQ_PIPE] = ACTIONS(5531),
    [anon_sym_u2ae4] = ACTIONS(5531),
    [anon_sym_BSLASHasymp] = ACTIONS(5531),
    [anon_sym_u224d] = ACTIONS(5531),
    [anon_sym_BSLASHcong] = ACTIONS(5531),
    [anon_sym_u2245] = ACTIONS(5531),
    [anon_sym_BSLASHdoteq] = ACTIONS(5531),
    [anon_sym_u2250] = ACTIONS(5531),
    [anon_sym_BSLASHgg] = ACTIONS(5531),
    [anon_sym_u226b] = ACTIONS(5531),
    [anon_sym_BSLASHll] = ACTIONS(5531),
    [anon_sym_u226a] = ACTIONS(5531),
    [anon_sym_BSLASHnotin] = ACTIONS(5531),
    [anon_sym_u2209] = ACTIONS(5531),
    [anon_sym_BSLASHprec] = ACTIONS(5529),
    [anon_sym_u227a] = ACTIONS(5531),
    [anon_sym_BSLASHsucc] = ACTIONS(5529),
    [anon_sym_u227b] = ACTIONS(5531),
    [anon_sym_BSLASHpreceq] = ACTIONS(5531),
    [anon_sym_u2aaf] = ACTIONS(5531),
    [anon_sym_BSLASHsucceq] = ACTIONS(5531),
    [anon_sym_u2ab0] = ACTIONS(5531),
    [anon_sym_BSLASHpropto] = ACTIONS(5531),
    [anon_sym_u221d] = ACTIONS(5531),
    [anon_sym_BSLASHsim] = ACTIONS(5529),
    [anon_sym_u223c] = ACTIONS(5531),
    [anon_sym_BSLASHsimeq] = ACTIONS(5531),
    [anon_sym_u2243] = ACTIONS(5531),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5529),
    [anon_sym_u228f] = ACTIONS(5531),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5529),
    [anon_sym_u2290] = ACTIONS(5531),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5531),
    [anon_sym_u2291] = ACTIONS(5531),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5531),
    [anon_sym_u2292] = ACTIONS(5531),
    [anon_sym_BSLASHsubset] = ACTIONS(5529),
    [anon_sym_u2282] = ACTIONS(5531),
    [anon_sym_BSLASHsupset] = ACTIONS(5529),
    [anon_sym_u2283] = ACTIONS(5531),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5531),
    [anon_sym_u2286] = ACTIONS(5531),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5531),
    [anon_sym_u2287] = ACTIONS(5531),
    [sym_compose] = ACTIONS(5531),
    [sym_map_to] = ACTIONS(5531),
    [sym_map_from] = ACTIONS(5531),
    [sym_setminus] = ACTIONS(5529),
    [anon_sym_BSLASHcap] = ACTIONS(5531),
    [anon_sym_BSLASHintersect] = ACTIONS(5531),
    [anon_sym_u2229] = ACTIONS(5531),
    [anon_sym_BSLASHcup] = ACTIONS(5531),
    [anon_sym_BSLASHunion] = ACTIONS(5531),
    [anon_sym_u222a] = ACTIONS(5531),
    [anon_sym_DOT_DOT] = ACTIONS(5529),
    [anon_sym_u2025] = ACTIONS(5531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5531),
    [anon_sym_u2026] = ACTIONS(5531),
    [anon_sym_PLUS] = ACTIONS(5529),
    [sym_plusplus] = ACTIONS(5531),
    [anon_sym_BSLASHoplus] = ACTIONS(5531),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5531),
    [anon_sym_u2295] = ACTIONS(5531),
    [anon_sym_BSLASHominus] = ACTIONS(5531),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5531),
    [anon_sym_u2296] = ACTIONS(5531),
    [sym_mod] = ACTIONS(5529),
    [sym_modmod] = ACTIONS(5531),
    [sym_vert] = ACTIONS(5529),
    [anon_sym_PIPE_PIPE] = ACTIONS(5531),
    [anon_sym_u2016] = ACTIONS(5531),
    [sym_minusminus] = ACTIONS(5531),
    [sym_amp] = ACTIONS(5529),
    [sym_ampamp] = ACTIONS(5531),
    [anon_sym_BSLASHodot] = ACTIONS(5531),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5531),
    [anon_sym_u2299] = ACTIONS(5531),
    [anon_sym_BSLASHoslash] = ACTIONS(5531),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5531),
    [anon_sym_u2298] = ACTIONS(5531),
    [anon_sym_BSLASHotimes] = ACTIONS(5531),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5531),
    [anon_sym_u2297] = ACTIONS(5531),
    [sym_mul] = ACTIONS(5529),
    [sym_mulmul] = ACTIONS(5531),
    [sym_slash] = ACTIONS(5529),
    [sym_slashslash] = ACTIONS(5531),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5531),
    [anon_sym_u25ef] = ACTIONS(5531),
    [anon_sym_BSLASHbullet] = ACTIONS(5531),
    [anon_sym_u25cf] = ACTIONS(5531),
    [anon_sym_BSLASHdiv] = ACTIONS(5531),
    [anon_sym_u00f7] = ACTIONS(5531),
    [anon_sym_BSLASHcirc] = ACTIONS(5531),
    [anon_sym_u2218] = ACTIONS(5531),
    [anon_sym_BSLASHstar] = ACTIONS(5531),
    [anon_sym_u22c6] = ACTIONS(5531),
    [anon_sym_u203c] = ACTIONS(5531),
    [sym_hashhash] = ACTIONS(5531),
    [sym_dol] = ACTIONS(5529),
    [sym_doldol] = ACTIONS(5531),
    [anon_sym_QMARK_QMARK] = ACTIONS(5531),
    [anon_sym_u2047] = ACTIONS(5531),
    [anon_sym_BSLASHsqcap] = ACTIONS(5531),
    [anon_sym_u2293] = ACTIONS(5531),
    [anon_sym_BSLASHsqcup] = ACTIONS(5531),
    [anon_sym_u2294] = ACTIONS(5531),
    [anon_sym_BSLASHuplus] = ACTIONS(5531),
    [anon_sym_u228e] = ACTIONS(5531),
    [anon_sym_BSLASHX] = ACTIONS(5531),
    [anon_sym_BSLASHtimes] = ACTIONS(5531),
    [anon_sym_u00d7] = ACTIONS(5531),
    [anon_sym_BSLASHwr] = ACTIONS(5531),
    [anon_sym_u2240] = ACTIONS(5531),
    [anon_sym_BSLASHcdot] = ACTIONS(5531),
    [anon_sym_u22c5] = ACTIONS(5531),
    [sym_pow] = ACTIONS(5529),
    [sym_powpow] = ACTIONS(5531),
    [anon_sym_CARET_PLUS] = ACTIONS(5531),
    [anon_sym_u207a] = ACTIONS(5531),
    [sym_asterisk] = ACTIONS(5531),
    [sym_sup_hash] = ACTIONS(5531),
    [sym_prime] = ACTIONS(5531),
    [sym__indent] = ACTIONS(5531),
    [sym__double_excl] = ACTIONS(5531),
  },
  [2181] = {
    [sym_block_comment] = STATE(2181),
    [sym_identifier] = ACTIONS(5533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5533),
    [anon_sym_u2208] = ACTIONS(5535),
    [anon_sym_BSLASHA] = ACTIONS(5533),
    [anon_sym_BSLASHforall] = ACTIONS(5535),
    [anon_sym_u2200] = ACTIONS(5535),
    [anon_sym_BSLASHE] = ACTIONS(5533),
    [anon_sym_BSLASHexists] = ACTIONS(5535),
    [anon_sym_u2203] = ACTIONS(5535),
    [sym_temporal_forall] = ACTIONS(5535),
    [sym_temporal_exists] = ACTIONS(5535),
    [anon_sym_LT_LT] = ACTIONS(5535),
    [anon_sym_u3008] = ACTIONS(5535),
    [anon_sym_u27e8] = ACTIONS(5535),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5535),
    [anon_sym_u25a1] = ACTIONS(5535),
    [anon_sym_AT] = ACTIONS(5533),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5535),
    [anon_sym_u2227] = ACTIONS(5535),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5535),
    [anon_sym_u2228] = ACTIONS(5535),
    [anon_sym_LPAREN] = ACTIONS(5533),
    [anon_sym_LBRACK] = ACTIONS(5533),
    [aux_sym_child_id_token1] = ACTIONS(5533),
    [sym_real_number] = ACTIONS(5535),
    [anon_sym_BSLASHb] = ACTIONS(5533),
    [anon_sym_BSLASHB] = ACTIONS(5535),
    [anon_sym_BSLASHo] = ACTIONS(5533),
    [anon_sym_BSLASHO] = ACTIONS(5535),
    [anon_sym_BSLASHh] = ACTIONS(5535),
    [anon_sym_BSLASHH] = ACTIONS(5535),
    [anon_sym_DQUOTE] = ACTIONS(5535),
    [anon_sym_TRUE] = ACTIONS(5533),
    [anon_sym_FALSE] = ACTIONS(5533),
    [sym_string_set] = ACTIONS(5533),
    [sym_boolean_set] = ACTIONS(5533),
    [anon_sym_Nat] = ACTIONS(5533),
    [anon_sym_u2115] = ACTIONS(5535),
    [anon_sym_Int] = ACTIONS(5533),
    [anon_sym_u2124] = ACTIONS(5535),
    [anon_sym_Real] = ACTIONS(5533),
    [anon_sym_u211d] = ACTIONS(5535),
    [anon_sym_CHOOSE] = ACTIONS(5533),
    [anon_sym_LBRACE] = ACTIONS(5535),
    [anon_sym_EQ] = ACTIONS(5533),
    [anon_sym_WF_] = ACTIONS(5533),
    [anon_sym_SF_] = ACTIONS(5533),
    [anon_sym_IF] = ACTIONS(5533),
    [anon_sym_CASE] = ACTIONS(5533),
    [anon_sym_LET] = ACTIONS(5533),
    [anon_sym_BSLASHlnot] = ACTIONS(5535),
    [anon_sym_BSLASHneg] = ACTIONS(5535),
    [anon_sym_TILDE] = ACTIONS(5533),
    [anon_sym_u00ac] = ACTIONS(5535),
    [sym_union] = ACTIONS(5533),
    [sym_powerset] = ACTIONS(5533),
    [sym_domain] = ACTIONS(5533),
    [anon_sym_DASH] = ACTIONS(5533),
    [sym_negative_dot] = ACTIONS(5535),
    [sym_enabled] = ACTIONS(5533),
    [sym_unchanged] = ACTIONS(5533),
    [anon_sym_LT_GT] = ACTIONS(5535),
    [anon_sym_u22c4] = ACTIONS(5535),
    [anon_sym_u25c7] = ACTIONS(5535),
    [anon_sym_EQ_GT] = ACTIONS(5535),
    [anon_sym_u27f9] = ACTIONS(5535),
    [anon_sym_u21d2] = ACTIONS(5535),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5535),
    [anon_sym_u21f8] = ACTIONS(5535),
    [anon_sym_u2945] = ACTIONS(5535),
    [anon_sym_BSLASHequiv] = ACTIONS(5535),
    [anon_sym_u2261] = ACTIONS(5535),
    [anon_sym_LT_EQ_GT] = ACTIONS(5535),
    [anon_sym_u27fa] = ACTIONS(5535),
    [anon_sym_u21d4] = ACTIONS(5535),
    [anon_sym_TILDE_GT] = ACTIONS(5535),
    [anon_sym_u21dd] = ACTIONS(5535),
    [anon_sym_u219d] = ACTIONS(5535),
    [anon_sym_BSLASHland] = ACTIONS(5535),
    [anon_sym_BSLASHlor] = ACTIONS(5535),
    [anon_sym_COLON_EQ] = ACTIONS(5535),
    [anon_sym_u2254] = ACTIONS(5535),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5535),
    [anon_sym_u2a74] = ACTIONS(5535),
    [anon_sym_SLASH_EQ] = ACTIONS(5535),
    [anon_sym_POUND] = ACTIONS(5533),
    [anon_sym_u2260] = ACTIONS(5535),
    [anon_sym_LT] = ACTIONS(5533),
    [sym_gt] = ACTIONS(5533),
    [anon_sym_LT_EQ] = ACTIONS(5533),
    [anon_sym_EQ_LT] = ACTIONS(5535),
    [anon_sym_BSLASHleq] = ACTIONS(5535),
    [anon_sym_u2264] = ACTIONS(5535),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_BSLASHgeq] = ACTIONS(5535),
    [anon_sym_u2265] = ACTIONS(5535),
    [anon_sym_BSLASHapprox] = ACTIONS(5535),
    [anon_sym_u2248] = ACTIONS(5535),
    [anon_sym_PIPE_DASH] = ACTIONS(5535),
    [anon_sym_u22a2] = ACTIONS(5535),
    [anon_sym_PIPE_EQ] = ACTIONS(5535),
    [anon_sym_u22a8] = ACTIONS(5535),
    [anon_sym_DASH_PIPE] = ACTIONS(5535),
    [anon_sym_u22a3] = ACTIONS(5535),
    [anon_sym_EQ_PIPE] = ACTIONS(5535),
    [anon_sym_u2ae4] = ACTIONS(5535),
    [anon_sym_BSLASHasymp] = ACTIONS(5535),
    [anon_sym_u224d] = ACTIONS(5535),
    [anon_sym_BSLASHcong] = ACTIONS(5535),
    [anon_sym_u2245] = ACTIONS(5535),
    [anon_sym_BSLASHdoteq] = ACTIONS(5535),
    [anon_sym_u2250] = ACTIONS(5535),
    [anon_sym_BSLASHgg] = ACTIONS(5535),
    [anon_sym_u226b] = ACTIONS(5535),
    [anon_sym_BSLASHll] = ACTIONS(5535),
    [anon_sym_u226a] = ACTIONS(5535),
    [anon_sym_BSLASHnotin] = ACTIONS(5535),
    [anon_sym_u2209] = ACTIONS(5535),
    [anon_sym_BSLASHprec] = ACTIONS(5533),
    [anon_sym_u227a] = ACTIONS(5535),
    [anon_sym_BSLASHsucc] = ACTIONS(5533),
    [anon_sym_u227b] = ACTIONS(5535),
    [anon_sym_BSLASHpreceq] = ACTIONS(5535),
    [anon_sym_u2aaf] = ACTIONS(5535),
    [anon_sym_BSLASHsucceq] = ACTIONS(5535),
    [anon_sym_u2ab0] = ACTIONS(5535),
    [anon_sym_BSLASHpropto] = ACTIONS(5535),
    [anon_sym_u221d] = ACTIONS(5535),
    [anon_sym_BSLASHsim] = ACTIONS(5533),
    [anon_sym_u223c] = ACTIONS(5535),
    [anon_sym_BSLASHsimeq] = ACTIONS(5535),
    [anon_sym_u2243] = ACTIONS(5535),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5533),
    [anon_sym_u228f] = ACTIONS(5535),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5533),
    [anon_sym_u2290] = ACTIONS(5535),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5535),
    [anon_sym_u2291] = ACTIONS(5535),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5535),
    [anon_sym_u2292] = ACTIONS(5535),
    [anon_sym_BSLASHsubset] = ACTIONS(5533),
    [anon_sym_u2282] = ACTIONS(5535),
    [anon_sym_BSLASHsupset] = ACTIONS(5533),
    [anon_sym_u2283] = ACTIONS(5535),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5535),
    [anon_sym_u2286] = ACTIONS(5535),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5535),
    [anon_sym_u2287] = ACTIONS(5535),
    [sym_compose] = ACTIONS(5535),
    [sym_map_to] = ACTIONS(5535),
    [sym_map_from] = ACTIONS(5535),
    [sym_setminus] = ACTIONS(5533),
    [anon_sym_BSLASHcap] = ACTIONS(5535),
    [anon_sym_BSLASHintersect] = ACTIONS(5535),
    [anon_sym_u2229] = ACTIONS(5535),
    [anon_sym_BSLASHcup] = ACTIONS(5535),
    [anon_sym_BSLASHunion] = ACTIONS(5535),
    [anon_sym_u222a] = ACTIONS(5535),
    [anon_sym_DOT_DOT] = ACTIONS(5533),
    [anon_sym_u2025] = ACTIONS(5535),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5535),
    [anon_sym_u2026] = ACTIONS(5535),
    [anon_sym_PLUS] = ACTIONS(5533),
    [sym_plusplus] = ACTIONS(5535),
    [anon_sym_BSLASHoplus] = ACTIONS(5535),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5535),
    [anon_sym_u2295] = ACTIONS(5535),
    [anon_sym_BSLASHominus] = ACTIONS(5535),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5535),
    [anon_sym_u2296] = ACTIONS(5535),
    [sym_mod] = ACTIONS(5533),
    [sym_modmod] = ACTIONS(5535),
    [sym_vert] = ACTIONS(5533),
    [anon_sym_PIPE_PIPE] = ACTIONS(5535),
    [anon_sym_u2016] = ACTIONS(5535),
    [sym_minusminus] = ACTIONS(5535),
    [sym_amp] = ACTIONS(5533),
    [sym_ampamp] = ACTIONS(5535),
    [anon_sym_BSLASHodot] = ACTIONS(5535),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5535),
    [anon_sym_u2299] = ACTIONS(5535),
    [anon_sym_BSLASHoslash] = ACTIONS(5535),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5535),
    [anon_sym_u2298] = ACTIONS(5535),
    [anon_sym_BSLASHotimes] = ACTIONS(5535),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5535),
    [anon_sym_u2297] = ACTIONS(5535),
    [sym_mul] = ACTIONS(5533),
    [sym_mulmul] = ACTIONS(5535),
    [sym_slash] = ACTIONS(5533),
    [sym_slashslash] = ACTIONS(5535),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5535),
    [anon_sym_u25ef] = ACTIONS(5535),
    [anon_sym_BSLASHbullet] = ACTIONS(5535),
    [anon_sym_u25cf] = ACTIONS(5535),
    [anon_sym_BSLASHdiv] = ACTIONS(5535),
    [anon_sym_u00f7] = ACTIONS(5535),
    [anon_sym_BSLASHcirc] = ACTIONS(5535),
    [anon_sym_u2218] = ACTIONS(5535),
    [anon_sym_BSLASHstar] = ACTIONS(5535),
    [anon_sym_u22c6] = ACTIONS(5535),
    [anon_sym_u203c] = ACTIONS(5535),
    [sym_hashhash] = ACTIONS(5535),
    [sym_dol] = ACTIONS(5533),
    [sym_doldol] = ACTIONS(5535),
    [anon_sym_QMARK_QMARK] = ACTIONS(5535),
    [anon_sym_u2047] = ACTIONS(5535),
    [anon_sym_BSLASHsqcap] = ACTIONS(5535),
    [anon_sym_u2293] = ACTIONS(5535),
    [anon_sym_BSLASHsqcup] = ACTIONS(5535),
    [anon_sym_u2294] = ACTIONS(5535),
    [anon_sym_BSLASHuplus] = ACTIONS(5535),
    [anon_sym_u228e] = ACTIONS(5535),
    [anon_sym_BSLASHX] = ACTIONS(5535),
    [anon_sym_BSLASHtimes] = ACTIONS(5535),
    [anon_sym_u00d7] = ACTIONS(5535),
    [anon_sym_BSLASHwr] = ACTIONS(5535),
    [anon_sym_u2240] = ACTIONS(5535),
    [anon_sym_BSLASHcdot] = ACTIONS(5535),
    [anon_sym_u22c5] = ACTIONS(5535),
    [sym_pow] = ACTIONS(5533),
    [sym_powpow] = ACTIONS(5535),
    [anon_sym_CARET_PLUS] = ACTIONS(5535),
    [anon_sym_u207a] = ACTIONS(5535),
    [sym_asterisk] = ACTIONS(5535),
    [sym_sup_hash] = ACTIONS(5535),
    [sym_prime] = ACTIONS(5535),
    [sym__indent] = ACTIONS(5535),
    [sym__double_excl] = ACTIONS(5535),
  },
  [2182] = {
    [sym_block_comment] = STATE(2182),
    [sym_identifier] = ACTIONS(5537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5537),
    [anon_sym_u2208] = ACTIONS(5539),
    [anon_sym_BSLASHA] = ACTIONS(5537),
    [anon_sym_BSLASHforall] = ACTIONS(5539),
    [anon_sym_u2200] = ACTIONS(5539),
    [anon_sym_BSLASHE] = ACTIONS(5537),
    [anon_sym_BSLASHexists] = ACTIONS(5539),
    [anon_sym_u2203] = ACTIONS(5539),
    [sym_temporal_forall] = ACTIONS(5539),
    [sym_temporal_exists] = ACTIONS(5539),
    [anon_sym_LT_LT] = ACTIONS(5539),
    [anon_sym_u3008] = ACTIONS(5539),
    [anon_sym_u27e8] = ACTIONS(5539),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5539),
    [anon_sym_u25a1] = ACTIONS(5539),
    [anon_sym_AT] = ACTIONS(5537),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5539),
    [anon_sym_u2227] = ACTIONS(5539),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5539),
    [anon_sym_u2228] = ACTIONS(5539),
    [anon_sym_LPAREN] = ACTIONS(5537),
    [anon_sym_LBRACK] = ACTIONS(5537),
    [aux_sym_child_id_token1] = ACTIONS(5537),
    [sym_real_number] = ACTIONS(5539),
    [anon_sym_BSLASHb] = ACTIONS(5537),
    [anon_sym_BSLASHB] = ACTIONS(5539),
    [anon_sym_BSLASHo] = ACTIONS(5537),
    [anon_sym_BSLASHO] = ACTIONS(5539),
    [anon_sym_BSLASHh] = ACTIONS(5539),
    [anon_sym_BSLASHH] = ACTIONS(5539),
    [anon_sym_DQUOTE] = ACTIONS(5539),
    [anon_sym_TRUE] = ACTIONS(5537),
    [anon_sym_FALSE] = ACTIONS(5537),
    [sym_string_set] = ACTIONS(5537),
    [sym_boolean_set] = ACTIONS(5537),
    [anon_sym_Nat] = ACTIONS(5537),
    [anon_sym_u2115] = ACTIONS(5539),
    [anon_sym_Int] = ACTIONS(5537),
    [anon_sym_u2124] = ACTIONS(5539),
    [anon_sym_Real] = ACTIONS(5537),
    [anon_sym_u211d] = ACTIONS(5539),
    [anon_sym_CHOOSE] = ACTIONS(5537),
    [anon_sym_LBRACE] = ACTIONS(5539),
    [anon_sym_EQ] = ACTIONS(5537),
    [anon_sym_WF_] = ACTIONS(5537),
    [anon_sym_SF_] = ACTIONS(5537),
    [anon_sym_IF] = ACTIONS(5537),
    [anon_sym_CASE] = ACTIONS(5537),
    [anon_sym_LET] = ACTIONS(5537),
    [anon_sym_BSLASHlnot] = ACTIONS(5539),
    [anon_sym_BSLASHneg] = ACTIONS(5539),
    [anon_sym_TILDE] = ACTIONS(5537),
    [anon_sym_u00ac] = ACTIONS(5539),
    [sym_union] = ACTIONS(5537),
    [sym_powerset] = ACTIONS(5537),
    [sym_domain] = ACTIONS(5537),
    [anon_sym_DASH] = ACTIONS(5537),
    [sym_negative_dot] = ACTIONS(5539),
    [sym_enabled] = ACTIONS(5537),
    [sym_unchanged] = ACTIONS(5537),
    [anon_sym_LT_GT] = ACTIONS(5539),
    [anon_sym_u22c4] = ACTIONS(5539),
    [anon_sym_u25c7] = ACTIONS(5539),
    [anon_sym_EQ_GT] = ACTIONS(5539),
    [anon_sym_u27f9] = ACTIONS(5539),
    [anon_sym_u21d2] = ACTIONS(5539),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5539),
    [anon_sym_u21f8] = ACTIONS(5539),
    [anon_sym_u2945] = ACTIONS(5539),
    [anon_sym_BSLASHequiv] = ACTIONS(5539),
    [anon_sym_u2261] = ACTIONS(5539),
    [anon_sym_LT_EQ_GT] = ACTIONS(5539),
    [anon_sym_u27fa] = ACTIONS(5539),
    [anon_sym_u21d4] = ACTIONS(5539),
    [anon_sym_TILDE_GT] = ACTIONS(5539),
    [anon_sym_u21dd] = ACTIONS(5539),
    [anon_sym_u219d] = ACTIONS(5539),
    [anon_sym_BSLASHland] = ACTIONS(5539),
    [anon_sym_BSLASHlor] = ACTIONS(5539),
    [anon_sym_COLON_EQ] = ACTIONS(5539),
    [anon_sym_u2254] = ACTIONS(5539),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5539),
    [anon_sym_u2a74] = ACTIONS(5539),
    [anon_sym_SLASH_EQ] = ACTIONS(5539),
    [anon_sym_POUND] = ACTIONS(5537),
    [anon_sym_u2260] = ACTIONS(5539),
    [anon_sym_LT] = ACTIONS(5537),
    [sym_gt] = ACTIONS(5537),
    [anon_sym_LT_EQ] = ACTIONS(5537),
    [anon_sym_EQ_LT] = ACTIONS(5539),
    [anon_sym_BSLASHleq] = ACTIONS(5539),
    [anon_sym_u2264] = ACTIONS(5539),
    [anon_sym_GT_EQ] = ACTIONS(5539),
    [anon_sym_BSLASHgeq] = ACTIONS(5539),
    [anon_sym_u2265] = ACTIONS(5539),
    [anon_sym_BSLASHapprox] = ACTIONS(5539),
    [anon_sym_u2248] = ACTIONS(5539),
    [anon_sym_PIPE_DASH] = ACTIONS(5539),
    [anon_sym_u22a2] = ACTIONS(5539),
    [anon_sym_PIPE_EQ] = ACTIONS(5539),
    [anon_sym_u22a8] = ACTIONS(5539),
    [anon_sym_DASH_PIPE] = ACTIONS(5539),
    [anon_sym_u22a3] = ACTIONS(5539),
    [anon_sym_EQ_PIPE] = ACTIONS(5539),
    [anon_sym_u2ae4] = ACTIONS(5539),
    [anon_sym_BSLASHasymp] = ACTIONS(5539),
    [anon_sym_u224d] = ACTIONS(5539),
    [anon_sym_BSLASHcong] = ACTIONS(5539),
    [anon_sym_u2245] = ACTIONS(5539),
    [anon_sym_BSLASHdoteq] = ACTIONS(5539),
    [anon_sym_u2250] = ACTIONS(5539),
    [anon_sym_BSLASHgg] = ACTIONS(5539),
    [anon_sym_u226b] = ACTIONS(5539),
    [anon_sym_BSLASHll] = ACTIONS(5539),
    [anon_sym_u226a] = ACTIONS(5539),
    [anon_sym_BSLASHnotin] = ACTIONS(5539),
    [anon_sym_u2209] = ACTIONS(5539),
    [anon_sym_BSLASHprec] = ACTIONS(5537),
    [anon_sym_u227a] = ACTIONS(5539),
    [anon_sym_BSLASHsucc] = ACTIONS(5537),
    [anon_sym_u227b] = ACTIONS(5539),
    [anon_sym_BSLASHpreceq] = ACTIONS(5539),
    [anon_sym_u2aaf] = ACTIONS(5539),
    [anon_sym_BSLASHsucceq] = ACTIONS(5539),
    [anon_sym_u2ab0] = ACTIONS(5539),
    [anon_sym_BSLASHpropto] = ACTIONS(5539),
    [anon_sym_u221d] = ACTIONS(5539),
    [anon_sym_BSLASHsim] = ACTIONS(5537),
    [anon_sym_u223c] = ACTIONS(5539),
    [anon_sym_BSLASHsimeq] = ACTIONS(5539),
    [anon_sym_u2243] = ACTIONS(5539),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5537),
    [anon_sym_u228f] = ACTIONS(5539),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5537),
    [anon_sym_u2290] = ACTIONS(5539),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5539),
    [anon_sym_u2291] = ACTIONS(5539),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5539),
    [anon_sym_u2292] = ACTIONS(5539),
    [anon_sym_BSLASHsubset] = ACTIONS(5537),
    [anon_sym_u2282] = ACTIONS(5539),
    [anon_sym_BSLASHsupset] = ACTIONS(5537),
    [anon_sym_u2283] = ACTIONS(5539),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5539),
    [anon_sym_u2286] = ACTIONS(5539),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5539),
    [anon_sym_u2287] = ACTIONS(5539),
    [sym_compose] = ACTIONS(5539),
    [sym_map_to] = ACTIONS(5539),
    [sym_map_from] = ACTIONS(5539),
    [sym_setminus] = ACTIONS(5537),
    [anon_sym_BSLASHcap] = ACTIONS(5539),
    [anon_sym_BSLASHintersect] = ACTIONS(5539),
    [anon_sym_u2229] = ACTIONS(5539),
    [anon_sym_BSLASHcup] = ACTIONS(5539),
    [anon_sym_BSLASHunion] = ACTIONS(5539),
    [anon_sym_u222a] = ACTIONS(5539),
    [anon_sym_DOT_DOT] = ACTIONS(5537),
    [anon_sym_u2025] = ACTIONS(5539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5539),
    [anon_sym_u2026] = ACTIONS(5539),
    [anon_sym_PLUS] = ACTIONS(5537),
    [sym_plusplus] = ACTIONS(5539),
    [anon_sym_BSLASHoplus] = ACTIONS(5539),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5539),
    [anon_sym_u2295] = ACTIONS(5539),
    [anon_sym_BSLASHominus] = ACTIONS(5539),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5539),
    [anon_sym_u2296] = ACTIONS(5539),
    [sym_mod] = ACTIONS(5537),
    [sym_modmod] = ACTIONS(5539),
    [sym_vert] = ACTIONS(5537),
    [anon_sym_PIPE_PIPE] = ACTIONS(5539),
    [anon_sym_u2016] = ACTIONS(5539),
    [sym_minusminus] = ACTIONS(5539),
    [sym_amp] = ACTIONS(5537),
    [sym_ampamp] = ACTIONS(5539),
    [anon_sym_BSLASHodot] = ACTIONS(5539),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5539),
    [anon_sym_u2299] = ACTIONS(5539),
    [anon_sym_BSLASHoslash] = ACTIONS(5539),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5539),
    [anon_sym_u2298] = ACTIONS(5539),
    [anon_sym_BSLASHotimes] = ACTIONS(5539),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5539),
    [anon_sym_u2297] = ACTIONS(5539),
    [sym_mul] = ACTIONS(5537),
    [sym_mulmul] = ACTIONS(5539),
    [sym_slash] = ACTIONS(5537),
    [sym_slashslash] = ACTIONS(5539),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5539),
    [anon_sym_u25ef] = ACTIONS(5539),
    [anon_sym_BSLASHbullet] = ACTIONS(5539),
    [anon_sym_u25cf] = ACTIONS(5539),
    [anon_sym_BSLASHdiv] = ACTIONS(5539),
    [anon_sym_u00f7] = ACTIONS(5539),
    [anon_sym_BSLASHcirc] = ACTIONS(5539),
    [anon_sym_u2218] = ACTIONS(5539),
    [anon_sym_BSLASHstar] = ACTIONS(5539),
    [anon_sym_u22c6] = ACTIONS(5539),
    [anon_sym_u203c] = ACTIONS(5539),
    [sym_hashhash] = ACTIONS(5539),
    [sym_dol] = ACTIONS(5537),
    [sym_doldol] = ACTIONS(5539),
    [anon_sym_QMARK_QMARK] = ACTIONS(5539),
    [anon_sym_u2047] = ACTIONS(5539),
    [anon_sym_BSLASHsqcap] = ACTIONS(5539),
    [anon_sym_u2293] = ACTIONS(5539),
    [anon_sym_BSLASHsqcup] = ACTIONS(5539),
    [anon_sym_u2294] = ACTIONS(5539),
    [anon_sym_BSLASHuplus] = ACTIONS(5539),
    [anon_sym_u228e] = ACTIONS(5539),
    [anon_sym_BSLASHX] = ACTIONS(5539),
    [anon_sym_BSLASHtimes] = ACTIONS(5539),
    [anon_sym_u00d7] = ACTIONS(5539),
    [anon_sym_BSLASHwr] = ACTIONS(5539),
    [anon_sym_u2240] = ACTIONS(5539),
    [anon_sym_BSLASHcdot] = ACTIONS(5539),
    [anon_sym_u22c5] = ACTIONS(5539),
    [sym_pow] = ACTIONS(5537),
    [sym_powpow] = ACTIONS(5539),
    [anon_sym_CARET_PLUS] = ACTIONS(5539),
    [anon_sym_u207a] = ACTIONS(5539),
    [sym_asterisk] = ACTIONS(5539),
    [sym_sup_hash] = ACTIONS(5539),
    [sym_prime] = ACTIONS(5539),
    [sym__indent] = ACTIONS(5539),
    [sym__double_excl] = ACTIONS(5539),
  },
  [2183] = {
    [sym_block_comment] = STATE(2183),
    [sym_identifier] = ACTIONS(5541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5541),
    [anon_sym_u2208] = ACTIONS(5543),
    [anon_sym_BSLASHA] = ACTIONS(5541),
    [anon_sym_BSLASHforall] = ACTIONS(5543),
    [anon_sym_u2200] = ACTIONS(5543),
    [anon_sym_BSLASHE] = ACTIONS(5541),
    [anon_sym_BSLASHexists] = ACTIONS(5543),
    [anon_sym_u2203] = ACTIONS(5543),
    [sym_temporal_forall] = ACTIONS(5543),
    [sym_temporal_exists] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5543),
    [anon_sym_u3008] = ACTIONS(5543),
    [anon_sym_u27e8] = ACTIONS(5543),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5543),
    [anon_sym_u25a1] = ACTIONS(5543),
    [anon_sym_AT] = ACTIONS(5541),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5543),
    [anon_sym_u2227] = ACTIONS(5543),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5543),
    [anon_sym_u2228] = ACTIONS(5543),
    [anon_sym_LPAREN] = ACTIONS(5541),
    [anon_sym_LBRACK] = ACTIONS(5541),
    [aux_sym_child_id_token1] = ACTIONS(5541),
    [sym_real_number] = ACTIONS(5543),
    [anon_sym_BSLASHb] = ACTIONS(5541),
    [anon_sym_BSLASHB] = ACTIONS(5543),
    [anon_sym_BSLASHo] = ACTIONS(5541),
    [anon_sym_BSLASHO] = ACTIONS(5543),
    [anon_sym_BSLASHh] = ACTIONS(5543),
    [anon_sym_BSLASHH] = ACTIONS(5543),
    [anon_sym_DQUOTE] = ACTIONS(5543),
    [anon_sym_TRUE] = ACTIONS(5541),
    [anon_sym_FALSE] = ACTIONS(5541),
    [sym_string_set] = ACTIONS(5541),
    [sym_boolean_set] = ACTIONS(5541),
    [anon_sym_Nat] = ACTIONS(5541),
    [anon_sym_u2115] = ACTIONS(5543),
    [anon_sym_Int] = ACTIONS(5541),
    [anon_sym_u2124] = ACTIONS(5543),
    [anon_sym_Real] = ACTIONS(5541),
    [anon_sym_u211d] = ACTIONS(5543),
    [anon_sym_CHOOSE] = ACTIONS(5541),
    [anon_sym_LBRACE] = ACTIONS(5543),
    [anon_sym_EQ] = ACTIONS(5541),
    [anon_sym_WF_] = ACTIONS(5541),
    [anon_sym_SF_] = ACTIONS(5541),
    [anon_sym_IF] = ACTIONS(5541),
    [anon_sym_CASE] = ACTIONS(5541),
    [anon_sym_LET] = ACTIONS(5541),
    [anon_sym_BSLASHlnot] = ACTIONS(5543),
    [anon_sym_BSLASHneg] = ACTIONS(5543),
    [anon_sym_TILDE] = ACTIONS(5541),
    [anon_sym_u00ac] = ACTIONS(5543),
    [sym_union] = ACTIONS(5541),
    [sym_powerset] = ACTIONS(5541),
    [sym_domain] = ACTIONS(5541),
    [anon_sym_DASH] = ACTIONS(5541),
    [sym_negative_dot] = ACTIONS(5543),
    [sym_enabled] = ACTIONS(5541),
    [sym_unchanged] = ACTIONS(5541),
    [anon_sym_LT_GT] = ACTIONS(5543),
    [anon_sym_u22c4] = ACTIONS(5543),
    [anon_sym_u25c7] = ACTIONS(5543),
    [anon_sym_EQ_GT] = ACTIONS(5543),
    [anon_sym_u27f9] = ACTIONS(5543),
    [anon_sym_u21d2] = ACTIONS(5543),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5543),
    [anon_sym_u21f8] = ACTIONS(5543),
    [anon_sym_u2945] = ACTIONS(5543),
    [anon_sym_BSLASHequiv] = ACTIONS(5543),
    [anon_sym_u2261] = ACTIONS(5543),
    [anon_sym_LT_EQ_GT] = ACTIONS(5543),
    [anon_sym_u27fa] = ACTIONS(5543),
    [anon_sym_u21d4] = ACTIONS(5543),
    [anon_sym_TILDE_GT] = ACTIONS(5543),
    [anon_sym_u21dd] = ACTIONS(5543),
    [anon_sym_u219d] = ACTIONS(5543),
    [anon_sym_BSLASHland] = ACTIONS(5543),
    [anon_sym_BSLASHlor] = ACTIONS(5543),
    [anon_sym_COLON_EQ] = ACTIONS(5543),
    [anon_sym_u2254] = ACTIONS(5543),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5543),
    [anon_sym_u2a74] = ACTIONS(5543),
    [anon_sym_SLASH_EQ] = ACTIONS(5543),
    [anon_sym_POUND] = ACTIONS(5541),
    [anon_sym_u2260] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5541),
    [sym_gt] = ACTIONS(5541),
    [anon_sym_LT_EQ] = ACTIONS(5541),
    [anon_sym_EQ_LT] = ACTIONS(5543),
    [anon_sym_BSLASHleq] = ACTIONS(5543),
    [anon_sym_u2264] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5543),
    [anon_sym_BSLASHgeq] = ACTIONS(5543),
    [anon_sym_u2265] = ACTIONS(5543),
    [anon_sym_BSLASHapprox] = ACTIONS(5543),
    [anon_sym_u2248] = ACTIONS(5543),
    [anon_sym_PIPE_DASH] = ACTIONS(5543),
    [anon_sym_u22a2] = ACTIONS(5543),
    [anon_sym_PIPE_EQ] = ACTIONS(5543),
    [anon_sym_u22a8] = ACTIONS(5543),
    [anon_sym_DASH_PIPE] = ACTIONS(5543),
    [anon_sym_u22a3] = ACTIONS(5543),
    [anon_sym_EQ_PIPE] = ACTIONS(5543),
    [anon_sym_u2ae4] = ACTIONS(5543),
    [anon_sym_BSLASHasymp] = ACTIONS(5543),
    [anon_sym_u224d] = ACTIONS(5543),
    [anon_sym_BSLASHcong] = ACTIONS(5543),
    [anon_sym_u2245] = ACTIONS(5543),
    [anon_sym_BSLASHdoteq] = ACTIONS(5543),
    [anon_sym_u2250] = ACTIONS(5543),
    [anon_sym_BSLASHgg] = ACTIONS(5543),
    [anon_sym_u226b] = ACTIONS(5543),
    [anon_sym_BSLASHll] = ACTIONS(5543),
    [anon_sym_u226a] = ACTIONS(5543),
    [anon_sym_BSLASHnotin] = ACTIONS(5543),
    [anon_sym_u2209] = ACTIONS(5543),
    [anon_sym_BSLASHprec] = ACTIONS(5541),
    [anon_sym_u227a] = ACTIONS(5543),
    [anon_sym_BSLASHsucc] = ACTIONS(5541),
    [anon_sym_u227b] = ACTIONS(5543),
    [anon_sym_BSLASHpreceq] = ACTIONS(5543),
    [anon_sym_u2aaf] = ACTIONS(5543),
    [anon_sym_BSLASHsucceq] = ACTIONS(5543),
    [anon_sym_u2ab0] = ACTIONS(5543),
    [anon_sym_BSLASHpropto] = ACTIONS(5543),
    [anon_sym_u221d] = ACTIONS(5543),
    [anon_sym_BSLASHsim] = ACTIONS(5541),
    [anon_sym_u223c] = ACTIONS(5543),
    [anon_sym_BSLASHsimeq] = ACTIONS(5543),
    [anon_sym_u2243] = ACTIONS(5543),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5541),
    [anon_sym_u228f] = ACTIONS(5543),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5541),
    [anon_sym_u2290] = ACTIONS(5543),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5543),
    [anon_sym_u2291] = ACTIONS(5543),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5543),
    [anon_sym_u2292] = ACTIONS(5543),
    [anon_sym_BSLASHsubset] = ACTIONS(5541),
    [anon_sym_u2282] = ACTIONS(5543),
    [anon_sym_BSLASHsupset] = ACTIONS(5541),
    [anon_sym_u2283] = ACTIONS(5543),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5543),
    [anon_sym_u2286] = ACTIONS(5543),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5543),
    [anon_sym_u2287] = ACTIONS(5543),
    [sym_compose] = ACTIONS(5543),
    [sym_map_to] = ACTIONS(5543),
    [sym_map_from] = ACTIONS(5543),
    [sym_setminus] = ACTIONS(5541),
    [anon_sym_BSLASHcap] = ACTIONS(5543),
    [anon_sym_BSLASHintersect] = ACTIONS(5543),
    [anon_sym_u2229] = ACTIONS(5543),
    [anon_sym_BSLASHcup] = ACTIONS(5543),
    [anon_sym_BSLASHunion] = ACTIONS(5543),
    [anon_sym_u222a] = ACTIONS(5543),
    [anon_sym_DOT_DOT] = ACTIONS(5541),
    [anon_sym_u2025] = ACTIONS(5543),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5543),
    [anon_sym_u2026] = ACTIONS(5543),
    [anon_sym_PLUS] = ACTIONS(5541),
    [sym_plusplus] = ACTIONS(5543),
    [anon_sym_BSLASHoplus] = ACTIONS(5543),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5543),
    [anon_sym_u2295] = ACTIONS(5543),
    [anon_sym_BSLASHominus] = ACTIONS(5543),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5543),
    [anon_sym_u2296] = ACTIONS(5543),
    [sym_mod] = ACTIONS(5541),
    [sym_modmod] = ACTIONS(5543),
    [sym_vert] = ACTIONS(5541),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_u2016] = ACTIONS(5543),
    [sym_minusminus] = ACTIONS(5543),
    [sym_amp] = ACTIONS(5541),
    [sym_ampamp] = ACTIONS(5543),
    [anon_sym_BSLASHodot] = ACTIONS(5543),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5543),
    [anon_sym_u2299] = ACTIONS(5543),
    [anon_sym_BSLASHoslash] = ACTIONS(5543),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5543),
    [anon_sym_u2298] = ACTIONS(5543),
    [anon_sym_BSLASHotimes] = ACTIONS(5543),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5543),
    [anon_sym_u2297] = ACTIONS(5543),
    [sym_mul] = ACTIONS(5541),
    [sym_mulmul] = ACTIONS(5543),
    [sym_slash] = ACTIONS(5541),
    [sym_slashslash] = ACTIONS(5543),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5543),
    [anon_sym_u25ef] = ACTIONS(5543),
    [anon_sym_BSLASHbullet] = ACTIONS(5543),
    [anon_sym_u25cf] = ACTIONS(5543),
    [anon_sym_BSLASHdiv] = ACTIONS(5543),
    [anon_sym_u00f7] = ACTIONS(5543),
    [anon_sym_BSLASHcirc] = ACTIONS(5543),
    [anon_sym_u2218] = ACTIONS(5543),
    [anon_sym_BSLASHstar] = ACTIONS(5543),
    [anon_sym_u22c6] = ACTIONS(5543),
    [anon_sym_u203c] = ACTIONS(5543),
    [sym_hashhash] = ACTIONS(5543),
    [sym_dol] = ACTIONS(5541),
    [sym_doldol] = ACTIONS(5543),
    [anon_sym_QMARK_QMARK] = ACTIONS(5543),
    [anon_sym_u2047] = ACTIONS(5543),
    [anon_sym_BSLASHsqcap] = ACTIONS(5543),
    [anon_sym_u2293] = ACTIONS(5543),
    [anon_sym_BSLASHsqcup] = ACTIONS(5543),
    [anon_sym_u2294] = ACTIONS(5543),
    [anon_sym_BSLASHuplus] = ACTIONS(5543),
    [anon_sym_u228e] = ACTIONS(5543),
    [anon_sym_BSLASHX] = ACTIONS(5543),
    [anon_sym_BSLASHtimes] = ACTIONS(5543),
    [anon_sym_u00d7] = ACTIONS(5543),
    [anon_sym_BSLASHwr] = ACTIONS(5543),
    [anon_sym_u2240] = ACTIONS(5543),
    [anon_sym_BSLASHcdot] = ACTIONS(5543),
    [anon_sym_u22c5] = ACTIONS(5543),
    [sym_pow] = ACTIONS(5541),
    [sym_powpow] = ACTIONS(5543),
    [anon_sym_CARET_PLUS] = ACTIONS(5543),
    [anon_sym_u207a] = ACTIONS(5543),
    [sym_asterisk] = ACTIONS(5543),
    [sym_sup_hash] = ACTIONS(5543),
    [sym_prime] = ACTIONS(5543),
    [sym__indent] = ACTIONS(5543),
    [sym__double_excl] = ACTIONS(5543),
  },
  [2184] = {
    [sym_block_comment] = STATE(2184),
    [sym_identifier] = ACTIONS(5545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5545),
    [anon_sym_u2208] = ACTIONS(5547),
    [anon_sym_BSLASHA] = ACTIONS(5545),
    [anon_sym_BSLASHforall] = ACTIONS(5547),
    [anon_sym_u2200] = ACTIONS(5547),
    [anon_sym_BSLASHE] = ACTIONS(5545),
    [anon_sym_BSLASHexists] = ACTIONS(5547),
    [anon_sym_u2203] = ACTIONS(5547),
    [sym_temporal_forall] = ACTIONS(5547),
    [sym_temporal_exists] = ACTIONS(5547),
    [anon_sym_LT_LT] = ACTIONS(5547),
    [anon_sym_u3008] = ACTIONS(5547),
    [anon_sym_u27e8] = ACTIONS(5547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5547),
    [anon_sym_u25a1] = ACTIONS(5547),
    [anon_sym_AT] = ACTIONS(5545),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5547),
    [anon_sym_u2227] = ACTIONS(5547),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5547),
    [anon_sym_u2228] = ACTIONS(5547),
    [anon_sym_LPAREN] = ACTIONS(5545),
    [anon_sym_LBRACK] = ACTIONS(5545),
    [aux_sym_child_id_token1] = ACTIONS(5545),
    [sym_real_number] = ACTIONS(5547),
    [anon_sym_BSLASHb] = ACTIONS(5545),
    [anon_sym_BSLASHB] = ACTIONS(5547),
    [anon_sym_BSLASHo] = ACTIONS(5545),
    [anon_sym_BSLASHO] = ACTIONS(5547),
    [anon_sym_BSLASHh] = ACTIONS(5547),
    [anon_sym_BSLASHH] = ACTIONS(5547),
    [anon_sym_DQUOTE] = ACTIONS(5547),
    [anon_sym_TRUE] = ACTIONS(5545),
    [anon_sym_FALSE] = ACTIONS(5545),
    [sym_string_set] = ACTIONS(5545),
    [sym_boolean_set] = ACTIONS(5545),
    [anon_sym_Nat] = ACTIONS(5545),
    [anon_sym_u2115] = ACTIONS(5547),
    [anon_sym_Int] = ACTIONS(5545),
    [anon_sym_u2124] = ACTIONS(5547),
    [anon_sym_Real] = ACTIONS(5545),
    [anon_sym_u211d] = ACTIONS(5547),
    [anon_sym_CHOOSE] = ACTIONS(5545),
    [anon_sym_LBRACE] = ACTIONS(5547),
    [anon_sym_EQ] = ACTIONS(5545),
    [anon_sym_WF_] = ACTIONS(5545),
    [anon_sym_SF_] = ACTIONS(5545),
    [anon_sym_IF] = ACTIONS(5545),
    [anon_sym_CASE] = ACTIONS(5545),
    [anon_sym_LET] = ACTIONS(5545),
    [anon_sym_BSLASHlnot] = ACTIONS(5547),
    [anon_sym_BSLASHneg] = ACTIONS(5547),
    [anon_sym_TILDE] = ACTIONS(5545),
    [anon_sym_u00ac] = ACTIONS(5547),
    [sym_union] = ACTIONS(5545),
    [sym_powerset] = ACTIONS(5545),
    [sym_domain] = ACTIONS(5545),
    [anon_sym_DASH] = ACTIONS(5545),
    [sym_negative_dot] = ACTIONS(5547),
    [sym_enabled] = ACTIONS(5545),
    [sym_unchanged] = ACTIONS(5545),
    [anon_sym_LT_GT] = ACTIONS(5547),
    [anon_sym_u22c4] = ACTIONS(5547),
    [anon_sym_u25c7] = ACTIONS(5547),
    [anon_sym_EQ_GT] = ACTIONS(5547),
    [anon_sym_u27f9] = ACTIONS(5547),
    [anon_sym_u21d2] = ACTIONS(5547),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5547),
    [anon_sym_u21f8] = ACTIONS(5547),
    [anon_sym_u2945] = ACTIONS(5547),
    [anon_sym_BSLASHequiv] = ACTIONS(5547),
    [anon_sym_u2261] = ACTIONS(5547),
    [anon_sym_LT_EQ_GT] = ACTIONS(5547),
    [anon_sym_u27fa] = ACTIONS(5547),
    [anon_sym_u21d4] = ACTIONS(5547),
    [anon_sym_TILDE_GT] = ACTIONS(5547),
    [anon_sym_u21dd] = ACTIONS(5547),
    [anon_sym_u219d] = ACTIONS(5547),
    [anon_sym_BSLASHland] = ACTIONS(5547),
    [anon_sym_BSLASHlor] = ACTIONS(5547),
    [anon_sym_COLON_EQ] = ACTIONS(5547),
    [anon_sym_u2254] = ACTIONS(5547),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5547),
    [anon_sym_u2a74] = ACTIONS(5547),
    [anon_sym_SLASH_EQ] = ACTIONS(5547),
    [anon_sym_POUND] = ACTIONS(5545),
    [anon_sym_u2260] = ACTIONS(5547),
    [anon_sym_LT] = ACTIONS(5545),
    [sym_gt] = ACTIONS(5545),
    [anon_sym_LT_EQ] = ACTIONS(5545),
    [anon_sym_EQ_LT] = ACTIONS(5547),
    [anon_sym_BSLASHleq] = ACTIONS(5547),
    [anon_sym_u2264] = ACTIONS(5547),
    [anon_sym_GT_EQ] = ACTIONS(5547),
    [anon_sym_BSLASHgeq] = ACTIONS(5547),
    [anon_sym_u2265] = ACTIONS(5547),
    [anon_sym_BSLASHapprox] = ACTIONS(5547),
    [anon_sym_u2248] = ACTIONS(5547),
    [anon_sym_PIPE_DASH] = ACTIONS(5547),
    [anon_sym_u22a2] = ACTIONS(5547),
    [anon_sym_PIPE_EQ] = ACTIONS(5547),
    [anon_sym_u22a8] = ACTIONS(5547),
    [anon_sym_DASH_PIPE] = ACTIONS(5547),
    [anon_sym_u22a3] = ACTIONS(5547),
    [anon_sym_EQ_PIPE] = ACTIONS(5547),
    [anon_sym_u2ae4] = ACTIONS(5547),
    [anon_sym_BSLASHasymp] = ACTIONS(5547),
    [anon_sym_u224d] = ACTIONS(5547),
    [anon_sym_BSLASHcong] = ACTIONS(5547),
    [anon_sym_u2245] = ACTIONS(5547),
    [anon_sym_BSLASHdoteq] = ACTIONS(5547),
    [anon_sym_u2250] = ACTIONS(5547),
    [anon_sym_BSLASHgg] = ACTIONS(5547),
    [anon_sym_u226b] = ACTIONS(5547),
    [anon_sym_BSLASHll] = ACTIONS(5547),
    [anon_sym_u226a] = ACTIONS(5547),
    [anon_sym_BSLASHnotin] = ACTIONS(5547),
    [anon_sym_u2209] = ACTIONS(5547),
    [anon_sym_BSLASHprec] = ACTIONS(5545),
    [anon_sym_u227a] = ACTIONS(5547),
    [anon_sym_BSLASHsucc] = ACTIONS(5545),
    [anon_sym_u227b] = ACTIONS(5547),
    [anon_sym_BSLASHpreceq] = ACTIONS(5547),
    [anon_sym_u2aaf] = ACTIONS(5547),
    [anon_sym_BSLASHsucceq] = ACTIONS(5547),
    [anon_sym_u2ab0] = ACTIONS(5547),
    [anon_sym_BSLASHpropto] = ACTIONS(5547),
    [anon_sym_u221d] = ACTIONS(5547),
    [anon_sym_BSLASHsim] = ACTIONS(5545),
    [anon_sym_u223c] = ACTIONS(5547),
    [anon_sym_BSLASHsimeq] = ACTIONS(5547),
    [anon_sym_u2243] = ACTIONS(5547),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5545),
    [anon_sym_u228f] = ACTIONS(5547),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5545),
    [anon_sym_u2290] = ACTIONS(5547),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5547),
    [anon_sym_u2291] = ACTIONS(5547),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5547),
    [anon_sym_u2292] = ACTIONS(5547),
    [anon_sym_BSLASHsubset] = ACTIONS(5545),
    [anon_sym_u2282] = ACTIONS(5547),
    [anon_sym_BSLASHsupset] = ACTIONS(5545),
    [anon_sym_u2283] = ACTIONS(5547),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5547),
    [anon_sym_u2286] = ACTIONS(5547),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5547),
    [anon_sym_u2287] = ACTIONS(5547),
    [sym_compose] = ACTIONS(5547),
    [sym_map_to] = ACTIONS(5547),
    [sym_map_from] = ACTIONS(5547),
    [sym_setminus] = ACTIONS(5545),
    [anon_sym_BSLASHcap] = ACTIONS(5547),
    [anon_sym_BSLASHintersect] = ACTIONS(5547),
    [anon_sym_u2229] = ACTIONS(5547),
    [anon_sym_BSLASHcup] = ACTIONS(5547),
    [anon_sym_BSLASHunion] = ACTIONS(5547),
    [anon_sym_u222a] = ACTIONS(5547),
    [anon_sym_DOT_DOT] = ACTIONS(5545),
    [anon_sym_u2025] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5547),
    [anon_sym_u2026] = ACTIONS(5547),
    [anon_sym_PLUS] = ACTIONS(5545),
    [sym_plusplus] = ACTIONS(5547),
    [anon_sym_BSLASHoplus] = ACTIONS(5547),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5547),
    [anon_sym_u2295] = ACTIONS(5547),
    [anon_sym_BSLASHominus] = ACTIONS(5547),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5547),
    [anon_sym_u2296] = ACTIONS(5547),
    [sym_mod] = ACTIONS(5545),
    [sym_modmod] = ACTIONS(5547),
    [sym_vert] = ACTIONS(5545),
    [anon_sym_PIPE_PIPE] = ACTIONS(5547),
    [anon_sym_u2016] = ACTIONS(5547),
    [sym_minusminus] = ACTIONS(5547),
    [sym_amp] = ACTIONS(5545),
    [sym_ampamp] = ACTIONS(5547),
    [anon_sym_BSLASHodot] = ACTIONS(5547),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5547),
    [anon_sym_u2299] = ACTIONS(5547),
    [anon_sym_BSLASHoslash] = ACTIONS(5547),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5547),
    [anon_sym_u2298] = ACTIONS(5547),
    [anon_sym_BSLASHotimes] = ACTIONS(5547),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5547),
    [anon_sym_u2297] = ACTIONS(5547),
    [sym_mul] = ACTIONS(5545),
    [sym_mulmul] = ACTIONS(5547),
    [sym_slash] = ACTIONS(5545),
    [sym_slashslash] = ACTIONS(5547),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5547),
    [anon_sym_u25ef] = ACTIONS(5547),
    [anon_sym_BSLASHbullet] = ACTIONS(5547),
    [anon_sym_u25cf] = ACTIONS(5547),
    [anon_sym_BSLASHdiv] = ACTIONS(5547),
    [anon_sym_u00f7] = ACTIONS(5547),
    [anon_sym_BSLASHcirc] = ACTIONS(5547),
    [anon_sym_u2218] = ACTIONS(5547),
    [anon_sym_BSLASHstar] = ACTIONS(5547),
    [anon_sym_u22c6] = ACTIONS(5547),
    [anon_sym_u203c] = ACTIONS(5547),
    [sym_hashhash] = ACTIONS(5547),
    [sym_dol] = ACTIONS(5545),
    [sym_doldol] = ACTIONS(5547),
    [anon_sym_QMARK_QMARK] = ACTIONS(5547),
    [anon_sym_u2047] = ACTIONS(5547),
    [anon_sym_BSLASHsqcap] = ACTIONS(5547),
    [anon_sym_u2293] = ACTIONS(5547),
    [anon_sym_BSLASHsqcup] = ACTIONS(5547),
    [anon_sym_u2294] = ACTIONS(5547),
    [anon_sym_BSLASHuplus] = ACTIONS(5547),
    [anon_sym_u228e] = ACTIONS(5547),
    [anon_sym_BSLASHX] = ACTIONS(5547),
    [anon_sym_BSLASHtimes] = ACTIONS(5547),
    [anon_sym_u00d7] = ACTIONS(5547),
    [anon_sym_BSLASHwr] = ACTIONS(5547),
    [anon_sym_u2240] = ACTIONS(5547),
    [anon_sym_BSLASHcdot] = ACTIONS(5547),
    [anon_sym_u22c5] = ACTIONS(5547),
    [sym_pow] = ACTIONS(5545),
    [sym_powpow] = ACTIONS(5547),
    [anon_sym_CARET_PLUS] = ACTIONS(5547),
    [anon_sym_u207a] = ACTIONS(5547),
    [sym_asterisk] = ACTIONS(5547),
    [sym_sup_hash] = ACTIONS(5547),
    [sym_prime] = ACTIONS(5547),
    [sym__indent] = ACTIONS(5547),
    [sym__double_excl] = ACTIONS(5547),
  },
  [2185] = {
    [sym_block_comment] = STATE(2185),
    [sym_identifier] = ACTIONS(5549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5549),
    [anon_sym_u2208] = ACTIONS(5551),
    [anon_sym_BSLASHA] = ACTIONS(5549),
    [anon_sym_BSLASHforall] = ACTIONS(5551),
    [anon_sym_u2200] = ACTIONS(5551),
    [anon_sym_BSLASHE] = ACTIONS(5549),
    [anon_sym_BSLASHexists] = ACTIONS(5551),
    [anon_sym_u2203] = ACTIONS(5551),
    [sym_temporal_forall] = ACTIONS(5551),
    [sym_temporal_exists] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5551),
    [anon_sym_u3008] = ACTIONS(5551),
    [anon_sym_u27e8] = ACTIONS(5551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5551),
    [anon_sym_u25a1] = ACTIONS(5551),
    [anon_sym_AT] = ACTIONS(5549),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5551),
    [anon_sym_u2227] = ACTIONS(5551),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5551),
    [anon_sym_u2228] = ACTIONS(5551),
    [anon_sym_LPAREN] = ACTIONS(5549),
    [anon_sym_LBRACK] = ACTIONS(5549),
    [aux_sym_child_id_token1] = ACTIONS(5549),
    [sym_real_number] = ACTIONS(5551),
    [anon_sym_BSLASHb] = ACTIONS(5549),
    [anon_sym_BSLASHB] = ACTIONS(5551),
    [anon_sym_BSLASHo] = ACTIONS(5549),
    [anon_sym_BSLASHO] = ACTIONS(5551),
    [anon_sym_BSLASHh] = ACTIONS(5551),
    [anon_sym_BSLASHH] = ACTIONS(5551),
    [anon_sym_DQUOTE] = ACTIONS(5551),
    [anon_sym_TRUE] = ACTIONS(5549),
    [anon_sym_FALSE] = ACTIONS(5549),
    [sym_string_set] = ACTIONS(5549),
    [sym_boolean_set] = ACTIONS(5549),
    [anon_sym_Nat] = ACTIONS(5549),
    [anon_sym_u2115] = ACTIONS(5551),
    [anon_sym_Int] = ACTIONS(5549),
    [anon_sym_u2124] = ACTIONS(5551),
    [anon_sym_Real] = ACTIONS(5549),
    [anon_sym_u211d] = ACTIONS(5551),
    [anon_sym_CHOOSE] = ACTIONS(5549),
    [anon_sym_LBRACE] = ACTIONS(5551),
    [anon_sym_EQ] = ACTIONS(5549),
    [anon_sym_WF_] = ACTIONS(5549),
    [anon_sym_SF_] = ACTIONS(5549),
    [anon_sym_IF] = ACTIONS(5549),
    [anon_sym_CASE] = ACTIONS(5549),
    [anon_sym_LET] = ACTIONS(5549),
    [anon_sym_BSLASHlnot] = ACTIONS(5551),
    [anon_sym_BSLASHneg] = ACTIONS(5551),
    [anon_sym_TILDE] = ACTIONS(5549),
    [anon_sym_u00ac] = ACTIONS(5551),
    [sym_union] = ACTIONS(5549),
    [sym_powerset] = ACTIONS(5549),
    [sym_domain] = ACTIONS(5549),
    [anon_sym_DASH] = ACTIONS(5549),
    [sym_negative_dot] = ACTIONS(5551),
    [sym_enabled] = ACTIONS(5549),
    [sym_unchanged] = ACTIONS(5549),
    [anon_sym_LT_GT] = ACTIONS(5551),
    [anon_sym_u22c4] = ACTIONS(5551),
    [anon_sym_u25c7] = ACTIONS(5551),
    [anon_sym_EQ_GT] = ACTIONS(5551),
    [anon_sym_u27f9] = ACTIONS(5551),
    [anon_sym_u21d2] = ACTIONS(5551),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5551),
    [anon_sym_u21f8] = ACTIONS(5551),
    [anon_sym_u2945] = ACTIONS(5551),
    [anon_sym_BSLASHequiv] = ACTIONS(5551),
    [anon_sym_u2261] = ACTIONS(5551),
    [anon_sym_LT_EQ_GT] = ACTIONS(5551),
    [anon_sym_u27fa] = ACTIONS(5551),
    [anon_sym_u21d4] = ACTIONS(5551),
    [anon_sym_TILDE_GT] = ACTIONS(5551),
    [anon_sym_u21dd] = ACTIONS(5551),
    [anon_sym_u219d] = ACTIONS(5551),
    [anon_sym_BSLASHland] = ACTIONS(5551),
    [anon_sym_BSLASHlor] = ACTIONS(5551),
    [anon_sym_COLON_EQ] = ACTIONS(5551),
    [anon_sym_u2254] = ACTIONS(5551),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5551),
    [anon_sym_u2a74] = ACTIONS(5551),
    [anon_sym_SLASH_EQ] = ACTIONS(5551),
    [anon_sym_POUND] = ACTIONS(5549),
    [anon_sym_u2260] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5549),
    [sym_gt] = ACTIONS(5549),
    [anon_sym_LT_EQ] = ACTIONS(5549),
    [anon_sym_EQ_LT] = ACTIONS(5551),
    [anon_sym_BSLASHleq] = ACTIONS(5551),
    [anon_sym_u2264] = ACTIONS(5551),
    [anon_sym_GT_EQ] = ACTIONS(5551),
    [anon_sym_BSLASHgeq] = ACTIONS(5551),
    [anon_sym_u2265] = ACTIONS(5551),
    [anon_sym_BSLASHapprox] = ACTIONS(5551),
    [anon_sym_u2248] = ACTIONS(5551),
    [anon_sym_PIPE_DASH] = ACTIONS(5551),
    [anon_sym_u22a2] = ACTIONS(5551),
    [anon_sym_PIPE_EQ] = ACTIONS(5551),
    [anon_sym_u22a8] = ACTIONS(5551),
    [anon_sym_DASH_PIPE] = ACTIONS(5551),
    [anon_sym_u22a3] = ACTIONS(5551),
    [anon_sym_EQ_PIPE] = ACTIONS(5551),
    [anon_sym_u2ae4] = ACTIONS(5551),
    [anon_sym_BSLASHasymp] = ACTIONS(5551),
    [anon_sym_u224d] = ACTIONS(5551),
    [anon_sym_BSLASHcong] = ACTIONS(5551),
    [anon_sym_u2245] = ACTIONS(5551),
    [anon_sym_BSLASHdoteq] = ACTIONS(5551),
    [anon_sym_u2250] = ACTIONS(5551),
    [anon_sym_BSLASHgg] = ACTIONS(5551),
    [anon_sym_u226b] = ACTIONS(5551),
    [anon_sym_BSLASHll] = ACTIONS(5551),
    [anon_sym_u226a] = ACTIONS(5551),
    [anon_sym_BSLASHnotin] = ACTIONS(5551),
    [anon_sym_u2209] = ACTIONS(5551),
    [anon_sym_BSLASHprec] = ACTIONS(5549),
    [anon_sym_u227a] = ACTIONS(5551),
    [anon_sym_BSLASHsucc] = ACTIONS(5549),
    [anon_sym_u227b] = ACTIONS(5551),
    [anon_sym_BSLASHpreceq] = ACTIONS(5551),
    [anon_sym_u2aaf] = ACTIONS(5551),
    [anon_sym_BSLASHsucceq] = ACTIONS(5551),
    [anon_sym_u2ab0] = ACTIONS(5551),
    [anon_sym_BSLASHpropto] = ACTIONS(5551),
    [anon_sym_u221d] = ACTIONS(5551),
    [anon_sym_BSLASHsim] = ACTIONS(5549),
    [anon_sym_u223c] = ACTIONS(5551),
    [anon_sym_BSLASHsimeq] = ACTIONS(5551),
    [anon_sym_u2243] = ACTIONS(5551),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5549),
    [anon_sym_u228f] = ACTIONS(5551),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5549),
    [anon_sym_u2290] = ACTIONS(5551),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5551),
    [anon_sym_u2291] = ACTIONS(5551),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5551),
    [anon_sym_u2292] = ACTIONS(5551),
    [anon_sym_BSLASHsubset] = ACTIONS(5549),
    [anon_sym_u2282] = ACTIONS(5551),
    [anon_sym_BSLASHsupset] = ACTIONS(5549),
    [anon_sym_u2283] = ACTIONS(5551),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5551),
    [anon_sym_u2286] = ACTIONS(5551),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5551),
    [anon_sym_u2287] = ACTIONS(5551),
    [sym_compose] = ACTIONS(5551),
    [sym_map_to] = ACTIONS(5551),
    [sym_map_from] = ACTIONS(5551),
    [sym_setminus] = ACTIONS(5549),
    [anon_sym_BSLASHcap] = ACTIONS(5551),
    [anon_sym_BSLASHintersect] = ACTIONS(5551),
    [anon_sym_u2229] = ACTIONS(5551),
    [anon_sym_BSLASHcup] = ACTIONS(5551),
    [anon_sym_BSLASHunion] = ACTIONS(5551),
    [anon_sym_u222a] = ACTIONS(5551),
    [anon_sym_DOT_DOT] = ACTIONS(5549),
    [anon_sym_u2025] = ACTIONS(5551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5551),
    [anon_sym_u2026] = ACTIONS(5551),
    [anon_sym_PLUS] = ACTIONS(5549),
    [sym_plusplus] = ACTIONS(5551),
    [anon_sym_BSLASHoplus] = ACTIONS(5551),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5551),
    [anon_sym_u2295] = ACTIONS(5551),
    [anon_sym_BSLASHominus] = ACTIONS(5551),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5551),
    [anon_sym_u2296] = ACTIONS(5551),
    [sym_mod] = ACTIONS(5549),
    [sym_modmod] = ACTIONS(5551),
    [sym_vert] = ACTIONS(5549),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_u2016] = ACTIONS(5551),
    [sym_minusminus] = ACTIONS(5551),
    [sym_amp] = ACTIONS(5549),
    [sym_ampamp] = ACTIONS(5551),
    [anon_sym_BSLASHodot] = ACTIONS(5551),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5551),
    [anon_sym_u2299] = ACTIONS(5551),
    [anon_sym_BSLASHoslash] = ACTIONS(5551),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5551),
    [anon_sym_u2298] = ACTIONS(5551),
    [anon_sym_BSLASHotimes] = ACTIONS(5551),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5551),
    [anon_sym_u2297] = ACTIONS(5551),
    [sym_mul] = ACTIONS(5549),
    [sym_mulmul] = ACTIONS(5551),
    [sym_slash] = ACTIONS(5549),
    [sym_slashslash] = ACTIONS(5551),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5551),
    [anon_sym_u25ef] = ACTIONS(5551),
    [anon_sym_BSLASHbullet] = ACTIONS(5551),
    [anon_sym_u25cf] = ACTIONS(5551),
    [anon_sym_BSLASHdiv] = ACTIONS(5551),
    [anon_sym_u00f7] = ACTIONS(5551),
    [anon_sym_BSLASHcirc] = ACTIONS(5551),
    [anon_sym_u2218] = ACTIONS(5551),
    [anon_sym_BSLASHstar] = ACTIONS(5551),
    [anon_sym_u22c6] = ACTIONS(5551),
    [anon_sym_u203c] = ACTIONS(5551),
    [sym_hashhash] = ACTIONS(5551),
    [sym_dol] = ACTIONS(5549),
    [sym_doldol] = ACTIONS(5551),
    [anon_sym_QMARK_QMARK] = ACTIONS(5551),
    [anon_sym_u2047] = ACTIONS(5551),
    [anon_sym_BSLASHsqcap] = ACTIONS(5551),
    [anon_sym_u2293] = ACTIONS(5551),
    [anon_sym_BSLASHsqcup] = ACTIONS(5551),
    [anon_sym_u2294] = ACTIONS(5551),
    [anon_sym_BSLASHuplus] = ACTIONS(5551),
    [anon_sym_u228e] = ACTIONS(5551),
    [anon_sym_BSLASHX] = ACTIONS(5551),
    [anon_sym_BSLASHtimes] = ACTIONS(5551),
    [anon_sym_u00d7] = ACTIONS(5551),
    [anon_sym_BSLASHwr] = ACTIONS(5551),
    [anon_sym_u2240] = ACTIONS(5551),
    [anon_sym_BSLASHcdot] = ACTIONS(5551),
    [anon_sym_u22c5] = ACTIONS(5551),
    [sym_pow] = ACTIONS(5549),
    [sym_powpow] = ACTIONS(5551),
    [anon_sym_CARET_PLUS] = ACTIONS(5551),
    [anon_sym_u207a] = ACTIONS(5551),
    [sym_asterisk] = ACTIONS(5551),
    [sym_sup_hash] = ACTIONS(5551),
    [sym_prime] = ACTIONS(5551),
    [sym__indent] = ACTIONS(5551),
    [sym__double_excl] = ACTIONS(5551),
  },
  [2186] = {
    [sym_block_comment] = STATE(2186),
    [sym_identifier] = ACTIONS(5553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5553),
    [anon_sym_u2208] = ACTIONS(5555),
    [anon_sym_BSLASHA] = ACTIONS(5553),
    [anon_sym_BSLASHforall] = ACTIONS(5555),
    [anon_sym_u2200] = ACTIONS(5555),
    [anon_sym_BSLASHE] = ACTIONS(5553),
    [anon_sym_BSLASHexists] = ACTIONS(5555),
    [anon_sym_u2203] = ACTIONS(5555),
    [sym_temporal_forall] = ACTIONS(5555),
    [sym_temporal_exists] = ACTIONS(5555),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_u3008] = ACTIONS(5555),
    [anon_sym_u27e8] = ACTIONS(5555),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5555),
    [anon_sym_u25a1] = ACTIONS(5555),
    [anon_sym_AT] = ACTIONS(5553),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5555),
    [anon_sym_u2227] = ACTIONS(5555),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5555),
    [anon_sym_u2228] = ACTIONS(5555),
    [anon_sym_LPAREN] = ACTIONS(5553),
    [anon_sym_LBRACK] = ACTIONS(5553),
    [aux_sym_child_id_token1] = ACTIONS(5553),
    [sym_real_number] = ACTIONS(5555),
    [anon_sym_BSLASHb] = ACTIONS(5553),
    [anon_sym_BSLASHB] = ACTIONS(5555),
    [anon_sym_BSLASHo] = ACTIONS(5553),
    [anon_sym_BSLASHO] = ACTIONS(5555),
    [anon_sym_BSLASHh] = ACTIONS(5555),
    [anon_sym_BSLASHH] = ACTIONS(5555),
    [anon_sym_DQUOTE] = ACTIONS(5555),
    [anon_sym_TRUE] = ACTIONS(5553),
    [anon_sym_FALSE] = ACTIONS(5553),
    [sym_string_set] = ACTIONS(5553),
    [sym_boolean_set] = ACTIONS(5553),
    [anon_sym_Nat] = ACTIONS(5553),
    [anon_sym_u2115] = ACTIONS(5555),
    [anon_sym_Int] = ACTIONS(5553),
    [anon_sym_u2124] = ACTIONS(5555),
    [anon_sym_Real] = ACTIONS(5553),
    [anon_sym_u211d] = ACTIONS(5555),
    [anon_sym_CHOOSE] = ACTIONS(5553),
    [anon_sym_LBRACE] = ACTIONS(5555),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_WF_] = ACTIONS(5553),
    [anon_sym_SF_] = ACTIONS(5553),
    [anon_sym_IF] = ACTIONS(5553),
    [anon_sym_CASE] = ACTIONS(5553),
    [anon_sym_LET] = ACTIONS(5553),
    [anon_sym_BSLASHlnot] = ACTIONS(5555),
    [anon_sym_BSLASHneg] = ACTIONS(5555),
    [anon_sym_TILDE] = ACTIONS(5553),
    [anon_sym_u00ac] = ACTIONS(5555),
    [sym_union] = ACTIONS(5553),
    [sym_powerset] = ACTIONS(5553),
    [sym_domain] = ACTIONS(5553),
    [anon_sym_DASH] = ACTIONS(5553),
    [sym_negative_dot] = ACTIONS(5555),
    [sym_enabled] = ACTIONS(5553),
    [sym_unchanged] = ACTIONS(5553),
    [anon_sym_LT_GT] = ACTIONS(5555),
    [anon_sym_u22c4] = ACTIONS(5555),
    [anon_sym_u25c7] = ACTIONS(5555),
    [anon_sym_EQ_GT] = ACTIONS(5555),
    [anon_sym_u27f9] = ACTIONS(5555),
    [anon_sym_u21d2] = ACTIONS(5555),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5555),
    [anon_sym_u21f8] = ACTIONS(5555),
    [anon_sym_u2945] = ACTIONS(5555),
    [anon_sym_BSLASHequiv] = ACTIONS(5555),
    [anon_sym_u2261] = ACTIONS(5555),
    [anon_sym_LT_EQ_GT] = ACTIONS(5555),
    [anon_sym_u27fa] = ACTIONS(5555),
    [anon_sym_u21d4] = ACTIONS(5555),
    [anon_sym_TILDE_GT] = ACTIONS(5555),
    [anon_sym_u21dd] = ACTIONS(5555),
    [anon_sym_u219d] = ACTIONS(5555),
    [anon_sym_BSLASHland] = ACTIONS(5555),
    [anon_sym_BSLASHlor] = ACTIONS(5555),
    [anon_sym_COLON_EQ] = ACTIONS(5555),
    [anon_sym_u2254] = ACTIONS(5555),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5555),
    [anon_sym_u2a74] = ACTIONS(5555),
    [anon_sym_SLASH_EQ] = ACTIONS(5555),
    [anon_sym_POUND] = ACTIONS(5553),
    [anon_sym_u2260] = ACTIONS(5555),
    [anon_sym_LT] = ACTIONS(5553),
    [sym_gt] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5553),
    [anon_sym_EQ_LT] = ACTIONS(5555),
    [anon_sym_BSLASHleq] = ACTIONS(5555),
    [anon_sym_u2264] = ACTIONS(5555),
    [anon_sym_GT_EQ] = ACTIONS(5555),
    [anon_sym_BSLASHgeq] = ACTIONS(5555),
    [anon_sym_u2265] = ACTIONS(5555),
    [anon_sym_BSLASHapprox] = ACTIONS(5555),
    [anon_sym_u2248] = ACTIONS(5555),
    [anon_sym_PIPE_DASH] = ACTIONS(5555),
    [anon_sym_u22a2] = ACTIONS(5555),
    [anon_sym_PIPE_EQ] = ACTIONS(5555),
    [anon_sym_u22a8] = ACTIONS(5555),
    [anon_sym_DASH_PIPE] = ACTIONS(5555),
    [anon_sym_u22a3] = ACTIONS(5555),
    [anon_sym_EQ_PIPE] = ACTIONS(5555),
    [anon_sym_u2ae4] = ACTIONS(5555),
    [anon_sym_BSLASHasymp] = ACTIONS(5555),
    [anon_sym_u224d] = ACTIONS(5555),
    [anon_sym_BSLASHcong] = ACTIONS(5555),
    [anon_sym_u2245] = ACTIONS(5555),
    [anon_sym_BSLASHdoteq] = ACTIONS(5555),
    [anon_sym_u2250] = ACTIONS(5555),
    [anon_sym_BSLASHgg] = ACTIONS(5555),
    [anon_sym_u226b] = ACTIONS(5555),
    [anon_sym_BSLASHll] = ACTIONS(5555),
    [anon_sym_u226a] = ACTIONS(5555),
    [anon_sym_BSLASHnotin] = ACTIONS(5555),
    [anon_sym_u2209] = ACTIONS(5555),
    [anon_sym_BSLASHprec] = ACTIONS(5553),
    [anon_sym_u227a] = ACTIONS(5555),
    [anon_sym_BSLASHsucc] = ACTIONS(5553),
    [anon_sym_u227b] = ACTIONS(5555),
    [anon_sym_BSLASHpreceq] = ACTIONS(5555),
    [anon_sym_u2aaf] = ACTIONS(5555),
    [anon_sym_BSLASHsucceq] = ACTIONS(5555),
    [anon_sym_u2ab0] = ACTIONS(5555),
    [anon_sym_BSLASHpropto] = ACTIONS(5555),
    [anon_sym_u221d] = ACTIONS(5555),
    [anon_sym_BSLASHsim] = ACTIONS(5553),
    [anon_sym_u223c] = ACTIONS(5555),
    [anon_sym_BSLASHsimeq] = ACTIONS(5555),
    [anon_sym_u2243] = ACTIONS(5555),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5553),
    [anon_sym_u228f] = ACTIONS(5555),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5553),
    [anon_sym_u2290] = ACTIONS(5555),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5555),
    [anon_sym_u2291] = ACTIONS(5555),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5555),
    [anon_sym_u2292] = ACTIONS(5555),
    [anon_sym_BSLASHsubset] = ACTIONS(5553),
    [anon_sym_u2282] = ACTIONS(5555),
    [anon_sym_BSLASHsupset] = ACTIONS(5553),
    [anon_sym_u2283] = ACTIONS(5555),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5555),
    [anon_sym_u2286] = ACTIONS(5555),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5555),
    [anon_sym_u2287] = ACTIONS(5555),
    [sym_compose] = ACTIONS(5555),
    [sym_map_to] = ACTIONS(5555),
    [sym_map_from] = ACTIONS(5555),
    [sym_setminus] = ACTIONS(5553),
    [anon_sym_BSLASHcap] = ACTIONS(5555),
    [anon_sym_BSLASHintersect] = ACTIONS(5555),
    [anon_sym_u2229] = ACTIONS(5555),
    [anon_sym_BSLASHcup] = ACTIONS(5555),
    [anon_sym_BSLASHunion] = ACTIONS(5555),
    [anon_sym_u222a] = ACTIONS(5555),
    [anon_sym_DOT_DOT] = ACTIONS(5553),
    [anon_sym_u2025] = ACTIONS(5555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5555),
    [anon_sym_u2026] = ACTIONS(5555),
    [anon_sym_PLUS] = ACTIONS(5553),
    [sym_plusplus] = ACTIONS(5555),
    [anon_sym_BSLASHoplus] = ACTIONS(5555),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5555),
    [anon_sym_u2295] = ACTIONS(5555),
    [anon_sym_BSLASHominus] = ACTIONS(5555),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5555),
    [anon_sym_u2296] = ACTIONS(5555),
    [sym_mod] = ACTIONS(5553),
    [sym_modmod] = ACTIONS(5555),
    [sym_vert] = ACTIONS(5553),
    [anon_sym_PIPE_PIPE] = ACTIONS(5555),
    [anon_sym_u2016] = ACTIONS(5555),
    [sym_minusminus] = ACTIONS(5555),
    [sym_amp] = ACTIONS(5553),
    [sym_ampamp] = ACTIONS(5555),
    [anon_sym_BSLASHodot] = ACTIONS(5555),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5555),
    [anon_sym_u2299] = ACTIONS(5555),
    [anon_sym_BSLASHoslash] = ACTIONS(5555),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5555),
    [anon_sym_u2298] = ACTIONS(5555),
    [anon_sym_BSLASHotimes] = ACTIONS(5555),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5555),
    [anon_sym_u2297] = ACTIONS(5555),
    [sym_mul] = ACTIONS(5553),
    [sym_mulmul] = ACTIONS(5555),
    [sym_slash] = ACTIONS(5553),
    [sym_slashslash] = ACTIONS(5555),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5555),
    [anon_sym_u25ef] = ACTIONS(5555),
    [anon_sym_BSLASHbullet] = ACTIONS(5555),
    [anon_sym_u25cf] = ACTIONS(5555),
    [anon_sym_BSLASHdiv] = ACTIONS(5555),
    [anon_sym_u00f7] = ACTIONS(5555),
    [anon_sym_BSLASHcirc] = ACTIONS(5555),
    [anon_sym_u2218] = ACTIONS(5555),
    [anon_sym_BSLASHstar] = ACTIONS(5555),
    [anon_sym_u22c6] = ACTIONS(5555),
    [anon_sym_u203c] = ACTIONS(5555),
    [sym_hashhash] = ACTIONS(5555),
    [sym_dol] = ACTIONS(5553),
    [sym_doldol] = ACTIONS(5555),
    [anon_sym_QMARK_QMARK] = ACTIONS(5555),
    [anon_sym_u2047] = ACTIONS(5555),
    [anon_sym_BSLASHsqcap] = ACTIONS(5555),
    [anon_sym_u2293] = ACTIONS(5555),
    [anon_sym_BSLASHsqcup] = ACTIONS(5555),
    [anon_sym_u2294] = ACTIONS(5555),
    [anon_sym_BSLASHuplus] = ACTIONS(5555),
    [anon_sym_u228e] = ACTIONS(5555),
    [anon_sym_BSLASHX] = ACTIONS(5555),
    [anon_sym_BSLASHtimes] = ACTIONS(5555),
    [anon_sym_u00d7] = ACTIONS(5555),
    [anon_sym_BSLASHwr] = ACTIONS(5555),
    [anon_sym_u2240] = ACTIONS(5555),
    [anon_sym_BSLASHcdot] = ACTIONS(5555),
    [anon_sym_u22c5] = ACTIONS(5555),
    [sym_pow] = ACTIONS(5553),
    [sym_powpow] = ACTIONS(5555),
    [anon_sym_CARET_PLUS] = ACTIONS(5555),
    [anon_sym_u207a] = ACTIONS(5555),
    [sym_asterisk] = ACTIONS(5555),
    [sym_sup_hash] = ACTIONS(5555),
    [sym_prime] = ACTIONS(5555),
    [sym__indent] = ACTIONS(5555),
    [sym__double_excl] = ACTIONS(5555),
  },
  [2187] = {
    [sym_block_comment] = STATE(2187),
    [sym_identifier] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5557),
    [anon_sym_u2208] = ACTIONS(5559),
    [anon_sym_BSLASHA] = ACTIONS(5557),
    [anon_sym_BSLASHforall] = ACTIONS(5559),
    [anon_sym_u2200] = ACTIONS(5559),
    [anon_sym_BSLASHE] = ACTIONS(5557),
    [anon_sym_BSLASHexists] = ACTIONS(5559),
    [anon_sym_u2203] = ACTIONS(5559),
    [sym_temporal_forall] = ACTIONS(5559),
    [sym_temporal_exists] = ACTIONS(5559),
    [anon_sym_LT_LT] = ACTIONS(5559),
    [anon_sym_u3008] = ACTIONS(5559),
    [anon_sym_u27e8] = ACTIONS(5559),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5559),
    [anon_sym_u25a1] = ACTIONS(5559),
    [anon_sym_AT] = ACTIONS(5557),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5559),
    [anon_sym_u2227] = ACTIONS(5559),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5559),
    [anon_sym_u2228] = ACTIONS(5559),
    [anon_sym_LPAREN] = ACTIONS(5557),
    [anon_sym_LBRACK] = ACTIONS(5557),
    [aux_sym_child_id_token1] = ACTIONS(5557),
    [sym_real_number] = ACTIONS(5559),
    [anon_sym_BSLASHb] = ACTIONS(5557),
    [anon_sym_BSLASHB] = ACTIONS(5559),
    [anon_sym_BSLASHo] = ACTIONS(5557),
    [anon_sym_BSLASHO] = ACTIONS(5559),
    [anon_sym_BSLASHh] = ACTIONS(5559),
    [anon_sym_BSLASHH] = ACTIONS(5559),
    [anon_sym_DQUOTE] = ACTIONS(5559),
    [anon_sym_TRUE] = ACTIONS(5557),
    [anon_sym_FALSE] = ACTIONS(5557),
    [sym_string_set] = ACTIONS(5557),
    [sym_boolean_set] = ACTIONS(5557),
    [anon_sym_Nat] = ACTIONS(5557),
    [anon_sym_u2115] = ACTIONS(5559),
    [anon_sym_Int] = ACTIONS(5557),
    [anon_sym_u2124] = ACTIONS(5559),
    [anon_sym_Real] = ACTIONS(5557),
    [anon_sym_u211d] = ACTIONS(5559),
    [anon_sym_CHOOSE] = ACTIONS(5557),
    [anon_sym_LBRACE] = ACTIONS(5559),
    [anon_sym_EQ] = ACTIONS(5557),
    [anon_sym_WF_] = ACTIONS(5557),
    [anon_sym_SF_] = ACTIONS(5557),
    [anon_sym_IF] = ACTIONS(5557),
    [anon_sym_CASE] = ACTIONS(5557),
    [anon_sym_LET] = ACTIONS(5557),
    [anon_sym_BSLASHlnot] = ACTIONS(5559),
    [anon_sym_BSLASHneg] = ACTIONS(5559),
    [anon_sym_TILDE] = ACTIONS(5557),
    [anon_sym_u00ac] = ACTIONS(5559),
    [sym_union] = ACTIONS(5557),
    [sym_powerset] = ACTIONS(5557),
    [sym_domain] = ACTIONS(5557),
    [anon_sym_DASH] = ACTIONS(5557),
    [sym_negative_dot] = ACTIONS(5559),
    [sym_enabled] = ACTIONS(5557),
    [sym_unchanged] = ACTIONS(5557),
    [anon_sym_LT_GT] = ACTIONS(5559),
    [anon_sym_u22c4] = ACTIONS(5559),
    [anon_sym_u25c7] = ACTIONS(5559),
    [anon_sym_EQ_GT] = ACTIONS(5559),
    [anon_sym_u27f9] = ACTIONS(5559),
    [anon_sym_u21d2] = ACTIONS(5559),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5559),
    [anon_sym_u21f8] = ACTIONS(5559),
    [anon_sym_u2945] = ACTIONS(5559),
    [anon_sym_BSLASHequiv] = ACTIONS(5559),
    [anon_sym_u2261] = ACTIONS(5559),
    [anon_sym_LT_EQ_GT] = ACTIONS(5559),
    [anon_sym_u27fa] = ACTIONS(5559),
    [anon_sym_u21d4] = ACTIONS(5559),
    [anon_sym_TILDE_GT] = ACTIONS(5559),
    [anon_sym_u21dd] = ACTIONS(5559),
    [anon_sym_u219d] = ACTIONS(5559),
    [anon_sym_BSLASHland] = ACTIONS(5559),
    [anon_sym_BSLASHlor] = ACTIONS(5559),
    [anon_sym_COLON_EQ] = ACTIONS(5559),
    [anon_sym_u2254] = ACTIONS(5559),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5559),
    [anon_sym_u2a74] = ACTIONS(5559),
    [anon_sym_SLASH_EQ] = ACTIONS(5559),
    [anon_sym_POUND] = ACTIONS(5557),
    [anon_sym_u2260] = ACTIONS(5559),
    [anon_sym_LT] = ACTIONS(5557),
    [sym_gt] = ACTIONS(5557),
    [anon_sym_LT_EQ] = ACTIONS(5557),
    [anon_sym_EQ_LT] = ACTIONS(5559),
    [anon_sym_BSLASHleq] = ACTIONS(5559),
    [anon_sym_u2264] = ACTIONS(5559),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_BSLASHgeq] = ACTIONS(5559),
    [anon_sym_u2265] = ACTIONS(5559),
    [anon_sym_BSLASHapprox] = ACTIONS(5559),
    [anon_sym_u2248] = ACTIONS(5559),
    [anon_sym_PIPE_DASH] = ACTIONS(5559),
    [anon_sym_u22a2] = ACTIONS(5559),
    [anon_sym_PIPE_EQ] = ACTIONS(5559),
    [anon_sym_u22a8] = ACTIONS(5559),
    [anon_sym_DASH_PIPE] = ACTIONS(5559),
    [anon_sym_u22a3] = ACTIONS(5559),
    [anon_sym_EQ_PIPE] = ACTIONS(5559),
    [anon_sym_u2ae4] = ACTIONS(5559),
    [anon_sym_BSLASHasymp] = ACTIONS(5559),
    [anon_sym_u224d] = ACTIONS(5559),
    [anon_sym_BSLASHcong] = ACTIONS(5559),
    [anon_sym_u2245] = ACTIONS(5559),
    [anon_sym_BSLASHdoteq] = ACTIONS(5559),
    [anon_sym_u2250] = ACTIONS(5559),
    [anon_sym_BSLASHgg] = ACTIONS(5559),
    [anon_sym_u226b] = ACTIONS(5559),
    [anon_sym_BSLASHll] = ACTIONS(5559),
    [anon_sym_u226a] = ACTIONS(5559),
    [anon_sym_BSLASHnotin] = ACTIONS(5559),
    [anon_sym_u2209] = ACTIONS(5559),
    [anon_sym_BSLASHprec] = ACTIONS(5557),
    [anon_sym_u227a] = ACTIONS(5559),
    [anon_sym_BSLASHsucc] = ACTIONS(5557),
    [anon_sym_u227b] = ACTIONS(5559),
    [anon_sym_BSLASHpreceq] = ACTIONS(5559),
    [anon_sym_u2aaf] = ACTIONS(5559),
    [anon_sym_BSLASHsucceq] = ACTIONS(5559),
    [anon_sym_u2ab0] = ACTIONS(5559),
    [anon_sym_BSLASHpropto] = ACTIONS(5559),
    [anon_sym_u221d] = ACTIONS(5559),
    [anon_sym_BSLASHsim] = ACTIONS(5557),
    [anon_sym_u223c] = ACTIONS(5559),
    [anon_sym_BSLASHsimeq] = ACTIONS(5559),
    [anon_sym_u2243] = ACTIONS(5559),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5557),
    [anon_sym_u228f] = ACTIONS(5559),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5557),
    [anon_sym_u2290] = ACTIONS(5559),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5559),
    [anon_sym_u2291] = ACTIONS(5559),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5559),
    [anon_sym_u2292] = ACTIONS(5559),
    [anon_sym_BSLASHsubset] = ACTIONS(5557),
    [anon_sym_u2282] = ACTIONS(5559),
    [anon_sym_BSLASHsupset] = ACTIONS(5557),
    [anon_sym_u2283] = ACTIONS(5559),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5559),
    [anon_sym_u2286] = ACTIONS(5559),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5559),
    [anon_sym_u2287] = ACTIONS(5559),
    [sym_compose] = ACTIONS(5559),
    [sym_map_to] = ACTIONS(5559),
    [sym_map_from] = ACTIONS(5559),
    [sym_setminus] = ACTIONS(5557),
    [anon_sym_BSLASHcap] = ACTIONS(5559),
    [anon_sym_BSLASHintersect] = ACTIONS(5559),
    [anon_sym_u2229] = ACTIONS(5559),
    [anon_sym_BSLASHcup] = ACTIONS(5559),
    [anon_sym_BSLASHunion] = ACTIONS(5559),
    [anon_sym_u222a] = ACTIONS(5559),
    [anon_sym_DOT_DOT] = ACTIONS(5557),
    [anon_sym_u2025] = ACTIONS(5559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5559),
    [anon_sym_u2026] = ACTIONS(5559),
    [anon_sym_PLUS] = ACTIONS(5557),
    [sym_plusplus] = ACTIONS(5559),
    [anon_sym_BSLASHoplus] = ACTIONS(5559),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5559),
    [anon_sym_u2295] = ACTIONS(5559),
    [anon_sym_BSLASHominus] = ACTIONS(5559),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5559),
    [anon_sym_u2296] = ACTIONS(5559),
    [sym_mod] = ACTIONS(5557),
    [sym_modmod] = ACTIONS(5559),
    [sym_vert] = ACTIONS(5557),
    [anon_sym_PIPE_PIPE] = ACTIONS(5559),
    [anon_sym_u2016] = ACTIONS(5559),
    [sym_minusminus] = ACTIONS(5559),
    [sym_amp] = ACTIONS(5557),
    [sym_ampamp] = ACTIONS(5559),
    [anon_sym_BSLASHodot] = ACTIONS(5559),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5559),
    [anon_sym_u2299] = ACTIONS(5559),
    [anon_sym_BSLASHoslash] = ACTIONS(5559),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5559),
    [anon_sym_u2298] = ACTIONS(5559),
    [anon_sym_BSLASHotimes] = ACTIONS(5559),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5559),
    [anon_sym_u2297] = ACTIONS(5559),
    [sym_mul] = ACTIONS(5557),
    [sym_mulmul] = ACTIONS(5559),
    [sym_slash] = ACTIONS(5557),
    [sym_slashslash] = ACTIONS(5559),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5559),
    [anon_sym_u25ef] = ACTIONS(5559),
    [anon_sym_BSLASHbullet] = ACTIONS(5559),
    [anon_sym_u25cf] = ACTIONS(5559),
    [anon_sym_BSLASHdiv] = ACTIONS(5559),
    [anon_sym_u00f7] = ACTIONS(5559),
    [anon_sym_BSLASHcirc] = ACTIONS(5559),
    [anon_sym_u2218] = ACTIONS(5559),
    [anon_sym_BSLASHstar] = ACTIONS(5559),
    [anon_sym_u22c6] = ACTIONS(5559),
    [anon_sym_u203c] = ACTIONS(5559),
    [sym_hashhash] = ACTIONS(5559),
    [sym_dol] = ACTIONS(5557),
    [sym_doldol] = ACTIONS(5559),
    [anon_sym_QMARK_QMARK] = ACTIONS(5559),
    [anon_sym_u2047] = ACTIONS(5559),
    [anon_sym_BSLASHsqcap] = ACTIONS(5559),
    [anon_sym_u2293] = ACTIONS(5559),
    [anon_sym_BSLASHsqcup] = ACTIONS(5559),
    [anon_sym_u2294] = ACTIONS(5559),
    [anon_sym_BSLASHuplus] = ACTIONS(5559),
    [anon_sym_u228e] = ACTIONS(5559),
    [anon_sym_BSLASHX] = ACTIONS(5559),
    [anon_sym_BSLASHtimes] = ACTIONS(5559),
    [anon_sym_u00d7] = ACTIONS(5559),
    [anon_sym_BSLASHwr] = ACTIONS(5559),
    [anon_sym_u2240] = ACTIONS(5559),
    [anon_sym_BSLASHcdot] = ACTIONS(5559),
    [anon_sym_u22c5] = ACTIONS(5559),
    [sym_pow] = ACTIONS(5557),
    [sym_powpow] = ACTIONS(5559),
    [anon_sym_CARET_PLUS] = ACTIONS(5559),
    [anon_sym_u207a] = ACTIONS(5559),
    [sym_asterisk] = ACTIONS(5559),
    [sym_sup_hash] = ACTIONS(5559),
    [sym_prime] = ACTIONS(5559),
    [sym__indent] = ACTIONS(5559),
    [sym__double_excl] = ACTIONS(5559),
  },
  [2188] = {
    [sym_block_comment] = STATE(2188),
    [sym_identifier] = ACTIONS(5561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5561),
    [anon_sym_u2208] = ACTIONS(5563),
    [anon_sym_BSLASHA] = ACTIONS(5561),
    [anon_sym_BSLASHforall] = ACTIONS(5563),
    [anon_sym_u2200] = ACTIONS(5563),
    [anon_sym_BSLASHE] = ACTIONS(5561),
    [anon_sym_BSLASHexists] = ACTIONS(5563),
    [anon_sym_u2203] = ACTIONS(5563),
    [sym_temporal_forall] = ACTIONS(5563),
    [sym_temporal_exists] = ACTIONS(5563),
    [anon_sym_LT_LT] = ACTIONS(5563),
    [anon_sym_u3008] = ACTIONS(5563),
    [anon_sym_u27e8] = ACTIONS(5563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5563),
    [anon_sym_u25a1] = ACTIONS(5563),
    [anon_sym_AT] = ACTIONS(5561),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5563),
    [anon_sym_u2227] = ACTIONS(5563),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5563),
    [anon_sym_u2228] = ACTIONS(5563),
    [anon_sym_LPAREN] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(5561),
    [aux_sym_child_id_token1] = ACTIONS(5561),
    [sym_real_number] = ACTIONS(5563),
    [anon_sym_BSLASHb] = ACTIONS(5561),
    [anon_sym_BSLASHB] = ACTIONS(5563),
    [anon_sym_BSLASHo] = ACTIONS(5561),
    [anon_sym_BSLASHO] = ACTIONS(5563),
    [anon_sym_BSLASHh] = ACTIONS(5563),
    [anon_sym_BSLASHH] = ACTIONS(5563),
    [anon_sym_DQUOTE] = ACTIONS(5563),
    [anon_sym_TRUE] = ACTIONS(5561),
    [anon_sym_FALSE] = ACTIONS(5561),
    [sym_string_set] = ACTIONS(5561),
    [sym_boolean_set] = ACTIONS(5561),
    [anon_sym_Nat] = ACTIONS(5561),
    [anon_sym_u2115] = ACTIONS(5563),
    [anon_sym_Int] = ACTIONS(5561),
    [anon_sym_u2124] = ACTIONS(5563),
    [anon_sym_Real] = ACTIONS(5561),
    [anon_sym_u211d] = ACTIONS(5563),
    [anon_sym_CHOOSE] = ACTIONS(5561),
    [anon_sym_LBRACE] = ACTIONS(5563),
    [anon_sym_EQ] = ACTIONS(5561),
    [anon_sym_WF_] = ACTIONS(5561),
    [anon_sym_SF_] = ACTIONS(5561),
    [anon_sym_IF] = ACTIONS(5561),
    [anon_sym_CASE] = ACTIONS(5561),
    [anon_sym_LET] = ACTIONS(5561),
    [anon_sym_BSLASHlnot] = ACTIONS(5563),
    [anon_sym_BSLASHneg] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5561),
    [anon_sym_u00ac] = ACTIONS(5563),
    [sym_union] = ACTIONS(5561),
    [sym_powerset] = ACTIONS(5561),
    [sym_domain] = ACTIONS(5561),
    [anon_sym_DASH] = ACTIONS(5561),
    [sym_negative_dot] = ACTIONS(5563),
    [sym_enabled] = ACTIONS(5561),
    [sym_unchanged] = ACTIONS(5561),
    [anon_sym_LT_GT] = ACTIONS(5563),
    [anon_sym_u22c4] = ACTIONS(5563),
    [anon_sym_u25c7] = ACTIONS(5563),
    [anon_sym_EQ_GT] = ACTIONS(5563),
    [anon_sym_u27f9] = ACTIONS(5563),
    [anon_sym_u21d2] = ACTIONS(5563),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5563),
    [anon_sym_u21f8] = ACTIONS(5563),
    [anon_sym_u2945] = ACTIONS(5563),
    [anon_sym_BSLASHequiv] = ACTIONS(5563),
    [anon_sym_u2261] = ACTIONS(5563),
    [anon_sym_LT_EQ_GT] = ACTIONS(5563),
    [anon_sym_u27fa] = ACTIONS(5563),
    [anon_sym_u21d4] = ACTIONS(5563),
    [anon_sym_TILDE_GT] = ACTIONS(5563),
    [anon_sym_u21dd] = ACTIONS(5563),
    [anon_sym_u219d] = ACTIONS(5563),
    [anon_sym_BSLASHland] = ACTIONS(5563),
    [anon_sym_BSLASHlor] = ACTIONS(5563),
    [anon_sym_COLON_EQ] = ACTIONS(5563),
    [anon_sym_u2254] = ACTIONS(5563),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5563),
    [anon_sym_u2a74] = ACTIONS(5563),
    [anon_sym_SLASH_EQ] = ACTIONS(5563),
    [anon_sym_POUND] = ACTIONS(5561),
    [anon_sym_u2260] = ACTIONS(5563),
    [anon_sym_LT] = ACTIONS(5561),
    [sym_gt] = ACTIONS(5561),
    [anon_sym_LT_EQ] = ACTIONS(5561),
    [anon_sym_EQ_LT] = ACTIONS(5563),
    [anon_sym_BSLASHleq] = ACTIONS(5563),
    [anon_sym_u2264] = ACTIONS(5563),
    [anon_sym_GT_EQ] = ACTIONS(5563),
    [anon_sym_BSLASHgeq] = ACTIONS(5563),
    [anon_sym_u2265] = ACTIONS(5563),
    [anon_sym_BSLASHapprox] = ACTIONS(5563),
    [anon_sym_u2248] = ACTIONS(5563),
    [anon_sym_PIPE_DASH] = ACTIONS(5563),
    [anon_sym_u22a2] = ACTIONS(5563),
    [anon_sym_PIPE_EQ] = ACTIONS(5563),
    [anon_sym_u22a8] = ACTIONS(5563),
    [anon_sym_DASH_PIPE] = ACTIONS(5563),
    [anon_sym_u22a3] = ACTIONS(5563),
    [anon_sym_EQ_PIPE] = ACTIONS(5563),
    [anon_sym_u2ae4] = ACTIONS(5563),
    [anon_sym_BSLASHasymp] = ACTIONS(5563),
    [anon_sym_u224d] = ACTIONS(5563),
    [anon_sym_BSLASHcong] = ACTIONS(5563),
    [anon_sym_u2245] = ACTIONS(5563),
    [anon_sym_BSLASHdoteq] = ACTIONS(5563),
    [anon_sym_u2250] = ACTIONS(5563),
    [anon_sym_BSLASHgg] = ACTIONS(5563),
    [anon_sym_u226b] = ACTIONS(5563),
    [anon_sym_BSLASHll] = ACTIONS(5563),
    [anon_sym_u226a] = ACTIONS(5563),
    [anon_sym_BSLASHnotin] = ACTIONS(5563),
    [anon_sym_u2209] = ACTIONS(5563),
    [anon_sym_BSLASHprec] = ACTIONS(5561),
    [anon_sym_u227a] = ACTIONS(5563),
    [anon_sym_BSLASHsucc] = ACTIONS(5561),
    [anon_sym_u227b] = ACTIONS(5563),
    [anon_sym_BSLASHpreceq] = ACTIONS(5563),
    [anon_sym_u2aaf] = ACTIONS(5563),
    [anon_sym_BSLASHsucceq] = ACTIONS(5563),
    [anon_sym_u2ab0] = ACTIONS(5563),
    [anon_sym_BSLASHpropto] = ACTIONS(5563),
    [anon_sym_u221d] = ACTIONS(5563),
    [anon_sym_BSLASHsim] = ACTIONS(5561),
    [anon_sym_u223c] = ACTIONS(5563),
    [anon_sym_BSLASHsimeq] = ACTIONS(5563),
    [anon_sym_u2243] = ACTIONS(5563),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5561),
    [anon_sym_u228f] = ACTIONS(5563),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5561),
    [anon_sym_u2290] = ACTIONS(5563),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5563),
    [anon_sym_u2291] = ACTIONS(5563),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5563),
    [anon_sym_u2292] = ACTIONS(5563),
    [anon_sym_BSLASHsubset] = ACTIONS(5561),
    [anon_sym_u2282] = ACTIONS(5563),
    [anon_sym_BSLASHsupset] = ACTIONS(5561),
    [anon_sym_u2283] = ACTIONS(5563),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5563),
    [anon_sym_u2286] = ACTIONS(5563),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5563),
    [anon_sym_u2287] = ACTIONS(5563),
    [sym_compose] = ACTIONS(5563),
    [sym_map_to] = ACTIONS(5563),
    [sym_map_from] = ACTIONS(5563),
    [sym_setminus] = ACTIONS(5561),
    [anon_sym_BSLASHcap] = ACTIONS(5563),
    [anon_sym_BSLASHintersect] = ACTIONS(5563),
    [anon_sym_u2229] = ACTIONS(5563),
    [anon_sym_BSLASHcup] = ACTIONS(5563),
    [anon_sym_BSLASHunion] = ACTIONS(5563),
    [anon_sym_u222a] = ACTIONS(5563),
    [anon_sym_DOT_DOT] = ACTIONS(5561),
    [anon_sym_u2025] = ACTIONS(5563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5563),
    [anon_sym_u2026] = ACTIONS(5563),
    [anon_sym_PLUS] = ACTIONS(5561),
    [sym_plusplus] = ACTIONS(5563),
    [anon_sym_BSLASHoplus] = ACTIONS(5563),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5563),
    [anon_sym_u2295] = ACTIONS(5563),
    [anon_sym_BSLASHominus] = ACTIONS(5563),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5563),
    [anon_sym_u2296] = ACTIONS(5563),
    [sym_mod] = ACTIONS(5561),
    [sym_modmod] = ACTIONS(5563),
    [sym_vert] = ACTIONS(5561),
    [anon_sym_PIPE_PIPE] = ACTIONS(5563),
    [anon_sym_u2016] = ACTIONS(5563),
    [sym_minusminus] = ACTIONS(5563),
    [sym_amp] = ACTIONS(5561),
    [sym_ampamp] = ACTIONS(5563),
    [anon_sym_BSLASHodot] = ACTIONS(5563),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5563),
    [anon_sym_u2299] = ACTIONS(5563),
    [anon_sym_BSLASHoslash] = ACTIONS(5563),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5563),
    [anon_sym_u2298] = ACTIONS(5563),
    [anon_sym_BSLASHotimes] = ACTIONS(5563),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5563),
    [anon_sym_u2297] = ACTIONS(5563),
    [sym_mul] = ACTIONS(5561),
    [sym_mulmul] = ACTIONS(5563),
    [sym_slash] = ACTIONS(5561),
    [sym_slashslash] = ACTIONS(5563),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5563),
    [anon_sym_u25ef] = ACTIONS(5563),
    [anon_sym_BSLASHbullet] = ACTIONS(5563),
    [anon_sym_u25cf] = ACTIONS(5563),
    [anon_sym_BSLASHdiv] = ACTIONS(5563),
    [anon_sym_u00f7] = ACTIONS(5563),
    [anon_sym_BSLASHcirc] = ACTIONS(5563),
    [anon_sym_u2218] = ACTIONS(5563),
    [anon_sym_BSLASHstar] = ACTIONS(5563),
    [anon_sym_u22c6] = ACTIONS(5563),
    [anon_sym_u203c] = ACTIONS(5563),
    [sym_hashhash] = ACTIONS(5563),
    [sym_dol] = ACTIONS(5561),
    [sym_doldol] = ACTIONS(5563),
    [anon_sym_QMARK_QMARK] = ACTIONS(5563),
    [anon_sym_u2047] = ACTIONS(5563),
    [anon_sym_BSLASHsqcap] = ACTIONS(5563),
    [anon_sym_u2293] = ACTIONS(5563),
    [anon_sym_BSLASHsqcup] = ACTIONS(5563),
    [anon_sym_u2294] = ACTIONS(5563),
    [anon_sym_BSLASHuplus] = ACTIONS(5563),
    [anon_sym_u228e] = ACTIONS(5563),
    [anon_sym_BSLASHX] = ACTIONS(5563),
    [anon_sym_BSLASHtimes] = ACTIONS(5563),
    [anon_sym_u00d7] = ACTIONS(5563),
    [anon_sym_BSLASHwr] = ACTIONS(5563),
    [anon_sym_u2240] = ACTIONS(5563),
    [anon_sym_BSLASHcdot] = ACTIONS(5563),
    [anon_sym_u22c5] = ACTIONS(5563),
    [sym_pow] = ACTIONS(5561),
    [sym_powpow] = ACTIONS(5563),
    [anon_sym_CARET_PLUS] = ACTIONS(5563),
    [anon_sym_u207a] = ACTIONS(5563),
    [sym_asterisk] = ACTIONS(5563),
    [sym_sup_hash] = ACTIONS(5563),
    [sym_prime] = ACTIONS(5563),
    [sym__indent] = ACTIONS(5563),
    [sym__double_excl] = ACTIONS(5563),
  },
  [2189] = {
    [sym_block_comment] = STATE(2189),
    [sym_identifier] = ACTIONS(5565),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5565),
    [anon_sym_u2208] = ACTIONS(5567),
    [anon_sym_BSLASHA] = ACTIONS(5565),
    [anon_sym_BSLASHforall] = ACTIONS(5567),
    [anon_sym_u2200] = ACTIONS(5567),
    [anon_sym_BSLASHE] = ACTIONS(5565),
    [anon_sym_BSLASHexists] = ACTIONS(5567),
    [anon_sym_u2203] = ACTIONS(5567),
    [sym_temporal_forall] = ACTIONS(5567),
    [sym_temporal_exists] = ACTIONS(5567),
    [anon_sym_LT_LT] = ACTIONS(5567),
    [anon_sym_u3008] = ACTIONS(5567),
    [anon_sym_u27e8] = ACTIONS(5567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5567),
    [anon_sym_u25a1] = ACTIONS(5567),
    [anon_sym_AT] = ACTIONS(5565),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5567),
    [anon_sym_u2227] = ACTIONS(5567),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5567),
    [anon_sym_u2228] = ACTIONS(5567),
    [anon_sym_LPAREN] = ACTIONS(5565),
    [anon_sym_LBRACK] = ACTIONS(5565),
    [aux_sym_child_id_token1] = ACTIONS(5565),
    [sym_real_number] = ACTIONS(5567),
    [anon_sym_BSLASHb] = ACTIONS(5565),
    [anon_sym_BSLASHB] = ACTIONS(5567),
    [anon_sym_BSLASHo] = ACTIONS(5565),
    [anon_sym_BSLASHO] = ACTIONS(5567),
    [anon_sym_BSLASHh] = ACTIONS(5567),
    [anon_sym_BSLASHH] = ACTIONS(5567),
    [anon_sym_DQUOTE] = ACTIONS(5567),
    [anon_sym_TRUE] = ACTIONS(5565),
    [anon_sym_FALSE] = ACTIONS(5565),
    [sym_string_set] = ACTIONS(5565),
    [sym_boolean_set] = ACTIONS(5565),
    [anon_sym_Nat] = ACTIONS(5565),
    [anon_sym_u2115] = ACTIONS(5567),
    [anon_sym_Int] = ACTIONS(5565),
    [anon_sym_u2124] = ACTIONS(5567),
    [anon_sym_Real] = ACTIONS(5565),
    [anon_sym_u211d] = ACTIONS(5567),
    [anon_sym_CHOOSE] = ACTIONS(5565),
    [anon_sym_LBRACE] = ACTIONS(5567),
    [anon_sym_EQ] = ACTIONS(5565),
    [anon_sym_WF_] = ACTIONS(5565),
    [anon_sym_SF_] = ACTIONS(5565),
    [anon_sym_IF] = ACTIONS(5565),
    [anon_sym_CASE] = ACTIONS(5565),
    [anon_sym_LET] = ACTIONS(5565),
    [anon_sym_BSLASHlnot] = ACTIONS(5567),
    [anon_sym_BSLASHneg] = ACTIONS(5567),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_u00ac] = ACTIONS(5567),
    [sym_union] = ACTIONS(5565),
    [sym_powerset] = ACTIONS(5565),
    [sym_domain] = ACTIONS(5565),
    [anon_sym_DASH] = ACTIONS(5565),
    [sym_negative_dot] = ACTIONS(5567),
    [sym_enabled] = ACTIONS(5565),
    [sym_unchanged] = ACTIONS(5565),
    [anon_sym_LT_GT] = ACTIONS(5567),
    [anon_sym_u22c4] = ACTIONS(5567),
    [anon_sym_u25c7] = ACTIONS(5567),
    [anon_sym_EQ_GT] = ACTIONS(5567),
    [anon_sym_u27f9] = ACTIONS(5567),
    [anon_sym_u21d2] = ACTIONS(5567),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5567),
    [anon_sym_u21f8] = ACTIONS(5567),
    [anon_sym_u2945] = ACTIONS(5567),
    [anon_sym_BSLASHequiv] = ACTIONS(5567),
    [anon_sym_u2261] = ACTIONS(5567),
    [anon_sym_LT_EQ_GT] = ACTIONS(5567),
    [anon_sym_u27fa] = ACTIONS(5567),
    [anon_sym_u21d4] = ACTIONS(5567),
    [anon_sym_TILDE_GT] = ACTIONS(5567),
    [anon_sym_u21dd] = ACTIONS(5567),
    [anon_sym_u219d] = ACTIONS(5567),
    [anon_sym_BSLASHland] = ACTIONS(5567),
    [anon_sym_BSLASHlor] = ACTIONS(5567),
    [anon_sym_COLON_EQ] = ACTIONS(5567),
    [anon_sym_u2254] = ACTIONS(5567),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5567),
    [anon_sym_u2a74] = ACTIONS(5567),
    [anon_sym_SLASH_EQ] = ACTIONS(5567),
    [anon_sym_POUND] = ACTIONS(5565),
    [anon_sym_u2260] = ACTIONS(5567),
    [anon_sym_LT] = ACTIONS(5565),
    [sym_gt] = ACTIONS(5565),
    [anon_sym_LT_EQ] = ACTIONS(5565),
    [anon_sym_EQ_LT] = ACTIONS(5567),
    [anon_sym_BSLASHleq] = ACTIONS(5567),
    [anon_sym_u2264] = ACTIONS(5567),
    [anon_sym_GT_EQ] = ACTIONS(5567),
    [anon_sym_BSLASHgeq] = ACTIONS(5567),
    [anon_sym_u2265] = ACTIONS(5567),
    [anon_sym_BSLASHapprox] = ACTIONS(5567),
    [anon_sym_u2248] = ACTIONS(5567),
    [anon_sym_PIPE_DASH] = ACTIONS(5567),
    [anon_sym_u22a2] = ACTIONS(5567),
    [anon_sym_PIPE_EQ] = ACTIONS(5567),
    [anon_sym_u22a8] = ACTIONS(5567),
    [anon_sym_DASH_PIPE] = ACTIONS(5567),
    [anon_sym_u22a3] = ACTIONS(5567),
    [anon_sym_EQ_PIPE] = ACTIONS(5567),
    [anon_sym_u2ae4] = ACTIONS(5567),
    [anon_sym_BSLASHasymp] = ACTIONS(5567),
    [anon_sym_u224d] = ACTIONS(5567),
    [anon_sym_BSLASHcong] = ACTIONS(5567),
    [anon_sym_u2245] = ACTIONS(5567),
    [anon_sym_BSLASHdoteq] = ACTIONS(5567),
    [anon_sym_u2250] = ACTIONS(5567),
    [anon_sym_BSLASHgg] = ACTIONS(5567),
    [anon_sym_u226b] = ACTIONS(5567),
    [anon_sym_BSLASHll] = ACTIONS(5567),
    [anon_sym_u226a] = ACTIONS(5567),
    [anon_sym_BSLASHnotin] = ACTIONS(5567),
    [anon_sym_u2209] = ACTIONS(5567),
    [anon_sym_BSLASHprec] = ACTIONS(5565),
    [anon_sym_u227a] = ACTIONS(5567),
    [anon_sym_BSLASHsucc] = ACTIONS(5565),
    [anon_sym_u227b] = ACTIONS(5567),
    [anon_sym_BSLASHpreceq] = ACTIONS(5567),
    [anon_sym_u2aaf] = ACTIONS(5567),
    [anon_sym_BSLASHsucceq] = ACTIONS(5567),
    [anon_sym_u2ab0] = ACTIONS(5567),
    [anon_sym_BSLASHpropto] = ACTIONS(5567),
    [anon_sym_u221d] = ACTIONS(5567),
    [anon_sym_BSLASHsim] = ACTIONS(5565),
    [anon_sym_u223c] = ACTIONS(5567),
    [anon_sym_BSLASHsimeq] = ACTIONS(5567),
    [anon_sym_u2243] = ACTIONS(5567),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5565),
    [anon_sym_u228f] = ACTIONS(5567),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5565),
    [anon_sym_u2290] = ACTIONS(5567),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5567),
    [anon_sym_u2291] = ACTIONS(5567),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5567),
    [anon_sym_u2292] = ACTIONS(5567),
    [anon_sym_BSLASHsubset] = ACTIONS(5565),
    [anon_sym_u2282] = ACTIONS(5567),
    [anon_sym_BSLASHsupset] = ACTIONS(5565),
    [anon_sym_u2283] = ACTIONS(5567),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5567),
    [anon_sym_u2286] = ACTIONS(5567),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5567),
    [anon_sym_u2287] = ACTIONS(5567),
    [sym_compose] = ACTIONS(5567),
    [sym_map_to] = ACTIONS(5567),
    [sym_map_from] = ACTIONS(5567),
    [sym_setminus] = ACTIONS(5565),
    [anon_sym_BSLASHcap] = ACTIONS(5567),
    [anon_sym_BSLASHintersect] = ACTIONS(5567),
    [anon_sym_u2229] = ACTIONS(5567),
    [anon_sym_BSLASHcup] = ACTIONS(5567),
    [anon_sym_BSLASHunion] = ACTIONS(5567),
    [anon_sym_u222a] = ACTIONS(5567),
    [anon_sym_DOT_DOT] = ACTIONS(5565),
    [anon_sym_u2025] = ACTIONS(5567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5567),
    [anon_sym_u2026] = ACTIONS(5567),
    [anon_sym_PLUS] = ACTIONS(5565),
    [sym_plusplus] = ACTIONS(5567),
    [anon_sym_BSLASHoplus] = ACTIONS(5567),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5567),
    [anon_sym_u2295] = ACTIONS(5567),
    [anon_sym_BSLASHominus] = ACTIONS(5567),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5567),
    [anon_sym_u2296] = ACTIONS(5567),
    [sym_mod] = ACTIONS(5565),
    [sym_modmod] = ACTIONS(5567),
    [sym_vert] = ACTIONS(5565),
    [anon_sym_PIPE_PIPE] = ACTIONS(5567),
    [anon_sym_u2016] = ACTIONS(5567),
    [sym_minusminus] = ACTIONS(5567),
    [sym_amp] = ACTIONS(5565),
    [sym_ampamp] = ACTIONS(5567),
    [anon_sym_BSLASHodot] = ACTIONS(5567),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5567),
    [anon_sym_u2299] = ACTIONS(5567),
    [anon_sym_BSLASHoslash] = ACTIONS(5567),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5567),
    [anon_sym_u2298] = ACTIONS(5567),
    [anon_sym_BSLASHotimes] = ACTIONS(5567),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5567),
    [anon_sym_u2297] = ACTIONS(5567),
    [sym_mul] = ACTIONS(5565),
    [sym_mulmul] = ACTIONS(5567),
    [sym_slash] = ACTIONS(5565),
    [sym_slashslash] = ACTIONS(5567),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5567),
    [anon_sym_u25ef] = ACTIONS(5567),
    [anon_sym_BSLASHbullet] = ACTIONS(5567),
    [anon_sym_u25cf] = ACTIONS(5567),
    [anon_sym_BSLASHdiv] = ACTIONS(5567),
    [anon_sym_u00f7] = ACTIONS(5567),
    [anon_sym_BSLASHcirc] = ACTIONS(5567),
    [anon_sym_u2218] = ACTIONS(5567),
    [anon_sym_BSLASHstar] = ACTIONS(5567),
    [anon_sym_u22c6] = ACTIONS(5567),
    [anon_sym_u203c] = ACTIONS(5567),
    [sym_hashhash] = ACTIONS(5567),
    [sym_dol] = ACTIONS(5565),
    [sym_doldol] = ACTIONS(5567),
    [anon_sym_QMARK_QMARK] = ACTIONS(5567),
    [anon_sym_u2047] = ACTIONS(5567),
    [anon_sym_BSLASHsqcap] = ACTIONS(5567),
    [anon_sym_u2293] = ACTIONS(5567),
    [anon_sym_BSLASHsqcup] = ACTIONS(5567),
    [anon_sym_u2294] = ACTIONS(5567),
    [anon_sym_BSLASHuplus] = ACTIONS(5567),
    [anon_sym_u228e] = ACTIONS(5567),
    [anon_sym_BSLASHX] = ACTIONS(5567),
    [anon_sym_BSLASHtimes] = ACTIONS(5567),
    [anon_sym_u00d7] = ACTIONS(5567),
    [anon_sym_BSLASHwr] = ACTIONS(5567),
    [anon_sym_u2240] = ACTIONS(5567),
    [anon_sym_BSLASHcdot] = ACTIONS(5567),
    [anon_sym_u22c5] = ACTIONS(5567),
    [sym_pow] = ACTIONS(5565),
    [sym_powpow] = ACTIONS(5567),
    [anon_sym_CARET_PLUS] = ACTIONS(5567),
    [anon_sym_u207a] = ACTIONS(5567),
    [sym_asterisk] = ACTIONS(5567),
    [sym_sup_hash] = ACTIONS(5567),
    [sym_prime] = ACTIONS(5567),
    [sym__indent] = ACTIONS(5567),
    [sym__double_excl] = ACTIONS(5567),
  },
  [2190] = {
    [sym_block_comment] = STATE(2190),
    [sym_identifier] = ACTIONS(5569),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5569),
    [anon_sym_u2208] = ACTIONS(5571),
    [anon_sym_BSLASHA] = ACTIONS(5569),
    [anon_sym_BSLASHforall] = ACTIONS(5571),
    [anon_sym_u2200] = ACTIONS(5571),
    [anon_sym_BSLASHE] = ACTIONS(5569),
    [anon_sym_BSLASHexists] = ACTIONS(5571),
    [anon_sym_u2203] = ACTIONS(5571),
    [sym_temporal_forall] = ACTIONS(5571),
    [sym_temporal_exists] = ACTIONS(5571),
    [anon_sym_LT_LT] = ACTIONS(5571),
    [anon_sym_u3008] = ACTIONS(5571),
    [anon_sym_u27e8] = ACTIONS(5571),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5571),
    [anon_sym_u25a1] = ACTIONS(5571),
    [anon_sym_AT] = ACTIONS(5569),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5571),
    [anon_sym_u2227] = ACTIONS(5571),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5571),
    [anon_sym_u2228] = ACTIONS(5571),
    [anon_sym_LPAREN] = ACTIONS(5569),
    [anon_sym_LBRACK] = ACTIONS(5569),
    [aux_sym_child_id_token1] = ACTIONS(5569),
    [sym_real_number] = ACTIONS(5571),
    [anon_sym_BSLASHb] = ACTIONS(5569),
    [anon_sym_BSLASHB] = ACTIONS(5571),
    [anon_sym_BSLASHo] = ACTIONS(5569),
    [anon_sym_BSLASHO] = ACTIONS(5571),
    [anon_sym_BSLASHh] = ACTIONS(5571),
    [anon_sym_BSLASHH] = ACTIONS(5571),
    [anon_sym_DQUOTE] = ACTIONS(5571),
    [anon_sym_TRUE] = ACTIONS(5569),
    [anon_sym_FALSE] = ACTIONS(5569),
    [sym_string_set] = ACTIONS(5569),
    [sym_boolean_set] = ACTIONS(5569),
    [anon_sym_Nat] = ACTIONS(5569),
    [anon_sym_u2115] = ACTIONS(5571),
    [anon_sym_Int] = ACTIONS(5569),
    [anon_sym_u2124] = ACTIONS(5571),
    [anon_sym_Real] = ACTIONS(5569),
    [anon_sym_u211d] = ACTIONS(5571),
    [anon_sym_CHOOSE] = ACTIONS(5569),
    [anon_sym_LBRACE] = ACTIONS(5571),
    [anon_sym_EQ] = ACTIONS(5569),
    [anon_sym_WF_] = ACTIONS(5569),
    [anon_sym_SF_] = ACTIONS(5569),
    [anon_sym_IF] = ACTIONS(5569),
    [anon_sym_CASE] = ACTIONS(5569),
    [anon_sym_LET] = ACTIONS(5569),
    [anon_sym_BSLASHlnot] = ACTIONS(5571),
    [anon_sym_BSLASHneg] = ACTIONS(5571),
    [anon_sym_TILDE] = ACTIONS(5569),
    [anon_sym_u00ac] = ACTIONS(5571),
    [sym_union] = ACTIONS(5569),
    [sym_powerset] = ACTIONS(5569),
    [sym_domain] = ACTIONS(5569),
    [anon_sym_DASH] = ACTIONS(5569),
    [sym_negative_dot] = ACTIONS(5571),
    [sym_enabled] = ACTIONS(5569),
    [sym_unchanged] = ACTIONS(5569),
    [anon_sym_LT_GT] = ACTIONS(5571),
    [anon_sym_u22c4] = ACTIONS(5571),
    [anon_sym_u25c7] = ACTIONS(5571),
    [anon_sym_EQ_GT] = ACTIONS(5571),
    [anon_sym_u27f9] = ACTIONS(5571),
    [anon_sym_u21d2] = ACTIONS(5571),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5571),
    [anon_sym_u21f8] = ACTIONS(5571),
    [anon_sym_u2945] = ACTIONS(5571),
    [anon_sym_BSLASHequiv] = ACTIONS(5571),
    [anon_sym_u2261] = ACTIONS(5571),
    [anon_sym_LT_EQ_GT] = ACTIONS(5571),
    [anon_sym_u27fa] = ACTIONS(5571),
    [anon_sym_u21d4] = ACTIONS(5571),
    [anon_sym_TILDE_GT] = ACTIONS(5571),
    [anon_sym_u21dd] = ACTIONS(5571),
    [anon_sym_u219d] = ACTIONS(5571),
    [anon_sym_BSLASHland] = ACTIONS(5571),
    [anon_sym_BSLASHlor] = ACTIONS(5571),
    [anon_sym_COLON_EQ] = ACTIONS(5571),
    [anon_sym_u2254] = ACTIONS(5571),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5571),
    [anon_sym_u2a74] = ACTIONS(5571),
    [anon_sym_SLASH_EQ] = ACTIONS(5571),
    [anon_sym_POUND] = ACTIONS(5569),
    [anon_sym_u2260] = ACTIONS(5571),
    [anon_sym_LT] = ACTIONS(5569),
    [sym_gt] = ACTIONS(5569),
    [anon_sym_LT_EQ] = ACTIONS(5569),
    [anon_sym_EQ_LT] = ACTIONS(5571),
    [anon_sym_BSLASHleq] = ACTIONS(5571),
    [anon_sym_u2264] = ACTIONS(5571),
    [anon_sym_GT_EQ] = ACTIONS(5571),
    [anon_sym_BSLASHgeq] = ACTIONS(5571),
    [anon_sym_u2265] = ACTIONS(5571),
    [anon_sym_BSLASHapprox] = ACTIONS(5571),
    [anon_sym_u2248] = ACTIONS(5571),
    [anon_sym_PIPE_DASH] = ACTIONS(5571),
    [anon_sym_u22a2] = ACTIONS(5571),
    [anon_sym_PIPE_EQ] = ACTIONS(5571),
    [anon_sym_u22a8] = ACTIONS(5571),
    [anon_sym_DASH_PIPE] = ACTIONS(5571),
    [anon_sym_u22a3] = ACTIONS(5571),
    [anon_sym_EQ_PIPE] = ACTIONS(5571),
    [anon_sym_u2ae4] = ACTIONS(5571),
    [anon_sym_BSLASHasymp] = ACTIONS(5571),
    [anon_sym_u224d] = ACTIONS(5571),
    [anon_sym_BSLASHcong] = ACTIONS(5571),
    [anon_sym_u2245] = ACTIONS(5571),
    [anon_sym_BSLASHdoteq] = ACTIONS(5571),
    [anon_sym_u2250] = ACTIONS(5571),
    [anon_sym_BSLASHgg] = ACTIONS(5571),
    [anon_sym_u226b] = ACTIONS(5571),
    [anon_sym_BSLASHll] = ACTIONS(5571),
    [anon_sym_u226a] = ACTIONS(5571),
    [anon_sym_BSLASHnotin] = ACTIONS(5571),
    [anon_sym_u2209] = ACTIONS(5571),
    [anon_sym_BSLASHprec] = ACTIONS(5569),
    [anon_sym_u227a] = ACTIONS(5571),
    [anon_sym_BSLASHsucc] = ACTIONS(5569),
    [anon_sym_u227b] = ACTIONS(5571),
    [anon_sym_BSLASHpreceq] = ACTIONS(5571),
    [anon_sym_u2aaf] = ACTIONS(5571),
    [anon_sym_BSLASHsucceq] = ACTIONS(5571),
    [anon_sym_u2ab0] = ACTIONS(5571),
    [anon_sym_BSLASHpropto] = ACTIONS(5571),
    [anon_sym_u221d] = ACTIONS(5571),
    [anon_sym_BSLASHsim] = ACTIONS(5569),
    [anon_sym_u223c] = ACTIONS(5571),
    [anon_sym_BSLASHsimeq] = ACTIONS(5571),
    [anon_sym_u2243] = ACTIONS(5571),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5569),
    [anon_sym_u228f] = ACTIONS(5571),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5569),
    [anon_sym_u2290] = ACTIONS(5571),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5571),
    [anon_sym_u2291] = ACTIONS(5571),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5571),
    [anon_sym_u2292] = ACTIONS(5571),
    [anon_sym_BSLASHsubset] = ACTIONS(5569),
    [anon_sym_u2282] = ACTIONS(5571),
    [anon_sym_BSLASHsupset] = ACTIONS(5569),
    [anon_sym_u2283] = ACTIONS(5571),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5571),
    [anon_sym_u2286] = ACTIONS(5571),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5571),
    [anon_sym_u2287] = ACTIONS(5571),
    [sym_compose] = ACTIONS(5571),
    [sym_map_to] = ACTIONS(5571),
    [sym_map_from] = ACTIONS(5571),
    [sym_setminus] = ACTIONS(5569),
    [anon_sym_BSLASHcap] = ACTIONS(5571),
    [anon_sym_BSLASHintersect] = ACTIONS(5571),
    [anon_sym_u2229] = ACTIONS(5571),
    [anon_sym_BSLASHcup] = ACTIONS(5571),
    [anon_sym_BSLASHunion] = ACTIONS(5571),
    [anon_sym_u222a] = ACTIONS(5571),
    [anon_sym_DOT_DOT] = ACTIONS(5569),
    [anon_sym_u2025] = ACTIONS(5571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5571),
    [anon_sym_u2026] = ACTIONS(5571),
    [anon_sym_PLUS] = ACTIONS(5569),
    [sym_plusplus] = ACTIONS(5571),
    [anon_sym_BSLASHoplus] = ACTIONS(5571),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5571),
    [anon_sym_u2295] = ACTIONS(5571),
    [anon_sym_BSLASHominus] = ACTIONS(5571),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5571),
    [anon_sym_u2296] = ACTIONS(5571),
    [sym_mod] = ACTIONS(5569),
    [sym_modmod] = ACTIONS(5571),
    [sym_vert] = ACTIONS(5569),
    [anon_sym_PIPE_PIPE] = ACTIONS(5571),
    [anon_sym_u2016] = ACTIONS(5571),
    [sym_minusminus] = ACTIONS(5571),
    [sym_amp] = ACTIONS(5569),
    [sym_ampamp] = ACTIONS(5571),
    [anon_sym_BSLASHodot] = ACTIONS(5571),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5571),
    [anon_sym_u2299] = ACTIONS(5571),
    [anon_sym_BSLASHoslash] = ACTIONS(5571),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5571),
    [anon_sym_u2298] = ACTIONS(5571),
    [anon_sym_BSLASHotimes] = ACTIONS(5571),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5571),
    [anon_sym_u2297] = ACTIONS(5571),
    [sym_mul] = ACTIONS(5569),
    [sym_mulmul] = ACTIONS(5571),
    [sym_slash] = ACTIONS(5569),
    [sym_slashslash] = ACTIONS(5571),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5571),
    [anon_sym_u25ef] = ACTIONS(5571),
    [anon_sym_BSLASHbullet] = ACTIONS(5571),
    [anon_sym_u25cf] = ACTIONS(5571),
    [anon_sym_BSLASHdiv] = ACTIONS(5571),
    [anon_sym_u00f7] = ACTIONS(5571),
    [anon_sym_BSLASHcirc] = ACTIONS(5571),
    [anon_sym_u2218] = ACTIONS(5571),
    [anon_sym_BSLASHstar] = ACTIONS(5571),
    [anon_sym_u22c6] = ACTIONS(5571),
    [anon_sym_u203c] = ACTIONS(5571),
    [sym_hashhash] = ACTIONS(5571),
    [sym_dol] = ACTIONS(5569),
    [sym_doldol] = ACTIONS(5571),
    [anon_sym_QMARK_QMARK] = ACTIONS(5571),
    [anon_sym_u2047] = ACTIONS(5571),
    [anon_sym_BSLASHsqcap] = ACTIONS(5571),
    [anon_sym_u2293] = ACTIONS(5571),
    [anon_sym_BSLASHsqcup] = ACTIONS(5571),
    [anon_sym_u2294] = ACTIONS(5571),
    [anon_sym_BSLASHuplus] = ACTIONS(5571),
    [anon_sym_u228e] = ACTIONS(5571),
    [anon_sym_BSLASHX] = ACTIONS(5571),
    [anon_sym_BSLASHtimes] = ACTIONS(5571),
    [anon_sym_u00d7] = ACTIONS(5571),
    [anon_sym_BSLASHwr] = ACTIONS(5571),
    [anon_sym_u2240] = ACTIONS(5571),
    [anon_sym_BSLASHcdot] = ACTIONS(5571),
    [anon_sym_u22c5] = ACTIONS(5571),
    [sym_pow] = ACTIONS(5569),
    [sym_powpow] = ACTIONS(5571),
    [anon_sym_CARET_PLUS] = ACTIONS(5571),
    [anon_sym_u207a] = ACTIONS(5571),
    [sym_asterisk] = ACTIONS(5571),
    [sym_sup_hash] = ACTIONS(5571),
    [sym_prime] = ACTIONS(5571),
    [sym__indent] = ACTIONS(5571),
    [sym__double_excl] = ACTIONS(5571),
  },
  [2191] = {
    [sym_block_comment] = STATE(2191),
    [sym_identifier] = ACTIONS(5573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5573),
    [anon_sym_u2208] = ACTIONS(5575),
    [anon_sym_BSLASHA] = ACTIONS(5573),
    [anon_sym_BSLASHforall] = ACTIONS(5575),
    [anon_sym_u2200] = ACTIONS(5575),
    [anon_sym_BSLASHE] = ACTIONS(5573),
    [anon_sym_BSLASHexists] = ACTIONS(5575),
    [anon_sym_u2203] = ACTIONS(5575),
    [sym_temporal_forall] = ACTIONS(5575),
    [sym_temporal_exists] = ACTIONS(5575),
    [anon_sym_LT_LT] = ACTIONS(5575),
    [anon_sym_u3008] = ACTIONS(5575),
    [anon_sym_u27e8] = ACTIONS(5575),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5575),
    [anon_sym_u25a1] = ACTIONS(5575),
    [anon_sym_AT] = ACTIONS(5573),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5575),
    [anon_sym_u2227] = ACTIONS(5575),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5575),
    [anon_sym_u2228] = ACTIONS(5575),
    [anon_sym_LPAREN] = ACTIONS(5573),
    [anon_sym_LBRACK] = ACTIONS(5573),
    [aux_sym_child_id_token1] = ACTIONS(5573),
    [sym_real_number] = ACTIONS(5575),
    [anon_sym_BSLASHb] = ACTIONS(5573),
    [anon_sym_BSLASHB] = ACTIONS(5575),
    [anon_sym_BSLASHo] = ACTIONS(5573),
    [anon_sym_BSLASHO] = ACTIONS(5575),
    [anon_sym_BSLASHh] = ACTIONS(5575),
    [anon_sym_BSLASHH] = ACTIONS(5575),
    [anon_sym_DQUOTE] = ACTIONS(5575),
    [anon_sym_TRUE] = ACTIONS(5573),
    [anon_sym_FALSE] = ACTIONS(5573),
    [sym_string_set] = ACTIONS(5573),
    [sym_boolean_set] = ACTIONS(5573),
    [anon_sym_Nat] = ACTIONS(5573),
    [anon_sym_u2115] = ACTIONS(5575),
    [anon_sym_Int] = ACTIONS(5573),
    [anon_sym_u2124] = ACTIONS(5575),
    [anon_sym_Real] = ACTIONS(5573),
    [anon_sym_u211d] = ACTIONS(5575),
    [anon_sym_CHOOSE] = ACTIONS(5573),
    [anon_sym_LBRACE] = ACTIONS(5575),
    [anon_sym_EQ] = ACTIONS(5573),
    [anon_sym_WF_] = ACTIONS(5573),
    [anon_sym_SF_] = ACTIONS(5573),
    [anon_sym_IF] = ACTIONS(5573),
    [anon_sym_CASE] = ACTIONS(5573),
    [anon_sym_LET] = ACTIONS(5573),
    [anon_sym_BSLASHlnot] = ACTIONS(5575),
    [anon_sym_BSLASHneg] = ACTIONS(5575),
    [anon_sym_TILDE] = ACTIONS(5573),
    [anon_sym_u00ac] = ACTIONS(5575),
    [sym_union] = ACTIONS(5573),
    [sym_powerset] = ACTIONS(5573),
    [sym_domain] = ACTIONS(5573),
    [anon_sym_DASH] = ACTIONS(5573),
    [sym_negative_dot] = ACTIONS(5575),
    [sym_enabled] = ACTIONS(5573),
    [sym_unchanged] = ACTIONS(5573),
    [anon_sym_LT_GT] = ACTIONS(5575),
    [anon_sym_u22c4] = ACTIONS(5575),
    [anon_sym_u25c7] = ACTIONS(5575),
    [anon_sym_EQ_GT] = ACTIONS(5575),
    [anon_sym_u27f9] = ACTIONS(5575),
    [anon_sym_u21d2] = ACTIONS(5575),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5575),
    [anon_sym_u21f8] = ACTIONS(5575),
    [anon_sym_u2945] = ACTIONS(5575),
    [anon_sym_BSLASHequiv] = ACTIONS(5575),
    [anon_sym_u2261] = ACTIONS(5575),
    [anon_sym_LT_EQ_GT] = ACTIONS(5575),
    [anon_sym_u27fa] = ACTIONS(5575),
    [anon_sym_u21d4] = ACTIONS(5575),
    [anon_sym_TILDE_GT] = ACTIONS(5575),
    [anon_sym_u21dd] = ACTIONS(5575),
    [anon_sym_u219d] = ACTIONS(5575),
    [anon_sym_BSLASHland] = ACTIONS(5575),
    [anon_sym_BSLASHlor] = ACTIONS(5575),
    [anon_sym_COLON_EQ] = ACTIONS(5575),
    [anon_sym_u2254] = ACTIONS(5575),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5575),
    [anon_sym_u2a74] = ACTIONS(5575),
    [anon_sym_SLASH_EQ] = ACTIONS(5575),
    [anon_sym_POUND] = ACTIONS(5573),
    [anon_sym_u2260] = ACTIONS(5575),
    [anon_sym_LT] = ACTIONS(5573),
    [sym_gt] = ACTIONS(5573),
    [anon_sym_LT_EQ] = ACTIONS(5573),
    [anon_sym_EQ_LT] = ACTIONS(5575),
    [anon_sym_BSLASHleq] = ACTIONS(5575),
    [anon_sym_u2264] = ACTIONS(5575),
    [anon_sym_GT_EQ] = ACTIONS(5575),
    [anon_sym_BSLASHgeq] = ACTIONS(5575),
    [anon_sym_u2265] = ACTIONS(5575),
    [anon_sym_BSLASHapprox] = ACTIONS(5575),
    [anon_sym_u2248] = ACTIONS(5575),
    [anon_sym_PIPE_DASH] = ACTIONS(5575),
    [anon_sym_u22a2] = ACTIONS(5575),
    [anon_sym_PIPE_EQ] = ACTIONS(5575),
    [anon_sym_u22a8] = ACTIONS(5575),
    [anon_sym_DASH_PIPE] = ACTIONS(5575),
    [anon_sym_u22a3] = ACTIONS(5575),
    [anon_sym_EQ_PIPE] = ACTIONS(5575),
    [anon_sym_u2ae4] = ACTIONS(5575),
    [anon_sym_BSLASHasymp] = ACTIONS(5575),
    [anon_sym_u224d] = ACTIONS(5575),
    [anon_sym_BSLASHcong] = ACTIONS(5575),
    [anon_sym_u2245] = ACTIONS(5575),
    [anon_sym_BSLASHdoteq] = ACTIONS(5575),
    [anon_sym_u2250] = ACTIONS(5575),
    [anon_sym_BSLASHgg] = ACTIONS(5575),
    [anon_sym_u226b] = ACTIONS(5575),
    [anon_sym_BSLASHll] = ACTIONS(5575),
    [anon_sym_u226a] = ACTIONS(5575),
    [anon_sym_BSLASHnotin] = ACTIONS(5575),
    [anon_sym_u2209] = ACTIONS(5575),
    [anon_sym_BSLASHprec] = ACTIONS(5573),
    [anon_sym_u227a] = ACTIONS(5575),
    [anon_sym_BSLASHsucc] = ACTIONS(5573),
    [anon_sym_u227b] = ACTIONS(5575),
    [anon_sym_BSLASHpreceq] = ACTIONS(5575),
    [anon_sym_u2aaf] = ACTIONS(5575),
    [anon_sym_BSLASHsucceq] = ACTIONS(5575),
    [anon_sym_u2ab0] = ACTIONS(5575),
    [anon_sym_BSLASHpropto] = ACTIONS(5575),
    [anon_sym_u221d] = ACTIONS(5575),
    [anon_sym_BSLASHsim] = ACTIONS(5573),
    [anon_sym_u223c] = ACTIONS(5575),
    [anon_sym_BSLASHsimeq] = ACTIONS(5575),
    [anon_sym_u2243] = ACTIONS(5575),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5573),
    [anon_sym_u228f] = ACTIONS(5575),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5573),
    [anon_sym_u2290] = ACTIONS(5575),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5575),
    [anon_sym_u2291] = ACTIONS(5575),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5575),
    [anon_sym_u2292] = ACTIONS(5575),
    [anon_sym_BSLASHsubset] = ACTIONS(5573),
    [anon_sym_u2282] = ACTIONS(5575),
    [anon_sym_BSLASHsupset] = ACTIONS(5573),
    [anon_sym_u2283] = ACTIONS(5575),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5575),
    [anon_sym_u2286] = ACTIONS(5575),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5575),
    [anon_sym_u2287] = ACTIONS(5575),
    [sym_compose] = ACTIONS(5575),
    [sym_map_to] = ACTIONS(5575),
    [sym_map_from] = ACTIONS(5575),
    [sym_setminus] = ACTIONS(5573),
    [anon_sym_BSLASHcap] = ACTIONS(5575),
    [anon_sym_BSLASHintersect] = ACTIONS(5575),
    [anon_sym_u2229] = ACTIONS(5575),
    [anon_sym_BSLASHcup] = ACTIONS(5575),
    [anon_sym_BSLASHunion] = ACTIONS(5575),
    [anon_sym_u222a] = ACTIONS(5575),
    [anon_sym_DOT_DOT] = ACTIONS(5573),
    [anon_sym_u2025] = ACTIONS(5575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5575),
    [anon_sym_u2026] = ACTIONS(5575),
    [anon_sym_PLUS] = ACTIONS(5573),
    [sym_plusplus] = ACTIONS(5575),
    [anon_sym_BSLASHoplus] = ACTIONS(5575),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5575),
    [anon_sym_u2295] = ACTIONS(5575),
    [anon_sym_BSLASHominus] = ACTIONS(5575),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5575),
    [anon_sym_u2296] = ACTIONS(5575),
    [sym_mod] = ACTIONS(5573),
    [sym_modmod] = ACTIONS(5575),
    [sym_vert] = ACTIONS(5573),
    [anon_sym_PIPE_PIPE] = ACTIONS(5575),
    [anon_sym_u2016] = ACTIONS(5575),
    [sym_minusminus] = ACTIONS(5575),
    [sym_amp] = ACTIONS(5573),
    [sym_ampamp] = ACTIONS(5575),
    [anon_sym_BSLASHodot] = ACTIONS(5575),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5575),
    [anon_sym_u2299] = ACTIONS(5575),
    [anon_sym_BSLASHoslash] = ACTIONS(5575),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5575),
    [anon_sym_u2298] = ACTIONS(5575),
    [anon_sym_BSLASHotimes] = ACTIONS(5575),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5575),
    [anon_sym_u2297] = ACTIONS(5575),
    [sym_mul] = ACTIONS(5573),
    [sym_mulmul] = ACTIONS(5575),
    [sym_slash] = ACTIONS(5573),
    [sym_slashslash] = ACTIONS(5575),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5575),
    [anon_sym_u25ef] = ACTIONS(5575),
    [anon_sym_BSLASHbullet] = ACTIONS(5575),
    [anon_sym_u25cf] = ACTIONS(5575),
    [anon_sym_BSLASHdiv] = ACTIONS(5575),
    [anon_sym_u00f7] = ACTIONS(5575),
    [anon_sym_BSLASHcirc] = ACTIONS(5575),
    [anon_sym_u2218] = ACTIONS(5575),
    [anon_sym_BSLASHstar] = ACTIONS(5575),
    [anon_sym_u22c6] = ACTIONS(5575),
    [anon_sym_u203c] = ACTIONS(5575),
    [sym_hashhash] = ACTIONS(5575),
    [sym_dol] = ACTIONS(5573),
    [sym_doldol] = ACTIONS(5575),
    [anon_sym_QMARK_QMARK] = ACTIONS(5575),
    [anon_sym_u2047] = ACTIONS(5575),
    [anon_sym_BSLASHsqcap] = ACTIONS(5575),
    [anon_sym_u2293] = ACTIONS(5575),
    [anon_sym_BSLASHsqcup] = ACTIONS(5575),
    [anon_sym_u2294] = ACTIONS(5575),
    [anon_sym_BSLASHuplus] = ACTIONS(5575),
    [anon_sym_u228e] = ACTIONS(5575),
    [anon_sym_BSLASHX] = ACTIONS(5575),
    [anon_sym_BSLASHtimes] = ACTIONS(5575),
    [anon_sym_u00d7] = ACTIONS(5575),
    [anon_sym_BSLASHwr] = ACTIONS(5575),
    [anon_sym_u2240] = ACTIONS(5575),
    [anon_sym_BSLASHcdot] = ACTIONS(5575),
    [anon_sym_u22c5] = ACTIONS(5575),
    [sym_pow] = ACTIONS(5573),
    [sym_powpow] = ACTIONS(5575),
    [anon_sym_CARET_PLUS] = ACTIONS(5575),
    [anon_sym_u207a] = ACTIONS(5575),
    [sym_asterisk] = ACTIONS(5575),
    [sym_sup_hash] = ACTIONS(5575),
    [sym_prime] = ACTIONS(5575),
    [sym__indent] = ACTIONS(5575),
    [sym__double_excl] = ACTIONS(5575),
  },
  [2192] = {
    [sym_block_comment] = STATE(2192),
    [sym_identifier] = ACTIONS(5577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5577),
    [anon_sym_u2208] = ACTIONS(5579),
    [anon_sym_BSLASHA] = ACTIONS(5577),
    [anon_sym_BSLASHforall] = ACTIONS(5579),
    [anon_sym_u2200] = ACTIONS(5579),
    [anon_sym_BSLASHE] = ACTIONS(5577),
    [anon_sym_BSLASHexists] = ACTIONS(5579),
    [anon_sym_u2203] = ACTIONS(5579),
    [sym_temporal_forall] = ACTIONS(5579),
    [sym_temporal_exists] = ACTIONS(5579),
    [anon_sym_LT_LT] = ACTIONS(5579),
    [anon_sym_u3008] = ACTIONS(5579),
    [anon_sym_u27e8] = ACTIONS(5579),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5579),
    [anon_sym_u25a1] = ACTIONS(5579),
    [anon_sym_AT] = ACTIONS(5577),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5579),
    [anon_sym_u2227] = ACTIONS(5579),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5579),
    [anon_sym_u2228] = ACTIONS(5579),
    [anon_sym_LPAREN] = ACTIONS(5577),
    [anon_sym_LBRACK] = ACTIONS(5577),
    [aux_sym_child_id_token1] = ACTIONS(5577),
    [sym_real_number] = ACTIONS(5579),
    [anon_sym_BSLASHb] = ACTIONS(5577),
    [anon_sym_BSLASHB] = ACTIONS(5579),
    [anon_sym_BSLASHo] = ACTIONS(5577),
    [anon_sym_BSLASHO] = ACTIONS(5579),
    [anon_sym_BSLASHh] = ACTIONS(5579),
    [anon_sym_BSLASHH] = ACTIONS(5579),
    [anon_sym_DQUOTE] = ACTIONS(5579),
    [anon_sym_TRUE] = ACTIONS(5577),
    [anon_sym_FALSE] = ACTIONS(5577),
    [sym_string_set] = ACTIONS(5577),
    [sym_boolean_set] = ACTIONS(5577),
    [anon_sym_Nat] = ACTIONS(5577),
    [anon_sym_u2115] = ACTIONS(5579),
    [anon_sym_Int] = ACTIONS(5577),
    [anon_sym_u2124] = ACTIONS(5579),
    [anon_sym_Real] = ACTIONS(5577),
    [anon_sym_u211d] = ACTIONS(5579),
    [anon_sym_CHOOSE] = ACTIONS(5577),
    [anon_sym_LBRACE] = ACTIONS(5579),
    [anon_sym_EQ] = ACTIONS(5577),
    [anon_sym_WF_] = ACTIONS(5577),
    [anon_sym_SF_] = ACTIONS(5577),
    [anon_sym_IF] = ACTIONS(5577),
    [anon_sym_CASE] = ACTIONS(5577),
    [anon_sym_LET] = ACTIONS(5577),
    [anon_sym_BSLASHlnot] = ACTIONS(5579),
    [anon_sym_BSLASHneg] = ACTIONS(5579),
    [anon_sym_TILDE] = ACTIONS(5577),
    [anon_sym_u00ac] = ACTIONS(5579),
    [sym_union] = ACTIONS(5577),
    [sym_powerset] = ACTIONS(5577),
    [sym_domain] = ACTIONS(5577),
    [anon_sym_DASH] = ACTIONS(5577),
    [sym_negative_dot] = ACTIONS(5579),
    [sym_enabled] = ACTIONS(5577),
    [sym_unchanged] = ACTIONS(5577),
    [anon_sym_LT_GT] = ACTIONS(5579),
    [anon_sym_u22c4] = ACTIONS(5579),
    [anon_sym_u25c7] = ACTIONS(5579),
    [anon_sym_EQ_GT] = ACTIONS(5579),
    [anon_sym_u27f9] = ACTIONS(5579),
    [anon_sym_u21d2] = ACTIONS(5579),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5579),
    [anon_sym_u21f8] = ACTIONS(5579),
    [anon_sym_u2945] = ACTIONS(5579),
    [anon_sym_BSLASHequiv] = ACTIONS(5579),
    [anon_sym_u2261] = ACTIONS(5579),
    [anon_sym_LT_EQ_GT] = ACTIONS(5579),
    [anon_sym_u27fa] = ACTIONS(5579),
    [anon_sym_u21d4] = ACTIONS(5579),
    [anon_sym_TILDE_GT] = ACTIONS(5579),
    [anon_sym_u21dd] = ACTIONS(5579),
    [anon_sym_u219d] = ACTIONS(5579),
    [anon_sym_BSLASHland] = ACTIONS(5579),
    [anon_sym_BSLASHlor] = ACTIONS(5579),
    [anon_sym_COLON_EQ] = ACTIONS(5579),
    [anon_sym_u2254] = ACTIONS(5579),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5579),
    [anon_sym_u2a74] = ACTIONS(5579),
    [anon_sym_SLASH_EQ] = ACTIONS(5579),
    [anon_sym_POUND] = ACTIONS(5577),
    [anon_sym_u2260] = ACTIONS(5579),
    [anon_sym_LT] = ACTIONS(5577),
    [sym_gt] = ACTIONS(5577),
    [anon_sym_LT_EQ] = ACTIONS(5577),
    [anon_sym_EQ_LT] = ACTIONS(5579),
    [anon_sym_BSLASHleq] = ACTIONS(5579),
    [anon_sym_u2264] = ACTIONS(5579),
    [anon_sym_GT_EQ] = ACTIONS(5579),
    [anon_sym_BSLASHgeq] = ACTIONS(5579),
    [anon_sym_u2265] = ACTIONS(5579),
    [anon_sym_BSLASHapprox] = ACTIONS(5579),
    [anon_sym_u2248] = ACTIONS(5579),
    [anon_sym_PIPE_DASH] = ACTIONS(5579),
    [anon_sym_u22a2] = ACTIONS(5579),
    [anon_sym_PIPE_EQ] = ACTIONS(5579),
    [anon_sym_u22a8] = ACTIONS(5579),
    [anon_sym_DASH_PIPE] = ACTIONS(5579),
    [anon_sym_u22a3] = ACTIONS(5579),
    [anon_sym_EQ_PIPE] = ACTIONS(5579),
    [anon_sym_u2ae4] = ACTIONS(5579),
    [anon_sym_BSLASHasymp] = ACTIONS(5579),
    [anon_sym_u224d] = ACTIONS(5579),
    [anon_sym_BSLASHcong] = ACTIONS(5579),
    [anon_sym_u2245] = ACTIONS(5579),
    [anon_sym_BSLASHdoteq] = ACTIONS(5579),
    [anon_sym_u2250] = ACTIONS(5579),
    [anon_sym_BSLASHgg] = ACTIONS(5579),
    [anon_sym_u226b] = ACTIONS(5579),
    [anon_sym_BSLASHll] = ACTIONS(5579),
    [anon_sym_u226a] = ACTIONS(5579),
    [anon_sym_BSLASHnotin] = ACTIONS(5579),
    [anon_sym_u2209] = ACTIONS(5579),
    [anon_sym_BSLASHprec] = ACTIONS(5577),
    [anon_sym_u227a] = ACTIONS(5579),
    [anon_sym_BSLASHsucc] = ACTIONS(5577),
    [anon_sym_u227b] = ACTIONS(5579),
    [anon_sym_BSLASHpreceq] = ACTIONS(5579),
    [anon_sym_u2aaf] = ACTIONS(5579),
    [anon_sym_BSLASHsucceq] = ACTIONS(5579),
    [anon_sym_u2ab0] = ACTIONS(5579),
    [anon_sym_BSLASHpropto] = ACTIONS(5579),
    [anon_sym_u221d] = ACTIONS(5579),
    [anon_sym_BSLASHsim] = ACTIONS(5577),
    [anon_sym_u223c] = ACTIONS(5579),
    [anon_sym_BSLASHsimeq] = ACTIONS(5579),
    [anon_sym_u2243] = ACTIONS(5579),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5577),
    [anon_sym_u228f] = ACTIONS(5579),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5577),
    [anon_sym_u2290] = ACTIONS(5579),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5579),
    [anon_sym_u2291] = ACTIONS(5579),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5579),
    [anon_sym_u2292] = ACTIONS(5579),
    [anon_sym_BSLASHsubset] = ACTIONS(5577),
    [anon_sym_u2282] = ACTIONS(5579),
    [anon_sym_BSLASHsupset] = ACTIONS(5577),
    [anon_sym_u2283] = ACTIONS(5579),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5579),
    [anon_sym_u2286] = ACTIONS(5579),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5579),
    [anon_sym_u2287] = ACTIONS(5579),
    [sym_compose] = ACTIONS(5579),
    [sym_map_to] = ACTIONS(5579),
    [sym_map_from] = ACTIONS(5579),
    [sym_setminus] = ACTIONS(5577),
    [anon_sym_BSLASHcap] = ACTIONS(5579),
    [anon_sym_BSLASHintersect] = ACTIONS(5579),
    [anon_sym_u2229] = ACTIONS(5579),
    [anon_sym_BSLASHcup] = ACTIONS(5579),
    [anon_sym_BSLASHunion] = ACTIONS(5579),
    [anon_sym_u222a] = ACTIONS(5579),
    [anon_sym_DOT_DOT] = ACTIONS(5577),
    [anon_sym_u2025] = ACTIONS(5579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5579),
    [anon_sym_u2026] = ACTIONS(5579),
    [anon_sym_PLUS] = ACTIONS(5577),
    [sym_plusplus] = ACTIONS(5579),
    [anon_sym_BSLASHoplus] = ACTIONS(5579),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5579),
    [anon_sym_u2295] = ACTIONS(5579),
    [anon_sym_BSLASHominus] = ACTIONS(5579),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5579),
    [anon_sym_u2296] = ACTIONS(5579),
    [sym_mod] = ACTIONS(5577),
    [sym_modmod] = ACTIONS(5579),
    [sym_vert] = ACTIONS(5577),
    [anon_sym_PIPE_PIPE] = ACTIONS(5579),
    [anon_sym_u2016] = ACTIONS(5579),
    [sym_minusminus] = ACTIONS(5579),
    [sym_amp] = ACTIONS(5577),
    [sym_ampamp] = ACTIONS(5579),
    [anon_sym_BSLASHodot] = ACTIONS(5579),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5579),
    [anon_sym_u2299] = ACTIONS(5579),
    [anon_sym_BSLASHoslash] = ACTIONS(5579),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5579),
    [anon_sym_u2298] = ACTIONS(5579),
    [anon_sym_BSLASHotimes] = ACTIONS(5579),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5579),
    [anon_sym_u2297] = ACTIONS(5579),
    [sym_mul] = ACTIONS(5577),
    [sym_mulmul] = ACTIONS(5579),
    [sym_slash] = ACTIONS(5577),
    [sym_slashslash] = ACTIONS(5579),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5579),
    [anon_sym_u25ef] = ACTIONS(5579),
    [anon_sym_BSLASHbullet] = ACTIONS(5579),
    [anon_sym_u25cf] = ACTIONS(5579),
    [anon_sym_BSLASHdiv] = ACTIONS(5579),
    [anon_sym_u00f7] = ACTIONS(5579),
    [anon_sym_BSLASHcirc] = ACTIONS(5579),
    [anon_sym_u2218] = ACTIONS(5579),
    [anon_sym_BSLASHstar] = ACTIONS(5579),
    [anon_sym_u22c6] = ACTIONS(5579),
    [anon_sym_u203c] = ACTIONS(5579),
    [sym_hashhash] = ACTIONS(5579),
    [sym_dol] = ACTIONS(5577),
    [sym_doldol] = ACTIONS(5579),
    [anon_sym_QMARK_QMARK] = ACTIONS(5579),
    [anon_sym_u2047] = ACTIONS(5579),
    [anon_sym_BSLASHsqcap] = ACTIONS(5579),
    [anon_sym_u2293] = ACTIONS(5579),
    [anon_sym_BSLASHsqcup] = ACTIONS(5579),
    [anon_sym_u2294] = ACTIONS(5579),
    [anon_sym_BSLASHuplus] = ACTIONS(5579),
    [anon_sym_u228e] = ACTIONS(5579),
    [anon_sym_BSLASHX] = ACTIONS(5579),
    [anon_sym_BSLASHtimes] = ACTIONS(5579),
    [anon_sym_u00d7] = ACTIONS(5579),
    [anon_sym_BSLASHwr] = ACTIONS(5579),
    [anon_sym_u2240] = ACTIONS(5579),
    [anon_sym_BSLASHcdot] = ACTIONS(5579),
    [anon_sym_u22c5] = ACTIONS(5579),
    [sym_pow] = ACTIONS(5577),
    [sym_powpow] = ACTIONS(5579),
    [anon_sym_CARET_PLUS] = ACTIONS(5579),
    [anon_sym_u207a] = ACTIONS(5579),
    [sym_asterisk] = ACTIONS(5579),
    [sym_sup_hash] = ACTIONS(5579),
    [sym_prime] = ACTIONS(5579),
    [sym__indent] = ACTIONS(5579),
    [sym__double_excl] = ACTIONS(5579),
  },
  [2193] = {
    [sym_block_comment] = STATE(2193),
    [sym_identifier] = ACTIONS(5581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5581),
    [anon_sym_u2208] = ACTIONS(5583),
    [anon_sym_BSLASHA] = ACTIONS(5581),
    [anon_sym_BSLASHforall] = ACTIONS(5583),
    [anon_sym_u2200] = ACTIONS(5583),
    [anon_sym_BSLASHE] = ACTIONS(5581),
    [anon_sym_BSLASHexists] = ACTIONS(5583),
    [anon_sym_u2203] = ACTIONS(5583),
    [sym_temporal_forall] = ACTIONS(5583),
    [sym_temporal_exists] = ACTIONS(5583),
    [anon_sym_LT_LT] = ACTIONS(5583),
    [anon_sym_u3008] = ACTIONS(5583),
    [anon_sym_u27e8] = ACTIONS(5583),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5583),
    [anon_sym_u25a1] = ACTIONS(5583),
    [anon_sym_AT] = ACTIONS(5581),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5583),
    [anon_sym_u2227] = ACTIONS(5583),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5583),
    [anon_sym_u2228] = ACTIONS(5583),
    [anon_sym_LPAREN] = ACTIONS(5581),
    [anon_sym_LBRACK] = ACTIONS(5581),
    [aux_sym_child_id_token1] = ACTIONS(5581),
    [sym_real_number] = ACTIONS(5583),
    [anon_sym_BSLASHb] = ACTIONS(5581),
    [anon_sym_BSLASHB] = ACTIONS(5583),
    [anon_sym_BSLASHo] = ACTIONS(5581),
    [anon_sym_BSLASHO] = ACTIONS(5583),
    [anon_sym_BSLASHh] = ACTIONS(5583),
    [anon_sym_BSLASHH] = ACTIONS(5583),
    [anon_sym_DQUOTE] = ACTIONS(5583),
    [anon_sym_TRUE] = ACTIONS(5581),
    [anon_sym_FALSE] = ACTIONS(5581),
    [sym_string_set] = ACTIONS(5581),
    [sym_boolean_set] = ACTIONS(5581),
    [anon_sym_Nat] = ACTIONS(5581),
    [anon_sym_u2115] = ACTIONS(5583),
    [anon_sym_Int] = ACTIONS(5581),
    [anon_sym_u2124] = ACTIONS(5583),
    [anon_sym_Real] = ACTIONS(5581),
    [anon_sym_u211d] = ACTIONS(5583),
    [anon_sym_CHOOSE] = ACTIONS(5581),
    [anon_sym_LBRACE] = ACTIONS(5583),
    [anon_sym_EQ] = ACTIONS(5581),
    [anon_sym_WF_] = ACTIONS(5581),
    [anon_sym_SF_] = ACTIONS(5581),
    [anon_sym_IF] = ACTIONS(5581),
    [anon_sym_CASE] = ACTIONS(5581),
    [anon_sym_LET] = ACTIONS(5581),
    [anon_sym_BSLASHlnot] = ACTIONS(5583),
    [anon_sym_BSLASHneg] = ACTIONS(5583),
    [anon_sym_TILDE] = ACTIONS(5581),
    [anon_sym_u00ac] = ACTIONS(5583),
    [sym_union] = ACTIONS(5581),
    [sym_powerset] = ACTIONS(5581),
    [sym_domain] = ACTIONS(5581),
    [anon_sym_DASH] = ACTIONS(5581),
    [sym_negative_dot] = ACTIONS(5583),
    [sym_enabled] = ACTIONS(5581),
    [sym_unchanged] = ACTIONS(5581),
    [anon_sym_LT_GT] = ACTIONS(5583),
    [anon_sym_u22c4] = ACTIONS(5583),
    [anon_sym_u25c7] = ACTIONS(5583),
    [anon_sym_EQ_GT] = ACTIONS(5583),
    [anon_sym_u27f9] = ACTIONS(5583),
    [anon_sym_u21d2] = ACTIONS(5583),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5583),
    [anon_sym_u21f8] = ACTIONS(5583),
    [anon_sym_u2945] = ACTIONS(5583),
    [anon_sym_BSLASHequiv] = ACTIONS(5583),
    [anon_sym_u2261] = ACTIONS(5583),
    [anon_sym_LT_EQ_GT] = ACTIONS(5583),
    [anon_sym_u27fa] = ACTIONS(5583),
    [anon_sym_u21d4] = ACTIONS(5583),
    [anon_sym_TILDE_GT] = ACTIONS(5583),
    [anon_sym_u21dd] = ACTIONS(5583),
    [anon_sym_u219d] = ACTIONS(5583),
    [anon_sym_BSLASHland] = ACTIONS(5583),
    [anon_sym_BSLASHlor] = ACTIONS(5583),
    [anon_sym_COLON_EQ] = ACTIONS(5583),
    [anon_sym_u2254] = ACTIONS(5583),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5583),
    [anon_sym_u2a74] = ACTIONS(5583),
    [anon_sym_SLASH_EQ] = ACTIONS(5583),
    [anon_sym_POUND] = ACTIONS(5581),
    [anon_sym_u2260] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5581),
    [sym_gt] = ACTIONS(5581),
    [anon_sym_LT_EQ] = ACTIONS(5581),
    [anon_sym_EQ_LT] = ACTIONS(5583),
    [anon_sym_BSLASHleq] = ACTIONS(5583),
    [anon_sym_u2264] = ACTIONS(5583),
    [anon_sym_GT_EQ] = ACTIONS(5583),
    [anon_sym_BSLASHgeq] = ACTIONS(5583),
    [anon_sym_u2265] = ACTIONS(5583),
    [anon_sym_BSLASHapprox] = ACTIONS(5583),
    [anon_sym_u2248] = ACTIONS(5583),
    [anon_sym_PIPE_DASH] = ACTIONS(5583),
    [anon_sym_u22a2] = ACTIONS(5583),
    [anon_sym_PIPE_EQ] = ACTIONS(5583),
    [anon_sym_u22a8] = ACTIONS(5583),
    [anon_sym_DASH_PIPE] = ACTIONS(5583),
    [anon_sym_u22a3] = ACTIONS(5583),
    [anon_sym_EQ_PIPE] = ACTIONS(5583),
    [anon_sym_u2ae4] = ACTIONS(5583),
    [anon_sym_BSLASHasymp] = ACTIONS(5583),
    [anon_sym_u224d] = ACTIONS(5583),
    [anon_sym_BSLASHcong] = ACTIONS(5583),
    [anon_sym_u2245] = ACTIONS(5583),
    [anon_sym_BSLASHdoteq] = ACTIONS(5583),
    [anon_sym_u2250] = ACTIONS(5583),
    [anon_sym_BSLASHgg] = ACTIONS(5583),
    [anon_sym_u226b] = ACTIONS(5583),
    [anon_sym_BSLASHll] = ACTIONS(5583),
    [anon_sym_u226a] = ACTIONS(5583),
    [anon_sym_BSLASHnotin] = ACTIONS(5583),
    [anon_sym_u2209] = ACTIONS(5583),
    [anon_sym_BSLASHprec] = ACTIONS(5581),
    [anon_sym_u227a] = ACTIONS(5583),
    [anon_sym_BSLASHsucc] = ACTIONS(5581),
    [anon_sym_u227b] = ACTIONS(5583),
    [anon_sym_BSLASHpreceq] = ACTIONS(5583),
    [anon_sym_u2aaf] = ACTIONS(5583),
    [anon_sym_BSLASHsucceq] = ACTIONS(5583),
    [anon_sym_u2ab0] = ACTIONS(5583),
    [anon_sym_BSLASHpropto] = ACTIONS(5583),
    [anon_sym_u221d] = ACTIONS(5583),
    [anon_sym_BSLASHsim] = ACTIONS(5581),
    [anon_sym_u223c] = ACTIONS(5583),
    [anon_sym_BSLASHsimeq] = ACTIONS(5583),
    [anon_sym_u2243] = ACTIONS(5583),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5581),
    [anon_sym_u228f] = ACTIONS(5583),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5581),
    [anon_sym_u2290] = ACTIONS(5583),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5583),
    [anon_sym_u2291] = ACTIONS(5583),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5583),
    [anon_sym_u2292] = ACTIONS(5583),
    [anon_sym_BSLASHsubset] = ACTIONS(5581),
    [anon_sym_u2282] = ACTIONS(5583),
    [anon_sym_BSLASHsupset] = ACTIONS(5581),
    [anon_sym_u2283] = ACTIONS(5583),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5583),
    [anon_sym_u2286] = ACTIONS(5583),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5583),
    [anon_sym_u2287] = ACTIONS(5583),
    [sym_compose] = ACTIONS(5583),
    [sym_map_to] = ACTIONS(5583),
    [sym_map_from] = ACTIONS(5583),
    [sym_setminus] = ACTIONS(5581),
    [anon_sym_BSLASHcap] = ACTIONS(5583),
    [anon_sym_BSLASHintersect] = ACTIONS(5583),
    [anon_sym_u2229] = ACTIONS(5583),
    [anon_sym_BSLASHcup] = ACTIONS(5583),
    [anon_sym_BSLASHunion] = ACTIONS(5583),
    [anon_sym_u222a] = ACTIONS(5583),
    [anon_sym_DOT_DOT] = ACTIONS(5581),
    [anon_sym_u2025] = ACTIONS(5583),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5583),
    [anon_sym_u2026] = ACTIONS(5583),
    [anon_sym_PLUS] = ACTIONS(5581),
    [sym_plusplus] = ACTIONS(5583),
    [anon_sym_BSLASHoplus] = ACTIONS(5583),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5583),
    [anon_sym_u2295] = ACTIONS(5583),
    [anon_sym_BSLASHominus] = ACTIONS(5583),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5583),
    [anon_sym_u2296] = ACTIONS(5583),
    [sym_mod] = ACTIONS(5581),
    [sym_modmod] = ACTIONS(5583),
    [sym_vert] = ACTIONS(5581),
    [anon_sym_PIPE_PIPE] = ACTIONS(5583),
    [anon_sym_u2016] = ACTIONS(5583),
    [sym_minusminus] = ACTIONS(5583),
    [sym_amp] = ACTIONS(5581),
    [sym_ampamp] = ACTIONS(5583),
    [anon_sym_BSLASHodot] = ACTIONS(5583),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5583),
    [anon_sym_u2299] = ACTIONS(5583),
    [anon_sym_BSLASHoslash] = ACTIONS(5583),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5583),
    [anon_sym_u2298] = ACTIONS(5583),
    [anon_sym_BSLASHotimes] = ACTIONS(5583),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5583),
    [anon_sym_u2297] = ACTIONS(5583),
    [sym_mul] = ACTIONS(5581),
    [sym_mulmul] = ACTIONS(5583),
    [sym_slash] = ACTIONS(5581),
    [sym_slashslash] = ACTIONS(5583),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5583),
    [anon_sym_u25ef] = ACTIONS(5583),
    [anon_sym_BSLASHbullet] = ACTIONS(5583),
    [anon_sym_u25cf] = ACTIONS(5583),
    [anon_sym_BSLASHdiv] = ACTIONS(5583),
    [anon_sym_u00f7] = ACTIONS(5583),
    [anon_sym_BSLASHcirc] = ACTIONS(5583),
    [anon_sym_u2218] = ACTIONS(5583),
    [anon_sym_BSLASHstar] = ACTIONS(5583),
    [anon_sym_u22c6] = ACTIONS(5583),
    [anon_sym_u203c] = ACTIONS(5583),
    [sym_hashhash] = ACTIONS(5583),
    [sym_dol] = ACTIONS(5581),
    [sym_doldol] = ACTIONS(5583),
    [anon_sym_QMARK_QMARK] = ACTIONS(5583),
    [anon_sym_u2047] = ACTIONS(5583),
    [anon_sym_BSLASHsqcap] = ACTIONS(5583),
    [anon_sym_u2293] = ACTIONS(5583),
    [anon_sym_BSLASHsqcup] = ACTIONS(5583),
    [anon_sym_u2294] = ACTIONS(5583),
    [anon_sym_BSLASHuplus] = ACTIONS(5583),
    [anon_sym_u228e] = ACTIONS(5583),
    [anon_sym_BSLASHX] = ACTIONS(5583),
    [anon_sym_BSLASHtimes] = ACTIONS(5583),
    [anon_sym_u00d7] = ACTIONS(5583),
    [anon_sym_BSLASHwr] = ACTIONS(5583),
    [anon_sym_u2240] = ACTIONS(5583),
    [anon_sym_BSLASHcdot] = ACTIONS(5583),
    [anon_sym_u22c5] = ACTIONS(5583),
    [sym_pow] = ACTIONS(5581),
    [sym_powpow] = ACTIONS(5583),
    [anon_sym_CARET_PLUS] = ACTIONS(5583),
    [anon_sym_u207a] = ACTIONS(5583),
    [sym_asterisk] = ACTIONS(5583),
    [sym_sup_hash] = ACTIONS(5583),
    [sym_prime] = ACTIONS(5583),
    [sym__indent] = ACTIONS(5583),
    [sym__double_excl] = ACTIONS(5583),
  },
  [2194] = {
    [sym_block_comment] = STATE(2194),
    [sym_identifier] = ACTIONS(5585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5585),
    [anon_sym_u2208] = ACTIONS(5587),
    [anon_sym_BSLASHA] = ACTIONS(5585),
    [anon_sym_BSLASHforall] = ACTIONS(5587),
    [anon_sym_u2200] = ACTIONS(5587),
    [anon_sym_BSLASHE] = ACTIONS(5585),
    [anon_sym_BSLASHexists] = ACTIONS(5587),
    [anon_sym_u2203] = ACTIONS(5587),
    [sym_temporal_forall] = ACTIONS(5587),
    [sym_temporal_exists] = ACTIONS(5587),
    [anon_sym_LT_LT] = ACTIONS(5587),
    [anon_sym_u3008] = ACTIONS(5587),
    [anon_sym_u27e8] = ACTIONS(5587),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5587),
    [anon_sym_u25a1] = ACTIONS(5587),
    [anon_sym_AT] = ACTIONS(5585),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5587),
    [anon_sym_u2227] = ACTIONS(5587),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5587),
    [anon_sym_u2228] = ACTIONS(5587),
    [anon_sym_LPAREN] = ACTIONS(5585),
    [anon_sym_LBRACK] = ACTIONS(5585),
    [aux_sym_child_id_token1] = ACTIONS(5585),
    [sym_real_number] = ACTIONS(5587),
    [anon_sym_BSLASHb] = ACTIONS(5585),
    [anon_sym_BSLASHB] = ACTIONS(5587),
    [anon_sym_BSLASHo] = ACTIONS(5585),
    [anon_sym_BSLASHO] = ACTIONS(5587),
    [anon_sym_BSLASHh] = ACTIONS(5587),
    [anon_sym_BSLASHH] = ACTIONS(5587),
    [anon_sym_DQUOTE] = ACTIONS(5587),
    [anon_sym_TRUE] = ACTIONS(5585),
    [anon_sym_FALSE] = ACTIONS(5585),
    [sym_string_set] = ACTIONS(5585),
    [sym_boolean_set] = ACTIONS(5585),
    [anon_sym_Nat] = ACTIONS(5585),
    [anon_sym_u2115] = ACTIONS(5587),
    [anon_sym_Int] = ACTIONS(5585),
    [anon_sym_u2124] = ACTIONS(5587),
    [anon_sym_Real] = ACTIONS(5585),
    [anon_sym_u211d] = ACTIONS(5587),
    [anon_sym_CHOOSE] = ACTIONS(5585),
    [anon_sym_LBRACE] = ACTIONS(5587),
    [anon_sym_EQ] = ACTIONS(5585),
    [anon_sym_WF_] = ACTIONS(5585),
    [anon_sym_SF_] = ACTIONS(5585),
    [anon_sym_IF] = ACTIONS(5585),
    [anon_sym_CASE] = ACTIONS(5585),
    [anon_sym_LET] = ACTIONS(5585),
    [anon_sym_BSLASHlnot] = ACTIONS(5587),
    [anon_sym_BSLASHneg] = ACTIONS(5587),
    [anon_sym_TILDE] = ACTIONS(5585),
    [anon_sym_u00ac] = ACTIONS(5587),
    [sym_union] = ACTIONS(5585),
    [sym_powerset] = ACTIONS(5585),
    [sym_domain] = ACTIONS(5585),
    [anon_sym_DASH] = ACTIONS(5585),
    [sym_negative_dot] = ACTIONS(5587),
    [sym_enabled] = ACTIONS(5585),
    [sym_unchanged] = ACTIONS(5585),
    [anon_sym_LT_GT] = ACTIONS(5587),
    [anon_sym_u22c4] = ACTIONS(5587),
    [anon_sym_u25c7] = ACTIONS(5587),
    [anon_sym_EQ_GT] = ACTIONS(5587),
    [anon_sym_u27f9] = ACTIONS(5587),
    [anon_sym_u21d2] = ACTIONS(5587),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5587),
    [anon_sym_u21f8] = ACTIONS(5587),
    [anon_sym_u2945] = ACTIONS(5587),
    [anon_sym_BSLASHequiv] = ACTIONS(5587),
    [anon_sym_u2261] = ACTIONS(5587),
    [anon_sym_LT_EQ_GT] = ACTIONS(5587),
    [anon_sym_u27fa] = ACTIONS(5587),
    [anon_sym_u21d4] = ACTIONS(5587),
    [anon_sym_TILDE_GT] = ACTIONS(5587),
    [anon_sym_u21dd] = ACTIONS(5587),
    [anon_sym_u219d] = ACTIONS(5587),
    [anon_sym_BSLASHland] = ACTIONS(5587),
    [anon_sym_BSLASHlor] = ACTIONS(5587),
    [anon_sym_COLON_EQ] = ACTIONS(5587),
    [anon_sym_u2254] = ACTIONS(5587),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5587),
    [anon_sym_u2a74] = ACTIONS(5587),
    [anon_sym_SLASH_EQ] = ACTIONS(5587),
    [anon_sym_POUND] = ACTIONS(5585),
    [anon_sym_u2260] = ACTIONS(5587),
    [anon_sym_LT] = ACTIONS(5585),
    [sym_gt] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5585),
    [anon_sym_EQ_LT] = ACTIONS(5587),
    [anon_sym_BSLASHleq] = ACTIONS(5587),
    [anon_sym_u2264] = ACTIONS(5587),
    [anon_sym_GT_EQ] = ACTIONS(5587),
    [anon_sym_BSLASHgeq] = ACTIONS(5587),
    [anon_sym_u2265] = ACTIONS(5587),
    [anon_sym_BSLASHapprox] = ACTIONS(5587),
    [anon_sym_u2248] = ACTIONS(5587),
    [anon_sym_PIPE_DASH] = ACTIONS(5587),
    [anon_sym_u22a2] = ACTIONS(5587),
    [anon_sym_PIPE_EQ] = ACTIONS(5587),
    [anon_sym_u22a8] = ACTIONS(5587),
    [anon_sym_DASH_PIPE] = ACTIONS(5587),
    [anon_sym_u22a3] = ACTIONS(5587),
    [anon_sym_EQ_PIPE] = ACTIONS(5587),
    [anon_sym_u2ae4] = ACTIONS(5587),
    [anon_sym_BSLASHasymp] = ACTIONS(5587),
    [anon_sym_u224d] = ACTIONS(5587),
    [anon_sym_BSLASHcong] = ACTIONS(5587),
    [anon_sym_u2245] = ACTIONS(5587),
    [anon_sym_BSLASHdoteq] = ACTIONS(5587),
    [anon_sym_u2250] = ACTIONS(5587),
    [anon_sym_BSLASHgg] = ACTIONS(5587),
    [anon_sym_u226b] = ACTIONS(5587),
    [anon_sym_BSLASHll] = ACTIONS(5587),
    [anon_sym_u226a] = ACTIONS(5587),
    [anon_sym_BSLASHnotin] = ACTIONS(5587),
    [anon_sym_u2209] = ACTIONS(5587),
    [anon_sym_BSLASHprec] = ACTIONS(5585),
    [anon_sym_u227a] = ACTIONS(5587),
    [anon_sym_BSLASHsucc] = ACTIONS(5585),
    [anon_sym_u227b] = ACTIONS(5587),
    [anon_sym_BSLASHpreceq] = ACTIONS(5587),
    [anon_sym_u2aaf] = ACTIONS(5587),
    [anon_sym_BSLASHsucceq] = ACTIONS(5587),
    [anon_sym_u2ab0] = ACTIONS(5587),
    [anon_sym_BSLASHpropto] = ACTIONS(5587),
    [anon_sym_u221d] = ACTIONS(5587),
    [anon_sym_BSLASHsim] = ACTIONS(5585),
    [anon_sym_u223c] = ACTIONS(5587),
    [anon_sym_BSLASHsimeq] = ACTIONS(5587),
    [anon_sym_u2243] = ACTIONS(5587),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5585),
    [anon_sym_u228f] = ACTIONS(5587),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5585),
    [anon_sym_u2290] = ACTIONS(5587),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5587),
    [anon_sym_u2291] = ACTIONS(5587),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5587),
    [anon_sym_u2292] = ACTIONS(5587),
    [anon_sym_BSLASHsubset] = ACTIONS(5585),
    [anon_sym_u2282] = ACTIONS(5587),
    [anon_sym_BSLASHsupset] = ACTIONS(5585),
    [anon_sym_u2283] = ACTIONS(5587),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5587),
    [anon_sym_u2286] = ACTIONS(5587),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5587),
    [anon_sym_u2287] = ACTIONS(5587),
    [sym_compose] = ACTIONS(5587),
    [sym_map_to] = ACTIONS(5587),
    [sym_map_from] = ACTIONS(5587),
    [sym_setminus] = ACTIONS(5585),
    [anon_sym_BSLASHcap] = ACTIONS(5587),
    [anon_sym_BSLASHintersect] = ACTIONS(5587),
    [anon_sym_u2229] = ACTIONS(5587),
    [anon_sym_BSLASHcup] = ACTIONS(5587),
    [anon_sym_BSLASHunion] = ACTIONS(5587),
    [anon_sym_u222a] = ACTIONS(5587),
    [anon_sym_DOT_DOT] = ACTIONS(5585),
    [anon_sym_u2025] = ACTIONS(5587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5587),
    [anon_sym_u2026] = ACTIONS(5587),
    [anon_sym_PLUS] = ACTIONS(5585),
    [sym_plusplus] = ACTIONS(5587),
    [anon_sym_BSLASHoplus] = ACTIONS(5587),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5587),
    [anon_sym_u2295] = ACTIONS(5587),
    [anon_sym_BSLASHominus] = ACTIONS(5587),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5587),
    [anon_sym_u2296] = ACTIONS(5587),
    [sym_mod] = ACTIONS(5585),
    [sym_modmod] = ACTIONS(5587),
    [sym_vert] = ACTIONS(5585),
    [anon_sym_PIPE_PIPE] = ACTIONS(5587),
    [anon_sym_u2016] = ACTIONS(5587),
    [sym_minusminus] = ACTIONS(5587),
    [sym_amp] = ACTIONS(5585),
    [sym_ampamp] = ACTIONS(5587),
    [anon_sym_BSLASHodot] = ACTIONS(5587),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5587),
    [anon_sym_u2299] = ACTIONS(5587),
    [anon_sym_BSLASHoslash] = ACTIONS(5587),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5587),
    [anon_sym_u2298] = ACTIONS(5587),
    [anon_sym_BSLASHotimes] = ACTIONS(5587),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5587),
    [anon_sym_u2297] = ACTIONS(5587),
    [sym_mul] = ACTIONS(5585),
    [sym_mulmul] = ACTIONS(5587),
    [sym_slash] = ACTIONS(5585),
    [sym_slashslash] = ACTIONS(5587),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5587),
    [anon_sym_u25ef] = ACTIONS(5587),
    [anon_sym_BSLASHbullet] = ACTIONS(5587),
    [anon_sym_u25cf] = ACTIONS(5587),
    [anon_sym_BSLASHdiv] = ACTIONS(5587),
    [anon_sym_u00f7] = ACTIONS(5587),
    [anon_sym_BSLASHcirc] = ACTIONS(5587),
    [anon_sym_u2218] = ACTIONS(5587),
    [anon_sym_BSLASHstar] = ACTIONS(5587),
    [anon_sym_u22c6] = ACTIONS(5587),
    [anon_sym_u203c] = ACTIONS(5587),
    [sym_hashhash] = ACTIONS(5587),
    [sym_dol] = ACTIONS(5585),
    [sym_doldol] = ACTIONS(5587),
    [anon_sym_QMARK_QMARK] = ACTIONS(5587),
    [anon_sym_u2047] = ACTIONS(5587),
    [anon_sym_BSLASHsqcap] = ACTIONS(5587),
    [anon_sym_u2293] = ACTIONS(5587),
    [anon_sym_BSLASHsqcup] = ACTIONS(5587),
    [anon_sym_u2294] = ACTIONS(5587),
    [anon_sym_BSLASHuplus] = ACTIONS(5587),
    [anon_sym_u228e] = ACTIONS(5587),
    [anon_sym_BSLASHX] = ACTIONS(5587),
    [anon_sym_BSLASHtimes] = ACTIONS(5587),
    [anon_sym_u00d7] = ACTIONS(5587),
    [anon_sym_BSLASHwr] = ACTIONS(5587),
    [anon_sym_u2240] = ACTIONS(5587),
    [anon_sym_BSLASHcdot] = ACTIONS(5587),
    [anon_sym_u22c5] = ACTIONS(5587),
    [sym_pow] = ACTIONS(5585),
    [sym_powpow] = ACTIONS(5587),
    [anon_sym_CARET_PLUS] = ACTIONS(5587),
    [anon_sym_u207a] = ACTIONS(5587),
    [sym_asterisk] = ACTIONS(5587),
    [sym_sup_hash] = ACTIONS(5587),
    [sym_prime] = ACTIONS(5587),
    [sym__indent] = ACTIONS(5587),
    [sym__double_excl] = ACTIONS(5587),
  },
  [2195] = {
    [sym_block_comment] = STATE(2195),
    [sym_identifier] = ACTIONS(5589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5589),
    [anon_sym_u2208] = ACTIONS(5591),
    [anon_sym_BSLASHA] = ACTIONS(5589),
    [anon_sym_BSLASHforall] = ACTIONS(5591),
    [anon_sym_u2200] = ACTIONS(5591),
    [anon_sym_BSLASHE] = ACTIONS(5589),
    [anon_sym_BSLASHexists] = ACTIONS(5591),
    [anon_sym_u2203] = ACTIONS(5591),
    [sym_temporal_forall] = ACTIONS(5591),
    [sym_temporal_exists] = ACTIONS(5591),
    [anon_sym_LT_LT] = ACTIONS(5591),
    [anon_sym_u3008] = ACTIONS(5591),
    [anon_sym_u27e8] = ACTIONS(5591),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5591),
    [anon_sym_u25a1] = ACTIONS(5591),
    [anon_sym_AT] = ACTIONS(5589),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5591),
    [anon_sym_u2227] = ACTIONS(5591),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5591),
    [anon_sym_u2228] = ACTIONS(5591),
    [anon_sym_LPAREN] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(5589),
    [aux_sym_child_id_token1] = ACTIONS(5589),
    [sym_real_number] = ACTIONS(5591),
    [anon_sym_BSLASHb] = ACTIONS(5589),
    [anon_sym_BSLASHB] = ACTIONS(5591),
    [anon_sym_BSLASHo] = ACTIONS(5589),
    [anon_sym_BSLASHO] = ACTIONS(5591),
    [anon_sym_BSLASHh] = ACTIONS(5591),
    [anon_sym_BSLASHH] = ACTIONS(5591),
    [anon_sym_DQUOTE] = ACTIONS(5591),
    [anon_sym_TRUE] = ACTIONS(5589),
    [anon_sym_FALSE] = ACTIONS(5589),
    [sym_string_set] = ACTIONS(5589),
    [sym_boolean_set] = ACTIONS(5589),
    [anon_sym_Nat] = ACTIONS(5589),
    [anon_sym_u2115] = ACTIONS(5591),
    [anon_sym_Int] = ACTIONS(5589),
    [anon_sym_u2124] = ACTIONS(5591),
    [anon_sym_Real] = ACTIONS(5589),
    [anon_sym_u211d] = ACTIONS(5591),
    [anon_sym_CHOOSE] = ACTIONS(5589),
    [anon_sym_LBRACE] = ACTIONS(5591),
    [anon_sym_EQ] = ACTIONS(5589),
    [anon_sym_WF_] = ACTIONS(5589),
    [anon_sym_SF_] = ACTIONS(5589),
    [anon_sym_IF] = ACTIONS(5589),
    [anon_sym_CASE] = ACTIONS(5589),
    [anon_sym_LET] = ACTIONS(5589),
    [anon_sym_BSLASHlnot] = ACTIONS(5591),
    [anon_sym_BSLASHneg] = ACTIONS(5591),
    [anon_sym_TILDE] = ACTIONS(5589),
    [anon_sym_u00ac] = ACTIONS(5591),
    [sym_union] = ACTIONS(5589),
    [sym_powerset] = ACTIONS(5589),
    [sym_domain] = ACTIONS(5589),
    [anon_sym_DASH] = ACTIONS(5589),
    [sym_negative_dot] = ACTIONS(5591),
    [sym_enabled] = ACTIONS(5589),
    [sym_unchanged] = ACTIONS(5589),
    [anon_sym_LT_GT] = ACTIONS(5591),
    [anon_sym_u22c4] = ACTIONS(5591),
    [anon_sym_u25c7] = ACTIONS(5591),
    [anon_sym_EQ_GT] = ACTIONS(5591),
    [anon_sym_u27f9] = ACTIONS(5591),
    [anon_sym_u21d2] = ACTIONS(5591),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5591),
    [anon_sym_u21f8] = ACTIONS(5591),
    [anon_sym_u2945] = ACTIONS(5591),
    [anon_sym_BSLASHequiv] = ACTIONS(5591),
    [anon_sym_u2261] = ACTIONS(5591),
    [anon_sym_LT_EQ_GT] = ACTIONS(5591),
    [anon_sym_u27fa] = ACTIONS(5591),
    [anon_sym_u21d4] = ACTIONS(5591),
    [anon_sym_TILDE_GT] = ACTIONS(5591),
    [anon_sym_u21dd] = ACTIONS(5591),
    [anon_sym_u219d] = ACTIONS(5591),
    [anon_sym_BSLASHland] = ACTIONS(5591),
    [anon_sym_BSLASHlor] = ACTIONS(5591),
    [anon_sym_COLON_EQ] = ACTIONS(5591),
    [anon_sym_u2254] = ACTIONS(5591),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5591),
    [anon_sym_u2a74] = ACTIONS(5591),
    [anon_sym_SLASH_EQ] = ACTIONS(5591),
    [anon_sym_POUND] = ACTIONS(5589),
    [anon_sym_u2260] = ACTIONS(5591),
    [anon_sym_LT] = ACTIONS(5589),
    [sym_gt] = ACTIONS(5589),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_EQ_LT] = ACTIONS(5591),
    [anon_sym_BSLASHleq] = ACTIONS(5591),
    [anon_sym_u2264] = ACTIONS(5591),
    [anon_sym_GT_EQ] = ACTIONS(5591),
    [anon_sym_BSLASHgeq] = ACTIONS(5591),
    [anon_sym_u2265] = ACTIONS(5591),
    [anon_sym_BSLASHapprox] = ACTIONS(5591),
    [anon_sym_u2248] = ACTIONS(5591),
    [anon_sym_PIPE_DASH] = ACTIONS(5591),
    [anon_sym_u22a2] = ACTIONS(5591),
    [anon_sym_PIPE_EQ] = ACTIONS(5591),
    [anon_sym_u22a8] = ACTIONS(5591),
    [anon_sym_DASH_PIPE] = ACTIONS(5591),
    [anon_sym_u22a3] = ACTIONS(5591),
    [anon_sym_EQ_PIPE] = ACTIONS(5591),
    [anon_sym_u2ae4] = ACTIONS(5591),
    [anon_sym_BSLASHasymp] = ACTIONS(5591),
    [anon_sym_u224d] = ACTIONS(5591),
    [anon_sym_BSLASHcong] = ACTIONS(5591),
    [anon_sym_u2245] = ACTIONS(5591),
    [anon_sym_BSLASHdoteq] = ACTIONS(5591),
    [anon_sym_u2250] = ACTIONS(5591),
    [anon_sym_BSLASHgg] = ACTIONS(5591),
    [anon_sym_u226b] = ACTIONS(5591),
    [anon_sym_BSLASHll] = ACTIONS(5591),
    [anon_sym_u226a] = ACTIONS(5591),
    [anon_sym_BSLASHnotin] = ACTIONS(5591),
    [anon_sym_u2209] = ACTIONS(5591),
    [anon_sym_BSLASHprec] = ACTIONS(5589),
    [anon_sym_u227a] = ACTIONS(5591),
    [anon_sym_BSLASHsucc] = ACTIONS(5589),
    [anon_sym_u227b] = ACTIONS(5591),
    [anon_sym_BSLASHpreceq] = ACTIONS(5591),
    [anon_sym_u2aaf] = ACTIONS(5591),
    [anon_sym_BSLASHsucceq] = ACTIONS(5591),
    [anon_sym_u2ab0] = ACTIONS(5591),
    [anon_sym_BSLASHpropto] = ACTIONS(5591),
    [anon_sym_u221d] = ACTIONS(5591),
    [anon_sym_BSLASHsim] = ACTIONS(5589),
    [anon_sym_u223c] = ACTIONS(5591),
    [anon_sym_BSLASHsimeq] = ACTIONS(5591),
    [anon_sym_u2243] = ACTIONS(5591),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5589),
    [anon_sym_u228f] = ACTIONS(5591),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5589),
    [anon_sym_u2290] = ACTIONS(5591),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5591),
    [anon_sym_u2291] = ACTIONS(5591),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5591),
    [anon_sym_u2292] = ACTIONS(5591),
    [anon_sym_BSLASHsubset] = ACTIONS(5589),
    [anon_sym_u2282] = ACTIONS(5591),
    [anon_sym_BSLASHsupset] = ACTIONS(5589),
    [anon_sym_u2283] = ACTIONS(5591),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5591),
    [anon_sym_u2286] = ACTIONS(5591),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5591),
    [anon_sym_u2287] = ACTIONS(5591),
    [sym_compose] = ACTIONS(5591),
    [sym_map_to] = ACTIONS(5591),
    [sym_map_from] = ACTIONS(5591),
    [sym_setminus] = ACTIONS(5589),
    [anon_sym_BSLASHcap] = ACTIONS(5591),
    [anon_sym_BSLASHintersect] = ACTIONS(5591),
    [anon_sym_u2229] = ACTIONS(5591),
    [anon_sym_BSLASHcup] = ACTIONS(5591),
    [anon_sym_BSLASHunion] = ACTIONS(5591),
    [anon_sym_u222a] = ACTIONS(5591),
    [anon_sym_DOT_DOT] = ACTIONS(5589),
    [anon_sym_u2025] = ACTIONS(5591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5591),
    [anon_sym_u2026] = ACTIONS(5591),
    [anon_sym_PLUS] = ACTIONS(5589),
    [sym_plusplus] = ACTIONS(5591),
    [anon_sym_BSLASHoplus] = ACTIONS(5591),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5591),
    [anon_sym_u2295] = ACTIONS(5591),
    [anon_sym_BSLASHominus] = ACTIONS(5591),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5591),
    [anon_sym_u2296] = ACTIONS(5591),
    [sym_mod] = ACTIONS(5589),
    [sym_modmod] = ACTIONS(5591),
    [sym_vert] = ACTIONS(5589),
    [anon_sym_PIPE_PIPE] = ACTIONS(5591),
    [anon_sym_u2016] = ACTIONS(5591),
    [sym_minusminus] = ACTIONS(5591),
    [sym_amp] = ACTIONS(5589),
    [sym_ampamp] = ACTIONS(5591),
    [anon_sym_BSLASHodot] = ACTIONS(5591),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5591),
    [anon_sym_u2299] = ACTIONS(5591),
    [anon_sym_BSLASHoslash] = ACTIONS(5591),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5591),
    [anon_sym_u2298] = ACTIONS(5591),
    [anon_sym_BSLASHotimes] = ACTIONS(5591),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5591),
    [anon_sym_u2297] = ACTIONS(5591),
    [sym_mul] = ACTIONS(5589),
    [sym_mulmul] = ACTIONS(5591),
    [sym_slash] = ACTIONS(5589),
    [sym_slashslash] = ACTIONS(5591),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5591),
    [anon_sym_u25ef] = ACTIONS(5591),
    [anon_sym_BSLASHbullet] = ACTIONS(5591),
    [anon_sym_u25cf] = ACTIONS(5591),
    [anon_sym_BSLASHdiv] = ACTIONS(5591),
    [anon_sym_u00f7] = ACTIONS(5591),
    [anon_sym_BSLASHcirc] = ACTIONS(5591),
    [anon_sym_u2218] = ACTIONS(5591),
    [anon_sym_BSLASHstar] = ACTIONS(5591),
    [anon_sym_u22c6] = ACTIONS(5591),
    [anon_sym_u203c] = ACTIONS(5591),
    [sym_hashhash] = ACTIONS(5591),
    [sym_dol] = ACTIONS(5589),
    [sym_doldol] = ACTIONS(5591),
    [anon_sym_QMARK_QMARK] = ACTIONS(5591),
    [anon_sym_u2047] = ACTIONS(5591),
    [anon_sym_BSLASHsqcap] = ACTIONS(5591),
    [anon_sym_u2293] = ACTIONS(5591),
    [anon_sym_BSLASHsqcup] = ACTIONS(5591),
    [anon_sym_u2294] = ACTIONS(5591),
    [anon_sym_BSLASHuplus] = ACTIONS(5591),
    [anon_sym_u228e] = ACTIONS(5591),
    [anon_sym_BSLASHX] = ACTIONS(5591),
    [anon_sym_BSLASHtimes] = ACTIONS(5591),
    [anon_sym_u00d7] = ACTIONS(5591),
    [anon_sym_BSLASHwr] = ACTIONS(5591),
    [anon_sym_u2240] = ACTIONS(5591),
    [anon_sym_BSLASHcdot] = ACTIONS(5591),
    [anon_sym_u22c5] = ACTIONS(5591),
    [sym_pow] = ACTIONS(5589),
    [sym_powpow] = ACTIONS(5591),
    [anon_sym_CARET_PLUS] = ACTIONS(5591),
    [anon_sym_u207a] = ACTIONS(5591),
    [sym_asterisk] = ACTIONS(5591),
    [sym_sup_hash] = ACTIONS(5591),
    [sym_prime] = ACTIONS(5591),
    [sym__indent] = ACTIONS(5591),
    [sym__double_excl] = ACTIONS(5591),
  },
  [2196] = {
    [sym_block_comment] = STATE(2196),
    [sym_identifier] = ACTIONS(5593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5593),
    [anon_sym_u2208] = ACTIONS(5595),
    [anon_sym_BSLASHA] = ACTIONS(5593),
    [anon_sym_BSLASHforall] = ACTIONS(5595),
    [anon_sym_u2200] = ACTIONS(5595),
    [anon_sym_BSLASHE] = ACTIONS(5593),
    [anon_sym_BSLASHexists] = ACTIONS(5595),
    [anon_sym_u2203] = ACTIONS(5595),
    [sym_temporal_forall] = ACTIONS(5595),
    [sym_temporal_exists] = ACTIONS(5595),
    [anon_sym_LT_LT] = ACTIONS(5595),
    [anon_sym_u3008] = ACTIONS(5595),
    [anon_sym_u27e8] = ACTIONS(5595),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5595),
    [anon_sym_u25a1] = ACTIONS(5595),
    [anon_sym_AT] = ACTIONS(5593),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5595),
    [anon_sym_u2227] = ACTIONS(5595),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5595),
    [anon_sym_u2228] = ACTIONS(5595),
    [anon_sym_LPAREN] = ACTIONS(5593),
    [anon_sym_LBRACK] = ACTIONS(5593),
    [aux_sym_child_id_token1] = ACTIONS(5593),
    [sym_real_number] = ACTIONS(5595),
    [anon_sym_BSLASHb] = ACTIONS(5593),
    [anon_sym_BSLASHB] = ACTIONS(5595),
    [anon_sym_BSLASHo] = ACTIONS(5593),
    [anon_sym_BSLASHO] = ACTIONS(5595),
    [anon_sym_BSLASHh] = ACTIONS(5595),
    [anon_sym_BSLASHH] = ACTIONS(5595),
    [anon_sym_DQUOTE] = ACTIONS(5595),
    [anon_sym_TRUE] = ACTIONS(5593),
    [anon_sym_FALSE] = ACTIONS(5593),
    [sym_string_set] = ACTIONS(5593),
    [sym_boolean_set] = ACTIONS(5593),
    [anon_sym_Nat] = ACTIONS(5593),
    [anon_sym_u2115] = ACTIONS(5595),
    [anon_sym_Int] = ACTIONS(5593),
    [anon_sym_u2124] = ACTIONS(5595),
    [anon_sym_Real] = ACTIONS(5593),
    [anon_sym_u211d] = ACTIONS(5595),
    [anon_sym_CHOOSE] = ACTIONS(5593),
    [anon_sym_LBRACE] = ACTIONS(5595),
    [anon_sym_EQ] = ACTIONS(5593),
    [anon_sym_WF_] = ACTIONS(5593),
    [anon_sym_SF_] = ACTIONS(5593),
    [anon_sym_IF] = ACTIONS(5593),
    [anon_sym_CASE] = ACTIONS(5593),
    [anon_sym_LET] = ACTIONS(5593),
    [anon_sym_BSLASHlnot] = ACTIONS(5595),
    [anon_sym_BSLASHneg] = ACTIONS(5595),
    [anon_sym_TILDE] = ACTIONS(5593),
    [anon_sym_u00ac] = ACTIONS(5595),
    [sym_union] = ACTIONS(5593),
    [sym_powerset] = ACTIONS(5593),
    [sym_domain] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5593),
    [sym_negative_dot] = ACTIONS(5595),
    [sym_enabled] = ACTIONS(5593),
    [sym_unchanged] = ACTIONS(5593),
    [anon_sym_LT_GT] = ACTIONS(5595),
    [anon_sym_u22c4] = ACTIONS(5595),
    [anon_sym_u25c7] = ACTIONS(5595),
    [anon_sym_EQ_GT] = ACTIONS(5595),
    [anon_sym_u27f9] = ACTIONS(5595),
    [anon_sym_u21d2] = ACTIONS(5595),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5595),
    [anon_sym_u21f8] = ACTIONS(5595),
    [anon_sym_u2945] = ACTIONS(5595),
    [anon_sym_BSLASHequiv] = ACTIONS(5595),
    [anon_sym_u2261] = ACTIONS(5595),
    [anon_sym_LT_EQ_GT] = ACTIONS(5595),
    [anon_sym_u27fa] = ACTIONS(5595),
    [anon_sym_u21d4] = ACTIONS(5595),
    [anon_sym_TILDE_GT] = ACTIONS(5595),
    [anon_sym_u21dd] = ACTIONS(5595),
    [anon_sym_u219d] = ACTIONS(5595),
    [anon_sym_BSLASHland] = ACTIONS(5595),
    [anon_sym_BSLASHlor] = ACTIONS(5595),
    [anon_sym_COLON_EQ] = ACTIONS(5595),
    [anon_sym_u2254] = ACTIONS(5595),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5595),
    [anon_sym_u2a74] = ACTIONS(5595),
    [anon_sym_SLASH_EQ] = ACTIONS(5595),
    [anon_sym_POUND] = ACTIONS(5593),
    [anon_sym_u2260] = ACTIONS(5595),
    [anon_sym_LT] = ACTIONS(5593),
    [sym_gt] = ACTIONS(5593),
    [anon_sym_LT_EQ] = ACTIONS(5593),
    [anon_sym_EQ_LT] = ACTIONS(5595),
    [anon_sym_BSLASHleq] = ACTIONS(5595),
    [anon_sym_u2264] = ACTIONS(5595),
    [anon_sym_GT_EQ] = ACTIONS(5595),
    [anon_sym_BSLASHgeq] = ACTIONS(5595),
    [anon_sym_u2265] = ACTIONS(5595),
    [anon_sym_BSLASHapprox] = ACTIONS(5595),
    [anon_sym_u2248] = ACTIONS(5595),
    [anon_sym_PIPE_DASH] = ACTIONS(5595),
    [anon_sym_u22a2] = ACTIONS(5595),
    [anon_sym_PIPE_EQ] = ACTIONS(5595),
    [anon_sym_u22a8] = ACTIONS(5595),
    [anon_sym_DASH_PIPE] = ACTIONS(5595),
    [anon_sym_u22a3] = ACTIONS(5595),
    [anon_sym_EQ_PIPE] = ACTIONS(5595),
    [anon_sym_u2ae4] = ACTIONS(5595),
    [anon_sym_BSLASHasymp] = ACTIONS(5595),
    [anon_sym_u224d] = ACTIONS(5595),
    [anon_sym_BSLASHcong] = ACTIONS(5595),
    [anon_sym_u2245] = ACTIONS(5595),
    [anon_sym_BSLASHdoteq] = ACTIONS(5595),
    [anon_sym_u2250] = ACTIONS(5595),
    [anon_sym_BSLASHgg] = ACTIONS(5595),
    [anon_sym_u226b] = ACTIONS(5595),
    [anon_sym_BSLASHll] = ACTIONS(5595),
    [anon_sym_u226a] = ACTIONS(5595),
    [anon_sym_BSLASHnotin] = ACTIONS(5595),
    [anon_sym_u2209] = ACTIONS(5595),
    [anon_sym_BSLASHprec] = ACTIONS(5593),
    [anon_sym_u227a] = ACTIONS(5595),
    [anon_sym_BSLASHsucc] = ACTIONS(5593),
    [anon_sym_u227b] = ACTIONS(5595),
    [anon_sym_BSLASHpreceq] = ACTIONS(5595),
    [anon_sym_u2aaf] = ACTIONS(5595),
    [anon_sym_BSLASHsucceq] = ACTIONS(5595),
    [anon_sym_u2ab0] = ACTIONS(5595),
    [anon_sym_BSLASHpropto] = ACTIONS(5595),
    [anon_sym_u221d] = ACTIONS(5595),
    [anon_sym_BSLASHsim] = ACTIONS(5593),
    [anon_sym_u223c] = ACTIONS(5595),
    [anon_sym_BSLASHsimeq] = ACTIONS(5595),
    [anon_sym_u2243] = ACTIONS(5595),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5593),
    [anon_sym_u228f] = ACTIONS(5595),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5593),
    [anon_sym_u2290] = ACTIONS(5595),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5595),
    [anon_sym_u2291] = ACTIONS(5595),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5595),
    [anon_sym_u2292] = ACTIONS(5595),
    [anon_sym_BSLASHsubset] = ACTIONS(5593),
    [anon_sym_u2282] = ACTIONS(5595),
    [anon_sym_BSLASHsupset] = ACTIONS(5593),
    [anon_sym_u2283] = ACTIONS(5595),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5595),
    [anon_sym_u2286] = ACTIONS(5595),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5595),
    [anon_sym_u2287] = ACTIONS(5595),
    [sym_compose] = ACTIONS(5595),
    [sym_map_to] = ACTIONS(5595),
    [sym_map_from] = ACTIONS(5595),
    [sym_setminus] = ACTIONS(5593),
    [anon_sym_BSLASHcap] = ACTIONS(5595),
    [anon_sym_BSLASHintersect] = ACTIONS(5595),
    [anon_sym_u2229] = ACTIONS(5595),
    [anon_sym_BSLASHcup] = ACTIONS(5595),
    [anon_sym_BSLASHunion] = ACTIONS(5595),
    [anon_sym_u222a] = ACTIONS(5595),
    [anon_sym_DOT_DOT] = ACTIONS(5593),
    [anon_sym_u2025] = ACTIONS(5595),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5595),
    [anon_sym_u2026] = ACTIONS(5595),
    [anon_sym_PLUS] = ACTIONS(5593),
    [sym_plusplus] = ACTIONS(5595),
    [anon_sym_BSLASHoplus] = ACTIONS(5595),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5595),
    [anon_sym_u2295] = ACTIONS(5595),
    [anon_sym_BSLASHominus] = ACTIONS(5595),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5595),
    [anon_sym_u2296] = ACTIONS(5595),
    [sym_mod] = ACTIONS(5593),
    [sym_modmod] = ACTIONS(5595),
    [sym_vert] = ACTIONS(5593),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_u2016] = ACTIONS(5595),
    [sym_minusminus] = ACTIONS(5595),
    [sym_amp] = ACTIONS(5593),
    [sym_ampamp] = ACTIONS(5595),
    [anon_sym_BSLASHodot] = ACTIONS(5595),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5595),
    [anon_sym_u2299] = ACTIONS(5595),
    [anon_sym_BSLASHoslash] = ACTIONS(5595),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5595),
    [anon_sym_u2298] = ACTIONS(5595),
    [anon_sym_BSLASHotimes] = ACTIONS(5595),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5595),
    [anon_sym_u2297] = ACTIONS(5595),
    [sym_mul] = ACTIONS(5593),
    [sym_mulmul] = ACTIONS(5595),
    [sym_slash] = ACTIONS(5593),
    [sym_slashslash] = ACTIONS(5595),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5595),
    [anon_sym_u25ef] = ACTIONS(5595),
    [anon_sym_BSLASHbullet] = ACTIONS(5595),
    [anon_sym_u25cf] = ACTIONS(5595),
    [anon_sym_BSLASHdiv] = ACTIONS(5595),
    [anon_sym_u00f7] = ACTIONS(5595),
    [anon_sym_BSLASHcirc] = ACTIONS(5595),
    [anon_sym_u2218] = ACTIONS(5595),
    [anon_sym_BSLASHstar] = ACTIONS(5595),
    [anon_sym_u22c6] = ACTIONS(5595),
    [anon_sym_u203c] = ACTIONS(5595),
    [sym_hashhash] = ACTIONS(5595),
    [sym_dol] = ACTIONS(5593),
    [sym_doldol] = ACTIONS(5595),
    [anon_sym_QMARK_QMARK] = ACTIONS(5595),
    [anon_sym_u2047] = ACTIONS(5595),
    [anon_sym_BSLASHsqcap] = ACTIONS(5595),
    [anon_sym_u2293] = ACTIONS(5595),
    [anon_sym_BSLASHsqcup] = ACTIONS(5595),
    [anon_sym_u2294] = ACTIONS(5595),
    [anon_sym_BSLASHuplus] = ACTIONS(5595),
    [anon_sym_u228e] = ACTIONS(5595),
    [anon_sym_BSLASHX] = ACTIONS(5595),
    [anon_sym_BSLASHtimes] = ACTIONS(5595),
    [anon_sym_u00d7] = ACTIONS(5595),
    [anon_sym_BSLASHwr] = ACTIONS(5595),
    [anon_sym_u2240] = ACTIONS(5595),
    [anon_sym_BSLASHcdot] = ACTIONS(5595),
    [anon_sym_u22c5] = ACTIONS(5595),
    [sym_pow] = ACTIONS(5593),
    [sym_powpow] = ACTIONS(5595),
    [anon_sym_CARET_PLUS] = ACTIONS(5595),
    [anon_sym_u207a] = ACTIONS(5595),
    [sym_asterisk] = ACTIONS(5595),
    [sym_sup_hash] = ACTIONS(5595),
    [sym_prime] = ACTIONS(5595),
    [sym__indent] = ACTIONS(5595),
    [sym__double_excl] = ACTIONS(5595),
  },
  [2197] = {
    [sym_block_comment] = STATE(2197),
    [sym_identifier] = ACTIONS(5597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5597),
    [anon_sym_u2208] = ACTIONS(5599),
    [anon_sym_BSLASHA] = ACTIONS(5597),
    [anon_sym_BSLASHforall] = ACTIONS(5599),
    [anon_sym_u2200] = ACTIONS(5599),
    [anon_sym_BSLASHE] = ACTIONS(5597),
    [anon_sym_BSLASHexists] = ACTIONS(5599),
    [anon_sym_u2203] = ACTIONS(5599),
    [sym_temporal_forall] = ACTIONS(5599),
    [sym_temporal_exists] = ACTIONS(5599),
    [anon_sym_LT_LT] = ACTIONS(5599),
    [anon_sym_u3008] = ACTIONS(5599),
    [anon_sym_u27e8] = ACTIONS(5599),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5599),
    [anon_sym_u25a1] = ACTIONS(5599),
    [anon_sym_AT] = ACTIONS(5597),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5599),
    [anon_sym_u2227] = ACTIONS(5599),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5599),
    [anon_sym_u2228] = ACTIONS(5599),
    [anon_sym_LPAREN] = ACTIONS(5597),
    [anon_sym_LBRACK] = ACTIONS(5597),
    [aux_sym_child_id_token1] = ACTIONS(5597),
    [sym_real_number] = ACTIONS(5599),
    [anon_sym_BSLASHb] = ACTIONS(5597),
    [anon_sym_BSLASHB] = ACTIONS(5599),
    [anon_sym_BSLASHo] = ACTIONS(5597),
    [anon_sym_BSLASHO] = ACTIONS(5599),
    [anon_sym_BSLASHh] = ACTIONS(5599),
    [anon_sym_BSLASHH] = ACTIONS(5599),
    [anon_sym_DQUOTE] = ACTIONS(5599),
    [anon_sym_TRUE] = ACTIONS(5597),
    [anon_sym_FALSE] = ACTIONS(5597),
    [sym_string_set] = ACTIONS(5597),
    [sym_boolean_set] = ACTIONS(5597),
    [anon_sym_Nat] = ACTIONS(5597),
    [anon_sym_u2115] = ACTIONS(5599),
    [anon_sym_Int] = ACTIONS(5597),
    [anon_sym_u2124] = ACTIONS(5599),
    [anon_sym_Real] = ACTIONS(5597),
    [anon_sym_u211d] = ACTIONS(5599),
    [anon_sym_CHOOSE] = ACTIONS(5597),
    [anon_sym_LBRACE] = ACTIONS(5599),
    [anon_sym_EQ] = ACTIONS(5597),
    [anon_sym_WF_] = ACTIONS(5597),
    [anon_sym_SF_] = ACTIONS(5597),
    [anon_sym_IF] = ACTIONS(5597),
    [anon_sym_CASE] = ACTIONS(5597),
    [anon_sym_LET] = ACTIONS(5597),
    [anon_sym_BSLASHlnot] = ACTIONS(5599),
    [anon_sym_BSLASHneg] = ACTIONS(5599),
    [anon_sym_TILDE] = ACTIONS(5597),
    [anon_sym_u00ac] = ACTIONS(5599),
    [sym_union] = ACTIONS(5597),
    [sym_powerset] = ACTIONS(5597),
    [sym_domain] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5597),
    [sym_negative_dot] = ACTIONS(5599),
    [sym_enabled] = ACTIONS(5597),
    [sym_unchanged] = ACTIONS(5597),
    [anon_sym_LT_GT] = ACTIONS(5599),
    [anon_sym_u22c4] = ACTIONS(5599),
    [anon_sym_u25c7] = ACTIONS(5599),
    [anon_sym_EQ_GT] = ACTIONS(5599),
    [anon_sym_u27f9] = ACTIONS(5599),
    [anon_sym_u21d2] = ACTIONS(5599),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5599),
    [anon_sym_u21f8] = ACTIONS(5599),
    [anon_sym_u2945] = ACTIONS(5599),
    [anon_sym_BSLASHequiv] = ACTIONS(5599),
    [anon_sym_u2261] = ACTIONS(5599),
    [anon_sym_LT_EQ_GT] = ACTIONS(5599),
    [anon_sym_u27fa] = ACTIONS(5599),
    [anon_sym_u21d4] = ACTIONS(5599),
    [anon_sym_TILDE_GT] = ACTIONS(5599),
    [anon_sym_u21dd] = ACTIONS(5599),
    [anon_sym_u219d] = ACTIONS(5599),
    [anon_sym_BSLASHland] = ACTIONS(5599),
    [anon_sym_BSLASHlor] = ACTIONS(5599),
    [anon_sym_COLON_EQ] = ACTIONS(5599),
    [anon_sym_u2254] = ACTIONS(5599),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5599),
    [anon_sym_u2a74] = ACTIONS(5599),
    [anon_sym_SLASH_EQ] = ACTIONS(5599),
    [anon_sym_POUND] = ACTIONS(5597),
    [anon_sym_u2260] = ACTIONS(5599),
    [anon_sym_LT] = ACTIONS(5597),
    [sym_gt] = ACTIONS(5597),
    [anon_sym_LT_EQ] = ACTIONS(5597),
    [anon_sym_EQ_LT] = ACTIONS(5599),
    [anon_sym_BSLASHleq] = ACTIONS(5599),
    [anon_sym_u2264] = ACTIONS(5599),
    [anon_sym_GT_EQ] = ACTIONS(5599),
    [anon_sym_BSLASHgeq] = ACTIONS(5599),
    [anon_sym_u2265] = ACTIONS(5599),
    [anon_sym_BSLASHapprox] = ACTIONS(5599),
    [anon_sym_u2248] = ACTIONS(5599),
    [anon_sym_PIPE_DASH] = ACTIONS(5599),
    [anon_sym_u22a2] = ACTIONS(5599),
    [anon_sym_PIPE_EQ] = ACTIONS(5599),
    [anon_sym_u22a8] = ACTIONS(5599),
    [anon_sym_DASH_PIPE] = ACTIONS(5599),
    [anon_sym_u22a3] = ACTIONS(5599),
    [anon_sym_EQ_PIPE] = ACTIONS(5599),
    [anon_sym_u2ae4] = ACTIONS(5599),
    [anon_sym_BSLASHasymp] = ACTIONS(5599),
    [anon_sym_u224d] = ACTIONS(5599),
    [anon_sym_BSLASHcong] = ACTIONS(5599),
    [anon_sym_u2245] = ACTIONS(5599),
    [anon_sym_BSLASHdoteq] = ACTIONS(5599),
    [anon_sym_u2250] = ACTIONS(5599),
    [anon_sym_BSLASHgg] = ACTIONS(5599),
    [anon_sym_u226b] = ACTIONS(5599),
    [anon_sym_BSLASHll] = ACTIONS(5599),
    [anon_sym_u226a] = ACTIONS(5599),
    [anon_sym_BSLASHnotin] = ACTIONS(5599),
    [anon_sym_u2209] = ACTIONS(5599),
    [anon_sym_BSLASHprec] = ACTIONS(5597),
    [anon_sym_u227a] = ACTIONS(5599),
    [anon_sym_BSLASHsucc] = ACTIONS(5597),
    [anon_sym_u227b] = ACTIONS(5599),
    [anon_sym_BSLASHpreceq] = ACTIONS(5599),
    [anon_sym_u2aaf] = ACTIONS(5599),
    [anon_sym_BSLASHsucceq] = ACTIONS(5599),
    [anon_sym_u2ab0] = ACTIONS(5599),
    [anon_sym_BSLASHpropto] = ACTIONS(5599),
    [anon_sym_u221d] = ACTIONS(5599),
    [anon_sym_BSLASHsim] = ACTIONS(5597),
    [anon_sym_u223c] = ACTIONS(5599),
    [anon_sym_BSLASHsimeq] = ACTIONS(5599),
    [anon_sym_u2243] = ACTIONS(5599),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5597),
    [anon_sym_u228f] = ACTIONS(5599),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5597),
    [anon_sym_u2290] = ACTIONS(5599),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5599),
    [anon_sym_u2291] = ACTIONS(5599),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5599),
    [anon_sym_u2292] = ACTIONS(5599),
    [anon_sym_BSLASHsubset] = ACTIONS(5597),
    [anon_sym_u2282] = ACTIONS(5599),
    [anon_sym_BSLASHsupset] = ACTIONS(5597),
    [anon_sym_u2283] = ACTIONS(5599),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5599),
    [anon_sym_u2286] = ACTIONS(5599),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5599),
    [anon_sym_u2287] = ACTIONS(5599),
    [sym_compose] = ACTIONS(5599),
    [sym_map_to] = ACTIONS(5599),
    [sym_map_from] = ACTIONS(5599),
    [sym_setminus] = ACTIONS(5597),
    [anon_sym_BSLASHcap] = ACTIONS(5599),
    [anon_sym_BSLASHintersect] = ACTIONS(5599),
    [anon_sym_u2229] = ACTIONS(5599),
    [anon_sym_BSLASHcup] = ACTIONS(5599),
    [anon_sym_BSLASHunion] = ACTIONS(5599),
    [anon_sym_u222a] = ACTIONS(5599),
    [anon_sym_DOT_DOT] = ACTIONS(5597),
    [anon_sym_u2025] = ACTIONS(5599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5599),
    [anon_sym_u2026] = ACTIONS(5599),
    [anon_sym_PLUS] = ACTIONS(5597),
    [sym_plusplus] = ACTIONS(5599),
    [anon_sym_BSLASHoplus] = ACTIONS(5599),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5599),
    [anon_sym_u2295] = ACTIONS(5599),
    [anon_sym_BSLASHominus] = ACTIONS(5599),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5599),
    [anon_sym_u2296] = ACTIONS(5599),
    [sym_mod] = ACTIONS(5597),
    [sym_modmod] = ACTIONS(5599),
    [sym_vert] = ACTIONS(5597),
    [anon_sym_PIPE_PIPE] = ACTIONS(5599),
    [anon_sym_u2016] = ACTIONS(5599),
    [sym_minusminus] = ACTIONS(5599),
    [sym_amp] = ACTIONS(5597),
    [sym_ampamp] = ACTIONS(5599),
    [anon_sym_BSLASHodot] = ACTIONS(5599),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5599),
    [anon_sym_u2299] = ACTIONS(5599),
    [anon_sym_BSLASHoslash] = ACTIONS(5599),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5599),
    [anon_sym_u2298] = ACTIONS(5599),
    [anon_sym_BSLASHotimes] = ACTIONS(5599),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5599),
    [anon_sym_u2297] = ACTIONS(5599),
    [sym_mul] = ACTIONS(5597),
    [sym_mulmul] = ACTIONS(5599),
    [sym_slash] = ACTIONS(5597),
    [sym_slashslash] = ACTIONS(5599),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5599),
    [anon_sym_u25ef] = ACTIONS(5599),
    [anon_sym_BSLASHbullet] = ACTIONS(5599),
    [anon_sym_u25cf] = ACTIONS(5599),
    [anon_sym_BSLASHdiv] = ACTIONS(5599),
    [anon_sym_u00f7] = ACTIONS(5599),
    [anon_sym_BSLASHcirc] = ACTIONS(5599),
    [anon_sym_u2218] = ACTIONS(5599),
    [anon_sym_BSLASHstar] = ACTIONS(5599),
    [anon_sym_u22c6] = ACTIONS(5599),
    [anon_sym_u203c] = ACTIONS(5599),
    [sym_hashhash] = ACTIONS(5599),
    [sym_dol] = ACTIONS(5597),
    [sym_doldol] = ACTIONS(5599),
    [anon_sym_QMARK_QMARK] = ACTIONS(5599),
    [anon_sym_u2047] = ACTIONS(5599),
    [anon_sym_BSLASHsqcap] = ACTIONS(5599),
    [anon_sym_u2293] = ACTIONS(5599),
    [anon_sym_BSLASHsqcup] = ACTIONS(5599),
    [anon_sym_u2294] = ACTIONS(5599),
    [anon_sym_BSLASHuplus] = ACTIONS(5599),
    [anon_sym_u228e] = ACTIONS(5599),
    [anon_sym_BSLASHX] = ACTIONS(5599),
    [anon_sym_BSLASHtimes] = ACTIONS(5599),
    [anon_sym_u00d7] = ACTIONS(5599),
    [anon_sym_BSLASHwr] = ACTIONS(5599),
    [anon_sym_u2240] = ACTIONS(5599),
    [anon_sym_BSLASHcdot] = ACTIONS(5599),
    [anon_sym_u22c5] = ACTIONS(5599),
    [sym_pow] = ACTIONS(5597),
    [sym_powpow] = ACTIONS(5599),
    [anon_sym_CARET_PLUS] = ACTIONS(5599),
    [anon_sym_u207a] = ACTIONS(5599),
    [sym_asterisk] = ACTIONS(5599),
    [sym_sup_hash] = ACTIONS(5599),
    [sym_prime] = ACTIONS(5599),
    [sym__indent] = ACTIONS(5599),
    [sym__double_excl] = ACTIONS(5599),
  },
  [2198] = {
    [sym_block_comment] = STATE(2198),
    [sym_identifier] = ACTIONS(5601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5601),
    [anon_sym_u2208] = ACTIONS(5603),
    [anon_sym_BSLASHA] = ACTIONS(5601),
    [anon_sym_BSLASHforall] = ACTIONS(5603),
    [anon_sym_u2200] = ACTIONS(5603),
    [anon_sym_BSLASHE] = ACTIONS(5601),
    [anon_sym_BSLASHexists] = ACTIONS(5603),
    [anon_sym_u2203] = ACTIONS(5603),
    [sym_temporal_forall] = ACTIONS(5603),
    [sym_temporal_exists] = ACTIONS(5603),
    [anon_sym_LT_LT] = ACTIONS(5603),
    [anon_sym_u3008] = ACTIONS(5603),
    [anon_sym_u27e8] = ACTIONS(5603),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5603),
    [anon_sym_u25a1] = ACTIONS(5603),
    [anon_sym_AT] = ACTIONS(5601),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5603),
    [anon_sym_u2227] = ACTIONS(5603),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5603),
    [anon_sym_u2228] = ACTIONS(5603),
    [anon_sym_LPAREN] = ACTIONS(5601),
    [anon_sym_LBRACK] = ACTIONS(5601),
    [aux_sym_child_id_token1] = ACTIONS(5601),
    [sym_real_number] = ACTIONS(5603),
    [anon_sym_BSLASHb] = ACTIONS(5601),
    [anon_sym_BSLASHB] = ACTIONS(5603),
    [anon_sym_BSLASHo] = ACTIONS(5601),
    [anon_sym_BSLASHO] = ACTIONS(5603),
    [anon_sym_BSLASHh] = ACTIONS(5603),
    [anon_sym_BSLASHH] = ACTIONS(5603),
    [anon_sym_DQUOTE] = ACTIONS(5603),
    [anon_sym_TRUE] = ACTIONS(5601),
    [anon_sym_FALSE] = ACTIONS(5601),
    [sym_string_set] = ACTIONS(5601),
    [sym_boolean_set] = ACTIONS(5601),
    [anon_sym_Nat] = ACTIONS(5601),
    [anon_sym_u2115] = ACTIONS(5603),
    [anon_sym_Int] = ACTIONS(5601),
    [anon_sym_u2124] = ACTIONS(5603),
    [anon_sym_Real] = ACTIONS(5601),
    [anon_sym_u211d] = ACTIONS(5603),
    [anon_sym_CHOOSE] = ACTIONS(5601),
    [anon_sym_LBRACE] = ACTIONS(5603),
    [anon_sym_EQ] = ACTIONS(5601),
    [anon_sym_WF_] = ACTIONS(5601),
    [anon_sym_SF_] = ACTIONS(5601),
    [anon_sym_IF] = ACTIONS(5601),
    [anon_sym_CASE] = ACTIONS(5601),
    [anon_sym_LET] = ACTIONS(5601),
    [anon_sym_BSLASHlnot] = ACTIONS(5603),
    [anon_sym_BSLASHneg] = ACTIONS(5603),
    [anon_sym_TILDE] = ACTIONS(5601),
    [anon_sym_u00ac] = ACTIONS(5603),
    [sym_union] = ACTIONS(5601),
    [sym_powerset] = ACTIONS(5601),
    [sym_domain] = ACTIONS(5601),
    [anon_sym_DASH] = ACTIONS(5601),
    [sym_negative_dot] = ACTIONS(5603),
    [sym_enabled] = ACTIONS(5601),
    [sym_unchanged] = ACTIONS(5601),
    [anon_sym_LT_GT] = ACTIONS(5603),
    [anon_sym_u22c4] = ACTIONS(5603),
    [anon_sym_u25c7] = ACTIONS(5603),
    [anon_sym_EQ_GT] = ACTIONS(5603),
    [anon_sym_u27f9] = ACTIONS(5603),
    [anon_sym_u21d2] = ACTIONS(5603),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5603),
    [anon_sym_u21f8] = ACTIONS(5603),
    [anon_sym_u2945] = ACTIONS(5603),
    [anon_sym_BSLASHequiv] = ACTIONS(5603),
    [anon_sym_u2261] = ACTIONS(5603),
    [anon_sym_LT_EQ_GT] = ACTIONS(5603),
    [anon_sym_u27fa] = ACTIONS(5603),
    [anon_sym_u21d4] = ACTIONS(5603),
    [anon_sym_TILDE_GT] = ACTIONS(5603),
    [anon_sym_u21dd] = ACTIONS(5603),
    [anon_sym_u219d] = ACTIONS(5603),
    [anon_sym_BSLASHland] = ACTIONS(5603),
    [anon_sym_BSLASHlor] = ACTIONS(5603),
    [anon_sym_COLON_EQ] = ACTIONS(5603),
    [anon_sym_u2254] = ACTIONS(5603),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5603),
    [anon_sym_u2a74] = ACTIONS(5603),
    [anon_sym_SLASH_EQ] = ACTIONS(5603),
    [anon_sym_POUND] = ACTIONS(5601),
    [anon_sym_u2260] = ACTIONS(5603),
    [anon_sym_LT] = ACTIONS(5601),
    [sym_gt] = ACTIONS(5601),
    [anon_sym_LT_EQ] = ACTIONS(5601),
    [anon_sym_EQ_LT] = ACTIONS(5603),
    [anon_sym_BSLASHleq] = ACTIONS(5603),
    [anon_sym_u2264] = ACTIONS(5603),
    [anon_sym_GT_EQ] = ACTIONS(5603),
    [anon_sym_BSLASHgeq] = ACTIONS(5603),
    [anon_sym_u2265] = ACTIONS(5603),
    [anon_sym_BSLASHapprox] = ACTIONS(5603),
    [anon_sym_u2248] = ACTIONS(5603),
    [anon_sym_PIPE_DASH] = ACTIONS(5603),
    [anon_sym_u22a2] = ACTIONS(5603),
    [anon_sym_PIPE_EQ] = ACTIONS(5603),
    [anon_sym_u22a8] = ACTIONS(5603),
    [anon_sym_DASH_PIPE] = ACTIONS(5603),
    [anon_sym_u22a3] = ACTIONS(5603),
    [anon_sym_EQ_PIPE] = ACTIONS(5603),
    [anon_sym_u2ae4] = ACTIONS(5603),
    [anon_sym_BSLASHasymp] = ACTIONS(5603),
    [anon_sym_u224d] = ACTIONS(5603),
    [anon_sym_BSLASHcong] = ACTIONS(5603),
    [anon_sym_u2245] = ACTIONS(5603),
    [anon_sym_BSLASHdoteq] = ACTIONS(5603),
    [anon_sym_u2250] = ACTIONS(5603),
    [anon_sym_BSLASHgg] = ACTIONS(5603),
    [anon_sym_u226b] = ACTIONS(5603),
    [anon_sym_BSLASHll] = ACTIONS(5603),
    [anon_sym_u226a] = ACTIONS(5603),
    [anon_sym_BSLASHnotin] = ACTIONS(5603),
    [anon_sym_u2209] = ACTIONS(5603),
    [anon_sym_BSLASHprec] = ACTIONS(5601),
    [anon_sym_u227a] = ACTIONS(5603),
    [anon_sym_BSLASHsucc] = ACTIONS(5601),
    [anon_sym_u227b] = ACTIONS(5603),
    [anon_sym_BSLASHpreceq] = ACTIONS(5603),
    [anon_sym_u2aaf] = ACTIONS(5603),
    [anon_sym_BSLASHsucceq] = ACTIONS(5603),
    [anon_sym_u2ab0] = ACTIONS(5603),
    [anon_sym_BSLASHpropto] = ACTIONS(5603),
    [anon_sym_u221d] = ACTIONS(5603),
    [anon_sym_BSLASHsim] = ACTIONS(5601),
    [anon_sym_u223c] = ACTIONS(5603),
    [anon_sym_BSLASHsimeq] = ACTIONS(5603),
    [anon_sym_u2243] = ACTIONS(5603),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5601),
    [anon_sym_u228f] = ACTIONS(5603),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5601),
    [anon_sym_u2290] = ACTIONS(5603),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5603),
    [anon_sym_u2291] = ACTIONS(5603),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5603),
    [anon_sym_u2292] = ACTIONS(5603),
    [anon_sym_BSLASHsubset] = ACTIONS(5601),
    [anon_sym_u2282] = ACTIONS(5603),
    [anon_sym_BSLASHsupset] = ACTIONS(5601),
    [anon_sym_u2283] = ACTIONS(5603),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5603),
    [anon_sym_u2286] = ACTIONS(5603),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5603),
    [anon_sym_u2287] = ACTIONS(5603),
    [sym_compose] = ACTIONS(5603),
    [sym_map_to] = ACTIONS(5603),
    [sym_map_from] = ACTIONS(5603),
    [sym_setminus] = ACTIONS(5601),
    [anon_sym_BSLASHcap] = ACTIONS(5603),
    [anon_sym_BSLASHintersect] = ACTIONS(5603),
    [anon_sym_u2229] = ACTIONS(5603),
    [anon_sym_BSLASHcup] = ACTIONS(5603),
    [anon_sym_BSLASHunion] = ACTIONS(5603),
    [anon_sym_u222a] = ACTIONS(5603),
    [anon_sym_DOT_DOT] = ACTIONS(5601),
    [anon_sym_u2025] = ACTIONS(5603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5603),
    [anon_sym_u2026] = ACTIONS(5603),
    [anon_sym_PLUS] = ACTIONS(5601),
    [sym_plusplus] = ACTIONS(5603),
    [anon_sym_BSLASHoplus] = ACTIONS(5603),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5603),
    [anon_sym_u2295] = ACTIONS(5603),
    [anon_sym_BSLASHominus] = ACTIONS(5603),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5603),
    [anon_sym_u2296] = ACTIONS(5603),
    [sym_mod] = ACTIONS(5601),
    [sym_modmod] = ACTIONS(5603),
    [sym_vert] = ACTIONS(5601),
    [anon_sym_PIPE_PIPE] = ACTIONS(5603),
    [anon_sym_u2016] = ACTIONS(5603),
    [sym_minusminus] = ACTIONS(5603),
    [sym_amp] = ACTIONS(5601),
    [sym_ampamp] = ACTIONS(5603),
    [anon_sym_BSLASHodot] = ACTIONS(5603),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5603),
    [anon_sym_u2299] = ACTIONS(5603),
    [anon_sym_BSLASHoslash] = ACTIONS(5603),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5603),
    [anon_sym_u2298] = ACTIONS(5603),
    [anon_sym_BSLASHotimes] = ACTIONS(5603),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5603),
    [anon_sym_u2297] = ACTIONS(5603),
    [sym_mul] = ACTIONS(5601),
    [sym_mulmul] = ACTIONS(5603),
    [sym_slash] = ACTIONS(5601),
    [sym_slashslash] = ACTIONS(5603),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5603),
    [anon_sym_u25ef] = ACTIONS(5603),
    [anon_sym_BSLASHbullet] = ACTIONS(5603),
    [anon_sym_u25cf] = ACTIONS(5603),
    [anon_sym_BSLASHdiv] = ACTIONS(5603),
    [anon_sym_u00f7] = ACTIONS(5603),
    [anon_sym_BSLASHcirc] = ACTIONS(5603),
    [anon_sym_u2218] = ACTIONS(5603),
    [anon_sym_BSLASHstar] = ACTIONS(5603),
    [anon_sym_u22c6] = ACTIONS(5603),
    [anon_sym_u203c] = ACTIONS(5603),
    [sym_hashhash] = ACTIONS(5603),
    [sym_dol] = ACTIONS(5601),
    [sym_doldol] = ACTIONS(5603),
    [anon_sym_QMARK_QMARK] = ACTIONS(5603),
    [anon_sym_u2047] = ACTIONS(5603),
    [anon_sym_BSLASHsqcap] = ACTIONS(5603),
    [anon_sym_u2293] = ACTIONS(5603),
    [anon_sym_BSLASHsqcup] = ACTIONS(5603),
    [anon_sym_u2294] = ACTIONS(5603),
    [anon_sym_BSLASHuplus] = ACTIONS(5603),
    [anon_sym_u228e] = ACTIONS(5603),
    [anon_sym_BSLASHX] = ACTIONS(5603),
    [anon_sym_BSLASHtimes] = ACTIONS(5603),
    [anon_sym_u00d7] = ACTIONS(5603),
    [anon_sym_BSLASHwr] = ACTIONS(5603),
    [anon_sym_u2240] = ACTIONS(5603),
    [anon_sym_BSLASHcdot] = ACTIONS(5603),
    [anon_sym_u22c5] = ACTIONS(5603),
    [sym_pow] = ACTIONS(5601),
    [sym_powpow] = ACTIONS(5603),
    [anon_sym_CARET_PLUS] = ACTIONS(5603),
    [anon_sym_u207a] = ACTIONS(5603),
    [sym_asterisk] = ACTIONS(5603),
    [sym_sup_hash] = ACTIONS(5603),
    [sym_prime] = ACTIONS(5603),
    [sym__indent] = ACTIONS(5603),
    [sym__double_excl] = ACTIONS(5603),
  },
  [2199] = {
    [sym_block_comment] = STATE(2199),
    [sym_identifier] = ACTIONS(5605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5605),
    [anon_sym_u2208] = ACTIONS(5607),
    [anon_sym_BSLASHA] = ACTIONS(5605),
    [anon_sym_BSLASHforall] = ACTIONS(5607),
    [anon_sym_u2200] = ACTIONS(5607),
    [anon_sym_BSLASHE] = ACTIONS(5605),
    [anon_sym_BSLASHexists] = ACTIONS(5607),
    [anon_sym_u2203] = ACTIONS(5607),
    [sym_temporal_forall] = ACTIONS(5607),
    [sym_temporal_exists] = ACTIONS(5607),
    [anon_sym_LT_LT] = ACTIONS(5607),
    [anon_sym_u3008] = ACTIONS(5607),
    [anon_sym_u27e8] = ACTIONS(5607),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5607),
    [anon_sym_u25a1] = ACTIONS(5607),
    [anon_sym_AT] = ACTIONS(5605),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5607),
    [anon_sym_u2227] = ACTIONS(5607),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5607),
    [anon_sym_u2228] = ACTIONS(5607),
    [anon_sym_LPAREN] = ACTIONS(5605),
    [anon_sym_LBRACK] = ACTIONS(5605),
    [aux_sym_child_id_token1] = ACTIONS(5605),
    [sym_real_number] = ACTIONS(5607),
    [anon_sym_BSLASHb] = ACTIONS(5605),
    [anon_sym_BSLASHB] = ACTIONS(5607),
    [anon_sym_BSLASHo] = ACTIONS(5605),
    [anon_sym_BSLASHO] = ACTIONS(5607),
    [anon_sym_BSLASHh] = ACTIONS(5607),
    [anon_sym_BSLASHH] = ACTIONS(5607),
    [anon_sym_DQUOTE] = ACTIONS(5607),
    [anon_sym_TRUE] = ACTIONS(5605),
    [anon_sym_FALSE] = ACTIONS(5605),
    [sym_string_set] = ACTIONS(5605),
    [sym_boolean_set] = ACTIONS(5605),
    [anon_sym_Nat] = ACTIONS(5605),
    [anon_sym_u2115] = ACTIONS(5607),
    [anon_sym_Int] = ACTIONS(5605),
    [anon_sym_u2124] = ACTIONS(5607),
    [anon_sym_Real] = ACTIONS(5605),
    [anon_sym_u211d] = ACTIONS(5607),
    [anon_sym_CHOOSE] = ACTIONS(5605),
    [anon_sym_LBRACE] = ACTIONS(5607),
    [anon_sym_EQ] = ACTIONS(5605),
    [anon_sym_WF_] = ACTIONS(5605),
    [anon_sym_SF_] = ACTIONS(5605),
    [anon_sym_IF] = ACTIONS(5605),
    [anon_sym_CASE] = ACTIONS(5605),
    [anon_sym_LET] = ACTIONS(5605),
    [anon_sym_BSLASHlnot] = ACTIONS(5607),
    [anon_sym_BSLASHneg] = ACTIONS(5607),
    [anon_sym_TILDE] = ACTIONS(5605),
    [anon_sym_u00ac] = ACTIONS(5607),
    [sym_union] = ACTIONS(5605),
    [sym_powerset] = ACTIONS(5605),
    [sym_domain] = ACTIONS(5605),
    [anon_sym_DASH] = ACTIONS(5605),
    [sym_negative_dot] = ACTIONS(5607),
    [sym_enabled] = ACTIONS(5605),
    [sym_unchanged] = ACTIONS(5605),
    [anon_sym_LT_GT] = ACTIONS(5607),
    [anon_sym_u22c4] = ACTIONS(5607),
    [anon_sym_u25c7] = ACTIONS(5607),
    [anon_sym_EQ_GT] = ACTIONS(5607),
    [anon_sym_u27f9] = ACTIONS(5607),
    [anon_sym_u21d2] = ACTIONS(5607),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5607),
    [anon_sym_u21f8] = ACTIONS(5607),
    [anon_sym_u2945] = ACTIONS(5607),
    [anon_sym_BSLASHequiv] = ACTIONS(5607),
    [anon_sym_u2261] = ACTIONS(5607),
    [anon_sym_LT_EQ_GT] = ACTIONS(5607),
    [anon_sym_u27fa] = ACTIONS(5607),
    [anon_sym_u21d4] = ACTIONS(5607),
    [anon_sym_TILDE_GT] = ACTIONS(5607),
    [anon_sym_u21dd] = ACTIONS(5607),
    [anon_sym_u219d] = ACTIONS(5607),
    [anon_sym_BSLASHland] = ACTIONS(5607),
    [anon_sym_BSLASHlor] = ACTIONS(5607),
    [anon_sym_COLON_EQ] = ACTIONS(5607),
    [anon_sym_u2254] = ACTIONS(5607),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5607),
    [anon_sym_u2a74] = ACTIONS(5607),
    [anon_sym_SLASH_EQ] = ACTIONS(5607),
    [anon_sym_POUND] = ACTIONS(5605),
    [anon_sym_u2260] = ACTIONS(5607),
    [anon_sym_LT] = ACTIONS(5605),
    [sym_gt] = ACTIONS(5605),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_EQ_LT] = ACTIONS(5607),
    [anon_sym_BSLASHleq] = ACTIONS(5607),
    [anon_sym_u2264] = ACTIONS(5607),
    [anon_sym_GT_EQ] = ACTIONS(5607),
    [anon_sym_BSLASHgeq] = ACTIONS(5607),
    [anon_sym_u2265] = ACTIONS(5607),
    [anon_sym_BSLASHapprox] = ACTIONS(5607),
    [anon_sym_u2248] = ACTIONS(5607),
    [anon_sym_PIPE_DASH] = ACTIONS(5607),
    [anon_sym_u22a2] = ACTIONS(5607),
    [anon_sym_PIPE_EQ] = ACTIONS(5607),
    [anon_sym_u22a8] = ACTIONS(5607),
    [anon_sym_DASH_PIPE] = ACTIONS(5607),
    [anon_sym_u22a3] = ACTIONS(5607),
    [anon_sym_EQ_PIPE] = ACTIONS(5607),
    [anon_sym_u2ae4] = ACTIONS(5607),
    [anon_sym_BSLASHasymp] = ACTIONS(5607),
    [anon_sym_u224d] = ACTIONS(5607),
    [anon_sym_BSLASHcong] = ACTIONS(5607),
    [anon_sym_u2245] = ACTIONS(5607),
    [anon_sym_BSLASHdoteq] = ACTIONS(5607),
    [anon_sym_u2250] = ACTIONS(5607),
    [anon_sym_BSLASHgg] = ACTIONS(5607),
    [anon_sym_u226b] = ACTIONS(5607),
    [anon_sym_BSLASHll] = ACTIONS(5607),
    [anon_sym_u226a] = ACTIONS(5607),
    [anon_sym_BSLASHnotin] = ACTIONS(5607),
    [anon_sym_u2209] = ACTIONS(5607),
    [anon_sym_BSLASHprec] = ACTIONS(5605),
    [anon_sym_u227a] = ACTIONS(5607),
    [anon_sym_BSLASHsucc] = ACTIONS(5605),
    [anon_sym_u227b] = ACTIONS(5607),
    [anon_sym_BSLASHpreceq] = ACTIONS(5607),
    [anon_sym_u2aaf] = ACTIONS(5607),
    [anon_sym_BSLASHsucceq] = ACTIONS(5607),
    [anon_sym_u2ab0] = ACTIONS(5607),
    [anon_sym_BSLASHpropto] = ACTIONS(5607),
    [anon_sym_u221d] = ACTIONS(5607),
    [anon_sym_BSLASHsim] = ACTIONS(5605),
    [anon_sym_u223c] = ACTIONS(5607),
    [anon_sym_BSLASHsimeq] = ACTIONS(5607),
    [anon_sym_u2243] = ACTIONS(5607),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5605),
    [anon_sym_u228f] = ACTIONS(5607),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5605),
    [anon_sym_u2290] = ACTIONS(5607),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5607),
    [anon_sym_u2291] = ACTIONS(5607),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5607),
    [anon_sym_u2292] = ACTIONS(5607),
    [anon_sym_BSLASHsubset] = ACTIONS(5605),
    [anon_sym_u2282] = ACTIONS(5607),
    [anon_sym_BSLASHsupset] = ACTIONS(5605),
    [anon_sym_u2283] = ACTIONS(5607),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5607),
    [anon_sym_u2286] = ACTIONS(5607),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5607),
    [anon_sym_u2287] = ACTIONS(5607),
    [sym_compose] = ACTIONS(5607),
    [sym_map_to] = ACTIONS(5607),
    [sym_map_from] = ACTIONS(5607),
    [sym_setminus] = ACTIONS(5605),
    [anon_sym_BSLASHcap] = ACTIONS(5607),
    [anon_sym_BSLASHintersect] = ACTIONS(5607),
    [anon_sym_u2229] = ACTIONS(5607),
    [anon_sym_BSLASHcup] = ACTIONS(5607),
    [anon_sym_BSLASHunion] = ACTIONS(5607),
    [anon_sym_u222a] = ACTIONS(5607),
    [anon_sym_DOT_DOT] = ACTIONS(5605),
    [anon_sym_u2025] = ACTIONS(5607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5607),
    [anon_sym_u2026] = ACTIONS(5607),
    [anon_sym_PLUS] = ACTIONS(5605),
    [sym_plusplus] = ACTIONS(5607),
    [anon_sym_BSLASHoplus] = ACTIONS(5607),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5607),
    [anon_sym_u2295] = ACTIONS(5607),
    [anon_sym_BSLASHominus] = ACTIONS(5607),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5607),
    [anon_sym_u2296] = ACTIONS(5607),
    [sym_mod] = ACTIONS(5605),
    [sym_modmod] = ACTIONS(5607),
    [sym_vert] = ACTIONS(5605),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_u2016] = ACTIONS(5607),
    [sym_minusminus] = ACTIONS(5607),
    [sym_amp] = ACTIONS(5605),
    [sym_ampamp] = ACTIONS(5607),
    [anon_sym_BSLASHodot] = ACTIONS(5607),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5607),
    [anon_sym_u2299] = ACTIONS(5607),
    [anon_sym_BSLASHoslash] = ACTIONS(5607),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5607),
    [anon_sym_u2298] = ACTIONS(5607),
    [anon_sym_BSLASHotimes] = ACTIONS(5607),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5607),
    [anon_sym_u2297] = ACTIONS(5607),
    [sym_mul] = ACTIONS(5605),
    [sym_mulmul] = ACTIONS(5607),
    [sym_slash] = ACTIONS(5605),
    [sym_slashslash] = ACTIONS(5607),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5607),
    [anon_sym_u25ef] = ACTIONS(5607),
    [anon_sym_BSLASHbullet] = ACTIONS(5607),
    [anon_sym_u25cf] = ACTIONS(5607),
    [anon_sym_BSLASHdiv] = ACTIONS(5607),
    [anon_sym_u00f7] = ACTIONS(5607),
    [anon_sym_BSLASHcirc] = ACTIONS(5607),
    [anon_sym_u2218] = ACTIONS(5607),
    [anon_sym_BSLASHstar] = ACTIONS(5607),
    [anon_sym_u22c6] = ACTIONS(5607),
    [anon_sym_u203c] = ACTIONS(5607),
    [sym_hashhash] = ACTIONS(5607),
    [sym_dol] = ACTIONS(5605),
    [sym_doldol] = ACTIONS(5607),
    [anon_sym_QMARK_QMARK] = ACTIONS(5607),
    [anon_sym_u2047] = ACTIONS(5607),
    [anon_sym_BSLASHsqcap] = ACTIONS(5607),
    [anon_sym_u2293] = ACTIONS(5607),
    [anon_sym_BSLASHsqcup] = ACTIONS(5607),
    [anon_sym_u2294] = ACTIONS(5607),
    [anon_sym_BSLASHuplus] = ACTIONS(5607),
    [anon_sym_u228e] = ACTIONS(5607),
    [anon_sym_BSLASHX] = ACTIONS(5607),
    [anon_sym_BSLASHtimes] = ACTIONS(5607),
    [anon_sym_u00d7] = ACTIONS(5607),
    [anon_sym_BSLASHwr] = ACTIONS(5607),
    [anon_sym_u2240] = ACTIONS(5607),
    [anon_sym_BSLASHcdot] = ACTIONS(5607),
    [anon_sym_u22c5] = ACTIONS(5607),
    [sym_pow] = ACTIONS(5605),
    [sym_powpow] = ACTIONS(5607),
    [anon_sym_CARET_PLUS] = ACTIONS(5607),
    [anon_sym_u207a] = ACTIONS(5607),
    [sym_asterisk] = ACTIONS(5607),
    [sym_sup_hash] = ACTIONS(5607),
    [sym_prime] = ACTIONS(5607),
    [sym__indent] = ACTIONS(5607),
    [sym__double_excl] = ACTIONS(5607),
  },
  [2200] = {
    [sym_block_comment] = STATE(2200),
    [sym_identifier] = ACTIONS(5609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5609),
    [anon_sym_u2208] = ACTIONS(5611),
    [anon_sym_BSLASHA] = ACTIONS(5609),
    [anon_sym_BSLASHforall] = ACTIONS(5611),
    [anon_sym_u2200] = ACTIONS(5611),
    [anon_sym_BSLASHE] = ACTIONS(5609),
    [anon_sym_BSLASHexists] = ACTIONS(5611),
    [anon_sym_u2203] = ACTIONS(5611),
    [sym_temporal_forall] = ACTIONS(5611),
    [sym_temporal_exists] = ACTIONS(5611),
    [anon_sym_LT_LT] = ACTIONS(5611),
    [anon_sym_u3008] = ACTIONS(5611),
    [anon_sym_u27e8] = ACTIONS(5611),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5611),
    [anon_sym_u25a1] = ACTIONS(5611),
    [anon_sym_AT] = ACTIONS(5609),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5611),
    [anon_sym_u2227] = ACTIONS(5611),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5611),
    [anon_sym_u2228] = ACTIONS(5611),
    [anon_sym_LPAREN] = ACTIONS(5609),
    [anon_sym_LBRACK] = ACTIONS(5609),
    [aux_sym_child_id_token1] = ACTIONS(5609),
    [sym_real_number] = ACTIONS(5611),
    [anon_sym_BSLASHb] = ACTIONS(5609),
    [anon_sym_BSLASHB] = ACTIONS(5611),
    [anon_sym_BSLASHo] = ACTIONS(5609),
    [anon_sym_BSLASHO] = ACTIONS(5611),
    [anon_sym_BSLASHh] = ACTIONS(5611),
    [anon_sym_BSLASHH] = ACTIONS(5611),
    [anon_sym_DQUOTE] = ACTIONS(5611),
    [anon_sym_TRUE] = ACTIONS(5609),
    [anon_sym_FALSE] = ACTIONS(5609),
    [sym_string_set] = ACTIONS(5609),
    [sym_boolean_set] = ACTIONS(5609),
    [anon_sym_Nat] = ACTIONS(5609),
    [anon_sym_u2115] = ACTIONS(5611),
    [anon_sym_Int] = ACTIONS(5609),
    [anon_sym_u2124] = ACTIONS(5611),
    [anon_sym_Real] = ACTIONS(5609),
    [anon_sym_u211d] = ACTIONS(5611),
    [anon_sym_CHOOSE] = ACTIONS(5609),
    [anon_sym_LBRACE] = ACTIONS(5611),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_WF_] = ACTIONS(5609),
    [anon_sym_SF_] = ACTIONS(5609),
    [anon_sym_IF] = ACTIONS(5609),
    [anon_sym_CASE] = ACTIONS(5609),
    [anon_sym_LET] = ACTIONS(5609),
    [anon_sym_BSLASHlnot] = ACTIONS(5611),
    [anon_sym_BSLASHneg] = ACTIONS(5611),
    [anon_sym_TILDE] = ACTIONS(5609),
    [anon_sym_u00ac] = ACTIONS(5611),
    [sym_union] = ACTIONS(5609),
    [sym_powerset] = ACTIONS(5609),
    [sym_domain] = ACTIONS(5609),
    [anon_sym_DASH] = ACTIONS(5609),
    [sym_negative_dot] = ACTIONS(5611),
    [sym_enabled] = ACTIONS(5609),
    [sym_unchanged] = ACTIONS(5609),
    [anon_sym_LT_GT] = ACTIONS(5611),
    [anon_sym_u22c4] = ACTIONS(5611),
    [anon_sym_u25c7] = ACTIONS(5611),
    [anon_sym_EQ_GT] = ACTIONS(5611),
    [anon_sym_u27f9] = ACTIONS(5611),
    [anon_sym_u21d2] = ACTIONS(5611),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5611),
    [anon_sym_u21f8] = ACTIONS(5611),
    [anon_sym_u2945] = ACTIONS(5611),
    [anon_sym_BSLASHequiv] = ACTIONS(5611),
    [anon_sym_u2261] = ACTIONS(5611),
    [anon_sym_LT_EQ_GT] = ACTIONS(5611),
    [anon_sym_u27fa] = ACTIONS(5611),
    [anon_sym_u21d4] = ACTIONS(5611),
    [anon_sym_TILDE_GT] = ACTIONS(5611),
    [anon_sym_u21dd] = ACTIONS(5611),
    [anon_sym_u219d] = ACTIONS(5611),
    [anon_sym_BSLASHland] = ACTIONS(5611),
    [anon_sym_BSLASHlor] = ACTIONS(5611),
    [anon_sym_COLON_EQ] = ACTIONS(5611),
    [anon_sym_u2254] = ACTIONS(5611),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5611),
    [anon_sym_u2a74] = ACTIONS(5611),
    [anon_sym_SLASH_EQ] = ACTIONS(5611),
    [anon_sym_POUND] = ACTIONS(5609),
    [anon_sym_u2260] = ACTIONS(5611),
    [anon_sym_LT] = ACTIONS(5609),
    [sym_gt] = ACTIONS(5609),
    [anon_sym_LT_EQ] = ACTIONS(5609),
    [anon_sym_EQ_LT] = ACTIONS(5611),
    [anon_sym_BSLASHleq] = ACTIONS(5611),
    [anon_sym_u2264] = ACTIONS(5611),
    [anon_sym_GT_EQ] = ACTIONS(5611),
    [anon_sym_BSLASHgeq] = ACTIONS(5611),
    [anon_sym_u2265] = ACTIONS(5611),
    [anon_sym_BSLASHapprox] = ACTIONS(5611),
    [anon_sym_u2248] = ACTIONS(5611),
    [anon_sym_PIPE_DASH] = ACTIONS(5611),
    [anon_sym_u22a2] = ACTIONS(5611),
    [anon_sym_PIPE_EQ] = ACTIONS(5611),
    [anon_sym_u22a8] = ACTIONS(5611),
    [anon_sym_DASH_PIPE] = ACTIONS(5611),
    [anon_sym_u22a3] = ACTIONS(5611),
    [anon_sym_EQ_PIPE] = ACTIONS(5611),
    [anon_sym_u2ae4] = ACTIONS(5611),
    [anon_sym_BSLASHasymp] = ACTIONS(5611),
    [anon_sym_u224d] = ACTIONS(5611),
    [anon_sym_BSLASHcong] = ACTIONS(5611),
    [anon_sym_u2245] = ACTIONS(5611),
    [anon_sym_BSLASHdoteq] = ACTIONS(5611),
    [anon_sym_u2250] = ACTIONS(5611),
    [anon_sym_BSLASHgg] = ACTIONS(5611),
    [anon_sym_u226b] = ACTIONS(5611),
    [anon_sym_BSLASHll] = ACTIONS(5611),
    [anon_sym_u226a] = ACTIONS(5611),
    [anon_sym_BSLASHnotin] = ACTIONS(5611),
    [anon_sym_u2209] = ACTIONS(5611),
    [anon_sym_BSLASHprec] = ACTIONS(5609),
    [anon_sym_u227a] = ACTIONS(5611),
    [anon_sym_BSLASHsucc] = ACTIONS(5609),
    [anon_sym_u227b] = ACTIONS(5611),
    [anon_sym_BSLASHpreceq] = ACTIONS(5611),
    [anon_sym_u2aaf] = ACTIONS(5611),
    [anon_sym_BSLASHsucceq] = ACTIONS(5611),
    [anon_sym_u2ab0] = ACTIONS(5611),
    [anon_sym_BSLASHpropto] = ACTIONS(5611),
    [anon_sym_u221d] = ACTIONS(5611),
    [anon_sym_BSLASHsim] = ACTIONS(5609),
    [anon_sym_u223c] = ACTIONS(5611),
    [anon_sym_BSLASHsimeq] = ACTIONS(5611),
    [anon_sym_u2243] = ACTIONS(5611),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5609),
    [anon_sym_u228f] = ACTIONS(5611),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5609),
    [anon_sym_u2290] = ACTIONS(5611),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5611),
    [anon_sym_u2291] = ACTIONS(5611),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5611),
    [anon_sym_u2292] = ACTIONS(5611),
    [anon_sym_BSLASHsubset] = ACTIONS(5609),
    [anon_sym_u2282] = ACTIONS(5611),
    [anon_sym_BSLASHsupset] = ACTIONS(5609),
    [anon_sym_u2283] = ACTIONS(5611),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5611),
    [anon_sym_u2286] = ACTIONS(5611),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5611),
    [anon_sym_u2287] = ACTIONS(5611),
    [sym_compose] = ACTIONS(5611),
    [sym_map_to] = ACTIONS(5611),
    [sym_map_from] = ACTIONS(5611),
    [sym_setminus] = ACTIONS(5609),
    [anon_sym_BSLASHcap] = ACTIONS(5611),
    [anon_sym_BSLASHintersect] = ACTIONS(5611),
    [anon_sym_u2229] = ACTIONS(5611),
    [anon_sym_BSLASHcup] = ACTIONS(5611),
    [anon_sym_BSLASHunion] = ACTIONS(5611),
    [anon_sym_u222a] = ACTIONS(5611),
    [anon_sym_DOT_DOT] = ACTIONS(5609),
    [anon_sym_u2025] = ACTIONS(5611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_u2026] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5609),
    [sym_plusplus] = ACTIONS(5611),
    [anon_sym_BSLASHoplus] = ACTIONS(5611),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5611),
    [anon_sym_u2295] = ACTIONS(5611),
    [anon_sym_BSLASHominus] = ACTIONS(5611),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5611),
    [anon_sym_u2296] = ACTIONS(5611),
    [sym_mod] = ACTIONS(5609),
    [sym_modmod] = ACTIONS(5611),
    [sym_vert] = ACTIONS(5609),
    [anon_sym_PIPE_PIPE] = ACTIONS(5611),
    [anon_sym_u2016] = ACTIONS(5611),
    [sym_minusminus] = ACTIONS(5611),
    [sym_amp] = ACTIONS(5609),
    [sym_ampamp] = ACTIONS(5611),
    [anon_sym_BSLASHodot] = ACTIONS(5611),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5611),
    [anon_sym_u2299] = ACTIONS(5611),
    [anon_sym_BSLASHoslash] = ACTIONS(5611),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5611),
    [anon_sym_u2298] = ACTIONS(5611),
    [anon_sym_BSLASHotimes] = ACTIONS(5611),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5611),
    [anon_sym_u2297] = ACTIONS(5611),
    [sym_mul] = ACTIONS(5609),
    [sym_mulmul] = ACTIONS(5611),
    [sym_slash] = ACTIONS(5609),
    [sym_slashslash] = ACTIONS(5611),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5611),
    [anon_sym_u25ef] = ACTIONS(5611),
    [anon_sym_BSLASHbullet] = ACTIONS(5611),
    [anon_sym_u25cf] = ACTIONS(5611),
    [anon_sym_BSLASHdiv] = ACTIONS(5611),
    [anon_sym_u00f7] = ACTIONS(5611),
    [anon_sym_BSLASHcirc] = ACTIONS(5611),
    [anon_sym_u2218] = ACTIONS(5611),
    [anon_sym_BSLASHstar] = ACTIONS(5611),
    [anon_sym_u22c6] = ACTIONS(5611),
    [anon_sym_u203c] = ACTIONS(5611),
    [sym_hashhash] = ACTIONS(5611),
    [sym_dol] = ACTIONS(5609),
    [sym_doldol] = ACTIONS(5611),
    [anon_sym_QMARK_QMARK] = ACTIONS(5611),
    [anon_sym_u2047] = ACTIONS(5611),
    [anon_sym_BSLASHsqcap] = ACTIONS(5611),
    [anon_sym_u2293] = ACTIONS(5611),
    [anon_sym_BSLASHsqcup] = ACTIONS(5611),
    [anon_sym_u2294] = ACTIONS(5611),
    [anon_sym_BSLASHuplus] = ACTIONS(5611),
    [anon_sym_u228e] = ACTIONS(5611),
    [anon_sym_BSLASHX] = ACTIONS(5611),
    [anon_sym_BSLASHtimes] = ACTIONS(5611),
    [anon_sym_u00d7] = ACTIONS(5611),
    [anon_sym_BSLASHwr] = ACTIONS(5611),
    [anon_sym_u2240] = ACTIONS(5611),
    [anon_sym_BSLASHcdot] = ACTIONS(5611),
    [anon_sym_u22c5] = ACTIONS(5611),
    [sym_pow] = ACTIONS(5609),
    [sym_powpow] = ACTIONS(5611),
    [anon_sym_CARET_PLUS] = ACTIONS(5611),
    [anon_sym_u207a] = ACTIONS(5611),
    [sym_asterisk] = ACTIONS(5611),
    [sym_sup_hash] = ACTIONS(5611),
    [sym_prime] = ACTIONS(5611),
    [sym__indent] = ACTIONS(5611),
    [sym__double_excl] = ACTIONS(5611),
  },
  [2201] = {
    [sym_block_comment] = STATE(2201),
    [sym_identifier] = ACTIONS(5613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5613),
    [anon_sym_u2208] = ACTIONS(5615),
    [anon_sym_BSLASHA] = ACTIONS(5613),
    [anon_sym_BSLASHforall] = ACTIONS(5615),
    [anon_sym_u2200] = ACTIONS(5615),
    [anon_sym_BSLASHE] = ACTIONS(5613),
    [anon_sym_BSLASHexists] = ACTIONS(5615),
    [anon_sym_u2203] = ACTIONS(5615),
    [sym_temporal_forall] = ACTIONS(5615),
    [sym_temporal_exists] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5615),
    [anon_sym_u3008] = ACTIONS(5615),
    [anon_sym_u27e8] = ACTIONS(5615),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5615),
    [anon_sym_u25a1] = ACTIONS(5615),
    [anon_sym_AT] = ACTIONS(5613),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5615),
    [anon_sym_u2227] = ACTIONS(5615),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5615),
    [anon_sym_u2228] = ACTIONS(5615),
    [anon_sym_LPAREN] = ACTIONS(5613),
    [anon_sym_LBRACK] = ACTIONS(5613),
    [aux_sym_child_id_token1] = ACTIONS(5613),
    [sym_real_number] = ACTIONS(5615),
    [anon_sym_BSLASHb] = ACTIONS(5613),
    [anon_sym_BSLASHB] = ACTIONS(5615),
    [anon_sym_BSLASHo] = ACTIONS(5613),
    [anon_sym_BSLASHO] = ACTIONS(5615),
    [anon_sym_BSLASHh] = ACTIONS(5615),
    [anon_sym_BSLASHH] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_TRUE] = ACTIONS(5613),
    [anon_sym_FALSE] = ACTIONS(5613),
    [sym_string_set] = ACTIONS(5613),
    [sym_boolean_set] = ACTIONS(5613),
    [anon_sym_Nat] = ACTIONS(5613),
    [anon_sym_u2115] = ACTIONS(5615),
    [anon_sym_Int] = ACTIONS(5613),
    [anon_sym_u2124] = ACTIONS(5615),
    [anon_sym_Real] = ACTIONS(5613),
    [anon_sym_u211d] = ACTIONS(5615),
    [anon_sym_CHOOSE] = ACTIONS(5613),
    [anon_sym_LBRACE] = ACTIONS(5615),
    [anon_sym_EQ] = ACTIONS(5613),
    [anon_sym_WF_] = ACTIONS(5613),
    [anon_sym_SF_] = ACTIONS(5613),
    [anon_sym_IF] = ACTIONS(5613),
    [anon_sym_CASE] = ACTIONS(5613),
    [anon_sym_LET] = ACTIONS(5613),
    [anon_sym_BSLASHlnot] = ACTIONS(5615),
    [anon_sym_BSLASHneg] = ACTIONS(5615),
    [anon_sym_TILDE] = ACTIONS(5613),
    [anon_sym_u00ac] = ACTIONS(5615),
    [sym_union] = ACTIONS(5613),
    [sym_powerset] = ACTIONS(5613),
    [sym_domain] = ACTIONS(5613),
    [anon_sym_DASH] = ACTIONS(5613),
    [sym_negative_dot] = ACTIONS(5615),
    [sym_enabled] = ACTIONS(5613),
    [sym_unchanged] = ACTIONS(5613),
    [anon_sym_LT_GT] = ACTIONS(5615),
    [anon_sym_u22c4] = ACTIONS(5615),
    [anon_sym_u25c7] = ACTIONS(5615),
    [anon_sym_EQ_GT] = ACTIONS(5615),
    [anon_sym_u27f9] = ACTIONS(5615),
    [anon_sym_u21d2] = ACTIONS(5615),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5615),
    [anon_sym_u21f8] = ACTIONS(5615),
    [anon_sym_u2945] = ACTIONS(5615),
    [anon_sym_BSLASHequiv] = ACTIONS(5615),
    [anon_sym_u2261] = ACTIONS(5615),
    [anon_sym_LT_EQ_GT] = ACTIONS(5615),
    [anon_sym_u27fa] = ACTIONS(5615),
    [anon_sym_u21d4] = ACTIONS(5615),
    [anon_sym_TILDE_GT] = ACTIONS(5615),
    [anon_sym_u21dd] = ACTIONS(5615),
    [anon_sym_u219d] = ACTIONS(5615),
    [anon_sym_BSLASHland] = ACTIONS(5615),
    [anon_sym_BSLASHlor] = ACTIONS(5615),
    [anon_sym_COLON_EQ] = ACTIONS(5615),
    [anon_sym_u2254] = ACTIONS(5615),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5615),
    [anon_sym_u2a74] = ACTIONS(5615),
    [anon_sym_SLASH_EQ] = ACTIONS(5615),
    [anon_sym_POUND] = ACTIONS(5613),
    [anon_sym_u2260] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5613),
    [sym_gt] = ACTIONS(5613),
    [anon_sym_LT_EQ] = ACTIONS(5613),
    [anon_sym_EQ_LT] = ACTIONS(5615),
    [anon_sym_BSLASHleq] = ACTIONS(5615),
    [anon_sym_u2264] = ACTIONS(5615),
    [anon_sym_GT_EQ] = ACTIONS(5615),
    [anon_sym_BSLASHgeq] = ACTIONS(5615),
    [anon_sym_u2265] = ACTIONS(5615),
    [anon_sym_BSLASHapprox] = ACTIONS(5615),
    [anon_sym_u2248] = ACTIONS(5615),
    [anon_sym_PIPE_DASH] = ACTIONS(5615),
    [anon_sym_u22a2] = ACTIONS(5615),
    [anon_sym_PIPE_EQ] = ACTIONS(5615),
    [anon_sym_u22a8] = ACTIONS(5615),
    [anon_sym_DASH_PIPE] = ACTIONS(5615),
    [anon_sym_u22a3] = ACTIONS(5615),
    [anon_sym_EQ_PIPE] = ACTIONS(5615),
    [anon_sym_u2ae4] = ACTIONS(5615),
    [anon_sym_BSLASHasymp] = ACTIONS(5615),
    [anon_sym_u224d] = ACTIONS(5615),
    [anon_sym_BSLASHcong] = ACTIONS(5615),
    [anon_sym_u2245] = ACTIONS(5615),
    [anon_sym_BSLASHdoteq] = ACTIONS(5615),
    [anon_sym_u2250] = ACTIONS(5615),
    [anon_sym_BSLASHgg] = ACTIONS(5615),
    [anon_sym_u226b] = ACTIONS(5615),
    [anon_sym_BSLASHll] = ACTIONS(5615),
    [anon_sym_u226a] = ACTIONS(5615),
    [anon_sym_BSLASHnotin] = ACTIONS(5615),
    [anon_sym_u2209] = ACTIONS(5615),
    [anon_sym_BSLASHprec] = ACTIONS(5613),
    [anon_sym_u227a] = ACTIONS(5615),
    [anon_sym_BSLASHsucc] = ACTIONS(5613),
    [anon_sym_u227b] = ACTIONS(5615),
    [anon_sym_BSLASHpreceq] = ACTIONS(5615),
    [anon_sym_u2aaf] = ACTIONS(5615),
    [anon_sym_BSLASHsucceq] = ACTIONS(5615),
    [anon_sym_u2ab0] = ACTIONS(5615),
    [anon_sym_BSLASHpropto] = ACTIONS(5615),
    [anon_sym_u221d] = ACTIONS(5615),
    [anon_sym_BSLASHsim] = ACTIONS(5613),
    [anon_sym_u223c] = ACTIONS(5615),
    [anon_sym_BSLASHsimeq] = ACTIONS(5615),
    [anon_sym_u2243] = ACTIONS(5615),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5613),
    [anon_sym_u228f] = ACTIONS(5615),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5613),
    [anon_sym_u2290] = ACTIONS(5615),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5615),
    [anon_sym_u2291] = ACTIONS(5615),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5615),
    [anon_sym_u2292] = ACTIONS(5615),
    [anon_sym_BSLASHsubset] = ACTIONS(5613),
    [anon_sym_u2282] = ACTIONS(5615),
    [anon_sym_BSLASHsupset] = ACTIONS(5613),
    [anon_sym_u2283] = ACTIONS(5615),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5615),
    [anon_sym_u2286] = ACTIONS(5615),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5615),
    [anon_sym_u2287] = ACTIONS(5615),
    [sym_compose] = ACTIONS(5615),
    [sym_map_to] = ACTIONS(5615),
    [sym_map_from] = ACTIONS(5615),
    [sym_setminus] = ACTIONS(5613),
    [anon_sym_BSLASHcap] = ACTIONS(5615),
    [anon_sym_BSLASHintersect] = ACTIONS(5615),
    [anon_sym_u2229] = ACTIONS(5615),
    [anon_sym_BSLASHcup] = ACTIONS(5615),
    [anon_sym_BSLASHunion] = ACTIONS(5615),
    [anon_sym_u222a] = ACTIONS(5615),
    [anon_sym_DOT_DOT] = ACTIONS(5613),
    [anon_sym_u2025] = ACTIONS(5615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5615),
    [anon_sym_u2026] = ACTIONS(5615),
    [anon_sym_PLUS] = ACTIONS(5613),
    [sym_plusplus] = ACTIONS(5615),
    [anon_sym_BSLASHoplus] = ACTIONS(5615),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5615),
    [anon_sym_u2295] = ACTIONS(5615),
    [anon_sym_BSLASHominus] = ACTIONS(5615),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5615),
    [anon_sym_u2296] = ACTIONS(5615),
    [sym_mod] = ACTIONS(5613),
    [sym_modmod] = ACTIONS(5615),
    [sym_vert] = ACTIONS(5613),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_u2016] = ACTIONS(5615),
    [sym_minusminus] = ACTIONS(5615),
    [sym_amp] = ACTIONS(5613),
    [sym_ampamp] = ACTIONS(5615),
    [anon_sym_BSLASHodot] = ACTIONS(5615),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5615),
    [anon_sym_u2299] = ACTIONS(5615),
    [anon_sym_BSLASHoslash] = ACTIONS(5615),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5615),
    [anon_sym_u2298] = ACTIONS(5615),
    [anon_sym_BSLASHotimes] = ACTIONS(5615),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5615),
    [anon_sym_u2297] = ACTIONS(5615),
    [sym_mul] = ACTIONS(5613),
    [sym_mulmul] = ACTIONS(5615),
    [sym_slash] = ACTIONS(5613),
    [sym_slashslash] = ACTIONS(5615),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5615),
    [anon_sym_u25ef] = ACTIONS(5615),
    [anon_sym_BSLASHbullet] = ACTIONS(5615),
    [anon_sym_u25cf] = ACTIONS(5615),
    [anon_sym_BSLASHdiv] = ACTIONS(5615),
    [anon_sym_u00f7] = ACTIONS(5615),
    [anon_sym_BSLASHcirc] = ACTIONS(5615),
    [anon_sym_u2218] = ACTIONS(5615),
    [anon_sym_BSLASHstar] = ACTIONS(5615),
    [anon_sym_u22c6] = ACTIONS(5615),
    [anon_sym_u203c] = ACTIONS(5615),
    [sym_hashhash] = ACTIONS(5615),
    [sym_dol] = ACTIONS(5613),
    [sym_doldol] = ACTIONS(5615),
    [anon_sym_QMARK_QMARK] = ACTIONS(5615),
    [anon_sym_u2047] = ACTIONS(5615),
    [anon_sym_BSLASHsqcap] = ACTIONS(5615),
    [anon_sym_u2293] = ACTIONS(5615),
    [anon_sym_BSLASHsqcup] = ACTIONS(5615),
    [anon_sym_u2294] = ACTIONS(5615),
    [anon_sym_BSLASHuplus] = ACTIONS(5615),
    [anon_sym_u228e] = ACTIONS(5615),
    [anon_sym_BSLASHX] = ACTIONS(5615),
    [anon_sym_BSLASHtimes] = ACTIONS(5615),
    [anon_sym_u00d7] = ACTIONS(5615),
    [anon_sym_BSLASHwr] = ACTIONS(5615),
    [anon_sym_u2240] = ACTIONS(5615),
    [anon_sym_BSLASHcdot] = ACTIONS(5615),
    [anon_sym_u22c5] = ACTIONS(5615),
    [sym_pow] = ACTIONS(5613),
    [sym_powpow] = ACTIONS(5615),
    [anon_sym_CARET_PLUS] = ACTIONS(5615),
    [anon_sym_u207a] = ACTIONS(5615),
    [sym_asterisk] = ACTIONS(5615),
    [sym_sup_hash] = ACTIONS(5615),
    [sym_prime] = ACTIONS(5615),
    [sym__indent] = ACTIONS(5615),
    [sym__double_excl] = ACTIONS(5615),
  },
  [2202] = {
    [sym_block_comment] = STATE(2202),
    [sym_identifier] = ACTIONS(5617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5617),
    [anon_sym_u2208] = ACTIONS(5619),
    [anon_sym_BSLASHA] = ACTIONS(5617),
    [anon_sym_BSLASHforall] = ACTIONS(5619),
    [anon_sym_u2200] = ACTIONS(5619),
    [anon_sym_BSLASHE] = ACTIONS(5617),
    [anon_sym_BSLASHexists] = ACTIONS(5619),
    [anon_sym_u2203] = ACTIONS(5619),
    [sym_temporal_forall] = ACTIONS(5619),
    [sym_temporal_exists] = ACTIONS(5619),
    [anon_sym_LT_LT] = ACTIONS(5619),
    [anon_sym_u3008] = ACTIONS(5619),
    [anon_sym_u27e8] = ACTIONS(5619),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5619),
    [anon_sym_u25a1] = ACTIONS(5619),
    [anon_sym_AT] = ACTIONS(5617),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5619),
    [anon_sym_u2227] = ACTIONS(5619),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5619),
    [anon_sym_u2228] = ACTIONS(5619),
    [anon_sym_LPAREN] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(5617),
    [aux_sym_child_id_token1] = ACTIONS(5617),
    [sym_real_number] = ACTIONS(5619),
    [anon_sym_BSLASHb] = ACTIONS(5617),
    [anon_sym_BSLASHB] = ACTIONS(5619),
    [anon_sym_BSLASHo] = ACTIONS(5617),
    [anon_sym_BSLASHO] = ACTIONS(5619),
    [anon_sym_BSLASHh] = ACTIONS(5619),
    [anon_sym_BSLASHH] = ACTIONS(5619),
    [anon_sym_DQUOTE] = ACTIONS(5619),
    [anon_sym_TRUE] = ACTIONS(5617),
    [anon_sym_FALSE] = ACTIONS(5617),
    [sym_string_set] = ACTIONS(5617),
    [sym_boolean_set] = ACTIONS(5617),
    [anon_sym_Nat] = ACTIONS(5617),
    [anon_sym_u2115] = ACTIONS(5619),
    [anon_sym_Int] = ACTIONS(5617),
    [anon_sym_u2124] = ACTIONS(5619),
    [anon_sym_Real] = ACTIONS(5617),
    [anon_sym_u211d] = ACTIONS(5619),
    [anon_sym_CHOOSE] = ACTIONS(5617),
    [anon_sym_LBRACE] = ACTIONS(5619),
    [anon_sym_EQ] = ACTIONS(5617),
    [anon_sym_WF_] = ACTIONS(5617),
    [anon_sym_SF_] = ACTIONS(5617),
    [anon_sym_IF] = ACTIONS(5617),
    [anon_sym_CASE] = ACTIONS(5617),
    [anon_sym_LET] = ACTIONS(5617),
    [anon_sym_BSLASHlnot] = ACTIONS(5619),
    [anon_sym_BSLASHneg] = ACTIONS(5619),
    [anon_sym_TILDE] = ACTIONS(5617),
    [anon_sym_u00ac] = ACTIONS(5619),
    [sym_union] = ACTIONS(5617),
    [sym_powerset] = ACTIONS(5617),
    [sym_domain] = ACTIONS(5617),
    [anon_sym_DASH] = ACTIONS(5617),
    [sym_negative_dot] = ACTIONS(5619),
    [sym_enabled] = ACTIONS(5617),
    [sym_unchanged] = ACTIONS(5617),
    [anon_sym_LT_GT] = ACTIONS(5619),
    [anon_sym_u22c4] = ACTIONS(5619),
    [anon_sym_u25c7] = ACTIONS(5619),
    [anon_sym_EQ_GT] = ACTIONS(5619),
    [anon_sym_u27f9] = ACTIONS(5619),
    [anon_sym_u21d2] = ACTIONS(5619),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5619),
    [anon_sym_u21f8] = ACTIONS(5619),
    [anon_sym_u2945] = ACTIONS(5619),
    [anon_sym_BSLASHequiv] = ACTIONS(5619),
    [anon_sym_u2261] = ACTIONS(5619),
    [anon_sym_LT_EQ_GT] = ACTIONS(5619),
    [anon_sym_u27fa] = ACTIONS(5619),
    [anon_sym_u21d4] = ACTIONS(5619),
    [anon_sym_TILDE_GT] = ACTIONS(5619),
    [anon_sym_u21dd] = ACTIONS(5619),
    [anon_sym_u219d] = ACTIONS(5619),
    [anon_sym_BSLASHland] = ACTIONS(5619),
    [anon_sym_BSLASHlor] = ACTIONS(5619),
    [anon_sym_COLON_EQ] = ACTIONS(5619),
    [anon_sym_u2254] = ACTIONS(5619),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5619),
    [anon_sym_u2a74] = ACTIONS(5619),
    [anon_sym_SLASH_EQ] = ACTIONS(5619),
    [anon_sym_POUND] = ACTIONS(5617),
    [anon_sym_u2260] = ACTIONS(5619),
    [anon_sym_LT] = ACTIONS(5617),
    [sym_gt] = ACTIONS(5617),
    [anon_sym_LT_EQ] = ACTIONS(5617),
    [anon_sym_EQ_LT] = ACTIONS(5619),
    [anon_sym_BSLASHleq] = ACTIONS(5619),
    [anon_sym_u2264] = ACTIONS(5619),
    [anon_sym_GT_EQ] = ACTIONS(5619),
    [anon_sym_BSLASHgeq] = ACTIONS(5619),
    [anon_sym_u2265] = ACTIONS(5619),
    [anon_sym_BSLASHapprox] = ACTIONS(5619),
    [anon_sym_u2248] = ACTIONS(5619),
    [anon_sym_PIPE_DASH] = ACTIONS(5619),
    [anon_sym_u22a2] = ACTIONS(5619),
    [anon_sym_PIPE_EQ] = ACTIONS(5619),
    [anon_sym_u22a8] = ACTIONS(5619),
    [anon_sym_DASH_PIPE] = ACTIONS(5619),
    [anon_sym_u22a3] = ACTIONS(5619),
    [anon_sym_EQ_PIPE] = ACTIONS(5619),
    [anon_sym_u2ae4] = ACTIONS(5619),
    [anon_sym_BSLASHasymp] = ACTIONS(5619),
    [anon_sym_u224d] = ACTIONS(5619),
    [anon_sym_BSLASHcong] = ACTIONS(5619),
    [anon_sym_u2245] = ACTIONS(5619),
    [anon_sym_BSLASHdoteq] = ACTIONS(5619),
    [anon_sym_u2250] = ACTIONS(5619),
    [anon_sym_BSLASHgg] = ACTIONS(5619),
    [anon_sym_u226b] = ACTIONS(5619),
    [anon_sym_BSLASHll] = ACTIONS(5619),
    [anon_sym_u226a] = ACTIONS(5619),
    [anon_sym_BSLASHnotin] = ACTIONS(5619),
    [anon_sym_u2209] = ACTIONS(5619),
    [anon_sym_BSLASHprec] = ACTIONS(5617),
    [anon_sym_u227a] = ACTIONS(5619),
    [anon_sym_BSLASHsucc] = ACTIONS(5617),
    [anon_sym_u227b] = ACTIONS(5619),
    [anon_sym_BSLASHpreceq] = ACTIONS(5619),
    [anon_sym_u2aaf] = ACTIONS(5619),
    [anon_sym_BSLASHsucceq] = ACTIONS(5619),
    [anon_sym_u2ab0] = ACTIONS(5619),
    [anon_sym_BSLASHpropto] = ACTIONS(5619),
    [anon_sym_u221d] = ACTIONS(5619),
    [anon_sym_BSLASHsim] = ACTIONS(5617),
    [anon_sym_u223c] = ACTIONS(5619),
    [anon_sym_BSLASHsimeq] = ACTIONS(5619),
    [anon_sym_u2243] = ACTIONS(5619),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5617),
    [anon_sym_u228f] = ACTIONS(5619),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5617),
    [anon_sym_u2290] = ACTIONS(5619),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5619),
    [anon_sym_u2291] = ACTIONS(5619),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5619),
    [anon_sym_u2292] = ACTIONS(5619),
    [anon_sym_BSLASHsubset] = ACTIONS(5617),
    [anon_sym_u2282] = ACTIONS(5619),
    [anon_sym_BSLASHsupset] = ACTIONS(5617),
    [anon_sym_u2283] = ACTIONS(5619),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5619),
    [anon_sym_u2286] = ACTIONS(5619),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5619),
    [anon_sym_u2287] = ACTIONS(5619),
    [sym_compose] = ACTIONS(5619),
    [sym_map_to] = ACTIONS(5619),
    [sym_map_from] = ACTIONS(5619),
    [sym_setminus] = ACTIONS(5617),
    [anon_sym_BSLASHcap] = ACTIONS(5619),
    [anon_sym_BSLASHintersect] = ACTIONS(5619),
    [anon_sym_u2229] = ACTIONS(5619),
    [anon_sym_BSLASHcup] = ACTIONS(5619),
    [anon_sym_BSLASHunion] = ACTIONS(5619),
    [anon_sym_u222a] = ACTIONS(5619),
    [anon_sym_DOT_DOT] = ACTIONS(5617),
    [anon_sym_u2025] = ACTIONS(5619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5619),
    [anon_sym_u2026] = ACTIONS(5619),
    [anon_sym_PLUS] = ACTIONS(5617),
    [sym_plusplus] = ACTIONS(5619),
    [anon_sym_BSLASHoplus] = ACTIONS(5619),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5619),
    [anon_sym_u2295] = ACTIONS(5619),
    [anon_sym_BSLASHominus] = ACTIONS(5619),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5619),
    [anon_sym_u2296] = ACTIONS(5619),
    [sym_mod] = ACTIONS(5617),
    [sym_modmod] = ACTIONS(5619),
    [sym_vert] = ACTIONS(5617),
    [anon_sym_PIPE_PIPE] = ACTIONS(5619),
    [anon_sym_u2016] = ACTIONS(5619),
    [sym_minusminus] = ACTIONS(5619),
    [sym_amp] = ACTIONS(5617),
    [sym_ampamp] = ACTIONS(5619),
    [anon_sym_BSLASHodot] = ACTIONS(5619),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5619),
    [anon_sym_u2299] = ACTIONS(5619),
    [anon_sym_BSLASHoslash] = ACTIONS(5619),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5619),
    [anon_sym_u2298] = ACTIONS(5619),
    [anon_sym_BSLASHotimes] = ACTIONS(5619),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5619),
    [anon_sym_u2297] = ACTIONS(5619),
    [sym_mul] = ACTIONS(5617),
    [sym_mulmul] = ACTIONS(5619),
    [sym_slash] = ACTIONS(5617),
    [sym_slashslash] = ACTIONS(5619),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5619),
    [anon_sym_u25ef] = ACTIONS(5619),
    [anon_sym_BSLASHbullet] = ACTIONS(5619),
    [anon_sym_u25cf] = ACTIONS(5619),
    [anon_sym_BSLASHdiv] = ACTIONS(5619),
    [anon_sym_u00f7] = ACTIONS(5619),
    [anon_sym_BSLASHcirc] = ACTIONS(5619),
    [anon_sym_u2218] = ACTIONS(5619),
    [anon_sym_BSLASHstar] = ACTIONS(5619),
    [anon_sym_u22c6] = ACTIONS(5619),
    [anon_sym_u203c] = ACTIONS(5619),
    [sym_hashhash] = ACTIONS(5619),
    [sym_dol] = ACTIONS(5617),
    [sym_doldol] = ACTIONS(5619),
    [anon_sym_QMARK_QMARK] = ACTIONS(5619),
    [anon_sym_u2047] = ACTIONS(5619),
    [anon_sym_BSLASHsqcap] = ACTIONS(5619),
    [anon_sym_u2293] = ACTIONS(5619),
    [anon_sym_BSLASHsqcup] = ACTIONS(5619),
    [anon_sym_u2294] = ACTIONS(5619),
    [anon_sym_BSLASHuplus] = ACTIONS(5619),
    [anon_sym_u228e] = ACTIONS(5619),
    [anon_sym_BSLASHX] = ACTIONS(5619),
    [anon_sym_BSLASHtimes] = ACTIONS(5619),
    [anon_sym_u00d7] = ACTIONS(5619),
    [anon_sym_BSLASHwr] = ACTIONS(5619),
    [anon_sym_u2240] = ACTIONS(5619),
    [anon_sym_BSLASHcdot] = ACTIONS(5619),
    [anon_sym_u22c5] = ACTIONS(5619),
    [sym_pow] = ACTIONS(5617),
    [sym_powpow] = ACTIONS(5619),
    [anon_sym_CARET_PLUS] = ACTIONS(5619),
    [anon_sym_u207a] = ACTIONS(5619),
    [sym_asterisk] = ACTIONS(5619),
    [sym_sup_hash] = ACTIONS(5619),
    [sym_prime] = ACTIONS(5619),
    [sym__indent] = ACTIONS(5619),
    [sym__double_excl] = ACTIONS(5619),
  },
  [2203] = {
    [sym_block_comment] = STATE(2203),
    [sym_identifier] = ACTIONS(5621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5621),
    [anon_sym_u2208] = ACTIONS(5623),
    [anon_sym_BSLASHA] = ACTIONS(5621),
    [anon_sym_BSLASHforall] = ACTIONS(5623),
    [anon_sym_u2200] = ACTIONS(5623),
    [anon_sym_BSLASHE] = ACTIONS(5621),
    [anon_sym_BSLASHexists] = ACTIONS(5623),
    [anon_sym_u2203] = ACTIONS(5623),
    [sym_temporal_forall] = ACTIONS(5623),
    [sym_temporal_exists] = ACTIONS(5623),
    [anon_sym_LT_LT] = ACTIONS(5623),
    [anon_sym_u3008] = ACTIONS(5623),
    [anon_sym_u27e8] = ACTIONS(5623),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5623),
    [anon_sym_u25a1] = ACTIONS(5623),
    [anon_sym_AT] = ACTIONS(5621),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5623),
    [anon_sym_u2227] = ACTIONS(5623),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5623),
    [anon_sym_u2228] = ACTIONS(5623),
    [anon_sym_LPAREN] = ACTIONS(5621),
    [anon_sym_LBRACK] = ACTIONS(5621),
    [aux_sym_child_id_token1] = ACTIONS(5621),
    [sym_real_number] = ACTIONS(5623),
    [anon_sym_BSLASHb] = ACTIONS(5621),
    [anon_sym_BSLASHB] = ACTIONS(5623),
    [anon_sym_BSLASHo] = ACTIONS(5621),
    [anon_sym_BSLASHO] = ACTIONS(5623),
    [anon_sym_BSLASHh] = ACTIONS(5623),
    [anon_sym_BSLASHH] = ACTIONS(5623),
    [anon_sym_DQUOTE] = ACTIONS(5623),
    [anon_sym_TRUE] = ACTIONS(5621),
    [anon_sym_FALSE] = ACTIONS(5621),
    [sym_string_set] = ACTIONS(5621),
    [sym_boolean_set] = ACTIONS(5621),
    [anon_sym_Nat] = ACTIONS(5621),
    [anon_sym_u2115] = ACTIONS(5623),
    [anon_sym_Int] = ACTIONS(5621),
    [anon_sym_u2124] = ACTIONS(5623),
    [anon_sym_Real] = ACTIONS(5621),
    [anon_sym_u211d] = ACTIONS(5623),
    [anon_sym_CHOOSE] = ACTIONS(5621),
    [anon_sym_LBRACE] = ACTIONS(5623),
    [anon_sym_EQ] = ACTIONS(5621),
    [anon_sym_WF_] = ACTIONS(5621),
    [anon_sym_SF_] = ACTIONS(5621),
    [anon_sym_IF] = ACTIONS(5621),
    [anon_sym_CASE] = ACTIONS(5621),
    [anon_sym_LET] = ACTIONS(5621),
    [anon_sym_BSLASHlnot] = ACTIONS(5623),
    [anon_sym_BSLASHneg] = ACTIONS(5623),
    [anon_sym_TILDE] = ACTIONS(5621),
    [anon_sym_u00ac] = ACTIONS(5623),
    [sym_union] = ACTIONS(5621),
    [sym_powerset] = ACTIONS(5621),
    [sym_domain] = ACTIONS(5621),
    [anon_sym_DASH] = ACTIONS(5621),
    [sym_negative_dot] = ACTIONS(5623),
    [sym_enabled] = ACTIONS(5621),
    [sym_unchanged] = ACTIONS(5621),
    [anon_sym_LT_GT] = ACTIONS(5623),
    [anon_sym_u22c4] = ACTIONS(5623),
    [anon_sym_u25c7] = ACTIONS(5623),
    [anon_sym_EQ_GT] = ACTIONS(5623),
    [anon_sym_u27f9] = ACTIONS(5623),
    [anon_sym_u21d2] = ACTIONS(5623),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5623),
    [anon_sym_u21f8] = ACTIONS(5623),
    [anon_sym_u2945] = ACTIONS(5623),
    [anon_sym_BSLASHequiv] = ACTIONS(5623),
    [anon_sym_u2261] = ACTIONS(5623),
    [anon_sym_LT_EQ_GT] = ACTIONS(5623),
    [anon_sym_u27fa] = ACTIONS(5623),
    [anon_sym_u21d4] = ACTIONS(5623),
    [anon_sym_TILDE_GT] = ACTIONS(5623),
    [anon_sym_u21dd] = ACTIONS(5623),
    [anon_sym_u219d] = ACTIONS(5623),
    [anon_sym_BSLASHland] = ACTIONS(5623),
    [anon_sym_BSLASHlor] = ACTIONS(5623),
    [anon_sym_COLON_EQ] = ACTIONS(5623),
    [anon_sym_u2254] = ACTIONS(5623),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5623),
    [anon_sym_u2a74] = ACTIONS(5623),
    [anon_sym_SLASH_EQ] = ACTIONS(5623),
    [anon_sym_POUND] = ACTIONS(5621),
    [anon_sym_u2260] = ACTIONS(5623),
    [anon_sym_LT] = ACTIONS(5621),
    [sym_gt] = ACTIONS(5621),
    [anon_sym_LT_EQ] = ACTIONS(5621),
    [anon_sym_EQ_LT] = ACTIONS(5623),
    [anon_sym_BSLASHleq] = ACTIONS(5623),
    [anon_sym_u2264] = ACTIONS(5623),
    [anon_sym_GT_EQ] = ACTIONS(5623),
    [anon_sym_BSLASHgeq] = ACTIONS(5623),
    [anon_sym_u2265] = ACTIONS(5623),
    [anon_sym_BSLASHapprox] = ACTIONS(5623),
    [anon_sym_u2248] = ACTIONS(5623),
    [anon_sym_PIPE_DASH] = ACTIONS(5623),
    [anon_sym_u22a2] = ACTIONS(5623),
    [anon_sym_PIPE_EQ] = ACTIONS(5623),
    [anon_sym_u22a8] = ACTIONS(5623),
    [anon_sym_DASH_PIPE] = ACTIONS(5623),
    [anon_sym_u22a3] = ACTIONS(5623),
    [anon_sym_EQ_PIPE] = ACTIONS(5623),
    [anon_sym_u2ae4] = ACTIONS(5623),
    [anon_sym_BSLASHasymp] = ACTIONS(5623),
    [anon_sym_u224d] = ACTIONS(5623),
    [anon_sym_BSLASHcong] = ACTIONS(5623),
    [anon_sym_u2245] = ACTIONS(5623),
    [anon_sym_BSLASHdoteq] = ACTIONS(5623),
    [anon_sym_u2250] = ACTIONS(5623),
    [anon_sym_BSLASHgg] = ACTIONS(5623),
    [anon_sym_u226b] = ACTIONS(5623),
    [anon_sym_BSLASHll] = ACTIONS(5623),
    [anon_sym_u226a] = ACTIONS(5623),
    [anon_sym_BSLASHnotin] = ACTIONS(5623),
    [anon_sym_u2209] = ACTIONS(5623),
    [anon_sym_BSLASHprec] = ACTIONS(5621),
    [anon_sym_u227a] = ACTIONS(5623),
    [anon_sym_BSLASHsucc] = ACTIONS(5621),
    [anon_sym_u227b] = ACTIONS(5623),
    [anon_sym_BSLASHpreceq] = ACTIONS(5623),
    [anon_sym_u2aaf] = ACTIONS(5623),
    [anon_sym_BSLASHsucceq] = ACTIONS(5623),
    [anon_sym_u2ab0] = ACTIONS(5623),
    [anon_sym_BSLASHpropto] = ACTIONS(5623),
    [anon_sym_u221d] = ACTIONS(5623),
    [anon_sym_BSLASHsim] = ACTIONS(5621),
    [anon_sym_u223c] = ACTIONS(5623),
    [anon_sym_BSLASHsimeq] = ACTIONS(5623),
    [anon_sym_u2243] = ACTIONS(5623),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5621),
    [anon_sym_u228f] = ACTIONS(5623),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5621),
    [anon_sym_u2290] = ACTIONS(5623),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5623),
    [anon_sym_u2291] = ACTIONS(5623),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5623),
    [anon_sym_u2292] = ACTIONS(5623),
    [anon_sym_BSLASHsubset] = ACTIONS(5621),
    [anon_sym_u2282] = ACTIONS(5623),
    [anon_sym_BSLASHsupset] = ACTIONS(5621),
    [anon_sym_u2283] = ACTIONS(5623),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5623),
    [anon_sym_u2286] = ACTIONS(5623),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5623),
    [anon_sym_u2287] = ACTIONS(5623),
    [sym_compose] = ACTIONS(5623),
    [sym_map_to] = ACTIONS(5623),
    [sym_map_from] = ACTIONS(5623),
    [sym_setminus] = ACTIONS(5621),
    [anon_sym_BSLASHcap] = ACTIONS(5623),
    [anon_sym_BSLASHintersect] = ACTIONS(5623),
    [anon_sym_u2229] = ACTIONS(5623),
    [anon_sym_BSLASHcup] = ACTIONS(5623),
    [anon_sym_BSLASHunion] = ACTIONS(5623),
    [anon_sym_u222a] = ACTIONS(5623),
    [anon_sym_DOT_DOT] = ACTIONS(5621),
    [anon_sym_u2025] = ACTIONS(5623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5623),
    [anon_sym_u2026] = ACTIONS(5623),
    [anon_sym_PLUS] = ACTIONS(5621),
    [sym_plusplus] = ACTIONS(5623),
    [anon_sym_BSLASHoplus] = ACTIONS(5623),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5623),
    [anon_sym_u2295] = ACTIONS(5623),
    [anon_sym_BSLASHominus] = ACTIONS(5623),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5623),
    [anon_sym_u2296] = ACTIONS(5623),
    [sym_mod] = ACTIONS(5621),
    [sym_modmod] = ACTIONS(5623),
    [sym_vert] = ACTIONS(5621),
    [anon_sym_PIPE_PIPE] = ACTIONS(5623),
    [anon_sym_u2016] = ACTIONS(5623),
    [sym_minusminus] = ACTIONS(5623),
    [sym_amp] = ACTIONS(5621),
    [sym_ampamp] = ACTIONS(5623),
    [anon_sym_BSLASHodot] = ACTIONS(5623),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5623),
    [anon_sym_u2299] = ACTIONS(5623),
    [anon_sym_BSLASHoslash] = ACTIONS(5623),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5623),
    [anon_sym_u2298] = ACTIONS(5623),
    [anon_sym_BSLASHotimes] = ACTIONS(5623),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5623),
    [anon_sym_u2297] = ACTIONS(5623),
    [sym_mul] = ACTIONS(5621),
    [sym_mulmul] = ACTIONS(5623),
    [sym_slash] = ACTIONS(5621),
    [sym_slashslash] = ACTIONS(5623),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5623),
    [anon_sym_u25ef] = ACTIONS(5623),
    [anon_sym_BSLASHbullet] = ACTIONS(5623),
    [anon_sym_u25cf] = ACTIONS(5623),
    [anon_sym_BSLASHdiv] = ACTIONS(5623),
    [anon_sym_u00f7] = ACTIONS(5623),
    [anon_sym_BSLASHcirc] = ACTIONS(5623),
    [anon_sym_u2218] = ACTIONS(5623),
    [anon_sym_BSLASHstar] = ACTIONS(5623),
    [anon_sym_u22c6] = ACTIONS(5623),
    [anon_sym_u203c] = ACTIONS(5623),
    [sym_hashhash] = ACTIONS(5623),
    [sym_dol] = ACTIONS(5621),
    [sym_doldol] = ACTIONS(5623),
    [anon_sym_QMARK_QMARK] = ACTIONS(5623),
    [anon_sym_u2047] = ACTIONS(5623),
    [anon_sym_BSLASHsqcap] = ACTIONS(5623),
    [anon_sym_u2293] = ACTIONS(5623),
    [anon_sym_BSLASHsqcup] = ACTIONS(5623),
    [anon_sym_u2294] = ACTIONS(5623),
    [anon_sym_BSLASHuplus] = ACTIONS(5623),
    [anon_sym_u228e] = ACTIONS(5623),
    [anon_sym_BSLASHX] = ACTIONS(5623),
    [anon_sym_BSLASHtimes] = ACTIONS(5623),
    [anon_sym_u00d7] = ACTIONS(5623),
    [anon_sym_BSLASHwr] = ACTIONS(5623),
    [anon_sym_u2240] = ACTIONS(5623),
    [anon_sym_BSLASHcdot] = ACTIONS(5623),
    [anon_sym_u22c5] = ACTIONS(5623),
    [sym_pow] = ACTIONS(5621),
    [sym_powpow] = ACTIONS(5623),
    [anon_sym_CARET_PLUS] = ACTIONS(5623),
    [anon_sym_u207a] = ACTIONS(5623),
    [sym_asterisk] = ACTIONS(5623),
    [sym_sup_hash] = ACTIONS(5623),
    [sym_prime] = ACTIONS(5623),
    [sym__indent] = ACTIONS(5623),
    [sym__double_excl] = ACTIONS(5623),
  },
  [2204] = {
    [sym_block_comment] = STATE(2204),
    [sym_identifier] = ACTIONS(5625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5625),
    [anon_sym_u2208] = ACTIONS(5627),
    [anon_sym_BSLASHA] = ACTIONS(5625),
    [anon_sym_BSLASHforall] = ACTIONS(5627),
    [anon_sym_u2200] = ACTIONS(5627),
    [anon_sym_BSLASHE] = ACTIONS(5625),
    [anon_sym_BSLASHexists] = ACTIONS(5627),
    [anon_sym_u2203] = ACTIONS(5627),
    [sym_temporal_forall] = ACTIONS(5627),
    [sym_temporal_exists] = ACTIONS(5627),
    [anon_sym_LT_LT] = ACTIONS(5627),
    [anon_sym_u3008] = ACTIONS(5627),
    [anon_sym_u27e8] = ACTIONS(5627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5627),
    [anon_sym_u25a1] = ACTIONS(5627),
    [anon_sym_AT] = ACTIONS(5625),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5627),
    [anon_sym_u2227] = ACTIONS(5627),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5627),
    [anon_sym_u2228] = ACTIONS(5627),
    [anon_sym_LPAREN] = ACTIONS(5625),
    [anon_sym_LBRACK] = ACTIONS(5625),
    [aux_sym_child_id_token1] = ACTIONS(5625),
    [sym_real_number] = ACTIONS(5627),
    [anon_sym_BSLASHb] = ACTIONS(5625),
    [anon_sym_BSLASHB] = ACTIONS(5627),
    [anon_sym_BSLASHo] = ACTIONS(5625),
    [anon_sym_BSLASHO] = ACTIONS(5627),
    [anon_sym_BSLASHh] = ACTIONS(5627),
    [anon_sym_BSLASHH] = ACTIONS(5627),
    [anon_sym_DQUOTE] = ACTIONS(5627),
    [anon_sym_TRUE] = ACTIONS(5625),
    [anon_sym_FALSE] = ACTIONS(5625),
    [sym_string_set] = ACTIONS(5625),
    [sym_boolean_set] = ACTIONS(5625),
    [anon_sym_Nat] = ACTIONS(5625),
    [anon_sym_u2115] = ACTIONS(5627),
    [anon_sym_Int] = ACTIONS(5625),
    [anon_sym_u2124] = ACTIONS(5627),
    [anon_sym_Real] = ACTIONS(5625),
    [anon_sym_u211d] = ACTIONS(5627),
    [anon_sym_CHOOSE] = ACTIONS(5625),
    [anon_sym_LBRACE] = ACTIONS(5627),
    [anon_sym_EQ] = ACTIONS(5625),
    [anon_sym_WF_] = ACTIONS(5625),
    [anon_sym_SF_] = ACTIONS(5625),
    [anon_sym_IF] = ACTIONS(5625),
    [anon_sym_CASE] = ACTIONS(5625),
    [anon_sym_LET] = ACTIONS(5625),
    [anon_sym_BSLASHlnot] = ACTIONS(5627),
    [anon_sym_BSLASHneg] = ACTIONS(5627),
    [anon_sym_TILDE] = ACTIONS(5625),
    [anon_sym_u00ac] = ACTIONS(5627),
    [sym_union] = ACTIONS(5625),
    [sym_powerset] = ACTIONS(5625),
    [sym_domain] = ACTIONS(5625),
    [anon_sym_DASH] = ACTIONS(5625),
    [sym_negative_dot] = ACTIONS(5627),
    [sym_enabled] = ACTIONS(5625),
    [sym_unchanged] = ACTIONS(5625),
    [anon_sym_LT_GT] = ACTIONS(5627),
    [anon_sym_u22c4] = ACTIONS(5627),
    [anon_sym_u25c7] = ACTIONS(5627),
    [anon_sym_EQ_GT] = ACTIONS(5627),
    [anon_sym_u27f9] = ACTIONS(5627),
    [anon_sym_u21d2] = ACTIONS(5627),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5627),
    [anon_sym_u21f8] = ACTIONS(5627),
    [anon_sym_u2945] = ACTIONS(5627),
    [anon_sym_BSLASHequiv] = ACTIONS(5627),
    [anon_sym_u2261] = ACTIONS(5627),
    [anon_sym_LT_EQ_GT] = ACTIONS(5627),
    [anon_sym_u27fa] = ACTIONS(5627),
    [anon_sym_u21d4] = ACTIONS(5627),
    [anon_sym_TILDE_GT] = ACTIONS(5627),
    [anon_sym_u21dd] = ACTIONS(5627),
    [anon_sym_u219d] = ACTIONS(5627),
    [anon_sym_BSLASHland] = ACTIONS(5627),
    [anon_sym_BSLASHlor] = ACTIONS(5627),
    [anon_sym_COLON_EQ] = ACTIONS(5627),
    [anon_sym_u2254] = ACTIONS(5627),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5627),
    [anon_sym_u2a74] = ACTIONS(5627),
    [anon_sym_SLASH_EQ] = ACTIONS(5627),
    [anon_sym_POUND] = ACTIONS(5625),
    [anon_sym_u2260] = ACTIONS(5627),
    [anon_sym_LT] = ACTIONS(5625),
    [sym_gt] = ACTIONS(5625),
    [anon_sym_LT_EQ] = ACTIONS(5625),
    [anon_sym_EQ_LT] = ACTIONS(5627),
    [anon_sym_BSLASHleq] = ACTIONS(5627),
    [anon_sym_u2264] = ACTIONS(5627),
    [anon_sym_GT_EQ] = ACTIONS(5627),
    [anon_sym_BSLASHgeq] = ACTIONS(5627),
    [anon_sym_u2265] = ACTIONS(5627),
    [anon_sym_BSLASHapprox] = ACTIONS(5627),
    [anon_sym_u2248] = ACTIONS(5627),
    [anon_sym_PIPE_DASH] = ACTIONS(5627),
    [anon_sym_u22a2] = ACTIONS(5627),
    [anon_sym_PIPE_EQ] = ACTIONS(5627),
    [anon_sym_u22a8] = ACTIONS(5627),
    [anon_sym_DASH_PIPE] = ACTIONS(5627),
    [anon_sym_u22a3] = ACTIONS(5627),
    [anon_sym_EQ_PIPE] = ACTIONS(5627),
    [anon_sym_u2ae4] = ACTIONS(5627),
    [anon_sym_BSLASHasymp] = ACTIONS(5627),
    [anon_sym_u224d] = ACTIONS(5627),
    [anon_sym_BSLASHcong] = ACTIONS(5627),
    [anon_sym_u2245] = ACTIONS(5627),
    [anon_sym_BSLASHdoteq] = ACTIONS(5627),
    [anon_sym_u2250] = ACTIONS(5627),
    [anon_sym_BSLASHgg] = ACTIONS(5627),
    [anon_sym_u226b] = ACTIONS(5627),
    [anon_sym_BSLASHll] = ACTIONS(5627),
    [anon_sym_u226a] = ACTIONS(5627),
    [anon_sym_BSLASHnotin] = ACTIONS(5627),
    [anon_sym_u2209] = ACTIONS(5627),
    [anon_sym_BSLASHprec] = ACTIONS(5625),
    [anon_sym_u227a] = ACTIONS(5627),
    [anon_sym_BSLASHsucc] = ACTIONS(5625),
    [anon_sym_u227b] = ACTIONS(5627),
    [anon_sym_BSLASHpreceq] = ACTIONS(5627),
    [anon_sym_u2aaf] = ACTIONS(5627),
    [anon_sym_BSLASHsucceq] = ACTIONS(5627),
    [anon_sym_u2ab0] = ACTIONS(5627),
    [anon_sym_BSLASHpropto] = ACTIONS(5627),
    [anon_sym_u221d] = ACTIONS(5627),
    [anon_sym_BSLASHsim] = ACTIONS(5625),
    [anon_sym_u223c] = ACTIONS(5627),
    [anon_sym_BSLASHsimeq] = ACTIONS(5627),
    [anon_sym_u2243] = ACTIONS(5627),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5625),
    [anon_sym_u228f] = ACTIONS(5627),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5625),
    [anon_sym_u2290] = ACTIONS(5627),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5627),
    [anon_sym_u2291] = ACTIONS(5627),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5627),
    [anon_sym_u2292] = ACTIONS(5627),
    [anon_sym_BSLASHsubset] = ACTIONS(5625),
    [anon_sym_u2282] = ACTIONS(5627),
    [anon_sym_BSLASHsupset] = ACTIONS(5625),
    [anon_sym_u2283] = ACTIONS(5627),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5627),
    [anon_sym_u2286] = ACTIONS(5627),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5627),
    [anon_sym_u2287] = ACTIONS(5627),
    [sym_compose] = ACTIONS(5627),
    [sym_map_to] = ACTIONS(5627),
    [sym_map_from] = ACTIONS(5627),
    [sym_setminus] = ACTIONS(5625),
    [anon_sym_BSLASHcap] = ACTIONS(5627),
    [anon_sym_BSLASHintersect] = ACTIONS(5627),
    [anon_sym_u2229] = ACTIONS(5627),
    [anon_sym_BSLASHcup] = ACTIONS(5627),
    [anon_sym_BSLASHunion] = ACTIONS(5627),
    [anon_sym_u222a] = ACTIONS(5627),
    [anon_sym_DOT_DOT] = ACTIONS(5625),
    [anon_sym_u2025] = ACTIONS(5627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5627),
    [anon_sym_u2026] = ACTIONS(5627),
    [anon_sym_PLUS] = ACTIONS(5625),
    [sym_plusplus] = ACTIONS(5627),
    [anon_sym_BSLASHoplus] = ACTIONS(5627),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5627),
    [anon_sym_u2295] = ACTIONS(5627),
    [anon_sym_BSLASHominus] = ACTIONS(5627),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5627),
    [anon_sym_u2296] = ACTIONS(5627),
    [sym_mod] = ACTIONS(5625),
    [sym_modmod] = ACTIONS(5627),
    [sym_vert] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_u2016] = ACTIONS(5627),
    [sym_minusminus] = ACTIONS(5627),
    [sym_amp] = ACTIONS(5625),
    [sym_ampamp] = ACTIONS(5627),
    [anon_sym_BSLASHodot] = ACTIONS(5627),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5627),
    [anon_sym_u2299] = ACTIONS(5627),
    [anon_sym_BSLASHoslash] = ACTIONS(5627),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5627),
    [anon_sym_u2298] = ACTIONS(5627),
    [anon_sym_BSLASHotimes] = ACTIONS(5627),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5627),
    [anon_sym_u2297] = ACTIONS(5627),
    [sym_mul] = ACTIONS(5625),
    [sym_mulmul] = ACTIONS(5627),
    [sym_slash] = ACTIONS(5625),
    [sym_slashslash] = ACTIONS(5627),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5627),
    [anon_sym_u25ef] = ACTIONS(5627),
    [anon_sym_BSLASHbullet] = ACTIONS(5627),
    [anon_sym_u25cf] = ACTIONS(5627),
    [anon_sym_BSLASHdiv] = ACTIONS(5627),
    [anon_sym_u00f7] = ACTIONS(5627),
    [anon_sym_BSLASHcirc] = ACTIONS(5627),
    [anon_sym_u2218] = ACTIONS(5627),
    [anon_sym_BSLASHstar] = ACTIONS(5627),
    [anon_sym_u22c6] = ACTIONS(5627),
    [anon_sym_u203c] = ACTIONS(5627),
    [sym_hashhash] = ACTIONS(5627),
    [sym_dol] = ACTIONS(5625),
    [sym_doldol] = ACTIONS(5627),
    [anon_sym_QMARK_QMARK] = ACTIONS(5627),
    [anon_sym_u2047] = ACTIONS(5627),
    [anon_sym_BSLASHsqcap] = ACTIONS(5627),
    [anon_sym_u2293] = ACTIONS(5627),
    [anon_sym_BSLASHsqcup] = ACTIONS(5627),
    [anon_sym_u2294] = ACTIONS(5627),
    [anon_sym_BSLASHuplus] = ACTIONS(5627),
    [anon_sym_u228e] = ACTIONS(5627),
    [anon_sym_BSLASHX] = ACTIONS(5627),
    [anon_sym_BSLASHtimes] = ACTIONS(5627),
    [anon_sym_u00d7] = ACTIONS(5627),
    [anon_sym_BSLASHwr] = ACTIONS(5627),
    [anon_sym_u2240] = ACTIONS(5627),
    [anon_sym_BSLASHcdot] = ACTIONS(5627),
    [anon_sym_u22c5] = ACTIONS(5627),
    [sym_pow] = ACTIONS(5625),
    [sym_powpow] = ACTIONS(5627),
    [anon_sym_CARET_PLUS] = ACTIONS(5627),
    [anon_sym_u207a] = ACTIONS(5627),
    [sym_asterisk] = ACTIONS(5627),
    [sym_sup_hash] = ACTIONS(5627),
    [sym_prime] = ACTIONS(5627),
    [sym__indent] = ACTIONS(5627),
    [sym__double_excl] = ACTIONS(5627),
  },
  [2205] = {
    [sym_block_comment] = STATE(2205),
    [sym_identifier] = ACTIONS(5629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5629),
    [anon_sym_u2208] = ACTIONS(5631),
    [anon_sym_BSLASHA] = ACTIONS(5629),
    [anon_sym_BSLASHforall] = ACTIONS(5631),
    [anon_sym_u2200] = ACTIONS(5631),
    [anon_sym_BSLASHE] = ACTIONS(5629),
    [anon_sym_BSLASHexists] = ACTIONS(5631),
    [anon_sym_u2203] = ACTIONS(5631),
    [sym_temporal_forall] = ACTIONS(5631),
    [sym_temporal_exists] = ACTIONS(5631),
    [anon_sym_LT_LT] = ACTIONS(5631),
    [anon_sym_u3008] = ACTIONS(5631),
    [anon_sym_u27e8] = ACTIONS(5631),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5631),
    [anon_sym_u25a1] = ACTIONS(5631),
    [anon_sym_AT] = ACTIONS(5629),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5631),
    [anon_sym_u2227] = ACTIONS(5631),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5631),
    [anon_sym_u2228] = ACTIONS(5631),
    [anon_sym_LPAREN] = ACTIONS(5629),
    [anon_sym_LBRACK] = ACTIONS(5629),
    [aux_sym_child_id_token1] = ACTIONS(5629),
    [sym_real_number] = ACTIONS(5631),
    [anon_sym_BSLASHb] = ACTIONS(5629),
    [anon_sym_BSLASHB] = ACTIONS(5631),
    [anon_sym_BSLASHo] = ACTIONS(5629),
    [anon_sym_BSLASHO] = ACTIONS(5631),
    [anon_sym_BSLASHh] = ACTIONS(5631),
    [anon_sym_BSLASHH] = ACTIONS(5631),
    [anon_sym_DQUOTE] = ACTIONS(5631),
    [anon_sym_TRUE] = ACTIONS(5629),
    [anon_sym_FALSE] = ACTIONS(5629),
    [sym_string_set] = ACTIONS(5629),
    [sym_boolean_set] = ACTIONS(5629),
    [anon_sym_Nat] = ACTIONS(5629),
    [anon_sym_u2115] = ACTIONS(5631),
    [anon_sym_Int] = ACTIONS(5629),
    [anon_sym_u2124] = ACTIONS(5631),
    [anon_sym_Real] = ACTIONS(5629),
    [anon_sym_u211d] = ACTIONS(5631),
    [anon_sym_CHOOSE] = ACTIONS(5629),
    [anon_sym_LBRACE] = ACTIONS(5631),
    [anon_sym_EQ] = ACTIONS(5629),
    [anon_sym_WF_] = ACTIONS(5629),
    [anon_sym_SF_] = ACTIONS(5629),
    [anon_sym_IF] = ACTIONS(5629),
    [anon_sym_CASE] = ACTIONS(5629),
    [anon_sym_LET] = ACTIONS(5629),
    [anon_sym_BSLASHlnot] = ACTIONS(5631),
    [anon_sym_BSLASHneg] = ACTIONS(5631),
    [anon_sym_TILDE] = ACTIONS(5629),
    [anon_sym_u00ac] = ACTIONS(5631),
    [sym_union] = ACTIONS(5629),
    [sym_powerset] = ACTIONS(5629),
    [sym_domain] = ACTIONS(5629),
    [anon_sym_DASH] = ACTIONS(5629),
    [sym_negative_dot] = ACTIONS(5631),
    [sym_enabled] = ACTIONS(5629),
    [sym_unchanged] = ACTIONS(5629),
    [anon_sym_LT_GT] = ACTIONS(5631),
    [anon_sym_u22c4] = ACTIONS(5631),
    [anon_sym_u25c7] = ACTIONS(5631),
    [anon_sym_EQ_GT] = ACTIONS(5631),
    [anon_sym_u27f9] = ACTIONS(5631),
    [anon_sym_u21d2] = ACTIONS(5631),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5631),
    [anon_sym_u21f8] = ACTIONS(5631),
    [anon_sym_u2945] = ACTIONS(5631),
    [anon_sym_BSLASHequiv] = ACTIONS(5631),
    [anon_sym_u2261] = ACTIONS(5631),
    [anon_sym_LT_EQ_GT] = ACTIONS(5631),
    [anon_sym_u27fa] = ACTIONS(5631),
    [anon_sym_u21d4] = ACTIONS(5631),
    [anon_sym_TILDE_GT] = ACTIONS(5631),
    [anon_sym_u21dd] = ACTIONS(5631),
    [anon_sym_u219d] = ACTIONS(5631),
    [anon_sym_BSLASHland] = ACTIONS(5631),
    [anon_sym_BSLASHlor] = ACTIONS(5631),
    [anon_sym_COLON_EQ] = ACTIONS(5631),
    [anon_sym_u2254] = ACTIONS(5631),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5631),
    [anon_sym_u2a74] = ACTIONS(5631),
    [anon_sym_SLASH_EQ] = ACTIONS(5631),
    [anon_sym_POUND] = ACTIONS(5629),
    [anon_sym_u2260] = ACTIONS(5631),
    [anon_sym_LT] = ACTIONS(5629),
    [sym_gt] = ACTIONS(5629),
    [anon_sym_LT_EQ] = ACTIONS(5629),
    [anon_sym_EQ_LT] = ACTIONS(5631),
    [anon_sym_BSLASHleq] = ACTIONS(5631),
    [anon_sym_u2264] = ACTIONS(5631),
    [anon_sym_GT_EQ] = ACTIONS(5631),
    [anon_sym_BSLASHgeq] = ACTIONS(5631),
    [anon_sym_u2265] = ACTIONS(5631),
    [anon_sym_BSLASHapprox] = ACTIONS(5631),
    [anon_sym_u2248] = ACTIONS(5631),
    [anon_sym_PIPE_DASH] = ACTIONS(5631),
    [anon_sym_u22a2] = ACTIONS(5631),
    [anon_sym_PIPE_EQ] = ACTIONS(5631),
    [anon_sym_u22a8] = ACTIONS(5631),
    [anon_sym_DASH_PIPE] = ACTIONS(5631),
    [anon_sym_u22a3] = ACTIONS(5631),
    [anon_sym_EQ_PIPE] = ACTIONS(5631),
    [anon_sym_u2ae4] = ACTIONS(5631),
    [anon_sym_BSLASHasymp] = ACTIONS(5631),
    [anon_sym_u224d] = ACTIONS(5631),
    [anon_sym_BSLASHcong] = ACTIONS(5631),
    [anon_sym_u2245] = ACTIONS(5631),
    [anon_sym_BSLASHdoteq] = ACTIONS(5631),
    [anon_sym_u2250] = ACTIONS(5631),
    [anon_sym_BSLASHgg] = ACTIONS(5631),
    [anon_sym_u226b] = ACTIONS(5631),
    [anon_sym_BSLASHll] = ACTIONS(5631),
    [anon_sym_u226a] = ACTIONS(5631),
    [anon_sym_BSLASHnotin] = ACTIONS(5631),
    [anon_sym_u2209] = ACTIONS(5631),
    [anon_sym_BSLASHprec] = ACTIONS(5629),
    [anon_sym_u227a] = ACTIONS(5631),
    [anon_sym_BSLASHsucc] = ACTIONS(5629),
    [anon_sym_u227b] = ACTIONS(5631),
    [anon_sym_BSLASHpreceq] = ACTIONS(5631),
    [anon_sym_u2aaf] = ACTIONS(5631),
    [anon_sym_BSLASHsucceq] = ACTIONS(5631),
    [anon_sym_u2ab0] = ACTIONS(5631),
    [anon_sym_BSLASHpropto] = ACTIONS(5631),
    [anon_sym_u221d] = ACTIONS(5631),
    [anon_sym_BSLASHsim] = ACTIONS(5629),
    [anon_sym_u223c] = ACTIONS(5631),
    [anon_sym_BSLASHsimeq] = ACTIONS(5631),
    [anon_sym_u2243] = ACTIONS(5631),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5629),
    [anon_sym_u228f] = ACTIONS(5631),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5629),
    [anon_sym_u2290] = ACTIONS(5631),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5631),
    [anon_sym_u2291] = ACTIONS(5631),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5631),
    [anon_sym_u2292] = ACTIONS(5631),
    [anon_sym_BSLASHsubset] = ACTIONS(5629),
    [anon_sym_u2282] = ACTIONS(5631),
    [anon_sym_BSLASHsupset] = ACTIONS(5629),
    [anon_sym_u2283] = ACTIONS(5631),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5631),
    [anon_sym_u2286] = ACTIONS(5631),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5631),
    [anon_sym_u2287] = ACTIONS(5631),
    [sym_compose] = ACTIONS(5631),
    [sym_map_to] = ACTIONS(5631),
    [sym_map_from] = ACTIONS(5631),
    [sym_setminus] = ACTIONS(5629),
    [anon_sym_BSLASHcap] = ACTIONS(5631),
    [anon_sym_BSLASHintersect] = ACTIONS(5631),
    [anon_sym_u2229] = ACTIONS(5631),
    [anon_sym_BSLASHcup] = ACTIONS(5631),
    [anon_sym_BSLASHunion] = ACTIONS(5631),
    [anon_sym_u222a] = ACTIONS(5631),
    [anon_sym_DOT_DOT] = ACTIONS(5629),
    [anon_sym_u2025] = ACTIONS(5631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5631),
    [anon_sym_u2026] = ACTIONS(5631),
    [anon_sym_PLUS] = ACTIONS(5629),
    [sym_plusplus] = ACTIONS(5631),
    [anon_sym_BSLASHoplus] = ACTIONS(5631),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5631),
    [anon_sym_u2295] = ACTIONS(5631),
    [anon_sym_BSLASHominus] = ACTIONS(5631),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5631),
    [anon_sym_u2296] = ACTIONS(5631),
    [sym_mod] = ACTIONS(5629),
    [sym_modmod] = ACTIONS(5631),
    [sym_vert] = ACTIONS(5629),
    [anon_sym_PIPE_PIPE] = ACTIONS(5631),
    [anon_sym_u2016] = ACTIONS(5631),
    [sym_minusminus] = ACTIONS(5631),
    [sym_amp] = ACTIONS(5629),
    [sym_ampamp] = ACTIONS(5631),
    [anon_sym_BSLASHodot] = ACTIONS(5631),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5631),
    [anon_sym_u2299] = ACTIONS(5631),
    [anon_sym_BSLASHoslash] = ACTIONS(5631),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5631),
    [anon_sym_u2298] = ACTIONS(5631),
    [anon_sym_BSLASHotimes] = ACTIONS(5631),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5631),
    [anon_sym_u2297] = ACTIONS(5631),
    [sym_mul] = ACTIONS(5629),
    [sym_mulmul] = ACTIONS(5631),
    [sym_slash] = ACTIONS(5629),
    [sym_slashslash] = ACTIONS(5631),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5631),
    [anon_sym_u25ef] = ACTIONS(5631),
    [anon_sym_BSLASHbullet] = ACTIONS(5631),
    [anon_sym_u25cf] = ACTIONS(5631),
    [anon_sym_BSLASHdiv] = ACTIONS(5631),
    [anon_sym_u00f7] = ACTIONS(5631),
    [anon_sym_BSLASHcirc] = ACTIONS(5631),
    [anon_sym_u2218] = ACTIONS(5631),
    [anon_sym_BSLASHstar] = ACTIONS(5631),
    [anon_sym_u22c6] = ACTIONS(5631),
    [anon_sym_u203c] = ACTIONS(5631),
    [sym_hashhash] = ACTIONS(5631),
    [sym_dol] = ACTIONS(5629),
    [sym_doldol] = ACTIONS(5631),
    [anon_sym_QMARK_QMARK] = ACTIONS(5631),
    [anon_sym_u2047] = ACTIONS(5631),
    [anon_sym_BSLASHsqcap] = ACTIONS(5631),
    [anon_sym_u2293] = ACTIONS(5631),
    [anon_sym_BSLASHsqcup] = ACTIONS(5631),
    [anon_sym_u2294] = ACTIONS(5631),
    [anon_sym_BSLASHuplus] = ACTIONS(5631),
    [anon_sym_u228e] = ACTIONS(5631),
    [anon_sym_BSLASHX] = ACTIONS(5631),
    [anon_sym_BSLASHtimes] = ACTIONS(5631),
    [anon_sym_u00d7] = ACTIONS(5631),
    [anon_sym_BSLASHwr] = ACTIONS(5631),
    [anon_sym_u2240] = ACTIONS(5631),
    [anon_sym_BSLASHcdot] = ACTIONS(5631),
    [anon_sym_u22c5] = ACTIONS(5631),
    [sym_pow] = ACTIONS(5629),
    [sym_powpow] = ACTIONS(5631),
    [anon_sym_CARET_PLUS] = ACTIONS(5631),
    [anon_sym_u207a] = ACTIONS(5631),
    [sym_asterisk] = ACTIONS(5631),
    [sym_sup_hash] = ACTIONS(5631),
    [sym_prime] = ACTIONS(5631),
    [sym__indent] = ACTIONS(5631),
    [sym__double_excl] = ACTIONS(5631),
  },
  [2206] = {
    [sym_block_comment] = STATE(2206),
    [sym_identifier] = ACTIONS(5633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5633),
    [anon_sym_u2208] = ACTIONS(5635),
    [anon_sym_BSLASHA] = ACTIONS(5633),
    [anon_sym_BSLASHforall] = ACTIONS(5635),
    [anon_sym_u2200] = ACTIONS(5635),
    [anon_sym_BSLASHE] = ACTIONS(5633),
    [anon_sym_BSLASHexists] = ACTIONS(5635),
    [anon_sym_u2203] = ACTIONS(5635),
    [sym_temporal_forall] = ACTIONS(5635),
    [sym_temporal_exists] = ACTIONS(5635),
    [anon_sym_LT_LT] = ACTIONS(5635),
    [anon_sym_u3008] = ACTIONS(5635),
    [anon_sym_u27e8] = ACTIONS(5635),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5635),
    [anon_sym_u25a1] = ACTIONS(5635),
    [anon_sym_AT] = ACTIONS(5633),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5635),
    [anon_sym_u2227] = ACTIONS(5635),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5635),
    [anon_sym_u2228] = ACTIONS(5635),
    [anon_sym_LPAREN] = ACTIONS(5633),
    [anon_sym_LBRACK] = ACTIONS(5633),
    [aux_sym_child_id_token1] = ACTIONS(5633),
    [sym_real_number] = ACTIONS(5635),
    [anon_sym_BSLASHb] = ACTIONS(5633),
    [anon_sym_BSLASHB] = ACTIONS(5635),
    [anon_sym_BSLASHo] = ACTIONS(5633),
    [anon_sym_BSLASHO] = ACTIONS(5635),
    [anon_sym_BSLASHh] = ACTIONS(5635),
    [anon_sym_BSLASHH] = ACTIONS(5635),
    [anon_sym_DQUOTE] = ACTIONS(5635),
    [anon_sym_TRUE] = ACTIONS(5633),
    [anon_sym_FALSE] = ACTIONS(5633),
    [sym_string_set] = ACTIONS(5633),
    [sym_boolean_set] = ACTIONS(5633),
    [anon_sym_Nat] = ACTIONS(5633),
    [anon_sym_u2115] = ACTIONS(5635),
    [anon_sym_Int] = ACTIONS(5633),
    [anon_sym_u2124] = ACTIONS(5635),
    [anon_sym_Real] = ACTIONS(5633),
    [anon_sym_u211d] = ACTIONS(5635),
    [anon_sym_CHOOSE] = ACTIONS(5633),
    [anon_sym_LBRACE] = ACTIONS(5635),
    [anon_sym_EQ] = ACTIONS(5633),
    [anon_sym_WF_] = ACTIONS(5633),
    [anon_sym_SF_] = ACTIONS(5633),
    [anon_sym_IF] = ACTIONS(5633),
    [anon_sym_CASE] = ACTIONS(5633),
    [anon_sym_LET] = ACTIONS(5633),
    [anon_sym_BSLASHlnot] = ACTIONS(5635),
    [anon_sym_BSLASHneg] = ACTIONS(5635),
    [anon_sym_TILDE] = ACTIONS(5633),
    [anon_sym_u00ac] = ACTIONS(5635),
    [sym_union] = ACTIONS(5633),
    [sym_powerset] = ACTIONS(5633),
    [sym_domain] = ACTIONS(5633),
    [anon_sym_DASH] = ACTIONS(5633),
    [sym_negative_dot] = ACTIONS(5635),
    [sym_enabled] = ACTIONS(5633),
    [sym_unchanged] = ACTIONS(5633),
    [anon_sym_LT_GT] = ACTIONS(5635),
    [anon_sym_u22c4] = ACTIONS(5635),
    [anon_sym_u25c7] = ACTIONS(5635),
    [anon_sym_EQ_GT] = ACTIONS(5635),
    [anon_sym_u27f9] = ACTIONS(5635),
    [anon_sym_u21d2] = ACTIONS(5635),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5635),
    [anon_sym_u21f8] = ACTIONS(5635),
    [anon_sym_u2945] = ACTIONS(5635),
    [anon_sym_BSLASHequiv] = ACTIONS(5635),
    [anon_sym_u2261] = ACTIONS(5635),
    [anon_sym_LT_EQ_GT] = ACTIONS(5635),
    [anon_sym_u27fa] = ACTIONS(5635),
    [anon_sym_u21d4] = ACTIONS(5635),
    [anon_sym_TILDE_GT] = ACTIONS(5635),
    [anon_sym_u21dd] = ACTIONS(5635),
    [anon_sym_u219d] = ACTIONS(5635),
    [anon_sym_BSLASHland] = ACTIONS(5635),
    [anon_sym_BSLASHlor] = ACTIONS(5635),
    [anon_sym_COLON_EQ] = ACTIONS(5635),
    [anon_sym_u2254] = ACTIONS(5635),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5635),
    [anon_sym_u2a74] = ACTIONS(5635),
    [anon_sym_SLASH_EQ] = ACTIONS(5635),
    [anon_sym_POUND] = ACTIONS(5633),
    [anon_sym_u2260] = ACTIONS(5635),
    [anon_sym_LT] = ACTIONS(5633),
    [sym_gt] = ACTIONS(5633),
    [anon_sym_LT_EQ] = ACTIONS(5633),
    [anon_sym_EQ_LT] = ACTIONS(5635),
    [anon_sym_BSLASHleq] = ACTIONS(5635),
    [anon_sym_u2264] = ACTIONS(5635),
    [anon_sym_GT_EQ] = ACTIONS(5635),
    [anon_sym_BSLASHgeq] = ACTIONS(5635),
    [anon_sym_u2265] = ACTIONS(5635),
    [anon_sym_BSLASHapprox] = ACTIONS(5635),
    [anon_sym_u2248] = ACTIONS(5635),
    [anon_sym_PIPE_DASH] = ACTIONS(5635),
    [anon_sym_u22a2] = ACTIONS(5635),
    [anon_sym_PIPE_EQ] = ACTIONS(5635),
    [anon_sym_u22a8] = ACTIONS(5635),
    [anon_sym_DASH_PIPE] = ACTIONS(5635),
    [anon_sym_u22a3] = ACTIONS(5635),
    [anon_sym_EQ_PIPE] = ACTIONS(5635),
    [anon_sym_u2ae4] = ACTIONS(5635),
    [anon_sym_BSLASHasymp] = ACTIONS(5635),
    [anon_sym_u224d] = ACTIONS(5635),
    [anon_sym_BSLASHcong] = ACTIONS(5635),
    [anon_sym_u2245] = ACTIONS(5635),
    [anon_sym_BSLASHdoteq] = ACTIONS(5635),
    [anon_sym_u2250] = ACTIONS(5635),
    [anon_sym_BSLASHgg] = ACTIONS(5635),
    [anon_sym_u226b] = ACTIONS(5635),
    [anon_sym_BSLASHll] = ACTIONS(5635),
    [anon_sym_u226a] = ACTIONS(5635),
    [anon_sym_BSLASHnotin] = ACTIONS(5635),
    [anon_sym_u2209] = ACTIONS(5635),
    [anon_sym_BSLASHprec] = ACTIONS(5633),
    [anon_sym_u227a] = ACTIONS(5635),
    [anon_sym_BSLASHsucc] = ACTIONS(5633),
    [anon_sym_u227b] = ACTIONS(5635),
    [anon_sym_BSLASHpreceq] = ACTIONS(5635),
    [anon_sym_u2aaf] = ACTIONS(5635),
    [anon_sym_BSLASHsucceq] = ACTIONS(5635),
    [anon_sym_u2ab0] = ACTIONS(5635),
    [anon_sym_BSLASHpropto] = ACTIONS(5635),
    [anon_sym_u221d] = ACTIONS(5635),
    [anon_sym_BSLASHsim] = ACTIONS(5633),
    [anon_sym_u223c] = ACTIONS(5635),
    [anon_sym_BSLASHsimeq] = ACTIONS(5635),
    [anon_sym_u2243] = ACTIONS(5635),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5633),
    [anon_sym_u228f] = ACTIONS(5635),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5633),
    [anon_sym_u2290] = ACTIONS(5635),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5635),
    [anon_sym_u2291] = ACTIONS(5635),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5635),
    [anon_sym_u2292] = ACTIONS(5635),
    [anon_sym_BSLASHsubset] = ACTIONS(5633),
    [anon_sym_u2282] = ACTIONS(5635),
    [anon_sym_BSLASHsupset] = ACTIONS(5633),
    [anon_sym_u2283] = ACTIONS(5635),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5635),
    [anon_sym_u2286] = ACTIONS(5635),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5635),
    [anon_sym_u2287] = ACTIONS(5635),
    [sym_compose] = ACTIONS(5635),
    [sym_map_to] = ACTIONS(5635),
    [sym_map_from] = ACTIONS(5635),
    [sym_setminus] = ACTIONS(5633),
    [anon_sym_BSLASHcap] = ACTIONS(5635),
    [anon_sym_BSLASHintersect] = ACTIONS(5635),
    [anon_sym_u2229] = ACTIONS(5635),
    [anon_sym_BSLASHcup] = ACTIONS(5635),
    [anon_sym_BSLASHunion] = ACTIONS(5635),
    [anon_sym_u222a] = ACTIONS(5635),
    [anon_sym_DOT_DOT] = ACTIONS(5633),
    [anon_sym_u2025] = ACTIONS(5635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5635),
    [anon_sym_u2026] = ACTIONS(5635),
    [anon_sym_PLUS] = ACTIONS(5633),
    [sym_plusplus] = ACTIONS(5635),
    [anon_sym_BSLASHoplus] = ACTIONS(5635),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5635),
    [anon_sym_u2295] = ACTIONS(5635),
    [anon_sym_BSLASHominus] = ACTIONS(5635),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5635),
    [anon_sym_u2296] = ACTIONS(5635),
    [sym_mod] = ACTIONS(5633),
    [sym_modmod] = ACTIONS(5635),
    [sym_vert] = ACTIONS(5633),
    [anon_sym_PIPE_PIPE] = ACTIONS(5635),
    [anon_sym_u2016] = ACTIONS(5635),
    [sym_minusminus] = ACTIONS(5635),
    [sym_amp] = ACTIONS(5633),
    [sym_ampamp] = ACTIONS(5635),
    [anon_sym_BSLASHodot] = ACTIONS(5635),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5635),
    [anon_sym_u2299] = ACTIONS(5635),
    [anon_sym_BSLASHoslash] = ACTIONS(5635),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5635),
    [anon_sym_u2298] = ACTIONS(5635),
    [anon_sym_BSLASHotimes] = ACTIONS(5635),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5635),
    [anon_sym_u2297] = ACTIONS(5635),
    [sym_mul] = ACTIONS(5633),
    [sym_mulmul] = ACTIONS(5635),
    [sym_slash] = ACTIONS(5633),
    [sym_slashslash] = ACTIONS(5635),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5635),
    [anon_sym_u25ef] = ACTIONS(5635),
    [anon_sym_BSLASHbullet] = ACTIONS(5635),
    [anon_sym_u25cf] = ACTIONS(5635),
    [anon_sym_BSLASHdiv] = ACTIONS(5635),
    [anon_sym_u00f7] = ACTIONS(5635),
    [anon_sym_BSLASHcirc] = ACTIONS(5635),
    [anon_sym_u2218] = ACTIONS(5635),
    [anon_sym_BSLASHstar] = ACTIONS(5635),
    [anon_sym_u22c6] = ACTIONS(5635),
    [anon_sym_u203c] = ACTIONS(5635),
    [sym_hashhash] = ACTIONS(5635),
    [sym_dol] = ACTIONS(5633),
    [sym_doldol] = ACTIONS(5635),
    [anon_sym_QMARK_QMARK] = ACTIONS(5635),
    [anon_sym_u2047] = ACTIONS(5635),
    [anon_sym_BSLASHsqcap] = ACTIONS(5635),
    [anon_sym_u2293] = ACTIONS(5635),
    [anon_sym_BSLASHsqcup] = ACTIONS(5635),
    [anon_sym_u2294] = ACTIONS(5635),
    [anon_sym_BSLASHuplus] = ACTIONS(5635),
    [anon_sym_u228e] = ACTIONS(5635),
    [anon_sym_BSLASHX] = ACTIONS(5635),
    [anon_sym_BSLASHtimes] = ACTIONS(5635),
    [anon_sym_u00d7] = ACTIONS(5635),
    [anon_sym_BSLASHwr] = ACTIONS(5635),
    [anon_sym_u2240] = ACTIONS(5635),
    [anon_sym_BSLASHcdot] = ACTIONS(5635),
    [anon_sym_u22c5] = ACTIONS(5635),
    [sym_pow] = ACTIONS(5633),
    [sym_powpow] = ACTIONS(5635),
    [anon_sym_CARET_PLUS] = ACTIONS(5635),
    [anon_sym_u207a] = ACTIONS(5635),
    [sym_asterisk] = ACTIONS(5635),
    [sym_sup_hash] = ACTIONS(5635),
    [sym_prime] = ACTIONS(5635),
    [sym__indent] = ACTIONS(5635),
    [sym__double_excl] = ACTIONS(5635),
  },
  [2207] = {
    [sym_block_comment] = STATE(2207),
    [sym_identifier] = ACTIONS(5637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5637),
    [anon_sym_u2208] = ACTIONS(5639),
    [anon_sym_BSLASHA] = ACTIONS(5637),
    [anon_sym_BSLASHforall] = ACTIONS(5639),
    [anon_sym_u2200] = ACTIONS(5639),
    [anon_sym_BSLASHE] = ACTIONS(5637),
    [anon_sym_BSLASHexists] = ACTIONS(5639),
    [anon_sym_u2203] = ACTIONS(5639),
    [sym_temporal_forall] = ACTIONS(5639),
    [sym_temporal_exists] = ACTIONS(5639),
    [anon_sym_LT_LT] = ACTIONS(5639),
    [anon_sym_u3008] = ACTIONS(5639),
    [anon_sym_u27e8] = ACTIONS(5639),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5639),
    [anon_sym_u25a1] = ACTIONS(5639),
    [anon_sym_AT] = ACTIONS(5637),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5639),
    [anon_sym_u2227] = ACTIONS(5639),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5639),
    [anon_sym_u2228] = ACTIONS(5639),
    [anon_sym_LPAREN] = ACTIONS(5637),
    [anon_sym_LBRACK] = ACTIONS(5637),
    [aux_sym_child_id_token1] = ACTIONS(5637),
    [sym_real_number] = ACTIONS(5639),
    [anon_sym_BSLASHb] = ACTIONS(5637),
    [anon_sym_BSLASHB] = ACTIONS(5639),
    [anon_sym_BSLASHo] = ACTIONS(5637),
    [anon_sym_BSLASHO] = ACTIONS(5639),
    [anon_sym_BSLASHh] = ACTIONS(5639),
    [anon_sym_BSLASHH] = ACTIONS(5639),
    [anon_sym_DQUOTE] = ACTIONS(5639),
    [anon_sym_TRUE] = ACTIONS(5637),
    [anon_sym_FALSE] = ACTIONS(5637),
    [sym_string_set] = ACTIONS(5637),
    [sym_boolean_set] = ACTIONS(5637),
    [anon_sym_Nat] = ACTIONS(5637),
    [anon_sym_u2115] = ACTIONS(5639),
    [anon_sym_Int] = ACTIONS(5637),
    [anon_sym_u2124] = ACTIONS(5639),
    [anon_sym_Real] = ACTIONS(5637),
    [anon_sym_u211d] = ACTIONS(5639),
    [anon_sym_CHOOSE] = ACTIONS(5637),
    [anon_sym_LBRACE] = ACTIONS(5639),
    [anon_sym_EQ] = ACTIONS(5637),
    [anon_sym_WF_] = ACTIONS(5637),
    [anon_sym_SF_] = ACTIONS(5637),
    [anon_sym_IF] = ACTIONS(5637),
    [anon_sym_CASE] = ACTIONS(5637),
    [anon_sym_LET] = ACTIONS(5637),
    [anon_sym_BSLASHlnot] = ACTIONS(5639),
    [anon_sym_BSLASHneg] = ACTIONS(5639),
    [anon_sym_TILDE] = ACTIONS(5637),
    [anon_sym_u00ac] = ACTIONS(5639),
    [sym_union] = ACTIONS(5637),
    [sym_powerset] = ACTIONS(5637),
    [sym_domain] = ACTIONS(5637),
    [anon_sym_DASH] = ACTIONS(5637),
    [sym_negative_dot] = ACTIONS(5639),
    [sym_enabled] = ACTIONS(5637),
    [sym_unchanged] = ACTIONS(5637),
    [anon_sym_LT_GT] = ACTIONS(5639),
    [anon_sym_u22c4] = ACTIONS(5639),
    [anon_sym_u25c7] = ACTIONS(5639),
    [anon_sym_EQ_GT] = ACTIONS(5639),
    [anon_sym_u27f9] = ACTIONS(5639),
    [anon_sym_u21d2] = ACTIONS(5639),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5639),
    [anon_sym_u21f8] = ACTIONS(5639),
    [anon_sym_u2945] = ACTIONS(5639),
    [anon_sym_BSLASHequiv] = ACTIONS(5639),
    [anon_sym_u2261] = ACTIONS(5639),
    [anon_sym_LT_EQ_GT] = ACTIONS(5639),
    [anon_sym_u27fa] = ACTIONS(5639),
    [anon_sym_u21d4] = ACTIONS(5639),
    [anon_sym_TILDE_GT] = ACTIONS(5639),
    [anon_sym_u21dd] = ACTIONS(5639),
    [anon_sym_u219d] = ACTIONS(5639),
    [anon_sym_BSLASHland] = ACTIONS(5639),
    [anon_sym_BSLASHlor] = ACTIONS(5639),
    [anon_sym_COLON_EQ] = ACTIONS(5639),
    [anon_sym_u2254] = ACTIONS(5639),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5639),
    [anon_sym_u2a74] = ACTIONS(5639),
    [anon_sym_SLASH_EQ] = ACTIONS(5639),
    [anon_sym_POUND] = ACTIONS(5637),
    [anon_sym_u2260] = ACTIONS(5639),
    [anon_sym_LT] = ACTIONS(5637),
    [sym_gt] = ACTIONS(5637),
    [anon_sym_LT_EQ] = ACTIONS(5637),
    [anon_sym_EQ_LT] = ACTIONS(5639),
    [anon_sym_BSLASHleq] = ACTIONS(5639),
    [anon_sym_u2264] = ACTIONS(5639),
    [anon_sym_GT_EQ] = ACTIONS(5639),
    [anon_sym_BSLASHgeq] = ACTIONS(5639),
    [anon_sym_u2265] = ACTIONS(5639),
    [anon_sym_BSLASHapprox] = ACTIONS(5639),
    [anon_sym_u2248] = ACTIONS(5639),
    [anon_sym_PIPE_DASH] = ACTIONS(5639),
    [anon_sym_u22a2] = ACTIONS(5639),
    [anon_sym_PIPE_EQ] = ACTIONS(5639),
    [anon_sym_u22a8] = ACTIONS(5639),
    [anon_sym_DASH_PIPE] = ACTIONS(5639),
    [anon_sym_u22a3] = ACTIONS(5639),
    [anon_sym_EQ_PIPE] = ACTIONS(5639),
    [anon_sym_u2ae4] = ACTIONS(5639),
    [anon_sym_BSLASHasymp] = ACTIONS(5639),
    [anon_sym_u224d] = ACTIONS(5639),
    [anon_sym_BSLASHcong] = ACTIONS(5639),
    [anon_sym_u2245] = ACTIONS(5639),
    [anon_sym_BSLASHdoteq] = ACTIONS(5639),
    [anon_sym_u2250] = ACTIONS(5639),
    [anon_sym_BSLASHgg] = ACTIONS(5639),
    [anon_sym_u226b] = ACTIONS(5639),
    [anon_sym_BSLASHll] = ACTIONS(5639),
    [anon_sym_u226a] = ACTIONS(5639),
    [anon_sym_BSLASHnotin] = ACTIONS(5639),
    [anon_sym_u2209] = ACTIONS(5639),
    [anon_sym_BSLASHprec] = ACTIONS(5637),
    [anon_sym_u227a] = ACTIONS(5639),
    [anon_sym_BSLASHsucc] = ACTIONS(5637),
    [anon_sym_u227b] = ACTIONS(5639),
    [anon_sym_BSLASHpreceq] = ACTIONS(5639),
    [anon_sym_u2aaf] = ACTIONS(5639),
    [anon_sym_BSLASHsucceq] = ACTIONS(5639),
    [anon_sym_u2ab0] = ACTIONS(5639),
    [anon_sym_BSLASHpropto] = ACTIONS(5639),
    [anon_sym_u221d] = ACTIONS(5639),
    [anon_sym_BSLASHsim] = ACTIONS(5637),
    [anon_sym_u223c] = ACTIONS(5639),
    [anon_sym_BSLASHsimeq] = ACTIONS(5639),
    [anon_sym_u2243] = ACTIONS(5639),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5637),
    [anon_sym_u228f] = ACTIONS(5639),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5637),
    [anon_sym_u2290] = ACTIONS(5639),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5639),
    [anon_sym_u2291] = ACTIONS(5639),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5639),
    [anon_sym_u2292] = ACTIONS(5639),
    [anon_sym_BSLASHsubset] = ACTIONS(5637),
    [anon_sym_u2282] = ACTIONS(5639),
    [anon_sym_BSLASHsupset] = ACTIONS(5637),
    [anon_sym_u2283] = ACTIONS(5639),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5639),
    [anon_sym_u2286] = ACTIONS(5639),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5639),
    [anon_sym_u2287] = ACTIONS(5639),
    [sym_compose] = ACTIONS(5639),
    [sym_map_to] = ACTIONS(5639),
    [sym_map_from] = ACTIONS(5639),
    [sym_setminus] = ACTIONS(5637),
    [anon_sym_BSLASHcap] = ACTIONS(5639),
    [anon_sym_BSLASHintersect] = ACTIONS(5639),
    [anon_sym_u2229] = ACTIONS(5639),
    [anon_sym_BSLASHcup] = ACTIONS(5639),
    [anon_sym_BSLASHunion] = ACTIONS(5639),
    [anon_sym_u222a] = ACTIONS(5639),
    [anon_sym_DOT_DOT] = ACTIONS(5637),
    [anon_sym_u2025] = ACTIONS(5639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5639),
    [anon_sym_u2026] = ACTIONS(5639),
    [anon_sym_PLUS] = ACTIONS(5637),
    [sym_plusplus] = ACTIONS(5639),
    [anon_sym_BSLASHoplus] = ACTIONS(5639),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5639),
    [anon_sym_u2295] = ACTIONS(5639),
    [anon_sym_BSLASHominus] = ACTIONS(5639),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5639),
    [anon_sym_u2296] = ACTIONS(5639),
    [sym_mod] = ACTIONS(5637),
    [sym_modmod] = ACTIONS(5639),
    [sym_vert] = ACTIONS(5637),
    [anon_sym_PIPE_PIPE] = ACTIONS(5639),
    [anon_sym_u2016] = ACTIONS(5639),
    [sym_minusminus] = ACTIONS(5639),
    [sym_amp] = ACTIONS(5637),
    [sym_ampamp] = ACTIONS(5639),
    [anon_sym_BSLASHodot] = ACTIONS(5639),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5639),
    [anon_sym_u2299] = ACTIONS(5639),
    [anon_sym_BSLASHoslash] = ACTIONS(5639),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5639),
    [anon_sym_u2298] = ACTIONS(5639),
    [anon_sym_BSLASHotimes] = ACTIONS(5639),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5639),
    [anon_sym_u2297] = ACTIONS(5639),
    [sym_mul] = ACTIONS(5637),
    [sym_mulmul] = ACTIONS(5639),
    [sym_slash] = ACTIONS(5637),
    [sym_slashslash] = ACTIONS(5639),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5639),
    [anon_sym_u25ef] = ACTIONS(5639),
    [anon_sym_BSLASHbullet] = ACTIONS(5639),
    [anon_sym_u25cf] = ACTIONS(5639),
    [anon_sym_BSLASHdiv] = ACTIONS(5639),
    [anon_sym_u00f7] = ACTIONS(5639),
    [anon_sym_BSLASHcirc] = ACTIONS(5639),
    [anon_sym_u2218] = ACTIONS(5639),
    [anon_sym_BSLASHstar] = ACTIONS(5639),
    [anon_sym_u22c6] = ACTIONS(5639),
    [anon_sym_u203c] = ACTIONS(5639),
    [sym_hashhash] = ACTIONS(5639),
    [sym_dol] = ACTIONS(5637),
    [sym_doldol] = ACTIONS(5639),
    [anon_sym_QMARK_QMARK] = ACTIONS(5639),
    [anon_sym_u2047] = ACTIONS(5639),
    [anon_sym_BSLASHsqcap] = ACTIONS(5639),
    [anon_sym_u2293] = ACTIONS(5639),
    [anon_sym_BSLASHsqcup] = ACTIONS(5639),
    [anon_sym_u2294] = ACTIONS(5639),
    [anon_sym_BSLASHuplus] = ACTIONS(5639),
    [anon_sym_u228e] = ACTIONS(5639),
    [anon_sym_BSLASHX] = ACTIONS(5639),
    [anon_sym_BSLASHtimes] = ACTIONS(5639),
    [anon_sym_u00d7] = ACTIONS(5639),
    [anon_sym_BSLASHwr] = ACTIONS(5639),
    [anon_sym_u2240] = ACTIONS(5639),
    [anon_sym_BSLASHcdot] = ACTIONS(5639),
    [anon_sym_u22c5] = ACTIONS(5639),
    [sym_pow] = ACTIONS(5637),
    [sym_powpow] = ACTIONS(5639),
    [anon_sym_CARET_PLUS] = ACTIONS(5639),
    [anon_sym_u207a] = ACTIONS(5639),
    [sym_asterisk] = ACTIONS(5639),
    [sym_sup_hash] = ACTIONS(5639),
    [sym_prime] = ACTIONS(5639),
    [sym__indent] = ACTIONS(5639),
    [sym__double_excl] = ACTIONS(5639),
  },
  [2208] = {
    [sym_block_comment] = STATE(2208),
    [sym_identifier] = ACTIONS(5641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5641),
    [anon_sym_u2208] = ACTIONS(5643),
    [anon_sym_BSLASHA] = ACTIONS(5641),
    [anon_sym_BSLASHforall] = ACTIONS(5643),
    [anon_sym_u2200] = ACTIONS(5643),
    [anon_sym_BSLASHE] = ACTIONS(5641),
    [anon_sym_BSLASHexists] = ACTIONS(5643),
    [anon_sym_u2203] = ACTIONS(5643),
    [sym_temporal_forall] = ACTIONS(5643),
    [sym_temporal_exists] = ACTIONS(5643),
    [anon_sym_LT_LT] = ACTIONS(5643),
    [anon_sym_u3008] = ACTIONS(5643),
    [anon_sym_u27e8] = ACTIONS(5643),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5643),
    [anon_sym_u25a1] = ACTIONS(5643),
    [anon_sym_AT] = ACTIONS(5641),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5643),
    [anon_sym_u2227] = ACTIONS(5643),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5643),
    [anon_sym_u2228] = ACTIONS(5643),
    [anon_sym_LPAREN] = ACTIONS(5641),
    [anon_sym_LBRACK] = ACTIONS(5641),
    [aux_sym_child_id_token1] = ACTIONS(5641),
    [sym_real_number] = ACTIONS(5643),
    [anon_sym_BSLASHb] = ACTIONS(5641),
    [anon_sym_BSLASHB] = ACTIONS(5643),
    [anon_sym_BSLASHo] = ACTIONS(5641),
    [anon_sym_BSLASHO] = ACTIONS(5643),
    [anon_sym_BSLASHh] = ACTIONS(5643),
    [anon_sym_BSLASHH] = ACTIONS(5643),
    [anon_sym_DQUOTE] = ACTIONS(5643),
    [anon_sym_TRUE] = ACTIONS(5641),
    [anon_sym_FALSE] = ACTIONS(5641),
    [sym_string_set] = ACTIONS(5641),
    [sym_boolean_set] = ACTIONS(5641),
    [anon_sym_Nat] = ACTIONS(5641),
    [anon_sym_u2115] = ACTIONS(5643),
    [anon_sym_Int] = ACTIONS(5641),
    [anon_sym_u2124] = ACTIONS(5643),
    [anon_sym_Real] = ACTIONS(5641),
    [anon_sym_u211d] = ACTIONS(5643),
    [anon_sym_CHOOSE] = ACTIONS(5641),
    [anon_sym_LBRACE] = ACTIONS(5643),
    [anon_sym_EQ] = ACTIONS(5641),
    [anon_sym_WF_] = ACTIONS(5641),
    [anon_sym_SF_] = ACTIONS(5641),
    [anon_sym_IF] = ACTIONS(5641),
    [anon_sym_CASE] = ACTIONS(5641),
    [anon_sym_LET] = ACTIONS(5641),
    [anon_sym_BSLASHlnot] = ACTIONS(5643),
    [anon_sym_BSLASHneg] = ACTIONS(5643),
    [anon_sym_TILDE] = ACTIONS(5641),
    [anon_sym_u00ac] = ACTIONS(5643),
    [sym_union] = ACTIONS(5641),
    [sym_powerset] = ACTIONS(5641),
    [sym_domain] = ACTIONS(5641),
    [anon_sym_DASH] = ACTIONS(5641),
    [sym_negative_dot] = ACTIONS(5643),
    [sym_enabled] = ACTIONS(5641),
    [sym_unchanged] = ACTIONS(5641),
    [anon_sym_LT_GT] = ACTIONS(5643),
    [anon_sym_u22c4] = ACTIONS(5643),
    [anon_sym_u25c7] = ACTIONS(5643),
    [anon_sym_EQ_GT] = ACTIONS(5643),
    [anon_sym_u27f9] = ACTIONS(5643),
    [anon_sym_u21d2] = ACTIONS(5643),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5643),
    [anon_sym_u21f8] = ACTIONS(5643),
    [anon_sym_u2945] = ACTIONS(5643),
    [anon_sym_BSLASHequiv] = ACTIONS(5643),
    [anon_sym_u2261] = ACTIONS(5643),
    [anon_sym_LT_EQ_GT] = ACTIONS(5643),
    [anon_sym_u27fa] = ACTIONS(5643),
    [anon_sym_u21d4] = ACTIONS(5643),
    [anon_sym_TILDE_GT] = ACTIONS(5643),
    [anon_sym_u21dd] = ACTIONS(5643),
    [anon_sym_u219d] = ACTIONS(5643),
    [anon_sym_BSLASHland] = ACTIONS(5643),
    [anon_sym_BSLASHlor] = ACTIONS(5643),
    [anon_sym_COLON_EQ] = ACTIONS(5643),
    [anon_sym_u2254] = ACTIONS(5643),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5643),
    [anon_sym_u2a74] = ACTIONS(5643),
    [anon_sym_SLASH_EQ] = ACTIONS(5643),
    [anon_sym_POUND] = ACTIONS(5641),
    [anon_sym_u2260] = ACTIONS(5643),
    [anon_sym_LT] = ACTIONS(5641),
    [sym_gt] = ACTIONS(5641),
    [anon_sym_LT_EQ] = ACTIONS(5641),
    [anon_sym_EQ_LT] = ACTIONS(5643),
    [anon_sym_BSLASHleq] = ACTIONS(5643),
    [anon_sym_u2264] = ACTIONS(5643),
    [anon_sym_GT_EQ] = ACTIONS(5643),
    [anon_sym_BSLASHgeq] = ACTIONS(5643),
    [anon_sym_u2265] = ACTIONS(5643),
    [anon_sym_BSLASHapprox] = ACTIONS(5643),
    [anon_sym_u2248] = ACTIONS(5643),
    [anon_sym_PIPE_DASH] = ACTIONS(5643),
    [anon_sym_u22a2] = ACTIONS(5643),
    [anon_sym_PIPE_EQ] = ACTIONS(5643),
    [anon_sym_u22a8] = ACTIONS(5643),
    [anon_sym_DASH_PIPE] = ACTIONS(5643),
    [anon_sym_u22a3] = ACTIONS(5643),
    [anon_sym_EQ_PIPE] = ACTIONS(5643),
    [anon_sym_u2ae4] = ACTIONS(5643),
    [anon_sym_BSLASHasymp] = ACTIONS(5643),
    [anon_sym_u224d] = ACTIONS(5643),
    [anon_sym_BSLASHcong] = ACTIONS(5643),
    [anon_sym_u2245] = ACTIONS(5643),
    [anon_sym_BSLASHdoteq] = ACTIONS(5643),
    [anon_sym_u2250] = ACTIONS(5643),
    [anon_sym_BSLASHgg] = ACTIONS(5643),
    [anon_sym_u226b] = ACTIONS(5643),
    [anon_sym_BSLASHll] = ACTIONS(5643),
    [anon_sym_u226a] = ACTIONS(5643),
    [anon_sym_BSLASHnotin] = ACTIONS(5643),
    [anon_sym_u2209] = ACTIONS(5643),
    [anon_sym_BSLASHprec] = ACTIONS(5641),
    [anon_sym_u227a] = ACTIONS(5643),
    [anon_sym_BSLASHsucc] = ACTIONS(5641),
    [anon_sym_u227b] = ACTIONS(5643),
    [anon_sym_BSLASHpreceq] = ACTIONS(5643),
    [anon_sym_u2aaf] = ACTIONS(5643),
    [anon_sym_BSLASHsucceq] = ACTIONS(5643),
    [anon_sym_u2ab0] = ACTIONS(5643),
    [anon_sym_BSLASHpropto] = ACTIONS(5643),
    [anon_sym_u221d] = ACTIONS(5643),
    [anon_sym_BSLASHsim] = ACTIONS(5641),
    [anon_sym_u223c] = ACTIONS(5643),
    [anon_sym_BSLASHsimeq] = ACTIONS(5643),
    [anon_sym_u2243] = ACTIONS(5643),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5641),
    [anon_sym_u228f] = ACTIONS(5643),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5641),
    [anon_sym_u2290] = ACTIONS(5643),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5643),
    [anon_sym_u2291] = ACTIONS(5643),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5643),
    [anon_sym_u2292] = ACTIONS(5643),
    [anon_sym_BSLASHsubset] = ACTIONS(5641),
    [anon_sym_u2282] = ACTIONS(5643),
    [anon_sym_BSLASHsupset] = ACTIONS(5641),
    [anon_sym_u2283] = ACTIONS(5643),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5643),
    [anon_sym_u2286] = ACTIONS(5643),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5643),
    [anon_sym_u2287] = ACTIONS(5643),
    [sym_compose] = ACTIONS(5643),
    [sym_map_to] = ACTIONS(5643),
    [sym_map_from] = ACTIONS(5643),
    [sym_setminus] = ACTIONS(5641),
    [anon_sym_BSLASHcap] = ACTIONS(5643),
    [anon_sym_BSLASHintersect] = ACTIONS(5643),
    [anon_sym_u2229] = ACTIONS(5643),
    [anon_sym_BSLASHcup] = ACTIONS(5643),
    [anon_sym_BSLASHunion] = ACTIONS(5643),
    [anon_sym_u222a] = ACTIONS(5643),
    [anon_sym_DOT_DOT] = ACTIONS(5641),
    [anon_sym_u2025] = ACTIONS(5643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5643),
    [anon_sym_u2026] = ACTIONS(5643),
    [anon_sym_PLUS] = ACTIONS(5641),
    [sym_plusplus] = ACTIONS(5643),
    [anon_sym_BSLASHoplus] = ACTIONS(5643),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5643),
    [anon_sym_u2295] = ACTIONS(5643),
    [anon_sym_BSLASHominus] = ACTIONS(5643),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5643),
    [anon_sym_u2296] = ACTIONS(5643),
    [sym_mod] = ACTIONS(5641),
    [sym_modmod] = ACTIONS(5643),
    [sym_vert] = ACTIONS(5641),
    [anon_sym_PIPE_PIPE] = ACTIONS(5643),
    [anon_sym_u2016] = ACTIONS(5643),
    [sym_minusminus] = ACTIONS(5643),
    [sym_amp] = ACTIONS(5641),
    [sym_ampamp] = ACTIONS(5643),
    [anon_sym_BSLASHodot] = ACTIONS(5643),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5643),
    [anon_sym_u2299] = ACTIONS(5643),
    [anon_sym_BSLASHoslash] = ACTIONS(5643),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5643),
    [anon_sym_u2298] = ACTIONS(5643),
    [anon_sym_BSLASHotimes] = ACTIONS(5643),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5643),
    [anon_sym_u2297] = ACTIONS(5643),
    [sym_mul] = ACTIONS(5641),
    [sym_mulmul] = ACTIONS(5643),
    [sym_slash] = ACTIONS(5641),
    [sym_slashslash] = ACTIONS(5643),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5643),
    [anon_sym_u25ef] = ACTIONS(5643),
    [anon_sym_BSLASHbullet] = ACTIONS(5643),
    [anon_sym_u25cf] = ACTIONS(5643),
    [anon_sym_BSLASHdiv] = ACTIONS(5643),
    [anon_sym_u00f7] = ACTIONS(5643),
    [anon_sym_BSLASHcirc] = ACTIONS(5643),
    [anon_sym_u2218] = ACTIONS(5643),
    [anon_sym_BSLASHstar] = ACTIONS(5643),
    [anon_sym_u22c6] = ACTIONS(5643),
    [anon_sym_u203c] = ACTIONS(5643),
    [sym_hashhash] = ACTIONS(5643),
    [sym_dol] = ACTIONS(5641),
    [sym_doldol] = ACTIONS(5643),
    [anon_sym_QMARK_QMARK] = ACTIONS(5643),
    [anon_sym_u2047] = ACTIONS(5643),
    [anon_sym_BSLASHsqcap] = ACTIONS(5643),
    [anon_sym_u2293] = ACTIONS(5643),
    [anon_sym_BSLASHsqcup] = ACTIONS(5643),
    [anon_sym_u2294] = ACTIONS(5643),
    [anon_sym_BSLASHuplus] = ACTIONS(5643),
    [anon_sym_u228e] = ACTIONS(5643),
    [anon_sym_BSLASHX] = ACTIONS(5643),
    [anon_sym_BSLASHtimes] = ACTIONS(5643),
    [anon_sym_u00d7] = ACTIONS(5643),
    [anon_sym_BSLASHwr] = ACTIONS(5643),
    [anon_sym_u2240] = ACTIONS(5643),
    [anon_sym_BSLASHcdot] = ACTIONS(5643),
    [anon_sym_u22c5] = ACTIONS(5643),
    [sym_pow] = ACTIONS(5641),
    [sym_powpow] = ACTIONS(5643),
    [anon_sym_CARET_PLUS] = ACTIONS(5643),
    [anon_sym_u207a] = ACTIONS(5643),
    [sym_asterisk] = ACTIONS(5643),
    [sym_sup_hash] = ACTIONS(5643),
    [sym_prime] = ACTIONS(5643),
    [sym__indent] = ACTIONS(5643),
    [sym__double_excl] = ACTIONS(5643),
  },
  [2209] = {
    [sym_block_comment] = STATE(2209),
    [sym_identifier] = ACTIONS(5645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5645),
    [anon_sym_u2208] = ACTIONS(5647),
    [anon_sym_BSLASHA] = ACTIONS(5645),
    [anon_sym_BSLASHforall] = ACTIONS(5647),
    [anon_sym_u2200] = ACTIONS(5647),
    [anon_sym_BSLASHE] = ACTIONS(5645),
    [anon_sym_BSLASHexists] = ACTIONS(5647),
    [anon_sym_u2203] = ACTIONS(5647),
    [sym_temporal_forall] = ACTIONS(5647),
    [sym_temporal_exists] = ACTIONS(5647),
    [anon_sym_LT_LT] = ACTIONS(5647),
    [anon_sym_u3008] = ACTIONS(5647),
    [anon_sym_u27e8] = ACTIONS(5647),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5647),
    [anon_sym_u25a1] = ACTIONS(5647),
    [anon_sym_AT] = ACTIONS(5645),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5647),
    [anon_sym_u2227] = ACTIONS(5647),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5647),
    [anon_sym_u2228] = ACTIONS(5647),
    [anon_sym_LPAREN] = ACTIONS(5645),
    [anon_sym_LBRACK] = ACTIONS(5645),
    [aux_sym_child_id_token1] = ACTIONS(5645),
    [sym_real_number] = ACTIONS(5647),
    [anon_sym_BSLASHb] = ACTIONS(5645),
    [anon_sym_BSLASHB] = ACTIONS(5647),
    [anon_sym_BSLASHo] = ACTIONS(5645),
    [anon_sym_BSLASHO] = ACTIONS(5647),
    [anon_sym_BSLASHh] = ACTIONS(5647),
    [anon_sym_BSLASHH] = ACTIONS(5647),
    [anon_sym_DQUOTE] = ACTIONS(5647),
    [anon_sym_TRUE] = ACTIONS(5645),
    [anon_sym_FALSE] = ACTIONS(5645),
    [sym_string_set] = ACTIONS(5645),
    [sym_boolean_set] = ACTIONS(5645),
    [anon_sym_Nat] = ACTIONS(5645),
    [anon_sym_u2115] = ACTIONS(5647),
    [anon_sym_Int] = ACTIONS(5645),
    [anon_sym_u2124] = ACTIONS(5647),
    [anon_sym_Real] = ACTIONS(5645),
    [anon_sym_u211d] = ACTIONS(5647),
    [anon_sym_CHOOSE] = ACTIONS(5645),
    [anon_sym_LBRACE] = ACTIONS(5647),
    [anon_sym_EQ] = ACTIONS(5645),
    [anon_sym_WF_] = ACTIONS(5645),
    [anon_sym_SF_] = ACTIONS(5645),
    [anon_sym_IF] = ACTIONS(5645),
    [anon_sym_CASE] = ACTIONS(5645),
    [anon_sym_LET] = ACTIONS(5645),
    [anon_sym_BSLASHlnot] = ACTIONS(5647),
    [anon_sym_BSLASHneg] = ACTIONS(5647),
    [anon_sym_TILDE] = ACTIONS(5645),
    [anon_sym_u00ac] = ACTIONS(5647),
    [sym_union] = ACTIONS(5645),
    [sym_powerset] = ACTIONS(5645),
    [sym_domain] = ACTIONS(5645),
    [anon_sym_DASH] = ACTIONS(5645),
    [sym_negative_dot] = ACTIONS(5647),
    [sym_enabled] = ACTIONS(5645),
    [sym_unchanged] = ACTIONS(5645),
    [anon_sym_LT_GT] = ACTIONS(5647),
    [anon_sym_u22c4] = ACTIONS(5647),
    [anon_sym_u25c7] = ACTIONS(5647),
    [anon_sym_EQ_GT] = ACTIONS(5647),
    [anon_sym_u27f9] = ACTIONS(5647),
    [anon_sym_u21d2] = ACTIONS(5647),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5647),
    [anon_sym_u21f8] = ACTIONS(5647),
    [anon_sym_u2945] = ACTIONS(5647),
    [anon_sym_BSLASHequiv] = ACTIONS(5647),
    [anon_sym_u2261] = ACTIONS(5647),
    [anon_sym_LT_EQ_GT] = ACTIONS(5647),
    [anon_sym_u27fa] = ACTIONS(5647),
    [anon_sym_u21d4] = ACTIONS(5647),
    [anon_sym_TILDE_GT] = ACTIONS(5647),
    [anon_sym_u21dd] = ACTIONS(5647),
    [anon_sym_u219d] = ACTIONS(5647),
    [anon_sym_BSLASHland] = ACTIONS(5647),
    [anon_sym_BSLASHlor] = ACTIONS(5647),
    [anon_sym_COLON_EQ] = ACTIONS(5647),
    [anon_sym_u2254] = ACTIONS(5647),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5647),
    [anon_sym_u2a74] = ACTIONS(5647),
    [anon_sym_SLASH_EQ] = ACTIONS(5647),
    [anon_sym_POUND] = ACTIONS(5645),
    [anon_sym_u2260] = ACTIONS(5647),
    [anon_sym_LT] = ACTIONS(5645),
    [sym_gt] = ACTIONS(5645),
    [anon_sym_LT_EQ] = ACTIONS(5645),
    [anon_sym_EQ_LT] = ACTIONS(5647),
    [anon_sym_BSLASHleq] = ACTIONS(5647),
    [anon_sym_u2264] = ACTIONS(5647),
    [anon_sym_GT_EQ] = ACTIONS(5647),
    [anon_sym_BSLASHgeq] = ACTIONS(5647),
    [anon_sym_u2265] = ACTIONS(5647),
    [anon_sym_BSLASHapprox] = ACTIONS(5647),
    [anon_sym_u2248] = ACTIONS(5647),
    [anon_sym_PIPE_DASH] = ACTIONS(5647),
    [anon_sym_u22a2] = ACTIONS(5647),
    [anon_sym_PIPE_EQ] = ACTIONS(5647),
    [anon_sym_u22a8] = ACTIONS(5647),
    [anon_sym_DASH_PIPE] = ACTIONS(5647),
    [anon_sym_u22a3] = ACTIONS(5647),
    [anon_sym_EQ_PIPE] = ACTIONS(5647),
    [anon_sym_u2ae4] = ACTIONS(5647),
    [anon_sym_BSLASHasymp] = ACTIONS(5647),
    [anon_sym_u224d] = ACTIONS(5647),
    [anon_sym_BSLASHcong] = ACTIONS(5647),
    [anon_sym_u2245] = ACTIONS(5647),
    [anon_sym_BSLASHdoteq] = ACTIONS(5647),
    [anon_sym_u2250] = ACTIONS(5647),
    [anon_sym_BSLASHgg] = ACTIONS(5647),
    [anon_sym_u226b] = ACTIONS(5647),
    [anon_sym_BSLASHll] = ACTIONS(5647),
    [anon_sym_u226a] = ACTIONS(5647),
    [anon_sym_BSLASHnotin] = ACTIONS(5647),
    [anon_sym_u2209] = ACTIONS(5647),
    [anon_sym_BSLASHprec] = ACTIONS(5645),
    [anon_sym_u227a] = ACTIONS(5647),
    [anon_sym_BSLASHsucc] = ACTIONS(5645),
    [anon_sym_u227b] = ACTIONS(5647),
    [anon_sym_BSLASHpreceq] = ACTIONS(5647),
    [anon_sym_u2aaf] = ACTIONS(5647),
    [anon_sym_BSLASHsucceq] = ACTIONS(5647),
    [anon_sym_u2ab0] = ACTIONS(5647),
    [anon_sym_BSLASHpropto] = ACTIONS(5647),
    [anon_sym_u221d] = ACTIONS(5647),
    [anon_sym_BSLASHsim] = ACTIONS(5645),
    [anon_sym_u223c] = ACTIONS(5647),
    [anon_sym_BSLASHsimeq] = ACTIONS(5647),
    [anon_sym_u2243] = ACTIONS(5647),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5645),
    [anon_sym_u228f] = ACTIONS(5647),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5645),
    [anon_sym_u2290] = ACTIONS(5647),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5647),
    [anon_sym_u2291] = ACTIONS(5647),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5647),
    [anon_sym_u2292] = ACTIONS(5647),
    [anon_sym_BSLASHsubset] = ACTIONS(5645),
    [anon_sym_u2282] = ACTIONS(5647),
    [anon_sym_BSLASHsupset] = ACTIONS(5645),
    [anon_sym_u2283] = ACTIONS(5647),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5647),
    [anon_sym_u2286] = ACTIONS(5647),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5647),
    [anon_sym_u2287] = ACTIONS(5647),
    [sym_compose] = ACTIONS(5647),
    [sym_map_to] = ACTIONS(5647),
    [sym_map_from] = ACTIONS(5647),
    [sym_setminus] = ACTIONS(5645),
    [anon_sym_BSLASHcap] = ACTIONS(5647),
    [anon_sym_BSLASHintersect] = ACTIONS(5647),
    [anon_sym_u2229] = ACTIONS(5647),
    [anon_sym_BSLASHcup] = ACTIONS(5647),
    [anon_sym_BSLASHunion] = ACTIONS(5647),
    [anon_sym_u222a] = ACTIONS(5647),
    [anon_sym_DOT_DOT] = ACTIONS(5645),
    [anon_sym_u2025] = ACTIONS(5647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5647),
    [anon_sym_u2026] = ACTIONS(5647),
    [anon_sym_PLUS] = ACTIONS(5645),
    [sym_plusplus] = ACTIONS(5647),
    [anon_sym_BSLASHoplus] = ACTIONS(5647),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5647),
    [anon_sym_u2295] = ACTIONS(5647),
    [anon_sym_BSLASHominus] = ACTIONS(5647),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5647),
    [anon_sym_u2296] = ACTIONS(5647),
    [sym_mod] = ACTIONS(5645),
    [sym_modmod] = ACTIONS(5647),
    [sym_vert] = ACTIONS(5645),
    [anon_sym_PIPE_PIPE] = ACTIONS(5647),
    [anon_sym_u2016] = ACTIONS(5647),
    [sym_minusminus] = ACTIONS(5647),
    [sym_amp] = ACTIONS(5645),
    [sym_ampamp] = ACTIONS(5647),
    [anon_sym_BSLASHodot] = ACTIONS(5647),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5647),
    [anon_sym_u2299] = ACTIONS(5647),
    [anon_sym_BSLASHoslash] = ACTIONS(5647),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5647),
    [anon_sym_u2298] = ACTIONS(5647),
    [anon_sym_BSLASHotimes] = ACTIONS(5647),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5647),
    [anon_sym_u2297] = ACTIONS(5647),
    [sym_mul] = ACTIONS(5645),
    [sym_mulmul] = ACTIONS(5647),
    [sym_slash] = ACTIONS(5645),
    [sym_slashslash] = ACTIONS(5647),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5647),
    [anon_sym_u25ef] = ACTIONS(5647),
    [anon_sym_BSLASHbullet] = ACTIONS(5647),
    [anon_sym_u25cf] = ACTIONS(5647),
    [anon_sym_BSLASHdiv] = ACTIONS(5647),
    [anon_sym_u00f7] = ACTIONS(5647),
    [anon_sym_BSLASHcirc] = ACTIONS(5647),
    [anon_sym_u2218] = ACTIONS(5647),
    [anon_sym_BSLASHstar] = ACTIONS(5647),
    [anon_sym_u22c6] = ACTIONS(5647),
    [anon_sym_u203c] = ACTIONS(5647),
    [sym_hashhash] = ACTIONS(5647),
    [sym_dol] = ACTIONS(5645),
    [sym_doldol] = ACTIONS(5647),
    [anon_sym_QMARK_QMARK] = ACTIONS(5647),
    [anon_sym_u2047] = ACTIONS(5647),
    [anon_sym_BSLASHsqcap] = ACTIONS(5647),
    [anon_sym_u2293] = ACTIONS(5647),
    [anon_sym_BSLASHsqcup] = ACTIONS(5647),
    [anon_sym_u2294] = ACTIONS(5647),
    [anon_sym_BSLASHuplus] = ACTIONS(5647),
    [anon_sym_u228e] = ACTIONS(5647),
    [anon_sym_BSLASHX] = ACTIONS(5647),
    [anon_sym_BSLASHtimes] = ACTIONS(5647),
    [anon_sym_u00d7] = ACTIONS(5647),
    [anon_sym_BSLASHwr] = ACTIONS(5647),
    [anon_sym_u2240] = ACTIONS(5647),
    [anon_sym_BSLASHcdot] = ACTIONS(5647),
    [anon_sym_u22c5] = ACTIONS(5647),
    [sym_pow] = ACTIONS(5645),
    [sym_powpow] = ACTIONS(5647),
    [anon_sym_CARET_PLUS] = ACTIONS(5647),
    [anon_sym_u207a] = ACTIONS(5647),
    [sym_asterisk] = ACTIONS(5647),
    [sym_sup_hash] = ACTIONS(5647),
    [sym_prime] = ACTIONS(5647),
    [sym__indent] = ACTIONS(5647),
    [sym__double_excl] = ACTIONS(5647),
  },
  [2210] = {
    [sym_block_comment] = STATE(2210),
    [sym_identifier] = ACTIONS(5649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5649),
    [anon_sym_u2208] = ACTIONS(5651),
    [anon_sym_BSLASHA] = ACTIONS(5649),
    [anon_sym_BSLASHforall] = ACTIONS(5651),
    [anon_sym_u2200] = ACTIONS(5651),
    [anon_sym_BSLASHE] = ACTIONS(5649),
    [anon_sym_BSLASHexists] = ACTIONS(5651),
    [anon_sym_u2203] = ACTIONS(5651),
    [sym_temporal_forall] = ACTIONS(5651),
    [sym_temporal_exists] = ACTIONS(5651),
    [anon_sym_LT_LT] = ACTIONS(5651),
    [anon_sym_u3008] = ACTIONS(5651),
    [anon_sym_u27e8] = ACTIONS(5651),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5651),
    [anon_sym_u25a1] = ACTIONS(5651),
    [anon_sym_AT] = ACTIONS(5649),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5651),
    [anon_sym_u2227] = ACTIONS(5651),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5651),
    [anon_sym_u2228] = ACTIONS(5651),
    [anon_sym_LPAREN] = ACTIONS(5649),
    [anon_sym_LBRACK] = ACTIONS(5649),
    [aux_sym_child_id_token1] = ACTIONS(5649),
    [sym_real_number] = ACTIONS(5651),
    [anon_sym_BSLASHb] = ACTIONS(5649),
    [anon_sym_BSLASHB] = ACTIONS(5651),
    [anon_sym_BSLASHo] = ACTIONS(5649),
    [anon_sym_BSLASHO] = ACTIONS(5651),
    [anon_sym_BSLASHh] = ACTIONS(5651),
    [anon_sym_BSLASHH] = ACTIONS(5651),
    [anon_sym_DQUOTE] = ACTIONS(5651),
    [anon_sym_TRUE] = ACTIONS(5649),
    [anon_sym_FALSE] = ACTIONS(5649),
    [sym_string_set] = ACTIONS(5649),
    [sym_boolean_set] = ACTIONS(5649),
    [anon_sym_Nat] = ACTIONS(5649),
    [anon_sym_u2115] = ACTIONS(5651),
    [anon_sym_Int] = ACTIONS(5649),
    [anon_sym_u2124] = ACTIONS(5651),
    [anon_sym_Real] = ACTIONS(5649),
    [anon_sym_u211d] = ACTIONS(5651),
    [anon_sym_CHOOSE] = ACTIONS(5649),
    [anon_sym_LBRACE] = ACTIONS(5651),
    [anon_sym_EQ] = ACTIONS(5649),
    [anon_sym_WF_] = ACTIONS(5649),
    [anon_sym_SF_] = ACTIONS(5649),
    [anon_sym_IF] = ACTIONS(5649),
    [anon_sym_CASE] = ACTIONS(5649),
    [anon_sym_LET] = ACTIONS(5649),
    [anon_sym_BSLASHlnot] = ACTIONS(5651),
    [anon_sym_BSLASHneg] = ACTIONS(5651),
    [anon_sym_TILDE] = ACTIONS(5649),
    [anon_sym_u00ac] = ACTIONS(5651),
    [sym_union] = ACTIONS(5649),
    [sym_powerset] = ACTIONS(5649),
    [sym_domain] = ACTIONS(5649),
    [anon_sym_DASH] = ACTIONS(5649),
    [sym_negative_dot] = ACTIONS(5651),
    [sym_enabled] = ACTIONS(5649),
    [sym_unchanged] = ACTIONS(5649),
    [anon_sym_LT_GT] = ACTIONS(5651),
    [anon_sym_u22c4] = ACTIONS(5651),
    [anon_sym_u25c7] = ACTIONS(5651),
    [anon_sym_EQ_GT] = ACTIONS(5651),
    [anon_sym_u27f9] = ACTIONS(5651),
    [anon_sym_u21d2] = ACTIONS(5651),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5651),
    [anon_sym_u21f8] = ACTIONS(5651),
    [anon_sym_u2945] = ACTIONS(5651),
    [anon_sym_BSLASHequiv] = ACTIONS(5651),
    [anon_sym_u2261] = ACTIONS(5651),
    [anon_sym_LT_EQ_GT] = ACTIONS(5651),
    [anon_sym_u27fa] = ACTIONS(5651),
    [anon_sym_u21d4] = ACTIONS(5651),
    [anon_sym_TILDE_GT] = ACTIONS(5651),
    [anon_sym_u21dd] = ACTIONS(5651),
    [anon_sym_u219d] = ACTIONS(5651),
    [anon_sym_BSLASHland] = ACTIONS(5651),
    [anon_sym_BSLASHlor] = ACTIONS(5651),
    [anon_sym_COLON_EQ] = ACTIONS(5651),
    [anon_sym_u2254] = ACTIONS(5651),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5651),
    [anon_sym_u2a74] = ACTIONS(5651),
    [anon_sym_SLASH_EQ] = ACTIONS(5651),
    [anon_sym_POUND] = ACTIONS(5649),
    [anon_sym_u2260] = ACTIONS(5651),
    [anon_sym_LT] = ACTIONS(5649),
    [sym_gt] = ACTIONS(5649),
    [anon_sym_LT_EQ] = ACTIONS(5649),
    [anon_sym_EQ_LT] = ACTIONS(5651),
    [anon_sym_BSLASHleq] = ACTIONS(5651),
    [anon_sym_u2264] = ACTIONS(5651),
    [anon_sym_GT_EQ] = ACTIONS(5651),
    [anon_sym_BSLASHgeq] = ACTIONS(5651),
    [anon_sym_u2265] = ACTIONS(5651),
    [anon_sym_BSLASHapprox] = ACTIONS(5651),
    [anon_sym_u2248] = ACTIONS(5651),
    [anon_sym_PIPE_DASH] = ACTIONS(5651),
    [anon_sym_u22a2] = ACTIONS(5651),
    [anon_sym_PIPE_EQ] = ACTIONS(5651),
    [anon_sym_u22a8] = ACTIONS(5651),
    [anon_sym_DASH_PIPE] = ACTIONS(5651),
    [anon_sym_u22a3] = ACTIONS(5651),
    [anon_sym_EQ_PIPE] = ACTIONS(5651),
    [anon_sym_u2ae4] = ACTIONS(5651),
    [anon_sym_BSLASHasymp] = ACTIONS(5651),
    [anon_sym_u224d] = ACTIONS(5651),
    [anon_sym_BSLASHcong] = ACTIONS(5651),
    [anon_sym_u2245] = ACTIONS(5651),
    [anon_sym_BSLASHdoteq] = ACTIONS(5651),
    [anon_sym_u2250] = ACTIONS(5651),
    [anon_sym_BSLASHgg] = ACTIONS(5651),
    [anon_sym_u226b] = ACTIONS(5651),
    [anon_sym_BSLASHll] = ACTIONS(5651),
    [anon_sym_u226a] = ACTIONS(5651),
    [anon_sym_BSLASHnotin] = ACTIONS(5651),
    [anon_sym_u2209] = ACTIONS(5651),
    [anon_sym_BSLASHprec] = ACTIONS(5649),
    [anon_sym_u227a] = ACTIONS(5651),
    [anon_sym_BSLASHsucc] = ACTIONS(5649),
    [anon_sym_u227b] = ACTIONS(5651),
    [anon_sym_BSLASHpreceq] = ACTIONS(5651),
    [anon_sym_u2aaf] = ACTIONS(5651),
    [anon_sym_BSLASHsucceq] = ACTIONS(5651),
    [anon_sym_u2ab0] = ACTIONS(5651),
    [anon_sym_BSLASHpropto] = ACTIONS(5651),
    [anon_sym_u221d] = ACTIONS(5651),
    [anon_sym_BSLASHsim] = ACTIONS(5649),
    [anon_sym_u223c] = ACTIONS(5651),
    [anon_sym_BSLASHsimeq] = ACTIONS(5651),
    [anon_sym_u2243] = ACTIONS(5651),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5649),
    [anon_sym_u228f] = ACTIONS(5651),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5649),
    [anon_sym_u2290] = ACTIONS(5651),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5651),
    [anon_sym_u2291] = ACTIONS(5651),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5651),
    [anon_sym_u2292] = ACTIONS(5651),
    [anon_sym_BSLASHsubset] = ACTIONS(5649),
    [anon_sym_u2282] = ACTIONS(5651),
    [anon_sym_BSLASHsupset] = ACTIONS(5649),
    [anon_sym_u2283] = ACTIONS(5651),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5651),
    [anon_sym_u2286] = ACTIONS(5651),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5651),
    [anon_sym_u2287] = ACTIONS(5651),
    [sym_compose] = ACTIONS(5651),
    [sym_map_to] = ACTIONS(5651),
    [sym_map_from] = ACTIONS(5651),
    [sym_setminus] = ACTIONS(5649),
    [anon_sym_BSLASHcap] = ACTIONS(5651),
    [anon_sym_BSLASHintersect] = ACTIONS(5651),
    [anon_sym_u2229] = ACTIONS(5651),
    [anon_sym_BSLASHcup] = ACTIONS(5651),
    [anon_sym_BSLASHunion] = ACTIONS(5651),
    [anon_sym_u222a] = ACTIONS(5651),
    [anon_sym_DOT_DOT] = ACTIONS(5649),
    [anon_sym_u2025] = ACTIONS(5651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5651),
    [anon_sym_u2026] = ACTIONS(5651),
    [anon_sym_PLUS] = ACTIONS(5649),
    [sym_plusplus] = ACTIONS(5651),
    [anon_sym_BSLASHoplus] = ACTIONS(5651),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5651),
    [anon_sym_u2295] = ACTIONS(5651),
    [anon_sym_BSLASHominus] = ACTIONS(5651),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5651),
    [anon_sym_u2296] = ACTIONS(5651),
    [sym_mod] = ACTIONS(5649),
    [sym_modmod] = ACTIONS(5651),
    [sym_vert] = ACTIONS(5649),
    [anon_sym_PIPE_PIPE] = ACTIONS(5651),
    [anon_sym_u2016] = ACTIONS(5651),
    [sym_minusminus] = ACTIONS(5651),
    [sym_amp] = ACTIONS(5649),
    [sym_ampamp] = ACTIONS(5651),
    [anon_sym_BSLASHodot] = ACTIONS(5651),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5651),
    [anon_sym_u2299] = ACTIONS(5651),
    [anon_sym_BSLASHoslash] = ACTIONS(5651),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5651),
    [anon_sym_u2298] = ACTIONS(5651),
    [anon_sym_BSLASHotimes] = ACTIONS(5651),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5651),
    [anon_sym_u2297] = ACTIONS(5651),
    [sym_mul] = ACTIONS(5649),
    [sym_mulmul] = ACTIONS(5651),
    [sym_slash] = ACTIONS(5649),
    [sym_slashslash] = ACTIONS(5651),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5651),
    [anon_sym_u25ef] = ACTIONS(5651),
    [anon_sym_BSLASHbullet] = ACTIONS(5651),
    [anon_sym_u25cf] = ACTIONS(5651),
    [anon_sym_BSLASHdiv] = ACTIONS(5651),
    [anon_sym_u00f7] = ACTIONS(5651),
    [anon_sym_BSLASHcirc] = ACTIONS(5651),
    [anon_sym_u2218] = ACTIONS(5651),
    [anon_sym_BSLASHstar] = ACTIONS(5651),
    [anon_sym_u22c6] = ACTIONS(5651),
    [anon_sym_u203c] = ACTIONS(5651),
    [sym_hashhash] = ACTIONS(5651),
    [sym_dol] = ACTIONS(5649),
    [sym_doldol] = ACTIONS(5651),
    [anon_sym_QMARK_QMARK] = ACTIONS(5651),
    [anon_sym_u2047] = ACTIONS(5651),
    [anon_sym_BSLASHsqcap] = ACTIONS(5651),
    [anon_sym_u2293] = ACTIONS(5651),
    [anon_sym_BSLASHsqcup] = ACTIONS(5651),
    [anon_sym_u2294] = ACTIONS(5651),
    [anon_sym_BSLASHuplus] = ACTIONS(5651),
    [anon_sym_u228e] = ACTIONS(5651),
    [anon_sym_BSLASHX] = ACTIONS(5651),
    [anon_sym_BSLASHtimes] = ACTIONS(5651),
    [anon_sym_u00d7] = ACTIONS(5651),
    [anon_sym_BSLASHwr] = ACTIONS(5651),
    [anon_sym_u2240] = ACTIONS(5651),
    [anon_sym_BSLASHcdot] = ACTIONS(5651),
    [anon_sym_u22c5] = ACTIONS(5651),
    [sym_pow] = ACTIONS(5649),
    [sym_powpow] = ACTIONS(5651),
    [anon_sym_CARET_PLUS] = ACTIONS(5651),
    [anon_sym_u207a] = ACTIONS(5651),
    [sym_asterisk] = ACTIONS(5651),
    [sym_sup_hash] = ACTIONS(5651),
    [sym_prime] = ACTIONS(5651),
    [sym__indent] = ACTIONS(5651),
    [sym__double_excl] = ACTIONS(5651),
  },
  [2211] = {
    [sym_block_comment] = STATE(2211),
    [sym_def_eq] = STATE(193),
    [sym_label_as] = STATE(545),
    [sym_identifier] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4078),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(4078),
    [anon_sym_EQ_EQ] = ACTIONS(5653),
    [anon_sym_u225c] = ACTIONS(3817),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_LOCAL] = ACTIONS(3845),
    [anon_sym_VARIABLE] = ACTIONS(3845),
    [anon_sym_VARIABLES] = ACTIONS(3845),
    [anon_sym_CONSTANT] = ACTIONS(3845),
    [anon_sym_CONSTANTS] = ACTIONS(3845),
    [anon_sym_RECURSIVE] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(5655),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_INSTANCE] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_Nat] = ACTIONS(3845),
    [anon_sym_u2115] = ACTIONS(4078),
    [anon_sym_Int] = ACTIONS(3845),
    [anon_sym_u2124] = ACTIONS(4078),
    [anon_sym_Real] = ACTIONS(3845),
    [anon_sym_u211d] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_BSLASHlnot] = ACTIONS(4078),
    [anon_sym_BSLASHneg] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_u00ac] = ACTIONS(4078),
    [sym_union] = ACTIONS(3845),
    [sym_powerset] = ACTIONS(3845),
    [sym_domain] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [sym_negative_dot] = ACTIONS(4078),
    [sym_enabled] = ACTIONS(3845),
    [sym_unchanged] = ACTIONS(3845),
    [anon_sym_LT_GT] = ACTIONS(4078),
    [anon_sym_u22c4] = ACTIONS(4078),
    [anon_sym_u25c7] = ACTIONS(4078),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(3845),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_ASSUME] = ACTIONS(3845),
    [anon_sym_ASSUMPTION] = ACTIONS(3845),
    [anon_sym_AXIOM] = ACTIONS(3845),
    [anon_sym_THEOREM] = ACTIONS(3845),
    [anon_sym_PROPOSITION] = ACTIONS(3845),
    [anon_sym_LEMMA] = ACTIONS(3845),
    [anon_sym_COROLLARY] = ACTIONS(3845),
    [anon_sym_PROOF] = ACTIONS(3845),
    [anon_sym_BY] = ACTIONS(3845),
    [anon_sym_OBVIOUS] = ACTIONS(3845),
    [anon_sym_OMITTED] = ACTIONS(3845),
    [anon_sym_USE] = ACTIONS(3845),
    [anon_sym_HIDE] = ACTIONS(3845),
    [sym__begin_proof] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2212] = {
    [sym_block_comment] = STATE(2212),
    [sym_def_eq] = STATE(203),
    [sym_label_as] = STATE(784),
    [ts_builtin_sym_end] = ACTIONS(4078),
    [sym_identifier] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4078),
    [anon_sym_EQ_EQ] = ACTIONS(3817),
    [anon_sym_u225c] = ACTIONS(3817),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_LOCAL] = ACTIONS(3845),
    [anon_sym_VARIABLE] = ACTIONS(3845),
    [anon_sym_VARIABLES] = ACTIONS(3845),
    [anon_sym_CONSTANT] = ACTIONS(3845),
    [anon_sym_CONSTANTS] = ACTIONS(3845),
    [anon_sym_RECURSIVE] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(5657),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_INSTANCE] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_Nat] = ACTIONS(3845),
    [anon_sym_u2115] = ACTIONS(4078),
    [anon_sym_Int] = ACTIONS(3845),
    [anon_sym_u2124] = ACTIONS(4078),
    [anon_sym_Real] = ACTIONS(3845),
    [anon_sym_u211d] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_BSLASHlnot] = ACTIONS(4078),
    [anon_sym_BSLASHneg] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_u00ac] = ACTIONS(4078),
    [sym_union] = ACTIONS(3845),
    [sym_powerset] = ACTIONS(3845),
    [sym_domain] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [sym_negative_dot] = ACTIONS(4078),
    [sym_enabled] = ACTIONS(3845),
    [sym_unchanged] = ACTIONS(3845),
    [anon_sym_LT_GT] = ACTIONS(4078),
    [anon_sym_u22c4] = ACTIONS(4078),
    [anon_sym_u25c7] = ACTIONS(4078),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(3845),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_ASSUME] = ACTIONS(3845),
    [anon_sym_ASSUMPTION] = ACTIONS(3845),
    [anon_sym_AXIOM] = ACTIONS(3845),
    [anon_sym_THEOREM] = ACTIONS(3845),
    [anon_sym_PROPOSITION] = ACTIONS(3845),
    [anon_sym_LEMMA] = ACTIONS(3845),
    [anon_sym_COROLLARY] = ACTIONS(3845),
    [anon_sym_PROOF] = ACTIONS(3845),
    [anon_sym_BY] = ACTIONS(3845),
    [anon_sym_OBVIOUS] = ACTIONS(3845),
    [anon_sym_OMITTED] = ACTIONS(3845),
    [anon_sym_USE] = ACTIONS(3845),
    [anon_sym_HIDE] = ACTIONS(3845),
    [sym__begin_proof] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2213] = {
    [sym_block_comment] = STATE(2213),
    [sym_label_as] = STATE(545),
    [sym_identifier] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4078),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_LOCAL] = ACTIONS(3845),
    [anon_sym_VARIABLE] = ACTIONS(3845),
    [anon_sym_VARIABLES] = ACTIONS(3845),
    [anon_sym_CONSTANT] = ACTIONS(3845),
    [anon_sym_CONSTANTS] = ACTIONS(3845),
    [anon_sym_RECURSIVE] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(5655),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_INSTANCE] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_Nat] = ACTIONS(3845),
    [anon_sym_u2115] = ACTIONS(4078),
    [anon_sym_Int] = ACTIONS(3845),
    [anon_sym_u2124] = ACTIONS(4078),
    [anon_sym_Real] = ACTIONS(3845),
    [anon_sym_u211d] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_BSLASHlnot] = ACTIONS(4078),
    [anon_sym_BSLASHneg] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_u00ac] = ACTIONS(4078),
    [sym_union] = ACTIONS(3845),
    [sym_powerset] = ACTIONS(3845),
    [sym_domain] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [sym_negative_dot] = ACTIONS(4078),
    [sym_enabled] = ACTIONS(3845),
    [sym_unchanged] = ACTIONS(3845),
    [anon_sym_LT_GT] = ACTIONS(4078),
    [anon_sym_u22c4] = ACTIONS(4078),
    [anon_sym_u25c7] = ACTIONS(4078),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(3845),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_ASSUME] = ACTIONS(3845),
    [anon_sym_ASSUMPTION] = ACTIONS(3845),
    [anon_sym_AXIOM] = ACTIONS(3845),
    [anon_sym_THEOREM] = ACTIONS(3845),
    [anon_sym_PROPOSITION] = ACTIONS(3845),
    [anon_sym_LEMMA] = ACTIONS(3845),
    [anon_sym_COROLLARY] = ACTIONS(3845),
    [anon_sym_PROOF] = ACTIONS(3845),
    [anon_sym_BY] = ACTIONS(3845),
    [anon_sym_OBVIOUS] = ACTIONS(3845),
    [anon_sym_OMITTED] = ACTIONS(3845),
    [anon_sym_USE] = ACTIONS(3845),
    [anon_sym_HIDE] = ACTIONS(3845),
    [sym__begin_proof] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2214] = {
    [sym_block_comment] = STATE(2214),
    [sym_label_as] = STATE(784),
    [ts_builtin_sym_end] = ACTIONS(4078),
    [sym_identifier] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4078),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_LOCAL] = ACTIONS(3845),
    [anon_sym_VARIABLE] = ACTIONS(3845),
    [anon_sym_VARIABLES] = ACTIONS(3845),
    [anon_sym_CONSTANT] = ACTIONS(3845),
    [anon_sym_CONSTANTS] = ACTIONS(3845),
    [anon_sym_RECURSIVE] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(5657),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_INSTANCE] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_Nat] = ACTIONS(3845),
    [anon_sym_u2115] = ACTIONS(4078),
    [anon_sym_Int] = ACTIONS(3845),
    [anon_sym_u2124] = ACTIONS(4078),
    [anon_sym_Real] = ACTIONS(3845),
    [anon_sym_u211d] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_BSLASHlnot] = ACTIONS(4078),
    [anon_sym_BSLASHneg] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_u00ac] = ACTIONS(4078),
    [sym_union] = ACTIONS(3845),
    [sym_powerset] = ACTIONS(3845),
    [sym_domain] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [sym_negative_dot] = ACTIONS(4078),
    [sym_enabled] = ACTIONS(3845),
    [sym_unchanged] = ACTIONS(3845),
    [anon_sym_LT_GT] = ACTIONS(4078),
    [anon_sym_u22c4] = ACTIONS(4078),
    [anon_sym_u25c7] = ACTIONS(4078),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(3845),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_ASSUME] = ACTIONS(3845),
    [anon_sym_ASSUMPTION] = ACTIONS(3845),
    [anon_sym_AXIOM] = ACTIONS(3845),
    [anon_sym_THEOREM] = ACTIONS(3845),
    [anon_sym_PROPOSITION] = ACTIONS(3845),
    [anon_sym_LEMMA] = ACTIONS(3845),
    [anon_sym_COROLLARY] = ACTIONS(3845),
    [anon_sym_PROOF] = ACTIONS(3845),
    [anon_sym_BY] = ACTIONS(3845),
    [anon_sym_OBVIOUS] = ACTIONS(3845),
    [anon_sym_OMITTED] = ACTIONS(3845),
    [anon_sym_USE] = ACTIONS(3845),
    [anon_sym_HIDE] = ACTIONS(3845),
    [sym__begin_proof] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2215] = {
    [sym_block_comment] = STATE(2215),
    [sym_def_eq] = STATE(783),
    [sym_label_as] = STATE(518),
    [sym_identifier] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4078),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(4078),
    [anon_sym_EQ_EQ] = ACTIONS(5653),
    [anon_sym_u225c] = ACTIONS(3817),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_LOCAL] = ACTIONS(3845),
    [anon_sym_VARIABLE] = ACTIONS(3845),
    [anon_sym_VARIABLES] = ACTIONS(3845),
    [anon_sym_CONSTANT] = ACTIONS(3845),
    [anon_sym_CONSTANTS] = ACTIONS(3845),
    [anon_sym_RECURSIVE] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_INSTANCE] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_Nat] = ACTIONS(3845),
    [anon_sym_u2115] = ACTIONS(4078),
    [anon_sym_Int] = ACTIONS(3845),
    [anon_sym_u2124] = ACTIONS(4078),
    [anon_sym_Real] = ACTIONS(3845),
    [anon_sym_u211d] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_BSLASHlnot] = ACTIONS(4078),
    [anon_sym_BSLASHneg] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_u00ac] = ACTIONS(4078),
    [sym_union] = ACTIONS(3845),
    [sym_powerset] = ACTIONS(3845),
    [sym_domain] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [sym_negative_dot] = ACTIONS(4078),
    [sym_enabled] = ACTIONS(3845),
    [sym_unchanged] = ACTIONS(3845),
    [anon_sym_LT_GT] = ACTIONS(4078),
    [anon_sym_u22c4] = ACTIONS(4078),
    [anon_sym_u25c7] = ACTIONS(4078),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(3845),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_ASSUME] = ACTIONS(3845),
    [anon_sym_ASSUMPTION] = ACTIONS(3845),
    [anon_sym_AXIOM] = ACTIONS(3845),
    [anon_sym_THEOREM] = ACTIONS(3845),
    [anon_sym_PROPOSITION] = ACTIONS(3845),
    [anon_sym_LEMMA] = ACTIONS(3845),
    [anon_sym_COROLLARY] = ACTIONS(3845),
    [anon_sym_USE] = ACTIONS(3845),
    [anon_sym_HIDE] = ACTIONS(3845),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2216] = {
    [sym_block_comment] = STATE(2216),
    [sym_label_as] = STATE(601),
    [ts_builtin_sym_end] = ACTIONS(4078),
    [sym_identifier] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4078),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_LOCAL] = ACTIONS(3845),
    [anon_sym_VARIABLE] = ACTIONS(3845),
    [anon_sym_VARIABLES] = ACTIONS(3845),
    [anon_sym_CONSTANT] = ACTIONS(3845),
    [anon_sym_CONSTANTS] = ACTIONS(3845),
    [anon_sym_RECURSIVE] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(5661),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_INSTANCE] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_Nat] = ACTIONS(3845),
    [anon_sym_u2115] = ACTIONS(4078),
    [anon_sym_Int] = ACTIONS(3845),
    [anon_sym_u2124] = ACTIONS(4078),
    [anon_sym_Real] = ACTIONS(3845),
    [anon_sym_u211d] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_BSLASHlnot] = ACTIONS(4078),
    [anon_sym_BSLASHneg] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_u00ac] = ACTIONS(4078),
    [sym_union] = ACTIONS(3845),
    [sym_powerset] = ACTIONS(3845),
    [sym_domain] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [sym_negative_dot] = ACTIONS(4078),
    [sym_enabled] = ACTIONS(3845),
    [sym_unchanged] = ACTIONS(3845),
    [anon_sym_LT_GT] = ACTIONS(4078),
    [anon_sym_u22c4] = ACTIONS(4078),
    [anon_sym_u25c7] = ACTIONS(4078),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(3845),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_ASSUME] = ACTIONS(3845),
    [anon_sym_ASSUMPTION] = ACTIONS(3845),
    [anon_sym_AXIOM] = ACTIONS(3845),
    [anon_sym_THEOREM] = ACTIONS(3845),
    [anon_sym_PROPOSITION] = ACTIONS(3845),
    [anon_sym_LEMMA] = ACTIONS(3845),
    [anon_sym_COROLLARY] = ACTIONS(3845),
    [anon_sym_USE] = ACTIONS(3845),
    [anon_sym_HIDE] = ACTIONS(3845),
    [anon_sym_DEF] = ACTIONS(3845),
    [anon_sym_DEFS] = ACTIONS(3845),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2217] = {
    [sym_block_comment] = STATE(2217),
    [sym_def_eq] = STATE(543),
    [sym_label_as] = STATE(601),
    [ts_builtin_sym_end] = ACTIONS(4078),
    [sym_identifier] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4078),
    [anon_sym_EQ_EQ] = ACTIONS(3817),
    [anon_sym_u225c] = ACTIONS(3817),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_LOCAL] = ACTIONS(3845),
    [anon_sym_VARIABLE] = ACTIONS(3845),
    [anon_sym_VARIABLES] = ACTIONS(3845),
    [anon_sym_CONSTANT] = ACTIONS(3845),
    [anon_sym_CONSTANTS] = ACTIONS(3845),
    [anon_sym_RECURSIVE] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(5661),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_INSTANCE] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_Nat] = ACTIONS(3845),
    [anon_sym_u2115] = ACTIONS(4078),
    [anon_sym_Int] = ACTIONS(3845),
    [anon_sym_u2124] = ACTIONS(4078),
    [anon_sym_Real] = ACTIONS(3845),
    [anon_sym_u211d] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_BSLASHlnot] = ACTIONS(4078),
    [anon_sym_BSLASHneg] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_u00ac] = ACTIONS(4078),
    [sym_union] = ACTIONS(3845),
    [sym_powerset] = ACTIONS(3845),
    [sym_domain] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [sym_negative_dot] = ACTIONS(4078),
    [sym_enabled] = ACTIONS(3845),
    [sym_unchanged] = ACTIONS(3845),
    [anon_sym_LT_GT] = ACTIONS(4078),
    [anon_sym_u22c4] = ACTIONS(4078),
    [anon_sym_u25c7] = ACTIONS(4078),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(3845),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_ASSUME] = ACTIONS(3845),
    [anon_sym_ASSUMPTION] = ACTIONS(3845),
    [anon_sym_AXIOM] = ACTIONS(3845),
    [anon_sym_THEOREM] = ACTIONS(3845),
    [anon_sym_PROPOSITION] = ACTIONS(3845),
    [anon_sym_LEMMA] = ACTIONS(3845),
    [anon_sym_COROLLARY] = ACTIONS(3845),
    [anon_sym_USE] = ACTIONS(3845),
    [anon_sym_HIDE] = ACTIONS(3845),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2218] = {
    [sym_block_comment] = STATE(2218),
    [sym_label_as] = STATE(518),
    [sym_identifier] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(4078),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_LOCAL] = ACTIONS(3845),
    [anon_sym_VARIABLE] = ACTIONS(3845),
    [anon_sym_VARIABLES] = ACTIONS(3845),
    [anon_sym_CONSTANT] = ACTIONS(3845),
    [anon_sym_CONSTANTS] = ACTIONS(3845),
    [anon_sym_RECURSIVE] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(5659),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_INSTANCE] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_Nat] = ACTIONS(3845),
    [anon_sym_u2115] = ACTIONS(4078),
    [anon_sym_Int] = ACTIONS(3845),
    [anon_sym_u2124] = ACTIONS(4078),
    [anon_sym_Real] = ACTIONS(3845),
    [anon_sym_u211d] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_BSLASHlnot] = ACTIONS(4078),
    [anon_sym_BSLASHneg] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_u00ac] = ACTIONS(4078),
    [sym_union] = ACTIONS(3845),
    [sym_powerset] = ACTIONS(3845),
    [sym_domain] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [sym_negative_dot] = ACTIONS(4078),
    [sym_enabled] = ACTIONS(3845),
    [sym_unchanged] = ACTIONS(3845),
    [anon_sym_LT_GT] = ACTIONS(4078),
    [anon_sym_u22c4] = ACTIONS(4078),
    [anon_sym_u25c7] = ACTIONS(4078),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(3845),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_ASSUME] = ACTIONS(3845),
    [anon_sym_ASSUMPTION] = ACTIONS(3845),
    [anon_sym_AXIOM] = ACTIONS(3845),
    [anon_sym_THEOREM] = ACTIONS(3845),
    [anon_sym_PROPOSITION] = ACTIONS(3845),
    [anon_sym_LEMMA] = ACTIONS(3845),
    [anon_sym_COROLLARY] = ACTIONS(3845),
    [anon_sym_USE] = ACTIONS(3845),
    [anon_sym_HIDE] = ACTIONS(3845),
    [anon_sym_DEF] = ACTIONS(3845),
    [anon_sym_DEFS] = ACTIONS(3845),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2219] = {
    [sym_block_comment] = STATE(2219),
    [sym_case_box] = STATE(244),
    [aux_sym_case_repeat1] = STATE(2219),
    [ts_builtin_sym_end] = ACTIONS(5663),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5663),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_LOCAL] = ACTIONS(5665),
    [anon_sym_VARIABLE] = ACTIONS(5665),
    [anon_sym_VARIABLES] = ACTIONS(5665),
    [anon_sym_CONSTANT] = ACTIONS(5665),
    [anon_sym_CONSTANTS] = ACTIONS(5665),
    [anon_sym_RECURSIVE] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_INSTANCE] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5665),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_ASSUME] = ACTIONS(5665),
    [anon_sym_ASSUMPTION] = ACTIONS(5665),
    [anon_sym_AXIOM] = ACTIONS(5665),
    [anon_sym_THEOREM] = ACTIONS(5665),
    [anon_sym_PROPOSITION] = ACTIONS(5665),
    [anon_sym_LEMMA] = ACTIONS(5665),
    [anon_sym_COROLLARY] = ACTIONS(5665),
    [anon_sym_PROOF] = ACTIONS(5665),
    [anon_sym_BY] = ACTIONS(5665),
    [anon_sym_OBVIOUS] = ACTIONS(5665),
    [anon_sym_OMITTED] = ACTIONS(5665),
    [anon_sym_USE] = ACTIONS(5665),
    [anon_sym_HIDE] = ACTIONS(5665),
    [sym__begin_proof] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2220] = {
    [sym_block_comment] = STATE(2220),
    [sym_case_box] = STATE(166),
    [aux_sym_case_repeat1] = STATE(2225),
    [sym_identifier] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5672),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_LOCAL] = ACTIONS(5670),
    [anon_sym_VARIABLE] = ACTIONS(5670),
    [anon_sym_VARIABLES] = ACTIONS(5670),
    [anon_sym_CONSTANT] = ACTIONS(5670),
    [anon_sym_CONSTANTS] = ACTIONS(5670),
    [anon_sym_RECURSIVE] = ACTIONS(5670),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_INSTANCE] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_Nat] = ACTIONS(5670),
    [anon_sym_u2115] = ACTIONS(5672),
    [anon_sym_Int] = ACTIONS(5670),
    [anon_sym_u2124] = ACTIONS(5672),
    [anon_sym_Real] = ACTIONS(5670),
    [anon_sym_u211d] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_BSLASHlnot] = ACTIONS(5672),
    [anon_sym_BSLASHneg] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5670),
    [anon_sym_u00ac] = ACTIONS(5672),
    [sym_union] = ACTIONS(5670),
    [sym_powerset] = ACTIONS(5670),
    [sym_domain] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [sym_negative_dot] = ACTIONS(5672),
    [sym_enabled] = ACTIONS(5670),
    [sym_unchanged] = ACTIONS(5670),
    [anon_sym_LT_GT] = ACTIONS(5672),
    [anon_sym_u22c4] = ACTIONS(5672),
    [anon_sym_u25c7] = ACTIONS(5672),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5670),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [anon_sym_ASSUME] = ACTIONS(5670),
    [anon_sym_ASSUMPTION] = ACTIONS(5670),
    [anon_sym_AXIOM] = ACTIONS(5670),
    [anon_sym_THEOREM] = ACTIONS(5670),
    [anon_sym_PROPOSITION] = ACTIONS(5670),
    [anon_sym_LEMMA] = ACTIONS(5670),
    [anon_sym_COROLLARY] = ACTIONS(5670),
    [anon_sym_PROOF] = ACTIONS(5670),
    [anon_sym_BY] = ACTIONS(5670),
    [anon_sym_OBVIOUS] = ACTIONS(5670),
    [anon_sym_OMITTED] = ACTIONS(5670),
    [anon_sym_USE] = ACTIONS(5670),
    [anon_sym_HIDE] = ACTIONS(5670),
    [sym__begin_proof] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [2221] = {
    [sym_block_comment] = STATE(2221),
    [ts_builtin_sym_end] = ACTIONS(5676),
    [sym_identifier] = ACTIONS(5678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5676),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_LOCAL] = ACTIONS(5678),
    [anon_sym_VARIABLE] = ACTIONS(5678),
    [anon_sym_VARIABLES] = ACTIONS(5678),
    [anon_sym_CONSTANT] = ACTIONS(5678),
    [anon_sym_CONSTANTS] = ACTIONS(5678),
    [anon_sym_RECURSIVE] = ACTIONS(5678),
    [anon_sym_LPAREN] = ACTIONS(5680),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_INSTANCE] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_Nat] = ACTIONS(5678),
    [anon_sym_u2115] = ACTIONS(5676),
    [anon_sym_Int] = ACTIONS(5678),
    [anon_sym_u2124] = ACTIONS(5676),
    [anon_sym_Real] = ACTIONS(5678),
    [anon_sym_u211d] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_BSLASHlnot] = ACTIONS(5676),
    [anon_sym_BSLASHneg] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5678),
    [anon_sym_u00ac] = ACTIONS(5676),
    [sym_union] = ACTIONS(5678),
    [sym_powerset] = ACTIONS(5678),
    [sym_domain] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [sym_negative_dot] = ACTIONS(5676),
    [sym_enabled] = ACTIONS(5678),
    [sym_unchanged] = ACTIONS(5678),
    [anon_sym_LT_GT] = ACTIONS(5676),
    [anon_sym_u22c4] = ACTIONS(5676),
    [anon_sym_u25c7] = ACTIONS(5676),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5678),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [anon_sym_ASSUME] = ACTIONS(5678),
    [anon_sym_ASSUMPTION] = ACTIONS(5678),
    [anon_sym_AXIOM] = ACTIONS(5678),
    [anon_sym_THEOREM] = ACTIONS(5678),
    [anon_sym_PROPOSITION] = ACTIONS(5678),
    [anon_sym_LEMMA] = ACTIONS(5678),
    [anon_sym_COROLLARY] = ACTIONS(5678),
    [anon_sym_PROOF] = ACTIONS(5678),
    [anon_sym_BY] = ACTIONS(5678),
    [anon_sym_OBVIOUS] = ACTIONS(5678),
    [anon_sym_OMITTED] = ACTIONS(5678),
    [anon_sym_USE] = ACTIONS(5678),
    [anon_sym_HIDE] = ACTIONS(5678),
    [sym__begin_proof] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [2222] = {
    [sym_block_comment] = STATE(2222),
    [sym_case_box] = STATE(136),
    [aux_sym_case_repeat1] = STATE(2219),
    [ts_builtin_sym_end] = ACTIONS(5672),
    [sym_identifier] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5672),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_LOCAL] = ACTIONS(5670),
    [anon_sym_VARIABLE] = ACTIONS(5670),
    [anon_sym_VARIABLES] = ACTIONS(5670),
    [anon_sym_CONSTANT] = ACTIONS(5670),
    [anon_sym_CONSTANTS] = ACTIONS(5670),
    [anon_sym_RECURSIVE] = ACTIONS(5670),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_INSTANCE] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_Nat] = ACTIONS(5670),
    [anon_sym_u2115] = ACTIONS(5672),
    [anon_sym_Int] = ACTIONS(5670),
    [anon_sym_u2124] = ACTIONS(5672),
    [anon_sym_Real] = ACTIONS(5670),
    [anon_sym_u211d] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_BSLASHlnot] = ACTIONS(5672),
    [anon_sym_BSLASHneg] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5670),
    [anon_sym_u00ac] = ACTIONS(5672),
    [sym_union] = ACTIONS(5670),
    [sym_powerset] = ACTIONS(5670),
    [sym_domain] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [sym_negative_dot] = ACTIONS(5672),
    [sym_enabled] = ACTIONS(5670),
    [sym_unchanged] = ACTIONS(5670),
    [anon_sym_LT_GT] = ACTIONS(5672),
    [anon_sym_u22c4] = ACTIONS(5672),
    [anon_sym_u25c7] = ACTIONS(5672),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5670),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [anon_sym_ASSUME] = ACTIONS(5670),
    [anon_sym_ASSUMPTION] = ACTIONS(5670),
    [anon_sym_AXIOM] = ACTIONS(5670),
    [anon_sym_THEOREM] = ACTIONS(5670),
    [anon_sym_PROPOSITION] = ACTIONS(5670),
    [anon_sym_LEMMA] = ACTIONS(5670),
    [anon_sym_COROLLARY] = ACTIONS(5670),
    [anon_sym_PROOF] = ACTIONS(5670),
    [anon_sym_BY] = ACTIONS(5670),
    [anon_sym_OBVIOUS] = ACTIONS(5670),
    [anon_sym_OMITTED] = ACTIONS(5670),
    [anon_sym_USE] = ACTIONS(5670),
    [anon_sym_HIDE] = ACTIONS(5670),
    [sym__begin_proof] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [2223] = {
    [sym_block_comment] = STATE(2223),
    [sym_identifier] = ACTIONS(5678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5676),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_LOCAL] = ACTIONS(5678),
    [anon_sym_VARIABLE] = ACTIONS(5678),
    [anon_sym_VARIABLES] = ACTIONS(5678),
    [anon_sym_CONSTANT] = ACTIONS(5678),
    [anon_sym_CONSTANTS] = ACTIONS(5678),
    [anon_sym_RECURSIVE] = ACTIONS(5678),
    [anon_sym_LPAREN] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_INSTANCE] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_Nat] = ACTIONS(5678),
    [anon_sym_u2115] = ACTIONS(5676),
    [anon_sym_Int] = ACTIONS(5678),
    [anon_sym_u2124] = ACTIONS(5676),
    [anon_sym_Real] = ACTIONS(5678),
    [anon_sym_u211d] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_BSLASHlnot] = ACTIONS(5676),
    [anon_sym_BSLASHneg] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5678),
    [anon_sym_u00ac] = ACTIONS(5676),
    [sym_union] = ACTIONS(5678),
    [sym_powerset] = ACTIONS(5678),
    [sym_domain] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [sym_negative_dot] = ACTIONS(5676),
    [sym_enabled] = ACTIONS(5678),
    [sym_unchanged] = ACTIONS(5678),
    [anon_sym_LT_GT] = ACTIONS(5676),
    [anon_sym_u22c4] = ACTIONS(5676),
    [anon_sym_u25c7] = ACTIONS(5676),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5678),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [anon_sym_ASSUME] = ACTIONS(5678),
    [anon_sym_ASSUMPTION] = ACTIONS(5678),
    [anon_sym_AXIOM] = ACTIONS(5678),
    [anon_sym_THEOREM] = ACTIONS(5678),
    [anon_sym_PROPOSITION] = ACTIONS(5678),
    [anon_sym_LEMMA] = ACTIONS(5678),
    [anon_sym_COROLLARY] = ACTIONS(5678),
    [anon_sym_PROOF] = ACTIONS(5678),
    [anon_sym_BY] = ACTIONS(5678),
    [anon_sym_OBVIOUS] = ACTIONS(5678),
    [anon_sym_OMITTED] = ACTIONS(5678),
    [anon_sym_USE] = ACTIONS(5678),
    [anon_sym_HIDE] = ACTIONS(5678),
    [sym__begin_proof] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [2224] = {
    [sym_block_comment] = STATE(2224),
    [sym_case_box] = STATE(135),
    [aux_sym_case_repeat1] = STATE(2222),
    [ts_builtin_sym_end] = ACTIONS(5684),
    [sym_identifier] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5684),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_LOCAL] = ACTIONS(5686),
    [anon_sym_VARIABLE] = ACTIONS(5686),
    [anon_sym_VARIABLES] = ACTIONS(5686),
    [anon_sym_CONSTANT] = ACTIONS(5686),
    [anon_sym_CONSTANTS] = ACTIONS(5686),
    [anon_sym_RECURSIVE] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_INSTANCE] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_Nat] = ACTIONS(5686),
    [anon_sym_u2115] = ACTIONS(5684),
    [anon_sym_Int] = ACTIONS(5686),
    [anon_sym_u2124] = ACTIONS(5684),
    [anon_sym_Real] = ACTIONS(5686),
    [anon_sym_u211d] = ACTIONS(5684),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_BSLASHlnot] = ACTIONS(5684),
    [anon_sym_BSLASHneg] = ACTIONS(5684),
    [anon_sym_TILDE] = ACTIONS(5686),
    [anon_sym_u00ac] = ACTIONS(5684),
    [sym_union] = ACTIONS(5686),
    [sym_powerset] = ACTIONS(5686),
    [sym_domain] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [sym_negative_dot] = ACTIONS(5684),
    [sym_enabled] = ACTIONS(5686),
    [sym_unchanged] = ACTIONS(5686),
    [anon_sym_LT_GT] = ACTIONS(5684),
    [anon_sym_u22c4] = ACTIONS(5684),
    [anon_sym_u25c7] = ACTIONS(5684),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5686),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [anon_sym_ASSUME] = ACTIONS(5686),
    [anon_sym_ASSUMPTION] = ACTIONS(5686),
    [anon_sym_AXIOM] = ACTIONS(5686),
    [anon_sym_THEOREM] = ACTIONS(5686),
    [anon_sym_PROPOSITION] = ACTIONS(5686),
    [anon_sym_LEMMA] = ACTIONS(5686),
    [anon_sym_COROLLARY] = ACTIONS(5686),
    [anon_sym_PROOF] = ACTIONS(5686),
    [anon_sym_BY] = ACTIONS(5686),
    [anon_sym_OBVIOUS] = ACTIONS(5686),
    [anon_sym_OMITTED] = ACTIONS(5686),
    [anon_sym_USE] = ACTIONS(5686),
    [anon_sym_HIDE] = ACTIONS(5686),
    [sym__begin_proof] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2225] = {
    [sym_block_comment] = STATE(2225),
    [sym_case_box] = STATE(302),
    [aux_sym_case_repeat1] = STATE(2225),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5663),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_LOCAL] = ACTIONS(5665),
    [anon_sym_VARIABLE] = ACTIONS(5665),
    [anon_sym_VARIABLES] = ACTIONS(5665),
    [anon_sym_CONSTANT] = ACTIONS(5665),
    [anon_sym_CONSTANTS] = ACTIONS(5665),
    [anon_sym_RECURSIVE] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_INSTANCE] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5665),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_ASSUME] = ACTIONS(5665),
    [anon_sym_ASSUMPTION] = ACTIONS(5665),
    [anon_sym_AXIOM] = ACTIONS(5665),
    [anon_sym_THEOREM] = ACTIONS(5665),
    [anon_sym_PROPOSITION] = ACTIONS(5665),
    [anon_sym_LEMMA] = ACTIONS(5665),
    [anon_sym_COROLLARY] = ACTIONS(5665),
    [anon_sym_PROOF] = ACTIONS(5665),
    [anon_sym_BY] = ACTIONS(5665),
    [anon_sym_OBVIOUS] = ACTIONS(5665),
    [anon_sym_OMITTED] = ACTIONS(5665),
    [anon_sym_USE] = ACTIONS(5665),
    [anon_sym_HIDE] = ACTIONS(5665),
    [sym__begin_proof] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2226] = {
    [sym_block_comment] = STATE(2226),
    [sym_case_box] = STATE(165),
    [aux_sym_case_repeat1] = STATE(2220),
    [sym_identifier] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5684),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_LOCAL] = ACTIONS(5686),
    [anon_sym_VARIABLE] = ACTIONS(5686),
    [anon_sym_VARIABLES] = ACTIONS(5686),
    [anon_sym_CONSTANT] = ACTIONS(5686),
    [anon_sym_CONSTANTS] = ACTIONS(5686),
    [anon_sym_RECURSIVE] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_INSTANCE] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_Nat] = ACTIONS(5686),
    [anon_sym_u2115] = ACTIONS(5684),
    [anon_sym_Int] = ACTIONS(5686),
    [anon_sym_u2124] = ACTIONS(5684),
    [anon_sym_Real] = ACTIONS(5686),
    [anon_sym_u211d] = ACTIONS(5684),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_BSLASHlnot] = ACTIONS(5684),
    [anon_sym_BSLASHneg] = ACTIONS(5684),
    [anon_sym_TILDE] = ACTIONS(5686),
    [anon_sym_u00ac] = ACTIONS(5684),
    [sym_union] = ACTIONS(5686),
    [sym_powerset] = ACTIONS(5686),
    [sym_domain] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [sym_negative_dot] = ACTIONS(5684),
    [sym_enabled] = ACTIONS(5686),
    [sym_unchanged] = ACTIONS(5686),
    [anon_sym_LT_GT] = ACTIONS(5684),
    [anon_sym_u22c4] = ACTIONS(5684),
    [anon_sym_u25c7] = ACTIONS(5684),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5686),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [anon_sym_ASSUME] = ACTIONS(5686),
    [anon_sym_ASSUMPTION] = ACTIONS(5686),
    [anon_sym_AXIOM] = ACTIONS(5686),
    [anon_sym_THEOREM] = ACTIONS(5686),
    [anon_sym_PROPOSITION] = ACTIONS(5686),
    [anon_sym_LEMMA] = ACTIONS(5686),
    [anon_sym_COROLLARY] = ACTIONS(5686),
    [anon_sym_PROOF] = ACTIONS(5686),
    [anon_sym_BY] = ACTIONS(5686),
    [anon_sym_OBVIOUS] = ACTIONS(5686),
    [anon_sym_OMITTED] = ACTIONS(5686),
    [anon_sym_USE] = ACTIONS(5686),
    [anon_sym_HIDE] = ACTIONS(5686),
    [sym__begin_proof] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2227] = {
    [sym_block_comment] = STATE(2227),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5690),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LOCAL] = ACTIONS(5688),
    [anon_sym_VARIABLE] = ACTIONS(5688),
    [anon_sym_VARIABLES] = ACTIONS(5688),
    [anon_sym_CONSTANT] = ACTIONS(5688),
    [anon_sym_CONSTANTS] = ACTIONS(5688),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5688),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_ASSUME] = ACTIONS(5688),
    [anon_sym_ASSUMPTION] = ACTIONS(5688),
    [anon_sym_AXIOM] = ACTIONS(5688),
    [anon_sym_THEOREM] = ACTIONS(5688),
    [anon_sym_PROPOSITION] = ACTIONS(5688),
    [anon_sym_LEMMA] = ACTIONS(5688),
    [anon_sym_COROLLARY] = ACTIONS(5688),
    [anon_sym_PROOF] = ACTIONS(5688),
    [anon_sym_BY] = ACTIONS(5688),
    [anon_sym_OBVIOUS] = ACTIONS(5688),
    [anon_sym_OMITTED] = ACTIONS(5688),
    [anon_sym_USE] = ACTIONS(5688),
    [anon_sym_HIDE] = ACTIONS(5688),
    [sym__begin_proof] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2228] = {
    [sym_block_comment] = STATE(2228),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5690),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LOCAL] = ACTIONS(5688),
    [anon_sym_VARIABLE] = ACTIONS(5688),
    [anon_sym_VARIABLES] = ACTIONS(5688),
    [anon_sym_CONSTANT] = ACTIONS(5688),
    [anon_sym_CONSTANTS] = ACTIONS(5688),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5688),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_ASSUME] = ACTIONS(5688),
    [anon_sym_ASSUMPTION] = ACTIONS(5688),
    [anon_sym_AXIOM] = ACTIONS(5688),
    [anon_sym_THEOREM] = ACTIONS(5688),
    [anon_sym_PROPOSITION] = ACTIONS(5688),
    [anon_sym_LEMMA] = ACTIONS(5688),
    [anon_sym_COROLLARY] = ACTIONS(5688),
    [anon_sym_PROOF] = ACTIONS(5688),
    [anon_sym_BY] = ACTIONS(5688),
    [anon_sym_OBVIOUS] = ACTIONS(5688),
    [anon_sym_OMITTED] = ACTIONS(5688),
    [anon_sym_USE] = ACTIONS(5688),
    [anon_sym_HIDE] = ACTIONS(5688),
    [sym__begin_proof] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2229] = {
    [sym_block_comment] = STATE(2229),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [sym_identifier] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5696),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_LOCAL] = ACTIONS(5698),
    [anon_sym_VARIABLE] = ACTIONS(5698),
    [anon_sym_VARIABLES] = ACTIONS(5698),
    [anon_sym_CONSTANT] = ACTIONS(5698),
    [anon_sym_CONSTANTS] = ACTIONS(5698),
    [anon_sym_RECURSIVE] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_INSTANCE] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_Nat] = ACTIONS(5698),
    [anon_sym_u2115] = ACTIONS(5696),
    [anon_sym_Int] = ACTIONS(5698),
    [anon_sym_u2124] = ACTIONS(5696),
    [anon_sym_Real] = ACTIONS(5698),
    [anon_sym_u211d] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_BSLASHlnot] = ACTIONS(5696),
    [anon_sym_BSLASHneg] = ACTIONS(5696),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_u00ac] = ACTIONS(5696),
    [sym_union] = ACTIONS(5698),
    [sym_powerset] = ACTIONS(5698),
    [sym_domain] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [sym_negative_dot] = ACTIONS(5696),
    [sym_enabled] = ACTIONS(5698),
    [sym_unchanged] = ACTIONS(5698),
    [anon_sym_LT_GT] = ACTIONS(5696),
    [anon_sym_u22c4] = ACTIONS(5696),
    [anon_sym_u25c7] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5698),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [anon_sym_ASSUME] = ACTIONS(5698),
    [anon_sym_ASSUMPTION] = ACTIONS(5698),
    [anon_sym_AXIOM] = ACTIONS(5698),
    [anon_sym_THEOREM] = ACTIONS(5698),
    [anon_sym_PROPOSITION] = ACTIONS(5698),
    [anon_sym_LEMMA] = ACTIONS(5698),
    [anon_sym_COROLLARY] = ACTIONS(5698),
    [anon_sym_PROOF] = ACTIONS(5698),
    [anon_sym_BY] = ACTIONS(5698),
    [anon_sym_OBVIOUS] = ACTIONS(5698),
    [anon_sym_OMITTED] = ACTIONS(5698),
    [anon_sym_USE] = ACTIONS(5698),
    [anon_sym_HIDE] = ACTIONS(5698),
    [sym__begin_proof] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [2230] = {
    [sym_block_comment] = STATE(2230),
    [ts_builtin_sym_end] = ACTIONS(5700),
    [sym_identifier] = ACTIONS(5702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5700),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_LOCAL] = ACTIONS(5702),
    [anon_sym_VARIABLE] = ACTIONS(5702),
    [anon_sym_VARIABLES] = ACTIONS(5702),
    [anon_sym_CONSTANT] = ACTIONS(5702),
    [anon_sym_CONSTANTS] = ACTIONS(5702),
    [anon_sym_RECURSIVE] = ACTIONS(5702),
    [anon_sym_LPAREN] = ACTIONS(5680),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_INSTANCE] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_Nat] = ACTIONS(5702),
    [anon_sym_u2115] = ACTIONS(5700),
    [anon_sym_Int] = ACTIONS(5702),
    [anon_sym_u2124] = ACTIONS(5700),
    [anon_sym_Real] = ACTIONS(5702),
    [anon_sym_u211d] = ACTIONS(5700),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_BSLASHlnot] = ACTIONS(5700),
    [anon_sym_BSLASHneg] = ACTIONS(5700),
    [anon_sym_TILDE] = ACTIONS(5702),
    [anon_sym_u00ac] = ACTIONS(5700),
    [sym_union] = ACTIONS(5702),
    [sym_powerset] = ACTIONS(5702),
    [sym_domain] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [sym_negative_dot] = ACTIONS(5700),
    [sym_enabled] = ACTIONS(5702),
    [sym_unchanged] = ACTIONS(5702),
    [anon_sym_LT_GT] = ACTIONS(5700),
    [anon_sym_u22c4] = ACTIONS(5700),
    [anon_sym_u25c7] = ACTIONS(5700),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5702),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [anon_sym_ASSUME] = ACTIONS(5702),
    [anon_sym_ASSUMPTION] = ACTIONS(5702),
    [anon_sym_AXIOM] = ACTIONS(5702),
    [anon_sym_THEOREM] = ACTIONS(5702),
    [anon_sym_PROPOSITION] = ACTIONS(5702),
    [anon_sym_LEMMA] = ACTIONS(5702),
    [anon_sym_COROLLARY] = ACTIONS(5702),
    [anon_sym_PROOF] = ACTIONS(5702),
    [anon_sym_BY] = ACTIONS(5702),
    [anon_sym_OBVIOUS] = ACTIONS(5702),
    [anon_sym_OMITTED] = ACTIONS(5702),
    [anon_sym_USE] = ACTIONS(5702),
    [anon_sym_HIDE] = ACTIONS(5702),
    [sym__begin_proof] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [2231] = {
    [sym_block_comment] = STATE(2231),
    [ts_builtin_sym_end] = ACTIONS(5704),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5704),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_LOCAL] = ACTIONS(5706),
    [anon_sym_VARIABLE] = ACTIONS(5706),
    [anon_sym_VARIABLES] = ACTIONS(5706),
    [anon_sym_CONSTANT] = ACTIONS(5706),
    [anon_sym_CONSTANTS] = ACTIONS(5706),
    [anon_sym_RECURSIVE] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_INSTANCE] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5706),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_ASSUME] = ACTIONS(5706),
    [anon_sym_ASSUMPTION] = ACTIONS(5706),
    [anon_sym_AXIOM] = ACTIONS(5706),
    [anon_sym_THEOREM] = ACTIONS(5706),
    [anon_sym_PROPOSITION] = ACTIONS(5706),
    [anon_sym_LEMMA] = ACTIONS(5706),
    [anon_sym_COROLLARY] = ACTIONS(5706),
    [anon_sym_PROOF] = ACTIONS(5706),
    [anon_sym_BY] = ACTIONS(5706),
    [anon_sym_OBVIOUS] = ACTIONS(5706),
    [anon_sym_OMITTED] = ACTIONS(5706),
    [anon_sym_USE] = ACTIONS(5706),
    [anon_sym_HIDE] = ACTIONS(5706),
    [sym__begin_proof] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2232] = {
    [sym_block_comment] = STATE(2232),
    [ts_builtin_sym_end] = ACTIONS(5708),
    [sym_identifier] = ACTIONS(5710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5708),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_LOCAL] = ACTIONS(5710),
    [anon_sym_VARIABLE] = ACTIONS(5710),
    [anon_sym_VARIABLES] = ACTIONS(5710),
    [anon_sym_CONSTANT] = ACTIONS(5710),
    [anon_sym_CONSTANTS] = ACTIONS(5710),
    [anon_sym_RECURSIVE] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_INSTANCE] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_Nat] = ACTIONS(5710),
    [anon_sym_u2115] = ACTIONS(5708),
    [anon_sym_Int] = ACTIONS(5710),
    [anon_sym_u2124] = ACTIONS(5708),
    [anon_sym_Real] = ACTIONS(5710),
    [anon_sym_u211d] = ACTIONS(5708),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_BSLASHlnot] = ACTIONS(5708),
    [anon_sym_BSLASHneg] = ACTIONS(5708),
    [anon_sym_TILDE] = ACTIONS(5710),
    [anon_sym_u00ac] = ACTIONS(5708),
    [sym_union] = ACTIONS(5710),
    [sym_powerset] = ACTIONS(5710),
    [sym_domain] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [sym_negative_dot] = ACTIONS(5708),
    [sym_enabled] = ACTIONS(5710),
    [sym_unchanged] = ACTIONS(5710),
    [anon_sym_LT_GT] = ACTIONS(5708),
    [anon_sym_u22c4] = ACTIONS(5708),
    [anon_sym_u25c7] = ACTIONS(5708),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5710),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [anon_sym_ASSUME] = ACTIONS(5710),
    [anon_sym_ASSUMPTION] = ACTIONS(5710),
    [anon_sym_AXIOM] = ACTIONS(5710),
    [anon_sym_THEOREM] = ACTIONS(5710),
    [anon_sym_PROPOSITION] = ACTIONS(5710),
    [anon_sym_LEMMA] = ACTIONS(5710),
    [anon_sym_COROLLARY] = ACTIONS(5710),
    [anon_sym_PROOF] = ACTIONS(5710),
    [anon_sym_BY] = ACTIONS(5710),
    [anon_sym_OBVIOUS] = ACTIONS(5710),
    [anon_sym_OMITTED] = ACTIONS(5710),
    [anon_sym_USE] = ACTIONS(5710),
    [anon_sym_HIDE] = ACTIONS(5710),
    [sym__begin_proof] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [2233] = {
    [sym_block_comment] = STATE(2233),
    [sym_identifier] = ACTIONS(5710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5708),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_LOCAL] = ACTIONS(5710),
    [anon_sym_VARIABLE] = ACTIONS(5710),
    [anon_sym_VARIABLES] = ACTIONS(5710),
    [anon_sym_CONSTANT] = ACTIONS(5710),
    [anon_sym_CONSTANTS] = ACTIONS(5710),
    [anon_sym_RECURSIVE] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_INSTANCE] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_Nat] = ACTIONS(5710),
    [anon_sym_u2115] = ACTIONS(5708),
    [anon_sym_Int] = ACTIONS(5710),
    [anon_sym_u2124] = ACTIONS(5708),
    [anon_sym_Real] = ACTIONS(5710),
    [anon_sym_u211d] = ACTIONS(5708),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_BSLASHlnot] = ACTIONS(5708),
    [anon_sym_BSLASHneg] = ACTIONS(5708),
    [anon_sym_TILDE] = ACTIONS(5710),
    [anon_sym_u00ac] = ACTIONS(5708),
    [sym_union] = ACTIONS(5710),
    [sym_powerset] = ACTIONS(5710),
    [sym_domain] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [sym_negative_dot] = ACTIONS(5708),
    [sym_enabled] = ACTIONS(5710),
    [sym_unchanged] = ACTIONS(5710),
    [anon_sym_LT_GT] = ACTIONS(5708),
    [anon_sym_u22c4] = ACTIONS(5708),
    [anon_sym_u25c7] = ACTIONS(5708),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5710),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [anon_sym_ASSUME] = ACTIONS(5710),
    [anon_sym_ASSUMPTION] = ACTIONS(5710),
    [anon_sym_AXIOM] = ACTIONS(5710),
    [anon_sym_THEOREM] = ACTIONS(5710),
    [anon_sym_PROPOSITION] = ACTIONS(5710),
    [anon_sym_LEMMA] = ACTIONS(5710),
    [anon_sym_COROLLARY] = ACTIONS(5710),
    [anon_sym_PROOF] = ACTIONS(5710),
    [anon_sym_BY] = ACTIONS(5710),
    [anon_sym_OBVIOUS] = ACTIONS(5710),
    [anon_sym_OMITTED] = ACTIONS(5710),
    [anon_sym_USE] = ACTIONS(5710),
    [anon_sym_HIDE] = ACTIONS(5710),
    [sym__begin_proof] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [2234] = {
    [sym_block_comment] = STATE(2234),
    [ts_builtin_sym_end] = ACTIONS(5712),
    [sym_identifier] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5712),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_LOCAL] = ACTIONS(5714),
    [anon_sym_VARIABLE] = ACTIONS(5714),
    [anon_sym_VARIABLES] = ACTIONS(5714),
    [anon_sym_CONSTANT] = ACTIONS(5714),
    [anon_sym_CONSTANTS] = ACTIONS(5714),
    [anon_sym_RECURSIVE] = ACTIONS(5714),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_INSTANCE] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_Nat] = ACTIONS(5714),
    [anon_sym_u2115] = ACTIONS(5712),
    [anon_sym_Int] = ACTIONS(5714),
    [anon_sym_u2124] = ACTIONS(5712),
    [anon_sym_Real] = ACTIONS(5714),
    [anon_sym_u211d] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_BSLASHlnot] = ACTIONS(5712),
    [anon_sym_BSLASHneg] = ACTIONS(5712),
    [anon_sym_TILDE] = ACTIONS(5714),
    [anon_sym_u00ac] = ACTIONS(5712),
    [sym_union] = ACTIONS(5714),
    [sym_powerset] = ACTIONS(5714),
    [sym_domain] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [sym_negative_dot] = ACTIONS(5712),
    [sym_enabled] = ACTIONS(5714),
    [sym_unchanged] = ACTIONS(5714),
    [anon_sym_LT_GT] = ACTIONS(5712),
    [anon_sym_u22c4] = ACTIONS(5712),
    [anon_sym_u25c7] = ACTIONS(5712),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5714),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [anon_sym_ASSUME] = ACTIONS(5714),
    [anon_sym_ASSUMPTION] = ACTIONS(5714),
    [anon_sym_AXIOM] = ACTIONS(5714),
    [anon_sym_THEOREM] = ACTIONS(5714),
    [anon_sym_PROPOSITION] = ACTIONS(5714),
    [anon_sym_LEMMA] = ACTIONS(5714),
    [anon_sym_COROLLARY] = ACTIONS(5714),
    [anon_sym_PROOF] = ACTIONS(5714),
    [anon_sym_BY] = ACTIONS(5714),
    [anon_sym_OBVIOUS] = ACTIONS(5714),
    [anon_sym_OMITTED] = ACTIONS(5714),
    [anon_sym_USE] = ACTIONS(5714),
    [anon_sym_HIDE] = ACTIONS(5714),
    [sym__begin_proof] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [2235] = {
    [sym_block_comment] = STATE(2235),
    [sym_identifier] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_LOCAL] = ACTIONS(5698),
    [anon_sym_VARIABLE] = ACTIONS(5698),
    [anon_sym_VARIABLES] = ACTIONS(5698),
    [anon_sym_CONSTANT] = ACTIONS(5698),
    [anon_sym_CONSTANTS] = ACTIONS(5698),
    [anon_sym_RECURSIVE] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_INSTANCE] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_Nat] = ACTIONS(5698),
    [anon_sym_u2115] = ACTIONS(5696),
    [anon_sym_Int] = ACTIONS(5698),
    [anon_sym_u2124] = ACTIONS(5696),
    [anon_sym_Real] = ACTIONS(5698),
    [anon_sym_u211d] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_BSLASHlnot] = ACTIONS(5696),
    [anon_sym_BSLASHneg] = ACTIONS(5696),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_u00ac] = ACTIONS(5696),
    [sym_union] = ACTIONS(5698),
    [sym_powerset] = ACTIONS(5698),
    [sym_domain] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [sym_negative_dot] = ACTIONS(5696),
    [sym_enabled] = ACTIONS(5698),
    [sym_unchanged] = ACTIONS(5698),
    [anon_sym_LT_GT] = ACTIONS(5696),
    [anon_sym_u22c4] = ACTIONS(5696),
    [anon_sym_u25c7] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5698),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [anon_sym_ASSUME] = ACTIONS(5698),
    [anon_sym_ASSUMPTION] = ACTIONS(5698),
    [anon_sym_AXIOM] = ACTIONS(5698),
    [anon_sym_THEOREM] = ACTIONS(5698),
    [anon_sym_PROPOSITION] = ACTIONS(5698),
    [anon_sym_LEMMA] = ACTIONS(5698),
    [anon_sym_COROLLARY] = ACTIONS(5698),
    [anon_sym_PROOF] = ACTIONS(5698),
    [anon_sym_BY] = ACTIONS(5698),
    [anon_sym_OBVIOUS] = ACTIONS(5698),
    [anon_sym_OMITTED] = ACTIONS(5698),
    [anon_sym_USE] = ACTIONS(5698),
    [anon_sym_HIDE] = ACTIONS(5698),
    [sym__begin_proof] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [2236] = {
    [sym_block_comment] = STATE(2236),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5704),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_LOCAL] = ACTIONS(5706),
    [anon_sym_VARIABLE] = ACTIONS(5706),
    [anon_sym_VARIABLES] = ACTIONS(5706),
    [anon_sym_CONSTANT] = ACTIONS(5706),
    [anon_sym_CONSTANTS] = ACTIONS(5706),
    [anon_sym_RECURSIVE] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_INSTANCE] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5706),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_ASSUME] = ACTIONS(5706),
    [anon_sym_ASSUMPTION] = ACTIONS(5706),
    [anon_sym_AXIOM] = ACTIONS(5706),
    [anon_sym_THEOREM] = ACTIONS(5706),
    [anon_sym_PROPOSITION] = ACTIONS(5706),
    [anon_sym_LEMMA] = ACTIONS(5706),
    [anon_sym_COROLLARY] = ACTIONS(5706),
    [anon_sym_PROOF] = ACTIONS(5706),
    [anon_sym_BY] = ACTIONS(5706),
    [anon_sym_OBVIOUS] = ACTIONS(5706),
    [anon_sym_OMITTED] = ACTIONS(5706),
    [anon_sym_USE] = ACTIONS(5706),
    [anon_sym_HIDE] = ACTIONS(5706),
    [sym__begin_proof] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2237] = {
    [sym_block_comment] = STATE(2237),
    [ts_builtin_sym_end] = ACTIONS(5716),
    [sym_identifier] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5716),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_LOCAL] = ACTIONS(5718),
    [anon_sym_VARIABLE] = ACTIONS(5718),
    [anon_sym_VARIABLES] = ACTIONS(5718),
    [anon_sym_CONSTANT] = ACTIONS(5718),
    [anon_sym_CONSTANTS] = ACTIONS(5718),
    [anon_sym_RECURSIVE] = ACTIONS(5718),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_INSTANCE] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_Nat] = ACTIONS(5718),
    [anon_sym_u2115] = ACTIONS(5716),
    [anon_sym_Int] = ACTIONS(5718),
    [anon_sym_u2124] = ACTIONS(5716),
    [anon_sym_Real] = ACTIONS(5718),
    [anon_sym_u211d] = ACTIONS(5716),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_BSLASHlnot] = ACTIONS(5716),
    [anon_sym_BSLASHneg] = ACTIONS(5716),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_u00ac] = ACTIONS(5716),
    [sym_union] = ACTIONS(5718),
    [sym_powerset] = ACTIONS(5718),
    [sym_domain] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [sym_negative_dot] = ACTIONS(5716),
    [sym_enabled] = ACTIONS(5718),
    [sym_unchanged] = ACTIONS(5718),
    [anon_sym_LT_GT] = ACTIONS(5716),
    [anon_sym_u22c4] = ACTIONS(5716),
    [anon_sym_u25c7] = ACTIONS(5716),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5718),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [anon_sym_ASSUME] = ACTIONS(5718),
    [anon_sym_ASSUMPTION] = ACTIONS(5718),
    [anon_sym_AXIOM] = ACTIONS(5718),
    [anon_sym_THEOREM] = ACTIONS(5718),
    [anon_sym_PROPOSITION] = ACTIONS(5718),
    [anon_sym_LEMMA] = ACTIONS(5718),
    [anon_sym_COROLLARY] = ACTIONS(5718),
    [anon_sym_PROOF] = ACTIONS(5718),
    [anon_sym_BY] = ACTIONS(5718),
    [anon_sym_OBVIOUS] = ACTIONS(5718),
    [anon_sym_OMITTED] = ACTIONS(5718),
    [anon_sym_USE] = ACTIONS(5718),
    [anon_sym_HIDE] = ACTIONS(5718),
    [sym__begin_proof] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [2238] = {
    [sym_block_comment] = STATE(2238),
    [sym_identifier] = ACTIONS(5720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5722),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_LOCAL] = ACTIONS(5720),
    [anon_sym_VARIABLE] = ACTIONS(5720),
    [anon_sym_VARIABLES] = ACTIONS(5720),
    [anon_sym_CONSTANT] = ACTIONS(5720),
    [anon_sym_CONSTANTS] = ACTIONS(5720),
    [anon_sym_RECURSIVE] = ACTIONS(5720),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_INSTANCE] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_Nat] = ACTIONS(5720),
    [anon_sym_u2115] = ACTIONS(5722),
    [anon_sym_Int] = ACTIONS(5720),
    [anon_sym_u2124] = ACTIONS(5722),
    [anon_sym_Real] = ACTIONS(5720),
    [anon_sym_u211d] = ACTIONS(5722),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_BSLASHlnot] = ACTIONS(5722),
    [anon_sym_BSLASHneg] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5720),
    [anon_sym_u00ac] = ACTIONS(5722),
    [sym_union] = ACTIONS(5720),
    [sym_powerset] = ACTIONS(5720),
    [sym_domain] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [sym_negative_dot] = ACTIONS(5722),
    [sym_enabled] = ACTIONS(5720),
    [sym_unchanged] = ACTIONS(5720),
    [anon_sym_LT_GT] = ACTIONS(5722),
    [anon_sym_u22c4] = ACTIONS(5722),
    [anon_sym_u25c7] = ACTIONS(5722),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5720),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [anon_sym_ASSUME] = ACTIONS(5720),
    [anon_sym_ASSUMPTION] = ACTIONS(5720),
    [anon_sym_AXIOM] = ACTIONS(5720),
    [anon_sym_THEOREM] = ACTIONS(5720),
    [anon_sym_PROPOSITION] = ACTIONS(5720),
    [anon_sym_LEMMA] = ACTIONS(5720),
    [anon_sym_COROLLARY] = ACTIONS(5720),
    [anon_sym_PROOF] = ACTIONS(5720),
    [anon_sym_BY] = ACTIONS(5720),
    [anon_sym_OBVIOUS] = ACTIONS(5720),
    [anon_sym_OMITTED] = ACTIONS(5720),
    [anon_sym_USE] = ACTIONS(5720),
    [anon_sym_HIDE] = ACTIONS(5720),
    [sym__begin_proof] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [2239] = {
    [sym_block_comment] = STATE(2239),
    [ts_builtin_sym_end] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5690),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LOCAL] = ACTIONS(5688),
    [anon_sym_VARIABLE] = ACTIONS(5688),
    [anon_sym_VARIABLES] = ACTIONS(5688),
    [anon_sym_CONSTANT] = ACTIONS(5688),
    [anon_sym_CONSTANTS] = ACTIONS(5688),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5688),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_ASSUME] = ACTIONS(5688),
    [anon_sym_ASSUMPTION] = ACTIONS(5688),
    [anon_sym_AXIOM] = ACTIONS(5688),
    [anon_sym_THEOREM] = ACTIONS(5688),
    [anon_sym_PROPOSITION] = ACTIONS(5688),
    [anon_sym_LEMMA] = ACTIONS(5688),
    [anon_sym_COROLLARY] = ACTIONS(5688),
    [anon_sym_PROOF] = ACTIONS(5688),
    [anon_sym_BY] = ACTIONS(5688),
    [anon_sym_OBVIOUS] = ACTIONS(5688),
    [anon_sym_OMITTED] = ACTIONS(5688),
    [anon_sym_USE] = ACTIONS(5688),
    [anon_sym_HIDE] = ACTIONS(5688),
    [sym__begin_proof] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2240] = {
    [sym_block_comment] = STATE(2240),
    [ts_builtin_sym_end] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5690),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LOCAL] = ACTIONS(5688),
    [anon_sym_VARIABLE] = ACTIONS(5688),
    [anon_sym_VARIABLES] = ACTIONS(5688),
    [anon_sym_CONSTANT] = ACTIONS(5688),
    [anon_sym_CONSTANTS] = ACTIONS(5688),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5688),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_ASSUME] = ACTIONS(5688),
    [anon_sym_ASSUMPTION] = ACTIONS(5688),
    [anon_sym_AXIOM] = ACTIONS(5688),
    [anon_sym_THEOREM] = ACTIONS(5688),
    [anon_sym_PROPOSITION] = ACTIONS(5688),
    [anon_sym_LEMMA] = ACTIONS(5688),
    [anon_sym_COROLLARY] = ACTIONS(5688),
    [anon_sym_PROOF] = ACTIONS(5688),
    [anon_sym_BY] = ACTIONS(5688),
    [anon_sym_OBVIOUS] = ACTIONS(5688),
    [anon_sym_OMITTED] = ACTIONS(5688),
    [anon_sym_USE] = ACTIONS(5688),
    [anon_sym_HIDE] = ACTIONS(5688),
    [sym__begin_proof] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2241] = {
    [sym_block_comment] = STATE(2241),
    [sym_identifier] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5716),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_LOCAL] = ACTIONS(5718),
    [anon_sym_VARIABLE] = ACTIONS(5718),
    [anon_sym_VARIABLES] = ACTIONS(5718),
    [anon_sym_CONSTANT] = ACTIONS(5718),
    [anon_sym_CONSTANTS] = ACTIONS(5718),
    [anon_sym_RECURSIVE] = ACTIONS(5718),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_INSTANCE] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_Nat] = ACTIONS(5718),
    [anon_sym_u2115] = ACTIONS(5716),
    [anon_sym_Int] = ACTIONS(5718),
    [anon_sym_u2124] = ACTIONS(5716),
    [anon_sym_Real] = ACTIONS(5718),
    [anon_sym_u211d] = ACTIONS(5716),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_BSLASHlnot] = ACTIONS(5716),
    [anon_sym_BSLASHneg] = ACTIONS(5716),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_u00ac] = ACTIONS(5716),
    [sym_union] = ACTIONS(5718),
    [sym_powerset] = ACTIONS(5718),
    [sym_domain] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [sym_negative_dot] = ACTIONS(5716),
    [sym_enabled] = ACTIONS(5718),
    [sym_unchanged] = ACTIONS(5718),
    [anon_sym_LT_GT] = ACTIONS(5716),
    [anon_sym_u22c4] = ACTIONS(5716),
    [anon_sym_u25c7] = ACTIONS(5716),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5718),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [anon_sym_ASSUME] = ACTIONS(5718),
    [anon_sym_ASSUMPTION] = ACTIONS(5718),
    [anon_sym_AXIOM] = ACTIONS(5718),
    [anon_sym_THEOREM] = ACTIONS(5718),
    [anon_sym_PROPOSITION] = ACTIONS(5718),
    [anon_sym_LEMMA] = ACTIONS(5718),
    [anon_sym_COROLLARY] = ACTIONS(5718),
    [anon_sym_PROOF] = ACTIONS(5718),
    [anon_sym_BY] = ACTIONS(5718),
    [anon_sym_OBVIOUS] = ACTIONS(5718),
    [anon_sym_OMITTED] = ACTIONS(5718),
    [anon_sym_USE] = ACTIONS(5718),
    [anon_sym_HIDE] = ACTIONS(5718),
    [sym__begin_proof] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [2242] = {
    [sym_block_comment] = STATE(2242),
    [sym_identifier] = ACTIONS(5702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5700),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_LOCAL] = ACTIONS(5702),
    [anon_sym_VARIABLE] = ACTIONS(5702),
    [anon_sym_VARIABLES] = ACTIONS(5702),
    [anon_sym_CONSTANT] = ACTIONS(5702),
    [anon_sym_CONSTANTS] = ACTIONS(5702),
    [anon_sym_RECURSIVE] = ACTIONS(5702),
    [anon_sym_LPAREN] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_INSTANCE] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_Nat] = ACTIONS(5702),
    [anon_sym_u2115] = ACTIONS(5700),
    [anon_sym_Int] = ACTIONS(5702),
    [anon_sym_u2124] = ACTIONS(5700),
    [anon_sym_Real] = ACTIONS(5702),
    [anon_sym_u211d] = ACTIONS(5700),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_BSLASHlnot] = ACTIONS(5700),
    [anon_sym_BSLASHneg] = ACTIONS(5700),
    [anon_sym_TILDE] = ACTIONS(5702),
    [anon_sym_u00ac] = ACTIONS(5700),
    [sym_union] = ACTIONS(5702),
    [sym_powerset] = ACTIONS(5702),
    [sym_domain] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [sym_negative_dot] = ACTIONS(5700),
    [sym_enabled] = ACTIONS(5702),
    [sym_unchanged] = ACTIONS(5702),
    [anon_sym_LT_GT] = ACTIONS(5700),
    [anon_sym_u22c4] = ACTIONS(5700),
    [anon_sym_u25c7] = ACTIONS(5700),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5702),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [anon_sym_ASSUME] = ACTIONS(5702),
    [anon_sym_ASSUMPTION] = ACTIONS(5702),
    [anon_sym_AXIOM] = ACTIONS(5702),
    [anon_sym_THEOREM] = ACTIONS(5702),
    [anon_sym_PROPOSITION] = ACTIONS(5702),
    [anon_sym_LEMMA] = ACTIONS(5702),
    [anon_sym_COROLLARY] = ACTIONS(5702),
    [anon_sym_PROOF] = ACTIONS(5702),
    [anon_sym_BY] = ACTIONS(5702),
    [anon_sym_OBVIOUS] = ACTIONS(5702),
    [anon_sym_OMITTED] = ACTIONS(5702),
    [anon_sym_USE] = ACTIONS(5702),
    [anon_sym_HIDE] = ACTIONS(5702),
    [sym__begin_proof] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [2243] = {
    [sym_block_comment] = STATE(2243),
    [ts_builtin_sym_end] = ACTIONS(5722),
    [sym_identifier] = ACTIONS(5720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5722),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_LOCAL] = ACTIONS(5720),
    [anon_sym_VARIABLE] = ACTIONS(5720),
    [anon_sym_VARIABLES] = ACTIONS(5720),
    [anon_sym_CONSTANT] = ACTIONS(5720),
    [anon_sym_CONSTANTS] = ACTIONS(5720),
    [anon_sym_RECURSIVE] = ACTIONS(5720),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_INSTANCE] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_Nat] = ACTIONS(5720),
    [anon_sym_u2115] = ACTIONS(5722),
    [anon_sym_Int] = ACTIONS(5720),
    [anon_sym_u2124] = ACTIONS(5722),
    [anon_sym_Real] = ACTIONS(5720),
    [anon_sym_u211d] = ACTIONS(5722),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_BSLASHlnot] = ACTIONS(5722),
    [anon_sym_BSLASHneg] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5720),
    [anon_sym_u00ac] = ACTIONS(5722),
    [sym_union] = ACTIONS(5720),
    [sym_powerset] = ACTIONS(5720),
    [sym_domain] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [sym_negative_dot] = ACTIONS(5722),
    [sym_enabled] = ACTIONS(5720),
    [sym_unchanged] = ACTIONS(5720),
    [anon_sym_LT_GT] = ACTIONS(5722),
    [anon_sym_u22c4] = ACTIONS(5722),
    [anon_sym_u25c7] = ACTIONS(5722),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5720),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [anon_sym_ASSUME] = ACTIONS(5720),
    [anon_sym_ASSUMPTION] = ACTIONS(5720),
    [anon_sym_AXIOM] = ACTIONS(5720),
    [anon_sym_THEOREM] = ACTIONS(5720),
    [anon_sym_PROPOSITION] = ACTIONS(5720),
    [anon_sym_LEMMA] = ACTIONS(5720),
    [anon_sym_COROLLARY] = ACTIONS(5720),
    [anon_sym_PROOF] = ACTIONS(5720),
    [anon_sym_BY] = ACTIONS(5720),
    [anon_sym_OBVIOUS] = ACTIONS(5720),
    [anon_sym_OMITTED] = ACTIONS(5720),
    [anon_sym_USE] = ACTIONS(5720),
    [anon_sym_HIDE] = ACTIONS(5720),
    [sym__begin_proof] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [2244] = {
    [sym_block_comment] = STATE(2244),
    [sym_identifier] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5712),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_LOCAL] = ACTIONS(5714),
    [anon_sym_VARIABLE] = ACTIONS(5714),
    [anon_sym_VARIABLES] = ACTIONS(5714),
    [anon_sym_CONSTANT] = ACTIONS(5714),
    [anon_sym_CONSTANTS] = ACTIONS(5714),
    [anon_sym_RECURSIVE] = ACTIONS(5714),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_INSTANCE] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_Nat] = ACTIONS(5714),
    [anon_sym_u2115] = ACTIONS(5712),
    [anon_sym_Int] = ACTIONS(5714),
    [anon_sym_u2124] = ACTIONS(5712),
    [anon_sym_Real] = ACTIONS(5714),
    [anon_sym_u211d] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_BSLASHlnot] = ACTIONS(5712),
    [anon_sym_BSLASHneg] = ACTIONS(5712),
    [anon_sym_TILDE] = ACTIONS(5714),
    [anon_sym_u00ac] = ACTIONS(5712),
    [sym_union] = ACTIONS(5714),
    [sym_powerset] = ACTIONS(5714),
    [sym_domain] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [sym_negative_dot] = ACTIONS(5712),
    [sym_enabled] = ACTIONS(5714),
    [sym_unchanged] = ACTIONS(5714),
    [anon_sym_LT_GT] = ACTIONS(5712),
    [anon_sym_u22c4] = ACTIONS(5712),
    [anon_sym_u25c7] = ACTIONS(5712),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5714),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [anon_sym_ASSUME] = ACTIONS(5714),
    [anon_sym_ASSUMPTION] = ACTIONS(5714),
    [anon_sym_AXIOM] = ACTIONS(5714),
    [anon_sym_THEOREM] = ACTIONS(5714),
    [anon_sym_PROPOSITION] = ACTIONS(5714),
    [anon_sym_LEMMA] = ACTIONS(5714),
    [anon_sym_COROLLARY] = ACTIONS(5714),
    [anon_sym_PROOF] = ACTIONS(5714),
    [anon_sym_BY] = ACTIONS(5714),
    [anon_sym_OBVIOUS] = ACTIONS(5714),
    [anon_sym_OMITTED] = ACTIONS(5714),
    [anon_sym_USE] = ACTIONS(5714),
    [anon_sym_HIDE] = ACTIONS(5714),
    [sym__begin_proof] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [2245] = {
    [sym_block_comment] = STATE(2245),
    [ts_builtin_sym_end] = ACTIONS(5724),
    [sym_identifier] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5724),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_LOCAL] = ACTIONS(5726),
    [anon_sym_VARIABLE] = ACTIONS(5726),
    [anon_sym_VARIABLES] = ACTIONS(5726),
    [anon_sym_CONSTANT] = ACTIONS(5726),
    [anon_sym_CONSTANTS] = ACTIONS(5726),
    [anon_sym_RECURSIVE] = ACTIONS(5726),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_INSTANCE] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_Nat] = ACTIONS(5726),
    [anon_sym_u2115] = ACTIONS(5724),
    [anon_sym_Int] = ACTIONS(5726),
    [anon_sym_u2124] = ACTIONS(5724),
    [anon_sym_Real] = ACTIONS(5726),
    [anon_sym_u211d] = ACTIONS(5724),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_BSLASHlnot] = ACTIONS(5724),
    [anon_sym_BSLASHneg] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5726),
    [anon_sym_u00ac] = ACTIONS(5724),
    [sym_union] = ACTIONS(5726),
    [sym_powerset] = ACTIONS(5726),
    [sym_domain] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [sym_negative_dot] = ACTIONS(5724),
    [sym_enabled] = ACTIONS(5726),
    [sym_unchanged] = ACTIONS(5726),
    [anon_sym_LT_GT] = ACTIONS(5724),
    [anon_sym_u22c4] = ACTIONS(5724),
    [anon_sym_u25c7] = ACTIONS(5724),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5726),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [anon_sym_ASSUME] = ACTIONS(5726),
    [anon_sym_ASSUMPTION] = ACTIONS(5726),
    [anon_sym_AXIOM] = ACTIONS(5726),
    [anon_sym_THEOREM] = ACTIONS(5726),
    [anon_sym_PROPOSITION] = ACTIONS(5726),
    [anon_sym_LEMMA] = ACTIONS(5726),
    [anon_sym_COROLLARY] = ACTIONS(5726),
    [anon_sym_PROOF] = ACTIONS(5726),
    [anon_sym_BY] = ACTIONS(5726),
    [anon_sym_OBVIOUS] = ACTIONS(5726),
    [anon_sym_OMITTED] = ACTIONS(5726),
    [anon_sym_USE] = ACTIONS(5726),
    [anon_sym_HIDE] = ACTIONS(5726),
    [sym__begin_proof] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [2246] = {
    [sym_block_comment] = STATE(2246),
    [ts_builtin_sym_end] = ACTIONS(5728),
    [sym_identifier] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5728),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_LOCAL] = ACTIONS(5730),
    [anon_sym_VARIABLE] = ACTIONS(5730),
    [anon_sym_VARIABLES] = ACTIONS(5730),
    [anon_sym_CONSTANT] = ACTIONS(5730),
    [anon_sym_CONSTANTS] = ACTIONS(5730),
    [anon_sym_RECURSIVE] = ACTIONS(5730),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_INSTANCE] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_Nat] = ACTIONS(5730),
    [anon_sym_u2115] = ACTIONS(5728),
    [anon_sym_Int] = ACTIONS(5730),
    [anon_sym_u2124] = ACTIONS(5728),
    [anon_sym_Real] = ACTIONS(5730),
    [anon_sym_u211d] = ACTIONS(5728),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_BSLASHlnot] = ACTIONS(5728),
    [anon_sym_BSLASHneg] = ACTIONS(5728),
    [anon_sym_TILDE] = ACTIONS(5730),
    [anon_sym_u00ac] = ACTIONS(5728),
    [sym_union] = ACTIONS(5730),
    [sym_powerset] = ACTIONS(5730),
    [sym_domain] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [sym_negative_dot] = ACTIONS(5728),
    [sym_enabled] = ACTIONS(5730),
    [sym_unchanged] = ACTIONS(5730),
    [anon_sym_LT_GT] = ACTIONS(5728),
    [anon_sym_u22c4] = ACTIONS(5728),
    [anon_sym_u25c7] = ACTIONS(5728),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5730),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [anon_sym_ASSUME] = ACTIONS(5730),
    [anon_sym_ASSUMPTION] = ACTIONS(5730),
    [anon_sym_AXIOM] = ACTIONS(5730),
    [anon_sym_THEOREM] = ACTIONS(5730),
    [anon_sym_PROPOSITION] = ACTIONS(5730),
    [anon_sym_LEMMA] = ACTIONS(5730),
    [anon_sym_COROLLARY] = ACTIONS(5730),
    [anon_sym_PROOF] = ACTIONS(5730),
    [anon_sym_BY] = ACTIONS(5730),
    [anon_sym_OBVIOUS] = ACTIONS(5730),
    [anon_sym_OMITTED] = ACTIONS(5730),
    [anon_sym_USE] = ACTIONS(5730),
    [anon_sym_HIDE] = ACTIONS(5730),
    [sym__begin_proof] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [2247] = {
    [sym_block_comment] = STATE(2247),
    [ts_builtin_sym_end] = ACTIONS(5704),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5704),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_LOCAL] = ACTIONS(5706),
    [anon_sym_VARIABLE] = ACTIONS(5706),
    [anon_sym_VARIABLES] = ACTIONS(5706),
    [anon_sym_CONSTANT] = ACTIONS(5706),
    [anon_sym_CONSTANTS] = ACTIONS(5706),
    [anon_sym_RECURSIVE] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_INSTANCE] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5706),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_ASSUME] = ACTIONS(5706),
    [anon_sym_ASSUMPTION] = ACTIONS(5706),
    [anon_sym_AXIOM] = ACTIONS(5706),
    [anon_sym_THEOREM] = ACTIONS(5706),
    [anon_sym_PROPOSITION] = ACTIONS(5706),
    [anon_sym_LEMMA] = ACTIONS(5706),
    [anon_sym_COROLLARY] = ACTIONS(5706),
    [anon_sym_PROOF] = ACTIONS(5706),
    [anon_sym_BY] = ACTIONS(5706),
    [anon_sym_OBVIOUS] = ACTIONS(5706),
    [anon_sym_OMITTED] = ACTIONS(5706),
    [anon_sym_USE] = ACTIONS(5706),
    [anon_sym_HIDE] = ACTIONS(5706),
    [sym__begin_proof] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2248] = {
    [sym_block_comment] = STATE(2248),
    [ts_builtin_sym_end] = ACTIONS(5732),
    [sym_identifier] = ACTIONS(5734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5732),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_LOCAL] = ACTIONS(5734),
    [anon_sym_VARIABLE] = ACTIONS(5734),
    [anon_sym_VARIABLES] = ACTIONS(5734),
    [anon_sym_CONSTANT] = ACTIONS(5734),
    [anon_sym_CONSTANTS] = ACTIONS(5734),
    [anon_sym_RECURSIVE] = ACTIONS(5734),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_INSTANCE] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_Nat] = ACTIONS(5734),
    [anon_sym_u2115] = ACTIONS(5732),
    [anon_sym_Int] = ACTIONS(5734),
    [anon_sym_u2124] = ACTIONS(5732),
    [anon_sym_Real] = ACTIONS(5734),
    [anon_sym_u211d] = ACTIONS(5732),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_BSLASHlnot] = ACTIONS(5732),
    [anon_sym_BSLASHneg] = ACTIONS(5732),
    [anon_sym_TILDE] = ACTIONS(5734),
    [anon_sym_u00ac] = ACTIONS(5732),
    [sym_union] = ACTIONS(5734),
    [sym_powerset] = ACTIONS(5734),
    [sym_domain] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [sym_negative_dot] = ACTIONS(5732),
    [sym_enabled] = ACTIONS(5734),
    [sym_unchanged] = ACTIONS(5734),
    [anon_sym_LT_GT] = ACTIONS(5732),
    [anon_sym_u22c4] = ACTIONS(5732),
    [anon_sym_u25c7] = ACTIONS(5732),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5734),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [anon_sym_ASSUME] = ACTIONS(5734),
    [anon_sym_ASSUMPTION] = ACTIONS(5734),
    [anon_sym_AXIOM] = ACTIONS(5734),
    [anon_sym_THEOREM] = ACTIONS(5734),
    [anon_sym_PROPOSITION] = ACTIONS(5734),
    [anon_sym_LEMMA] = ACTIONS(5734),
    [anon_sym_COROLLARY] = ACTIONS(5734),
    [anon_sym_PROOF] = ACTIONS(5734),
    [anon_sym_BY] = ACTIONS(5734),
    [anon_sym_OBVIOUS] = ACTIONS(5734),
    [anon_sym_OMITTED] = ACTIONS(5734),
    [anon_sym_USE] = ACTIONS(5734),
    [anon_sym_HIDE] = ACTIONS(5734),
    [sym__begin_proof] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [2249] = {
    [sym_block_comment] = STATE(2249),
    [ts_builtin_sym_end] = ACTIONS(5736),
    [sym_identifier] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5736),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_LOCAL] = ACTIONS(5738),
    [anon_sym_VARIABLE] = ACTIONS(5738),
    [anon_sym_VARIABLES] = ACTIONS(5738),
    [anon_sym_CONSTANT] = ACTIONS(5738),
    [anon_sym_CONSTANTS] = ACTIONS(5738),
    [anon_sym_RECURSIVE] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_INSTANCE] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_Nat] = ACTIONS(5738),
    [anon_sym_u2115] = ACTIONS(5736),
    [anon_sym_Int] = ACTIONS(5738),
    [anon_sym_u2124] = ACTIONS(5736),
    [anon_sym_Real] = ACTIONS(5738),
    [anon_sym_u211d] = ACTIONS(5736),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_BSLASHlnot] = ACTIONS(5736),
    [anon_sym_BSLASHneg] = ACTIONS(5736),
    [anon_sym_TILDE] = ACTIONS(5738),
    [anon_sym_u00ac] = ACTIONS(5736),
    [sym_union] = ACTIONS(5738),
    [sym_powerset] = ACTIONS(5738),
    [sym_domain] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [sym_negative_dot] = ACTIONS(5736),
    [sym_enabled] = ACTIONS(5738),
    [sym_unchanged] = ACTIONS(5738),
    [anon_sym_LT_GT] = ACTIONS(5736),
    [anon_sym_u22c4] = ACTIONS(5736),
    [anon_sym_u25c7] = ACTIONS(5736),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5738),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [anon_sym_ASSUME] = ACTIONS(5738),
    [anon_sym_ASSUMPTION] = ACTIONS(5738),
    [anon_sym_AXIOM] = ACTIONS(5738),
    [anon_sym_THEOREM] = ACTIONS(5738),
    [anon_sym_PROPOSITION] = ACTIONS(5738),
    [anon_sym_LEMMA] = ACTIONS(5738),
    [anon_sym_COROLLARY] = ACTIONS(5738),
    [anon_sym_PROOF] = ACTIONS(5738),
    [anon_sym_BY] = ACTIONS(5738),
    [anon_sym_OBVIOUS] = ACTIONS(5738),
    [anon_sym_OMITTED] = ACTIONS(5738),
    [anon_sym_USE] = ACTIONS(5738),
    [anon_sym_HIDE] = ACTIONS(5738),
    [sym__begin_proof] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [2250] = {
    [sym_block_comment] = STATE(2250),
    [sym_case_box] = STATE(235),
    [aux_sym_case_repeat1] = STATE(2250),
    [ts_builtin_sym_end] = ACTIONS(5663),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5663),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LOCAL] = ACTIONS(5665),
    [anon_sym_VARIABLE] = ACTIONS(5665),
    [anon_sym_VARIABLES] = ACTIONS(5665),
    [anon_sym_CONSTANT] = ACTIONS(5665),
    [anon_sym_CONSTANTS] = ACTIONS(5665),
    [anon_sym_RECURSIVE] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_INSTANCE] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5665),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_ASSUME] = ACTIONS(5665),
    [anon_sym_ASSUMPTION] = ACTIONS(5665),
    [anon_sym_AXIOM] = ACTIONS(5665),
    [anon_sym_THEOREM] = ACTIONS(5665),
    [anon_sym_PROPOSITION] = ACTIONS(5665),
    [anon_sym_LEMMA] = ACTIONS(5665),
    [anon_sym_COROLLARY] = ACTIONS(5665),
    [anon_sym_USE] = ACTIONS(5665),
    [anon_sym_HIDE] = ACTIONS(5665),
    [anon_sym_DEF] = ACTIONS(5665),
    [anon_sym_DEFS] = ACTIONS(5665),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2251] = {
    [sym_block_comment] = STATE(2251),
    [ts_builtin_sym_end] = ACTIONS(5740),
    [sym_identifier] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5740),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_LOCAL] = ACTIONS(5742),
    [anon_sym_VARIABLE] = ACTIONS(5742),
    [anon_sym_VARIABLES] = ACTIONS(5742),
    [anon_sym_CONSTANT] = ACTIONS(5742),
    [anon_sym_CONSTANTS] = ACTIONS(5742),
    [anon_sym_RECURSIVE] = ACTIONS(5742),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_INSTANCE] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_Nat] = ACTIONS(5742),
    [anon_sym_u2115] = ACTIONS(5740),
    [anon_sym_Int] = ACTIONS(5742),
    [anon_sym_u2124] = ACTIONS(5740),
    [anon_sym_Real] = ACTIONS(5742),
    [anon_sym_u211d] = ACTIONS(5740),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_BSLASHlnot] = ACTIONS(5740),
    [anon_sym_BSLASHneg] = ACTIONS(5740),
    [anon_sym_TILDE] = ACTIONS(5742),
    [anon_sym_u00ac] = ACTIONS(5740),
    [sym_union] = ACTIONS(5742),
    [sym_powerset] = ACTIONS(5742),
    [sym_domain] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [sym_negative_dot] = ACTIONS(5740),
    [sym_enabled] = ACTIONS(5742),
    [sym_unchanged] = ACTIONS(5742),
    [anon_sym_LT_GT] = ACTIONS(5740),
    [anon_sym_u22c4] = ACTIONS(5740),
    [anon_sym_u25c7] = ACTIONS(5740),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5742),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [anon_sym_ASSUME] = ACTIONS(5742),
    [anon_sym_ASSUMPTION] = ACTIONS(5742),
    [anon_sym_AXIOM] = ACTIONS(5742),
    [anon_sym_THEOREM] = ACTIONS(5742),
    [anon_sym_PROPOSITION] = ACTIONS(5742),
    [anon_sym_LEMMA] = ACTIONS(5742),
    [anon_sym_COROLLARY] = ACTIONS(5742),
    [anon_sym_PROOF] = ACTIONS(5742),
    [anon_sym_BY] = ACTIONS(5742),
    [anon_sym_OBVIOUS] = ACTIONS(5742),
    [anon_sym_OMITTED] = ACTIONS(5742),
    [anon_sym_USE] = ACTIONS(5742),
    [anon_sym_HIDE] = ACTIONS(5742),
    [sym__begin_proof] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [2252] = {
    [sym_block_comment] = STATE(2252),
    [ts_builtin_sym_end] = ACTIONS(5744),
    [sym_identifier] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5744),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_LOCAL] = ACTIONS(5746),
    [anon_sym_VARIABLE] = ACTIONS(5746),
    [anon_sym_VARIABLES] = ACTIONS(5746),
    [anon_sym_CONSTANT] = ACTIONS(5746),
    [anon_sym_CONSTANTS] = ACTIONS(5746),
    [anon_sym_RECURSIVE] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_INSTANCE] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_Nat] = ACTIONS(5746),
    [anon_sym_u2115] = ACTIONS(5744),
    [anon_sym_Int] = ACTIONS(5746),
    [anon_sym_u2124] = ACTIONS(5744),
    [anon_sym_Real] = ACTIONS(5746),
    [anon_sym_u211d] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_BSLASHlnot] = ACTIONS(5744),
    [anon_sym_BSLASHneg] = ACTIONS(5744),
    [anon_sym_TILDE] = ACTIONS(5746),
    [anon_sym_u00ac] = ACTIONS(5744),
    [sym_union] = ACTIONS(5746),
    [sym_powerset] = ACTIONS(5746),
    [sym_domain] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [sym_negative_dot] = ACTIONS(5744),
    [sym_enabled] = ACTIONS(5746),
    [sym_unchanged] = ACTIONS(5746),
    [anon_sym_LT_GT] = ACTIONS(5744),
    [anon_sym_u22c4] = ACTIONS(5744),
    [anon_sym_u25c7] = ACTIONS(5744),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5746),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [anon_sym_ASSUME] = ACTIONS(5746),
    [anon_sym_ASSUMPTION] = ACTIONS(5746),
    [anon_sym_AXIOM] = ACTIONS(5746),
    [anon_sym_THEOREM] = ACTIONS(5746),
    [anon_sym_PROPOSITION] = ACTIONS(5746),
    [anon_sym_LEMMA] = ACTIONS(5746),
    [anon_sym_COROLLARY] = ACTIONS(5746),
    [anon_sym_PROOF] = ACTIONS(5746),
    [anon_sym_BY] = ACTIONS(5746),
    [anon_sym_OBVIOUS] = ACTIONS(5746),
    [anon_sym_OMITTED] = ACTIONS(5746),
    [anon_sym_USE] = ACTIONS(5746),
    [anon_sym_HIDE] = ACTIONS(5746),
    [sym__begin_proof] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [2253] = {
    [sym_block_comment] = STATE(2253),
    [ts_builtin_sym_end] = ACTIONS(5748),
    [sym_identifier] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5748),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_LOCAL] = ACTIONS(5750),
    [anon_sym_VARIABLE] = ACTIONS(5750),
    [anon_sym_VARIABLES] = ACTIONS(5750),
    [anon_sym_CONSTANT] = ACTIONS(5750),
    [anon_sym_CONSTANTS] = ACTIONS(5750),
    [anon_sym_RECURSIVE] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_INSTANCE] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_Nat] = ACTIONS(5750),
    [anon_sym_u2115] = ACTIONS(5748),
    [anon_sym_Int] = ACTIONS(5750),
    [anon_sym_u2124] = ACTIONS(5748),
    [anon_sym_Real] = ACTIONS(5750),
    [anon_sym_u211d] = ACTIONS(5748),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_BSLASHlnot] = ACTIONS(5748),
    [anon_sym_BSLASHneg] = ACTIONS(5748),
    [anon_sym_TILDE] = ACTIONS(5750),
    [anon_sym_u00ac] = ACTIONS(5748),
    [sym_union] = ACTIONS(5750),
    [sym_powerset] = ACTIONS(5750),
    [sym_domain] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [sym_negative_dot] = ACTIONS(5748),
    [sym_enabled] = ACTIONS(5750),
    [sym_unchanged] = ACTIONS(5750),
    [anon_sym_LT_GT] = ACTIONS(5748),
    [anon_sym_u22c4] = ACTIONS(5748),
    [anon_sym_u25c7] = ACTIONS(5748),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5750),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [anon_sym_ASSUME] = ACTIONS(5750),
    [anon_sym_ASSUMPTION] = ACTIONS(5750),
    [anon_sym_AXIOM] = ACTIONS(5750),
    [anon_sym_THEOREM] = ACTIONS(5750),
    [anon_sym_PROPOSITION] = ACTIONS(5750),
    [anon_sym_LEMMA] = ACTIONS(5750),
    [anon_sym_COROLLARY] = ACTIONS(5750),
    [anon_sym_PROOF] = ACTIONS(5750),
    [anon_sym_BY] = ACTIONS(5750),
    [anon_sym_OBVIOUS] = ACTIONS(5750),
    [anon_sym_OMITTED] = ACTIONS(5750),
    [anon_sym_USE] = ACTIONS(5750),
    [anon_sym_HIDE] = ACTIONS(5750),
    [sym__begin_proof] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [2254] = {
    [sym_block_comment] = STATE(2254),
    [ts_builtin_sym_end] = ACTIONS(5752),
    [sym_identifier] = ACTIONS(5754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5752),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_LOCAL] = ACTIONS(5754),
    [anon_sym_VARIABLE] = ACTIONS(5754),
    [anon_sym_VARIABLES] = ACTIONS(5754),
    [anon_sym_CONSTANT] = ACTIONS(5754),
    [anon_sym_CONSTANTS] = ACTIONS(5754),
    [anon_sym_RECURSIVE] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_INSTANCE] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_Nat] = ACTIONS(5754),
    [anon_sym_u2115] = ACTIONS(5752),
    [anon_sym_Int] = ACTIONS(5754),
    [anon_sym_u2124] = ACTIONS(5752),
    [anon_sym_Real] = ACTIONS(5754),
    [anon_sym_u211d] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_BSLASHlnot] = ACTIONS(5752),
    [anon_sym_BSLASHneg] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(5754),
    [anon_sym_u00ac] = ACTIONS(5752),
    [sym_union] = ACTIONS(5754),
    [sym_powerset] = ACTIONS(5754),
    [sym_domain] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [sym_negative_dot] = ACTIONS(5752),
    [sym_enabled] = ACTIONS(5754),
    [sym_unchanged] = ACTIONS(5754),
    [anon_sym_LT_GT] = ACTIONS(5752),
    [anon_sym_u22c4] = ACTIONS(5752),
    [anon_sym_u25c7] = ACTIONS(5752),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5754),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [anon_sym_ASSUME] = ACTIONS(5754),
    [anon_sym_ASSUMPTION] = ACTIONS(5754),
    [anon_sym_AXIOM] = ACTIONS(5754),
    [anon_sym_THEOREM] = ACTIONS(5754),
    [anon_sym_PROPOSITION] = ACTIONS(5754),
    [anon_sym_LEMMA] = ACTIONS(5754),
    [anon_sym_COROLLARY] = ACTIONS(5754),
    [anon_sym_PROOF] = ACTIONS(5754),
    [anon_sym_BY] = ACTIONS(5754),
    [anon_sym_OBVIOUS] = ACTIONS(5754),
    [anon_sym_OMITTED] = ACTIONS(5754),
    [anon_sym_USE] = ACTIONS(5754),
    [anon_sym_HIDE] = ACTIONS(5754),
    [sym__begin_proof] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [2255] = {
    [sym_block_comment] = STATE(2255),
    [ts_builtin_sym_end] = ACTIONS(5756),
    [sym_identifier] = ACTIONS(5758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5756),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_LOCAL] = ACTIONS(5758),
    [anon_sym_VARIABLE] = ACTIONS(5758),
    [anon_sym_VARIABLES] = ACTIONS(5758),
    [anon_sym_CONSTANT] = ACTIONS(5758),
    [anon_sym_CONSTANTS] = ACTIONS(5758),
    [anon_sym_RECURSIVE] = ACTIONS(5758),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_INSTANCE] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_Nat] = ACTIONS(5758),
    [anon_sym_u2115] = ACTIONS(5756),
    [anon_sym_Int] = ACTIONS(5758),
    [anon_sym_u2124] = ACTIONS(5756),
    [anon_sym_Real] = ACTIONS(5758),
    [anon_sym_u211d] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_BSLASHlnot] = ACTIONS(5756),
    [anon_sym_BSLASHneg] = ACTIONS(5756),
    [anon_sym_TILDE] = ACTIONS(5758),
    [anon_sym_u00ac] = ACTIONS(5756),
    [sym_union] = ACTIONS(5758),
    [sym_powerset] = ACTIONS(5758),
    [sym_domain] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [sym_negative_dot] = ACTIONS(5756),
    [sym_enabled] = ACTIONS(5758),
    [sym_unchanged] = ACTIONS(5758),
    [anon_sym_LT_GT] = ACTIONS(5756),
    [anon_sym_u22c4] = ACTIONS(5756),
    [anon_sym_u25c7] = ACTIONS(5756),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5758),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [anon_sym_ASSUME] = ACTIONS(5758),
    [anon_sym_ASSUMPTION] = ACTIONS(5758),
    [anon_sym_AXIOM] = ACTIONS(5758),
    [anon_sym_THEOREM] = ACTIONS(5758),
    [anon_sym_PROPOSITION] = ACTIONS(5758),
    [anon_sym_LEMMA] = ACTIONS(5758),
    [anon_sym_COROLLARY] = ACTIONS(5758),
    [anon_sym_PROOF] = ACTIONS(5758),
    [anon_sym_BY] = ACTIONS(5758),
    [anon_sym_OBVIOUS] = ACTIONS(5758),
    [anon_sym_OMITTED] = ACTIONS(5758),
    [anon_sym_USE] = ACTIONS(5758),
    [anon_sym_HIDE] = ACTIONS(5758),
    [sym__begin_proof] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [2256] = {
    [sym_block_comment] = STATE(2256),
    [ts_builtin_sym_end] = ACTIONS(5760),
    [sym_identifier] = ACTIONS(5762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5760),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_LOCAL] = ACTIONS(5762),
    [anon_sym_VARIABLE] = ACTIONS(5762),
    [anon_sym_VARIABLES] = ACTIONS(5762),
    [anon_sym_CONSTANT] = ACTIONS(5762),
    [anon_sym_CONSTANTS] = ACTIONS(5762),
    [anon_sym_RECURSIVE] = ACTIONS(5762),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_INSTANCE] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_Nat] = ACTIONS(5762),
    [anon_sym_u2115] = ACTIONS(5760),
    [anon_sym_Int] = ACTIONS(5762),
    [anon_sym_u2124] = ACTIONS(5760),
    [anon_sym_Real] = ACTIONS(5762),
    [anon_sym_u211d] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_BSLASHlnot] = ACTIONS(5760),
    [anon_sym_BSLASHneg] = ACTIONS(5760),
    [anon_sym_TILDE] = ACTIONS(5762),
    [anon_sym_u00ac] = ACTIONS(5760),
    [sym_union] = ACTIONS(5762),
    [sym_powerset] = ACTIONS(5762),
    [sym_domain] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [sym_negative_dot] = ACTIONS(5760),
    [sym_enabled] = ACTIONS(5762),
    [sym_unchanged] = ACTIONS(5762),
    [anon_sym_LT_GT] = ACTIONS(5760),
    [anon_sym_u22c4] = ACTIONS(5760),
    [anon_sym_u25c7] = ACTIONS(5760),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5762),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [anon_sym_ASSUME] = ACTIONS(5762),
    [anon_sym_ASSUMPTION] = ACTIONS(5762),
    [anon_sym_AXIOM] = ACTIONS(5762),
    [anon_sym_THEOREM] = ACTIONS(5762),
    [anon_sym_PROPOSITION] = ACTIONS(5762),
    [anon_sym_LEMMA] = ACTIONS(5762),
    [anon_sym_COROLLARY] = ACTIONS(5762),
    [anon_sym_PROOF] = ACTIONS(5762),
    [anon_sym_BY] = ACTIONS(5762),
    [anon_sym_OBVIOUS] = ACTIONS(5762),
    [anon_sym_OMITTED] = ACTIONS(5762),
    [anon_sym_USE] = ACTIONS(5762),
    [anon_sym_HIDE] = ACTIONS(5762),
    [sym__begin_proof] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [2257] = {
    [sym_block_comment] = STATE(2257),
    [ts_builtin_sym_end] = ACTIONS(5764),
    [sym_identifier] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5764),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_LOCAL] = ACTIONS(5766),
    [anon_sym_VARIABLE] = ACTIONS(5766),
    [anon_sym_VARIABLES] = ACTIONS(5766),
    [anon_sym_CONSTANT] = ACTIONS(5766),
    [anon_sym_CONSTANTS] = ACTIONS(5766),
    [anon_sym_RECURSIVE] = ACTIONS(5766),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_INSTANCE] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_Nat] = ACTIONS(5766),
    [anon_sym_u2115] = ACTIONS(5764),
    [anon_sym_Int] = ACTIONS(5766),
    [anon_sym_u2124] = ACTIONS(5764),
    [anon_sym_Real] = ACTIONS(5766),
    [anon_sym_u211d] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_BSLASHlnot] = ACTIONS(5764),
    [anon_sym_BSLASHneg] = ACTIONS(5764),
    [anon_sym_TILDE] = ACTIONS(5766),
    [anon_sym_u00ac] = ACTIONS(5764),
    [sym_union] = ACTIONS(5766),
    [sym_powerset] = ACTIONS(5766),
    [sym_domain] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [sym_negative_dot] = ACTIONS(5764),
    [sym_enabled] = ACTIONS(5766),
    [sym_unchanged] = ACTIONS(5766),
    [anon_sym_LT_GT] = ACTIONS(5764),
    [anon_sym_u22c4] = ACTIONS(5764),
    [anon_sym_u25c7] = ACTIONS(5764),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5766),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [anon_sym_ASSUME] = ACTIONS(5766),
    [anon_sym_ASSUMPTION] = ACTIONS(5766),
    [anon_sym_AXIOM] = ACTIONS(5766),
    [anon_sym_THEOREM] = ACTIONS(5766),
    [anon_sym_PROPOSITION] = ACTIONS(5766),
    [anon_sym_LEMMA] = ACTIONS(5766),
    [anon_sym_COROLLARY] = ACTIONS(5766),
    [anon_sym_PROOF] = ACTIONS(5766),
    [anon_sym_BY] = ACTIONS(5766),
    [anon_sym_OBVIOUS] = ACTIONS(5766),
    [anon_sym_OMITTED] = ACTIONS(5766),
    [anon_sym_USE] = ACTIONS(5766),
    [anon_sym_HIDE] = ACTIONS(5766),
    [sym__begin_proof] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [2258] = {
    [sym_block_comment] = STATE(2258),
    [ts_builtin_sym_end] = ACTIONS(5768),
    [sym_identifier] = ACTIONS(5770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5768),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_LOCAL] = ACTIONS(5770),
    [anon_sym_VARIABLE] = ACTIONS(5770),
    [anon_sym_VARIABLES] = ACTIONS(5770),
    [anon_sym_CONSTANT] = ACTIONS(5770),
    [anon_sym_CONSTANTS] = ACTIONS(5770),
    [anon_sym_RECURSIVE] = ACTIONS(5770),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_INSTANCE] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_Nat] = ACTIONS(5770),
    [anon_sym_u2115] = ACTIONS(5768),
    [anon_sym_Int] = ACTIONS(5770),
    [anon_sym_u2124] = ACTIONS(5768),
    [anon_sym_Real] = ACTIONS(5770),
    [anon_sym_u211d] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_BSLASHlnot] = ACTIONS(5768),
    [anon_sym_BSLASHneg] = ACTIONS(5768),
    [anon_sym_TILDE] = ACTIONS(5770),
    [anon_sym_u00ac] = ACTIONS(5768),
    [sym_union] = ACTIONS(5770),
    [sym_powerset] = ACTIONS(5770),
    [sym_domain] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [sym_negative_dot] = ACTIONS(5768),
    [sym_enabled] = ACTIONS(5770),
    [sym_unchanged] = ACTIONS(5770),
    [anon_sym_LT_GT] = ACTIONS(5768),
    [anon_sym_u22c4] = ACTIONS(5768),
    [anon_sym_u25c7] = ACTIONS(5768),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5770),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [anon_sym_ASSUME] = ACTIONS(5770),
    [anon_sym_ASSUMPTION] = ACTIONS(5770),
    [anon_sym_AXIOM] = ACTIONS(5770),
    [anon_sym_THEOREM] = ACTIONS(5770),
    [anon_sym_PROPOSITION] = ACTIONS(5770),
    [anon_sym_LEMMA] = ACTIONS(5770),
    [anon_sym_COROLLARY] = ACTIONS(5770),
    [anon_sym_PROOF] = ACTIONS(5770),
    [anon_sym_BY] = ACTIONS(5770),
    [anon_sym_OBVIOUS] = ACTIONS(5770),
    [anon_sym_OMITTED] = ACTIONS(5770),
    [anon_sym_USE] = ACTIONS(5770),
    [anon_sym_HIDE] = ACTIONS(5770),
    [sym__begin_proof] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [2259] = {
    [sym_block_comment] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(5772),
    [sym_identifier] = ACTIONS(5774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5772),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_LOCAL] = ACTIONS(5774),
    [anon_sym_VARIABLE] = ACTIONS(5774),
    [anon_sym_VARIABLES] = ACTIONS(5774),
    [anon_sym_CONSTANT] = ACTIONS(5774),
    [anon_sym_CONSTANTS] = ACTIONS(5774),
    [anon_sym_RECURSIVE] = ACTIONS(5774),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_INSTANCE] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_Nat] = ACTIONS(5774),
    [anon_sym_u2115] = ACTIONS(5772),
    [anon_sym_Int] = ACTIONS(5774),
    [anon_sym_u2124] = ACTIONS(5772),
    [anon_sym_Real] = ACTIONS(5774),
    [anon_sym_u211d] = ACTIONS(5772),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_BSLASHlnot] = ACTIONS(5772),
    [anon_sym_BSLASHneg] = ACTIONS(5772),
    [anon_sym_TILDE] = ACTIONS(5774),
    [anon_sym_u00ac] = ACTIONS(5772),
    [sym_union] = ACTIONS(5774),
    [sym_powerset] = ACTIONS(5774),
    [sym_domain] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [sym_negative_dot] = ACTIONS(5772),
    [sym_enabled] = ACTIONS(5774),
    [sym_unchanged] = ACTIONS(5774),
    [anon_sym_LT_GT] = ACTIONS(5772),
    [anon_sym_u22c4] = ACTIONS(5772),
    [anon_sym_u25c7] = ACTIONS(5772),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5774),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [anon_sym_ASSUME] = ACTIONS(5774),
    [anon_sym_ASSUMPTION] = ACTIONS(5774),
    [anon_sym_AXIOM] = ACTIONS(5774),
    [anon_sym_THEOREM] = ACTIONS(5774),
    [anon_sym_PROPOSITION] = ACTIONS(5774),
    [anon_sym_LEMMA] = ACTIONS(5774),
    [anon_sym_COROLLARY] = ACTIONS(5774),
    [anon_sym_PROOF] = ACTIONS(5774),
    [anon_sym_BY] = ACTIONS(5774),
    [anon_sym_OBVIOUS] = ACTIONS(5774),
    [anon_sym_OMITTED] = ACTIONS(5774),
    [anon_sym_USE] = ACTIONS(5774),
    [anon_sym_HIDE] = ACTIONS(5774),
    [sym__begin_proof] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [2260] = {
    [sym_block_comment] = STATE(2260),
    [sym_case_box] = STATE(184),
    [aux_sym_case_repeat1] = STATE(2364),
    [ts_builtin_sym_end] = ACTIONS(5684),
    [sym_identifier] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5684),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_COMMA] = ACTIONS(5684),
    [anon_sym_LOCAL] = ACTIONS(5686),
    [anon_sym_VARIABLE] = ACTIONS(5686),
    [anon_sym_VARIABLES] = ACTIONS(5686),
    [anon_sym_CONSTANT] = ACTIONS(5686),
    [anon_sym_CONSTANTS] = ACTIONS(5686),
    [anon_sym_RECURSIVE] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_INSTANCE] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_Nat] = ACTIONS(5686),
    [anon_sym_u2115] = ACTIONS(5684),
    [anon_sym_Int] = ACTIONS(5686),
    [anon_sym_u2124] = ACTIONS(5684),
    [anon_sym_Real] = ACTIONS(5686),
    [anon_sym_u211d] = ACTIONS(5684),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_BSLASHlnot] = ACTIONS(5684),
    [anon_sym_BSLASHneg] = ACTIONS(5684),
    [anon_sym_TILDE] = ACTIONS(5686),
    [anon_sym_u00ac] = ACTIONS(5684),
    [sym_union] = ACTIONS(5686),
    [sym_powerset] = ACTIONS(5686),
    [sym_domain] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [sym_negative_dot] = ACTIONS(5684),
    [sym_enabled] = ACTIONS(5686),
    [sym_unchanged] = ACTIONS(5686),
    [anon_sym_LT_GT] = ACTIONS(5684),
    [anon_sym_u22c4] = ACTIONS(5684),
    [anon_sym_u25c7] = ACTIONS(5684),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5686),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [anon_sym_ASSUME] = ACTIONS(5686),
    [anon_sym_ASSUMPTION] = ACTIONS(5686),
    [anon_sym_AXIOM] = ACTIONS(5686),
    [anon_sym_THEOREM] = ACTIONS(5686),
    [anon_sym_PROPOSITION] = ACTIONS(5686),
    [anon_sym_LEMMA] = ACTIONS(5686),
    [anon_sym_COROLLARY] = ACTIONS(5686),
    [anon_sym_USE] = ACTIONS(5686),
    [anon_sym_HIDE] = ACTIONS(5686),
    [anon_sym_DEF] = ACTIONS(5686),
    [anon_sym_DEFS] = ACTIONS(5686),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2261] = {
    [sym_block_comment] = STATE(2261),
    [ts_builtin_sym_end] = ACTIONS(5676),
    [sym_identifier] = ACTIONS(5678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5676),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_LOCAL] = ACTIONS(5678),
    [anon_sym_VARIABLE] = ACTIONS(5678),
    [anon_sym_VARIABLES] = ACTIONS(5678),
    [anon_sym_CONSTANT] = ACTIONS(5678),
    [anon_sym_CONSTANTS] = ACTIONS(5678),
    [anon_sym_RECURSIVE] = ACTIONS(5678),
    [anon_sym_LPAREN] = ACTIONS(5776),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_INSTANCE] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_Nat] = ACTIONS(5678),
    [anon_sym_u2115] = ACTIONS(5676),
    [anon_sym_Int] = ACTIONS(5678),
    [anon_sym_u2124] = ACTIONS(5676),
    [anon_sym_Real] = ACTIONS(5678),
    [anon_sym_u211d] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_BSLASHlnot] = ACTIONS(5676),
    [anon_sym_BSLASHneg] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5678),
    [anon_sym_u00ac] = ACTIONS(5676),
    [sym_union] = ACTIONS(5678),
    [sym_powerset] = ACTIONS(5678),
    [sym_domain] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [sym_negative_dot] = ACTIONS(5676),
    [sym_enabled] = ACTIONS(5678),
    [sym_unchanged] = ACTIONS(5678),
    [anon_sym_LT_GT] = ACTIONS(5676),
    [anon_sym_u22c4] = ACTIONS(5676),
    [anon_sym_u25c7] = ACTIONS(5676),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5678),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [anon_sym_ASSUME] = ACTIONS(5678),
    [anon_sym_ASSUMPTION] = ACTIONS(5678),
    [anon_sym_AXIOM] = ACTIONS(5678),
    [anon_sym_THEOREM] = ACTIONS(5678),
    [anon_sym_PROPOSITION] = ACTIONS(5678),
    [anon_sym_LEMMA] = ACTIONS(5678),
    [anon_sym_COROLLARY] = ACTIONS(5678),
    [anon_sym_USE] = ACTIONS(5678),
    [anon_sym_HIDE] = ACTIONS(5678),
    [anon_sym_DEF] = ACTIONS(5678),
    [anon_sym_DEFS] = ACTIONS(5678),
    [sym__double_excl] = ACTIONS(5676),
  },
  [2262] = {
    [sym_block_comment] = STATE(2262),
    [ts_builtin_sym_end] = ACTIONS(5351),
    [sym_identifier] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5351),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_LOCAL] = ACTIONS(5349),
    [anon_sym_VARIABLE] = ACTIONS(5349),
    [anon_sym_VARIABLES] = ACTIONS(5349),
    [anon_sym_CONSTANT] = ACTIONS(5349),
    [anon_sym_CONSTANTS] = ACTIONS(5349),
    [anon_sym_RECURSIVE] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_INSTANCE] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_Nat] = ACTIONS(5349),
    [anon_sym_u2115] = ACTIONS(5351),
    [anon_sym_Int] = ACTIONS(5349),
    [anon_sym_u2124] = ACTIONS(5351),
    [anon_sym_Real] = ACTIONS(5349),
    [anon_sym_u211d] = ACTIONS(5351),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_BSLASHlnot] = ACTIONS(5351),
    [anon_sym_BSLASHneg] = ACTIONS(5351),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_u00ac] = ACTIONS(5351),
    [sym_union] = ACTIONS(5349),
    [sym_powerset] = ACTIONS(5349),
    [sym_domain] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [sym_negative_dot] = ACTIONS(5351),
    [sym_enabled] = ACTIONS(5349),
    [sym_unchanged] = ACTIONS(5349),
    [anon_sym_LT_GT] = ACTIONS(5351),
    [anon_sym_u22c4] = ACTIONS(5351),
    [anon_sym_u25c7] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5349),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [anon_sym_ASSUME] = ACTIONS(5349),
    [anon_sym_ASSUMPTION] = ACTIONS(5349),
    [anon_sym_AXIOM] = ACTIONS(5349),
    [anon_sym_THEOREM] = ACTIONS(5349),
    [anon_sym_PROPOSITION] = ACTIONS(5349),
    [anon_sym_LEMMA] = ACTIONS(5349),
    [anon_sym_COROLLARY] = ACTIONS(5349),
    [anon_sym_PROOF] = ACTIONS(5349),
    [anon_sym_BY] = ACTIONS(5349),
    [anon_sym_OBVIOUS] = ACTIONS(5349),
    [anon_sym_OMITTED] = ACTIONS(5349),
    [anon_sym_USE] = ACTIONS(5349),
    [anon_sym_HIDE] = ACTIONS(5349),
    [sym__begin_proof] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [2263] = {
    [sym_block_comment] = STATE(2263),
    [sym_case_box] = STATE(162),
    [aux_sym_case_repeat1] = STATE(2268),
    [sym_identifier] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5684),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_COMMA] = ACTIONS(5684),
    [anon_sym_LOCAL] = ACTIONS(5686),
    [anon_sym_VARIABLE] = ACTIONS(5686),
    [anon_sym_VARIABLES] = ACTIONS(5686),
    [anon_sym_CONSTANT] = ACTIONS(5686),
    [anon_sym_CONSTANTS] = ACTIONS(5686),
    [anon_sym_RECURSIVE] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_INSTANCE] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_Nat] = ACTIONS(5686),
    [anon_sym_u2115] = ACTIONS(5684),
    [anon_sym_Int] = ACTIONS(5686),
    [anon_sym_u2124] = ACTIONS(5684),
    [anon_sym_Real] = ACTIONS(5686),
    [anon_sym_u211d] = ACTIONS(5684),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_BSLASHlnot] = ACTIONS(5684),
    [anon_sym_BSLASHneg] = ACTIONS(5684),
    [anon_sym_TILDE] = ACTIONS(5686),
    [anon_sym_u00ac] = ACTIONS(5684),
    [sym_union] = ACTIONS(5686),
    [sym_powerset] = ACTIONS(5686),
    [sym_domain] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [sym_negative_dot] = ACTIONS(5684),
    [sym_enabled] = ACTIONS(5686),
    [sym_unchanged] = ACTIONS(5686),
    [anon_sym_LT_GT] = ACTIONS(5684),
    [anon_sym_u22c4] = ACTIONS(5684),
    [anon_sym_u25c7] = ACTIONS(5684),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5686),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [anon_sym_ASSUME] = ACTIONS(5686),
    [anon_sym_ASSUMPTION] = ACTIONS(5686),
    [anon_sym_AXIOM] = ACTIONS(5686),
    [anon_sym_THEOREM] = ACTIONS(5686),
    [anon_sym_PROPOSITION] = ACTIONS(5686),
    [anon_sym_LEMMA] = ACTIONS(5686),
    [anon_sym_COROLLARY] = ACTIONS(5686),
    [anon_sym_USE] = ACTIONS(5686),
    [anon_sym_HIDE] = ACTIONS(5686),
    [anon_sym_DEF] = ACTIONS(5686),
    [anon_sym_DEFS] = ACTIONS(5686),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2264] = {
    [sym_block_comment] = STATE(2264),
    [ts_builtin_sym_end] = ACTIONS(5778),
    [sym_identifier] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5778),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_LOCAL] = ACTIONS(5780),
    [anon_sym_VARIABLE] = ACTIONS(5780),
    [anon_sym_VARIABLES] = ACTIONS(5780),
    [anon_sym_CONSTANT] = ACTIONS(5780),
    [anon_sym_CONSTANTS] = ACTIONS(5780),
    [anon_sym_RECURSIVE] = ACTIONS(5780),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_INSTANCE] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_Nat] = ACTIONS(5780),
    [anon_sym_u2115] = ACTIONS(5778),
    [anon_sym_Int] = ACTIONS(5780),
    [anon_sym_u2124] = ACTIONS(5778),
    [anon_sym_Real] = ACTIONS(5780),
    [anon_sym_u211d] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_BSLASHlnot] = ACTIONS(5778),
    [anon_sym_BSLASHneg] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5780),
    [anon_sym_u00ac] = ACTIONS(5778),
    [sym_union] = ACTIONS(5780),
    [sym_powerset] = ACTIONS(5780),
    [sym_domain] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [sym_negative_dot] = ACTIONS(5778),
    [sym_enabled] = ACTIONS(5780),
    [sym_unchanged] = ACTIONS(5780),
    [anon_sym_LT_GT] = ACTIONS(5778),
    [anon_sym_u22c4] = ACTIONS(5778),
    [anon_sym_u25c7] = ACTIONS(5778),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5780),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [anon_sym_ASSUME] = ACTIONS(5780),
    [anon_sym_ASSUMPTION] = ACTIONS(5780),
    [anon_sym_AXIOM] = ACTIONS(5780),
    [anon_sym_THEOREM] = ACTIONS(5780),
    [anon_sym_PROPOSITION] = ACTIONS(5780),
    [anon_sym_LEMMA] = ACTIONS(5780),
    [anon_sym_COROLLARY] = ACTIONS(5780),
    [anon_sym_PROOF] = ACTIONS(5780),
    [anon_sym_BY] = ACTIONS(5780),
    [anon_sym_OBVIOUS] = ACTIONS(5780),
    [anon_sym_OMITTED] = ACTIONS(5780),
    [anon_sym_USE] = ACTIONS(5780),
    [anon_sym_HIDE] = ACTIONS(5780),
    [sym__begin_proof] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [2265] = {
    [sym_block_comment] = STATE(2265),
    [ts_builtin_sym_end] = ACTIONS(5782),
    [sym_identifier] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5782),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_LOCAL] = ACTIONS(5784),
    [anon_sym_VARIABLE] = ACTIONS(5784),
    [anon_sym_VARIABLES] = ACTIONS(5784),
    [anon_sym_CONSTANT] = ACTIONS(5784),
    [anon_sym_CONSTANTS] = ACTIONS(5784),
    [anon_sym_RECURSIVE] = ACTIONS(5784),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_INSTANCE] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_Nat] = ACTIONS(5784),
    [anon_sym_u2115] = ACTIONS(5782),
    [anon_sym_Int] = ACTIONS(5784),
    [anon_sym_u2124] = ACTIONS(5782),
    [anon_sym_Real] = ACTIONS(5784),
    [anon_sym_u211d] = ACTIONS(5782),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_BSLASHlnot] = ACTIONS(5782),
    [anon_sym_BSLASHneg] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [anon_sym_u00ac] = ACTIONS(5782),
    [sym_union] = ACTIONS(5784),
    [sym_powerset] = ACTIONS(5784),
    [sym_domain] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [sym_negative_dot] = ACTIONS(5782),
    [sym_enabled] = ACTIONS(5784),
    [sym_unchanged] = ACTIONS(5784),
    [anon_sym_LT_GT] = ACTIONS(5782),
    [anon_sym_u22c4] = ACTIONS(5782),
    [anon_sym_u25c7] = ACTIONS(5782),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5784),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [anon_sym_ASSUME] = ACTIONS(5784),
    [anon_sym_ASSUMPTION] = ACTIONS(5784),
    [anon_sym_AXIOM] = ACTIONS(5784),
    [anon_sym_THEOREM] = ACTIONS(5784),
    [anon_sym_PROPOSITION] = ACTIONS(5784),
    [anon_sym_LEMMA] = ACTIONS(5784),
    [anon_sym_COROLLARY] = ACTIONS(5784),
    [anon_sym_PROOF] = ACTIONS(5784),
    [anon_sym_BY] = ACTIONS(5784),
    [anon_sym_OBVIOUS] = ACTIONS(5784),
    [anon_sym_OMITTED] = ACTIONS(5784),
    [anon_sym_USE] = ACTIONS(5784),
    [anon_sym_HIDE] = ACTIONS(5784),
    [sym__begin_proof] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [2266] = {
    [sym_block_comment] = STATE(2266),
    [ts_builtin_sym_end] = ACTIONS(5663),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5663),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_LOCAL] = ACTIONS(5665),
    [anon_sym_VARIABLE] = ACTIONS(5665),
    [anon_sym_VARIABLES] = ACTIONS(5665),
    [anon_sym_CONSTANT] = ACTIONS(5665),
    [anon_sym_CONSTANTS] = ACTIONS(5665),
    [anon_sym_RECURSIVE] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_INSTANCE] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5665),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_ASSUME] = ACTIONS(5665),
    [anon_sym_ASSUMPTION] = ACTIONS(5665),
    [anon_sym_AXIOM] = ACTIONS(5665),
    [anon_sym_THEOREM] = ACTIONS(5665),
    [anon_sym_PROPOSITION] = ACTIONS(5665),
    [anon_sym_LEMMA] = ACTIONS(5665),
    [anon_sym_COROLLARY] = ACTIONS(5665),
    [anon_sym_PROOF] = ACTIONS(5665),
    [anon_sym_BY] = ACTIONS(5665),
    [anon_sym_OBVIOUS] = ACTIONS(5665),
    [anon_sym_OMITTED] = ACTIONS(5665),
    [anon_sym_USE] = ACTIONS(5665),
    [anon_sym_HIDE] = ACTIONS(5665),
    [sym__begin_proof] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2267] = {
    [sym_block_comment] = STATE(2267),
    [ts_builtin_sym_end] = ACTIONS(5786),
    [sym_identifier] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5786),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_LOCAL] = ACTIONS(5788),
    [anon_sym_VARIABLE] = ACTIONS(5788),
    [anon_sym_VARIABLES] = ACTIONS(5788),
    [anon_sym_CONSTANT] = ACTIONS(5788),
    [anon_sym_CONSTANTS] = ACTIONS(5788),
    [anon_sym_RECURSIVE] = ACTIONS(5788),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_INSTANCE] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_Nat] = ACTIONS(5788),
    [anon_sym_u2115] = ACTIONS(5786),
    [anon_sym_Int] = ACTIONS(5788),
    [anon_sym_u2124] = ACTIONS(5786),
    [anon_sym_Real] = ACTIONS(5788),
    [anon_sym_u211d] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_BSLASHlnot] = ACTIONS(5786),
    [anon_sym_BSLASHneg] = ACTIONS(5786),
    [anon_sym_TILDE] = ACTIONS(5788),
    [anon_sym_u00ac] = ACTIONS(5786),
    [sym_union] = ACTIONS(5788),
    [sym_powerset] = ACTIONS(5788),
    [sym_domain] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [sym_negative_dot] = ACTIONS(5786),
    [sym_enabled] = ACTIONS(5788),
    [sym_unchanged] = ACTIONS(5788),
    [anon_sym_LT_GT] = ACTIONS(5786),
    [anon_sym_u22c4] = ACTIONS(5786),
    [anon_sym_u25c7] = ACTIONS(5786),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5788),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [anon_sym_ASSUME] = ACTIONS(5788),
    [anon_sym_ASSUMPTION] = ACTIONS(5788),
    [anon_sym_AXIOM] = ACTIONS(5788),
    [anon_sym_THEOREM] = ACTIONS(5788),
    [anon_sym_PROPOSITION] = ACTIONS(5788),
    [anon_sym_LEMMA] = ACTIONS(5788),
    [anon_sym_COROLLARY] = ACTIONS(5788),
    [anon_sym_PROOF] = ACTIONS(5788),
    [anon_sym_BY] = ACTIONS(5788),
    [anon_sym_OBVIOUS] = ACTIONS(5788),
    [anon_sym_OMITTED] = ACTIONS(5788),
    [anon_sym_USE] = ACTIONS(5788),
    [anon_sym_HIDE] = ACTIONS(5788),
    [sym__begin_proof] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [2268] = {
    [sym_block_comment] = STATE(2268),
    [sym_case_box] = STATE(163),
    [aux_sym_case_repeat1] = STATE(2274),
    [sym_identifier] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5672),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_LOCAL] = ACTIONS(5670),
    [anon_sym_VARIABLE] = ACTIONS(5670),
    [anon_sym_VARIABLES] = ACTIONS(5670),
    [anon_sym_CONSTANT] = ACTIONS(5670),
    [anon_sym_CONSTANTS] = ACTIONS(5670),
    [anon_sym_RECURSIVE] = ACTIONS(5670),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_INSTANCE] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_Nat] = ACTIONS(5670),
    [anon_sym_u2115] = ACTIONS(5672),
    [anon_sym_Int] = ACTIONS(5670),
    [anon_sym_u2124] = ACTIONS(5672),
    [anon_sym_Real] = ACTIONS(5670),
    [anon_sym_u211d] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_BSLASHlnot] = ACTIONS(5672),
    [anon_sym_BSLASHneg] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5670),
    [anon_sym_u00ac] = ACTIONS(5672),
    [sym_union] = ACTIONS(5670),
    [sym_powerset] = ACTIONS(5670),
    [sym_domain] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [sym_negative_dot] = ACTIONS(5672),
    [sym_enabled] = ACTIONS(5670),
    [sym_unchanged] = ACTIONS(5670),
    [anon_sym_LT_GT] = ACTIONS(5672),
    [anon_sym_u22c4] = ACTIONS(5672),
    [anon_sym_u25c7] = ACTIONS(5672),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5670),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [anon_sym_ASSUME] = ACTIONS(5670),
    [anon_sym_ASSUMPTION] = ACTIONS(5670),
    [anon_sym_AXIOM] = ACTIONS(5670),
    [anon_sym_THEOREM] = ACTIONS(5670),
    [anon_sym_PROPOSITION] = ACTIONS(5670),
    [anon_sym_LEMMA] = ACTIONS(5670),
    [anon_sym_COROLLARY] = ACTIONS(5670),
    [anon_sym_USE] = ACTIONS(5670),
    [anon_sym_HIDE] = ACTIONS(5670),
    [anon_sym_DEF] = ACTIONS(5670),
    [anon_sym_DEFS] = ACTIONS(5670),
    [sym__double_excl] = ACTIONS(5672),
  },
  [2269] = {
    [sym_block_comment] = STATE(2269),
    [ts_builtin_sym_end] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5790),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_LOCAL] = ACTIONS(5792),
    [anon_sym_VARIABLE] = ACTIONS(5792),
    [anon_sym_VARIABLES] = ACTIONS(5792),
    [anon_sym_CONSTANT] = ACTIONS(5792),
    [anon_sym_CONSTANTS] = ACTIONS(5792),
    [anon_sym_RECURSIVE] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_INSTANCE] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_Nat] = ACTIONS(5792),
    [anon_sym_u2115] = ACTIONS(5790),
    [anon_sym_Int] = ACTIONS(5792),
    [anon_sym_u2124] = ACTIONS(5790),
    [anon_sym_Real] = ACTIONS(5792),
    [anon_sym_u211d] = ACTIONS(5790),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_BSLASHlnot] = ACTIONS(5790),
    [anon_sym_BSLASHneg] = ACTIONS(5790),
    [anon_sym_TILDE] = ACTIONS(5792),
    [anon_sym_u00ac] = ACTIONS(5790),
    [sym_union] = ACTIONS(5792),
    [sym_powerset] = ACTIONS(5792),
    [sym_domain] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [sym_negative_dot] = ACTIONS(5790),
    [sym_enabled] = ACTIONS(5792),
    [sym_unchanged] = ACTIONS(5792),
    [anon_sym_LT_GT] = ACTIONS(5790),
    [anon_sym_u22c4] = ACTIONS(5790),
    [anon_sym_u25c7] = ACTIONS(5790),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5792),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [anon_sym_ASSUME] = ACTIONS(5792),
    [anon_sym_ASSUMPTION] = ACTIONS(5792),
    [anon_sym_AXIOM] = ACTIONS(5792),
    [anon_sym_THEOREM] = ACTIONS(5792),
    [anon_sym_PROPOSITION] = ACTIONS(5792),
    [anon_sym_LEMMA] = ACTIONS(5792),
    [anon_sym_COROLLARY] = ACTIONS(5792),
    [anon_sym_PROOF] = ACTIONS(5792),
    [anon_sym_BY] = ACTIONS(5792),
    [anon_sym_OBVIOUS] = ACTIONS(5792),
    [anon_sym_OMITTED] = ACTIONS(5792),
    [anon_sym_USE] = ACTIONS(5792),
    [anon_sym_HIDE] = ACTIONS(5792),
    [sym__begin_proof] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [2270] = {
    [sym_block_comment] = STATE(2270),
    [ts_builtin_sym_end] = ACTIONS(5794),
    [sym_identifier] = ACTIONS(5796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5794),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_LOCAL] = ACTIONS(5796),
    [anon_sym_VARIABLE] = ACTIONS(5796),
    [anon_sym_VARIABLES] = ACTIONS(5796),
    [anon_sym_CONSTANT] = ACTIONS(5796),
    [anon_sym_CONSTANTS] = ACTIONS(5796),
    [anon_sym_RECURSIVE] = ACTIONS(5796),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_INSTANCE] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_Nat] = ACTIONS(5796),
    [anon_sym_u2115] = ACTIONS(5794),
    [anon_sym_Int] = ACTIONS(5796),
    [anon_sym_u2124] = ACTIONS(5794),
    [anon_sym_Real] = ACTIONS(5796),
    [anon_sym_u211d] = ACTIONS(5794),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_BSLASHlnot] = ACTIONS(5794),
    [anon_sym_BSLASHneg] = ACTIONS(5794),
    [anon_sym_TILDE] = ACTIONS(5796),
    [anon_sym_u00ac] = ACTIONS(5794),
    [sym_union] = ACTIONS(5796),
    [sym_powerset] = ACTIONS(5796),
    [sym_domain] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [sym_negative_dot] = ACTIONS(5794),
    [sym_enabled] = ACTIONS(5796),
    [sym_unchanged] = ACTIONS(5796),
    [anon_sym_LT_GT] = ACTIONS(5794),
    [anon_sym_u22c4] = ACTIONS(5794),
    [anon_sym_u25c7] = ACTIONS(5794),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5796),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [anon_sym_ASSUME] = ACTIONS(5796),
    [anon_sym_ASSUMPTION] = ACTIONS(5796),
    [anon_sym_AXIOM] = ACTIONS(5796),
    [anon_sym_THEOREM] = ACTIONS(5796),
    [anon_sym_PROPOSITION] = ACTIONS(5796),
    [anon_sym_LEMMA] = ACTIONS(5796),
    [anon_sym_COROLLARY] = ACTIONS(5796),
    [anon_sym_PROOF] = ACTIONS(5796),
    [anon_sym_BY] = ACTIONS(5796),
    [anon_sym_OBVIOUS] = ACTIONS(5796),
    [anon_sym_OMITTED] = ACTIONS(5796),
    [anon_sym_USE] = ACTIONS(5796),
    [anon_sym_HIDE] = ACTIONS(5796),
    [sym__begin_proof] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [2271] = {
    [sym_block_comment] = STATE(2271),
    [ts_builtin_sym_end] = ACTIONS(5798),
    [sym_identifier] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5798),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_LOCAL] = ACTIONS(5800),
    [anon_sym_VARIABLE] = ACTIONS(5800),
    [anon_sym_VARIABLES] = ACTIONS(5800),
    [anon_sym_CONSTANT] = ACTIONS(5800),
    [anon_sym_CONSTANTS] = ACTIONS(5800),
    [anon_sym_RECURSIVE] = ACTIONS(5800),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_INSTANCE] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_Nat] = ACTIONS(5800),
    [anon_sym_u2115] = ACTIONS(5798),
    [anon_sym_Int] = ACTIONS(5800),
    [anon_sym_u2124] = ACTIONS(5798),
    [anon_sym_Real] = ACTIONS(5800),
    [anon_sym_u211d] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_BSLASHlnot] = ACTIONS(5798),
    [anon_sym_BSLASHneg] = ACTIONS(5798),
    [anon_sym_TILDE] = ACTIONS(5800),
    [anon_sym_u00ac] = ACTIONS(5798),
    [sym_union] = ACTIONS(5800),
    [sym_powerset] = ACTIONS(5800),
    [sym_domain] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [sym_negative_dot] = ACTIONS(5798),
    [sym_enabled] = ACTIONS(5800),
    [sym_unchanged] = ACTIONS(5800),
    [anon_sym_LT_GT] = ACTIONS(5798),
    [anon_sym_u22c4] = ACTIONS(5798),
    [anon_sym_u25c7] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5800),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [anon_sym_ASSUME] = ACTIONS(5800),
    [anon_sym_ASSUMPTION] = ACTIONS(5800),
    [anon_sym_AXIOM] = ACTIONS(5800),
    [anon_sym_THEOREM] = ACTIONS(5800),
    [anon_sym_PROPOSITION] = ACTIONS(5800),
    [anon_sym_LEMMA] = ACTIONS(5800),
    [anon_sym_COROLLARY] = ACTIONS(5800),
    [anon_sym_PROOF] = ACTIONS(5800),
    [anon_sym_BY] = ACTIONS(5800),
    [anon_sym_OBVIOUS] = ACTIONS(5800),
    [anon_sym_OMITTED] = ACTIONS(5800),
    [anon_sym_USE] = ACTIONS(5800),
    [anon_sym_HIDE] = ACTIONS(5800),
    [sym__begin_proof] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [2272] = {
    [sym_block_comment] = STATE(2272),
    [ts_builtin_sym_end] = ACTIONS(5802),
    [sym_identifier] = ACTIONS(5804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5802),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_LOCAL] = ACTIONS(5804),
    [anon_sym_VARIABLE] = ACTIONS(5804),
    [anon_sym_VARIABLES] = ACTIONS(5804),
    [anon_sym_CONSTANT] = ACTIONS(5804),
    [anon_sym_CONSTANTS] = ACTIONS(5804),
    [anon_sym_RECURSIVE] = ACTIONS(5804),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_INSTANCE] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_Nat] = ACTIONS(5804),
    [anon_sym_u2115] = ACTIONS(5802),
    [anon_sym_Int] = ACTIONS(5804),
    [anon_sym_u2124] = ACTIONS(5802),
    [anon_sym_Real] = ACTIONS(5804),
    [anon_sym_u211d] = ACTIONS(5802),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_BSLASHlnot] = ACTIONS(5802),
    [anon_sym_BSLASHneg] = ACTIONS(5802),
    [anon_sym_TILDE] = ACTIONS(5804),
    [anon_sym_u00ac] = ACTIONS(5802),
    [sym_union] = ACTIONS(5804),
    [sym_powerset] = ACTIONS(5804),
    [sym_domain] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [sym_negative_dot] = ACTIONS(5802),
    [sym_enabled] = ACTIONS(5804),
    [sym_unchanged] = ACTIONS(5804),
    [anon_sym_LT_GT] = ACTIONS(5802),
    [anon_sym_u22c4] = ACTIONS(5802),
    [anon_sym_u25c7] = ACTIONS(5802),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5804),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [anon_sym_ASSUME] = ACTIONS(5804),
    [anon_sym_ASSUMPTION] = ACTIONS(5804),
    [anon_sym_AXIOM] = ACTIONS(5804),
    [anon_sym_THEOREM] = ACTIONS(5804),
    [anon_sym_PROPOSITION] = ACTIONS(5804),
    [anon_sym_LEMMA] = ACTIONS(5804),
    [anon_sym_COROLLARY] = ACTIONS(5804),
    [anon_sym_PROOF] = ACTIONS(5804),
    [anon_sym_BY] = ACTIONS(5804),
    [anon_sym_OBVIOUS] = ACTIONS(5804),
    [anon_sym_OMITTED] = ACTIONS(5804),
    [anon_sym_USE] = ACTIONS(5804),
    [anon_sym_HIDE] = ACTIONS(5804),
    [sym__begin_proof] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [2273] = {
    [sym_block_comment] = STATE(2273),
    [ts_builtin_sym_end] = ACTIONS(5806),
    [sym_identifier] = ACTIONS(5808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5806),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_LOCAL] = ACTIONS(5808),
    [anon_sym_VARIABLE] = ACTIONS(5808),
    [anon_sym_VARIABLES] = ACTIONS(5808),
    [anon_sym_CONSTANT] = ACTIONS(5808),
    [anon_sym_CONSTANTS] = ACTIONS(5808),
    [anon_sym_RECURSIVE] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_INSTANCE] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_Nat] = ACTIONS(5808),
    [anon_sym_u2115] = ACTIONS(5806),
    [anon_sym_Int] = ACTIONS(5808),
    [anon_sym_u2124] = ACTIONS(5806),
    [anon_sym_Real] = ACTIONS(5808),
    [anon_sym_u211d] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_BSLASHlnot] = ACTIONS(5806),
    [anon_sym_BSLASHneg] = ACTIONS(5806),
    [anon_sym_TILDE] = ACTIONS(5808),
    [anon_sym_u00ac] = ACTIONS(5806),
    [sym_union] = ACTIONS(5808),
    [sym_powerset] = ACTIONS(5808),
    [sym_domain] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [sym_negative_dot] = ACTIONS(5806),
    [sym_enabled] = ACTIONS(5808),
    [sym_unchanged] = ACTIONS(5808),
    [anon_sym_LT_GT] = ACTIONS(5806),
    [anon_sym_u22c4] = ACTIONS(5806),
    [anon_sym_u25c7] = ACTIONS(5806),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5808),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [anon_sym_ASSUME] = ACTIONS(5808),
    [anon_sym_ASSUMPTION] = ACTIONS(5808),
    [anon_sym_AXIOM] = ACTIONS(5808),
    [anon_sym_THEOREM] = ACTIONS(5808),
    [anon_sym_PROPOSITION] = ACTIONS(5808),
    [anon_sym_LEMMA] = ACTIONS(5808),
    [anon_sym_COROLLARY] = ACTIONS(5808),
    [anon_sym_PROOF] = ACTIONS(5808),
    [anon_sym_BY] = ACTIONS(5808),
    [anon_sym_OBVIOUS] = ACTIONS(5808),
    [anon_sym_OMITTED] = ACTIONS(5808),
    [anon_sym_USE] = ACTIONS(5808),
    [anon_sym_HIDE] = ACTIONS(5808),
    [sym__begin_proof] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [2274] = {
    [sym_block_comment] = STATE(2274),
    [sym_case_box] = STATE(295),
    [aux_sym_case_repeat1] = STATE(2274),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5663),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LOCAL] = ACTIONS(5665),
    [anon_sym_VARIABLE] = ACTIONS(5665),
    [anon_sym_VARIABLES] = ACTIONS(5665),
    [anon_sym_CONSTANT] = ACTIONS(5665),
    [anon_sym_CONSTANTS] = ACTIONS(5665),
    [anon_sym_RECURSIVE] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_INSTANCE] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5665),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_ASSUME] = ACTIONS(5665),
    [anon_sym_ASSUMPTION] = ACTIONS(5665),
    [anon_sym_AXIOM] = ACTIONS(5665),
    [anon_sym_THEOREM] = ACTIONS(5665),
    [anon_sym_PROPOSITION] = ACTIONS(5665),
    [anon_sym_LEMMA] = ACTIONS(5665),
    [anon_sym_COROLLARY] = ACTIONS(5665),
    [anon_sym_USE] = ACTIONS(5665),
    [anon_sym_HIDE] = ACTIONS(5665),
    [anon_sym_DEF] = ACTIONS(5665),
    [anon_sym_DEFS] = ACTIONS(5665),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2275] = {
    [sym_block_comment] = STATE(2275),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [sym_identifier] = ACTIONS(5812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5810),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_LOCAL] = ACTIONS(5812),
    [anon_sym_VARIABLE] = ACTIONS(5812),
    [anon_sym_VARIABLES] = ACTIONS(5812),
    [anon_sym_CONSTANT] = ACTIONS(5812),
    [anon_sym_CONSTANTS] = ACTIONS(5812),
    [anon_sym_RECURSIVE] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_INSTANCE] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_Nat] = ACTIONS(5812),
    [anon_sym_u2115] = ACTIONS(5810),
    [anon_sym_Int] = ACTIONS(5812),
    [anon_sym_u2124] = ACTIONS(5810),
    [anon_sym_Real] = ACTIONS(5812),
    [anon_sym_u211d] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_BSLASHlnot] = ACTIONS(5810),
    [anon_sym_BSLASHneg] = ACTIONS(5810),
    [anon_sym_TILDE] = ACTIONS(5812),
    [anon_sym_u00ac] = ACTIONS(5810),
    [sym_union] = ACTIONS(5812),
    [sym_powerset] = ACTIONS(5812),
    [sym_domain] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [sym_negative_dot] = ACTIONS(5810),
    [sym_enabled] = ACTIONS(5812),
    [sym_unchanged] = ACTIONS(5812),
    [anon_sym_LT_GT] = ACTIONS(5810),
    [anon_sym_u22c4] = ACTIONS(5810),
    [anon_sym_u25c7] = ACTIONS(5810),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5812),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [anon_sym_ASSUME] = ACTIONS(5812),
    [anon_sym_ASSUMPTION] = ACTIONS(5812),
    [anon_sym_AXIOM] = ACTIONS(5812),
    [anon_sym_THEOREM] = ACTIONS(5812),
    [anon_sym_PROPOSITION] = ACTIONS(5812),
    [anon_sym_LEMMA] = ACTIONS(5812),
    [anon_sym_COROLLARY] = ACTIONS(5812),
    [anon_sym_PROOF] = ACTIONS(5812),
    [anon_sym_BY] = ACTIONS(5812),
    [anon_sym_OBVIOUS] = ACTIONS(5812),
    [anon_sym_OMITTED] = ACTIONS(5812),
    [anon_sym_USE] = ACTIONS(5812),
    [anon_sym_HIDE] = ACTIONS(5812),
    [sym__begin_proof] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [2276] = {
    [sym_block_comment] = STATE(2276),
    [ts_builtin_sym_end] = ACTIONS(5814),
    [sym_identifier] = ACTIONS(5816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5814),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_LOCAL] = ACTIONS(5816),
    [anon_sym_VARIABLE] = ACTIONS(5816),
    [anon_sym_VARIABLES] = ACTIONS(5816),
    [anon_sym_CONSTANT] = ACTIONS(5816),
    [anon_sym_CONSTANTS] = ACTIONS(5816),
    [anon_sym_RECURSIVE] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_INSTANCE] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_Nat] = ACTIONS(5816),
    [anon_sym_u2115] = ACTIONS(5814),
    [anon_sym_Int] = ACTIONS(5816),
    [anon_sym_u2124] = ACTIONS(5814),
    [anon_sym_Real] = ACTIONS(5816),
    [anon_sym_u211d] = ACTIONS(5814),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_BSLASHlnot] = ACTIONS(5814),
    [anon_sym_BSLASHneg] = ACTIONS(5814),
    [anon_sym_TILDE] = ACTIONS(5816),
    [anon_sym_u00ac] = ACTIONS(5814),
    [sym_union] = ACTIONS(5816),
    [sym_powerset] = ACTIONS(5816),
    [sym_domain] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [sym_negative_dot] = ACTIONS(5814),
    [sym_enabled] = ACTIONS(5816),
    [sym_unchanged] = ACTIONS(5816),
    [anon_sym_LT_GT] = ACTIONS(5814),
    [anon_sym_u22c4] = ACTIONS(5814),
    [anon_sym_u25c7] = ACTIONS(5814),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5816),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [anon_sym_ASSUME] = ACTIONS(5816),
    [anon_sym_ASSUMPTION] = ACTIONS(5816),
    [anon_sym_AXIOM] = ACTIONS(5816),
    [anon_sym_THEOREM] = ACTIONS(5816),
    [anon_sym_PROPOSITION] = ACTIONS(5816),
    [anon_sym_LEMMA] = ACTIONS(5816),
    [anon_sym_COROLLARY] = ACTIONS(5816),
    [anon_sym_PROOF] = ACTIONS(5816),
    [anon_sym_BY] = ACTIONS(5816),
    [anon_sym_OBVIOUS] = ACTIONS(5816),
    [anon_sym_OMITTED] = ACTIONS(5816),
    [anon_sym_USE] = ACTIONS(5816),
    [anon_sym_HIDE] = ACTIONS(5816),
    [sym__begin_proof] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [2277] = {
    [sym_block_comment] = STATE(2277),
    [ts_builtin_sym_end] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5818),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_LOCAL] = ACTIONS(5820),
    [anon_sym_VARIABLE] = ACTIONS(5820),
    [anon_sym_VARIABLES] = ACTIONS(5820),
    [anon_sym_CONSTANT] = ACTIONS(5820),
    [anon_sym_CONSTANTS] = ACTIONS(5820),
    [anon_sym_RECURSIVE] = ACTIONS(5820),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_INSTANCE] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_Nat] = ACTIONS(5820),
    [anon_sym_u2115] = ACTIONS(5818),
    [anon_sym_Int] = ACTIONS(5820),
    [anon_sym_u2124] = ACTIONS(5818),
    [anon_sym_Real] = ACTIONS(5820),
    [anon_sym_u211d] = ACTIONS(5818),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_BSLASHlnot] = ACTIONS(5818),
    [anon_sym_BSLASHneg] = ACTIONS(5818),
    [anon_sym_TILDE] = ACTIONS(5820),
    [anon_sym_u00ac] = ACTIONS(5818),
    [sym_union] = ACTIONS(5820),
    [sym_powerset] = ACTIONS(5820),
    [sym_domain] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [sym_negative_dot] = ACTIONS(5818),
    [sym_enabled] = ACTIONS(5820),
    [sym_unchanged] = ACTIONS(5820),
    [anon_sym_LT_GT] = ACTIONS(5818),
    [anon_sym_u22c4] = ACTIONS(5818),
    [anon_sym_u25c7] = ACTIONS(5818),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5820),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [anon_sym_ASSUME] = ACTIONS(5820),
    [anon_sym_ASSUMPTION] = ACTIONS(5820),
    [anon_sym_AXIOM] = ACTIONS(5820),
    [anon_sym_THEOREM] = ACTIONS(5820),
    [anon_sym_PROPOSITION] = ACTIONS(5820),
    [anon_sym_LEMMA] = ACTIONS(5820),
    [anon_sym_COROLLARY] = ACTIONS(5820),
    [anon_sym_PROOF] = ACTIONS(5820),
    [anon_sym_BY] = ACTIONS(5820),
    [anon_sym_OBVIOUS] = ACTIONS(5820),
    [anon_sym_OMITTED] = ACTIONS(5820),
    [anon_sym_USE] = ACTIONS(5820),
    [anon_sym_HIDE] = ACTIONS(5820),
    [sym__begin_proof] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [2278] = {
    [sym_block_comment] = STATE(2278),
    [ts_builtin_sym_end] = ACTIONS(5822),
    [sym_identifier] = ACTIONS(5824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5822),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_LOCAL] = ACTIONS(5824),
    [anon_sym_VARIABLE] = ACTIONS(5824),
    [anon_sym_VARIABLES] = ACTIONS(5824),
    [anon_sym_CONSTANT] = ACTIONS(5824),
    [anon_sym_CONSTANTS] = ACTIONS(5824),
    [anon_sym_RECURSIVE] = ACTIONS(5824),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_INSTANCE] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_Nat] = ACTIONS(5824),
    [anon_sym_u2115] = ACTIONS(5822),
    [anon_sym_Int] = ACTIONS(5824),
    [anon_sym_u2124] = ACTIONS(5822),
    [anon_sym_Real] = ACTIONS(5824),
    [anon_sym_u211d] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_BSLASHlnot] = ACTIONS(5822),
    [anon_sym_BSLASHneg] = ACTIONS(5822),
    [anon_sym_TILDE] = ACTIONS(5824),
    [anon_sym_u00ac] = ACTIONS(5822),
    [sym_union] = ACTIONS(5824),
    [sym_powerset] = ACTIONS(5824),
    [sym_domain] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [sym_negative_dot] = ACTIONS(5822),
    [sym_enabled] = ACTIONS(5824),
    [sym_unchanged] = ACTIONS(5824),
    [anon_sym_LT_GT] = ACTIONS(5822),
    [anon_sym_u22c4] = ACTIONS(5822),
    [anon_sym_u25c7] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5824),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [anon_sym_ASSUME] = ACTIONS(5824),
    [anon_sym_ASSUMPTION] = ACTIONS(5824),
    [anon_sym_AXIOM] = ACTIONS(5824),
    [anon_sym_THEOREM] = ACTIONS(5824),
    [anon_sym_PROPOSITION] = ACTIONS(5824),
    [anon_sym_LEMMA] = ACTIONS(5824),
    [anon_sym_COROLLARY] = ACTIONS(5824),
    [anon_sym_PROOF] = ACTIONS(5824),
    [anon_sym_BY] = ACTIONS(5824),
    [anon_sym_OBVIOUS] = ACTIONS(5824),
    [anon_sym_OMITTED] = ACTIONS(5824),
    [anon_sym_USE] = ACTIONS(5824),
    [anon_sym_HIDE] = ACTIONS(5824),
    [sym__begin_proof] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [2279] = {
    [sym_block_comment] = STATE(2279),
    [ts_builtin_sym_end] = ACTIONS(5826),
    [sym_identifier] = ACTIONS(5828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5826),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_LOCAL] = ACTIONS(5828),
    [anon_sym_VARIABLE] = ACTIONS(5828),
    [anon_sym_VARIABLES] = ACTIONS(5828),
    [anon_sym_CONSTANT] = ACTIONS(5828),
    [anon_sym_CONSTANTS] = ACTIONS(5828),
    [anon_sym_RECURSIVE] = ACTIONS(5828),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_INSTANCE] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_Nat] = ACTIONS(5828),
    [anon_sym_u2115] = ACTIONS(5826),
    [anon_sym_Int] = ACTIONS(5828),
    [anon_sym_u2124] = ACTIONS(5826),
    [anon_sym_Real] = ACTIONS(5828),
    [anon_sym_u211d] = ACTIONS(5826),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_BSLASHlnot] = ACTIONS(5826),
    [anon_sym_BSLASHneg] = ACTIONS(5826),
    [anon_sym_TILDE] = ACTIONS(5828),
    [anon_sym_u00ac] = ACTIONS(5826),
    [sym_union] = ACTIONS(5828),
    [sym_powerset] = ACTIONS(5828),
    [sym_domain] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [sym_negative_dot] = ACTIONS(5826),
    [sym_enabled] = ACTIONS(5828),
    [sym_unchanged] = ACTIONS(5828),
    [anon_sym_LT_GT] = ACTIONS(5826),
    [anon_sym_u22c4] = ACTIONS(5826),
    [anon_sym_u25c7] = ACTIONS(5826),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5828),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [anon_sym_ASSUME] = ACTIONS(5828),
    [anon_sym_ASSUMPTION] = ACTIONS(5828),
    [anon_sym_AXIOM] = ACTIONS(5828),
    [anon_sym_THEOREM] = ACTIONS(5828),
    [anon_sym_PROPOSITION] = ACTIONS(5828),
    [anon_sym_LEMMA] = ACTIONS(5828),
    [anon_sym_COROLLARY] = ACTIONS(5828),
    [anon_sym_PROOF] = ACTIONS(5828),
    [anon_sym_BY] = ACTIONS(5828),
    [anon_sym_OBVIOUS] = ACTIONS(5828),
    [anon_sym_OMITTED] = ACTIONS(5828),
    [anon_sym_USE] = ACTIONS(5828),
    [anon_sym_HIDE] = ACTIONS(5828),
    [sym__begin_proof] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [2280] = {
    [sym_block_comment] = STATE(2280),
    [ts_builtin_sym_end] = ACTIONS(5830),
    [sym_identifier] = ACTIONS(5832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5830),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_LOCAL] = ACTIONS(5832),
    [anon_sym_VARIABLE] = ACTIONS(5832),
    [anon_sym_VARIABLES] = ACTIONS(5832),
    [anon_sym_CONSTANT] = ACTIONS(5832),
    [anon_sym_CONSTANTS] = ACTIONS(5832),
    [anon_sym_RECURSIVE] = ACTIONS(5832),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_INSTANCE] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_Nat] = ACTIONS(5832),
    [anon_sym_u2115] = ACTIONS(5830),
    [anon_sym_Int] = ACTIONS(5832),
    [anon_sym_u2124] = ACTIONS(5830),
    [anon_sym_Real] = ACTIONS(5832),
    [anon_sym_u211d] = ACTIONS(5830),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_BSLASHlnot] = ACTIONS(5830),
    [anon_sym_BSLASHneg] = ACTIONS(5830),
    [anon_sym_TILDE] = ACTIONS(5832),
    [anon_sym_u00ac] = ACTIONS(5830),
    [sym_union] = ACTIONS(5832),
    [sym_powerset] = ACTIONS(5832),
    [sym_domain] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [sym_negative_dot] = ACTIONS(5830),
    [sym_enabled] = ACTIONS(5832),
    [sym_unchanged] = ACTIONS(5832),
    [anon_sym_LT_GT] = ACTIONS(5830),
    [anon_sym_u22c4] = ACTIONS(5830),
    [anon_sym_u25c7] = ACTIONS(5830),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5832),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [anon_sym_ASSUME] = ACTIONS(5832),
    [anon_sym_ASSUMPTION] = ACTIONS(5832),
    [anon_sym_AXIOM] = ACTIONS(5832),
    [anon_sym_THEOREM] = ACTIONS(5832),
    [anon_sym_PROPOSITION] = ACTIONS(5832),
    [anon_sym_LEMMA] = ACTIONS(5832),
    [anon_sym_COROLLARY] = ACTIONS(5832),
    [anon_sym_PROOF] = ACTIONS(5832),
    [anon_sym_BY] = ACTIONS(5832),
    [anon_sym_OBVIOUS] = ACTIONS(5832),
    [anon_sym_OMITTED] = ACTIONS(5832),
    [anon_sym_USE] = ACTIONS(5832),
    [anon_sym_HIDE] = ACTIONS(5832),
    [sym__begin_proof] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [2281] = {
    [sym_block_comment] = STATE(2281),
    [ts_builtin_sym_end] = ACTIONS(5834),
    [sym_identifier] = ACTIONS(5836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5834),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_LOCAL] = ACTIONS(5836),
    [anon_sym_VARIABLE] = ACTIONS(5836),
    [anon_sym_VARIABLES] = ACTIONS(5836),
    [anon_sym_CONSTANT] = ACTIONS(5836),
    [anon_sym_CONSTANTS] = ACTIONS(5836),
    [anon_sym_RECURSIVE] = ACTIONS(5836),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_INSTANCE] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_Nat] = ACTIONS(5836),
    [anon_sym_u2115] = ACTIONS(5834),
    [anon_sym_Int] = ACTIONS(5836),
    [anon_sym_u2124] = ACTIONS(5834),
    [anon_sym_Real] = ACTIONS(5836),
    [anon_sym_u211d] = ACTIONS(5834),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_BSLASHlnot] = ACTIONS(5834),
    [anon_sym_BSLASHneg] = ACTIONS(5834),
    [anon_sym_TILDE] = ACTIONS(5836),
    [anon_sym_u00ac] = ACTIONS(5834),
    [sym_union] = ACTIONS(5836),
    [sym_powerset] = ACTIONS(5836),
    [sym_domain] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [sym_negative_dot] = ACTIONS(5834),
    [sym_enabled] = ACTIONS(5836),
    [sym_unchanged] = ACTIONS(5836),
    [anon_sym_LT_GT] = ACTIONS(5834),
    [anon_sym_u22c4] = ACTIONS(5834),
    [anon_sym_u25c7] = ACTIONS(5834),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5836),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [anon_sym_ASSUME] = ACTIONS(5836),
    [anon_sym_ASSUMPTION] = ACTIONS(5836),
    [anon_sym_AXIOM] = ACTIONS(5836),
    [anon_sym_THEOREM] = ACTIONS(5836),
    [anon_sym_PROPOSITION] = ACTIONS(5836),
    [anon_sym_LEMMA] = ACTIONS(5836),
    [anon_sym_COROLLARY] = ACTIONS(5836),
    [anon_sym_PROOF] = ACTIONS(5836),
    [anon_sym_BY] = ACTIONS(5836),
    [anon_sym_OBVIOUS] = ACTIONS(5836),
    [anon_sym_OMITTED] = ACTIONS(5836),
    [anon_sym_USE] = ACTIONS(5836),
    [anon_sym_HIDE] = ACTIONS(5836),
    [sym__begin_proof] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [2282] = {
    [sym_block_comment] = STATE(2282),
    [ts_builtin_sym_end] = ACTIONS(5838),
    [sym_identifier] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5838),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_LOCAL] = ACTIONS(5840),
    [anon_sym_VARIABLE] = ACTIONS(5840),
    [anon_sym_VARIABLES] = ACTIONS(5840),
    [anon_sym_CONSTANT] = ACTIONS(5840),
    [anon_sym_CONSTANTS] = ACTIONS(5840),
    [anon_sym_RECURSIVE] = ACTIONS(5840),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_INSTANCE] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_Nat] = ACTIONS(5840),
    [anon_sym_u2115] = ACTIONS(5838),
    [anon_sym_Int] = ACTIONS(5840),
    [anon_sym_u2124] = ACTIONS(5838),
    [anon_sym_Real] = ACTIONS(5840),
    [anon_sym_u211d] = ACTIONS(5838),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_BSLASHlnot] = ACTIONS(5838),
    [anon_sym_BSLASHneg] = ACTIONS(5838),
    [anon_sym_TILDE] = ACTIONS(5840),
    [anon_sym_u00ac] = ACTIONS(5838),
    [sym_union] = ACTIONS(5840),
    [sym_powerset] = ACTIONS(5840),
    [sym_domain] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [sym_negative_dot] = ACTIONS(5838),
    [sym_enabled] = ACTIONS(5840),
    [sym_unchanged] = ACTIONS(5840),
    [anon_sym_LT_GT] = ACTIONS(5838),
    [anon_sym_u22c4] = ACTIONS(5838),
    [anon_sym_u25c7] = ACTIONS(5838),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5840),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [anon_sym_ASSUME] = ACTIONS(5840),
    [anon_sym_ASSUMPTION] = ACTIONS(5840),
    [anon_sym_AXIOM] = ACTIONS(5840),
    [anon_sym_THEOREM] = ACTIONS(5840),
    [anon_sym_PROPOSITION] = ACTIONS(5840),
    [anon_sym_LEMMA] = ACTIONS(5840),
    [anon_sym_COROLLARY] = ACTIONS(5840),
    [anon_sym_PROOF] = ACTIONS(5840),
    [anon_sym_BY] = ACTIONS(5840),
    [anon_sym_OBVIOUS] = ACTIONS(5840),
    [anon_sym_OMITTED] = ACTIONS(5840),
    [anon_sym_USE] = ACTIONS(5840),
    [anon_sym_HIDE] = ACTIONS(5840),
    [sym__begin_proof] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [2283] = {
    [sym_block_comment] = STATE(2283),
    [ts_builtin_sym_end] = ACTIONS(5842),
    [sym_identifier] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5842),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_LOCAL] = ACTIONS(5844),
    [anon_sym_VARIABLE] = ACTIONS(5844),
    [anon_sym_VARIABLES] = ACTIONS(5844),
    [anon_sym_CONSTANT] = ACTIONS(5844),
    [anon_sym_CONSTANTS] = ACTIONS(5844),
    [anon_sym_RECURSIVE] = ACTIONS(5844),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_INSTANCE] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_Nat] = ACTIONS(5844),
    [anon_sym_u2115] = ACTIONS(5842),
    [anon_sym_Int] = ACTIONS(5844),
    [anon_sym_u2124] = ACTIONS(5842),
    [anon_sym_Real] = ACTIONS(5844),
    [anon_sym_u211d] = ACTIONS(5842),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_BSLASHlnot] = ACTIONS(5842),
    [anon_sym_BSLASHneg] = ACTIONS(5842),
    [anon_sym_TILDE] = ACTIONS(5844),
    [anon_sym_u00ac] = ACTIONS(5842),
    [sym_union] = ACTIONS(5844),
    [sym_powerset] = ACTIONS(5844),
    [sym_domain] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [sym_negative_dot] = ACTIONS(5842),
    [sym_enabled] = ACTIONS(5844),
    [sym_unchanged] = ACTIONS(5844),
    [anon_sym_LT_GT] = ACTIONS(5842),
    [anon_sym_u22c4] = ACTIONS(5842),
    [anon_sym_u25c7] = ACTIONS(5842),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5844),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [anon_sym_ASSUME] = ACTIONS(5844),
    [anon_sym_ASSUMPTION] = ACTIONS(5844),
    [anon_sym_AXIOM] = ACTIONS(5844),
    [anon_sym_THEOREM] = ACTIONS(5844),
    [anon_sym_PROPOSITION] = ACTIONS(5844),
    [anon_sym_LEMMA] = ACTIONS(5844),
    [anon_sym_COROLLARY] = ACTIONS(5844),
    [anon_sym_PROOF] = ACTIONS(5844),
    [anon_sym_BY] = ACTIONS(5844),
    [anon_sym_OBVIOUS] = ACTIONS(5844),
    [anon_sym_OMITTED] = ACTIONS(5844),
    [anon_sym_USE] = ACTIONS(5844),
    [anon_sym_HIDE] = ACTIONS(5844),
    [sym__begin_proof] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [2284] = {
    [sym_block_comment] = STATE(2284),
    [ts_builtin_sym_end] = ACTIONS(5846),
    [sym_identifier] = ACTIONS(5848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5846),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_LOCAL] = ACTIONS(5848),
    [anon_sym_VARIABLE] = ACTIONS(5848),
    [anon_sym_VARIABLES] = ACTIONS(5848),
    [anon_sym_CONSTANT] = ACTIONS(5848),
    [anon_sym_CONSTANTS] = ACTIONS(5848),
    [anon_sym_RECURSIVE] = ACTIONS(5848),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_INSTANCE] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_Nat] = ACTIONS(5848),
    [anon_sym_u2115] = ACTIONS(5846),
    [anon_sym_Int] = ACTIONS(5848),
    [anon_sym_u2124] = ACTIONS(5846),
    [anon_sym_Real] = ACTIONS(5848),
    [anon_sym_u211d] = ACTIONS(5846),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_BSLASHlnot] = ACTIONS(5846),
    [anon_sym_BSLASHneg] = ACTIONS(5846),
    [anon_sym_TILDE] = ACTIONS(5848),
    [anon_sym_u00ac] = ACTIONS(5846),
    [sym_union] = ACTIONS(5848),
    [sym_powerset] = ACTIONS(5848),
    [sym_domain] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [sym_negative_dot] = ACTIONS(5846),
    [sym_enabled] = ACTIONS(5848),
    [sym_unchanged] = ACTIONS(5848),
    [anon_sym_LT_GT] = ACTIONS(5846),
    [anon_sym_u22c4] = ACTIONS(5846),
    [anon_sym_u25c7] = ACTIONS(5846),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5848),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [anon_sym_ASSUME] = ACTIONS(5848),
    [anon_sym_ASSUMPTION] = ACTIONS(5848),
    [anon_sym_AXIOM] = ACTIONS(5848),
    [anon_sym_THEOREM] = ACTIONS(5848),
    [anon_sym_PROPOSITION] = ACTIONS(5848),
    [anon_sym_LEMMA] = ACTIONS(5848),
    [anon_sym_COROLLARY] = ACTIONS(5848),
    [anon_sym_PROOF] = ACTIONS(5848),
    [anon_sym_BY] = ACTIONS(5848),
    [anon_sym_OBVIOUS] = ACTIONS(5848),
    [anon_sym_OMITTED] = ACTIONS(5848),
    [anon_sym_USE] = ACTIONS(5848),
    [anon_sym_HIDE] = ACTIONS(5848),
    [sym__begin_proof] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [2285] = {
    [sym_block_comment] = STATE(2285),
    [sym_identifier] = ACTIONS(5850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_LOCAL] = ACTIONS(5850),
    [anon_sym_VARIABLE] = ACTIONS(5850),
    [anon_sym_VARIABLES] = ACTIONS(5850),
    [anon_sym_CONSTANT] = ACTIONS(5850),
    [anon_sym_CONSTANTS] = ACTIONS(5850),
    [anon_sym_RECURSIVE] = ACTIONS(5850),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_INSTANCE] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_Nat] = ACTIONS(5850),
    [anon_sym_u2115] = ACTIONS(5852),
    [anon_sym_Int] = ACTIONS(5850),
    [anon_sym_u2124] = ACTIONS(5852),
    [anon_sym_Real] = ACTIONS(5850),
    [anon_sym_u211d] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_BSLASHlnot] = ACTIONS(5852),
    [anon_sym_BSLASHneg] = ACTIONS(5852),
    [anon_sym_TILDE] = ACTIONS(5850),
    [anon_sym_u00ac] = ACTIONS(5852),
    [sym_union] = ACTIONS(5850),
    [sym_powerset] = ACTIONS(5850),
    [sym_domain] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [sym_negative_dot] = ACTIONS(5852),
    [sym_enabled] = ACTIONS(5850),
    [sym_unchanged] = ACTIONS(5850),
    [anon_sym_LT_GT] = ACTIONS(5852),
    [anon_sym_u22c4] = ACTIONS(5852),
    [anon_sym_u25c7] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5850),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [anon_sym_ASSUME] = ACTIONS(5850),
    [anon_sym_ASSUMPTION] = ACTIONS(5850),
    [anon_sym_AXIOM] = ACTIONS(5850),
    [anon_sym_THEOREM] = ACTIONS(5850),
    [anon_sym_PROPOSITION] = ACTIONS(5850),
    [anon_sym_LEMMA] = ACTIONS(5850),
    [anon_sym_COROLLARY] = ACTIONS(5850),
    [anon_sym_PROOF] = ACTIONS(5850),
    [anon_sym_BY] = ACTIONS(5850),
    [anon_sym_OBVIOUS] = ACTIONS(5850),
    [anon_sym_OMITTED] = ACTIONS(5850),
    [anon_sym_USE] = ACTIONS(5850),
    [anon_sym_HIDE] = ACTIONS(5850),
    [sym__begin_proof] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [2286] = {
    [sym_block_comment] = STATE(2286),
    [sym_identifier] = ACTIONS(5808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5806),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_LOCAL] = ACTIONS(5808),
    [anon_sym_VARIABLE] = ACTIONS(5808),
    [anon_sym_VARIABLES] = ACTIONS(5808),
    [anon_sym_CONSTANT] = ACTIONS(5808),
    [anon_sym_CONSTANTS] = ACTIONS(5808),
    [anon_sym_RECURSIVE] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_INSTANCE] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_Nat] = ACTIONS(5808),
    [anon_sym_u2115] = ACTIONS(5806),
    [anon_sym_Int] = ACTIONS(5808),
    [anon_sym_u2124] = ACTIONS(5806),
    [anon_sym_Real] = ACTIONS(5808),
    [anon_sym_u211d] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_BSLASHlnot] = ACTIONS(5806),
    [anon_sym_BSLASHneg] = ACTIONS(5806),
    [anon_sym_TILDE] = ACTIONS(5808),
    [anon_sym_u00ac] = ACTIONS(5806),
    [sym_union] = ACTIONS(5808),
    [sym_powerset] = ACTIONS(5808),
    [sym_domain] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [sym_negative_dot] = ACTIONS(5806),
    [sym_enabled] = ACTIONS(5808),
    [sym_unchanged] = ACTIONS(5808),
    [anon_sym_LT_GT] = ACTIONS(5806),
    [anon_sym_u22c4] = ACTIONS(5806),
    [anon_sym_u25c7] = ACTIONS(5806),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5808),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [anon_sym_ASSUME] = ACTIONS(5808),
    [anon_sym_ASSUMPTION] = ACTIONS(5808),
    [anon_sym_AXIOM] = ACTIONS(5808),
    [anon_sym_THEOREM] = ACTIONS(5808),
    [anon_sym_PROPOSITION] = ACTIONS(5808),
    [anon_sym_LEMMA] = ACTIONS(5808),
    [anon_sym_COROLLARY] = ACTIONS(5808),
    [anon_sym_PROOF] = ACTIONS(5808),
    [anon_sym_BY] = ACTIONS(5808),
    [anon_sym_OBVIOUS] = ACTIONS(5808),
    [anon_sym_OMITTED] = ACTIONS(5808),
    [anon_sym_USE] = ACTIONS(5808),
    [anon_sym_HIDE] = ACTIONS(5808),
    [sym__begin_proof] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [2287] = {
    [sym_block_comment] = STATE(2287),
    [sym_identifier] = ACTIONS(5854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_LOCAL] = ACTIONS(5854),
    [anon_sym_VARIABLE] = ACTIONS(5854),
    [anon_sym_VARIABLES] = ACTIONS(5854),
    [anon_sym_CONSTANT] = ACTIONS(5854),
    [anon_sym_CONSTANTS] = ACTIONS(5854),
    [anon_sym_RECURSIVE] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_INSTANCE] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_Nat] = ACTIONS(5854),
    [anon_sym_u2115] = ACTIONS(5856),
    [anon_sym_Int] = ACTIONS(5854),
    [anon_sym_u2124] = ACTIONS(5856),
    [anon_sym_Real] = ACTIONS(5854),
    [anon_sym_u211d] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_BSLASHlnot] = ACTIONS(5856),
    [anon_sym_BSLASHneg] = ACTIONS(5856),
    [anon_sym_TILDE] = ACTIONS(5854),
    [anon_sym_u00ac] = ACTIONS(5856),
    [sym_union] = ACTIONS(5854),
    [sym_powerset] = ACTIONS(5854),
    [sym_domain] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [sym_negative_dot] = ACTIONS(5856),
    [sym_enabled] = ACTIONS(5854),
    [sym_unchanged] = ACTIONS(5854),
    [anon_sym_LT_GT] = ACTIONS(5856),
    [anon_sym_u22c4] = ACTIONS(5856),
    [anon_sym_u25c7] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5854),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [anon_sym_ASSUME] = ACTIONS(5854),
    [anon_sym_ASSUMPTION] = ACTIONS(5854),
    [anon_sym_AXIOM] = ACTIONS(5854),
    [anon_sym_THEOREM] = ACTIONS(5854),
    [anon_sym_PROPOSITION] = ACTIONS(5854),
    [anon_sym_LEMMA] = ACTIONS(5854),
    [anon_sym_COROLLARY] = ACTIONS(5854),
    [anon_sym_PROOF] = ACTIONS(5854),
    [anon_sym_BY] = ACTIONS(5854),
    [anon_sym_OBVIOUS] = ACTIONS(5854),
    [anon_sym_OMITTED] = ACTIONS(5854),
    [anon_sym_USE] = ACTIONS(5854),
    [anon_sym_HIDE] = ACTIONS(5854),
    [sym__begin_proof] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [2288] = {
    [sym_block_comment] = STATE(2288),
    [sym_identifier] = ACTIONS(5858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_LOCAL] = ACTIONS(5858),
    [anon_sym_VARIABLE] = ACTIONS(5858),
    [anon_sym_VARIABLES] = ACTIONS(5858),
    [anon_sym_CONSTANT] = ACTIONS(5858),
    [anon_sym_CONSTANTS] = ACTIONS(5858),
    [anon_sym_RECURSIVE] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_INSTANCE] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_Nat] = ACTIONS(5858),
    [anon_sym_u2115] = ACTIONS(5860),
    [anon_sym_Int] = ACTIONS(5858),
    [anon_sym_u2124] = ACTIONS(5860),
    [anon_sym_Real] = ACTIONS(5858),
    [anon_sym_u211d] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_BSLASHlnot] = ACTIONS(5860),
    [anon_sym_BSLASHneg] = ACTIONS(5860),
    [anon_sym_TILDE] = ACTIONS(5858),
    [anon_sym_u00ac] = ACTIONS(5860),
    [sym_union] = ACTIONS(5858),
    [sym_powerset] = ACTIONS(5858),
    [sym_domain] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [sym_negative_dot] = ACTIONS(5860),
    [sym_enabled] = ACTIONS(5858),
    [sym_unchanged] = ACTIONS(5858),
    [anon_sym_LT_GT] = ACTIONS(5860),
    [anon_sym_u22c4] = ACTIONS(5860),
    [anon_sym_u25c7] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5858),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [anon_sym_ASSUME] = ACTIONS(5858),
    [anon_sym_ASSUMPTION] = ACTIONS(5858),
    [anon_sym_AXIOM] = ACTIONS(5858),
    [anon_sym_THEOREM] = ACTIONS(5858),
    [anon_sym_PROPOSITION] = ACTIONS(5858),
    [anon_sym_LEMMA] = ACTIONS(5858),
    [anon_sym_COROLLARY] = ACTIONS(5858),
    [anon_sym_PROOF] = ACTIONS(5858),
    [anon_sym_BY] = ACTIONS(5858),
    [anon_sym_OBVIOUS] = ACTIONS(5858),
    [anon_sym_OMITTED] = ACTIONS(5858),
    [anon_sym_USE] = ACTIONS(5858),
    [anon_sym_HIDE] = ACTIONS(5858),
    [sym__begin_proof] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [2289] = {
    [sym_block_comment] = STATE(2289),
    [sym_identifier] = ACTIONS(5770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5768),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_LOCAL] = ACTIONS(5770),
    [anon_sym_VARIABLE] = ACTIONS(5770),
    [anon_sym_VARIABLES] = ACTIONS(5770),
    [anon_sym_CONSTANT] = ACTIONS(5770),
    [anon_sym_CONSTANTS] = ACTIONS(5770),
    [anon_sym_RECURSIVE] = ACTIONS(5770),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_INSTANCE] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_Nat] = ACTIONS(5770),
    [anon_sym_u2115] = ACTIONS(5768),
    [anon_sym_Int] = ACTIONS(5770),
    [anon_sym_u2124] = ACTIONS(5768),
    [anon_sym_Real] = ACTIONS(5770),
    [anon_sym_u211d] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_BSLASHlnot] = ACTIONS(5768),
    [anon_sym_BSLASHneg] = ACTIONS(5768),
    [anon_sym_TILDE] = ACTIONS(5770),
    [anon_sym_u00ac] = ACTIONS(5768),
    [sym_union] = ACTIONS(5770),
    [sym_powerset] = ACTIONS(5770),
    [sym_domain] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [sym_negative_dot] = ACTIONS(5768),
    [sym_enabled] = ACTIONS(5770),
    [sym_unchanged] = ACTIONS(5770),
    [anon_sym_LT_GT] = ACTIONS(5768),
    [anon_sym_u22c4] = ACTIONS(5768),
    [anon_sym_u25c7] = ACTIONS(5768),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5770),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [anon_sym_ASSUME] = ACTIONS(5770),
    [anon_sym_ASSUMPTION] = ACTIONS(5770),
    [anon_sym_AXIOM] = ACTIONS(5770),
    [anon_sym_THEOREM] = ACTIONS(5770),
    [anon_sym_PROPOSITION] = ACTIONS(5770),
    [anon_sym_LEMMA] = ACTIONS(5770),
    [anon_sym_COROLLARY] = ACTIONS(5770),
    [anon_sym_PROOF] = ACTIONS(5770),
    [anon_sym_BY] = ACTIONS(5770),
    [anon_sym_OBVIOUS] = ACTIONS(5770),
    [anon_sym_OMITTED] = ACTIONS(5770),
    [anon_sym_USE] = ACTIONS(5770),
    [anon_sym_HIDE] = ACTIONS(5770),
    [sym__begin_proof] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [2290] = {
    [sym_block_comment] = STATE(2290),
    [ts_builtin_sym_end] = ACTIONS(5862),
    [sym_identifier] = ACTIONS(5864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5862),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_LOCAL] = ACTIONS(5864),
    [anon_sym_VARIABLE] = ACTIONS(5864),
    [anon_sym_VARIABLES] = ACTIONS(5864),
    [anon_sym_CONSTANT] = ACTIONS(5864),
    [anon_sym_CONSTANTS] = ACTIONS(5864),
    [anon_sym_RECURSIVE] = ACTIONS(5864),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_INSTANCE] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_Nat] = ACTIONS(5864),
    [anon_sym_u2115] = ACTIONS(5862),
    [anon_sym_Int] = ACTIONS(5864),
    [anon_sym_u2124] = ACTIONS(5862),
    [anon_sym_Real] = ACTIONS(5864),
    [anon_sym_u211d] = ACTIONS(5862),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_BSLASHlnot] = ACTIONS(5862),
    [anon_sym_BSLASHneg] = ACTIONS(5862),
    [anon_sym_TILDE] = ACTIONS(5864),
    [anon_sym_u00ac] = ACTIONS(5862),
    [sym_union] = ACTIONS(5864),
    [sym_powerset] = ACTIONS(5864),
    [sym_domain] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [sym_negative_dot] = ACTIONS(5862),
    [sym_enabled] = ACTIONS(5864),
    [sym_unchanged] = ACTIONS(5864),
    [anon_sym_LT_GT] = ACTIONS(5862),
    [anon_sym_u22c4] = ACTIONS(5862),
    [anon_sym_u25c7] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5864),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [anon_sym_ASSUME] = ACTIONS(5864),
    [anon_sym_ASSUMPTION] = ACTIONS(5864),
    [anon_sym_AXIOM] = ACTIONS(5864),
    [anon_sym_THEOREM] = ACTIONS(5864),
    [anon_sym_PROPOSITION] = ACTIONS(5864),
    [anon_sym_LEMMA] = ACTIONS(5864),
    [anon_sym_COROLLARY] = ACTIONS(5864),
    [anon_sym_PROOF] = ACTIONS(5864),
    [anon_sym_BY] = ACTIONS(5864),
    [anon_sym_OBVIOUS] = ACTIONS(5864),
    [anon_sym_OMITTED] = ACTIONS(5864),
    [anon_sym_USE] = ACTIONS(5864),
    [anon_sym_HIDE] = ACTIONS(5864),
    [sym__begin_proof] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [2291] = {
    [sym_block_comment] = STATE(2291),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5690),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LOCAL] = ACTIONS(5688),
    [anon_sym_VARIABLE] = ACTIONS(5688),
    [anon_sym_VARIABLES] = ACTIONS(5688),
    [anon_sym_CONSTANT] = ACTIONS(5688),
    [anon_sym_CONSTANTS] = ACTIONS(5688),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5688),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_ASSUME] = ACTIONS(5688),
    [anon_sym_ASSUMPTION] = ACTIONS(5688),
    [anon_sym_AXIOM] = ACTIONS(5688),
    [anon_sym_THEOREM] = ACTIONS(5688),
    [anon_sym_PROPOSITION] = ACTIONS(5688),
    [anon_sym_LEMMA] = ACTIONS(5688),
    [anon_sym_COROLLARY] = ACTIONS(5688),
    [anon_sym_PROOF] = ACTIONS(5688),
    [anon_sym_BY] = ACTIONS(5688),
    [anon_sym_OBVIOUS] = ACTIONS(5688),
    [anon_sym_OMITTED] = ACTIONS(5688),
    [anon_sym_USE] = ACTIONS(5688),
    [anon_sym_HIDE] = ACTIONS(5688),
    [sym__begin_proof] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2292] = {
    [sym_block_comment] = STATE(2292),
    [sym_identifier] = ACTIONS(5758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5756),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_LOCAL] = ACTIONS(5758),
    [anon_sym_VARIABLE] = ACTIONS(5758),
    [anon_sym_VARIABLES] = ACTIONS(5758),
    [anon_sym_CONSTANT] = ACTIONS(5758),
    [anon_sym_CONSTANTS] = ACTIONS(5758),
    [anon_sym_RECURSIVE] = ACTIONS(5758),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_INSTANCE] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_Nat] = ACTIONS(5758),
    [anon_sym_u2115] = ACTIONS(5756),
    [anon_sym_Int] = ACTIONS(5758),
    [anon_sym_u2124] = ACTIONS(5756),
    [anon_sym_Real] = ACTIONS(5758),
    [anon_sym_u211d] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_BSLASHlnot] = ACTIONS(5756),
    [anon_sym_BSLASHneg] = ACTIONS(5756),
    [anon_sym_TILDE] = ACTIONS(5758),
    [anon_sym_u00ac] = ACTIONS(5756),
    [sym_union] = ACTIONS(5758),
    [sym_powerset] = ACTIONS(5758),
    [sym_domain] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [sym_negative_dot] = ACTIONS(5756),
    [sym_enabled] = ACTIONS(5758),
    [sym_unchanged] = ACTIONS(5758),
    [anon_sym_LT_GT] = ACTIONS(5756),
    [anon_sym_u22c4] = ACTIONS(5756),
    [anon_sym_u25c7] = ACTIONS(5756),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5758),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [anon_sym_ASSUME] = ACTIONS(5758),
    [anon_sym_ASSUMPTION] = ACTIONS(5758),
    [anon_sym_AXIOM] = ACTIONS(5758),
    [anon_sym_THEOREM] = ACTIONS(5758),
    [anon_sym_PROPOSITION] = ACTIONS(5758),
    [anon_sym_LEMMA] = ACTIONS(5758),
    [anon_sym_COROLLARY] = ACTIONS(5758),
    [anon_sym_PROOF] = ACTIONS(5758),
    [anon_sym_BY] = ACTIONS(5758),
    [anon_sym_OBVIOUS] = ACTIONS(5758),
    [anon_sym_OMITTED] = ACTIONS(5758),
    [anon_sym_USE] = ACTIONS(5758),
    [anon_sym_HIDE] = ACTIONS(5758),
    [sym__begin_proof] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [2293] = {
    [sym_block_comment] = STATE(2293),
    [sym_identifier] = ACTIONS(5762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5760),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_LOCAL] = ACTIONS(5762),
    [anon_sym_VARIABLE] = ACTIONS(5762),
    [anon_sym_VARIABLES] = ACTIONS(5762),
    [anon_sym_CONSTANT] = ACTIONS(5762),
    [anon_sym_CONSTANTS] = ACTIONS(5762),
    [anon_sym_RECURSIVE] = ACTIONS(5762),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_INSTANCE] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_Nat] = ACTIONS(5762),
    [anon_sym_u2115] = ACTIONS(5760),
    [anon_sym_Int] = ACTIONS(5762),
    [anon_sym_u2124] = ACTIONS(5760),
    [anon_sym_Real] = ACTIONS(5762),
    [anon_sym_u211d] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_BSLASHlnot] = ACTIONS(5760),
    [anon_sym_BSLASHneg] = ACTIONS(5760),
    [anon_sym_TILDE] = ACTIONS(5762),
    [anon_sym_u00ac] = ACTIONS(5760),
    [sym_union] = ACTIONS(5762),
    [sym_powerset] = ACTIONS(5762),
    [sym_domain] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [sym_negative_dot] = ACTIONS(5760),
    [sym_enabled] = ACTIONS(5762),
    [sym_unchanged] = ACTIONS(5762),
    [anon_sym_LT_GT] = ACTIONS(5760),
    [anon_sym_u22c4] = ACTIONS(5760),
    [anon_sym_u25c7] = ACTIONS(5760),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5762),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [anon_sym_ASSUME] = ACTIONS(5762),
    [anon_sym_ASSUMPTION] = ACTIONS(5762),
    [anon_sym_AXIOM] = ACTIONS(5762),
    [anon_sym_THEOREM] = ACTIONS(5762),
    [anon_sym_PROPOSITION] = ACTIONS(5762),
    [anon_sym_LEMMA] = ACTIONS(5762),
    [anon_sym_COROLLARY] = ACTIONS(5762),
    [anon_sym_PROOF] = ACTIONS(5762),
    [anon_sym_BY] = ACTIONS(5762),
    [anon_sym_OBVIOUS] = ACTIONS(5762),
    [anon_sym_OMITTED] = ACTIONS(5762),
    [anon_sym_USE] = ACTIONS(5762),
    [anon_sym_HIDE] = ACTIONS(5762),
    [sym__begin_proof] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [2294] = {
    [sym_block_comment] = STATE(2294),
    [sym_identifier] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5764),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_LOCAL] = ACTIONS(5766),
    [anon_sym_VARIABLE] = ACTIONS(5766),
    [anon_sym_VARIABLES] = ACTIONS(5766),
    [anon_sym_CONSTANT] = ACTIONS(5766),
    [anon_sym_CONSTANTS] = ACTIONS(5766),
    [anon_sym_RECURSIVE] = ACTIONS(5766),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_INSTANCE] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_Nat] = ACTIONS(5766),
    [anon_sym_u2115] = ACTIONS(5764),
    [anon_sym_Int] = ACTIONS(5766),
    [anon_sym_u2124] = ACTIONS(5764),
    [anon_sym_Real] = ACTIONS(5766),
    [anon_sym_u211d] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_BSLASHlnot] = ACTIONS(5764),
    [anon_sym_BSLASHneg] = ACTIONS(5764),
    [anon_sym_TILDE] = ACTIONS(5766),
    [anon_sym_u00ac] = ACTIONS(5764),
    [sym_union] = ACTIONS(5766),
    [sym_powerset] = ACTIONS(5766),
    [sym_domain] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [sym_negative_dot] = ACTIONS(5764),
    [sym_enabled] = ACTIONS(5766),
    [sym_unchanged] = ACTIONS(5766),
    [anon_sym_LT_GT] = ACTIONS(5764),
    [anon_sym_u22c4] = ACTIONS(5764),
    [anon_sym_u25c7] = ACTIONS(5764),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5766),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [anon_sym_ASSUME] = ACTIONS(5766),
    [anon_sym_ASSUMPTION] = ACTIONS(5766),
    [anon_sym_AXIOM] = ACTIONS(5766),
    [anon_sym_THEOREM] = ACTIONS(5766),
    [anon_sym_PROPOSITION] = ACTIONS(5766),
    [anon_sym_LEMMA] = ACTIONS(5766),
    [anon_sym_COROLLARY] = ACTIONS(5766),
    [anon_sym_PROOF] = ACTIONS(5766),
    [anon_sym_BY] = ACTIONS(5766),
    [anon_sym_OBVIOUS] = ACTIONS(5766),
    [anon_sym_OMITTED] = ACTIONS(5766),
    [anon_sym_USE] = ACTIONS(5766),
    [anon_sym_HIDE] = ACTIONS(5766),
    [sym__begin_proof] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [2295] = {
    [sym_block_comment] = STATE(2295),
    [sym_identifier] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5724),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_LOCAL] = ACTIONS(5726),
    [anon_sym_VARIABLE] = ACTIONS(5726),
    [anon_sym_VARIABLES] = ACTIONS(5726),
    [anon_sym_CONSTANT] = ACTIONS(5726),
    [anon_sym_CONSTANTS] = ACTIONS(5726),
    [anon_sym_RECURSIVE] = ACTIONS(5726),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_INSTANCE] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_Nat] = ACTIONS(5726),
    [anon_sym_u2115] = ACTIONS(5724),
    [anon_sym_Int] = ACTIONS(5726),
    [anon_sym_u2124] = ACTIONS(5724),
    [anon_sym_Real] = ACTIONS(5726),
    [anon_sym_u211d] = ACTIONS(5724),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_BSLASHlnot] = ACTIONS(5724),
    [anon_sym_BSLASHneg] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5726),
    [anon_sym_u00ac] = ACTIONS(5724),
    [sym_union] = ACTIONS(5726),
    [sym_powerset] = ACTIONS(5726),
    [sym_domain] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [sym_negative_dot] = ACTIONS(5724),
    [sym_enabled] = ACTIONS(5726),
    [sym_unchanged] = ACTIONS(5726),
    [anon_sym_LT_GT] = ACTIONS(5724),
    [anon_sym_u22c4] = ACTIONS(5724),
    [anon_sym_u25c7] = ACTIONS(5724),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5726),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [anon_sym_ASSUME] = ACTIONS(5726),
    [anon_sym_ASSUMPTION] = ACTIONS(5726),
    [anon_sym_AXIOM] = ACTIONS(5726),
    [anon_sym_THEOREM] = ACTIONS(5726),
    [anon_sym_PROPOSITION] = ACTIONS(5726),
    [anon_sym_LEMMA] = ACTIONS(5726),
    [anon_sym_COROLLARY] = ACTIONS(5726),
    [anon_sym_PROOF] = ACTIONS(5726),
    [anon_sym_BY] = ACTIONS(5726),
    [anon_sym_OBVIOUS] = ACTIONS(5726),
    [anon_sym_OMITTED] = ACTIONS(5726),
    [anon_sym_USE] = ACTIONS(5726),
    [anon_sym_HIDE] = ACTIONS(5726),
    [sym__begin_proof] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [2296] = {
    [sym_block_comment] = STATE(2296),
    [sym_identifier] = ACTIONS(5678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5676),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_LOCAL] = ACTIONS(5678),
    [anon_sym_VARIABLE] = ACTIONS(5678),
    [anon_sym_VARIABLES] = ACTIONS(5678),
    [anon_sym_CONSTANT] = ACTIONS(5678),
    [anon_sym_CONSTANTS] = ACTIONS(5678),
    [anon_sym_RECURSIVE] = ACTIONS(5678),
    [anon_sym_LPAREN] = ACTIONS(5866),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_INSTANCE] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_Nat] = ACTIONS(5678),
    [anon_sym_u2115] = ACTIONS(5676),
    [anon_sym_Int] = ACTIONS(5678),
    [anon_sym_u2124] = ACTIONS(5676),
    [anon_sym_Real] = ACTIONS(5678),
    [anon_sym_u211d] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_BSLASHlnot] = ACTIONS(5676),
    [anon_sym_BSLASHneg] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5678),
    [anon_sym_u00ac] = ACTIONS(5676),
    [sym_union] = ACTIONS(5678),
    [sym_powerset] = ACTIONS(5678),
    [sym_domain] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [sym_negative_dot] = ACTIONS(5676),
    [sym_enabled] = ACTIONS(5678),
    [sym_unchanged] = ACTIONS(5678),
    [anon_sym_LT_GT] = ACTIONS(5676),
    [anon_sym_u22c4] = ACTIONS(5676),
    [anon_sym_u25c7] = ACTIONS(5676),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5678),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [anon_sym_ASSUME] = ACTIONS(5678),
    [anon_sym_ASSUMPTION] = ACTIONS(5678),
    [anon_sym_AXIOM] = ACTIONS(5678),
    [anon_sym_THEOREM] = ACTIONS(5678),
    [anon_sym_PROPOSITION] = ACTIONS(5678),
    [anon_sym_LEMMA] = ACTIONS(5678),
    [anon_sym_COROLLARY] = ACTIONS(5678),
    [anon_sym_USE] = ACTIONS(5678),
    [anon_sym_HIDE] = ACTIONS(5678),
    [anon_sym_DEF] = ACTIONS(5678),
    [anon_sym_DEFS] = ACTIONS(5678),
    [sym__double_excl] = ACTIONS(5676),
  },
  [2297] = {
    [sym_block_comment] = STATE(2297),
    [sym_identifier] = ACTIONS(5868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5870),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_LOCAL] = ACTIONS(5868),
    [anon_sym_VARIABLE] = ACTIONS(5868),
    [anon_sym_VARIABLES] = ACTIONS(5868),
    [anon_sym_CONSTANT] = ACTIONS(5868),
    [anon_sym_CONSTANTS] = ACTIONS(5868),
    [anon_sym_RECURSIVE] = ACTIONS(5868),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_INSTANCE] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_Nat] = ACTIONS(5868),
    [anon_sym_u2115] = ACTIONS(5870),
    [anon_sym_Int] = ACTIONS(5868),
    [anon_sym_u2124] = ACTIONS(5870),
    [anon_sym_Real] = ACTIONS(5868),
    [anon_sym_u211d] = ACTIONS(5870),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_BSLASHlnot] = ACTIONS(5870),
    [anon_sym_BSLASHneg] = ACTIONS(5870),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_u00ac] = ACTIONS(5870),
    [sym_union] = ACTIONS(5868),
    [sym_powerset] = ACTIONS(5868),
    [sym_domain] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [sym_negative_dot] = ACTIONS(5870),
    [sym_enabled] = ACTIONS(5868),
    [sym_unchanged] = ACTIONS(5868),
    [anon_sym_LT_GT] = ACTIONS(5870),
    [anon_sym_u22c4] = ACTIONS(5870),
    [anon_sym_u25c7] = ACTIONS(5870),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5868),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [anon_sym_ASSUME] = ACTIONS(5868),
    [anon_sym_ASSUMPTION] = ACTIONS(5868),
    [anon_sym_AXIOM] = ACTIONS(5868),
    [anon_sym_THEOREM] = ACTIONS(5868),
    [anon_sym_PROPOSITION] = ACTIONS(5868),
    [anon_sym_LEMMA] = ACTIONS(5868),
    [anon_sym_COROLLARY] = ACTIONS(5868),
    [anon_sym_PROOF] = ACTIONS(5868),
    [anon_sym_BY] = ACTIONS(5868),
    [anon_sym_OBVIOUS] = ACTIONS(5868),
    [anon_sym_OMITTED] = ACTIONS(5868),
    [anon_sym_USE] = ACTIONS(5868),
    [anon_sym_HIDE] = ACTIONS(5868),
    [sym__begin_proof] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [2298] = {
    [sym_block_comment] = STATE(2298),
    [ts_builtin_sym_end] = ACTIONS(5872),
    [sym_identifier] = ACTIONS(5874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5872),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_LOCAL] = ACTIONS(5874),
    [anon_sym_VARIABLE] = ACTIONS(5874),
    [anon_sym_VARIABLES] = ACTIONS(5874),
    [anon_sym_CONSTANT] = ACTIONS(5874),
    [anon_sym_CONSTANTS] = ACTIONS(5874),
    [anon_sym_RECURSIVE] = ACTIONS(5874),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_INSTANCE] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_Nat] = ACTIONS(5874),
    [anon_sym_u2115] = ACTIONS(5872),
    [anon_sym_Int] = ACTIONS(5874),
    [anon_sym_u2124] = ACTIONS(5872),
    [anon_sym_Real] = ACTIONS(5874),
    [anon_sym_u211d] = ACTIONS(5872),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_BSLASHlnot] = ACTIONS(5872),
    [anon_sym_BSLASHneg] = ACTIONS(5872),
    [anon_sym_TILDE] = ACTIONS(5874),
    [anon_sym_u00ac] = ACTIONS(5872),
    [sym_union] = ACTIONS(5874),
    [sym_powerset] = ACTIONS(5874),
    [sym_domain] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [sym_negative_dot] = ACTIONS(5872),
    [sym_enabled] = ACTIONS(5874),
    [sym_unchanged] = ACTIONS(5874),
    [anon_sym_LT_GT] = ACTIONS(5872),
    [anon_sym_u22c4] = ACTIONS(5872),
    [anon_sym_u25c7] = ACTIONS(5872),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5874),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [anon_sym_ASSUME] = ACTIONS(5874),
    [anon_sym_ASSUMPTION] = ACTIONS(5874),
    [anon_sym_AXIOM] = ACTIONS(5874),
    [anon_sym_THEOREM] = ACTIONS(5874),
    [anon_sym_PROPOSITION] = ACTIONS(5874),
    [anon_sym_LEMMA] = ACTIONS(5874),
    [anon_sym_COROLLARY] = ACTIONS(5874),
    [anon_sym_PROOF] = ACTIONS(5874),
    [anon_sym_BY] = ACTIONS(5874),
    [anon_sym_OBVIOUS] = ACTIONS(5874),
    [anon_sym_OMITTED] = ACTIONS(5874),
    [anon_sym_USE] = ACTIONS(5874),
    [anon_sym_HIDE] = ACTIONS(5874),
    [sym__begin_proof] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [2299] = {
    [sym_block_comment] = STATE(2299),
    [ts_builtin_sym_end] = ACTIONS(5876),
    [sym_identifier] = ACTIONS(5878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5876),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_LOCAL] = ACTIONS(5878),
    [anon_sym_VARIABLE] = ACTIONS(5878),
    [anon_sym_VARIABLES] = ACTIONS(5878),
    [anon_sym_CONSTANT] = ACTIONS(5878),
    [anon_sym_CONSTANTS] = ACTIONS(5878),
    [anon_sym_RECURSIVE] = ACTIONS(5878),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_INSTANCE] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_Nat] = ACTIONS(5878),
    [anon_sym_u2115] = ACTIONS(5876),
    [anon_sym_Int] = ACTIONS(5878),
    [anon_sym_u2124] = ACTIONS(5876),
    [anon_sym_Real] = ACTIONS(5878),
    [anon_sym_u211d] = ACTIONS(5876),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_BSLASHlnot] = ACTIONS(5876),
    [anon_sym_BSLASHneg] = ACTIONS(5876),
    [anon_sym_TILDE] = ACTIONS(5878),
    [anon_sym_u00ac] = ACTIONS(5876),
    [sym_union] = ACTIONS(5878),
    [sym_powerset] = ACTIONS(5878),
    [sym_domain] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [sym_negative_dot] = ACTIONS(5876),
    [sym_enabled] = ACTIONS(5878),
    [sym_unchanged] = ACTIONS(5878),
    [anon_sym_LT_GT] = ACTIONS(5876),
    [anon_sym_u22c4] = ACTIONS(5876),
    [anon_sym_u25c7] = ACTIONS(5876),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5878),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [anon_sym_ASSUME] = ACTIONS(5878),
    [anon_sym_ASSUMPTION] = ACTIONS(5878),
    [anon_sym_AXIOM] = ACTIONS(5878),
    [anon_sym_THEOREM] = ACTIONS(5878),
    [anon_sym_PROPOSITION] = ACTIONS(5878),
    [anon_sym_LEMMA] = ACTIONS(5878),
    [anon_sym_COROLLARY] = ACTIONS(5878),
    [anon_sym_PROOF] = ACTIONS(5878),
    [anon_sym_BY] = ACTIONS(5878),
    [anon_sym_OBVIOUS] = ACTIONS(5878),
    [anon_sym_OMITTED] = ACTIONS(5878),
    [anon_sym_USE] = ACTIONS(5878),
    [anon_sym_HIDE] = ACTIONS(5878),
    [sym__begin_proof] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [2300] = {
    [sym_block_comment] = STATE(2300),
    [ts_builtin_sym_end] = ACTIONS(5880),
    [sym_identifier] = ACTIONS(5882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5880),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_LOCAL] = ACTIONS(5882),
    [anon_sym_VARIABLE] = ACTIONS(5882),
    [anon_sym_VARIABLES] = ACTIONS(5882),
    [anon_sym_CONSTANT] = ACTIONS(5882),
    [anon_sym_CONSTANTS] = ACTIONS(5882),
    [anon_sym_RECURSIVE] = ACTIONS(5882),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_INSTANCE] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_Nat] = ACTIONS(5882),
    [anon_sym_u2115] = ACTIONS(5880),
    [anon_sym_Int] = ACTIONS(5882),
    [anon_sym_u2124] = ACTIONS(5880),
    [anon_sym_Real] = ACTIONS(5882),
    [anon_sym_u211d] = ACTIONS(5880),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_BSLASHlnot] = ACTIONS(5880),
    [anon_sym_BSLASHneg] = ACTIONS(5880),
    [anon_sym_TILDE] = ACTIONS(5882),
    [anon_sym_u00ac] = ACTIONS(5880),
    [sym_union] = ACTIONS(5882),
    [sym_powerset] = ACTIONS(5882),
    [sym_domain] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [sym_negative_dot] = ACTIONS(5880),
    [sym_enabled] = ACTIONS(5882),
    [sym_unchanged] = ACTIONS(5882),
    [anon_sym_LT_GT] = ACTIONS(5880),
    [anon_sym_u22c4] = ACTIONS(5880),
    [anon_sym_u25c7] = ACTIONS(5880),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5882),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [anon_sym_ASSUME] = ACTIONS(5882),
    [anon_sym_ASSUMPTION] = ACTIONS(5882),
    [anon_sym_AXIOM] = ACTIONS(5882),
    [anon_sym_THEOREM] = ACTIONS(5882),
    [anon_sym_PROPOSITION] = ACTIONS(5882),
    [anon_sym_LEMMA] = ACTIONS(5882),
    [anon_sym_COROLLARY] = ACTIONS(5882),
    [anon_sym_PROOF] = ACTIONS(5882),
    [anon_sym_BY] = ACTIONS(5882),
    [anon_sym_OBVIOUS] = ACTIONS(5882),
    [anon_sym_OMITTED] = ACTIONS(5882),
    [anon_sym_USE] = ACTIONS(5882),
    [anon_sym_HIDE] = ACTIONS(5882),
    [sym__begin_proof] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [2301] = {
    [sym_block_comment] = STATE(2301),
    [ts_builtin_sym_end] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5690),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LOCAL] = ACTIONS(5688),
    [anon_sym_VARIABLE] = ACTIONS(5688),
    [anon_sym_VARIABLES] = ACTIONS(5688),
    [anon_sym_CONSTANT] = ACTIONS(5688),
    [anon_sym_CONSTANTS] = ACTIONS(5688),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5688),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_ASSUME] = ACTIONS(5688),
    [anon_sym_ASSUMPTION] = ACTIONS(5688),
    [anon_sym_AXIOM] = ACTIONS(5688),
    [anon_sym_THEOREM] = ACTIONS(5688),
    [anon_sym_PROPOSITION] = ACTIONS(5688),
    [anon_sym_LEMMA] = ACTIONS(5688),
    [anon_sym_COROLLARY] = ACTIONS(5688),
    [anon_sym_PROOF] = ACTIONS(5688),
    [anon_sym_BY] = ACTIONS(5688),
    [anon_sym_OBVIOUS] = ACTIONS(5688),
    [anon_sym_OMITTED] = ACTIONS(5688),
    [anon_sym_USE] = ACTIONS(5688),
    [anon_sym_HIDE] = ACTIONS(5688),
    [sym__begin_proof] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2302] = {
    [sym_block_comment] = STATE(2302),
    [ts_builtin_sym_end] = ACTIONS(5884),
    [sym_identifier] = ACTIONS(5886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5884),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_LOCAL] = ACTIONS(5886),
    [anon_sym_VARIABLE] = ACTIONS(5886),
    [anon_sym_VARIABLES] = ACTIONS(5886),
    [anon_sym_CONSTANT] = ACTIONS(5886),
    [anon_sym_CONSTANTS] = ACTIONS(5886),
    [anon_sym_RECURSIVE] = ACTIONS(5886),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_INSTANCE] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_Nat] = ACTIONS(5886),
    [anon_sym_u2115] = ACTIONS(5884),
    [anon_sym_Int] = ACTIONS(5886),
    [anon_sym_u2124] = ACTIONS(5884),
    [anon_sym_Real] = ACTIONS(5886),
    [anon_sym_u211d] = ACTIONS(5884),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_BSLASHlnot] = ACTIONS(5884),
    [anon_sym_BSLASHneg] = ACTIONS(5884),
    [anon_sym_TILDE] = ACTIONS(5886),
    [anon_sym_u00ac] = ACTIONS(5884),
    [sym_union] = ACTIONS(5886),
    [sym_powerset] = ACTIONS(5886),
    [sym_domain] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [sym_negative_dot] = ACTIONS(5884),
    [sym_enabled] = ACTIONS(5886),
    [sym_unchanged] = ACTIONS(5886),
    [anon_sym_LT_GT] = ACTIONS(5884),
    [anon_sym_u22c4] = ACTIONS(5884),
    [anon_sym_u25c7] = ACTIONS(5884),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5886),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [anon_sym_ASSUME] = ACTIONS(5886),
    [anon_sym_ASSUMPTION] = ACTIONS(5886),
    [anon_sym_AXIOM] = ACTIONS(5886),
    [anon_sym_THEOREM] = ACTIONS(5886),
    [anon_sym_PROPOSITION] = ACTIONS(5886),
    [anon_sym_LEMMA] = ACTIONS(5886),
    [anon_sym_COROLLARY] = ACTIONS(5886),
    [anon_sym_PROOF] = ACTIONS(5886),
    [anon_sym_BY] = ACTIONS(5886),
    [anon_sym_OBVIOUS] = ACTIONS(5886),
    [anon_sym_OMITTED] = ACTIONS(5886),
    [anon_sym_USE] = ACTIONS(5886),
    [anon_sym_HIDE] = ACTIONS(5886),
    [sym__begin_proof] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [2303] = {
    [sym_block_comment] = STATE(2303),
    [sym_identifier] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5890),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_LOCAL] = ACTIONS(5888),
    [anon_sym_VARIABLE] = ACTIONS(5888),
    [anon_sym_VARIABLES] = ACTIONS(5888),
    [anon_sym_CONSTANT] = ACTIONS(5888),
    [anon_sym_CONSTANTS] = ACTIONS(5888),
    [anon_sym_RECURSIVE] = ACTIONS(5888),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_INSTANCE] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_Nat] = ACTIONS(5888),
    [anon_sym_u2115] = ACTIONS(5890),
    [anon_sym_Int] = ACTIONS(5888),
    [anon_sym_u2124] = ACTIONS(5890),
    [anon_sym_Real] = ACTIONS(5888),
    [anon_sym_u211d] = ACTIONS(5890),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_BSLASHlnot] = ACTIONS(5890),
    [anon_sym_BSLASHneg] = ACTIONS(5890),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_u00ac] = ACTIONS(5890),
    [sym_union] = ACTIONS(5888),
    [sym_powerset] = ACTIONS(5888),
    [sym_domain] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [sym_negative_dot] = ACTIONS(5890),
    [sym_enabled] = ACTIONS(5888),
    [sym_unchanged] = ACTIONS(5888),
    [anon_sym_LT_GT] = ACTIONS(5890),
    [anon_sym_u22c4] = ACTIONS(5890),
    [anon_sym_u25c7] = ACTIONS(5890),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5888),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [anon_sym_ASSUME] = ACTIONS(5888),
    [anon_sym_ASSUMPTION] = ACTIONS(5888),
    [anon_sym_AXIOM] = ACTIONS(5888),
    [anon_sym_THEOREM] = ACTIONS(5888),
    [anon_sym_PROPOSITION] = ACTIONS(5888),
    [anon_sym_LEMMA] = ACTIONS(5888),
    [anon_sym_COROLLARY] = ACTIONS(5888),
    [anon_sym_PROOF] = ACTIONS(5888),
    [anon_sym_BY] = ACTIONS(5888),
    [anon_sym_OBVIOUS] = ACTIONS(5888),
    [anon_sym_OMITTED] = ACTIONS(5888),
    [anon_sym_USE] = ACTIONS(5888),
    [anon_sym_HIDE] = ACTIONS(5888),
    [sym__begin_proof] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [2304] = {
    [sym_block_comment] = STATE(2304),
    [sym_identifier] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5728),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_LOCAL] = ACTIONS(5730),
    [anon_sym_VARIABLE] = ACTIONS(5730),
    [anon_sym_VARIABLES] = ACTIONS(5730),
    [anon_sym_CONSTANT] = ACTIONS(5730),
    [anon_sym_CONSTANTS] = ACTIONS(5730),
    [anon_sym_RECURSIVE] = ACTIONS(5730),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_INSTANCE] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_Nat] = ACTIONS(5730),
    [anon_sym_u2115] = ACTIONS(5728),
    [anon_sym_Int] = ACTIONS(5730),
    [anon_sym_u2124] = ACTIONS(5728),
    [anon_sym_Real] = ACTIONS(5730),
    [anon_sym_u211d] = ACTIONS(5728),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_BSLASHlnot] = ACTIONS(5728),
    [anon_sym_BSLASHneg] = ACTIONS(5728),
    [anon_sym_TILDE] = ACTIONS(5730),
    [anon_sym_u00ac] = ACTIONS(5728),
    [sym_union] = ACTIONS(5730),
    [sym_powerset] = ACTIONS(5730),
    [sym_domain] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [sym_negative_dot] = ACTIONS(5728),
    [sym_enabled] = ACTIONS(5730),
    [sym_unchanged] = ACTIONS(5730),
    [anon_sym_LT_GT] = ACTIONS(5728),
    [anon_sym_u22c4] = ACTIONS(5728),
    [anon_sym_u25c7] = ACTIONS(5728),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5730),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [anon_sym_ASSUME] = ACTIONS(5730),
    [anon_sym_ASSUMPTION] = ACTIONS(5730),
    [anon_sym_AXIOM] = ACTIONS(5730),
    [anon_sym_THEOREM] = ACTIONS(5730),
    [anon_sym_PROPOSITION] = ACTIONS(5730),
    [anon_sym_LEMMA] = ACTIONS(5730),
    [anon_sym_COROLLARY] = ACTIONS(5730),
    [anon_sym_PROOF] = ACTIONS(5730),
    [anon_sym_BY] = ACTIONS(5730),
    [anon_sym_OBVIOUS] = ACTIONS(5730),
    [anon_sym_OMITTED] = ACTIONS(5730),
    [anon_sym_USE] = ACTIONS(5730),
    [anon_sym_HIDE] = ACTIONS(5730),
    [sym__begin_proof] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [2305] = {
    [sym_block_comment] = STATE(2305),
    [sym_identifier] = ACTIONS(5734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5732),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_LOCAL] = ACTIONS(5734),
    [anon_sym_VARIABLE] = ACTIONS(5734),
    [anon_sym_VARIABLES] = ACTIONS(5734),
    [anon_sym_CONSTANT] = ACTIONS(5734),
    [anon_sym_CONSTANTS] = ACTIONS(5734),
    [anon_sym_RECURSIVE] = ACTIONS(5734),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_INSTANCE] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_Nat] = ACTIONS(5734),
    [anon_sym_u2115] = ACTIONS(5732),
    [anon_sym_Int] = ACTIONS(5734),
    [anon_sym_u2124] = ACTIONS(5732),
    [anon_sym_Real] = ACTIONS(5734),
    [anon_sym_u211d] = ACTIONS(5732),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_BSLASHlnot] = ACTIONS(5732),
    [anon_sym_BSLASHneg] = ACTIONS(5732),
    [anon_sym_TILDE] = ACTIONS(5734),
    [anon_sym_u00ac] = ACTIONS(5732),
    [sym_union] = ACTIONS(5734),
    [sym_powerset] = ACTIONS(5734),
    [sym_domain] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [sym_negative_dot] = ACTIONS(5732),
    [sym_enabled] = ACTIONS(5734),
    [sym_unchanged] = ACTIONS(5734),
    [anon_sym_LT_GT] = ACTIONS(5732),
    [anon_sym_u22c4] = ACTIONS(5732),
    [anon_sym_u25c7] = ACTIONS(5732),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5734),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [anon_sym_ASSUME] = ACTIONS(5734),
    [anon_sym_ASSUMPTION] = ACTIONS(5734),
    [anon_sym_AXIOM] = ACTIONS(5734),
    [anon_sym_THEOREM] = ACTIONS(5734),
    [anon_sym_PROPOSITION] = ACTIONS(5734),
    [anon_sym_LEMMA] = ACTIONS(5734),
    [anon_sym_COROLLARY] = ACTIONS(5734),
    [anon_sym_PROOF] = ACTIONS(5734),
    [anon_sym_BY] = ACTIONS(5734),
    [anon_sym_OBVIOUS] = ACTIONS(5734),
    [anon_sym_OMITTED] = ACTIONS(5734),
    [anon_sym_USE] = ACTIONS(5734),
    [anon_sym_HIDE] = ACTIONS(5734),
    [sym__begin_proof] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [2306] = {
    [sym_block_comment] = STATE(2306),
    [ts_builtin_sym_end] = ACTIONS(5892),
    [sym_identifier] = ACTIONS(5894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5892),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_LOCAL] = ACTIONS(5894),
    [anon_sym_VARIABLE] = ACTIONS(5894),
    [anon_sym_VARIABLES] = ACTIONS(5894),
    [anon_sym_CONSTANT] = ACTIONS(5894),
    [anon_sym_CONSTANTS] = ACTIONS(5894),
    [anon_sym_RECURSIVE] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_INSTANCE] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_Nat] = ACTIONS(5894),
    [anon_sym_u2115] = ACTIONS(5892),
    [anon_sym_Int] = ACTIONS(5894),
    [anon_sym_u2124] = ACTIONS(5892),
    [anon_sym_Real] = ACTIONS(5894),
    [anon_sym_u211d] = ACTIONS(5892),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_BSLASHlnot] = ACTIONS(5892),
    [anon_sym_BSLASHneg] = ACTIONS(5892),
    [anon_sym_TILDE] = ACTIONS(5894),
    [anon_sym_u00ac] = ACTIONS(5892),
    [sym_union] = ACTIONS(5894),
    [sym_powerset] = ACTIONS(5894),
    [sym_domain] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [sym_negative_dot] = ACTIONS(5892),
    [sym_enabled] = ACTIONS(5894),
    [sym_unchanged] = ACTIONS(5894),
    [anon_sym_LT_GT] = ACTIONS(5892),
    [anon_sym_u22c4] = ACTIONS(5892),
    [anon_sym_u25c7] = ACTIONS(5892),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5894),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [anon_sym_ASSUME] = ACTIONS(5894),
    [anon_sym_ASSUMPTION] = ACTIONS(5894),
    [anon_sym_AXIOM] = ACTIONS(5894),
    [anon_sym_THEOREM] = ACTIONS(5894),
    [anon_sym_PROPOSITION] = ACTIONS(5894),
    [anon_sym_LEMMA] = ACTIONS(5894),
    [anon_sym_COROLLARY] = ACTIONS(5894),
    [anon_sym_PROOF] = ACTIONS(5894),
    [anon_sym_BY] = ACTIONS(5894),
    [anon_sym_OBVIOUS] = ACTIONS(5894),
    [anon_sym_OMITTED] = ACTIONS(5894),
    [anon_sym_USE] = ACTIONS(5894),
    [anon_sym_HIDE] = ACTIONS(5894),
    [sym__begin_proof] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [2307] = {
    [sym_block_comment] = STATE(2307),
    [sym_identifier] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5740),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_LOCAL] = ACTIONS(5742),
    [anon_sym_VARIABLE] = ACTIONS(5742),
    [anon_sym_VARIABLES] = ACTIONS(5742),
    [anon_sym_CONSTANT] = ACTIONS(5742),
    [anon_sym_CONSTANTS] = ACTIONS(5742),
    [anon_sym_RECURSIVE] = ACTIONS(5742),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_INSTANCE] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_Nat] = ACTIONS(5742),
    [anon_sym_u2115] = ACTIONS(5740),
    [anon_sym_Int] = ACTIONS(5742),
    [anon_sym_u2124] = ACTIONS(5740),
    [anon_sym_Real] = ACTIONS(5742),
    [anon_sym_u211d] = ACTIONS(5740),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_BSLASHlnot] = ACTIONS(5740),
    [anon_sym_BSLASHneg] = ACTIONS(5740),
    [anon_sym_TILDE] = ACTIONS(5742),
    [anon_sym_u00ac] = ACTIONS(5740),
    [sym_union] = ACTIONS(5742),
    [sym_powerset] = ACTIONS(5742),
    [sym_domain] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [sym_negative_dot] = ACTIONS(5740),
    [sym_enabled] = ACTIONS(5742),
    [sym_unchanged] = ACTIONS(5742),
    [anon_sym_LT_GT] = ACTIONS(5740),
    [anon_sym_u22c4] = ACTIONS(5740),
    [anon_sym_u25c7] = ACTIONS(5740),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5742),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [anon_sym_ASSUME] = ACTIONS(5742),
    [anon_sym_ASSUMPTION] = ACTIONS(5742),
    [anon_sym_AXIOM] = ACTIONS(5742),
    [anon_sym_THEOREM] = ACTIONS(5742),
    [anon_sym_PROPOSITION] = ACTIONS(5742),
    [anon_sym_LEMMA] = ACTIONS(5742),
    [anon_sym_COROLLARY] = ACTIONS(5742),
    [anon_sym_PROOF] = ACTIONS(5742),
    [anon_sym_BY] = ACTIONS(5742),
    [anon_sym_OBVIOUS] = ACTIONS(5742),
    [anon_sym_OMITTED] = ACTIONS(5742),
    [anon_sym_USE] = ACTIONS(5742),
    [anon_sym_HIDE] = ACTIONS(5742),
    [sym__begin_proof] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [2308] = {
    [sym_block_comment] = STATE(2308),
    [ts_builtin_sym_end] = ACTIONS(5896),
    [sym_identifier] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5896),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_LOCAL] = ACTIONS(5898),
    [anon_sym_VARIABLE] = ACTIONS(5898),
    [anon_sym_VARIABLES] = ACTIONS(5898),
    [anon_sym_CONSTANT] = ACTIONS(5898),
    [anon_sym_CONSTANTS] = ACTIONS(5898),
    [anon_sym_RECURSIVE] = ACTIONS(5898),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_INSTANCE] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_Nat] = ACTIONS(5898),
    [anon_sym_u2115] = ACTIONS(5896),
    [anon_sym_Int] = ACTIONS(5898),
    [anon_sym_u2124] = ACTIONS(5896),
    [anon_sym_Real] = ACTIONS(5898),
    [anon_sym_u211d] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_BSLASHlnot] = ACTIONS(5896),
    [anon_sym_BSLASHneg] = ACTIONS(5896),
    [anon_sym_TILDE] = ACTIONS(5898),
    [anon_sym_u00ac] = ACTIONS(5896),
    [sym_union] = ACTIONS(5898),
    [sym_powerset] = ACTIONS(5898),
    [sym_domain] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [sym_negative_dot] = ACTIONS(5896),
    [sym_enabled] = ACTIONS(5898),
    [sym_unchanged] = ACTIONS(5898),
    [anon_sym_LT_GT] = ACTIONS(5896),
    [anon_sym_u22c4] = ACTIONS(5896),
    [anon_sym_u25c7] = ACTIONS(5896),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5898),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [anon_sym_ASSUME] = ACTIONS(5898),
    [anon_sym_ASSUMPTION] = ACTIONS(5898),
    [anon_sym_AXIOM] = ACTIONS(5898),
    [anon_sym_THEOREM] = ACTIONS(5898),
    [anon_sym_PROPOSITION] = ACTIONS(5898),
    [anon_sym_LEMMA] = ACTIONS(5898),
    [anon_sym_COROLLARY] = ACTIONS(5898),
    [anon_sym_PROOF] = ACTIONS(5898),
    [anon_sym_BY] = ACTIONS(5898),
    [anon_sym_OBVIOUS] = ACTIONS(5898),
    [anon_sym_OMITTED] = ACTIONS(5898),
    [anon_sym_USE] = ACTIONS(5898),
    [anon_sym_HIDE] = ACTIONS(5898),
    [sym__begin_proof] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [2309] = {
    [sym_block_comment] = STATE(2309),
    [ts_builtin_sym_end] = ACTIONS(5900),
    [sym_identifier] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5900),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_LOCAL] = ACTIONS(5902),
    [anon_sym_VARIABLE] = ACTIONS(5902),
    [anon_sym_VARIABLES] = ACTIONS(5902),
    [anon_sym_CONSTANT] = ACTIONS(5902),
    [anon_sym_CONSTANTS] = ACTIONS(5902),
    [anon_sym_RECURSIVE] = ACTIONS(5902),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_INSTANCE] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_Nat] = ACTIONS(5902),
    [anon_sym_u2115] = ACTIONS(5900),
    [anon_sym_Int] = ACTIONS(5902),
    [anon_sym_u2124] = ACTIONS(5900),
    [anon_sym_Real] = ACTIONS(5902),
    [anon_sym_u211d] = ACTIONS(5900),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_BSLASHlnot] = ACTIONS(5900),
    [anon_sym_BSLASHneg] = ACTIONS(5900),
    [anon_sym_TILDE] = ACTIONS(5902),
    [anon_sym_u00ac] = ACTIONS(5900),
    [sym_union] = ACTIONS(5902),
    [sym_powerset] = ACTIONS(5902),
    [sym_domain] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [sym_negative_dot] = ACTIONS(5900),
    [sym_enabled] = ACTIONS(5902),
    [sym_unchanged] = ACTIONS(5902),
    [anon_sym_LT_GT] = ACTIONS(5900),
    [anon_sym_u22c4] = ACTIONS(5900),
    [anon_sym_u25c7] = ACTIONS(5900),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5902),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [anon_sym_ASSUME] = ACTIONS(5902),
    [anon_sym_ASSUMPTION] = ACTIONS(5902),
    [anon_sym_AXIOM] = ACTIONS(5902),
    [anon_sym_THEOREM] = ACTIONS(5902),
    [anon_sym_PROPOSITION] = ACTIONS(5902),
    [anon_sym_LEMMA] = ACTIONS(5902),
    [anon_sym_COROLLARY] = ACTIONS(5902),
    [anon_sym_PROOF] = ACTIONS(5902),
    [anon_sym_BY] = ACTIONS(5902),
    [anon_sym_OBVIOUS] = ACTIONS(5902),
    [anon_sym_OMITTED] = ACTIONS(5902),
    [anon_sym_USE] = ACTIONS(5902),
    [anon_sym_HIDE] = ACTIONS(5902),
    [sym__begin_proof] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [2310] = {
    [sym_block_comment] = STATE(2310),
    [ts_builtin_sym_end] = ACTIONS(5856),
    [sym_identifier] = ACTIONS(5854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5856),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_LOCAL] = ACTIONS(5854),
    [anon_sym_VARIABLE] = ACTIONS(5854),
    [anon_sym_VARIABLES] = ACTIONS(5854),
    [anon_sym_CONSTANT] = ACTIONS(5854),
    [anon_sym_CONSTANTS] = ACTIONS(5854),
    [anon_sym_RECURSIVE] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_INSTANCE] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_Nat] = ACTIONS(5854),
    [anon_sym_u2115] = ACTIONS(5856),
    [anon_sym_Int] = ACTIONS(5854),
    [anon_sym_u2124] = ACTIONS(5856),
    [anon_sym_Real] = ACTIONS(5854),
    [anon_sym_u211d] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_BSLASHlnot] = ACTIONS(5856),
    [anon_sym_BSLASHneg] = ACTIONS(5856),
    [anon_sym_TILDE] = ACTIONS(5854),
    [anon_sym_u00ac] = ACTIONS(5856),
    [sym_union] = ACTIONS(5854),
    [sym_powerset] = ACTIONS(5854),
    [sym_domain] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [sym_negative_dot] = ACTIONS(5856),
    [sym_enabled] = ACTIONS(5854),
    [sym_unchanged] = ACTIONS(5854),
    [anon_sym_LT_GT] = ACTIONS(5856),
    [anon_sym_u22c4] = ACTIONS(5856),
    [anon_sym_u25c7] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5854),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [anon_sym_ASSUME] = ACTIONS(5854),
    [anon_sym_ASSUMPTION] = ACTIONS(5854),
    [anon_sym_AXIOM] = ACTIONS(5854),
    [anon_sym_THEOREM] = ACTIONS(5854),
    [anon_sym_PROPOSITION] = ACTIONS(5854),
    [anon_sym_LEMMA] = ACTIONS(5854),
    [anon_sym_COROLLARY] = ACTIONS(5854),
    [anon_sym_PROOF] = ACTIONS(5854),
    [anon_sym_BY] = ACTIONS(5854),
    [anon_sym_OBVIOUS] = ACTIONS(5854),
    [anon_sym_OMITTED] = ACTIONS(5854),
    [anon_sym_USE] = ACTIONS(5854),
    [anon_sym_HIDE] = ACTIONS(5854),
    [sym__begin_proof] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [2311] = {
    [sym_block_comment] = STATE(2311),
    [sym_identifier] = ACTIONS(5754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_LOCAL] = ACTIONS(5754),
    [anon_sym_VARIABLE] = ACTIONS(5754),
    [anon_sym_VARIABLES] = ACTIONS(5754),
    [anon_sym_CONSTANT] = ACTIONS(5754),
    [anon_sym_CONSTANTS] = ACTIONS(5754),
    [anon_sym_RECURSIVE] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_INSTANCE] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_Nat] = ACTIONS(5754),
    [anon_sym_u2115] = ACTIONS(5752),
    [anon_sym_Int] = ACTIONS(5754),
    [anon_sym_u2124] = ACTIONS(5752),
    [anon_sym_Real] = ACTIONS(5754),
    [anon_sym_u211d] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_BSLASHlnot] = ACTIONS(5752),
    [anon_sym_BSLASHneg] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(5754),
    [anon_sym_u00ac] = ACTIONS(5752),
    [sym_union] = ACTIONS(5754),
    [sym_powerset] = ACTIONS(5754),
    [sym_domain] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [sym_negative_dot] = ACTIONS(5752),
    [sym_enabled] = ACTIONS(5754),
    [sym_unchanged] = ACTIONS(5754),
    [anon_sym_LT_GT] = ACTIONS(5752),
    [anon_sym_u22c4] = ACTIONS(5752),
    [anon_sym_u25c7] = ACTIONS(5752),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5754),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [anon_sym_ASSUME] = ACTIONS(5754),
    [anon_sym_ASSUMPTION] = ACTIONS(5754),
    [anon_sym_AXIOM] = ACTIONS(5754),
    [anon_sym_THEOREM] = ACTIONS(5754),
    [anon_sym_PROPOSITION] = ACTIONS(5754),
    [anon_sym_LEMMA] = ACTIONS(5754),
    [anon_sym_COROLLARY] = ACTIONS(5754),
    [anon_sym_PROOF] = ACTIONS(5754),
    [anon_sym_BY] = ACTIONS(5754),
    [anon_sym_OBVIOUS] = ACTIONS(5754),
    [anon_sym_OMITTED] = ACTIONS(5754),
    [anon_sym_USE] = ACTIONS(5754),
    [anon_sym_HIDE] = ACTIONS(5754),
    [sym__begin_proof] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [2312] = {
    [sym_block_comment] = STATE(2312),
    [ts_builtin_sym_end] = ACTIONS(5904),
    [sym_identifier] = ACTIONS(5906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5904),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_LOCAL] = ACTIONS(5906),
    [anon_sym_VARIABLE] = ACTIONS(5906),
    [anon_sym_VARIABLES] = ACTIONS(5906),
    [anon_sym_CONSTANT] = ACTIONS(5906),
    [anon_sym_CONSTANTS] = ACTIONS(5906),
    [anon_sym_RECURSIVE] = ACTIONS(5906),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_INSTANCE] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_Nat] = ACTIONS(5906),
    [anon_sym_u2115] = ACTIONS(5904),
    [anon_sym_Int] = ACTIONS(5906),
    [anon_sym_u2124] = ACTIONS(5904),
    [anon_sym_Real] = ACTIONS(5906),
    [anon_sym_u211d] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_BSLASHlnot] = ACTIONS(5904),
    [anon_sym_BSLASHneg] = ACTIONS(5904),
    [anon_sym_TILDE] = ACTIONS(5906),
    [anon_sym_u00ac] = ACTIONS(5904),
    [sym_union] = ACTIONS(5906),
    [sym_powerset] = ACTIONS(5906),
    [sym_domain] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [sym_negative_dot] = ACTIONS(5904),
    [sym_enabled] = ACTIONS(5906),
    [sym_unchanged] = ACTIONS(5906),
    [anon_sym_LT_GT] = ACTIONS(5904),
    [anon_sym_u22c4] = ACTIONS(5904),
    [anon_sym_u25c7] = ACTIONS(5904),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5906),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [anon_sym_ASSUME] = ACTIONS(5906),
    [anon_sym_ASSUMPTION] = ACTIONS(5906),
    [anon_sym_AXIOM] = ACTIONS(5906),
    [anon_sym_THEOREM] = ACTIONS(5906),
    [anon_sym_PROPOSITION] = ACTIONS(5906),
    [anon_sym_LEMMA] = ACTIONS(5906),
    [anon_sym_COROLLARY] = ACTIONS(5906),
    [anon_sym_PROOF] = ACTIONS(5906),
    [anon_sym_BY] = ACTIONS(5906),
    [anon_sym_OBVIOUS] = ACTIONS(5906),
    [anon_sym_OMITTED] = ACTIONS(5906),
    [anon_sym_USE] = ACTIONS(5906),
    [anon_sym_HIDE] = ACTIONS(5906),
    [sym__begin_proof] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [2313] = {
    [sym_block_comment] = STATE(2313),
    [ts_builtin_sym_end] = ACTIONS(5908),
    [sym_identifier] = ACTIONS(5910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5908),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_LOCAL] = ACTIONS(5910),
    [anon_sym_VARIABLE] = ACTIONS(5910),
    [anon_sym_VARIABLES] = ACTIONS(5910),
    [anon_sym_CONSTANT] = ACTIONS(5910),
    [anon_sym_CONSTANTS] = ACTIONS(5910),
    [anon_sym_RECURSIVE] = ACTIONS(5910),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_INSTANCE] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_Nat] = ACTIONS(5910),
    [anon_sym_u2115] = ACTIONS(5908),
    [anon_sym_Int] = ACTIONS(5910),
    [anon_sym_u2124] = ACTIONS(5908),
    [anon_sym_Real] = ACTIONS(5910),
    [anon_sym_u211d] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_BSLASHlnot] = ACTIONS(5908),
    [anon_sym_BSLASHneg] = ACTIONS(5908),
    [anon_sym_TILDE] = ACTIONS(5910),
    [anon_sym_u00ac] = ACTIONS(5908),
    [sym_union] = ACTIONS(5910),
    [sym_powerset] = ACTIONS(5910),
    [sym_domain] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [sym_negative_dot] = ACTIONS(5908),
    [sym_enabled] = ACTIONS(5910),
    [sym_unchanged] = ACTIONS(5910),
    [anon_sym_LT_GT] = ACTIONS(5908),
    [anon_sym_u22c4] = ACTIONS(5908),
    [anon_sym_u25c7] = ACTIONS(5908),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5910),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [anon_sym_ASSUME] = ACTIONS(5910),
    [anon_sym_ASSUMPTION] = ACTIONS(5910),
    [anon_sym_AXIOM] = ACTIONS(5910),
    [anon_sym_THEOREM] = ACTIONS(5910),
    [anon_sym_PROPOSITION] = ACTIONS(5910),
    [anon_sym_LEMMA] = ACTIONS(5910),
    [anon_sym_COROLLARY] = ACTIONS(5910),
    [anon_sym_PROOF] = ACTIONS(5910),
    [anon_sym_BY] = ACTIONS(5910),
    [anon_sym_OBVIOUS] = ACTIONS(5910),
    [anon_sym_OMITTED] = ACTIONS(5910),
    [anon_sym_USE] = ACTIONS(5910),
    [anon_sym_HIDE] = ACTIONS(5910),
    [sym__begin_proof] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [2314] = {
    [sym_block_comment] = STATE(2314),
    [ts_builtin_sym_end] = ACTIONS(5912),
    [sym_identifier] = ACTIONS(5914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5912),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_LOCAL] = ACTIONS(5914),
    [anon_sym_VARIABLE] = ACTIONS(5914),
    [anon_sym_VARIABLES] = ACTIONS(5914),
    [anon_sym_CONSTANT] = ACTIONS(5914),
    [anon_sym_CONSTANTS] = ACTIONS(5914),
    [anon_sym_RECURSIVE] = ACTIONS(5914),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_INSTANCE] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_Nat] = ACTIONS(5914),
    [anon_sym_u2115] = ACTIONS(5912),
    [anon_sym_Int] = ACTIONS(5914),
    [anon_sym_u2124] = ACTIONS(5912),
    [anon_sym_Real] = ACTIONS(5914),
    [anon_sym_u211d] = ACTIONS(5912),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_BSLASHlnot] = ACTIONS(5912),
    [anon_sym_BSLASHneg] = ACTIONS(5912),
    [anon_sym_TILDE] = ACTIONS(5914),
    [anon_sym_u00ac] = ACTIONS(5912),
    [sym_union] = ACTIONS(5914),
    [sym_powerset] = ACTIONS(5914),
    [sym_domain] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [sym_negative_dot] = ACTIONS(5912),
    [sym_enabled] = ACTIONS(5914),
    [sym_unchanged] = ACTIONS(5914),
    [anon_sym_LT_GT] = ACTIONS(5912),
    [anon_sym_u22c4] = ACTIONS(5912),
    [anon_sym_u25c7] = ACTIONS(5912),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5914),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [anon_sym_ASSUME] = ACTIONS(5914),
    [anon_sym_ASSUMPTION] = ACTIONS(5914),
    [anon_sym_AXIOM] = ACTIONS(5914),
    [anon_sym_THEOREM] = ACTIONS(5914),
    [anon_sym_PROPOSITION] = ACTIONS(5914),
    [anon_sym_LEMMA] = ACTIONS(5914),
    [anon_sym_COROLLARY] = ACTIONS(5914),
    [anon_sym_PROOF] = ACTIONS(5914),
    [anon_sym_BY] = ACTIONS(5914),
    [anon_sym_OBVIOUS] = ACTIONS(5914),
    [anon_sym_OMITTED] = ACTIONS(5914),
    [anon_sym_USE] = ACTIONS(5914),
    [anon_sym_HIDE] = ACTIONS(5914),
    [sym__begin_proof] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [2315] = {
    [sym_block_comment] = STATE(2315),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5663),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_LOCAL] = ACTIONS(5665),
    [anon_sym_VARIABLE] = ACTIONS(5665),
    [anon_sym_VARIABLES] = ACTIONS(5665),
    [anon_sym_CONSTANT] = ACTIONS(5665),
    [anon_sym_CONSTANTS] = ACTIONS(5665),
    [anon_sym_RECURSIVE] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_INSTANCE] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5665),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_ASSUME] = ACTIONS(5665),
    [anon_sym_ASSUMPTION] = ACTIONS(5665),
    [anon_sym_AXIOM] = ACTIONS(5665),
    [anon_sym_THEOREM] = ACTIONS(5665),
    [anon_sym_PROPOSITION] = ACTIONS(5665),
    [anon_sym_LEMMA] = ACTIONS(5665),
    [anon_sym_COROLLARY] = ACTIONS(5665),
    [anon_sym_PROOF] = ACTIONS(5665),
    [anon_sym_BY] = ACTIONS(5665),
    [anon_sym_OBVIOUS] = ACTIONS(5665),
    [anon_sym_OMITTED] = ACTIONS(5665),
    [anon_sym_USE] = ACTIONS(5665),
    [anon_sym_HIDE] = ACTIONS(5665),
    [sym__begin_proof] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2316] = {
    [sym_block_comment] = STATE(2316),
    [sym_identifier] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5786),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_LOCAL] = ACTIONS(5788),
    [anon_sym_VARIABLE] = ACTIONS(5788),
    [anon_sym_VARIABLES] = ACTIONS(5788),
    [anon_sym_CONSTANT] = ACTIONS(5788),
    [anon_sym_CONSTANTS] = ACTIONS(5788),
    [anon_sym_RECURSIVE] = ACTIONS(5788),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_INSTANCE] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_Nat] = ACTIONS(5788),
    [anon_sym_u2115] = ACTIONS(5786),
    [anon_sym_Int] = ACTIONS(5788),
    [anon_sym_u2124] = ACTIONS(5786),
    [anon_sym_Real] = ACTIONS(5788),
    [anon_sym_u211d] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_BSLASHlnot] = ACTIONS(5786),
    [anon_sym_BSLASHneg] = ACTIONS(5786),
    [anon_sym_TILDE] = ACTIONS(5788),
    [anon_sym_u00ac] = ACTIONS(5786),
    [sym_union] = ACTIONS(5788),
    [sym_powerset] = ACTIONS(5788),
    [sym_domain] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [sym_negative_dot] = ACTIONS(5786),
    [sym_enabled] = ACTIONS(5788),
    [sym_unchanged] = ACTIONS(5788),
    [anon_sym_LT_GT] = ACTIONS(5786),
    [anon_sym_u22c4] = ACTIONS(5786),
    [anon_sym_u25c7] = ACTIONS(5786),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5788),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [anon_sym_ASSUME] = ACTIONS(5788),
    [anon_sym_ASSUMPTION] = ACTIONS(5788),
    [anon_sym_AXIOM] = ACTIONS(5788),
    [anon_sym_THEOREM] = ACTIONS(5788),
    [anon_sym_PROPOSITION] = ACTIONS(5788),
    [anon_sym_LEMMA] = ACTIONS(5788),
    [anon_sym_COROLLARY] = ACTIONS(5788),
    [anon_sym_PROOF] = ACTIONS(5788),
    [anon_sym_BY] = ACTIONS(5788),
    [anon_sym_OBVIOUS] = ACTIONS(5788),
    [anon_sym_OMITTED] = ACTIONS(5788),
    [anon_sym_USE] = ACTIONS(5788),
    [anon_sym_HIDE] = ACTIONS(5788),
    [sym__begin_proof] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [2317] = {
    [sym_block_comment] = STATE(2317),
    [ts_builtin_sym_end] = ACTIONS(5916),
    [sym_identifier] = ACTIONS(5918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5916),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_LOCAL] = ACTIONS(5918),
    [anon_sym_VARIABLE] = ACTIONS(5918),
    [anon_sym_VARIABLES] = ACTIONS(5918),
    [anon_sym_CONSTANT] = ACTIONS(5918),
    [anon_sym_CONSTANTS] = ACTIONS(5918),
    [anon_sym_RECURSIVE] = ACTIONS(5918),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_INSTANCE] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_Nat] = ACTIONS(5918),
    [anon_sym_u2115] = ACTIONS(5916),
    [anon_sym_Int] = ACTIONS(5918),
    [anon_sym_u2124] = ACTIONS(5916),
    [anon_sym_Real] = ACTIONS(5918),
    [anon_sym_u211d] = ACTIONS(5916),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_BSLASHlnot] = ACTIONS(5916),
    [anon_sym_BSLASHneg] = ACTIONS(5916),
    [anon_sym_TILDE] = ACTIONS(5918),
    [anon_sym_u00ac] = ACTIONS(5916),
    [sym_union] = ACTIONS(5918),
    [sym_powerset] = ACTIONS(5918),
    [sym_domain] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [sym_negative_dot] = ACTIONS(5916),
    [sym_enabled] = ACTIONS(5918),
    [sym_unchanged] = ACTIONS(5918),
    [anon_sym_LT_GT] = ACTIONS(5916),
    [anon_sym_u22c4] = ACTIONS(5916),
    [anon_sym_u25c7] = ACTIONS(5916),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5918),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [anon_sym_ASSUME] = ACTIONS(5918),
    [anon_sym_ASSUMPTION] = ACTIONS(5918),
    [anon_sym_AXIOM] = ACTIONS(5918),
    [anon_sym_THEOREM] = ACTIONS(5918),
    [anon_sym_PROPOSITION] = ACTIONS(5918),
    [anon_sym_LEMMA] = ACTIONS(5918),
    [anon_sym_COROLLARY] = ACTIONS(5918),
    [anon_sym_PROOF] = ACTIONS(5918),
    [anon_sym_BY] = ACTIONS(5918),
    [anon_sym_OBVIOUS] = ACTIONS(5918),
    [anon_sym_OMITTED] = ACTIONS(5918),
    [anon_sym_USE] = ACTIONS(5918),
    [anon_sym_HIDE] = ACTIONS(5918),
    [sym__begin_proof] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [2318] = {
    [sym_block_comment] = STATE(2318),
    [sym_identifier] = ACTIONS(5804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5802),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_LOCAL] = ACTIONS(5804),
    [anon_sym_VARIABLE] = ACTIONS(5804),
    [anon_sym_VARIABLES] = ACTIONS(5804),
    [anon_sym_CONSTANT] = ACTIONS(5804),
    [anon_sym_CONSTANTS] = ACTIONS(5804),
    [anon_sym_RECURSIVE] = ACTIONS(5804),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_INSTANCE] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_Nat] = ACTIONS(5804),
    [anon_sym_u2115] = ACTIONS(5802),
    [anon_sym_Int] = ACTIONS(5804),
    [anon_sym_u2124] = ACTIONS(5802),
    [anon_sym_Real] = ACTIONS(5804),
    [anon_sym_u211d] = ACTIONS(5802),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_BSLASHlnot] = ACTIONS(5802),
    [anon_sym_BSLASHneg] = ACTIONS(5802),
    [anon_sym_TILDE] = ACTIONS(5804),
    [anon_sym_u00ac] = ACTIONS(5802),
    [sym_union] = ACTIONS(5804),
    [sym_powerset] = ACTIONS(5804),
    [sym_domain] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [sym_negative_dot] = ACTIONS(5802),
    [sym_enabled] = ACTIONS(5804),
    [sym_unchanged] = ACTIONS(5804),
    [anon_sym_LT_GT] = ACTIONS(5802),
    [anon_sym_u22c4] = ACTIONS(5802),
    [anon_sym_u25c7] = ACTIONS(5802),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5804),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [anon_sym_ASSUME] = ACTIONS(5804),
    [anon_sym_ASSUMPTION] = ACTIONS(5804),
    [anon_sym_AXIOM] = ACTIONS(5804),
    [anon_sym_THEOREM] = ACTIONS(5804),
    [anon_sym_PROPOSITION] = ACTIONS(5804),
    [anon_sym_LEMMA] = ACTIONS(5804),
    [anon_sym_COROLLARY] = ACTIONS(5804),
    [anon_sym_PROOF] = ACTIONS(5804),
    [anon_sym_BY] = ACTIONS(5804),
    [anon_sym_OBVIOUS] = ACTIONS(5804),
    [anon_sym_OMITTED] = ACTIONS(5804),
    [anon_sym_USE] = ACTIONS(5804),
    [anon_sym_HIDE] = ACTIONS(5804),
    [sym__begin_proof] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [2319] = {
    [sym_block_comment] = STATE(2319),
    [sym_identifier] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5838),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_LOCAL] = ACTIONS(5840),
    [anon_sym_VARIABLE] = ACTIONS(5840),
    [anon_sym_VARIABLES] = ACTIONS(5840),
    [anon_sym_CONSTANT] = ACTIONS(5840),
    [anon_sym_CONSTANTS] = ACTIONS(5840),
    [anon_sym_RECURSIVE] = ACTIONS(5840),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_INSTANCE] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_Nat] = ACTIONS(5840),
    [anon_sym_u2115] = ACTIONS(5838),
    [anon_sym_Int] = ACTIONS(5840),
    [anon_sym_u2124] = ACTIONS(5838),
    [anon_sym_Real] = ACTIONS(5840),
    [anon_sym_u211d] = ACTIONS(5838),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_BSLASHlnot] = ACTIONS(5838),
    [anon_sym_BSLASHneg] = ACTIONS(5838),
    [anon_sym_TILDE] = ACTIONS(5840),
    [anon_sym_u00ac] = ACTIONS(5838),
    [sym_union] = ACTIONS(5840),
    [sym_powerset] = ACTIONS(5840),
    [sym_domain] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [sym_negative_dot] = ACTIONS(5838),
    [sym_enabled] = ACTIONS(5840),
    [sym_unchanged] = ACTIONS(5840),
    [anon_sym_LT_GT] = ACTIONS(5838),
    [anon_sym_u22c4] = ACTIONS(5838),
    [anon_sym_u25c7] = ACTIONS(5838),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5840),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [anon_sym_ASSUME] = ACTIONS(5840),
    [anon_sym_ASSUMPTION] = ACTIONS(5840),
    [anon_sym_AXIOM] = ACTIONS(5840),
    [anon_sym_THEOREM] = ACTIONS(5840),
    [anon_sym_PROPOSITION] = ACTIONS(5840),
    [anon_sym_LEMMA] = ACTIONS(5840),
    [anon_sym_COROLLARY] = ACTIONS(5840),
    [anon_sym_PROOF] = ACTIONS(5840),
    [anon_sym_BY] = ACTIONS(5840),
    [anon_sym_OBVIOUS] = ACTIONS(5840),
    [anon_sym_OMITTED] = ACTIONS(5840),
    [anon_sym_USE] = ACTIONS(5840),
    [anon_sym_HIDE] = ACTIONS(5840),
    [sym__begin_proof] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [2320] = {
    [sym_block_comment] = STATE(2320),
    [sym_identifier] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5842),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_LOCAL] = ACTIONS(5844),
    [anon_sym_VARIABLE] = ACTIONS(5844),
    [anon_sym_VARIABLES] = ACTIONS(5844),
    [anon_sym_CONSTANT] = ACTIONS(5844),
    [anon_sym_CONSTANTS] = ACTIONS(5844),
    [anon_sym_RECURSIVE] = ACTIONS(5844),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_INSTANCE] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_Nat] = ACTIONS(5844),
    [anon_sym_u2115] = ACTIONS(5842),
    [anon_sym_Int] = ACTIONS(5844),
    [anon_sym_u2124] = ACTIONS(5842),
    [anon_sym_Real] = ACTIONS(5844),
    [anon_sym_u211d] = ACTIONS(5842),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_BSLASHlnot] = ACTIONS(5842),
    [anon_sym_BSLASHneg] = ACTIONS(5842),
    [anon_sym_TILDE] = ACTIONS(5844),
    [anon_sym_u00ac] = ACTIONS(5842),
    [sym_union] = ACTIONS(5844),
    [sym_powerset] = ACTIONS(5844),
    [sym_domain] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [sym_negative_dot] = ACTIONS(5842),
    [sym_enabled] = ACTIONS(5844),
    [sym_unchanged] = ACTIONS(5844),
    [anon_sym_LT_GT] = ACTIONS(5842),
    [anon_sym_u22c4] = ACTIONS(5842),
    [anon_sym_u25c7] = ACTIONS(5842),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5844),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [anon_sym_ASSUME] = ACTIONS(5844),
    [anon_sym_ASSUMPTION] = ACTIONS(5844),
    [anon_sym_AXIOM] = ACTIONS(5844),
    [anon_sym_THEOREM] = ACTIONS(5844),
    [anon_sym_PROPOSITION] = ACTIONS(5844),
    [anon_sym_LEMMA] = ACTIONS(5844),
    [anon_sym_COROLLARY] = ACTIONS(5844),
    [anon_sym_PROOF] = ACTIONS(5844),
    [anon_sym_BY] = ACTIONS(5844),
    [anon_sym_OBVIOUS] = ACTIONS(5844),
    [anon_sym_OMITTED] = ACTIONS(5844),
    [anon_sym_USE] = ACTIONS(5844),
    [anon_sym_HIDE] = ACTIONS(5844),
    [sym__begin_proof] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [2321] = {
    [sym_block_comment] = STATE(2321),
    [sym_identifier] = ACTIONS(5864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5862),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_LOCAL] = ACTIONS(5864),
    [anon_sym_VARIABLE] = ACTIONS(5864),
    [anon_sym_VARIABLES] = ACTIONS(5864),
    [anon_sym_CONSTANT] = ACTIONS(5864),
    [anon_sym_CONSTANTS] = ACTIONS(5864),
    [anon_sym_RECURSIVE] = ACTIONS(5864),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_INSTANCE] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_Nat] = ACTIONS(5864),
    [anon_sym_u2115] = ACTIONS(5862),
    [anon_sym_Int] = ACTIONS(5864),
    [anon_sym_u2124] = ACTIONS(5862),
    [anon_sym_Real] = ACTIONS(5864),
    [anon_sym_u211d] = ACTIONS(5862),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_BSLASHlnot] = ACTIONS(5862),
    [anon_sym_BSLASHneg] = ACTIONS(5862),
    [anon_sym_TILDE] = ACTIONS(5864),
    [anon_sym_u00ac] = ACTIONS(5862),
    [sym_union] = ACTIONS(5864),
    [sym_powerset] = ACTIONS(5864),
    [sym_domain] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [sym_negative_dot] = ACTIONS(5862),
    [sym_enabled] = ACTIONS(5864),
    [sym_unchanged] = ACTIONS(5864),
    [anon_sym_LT_GT] = ACTIONS(5862),
    [anon_sym_u22c4] = ACTIONS(5862),
    [anon_sym_u25c7] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5864),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [anon_sym_ASSUME] = ACTIONS(5864),
    [anon_sym_ASSUMPTION] = ACTIONS(5864),
    [anon_sym_AXIOM] = ACTIONS(5864),
    [anon_sym_THEOREM] = ACTIONS(5864),
    [anon_sym_PROPOSITION] = ACTIONS(5864),
    [anon_sym_LEMMA] = ACTIONS(5864),
    [anon_sym_COROLLARY] = ACTIONS(5864),
    [anon_sym_PROOF] = ACTIONS(5864),
    [anon_sym_BY] = ACTIONS(5864),
    [anon_sym_OBVIOUS] = ACTIONS(5864),
    [anon_sym_OMITTED] = ACTIONS(5864),
    [anon_sym_USE] = ACTIONS(5864),
    [anon_sym_HIDE] = ACTIONS(5864),
    [sym__begin_proof] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [2322] = {
    [sym_block_comment] = STATE(2322),
    [sym_identifier] = ACTIONS(5894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5892),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_LOCAL] = ACTIONS(5894),
    [anon_sym_VARIABLE] = ACTIONS(5894),
    [anon_sym_VARIABLES] = ACTIONS(5894),
    [anon_sym_CONSTANT] = ACTIONS(5894),
    [anon_sym_CONSTANTS] = ACTIONS(5894),
    [anon_sym_RECURSIVE] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_INSTANCE] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_Nat] = ACTIONS(5894),
    [anon_sym_u2115] = ACTIONS(5892),
    [anon_sym_Int] = ACTIONS(5894),
    [anon_sym_u2124] = ACTIONS(5892),
    [anon_sym_Real] = ACTIONS(5894),
    [anon_sym_u211d] = ACTIONS(5892),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_BSLASHlnot] = ACTIONS(5892),
    [anon_sym_BSLASHneg] = ACTIONS(5892),
    [anon_sym_TILDE] = ACTIONS(5894),
    [anon_sym_u00ac] = ACTIONS(5892),
    [sym_union] = ACTIONS(5894),
    [sym_powerset] = ACTIONS(5894),
    [sym_domain] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [sym_negative_dot] = ACTIONS(5892),
    [sym_enabled] = ACTIONS(5894),
    [sym_unchanged] = ACTIONS(5894),
    [anon_sym_LT_GT] = ACTIONS(5892),
    [anon_sym_u22c4] = ACTIONS(5892),
    [anon_sym_u25c7] = ACTIONS(5892),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5894),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [anon_sym_ASSUME] = ACTIONS(5894),
    [anon_sym_ASSUMPTION] = ACTIONS(5894),
    [anon_sym_AXIOM] = ACTIONS(5894),
    [anon_sym_THEOREM] = ACTIONS(5894),
    [anon_sym_PROPOSITION] = ACTIONS(5894),
    [anon_sym_LEMMA] = ACTIONS(5894),
    [anon_sym_COROLLARY] = ACTIONS(5894),
    [anon_sym_PROOF] = ACTIONS(5894),
    [anon_sym_BY] = ACTIONS(5894),
    [anon_sym_OBVIOUS] = ACTIONS(5894),
    [anon_sym_OMITTED] = ACTIONS(5894),
    [anon_sym_USE] = ACTIONS(5894),
    [anon_sym_HIDE] = ACTIONS(5894),
    [sym__begin_proof] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [2323] = {
    [sym_block_comment] = STATE(2323),
    [sym_identifier] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5896),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_LOCAL] = ACTIONS(5898),
    [anon_sym_VARIABLE] = ACTIONS(5898),
    [anon_sym_VARIABLES] = ACTIONS(5898),
    [anon_sym_CONSTANT] = ACTIONS(5898),
    [anon_sym_CONSTANTS] = ACTIONS(5898),
    [anon_sym_RECURSIVE] = ACTIONS(5898),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_INSTANCE] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_Nat] = ACTIONS(5898),
    [anon_sym_u2115] = ACTIONS(5896),
    [anon_sym_Int] = ACTIONS(5898),
    [anon_sym_u2124] = ACTIONS(5896),
    [anon_sym_Real] = ACTIONS(5898),
    [anon_sym_u211d] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_BSLASHlnot] = ACTIONS(5896),
    [anon_sym_BSLASHneg] = ACTIONS(5896),
    [anon_sym_TILDE] = ACTIONS(5898),
    [anon_sym_u00ac] = ACTIONS(5896),
    [sym_union] = ACTIONS(5898),
    [sym_powerset] = ACTIONS(5898),
    [sym_domain] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [sym_negative_dot] = ACTIONS(5896),
    [sym_enabled] = ACTIONS(5898),
    [sym_unchanged] = ACTIONS(5898),
    [anon_sym_LT_GT] = ACTIONS(5896),
    [anon_sym_u22c4] = ACTIONS(5896),
    [anon_sym_u25c7] = ACTIONS(5896),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5898),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [anon_sym_ASSUME] = ACTIONS(5898),
    [anon_sym_ASSUMPTION] = ACTIONS(5898),
    [anon_sym_AXIOM] = ACTIONS(5898),
    [anon_sym_THEOREM] = ACTIONS(5898),
    [anon_sym_PROPOSITION] = ACTIONS(5898),
    [anon_sym_LEMMA] = ACTIONS(5898),
    [anon_sym_COROLLARY] = ACTIONS(5898),
    [anon_sym_PROOF] = ACTIONS(5898),
    [anon_sym_BY] = ACTIONS(5898),
    [anon_sym_OBVIOUS] = ACTIONS(5898),
    [anon_sym_OMITTED] = ACTIONS(5898),
    [anon_sym_USE] = ACTIONS(5898),
    [anon_sym_HIDE] = ACTIONS(5898),
    [sym__begin_proof] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [2324] = {
    [sym_block_comment] = STATE(2324),
    [sym_identifier] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5900),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_LOCAL] = ACTIONS(5902),
    [anon_sym_VARIABLE] = ACTIONS(5902),
    [anon_sym_VARIABLES] = ACTIONS(5902),
    [anon_sym_CONSTANT] = ACTIONS(5902),
    [anon_sym_CONSTANTS] = ACTIONS(5902),
    [anon_sym_RECURSIVE] = ACTIONS(5902),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_INSTANCE] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_Nat] = ACTIONS(5902),
    [anon_sym_u2115] = ACTIONS(5900),
    [anon_sym_Int] = ACTIONS(5902),
    [anon_sym_u2124] = ACTIONS(5900),
    [anon_sym_Real] = ACTIONS(5902),
    [anon_sym_u211d] = ACTIONS(5900),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_BSLASHlnot] = ACTIONS(5900),
    [anon_sym_BSLASHneg] = ACTIONS(5900),
    [anon_sym_TILDE] = ACTIONS(5902),
    [anon_sym_u00ac] = ACTIONS(5900),
    [sym_union] = ACTIONS(5902),
    [sym_powerset] = ACTIONS(5902),
    [sym_domain] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [sym_negative_dot] = ACTIONS(5900),
    [sym_enabled] = ACTIONS(5902),
    [sym_unchanged] = ACTIONS(5902),
    [anon_sym_LT_GT] = ACTIONS(5900),
    [anon_sym_u22c4] = ACTIONS(5900),
    [anon_sym_u25c7] = ACTIONS(5900),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5902),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [anon_sym_ASSUME] = ACTIONS(5902),
    [anon_sym_ASSUMPTION] = ACTIONS(5902),
    [anon_sym_AXIOM] = ACTIONS(5902),
    [anon_sym_THEOREM] = ACTIONS(5902),
    [anon_sym_PROPOSITION] = ACTIONS(5902),
    [anon_sym_LEMMA] = ACTIONS(5902),
    [anon_sym_COROLLARY] = ACTIONS(5902),
    [anon_sym_PROOF] = ACTIONS(5902),
    [anon_sym_BY] = ACTIONS(5902),
    [anon_sym_OBVIOUS] = ACTIONS(5902),
    [anon_sym_OMITTED] = ACTIONS(5902),
    [anon_sym_USE] = ACTIONS(5902),
    [anon_sym_HIDE] = ACTIONS(5902),
    [sym__begin_proof] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [2325] = {
    [sym_block_comment] = STATE(2325),
    [sym_identifier] = ACTIONS(5906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5904),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_LOCAL] = ACTIONS(5906),
    [anon_sym_VARIABLE] = ACTIONS(5906),
    [anon_sym_VARIABLES] = ACTIONS(5906),
    [anon_sym_CONSTANT] = ACTIONS(5906),
    [anon_sym_CONSTANTS] = ACTIONS(5906),
    [anon_sym_RECURSIVE] = ACTIONS(5906),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_INSTANCE] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_Nat] = ACTIONS(5906),
    [anon_sym_u2115] = ACTIONS(5904),
    [anon_sym_Int] = ACTIONS(5906),
    [anon_sym_u2124] = ACTIONS(5904),
    [anon_sym_Real] = ACTIONS(5906),
    [anon_sym_u211d] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_BSLASHlnot] = ACTIONS(5904),
    [anon_sym_BSLASHneg] = ACTIONS(5904),
    [anon_sym_TILDE] = ACTIONS(5906),
    [anon_sym_u00ac] = ACTIONS(5904),
    [sym_union] = ACTIONS(5906),
    [sym_powerset] = ACTIONS(5906),
    [sym_domain] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [sym_negative_dot] = ACTIONS(5904),
    [sym_enabled] = ACTIONS(5906),
    [sym_unchanged] = ACTIONS(5906),
    [anon_sym_LT_GT] = ACTIONS(5904),
    [anon_sym_u22c4] = ACTIONS(5904),
    [anon_sym_u25c7] = ACTIONS(5904),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5906),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [anon_sym_ASSUME] = ACTIONS(5906),
    [anon_sym_ASSUMPTION] = ACTIONS(5906),
    [anon_sym_AXIOM] = ACTIONS(5906),
    [anon_sym_THEOREM] = ACTIONS(5906),
    [anon_sym_PROPOSITION] = ACTIONS(5906),
    [anon_sym_LEMMA] = ACTIONS(5906),
    [anon_sym_COROLLARY] = ACTIONS(5906),
    [anon_sym_PROOF] = ACTIONS(5906),
    [anon_sym_BY] = ACTIONS(5906),
    [anon_sym_OBVIOUS] = ACTIONS(5906),
    [anon_sym_OMITTED] = ACTIONS(5906),
    [anon_sym_USE] = ACTIONS(5906),
    [anon_sym_HIDE] = ACTIONS(5906),
    [sym__begin_proof] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [2326] = {
    [sym_block_comment] = STATE(2326),
    [sym_identifier] = ACTIONS(5774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5772),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_LOCAL] = ACTIONS(5774),
    [anon_sym_VARIABLE] = ACTIONS(5774),
    [anon_sym_VARIABLES] = ACTIONS(5774),
    [anon_sym_CONSTANT] = ACTIONS(5774),
    [anon_sym_CONSTANTS] = ACTIONS(5774),
    [anon_sym_RECURSIVE] = ACTIONS(5774),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_INSTANCE] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_Nat] = ACTIONS(5774),
    [anon_sym_u2115] = ACTIONS(5772),
    [anon_sym_Int] = ACTIONS(5774),
    [anon_sym_u2124] = ACTIONS(5772),
    [anon_sym_Real] = ACTIONS(5774),
    [anon_sym_u211d] = ACTIONS(5772),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_BSLASHlnot] = ACTIONS(5772),
    [anon_sym_BSLASHneg] = ACTIONS(5772),
    [anon_sym_TILDE] = ACTIONS(5774),
    [anon_sym_u00ac] = ACTIONS(5772),
    [sym_union] = ACTIONS(5774),
    [sym_powerset] = ACTIONS(5774),
    [sym_domain] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [sym_negative_dot] = ACTIONS(5772),
    [sym_enabled] = ACTIONS(5774),
    [sym_unchanged] = ACTIONS(5774),
    [anon_sym_LT_GT] = ACTIONS(5772),
    [anon_sym_u22c4] = ACTIONS(5772),
    [anon_sym_u25c7] = ACTIONS(5772),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5774),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [anon_sym_ASSUME] = ACTIONS(5774),
    [anon_sym_ASSUMPTION] = ACTIONS(5774),
    [anon_sym_AXIOM] = ACTIONS(5774),
    [anon_sym_THEOREM] = ACTIONS(5774),
    [anon_sym_PROPOSITION] = ACTIONS(5774),
    [anon_sym_LEMMA] = ACTIONS(5774),
    [anon_sym_COROLLARY] = ACTIONS(5774),
    [anon_sym_PROOF] = ACTIONS(5774),
    [anon_sym_BY] = ACTIONS(5774),
    [anon_sym_OBVIOUS] = ACTIONS(5774),
    [anon_sym_OMITTED] = ACTIONS(5774),
    [anon_sym_USE] = ACTIONS(5774),
    [anon_sym_HIDE] = ACTIONS(5774),
    [sym__begin_proof] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [2327] = {
    [sym_block_comment] = STATE(2327),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5704),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_LOCAL] = ACTIONS(5706),
    [anon_sym_VARIABLE] = ACTIONS(5706),
    [anon_sym_VARIABLES] = ACTIONS(5706),
    [anon_sym_CONSTANT] = ACTIONS(5706),
    [anon_sym_CONSTANTS] = ACTIONS(5706),
    [anon_sym_RECURSIVE] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_INSTANCE] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5706),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_ASSUME] = ACTIONS(5706),
    [anon_sym_ASSUMPTION] = ACTIONS(5706),
    [anon_sym_AXIOM] = ACTIONS(5706),
    [anon_sym_THEOREM] = ACTIONS(5706),
    [anon_sym_PROPOSITION] = ACTIONS(5706),
    [anon_sym_LEMMA] = ACTIONS(5706),
    [anon_sym_COROLLARY] = ACTIONS(5706),
    [anon_sym_PROOF] = ACTIONS(5706),
    [anon_sym_BY] = ACTIONS(5706),
    [anon_sym_OBVIOUS] = ACTIONS(5706),
    [anon_sym_OMITTED] = ACTIONS(5706),
    [anon_sym_USE] = ACTIONS(5706),
    [anon_sym_HIDE] = ACTIONS(5706),
    [sym__begin_proof] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2328] = {
    [sym_block_comment] = STATE(2328),
    [ts_builtin_sym_end] = ACTIONS(5920),
    [sym_identifier] = ACTIONS(5922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5920),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_LOCAL] = ACTIONS(5922),
    [anon_sym_VARIABLE] = ACTIONS(5922),
    [anon_sym_VARIABLES] = ACTIONS(5922),
    [anon_sym_CONSTANT] = ACTIONS(5922),
    [anon_sym_CONSTANTS] = ACTIONS(5922),
    [anon_sym_RECURSIVE] = ACTIONS(5922),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_INSTANCE] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_Nat] = ACTIONS(5922),
    [anon_sym_u2115] = ACTIONS(5920),
    [anon_sym_Int] = ACTIONS(5922),
    [anon_sym_u2124] = ACTIONS(5920),
    [anon_sym_Real] = ACTIONS(5922),
    [anon_sym_u211d] = ACTIONS(5920),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_BSLASHlnot] = ACTIONS(5920),
    [anon_sym_BSLASHneg] = ACTIONS(5920),
    [anon_sym_TILDE] = ACTIONS(5922),
    [anon_sym_u00ac] = ACTIONS(5920),
    [sym_union] = ACTIONS(5922),
    [sym_powerset] = ACTIONS(5922),
    [sym_domain] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [sym_negative_dot] = ACTIONS(5920),
    [sym_enabled] = ACTIONS(5922),
    [sym_unchanged] = ACTIONS(5922),
    [anon_sym_LT_GT] = ACTIONS(5920),
    [anon_sym_u22c4] = ACTIONS(5920),
    [anon_sym_u25c7] = ACTIONS(5920),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5922),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [anon_sym_ASSUME] = ACTIONS(5922),
    [anon_sym_ASSUMPTION] = ACTIONS(5922),
    [anon_sym_AXIOM] = ACTIONS(5922),
    [anon_sym_THEOREM] = ACTIONS(5922),
    [anon_sym_PROPOSITION] = ACTIONS(5922),
    [anon_sym_LEMMA] = ACTIONS(5922),
    [anon_sym_COROLLARY] = ACTIONS(5922),
    [anon_sym_PROOF] = ACTIONS(5922),
    [anon_sym_BY] = ACTIONS(5922),
    [anon_sym_OBVIOUS] = ACTIONS(5922),
    [anon_sym_OMITTED] = ACTIONS(5922),
    [anon_sym_USE] = ACTIONS(5922),
    [anon_sym_HIDE] = ACTIONS(5922),
    [sym__begin_proof] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [2329] = {
    [sym_block_comment] = STATE(2329),
    [sym_identifier] = ACTIONS(5910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5908),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_LOCAL] = ACTIONS(5910),
    [anon_sym_VARIABLE] = ACTIONS(5910),
    [anon_sym_VARIABLES] = ACTIONS(5910),
    [anon_sym_CONSTANT] = ACTIONS(5910),
    [anon_sym_CONSTANTS] = ACTIONS(5910),
    [anon_sym_RECURSIVE] = ACTIONS(5910),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_INSTANCE] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_Nat] = ACTIONS(5910),
    [anon_sym_u2115] = ACTIONS(5908),
    [anon_sym_Int] = ACTIONS(5910),
    [anon_sym_u2124] = ACTIONS(5908),
    [anon_sym_Real] = ACTIONS(5910),
    [anon_sym_u211d] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_BSLASHlnot] = ACTIONS(5908),
    [anon_sym_BSLASHneg] = ACTIONS(5908),
    [anon_sym_TILDE] = ACTIONS(5910),
    [anon_sym_u00ac] = ACTIONS(5908),
    [sym_union] = ACTIONS(5910),
    [sym_powerset] = ACTIONS(5910),
    [sym_domain] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [sym_negative_dot] = ACTIONS(5908),
    [sym_enabled] = ACTIONS(5910),
    [sym_unchanged] = ACTIONS(5910),
    [anon_sym_LT_GT] = ACTIONS(5908),
    [anon_sym_u22c4] = ACTIONS(5908),
    [anon_sym_u25c7] = ACTIONS(5908),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5910),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [anon_sym_ASSUME] = ACTIONS(5910),
    [anon_sym_ASSUMPTION] = ACTIONS(5910),
    [anon_sym_AXIOM] = ACTIONS(5910),
    [anon_sym_THEOREM] = ACTIONS(5910),
    [anon_sym_PROPOSITION] = ACTIONS(5910),
    [anon_sym_LEMMA] = ACTIONS(5910),
    [anon_sym_COROLLARY] = ACTIONS(5910),
    [anon_sym_PROOF] = ACTIONS(5910),
    [anon_sym_BY] = ACTIONS(5910),
    [anon_sym_OBVIOUS] = ACTIONS(5910),
    [anon_sym_OMITTED] = ACTIONS(5910),
    [anon_sym_USE] = ACTIONS(5910),
    [anon_sym_HIDE] = ACTIONS(5910),
    [sym__begin_proof] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [2330] = {
    [sym_block_comment] = STATE(2330),
    [sym_identifier] = ACTIONS(5914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_LOCAL] = ACTIONS(5914),
    [anon_sym_VARIABLE] = ACTIONS(5914),
    [anon_sym_VARIABLES] = ACTIONS(5914),
    [anon_sym_CONSTANT] = ACTIONS(5914),
    [anon_sym_CONSTANTS] = ACTIONS(5914),
    [anon_sym_RECURSIVE] = ACTIONS(5914),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_INSTANCE] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_Nat] = ACTIONS(5914),
    [anon_sym_u2115] = ACTIONS(5912),
    [anon_sym_Int] = ACTIONS(5914),
    [anon_sym_u2124] = ACTIONS(5912),
    [anon_sym_Real] = ACTIONS(5914),
    [anon_sym_u211d] = ACTIONS(5912),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_BSLASHlnot] = ACTIONS(5912),
    [anon_sym_BSLASHneg] = ACTIONS(5912),
    [anon_sym_TILDE] = ACTIONS(5914),
    [anon_sym_u00ac] = ACTIONS(5912),
    [sym_union] = ACTIONS(5914),
    [sym_powerset] = ACTIONS(5914),
    [sym_domain] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [sym_negative_dot] = ACTIONS(5912),
    [sym_enabled] = ACTIONS(5914),
    [sym_unchanged] = ACTIONS(5914),
    [anon_sym_LT_GT] = ACTIONS(5912),
    [anon_sym_u22c4] = ACTIONS(5912),
    [anon_sym_u25c7] = ACTIONS(5912),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5914),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [anon_sym_ASSUME] = ACTIONS(5914),
    [anon_sym_ASSUMPTION] = ACTIONS(5914),
    [anon_sym_AXIOM] = ACTIONS(5914),
    [anon_sym_THEOREM] = ACTIONS(5914),
    [anon_sym_PROPOSITION] = ACTIONS(5914),
    [anon_sym_LEMMA] = ACTIONS(5914),
    [anon_sym_COROLLARY] = ACTIONS(5914),
    [anon_sym_PROOF] = ACTIONS(5914),
    [anon_sym_BY] = ACTIONS(5914),
    [anon_sym_OBVIOUS] = ACTIONS(5914),
    [anon_sym_OMITTED] = ACTIONS(5914),
    [anon_sym_USE] = ACTIONS(5914),
    [anon_sym_HIDE] = ACTIONS(5914),
    [sym__begin_proof] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [2331] = {
    [sym_block_comment] = STATE(2331),
    [sym_identifier] = ACTIONS(5918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5916),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_LOCAL] = ACTIONS(5918),
    [anon_sym_VARIABLE] = ACTIONS(5918),
    [anon_sym_VARIABLES] = ACTIONS(5918),
    [anon_sym_CONSTANT] = ACTIONS(5918),
    [anon_sym_CONSTANTS] = ACTIONS(5918),
    [anon_sym_RECURSIVE] = ACTIONS(5918),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_INSTANCE] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_Nat] = ACTIONS(5918),
    [anon_sym_u2115] = ACTIONS(5916),
    [anon_sym_Int] = ACTIONS(5918),
    [anon_sym_u2124] = ACTIONS(5916),
    [anon_sym_Real] = ACTIONS(5918),
    [anon_sym_u211d] = ACTIONS(5916),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_BSLASHlnot] = ACTIONS(5916),
    [anon_sym_BSLASHneg] = ACTIONS(5916),
    [anon_sym_TILDE] = ACTIONS(5918),
    [anon_sym_u00ac] = ACTIONS(5916),
    [sym_union] = ACTIONS(5918),
    [sym_powerset] = ACTIONS(5918),
    [sym_domain] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [sym_negative_dot] = ACTIONS(5916),
    [sym_enabled] = ACTIONS(5918),
    [sym_unchanged] = ACTIONS(5918),
    [anon_sym_LT_GT] = ACTIONS(5916),
    [anon_sym_u22c4] = ACTIONS(5916),
    [anon_sym_u25c7] = ACTIONS(5916),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5918),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [anon_sym_ASSUME] = ACTIONS(5918),
    [anon_sym_ASSUMPTION] = ACTIONS(5918),
    [anon_sym_AXIOM] = ACTIONS(5918),
    [anon_sym_THEOREM] = ACTIONS(5918),
    [anon_sym_PROPOSITION] = ACTIONS(5918),
    [anon_sym_LEMMA] = ACTIONS(5918),
    [anon_sym_COROLLARY] = ACTIONS(5918),
    [anon_sym_PROOF] = ACTIONS(5918),
    [anon_sym_BY] = ACTIONS(5918),
    [anon_sym_OBVIOUS] = ACTIONS(5918),
    [anon_sym_OMITTED] = ACTIONS(5918),
    [anon_sym_USE] = ACTIONS(5918),
    [anon_sym_HIDE] = ACTIONS(5918),
    [sym__begin_proof] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [2332] = {
    [sym_block_comment] = STATE(2332),
    [sym_identifier] = ACTIONS(5922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5920),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_LOCAL] = ACTIONS(5922),
    [anon_sym_VARIABLE] = ACTIONS(5922),
    [anon_sym_VARIABLES] = ACTIONS(5922),
    [anon_sym_CONSTANT] = ACTIONS(5922),
    [anon_sym_CONSTANTS] = ACTIONS(5922),
    [anon_sym_RECURSIVE] = ACTIONS(5922),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_INSTANCE] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_Nat] = ACTIONS(5922),
    [anon_sym_u2115] = ACTIONS(5920),
    [anon_sym_Int] = ACTIONS(5922),
    [anon_sym_u2124] = ACTIONS(5920),
    [anon_sym_Real] = ACTIONS(5922),
    [anon_sym_u211d] = ACTIONS(5920),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_BSLASHlnot] = ACTIONS(5920),
    [anon_sym_BSLASHneg] = ACTIONS(5920),
    [anon_sym_TILDE] = ACTIONS(5922),
    [anon_sym_u00ac] = ACTIONS(5920),
    [sym_union] = ACTIONS(5922),
    [sym_powerset] = ACTIONS(5922),
    [sym_domain] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [sym_negative_dot] = ACTIONS(5920),
    [sym_enabled] = ACTIONS(5922),
    [sym_unchanged] = ACTIONS(5922),
    [anon_sym_LT_GT] = ACTIONS(5920),
    [anon_sym_u22c4] = ACTIONS(5920),
    [anon_sym_u25c7] = ACTIONS(5920),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5922),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [anon_sym_ASSUME] = ACTIONS(5922),
    [anon_sym_ASSUMPTION] = ACTIONS(5922),
    [anon_sym_AXIOM] = ACTIONS(5922),
    [anon_sym_THEOREM] = ACTIONS(5922),
    [anon_sym_PROPOSITION] = ACTIONS(5922),
    [anon_sym_LEMMA] = ACTIONS(5922),
    [anon_sym_COROLLARY] = ACTIONS(5922),
    [anon_sym_PROOF] = ACTIONS(5922),
    [anon_sym_BY] = ACTIONS(5922),
    [anon_sym_OBVIOUS] = ACTIONS(5922),
    [anon_sym_OMITTED] = ACTIONS(5922),
    [anon_sym_USE] = ACTIONS(5922),
    [anon_sym_HIDE] = ACTIONS(5922),
    [sym__begin_proof] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [2333] = {
    [sym_block_comment] = STATE(2333),
    [sym_identifier] = ACTIONS(5924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5926),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_LOCAL] = ACTIONS(5924),
    [anon_sym_VARIABLE] = ACTIONS(5924),
    [anon_sym_VARIABLES] = ACTIONS(5924),
    [anon_sym_CONSTANT] = ACTIONS(5924),
    [anon_sym_CONSTANTS] = ACTIONS(5924),
    [anon_sym_RECURSIVE] = ACTIONS(5924),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_INSTANCE] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_Nat] = ACTIONS(5924),
    [anon_sym_u2115] = ACTIONS(5926),
    [anon_sym_Int] = ACTIONS(5924),
    [anon_sym_u2124] = ACTIONS(5926),
    [anon_sym_Real] = ACTIONS(5924),
    [anon_sym_u211d] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_BSLASHlnot] = ACTIONS(5926),
    [anon_sym_BSLASHneg] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5924),
    [anon_sym_u00ac] = ACTIONS(5926),
    [sym_union] = ACTIONS(5924),
    [sym_powerset] = ACTIONS(5924),
    [sym_domain] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [sym_negative_dot] = ACTIONS(5926),
    [sym_enabled] = ACTIONS(5924),
    [sym_unchanged] = ACTIONS(5924),
    [anon_sym_LT_GT] = ACTIONS(5926),
    [anon_sym_u22c4] = ACTIONS(5926),
    [anon_sym_u25c7] = ACTIONS(5926),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5924),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [anon_sym_ASSUME] = ACTIONS(5924),
    [anon_sym_ASSUMPTION] = ACTIONS(5924),
    [anon_sym_AXIOM] = ACTIONS(5924),
    [anon_sym_THEOREM] = ACTIONS(5924),
    [anon_sym_PROPOSITION] = ACTIONS(5924),
    [anon_sym_LEMMA] = ACTIONS(5924),
    [anon_sym_COROLLARY] = ACTIONS(5924),
    [anon_sym_PROOF] = ACTIONS(5924),
    [anon_sym_BY] = ACTIONS(5924),
    [anon_sym_OBVIOUS] = ACTIONS(5924),
    [anon_sym_OMITTED] = ACTIONS(5924),
    [anon_sym_USE] = ACTIONS(5924),
    [anon_sym_HIDE] = ACTIONS(5924),
    [sym__begin_proof] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [2334] = {
    [sym_block_comment] = STATE(2334),
    [sym_identifier] = ACTIONS(5928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5930),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_LOCAL] = ACTIONS(5928),
    [anon_sym_VARIABLE] = ACTIONS(5928),
    [anon_sym_VARIABLES] = ACTIONS(5928),
    [anon_sym_CONSTANT] = ACTIONS(5928),
    [anon_sym_CONSTANTS] = ACTIONS(5928),
    [anon_sym_RECURSIVE] = ACTIONS(5928),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_INSTANCE] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_Nat] = ACTIONS(5928),
    [anon_sym_u2115] = ACTIONS(5930),
    [anon_sym_Int] = ACTIONS(5928),
    [anon_sym_u2124] = ACTIONS(5930),
    [anon_sym_Real] = ACTIONS(5928),
    [anon_sym_u211d] = ACTIONS(5930),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_BSLASHlnot] = ACTIONS(5930),
    [anon_sym_BSLASHneg] = ACTIONS(5930),
    [anon_sym_TILDE] = ACTIONS(5928),
    [anon_sym_u00ac] = ACTIONS(5930),
    [sym_union] = ACTIONS(5928),
    [sym_powerset] = ACTIONS(5928),
    [sym_domain] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [sym_negative_dot] = ACTIONS(5930),
    [sym_enabled] = ACTIONS(5928),
    [sym_unchanged] = ACTIONS(5928),
    [anon_sym_LT_GT] = ACTIONS(5930),
    [anon_sym_u22c4] = ACTIONS(5930),
    [anon_sym_u25c7] = ACTIONS(5930),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5928),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [anon_sym_ASSUME] = ACTIONS(5928),
    [anon_sym_ASSUMPTION] = ACTIONS(5928),
    [anon_sym_AXIOM] = ACTIONS(5928),
    [anon_sym_THEOREM] = ACTIONS(5928),
    [anon_sym_PROPOSITION] = ACTIONS(5928),
    [anon_sym_LEMMA] = ACTIONS(5928),
    [anon_sym_COROLLARY] = ACTIONS(5928),
    [anon_sym_PROOF] = ACTIONS(5928),
    [anon_sym_BY] = ACTIONS(5928),
    [anon_sym_OBVIOUS] = ACTIONS(5928),
    [anon_sym_OMITTED] = ACTIONS(5928),
    [anon_sym_USE] = ACTIONS(5928),
    [anon_sym_HIDE] = ACTIONS(5928),
    [sym__begin_proof] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [2335] = {
    [sym_block_comment] = STATE(2335),
    [sym_identifier] = ACTIONS(5932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5934),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_LOCAL] = ACTIONS(5932),
    [anon_sym_VARIABLE] = ACTIONS(5932),
    [anon_sym_VARIABLES] = ACTIONS(5932),
    [anon_sym_CONSTANT] = ACTIONS(5932),
    [anon_sym_CONSTANTS] = ACTIONS(5932),
    [anon_sym_RECURSIVE] = ACTIONS(5932),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_INSTANCE] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_Nat] = ACTIONS(5932),
    [anon_sym_u2115] = ACTIONS(5934),
    [anon_sym_Int] = ACTIONS(5932),
    [anon_sym_u2124] = ACTIONS(5934),
    [anon_sym_Real] = ACTIONS(5932),
    [anon_sym_u211d] = ACTIONS(5934),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_BSLASHlnot] = ACTIONS(5934),
    [anon_sym_BSLASHneg] = ACTIONS(5934),
    [anon_sym_TILDE] = ACTIONS(5932),
    [anon_sym_u00ac] = ACTIONS(5934),
    [sym_union] = ACTIONS(5932),
    [sym_powerset] = ACTIONS(5932),
    [sym_domain] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [sym_negative_dot] = ACTIONS(5934),
    [sym_enabled] = ACTIONS(5932),
    [sym_unchanged] = ACTIONS(5932),
    [anon_sym_LT_GT] = ACTIONS(5934),
    [anon_sym_u22c4] = ACTIONS(5934),
    [anon_sym_u25c7] = ACTIONS(5934),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5932),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [anon_sym_ASSUME] = ACTIONS(5932),
    [anon_sym_ASSUMPTION] = ACTIONS(5932),
    [anon_sym_AXIOM] = ACTIONS(5932),
    [anon_sym_THEOREM] = ACTIONS(5932),
    [anon_sym_PROPOSITION] = ACTIONS(5932),
    [anon_sym_LEMMA] = ACTIONS(5932),
    [anon_sym_COROLLARY] = ACTIONS(5932),
    [anon_sym_PROOF] = ACTIONS(5932),
    [anon_sym_BY] = ACTIONS(5932),
    [anon_sym_OBVIOUS] = ACTIONS(5932),
    [anon_sym_OMITTED] = ACTIONS(5932),
    [anon_sym_USE] = ACTIONS(5932),
    [anon_sym_HIDE] = ACTIONS(5932),
    [sym__begin_proof] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [2336] = {
    [sym_block_comment] = STATE(2336),
    [ts_builtin_sym_end] = ACTIONS(5926),
    [sym_identifier] = ACTIONS(5924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5926),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_LOCAL] = ACTIONS(5924),
    [anon_sym_VARIABLE] = ACTIONS(5924),
    [anon_sym_VARIABLES] = ACTIONS(5924),
    [anon_sym_CONSTANT] = ACTIONS(5924),
    [anon_sym_CONSTANTS] = ACTIONS(5924),
    [anon_sym_RECURSIVE] = ACTIONS(5924),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_INSTANCE] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_Nat] = ACTIONS(5924),
    [anon_sym_u2115] = ACTIONS(5926),
    [anon_sym_Int] = ACTIONS(5924),
    [anon_sym_u2124] = ACTIONS(5926),
    [anon_sym_Real] = ACTIONS(5924),
    [anon_sym_u211d] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_BSLASHlnot] = ACTIONS(5926),
    [anon_sym_BSLASHneg] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5924),
    [anon_sym_u00ac] = ACTIONS(5926),
    [sym_union] = ACTIONS(5924),
    [sym_powerset] = ACTIONS(5924),
    [sym_domain] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [sym_negative_dot] = ACTIONS(5926),
    [sym_enabled] = ACTIONS(5924),
    [sym_unchanged] = ACTIONS(5924),
    [anon_sym_LT_GT] = ACTIONS(5926),
    [anon_sym_u22c4] = ACTIONS(5926),
    [anon_sym_u25c7] = ACTIONS(5926),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5924),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [anon_sym_ASSUME] = ACTIONS(5924),
    [anon_sym_ASSUMPTION] = ACTIONS(5924),
    [anon_sym_AXIOM] = ACTIONS(5924),
    [anon_sym_THEOREM] = ACTIONS(5924),
    [anon_sym_PROPOSITION] = ACTIONS(5924),
    [anon_sym_LEMMA] = ACTIONS(5924),
    [anon_sym_COROLLARY] = ACTIONS(5924),
    [anon_sym_PROOF] = ACTIONS(5924),
    [anon_sym_BY] = ACTIONS(5924),
    [anon_sym_OBVIOUS] = ACTIONS(5924),
    [anon_sym_OMITTED] = ACTIONS(5924),
    [anon_sym_USE] = ACTIONS(5924),
    [anon_sym_HIDE] = ACTIONS(5924),
    [sym__begin_proof] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [2337] = {
    [sym_block_comment] = STATE(2337),
    [ts_builtin_sym_end] = ACTIONS(5930),
    [sym_identifier] = ACTIONS(5928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5930),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_LOCAL] = ACTIONS(5928),
    [anon_sym_VARIABLE] = ACTIONS(5928),
    [anon_sym_VARIABLES] = ACTIONS(5928),
    [anon_sym_CONSTANT] = ACTIONS(5928),
    [anon_sym_CONSTANTS] = ACTIONS(5928),
    [anon_sym_RECURSIVE] = ACTIONS(5928),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_INSTANCE] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_Nat] = ACTIONS(5928),
    [anon_sym_u2115] = ACTIONS(5930),
    [anon_sym_Int] = ACTIONS(5928),
    [anon_sym_u2124] = ACTIONS(5930),
    [anon_sym_Real] = ACTIONS(5928),
    [anon_sym_u211d] = ACTIONS(5930),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_BSLASHlnot] = ACTIONS(5930),
    [anon_sym_BSLASHneg] = ACTIONS(5930),
    [anon_sym_TILDE] = ACTIONS(5928),
    [anon_sym_u00ac] = ACTIONS(5930),
    [sym_union] = ACTIONS(5928),
    [sym_powerset] = ACTIONS(5928),
    [sym_domain] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [sym_negative_dot] = ACTIONS(5930),
    [sym_enabled] = ACTIONS(5928),
    [sym_unchanged] = ACTIONS(5928),
    [anon_sym_LT_GT] = ACTIONS(5930),
    [anon_sym_u22c4] = ACTIONS(5930),
    [anon_sym_u25c7] = ACTIONS(5930),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5928),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [anon_sym_ASSUME] = ACTIONS(5928),
    [anon_sym_ASSUMPTION] = ACTIONS(5928),
    [anon_sym_AXIOM] = ACTIONS(5928),
    [anon_sym_THEOREM] = ACTIONS(5928),
    [anon_sym_PROPOSITION] = ACTIONS(5928),
    [anon_sym_LEMMA] = ACTIONS(5928),
    [anon_sym_COROLLARY] = ACTIONS(5928),
    [anon_sym_PROOF] = ACTIONS(5928),
    [anon_sym_BY] = ACTIONS(5928),
    [anon_sym_OBVIOUS] = ACTIONS(5928),
    [anon_sym_OMITTED] = ACTIONS(5928),
    [anon_sym_USE] = ACTIONS(5928),
    [anon_sym_HIDE] = ACTIONS(5928),
    [sym__begin_proof] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [2338] = {
    [sym_block_comment] = STATE(2338),
    [ts_builtin_sym_end] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(5932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5934),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_LOCAL] = ACTIONS(5932),
    [anon_sym_VARIABLE] = ACTIONS(5932),
    [anon_sym_VARIABLES] = ACTIONS(5932),
    [anon_sym_CONSTANT] = ACTIONS(5932),
    [anon_sym_CONSTANTS] = ACTIONS(5932),
    [anon_sym_RECURSIVE] = ACTIONS(5932),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_INSTANCE] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_Nat] = ACTIONS(5932),
    [anon_sym_u2115] = ACTIONS(5934),
    [anon_sym_Int] = ACTIONS(5932),
    [anon_sym_u2124] = ACTIONS(5934),
    [anon_sym_Real] = ACTIONS(5932),
    [anon_sym_u211d] = ACTIONS(5934),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_BSLASHlnot] = ACTIONS(5934),
    [anon_sym_BSLASHneg] = ACTIONS(5934),
    [anon_sym_TILDE] = ACTIONS(5932),
    [anon_sym_u00ac] = ACTIONS(5934),
    [sym_union] = ACTIONS(5932),
    [sym_powerset] = ACTIONS(5932),
    [sym_domain] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [sym_negative_dot] = ACTIONS(5934),
    [sym_enabled] = ACTIONS(5932),
    [sym_unchanged] = ACTIONS(5932),
    [anon_sym_LT_GT] = ACTIONS(5934),
    [anon_sym_u22c4] = ACTIONS(5934),
    [anon_sym_u25c7] = ACTIONS(5934),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5932),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [anon_sym_ASSUME] = ACTIONS(5932),
    [anon_sym_ASSUMPTION] = ACTIONS(5932),
    [anon_sym_AXIOM] = ACTIONS(5932),
    [anon_sym_THEOREM] = ACTIONS(5932),
    [anon_sym_PROPOSITION] = ACTIONS(5932),
    [anon_sym_LEMMA] = ACTIONS(5932),
    [anon_sym_COROLLARY] = ACTIONS(5932),
    [anon_sym_PROOF] = ACTIONS(5932),
    [anon_sym_BY] = ACTIONS(5932),
    [anon_sym_OBVIOUS] = ACTIONS(5932),
    [anon_sym_OMITTED] = ACTIONS(5932),
    [anon_sym_USE] = ACTIONS(5932),
    [anon_sym_HIDE] = ACTIONS(5932),
    [sym__begin_proof] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [2339] = {
    [sym_block_comment] = STATE(2339),
    [ts_builtin_sym_end] = ACTIONS(5870),
    [sym_identifier] = ACTIONS(5868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5870),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_LOCAL] = ACTIONS(5868),
    [anon_sym_VARIABLE] = ACTIONS(5868),
    [anon_sym_VARIABLES] = ACTIONS(5868),
    [anon_sym_CONSTANT] = ACTIONS(5868),
    [anon_sym_CONSTANTS] = ACTIONS(5868),
    [anon_sym_RECURSIVE] = ACTIONS(5868),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_INSTANCE] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_Nat] = ACTIONS(5868),
    [anon_sym_u2115] = ACTIONS(5870),
    [anon_sym_Int] = ACTIONS(5868),
    [anon_sym_u2124] = ACTIONS(5870),
    [anon_sym_Real] = ACTIONS(5868),
    [anon_sym_u211d] = ACTIONS(5870),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_BSLASHlnot] = ACTIONS(5870),
    [anon_sym_BSLASHneg] = ACTIONS(5870),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_u00ac] = ACTIONS(5870),
    [sym_union] = ACTIONS(5868),
    [sym_powerset] = ACTIONS(5868),
    [sym_domain] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [sym_negative_dot] = ACTIONS(5870),
    [sym_enabled] = ACTIONS(5868),
    [sym_unchanged] = ACTIONS(5868),
    [anon_sym_LT_GT] = ACTIONS(5870),
    [anon_sym_u22c4] = ACTIONS(5870),
    [anon_sym_u25c7] = ACTIONS(5870),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5868),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [anon_sym_ASSUME] = ACTIONS(5868),
    [anon_sym_ASSUMPTION] = ACTIONS(5868),
    [anon_sym_AXIOM] = ACTIONS(5868),
    [anon_sym_THEOREM] = ACTIONS(5868),
    [anon_sym_PROPOSITION] = ACTIONS(5868),
    [anon_sym_LEMMA] = ACTIONS(5868),
    [anon_sym_COROLLARY] = ACTIONS(5868),
    [anon_sym_PROOF] = ACTIONS(5868),
    [anon_sym_BY] = ACTIONS(5868),
    [anon_sym_OBVIOUS] = ACTIONS(5868),
    [anon_sym_OMITTED] = ACTIONS(5868),
    [anon_sym_USE] = ACTIONS(5868),
    [anon_sym_HIDE] = ACTIONS(5868),
    [sym__begin_proof] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [2340] = {
    [sym_block_comment] = STATE(2340),
    [sym_identifier] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5736),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_LOCAL] = ACTIONS(5738),
    [anon_sym_VARIABLE] = ACTIONS(5738),
    [anon_sym_VARIABLES] = ACTIONS(5738),
    [anon_sym_CONSTANT] = ACTIONS(5738),
    [anon_sym_CONSTANTS] = ACTIONS(5738),
    [anon_sym_RECURSIVE] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_INSTANCE] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_Nat] = ACTIONS(5738),
    [anon_sym_u2115] = ACTIONS(5736),
    [anon_sym_Int] = ACTIONS(5738),
    [anon_sym_u2124] = ACTIONS(5736),
    [anon_sym_Real] = ACTIONS(5738),
    [anon_sym_u211d] = ACTIONS(5736),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_BSLASHlnot] = ACTIONS(5736),
    [anon_sym_BSLASHneg] = ACTIONS(5736),
    [anon_sym_TILDE] = ACTIONS(5738),
    [anon_sym_u00ac] = ACTIONS(5736),
    [sym_union] = ACTIONS(5738),
    [sym_powerset] = ACTIONS(5738),
    [sym_domain] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [sym_negative_dot] = ACTIONS(5736),
    [sym_enabled] = ACTIONS(5738),
    [sym_unchanged] = ACTIONS(5738),
    [anon_sym_LT_GT] = ACTIONS(5736),
    [anon_sym_u22c4] = ACTIONS(5736),
    [anon_sym_u25c7] = ACTIONS(5736),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5738),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [anon_sym_ASSUME] = ACTIONS(5738),
    [anon_sym_ASSUMPTION] = ACTIONS(5738),
    [anon_sym_AXIOM] = ACTIONS(5738),
    [anon_sym_THEOREM] = ACTIONS(5738),
    [anon_sym_PROPOSITION] = ACTIONS(5738),
    [anon_sym_LEMMA] = ACTIONS(5738),
    [anon_sym_COROLLARY] = ACTIONS(5738),
    [anon_sym_PROOF] = ACTIONS(5738),
    [anon_sym_BY] = ACTIONS(5738),
    [anon_sym_OBVIOUS] = ACTIONS(5738),
    [anon_sym_OMITTED] = ACTIONS(5738),
    [anon_sym_USE] = ACTIONS(5738),
    [anon_sym_HIDE] = ACTIONS(5738),
    [sym__begin_proof] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [2341] = {
    [sym_block_comment] = STATE(2341),
    [sym_identifier] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5744),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_LOCAL] = ACTIONS(5746),
    [anon_sym_VARIABLE] = ACTIONS(5746),
    [anon_sym_VARIABLES] = ACTIONS(5746),
    [anon_sym_CONSTANT] = ACTIONS(5746),
    [anon_sym_CONSTANTS] = ACTIONS(5746),
    [anon_sym_RECURSIVE] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_INSTANCE] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_Nat] = ACTIONS(5746),
    [anon_sym_u2115] = ACTIONS(5744),
    [anon_sym_Int] = ACTIONS(5746),
    [anon_sym_u2124] = ACTIONS(5744),
    [anon_sym_Real] = ACTIONS(5746),
    [anon_sym_u211d] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_BSLASHlnot] = ACTIONS(5744),
    [anon_sym_BSLASHneg] = ACTIONS(5744),
    [anon_sym_TILDE] = ACTIONS(5746),
    [anon_sym_u00ac] = ACTIONS(5744),
    [sym_union] = ACTIONS(5746),
    [sym_powerset] = ACTIONS(5746),
    [sym_domain] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [sym_negative_dot] = ACTIONS(5744),
    [sym_enabled] = ACTIONS(5746),
    [sym_unchanged] = ACTIONS(5746),
    [anon_sym_LT_GT] = ACTIONS(5744),
    [anon_sym_u22c4] = ACTIONS(5744),
    [anon_sym_u25c7] = ACTIONS(5744),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5746),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [anon_sym_ASSUME] = ACTIONS(5746),
    [anon_sym_ASSUMPTION] = ACTIONS(5746),
    [anon_sym_AXIOM] = ACTIONS(5746),
    [anon_sym_THEOREM] = ACTIONS(5746),
    [anon_sym_PROPOSITION] = ACTIONS(5746),
    [anon_sym_LEMMA] = ACTIONS(5746),
    [anon_sym_COROLLARY] = ACTIONS(5746),
    [anon_sym_PROOF] = ACTIONS(5746),
    [anon_sym_BY] = ACTIONS(5746),
    [anon_sym_OBVIOUS] = ACTIONS(5746),
    [anon_sym_OMITTED] = ACTIONS(5746),
    [anon_sym_USE] = ACTIONS(5746),
    [anon_sym_HIDE] = ACTIONS(5746),
    [sym__begin_proof] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [2342] = {
    [sym_block_comment] = STATE(2342),
    [sym_identifier] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5748),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_LOCAL] = ACTIONS(5750),
    [anon_sym_VARIABLE] = ACTIONS(5750),
    [anon_sym_VARIABLES] = ACTIONS(5750),
    [anon_sym_CONSTANT] = ACTIONS(5750),
    [anon_sym_CONSTANTS] = ACTIONS(5750),
    [anon_sym_RECURSIVE] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_INSTANCE] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_Nat] = ACTIONS(5750),
    [anon_sym_u2115] = ACTIONS(5748),
    [anon_sym_Int] = ACTIONS(5750),
    [anon_sym_u2124] = ACTIONS(5748),
    [anon_sym_Real] = ACTIONS(5750),
    [anon_sym_u211d] = ACTIONS(5748),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_BSLASHlnot] = ACTIONS(5748),
    [anon_sym_BSLASHneg] = ACTIONS(5748),
    [anon_sym_TILDE] = ACTIONS(5750),
    [anon_sym_u00ac] = ACTIONS(5748),
    [sym_union] = ACTIONS(5750),
    [sym_powerset] = ACTIONS(5750),
    [sym_domain] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [sym_negative_dot] = ACTIONS(5748),
    [sym_enabled] = ACTIONS(5750),
    [sym_unchanged] = ACTIONS(5750),
    [anon_sym_LT_GT] = ACTIONS(5748),
    [anon_sym_u22c4] = ACTIONS(5748),
    [anon_sym_u25c7] = ACTIONS(5748),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5750),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [anon_sym_ASSUME] = ACTIONS(5750),
    [anon_sym_ASSUMPTION] = ACTIONS(5750),
    [anon_sym_AXIOM] = ACTIONS(5750),
    [anon_sym_THEOREM] = ACTIONS(5750),
    [anon_sym_PROPOSITION] = ACTIONS(5750),
    [anon_sym_LEMMA] = ACTIONS(5750),
    [anon_sym_COROLLARY] = ACTIONS(5750),
    [anon_sym_PROOF] = ACTIONS(5750),
    [anon_sym_BY] = ACTIONS(5750),
    [anon_sym_OBVIOUS] = ACTIONS(5750),
    [anon_sym_OMITTED] = ACTIONS(5750),
    [anon_sym_USE] = ACTIONS(5750),
    [anon_sym_HIDE] = ACTIONS(5750),
    [sym__begin_proof] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [2343] = {
    [sym_block_comment] = STATE(2343),
    [sym_identifier] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5778),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_LOCAL] = ACTIONS(5780),
    [anon_sym_VARIABLE] = ACTIONS(5780),
    [anon_sym_VARIABLES] = ACTIONS(5780),
    [anon_sym_CONSTANT] = ACTIONS(5780),
    [anon_sym_CONSTANTS] = ACTIONS(5780),
    [anon_sym_RECURSIVE] = ACTIONS(5780),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_INSTANCE] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_Nat] = ACTIONS(5780),
    [anon_sym_u2115] = ACTIONS(5778),
    [anon_sym_Int] = ACTIONS(5780),
    [anon_sym_u2124] = ACTIONS(5778),
    [anon_sym_Real] = ACTIONS(5780),
    [anon_sym_u211d] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_BSLASHlnot] = ACTIONS(5778),
    [anon_sym_BSLASHneg] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5780),
    [anon_sym_u00ac] = ACTIONS(5778),
    [sym_union] = ACTIONS(5780),
    [sym_powerset] = ACTIONS(5780),
    [sym_domain] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [sym_negative_dot] = ACTIONS(5778),
    [sym_enabled] = ACTIONS(5780),
    [sym_unchanged] = ACTIONS(5780),
    [anon_sym_LT_GT] = ACTIONS(5778),
    [anon_sym_u22c4] = ACTIONS(5778),
    [anon_sym_u25c7] = ACTIONS(5778),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5780),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [anon_sym_ASSUME] = ACTIONS(5780),
    [anon_sym_ASSUMPTION] = ACTIONS(5780),
    [anon_sym_AXIOM] = ACTIONS(5780),
    [anon_sym_THEOREM] = ACTIONS(5780),
    [anon_sym_PROPOSITION] = ACTIONS(5780),
    [anon_sym_LEMMA] = ACTIONS(5780),
    [anon_sym_COROLLARY] = ACTIONS(5780),
    [anon_sym_PROOF] = ACTIONS(5780),
    [anon_sym_BY] = ACTIONS(5780),
    [anon_sym_OBVIOUS] = ACTIONS(5780),
    [anon_sym_OMITTED] = ACTIONS(5780),
    [anon_sym_USE] = ACTIONS(5780),
    [anon_sym_HIDE] = ACTIONS(5780),
    [sym__begin_proof] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [2344] = {
    [sym_block_comment] = STATE(2344),
    [sym_identifier] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5782),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_LOCAL] = ACTIONS(5784),
    [anon_sym_VARIABLE] = ACTIONS(5784),
    [anon_sym_VARIABLES] = ACTIONS(5784),
    [anon_sym_CONSTANT] = ACTIONS(5784),
    [anon_sym_CONSTANTS] = ACTIONS(5784),
    [anon_sym_RECURSIVE] = ACTIONS(5784),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_INSTANCE] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_Nat] = ACTIONS(5784),
    [anon_sym_u2115] = ACTIONS(5782),
    [anon_sym_Int] = ACTIONS(5784),
    [anon_sym_u2124] = ACTIONS(5782),
    [anon_sym_Real] = ACTIONS(5784),
    [anon_sym_u211d] = ACTIONS(5782),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_BSLASHlnot] = ACTIONS(5782),
    [anon_sym_BSLASHneg] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [anon_sym_u00ac] = ACTIONS(5782),
    [sym_union] = ACTIONS(5784),
    [sym_powerset] = ACTIONS(5784),
    [sym_domain] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [sym_negative_dot] = ACTIONS(5782),
    [sym_enabled] = ACTIONS(5784),
    [sym_unchanged] = ACTIONS(5784),
    [anon_sym_LT_GT] = ACTIONS(5782),
    [anon_sym_u22c4] = ACTIONS(5782),
    [anon_sym_u25c7] = ACTIONS(5782),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5784),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [anon_sym_ASSUME] = ACTIONS(5784),
    [anon_sym_ASSUMPTION] = ACTIONS(5784),
    [anon_sym_AXIOM] = ACTIONS(5784),
    [anon_sym_THEOREM] = ACTIONS(5784),
    [anon_sym_PROPOSITION] = ACTIONS(5784),
    [anon_sym_LEMMA] = ACTIONS(5784),
    [anon_sym_COROLLARY] = ACTIONS(5784),
    [anon_sym_PROOF] = ACTIONS(5784),
    [anon_sym_BY] = ACTIONS(5784),
    [anon_sym_OBVIOUS] = ACTIONS(5784),
    [anon_sym_OMITTED] = ACTIONS(5784),
    [anon_sym_USE] = ACTIONS(5784),
    [anon_sym_HIDE] = ACTIONS(5784),
    [sym__begin_proof] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [2345] = {
    [sym_block_comment] = STATE(2345),
    [ts_builtin_sym_end] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5890),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_LOCAL] = ACTIONS(5888),
    [anon_sym_VARIABLE] = ACTIONS(5888),
    [anon_sym_VARIABLES] = ACTIONS(5888),
    [anon_sym_CONSTANT] = ACTIONS(5888),
    [anon_sym_CONSTANTS] = ACTIONS(5888),
    [anon_sym_RECURSIVE] = ACTIONS(5888),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_INSTANCE] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_Nat] = ACTIONS(5888),
    [anon_sym_u2115] = ACTIONS(5890),
    [anon_sym_Int] = ACTIONS(5888),
    [anon_sym_u2124] = ACTIONS(5890),
    [anon_sym_Real] = ACTIONS(5888),
    [anon_sym_u211d] = ACTIONS(5890),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_BSLASHlnot] = ACTIONS(5890),
    [anon_sym_BSLASHneg] = ACTIONS(5890),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_u00ac] = ACTIONS(5890),
    [sym_union] = ACTIONS(5888),
    [sym_powerset] = ACTIONS(5888),
    [sym_domain] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [sym_negative_dot] = ACTIONS(5890),
    [sym_enabled] = ACTIONS(5888),
    [sym_unchanged] = ACTIONS(5888),
    [anon_sym_LT_GT] = ACTIONS(5890),
    [anon_sym_u22c4] = ACTIONS(5890),
    [anon_sym_u25c7] = ACTIONS(5890),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5888),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [anon_sym_ASSUME] = ACTIONS(5888),
    [anon_sym_ASSUMPTION] = ACTIONS(5888),
    [anon_sym_AXIOM] = ACTIONS(5888),
    [anon_sym_THEOREM] = ACTIONS(5888),
    [anon_sym_PROPOSITION] = ACTIONS(5888),
    [anon_sym_LEMMA] = ACTIONS(5888),
    [anon_sym_COROLLARY] = ACTIONS(5888),
    [anon_sym_PROOF] = ACTIONS(5888),
    [anon_sym_BY] = ACTIONS(5888),
    [anon_sym_OBVIOUS] = ACTIONS(5888),
    [anon_sym_OMITTED] = ACTIONS(5888),
    [anon_sym_USE] = ACTIONS(5888),
    [anon_sym_HIDE] = ACTIONS(5888),
    [sym__begin_proof] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [2346] = {
    [sym_block_comment] = STATE(2346),
    [ts_builtin_sym_end] = ACTIONS(5852),
    [sym_identifier] = ACTIONS(5850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5852),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_LOCAL] = ACTIONS(5850),
    [anon_sym_VARIABLE] = ACTIONS(5850),
    [anon_sym_VARIABLES] = ACTIONS(5850),
    [anon_sym_CONSTANT] = ACTIONS(5850),
    [anon_sym_CONSTANTS] = ACTIONS(5850),
    [anon_sym_RECURSIVE] = ACTIONS(5850),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_INSTANCE] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_Nat] = ACTIONS(5850),
    [anon_sym_u2115] = ACTIONS(5852),
    [anon_sym_Int] = ACTIONS(5850),
    [anon_sym_u2124] = ACTIONS(5852),
    [anon_sym_Real] = ACTIONS(5850),
    [anon_sym_u211d] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_BSLASHlnot] = ACTIONS(5852),
    [anon_sym_BSLASHneg] = ACTIONS(5852),
    [anon_sym_TILDE] = ACTIONS(5850),
    [anon_sym_u00ac] = ACTIONS(5852),
    [sym_union] = ACTIONS(5850),
    [sym_powerset] = ACTIONS(5850),
    [sym_domain] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [sym_negative_dot] = ACTIONS(5852),
    [sym_enabled] = ACTIONS(5850),
    [sym_unchanged] = ACTIONS(5850),
    [anon_sym_LT_GT] = ACTIONS(5852),
    [anon_sym_u22c4] = ACTIONS(5852),
    [anon_sym_u25c7] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5850),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [anon_sym_ASSUME] = ACTIONS(5850),
    [anon_sym_ASSUMPTION] = ACTIONS(5850),
    [anon_sym_AXIOM] = ACTIONS(5850),
    [anon_sym_THEOREM] = ACTIONS(5850),
    [anon_sym_PROPOSITION] = ACTIONS(5850),
    [anon_sym_LEMMA] = ACTIONS(5850),
    [anon_sym_COROLLARY] = ACTIONS(5850),
    [anon_sym_PROOF] = ACTIONS(5850),
    [anon_sym_BY] = ACTIONS(5850),
    [anon_sym_OBVIOUS] = ACTIONS(5850),
    [anon_sym_OMITTED] = ACTIONS(5850),
    [anon_sym_USE] = ACTIONS(5850),
    [anon_sym_HIDE] = ACTIONS(5850),
    [sym__begin_proof] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [2347] = {
    [sym_block_comment] = STATE(2347),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [sym_identifier] = ACTIONS(5858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5860),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_LOCAL] = ACTIONS(5858),
    [anon_sym_VARIABLE] = ACTIONS(5858),
    [anon_sym_VARIABLES] = ACTIONS(5858),
    [anon_sym_CONSTANT] = ACTIONS(5858),
    [anon_sym_CONSTANTS] = ACTIONS(5858),
    [anon_sym_RECURSIVE] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_INSTANCE] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_Nat] = ACTIONS(5858),
    [anon_sym_u2115] = ACTIONS(5860),
    [anon_sym_Int] = ACTIONS(5858),
    [anon_sym_u2124] = ACTIONS(5860),
    [anon_sym_Real] = ACTIONS(5858),
    [anon_sym_u211d] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_BSLASHlnot] = ACTIONS(5860),
    [anon_sym_BSLASHneg] = ACTIONS(5860),
    [anon_sym_TILDE] = ACTIONS(5858),
    [anon_sym_u00ac] = ACTIONS(5860),
    [sym_union] = ACTIONS(5858),
    [sym_powerset] = ACTIONS(5858),
    [sym_domain] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [sym_negative_dot] = ACTIONS(5860),
    [sym_enabled] = ACTIONS(5858),
    [sym_unchanged] = ACTIONS(5858),
    [anon_sym_LT_GT] = ACTIONS(5860),
    [anon_sym_u22c4] = ACTIONS(5860),
    [anon_sym_u25c7] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5858),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [anon_sym_ASSUME] = ACTIONS(5858),
    [anon_sym_ASSUMPTION] = ACTIONS(5858),
    [anon_sym_AXIOM] = ACTIONS(5858),
    [anon_sym_THEOREM] = ACTIONS(5858),
    [anon_sym_PROPOSITION] = ACTIONS(5858),
    [anon_sym_LEMMA] = ACTIONS(5858),
    [anon_sym_COROLLARY] = ACTIONS(5858),
    [anon_sym_PROOF] = ACTIONS(5858),
    [anon_sym_BY] = ACTIONS(5858),
    [anon_sym_OBVIOUS] = ACTIONS(5858),
    [anon_sym_OMITTED] = ACTIONS(5858),
    [anon_sym_USE] = ACTIONS(5858),
    [anon_sym_HIDE] = ACTIONS(5858),
    [sym__begin_proof] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [2348] = {
    [sym_block_comment] = STATE(2348),
    [sym_identifier] = ACTIONS(5792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5790),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_LOCAL] = ACTIONS(5792),
    [anon_sym_VARIABLE] = ACTIONS(5792),
    [anon_sym_VARIABLES] = ACTIONS(5792),
    [anon_sym_CONSTANT] = ACTIONS(5792),
    [anon_sym_CONSTANTS] = ACTIONS(5792),
    [anon_sym_RECURSIVE] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_INSTANCE] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_Nat] = ACTIONS(5792),
    [anon_sym_u2115] = ACTIONS(5790),
    [anon_sym_Int] = ACTIONS(5792),
    [anon_sym_u2124] = ACTIONS(5790),
    [anon_sym_Real] = ACTIONS(5792),
    [anon_sym_u211d] = ACTIONS(5790),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_BSLASHlnot] = ACTIONS(5790),
    [anon_sym_BSLASHneg] = ACTIONS(5790),
    [anon_sym_TILDE] = ACTIONS(5792),
    [anon_sym_u00ac] = ACTIONS(5790),
    [sym_union] = ACTIONS(5792),
    [sym_powerset] = ACTIONS(5792),
    [sym_domain] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [sym_negative_dot] = ACTIONS(5790),
    [sym_enabled] = ACTIONS(5792),
    [sym_unchanged] = ACTIONS(5792),
    [anon_sym_LT_GT] = ACTIONS(5790),
    [anon_sym_u22c4] = ACTIONS(5790),
    [anon_sym_u25c7] = ACTIONS(5790),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5792),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [anon_sym_ASSUME] = ACTIONS(5792),
    [anon_sym_ASSUMPTION] = ACTIONS(5792),
    [anon_sym_AXIOM] = ACTIONS(5792),
    [anon_sym_THEOREM] = ACTIONS(5792),
    [anon_sym_PROPOSITION] = ACTIONS(5792),
    [anon_sym_LEMMA] = ACTIONS(5792),
    [anon_sym_COROLLARY] = ACTIONS(5792),
    [anon_sym_PROOF] = ACTIONS(5792),
    [anon_sym_BY] = ACTIONS(5792),
    [anon_sym_OBVIOUS] = ACTIONS(5792),
    [anon_sym_OMITTED] = ACTIONS(5792),
    [anon_sym_USE] = ACTIONS(5792),
    [anon_sym_HIDE] = ACTIONS(5792),
    [sym__begin_proof] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [2349] = {
    [sym_block_comment] = STATE(2349),
    [sym_identifier] = ACTIONS(5796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5794),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_LOCAL] = ACTIONS(5796),
    [anon_sym_VARIABLE] = ACTIONS(5796),
    [anon_sym_VARIABLES] = ACTIONS(5796),
    [anon_sym_CONSTANT] = ACTIONS(5796),
    [anon_sym_CONSTANTS] = ACTIONS(5796),
    [anon_sym_RECURSIVE] = ACTIONS(5796),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_INSTANCE] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_Nat] = ACTIONS(5796),
    [anon_sym_u2115] = ACTIONS(5794),
    [anon_sym_Int] = ACTIONS(5796),
    [anon_sym_u2124] = ACTIONS(5794),
    [anon_sym_Real] = ACTIONS(5796),
    [anon_sym_u211d] = ACTIONS(5794),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_BSLASHlnot] = ACTIONS(5794),
    [anon_sym_BSLASHneg] = ACTIONS(5794),
    [anon_sym_TILDE] = ACTIONS(5796),
    [anon_sym_u00ac] = ACTIONS(5794),
    [sym_union] = ACTIONS(5796),
    [sym_powerset] = ACTIONS(5796),
    [sym_domain] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [sym_negative_dot] = ACTIONS(5794),
    [sym_enabled] = ACTIONS(5796),
    [sym_unchanged] = ACTIONS(5796),
    [anon_sym_LT_GT] = ACTIONS(5794),
    [anon_sym_u22c4] = ACTIONS(5794),
    [anon_sym_u25c7] = ACTIONS(5794),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5796),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [anon_sym_ASSUME] = ACTIONS(5796),
    [anon_sym_ASSUMPTION] = ACTIONS(5796),
    [anon_sym_AXIOM] = ACTIONS(5796),
    [anon_sym_THEOREM] = ACTIONS(5796),
    [anon_sym_PROPOSITION] = ACTIONS(5796),
    [anon_sym_LEMMA] = ACTIONS(5796),
    [anon_sym_COROLLARY] = ACTIONS(5796),
    [anon_sym_PROOF] = ACTIONS(5796),
    [anon_sym_BY] = ACTIONS(5796),
    [anon_sym_OBVIOUS] = ACTIONS(5796),
    [anon_sym_OMITTED] = ACTIONS(5796),
    [anon_sym_USE] = ACTIONS(5796),
    [anon_sym_HIDE] = ACTIONS(5796),
    [sym__begin_proof] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [2350] = {
    [sym_block_comment] = STATE(2350),
    [sym_identifier] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5798),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_LOCAL] = ACTIONS(5800),
    [anon_sym_VARIABLE] = ACTIONS(5800),
    [anon_sym_VARIABLES] = ACTIONS(5800),
    [anon_sym_CONSTANT] = ACTIONS(5800),
    [anon_sym_CONSTANTS] = ACTIONS(5800),
    [anon_sym_RECURSIVE] = ACTIONS(5800),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_INSTANCE] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_Nat] = ACTIONS(5800),
    [anon_sym_u2115] = ACTIONS(5798),
    [anon_sym_Int] = ACTIONS(5800),
    [anon_sym_u2124] = ACTIONS(5798),
    [anon_sym_Real] = ACTIONS(5800),
    [anon_sym_u211d] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_BSLASHlnot] = ACTIONS(5798),
    [anon_sym_BSLASHneg] = ACTIONS(5798),
    [anon_sym_TILDE] = ACTIONS(5800),
    [anon_sym_u00ac] = ACTIONS(5798),
    [sym_union] = ACTIONS(5800),
    [sym_powerset] = ACTIONS(5800),
    [sym_domain] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [sym_negative_dot] = ACTIONS(5798),
    [sym_enabled] = ACTIONS(5800),
    [sym_unchanged] = ACTIONS(5800),
    [anon_sym_LT_GT] = ACTIONS(5798),
    [anon_sym_u22c4] = ACTIONS(5798),
    [anon_sym_u25c7] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5800),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [anon_sym_ASSUME] = ACTIONS(5800),
    [anon_sym_ASSUMPTION] = ACTIONS(5800),
    [anon_sym_AXIOM] = ACTIONS(5800),
    [anon_sym_THEOREM] = ACTIONS(5800),
    [anon_sym_PROPOSITION] = ACTIONS(5800),
    [anon_sym_LEMMA] = ACTIONS(5800),
    [anon_sym_COROLLARY] = ACTIONS(5800),
    [anon_sym_PROOF] = ACTIONS(5800),
    [anon_sym_BY] = ACTIONS(5800),
    [anon_sym_OBVIOUS] = ACTIONS(5800),
    [anon_sym_OMITTED] = ACTIONS(5800),
    [anon_sym_USE] = ACTIONS(5800),
    [anon_sym_HIDE] = ACTIONS(5800),
    [sym__begin_proof] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [2351] = {
    [sym_block_comment] = STATE(2351),
    [sym_identifier] = ACTIONS(5812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5810),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_LOCAL] = ACTIONS(5812),
    [anon_sym_VARIABLE] = ACTIONS(5812),
    [anon_sym_VARIABLES] = ACTIONS(5812),
    [anon_sym_CONSTANT] = ACTIONS(5812),
    [anon_sym_CONSTANTS] = ACTIONS(5812),
    [anon_sym_RECURSIVE] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_INSTANCE] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_Nat] = ACTIONS(5812),
    [anon_sym_u2115] = ACTIONS(5810),
    [anon_sym_Int] = ACTIONS(5812),
    [anon_sym_u2124] = ACTIONS(5810),
    [anon_sym_Real] = ACTIONS(5812),
    [anon_sym_u211d] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_BSLASHlnot] = ACTIONS(5810),
    [anon_sym_BSLASHneg] = ACTIONS(5810),
    [anon_sym_TILDE] = ACTIONS(5812),
    [anon_sym_u00ac] = ACTIONS(5810),
    [sym_union] = ACTIONS(5812),
    [sym_powerset] = ACTIONS(5812),
    [sym_domain] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [sym_negative_dot] = ACTIONS(5810),
    [sym_enabled] = ACTIONS(5812),
    [sym_unchanged] = ACTIONS(5812),
    [anon_sym_LT_GT] = ACTIONS(5810),
    [anon_sym_u22c4] = ACTIONS(5810),
    [anon_sym_u25c7] = ACTIONS(5810),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5812),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [anon_sym_ASSUME] = ACTIONS(5812),
    [anon_sym_ASSUMPTION] = ACTIONS(5812),
    [anon_sym_AXIOM] = ACTIONS(5812),
    [anon_sym_THEOREM] = ACTIONS(5812),
    [anon_sym_PROPOSITION] = ACTIONS(5812),
    [anon_sym_LEMMA] = ACTIONS(5812),
    [anon_sym_COROLLARY] = ACTIONS(5812),
    [anon_sym_PROOF] = ACTIONS(5812),
    [anon_sym_BY] = ACTIONS(5812),
    [anon_sym_OBVIOUS] = ACTIONS(5812),
    [anon_sym_OMITTED] = ACTIONS(5812),
    [anon_sym_USE] = ACTIONS(5812),
    [anon_sym_HIDE] = ACTIONS(5812),
    [sym__begin_proof] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [2352] = {
    [sym_block_comment] = STATE(2352),
    [sym_identifier] = ACTIONS(5816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5814),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_LOCAL] = ACTIONS(5816),
    [anon_sym_VARIABLE] = ACTIONS(5816),
    [anon_sym_VARIABLES] = ACTIONS(5816),
    [anon_sym_CONSTANT] = ACTIONS(5816),
    [anon_sym_CONSTANTS] = ACTIONS(5816),
    [anon_sym_RECURSIVE] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_INSTANCE] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_Nat] = ACTIONS(5816),
    [anon_sym_u2115] = ACTIONS(5814),
    [anon_sym_Int] = ACTIONS(5816),
    [anon_sym_u2124] = ACTIONS(5814),
    [anon_sym_Real] = ACTIONS(5816),
    [anon_sym_u211d] = ACTIONS(5814),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_BSLASHlnot] = ACTIONS(5814),
    [anon_sym_BSLASHneg] = ACTIONS(5814),
    [anon_sym_TILDE] = ACTIONS(5816),
    [anon_sym_u00ac] = ACTIONS(5814),
    [sym_union] = ACTIONS(5816),
    [sym_powerset] = ACTIONS(5816),
    [sym_domain] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [sym_negative_dot] = ACTIONS(5814),
    [sym_enabled] = ACTIONS(5816),
    [sym_unchanged] = ACTIONS(5816),
    [anon_sym_LT_GT] = ACTIONS(5814),
    [anon_sym_u22c4] = ACTIONS(5814),
    [anon_sym_u25c7] = ACTIONS(5814),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5816),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [anon_sym_ASSUME] = ACTIONS(5816),
    [anon_sym_ASSUMPTION] = ACTIONS(5816),
    [anon_sym_AXIOM] = ACTIONS(5816),
    [anon_sym_THEOREM] = ACTIONS(5816),
    [anon_sym_PROPOSITION] = ACTIONS(5816),
    [anon_sym_LEMMA] = ACTIONS(5816),
    [anon_sym_COROLLARY] = ACTIONS(5816),
    [anon_sym_PROOF] = ACTIONS(5816),
    [anon_sym_BY] = ACTIONS(5816),
    [anon_sym_OBVIOUS] = ACTIONS(5816),
    [anon_sym_OMITTED] = ACTIONS(5816),
    [anon_sym_USE] = ACTIONS(5816),
    [anon_sym_HIDE] = ACTIONS(5816),
    [sym__begin_proof] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [2353] = {
    [sym_block_comment] = STATE(2353),
    [sym_identifier] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5818),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_LOCAL] = ACTIONS(5820),
    [anon_sym_VARIABLE] = ACTIONS(5820),
    [anon_sym_VARIABLES] = ACTIONS(5820),
    [anon_sym_CONSTANT] = ACTIONS(5820),
    [anon_sym_CONSTANTS] = ACTIONS(5820),
    [anon_sym_RECURSIVE] = ACTIONS(5820),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_INSTANCE] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_Nat] = ACTIONS(5820),
    [anon_sym_u2115] = ACTIONS(5818),
    [anon_sym_Int] = ACTIONS(5820),
    [anon_sym_u2124] = ACTIONS(5818),
    [anon_sym_Real] = ACTIONS(5820),
    [anon_sym_u211d] = ACTIONS(5818),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_BSLASHlnot] = ACTIONS(5818),
    [anon_sym_BSLASHneg] = ACTIONS(5818),
    [anon_sym_TILDE] = ACTIONS(5820),
    [anon_sym_u00ac] = ACTIONS(5818),
    [sym_union] = ACTIONS(5820),
    [sym_powerset] = ACTIONS(5820),
    [sym_domain] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [sym_negative_dot] = ACTIONS(5818),
    [sym_enabled] = ACTIONS(5820),
    [sym_unchanged] = ACTIONS(5820),
    [anon_sym_LT_GT] = ACTIONS(5818),
    [anon_sym_u22c4] = ACTIONS(5818),
    [anon_sym_u25c7] = ACTIONS(5818),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5820),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [anon_sym_ASSUME] = ACTIONS(5820),
    [anon_sym_ASSUMPTION] = ACTIONS(5820),
    [anon_sym_AXIOM] = ACTIONS(5820),
    [anon_sym_THEOREM] = ACTIONS(5820),
    [anon_sym_PROPOSITION] = ACTIONS(5820),
    [anon_sym_LEMMA] = ACTIONS(5820),
    [anon_sym_COROLLARY] = ACTIONS(5820),
    [anon_sym_PROOF] = ACTIONS(5820),
    [anon_sym_BY] = ACTIONS(5820),
    [anon_sym_OBVIOUS] = ACTIONS(5820),
    [anon_sym_OMITTED] = ACTIONS(5820),
    [anon_sym_USE] = ACTIONS(5820),
    [anon_sym_HIDE] = ACTIONS(5820),
    [sym__begin_proof] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [2354] = {
    [sym_block_comment] = STATE(2354),
    [sym_identifier] = ACTIONS(5824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_LOCAL] = ACTIONS(5824),
    [anon_sym_VARIABLE] = ACTIONS(5824),
    [anon_sym_VARIABLES] = ACTIONS(5824),
    [anon_sym_CONSTANT] = ACTIONS(5824),
    [anon_sym_CONSTANTS] = ACTIONS(5824),
    [anon_sym_RECURSIVE] = ACTIONS(5824),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_INSTANCE] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_Nat] = ACTIONS(5824),
    [anon_sym_u2115] = ACTIONS(5822),
    [anon_sym_Int] = ACTIONS(5824),
    [anon_sym_u2124] = ACTIONS(5822),
    [anon_sym_Real] = ACTIONS(5824),
    [anon_sym_u211d] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_BSLASHlnot] = ACTIONS(5822),
    [anon_sym_BSLASHneg] = ACTIONS(5822),
    [anon_sym_TILDE] = ACTIONS(5824),
    [anon_sym_u00ac] = ACTIONS(5822),
    [sym_union] = ACTIONS(5824),
    [sym_powerset] = ACTIONS(5824),
    [sym_domain] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [sym_negative_dot] = ACTIONS(5822),
    [sym_enabled] = ACTIONS(5824),
    [sym_unchanged] = ACTIONS(5824),
    [anon_sym_LT_GT] = ACTIONS(5822),
    [anon_sym_u22c4] = ACTIONS(5822),
    [anon_sym_u25c7] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5824),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [anon_sym_ASSUME] = ACTIONS(5824),
    [anon_sym_ASSUMPTION] = ACTIONS(5824),
    [anon_sym_AXIOM] = ACTIONS(5824),
    [anon_sym_THEOREM] = ACTIONS(5824),
    [anon_sym_PROPOSITION] = ACTIONS(5824),
    [anon_sym_LEMMA] = ACTIONS(5824),
    [anon_sym_COROLLARY] = ACTIONS(5824),
    [anon_sym_PROOF] = ACTIONS(5824),
    [anon_sym_BY] = ACTIONS(5824),
    [anon_sym_OBVIOUS] = ACTIONS(5824),
    [anon_sym_OMITTED] = ACTIONS(5824),
    [anon_sym_USE] = ACTIONS(5824),
    [anon_sym_HIDE] = ACTIONS(5824),
    [sym__begin_proof] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [2355] = {
    [sym_block_comment] = STATE(2355),
    [sym_identifier] = ACTIONS(5828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5826),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_LOCAL] = ACTIONS(5828),
    [anon_sym_VARIABLE] = ACTIONS(5828),
    [anon_sym_VARIABLES] = ACTIONS(5828),
    [anon_sym_CONSTANT] = ACTIONS(5828),
    [anon_sym_CONSTANTS] = ACTIONS(5828),
    [anon_sym_RECURSIVE] = ACTIONS(5828),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_INSTANCE] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_Nat] = ACTIONS(5828),
    [anon_sym_u2115] = ACTIONS(5826),
    [anon_sym_Int] = ACTIONS(5828),
    [anon_sym_u2124] = ACTIONS(5826),
    [anon_sym_Real] = ACTIONS(5828),
    [anon_sym_u211d] = ACTIONS(5826),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_BSLASHlnot] = ACTIONS(5826),
    [anon_sym_BSLASHneg] = ACTIONS(5826),
    [anon_sym_TILDE] = ACTIONS(5828),
    [anon_sym_u00ac] = ACTIONS(5826),
    [sym_union] = ACTIONS(5828),
    [sym_powerset] = ACTIONS(5828),
    [sym_domain] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [sym_negative_dot] = ACTIONS(5826),
    [sym_enabled] = ACTIONS(5828),
    [sym_unchanged] = ACTIONS(5828),
    [anon_sym_LT_GT] = ACTIONS(5826),
    [anon_sym_u22c4] = ACTIONS(5826),
    [anon_sym_u25c7] = ACTIONS(5826),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5828),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [anon_sym_ASSUME] = ACTIONS(5828),
    [anon_sym_ASSUMPTION] = ACTIONS(5828),
    [anon_sym_AXIOM] = ACTIONS(5828),
    [anon_sym_THEOREM] = ACTIONS(5828),
    [anon_sym_PROPOSITION] = ACTIONS(5828),
    [anon_sym_LEMMA] = ACTIONS(5828),
    [anon_sym_COROLLARY] = ACTIONS(5828),
    [anon_sym_PROOF] = ACTIONS(5828),
    [anon_sym_BY] = ACTIONS(5828),
    [anon_sym_OBVIOUS] = ACTIONS(5828),
    [anon_sym_OMITTED] = ACTIONS(5828),
    [anon_sym_USE] = ACTIONS(5828),
    [anon_sym_HIDE] = ACTIONS(5828),
    [sym__begin_proof] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [2356] = {
    [sym_block_comment] = STATE(2356),
    [sym_identifier] = ACTIONS(5832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5830),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_LOCAL] = ACTIONS(5832),
    [anon_sym_VARIABLE] = ACTIONS(5832),
    [anon_sym_VARIABLES] = ACTIONS(5832),
    [anon_sym_CONSTANT] = ACTIONS(5832),
    [anon_sym_CONSTANTS] = ACTIONS(5832),
    [anon_sym_RECURSIVE] = ACTIONS(5832),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_INSTANCE] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_Nat] = ACTIONS(5832),
    [anon_sym_u2115] = ACTIONS(5830),
    [anon_sym_Int] = ACTIONS(5832),
    [anon_sym_u2124] = ACTIONS(5830),
    [anon_sym_Real] = ACTIONS(5832),
    [anon_sym_u211d] = ACTIONS(5830),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_BSLASHlnot] = ACTIONS(5830),
    [anon_sym_BSLASHneg] = ACTIONS(5830),
    [anon_sym_TILDE] = ACTIONS(5832),
    [anon_sym_u00ac] = ACTIONS(5830),
    [sym_union] = ACTIONS(5832),
    [sym_powerset] = ACTIONS(5832),
    [sym_domain] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [sym_negative_dot] = ACTIONS(5830),
    [sym_enabled] = ACTIONS(5832),
    [sym_unchanged] = ACTIONS(5832),
    [anon_sym_LT_GT] = ACTIONS(5830),
    [anon_sym_u22c4] = ACTIONS(5830),
    [anon_sym_u25c7] = ACTIONS(5830),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5832),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [anon_sym_ASSUME] = ACTIONS(5832),
    [anon_sym_ASSUMPTION] = ACTIONS(5832),
    [anon_sym_AXIOM] = ACTIONS(5832),
    [anon_sym_THEOREM] = ACTIONS(5832),
    [anon_sym_PROPOSITION] = ACTIONS(5832),
    [anon_sym_LEMMA] = ACTIONS(5832),
    [anon_sym_COROLLARY] = ACTIONS(5832),
    [anon_sym_PROOF] = ACTIONS(5832),
    [anon_sym_BY] = ACTIONS(5832),
    [anon_sym_OBVIOUS] = ACTIONS(5832),
    [anon_sym_OMITTED] = ACTIONS(5832),
    [anon_sym_USE] = ACTIONS(5832),
    [anon_sym_HIDE] = ACTIONS(5832),
    [sym__begin_proof] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [2357] = {
    [sym_block_comment] = STATE(2357),
    [sym_identifier] = ACTIONS(5836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5834),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_LOCAL] = ACTIONS(5836),
    [anon_sym_VARIABLE] = ACTIONS(5836),
    [anon_sym_VARIABLES] = ACTIONS(5836),
    [anon_sym_CONSTANT] = ACTIONS(5836),
    [anon_sym_CONSTANTS] = ACTIONS(5836),
    [anon_sym_RECURSIVE] = ACTIONS(5836),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_INSTANCE] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_Nat] = ACTIONS(5836),
    [anon_sym_u2115] = ACTIONS(5834),
    [anon_sym_Int] = ACTIONS(5836),
    [anon_sym_u2124] = ACTIONS(5834),
    [anon_sym_Real] = ACTIONS(5836),
    [anon_sym_u211d] = ACTIONS(5834),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_BSLASHlnot] = ACTIONS(5834),
    [anon_sym_BSLASHneg] = ACTIONS(5834),
    [anon_sym_TILDE] = ACTIONS(5836),
    [anon_sym_u00ac] = ACTIONS(5834),
    [sym_union] = ACTIONS(5836),
    [sym_powerset] = ACTIONS(5836),
    [sym_domain] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [sym_negative_dot] = ACTIONS(5834),
    [sym_enabled] = ACTIONS(5836),
    [sym_unchanged] = ACTIONS(5836),
    [anon_sym_LT_GT] = ACTIONS(5834),
    [anon_sym_u22c4] = ACTIONS(5834),
    [anon_sym_u25c7] = ACTIONS(5834),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5836),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [anon_sym_ASSUME] = ACTIONS(5836),
    [anon_sym_ASSUMPTION] = ACTIONS(5836),
    [anon_sym_AXIOM] = ACTIONS(5836),
    [anon_sym_THEOREM] = ACTIONS(5836),
    [anon_sym_PROPOSITION] = ACTIONS(5836),
    [anon_sym_LEMMA] = ACTIONS(5836),
    [anon_sym_COROLLARY] = ACTIONS(5836),
    [anon_sym_PROOF] = ACTIONS(5836),
    [anon_sym_BY] = ACTIONS(5836),
    [anon_sym_OBVIOUS] = ACTIONS(5836),
    [anon_sym_OMITTED] = ACTIONS(5836),
    [anon_sym_USE] = ACTIONS(5836),
    [anon_sym_HIDE] = ACTIONS(5836),
    [sym__begin_proof] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [2358] = {
    [sym_block_comment] = STATE(2358),
    [sym_identifier] = ACTIONS(5848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5846),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_LOCAL] = ACTIONS(5848),
    [anon_sym_VARIABLE] = ACTIONS(5848),
    [anon_sym_VARIABLES] = ACTIONS(5848),
    [anon_sym_CONSTANT] = ACTIONS(5848),
    [anon_sym_CONSTANTS] = ACTIONS(5848),
    [anon_sym_RECURSIVE] = ACTIONS(5848),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_INSTANCE] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_Nat] = ACTIONS(5848),
    [anon_sym_u2115] = ACTIONS(5846),
    [anon_sym_Int] = ACTIONS(5848),
    [anon_sym_u2124] = ACTIONS(5846),
    [anon_sym_Real] = ACTIONS(5848),
    [anon_sym_u211d] = ACTIONS(5846),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_BSLASHlnot] = ACTIONS(5846),
    [anon_sym_BSLASHneg] = ACTIONS(5846),
    [anon_sym_TILDE] = ACTIONS(5848),
    [anon_sym_u00ac] = ACTIONS(5846),
    [sym_union] = ACTIONS(5848),
    [sym_powerset] = ACTIONS(5848),
    [sym_domain] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [sym_negative_dot] = ACTIONS(5846),
    [sym_enabled] = ACTIONS(5848),
    [sym_unchanged] = ACTIONS(5848),
    [anon_sym_LT_GT] = ACTIONS(5846),
    [anon_sym_u22c4] = ACTIONS(5846),
    [anon_sym_u25c7] = ACTIONS(5846),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5848),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [anon_sym_ASSUME] = ACTIONS(5848),
    [anon_sym_ASSUMPTION] = ACTIONS(5848),
    [anon_sym_AXIOM] = ACTIONS(5848),
    [anon_sym_THEOREM] = ACTIONS(5848),
    [anon_sym_PROPOSITION] = ACTIONS(5848),
    [anon_sym_LEMMA] = ACTIONS(5848),
    [anon_sym_COROLLARY] = ACTIONS(5848),
    [anon_sym_PROOF] = ACTIONS(5848),
    [anon_sym_BY] = ACTIONS(5848),
    [anon_sym_OBVIOUS] = ACTIONS(5848),
    [anon_sym_OMITTED] = ACTIONS(5848),
    [anon_sym_USE] = ACTIONS(5848),
    [anon_sym_HIDE] = ACTIONS(5848),
    [sym__begin_proof] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [2359] = {
    [sym_block_comment] = STATE(2359),
    [sym_identifier] = ACTIONS(5874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5872),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_LOCAL] = ACTIONS(5874),
    [anon_sym_VARIABLE] = ACTIONS(5874),
    [anon_sym_VARIABLES] = ACTIONS(5874),
    [anon_sym_CONSTANT] = ACTIONS(5874),
    [anon_sym_CONSTANTS] = ACTIONS(5874),
    [anon_sym_RECURSIVE] = ACTIONS(5874),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_INSTANCE] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_Nat] = ACTIONS(5874),
    [anon_sym_u2115] = ACTIONS(5872),
    [anon_sym_Int] = ACTIONS(5874),
    [anon_sym_u2124] = ACTIONS(5872),
    [anon_sym_Real] = ACTIONS(5874),
    [anon_sym_u211d] = ACTIONS(5872),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_BSLASHlnot] = ACTIONS(5872),
    [anon_sym_BSLASHneg] = ACTIONS(5872),
    [anon_sym_TILDE] = ACTIONS(5874),
    [anon_sym_u00ac] = ACTIONS(5872),
    [sym_union] = ACTIONS(5874),
    [sym_powerset] = ACTIONS(5874),
    [sym_domain] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [sym_negative_dot] = ACTIONS(5872),
    [sym_enabled] = ACTIONS(5874),
    [sym_unchanged] = ACTIONS(5874),
    [anon_sym_LT_GT] = ACTIONS(5872),
    [anon_sym_u22c4] = ACTIONS(5872),
    [anon_sym_u25c7] = ACTIONS(5872),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5874),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [anon_sym_ASSUME] = ACTIONS(5874),
    [anon_sym_ASSUMPTION] = ACTIONS(5874),
    [anon_sym_AXIOM] = ACTIONS(5874),
    [anon_sym_THEOREM] = ACTIONS(5874),
    [anon_sym_PROPOSITION] = ACTIONS(5874),
    [anon_sym_LEMMA] = ACTIONS(5874),
    [anon_sym_COROLLARY] = ACTIONS(5874),
    [anon_sym_PROOF] = ACTIONS(5874),
    [anon_sym_BY] = ACTIONS(5874),
    [anon_sym_OBVIOUS] = ACTIONS(5874),
    [anon_sym_OMITTED] = ACTIONS(5874),
    [anon_sym_USE] = ACTIONS(5874),
    [anon_sym_HIDE] = ACTIONS(5874),
    [sym__begin_proof] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [2360] = {
    [sym_block_comment] = STATE(2360),
    [sym_identifier] = ACTIONS(5878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5876),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_LOCAL] = ACTIONS(5878),
    [anon_sym_VARIABLE] = ACTIONS(5878),
    [anon_sym_VARIABLES] = ACTIONS(5878),
    [anon_sym_CONSTANT] = ACTIONS(5878),
    [anon_sym_CONSTANTS] = ACTIONS(5878),
    [anon_sym_RECURSIVE] = ACTIONS(5878),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_INSTANCE] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_Nat] = ACTIONS(5878),
    [anon_sym_u2115] = ACTIONS(5876),
    [anon_sym_Int] = ACTIONS(5878),
    [anon_sym_u2124] = ACTIONS(5876),
    [anon_sym_Real] = ACTIONS(5878),
    [anon_sym_u211d] = ACTIONS(5876),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_BSLASHlnot] = ACTIONS(5876),
    [anon_sym_BSLASHneg] = ACTIONS(5876),
    [anon_sym_TILDE] = ACTIONS(5878),
    [anon_sym_u00ac] = ACTIONS(5876),
    [sym_union] = ACTIONS(5878),
    [sym_powerset] = ACTIONS(5878),
    [sym_domain] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [sym_negative_dot] = ACTIONS(5876),
    [sym_enabled] = ACTIONS(5878),
    [sym_unchanged] = ACTIONS(5878),
    [anon_sym_LT_GT] = ACTIONS(5876),
    [anon_sym_u22c4] = ACTIONS(5876),
    [anon_sym_u25c7] = ACTIONS(5876),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5878),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [anon_sym_ASSUME] = ACTIONS(5878),
    [anon_sym_ASSUMPTION] = ACTIONS(5878),
    [anon_sym_AXIOM] = ACTIONS(5878),
    [anon_sym_THEOREM] = ACTIONS(5878),
    [anon_sym_PROPOSITION] = ACTIONS(5878),
    [anon_sym_LEMMA] = ACTIONS(5878),
    [anon_sym_COROLLARY] = ACTIONS(5878),
    [anon_sym_PROOF] = ACTIONS(5878),
    [anon_sym_BY] = ACTIONS(5878),
    [anon_sym_OBVIOUS] = ACTIONS(5878),
    [anon_sym_OMITTED] = ACTIONS(5878),
    [anon_sym_USE] = ACTIONS(5878),
    [anon_sym_HIDE] = ACTIONS(5878),
    [sym__begin_proof] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [2361] = {
    [sym_block_comment] = STATE(2361),
    [sym_identifier] = ACTIONS(5882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5880),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_LOCAL] = ACTIONS(5882),
    [anon_sym_VARIABLE] = ACTIONS(5882),
    [anon_sym_VARIABLES] = ACTIONS(5882),
    [anon_sym_CONSTANT] = ACTIONS(5882),
    [anon_sym_CONSTANTS] = ACTIONS(5882),
    [anon_sym_RECURSIVE] = ACTIONS(5882),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_INSTANCE] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_Nat] = ACTIONS(5882),
    [anon_sym_u2115] = ACTIONS(5880),
    [anon_sym_Int] = ACTIONS(5882),
    [anon_sym_u2124] = ACTIONS(5880),
    [anon_sym_Real] = ACTIONS(5882),
    [anon_sym_u211d] = ACTIONS(5880),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_BSLASHlnot] = ACTIONS(5880),
    [anon_sym_BSLASHneg] = ACTIONS(5880),
    [anon_sym_TILDE] = ACTIONS(5882),
    [anon_sym_u00ac] = ACTIONS(5880),
    [sym_union] = ACTIONS(5882),
    [sym_powerset] = ACTIONS(5882),
    [sym_domain] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [sym_negative_dot] = ACTIONS(5880),
    [sym_enabled] = ACTIONS(5882),
    [sym_unchanged] = ACTIONS(5882),
    [anon_sym_LT_GT] = ACTIONS(5880),
    [anon_sym_u22c4] = ACTIONS(5880),
    [anon_sym_u25c7] = ACTIONS(5880),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5882),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [anon_sym_ASSUME] = ACTIONS(5882),
    [anon_sym_ASSUMPTION] = ACTIONS(5882),
    [anon_sym_AXIOM] = ACTIONS(5882),
    [anon_sym_THEOREM] = ACTIONS(5882),
    [anon_sym_PROPOSITION] = ACTIONS(5882),
    [anon_sym_LEMMA] = ACTIONS(5882),
    [anon_sym_COROLLARY] = ACTIONS(5882),
    [anon_sym_PROOF] = ACTIONS(5882),
    [anon_sym_BY] = ACTIONS(5882),
    [anon_sym_OBVIOUS] = ACTIONS(5882),
    [anon_sym_OMITTED] = ACTIONS(5882),
    [anon_sym_USE] = ACTIONS(5882),
    [anon_sym_HIDE] = ACTIONS(5882),
    [sym__begin_proof] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [2362] = {
    [sym_block_comment] = STATE(2362),
    [sym_identifier] = ACTIONS(5936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5938),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_LOCAL] = ACTIONS(5936),
    [anon_sym_VARIABLE] = ACTIONS(5936),
    [anon_sym_VARIABLES] = ACTIONS(5936),
    [anon_sym_CONSTANT] = ACTIONS(5936),
    [anon_sym_CONSTANTS] = ACTIONS(5936),
    [anon_sym_RECURSIVE] = ACTIONS(5936),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_INSTANCE] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_Nat] = ACTIONS(5936),
    [anon_sym_u2115] = ACTIONS(5938),
    [anon_sym_Int] = ACTIONS(5936),
    [anon_sym_u2124] = ACTIONS(5938),
    [anon_sym_Real] = ACTIONS(5936),
    [anon_sym_u211d] = ACTIONS(5938),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_BSLASHlnot] = ACTIONS(5938),
    [anon_sym_BSLASHneg] = ACTIONS(5938),
    [anon_sym_TILDE] = ACTIONS(5936),
    [anon_sym_u00ac] = ACTIONS(5938),
    [sym_union] = ACTIONS(5936),
    [sym_powerset] = ACTIONS(5936),
    [sym_domain] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [sym_negative_dot] = ACTIONS(5938),
    [sym_enabled] = ACTIONS(5936),
    [sym_unchanged] = ACTIONS(5936),
    [anon_sym_LT_GT] = ACTIONS(5938),
    [anon_sym_u22c4] = ACTIONS(5938),
    [anon_sym_u25c7] = ACTIONS(5938),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5936),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [anon_sym_ASSUME] = ACTIONS(5936),
    [anon_sym_ASSUMPTION] = ACTIONS(5936),
    [anon_sym_AXIOM] = ACTIONS(5936),
    [anon_sym_THEOREM] = ACTIONS(5936),
    [anon_sym_PROPOSITION] = ACTIONS(5936),
    [anon_sym_LEMMA] = ACTIONS(5936),
    [anon_sym_COROLLARY] = ACTIONS(5936),
    [anon_sym_PROOF] = ACTIONS(5936),
    [anon_sym_BY] = ACTIONS(5936),
    [anon_sym_OBVIOUS] = ACTIONS(5936),
    [anon_sym_OMITTED] = ACTIONS(5936),
    [anon_sym_USE] = ACTIONS(5936),
    [anon_sym_HIDE] = ACTIONS(5936),
    [sym__begin_proof] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [2363] = {
    [sym_block_comment] = STATE(2363),
    [sym_identifier] = ACTIONS(5886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5884),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_LOCAL] = ACTIONS(5886),
    [anon_sym_VARIABLE] = ACTIONS(5886),
    [anon_sym_VARIABLES] = ACTIONS(5886),
    [anon_sym_CONSTANT] = ACTIONS(5886),
    [anon_sym_CONSTANTS] = ACTIONS(5886),
    [anon_sym_RECURSIVE] = ACTIONS(5886),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_INSTANCE] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_Nat] = ACTIONS(5886),
    [anon_sym_u2115] = ACTIONS(5884),
    [anon_sym_Int] = ACTIONS(5886),
    [anon_sym_u2124] = ACTIONS(5884),
    [anon_sym_Real] = ACTIONS(5886),
    [anon_sym_u211d] = ACTIONS(5884),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_BSLASHlnot] = ACTIONS(5884),
    [anon_sym_BSLASHneg] = ACTIONS(5884),
    [anon_sym_TILDE] = ACTIONS(5886),
    [anon_sym_u00ac] = ACTIONS(5884),
    [sym_union] = ACTIONS(5886),
    [sym_powerset] = ACTIONS(5886),
    [sym_domain] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [sym_negative_dot] = ACTIONS(5884),
    [sym_enabled] = ACTIONS(5886),
    [sym_unchanged] = ACTIONS(5886),
    [anon_sym_LT_GT] = ACTIONS(5884),
    [anon_sym_u22c4] = ACTIONS(5884),
    [anon_sym_u25c7] = ACTIONS(5884),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5886),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [anon_sym_ASSUME] = ACTIONS(5886),
    [anon_sym_ASSUMPTION] = ACTIONS(5886),
    [anon_sym_AXIOM] = ACTIONS(5886),
    [anon_sym_THEOREM] = ACTIONS(5886),
    [anon_sym_PROPOSITION] = ACTIONS(5886),
    [anon_sym_LEMMA] = ACTIONS(5886),
    [anon_sym_COROLLARY] = ACTIONS(5886),
    [anon_sym_PROOF] = ACTIONS(5886),
    [anon_sym_BY] = ACTIONS(5886),
    [anon_sym_OBVIOUS] = ACTIONS(5886),
    [anon_sym_OMITTED] = ACTIONS(5886),
    [anon_sym_USE] = ACTIONS(5886),
    [anon_sym_HIDE] = ACTIONS(5886),
    [sym__begin_proof] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [2364] = {
    [sym_block_comment] = STATE(2364),
    [sym_case_box] = STATE(180),
    [aux_sym_case_repeat1] = STATE(2250),
    [ts_builtin_sym_end] = ACTIONS(5672),
    [sym_identifier] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5672),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_LOCAL] = ACTIONS(5670),
    [anon_sym_VARIABLE] = ACTIONS(5670),
    [anon_sym_VARIABLES] = ACTIONS(5670),
    [anon_sym_CONSTANT] = ACTIONS(5670),
    [anon_sym_CONSTANTS] = ACTIONS(5670),
    [anon_sym_RECURSIVE] = ACTIONS(5670),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_INSTANCE] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_Nat] = ACTIONS(5670),
    [anon_sym_u2115] = ACTIONS(5672),
    [anon_sym_Int] = ACTIONS(5670),
    [anon_sym_u2124] = ACTIONS(5672),
    [anon_sym_Real] = ACTIONS(5670),
    [anon_sym_u211d] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_BSLASHlnot] = ACTIONS(5672),
    [anon_sym_BSLASHneg] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5670),
    [anon_sym_u00ac] = ACTIONS(5672),
    [sym_union] = ACTIONS(5670),
    [sym_powerset] = ACTIONS(5670),
    [sym_domain] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [sym_negative_dot] = ACTIONS(5672),
    [sym_enabled] = ACTIONS(5670),
    [sym_unchanged] = ACTIONS(5670),
    [anon_sym_LT_GT] = ACTIONS(5672),
    [anon_sym_u22c4] = ACTIONS(5672),
    [anon_sym_u25c7] = ACTIONS(5672),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5670),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [anon_sym_ASSUME] = ACTIONS(5670),
    [anon_sym_ASSUMPTION] = ACTIONS(5670),
    [anon_sym_AXIOM] = ACTIONS(5670),
    [anon_sym_THEOREM] = ACTIONS(5670),
    [anon_sym_PROPOSITION] = ACTIONS(5670),
    [anon_sym_LEMMA] = ACTIONS(5670),
    [anon_sym_COROLLARY] = ACTIONS(5670),
    [anon_sym_USE] = ACTIONS(5670),
    [anon_sym_HIDE] = ACTIONS(5670),
    [anon_sym_DEF] = ACTIONS(5670),
    [anon_sym_DEFS] = ACTIONS(5670),
    [sym__double_excl] = ACTIONS(5672),
  },
  [2365] = {
    [sym_block_comment] = STATE(2365),
    [sym_identifier] = ACTIONS(5940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5942),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_LOCAL] = ACTIONS(5940),
    [anon_sym_VARIABLE] = ACTIONS(5940),
    [anon_sym_VARIABLES] = ACTIONS(5940),
    [anon_sym_CONSTANT] = ACTIONS(5940),
    [anon_sym_CONSTANTS] = ACTIONS(5940),
    [anon_sym_RECURSIVE] = ACTIONS(5940),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_INSTANCE] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_Nat] = ACTIONS(5940),
    [anon_sym_u2115] = ACTIONS(5942),
    [anon_sym_Int] = ACTIONS(5940),
    [anon_sym_u2124] = ACTIONS(5942),
    [anon_sym_Real] = ACTIONS(5940),
    [anon_sym_u211d] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_BSLASHlnot] = ACTIONS(5942),
    [anon_sym_BSLASHneg] = ACTIONS(5942),
    [anon_sym_TILDE] = ACTIONS(5940),
    [anon_sym_u00ac] = ACTIONS(5942),
    [sym_union] = ACTIONS(5940),
    [sym_powerset] = ACTIONS(5940),
    [sym_domain] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [sym_negative_dot] = ACTIONS(5942),
    [sym_enabled] = ACTIONS(5940),
    [sym_unchanged] = ACTIONS(5940),
    [anon_sym_LT_GT] = ACTIONS(5942),
    [anon_sym_u22c4] = ACTIONS(5942),
    [anon_sym_u25c7] = ACTIONS(5942),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5940),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [anon_sym_ASSUME] = ACTIONS(5940),
    [anon_sym_ASSUMPTION] = ACTIONS(5940),
    [anon_sym_AXIOM] = ACTIONS(5940),
    [anon_sym_THEOREM] = ACTIONS(5940),
    [anon_sym_PROPOSITION] = ACTIONS(5940),
    [anon_sym_LEMMA] = ACTIONS(5940),
    [anon_sym_COROLLARY] = ACTIONS(5940),
    [anon_sym_PROOF] = ACTIONS(5940),
    [anon_sym_BY] = ACTIONS(5940),
    [anon_sym_OBVIOUS] = ACTIONS(5940),
    [anon_sym_OMITTED] = ACTIONS(5940),
    [anon_sym_USE] = ACTIONS(5940),
    [anon_sym_HIDE] = ACTIONS(5940),
    [sym__begin_proof] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [2366] = {
    [sym_block_comment] = STATE(2366),
    [sym_identifier] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5351),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_LOCAL] = ACTIONS(5349),
    [anon_sym_VARIABLE] = ACTIONS(5349),
    [anon_sym_VARIABLES] = ACTIONS(5349),
    [anon_sym_CONSTANT] = ACTIONS(5349),
    [anon_sym_CONSTANTS] = ACTIONS(5349),
    [anon_sym_RECURSIVE] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_INSTANCE] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_Nat] = ACTIONS(5349),
    [anon_sym_u2115] = ACTIONS(5351),
    [anon_sym_Int] = ACTIONS(5349),
    [anon_sym_u2124] = ACTIONS(5351),
    [anon_sym_Real] = ACTIONS(5349),
    [anon_sym_u211d] = ACTIONS(5351),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_BSLASHlnot] = ACTIONS(5351),
    [anon_sym_BSLASHneg] = ACTIONS(5351),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_u00ac] = ACTIONS(5351),
    [sym_union] = ACTIONS(5349),
    [sym_powerset] = ACTIONS(5349),
    [sym_domain] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [sym_negative_dot] = ACTIONS(5351),
    [sym_enabled] = ACTIONS(5349),
    [sym_unchanged] = ACTIONS(5349),
    [anon_sym_LT_GT] = ACTIONS(5351),
    [anon_sym_u22c4] = ACTIONS(5351),
    [anon_sym_u25c7] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5349),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [anon_sym_ASSUME] = ACTIONS(5349),
    [anon_sym_ASSUMPTION] = ACTIONS(5349),
    [anon_sym_AXIOM] = ACTIONS(5349),
    [anon_sym_THEOREM] = ACTIONS(5349),
    [anon_sym_PROPOSITION] = ACTIONS(5349),
    [anon_sym_LEMMA] = ACTIONS(5349),
    [anon_sym_COROLLARY] = ACTIONS(5349),
    [anon_sym_PROOF] = ACTIONS(5349),
    [anon_sym_BY] = ACTIONS(5349),
    [anon_sym_OBVIOUS] = ACTIONS(5349),
    [anon_sym_OMITTED] = ACTIONS(5349),
    [anon_sym_USE] = ACTIONS(5349),
    [anon_sym_HIDE] = ACTIONS(5349),
    [sym__begin_proof] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [2367] = {
    [sym_block_comment] = STATE(2367),
    [ts_builtin_sym_end] = ACTIONS(5942),
    [sym_identifier] = ACTIONS(5940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5942),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_LOCAL] = ACTIONS(5940),
    [anon_sym_VARIABLE] = ACTIONS(5940),
    [anon_sym_VARIABLES] = ACTIONS(5940),
    [anon_sym_CONSTANT] = ACTIONS(5940),
    [anon_sym_CONSTANTS] = ACTIONS(5940),
    [anon_sym_RECURSIVE] = ACTIONS(5940),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_INSTANCE] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_Nat] = ACTIONS(5940),
    [anon_sym_u2115] = ACTIONS(5942),
    [anon_sym_Int] = ACTIONS(5940),
    [anon_sym_u2124] = ACTIONS(5942),
    [anon_sym_Real] = ACTIONS(5940),
    [anon_sym_u211d] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_BSLASHlnot] = ACTIONS(5942),
    [anon_sym_BSLASHneg] = ACTIONS(5942),
    [anon_sym_TILDE] = ACTIONS(5940),
    [anon_sym_u00ac] = ACTIONS(5942),
    [sym_union] = ACTIONS(5940),
    [sym_powerset] = ACTIONS(5940),
    [sym_domain] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [sym_negative_dot] = ACTIONS(5942),
    [sym_enabled] = ACTIONS(5940),
    [sym_unchanged] = ACTIONS(5940),
    [anon_sym_LT_GT] = ACTIONS(5942),
    [anon_sym_u22c4] = ACTIONS(5942),
    [anon_sym_u25c7] = ACTIONS(5942),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5940),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [anon_sym_ASSUME] = ACTIONS(5940),
    [anon_sym_ASSUMPTION] = ACTIONS(5940),
    [anon_sym_AXIOM] = ACTIONS(5940),
    [anon_sym_THEOREM] = ACTIONS(5940),
    [anon_sym_PROPOSITION] = ACTIONS(5940),
    [anon_sym_LEMMA] = ACTIONS(5940),
    [anon_sym_COROLLARY] = ACTIONS(5940),
    [anon_sym_PROOF] = ACTIONS(5940),
    [anon_sym_BY] = ACTIONS(5940),
    [anon_sym_OBVIOUS] = ACTIONS(5940),
    [anon_sym_OMITTED] = ACTIONS(5940),
    [anon_sym_USE] = ACTIONS(5940),
    [anon_sym_HIDE] = ACTIONS(5940),
    [sym__begin_proof] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [2368] = {
    [sym_block_comment] = STATE(2368),
    [ts_builtin_sym_end] = ACTIONS(5938),
    [sym_identifier] = ACTIONS(5936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5938),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_LOCAL] = ACTIONS(5936),
    [anon_sym_VARIABLE] = ACTIONS(5936),
    [anon_sym_VARIABLES] = ACTIONS(5936),
    [anon_sym_CONSTANT] = ACTIONS(5936),
    [anon_sym_CONSTANTS] = ACTIONS(5936),
    [anon_sym_RECURSIVE] = ACTIONS(5936),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_INSTANCE] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_Nat] = ACTIONS(5936),
    [anon_sym_u2115] = ACTIONS(5938),
    [anon_sym_Int] = ACTIONS(5936),
    [anon_sym_u2124] = ACTIONS(5938),
    [anon_sym_Real] = ACTIONS(5936),
    [anon_sym_u211d] = ACTIONS(5938),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_BSLASHlnot] = ACTIONS(5938),
    [anon_sym_BSLASHneg] = ACTIONS(5938),
    [anon_sym_TILDE] = ACTIONS(5936),
    [anon_sym_u00ac] = ACTIONS(5938),
    [sym_union] = ACTIONS(5936),
    [sym_powerset] = ACTIONS(5936),
    [sym_domain] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [sym_negative_dot] = ACTIONS(5938),
    [sym_enabled] = ACTIONS(5936),
    [sym_unchanged] = ACTIONS(5936),
    [anon_sym_LT_GT] = ACTIONS(5938),
    [anon_sym_u22c4] = ACTIONS(5938),
    [anon_sym_u25c7] = ACTIONS(5938),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5936),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [anon_sym_ASSUME] = ACTIONS(5936),
    [anon_sym_ASSUMPTION] = ACTIONS(5936),
    [anon_sym_AXIOM] = ACTIONS(5936),
    [anon_sym_THEOREM] = ACTIONS(5936),
    [anon_sym_PROPOSITION] = ACTIONS(5936),
    [anon_sym_LEMMA] = ACTIONS(5936),
    [anon_sym_COROLLARY] = ACTIONS(5936),
    [anon_sym_PROOF] = ACTIONS(5936),
    [anon_sym_BY] = ACTIONS(5936),
    [anon_sym_OBVIOUS] = ACTIONS(5936),
    [anon_sym_OMITTED] = ACTIONS(5936),
    [anon_sym_USE] = ACTIONS(5936),
    [anon_sym_HIDE] = ACTIONS(5936),
    [sym__begin_proof] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [2369] = {
    [sym_block_comment] = STATE(2369),
    [sym_identifier] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5712),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_LOCAL] = ACTIONS(5714),
    [anon_sym_VARIABLE] = ACTIONS(5714),
    [anon_sym_VARIABLES] = ACTIONS(5714),
    [anon_sym_CONSTANT] = ACTIONS(5714),
    [anon_sym_CONSTANTS] = ACTIONS(5714),
    [anon_sym_RECURSIVE] = ACTIONS(5714),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_INSTANCE] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_Nat] = ACTIONS(5714),
    [anon_sym_u2115] = ACTIONS(5712),
    [anon_sym_Int] = ACTIONS(5714),
    [anon_sym_u2124] = ACTIONS(5712),
    [anon_sym_Real] = ACTIONS(5714),
    [anon_sym_u211d] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_BSLASHlnot] = ACTIONS(5712),
    [anon_sym_BSLASHneg] = ACTIONS(5712),
    [anon_sym_TILDE] = ACTIONS(5714),
    [anon_sym_u00ac] = ACTIONS(5712),
    [sym_union] = ACTIONS(5714),
    [sym_powerset] = ACTIONS(5714),
    [sym_domain] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [sym_negative_dot] = ACTIONS(5712),
    [sym_enabled] = ACTIONS(5714),
    [sym_unchanged] = ACTIONS(5714),
    [anon_sym_LT_GT] = ACTIONS(5712),
    [anon_sym_u22c4] = ACTIONS(5712),
    [anon_sym_u25c7] = ACTIONS(5712),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5714),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [anon_sym_ASSUME] = ACTIONS(5714),
    [anon_sym_ASSUMPTION] = ACTIONS(5714),
    [anon_sym_AXIOM] = ACTIONS(5714),
    [anon_sym_THEOREM] = ACTIONS(5714),
    [anon_sym_PROPOSITION] = ACTIONS(5714),
    [anon_sym_LEMMA] = ACTIONS(5714),
    [anon_sym_COROLLARY] = ACTIONS(5714),
    [anon_sym_USE] = ACTIONS(5714),
    [anon_sym_HIDE] = ACTIONS(5714),
    [anon_sym_DEF] = ACTIONS(5714),
    [anon_sym_DEFS] = ACTIONS(5714),
    [sym__double_excl] = ACTIONS(5712),
  },
  [2370] = {
    [sym_block_comment] = STATE(2370),
    [sym_identifier] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_LOCAL] = ACTIONS(5698),
    [anon_sym_VARIABLE] = ACTIONS(5698),
    [anon_sym_VARIABLES] = ACTIONS(5698),
    [anon_sym_CONSTANT] = ACTIONS(5698),
    [anon_sym_CONSTANTS] = ACTIONS(5698),
    [anon_sym_RECURSIVE] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_INSTANCE] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_Nat] = ACTIONS(5698),
    [anon_sym_u2115] = ACTIONS(5696),
    [anon_sym_Int] = ACTIONS(5698),
    [anon_sym_u2124] = ACTIONS(5696),
    [anon_sym_Real] = ACTIONS(5698),
    [anon_sym_u211d] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_BSLASHlnot] = ACTIONS(5696),
    [anon_sym_BSLASHneg] = ACTIONS(5696),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_u00ac] = ACTIONS(5696),
    [sym_union] = ACTIONS(5698),
    [sym_powerset] = ACTIONS(5698),
    [sym_domain] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [sym_negative_dot] = ACTIONS(5696),
    [sym_enabled] = ACTIONS(5698),
    [sym_unchanged] = ACTIONS(5698),
    [anon_sym_LT_GT] = ACTIONS(5696),
    [anon_sym_u22c4] = ACTIONS(5696),
    [anon_sym_u25c7] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5698),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [anon_sym_ASSUME] = ACTIONS(5698),
    [anon_sym_ASSUMPTION] = ACTIONS(5698),
    [anon_sym_AXIOM] = ACTIONS(5698),
    [anon_sym_THEOREM] = ACTIONS(5698),
    [anon_sym_PROPOSITION] = ACTIONS(5698),
    [anon_sym_LEMMA] = ACTIONS(5698),
    [anon_sym_COROLLARY] = ACTIONS(5698),
    [anon_sym_USE] = ACTIONS(5698),
    [anon_sym_HIDE] = ACTIONS(5698),
    [anon_sym_DEF] = ACTIONS(5698),
    [anon_sym_DEFS] = ACTIONS(5698),
    [sym__double_excl] = ACTIONS(5696),
  },
  [2371] = {
    [sym_block_comment] = STATE(2371),
    [sym_identifier] = ACTIONS(5702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5700),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_COMMA] = ACTIONS(5700),
    [anon_sym_LOCAL] = ACTIONS(5702),
    [anon_sym_VARIABLE] = ACTIONS(5702),
    [anon_sym_VARIABLES] = ACTIONS(5702),
    [anon_sym_CONSTANT] = ACTIONS(5702),
    [anon_sym_CONSTANTS] = ACTIONS(5702),
    [anon_sym_RECURSIVE] = ACTIONS(5702),
    [anon_sym_LPAREN] = ACTIONS(5866),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_INSTANCE] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_Nat] = ACTIONS(5702),
    [anon_sym_u2115] = ACTIONS(5700),
    [anon_sym_Int] = ACTIONS(5702),
    [anon_sym_u2124] = ACTIONS(5700),
    [anon_sym_Real] = ACTIONS(5702),
    [anon_sym_u211d] = ACTIONS(5700),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_BSLASHlnot] = ACTIONS(5700),
    [anon_sym_BSLASHneg] = ACTIONS(5700),
    [anon_sym_TILDE] = ACTIONS(5702),
    [anon_sym_u00ac] = ACTIONS(5700),
    [sym_union] = ACTIONS(5702),
    [sym_powerset] = ACTIONS(5702),
    [sym_domain] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [sym_negative_dot] = ACTIONS(5700),
    [sym_enabled] = ACTIONS(5702),
    [sym_unchanged] = ACTIONS(5702),
    [anon_sym_LT_GT] = ACTIONS(5700),
    [anon_sym_u22c4] = ACTIONS(5700),
    [anon_sym_u25c7] = ACTIONS(5700),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5702),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [anon_sym_ASSUME] = ACTIONS(5702),
    [anon_sym_ASSUMPTION] = ACTIONS(5702),
    [anon_sym_AXIOM] = ACTIONS(5702),
    [anon_sym_THEOREM] = ACTIONS(5702),
    [anon_sym_PROPOSITION] = ACTIONS(5702),
    [anon_sym_LEMMA] = ACTIONS(5702),
    [anon_sym_COROLLARY] = ACTIONS(5702),
    [anon_sym_USE] = ACTIONS(5702),
    [anon_sym_HIDE] = ACTIONS(5702),
    [anon_sym_DEF] = ACTIONS(5702),
    [anon_sym_DEFS] = ACTIONS(5702),
    [sym__double_excl] = ACTIONS(5700),
  },
  [2372] = {
    [sym_block_comment] = STATE(2372),
    [ts_builtin_sym_end] = ACTIONS(5704),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5704),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LOCAL] = ACTIONS(5706),
    [anon_sym_VARIABLE] = ACTIONS(5706),
    [anon_sym_VARIABLES] = ACTIONS(5706),
    [anon_sym_CONSTANT] = ACTIONS(5706),
    [anon_sym_CONSTANTS] = ACTIONS(5706),
    [anon_sym_RECURSIVE] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_INSTANCE] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5706),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_ASSUME] = ACTIONS(5706),
    [anon_sym_ASSUMPTION] = ACTIONS(5706),
    [anon_sym_AXIOM] = ACTIONS(5706),
    [anon_sym_THEOREM] = ACTIONS(5706),
    [anon_sym_PROPOSITION] = ACTIONS(5706),
    [anon_sym_LEMMA] = ACTIONS(5706),
    [anon_sym_COROLLARY] = ACTIONS(5706),
    [anon_sym_USE] = ACTIONS(5706),
    [anon_sym_HIDE] = ACTIONS(5706),
    [anon_sym_DEF] = ACTIONS(5706),
    [anon_sym_DEFS] = ACTIONS(5706),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2373] = {
    [sym_block_comment] = STATE(2373),
    [ts_builtin_sym_end] = ACTIONS(5722),
    [sym_identifier] = ACTIONS(5720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5722),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_LOCAL] = ACTIONS(5720),
    [anon_sym_VARIABLE] = ACTIONS(5720),
    [anon_sym_VARIABLES] = ACTIONS(5720),
    [anon_sym_CONSTANT] = ACTIONS(5720),
    [anon_sym_CONSTANTS] = ACTIONS(5720),
    [anon_sym_RECURSIVE] = ACTIONS(5720),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_INSTANCE] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_Nat] = ACTIONS(5720),
    [anon_sym_u2115] = ACTIONS(5722),
    [anon_sym_Int] = ACTIONS(5720),
    [anon_sym_u2124] = ACTIONS(5722),
    [anon_sym_Real] = ACTIONS(5720),
    [anon_sym_u211d] = ACTIONS(5722),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_BSLASHlnot] = ACTIONS(5722),
    [anon_sym_BSLASHneg] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5720),
    [anon_sym_u00ac] = ACTIONS(5722),
    [sym_union] = ACTIONS(5720),
    [sym_powerset] = ACTIONS(5720),
    [sym_domain] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [sym_negative_dot] = ACTIONS(5722),
    [sym_enabled] = ACTIONS(5720),
    [sym_unchanged] = ACTIONS(5720),
    [anon_sym_LT_GT] = ACTIONS(5722),
    [anon_sym_u22c4] = ACTIONS(5722),
    [anon_sym_u25c7] = ACTIONS(5722),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5720),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [anon_sym_ASSUME] = ACTIONS(5720),
    [anon_sym_ASSUMPTION] = ACTIONS(5720),
    [anon_sym_AXIOM] = ACTIONS(5720),
    [anon_sym_THEOREM] = ACTIONS(5720),
    [anon_sym_PROPOSITION] = ACTIONS(5720),
    [anon_sym_LEMMA] = ACTIONS(5720),
    [anon_sym_COROLLARY] = ACTIONS(5720),
    [anon_sym_USE] = ACTIONS(5720),
    [anon_sym_HIDE] = ACTIONS(5720),
    [anon_sym_DEF] = ACTIONS(5720),
    [anon_sym_DEFS] = ACTIONS(5720),
    [sym__double_excl] = ACTIONS(5722),
  },
  [2374] = {
    [sym_block_comment] = STATE(2374),
    [sym_identifier] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5716),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_COMMA] = ACTIONS(5716),
    [anon_sym_LOCAL] = ACTIONS(5718),
    [anon_sym_VARIABLE] = ACTIONS(5718),
    [anon_sym_VARIABLES] = ACTIONS(5718),
    [anon_sym_CONSTANT] = ACTIONS(5718),
    [anon_sym_CONSTANTS] = ACTIONS(5718),
    [anon_sym_RECURSIVE] = ACTIONS(5718),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_INSTANCE] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_Nat] = ACTIONS(5718),
    [anon_sym_u2115] = ACTIONS(5716),
    [anon_sym_Int] = ACTIONS(5718),
    [anon_sym_u2124] = ACTIONS(5716),
    [anon_sym_Real] = ACTIONS(5718),
    [anon_sym_u211d] = ACTIONS(5716),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_BSLASHlnot] = ACTIONS(5716),
    [anon_sym_BSLASHneg] = ACTIONS(5716),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_u00ac] = ACTIONS(5716),
    [sym_union] = ACTIONS(5718),
    [sym_powerset] = ACTIONS(5718),
    [sym_domain] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [sym_negative_dot] = ACTIONS(5716),
    [sym_enabled] = ACTIONS(5718),
    [sym_unchanged] = ACTIONS(5718),
    [anon_sym_LT_GT] = ACTIONS(5716),
    [anon_sym_u22c4] = ACTIONS(5716),
    [anon_sym_u25c7] = ACTIONS(5716),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5718),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [anon_sym_ASSUME] = ACTIONS(5718),
    [anon_sym_ASSUMPTION] = ACTIONS(5718),
    [anon_sym_AXIOM] = ACTIONS(5718),
    [anon_sym_THEOREM] = ACTIONS(5718),
    [anon_sym_PROPOSITION] = ACTIONS(5718),
    [anon_sym_LEMMA] = ACTIONS(5718),
    [anon_sym_COROLLARY] = ACTIONS(5718),
    [anon_sym_USE] = ACTIONS(5718),
    [anon_sym_HIDE] = ACTIONS(5718),
    [anon_sym_DEF] = ACTIONS(5718),
    [anon_sym_DEFS] = ACTIONS(5718),
    [sym__double_excl] = ACTIONS(5716),
  },
  [2375] = {
    [sym_block_comment] = STATE(2375),
    [ts_builtin_sym_end] = ACTIONS(5708),
    [sym_identifier] = ACTIONS(5710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5708),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_COMMA] = ACTIONS(5708),
    [anon_sym_LOCAL] = ACTIONS(5710),
    [anon_sym_VARIABLE] = ACTIONS(5710),
    [anon_sym_VARIABLES] = ACTIONS(5710),
    [anon_sym_CONSTANT] = ACTIONS(5710),
    [anon_sym_CONSTANTS] = ACTIONS(5710),
    [anon_sym_RECURSIVE] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_INSTANCE] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_Nat] = ACTIONS(5710),
    [anon_sym_u2115] = ACTIONS(5708),
    [anon_sym_Int] = ACTIONS(5710),
    [anon_sym_u2124] = ACTIONS(5708),
    [anon_sym_Real] = ACTIONS(5710),
    [anon_sym_u211d] = ACTIONS(5708),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_BSLASHlnot] = ACTIONS(5708),
    [anon_sym_BSLASHneg] = ACTIONS(5708),
    [anon_sym_TILDE] = ACTIONS(5710),
    [anon_sym_u00ac] = ACTIONS(5708),
    [sym_union] = ACTIONS(5710),
    [sym_powerset] = ACTIONS(5710),
    [sym_domain] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [sym_negative_dot] = ACTIONS(5708),
    [sym_enabled] = ACTIONS(5710),
    [sym_unchanged] = ACTIONS(5710),
    [anon_sym_LT_GT] = ACTIONS(5708),
    [anon_sym_u22c4] = ACTIONS(5708),
    [anon_sym_u25c7] = ACTIONS(5708),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5710),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [anon_sym_ASSUME] = ACTIONS(5710),
    [anon_sym_ASSUMPTION] = ACTIONS(5710),
    [anon_sym_AXIOM] = ACTIONS(5710),
    [anon_sym_THEOREM] = ACTIONS(5710),
    [anon_sym_PROPOSITION] = ACTIONS(5710),
    [anon_sym_LEMMA] = ACTIONS(5710),
    [anon_sym_COROLLARY] = ACTIONS(5710),
    [anon_sym_USE] = ACTIONS(5710),
    [anon_sym_HIDE] = ACTIONS(5710),
    [anon_sym_DEF] = ACTIONS(5710),
    [anon_sym_DEFS] = ACTIONS(5710),
    [sym__double_excl] = ACTIONS(5708),
  },
  [2376] = {
    [sym_block_comment] = STATE(2376),
    [ts_builtin_sym_end] = ACTIONS(5712),
    [sym_identifier] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5712),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_LOCAL] = ACTIONS(5714),
    [anon_sym_VARIABLE] = ACTIONS(5714),
    [anon_sym_VARIABLES] = ACTIONS(5714),
    [anon_sym_CONSTANT] = ACTIONS(5714),
    [anon_sym_CONSTANTS] = ACTIONS(5714),
    [anon_sym_RECURSIVE] = ACTIONS(5714),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_INSTANCE] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_Nat] = ACTIONS(5714),
    [anon_sym_u2115] = ACTIONS(5712),
    [anon_sym_Int] = ACTIONS(5714),
    [anon_sym_u2124] = ACTIONS(5712),
    [anon_sym_Real] = ACTIONS(5714),
    [anon_sym_u211d] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_BSLASHlnot] = ACTIONS(5712),
    [anon_sym_BSLASHneg] = ACTIONS(5712),
    [anon_sym_TILDE] = ACTIONS(5714),
    [anon_sym_u00ac] = ACTIONS(5712),
    [sym_union] = ACTIONS(5714),
    [sym_powerset] = ACTIONS(5714),
    [sym_domain] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [sym_negative_dot] = ACTIONS(5712),
    [sym_enabled] = ACTIONS(5714),
    [sym_unchanged] = ACTIONS(5714),
    [anon_sym_LT_GT] = ACTIONS(5712),
    [anon_sym_u22c4] = ACTIONS(5712),
    [anon_sym_u25c7] = ACTIONS(5712),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5714),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [anon_sym_ASSUME] = ACTIONS(5714),
    [anon_sym_ASSUMPTION] = ACTIONS(5714),
    [anon_sym_AXIOM] = ACTIONS(5714),
    [anon_sym_THEOREM] = ACTIONS(5714),
    [anon_sym_PROPOSITION] = ACTIONS(5714),
    [anon_sym_LEMMA] = ACTIONS(5714),
    [anon_sym_COROLLARY] = ACTIONS(5714),
    [anon_sym_USE] = ACTIONS(5714),
    [anon_sym_HIDE] = ACTIONS(5714),
    [anon_sym_DEF] = ACTIONS(5714),
    [anon_sym_DEFS] = ACTIONS(5714),
    [sym__double_excl] = ACTIONS(5712),
  },
  [2377] = {
    [sym_block_comment] = STATE(2377),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5690),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LOCAL] = ACTIONS(5688),
    [anon_sym_VARIABLE] = ACTIONS(5688),
    [anon_sym_VARIABLES] = ACTIONS(5688),
    [anon_sym_CONSTANT] = ACTIONS(5688),
    [anon_sym_CONSTANTS] = ACTIONS(5688),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5688),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_ASSUME] = ACTIONS(5688),
    [anon_sym_ASSUMPTION] = ACTIONS(5688),
    [anon_sym_AXIOM] = ACTIONS(5688),
    [anon_sym_THEOREM] = ACTIONS(5688),
    [anon_sym_PROPOSITION] = ACTIONS(5688),
    [anon_sym_LEMMA] = ACTIONS(5688),
    [anon_sym_COROLLARY] = ACTIONS(5688),
    [anon_sym_USE] = ACTIONS(5688),
    [anon_sym_HIDE] = ACTIONS(5688),
    [anon_sym_DEF] = ACTIONS(5688),
    [anon_sym_DEFS] = ACTIONS(5688),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2378] = {
    [sym_block_comment] = STATE(2378),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5690),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LOCAL] = ACTIONS(5688),
    [anon_sym_VARIABLE] = ACTIONS(5688),
    [anon_sym_VARIABLES] = ACTIONS(5688),
    [anon_sym_CONSTANT] = ACTIONS(5688),
    [anon_sym_CONSTANTS] = ACTIONS(5688),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5688),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_ASSUME] = ACTIONS(5688),
    [anon_sym_ASSUMPTION] = ACTIONS(5688),
    [anon_sym_AXIOM] = ACTIONS(5688),
    [anon_sym_THEOREM] = ACTIONS(5688),
    [anon_sym_PROPOSITION] = ACTIONS(5688),
    [anon_sym_LEMMA] = ACTIONS(5688),
    [anon_sym_COROLLARY] = ACTIONS(5688),
    [anon_sym_USE] = ACTIONS(5688),
    [anon_sym_HIDE] = ACTIONS(5688),
    [anon_sym_DEF] = ACTIONS(5688),
    [anon_sym_DEFS] = ACTIONS(5688),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2379] = {
    [sym_block_comment] = STATE(2379),
    [ts_builtin_sym_end] = ACTIONS(5716),
    [sym_identifier] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5716),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_COMMA] = ACTIONS(5716),
    [anon_sym_LOCAL] = ACTIONS(5718),
    [anon_sym_VARIABLE] = ACTIONS(5718),
    [anon_sym_VARIABLES] = ACTIONS(5718),
    [anon_sym_CONSTANT] = ACTIONS(5718),
    [anon_sym_CONSTANTS] = ACTIONS(5718),
    [anon_sym_RECURSIVE] = ACTIONS(5718),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_INSTANCE] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_Nat] = ACTIONS(5718),
    [anon_sym_u2115] = ACTIONS(5716),
    [anon_sym_Int] = ACTIONS(5718),
    [anon_sym_u2124] = ACTIONS(5716),
    [anon_sym_Real] = ACTIONS(5718),
    [anon_sym_u211d] = ACTIONS(5716),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_BSLASHlnot] = ACTIONS(5716),
    [anon_sym_BSLASHneg] = ACTIONS(5716),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_u00ac] = ACTIONS(5716),
    [sym_union] = ACTIONS(5718),
    [sym_powerset] = ACTIONS(5718),
    [sym_domain] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [sym_negative_dot] = ACTIONS(5716),
    [sym_enabled] = ACTIONS(5718),
    [sym_unchanged] = ACTIONS(5718),
    [anon_sym_LT_GT] = ACTIONS(5716),
    [anon_sym_u22c4] = ACTIONS(5716),
    [anon_sym_u25c7] = ACTIONS(5716),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5718),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [anon_sym_ASSUME] = ACTIONS(5718),
    [anon_sym_ASSUMPTION] = ACTIONS(5718),
    [anon_sym_AXIOM] = ACTIONS(5718),
    [anon_sym_THEOREM] = ACTIONS(5718),
    [anon_sym_PROPOSITION] = ACTIONS(5718),
    [anon_sym_LEMMA] = ACTIONS(5718),
    [anon_sym_COROLLARY] = ACTIONS(5718),
    [anon_sym_USE] = ACTIONS(5718),
    [anon_sym_HIDE] = ACTIONS(5718),
    [anon_sym_DEF] = ACTIONS(5718),
    [anon_sym_DEFS] = ACTIONS(5718),
    [sym__double_excl] = ACTIONS(5716),
  },
  [2380] = {
    [sym_block_comment] = STATE(2380),
    [ts_builtin_sym_end] = ACTIONS(5700),
    [sym_identifier] = ACTIONS(5702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5700),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_COMMA] = ACTIONS(5700),
    [anon_sym_LOCAL] = ACTIONS(5702),
    [anon_sym_VARIABLE] = ACTIONS(5702),
    [anon_sym_VARIABLES] = ACTIONS(5702),
    [anon_sym_CONSTANT] = ACTIONS(5702),
    [anon_sym_CONSTANTS] = ACTIONS(5702),
    [anon_sym_RECURSIVE] = ACTIONS(5702),
    [anon_sym_LPAREN] = ACTIONS(5776),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_INSTANCE] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_Nat] = ACTIONS(5702),
    [anon_sym_u2115] = ACTIONS(5700),
    [anon_sym_Int] = ACTIONS(5702),
    [anon_sym_u2124] = ACTIONS(5700),
    [anon_sym_Real] = ACTIONS(5702),
    [anon_sym_u211d] = ACTIONS(5700),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_BSLASHlnot] = ACTIONS(5700),
    [anon_sym_BSLASHneg] = ACTIONS(5700),
    [anon_sym_TILDE] = ACTIONS(5702),
    [anon_sym_u00ac] = ACTIONS(5700),
    [sym_union] = ACTIONS(5702),
    [sym_powerset] = ACTIONS(5702),
    [sym_domain] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [sym_negative_dot] = ACTIONS(5700),
    [sym_enabled] = ACTIONS(5702),
    [sym_unchanged] = ACTIONS(5702),
    [anon_sym_LT_GT] = ACTIONS(5700),
    [anon_sym_u22c4] = ACTIONS(5700),
    [anon_sym_u25c7] = ACTIONS(5700),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5702),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [anon_sym_ASSUME] = ACTIONS(5702),
    [anon_sym_ASSUMPTION] = ACTIONS(5702),
    [anon_sym_AXIOM] = ACTIONS(5702),
    [anon_sym_THEOREM] = ACTIONS(5702),
    [anon_sym_PROPOSITION] = ACTIONS(5702),
    [anon_sym_LEMMA] = ACTIONS(5702),
    [anon_sym_COROLLARY] = ACTIONS(5702),
    [anon_sym_USE] = ACTIONS(5702),
    [anon_sym_HIDE] = ACTIONS(5702),
    [anon_sym_DEF] = ACTIONS(5702),
    [anon_sym_DEFS] = ACTIONS(5702),
    [sym__double_excl] = ACTIONS(5700),
  },
  [2381] = {
    [sym_block_comment] = STATE(2381),
    [sym_identifier] = ACTIONS(5720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5722),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_LOCAL] = ACTIONS(5720),
    [anon_sym_VARIABLE] = ACTIONS(5720),
    [anon_sym_VARIABLES] = ACTIONS(5720),
    [anon_sym_CONSTANT] = ACTIONS(5720),
    [anon_sym_CONSTANTS] = ACTIONS(5720),
    [anon_sym_RECURSIVE] = ACTIONS(5720),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_INSTANCE] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_Nat] = ACTIONS(5720),
    [anon_sym_u2115] = ACTIONS(5722),
    [anon_sym_Int] = ACTIONS(5720),
    [anon_sym_u2124] = ACTIONS(5722),
    [anon_sym_Real] = ACTIONS(5720),
    [anon_sym_u211d] = ACTIONS(5722),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_BSLASHlnot] = ACTIONS(5722),
    [anon_sym_BSLASHneg] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5720),
    [anon_sym_u00ac] = ACTIONS(5722),
    [sym_union] = ACTIONS(5720),
    [sym_powerset] = ACTIONS(5720),
    [sym_domain] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [sym_negative_dot] = ACTIONS(5722),
    [sym_enabled] = ACTIONS(5720),
    [sym_unchanged] = ACTIONS(5720),
    [anon_sym_LT_GT] = ACTIONS(5722),
    [anon_sym_u22c4] = ACTIONS(5722),
    [anon_sym_u25c7] = ACTIONS(5722),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5720),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [anon_sym_ASSUME] = ACTIONS(5720),
    [anon_sym_ASSUMPTION] = ACTIONS(5720),
    [anon_sym_AXIOM] = ACTIONS(5720),
    [anon_sym_THEOREM] = ACTIONS(5720),
    [anon_sym_PROPOSITION] = ACTIONS(5720),
    [anon_sym_LEMMA] = ACTIONS(5720),
    [anon_sym_COROLLARY] = ACTIONS(5720),
    [anon_sym_USE] = ACTIONS(5720),
    [anon_sym_HIDE] = ACTIONS(5720),
    [anon_sym_DEF] = ACTIONS(5720),
    [anon_sym_DEFS] = ACTIONS(5720),
    [sym__double_excl] = ACTIONS(5722),
  },
  [2382] = {
    [sym_block_comment] = STATE(2382),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [sym_identifier] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5696),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_LOCAL] = ACTIONS(5698),
    [anon_sym_VARIABLE] = ACTIONS(5698),
    [anon_sym_VARIABLES] = ACTIONS(5698),
    [anon_sym_CONSTANT] = ACTIONS(5698),
    [anon_sym_CONSTANTS] = ACTIONS(5698),
    [anon_sym_RECURSIVE] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_INSTANCE] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_Nat] = ACTIONS(5698),
    [anon_sym_u2115] = ACTIONS(5696),
    [anon_sym_Int] = ACTIONS(5698),
    [anon_sym_u2124] = ACTIONS(5696),
    [anon_sym_Real] = ACTIONS(5698),
    [anon_sym_u211d] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_BSLASHlnot] = ACTIONS(5696),
    [anon_sym_BSLASHneg] = ACTIONS(5696),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_u00ac] = ACTIONS(5696),
    [sym_union] = ACTIONS(5698),
    [sym_powerset] = ACTIONS(5698),
    [sym_domain] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [sym_negative_dot] = ACTIONS(5696),
    [sym_enabled] = ACTIONS(5698),
    [sym_unchanged] = ACTIONS(5698),
    [anon_sym_LT_GT] = ACTIONS(5696),
    [anon_sym_u22c4] = ACTIONS(5696),
    [anon_sym_u25c7] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5698),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [anon_sym_ASSUME] = ACTIONS(5698),
    [anon_sym_ASSUMPTION] = ACTIONS(5698),
    [anon_sym_AXIOM] = ACTIONS(5698),
    [anon_sym_THEOREM] = ACTIONS(5698),
    [anon_sym_PROPOSITION] = ACTIONS(5698),
    [anon_sym_LEMMA] = ACTIONS(5698),
    [anon_sym_COROLLARY] = ACTIONS(5698),
    [anon_sym_USE] = ACTIONS(5698),
    [anon_sym_HIDE] = ACTIONS(5698),
    [anon_sym_DEF] = ACTIONS(5698),
    [anon_sym_DEFS] = ACTIONS(5698),
    [sym__double_excl] = ACTIONS(5696),
  },
  [2383] = {
    [sym_block_comment] = STATE(2383),
    [ts_builtin_sym_end] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5690),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LOCAL] = ACTIONS(5688),
    [anon_sym_VARIABLE] = ACTIONS(5688),
    [anon_sym_VARIABLES] = ACTIONS(5688),
    [anon_sym_CONSTANT] = ACTIONS(5688),
    [anon_sym_CONSTANTS] = ACTIONS(5688),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5688),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_ASSUME] = ACTIONS(5688),
    [anon_sym_ASSUMPTION] = ACTIONS(5688),
    [anon_sym_AXIOM] = ACTIONS(5688),
    [anon_sym_THEOREM] = ACTIONS(5688),
    [anon_sym_PROPOSITION] = ACTIONS(5688),
    [anon_sym_LEMMA] = ACTIONS(5688),
    [anon_sym_COROLLARY] = ACTIONS(5688),
    [anon_sym_USE] = ACTIONS(5688),
    [anon_sym_HIDE] = ACTIONS(5688),
    [anon_sym_DEF] = ACTIONS(5688),
    [anon_sym_DEFS] = ACTIONS(5688),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2384] = {
    [sym_block_comment] = STATE(2384),
    [ts_builtin_sym_end] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5690),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LOCAL] = ACTIONS(5688),
    [anon_sym_VARIABLE] = ACTIONS(5688),
    [anon_sym_VARIABLES] = ACTIONS(5688),
    [anon_sym_CONSTANT] = ACTIONS(5688),
    [anon_sym_CONSTANTS] = ACTIONS(5688),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5688),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_ASSUME] = ACTIONS(5688),
    [anon_sym_ASSUMPTION] = ACTIONS(5688),
    [anon_sym_AXIOM] = ACTIONS(5688),
    [anon_sym_THEOREM] = ACTIONS(5688),
    [anon_sym_PROPOSITION] = ACTIONS(5688),
    [anon_sym_LEMMA] = ACTIONS(5688),
    [anon_sym_COROLLARY] = ACTIONS(5688),
    [anon_sym_USE] = ACTIONS(5688),
    [anon_sym_HIDE] = ACTIONS(5688),
    [anon_sym_DEF] = ACTIONS(5688),
    [anon_sym_DEFS] = ACTIONS(5688),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2385] = {
    [sym_block_comment] = STATE(2385),
    [sym_identifier] = ACTIONS(5710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5708),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_COMMA] = ACTIONS(5708),
    [anon_sym_LOCAL] = ACTIONS(5710),
    [anon_sym_VARIABLE] = ACTIONS(5710),
    [anon_sym_VARIABLES] = ACTIONS(5710),
    [anon_sym_CONSTANT] = ACTIONS(5710),
    [anon_sym_CONSTANTS] = ACTIONS(5710),
    [anon_sym_RECURSIVE] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_INSTANCE] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_Nat] = ACTIONS(5710),
    [anon_sym_u2115] = ACTIONS(5708),
    [anon_sym_Int] = ACTIONS(5710),
    [anon_sym_u2124] = ACTIONS(5708),
    [anon_sym_Real] = ACTIONS(5710),
    [anon_sym_u211d] = ACTIONS(5708),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_BSLASHlnot] = ACTIONS(5708),
    [anon_sym_BSLASHneg] = ACTIONS(5708),
    [anon_sym_TILDE] = ACTIONS(5710),
    [anon_sym_u00ac] = ACTIONS(5708),
    [sym_union] = ACTIONS(5710),
    [sym_powerset] = ACTIONS(5710),
    [sym_domain] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [sym_negative_dot] = ACTIONS(5708),
    [sym_enabled] = ACTIONS(5710),
    [sym_unchanged] = ACTIONS(5710),
    [anon_sym_LT_GT] = ACTIONS(5708),
    [anon_sym_u22c4] = ACTIONS(5708),
    [anon_sym_u25c7] = ACTIONS(5708),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5710),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [anon_sym_ASSUME] = ACTIONS(5710),
    [anon_sym_ASSUMPTION] = ACTIONS(5710),
    [anon_sym_AXIOM] = ACTIONS(5710),
    [anon_sym_THEOREM] = ACTIONS(5710),
    [anon_sym_PROPOSITION] = ACTIONS(5710),
    [anon_sym_LEMMA] = ACTIONS(5710),
    [anon_sym_COROLLARY] = ACTIONS(5710),
    [anon_sym_USE] = ACTIONS(5710),
    [anon_sym_HIDE] = ACTIONS(5710),
    [anon_sym_DEF] = ACTIONS(5710),
    [anon_sym_DEFS] = ACTIONS(5710),
    [sym__double_excl] = ACTIONS(5708),
  },
  [2386] = {
    [sym_block_comment] = STATE(2386),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5704),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LOCAL] = ACTIONS(5706),
    [anon_sym_VARIABLE] = ACTIONS(5706),
    [anon_sym_VARIABLES] = ACTIONS(5706),
    [anon_sym_CONSTANT] = ACTIONS(5706),
    [anon_sym_CONSTANTS] = ACTIONS(5706),
    [anon_sym_RECURSIVE] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_INSTANCE] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5706),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_ASSUME] = ACTIONS(5706),
    [anon_sym_ASSUMPTION] = ACTIONS(5706),
    [anon_sym_AXIOM] = ACTIONS(5706),
    [anon_sym_THEOREM] = ACTIONS(5706),
    [anon_sym_PROPOSITION] = ACTIONS(5706),
    [anon_sym_LEMMA] = ACTIONS(5706),
    [anon_sym_COROLLARY] = ACTIONS(5706),
    [anon_sym_USE] = ACTIONS(5706),
    [anon_sym_HIDE] = ACTIONS(5706),
    [anon_sym_DEF] = ACTIONS(5706),
    [anon_sym_DEFS] = ACTIONS(5706),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2387] = {
    [sym_block_comment] = STATE(2387),
    [sym_identifier] = ACTIONS(5924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5926),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_LOCAL] = ACTIONS(5924),
    [anon_sym_VARIABLE] = ACTIONS(5924),
    [anon_sym_VARIABLES] = ACTIONS(5924),
    [anon_sym_CONSTANT] = ACTIONS(5924),
    [anon_sym_CONSTANTS] = ACTIONS(5924),
    [anon_sym_RECURSIVE] = ACTIONS(5924),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_INSTANCE] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_Nat] = ACTIONS(5924),
    [anon_sym_u2115] = ACTIONS(5926),
    [anon_sym_Int] = ACTIONS(5924),
    [anon_sym_u2124] = ACTIONS(5926),
    [anon_sym_Real] = ACTIONS(5924),
    [anon_sym_u211d] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_BSLASHlnot] = ACTIONS(5926),
    [anon_sym_BSLASHneg] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5924),
    [anon_sym_u00ac] = ACTIONS(5926),
    [sym_union] = ACTIONS(5924),
    [sym_powerset] = ACTIONS(5924),
    [sym_domain] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [sym_negative_dot] = ACTIONS(5926),
    [sym_enabled] = ACTIONS(5924),
    [sym_unchanged] = ACTIONS(5924),
    [anon_sym_LT_GT] = ACTIONS(5926),
    [anon_sym_u22c4] = ACTIONS(5926),
    [anon_sym_u25c7] = ACTIONS(5926),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5924),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [anon_sym_ASSUME] = ACTIONS(5924),
    [anon_sym_ASSUMPTION] = ACTIONS(5924),
    [anon_sym_AXIOM] = ACTIONS(5924),
    [anon_sym_THEOREM] = ACTIONS(5924),
    [anon_sym_PROPOSITION] = ACTIONS(5924),
    [anon_sym_LEMMA] = ACTIONS(5924),
    [anon_sym_COROLLARY] = ACTIONS(5924),
    [anon_sym_USE] = ACTIONS(5924),
    [anon_sym_HIDE] = ACTIONS(5924),
    [anon_sym_DEF] = ACTIONS(5924),
    [anon_sym_DEFS] = ACTIONS(5924),
    [sym__double_excl] = ACTIONS(5926),
  },
  [2388] = {
    [sym_block_comment] = STATE(2388),
    [ts_builtin_sym_end] = ACTIONS(5900),
    [sym_identifier] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5900),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_COMMA] = ACTIONS(5900),
    [anon_sym_LOCAL] = ACTIONS(5902),
    [anon_sym_VARIABLE] = ACTIONS(5902),
    [anon_sym_VARIABLES] = ACTIONS(5902),
    [anon_sym_CONSTANT] = ACTIONS(5902),
    [anon_sym_CONSTANTS] = ACTIONS(5902),
    [anon_sym_RECURSIVE] = ACTIONS(5902),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_INSTANCE] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_Nat] = ACTIONS(5902),
    [anon_sym_u2115] = ACTIONS(5900),
    [anon_sym_Int] = ACTIONS(5902),
    [anon_sym_u2124] = ACTIONS(5900),
    [anon_sym_Real] = ACTIONS(5902),
    [anon_sym_u211d] = ACTIONS(5900),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_BSLASHlnot] = ACTIONS(5900),
    [anon_sym_BSLASHneg] = ACTIONS(5900),
    [anon_sym_TILDE] = ACTIONS(5902),
    [anon_sym_u00ac] = ACTIONS(5900),
    [sym_union] = ACTIONS(5902),
    [sym_powerset] = ACTIONS(5902),
    [sym_domain] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [sym_negative_dot] = ACTIONS(5900),
    [sym_enabled] = ACTIONS(5902),
    [sym_unchanged] = ACTIONS(5902),
    [anon_sym_LT_GT] = ACTIONS(5900),
    [anon_sym_u22c4] = ACTIONS(5900),
    [anon_sym_u25c7] = ACTIONS(5900),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5902),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [anon_sym_ASSUME] = ACTIONS(5902),
    [anon_sym_ASSUMPTION] = ACTIONS(5902),
    [anon_sym_AXIOM] = ACTIONS(5902),
    [anon_sym_THEOREM] = ACTIONS(5902),
    [anon_sym_PROPOSITION] = ACTIONS(5902),
    [anon_sym_LEMMA] = ACTIONS(5902),
    [anon_sym_COROLLARY] = ACTIONS(5902),
    [anon_sym_USE] = ACTIONS(5902),
    [anon_sym_HIDE] = ACTIONS(5902),
    [anon_sym_DEF] = ACTIONS(5902),
    [anon_sym_DEFS] = ACTIONS(5902),
    [sym__double_excl] = ACTIONS(5900),
  },
  [2389] = {
    [sym_block_comment] = STATE(2389),
    [ts_builtin_sym_end] = ACTIONS(5728),
    [sym_identifier] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5728),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_LOCAL] = ACTIONS(5730),
    [anon_sym_VARIABLE] = ACTIONS(5730),
    [anon_sym_VARIABLES] = ACTIONS(5730),
    [anon_sym_CONSTANT] = ACTIONS(5730),
    [anon_sym_CONSTANTS] = ACTIONS(5730),
    [anon_sym_RECURSIVE] = ACTIONS(5730),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_INSTANCE] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_Nat] = ACTIONS(5730),
    [anon_sym_u2115] = ACTIONS(5728),
    [anon_sym_Int] = ACTIONS(5730),
    [anon_sym_u2124] = ACTIONS(5728),
    [anon_sym_Real] = ACTIONS(5730),
    [anon_sym_u211d] = ACTIONS(5728),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_BSLASHlnot] = ACTIONS(5728),
    [anon_sym_BSLASHneg] = ACTIONS(5728),
    [anon_sym_TILDE] = ACTIONS(5730),
    [anon_sym_u00ac] = ACTIONS(5728),
    [sym_union] = ACTIONS(5730),
    [sym_powerset] = ACTIONS(5730),
    [sym_domain] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [sym_negative_dot] = ACTIONS(5728),
    [sym_enabled] = ACTIONS(5730),
    [sym_unchanged] = ACTIONS(5730),
    [anon_sym_LT_GT] = ACTIONS(5728),
    [anon_sym_u22c4] = ACTIONS(5728),
    [anon_sym_u25c7] = ACTIONS(5728),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5730),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [anon_sym_ASSUME] = ACTIONS(5730),
    [anon_sym_ASSUMPTION] = ACTIONS(5730),
    [anon_sym_AXIOM] = ACTIONS(5730),
    [anon_sym_THEOREM] = ACTIONS(5730),
    [anon_sym_PROPOSITION] = ACTIONS(5730),
    [anon_sym_LEMMA] = ACTIONS(5730),
    [anon_sym_COROLLARY] = ACTIONS(5730),
    [anon_sym_USE] = ACTIONS(5730),
    [anon_sym_HIDE] = ACTIONS(5730),
    [anon_sym_DEF] = ACTIONS(5730),
    [anon_sym_DEFS] = ACTIONS(5730),
    [sym__double_excl] = ACTIONS(5728),
  },
  [2390] = {
    [sym_block_comment] = STATE(2390),
    [ts_builtin_sym_end] = ACTIONS(5786),
    [sym_identifier] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5786),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_LOCAL] = ACTIONS(5788),
    [anon_sym_VARIABLE] = ACTIONS(5788),
    [anon_sym_VARIABLES] = ACTIONS(5788),
    [anon_sym_CONSTANT] = ACTIONS(5788),
    [anon_sym_CONSTANTS] = ACTIONS(5788),
    [anon_sym_RECURSIVE] = ACTIONS(5788),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_INSTANCE] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_Nat] = ACTIONS(5788),
    [anon_sym_u2115] = ACTIONS(5786),
    [anon_sym_Int] = ACTIONS(5788),
    [anon_sym_u2124] = ACTIONS(5786),
    [anon_sym_Real] = ACTIONS(5788),
    [anon_sym_u211d] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_BSLASHlnot] = ACTIONS(5786),
    [anon_sym_BSLASHneg] = ACTIONS(5786),
    [anon_sym_TILDE] = ACTIONS(5788),
    [anon_sym_u00ac] = ACTIONS(5786),
    [sym_union] = ACTIONS(5788),
    [sym_powerset] = ACTIONS(5788),
    [sym_domain] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [sym_negative_dot] = ACTIONS(5786),
    [sym_enabled] = ACTIONS(5788),
    [sym_unchanged] = ACTIONS(5788),
    [anon_sym_LT_GT] = ACTIONS(5786),
    [anon_sym_u22c4] = ACTIONS(5786),
    [anon_sym_u25c7] = ACTIONS(5786),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5788),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [anon_sym_ASSUME] = ACTIONS(5788),
    [anon_sym_ASSUMPTION] = ACTIONS(5788),
    [anon_sym_AXIOM] = ACTIONS(5788),
    [anon_sym_THEOREM] = ACTIONS(5788),
    [anon_sym_PROPOSITION] = ACTIONS(5788),
    [anon_sym_LEMMA] = ACTIONS(5788),
    [anon_sym_COROLLARY] = ACTIONS(5788),
    [anon_sym_USE] = ACTIONS(5788),
    [anon_sym_HIDE] = ACTIONS(5788),
    [anon_sym_DEF] = ACTIONS(5788),
    [anon_sym_DEFS] = ACTIONS(5788),
    [sym__double_excl] = ACTIONS(5786),
  },
  [2391] = {
    [sym_block_comment] = STATE(2391),
    [sym_identifier] = ACTIONS(5774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5772),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_LOCAL] = ACTIONS(5774),
    [anon_sym_VARIABLE] = ACTIONS(5774),
    [anon_sym_VARIABLES] = ACTIONS(5774),
    [anon_sym_CONSTANT] = ACTIONS(5774),
    [anon_sym_CONSTANTS] = ACTIONS(5774),
    [anon_sym_RECURSIVE] = ACTIONS(5774),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_INSTANCE] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_Nat] = ACTIONS(5774),
    [anon_sym_u2115] = ACTIONS(5772),
    [anon_sym_Int] = ACTIONS(5774),
    [anon_sym_u2124] = ACTIONS(5772),
    [anon_sym_Real] = ACTIONS(5774),
    [anon_sym_u211d] = ACTIONS(5772),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_BSLASHlnot] = ACTIONS(5772),
    [anon_sym_BSLASHneg] = ACTIONS(5772),
    [anon_sym_TILDE] = ACTIONS(5774),
    [anon_sym_u00ac] = ACTIONS(5772),
    [sym_union] = ACTIONS(5774),
    [sym_powerset] = ACTIONS(5774),
    [sym_domain] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [sym_negative_dot] = ACTIONS(5772),
    [sym_enabled] = ACTIONS(5774),
    [sym_unchanged] = ACTIONS(5774),
    [anon_sym_LT_GT] = ACTIONS(5772),
    [anon_sym_u22c4] = ACTIONS(5772),
    [anon_sym_u25c7] = ACTIONS(5772),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5774),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [anon_sym_ASSUME] = ACTIONS(5774),
    [anon_sym_ASSUMPTION] = ACTIONS(5774),
    [anon_sym_AXIOM] = ACTIONS(5774),
    [anon_sym_THEOREM] = ACTIONS(5774),
    [anon_sym_PROPOSITION] = ACTIONS(5774),
    [anon_sym_LEMMA] = ACTIONS(5774),
    [anon_sym_COROLLARY] = ACTIONS(5774),
    [anon_sym_USE] = ACTIONS(5774),
    [anon_sym_HIDE] = ACTIONS(5774),
    [anon_sym_DEF] = ACTIONS(5774),
    [anon_sym_DEFS] = ACTIONS(5774),
    [sym__double_excl] = ACTIONS(5772),
  },
  [2392] = {
    [sym_block_comment] = STATE(2392),
    [sym_identifier] = ACTIONS(5808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5806),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_LOCAL] = ACTIONS(5808),
    [anon_sym_VARIABLE] = ACTIONS(5808),
    [anon_sym_VARIABLES] = ACTIONS(5808),
    [anon_sym_CONSTANT] = ACTIONS(5808),
    [anon_sym_CONSTANTS] = ACTIONS(5808),
    [anon_sym_RECURSIVE] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_INSTANCE] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_Nat] = ACTIONS(5808),
    [anon_sym_u2115] = ACTIONS(5806),
    [anon_sym_Int] = ACTIONS(5808),
    [anon_sym_u2124] = ACTIONS(5806),
    [anon_sym_Real] = ACTIONS(5808),
    [anon_sym_u211d] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_BSLASHlnot] = ACTIONS(5806),
    [anon_sym_BSLASHneg] = ACTIONS(5806),
    [anon_sym_TILDE] = ACTIONS(5808),
    [anon_sym_u00ac] = ACTIONS(5806),
    [sym_union] = ACTIONS(5808),
    [sym_powerset] = ACTIONS(5808),
    [sym_domain] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [sym_negative_dot] = ACTIONS(5806),
    [sym_enabled] = ACTIONS(5808),
    [sym_unchanged] = ACTIONS(5808),
    [anon_sym_LT_GT] = ACTIONS(5806),
    [anon_sym_u22c4] = ACTIONS(5806),
    [anon_sym_u25c7] = ACTIONS(5806),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5808),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [anon_sym_ASSUME] = ACTIONS(5808),
    [anon_sym_ASSUMPTION] = ACTIONS(5808),
    [anon_sym_AXIOM] = ACTIONS(5808),
    [anon_sym_THEOREM] = ACTIONS(5808),
    [anon_sym_PROPOSITION] = ACTIONS(5808),
    [anon_sym_LEMMA] = ACTIONS(5808),
    [anon_sym_COROLLARY] = ACTIONS(5808),
    [anon_sym_USE] = ACTIONS(5808),
    [anon_sym_HIDE] = ACTIONS(5808),
    [anon_sym_DEF] = ACTIONS(5808),
    [anon_sym_DEFS] = ACTIONS(5808),
    [sym__double_excl] = ACTIONS(5806),
  },
  [2393] = {
    [sym_block_comment] = STATE(2393),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5704),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LOCAL] = ACTIONS(5706),
    [anon_sym_VARIABLE] = ACTIONS(5706),
    [anon_sym_VARIABLES] = ACTIONS(5706),
    [anon_sym_CONSTANT] = ACTIONS(5706),
    [anon_sym_CONSTANTS] = ACTIONS(5706),
    [anon_sym_RECURSIVE] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_INSTANCE] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5706),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_ASSUME] = ACTIONS(5706),
    [anon_sym_ASSUMPTION] = ACTIONS(5706),
    [anon_sym_AXIOM] = ACTIONS(5706),
    [anon_sym_THEOREM] = ACTIONS(5706),
    [anon_sym_PROPOSITION] = ACTIONS(5706),
    [anon_sym_LEMMA] = ACTIONS(5706),
    [anon_sym_COROLLARY] = ACTIONS(5706),
    [anon_sym_USE] = ACTIONS(5706),
    [anon_sym_HIDE] = ACTIONS(5706),
    [anon_sym_DEF] = ACTIONS(5706),
    [anon_sym_DEFS] = ACTIONS(5706),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2394] = {
    [sym_block_comment] = STATE(2394),
    [sym_identifier] = ACTIONS(5910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5908),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_LOCAL] = ACTIONS(5910),
    [anon_sym_VARIABLE] = ACTIONS(5910),
    [anon_sym_VARIABLES] = ACTIONS(5910),
    [anon_sym_CONSTANT] = ACTIONS(5910),
    [anon_sym_CONSTANTS] = ACTIONS(5910),
    [anon_sym_RECURSIVE] = ACTIONS(5910),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_INSTANCE] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_Nat] = ACTIONS(5910),
    [anon_sym_u2115] = ACTIONS(5908),
    [anon_sym_Int] = ACTIONS(5910),
    [anon_sym_u2124] = ACTIONS(5908),
    [anon_sym_Real] = ACTIONS(5910),
    [anon_sym_u211d] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_BSLASHlnot] = ACTIONS(5908),
    [anon_sym_BSLASHneg] = ACTIONS(5908),
    [anon_sym_TILDE] = ACTIONS(5910),
    [anon_sym_u00ac] = ACTIONS(5908),
    [sym_union] = ACTIONS(5910),
    [sym_powerset] = ACTIONS(5910),
    [sym_domain] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [sym_negative_dot] = ACTIONS(5908),
    [sym_enabled] = ACTIONS(5910),
    [sym_unchanged] = ACTIONS(5910),
    [anon_sym_LT_GT] = ACTIONS(5908),
    [anon_sym_u22c4] = ACTIONS(5908),
    [anon_sym_u25c7] = ACTIONS(5908),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5910),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [anon_sym_ASSUME] = ACTIONS(5910),
    [anon_sym_ASSUMPTION] = ACTIONS(5910),
    [anon_sym_AXIOM] = ACTIONS(5910),
    [anon_sym_THEOREM] = ACTIONS(5910),
    [anon_sym_PROPOSITION] = ACTIONS(5910),
    [anon_sym_LEMMA] = ACTIONS(5910),
    [anon_sym_COROLLARY] = ACTIONS(5910),
    [anon_sym_USE] = ACTIONS(5910),
    [anon_sym_HIDE] = ACTIONS(5910),
    [anon_sym_DEF] = ACTIONS(5910),
    [anon_sym_DEFS] = ACTIONS(5910),
    [sym__double_excl] = ACTIONS(5908),
  },
  [2395] = {
    [sym_block_comment] = STATE(2395),
    [sym_identifier] = ACTIONS(5914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_COMMA] = ACTIONS(5912),
    [anon_sym_LOCAL] = ACTIONS(5914),
    [anon_sym_VARIABLE] = ACTIONS(5914),
    [anon_sym_VARIABLES] = ACTIONS(5914),
    [anon_sym_CONSTANT] = ACTIONS(5914),
    [anon_sym_CONSTANTS] = ACTIONS(5914),
    [anon_sym_RECURSIVE] = ACTIONS(5914),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_INSTANCE] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_Nat] = ACTIONS(5914),
    [anon_sym_u2115] = ACTIONS(5912),
    [anon_sym_Int] = ACTIONS(5914),
    [anon_sym_u2124] = ACTIONS(5912),
    [anon_sym_Real] = ACTIONS(5914),
    [anon_sym_u211d] = ACTIONS(5912),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_BSLASHlnot] = ACTIONS(5912),
    [anon_sym_BSLASHneg] = ACTIONS(5912),
    [anon_sym_TILDE] = ACTIONS(5914),
    [anon_sym_u00ac] = ACTIONS(5912),
    [sym_union] = ACTIONS(5914),
    [sym_powerset] = ACTIONS(5914),
    [sym_domain] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [sym_negative_dot] = ACTIONS(5912),
    [sym_enabled] = ACTIONS(5914),
    [sym_unchanged] = ACTIONS(5914),
    [anon_sym_LT_GT] = ACTIONS(5912),
    [anon_sym_u22c4] = ACTIONS(5912),
    [anon_sym_u25c7] = ACTIONS(5912),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5914),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [anon_sym_ASSUME] = ACTIONS(5914),
    [anon_sym_ASSUMPTION] = ACTIONS(5914),
    [anon_sym_AXIOM] = ACTIONS(5914),
    [anon_sym_THEOREM] = ACTIONS(5914),
    [anon_sym_PROPOSITION] = ACTIONS(5914),
    [anon_sym_LEMMA] = ACTIONS(5914),
    [anon_sym_COROLLARY] = ACTIONS(5914),
    [anon_sym_USE] = ACTIONS(5914),
    [anon_sym_HIDE] = ACTIONS(5914),
    [anon_sym_DEF] = ACTIONS(5914),
    [anon_sym_DEFS] = ACTIONS(5914),
    [sym__double_excl] = ACTIONS(5912),
  },
  [2396] = {
    [sym_block_comment] = STATE(2396),
    [sym_identifier] = ACTIONS(5918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5916),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_LOCAL] = ACTIONS(5918),
    [anon_sym_VARIABLE] = ACTIONS(5918),
    [anon_sym_VARIABLES] = ACTIONS(5918),
    [anon_sym_CONSTANT] = ACTIONS(5918),
    [anon_sym_CONSTANTS] = ACTIONS(5918),
    [anon_sym_RECURSIVE] = ACTIONS(5918),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_INSTANCE] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_Nat] = ACTIONS(5918),
    [anon_sym_u2115] = ACTIONS(5916),
    [anon_sym_Int] = ACTIONS(5918),
    [anon_sym_u2124] = ACTIONS(5916),
    [anon_sym_Real] = ACTIONS(5918),
    [anon_sym_u211d] = ACTIONS(5916),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_BSLASHlnot] = ACTIONS(5916),
    [anon_sym_BSLASHneg] = ACTIONS(5916),
    [anon_sym_TILDE] = ACTIONS(5918),
    [anon_sym_u00ac] = ACTIONS(5916),
    [sym_union] = ACTIONS(5918),
    [sym_powerset] = ACTIONS(5918),
    [sym_domain] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [sym_negative_dot] = ACTIONS(5916),
    [sym_enabled] = ACTIONS(5918),
    [sym_unchanged] = ACTIONS(5918),
    [anon_sym_LT_GT] = ACTIONS(5916),
    [anon_sym_u22c4] = ACTIONS(5916),
    [anon_sym_u25c7] = ACTIONS(5916),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5918),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [anon_sym_ASSUME] = ACTIONS(5918),
    [anon_sym_ASSUMPTION] = ACTIONS(5918),
    [anon_sym_AXIOM] = ACTIONS(5918),
    [anon_sym_THEOREM] = ACTIONS(5918),
    [anon_sym_PROPOSITION] = ACTIONS(5918),
    [anon_sym_LEMMA] = ACTIONS(5918),
    [anon_sym_COROLLARY] = ACTIONS(5918),
    [anon_sym_USE] = ACTIONS(5918),
    [anon_sym_HIDE] = ACTIONS(5918),
    [anon_sym_DEF] = ACTIONS(5918),
    [anon_sym_DEFS] = ACTIONS(5918),
    [sym__double_excl] = ACTIONS(5916),
  },
  [2397] = {
    [sym_block_comment] = STATE(2397),
    [ts_builtin_sym_end] = ACTIONS(5842),
    [sym_identifier] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5842),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_COMMA] = ACTIONS(5842),
    [anon_sym_LOCAL] = ACTIONS(5844),
    [anon_sym_VARIABLE] = ACTIONS(5844),
    [anon_sym_VARIABLES] = ACTIONS(5844),
    [anon_sym_CONSTANT] = ACTIONS(5844),
    [anon_sym_CONSTANTS] = ACTIONS(5844),
    [anon_sym_RECURSIVE] = ACTIONS(5844),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_INSTANCE] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_Nat] = ACTIONS(5844),
    [anon_sym_u2115] = ACTIONS(5842),
    [anon_sym_Int] = ACTIONS(5844),
    [anon_sym_u2124] = ACTIONS(5842),
    [anon_sym_Real] = ACTIONS(5844),
    [anon_sym_u211d] = ACTIONS(5842),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_BSLASHlnot] = ACTIONS(5842),
    [anon_sym_BSLASHneg] = ACTIONS(5842),
    [anon_sym_TILDE] = ACTIONS(5844),
    [anon_sym_u00ac] = ACTIONS(5842),
    [sym_union] = ACTIONS(5844),
    [sym_powerset] = ACTIONS(5844),
    [sym_domain] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [sym_negative_dot] = ACTIONS(5842),
    [sym_enabled] = ACTIONS(5844),
    [sym_unchanged] = ACTIONS(5844),
    [anon_sym_LT_GT] = ACTIONS(5842),
    [anon_sym_u22c4] = ACTIONS(5842),
    [anon_sym_u25c7] = ACTIONS(5842),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5844),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [anon_sym_ASSUME] = ACTIONS(5844),
    [anon_sym_ASSUMPTION] = ACTIONS(5844),
    [anon_sym_AXIOM] = ACTIONS(5844),
    [anon_sym_THEOREM] = ACTIONS(5844),
    [anon_sym_PROPOSITION] = ACTIONS(5844),
    [anon_sym_LEMMA] = ACTIONS(5844),
    [anon_sym_COROLLARY] = ACTIONS(5844),
    [anon_sym_USE] = ACTIONS(5844),
    [anon_sym_HIDE] = ACTIONS(5844),
    [anon_sym_DEF] = ACTIONS(5844),
    [anon_sym_DEFS] = ACTIONS(5844),
    [sym__double_excl] = ACTIONS(5842),
  },
  [2398] = {
    [sym_block_comment] = STATE(2398),
    [sym_identifier] = ACTIONS(5922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5920),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_LOCAL] = ACTIONS(5922),
    [anon_sym_VARIABLE] = ACTIONS(5922),
    [anon_sym_VARIABLES] = ACTIONS(5922),
    [anon_sym_CONSTANT] = ACTIONS(5922),
    [anon_sym_CONSTANTS] = ACTIONS(5922),
    [anon_sym_RECURSIVE] = ACTIONS(5922),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_INSTANCE] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_Nat] = ACTIONS(5922),
    [anon_sym_u2115] = ACTIONS(5920),
    [anon_sym_Int] = ACTIONS(5922),
    [anon_sym_u2124] = ACTIONS(5920),
    [anon_sym_Real] = ACTIONS(5922),
    [anon_sym_u211d] = ACTIONS(5920),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_BSLASHlnot] = ACTIONS(5920),
    [anon_sym_BSLASHneg] = ACTIONS(5920),
    [anon_sym_TILDE] = ACTIONS(5922),
    [anon_sym_u00ac] = ACTIONS(5920),
    [sym_union] = ACTIONS(5922),
    [sym_powerset] = ACTIONS(5922),
    [sym_domain] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [sym_negative_dot] = ACTIONS(5920),
    [sym_enabled] = ACTIONS(5922),
    [sym_unchanged] = ACTIONS(5922),
    [anon_sym_LT_GT] = ACTIONS(5920),
    [anon_sym_u22c4] = ACTIONS(5920),
    [anon_sym_u25c7] = ACTIONS(5920),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5922),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [anon_sym_ASSUME] = ACTIONS(5922),
    [anon_sym_ASSUMPTION] = ACTIONS(5922),
    [anon_sym_AXIOM] = ACTIONS(5922),
    [anon_sym_THEOREM] = ACTIONS(5922),
    [anon_sym_PROPOSITION] = ACTIONS(5922),
    [anon_sym_LEMMA] = ACTIONS(5922),
    [anon_sym_COROLLARY] = ACTIONS(5922),
    [anon_sym_USE] = ACTIONS(5922),
    [anon_sym_HIDE] = ACTIONS(5922),
    [anon_sym_DEF] = ACTIONS(5922),
    [anon_sym_DEFS] = ACTIONS(5922),
    [sym__double_excl] = ACTIONS(5920),
  },
  [2399] = {
    [sym_block_comment] = STATE(2399),
    [sym_identifier] = ACTIONS(5854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_LOCAL] = ACTIONS(5854),
    [anon_sym_VARIABLE] = ACTIONS(5854),
    [anon_sym_VARIABLES] = ACTIONS(5854),
    [anon_sym_CONSTANT] = ACTIONS(5854),
    [anon_sym_CONSTANTS] = ACTIONS(5854),
    [anon_sym_RECURSIVE] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_INSTANCE] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_Nat] = ACTIONS(5854),
    [anon_sym_u2115] = ACTIONS(5856),
    [anon_sym_Int] = ACTIONS(5854),
    [anon_sym_u2124] = ACTIONS(5856),
    [anon_sym_Real] = ACTIONS(5854),
    [anon_sym_u211d] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_BSLASHlnot] = ACTIONS(5856),
    [anon_sym_BSLASHneg] = ACTIONS(5856),
    [anon_sym_TILDE] = ACTIONS(5854),
    [anon_sym_u00ac] = ACTIONS(5856),
    [sym_union] = ACTIONS(5854),
    [sym_powerset] = ACTIONS(5854),
    [sym_domain] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [sym_negative_dot] = ACTIONS(5856),
    [sym_enabled] = ACTIONS(5854),
    [sym_unchanged] = ACTIONS(5854),
    [anon_sym_LT_GT] = ACTIONS(5856),
    [anon_sym_u22c4] = ACTIONS(5856),
    [anon_sym_u25c7] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5854),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [anon_sym_ASSUME] = ACTIONS(5854),
    [anon_sym_ASSUMPTION] = ACTIONS(5854),
    [anon_sym_AXIOM] = ACTIONS(5854),
    [anon_sym_THEOREM] = ACTIONS(5854),
    [anon_sym_PROPOSITION] = ACTIONS(5854),
    [anon_sym_LEMMA] = ACTIONS(5854),
    [anon_sym_COROLLARY] = ACTIONS(5854),
    [anon_sym_USE] = ACTIONS(5854),
    [anon_sym_HIDE] = ACTIONS(5854),
    [anon_sym_DEF] = ACTIONS(5854),
    [anon_sym_DEFS] = ACTIONS(5854),
    [sym__double_excl] = ACTIONS(5856),
  },
  [2400] = {
    [sym_block_comment] = STATE(2400),
    [ts_builtin_sym_end] = ACTIONS(5904),
    [sym_identifier] = ACTIONS(5906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5904),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_LOCAL] = ACTIONS(5906),
    [anon_sym_VARIABLE] = ACTIONS(5906),
    [anon_sym_VARIABLES] = ACTIONS(5906),
    [anon_sym_CONSTANT] = ACTIONS(5906),
    [anon_sym_CONSTANTS] = ACTIONS(5906),
    [anon_sym_RECURSIVE] = ACTIONS(5906),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_INSTANCE] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_Nat] = ACTIONS(5906),
    [anon_sym_u2115] = ACTIONS(5904),
    [anon_sym_Int] = ACTIONS(5906),
    [anon_sym_u2124] = ACTIONS(5904),
    [anon_sym_Real] = ACTIONS(5906),
    [anon_sym_u211d] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_BSLASHlnot] = ACTIONS(5904),
    [anon_sym_BSLASHneg] = ACTIONS(5904),
    [anon_sym_TILDE] = ACTIONS(5906),
    [anon_sym_u00ac] = ACTIONS(5904),
    [sym_union] = ACTIONS(5906),
    [sym_powerset] = ACTIONS(5906),
    [sym_domain] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [sym_negative_dot] = ACTIONS(5904),
    [sym_enabled] = ACTIONS(5906),
    [sym_unchanged] = ACTIONS(5906),
    [anon_sym_LT_GT] = ACTIONS(5904),
    [anon_sym_u22c4] = ACTIONS(5904),
    [anon_sym_u25c7] = ACTIONS(5904),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5906),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [anon_sym_ASSUME] = ACTIONS(5906),
    [anon_sym_ASSUMPTION] = ACTIONS(5906),
    [anon_sym_AXIOM] = ACTIONS(5906),
    [anon_sym_THEOREM] = ACTIONS(5906),
    [anon_sym_PROPOSITION] = ACTIONS(5906),
    [anon_sym_LEMMA] = ACTIONS(5906),
    [anon_sym_COROLLARY] = ACTIONS(5906),
    [anon_sym_USE] = ACTIONS(5906),
    [anon_sym_HIDE] = ACTIONS(5906),
    [anon_sym_DEF] = ACTIONS(5906),
    [anon_sym_DEFS] = ACTIONS(5906),
    [sym__double_excl] = ACTIONS(5904),
  },
  [2401] = {
    [sym_block_comment] = STATE(2401),
    [sym_identifier] = ACTIONS(5928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5930),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_LOCAL] = ACTIONS(5928),
    [anon_sym_VARIABLE] = ACTIONS(5928),
    [anon_sym_VARIABLES] = ACTIONS(5928),
    [anon_sym_CONSTANT] = ACTIONS(5928),
    [anon_sym_CONSTANTS] = ACTIONS(5928),
    [anon_sym_RECURSIVE] = ACTIONS(5928),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_INSTANCE] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_Nat] = ACTIONS(5928),
    [anon_sym_u2115] = ACTIONS(5930),
    [anon_sym_Int] = ACTIONS(5928),
    [anon_sym_u2124] = ACTIONS(5930),
    [anon_sym_Real] = ACTIONS(5928),
    [anon_sym_u211d] = ACTIONS(5930),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_BSLASHlnot] = ACTIONS(5930),
    [anon_sym_BSLASHneg] = ACTIONS(5930),
    [anon_sym_TILDE] = ACTIONS(5928),
    [anon_sym_u00ac] = ACTIONS(5930),
    [sym_union] = ACTIONS(5928),
    [sym_powerset] = ACTIONS(5928),
    [sym_domain] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [sym_negative_dot] = ACTIONS(5930),
    [sym_enabled] = ACTIONS(5928),
    [sym_unchanged] = ACTIONS(5928),
    [anon_sym_LT_GT] = ACTIONS(5930),
    [anon_sym_u22c4] = ACTIONS(5930),
    [anon_sym_u25c7] = ACTIONS(5930),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5928),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [anon_sym_ASSUME] = ACTIONS(5928),
    [anon_sym_ASSUMPTION] = ACTIONS(5928),
    [anon_sym_AXIOM] = ACTIONS(5928),
    [anon_sym_THEOREM] = ACTIONS(5928),
    [anon_sym_PROPOSITION] = ACTIONS(5928),
    [anon_sym_LEMMA] = ACTIONS(5928),
    [anon_sym_COROLLARY] = ACTIONS(5928),
    [anon_sym_USE] = ACTIONS(5928),
    [anon_sym_HIDE] = ACTIONS(5928),
    [anon_sym_DEF] = ACTIONS(5928),
    [anon_sym_DEFS] = ACTIONS(5928),
    [sym__double_excl] = ACTIONS(5930),
  },
  [2402] = {
    [sym_block_comment] = STATE(2402),
    [sym_identifier] = ACTIONS(5932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5934),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_LOCAL] = ACTIONS(5932),
    [anon_sym_VARIABLE] = ACTIONS(5932),
    [anon_sym_VARIABLES] = ACTIONS(5932),
    [anon_sym_CONSTANT] = ACTIONS(5932),
    [anon_sym_CONSTANTS] = ACTIONS(5932),
    [anon_sym_RECURSIVE] = ACTIONS(5932),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_INSTANCE] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_Nat] = ACTIONS(5932),
    [anon_sym_u2115] = ACTIONS(5934),
    [anon_sym_Int] = ACTIONS(5932),
    [anon_sym_u2124] = ACTIONS(5934),
    [anon_sym_Real] = ACTIONS(5932),
    [anon_sym_u211d] = ACTIONS(5934),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_BSLASHlnot] = ACTIONS(5934),
    [anon_sym_BSLASHneg] = ACTIONS(5934),
    [anon_sym_TILDE] = ACTIONS(5932),
    [anon_sym_u00ac] = ACTIONS(5934),
    [sym_union] = ACTIONS(5932),
    [sym_powerset] = ACTIONS(5932),
    [sym_domain] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [sym_negative_dot] = ACTIONS(5934),
    [sym_enabled] = ACTIONS(5932),
    [sym_unchanged] = ACTIONS(5932),
    [anon_sym_LT_GT] = ACTIONS(5934),
    [anon_sym_u22c4] = ACTIONS(5934),
    [anon_sym_u25c7] = ACTIONS(5934),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5932),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [anon_sym_ASSUME] = ACTIONS(5932),
    [anon_sym_ASSUMPTION] = ACTIONS(5932),
    [anon_sym_AXIOM] = ACTIONS(5932),
    [anon_sym_THEOREM] = ACTIONS(5932),
    [anon_sym_PROPOSITION] = ACTIONS(5932),
    [anon_sym_LEMMA] = ACTIONS(5932),
    [anon_sym_COROLLARY] = ACTIONS(5932),
    [anon_sym_USE] = ACTIONS(5932),
    [anon_sym_HIDE] = ACTIONS(5932),
    [anon_sym_DEF] = ACTIONS(5932),
    [anon_sym_DEFS] = ACTIONS(5932),
    [sym__double_excl] = ACTIONS(5934),
  },
  [2403] = {
    [sym_block_comment] = STATE(2403),
    [sym_identifier] = ACTIONS(5858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_LOCAL] = ACTIONS(5858),
    [anon_sym_VARIABLE] = ACTIONS(5858),
    [anon_sym_VARIABLES] = ACTIONS(5858),
    [anon_sym_CONSTANT] = ACTIONS(5858),
    [anon_sym_CONSTANTS] = ACTIONS(5858),
    [anon_sym_RECURSIVE] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_INSTANCE] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_Nat] = ACTIONS(5858),
    [anon_sym_u2115] = ACTIONS(5860),
    [anon_sym_Int] = ACTIONS(5858),
    [anon_sym_u2124] = ACTIONS(5860),
    [anon_sym_Real] = ACTIONS(5858),
    [anon_sym_u211d] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_BSLASHlnot] = ACTIONS(5860),
    [anon_sym_BSLASHneg] = ACTIONS(5860),
    [anon_sym_TILDE] = ACTIONS(5858),
    [anon_sym_u00ac] = ACTIONS(5860),
    [sym_union] = ACTIONS(5858),
    [sym_powerset] = ACTIONS(5858),
    [sym_domain] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [sym_negative_dot] = ACTIONS(5860),
    [sym_enabled] = ACTIONS(5858),
    [sym_unchanged] = ACTIONS(5858),
    [anon_sym_LT_GT] = ACTIONS(5860),
    [anon_sym_u22c4] = ACTIONS(5860),
    [anon_sym_u25c7] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5858),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [anon_sym_ASSUME] = ACTIONS(5858),
    [anon_sym_ASSUMPTION] = ACTIONS(5858),
    [anon_sym_AXIOM] = ACTIONS(5858),
    [anon_sym_THEOREM] = ACTIONS(5858),
    [anon_sym_PROPOSITION] = ACTIONS(5858),
    [anon_sym_LEMMA] = ACTIONS(5858),
    [anon_sym_COROLLARY] = ACTIONS(5858),
    [anon_sym_USE] = ACTIONS(5858),
    [anon_sym_HIDE] = ACTIONS(5858),
    [anon_sym_DEF] = ACTIONS(5858),
    [anon_sym_DEFS] = ACTIONS(5858),
    [sym__double_excl] = ACTIONS(5860),
  },
  [2404] = {
    [sym_block_comment] = STATE(2404),
    [sym_identifier] = ACTIONS(5770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5768),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_LOCAL] = ACTIONS(5770),
    [anon_sym_VARIABLE] = ACTIONS(5770),
    [anon_sym_VARIABLES] = ACTIONS(5770),
    [anon_sym_CONSTANT] = ACTIONS(5770),
    [anon_sym_CONSTANTS] = ACTIONS(5770),
    [anon_sym_RECURSIVE] = ACTIONS(5770),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_INSTANCE] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_Nat] = ACTIONS(5770),
    [anon_sym_u2115] = ACTIONS(5768),
    [anon_sym_Int] = ACTIONS(5770),
    [anon_sym_u2124] = ACTIONS(5768),
    [anon_sym_Real] = ACTIONS(5770),
    [anon_sym_u211d] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_BSLASHlnot] = ACTIONS(5768),
    [anon_sym_BSLASHneg] = ACTIONS(5768),
    [anon_sym_TILDE] = ACTIONS(5770),
    [anon_sym_u00ac] = ACTIONS(5768),
    [sym_union] = ACTIONS(5770),
    [sym_powerset] = ACTIONS(5770),
    [sym_domain] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [sym_negative_dot] = ACTIONS(5768),
    [sym_enabled] = ACTIONS(5770),
    [sym_unchanged] = ACTIONS(5770),
    [anon_sym_LT_GT] = ACTIONS(5768),
    [anon_sym_u22c4] = ACTIONS(5768),
    [anon_sym_u25c7] = ACTIONS(5768),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5770),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [anon_sym_ASSUME] = ACTIONS(5770),
    [anon_sym_ASSUMPTION] = ACTIONS(5770),
    [anon_sym_AXIOM] = ACTIONS(5770),
    [anon_sym_THEOREM] = ACTIONS(5770),
    [anon_sym_PROPOSITION] = ACTIONS(5770),
    [anon_sym_LEMMA] = ACTIONS(5770),
    [anon_sym_COROLLARY] = ACTIONS(5770),
    [anon_sym_USE] = ACTIONS(5770),
    [anon_sym_HIDE] = ACTIONS(5770),
    [anon_sym_DEF] = ACTIONS(5770),
    [anon_sym_DEFS] = ACTIONS(5770),
    [sym__double_excl] = ACTIONS(5768),
  },
  [2405] = {
    [sym_block_comment] = STATE(2405),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5690),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LOCAL] = ACTIONS(5688),
    [anon_sym_VARIABLE] = ACTIONS(5688),
    [anon_sym_VARIABLES] = ACTIONS(5688),
    [anon_sym_CONSTANT] = ACTIONS(5688),
    [anon_sym_CONSTANTS] = ACTIONS(5688),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5688),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_ASSUME] = ACTIONS(5688),
    [anon_sym_ASSUMPTION] = ACTIONS(5688),
    [anon_sym_AXIOM] = ACTIONS(5688),
    [anon_sym_THEOREM] = ACTIONS(5688),
    [anon_sym_PROPOSITION] = ACTIONS(5688),
    [anon_sym_LEMMA] = ACTIONS(5688),
    [anon_sym_COROLLARY] = ACTIONS(5688),
    [anon_sym_USE] = ACTIONS(5688),
    [anon_sym_HIDE] = ACTIONS(5688),
    [anon_sym_DEF] = ACTIONS(5688),
    [anon_sym_DEFS] = ACTIONS(5688),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2406] = {
    [sym_block_comment] = STATE(2406),
    [ts_builtin_sym_end] = ACTIONS(5690),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5690),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LOCAL] = ACTIONS(5688),
    [anon_sym_VARIABLE] = ACTIONS(5688),
    [anon_sym_VARIABLES] = ACTIONS(5688),
    [anon_sym_CONSTANT] = ACTIONS(5688),
    [anon_sym_CONSTANTS] = ACTIONS(5688),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5688),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_ASSUME] = ACTIONS(5688),
    [anon_sym_ASSUMPTION] = ACTIONS(5688),
    [anon_sym_AXIOM] = ACTIONS(5688),
    [anon_sym_THEOREM] = ACTIONS(5688),
    [anon_sym_PROPOSITION] = ACTIONS(5688),
    [anon_sym_LEMMA] = ACTIONS(5688),
    [anon_sym_COROLLARY] = ACTIONS(5688),
    [anon_sym_USE] = ACTIONS(5688),
    [anon_sym_HIDE] = ACTIONS(5688),
    [anon_sym_DEF] = ACTIONS(5688),
    [anon_sym_DEFS] = ACTIONS(5688),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2407] = {
    [sym_block_comment] = STATE(2407),
    [ts_builtin_sym_end] = ACTIONS(5870),
    [sym_identifier] = ACTIONS(5868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5870),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_LOCAL] = ACTIONS(5868),
    [anon_sym_VARIABLE] = ACTIONS(5868),
    [anon_sym_VARIABLES] = ACTIONS(5868),
    [anon_sym_CONSTANT] = ACTIONS(5868),
    [anon_sym_CONSTANTS] = ACTIONS(5868),
    [anon_sym_RECURSIVE] = ACTIONS(5868),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_INSTANCE] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_Nat] = ACTIONS(5868),
    [anon_sym_u2115] = ACTIONS(5870),
    [anon_sym_Int] = ACTIONS(5868),
    [anon_sym_u2124] = ACTIONS(5870),
    [anon_sym_Real] = ACTIONS(5868),
    [anon_sym_u211d] = ACTIONS(5870),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_BSLASHlnot] = ACTIONS(5870),
    [anon_sym_BSLASHneg] = ACTIONS(5870),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_u00ac] = ACTIONS(5870),
    [sym_union] = ACTIONS(5868),
    [sym_powerset] = ACTIONS(5868),
    [sym_domain] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [sym_negative_dot] = ACTIONS(5870),
    [sym_enabled] = ACTIONS(5868),
    [sym_unchanged] = ACTIONS(5868),
    [anon_sym_LT_GT] = ACTIONS(5870),
    [anon_sym_u22c4] = ACTIONS(5870),
    [anon_sym_u25c7] = ACTIONS(5870),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5868),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [anon_sym_ASSUME] = ACTIONS(5868),
    [anon_sym_ASSUMPTION] = ACTIONS(5868),
    [anon_sym_AXIOM] = ACTIONS(5868),
    [anon_sym_THEOREM] = ACTIONS(5868),
    [anon_sym_PROPOSITION] = ACTIONS(5868),
    [anon_sym_LEMMA] = ACTIONS(5868),
    [anon_sym_COROLLARY] = ACTIONS(5868),
    [anon_sym_USE] = ACTIONS(5868),
    [anon_sym_HIDE] = ACTIONS(5868),
    [anon_sym_DEF] = ACTIONS(5868),
    [anon_sym_DEFS] = ACTIONS(5868),
    [sym__double_excl] = ACTIONS(5870),
  },
  [2408] = {
    [sym_block_comment] = STATE(2408),
    [ts_builtin_sym_end] = ACTIONS(5846),
    [sym_identifier] = ACTIONS(5848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5846),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_LOCAL] = ACTIONS(5848),
    [anon_sym_VARIABLE] = ACTIONS(5848),
    [anon_sym_VARIABLES] = ACTIONS(5848),
    [anon_sym_CONSTANT] = ACTIONS(5848),
    [anon_sym_CONSTANTS] = ACTIONS(5848),
    [anon_sym_RECURSIVE] = ACTIONS(5848),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_INSTANCE] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_Nat] = ACTIONS(5848),
    [anon_sym_u2115] = ACTIONS(5846),
    [anon_sym_Int] = ACTIONS(5848),
    [anon_sym_u2124] = ACTIONS(5846),
    [anon_sym_Real] = ACTIONS(5848),
    [anon_sym_u211d] = ACTIONS(5846),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_BSLASHlnot] = ACTIONS(5846),
    [anon_sym_BSLASHneg] = ACTIONS(5846),
    [anon_sym_TILDE] = ACTIONS(5848),
    [anon_sym_u00ac] = ACTIONS(5846),
    [sym_union] = ACTIONS(5848),
    [sym_powerset] = ACTIONS(5848),
    [sym_domain] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [sym_negative_dot] = ACTIONS(5846),
    [sym_enabled] = ACTIONS(5848),
    [sym_unchanged] = ACTIONS(5848),
    [anon_sym_LT_GT] = ACTIONS(5846),
    [anon_sym_u22c4] = ACTIONS(5846),
    [anon_sym_u25c7] = ACTIONS(5846),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5848),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [anon_sym_ASSUME] = ACTIONS(5848),
    [anon_sym_ASSUMPTION] = ACTIONS(5848),
    [anon_sym_AXIOM] = ACTIONS(5848),
    [anon_sym_THEOREM] = ACTIONS(5848),
    [anon_sym_PROPOSITION] = ACTIONS(5848),
    [anon_sym_LEMMA] = ACTIONS(5848),
    [anon_sym_COROLLARY] = ACTIONS(5848),
    [anon_sym_USE] = ACTIONS(5848),
    [anon_sym_HIDE] = ACTIONS(5848),
    [anon_sym_DEF] = ACTIONS(5848),
    [anon_sym_DEFS] = ACTIONS(5848),
    [sym__double_excl] = ACTIONS(5846),
  },
  [2409] = {
    [sym_block_comment] = STATE(2409),
    [ts_builtin_sym_end] = ACTIONS(5862),
    [sym_identifier] = ACTIONS(5864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5862),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5862),
    [anon_sym_LOCAL] = ACTIONS(5864),
    [anon_sym_VARIABLE] = ACTIONS(5864),
    [anon_sym_VARIABLES] = ACTIONS(5864),
    [anon_sym_CONSTANT] = ACTIONS(5864),
    [anon_sym_CONSTANTS] = ACTIONS(5864),
    [anon_sym_RECURSIVE] = ACTIONS(5864),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_INSTANCE] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_Nat] = ACTIONS(5864),
    [anon_sym_u2115] = ACTIONS(5862),
    [anon_sym_Int] = ACTIONS(5864),
    [anon_sym_u2124] = ACTIONS(5862),
    [anon_sym_Real] = ACTIONS(5864),
    [anon_sym_u211d] = ACTIONS(5862),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_BSLASHlnot] = ACTIONS(5862),
    [anon_sym_BSLASHneg] = ACTIONS(5862),
    [anon_sym_TILDE] = ACTIONS(5864),
    [anon_sym_u00ac] = ACTIONS(5862),
    [sym_union] = ACTIONS(5864),
    [sym_powerset] = ACTIONS(5864),
    [sym_domain] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [sym_negative_dot] = ACTIONS(5862),
    [sym_enabled] = ACTIONS(5864),
    [sym_unchanged] = ACTIONS(5864),
    [anon_sym_LT_GT] = ACTIONS(5862),
    [anon_sym_u22c4] = ACTIONS(5862),
    [anon_sym_u25c7] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5864),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [anon_sym_ASSUME] = ACTIONS(5864),
    [anon_sym_ASSUMPTION] = ACTIONS(5864),
    [anon_sym_AXIOM] = ACTIONS(5864),
    [anon_sym_THEOREM] = ACTIONS(5864),
    [anon_sym_PROPOSITION] = ACTIONS(5864),
    [anon_sym_LEMMA] = ACTIONS(5864),
    [anon_sym_COROLLARY] = ACTIONS(5864),
    [anon_sym_USE] = ACTIONS(5864),
    [anon_sym_HIDE] = ACTIONS(5864),
    [anon_sym_DEF] = ACTIONS(5864),
    [anon_sym_DEFS] = ACTIONS(5864),
    [sym__double_excl] = ACTIONS(5862),
  },
  [2410] = {
    [sym_block_comment] = STATE(2410),
    [ts_builtin_sym_end] = ACTIONS(5778),
    [sym_identifier] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5778),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_LOCAL] = ACTIONS(5780),
    [anon_sym_VARIABLE] = ACTIONS(5780),
    [anon_sym_VARIABLES] = ACTIONS(5780),
    [anon_sym_CONSTANT] = ACTIONS(5780),
    [anon_sym_CONSTANTS] = ACTIONS(5780),
    [anon_sym_RECURSIVE] = ACTIONS(5780),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_INSTANCE] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_Nat] = ACTIONS(5780),
    [anon_sym_u2115] = ACTIONS(5778),
    [anon_sym_Int] = ACTIONS(5780),
    [anon_sym_u2124] = ACTIONS(5778),
    [anon_sym_Real] = ACTIONS(5780),
    [anon_sym_u211d] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_BSLASHlnot] = ACTIONS(5778),
    [anon_sym_BSLASHneg] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5780),
    [anon_sym_u00ac] = ACTIONS(5778),
    [sym_union] = ACTIONS(5780),
    [sym_powerset] = ACTIONS(5780),
    [sym_domain] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [sym_negative_dot] = ACTIONS(5778),
    [sym_enabled] = ACTIONS(5780),
    [sym_unchanged] = ACTIONS(5780),
    [anon_sym_LT_GT] = ACTIONS(5778),
    [anon_sym_u22c4] = ACTIONS(5778),
    [anon_sym_u25c7] = ACTIONS(5778),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5780),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [anon_sym_ASSUME] = ACTIONS(5780),
    [anon_sym_ASSUMPTION] = ACTIONS(5780),
    [anon_sym_AXIOM] = ACTIONS(5780),
    [anon_sym_THEOREM] = ACTIONS(5780),
    [anon_sym_PROPOSITION] = ACTIONS(5780),
    [anon_sym_LEMMA] = ACTIONS(5780),
    [anon_sym_COROLLARY] = ACTIONS(5780),
    [anon_sym_USE] = ACTIONS(5780),
    [anon_sym_HIDE] = ACTIONS(5780),
    [anon_sym_DEF] = ACTIONS(5780),
    [anon_sym_DEFS] = ACTIONS(5780),
    [sym__double_excl] = ACTIONS(5778),
  },
  [2411] = {
    [sym_block_comment] = STATE(2411),
    [sym_identifier] = ACTIONS(5758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5756),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_LOCAL] = ACTIONS(5758),
    [anon_sym_VARIABLE] = ACTIONS(5758),
    [anon_sym_VARIABLES] = ACTIONS(5758),
    [anon_sym_CONSTANT] = ACTIONS(5758),
    [anon_sym_CONSTANTS] = ACTIONS(5758),
    [anon_sym_RECURSIVE] = ACTIONS(5758),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_INSTANCE] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_Nat] = ACTIONS(5758),
    [anon_sym_u2115] = ACTIONS(5756),
    [anon_sym_Int] = ACTIONS(5758),
    [anon_sym_u2124] = ACTIONS(5756),
    [anon_sym_Real] = ACTIONS(5758),
    [anon_sym_u211d] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_BSLASHlnot] = ACTIONS(5756),
    [anon_sym_BSLASHneg] = ACTIONS(5756),
    [anon_sym_TILDE] = ACTIONS(5758),
    [anon_sym_u00ac] = ACTIONS(5756),
    [sym_union] = ACTIONS(5758),
    [sym_powerset] = ACTIONS(5758),
    [sym_domain] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [sym_negative_dot] = ACTIONS(5756),
    [sym_enabled] = ACTIONS(5758),
    [sym_unchanged] = ACTIONS(5758),
    [anon_sym_LT_GT] = ACTIONS(5756),
    [anon_sym_u22c4] = ACTIONS(5756),
    [anon_sym_u25c7] = ACTIONS(5756),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5758),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [anon_sym_ASSUME] = ACTIONS(5758),
    [anon_sym_ASSUMPTION] = ACTIONS(5758),
    [anon_sym_AXIOM] = ACTIONS(5758),
    [anon_sym_THEOREM] = ACTIONS(5758),
    [anon_sym_PROPOSITION] = ACTIONS(5758),
    [anon_sym_LEMMA] = ACTIONS(5758),
    [anon_sym_COROLLARY] = ACTIONS(5758),
    [anon_sym_USE] = ACTIONS(5758),
    [anon_sym_HIDE] = ACTIONS(5758),
    [anon_sym_DEF] = ACTIONS(5758),
    [anon_sym_DEFS] = ACTIONS(5758),
    [sym__double_excl] = ACTIONS(5756),
  },
  [2412] = {
    [sym_block_comment] = STATE(2412),
    [sym_identifier] = ACTIONS(5762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5760),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_LOCAL] = ACTIONS(5762),
    [anon_sym_VARIABLE] = ACTIONS(5762),
    [anon_sym_VARIABLES] = ACTIONS(5762),
    [anon_sym_CONSTANT] = ACTIONS(5762),
    [anon_sym_CONSTANTS] = ACTIONS(5762),
    [anon_sym_RECURSIVE] = ACTIONS(5762),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_INSTANCE] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_Nat] = ACTIONS(5762),
    [anon_sym_u2115] = ACTIONS(5760),
    [anon_sym_Int] = ACTIONS(5762),
    [anon_sym_u2124] = ACTIONS(5760),
    [anon_sym_Real] = ACTIONS(5762),
    [anon_sym_u211d] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_BSLASHlnot] = ACTIONS(5760),
    [anon_sym_BSLASHneg] = ACTIONS(5760),
    [anon_sym_TILDE] = ACTIONS(5762),
    [anon_sym_u00ac] = ACTIONS(5760),
    [sym_union] = ACTIONS(5762),
    [sym_powerset] = ACTIONS(5762),
    [sym_domain] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [sym_negative_dot] = ACTIONS(5760),
    [sym_enabled] = ACTIONS(5762),
    [sym_unchanged] = ACTIONS(5762),
    [anon_sym_LT_GT] = ACTIONS(5760),
    [anon_sym_u22c4] = ACTIONS(5760),
    [anon_sym_u25c7] = ACTIONS(5760),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5762),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [anon_sym_ASSUME] = ACTIONS(5762),
    [anon_sym_ASSUMPTION] = ACTIONS(5762),
    [anon_sym_AXIOM] = ACTIONS(5762),
    [anon_sym_THEOREM] = ACTIONS(5762),
    [anon_sym_PROPOSITION] = ACTIONS(5762),
    [anon_sym_LEMMA] = ACTIONS(5762),
    [anon_sym_COROLLARY] = ACTIONS(5762),
    [anon_sym_USE] = ACTIONS(5762),
    [anon_sym_HIDE] = ACTIONS(5762),
    [anon_sym_DEF] = ACTIONS(5762),
    [anon_sym_DEFS] = ACTIONS(5762),
    [sym__double_excl] = ACTIONS(5760),
  },
  [2413] = {
    [sym_block_comment] = STATE(2413),
    [sym_identifier] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5764),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_LOCAL] = ACTIONS(5766),
    [anon_sym_VARIABLE] = ACTIONS(5766),
    [anon_sym_VARIABLES] = ACTIONS(5766),
    [anon_sym_CONSTANT] = ACTIONS(5766),
    [anon_sym_CONSTANTS] = ACTIONS(5766),
    [anon_sym_RECURSIVE] = ACTIONS(5766),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_INSTANCE] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_Nat] = ACTIONS(5766),
    [anon_sym_u2115] = ACTIONS(5764),
    [anon_sym_Int] = ACTIONS(5766),
    [anon_sym_u2124] = ACTIONS(5764),
    [anon_sym_Real] = ACTIONS(5766),
    [anon_sym_u211d] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_BSLASHlnot] = ACTIONS(5764),
    [anon_sym_BSLASHneg] = ACTIONS(5764),
    [anon_sym_TILDE] = ACTIONS(5766),
    [anon_sym_u00ac] = ACTIONS(5764),
    [sym_union] = ACTIONS(5766),
    [sym_powerset] = ACTIONS(5766),
    [sym_domain] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [sym_negative_dot] = ACTIONS(5764),
    [sym_enabled] = ACTIONS(5766),
    [sym_unchanged] = ACTIONS(5766),
    [anon_sym_LT_GT] = ACTIONS(5764),
    [anon_sym_u22c4] = ACTIONS(5764),
    [anon_sym_u25c7] = ACTIONS(5764),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5766),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [anon_sym_ASSUME] = ACTIONS(5766),
    [anon_sym_ASSUMPTION] = ACTIONS(5766),
    [anon_sym_AXIOM] = ACTIONS(5766),
    [anon_sym_THEOREM] = ACTIONS(5766),
    [anon_sym_PROPOSITION] = ACTIONS(5766),
    [anon_sym_LEMMA] = ACTIONS(5766),
    [anon_sym_COROLLARY] = ACTIONS(5766),
    [anon_sym_USE] = ACTIONS(5766),
    [anon_sym_HIDE] = ACTIONS(5766),
    [anon_sym_DEF] = ACTIONS(5766),
    [anon_sym_DEFS] = ACTIONS(5766),
    [sym__double_excl] = ACTIONS(5764),
  },
  [2414] = {
    [sym_block_comment] = STATE(2414),
    [sym_identifier] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5736),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_LOCAL] = ACTIONS(5738),
    [anon_sym_VARIABLE] = ACTIONS(5738),
    [anon_sym_VARIABLES] = ACTIONS(5738),
    [anon_sym_CONSTANT] = ACTIONS(5738),
    [anon_sym_CONSTANTS] = ACTIONS(5738),
    [anon_sym_RECURSIVE] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_INSTANCE] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_Nat] = ACTIONS(5738),
    [anon_sym_u2115] = ACTIONS(5736),
    [anon_sym_Int] = ACTIONS(5738),
    [anon_sym_u2124] = ACTIONS(5736),
    [anon_sym_Real] = ACTIONS(5738),
    [anon_sym_u211d] = ACTIONS(5736),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_BSLASHlnot] = ACTIONS(5736),
    [anon_sym_BSLASHneg] = ACTIONS(5736),
    [anon_sym_TILDE] = ACTIONS(5738),
    [anon_sym_u00ac] = ACTIONS(5736),
    [sym_union] = ACTIONS(5738),
    [sym_powerset] = ACTIONS(5738),
    [sym_domain] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [sym_negative_dot] = ACTIONS(5736),
    [sym_enabled] = ACTIONS(5738),
    [sym_unchanged] = ACTIONS(5738),
    [anon_sym_LT_GT] = ACTIONS(5736),
    [anon_sym_u22c4] = ACTIONS(5736),
    [anon_sym_u25c7] = ACTIONS(5736),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5738),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [anon_sym_ASSUME] = ACTIONS(5738),
    [anon_sym_ASSUMPTION] = ACTIONS(5738),
    [anon_sym_AXIOM] = ACTIONS(5738),
    [anon_sym_THEOREM] = ACTIONS(5738),
    [anon_sym_PROPOSITION] = ACTIONS(5738),
    [anon_sym_LEMMA] = ACTIONS(5738),
    [anon_sym_COROLLARY] = ACTIONS(5738),
    [anon_sym_USE] = ACTIONS(5738),
    [anon_sym_HIDE] = ACTIONS(5738),
    [anon_sym_DEF] = ACTIONS(5738),
    [anon_sym_DEFS] = ACTIONS(5738),
    [sym__double_excl] = ACTIONS(5736),
  },
  [2415] = {
    [sym_block_comment] = STATE(2415),
    [sym_identifier] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5724),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_COMMA] = ACTIONS(5724),
    [anon_sym_LOCAL] = ACTIONS(5726),
    [anon_sym_VARIABLE] = ACTIONS(5726),
    [anon_sym_VARIABLES] = ACTIONS(5726),
    [anon_sym_CONSTANT] = ACTIONS(5726),
    [anon_sym_CONSTANTS] = ACTIONS(5726),
    [anon_sym_RECURSIVE] = ACTIONS(5726),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_INSTANCE] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_Nat] = ACTIONS(5726),
    [anon_sym_u2115] = ACTIONS(5724),
    [anon_sym_Int] = ACTIONS(5726),
    [anon_sym_u2124] = ACTIONS(5724),
    [anon_sym_Real] = ACTIONS(5726),
    [anon_sym_u211d] = ACTIONS(5724),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_BSLASHlnot] = ACTIONS(5724),
    [anon_sym_BSLASHneg] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5726),
    [anon_sym_u00ac] = ACTIONS(5724),
    [sym_union] = ACTIONS(5726),
    [sym_powerset] = ACTIONS(5726),
    [sym_domain] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [sym_negative_dot] = ACTIONS(5724),
    [sym_enabled] = ACTIONS(5726),
    [sym_unchanged] = ACTIONS(5726),
    [anon_sym_LT_GT] = ACTIONS(5724),
    [anon_sym_u22c4] = ACTIONS(5724),
    [anon_sym_u25c7] = ACTIONS(5724),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5726),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [anon_sym_ASSUME] = ACTIONS(5726),
    [anon_sym_ASSUMPTION] = ACTIONS(5726),
    [anon_sym_AXIOM] = ACTIONS(5726),
    [anon_sym_THEOREM] = ACTIONS(5726),
    [anon_sym_PROPOSITION] = ACTIONS(5726),
    [anon_sym_LEMMA] = ACTIONS(5726),
    [anon_sym_COROLLARY] = ACTIONS(5726),
    [anon_sym_USE] = ACTIONS(5726),
    [anon_sym_HIDE] = ACTIONS(5726),
    [anon_sym_DEF] = ACTIONS(5726),
    [anon_sym_DEFS] = ACTIONS(5726),
    [sym__double_excl] = ACTIONS(5724),
  },
  [2416] = {
    [sym_block_comment] = STATE(2416),
    [ts_builtin_sym_end] = ACTIONS(5908),
    [sym_identifier] = ACTIONS(5910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5908),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_LOCAL] = ACTIONS(5910),
    [anon_sym_VARIABLE] = ACTIONS(5910),
    [anon_sym_VARIABLES] = ACTIONS(5910),
    [anon_sym_CONSTANT] = ACTIONS(5910),
    [anon_sym_CONSTANTS] = ACTIONS(5910),
    [anon_sym_RECURSIVE] = ACTIONS(5910),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_INSTANCE] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_Nat] = ACTIONS(5910),
    [anon_sym_u2115] = ACTIONS(5908),
    [anon_sym_Int] = ACTIONS(5910),
    [anon_sym_u2124] = ACTIONS(5908),
    [anon_sym_Real] = ACTIONS(5910),
    [anon_sym_u211d] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_BSLASHlnot] = ACTIONS(5908),
    [anon_sym_BSLASHneg] = ACTIONS(5908),
    [anon_sym_TILDE] = ACTIONS(5910),
    [anon_sym_u00ac] = ACTIONS(5908),
    [sym_union] = ACTIONS(5910),
    [sym_powerset] = ACTIONS(5910),
    [sym_domain] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [sym_negative_dot] = ACTIONS(5908),
    [sym_enabled] = ACTIONS(5910),
    [sym_unchanged] = ACTIONS(5910),
    [anon_sym_LT_GT] = ACTIONS(5908),
    [anon_sym_u22c4] = ACTIONS(5908),
    [anon_sym_u25c7] = ACTIONS(5908),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5910),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [anon_sym_ASSUME] = ACTIONS(5910),
    [anon_sym_ASSUMPTION] = ACTIONS(5910),
    [anon_sym_AXIOM] = ACTIONS(5910),
    [anon_sym_THEOREM] = ACTIONS(5910),
    [anon_sym_PROPOSITION] = ACTIONS(5910),
    [anon_sym_LEMMA] = ACTIONS(5910),
    [anon_sym_COROLLARY] = ACTIONS(5910),
    [anon_sym_USE] = ACTIONS(5910),
    [anon_sym_HIDE] = ACTIONS(5910),
    [anon_sym_DEF] = ACTIONS(5910),
    [anon_sym_DEFS] = ACTIONS(5910),
    [sym__double_excl] = ACTIONS(5908),
  },
  [2417] = {
    [sym_block_comment] = STATE(2417),
    [sym_identifier] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5744),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_LOCAL] = ACTIONS(5746),
    [anon_sym_VARIABLE] = ACTIONS(5746),
    [anon_sym_VARIABLES] = ACTIONS(5746),
    [anon_sym_CONSTANT] = ACTIONS(5746),
    [anon_sym_CONSTANTS] = ACTIONS(5746),
    [anon_sym_RECURSIVE] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_INSTANCE] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_Nat] = ACTIONS(5746),
    [anon_sym_u2115] = ACTIONS(5744),
    [anon_sym_Int] = ACTIONS(5746),
    [anon_sym_u2124] = ACTIONS(5744),
    [anon_sym_Real] = ACTIONS(5746),
    [anon_sym_u211d] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_BSLASHlnot] = ACTIONS(5744),
    [anon_sym_BSLASHneg] = ACTIONS(5744),
    [anon_sym_TILDE] = ACTIONS(5746),
    [anon_sym_u00ac] = ACTIONS(5744),
    [sym_union] = ACTIONS(5746),
    [sym_powerset] = ACTIONS(5746),
    [sym_domain] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [sym_negative_dot] = ACTIONS(5744),
    [sym_enabled] = ACTIONS(5746),
    [sym_unchanged] = ACTIONS(5746),
    [anon_sym_LT_GT] = ACTIONS(5744),
    [anon_sym_u22c4] = ACTIONS(5744),
    [anon_sym_u25c7] = ACTIONS(5744),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5746),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [anon_sym_ASSUME] = ACTIONS(5746),
    [anon_sym_ASSUMPTION] = ACTIONS(5746),
    [anon_sym_AXIOM] = ACTIONS(5746),
    [anon_sym_THEOREM] = ACTIONS(5746),
    [anon_sym_PROPOSITION] = ACTIONS(5746),
    [anon_sym_LEMMA] = ACTIONS(5746),
    [anon_sym_COROLLARY] = ACTIONS(5746),
    [anon_sym_USE] = ACTIONS(5746),
    [anon_sym_HIDE] = ACTIONS(5746),
    [anon_sym_DEF] = ACTIONS(5746),
    [anon_sym_DEFS] = ACTIONS(5746),
    [sym__double_excl] = ACTIONS(5744),
  },
  [2418] = {
    [sym_block_comment] = STATE(2418),
    [ts_builtin_sym_end] = ACTIONS(5912),
    [sym_identifier] = ACTIONS(5914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5912),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_COMMA] = ACTIONS(5912),
    [anon_sym_LOCAL] = ACTIONS(5914),
    [anon_sym_VARIABLE] = ACTIONS(5914),
    [anon_sym_VARIABLES] = ACTIONS(5914),
    [anon_sym_CONSTANT] = ACTIONS(5914),
    [anon_sym_CONSTANTS] = ACTIONS(5914),
    [anon_sym_RECURSIVE] = ACTIONS(5914),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_INSTANCE] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_Nat] = ACTIONS(5914),
    [anon_sym_u2115] = ACTIONS(5912),
    [anon_sym_Int] = ACTIONS(5914),
    [anon_sym_u2124] = ACTIONS(5912),
    [anon_sym_Real] = ACTIONS(5914),
    [anon_sym_u211d] = ACTIONS(5912),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_BSLASHlnot] = ACTIONS(5912),
    [anon_sym_BSLASHneg] = ACTIONS(5912),
    [anon_sym_TILDE] = ACTIONS(5914),
    [anon_sym_u00ac] = ACTIONS(5912),
    [sym_union] = ACTIONS(5914),
    [sym_powerset] = ACTIONS(5914),
    [sym_domain] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [sym_negative_dot] = ACTIONS(5912),
    [sym_enabled] = ACTIONS(5914),
    [sym_unchanged] = ACTIONS(5914),
    [anon_sym_LT_GT] = ACTIONS(5912),
    [anon_sym_u22c4] = ACTIONS(5912),
    [anon_sym_u25c7] = ACTIONS(5912),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5914),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [anon_sym_ASSUME] = ACTIONS(5914),
    [anon_sym_ASSUMPTION] = ACTIONS(5914),
    [anon_sym_AXIOM] = ACTIONS(5914),
    [anon_sym_THEOREM] = ACTIONS(5914),
    [anon_sym_PROPOSITION] = ACTIONS(5914),
    [anon_sym_LEMMA] = ACTIONS(5914),
    [anon_sym_COROLLARY] = ACTIONS(5914),
    [anon_sym_USE] = ACTIONS(5914),
    [anon_sym_HIDE] = ACTIONS(5914),
    [anon_sym_DEF] = ACTIONS(5914),
    [anon_sym_DEFS] = ACTIONS(5914),
    [sym__double_excl] = ACTIONS(5912),
  },
  [2419] = {
    [sym_block_comment] = STATE(2419),
    [sym_identifier] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5748),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_COMMA] = ACTIONS(5748),
    [anon_sym_LOCAL] = ACTIONS(5750),
    [anon_sym_VARIABLE] = ACTIONS(5750),
    [anon_sym_VARIABLES] = ACTIONS(5750),
    [anon_sym_CONSTANT] = ACTIONS(5750),
    [anon_sym_CONSTANTS] = ACTIONS(5750),
    [anon_sym_RECURSIVE] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_INSTANCE] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_Nat] = ACTIONS(5750),
    [anon_sym_u2115] = ACTIONS(5748),
    [anon_sym_Int] = ACTIONS(5750),
    [anon_sym_u2124] = ACTIONS(5748),
    [anon_sym_Real] = ACTIONS(5750),
    [anon_sym_u211d] = ACTIONS(5748),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_BSLASHlnot] = ACTIONS(5748),
    [anon_sym_BSLASHneg] = ACTIONS(5748),
    [anon_sym_TILDE] = ACTIONS(5750),
    [anon_sym_u00ac] = ACTIONS(5748),
    [sym_union] = ACTIONS(5750),
    [sym_powerset] = ACTIONS(5750),
    [sym_domain] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [sym_negative_dot] = ACTIONS(5748),
    [sym_enabled] = ACTIONS(5750),
    [sym_unchanged] = ACTIONS(5750),
    [anon_sym_LT_GT] = ACTIONS(5748),
    [anon_sym_u22c4] = ACTIONS(5748),
    [anon_sym_u25c7] = ACTIONS(5748),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5750),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [anon_sym_ASSUME] = ACTIONS(5750),
    [anon_sym_ASSUMPTION] = ACTIONS(5750),
    [anon_sym_AXIOM] = ACTIONS(5750),
    [anon_sym_THEOREM] = ACTIONS(5750),
    [anon_sym_PROPOSITION] = ACTIONS(5750),
    [anon_sym_LEMMA] = ACTIONS(5750),
    [anon_sym_COROLLARY] = ACTIONS(5750),
    [anon_sym_USE] = ACTIONS(5750),
    [anon_sym_HIDE] = ACTIONS(5750),
    [anon_sym_DEF] = ACTIONS(5750),
    [anon_sym_DEFS] = ACTIONS(5750),
    [sym__double_excl] = ACTIONS(5748),
  },
  [2420] = {
    [sym_block_comment] = STATE(2420),
    [ts_builtin_sym_end] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5790),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_COMMA] = ACTIONS(5790),
    [anon_sym_LOCAL] = ACTIONS(5792),
    [anon_sym_VARIABLE] = ACTIONS(5792),
    [anon_sym_VARIABLES] = ACTIONS(5792),
    [anon_sym_CONSTANT] = ACTIONS(5792),
    [anon_sym_CONSTANTS] = ACTIONS(5792),
    [anon_sym_RECURSIVE] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_INSTANCE] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_Nat] = ACTIONS(5792),
    [anon_sym_u2115] = ACTIONS(5790),
    [anon_sym_Int] = ACTIONS(5792),
    [anon_sym_u2124] = ACTIONS(5790),
    [anon_sym_Real] = ACTIONS(5792),
    [anon_sym_u211d] = ACTIONS(5790),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_BSLASHlnot] = ACTIONS(5790),
    [anon_sym_BSLASHneg] = ACTIONS(5790),
    [anon_sym_TILDE] = ACTIONS(5792),
    [anon_sym_u00ac] = ACTIONS(5790),
    [sym_union] = ACTIONS(5792),
    [sym_powerset] = ACTIONS(5792),
    [sym_domain] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [sym_negative_dot] = ACTIONS(5790),
    [sym_enabled] = ACTIONS(5792),
    [sym_unchanged] = ACTIONS(5792),
    [anon_sym_LT_GT] = ACTIONS(5790),
    [anon_sym_u22c4] = ACTIONS(5790),
    [anon_sym_u25c7] = ACTIONS(5790),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5792),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [anon_sym_ASSUME] = ACTIONS(5792),
    [anon_sym_ASSUMPTION] = ACTIONS(5792),
    [anon_sym_AXIOM] = ACTIONS(5792),
    [anon_sym_THEOREM] = ACTIONS(5792),
    [anon_sym_PROPOSITION] = ACTIONS(5792),
    [anon_sym_LEMMA] = ACTIONS(5792),
    [anon_sym_COROLLARY] = ACTIONS(5792),
    [anon_sym_USE] = ACTIONS(5792),
    [anon_sym_HIDE] = ACTIONS(5792),
    [anon_sym_DEF] = ACTIONS(5792),
    [anon_sym_DEFS] = ACTIONS(5792),
    [sym__double_excl] = ACTIONS(5790),
  },
  [2421] = {
    [sym_block_comment] = STATE(2421),
    [ts_builtin_sym_end] = ACTIONS(5794),
    [sym_identifier] = ACTIONS(5796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5794),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_LOCAL] = ACTIONS(5796),
    [anon_sym_VARIABLE] = ACTIONS(5796),
    [anon_sym_VARIABLES] = ACTIONS(5796),
    [anon_sym_CONSTANT] = ACTIONS(5796),
    [anon_sym_CONSTANTS] = ACTIONS(5796),
    [anon_sym_RECURSIVE] = ACTIONS(5796),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_INSTANCE] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_Nat] = ACTIONS(5796),
    [anon_sym_u2115] = ACTIONS(5794),
    [anon_sym_Int] = ACTIONS(5796),
    [anon_sym_u2124] = ACTIONS(5794),
    [anon_sym_Real] = ACTIONS(5796),
    [anon_sym_u211d] = ACTIONS(5794),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_BSLASHlnot] = ACTIONS(5794),
    [anon_sym_BSLASHneg] = ACTIONS(5794),
    [anon_sym_TILDE] = ACTIONS(5796),
    [anon_sym_u00ac] = ACTIONS(5794),
    [sym_union] = ACTIONS(5796),
    [sym_powerset] = ACTIONS(5796),
    [sym_domain] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [sym_negative_dot] = ACTIONS(5794),
    [sym_enabled] = ACTIONS(5796),
    [sym_unchanged] = ACTIONS(5796),
    [anon_sym_LT_GT] = ACTIONS(5794),
    [anon_sym_u22c4] = ACTIONS(5794),
    [anon_sym_u25c7] = ACTIONS(5794),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5796),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [anon_sym_ASSUME] = ACTIONS(5796),
    [anon_sym_ASSUMPTION] = ACTIONS(5796),
    [anon_sym_AXIOM] = ACTIONS(5796),
    [anon_sym_THEOREM] = ACTIONS(5796),
    [anon_sym_PROPOSITION] = ACTIONS(5796),
    [anon_sym_LEMMA] = ACTIONS(5796),
    [anon_sym_COROLLARY] = ACTIONS(5796),
    [anon_sym_USE] = ACTIONS(5796),
    [anon_sym_HIDE] = ACTIONS(5796),
    [anon_sym_DEF] = ACTIONS(5796),
    [anon_sym_DEFS] = ACTIONS(5796),
    [sym__double_excl] = ACTIONS(5794),
  },
  [2422] = {
    [sym_block_comment] = STATE(2422),
    [ts_builtin_sym_end] = ACTIONS(5798),
    [sym_identifier] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5798),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_LOCAL] = ACTIONS(5800),
    [anon_sym_VARIABLE] = ACTIONS(5800),
    [anon_sym_VARIABLES] = ACTIONS(5800),
    [anon_sym_CONSTANT] = ACTIONS(5800),
    [anon_sym_CONSTANTS] = ACTIONS(5800),
    [anon_sym_RECURSIVE] = ACTIONS(5800),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_INSTANCE] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_Nat] = ACTIONS(5800),
    [anon_sym_u2115] = ACTIONS(5798),
    [anon_sym_Int] = ACTIONS(5800),
    [anon_sym_u2124] = ACTIONS(5798),
    [anon_sym_Real] = ACTIONS(5800),
    [anon_sym_u211d] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_BSLASHlnot] = ACTIONS(5798),
    [anon_sym_BSLASHneg] = ACTIONS(5798),
    [anon_sym_TILDE] = ACTIONS(5800),
    [anon_sym_u00ac] = ACTIONS(5798),
    [sym_union] = ACTIONS(5800),
    [sym_powerset] = ACTIONS(5800),
    [sym_domain] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [sym_negative_dot] = ACTIONS(5798),
    [sym_enabled] = ACTIONS(5800),
    [sym_unchanged] = ACTIONS(5800),
    [anon_sym_LT_GT] = ACTIONS(5798),
    [anon_sym_u22c4] = ACTIONS(5798),
    [anon_sym_u25c7] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5800),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [anon_sym_ASSUME] = ACTIONS(5800),
    [anon_sym_ASSUMPTION] = ACTIONS(5800),
    [anon_sym_AXIOM] = ACTIONS(5800),
    [anon_sym_THEOREM] = ACTIONS(5800),
    [anon_sym_PROPOSITION] = ACTIONS(5800),
    [anon_sym_LEMMA] = ACTIONS(5800),
    [anon_sym_COROLLARY] = ACTIONS(5800),
    [anon_sym_USE] = ACTIONS(5800),
    [anon_sym_HIDE] = ACTIONS(5800),
    [anon_sym_DEF] = ACTIONS(5800),
    [anon_sym_DEFS] = ACTIONS(5800),
    [sym__double_excl] = ACTIONS(5798),
  },
  [2423] = {
    [sym_block_comment] = STATE(2423),
    [sym_identifier] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5778),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_LOCAL] = ACTIONS(5780),
    [anon_sym_VARIABLE] = ACTIONS(5780),
    [anon_sym_VARIABLES] = ACTIONS(5780),
    [anon_sym_CONSTANT] = ACTIONS(5780),
    [anon_sym_CONSTANTS] = ACTIONS(5780),
    [anon_sym_RECURSIVE] = ACTIONS(5780),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_INSTANCE] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_Nat] = ACTIONS(5780),
    [anon_sym_u2115] = ACTIONS(5778),
    [anon_sym_Int] = ACTIONS(5780),
    [anon_sym_u2124] = ACTIONS(5778),
    [anon_sym_Real] = ACTIONS(5780),
    [anon_sym_u211d] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_BSLASHlnot] = ACTIONS(5778),
    [anon_sym_BSLASHneg] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5780),
    [anon_sym_u00ac] = ACTIONS(5778),
    [sym_union] = ACTIONS(5780),
    [sym_powerset] = ACTIONS(5780),
    [sym_domain] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [sym_negative_dot] = ACTIONS(5778),
    [sym_enabled] = ACTIONS(5780),
    [sym_unchanged] = ACTIONS(5780),
    [anon_sym_LT_GT] = ACTIONS(5778),
    [anon_sym_u22c4] = ACTIONS(5778),
    [anon_sym_u25c7] = ACTIONS(5778),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5780),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [anon_sym_ASSUME] = ACTIONS(5780),
    [anon_sym_ASSUMPTION] = ACTIONS(5780),
    [anon_sym_AXIOM] = ACTIONS(5780),
    [anon_sym_THEOREM] = ACTIONS(5780),
    [anon_sym_PROPOSITION] = ACTIONS(5780),
    [anon_sym_LEMMA] = ACTIONS(5780),
    [anon_sym_COROLLARY] = ACTIONS(5780),
    [anon_sym_USE] = ACTIONS(5780),
    [anon_sym_HIDE] = ACTIONS(5780),
    [anon_sym_DEF] = ACTIONS(5780),
    [anon_sym_DEFS] = ACTIONS(5780),
    [sym__double_excl] = ACTIONS(5778),
  },
  [2424] = {
    [sym_block_comment] = STATE(2424),
    [sym_identifier] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5782),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_COMMA] = ACTIONS(5782),
    [anon_sym_LOCAL] = ACTIONS(5784),
    [anon_sym_VARIABLE] = ACTIONS(5784),
    [anon_sym_VARIABLES] = ACTIONS(5784),
    [anon_sym_CONSTANT] = ACTIONS(5784),
    [anon_sym_CONSTANTS] = ACTIONS(5784),
    [anon_sym_RECURSIVE] = ACTIONS(5784),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_INSTANCE] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_Nat] = ACTIONS(5784),
    [anon_sym_u2115] = ACTIONS(5782),
    [anon_sym_Int] = ACTIONS(5784),
    [anon_sym_u2124] = ACTIONS(5782),
    [anon_sym_Real] = ACTIONS(5784),
    [anon_sym_u211d] = ACTIONS(5782),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_BSLASHlnot] = ACTIONS(5782),
    [anon_sym_BSLASHneg] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [anon_sym_u00ac] = ACTIONS(5782),
    [sym_union] = ACTIONS(5784),
    [sym_powerset] = ACTIONS(5784),
    [sym_domain] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [sym_negative_dot] = ACTIONS(5782),
    [sym_enabled] = ACTIONS(5784),
    [sym_unchanged] = ACTIONS(5784),
    [anon_sym_LT_GT] = ACTIONS(5782),
    [anon_sym_u22c4] = ACTIONS(5782),
    [anon_sym_u25c7] = ACTIONS(5782),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5784),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [anon_sym_ASSUME] = ACTIONS(5784),
    [anon_sym_ASSUMPTION] = ACTIONS(5784),
    [anon_sym_AXIOM] = ACTIONS(5784),
    [anon_sym_THEOREM] = ACTIONS(5784),
    [anon_sym_PROPOSITION] = ACTIONS(5784),
    [anon_sym_LEMMA] = ACTIONS(5784),
    [anon_sym_COROLLARY] = ACTIONS(5784),
    [anon_sym_USE] = ACTIONS(5784),
    [anon_sym_HIDE] = ACTIONS(5784),
    [anon_sym_DEF] = ACTIONS(5784),
    [anon_sym_DEFS] = ACTIONS(5784),
    [sym__double_excl] = ACTIONS(5782),
  },
  [2425] = {
    [sym_block_comment] = STATE(2425),
    [sym_identifier] = ACTIONS(5868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5870),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_LOCAL] = ACTIONS(5868),
    [anon_sym_VARIABLE] = ACTIONS(5868),
    [anon_sym_VARIABLES] = ACTIONS(5868),
    [anon_sym_CONSTANT] = ACTIONS(5868),
    [anon_sym_CONSTANTS] = ACTIONS(5868),
    [anon_sym_RECURSIVE] = ACTIONS(5868),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_INSTANCE] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_Nat] = ACTIONS(5868),
    [anon_sym_u2115] = ACTIONS(5870),
    [anon_sym_Int] = ACTIONS(5868),
    [anon_sym_u2124] = ACTIONS(5870),
    [anon_sym_Real] = ACTIONS(5868),
    [anon_sym_u211d] = ACTIONS(5870),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_BSLASHlnot] = ACTIONS(5870),
    [anon_sym_BSLASHneg] = ACTIONS(5870),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_u00ac] = ACTIONS(5870),
    [sym_union] = ACTIONS(5868),
    [sym_powerset] = ACTIONS(5868),
    [sym_domain] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [sym_negative_dot] = ACTIONS(5870),
    [sym_enabled] = ACTIONS(5868),
    [sym_unchanged] = ACTIONS(5868),
    [anon_sym_LT_GT] = ACTIONS(5870),
    [anon_sym_u22c4] = ACTIONS(5870),
    [anon_sym_u25c7] = ACTIONS(5870),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5868),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [anon_sym_ASSUME] = ACTIONS(5868),
    [anon_sym_ASSUMPTION] = ACTIONS(5868),
    [anon_sym_AXIOM] = ACTIONS(5868),
    [anon_sym_THEOREM] = ACTIONS(5868),
    [anon_sym_PROPOSITION] = ACTIONS(5868),
    [anon_sym_LEMMA] = ACTIONS(5868),
    [anon_sym_COROLLARY] = ACTIONS(5868),
    [anon_sym_USE] = ACTIONS(5868),
    [anon_sym_HIDE] = ACTIONS(5868),
    [anon_sym_DEF] = ACTIONS(5868),
    [anon_sym_DEFS] = ACTIONS(5868),
    [sym__double_excl] = ACTIONS(5870),
  },
  [2426] = {
    [sym_block_comment] = STATE(2426),
    [ts_builtin_sym_end] = ACTIONS(5704),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5704),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LOCAL] = ACTIONS(5706),
    [anon_sym_VARIABLE] = ACTIONS(5706),
    [anon_sym_VARIABLES] = ACTIONS(5706),
    [anon_sym_CONSTANT] = ACTIONS(5706),
    [anon_sym_CONSTANTS] = ACTIONS(5706),
    [anon_sym_RECURSIVE] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_INSTANCE] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5706),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_ASSUME] = ACTIONS(5706),
    [anon_sym_ASSUMPTION] = ACTIONS(5706),
    [anon_sym_AXIOM] = ACTIONS(5706),
    [anon_sym_THEOREM] = ACTIONS(5706),
    [anon_sym_PROPOSITION] = ACTIONS(5706),
    [anon_sym_LEMMA] = ACTIONS(5706),
    [anon_sym_COROLLARY] = ACTIONS(5706),
    [anon_sym_USE] = ACTIONS(5706),
    [anon_sym_HIDE] = ACTIONS(5706),
    [anon_sym_DEF] = ACTIONS(5706),
    [anon_sym_DEFS] = ACTIONS(5706),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2427] = {
    [sym_block_comment] = STATE(2427),
    [ts_builtin_sym_end] = ACTIONS(5916),
    [sym_identifier] = ACTIONS(5918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5916),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_LOCAL] = ACTIONS(5918),
    [anon_sym_VARIABLE] = ACTIONS(5918),
    [anon_sym_VARIABLES] = ACTIONS(5918),
    [anon_sym_CONSTANT] = ACTIONS(5918),
    [anon_sym_CONSTANTS] = ACTIONS(5918),
    [anon_sym_RECURSIVE] = ACTIONS(5918),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_INSTANCE] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_Nat] = ACTIONS(5918),
    [anon_sym_u2115] = ACTIONS(5916),
    [anon_sym_Int] = ACTIONS(5918),
    [anon_sym_u2124] = ACTIONS(5916),
    [anon_sym_Real] = ACTIONS(5918),
    [anon_sym_u211d] = ACTIONS(5916),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_BSLASHlnot] = ACTIONS(5916),
    [anon_sym_BSLASHneg] = ACTIONS(5916),
    [anon_sym_TILDE] = ACTIONS(5918),
    [anon_sym_u00ac] = ACTIONS(5916),
    [sym_union] = ACTIONS(5918),
    [sym_powerset] = ACTIONS(5918),
    [sym_domain] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [sym_negative_dot] = ACTIONS(5916),
    [sym_enabled] = ACTIONS(5918),
    [sym_unchanged] = ACTIONS(5918),
    [anon_sym_LT_GT] = ACTIONS(5916),
    [anon_sym_u22c4] = ACTIONS(5916),
    [anon_sym_u25c7] = ACTIONS(5916),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5918),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [anon_sym_ASSUME] = ACTIONS(5918),
    [anon_sym_ASSUMPTION] = ACTIONS(5918),
    [anon_sym_AXIOM] = ACTIONS(5918),
    [anon_sym_THEOREM] = ACTIONS(5918),
    [anon_sym_PROPOSITION] = ACTIONS(5918),
    [anon_sym_LEMMA] = ACTIONS(5918),
    [anon_sym_COROLLARY] = ACTIONS(5918),
    [anon_sym_USE] = ACTIONS(5918),
    [anon_sym_HIDE] = ACTIONS(5918),
    [anon_sym_DEF] = ACTIONS(5918),
    [anon_sym_DEFS] = ACTIONS(5918),
    [sym__double_excl] = ACTIONS(5916),
  },
  [2428] = {
    [sym_block_comment] = STATE(2428),
    [sym_identifier] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5890),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_COMMA] = ACTIONS(5890),
    [anon_sym_LOCAL] = ACTIONS(5888),
    [anon_sym_VARIABLE] = ACTIONS(5888),
    [anon_sym_VARIABLES] = ACTIONS(5888),
    [anon_sym_CONSTANT] = ACTIONS(5888),
    [anon_sym_CONSTANTS] = ACTIONS(5888),
    [anon_sym_RECURSIVE] = ACTIONS(5888),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_INSTANCE] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_Nat] = ACTIONS(5888),
    [anon_sym_u2115] = ACTIONS(5890),
    [anon_sym_Int] = ACTIONS(5888),
    [anon_sym_u2124] = ACTIONS(5890),
    [anon_sym_Real] = ACTIONS(5888),
    [anon_sym_u211d] = ACTIONS(5890),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_BSLASHlnot] = ACTIONS(5890),
    [anon_sym_BSLASHneg] = ACTIONS(5890),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_u00ac] = ACTIONS(5890),
    [sym_union] = ACTIONS(5888),
    [sym_powerset] = ACTIONS(5888),
    [sym_domain] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [sym_negative_dot] = ACTIONS(5890),
    [sym_enabled] = ACTIONS(5888),
    [sym_unchanged] = ACTIONS(5888),
    [anon_sym_LT_GT] = ACTIONS(5890),
    [anon_sym_u22c4] = ACTIONS(5890),
    [anon_sym_u25c7] = ACTIONS(5890),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5888),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [anon_sym_ASSUME] = ACTIONS(5888),
    [anon_sym_ASSUMPTION] = ACTIONS(5888),
    [anon_sym_AXIOM] = ACTIONS(5888),
    [anon_sym_THEOREM] = ACTIONS(5888),
    [anon_sym_PROPOSITION] = ACTIONS(5888),
    [anon_sym_LEMMA] = ACTIONS(5888),
    [anon_sym_COROLLARY] = ACTIONS(5888),
    [anon_sym_USE] = ACTIONS(5888),
    [anon_sym_HIDE] = ACTIONS(5888),
    [anon_sym_DEF] = ACTIONS(5888),
    [anon_sym_DEFS] = ACTIONS(5888),
    [sym__double_excl] = ACTIONS(5890),
  },
  [2429] = {
    [sym_block_comment] = STATE(2429),
    [sym_identifier] = ACTIONS(5792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5790),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_COMMA] = ACTIONS(5790),
    [anon_sym_LOCAL] = ACTIONS(5792),
    [anon_sym_VARIABLE] = ACTIONS(5792),
    [anon_sym_VARIABLES] = ACTIONS(5792),
    [anon_sym_CONSTANT] = ACTIONS(5792),
    [anon_sym_CONSTANTS] = ACTIONS(5792),
    [anon_sym_RECURSIVE] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_INSTANCE] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_Nat] = ACTIONS(5792),
    [anon_sym_u2115] = ACTIONS(5790),
    [anon_sym_Int] = ACTIONS(5792),
    [anon_sym_u2124] = ACTIONS(5790),
    [anon_sym_Real] = ACTIONS(5792),
    [anon_sym_u211d] = ACTIONS(5790),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_BSLASHlnot] = ACTIONS(5790),
    [anon_sym_BSLASHneg] = ACTIONS(5790),
    [anon_sym_TILDE] = ACTIONS(5792),
    [anon_sym_u00ac] = ACTIONS(5790),
    [sym_union] = ACTIONS(5792),
    [sym_powerset] = ACTIONS(5792),
    [sym_domain] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [sym_negative_dot] = ACTIONS(5790),
    [sym_enabled] = ACTIONS(5792),
    [sym_unchanged] = ACTIONS(5792),
    [anon_sym_LT_GT] = ACTIONS(5790),
    [anon_sym_u22c4] = ACTIONS(5790),
    [anon_sym_u25c7] = ACTIONS(5790),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5792),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [anon_sym_ASSUME] = ACTIONS(5792),
    [anon_sym_ASSUMPTION] = ACTIONS(5792),
    [anon_sym_AXIOM] = ACTIONS(5792),
    [anon_sym_THEOREM] = ACTIONS(5792),
    [anon_sym_PROPOSITION] = ACTIONS(5792),
    [anon_sym_LEMMA] = ACTIONS(5792),
    [anon_sym_COROLLARY] = ACTIONS(5792),
    [anon_sym_USE] = ACTIONS(5792),
    [anon_sym_HIDE] = ACTIONS(5792),
    [anon_sym_DEF] = ACTIONS(5792),
    [anon_sym_DEFS] = ACTIONS(5792),
    [sym__double_excl] = ACTIONS(5790),
  },
  [2430] = {
    [sym_block_comment] = STATE(2430),
    [sym_identifier] = ACTIONS(5796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5794),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_LOCAL] = ACTIONS(5796),
    [anon_sym_VARIABLE] = ACTIONS(5796),
    [anon_sym_VARIABLES] = ACTIONS(5796),
    [anon_sym_CONSTANT] = ACTIONS(5796),
    [anon_sym_CONSTANTS] = ACTIONS(5796),
    [anon_sym_RECURSIVE] = ACTIONS(5796),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_INSTANCE] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_Nat] = ACTIONS(5796),
    [anon_sym_u2115] = ACTIONS(5794),
    [anon_sym_Int] = ACTIONS(5796),
    [anon_sym_u2124] = ACTIONS(5794),
    [anon_sym_Real] = ACTIONS(5796),
    [anon_sym_u211d] = ACTIONS(5794),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_BSLASHlnot] = ACTIONS(5794),
    [anon_sym_BSLASHneg] = ACTIONS(5794),
    [anon_sym_TILDE] = ACTIONS(5796),
    [anon_sym_u00ac] = ACTIONS(5794),
    [sym_union] = ACTIONS(5796),
    [sym_powerset] = ACTIONS(5796),
    [sym_domain] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [sym_negative_dot] = ACTIONS(5794),
    [sym_enabled] = ACTIONS(5796),
    [sym_unchanged] = ACTIONS(5796),
    [anon_sym_LT_GT] = ACTIONS(5794),
    [anon_sym_u22c4] = ACTIONS(5794),
    [anon_sym_u25c7] = ACTIONS(5794),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5796),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [anon_sym_ASSUME] = ACTIONS(5796),
    [anon_sym_ASSUMPTION] = ACTIONS(5796),
    [anon_sym_AXIOM] = ACTIONS(5796),
    [anon_sym_THEOREM] = ACTIONS(5796),
    [anon_sym_PROPOSITION] = ACTIONS(5796),
    [anon_sym_LEMMA] = ACTIONS(5796),
    [anon_sym_COROLLARY] = ACTIONS(5796),
    [anon_sym_USE] = ACTIONS(5796),
    [anon_sym_HIDE] = ACTIONS(5796),
    [anon_sym_DEF] = ACTIONS(5796),
    [anon_sym_DEFS] = ACTIONS(5796),
    [sym__double_excl] = ACTIONS(5794),
  },
  [2431] = {
    [sym_block_comment] = STATE(2431),
    [sym_identifier] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5798),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_LOCAL] = ACTIONS(5800),
    [anon_sym_VARIABLE] = ACTIONS(5800),
    [anon_sym_VARIABLES] = ACTIONS(5800),
    [anon_sym_CONSTANT] = ACTIONS(5800),
    [anon_sym_CONSTANTS] = ACTIONS(5800),
    [anon_sym_RECURSIVE] = ACTIONS(5800),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_INSTANCE] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_Nat] = ACTIONS(5800),
    [anon_sym_u2115] = ACTIONS(5798),
    [anon_sym_Int] = ACTIONS(5800),
    [anon_sym_u2124] = ACTIONS(5798),
    [anon_sym_Real] = ACTIONS(5800),
    [anon_sym_u211d] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_BSLASHlnot] = ACTIONS(5798),
    [anon_sym_BSLASHneg] = ACTIONS(5798),
    [anon_sym_TILDE] = ACTIONS(5800),
    [anon_sym_u00ac] = ACTIONS(5798),
    [sym_union] = ACTIONS(5800),
    [sym_powerset] = ACTIONS(5800),
    [sym_domain] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [sym_negative_dot] = ACTIONS(5798),
    [sym_enabled] = ACTIONS(5800),
    [sym_unchanged] = ACTIONS(5800),
    [anon_sym_LT_GT] = ACTIONS(5798),
    [anon_sym_u22c4] = ACTIONS(5798),
    [anon_sym_u25c7] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5800),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [anon_sym_ASSUME] = ACTIONS(5800),
    [anon_sym_ASSUMPTION] = ACTIONS(5800),
    [anon_sym_AXIOM] = ACTIONS(5800),
    [anon_sym_THEOREM] = ACTIONS(5800),
    [anon_sym_PROPOSITION] = ACTIONS(5800),
    [anon_sym_LEMMA] = ACTIONS(5800),
    [anon_sym_COROLLARY] = ACTIONS(5800),
    [anon_sym_USE] = ACTIONS(5800),
    [anon_sym_HIDE] = ACTIONS(5800),
    [anon_sym_DEF] = ACTIONS(5800),
    [anon_sym_DEFS] = ACTIONS(5800),
    [sym__double_excl] = ACTIONS(5798),
  },
  [2432] = {
    [sym_block_comment] = STATE(2432),
    [ts_builtin_sym_end] = ACTIONS(5802),
    [sym_identifier] = ACTIONS(5804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5802),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_COMMA] = ACTIONS(5802),
    [anon_sym_LOCAL] = ACTIONS(5804),
    [anon_sym_VARIABLE] = ACTIONS(5804),
    [anon_sym_VARIABLES] = ACTIONS(5804),
    [anon_sym_CONSTANT] = ACTIONS(5804),
    [anon_sym_CONSTANTS] = ACTIONS(5804),
    [anon_sym_RECURSIVE] = ACTIONS(5804),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_INSTANCE] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_Nat] = ACTIONS(5804),
    [anon_sym_u2115] = ACTIONS(5802),
    [anon_sym_Int] = ACTIONS(5804),
    [anon_sym_u2124] = ACTIONS(5802),
    [anon_sym_Real] = ACTIONS(5804),
    [anon_sym_u211d] = ACTIONS(5802),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_BSLASHlnot] = ACTIONS(5802),
    [anon_sym_BSLASHneg] = ACTIONS(5802),
    [anon_sym_TILDE] = ACTIONS(5804),
    [anon_sym_u00ac] = ACTIONS(5802),
    [sym_union] = ACTIONS(5804),
    [sym_powerset] = ACTIONS(5804),
    [sym_domain] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [sym_negative_dot] = ACTIONS(5802),
    [sym_enabled] = ACTIONS(5804),
    [sym_unchanged] = ACTIONS(5804),
    [anon_sym_LT_GT] = ACTIONS(5802),
    [anon_sym_u22c4] = ACTIONS(5802),
    [anon_sym_u25c7] = ACTIONS(5802),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5804),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [anon_sym_ASSUME] = ACTIONS(5804),
    [anon_sym_ASSUMPTION] = ACTIONS(5804),
    [anon_sym_AXIOM] = ACTIONS(5804),
    [anon_sym_THEOREM] = ACTIONS(5804),
    [anon_sym_PROPOSITION] = ACTIONS(5804),
    [anon_sym_LEMMA] = ACTIONS(5804),
    [anon_sym_COROLLARY] = ACTIONS(5804),
    [anon_sym_USE] = ACTIONS(5804),
    [anon_sym_HIDE] = ACTIONS(5804),
    [anon_sym_DEF] = ACTIONS(5804),
    [anon_sym_DEFS] = ACTIONS(5804),
    [sym__double_excl] = ACTIONS(5802),
  },
  [2433] = {
    [sym_block_comment] = STATE(2433),
    [sym_identifier] = ACTIONS(5812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5810),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_LOCAL] = ACTIONS(5812),
    [anon_sym_VARIABLE] = ACTIONS(5812),
    [anon_sym_VARIABLES] = ACTIONS(5812),
    [anon_sym_CONSTANT] = ACTIONS(5812),
    [anon_sym_CONSTANTS] = ACTIONS(5812),
    [anon_sym_RECURSIVE] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_INSTANCE] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_Nat] = ACTIONS(5812),
    [anon_sym_u2115] = ACTIONS(5810),
    [anon_sym_Int] = ACTIONS(5812),
    [anon_sym_u2124] = ACTIONS(5810),
    [anon_sym_Real] = ACTIONS(5812),
    [anon_sym_u211d] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_BSLASHlnot] = ACTIONS(5810),
    [anon_sym_BSLASHneg] = ACTIONS(5810),
    [anon_sym_TILDE] = ACTIONS(5812),
    [anon_sym_u00ac] = ACTIONS(5810),
    [sym_union] = ACTIONS(5812),
    [sym_powerset] = ACTIONS(5812),
    [sym_domain] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [sym_negative_dot] = ACTIONS(5810),
    [sym_enabled] = ACTIONS(5812),
    [sym_unchanged] = ACTIONS(5812),
    [anon_sym_LT_GT] = ACTIONS(5810),
    [anon_sym_u22c4] = ACTIONS(5810),
    [anon_sym_u25c7] = ACTIONS(5810),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5812),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [anon_sym_ASSUME] = ACTIONS(5812),
    [anon_sym_ASSUMPTION] = ACTIONS(5812),
    [anon_sym_AXIOM] = ACTIONS(5812),
    [anon_sym_THEOREM] = ACTIONS(5812),
    [anon_sym_PROPOSITION] = ACTIONS(5812),
    [anon_sym_LEMMA] = ACTIONS(5812),
    [anon_sym_COROLLARY] = ACTIONS(5812),
    [anon_sym_USE] = ACTIONS(5812),
    [anon_sym_HIDE] = ACTIONS(5812),
    [anon_sym_DEF] = ACTIONS(5812),
    [anon_sym_DEFS] = ACTIONS(5812),
    [sym__double_excl] = ACTIONS(5810),
  },
  [2434] = {
    [sym_block_comment] = STATE(2434),
    [sym_identifier] = ACTIONS(5816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5814),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_COMMA] = ACTIONS(5814),
    [anon_sym_LOCAL] = ACTIONS(5816),
    [anon_sym_VARIABLE] = ACTIONS(5816),
    [anon_sym_VARIABLES] = ACTIONS(5816),
    [anon_sym_CONSTANT] = ACTIONS(5816),
    [anon_sym_CONSTANTS] = ACTIONS(5816),
    [anon_sym_RECURSIVE] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_INSTANCE] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_Nat] = ACTIONS(5816),
    [anon_sym_u2115] = ACTIONS(5814),
    [anon_sym_Int] = ACTIONS(5816),
    [anon_sym_u2124] = ACTIONS(5814),
    [anon_sym_Real] = ACTIONS(5816),
    [anon_sym_u211d] = ACTIONS(5814),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_BSLASHlnot] = ACTIONS(5814),
    [anon_sym_BSLASHneg] = ACTIONS(5814),
    [anon_sym_TILDE] = ACTIONS(5816),
    [anon_sym_u00ac] = ACTIONS(5814),
    [sym_union] = ACTIONS(5816),
    [sym_powerset] = ACTIONS(5816),
    [sym_domain] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [sym_negative_dot] = ACTIONS(5814),
    [sym_enabled] = ACTIONS(5816),
    [sym_unchanged] = ACTIONS(5816),
    [anon_sym_LT_GT] = ACTIONS(5814),
    [anon_sym_u22c4] = ACTIONS(5814),
    [anon_sym_u25c7] = ACTIONS(5814),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5816),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [anon_sym_ASSUME] = ACTIONS(5816),
    [anon_sym_ASSUMPTION] = ACTIONS(5816),
    [anon_sym_AXIOM] = ACTIONS(5816),
    [anon_sym_THEOREM] = ACTIONS(5816),
    [anon_sym_PROPOSITION] = ACTIONS(5816),
    [anon_sym_LEMMA] = ACTIONS(5816),
    [anon_sym_COROLLARY] = ACTIONS(5816),
    [anon_sym_USE] = ACTIONS(5816),
    [anon_sym_HIDE] = ACTIONS(5816),
    [anon_sym_DEF] = ACTIONS(5816),
    [anon_sym_DEFS] = ACTIONS(5816),
    [sym__double_excl] = ACTIONS(5814),
  },
  [2435] = {
    [sym_block_comment] = STATE(2435),
    [sym_identifier] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5818),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5818),
    [anon_sym_LOCAL] = ACTIONS(5820),
    [anon_sym_VARIABLE] = ACTIONS(5820),
    [anon_sym_VARIABLES] = ACTIONS(5820),
    [anon_sym_CONSTANT] = ACTIONS(5820),
    [anon_sym_CONSTANTS] = ACTIONS(5820),
    [anon_sym_RECURSIVE] = ACTIONS(5820),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_INSTANCE] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_Nat] = ACTIONS(5820),
    [anon_sym_u2115] = ACTIONS(5818),
    [anon_sym_Int] = ACTIONS(5820),
    [anon_sym_u2124] = ACTIONS(5818),
    [anon_sym_Real] = ACTIONS(5820),
    [anon_sym_u211d] = ACTIONS(5818),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_BSLASHlnot] = ACTIONS(5818),
    [anon_sym_BSLASHneg] = ACTIONS(5818),
    [anon_sym_TILDE] = ACTIONS(5820),
    [anon_sym_u00ac] = ACTIONS(5818),
    [sym_union] = ACTIONS(5820),
    [sym_powerset] = ACTIONS(5820),
    [sym_domain] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [sym_negative_dot] = ACTIONS(5818),
    [sym_enabled] = ACTIONS(5820),
    [sym_unchanged] = ACTIONS(5820),
    [anon_sym_LT_GT] = ACTIONS(5818),
    [anon_sym_u22c4] = ACTIONS(5818),
    [anon_sym_u25c7] = ACTIONS(5818),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5820),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [anon_sym_ASSUME] = ACTIONS(5820),
    [anon_sym_ASSUMPTION] = ACTIONS(5820),
    [anon_sym_AXIOM] = ACTIONS(5820),
    [anon_sym_THEOREM] = ACTIONS(5820),
    [anon_sym_PROPOSITION] = ACTIONS(5820),
    [anon_sym_LEMMA] = ACTIONS(5820),
    [anon_sym_COROLLARY] = ACTIONS(5820),
    [anon_sym_USE] = ACTIONS(5820),
    [anon_sym_HIDE] = ACTIONS(5820),
    [anon_sym_DEF] = ACTIONS(5820),
    [anon_sym_DEFS] = ACTIONS(5820),
    [sym__double_excl] = ACTIONS(5818),
  },
  [2436] = {
    [sym_block_comment] = STATE(2436),
    [sym_identifier] = ACTIONS(5824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_LOCAL] = ACTIONS(5824),
    [anon_sym_VARIABLE] = ACTIONS(5824),
    [anon_sym_VARIABLES] = ACTIONS(5824),
    [anon_sym_CONSTANT] = ACTIONS(5824),
    [anon_sym_CONSTANTS] = ACTIONS(5824),
    [anon_sym_RECURSIVE] = ACTIONS(5824),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_INSTANCE] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_Nat] = ACTIONS(5824),
    [anon_sym_u2115] = ACTIONS(5822),
    [anon_sym_Int] = ACTIONS(5824),
    [anon_sym_u2124] = ACTIONS(5822),
    [anon_sym_Real] = ACTIONS(5824),
    [anon_sym_u211d] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_BSLASHlnot] = ACTIONS(5822),
    [anon_sym_BSLASHneg] = ACTIONS(5822),
    [anon_sym_TILDE] = ACTIONS(5824),
    [anon_sym_u00ac] = ACTIONS(5822),
    [sym_union] = ACTIONS(5824),
    [sym_powerset] = ACTIONS(5824),
    [sym_domain] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [sym_negative_dot] = ACTIONS(5822),
    [sym_enabled] = ACTIONS(5824),
    [sym_unchanged] = ACTIONS(5824),
    [anon_sym_LT_GT] = ACTIONS(5822),
    [anon_sym_u22c4] = ACTIONS(5822),
    [anon_sym_u25c7] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5824),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [anon_sym_ASSUME] = ACTIONS(5824),
    [anon_sym_ASSUMPTION] = ACTIONS(5824),
    [anon_sym_AXIOM] = ACTIONS(5824),
    [anon_sym_THEOREM] = ACTIONS(5824),
    [anon_sym_PROPOSITION] = ACTIONS(5824),
    [anon_sym_LEMMA] = ACTIONS(5824),
    [anon_sym_COROLLARY] = ACTIONS(5824),
    [anon_sym_USE] = ACTIONS(5824),
    [anon_sym_HIDE] = ACTIONS(5824),
    [anon_sym_DEF] = ACTIONS(5824),
    [anon_sym_DEFS] = ACTIONS(5824),
    [sym__double_excl] = ACTIONS(5822),
  },
  [2437] = {
    [sym_block_comment] = STATE(2437),
    [sym_identifier] = ACTIONS(5828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5826),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_COMMA] = ACTIONS(5826),
    [anon_sym_LOCAL] = ACTIONS(5828),
    [anon_sym_VARIABLE] = ACTIONS(5828),
    [anon_sym_VARIABLES] = ACTIONS(5828),
    [anon_sym_CONSTANT] = ACTIONS(5828),
    [anon_sym_CONSTANTS] = ACTIONS(5828),
    [anon_sym_RECURSIVE] = ACTIONS(5828),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_INSTANCE] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_Nat] = ACTIONS(5828),
    [anon_sym_u2115] = ACTIONS(5826),
    [anon_sym_Int] = ACTIONS(5828),
    [anon_sym_u2124] = ACTIONS(5826),
    [anon_sym_Real] = ACTIONS(5828),
    [anon_sym_u211d] = ACTIONS(5826),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_BSLASHlnot] = ACTIONS(5826),
    [anon_sym_BSLASHneg] = ACTIONS(5826),
    [anon_sym_TILDE] = ACTIONS(5828),
    [anon_sym_u00ac] = ACTIONS(5826),
    [sym_union] = ACTIONS(5828),
    [sym_powerset] = ACTIONS(5828),
    [sym_domain] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [sym_negative_dot] = ACTIONS(5826),
    [sym_enabled] = ACTIONS(5828),
    [sym_unchanged] = ACTIONS(5828),
    [anon_sym_LT_GT] = ACTIONS(5826),
    [anon_sym_u22c4] = ACTIONS(5826),
    [anon_sym_u25c7] = ACTIONS(5826),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5828),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [anon_sym_ASSUME] = ACTIONS(5828),
    [anon_sym_ASSUMPTION] = ACTIONS(5828),
    [anon_sym_AXIOM] = ACTIONS(5828),
    [anon_sym_THEOREM] = ACTIONS(5828),
    [anon_sym_PROPOSITION] = ACTIONS(5828),
    [anon_sym_LEMMA] = ACTIONS(5828),
    [anon_sym_COROLLARY] = ACTIONS(5828),
    [anon_sym_USE] = ACTIONS(5828),
    [anon_sym_HIDE] = ACTIONS(5828),
    [anon_sym_DEF] = ACTIONS(5828),
    [anon_sym_DEFS] = ACTIONS(5828),
    [sym__double_excl] = ACTIONS(5826),
  },
  [2438] = {
    [sym_block_comment] = STATE(2438),
    [sym_identifier] = ACTIONS(5832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5830),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_COMMA] = ACTIONS(5830),
    [anon_sym_LOCAL] = ACTIONS(5832),
    [anon_sym_VARIABLE] = ACTIONS(5832),
    [anon_sym_VARIABLES] = ACTIONS(5832),
    [anon_sym_CONSTANT] = ACTIONS(5832),
    [anon_sym_CONSTANTS] = ACTIONS(5832),
    [anon_sym_RECURSIVE] = ACTIONS(5832),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_INSTANCE] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_Nat] = ACTIONS(5832),
    [anon_sym_u2115] = ACTIONS(5830),
    [anon_sym_Int] = ACTIONS(5832),
    [anon_sym_u2124] = ACTIONS(5830),
    [anon_sym_Real] = ACTIONS(5832),
    [anon_sym_u211d] = ACTIONS(5830),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_BSLASHlnot] = ACTIONS(5830),
    [anon_sym_BSLASHneg] = ACTIONS(5830),
    [anon_sym_TILDE] = ACTIONS(5832),
    [anon_sym_u00ac] = ACTIONS(5830),
    [sym_union] = ACTIONS(5832),
    [sym_powerset] = ACTIONS(5832),
    [sym_domain] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [sym_negative_dot] = ACTIONS(5830),
    [sym_enabled] = ACTIONS(5832),
    [sym_unchanged] = ACTIONS(5832),
    [anon_sym_LT_GT] = ACTIONS(5830),
    [anon_sym_u22c4] = ACTIONS(5830),
    [anon_sym_u25c7] = ACTIONS(5830),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5832),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [anon_sym_ASSUME] = ACTIONS(5832),
    [anon_sym_ASSUMPTION] = ACTIONS(5832),
    [anon_sym_AXIOM] = ACTIONS(5832),
    [anon_sym_THEOREM] = ACTIONS(5832),
    [anon_sym_PROPOSITION] = ACTIONS(5832),
    [anon_sym_LEMMA] = ACTIONS(5832),
    [anon_sym_COROLLARY] = ACTIONS(5832),
    [anon_sym_USE] = ACTIONS(5832),
    [anon_sym_HIDE] = ACTIONS(5832),
    [anon_sym_DEF] = ACTIONS(5832),
    [anon_sym_DEFS] = ACTIONS(5832),
    [sym__double_excl] = ACTIONS(5830),
  },
  [2439] = {
    [sym_block_comment] = STATE(2439),
    [sym_identifier] = ACTIONS(5836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5834),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_LOCAL] = ACTIONS(5836),
    [anon_sym_VARIABLE] = ACTIONS(5836),
    [anon_sym_VARIABLES] = ACTIONS(5836),
    [anon_sym_CONSTANT] = ACTIONS(5836),
    [anon_sym_CONSTANTS] = ACTIONS(5836),
    [anon_sym_RECURSIVE] = ACTIONS(5836),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_INSTANCE] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_Nat] = ACTIONS(5836),
    [anon_sym_u2115] = ACTIONS(5834),
    [anon_sym_Int] = ACTIONS(5836),
    [anon_sym_u2124] = ACTIONS(5834),
    [anon_sym_Real] = ACTIONS(5836),
    [anon_sym_u211d] = ACTIONS(5834),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_BSLASHlnot] = ACTIONS(5834),
    [anon_sym_BSLASHneg] = ACTIONS(5834),
    [anon_sym_TILDE] = ACTIONS(5836),
    [anon_sym_u00ac] = ACTIONS(5834),
    [sym_union] = ACTIONS(5836),
    [sym_powerset] = ACTIONS(5836),
    [sym_domain] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [sym_negative_dot] = ACTIONS(5834),
    [sym_enabled] = ACTIONS(5836),
    [sym_unchanged] = ACTIONS(5836),
    [anon_sym_LT_GT] = ACTIONS(5834),
    [anon_sym_u22c4] = ACTIONS(5834),
    [anon_sym_u25c7] = ACTIONS(5834),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5836),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [anon_sym_ASSUME] = ACTIONS(5836),
    [anon_sym_ASSUMPTION] = ACTIONS(5836),
    [anon_sym_AXIOM] = ACTIONS(5836),
    [anon_sym_THEOREM] = ACTIONS(5836),
    [anon_sym_PROPOSITION] = ACTIONS(5836),
    [anon_sym_LEMMA] = ACTIONS(5836),
    [anon_sym_COROLLARY] = ACTIONS(5836),
    [anon_sym_USE] = ACTIONS(5836),
    [anon_sym_HIDE] = ACTIONS(5836),
    [anon_sym_DEF] = ACTIONS(5836),
    [anon_sym_DEFS] = ACTIONS(5836),
    [sym__double_excl] = ACTIONS(5834),
  },
  [2440] = {
    [sym_block_comment] = STATE(2440),
    [sym_identifier] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5728),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_LOCAL] = ACTIONS(5730),
    [anon_sym_VARIABLE] = ACTIONS(5730),
    [anon_sym_VARIABLES] = ACTIONS(5730),
    [anon_sym_CONSTANT] = ACTIONS(5730),
    [anon_sym_CONSTANTS] = ACTIONS(5730),
    [anon_sym_RECURSIVE] = ACTIONS(5730),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_INSTANCE] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_Nat] = ACTIONS(5730),
    [anon_sym_u2115] = ACTIONS(5728),
    [anon_sym_Int] = ACTIONS(5730),
    [anon_sym_u2124] = ACTIONS(5728),
    [anon_sym_Real] = ACTIONS(5730),
    [anon_sym_u211d] = ACTIONS(5728),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_BSLASHlnot] = ACTIONS(5728),
    [anon_sym_BSLASHneg] = ACTIONS(5728),
    [anon_sym_TILDE] = ACTIONS(5730),
    [anon_sym_u00ac] = ACTIONS(5728),
    [sym_union] = ACTIONS(5730),
    [sym_powerset] = ACTIONS(5730),
    [sym_domain] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [sym_negative_dot] = ACTIONS(5728),
    [sym_enabled] = ACTIONS(5730),
    [sym_unchanged] = ACTIONS(5730),
    [anon_sym_LT_GT] = ACTIONS(5728),
    [anon_sym_u22c4] = ACTIONS(5728),
    [anon_sym_u25c7] = ACTIONS(5728),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5730),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [anon_sym_ASSUME] = ACTIONS(5730),
    [anon_sym_ASSUMPTION] = ACTIONS(5730),
    [anon_sym_AXIOM] = ACTIONS(5730),
    [anon_sym_THEOREM] = ACTIONS(5730),
    [anon_sym_PROPOSITION] = ACTIONS(5730),
    [anon_sym_LEMMA] = ACTIONS(5730),
    [anon_sym_COROLLARY] = ACTIONS(5730),
    [anon_sym_USE] = ACTIONS(5730),
    [anon_sym_HIDE] = ACTIONS(5730),
    [anon_sym_DEF] = ACTIONS(5730),
    [anon_sym_DEFS] = ACTIONS(5730),
    [sym__double_excl] = ACTIONS(5728),
  },
  [2441] = {
    [sym_block_comment] = STATE(2441),
    [ts_builtin_sym_end] = ACTIONS(5732),
    [sym_identifier] = ACTIONS(5734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5732),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_COMMA] = ACTIONS(5732),
    [anon_sym_LOCAL] = ACTIONS(5734),
    [anon_sym_VARIABLE] = ACTIONS(5734),
    [anon_sym_VARIABLES] = ACTIONS(5734),
    [anon_sym_CONSTANT] = ACTIONS(5734),
    [anon_sym_CONSTANTS] = ACTIONS(5734),
    [anon_sym_RECURSIVE] = ACTIONS(5734),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_INSTANCE] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_Nat] = ACTIONS(5734),
    [anon_sym_u2115] = ACTIONS(5732),
    [anon_sym_Int] = ACTIONS(5734),
    [anon_sym_u2124] = ACTIONS(5732),
    [anon_sym_Real] = ACTIONS(5734),
    [anon_sym_u211d] = ACTIONS(5732),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_BSLASHlnot] = ACTIONS(5732),
    [anon_sym_BSLASHneg] = ACTIONS(5732),
    [anon_sym_TILDE] = ACTIONS(5734),
    [anon_sym_u00ac] = ACTIONS(5732),
    [sym_union] = ACTIONS(5734),
    [sym_powerset] = ACTIONS(5734),
    [sym_domain] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [sym_negative_dot] = ACTIONS(5732),
    [sym_enabled] = ACTIONS(5734),
    [sym_unchanged] = ACTIONS(5734),
    [anon_sym_LT_GT] = ACTIONS(5732),
    [anon_sym_u22c4] = ACTIONS(5732),
    [anon_sym_u25c7] = ACTIONS(5732),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5734),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [anon_sym_ASSUME] = ACTIONS(5734),
    [anon_sym_ASSUMPTION] = ACTIONS(5734),
    [anon_sym_AXIOM] = ACTIONS(5734),
    [anon_sym_THEOREM] = ACTIONS(5734),
    [anon_sym_PROPOSITION] = ACTIONS(5734),
    [anon_sym_LEMMA] = ACTIONS(5734),
    [anon_sym_COROLLARY] = ACTIONS(5734),
    [anon_sym_USE] = ACTIONS(5734),
    [anon_sym_HIDE] = ACTIONS(5734),
    [anon_sym_DEF] = ACTIONS(5734),
    [anon_sym_DEFS] = ACTIONS(5734),
    [sym__double_excl] = ACTIONS(5732),
  },
  [2442] = {
    [sym_block_comment] = STATE(2442),
    [sym_identifier] = ACTIONS(5734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5732),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_COMMA] = ACTIONS(5732),
    [anon_sym_LOCAL] = ACTIONS(5734),
    [anon_sym_VARIABLE] = ACTIONS(5734),
    [anon_sym_VARIABLES] = ACTIONS(5734),
    [anon_sym_CONSTANT] = ACTIONS(5734),
    [anon_sym_CONSTANTS] = ACTIONS(5734),
    [anon_sym_RECURSIVE] = ACTIONS(5734),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_INSTANCE] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_Nat] = ACTIONS(5734),
    [anon_sym_u2115] = ACTIONS(5732),
    [anon_sym_Int] = ACTIONS(5734),
    [anon_sym_u2124] = ACTIONS(5732),
    [anon_sym_Real] = ACTIONS(5734),
    [anon_sym_u211d] = ACTIONS(5732),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_BSLASHlnot] = ACTIONS(5732),
    [anon_sym_BSLASHneg] = ACTIONS(5732),
    [anon_sym_TILDE] = ACTIONS(5734),
    [anon_sym_u00ac] = ACTIONS(5732),
    [sym_union] = ACTIONS(5734),
    [sym_powerset] = ACTIONS(5734),
    [sym_domain] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [sym_negative_dot] = ACTIONS(5732),
    [sym_enabled] = ACTIONS(5734),
    [sym_unchanged] = ACTIONS(5734),
    [anon_sym_LT_GT] = ACTIONS(5732),
    [anon_sym_u22c4] = ACTIONS(5732),
    [anon_sym_u25c7] = ACTIONS(5732),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5734),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [anon_sym_ASSUME] = ACTIONS(5734),
    [anon_sym_ASSUMPTION] = ACTIONS(5734),
    [anon_sym_AXIOM] = ACTIONS(5734),
    [anon_sym_THEOREM] = ACTIONS(5734),
    [anon_sym_PROPOSITION] = ACTIONS(5734),
    [anon_sym_LEMMA] = ACTIONS(5734),
    [anon_sym_COROLLARY] = ACTIONS(5734),
    [anon_sym_USE] = ACTIONS(5734),
    [anon_sym_HIDE] = ACTIONS(5734),
    [anon_sym_DEF] = ACTIONS(5734),
    [anon_sym_DEFS] = ACTIONS(5734),
    [sym__double_excl] = ACTIONS(5732),
  },
  [2443] = {
    [sym_block_comment] = STATE(2443),
    [sym_identifier] = ACTIONS(5848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5846),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_LOCAL] = ACTIONS(5848),
    [anon_sym_VARIABLE] = ACTIONS(5848),
    [anon_sym_VARIABLES] = ACTIONS(5848),
    [anon_sym_CONSTANT] = ACTIONS(5848),
    [anon_sym_CONSTANTS] = ACTIONS(5848),
    [anon_sym_RECURSIVE] = ACTIONS(5848),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_INSTANCE] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_Nat] = ACTIONS(5848),
    [anon_sym_u2115] = ACTIONS(5846),
    [anon_sym_Int] = ACTIONS(5848),
    [anon_sym_u2124] = ACTIONS(5846),
    [anon_sym_Real] = ACTIONS(5848),
    [anon_sym_u211d] = ACTIONS(5846),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_BSLASHlnot] = ACTIONS(5846),
    [anon_sym_BSLASHneg] = ACTIONS(5846),
    [anon_sym_TILDE] = ACTIONS(5848),
    [anon_sym_u00ac] = ACTIONS(5846),
    [sym_union] = ACTIONS(5848),
    [sym_powerset] = ACTIONS(5848),
    [sym_domain] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [sym_negative_dot] = ACTIONS(5846),
    [sym_enabled] = ACTIONS(5848),
    [sym_unchanged] = ACTIONS(5848),
    [anon_sym_LT_GT] = ACTIONS(5846),
    [anon_sym_u22c4] = ACTIONS(5846),
    [anon_sym_u25c7] = ACTIONS(5846),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5848),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [anon_sym_ASSUME] = ACTIONS(5848),
    [anon_sym_ASSUMPTION] = ACTIONS(5848),
    [anon_sym_AXIOM] = ACTIONS(5848),
    [anon_sym_THEOREM] = ACTIONS(5848),
    [anon_sym_PROPOSITION] = ACTIONS(5848),
    [anon_sym_LEMMA] = ACTIONS(5848),
    [anon_sym_COROLLARY] = ACTIONS(5848),
    [anon_sym_USE] = ACTIONS(5848),
    [anon_sym_HIDE] = ACTIONS(5848),
    [anon_sym_DEF] = ACTIONS(5848),
    [anon_sym_DEFS] = ACTIONS(5848),
    [sym__double_excl] = ACTIONS(5846),
  },
  [2444] = {
    [sym_block_comment] = STATE(2444),
    [sym_identifier] = ACTIONS(5874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5872),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_COMMA] = ACTIONS(5872),
    [anon_sym_LOCAL] = ACTIONS(5874),
    [anon_sym_VARIABLE] = ACTIONS(5874),
    [anon_sym_VARIABLES] = ACTIONS(5874),
    [anon_sym_CONSTANT] = ACTIONS(5874),
    [anon_sym_CONSTANTS] = ACTIONS(5874),
    [anon_sym_RECURSIVE] = ACTIONS(5874),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_INSTANCE] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_Nat] = ACTIONS(5874),
    [anon_sym_u2115] = ACTIONS(5872),
    [anon_sym_Int] = ACTIONS(5874),
    [anon_sym_u2124] = ACTIONS(5872),
    [anon_sym_Real] = ACTIONS(5874),
    [anon_sym_u211d] = ACTIONS(5872),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_BSLASHlnot] = ACTIONS(5872),
    [anon_sym_BSLASHneg] = ACTIONS(5872),
    [anon_sym_TILDE] = ACTIONS(5874),
    [anon_sym_u00ac] = ACTIONS(5872),
    [sym_union] = ACTIONS(5874),
    [sym_powerset] = ACTIONS(5874),
    [sym_domain] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [sym_negative_dot] = ACTIONS(5872),
    [sym_enabled] = ACTIONS(5874),
    [sym_unchanged] = ACTIONS(5874),
    [anon_sym_LT_GT] = ACTIONS(5872),
    [anon_sym_u22c4] = ACTIONS(5872),
    [anon_sym_u25c7] = ACTIONS(5872),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5874),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [anon_sym_ASSUME] = ACTIONS(5874),
    [anon_sym_ASSUMPTION] = ACTIONS(5874),
    [anon_sym_AXIOM] = ACTIONS(5874),
    [anon_sym_THEOREM] = ACTIONS(5874),
    [anon_sym_PROPOSITION] = ACTIONS(5874),
    [anon_sym_LEMMA] = ACTIONS(5874),
    [anon_sym_COROLLARY] = ACTIONS(5874),
    [anon_sym_USE] = ACTIONS(5874),
    [anon_sym_HIDE] = ACTIONS(5874),
    [anon_sym_DEF] = ACTIONS(5874),
    [anon_sym_DEFS] = ACTIONS(5874),
    [sym__double_excl] = ACTIONS(5872),
  },
  [2445] = {
    [sym_block_comment] = STATE(2445),
    [sym_identifier] = ACTIONS(5878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5876),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_COMMA] = ACTIONS(5876),
    [anon_sym_LOCAL] = ACTIONS(5878),
    [anon_sym_VARIABLE] = ACTIONS(5878),
    [anon_sym_VARIABLES] = ACTIONS(5878),
    [anon_sym_CONSTANT] = ACTIONS(5878),
    [anon_sym_CONSTANTS] = ACTIONS(5878),
    [anon_sym_RECURSIVE] = ACTIONS(5878),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_INSTANCE] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_Nat] = ACTIONS(5878),
    [anon_sym_u2115] = ACTIONS(5876),
    [anon_sym_Int] = ACTIONS(5878),
    [anon_sym_u2124] = ACTIONS(5876),
    [anon_sym_Real] = ACTIONS(5878),
    [anon_sym_u211d] = ACTIONS(5876),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_BSLASHlnot] = ACTIONS(5876),
    [anon_sym_BSLASHneg] = ACTIONS(5876),
    [anon_sym_TILDE] = ACTIONS(5878),
    [anon_sym_u00ac] = ACTIONS(5876),
    [sym_union] = ACTIONS(5878),
    [sym_powerset] = ACTIONS(5878),
    [sym_domain] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [sym_negative_dot] = ACTIONS(5876),
    [sym_enabled] = ACTIONS(5878),
    [sym_unchanged] = ACTIONS(5878),
    [anon_sym_LT_GT] = ACTIONS(5876),
    [anon_sym_u22c4] = ACTIONS(5876),
    [anon_sym_u25c7] = ACTIONS(5876),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5878),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [anon_sym_ASSUME] = ACTIONS(5878),
    [anon_sym_ASSUMPTION] = ACTIONS(5878),
    [anon_sym_AXIOM] = ACTIONS(5878),
    [anon_sym_THEOREM] = ACTIONS(5878),
    [anon_sym_PROPOSITION] = ACTIONS(5878),
    [anon_sym_LEMMA] = ACTIONS(5878),
    [anon_sym_COROLLARY] = ACTIONS(5878),
    [anon_sym_USE] = ACTIONS(5878),
    [anon_sym_HIDE] = ACTIONS(5878),
    [anon_sym_DEF] = ACTIONS(5878),
    [anon_sym_DEFS] = ACTIONS(5878),
    [sym__double_excl] = ACTIONS(5876),
  },
  [2446] = {
    [sym_block_comment] = STATE(2446),
    [sym_identifier] = ACTIONS(5882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5880),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_COMMA] = ACTIONS(5880),
    [anon_sym_LOCAL] = ACTIONS(5882),
    [anon_sym_VARIABLE] = ACTIONS(5882),
    [anon_sym_VARIABLES] = ACTIONS(5882),
    [anon_sym_CONSTANT] = ACTIONS(5882),
    [anon_sym_CONSTANTS] = ACTIONS(5882),
    [anon_sym_RECURSIVE] = ACTIONS(5882),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_INSTANCE] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_Nat] = ACTIONS(5882),
    [anon_sym_u2115] = ACTIONS(5880),
    [anon_sym_Int] = ACTIONS(5882),
    [anon_sym_u2124] = ACTIONS(5880),
    [anon_sym_Real] = ACTIONS(5882),
    [anon_sym_u211d] = ACTIONS(5880),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_BSLASHlnot] = ACTIONS(5880),
    [anon_sym_BSLASHneg] = ACTIONS(5880),
    [anon_sym_TILDE] = ACTIONS(5882),
    [anon_sym_u00ac] = ACTIONS(5880),
    [sym_union] = ACTIONS(5882),
    [sym_powerset] = ACTIONS(5882),
    [sym_domain] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [sym_negative_dot] = ACTIONS(5880),
    [sym_enabled] = ACTIONS(5882),
    [sym_unchanged] = ACTIONS(5882),
    [anon_sym_LT_GT] = ACTIONS(5880),
    [anon_sym_u22c4] = ACTIONS(5880),
    [anon_sym_u25c7] = ACTIONS(5880),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5882),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [anon_sym_ASSUME] = ACTIONS(5882),
    [anon_sym_ASSUMPTION] = ACTIONS(5882),
    [anon_sym_AXIOM] = ACTIONS(5882),
    [anon_sym_THEOREM] = ACTIONS(5882),
    [anon_sym_PROPOSITION] = ACTIONS(5882),
    [anon_sym_LEMMA] = ACTIONS(5882),
    [anon_sym_COROLLARY] = ACTIONS(5882),
    [anon_sym_USE] = ACTIONS(5882),
    [anon_sym_HIDE] = ACTIONS(5882),
    [anon_sym_DEF] = ACTIONS(5882),
    [anon_sym_DEFS] = ACTIONS(5882),
    [sym__double_excl] = ACTIONS(5880),
  },
  [2447] = {
    [sym_block_comment] = STATE(2447),
    [sym_identifier] = ACTIONS(5936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5938),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_LOCAL] = ACTIONS(5936),
    [anon_sym_VARIABLE] = ACTIONS(5936),
    [anon_sym_VARIABLES] = ACTIONS(5936),
    [anon_sym_CONSTANT] = ACTIONS(5936),
    [anon_sym_CONSTANTS] = ACTIONS(5936),
    [anon_sym_RECURSIVE] = ACTIONS(5936),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_INSTANCE] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_Nat] = ACTIONS(5936),
    [anon_sym_u2115] = ACTIONS(5938),
    [anon_sym_Int] = ACTIONS(5936),
    [anon_sym_u2124] = ACTIONS(5938),
    [anon_sym_Real] = ACTIONS(5936),
    [anon_sym_u211d] = ACTIONS(5938),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_BSLASHlnot] = ACTIONS(5938),
    [anon_sym_BSLASHneg] = ACTIONS(5938),
    [anon_sym_TILDE] = ACTIONS(5936),
    [anon_sym_u00ac] = ACTIONS(5938),
    [sym_union] = ACTIONS(5936),
    [sym_powerset] = ACTIONS(5936),
    [sym_domain] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [sym_negative_dot] = ACTIONS(5938),
    [sym_enabled] = ACTIONS(5936),
    [sym_unchanged] = ACTIONS(5936),
    [anon_sym_LT_GT] = ACTIONS(5938),
    [anon_sym_u22c4] = ACTIONS(5938),
    [anon_sym_u25c7] = ACTIONS(5938),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5936),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [anon_sym_ASSUME] = ACTIONS(5936),
    [anon_sym_ASSUMPTION] = ACTIONS(5936),
    [anon_sym_AXIOM] = ACTIONS(5936),
    [anon_sym_THEOREM] = ACTIONS(5936),
    [anon_sym_PROPOSITION] = ACTIONS(5936),
    [anon_sym_LEMMA] = ACTIONS(5936),
    [anon_sym_COROLLARY] = ACTIONS(5936),
    [anon_sym_USE] = ACTIONS(5936),
    [anon_sym_HIDE] = ACTIONS(5936),
    [anon_sym_DEF] = ACTIONS(5936),
    [anon_sym_DEFS] = ACTIONS(5936),
    [sym__double_excl] = ACTIONS(5938),
  },
  [2448] = {
    [sym_block_comment] = STATE(2448),
    [sym_identifier] = ACTIONS(5886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5884),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_COMMA] = ACTIONS(5884),
    [anon_sym_LOCAL] = ACTIONS(5886),
    [anon_sym_VARIABLE] = ACTIONS(5886),
    [anon_sym_VARIABLES] = ACTIONS(5886),
    [anon_sym_CONSTANT] = ACTIONS(5886),
    [anon_sym_CONSTANTS] = ACTIONS(5886),
    [anon_sym_RECURSIVE] = ACTIONS(5886),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_INSTANCE] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_Nat] = ACTIONS(5886),
    [anon_sym_u2115] = ACTIONS(5884),
    [anon_sym_Int] = ACTIONS(5886),
    [anon_sym_u2124] = ACTIONS(5884),
    [anon_sym_Real] = ACTIONS(5886),
    [anon_sym_u211d] = ACTIONS(5884),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_BSLASHlnot] = ACTIONS(5884),
    [anon_sym_BSLASHneg] = ACTIONS(5884),
    [anon_sym_TILDE] = ACTIONS(5886),
    [anon_sym_u00ac] = ACTIONS(5884),
    [sym_union] = ACTIONS(5886),
    [sym_powerset] = ACTIONS(5886),
    [sym_domain] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [sym_negative_dot] = ACTIONS(5884),
    [sym_enabled] = ACTIONS(5886),
    [sym_unchanged] = ACTIONS(5886),
    [anon_sym_LT_GT] = ACTIONS(5884),
    [anon_sym_u22c4] = ACTIONS(5884),
    [anon_sym_u25c7] = ACTIONS(5884),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5886),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [anon_sym_ASSUME] = ACTIONS(5886),
    [anon_sym_ASSUMPTION] = ACTIONS(5886),
    [anon_sym_AXIOM] = ACTIONS(5886),
    [anon_sym_THEOREM] = ACTIONS(5886),
    [anon_sym_PROPOSITION] = ACTIONS(5886),
    [anon_sym_LEMMA] = ACTIONS(5886),
    [anon_sym_COROLLARY] = ACTIONS(5886),
    [anon_sym_USE] = ACTIONS(5886),
    [anon_sym_HIDE] = ACTIONS(5886),
    [anon_sym_DEF] = ACTIONS(5886),
    [anon_sym_DEFS] = ACTIONS(5886),
    [sym__double_excl] = ACTIONS(5884),
  },
  [2449] = {
    [sym_block_comment] = STATE(2449),
    [sym_identifier] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5740),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5740),
    [anon_sym_LOCAL] = ACTIONS(5742),
    [anon_sym_VARIABLE] = ACTIONS(5742),
    [anon_sym_VARIABLES] = ACTIONS(5742),
    [anon_sym_CONSTANT] = ACTIONS(5742),
    [anon_sym_CONSTANTS] = ACTIONS(5742),
    [anon_sym_RECURSIVE] = ACTIONS(5742),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_INSTANCE] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_Nat] = ACTIONS(5742),
    [anon_sym_u2115] = ACTIONS(5740),
    [anon_sym_Int] = ACTIONS(5742),
    [anon_sym_u2124] = ACTIONS(5740),
    [anon_sym_Real] = ACTIONS(5742),
    [anon_sym_u211d] = ACTIONS(5740),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_BSLASHlnot] = ACTIONS(5740),
    [anon_sym_BSLASHneg] = ACTIONS(5740),
    [anon_sym_TILDE] = ACTIONS(5742),
    [anon_sym_u00ac] = ACTIONS(5740),
    [sym_union] = ACTIONS(5742),
    [sym_powerset] = ACTIONS(5742),
    [sym_domain] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [sym_negative_dot] = ACTIONS(5740),
    [sym_enabled] = ACTIONS(5742),
    [sym_unchanged] = ACTIONS(5742),
    [anon_sym_LT_GT] = ACTIONS(5740),
    [anon_sym_u22c4] = ACTIONS(5740),
    [anon_sym_u25c7] = ACTIONS(5740),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5742),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [anon_sym_ASSUME] = ACTIONS(5742),
    [anon_sym_ASSUMPTION] = ACTIONS(5742),
    [anon_sym_AXIOM] = ACTIONS(5742),
    [anon_sym_THEOREM] = ACTIONS(5742),
    [anon_sym_PROPOSITION] = ACTIONS(5742),
    [anon_sym_LEMMA] = ACTIONS(5742),
    [anon_sym_COROLLARY] = ACTIONS(5742),
    [anon_sym_USE] = ACTIONS(5742),
    [anon_sym_HIDE] = ACTIONS(5742),
    [anon_sym_DEF] = ACTIONS(5742),
    [anon_sym_DEFS] = ACTIONS(5742),
    [sym__double_excl] = ACTIONS(5740),
  },
  [2450] = {
    [sym_block_comment] = STATE(2450),
    [ts_builtin_sym_end] = ACTIONS(5920),
    [sym_identifier] = ACTIONS(5922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5920),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_LOCAL] = ACTIONS(5922),
    [anon_sym_VARIABLE] = ACTIONS(5922),
    [anon_sym_VARIABLES] = ACTIONS(5922),
    [anon_sym_CONSTANT] = ACTIONS(5922),
    [anon_sym_CONSTANTS] = ACTIONS(5922),
    [anon_sym_RECURSIVE] = ACTIONS(5922),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_INSTANCE] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_Nat] = ACTIONS(5922),
    [anon_sym_u2115] = ACTIONS(5920),
    [anon_sym_Int] = ACTIONS(5922),
    [anon_sym_u2124] = ACTIONS(5920),
    [anon_sym_Real] = ACTIONS(5922),
    [anon_sym_u211d] = ACTIONS(5920),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_BSLASHlnot] = ACTIONS(5920),
    [anon_sym_BSLASHneg] = ACTIONS(5920),
    [anon_sym_TILDE] = ACTIONS(5922),
    [anon_sym_u00ac] = ACTIONS(5920),
    [sym_union] = ACTIONS(5922),
    [sym_powerset] = ACTIONS(5922),
    [sym_domain] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [sym_negative_dot] = ACTIONS(5920),
    [sym_enabled] = ACTIONS(5922),
    [sym_unchanged] = ACTIONS(5922),
    [anon_sym_LT_GT] = ACTIONS(5920),
    [anon_sym_u22c4] = ACTIONS(5920),
    [anon_sym_u25c7] = ACTIONS(5920),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5922),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [anon_sym_ASSUME] = ACTIONS(5922),
    [anon_sym_ASSUMPTION] = ACTIONS(5922),
    [anon_sym_AXIOM] = ACTIONS(5922),
    [anon_sym_THEOREM] = ACTIONS(5922),
    [anon_sym_PROPOSITION] = ACTIONS(5922),
    [anon_sym_LEMMA] = ACTIONS(5922),
    [anon_sym_COROLLARY] = ACTIONS(5922),
    [anon_sym_USE] = ACTIONS(5922),
    [anon_sym_HIDE] = ACTIONS(5922),
    [anon_sym_DEF] = ACTIONS(5922),
    [anon_sym_DEFS] = ACTIONS(5922),
    [sym__double_excl] = ACTIONS(5920),
  },
  [2451] = {
    [sym_block_comment] = STATE(2451),
    [ts_builtin_sym_end] = ACTIONS(5752),
    [sym_identifier] = ACTIONS(5754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5752),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_LOCAL] = ACTIONS(5754),
    [anon_sym_VARIABLE] = ACTIONS(5754),
    [anon_sym_VARIABLES] = ACTIONS(5754),
    [anon_sym_CONSTANT] = ACTIONS(5754),
    [anon_sym_CONSTANTS] = ACTIONS(5754),
    [anon_sym_RECURSIVE] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_INSTANCE] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_Nat] = ACTIONS(5754),
    [anon_sym_u2115] = ACTIONS(5752),
    [anon_sym_Int] = ACTIONS(5754),
    [anon_sym_u2124] = ACTIONS(5752),
    [anon_sym_Real] = ACTIONS(5754),
    [anon_sym_u211d] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_BSLASHlnot] = ACTIONS(5752),
    [anon_sym_BSLASHneg] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(5754),
    [anon_sym_u00ac] = ACTIONS(5752),
    [sym_union] = ACTIONS(5754),
    [sym_powerset] = ACTIONS(5754),
    [sym_domain] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [sym_negative_dot] = ACTIONS(5752),
    [sym_enabled] = ACTIONS(5754),
    [sym_unchanged] = ACTIONS(5754),
    [anon_sym_LT_GT] = ACTIONS(5752),
    [anon_sym_u22c4] = ACTIONS(5752),
    [anon_sym_u25c7] = ACTIONS(5752),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5754),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [anon_sym_ASSUME] = ACTIONS(5754),
    [anon_sym_ASSUMPTION] = ACTIONS(5754),
    [anon_sym_AXIOM] = ACTIONS(5754),
    [anon_sym_THEOREM] = ACTIONS(5754),
    [anon_sym_PROPOSITION] = ACTIONS(5754),
    [anon_sym_LEMMA] = ACTIONS(5754),
    [anon_sym_COROLLARY] = ACTIONS(5754),
    [anon_sym_USE] = ACTIONS(5754),
    [anon_sym_HIDE] = ACTIONS(5754),
    [anon_sym_DEF] = ACTIONS(5754),
    [anon_sym_DEFS] = ACTIONS(5754),
    [sym__double_excl] = ACTIONS(5752),
  },
  [2452] = {
    [sym_block_comment] = STATE(2452),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [sym_identifier] = ACTIONS(5812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5810),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_LOCAL] = ACTIONS(5812),
    [anon_sym_VARIABLE] = ACTIONS(5812),
    [anon_sym_VARIABLES] = ACTIONS(5812),
    [anon_sym_CONSTANT] = ACTIONS(5812),
    [anon_sym_CONSTANTS] = ACTIONS(5812),
    [anon_sym_RECURSIVE] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_INSTANCE] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_Nat] = ACTIONS(5812),
    [anon_sym_u2115] = ACTIONS(5810),
    [anon_sym_Int] = ACTIONS(5812),
    [anon_sym_u2124] = ACTIONS(5810),
    [anon_sym_Real] = ACTIONS(5812),
    [anon_sym_u211d] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_BSLASHlnot] = ACTIONS(5810),
    [anon_sym_BSLASHneg] = ACTIONS(5810),
    [anon_sym_TILDE] = ACTIONS(5812),
    [anon_sym_u00ac] = ACTIONS(5810),
    [sym_union] = ACTIONS(5812),
    [sym_powerset] = ACTIONS(5812),
    [sym_domain] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [sym_negative_dot] = ACTIONS(5810),
    [sym_enabled] = ACTIONS(5812),
    [sym_unchanged] = ACTIONS(5812),
    [anon_sym_LT_GT] = ACTIONS(5810),
    [anon_sym_u22c4] = ACTIONS(5810),
    [anon_sym_u25c7] = ACTIONS(5810),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5812),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [anon_sym_ASSUME] = ACTIONS(5812),
    [anon_sym_ASSUMPTION] = ACTIONS(5812),
    [anon_sym_AXIOM] = ACTIONS(5812),
    [anon_sym_THEOREM] = ACTIONS(5812),
    [anon_sym_PROPOSITION] = ACTIONS(5812),
    [anon_sym_LEMMA] = ACTIONS(5812),
    [anon_sym_COROLLARY] = ACTIONS(5812),
    [anon_sym_USE] = ACTIONS(5812),
    [anon_sym_HIDE] = ACTIONS(5812),
    [anon_sym_DEF] = ACTIONS(5812),
    [anon_sym_DEFS] = ACTIONS(5812),
    [sym__double_excl] = ACTIONS(5810),
  },
  [2453] = {
    [sym_block_comment] = STATE(2453),
    [sym_identifier] = ACTIONS(5940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5942),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_LOCAL] = ACTIONS(5940),
    [anon_sym_VARIABLE] = ACTIONS(5940),
    [anon_sym_VARIABLES] = ACTIONS(5940),
    [anon_sym_CONSTANT] = ACTIONS(5940),
    [anon_sym_CONSTANTS] = ACTIONS(5940),
    [anon_sym_RECURSIVE] = ACTIONS(5940),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_INSTANCE] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_Nat] = ACTIONS(5940),
    [anon_sym_u2115] = ACTIONS(5942),
    [anon_sym_Int] = ACTIONS(5940),
    [anon_sym_u2124] = ACTIONS(5942),
    [anon_sym_Real] = ACTIONS(5940),
    [anon_sym_u211d] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_BSLASHlnot] = ACTIONS(5942),
    [anon_sym_BSLASHneg] = ACTIONS(5942),
    [anon_sym_TILDE] = ACTIONS(5940),
    [anon_sym_u00ac] = ACTIONS(5942),
    [sym_union] = ACTIONS(5940),
    [sym_powerset] = ACTIONS(5940),
    [sym_domain] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [sym_negative_dot] = ACTIONS(5942),
    [sym_enabled] = ACTIONS(5940),
    [sym_unchanged] = ACTIONS(5940),
    [anon_sym_LT_GT] = ACTIONS(5942),
    [anon_sym_u22c4] = ACTIONS(5942),
    [anon_sym_u25c7] = ACTIONS(5942),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5940),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [anon_sym_ASSUME] = ACTIONS(5940),
    [anon_sym_ASSUMPTION] = ACTIONS(5940),
    [anon_sym_AXIOM] = ACTIONS(5940),
    [anon_sym_THEOREM] = ACTIONS(5940),
    [anon_sym_PROPOSITION] = ACTIONS(5940),
    [anon_sym_LEMMA] = ACTIONS(5940),
    [anon_sym_COROLLARY] = ACTIONS(5940),
    [anon_sym_USE] = ACTIONS(5940),
    [anon_sym_HIDE] = ACTIONS(5940),
    [anon_sym_DEF] = ACTIONS(5940),
    [anon_sym_DEFS] = ACTIONS(5940),
    [sym__double_excl] = ACTIONS(5942),
  },
  [2454] = {
    [sym_block_comment] = STATE(2454),
    [sym_identifier] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5351),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_LOCAL] = ACTIONS(5349),
    [anon_sym_VARIABLE] = ACTIONS(5349),
    [anon_sym_VARIABLES] = ACTIONS(5349),
    [anon_sym_CONSTANT] = ACTIONS(5349),
    [anon_sym_CONSTANTS] = ACTIONS(5349),
    [anon_sym_RECURSIVE] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_INSTANCE] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_Nat] = ACTIONS(5349),
    [anon_sym_u2115] = ACTIONS(5351),
    [anon_sym_Int] = ACTIONS(5349),
    [anon_sym_u2124] = ACTIONS(5351),
    [anon_sym_Real] = ACTIONS(5349),
    [anon_sym_u211d] = ACTIONS(5351),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_BSLASHlnot] = ACTIONS(5351),
    [anon_sym_BSLASHneg] = ACTIONS(5351),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_u00ac] = ACTIONS(5351),
    [sym_union] = ACTIONS(5349),
    [sym_powerset] = ACTIONS(5349),
    [sym_domain] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [sym_negative_dot] = ACTIONS(5351),
    [sym_enabled] = ACTIONS(5349),
    [sym_unchanged] = ACTIONS(5349),
    [anon_sym_LT_GT] = ACTIONS(5351),
    [anon_sym_u22c4] = ACTIONS(5351),
    [anon_sym_u25c7] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5349),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [anon_sym_ASSUME] = ACTIONS(5349),
    [anon_sym_ASSUMPTION] = ACTIONS(5349),
    [anon_sym_AXIOM] = ACTIONS(5349),
    [anon_sym_THEOREM] = ACTIONS(5349),
    [anon_sym_PROPOSITION] = ACTIONS(5349),
    [anon_sym_LEMMA] = ACTIONS(5349),
    [anon_sym_COROLLARY] = ACTIONS(5349),
    [anon_sym_USE] = ACTIONS(5349),
    [anon_sym_HIDE] = ACTIONS(5349),
    [anon_sym_DEF] = ACTIONS(5349),
    [anon_sym_DEFS] = ACTIONS(5349),
    [sym__double_excl] = ACTIONS(5351),
  },
  [2455] = {
    [sym_block_comment] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5890),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_COMMA] = ACTIONS(5890),
    [anon_sym_LOCAL] = ACTIONS(5888),
    [anon_sym_VARIABLE] = ACTIONS(5888),
    [anon_sym_VARIABLES] = ACTIONS(5888),
    [anon_sym_CONSTANT] = ACTIONS(5888),
    [anon_sym_CONSTANTS] = ACTIONS(5888),
    [anon_sym_RECURSIVE] = ACTIONS(5888),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_INSTANCE] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_Nat] = ACTIONS(5888),
    [anon_sym_u2115] = ACTIONS(5890),
    [anon_sym_Int] = ACTIONS(5888),
    [anon_sym_u2124] = ACTIONS(5890),
    [anon_sym_Real] = ACTIONS(5888),
    [anon_sym_u211d] = ACTIONS(5890),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_BSLASHlnot] = ACTIONS(5890),
    [anon_sym_BSLASHneg] = ACTIONS(5890),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_u00ac] = ACTIONS(5890),
    [sym_union] = ACTIONS(5888),
    [sym_powerset] = ACTIONS(5888),
    [sym_domain] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [sym_negative_dot] = ACTIONS(5890),
    [sym_enabled] = ACTIONS(5888),
    [sym_unchanged] = ACTIONS(5888),
    [anon_sym_LT_GT] = ACTIONS(5890),
    [anon_sym_u22c4] = ACTIONS(5890),
    [anon_sym_u25c7] = ACTIONS(5890),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5888),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [anon_sym_ASSUME] = ACTIONS(5888),
    [anon_sym_ASSUMPTION] = ACTIONS(5888),
    [anon_sym_AXIOM] = ACTIONS(5888),
    [anon_sym_THEOREM] = ACTIONS(5888),
    [anon_sym_PROPOSITION] = ACTIONS(5888),
    [anon_sym_LEMMA] = ACTIONS(5888),
    [anon_sym_COROLLARY] = ACTIONS(5888),
    [anon_sym_USE] = ACTIONS(5888),
    [anon_sym_HIDE] = ACTIONS(5888),
    [anon_sym_DEF] = ACTIONS(5888),
    [anon_sym_DEFS] = ACTIONS(5888),
    [sym__double_excl] = ACTIONS(5890),
  },
  [2456] = {
    [sym_block_comment] = STATE(2456),
    [ts_builtin_sym_end] = ACTIONS(5814),
    [sym_identifier] = ACTIONS(5816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5814),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_COMMA] = ACTIONS(5814),
    [anon_sym_LOCAL] = ACTIONS(5816),
    [anon_sym_VARIABLE] = ACTIONS(5816),
    [anon_sym_VARIABLES] = ACTIONS(5816),
    [anon_sym_CONSTANT] = ACTIONS(5816),
    [anon_sym_CONSTANTS] = ACTIONS(5816),
    [anon_sym_RECURSIVE] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_INSTANCE] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_Nat] = ACTIONS(5816),
    [anon_sym_u2115] = ACTIONS(5814),
    [anon_sym_Int] = ACTIONS(5816),
    [anon_sym_u2124] = ACTIONS(5814),
    [anon_sym_Real] = ACTIONS(5816),
    [anon_sym_u211d] = ACTIONS(5814),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_BSLASHlnot] = ACTIONS(5814),
    [anon_sym_BSLASHneg] = ACTIONS(5814),
    [anon_sym_TILDE] = ACTIONS(5816),
    [anon_sym_u00ac] = ACTIONS(5814),
    [sym_union] = ACTIONS(5816),
    [sym_powerset] = ACTIONS(5816),
    [sym_domain] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [sym_negative_dot] = ACTIONS(5814),
    [sym_enabled] = ACTIONS(5816),
    [sym_unchanged] = ACTIONS(5816),
    [anon_sym_LT_GT] = ACTIONS(5814),
    [anon_sym_u22c4] = ACTIONS(5814),
    [anon_sym_u25c7] = ACTIONS(5814),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5816),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [anon_sym_ASSUME] = ACTIONS(5816),
    [anon_sym_ASSUMPTION] = ACTIONS(5816),
    [anon_sym_AXIOM] = ACTIONS(5816),
    [anon_sym_THEOREM] = ACTIONS(5816),
    [anon_sym_PROPOSITION] = ACTIONS(5816),
    [anon_sym_LEMMA] = ACTIONS(5816),
    [anon_sym_COROLLARY] = ACTIONS(5816),
    [anon_sym_USE] = ACTIONS(5816),
    [anon_sym_HIDE] = ACTIONS(5816),
    [anon_sym_DEF] = ACTIONS(5816),
    [anon_sym_DEFS] = ACTIONS(5816),
    [sym__double_excl] = ACTIONS(5814),
  },
  [2457] = {
    [sym_block_comment] = STATE(2457),
    [sym_identifier] = ACTIONS(5754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_LOCAL] = ACTIONS(5754),
    [anon_sym_VARIABLE] = ACTIONS(5754),
    [anon_sym_VARIABLES] = ACTIONS(5754),
    [anon_sym_CONSTANT] = ACTIONS(5754),
    [anon_sym_CONSTANTS] = ACTIONS(5754),
    [anon_sym_RECURSIVE] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_INSTANCE] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_Nat] = ACTIONS(5754),
    [anon_sym_u2115] = ACTIONS(5752),
    [anon_sym_Int] = ACTIONS(5754),
    [anon_sym_u2124] = ACTIONS(5752),
    [anon_sym_Real] = ACTIONS(5754),
    [anon_sym_u211d] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_BSLASHlnot] = ACTIONS(5752),
    [anon_sym_BSLASHneg] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(5754),
    [anon_sym_u00ac] = ACTIONS(5752),
    [sym_union] = ACTIONS(5754),
    [sym_powerset] = ACTIONS(5754),
    [sym_domain] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [sym_negative_dot] = ACTIONS(5752),
    [sym_enabled] = ACTIONS(5754),
    [sym_unchanged] = ACTIONS(5754),
    [anon_sym_LT_GT] = ACTIONS(5752),
    [anon_sym_u22c4] = ACTIONS(5752),
    [anon_sym_u25c7] = ACTIONS(5752),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5754),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [anon_sym_ASSUME] = ACTIONS(5754),
    [anon_sym_ASSUMPTION] = ACTIONS(5754),
    [anon_sym_AXIOM] = ACTIONS(5754),
    [anon_sym_THEOREM] = ACTIONS(5754),
    [anon_sym_PROPOSITION] = ACTIONS(5754),
    [anon_sym_LEMMA] = ACTIONS(5754),
    [anon_sym_COROLLARY] = ACTIONS(5754),
    [anon_sym_USE] = ACTIONS(5754),
    [anon_sym_HIDE] = ACTIONS(5754),
    [anon_sym_DEF] = ACTIONS(5754),
    [anon_sym_DEFS] = ACTIONS(5754),
    [sym__double_excl] = ACTIONS(5752),
  },
  [2458] = {
    [sym_block_comment] = STATE(2458),
    [ts_builtin_sym_end] = ACTIONS(5806),
    [sym_identifier] = ACTIONS(5808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5806),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_LOCAL] = ACTIONS(5808),
    [anon_sym_VARIABLE] = ACTIONS(5808),
    [anon_sym_VARIABLES] = ACTIONS(5808),
    [anon_sym_CONSTANT] = ACTIONS(5808),
    [anon_sym_CONSTANTS] = ACTIONS(5808),
    [anon_sym_RECURSIVE] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_INSTANCE] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_Nat] = ACTIONS(5808),
    [anon_sym_u2115] = ACTIONS(5806),
    [anon_sym_Int] = ACTIONS(5808),
    [anon_sym_u2124] = ACTIONS(5806),
    [anon_sym_Real] = ACTIONS(5808),
    [anon_sym_u211d] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_BSLASHlnot] = ACTIONS(5806),
    [anon_sym_BSLASHneg] = ACTIONS(5806),
    [anon_sym_TILDE] = ACTIONS(5808),
    [anon_sym_u00ac] = ACTIONS(5806),
    [sym_union] = ACTIONS(5808),
    [sym_powerset] = ACTIONS(5808),
    [sym_domain] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [sym_negative_dot] = ACTIONS(5806),
    [sym_enabled] = ACTIONS(5808),
    [sym_unchanged] = ACTIONS(5808),
    [anon_sym_LT_GT] = ACTIONS(5806),
    [anon_sym_u22c4] = ACTIONS(5806),
    [anon_sym_u25c7] = ACTIONS(5806),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5808),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [anon_sym_ASSUME] = ACTIONS(5808),
    [anon_sym_ASSUMPTION] = ACTIONS(5808),
    [anon_sym_AXIOM] = ACTIONS(5808),
    [anon_sym_THEOREM] = ACTIONS(5808),
    [anon_sym_PROPOSITION] = ACTIONS(5808),
    [anon_sym_LEMMA] = ACTIONS(5808),
    [anon_sym_COROLLARY] = ACTIONS(5808),
    [anon_sym_USE] = ACTIONS(5808),
    [anon_sym_HIDE] = ACTIONS(5808),
    [anon_sym_DEF] = ACTIONS(5808),
    [anon_sym_DEFS] = ACTIONS(5808),
    [sym__double_excl] = ACTIONS(5806),
  },
  [2459] = {
    [sym_block_comment] = STATE(2459),
    [ts_builtin_sym_end] = ACTIONS(5856),
    [sym_identifier] = ACTIONS(5854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5856),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_LOCAL] = ACTIONS(5854),
    [anon_sym_VARIABLE] = ACTIONS(5854),
    [anon_sym_VARIABLES] = ACTIONS(5854),
    [anon_sym_CONSTANT] = ACTIONS(5854),
    [anon_sym_CONSTANTS] = ACTIONS(5854),
    [anon_sym_RECURSIVE] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_INSTANCE] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_Nat] = ACTIONS(5854),
    [anon_sym_u2115] = ACTIONS(5856),
    [anon_sym_Int] = ACTIONS(5854),
    [anon_sym_u2124] = ACTIONS(5856),
    [anon_sym_Real] = ACTIONS(5854),
    [anon_sym_u211d] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_BSLASHlnot] = ACTIONS(5856),
    [anon_sym_BSLASHneg] = ACTIONS(5856),
    [anon_sym_TILDE] = ACTIONS(5854),
    [anon_sym_u00ac] = ACTIONS(5856),
    [sym_union] = ACTIONS(5854),
    [sym_powerset] = ACTIONS(5854),
    [sym_domain] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [sym_negative_dot] = ACTIONS(5856),
    [sym_enabled] = ACTIONS(5854),
    [sym_unchanged] = ACTIONS(5854),
    [anon_sym_LT_GT] = ACTIONS(5856),
    [anon_sym_u22c4] = ACTIONS(5856),
    [anon_sym_u25c7] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5854),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [anon_sym_ASSUME] = ACTIONS(5854),
    [anon_sym_ASSUMPTION] = ACTIONS(5854),
    [anon_sym_AXIOM] = ACTIONS(5854),
    [anon_sym_THEOREM] = ACTIONS(5854),
    [anon_sym_PROPOSITION] = ACTIONS(5854),
    [anon_sym_LEMMA] = ACTIONS(5854),
    [anon_sym_COROLLARY] = ACTIONS(5854),
    [anon_sym_USE] = ACTIONS(5854),
    [anon_sym_HIDE] = ACTIONS(5854),
    [anon_sym_DEF] = ACTIONS(5854),
    [anon_sym_DEFS] = ACTIONS(5854),
    [sym__double_excl] = ACTIONS(5856),
  },
  [2460] = {
    [sym_block_comment] = STATE(2460),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [sym_identifier] = ACTIONS(5858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5860),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_LOCAL] = ACTIONS(5858),
    [anon_sym_VARIABLE] = ACTIONS(5858),
    [anon_sym_VARIABLES] = ACTIONS(5858),
    [anon_sym_CONSTANT] = ACTIONS(5858),
    [anon_sym_CONSTANTS] = ACTIONS(5858),
    [anon_sym_RECURSIVE] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_INSTANCE] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_Nat] = ACTIONS(5858),
    [anon_sym_u2115] = ACTIONS(5860),
    [anon_sym_Int] = ACTIONS(5858),
    [anon_sym_u2124] = ACTIONS(5860),
    [anon_sym_Real] = ACTIONS(5858),
    [anon_sym_u211d] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_BSLASHlnot] = ACTIONS(5860),
    [anon_sym_BSLASHneg] = ACTIONS(5860),
    [anon_sym_TILDE] = ACTIONS(5858),
    [anon_sym_u00ac] = ACTIONS(5860),
    [sym_union] = ACTIONS(5858),
    [sym_powerset] = ACTIONS(5858),
    [sym_domain] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [sym_negative_dot] = ACTIONS(5860),
    [sym_enabled] = ACTIONS(5858),
    [sym_unchanged] = ACTIONS(5858),
    [anon_sym_LT_GT] = ACTIONS(5860),
    [anon_sym_u22c4] = ACTIONS(5860),
    [anon_sym_u25c7] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5858),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [anon_sym_ASSUME] = ACTIONS(5858),
    [anon_sym_ASSUMPTION] = ACTIONS(5858),
    [anon_sym_AXIOM] = ACTIONS(5858),
    [anon_sym_THEOREM] = ACTIONS(5858),
    [anon_sym_PROPOSITION] = ACTIONS(5858),
    [anon_sym_LEMMA] = ACTIONS(5858),
    [anon_sym_COROLLARY] = ACTIONS(5858),
    [anon_sym_USE] = ACTIONS(5858),
    [anon_sym_HIDE] = ACTIONS(5858),
    [anon_sym_DEF] = ACTIONS(5858),
    [anon_sym_DEFS] = ACTIONS(5858),
    [sym__double_excl] = ACTIONS(5860),
  },
  [2461] = {
    [sym_block_comment] = STATE(2461),
    [ts_builtin_sym_end] = ACTIONS(5782),
    [sym_identifier] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5782),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_COMMA] = ACTIONS(5782),
    [anon_sym_LOCAL] = ACTIONS(5784),
    [anon_sym_VARIABLE] = ACTIONS(5784),
    [anon_sym_VARIABLES] = ACTIONS(5784),
    [anon_sym_CONSTANT] = ACTIONS(5784),
    [anon_sym_CONSTANTS] = ACTIONS(5784),
    [anon_sym_RECURSIVE] = ACTIONS(5784),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_INSTANCE] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_Nat] = ACTIONS(5784),
    [anon_sym_u2115] = ACTIONS(5782),
    [anon_sym_Int] = ACTIONS(5784),
    [anon_sym_u2124] = ACTIONS(5782),
    [anon_sym_Real] = ACTIONS(5784),
    [anon_sym_u211d] = ACTIONS(5782),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_BSLASHlnot] = ACTIONS(5782),
    [anon_sym_BSLASHneg] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [anon_sym_u00ac] = ACTIONS(5782),
    [sym_union] = ACTIONS(5784),
    [sym_powerset] = ACTIONS(5784),
    [sym_domain] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [sym_negative_dot] = ACTIONS(5782),
    [sym_enabled] = ACTIONS(5784),
    [sym_unchanged] = ACTIONS(5784),
    [anon_sym_LT_GT] = ACTIONS(5782),
    [anon_sym_u22c4] = ACTIONS(5782),
    [anon_sym_u25c7] = ACTIONS(5782),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5784),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [anon_sym_ASSUME] = ACTIONS(5784),
    [anon_sym_ASSUMPTION] = ACTIONS(5784),
    [anon_sym_AXIOM] = ACTIONS(5784),
    [anon_sym_THEOREM] = ACTIONS(5784),
    [anon_sym_PROPOSITION] = ACTIONS(5784),
    [anon_sym_LEMMA] = ACTIONS(5784),
    [anon_sym_COROLLARY] = ACTIONS(5784),
    [anon_sym_USE] = ACTIONS(5784),
    [anon_sym_HIDE] = ACTIONS(5784),
    [anon_sym_DEF] = ACTIONS(5784),
    [anon_sym_DEFS] = ACTIONS(5784),
    [sym__double_excl] = ACTIONS(5782),
  },
  [2462] = {
    [sym_block_comment] = STATE(2462),
    [ts_builtin_sym_end] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5818),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5818),
    [anon_sym_LOCAL] = ACTIONS(5820),
    [anon_sym_VARIABLE] = ACTIONS(5820),
    [anon_sym_VARIABLES] = ACTIONS(5820),
    [anon_sym_CONSTANT] = ACTIONS(5820),
    [anon_sym_CONSTANTS] = ACTIONS(5820),
    [anon_sym_RECURSIVE] = ACTIONS(5820),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_INSTANCE] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_Nat] = ACTIONS(5820),
    [anon_sym_u2115] = ACTIONS(5818),
    [anon_sym_Int] = ACTIONS(5820),
    [anon_sym_u2124] = ACTIONS(5818),
    [anon_sym_Real] = ACTIONS(5820),
    [anon_sym_u211d] = ACTIONS(5818),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_BSLASHlnot] = ACTIONS(5818),
    [anon_sym_BSLASHneg] = ACTIONS(5818),
    [anon_sym_TILDE] = ACTIONS(5820),
    [anon_sym_u00ac] = ACTIONS(5818),
    [sym_union] = ACTIONS(5820),
    [sym_powerset] = ACTIONS(5820),
    [sym_domain] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [sym_negative_dot] = ACTIONS(5818),
    [sym_enabled] = ACTIONS(5820),
    [sym_unchanged] = ACTIONS(5820),
    [anon_sym_LT_GT] = ACTIONS(5818),
    [anon_sym_u22c4] = ACTIONS(5818),
    [anon_sym_u25c7] = ACTIONS(5818),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5820),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [anon_sym_ASSUME] = ACTIONS(5820),
    [anon_sym_ASSUMPTION] = ACTIONS(5820),
    [anon_sym_AXIOM] = ACTIONS(5820),
    [anon_sym_THEOREM] = ACTIONS(5820),
    [anon_sym_PROPOSITION] = ACTIONS(5820),
    [anon_sym_LEMMA] = ACTIONS(5820),
    [anon_sym_COROLLARY] = ACTIONS(5820),
    [anon_sym_USE] = ACTIONS(5820),
    [anon_sym_HIDE] = ACTIONS(5820),
    [anon_sym_DEF] = ACTIONS(5820),
    [anon_sym_DEFS] = ACTIONS(5820),
    [sym__double_excl] = ACTIONS(5818),
  },
  [2463] = {
    [sym_block_comment] = STATE(2463),
    [ts_builtin_sym_end] = ACTIONS(5768),
    [sym_identifier] = ACTIONS(5770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5768),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_LOCAL] = ACTIONS(5770),
    [anon_sym_VARIABLE] = ACTIONS(5770),
    [anon_sym_VARIABLES] = ACTIONS(5770),
    [anon_sym_CONSTANT] = ACTIONS(5770),
    [anon_sym_CONSTANTS] = ACTIONS(5770),
    [anon_sym_RECURSIVE] = ACTIONS(5770),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_INSTANCE] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_Nat] = ACTIONS(5770),
    [anon_sym_u2115] = ACTIONS(5768),
    [anon_sym_Int] = ACTIONS(5770),
    [anon_sym_u2124] = ACTIONS(5768),
    [anon_sym_Real] = ACTIONS(5770),
    [anon_sym_u211d] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_BSLASHlnot] = ACTIONS(5768),
    [anon_sym_BSLASHneg] = ACTIONS(5768),
    [anon_sym_TILDE] = ACTIONS(5770),
    [anon_sym_u00ac] = ACTIONS(5768),
    [sym_union] = ACTIONS(5770),
    [sym_powerset] = ACTIONS(5770),
    [sym_domain] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [sym_negative_dot] = ACTIONS(5768),
    [sym_enabled] = ACTIONS(5770),
    [sym_unchanged] = ACTIONS(5770),
    [anon_sym_LT_GT] = ACTIONS(5768),
    [anon_sym_u22c4] = ACTIONS(5768),
    [anon_sym_u25c7] = ACTIONS(5768),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5770),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [anon_sym_ASSUME] = ACTIONS(5770),
    [anon_sym_ASSUMPTION] = ACTIONS(5770),
    [anon_sym_AXIOM] = ACTIONS(5770),
    [anon_sym_THEOREM] = ACTIONS(5770),
    [anon_sym_PROPOSITION] = ACTIONS(5770),
    [anon_sym_LEMMA] = ACTIONS(5770),
    [anon_sym_COROLLARY] = ACTIONS(5770),
    [anon_sym_USE] = ACTIONS(5770),
    [anon_sym_HIDE] = ACTIONS(5770),
    [anon_sym_DEF] = ACTIONS(5770),
    [anon_sym_DEFS] = ACTIONS(5770),
    [sym__double_excl] = ACTIONS(5768),
  },
  [2464] = {
    [sym_block_comment] = STATE(2464),
    [ts_builtin_sym_end] = ACTIONS(5822),
    [sym_identifier] = ACTIONS(5824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5822),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_LOCAL] = ACTIONS(5824),
    [anon_sym_VARIABLE] = ACTIONS(5824),
    [anon_sym_VARIABLES] = ACTIONS(5824),
    [anon_sym_CONSTANT] = ACTIONS(5824),
    [anon_sym_CONSTANTS] = ACTIONS(5824),
    [anon_sym_RECURSIVE] = ACTIONS(5824),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_INSTANCE] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_Nat] = ACTIONS(5824),
    [anon_sym_u2115] = ACTIONS(5822),
    [anon_sym_Int] = ACTIONS(5824),
    [anon_sym_u2124] = ACTIONS(5822),
    [anon_sym_Real] = ACTIONS(5824),
    [anon_sym_u211d] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_BSLASHlnot] = ACTIONS(5822),
    [anon_sym_BSLASHneg] = ACTIONS(5822),
    [anon_sym_TILDE] = ACTIONS(5824),
    [anon_sym_u00ac] = ACTIONS(5822),
    [sym_union] = ACTIONS(5824),
    [sym_powerset] = ACTIONS(5824),
    [sym_domain] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [sym_negative_dot] = ACTIONS(5822),
    [sym_enabled] = ACTIONS(5824),
    [sym_unchanged] = ACTIONS(5824),
    [anon_sym_LT_GT] = ACTIONS(5822),
    [anon_sym_u22c4] = ACTIONS(5822),
    [anon_sym_u25c7] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5824),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [anon_sym_ASSUME] = ACTIONS(5824),
    [anon_sym_ASSUMPTION] = ACTIONS(5824),
    [anon_sym_AXIOM] = ACTIONS(5824),
    [anon_sym_THEOREM] = ACTIONS(5824),
    [anon_sym_PROPOSITION] = ACTIONS(5824),
    [anon_sym_LEMMA] = ACTIONS(5824),
    [anon_sym_COROLLARY] = ACTIONS(5824),
    [anon_sym_USE] = ACTIONS(5824),
    [anon_sym_HIDE] = ACTIONS(5824),
    [anon_sym_DEF] = ACTIONS(5824),
    [anon_sym_DEFS] = ACTIONS(5824),
    [sym__double_excl] = ACTIONS(5822),
  },
  [2465] = {
    [sym_block_comment] = STATE(2465),
    [ts_builtin_sym_end] = ACTIONS(5826),
    [sym_identifier] = ACTIONS(5828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5826),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_COMMA] = ACTIONS(5826),
    [anon_sym_LOCAL] = ACTIONS(5828),
    [anon_sym_VARIABLE] = ACTIONS(5828),
    [anon_sym_VARIABLES] = ACTIONS(5828),
    [anon_sym_CONSTANT] = ACTIONS(5828),
    [anon_sym_CONSTANTS] = ACTIONS(5828),
    [anon_sym_RECURSIVE] = ACTIONS(5828),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_INSTANCE] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_Nat] = ACTIONS(5828),
    [anon_sym_u2115] = ACTIONS(5826),
    [anon_sym_Int] = ACTIONS(5828),
    [anon_sym_u2124] = ACTIONS(5826),
    [anon_sym_Real] = ACTIONS(5828),
    [anon_sym_u211d] = ACTIONS(5826),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_BSLASHlnot] = ACTIONS(5826),
    [anon_sym_BSLASHneg] = ACTIONS(5826),
    [anon_sym_TILDE] = ACTIONS(5828),
    [anon_sym_u00ac] = ACTIONS(5826),
    [sym_union] = ACTIONS(5828),
    [sym_powerset] = ACTIONS(5828),
    [sym_domain] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [sym_negative_dot] = ACTIONS(5826),
    [sym_enabled] = ACTIONS(5828),
    [sym_unchanged] = ACTIONS(5828),
    [anon_sym_LT_GT] = ACTIONS(5826),
    [anon_sym_u22c4] = ACTIONS(5826),
    [anon_sym_u25c7] = ACTIONS(5826),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5828),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [anon_sym_ASSUME] = ACTIONS(5828),
    [anon_sym_ASSUMPTION] = ACTIONS(5828),
    [anon_sym_AXIOM] = ACTIONS(5828),
    [anon_sym_THEOREM] = ACTIONS(5828),
    [anon_sym_PROPOSITION] = ACTIONS(5828),
    [anon_sym_LEMMA] = ACTIONS(5828),
    [anon_sym_COROLLARY] = ACTIONS(5828),
    [anon_sym_USE] = ACTIONS(5828),
    [anon_sym_HIDE] = ACTIONS(5828),
    [anon_sym_DEF] = ACTIONS(5828),
    [anon_sym_DEFS] = ACTIONS(5828),
    [sym__double_excl] = ACTIONS(5826),
  },
  [2466] = {
    [sym_block_comment] = STATE(2466),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5663),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LOCAL] = ACTIONS(5665),
    [anon_sym_VARIABLE] = ACTIONS(5665),
    [anon_sym_VARIABLES] = ACTIONS(5665),
    [anon_sym_CONSTANT] = ACTIONS(5665),
    [anon_sym_CONSTANTS] = ACTIONS(5665),
    [anon_sym_RECURSIVE] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_INSTANCE] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5665),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_ASSUME] = ACTIONS(5665),
    [anon_sym_ASSUMPTION] = ACTIONS(5665),
    [anon_sym_AXIOM] = ACTIONS(5665),
    [anon_sym_THEOREM] = ACTIONS(5665),
    [anon_sym_PROPOSITION] = ACTIONS(5665),
    [anon_sym_LEMMA] = ACTIONS(5665),
    [anon_sym_COROLLARY] = ACTIONS(5665),
    [anon_sym_USE] = ACTIONS(5665),
    [anon_sym_HIDE] = ACTIONS(5665),
    [anon_sym_DEF] = ACTIONS(5665),
    [anon_sym_DEFS] = ACTIONS(5665),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2467] = {
    [sym_block_comment] = STATE(2467),
    [sym_identifier] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5786),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_LOCAL] = ACTIONS(5788),
    [anon_sym_VARIABLE] = ACTIONS(5788),
    [anon_sym_VARIABLES] = ACTIONS(5788),
    [anon_sym_CONSTANT] = ACTIONS(5788),
    [anon_sym_CONSTANTS] = ACTIONS(5788),
    [anon_sym_RECURSIVE] = ACTIONS(5788),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_INSTANCE] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_Nat] = ACTIONS(5788),
    [anon_sym_u2115] = ACTIONS(5786),
    [anon_sym_Int] = ACTIONS(5788),
    [anon_sym_u2124] = ACTIONS(5786),
    [anon_sym_Real] = ACTIONS(5788),
    [anon_sym_u211d] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_BSLASHlnot] = ACTIONS(5786),
    [anon_sym_BSLASHneg] = ACTIONS(5786),
    [anon_sym_TILDE] = ACTIONS(5788),
    [anon_sym_u00ac] = ACTIONS(5786),
    [sym_union] = ACTIONS(5788),
    [sym_powerset] = ACTIONS(5788),
    [sym_domain] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [sym_negative_dot] = ACTIONS(5786),
    [sym_enabled] = ACTIONS(5788),
    [sym_unchanged] = ACTIONS(5788),
    [anon_sym_LT_GT] = ACTIONS(5786),
    [anon_sym_u22c4] = ACTIONS(5786),
    [anon_sym_u25c7] = ACTIONS(5786),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5788),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [anon_sym_ASSUME] = ACTIONS(5788),
    [anon_sym_ASSUMPTION] = ACTIONS(5788),
    [anon_sym_AXIOM] = ACTIONS(5788),
    [anon_sym_THEOREM] = ACTIONS(5788),
    [anon_sym_PROPOSITION] = ACTIONS(5788),
    [anon_sym_LEMMA] = ACTIONS(5788),
    [anon_sym_COROLLARY] = ACTIONS(5788),
    [anon_sym_USE] = ACTIONS(5788),
    [anon_sym_HIDE] = ACTIONS(5788),
    [anon_sym_DEF] = ACTIONS(5788),
    [anon_sym_DEFS] = ACTIONS(5788),
    [sym__double_excl] = ACTIONS(5786),
  },
  [2468] = {
    [sym_block_comment] = STATE(2468),
    [ts_builtin_sym_end] = ACTIONS(5872),
    [sym_identifier] = ACTIONS(5874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5872),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_COMMA] = ACTIONS(5872),
    [anon_sym_LOCAL] = ACTIONS(5874),
    [anon_sym_VARIABLE] = ACTIONS(5874),
    [anon_sym_VARIABLES] = ACTIONS(5874),
    [anon_sym_CONSTANT] = ACTIONS(5874),
    [anon_sym_CONSTANTS] = ACTIONS(5874),
    [anon_sym_RECURSIVE] = ACTIONS(5874),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_INSTANCE] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_Nat] = ACTIONS(5874),
    [anon_sym_u2115] = ACTIONS(5872),
    [anon_sym_Int] = ACTIONS(5874),
    [anon_sym_u2124] = ACTIONS(5872),
    [anon_sym_Real] = ACTIONS(5874),
    [anon_sym_u211d] = ACTIONS(5872),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_BSLASHlnot] = ACTIONS(5872),
    [anon_sym_BSLASHneg] = ACTIONS(5872),
    [anon_sym_TILDE] = ACTIONS(5874),
    [anon_sym_u00ac] = ACTIONS(5872),
    [sym_union] = ACTIONS(5874),
    [sym_powerset] = ACTIONS(5874),
    [sym_domain] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [sym_negative_dot] = ACTIONS(5872),
    [sym_enabled] = ACTIONS(5874),
    [sym_unchanged] = ACTIONS(5874),
    [anon_sym_LT_GT] = ACTIONS(5872),
    [anon_sym_u22c4] = ACTIONS(5872),
    [anon_sym_u25c7] = ACTIONS(5872),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5874),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [anon_sym_ASSUME] = ACTIONS(5874),
    [anon_sym_ASSUMPTION] = ACTIONS(5874),
    [anon_sym_AXIOM] = ACTIONS(5874),
    [anon_sym_THEOREM] = ACTIONS(5874),
    [anon_sym_PROPOSITION] = ACTIONS(5874),
    [anon_sym_LEMMA] = ACTIONS(5874),
    [anon_sym_COROLLARY] = ACTIONS(5874),
    [anon_sym_USE] = ACTIONS(5874),
    [anon_sym_HIDE] = ACTIONS(5874),
    [anon_sym_DEF] = ACTIONS(5874),
    [anon_sym_DEFS] = ACTIONS(5874),
    [sym__double_excl] = ACTIONS(5872),
  },
  [2469] = {
    [sym_block_comment] = STATE(2469),
    [ts_builtin_sym_end] = ACTIONS(5876),
    [sym_identifier] = ACTIONS(5878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5876),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_COMMA] = ACTIONS(5876),
    [anon_sym_LOCAL] = ACTIONS(5878),
    [anon_sym_VARIABLE] = ACTIONS(5878),
    [anon_sym_VARIABLES] = ACTIONS(5878),
    [anon_sym_CONSTANT] = ACTIONS(5878),
    [anon_sym_CONSTANTS] = ACTIONS(5878),
    [anon_sym_RECURSIVE] = ACTIONS(5878),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_INSTANCE] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_Nat] = ACTIONS(5878),
    [anon_sym_u2115] = ACTIONS(5876),
    [anon_sym_Int] = ACTIONS(5878),
    [anon_sym_u2124] = ACTIONS(5876),
    [anon_sym_Real] = ACTIONS(5878),
    [anon_sym_u211d] = ACTIONS(5876),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_BSLASHlnot] = ACTIONS(5876),
    [anon_sym_BSLASHneg] = ACTIONS(5876),
    [anon_sym_TILDE] = ACTIONS(5878),
    [anon_sym_u00ac] = ACTIONS(5876),
    [sym_union] = ACTIONS(5878),
    [sym_powerset] = ACTIONS(5878),
    [sym_domain] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [sym_negative_dot] = ACTIONS(5876),
    [sym_enabled] = ACTIONS(5878),
    [sym_unchanged] = ACTIONS(5878),
    [anon_sym_LT_GT] = ACTIONS(5876),
    [anon_sym_u22c4] = ACTIONS(5876),
    [anon_sym_u25c7] = ACTIONS(5876),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5878),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [anon_sym_ASSUME] = ACTIONS(5878),
    [anon_sym_ASSUMPTION] = ACTIONS(5878),
    [anon_sym_AXIOM] = ACTIONS(5878),
    [anon_sym_THEOREM] = ACTIONS(5878),
    [anon_sym_PROPOSITION] = ACTIONS(5878),
    [anon_sym_LEMMA] = ACTIONS(5878),
    [anon_sym_COROLLARY] = ACTIONS(5878),
    [anon_sym_USE] = ACTIONS(5878),
    [anon_sym_HIDE] = ACTIONS(5878),
    [anon_sym_DEF] = ACTIONS(5878),
    [anon_sym_DEFS] = ACTIONS(5878),
    [sym__double_excl] = ACTIONS(5876),
  },
  [2470] = {
    [sym_block_comment] = STATE(2470),
    [ts_builtin_sym_end] = ACTIONS(5852),
    [sym_identifier] = ACTIONS(5850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5852),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_LOCAL] = ACTIONS(5850),
    [anon_sym_VARIABLE] = ACTIONS(5850),
    [anon_sym_VARIABLES] = ACTIONS(5850),
    [anon_sym_CONSTANT] = ACTIONS(5850),
    [anon_sym_CONSTANTS] = ACTIONS(5850),
    [anon_sym_RECURSIVE] = ACTIONS(5850),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_INSTANCE] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_Nat] = ACTIONS(5850),
    [anon_sym_u2115] = ACTIONS(5852),
    [anon_sym_Int] = ACTIONS(5850),
    [anon_sym_u2124] = ACTIONS(5852),
    [anon_sym_Real] = ACTIONS(5850),
    [anon_sym_u211d] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_BSLASHlnot] = ACTIONS(5852),
    [anon_sym_BSLASHneg] = ACTIONS(5852),
    [anon_sym_TILDE] = ACTIONS(5850),
    [anon_sym_u00ac] = ACTIONS(5852),
    [sym_union] = ACTIONS(5850),
    [sym_powerset] = ACTIONS(5850),
    [sym_domain] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [sym_negative_dot] = ACTIONS(5852),
    [sym_enabled] = ACTIONS(5850),
    [sym_unchanged] = ACTIONS(5850),
    [anon_sym_LT_GT] = ACTIONS(5852),
    [anon_sym_u22c4] = ACTIONS(5852),
    [anon_sym_u25c7] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5850),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [anon_sym_ASSUME] = ACTIONS(5850),
    [anon_sym_ASSUMPTION] = ACTIONS(5850),
    [anon_sym_AXIOM] = ACTIONS(5850),
    [anon_sym_THEOREM] = ACTIONS(5850),
    [anon_sym_PROPOSITION] = ACTIONS(5850),
    [anon_sym_LEMMA] = ACTIONS(5850),
    [anon_sym_COROLLARY] = ACTIONS(5850),
    [anon_sym_USE] = ACTIONS(5850),
    [anon_sym_HIDE] = ACTIONS(5850),
    [anon_sym_DEF] = ACTIONS(5850),
    [anon_sym_DEFS] = ACTIONS(5850),
    [sym__double_excl] = ACTIONS(5852),
  },
  [2471] = {
    [sym_block_comment] = STATE(2471),
    [ts_builtin_sym_end] = ACTIONS(5880),
    [sym_identifier] = ACTIONS(5882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5880),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_COMMA] = ACTIONS(5880),
    [anon_sym_LOCAL] = ACTIONS(5882),
    [anon_sym_VARIABLE] = ACTIONS(5882),
    [anon_sym_VARIABLES] = ACTIONS(5882),
    [anon_sym_CONSTANT] = ACTIONS(5882),
    [anon_sym_CONSTANTS] = ACTIONS(5882),
    [anon_sym_RECURSIVE] = ACTIONS(5882),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_INSTANCE] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_Nat] = ACTIONS(5882),
    [anon_sym_u2115] = ACTIONS(5880),
    [anon_sym_Int] = ACTIONS(5882),
    [anon_sym_u2124] = ACTIONS(5880),
    [anon_sym_Real] = ACTIONS(5882),
    [anon_sym_u211d] = ACTIONS(5880),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_BSLASHlnot] = ACTIONS(5880),
    [anon_sym_BSLASHneg] = ACTIONS(5880),
    [anon_sym_TILDE] = ACTIONS(5882),
    [anon_sym_u00ac] = ACTIONS(5880),
    [sym_union] = ACTIONS(5882),
    [sym_powerset] = ACTIONS(5882),
    [sym_domain] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [sym_negative_dot] = ACTIONS(5880),
    [sym_enabled] = ACTIONS(5882),
    [sym_unchanged] = ACTIONS(5882),
    [anon_sym_LT_GT] = ACTIONS(5880),
    [anon_sym_u22c4] = ACTIONS(5880),
    [anon_sym_u25c7] = ACTIONS(5880),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5882),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [anon_sym_ASSUME] = ACTIONS(5882),
    [anon_sym_ASSUMPTION] = ACTIONS(5882),
    [anon_sym_AXIOM] = ACTIONS(5882),
    [anon_sym_THEOREM] = ACTIONS(5882),
    [anon_sym_PROPOSITION] = ACTIONS(5882),
    [anon_sym_LEMMA] = ACTIONS(5882),
    [anon_sym_COROLLARY] = ACTIONS(5882),
    [anon_sym_USE] = ACTIONS(5882),
    [anon_sym_HIDE] = ACTIONS(5882),
    [anon_sym_DEF] = ACTIONS(5882),
    [anon_sym_DEFS] = ACTIONS(5882),
    [sym__double_excl] = ACTIONS(5880),
  },
  [2472] = {
    [sym_block_comment] = STATE(2472),
    [ts_builtin_sym_end] = ACTIONS(5938),
    [sym_identifier] = ACTIONS(5936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5938),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_LOCAL] = ACTIONS(5936),
    [anon_sym_VARIABLE] = ACTIONS(5936),
    [anon_sym_VARIABLES] = ACTIONS(5936),
    [anon_sym_CONSTANT] = ACTIONS(5936),
    [anon_sym_CONSTANTS] = ACTIONS(5936),
    [anon_sym_RECURSIVE] = ACTIONS(5936),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_INSTANCE] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_Nat] = ACTIONS(5936),
    [anon_sym_u2115] = ACTIONS(5938),
    [anon_sym_Int] = ACTIONS(5936),
    [anon_sym_u2124] = ACTIONS(5938),
    [anon_sym_Real] = ACTIONS(5936),
    [anon_sym_u211d] = ACTIONS(5938),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_BSLASHlnot] = ACTIONS(5938),
    [anon_sym_BSLASHneg] = ACTIONS(5938),
    [anon_sym_TILDE] = ACTIONS(5936),
    [anon_sym_u00ac] = ACTIONS(5938),
    [sym_union] = ACTIONS(5936),
    [sym_powerset] = ACTIONS(5936),
    [sym_domain] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [sym_negative_dot] = ACTIONS(5938),
    [sym_enabled] = ACTIONS(5936),
    [sym_unchanged] = ACTIONS(5936),
    [anon_sym_LT_GT] = ACTIONS(5938),
    [anon_sym_u22c4] = ACTIONS(5938),
    [anon_sym_u25c7] = ACTIONS(5938),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5936),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [anon_sym_ASSUME] = ACTIONS(5936),
    [anon_sym_ASSUMPTION] = ACTIONS(5936),
    [anon_sym_AXIOM] = ACTIONS(5936),
    [anon_sym_THEOREM] = ACTIONS(5936),
    [anon_sym_PROPOSITION] = ACTIONS(5936),
    [anon_sym_LEMMA] = ACTIONS(5936),
    [anon_sym_COROLLARY] = ACTIONS(5936),
    [anon_sym_USE] = ACTIONS(5936),
    [anon_sym_HIDE] = ACTIONS(5936),
    [anon_sym_DEF] = ACTIONS(5936),
    [anon_sym_DEFS] = ACTIONS(5936),
    [sym__double_excl] = ACTIONS(5938),
  },
  [2473] = {
    [sym_block_comment] = STATE(2473),
    [ts_builtin_sym_end] = ACTIONS(5884),
    [sym_identifier] = ACTIONS(5886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5884),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_COMMA] = ACTIONS(5884),
    [anon_sym_LOCAL] = ACTIONS(5886),
    [anon_sym_VARIABLE] = ACTIONS(5886),
    [anon_sym_VARIABLES] = ACTIONS(5886),
    [anon_sym_CONSTANT] = ACTIONS(5886),
    [anon_sym_CONSTANTS] = ACTIONS(5886),
    [anon_sym_RECURSIVE] = ACTIONS(5886),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_INSTANCE] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_Nat] = ACTIONS(5886),
    [anon_sym_u2115] = ACTIONS(5884),
    [anon_sym_Int] = ACTIONS(5886),
    [anon_sym_u2124] = ACTIONS(5884),
    [anon_sym_Real] = ACTIONS(5886),
    [anon_sym_u211d] = ACTIONS(5884),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_BSLASHlnot] = ACTIONS(5884),
    [anon_sym_BSLASHneg] = ACTIONS(5884),
    [anon_sym_TILDE] = ACTIONS(5886),
    [anon_sym_u00ac] = ACTIONS(5884),
    [sym_union] = ACTIONS(5886),
    [sym_powerset] = ACTIONS(5886),
    [sym_domain] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [sym_negative_dot] = ACTIONS(5884),
    [sym_enabled] = ACTIONS(5886),
    [sym_unchanged] = ACTIONS(5886),
    [anon_sym_LT_GT] = ACTIONS(5884),
    [anon_sym_u22c4] = ACTIONS(5884),
    [anon_sym_u25c7] = ACTIONS(5884),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5886),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [anon_sym_ASSUME] = ACTIONS(5886),
    [anon_sym_ASSUMPTION] = ACTIONS(5886),
    [anon_sym_AXIOM] = ACTIONS(5886),
    [anon_sym_THEOREM] = ACTIONS(5886),
    [anon_sym_PROPOSITION] = ACTIONS(5886),
    [anon_sym_LEMMA] = ACTIONS(5886),
    [anon_sym_COROLLARY] = ACTIONS(5886),
    [anon_sym_USE] = ACTIONS(5886),
    [anon_sym_HIDE] = ACTIONS(5886),
    [anon_sym_DEF] = ACTIONS(5886),
    [anon_sym_DEFS] = ACTIONS(5886),
    [sym__double_excl] = ACTIONS(5884),
  },
  [2474] = {
    [sym_block_comment] = STATE(2474),
    [ts_builtin_sym_end] = ACTIONS(5756),
    [sym_identifier] = ACTIONS(5758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5756),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_LOCAL] = ACTIONS(5758),
    [anon_sym_VARIABLE] = ACTIONS(5758),
    [anon_sym_VARIABLES] = ACTIONS(5758),
    [anon_sym_CONSTANT] = ACTIONS(5758),
    [anon_sym_CONSTANTS] = ACTIONS(5758),
    [anon_sym_RECURSIVE] = ACTIONS(5758),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_INSTANCE] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_Nat] = ACTIONS(5758),
    [anon_sym_u2115] = ACTIONS(5756),
    [anon_sym_Int] = ACTIONS(5758),
    [anon_sym_u2124] = ACTIONS(5756),
    [anon_sym_Real] = ACTIONS(5758),
    [anon_sym_u211d] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_BSLASHlnot] = ACTIONS(5756),
    [anon_sym_BSLASHneg] = ACTIONS(5756),
    [anon_sym_TILDE] = ACTIONS(5758),
    [anon_sym_u00ac] = ACTIONS(5756),
    [sym_union] = ACTIONS(5758),
    [sym_powerset] = ACTIONS(5758),
    [sym_domain] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [sym_negative_dot] = ACTIONS(5756),
    [sym_enabled] = ACTIONS(5758),
    [sym_unchanged] = ACTIONS(5758),
    [anon_sym_LT_GT] = ACTIONS(5756),
    [anon_sym_u22c4] = ACTIONS(5756),
    [anon_sym_u25c7] = ACTIONS(5756),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5758),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [anon_sym_ASSUME] = ACTIONS(5758),
    [anon_sym_ASSUMPTION] = ACTIONS(5758),
    [anon_sym_AXIOM] = ACTIONS(5758),
    [anon_sym_THEOREM] = ACTIONS(5758),
    [anon_sym_PROPOSITION] = ACTIONS(5758),
    [anon_sym_LEMMA] = ACTIONS(5758),
    [anon_sym_COROLLARY] = ACTIONS(5758),
    [anon_sym_USE] = ACTIONS(5758),
    [anon_sym_HIDE] = ACTIONS(5758),
    [anon_sym_DEF] = ACTIONS(5758),
    [anon_sym_DEFS] = ACTIONS(5758),
    [sym__double_excl] = ACTIONS(5756),
  },
  [2475] = {
    [sym_block_comment] = STATE(2475),
    [sym_identifier] = ACTIONS(5804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5802),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_COMMA] = ACTIONS(5802),
    [anon_sym_LOCAL] = ACTIONS(5804),
    [anon_sym_VARIABLE] = ACTIONS(5804),
    [anon_sym_VARIABLES] = ACTIONS(5804),
    [anon_sym_CONSTANT] = ACTIONS(5804),
    [anon_sym_CONSTANTS] = ACTIONS(5804),
    [anon_sym_RECURSIVE] = ACTIONS(5804),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_INSTANCE] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_Nat] = ACTIONS(5804),
    [anon_sym_u2115] = ACTIONS(5802),
    [anon_sym_Int] = ACTIONS(5804),
    [anon_sym_u2124] = ACTIONS(5802),
    [anon_sym_Real] = ACTIONS(5804),
    [anon_sym_u211d] = ACTIONS(5802),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_BSLASHlnot] = ACTIONS(5802),
    [anon_sym_BSLASHneg] = ACTIONS(5802),
    [anon_sym_TILDE] = ACTIONS(5804),
    [anon_sym_u00ac] = ACTIONS(5802),
    [sym_union] = ACTIONS(5804),
    [sym_powerset] = ACTIONS(5804),
    [sym_domain] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [sym_negative_dot] = ACTIONS(5802),
    [sym_enabled] = ACTIONS(5804),
    [sym_unchanged] = ACTIONS(5804),
    [anon_sym_LT_GT] = ACTIONS(5802),
    [anon_sym_u22c4] = ACTIONS(5802),
    [anon_sym_u25c7] = ACTIONS(5802),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5804),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [anon_sym_ASSUME] = ACTIONS(5804),
    [anon_sym_ASSUMPTION] = ACTIONS(5804),
    [anon_sym_AXIOM] = ACTIONS(5804),
    [anon_sym_THEOREM] = ACTIONS(5804),
    [anon_sym_PROPOSITION] = ACTIONS(5804),
    [anon_sym_LEMMA] = ACTIONS(5804),
    [anon_sym_COROLLARY] = ACTIONS(5804),
    [anon_sym_USE] = ACTIONS(5804),
    [anon_sym_HIDE] = ACTIONS(5804),
    [anon_sym_DEF] = ACTIONS(5804),
    [anon_sym_DEFS] = ACTIONS(5804),
    [sym__double_excl] = ACTIONS(5802),
  },
  [2476] = {
    [sym_block_comment] = STATE(2476),
    [ts_builtin_sym_end] = ACTIONS(5926),
    [sym_identifier] = ACTIONS(5924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5926),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_LOCAL] = ACTIONS(5924),
    [anon_sym_VARIABLE] = ACTIONS(5924),
    [anon_sym_VARIABLES] = ACTIONS(5924),
    [anon_sym_CONSTANT] = ACTIONS(5924),
    [anon_sym_CONSTANTS] = ACTIONS(5924),
    [anon_sym_RECURSIVE] = ACTIONS(5924),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_INSTANCE] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_Nat] = ACTIONS(5924),
    [anon_sym_u2115] = ACTIONS(5926),
    [anon_sym_Int] = ACTIONS(5924),
    [anon_sym_u2124] = ACTIONS(5926),
    [anon_sym_Real] = ACTIONS(5924),
    [anon_sym_u211d] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_BSLASHlnot] = ACTIONS(5926),
    [anon_sym_BSLASHneg] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5924),
    [anon_sym_u00ac] = ACTIONS(5926),
    [sym_union] = ACTIONS(5924),
    [sym_powerset] = ACTIONS(5924),
    [sym_domain] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [sym_negative_dot] = ACTIONS(5926),
    [sym_enabled] = ACTIONS(5924),
    [sym_unchanged] = ACTIONS(5924),
    [anon_sym_LT_GT] = ACTIONS(5926),
    [anon_sym_u22c4] = ACTIONS(5926),
    [anon_sym_u25c7] = ACTIONS(5926),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5924),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [anon_sym_ASSUME] = ACTIONS(5924),
    [anon_sym_ASSUMPTION] = ACTIONS(5924),
    [anon_sym_AXIOM] = ACTIONS(5924),
    [anon_sym_THEOREM] = ACTIONS(5924),
    [anon_sym_PROPOSITION] = ACTIONS(5924),
    [anon_sym_LEMMA] = ACTIONS(5924),
    [anon_sym_COROLLARY] = ACTIONS(5924),
    [anon_sym_USE] = ACTIONS(5924),
    [anon_sym_HIDE] = ACTIONS(5924),
    [anon_sym_DEF] = ACTIONS(5924),
    [anon_sym_DEFS] = ACTIONS(5924),
    [sym__double_excl] = ACTIONS(5926),
  },
  [2477] = {
    [sym_block_comment] = STATE(2477),
    [ts_builtin_sym_end] = ACTIONS(5740),
    [sym_identifier] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5740),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5740),
    [anon_sym_LOCAL] = ACTIONS(5742),
    [anon_sym_VARIABLE] = ACTIONS(5742),
    [anon_sym_VARIABLES] = ACTIONS(5742),
    [anon_sym_CONSTANT] = ACTIONS(5742),
    [anon_sym_CONSTANTS] = ACTIONS(5742),
    [anon_sym_RECURSIVE] = ACTIONS(5742),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_INSTANCE] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_Nat] = ACTIONS(5742),
    [anon_sym_u2115] = ACTIONS(5740),
    [anon_sym_Int] = ACTIONS(5742),
    [anon_sym_u2124] = ACTIONS(5740),
    [anon_sym_Real] = ACTIONS(5742),
    [anon_sym_u211d] = ACTIONS(5740),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_BSLASHlnot] = ACTIONS(5740),
    [anon_sym_BSLASHneg] = ACTIONS(5740),
    [anon_sym_TILDE] = ACTIONS(5742),
    [anon_sym_u00ac] = ACTIONS(5740),
    [sym_union] = ACTIONS(5742),
    [sym_powerset] = ACTIONS(5742),
    [sym_domain] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [sym_negative_dot] = ACTIONS(5740),
    [sym_enabled] = ACTIONS(5742),
    [sym_unchanged] = ACTIONS(5742),
    [anon_sym_LT_GT] = ACTIONS(5740),
    [anon_sym_u22c4] = ACTIONS(5740),
    [anon_sym_u25c7] = ACTIONS(5740),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5742),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [anon_sym_ASSUME] = ACTIONS(5742),
    [anon_sym_ASSUMPTION] = ACTIONS(5742),
    [anon_sym_AXIOM] = ACTIONS(5742),
    [anon_sym_THEOREM] = ACTIONS(5742),
    [anon_sym_PROPOSITION] = ACTIONS(5742),
    [anon_sym_LEMMA] = ACTIONS(5742),
    [anon_sym_COROLLARY] = ACTIONS(5742),
    [anon_sym_USE] = ACTIONS(5742),
    [anon_sym_HIDE] = ACTIONS(5742),
    [anon_sym_DEF] = ACTIONS(5742),
    [anon_sym_DEFS] = ACTIONS(5742),
    [sym__double_excl] = ACTIONS(5740),
  },
  [2478] = {
    [sym_block_comment] = STATE(2478),
    [ts_builtin_sym_end] = ACTIONS(5744),
    [sym_identifier] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5744),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_LOCAL] = ACTIONS(5746),
    [anon_sym_VARIABLE] = ACTIONS(5746),
    [anon_sym_VARIABLES] = ACTIONS(5746),
    [anon_sym_CONSTANT] = ACTIONS(5746),
    [anon_sym_CONSTANTS] = ACTIONS(5746),
    [anon_sym_RECURSIVE] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_INSTANCE] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_Nat] = ACTIONS(5746),
    [anon_sym_u2115] = ACTIONS(5744),
    [anon_sym_Int] = ACTIONS(5746),
    [anon_sym_u2124] = ACTIONS(5744),
    [anon_sym_Real] = ACTIONS(5746),
    [anon_sym_u211d] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_BSLASHlnot] = ACTIONS(5744),
    [anon_sym_BSLASHneg] = ACTIONS(5744),
    [anon_sym_TILDE] = ACTIONS(5746),
    [anon_sym_u00ac] = ACTIONS(5744),
    [sym_union] = ACTIONS(5746),
    [sym_powerset] = ACTIONS(5746),
    [sym_domain] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [sym_negative_dot] = ACTIONS(5744),
    [sym_enabled] = ACTIONS(5746),
    [sym_unchanged] = ACTIONS(5746),
    [anon_sym_LT_GT] = ACTIONS(5744),
    [anon_sym_u22c4] = ACTIONS(5744),
    [anon_sym_u25c7] = ACTIONS(5744),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5746),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [anon_sym_ASSUME] = ACTIONS(5746),
    [anon_sym_ASSUMPTION] = ACTIONS(5746),
    [anon_sym_AXIOM] = ACTIONS(5746),
    [anon_sym_THEOREM] = ACTIONS(5746),
    [anon_sym_PROPOSITION] = ACTIONS(5746),
    [anon_sym_LEMMA] = ACTIONS(5746),
    [anon_sym_COROLLARY] = ACTIONS(5746),
    [anon_sym_USE] = ACTIONS(5746),
    [anon_sym_HIDE] = ACTIONS(5746),
    [anon_sym_DEF] = ACTIONS(5746),
    [anon_sym_DEFS] = ACTIONS(5746),
    [sym__double_excl] = ACTIONS(5744),
  },
  [2479] = {
    [sym_block_comment] = STATE(2479),
    [ts_builtin_sym_end] = ACTIONS(5736),
    [sym_identifier] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5736),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_LOCAL] = ACTIONS(5738),
    [anon_sym_VARIABLE] = ACTIONS(5738),
    [anon_sym_VARIABLES] = ACTIONS(5738),
    [anon_sym_CONSTANT] = ACTIONS(5738),
    [anon_sym_CONSTANTS] = ACTIONS(5738),
    [anon_sym_RECURSIVE] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_INSTANCE] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_Nat] = ACTIONS(5738),
    [anon_sym_u2115] = ACTIONS(5736),
    [anon_sym_Int] = ACTIONS(5738),
    [anon_sym_u2124] = ACTIONS(5736),
    [anon_sym_Real] = ACTIONS(5738),
    [anon_sym_u211d] = ACTIONS(5736),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_BSLASHlnot] = ACTIONS(5736),
    [anon_sym_BSLASHneg] = ACTIONS(5736),
    [anon_sym_TILDE] = ACTIONS(5738),
    [anon_sym_u00ac] = ACTIONS(5736),
    [sym_union] = ACTIONS(5738),
    [sym_powerset] = ACTIONS(5738),
    [sym_domain] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [sym_negative_dot] = ACTIONS(5736),
    [sym_enabled] = ACTIONS(5738),
    [sym_unchanged] = ACTIONS(5738),
    [anon_sym_LT_GT] = ACTIONS(5736),
    [anon_sym_u22c4] = ACTIONS(5736),
    [anon_sym_u25c7] = ACTIONS(5736),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5738),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [anon_sym_ASSUME] = ACTIONS(5738),
    [anon_sym_ASSUMPTION] = ACTIONS(5738),
    [anon_sym_AXIOM] = ACTIONS(5738),
    [anon_sym_THEOREM] = ACTIONS(5738),
    [anon_sym_PROPOSITION] = ACTIONS(5738),
    [anon_sym_LEMMA] = ACTIONS(5738),
    [anon_sym_COROLLARY] = ACTIONS(5738),
    [anon_sym_USE] = ACTIONS(5738),
    [anon_sym_HIDE] = ACTIONS(5738),
    [anon_sym_DEF] = ACTIONS(5738),
    [anon_sym_DEFS] = ACTIONS(5738),
    [sym__double_excl] = ACTIONS(5736),
  },
  [2480] = {
    [sym_block_comment] = STATE(2480),
    [ts_builtin_sym_end] = ACTIONS(5760),
    [sym_identifier] = ACTIONS(5762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5760),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_LOCAL] = ACTIONS(5762),
    [anon_sym_VARIABLE] = ACTIONS(5762),
    [anon_sym_VARIABLES] = ACTIONS(5762),
    [anon_sym_CONSTANT] = ACTIONS(5762),
    [anon_sym_CONSTANTS] = ACTIONS(5762),
    [anon_sym_RECURSIVE] = ACTIONS(5762),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_INSTANCE] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_Nat] = ACTIONS(5762),
    [anon_sym_u2115] = ACTIONS(5760),
    [anon_sym_Int] = ACTIONS(5762),
    [anon_sym_u2124] = ACTIONS(5760),
    [anon_sym_Real] = ACTIONS(5762),
    [anon_sym_u211d] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_BSLASHlnot] = ACTIONS(5760),
    [anon_sym_BSLASHneg] = ACTIONS(5760),
    [anon_sym_TILDE] = ACTIONS(5762),
    [anon_sym_u00ac] = ACTIONS(5760),
    [sym_union] = ACTIONS(5762),
    [sym_powerset] = ACTIONS(5762),
    [sym_domain] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [sym_negative_dot] = ACTIONS(5760),
    [sym_enabled] = ACTIONS(5762),
    [sym_unchanged] = ACTIONS(5762),
    [anon_sym_LT_GT] = ACTIONS(5760),
    [anon_sym_u22c4] = ACTIONS(5760),
    [anon_sym_u25c7] = ACTIONS(5760),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5762),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [anon_sym_ASSUME] = ACTIONS(5762),
    [anon_sym_ASSUMPTION] = ACTIONS(5762),
    [anon_sym_AXIOM] = ACTIONS(5762),
    [anon_sym_THEOREM] = ACTIONS(5762),
    [anon_sym_PROPOSITION] = ACTIONS(5762),
    [anon_sym_LEMMA] = ACTIONS(5762),
    [anon_sym_COROLLARY] = ACTIONS(5762),
    [anon_sym_USE] = ACTIONS(5762),
    [anon_sym_HIDE] = ACTIONS(5762),
    [anon_sym_DEF] = ACTIONS(5762),
    [anon_sym_DEFS] = ACTIONS(5762),
    [sym__double_excl] = ACTIONS(5760),
  },
  [2481] = {
    [sym_block_comment] = STATE(2481),
    [ts_builtin_sym_end] = ACTIONS(5764),
    [sym_identifier] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5764),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_LOCAL] = ACTIONS(5766),
    [anon_sym_VARIABLE] = ACTIONS(5766),
    [anon_sym_VARIABLES] = ACTIONS(5766),
    [anon_sym_CONSTANT] = ACTIONS(5766),
    [anon_sym_CONSTANTS] = ACTIONS(5766),
    [anon_sym_RECURSIVE] = ACTIONS(5766),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_INSTANCE] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_Nat] = ACTIONS(5766),
    [anon_sym_u2115] = ACTIONS(5764),
    [anon_sym_Int] = ACTIONS(5766),
    [anon_sym_u2124] = ACTIONS(5764),
    [anon_sym_Real] = ACTIONS(5766),
    [anon_sym_u211d] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_BSLASHlnot] = ACTIONS(5764),
    [anon_sym_BSLASHneg] = ACTIONS(5764),
    [anon_sym_TILDE] = ACTIONS(5766),
    [anon_sym_u00ac] = ACTIONS(5764),
    [sym_union] = ACTIONS(5766),
    [sym_powerset] = ACTIONS(5766),
    [sym_domain] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [sym_negative_dot] = ACTIONS(5764),
    [sym_enabled] = ACTIONS(5766),
    [sym_unchanged] = ACTIONS(5766),
    [anon_sym_LT_GT] = ACTIONS(5764),
    [anon_sym_u22c4] = ACTIONS(5764),
    [anon_sym_u25c7] = ACTIONS(5764),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5766),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [anon_sym_ASSUME] = ACTIONS(5766),
    [anon_sym_ASSUMPTION] = ACTIONS(5766),
    [anon_sym_AXIOM] = ACTIONS(5766),
    [anon_sym_THEOREM] = ACTIONS(5766),
    [anon_sym_PROPOSITION] = ACTIONS(5766),
    [anon_sym_LEMMA] = ACTIONS(5766),
    [anon_sym_COROLLARY] = ACTIONS(5766),
    [anon_sym_USE] = ACTIONS(5766),
    [anon_sym_HIDE] = ACTIONS(5766),
    [anon_sym_DEF] = ACTIONS(5766),
    [anon_sym_DEFS] = ACTIONS(5766),
    [sym__double_excl] = ACTIONS(5764),
  },
  [2482] = {
    [sym_block_comment] = STATE(2482),
    [sym_identifier] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5838),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_LOCAL] = ACTIONS(5840),
    [anon_sym_VARIABLE] = ACTIONS(5840),
    [anon_sym_VARIABLES] = ACTIONS(5840),
    [anon_sym_CONSTANT] = ACTIONS(5840),
    [anon_sym_CONSTANTS] = ACTIONS(5840),
    [anon_sym_RECURSIVE] = ACTIONS(5840),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_INSTANCE] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_Nat] = ACTIONS(5840),
    [anon_sym_u2115] = ACTIONS(5838),
    [anon_sym_Int] = ACTIONS(5840),
    [anon_sym_u2124] = ACTIONS(5838),
    [anon_sym_Real] = ACTIONS(5840),
    [anon_sym_u211d] = ACTIONS(5838),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_BSLASHlnot] = ACTIONS(5838),
    [anon_sym_BSLASHneg] = ACTIONS(5838),
    [anon_sym_TILDE] = ACTIONS(5840),
    [anon_sym_u00ac] = ACTIONS(5838),
    [sym_union] = ACTIONS(5840),
    [sym_powerset] = ACTIONS(5840),
    [sym_domain] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [sym_negative_dot] = ACTIONS(5838),
    [sym_enabled] = ACTIONS(5840),
    [sym_unchanged] = ACTIONS(5840),
    [anon_sym_LT_GT] = ACTIONS(5838),
    [anon_sym_u22c4] = ACTIONS(5838),
    [anon_sym_u25c7] = ACTIONS(5838),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5840),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [anon_sym_ASSUME] = ACTIONS(5840),
    [anon_sym_ASSUMPTION] = ACTIONS(5840),
    [anon_sym_AXIOM] = ACTIONS(5840),
    [anon_sym_THEOREM] = ACTIONS(5840),
    [anon_sym_PROPOSITION] = ACTIONS(5840),
    [anon_sym_LEMMA] = ACTIONS(5840),
    [anon_sym_COROLLARY] = ACTIONS(5840),
    [anon_sym_USE] = ACTIONS(5840),
    [anon_sym_HIDE] = ACTIONS(5840),
    [anon_sym_DEF] = ACTIONS(5840),
    [anon_sym_DEFS] = ACTIONS(5840),
    [sym__double_excl] = ACTIONS(5838),
  },
  [2483] = {
    [sym_block_comment] = STATE(2483),
    [ts_builtin_sym_end] = ACTIONS(5724),
    [sym_identifier] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5724),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_COMMA] = ACTIONS(5724),
    [anon_sym_LOCAL] = ACTIONS(5726),
    [anon_sym_VARIABLE] = ACTIONS(5726),
    [anon_sym_VARIABLES] = ACTIONS(5726),
    [anon_sym_CONSTANT] = ACTIONS(5726),
    [anon_sym_CONSTANTS] = ACTIONS(5726),
    [anon_sym_RECURSIVE] = ACTIONS(5726),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_INSTANCE] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_Nat] = ACTIONS(5726),
    [anon_sym_u2115] = ACTIONS(5724),
    [anon_sym_Int] = ACTIONS(5726),
    [anon_sym_u2124] = ACTIONS(5724),
    [anon_sym_Real] = ACTIONS(5726),
    [anon_sym_u211d] = ACTIONS(5724),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_BSLASHlnot] = ACTIONS(5724),
    [anon_sym_BSLASHneg] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5726),
    [anon_sym_u00ac] = ACTIONS(5724),
    [sym_union] = ACTIONS(5726),
    [sym_powerset] = ACTIONS(5726),
    [sym_domain] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [sym_negative_dot] = ACTIONS(5724),
    [sym_enabled] = ACTIONS(5726),
    [sym_unchanged] = ACTIONS(5726),
    [anon_sym_LT_GT] = ACTIONS(5724),
    [anon_sym_u22c4] = ACTIONS(5724),
    [anon_sym_u25c7] = ACTIONS(5724),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5726),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [anon_sym_ASSUME] = ACTIONS(5726),
    [anon_sym_ASSUMPTION] = ACTIONS(5726),
    [anon_sym_AXIOM] = ACTIONS(5726),
    [anon_sym_THEOREM] = ACTIONS(5726),
    [anon_sym_PROPOSITION] = ACTIONS(5726),
    [anon_sym_LEMMA] = ACTIONS(5726),
    [anon_sym_COROLLARY] = ACTIONS(5726),
    [anon_sym_USE] = ACTIONS(5726),
    [anon_sym_HIDE] = ACTIONS(5726),
    [anon_sym_DEF] = ACTIONS(5726),
    [anon_sym_DEFS] = ACTIONS(5726),
    [sym__double_excl] = ACTIONS(5724),
  },
  [2484] = {
    [sym_block_comment] = STATE(2484),
    [sym_identifier] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5842),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_COMMA] = ACTIONS(5842),
    [anon_sym_LOCAL] = ACTIONS(5844),
    [anon_sym_VARIABLE] = ACTIONS(5844),
    [anon_sym_VARIABLES] = ACTIONS(5844),
    [anon_sym_CONSTANT] = ACTIONS(5844),
    [anon_sym_CONSTANTS] = ACTIONS(5844),
    [anon_sym_RECURSIVE] = ACTIONS(5844),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_INSTANCE] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_Nat] = ACTIONS(5844),
    [anon_sym_u2115] = ACTIONS(5842),
    [anon_sym_Int] = ACTIONS(5844),
    [anon_sym_u2124] = ACTIONS(5842),
    [anon_sym_Real] = ACTIONS(5844),
    [anon_sym_u211d] = ACTIONS(5842),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_BSLASHlnot] = ACTIONS(5842),
    [anon_sym_BSLASHneg] = ACTIONS(5842),
    [anon_sym_TILDE] = ACTIONS(5844),
    [anon_sym_u00ac] = ACTIONS(5842),
    [sym_union] = ACTIONS(5844),
    [sym_powerset] = ACTIONS(5844),
    [sym_domain] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [sym_negative_dot] = ACTIONS(5842),
    [sym_enabled] = ACTIONS(5844),
    [sym_unchanged] = ACTIONS(5844),
    [anon_sym_LT_GT] = ACTIONS(5842),
    [anon_sym_u22c4] = ACTIONS(5842),
    [anon_sym_u25c7] = ACTIONS(5842),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5844),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [anon_sym_ASSUME] = ACTIONS(5844),
    [anon_sym_ASSUMPTION] = ACTIONS(5844),
    [anon_sym_AXIOM] = ACTIONS(5844),
    [anon_sym_THEOREM] = ACTIONS(5844),
    [anon_sym_PROPOSITION] = ACTIONS(5844),
    [anon_sym_LEMMA] = ACTIONS(5844),
    [anon_sym_COROLLARY] = ACTIONS(5844),
    [anon_sym_USE] = ACTIONS(5844),
    [anon_sym_HIDE] = ACTIONS(5844),
    [anon_sym_DEF] = ACTIONS(5844),
    [anon_sym_DEFS] = ACTIONS(5844),
    [sym__double_excl] = ACTIONS(5842),
  },
  [2485] = {
    [sym_block_comment] = STATE(2485),
    [sym_identifier] = ACTIONS(5864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5862),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5862),
    [anon_sym_LOCAL] = ACTIONS(5864),
    [anon_sym_VARIABLE] = ACTIONS(5864),
    [anon_sym_VARIABLES] = ACTIONS(5864),
    [anon_sym_CONSTANT] = ACTIONS(5864),
    [anon_sym_CONSTANTS] = ACTIONS(5864),
    [anon_sym_RECURSIVE] = ACTIONS(5864),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_INSTANCE] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_Nat] = ACTIONS(5864),
    [anon_sym_u2115] = ACTIONS(5862),
    [anon_sym_Int] = ACTIONS(5864),
    [anon_sym_u2124] = ACTIONS(5862),
    [anon_sym_Real] = ACTIONS(5864),
    [anon_sym_u211d] = ACTIONS(5862),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_BSLASHlnot] = ACTIONS(5862),
    [anon_sym_BSLASHneg] = ACTIONS(5862),
    [anon_sym_TILDE] = ACTIONS(5864),
    [anon_sym_u00ac] = ACTIONS(5862),
    [sym_union] = ACTIONS(5864),
    [sym_powerset] = ACTIONS(5864),
    [sym_domain] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [sym_negative_dot] = ACTIONS(5862),
    [sym_enabled] = ACTIONS(5864),
    [sym_unchanged] = ACTIONS(5864),
    [anon_sym_LT_GT] = ACTIONS(5862),
    [anon_sym_u22c4] = ACTIONS(5862),
    [anon_sym_u25c7] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5864),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [anon_sym_ASSUME] = ACTIONS(5864),
    [anon_sym_ASSUMPTION] = ACTIONS(5864),
    [anon_sym_AXIOM] = ACTIONS(5864),
    [anon_sym_THEOREM] = ACTIONS(5864),
    [anon_sym_PROPOSITION] = ACTIONS(5864),
    [anon_sym_LEMMA] = ACTIONS(5864),
    [anon_sym_COROLLARY] = ACTIONS(5864),
    [anon_sym_USE] = ACTIONS(5864),
    [anon_sym_HIDE] = ACTIONS(5864),
    [anon_sym_DEF] = ACTIONS(5864),
    [anon_sym_DEFS] = ACTIONS(5864),
    [sym__double_excl] = ACTIONS(5862),
  },
  [2486] = {
    [sym_block_comment] = STATE(2486),
    [ts_builtin_sym_end] = ACTIONS(5830),
    [sym_identifier] = ACTIONS(5832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5830),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_COMMA] = ACTIONS(5830),
    [anon_sym_LOCAL] = ACTIONS(5832),
    [anon_sym_VARIABLE] = ACTIONS(5832),
    [anon_sym_VARIABLES] = ACTIONS(5832),
    [anon_sym_CONSTANT] = ACTIONS(5832),
    [anon_sym_CONSTANTS] = ACTIONS(5832),
    [anon_sym_RECURSIVE] = ACTIONS(5832),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_INSTANCE] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_Nat] = ACTIONS(5832),
    [anon_sym_u2115] = ACTIONS(5830),
    [anon_sym_Int] = ACTIONS(5832),
    [anon_sym_u2124] = ACTIONS(5830),
    [anon_sym_Real] = ACTIONS(5832),
    [anon_sym_u211d] = ACTIONS(5830),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_BSLASHlnot] = ACTIONS(5830),
    [anon_sym_BSLASHneg] = ACTIONS(5830),
    [anon_sym_TILDE] = ACTIONS(5832),
    [anon_sym_u00ac] = ACTIONS(5830),
    [sym_union] = ACTIONS(5832),
    [sym_powerset] = ACTIONS(5832),
    [sym_domain] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [sym_negative_dot] = ACTIONS(5830),
    [sym_enabled] = ACTIONS(5832),
    [sym_unchanged] = ACTIONS(5832),
    [anon_sym_LT_GT] = ACTIONS(5830),
    [anon_sym_u22c4] = ACTIONS(5830),
    [anon_sym_u25c7] = ACTIONS(5830),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5832),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [anon_sym_ASSUME] = ACTIONS(5832),
    [anon_sym_ASSUMPTION] = ACTIONS(5832),
    [anon_sym_AXIOM] = ACTIONS(5832),
    [anon_sym_THEOREM] = ACTIONS(5832),
    [anon_sym_PROPOSITION] = ACTIONS(5832),
    [anon_sym_LEMMA] = ACTIONS(5832),
    [anon_sym_COROLLARY] = ACTIONS(5832),
    [anon_sym_USE] = ACTIONS(5832),
    [anon_sym_HIDE] = ACTIONS(5832),
    [anon_sym_DEF] = ACTIONS(5832),
    [anon_sym_DEFS] = ACTIONS(5832),
    [sym__double_excl] = ACTIONS(5830),
  },
  [2487] = {
    [sym_block_comment] = STATE(2487),
    [sym_identifier] = ACTIONS(5894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5892),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_LOCAL] = ACTIONS(5894),
    [anon_sym_VARIABLE] = ACTIONS(5894),
    [anon_sym_VARIABLES] = ACTIONS(5894),
    [anon_sym_CONSTANT] = ACTIONS(5894),
    [anon_sym_CONSTANTS] = ACTIONS(5894),
    [anon_sym_RECURSIVE] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_INSTANCE] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_Nat] = ACTIONS(5894),
    [anon_sym_u2115] = ACTIONS(5892),
    [anon_sym_Int] = ACTIONS(5894),
    [anon_sym_u2124] = ACTIONS(5892),
    [anon_sym_Real] = ACTIONS(5894),
    [anon_sym_u211d] = ACTIONS(5892),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_BSLASHlnot] = ACTIONS(5892),
    [anon_sym_BSLASHneg] = ACTIONS(5892),
    [anon_sym_TILDE] = ACTIONS(5894),
    [anon_sym_u00ac] = ACTIONS(5892),
    [sym_union] = ACTIONS(5894),
    [sym_powerset] = ACTIONS(5894),
    [sym_domain] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [sym_negative_dot] = ACTIONS(5892),
    [sym_enabled] = ACTIONS(5894),
    [sym_unchanged] = ACTIONS(5894),
    [anon_sym_LT_GT] = ACTIONS(5892),
    [anon_sym_u22c4] = ACTIONS(5892),
    [anon_sym_u25c7] = ACTIONS(5892),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5894),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [anon_sym_ASSUME] = ACTIONS(5894),
    [anon_sym_ASSUMPTION] = ACTIONS(5894),
    [anon_sym_AXIOM] = ACTIONS(5894),
    [anon_sym_THEOREM] = ACTIONS(5894),
    [anon_sym_PROPOSITION] = ACTIONS(5894),
    [anon_sym_LEMMA] = ACTIONS(5894),
    [anon_sym_COROLLARY] = ACTIONS(5894),
    [anon_sym_USE] = ACTIONS(5894),
    [anon_sym_HIDE] = ACTIONS(5894),
    [anon_sym_DEF] = ACTIONS(5894),
    [anon_sym_DEFS] = ACTIONS(5894),
    [sym__double_excl] = ACTIONS(5892),
  },
  [2488] = {
    [sym_block_comment] = STATE(2488),
    [sym_identifier] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5896),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_COMMA] = ACTIONS(5896),
    [anon_sym_LOCAL] = ACTIONS(5898),
    [anon_sym_VARIABLE] = ACTIONS(5898),
    [anon_sym_VARIABLES] = ACTIONS(5898),
    [anon_sym_CONSTANT] = ACTIONS(5898),
    [anon_sym_CONSTANTS] = ACTIONS(5898),
    [anon_sym_RECURSIVE] = ACTIONS(5898),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_INSTANCE] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_Nat] = ACTIONS(5898),
    [anon_sym_u2115] = ACTIONS(5896),
    [anon_sym_Int] = ACTIONS(5898),
    [anon_sym_u2124] = ACTIONS(5896),
    [anon_sym_Real] = ACTIONS(5898),
    [anon_sym_u211d] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_BSLASHlnot] = ACTIONS(5896),
    [anon_sym_BSLASHneg] = ACTIONS(5896),
    [anon_sym_TILDE] = ACTIONS(5898),
    [anon_sym_u00ac] = ACTIONS(5896),
    [sym_union] = ACTIONS(5898),
    [sym_powerset] = ACTIONS(5898),
    [sym_domain] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [sym_negative_dot] = ACTIONS(5896),
    [sym_enabled] = ACTIONS(5898),
    [sym_unchanged] = ACTIONS(5898),
    [anon_sym_LT_GT] = ACTIONS(5896),
    [anon_sym_u22c4] = ACTIONS(5896),
    [anon_sym_u25c7] = ACTIONS(5896),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5898),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [anon_sym_ASSUME] = ACTIONS(5898),
    [anon_sym_ASSUMPTION] = ACTIONS(5898),
    [anon_sym_AXIOM] = ACTIONS(5898),
    [anon_sym_THEOREM] = ACTIONS(5898),
    [anon_sym_PROPOSITION] = ACTIONS(5898),
    [anon_sym_LEMMA] = ACTIONS(5898),
    [anon_sym_COROLLARY] = ACTIONS(5898),
    [anon_sym_USE] = ACTIONS(5898),
    [anon_sym_HIDE] = ACTIONS(5898),
    [anon_sym_DEF] = ACTIONS(5898),
    [anon_sym_DEFS] = ACTIONS(5898),
    [sym__double_excl] = ACTIONS(5896),
  },
  [2489] = {
    [sym_block_comment] = STATE(2489),
    [sym_identifier] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5900),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_COMMA] = ACTIONS(5900),
    [anon_sym_LOCAL] = ACTIONS(5902),
    [anon_sym_VARIABLE] = ACTIONS(5902),
    [anon_sym_VARIABLES] = ACTIONS(5902),
    [anon_sym_CONSTANT] = ACTIONS(5902),
    [anon_sym_CONSTANTS] = ACTIONS(5902),
    [anon_sym_RECURSIVE] = ACTIONS(5902),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_INSTANCE] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_Nat] = ACTIONS(5902),
    [anon_sym_u2115] = ACTIONS(5900),
    [anon_sym_Int] = ACTIONS(5902),
    [anon_sym_u2124] = ACTIONS(5900),
    [anon_sym_Real] = ACTIONS(5902),
    [anon_sym_u211d] = ACTIONS(5900),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_BSLASHlnot] = ACTIONS(5900),
    [anon_sym_BSLASHneg] = ACTIONS(5900),
    [anon_sym_TILDE] = ACTIONS(5902),
    [anon_sym_u00ac] = ACTIONS(5900),
    [sym_union] = ACTIONS(5902),
    [sym_powerset] = ACTIONS(5902),
    [sym_domain] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [sym_negative_dot] = ACTIONS(5900),
    [sym_enabled] = ACTIONS(5902),
    [sym_unchanged] = ACTIONS(5902),
    [anon_sym_LT_GT] = ACTIONS(5900),
    [anon_sym_u22c4] = ACTIONS(5900),
    [anon_sym_u25c7] = ACTIONS(5900),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5902),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [anon_sym_ASSUME] = ACTIONS(5902),
    [anon_sym_ASSUMPTION] = ACTIONS(5902),
    [anon_sym_AXIOM] = ACTIONS(5902),
    [anon_sym_THEOREM] = ACTIONS(5902),
    [anon_sym_PROPOSITION] = ACTIONS(5902),
    [anon_sym_LEMMA] = ACTIONS(5902),
    [anon_sym_COROLLARY] = ACTIONS(5902),
    [anon_sym_USE] = ACTIONS(5902),
    [anon_sym_HIDE] = ACTIONS(5902),
    [anon_sym_DEF] = ACTIONS(5902),
    [anon_sym_DEFS] = ACTIONS(5902),
    [sym__double_excl] = ACTIONS(5900),
  },
  [2490] = {
    [sym_block_comment] = STATE(2490),
    [sym_identifier] = ACTIONS(5906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5904),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_LOCAL] = ACTIONS(5906),
    [anon_sym_VARIABLE] = ACTIONS(5906),
    [anon_sym_VARIABLES] = ACTIONS(5906),
    [anon_sym_CONSTANT] = ACTIONS(5906),
    [anon_sym_CONSTANTS] = ACTIONS(5906),
    [anon_sym_RECURSIVE] = ACTIONS(5906),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_INSTANCE] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_Nat] = ACTIONS(5906),
    [anon_sym_u2115] = ACTIONS(5904),
    [anon_sym_Int] = ACTIONS(5906),
    [anon_sym_u2124] = ACTIONS(5904),
    [anon_sym_Real] = ACTIONS(5906),
    [anon_sym_u211d] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_BSLASHlnot] = ACTIONS(5904),
    [anon_sym_BSLASHneg] = ACTIONS(5904),
    [anon_sym_TILDE] = ACTIONS(5906),
    [anon_sym_u00ac] = ACTIONS(5904),
    [sym_union] = ACTIONS(5906),
    [sym_powerset] = ACTIONS(5906),
    [sym_domain] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [sym_negative_dot] = ACTIONS(5904),
    [sym_enabled] = ACTIONS(5906),
    [sym_unchanged] = ACTIONS(5906),
    [anon_sym_LT_GT] = ACTIONS(5904),
    [anon_sym_u22c4] = ACTIONS(5904),
    [anon_sym_u25c7] = ACTIONS(5904),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5906),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [anon_sym_ASSUME] = ACTIONS(5906),
    [anon_sym_ASSUMPTION] = ACTIONS(5906),
    [anon_sym_AXIOM] = ACTIONS(5906),
    [anon_sym_THEOREM] = ACTIONS(5906),
    [anon_sym_PROPOSITION] = ACTIONS(5906),
    [anon_sym_LEMMA] = ACTIONS(5906),
    [anon_sym_COROLLARY] = ACTIONS(5906),
    [anon_sym_USE] = ACTIONS(5906),
    [anon_sym_HIDE] = ACTIONS(5906),
    [anon_sym_DEF] = ACTIONS(5906),
    [anon_sym_DEFS] = ACTIONS(5906),
    [sym__double_excl] = ACTIONS(5904),
  },
  [2491] = {
    [sym_block_comment] = STATE(2491),
    [ts_builtin_sym_end] = ACTIONS(5772),
    [sym_identifier] = ACTIONS(5774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5772),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_LOCAL] = ACTIONS(5774),
    [anon_sym_VARIABLE] = ACTIONS(5774),
    [anon_sym_VARIABLES] = ACTIONS(5774),
    [anon_sym_CONSTANT] = ACTIONS(5774),
    [anon_sym_CONSTANTS] = ACTIONS(5774),
    [anon_sym_RECURSIVE] = ACTIONS(5774),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_INSTANCE] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_Nat] = ACTIONS(5774),
    [anon_sym_u2115] = ACTIONS(5772),
    [anon_sym_Int] = ACTIONS(5774),
    [anon_sym_u2124] = ACTIONS(5772),
    [anon_sym_Real] = ACTIONS(5774),
    [anon_sym_u211d] = ACTIONS(5772),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_BSLASHlnot] = ACTIONS(5772),
    [anon_sym_BSLASHneg] = ACTIONS(5772),
    [anon_sym_TILDE] = ACTIONS(5774),
    [anon_sym_u00ac] = ACTIONS(5772),
    [sym_union] = ACTIONS(5774),
    [sym_powerset] = ACTIONS(5774),
    [sym_domain] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [sym_negative_dot] = ACTIONS(5772),
    [sym_enabled] = ACTIONS(5774),
    [sym_unchanged] = ACTIONS(5774),
    [anon_sym_LT_GT] = ACTIONS(5772),
    [anon_sym_u22c4] = ACTIONS(5772),
    [anon_sym_u25c7] = ACTIONS(5772),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5774),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [anon_sym_ASSUME] = ACTIONS(5774),
    [anon_sym_ASSUMPTION] = ACTIONS(5774),
    [anon_sym_AXIOM] = ACTIONS(5774),
    [anon_sym_THEOREM] = ACTIONS(5774),
    [anon_sym_PROPOSITION] = ACTIONS(5774),
    [anon_sym_LEMMA] = ACTIONS(5774),
    [anon_sym_COROLLARY] = ACTIONS(5774),
    [anon_sym_USE] = ACTIONS(5774),
    [anon_sym_HIDE] = ACTIONS(5774),
    [anon_sym_DEF] = ACTIONS(5774),
    [anon_sym_DEFS] = ACTIONS(5774),
    [sym__double_excl] = ACTIONS(5772),
  },
  [2492] = {
    [sym_block_comment] = STATE(2492),
    [ts_builtin_sym_end] = ACTIONS(5834),
    [sym_identifier] = ACTIONS(5836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5834),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_LOCAL] = ACTIONS(5836),
    [anon_sym_VARIABLE] = ACTIONS(5836),
    [anon_sym_VARIABLES] = ACTIONS(5836),
    [anon_sym_CONSTANT] = ACTIONS(5836),
    [anon_sym_CONSTANTS] = ACTIONS(5836),
    [anon_sym_RECURSIVE] = ACTIONS(5836),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_INSTANCE] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_Nat] = ACTIONS(5836),
    [anon_sym_u2115] = ACTIONS(5834),
    [anon_sym_Int] = ACTIONS(5836),
    [anon_sym_u2124] = ACTIONS(5834),
    [anon_sym_Real] = ACTIONS(5836),
    [anon_sym_u211d] = ACTIONS(5834),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_BSLASHlnot] = ACTIONS(5834),
    [anon_sym_BSLASHneg] = ACTIONS(5834),
    [anon_sym_TILDE] = ACTIONS(5836),
    [anon_sym_u00ac] = ACTIONS(5834),
    [sym_union] = ACTIONS(5836),
    [sym_powerset] = ACTIONS(5836),
    [sym_domain] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [sym_negative_dot] = ACTIONS(5834),
    [sym_enabled] = ACTIONS(5836),
    [sym_unchanged] = ACTIONS(5836),
    [anon_sym_LT_GT] = ACTIONS(5834),
    [anon_sym_u22c4] = ACTIONS(5834),
    [anon_sym_u25c7] = ACTIONS(5834),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5836),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [anon_sym_ASSUME] = ACTIONS(5836),
    [anon_sym_ASSUMPTION] = ACTIONS(5836),
    [anon_sym_AXIOM] = ACTIONS(5836),
    [anon_sym_THEOREM] = ACTIONS(5836),
    [anon_sym_PROPOSITION] = ACTIONS(5836),
    [anon_sym_LEMMA] = ACTIONS(5836),
    [anon_sym_COROLLARY] = ACTIONS(5836),
    [anon_sym_USE] = ACTIONS(5836),
    [anon_sym_HIDE] = ACTIONS(5836),
    [anon_sym_DEF] = ACTIONS(5836),
    [anon_sym_DEFS] = ACTIONS(5836),
    [sym__double_excl] = ACTIONS(5834),
  },
  [2493] = {
    [sym_block_comment] = STATE(2493),
    [ts_builtin_sym_end] = ACTIONS(5748),
    [sym_identifier] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5748),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_COMMA] = ACTIONS(5748),
    [anon_sym_LOCAL] = ACTIONS(5750),
    [anon_sym_VARIABLE] = ACTIONS(5750),
    [anon_sym_VARIABLES] = ACTIONS(5750),
    [anon_sym_CONSTANT] = ACTIONS(5750),
    [anon_sym_CONSTANTS] = ACTIONS(5750),
    [anon_sym_RECURSIVE] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_INSTANCE] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_Nat] = ACTIONS(5750),
    [anon_sym_u2115] = ACTIONS(5748),
    [anon_sym_Int] = ACTIONS(5750),
    [anon_sym_u2124] = ACTIONS(5748),
    [anon_sym_Real] = ACTIONS(5750),
    [anon_sym_u211d] = ACTIONS(5748),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_BSLASHlnot] = ACTIONS(5748),
    [anon_sym_BSLASHneg] = ACTIONS(5748),
    [anon_sym_TILDE] = ACTIONS(5750),
    [anon_sym_u00ac] = ACTIONS(5748),
    [sym_union] = ACTIONS(5750),
    [sym_powerset] = ACTIONS(5750),
    [sym_domain] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [sym_negative_dot] = ACTIONS(5748),
    [sym_enabled] = ACTIONS(5750),
    [sym_unchanged] = ACTIONS(5750),
    [anon_sym_LT_GT] = ACTIONS(5748),
    [anon_sym_u22c4] = ACTIONS(5748),
    [anon_sym_u25c7] = ACTIONS(5748),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5750),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [anon_sym_ASSUME] = ACTIONS(5750),
    [anon_sym_ASSUMPTION] = ACTIONS(5750),
    [anon_sym_AXIOM] = ACTIONS(5750),
    [anon_sym_THEOREM] = ACTIONS(5750),
    [anon_sym_PROPOSITION] = ACTIONS(5750),
    [anon_sym_LEMMA] = ACTIONS(5750),
    [anon_sym_COROLLARY] = ACTIONS(5750),
    [anon_sym_USE] = ACTIONS(5750),
    [anon_sym_HIDE] = ACTIONS(5750),
    [anon_sym_DEF] = ACTIONS(5750),
    [anon_sym_DEFS] = ACTIONS(5750),
    [sym__double_excl] = ACTIONS(5748),
  },
  [2494] = {
    [sym_block_comment] = STATE(2494),
    [ts_builtin_sym_end] = ACTIONS(5838),
    [sym_identifier] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5838),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_LOCAL] = ACTIONS(5840),
    [anon_sym_VARIABLE] = ACTIONS(5840),
    [anon_sym_VARIABLES] = ACTIONS(5840),
    [anon_sym_CONSTANT] = ACTIONS(5840),
    [anon_sym_CONSTANTS] = ACTIONS(5840),
    [anon_sym_RECURSIVE] = ACTIONS(5840),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_INSTANCE] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_Nat] = ACTIONS(5840),
    [anon_sym_u2115] = ACTIONS(5838),
    [anon_sym_Int] = ACTIONS(5840),
    [anon_sym_u2124] = ACTIONS(5838),
    [anon_sym_Real] = ACTIONS(5840),
    [anon_sym_u211d] = ACTIONS(5838),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_BSLASHlnot] = ACTIONS(5838),
    [anon_sym_BSLASHneg] = ACTIONS(5838),
    [anon_sym_TILDE] = ACTIONS(5840),
    [anon_sym_u00ac] = ACTIONS(5838),
    [sym_union] = ACTIONS(5840),
    [sym_powerset] = ACTIONS(5840),
    [sym_domain] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [sym_negative_dot] = ACTIONS(5838),
    [sym_enabled] = ACTIONS(5840),
    [sym_unchanged] = ACTIONS(5840),
    [anon_sym_LT_GT] = ACTIONS(5838),
    [anon_sym_u22c4] = ACTIONS(5838),
    [anon_sym_u25c7] = ACTIONS(5838),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5840),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [anon_sym_ASSUME] = ACTIONS(5840),
    [anon_sym_ASSUMPTION] = ACTIONS(5840),
    [anon_sym_AXIOM] = ACTIONS(5840),
    [anon_sym_THEOREM] = ACTIONS(5840),
    [anon_sym_PROPOSITION] = ACTIONS(5840),
    [anon_sym_LEMMA] = ACTIONS(5840),
    [anon_sym_COROLLARY] = ACTIONS(5840),
    [anon_sym_USE] = ACTIONS(5840),
    [anon_sym_HIDE] = ACTIONS(5840),
    [anon_sym_DEF] = ACTIONS(5840),
    [anon_sym_DEFS] = ACTIONS(5840),
    [sym__double_excl] = ACTIONS(5838),
  },
  [2495] = {
    [sym_block_comment] = STATE(2495),
    [ts_builtin_sym_end] = ACTIONS(5663),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5663),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LOCAL] = ACTIONS(5665),
    [anon_sym_VARIABLE] = ACTIONS(5665),
    [anon_sym_VARIABLES] = ACTIONS(5665),
    [anon_sym_CONSTANT] = ACTIONS(5665),
    [anon_sym_CONSTANTS] = ACTIONS(5665),
    [anon_sym_RECURSIVE] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_INSTANCE] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5665),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_ASSUME] = ACTIONS(5665),
    [anon_sym_ASSUMPTION] = ACTIONS(5665),
    [anon_sym_AXIOM] = ACTIONS(5665),
    [anon_sym_THEOREM] = ACTIONS(5665),
    [anon_sym_PROPOSITION] = ACTIONS(5665),
    [anon_sym_LEMMA] = ACTIONS(5665),
    [anon_sym_COROLLARY] = ACTIONS(5665),
    [anon_sym_USE] = ACTIONS(5665),
    [anon_sym_HIDE] = ACTIONS(5665),
    [anon_sym_DEF] = ACTIONS(5665),
    [anon_sym_DEFS] = ACTIONS(5665),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2496] = {
    [sym_block_comment] = STATE(2496),
    [ts_builtin_sym_end] = ACTIONS(5942),
    [sym_identifier] = ACTIONS(5940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5942),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_LOCAL] = ACTIONS(5940),
    [anon_sym_VARIABLE] = ACTIONS(5940),
    [anon_sym_VARIABLES] = ACTIONS(5940),
    [anon_sym_CONSTANT] = ACTIONS(5940),
    [anon_sym_CONSTANTS] = ACTIONS(5940),
    [anon_sym_RECURSIVE] = ACTIONS(5940),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_INSTANCE] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_Nat] = ACTIONS(5940),
    [anon_sym_u2115] = ACTIONS(5942),
    [anon_sym_Int] = ACTIONS(5940),
    [anon_sym_u2124] = ACTIONS(5942),
    [anon_sym_Real] = ACTIONS(5940),
    [anon_sym_u211d] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_BSLASHlnot] = ACTIONS(5942),
    [anon_sym_BSLASHneg] = ACTIONS(5942),
    [anon_sym_TILDE] = ACTIONS(5940),
    [anon_sym_u00ac] = ACTIONS(5942),
    [sym_union] = ACTIONS(5940),
    [sym_powerset] = ACTIONS(5940),
    [sym_domain] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [sym_negative_dot] = ACTIONS(5942),
    [sym_enabled] = ACTIONS(5940),
    [sym_unchanged] = ACTIONS(5940),
    [anon_sym_LT_GT] = ACTIONS(5942),
    [anon_sym_u22c4] = ACTIONS(5942),
    [anon_sym_u25c7] = ACTIONS(5942),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5940),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [anon_sym_ASSUME] = ACTIONS(5940),
    [anon_sym_ASSUMPTION] = ACTIONS(5940),
    [anon_sym_AXIOM] = ACTIONS(5940),
    [anon_sym_THEOREM] = ACTIONS(5940),
    [anon_sym_PROPOSITION] = ACTIONS(5940),
    [anon_sym_LEMMA] = ACTIONS(5940),
    [anon_sym_COROLLARY] = ACTIONS(5940),
    [anon_sym_USE] = ACTIONS(5940),
    [anon_sym_HIDE] = ACTIONS(5940),
    [anon_sym_DEF] = ACTIONS(5940),
    [anon_sym_DEFS] = ACTIONS(5940),
    [sym__double_excl] = ACTIONS(5942),
  },
  [2497] = {
    [sym_block_comment] = STATE(2497),
    [ts_builtin_sym_end] = ACTIONS(5930),
    [sym_identifier] = ACTIONS(5928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5930),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_LOCAL] = ACTIONS(5928),
    [anon_sym_VARIABLE] = ACTIONS(5928),
    [anon_sym_VARIABLES] = ACTIONS(5928),
    [anon_sym_CONSTANT] = ACTIONS(5928),
    [anon_sym_CONSTANTS] = ACTIONS(5928),
    [anon_sym_RECURSIVE] = ACTIONS(5928),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_INSTANCE] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_Nat] = ACTIONS(5928),
    [anon_sym_u2115] = ACTIONS(5930),
    [anon_sym_Int] = ACTIONS(5928),
    [anon_sym_u2124] = ACTIONS(5930),
    [anon_sym_Real] = ACTIONS(5928),
    [anon_sym_u211d] = ACTIONS(5930),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_BSLASHlnot] = ACTIONS(5930),
    [anon_sym_BSLASHneg] = ACTIONS(5930),
    [anon_sym_TILDE] = ACTIONS(5928),
    [anon_sym_u00ac] = ACTIONS(5930),
    [sym_union] = ACTIONS(5928),
    [sym_powerset] = ACTIONS(5928),
    [sym_domain] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [sym_negative_dot] = ACTIONS(5930),
    [sym_enabled] = ACTIONS(5928),
    [sym_unchanged] = ACTIONS(5928),
    [anon_sym_LT_GT] = ACTIONS(5930),
    [anon_sym_u22c4] = ACTIONS(5930),
    [anon_sym_u25c7] = ACTIONS(5930),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5928),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [anon_sym_ASSUME] = ACTIONS(5928),
    [anon_sym_ASSUMPTION] = ACTIONS(5928),
    [anon_sym_AXIOM] = ACTIONS(5928),
    [anon_sym_THEOREM] = ACTIONS(5928),
    [anon_sym_PROPOSITION] = ACTIONS(5928),
    [anon_sym_LEMMA] = ACTIONS(5928),
    [anon_sym_COROLLARY] = ACTIONS(5928),
    [anon_sym_USE] = ACTIONS(5928),
    [anon_sym_HIDE] = ACTIONS(5928),
    [anon_sym_DEF] = ACTIONS(5928),
    [anon_sym_DEFS] = ACTIONS(5928),
    [sym__double_excl] = ACTIONS(5930),
  },
  [2498] = {
    [sym_block_comment] = STATE(2498),
    [ts_builtin_sym_end] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(5932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5934),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_LOCAL] = ACTIONS(5932),
    [anon_sym_VARIABLE] = ACTIONS(5932),
    [anon_sym_VARIABLES] = ACTIONS(5932),
    [anon_sym_CONSTANT] = ACTIONS(5932),
    [anon_sym_CONSTANTS] = ACTIONS(5932),
    [anon_sym_RECURSIVE] = ACTIONS(5932),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_INSTANCE] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_Nat] = ACTIONS(5932),
    [anon_sym_u2115] = ACTIONS(5934),
    [anon_sym_Int] = ACTIONS(5932),
    [anon_sym_u2124] = ACTIONS(5934),
    [anon_sym_Real] = ACTIONS(5932),
    [anon_sym_u211d] = ACTIONS(5934),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_BSLASHlnot] = ACTIONS(5934),
    [anon_sym_BSLASHneg] = ACTIONS(5934),
    [anon_sym_TILDE] = ACTIONS(5932),
    [anon_sym_u00ac] = ACTIONS(5934),
    [sym_union] = ACTIONS(5932),
    [sym_powerset] = ACTIONS(5932),
    [sym_domain] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [sym_negative_dot] = ACTIONS(5934),
    [sym_enabled] = ACTIONS(5932),
    [sym_unchanged] = ACTIONS(5932),
    [anon_sym_LT_GT] = ACTIONS(5934),
    [anon_sym_u22c4] = ACTIONS(5934),
    [anon_sym_u25c7] = ACTIONS(5934),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5932),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [anon_sym_ASSUME] = ACTIONS(5932),
    [anon_sym_ASSUMPTION] = ACTIONS(5932),
    [anon_sym_AXIOM] = ACTIONS(5932),
    [anon_sym_THEOREM] = ACTIONS(5932),
    [anon_sym_PROPOSITION] = ACTIONS(5932),
    [anon_sym_LEMMA] = ACTIONS(5932),
    [anon_sym_COROLLARY] = ACTIONS(5932),
    [anon_sym_USE] = ACTIONS(5932),
    [anon_sym_HIDE] = ACTIONS(5932),
    [anon_sym_DEF] = ACTIONS(5932),
    [anon_sym_DEFS] = ACTIONS(5932),
    [sym__double_excl] = ACTIONS(5934),
  },
  [2499] = {
    [sym_block_comment] = STATE(2499),
    [ts_builtin_sym_end] = ACTIONS(5351),
    [sym_identifier] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5351),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_LOCAL] = ACTIONS(5349),
    [anon_sym_VARIABLE] = ACTIONS(5349),
    [anon_sym_VARIABLES] = ACTIONS(5349),
    [anon_sym_CONSTANT] = ACTIONS(5349),
    [anon_sym_CONSTANTS] = ACTIONS(5349),
    [anon_sym_RECURSIVE] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_INSTANCE] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_Nat] = ACTIONS(5349),
    [anon_sym_u2115] = ACTIONS(5351),
    [anon_sym_Int] = ACTIONS(5349),
    [anon_sym_u2124] = ACTIONS(5351),
    [anon_sym_Real] = ACTIONS(5349),
    [anon_sym_u211d] = ACTIONS(5351),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_BSLASHlnot] = ACTIONS(5351),
    [anon_sym_BSLASHneg] = ACTIONS(5351),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_u00ac] = ACTIONS(5351),
    [sym_union] = ACTIONS(5349),
    [sym_powerset] = ACTIONS(5349),
    [sym_domain] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [sym_negative_dot] = ACTIONS(5351),
    [sym_enabled] = ACTIONS(5349),
    [sym_unchanged] = ACTIONS(5349),
    [anon_sym_LT_GT] = ACTIONS(5351),
    [anon_sym_u22c4] = ACTIONS(5351),
    [anon_sym_u25c7] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5349),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [anon_sym_ASSUME] = ACTIONS(5349),
    [anon_sym_ASSUMPTION] = ACTIONS(5349),
    [anon_sym_AXIOM] = ACTIONS(5349),
    [anon_sym_THEOREM] = ACTIONS(5349),
    [anon_sym_PROPOSITION] = ACTIONS(5349),
    [anon_sym_LEMMA] = ACTIONS(5349),
    [anon_sym_COROLLARY] = ACTIONS(5349),
    [anon_sym_USE] = ACTIONS(5349),
    [anon_sym_HIDE] = ACTIONS(5349),
    [anon_sym_DEF] = ACTIONS(5349),
    [anon_sym_DEFS] = ACTIONS(5349),
    [sym__double_excl] = ACTIONS(5351),
  },
  [2500] = {
    [sym_block_comment] = STATE(2500),
    [ts_builtin_sym_end] = ACTIONS(5892),
    [sym_identifier] = ACTIONS(5894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5892),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_LOCAL] = ACTIONS(5894),
    [anon_sym_VARIABLE] = ACTIONS(5894),
    [anon_sym_VARIABLES] = ACTIONS(5894),
    [anon_sym_CONSTANT] = ACTIONS(5894),
    [anon_sym_CONSTANTS] = ACTIONS(5894),
    [anon_sym_RECURSIVE] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_INSTANCE] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_Nat] = ACTIONS(5894),
    [anon_sym_u2115] = ACTIONS(5892),
    [anon_sym_Int] = ACTIONS(5894),
    [anon_sym_u2124] = ACTIONS(5892),
    [anon_sym_Real] = ACTIONS(5894),
    [anon_sym_u211d] = ACTIONS(5892),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_BSLASHlnot] = ACTIONS(5892),
    [anon_sym_BSLASHneg] = ACTIONS(5892),
    [anon_sym_TILDE] = ACTIONS(5894),
    [anon_sym_u00ac] = ACTIONS(5892),
    [sym_union] = ACTIONS(5894),
    [sym_powerset] = ACTIONS(5894),
    [sym_domain] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [sym_negative_dot] = ACTIONS(5892),
    [sym_enabled] = ACTIONS(5894),
    [sym_unchanged] = ACTIONS(5894),
    [anon_sym_LT_GT] = ACTIONS(5892),
    [anon_sym_u22c4] = ACTIONS(5892),
    [anon_sym_u25c7] = ACTIONS(5892),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5894),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [anon_sym_ASSUME] = ACTIONS(5894),
    [anon_sym_ASSUMPTION] = ACTIONS(5894),
    [anon_sym_AXIOM] = ACTIONS(5894),
    [anon_sym_THEOREM] = ACTIONS(5894),
    [anon_sym_PROPOSITION] = ACTIONS(5894),
    [anon_sym_LEMMA] = ACTIONS(5894),
    [anon_sym_COROLLARY] = ACTIONS(5894),
    [anon_sym_USE] = ACTIONS(5894),
    [anon_sym_HIDE] = ACTIONS(5894),
    [anon_sym_DEF] = ACTIONS(5894),
    [anon_sym_DEFS] = ACTIONS(5894),
    [sym__double_excl] = ACTIONS(5892),
  },
  [2501] = {
    [sym_block_comment] = STATE(2501),
    [ts_builtin_sym_end] = ACTIONS(5896),
    [sym_identifier] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5896),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_COMMA] = ACTIONS(5896),
    [anon_sym_LOCAL] = ACTIONS(5898),
    [anon_sym_VARIABLE] = ACTIONS(5898),
    [anon_sym_VARIABLES] = ACTIONS(5898),
    [anon_sym_CONSTANT] = ACTIONS(5898),
    [anon_sym_CONSTANTS] = ACTIONS(5898),
    [anon_sym_RECURSIVE] = ACTIONS(5898),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_INSTANCE] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_Nat] = ACTIONS(5898),
    [anon_sym_u2115] = ACTIONS(5896),
    [anon_sym_Int] = ACTIONS(5898),
    [anon_sym_u2124] = ACTIONS(5896),
    [anon_sym_Real] = ACTIONS(5898),
    [anon_sym_u211d] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_BSLASHlnot] = ACTIONS(5896),
    [anon_sym_BSLASHneg] = ACTIONS(5896),
    [anon_sym_TILDE] = ACTIONS(5898),
    [anon_sym_u00ac] = ACTIONS(5896),
    [sym_union] = ACTIONS(5898),
    [sym_powerset] = ACTIONS(5898),
    [sym_domain] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [sym_negative_dot] = ACTIONS(5896),
    [sym_enabled] = ACTIONS(5898),
    [sym_unchanged] = ACTIONS(5898),
    [anon_sym_LT_GT] = ACTIONS(5896),
    [anon_sym_u22c4] = ACTIONS(5896),
    [anon_sym_u25c7] = ACTIONS(5896),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5898),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [anon_sym_ASSUME] = ACTIONS(5898),
    [anon_sym_ASSUMPTION] = ACTIONS(5898),
    [anon_sym_AXIOM] = ACTIONS(5898),
    [anon_sym_THEOREM] = ACTIONS(5898),
    [anon_sym_PROPOSITION] = ACTIONS(5898),
    [anon_sym_LEMMA] = ACTIONS(5898),
    [anon_sym_COROLLARY] = ACTIONS(5898),
    [anon_sym_USE] = ACTIONS(5898),
    [anon_sym_HIDE] = ACTIONS(5898),
    [anon_sym_DEF] = ACTIONS(5898),
    [anon_sym_DEFS] = ACTIONS(5898),
    [sym__double_excl] = ACTIONS(5896),
  },
  [2502] = {
    [sym_block_comment] = STATE(2502),
    [sym_identifier] = ACTIONS(5850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_LOCAL] = ACTIONS(5850),
    [anon_sym_VARIABLE] = ACTIONS(5850),
    [anon_sym_VARIABLES] = ACTIONS(5850),
    [anon_sym_CONSTANT] = ACTIONS(5850),
    [anon_sym_CONSTANTS] = ACTIONS(5850),
    [anon_sym_RECURSIVE] = ACTIONS(5850),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_INSTANCE] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_Nat] = ACTIONS(5850),
    [anon_sym_u2115] = ACTIONS(5852),
    [anon_sym_Int] = ACTIONS(5850),
    [anon_sym_u2124] = ACTIONS(5852),
    [anon_sym_Real] = ACTIONS(5850),
    [anon_sym_u211d] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_BSLASHlnot] = ACTIONS(5852),
    [anon_sym_BSLASHneg] = ACTIONS(5852),
    [anon_sym_TILDE] = ACTIONS(5850),
    [anon_sym_u00ac] = ACTIONS(5852),
    [sym_union] = ACTIONS(5850),
    [sym_powerset] = ACTIONS(5850),
    [sym_domain] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [sym_negative_dot] = ACTIONS(5852),
    [sym_enabled] = ACTIONS(5850),
    [sym_unchanged] = ACTIONS(5850),
    [anon_sym_LT_GT] = ACTIONS(5852),
    [anon_sym_u22c4] = ACTIONS(5852),
    [anon_sym_u25c7] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5850),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [anon_sym_ASSUME] = ACTIONS(5850),
    [anon_sym_ASSUMPTION] = ACTIONS(5850),
    [anon_sym_AXIOM] = ACTIONS(5850),
    [anon_sym_THEOREM] = ACTIONS(5850),
    [anon_sym_PROPOSITION] = ACTIONS(5850),
    [anon_sym_LEMMA] = ACTIONS(5850),
    [anon_sym_COROLLARY] = ACTIONS(5850),
    [anon_sym_USE] = ACTIONS(5850),
    [anon_sym_HIDE] = ACTIONS(5850),
    [anon_sym_DEF] = ACTIONS(5850),
    [anon_sym_DEFS] = ACTIONS(5850),
    [sym__double_excl] = ACTIONS(5852),
  },
  [2503] = {
    [sym_block_comment] = STATE(2503),
    [sym_label_as] = STATE(573),
    [sym_identifier] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(5944),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_INSTANCE] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_Nat] = ACTIONS(3845),
    [anon_sym_u2115] = ACTIONS(4078),
    [anon_sym_Int] = ACTIONS(3845),
    [anon_sym_u2124] = ACTIONS(4078),
    [anon_sym_Real] = ACTIONS(3845),
    [anon_sym_u211d] = ACTIONS(4078),
    [anon_sym_RBRACE] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_BSLASHlnot] = ACTIONS(4078),
    [anon_sym_BSLASHneg] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_u00ac] = ACTIONS(4078),
    [sym_union] = ACTIONS(3845),
    [sym_powerset] = ACTIONS(3845),
    [sym_domain] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [sym_negative_dot] = ACTIONS(4078),
    [sym_enabled] = ACTIONS(3845),
    [sym_unchanged] = ACTIONS(3845),
    [anon_sym_LT_GT] = ACTIONS(4078),
    [anon_sym_u22c4] = ACTIONS(4078),
    [anon_sym_u25c7] = ACTIONS(4078),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_end] = ACTIONS(3845),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2504] = {
    [sym_block_comment] = STATE(2504),
    [sym_label_as] = STATE(993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_RBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_RBRACE] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_THEN] = ACTIONS(4078),
    [anon_sym_ELSE] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_PROVE] = ACTIONS(4078),
    [anon_sym_end] = ACTIONS(4078),
    [anon_sym_SEMI] = ACTIONS(4078),
    [anon_sym_define] = ACTIONS(4078),
    [anon_sym_macro] = ACTIONS(4078),
    [anon_sym_procedure] = ACTIONS(4078),
    [anon_sym_fair] = ACTIONS(4078),
    [anon_sym_process] = ACTIONS(4078),
    [anon_sym_variable] = ACTIONS(3845),
    [anon_sym_variables] = ACTIONS(4078),
    [anon_sym_begin] = ACTIONS(4078),
    [anon_sym_then] = ACTIONS(4078),
    [anon_sym_elsif] = ACTIONS(4078),
    [anon_sym_else] = ACTIONS(4078),
    [anon_sym_do] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2505] = {
    [sym_block_comment] = STATE(2505),
    [sym_identifier] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(2892),
    [anon_sym_u2208] = ACTIONS(2894),
    [anon_sym_LT_LT] = ACTIONS(2894),
    [anon_sym_u3008] = ACTIONS(2894),
    [anon_sym_u27e8] = ACTIONS(2894),
    [anon_sym_GT_GT] = ACTIONS(2894),
    [anon_sym_u3009] = ACTIONS(2894),
    [anon_sym_u27e9] = ACTIONS(2894),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2894),
    [anon_sym_u25a1] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2892),
    [anon_sym_AT] = ACTIONS(2892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(2894),
    [anon_sym_u2227] = ACTIONS(2894),
    [anon_sym_BSLASH_SLASH] = ACTIONS(2894),
    [anon_sym_u2228] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2892),
    [aux_sym_child_id_token1] = ACTIONS(2892),
    [anon_sym_BSLASHo] = ACTIONS(2892),
    [anon_sym_Nat] = ACTIONS(2892),
    [anon_sym_u2115] = ACTIONS(2894),
    [anon_sym_Int] = ACTIONS(2892),
    [anon_sym_u2124] = ACTIONS(2894),
    [anon_sym_Real] = ACTIONS(2892),
    [anon_sym_u211d] = ACTIONS(2894),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_BSLASHlnot] = ACTIONS(2894),
    [anon_sym_BSLASHneg] = ACTIONS(2894),
    [anon_sym_TILDE] = ACTIONS(2892),
    [anon_sym_u00ac] = ACTIONS(2894),
    [sym_union] = ACTIONS(2892),
    [sym_powerset] = ACTIONS(2892),
    [sym_domain] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [sym_negative_dot] = ACTIONS(2894),
    [sym_enabled] = ACTIONS(2892),
    [sym_unchanged] = ACTIONS(2892),
    [anon_sym_LT_GT] = ACTIONS(2894),
    [anon_sym_u22c4] = ACTIONS(2894),
    [anon_sym_u25c7] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_u27f9] = ACTIONS(2894),
    [anon_sym_u21d2] = ACTIONS(2894),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(2894),
    [anon_sym_u21f8] = ACTIONS(2894),
    [anon_sym_u2945] = ACTIONS(2894),
    [anon_sym_BSLASHequiv] = ACTIONS(2894),
    [anon_sym_u2261] = ACTIONS(2894),
    [anon_sym_LT_EQ_GT] = ACTIONS(2894),
    [anon_sym_u27fa] = ACTIONS(2894),
    [anon_sym_u21d4] = ACTIONS(2894),
    [anon_sym_TILDE_GT] = ACTIONS(2894),
    [anon_sym_u21dd] = ACTIONS(2894),
    [anon_sym_u219d] = ACTIONS(2894),
    [anon_sym_BSLASHland] = ACTIONS(2894),
    [anon_sym_BSLASHlor] = ACTIONS(2894),
    [anon_sym_COLON_EQ] = ACTIONS(2894),
    [anon_sym_u2254] = ACTIONS(2894),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(2894),
    [anon_sym_u2a74] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_POUND] = ACTIONS(2892),
    [anon_sym_u2260] = ACTIONS(2894),
    [anon_sym_LT] = ACTIONS(2892),
    [sym_gt] = ACTIONS(2892),
    [anon_sym_LT_EQ] = ACTIONS(2892),
    [anon_sym_EQ_LT] = ACTIONS(2894),
    [anon_sym_BSLASHleq] = ACTIONS(2894),
    [anon_sym_u2264] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_BSLASHgeq] = ACTIONS(2894),
    [anon_sym_u2265] = ACTIONS(2894),
    [anon_sym_BSLASHapprox] = ACTIONS(2894),
    [anon_sym_u2248] = ACTIONS(2894),
    [anon_sym_PIPE_DASH] = ACTIONS(2894),
    [anon_sym_u22a2] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_u22a8] = ACTIONS(2894),
    [anon_sym_DASH_PIPE] = ACTIONS(2894),
    [anon_sym_u22a3] = ACTIONS(2894),
    [anon_sym_EQ_PIPE] = ACTIONS(2894),
    [anon_sym_u2ae4] = ACTIONS(2894),
    [anon_sym_BSLASHasymp] = ACTIONS(2894),
    [anon_sym_u224d] = ACTIONS(2894),
    [anon_sym_BSLASHcong] = ACTIONS(2894),
    [anon_sym_u2245] = ACTIONS(2894),
    [anon_sym_BSLASHdoteq] = ACTIONS(2894),
    [anon_sym_u2250] = ACTIONS(2894),
    [anon_sym_BSLASHgg] = ACTIONS(2894),
    [anon_sym_u226b] = ACTIONS(2894),
    [anon_sym_BSLASHll] = ACTIONS(2894),
    [anon_sym_u226a] = ACTIONS(2894),
    [anon_sym_BSLASHnotin] = ACTIONS(2894),
    [anon_sym_u2209] = ACTIONS(2894),
    [anon_sym_BSLASHprec] = ACTIONS(2892),
    [anon_sym_u227a] = ACTIONS(2894),
    [anon_sym_BSLASHsucc] = ACTIONS(2892),
    [anon_sym_u227b] = ACTIONS(2894),
    [anon_sym_BSLASHpreceq] = ACTIONS(2894),
    [anon_sym_u2aaf] = ACTIONS(2894),
    [anon_sym_BSLASHsucceq] = ACTIONS(2894),
    [anon_sym_u2ab0] = ACTIONS(2894),
    [anon_sym_BSLASHpropto] = ACTIONS(2894),
    [anon_sym_u221d] = ACTIONS(2894),
    [anon_sym_BSLASHsim] = ACTIONS(2892),
    [anon_sym_u223c] = ACTIONS(2894),
    [anon_sym_BSLASHsimeq] = ACTIONS(2894),
    [anon_sym_u2243] = ACTIONS(2894),
    [anon_sym_BSLASHsqsubset] = ACTIONS(2892),
    [anon_sym_u228f] = ACTIONS(2894),
    [anon_sym_BSLASHsqsupset] = ACTIONS(2892),
    [anon_sym_u2290] = ACTIONS(2894),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(2894),
    [anon_sym_u2291] = ACTIONS(2894),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(2894),
    [anon_sym_u2292] = ACTIONS(2894),
    [anon_sym_BSLASHsubset] = ACTIONS(2892),
    [anon_sym_u2282] = ACTIONS(2894),
    [anon_sym_BSLASHsupset] = ACTIONS(2892),
    [anon_sym_u2283] = ACTIONS(2894),
    [anon_sym_BSLASHsubseteq] = ACTIONS(2894),
    [anon_sym_u2286] = ACTIONS(2894),
    [anon_sym_BSLASHsupseteq] = ACTIONS(2894),
    [anon_sym_u2287] = ACTIONS(2894),
    [sym_compose] = ACTIONS(2894),
    [sym_map_to] = ACTIONS(2894),
    [sym_map_from] = ACTIONS(2894),
    [sym_setminus] = ACTIONS(2892),
    [anon_sym_BSLASHcap] = ACTIONS(2894),
    [anon_sym_BSLASHintersect] = ACTIONS(2894),
    [anon_sym_u2229] = ACTIONS(2894),
    [anon_sym_BSLASHcup] = ACTIONS(2894),
    [anon_sym_BSLASHunion] = ACTIONS(2894),
    [anon_sym_u222a] = ACTIONS(2894),
    [anon_sym_DOT_DOT] = ACTIONS(2892),
    [anon_sym_u2025] = ACTIONS(2894),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2894),
    [anon_sym_u2026] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [sym_plusplus] = ACTIONS(2894),
    [anon_sym_BSLASHoplus] = ACTIONS(2894),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(2894),
    [anon_sym_u2295] = ACTIONS(2894),
    [anon_sym_BSLASHominus] = ACTIONS(2894),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(2894),
    [anon_sym_u2296] = ACTIONS(2894),
    [sym_mod] = ACTIONS(2892),
    [sym_modmod] = ACTIONS(2894),
    [sym_vert] = ACTIONS(2892),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_u2016] = ACTIONS(2894),
    [sym_minusminus] = ACTIONS(2894),
    [sym_amp] = ACTIONS(2892),
    [sym_ampamp] = ACTIONS(2894),
    [anon_sym_BSLASHodot] = ACTIONS(2894),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(2894),
    [anon_sym_u2299] = ACTIONS(2894),
    [anon_sym_BSLASHoslash] = ACTIONS(2894),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(2894),
    [anon_sym_u2298] = ACTIONS(2894),
    [anon_sym_BSLASHotimes] = ACTIONS(2894),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(2894),
    [anon_sym_u2297] = ACTIONS(2894),
    [sym_mul] = ACTIONS(2892),
    [sym_mulmul] = ACTIONS(2894),
    [sym_slash] = ACTIONS(2892),
    [sym_slashslash] = ACTIONS(2894),
    [anon_sym_BSLASHbigcirc] = ACTIONS(2894),
    [anon_sym_u25ef] = ACTIONS(2894),
    [anon_sym_BSLASHbullet] = ACTIONS(2894),
    [anon_sym_u25cf] = ACTIONS(2894),
    [anon_sym_BSLASHdiv] = ACTIONS(2894),
    [anon_sym_u00f7] = ACTIONS(2894),
    [anon_sym_BSLASHcirc] = ACTIONS(2894),
    [anon_sym_u2218] = ACTIONS(2894),
    [anon_sym_BSLASHstar] = ACTIONS(2894),
    [anon_sym_u22c6] = ACTIONS(2894),
    [anon_sym_u203c] = ACTIONS(2894),
    [sym_hashhash] = ACTIONS(2894),
    [sym_dol] = ACTIONS(2892),
    [sym_doldol] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2894),
    [anon_sym_u2047] = ACTIONS(2894),
    [anon_sym_BSLASHsqcap] = ACTIONS(2894),
    [anon_sym_u2293] = ACTIONS(2894),
    [anon_sym_BSLASHsqcup] = ACTIONS(2894),
    [anon_sym_u2294] = ACTIONS(2894),
    [anon_sym_BSLASHuplus] = ACTIONS(2894),
    [anon_sym_u228e] = ACTIONS(2894),
    [anon_sym_BSLASHX] = ACTIONS(2894),
    [anon_sym_BSLASHtimes] = ACTIONS(2894),
    [anon_sym_u00d7] = ACTIONS(2894),
    [anon_sym_BSLASHwr] = ACTIONS(2894),
    [anon_sym_u2240] = ACTIONS(2894),
    [anon_sym_BSLASHcdot] = ACTIONS(2894),
    [anon_sym_u22c5] = ACTIONS(2894),
    [sym_pow] = ACTIONS(2892),
    [sym_powpow] = ACTIONS(2894),
    [anon_sym_CARET_PLUS] = ACTIONS(2894),
    [anon_sym_u207a] = ACTIONS(2894),
    [sym_asterisk] = ACTIONS(2894),
    [sym_sup_hash] = ACTIONS(2894),
    [sym_prime] = ACTIONS(2894),
    [sym__double_excl] = ACTIONS(2894),
  },
  [2506] = {
    [sym_block_comment] = STATE(2506),
    [sym_label_as] = STATE(437),
    [sym_identifier] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_RECURSIVE] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(5948),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_Nat] = ACTIONS(3845),
    [anon_sym_u2115] = ACTIONS(4078),
    [anon_sym_Int] = ACTIONS(3845),
    [anon_sym_u2124] = ACTIONS(4078),
    [anon_sym_Real] = ACTIONS(3845),
    [anon_sym_u211d] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_IN] = ACTIONS(3845),
    [anon_sym_BSLASHlnot] = ACTIONS(4078),
    [anon_sym_BSLASHneg] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_u00ac] = ACTIONS(4078),
    [sym_union] = ACTIONS(3845),
    [sym_powerset] = ACTIONS(3845),
    [sym_domain] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [sym_negative_dot] = ACTIONS(4078),
    [sym_enabled] = ACTIONS(3845),
    [sym_unchanged] = ACTIONS(3845),
    [anon_sym_LT_GT] = ACTIONS(4078),
    [anon_sym_u22c4] = ACTIONS(4078),
    [anon_sym_u25c7] = ACTIONS(4078),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2507] = {
    [sym_block_comment] = STATE(2507),
    [sym_label_as] = STATE(657),
    [sym_identifier] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(5950),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_Nat] = ACTIONS(3845),
    [anon_sym_u2115] = ACTIONS(4078),
    [anon_sym_Int] = ACTIONS(3845),
    [anon_sym_u2124] = ACTIONS(4078),
    [anon_sym_Real] = ACTIONS(3845),
    [anon_sym_u211d] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_BSLASHlnot] = ACTIONS(4078),
    [anon_sym_BSLASHneg] = ACTIONS(4078),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_u00ac] = ACTIONS(4078),
    [sym_union] = ACTIONS(3845),
    [sym_powerset] = ACTIONS(3845),
    [sym_domain] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [sym_negative_dot] = ACTIONS(4078),
    [sym_enabled] = ACTIONS(3845),
    [sym_unchanged] = ACTIONS(3845),
    [anon_sym_LT_GT] = ACTIONS(4078),
    [anon_sym_u22c4] = ACTIONS(4078),
    [anon_sym_u25c7] = ACTIONS(4078),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__begin_proof_step] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2508] = {
    [sym_block_comment] = STATE(2508),
    [sym_case_box] = STATE(138),
    [aux_sym_case_repeat1] = STATE(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_COLON] = ACTIONS(5686),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_COMMA] = ACTIONS(5684),
    [anon_sym_RPAREN] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_RBRACK] = ACTIONS(5684),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_LBRACE] = ACTIONS(5684),
    [anon_sym_RBRACE] = ACTIONS(5684),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_THEN] = ACTIONS(5684),
    [anon_sym_ELSE] = ACTIONS(5684),
    [anon_sym_DASH] = ACTIONS(5686),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5684),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [anon_sym_PROVE] = ACTIONS(5684),
    [anon_sym_end] = ACTIONS(5684),
    [anon_sym_SEMI] = ACTIONS(5684),
    [anon_sym_define] = ACTIONS(5684),
    [anon_sym_macro] = ACTIONS(5684),
    [anon_sym_procedure] = ACTIONS(5684),
    [anon_sym_fair] = ACTIONS(5684),
    [anon_sym_process] = ACTIONS(5684),
    [anon_sym_variable] = ACTIONS(5686),
    [anon_sym_variables] = ACTIONS(5684),
    [anon_sym_begin] = ACTIONS(5684),
    [anon_sym_then] = ACTIONS(5684),
    [anon_sym_elsif] = ACTIONS(5684),
    [anon_sym_else] = ACTIONS(5684),
    [anon_sym_do] = ACTIONS(5684),
    [anon_sym_or] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2509] = {
    [sym_block_comment] = STATE(2509),
    [sym_case_box] = STATE(241),
    [aux_sym_case_repeat1] = STATE(2509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_COLON] = ACTIONS(5665),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_RPAREN] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_RBRACK] = ACTIONS(5663),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_LBRACE] = ACTIONS(5663),
    [anon_sym_RBRACE] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_THEN] = ACTIONS(5663),
    [anon_sym_ELSE] = ACTIONS(5663),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_PROVE] = ACTIONS(5663),
    [anon_sym_end] = ACTIONS(5663),
    [anon_sym_SEMI] = ACTIONS(5663),
    [anon_sym_define] = ACTIONS(5663),
    [anon_sym_macro] = ACTIONS(5663),
    [anon_sym_procedure] = ACTIONS(5663),
    [anon_sym_fair] = ACTIONS(5663),
    [anon_sym_process] = ACTIONS(5663),
    [anon_sym_variable] = ACTIONS(5665),
    [anon_sym_variables] = ACTIONS(5663),
    [anon_sym_begin] = ACTIONS(5663),
    [anon_sym_then] = ACTIONS(5663),
    [anon_sym_elsif] = ACTIONS(5663),
    [anon_sym_else] = ACTIONS(5663),
    [anon_sym_do] = ACTIONS(5663),
    [anon_sym_or] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2510] = {
    [sym_block_comment] = STATE(2510),
    [sym_identifier] = ACTIONS(5678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(5952),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_INSTANCE] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_Nat] = ACTIONS(5678),
    [anon_sym_u2115] = ACTIONS(5676),
    [anon_sym_Int] = ACTIONS(5678),
    [anon_sym_u2124] = ACTIONS(5676),
    [anon_sym_Real] = ACTIONS(5678),
    [anon_sym_u211d] = ACTIONS(5676),
    [anon_sym_RBRACE] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_BSLASHlnot] = ACTIONS(5676),
    [anon_sym_BSLASHneg] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5678),
    [anon_sym_u00ac] = ACTIONS(5676),
    [sym_union] = ACTIONS(5678),
    [sym_powerset] = ACTIONS(5678),
    [sym_domain] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [sym_negative_dot] = ACTIONS(5676),
    [sym_enabled] = ACTIONS(5678),
    [sym_unchanged] = ACTIONS(5678),
    [anon_sym_LT_GT] = ACTIONS(5676),
    [anon_sym_u22c4] = ACTIONS(5676),
    [anon_sym_u25c7] = ACTIONS(5676),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5676),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [anon_sym_end] = ACTIONS(5678),
    [sym__double_excl] = ACTIONS(5676),
  },
  [2511] = {
    [sym_block_comment] = STATE(2511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_COLON] = ACTIONS(5678),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(5954),
    [anon_sym_RPAREN] = ACTIONS(5676),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_RBRACK] = ACTIONS(5676),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_LBRACE] = ACTIONS(5676),
    [anon_sym_RBRACE] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_THEN] = ACTIONS(5676),
    [anon_sym_ELSE] = ACTIONS(5676),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5676),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [anon_sym_PROVE] = ACTIONS(5676),
    [anon_sym_end] = ACTIONS(5676),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_define] = ACTIONS(5676),
    [anon_sym_macro] = ACTIONS(5676),
    [anon_sym_procedure] = ACTIONS(5676),
    [anon_sym_fair] = ACTIONS(5676),
    [anon_sym_process] = ACTIONS(5676),
    [anon_sym_variable] = ACTIONS(5678),
    [anon_sym_variables] = ACTIONS(5676),
    [anon_sym_begin] = ACTIONS(5676),
    [anon_sym_then] = ACTIONS(5676),
    [anon_sym_elsif] = ACTIONS(5676),
    [anon_sym_else] = ACTIONS(5676),
    [anon_sym_do] = ACTIONS(5676),
    [anon_sym_or] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [2512] = {
    [sym_block_comment] = STATE(2512),
    [sym_case_box] = STATE(169),
    [aux_sym_case_repeat1] = STATE(2513),
    [sym_identifier] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_INSTANCE] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_Nat] = ACTIONS(5670),
    [anon_sym_u2115] = ACTIONS(5672),
    [anon_sym_Int] = ACTIONS(5670),
    [anon_sym_u2124] = ACTIONS(5672),
    [anon_sym_Real] = ACTIONS(5670),
    [anon_sym_u211d] = ACTIONS(5672),
    [anon_sym_RBRACE] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_BSLASHlnot] = ACTIONS(5672),
    [anon_sym_BSLASHneg] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5670),
    [anon_sym_u00ac] = ACTIONS(5672),
    [sym_union] = ACTIONS(5670),
    [sym_powerset] = ACTIONS(5670),
    [sym_domain] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [sym_negative_dot] = ACTIONS(5672),
    [sym_enabled] = ACTIONS(5670),
    [sym_unchanged] = ACTIONS(5670),
    [anon_sym_LT_GT] = ACTIONS(5672),
    [anon_sym_u22c4] = ACTIONS(5672),
    [anon_sym_u25c7] = ACTIONS(5672),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5672),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [anon_sym_end] = ACTIONS(5670),
    [sym__double_excl] = ACTIONS(5672),
  },
  [2513] = {
    [sym_block_comment] = STATE(2513),
    [sym_case_box] = STATE(308),
    [aux_sym_case_repeat1] = STATE(2513),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_INSTANCE] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_RBRACE] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_end] = ACTIONS(5665),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2514] = {
    [sym_block_comment] = STATE(2514),
    [sym_case_box] = STATE(168),
    [aux_sym_case_repeat1] = STATE(2512),
    [sym_identifier] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_COMMA] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_INSTANCE] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_Nat] = ACTIONS(5686),
    [anon_sym_u2115] = ACTIONS(5684),
    [anon_sym_Int] = ACTIONS(5686),
    [anon_sym_u2124] = ACTIONS(5684),
    [anon_sym_Real] = ACTIONS(5686),
    [anon_sym_u211d] = ACTIONS(5684),
    [anon_sym_RBRACE] = ACTIONS(5684),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_BSLASHlnot] = ACTIONS(5684),
    [anon_sym_BSLASHneg] = ACTIONS(5684),
    [anon_sym_TILDE] = ACTIONS(5686),
    [anon_sym_u00ac] = ACTIONS(5684),
    [sym_union] = ACTIONS(5686),
    [sym_powerset] = ACTIONS(5686),
    [sym_domain] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [sym_negative_dot] = ACTIONS(5684),
    [sym_enabled] = ACTIONS(5686),
    [sym_unchanged] = ACTIONS(5686),
    [anon_sym_LT_GT] = ACTIONS(5684),
    [anon_sym_u22c4] = ACTIONS(5684),
    [anon_sym_u25c7] = ACTIONS(5684),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5684),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [anon_sym_end] = ACTIONS(5686),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2515] = {
    [sym_block_comment] = STATE(2515),
    [sym_case_box] = STATE(139),
    [aux_sym_case_repeat1] = STATE(2509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_COLON] = ACTIONS(5670),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_RPAREN] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_RBRACK] = ACTIONS(5672),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_LBRACE] = ACTIONS(5672),
    [anon_sym_RBRACE] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_THEN] = ACTIONS(5672),
    [anon_sym_ELSE] = ACTIONS(5672),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5672),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [anon_sym_PROVE] = ACTIONS(5672),
    [anon_sym_end] = ACTIONS(5672),
    [anon_sym_SEMI] = ACTIONS(5672),
    [anon_sym_define] = ACTIONS(5672),
    [anon_sym_macro] = ACTIONS(5672),
    [anon_sym_procedure] = ACTIONS(5672),
    [anon_sym_fair] = ACTIONS(5672),
    [anon_sym_process] = ACTIONS(5672),
    [anon_sym_variable] = ACTIONS(5670),
    [anon_sym_variables] = ACTIONS(5672),
    [anon_sym_begin] = ACTIONS(5672),
    [anon_sym_then] = ACTIONS(5672),
    [anon_sym_elsif] = ACTIONS(5672),
    [anon_sym_else] = ACTIONS(5672),
    [anon_sym_do] = ACTIONS(5672),
    [anon_sym_or] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [2516] = {
    [sym_block_comment] = STATE(2516),
    [sym_identifier] = ACTIONS(5678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_RECURSIVE] = ACTIONS(5678),
    [anon_sym_LPAREN] = ACTIONS(5956),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_Nat] = ACTIONS(5678),
    [anon_sym_u2115] = ACTIONS(5676),
    [anon_sym_Int] = ACTIONS(5678),
    [anon_sym_u2124] = ACTIONS(5676),
    [anon_sym_Real] = ACTIONS(5678),
    [anon_sym_u211d] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_IN] = ACTIONS(5678),
    [anon_sym_BSLASHlnot] = ACTIONS(5676),
    [anon_sym_BSLASHneg] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5678),
    [anon_sym_u00ac] = ACTIONS(5676),
    [sym_union] = ACTIONS(5678),
    [sym_powerset] = ACTIONS(5678),
    [sym_domain] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [sym_negative_dot] = ACTIONS(5676),
    [sym_enabled] = ACTIONS(5678),
    [sym_unchanged] = ACTIONS(5678),
    [anon_sym_LT_GT] = ACTIONS(5676),
    [anon_sym_u22c4] = ACTIONS(5676),
    [anon_sym_u25c7] = ACTIONS(5676),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5676),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [2517] = {
    [sym_block_comment] = STATE(2517),
    [sym_identifier] = ACTIONS(5710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_COMMA] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_INSTANCE] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_Nat] = ACTIONS(5710),
    [anon_sym_u2115] = ACTIONS(5708),
    [anon_sym_Int] = ACTIONS(5710),
    [anon_sym_u2124] = ACTIONS(5708),
    [anon_sym_Real] = ACTIONS(5710),
    [anon_sym_u211d] = ACTIONS(5708),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_BSLASHlnot] = ACTIONS(5708),
    [anon_sym_BSLASHneg] = ACTIONS(5708),
    [anon_sym_TILDE] = ACTIONS(5710),
    [anon_sym_u00ac] = ACTIONS(5708),
    [sym_union] = ACTIONS(5710),
    [sym_powerset] = ACTIONS(5710),
    [sym_domain] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [sym_negative_dot] = ACTIONS(5708),
    [sym_enabled] = ACTIONS(5710),
    [sym_unchanged] = ACTIONS(5710),
    [anon_sym_LT_GT] = ACTIONS(5708),
    [anon_sym_u22c4] = ACTIONS(5708),
    [anon_sym_u25c7] = ACTIONS(5708),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5708),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [anon_sym_end] = ACTIONS(5710),
    [sym__double_excl] = ACTIONS(5708),
  },
  [2518] = {
    [sym_block_comment] = STATE(2518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_COLON] = ACTIONS(5720),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_RPAREN] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_RBRACK] = ACTIONS(5722),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_LBRACE] = ACTIONS(5722),
    [anon_sym_RBRACE] = ACTIONS(5722),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_THEN] = ACTIONS(5722),
    [anon_sym_ELSE] = ACTIONS(5722),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5722),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [anon_sym_PROVE] = ACTIONS(5722),
    [anon_sym_end] = ACTIONS(5722),
    [anon_sym_SEMI] = ACTIONS(5722),
    [anon_sym_define] = ACTIONS(5722),
    [anon_sym_macro] = ACTIONS(5722),
    [anon_sym_procedure] = ACTIONS(5722),
    [anon_sym_fair] = ACTIONS(5722),
    [anon_sym_process] = ACTIONS(5722),
    [anon_sym_variable] = ACTIONS(5720),
    [anon_sym_variables] = ACTIONS(5722),
    [anon_sym_begin] = ACTIONS(5722),
    [anon_sym_then] = ACTIONS(5722),
    [anon_sym_elsif] = ACTIONS(5722),
    [anon_sym_else] = ACTIONS(5722),
    [anon_sym_do] = ACTIONS(5722),
    [anon_sym_or] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [2519] = {
    [sym_block_comment] = STATE(2519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_COLON] = ACTIONS(5698),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_THEN] = ACTIONS(5696),
    [anon_sym_ELSE] = ACTIONS(5696),
    [anon_sym_DASH] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5696),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [anon_sym_PROVE] = ACTIONS(5696),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_define] = ACTIONS(5696),
    [anon_sym_macro] = ACTIONS(5696),
    [anon_sym_procedure] = ACTIONS(5696),
    [anon_sym_fair] = ACTIONS(5696),
    [anon_sym_process] = ACTIONS(5696),
    [anon_sym_variable] = ACTIONS(5698),
    [anon_sym_variables] = ACTIONS(5696),
    [anon_sym_begin] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [2520] = {
    [sym_block_comment] = STATE(2520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_COLON] = ACTIONS(5702),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_COMMA] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(5954),
    [anon_sym_RPAREN] = ACTIONS(5700),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_RBRACK] = ACTIONS(5700),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_LBRACE] = ACTIONS(5700),
    [anon_sym_RBRACE] = ACTIONS(5700),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_THEN] = ACTIONS(5700),
    [anon_sym_ELSE] = ACTIONS(5700),
    [anon_sym_DASH] = ACTIONS(5702),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5700),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [anon_sym_PROVE] = ACTIONS(5700),
    [anon_sym_end] = ACTIONS(5700),
    [anon_sym_SEMI] = ACTIONS(5700),
    [anon_sym_define] = ACTIONS(5700),
    [anon_sym_macro] = ACTIONS(5700),
    [anon_sym_procedure] = ACTIONS(5700),
    [anon_sym_fair] = ACTIONS(5700),
    [anon_sym_process] = ACTIONS(5700),
    [anon_sym_variable] = ACTIONS(5702),
    [anon_sym_variables] = ACTIONS(5700),
    [anon_sym_begin] = ACTIONS(5700),
    [anon_sym_then] = ACTIONS(5700),
    [anon_sym_elsif] = ACTIONS(5700),
    [anon_sym_else] = ACTIONS(5700),
    [anon_sym_do] = ACTIONS(5700),
    [anon_sym_or] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [2521] = {
    [sym_block_comment] = STATE(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_COLON] = ACTIONS(5688),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_RPAREN] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_RBRACK] = ACTIONS(5690),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_LBRACE] = ACTIONS(5690),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_THEN] = ACTIONS(5690),
    [anon_sym_ELSE] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_PROVE] = ACTIONS(5690),
    [anon_sym_end] = ACTIONS(5690),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_define] = ACTIONS(5690),
    [anon_sym_macro] = ACTIONS(5690),
    [anon_sym_procedure] = ACTIONS(5690),
    [anon_sym_fair] = ACTIONS(5690),
    [anon_sym_process] = ACTIONS(5690),
    [anon_sym_variable] = ACTIONS(5688),
    [anon_sym_variables] = ACTIONS(5690),
    [anon_sym_begin] = ACTIONS(5690),
    [anon_sym_then] = ACTIONS(5690),
    [anon_sym_elsif] = ACTIONS(5690),
    [anon_sym_else] = ACTIONS(5690),
    [anon_sym_do] = ACTIONS(5690),
    [anon_sym_or] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2522] = {
    [sym_block_comment] = STATE(2522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_COLON] = ACTIONS(5714),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_RPAREN] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_RBRACK] = ACTIONS(5712),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_LBRACE] = ACTIONS(5712),
    [anon_sym_RBRACE] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_THEN] = ACTIONS(5712),
    [anon_sym_ELSE] = ACTIONS(5712),
    [anon_sym_DASH] = ACTIONS(5714),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5712),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [anon_sym_PROVE] = ACTIONS(5712),
    [anon_sym_end] = ACTIONS(5712),
    [anon_sym_SEMI] = ACTIONS(5712),
    [anon_sym_define] = ACTIONS(5712),
    [anon_sym_macro] = ACTIONS(5712),
    [anon_sym_procedure] = ACTIONS(5712),
    [anon_sym_fair] = ACTIONS(5712),
    [anon_sym_process] = ACTIONS(5712),
    [anon_sym_variable] = ACTIONS(5714),
    [anon_sym_variables] = ACTIONS(5712),
    [anon_sym_begin] = ACTIONS(5712),
    [anon_sym_then] = ACTIONS(5712),
    [anon_sym_elsif] = ACTIONS(5712),
    [anon_sym_else] = ACTIONS(5712),
    [anon_sym_do] = ACTIONS(5712),
    [anon_sym_or] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [2523] = {
    [sym_block_comment] = STATE(2523),
    [sym_case_box] = STATE(301),
    [aux_sym_case_repeat1] = STATE(2523),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_RECURSIVE] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_IN] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2524] = {
    [sym_block_comment] = STATE(2524),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_end] = ACTIONS(5688),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2525] = {
    [sym_block_comment] = STATE(2525),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_end] = ACTIONS(5688),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2526] = {
    [sym_block_comment] = STATE(2526),
    [sym_case_box] = STATE(153),
    [aux_sym_case_repeat1] = STATE(2528),
    [sym_identifier] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_COMMA] = ACTIONS(5684),
    [anon_sym_RECURSIVE] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_Nat] = ACTIONS(5686),
    [anon_sym_u2115] = ACTIONS(5684),
    [anon_sym_Int] = ACTIONS(5686),
    [anon_sym_u2124] = ACTIONS(5684),
    [anon_sym_Real] = ACTIONS(5686),
    [anon_sym_u211d] = ACTIONS(5684),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_IN] = ACTIONS(5686),
    [anon_sym_BSLASHlnot] = ACTIONS(5684),
    [anon_sym_BSLASHneg] = ACTIONS(5684),
    [anon_sym_TILDE] = ACTIONS(5686),
    [anon_sym_u00ac] = ACTIONS(5684),
    [sym_union] = ACTIONS(5686),
    [sym_powerset] = ACTIONS(5686),
    [sym_domain] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [sym_negative_dot] = ACTIONS(5684),
    [sym_enabled] = ACTIONS(5686),
    [sym_unchanged] = ACTIONS(5686),
    [anon_sym_LT_GT] = ACTIONS(5684),
    [anon_sym_u22c4] = ACTIONS(5684),
    [anon_sym_u25c7] = ACTIONS(5684),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5684),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2527] = {
    [sym_block_comment] = STATE(2527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_COLON] = ACTIONS(5706),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_RPAREN] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_RBRACK] = ACTIONS(5704),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(5704),
    [anon_sym_RBRACE] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_THEN] = ACTIONS(5704),
    [anon_sym_ELSE] = ACTIONS(5704),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_PROVE] = ACTIONS(5704),
    [anon_sym_end] = ACTIONS(5704),
    [anon_sym_SEMI] = ACTIONS(5704),
    [anon_sym_define] = ACTIONS(5704),
    [anon_sym_macro] = ACTIONS(5704),
    [anon_sym_procedure] = ACTIONS(5704),
    [anon_sym_fair] = ACTIONS(5704),
    [anon_sym_process] = ACTIONS(5704),
    [anon_sym_variable] = ACTIONS(5706),
    [anon_sym_variables] = ACTIONS(5704),
    [anon_sym_begin] = ACTIONS(5704),
    [anon_sym_then] = ACTIONS(5704),
    [anon_sym_elsif] = ACTIONS(5704),
    [anon_sym_else] = ACTIONS(5704),
    [anon_sym_do] = ACTIONS(5704),
    [anon_sym_or] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2528] = {
    [sym_block_comment] = STATE(2528),
    [sym_case_box] = STATE(154),
    [aux_sym_case_repeat1] = STATE(2523),
    [sym_identifier] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_RECURSIVE] = ACTIONS(5670),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_Nat] = ACTIONS(5670),
    [anon_sym_u2115] = ACTIONS(5672),
    [anon_sym_Int] = ACTIONS(5670),
    [anon_sym_u2124] = ACTIONS(5672),
    [anon_sym_Real] = ACTIONS(5670),
    [anon_sym_u211d] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_IN] = ACTIONS(5670),
    [anon_sym_BSLASHlnot] = ACTIONS(5672),
    [anon_sym_BSLASHneg] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5670),
    [anon_sym_u00ac] = ACTIONS(5672),
    [sym_union] = ACTIONS(5670),
    [sym_powerset] = ACTIONS(5670),
    [sym_domain] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [sym_negative_dot] = ACTIONS(5672),
    [sym_enabled] = ACTIONS(5670),
    [sym_unchanged] = ACTIONS(5670),
    [anon_sym_LT_GT] = ACTIONS(5672),
    [anon_sym_u22c4] = ACTIONS(5672),
    [anon_sym_u25c7] = ACTIONS(5672),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5672),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [2529] = {
    [sym_block_comment] = STATE(2529),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_INSTANCE] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_RBRACE] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_end] = ACTIONS(5706),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2530] = {
    [sym_block_comment] = STATE(2530),
    [sym_identifier] = ACTIONS(5702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_COMMA] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(5952),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_INSTANCE] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_Nat] = ACTIONS(5702),
    [anon_sym_u2115] = ACTIONS(5700),
    [anon_sym_Int] = ACTIONS(5702),
    [anon_sym_u2124] = ACTIONS(5700),
    [anon_sym_Real] = ACTIONS(5702),
    [anon_sym_u211d] = ACTIONS(5700),
    [anon_sym_RBRACE] = ACTIONS(5700),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_BSLASHlnot] = ACTIONS(5700),
    [anon_sym_BSLASHneg] = ACTIONS(5700),
    [anon_sym_TILDE] = ACTIONS(5702),
    [anon_sym_u00ac] = ACTIONS(5700),
    [sym_union] = ACTIONS(5702),
    [sym_powerset] = ACTIONS(5702),
    [sym_domain] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [sym_negative_dot] = ACTIONS(5700),
    [sym_enabled] = ACTIONS(5702),
    [sym_unchanged] = ACTIONS(5702),
    [anon_sym_LT_GT] = ACTIONS(5700),
    [anon_sym_u22c4] = ACTIONS(5700),
    [anon_sym_u25c7] = ACTIONS(5700),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5700),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [anon_sym_end] = ACTIONS(5702),
    [sym__double_excl] = ACTIONS(5700),
  },
  [2531] = {
    [sym_block_comment] = STATE(2531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_COLON] = ACTIONS(5688),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_RPAREN] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_RBRACK] = ACTIONS(5690),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_LBRACE] = ACTIONS(5690),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_THEN] = ACTIONS(5690),
    [anon_sym_ELSE] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_PROVE] = ACTIONS(5690),
    [anon_sym_end] = ACTIONS(5690),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_define] = ACTIONS(5690),
    [anon_sym_macro] = ACTIONS(5690),
    [anon_sym_procedure] = ACTIONS(5690),
    [anon_sym_fair] = ACTIONS(5690),
    [anon_sym_process] = ACTIONS(5690),
    [anon_sym_variable] = ACTIONS(5688),
    [anon_sym_variables] = ACTIONS(5690),
    [anon_sym_begin] = ACTIONS(5690),
    [anon_sym_then] = ACTIONS(5690),
    [anon_sym_elsif] = ACTIONS(5690),
    [anon_sym_else] = ACTIONS(5690),
    [anon_sym_do] = ACTIONS(5690),
    [anon_sym_or] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2532] = {
    [sym_block_comment] = STATE(2532),
    [sym_identifier] = ACTIONS(5720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_INSTANCE] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_Nat] = ACTIONS(5720),
    [anon_sym_u2115] = ACTIONS(5722),
    [anon_sym_Int] = ACTIONS(5720),
    [anon_sym_u2124] = ACTIONS(5722),
    [anon_sym_Real] = ACTIONS(5720),
    [anon_sym_u211d] = ACTIONS(5722),
    [anon_sym_RBRACE] = ACTIONS(5722),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_BSLASHlnot] = ACTIONS(5722),
    [anon_sym_BSLASHneg] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5720),
    [anon_sym_u00ac] = ACTIONS(5722),
    [sym_union] = ACTIONS(5720),
    [sym_powerset] = ACTIONS(5720),
    [sym_domain] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [sym_negative_dot] = ACTIONS(5722),
    [sym_enabled] = ACTIONS(5720),
    [sym_unchanged] = ACTIONS(5720),
    [anon_sym_LT_GT] = ACTIONS(5722),
    [anon_sym_u22c4] = ACTIONS(5722),
    [anon_sym_u25c7] = ACTIONS(5722),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5722),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [anon_sym_end] = ACTIONS(5720),
    [sym__double_excl] = ACTIONS(5722),
  },
  [2533] = {
    [sym_block_comment] = STATE(2533),
    [sym_identifier] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_COMMA] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_INSTANCE] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_Nat] = ACTIONS(5718),
    [anon_sym_u2115] = ACTIONS(5716),
    [anon_sym_Int] = ACTIONS(5718),
    [anon_sym_u2124] = ACTIONS(5716),
    [anon_sym_Real] = ACTIONS(5718),
    [anon_sym_u211d] = ACTIONS(5716),
    [anon_sym_RBRACE] = ACTIONS(5716),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_BSLASHlnot] = ACTIONS(5716),
    [anon_sym_BSLASHneg] = ACTIONS(5716),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_u00ac] = ACTIONS(5716),
    [sym_union] = ACTIONS(5718),
    [sym_powerset] = ACTIONS(5718),
    [sym_domain] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [sym_negative_dot] = ACTIONS(5716),
    [sym_enabled] = ACTIONS(5718),
    [sym_unchanged] = ACTIONS(5718),
    [anon_sym_LT_GT] = ACTIONS(5716),
    [anon_sym_u22c4] = ACTIONS(5716),
    [anon_sym_u25c7] = ACTIONS(5716),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5716),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [anon_sym_end] = ACTIONS(5718),
    [sym__double_excl] = ACTIONS(5716),
  },
  [2534] = {
    [sym_block_comment] = STATE(2534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_COLON] = ACTIONS(5710),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_COMMA] = ACTIONS(5708),
    [anon_sym_RPAREN] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_RBRACK] = ACTIONS(5708),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_LBRACE] = ACTIONS(5708),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_THEN] = ACTIONS(5708),
    [anon_sym_ELSE] = ACTIONS(5708),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5708),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [anon_sym_PROVE] = ACTIONS(5708),
    [anon_sym_end] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5708),
    [anon_sym_define] = ACTIONS(5708),
    [anon_sym_macro] = ACTIONS(5708),
    [anon_sym_procedure] = ACTIONS(5708),
    [anon_sym_fair] = ACTIONS(5708),
    [anon_sym_process] = ACTIONS(5708),
    [anon_sym_variable] = ACTIONS(5710),
    [anon_sym_variables] = ACTIONS(5708),
    [anon_sym_begin] = ACTIONS(5708),
    [anon_sym_then] = ACTIONS(5708),
    [anon_sym_elsif] = ACTIONS(5708),
    [anon_sym_else] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(5708),
    [anon_sym_or] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [2535] = {
    [sym_block_comment] = STATE(2535),
    [sym_identifier] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_INSTANCE] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_Nat] = ACTIONS(5714),
    [anon_sym_u2115] = ACTIONS(5712),
    [anon_sym_Int] = ACTIONS(5714),
    [anon_sym_u2124] = ACTIONS(5712),
    [anon_sym_Real] = ACTIONS(5714),
    [anon_sym_u211d] = ACTIONS(5712),
    [anon_sym_RBRACE] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_BSLASHlnot] = ACTIONS(5712),
    [anon_sym_BSLASHneg] = ACTIONS(5712),
    [anon_sym_TILDE] = ACTIONS(5714),
    [anon_sym_u00ac] = ACTIONS(5712),
    [sym_union] = ACTIONS(5714),
    [sym_powerset] = ACTIONS(5714),
    [sym_domain] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [sym_negative_dot] = ACTIONS(5712),
    [sym_enabled] = ACTIONS(5714),
    [sym_unchanged] = ACTIONS(5714),
    [anon_sym_LT_GT] = ACTIONS(5712),
    [anon_sym_u22c4] = ACTIONS(5712),
    [anon_sym_u25c7] = ACTIONS(5712),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5712),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [anon_sym_end] = ACTIONS(5714),
    [sym__double_excl] = ACTIONS(5712),
  },
  [2536] = {
    [sym_block_comment] = STATE(2536),
    [sym_identifier] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_INSTANCE] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_Nat] = ACTIONS(5698),
    [anon_sym_u2115] = ACTIONS(5696),
    [anon_sym_Int] = ACTIONS(5698),
    [anon_sym_u2124] = ACTIONS(5696),
    [anon_sym_Real] = ACTIONS(5698),
    [anon_sym_u211d] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_BSLASHlnot] = ACTIONS(5696),
    [anon_sym_BSLASHneg] = ACTIONS(5696),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_u00ac] = ACTIONS(5696),
    [sym_union] = ACTIONS(5698),
    [sym_powerset] = ACTIONS(5698),
    [sym_domain] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [sym_negative_dot] = ACTIONS(5696),
    [sym_enabled] = ACTIONS(5698),
    [sym_unchanged] = ACTIONS(5698),
    [anon_sym_LT_GT] = ACTIONS(5696),
    [anon_sym_u22c4] = ACTIONS(5696),
    [anon_sym_u25c7] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5696),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [anon_sym_end] = ACTIONS(5698),
    [sym__double_excl] = ACTIONS(5696),
  },
  [2537] = {
    [sym_block_comment] = STATE(2537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_COLON] = ACTIONS(5718),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_COMMA] = ACTIONS(5716),
    [anon_sym_RPAREN] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_RBRACK] = ACTIONS(5716),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_LBRACE] = ACTIONS(5716),
    [anon_sym_RBRACE] = ACTIONS(5716),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_THEN] = ACTIONS(5716),
    [anon_sym_ELSE] = ACTIONS(5716),
    [anon_sym_DASH] = ACTIONS(5718),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5716),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [anon_sym_PROVE] = ACTIONS(5716),
    [anon_sym_end] = ACTIONS(5716),
    [anon_sym_SEMI] = ACTIONS(5716),
    [anon_sym_define] = ACTIONS(5716),
    [anon_sym_macro] = ACTIONS(5716),
    [anon_sym_procedure] = ACTIONS(5716),
    [anon_sym_fair] = ACTIONS(5716),
    [anon_sym_process] = ACTIONS(5716),
    [anon_sym_variable] = ACTIONS(5718),
    [anon_sym_variables] = ACTIONS(5716),
    [anon_sym_begin] = ACTIONS(5716),
    [anon_sym_then] = ACTIONS(5716),
    [anon_sym_elsif] = ACTIONS(5716),
    [anon_sym_else] = ACTIONS(5716),
    [anon_sym_do] = ACTIONS(5716),
    [anon_sym_or] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [2538] = {
    [sym_block_comment] = STATE(2538),
    [sym_identifier] = ACTIONS(5928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_INSTANCE] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_Nat] = ACTIONS(5928),
    [anon_sym_u2115] = ACTIONS(5930),
    [anon_sym_Int] = ACTIONS(5928),
    [anon_sym_u2124] = ACTIONS(5930),
    [anon_sym_Real] = ACTIONS(5928),
    [anon_sym_u211d] = ACTIONS(5930),
    [anon_sym_RBRACE] = ACTIONS(5930),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_BSLASHlnot] = ACTIONS(5930),
    [anon_sym_BSLASHneg] = ACTIONS(5930),
    [anon_sym_TILDE] = ACTIONS(5928),
    [anon_sym_u00ac] = ACTIONS(5930),
    [sym_union] = ACTIONS(5928),
    [sym_powerset] = ACTIONS(5928),
    [sym_domain] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [sym_negative_dot] = ACTIONS(5930),
    [sym_enabled] = ACTIONS(5928),
    [sym_unchanged] = ACTIONS(5928),
    [anon_sym_LT_GT] = ACTIONS(5930),
    [anon_sym_u22c4] = ACTIONS(5930),
    [anon_sym_u25c7] = ACTIONS(5930),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5930),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [anon_sym_end] = ACTIONS(5928),
    [sym__double_excl] = ACTIONS(5930),
  },
  [2539] = {
    [sym_block_comment] = STATE(2539),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_IN] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2540] = {
    [sym_block_comment] = STATE(2540),
    [sym_identifier] = ACTIONS(5710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_COMMA] = ACTIONS(5708),
    [anon_sym_RECURSIVE] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_Nat] = ACTIONS(5710),
    [anon_sym_u2115] = ACTIONS(5708),
    [anon_sym_Int] = ACTIONS(5710),
    [anon_sym_u2124] = ACTIONS(5708),
    [anon_sym_Real] = ACTIONS(5710),
    [anon_sym_u211d] = ACTIONS(5708),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_IN] = ACTIONS(5710),
    [anon_sym_BSLASHlnot] = ACTIONS(5708),
    [anon_sym_BSLASHneg] = ACTIONS(5708),
    [anon_sym_TILDE] = ACTIONS(5710),
    [anon_sym_u00ac] = ACTIONS(5708),
    [sym_union] = ACTIONS(5710),
    [sym_powerset] = ACTIONS(5710),
    [sym_domain] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [sym_negative_dot] = ACTIONS(5708),
    [sym_enabled] = ACTIONS(5710),
    [sym_unchanged] = ACTIONS(5710),
    [anon_sym_LT_GT] = ACTIONS(5708),
    [anon_sym_u22c4] = ACTIONS(5708),
    [anon_sym_u25c7] = ACTIONS(5708),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5708),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [2541] = {
    [sym_block_comment] = STATE(2541),
    [sym_identifier] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_RECURSIVE] = ACTIONS(5714),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_Nat] = ACTIONS(5714),
    [anon_sym_u2115] = ACTIONS(5712),
    [anon_sym_Int] = ACTIONS(5714),
    [anon_sym_u2124] = ACTIONS(5712),
    [anon_sym_Real] = ACTIONS(5714),
    [anon_sym_u211d] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_IN] = ACTIONS(5714),
    [anon_sym_BSLASHlnot] = ACTIONS(5712),
    [anon_sym_BSLASHneg] = ACTIONS(5712),
    [anon_sym_TILDE] = ACTIONS(5714),
    [anon_sym_u00ac] = ACTIONS(5712),
    [sym_union] = ACTIONS(5714),
    [sym_powerset] = ACTIONS(5714),
    [sym_domain] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [sym_negative_dot] = ACTIONS(5712),
    [sym_enabled] = ACTIONS(5714),
    [sym_unchanged] = ACTIONS(5714),
    [anon_sym_LT_GT] = ACTIONS(5712),
    [anon_sym_u22c4] = ACTIONS(5712),
    [anon_sym_u25c7] = ACTIONS(5712),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5712),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [2542] = {
    [sym_block_comment] = STATE(2542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_COLON] = ACTIONS(5888),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_COMMA] = ACTIONS(5890),
    [anon_sym_RPAREN] = ACTIONS(5890),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_RBRACK] = ACTIONS(5890),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_LBRACE] = ACTIONS(5890),
    [anon_sym_RBRACE] = ACTIONS(5890),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_THEN] = ACTIONS(5890),
    [anon_sym_ELSE] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5888),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5890),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [anon_sym_PROVE] = ACTIONS(5890),
    [anon_sym_end] = ACTIONS(5890),
    [anon_sym_SEMI] = ACTIONS(5890),
    [anon_sym_define] = ACTIONS(5890),
    [anon_sym_macro] = ACTIONS(5890),
    [anon_sym_procedure] = ACTIONS(5890),
    [anon_sym_fair] = ACTIONS(5890),
    [anon_sym_process] = ACTIONS(5890),
    [anon_sym_variable] = ACTIONS(5888),
    [anon_sym_variables] = ACTIONS(5890),
    [anon_sym_begin] = ACTIONS(5890),
    [anon_sym_then] = ACTIONS(5890),
    [anon_sym_elsif] = ACTIONS(5890),
    [anon_sym_else] = ACTIONS(5890),
    [anon_sym_do] = ACTIONS(5890),
    [anon_sym_or] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [2543] = {
    [sym_block_comment] = STATE(2543),
    [sym_identifier] = ACTIONS(5720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_RECURSIVE] = ACTIONS(5720),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_Nat] = ACTIONS(5720),
    [anon_sym_u2115] = ACTIONS(5722),
    [anon_sym_Int] = ACTIONS(5720),
    [anon_sym_u2124] = ACTIONS(5722),
    [anon_sym_Real] = ACTIONS(5720),
    [anon_sym_u211d] = ACTIONS(5722),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_IN] = ACTIONS(5720),
    [anon_sym_BSLASHlnot] = ACTIONS(5722),
    [anon_sym_BSLASHneg] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5720),
    [anon_sym_u00ac] = ACTIONS(5722),
    [sym_union] = ACTIONS(5720),
    [sym_powerset] = ACTIONS(5720),
    [sym_domain] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [sym_negative_dot] = ACTIONS(5722),
    [sym_enabled] = ACTIONS(5720),
    [sym_unchanged] = ACTIONS(5720),
    [anon_sym_LT_GT] = ACTIONS(5722),
    [anon_sym_u22c4] = ACTIONS(5722),
    [anon_sym_u25c7] = ACTIONS(5722),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5722),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [2544] = {
    [sym_block_comment] = STATE(2544),
    [sym_case_box] = STATE(177),
    [aux_sym_case_repeat1] = STATE(2553),
    [sym_identifier] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_COMMA] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_Nat] = ACTIONS(5686),
    [anon_sym_u2115] = ACTIONS(5684),
    [anon_sym_Int] = ACTIONS(5686),
    [anon_sym_u2124] = ACTIONS(5684),
    [anon_sym_Real] = ACTIONS(5686),
    [anon_sym_u211d] = ACTIONS(5684),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_BSLASHlnot] = ACTIONS(5684),
    [anon_sym_BSLASHneg] = ACTIONS(5684),
    [anon_sym_TILDE] = ACTIONS(5686),
    [anon_sym_u00ac] = ACTIONS(5684),
    [sym_union] = ACTIONS(5686),
    [sym_powerset] = ACTIONS(5686),
    [sym_domain] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [sym_negative_dot] = ACTIONS(5684),
    [sym_enabled] = ACTIONS(5686),
    [sym_unchanged] = ACTIONS(5686),
    [anon_sym_LT_GT] = ACTIONS(5684),
    [anon_sym_u22c4] = ACTIONS(5684),
    [anon_sym_u25c7] = ACTIONS(5684),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5684),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [sym__begin_proof_step] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2545] = {
    [sym_block_comment] = STATE(2545),
    [sym_identifier] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_INSTANCE] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_Nat] = ACTIONS(5780),
    [anon_sym_u2115] = ACTIONS(5778),
    [anon_sym_Int] = ACTIONS(5780),
    [anon_sym_u2124] = ACTIONS(5778),
    [anon_sym_Real] = ACTIONS(5780),
    [anon_sym_u211d] = ACTIONS(5778),
    [anon_sym_RBRACE] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_BSLASHlnot] = ACTIONS(5778),
    [anon_sym_BSLASHneg] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5780),
    [anon_sym_u00ac] = ACTIONS(5778),
    [sym_union] = ACTIONS(5780),
    [sym_powerset] = ACTIONS(5780),
    [sym_domain] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [sym_negative_dot] = ACTIONS(5778),
    [sym_enabled] = ACTIONS(5780),
    [sym_unchanged] = ACTIONS(5780),
    [anon_sym_LT_GT] = ACTIONS(5778),
    [anon_sym_u22c4] = ACTIONS(5778),
    [anon_sym_u25c7] = ACTIONS(5778),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5778),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [anon_sym_end] = ACTIONS(5780),
    [sym__double_excl] = ACTIONS(5778),
  },
  [2546] = {
    [sym_block_comment] = STATE(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_COLON] = ACTIONS(5730),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_RPAREN] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_RBRACK] = ACTIONS(5728),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_LBRACE] = ACTIONS(5728),
    [anon_sym_RBRACE] = ACTIONS(5728),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_THEN] = ACTIONS(5728),
    [anon_sym_ELSE] = ACTIONS(5728),
    [anon_sym_DASH] = ACTIONS(5730),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5728),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [anon_sym_PROVE] = ACTIONS(5728),
    [anon_sym_end] = ACTIONS(5728),
    [anon_sym_SEMI] = ACTIONS(5728),
    [anon_sym_define] = ACTIONS(5728),
    [anon_sym_macro] = ACTIONS(5728),
    [anon_sym_procedure] = ACTIONS(5728),
    [anon_sym_fair] = ACTIONS(5728),
    [anon_sym_process] = ACTIONS(5728),
    [anon_sym_variable] = ACTIONS(5730),
    [anon_sym_variables] = ACTIONS(5728),
    [anon_sym_begin] = ACTIONS(5728),
    [anon_sym_then] = ACTIONS(5728),
    [anon_sym_elsif] = ACTIONS(5728),
    [anon_sym_else] = ACTIONS(5728),
    [anon_sym_do] = ACTIONS(5728),
    [anon_sym_or] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [2547] = {
    [sym_block_comment] = STATE(2547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_COLON] = ACTIONS(5734),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_COMMA] = ACTIONS(5732),
    [anon_sym_RPAREN] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_RBRACK] = ACTIONS(5732),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_LBRACE] = ACTIONS(5732),
    [anon_sym_RBRACE] = ACTIONS(5732),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_THEN] = ACTIONS(5732),
    [anon_sym_ELSE] = ACTIONS(5732),
    [anon_sym_DASH] = ACTIONS(5734),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5732),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [anon_sym_PROVE] = ACTIONS(5732),
    [anon_sym_end] = ACTIONS(5732),
    [anon_sym_SEMI] = ACTIONS(5732),
    [anon_sym_define] = ACTIONS(5732),
    [anon_sym_macro] = ACTIONS(5732),
    [anon_sym_procedure] = ACTIONS(5732),
    [anon_sym_fair] = ACTIONS(5732),
    [anon_sym_process] = ACTIONS(5732),
    [anon_sym_variable] = ACTIONS(5734),
    [anon_sym_variables] = ACTIONS(5732),
    [anon_sym_begin] = ACTIONS(5732),
    [anon_sym_then] = ACTIONS(5732),
    [anon_sym_elsif] = ACTIONS(5732),
    [anon_sym_else] = ACTIONS(5732),
    [anon_sym_do] = ACTIONS(5732),
    [anon_sym_or] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [2548] = {
    [sym_block_comment] = STATE(2548),
    [sym_identifier] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_COMMA] = ACTIONS(5782),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_INSTANCE] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_Nat] = ACTIONS(5784),
    [anon_sym_u2115] = ACTIONS(5782),
    [anon_sym_Int] = ACTIONS(5784),
    [anon_sym_u2124] = ACTIONS(5782),
    [anon_sym_Real] = ACTIONS(5784),
    [anon_sym_u211d] = ACTIONS(5782),
    [anon_sym_RBRACE] = ACTIONS(5782),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_BSLASHlnot] = ACTIONS(5782),
    [anon_sym_BSLASHneg] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [anon_sym_u00ac] = ACTIONS(5782),
    [sym_union] = ACTIONS(5784),
    [sym_powerset] = ACTIONS(5784),
    [sym_domain] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [sym_negative_dot] = ACTIONS(5782),
    [sym_enabled] = ACTIONS(5784),
    [sym_unchanged] = ACTIONS(5784),
    [anon_sym_LT_GT] = ACTIONS(5782),
    [anon_sym_u22c4] = ACTIONS(5782),
    [anon_sym_u25c7] = ACTIONS(5782),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5782),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [anon_sym_end] = ACTIONS(5784),
    [sym__double_excl] = ACTIONS(5782),
  },
  [2549] = {
    [sym_block_comment] = STATE(2549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_COLON] = ACTIONS(5738),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RPAREN] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_RBRACK] = ACTIONS(5736),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_LBRACE] = ACTIONS(5736),
    [anon_sym_RBRACE] = ACTIONS(5736),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_THEN] = ACTIONS(5736),
    [anon_sym_ELSE] = ACTIONS(5736),
    [anon_sym_DASH] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5736),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [anon_sym_PROVE] = ACTIONS(5736),
    [anon_sym_end] = ACTIONS(5736),
    [anon_sym_SEMI] = ACTIONS(5736),
    [anon_sym_define] = ACTIONS(5736),
    [anon_sym_macro] = ACTIONS(5736),
    [anon_sym_procedure] = ACTIONS(5736),
    [anon_sym_fair] = ACTIONS(5736),
    [anon_sym_process] = ACTIONS(5736),
    [anon_sym_variable] = ACTIONS(5738),
    [anon_sym_variables] = ACTIONS(5736),
    [anon_sym_begin] = ACTIONS(5736),
    [anon_sym_then] = ACTIONS(5736),
    [anon_sym_elsif] = ACTIONS(5736),
    [anon_sym_else] = ACTIONS(5736),
    [anon_sym_do] = ACTIONS(5736),
    [anon_sym_or] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [2550] = {
    [sym_block_comment] = STATE(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_COLON] = ACTIONS(5742),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5740),
    [anon_sym_RPAREN] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_RBRACK] = ACTIONS(5740),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_LBRACE] = ACTIONS(5740),
    [anon_sym_RBRACE] = ACTIONS(5740),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_THEN] = ACTIONS(5740),
    [anon_sym_ELSE] = ACTIONS(5740),
    [anon_sym_DASH] = ACTIONS(5742),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5740),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [anon_sym_PROVE] = ACTIONS(5740),
    [anon_sym_end] = ACTIONS(5740),
    [anon_sym_SEMI] = ACTIONS(5740),
    [anon_sym_define] = ACTIONS(5740),
    [anon_sym_macro] = ACTIONS(5740),
    [anon_sym_procedure] = ACTIONS(5740),
    [anon_sym_fair] = ACTIONS(5740),
    [anon_sym_process] = ACTIONS(5740),
    [anon_sym_variable] = ACTIONS(5742),
    [anon_sym_variables] = ACTIONS(5740),
    [anon_sym_begin] = ACTIONS(5740),
    [anon_sym_then] = ACTIONS(5740),
    [anon_sym_elsif] = ACTIONS(5740),
    [anon_sym_else] = ACTIONS(5740),
    [anon_sym_do] = ACTIONS(5740),
    [anon_sym_or] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [2551] = {
    [sym_block_comment] = STATE(2551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_COLON] = ACTIONS(5746),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_RPAREN] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_RBRACK] = ACTIONS(5744),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5744),
    [anon_sym_RBRACE] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_THEN] = ACTIONS(5744),
    [anon_sym_ELSE] = ACTIONS(5744),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5744),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [anon_sym_PROVE] = ACTIONS(5744),
    [anon_sym_end] = ACTIONS(5744),
    [anon_sym_SEMI] = ACTIONS(5744),
    [anon_sym_define] = ACTIONS(5744),
    [anon_sym_macro] = ACTIONS(5744),
    [anon_sym_procedure] = ACTIONS(5744),
    [anon_sym_fair] = ACTIONS(5744),
    [anon_sym_process] = ACTIONS(5744),
    [anon_sym_variable] = ACTIONS(5746),
    [anon_sym_variables] = ACTIONS(5744),
    [anon_sym_begin] = ACTIONS(5744),
    [anon_sym_then] = ACTIONS(5744),
    [anon_sym_elsif] = ACTIONS(5744),
    [anon_sym_else] = ACTIONS(5744),
    [anon_sym_do] = ACTIONS(5744),
    [anon_sym_or] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [2552] = {
    [sym_block_comment] = STATE(2552),
    [sym_identifier] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_RECURSIVE] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_Nat] = ACTIONS(5698),
    [anon_sym_u2115] = ACTIONS(5696),
    [anon_sym_Int] = ACTIONS(5698),
    [anon_sym_u2124] = ACTIONS(5696),
    [anon_sym_Real] = ACTIONS(5698),
    [anon_sym_u211d] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_IN] = ACTIONS(5698),
    [anon_sym_BSLASHlnot] = ACTIONS(5696),
    [anon_sym_BSLASHneg] = ACTIONS(5696),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_u00ac] = ACTIONS(5696),
    [sym_union] = ACTIONS(5698),
    [sym_powerset] = ACTIONS(5698),
    [sym_domain] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [sym_negative_dot] = ACTIONS(5696),
    [sym_enabled] = ACTIONS(5698),
    [sym_unchanged] = ACTIONS(5698),
    [anon_sym_LT_GT] = ACTIONS(5696),
    [anon_sym_u22c4] = ACTIONS(5696),
    [anon_sym_u25c7] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5696),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [2553] = {
    [sym_block_comment] = STATE(2553),
    [sym_case_box] = STATE(178),
    [aux_sym_case_repeat1] = STATE(2560),
    [sym_identifier] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_Nat] = ACTIONS(5670),
    [anon_sym_u2115] = ACTIONS(5672),
    [anon_sym_Int] = ACTIONS(5670),
    [anon_sym_u2124] = ACTIONS(5672),
    [anon_sym_Real] = ACTIONS(5670),
    [anon_sym_u211d] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_BSLASHlnot] = ACTIONS(5672),
    [anon_sym_BSLASHneg] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5670),
    [anon_sym_u00ac] = ACTIONS(5672),
    [sym_union] = ACTIONS(5670),
    [sym_powerset] = ACTIONS(5670),
    [sym_domain] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [sym_negative_dot] = ACTIONS(5672),
    [sym_enabled] = ACTIONS(5670),
    [sym_unchanged] = ACTIONS(5670),
    [anon_sym_LT_GT] = ACTIONS(5672),
    [anon_sym_u22c4] = ACTIONS(5672),
    [anon_sym_u25c7] = ACTIONS(5672),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5672),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [sym__begin_proof_step] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [2554] = {
    [sym_block_comment] = STATE(2554),
    [sym_identifier] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_INSTANCE] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_Nat] = ACTIONS(5738),
    [anon_sym_u2115] = ACTIONS(5736),
    [anon_sym_Int] = ACTIONS(5738),
    [anon_sym_u2124] = ACTIONS(5736),
    [anon_sym_Real] = ACTIONS(5738),
    [anon_sym_u211d] = ACTIONS(5736),
    [anon_sym_RBRACE] = ACTIONS(5736),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_BSLASHlnot] = ACTIONS(5736),
    [anon_sym_BSLASHneg] = ACTIONS(5736),
    [anon_sym_TILDE] = ACTIONS(5738),
    [anon_sym_u00ac] = ACTIONS(5736),
    [sym_union] = ACTIONS(5738),
    [sym_powerset] = ACTIONS(5738),
    [sym_domain] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [sym_negative_dot] = ACTIONS(5736),
    [sym_enabled] = ACTIONS(5738),
    [sym_unchanged] = ACTIONS(5738),
    [anon_sym_LT_GT] = ACTIONS(5736),
    [anon_sym_u22c4] = ACTIONS(5736),
    [anon_sym_u25c7] = ACTIONS(5736),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5736),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [anon_sym_end] = ACTIONS(5738),
    [sym__double_excl] = ACTIONS(5736),
  },
  [2555] = {
    [sym_block_comment] = STATE(2555),
    [sym_identifier] = ACTIONS(5792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_COMMA] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_INSTANCE] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_Nat] = ACTIONS(5792),
    [anon_sym_u2115] = ACTIONS(5790),
    [anon_sym_Int] = ACTIONS(5792),
    [anon_sym_u2124] = ACTIONS(5790),
    [anon_sym_Real] = ACTIONS(5792),
    [anon_sym_u211d] = ACTIONS(5790),
    [anon_sym_RBRACE] = ACTIONS(5790),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_BSLASHlnot] = ACTIONS(5790),
    [anon_sym_BSLASHneg] = ACTIONS(5790),
    [anon_sym_TILDE] = ACTIONS(5792),
    [anon_sym_u00ac] = ACTIONS(5790),
    [sym_union] = ACTIONS(5792),
    [sym_powerset] = ACTIONS(5792),
    [sym_domain] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [sym_negative_dot] = ACTIONS(5790),
    [sym_enabled] = ACTIONS(5792),
    [sym_unchanged] = ACTIONS(5792),
    [anon_sym_LT_GT] = ACTIONS(5790),
    [anon_sym_u22c4] = ACTIONS(5790),
    [anon_sym_u25c7] = ACTIONS(5790),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5790),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [anon_sym_end] = ACTIONS(5792),
    [sym__double_excl] = ACTIONS(5790),
  },
  [2556] = {
    [sym_block_comment] = STATE(2556),
    [sym_identifier] = ACTIONS(5796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_INSTANCE] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_Nat] = ACTIONS(5796),
    [anon_sym_u2115] = ACTIONS(5794),
    [anon_sym_Int] = ACTIONS(5796),
    [anon_sym_u2124] = ACTIONS(5794),
    [anon_sym_Real] = ACTIONS(5796),
    [anon_sym_u211d] = ACTIONS(5794),
    [anon_sym_RBRACE] = ACTIONS(5794),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_BSLASHlnot] = ACTIONS(5794),
    [anon_sym_BSLASHneg] = ACTIONS(5794),
    [anon_sym_TILDE] = ACTIONS(5796),
    [anon_sym_u00ac] = ACTIONS(5794),
    [sym_union] = ACTIONS(5796),
    [sym_powerset] = ACTIONS(5796),
    [sym_domain] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [sym_negative_dot] = ACTIONS(5794),
    [sym_enabled] = ACTIONS(5796),
    [sym_unchanged] = ACTIONS(5796),
    [anon_sym_LT_GT] = ACTIONS(5794),
    [anon_sym_u22c4] = ACTIONS(5794),
    [anon_sym_u25c7] = ACTIONS(5794),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5794),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [anon_sym_end] = ACTIONS(5796),
    [sym__double_excl] = ACTIONS(5794),
  },
  [2557] = {
    [sym_block_comment] = STATE(2557),
    [sym_identifier] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_INSTANCE] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_Nat] = ACTIONS(5800),
    [anon_sym_u2115] = ACTIONS(5798),
    [anon_sym_Int] = ACTIONS(5800),
    [anon_sym_u2124] = ACTIONS(5798),
    [anon_sym_Real] = ACTIONS(5800),
    [anon_sym_u211d] = ACTIONS(5798),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_BSLASHlnot] = ACTIONS(5798),
    [anon_sym_BSLASHneg] = ACTIONS(5798),
    [anon_sym_TILDE] = ACTIONS(5800),
    [anon_sym_u00ac] = ACTIONS(5798),
    [sym_union] = ACTIONS(5800),
    [sym_powerset] = ACTIONS(5800),
    [sym_domain] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [sym_negative_dot] = ACTIONS(5798),
    [sym_enabled] = ACTIONS(5800),
    [sym_unchanged] = ACTIONS(5800),
    [anon_sym_LT_GT] = ACTIONS(5798),
    [anon_sym_u22c4] = ACTIONS(5798),
    [anon_sym_u25c7] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5798),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [anon_sym_end] = ACTIONS(5800),
    [sym__double_excl] = ACTIONS(5798),
  },
  [2558] = {
    [sym_block_comment] = STATE(2558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_COLON] = ACTIONS(5854),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_RBRACK] = ACTIONS(5856),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_THEN] = ACTIONS(5856),
    [anon_sym_ELSE] = ACTIONS(5856),
    [anon_sym_DASH] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5856),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [anon_sym_PROVE] = ACTIONS(5856),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_define] = ACTIONS(5856),
    [anon_sym_macro] = ACTIONS(5856),
    [anon_sym_procedure] = ACTIONS(5856),
    [anon_sym_fair] = ACTIONS(5856),
    [anon_sym_process] = ACTIONS(5856),
    [anon_sym_variable] = ACTIONS(5854),
    [anon_sym_variables] = ACTIONS(5856),
    [anon_sym_begin] = ACTIONS(5856),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_elsif] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [2559] = {
    [sym_block_comment] = STATE(2559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_COLON] = ACTIONS(5750),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_COMMA] = ACTIONS(5748),
    [anon_sym_RPAREN] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_RBRACK] = ACTIONS(5748),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5748),
    [anon_sym_RBRACE] = ACTIONS(5748),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_THEN] = ACTIONS(5748),
    [anon_sym_ELSE] = ACTIONS(5748),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5748),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [anon_sym_PROVE] = ACTIONS(5748),
    [anon_sym_end] = ACTIONS(5748),
    [anon_sym_SEMI] = ACTIONS(5748),
    [anon_sym_define] = ACTIONS(5748),
    [anon_sym_macro] = ACTIONS(5748),
    [anon_sym_procedure] = ACTIONS(5748),
    [anon_sym_fair] = ACTIONS(5748),
    [anon_sym_process] = ACTIONS(5748),
    [anon_sym_variable] = ACTIONS(5750),
    [anon_sym_variables] = ACTIONS(5748),
    [anon_sym_begin] = ACTIONS(5748),
    [anon_sym_then] = ACTIONS(5748),
    [anon_sym_elsif] = ACTIONS(5748),
    [anon_sym_else] = ACTIONS(5748),
    [anon_sym_do] = ACTIONS(5748),
    [anon_sym_or] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [2560] = {
    [sym_block_comment] = STATE(2560),
    [sym_case_box] = STATE(243),
    [aux_sym_case_repeat1] = STATE(2560),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__begin_proof_step] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2561] = {
    [sym_block_comment] = STATE(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_COLON] = ACTIONS(5770),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_RPAREN] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_RBRACK] = ACTIONS(5768),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_LBRACE] = ACTIONS(5768),
    [anon_sym_RBRACE] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_THEN] = ACTIONS(5768),
    [anon_sym_ELSE] = ACTIONS(5768),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [anon_sym_PROVE] = ACTIONS(5768),
    [anon_sym_end] = ACTIONS(5768),
    [anon_sym_SEMI] = ACTIONS(5768),
    [anon_sym_define] = ACTIONS(5768),
    [anon_sym_macro] = ACTIONS(5768),
    [anon_sym_procedure] = ACTIONS(5768),
    [anon_sym_fair] = ACTIONS(5768),
    [anon_sym_process] = ACTIONS(5768),
    [anon_sym_variable] = ACTIONS(5770),
    [anon_sym_variables] = ACTIONS(5768),
    [anon_sym_begin] = ACTIONS(5768),
    [anon_sym_then] = ACTIONS(5768),
    [anon_sym_elsif] = ACTIONS(5768),
    [anon_sym_else] = ACTIONS(5768),
    [anon_sym_do] = ACTIONS(5768),
    [anon_sym_or] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [2562] = {
    [sym_block_comment] = STATE(2562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_COLON] = ACTIONS(5754),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_RPAREN] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_RBRACK] = ACTIONS(5752),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_LBRACE] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_THEN] = ACTIONS(5752),
    [anon_sym_ELSE] = ACTIONS(5752),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5752),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [anon_sym_PROVE] = ACTIONS(5752),
    [anon_sym_end] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5752),
    [anon_sym_define] = ACTIONS(5752),
    [anon_sym_macro] = ACTIONS(5752),
    [anon_sym_procedure] = ACTIONS(5752),
    [anon_sym_fair] = ACTIONS(5752),
    [anon_sym_process] = ACTIONS(5752),
    [anon_sym_variable] = ACTIONS(5754),
    [anon_sym_variables] = ACTIONS(5752),
    [anon_sym_begin] = ACTIONS(5752),
    [anon_sym_then] = ACTIONS(5752),
    [anon_sym_elsif] = ACTIONS(5752),
    [anon_sym_else] = ACTIONS(5752),
    [anon_sym_do] = ACTIONS(5752),
    [anon_sym_or] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [2563] = {
    [sym_block_comment] = STATE(2563),
    [sym_identifier] = ACTIONS(5812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_INSTANCE] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_Nat] = ACTIONS(5812),
    [anon_sym_u2115] = ACTIONS(5810),
    [anon_sym_Int] = ACTIONS(5812),
    [anon_sym_u2124] = ACTIONS(5810),
    [anon_sym_Real] = ACTIONS(5812),
    [anon_sym_u211d] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_BSLASHlnot] = ACTIONS(5810),
    [anon_sym_BSLASHneg] = ACTIONS(5810),
    [anon_sym_TILDE] = ACTIONS(5812),
    [anon_sym_u00ac] = ACTIONS(5810),
    [sym_union] = ACTIONS(5812),
    [sym_powerset] = ACTIONS(5812),
    [sym_domain] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [sym_negative_dot] = ACTIONS(5810),
    [sym_enabled] = ACTIONS(5812),
    [sym_unchanged] = ACTIONS(5812),
    [anon_sym_LT_GT] = ACTIONS(5810),
    [anon_sym_u22c4] = ACTIONS(5810),
    [anon_sym_u25c7] = ACTIONS(5810),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5810),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [anon_sym_end] = ACTIONS(5812),
    [sym__double_excl] = ACTIONS(5810),
  },
  [2564] = {
    [sym_block_comment] = STATE(2564),
    [sym_identifier] = ACTIONS(5678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(5958),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_Nat] = ACTIONS(5678),
    [anon_sym_u2115] = ACTIONS(5676),
    [anon_sym_Int] = ACTIONS(5678),
    [anon_sym_u2124] = ACTIONS(5676),
    [anon_sym_Real] = ACTIONS(5678),
    [anon_sym_u211d] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_BSLASHlnot] = ACTIONS(5676),
    [anon_sym_BSLASHneg] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5678),
    [anon_sym_u00ac] = ACTIONS(5676),
    [sym_union] = ACTIONS(5678),
    [sym_powerset] = ACTIONS(5678),
    [sym_domain] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [sym_negative_dot] = ACTIONS(5676),
    [sym_enabled] = ACTIONS(5678),
    [sym_unchanged] = ACTIONS(5678),
    [anon_sym_LT_GT] = ACTIONS(5676),
    [anon_sym_u22c4] = ACTIONS(5676),
    [anon_sym_u25c7] = ACTIONS(5676),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5676),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [sym__begin_proof_step] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [2565] = {
    [sym_block_comment] = STATE(2565),
    [sym_identifier] = ACTIONS(5816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_COMMA] = ACTIONS(5814),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_INSTANCE] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_Nat] = ACTIONS(5816),
    [anon_sym_u2115] = ACTIONS(5814),
    [anon_sym_Int] = ACTIONS(5816),
    [anon_sym_u2124] = ACTIONS(5814),
    [anon_sym_Real] = ACTIONS(5816),
    [anon_sym_u211d] = ACTIONS(5814),
    [anon_sym_RBRACE] = ACTIONS(5814),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_BSLASHlnot] = ACTIONS(5814),
    [anon_sym_BSLASHneg] = ACTIONS(5814),
    [anon_sym_TILDE] = ACTIONS(5816),
    [anon_sym_u00ac] = ACTIONS(5814),
    [sym_union] = ACTIONS(5816),
    [sym_powerset] = ACTIONS(5816),
    [sym_domain] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [sym_negative_dot] = ACTIONS(5814),
    [sym_enabled] = ACTIONS(5816),
    [sym_unchanged] = ACTIONS(5816),
    [anon_sym_LT_GT] = ACTIONS(5814),
    [anon_sym_u22c4] = ACTIONS(5814),
    [anon_sym_u25c7] = ACTIONS(5814),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5814),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [anon_sym_end] = ACTIONS(5816),
    [sym__double_excl] = ACTIONS(5814),
  },
  [2566] = {
    [sym_block_comment] = STATE(2566),
    [sym_identifier] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5818),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_INSTANCE] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_Nat] = ACTIONS(5820),
    [anon_sym_u2115] = ACTIONS(5818),
    [anon_sym_Int] = ACTIONS(5820),
    [anon_sym_u2124] = ACTIONS(5818),
    [anon_sym_Real] = ACTIONS(5820),
    [anon_sym_u211d] = ACTIONS(5818),
    [anon_sym_RBRACE] = ACTIONS(5818),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_BSLASHlnot] = ACTIONS(5818),
    [anon_sym_BSLASHneg] = ACTIONS(5818),
    [anon_sym_TILDE] = ACTIONS(5820),
    [anon_sym_u00ac] = ACTIONS(5818),
    [sym_union] = ACTIONS(5820),
    [sym_powerset] = ACTIONS(5820),
    [sym_domain] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [sym_negative_dot] = ACTIONS(5818),
    [sym_enabled] = ACTIONS(5820),
    [sym_unchanged] = ACTIONS(5820),
    [anon_sym_LT_GT] = ACTIONS(5818),
    [anon_sym_u22c4] = ACTIONS(5818),
    [anon_sym_u25c7] = ACTIONS(5818),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5818),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [anon_sym_end] = ACTIONS(5820),
    [sym__double_excl] = ACTIONS(5818),
  },
  [2567] = {
    [sym_block_comment] = STATE(2567),
    [sym_identifier] = ACTIONS(5824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_INSTANCE] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_Nat] = ACTIONS(5824),
    [anon_sym_u2115] = ACTIONS(5822),
    [anon_sym_Int] = ACTIONS(5824),
    [anon_sym_u2124] = ACTIONS(5822),
    [anon_sym_Real] = ACTIONS(5824),
    [anon_sym_u211d] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_BSLASHlnot] = ACTIONS(5822),
    [anon_sym_BSLASHneg] = ACTIONS(5822),
    [anon_sym_TILDE] = ACTIONS(5824),
    [anon_sym_u00ac] = ACTIONS(5822),
    [sym_union] = ACTIONS(5824),
    [sym_powerset] = ACTIONS(5824),
    [sym_domain] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [sym_negative_dot] = ACTIONS(5822),
    [sym_enabled] = ACTIONS(5824),
    [sym_unchanged] = ACTIONS(5824),
    [anon_sym_LT_GT] = ACTIONS(5822),
    [anon_sym_u22c4] = ACTIONS(5822),
    [anon_sym_u25c7] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5822),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [anon_sym_end] = ACTIONS(5824),
    [sym__double_excl] = ACTIONS(5822),
  },
  [2568] = {
    [sym_block_comment] = STATE(2568),
    [sym_identifier] = ACTIONS(5828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_COMMA] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_INSTANCE] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_Nat] = ACTIONS(5828),
    [anon_sym_u2115] = ACTIONS(5826),
    [anon_sym_Int] = ACTIONS(5828),
    [anon_sym_u2124] = ACTIONS(5826),
    [anon_sym_Real] = ACTIONS(5828),
    [anon_sym_u211d] = ACTIONS(5826),
    [anon_sym_RBRACE] = ACTIONS(5826),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_BSLASHlnot] = ACTIONS(5826),
    [anon_sym_BSLASHneg] = ACTIONS(5826),
    [anon_sym_TILDE] = ACTIONS(5828),
    [anon_sym_u00ac] = ACTIONS(5826),
    [sym_union] = ACTIONS(5828),
    [sym_powerset] = ACTIONS(5828),
    [sym_domain] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [sym_negative_dot] = ACTIONS(5826),
    [sym_enabled] = ACTIONS(5828),
    [sym_unchanged] = ACTIONS(5828),
    [anon_sym_LT_GT] = ACTIONS(5826),
    [anon_sym_u22c4] = ACTIONS(5826),
    [anon_sym_u25c7] = ACTIONS(5826),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5826),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [anon_sym_end] = ACTIONS(5828),
    [sym__double_excl] = ACTIONS(5826),
  },
  [2569] = {
    [sym_block_comment] = STATE(2569),
    [sym_identifier] = ACTIONS(5832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_COMMA] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_INSTANCE] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_Nat] = ACTIONS(5832),
    [anon_sym_u2115] = ACTIONS(5830),
    [anon_sym_Int] = ACTIONS(5832),
    [anon_sym_u2124] = ACTIONS(5830),
    [anon_sym_Real] = ACTIONS(5832),
    [anon_sym_u211d] = ACTIONS(5830),
    [anon_sym_RBRACE] = ACTIONS(5830),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_BSLASHlnot] = ACTIONS(5830),
    [anon_sym_BSLASHneg] = ACTIONS(5830),
    [anon_sym_TILDE] = ACTIONS(5832),
    [anon_sym_u00ac] = ACTIONS(5830),
    [sym_union] = ACTIONS(5832),
    [sym_powerset] = ACTIONS(5832),
    [sym_domain] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [sym_negative_dot] = ACTIONS(5830),
    [sym_enabled] = ACTIONS(5832),
    [sym_unchanged] = ACTIONS(5832),
    [anon_sym_LT_GT] = ACTIONS(5830),
    [anon_sym_u22c4] = ACTIONS(5830),
    [anon_sym_u25c7] = ACTIONS(5830),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5830),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [anon_sym_end] = ACTIONS(5832),
    [sym__double_excl] = ACTIONS(5830),
  },
  [2570] = {
    [sym_block_comment] = STATE(2570),
    [sym_identifier] = ACTIONS(5836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_INSTANCE] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_Nat] = ACTIONS(5836),
    [anon_sym_u2115] = ACTIONS(5834),
    [anon_sym_Int] = ACTIONS(5836),
    [anon_sym_u2124] = ACTIONS(5834),
    [anon_sym_Real] = ACTIONS(5836),
    [anon_sym_u211d] = ACTIONS(5834),
    [anon_sym_RBRACE] = ACTIONS(5834),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_BSLASHlnot] = ACTIONS(5834),
    [anon_sym_BSLASHneg] = ACTIONS(5834),
    [anon_sym_TILDE] = ACTIONS(5836),
    [anon_sym_u00ac] = ACTIONS(5834),
    [sym_union] = ACTIONS(5836),
    [sym_powerset] = ACTIONS(5836),
    [sym_domain] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [sym_negative_dot] = ACTIONS(5834),
    [sym_enabled] = ACTIONS(5836),
    [sym_unchanged] = ACTIONS(5836),
    [anon_sym_LT_GT] = ACTIONS(5834),
    [anon_sym_u22c4] = ACTIONS(5834),
    [anon_sym_u25c7] = ACTIONS(5834),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5834),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [anon_sym_end] = ACTIONS(5836),
    [sym__double_excl] = ACTIONS(5834),
  },
  [2571] = {
    [sym_block_comment] = STATE(2571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_COLON] = ACTIONS(5780),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_RPAREN] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_RBRACK] = ACTIONS(5778),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_LBRACE] = ACTIONS(5778),
    [anon_sym_RBRACE] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_THEN] = ACTIONS(5778),
    [anon_sym_ELSE] = ACTIONS(5778),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5778),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [anon_sym_PROVE] = ACTIONS(5778),
    [anon_sym_end] = ACTIONS(5778),
    [anon_sym_SEMI] = ACTIONS(5778),
    [anon_sym_define] = ACTIONS(5778),
    [anon_sym_macro] = ACTIONS(5778),
    [anon_sym_procedure] = ACTIONS(5778),
    [anon_sym_fair] = ACTIONS(5778),
    [anon_sym_process] = ACTIONS(5778),
    [anon_sym_variable] = ACTIONS(5780),
    [anon_sym_variables] = ACTIONS(5778),
    [anon_sym_begin] = ACTIONS(5778),
    [anon_sym_then] = ACTIONS(5778),
    [anon_sym_elsif] = ACTIONS(5778),
    [anon_sym_else] = ACTIONS(5778),
    [anon_sym_do] = ACTIONS(5778),
    [anon_sym_or] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [2572] = {
    [sym_block_comment] = STATE(2572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_COLON] = ACTIONS(5784),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_COMMA] = ACTIONS(5782),
    [anon_sym_RPAREN] = ACTIONS(5782),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_RBRACK] = ACTIONS(5782),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_LBRACE] = ACTIONS(5782),
    [anon_sym_RBRACE] = ACTIONS(5782),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_THEN] = ACTIONS(5782),
    [anon_sym_ELSE] = ACTIONS(5782),
    [anon_sym_DASH] = ACTIONS(5784),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5782),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [anon_sym_PROVE] = ACTIONS(5782),
    [anon_sym_end] = ACTIONS(5782),
    [anon_sym_SEMI] = ACTIONS(5782),
    [anon_sym_define] = ACTIONS(5782),
    [anon_sym_macro] = ACTIONS(5782),
    [anon_sym_procedure] = ACTIONS(5782),
    [anon_sym_fair] = ACTIONS(5782),
    [anon_sym_process] = ACTIONS(5782),
    [anon_sym_variable] = ACTIONS(5784),
    [anon_sym_variables] = ACTIONS(5782),
    [anon_sym_begin] = ACTIONS(5782),
    [anon_sym_then] = ACTIONS(5782),
    [anon_sym_elsif] = ACTIONS(5782),
    [anon_sym_else] = ACTIONS(5782),
    [anon_sym_do] = ACTIONS(5782),
    [anon_sym_or] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [2573] = {
    [sym_block_comment] = STATE(2573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_COLON] = ACTIONS(5665),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_RPAREN] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_RBRACK] = ACTIONS(5663),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_LBRACE] = ACTIONS(5663),
    [anon_sym_RBRACE] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_THEN] = ACTIONS(5663),
    [anon_sym_ELSE] = ACTIONS(5663),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_PROVE] = ACTIONS(5663),
    [anon_sym_end] = ACTIONS(5663),
    [anon_sym_SEMI] = ACTIONS(5663),
    [anon_sym_define] = ACTIONS(5663),
    [anon_sym_macro] = ACTIONS(5663),
    [anon_sym_procedure] = ACTIONS(5663),
    [anon_sym_fair] = ACTIONS(5663),
    [anon_sym_process] = ACTIONS(5663),
    [anon_sym_variable] = ACTIONS(5665),
    [anon_sym_variables] = ACTIONS(5663),
    [anon_sym_begin] = ACTIONS(5663),
    [anon_sym_then] = ACTIONS(5663),
    [anon_sym_elsif] = ACTIONS(5663),
    [anon_sym_else] = ACTIONS(5663),
    [anon_sym_do] = ACTIONS(5663),
    [anon_sym_or] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2574] = {
    [sym_block_comment] = STATE(2574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_COLON] = ACTIONS(5788),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_RBRACK] = ACTIONS(5786),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_LBRACE] = ACTIONS(5786),
    [anon_sym_RBRACE] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_THEN] = ACTIONS(5786),
    [anon_sym_ELSE] = ACTIONS(5786),
    [anon_sym_DASH] = ACTIONS(5788),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5786),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [anon_sym_PROVE] = ACTIONS(5786),
    [anon_sym_end] = ACTIONS(5786),
    [anon_sym_SEMI] = ACTIONS(5786),
    [anon_sym_define] = ACTIONS(5786),
    [anon_sym_macro] = ACTIONS(5786),
    [anon_sym_procedure] = ACTIONS(5786),
    [anon_sym_fair] = ACTIONS(5786),
    [anon_sym_process] = ACTIONS(5786),
    [anon_sym_variable] = ACTIONS(5788),
    [anon_sym_variables] = ACTIONS(5786),
    [anon_sym_begin] = ACTIONS(5786),
    [anon_sym_then] = ACTIONS(5786),
    [anon_sym_elsif] = ACTIONS(5786),
    [anon_sym_else] = ACTIONS(5786),
    [anon_sym_do] = ACTIONS(5786),
    [anon_sym_or] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [2575] = {
    [sym_block_comment] = STATE(2575),
    [sym_identifier] = ACTIONS(5848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_INSTANCE] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_Nat] = ACTIONS(5848),
    [anon_sym_u2115] = ACTIONS(5846),
    [anon_sym_Int] = ACTIONS(5848),
    [anon_sym_u2124] = ACTIONS(5846),
    [anon_sym_Real] = ACTIONS(5848),
    [anon_sym_u211d] = ACTIONS(5846),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_BSLASHlnot] = ACTIONS(5846),
    [anon_sym_BSLASHneg] = ACTIONS(5846),
    [anon_sym_TILDE] = ACTIONS(5848),
    [anon_sym_u00ac] = ACTIONS(5846),
    [sym_union] = ACTIONS(5848),
    [sym_powerset] = ACTIONS(5848),
    [sym_domain] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [sym_negative_dot] = ACTIONS(5846),
    [sym_enabled] = ACTIONS(5848),
    [sym_unchanged] = ACTIONS(5848),
    [anon_sym_LT_GT] = ACTIONS(5846),
    [anon_sym_u22c4] = ACTIONS(5846),
    [anon_sym_u25c7] = ACTIONS(5846),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5846),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [anon_sym_end] = ACTIONS(5848),
    [sym__double_excl] = ACTIONS(5846),
  },
  [2576] = {
    [sym_block_comment] = STATE(2576),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_COLON] = ACTIONS(5792),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_COMMA] = ACTIONS(5790),
    [anon_sym_RPAREN] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_RBRACK] = ACTIONS(5790),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_LBRACE] = ACTIONS(5790),
    [anon_sym_RBRACE] = ACTIONS(5790),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_THEN] = ACTIONS(5790),
    [anon_sym_ELSE] = ACTIONS(5790),
    [anon_sym_DASH] = ACTIONS(5792),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5790),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [anon_sym_PROVE] = ACTIONS(5790),
    [anon_sym_end] = ACTIONS(5790),
    [anon_sym_SEMI] = ACTIONS(5790),
    [anon_sym_define] = ACTIONS(5790),
    [anon_sym_macro] = ACTIONS(5790),
    [anon_sym_procedure] = ACTIONS(5790),
    [anon_sym_fair] = ACTIONS(5790),
    [anon_sym_process] = ACTIONS(5790),
    [anon_sym_variable] = ACTIONS(5792),
    [anon_sym_variables] = ACTIONS(5790),
    [anon_sym_begin] = ACTIONS(5790),
    [anon_sym_then] = ACTIONS(5790),
    [anon_sym_elsif] = ACTIONS(5790),
    [anon_sym_else] = ACTIONS(5790),
    [anon_sym_do] = ACTIONS(5790),
    [anon_sym_or] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [2577] = {
    [sym_block_comment] = STATE(2577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_COLON] = ACTIONS(5796),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_RPAREN] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_RBRACK] = ACTIONS(5794),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(5794),
    [anon_sym_RBRACE] = ACTIONS(5794),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_THEN] = ACTIONS(5794),
    [anon_sym_ELSE] = ACTIONS(5794),
    [anon_sym_DASH] = ACTIONS(5796),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5794),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [anon_sym_PROVE] = ACTIONS(5794),
    [anon_sym_end] = ACTIONS(5794),
    [anon_sym_SEMI] = ACTIONS(5794),
    [anon_sym_define] = ACTIONS(5794),
    [anon_sym_macro] = ACTIONS(5794),
    [anon_sym_procedure] = ACTIONS(5794),
    [anon_sym_fair] = ACTIONS(5794),
    [anon_sym_process] = ACTIONS(5794),
    [anon_sym_variable] = ACTIONS(5796),
    [anon_sym_variables] = ACTIONS(5794),
    [anon_sym_begin] = ACTIONS(5794),
    [anon_sym_then] = ACTIONS(5794),
    [anon_sym_elsif] = ACTIONS(5794),
    [anon_sym_else] = ACTIONS(5794),
    [anon_sym_do] = ACTIONS(5794),
    [anon_sym_or] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [2578] = {
    [sym_block_comment] = STATE(2578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_COLON] = ACTIONS(5800),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_RBRACK] = ACTIONS(5798),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_THEN] = ACTIONS(5798),
    [anon_sym_ELSE] = ACTIONS(5798),
    [anon_sym_DASH] = ACTIONS(5800),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5798),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [anon_sym_PROVE] = ACTIONS(5798),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_define] = ACTIONS(5798),
    [anon_sym_macro] = ACTIONS(5798),
    [anon_sym_procedure] = ACTIONS(5798),
    [anon_sym_fair] = ACTIONS(5798),
    [anon_sym_process] = ACTIONS(5798),
    [anon_sym_variable] = ACTIONS(5800),
    [anon_sym_variables] = ACTIONS(5798),
    [anon_sym_begin] = ACTIONS(5798),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_elsif] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [2579] = {
    [sym_block_comment] = STATE(2579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_COLON] = ACTIONS(5804),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_COMMA] = ACTIONS(5802),
    [anon_sym_RPAREN] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_RBRACK] = ACTIONS(5802),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_LBRACE] = ACTIONS(5802),
    [anon_sym_RBRACE] = ACTIONS(5802),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_THEN] = ACTIONS(5802),
    [anon_sym_ELSE] = ACTIONS(5802),
    [anon_sym_DASH] = ACTIONS(5804),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5802),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [anon_sym_PROVE] = ACTIONS(5802),
    [anon_sym_end] = ACTIONS(5802),
    [anon_sym_SEMI] = ACTIONS(5802),
    [anon_sym_define] = ACTIONS(5802),
    [anon_sym_macro] = ACTIONS(5802),
    [anon_sym_procedure] = ACTIONS(5802),
    [anon_sym_fair] = ACTIONS(5802),
    [anon_sym_process] = ACTIONS(5802),
    [anon_sym_variable] = ACTIONS(5804),
    [anon_sym_variables] = ACTIONS(5802),
    [anon_sym_begin] = ACTIONS(5802),
    [anon_sym_then] = ACTIONS(5802),
    [anon_sym_elsif] = ACTIONS(5802),
    [anon_sym_else] = ACTIONS(5802),
    [anon_sym_do] = ACTIONS(5802),
    [anon_sym_or] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [2580] = {
    [sym_block_comment] = STATE(2580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_COLON] = ACTIONS(5349),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_RPAREN] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_RBRACK] = ACTIONS(5351),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_LBRACE] = ACTIONS(5351),
    [anon_sym_RBRACE] = ACTIONS(5351),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_THEN] = ACTIONS(5351),
    [anon_sym_ELSE] = ACTIONS(5351),
    [anon_sym_DASH] = ACTIONS(5349),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [anon_sym_PROVE] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(5351),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym_define] = ACTIONS(5351),
    [anon_sym_macro] = ACTIONS(5351),
    [anon_sym_procedure] = ACTIONS(5351),
    [anon_sym_fair] = ACTIONS(5351),
    [anon_sym_process] = ACTIONS(5351),
    [anon_sym_variable] = ACTIONS(5349),
    [anon_sym_variables] = ACTIONS(5351),
    [anon_sym_begin] = ACTIONS(5351),
    [anon_sym_then] = ACTIONS(5351),
    [anon_sym_elsif] = ACTIONS(5351),
    [anon_sym_else] = ACTIONS(5351),
    [anon_sym_do] = ACTIONS(5351),
    [anon_sym_or] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [2581] = {
    [sym_block_comment] = STATE(2581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_COLON] = ACTIONS(5758),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_RPAREN] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_RBRACK] = ACTIONS(5756),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_RBRACE] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_THEN] = ACTIONS(5756),
    [anon_sym_ELSE] = ACTIONS(5756),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5756),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [anon_sym_PROVE] = ACTIONS(5756),
    [anon_sym_end] = ACTIONS(5756),
    [anon_sym_SEMI] = ACTIONS(5756),
    [anon_sym_define] = ACTIONS(5756),
    [anon_sym_macro] = ACTIONS(5756),
    [anon_sym_procedure] = ACTIONS(5756),
    [anon_sym_fair] = ACTIONS(5756),
    [anon_sym_process] = ACTIONS(5756),
    [anon_sym_variable] = ACTIONS(5758),
    [anon_sym_variables] = ACTIONS(5756),
    [anon_sym_begin] = ACTIONS(5756),
    [anon_sym_then] = ACTIONS(5756),
    [anon_sym_elsif] = ACTIONS(5756),
    [anon_sym_else] = ACTIONS(5756),
    [anon_sym_do] = ACTIONS(5756),
    [anon_sym_or] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [2582] = {
    [sym_block_comment] = STATE(2582),
    [sym_identifier] = ACTIONS(5850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_INSTANCE] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_Nat] = ACTIONS(5850),
    [anon_sym_u2115] = ACTIONS(5852),
    [anon_sym_Int] = ACTIONS(5850),
    [anon_sym_u2124] = ACTIONS(5852),
    [anon_sym_Real] = ACTIONS(5850),
    [anon_sym_u211d] = ACTIONS(5852),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_BSLASHlnot] = ACTIONS(5852),
    [anon_sym_BSLASHneg] = ACTIONS(5852),
    [anon_sym_TILDE] = ACTIONS(5850),
    [anon_sym_u00ac] = ACTIONS(5852),
    [sym_union] = ACTIONS(5850),
    [sym_powerset] = ACTIONS(5850),
    [sym_domain] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [sym_negative_dot] = ACTIONS(5852),
    [sym_enabled] = ACTIONS(5850),
    [sym_unchanged] = ACTIONS(5850),
    [anon_sym_LT_GT] = ACTIONS(5852),
    [anon_sym_u22c4] = ACTIONS(5852),
    [anon_sym_u25c7] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5852),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [anon_sym_end] = ACTIONS(5850),
    [sym__double_excl] = ACTIONS(5852),
  },
  [2583] = {
    [sym_block_comment] = STATE(2583),
    [sym_identifier] = ACTIONS(5808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_INSTANCE] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_Nat] = ACTIONS(5808),
    [anon_sym_u2115] = ACTIONS(5806),
    [anon_sym_Int] = ACTIONS(5808),
    [anon_sym_u2124] = ACTIONS(5806),
    [anon_sym_Real] = ACTIONS(5808),
    [anon_sym_u211d] = ACTIONS(5806),
    [anon_sym_RBRACE] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_BSLASHlnot] = ACTIONS(5806),
    [anon_sym_BSLASHneg] = ACTIONS(5806),
    [anon_sym_TILDE] = ACTIONS(5808),
    [anon_sym_u00ac] = ACTIONS(5806),
    [sym_union] = ACTIONS(5808),
    [sym_powerset] = ACTIONS(5808),
    [sym_domain] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [sym_negative_dot] = ACTIONS(5806),
    [sym_enabled] = ACTIONS(5808),
    [sym_unchanged] = ACTIONS(5808),
    [anon_sym_LT_GT] = ACTIONS(5806),
    [anon_sym_u22c4] = ACTIONS(5806),
    [anon_sym_u25c7] = ACTIONS(5806),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5806),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [anon_sym_end] = ACTIONS(5808),
    [sym__double_excl] = ACTIONS(5806),
  },
  [2584] = {
    [sym_block_comment] = STATE(2584),
    [sym_identifier] = ACTIONS(5854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_INSTANCE] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_Nat] = ACTIONS(5854),
    [anon_sym_u2115] = ACTIONS(5856),
    [anon_sym_Int] = ACTIONS(5854),
    [anon_sym_u2124] = ACTIONS(5856),
    [anon_sym_Real] = ACTIONS(5854),
    [anon_sym_u211d] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_BSLASHlnot] = ACTIONS(5856),
    [anon_sym_BSLASHneg] = ACTIONS(5856),
    [anon_sym_TILDE] = ACTIONS(5854),
    [anon_sym_u00ac] = ACTIONS(5856),
    [sym_union] = ACTIONS(5854),
    [sym_powerset] = ACTIONS(5854),
    [sym_domain] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [sym_negative_dot] = ACTIONS(5856),
    [sym_enabled] = ACTIONS(5854),
    [sym_unchanged] = ACTIONS(5854),
    [anon_sym_LT_GT] = ACTIONS(5856),
    [anon_sym_u22c4] = ACTIONS(5856),
    [anon_sym_u25c7] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5856),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [anon_sym_end] = ACTIONS(5854),
    [sym__double_excl] = ACTIONS(5856),
  },
  [2585] = {
    [sym_block_comment] = STATE(2585),
    [sym_identifier] = ACTIONS(5858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_INSTANCE] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_Nat] = ACTIONS(5858),
    [anon_sym_u2115] = ACTIONS(5860),
    [anon_sym_Int] = ACTIONS(5858),
    [anon_sym_u2124] = ACTIONS(5860),
    [anon_sym_Real] = ACTIONS(5858),
    [anon_sym_u211d] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_BSLASHlnot] = ACTIONS(5860),
    [anon_sym_BSLASHneg] = ACTIONS(5860),
    [anon_sym_TILDE] = ACTIONS(5858),
    [anon_sym_u00ac] = ACTIONS(5860),
    [sym_union] = ACTIONS(5858),
    [sym_powerset] = ACTIONS(5858),
    [sym_domain] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [sym_negative_dot] = ACTIONS(5860),
    [sym_enabled] = ACTIONS(5858),
    [sym_unchanged] = ACTIONS(5858),
    [anon_sym_LT_GT] = ACTIONS(5860),
    [anon_sym_u22c4] = ACTIONS(5860),
    [anon_sym_u25c7] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5860),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [anon_sym_end] = ACTIONS(5858),
    [sym__double_excl] = ACTIONS(5860),
  },
  [2586] = {
    [sym_block_comment] = STATE(2586),
    [sym_identifier] = ACTIONS(5770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_INSTANCE] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_Nat] = ACTIONS(5770),
    [anon_sym_u2115] = ACTIONS(5768),
    [anon_sym_Int] = ACTIONS(5770),
    [anon_sym_u2124] = ACTIONS(5768),
    [anon_sym_Real] = ACTIONS(5770),
    [anon_sym_u211d] = ACTIONS(5768),
    [anon_sym_RBRACE] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_BSLASHlnot] = ACTIONS(5768),
    [anon_sym_BSLASHneg] = ACTIONS(5768),
    [anon_sym_TILDE] = ACTIONS(5770),
    [anon_sym_u00ac] = ACTIONS(5768),
    [sym_union] = ACTIONS(5770),
    [sym_powerset] = ACTIONS(5770),
    [sym_domain] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [sym_negative_dot] = ACTIONS(5768),
    [sym_enabled] = ACTIONS(5770),
    [sym_unchanged] = ACTIONS(5770),
    [anon_sym_LT_GT] = ACTIONS(5768),
    [anon_sym_u22c4] = ACTIONS(5768),
    [anon_sym_u25c7] = ACTIONS(5768),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [anon_sym_end] = ACTIONS(5770),
    [sym__double_excl] = ACTIONS(5768),
  },
  [2587] = {
    [sym_block_comment] = STATE(2587),
    [sym_identifier] = ACTIONS(5874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_COMMA] = ACTIONS(5872),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_INSTANCE] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_Nat] = ACTIONS(5874),
    [anon_sym_u2115] = ACTIONS(5872),
    [anon_sym_Int] = ACTIONS(5874),
    [anon_sym_u2124] = ACTIONS(5872),
    [anon_sym_Real] = ACTIONS(5874),
    [anon_sym_u211d] = ACTIONS(5872),
    [anon_sym_RBRACE] = ACTIONS(5872),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_BSLASHlnot] = ACTIONS(5872),
    [anon_sym_BSLASHneg] = ACTIONS(5872),
    [anon_sym_TILDE] = ACTIONS(5874),
    [anon_sym_u00ac] = ACTIONS(5872),
    [sym_union] = ACTIONS(5874),
    [sym_powerset] = ACTIONS(5874),
    [sym_domain] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [sym_negative_dot] = ACTIONS(5872),
    [sym_enabled] = ACTIONS(5874),
    [sym_unchanged] = ACTIONS(5874),
    [anon_sym_LT_GT] = ACTIONS(5872),
    [anon_sym_u22c4] = ACTIONS(5872),
    [anon_sym_u25c7] = ACTIONS(5872),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5872),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [anon_sym_end] = ACTIONS(5874),
    [sym__double_excl] = ACTIONS(5872),
  },
  [2588] = {
    [sym_block_comment] = STATE(2588),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_INSTANCE] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_end] = ACTIONS(5688),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2589] = {
    [sym_block_comment] = STATE(2589),
    [sym_identifier] = ACTIONS(5878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_COMMA] = ACTIONS(5876),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_INSTANCE] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_Nat] = ACTIONS(5878),
    [anon_sym_u2115] = ACTIONS(5876),
    [anon_sym_Int] = ACTIONS(5878),
    [anon_sym_u2124] = ACTIONS(5876),
    [anon_sym_Real] = ACTIONS(5878),
    [anon_sym_u211d] = ACTIONS(5876),
    [anon_sym_RBRACE] = ACTIONS(5876),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_BSLASHlnot] = ACTIONS(5876),
    [anon_sym_BSLASHneg] = ACTIONS(5876),
    [anon_sym_TILDE] = ACTIONS(5878),
    [anon_sym_u00ac] = ACTIONS(5876),
    [sym_union] = ACTIONS(5878),
    [sym_powerset] = ACTIONS(5878),
    [sym_domain] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [sym_negative_dot] = ACTIONS(5876),
    [sym_enabled] = ACTIONS(5878),
    [sym_unchanged] = ACTIONS(5878),
    [anon_sym_LT_GT] = ACTIONS(5876),
    [anon_sym_u22c4] = ACTIONS(5876),
    [anon_sym_u25c7] = ACTIONS(5876),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5876),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [anon_sym_end] = ACTIONS(5878),
    [sym__double_excl] = ACTIONS(5876),
  },
  [2590] = {
    [sym_block_comment] = STATE(2590),
    [sym_identifier] = ACTIONS(5758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_INSTANCE] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_Nat] = ACTIONS(5758),
    [anon_sym_u2115] = ACTIONS(5756),
    [anon_sym_Int] = ACTIONS(5758),
    [anon_sym_u2124] = ACTIONS(5756),
    [anon_sym_Real] = ACTIONS(5758),
    [anon_sym_u211d] = ACTIONS(5756),
    [anon_sym_RBRACE] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_BSLASHlnot] = ACTIONS(5756),
    [anon_sym_BSLASHneg] = ACTIONS(5756),
    [anon_sym_TILDE] = ACTIONS(5758),
    [anon_sym_u00ac] = ACTIONS(5756),
    [sym_union] = ACTIONS(5758),
    [sym_powerset] = ACTIONS(5758),
    [sym_domain] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [sym_negative_dot] = ACTIONS(5756),
    [sym_enabled] = ACTIONS(5758),
    [sym_unchanged] = ACTIONS(5758),
    [anon_sym_LT_GT] = ACTIONS(5756),
    [anon_sym_u22c4] = ACTIONS(5756),
    [anon_sym_u25c7] = ACTIONS(5756),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5756),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [anon_sym_end] = ACTIONS(5758),
    [sym__double_excl] = ACTIONS(5756),
  },
  [2591] = {
    [sym_block_comment] = STATE(2591),
    [sym_identifier] = ACTIONS(5762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_INSTANCE] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_Nat] = ACTIONS(5762),
    [anon_sym_u2115] = ACTIONS(5760),
    [anon_sym_Int] = ACTIONS(5762),
    [anon_sym_u2124] = ACTIONS(5760),
    [anon_sym_Real] = ACTIONS(5762),
    [anon_sym_u211d] = ACTIONS(5760),
    [anon_sym_RBRACE] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_BSLASHlnot] = ACTIONS(5760),
    [anon_sym_BSLASHneg] = ACTIONS(5760),
    [anon_sym_TILDE] = ACTIONS(5762),
    [anon_sym_u00ac] = ACTIONS(5760),
    [sym_union] = ACTIONS(5762),
    [sym_powerset] = ACTIONS(5762),
    [sym_domain] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [sym_negative_dot] = ACTIONS(5760),
    [sym_enabled] = ACTIONS(5762),
    [sym_unchanged] = ACTIONS(5762),
    [anon_sym_LT_GT] = ACTIONS(5760),
    [anon_sym_u22c4] = ACTIONS(5760),
    [anon_sym_u25c7] = ACTIONS(5760),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5760),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [anon_sym_end] = ACTIONS(5762),
    [sym__double_excl] = ACTIONS(5760),
  },
  [2592] = {
    [sym_block_comment] = STATE(2592),
    [sym_identifier] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_INSTANCE] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_Nat] = ACTIONS(5766),
    [anon_sym_u2115] = ACTIONS(5764),
    [anon_sym_Int] = ACTIONS(5766),
    [anon_sym_u2124] = ACTIONS(5764),
    [anon_sym_Real] = ACTIONS(5766),
    [anon_sym_u211d] = ACTIONS(5764),
    [anon_sym_RBRACE] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_BSLASHlnot] = ACTIONS(5764),
    [anon_sym_BSLASHneg] = ACTIONS(5764),
    [anon_sym_TILDE] = ACTIONS(5766),
    [anon_sym_u00ac] = ACTIONS(5764),
    [sym_union] = ACTIONS(5766),
    [sym_powerset] = ACTIONS(5766),
    [sym_domain] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [sym_negative_dot] = ACTIONS(5764),
    [sym_enabled] = ACTIONS(5766),
    [sym_unchanged] = ACTIONS(5766),
    [anon_sym_LT_GT] = ACTIONS(5764),
    [anon_sym_u22c4] = ACTIONS(5764),
    [anon_sym_u25c7] = ACTIONS(5764),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5764),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [anon_sym_end] = ACTIONS(5766),
    [sym__double_excl] = ACTIONS(5764),
  },
  [2593] = {
    [sym_block_comment] = STATE(2593),
    [sym_identifier] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_COMMA] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_INSTANCE] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_Nat] = ACTIONS(5726),
    [anon_sym_u2115] = ACTIONS(5724),
    [anon_sym_Int] = ACTIONS(5726),
    [anon_sym_u2124] = ACTIONS(5724),
    [anon_sym_Real] = ACTIONS(5726),
    [anon_sym_u211d] = ACTIONS(5724),
    [anon_sym_RBRACE] = ACTIONS(5724),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_BSLASHlnot] = ACTIONS(5724),
    [anon_sym_BSLASHneg] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5726),
    [anon_sym_u00ac] = ACTIONS(5724),
    [sym_union] = ACTIONS(5726),
    [sym_powerset] = ACTIONS(5726),
    [sym_domain] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [sym_negative_dot] = ACTIONS(5724),
    [sym_enabled] = ACTIONS(5726),
    [sym_unchanged] = ACTIONS(5726),
    [anon_sym_LT_GT] = ACTIONS(5724),
    [anon_sym_u22c4] = ACTIONS(5724),
    [anon_sym_u25c7] = ACTIONS(5724),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5724),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [anon_sym_end] = ACTIONS(5726),
    [sym__double_excl] = ACTIONS(5724),
  },
  [2594] = {
    [sym_block_comment] = STATE(2594),
    [sym_identifier] = ACTIONS(5882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_COMMA] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_INSTANCE] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_Nat] = ACTIONS(5882),
    [anon_sym_u2115] = ACTIONS(5880),
    [anon_sym_Int] = ACTIONS(5882),
    [anon_sym_u2124] = ACTIONS(5880),
    [anon_sym_Real] = ACTIONS(5882),
    [anon_sym_u211d] = ACTIONS(5880),
    [anon_sym_RBRACE] = ACTIONS(5880),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_BSLASHlnot] = ACTIONS(5880),
    [anon_sym_BSLASHneg] = ACTIONS(5880),
    [anon_sym_TILDE] = ACTIONS(5882),
    [anon_sym_u00ac] = ACTIONS(5880),
    [sym_union] = ACTIONS(5882),
    [sym_powerset] = ACTIONS(5882),
    [sym_domain] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [sym_negative_dot] = ACTIONS(5880),
    [sym_enabled] = ACTIONS(5882),
    [sym_unchanged] = ACTIONS(5882),
    [anon_sym_LT_GT] = ACTIONS(5880),
    [anon_sym_u22c4] = ACTIONS(5880),
    [anon_sym_u25c7] = ACTIONS(5880),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5880),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [anon_sym_end] = ACTIONS(5882),
    [sym__double_excl] = ACTIONS(5880),
  },
  [2595] = {
    [sym_block_comment] = STATE(2595),
    [sym_identifier] = ACTIONS(5936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_INSTANCE] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_Nat] = ACTIONS(5936),
    [anon_sym_u2115] = ACTIONS(5938),
    [anon_sym_Int] = ACTIONS(5936),
    [anon_sym_u2124] = ACTIONS(5938),
    [anon_sym_Real] = ACTIONS(5936),
    [anon_sym_u211d] = ACTIONS(5938),
    [anon_sym_RBRACE] = ACTIONS(5938),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_BSLASHlnot] = ACTIONS(5938),
    [anon_sym_BSLASHneg] = ACTIONS(5938),
    [anon_sym_TILDE] = ACTIONS(5936),
    [anon_sym_u00ac] = ACTIONS(5938),
    [sym_union] = ACTIONS(5936),
    [sym_powerset] = ACTIONS(5936),
    [sym_domain] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [sym_negative_dot] = ACTIONS(5938),
    [sym_enabled] = ACTIONS(5936),
    [sym_unchanged] = ACTIONS(5936),
    [anon_sym_LT_GT] = ACTIONS(5938),
    [anon_sym_u22c4] = ACTIONS(5938),
    [anon_sym_u25c7] = ACTIONS(5938),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5938),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [anon_sym_end] = ACTIONS(5936),
    [sym__double_excl] = ACTIONS(5938),
  },
  [2596] = {
    [sym_block_comment] = STATE(2596),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_COLON] = ACTIONS(5812),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_THEN] = ACTIONS(5810),
    [anon_sym_ELSE] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5812),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5810),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [anon_sym_PROVE] = ACTIONS(5810),
    [anon_sym_end] = ACTIONS(5810),
    [anon_sym_SEMI] = ACTIONS(5810),
    [anon_sym_define] = ACTIONS(5810),
    [anon_sym_macro] = ACTIONS(5810),
    [anon_sym_procedure] = ACTIONS(5810),
    [anon_sym_fair] = ACTIONS(5810),
    [anon_sym_process] = ACTIONS(5810),
    [anon_sym_variable] = ACTIONS(5812),
    [anon_sym_variables] = ACTIONS(5810),
    [anon_sym_begin] = ACTIONS(5810),
    [anon_sym_then] = ACTIONS(5810),
    [anon_sym_elsif] = ACTIONS(5810),
    [anon_sym_else] = ACTIONS(5810),
    [anon_sym_do] = ACTIONS(5810),
    [anon_sym_or] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [2597] = {
    [sym_block_comment] = STATE(2597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_COLON] = ACTIONS(5816),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_COMMA] = ACTIONS(5814),
    [anon_sym_RPAREN] = ACTIONS(5814),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_RBRACK] = ACTIONS(5814),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_LBRACE] = ACTIONS(5814),
    [anon_sym_RBRACE] = ACTIONS(5814),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_THEN] = ACTIONS(5814),
    [anon_sym_ELSE] = ACTIONS(5814),
    [anon_sym_DASH] = ACTIONS(5816),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5814),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [anon_sym_PROVE] = ACTIONS(5814),
    [anon_sym_end] = ACTIONS(5814),
    [anon_sym_SEMI] = ACTIONS(5814),
    [anon_sym_define] = ACTIONS(5814),
    [anon_sym_macro] = ACTIONS(5814),
    [anon_sym_procedure] = ACTIONS(5814),
    [anon_sym_fair] = ACTIONS(5814),
    [anon_sym_process] = ACTIONS(5814),
    [anon_sym_variable] = ACTIONS(5816),
    [anon_sym_variables] = ACTIONS(5814),
    [anon_sym_begin] = ACTIONS(5814),
    [anon_sym_then] = ACTIONS(5814),
    [anon_sym_elsif] = ACTIONS(5814),
    [anon_sym_else] = ACTIONS(5814),
    [anon_sym_do] = ACTIONS(5814),
    [anon_sym_or] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [2598] = {
    [sym_block_comment] = STATE(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_COLON] = ACTIONS(5820),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5818),
    [anon_sym_RPAREN] = ACTIONS(5818),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_RBRACK] = ACTIONS(5818),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_LBRACE] = ACTIONS(5818),
    [anon_sym_RBRACE] = ACTIONS(5818),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_THEN] = ACTIONS(5818),
    [anon_sym_ELSE] = ACTIONS(5818),
    [anon_sym_DASH] = ACTIONS(5820),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5818),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [anon_sym_PROVE] = ACTIONS(5818),
    [anon_sym_end] = ACTIONS(5818),
    [anon_sym_SEMI] = ACTIONS(5818),
    [anon_sym_define] = ACTIONS(5818),
    [anon_sym_macro] = ACTIONS(5818),
    [anon_sym_procedure] = ACTIONS(5818),
    [anon_sym_fair] = ACTIONS(5818),
    [anon_sym_process] = ACTIONS(5818),
    [anon_sym_variable] = ACTIONS(5820),
    [anon_sym_variables] = ACTIONS(5818),
    [anon_sym_begin] = ACTIONS(5818),
    [anon_sym_then] = ACTIONS(5818),
    [anon_sym_elsif] = ACTIONS(5818),
    [anon_sym_else] = ACTIONS(5818),
    [anon_sym_do] = ACTIONS(5818),
    [anon_sym_or] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [2599] = {
    [sym_block_comment] = STATE(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_COLON] = ACTIONS(5824),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_RBRACK] = ACTIONS(5822),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_THEN] = ACTIONS(5822),
    [anon_sym_ELSE] = ACTIONS(5822),
    [anon_sym_DASH] = ACTIONS(5824),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5822),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [anon_sym_PROVE] = ACTIONS(5822),
    [anon_sym_end] = ACTIONS(5822),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_define] = ACTIONS(5822),
    [anon_sym_macro] = ACTIONS(5822),
    [anon_sym_procedure] = ACTIONS(5822),
    [anon_sym_fair] = ACTIONS(5822),
    [anon_sym_process] = ACTIONS(5822),
    [anon_sym_variable] = ACTIONS(5824),
    [anon_sym_variables] = ACTIONS(5822),
    [anon_sym_begin] = ACTIONS(5822),
    [anon_sym_then] = ACTIONS(5822),
    [anon_sym_elsif] = ACTIONS(5822),
    [anon_sym_else] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(5822),
    [anon_sym_or] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [2600] = {
    [sym_block_comment] = STATE(2600),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_COLON] = ACTIONS(5828),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_COMMA] = ACTIONS(5826),
    [anon_sym_RPAREN] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_RBRACK] = ACTIONS(5826),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_LBRACE] = ACTIONS(5826),
    [anon_sym_RBRACE] = ACTIONS(5826),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_THEN] = ACTIONS(5826),
    [anon_sym_ELSE] = ACTIONS(5826),
    [anon_sym_DASH] = ACTIONS(5828),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5826),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [anon_sym_PROVE] = ACTIONS(5826),
    [anon_sym_end] = ACTIONS(5826),
    [anon_sym_SEMI] = ACTIONS(5826),
    [anon_sym_define] = ACTIONS(5826),
    [anon_sym_macro] = ACTIONS(5826),
    [anon_sym_procedure] = ACTIONS(5826),
    [anon_sym_fair] = ACTIONS(5826),
    [anon_sym_process] = ACTIONS(5826),
    [anon_sym_variable] = ACTIONS(5828),
    [anon_sym_variables] = ACTIONS(5826),
    [anon_sym_begin] = ACTIONS(5826),
    [anon_sym_then] = ACTIONS(5826),
    [anon_sym_elsif] = ACTIONS(5826),
    [anon_sym_else] = ACTIONS(5826),
    [anon_sym_do] = ACTIONS(5826),
    [anon_sym_or] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [2601] = {
    [sym_block_comment] = STATE(2601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_COLON] = ACTIONS(5832),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_COMMA] = ACTIONS(5830),
    [anon_sym_RPAREN] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_RBRACK] = ACTIONS(5830),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_LBRACE] = ACTIONS(5830),
    [anon_sym_RBRACE] = ACTIONS(5830),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_THEN] = ACTIONS(5830),
    [anon_sym_ELSE] = ACTIONS(5830),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5830),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [anon_sym_PROVE] = ACTIONS(5830),
    [anon_sym_end] = ACTIONS(5830),
    [anon_sym_SEMI] = ACTIONS(5830),
    [anon_sym_define] = ACTIONS(5830),
    [anon_sym_macro] = ACTIONS(5830),
    [anon_sym_procedure] = ACTIONS(5830),
    [anon_sym_fair] = ACTIONS(5830),
    [anon_sym_process] = ACTIONS(5830),
    [anon_sym_variable] = ACTIONS(5832),
    [anon_sym_variables] = ACTIONS(5830),
    [anon_sym_begin] = ACTIONS(5830),
    [anon_sym_then] = ACTIONS(5830),
    [anon_sym_elsif] = ACTIONS(5830),
    [anon_sym_else] = ACTIONS(5830),
    [anon_sym_do] = ACTIONS(5830),
    [anon_sym_or] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [2602] = {
    [sym_block_comment] = STATE(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_COLON] = ACTIONS(5836),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_RPAREN] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_RBRACK] = ACTIONS(5834),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_LBRACE] = ACTIONS(5834),
    [anon_sym_RBRACE] = ACTIONS(5834),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_THEN] = ACTIONS(5834),
    [anon_sym_ELSE] = ACTIONS(5834),
    [anon_sym_DASH] = ACTIONS(5836),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5834),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [anon_sym_PROVE] = ACTIONS(5834),
    [anon_sym_end] = ACTIONS(5834),
    [anon_sym_SEMI] = ACTIONS(5834),
    [anon_sym_define] = ACTIONS(5834),
    [anon_sym_macro] = ACTIONS(5834),
    [anon_sym_procedure] = ACTIONS(5834),
    [anon_sym_fair] = ACTIONS(5834),
    [anon_sym_process] = ACTIONS(5834),
    [anon_sym_variable] = ACTIONS(5836),
    [anon_sym_variables] = ACTIONS(5834),
    [anon_sym_begin] = ACTIONS(5834),
    [anon_sym_then] = ACTIONS(5834),
    [anon_sym_elsif] = ACTIONS(5834),
    [anon_sym_else] = ACTIONS(5834),
    [anon_sym_do] = ACTIONS(5834),
    [anon_sym_or] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [2603] = {
    [sym_block_comment] = STATE(2603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_COLON] = ACTIONS(5840),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_RPAREN] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_RBRACK] = ACTIONS(5838),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_LBRACE] = ACTIONS(5838),
    [anon_sym_RBRACE] = ACTIONS(5838),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_THEN] = ACTIONS(5838),
    [anon_sym_ELSE] = ACTIONS(5838),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5838),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [anon_sym_PROVE] = ACTIONS(5838),
    [anon_sym_end] = ACTIONS(5838),
    [anon_sym_SEMI] = ACTIONS(5838),
    [anon_sym_define] = ACTIONS(5838),
    [anon_sym_macro] = ACTIONS(5838),
    [anon_sym_procedure] = ACTIONS(5838),
    [anon_sym_fair] = ACTIONS(5838),
    [anon_sym_process] = ACTIONS(5838),
    [anon_sym_variable] = ACTIONS(5840),
    [anon_sym_variables] = ACTIONS(5838),
    [anon_sym_begin] = ACTIONS(5838),
    [anon_sym_then] = ACTIONS(5838),
    [anon_sym_elsif] = ACTIONS(5838),
    [anon_sym_else] = ACTIONS(5838),
    [anon_sym_do] = ACTIONS(5838),
    [anon_sym_or] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [2604] = {
    [sym_block_comment] = STATE(2604),
    [sym_identifier] = ACTIONS(5868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_INSTANCE] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_Nat] = ACTIONS(5868),
    [anon_sym_u2115] = ACTIONS(5870),
    [anon_sym_Int] = ACTIONS(5868),
    [anon_sym_u2124] = ACTIONS(5870),
    [anon_sym_Real] = ACTIONS(5868),
    [anon_sym_u211d] = ACTIONS(5870),
    [anon_sym_RBRACE] = ACTIONS(5870),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_BSLASHlnot] = ACTIONS(5870),
    [anon_sym_BSLASHneg] = ACTIONS(5870),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_u00ac] = ACTIONS(5870),
    [sym_union] = ACTIONS(5868),
    [sym_powerset] = ACTIONS(5868),
    [sym_domain] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [sym_negative_dot] = ACTIONS(5870),
    [sym_enabled] = ACTIONS(5868),
    [sym_unchanged] = ACTIONS(5868),
    [anon_sym_LT_GT] = ACTIONS(5870),
    [anon_sym_u22c4] = ACTIONS(5870),
    [anon_sym_u25c7] = ACTIONS(5870),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5870),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [anon_sym_end] = ACTIONS(5868),
    [sym__double_excl] = ACTIONS(5870),
  },
  [2605] = {
    [sym_block_comment] = STATE(2605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_COLON] = ACTIONS(5844),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_COMMA] = ACTIONS(5842),
    [anon_sym_RPAREN] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_RBRACK] = ACTIONS(5842),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_LBRACE] = ACTIONS(5842),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_THEN] = ACTIONS(5842),
    [anon_sym_ELSE] = ACTIONS(5842),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5842),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [anon_sym_PROVE] = ACTIONS(5842),
    [anon_sym_end] = ACTIONS(5842),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_define] = ACTIONS(5842),
    [anon_sym_macro] = ACTIONS(5842),
    [anon_sym_procedure] = ACTIONS(5842),
    [anon_sym_fair] = ACTIONS(5842),
    [anon_sym_process] = ACTIONS(5842),
    [anon_sym_variable] = ACTIONS(5844),
    [anon_sym_variables] = ACTIONS(5842),
    [anon_sym_begin] = ACTIONS(5842),
    [anon_sym_then] = ACTIONS(5842),
    [anon_sym_elsif] = ACTIONS(5842),
    [anon_sym_else] = ACTIONS(5842),
    [anon_sym_do] = ACTIONS(5842),
    [anon_sym_or] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [2606] = {
    [sym_block_comment] = STATE(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_COLON] = ACTIONS(5848),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_RPAREN] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_RBRACK] = ACTIONS(5846),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_LBRACE] = ACTIONS(5846),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_THEN] = ACTIONS(5846),
    [anon_sym_ELSE] = ACTIONS(5846),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5846),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [anon_sym_PROVE] = ACTIONS(5846),
    [anon_sym_end] = ACTIONS(5846),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_define] = ACTIONS(5846),
    [anon_sym_macro] = ACTIONS(5846),
    [anon_sym_procedure] = ACTIONS(5846),
    [anon_sym_fair] = ACTIONS(5846),
    [anon_sym_process] = ACTIONS(5846),
    [anon_sym_variable] = ACTIONS(5848),
    [anon_sym_variables] = ACTIONS(5846),
    [anon_sym_begin] = ACTIONS(5846),
    [anon_sym_then] = ACTIONS(5846),
    [anon_sym_elsif] = ACTIONS(5846),
    [anon_sym_else] = ACTIONS(5846),
    [anon_sym_do] = ACTIONS(5846),
    [anon_sym_or] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [2607] = {
    [sym_block_comment] = STATE(2607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_COLON] = ACTIONS(5864),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5862),
    [anon_sym_RPAREN] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_RBRACK] = ACTIONS(5862),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_LBRACE] = ACTIONS(5862),
    [anon_sym_RBRACE] = ACTIONS(5862),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_THEN] = ACTIONS(5862),
    [anon_sym_ELSE] = ACTIONS(5862),
    [anon_sym_DASH] = ACTIONS(5864),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5862),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [anon_sym_PROVE] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5862),
    [anon_sym_define] = ACTIONS(5862),
    [anon_sym_macro] = ACTIONS(5862),
    [anon_sym_procedure] = ACTIONS(5862),
    [anon_sym_fair] = ACTIONS(5862),
    [anon_sym_process] = ACTIONS(5862),
    [anon_sym_variable] = ACTIONS(5864),
    [anon_sym_variables] = ACTIONS(5862),
    [anon_sym_begin] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5862),
    [anon_sym_elsif] = ACTIONS(5862),
    [anon_sym_else] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5862),
    [anon_sym_or] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [2608] = {
    [sym_block_comment] = STATE(2608),
    [sym_identifier] = ACTIONS(5886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_COMMA] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_INSTANCE] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_Nat] = ACTIONS(5886),
    [anon_sym_u2115] = ACTIONS(5884),
    [anon_sym_Int] = ACTIONS(5886),
    [anon_sym_u2124] = ACTIONS(5884),
    [anon_sym_Real] = ACTIONS(5886),
    [anon_sym_u211d] = ACTIONS(5884),
    [anon_sym_RBRACE] = ACTIONS(5884),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_BSLASHlnot] = ACTIONS(5884),
    [anon_sym_BSLASHneg] = ACTIONS(5884),
    [anon_sym_TILDE] = ACTIONS(5886),
    [anon_sym_u00ac] = ACTIONS(5884),
    [sym_union] = ACTIONS(5886),
    [sym_powerset] = ACTIONS(5886),
    [sym_domain] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [sym_negative_dot] = ACTIONS(5884),
    [sym_enabled] = ACTIONS(5886),
    [sym_unchanged] = ACTIONS(5886),
    [anon_sym_LT_GT] = ACTIONS(5884),
    [anon_sym_u22c4] = ACTIONS(5884),
    [anon_sym_u25c7] = ACTIONS(5884),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5884),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [anon_sym_end] = ACTIONS(5886),
    [sym__double_excl] = ACTIONS(5884),
  },
  [2609] = {
    [sym_block_comment] = STATE(2609),
    [sym_identifier] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_COMMA] = ACTIONS(5890),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_INSTANCE] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_Nat] = ACTIONS(5888),
    [anon_sym_u2115] = ACTIONS(5890),
    [anon_sym_Int] = ACTIONS(5888),
    [anon_sym_u2124] = ACTIONS(5890),
    [anon_sym_Real] = ACTIONS(5888),
    [anon_sym_u211d] = ACTIONS(5890),
    [anon_sym_RBRACE] = ACTIONS(5890),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_BSLASHlnot] = ACTIONS(5890),
    [anon_sym_BSLASHneg] = ACTIONS(5890),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_u00ac] = ACTIONS(5890),
    [sym_union] = ACTIONS(5888),
    [sym_powerset] = ACTIONS(5888),
    [sym_domain] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [sym_negative_dot] = ACTIONS(5890),
    [sym_enabled] = ACTIONS(5888),
    [sym_unchanged] = ACTIONS(5888),
    [anon_sym_LT_GT] = ACTIONS(5890),
    [anon_sym_u22c4] = ACTIONS(5890),
    [anon_sym_u25c7] = ACTIONS(5890),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5890),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [anon_sym_end] = ACTIONS(5888),
    [sym__double_excl] = ACTIONS(5890),
  },
  [2610] = {
    [sym_block_comment] = STATE(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_COLON] = ACTIONS(5874),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_COMMA] = ACTIONS(5872),
    [anon_sym_RPAREN] = ACTIONS(5872),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_RBRACK] = ACTIONS(5872),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_LBRACE] = ACTIONS(5872),
    [anon_sym_RBRACE] = ACTIONS(5872),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_THEN] = ACTIONS(5872),
    [anon_sym_ELSE] = ACTIONS(5872),
    [anon_sym_DASH] = ACTIONS(5874),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5872),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [anon_sym_PROVE] = ACTIONS(5872),
    [anon_sym_end] = ACTIONS(5872),
    [anon_sym_SEMI] = ACTIONS(5872),
    [anon_sym_define] = ACTIONS(5872),
    [anon_sym_macro] = ACTIONS(5872),
    [anon_sym_procedure] = ACTIONS(5872),
    [anon_sym_fair] = ACTIONS(5872),
    [anon_sym_process] = ACTIONS(5872),
    [anon_sym_variable] = ACTIONS(5874),
    [anon_sym_variables] = ACTIONS(5872),
    [anon_sym_begin] = ACTIONS(5872),
    [anon_sym_then] = ACTIONS(5872),
    [anon_sym_elsif] = ACTIONS(5872),
    [anon_sym_else] = ACTIONS(5872),
    [anon_sym_do] = ACTIONS(5872),
    [anon_sym_or] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [2611] = {
    [sym_block_comment] = STATE(2611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_COLON] = ACTIONS(5878),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_COMMA] = ACTIONS(5876),
    [anon_sym_RPAREN] = ACTIONS(5876),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_RBRACK] = ACTIONS(5876),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_LBRACE] = ACTIONS(5876),
    [anon_sym_RBRACE] = ACTIONS(5876),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_THEN] = ACTIONS(5876),
    [anon_sym_ELSE] = ACTIONS(5876),
    [anon_sym_DASH] = ACTIONS(5878),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5876),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [anon_sym_PROVE] = ACTIONS(5876),
    [anon_sym_end] = ACTIONS(5876),
    [anon_sym_SEMI] = ACTIONS(5876),
    [anon_sym_define] = ACTIONS(5876),
    [anon_sym_macro] = ACTIONS(5876),
    [anon_sym_procedure] = ACTIONS(5876),
    [anon_sym_fair] = ACTIONS(5876),
    [anon_sym_process] = ACTIONS(5876),
    [anon_sym_variable] = ACTIONS(5878),
    [anon_sym_variables] = ACTIONS(5876),
    [anon_sym_begin] = ACTIONS(5876),
    [anon_sym_then] = ACTIONS(5876),
    [anon_sym_elsif] = ACTIONS(5876),
    [anon_sym_else] = ACTIONS(5876),
    [anon_sym_do] = ACTIONS(5876),
    [anon_sym_or] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [2612] = {
    [sym_block_comment] = STATE(2612),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_RECURSIVE] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_IN] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2613] = {
    [sym_block_comment] = STATE(2613),
    [sym_identifier] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_INSTANCE] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_Nat] = ACTIONS(5730),
    [anon_sym_u2115] = ACTIONS(5728),
    [anon_sym_Int] = ACTIONS(5730),
    [anon_sym_u2124] = ACTIONS(5728),
    [anon_sym_Real] = ACTIONS(5730),
    [anon_sym_u211d] = ACTIONS(5728),
    [anon_sym_RBRACE] = ACTIONS(5728),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_BSLASHlnot] = ACTIONS(5728),
    [anon_sym_BSLASHneg] = ACTIONS(5728),
    [anon_sym_TILDE] = ACTIONS(5730),
    [anon_sym_u00ac] = ACTIONS(5728),
    [sym_union] = ACTIONS(5730),
    [sym_powerset] = ACTIONS(5730),
    [sym_domain] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [sym_negative_dot] = ACTIONS(5728),
    [sym_enabled] = ACTIONS(5730),
    [sym_unchanged] = ACTIONS(5730),
    [anon_sym_LT_GT] = ACTIONS(5728),
    [anon_sym_u22c4] = ACTIONS(5728),
    [anon_sym_u25c7] = ACTIONS(5728),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5728),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [anon_sym_end] = ACTIONS(5730),
    [sym__double_excl] = ACTIONS(5728),
  },
  [2614] = {
    [sym_block_comment] = STATE(2614),
    [sym_identifier] = ACTIONS(5734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_COMMA] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_INSTANCE] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_Nat] = ACTIONS(5734),
    [anon_sym_u2115] = ACTIONS(5732),
    [anon_sym_Int] = ACTIONS(5734),
    [anon_sym_u2124] = ACTIONS(5732),
    [anon_sym_Real] = ACTIONS(5734),
    [anon_sym_u211d] = ACTIONS(5732),
    [anon_sym_RBRACE] = ACTIONS(5732),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_BSLASHlnot] = ACTIONS(5732),
    [anon_sym_BSLASHneg] = ACTIONS(5732),
    [anon_sym_TILDE] = ACTIONS(5734),
    [anon_sym_u00ac] = ACTIONS(5732),
    [sym_union] = ACTIONS(5734),
    [sym_powerset] = ACTIONS(5734),
    [sym_domain] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [sym_negative_dot] = ACTIONS(5732),
    [sym_enabled] = ACTIONS(5734),
    [sym_unchanged] = ACTIONS(5734),
    [anon_sym_LT_GT] = ACTIONS(5732),
    [anon_sym_u22c4] = ACTIONS(5732),
    [anon_sym_u25c7] = ACTIONS(5732),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5732),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [anon_sym_end] = ACTIONS(5734),
    [sym__double_excl] = ACTIONS(5732),
  },
  [2615] = {
    [sym_block_comment] = STATE(2615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_COLON] = ACTIONS(5882),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_COMMA] = ACTIONS(5880),
    [anon_sym_RPAREN] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_RBRACK] = ACTIONS(5880),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_LBRACE] = ACTIONS(5880),
    [anon_sym_RBRACE] = ACTIONS(5880),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_THEN] = ACTIONS(5880),
    [anon_sym_ELSE] = ACTIONS(5880),
    [anon_sym_DASH] = ACTIONS(5882),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5880),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [anon_sym_PROVE] = ACTIONS(5880),
    [anon_sym_end] = ACTIONS(5880),
    [anon_sym_SEMI] = ACTIONS(5880),
    [anon_sym_define] = ACTIONS(5880),
    [anon_sym_macro] = ACTIONS(5880),
    [anon_sym_procedure] = ACTIONS(5880),
    [anon_sym_fair] = ACTIONS(5880),
    [anon_sym_process] = ACTIONS(5880),
    [anon_sym_variable] = ACTIONS(5882),
    [anon_sym_variables] = ACTIONS(5880),
    [anon_sym_begin] = ACTIONS(5880),
    [anon_sym_then] = ACTIONS(5880),
    [anon_sym_elsif] = ACTIONS(5880),
    [anon_sym_else] = ACTIONS(5880),
    [anon_sym_do] = ACTIONS(5880),
    [anon_sym_or] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [2616] = {
    [sym_block_comment] = STATE(2616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_COLON] = ACTIONS(5936),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_RPAREN] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_RBRACK] = ACTIONS(5938),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(5938),
    [anon_sym_RBRACE] = ACTIONS(5938),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_THEN] = ACTIONS(5938),
    [anon_sym_ELSE] = ACTIONS(5938),
    [anon_sym_DASH] = ACTIONS(5936),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5938),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [anon_sym_PROVE] = ACTIONS(5938),
    [anon_sym_end] = ACTIONS(5938),
    [anon_sym_SEMI] = ACTIONS(5938),
    [anon_sym_define] = ACTIONS(5938),
    [anon_sym_macro] = ACTIONS(5938),
    [anon_sym_procedure] = ACTIONS(5938),
    [anon_sym_fair] = ACTIONS(5938),
    [anon_sym_process] = ACTIONS(5938),
    [anon_sym_variable] = ACTIONS(5936),
    [anon_sym_variables] = ACTIONS(5938),
    [anon_sym_begin] = ACTIONS(5938),
    [anon_sym_then] = ACTIONS(5938),
    [anon_sym_elsif] = ACTIONS(5938),
    [anon_sym_else] = ACTIONS(5938),
    [anon_sym_do] = ACTIONS(5938),
    [anon_sym_or] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [2617] = {
    [sym_block_comment] = STATE(2617),
    [sym_identifier] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_INSTANCE] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_Nat] = ACTIONS(5742),
    [anon_sym_u2115] = ACTIONS(5740),
    [anon_sym_Int] = ACTIONS(5742),
    [anon_sym_u2124] = ACTIONS(5740),
    [anon_sym_Real] = ACTIONS(5742),
    [anon_sym_u211d] = ACTIONS(5740),
    [anon_sym_RBRACE] = ACTIONS(5740),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_BSLASHlnot] = ACTIONS(5740),
    [anon_sym_BSLASHneg] = ACTIONS(5740),
    [anon_sym_TILDE] = ACTIONS(5742),
    [anon_sym_u00ac] = ACTIONS(5740),
    [sym_union] = ACTIONS(5742),
    [sym_powerset] = ACTIONS(5742),
    [sym_domain] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [sym_negative_dot] = ACTIONS(5740),
    [sym_enabled] = ACTIONS(5742),
    [sym_unchanged] = ACTIONS(5742),
    [anon_sym_LT_GT] = ACTIONS(5740),
    [anon_sym_u22c4] = ACTIONS(5740),
    [anon_sym_u25c7] = ACTIONS(5740),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5740),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [anon_sym_end] = ACTIONS(5742),
    [sym__double_excl] = ACTIONS(5740),
  },
  [2618] = {
    [sym_block_comment] = STATE(2618),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_COLON] = ACTIONS(5886),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_COMMA] = ACTIONS(5884),
    [anon_sym_RPAREN] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_RBRACK] = ACTIONS(5884),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_LBRACE] = ACTIONS(5884),
    [anon_sym_RBRACE] = ACTIONS(5884),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_THEN] = ACTIONS(5884),
    [anon_sym_ELSE] = ACTIONS(5884),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5884),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [anon_sym_PROVE] = ACTIONS(5884),
    [anon_sym_end] = ACTIONS(5884),
    [anon_sym_SEMI] = ACTIONS(5884),
    [anon_sym_define] = ACTIONS(5884),
    [anon_sym_macro] = ACTIONS(5884),
    [anon_sym_procedure] = ACTIONS(5884),
    [anon_sym_fair] = ACTIONS(5884),
    [anon_sym_process] = ACTIONS(5884),
    [anon_sym_variable] = ACTIONS(5886),
    [anon_sym_variables] = ACTIONS(5884),
    [anon_sym_begin] = ACTIONS(5884),
    [anon_sym_then] = ACTIONS(5884),
    [anon_sym_elsif] = ACTIONS(5884),
    [anon_sym_else] = ACTIONS(5884),
    [anon_sym_do] = ACTIONS(5884),
    [anon_sym_or] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [2619] = {
    [sym_block_comment] = STATE(2619),
    [sym_identifier] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_INSTANCE] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_Nat] = ACTIONS(5746),
    [anon_sym_u2115] = ACTIONS(5744),
    [anon_sym_Int] = ACTIONS(5746),
    [anon_sym_u2124] = ACTIONS(5744),
    [anon_sym_Real] = ACTIONS(5746),
    [anon_sym_u211d] = ACTIONS(5744),
    [anon_sym_RBRACE] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_BSLASHlnot] = ACTIONS(5744),
    [anon_sym_BSLASHneg] = ACTIONS(5744),
    [anon_sym_TILDE] = ACTIONS(5746),
    [anon_sym_u00ac] = ACTIONS(5744),
    [sym_union] = ACTIONS(5746),
    [sym_powerset] = ACTIONS(5746),
    [sym_domain] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [sym_negative_dot] = ACTIONS(5744),
    [sym_enabled] = ACTIONS(5746),
    [sym_unchanged] = ACTIONS(5746),
    [anon_sym_LT_GT] = ACTIONS(5744),
    [anon_sym_u22c4] = ACTIONS(5744),
    [anon_sym_u25c7] = ACTIONS(5744),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5744),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [anon_sym_end] = ACTIONS(5746),
    [sym__double_excl] = ACTIONS(5744),
  },
  [2620] = {
    [sym_block_comment] = STATE(2620),
    [sym_identifier] = ACTIONS(5940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_INSTANCE] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_Nat] = ACTIONS(5940),
    [anon_sym_u2115] = ACTIONS(5942),
    [anon_sym_Int] = ACTIONS(5940),
    [anon_sym_u2124] = ACTIONS(5942),
    [anon_sym_Real] = ACTIONS(5940),
    [anon_sym_u211d] = ACTIONS(5942),
    [anon_sym_RBRACE] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_BSLASHlnot] = ACTIONS(5942),
    [anon_sym_BSLASHneg] = ACTIONS(5942),
    [anon_sym_TILDE] = ACTIONS(5940),
    [anon_sym_u00ac] = ACTIONS(5942),
    [sym_union] = ACTIONS(5940),
    [sym_powerset] = ACTIONS(5940),
    [sym_domain] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [sym_negative_dot] = ACTIONS(5942),
    [sym_enabled] = ACTIONS(5940),
    [sym_unchanged] = ACTIONS(5940),
    [anon_sym_LT_GT] = ACTIONS(5942),
    [anon_sym_u22c4] = ACTIONS(5942),
    [anon_sym_u25c7] = ACTIONS(5942),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5942),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [anon_sym_end] = ACTIONS(5940),
    [sym__double_excl] = ACTIONS(5942),
  },
  [2621] = {
    [sym_block_comment] = STATE(2621),
    [sym_identifier] = ACTIONS(5754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_INSTANCE] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_Nat] = ACTIONS(5754),
    [anon_sym_u2115] = ACTIONS(5752),
    [anon_sym_Int] = ACTIONS(5754),
    [anon_sym_u2124] = ACTIONS(5752),
    [anon_sym_Real] = ACTIONS(5754),
    [anon_sym_u211d] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_BSLASHlnot] = ACTIONS(5752),
    [anon_sym_BSLASHneg] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(5754),
    [anon_sym_u00ac] = ACTIONS(5752),
    [sym_union] = ACTIONS(5754),
    [sym_powerset] = ACTIONS(5754),
    [sym_domain] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [sym_negative_dot] = ACTIONS(5752),
    [sym_enabled] = ACTIONS(5754),
    [sym_unchanged] = ACTIONS(5754),
    [anon_sym_LT_GT] = ACTIONS(5752),
    [anon_sym_u22c4] = ACTIONS(5752),
    [anon_sym_u25c7] = ACTIONS(5752),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5752),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [anon_sym_end] = ACTIONS(5754),
    [sym__double_excl] = ACTIONS(5752),
  },
  [2622] = {
    [sym_block_comment] = STATE(2622),
    [sym_identifier] = ACTIONS(5702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_COMMA] = ACTIONS(5700),
    [anon_sym_RECURSIVE] = ACTIONS(5702),
    [anon_sym_LPAREN] = ACTIONS(5956),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_Nat] = ACTIONS(5702),
    [anon_sym_u2115] = ACTIONS(5700),
    [anon_sym_Int] = ACTIONS(5702),
    [anon_sym_u2124] = ACTIONS(5700),
    [anon_sym_Real] = ACTIONS(5702),
    [anon_sym_u211d] = ACTIONS(5700),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_IN] = ACTIONS(5702),
    [anon_sym_BSLASHlnot] = ACTIONS(5700),
    [anon_sym_BSLASHneg] = ACTIONS(5700),
    [anon_sym_TILDE] = ACTIONS(5702),
    [anon_sym_u00ac] = ACTIONS(5700),
    [sym_union] = ACTIONS(5702),
    [sym_powerset] = ACTIONS(5702),
    [sym_domain] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [sym_negative_dot] = ACTIONS(5700),
    [sym_enabled] = ACTIONS(5702),
    [sym_unchanged] = ACTIONS(5702),
    [anon_sym_LT_GT] = ACTIONS(5700),
    [anon_sym_u22c4] = ACTIONS(5700),
    [anon_sym_u25c7] = ACTIONS(5700),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5700),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [2623] = {
    [sym_block_comment] = STATE(2623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_COLON] = ACTIONS(5894),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_RPAREN] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_RBRACK] = ACTIONS(5892),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(5892),
    [anon_sym_RBRACE] = ACTIONS(5892),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_THEN] = ACTIONS(5892),
    [anon_sym_ELSE] = ACTIONS(5892),
    [anon_sym_DASH] = ACTIONS(5894),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [anon_sym_PROVE] = ACTIONS(5892),
    [anon_sym_end] = ACTIONS(5892),
    [anon_sym_SEMI] = ACTIONS(5892),
    [anon_sym_define] = ACTIONS(5892),
    [anon_sym_macro] = ACTIONS(5892),
    [anon_sym_procedure] = ACTIONS(5892),
    [anon_sym_fair] = ACTIONS(5892),
    [anon_sym_process] = ACTIONS(5892),
    [anon_sym_variable] = ACTIONS(5894),
    [anon_sym_variables] = ACTIONS(5892),
    [anon_sym_begin] = ACTIONS(5892),
    [anon_sym_then] = ACTIONS(5892),
    [anon_sym_elsif] = ACTIONS(5892),
    [anon_sym_else] = ACTIONS(5892),
    [anon_sym_do] = ACTIONS(5892),
    [anon_sym_or] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [2624] = {
    [sym_block_comment] = STATE(2624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_COLON] = ACTIONS(5898),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_COMMA] = ACTIONS(5896),
    [anon_sym_RPAREN] = ACTIONS(5896),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_RBRACK] = ACTIONS(5896),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_RBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_THEN] = ACTIONS(5896),
    [anon_sym_ELSE] = ACTIONS(5896),
    [anon_sym_DASH] = ACTIONS(5898),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [anon_sym_PROVE] = ACTIONS(5896),
    [anon_sym_end] = ACTIONS(5896),
    [anon_sym_SEMI] = ACTIONS(5896),
    [anon_sym_define] = ACTIONS(5896),
    [anon_sym_macro] = ACTIONS(5896),
    [anon_sym_procedure] = ACTIONS(5896),
    [anon_sym_fair] = ACTIONS(5896),
    [anon_sym_process] = ACTIONS(5896),
    [anon_sym_variable] = ACTIONS(5898),
    [anon_sym_variables] = ACTIONS(5896),
    [anon_sym_begin] = ACTIONS(5896),
    [anon_sym_then] = ACTIONS(5896),
    [anon_sym_elsif] = ACTIONS(5896),
    [anon_sym_else] = ACTIONS(5896),
    [anon_sym_do] = ACTIONS(5896),
    [anon_sym_or] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [2625] = {
    [sym_block_comment] = STATE(2625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_COLON] = ACTIONS(5902),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_COMMA] = ACTIONS(5900),
    [anon_sym_RPAREN] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_RBRACK] = ACTIONS(5900),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(5900),
    [anon_sym_RBRACE] = ACTIONS(5900),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_THEN] = ACTIONS(5900),
    [anon_sym_ELSE] = ACTIONS(5900),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [anon_sym_PROVE] = ACTIONS(5900),
    [anon_sym_end] = ACTIONS(5900),
    [anon_sym_SEMI] = ACTIONS(5900),
    [anon_sym_define] = ACTIONS(5900),
    [anon_sym_macro] = ACTIONS(5900),
    [anon_sym_procedure] = ACTIONS(5900),
    [anon_sym_fair] = ACTIONS(5900),
    [anon_sym_process] = ACTIONS(5900),
    [anon_sym_variable] = ACTIONS(5902),
    [anon_sym_variables] = ACTIONS(5900),
    [anon_sym_begin] = ACTIONS(5900),
    [anon_sym_then] = ACTIONS(5900),
    [anon_sym_elsif] = ACTIONS(5900),
    [anon_sym_else] = ACTIONS(5900),
    [anon_sym_do] = ACTIONS(5900),
    [anon_sym_or] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [2626] = {
    [sym_block_comment] = STATE(2626),
    [sym_identifier] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_INSTANCE] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_Nat] = ACTIONS(5349),
    [anon_sym_u2115] = ACTIONS(5351),
    [anon_sym_Int] = ACTIONS(5349),
    [anon_sym_u2124] = ACTIONS(5351),
    [anon_sym_Real] = ACTIONS(5349),
    [anon_sym_u211d] = ACTIONS(5351),
    [anon_sym_RBRACE] = ACTIONS(5351),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_BSLASHlnot] = ACTIONS(5351),
    [anon_sym_BSLASHneg] = ACTIONS(5351),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_u00ac] = ACTIONS(5351),
    [sym_union] = ACTIONS(5349),
    [sym_powerset] = ACTIONS(5349),
    [sym_domain] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [sym_negative_dot] = ACTIONS(5351),
    [sym_enabled] = ACTIONS(5349),
    [sym_unchanged] = ACTIONS(5349),
    [anon_sym_LT_GT] = ACTIONS(5351),
    [anon_sym_u22c4] = ACTIONS(5351),
    [anon_sym_u25c7] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [anon_sym_end] = ACTIONS(5349),
    [sym__double_excl] = ACTIONS(5351),
  },
  [2627] = {
    [sym_block_comment] = STATE(2627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_COLON] = ACTIONS(5762),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_RPAREN] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_RBRACK] = ACTIONS(5760),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_LBRACE] = ACTIONS(5760),
    [anon_sym_RBRACE] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_THEN] = ACTIONS(5760),
    [anon_sym_ELSE] = ACTIONS(5760),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5760),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [anon_sym_PROVE] = ACTIONS(5760),
    [anon_sym_end] = ACTIONS(5760),
    [anon_sym_SEMI] = ACTIONS(5760),
    [anon_sym_define] = ACTIONS(5760),
    [anon_sym_macro] = ACTIONS(5760),
    [anon_sym_procedure] = ACTIONS(5760),
    [anon_sym_fair] = ACTIONS(5760),
    [anon_sym_process] = ACTIONS(5760),
    [anon_sym_variable] = ACTIONS(5762),
    [anon_sym_variables] = ACTIONS(5760),
    [anon_sym_begin] = ACTIONS(5760),
    [anon_sym_then] = ACTIONS(5760),
    [anon_sym_elsif] = ACTIONS(5760),
    [anon_sym_else] = ACTIONS(5760),
    [anon_sym_do] = ACTIONS(5760),
    [anon_sym_or] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [2628] = {
    [sym_block_comment] = STATE(2628),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_INSTANCE] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_RBRACE] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_end] = ACTIONS(5665),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2629] = {
    [sym_block_comment] = STATE(2629),
    [sym_identifier] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_INSTANCE] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_Nat] = ACTIONS(5788),
    [anon_sym_u2115] = ACTIONS(5786),
    [anon_sym_Int] = ACTIONS(5788),
    [anon_sym_u2124] = ACTIONS(5786),
    [anon_sym_Real] = ACTIONS(5788),
    [anon_sym_u211d] = ACTIONS(5786),
    [anon_sym_RBRACE] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_BSLASHlnot] = ACTIONS(5786),
    [anon_sym_BSLASHneg] = ACTIONS(5786),
    [anon_sym_TILDE] = ACTIONS(5788),
    [anon_sym_u00ac] = ACTIONS(5786),
    [sym_union] = ACTIONS(5788),
    [sym_powerset] = ACTIONS(5788),
    [sym_domain] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [sym_negative_dot] = ACTIONS(5786),
    [sym_enabled] = ACTIONS(5788),
    [sym_unchanged] = ACTIONS(5788),
    [anon_sym_LT_GT] = ACTIONS(5786),
    [anon_sym_u22c4] = ACTIONS(5786),
    [anon_sym_u25c7] = ACTIONS(5786),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5786),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [anon_sym_end] = ACTIONS(5788),
    [sym__double_excl] = ACTIONS(5786),
  },
  [2630] = {
    [sym_block_comment] = STATE(2630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_COLON] = ACTIONS(5906),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_RPAREN] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_RBRACK] = ACTIONS(5904),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_LBRACE] = ACTIONS(5904),
    [anon_sym_RBRACE] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_THEN] = ACTIONS(5904),
    [anon_sym_ELSE] = ACTIONS(5904),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [anon_sym_PROVE] = ACTIONS(5904),
    [anon_sym_end] = ACTIONS(5904),
    [anon_sym_SEMI] = ACTIONS(5904),
    [anon_sym_define] = ACTIONS(5904),
    [anon_sym_macro] = ACTIONS(5904),
    [anon_sym_procedure] = ACTIONS(5904),
    [anon_sym_fair] = ACTIONS(5904),
    [anon_sym_process] = ACTIONS(5904),
    [anon_sym_variable] = ACTIONS(5906),
    [anon_sym_variables] = ACTIONS(5904),
    [anon_sym_begin] = ACTIONS(5904),
    [anon_sym_then] = ACTIONS(5904),
    [anon_sym_elsif] = ACTIONS(5904),
    [anon_sym_else] = ACTIONS(5904),
    [anon_sym_do] = ACTIONS(5904),
    [anon_sym_or] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [2631] = {
    [sym_block_comment] = STATE(2631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_COLON] = ACTIONS(5940),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_RPAREN] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_RBRACK] = ACTIONS(5942),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_LBRACE] = ACTIONS(5942),
    [anon_sym_RBRACE] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_THEN] = ACTIONS(5942),
    [anon_sym_ELSE] = ACTIONS(5942),
    [anon_sym_DASH] = ACTIONS(5940),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5942),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [anon_sym_PROVE] = ACTIONS(5942),
    [anon_sym_end] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(5942),
    [anon_sym_define] = ACTIONS(5942),
    [anon_sym_macro] = ACTIONS(5942),
    [anon_sym_procedure] = ACTIONS(5942),
    [anon_sym_fair] = ACTIONS(5942),
    [anon_sym_process] = ACTIONS(5942),
    [anon_sym_variable] = ACTIONS(5940),
    [anon_sym_variables] = ACTIONS(5942),
    [anon_sym_begin] = ACTIONS(5942),
    [anon_sym_then] = ACTIONS(5942),
    [anon_sym_elsif] = ACTIONS(5942),
    [anon_sym_else] = ACTIONS(5942),
    [anon_sym_do] = ACTIONS(5942),
    [anon_sym_or] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [2632] = {
    [sym_block_comment] = STATE(2632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_COLON] = ACTIONS(5766),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_RPAREN] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_RBRACK] = ACTIONS(5764),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(5764),
    [anon_sym_RBRACE] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_THEN] = ACTIONS(5764),
    [anon_sym_ELSE] = ACTIONS(5764),
    [anon_sym_DASH] = ACTIONS(5766),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5764),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [anon_sym_PROVE] = ACTIONS(5764),
    [anon_sym_end] = ACTIONS(5764),
    [anon_sym_SEMI] = ACTIONS(5764),
    [anon_sym_define] = ACTIONS(5764),
    [anon_sym_macro] = ACTIONS(5764),
    [anon_sym_procedure] = ACTIONS(5764),
    [anon_sym_fair] = ACTIONS(5764),
    [anon_sym_process] = ACTIONS(5764),
    [anon_sym_variable] = ACTIONS(5766),
    [anon_sym_variables] = ACTIONS(5764),
    [anon_sym_begin] = ACTIONS(5764),
    [anon_sym_then] = ACTIONS(5764),
    [anon_sym_elsif] = ACTIONS(5764),
    [anon_sym_else] = ACTIONS(5764),
    [anon_sym_do] = ACTIONS(5764),
    [anon_sym_or] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [2633] = {
    [sym_block_comment] = STATE(2633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_COLON] = ACTIONS(5726),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_COMMA] = ACTIONS(5724),
    [anon_sym_RPAREN] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_RBRACK] = ACTIONS(5724),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_LBRACE] = ACTIONS(5724),
    [anon_sym_RBRACE] = ACTIONS(5724),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_THEN] = ACTIONS(5724),
    [anon_sym_ELSE] = ACTIONS(5724),
    [anon_sym_DASH] = ACTIONS(5726),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5724),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [anon_sym_PROVE] = ACTIONS(5724),
    [anon_sym_end] = ACTIONS(5724),
    [anon_sym_SEMI] = ACTIONS(5724),
    [anon_sym_define] = ACTIONS(5724),
    [anon_sym_macro] = ACTIONS(5724),
    [anon_sym_procedure] = ACTIONS(5724),
    [anon_sym_fair] = ACTIONS(5724),
    [anon_sym_process] = ACTIONS(5724),
    [anon_sym_variable] = ACTIONS(5726),
    [anon_sym_variables] = ACTIONS(5724),
    [anon_sym_begin] = ACTIONS(5724),
    [anon_sym_then] = ACTIONS(5724),
    [anon_sym_elsif] = ACTIONS(5724),
    [anon_sym_else] = ACTIONS(5724),
    [anon_sym_do] = ACTIONS(5724),
    [anon_sym_or] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [2634] = {
    [sym_block_comment] = STATE(2634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_COLON] = ACTIONS(5774),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_RPAREN] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_RBRACK] = ACTIONS(5772),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_LBRACE] = ACTIONS(5772),
    [anon_sym_RBRACE] = ACTIONS(5772),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_THEN] = ACTIONS(5772),
    [anon_sym_ELSE] = ACTIONS(5772),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5772),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [anon_sym_PROVE] = ACTIONS(5772),
    [anon_sym_end] = ACTIONS(5772),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_define] = ACTIONS(5772),
    [anon_sym_macro] = ACTIONS(5772),
    [anon_sym_procedure] = ACTIONS(5772),
    [anon_sym_fair] = ACTIONS(5772),
    [anon_sym_process] = ACTIONS(5772),
    [anon_sym_variable] = ACTIONS(5774),
    [anon_sym_variables] = ACTIONS(5772),
    [anon_sym_begin] = ACTIONS(5772),
    [anon_sym_then] = ACTIONS(5772),
    [anon_sym_elsif] = ACTIONS(5772),
    [anon_sym_else] = ACTIONS(5772),
    [anon_sym_do] = ACTIONS(5772),
    [anon_sym_or] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [2635] = {
    [sym_block_comment] = STATE(2635),
    [sym_identifier] = ACTIONS(5804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_COMMA] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_INSTANCE] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_Nat] = ACTIONS(5804),
    [anon_sym_u2115] = ACTIONS(5802),
    [anon_sym_Int] = ACTIONS(5804),
    [anon_sym_u2124] = ACTIONS(5802),
    [anon_sym_Real] = ACTIONS(5804),
    [anon_sym_u211d] = ACTIONS(5802),
    [anon_sym_RBRACE] = ACTIONS(5802),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_BSLASHlnot] = ACTIONS(5802),
    [anon_sym_BSLASHneg] = ACTIONS(5802),
    [anon_sym_TILDE] = ACTIONS(5804),
    [anon_sym_u00ac] = ACTIONS(5802),
    [sym_union] = ACTIONS(5804),
    [sym_powerset] = ACTIONS(5804),
    [sym_domain] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [sym_negative_dot] = ACTIONS(5802),
    [sym_enabled] = ACTIONS(5804),
    [sym_unchanged] = ACTIONS(5804),
    [anon_sym_LT_GT] = ACTIONS(5802),
    [anon_sym_u22c4] = ACTIONS(5802),
    [anon_sym_u25c7] = ACTIONS(5802),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5802),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [anon_sym_end] = ACTIONS(5804),
    [sym__double_excl] = ACTIONS(5802),
  },
  [2636] = {
    [sym_block_comment] = STATE(2636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_COLON] = ACTIONS(5688),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_RPAREN] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_RBRACK] = ACTIONS(5690),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_LBRACE] = ACTIONS(5690),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_THEN] = ACTIONS(5690),
    [anon_sym_ELSE] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_PROVE] = ACTIONS(5690),
    [anon_sym_end] = ACTIONS(5690),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_define] = ACTIONS(5690),
    [anon_sym_macro] = ACTIONS(5690),
    [anon_sym_procedure] = ACTIONS(5690),
    [anon_sym_fair] = ACTIONS(5690),
    [anon_sym_process] = ACTIONS(5690),
    [anon_sym_variable] = ACTIONS(5688),
    [anon_sym_variables] = ACTIONS(5690),
    [anon_sym_begin] = ACTIONS(5690),
    [anon_sym_then] = ACTIONS(5690),
    [anon_sym_elsif] = ACTIONS(5690),
    [anon_sym_else] = ACTIONS(5690),
    [anon_sym_do] = ACTIONS(5690),
    [anon_sym_or] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2637] = {
    [sym_block_comment] = STATE(2637),
    [sym_identifier] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_INSTANCE] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_Nat] = ACTIONS(5840),
    [anon_sym_u2115] = ACTIONS(5838),
    [anon_sym_Int] = ACTIONS(5840),
    [anon_sym_u2124] = ACTIONS(5838),
    [anon_sym_Real] = ACTIONS(5840),
    [anon_sym_u211d] = ACTIONS(5838),
    [anon_sym_RBRACE] = ACTIONS(5838),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_BSLASHlnot] = ACTIONS(5838),
    [anon_sym_BSLASHneg] = ACTIONS(5838),
    [anon_sym_TILDE] = ACTIONS(5840),
    [anon_sym_u00ac] = ACTIONS(5838),
    [sym_union] = ACTIONS(5840),
    [sym_powerset] = ACTIONS(5840),
    [sym_domain] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [sym_negative_dot] = ACTIONS(5838),
    [sym_enabled] = ACTIONS(5840),
    [sym_unchanged] = ACTIONS(5840),
    [anon_sym_LT_GT] = ACTIONS(5838),
    [anon_sym_u22c4] = ACTIONS(5838),
    [anon_sym_u25c7] = ACTIONS(5838),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5838),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [anon_sym_end] = ACTIONS(5840),
    [sym__double_excl] = ACTIONS(5838),
  },
  [2638] = {
    [sym_block_comment] = STATE(2638),
    [sym_identifier] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_COMMA] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_INSTANCE] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_Nat] = ACTIONS(5844),
    [anon_sym_u2115] = ACTIONS(5842),
    [anon_sym_Int] = ACTIONS(5844),
    [anon_sym_u2124] = ACTIONS(5842),
    [anon_sym_Real] = ACTIONS(5844),
    [anon_sym_u211d] = ACTIONS(5842),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_BSLASHlnot] = ACTIONS(5842),
    [anon_sym_BSLASHneg] = ACTIONS(5842),
    [anon_sym_TILDE] = ACTIONS(5844),
    [anon_sym_u00ac] = ACTIONS(5842),
    [sym_union] = ACTIONS(5844),
    [sym_powerset] = ACTIONS(5844),
    [sym_domain] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [sym_negative_dot] = ACTIONS(5842),
    [sym_enabled] = ACTIONS(5844),
    [sym_unchanged] = ACTIONS(5844),
    [anon_sym_LT_GT] = ACTIONS(5842),
    [anon_sym_u22c4] = ACTIONS(5842),
    [anon_sym_u25c7] = ACTIONS(5842),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5842),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [anon_sym_end] = ACTIONS(5844),
    [sym__double_excl] = ACTIONS(5842),
  },
  [2639] = {
    [sym_block_comment] = STATE(2639),
    [sym_identifier] = ACTIONS(5864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_INSTANCE] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_Nat] = ACTIONS(5864),
    [anon_sym_u2115] = ACTIONS(5862),
    [anon_sym_Int] = ACTIONS(5864),
    [anon_sym_u2124] = ACTIONS(5862),
    [anon_sym_Real] = ACTIONS(5864),
    [anon_sym_u211d] = ACTIONS(5862),
    [anon_sym_RBRACE] = ACTIONS(5862),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_BSLASHlnot] = ACTIONS(5862),
    [anon_sym_BSLASHneg] = ACTIONS(5862),
    [anon_sym_TILDE] = ACTIONS(5864),
    [anon_sym_u00ac] = ACTIONS(5862),
    [sym_union] = ACTIONS(5864),
    [sym_powerset] = ACTIONS(5864),
    [sym_domain] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [sym_negative_dot] = ACTIONS(5862),
    [sym_enabled] = ACTIONS(5864),
    [sym_unchanged] = ACTIONS(5864),
    [anon_sym_LT_GT] = ACTIONS(5862),
    [anon_sym_u22c4] = ACTIONS(5862),
    [anon_sym_u25c7] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5862),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5864),
    [sym__double_excl] = ACTIONS(5862),
  },
  [2640] = {
    [sym_block_comment] = STATE(2640),
    [sym_identifier] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_COMMA] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_INSTANCE] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_Nat] = ACTIONS(5750),
    [anon_sym_u2115] = ACTIONS(5748),
    [anon_sym_Int] = ACTIONS(5750),
    [anon_sym_u2124] = ACTIONS(5748),
    [anon_sym_Real] = ACTIONS(5750),
    [anon_sym_u211d] = ACTIONS(5748),
    [anon_sym_RBRACE] = ACTIONS(5748),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_BSLASHlnot] = ACTIONS(5748),
    [anon_sym_BSLASHneg] = ACTIONS(5748),
    [anon_sym_TILDE] = ACTIONS(5750),
    [anon_sym_u00ac] = ACTIONS(5748),
    [sym_union] = ACTIONS(5750),
    [sym_powerset] = ACTIONS(5750),
    [sym_domain] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [sym_negative_dot] = ACTIONS(5748),
    [sym_enabled] = ACTIONS(5750),
    [sym_unchanged] = ACTIONS(5750),
    [anon_sym_LT_GT] = ACTIONS(5748),
    [anon_sym_u22c4] = ACTIONS(5748),
    [anon_sym_u25c7] = ACTIONS(5748),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5748),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [anon_sym_end] = ACTIONS(5750),
    [sym__double_excl] = ACTIONS(5748),
  },
  [2641] = {
    [sym_block_comment] = STATE(2641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_COLON] = ACTIONS(5910),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_RPAREN] = ACTIONS(5908),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_RBRACK] = ACTIONS(5908),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_LBRACE] = ACTIONS(5908),
    [anon_sym_RBRACE] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_THEN] = ACTIONS(5908),
    [anon_sym_ELSE] = ACTIONS(5908),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5908),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [anon_sym_PROVE] = ACTIONS(5908),
    [anon_sym_end] = ACTIONS(5908),
    [anon_sym_SEMI] = ACTIONS(5908),
    [anon_sym_define] = ACTIONS(5908),
    [anon_sym_macro] = ACTIONS(5908),
    [anon_sym_procedure] = ACTIONS(5908),
    [anon_sym_fair] = ACTIONS(5908),
    [anon_sym_process] = ACTIONS(5908),
    [anon_sym_variable] = ACTIONS(5910),
    [anon_sym_variables] = ACTIONS(5908),
    [anon_sym_begin] = ACTIONS(5908),
    [anon_sym_then] = ACTIONS(5908),
    [anon_sym_elsif] = ACTIONS(5908),
    [anon_sym_else] = ACTIONS(5908),
    [anon_sym_do] = ACTIONS(5908),
    [anon_sym_or] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [2642] = {
    [sym_block_comment] = STATE(2642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_COLON] = ACTIONS(5706),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_RPAREN] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_RBRACK] = ACTIONS(5704),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(5704),
    [anon_sym_RBRACE] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_THEN] = ACTIONS(5704),
    [anon_sym_ELSE] = ACTIONS(5704),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_PROVE] = ACTIONS(5704),
    [anon_sym_end] = ACTIONS(5704),
    [anon_sym_SEMI] = ACTIONS(5704),
    [anon_sym_define] = ACTIONS(5704),
    [anon_sym_macro] = ACTIONS(5704),
    [anon_sym_procedure] = ACTIONS(5704),
    [anon_sym_fair] = ACTIONS(5704),
    [anon_sym_process] = ACTIONS(5704),
    [anon_sym_variable] = ACTIONS(5706),
    [anon_sym_variables] = ACTIONS(5704),
    [anon_sym_begin] = ACTIONS(5704),
    [anon_sym_then] = ACTIONS(5704),
    [anon_sym_elsif] = ACTIONS(5704),
    [anon_sym_else] = ACTIONS(5704),
    [anon_sym_do] = ACTIONS(5704),
    [anon_sym_or] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2643] = {
    [sym_block_comment] = STATE(2643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_COLON] = ACTIONS(5914),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_COMMA] = ACTIONS(5912),
    [anon_sym_RPAREN] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_RBRACK] = ACTIONS(5912),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_LBRACE] = ACTIONS(5912),
    [anon_sym_RBRACE] = ACTIONS(5912),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_THEN] = ACTIONS(5912),
    [anon_sym_ELSE] = ACTIONS(5912),
    [anon_sym_DASH] = ACTIONS(5914),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5912),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [anon_sym_PROVE] = ACTIONS(5912),
    [anon_sym_end] = ACTIONS(5912),
    [anon_sym_SEMI] = ACTIONS(5912),
    [anon_sym_define] = ACTIONS(5912),
    [anon_sym_macro] = ACTIONS(5912),
    [anon_sym_procedure] = ACTIONS(5912),
    [anon_sym_fair] = ACTIONS(5912),
    [anon_sym_process] = ACTIONS(5912),
    [anon_sym_variable] = ACTIONS(5914),
    [anon_sym_variables] = ACTIONS(5912),
    [anon_sym_begin] = ACTIONS(5912),
    [anon_sym_then] = ACTIONS(5912),
    [anon_sym_elsif] = ACTIONS(5912),
    [anon_sym_else] = ACTIONS(5912),
    [anon_sym_do] = ACTIONS(5912),
    [anon_sym_or] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [2644] = {
    [sym_block_comment] = STATE(2644),
    [sym_identifier] = ACTIONS(5894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_INSTANCE] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_Nat] = ACTIONS(5894),
    [anon_sym_u2115] = ACTIONS(5892),
    [anon_sym_Int] = ACTIONS(5894),
    [anon_sym_u2124] = ACTIONS(5892),
    [anon_sym_Real] = ACTIONS(5894),
    [anon_sym_u211d] = ACTIONS(5892),
    [anon_sym_RBRACE] = ACTIONS(5892),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_BSLASHlnot] = ACTIONS(5892),
    [anon_sym_BSLASHneg] = ACTIONS(5892),
    [anon_sym_TILDE] = ACTIONS(5894),
    [anon_sym_u00ac] = ACTIONS(5892),
    [sym_union] = ACTIONS(5894),
    [sym_powerset] = ACTIONS(5894),
    [sym_domain] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [sym_negative_dot] = ACTIONS(5892),
    [sym_enabled] = ACTIONS(5894),
    [sym_unchanged] = ACTIONS(5894),
    [anon_sym_LT_GT] = ACTIONS(5892),
    [anon_sym_u22c4] = ACTIONS(5892),
    [anon_sym_u25c7] = ACTIONS(5892),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [anon_sym_end] = ACTIONS(5894),
    [sym__double_excl] = ACTIONS(5892),
  },
  [2645] = {
    [sym_block_comment] = STATE(2645),
    [sym_identifier] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_COMMA] = ACTIONS(5896),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_INSTANCE] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_Nat] = ACTIONS(5898),
    [anon_sym_u2115] = ACTIONS(5896),
    [anon_sym_Int] = ACTIONS(5898),
    [anon_sym_u2124] = ACTIONS(5896),
    [anon_sym_Real] = ACTIONS(5898),
    [anon_sym_u211d] = ACTIONS(5896),
    [anon_sym_RBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_BSLASHlnot] = ACTIONS(5896),
    [anon_sym_BSLASHneg] = ACTIONS(5896),
    [anon_sym_TILDE] = ACTIONS(5898),
    [anon_sym_u00ac] = ACTIONS(5896),
    [sym_union] = ACTIONS(5898),
    [sym_powerset] = ACTIONS(5898),
    [sym_domain] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [sym_negative_dot] = ACTIONS(5896),
    [sym_enabled] = ACTIONS(5898),
    [sym_unchanged] = ACTIONS(5898),
    [anon_sym_LT_GT] = ACTIONS(5896),
    [anon_sym_u22c4] = ACTIONS(5896),
    [anon_sym_u25c7] = ACTIONS(5896),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [anon_sym_end] = ACTIONS(5898),
    [sym__double_excl] = ACTIONS(5896),
  },
  [2646] = {
    [sym_block_comment] = STATE(2646),
    [sym_identifier] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_COMMA] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_INSTANCE] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_Nat] = ACTIONS(5902),
    [anon_sym_u2115] = ACTIONS(5900),
    [anon_sym_Int] = ACTIONS(5902),
    [anon_sym_u2124] = ACTIONS(5900),
    [anon_sym_Real] = ACTIONS(5902),
    [anon_sym_u211d] = ACTIONS(5900),
    [anon_sym_RBRACE] = ACTIONS(5900),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_BSLASHlnot] = ACTIONS(5900),
    [anon_sym_BSLASHneg] = ACTIONS(5900),
    [anon_sym_TILDE] = ACTIONS(5902),
    [anon_sym_u00ac] = ACTIONS(5900),
    [sym_union] = ACTIONS(5902),
    [sym_powerset] = ACTIONS(5902),
    [sym_domain] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [sym_negative_dot] = ACTIONS(5900),
    [sym_enabled] = ACTIONS(5902),
    [sym_unchanged] = ACTIONS(5902),
    [anon_sym_LT_GT] = ACTIONS(5900),
    [anon_sym_u22c4] = ACTIONS(5900),
    [anon_sym_u25c7] = ACTIONS(5900),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [anon_sym_end] = ACTIONS(5902),
    [sym__double_excl] = ACTIONS(5900),
  },
  [2647] = {
    [sym_block_comment] = STATE(2647),
    [sym_identifier] = ACTIONS(5906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_INSTANCE] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_Nat] = ACTIONS(5906),
    [anon_sym_u2115] = ACTIONS(5904),
    [anon_sym_Int] = ACTIONS(5906),
    [anon_sym_u2124] = ACTIONS(5904),
    [anon_sym_Real] = ACTIONS(5906),
    [anon_sym_u211d] = ACTIONS(5904),
    [anon_sym_RBRACE] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_BSLASHlnot] = ACTIONS(5904),
    [anon_sym_BSLASHneg] = ACTIONS(5904),
    [anon_sym_TILDE] = ACTIONS(5906),
    [anon_sym_u00ac] = ACTIONS(5904),
    [sym_union] = ACTIONS(5906),
    [sym_powerset] = ACTIONS(5906),
    [sym_domain] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [sym_negative_dot] = ACTIONS(5904),
    [sym_enabled] = ACTIONS(5906),
    [sym_unchanged] = ACTIONS(5906),
    [anon_sym_LT_GT] = ACTIONS(5904),
    [anon_sym_u22c4] = ACTIONS(5904),
    [anon_sym_u25c7] = ACTIONS(5904),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [anon_sym_end] = ACTIONS(5906),
    [sym__double_excl] = ACTIONS(5904),
  },
  [2648] = {
    [sym_block_comment] = STATE(2648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_COLON] = ACTIONS(5918),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_RPAREN] = ACTIONS(5916),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_RBRACK] = ACTIONS(5916),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_LBRACE] = ACTIONS(5916),
    [anon_sym_RBRACE] = ACTIONS(5916),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_THEN] = ACTIONS(5916),
    [anon_sym_ELSE] = ACTIONS(5916),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5916),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [anon_sym_PROVE] = ACTIONS(5916),
    [anon_sym_end] = ACTIONS(5916),
    [anon_sym_SEMI] = ACTIONS(5916),
    [anon_sym_define] = ACTIONS(5916),
    [anon_sym_macro] = ACTIONS(5916),
    [anon_sym_procedure] = ACTIONS(5916),
    [anon_sym_fair] = ACTIONS(5916),
    [anon_sym_process] = ACTIONS(5916),
    [anon_sym_variable] = ACTIONS(5918),
    [anon_sym_variables] = ACTIONS(5916),
    [anon_sym_begin] = ACTIONS(5916),
    [anon_sym_then] = ACTIONS(5916),
    [anon_sym_elsif] = ACTIONS(5916),
    [anon_sym_else] = ACTIONS(5916),
    [anon_sym_do] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [2649] = {
    [sym_block_comment] = STATE(2649),
    [sym_identifier] = ACTIONS(5774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_INSTANCE] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_Nat] = ACTIONS(5774),
    [anon_sym_u2115] = ACTIONS(5772),
    [anon_sym_Int] = ACTIONS(5774),
    [anon_sym_u2124] = ACTIONS(5772),
    [anon_sym_Real] = ACTIONS(5774),
    [anon_sym_u211d] = ACTIONS(5772),
    [anon_sym_RBRACE] = ACTIONS(5772),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_BSLASHlnot] = ACTIONS(5772),
    [anon_sym_BSLASHneg] = ACTIONS(5772),
    [anon_sym_TILDE] = ACTIONS(5774),
    [anon_sym_u00ac] = ACTIONS(5772),
    [sym_union] = ACTIONS(5774),
    [sym_powerset] = ACTIONS(5774),
    [sym_domain] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [sym_negative_dot] = ACTIONS(5772),
    [sym_enabled] = ACTIONS(5774),
    [sym_unchanged] = ACTIONS(5774),
    [anon_sym_LT_GT] = ACTIONS(5772),
    [anon_sym_u22c4] = ACTIONS(5772),
    [anon_sym_u25c7] = ACTIONS(5772),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5772),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [anon_sym_end] = ACTIONS(5774),
    [sym__double_excl] = ACTIONS(5772),
  },
  [2650] = {
    [sym_block_comment] = STATE(2650),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_COLON] = ACTIONS(5922),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_RPAREN] = ACTIONS(5920),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_RBRACK] = ACTIONS(5920),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_LBRACE] = ACTIONS(5920),
    [anon_sym_RBRACE] = ACTIONS(5920),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_THEN] = ACTIONS(5920),
    [anon_sym_ELSE] = ACTIONS(5920),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5920),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [anon_sym_PROVE] = ACTIONS(5920),
    [anon_sym_end] = ACTIONS(5920),
    [anon_sym_SEMI] = ACTIONS(5920),
    [anon_sym_define] = ACTIONS(5920),
    [anon_sym_macro] = ACTIONS(5920),
    [anon_sym_procedure] = ACTIONS(5920),
    [anon_sym_fair] = ACTIONS(5920),
    [anon_sym_process] = ACTIONS(5920),
    [anon_sym_variable] = ACTIONS(5922),
    [anon_sym_variables] = ACTIONS(5920),
    [anon_sym_begin] = ACTIONS(5920),
    [anon_sym_then] = ACTIONS(5920),
    [anon_sym_elsif] = ACTIONS(5920),
    [anon_sym_else] = ACTIONS(5920),
    [anon_sym_do] = ACTIONS(5920),
    [anon_sym_or] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [2651] = {
    [sym_block_comment] = STATE(2651),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_IN] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2652] = {
    [sym_block_comment] = STATE(2652),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_INSTANCE] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_RBRACE] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_end] = ACTIONS(5706),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2653] = {
    [sym_block_comment] = STATE(2653),
    [sym_identifier] = ACTIONS(5910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_INSTANCE] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_Nat] = ACTIONS(5910),
    [anon_sym_u2115] = ACTIONS(5908),
    [anon_sym_Int] = ACTIONS(5910),
    [anon_sym_u2124] = ACTIONS(5908),
    [anon_sym_Real] = ACTIONS(5910),
    [anon_sym_u211d] = ACTIONS(5908),
    [anon_sym_RBRACE] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_BSLASHlnot] = ACTIONS(5908),
    [anon_sym_BSLASHneg] = ACTIONS(5908),
    [anon_sym_TILDE] = ACTIONS(5910),
    [anon_sym_u00ac] = ACTIONS(5908),
    [sym_union] = ACTIONS(5910),
    [sym_powerset] = ACTIONS(5910),
    [sym_domain] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [sym_negative_dot] = ACTIONS(5908),
    [sym_enabled] = ACTIONS(5910),
    [sym_unchanged] = ACTIONS(5910),
    [anon_sym_LT_GT] = ACTIONS(5908),
    [anon_sym_u22c4] = ACTIONS(5908),
    [anon_sym_u25c7] = ACTIONS(5908),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5908),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [anon_sym_end] = ACTIONS(5910),
    [sym__double_excl] = ACTIONS(5908),
  },
  [2654] = {
    [sym_block_comment] = STATE(2654),
    [sym_identifier] = ACTIONS(5914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_COMMA] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_INSTANCE] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_Nat] = ACTIONS(5914),
    [anon_sym_u2115] = ACTIONS(5912),
    [anon_sym_Int] = ACTIONS(5914),
    [anon_sym_u2124] = ACTIONS(5912),
    [anon_sym_Real] = ACTIONS(5914),
    [anon_sym_u211d] = ACTIONS(5912),
    [anon_sym_RBRACE] = ACTIONS(5912),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_BSLASHlnot] = ACTIONS(5912),
    [anon_sym_BSLASHneg] = ACTIONS(5912),
    [anon_sym_TILDE] = ACTIONS(5914),
    [anon_sym_u00ac] = ACTIONS(5912),
    [sym_union] = ACTIONS(5914),
    [sym_powerset] = ACTIONS(5914),
    [sym_domain] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [sym_negative_dot] = ACTIONS(5912),
    [sym_enabled] = ACTIONS(5914),
    [sym_unchanged] = ACTIONS(5914),
    [anon_sym_LT_GT] = ACTIONS(5912),
    [anon_sym_u22c4] = ACTIONS(5912),
    [anon_sym_u25c7] = ACTIONS(5912),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5912),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [anon_sym_end] = ACTIONS(5914),
    [sym__double_excl] = ACTIONS(5912),
  },
  [2655] = {
    [sym_block_comment] = STATE(2655),
    [sym_identifier] = ACTIONS(5918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_INSTANCE] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_Nat] = ACTIONS(5918),
    [anon_sym_u2115] = ACTIONS(5916),
    [anon_sym_Int] = ACTIONS(5918),
    [anon_sym_u2124] = ACTIONS(5916),
    [anon_sym_Real] = ACTIONS(5918),
    [anon_sym_u211d] = ACTIONS(5916),
    [anon_sym_RBRACE] = ACTIONS(5916),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_BSLASHlnot] = ACTIONS(5916),
    [anon_sym_BSLASHneg] = ACTIONS(5916),
    [anon_sym_TILDE] = ACTIONS(5918),
    [anon_sym_u00ac] = ACTIONS(5916),
    [sym_union] = ACTIONS(5918),
    [sym_powerset] = ACTIONS(5918),
    [sym_domain] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [sym_negative_dot] = ACTIONS(5916),
    [sym_enabled] = ACTIONS(5918),
    [sym_unchanged] = ACTIONS(5918),
    [anon_sym_LT_GT] = ACTIONS(5916),
    [anon_sym_u22c4] = ACTIONS(5916),
    [anon_sym_u25c7] = ACTIONS(5916),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5916),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [anon_sym_end] = ACTIONS(5918),
    [sym__double_excl] = ACTIONS(5916),
  },
  [2656] = {
    [sym_block_comment] = STATE(2656),
    [sym_identifier] = ACTIONS(5922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_INSTANCE] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_Nat] = ACTIONS(5922),
    [anon_sym_u2115] = ACTIONS(5920),
    [anon_sym_Int] = ACTIONS(5922),
    [anon_sym_u2124] = ACTIONS(5920),
    [anon_sym_Real] = ACTIONS(5922),
    [anon_sym_u211d] = ACTIONS(5920),
    [anon_sym_RBRACE] = ACTIONS(5920),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_BSLASHlnot] = ACTIONS(5920),
    [anon_sym_BSLASHneg] = ACTIONS(5920),
    [anon_sym_TILDE] = ACTIONS(5922),
    [anon_sym_u00ac] = ACTIONS(5920),
    [sym_union] = ACTIONS(5922),
    [sym_powerset] = ACTIONS(5922),
    [sym_domain] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [sym_negative_dot] = ACTIONS(5920),
    [sym_enabled] = ACTIONS(5922),
    [sym_unchanged] = ACTIONS(5922),
    [anon_sym_LT_GT] = ACTIONS(5920),
    [anon_sym_u22c4] = ACTIONS(5920),
    [anon_sym_u25c7] = ACTIONS(5920),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5920),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [anon_sym_end] = ACTIONS(5922),
    [sym__double_excl] = ACTIONS(5920),
  },
  [2657] = {
    [sym_block_comment] = STATE(2657),
    [sym_identifier] = ACTIONS(5924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_INSTANCE] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_Nat] = ACTIONS(5924),
    [anon_sym_u2115] = ACTIONS(5926),
    [anon_sym_Int] = ACTIONS(5924),
    [anon_sym_u2124] = ACTIONS(5926),
    [anon_sym_Real] = ACTIONS(5924),
    [anon_sym_u211d] = ACTIONS(5926),
    [anon_sym_RBRACE] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_BSLASHlnot] = ACTIONS(5926),
    [anon_sym_BSLASHneg] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5924),
    [anon_sym_u00ac] = ACTIONS(5926),
    [sym_union] = ACTIONS(5924),
    [sym_powerset] = ACTIONS(5924),
    [sym_domain] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [sym_negative_dot] = ACTIONS(5926),
    [sym_enabled] = ACTIONS(5924),
    [sym_unchanged] = ACTIONS(5924),
    [anon_sym_LT_GT] = ACTIONS(5926),
    [anon_sym_u22c4] = ACTIONS(5926),
    [anon_sym_u25c7] = ACTIONS(5926),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5926),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [anon_sym_end] = ACTIONS(5924),
    [sym__double_excl] = ACTIONS(5926),
  },
  [2658] = {
    [sym_block_comment] = STATE(2658),
    [sym_identifier] = ACTIONS(5932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_INSTANCE] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_Nat] = ACTIONS(5932),
    [anon_sym_u2115] = ACTIONS(5934),
    [anon_sym_Int] = ACTIONS(5932),
    [anon_sym_u2124] = ACTIONS(5934),
    [anon_sym_Real] = ACTIONS(5932),
    [anon_sym_u211d] = ACTIONS(5934),
    [anon_sym_RBRACE] = ACTIONS(5934),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_BSLASHlnot] = ACTIONS(5934),
    [anon_sym_BSLASHneg] = ACTIONS(5934),
    [anon_sym_TILDE] = ACTIONS(5932),
    [anon_sym_u00ac] = ACTIONS(5934),
    [sym_union] = ACTIONS(5932),
    [sym_powerset] = ACTIONS(5932),
    [sym_domain] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [sym_negative_dot] = ACTIONS(5934),
    [sym_enabled] = ACTIONS(5932),
    [sym_unchanged] = ACTIONS(5932),
    [anon_sym_LT_GT] = ACTIONS(5934),
    [anon_sym_u22c4] = ACTIONS(5934),
    [anon_sym_u25c7] = ACTIONS(5934),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5934),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [anon_sym_end] = ACTIONS(5932),
    [sym__double_excl] = ACTIONS(5934),
  },
  [2659] = {
    [sym_block_comment] = STATE(2659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_COLON] = ACTIONS(5924),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_RPAREN] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_RBRACK] = ACTIONS(5926),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_LBRACE] = ACTIONS(5926),
    [anon_sym_RBRACE] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_THEN] = ACTIONS(5926),
    [anon_sym_ELSE] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5926),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [anon_sym_PROVE] = ACTIONS(5926),
    [anon_sym_end] = ACTIONS(5926),
    [anon_sym_SEMI] = ACTIONS(5926),
    [anon_sym_define] = ACTIONS(5926),
    [anon_sym_macro] = ACTIONS(5926),
    [anon_sym_procedure] = ACTIONS(5926),
    [anon_sym_fair] = ACTIONS(5926),
    [anon_sym_process] = ACTIONS(5926),
    [anon_sym_variable] = ACTIONS(5924),
    [anon_sym_variables] = ACTIONS(5926),
    [anon_sym_begin] = ACTIONS(5926),
    [anon_sym_then] = ACTIONS(5926),
    [anon_sym_elsif] = ACTIONS(5926),
    [anon_sym_else] = ACTIONS(5926),
    [anon_sym_do] = ACTIONS(5926),
    [anon_sym_or] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [2660] = {
    [sym_block_comment] = STATE(2660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_COLON] = ACTIONS(5928),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_RPAREN] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_RBRACK] = ACTIONS(5930),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_LBRACE] = ACTIONS(5930),
    [anon_sym_RBRACE] = ACTIONS(5930),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_THEN] = ACTIONS(5930),
    [anon_sym_ELSE] = ACTIONS(5930),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5930),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [anon_sym_PROVE] = ACTIONS(5930),
    [anon_sym_end] = ACTIONS(5930),
    [anon_sym_SEMI] = ACTIONS(5930),
    [anon_sym_define] = ACTIONS(5930),
    [anon_sym_macro] = ACTIONS(5930),
    [anon_sym_procedure] = ACTIONS(5930),
    [anon_sym_fair] = ACTIONS(5930),
    [anon_sym_process] = ACTIONS(5930),
    [anon_sym_variable] = ACTIONS(5928),
    [anon_sym_variables] = ACTIONS(5930),
    [anon_sym_begin] = ACTIONS(5930),
    [anon_sym_then] = ACTIONS(5930),
    [anon_sym_elsif] = ACTIONS(5930),
    [anon_sym_else] = ACTIONS(5930),
    [anon_sym_do] = ACTIONS(5930),
    [anon_sym_or] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [2661] = {
    [sym_block_comment] = STATE(2661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_COLON] = ACTIONS(5932),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_RPAREN] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_RBRACK] = ACTIONS(5934),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(5934),
    [anon_sym_RBRACE] = ACTIONS(5934),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_THEN] = ACTIONS(5934),
    [anon_sym_ELSE] = ACTIONS(5934),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5934),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [anon_sym_PROVE] = ACTIONS(5934),
    [anon_sym_end] = ACTIONS(5934),
    [anon_sym_SEMI] = ACTIONS(5934),
    [anon_sym_define] = ACTIONS(5934),
    [anon_sym_macro] = ACTIONS(5934),
    [anon_sym_procedure] = ACTIONS(5934),
    [anon_sym_fair] = ACTIONS(5934),
    [anon_sym_process] = ACTIONS(5934),
    [anon_sym_variable] = ACTIONS(5932),
    [anon_sym_variables] = ACTIONS(5934),
    [anon_sym_begin] = ACTIONS(5934),
    [anon_sym_then] = ACTIONS(5934),
    [anon_sym_elsif] = ACTIONS(5934),
    [anon_sym_else] = ACTIONS(5934),
    [anon_sym_do] = ACTIONS(5934),
    [anon_sym_or] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [2662] = {
    [sym_block_comment] = STATE(2662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_COLON] = ACTIONS(5850),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_RBRACK] = ACTIONS(5852),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_THEN] = ACTIONS(5852),
    [anon_sym_ELSE] = ACTIONS(5852),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5852),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [anon_sym_PROVE] = ACTIONS(5852),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_define] = ACTIONS(5852),
    [anon_sym_macro] = ACTIONS(5852),
    [anon_sym_procedure] = ACTIONS(5852),
    [anon_sym_fair] = ACTIONS(5852),
    [anon_sym_process] = ACTIONS(5852),
    [anon_sym_variable] = ACTIONS(5850),
    [anon_sym_variables] = ACTIONS(5852),
    [anon_sym_begin] = ACTIONS(5852),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_elsif] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [2663] = {
    [sym_block_comment] = STATE(2663),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_RPAREN] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_RBRACK] = ACTIONS(5806),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_RBRACE] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_THEN] = ACTIONS(5806),
    [anon_sym_ELSE] = ACTIONS(5806),
    [anon_sym_DASH] = ACTIONS(5808),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5806),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [anon_sym_PROVE] = ACTIONS(5806),
    [anon_sym_end] = ACTIONS(5806),
    [anon_sym_SEMI] = ACTIONS(5806),
    [anon_sym_define] = ACTIONS(5806),
    [anon_sym_macro] = ACTIONS(5806),
    [anon_sym_procedure] = ACTIONS(5806),
    [anon_sym_fair] = ACTIONS(5806),
    [anon_sym_process] = ACTIONS(5806),
    [anon_sym_variable] = ACTIONS(5808),
    [anon_sym_variables] = ACTIONS(5806),
    [anon_sym_begin] = ACTIONS(5806),
    [anon_sym_then] = ACTIONS(5806),
    [anon_sym_elsif] = ACTIONS(5806),
    [anon_sym_else] = ACTIONS(5806),
    [anon_sym_do] = ACTIONS(5806),
    [anon_sym_or] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [2664] = {
    [sym_block_comment] = STATE(2664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_COLON] = ACTIONS(5868),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_RPAREN] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_RBRACK] = ACTIONS(5870),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_RBRACE] = ACTIONS(5870),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_THEN] = ACTIONS(5870),
    [anon_sym_ELSE] = ACTIONS(5870),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5870),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [anon_sym_PROVE] = ACTIONS(5870),
    [anon_sym_end] = ACTIONS(5870),
    [anon_sym_SEMI] = ACTIONS(5870),
    [anon_sym_define] = ACTIONS(5870),
    [anon_sym_macro] = ACTIONS(5870),
    [anon_sym_procedure] = ACTIONS(5870),
    [anon_sym_fair] = ACTIONS(5870),
    [anon_sym_process] = ACTIONS(5870),
    [anon_sym_variable] = ACTIONS(5868),
    [anon_sym_variables] = ACTIONS(5870),
    [anon_sym_begin] = ACTIONS(5870),
    [anon_sym_then] = ACTIONS(5870),
    [anon_sym_elsif] = ACTIONS(5870),
    [anon_sym_else] = ACTIONS(5870),
    [anon_sym_do] = ACTIONS(5870),
    [anon_sym_or] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [2665] = {
    [sym_block_comment] = STATE(2665),
    [sym_identifier] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_COMMA] = ACTIONS(5716),
    [anon_sym_RECURSIVE] = ACTIONS(5718),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_Nat] = ACTIONS(5718),
    [anon_sym_u2115] = ACTIONS(5716),
    [anon_sym_Int] = ACTIONS(5718),
    [anon_sym_u2124] = ACTIONS(5716),
    [anon_sym_Real] = ACTIONS(5718),
    [anon_sym_u211d] = ACTIONS(5716),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_IN] = ACTIONS(5718),
    [anon_sym_BSLASHlnot] = ACTIONS(5716),
    [anon_sym_BSLASHneg] = ACTIONS(5716),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_u00ac] = ACTIONS(5716),
    [sym_union] = ACTIONS(5718),
    [sym_powerset] = ACTIONS(5718),
    [sym_domain] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [sym_negative_dot] = ACTIONS(5716),
    [sym_enabled] = ACTIONS(5718),
    [sym_unchanged] = ACTIONS(5718),
    [anon_sym_LT_GT] = ACTIONS(5716),
    [anon_sym_u22c4] = ACTIONS(5716),
    [anon_sym_u25c7] = ACTIONS(5716),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5716),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [2666] = {
    [sym_block_comment] = STATE(2666),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_COLON] = ACTIONS(5858),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_THEN] = ACTIONS(5860),
    [anon_sym_ELSE] = ACTIONS(5860),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5860),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [anon_sym_PROVE] = ACTIONS(5860),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_define] = ACTIONS(5860),
    [anon_sym_macro] = ACTIONS(5860),
    [anon_sym_procedure] = ACTIONS(5860),
    [anon_sym_fair] = ACTIONS(5860),
    [anon_sym_process] = ACTIONS(5860),
    [anon_sym_variable] = ACTIONS(5858),
    [anon_sym_variables] = ACTIONS(5860),
    [anon_sym_begin] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [2667] = {
    [sym_block_comment] = STATE(2667),
    [sym_identifier] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_Nat] = ACTIONS(5714),
    [anon_sym_u2115] = ACTIONS(5712),
    [anon_sym_Int] = ACTIONS(5714),
    [anon_sym_u2124] = ACTIONS(5712),
    [anon_sym_Real] = ACTIONS(5714),
    [anon_sym_u211d] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_BSLASHlnot] = ACTIONS(5712),
    [anon_sym_BSLASHneg] = ACTIONS(5712),
    [anon_sym_TILDE] = ACTIONS(5714),
    [anon_sym_u00ac] = ACTIONS(5712),
    [sym_union] = ACTIONS(5714),
    [sym_powerset] = ACTIONS(5714),
    [sym_domain] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [sym_negative_dot] = ACTIONS(5712),
    [sym_enabled] = ACTIONS(5714),
    [sym_unchanged] = ACTIONS(5714),
    [anon_sym_LT_GT] = ACTIONS(5712),
    [anon_sym_u22c4] = ACTIONS(5712),
    [anon_sym_u25c7] = ACTIONS(5712),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5712),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [sym__begin_proof_step] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [2668] = {
    [sym_block_comment] = STATE(2668),
    [sym_identifier] = ACTIONS(5762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_RECURSIVE] = ACTIONS(5762),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_Nat] = ACTIONS(5762),
    [anon_sym_u2115] = ACTIONS(5760),
    [anon_sym_Int] = ACTIONS(5762),
    [anon_sym_u2124] = ACTIONS(5760),
    [anon_sym_Real] = ACTIONS(5762),
    [anon_sym_u211d] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_IN] = ACTIONS(5762),
    [anon_sym_BSLASHlnot] = ACTIONS(5760),
    [anon_sym_BSLASHneg] = ACTIONS(5760),
    [anon_sym_TILDE] = ACTIONS(5762),
    [anon_sym_u00ac] = ACTIONS(5760),
    [sym_union] = ACTIONS(5762),
    [sym_powerset] = ACTIONS(5762),
    [sym_domain] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [sym_negative_dot] = ACTIONS(5760),
    [sym_enabled] = ACTIONS(5762),
    [sym_unchanged] = ACTIONS(5762),
    [anon_sym_LT_GT] = ACTIONS(5760),
    [anon_sym_u22c4] = ACTIONS(5760),
    [anon_sym_u25c7] = ACTIONS(5760),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5760),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [2669] = {
    [sym_block_comment] = STATE(2669),
    [sym_identifier] = ACTIONS(5894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_RECURSIVE] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_Nat] = ACTIONS(5894),
    [anon_sym_u2115] = ACTIONS(5892),
    [anon_sym_Int] = ACTIONS(5894),
    [anon_sym_u2124] = ACTIONS(5892),
    [anon_sym_Real] = ACTIONS(5894),
    [anon_sym_u211d] = ACTIONS(5892),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_IN] = ACTIONS(5894),
    [anon_sym_BSLASHlnot] = ACTIONS(5892),
    [anon_sym_BSLASHneg] = ACTIONS(5892),
    [anon_sym_TILDE] = ACTIONS(5894),
    [anon_sym_u00ac] = ACTIONS(5892),
    [sym_union] = ACTIONS(5894),
    [sym_powerset] = ACTIONS(5894),
    [sym_domain] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [sym_negative_dot] = ACTIONS(5892),
    [sym_enabled] = ACTIONS(5894),
    [sym_unchanged] = ACTIONS(5894),
    [anon_sym_LT_GT] = ACTIONS(5892),
    [anon_sym_u22c4] = ACTIONS(5892),
    [anon_sym_u25c7] = ACTIONS(5892),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [2670] = {
    [sym_block_comment] = STATE(2670),
    [sym_identifier] = ACTIONS(5832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_COMMA] = ACTIONS(5830),
    [anon_sym_RECURSIVE] = ACTIONS(5832),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_Nat] = ACTIONS(5832),
    [anon_sym_u2115] = ACTIONS(5830),
    [anon_sym_Int] = ACTIONS(5832),
    [anon_sym_u2124] = ACTIONS(5830),
    [anon_sym_Real] = ACTIONS(5832),
    [anon_sym_u211d] = ACTIONS(5830),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_IN] = ACTIONS(5832),
    [anon_sym_BSLASHlnot] = ACTIONS(5830),
    [anon_sym_BSLASHneg] = ACTIONS(5830),
    [anon_sym_TILDE] = ACTIONS(5832),
    [anon_sym_u00ac] = ACTIONS(5830),
    [sym_union] = ACTIONS(5832),
    [sym_powerset] = ACTIONS(5832),
    [sym_domain] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [sym_negative_dot] = ACTIONS(5830),
    [sym_enabled] = ACTIONS(5832),
    [sym_unchanged] = ACTIONS(5832),
    [anon_sym_LT_GT] = ACTIONS(5830),
    [anon_sym_u22c4] = ACTIONS(5830),
    [anon_sym_u25c7] = ACTIONS(5830),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5830),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [2671] = {
    [sym_block_comment] = STATE(2671),
    [sym_identifier] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_COMMA] = ACTIONS(5896),
    [anon_sym_RECURSIVE] = ACTIONS(5898),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_Nat] = ACTIONS(5898),
    [anon_sym_u2115] = ACTIONS(5896),
    [anon_sym_Int] = ACTIONS(5898),
    [anon_sym_u2124] = ACTIONS(5896),
    [anon_sym_Real] = ACTIONS(5898),
    [anon_sym_u211d] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_IN] = ACTIONS(5898),
    [anon_sym_BSLASHlnot] = ACTIONS(5896),
    [anon_sym_BSLASHneg] = ACTIONS(5896),
    [anon_sym_TILDE] = ACTIONS(5898),
    [anon_sym_u00ac] = ACTIONS(5896),
    [sym_union] = ACTIONS(5898),
    [sym_powerset] = ACTIONS(5898),
    [sym_domain] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [sym_negative_dot] = ACTIONS(5896),
    [sym_enabled] = ACTIONS(5898),
    [sym_unchanged] = ACTIONS(5898),
    [anon_sym_LT_GT] = ACTIONS(5896),
    [anon_sym_u22c4] = ACTIONS(5896),
    [anon_sym_u25c7] = ACTIONS(5896),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [2672] = {
    [sym_block_comment] = STATE(2672),
    [sym_identifier] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_COMMA] = ACTIONS(5900),
    [anon_sym_RECURSIVE] = ACTIONS(5902),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_Nat] = ACTIONS(5902),
    [anon_sym_u2115] = ACTIONS(5900),
    [anon_sym_Int] = ACTIONS(5902),
    [anon_sym_u2124] = ACTIONS(5900),
    [anon_sym_Real] = ACTIONS(5902),
    [anon_sym_u211d] = ACTIONS(5900),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_IN] = ACTIONS(5902),
    [anon_sym_BSLASHlnot] = ACTIONS(5900),
    [anon_sym_BSLASHneg] = ACTIONS(5900),
    [anon_sym_TILDE] = ACTIONS(5902),
    [anon_sym_u00ac] = ACTIONS(5900),
    [sym_union] = ACTIONS(5902),
    [sym_powerset] = ACTIONS(5902),
    [sym_domain] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [sym_negative_dot] = ACTIONS(5900),
    [sym_enabled] = ACTIONS(5902),
    [sym_unchanged] = ACTIONS(5902),
    [anon_sym_LT_GT] = ACTIONS(5900),
    [anon_sym_u22c4] = ACTIONS(5900),
    [anon_sym_u25c7] = ACTIONS(5900),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [2673] = {
    [sym_block_comment] = STATE(2673),
    [sym_identifier] = ACTIONS(5906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_RECURSIVE] = ACTIONS(5906),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_Nat] = ACTIONS(5906),
    [anon_sym_u2115] = ACTIONS(5904),
    [anon_sym_Int] = ACTIONS(5906),
    [anon_sym_u2124] = ACTIONS(5904),
    [anon_sym_Real] = ACTIONS(5906),
    [anon_sym_u211d] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_IN] = ACTIONS(5906),
    [anon_sym_BSLASHlnot] = ACTIONS(5904),
    [anon_sym_BSLASHneg] = ACTIONS(5904),
    [anon_sym_TILDE] = ACTIONS(5906),
    [anon_sym_u00ac] = ACTIONS(5904),
    [sym_union] = ACTIONS(5906),
    [sym_powerset] = ACTIONS(5906),
    [sym_domain] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [sym_negative_dot] = ACTIONS(5904),
    [sym_enabled] = ACTIONS(5906),
    [sym_unchanged] = ACTIONS(5906),
    [anon_sym_LT_GT] = ACTIONS(5904),
    [anon_sym_u22c4] = ACTIONS(5904),
    [anon_sym_u25c7] = ACTIONS(5904),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [2674] = {
    [sym_block_comment] = STATE(2674),
    [sym_identifier] = ACTIONS(5836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_RECURSIVE] = ACTIONS(5836),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_Nat] = ACTIONS(5836),
    [anon_sym_u2115] = ACTIONS(5834),
    [anon_sym_Int] = ACTIONS(5836),
    [anon_sym_u2124] = ACTIONS(5834),
    [anon_sym_Real] = ACTIONS(5836),
    [anon_sym_u211d] = ACTIONS(5834),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_IN] = ACTIONS(5836),
    [anon_sym_BSLASHlnot] = ACTIONS(5834),
    [anon_sym_BSLASHneg] = ACTIONS(5834),
    [anon_sym_TILDE] = ACTIONS(5836),
    [anon_sym_u00ac] = ACTIONS(5834),
    [sym_union] = ACTIONS(5836),
    [sym_powerset] = ACTIONS(5836),
    [sym_domain] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [sym_negative_dot] = ACTIONS(5834),
    [sym_enabled] = ACTIONS(5836),
    [sym_unchanged] = ACTIONS(5836),
    [anon_sym_LT_GT] = ACTIONS(5834),
    [anon_sym_u22c4] = ACTIONS(5834),
    [anon_sym_u25c7] = ACTIONS(5834),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5834),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [2675] = {
    [sym_block_comment] = STATE(2675),
    [sym_identifier] = ACTIONS(5812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_RECURSIVE] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_Nat] = ACTIONS(5812),
    [anon_sym_u2115] = ACTIONS(5810),
    [anon_sym_Int] = ACTIONS(5812),
    [anon_sym_u2124] = ACTIONS(5810),
    [anon_sym_Real] = ACTIONS(5812),
    [anon_sym_u211d] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_IN] = ACTIONS(5812),
    [anon_sym_BSLASHlnot] = ACTIONS(5810),
    [anon_sym_BSLASHneg] = ACTIONS(5810),
    [anon_sym_TILDE] = ACTIONS(5812),
    [anon_sym_u00ac] = ACTIONS(5810),
    [sym_union] = ACTIONS(5812),
    [sym_powerset] = ACTIONS(5812),
    [sym_domain] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [sym_negative_dot] = ACTIONS(5810),
    [sym_enabled] = ACTIONS(5812),
    [sym_unchanged] = ACTIONS(5812),
    [anon_sym_LT_GT] = ACTIONS(5810),
    [anon_sym_u22c4] = ACTIONS(5810),
    [anon_sym_u25c7] = ACTIONS(5810),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5810),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [2676] = {
    [sym_block_comment] = STATE(2676),
    [sym_identifier] = ACTIONS(5940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_RECURSIVE] = ACTIONS(5940),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_Nat] = ACTIONS(5940),
    [anon_sym_u2115] = ACTIONS(5942),
    [anon_sym_Int] = ACTIONS(5940),
    [anon_sym_u2124] = ACTIONS(5942),
    [anon_sym_Real] = ACTIONS(5940),
    [anon_sym_u211d] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_IN] = ACTIONS(5940),
    [anon_sym_BSLASHlnot] = ACTIONS(5942),
    [anon_sym_BSLASHneg] = ACTIONS(5942),
    [anon_sym_TILDE] = ACTIONS(5940),
    [anon_sym_u00ac] = ACTIONS(5942),
    [sym_union] = ACTIONS(5940),
    [sym_powerset] = ACTIONS(5940),
    [sym_domain] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [sym_negative_dot] = ACTIONS(5942),
    [sym_enabled] = ACTIONS(5940),
    [sym_unchanged] = ACTIONS(5940),
    [anon_sym_LT_GT] = ACTIONS(5942),
    [anon_sym_u22c4] = ACTIONS(5942),
    [anon_sym_u25c7] = ACTIONS(5942),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5942),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [2677] = {
    [sym_block_comment] = STATE(2677),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__begin_proof_step] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2678] = {
    [sym_block_comment] = STATE(2678),
    [sym_identifier] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_RECURSIVE] = ACTIONS(5730),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_Nat] = ACTIONS(5730),
    [anon_sym_u2115] = ACTIONS(5728),
    [anon_sym_Int] = ACTIONS(5730),
    [anon_sym_u2124] = ACTIONS(5728),
    [anon_sym_Real] = ACTIONS(5730),
    [anon_sym_u211d] = ACTIONS(5728),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_IN] = ACTIONS(5730),
    [anon_sym_BSLASHlnot] = ACTIONS(5728),
    [anon_sym_BSLASHneg] = ACTIONS(5728),
    [anon_sym_TILDE] = ACTIONS(5730),
    [anon_sym_u00ac] = ACTIONS(5728),
    [sym_union] = ACTIONS(5730),
    [sym_powerset] = ACTIONS(5730),
    [sym_domain] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [sym_negative_dot] = ACTIONS(5728),
    [sym_enabled] = ACTIONS(5730),
    [sym_unchanged] = ACTIONS(5730),
    [anon_sym_LT_GT] = ACTIONS(5728),
    [anon_sym_u22c4] = ACTIONS(5728),
    [anon_sym_u25c7] = ACTIONS(5728),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5728),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [2679] = {
    [sym_block_comment] = STATE(2679),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_RECURSIVE] = ACTIONS(5665),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_IN] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2680] = {
    [sym_block_comment] = STATE(2680),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__begin_proof_step] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2681] = {
    [sym_block_comment] = STATE(2681),
    [sym_identifier] = ACTIONS(5734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_COMMA] = ACTIONS(5732),
    [anon_sym_RECURSIVE] = ACTIONS(5734),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_Nat] = ACTIONS(5734),
    [anon_sym_u2115] = ACTIONS(5732),
    [anon_sym_Int] = ACTIONS(5734),
    [anon_sym_u2124] = ACTIONS(5732),
    [anon_sym_Real] = ACTIONS(5734),
    [anon_sym_u211d] = ACTIONS(5732),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_IN] = ACTIONS(5734),
    [anon_sym_BSLASHlnot] = ACTIONS(5732),
    [anon_sym_BSLASHneg] = ACTIONS(5732),
    [anon_sym_TILDE] = ACTIONS(5734),
    [anon_sym_u00ac] = ACTIONS(5732),
    [sym_union] = ACTIONS(5734),
    [sym_powerset] = ACTIONS(5734),
    [sym_domain] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [sym_negative_dot] = ACTIONS(5732),
    [sym_enabled] = ACTIONS(5734),
    [sym_unchanged] = ACTIONS(5734),
    [anon_sym_LT_GT] = ACTIONS(5732),
    [anon_sym_u22c4] = ACTIONS(5732),
    [anon_sym_u25c7] = ACTIONS(5732),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5732),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [2682] = {
    [sym_block_comment] = STATE(2682),
    [sym_identifier] = ACTIONS(5816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_COMMA] = ACTIONS(5814),
    [anon_sym_RECURSIVE] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_Nat] = ACTIONS(5816),
    [anon_sym_u2115] = ACTIONS(5814),
    [anon_sym_Int] = ACTIONS(5816),
    [anon_sym_u2124] = ACTIONS(5814),
    [anon_sym_Real] = ACTIONS(5816),
    [anon_sym_u211d] = ACTIONS(5814),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_IN] = ACTIONS(5816),
    [anon_sym_BSLASHlnot] = ACTIONS(5814),
    [anon_sym_BSLASHneg] = ACTIONS(5814),
    [anon_sym_TILDE] = ACTIONS(5816),
    [anon_sym_u00ac] = ACTIONS(5814),
    [sym_union] = ACTIONS(5816),
    [sym_powerset] = ACTIONS(5816),
    [sym_domain] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [sym_negative_dot] = ACTIONS(5814),
    [sym_enabled] = ACTIONS(5816),
    [sym_unchanged] = ACTIONS(5816),
    [anon_sym_LT_GT] = ACTIONS(5814),
    [anon_sym_u22c4] = ACTIONS(5814),
    [anon_sym_u25c7] = ACTIONS(5814),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5814),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [2683] = {
    [sym_block_comment] = STATE(2683),
    [sym_identifier] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5818),
    [anon_sym_RECURSIVE] = ACTIONS(5820),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_Nat] = ACTIONS(5820),
    [anon_sym_u2115] = ACTIONS(5818),
    [anon_sym_Int] = ACTIONS(5820),
    [anon_sym_u2124] = ACTIONS(5818),
    [anon_sym_Real] = ACTIONS(5820),
    [anon_sym_u211d] = ACTIONS(5818),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_IN] = ACTIONS(5820),
    [anon_sym_BSLASHlnot] = ACTIONS(5818),
    [anon_sym_BSLASHneg] = ACTIONS(5818),
    [anon_sym_TILDE] = ACTIONS(5820),
    [anon_sym_u00ac] = ACTIONS(5818),
    [sym_union] = ACTIONS(5820),
    [sym_powerset] = ACTIONS(5820),
    [sym_domain] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [sym_negative_dot] = ACTIONS(5818),
    [sym_enabled] = ACTIONS(5820),
    [sym_unchanged] = ACTIONS(5820),
    [anon_sym_LT_GT] = ACTIONS(5818),
    [anon_sym_u22c4] = ACTIONS(5818),
    [anon_sym_u25c7] = ACTIONS(5818),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5818),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [2684] = {
    [sym_block_comment] = STATE(2684),
    [sym_identifier] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_RECURSIVE] = ACTIONS(5780),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_Nat] = ACTIONS(5780),
    [anon_sym_u2115] = ACTIONS(5778),
    [anon_sym_Int] = ACTIONS(5780),
    [anon_sym_u2124] = ACTIONS(5778),
    [anon_sym_Real] = ACTIONS(5780),
    [anon_sym_u211d] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_IN] = ACTIONS(5780),
    [anon_sym_BSLASHlnot] = ACTIONS(5778),
    [anon_sym_BSLASHneg] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5780),
    [anon_sym_u00ac] = ACTIONS(5778),
    [sym_union] = ACTIONS(5780),
    [sym_powerset] = ACTIONS(5780),
    [sym_domain] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [sym_negative_dot] = ACTIONS(5778),
    [sym_enabled] = ACTIONS(5780),
    [sym_unchanged] = ACTIONS(5780),
    [anon_sym_LT_GT] = ACTIONS(5778),
    [anon_sym_u22c4] = ACTIONS(5778),
    [anon_sym_u25c7] = ACTIONS(5778),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5778),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [2685] = {
    [sym_block_comment] = STATE(2685),
    [sym_identifier] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_RECURSIVE] = ACTIONS(5788),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_Nat] = ACTIONS(5788),
    [anon_sym_u2115] = ACTIONS(5786),
    [anon_sym_Int] = ACTIONS(5788),
    [anon_sym_u2124] = ACTIONS(5786),
    [anon_sym_Real] = ACTIONS(5788),
    [anon_sym_u211d] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_IN] = ACTIONS(5788),
    [anon_sym_BSLASHlnot] = ACTIONS(5786),
    [anon_sym_BSLASHneg] = ACTIONS(5786),
    [anon_sym_TILDE] = ACTIONS(5788),
    [anon_sym_u00ac] = ACTIONS(5786),
    [sym_union] = ACTIONS(5788),
    [sym_powerset] = ACTIONS(5788),
    [sym_domain] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [sym_negative_dot] = ACTIONS(5786),
    [sym_enabled] = ACTIONS(5788),
    [sym_unchanged] = ACTIONS(5788),
    [anon_sym_LT_GT] = ACTIONS(5786),
    [anon_sym_u22c4] = ACTIONS(5786),
    [anon_sym_u25c7] = ACTIONS(5786),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5786),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [2686] = {
    [sym_block_comment] = STATE(2686),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__begin_proof_step] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2687] = {
    [sym_block_comment] = STATE(2687),
    [sym_identifier] = ACTIONS(5774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_RECURSIVE] = ACTIONS(5774),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_Nat] = ACTIONS(5774),
    [anon_sym_u2115] = ACTIONS(5772),
    [anon_sym_Int] = ACTIONS(5774),
    [anon_sym_u2124] = ACTIONS(5772),
    [anon_sym_Real] = ACTIONS(5774),
    [anon_sym_u211d] = ACTIONS(5772),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_IN] = ACTIONS(5774),
    [anon_sym_BSLASHlnot] = ACTIONS(5772),
    [anon_sym_BSLASHneg] = ACTIONS(5772),
    [anon_sym_TILDE] = ACTIONS(5774),
    [anon_sym_u00ac] = ACTIONS(5772),
    [sym_union] = ACTIONS(5774),
    [sym_powerset] = ACTIONS(5774),
    [sym_domain] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [sym_negative_dot] = ACTIONS(5772),
    [sym_enabled] = ACTIONS(5774),
    [sym_unchanged] = ACTIONS(5774),
    [anon_sym_LT_GT] = ACTIONS(5772),
    [anon_sym_u22c4] = ACTIONS(5772),
    [anon_sym_u25c7] = ACTIONS(5772),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5772),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [2688] = {
    [sym_block_comment] = STATE(2688),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_RECURSIVE] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_IN] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2689] = {
    [sym_block_comment] = STATE(2689),
    [sym_identifier] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5740),
    [anon_sym_RECURSIVE] = ACTIONS(5742),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_Nat] = ACTIONS(5742),
    [anon_sym_u2115] = ACTIONS(5740),
    [anon_sym_Int] = ACTIONS(5742),
    [anon_sym_u2124] = ACTIONS(5740),
    [anon_sym_Real] = ACTIONS(5742),
    [anon_sym_u211d] = ACTIONS(5740),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_IN] = ACTIONS(5742),
    [anon_sym_BSLASHlnot] = ACTIONS(5740),
    [anon_sym_BSLASHneg] = ACTIONS(5740),
    [anon_sym_TILDE] = ACTIONS(5742),
    [anon_sym_u00ac] = ACTIONS(5740),
    [sym_union] = ACTIONS(5742),
    [sym_powerset] = ACTIONS(5742),
    [sym_domain] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [sym_negative_dot] = ACTIONS(5740),
    [sym_enabled] = ACTIONS(5742),
    [sym_unchanged] = ACTIONS(5742),
    [anon_sym_LT_GT] = ACTIONS(5740),
    [anon_sym_u22c4] = ACTIONS(5740),
    [anon_sym_u25c7] = ACTIONS(5740),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5740),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [2690] = {
    [sym_block_comment] = STATE(2690),
    [sym_identifier] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_RECURSIVE] = ACTIONS(5766),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_Nat] = ACTIONS(5766),
    [anon_sym_u2115] = ACTIONS(5764),
    [anon_sym_Int] = ACTIONS(5766),
    [anon_sym_u2124] = ACTIONS(5764),
    [anon_sym_Real] = ACTIONS(5766),
    [anon_sym_u211d] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_IN] = ACTIONS(5766),
    [anon_sym_BSLASHlnot] = ACTIONS(5764),
    [anon_sym_BSLASHneg] = ACTIONS(5764),
    [anon_sym_TILDE] = ACTIONS(5766),
    [anon_sym_u00ac] = ACTIONS(5764),
    [sym_union] = ACTIONS(5766),
    [sym_powerset] = ACTIONS(5766),
    [sym_domain] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [sym_negative_dot] = ACTIONS(5764),
    [sym_enabled] = ACTIONS(5766),
    [sym_unchanged] = ACTIONS(5766),
    [anon_sym_LT_GT] = ACTIONS(5764),
    [anon_sym_u22c4] = ACTIONS(5764),
    [anon_sym_u25c7] = ACTIONS(5764),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5764),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [2691] = {
    [sym_block_comment] = STATE(2691),
    [sym_identifier] = ACTIONS(5702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_COMMA] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(5958),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_Nat] = ACTIONS(5702),
    [anon_sym_u2115] = ACTIONS(5700),
    [anon_sym_Int] = ACTIONS(5702),
    [anon_sym_u2124] = ACTIONS(5700),
    [anon_sym_Real] = ACTIONS(5702),
    [anon_sym_u211d] = ACTIONS(5700),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_BSLASHlnot] = ACTIONS(5700),
    [anon_sym_BSLASHneg] = ACTIONS(5700),
    [anon_sym_TILDE] = ACTIONS(5702),
    [anon_sym_u00ac] = ACTIONS(5700),
    [sym_union] = ACTIONS(5702),
    [sym_powerset] = ACTIONS(5702),
    [sym_domain] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [sym_negative_dot] = ACTIONS(5700),
    [sym_enabled] = ACTIONS(5702),
    [sym_unchanged] = ACTIONS(5702),
    [anon_sym_LT_GT] = ACTIONS(5700),
    [anon_sym_u22c4] = ACTIONS(5700),
    [anon_sym_u25c7] = ACTIONS(5700),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5700),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [sym__begin_proof_step] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [2692] = {
    [sym_block_comment] = STATE(2692),
    [sym_identifier] = ACTIONS(5910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_RECURSIVE] = ACTIONS(5910),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_Nat] = ACTIONS(5910),
    [anon_sym_u2115] = ACTIONS(5908),
    [anon_sym_Int] = ACTIONS(5910),
    [anon_sym_u2124] = ACTIONS(5908),
    [anon_sym_Real] = ACTIONS(5910),
    [anon_sym_u211d] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_IN] = ACTIONS(5910),
    [anon_sym_BSLASHlnot] = ACTIONS(5908),
    [anon_sym_BSLASHneg] = ACTIONS(5908),
    [anon_sym_TILDE] = ACTIONS(5910),
    [anon_sym_u00ac] = ACTIONS(5908),
    [sym_union] = ACTIONS(5910),
    [sym_powerset] = ACTIONS(5910),
    [sym_domain] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [sym_negative_dot] = ACTIONS(5908),
    [sym_enabled] = ACTIONS(5910),
    [sym_unchanged] = ACTIONS(5910),
    [anon_sym_LT_GT] = ACTIONS(5908),
    [anon_sym_u22c4] = ACTIONS(5908),
    [anon_sym_u25c7] = ACTIONS(5908),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5908),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [2693] = {
    [sym_block_comment] = STATE(2693),
    [sym_identifier] = ACTIONS(5914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_COMMA] = ACTIONS(5912),
    [anon_sym_RECURSIVE] = ACTIONS(5914),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_Nat] = ACTIONS(5914),
    [anon_sym_u2115] = ACTIONS(5912),
    [anon_sym_Int] = ACTIONS(5914),
    [anon_sym_u2124] = ACTIONS(5912),
    [anon_sym_Real] = ACTIONS(5914),
    [anon_sym_u211d] = ACTIONS(5912),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_IN] = ACTIONS(5914),
    [anon_sym_BSLASHlnot] = ACTIONS(5912),
    [anon_sym_BSLASHneg] = ACTIONS(5912),
    [anon_sym_TILDE] = ACTIONS(5914),
    [anon_sym_u00ac] = ACTIONS(5912),
    [sym_union] = ACTIONS(5914),
    [sym_powerset] = ACTIONS(5914),
    [sym_domain] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [sym_negative_dot] = ACTIONS(5912),
    [sym_enabled] = ACTIONS(5914),
    [sym_unchanged] = ACTIONS(5914),
    [anon_sym_LT_GT] = ACTIONS(5912),
    [anon_sym_u22c4] = ACTIONS(5912),
    [anon_sym_u25c7] = ACTIONS(5912),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5912),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [2694] = {
    [sym_block_comment] = STATE(2694),
    [sym_identifier] = ACTIONS(5918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_RECURSIVE] = ACTIONS(5918),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_Nat] = ACTIONS(5918),
    [anon_sym_u2115] = ACTIONS(5916),
    [anon_sym_Int] = ACTIONS(5918),
    [anon_sym_u2124] = ACTIONS(5916),
    [anon_sym_Real] = ACTIONS(5918),
    [anon_sym_u211d] = ACTIONS(5916),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_IN] = ACTIONS(5918),
    [anon_sym_BSLASHlnot] = ACTIONS(5916),
    [anon_sym_BSLASHneg] = ACTIONS(5916),
    [anon_sym_TILDE] = ACTIONS(5918),
    [anon_sym_u00ac] = ACTIONS(5916),
    [sym_union] = ACTIONS(5918),
    [sym_powerset] = ACTIONS(5918),
    [sym_domain] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [sym_negative_dot] = ACTIONS(5916),
    [sym_enabled] = ACTIONS(5918),
    [sym_unchanged] = ACTIONS(5918),
    [anon_sym_LT_GT] = ACTIONS(5916),
    [anon_sym_u22c4] = ACTIONS(5916),
    [anon_sym_u25c7] = ACTIONS(5916),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5916),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [2695] = {
    [sym_block_comment] = STATE(2695),
    [sym_identifier] = ACTIONS(5922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_RECURSIVE] = ACTIONS(5922),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_Nat] = ACTIONS(5922),
    [anon_sym_u2115] = ACTIONS(5920),
    [anon_sym_Int] = ACTIONS(5922),
    [anon_sym_u2124] = ACTIONS(5920),
    [anon_sym_Real] = ACTIONS(5922),
    [anon_sym_u211d] = ACTIONS(5920),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_IN] = ACTIONS(5922),
    [anon_sym_BSLASHlnot] = ACTIONS(5920),
    [anon_sym_BSLASHneg] = ACTIONS(5920),
    [anon_sym_TILDE] = ACTIONS(5922),
    [anon_sym_u00ac] = ACTIONS(5920),
    [sym_union] = ACTIONS(5922),
    [sym_powerset] = ACTIONS(5922),
    [sym_domain] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [sym_negative_dot] = ACTIONS(5920),
    [sym_enabled] = ACTIONS(5922),
    [sym_unchanged] = ACTIONS(5922),
    [anon_sym_LT_GT] = ACTIONS(5920),
    [anon_sym_u22c4] = ACTIONS(5920),
    [anon_sym_u25c7] = ACTIONS(5920),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5920),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [2696] = {
    [sym_block_comment] = STATE(2696),
    [sym_identifier] = ACTIONS(5720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_Nat] = ACTIONS(5720),
    [anon_sym_u2115] = ACTIONS(5722),
    [anon_sym_Int] = ACTIONS(5720),
    [anon_sym_u2124] = ACTIONS(5722),
    [anon_sym_Real] = ACTIONS(5720),
    [anon_sym_u211d] = ACTIONS(5722),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_BSLASHlnot] = ACTIONS(5722),
    [anon_sym_BSLASHneg] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5720),
    [anon_sym_u00ac] = ACTIONS(5722),
    [sym_union] = ACTIONS(5720),
    [sym_powerset] = ACTIONS(5720),
    [sym_domain] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [sym_negative_dot] = ACTIONS(5722),
    [sym_enabled] = ACTIONS(5720),
    [sym_unchanged] = ACTIONS(5720),
    [anon_sym_LT_GT] = ACTIONS(5722),
    [anon_sym_u22c4] = ACTIONS(5722),
    [anon_sym_u25c7] = ACTIONS(5722),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5722),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [sym__begin_proof_step] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [2697] = {
    [sym_block_comment] = STATE(2697),
    [sym_identifier] = ACTIONS(5924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_RECURSIVE] = ACTIONS(5924),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_Nat] = ACTIONS(5924),
    [anon_sym_u2115] = ACTIONS(5926),
    [anon_sym_Int] = ACTIONS(5924),
    [anon_sym_u2124] = ACTIONS(5926),
    [anon_sym_Real] = ACTIONS(5924),
    [anon_sym_u211d] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_IN] = ACTIONS(5924),
    [anon_sym_BSLASHlnot] = ACTIONS(5926),
    [anon_sym_BSLASHneg] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5924),
    [anon_sym_u00ac] = ACTIONS(5926),
    [sym_union] = ACTIONS(5924),
    [sym_powerset] = ACTIONS(5924),
    [sym_domain] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [sym_negative_dot] = ACTIONS(5926),
    [sym_enabled] = ACTIONS(5924),
    [sym_unchanged] = ACTIONS(5924),
    [anon_sym_LT_GT] = ACTIONS(5926),
    [anon_sym_u22c4] = ACTIONS(5926),
    [anon_sym_u25c7] = ACTIONS(5926),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5926),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [2698] = {
    [sym_block_comment] = STATE(2698),
    [sym_identifier] = ACTIONS(5928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_RECURSIVE] = ACTIONS(5928),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_Nat] = ACTIONS(5928),
    [anon_sym_u2115] = ACTIONS(5930),
    [anon_sym_Int] = ACTIONS(5928),
    [anon_sym_u2124] = ACTIONS(5930),
    [anon_sym_Real] = ACTIONS(5928),
    [anon_sym_u211d] = ACTIONS(5930),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_IN] = ACTIONS(5928),
    [anon_sym_BSLASHlnot] = ACTIONS(5930),
    [anon_sym_BSLASHneg] = ACTIONS(5930),
    [anon_sym_TILDE] = ACTIONS(5928),
    [anon_sym_u00ac] = ACTIONS(5930),
    [sym_union] = ACTIONS(5928),
    [sym_powerset] = ACTIONS(5928),
    [sym_domain] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [sym_negative_dot] = ACTIONS(5930),
    [sym_enabled] = ACTIONS(5928),
    [sym_unchanged] = ACTIONS(5928),
    [anon_sym_LT_GT] = ACTIONS(5930),
    [anon_sym_u22c4] = ACTIONS(5930),
    [anon_sym_u25c7] = ACTIONS(5930),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5930),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [2699] = {
    [sym_block_comment] = STATE(2699),
    [sym_identifier] = ACTIONS(5932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_RECURSIVE] = ACTIONS(5932),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_Nat] = ACTIONS(5932),
    [anon_sym_u2115] = ACTIONS(5934),
    [anon_sym_Int] = ACTIONS(5932),
    [anon_sym_u2124] = ACTIONS(5934),
    [anon_sym_Real] = ACTIONS(5932),
    [anon_sym_u211d] = ACTIONS(5934),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_IN] = ACTIONS(5932),
    [anon_sym_BSLASHlnot] = ACTIONS(5934),
    [anon_sym_BSLASHneg] = ACTIONS(5934),
    [anon_sym_TILDE] = ACTIONS(5932),
    [anon_sym_u00ac] = ACTIONS(5934),
    [sym_union] = ACTIONS(5932),
    [sym_powerset] = ACTIONS(5932),
    [sym_domain] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [sym_negative_dot] = ACTIONS(5934),
    [sym_enabled] = ACTIONS(5932),
    [sym_unchanged] = ACTIONS(5932),
    [anon_sym_LT_GT] = ACTIONS(5934),
    [anon_sym_u22c4] = ACTIONS(5934),
    [anon_sym_u25c7] = ACTIONS(5934),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5934),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [2700] = {
    [sym_block_comment] = STATE(2700),
    [sym_identifier] = ACTIONS(5804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_COMMA] = ACTIONS(5802),
    [anon_sym_RECURSIVE] = ACTIONS(5804),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_Nat] = ACTIONS(5804),
    [anon_sym_u2115] = ACTIONS(5802),
    [anon_sym_Int] = ACTIONS(5804),
    [anon_sym_u2124] = ACTIONS(5802),
    [anon_sym_Real] = ACTIONS(5804),
    [anon_sym_u211d] = ACTIONS(5802),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_IN] = ACTIONS(5804),
    [anon_sym_BSLASHlnot] = ACTIONS(5802),
    [anon_sym_BSLASHneg] = ACTIONS(5802),
    [anon_sym_TILDE] = ACTIONS(5804),
    [anon_sym_u00ac] = ACTIONS(5802),
    [sym_union] = ACTIONS(5804),
    [sym_powerset] = ACTIONS(5804),
    [sym_domain] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [sym_negative_dot] = ACTIONS(5802),
    [sym_enabled] = ACTIONS(5804),
    [sym_unchanged] = ACTIONS(5804),
    [anon_sym_LT_GT] = ACTIONS(5802),
    [anon_sym_u22c4] = ACTIONS(5802),
    [anon_sym_u25c7] = ACTIONS(5802),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5802),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [2701] = {
    [sym_block_comment] = STATE(2701),
    [sym_identifier] = ACTIONS(5710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_COMMA] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_Nat] = ACTIONS(5710),
    [anon_sym_u2115] = ACTIONS(5708),
    [anon_sym_Int] = ACTIONS(5710),
    [anon_sym_u2124] = ACTIONS(5708),
    [anon_sym_Real] = ACTIONS(5710),
    [anon_sym_u211d] = ACTIONS(5708),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_BSLASHlnot] = ACTIONS(5708),
    [anon_sym_BSLASHneg] = ACTIONS(5708),
    [anon_sym_TILDE] = ACTIONS(5710),
    [anon_sym_u00ac] = ACTIONS(5708),
    [sym_union] = ACTIONS(5710),
    [sym_powerset] = ACTIONS(5710),
    [sym_domain] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [sym_negative_dot] = ACTIONS(5708),
    [sym_enabled] = ACTIONS(5710),
    [sym_unchanged] = ACTIONS(5710),
    [anon_sym_LT_GT] = ACTIONS(5708),
    [anon_sym_u22c4] = ACTIONS(5708),
    [anon_sym_u25c7] = ACTIONS(5708),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5708),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [sym__begin_proof_step] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [2702] = {
    [sym_block_comment] = STATE(2702),
    [sym_identifier] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_COMMA] = ACTIONS(5890),
    [anon_sym_RECURSIVE] = ACTIONS(5888),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_Nat] = ACTIONS(5888),
    [anon_sym_u2115] = ACTIONS(5890),
    [anon_sym_Int] = ACTIONS(5888),
    [anon_sym_u2124] = ACTIONS(5890),
    [anon_sym_Real] = ACTIONS(5888),
    [anon_sym_u211d] = ACTIONS(5890),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_IN] = ACTIONS(5888),
    [anon_sym_BSLASHlnot] = ACTIONS(5890),
    [anon_sym_BSLASHneg] = ACTIONS(5890),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_u00ac] = ACTIONS(5890),
    [sym_union] = ACTIONS(5888),
    [sym_powerset] = ACTIONS(5888),
    [sym_domain] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [sym_negative_dot] = ACTIONS(5890),
    [sym_enabled] = ACTIONS(5888),
    [sym_unchanged] = ACTIONS(5888),
    [anon_sym_LT_GT] = ACTIONS(5890),
    [anon_sym_u22c4] = ACTIONS(5890),
    [anon_sym_u25c7] = ACTIONS(5890),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5890),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [2703] = {
    [sym_block_comment] = STATE(2703),
    [sym_identifier] = ACTIONS(5828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_COMMA] = ACTIONS(5826),
    [anon_sym_RECURSIVE] = ACTIONS(5828),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_Nat] = ACTIONS(5828),
    [anon_sym_u2115] = ACTIONS(5826),
    [anon_sym_Int] = ACTIONS(5828),
    [anon_sym_u2124] = ACTIONS(5826),
    [anon_sym_Real] = ACTIONS(5828),
    [anon_sym_u211d] = ACTIONS(5826),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_IN] = ACTIONS(5828),
    [anon_sym_BSLASHlnot] = ACTIONS(5826),
    [anon_sym_BSLASHneg] = ACTIONS(5826),
    [anon_sym_TILDE] = ACTIONS(5828),
    [anon_sym_u00ac] = ACTIONS(5826),
    [sym_union] = ACTIONS(5828),
    [sym_powerset] = ACTIONS(5828),
    [sym_domain] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [sym_negative_dot] = ACTIONS(5826),
    [sym_enabled] = ACTIONS(5828),
    [sym_unchanged] = ACTIONS(5828),
    [anon_sym_LT_GT] = ACTIONS(5826),
    [anon_sym_u22c4] = ACTIONS(5826),
    [anon_sym_u25c7] = ACTIONS(5826),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5826),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [2704] = {
    [sym_block_comment] = STATE(2704),
    [sym_identifier] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_COMMA] = ACTIONS(5724),
    [anon_sym_RECURSIVE] = ACTIONS(5726),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_Nat] = ACTIONS(5726),
    [anon_sym_u2115] = ACTIONS(5724),
    [anon_sym_Int] = ACTIONS(5726),
    [anon_sym_u2124] = ACTIONS(5724),
    [anon_sym_Real] = ACTIONS(5726),
    [anon_sym_u211d] = ACTIONS(5724),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_IN] = ACTIONS(5726),
    [anon_sym_BSLASHlnot] = ACTIONS(5724),
    [anon_sym_BSLASHneg] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5726),
    [anon_sym_u00ac] = ACTIONS(5724),
    [sym_union] = ACTIONS(5726),
    [sym_powerset] = ACTIONS(5726),
    [sym_domain] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [sym_negative_dot] = ACTIONS(5724),
    [sym_enabled] = ACTIONS(5726),
    [sym_unchanged] = ACTIONS(5726),
    [anon_sym_LT_GT] = ACTIONS(5724),
    [anon_sym_u22c4] = ACTIONS(5724),
    [anon_sym_u25c7] = ACTIONS(5724),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5724),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [2705] = {
    [sym_block_comment] = STATE(2705),
    [sym_identifier] = ACTIONS(5848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_RECURSIVE] = ACTIONS(5848),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_Nat] = ACTIONS(5848),
    [anon_sym_u2115] = ACTIONS(5846),
    [anon_sym_Int] = ACTIONS(5848),
    [anon_sym_u2124] = ACTIONS(5846),
    [anon_sym_Real] = ACTIONS(5848),
    [anon_sym_u211d] = ACTIONS(5846),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_IN] = ACTIONS(5848),
    [anon_sym_BSLASHlnot] = ACTIONS(5846),
    [anon_sym_BSLASHneg] = ACTIONS(5846),
    [anon_sym_TILDE] = ACTIONS(5848),
    [anon_sym_u00ac] = ACTIONS(5846),
    [sym_union] = ACTIONS(5848),
    [sym_powerset] = ACTIONS(5848),
    [sym_domain] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [sym_negative_dot] = ACTIONS(5846),
    [sym_enabled] = ACTIONS(5848),
    [sym_unchanged] = ACTIONS(5848),
    [anon_sym_LT_GT] = ACTIONS(5846),
    [anon_sym_u22c4] = ACTIONS(5846),
    [anon_sym_u25c7] = ACTIONS(5846),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5846),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [2706] = {
    [sym_block_comment] = STATE(2706),
    [sym_identifier] = ACTIONS(5874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_COMMA] = ACTIONS(5872),
    [anon_sym_RECURSIVE] = ACTIONS(5874),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_Nat] = ACTIONS(5874),
    [anon_sym_u2115] = ACTIONS(5872),
    [anon_sym_Int] = ACTIONS(5874),
    [anon_sym_u2124] = ACTIONS(5872),
    [anon_sym_Real] = ACTIONS(5874),
    [anon_sym_u211d] = ACTIONS(5872),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_IN] = ACTIONS(5874),
    [anon_sym_BSLASHlnot] = ACTIONS(5872),
    [anon_sym_BSLASHneg] = ACTIONS(5872),
    [anon_sym_TILDE] = ACTIONS(5874),
    [anon_sym_u00ac] = ACTIONS(5872),
    [sym_union] = ACTIONS(5874),
    [sym_powerset] = ACTIONS(5874),
    [sym_domain] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [sym_negative_dot] = ACTIONS(5872),
    [sym_enabled] = ACTIONS(5874),
    [sym_unchanged] = ACTIONS(5874),
    [anon_sym_LT_GT] = ACTIONS(5872),
    [anon_sym_u22c4] = ACTIONS(5872),
    [anon_sym_u25c7] = ACTIONS(5872),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5872),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [2707] = {
    [sym_block_comment] = STATE(2707),
    [sym_identifier] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_COMMA] = ACTIONS(5782),
    [anon_sym_RECURSIVE] = ACTIONS(5784),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_Nat] = ACTIONS(5784),
    [anon_sym_u2115] = ACTIONS(5782),
    [anon_sym_Int] = ACTIONS(5784),
    [anon_sym_u2124] = ACTIONS(5782),
    [anon_sym_Real] = ACTIONS(5784),
    [anon_sym_u211d] = ACTIONS(5782),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_IN] = ACTIONS(5784),
    [anon_sym_BSLASHlnot] = ACTIONS(5782),
    [anon_sym_BSLASHneg] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [anon_sym_u00ac] = ACTIONS(5782),
    [sym_union] = ACTIONS(5784),
    [sym_powerset] = ACTIONS(5784),
    [sym_domain] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [sym_negative_dot] = ACTIONS(5782),
    [sym_enabled] = ACTIONS(5784),
    [sym_unchanged] = ACTIONS(5784),
    [anon_sym_LT_GT] = ACTIONS(5782),
    [anon_sym_u22c4] = ACTIONS(5782),
    [anon_sym_u25c7] = ACTIONS(5782),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5782),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [2708] = {
    [sym_block_comment] = STATE(2708),
    [sym_identifier] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RECURSIVE] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_Nat] = ACTIONS(5738),
    [anon_sym_u2115] = ACTIONS(5736),
    [anon_sym_Int] = ACTIONS(5738),
    [anon_sym_u2124] = ACTIONS(5736),
    [anon_sym_Real] = ACTIONS(5738),
    [anon_sym_u211d] = ACTIONS(5736),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_IN] = ACTIONS(5738),
    [anon_sym_BSLASHlnot] = ACTIONS(5736),
    [anon_sym_BSLASHneg] = ACTIONS(5736),
    [anon_sym_TILDE] = ACTIONS(5738),
    [anon_sym_u00ac] = ACTIONS(5736),
    [sym_union] = ACTIONS(5738),
    [sym_powerset] = ACTIONS(5738),
    [sym_domain] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [sym_negative_dot] = ACTIONS(5736),
    [sym_enabled] = ACTIONS(5738),
    [sym_unchanged] = ACTIONS(5738),
    [anon_sym_LT_GT] = ACTIONS(5736),
    [anon_sym_u22c4] = ACTIONS(5736),
    [anon_sym_u25c7] = ACTIONS(5736),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5736),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [2709] = {
    [sym_block_comment] = STATE(2709),
    [sym_identifier] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_RECURSIVE] = ACTIONS(5840),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_Nat] = ACTIONS(5840),
    [anon_sym_u2115] = ACTIONS(5838),
    [anon_sym_Int] = ACTIONS(5840),
    [anon_sym_u2124] = ACTIONS(5838),
    [anon_sym_Real] = ACTIONS(5840),
    [anon_sym_u211d] = ACTIONS(5838),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_IN] = ACTIONS(5840),
    [anon_sym_BSLASHlnot] = ACTIONS(5838),
    [anon_sym_BSLASHneg] = ACTIONS(5838),
    [anon_sym_TILDE] = ACTIONS(5840),
    [anon_sym_u00ac] = ACTIONS(5838),
    [sym_union] = ACTIONS(5840),
    [sym_powerset] = ACTIONS(5840),
    [sym_domain] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [sym_negative_dot] = ACTIONS(5838),
    [sym_enabled] = ACTIONS(5840),
    [sym_unchanged] = ACTIONS(5840),
    [anon_sym_LT_GT] = ACTIONS(5838),
    [anon_sym_u22c4] = ACTIONS(5838),
    [anon_sym_u25c7] = ACTIONS(5838),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5838),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [2710] = {
    [sym_block_comment] = STATE(2710),
    [sym_identifier] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_RECURSIVE] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_Nat] = ACTIONS(5746),
    [anon_sym_u2115] = ACTIONS(5744),
    [anon_sym_Int] = ACTIONS(5746),
    [anon_sym_u2124] = ACTIONS(5744),
    [anon_sym_Real] = ACTIONS(5746),
    [anon_sym_u211d] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_IN] = ACTIONS(5746),
    [anon_sym_BSLASHlnot] = ACTIONS(5744),
    [anon_sym_BSLASHneg] = ACTIONS(5744),
    [anon_sym_TILDE] = ACTIONS(5746),
    [anon_sym_u00ac] = ACTIONS(5744),
    [sym_union] = ACTIONS(5746),
    [sym_powerset] = ACTIONS(5746),
    [sym_domain] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [sym_negative_dot] = ACTIONS(5744),
    [sym_enabled] = ACTIONS(5746),
    [sym_unchanged] = ACTIONS(5746),
    [anon_sym_LT_GT] = ACTIONS(5744),
    [anon_sym_u22c4] = ACTIONS(5744),
    [anon_sym_u25c7] = ACTIONS(5744),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5744),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [2711] = {
    [sym_block_comment] = STATE(2711),
    [sym_identifier] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_COMMA] = ACTIONS(5842),
    [anon_sym_RECURSIVE] = ACTIONS(5844),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_Nat] = ACTIONS(5844),
    [anon_sym_u2115] = ACTIONS(5842),
    [anon_sym_Int] = ACTIONS(5844),
    [anon_sym_u2124] = ACTIONS(5842),
    [anon_sym_Real] = ACTIONS(5844),
    [anon_sym_u211d] = ACTIONS(5842),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_IN] = ACTIONS(5844),
    [anon_sym_BSLASHlnot] = ACTIONS(5842),
    [anon_sym_BSLASHneg] = ACTIONS(5842),
    [anon_sym_TILDE] = ACTIONS(5844),
    [anon_sym_u00ac] = ACTIONS(5842),
    [sym_union] = ACTIONS(5844),
    [sym_powerset] = ACTIONS(5844),
    [sym_domain] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [sym_negative_dot] = ACTIONS(5842),
    [sym_enabled] = ACTIONS(5844),
    [sym_unchanged] = ACTIONS(5844),
    [anon_sym_LT_GT] = ACTIONS(5842),
    [anon_sym_u22c4] = ACTIONS(5842),
    [anon_sym_u25c7] = ACTIONS(5842),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5842),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [2712] = {
    [sym_block_comment] = STATE(2712),
    [sym_identifier] = ACTIONS(5878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_COMMA] = ACTIONS(5876),
    [anon_sym_RECURSIVE] = ACTIONS(5878),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_Nat] = ACTIONS(5878),
    [anon_sym_u2115] = ACTIONS(5876),
    [anon_sym_Int] = ACTIONS(5878),
    [anon_sym_u2124] = ACTIONS(5876),
    [anon_sym_Real] = ACTIONS(5878),
    [anon_sym_u211d] = ACTIONS(5876),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_IN] = ACTIONS(5878),
    [anon_sym_BSLASHlnot] = ACTIONS(5876),
    [anon_sym_BSLASHneg] = ACTIONS(5876),
    [anon_sym_TILDE] = ACTIONS(5878),
    [anon_sym_u00ac] = ACTIONS(5876),
    [sym_union] = ACTIONS(5878),
    [sym_powerset] = ACTIONS(5878),
    [sym_domain] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [sym_negative_dot] = ACTIONS(5876),
    [sym_enabled] = ACTIONS(5878),
    [sym_unchanged] = ACTIONS(5878),
    [anon_sym_LT_GT] = ACTIONS(5876),
    [anon_sym_u22c4] = ACTIONS(5876),
    [anon_sym_u25c7] = ACTIONS(5876),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5876),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [2713] = {
    [sym_block_comment] = STATE(2713),
    [sym_identifier] = ACTIONS(5882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_COMMA] = ACTIONS(5880),
    [anon_sym_RECURSIVE] = ACTIONS(5882),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_Nat] = ACTIONS(5882),
    [anon_sym_u2115] = ACTIONS(5880),
    [anon_sym_Int] = ACTIONS(5882),
    [anon_sym_u2124] = ACTIONS(5880),
    [anon_sym_Real] = ACTIONS(5882),
    [anon_sym_u211d] = ACTIONS(5880),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_IN] = ACTIONS(5882),
    [anon_sym_BSLASHlnot] = ACTIONS(5880),
    [anon_sym_BSLASHneg] = ACTIONS(5880),
    [anon_sym_TILDE] = ACTIONS(5882),
    [anon_sym_u00ac] = ACTIONS(5880),
    [sym_union] = ACTIONS(5882),
    [sym_powerset] = ACTIONS(5882),
    [sym_domain] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [sym_negative_dot] = ACTIONS(5880),
    [sym_enabled] = ACTIONS(5882),
    [sym_unchanged] = ACTIONS(5882),
    [anon_sym_LT_GT] = ACTIONS(5880),
    [anon_sym_u22c4] = ACTIONS(5880),
    [anon_sym_u25c7] = ACTIONS(5880),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5880),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [2714] = {
    [sym_block_comment] = STATE(2714),
    [sym_identifier] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_COMMA] = ACTIONS(5748),
    [anon_sym_RECURSIVE] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_Nat] = ACTIONS(5750),
    [anon_sym_u2115] = ACTIONS(5748),
    [anon_sym_Int] = ACTIONS(5750),
    [anon_sym_u2124] = ACTIONS(5748),
    [anon_sym_Real] = ACTIONS(5750),
    [anon_sym_u211d] = ACTIONS(5748),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_IN] = ACTIONS(5750),
    [anon_sym_BSLASHlnot] = ACTIONS(5748),
    [anon_sym_BSLASHneg] = ACTIONS(5748),
    [anon_sym_TILDE] = ACTIONS(5750),
    [anon_sym_u00ac] = ACTIONS(5748),
    [sym_union] = ACTIONS(5750),
    [sym_powerset] = ACTIONS(5750),
    [sym_domain] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [sym_negative_dot] = ACTIONS(5748),
    [sym_enabled] = ACTIONS(5750),
    [sym_unchanged] = ACTIONS(5750),
    [anon_sym_LT_GT] = ACTIONS(5748),
    [anon_sym_u22c4] = ACTIONS(5748),
    [anon_sym_u25c7] = ACTIONS(5748),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5748),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [2715] = {
    [sym_block_comment] = STATE(2715),
    [sym_identifier] = ACTIONS(5864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5862),
    [anon_sym_RECURSIVE] = ACTIONS(5864),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_Nat] = ACTIONS(5864),
    [anon_sym_u2115] = ACTIONS(5862),
    [anon_sym_Int] = ACTIONS(5864),
    [anon_sym_u2124] = ACTIONS(5862),
    [anon_sym_Real] = ACTIONS(5864),
    [anon_sym_u211d] = ACTIONS(5862),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_IN] = ACTIONS(5864),
    [anon_sym_BSLASHlnot] = ACTIONS(5862),
    [anon_sym_BSLASHneg] = ACTIONS(5862),
    [anon_sym_TILDE] = ACTIONS(5864),
    [anon_sym_u00ac] = ACTIONS(5862),
    [sym_union] = ACTIONS(5864),
    [sym_powerset] = ACTIONS(5864),
    [sym_domain] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [sym_negative_dot] = ACTIONS(5862),
    [sym_enabled] = ACTIONS(5864),
    [sym_unchanged] = ACTIONS(5864),
    [anon_sym_LT_GT] = ACTIONS(5862),
    [anon_sym_u22c4] = ACTIONS(5862),
    [anon_sym_u25c7] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5862),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [2716] = {
    [sym_block_comment] = STATE(2716),
    [sym_identifier] = ACTIONS(5936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_RECURSIVE] = ACTIONS(5936),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_Nat] = ACTIONS(5936),
    [anon_sym_u2115] = ACTIONS(5938),
    [anon_sym_Int] = ACTIONS(5936),
    [anon_sym_u2124] = ACTIONS(5938),
    [anon_sym_Real] = ACTIONS(5936),
    [anon_sym_u211d] = ACTIONS(5938),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_IN] = ACTIONS(5936),
    [anon_sym_BSLASHlnot] = ACTIONS(5938),
    [anon_sym_BSLASHneg] = ACTIONS(5938),
    [anon_sym_TILDE] = ACTIONS(5936),
    [anon_sym_u00ac] = ACTIONS(5938),
    [sym_union] = ACTIONS(5936),
    [sym_powerset] = ACTIONS(5936),
    [sym_domain] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [sym_negative_dot] = ACTIONS(5938),
    [sym_enabled] = ACTIONS(5936),
    [sym_unchanged] = ACTIONS(5936),
    [anon_sym_LT_GT] = ACTIONS(5938),
    [anon_sym_u22c4] = ACTIONS(5938),
    [anon_sym_u25c7] = ACTIONS(5938),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5938),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [2717] = {
    [sym_block_comment] = STATE(2717),
    [sym_identifier] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_COMMA] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_Nat] = ACTIONS(5718),
    [anon_sym_u2115] = ACTIONS(5716),
    [anon_sym_Int] = ACTIONS(5718),
    [anon_sym_u2124] = ACTIONS(5716),
    [anon_sym_Real] = ACTIONS(5718),
    [anon_sym_u211d] = ACTIONS(5716),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_BSLASHlnot] = ACTIONS(5716),
    [anon_sym_BSLASHneg] = ACTIONS(5716),
    [anon_sym_TILDE] = ACTIONS(5718),
    [anon_sym_u00ac] = ACTIONS(5716),
    [sym_union] = ACTIONS(5718),
    [sym_powerset] = ACTIONS(5718),
    [sym_domain] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [sym_negative_dot] = ACTIONS(5716),
    [sym_enabled] = ACTIONS(5718),
    [sym_unchanged] = ACTIONS(5718),
    [anon_sym_LT_GT] = ACTIONS(5716),
    [anon_sym_u22c4] = ACTIONS(5716),
    [anon_sym_u25c7] = ACTIONS(5716),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5716),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [sym__begin_proof_step] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [2718] = {
    [sym_block_comment] = STATE(2718),
    [sym_identifier] = ACTIONS(5850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_RECURSIVE] = ACTIONS(5850),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_Nat] = ACTIONS(5850),
    [anon_sym_u2115] = ACTIONS(5852),
    [anon_sym_Int] = ACTIONS(5850),
    [anon_sym_u2124] = ACTIONS(5852),
    [anon_sym_Real] = ACTIONS(5850),
    [anon_sym_u211d] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_IN] = ACTIONS(5850),
    [anon_sym_BSLASHlnot] = ACTIONS(5852),
    [anon_sym_BSLASHneg] = ACTIONS(5852),
    [anon_sym_TILDE] = ACTIONS(5850),
    [anon_sym_u00ac] = ACTIONS(5852),
    [sym_union] = ACTIONS(5850),
    [sym_powerset] = ACTIONS(5850),
    [sym_domain] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [sym_negative_dot] = ACTIONS(5852),
    [sym_enabled] = ACTIONS(5850),
    [sym_unchanged] = ACTIONS(5850),
    [anon_sym_LT_GT] = ACTIONS(5852),
    [anon_sym_u22c4] = ACTIONS(5852),
    [anon_sym_u25c7] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5852),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [2719] = {
    [sym_block_comment] = STATE(2719),
    [sym_identifier] = ACTIONS(5808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_RECURSIVE] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_Nat] = ACTIONS(5808),
    [anon_sym_u2115] = ACTIONS(5806),
    [anon_sym_Int] = ACTIONS(5808),
    [anon_sym_u2124] = ACTIONS(5806),
    [anon_sym_Real] = ACTIONS(5808),
    [anon_sym_u211d] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_IN] = ACTIONS(5808),
    [anon_sym_BSLASHlnot] = ACTIONS(5806),
    [anon_sym_BSLASHneg] = ACTIONS(5806),
    [anon_sym_TILDE] = ACTIONS(5808),
    [anon_sym_u00ac] = ACTIONS(5806),
    [sym_union] = ACTIONS(5808),
    [sym_powerset] = ACTIONS(5808),
    [sym_domain] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [sym_negative_dot] = ACTIONS(5806),
    [sym_enabled] = ACTIONS(5808),
    [sym_unchanged] = ACTIONS(5808),
    [anon_sym_LT_GT] = ACTIONS(5806),
    [anon_sym_u22c4] = ACTIONS(5806),
    [anon_sym_u25c7] = ACTIONS(5806),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5806),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [2720] = {
    [sym_block_comment] = STATE(2720),
    [sym_identifier] = ACTIONS(5854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_RECURSIVE] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_Nat] = ACTIONS(5854),
    [anon_sym_u2115] = ACTIONS(5856),
    [anon_sym_Int] = ACTIONS(5854),
    [anon_sym_u2124] = ACTIONS(5856),
    [anon_sym_Real] = ACTIONS(5854),
    [anon_sym_u211d] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_IN] = ACTIONS(5854),
    [anon_sym_BSLASHlnot] = ACTIONS(5856),
    [anon_sym_BSLASHneg] = ACTIONS(5856),
    [anon_sym_TILDE] = ACTIONS(5854),
    [anon_sym_u00ac] = ACTIONS(5856),
    [sym_union] = ACTIONS(5854),
    [sym_powerset] = ACTIONS(5854),
    [sym_domain] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [sym_negative_dot] = ACTIONS(5856),
    [sym_enabled] = ACTIONS(5854),
    [sym_unchanged] = ACTIONS(5854),
    [anon_sym_LT_GT] = ACTIONS(5856),
    [anon_sym_u22c4] = ACTIONS(5856),
    [anon_sym_u25c7] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5856),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [2721] = {
    [sym_block_comment] = STATE(2721),
    [sym_identifier] = ACTIONS(5858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_RECURSIVE] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_Nat] = ACTIONS(5858),
    [anon_sym_u2115] = ACTIONS(5860),
    [anon_sym_Int] = ACTIONS(5858),
    [anon_sym_u2124] = ACTIONS(5860),
    [anon_sym_Real] = ACTIONS(5858),
    [anon_sym_u211d] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_IN] = ACTIONS(5858),
    [anon_sym_BSLASHlnot] = ACTIONS(5860),
    [anon_sym_BSLASHneg] = ACTIONS(5860),
    [anon_sym_TILDE] = ACTIONS(5858),
    [anon_sym_u00ac] = ACTIONS(5860),
    [sym_union] = ACTIONS(5858),
    [sym_powerset] = ACTIONS(5858),
    [sym_domain] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [sym_negative_dot] = ACTIONS(5860),
    [sym_enabled] = ACTIONS(5858),
    [sym_unchanged] = ACTIONS(5858),
    [anon_sym_LT_GT] = ACTIONS(5860),
    [anon_sym_u22c4] = ACTIONS(5860),
    [anon_sym_u25c7] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5860),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [2722] = {
    [sym_block_comment] = STATE(2722),
    [sym_identifier] = ACTIONS(5868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_RECURSIVE] = ACTIONS(5868),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_Nat] = ACTIONS(5868),
    [anon_sym_u2115] = ACTIONS(5870),
    [anon_sym_Int] = ACTIONS(5868),
    [anon_sym_u2124] = ACTIONS(5870),
    [anon_sym_Real] = ACTIONS(5868),
    [anon_sym_u211d] = ACTIONS(5870),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_IN] = ACTIONS(5868),
    [anon_sym_BSLASHlnot] = ACTIONS(5870),
    [anon_sym_BSLASHneg] = ACTIONS(5870),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_u00ac] = ACTIONS(5870),
    [sym_union] = ACTIONS(5868),
    [sym_powerset] = ACTIONS(5868),
    [sym_domain] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [sym_negative_dot] = ACTIONS(5870),
    [sym_enabled] = ACTIONS(5868),
    [sym_unchanged] = ACTIONS(5868),
    [anon_sym_LT_GT] = ACTIONS(5870),
    [anon_sym_u22c4] = ACTIONS(5870),
    [anon_sym_u25c7] = ACTIONS(5870),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5870),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [2723] = {
    [sym_block_comment] = STATE(2723),
    [sym_identifier] = ACTIONS(5886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_COMMA] = ACTIONS(5884),
    [anon_sym_RECURSIVE] = ACTIONS(5886),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_Nat] = ACTIONS(5886),
    [anon_sym_u2115] = ACTIONS(5884),
    [anon_sym_Int] = ACTIONS(5886),
    [anon_sym_u2124] = ACTIONS(5884),
    [anon_sym_Real] = ACTIONS(5886),
    [anon_sym_u211d] = ACTIONS(5884),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_IN] = ACTIONS(5886),
    [anon_sym_BSLASHlnot] = ACTIONS(5884),
    [anon_sym_BSLASHneg] = ACTIONS(5884),
    [anon_sym_TILDE] = ACTIONS(5886),
    [anon_sym_u00ac] = ACTIONS(5884),
    [sym_union] = ACTIONS(5886),
    [sym_powerset] = ACTIONS(5886),
    [sym_domain] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [sym_negative_dot] = ACTIONS(5884),
    [sym_enabled] = ACTIONS(5886),
    [sym_unchanged] = ACTIONS(5886),
    [anon_sym_LT_GT] = ACTIONS(5884),
    [anon_sym_u22c4] = ACTIONS(5884),
    [anon_sym_u25c7] = ACTIONS(5884),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5884),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [2724] = {
    [sym_block_comment] = STATE(2724),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_RECURSIVE] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_IN] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2725] = {
    [sym_block_comment] = STATE(2725),
    [sym_identifier] = ACTIONS(5754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_RECURSIVE] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_Nat] = ACTIONS(5754),
    [anon_sym_u2115] = ACTIONS(5752),
    [anon_sym_Int] = ACTIONS(5754),
    [anon_sym_u2124] = ACTIONS(5752),
    [anon_sym_Real] = ACTIONS(5754),
    [anon_sym_u211d] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_IN] = ACTIONS(5754),
    [anon_sym_BSLASHlnot] = ACTIONS(5752),
    [anon_sym_BSLASHneg] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(5754),
    [anon_sym_u00ac] = ACTIONS(5752),
    [sym_union] = ACTIONS(5754),
    [sym_powerset] = ACTIONS(5754),
    [sym_domain] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [sym_negative_dot] = ACTIONS(5752),
    [sym_enabled] = ACTIONS(5754),
    [sym_unchanged] = ACTIONS(5754),
    [anon_sym_LT_GT] = ACTIONS(5752),
    [anon_sym_u22c4] = ACTIONS(5752),
    [anon_sym_u25c7] = ACTIONS(5752),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5752),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [2726] = {
    [sym_block_comment] = STATE(2726),
    [sym_identifier] = ACTIONS(5770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_RECURSIVE] = ACTIONS(5770),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_Nat] = ACTIONS(5770),
    [anon_sym_u2115] = ACTIONS(5768),
    [anon_sym_Int] = ACTIONS(5770),
    [anon_sym_u2124] = ACTIONS(5768),
    [anon_sym_Real] = ACTIONS(5770),
    [anon_sym_u211d] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_IN] = ACTIONS(5770),
    [anon_sym_BSLASHlnot] = ACTIONS(5768),
    [anon_sym_BSLASHneg] = ACTIONS(5768),
    [anon_sym_TILDE] = ACTIONS(5770),
    [anon_sym_u00ac] = ACTIONS(5768),
    [sym_union] = ACTIONS(5770),
    [sym_powerset] = ACTIONS(5770),
    [sym_domain] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [sym_negative_dot] = ACTIONS(5768),
    [sym_enabled] = ACTIONS(5770),
    [sym_unchanged] = ACTIONS(5770),
    [anon_sym_LT_GT] = ACTIONS(5768),
    [anon_sym_u22c4] = ACTIONS(5768),
    [anon_sym_u25c7] = ACTIONS(5768),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [2727] = {
    [sym_block_comment] = STATE(2727),
    [sym_identifier] = ACTIONS(5792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_COMMA] = ACTIONS(5790),
    [anon_sym_RECURSIVE] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_Nat] = ACTIONS(5792),
    [anon_sym_u2115] = ACTIONS(5790),
    [anon_sym_Int] = ACTIONS(5792),
    [anon_sym_u2124] = ACTIONS(5790),
    [anon_sym_Real] = ACTIONS(5792),
    [anon_sym_u211d] = ACTIONS(5790),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_IN] = ACTIONS(5792),
    [anon_sym_BSLASHlnot] = ACTIONS(5790),
    [anon_sym_BSLASHneg] = ACTIONS(5790),
    [anon_sym_TILDE] = ACTIONS(5792),
    [anon_sym_u00ac] = ACTIONS(5790),
    [sym_union] = ACTIONS(5792),
    [sym_powerset] = ACTIONS(5792),
    [sym_domain] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [sym_negative_dot] = ACTIONS(5790),
    [sym_enabled] = ACTIONS(5792),
    [sym_unchanged] = ACTIONS(5792),
    [anon_sym_LT_GT] = ACTIONS(5790),
    [anon_sym_u22c4] = ACTIONS(5790),
    [anon_sym_u25c7] = ACTIONS(5790),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5790),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [2728] = {
    [sym_block_comment] = STATE(2728),
    [sym_identifier] = ACTIONS(5824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_RECURSIVE] = ACTIONS(5824),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_Nat] = ACTIONS(5824),
    [anon_sym_u2115] = ACTIONS(5822),
    [anon_sym_Int] = ACTIONS(5824),
    [anon_sym_u2124] = ACTIONS(5822),
    [anon_sym_Real] = ACTIONS(5824),
    [anon_sym_u211d] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_IN] = ACTIONS(5824),
    [anon_sym_BSLASHlnot] = ACTIONS(5822),
    [anon_sym_BSLASHneg] = ACTIONS(5822),
    [anon_sym_TILDE] = ACTIONS(5824),
    [anon_sym_u00ac] = ACTIONS(5822),
    [sym_union] = ACTIONS(5824),
    [sym_powerset] = ACTIONS(5824),
    [sym_domain] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [sym_negative_dot] = ACTIONS(5822),
    [sym_enabled] = ACTIONS(5824),
    [sym_unchanged] = ACTIONS(5824),
    [anon_sym_LT_GT] = ACTIONS(5822),
    [anon_sym_u22c4] = ACTIONS(5822),
    [anon_sym_u25c7] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5822),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [2729] = {
    [sym_block_comment] = STATE(2729),
    [sym_identifier] = ACTIONS(5758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_RECURSIVE] = ACTIONS(5758),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_Nat] = ACTIONS(5758),
    [anon_sym_u2115] = ACTIONS(5756),
    [anon_sym_Int] = ACTIONS(5758),
    [anon_sym_u2124] = ACTIONS(5756),
    [anon_sym_Real] = ACTIONS(5758),
    [anon_sym_u211d] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_IN] = ACTIONS(5758),
    [anon_sym_BSLASHlnot] = ACTIONS(5756),
    [anon_sym_BSLASHneg] = ACTIONS(5756),
    [anon_sym_TILDE] = ACTIONS(5758),
    [anon_sym_u00ac] = ACTIONS(5756),
    [sym_union] = ACTIONS(5758),
    [sym_powerset] = ACTIONS(5758),
    [sym_domain] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [sym_negative_dot] = ACTIONS(5756),
    [sym_enabled] = ACTIONS(5758),
    [sym_unchanged] = ACTIONS(5758),
    [anon_sym_LT_GT] = ACTIONS(5756),
    [anon_sym_u22c4] = ACTIONS(5756),
    [anon_sym_u25c7] = ACTIONS(5756),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5756),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [2730] = {
    [sym_block_comment] = STATE(2730),
    [sym_identifier] = ACTIONS(5796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_RECURSIVE] = ACTIONS(5796),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_Nat] = ACTIONS(5796),
    [anon_sym_u2115] = ACTIONS(5794),
    [anon_sym_Int] = ACTIONS(5796),
    [anon_sym_u2124] = ACTIONS(5794),
    [anon_sym_Real] = ACTIONS(5796),
    [anon_sym_u211d] = ACTIONS(5794),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_IN] = ACTIONS(5796),
    [anon_sym_BSLASHlnot] = ACTIONS(5794),
    [anon_sym_BSLASHneg] = ACTIONS(5794),
    [anon_sym_TILDE] = ACTIONS(5796),
    [anon_sym_u00ac] = ACTIONS(5794),
    [sym_union] = ACTIONS(5796),
    [sym_powerset] = ACTIONS(5796),
    [sym_domain] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [sym_negative_dot] = ACTIONS(5794),
    [sym_enabled] = ACTIONS(5796),
    [sym_unchanged] = ACTIONS(5796),
    [anon_sym_LT_GT] = ACTIONS(5794),
    [anon_sym_u22c4] = ACTIONS(5794),
    [anon_sym_u25c7] = ACTIONS(5794),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5794),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [2731] = {
    [sym_block_comment] = STATE(2731),
    [sym_identifier] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_RECURSIVE] = ACTIONS(5800),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_Nat] = ACTIONS(5800),
    [anon_sym_u2115] = ACTIONS(5798),
    [anon_sym_Int] = ACTIONS(5800),
    [anon_sym_u2124] = ACTIONS(5798),
    [anon_sym_Real] = ACTIONS(5800),
    [anon_sym_u211d] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_IN] = ACTIONS(5800),
    [anon_sym_BSLASHlnot] = ACTIONS(5798),
    [anon_sym_BSLASHneg] = ACTIONS(5798),
    [anon_sym_TILDE] = ACTIONS(5800),
    [anon_sym_u00ac] = ACTIONS(5798),
    [sym_union] = ACTIONS(5800),
    [sym_powerset] = ACTIONS(5800),
    [sym_domain] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [sym_negative_dot] = ACTIONS(5798),
    [sym_enabled] = ACTIONS(5800),
    [sym_unchanged] = ACTIONS(5800),
    [anon_sym_LT_GT] = ACTIONS(5798),
    [anon_sym_u22c4] = ACTIONS(5798),
    [anon_sym_u25c7] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5798),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [2732] = {
    [sym_block_comment] = STATE(2732),
    [sym_identifier] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_RECURSIVE] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_Nat] = ACTIONS(5349),
    [anon_sym_u2115] = ACTIONS(5351),
    [anon_sym_Int] = ACTIONS(5349),
    [anon_sym_u2124] = ACTIONS(5351),
    [anon_sym_Real] = ACTIONS(5349),
    [anon_sym_u211d] = ACTIONS(5351),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_IN] = ACTIONS(5349),
    [anon_sym_BSLASHlnot] = ACTIONS(5351),
    [anon_sym_BSLASHneg] = ACTIONS(5351),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_u00ac] = ACTIONS(5351),
    [sym_union] = ACTIONS(5349),
    [sym_powerset] = ACTIONS(5349),
    [sym_domain] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [sym_negative_dot] = ACTIONS(5351),
    [sym_enabled] = ACTIONS(5349),
    [sym_unchanged] = ACTIONS(5349),
    [anon_sym_LT_GT] = ACTIONS(5351),
    [anon_sym_u22c4] = ACTIONS(5351),
    [anon_sym_u25c7] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [2733] = {
    [sym_block_comment] = STATE(2733),
    [sym_identifier] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_Nat] = ACTIONS(5698),
    [anon_sym_u2115] = ACTIONS(5696),
    [anon_sym_Int] = ACTIONS(5698),
    [anon_sym_u2124] = ACTIONS(5696),
    [anon_sym_Real] = ACTIONS(5698),
    [anon_sym_u211d] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_BSLASHlnot] = ACTIONS(5696),
    [anon_sym_BSLASHneg] = ACTIONS(5696),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_u00ac] = ACTIONS(5696),
    [sym_union] = ACTIONS(5698),
    [sym_powerset] = ACTIONS(5698),
    [sym_domain] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [sym_negative_dot] = ACTIONS(5696),
    [sym_enabled] = ACTIONS(5698),
    [sym_unchanged] = ACTIONS(5698),
    [anon_sym_LT_GT] = ACTIONS(5696),
    [anon_sym_u22c4] = ACTIONS(5696),
    [anon_sym_u25c7] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5696),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [sym__begin_proof_step] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [2734] = {
    [sym_block_comment] = STATE(2734),
    [sym_identifier] = ACTIONS(5796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_Nat] = ACTIONS(5796),
    [anon_sym_u2115] = ACTIONS(5794),
    [anon_sym_Int] = ACTIONS(5796),
    [anon_sym_u2124] = ACTIONS(5794),
    [anon_sym_Real] = ACTIONS(5796),
    [anon_sym_u211d] = ACTIONS(5794),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_BSLASHlnot] = ACTIONS(5794),
    [anon_sym_BSLASHneg] = ACTIONS(5794),
    [anon_sym_TILDE] = ACTIONS(5796),
    [anon_sym_u00ac] = ACTIONS(5794),
    [sym_union] = ACTIONS(5796),
    [sym_powerset] = ACTIONS(5796),
    [sym_domain] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [sym_negative_dot] = ACTIONS(5794),
    [sym_enabled] = ACTIONS(5796),
    [sym_unchanged] = ACTIONS(5796),
    [anon_sym_LT_GT] = ACTIONS(5794),
    [anon_sym_u22c4] = ACTIONS(5794),
    [anon_sym_u25c7] = ACTIONS(5794),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5794),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [sym__begin_proof_step] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [2735] = {
    [sym_block_comment] = STATE(2735),
    [sym_identifier] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_COMMA] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_Nat] = ACTIONS(5750),
    [anon_sym_u2115] = ACTIONS(5748),
    [anon_sym_Int] = ACTIONS(5750),
    [anon_sym_u2124] = ACTIONS(5748),
    [anon_sym_Real] = ACTIONS(5750),
    [anon_sym_u211d] = ACTIONS(5748),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_BSLASHlnot] = ACTIONS(5748),
    [anon_sym_BSLASHneg] = ACTIONS(5748),
    [anon_sym_TILDE] = ACTIONS(5750),
    [anon_sym_u00ac] = ACTIONS(5748),
    [sym_union] = ACTIONS(5750),
    [sym_powerset] = ACTIONS(5750),
    [sym_domain] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [sym_negative_dot] = ACTIONS(5748),
    [sym_enabled] = ACTIONS(5750),
    [sym_unchanged] = ACTIONS(5750),
    [anon_sym_LT_GT] = ACTIONS(5748),
    [anon_sym_u22c4] = ACTIONS(5748),
    [anon_sym_u25c7] = ACTIONS(5748),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5748),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [sym__begin_proof_step] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [2736] = {
    [sym_block_comment] = STATE(2736),
    [sym_identifier] = ACTIONS(5734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_COMMA] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_Nat] = ACTIONS(5734),
    [anon_sym_u2115] = ACTIONS(5732),
    [anon_sym_Int] = ACTIONS(5734),
    [anon_sym_u2124] = ACTIONS(5732),
    [anon_sym_Real] = ACTIONS(5734),
    [anon_sym_u211d] = ACTIONS(5732),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_BSLASHlnot] = ACTIONS(5732),
    [anon_sym_BSLASHneg] = ACTIONS(5732),
    [anon_sym_TILDE] = ACTIONS(5734),
    [anon_sym_u00ac] = ACTIONS(5732),
    [sym_union] = ACTIONS(5734),
    [sym_powerset] = ACTIONS(5734),
    [sym_domain] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [sym_negative_dot] = ACTIONS(5732),
    [sym_enabled] = ACTIONS(5734),
    [sym_unchanged] = ACTIONS(5734),
    [anon_sym_LT_GT] = ACTIONS(5732),
    [anon_sym_u22c4] = ACTIONS(5732),
    [anon_sym_u25c7] = ACTIONS(5732),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5732),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [sym__begin_proof_step] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [2737] = {
    [sym_block_comment] = STATE(2737),
    [sym_identifier] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_COMMA] = ACTIONS(5890),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_Nat] = ACTIONS(5888),
    [anon_sym_u2115] = ACTIONS(5890),
    [anon_sym_Int] = ACTIONS(5888),
    [anon_sym_u2124] = ACTIONS(5890),
    [anon_sym_Real] = ACTIONS(5888),
    [anon_sym_u211d] = ACTIONS(5890),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_BSLASHlnot] = ACTIONS(5890),
    [anon_sym_BSLASHneg] = ACTIONS(5890),
    [anon_sym_TILDE] = ACTIONS(5888),
    [anon_sym_u00ac] = ACTIONS(5890),
    [sym_union] = ACTIONS(5888),
    [sym_powerset] = ACTIONS(5888),
    [sym_domain] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [sym_negative_dot] = ACTIONS(5890),
    [sym_enabled] = ACTIONS(5888),
    [sym_unchanged] = ACTIONS(5888),
    [anon_sym_LT_GT] = ACTIONS(5890),
    [anon_sym_u22c4] = ACTIONS(5890),
    [anon_sym_u25c7] = ACTIONS(5890),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5890),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [sym__begin_proof_step] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [2738] = {
    [sym_block_comment] = STATE(2738),
    [sym_identifier] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_Nat] = ACTIONS(5742),
    [anon_sym_u2115] = ACTIONS(5740),
    [anon_sym_Int] = ACTIONS(5742),
    [anon_sym_u2124] = ACTIONS(5740),
    [anon_sym_Real] = ACTIONS(5742),
    [anon_sym_u211d] = ACTIONS(5740),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_BSLASHlnot] = ACTIONS(5740),
    [anon_sym_BSLASHneg] = ACTIONS(5740),
    [anon_sym_TILDE] = ACTIONS(5742),
    [anon_sym_u00ac] = ACTIONS(5740),
    [sym_union] = ACTIONS(5742),
    [sym_powerset] = ACTIONS(5742),
    [sym_domain] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [sym_negative_dot] = ACTIONS(5740),
    [sym_enabled] = ACTIONS(5742),
    [sym_unchanged] = ACTIONS(5742),
    [anon_sym_LT_GT] = ACTIONS(5740),
    [anon_sym_u22c4] = ACTIONS(5740),
    [anon_sym_u25c7] = ACTIONS(5740),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5740),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [sym__begin_proof_step] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [2739] = {
    [sym_block_comment] = STATE(2739),
    [sym_identifier] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_Nat] = ACTIONS(5780),
    [anon_sym_u2115] = ACTIONS(5778),
    [anon_sym_Int] = ACTIONS(5780),
    [anon_sym_u2124] = ACTIONS(5778),
    [anon_sym_Real] = ACTIONS(5780),
    [anon_sym_u211d] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_BSLASHlnot] = ACTIONS(5778),
    [anon_sym_BSLASHneg] = ACTIONS(5778),
    [anon_sym_TILDE] = ACTIONS(5780),
    [anon_sym_u00ac] = ACTIONS(5778),
    [sym_union] = ACTIONS(5780),
    [sym_powerset] = ACTIONS(5780),
    [sym_domain] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [sym_negative_dot] = ACTIONS(5778),
    [sym_enabled] = ACTIONS(5780),
    [sym_unchanged] = ACTIONS(5780),
    [anon_sym_LT_GT] = ACTIONS(5778),
    [anon_sym_u22c4] = ACTIONS(5778),
    [anon_sym_u25c7] = ACTIONS(5778),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5778),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [sym__begin_proof_step] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [2740] = {
    [sym_block_comment] = STATE(2740),
    [sym_identifier] = ACTIONS(5854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_Nat] = ACTIONS(5854),
    [anon_sym_u2115] = ACTIONS(5856),
    [anon_sym_Int] = ACTIONS(5854),
    [anon_sym_u2124] = ACTIONS(5856),
    [anon_sym_Real] = ACTIONS(5854),
    [anon_sym_u211d] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_BSLASHlnot] = ACTIONS(5856),
    [anon_sym_BSLASHneg] = ACTIONS(5856),
    [anon_sym_TILDE] = ACTIONS(5854),
    [anon_sym_u00ac] = ACTIONS(5856),
    [sym_union] = ACTIONS(5854),
    [sym_powerset] = ACTIONS(5854),
    [sym_domain] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [sym_negative_dot] = ACTIONS(5856),
    [sym_enabled] = ACTIONS(5854),
    [sym_unchanged] = ACTIONS(5854),
    [anon_sym_LT_GT] = ACTIONS(5856),
    [anon_sym_u22c4] = ACTIONS(5856),
    [anon_sym_u25c7] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5856),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [sym__begin_proof_step] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [2741] = {
    [sym_block_comment] = STATE(2741),
    [sym_identifier] = ACTIONS(5858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_Nat] = ACTIONS(5858),
    [anon_sym_u2115] = ACTIONS(5860),
    [anon_sym_Int] = ACTIONS(5858),
    [anon_sym_u2124] = ACTIONS(5860),
    [anon_sym_Real] = ACTIONS(5858),
    [anon_sym_u211d] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_BSLASHlnot] = ACTIONS(5860),
    [anon_sym_BSLASHneg] = ACTIONS(5860),
    [anon_sym_TILDE] = ACTIONS(5858),
    [anon_sym_u00ac] = ACTIONS(5860),
    [sym_union] = ACTIONS(5858),
    [sym_powerset] = ACTIONS(5858),
    [sym_domain] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [sym_negative_dot] = ACTIONS(5860),
    [sym_enabled] = ACTIONS(5858),
    [sym_unchanged] = ACTIONS(5858),
    [anon_sym_LT_GT] = ACTIONS(5860),
    [anon_sym_u22c4] = ACTIONS(5860),
    [anon_sym_u25c7] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5860),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [sym__begin_proof_step] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [2742] = {
    [sym_block_comment] = STATE(2742),
    [sym_identifier] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_COMMA] = ACTIONS(5782),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_Nat] = ACTIONS(5784),
    [anon_sym_u2115] = ACTIONS(5782),
    [anon_sym_Int] = ACTIONS(5784),
    [anon_sym_u2124] = ACTIONS(5782),
    [anon_sym_Real] = ACTIONS(5784),
    [anon_sym_u211d] = ACTIONS(5782),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_BSLASHlnot] = ACTIONS(5782),
    [anon_sym_BSLASHneg] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [anon_sym_u00ac] = ACTIONS(5782),
    [sym_union] = ACTIONS(5784),
    [sym_powerset] = ACTIONS(5784),
    [sym_domain] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [sym_negative_dot] = ACTIONS(5782),
    [sym_enabled] = ACTIONS(5784),
    [sym_unchanged] = ACTIONS(5784),
    [anon_sym_LT_GT] = ACTIONS(5782),
    [anon_sym_u22c4] = ACTIONS(5782),
    [anon_sym_u25c7] = ACTIONS(5782),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5782),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [sym__begin_proof_step] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [2743] = {
    [sym_block_comment] = STATE(2743),
    [sym_identifier] = ACTIONS(5665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_Nat] = ACTIONS(5665),
    [anon_sym_u2115] = ACTIONS(5663),
    [anon_sym_Int] = ACTIONS(5665),
    [anon_sym_u2124] = ACTIONS(5663),
    [anon_sym_Real] = ACTIONS(5665),
    [anon_sym_u211d] = ACTIONS(5663),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_BSLASHlnot] = ACTIONS(5663),
    [anon_sym_BSLASHneg] = ACTIONS(5663),
    [anon_sym_TILDE] = ACTIONS(5665),
    [anon_sym_u00ac] = ACTIONS(5663),
    [sym_union] = ACTIONS(5665),
    [sym_powerset] = ACTIONS(5665),
    [sym_domain] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [sym_negative_dot] = ACTIONS(5663),
    [sym_enabled] = ACTIONS(5665),
    [sym_unchanged] = ACTIONS(5665),
    [anon_sym_LT_GT] = ACTIONS(5663),
    [anon_sym_u22c4] = ACTIONS(5663),
    [anon_sym_u25c7] = ACTIONS(5663),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__begin_proof_step] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2744] = {
    [sym_block_comment] = STATE(2744),
    [sym_identifier] = ACTIONS(5792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_COMMA] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_Nat] = ACTIONS(5792),
    [anon_sym_u2115] = ACTIONS(5790),
    [anon_sym_Int] = ACTIONS(5792),
    [anon_sym_u2124] = ACTIONS(5790),
    [anon_sym_Real] = ACTIONS(5792),
    [anon_sym_u211d] = ACTIONS(5790),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_BSLASHlnot] = ACTIONS(5790),
    [anon_sym_BSLASHneg] = ACTIONS(5790),
    [anon_sym_TILDE] = ACTIONS(5792),
    [anon_sym_u00ac] = ACTIONS(5790),
    [sym_union] = ACTIONS(5792),
    [sym_powerset] = ACTIONS(5792),
    [sym_domain] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [sym_negative_dot] = ACTIONS(5790),
    [sym_enabled] = ACTIONS(5792),
    [sym_unchanged] = ACTIONS(5792),
    [anon_sym_LT_GT] = ACTIONS(5790),
    [anon_sym_u22c4] = ACTIONS(5790),
    [anon_sym_u25c7] = ACTIONS(5790),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5790),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [sym__begin_proof_step] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [2745] = {
    [sym_block_comment] = STATE(2745),
    [sym_identifier] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_Nat] = ACTIONS(5800),
    [anon_sym_u2115] = ACTIONS(5798),
    [anon_sym_Int] = ACTIONS(5800),
    [anon_sym_u2124] = ACTIONS(5798),
    [anon_sym_Real] = ACTIONS(5800),
    [anon_sym_u211d] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_BSLASHlnot] = ACTIONS(5798),
    [anon_sym_BSLASHneg] = ACTIONS(5798),
    [anon_sym_TILDE] = ACTIONS(5800),
    [anon_sym_u00ac] = ACTIONS(5798),
    [sym_union] = ACTIONS(5800),
    [sym_powerset] = ACTIONS(5800),
    [sym_domain] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [sym_negative_dot] = ACTIONS(5798),
    [sym_enabled] = ACTIONS(5800),
    [sym_unchanged] = ACTIONS(5800),
    [anon_sym_LT_GT] = ACTIONS(5798),
    [anon_sym_u22c4] = ACTIONS(5798),
    [anon_sym_u25c7] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5798),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [sym__begin_proof_step] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [2746] = {
    [sym_block_comment] = STATE(2746),
    [sym_identifier] = ACTIONS(5788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_Nat] = ACTIONS(5788),
    [anon_sym_u2115] = ACTIONS(5786),
    [anon_sym_Int] = ACTIONS(5788),
    [anon_sym_u2124] = ACTIONS(5786),
    [anon_sym_Real] = ACTIONS(5788),
    [anon_sym_u211d] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_BSLASHlnot] = ACTIONS(5786),
    [anon_sym_BSLASHneg] = ACTIONS(5786),
    [anon_sym_TILDE] = ACTIONS(5788),
    [anon_sym_u00ac] = ACTIONS(5786),
    [sym_union] = ACTIONS(5788),
    [sym_powerset] = ACTIONS(5788),
    [sym_domain] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [sym_negative_dot] = ACTIONS(5786),
    [sym_enabled] = ACTIONS(5788),
    [sym_unchanged] = ACTIONS(5788),
    [anon_sym_LT_GT] = ACTIONS(5786),
    [anon_sym_u22c4] = ACTIONS(5786),
    [anon_sym_u25c7] = ACTIONS(5786),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5786),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [sym__begin_proof_step] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [2747] = {
    [sym_block_comment] = STATE(2747),
    [sym_identifier] = ACTIONS(5770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_Nat] = ACTIONS(5770),
    [anon_sym_u2115] = ACTIONS(5768),
    [anon_sym_Int] = ACTIONS(5770),
    [anon_sym_u2124] = ACTIONS(5768),
    [anon_sym_Real] = ACTIONS(5770),
    [anon_sym_u211d] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_BSLASHlnot] = ACTIONS(5768),
    [anon_sym_BSLASHneg] = ACTIONS(5768),
    [anon_sym_TILDE] = ACTIONS(5770),
    [anon_sym_u00ac] = ACTIONS(5768),
    [sym_union] = ACTIONS(5770),
    [sym_powerset] = ACTIONS(5770),
    [sym_domain] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [sym_negative_dot] = ACTIONS(5768),
    [sym_enabled] = ACTIONS(5770),
    [sym_unchanged] = ACTIONS(5770),
    [anon_sym_LT_GT] = ACTIONS(5768),
    [anon_sym_u22c4] = ACTIONS(5768),
    [anon_sym_u25c7] = ACTIONS(5768),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [sym__begin_proof_step] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [2748] = {
    [sym_block_comment] = STATE(2748),
    [sym_identifier] = ACTIONS(5812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_Nat] = ACTIONS(5812),
    [anon_sym_u2115] = ACTIONS(5810),
    [anon_sym_Int] = ACTIONS(5812),
    [anon_sym_u2124] = ACTIONS(5810),
    [anon_sym_Real] = ACTIONS(5812),
    [anon_sym_u211d] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_BSLASHlnot] = ACTIONS(5810),
    [anon_sym_BSLASHneg] = ACTIONS(5810),
    [anon_sym_TILDE] = ACTIONS(5812),
    [anon_sym_u00ac] = ACTIONS(5810),
    [sym_union] = ACTIONS(5812),
    [sym_powerset] = ACTIONS(5812),
    [sym_domain] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [sym_negative_dot] = ACTIONS(5810),
    [sym_enabled] = ACTIONS(5812),
    [sym_unchanged] = ACTIONS(5812),
    [anon_sym_LT_GT] = ACTIONS(5810),
    [anon_sym_u22c4] = ACTIONS(5810),
    [anon_sym_u25c7] = ACTIONS(5810),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5810),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [sym__begin_proof_step] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [2749] = {
    [sym_block_comment] = STATE(2749),
    [sym_identifier] = ACTIONS(5816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_COMMA] = ACTIONS(5814),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_Nat] = ACTIONS(5816),
    [anon_sym_u2115] = ACTIONS(5814),
    [anon_sym_Int] = ACTIONS(5816),
    [anon_sym_u2124] = ACTIONS(5814),
    [anon_sym_Real] = ACTIONS(5816),
    [anon_sym_u211d] = ACTIONS(5814),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_BSLASHlnot] = ACTIONS(5814),
    [anon_sym_BSLASHneg] = ACTIONS(5814),
    [anon_sym_TILDE] = ACTIONS(5816),
    [anon_sym_u00ac] = ACTIONS(5814),
    [sym_union] = ACTIONS(5816),
    [sym_powerset] = ACTIONS(5816),
    [sym_domain] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [sym_negative_dot] = ACTIONS(5814),
    [sym_enabled] = ACTIONS(5816),
    [sym_unchanged] = ACTIONS(5816),
    [anon_sym_LT_GT] = ACTIONS(5814),
    [anon_sym_u22c4] = ACTIONS(5814),
    [anon_sym_u25c7] = ACTIONS(5814),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5814),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [sym__begin_proof_step] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [2750] = {
    [sym_block_comment] = STATE(2750),
    [sym_identifier] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5818),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_Nat] = ACTIONS(5820),
    [anon_sym_u2115] = ACTIONS(5818),
    [anon_sym_Int] = ACTIONS(5820),
    [anon_sym_u2124] = ACTIONS(5818),
    [anon_sym_Real] = ACTIONS(5820),
    [anon_sym_u211d] = ACTIONS(5818),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_BSLASHlnot] = ACTIONS(5818),
    [anon_sym_BSLASHneg] = ACTIONS(5818),
    [anon_sym_TILDE] = ACTIONS(5820),
    [anon_sym_u00ac] = ACTIONS(5818),
    [sym_union] = ACTIONS(5820),
    [sym_powerset] = ACTIONS(5820),
    [sym_domain] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [sym_negative_dot] = ACTIONS(5818),
    [sym_enabled] = ACTIONS(5820),
    [sym_unchanged] = ACTIONS(5820),
    [anon_sym_LT_GT] = ACTIONS(5818),
    [anon_sym_u22c4] = ACTIONS(5818),
    [anon_sym_u25c7] = ACTIONS(5818),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5818),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [sym__begin_proof_step] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [2751] = {
    [sym_block_comment] = STATE(2751),
    [sym_identifier] = ACTIONS(5758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_Nat] = ACTIONS(5758),
    [anon_sym_u2115] = ACTIONS(5756),
    [anon_sym_Int] = ACTIONS(5758),
    [anon_sym_u2124] = ACTIONS(5756),
    [anon_sym_Real] = ACTIONS(5758),
    [anon_sym_u211d] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_BSLASHlnot] = ACTIONS(5756),
    [anon_sym_BSLASHneg] = ACTIONS(5756),
    [anon_sym_TILDE] = ACTIONS(5758),
    [anon_sym_u00ac] = ACTIONS(5756),
    [sym_union] = ACTIONS(5758),
    [sym_powerset] = ACTIONS(5758),
    [sym_domain] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [sym_negative_dot] = ACTIONS(5756),
    [sym_enabled] = ACTIONS(5758),
    [sym_unchanged] = ACTIONS(5758),
    [anon_sym_LT_GT] = ACTIONS(5756),
    [anon_sym_u22c4] = ACTIONS(5756),
    [anon_sym_u25c7] = ACTIONS(5756),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5756),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [sym__begin_proof_step] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [2752] = {
    [sym_block_comment] = STATE(2752),
    [sym_identifier] = ACTIONS(5824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_Nat] = ACTIONS(5824),
    [anon_sym_u2115] = ACTIONS(5822),
    [anon_sym_Int] = ACTIONS(5824),
    [anon_sym_u2124] = ACTIONS(5822),
    [anon_sym_Real] = ACTIONS(5824),
    [anon_sym_u211d] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_BSLASHlnot] = ACTIONS(5822),
    [anon_sym_BSLASHneg] = ACTIONS(5822),
    [anon_sym_TILDE] = ACTIONS(5824),
    [anon_sym_u00ac] = ACTIONS(5822),
    [sym_union] = ACTIONS(5824),
    [sym_powerset] = ACTIONS(5824),
    [sym_domain] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [sym_negative_dot] = ACTIONS(5822),
    [sym_enabled] = ACTIONS(5824),
    [sym_unchanged] = ACTIONS(5824),
    [anon_sym_LT_GT] = ACTIONS(5822),
    [anon_sym_u22c4] = ACTIONS(5822),
    [anon_sym_u25c7] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5822),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [sym__begin_proof_step] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [2753] = {
    [sym_block_comment] = STATE(2753),
    [sym_identifier] = ACTIONS(5828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_COMMA] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_Nat] = ACTIONS(5828),
    [anon_sym_u2115] = ACTIONS(5826),
    [anon_sym_Int] = ACTIONS(5828),
    [anon_sym_u2124] = ACTIONS(5826),
    [anon_sym_Real] = ACTIONS(5828),
    [anon_sym_u211d] = ACTIONS(5826),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_BSLASHlnot] = ACTIONS(5826),
    [anon_sym_BSLASHneg] = ACTIONS(5826),
    [anon_sym_TILDE] = ACTIONS(5828),
    [anon_sym_u00ac] = ACTIONS(5826),
    [sym_union] = ACTIONS(5828),
    [sym_powerset] = ACTIONS(5828),
    [sym_domain] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [sym_negative_dot] = ACTIONS(5826),
    [sym_enabled] = ACTIONS(5828),
    [sym_unchanged] = ACTIONS(5828),
    [anon_sym_LT_GT] = ACTIONS(5826),
    [anon_sym_u22c4] = ACTIONS(5826),
    [anon_sym_u25c7] = ACTIONS(5826),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5826),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [sym__begin_proof_step] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [2754] = {
    [sym_block_comment] = STATE(2754),
    [sym_identifier] = ACTIONS(5804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_COMMA] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_Nat] = ACTIONS(5804),
    [anon_sym_u2115] = ACTIONS(5802),
    [anon_sym_Int] = ACTIONS(5804),
    [anon_sym_u2124] = ACTIONS(5802),
    [anon_sym_Real] = ACTIONS(5804),
    [anon_sym_u211d] = ACTIONS(5802),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_BSLASHlnot] = ACTIONS(5802),
    [anon_sym_BSLASHneg] = ACTIONS(5802),
    [anon_sym_TILDE] = ACTIONS(5804),
    [anon_sym_u00ac] = ACTIONS(5802),
    [sym_union] = ACTIONS(5804),
    [sym_powerset] = ACTIONS(5804),
    [sym_domain] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [sym_negative_dot] = ACTIONS(5802),
    [sym_enabled] = ACTIONS(5804),
    [sym_unchanged] = ACTIONS(5804),
    [anon_sym_LT_GT] = ACTIONS(5802),
    [anon_sym_u22c4] = ACTIONS(5802),
    [anon_sym_u25c7] = ACTIONS(5802),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5802),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [sym__begin_proof_step] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [2755] = {
    [sym_block_comment] = STATE(2755),
    [sym_identifier] = ACTIONS(5832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_COMMA] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_Nat] = ACTIONS(5832),
    [anon_sym_u2115] = ACTIONS(5830),
    [anon_sym_Int] = ACTIONS(5832),
    [anon_sym_u2124] = ACTIONS(5830),
    [anon_sym_Real] = ACTIONS(5832),
    [anon_sym_u211d] = ACTIONS(5830),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_BSLASHlnot] = ACTIONS(5830),
    [anon_sym_BSLASHneg] = ACTIONS(5830),
    [anon_sym_TILDE] = ACTIONS(5832),
    [anon_sym_u00ac] = ACTIONS(5830),
    [sym_union] = ACTIONS(5832),
    [sym_powerset] = ACTIONS(5832),
    [sym_domain] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [sym_negative_dot] = ACTIONS(5830),
    [sym_enabled] = ACTIONS(5832),
    [sym_unchanged] = ACTIONS(5832),
    [anon_sym_LT_GT] = ACTIONS(5830),
    [anon_sym_u22c4] = ACTIONS(5830),
    [anon_sym_u25c7] = ACTIONS(5830),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5830),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [sym__begin_proof_step] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [2756] = {
    [sym_block_comment] = STATE(2756),
    [sym_identifier] = ACTIONS(5762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_Nat] = ACTIONS(5762),
    [anon_sym_u2115] = ACTIONS(5760),
    [anon_sym_Int] = ACTIONS(5762),
    [anon_sym_u2124] = ACTIONS(5760),
    [anon_sym_Real] = ACTIONS(5762),
    [anon_sym_u211d] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_BSLASHlnot] = ACTIONS(5760),
    [anon_sym_BSLASHneg] = ACTIONS(5760),
    [anon_sym_TILDE] = ACTIONS(5762),
    [anon_sym_u00ac] = ACTIONS(5760),
    [sym_union] = ACTIONS(5762),
    [sym_powerset] = ACTIONS(5762),
    [sym_domain] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [sym_negative_dot] = ACTIONS(5760),
    [sym_enabled] = ACTIONS(5762),
    [sym_unchanged] = ACTIONS(5762),
    [anon_sym_LT_GT] = ACTIONS(5760),
    [anon_sym_u22c4] = ACTIONS(5760),
    [anon_sym_u25c7] = ACTIONS(5760),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5760),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [sym__begin_proof_step] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [2757] = {
    [sym_block_comment] = STATE(2757),
    [sym_identifier] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_Nat] = ACTIONS(5840),
    [anon_sym_u2115] = ACTIONS(5838),
    [anon_sym_Int] = ACTIONS(5840),
    [anon_sym_u2124] = ACTIONS(5838),
    [anon_sym_Real] = ACTIONS(5840),
    [anon_sym_u211d] = ACTIONS(5838),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_BSLASHlnot] = ACTIONS(5838),
    [anon_sym_BSLASHneg] = ACTIONS(5838),
    [anon_sym_TILDE] = ACTIONS(5840),
    [anon_sym_u00ac] = ACTIONS(5838),
    [sym_union] = ACTIONS(5840),
    [sym_powerset] = ACTIONS(5840),
    [sym_domain] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [sym_negative_dot] = ACTIONS(5838),
    [sym_enabled] = ACTIONS(5840),
    [sym_unchanged] = ACTIONS(5840),
    [anon_sym_LT_GT] = ACTIONS(5838),
    [anon_sym_u22c4] = ACTIONS(5838),
    [anon_sym_u25c7] = ACTIONS(5838),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5838),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [sym__begin_proof_step] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [2758] = {
    [sym_block_comment] = STATE(2758),
    [sym_identifier] = ACTIONS(5836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_Nat] = ACTIONS(5836),
    [anon_sym_u2115] = ACTIONS(5834),
    [anon_sym_Int] = ACTIONS(5836),
    [anon_sym_u2124] = ACTIONS(5834),
    [anon_sym_Real] = ACTIONS(5836),
    [anon_sym_u211d] = ACTIONS(5834),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_BSLASHlnot] = ACTIONS(5834),
    [anon_sym_BSLASHneg] = ACTIONS(5834),
    [anon_sym_TILDE] = ACTIONS(5836),
    [anon_sym_u00ac] = ACTIONS(5834),
    [sym_union] = ACTIONS(5836),
    [sym_powerset] = ACTIONS(5836),
    [sym_domain] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [sym_negative_dot] = ACTIONS(5834),
    [sym_enabled] = ACTIONS(5836),
    [sym_unchanged] = ACTIONS(5836),
    [anon_sym_LT_GT] = ACTIONS(5834),
    [anon_sym_u22c4] = ACTIONS(5834),
    [anon_sym_u25c7] = ACTIONS(5834),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5834),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [sym__begin_proof_step] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [2759] = {
    [sym_block_comment] = STATE(2759),
    [sym_identifier] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_COMMA] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_Nat] = ACTIONS(5844),
    [anon_sym_u2115] = ACTIONS(5842),
    [anon_sym_Int] = ACTIONS(5844),
    [anon_sym_u2124] = ACTIONS(5842),
    [anon_sym_Real] = ACTIONS(5844),
    [anon_sym_u211d] = ACTIONS(5842),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_BSLASHlnot] = ACTIONS(5842),
    [anon_sym_BSLASHneg] = ACTIONS(5842),
    [anon_sym_TILDE] = ACTIONS(5844),
    [anon_sym_u00ac] = ACTIONS(5842),
    [sym_union] = ACTIONS(5844),
    [sym_powerset] = ACTIONS(5844),
    [sym_domain] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [sym_negative_dot] = ACTIONS(5842),
    [sym_enabled] = ACTIONS(5844),
    [sym_unchanged] = ACTIONS(5844),
    [anon_sym_LT_GT] = ACTIONS(5842),
    [anon_sym_u22c4] = ACTIONS(5842),
    [anon_sym_u25c7] = ACTIONS(5842),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5842),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [sym__begin_proof_step] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [2760] = {
    [sym_block_comment] = STATE(2760),
    [sym_identifier] = ACTIONS(5864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_Nat] = ACTIONS(5864),
    [anon_sym_u2115] = ACTIONS(5862),
    [anon_sym_Int] = ACTIONS(5864),
    [anon_sym_u2124] = ACTIONS(5862),
    [anon_sym_Real] = ACTIONS(5864),
    [anon_sym_u211d] = ACTIONS(5862),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_BSLASHlnot] = ACTIONS(5862),
    [anon_sym_BSLASHneg] = ACTIONS(5862),
    [anon_sym_TILDE] = ACTIONS(5864),
    [anon_sym_u00ac] = ACTIONS(5862),
    [sym_union] = ACTIONS(5864),
    [sym_powerset] = ACTIONS(5864),
    [sym_domain] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [sym_negative_dot] = ACTIONS(5862),
    [sym_enabled] = ACTIONS(5864),
    [sym_unchanged] = ACTIONS(5864),
    [anon_sym_LT_GT] = ACTIONS(5862),
    [anon_sym_u22c4] = ACTIONS(5862),
    [anon_sym_u25c7] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5862),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [sym__begin_proof_step] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [2761] = {
    [sym_block_comment] = STATE(2761),
    [sym_identifier] = ACTIONS(5774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_Nat] = ACTIONS(5774),
    [anon_sym_u2115] = ACTIONS(5772),
    [anon_sym_Int] = ACTIONS(5774),
    [anon_sym_u2124] = ACTIONS(5772),
    [anon_sym_Real] = ACTIONS(5774),
    [anon_sym_u211d] = ACTIONS(5772),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_BSLASHlnot] = ACTIONS(5772),
    [anon_sym_BSLASHneg] = ACTIONS(5772),
    [anon_sym_TILDE] = ACTIONS(5774),
    [anon_sym_u00ac] = ACTIONS(5772),
    [sym_union] = ACTIONS(5774),
    [sym_powerset] = ACTIONS(5774),
    [sym_domain] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [sym_negative_dot] = ACTIONS(5772),
    [sym_enabled] = ACTIONS(5774),
    [sym_unchanged] = ACTIONS(5774),
    [anon_sym_LT_GT] = ACTIONS(5772),
    [anon_sym_u22c4] = ACTIONS(5772),
    [anon_sym_u25c7] = ACTIONS(5772),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5772),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [sym__begin_proof_step] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [2762] = {
    [sym_block_comment] = STATE(2762),
    [sym_identifier] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_Nat] = ACTIONS(5766),
    [anon_sym_u2115] = ACTIONS(5764),
    [anon_sym_Int] = ACTIONS(5766),
    [anon_sym_u2124] = ACTIONS(5764),
    [anon_sym_Real] = ACTIONS(5766),
    [anon_sym_u211d] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_BSLASHlnot] = ACTIONS(5764),
    [anon_sym_BSLASHneg] = ACTIONS(5764),
    [anon_sym_TILDE] = ACTIONS(5766),
    [anon_sym_u00ac] = ACTIONS(5764),
    [sym_union] = ACTIONS(5766),
    [sym_powerset] = ACTIONS(5766),
    [sym_domain] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [sym_negative_dot] = ACTIONS(5764),
    [sym_enabled] = ACTIONS(5766),
    [sym_unchanged] = ACTIONS(5766),
    [anon_sym_LT_GT] = ACTIONS(5764),
    [anon_sym_u22c4] = ACTIONS(5764),
    [anon_sym_u25c7] = ACTIONS(5764),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5764),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [sym__begin_proof_step] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [2763] = {
    [sym_block_comment] = STATE(2763),
    [sym_identifier] = ACTIONS(5848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_Nat] = ACTIONS(5848),
    [anon_sym_u2115] = ACTIONS(5846),
    [anon_sym_Int] = ACTIONS(5848),
    [anon_sym_u2124] = ACTIONS(5846),
    [anon_sym_Real] = ACTIONS(5848),
    [anon_sym_u211d] = ACTIONS(5846),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_BSLASHlnot] = ACTIONS(5846),
    [anon_sym_BSLASHneg] = ACTIONS(5846),
    [anon_sym_TILDE] = ACTIONS(5848),
    [anon_sym_u00ac] = ACTIONS(5846),
    [sym_union] = ACTIONS(5848),
    [sym_powerset] = ACTIONS(5848),
    [sym_domain] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [sym_negative_dot] = ACTIONS(5846),
    [sym_enabled] = ACTIONS(5848),
    [sym_unchanged] = ACTIONS(5848),
    [anon_sym_LT_GT] = ACTIONS(5846),
    [anon_sym_u22c4] = ACTIONS(5846),
    [anon_sym_u25c7] = ACTIONS(5846),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5846),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [sym__begin_proof_step] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [2764] = {
    [sym_block_comment] = STATE(2764),
    [sym_identifier] = ACTIONS(5874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_COMMA] = ACTIONS(5872),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_Nat] = ACTIONS(5874),
    [anon_sym_u2115] = ACTIONS(5872),
    [anon_sym_Int] = ACTIONS(5874),
    [anon_sym_u2124] = ACTIONS(5872),
    [anon_sym_Real] = ACTIONS(5874),
    [anon_sym_u211d] = ACTIONS(5872),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_BSLASHlnot] = ACTIONS(5872),
    [anon_sym_BSLASHneg] = ACTIONS(5872),
    [anon_sym_TILDE] = ACTIONS(5874),
    [anon_sym_u00ac] = ACTIONS(5872),
    [sym_union] = ACTIONS(5874),
    [sym_powerset] = ACTIONS(5874),
    [sym_domain] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [sym_negative_dot] = ACTIONS(5872),
    [sym_enabled] = ACTIONS(5874),
    [sym_unchanged] = ACTIONS(5874),
    [anon_sym_LT_GT] = ACTIONS(5872),
    [anon_sym_u22c4] = ACTIONS(5872),
    [anon_sym_u25c7] = ACTIONS(5872),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5872),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [sym__begin_proof_step] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [2765] = {
    [sym_block_comment] = STATE(2765),
    [sym_identifier] = ACTIONS(5878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_COMMA] = ACTIONS(5876),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_Nat] = ACTIONS(5878),
    [anon_sym_u2115] = ACTIONS(5876),
    [anon_sym_Int] = ACTIONS(5878),
    [anon_sym_u2124] = ACTIONS(5876),
    [anon_sym_Real] = ACTIONS(5878),
    [anon_sym_u211d] = ACTIONS(5876),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_BSLASHlnot] = ACTIONS(5876),
    [anon_sym_BSLASHneg] = ACTIONS(5876),
    [anon_sym_TILDE] = ACTIONS(5878),
    [anon_sym_u00ac] = ACTIONS(5876),
    [sym_union] = ACTIONS(5878),
    [sym_powerset] = ACTIONS(5878),
    [sym_domain] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [sym_negative_dot] = ACTIONS(5876),
    [sym_enabled] = ACTIONS(5878),
    [sym_unchanged] = ACTIONS(5878),
    [anon_sym_LT_GT] = ACTIONS(5876),
    [anon_sym_u22c4] = ACTIONS(5876),
    [anon_sym_u25c7] = ACTIONS(5876),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5876),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [sym__begin_proof_step] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [2766] = {
    [sym_block_comment] = STATE(2766),
    [sym_identifier] = ACTIONS(5754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_Nat] = ACTIONS(5754),
    [anon_sym_u2115] = ACTIONS(5752),
    [anon_sym_Int] = ACTIONS(5754),
    [anon_sym_u2124] = ACTIONS(5752),
    [anon_sym_Real] = ACTIONS(5754),
    [anon_sym_u211d] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_BSLASHlnot] = ACTIONS(5752),
    [anon_sym_BSLASHneg] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(5754),
    [anon_sym_u00ac] = ACTIONS(5752),
    [sym_union] = ACTIONS(5754),
    [sym_powerset] = ACTIONS(5754),
    [sym_domain] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [sym_negative_dot] = ACTIONS(5752),
    [sym_enabled] = ACTIONS(5754),
    [sym_unchanged] = ACTIONS(5754),
    [anon_sym_LT_GT] = ACTIONS(5752),
    [anon_sym_u22c4] = ACTIONS(5752),
    [anon_sym_u25c7] = ACTIONS(5752),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5752),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [sym__begin_proof_step] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [2767] = {
    [sym_block_comment] = STATE(2767),
    [sym_identifier] = ACTIONS(5882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_COMMA] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_Nat] = ACTIONS(5882),
    [anon_sym_u2115] = ACTIONS(5880),
    [anon_sym_Int] = ACTIONS(5882),
    [anon_sym_u2124] = ACTIONS(5880),
    [anon_sym_Real] = ACTIONS(5882),
    [anon_sym_u211d] = ACTIONS(5880),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_BSLASHlnot] = ACTIONS(5880),
    [anon_sym_BSLASHneg] = ACTIONS(5880),
    [anon_sym_TILDE] = ACTIONS(5882),
    [anon_sym_u00ac] = ACTIONS(5880),
    [sym_union] = ACTIONS(5882),
    [sym_powerset] = ACTIONS(5882),
    [sym_domain] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [sym_negative_dot] = ACTIONS(5880),
    [sym_enabled] = ACTIONS(5882),
    [sym_unchanged] = ACTIONS(5882),
    [anon_sym_LT_GT] = ACTIONS(5880),
    [anon_sym_u22c4] = ACTIONS(5880),
    [anon_sym_u25c7] = ACTIONS(5880),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5880),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [sym__begin_proof_step] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [2768] = {
    [sym_block_comment] = STATE(2768),
    [sym_identifier] = ACTIONS(5936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_Nat] = ACTIONS(5936),
    [anon_sym_u2115] = ACTIONS(5938),
    [anon_sym_Int] = ACTIONS(5936),
    [anon_sym_u2124] = ACTIONS(5938),
    [anon_sym_Real] = ACTIONS(5936),
    [anon_sym_u211d] = ACTIONS(5938),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_BSLASHlnot] = ACTIONS(5938),
    [anon_sym_BSLASHneg] = ACTIONS(5938),
    [anon_sym_TILDE] = ACTIONS(5936),
    [anon_sym_u00ac] = ACTIONS(5938),
    [sym_union] = ACTIONS(5936),
    [sym_powerset] = ACTIONS(5936),
    [sym_domain] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [sym_negative_dot] = ACTIONS(5938),
    [sym_enabled] = ACTIONS(5936),
    [sym_unchanged] = ACTIONS(5936),
    [anon_sym_LT_GT] = ACTIONS(5938),
    [anon_sym_u22c4] = ACTIONS(5938),
    [anon_sym_u25c7] = ACTIONS(5938),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5938),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [sym__begin_proof_step] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [2769] = {
    [sym_block_comment] = STATE(2769),
    [sym_identifier] = ACTIONS(5886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_COMMA] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_Nat] = ACTIONS(5886),
    [anon_sym_u2115] = ACTIONS(5884),
    [anon_sym_Int] = ACTIONS(5886),
    [anon_sym_u2124] = ACTIONS(5884),
    [anon_sym_Real] = ACTIONS(5886),
    [anon_sym_u211d] = ACTIONS(5884),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_BSLASHlnot] = ACTIONS(5884),
    [anon_sym_BSLASHneg] = ACTIONS(5884),
    [anon_sym_TILDE] = ACTIONS(5886),
    [anon_sym_u00ac] = ACTIONS(5884),
    [sym_union] = ACTIONS(5886),
    [sym_powerset] = ACTIONS(5886),
    [sym_domain] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [sym_negative_dot] = ACTIONS(5884),
    [sym_enabled] = ACTIONS(5886),
    [sym_unchanged] = ACTIONS(5886),
    [anon_sym_LT_GT] = ACTIONS(5884),
    [anon_sym_u22c4] = ACTIONS(5884),
    [anon_sym_u25c7] = ACTIONS(5884),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5884),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [sym__begin_proof_step] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [2770] = {
    [sym_block_comment] = STATE(2770),
    [sym_identifier] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_Nat] = ACTIONS(5706),
    [anon_sym_u2115] = ACTIONS(5704),
    [anon_sym_Int] = ACTIONS(5706),
    [anon_sym_u2124] = ACTIONS(5704),
    [anon_sym_Real] = ACTIONS(5706),
    [anon_sym_u211d] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_BSLASHlnot] = ACTIONS(5704),
    [anon_sym_BSLASHneg] = ACTIONS(5704),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_u00ac] = ACTIONS(5704),
    [sym_union] = ACTIONS(5706),
    [sym_powerset] = ACTIONS(5706),
    [sym_domain] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [sym_negative_dot] = ACTIONS(5704),
    [sym_enabled] = ACTIONS(5706),
    [sym_unchanged] = ACTIONS(5706),
    [anon_sym_LT_GT] = ACTIONS(5704),
    [anon_sym_u22c4] = ACTIONS(5704),
    [anon_sym_u25c7] = ACTIONS(5704),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__begin_proof_step] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2771] = {
    [sym_block_comment] = STATE(2771),
    [sym_identifier] = ACTIONS(5910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_Nat] = ACTIONS(5910),
    [anon_sym_u2115] = ACTIONS(5908),
    [anon_sym_Int] = ACTIONS(5910),
    [anon_sym_u2124] = ACTIONS(5908),
    [anon_sym_Real] = ACTIONS(5910),
    [anon_sym_u211d] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_BSLASHlnot] = ACTIONS(5908),
    [anon_sym_BSLASHneg] = ACTIONS(5908),
    [anon_sym_TILDE] = ACTIONS(5910),
    [anon_sym_u00ac] = ACTIONS(5908),
    [sym_union] = ACTIONS(5910),
    [sym_powerset] = ACTIONS(5910),
    [sym_domain] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [sym_negative_dot] = ACTIONS(5908),
    [sym_enabled] = ACTIONS(5910),
    [sym_unchanged] = ACTIONS(5910),
    [anon_sym_LT_GT] = ACTIONS(5908),
    [anon_sym_u22c4] = ACTIONS(5908),
    [anon_sym_u25c7] = ACTIONS(5908),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5908),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [sym__begin_proof_step] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [2772] = {
    [sym_block_comment] = STATE(2772),
    [sym_identifier] = ACTIONS(5894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_Nat] = ACTIONS(5894),
    [anon_sym_u2115] = ACTIONS(5892),
    [anon_sym_Int] = ACTIONS(5894),
    [anon_sym_u2124] = ACTIONS(5892),
    [anon_sym_Real] = ACTIONS(5894),
    [anon_sym_u211d] = ACTIONS(5892),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_BSLASHlnot] = ACTIONS(5892),
    [anon_sym_BSLASHneg] = ACTIONS(5892),
    [anon_sym_TILDE] = ACTIONS(5894),
    [anon_sym_u00ac] = ACTIONS(5892),
    [sym_union] = ACTIONS(5894),
    [sym_powerset] = ACTIONS(5894),
    [sym_domain] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [sym_negative_dot] = ACTIONS(5892),
    [sym_enabled] = ACTIONS(5894),
    [sym_unchanged] = ACTIONS(5894),
    [anon_sym_LT_GT] = ACTIONS(5892),
    [anon_sym_u22c4] = ACTIONS(5892),
    [anon_sym_u25c7] = ACTIONS(5892),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [sym__begin_proof_step] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [2773] = {
    [sym_block_comment] = STATE(2773),
    [sym_identifier] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_COMMA] = ACTIONS(5896),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_Nat] = ACTIONS(5898),
    [anon_sym_u2115] = ACTIONS(5896),
    [anon_sym_Int] = ACTIONS(5898),
    [anon_sym_u2124] = ACTIONS(5896),
    [anon_sym_Real] = ACTIONS(5898),
    [anon_sym_u211d] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_BSLASHlnot] = ACTIONS(5896),
    [anon_sym_BSLASHneg] = ACTIONS(5896),
    [anon_sym_TILDE] = ACTIONS(5898),
    [anon_sym_u00ac] = ACTIONS(5896),
    [sym_union] = ACTIONS(5898),
    [sym_powerset] = ACTIONS(5898),
    [sym_domain] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [sym_negative_dot] = ACTIONS(5896),
    [sym_enabled] = ACTIONS(5898),
    [sym_unchanged] = ACTIONS(5898),
    [anon_sym_LT_GT] = ACTIONS(5896),
    [anon_sym_u22c4] = ACTIONS(5896),
    [anon_sym_u25c7] = ACTIONS(5896),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [sym__begin_proof_step] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [2774] = {
    [sym_block_comment] = STATE(2774),
    [sym_identifier] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_COMMA] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_Nat] = ACTIONS(5902),
    [anon_sym_u2115] = ACTIONS(5900),
    [anon_sym_Int] = ACTIONS(5902),
    [anon_sym_u2124] = ACTIONS(5900),
    [anon_sym_Real] = ACTIONS(5902),
    [anon_sym_u211d] = ACTIONS(5900),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_BSLASHlnot] = ACTIONS(5900),
    [anon_sym_BSLASHneg] = ACTIONS(5900),
    [anon_sym_TILDE] = ACTIONS(5902),
    [anon_sym_u00ac] = ACTIONS(5900),
    [sym_union] = ACTIONS(5902),
    [sym_powerset] = ACTIONS(5902),
    [sym_domain] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [sym_negative_dot] = ACTIONS(5900),
    [sym_enabled] = ACTIONS(5902),
    [sym_unchanged] = ACTIONS(5902),
    [anon_sym_LT_GT] = ACTIONS(5900),
    [anon_sym_u22c4] = ACTIONS(5900),
    [anon_sym_u25c7] = ACTIONS(5900),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [sym__begin_proof_step] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [2775] = {
    [sym_block_comment] = STATE(2775),
    [sym_identifier] = ACTIONS(5906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_Nat] = ACTIONS(5906),
    [anon_sym_u2115] = ACTIONS(5904),
    [anon_sym_Int] = ACTIONS(5906),
    [anon_sym_u2124] = ACTIONS(5904),
    [anon_sym_Real] = ACTIONS(5906),
    [anon_sym_u211d] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_BSLASHlnot] = ACTIONS(5904),
    [anon_sym_BSLASHneg] = ACTIONS(5904),
    [anon_sym_TILDE] = ACTIONS(5906),
    [anon_sym_u00ac] = ACTIONS(5904),
    [sym_union] = ACTIONS(5906),
    [sym_powerset] = ACTIONS(5906),
    [sym_domain] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [sym_negative_dot] = ACTIONS(5904),
    [sym_enabled] = ACTIONS(5906),
    [sym_unchanged] = ACTIONS(5906),
    [anon_sym_LT_GT] = ACTIONS(5904),
    [anon_sym_u22c4] = ACTIONS(5904),
    [anon_sym_u25c7] = ACTIONS(5904),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [sym__begin_proof_step] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [2776] = {
    [sym_block_comment] = STATE(2776),
    [sym_identifier] = ACTIONS(5914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_COMMA] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_Nat] = ACTIONS(5914),
    [anon_sym_u2115] = ACTIONS(5912),
    [anon_sym_Int] = ACTIONS(5914),
    [anon_sym_u2124] = ACTIONS(5912),
    [anon_sym_Real] = ACTIONS(5914),
    [anon_sym_u211d] = ACTIONS(5912),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_BSLASHlnot] = ACTIONS(5912),
    [anon_sym_BSLASHneg] = ACTIONS(5912),
    [anon_sym_TILDE] = ACTIONS(5914),
    [anon_sym_u00ac] = ACTIONS(5912),
    [sym_union] = ACTIONS(5914),
    [sym_powerset] = ACTIONS(5914),
    [sym_domain] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [sym_negative_dot] = ACTIONS(5912),
    [sym_enabled] = ACTIONS(5914),
    [sym_unchanged] = ACTIONS(5914),
    [anon_sym_LT_GT] = ACTIONS(5912),
    [anon_sym_u22c4] = ACTIONS(5912),
    [anon_sym_u25c7] = ACTIONS(5912),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5912),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [sym__begin_proof_step] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [2777] = {
    [sym_block_comment] = STATE(2777),
    [sym_identifier] = ACTIONS(5850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_Nat] = ACTIONS(5850),
    [anon_sym_u2115] = ACTIONS(5852),
    [anon_sym_Int] = ACTIONS(5850),
    [anon_sym_u2124] = ACTIONS(5852),
    [anon_sym_Real] = ACTIONS(5850),
    [anon_sym_u211d] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_BSLASHlnot] = ACTIONS(5852),
    [anon_sym_BSLASHneg] = ACTIONS(5852),
    [anon_sym_TILDE] = ACTIONS(5850),
    [anon_sym_u00ac] = ACTIONS(5852),
    [sym_union] = ACTIONS(5850),
    [sym_powerset] = ACTIONS(5850),
    [sym_domain] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [sym_negative_dot] = ACTIONS(5852),
    [sym_enabled] = ACTIONS(5850),
    [sym_unchanged] = ACTIONS(5850),
    [anon_sym_LT_GT] = ACTIONS(5852),
    [anon_sym_u22c4] = ACTIONS(5852),
    [anon_sym_u25c7] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5852),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [sym__begin_proof_step] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [2778] = {
    [sym_block_comment] = STATE(2778),
    [sym_identifier] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_Nat] = ACTIONS(5349),
    [anon_sym_u2115] = ACTIONS(5351),
    [anon_sym_Int] = ACTIONS(5349),
    [anon_sym_u2124] = ACTIONS(5351),
    [anon_sym_Real] = ACTIONS(5349),
    [anon_sym_u211d] = ACTIONS(5351),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_BSLASHlnot] = ACTIONS(5351),
    [anon_sym_BSLASHneg] = ACTIONS(5351),
    [anon_sym_TILDE] = ACTIONS(5349),
    [anon_sym_u00ac] = ACTIONS(5351),
    [sym_union] = ACTIONS(5349),
    [sym_powerset] = ACTIONS(5349),
    [sym_domain] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [sym_negative_dot] = ACTIONS(5351),
    [sym_enabled] = ACTIONS(5349),
    [sym_unchanged] = ACTIONS(5349),
    [anon_sym_LT_GT] = ACTIONS(5351),
    [anon_sym_u22c4] = ACTIONS(5351),
    [anon_sym_u25c7] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [sym__begin_proof_step] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [2779] = {
    [sym_block_comment] = STATE(2779),
    [sym_identifier] = ACTIONS(5940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_Nat] = ACTIONS(5940),
    [anon_sym_u2115] = ACTIONS(5942),
    [anon_sym_Int] = ACTIONS(5940),
    [anon_sym_u2124] = ACTIONS(5942),
    [anon_sym_Real] = ACTIONS(5940),
    [anon_sym_u211d] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_BSLASHlnot] = ACTIONS(5942),
    [anon_sym_BSLASHneg] = ACTIONS(5942),
    [anon_sym_TILDE] = ACTIONS(5940),
    [anon_sym_u00ac] = ACTIONS(5942),
    [sym_union] = ACTIONS(5940),
    [sym_powerset] = ACTIONS(5940),
    [sym_domain] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [sym_negative_dot] = ACTIONS(5942),
    [sym_enabled] = ACTIONS(5940),
    [sym_unchanged] = ACTIONS(5940),
    [anon_sym_LT_GT] = ACTIONS(5942),
    [anon_sym_u22c4] = ACTIONS(5942),
    [anon_sym_u25c7] = ACTIONS(5942),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5942),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [sym__begin_proof_step] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [2780] = {
    [sym_block_comment] = STATE(2780),
    [sym_identifier] = ACTIONS(5918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_Nat] = ACTIONS(5918),
    [anon_sym_u2115] = ACTIONS(5916),
    [anon_sym_Int] = ACTIONS(5918),
    [anon_sym_u2124] = ACTIONS(5916),
    [anon_sym_Real] = ACTIONS(5918),
    [anon_sym_u211d] = ACTIONS(5916),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_BSLASHlnot] = ACTIONS(5916),
    [anon_sym_BSLASHneg] = ACTIONS(5916),
    [anon_sym_TILDE] = ACTIONS(5918),
    [anon_sym_u00ac] = ACTIONS(5916),
    [sym_union] = ACTIONS(5918),
    [sym_powerset] = ACTIONS(5918),
    [sym_domain] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [sym_negative_dot] = ACTIONS(5916),
    [sym_enabled] = ACTIONS(5918),
    [sym_unchanged] = ACTIONS(5918),
    [anon_sym_LT_GT] = ACTIONS(5916),
    [anon_sym_u22c4] = ACTIONS(5916),
    [anon_sym_u25c7] = ACTIONS(5916),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5916),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [sym__begin_proof_step] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [2781] = {
    [sym_block_comment] = STATE(2781),
    [sym_identifier] = ACTIONS(5922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_Nat] = ACTIONS(5922),
    [anon_sym_u2115] = ACTIONS(5920),
    [anon_sym_Int] = ACTIONS(5922),
    [anon_sym_u2124] = ACTIONS(5920),
    [anon_sym_Real] = ACTIONS(5922),
    [anon_sym_u211d] = ACTIONS(5920),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_BSLASHlnot] = ACTIONS(5920),
    [anon_sym_BSLASHneg] = ACTIONS(5920),
    [anon_sym_TILDE] = ACTIONS(5922),
    [anon_sym_u00ac] = ACTIONS(5920),
    [sym_union] = ACTIONS(5922),
    [sym_powerset] = ACTIONS(5922),
    [sym_domain] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [sym_negative_dot] = ACTIONS(5920),
    [sym_enabled] = ACTIONS(5922),
    [sym_unchanged] = ACTIONS(5922),
    [anon_sym_LT_GT] = ACTIONS(5920),
    [anon_sym_u22c4] = ACTIONS(5920),
    [anon_sym_u25c7] = ACTIONS(5920),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5920),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [sym__begin_proof_step] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [2782] = {
    [sym_block_comment] = STATE(2782),
    [sym_identifier] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_COMMA] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_Nat] = ACTIONS(5726),
    [anon_sym_u2115] = ACTIONS(5724),
    [anon_sym_Int] = ACTIONS(5726),
    [anon_sym_u2124] = ACTIONS(5724),
    [anon_sym_Real] = ACTIONS(5726),
    [anon_sym_u211d] = ACTIONS(5724),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_BSLASHlnot] = ACTIONS(5724),
    [anon_sym_BSLASHneg] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5726),
    [anon_sym_u00ac] = ACTIONS(5724),
    [sym_union] = ACTIONS(5726),
    [sym_powerset] = ACTIONS(5726),
    [sym_domain] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [sym_negative_dot] = ACTIONS(5724),
    [sym_enabled] = ACTIONS(5726),
    [sym_unchanged] = ACTIONS(5726),
    [anon_sym_LT_GT] = ACTIONS(5724),
    [anon_sym_u22c4] = ACTIONS(5724),
    [anon_sym_u25c7] = ACTIONS(5724),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5724),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [sym__begin_proof_step] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [2783] = {
    [sym_block_comment] = STATE(2783),
    [sym_identifier] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_Nat] = ACTIONS(5688),
    [anon_sym_u2115] = ACTIONS(5690),
    [anon_sym_Int] = ACTIONS(5688),
    [anon_sym_u2124] = ACTIONS(5690),
    [anon_sym_Real] = ACTIONS(5688),
    [anon_sym_u211d] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_BSLASHlnot] = ACTIONS(5690),
    [anon_sym_BSLASHneg] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5688),
    [anon_sym_u00ac] = ACTIONS(5690),
    [sym_union] = ACTIONS(5688),
    [sym_powerset] = ACTIONS(5688),
    [sym_domain] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym_negative_dot] = ACTIONS(5690),
    [sym_enabled] = ACTIONS(5688),
    [sym_unchanged] = ACTIONS(5688),
    [anon_sym_LT_GT] = ACTIONS(5690),
    [anon_sym_u22c4] = ACTIONS(5690),
    [anon_sym_u25c7] = ACTIONS(5690),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__begin_proof_step] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2784] = {
    [sym_block_comment] = STATE(2784),
    [sym_identifier] = ACTIONS(5868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_Nat] = ACTIONS(5868),
    [anon_sym_u2115] = ACTIONS(5870),
    [anon_sym_Int] = ACTIONS(5868),
    [anon_sym_u2124] = ACTIONS(5870),
    [anon_sym_Real] = ACTIONS(5868),
    [anon_sym_u211d] = ACTIONS(5870),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_BSLASHlnot] = ACTIONS(5870),
    [anon_sym_BSLASHneg] = ACTIONS(5870),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_u00ac] = ACTIONS(5870),
    [sym_union] = ACTIONS(5868),
    [sym_powerset] = ACTIONS(5868),
    [sym_domain] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [sym_negative_dot] = ACTIONS(5870),
    [sym_enabled] = ACTIONS(5868),
    [sym_unchanged] = ACTIONS(5868),
    [anon_sym_LT_GT] = ACTIONS(5870),
    [anon_sym_u22c4] = ACTIONS(5870),
    [anon_sym_u25c7] = ACTIONS(5870),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5870),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [sym__begin_proof_step] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [2785] = {
    [sym_block_comment] = STATE(2785),
    [sym_identifier] = ACTIONS(5924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_Nat] = ACTIONS(5924),
    [anon_sym_u2115] = ACTIONS(5926),
    [anon_sym_Int] = ACTIONS(5924),
    [anon_sym_u2124] = ACTIONS(5926),
    [anon_sym_Real] = ACTIONS(5924),
    [anon_sym_u211d] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_BSLASHlnot] = ACTIONS(5926),
    [anon_sym_BSLASHneg] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5924),
    [anon_sym_u00ac] = ACTIONS(5926),
    [sym_union] = ACTIONS(5924),
    [sym_powerset] = ACTIONS(5924),
    [sym_domain] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [sym_negative_dot] = ACTIONS(5926),
    [sym_enabled] = ACTIONS(5924),
    [sym_unchanged] = ACTIONS(5924),
    [anon_sym_LT_GT] = ACTIONS(5926),
    [anon_sym_u22c4] = ACTIONS(5926),
    [anon_sym_u25c7] = ACTIONS(5926),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5926),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [sym__begin_proof_step] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [2786] = {
    [sym_block_comment] = STATE(2786),
    [sym_identifier] = ACTIONS(5928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_Nat] = ACTIONS(5928),
    [anon_sym_u2115] = ACTIONS(5930),
    [anon_sym_Int] = ACTIONS(5928),
    [anon_sym_u2124] = ACTIONS(5930),
    [anon_sym_Real] = ACTIONS(5928),
    [anon_sym_u211d] = ACTIONS(5930),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_BSLASHlnot] = ACTIONS(5930),
    [anon_sym_BSLASHneg] = ACTIONS(5930),
    [anon_sym_TILDE] = ACTIONS(5928),
    [anon_sym_u00ac] = ACTIONS(5930),
    [sym_union] = ACTIONS(5928),
    [sym_powerset] = ACTIONS(5928),
    [sym_domain] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [sym_negative_dot] = ACTIONS(5930),
    [sym_enabled] = ACTIONS(5928),
    [sym_unchanged] = ACTIONS(5928),
    [anon_sym_LT_GT] = ACTIONS(5930),
    [anon_sym_u22c4] = ACTIONS(5930),
    [anon_sym_u25c7] = ACTIONS(5930),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5930),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [sym__begin_proof_step] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [2787] = {
    [sym_block_comment] = STATE(2787),
    [sym_identifier] = ACTIONS(5932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_Nat] = ACTIONS(5932),
    [anon_sym_u2115] = ACTIONS(5934),
    [anon_sym_Int] = ACTIONS(5932),
    [anon_sym_u2124] = ACTIONS(5934),
    [anon_sym_Real] = ACTIONS(5932),
    [anon_sym_u211d] = ACTIONS(5934),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_BSLASHlnot] = ACTIONS(5934),
    [anon_sym_BSLASHneg] = ACTIONS(5934),
    [anon_sym_TILDE] = ACTIONS(5932),
    [anon_sym_u00ac] = ACTIONS(5934),
    [sym_union] = ACTIONS(5932),
    [sym_powerset] = ACTIONS(5932),
    [sym_domain] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [sym_negative_dot] = ACTIONS(5934),
    [sym_enabled] = ACTIONS(5932),
    [sym_unchanged] = ACTIONS(5932),
    [anon_sym_LT_GT] = ACTIONS(5934),
    [anon_sym_u22c4] = ACTIONS(5934),
    [anon_sym_u25c7] = ACTIONS(5934),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5934),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [sym__begin_proof_step] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [2788] = {
    [sym_block_comment] = STATE(2788),
    [sym_identifier] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_Nat] = ACTIONS(5738),
    [anon_sym_u2115] = ACTIONS(5736),
    [anon_sym_Int] = ACTIONS(5738),
    [anon_sym_u2124] = ACTIONS(5736),
    [anon_sym_Real] = ACTIONS(5738),
    [anon_sym_u211d] = ACTIONS(5736),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_BSLASHlnot] = ACTIONS(5736),
    [anon_sym_BSLASHneg] = ACTIONS(5736),
    [anon_sym_TILDE] = ACTIONS(5738),
    [anon_sym_u00ac] = ACTIONS(5736),
    [sym_union] = ACTIONS(5738),
    [sym_powerset] = ACTIONS(5738),
    [sym_domain] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [sym_negative_dot] = ACTIONS(5736),
    [sym_enabled] = ACTIONS(5738),
    [sym_unchanged] = ACTIONS(5738),
    [anon_sym_LT_GT] = ACTIONS(5736),
    [anon_sym_u22c4] = ACTIONS(5736),
    [anon_sym_u25c7] = ACTIONS(5736),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5736),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [sym__begin_proof_step] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [2789] = {
    [sym_block_comment] = STATE(2789),
    [sym_identifier] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_Nat] = ACTIONS(5730),
    [anon_sym_u2115] = ACTIONS(5728),
    [anon_sym_Int] = ACTIONS(5730),
    [anon_sym_u2124] = ACTIONS(5728),
    [anon_sym_Real] = ACTIONS(5730),
    [anon_sym_u211d] = ACTIONS(5728),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_BSLASHlnot] = ACTIONS(5728),
    [anon_sym_BSLASHneg] = ACTIONS(5728),
    [anon_sym_TILDE] = ACTIONS(5730),
    [anon_sym_u00ac] = ACTIONS(5728),
    [sym_union] = ACTIONS(5730),
    [sym_powerset] = ACTIONS(5730),
    [sym_domain] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [sym_negative_dot] = ACTIONS(5728),
    [sym_enabled] = ACTIONS(5730),
    [sym_unchanged] = ACTIONS(5730),
    [anon_sym_LT_GT] = ACTIONS(5728),
    [anon_sym_u22c4] = ACTIONS(5728),
    [anon_sym_u25c7] = ACTIONS(5728),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5728),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [sym__begin_proof_step] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [2790] = {
    [sym_block_comment] = STATE(2790),
    [sym_identifier] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_Nat] = ACTIONS(5746),
    [anon_sym_u2115] = ACTIONS(5744),
    [anon_sym_Int] = ACTIONS(5746),
    [anon_sym_u2124] = ACTIONS(5744),
    [anon_sym_Real] = ACTIONS(5746),
    [anon_sym_u211d] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_BSLASHlnot] = ACTIONS(5744),
    [anon_sym_BSLASHneg] = ACTIONS(5744),
    [anon_sym_TILDE] = ACTIONS(5746),
    [anon_sym_u00ac] = ACTIONS(5744),
    [sym_union] = ACTIONS(5746),
    [sym_powerset] = ACTIONS(5746),
    [sym_domain] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [sym_negative_dot] = ACTIONS(5744),
    [sym_enabled] = ACTIONS(5746),
    [sym_unchanged] = ACTIONS(5746),
    [anon_sym_LT_GT] = ACTIONS(5744),
    [anon_sym_u22c4] = ACTIONS(5744),
    [anon_sym_u25c7] = ACTIONS(5744),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5744),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [sym__begin_proof_step] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [2791] = {
    [sym_block_comment] = STATE(2791),
    [sym_identifier] = ACTIONS(5808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_Nat] = ACTIONS(5808),
    [anon_sym_u2115] = ACTIONS(5806),
    [anon_sym_Int] = ACTIONS(5808),
    [anon_sym_u2124] = ACTIONS(5806),
    [anon_sym_Real] = ACTIONS(5808),
    [anon_sym_u211d] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_BSLASHlnot] = ACTIONS(5806),
    [anon_sym_BSLASHneg] = ACTIONS(5806),
    [anon_sym_TILDE] = ACTIONS(5808),
    [anon_sym_u00ac] = ACTIONS(5806),
    [sym_union] = ACTIONS(5808),
    [sym_powerset] = ACTIONS(5808),
    [sym_domain] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [sym_negative_dot] = ACTIONS(5806),
    [sym_enabled] = ACTIONS(5808),
    [sym_unchanged] = ACTIONS(5808),
    [anon_sym_LT_GT] = ACTIONS(5806),
    [anon_sym_u22c4] = ACTIONS(5806),
    [anon_sym_u25c7] = ACTIONS(5806),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5806),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [sym__begin_proof_step] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [2792] = {
    [sym_block_comment] = STATE(2792),
    [sym_identifier] = ACTIONS(5960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5960),
    [anon_sym_u2208] = ACTIONS(5962),
    [anon_sym_LT_LT] = ACTIONS(5962),
    [anon_sym_u3008] = ACTIONS(5962),
    [anon_sym_u27e8] = ACTIONS(5962),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5962),
    [anon_sym_u25a1] = ACTIONS(5962),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5962),
    [anon_sym_u2227] = ACTIONS(5962),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5962),
    [anon_sym_u2228] = ACTIONS(5962),
    [anon_sym_LPAREN] = ACTIONS(5960),
    [anon_sym_LBRACK] = ACTIONS(5960),
    [anon_sym_BSLASHo] = ACTIONS(5960),
    [anon_sym_LBRACE] = ACTIONS(5962),
    [anon_sym_EQ] = ACTIONS(5960),
    [anon_sym_BSLASHlnot] = ACTIONS(5962),
    [anon_sym_BSLASHneg] = ACTIONS(5962),
    [anon_sym_TILDE] = ACTIONS(5960),
    [anon_sym_u00ac] = ACTIONS(5962),
    [sym_union] = ACTIONS(5960),
    [sym_powerset] = ACTIONS(5960),
    [sym_domain] = ACTIONS(5960),
    [anon_sym_DASH] = ACTIONS(5960),
    [sym_negative_dot] = ACTIONS(5962),
    [sym_enabled] = ACTIONS(5960),
    [sym_unchanged] = ACTIONS(5960),
    [anon_sym_LT_GT] = ACTIONS(5962),
    [anon_sym_u22c4] = ACTIONS(5962),
    [anon_sym_u25c7] = ACTIONS(5962),
    [anon_sym_EQ_GT] = ACTIONS(5962),
    [anon_sym_u27f9] = ACTIONS(5962),
    [anon_sym_u21d2] = ACTIONS(5962),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5962),
    [anon_sym_u21f8] = ACTIONS(5962),
    [anon_sym_u2945] = ACTIONS(5962),
    [anon_sym_BSLASHequiv] = ACTIONS(5962),
    [anon_sym_u2261] = ACTIONS(5962),
    [anon_sym_LT_EQ_GT] = ACTIONS(5962),
    [anon_sym_u27fa] = ACTIONS(5962),
    [anon_sym_u21d4] = ACTIONS(5962),
    [anon_sym_TILDE_GT] = ACTIONS(5962),
    [anon_sym_u21dd] = ACTIONS(5962),
    [anon_sym_u219d] = ACTIONS(5962),
    [anon_sym_BSLASHland] = ACTIONS(5962),
    [anon_sym_BSLASHlor] = ACTIONS(5962),
    [anon_sym_COLON_EQ] = ACTIONS(5962),
    [anon_sym_u2254] = ACTIONS(5962),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5962),
    [anon_sym_u2a74] = ACTIONS(5962),
    [anon_sym_SLASH_EQ] = ACTIONS(5962),
    [anon_sym_POUND] = ACTIONS(5960),
    [anon_sym_u2260] = ACTIONS(5962),
    [anon_sym_LT] = ACTIONS(5960),
    [sym_gt] = ACTIONS(5960),
    [anon_sym_LT_EQ] = ACTIONS(5960),
    [anon_sym_EQ_LT] = ACTIONS(5962),
    [anon_sym_BSLASHleq] = ACTIONS(5962),
    [anon_sym_u2264] = ACTIONS(5962),
    [anon_sym_GT_EQ] = ACTIONS(5962),
    [anon_sym_BSLASHgeq] = ACTIONS(5962),
    [anon_sym_u2265] = ACTIONS(5962),
    [anon_sym_BSLASHapprox] = ACTIONS(5962),
    [anon_sym_u2248] = ACTIONS(5962),
    [anon_sym_PIPE_DASH] = ACTIONS(5962),
    [anon_sym_u22a2] = ACTIONS(5962),
    [anon_sym_PIPE_EQ] = ACTIONS(5962),
    [anon_sym_u22a8] = ACTIONS(5962),
    [anon_sym_DASH_PIPE] = ACTIONS(5962),
    [anon_sym_u22a3] = ACTIONS(5962),
    [anon_sym_EQ_PIPE] = ACTIONS(5962),
    [anon_sym_u2ae4] = ACTIONS(5962),
    [anon_sym_BSLASHasymp] = ACTIONS(5962),
    [anon_sym_u224d] = ACTIONS(5962),
    [anon_sym_BSLASHcong] = ACTIONS(5962),
    [anon_sym_u2245] = ACTIONS(5962),
    [anon_sym_BSLASHdoteq] = ACTIONS(5962),
    [anon_sym_u2250] = ACTIONS(5962),
    [anon_sym_BSLASHgg] = ACTIONS(5962),
    [anon_sym_u226b] = ACTIONS(5962),
    [anon_sym_BSLASHll] = ACTIONS(5962),
    [anon_sym_u226a] = ACTIONS(5962),
    [anon_sym_BSLASHnotin] = ACTIONS(5962),
    [anon_sym_u2209] = ACTIONS(5962),
    [anon_sym_BSLASHprec] = ACTIONS(5960),
    [anon_sym_u227a] = ACTIONS(5962),
    [anon_sym_BSLASHsucc] = ACTIONS(5960),
    [anon_sym_u227b] = ACTIONS(5962),
    [anon_sym_BSLASHpreceq] = ACTIONS(5962),
    [anon_sym_u2aaf] = ACTIONS(5962),
    [anon_sym_BSLASHsucceq] = ACTIONS(5962),
    [anon_sym_u2ab0] = ACTIONS(5962),
    [anon_sym_BSLASHpropto] = ACTIONS(5962),
    [anon_sym_u221d] = ACTIONS(5962),
    [anon_sym_BSLASHsim] = ACTIONS(5960),
    [anon_sym_u223c] = ACTIONS(5962),
    [anon_sym_BSLASHsimeq] = ACTIONS(5962),
    [anon_sym_u2243] = ACTIONS(5962),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5960),
    [anon_sym_u228f] = ACTIONS(5962),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5960),
    [anon_sym_u2290] = ACTIONS(5962),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5962),
    [anon_sym_u2291] = ACTIONS(5962),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5962),
    [anon_sym_u2292] = ACTIONS(5962),
    [anon_sym_BSLASHsubset] = ACTIONS(5960),
    [anon_sym_u2282] = ACTIONS(5962),
    [anon_sym_BSLASHsupset] = ACTIONS(5960),
    [anon_sym_u2283] = ACTIONS(5962),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5962),
    [anon_sym_u2286] = ACTIONS(5962),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5962),
    [anon_sym_u2287] = ACTIONS(5962),
    [sym_compose] = ACTIONS(5962),
    [sym_map_to] = ACTIONS(5962),
    [sym_map_from] = ACTIONS(5962),
    [sym_setminus] = ACTIONS(5960),
    [anon_sym_BSLASHcap] = ACTIONS(5962),
    [anon_sym_BSLASHintersect] = ACTIONS(5962),
    [anon_sym_u2229] = ACTIONS(5962),
    [anon_sym_BSLASHcup] = ACTIONS(5962),
    [anon_sym_BSLASHunion] = ACTIONS(5962),
    [anon_sym_u222a] = ACTIONS(5962),
    [anon_sym_DOT_DOT] = ACTIONS(5960),
    [anon_sym_u2025] = ACTIONS(5962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_u2026] = ACTIONS(5962),
    [anon_sym_PLUS] = ACTIONS(5960),
    [sym_plusplus] = ACTIONS(5962),
    [anon_sym_BSLASHoplus] = ACTIONS(5962),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5962),
    [anon_sym_u2295] = ACTIONS(5962),
    [anon_sym_BSLASHominus] = ACTIONS(5962),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5962),
    [anon_sym_u2296] = ACTIONS(5962),
    [sym_mod] = ACTIONS(5960),
    [sym_modmod] = ACTIONS(5962),
    [sym_vert] = ACTIONS(5960),
    [anon_sym_PIPE_PIPE] = ACTIONS(5962),
    [anon_sym_u2016] = ACTIONS(5962),
    [sym_minusminus] = ACTIONS(5962),
    [sym_amp] = ACTIONS(5960),
    [sym_ampamp] = ACTIONS(5962),
    [anon_sym_BSLASHodot] = ACTIONS(5962),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5962),
    [anon_sym_u2299] = ACTIONS(5962),
    [anon_sym_BSLASHoslash] = ACTIONS(5962),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5962),
    [anon_sym_u2298] = ACTIONS(5962),
    [anon_sym_BSLASHotimes] = ACTIONS(5962),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5962),
    [anon_sym_u2297] = ACTIONS(5962),
    [sym_mul] = ACTIONS(5960),
    [sym_mulmul] = ACTIONS(5962),
    [sym_slash] = ACTIONS(5960),
    [sym_slashslash] = ACTIONS(5962),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5962),
    [anon_sym_u25ef] = ACTIONS(5962),
    [anon_sym_BSLASHbullet] = ACTIONS(5962),
    [anon_sym_u25cf] = ACTIONS(5962),
    [anon_sym_BSLASHdiv] = ACTIONS(5962),
    [anon_sym_u00f7] = ACTIONS(5962),
    [anon_sym_BSLASHcirc] = ACTIONS(5962),
    [anon_sym_u2218] = ACTIONS(5962),
    [anon_sym_BSLASHstar] = ACTIONS(5962),
    [anon_sym_u22c6] = ACTIONS(5962),
    [anon_sym_u203c] = ACTIONS(5962),
    [sym_hashhash] = ACTIONS(5962),
    [sym_dol] = ACTIONS(5960),
    [sym_doldol] = ACTIONS(5962),
    [anon_sym_QMARK_QMARK] = ACTIONS(5962),
    [anon_sym_u2047] = ACTIONS(5962),
    [anon_sym_BSLASHsqcap] = ACTIONS(5962),
    [anon_sym_u2293] = ACTIONS(5962),
    [anon_sym_BSLASHsqcup] = ACTIONS(5962),
    [anon_sym_u2294] = ACTIONS(5962),
    [anon_sym_BSLASHuplus] = ACTIONS(5962),
    [anon_sym_u228e] = ACTIONS(5962),
    [anon_sym_BSLASHX] = ACTIONS(5962),
    [anon_sym_BSLASHtimes] = ACTIONS(5962),
    [anon_sym_u00d7] = ACTIONS(5962),
    [anon_sym_BSLASHwr] = ACTIONS(5962),
    [anon_sym_u2240] = ACTIONS(5962),
    [anon_sym_BSLASHcdot] = ACTIONS(5962),
    [anon_sym_u22c5] = ACTIONS(5962),
    [sym_pow] = ACTIONS(5960),
    [sym_powpow] = ACTIONS(5962),
    [anon_sym_CARET_PLUS] = ACTIONS(5962),
    [anon_sym_u207a] = ACTIONS(5962),
    [sym_asterisk] = ACTIONS(5962),
    [sym_sup_hash] = ACTIONS(5962),
    [sym_prime] = ACTIONS(5962),
    [sym__double_excl] = ACTIONS(5962),
  },
  [2793] = {
    [sym_block_comment] = STATE(2793),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(855),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(5972),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2794] = {
    [sym_block_comment] = STATE(2794),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(915),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(5978),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2795] = {
    [sym_block_comment] = STATE(2795),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(945),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(5980),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2796] = {
    [sym_block_comment] = STATE(2796),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(958),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(5982),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2797] = {
    [sym_block_comment] = STATE(2797),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(973),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(5984),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2798] = {
    [sym_block_comment] = STATE(2798),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(1019),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(5986),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2799] = {
    [sym_block_comment] = STATE(2799),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(988),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(5988),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2800] = {
    [sym_block_comment] = STATE(2800),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(812),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(5990),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2801] = {
    [sym_block_comment] = STATE(2801),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(1003),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(5992),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2802] = {
    [sym_block_comment] = STATE(2802),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(930),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(5994),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2803] = {
    [sym_block_comment] = STATE(2803),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(826),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(5996),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2804] = {
    [sym_block_comment] = STATE(2804),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(1033),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(5998),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2805] = {
    [sym_block_comment] = STATE(2805),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(899),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(6000),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2806] = {
    [sym_block_comment] = STATE(2806),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(1051),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(6002),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2807] = {
    [sym_block_comment] = STATE(2807),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(841),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(6004),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2808] = {
    [sym_block_comment] = STATE(2808),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(869),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(6006),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2809] = {
    [sym_block_comment] = STATE(2809),
    [sym_set_in] = STATE(699),
    [sym_all_map_to] = STATE(885),
    [sym_label_as] = STATE(326),
    [aux_sym_variable_declaration_repeat1] = STATE(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5970),
    [anon_sym_u27fc] = ACTIONS(5970),
    [anon_sym_u21a6] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_COLON] = ACTIONS(6008),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2810] = {
    [sym_block_comment] = STATE(2810),
    [sym_label_as] = STATE(603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(6010),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_PROOF] = ACTIONS(4078),
    [anon_sym_BY] = ACTIONS(4078),
    [anon_sym_OBVIOUS] = ACTIONS(4078),
    [anon_sym_OMITTED] = ACTIONS(4078),
    [sym__begin_proof] = ACTIONS(4078),
    [sym__begin_proof_step] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2811] = {
    [sym_block_comment] = STATE(2811),
    [sym_label_as] = STATE(357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_GT_GT] = ACTIONS(3845),
    [anon_sym_u3009] = ACTIONS(3845),
    [anon_sym_u27e9] = ACTIONS(3845),
    [anon_sym_GT_GT_] = ACTIONS(4078),
    [anon_sym_u3009_] = ACTIONS(4078),
    [anon_sym_u27e9_] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(6012),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2812] = {
    [sym_block_comment] = STATE(2812),
    [sym_rangle_bracket] = STATE(4663),
    [sym_label_as] = STATE(357),
    [aux_sym_variable_declaration_repeat1] = STATE(4128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_GT_GT] = ACTIONS(6014),
    [anon_sym_u3009] = ACTIONS(6014),
    [anon_sym_u27e9] = ACTIONS(6014),
    [anon_sym_GT_GT_] = ACTIONS(4078),
    [anon_sym_u3009_] = ACTIONS(4078),
    [anon_sym_u27e9_] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(6012),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2813] = {
    [sym_block_comment] = STATE(2813),
    [sym_label_as] = STATE(490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(6020),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_PROOF] = ACTIONS(4078),
    [anon_sym_BY] = ACTIONS(4078),
    [anon_sym_OBVIOUS] = ACTIONS(4078),
    [anon_sym_OMITTED] = ACTIONS(4078),
    [sym__begin_proof] = ACTIONS(4078),
    [sym__begin_proof_step] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2814] = {
    [sym_block_comment] = STATE(2814),
    [sym_case_box] = STATE(172),
    [aux_sym_case_repeat1] = STATE(2816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_DASH_GT] = ACTIONS(5672),
    [anon_sym_u27f6] = ACTIONS(5672),
    [anon_sym_u2192] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5672),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [anon_sym_PROOF] = ACTIONS(5672),
    [anon_sym_BY] = ACTIONS(5672),
    [anon_sym_OBVIOUS] = ACTIONS(5672),
    [anon_sym_OMITTED] = ACTIONS(5672),
    [sym__begin_proof] = ACTIONS(5672),
    [sym__begin_proof_step] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [2815] = {
    [sym_block_comment] = STATE(2815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_DASH_GT] = ACTIONS(5676),
    [anon_sym_u27f6] = ACTIONS(5676),
    [anon_sym_u2192] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(6022),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5676),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [anon_sym_PROOF] = ACTIONS(5676),
    [anon_sym_BY] = ACTIONS(5676),
    [anon_sym_OBVIOUS] = ACTIONS(5676),
    [anon_sym_OMITTED] = ACTIONS(5676),
    [sym__begin_proof] = ACTIONS(5676),
    [sym__begin_proof_step] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [2816] = {
    [sym_block_comment] = STATE(2816),
    [sym_case_box] = STATE(231),
    [aux_sym_case_repeat1] = STATE(2816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_u27f6] = ACTIONS(5663),
    [anon_sym_u2192] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_PROOF] = ACTIONS(5663),
    [anon_sym_BY] = ACTIONS(5663),
    [anon_sym_OBVIOUS] = ACTIONS(5663),
    [anon_sym_OMITTED] = ACTIONS(5663),
    [sym__begin_proof] = ACTIONS(5663),
    [sym__begin_proof_step] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2817] = {
    [sym_block_comment] = STATE(2817),
    [sym_case_box] = STATE(171),
    [aux_sym_case_repeat1] = STATE(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_DASH_GT] = ACTIONS(5684),
    [anon_sym_u27f6] = ACTIONS(5684),
    [anon_sym_u2192] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5684),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [anon_sym_PROOF] = ACTIONS(5684),
    [anon_sym_BY] = ACTIONS(5684),
    [anon_sym_OBVIOUS] = ACTIONS(5684),
    [anon_sym_OMITTED] = ACTIONS(5684),
    [sym__begin_proof] = ACTIONS(5684),
    [sym__begin_proof_step] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2818] = {
    [sym_block_comment] = STATE(2818),
    [sym_label_as] = STATE(993),
    [aux_sym_pcal_lhs_repeat1] = STATE(4212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_LBRACK] = ACTIONS(6024),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_RBRACE] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(6027),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(6030),
    [anon_sym_u2254] = ACTIONS(6030),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_end] = ACTIONS(4078),
    [anon_sym_SEMI] = ACTIONS(4078),
    [anon_sym_elsif] = ACTIONS(4078),
    [anon_sym_else] = ACTIONS(4078),
    [anon_sym_or] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2819] = {
    [sym_block_comment] = STATE(2819),
    [sym_label_as] = STATE(326),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27f6] = ACTIONS(4078),
    [anon_sym_u2192] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EXCEPT] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_RBRACK_] = ACTIONS(4078),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2820] = {
    [sym_block_comment] = STATE(2820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_DASH_GT] = ACTIONS(5716),
    [anon_sym_u27f6] = ACTIONS(5716),
    [anon_sym_u2192] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5716),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [anon_sym_PROOF] = ACTIONS(5716),
    [anon_sym_BY] = ACTIONS(5716),
    [anon_sym_OBVIOUS] = ACTIONS(5716),
    [anon_sym_OMITTED] = ACTIONS(5716),
    [sym__begin_proof] = ACTIONS(5716),
    [sym__begin_proof_step] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [2821] = {
    [sym_block_comment] = STATE(2821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_DASH_GT] = ACTIONS(5696),
    [anon_sym_u27f6] = ACTIONS(5696),
    [anon_sym_u2192] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5696),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [anon_sym_PROOF] = ACTIONS(5696),
    [anon_sym_BY] = ACTIONS(5696),
    [anon_sym_OBVIOUS] = ACTIONS(5696),
    [anon_sym_OMITTED] = ACTIONS(5696),
    [sym__begin_proof] = ACTIONS(5696),
    [sym__begin_proof_step] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [2822] = {
    [sym_block_comment] = STATE(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_DASH_GT] = ACTIONS(5704),
    [anon_sym_u27f6] = ACTIONS(5704),
    [anon_sym_u2192] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_PROOF] = ACTIONS(5704),
    [anon_sym_BY] = ACTIONS(5704),
    [anon_sym_OBVIOUS] = ACTIONS(5704),
    [anon_sym_OMITTED] = ACTIONS(5704),
    [sym__begin_proof] = ACTIONS(5704),
    [sym__begin_proof_step] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2823] = {
    [sym_block_comment] = STATE(2823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_DASH_GT] = ACTIONS(5690),
    [anon_sym_u27f6] = ACTIONS(5690),
    [anon_sym_u2192] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_PROOF] = ACTIONS(5690),
    [anon_sym_BY] = ACTIONS(5690),
    [anon_sym_OBVIOUS] = ACTIONS(5690),
    [anon_sym_OMITTED] = ACTIONS(5690),
    [sym__begin_proof] = ACTIONS(5690),
    [sym__begin_proof_step] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2824] = {
    [sym_block_comment] = STATE(2824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_DASH_GT] = ACTIONS(5722),
    [anon_sym_u27f6] = ACTIONS(5722),
    [anon_sym_u2192] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5722),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [anon_sym_PROOF] = ACTIONS(5722),
    [anon_sym_BY] = ACTIONS(5722),
    [anon_sym_OBVIOUS] = ACTIONS(5722),
    [anon_sym_OMITTED] = ACTIONS(5722),
    [sym__begin_proof] = ACTIONS(5722),
    [sym__begin_proof_step] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [2825] = {
    [sym_block_comment] = STATE(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_DASH_GT] = ACTIONS(5712),
    [anon_sym_u27f6] = ACTIONS(5712),
    [anon_sym_u2192] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5712),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [anon_sym_PROOF] = ACTIONS(5712),
    [anon_sym_BY] = ACTIONS(5712),
    [anon_sym_OBVIOUS] = ACTIONS(5712),
    [anon_sym_OMITTED] = ACTIONS(5712),
    [sym__begin_proof] = ACTIONS(5712),
    [sym__begin_proof_step] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [2826] = {
    [sym_block_comment] = STATE(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_DASH_GT] = ACTIONS(5700),
    [anon_sym_u27f6] = ACTIONS(5700),
    [anon_sym_u2192] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(6022),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5700),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [anon_sym_PROOF] = ACTIONS(5700),
    [anon_sym_BY] = ACTIONS(5700),
    [anon_sym_OBVIOUS] = ACTIONS(5700),
    [anon_sym_OMITTED] = ACTIONS(5700),
    [sym__begin_proof] = ACTIONS(5700),
    [sym__begin_proof_step] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [2827] = {
    [sym_block_comment] = STATE(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_DASH_GT] = ACTIONS(5708),
    [anon_sym_u27f6] = ACTIONS(5708),
    [anon_sym_u2192] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5708),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [anon_sym_PROOF] = ACTIONS(5708),
    [anon_sym_BY] = ACTIONS(5708),
    [anon_sym_OBVIOUS] = ACTIONS(5708),
    [anon_sym_OMITTED] = ACTIONS(5708),
    [sym__begin_proof] = ACTIONS(5708),
    [sym__begin_proof_step] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [2828] = {
    [sym_block_comment] = STATE(2828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_DASH_GT] = ACTIONS(5690),
    [anon_sym_u27f6] = ACTIONS(5690),
    [anon_sym_u2192] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_PROOF] = ACTIONS(5690),
    [anon_sym_BY] = ACTIONS(5690),
    [anon_sym_OBVIOUS] = ACTIONS(5690),
    [anon_sym_OMITTED] = ACTIONS(5690),
    [sym__begin_proof] = ACTIONS(5690),
    [sym__begin_proof_step] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2829] = {
    [sym_block_comment] = STATE(2829),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_DASH_GT] = ACTIONS(5740),
    [anon_sym_u27f6] = ACTIONS(5740),
    [anon_sym_u2192] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5740),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [anon_sym_PROOF] = ACTIONS(5740),
    [anon_sym_BY] = ACTIONS(5740),
    [anon_sym_OBVIOUS] = ACTIONS(5740),
    [anon_sym_OMITTED] = ACTIONS(5740),
    [sym__begin_proof] = ACTIONS(5740),
    [sym__begin_proof_step] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [2830] = {
    [sym_block_comment] = STATE(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_DASH_GT] = ACTIONS(5736),
    [anon_sym_u27f6] = ACTIONS(5736),
    [anon_sym_u2192] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5736),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [anon_sym_PROOF] = ACTIONS(5736),
    [anon_sym_BY] = ACTIONS(5736),
    [anon_sym_OBVIOUS] = ACTIONS(5736),
    [anon_sym_OMITTED] = ACTIONS(5736),
    [sym__begin_proof] = ACTIONS(5736),
    [sym__begin_proof_step] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [2831] = {
    [sym_block_comment] = STATE(2831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_DASH_GT] = ACTIONS(5752),
    [anon_sym_u27f6] = ACTIONS(5752),
    [anon_sym_u2192] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5752),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [anon_sym_PROOF] = ACTIONS(5752),
    [anon_sym_BY] = ACTIONS(5752),
    [anon_sym_OBVIOUS] = ACTIONS(5752),
    [anon_sym_OMITTED] = ACTIONS(5752),
    [sym__begin_proof] = ACTIONS(5752),
    [sym__begin_proof_step] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [2832] = {
    [sym_block_comment] = STATE(2832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_DASH_GT] = ACTIONS(5744),
    [anon_sym_u27f6] = ACTIONS(5744),
    [anon_sym_u2192] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5744),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [anon_sym_PROOF] = ACTIONS(5744),
    [anon_sym_BY] = ACTIONS(5744),
    [anon_sym_OBVIOUS] = ACTIONS(5744),
    [anon_sym_OMITTED] = ACTIONS(5744),
    [sym__begin_proof] = ACTIONS(5744),
    [sym__begin_proof_step] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [2833] = {
    [sym_block_comment] = STATE(2833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_DASH_GT] = ACTIONS(5748),
    [anon_sym_u27f6] = ACTIONS(5748),
    [anon_sym_u2192] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5748),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [anon_sym_PROOF] = ACTIONS(5748),
    [anon_sym_BY] = ACTIONS(5748),
    [anon_sym_OBVIOUS] = ACTIONS(5748),
    [anon_sym_OMITTED] = ACTIONS(5748),
    [sym__begin_proof] = ACTIONS(5748),
    [sym__begin_proof_step] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [2834] = {
    [sym_block_comment] = STATE(2834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_DASH_GT] = ACTIONS(5838),
    [anon_sym_u27f6] = ACTIONS(5838),
    [anon_sym_u2192] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5838),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [anon_sym_PROOF] = ACTIONS(5838),
    [anon_sym_BY] = ACTIONS(5838),
    [anon_sym_OBVIOUS] = ACTIONS(5838),
    [anon_sym_OMITTED] = ACTIONS(5838),
    [sym__begin_proof] = ACTIONS(5838),
    [sym__begin_proof_step] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [2835] = {
    [sym_block_comment] = STATE(2835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_DASH_GT] = ACTIONS(5778),
    [anon_sym_u27f6] = ACTIONS(5778),
    [anon_sym_u2192] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5778),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [anon_sym_PROOF] = ACTIONS(5778),
    [anon_sym_BY] = ACTIONS(5778),
    [anon_sym_OBVIOUS] = ACTIONS(5778),
    [anon_sym_OMITTED] = ACTIONS(5778),
    [sym__begin_proof] = ACTIONS(5778),
    [sym__begin_proof_step] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [2836] = {
    [sym_block_comment] = STATE(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_DASH_GT] = ACTIONS(5782),
    [anon_sym_u27f6] = ACTIONS(5782),
    [anon_sym_u2192] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5782),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [anon_sym_PROOF] = ACTIONS(5782),
    [anon_sym_BY] = ACTIONS(5782),
    [anon_sym_OBVIOUS] = ACTIONS(5782),
    [anon_sym_OMITTED] = ACTIONS(5782),
    [sym__begin_proof] = ACTIONS(5782),
    [sym__begin_proof_step] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [2837] = {
    [sym_block_comment] = STATE(2837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_DASH_GT] = ACTIONS(5790),
    [anon_sym_u27f6] = ACTIONS(5790),
    [anon_sym_u2192] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5790),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [anon_sym_PROOF] = ACTIONS(5790),
    [anon_sym_BY] = ACTIONS(5790),
    [anon_sym_OBVIOUS] = ACTIONS(5790),
    [anon_sym_OMITTED] = ACTIONS(5790),
    [sym__begin_proof] = ACTIONS(5790),
    [sym__begin_proof_step] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [2838] = {
    [sym_block_comment] = STATE(2838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_DASH_GT] = ACTIONS(5794),
    [anon_sym_u27f6] = ACTIONS(5794),
    [anon_sym_u2192] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5794),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [anon_sym_PROOF] = ACTIONS(5794),
    [anon_sym_BY] = ACTIONS(5794),
    [anon_sym_OBVIOUS] = ACTIONS(5794),
    [anon_sym_OMITTED] = ACTIONS(5794),
    [sym__begin_proof] = ACTIONS(5794),
    [sym__begin_proof_step] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [2839] = {
    [sym_block_comment] = STATE(2839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_DASH_GT] = ACTIONS(5798),
    [anon_sym_u27f6] = ACTIONS(5798),
    [anon_sym_u2192] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5798),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [anon_sym_PROOF] = ACTIONS(5798),
    [anon_sym_BY] = ACTIONS(5798),
    [anon_sym_OBVIOUS] = ACTIONS(5798),
    [anon_sym_OMITTED] = ACTIONS(5798),
    [sym__begin_proof] = ACTIONS(5798),
    [sym__begin_proof_step] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [2840] = {
    [sym_block_comment] = STATE(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_DASH_GT] = ACTIONS(5890),
    [anon_sym_u27f6] = ACTIONS(5890),
    [anon_sym_u2192] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5890),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [anon_sym_PROOF] = ACTIONS(5890),
    [anon_sym_BY] = ACTIONS(5890),
    [anon_sym_OBVIOUS] = ACTIONS(5890),
    [anon_sym_OMITTED] = ACTIONS(5890),
    [sym__begin_proof] = ACTIONS(5890),
    [sym__begin_proof_step] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [2841] = {
    [sym_block_comment] = STATE(2841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_DASH_GT] = ACTIONS(5810),
    [anon_sym_u27f6] = ACTIONS(5810),
    [anon_sym_u2192] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5810),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [anon_sym_PROOF] = ACTIONS(5810),
    [anon_sym_BY] = ACTIONS(5810),
    [anon_sym_OBVIOUS] = ACTIONS(5810),
    [anon_sym_OMITTED] = ACTIONS(5810),
    [sym__begin_proof] = ACTIONS(5810),
    [sym__begin_proof_step] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [2842] = {
    [sym_block_comment] = STATE(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_DASH_GT] = ACTIONS(5814),
    [anon_sym_u27f6] = ACTIONS(5814),
    [anon_sym_u2192] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5814),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [anon_sym_PROOF] = ACTIONS(5814),
    [anon_sym_BY] = ACTIONS(5814),
    [anon_sym_OBVIOUS] = ACTIONS(5814),
    [anon_sym_OMITTED] = ACTIONS(5814),
    [sym__begin_proof] = ACTIONS(5814),
    [sym__begin_proof_step] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [2843] = {
    [sym_block_comment] = STATE(2843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_DASH_GT] = ACTIONS(5818),
    [anon_sym_u27f6] = ACTIONS(5818),
    [anon_sym_u2192] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5818),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [anon_sym_PROOF] = ACTIONS(5818),
    [anon_sym_BY] = ACTIONS(5818),
    [anon_sym_OBVIOUS] = ACTIONS(5818),
    [anon_sym_OMITTED] = ACTIONS(5818),
    [sym__begin_proof] = ACTIONS(5818),
    [sym__begin_proof_step] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [2844] = {
    [sym_block_comment] = STATE(2844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_DASH_GT] = ACTIONS(5822),
    [anon_sym_u27f6] = ACTIONS(5822),
    [anon_sym_u2192] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5822),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [anon_sym_PROOF] = ACTIONS(5822),
    [anon_sym_BY] = ACTIONS(5822),
    [anon_sym_OBVIOUS] = ACTIONS(5822),
    [anon_sym_OMITTED] = ACTIONS(5822),
    [sym__begin_proof] = ACTIONS(5822),
    [sym__begin_proof_step] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [2845] = {
    [sym_block_comment] = STATE(2845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_DASH_GT] = ACTIONS(5826),
    [anon_sym_u27f6] = ACTIONS(5826),
    [anon_sym_u2192] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5826),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [anon_sym_PROOF] = ACTIONS(5826),
    [anon_sym_BY] = ACTIONS(5826),
    [anon_sym_OBVIOUS] = ACTIONS(5826),
    [anon_sym_OMITTED] = ACTIONS(5826),
    [sym__begin_proof] = ACTIONS(5826),
    [sym__begin_proof_step] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [2846] = {
    [sym_block_comment] = STATE(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_DASH_GT] = ACTIONS(5842),
    [anon_sym_u27f6] = ACTIONS(5842),
    [anon_sym_u2192] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5842),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [anon_sym_PROOF] = ACTIONS(5842),
    [anon_sym_BY] = ACTIONS(5842),
    [anon_sym_OBVIOUS] = ACTIONS(5842),
    [anon_sym_OMITTED] = ACTIONS(5842),
    [sym__begin_proof] = ACTIONS(5842),
    [sym__begin_proof_step] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [2847] = {
    [sym_block_comment] = STATE(2847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_DASH_GT] = ACTIONS(5830),
    [anon_sym_u27f6] = ACTIONS(5830),
    [anon_sym_u2192] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5830),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [anon_sym_PROOF] = ACTIONS(5830),
    [anon_sym_BY] = ACTIONS(5830),
    [anon_sym_OBVIOUS] = ACTIONS(5830),
    [anon_sym_OMITTED] = ACTIONS(5830),
    [sym__begin_proof] = ACTIONS(5830),
    [sym__begin_proof_step] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [2848] = {
    [sym_block_comment] = STATE(2848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_DASH_GT] = ACTIONS(5834),
    [anon_sym_u27f6] = ACTIONS(5834),
    [anon_sym_u2192] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5834),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [anon_sym_PROOF] = ACTIONS(5834),
    [anon_sym_BY] = ACTIONS(5834),
    [anon_sym_OBVIOUS] = ACTIONS(5834),
    [anon_sym_OMITTED] = ACTIONS(5834),
    [sym__begin_proof] = ACTIONS(5834),
    [sym__begin_proof_step] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [2849] = {
    [sym_block_comment] = STATE(2849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_DASH_GT] = ACTIONS(5846),
    [anon_sym_u27f6] = ACTIONS(5846),
    [anon_sym_u2192] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5846),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [anon_sym_PROOF] = ACTIONS(5846),
    [anon_sym_BY] = ACTIONS(5846),
    [anon_sym_OBVIOUS] = ACTIONS(5846),
    [anon_sym_OMITTED] = ACTIONS(5846),
    [sym__begin_proof] = ACTIONS(5846),
    [sym__begin_proof_step] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [2850] = {
    [sym_block_comment] = STATE(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_DASH_GT] = ACTIONS(5802),
    [anon_sym_u27f6] = ACTIONS(5802),
    [anon_sym_u2192] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5802),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [anon_sym_PROOF] = ACTIONS(5802),
    [anon_sym_BY] = ACTIONS(5802),
    [anon_sym_OBVIOUS] = ACTIONS(5802),
    [anon_sym_OMITTED] = ACTIONS(5802),
    [sym__begin_proof] = ACTIONS(5802),
    [sym__begin_proof_step] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [2851] = {
    [sym_block_comment] = STATE(2851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_DASH_GT] = ACTIONS(5872),
    [anon_sym_u27f6] = ACTIONS(5872),
    [anon_sym_u2192] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5872),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [anon_sym_PROOF] = ACTIONS(5872),
    [anon_sym_BY] = ACTIONS(5872),
    [anon_sym_OBVIOUS] = ACTIONS(5872),
    [anon_sym_OMITTED] = ACTIONS(5872),
    [sym__begin_proof] = ACTIONS(5872),
    [sym__begin_proof_step] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [2852] = {
    [sym_block_comment] = STATE(2852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_DASH_GT] = ACTIONS(5876),
    [anon_sym_u27f6] = ACTIONS(5876),
    [anon_sym_u2192] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5876),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [anon_sym_PROOF] = ACTIONS(5876),
    [anon_sym_BY] = ACTIONS(5876),
    [anon_sym_OBVIOUS] = ACTIONS(5876),
    [anon_sym_OMITTED] = ACTIONS(5876),
    [sym__begin_proof] = ACTIONS(5876),
    [sym__begin_proof_step] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [2853] = {
    [sym_block_comment] = STATE(2853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_DASH_GT] = ACTIONS(5880),
    [anon_sym_u27f6] = ACTIONS(5880),
    [anon_sym_u2192] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5880),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [anon_sym_PROOF] = ACTIONS(5880),
    [anon_sym_BY] = ACTIONS(5880),
    [anon_sym_OBVIOUS] = ACTIONS(5880),
    [anon_sym_OMITTED] = ACTIONS(5880),
    [sym__begin_proof] = ACTIONS(5880),
    [sym__begin_proof_step] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [2854] = {
    [sym_block_comment] = STATE(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_DASH_GT] = ACTIONS(5938),
    [anon_sym_u27f6] = ACTIONS(5938),
    [anon_sym_u2192] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5938),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [anon_sym_PROOF] = ACTIONS(5938),
    [anon_sym_BY] = ACTIONS(5938),
    [anon_sym_OBVIOUS] = ACTIONS(5938),
    [anon_sym_OMITTED] = ACTIONS(5938),
    [sym__begin_proof] = ACTIONS(5938),
    [sym__begin_proof_step] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [2855] = {
    [sym_block_comment] = STATE(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_DASH_GT] = ACTIONS(5884),
    [anon_sym_u27f6] = ACTIONS(5884),
    [anon_sym_u2192] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5884),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [anon_sym_PROOF] = ACTIONS(5884),
    [anon_sym_BY] = ACTIONS(5884),
    [anon_sym_OBVIOUS] = ACTIONS(5884),
    [anon_sym_OMITTED] = ACTIONS(5884),
    [sym__begin_proof] = ACTIONS(5884),
    [sym__begin_proof_step] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [2856] = {
    [sym_block_comment] = STATE(2856),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_DASH_GT] = ACTIONS(5942),
    [anon_sym_u27f6] = ACTIONS(5942),
    [anon_sym_u2192] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5942),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [anon_sym_PROOF] = ACTIONS(5942),
    [anon_sym_BY] = ACTIONS(5942),
    [anon_sym_OBVIOUS] = ACTIONS(5942),
    [anon_sym_OMITTED] = ACTIONS(5942),
    [sym__begin_proof] = ACTIONS(5942),
    [sym__begin_proof_step] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [2857] = {
    [sym_block_comment] = STATE(2857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_u27f6] = ACTIONS(5351),
    [anon_sym_u2192] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [anon_sym_PROOF] = ACTIONS(5351),
    [anon_sym_BY] = ACTIONS(5351),
    [anon_sym_OBVIOUS] = ACTIONS(5351),
    [anon_sym_OMITTED] = ACTIONS(5351),
    [sym__begin_proof] = ACTIONS(5351),
    [sym__begin_proof_step] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [2858] = {
    [sym_block_comment] = STATE(2858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_DASH_GT] = ACTIONS(5772),
    [anon_sym_u27f6] = ACTIONS(5772),
    [anon_sym_u2192] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5772),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [anon_sym_PROOF] = ACTIONS(5772),
    [anon_sym_BY] = ACTIONS(5772),
    [anon_sym_OBVIOUS] = ACTIONS(5772),
    [anon_sym_OMITTED] = ACTIONS(5772),
    [sym__begin_proof] = ACTIONS(5772),
    [sym__begin_proof_step] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [2859] = {
    [sym_block_comment] = STATE(2859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_DASH_GT] = ACTIONS(5862),
    [anon_sym_u27f6] = ACTIONS(5862),
    [anon_sym_u2192] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5862),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [anon_sym_PROOF] = ACTIONS(5862),
    [anon_sym_BY] = ACTIONS(5862),
    [anon_sym_OBVIOUS] = ACTIONS(5862),
    [anon_sym_OMITTED] = ACTIONS(5862),
    [sym__begin_proof] = ACTIONS(5862),
    [sym__begin_proof_step] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [2860] = {
    [sym_block_comment] = STATE(2860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_DASH_GT] = ACTIONS(5704),
    [anon_sym_u27f6] = ACTIONS(5704),
    [anon_sym_u2192] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_PROOF] = ACTIONS(5704),
    [anon_sym_BY] = ACTIONS(5704),
    [anon_sym_OBVIOUS] = ACTIONS(5704),
    [anon_sym_OMITTED] = ACTIONS(5704),
    [sym__begin_proof] = ACTIONS(5704),
    [sym__begin_proof_step] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2861] = {
    [sym_block_comment] = STATE(2861),
    [sym_case_box] = STATE(143),
    [aux_sym_case_repeat1] = STATE(2863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_GT_GT] = ACTIONS(5686),
    [anon_sym_u3009] = ACTIONS(5686),
    [anon_sym_u27e9] = ACTIONS(5686),
    [anon_sym_GT_GT_] = ACTIONS(5684),
    [anon_sym_u3009_] = ACTIONS(5684),
    [anon_sym_u27e9_] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_COMMA] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5684),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2862] = {
    [sym_block_comment] = STATE(2862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_DASH_GT] = ACTIONS(5908),
    [anon_sym_u27f6] = ACTIONS(5908),
    [anon_sym_u2192] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5908),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [anon_sym_PROOF] = ACTIONS(5908),
    [anon_sym_BY] = ACTIONS(5908),
    [anon_sym_OBVIOUS] = ACTIONS(5908),
    [anon_sym_OMITTED] = ACTIONS(5908),
    [sym__begin_proof] = ACTIONS(5908),
    [sym__begin_proof_step] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [2863] = {
    [sym_block_comment] = STATE(2863),
    [sym_case_box] = STATE(144),
    [aux_sym_case_repeat1] = STATE(2869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_GT_GT] = ACTIONS(5670),
    [anon_sym_u3009] = ACTIONS(5670),
    [anon_sym_u27e9] = ACTIONS(5670),
    [anon_sym_GT_GT_] = ACTIONS(5672),
    [anon_sym_u3009_] = ACTIONS(5672),
    [anon_sym_u27e9_] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5672),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [2864] = {
    [sym_block_comment] = STATE(2864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_DASH_GT] = ACTIONS(5732),
    [anon_sym_u27f6] = ACTIONS(5732),
    [anon_sym_u2192] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5732),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [anon_sym_PROOF] = ACTIONS(5732),
    [anon_sym_BY] = ACTIONS(5732),
    [anon_sym_OBVIOUS] = ACTIONS(5732),
    [anon_sym_OMITTED] = ACTIONS(5732),
    [sym__begin_proof] = ACTIONS(5732),
    [sym__begin_proof_step] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [2865] = {
    [sym_block_comment] = STATE(2865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_DASH_GT] = ACTIONS(5916),
    [anon_sym_u27f6] = ACTIONS(5916),
    [anon_sym_u2192] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5916),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [anon_sym_PROOF] = ACTIONS(5916),
    [anon_sym_BY] = ACTIONS(5916),
    [anon_sym_OBVIOUS] = ACTIONS(5916),
    [anon_sym_OMITTED] = ACTIONS(5916),
    [sym__begin_proof] = ACTIONS(5916),
    [sym__begin_proof_step] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [2866] = {
    [sym_block_comment] = STATE(2866),
    [sym_label_as] = STATE(463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_GT_GT] = ACTIONS(4078),
    [anon_sym_u3009] = ACTIONS(4078),
    [anon_sym_u27e9] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(6033),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2867] = {
    [sym_block_comment] = STATE(2867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_DASH_GT] = ACTIONS(5920),
    [anon_sym_u27f6] = ACTIONS(5920),
    [anon_sym_u2192] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5920),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [anon_sym_PROOF] = ACTIONS(5920),
    [anon_sym_BY] = ACTIONS(5920),
    [anon_sym_OBVIOUS] = ACTIONS(5920),
    [anon_sym_OMITTED] = ACTIONS(5920),
    [sym__begin_proof] = ACTIONS(5920),
    [sym__begin_proof_step] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [2868] = {
    [sym_block_comment] = STATE(2868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_DASH_GT] = ACTIONS(5926),
    [anon_sym_u27f6] = ACTIONS(5926),
    [anon_sym_u2192] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5926),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [anon_sym_PROOF] = ACTIONS(5926),
    [anon_sym_BY] = ACTIONS(5926),
    [anon_sym_OBVIOUS] = ACTIONS(5926),
    [anon_sym_OMITTED] = ACTIONS(5926),
    [sym__begin_proof] = ACTIONS(5926),
    [sym__begin_proof_step] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [2869] = {
    [sym_block_comment] = STATE(2869),
    [sym_case_box] = STATE(238),
    [aux_sym_case_repeat1] = STATE(2869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_GT_GT] = ACTIONS(5665),
    [anon_sym_u3009] = ACTIONS(5665),
    [anon_sym_u27e9] = ACTIONS(5665),
    [anon_sym_GT_GT_] = ACTIONS(5663),
    [anon_sym_u3009_] = ACTIONS(5663),
    [anon_sym_u27e9_] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2870] = {
    [sym_block_comment] = STATE(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_DASH_GT] = ACTIONS(5930),
    [anon_sym_u27f6] = ACTIONS(5930),
    [anon_sym_u2192] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5930),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [anon_sym_PROOF] = ACTIONS(5930),
    [anon_sym_BY] = ACTIONS(5930),
    [anon_sym_OBVIOUS] = ACTIONS(5930),
    [anon_sym_OMITTED] = ACTIONS(5930),
    [sym__begin_proof] = ACTIONS(5930),
    [sym__begin_proof_step] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [2871] = {
    [sym_block_comment] = STATE(2871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5678),
    [anon_sym_u3009] = ACTIONS(5678),
    [anon_sym_u27e9] = ACTIONS(5678),
    [anon_sym_GT_GT_] = ACTIONS(5676),
    [anon_sym_u3009_] = ACTIONS(5676),
    [anon_sym_u27e9_] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(6035),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5676),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [2872] = {
    [sym_block_comment] = STATE(2872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_DASH_GT] = ACTIONS(5934),
    [anon_sym_u27f6] = ACTIONS(5934),
    [anon_sym_u2192] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5934),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [anon_sym_PROOF] = ACTIONS(5934),
    [anon_sym_BY] = ACTIONS(5934),
    [anon_sym_OBVIOUS] = ACTIONS(5934),
    [anon_sym_OMITTED] = ACTIONS(5934),
    [sym__begin_proof] = ACTIONS(5934),
    [sym__begin_proof_step] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [2873] = {
    [sym_block_comment] = STATE(2873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_u27f6] = ACTIONS(5663),
    [anon_sym_u2192] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_PROOF] = ACTIONS(5663),
    [anon_sym_BY] = ACTIONS(5663),
    [anon_sym_OBVIOUS] = ACTIONS(5663),
    [anon_sym_OMITTED] = ACTIONS(5663),
    [sym__begin_proof] = ACTIONS(5663),
    [sym__begin_proof_step] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2874] = {
    [sym_block_comment] = STATE(2874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_DASH_GT] = ACTIONS(5786),
    [anon_sym_u27f6] = ACTIONS(5786),
    [anon_sym_u2192] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5786),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [anon_sym_PROOF] = ACTIONS(5786),
    [anon_sym_BY] = ACTIONS(5786),
    [anon_sym_OBVIOUS] = ACTIONS(5786),
    [anon_sym_OMITTED] = ACTIONS(5786),
    [sym__begin_proof] = ACTIONS(5786),
    [sym__begin_proof_step] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [2875] = {
    [sym_block_comment] = STATE(2875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_DASH_GT] = ACTIONS(5728),
    [anon_sym_u27f6] = ACTIONS(5728),
    [anon_sym_u2192] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5728),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [anon_sym_PROOF] = ACTIONS(5728),
    [anon_sym_BY] = ACTIONS(5728),
    [anon_sym_OBVIOUS] = ACTIONS(5728),
    [anon_sym_OMITTED] = ACTIONS(5728),
    [sym__begin_proof] = ACTIONS(5728),
    [sym__begin_proof_step] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [2876] = {
    [sym_block_comment] = STATE(2876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_DASH_GT] = ACTIONS(5852),
    [anon_sym_u27f6] = ACTIONS(5852),
    [anon_sym_u2192] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5852),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [anon_sym_PROOF] = ACTIONS(5852),
    [anon_sym_BY] = ACTIONS(5852),
    [anon_sym_OBVIOUS] = ACTIONS(5852),
    [anon_sym_OMITTED] = ACTIONS(5852),
    [sym__begin_proof] = ACTIONS(5852),
    [sym__begin_proof_step] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [2877] = {
    [sym_block_comment] = STATE(2877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_DASH_GT] = ACTIONS(5806),
    [anon_sym_u27f6] = ACTIONS(5806),
    [anon_sym_u2192] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5806),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [anon_sym_PROOF] = ACTIONS(5806),
    [anon_sym_BY] = ACTIONS(5806),
    [anon_sym_OBVIOUS] = ACTIONS(5806),
    [anon_sym_OMITTED] = ACTIONS(5806),
    [sym__begin_proof] = ACTIONS(5806),
    [sym__begin_proof_step] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [2878] = {
    [sym_block_comment] = STATE(2878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_DASH_GT] = ACTIONS(5856),
    [anon_sym_u27f6] = ACTIONS(5856),
    [anon_sym_u2192] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5856),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [anon_sym_PROOF] = ACTIONS(5856),
    [anon_sym_BY] = ACTIONS(5856),
    [anon_sym_OBVIOUS] = ACTIONS(5856),
    [anon_sym_OMITTED] = ACTIONS(5856),
    [sym__begin_proof] = ACTIONS(5856),
    [sym__begin_proof_step] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [2879] = {
    [sym_block_comment] = STATE(2879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_DASH_GT] = ACTIONS(5860),
    [anon_sym_u27f6] = ACTIONS(5860),
    [anon_sym_u2192] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5860),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [anon_sym_PROOF] = ACTIONS(5860),
    [anon_sym_BY] = ACTIONS(5860),
    [anon_sym_OBVIOUS] = ACTIONS(5860),
    [anon_sym_OMITTED] = ACTIONS(5860),
    [sym__begin_proof] = ACTIONS(5860),
    [sym__begin_proof_step] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [2880] = {
    [sym_block_comment] = STATE(2880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_DASH_GT] = ACTIONS(5768),
    [anon_sym_u27f6] = ACTIONS(5768),
    [anon_sym_u2192] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [anon_sym_PROOF] = ACTIONS(5768),
    [anon_sym_BY] = ACTIONS(5768),
    [anon_sym_OBVIOUS] = ACTIONS(5768),
    [anon_sym_OMITTED] = ACTIONS(5768),
    [sym__begin_proof] = ACTIONS(5768),
    [sym__begin_proof_step] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [2881] = {
    [sym_block_comment] = STATE(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_DASH_GT] = ACTIONS(5892),
    [anon_sym_u27f6] = ACTIONS(5892),
    [anon_sym_u2192] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [anon_sym_PROOF] = ACTIONS(5892),
    [anon_sym_BY] = ACTIONS(5892),
    [anon_sym_OBVIOUS] = ACTIONS(5892),
    [anon_sym_OMITTED] = ACTIONS(5892),
    [sym__begin_proof] = ACTIONS(5892),
    [sym__begin_proof_step] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [2882] = {
    [sym_block_comment] = STATE(2882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_DASH_GT] = ACTIONS(5690),
    [anon_sym_u27f6] = ACTIONS(5690),
    [anon_sym_u2192] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_PROOF] = ACTIONS(5690),
    [anon_sym_BY] = ACTIONS(5690),
    [anon_sym_OBVIOUS] = ACTIONS(5690),
    [anon_sym_OMITTED] = ACTIONS(5690),
    [sym__begin_proof] = ACTIONS(5690),
    [sym__begin_proof_step] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2883] = {
    [sym_block_comment] = STATE(2883),
    [sym_label_as] = STATE(631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(6037),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_DEF] = ACTIONS(3845),
    [anon_sym_DEFS] = ACTIONS(4078),
    [sym__begin_proof_step] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2884] = {
    [sym_block_comment] = STATE(2884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_DASH_GT] = ACTIONS(5756),
    [anon_sym_u27f6] = ACTIONS(5756),
    [anon_sym_u2192] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5756),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [anon_sym_PROOF] = ACTIONS(5756),
    [anon_sym_BY] = ACTIONS(5756),
    [anon_sym_OBVIOUS] = ACTIONS(5756),
    [anon_sym_OMITTED] = ACTIONS(5756),
    [sym__begin_proof] = ACTIONS(5756),
    [sym__begin_proof_step] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [2885] = {
    [sym_block_comment] = STATE(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_DASH_GT] = ACTIONS(5760),
    [anon_sym_u27f6] = ACTIONS(5760),
    [anon_sym_u2192] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5760),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [anon_sym_PROOF] = ACTIONS(5760),
    [anon_sym_BY] = ACTIONS(5760),
    [anon_sym_OBVIOUS] = ACTIONS(5760),
    [anon_sym_OMITTED] = ACTIONS(5760),
    [sym__begin_proof] = ACTIONS(5760),
    [sym__begin_proof_step] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [2886] = {
    [sym_block_comment] = STATE(2886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_DASH_GT] = ACTIONS(5764),
    [anon_sym_u27f6] = ACTIONS(5764),
    [anon_sym_u2192] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5764),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [anon_sym_PROOF] = ACTIONS(5764),
    [anon_sym_BY] = ACTIONS(5764),
    [anon_sym_OBVIOUS] = ACTIONS(5764),
    [anon_sym_OMITTED] = ACTIONS(5764),
    [sym__begin_proof] = ACTIONS(5764),
    [sym__begin_proof_step] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [2887] = {
    [sym_block_comment] = STATE(2887),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_DASH_GT] = ACTIONS(5724),
    [anon_sym_u27f6] = ACTIONS(5724),
    [anon_sym_u2192] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5724),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [anon_sym_PROOF] = ACTIONS(5724),
    [anon_sym_BY] = ACTIONS(5724),
    [anon_sym_OBVIOUS] = ACTIONS(5724),
    [anon_sym_OMITTED] = ACTIONS(5724),
    [sym__begin_proof] = ACTIONS(5724),
    [sym__begin_proof_step] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [2888] = {
    [sym_block_comment] = STATE(2888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_DASH_GT] = ACTIONS(5896),
    [anon_sym_u27f6] = ACTIONS(5896),
    [anon_sym_u2192] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [anon_sym_PROOF] = ACTIONS(5896),
    [anon_sym_BY] = ACTIONS(5896),
    [anon_sym_OBVIOUS] = ACTIONS(5896),
    [anon_sym_OMITTED] = ACTIONS(5896),
    [sym__begin_proof] = ACTIONS(5896),
    [sym__begin_proof_step] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [2889] = {
    [sym_block_comment] = STATE(2889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_DASH_GT] = ACTIONS(5900),
    [anon_sym_u27f6] = ACTIONS(5900),
    [anon_sym_u2192] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [anon_sym_PROOF] = ACTIONS(5900),
    [anon_sym_BY] = ACTIONS(5900),
    [anon_sym_OBVIOUS] = ACTIONS(5900),
    [anon_sym_OMITTED] = ACTIONS(5900),
    [sym__begin_proof] = ACTIONS(5900),
    [sym__begin_proof_step] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [2890] = {
    [sym_block_comment] = STATE(2890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_DASH_GT] = ACTIONS(5904),
    [anon_sym_u27f6] = ACTIONS(5904),
    [anon_sym_u2192] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [anon_sym_PROOF] = ACTIONS(5904),
    [anon_sym_BY] = ACTIONS(5904),
    [anon_sym_OBVIOUS] = ACTIONS(5904),
    [anon_sym_OMITTED] = ACTIONS(5904),
    [sym__begin_proof] = ACTIONS(5904),
    [sym__begin_proof_step] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [2891] = {
    [sym_block_comment] = STATE(2891),
    [sym_label_as] = STATE(411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(4078),
    [anon_sym_u27fc] = ACTIONS(4078),
    [anon_sym_u21a6] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(6039),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(3845),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2892] = {
    [sym_block_comment] = STATE(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_DASH_GT] = ACTIONS(5870),
    [anon_sym_u27f6] = ACTIONS(5870),
    [anon_sym_u2192] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5870),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [anon_sym_PROOF] = ACTIONS(5870),
    [anon_sym_BY] = ACTIONS(5870),
    [anon_sym_OBVIOUS] = ACTIONS(5870),
    [anon_sym_OMITTED] = ACTIONS(5870),
    [sym__begin_proof] = ACTIONS(5870),
    [sym__begin_proof_step] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [2893] = {
    [sym_block_comment] = STATE(2893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_DASH_GT] = ACTIONS(5912),
    [anon_sym_u27f6] = ACTIONS(5912),
    [anon_sym_u2192] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5912),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [anon_sym_PROOF] = ACTIONS(5912),
    [anon_sym_BY] = ACTIONS(5912),
    [anon_sym_OBVIOUS] = ACTIONS(5912),
    [anon_sym_OMITTED] = ACTIONS(5912),
    [sym__begin_proof] = ACTIONS(5912),
    [sym__begin_proof_step] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [2894] = {
    [sym_block_comment] = STATE(2894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_GT_GT] = ACTIONS(5688),
    [anon_sym_u3009] = ACTIONS(5688),
    [anon_sym_u27e9] = ACTIONS(5688),
    [anon_sym_GT_GT_] = ACTIONS(5690),
    [anon_sym_u3009_] = ACTIONS(5690),
    [anon_sym_u27e9_] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2895] = {
    [sym_block_comment] = STATE(2895),
    [sym_case_box] = STATE(159),
    [aux_sym_case_repeat1] = STATE(2904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5684),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [anon_sym_PROOF] = ACTIONS(5684),
    [anon_sym_BY] = ACTIONS(5684),
    [anon_sym_OBVIOUS] = ACTIONS(5684),
    [anon_sym_OMITTED] = ACTIONS(5684),
    [sym__begin_proof] = ACTIONS(5684),
    [sym__begin_proof_step] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2896] = {
    [sym_block_comment] = STATE(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_GT_GT] = ACTIONS(5710),
    [anon_sym_u3009] = ACTIONS(5710),
    [anon_sym_u27e9] = ACTIONS(5710),
    [anon_sym_GT_GT_] = ACTIONS(5708),
    [anon_sym_u3009_] = ACTIONS(5708),
    [anon_sym_u27e9_] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_COMMA] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5708),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [2897] = {
    [sym_block_comment] = STATE(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(6041),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5676),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [anon_sym_PROOF] = ACTIONS(5676),
    [anon_sym_BY] = ACTIONS(5676),
    [anon_sym_OBVIOUS] = ACTIONS(5676),
    [anon_sym_OMITTED] = ACTIONS(5676),
    [sym__begin_proof] = ACTIONS(5676),
    [sym__begin_proof_step] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [2898] = {
    [sym_block_comment] = STATE(2898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_GT_GT] = ACTIONS(5714),
    [anon_sym_u3009] = ACTIONS(5714),
    [anon_sym_u27e9] = ACTIONS(5714),
    [anon_sym_GT_GT_] = ACTIONS(5712),
    [anon_sym_u3009_] = ACTIONS(5712),
    [anon_sym_u27e9_] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5712),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [2899] = {
    [sym_block_comment] = STATE(2899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_u3009] = ACTIONS(5698),
    [anon_sym_u27e9] = ACTIONS(5698),
    [anon_sym_GT_GT_] = ACTIONS(5696),
    [anon_sym_u3009_] = ACTIONS(5696),
    [anon_sym_u27e9_] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5696),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [2900] = {
    [sym_block_comment] = STATE(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_GT_GT] = ACTIONS(5688),
    [anon_sym_u3009] = ACTIONS(5688),
    [anon_sym_u27e9] = ACTIONS(5688),
    [anon_sym_GT_GT_] = ACTIONS(5690),
    [anon_sym_u3009_] = ACTIONS(5690),
    [anon_sym_u27e9_] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2901] = {
    [sym_block_comment] = STATE(2901),
    [sym_def_eq] = STATE(751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_EQ_EQ] = ACTIONS(3817),
    [anon_sym_u225c] = ACTIONS(3817),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_LPAREN] = ACTIONS(6043),
    [anon_sym_LBRACK] = ACTIONS(5768),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [anon_sym_PROOF] = ACTIONS(5768),
    [anon_sym_BY] = ACTIONS(5768),
    [anon_sym_OBVIOUS] = ACTIONS(5768),
    [anon_sym_OMITTED] = ACTIONS(5768),
    [sym__begin_proof] = ACTIONS(5768),
    [sym__begin_proof_step] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [2902] = {
    [sym_block_comment] = STATE(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_u3009] = ACTIONS(5718),
    [anon_sym_u27e9] = ACTIONS(5718),
    [anon_sym_GT_GT_] = ACTIONS(5716),
    [anon_sym_u3009_] = ACTIONS(5716),
    [anon_sym_u27e9_] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_COMMA] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5716),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [2903] = {
    [sym_block_comment] = STATE(2903),
    [sym_case_box] = STATE(283),
    [aux_sym_case_repeat1] = STATE(2903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_PROOF] = ACTIONS(5663),
    [anon_sym_BY] = ACTIONS(5663),
    [anon_sym_OBVIOUS] = ACTIONS(5663),
    [anon_sym_OMITTED] = ACTIONS(5663),
    [sym__begin_proof] = ACTIONS(5663),
    [sym__begin_proof_step] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2904] = {
    [sym_block_comment] = STATE(2904),
    [sym_case_box] = STATE(160),
    [aux_sym_case_repeat1] = STATE(2903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5672),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [anon_sym_PROOF] = ACTIONS(5672),
    [anon_sym_BY] = ACTIONS(5672),
    [anon_sym_OBVIOUS] = ACTIONS(5672),
    [anon_sym_OMITTED] = ACTIONS(5672),
    [sym__begin_proof] = ACTIONS(5672),
    [sym__begin_proof_step] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [2905] = {
    [sym_block_comment] = STATE(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_GT_GT] = ACTIONS(5706),
    [anon_sym_u3009] = ACTIONS(5706),
    [anon_sym_u27e9] = ACTIONS(5706),
    [anon_sym_GT_GT_] = ACTIONS(5704),
    [anon_sym_u3009_] = ACTIONS(5704),
    [anon_sym_u27e9_] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2906] = {
    [sym_block_comment] = STATE(2906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_GT_GT] = ACTIONS(5702),
    [anon_sym_u3009] = ACTIONS(5702),
    [anon_sym_u27e9] = ACTIONS(5702),
    [anon_sym_GT_GT_] = ACTIONS(5700),
    [anon_sym_u3009_] = ACTIONS(5700),
    [anon_sym_u27e9_] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_COMMA] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(6035),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5700),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [2907] = {
    [sym_block_comment] = STATE(2907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_GT_GT] = ACTIONS(5720),
    [anon_sym_u3009] = ACTIONS(5720),
    [anon_sym_u27e9] = ACTIONS(5720),
    [anon_sym_GT_GT_] = ACTIONS(5722),
    [anon_sym_u3009_] = ACTIONS(5722),
    [anon_sym_u27e9_] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5722),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [2908] = {
    [sym_block_comment] = STATE(2908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_GT_GT] = ACTIONS(5906),
    [anon_sym_u3009] = ACTIONS(5906),
    [anon_sym_u27e9] = ACTIONS(5906),
    [anon_sym_GT_GT_] = ACTIONS(5904),
    [anon_sym_u3009_] = ACTIONS(5904),
    [anon_sym_u27e9_] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [2909] = {
    [sym_block_comment] = STATE(2909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_u3009] = ACTIONS(5800),
    [anon_sym_u27e9] = ACTIONS(5800),
    [anon_sym_GT_GT_] = ACTIONS(5798),
    [anon_sym_u3009_] = ACTIONS(5798),
    [anon_sym_u27e9_] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5798),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [2910] = {
    [sym_block_comment] = STATE(2910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_GT_GT] = ACTIONS(5804),
    [anon_sym_u3009] = ACTIONS(5804),
    [anon_sym_u27e9] = ACTIONS(5804),
    [anon_sym_GT_GT_] = ACTIONS(5802),
    [anon_sym_u3009_] = ACTIONS(5802),
    [anon_sym_u27e9_] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_COMMA] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5802),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [2911] = {
    [sym_block_comment] = STATE(2911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_u3009] = ACTIONS(5770),
    [anon_sym_u27e9] = ACTIONS(5770),
    [anon_sym_GT_GT_] = ACTIONS(5768),
    [anon_sym_u3009_] = ACTIONS(5768),
    [anon_sym_u27e9_] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [2912] = {
    [sym_block_comment] = STATE(2912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_GT_GT] = ACTIONS(5840),
    [anon_sym_u3009] = ACTIONS(5840),
    [anon_sym_u27e9] = ACTIONS(5840),
    [anon_sym_GT_GT_] = ACTIONS(5838),
    [anon_sym_u3009_] = ACTIONS(5838),
    [anon_sym_u27e9_] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5838),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [2913] = {
    [sym_block_comment] = STATE(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_GT_GT] = ACTIONS(5844),
    [anon_sym_u3009] = ACTIONS(5844),
    [anon_sym_u27e9] = ACTIONS(5844),
    [anon_sym_GT_GT_] = ACTIONS(5842),
    [anon_sym_u3009_] = ACTIONS(5842),
    [anon_sym_u27e9_] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_COMMA] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5842),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [2914] = {
    [sym_block_comment] = STATE(2914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_GT_GT] = ACTIONS(5848),
    [anon_sym_u3009] = ACTIONS(5848),
    [anon_sym_u27e9] = ACTIONS(5848),
    [anon_sym_GT_GT_] = ACTIONS(5846),
    [anon_sym_u3009_] = ACTIONS(5846),
    [anon_sym_u27e9_] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5846),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [2915] = {
    [sym_block_comment] = STATE(2915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5864),
    [anon_sym_u3009] = ACTIONS(5864),
    [anon_sym_u27e9] = ACTIONS(5864),
    [anon_sym_GT_GT_] = ACTIONS(5862),
    [anon_sym_u3009_] = ACTIONS(5862),
    [anon_sym_u27e9_] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5862),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [2916] = {
    [sym_block_comment] = STATE(2916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_GT_GT] = ACTIONS(5894),
    [anon_sym_u3009] = ACTIONS(5894),
    [anon_sym_u27e9] = ACTIONS(5894),
    [anon_sym_GT_GT_] = ACTIONS(5892),
    [anon_sym_u3009_] = ACTIONS(5892),
    [anon_sym_u27e9_] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [2917] = {
    [sym_block_comment] = STATE(2917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_GT_GT] = ACTIONS(5898),
    [anon_sym_u3009] = ACTIONS(5898),
    [anon_sym_u27e9] = ACTIONS(5898),
    [anon_sym_GT_GT_] = ACTIONS(5896),
    [anon_sym_u3009_] = ACTIONS(5896),
    [anon_sym_u27e9_] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_COMMA] = ACTIONS(5896),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [2918] = {
    [sym_block_comment] = STATE(2918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_u3009] = ACTIONS(5902),
    [anon_sym_u27e9] = ACTIONS(5902),
    [anon_sym_GT_GT_] = ACTIONS(5900),
    [anon_sym_u3009_] = ACTIONS(5900),
    [anon_sym_u27e9_] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_COMMA] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [2919] = {
    [sym_block_comment] = STATE(2919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(6041),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5700),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [anon_sym_PROOF] = ACTIONS(5700),
    [anon_sym_BY] = ACTIONS(5700),
    [anon_sym_OBVIOUS] = ACTIONS(5700),
    [anon_sym_OMITTED] = ACTIONS(5700),
    [sym__begin_proof] = ACTIONS(5700),
    [sym__begin_proof_step] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [2920] = {
    [sym_block_comment] = STATE(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_GT_GT] = ACTIONS(5940),
    [anon_sym_u3009] = ACTIONS(5940),
    [anon_sym_u27e9] = ACTIONS(5940),
    [anon_sym_GT_GT_] = ACTIONS(5942),
    [anon_sym_u3009_] = ACTIONS(5942),
    [anon_sym_u27e9_] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5942),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [2921] = {
    [sym_block_comment] = STATE(2921),
    [sym_label_as] = STATE(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4078),
    [anon_sym_u25a1] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(6045),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__bullet] = ACTIONS(4078),
    [sym__dedent] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2922] = {
    [sym_block_comment] = STATE(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5774),
    [anon_sym_u3009] = ACTIONS(5774),
    [anon_sym_u27e9] = ACTIONS(5774),
    [anon_sym_GT_GT_] = ACTIONS(5772),
    [anon_sym_u3009_] = ACTIONS(5772),
    [anon_sym_u27e9_] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5772),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [2923] = {
    [sym_block_comment] = STATE(2923),
    [sym_case_box] = STATE(131),
    [aux_sym_case_repeat1] = STATE(2975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_DASH_GT] = ACTIONS(5672),
    [anon_sym_u27f6] = ACTIONS(5672),
    [anon_sym_u2192] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EXCEPT] = ACTIONS(5672),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_RBRACK_] = ACTIONS(5672),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5672),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [2924] = {
    [sym_block_comment] = STATE(2924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5712),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [anon_sym_PROOF] = ACTIONS(5712),
    [anon_sym_BY] = ACTIONS(5712),
    [anon_sym_OBVIOUS] = ACTIONS(5712),
    [anon_sym_OMITTED] = ACTIONS(5712),
    [sym__begin_proof] = ACTIONS(5712),
    [sym__begin_proof_step] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [2925] = {
    [sym_block_comment] = STATE(2925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_GT_GT] = ACTIONS(5706),
    [anon_sym_u3009] = ACTIONS(5706),
    [anon_sym_u27e9] = ACTIONS(5706),
    [anon_sym_GT_GT_] = ACTIONS(5704),
    [anon_sym_u3009_] = ACTIONS(5704),
    [anon_sym_u27e9_] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2926] = {
    [sym_block_comment] = STATE(2926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_u3009] = ACTIONS(5910),
    [anon_sym_u27e9] = ACTIONS(5910),
    [anon_sym_GT_GT_] = ACTIONS(5908),
    [anon_sym_u3009_] = ACTIONS(5908),
    [anon_sym_u27e9_] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5908),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [2927] = {
    [sym_block_comment] = STATE(2927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_GT_GT] = ACTIONS(5914),
    [anon_sym_u3009] = ACTIONS(5914),
    [anon_sym_u27e9] = ACTIONS(5914),
    [anon_sym_GT_GT_] = ACTIONS(5912),
    [anon_sym_u3009_] = ACTIONS(5912),
    [anon_sym_u27e9_] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_COMMA] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5912),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [2928] = {
    [sym_block_comment] = STATE(2928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_GT_GT] = ACTIONS(5688),
    [anon_sym_u3009] = ACTIONS(5688),
    [anon_sym_u27e9] = ACTIONS(5688),
    [anon_sym_GT_GT_] = ACTIONS(5690),
    [anon_sym_u3009_] = ACTIONS(5690),
    [anon_sym_u27e9_] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2929] = {
    [sym_block_comment] = STATE(2929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_GT_GT] = ACTIONS(5932),
    [anon_sym_u3009] = ACTIONS(5932),
    [anon_sym_u27e9] = ACTIONS(5932),
    [anon_sym_GT_GT_] = ACTIONS(5934),
    [anon_sym_u3009_] = ACTIONS(5934),
    [anon_sym_u27e9_] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5934),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [2930] = {
    [sym_block_comment] = STATE(2930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_GT_GT] = ACTIONS(5738),
    [anon_sym_u3009] = ACTIONS(5738),
    [anon_sym_u27e9] = ACTIONS(5738),
    [anon_sym_GT_GT_] = ACTIONS(5736),
    [anon_sym_u3009_] = ACTIONS(5736),
    [anon_sym_u27e9_] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5736),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [2931] = {
    [sym_block_comment] = STATE(2931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_GT_GT] = ACTIONS(5746),
    [anon_sym_u3009] = ACTIONS(5746),
    [anon_sym_u27e9] = ACTIONS(5746),
    [anon_sym_GT_GT_] = ACTIONS(5744),
    [anon_sym_u3009_] = ACTIONS(5744),
    [anon_sym_u27e9_] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5744),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [2932] = {
    [sym_block_comment] = STATE(2932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_GT_GT] = ACTIONS(5750),
    [anon_sym_u3009] = ACTIONS(5750),
    [anon_sym_u27e9] = ACTIONS(5750),
    [anon_sym_GT_GT_] = ACTIONS(5748),
    [anon_sym_u3009_] = ACTIONS(5748),
    [anon_sym_u27e9_] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_COMMA] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5748),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [2933] = {
    [sym_block_comment] = STATE(2933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_EQ_EQ] = ACTIONS(5892),
    [anon_sym_u225c] = ACTIONS(5892),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5892),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [anon_sym_PROOF] = ACTIONS(5892),
    [anon_sym_BY] = ACTIONS(5892),
    [anon_sym_OBVIOUS] = ACTIONS(5892),
    [anon_sym_OMITTED] = ACTIONS(5892),
    [sym__begin_proof] = ACTIONS(5892),
    [sym__begin_proof_step] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [2934] = {
    [sym_block_comment] = STATE(2934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_EQ_EQ] = ACTIONS(5896),
    [anon_sym_u225c] = ACTIONS(5896),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [anon_sym_LBRACK] = ACTIONS(5896),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [anon_sym_PROOF] = ACTIONS(5896),
    [anon_sym_BY] = ACTIONS(5896),
    [anon_sym_OBVIOUS] = ACTIONS(5896),
    [anon_sym_OMITTED] = ACTIONS(5896),
    [sym__begin_proof] = ACTIONS(5896),
    [sym__begin_proof_step] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [2935] = {
    [sym_block_comment] = STATE(2935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_EQ_EQ] = ACTIONS(5900),
    [anon_sym_u225c] = ACTIONS(5900),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_LPAREN] = ACTIONS(5902),
    [anon_sym_LBRACK] = ACTIONS(5900),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [anon_sym_PROOF] = ACTIONS(5900),
    [anon_sym_BY] = ACTIONS(5900),
    [anon_sym_OBVIOUS] = ACTIONS(5900),
    [anon_sym_OMITTED] = ACTIONS(5900),
    [sym__begin_proof] = ACTIONS(5900),
    [sym__begin_proof_step] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [2936] = {
    [sym_block_comment] = STATE(2936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_EQ_EQ] = ACTIONS(5904),
    [anon_sym_u225c] = ACTIONS(5904),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_LPAREN] = ACTIONS(5906),
    [anon_sym_LBRACK] = ACTIONS(5904),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [anon_sym_PROOF] = ACTIONS(5904),
    [anon_sym_BY] = ACTIONS(5904),
    [anon_sym_OBVIOUS] = ACTIONS(5904),
    [anon_sym_OMITTED] = ACTIONS(5904),
    [sym__begin_proof] = ACTIONS(5904),
    [sym__begin_proof_step] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [2937] = {
    [sym_block_comment] = STATE(2937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_PROOF] = ACTIONS(5690),
    [anon_sym_BY] = ACTIONS(5690),
    [anon_sym_OBVIOUS] = ACTIONS(5690),
    [anon_sym_OMITTED] = ACTIONS(5690),
    [sym__begin_proof] = ACTIONS(5690),
    [sym__begin_proof_step] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2938] = {
    [sym_block_comment] = STATE(2938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5696),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [anon_sym_PROOF] = ACTIONS(5696),
    [anon_sym_BY] = ACTIONS(5696),
    [anon_sym_OBVIOUS] = ACTIONS(5696),
    [anon_sym_OMITTED] = ACTIONS(5696),
    [sym__begin_proof] = ACTIONS(5696),
    [sym__begin_proof_step] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [2939] = {
    [sym_block_comment] = STATE(2939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_GT_GT] = ACTIONS(5780),
    [anon_sym_u3009] = ACTIONS(5780),
    [anon_sym_u27e9] = ACTIONS(5780),
    [anon_sym_GT_GT_] = ACTIONS(5778),
    [anon_sym_u3009_] = ACTIONS(5778),
    [anon_sym_u27e9_] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5778),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [2940] = {
    [sym_block_comment] = STATE(2940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_GT_GT] = ACTIONS(5784),
    [anon_sym_u3009] = ACTIONS(5784),
    [anon_sym_u27e9] = ACTIONS(5784),
    [anon_sym_GT_GT_] = ACTIONS(5782),
    [anon_sym_u3009_] = ACTIONS(5782),
    [anon_sym_u27e9_] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_COMMA] = ACTIONS(5782),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5782),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [2941] = {
    [sym_block_comment] = STATE(2941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_u3009] = ACTIONS(5758),
    [anon_sym_u27e9] = ACTIONS(5758),
    [anon_sym_GT_GT_] = ACTIONS(5756),
    [anon_sym_u3009_] = ACTIONS(5756),
    [anon_sym_u27e9_] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5756),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [2942] = {
    [sym_block_comment] = STATE(2942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_u3009] = ACTIONS(5762),
    [anon_sym_u27e9] = ACTIONS(5762),
    [anon_sym_GT_GT_] = ACTIONS(5760),
    [anon_sym_u3009_] = ACTIONS(5760),
    [anon_sym_u27e9_] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5760),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [2943] = {
    [sym_block_comment] = STATE(2943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_GT_GT] = ACTIONS(5792),
    [anon_sym_u3009] = ACTIONS(5792),
    [anon_sym_u27e9] = ACTIONS(5792),
    [anon_sym_GT_GT_] = ACTIONS(5790),
    [anon_sym_u3009_] = ACTIONS(5790),
    [anon_sym_u27e9_] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_COMMA] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5790),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [2944] = {
    [sym_block_comment] = STATE(2944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_GT_GT] = ACTIONS(5796),
    [anon_sym_u3009] = ACTIONS(5796),
    [anon_sym_u27e9] = ACTIONS(5796),
    [anon_sym_GT_GT_] = ACTIONS(5794),
    [anon_sym_u3009_] = ACTIONS(5794),
    [anon_sym_u27e9_] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5794),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [2945] = {
    [sym_block_comment] = STATE(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_GT_GT] = ACTIONS(5766),
    [anon_sym_u3009] = ACTIONS(5766),
    [anon_sym_u27e9] = ACTIONS(5766),
    [anon_sym_GT_GT_] = ACTIONS(5764),
    [anon_sym_u3009_] = ACTIONS(5764),
    [anon_sym_u27e9_] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5764),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [2946] = {
    [sym_block_comment] = STATE(2946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_GT_GT] = ACTIONS(5726),
    [anon_sym_u3009] = ACTIONS(5726),
    [anon_sym_u27e9] = ACTIONS(5726),
    [anon_sym_GT_GT_] = ACTIONS(5724),
    [anon_sym_u3009_] = ACTIONS(5724),
    [anon_sym_u27e9_] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_COMMA] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5724),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [2947] = {
    [sym_block_comment] = STATE(2947),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_GT_GT] = ACTIONS(5812),
    [anon_sym_u3009] = ACTIONS(5812),
    [anon_sym_u27e9] = ACTIONS(5812),
    [anon_sym_GT_GT_] = ACTIONS(5810),
    [anon_sym_u3009_] = ACTIONS(5810),
    [anon_sym_u27e9_] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5810),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [2948] = {
    [sym_block_comment] = STATE(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_u3009] = ACTIONS(5858),
    [anon_sym_u27e9] = ACTIONS(5858),
    [anon_sym_GT_GT_] = ACTIONS(5860),
    [anon_sym_u3009_] = ACTIONS(5860),
    [anon_sym_u27e9_] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5860),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [2949] = {
    [sym_block_comment] = STATE(2949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_GT_GT] = ACTIONS(5820),
    [anon_sym_u3009] = ACTIONS(5820),
    [anon_sym_u27e9] = ACTIONS(5820),
    [anon_sym_GT_GT_] = ACTIONS(5818),
    [anon_sym_u3009_] = ACTIONS(5818),
    [anon_sym_u27e9_] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5818),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5818),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [2950] = {
    [sym_block_comment] = STATE(2950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_GT_GT] = ACTIONS(5824),
    [anon_sym_u3009] = ACTIONS(5824),
    [anon_sym_u27e9] = ACTIONS(5824),
    [anon_sym_GT_GT_] = ACTIONS(5822),
    [anon_sym_u3009_] = ACTIONS(5822),
    [anon_sym_u27e9_] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5822),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [2951] = {
    [sym_block_comment] = STATE(2951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_GT_GT] = ACTIONS(5828),
    [anon_sym_u3009] = ACTIONS(5828),
    [anon_sym_u27e9] = ACTIONS(5828),
    [anon_sym_GT_GT_] = ACTIONS(5826),
    [anon_sym_u3009_] = ACTIONS(5826),
    [anon_sym_u27e9_] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_COMMA] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5826),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [2952] = {
    [sym_block_comment] = STATE(2952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_GT_GT] = ACTIONS(5832),
    [anon_sym_u3009] = ACTIONS(5832),
    [anon_sym_u27e9] = ACTIONS(5832),
    [anon_sym_GT_GT_] = ACTIONS(5830),
    [anon_sym_u3009_] = ACTIONS(5830),
    [anon_sym_u27e9_] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_COMMA] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5830),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [2953] = {
    [sym_block_comment] = STATE(2953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_GT_GT] = ACTIONS(5836),
    [anon_sym_u3009] = ACTIONS(5836),
    [anon_sym_u27e9] = ACTIONS(5836),
    [anon_sym_GT_GT_] = ACTIONS(5834),
    [anon_sym_u3009_] = ACTIONS(5834),
    [anon_sym_u27e9_] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5834),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [2954] = {
    [sym_block_comment] = STATE(2954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_DASH_GT] = ACTIONS(5676),
    [anon_sym_u27f6] = ACTIONS(5676),
    [anon_sym_u2192] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EXCEPT] = ACTIONS(5676),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_RBRACK_] = ACTIONS(5676),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5676),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [2955] = {
    [sym_block_comment] = STATE(2955),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_GT_GT] = ACTIONS(5874),
    [anon_sym_u3009] = ACTIONS(5874),
    [anon_sym_u27e9] = ACTIONS(5874),
    [anon_sym_GT_GT_] = ACTIONS(5872),
    [anon_sym_u3009_] = ACTIONS(5872),
    [anon_sym_u27e9_] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_COMMA] = ACTIONS(5872),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5872),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [2956] = {
    [sym_block_comment] = STATE(2956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_GT_GT] = ACTIONS(5878),
    [anon_sym_u3009] = ACTIONS(5878),
    [anon_sym_u27e9] = ACTIONS(5878),
    [anon_sym_GT_GT_] = ACTIONS(5876),
    [anon_sym_u3009_] = ACTIONS(5876),
    [anon_sym_u27e9_] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_COMMA] = ACTIONS(5876),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5876),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [2957] = {
    [sym_block_comment] = STATE(2957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_GT_GT] = ACTIONS(5882),
    [anon_sym_u3009] = ACTIONS(5882),
    [anon_sym_u27e9] = ACTIONS(5882),
    [anon_sym_GT_GT_] = ACTIONS(5880),
    [anon_sym_u3009_] = ACTIONS(5880),
    [anon_sym_u27e9_] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_COMMA] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5880),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [2958] = {
    [sym_block_comment] = STATE(2958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_GT_GT] = ACTIONS(5936),
    [anon_sym_u3009] = ACTIONS(5936),
    [anon_sym_u27e9] = ACTIONS(5936),
    [anon_sym_GT_GT_] = ACTIONS(5938),
    [anon_sym_u3009_] = ACTIONS(5938),
    [anon_sym_u27e9_] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5938),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [2959] = {
    [sym_block_comment] = STATE(2959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_GT_GT] = ACTIONS(5886),
    [anon_sym_u3009] = ACTIONS(5886),
    [anon_sym_u27e9] = ACTIONS(5886),
    [anon_sym_GT_GT_] = ACTIONS(5884),
    [anon_sym_u3009_] = ACTIONS(5884),
    [anon_sym_u27e9_] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_COMMA] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5884),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [2960] = {
    [sym_block_comment] = STATE(2960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5716),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [anon_sym_PROOF] = ACTIONS(5716),
    [anon_sym_BY] = ACTIONS(5716),
    [anon_sym_OBVIOUS] = ACTIONS(5716),
    [anon_sym_OMITTED] = ACTIONS(5716),
    [sym__begin_proof] = ACTIONS(5716),
    [sym__begin_proof_step] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [2961] = {
    [sym_block_comment] = STATE(2961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5722),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [anon_sym_PROOF] = ACTIONS(5722),
    [anon_sym_BY] = ACTIONS(5722),
    [anon_sym_OBVIOUS] = ACTIONS(5722),
    [anon_sym_OMITTED] = ACTIONS(5722),
    [sym__begin_proof] = ACTIONS(5722),
    [sym__begin_proof_step] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [2962] = {
    [sym_block_comment] = STATE(2962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_GT_GT] = ACTIONS(5918),
    [anon_sym_u3009] = ACTIONS(5918),
    [anon_sym_u27e9] = ACTIONS(5918),
    [anon_sym_GT_GT_] = ACTIONS(5916),
    [anon_sym_u3009_] = ACTIONS(5916),
    [anon_sym_u27e9_] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5916),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [2963] = {
    [sym_block_comment] = STATE(2963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5922),
    [anon_sym_u3009] = ACTIONS(5922),
    [anon_sym_u27e9] = ACTIONS(5922),
    [anon_sym_GT_GT_] = ACTIONS(5920),
    [anon_sym_u3009_] = ACTIONS(5920),
    [anon_sym_u27e9_] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5920),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [2964] = {
    [sym_block_comment] = STATE(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_GT_GT] = ACTIONS(5924),
    [anon_sym_u3009] = ACTIONS(5924),
    [anon_sym_u27e9] = ACTIONS(5924),
    [anon_sym_GT_GT_] = ACTIONS(5926),
    [anon_sym_u3009_] = ACTIONS(5926),
    [anon_sym_u27e9_] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5926),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [2965] = {
    [sym_block_comment] = STATE(2965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_GT_GT] = ACTIONS(5928),
    [anon_sym_u3009] = ACTIONS(5928),
    [anon_sym_u27e9] = ACTIONS(5928),
    [anon_sym_GT_GT_] = ACTIONS(5930),
    [anon_sym_u3009_] = ACTIONS(5930),
    [anon_sym_u27e9_] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5930),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [2966] = {
    [sym_block_comment] = STATE(2966),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_GT_GT] = ACTIONS(5868),
    [anon_sym_u3009] = ACTIONS(5868),
    [anon_sym_u27e9] = ACTIONS(5868),
    [anon_sym_GT_GT_] = ACTIONS(5870),
    [anon_sym_u3009_] = ACTIONS(5870),
    [anon_sym_u27e9_] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5870),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [2967] = {
    [sym_block_comment] = STATE(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_GT_GT] = ACTIONS(5888),
    [anon_sym_u3009] = ACTIONS(5888),
    [anon_sym_u27e9] = ACTIONS(5888),
    [anon_sym_GT_GT_] = ACTIONS(5890),
    [anon_sym_u3009_] = ACTIONS(5890),
    [anon_sym_u27e9_] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_COMMA] = ACTIONS(5890),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5890),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [2968] = {
    [sym_block_comment] = STATE(2968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_PROOF] = ACTIONS(5690),
    [anon_sym_BY] = ACTIONS(5690),
    [anon_sym_OBVIOUS] = ACTIONS(5690),
    [anon_sym_OMITTED] = ACTIONS(5690),
    [sym__begin_proof] = ACTIONS(5690),
    [sym__begin_proof_step] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [2969] = {
    [sym_block_comment] = STATE(2969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_GT_GT] = ACTIONS(5730),
    [anon_sym_u3009] = ACTIONS(5730),
    [anon_sym_u27e9] = ACTIONS(5730),
    [anon_sym_GT_GT_] = ACTIONS(5728),
    [anon_sym_u3009_] = ACTIONS(5728),
    [anon_sym_u27e9_] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5728),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [2970] = {
    [sym_block_comment] = STATE(2970),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_GT_GT] = ACTIONS(5734),
    [anon_sym_u3009] = ACTIONS(5734),
    [anon_sym_u27e9] = ACTIONS(5734),
    [anon_sym_GT_GT_] = ACTIONS(5732),
    [anon_sym_u3009_] = ACTIONS(5732),
    [anon_sym_u27e9_] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_COMMA] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5732),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [2971] = {
    [sym_block_comment] = STATE(2971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_GT_GT] = ACTIONS(5742),
    [anon_sym_u3009] = ACTIONS(5742),
    [anon_sym_u27e9] = ACTIONS(5742),
    [anon_sym_GT_GT_] = ACTIONS(5740),
    [anon_sym_u3009_] = ACTIONS(5740),
    [anon_sym_u27e9_] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5740),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [2972] = {
    [sym_block_comment] = STATE(2972),
    [sym_set_in] = STATE(323),
    [sym_label_as] = STATE(993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5964),
    [anon_sym_u2208] = ACTIONS(5967),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_RBRACE] = ACTIONS(4078),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2973] = {
    [sym_block_comment] = STATE(2973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_u3009] = ACTIONS(5754),
    [anon_sym_u27e9] = ACTIONS(5754),
    [anon_sym_GT_GT_] = ACTIONS(5752),
    [anon_sym_u3009_] = ACTIONS(5752),
    [anon_sym_u27e9_] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5752),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [2974] = {
    [sym_block_comment] = STATE(2974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_PROOF] = ACTIONS(5704),
    [anon_sym_BY] = ACTIONS(5704),
    [anon_sym_OBVIOUS] = ACTIONS(5704),
    [anon_sym_OMITTED] = ACTIONS(5704),
    [sym__begin_proof] = ACTIONS(5704),
    [sym__begin_proof_step] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [2975] = {
    [sym_block_comment] = STATE(2975),
    [sym_case_box] = STATE(303),
    [aux_sym_case_repeat1] = STATE(2975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_u27f6] = ACTIONS(5663),
    [anon_sym_u2192] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EXCEPT] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_RBRACK_] = ACTIONS(5663),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2976] = {
    [sym_block_comment] = STATE(2976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5708),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [anon_sym_PROOF] = ACTIONS(5708),
    [anon_sym_BY] = ACTIONS(5708),
    [anon_sym_OBVIOUS] = ACTIONS(5708),
    [anon_sym_OMITTED] = ACTIONS(5708),
    [sym__begin_proof] = ACTIONS(5708),
    [sym__begin_proof_step] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [2977] = {
    [sym_block_comment] = STATE(2977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_GT_GT] = ACTIONS(5349),
    [anon_sym_u3009] = ACTIONS(5349),
    [anon_sym_u27e9] = ACTIONS(5349),
    [anon_sym_GT_GT_] = ACTIONS(5351),
    [anon_sym_u3009_] = ACTIONS(5351),
    [anon_sym_u27e9_] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [2978] = {
    [sym_block_comment] = STATE(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5850),
    [anon_sym_u3009] = ACTIONS(5850),
    [anon_sym_u27e9] = ACTIONS(5850),
    [anon_sym_GT_GT_] = ACTIONS(5852),
    [anon_sym_u3009_] = ACTIONS(5852),
    [anon_sym_u27e9_] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5852),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [2979] = {
    [sym_block_comment] = STATE(2979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_GT_GT] = ACTIONS(5808),
    [anon_sym_u3009] = ACTIONS(5808),
    [anon_sym_u27e9] = ACTIONS(5808),
    [anon_sym_GT_GT_] = ACTIONS(5806),
    [anon_sym_u3009_] = ACTIONS(5806),
    [anon_sym_u27e9_] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5806),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [2980] = {
    [sym_block_comment] = STATE(2980),
    [sym_case_box] = STATE(141),
    [aux_sym_case_repeat1] = STATE(2923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_DASH_GT] = ACTIONS(5684),
    [anon_sym_u27f6] = ACTIONS(5684),
    [anon_sym_u2192] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EXCEPT] = ACTIONS(5684),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_RBRACK_] = ACTIONS(5684),
    [anon_sym_DASH] = ACTIONS(5686),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5684),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2981] = {
    [sym_block_comment] = STATE(2981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_u3009] = ACTIONS(5854),
    [anon_sym_u27e9] = ACTIONS(5854),
    [anon_sym_GT_GT_] = ACTIONS(5856),
    [anon_sym_u3009_] = ACTIONS(5856),
    [anon_sym_u27e9_] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5856),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [2982] = {
    [sym_block_comment] = STATE(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_GT_GT] = ACTIONS(5665),
    [anon_sym_u3009] = ACTIONS(5665),
    [anon_sym_u27e9] = ACTIONS(5665),
    [anon_sym_GT_GT_] = ACTIONS(5663),
    [anon_sym_u3009_] = ACTIONS(5663),
    [anon_sym_u27e9_] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2983] = {
    [sym_block_comment] = STATE(2983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_GT_GT] = ACTIONS(5788),
    [anon_sym_u3009] = ACTIONS(5788),
    [anon_sym_u27e9] = ACTIONS(5788),
    [anon_sym_GT_GT_] = ACTIONS(5786),
    [anon_sym_u3009_] = ACTIONS(5786),
    [anon_sym_u27e9_] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5786),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [2984] = {
    [sym_block_comment] = STATE(2984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_GT_GT] = ACTIONS(5816),
    [anon_sym_u3009] = ACTIONS(5816),
    [anon_sym_u27e9] = ACTIONS(5816),
    [anon_sym_GT_GT_] = ACTIONS(5814),
    [anon_sym_u3009_] = ACTIONS(5814),
    [anon_sym_u27e9_] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_COMMA] = ACTIONS(5814),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5814),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [2985] = {
    [sym_block_comment] = STATE(2985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5912),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [anon_sym_PROOF] = ACTIONS(5912),
    [anon_sym_BY] = ACTIONS(5912),
    [anon_sym_OBVIOUS] = ACTIONS(5912),
    [anon_sym_OMITTED] = ACTIONS(5912),
    [sym__begin_proof] = ACTIONS(5912),
    [sym__begin_proof_step] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [2986] = {
    [sym_block_comment] = STATE(2986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5830),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [anon_sym_PROOF] = ACTIONS(5830),
    [anon_sym_BY] = ACTIONS(5830),
    [anon_sym_OBVIOUS] = ACTIONS(5830),
    [anon_sym_OMITTED] = ACTIONS(5830),
    [sym__begin_proof] = ACTIONS(5830),
    [sym__begin_proof_step] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [2987] = {
    [sym_block_comment] = STATE(2987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5834),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [anon_sym_PROOF] = ACTIONS(5834),
    [anon_sym_BY] = ACTIONS(5834),
    [anon_sym_OBVIOUS] = ACTIONS(5834),
    [anon_sym_OMITTED] = ACTIONS(5834),
    [sym__begin_proof] = ACTIONS(5834),
    [sym__begin_proof_step] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [2988] = {
    [sym_block_comment] = STATE(2988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5846),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [anon_sym_PROOF] = ACTIONS(5846),
    [anon_sym_BY] = ACTIONS(5846),
    [anon_sym_OBVIOUS] = ACTIONS(5846),
    [anon_sym_OMITTED] = ACTIONS(5846),
    [sym__begin_proof] = ACTIONS(5846),
    [sym__begin_proof_step] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [2989] = {
    [sym_block_comment] = STATE(2989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_PROOF] = ACTIONS(5663),
    [anon_sym_BY] = ACTIONS(5663),
    [anon_sym_OBVIOUS] = ACTIONS(5663),
    [anon_sym_OMITTED] = ACTIONS(5663),
    [sym__begin_proof] = ACTIONS(5663),
    [sym__begin_proof_step] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [2990] = {
    [sym_block_comment] = STATE(2990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5786),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [anon_sym_PROOF] = ACTIONS(5786),
    [anon_sym_BY] = ACTIONS(5786),
    [anon_sym_OBVIOUS] = ACTIONS(5786),
    [anon_sym_OMITTED] = ACTIONS(5786),
    [sym__begin_proof] = ACTIONS(5786),
    [sym__begin_proof_step] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [2991] = {
    [sym_block_comment] = STATE(2991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5872),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [anon_sym_PROOF] = ACTIONS(5872),
    [anon_sym_BY] = ACTIONS(5872),
    [anon_sym_OBVIOUS] = ACTIONS(5872),
    [anon_sym_OMITTED] = ACTIONS(5872),
    [sym__begin_proof] = ACTIONS(5872),
    [sym__begin_proof_step] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [2992] = {
    [sym_block_comment] = STATE(2992),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5876),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [anon_sym_PROOF] = ACTIONS(5876),
    [anon_sym_BY] = ACTIONS(5876),
    [anon_sym_OBVIOUS] = ACTIONS(5876),
    [anon_sym_OMITTED] = ACTIONS(5876),
    [sym__begin_proof] = ACTIONS(5876),
    [sym__begin_proof_step] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [2993] = {
    [sym_block_comment] = STATE(2993),
    [sym_case_box] = STATE(174),
    [aux_sym_case_repeat1] = STATE(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_COMMA] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5684),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [anon_sym_DEF] = ACTIONS(5686),
    [anon_sym_DEFS] = ACTIONS(5684),
    [sym__begin_proof_step] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [2994] = {
    [sym_block_comment] = STATE(2994),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6052),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [2995] = {
    [sym_block_comment] = STATE(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5880),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [anon_sym_PROOF] = ACTIONS(5880),
    [anon_sym_BY] = ACTIONS(5880),
    [anon_sym_OBVIOUS] = ACTIONS(5880),
    [anon_sym_OMITTED] = ACTIONS(5880),
    [sym__begin_proof] = ACTIONS(5880),
    [sym__begin_proof_step] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [2996] = {
    [sym_block_comment] = STATE(2996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5938),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [anon_sym_PROOF] = ACTIONS(5938),
    [anon_sym_BY] = ACTIONS(5938),
    [anon_sym_OBVIOUS] = ACTIONS(5938),
    [anon_sym_OMITTED] = ACTIONS(5938),
    [sym__begin_proof] = ACTIONS(5938),
    [sym__begin_proof_step] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [2997] = {
    [sym_block_comment] = STATE(2997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5884),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [anon_sym_PROOF] = ACTIONS(5884),
    [anon_sym_BY] = ACTIONS(5884),
    [anon_sym_OBVIOUS] = ACTIONS(5884),
    [anon_sym_OMITTED] = ACTIONS(5884),
    [sym__begin_proof] = ACTIONS(5884),
    [sym__begin_proof_step] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [2998] = {
    [sym_block_comment] = STATE(2998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5744),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [anon_sym_PROOF] = ACTIONS(5744),
    [anon_sym_BY] = ACTIONS(5744),
    [anon_sym_OBVIOUS] = ACTIONS(5744),
    [anon_sym_OMITTED] = ACTIONS(5744),
    [sym__begin_proof] = ACTIONS(5744),
    [sym__begin_proof_step] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [2999] = {
    [sym_block_comment] = STATE(2999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5728),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [anon_sym_PROOF] = ACTIONS(5728),
    [anon_sym_BY] = ACTIONS(5728),
    [anon_sym_OBVIOUS] = ACTIONS(5728),
    [anon_sym_OMITTED] = ACTIONS(5728),
    [sym__begin_proof] = ACTIONS(5728),
    [sym__begin_proof_step] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [3000] = {
    [sym_block_comment] = STATE(3000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5732),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [anon_sym_PROOF] = ACTIONS(5732),
    [anon_sym_BY] = ACTIONS(5732),
    [anon_sym_OBVIOUS] = ACTIONS(5732),
    [anon_sym_OMITTED] = ACTIONS(5732),
    [sym__begin_proof] = ACTIONS(5732),
    [sym__begin_proof_step] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [3001] = {
    [sym_block_comment] = STATE(3001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_DASH_GT] = ACTIONS(5704),
    [anon_sym_u27f6] = ACTIONS(5704),
    [anon_sym_u2192] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EXCEPT] = ACTIONS(5704),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_RBRACK_] = ACTIONS(5704),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [3002] = {
    [sym_block_comment] = STATE(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [anon_sym_PROOF] = ACTIONS(5351),
    [anon_sym_BY] = ACTIONS(5351),
    [anon_sym_OBVIOUS] = ACTIONS(5351),
    [anon_sym_OMITTED] = ACTIONS(5351),
    [sym__begin_proof] = ACTIONS(5351),
    [sym__begin_proof_step] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [3003] = {
    [sym_block_comment] = STATE(3003),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6055),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3004] = {
    [sym_block_comment] = STATE(3004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5740),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [anon_sym_PROOF] = ACTIONS(5740),
    [anon_sym_BY] = ACTIONS(5740),
    [anon_sym_OBVIOUS] = ACTIONS(5740),
    [anon_sym_OMITTED] = ACTIONS(5740),
    [sym__begin_proof] = ACTIONS(5740),
    [sym__begin_proof_step] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [3005] = {
    [sym_block_comment] = STATE(3005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_DASH_GT] = ACTIONS(5722),
    [anon_sym_u27f6] = ACTIONS(5722),
    [anon_sym_u2192] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EXCEPT] = ACTIONS(5722),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_RBRACK_] = ACTIONS(5722),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5722),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [3006] = {
    [sym_block_comment] = STATE(3006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5802),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [anon_sym_PROOF] = ACTIONS(5802),
    [anon_sym_BY] = ACTIONS(5802),
    [anon_sym_OBVIOUS] = ACTIONS(5802),
    [anon_sym_OMITTED] = ACTIONS(5802),
    [sym__begin_proof] = ACTIONS(5802),
    [sym__begin_proof_step] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [3007] = {
    [sym_block_comment] = STATE(3007),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4653),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6058),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3008] = {
    [sym_block_comment] = STATE(3008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5852),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [anon_sym_PROOF] = ACTIONS(5852),
    [anon_sym_BY] = ACTIONS(5852),
    [anon_sym_OBVIOUS] = ACTIONS(5852),
    [anon_sym_OMITTED] = ACTIONS(5852),
    [sym__begin_proof] = ACTIONS(5852),
    [sym__begin_proof_step] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [3009] = {
    [sym_block_comment] = STATE(3009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5806),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [anon_sym_PROOF] = ACTIONS(5806),
    [anon_sym_BY] = ACTIONS(5806),
    [anon_sym_OBVIOUS] = ACTIONS(5806),
    [anon_sym_OMITTED] = ACTIONS(5806),
    [sym__begin_proof] = ACTIONS(5806),
    [sym__begin_proof_step] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [3010] = {
    [sym_block_comment] = STATE(3010),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3011] = {
    [sym_block_comment] = STATE(3011),
    [sym_case_box] = STATE(151),
    [aux_sym_case_repeat1] = STATE(3050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5672),
    [anon_sym_u27fc] = ACTIONS(5672),
    [anon_sym_u21a6] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5670),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5672),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [3012] = {
    [sym_block_comment] = STATE(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_DASH_GT] = ACTIONS(5708),
    [anon_sym_u27f6] = ACTIONS(5708),
    [anon_sym_u2192] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EXCEPT] = ACTIONS(5708),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_RBRACK_] = ACTIONS(5708),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5708),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [3013] = {
    [sym_block_comment] = STATE(3013),
    [sym_case_box] = STATE(240),
    [aux_sym_case_repeat1] = STATE(3013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_GT_GT] = ACTIONS(5663),
    [anon_sym_u3009] = ACTIONS(5663),
    [anon_sym_u27e9] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [3014] = {
    [sym_block_comment] = STATE(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5856),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [anon_sym_PROOF] = ACTIONS(5856),
    [anon_sym_BY] = ACTIONS(5856),
    [anon_sym_OBVIOUS] = ACTIONS(5856),
    [anon_sym_OMITTED] = ACTIONS(5856),
    [sym__begin_proof] = ACTIONS(5856),
    [sym__begin_proof_step] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [3015] = {
    [sym_block_comment] = STATE(3015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5860),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [anon_sym_PROOF] = ACTIONS(5860),
    [anon_sym_BY] = ACTIONS(5860),
    [anon_sym_OBVIOUS] = ACTIONS(5860),
    [anon_sym_OMITTED] = ACTIONS(5860),
    [sym__begin_proof] = ACTIONS(5860),
    [sym__begin_proof_step] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [3016] = {
    [sym_block_comment] = STATE(3016),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6064),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3017] = {
    [sym_block_comment] = STATE(3017),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [anon_sym_PROOF] = ACTIONS(5768),
    [anon_sym_BY] = ACTIONS(5768),
    [anon_sym_OBVIOUS] = ACTIONS(5768),
    [anon_sym_OMITTED] = ACTIONS(5768),
    [sym__begin_proof] = ACTIONS(5768),
    [sym__begin_proof_step] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [3018] = {
    [sym_block_comment] = STATE(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5676),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [anon_sym_DEF] = ACTIONS(5678),
    [anon_sym_DEFS] = ACTIONS(5676),
    [sym__begin_proof_step] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [3019] = {
    [sym_block_comment] = STATE(3019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5748),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [anon_sym_PROOF] = ACTIONS(5748),
    [anon_sym_BY] = ACTIONS(5748),
    [anon_sym_OBVIOUS] = ACTIONS(5748),
    [anon_sym_OMITTED] = ACTIONS(5748),
    [sym__begin_proof] = ACTIONS(5748),
    [sym__begin_proof_step] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [3020] = {
    [sym_block_comment] = STATE(3020),
    [sym_case_box] = STATE(175),
    [aux_sym_case_repeat1] = STATE(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5672),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [anon_sym_DEF] = ACTIONS(5670),
    [anon_sym_DEFS] = ACTIONS(5672),
    [sym__begin_proof_step] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [3021] = {
    [sym_block_comment] = STATE(3021),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3022] = {
    [sym_block_comment] = STATE(3022),
    [sym_case_box] = STATE(237),
    [aux_sym_case_repeat1] = STATE(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_DEF] = ACTIONS(5665),
    [anon_sym_DEFS] = ACTIONS(5663),
    [sym__begin_proof_step] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [3023] = {
    [sym_block_comment] = STATE(3023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5676),
    [anon_sym_u3009] = ACTIONS(5676),
    [anon_sym_u27e9] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(6072),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5676),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [3024] = {
    [sym_block_comment] = STATE(3024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_PROOF] = ACTIONS(5690),
    [anon_sym_BY] = ACTIONS(5690),
    [anon_sym_OBVIOUS] = ACTIONS(5690),
    [anon_sym_OMITTED] = ACTIONS(5690),
    [sym__begin_proof] = ACTIONS(5690),
    [sym__begin_proof_step] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3025] = {
    [sym_block_comment] = STATE(3025),
    [sym_case_box] = STATE(156),
    [aux_sym_case_repeat1] = STATE(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_u3009] = ACTIONS(5684),
    [anon_sym_u27e9] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_COMMA] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5684),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [3026] = {
    [sym_block_comment] = STATE(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5838),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [anon_sym_PROOF] = ACTIONS(5838),
    [anon_sym_BY] = ACTIONS(5838),
    [anon_sym_OBVIOUS] = ACTIONS(5838),
    [anon_sym_OMITTED] = ACTIONS(5838),
    [sym__begin_proof] = ACTIONS(5838),
    [sym__begin_proof_step] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [3027] = {
    [sym_block_comment] = STATE(3027),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4705),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3028] = {
    [sym_block_comment] = STATE(3028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5842),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [anon_sym_PROOF] = ACTIONS(5842),
    [anon_sym_BY] = ACTIONS(5842),
    [anon_sym_OBVIOUS] = ACTIONS(5842),
    [anon_sym_OMITTED] = ACTIONS(5842),
    [sym__begin_proof] = ACTIONS(5842),
    [sym__begin_proof_step] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [3029] = {
    [sym_block_comment] = STATE(3029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_DASH_GT] = ACTIONS(5712),
    [anon_sym_u27f6] = ACTIONS(5712),
    [anon_sym_u2192] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EXCEPT] = ACTIONS(5712),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_RBRACK_] = ACTIONS(5712),
    [anon_sym_DASH] = ACTIONS(5714),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5712),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [3030] = {
    [sym_block_comment] = STATE(3030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5862),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [anon_sym_PROOF] = ACTIONS(5862),
    [anon_sym_BY] = ACTIONS(5862),
    [anon_sym_OBVIOUS] = ACTIONS(5862),
    [anon_sym_OMITTED] = ACTIONS(5862),
    [sym__begin_proof] = ACTIONS(5862),
    [sym__begin_proof_step] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [3031] = {
    [sym_block_comment] = STATE(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5890),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [anon_sym_PROOF] = ACTIONS(5890),
    [anon_sym_BY] = ACTIONS(5890),
    [anon_sym_OBVIOUS] = ACTIONS(5890),
    [anon_sym_OMITTED] = ACTIONS(5890),
    [sym__begin_proof] = ACTIONS(5890),
    [sym__begin_proof_step] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [3032] = {
    [sym_block_comment] = STATE(3032),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4737),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3033] = {
    [sym_block_comment] = STATE(3033),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6080),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3034] = {
    [sym_block_comment] = STATE(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_DASH_GT] = ACTIONS(5696),
    [anon_sym_u27f6] = ACTIONS(5696),
    [anon_sym_u2192] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EXCEPT] = ACTIONS(5696),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_RBRACK_] = ACTIONS(5696),
    [anon_sym_DASH] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5696),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [3035] = {
    [sym_block_comment] = STATE(3035),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4765),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6083),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3036] = {
    [sym_block_comment] = STATE(3036),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6086),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3037] = {
    [sym_block_comment] = STATE(3037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5778),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [anon_sym_PROOF] = ACTIONS(5778),
    [anon_sym_BY] = ACTIONS(5778),
    [anon_sym_OBVIOUS] = ACTIONS(5778),
    [anon_sym_OMITTED] = ACTIONS(5778),
    [sym__begin_proof] = ACTIONS(5778),
    [sym__begin_proof_step] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [3038] = {
    [sym_block_comment] = STATE(3038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5942),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [anon_sym_PROOF] = ACTIONS(5942),
    [anon_sym_BY] = ACTIONS(5942),
    [anon_sym_OBVIOUS] = ACTIONS(5942),
    [anon_sym_OMITTED] = ACTIONS(5942),
    [sym__begin_proof] = ACTIONS(5942),
    [sym__begin_proof_step] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [3039] = {
    [sym_block_comment] = STATE(3039),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6089),
    [anon_sym_LPAREN] = ACTIONS(6093),
    [anon_sym_RPAREN] = ACTIONS(6095),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3040] = {
    [sym_block_comment] = STATE(3040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5782),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [anon_sym_PROOF] = ACTIONS(5782),
    [anon_sym_BY] = ACTIONS(5782),
    [anon_sym_OBVIOUS] = ACTIONS(5782),
    [anon_sym_OMITTED] = ACTIONS(5782),
    [sym__begin_proof] = ACTIONS(5782),
    [sym__begin_proof_step] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [3041] = {
    [sym_block_comment] = STATE(3041),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5870),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [anon_sym_PROOF] = ACTIONS(5870),
    [anon_sym_BY] = ACTIONS(5870),
    [anon_sym_OBVIOUS] = ACTIONS(5870),
    [anon_sym_OMITTED] = ACTIONS(5870),
    [sym__begin_proof] = ACTIONS(5870),
    [sym__begin_proof_step] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [3042] = {
    [sym_block_comment] = STATE(3042),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6099),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3043] = {
    [sym_block_comment] = STATE(3043),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6102),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3044] = {
    [sym_block_comment] = STATE(3044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5752),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [anon_sym_PROOF] = ACTIONS(5752),
    [anon_sym_BY] = ACTIONS(5752),
    [anon_sym_OBVIOUS] = ACTIONS(5752),
    [anon_sym_OMITTED] = ACTIONS(5752),
    [sym__begin_proof] = ACTIONS(5752),
    [sym__begin_proof_step] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [3045] = {
    [sym_block_comment] = STATE(3045),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3046] = {
    [sym_block_comment] = STATE(3046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5790),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [anon_sym_PROOF] = ACTIONS(5790),
    [anon_sym_BY] = ACTIONS(5790),
    [anon_sym_OBVIOUS] = ACTIONS(5790),
    [anon_sym_OMITTED] = ACTIONS(5790),
    [sym__begin_proof] = ACTIONS(5790),
    [sym__begin_proof_step] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [3047] = {
    [sym_block_comment] = STATE(3047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_DASH_GT] = ACTIONS(5700),
    [anon_sym_u27f6] = ACTIONS(5700),
    [anon_sym_u2192] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EXCEPT] = ACTIONS(5700),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_RBRACK_] = ACTIONS(5700),
    [anon_sym_DASH] = ACTIONS(5702),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5700),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [3048] = {
    [sym_block_comment] = STATE(3048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5794),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [anon_sym_PROOF] = ACTIONS(5794),
    [anon_sym_BY] = ACTIONS(5794),
    [anon_sym_OBVIOUS] = ACTIONS(5794),
    [anon_sym_OMITTED] = ACTIONS(5794),
    [sym__begin_proof] = ACTIONS(5794),
    [sym__begin_proof_step] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [3049] = {
    [sym_block_comment] = STATE(3049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5798),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [anon_sym_PROOF] = ACTIONS(5798),
    [anon_sym_BY] = ACTIONS(5798),
    [anon_sym_OBVIOUS] = ACTIONS(5798),
    [anon_sym_OMITTED] = ACTIONS(5798),
    [sym__begin_proof] = ACTIONS(5798),
    [sym__begin_proof_step] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [3050] = {
    [sym_block_comment] = STATE(3050),
    [sym_case_box] = STATE(281),
    [aux_sym_case_repeat1] = STATE(3050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5663),
    [anon_sym_u27fc] = ACTIONS(5663),
    [anon_sym_u21a6] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5665),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [3051] = {
    [sym_block_comment] = STATE(3051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5756),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [anon_sym_PROOF] = ACTIONS(5756),
    [anon_sym_BY] = ACTIONS(5756),
    [anon_sym_OBVIOUS] = ACTIONS(5756),
    [anon_sym_OMITTED] = ACTIONS(5756),
    [sym__begin_proof] = ACTIONS(5756),
    [sym__begin_proof_step] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [3052] = {
    [sym_block_comment] = STATE(3052),
    [sym_case_box] = STATE(157),
    [aux_sym_case_repeat1] = STATE(3013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_GT_GT] = ACTIONS(5672),
    [anon_sym_u3009] = ACTIONS(5672),
    [anon_sym_u27e9] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5672),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [3053] = {
    [sym_block_comment] = STATE(3053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5760),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [anon_sym_PROOF] = ACTIONS(5760),
    [anon_sym_BY] = ACTIONS(5760),
    [anon_sym_OBVIOUS] = ACTIONS(5760),
    [anon_sym_OMITTED] = ACTIONS(5760),
    [sym__begin_proof] = ACTIONS(5760),
    [sym__begin_proof_step] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [3054] = {
    [sym_block_comment] = STATE(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5764),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [anon_sym_PROOF] = ACTIONS(5764),
    [anon_sym_BY] = ACTIONS(5764),
    [anon_sym_OBVIOUS] = ACTIONS(5764),
    [anon_sym_OMITTED] = ACTIONS(5764),
    [sym__begin_proof] = ACTIONS(5764),
    [sym__begin_proof_step] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [3055] = {
    [sym_block_comment] = STATE(3055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5724),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [anon_sym_PROOF] = ACTIONS(5724),
    [anon_sym_BY] = ACTIONS(5724),
    [anon_sym_OBVIOUS] = ACTIONS(5724),
    [anon_sym_OMITTED] = ACTIONS(5724),
    [sym__begin_proof] = ACTIONS(5724),
    [sym__begin_proof_step] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [3056] = {
    [sym_block_comment] = STATE(3056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [anon_sym_PROOF] = ACTIONS(5892),
    [anon_sym_BY] = ACTIONS(5892),
    [anon_sym_OBVIOUS] = ACTIONS(5892),
    [anon_sym_OMITTED] = ACTIONS(5892),
    [sym__begin_proof] = ACTIONS(5892),
    [sym__begin_proof_step] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [3057] = {
    [sym_block_comment] = STATE(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_DASH_GT] = ACTIONS(5716),
    [anon_sym_u27f6] = ACTIONS(5716),
    [anon_sym_u2192] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EXCEPT] = ACTIONS(5716),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_RBRACK_] = ACTIONS(5716),
    [anon_sym_DASH] = ACTIONS(5718),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5716),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [3058] = {
    [sym_block_comment] = STATE(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [anon_sym_PROOF] = ACTIONS(5896),
    [anon_sym_BY] = ACTIONS(5896),
    [anon_sym_OBVIOUS] = ACTIONS(5896),
    [anon_sym_OMITTED] = ACTIONS(5896),
    [sym__begin_proof] = ACTIONS(5896),
    [sym__begin_proof_step] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [3059] = {
    [sym_block_comment] = STATE(3059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [anon_sym_PROOF] = ACTIONS(5900),
    [anon_sym_BY] = ACTIONS(5900),
    [anon_sym_OBVIOUS] = ACTIONS(5900),
    [anon_sym_OMITTED] = ACTIONS(5900),
    [sym__begin_proof] = ACTIONS(5900),
    [sym__begin_proof_step] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [3060] = {
    [sym_block_comment] = STATE(3060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [anon_sym_PROOF] = ACTIONS(5904),
    [anon_sym_BY] = ACTIONS(5904),
    [anon_sym_OBVIOUS] = ACTIONS(5904),
    [anon_sym_OMITTED] = ACTIONS(5904),
    [sym__begin_proof] = ACTIONS(5904),
    [sym__begin_proof_step] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [3061] = {
    [sym_block_comment] = STATE(3061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5772),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [anon_sym_PROOF] = ACTIONS(5772),
    [anon_sym_BY] = ACTIONS(5772),
    [anon_sym_OBVIOUS] = ACTIONS(5772),
    [anon_sym_OMITTED] = ACTIONS(5772),
    [sym__begin_proof] = ACTIONS(5772),
    [sym__begin_proof_step] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [3062] = {
    [sym_block_comment] = STATE(3062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_DASH_GT] = ACTIONS(5690),
    [anon_sym_u27f6] = ACTIONS(5690),
    [anon_sym_u2192] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EXCEPT] = ACTIONS(5690),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_RBRACK_] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3063] = {
    [sym_block_comment] = STATE(3063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5736),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [anon_sym_PROOF] = ACTIONS(5736),
    [anon_sym_BY] = ACTIONS(5736),
    [anon_sym_OBVIOUS] = ACTIONS(5736),
    [anon_sym_OMITTED] = ACTIONS(5736),
    [sym__begin_proof] = ACTIONS(5736),
    [sym__begin_proof_step] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [3064] = {
    [sym_block_comment] = STATE(3064),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6108),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3065] = {
    [sym_block_comment] = STATE(3065),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_PROOF] = ACTIONS(5704),
    [anon_sym_BY] = ACTIONS(5704),
    [anon_sym_OBVIOUS] = ACTIONS(5704),
    [anon_sym_OMITTED] = ACTIONS(5704),
    [sym__begin_proof] = ACTIONS(5704),
    [sym__begin_proof_step] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [3066] = {
    [sym_block_comment] = STATE(3066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_DASH_GT] = ACTIONS(5690),
    [anon_sym_u27f6] = ACTIONS(5690),
    [anon_sym_u2192] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EXCEPT] = ACTIONS(5690),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_RBRACK_] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3067] = {
    [sym_block_comment] = STATE(3067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5810),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [anon_sym_PROOF] = ACTIONS(5810),
    [anon_sym_BY] = ACTIONS(5810),
    [anon_sym_OBVIOUS] = ACTIONS(5810),
    [anon_sym_OMITTED] = ACTIONS(5810),
    [sym__begin_proof] = ACTIONS(5810),
    [sym__begin_proof_step] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [3068] = {
    [sym_block_comment] = STATE(3068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5814),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [anon_sym_PROOF] = ACTIONS(5814),
    [anon_sym_BY] = ACTIONS(5814),
    [anon_sym_OBVIOUS] = ACTIONS(5814),
    [anon_sym_OMITTED] = ACTIONS(5814),
    [sym__begin_proof] = ACTIONS(5814),
    [sym__begin_proof_step] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [3069] = {
    [sym_block_comment] = STATE(3069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5676),
    [anon_sym_u27fc] = ACTIONS(5676),
    [anon_sym_u21a6] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(6111),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5678),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5676),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [3070] = {
    [sym_block_comment] = STATE(3070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5818),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [anon_sym_PROOF] = ACTIONS(5818),
    [anon_sym_BY] = ACTIONS(5818),
    [anon_sym_OBVIOUS] = ACTIONS(5818),
    [anon_sym_OMITTED] = ACTIONS(5818),
    [sym__begin_proof] = ACTIONS(5818),
    [sym__begin_proof_step] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [3071] = {
    [sym_block_comment] = STATE(3071),
    [sym_case_box] = STATE(150),
    [aux_sym_case_repeat1] = STATE(3011),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5684),
    [anon_sym_u27fc] = ACTIONS(5684),
    [anon_sym_u21a6] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_COMMA] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5686),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5684),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [3072] = {
    [sym_block_comment] = STATE(3072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5908),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [anon_sym_PROOF] = ACTIONS(5908),
    [anon_sym_BY] = ACTIONS(5908),
    [anon_sym_OBVIOUS] = ACTIONS(5908),
    [anon_sym_OMITTED] = ACTIONS(5908),
    [sym__begin_proof] = ACTIONS(5908),
    [sym__begin_proof_step] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [3073] = {
    [sym_block_comment] = STATE(3073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5822),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [anon_sym_PROOF] = ACTIONS(5822),
    [anon_sym_BY] = ACTIONS(5822),
    [anon_sym_OBVIOUS] = ACTIONS(5822),
    [anon_sym_OMITTED] = ACTIONS(5822),
    [sym__begin_proof] = ACTIONS(5822),
    [sym__begin_proof_step] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [3074] = {
    [sym_block_comment] = STATE(3074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5934),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [anon_sym_PROOF] = ACTIONS(5934),
    [anon_sym_BY] = ACTIONS(5934),
    [anon_sym_OBVIOUS] = ACTIONS(5934),
    [anon_sym_OMITTED] = ACTIONS(5934),
    [sym__begin_proof] = ACTIONS(5934),
    [sym__begin_proof_step] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [3075] = {
    [sym_block_comment] = STATE(3075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5916),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [anon_sym_PROOF] = ACTIONS(5916),
    [anon_sym_BY] = ACTIONS(5916),
    [anon_sym_OBVIOUS] = ACTIONS(5916),
    [anon_sym_OMITTED] = ACTIONS(5916),
    [sym__begin_proof] = ACTIONS(5916),
    [sym__begin_proof_step] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [3076] = {
    [sym_block_comment] = STATE(3076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5920),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [anon_sym_PROOF] = ACTIONS(5920),
    [anon_sym_BY] = ACTIONS(5920),
    [anon_sym_OBVIOUS] = ACTIONS(5920),
    [anon_sym_OMITTED] = ACTIONS(5920),
    [sym__begin_proof] = ACTIONS(5920),
    [sym__begin_proof_step] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [3077] = {
    [sym_block_comment] = STATE(3077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5826),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [anon_sym_PROOF] = ACTIONS(5826),
    [anon_sym_BY] = ACTIONS(5826),
    [anon_sym_OBVIOUS] = ACTIONS(5826),
    [anon_sym_OMITTED] = ACTIONS(5826),
    [sym__begin_proof] = ACTIONS(5826),
    [sym__begin_proof_step] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [3078] = {
    [sym_block_comment] = STATE(3078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5926),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [anon_sym_PROOF] = ACTIONS(5926),
    [anon_sym_BY] = ACTIONS(5926),
    [anon_sym_OBVIOUS] = ACTIONS(5926),
    [anon_sym_OMITTED] = ACTIONS(5926),
    [sym__begin_proof] = ACTIONS(5926),
    [sym__begin_proof_step] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [3079] = {
    [sym_block_comment] = STATE(3079),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5930),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [anon_sym_PROOF] = ACTIONS(5930),
    [anon_sym_BY] = ACTIONS(5930),
    [anon_sym_OBVIOUS] = ACTIONS(5930),
    [anon_sym_OMITTED] = ACTIONS(5930),
    [sym__begin_proof] = ACTIONS(5930),
    [sym__begin_proof_step] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [3080] = {
    [sym_block_comment] = STATE(3080),
    [sym_label_as] = STATE(993),
    [aux_sym_extends_repeat1] = STATE(4779),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(6113),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3081] = {
    [sym_block_comment] = STATE(3081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5708),
    [anon_sym_u27fc] = ACTIONS(5708),
    [anon_sym_u21a6] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_COMMA] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5710),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5708),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [3082] = {
    [sym_block_comment] = STATE(3082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_DASH_GT] = ACTIONS(5744),
    [anon_sym_u27f6] = ACTIONS(5744),
    [anon_sym_u2192] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EXCEPT] = ACTIONS(5744),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_RBRACK_] = ACTIONS(5744),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5744),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [3083] = {
    [sym_block_comment] = STATE(3083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_DASH_GT] = ACTIONS(5830),
    [anon_sym_u27f6] = ACTIONS(5830),
    [anon_sym_u2192] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EXCEPT] = ACTIONS(5830),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_RBRACK_] = ACTIONS(5830),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5830),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [3084] = {
    [sym_block_comment] = STATE(3084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_DEF] = ACTIONS(5706),
    [anon_sym_DEFS] = ACTIONS(5704),
    [sym__begin_proof_step] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [3085] = {
    [sym_block_comment] = STATE(3085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_COMMA] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5716),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [anon_sym_DEF] = ACTIONS(5718),
    [anon_sym_DEFS] = ACTIONS(5716),
    [sym__begin_proof_step] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [3086] = {
    [sym_block_comment] = STATE(3086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_DASH_GT] = ACTIONS(5834),
    [anon_sym_u27f6] = ACTIONS(5834),
    [anon_sym_u2192] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EXCEPT] = ACTIONS(5834),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_RBRACK_] = ACTIONS(5834),
    [anon_sym_DASH] = ACTIONS(5836),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5834),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [3087] = {
    [sym_block_comment] = STATE(3087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5696),
    [anon_sym_u27fc] = ACTIONS(5696),
    [anon_sym_u21a6] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5698),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5696),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [3088] = {
    [sym_block_comment] = STATE(3088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_DASH_GT] = ACTIONS(5786),
    [anon_sym_u27f6] = ACTIONS(5786),
    [anon_sym_u2192] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EXCEPT] = ACTIONS(5786),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_RBRACK_] = ACTIONS(5786),
    [anon_sym_DASH] = ACTIONS(5788),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5786),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [3089] = {
    [sym_block_comment] = STATE(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_DASH_GT] = ACTIONS(5890),
    [anon_sym_u27f6] = ACTIONS(5890),
    [anon_sym_u2192] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EXCEPT] = ACTIONS(5890),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_RBRACK_] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5888),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5890),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [3090] = {
    [sym_block_comment] = STATE(3090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5700),
    [anon_sym_u27fc] = ACTIONS(5700),
    [anon_sym_u21a6] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_COMMA] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(6111),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5702),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5700),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [3091] = {
    [sym_block_comment] = STATE(3091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_DEF] = ACTIONS(5688),
    [anon_sym_DEFS] = ACTIONS(5690),
    [sym__begin_proof_step] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3092] = {
    [sym_block_comment] = STATE(3092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_DASH_GT] = ACTIONS(5838),
    [anon_sym_u27f6] = ACTIONS(5838),
    [anon_sym_u2192] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EXCEPT] = ACTIONS(5838),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_RBRACK_] = ACTIONS(5838),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5838),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [3093] = {
    [sym_block_comment] = STATE(3093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_DASH_GT] = ACTIONS(5842),
    [anon_sym_u27f6] = ACTIONS(5842),
    [anon_sym_u2192] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EXCEPT] = ACTIONS(5842),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_RBRACK_] = ACTIONS(5842),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5842),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [3094] = {
    [sym_block_comment] = STATE(3094),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_DASH_GT] = ACTIONS(5846),
    [anon_sym_u27f6] = ACTIONS(5846),
    [anon_sym_u2192] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EXCEPT] = ACTIONS(5846),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_RBRACK_] = ACTIONS(5846),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5846),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [3095] = {
    [sym_block_comment] = STATE(3095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_DASH_GT] = ACTIONS(5862),
    [anon_sym_u27f6] = ACTIONS(5862),
    [anon_sym_u2192] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EXCEPT] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_RBRACK_] = ACTIONS(5862),
    [anon_sym_DASH] = ACTIONS(5864),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5862),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [3096] = {
    [sym_block_comment] = STATE(3096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_DASH_GT] = ACTIONS(5778),
    [anon_sym_u27f6] = ACTIONS(5778),
    [anon_sym_u2192] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EXCEPT] = ACTIONS(5778),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_RBRACK_] = ACTIONS(5778),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5778),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [3097] = {
    [sym_block_comment] = STATE(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5712),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [anon_sym_DEF] = ACTIONS(5714),
    [anon_sym_DEFS] = ACTIONS(5712),
    [sym__begin_proof_step] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [3098] = {
    [sym_block_comment] = STATE(3098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_DASH_GT] = ACTIONS(5794),
    [anon_sym_u27f6] = ACTIONS(5794),
    [anon_sym_u2192] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EXCEPT] = ACTIONS(5794),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_RBRACK_] = ACTIONS(5794),
    [anon_sym_DASH] = ACTIONS(5796),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5794),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [3099] = {
    [sym_block_comment] = STATE(3099),
    [sym_label_as] = STATE(201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(3845),
    [anon_sym_u2208] = ACTIONS(4078),
    [anon_sym_COLON_COLON] = ACTIONS(3825),
    [anon_sym_u2237] = ACTIONS(3827),
    [anon_sym_SLASH_BSLASH] = ACTIONS(4078),
    [anon_sym_u2227] = ACTIONS(4078),
    [anon_sym_BSLASH_SLASH] = ACTIONS(4078),
    [anon_sym_u2228] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27f9] = ACTIONS(4078),
    [anon_sym_u21d2] = ACTIONS(4078),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(4078),
    [anon_sym_u21f8] = ACTIONS(4078),
    [anon_sym_u2945] = ACTIONS(4078),
    [anon_sym_BSLASHequiv] = ACTIONS(4078),
    [anon_sym_u2261] = ACTIONS(4078),
    [anon_sym_LT_EQ_GT] = ACTIONS(4078),
    [anon_sym_u27fa] = ACTIONS(4078),
    [anon_sym_u21d4] = ACTIONS(4078),
    [anon_sym_TILDE_GT] = ACTIONS(4078),
    [anon_sym_u21dd] = ACTIONS(4078),
    [anon_sym_u219d] = ACTIONS(4078),
    [anon_sym_BSLASHland] = ACTIONS(4078),
    [anon_sym_BSLASHlor] = ACTIONS(4078),
    [anon_sym_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2254] = ACTIONS(4078),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(4078),
    [anon_sym_u2a74] = ACTIONS(4078),
    [anon_sym_SLASH_EQ] = ACTIONS(4078),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_u2260] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(3845),
    [sym_gt] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_EQ_LT] = ACTIONS(4078),
    [anon_sym_BSLASHleq] = ACTIONS(4078),
    [anon_sym_u2264] = ACTIONS(4078),
    [anon_sym_GT_EQ] = ACTIONS(4078),
    [anon_sym_BSLASHgeq] = ACTIONS(4078),
    [anon_sym_u2265] = ACTIONS(4078),
    [anon_sym_BSLASHapprox] = ACTIONS(4078),
    [anon_sym_u2248] = ACTIONS(4078),
    [anon_sym_PIPE_DASH] = ACTIONS(4078),
    [anon_sym_u22a2] = ACTIONS(4078),
    [anon_sym_PIPE_EQ] = ACTIONS(4078),
    [anon_sym_u22a8] = ACTIONS(4078),
    [anon_sym_DASH_PIPE] = ACTIONS(4078),
    [anon_sym_u22a3] = ACTIONS(4078),
    [anon_sym_EQ_PIPE] = ACTIONS(4078),
    [anon_sym_u2ae4] = ACTIONS(4078),
    [anon_sym_BSLASHasymp] = ACTIONS(4078),
    [anon_sym_u224d] = ACTIONS(4078),
    [anon_sym_BSLASHcong] = ACTIONS(4078),
    [anon_sym_u2245] = ACTIONS(4078),
    [anon_sym_BSLASHdoteq] = ACTIONS(4078),
    [anon_sym_u2250] = ACTIONS(4078),
    [anon_sym_BSLASHgg] = ACTIONS(4078),
    [anon_sym_u226b] = ACTIONS(4078),
    [anon_sym_BSLASHll] = ACTIONS(4078),
    [anon_sym_u226a] = ACTIONS(4078),
    [anon_sym_BSLASHnotin] = ACTIONS(4078),
    [anon_sym_u2209] = ACTIONS(4078),
    [anon_sym_BSLASHprec] = ACTIONS(3845),
    [anon_sym_u227a] = ACTIONS(4078),
    [anon_sym_BSLASHsucc] = ACTIONS(3845),
    [anon_sym_u227b] = ACTIONS(4078),
    [anon_sym_BSLASHpreceq] = ACTIONS(4078),
    [anon_sym_u2aaf] = ACTIONS(4078),
    [anon_sym_BSLASHsucceq] = ACTIONS(4078),
    [anon_sym_u2ab0] = ACTIONS(4078),
    [anon_sym_BSLASHpropto] = ACTIONS(4078),
    [anon_sym_u221d] = ACTIONS(4078),
    [anon_sym_BSLASHsim] = ACTIONS(3845),
    [anon_sym_u223c] = ACTIONS(4078),
    [anon_sym_BSLASHsimeq] = ACTIONS(4078),
    [anon_sym_u2243] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubset] = ACTIONS(3845),
    [anon_sym_u228f] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupset] = ACTIONS(3845),
    [anon_sym_u2290] = ACTIONS(4078),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(4078),
    [anon_sym_u2291] = ACTIONS(4078),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(4078),
    [anon_sym_u2292] = ACTIONS(4078),
    [anon_sym_BSLASHsubset] = ACTIONS(3845),
    [anon_sym_u2282] = ACTIONS(4078),
    [anon_sym_BSLASHsupset] = ACTIONS(3845),
    [anon_sym_u2283] = ACTIONS(4078),
    [anon_sym_BSLASHsubseteq] = ACTIONS(4078),
    [anon_sym_u2286] = ACTIONS(4078),
    [anon_sym_BSLASHsupseteq] = ACTIONS(4078),
    [anon_sym_u2287] = ACTIONS(4078),
    [sym_compose] = ACTIONS(4078),
    [sym_map_to] = ACTIONS(4078),
    [sym_map_from] = ACTIONS(4078),
    [sym_setminus] = ACTIONS(3845),
    [anon_sym_BSLASHcap] = ACTIONS(4078),
    [anon_sym_BSLASHintersect] = ACTIONS(4078),
    [anon_sym_u2229] = ACTIONS(4078),
    [anon_sym_BSLASHcup] = ACTIONS(4078),
    [anon_sym_BSLASHunion] = ACTIONS(4078),
    [anon_sym_u222a] = ACTIONS(4078),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_u2025] = ACTIONS(4078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4078),
    [anon_sym_u2026] = ACTIONS(4078),
    [anon_sym_PLUS] = ACTIONS(3845),
    [sym_plusplus] = ACTIONS(4078),
    [anon_sym_BSLASHoplus] = ACTIONS(4078),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(4078),
    [anon_sym_u2295] = ACTIONS(4078),
    [anon_sym_BSLASHominus] = ACTIONS(4078),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2296] = ACTIONS(4078),
    [sym_mod] = ACTIONS(3845),
    [sym_modmod] = ACTIONS(4078),
    [sym_vert] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [anon_sym_u2016] = ACTIONS(4078),
    [sym_minusminus] = ACTIONS(4078),
    [sym_amp] = ACTIONS(3845),
    [sym_ampamp] = ACTIONS(4078),
    [anon_sym_BSLASHodot] = ACTIONS(4078),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(4078),
    [anon_sym_u2299] = ACTIONS(4078),
    [anon_sym_BSLASHoslash] = ACTIONS(4078),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(4078),
    [anon_sym_u2298] = ACTIONS(4078),
    [anon_sym_BSLASHotimes] = ACTIONS(4078),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(4078),
    [anon_sym_u2297] = ACTIONS(4078),
    [sym_mul] = ACTIONS(3845),
    [sym_mulmul] = ACTIONS(4078),
    [sym_slash] = ACTIONS(3845),
    [sym_slashslash] = ACTIONS(4078),
    [anon_sym_BSLASHbigcirc] = ACTIONS(4078),
    [anon_sym_u25ef] = ACTIONS(4078),
    [anon_sym_BSLASHbullet] = ACTIONS(4078),
    [anon_sym_u25cf] = ACTIONS(4078),
    [anon_sym_BSLASHdiv] = ACTIONS(4078),
    [anon_sym_u00f7] = ACTIONS(4078),
    [anon_sym_BSLASHcirc] = ACTIONS(4078),
    [anon_sym_u2218] = ACTIONS(4078),
    [anon_sym_BSLASHstar] = ACTIONS(4078),
    [anon_sym_u22c6] = ACTIONS(4078),
    [anon_sym_u203c] = ACTIONS(4078),
    [sym_hashhash] = ACTIONS(4078),
    [sym_dol] = ACTIONS(3845),
    [sym_doldol] = ACTIONS(4078),
    [anon_sym_QMARK_QMARK] = ACTIONS(4078),
    [anon_sym_u2047] = ACTIONS(4078),
    [anon_sym_BSLASHsqcap] = ACTIONS(4078),
    [anon_sym_u2293] = ACTIONS(4078),
    [anon_sym_BSLASHsqcup] = ACTIONS(4078),
    [anon_sym_u2294] = ACTIONS(4078),
    [anon_sym_BSLASHuplus] = ACTIONS(4078),
    [anon_sym_u228e] = ACTIONS(4078),
    [anon_sym_BSLASHX] = ACTIONS(4078),
    [anon_sym_BSLASHtimes] = ACTIONS(4078),
    [anon_sym_u00d7] = ACTIONS(4078),
    [anon_sym_BSLASHwr] = ACTIONS(4078),
    [anon_sym_u2240] = ACTIONS(4078),
    [anon_sym_BSLASHcdot] = ACTIONS(4078),
    [anon_sym_u22c5] = ACTIONS(4078),
    [sym_pow] = ACTIONS(3845),
    [sym_powpow] = ACTIONS(4078),
    [anon_sym_CARET_PLUS] = ACTIONS(4078),
    [anon_sym_u207a] = ACTIONS(4078),
    [sym_asterisk] = ACTIONS(4078),
    [sym_sup_hash] = ACTIONS(4078),
    [sym_prime] = ACTIONS(4078),
    [anon_sym_PROVE] = ACTIONS(4078),
    [sym__double_excl] = ACTIONS(4078),
  },
  [3100] = {
    [sym_block_comment] = STATE(3100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_GT_GT] = ACTIONS(5690),
    [anon_sym_u3009] = ACTIONS(5690),
    [anon_sym_u27e9] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3101] = {
    [sym_block_comment] = STATE(3101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_u3009] = ACTIONS(5696),
    [anon_sym_u27e9] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5696),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [3102] = {
    [sym_block_comment] = STATE(3102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_DASH_GT] = ACTIONS(5798),
    [anon_sym_u27f6] = ACTIONS(5798),
    [anon_sym_u2192] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EXCEPT] = ACTIONS(5798),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_RBRACK_] = ACTIONS(5798),
    [anon_sym_DASH] = ACTIONS(5800),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5798),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [3103] = {
    [sym_block_comment] = STATE(3103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_DASH_GT] = ACTIONS(5872),
    [anon_sym_u27f6] = ACTIONS(5872),
    [anon_sym_u2192] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EXCEPT] = ACTIONS(5872),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_RBRACK_] = ACTIONS(5872),
    [anon_sym_DASH] = ACTIONS(5874),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5872),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [3104] = {
    [sym_block_comment] = STATE(3104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_DASH_GT] = ACTIONS(5876),
    [anon_sym_u27f6] = ACTIONS(5876),
    [anon_sym_u2192] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EXCEPT] = ACTIONS(5876),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_RBRACK_] = ACTIONS(5876),
    [anon_sym_DASH] = ACTIONS(5878),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5876),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [3105] = {
    [sym_block_comment] = STATE(3105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_DEF] = ACTIONS(5688),
    [anon_sym_DEFS] = ACTIONS(5690),
    [sym__begin_proof_step] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3106] = {
    [sym_block_comment] = STATE(3106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_DASH_GT] = ACTIONS(5782),
    [anon_sym_u27f6] = ACTIONS(5782),
    [anon_sym_u2192] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EXCEPT] = ACTIONS(5782),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_RBRACK_] = ACTIONS(5782),
    [anon_sym_DASH] = ACTIONS(5784),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5782),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [3107] = {
    [sym_block_comment] = STATE(3107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_DASH_GT] = ACTIONS(5852),
    [anon_sym_u27f6] = ACTIONS(5852),
    [anon_sym_u2192] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EXCEPT] = ACTIONS(5852),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_RBRACK_] = ACTIONS(5852),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5852),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [3108] = {
    [sym_block_comment] = STATE(3108),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_DASH_GT] = ACTIONS(5806),
    [anon_sym_u27f6] = ACTIONS(5806),
    [anon_sym_u2192] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EXCEPT] = ACTIONS(5806),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_RBRACK_] = ACTIONS(5806),
    [anon_sym_DASH] = ACTIONS(5808),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5806),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [3109] = {
    [sym_block_comment] = STATE(3109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_DASH_GT] = ACTIONS(5856),
    [anon_sym_u27f6] = ACTIONS(5856),
    [anon_sym_u2192] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EXCEPT] = ACTIONS(5856),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_RBRACK_] = ACTIONS(5856),
    [anon_sym_DASH] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5856),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [3110] = {
    [sym_block_comment] = STATE(3110),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_DASH_GT] = ACTIONS(5880),
    [anon_sym_u27f6] = ACTIONS(5880),
    [anon_sym_u2192] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EXCEPT] = ACTIONS(5880),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_RBRACK_] = ACTIONS(5880),
    [anon_sym_DASH] = ACTIONS(5882),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5880),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [3111] = {
    [sym_block_comment] = STATE(3111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_DASH_GT] = ACTIONS(5938),
    [anon_sym_u27f6] = ACTIONS(5938),
    [anon_sym_u2192] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EXCEPT] = ACTIONS(5938),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_RBRACK_] = ACTIONS(5938),
    [anon_sym_DASH] = ACTIONS(5936),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5938),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [3112] = {
    [sym_block_comment] = STATE(3112),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5696),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [anon_sym_DEF] = ACTIONS(5698),
    [anon_sym_DEFS] = ACTIONS(5696),
    [sym__begin_proof_step] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [3113] = {
    [sym_block_comment] = STATE(3113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_DASH_GT] = ACTIONS(5926),
    [anon_sym_u27f6] = ACTIONS(5926),
    [anon_sym_u2192] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EXCEPT] = ACTIONS(5926),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_RBRACK_] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5926),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [3114] = {
    [sym_block_comment] = STATE(3114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_u3009] = ACTIONS(5708),
    [anon_sym_u27e9] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_COMMA] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5708),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [3115] = {
    [sym_block_comment] = STATE(3115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_DASH_GT] = ACTIONS(5748),
    [anon_sym_u27f6] = ACTIONS(5748),
    [anon_sym_u2192] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EXCEPT] = ACTIONS(5748),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_RBRACK_] = ACTIONS(5748),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5748),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [3116] = {
    [sym_block_comment] = STATE(3116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_DASH_GT] = ACTIONS(5860),
    [anon_sym_u27f6] = ACTIONS(5860),
    [anon_sym_u2192] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EXCEPT] = ACTIONS(5860),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_RBRACK_] = ACTIONS(5860),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5860),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [3117] = {
    [sym_block_comment] = STATE(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_DASH_GT] = ACTIONS(5802),
    [anon_sym_u27f6] = ACTIONS(5802),
    [anon_sym_u2192] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EXCEPT] = ACTIONS(5802),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_RBRACK_] = ACTIONS(5802),
    [anon_sym_DASH] = ACTIONS(5804),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5802),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [3118] = {
    [sym_block_comment] = STATE(3118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_GT_GT] = ACTIONS(5690),
    [anon_sym_u3009] = ACTIONS(5690),
    [anon_sym_u27e9] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3119] = {
    [sym_block_comment] = STATE(3119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_DASH_GT] = ACTIONS(5768),
    [anon_sym_u27f6] = ACTIONS(5768),
    [anon_sym_u2192] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EXCEPT] = ACTIONS(5768),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_RBRACK_] = ACTIONS(5768),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [3120] = {
    [sym_block_comment] = STATE(3120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_DASH_GT] = ACTIONS(5884),
    [anon_sym_u27f6] = ACTIONS(5884),
    [anon_sym_u2192] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EXCEPT] = ACTIONS(5884),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_RBRACK_] = ACTIONS(5884),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5884),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [3121] = {
    [sym_block_comment] = STATE(3121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5704),
    [anon_sym_u27fc] = ACTIONS(5704),
    [anon_sym_u21a6] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5706),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [3122] = {
    [sym_block_comment] = STATE(3122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5722),
    [anon_sym_u27fc] = ACTIONS(5722),
    [anon_sym_u21a6] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5720),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5722),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [3123] = {
    [sym_block_comment] = STATE(3123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_DASH_GT] = ACTIONS(5934),
    [anon_sym_u27f6] = ACTIONS(5934),
    [anon_sym_u2192] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EXCEPT] = ACTIONS(5934),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_RBRACK_] = ACTIONS(5934),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5934),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [3124] = {
    [sym_block_comment] = STATE(3124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5722),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [anon_sym_DEF] = ACTIONS(5720),
    [anon_sym_DEFS] = ACTIONS(5722),
    [sym__begin_proof_step] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [3125] = {
    [sym_block_comment] = STATE(3125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_DASH_GT] = ACTIONS(5663),
    [anon_sym_u27f6] = ACTIONS(5663),
    [anon_sym_u2192] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EXCEPT] = ACTIONS(5663),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_RBRACK_] = ACTIONS(5663),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [3126] = {
    [sym_block_comment] = STATE(3126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5716),
    [anon_sym_u27fc] = ACTIONS(5716),
    [anon_sym_u21a6] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_COMMA] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5718),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5716),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [3127] = {
    [sym_block_comment] = STATE(3127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_GT_GT] = ACTIONS(5712),
    [anon_sym_u3009] = ACTIONS(5712),
    [anon_sym_u27e9] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5712),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [3128] = {
    [sym_block_comment] = STATE(3128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_GT_GT] = ACTIONS(5704),
    [anon_sym_u3009] = ACTIONS(5704),
    [anon_sym_u27e9] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [3129] = {
    [sym_block_comment] = STATE(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_DASH_GT] = ACTIONS(5752),
    [anon_sym_u27f6] = ACTIONS(5752),
    [anon_sym_u2192] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EXCEPT] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_RBRACK_] = ACTIONS(5752),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5752),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [3130] = {
    [sym_block_comment] = STATE(3130),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_DASH_GT] = ACTIONS(5728),
    [anon_sym_u27f6] = ACTIONS(5728),
    [anon_sym_u2192] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EXCEPT] = ACTIONS(5728),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_RBRACK_] = ACTIONS(5728),
    [anon_sym_DASH] = ACTIONS(5730),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5728),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [3131] = {
    [sym_block_comment] = STATE(3131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_GT_GT] = ACTIONS(5700),
    [anon_sym_u3009] = ACTIONS(5700),
    [anon_sym_u27e9] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_COMMA] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(6072),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5700),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [3132] = {
    [sym_block_comment] = STATE(3132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_DASH_GT] = ACTIONS(5690),
    [anon_sym_u27f6] = ACTIONS(5690),
    [anon_sym_u2192] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EXCEPT] = ACTIONS(5690),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_RBRACK_] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3133] = {
    [sym_block_comment] = STATE(3133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_GT_GT] = ACTIONS(5722),
    [anon_sym_u3009] = ACTIONS(5722),
    [anon_sym_u27e9] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5722),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [3134] = {
    [sym_block_comment] = STATE(3134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_DASH_GT] = ACTIONS(5892),
    [anon_sym_u27f6] = ACTIONS(5892),
    [anon_sym_u2192] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EXCEPT] = ACTIONS(5892),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_RBRACK_] = ACTIONS(5892),
    [anon_sym_DASH] = ACTIONS(5894),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [3135] = {
    [sym_block_comment] = STATE(3135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_DASH_GT] = ACTIONS(5896),
    [anon_sym_u27f6] = ACTIONS(5896),
    [anon_sym_u2192] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EXCEPT] = ACTIONS(5896),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_RBRACK_] = ACTIONS(5896),
    [anon_sym_DASH] = ACTIONS(5898),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [3136] = {
    [sym_block_comment] = STATE(3136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_DASH_GT] = ACTIONS(5900),
    [anon_sym_u27f6] = ACTIONS(5900),
    [anon_sym_u2192] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EXCEPT] = ACTIONS(5900),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_RBRACK_] = ACTIONS(5900),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [3137] = {
    [sym_block_comment] = STATE(3137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_DASH_GT] = ACTIONS(5704),
    [anon_sym_u27f6] = ACTIONS(5704),
    [anon_sym_u2192] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EXCEPT] = ACTIONS(5704),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_RBRACK_] = ACTIONS(5704),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [3138] = {
    [sym_block_comment] = STATE(3138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5712),
    [anon_sym_u27fc] = ACTIONS(5712),
    [anon_sym_u21a6] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5714),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5712),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [3139] = {
    [sym_block_comment] = STATE(3139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_DASH_GT] = ACTIONS(5732),
    [anon_sym_u27f6] = ACTIONS(5732),
    [anon_sym_u2192] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EXCEPT] = ACTIONS(5732),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_RBRACK_] = ACTIONS(5732),
    [anon_sym_DASH] = ACTIONS(5734),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5732),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [3140] = {
    [sym_block_comment] = STATE(3140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_COMMA] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5708),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [anon_sym_DEF] = ACTIONS(5710),
    [anon_sym_DEFS] = ACTIONS(5708),
    [sym__begin_proof_step] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [3141] = {
    [sym_block_comment] = STATE(3141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_DASH_GT] = ACTIONS(5790),
    [anon_sym_u27f6] = ACTIONS(5790),
    [anon_sym_u2192] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EXCEPT] = ACTIONS(5790),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_RBRACK_] = ACTIONS(5790),
    [anon_sym_DASH] = ACTIONS(5792),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5790),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [3142] = {
    [sym_block_comment] = STATE(3142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_DASH_GT] = ACTIONS(5756),
    [anon_sym_u27f6] = ACTIONS(5756),
    [anon_sym_u2192] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EXCEPT] = ACTIONS(5756),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_RBRACK_] = ACTIONS(5756),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5756),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [3143] = {
    [sym_block_comment] = STATE(3143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_DASH_GT] = ACTIONS(5760),
    [anon_sym_u27f6] = ACTIONS(5760),
    [anon_sym_u2192] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EXCEPT] = ACTIONS(5760),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_RBRACK_] = ACTIONS(5760),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5760),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [3144] = {
    [sym_block_comment] = STATE(3144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_DASH_GT] = ACTIONS(5764),
    [anon_sym_u27f6] = ACTIONS(5764),
    [anon_sym_u2192] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EXCEPT] = ACTIONS(5764),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_RBRACK_] = ACTIONS(5764),
    [anon_sym_DASH] = ACTIONS(5766),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5764),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [3145] = {
    [sym_block_comment] = STATE(3145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_DASH_GT] = ACTIONS(5724),
    [anon_sym_u27f6] = ACTIONS(5724),
    [anon_sym_u2192] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EXCEPT] = ACTIONS(5724),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_RBRACK_] = ACTIONS(5724),
    [anon_sym_DASH] = ACTIONS(5726),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5724),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [3146] = {
    [sym_block_comment] = STATE(3146),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_DASH_GT] = ACTIONS(5772),
    [anon_sym_u27f6] = ACTIONS(5772),
    [anon_sym_u2192] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EXCEPT] = ACTIONS(5772),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_RBRACK_] = ACTIONS(5772),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5772),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [3147] = {
    [sym_block_comment] = STATE(3147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_DASH_GT] = ACTIONS(5736),
    [anon_sym_u27f6] = ACTIONS(5736),
    [anon_sym_u2192] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EXCEPT] = ACTIONS(5736),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_RBRACK_] = ACTIONS(5736),
    [anon_sym_DASH] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5736),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [3148] = {
    [sym_block_comment] = STATE(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_DASH_GT] = ACTIONS(5810),
    [anon_sym_u27f6] = ACTIONS(5810),
    [anon_sym_u2192] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EXCEPT] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_RBRACK_] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5812),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5810),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [3149] = {
    [sym_block_comment] = STATE(3149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_DASH_GT] = ACTIONS(5904),
    [anon_sym_u27f6] = ACTIONS(5904),
    [anon_sym_u2192] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EXCEPT] = ACTIONS(5904),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_RBRACK_] = ACTIONS(5904),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [3150] = {
    [sym_block_comment] = STATE(3150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_DASH_GT] = ACTIONS(5942),
    [anon_sym_u27f6] = ACTIONS(5942),
    [anon_sym_u2192] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EXCEPT] = ACTIONS(5942),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_RBRACK_] = ACTIONS(5942),
    [anon_sym_DASH] = ACTIONS(5940),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5942),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [3151] = {
    [sym_block_comment] = STATE(3151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5690),
    [anon_sym_u27fc] = ACTIONS(5690),
    [anon_sym_u21a6] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5688),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3152] = {
    [sym_block_comment] = STATE(3152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5690),
    [anon_sym_u27fc] = ACTIONS(5690),
    [anon_sym_u21a6] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5688),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3153] = {
    [sym_block_comment] = STATE(3153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_DASH_GT] = ACTIONS(5740),
    [anon_sym_u27f6] = ACTIONS(5740),
    [anon_sym_u2192] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EXCEPT] = ACTIONS(5740),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_RBRACK_] = ACTIONS(5740),
    [anon_sym_DASH] = ACTIONS(5742),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5740),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [3154] = {
    [sym_block_comment] = STATE(3154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_DASH_GT] = ACTIONS(5908),
    [anon_sym_u27f6] = ACTIONS(5908),
    [anon_sym_u2192] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EXCEPT] = ACTIONS(5908),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_RBRACK_] = ACTIONS(5908),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5908),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [3155] = {
    [sym_block_comment] = STATE(3155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_DASH_GT] = ACTIONS(5814),
    [anon_sym_u27f6] = ACTIONS(5814),
    [anon_sym_u2192] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EXCEPT] = ACTIONS(5814),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_RBRACK_] = ACTIONS(5814),
    [anon_sym_DASH] = ACTIONS(5816),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5814),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [3156] = {
    [sym_block_comment] = STATE(3156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_DASH_GT] = ACTIONS(5930),
    [anon_sym_u27f6] = ACTIONS(5930),
    [anon_sym_u2192] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EXCEPT] = ACTIONS(5930),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_RBRACK_] = ACTIONS(5930),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5930),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [3157] = {
    [sym_block_comment] = STATE(3157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_DASH_GT] = ACTIONS(5920),
    [anon_sym_u27f6] = ACTIONS(5920),
    [anon_sym_u2192] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EXCEPT] = ACTIONS(5920),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_RBRACK_] = ACTIONS(5920),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5920),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [3158] = {
    [sym_block_comment] = STATE(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_GT_GT] = ACTIONS(5716),
    [anon_sym_u3009] = ACTIONS(5716),
    [anon_sym_u27e9] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_COMMA] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5716),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [3159] = {
    [sym_block_comment] = STATE(3159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_DASH_GT] = ACTIONS(5912),
    [anon_sym_u27f6] = ACTIONS(5912),
    [anon_sym_u2192] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EXCEPT] = ACTIONS(5912),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_RBRACK_] = ACTIONS(5912),
    [anon_sym_DASH] = ACTIONS(5914),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5912),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [3160] = {
    [sym_block_comment] = STATE(3160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_DASH_GT] = ACTIONS(5916),
    [anon_sym_u27f6] = ACTIONS(5916),
    [anon_sym_u2192] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EXCEPT] = ACTIONS(5916),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_RBRACK_] = ACTIONS(5916),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5916),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [3161] = {
    [sym_block_comment] = STATE(3161),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_DASH_GT] = ACTIONS(5818),
    [anon_sym_u27f6] = ACTIONS(5818),
    [anon_sym_u2192] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EXCEPT] = ACTIONS(5818),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_RBRACK_] = ACTIONS(5818),
    [anon_sym_DASH] = ACTIONS(5820),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5818),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [3162] = {
    [sym_block_comment] = STATE(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_COMMA] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5700),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [anon_sym_DEF] = ACTIONS(5702),
    [anon_sym_DEFS] = ACTIONS(5700),
    [sym__begin_proof_step] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [3163] = {
    [sym_block_comment] = STATE(3163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_DASH_GT] = ACTIONS(5822),
    [anon_sym_u27f6] = ACTIONS(5822),
    [anon_sym_u2192] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EXCEPT] = ACTIONS(5822),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_RBRACK_] = ACTIONS(5822),
    [anon_sym_DASH] = ACTIONS(5824),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5822),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [3164] = {
    [sym_block_comment] = STATE(3164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_DASH_GT] = ACTIONS(5826),
    [anon_sym_u27f6] = ACTIONS(5826),
    [anon_sym_u2192] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EXCEPT] = ACTIONS(5826),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_RBRACK_] = ACTIONS(5826),
    [anon_sym_DASH] = ACTIONS(5828),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5826),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [3165] = {
    [sym_block_comment] = STATE(3165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_DASH_GT] = ACTIONS(5870),
    [anon_sym_u27f6] = ACTIONS(5870),
    [anon_sym_u2192] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EXCEPT] = ACTIONS(5870),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_RBRACK_] = ACTIONS(5870),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5870),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [3166] = {
    [sym_block_comment] = STATE(3166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_u27f6] = ACTIONS(5351),
    [anon_sym_u2192] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EXCEPT] = ACTIONS(5351),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_RBRACK_] = ACTIONS(5351),
    [anon_sym_DASH] = ACTIONS(5349),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [3167] = {
    [sym_block_comment] = STATE(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_COMMA] = ACTIONS(5890),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5890),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [anon_sym_DEF] = ACTIONS(5888),
    [anon_sym_DEFS] = ACTIONS(5890),
    [sym__begin_proof_step] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [3168] = {
    [sym_block_comment] = STATE(3168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5786),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [anon_sym_DEF] = ACTIONS(5788),
    [anon_sym_DEFS] = ACTIONS(5786),
    [sym__begin_proof_step] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [3169] = {
    [sym_block_comment] = STATE(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_GT_GT] = ACTIONS(5806),
    [anon_sym_u3009] = ACTIONS(5806),
    [anon_sym_u27e9] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5806),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [3170] = {
    [sym_block_comment] = STATE(3170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5732),
    [anon_sym_u27fc] = ACTIONS(5732),
    [anon_sym_u21a6] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_COMMA] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5734),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5732),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [3171] = {
    [sym_block_comment] = STATE(3171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_GT_GT] = ACTIONS(5926),
    [anon_sym_u3009] = ACTIONS(5926),
    [anon_sym_u27e9] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5926),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [3172] = {
    [sym_block_comment] = STATE(3172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_u3009] = ACTIONS(5856),
    [anon_sym_u27e9] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5856),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [3173] = {
    [sym_block_comment] = STATE(3173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_GT_GT] = ACTIONS(5892),
    [anon_sym_u3009] = ACTIONS(5892),
    [anon_sym_u27e9] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [3174] = {
    [sym_block_comment] = STATE(3174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_GT_GT] = ACTIONS(5930),
    [anon_sym_u3009] = ACTIONS(5930),
    [anon_sym_u27e9] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5930),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [3175] = {
    [sym_block_comment] = STATE(3175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_GT_GT] = ACTIONS(5934),
    [anon_sym_u3009] = ACTIONS(5934),
    [anon_sym_u27e9] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5934),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [3176] = {
    [sym_block_comment] = STATE(3176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5778),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [anon_sym_DEF] = ACTIONS(5780),
    [anon_sym_DEFS] = ACTIONS(5778),
    [sym__begin_proof_step] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [3177] = {
    [sym_block_comment] = STATE(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5852),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [anon_sym_DEF] = ACTIONS(5850),
    [anon_sym_DEFS] = ACTIONS(5852),
    [sym__begin_proof_step] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [3178] = {
    [sym_block_comment] = STATE(3178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_u3009] = ACTIONS(5862),
    [anon_sym_u27e9] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5862),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [3179] = {
    [sym_block_comment] = STATE(3179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5772),
    [anon_sym_u27fc] = ACTIONS(5772),
    [anon_sym_u21a6] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5774),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5772),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [3180] = {
    [sym_block_comment] = STATE(3180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_GT_GT] = ACTIONS(5790),
    [anon_sym_u3009] = ACTIONS(5790),
    [anon_sym_u27e9] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_COMMA] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5790),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [3181] = {
    [sym_block_comment] = STATE(3181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_GT_GT] = ACTIONS(5794),
    [anon_sym_u3009] = ACTIONS(5794),
    [anon_sym_u27e9] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5794),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [3182] = {
    [sym_block_comment] = STATE(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5798),
    [anon_sym_u3009] = ACTIONS(5798),
    [anon_sym_u27e9] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5798),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [3183] = {
    [sym_block_comment] = STATE(3183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5842),
    [anon_sym_u27fc] = ACTIONS(5842),
    [anon_sym_u21a6] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_COMMA] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5844),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5842),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [3184] = {
    [sym_block_comment] = STATE(3184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_u3009] = ACTIONS(5860),
    [anon_sym_u27e9] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5860),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [3185] = {
    [sym_block_comment] = STATE(3185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_GT_GT] = ACTIONS(5768),
    [anon_sym_u3009] = ACTIONS(5768),
    [anon_sym_u27e9] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [3186] = {
    [sym_block_comment] = STATE(3186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5772),
    [anon_sym_u3009] = ACTIONS(5772),
    [anon_sym_u27e9] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5772),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [3187] = {
    [sym_block_comment] = STATE(3187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5810),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [anon_sym_DEF] = ACTIONS(5812),
    [anon_sym_DEFS] = ACTIONS(5810),
    [sym__begin_proof_step] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [3188] = {
    [sym_block_comment] = STATE(3188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_COMMA] = ACTIONS(5814),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5814),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [anon_sym_DEF] = ACTIONS(5816),
    [anon_sym_DEFS] = ACTIONS(5814),
    [sym__begin_proof_step] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [3189] = {
    [sym_block_comment] = STATE(3189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_COMMA] = ACTIONS(5782),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5782),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [anon_sym_DEF] = ACTIONS(5784),
    [anon_sym_DEFS] = ACTIONS(5782),
    [sym__begin_proof_step] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [3190] = {
    [sym_block_comment] = STATE(3190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_COMMA] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5802),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [anon_sym_DEF] = ACTIONS(5804),
    [anon_sym_DEFS] = ACTIONS(5802),
    [sym__begin_proof_step] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [3191] = {
    [sym_block_comment] = STATE(3191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5790),
    [anon_sym_u27fc] = ACTIONS(5790),
    [anon_sym_u21a6] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_COMMA] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5792),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5790),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [3192] = {
    [sym_block_comment] = STATE(3192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5794),
    [anon_sym_u27fc] = ACTIONS(5794),
    [anon_sym_u21a6] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5796),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5794),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [3193] = {
    [sym_block_comment] = STATE(3193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5798),
    [anon_sym_u27fc] = ACTIONS(5798),
    [anon_sym_u21a6] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5800),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5798),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [3194] = {
    [sym_block_comment] = STATE(3194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [anon_sym_DEF] = ACTIONS(5688),
    [anon_sym_DEFS] = ACTIONS(5690),
    [sym__begin_proof_step] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3195] = {
    [sym_block_comment] = STATE(3195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_GT_GT] = ACTIONS(5810),
    [anon_sym_u3009] = ACTIONS(5810),
    [anon_sym_u27e9] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5810),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [3196] = {
    [sym_block_comment] = STATE(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_GT_GT] = ACTIONS(5690),
    [anon_sym_u3009] = ACTIONS(5690),
    [anon_sym_u27e9] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3197] = {
    [sym_block_comment] = STATE(3197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_GT_GT] = ACTIONS(5814),
    [anon_sym_u3009] = ACTIONS(5814),
    [anon_sym_u27e9] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_COMMA] = ACTIONS(5814),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5814),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [3198] = {
    [sym_block_comment] = STATE(3198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5806),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [anon_sym_DEF] = ACTIONS(5808),
    [anon_sym_DEFS] = ACTIONS(5806),
    [sym__begin_proof_step] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [3199] = {
    [sym_block_comment] = STATE(3199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_GT_GT] = ACTIONS(5756),
    [anon_sym_u3009] = ACTIONS(5756),
    [anon_sym_u27e9] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5756),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [3200] = {
    [sym_block_comment] = STATE(3200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_GT_GT] = ACTIONS(5760),
    [anon_sym_u3009] = ACTIONS(5760),
    [anon_sym_u27e9] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5760),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [3201] = {
    [sym_block_comment] = STATE(3201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5818),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5818),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [anon_sym_DEF] = ACTIONS(5820),
    [anon_sym_DEFS] = ACTIONS(5818),
    [sym__begin_proof_step] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [3202] = {
    [sym_block_comment] = STATE(3202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_GT_GT] = ACTIONS(5764),
    [anon_sym_u3009] = ACTIONS(5764),
    [anon_sym_u27e9] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5764),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [3203] = {
    [sym_block_comment] = STATE(3203),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_GT_GT] = ACTIONS(5818),
    [anon_sym_u3009] = ACTIONS(5818),
    [anon_sym_u27e9] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5818),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5818),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [3204] = {
    [sym_block_comment] = STATE(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_GT_GT] = ACTIONS(5724),
    [anon_sym_u3009] = ACTIONS(5724),
    [anon_sym_u27e9] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_COMMA] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5724),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [3205] = {
    [sym_block_comment] = STATE(3205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5772),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [anon_sym_DEF] = ACTIONS(5774),
    [anon_sym_DEFS] = ACTIONS(5772),
    [sym__begin_proof_step] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [3206] = {
    [sym_block_comment] = STATE(3206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5822),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [anon_sym_DEF] = ACTIONS(5824),
    [anon_sym_DEFS] = ACTIONS(5822),
    [sym__begin_proof_step] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [3207] = {
    [sym_block_comment] = STATE(3207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_COMMA] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5826),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [anon_sym_DEF] = ACTIONS(5828),
    [anon_sym_DEFS] = ACTIONS(5826),
    [sym__begin_proof_step] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [3208] = {
    [sym_block_comment] = STATE(3208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5916),
    [anon_sym_u27fc] = ACTIONS(5916),
    [anon_sym_u21a6] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5918),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5916),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [3209] = {
    [sym_block_comment] = STATE(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_COMMA] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5830),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [anon_sym_DEF] = ACTIONS(5832),
    [anon_sym_DEFS] = ACTIONS(5830),
    [sym__begin_proof_step] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [3210] = {
    [sym_block_comment] = STATE(3210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5802),
    [anon_sym_u27fc] = ACTIONS(5802),
    [anon_sym_u21a6] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_COMMA] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5804),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5802),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [3211] = {
    [sym_block_comment] = STATE(3211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_GT_GT] = ACTIONS(5822),
    [anon_sym_u3009] = ACTIONS(5822),
    [anon_sym_u27e9] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5822),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [3212] = {
    [sym_block_comment] = STATE(3212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [anon_sym_DEF] = ACTIONS(5706),
    [anon_sym_DEFS] = ACTIONS(5704),
    [sym__begin_proof_step] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [3213] = {
    [sym_block_comment] = STATE(3213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5834),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [anon_sym_DEF] = ACTIONS(5836),
    [anon_sym_DEFS] = ACTIONS(5834),
    [sym__begin_proof_step] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [3214] = {
    [sym_block_comment] = STATE(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_GT_GT] = ACTIONS(5826),
    [anon_sym_u3009] = ACTIONS(5826),
    [anon_sym_u27e9] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_COMMA] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5826),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [3215] = {
    [sym_block_comment] = STATE(3215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_GT_GT] = ACTIONS(5896),
    [anon_sym_u3009] = ACTIONS(5896),
    [anon_sym_u27e9] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_COMMA] = ACTIONS(5896),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [3216] = {
    [sym_block_comment] = STATE(3216),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5838),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [anon_sym_DEF] = ACTIONS(5840),
    [anon_sym_DEFS] = ACTIONS(5838),
    [sym__begin_proof_step] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [3217] = {
    [sym_block_comment] = STATE(3217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5810),
    [anon_sym_u27fc] = ACTIONS(5810),
    [anon_sym_u21a6] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5812),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5810),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [3218] = {
    [sym_block_comment] = STATE(3218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_GT_GT] = ACTIONS(5830),
    [anon_sym_u3009] = ACTIONS(5830),
    [anon_sym_u27e9] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_COMMA] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5830),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [3219] = {
    [sym_block_comment] = STATE(3219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5752),
    [anon_sym_u27fc] = ACTIONS(5752),
    [anon_sym_u21a6] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5754),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5752),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [3220] = {
    [sym_block_comment] = STATE(3220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_GT_GT] = ACTIONS(5834),
    [anon_sym_u3009] = ACTIONS(5834),
    [anon_sym_u27e9] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5834),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [3221] = {
    [sym_block_comment] = STATE(3221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5814),
    [anon_sym_u27fc] = ACTIONS(5814),
    [anon_sym_u21a6] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_COMMA] = ACTIONS(5814),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5816),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5814),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [3222] = {
    [sym_block_comment] = STATE(3222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5818),
    [anon_sym_u27fc] = ACTIONS(5818),
    [anon_sym_u21a6] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5818),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5820),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5818),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [3223] = {
    [sym_block_comment] = STATE(3223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5822),
    [anon_sym_u27fc] = ACTIONS(5822),
    [anon_sym_u21a6] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5824),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5822),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [3224] = {
    [sym_block_comment] = STATE(3224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5826),
    [anon_sym_u27fc] = ACTIONS(5826),
    [anon_sym_u21a6] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_COMMA] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5828),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5826),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [3225] = {
    [sym_block_comment] = STATE(3225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_GT_GT] = ACTIONS(5846),
    [anon_sym_u3009] = ACTIONS(5846),
    [anon_sym_u27e9] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5846),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [3226] = {
    [sym_block_comment] = STATE(3226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5830),
    [anon_sym_u27fc] = ACTIONS(5830),
    [anon_sym_u21a6] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_COMMA] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5832),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5830),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [3227] = {
    [sym_block_comment] = STATE(3227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5834),
    [anon_sym_u27fc] = ACTIONS(5834),
    [anon_sym_u21a6] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5836),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5834),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [3228] = {
    [sym_block_comment] = STATE(3228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5736),
    [anon_sym_u27fc] = ACTIONS(5736),
    [anon_sym_u21a6] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5738),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5736),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [3229] = {
    [sym_block_comment] = STATE(3229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5908),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [anon_sym_DEF] = ACTIONS(5910),
    [anon_sym_DEFS] = ACTIONS(5908),
    [sym__begin_proof_step] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [3230] = {
    [sym_block_comment] = STATE(3230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_COMMA] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5912),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [anon_sym_DEF] = ACTIONS(5914),
    [anon_sym_DEFS] = ACTIONS(5912),
    [sym__begin_proof_step] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [3231] = {
    [sym_block_comment] = STATE(3231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_COMMA] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5842),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [anon_sym_DEF] = ACTIONS(5844),
    [anon_sym_DEFS] = ACTIONS(5842),
    [sym__begin_proof_step] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [3232] = {
    [sym_block_comment] = STATE(3232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5920),
    [anon_sym_u27fc] = ACTIONS(5920),
    [anon_sym_u21a6] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5922),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5920),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [3233] = {
    [sym_block_comment] = STATE(3233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_GT_GT] = ACTIONS(5870),
    [anon_sym_u3009] = ACTIONS(5870),
    [anon_sym_u27e9] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5870),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [3234] = {
    [sym_block_comment] = STATE(3234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_GT_GT] = ACTIONS(5663),
    [anon_sym_u3009] = ACTIONS(5663),
    [anon_sym_u27e9] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [3235] = {
    [sym_block_comment] = STATE(3235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5862),
    [anon_sym_u27fc] = ACTIONS(5862),
    [anon_sym_u21a6] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5864),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5862),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [3236] = {
    [sym_block_comment] = STATE(3236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_GT_GT] = ACTIONS(5872),
    [anon_sym_u3009] = ACTIONS(5872),
    [anon_sym_u27e9] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_COMMA] = ACTIONS(5872),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5872),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [3237] = {
    [sym_block_comment] = STATE(3237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5778),
    [anon_sym_u27fc] = ACTIONS(5778),
    [anon_sym_u21a6] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5780),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5778),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [3238] = {
    [sym_block_comment] = STATE(3238),
    [sym_case_box] = STATE(147),
    [aux_sym_case_repeat1] = STATE(3344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5686),
    [anon_sym_u2208] = ACTIONS(5684),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5684),
    [anon_sym_u2227] = ACTIONS(5684),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5684),
    [anon_sym_u2228] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_BSLASHo] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5686),
    [anon_sym_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27f9] = ACTIONS(5684),
    [anon_sym_u21d2] = ACTIONS(5684),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5684),
    [anon_sym_u21f8] = ACTIONS(5684),
    [anon_sym_u2945] = ACTIONS(5684),
    [anon_sym_BSLASHequiv] = ACTIONS(5684),
    [anon_sym_u2261] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5684),
    [anon_sym_u27fa] = ACTIONS(5684),
    [anon_sym_u21d4] = ACTIONS(5684),
    [anon_sym_TILDE_GT] = ACTIONS(5684),
    [anon_sym_u21dd] = ACTIONS(5684),
    [anon_sym_u219d] = ACTIONS(5684),
    [anon_sym_BSLASHland] = ACTIONS(5684),
    [anon_sym_BSLASHlor] = ACTIONS(5684),
    [anon_sym_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2254] = ACTIONS(5684),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5684),
    [anon_sym_u2a74] = ACTIONS(5684),
    [anon_sym_SLASH_EQ] = ACTIONS(5684),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_u2260] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5686),
    [sym_gt] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5686),
    [anon_sym_EQ_LT] = ACTIONS(5684),
    [anon_sym_BSLASHleq] = ACTIONS(5684),
    [anon_sym_u2264] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_BSLASHgeq] = ACTIONS(5684),
    [anon_sym_u2265] = ACTIONS(5684),
    [anon_sym_BSLASHapprox] = ACTIONS(5684),
    [anon_sym_u2248] = ACTIONS(5684),
    [anon_sym_PIPE_DASH] = ACTIONS(5684),
    [anon_sym_u22a2] = ACTIONS(5684),
    [anon_sym_PIPE_EQ] = ACTIONS(5684),
    [anon_sym_u22a8] = ACTIONS(5684),
    [anon_sym_DASH_PIPE] = ACTIONS(5684),
    [anon_sym_u22a3] = ACTIONS(5684),
    [anon_sym_EQ_PIPE] = ACTIONS(5684),
    [anon_sym_u2ae4] = ACTIONS(5684),
    [anon_sym_BSLASHasymp] = ACTIONS(5684),
    [anon_sym_u224d] = ACTIONS(5684),
    [anon_sym_BSLASHcong] = ACTIONS(5684),
    [anon_sym_u2245] = ACTIONS(5684),
    [anon_sym_BSLASHdoteq] = ACTIONS(5684),
    [anon_sym_u2250] = ACTIONS(5684),
    [anon_sym_BSLASHgg] = ACTIONS(5684),
    [anon_sym_u226b] = ACTIONS(5684),
    [anon_sym_BSLASHll] = ACTIONS(5684),
    [anon_sym_u226a] = ACTIONS(5684),
    [anon_sym_BSLASHnotin] = ACTIONS(5684),
    [anon_sym_u2209] = ACTIONS(5684),
    [anon_sym_BSLASHprec] = ACTIONS(5686),
    [anon_sym_u227a] = ACTIONS(5684),
    [anon_sym_BSLASHsucc] = ACTIONS(5686),
    [anon_sym_u227b] = ACTIONS(5684),
    [anon_sym_BSLASHpreceq] = ACTIONS(5684),
    [anon_sym_u2aaf] = ACTIONS(5684),
    [anon_sym_BSLASHsucceq] = ACTIONS(5684),
    [anon_sym_u2ab0] = ACTIONS(5684),
    [anon_sym_BSLASHpropto] = ACTIONS(5684),
    [anon_sym_u221d] = ACTIONS(5684),
    [anon_sym_BSLASHsim] = ACTIONS(5686),
    [anon_sym_u223c] = ACTIONS(5684),
    [anon_sym_BSLASHsimeq] = ACTIONS(5684),
    [anon_sym_u2243] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5686),
    [anon_sym_u228f] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5686),
    [anon_sym_u2290] = ACTIONS(5684),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5684),
    [anon_sym_u2291] = ACTIONS(5684),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5684),
    [anon_sym_u2292] = ACTIONS(5684),
    [anon_sym_BSLASHsubset] = ACTIONS(5686),
    [anon_sym_u2282] = ACTIONS(5684),
    [anon_sym_BSLASHsupset] = ACTIONS(5686),
    [anon_sym_u2283] = ACTIONS(5684),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5684),
    [anon_sym_u2286] = ACTIONS(5684),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5684),
    [anon_sym_u2287] = ACTIONS(5684),
    [sym_compose] = ACTIONS(5684),
    [sym_map_to] = ACTIONS(5684),
    [sym_map_from] = ACTIONS(5684),
    [sym_setminus] = ACTIONS(5686),
    [anon_sym_BSLASHcap] = ACTIONS(5684),
    [anon_sym_BSLASHintersect] = ACTIONS(5684),
    [anon_sym_u2229] = ACTIONS(5684),
    [anon_sym_BSLASHcup] = ACTIONS(5684),
    [anon_sym_BSLASHunion] = ACTIONS(5684),
    [anon_sym_u222a] = ACTIONS(5684),
    [anon_sym_DOT_DOT] = ACTIONS(5686),
    [anon_sym_u2025] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5684),
    [anon_sym_u2026] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5686),
    [sym_plusplus] = ACTIONS(5684),
    [anon_sym_BSLASHoplus] = ACTIONS(5684),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5684),
    [anon_sym_u2295] = ACTIONS(5684),
    [anon_sym_BSLASHominus] = ACTIONS(5684),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2296] = ACTIONS(5684),
    [sym_mod] = ACTIONS(5686),
    [sym_modmod] = ACTIONS(5684),
    [sym_vert] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5684),
    [anon_sym_u2016] = ACTIONS(5684),
    [sym_minusminus] = ACTIONS(5684),
    [sym_amp] = ACTIONS(5686),
    [sym_ampamp] = ACTIONS(5684),
    [anon_sym_BSLASHodot] = ACTIONS(5684),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5684),
    [anon_sym_u2299] = ACTIONS(5684),
    [anon_sym_BSLASHoslash] = ACTIONS(5684),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5684),
    [anon_sym_u2298] = ACTIONS(5684),
    [anon_sym_BSLASHotimes] = ACTIONS(5684),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5684),
    [anon_sym_u2297] = ACTIONS(5684),
    [sym_mul] = ACTIONS(5686),
    [sym_mulmul] = ACTIONS(5684),
    [sym_slash] = ACTIONS(5686),
    [sym_slashslash] = ACTIONS(5684),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5684),
    [anon_sym_u25ef] = ACTIONS(5684),
    [anon_sym_BSLASHbullet] = ACTIONS(5684),
    [anon_sym_u25cf] = ACTIONS(5684),
    [anon_sym_BSLASHdiv] = ACTIONS(5684),
    [anon_sym_u00f7] = ACTIONS(5684),
    [anon_sym_BSLASHcirc] = ACTIONS(5684),
    [anon_sym_u2218] = ACTIONS(5684),
    [anon_sym_BSLASHstar] = ACTIONS(5684),
    [anon_sym_u22c6] = ACTIONS(5684),
    [anon_sym_u203c] = ACTIONS(5684),
    [sym_hashhash] = ACTIONS(5684),
    [sym_dol] = ACTIONS(5686),
    [sym_doldol] = ACTIONS(5684),
    [anon_sym_QMARK_QMARK] = ACTIONS(5684),
    [anon_sym_u2047] = ACTIONS(5684),
    [anon_sym_BSLASHsqcap] = ACTIONS(5684),
    [anon_sym_u2293] = ACTIONS(5684),
    [anon_sym_BSLASHsqcup] = ACTIONS(5684),
    [anon_sym_u2294] = ACTIONS(5684),
    [anon_sym_BSLASHuplus] = ACTIONS(5684),
    [anon_sym_u228e] = ACTIONS(5684),
    [anon_sym_BSLASHX] = ACTIONS(5684),
    [anon_sym_BSLASHtimes] = ACTIONS(5684),
    [anon_sym_u00d7] = ACTIONS(5684),
    [anon_sym_BSLASHwr] = ACTIONS(5684),
    [anon_sym_u2240] = ACTIONS(5684),
    [anon_sym_BSLASHcdot] = ACTIONS(5684),
    [anon_sym_u22c5] = ACTIONS(5684),
    [sym_pow] = ACTIONS(5686),
    [sym_powpow] = ACTIONS(5684),
    [anon_sym_CARET_PLUS] = ACTIONS(5684),
    [anon_sym_u207a] = ACTIONS(5684),
    [sym_asterisk] = ACTIONS(5684),
    [sym_sup_hash] = ACTIONS(5684),
    [sym_prime] = ACTIONS(5684),
    [sym__bullet] = ACTIONS(5684),
    [sym__dedent] = ACTIONS(5684),
    [sym__double_excl] = ACTIONS(5684),
  },
  [3239] = {
    [sym_block_comment] = STATE(3239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5862),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [anon_sym_DEF] = ACTIONS(5864),
    [anon_sym_DEFS] = ACTIONS(5862),
    [sym__begin_proof_step] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [3240] = {
    [sym_block_comment] = STATE(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5846),
    [anon_sym_u27fc] = ACTIONS(5846),
    [anon_sym_u21a6] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5848),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5846),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [3241] = {
    [sym_block_comment] = STATE(3241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_GT_GT] = ACTIONS(5876),
    [anon_sym_u3009] = ACTIONS(5876),
    [anon_sym_u27e9] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_COMMA] = ACTIONS(5876),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5876),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [3242] = {
    [sym_block_comment] = STATE(3242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_GT_GT] = ACTIONS(5748),
    [anon_sym_u3009] = ACTIONS(5748),
    [anon_sym_u27e9] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_COMMA] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5748),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [3243] = {
    [sym_block_comment] = STATE(3243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_GT_GT] = ACTIONS(5880),
    [anon_sym_u3009] = ACTIONS(5880),
    [anon_sym_u27e9] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_COMMA] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5880),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [3244] = {
    [sym_block_comment] = STATE(3244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_GT_GT] = ACTIONS(5890),
    [anon_sym_u3009] = ACTIONS(5890),
    [anon_sym_u27e9] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_COMMA] = ACTIONS(5890),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5890),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [3245] = {
    [sym_block_comment] = STATE(3245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_GT_GT] = ACTIONS(5938),
    [anon_sym_u3009] = ACTIONS(5938),
    [anon_sym_u27e9] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5938),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [3246] = {
    [sym_block_comment] = STATE(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5916),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [anon_sym_DEF] = ACTIONS(5918),
    [anon_sym_DEFS] = ACTIONS(5916),
    [sym__begin_proof_step] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [3247] = {
    [sym_block_comment] = STATE(3247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_GT_GT] = ACTIONS(5884),
    [anon_sym_u3009] = ACTIONS(5884),
    [anon_sym_u27e9] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_COMMA] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5884),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [3248] = {
    [sym_block_comment] = STATE(3248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5920),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [anon_sym_DEF] = ACTIONS(5922),
    [anon_sym_DEFS] = ACTIONS(5920),
    [sym__begin_proof_step] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [3249] = {
    [sym_block_comment] = STATE(3249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5744),
    [anon_sym_u27fc] = ACTIONS(5744),
    [anon_sym_u21a6] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5746),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5744),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [3250] = {
    [sym_block_comment] = STATE(3250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_GT_GT] = ACTIONS(5900),
    [anon_sym_u3009] = ACTIONS(5900),
    [anon_sym_u27e9] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_COMMA] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [3251] = {
    [sym_block_comment] = STATE(3251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5934),
    [anon_sym_u27fc] = ACTIONS(5934),
    [anon_sym_u21a6] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5932),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5934),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [3252] = {
    [sym_block_comment] = STATE(3252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5756),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [anon_sym_DEF] = ACTIONS(5758),
    [anon_sym_DEFS] = ACTIONS(5756),
    [sym__begin_proof_step] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [3253] = {
    [sym_block_comment] = STATE(3253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_u3009] = ACTIONS(5920),
    [anon_sym_u27e9] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5920),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [3254] = {
    [sym_block_comment] = STATE(3254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5926),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [anon_sym_DEF] = ACTIONS(5924),
    [anon_sym_DEFS] = ACTIONS(5926),
    [sym__begin_proof_step] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [3255] = {
    [sym_block_comment] = STATE(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5872),
    [anon_sym_u27fc] = ACTIONS(5872),
    [anon_sym_u21a6] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_COMMA] = ACTIONS(5872),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5874),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5872),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [3256] = {
    [sym_block_comment] = STATE(3256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5876),
    [anon_sym_u27fc] = ACTIONS(5876),
    [anon_sym_u21a6] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_COMMA] = ACTIONS(5876),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5878),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5876),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [3257] = {
    [sym_block_comment] = STATE(3257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5930),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [anon_sym_DEF] = ACTIONS(5928),
    [anon_sym_DEFS] = ACTIONS(5930),
    [sym__begin_proof_step] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [3258] = {
    [sym_block_comment] = STATE(3258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_GT_GT] = ACTIONS(5728),
    [anon_sym_u3009] = ACTIONS(5728),
    [anon_sym_u27e9] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5728),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [3259] = {
    [sym_block_comment] = STATE(3259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_GT_GT] = ACTIONS(5732),
    [anon_sym_u3009] = ACTIONS(5732),
    [anon_sym_u27e9] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_COMMA] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5732),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [3260] = {
    [sym_block_comment] = STATE(3260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5846),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [anon_sym_DEF] = ACTIONS(5848),
    [anon_sym_DEFS] = ACTIONS(5846),
    [sym__begin_proof_step] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [3261] = {
    [sym_block_comment] = STATE(3261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5934),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [anon_sym_DEF] = ACTIONS(5932),
    [anon_sym_DEFS] = ACTIONS(5934),
    [sym__begin_proof_step] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [3262] = {
    [sym_block_comment] = STATE(3262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_GT_GT] = ACTIONS(5904),
    [anon_sym_u3009] = ACTIONS(5904),
    [anon_sym_u27e9] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [3263] = {
    [sym_block_comment] = STATE(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_GT_GT] = ACTIONS(5351),
    [anon_sym_u3009] = ACTIONS(5351),
    [anon_sym_u27e9] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [3264] = {
    [sym_block_comment] = STATE(3264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_GT_GT] = ACTIONS(5704),
    [anon_sym_u3009] = ACTIONS(5704),
    [anon_sym_u27e9] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [3265] = {
    [sym_block_comment] = STATE(3265),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5880),
    [anon_sym_u27fc] = ACTIONS(5880),
    [anon_sym_u21a6] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_COMMA] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5882),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5880),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [3266] = {
    [sym_block_comment] = STATE(3266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_COMMA] = ACTIONS(5872),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5872),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [anon_sym_DEF] = ACTIONS(5874),
    [anon_sym_DEFS] = ACTIONS(5872),
    [sym__begin_proof_step] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [3267] = {
    [sym_block_comment] = STATE(3267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_COMMA] = ACTIONS(5876),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5876),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [anon_sym_DEF] = ACTIONS(5878),
    [anon_sym_DEFS] = ACTIONS(5876),
    [sym__begin_proof_step] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [3268] = {
    [sym_block_comment] = STATE(3268),
    [sym_case_box] = STATE(288),
    [aux_sym_case_repeat1] = STATE(3268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5667),
    [anon_sym_u25a1] = ACTIONS(5667),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__bullet] = ACTIONS(5663),
    [sym__dedent] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [3269] = {
    [sym_block_comment] = STATE(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_GT_GT] = ACTIONS(5740),
    [anon_sym_u3009] = ACTIONS(5740),
    [anon_sym_u27e9] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5740),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [3270] = {
    [sym_block_comment] = STATE(3270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5938),
    [anon_sym_u27fc] = ACTIONS(5938),
    [anon_sym_u21a6] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5936),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5938),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [3271] = {
    [sym_block_comment] = STATE(3271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5870),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [anon_sym_DEF] = ACTIONS(5868),
    [anon_sym_DEFS] = ACTIONS(5870),
    [sym__begin_proof_step] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [3272] = {
    [sym_block_comment] = STATE(3272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5740),
    [anon_sym_u27fc] = ACTIONS(5740),
    [anon_sym_u21a6] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5742),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5740),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [3273] = {
    [sym_block_comment] = STATE(3273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_COMMA] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5880),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [anon_sym_DEF] = ACTIONS(5882),
    [anon_sym_DEFS] = ACTIONS(5880),
    [sym__begin_proof_step] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [3274] = {
    [sym_block_comment] = STATE(3274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5938),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [anon_sym_DEF] = ACTIONS(5936),
    [anon_sym_DEFS] = ACTIONS(5938),
    [sym__begin_proof_step] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [3275] = {
    [sym_block_comment] = STATE(3275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5663),
    [anon_sym_u27fc] = ACTIONS(5663),
    [anon_sym_u21a6] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5665),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [3276] = {
    [sym_block_comment] = STATE(3276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5926),
    [anon_sym_u27fc] = ACTIONS(5926),
    [anon_sym_u21a6] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5924),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5926),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [3277] = {
    [sym_block_comment] = STATE(3277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_COMMA] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5884),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [anon_sym_DEF] = ACTIONS(5886),
    [anon_sym_DEFS] = ACTIONS(5884),
    [sym__begin_proof_step] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [3278] = {
    [sym_block_comment] = STATE(3278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_GT_GT] = ACTIONS(5736),
    [anon_sym_u3009] = ACTIONS(5736),
    [anon_sym_u27e9] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5736),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [3279] = {
    [sym_block_comment] = STATE(3279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5760),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [anon_sym_DEF] = ACTIONS(5762),
    [anon_sym_DEFS] = ACTIONS(5760),
    [sym__begin_proof_step] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [3280] = {
    [sym_block_comment] = STATE(3280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5892),
    [anon_sym_u27fc] = ACTIONS(5892),
    [anon_sym_u21a6] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5894),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [3281] = {
    [sym_block_comment] = STATE(3281),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5884),
    [anon_sym_u27fc] = ACTIONS(5884),
    [anon_sym_u21a6] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_COMMA] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5886),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5884),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [3282] = {
    [sym_block_comment] = STATE(3282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5838),
    [anon_sym_u27fc] = ACTIONS(5838),
    [anon_sym_u21a6] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5840),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5838),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [3283] = {
    [sym_block_comment] = STATE(3283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_GT_GT] = ACTIONS(5838),
    [anon_sym_u3009] = ACTIONS(5838),
    [anon_sym_u27e9] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5838),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [3284] = {
    [sym_block_comment] = STATE(3284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5782),
    [anon_sym_u27fc] = ACTIONS(5782),
    [anon_sym_u21a6] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_COMMA] = ACTIONS(5782),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5784),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5782),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [3285] = {
    [sym_block_comment] = STATE(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [anon_sym_DEF] = ACTIONS(5894),
    [anon_sym_DEFS] = ACTIONS(5892),
    [sym__begin_proof_step] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [3286] = {
    [sym_block_comment] = STATE(3286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5748),
    [anon_sym_u27fc] = ACTIONS(5748),
    [anon_sym_u21a6] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_COMMA] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5750),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5748),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [3287] = {
    [sym_block_comment] = STATE(3287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5896),
    [anon_sym_u27fc] = ACTIONS(5896),
    [anon_sym_u21a6] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_COMMA] = ACTIONS(5896),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5898),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [3288] = {
    [sym_block_comment] = STATE(3288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5908),
    [anon_sym_u27fc] = ACTIONS(5908),
    [anon_sym_u21a6] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5910),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5908),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [3289] = {
    [sym_block_comment] = STATE(3289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5764),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [anon_sym_DEF] = ACTIONS(5766),
    [anon_sym_DEFS] = ACTIONS(5764),
    [sym__begin_proof_step] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [3290] = {
    [sym_block_comment] = STATE(3290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_u3009] = ACTIONS(5752),
    [anon_sym_u27e9] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5752),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [3291] = {
    [sym_block_comment] = STATE(3291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5728),
    [anon_sym_u27fc] = ACTIONS(5728),
    [anon_sym_u21a6] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5730),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5728),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [3292] = {
    [sym_block_comment] = STATE(3292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_GT_GT] = ACTIONS(5908),
    [anon_sym_u3009] = ACTIONS(5908),
    [anon_sym_u27e9] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5908),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [3293] = {
    [sym_block_comment] = STATE(3293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_GT_GT] = ACTIONS(5912),
    [anon_sym_u3009] = ACTIONS(5912),
    [anon_sym_u27e9] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_COMMA] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5912),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [3294] = {
    [sym_block_comment] = STATE(3294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_COMMA] = ACTIONS(5896),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [anon_sym_DEF] = ACTIONS(5898),
    [anon_sym_DEFS] = ACTIONS(5896),
    [sym__begin_proof_step] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [3295] = {
    [sym_block_comment] = STATE(3295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_GT_GT] = ACTIONS(5778),
    [anon_sym_u3009] = ACTIONS(5778),
    [anon_sym_u27e9] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5778),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [3296] = {
    [sym_block_comment] = STATE(3296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_COMMA] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5724),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [anon_sym_DEF] = ACTIONS(5726),
    [anon_sym_DEFS] = ACTIONS(5724),
    [sym__begin_proof_step] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [3297] = {
    [sym_block_comment] = STATE(3297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_GT_GT] = ACTIONS(5782),
    [anon_sym_u3009] = ACTIONS(5782),
    [anon_sym_u27e9] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_COMMA] = ACTIONS(5782),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5782),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [3298] = {
    [sym_block_comment] = STATE(3298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_GT_GT] = ACTIONS(5842),
    [anon_sym_u3009] = ACTIONS(5842),
    [anon_sym_u27e9] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_COMMA] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5842),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [3299] = {
    [sym_block_comment] = STATE(3299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_COMMA] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [anon_sym_DEF] = ACTIONS(5902),
    [anon_sym_DEFS] = ACTIONS(5900),
    [sym__begin_proof_step] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [3300] = {
    [sym_block_comment] = STATE(3300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5900),
    [anon_sym_u27fc] = ACTIONS(5900),
    [anon_sym_u21a6] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_COMMA] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5902),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [3301] = {
    [sym_block_comment] = STATE(3301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5904),
    [anon_sym_u27fc] = ACTIONS(5904),
    [anon_sym_u21a6] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5906),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [3302] = {
    [sym_block_comment] = STATE(3302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5912),
    [anon_sym_u27fc] = ACTIONS(5912),
    [anon_sym_u21a6] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_COMMA] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5914),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5912),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [3303] = {
    [sym_block_comment] = STATE(3303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [anon_sym_DEF] = ACTIONS(5906),
    [anon_sym_DEFS] = ACTIONS(5904),
    [sym__begin_proof_step] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [3304] = {
    [sym_block_comment] = STATE(3304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5942),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [anon_sym_DEF] = ACTIONS(5940),
    [anon_sym_DEFS] = ACTIONS(5942),
    [sym__begin_proof_step] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [3305] = {
    [sym_block_comment] = STATE(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5942),
    [anon_sym_u27fc] = ACTIONS(5942),
    [anon_sym_u21a6] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5940),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5942),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [3306] = {
    [sym_block_comment] = STATE(3306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [anon_sym_DEF] = ACTIONS(5349),
    [anon_sym_DEFS] = ACTIONS(5351),
    [sym__begin_proof_step] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [3307] = {
    [sym_block_comment] = STATE(3307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_GT_GT] = ACTIONS(5744),
    [anon_sym_u3009] = ACTIONS(5744),
    [anon_sym_u27e9] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5744),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [3308] = {
    [sym_block_comment] = STATE(3308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5740),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [anon_sym_DEF] = ACTIONS(5742),
    [anon_sym_DEFS] = ACTIONS(5740),
    [sym__begin_proof_step] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [3309] = {
    [sym_block_comment] = STATE(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_GT_GT] = ACTIONS(5942),
    [anon_sym_u3009] = ACTIONS(5942),
    [anon_sym_u27e9] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5942),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [3310] = {
    [sym_block_comment] = STATE(3310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_GT_GT] = ACTIONS(5786),
    [anon_sym_u3009] = ACTIONS(5786),
    [anon_sym_u27e9] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5786),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [3311] = {
    [sym_block_comment] = STATE(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5860),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [anon_sym_DEF] = ACTIONS(5858),
    [anon_sym_DEFS] = ACTIONS(5860),
    [sym__begin_proof_step] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [3312] = {
    [sym_block_comment] = STATE(3312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5752),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [anon_sym_DEF] = ACTIONS(5754),
    [anon_sym_DEFS] = ACTIONS(5752),
    [sym__begin_proof_step] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [3313] = {
    [sym_block_comment] = STATE(3313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5856),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [anon_sym_DEF] = ACTIONS(5854),
    [anon_sym_DEFS] = ACTIONS(5856),
    [sym__begin_proof_step] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [3314] = {
    [sym_block_comment] = STATE(3314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5852),
    [anon_sym_u27fc] = ACTIONS(5852),
    [anon_sym_u21a6] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5850),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5852),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [3315] = {
    [sym_block_comment] = STATE(3315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5736),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [anon_sym_DEF] = ACTIONS(5738),
    [anon_sym_DEFS] = ACTIONS(5736),
    [sym__begin_proof_step] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [3316] = {
    [sym_block_comment] = STATE(3316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_COMMA] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5790),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [anon_sym_DEF] = ACTIONS(5792),
    [anon_sym_DEFS] = ACTIONS(5790),
    [sym__begin_proof_step] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [3317] = {
    [sym_block_comment] = STATE(3317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5806),
    [anon_sym_u27fc] = ACTIONS(5806),
    [anon_sym_u21a6] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5808),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5806),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [3318] = {
    [sym_block_comment] = STATE(3318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5786),
    [anon_sym_u27fc] = ACTIONS(5786),
    [anon_sym_u21a6] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5788),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5786),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [3319] = {
    [sym_block_comment] = STATE(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5856),
    [anon_sym_u27fc] = ACTIONS(5856),
    [anon_sym_u21a6] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5854),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5856),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [3320] = {
    [sym_block_comment] = STATE(3320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5744),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [anon_sym_DEF] = ACTIONS(5746),
    [anon_sym_DEFS] = ACTIONS(5744),
    [sym__begin_proof_step] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [3321] = {
    [sym_block_comment] = STATE(3321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5794),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [anon_sym_DEF] = ACTIONS(5796),
    [anon_sym_DEFS] = ACTIONS(5794),
    [sym__begin_proof_step] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [3322] = {
    [sym_block_comment] = STATE(3322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5860),
    [anon_sym_u27fc] = ACTIONS(5860),
    [anon_sym_u21a6] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5858),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5860),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [3323] = {
    [sym_block_comment] = STATE(3323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5768),
    [anon_sym_u27fc] = ACTIONS(5768),
    [anon_sym_u21a6] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5770),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [3324] = {
    [sym_block_comment] = STATE(3324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5798),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [anon_sym_DEF] = ACTIONS(5800),
    [anon_sym_DEFS] = ACTIONS(5798),
    [sym__begin_proof_step] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [3325] = {
    [sym_block_comment] = STATE(3325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5704),
    [anon_sym_u27fc] = ACTIONS(5704),
    [anon_sym_u21a6] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5706),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [3326] = {
    [sym_block_comment] = STATE(3326),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5930),
    [anon_sym_u27fc] = ACTIONS(5930),
    [anon_sym_u21a6] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_COMMA] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5928),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5930),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [3327] = {
    [sym_block_comment] = STATE(3327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5690),
    [anon_sym_u27fc] = ACTIONS(5690),
    [anon_sym_u21a6] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_COMMA] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5688),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3328] = {
    [sym_block_comment] = STATE(3328),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5728),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [anon_sym_DEF] = ACTIONS(5730),
    [anon_sym_DEFS] = ACTIONS(5728),
    [sym__begin_proof_step] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [3329] = {
    [sym_block_comment] = STATE(3329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5351),
    [anon_sym_u27fc] = ACTIONS(5351),
    [anon_sym_u21a6] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5349),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [3330] = {
    [sym_block_comment] = STATE(3330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5756),
    [anon_sym_u27fc] = ACTIONS(5756),
    [anon_sym_u21a6] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5758),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5756),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [3331] = {
    [sym_block_comment] = STATE(3331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5760),
    [anon_sym_u27fc] = ACTIONS(5760),
    [anon_sym_u21a6] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5762),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5760),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [3332] = {
    [sym_block_comment] = STATE(3332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5764),
    [anon_sym_u27fc] = ACTIONS(5764),
    [anon_sym_u21a6] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5766),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5764),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [3333] = {
    [sym_block_comment] = STATE(3333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5724),
    [anon_sym_u27fc] = ACTIONS(5724),
    [anon_sym_u21a6] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_COMMA] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5726),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5724),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [3334] = {
    [sym_block_comment] = STATE(3334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5678),
    [anon_sym_u2208] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_u25a1] = ACTIONS(5676),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5676),
    [anon_sym_u2227] = ACTIONS(5676),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5676),
    [anon_sym_u2228] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(6116),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_BSLASHo] = ACTIONS(5678),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27f9] = ACTIONS(5676),
    [anon_sym_u21d2] = ACTIONS(5676),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5676),
    [anon_sym_u21f8] = ACTIONS(5676),
    [anon_sym_u2945] = ACTIONS(5676),
    [anon_sym_BSLASHequiv] = ACTIONS(5676),
    [anon_sym_u2261] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5676),
    [anon_sym_u27fa] = ACTIONS(5676),
    [anon_sym_u21d4] = ACTIONS(5676),
    [anon_sym_TILDE_GT] = ACTIONS(5676),
    [anon_sym_u21dd] = ACTIONS(5676),
    [anon_sym_u219d] = ACTIONS(5676),
    [anon_sym_BSLASHland] = ACTIONS(5676),
    [anon_sym_BSLASHlor] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2254] = ACTIONS(5676),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5676),
    [anon_sym_u2a74] = ACTIONS(5676),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_u2260] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [sym_gt] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5678),
    [anon_sym_EQ_LT] = ACTIONS(5676),
    [anon_sym_BSLASHleq] = ACTIONS(5676),
    [anon_sym_u2264] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_BSLASHgeq] = ACTIONS(5676),
    [anon_sym_u2265] = ACTIONS(5676),
    [anon_sym_BSLASHapprox] = ACTIONS(5676),
    [anon_sym_u2248] = ACTIONS(5676),
    [anon_sym_PIPE_DASH] = ACTIONS(5676),
    [anon_sym_u22a2] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_u22a8] = ACTIONS(5676),
    [anon_sym_DASH_PIPE] = ACTIONS(5676),
    [anon_sym_u22a3] = ACTIONS(5676),
    [anon_sym_EQ_PIPE] = ACTIONS(5676),
    [anon_sym_u2ae4] = ACTIONS(5676),
    [anon_sym_BSLASHasymp] = ACTIONS(5676),
    [anon_sym_u224d] = ACTIONS(5676),
    [anon_sym_BSLASHcong] = ACTIONS(5676),
    [anon_sym_u2245] = ACTIONS(5676),
    [anon_sym_BSLASHdoteq] = ACTIONS(5676),
    [anon_sym_u2250] = ACTIONS(5676),
    [anon_sym_BSLASHgg] = ACTIONS(5676),
    [anon_sym_u226b] = ACTIONS(5676),
    [anon_sym_BSLASHll] = ACTIONS(5676),
    [anon_sym_u226a] = ACTIONS(5676),
    [anon_sym_BSLASHnotin] = ACTIONS(5676),
    [anon_sym_u2209] = ACTIONS(5676),
    [anon_sym_BSLASHprec] = ACTIONS(5678),
    [anon_sym_u227a] = ACTIONS(5676),
    [anon_sym_BSLASHsucc] = ACTIONS(5678),
    [anon_sym_u227b] = ACTIONS(5676),
    [anon_sym_BSLASHpreceq] = ACTIONS(5676),
    [anon_sym_u2aaf] = ACTIONS(5676),
    [anon_sym_BSLASHsucceq] = ACTIONS(5676),
    [anon_sym_u2ab0] = ACTIONS(5676),
    [anon_sym_BSLASHpropto] = ACTIONS(5676),
    [anon_sym_u221d] = ACTIONS(5676),
    [anon_sym_BSLASHsim] = ACTIONS(5678),
    [anon_sym_u223c] = ACTIONS(5676),
    [anon_sym_BSLASHsimeq] = ACTIONS(5676),
    [anon_sym_u2243] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5678),
    [anon_sym_u228f] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5678),
    [anon_sym_u2290] = ACTIONS(5676),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5676),
    [anon_sym_u2291] = ACTIONS(5676),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5676),
    [anon_sym_u2292] = ACTIONS(5676),
    [anon_sym_BSLASHsubset] = ACTIONS(5678),
    [anon_sym_u2282] = ACTIONS(5676),
    [anon_sym_BSLASHsupset] = ACTIONS(5678),
    [anon_sym_u2283] = ACTIONS(5676),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5676),
    [anon_sym_u2286] = ACTIONS(5676),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5676),
    [anon_sym_u2287] = ACTIONS(5676),
    [sym_compose] = ACTIONS(5676),
    [sym_map_to] = ACTIONS(5676),
    [sym_map_from] = ACTIONS(5676),
    [sym_setminus] = ACTIONS(5678),
    [anon_sym_BSLASHcap] = ACTIONS(5676),
    [anon_sym_BSLASHintersect] = ACTIONS(5676),
    [anon_sym_u2229] = ACTIONS(5676),
    [anon_sym_BSLASHcup] = ACTIONS(5676),
    [anon_sym_BSLASHunion] = ACTIONS(5676),
    [anon_sym_u222a] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5678),
    [anon_sym_u2025] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5676),
    [anon_sym_u2026] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [sym_plusplus] = ACTIONS(5676),
    [anon_sym_BSLASHoplus] = ACTIONS(5676),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5676),
    [anon_sym_u2295] = ACTIONS(5676),
    [anon_sym_BSLASHominus] = ACTIONS(5676),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2296] = ACTIONS(5676),
    [sym_mod] = ACTIONS(5678),
    [sym_modmod] = ACTIONS(5676),
    [sym_vert] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_u2016] = ACTIONS(5676),
    [sym_minusminus] = ACTIONS(5676),
    [sym_amp] = ACTIONS(5678),
    [sym_ampamp] = ACTIONS(5676),
    [anon_sym_BSLASHodot] = ACTIONS(5676),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5676),
    [anon_sym_u2299] = ACTIONS(5676),
    [anon_sym_BSLASHoslash] = ACTIONS(5676),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5676),
    [anon_sym_u2298] = ACTIONS(5676),
    [anon_sym_BSLASHotimes] = ACTIONS(5676),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5676),
    [anon_sym_u2297] = ACTIONS(5676),
    [sym_mul] = ACTIONS(5678),
    [sym_mulmul] = ACTIONS(5676),
    [sym_slash] = ACTIONS(5678),
    [sym_slashslash] = ACTIONS(5676),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5676),
    [anon_sym_u25ef] = ACTIONS(5676),
    [anon_sym_BSLASHbullet] = ACTIONS(5676),
    [anon_sym_u25cf] = ACTIONS(5676),
    [anon_sym_BSLASHdiv] = ACTIONS(5676),
    [anon_sym_u00f7] = ACTIONS(5676),
    [anon_sym_BSLASHcirc] = ACTIONS(5676),
    [anon_sym_u2218] = ACTIONS(5676),
    [anon_sym_BSLASHstar] = ACTIONS(5676),
    [anon_sym_u22c6] = ACTIONS(5676),
    [anon_sym_u203c] = ACTIONS(5676),
    [sym_hashhash] = ACTIONS(5676),
    [sym_dol] = ACTIONS(5678),
    [sym_doldol] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_u2047] = ACTIONS(5676),
    [anon_sym_BSLASHsqcap] = ACTIONS(5676),
    [anon_sym_u2293] = ACTIONS(5676),
    [anon_sym_BSLASHsqcup] = ACTIONS(5676),
    [anon_sym_u2294] = ACTIONS(5676),
    [anon_sym_BSLASHuplus] = ACTIONS(5676),
    [anon_sym_u228e] = ACTIONS(5676),
    [anon_sym_BSLASHX] = ACTIONS(5676),
    [anon_sym_BSLASHtimes] = ACTIONS(5676),
    [anon_sym_u00d7] = ACTIONS(5676),
    [anon_sym_BSLASHwr] = ACTIONS(5676),
    [anon_sym_u2240] = ACTIONS(5676),
    [anon_sym_BSLASHcdot] = ACTIONS(5676),
    [anon_sym_u22c5] = ACTIONS(5676),
    [sym_pow] = ACTIONS(5678),
    [sym_powpow] = ACTIONS(5676),
    [anon_sym_CARET_PLUS] = ACTIONS(5676),
    [anon_sym_u207a] = ACTIONS(5676),
    [sym_asterisk] = ACTIONS(5676),
    [sym_sup_hash] = ACTIONS(5676),
    [sym_prime] = ACTIONS(5676),
    [sym__bullet] = ACTIONS(5676),
    [sym__dedent] = ACTIONS(5676),
    [sym__double_excl] = ACTIONS(5676),
  },
  [3335] = {
    [sym_block_comment] = STATE(3335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_COMMA] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5748),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [anon_sym_DEF] = ACTIONS(5750),
    [anon_sym_DEFS] = ACTIONS(5748),
    [sym__begin_proof_step] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [3336] = {
    [sym_block_comment] = STATE(3336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [anon_sym_DEF] = ACTIONS(5770),
    [anon_sym_DEFS] = ACTIONS(5768),
    [sym__begin_proof_step] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [3337] = {
    [sym_block_comment] = STATE(3337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5870),
    [anon_sym_u27fc] = ACTIONS(5870),
    [anon_sym_u21a6] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5868),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5870),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [3338] = {
    [sym_block_comment] = STATE(3338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_COMMA] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5732),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [anon_sym_DEF] = ACTIONS(5734),
    [anon_sym_DEFS] = ACTIONS(5732),
    [sym__begin_proof_step] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [3339] = {
    [sym_block_comment] = STATE(3339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_GT_GT] = ACTIONS(5802),
    [anon_sym_u3009] = ACTIONS(5802),
    [anon_sym_u27e9] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_COMMA] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5802),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [3340] = {
    [sym_block_comment] = STATE(3340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_PIPE_DASH_GT] = ACTIONS(5890),
    [anon_sym_u27fc] = ACTIONS(5890),
    [anon_sym_u21a6] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_COMMA] = ACTIONS(5890),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5888),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5890),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [3341] = {
    [sym_block_comment] = STATE(3341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_COMMA] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [anon_sym_DEF] = ACTIONS(5665),
    [anon_sym_DEFS] = ACTIONS(5663),
    [sym__begin_proof_step] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [3342] = {
    [sym_block_comment] = STATE(3342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_u3009] = ACTIONS(5852),
    [anon_sym_u27e9] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5852),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [3343] = {
    [sym_block_comment] = STATE(3343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_GT_GT] = ACTIONS(5916),
    [anon_sym_u3009] = ACTIONS(5916),
    [anon_sym_u27e9] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5916),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [3344] = {
    [sym_block_comment] = STATE(3344),
    [sym_case_box] = STATE(148),
    [aux_sym_case_repeat1] = STATE(3268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5670),
    [anon_sym_u2208] = ACTIONS(5672),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_u25a1] = ACTIONS(5674),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5672),
    [anon_sym_u2227] = ACTIONS(5672),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5672),
    [anon_sym_u2228] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_BSLASHo] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27f9] = ACTIONS(5672),
    [anon_sym_u21d2] = ACTIONS(5672),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5672),
    [anon_sym_u21f8] = ACTIONS(5672),
    [anon_sym_u2945] = ACTIONS(5672),
    [anon_sym_BSLASHequiv] = ACTIONS(5672),
    [anon_sym_u2261] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5672),
    [anon_sym_u27fa] = ACTIONS(5672),
    [anon_sym_u21d4] = ACTIONS(5672),
    [anon_sym_TILDE_GT] = ACTIONS(5672),
    [anon_sym_u21dd] = ACTIONS(5672),
    [anon_sym_u219d] = ACTIONS(5672),
    [anon_sym_BSLASHland] = ACTIONS(5672),
    [anon_sym_BSLASHlor] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2254] = ACTIONS(5672),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5672),
    [anon_sym_u2a74] = ACTIONS(5672),
    [anon_sym_SLASH_EQ] = ACTIONS(5672),
    [anon_sym_POUND] = ACTIONS(5670),
    [anon_sym_u2260] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5670),
    [sym_gt] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_EQ_LT] = ACTIONS(5672),
    [anon_sym_BSLASHleq] = ACTIONS(5672),
    [anon_sym_u2264] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_BSLASHgeq] = ACTIONS(5672),
    [anon_sym_u2265] = ACTIONS(5672),
    [anon_sym_BSLASHapprox] = ACTIONS(5672),
    [anon_sym_u2248] = ACTIONS(5672),
    [anon_sym_PIPE_DASH] = ACTIONS(5672),
    [anon_sym_u22a2] = ACTIONS(5672),
    [anon_sym_PIPE_EQ] = ACTIONS(5672),
    [anon_sym_u22a8] = ACTIONS(5672),
    [anon_sym_DASH_PIPE] = ACTIONS(5672),
    [anon_sym_u22a3] = ACTIONS(5672),
    [anon_sym_EQ_PIPE] = ACTIONS(5672),
    [anon_sym_u2ae4] = ACTIONS(5672),
    [anon_sym_BSLASHasymp] = ACTIONS(5672),
    [anon_sym_u224d] = ACTIONS(5672),
    [anon_sym_BSLASHcong] = ACTIONS(5672),
    [anon_sym_u2245] = ACTIONS(5672),
    [anon_sym_BSLASHdoteq] = ACTIONS(5672),
    [anon_sym_u2250] = ACTIONS(5672),
    [anon_sym_BSLASHgg] = ACTIONS(5672),
    [anon_sym_u226b] = ACTIONS(5672),
    [anon_sym_BSLASHll] = ACTIONS(5672),
    [anon_sym_u226a] = ACTIONS(5672),
    [anon_sym_BSLASHnotin] = ACTIONS(5672),
    [anon_sym_u2209] = ACTIONS(5672),
    [anon_sym_BSLASHprec] = ACTIONS(5670),
    [anon_sym_u227a] = ACTIONS(5672),
    [anon_sym_BSLASHsucc] = ACTIONS(5670),
    [anon_sym_u227b] = ACTIONS(5672),
    [anon_sym_BSLASHpreceq] = ACTIONS(5672),
    [anon_sym_u2aaf] = ACTIONS(5672),
    [anon_sym_BSLASHsucceq] = ACTIONS(5672),
    [anon_sym_u2ab0] = ACTIONS(5672),
    [anon_sym_BSLASHpropto] = ACTIONS(5672),
    [anon_sym_u221d] = ACTIONS(5672),
    [anon_sym_BSLASHsim] = ACTIONS(5670),
    [anon_sym_u223c] = ACTIONS(5672),
    [anon_sym_BSLASHsimeq] = ACTIONS(5672),
    [anon_sym_u2243] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5670),
    [anon_sym_u228f] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5670),
    [anon_sym_u2290] = ACTIONS(5672),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5672),
    [anon_sym_u2291] = ACTIONS(5672),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5672),
    [anon_sym_u2292] = ACTIONS(5672),
    [anon_sym_BSLASHsubset] = ACTIONS(5670),
    [anon_sym_u2282] = ACTIONS(5672),
    [anon_sym_BSLASHsupset] = ACTIONS(5670),
    [anon_sym_u2283] = ACTIONS(5672),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5672),
    [anon_sym_u2286] = ACTIONS(5672),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5672),
    [anon_sym_u2287] = ACTIONS(5672),
    [sym_compose] = ACTIONS(5672),
    [sym_map_to] = ACTIONS(5672),
    [sym_map_from] = ACTIONS(5672),
    [sym_setminus] = ACTIONS(5670),
    [anon_sym_BSLASHcap] = ACTIONS(5672),
    [anon_sym_BSLASHintersect] = ACTIONS(5672),
    [anon_sym_u2229] = ACTIONS(5672),
    [anon_sym_BSLASHcup] = ACTIONS(5672),
    [anon_sym_BSLASHunion] = ACTIONS(5672),
    [anon_sym_u222a] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5670),
    [anon_sym_u2025] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5672),
    [anon_sym_u2026] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5670),
    [sym_plusplus] = ACTIONS(5672),
    [anon_sym_BSLASHoplus] = ACTIONS(5672),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5672),
    [anon_sym_u2295] = ACTIONS(5672),
    [anon_sym_BSLASHominus] = ACTIONS(5672),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2296] = ACTIONS(5672),
    [sym_mod] = ACTIONS(5670),
    [sym_modmod] = ACTIONS(5672),
    [sym_vert] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_u2016] = ACTIONS(5672),
    [sym_minusminus] = ACTIONS(5672),
    [sym_amp] = ACTIONS(5670),
    [sym_ampamp] = ACTIONS(5672),
    [anon_sym_BSLASHodot] = ACTIONS(5672),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5672),
    [anon_sym_u2299] = ACTIONS(5672),
    [anon_sym_BSLASHoslash] = ACTIONS(5672),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5672),
    [anon_sym_u2298] = ACTIONS(5672),
    [anon_sym_BSLASHotimes] = ACTIONS(5672),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5672),
    [anon_sym_u2297] = ACTIONS(5672),
    [sym_mul] = ACTIONS(5670),
    [sym_mulmul] = ACTIONS(5672),
    [sym_slash] = ACTIONS(5670),
    [sym_slashslash] = ACTIONS(5672),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5672),
    [anon_sym_u25ef] = ACTIONS(5672),
    [anon_sym_BSLASHbullet] = ACTIONS(5672),
    [anon_sym_u25cf] = ACTIONS(5672),
    [anon_sym_BSLASHdiv] = ACTIONS(5672),
    [anon_sym_u00f7] = ACTIONS(5672),
    [anon_sym_BSLASHcirc] = ACTIONS(5672),
    [anon_sym_u2218] = ACTIONS(5672),
    [anon_sym_BSLASHstar] = ACTIONS(5672),
    [anon_sym_u22c6] = ACTIONS(5672),
    [anon_sym_u203c] = ACTIONS(5672),
    [sym_hashhash] = ACTIONS(5672),
    [sym_dol] = ACTIONS(5670),
    [sym_doldol] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_u2047] = ACTIONS(5672),
    [anon_sym_BSLASHsqcap] = ACTIONS(5672),
    [anon_sym_u2293] = ACTIONS(5672),
    [anon_sym_BSLASHsqcup] = ACTIONS(5672),
    [anon_sym_u2294] = ACTIONS(5672),
    [anon_sym_BSLASHuplus] = ACTIONS(5672),
    [anon_sym_u228e] = ACTIONS(5672),
    [anon_sym_BSLASHX] = ACTIONS(5672),
    [anon_sym_BSLASHtimes] = ACTIONS(5672),
    [anon_sym_u00d7] = ACTIONS(5672),
    [anon_sym_BSLASHwr] = ACTIONS(5672),
    [anon_sym_u2240] = ACTIONS(5672),
    [anon_sym_BSLASHcdot] = ACTIONS(5672),
    [anon_sym_u22c5] = ACTIONS(5672),
    [sym_pow] = ACTIONS(5670),
    [sym_powpow] = ACTIONS(5672),
    [anon_sym_CARET_PLUS] = ACTIONS(5672),
    [anon_sym_u207a] = ACTIONS(5672),
    [sym_asterisk] = ACTIONS(5672),
    [sym_sup_hash] = ACTIONS(5672),
    [sym_prime] = ACTIONS(5672),
    [sym__bullet] = ACTIONS(5672),
    [sym__dedent] = ACTIONS(5672),
    [sym__double_excl] = ACTIONS(5672),
  },
  [3345] = {
    [sym_block_comment] = STATE(3345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5698),
    [anon_sym_u2208] = ACTIONS(5696),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5696),
    [anon_sym_u25a1] = ACTIONS(5696),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5696),
    [anon_sym_u2227] = ACTIONS(5696),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5696),
    [anon_sym_u2228] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_BANG] = ACTIONS(5696),
    [anon_sym_BSLASHo] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27f9] = ACTIONS(5696),
    [anon_sym_u21d2] = ACTIONS(5696),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5696),
    [anon_sym_u21f8] = ACTIONS(5696),
    [anon_sym_u2945] = ACTIONS(5696),
    [anon_sym_BSLASHequiv] = ACTIONS(5696),
    [anon_sym_u2261] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_u27fa] = ACTIONS(5696),
    [anon_sym_u21d4] = ACTIONS(5696),
    [anon_sym_TILDE_GT] = ACTIONS(5696),
    [anon_sym_u21dd] = ACTIONS(5696),
    [anon_sym_u219d] = ACTIONS(5696),
    [anon_sym_BSLASHland] = ACTIONS(5696),
    [anon_sym_BSLASHlor] = ACTIONS(5696),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2254] = ACTIONS(5696),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5696),
    [anon_sym_u2a74] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_POUND] = ACTIONS(5698),
    [anon_sym_u2260] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [sym_gt] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_EQ_LT] = ACTIONS(5696),
    [anon_sym_BSLASHleq] = ACTIONS(5696),
    [anon_sym_u2264] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_BSLASHgeq] = ACTIONS(5696),
    [anon_sym_u2265] = ACTIONS(5696),
    [anon_sym_BSLASHapprox] = ACTIONS(5696),
    [anon_sym_u2248] = ACTIONS(5696),
    [anon_sym_PIPE_DASH] = ACTIONS(5696),
    [anon_sym_u22a2] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_u22a8] = ACTIONS(5696),
    [anon_sym_DASH_PIPE] = ACTIONS(5696),
    [anon_sym_u22a3] = ACTIONS(5696),
    [anon_sym_EQ_PIPE] = ACTIONS(5696),
    [anon_sym_u2ae4] = ACTIONS(5696),
    [anon_sym_BSLASHasymp] = ACTIONS(5696),
    [anon_sym_u224d] = ACTIONS(5696),
    [anon_sym_BSLASHcong] = ACTIONS(5696),
    [anon_sym_u2245] = ACTIONS(5696),
    [anon_sym_BSLASHdoteq] = ACTIONS(5696),
    [anon_sym_u2250] = ACTIONS(5696),
    [anon_sym_BSLASHgg] = ACTIONS(5696),
    [anon_sym_u226b] = ACTIONS(5696),
    [anon_sym_BSLASHll] = ACTIONS(5696),
    [anon_sym_u226a] = ACTIONS(5696),
    [anon_sym_BSLASHnotin] = ACTIONS(5696),
    [anon_sym_u2209] = ACTIONS(5696),
    [anon_sym_BSLASHprec] = ACTIONS(5698),
    [anon_sym_u227a] = ACTIONS(5696),
    [anon_sym_BSLASHsucc] = ACTIONS(5698),
    [anon_sym_u227b] = ACTIONS(5696),
    [anon_sym_BSLASHpreceq] = ACTIONS(5696),
    [anon_sym_u2aaf] = ACTIONS(5696),
    [anon_sym_BSLASHsucceq] = ACTIONS(5696),
    [anon_sym_u2ab0] = ACTIONS(5696),
    [anon_sym_BSLASHpropto] = ACTIONS(5696),
    [anon_sym_u221d] = ACTIONS(5696),
    [anon_sym_BSLASHsim] = ACTIONS(5698),
    [anon_sym_u223c] = ACTIONS(5696),
    [anon_sym_BSLASHsimeq] = ACTIONS(5696),
    [anon_sym_u2243] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5698),
    [anon_sym_u228f] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5698),
    [anon_sym_u2290] = ACTIONS(5696),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5696),
    [anon_sym_u2291] = ACTIONS(5696),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5696),
    [anon_sym_u2292] = ACTIONS(5696),
    [anon_sym_BSLASHsubset] = ACTIONS(5698),
    [anon_sym_u2282] = ACTIONS(5696),
    [anon_sym_BSLASHsupset] = ACTIONS(5698),
    [anon_sym_u2283] = ACTIONS(5696),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5696),
    [anon_sym_u2286] = ACTIONS(5696),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5696),
    [anon_sym_u2287] = ACTIONS(5696),
    [sym_compose] = ACTIONS(5696),
    [sym_map_to] = ACTIONS(5696),
    [sym_map_from] = ACTIONS(5696),
    [sym_setminus] = ACTIONS(5698),
    [anon_sym_BSLASHcap] = ACTIONS(5696),
    [anon_sym_BSLASHintersect] = ACTIONS(5696),
    [anon_sym_u2229] = ACTIONS(5696),
    [anon_sym_BSLASHcup] = ACTIONS(5696),
    [anon_sym_BSLASHunion] = ACTIONS(5696),
    [anon_sym_u222a] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_u2025] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_u2026] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [sym_plusplus] = ACTIONS(5696),
    [anon_sym_BSLASHoplus] = ACTIONS(5696),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5696),
    [anon_sym_u2295] = ACTIONS(5696),
    [anon_sym_BSLASHominus] = ACTIONS(5696),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2296] = ACTIONS(5696),
    [sym_mod] = ACTIONS(5698),
    [sym_modmod] = ACTIONS(5696),
    [sym_vert] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_u2016] = ACTIONS(5696),
    [sym_minusminus] = ACTIONS(5696),
    [sym_amp] = ACTIONS(5698),
    [sym_ampamp] = ACTIONS(5696),
    [anon_sym_BSLASHodot] = ACTIONS(5696),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5696),
    [anon_sym_u2299] = ACTIONS(5696),
    [anon_sym_BSLASHoslash] = ACTIONS(5696),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5696),
    [anon_sym_u2298] = ACTIONS(5696),
    [anon_sym_BSLASHotimes] = ACTIONS(5696),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5696),
    [anon_sym_u2297] = ACTIONS(5696),
    [sym_mul] = ACTIONS(5698),
    [sym_mulmul] = ACTIONS(5696),
    [sym_slash] = ACTIONS(5698),
    [sym_slashslash] = ACTIONS(5696),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5696),
    [anon_sym_u25ef] = ACTIONS(5696),
    [anon_sym_BSLASHbullet] = ACTIONS(5696),
    [anon_sym_u25cf] = ACTIONS(5696),
    [anon_sym_BSLASHdiv] = ACTIONS(5696),
    [anon_sym_u00f7] = ACTIONS(5696),
    [anon_sym_BSLASHcirc] = ACTIONS(5696),
    [anon_sym_u2218] = ACTIONS(5696),
    [anon_sym_BSLASHstar] = ACTIONS(5696),
    [anon_sym_u22c6] = ACTIONS(5696),
    [anon_sym_u203c] = ACTIONS(5696),
    [sym_hashhash] = ACTIONS(5696),
    [sym_dol] = ACTIONS(5698),
    [sym_doldol] = ACTIONS(5696),
    [anon_sym_QMARK_QMARK] = ACTIONS(5696),
    [anon_sym_u2047] = ACTIONS(5696),
    [anon_sym_BSLASHsqcap] = ACTIONS(5696),
    [anon_sym_u2293] = ACTIONS(5696),
    [anon_sym_BSLASHsqcup] = ACTIONS(5696),
    [anon_sym_u2294] = ACTIONS(5696),
    [anon_sym_BSLASHuplus] = ACTIONS(5696),
    [anon_sym_u228e] = ACTIONS(5696),
    [anon_sym_BSLASHX] = ACTIONS(5696),
    [anon_sym_BSLASHtimes] = ACTIONS(5696),
    [anon_sym_u00d7] = ACTIONS(5696),
    [anon_sym_BSLASHwr] = ACTIONS(5696),
    [anon_sym_u2240] = ACTIONS(5696),
    [anon_sym_BSLASHcdot] = ACTIONS(5696),
    [anon_sym_u22c5] = ACTIONS(5696),
    [sym_pow] = ACTIONS(5698),
    [sym_powpow] = ACTIONS(5696),
    [anon_sym_CARET_PLUS] = ACTIONS(5696),
    [anon_sym_u207a] = ACTIONS(5696),
    [sym_asterisk] = ACTIONS(5696),
    [sym_sup_hash] = ACTIONS(5696),
    [sym_prime] = ACTIONS(5696),
    [sym__bullet] = ACTIONS(5696),
    [sym__dedent] = ACTIONS(5696),
    [sym__double_excl] = ACTIONS(5696),
  },
  [3346] = {
    [sym_block_comment] = STATE(3346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5718),
    [anon_sym_u2208] = ACTIONS(5716),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5716),
    [anon_sym_u25a1] = ACTIONS(5716),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5716),
    [anon_sym_u2227] = ACTIONS(5716),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5716),
    [anon_sym_u2228] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5718),
    [anon_sym_BANG] = ACTIONS(5716),
    [anon_sym_BSLASHo] = ACTIONS(5718),
    [anon_sym_DOT] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_DASH] = ACTIONS(5718),
    [anon_sym_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27f9] = ACTIONS(5716),
    [anon_sym_u21d2] = ACTIONS(5716),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5716),
    [anon_sym_u21f8] = ACTIONS(5716),
    [anon_sym_u2945] = ACTIONS(5716),
    [anon_sym_BSLASHequiv] = ACTIONS(5716),
    [anon_sym_u2261] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5716),
    [anon_sym_u27fa] = ACTIONS(5716),
    [anon_sym_u21d4] = ACTIONS(5716),
    [anon_sym_TILDE_GT] = ACTIONS(5716),
    [anon_sym_u21dd] = ACTIONS(5716),
    [anon_sym_u219d] = ACTIONS(5716),
    [anon_sym_BSLASHland] = ACTIONS(5716),
    [anon_sym_BSLASHlor] = ACTIONS(5716),
    [anon_sym_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2254] = ACTIONS(5716),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5716),
    [anon_sym_u2a74] = ACTIONS(5716),
    [anon_sym_SLASH_EQ] = ACTIONS(5716),
    [anon_sym_POUND] = ACTIONS(5718),
    [anon_sym_u2260] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5718),
    [sym_gt] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5718),
    [anon_sym_EQ_LT] = ACTIONS(5716),
    [anon_sym_BSLASHleq] = ACTIONS(5716),
    [anon_sym_u2264] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_BSLASHgeq] = ACTIONS(5716),
    [anon_sym_u2265] = ACTIONS(5716),
    [anon_sym_BSLASHapprox] = ACTIONS(5716),
    [anon_sym_u2248] = ACTIONS(5716),
    [anon_sym_PIPE_DASH] = ACTIONS(5716),
    [anon_sym_u22a2] = ACTIONS(5716),
    [anon_sym_PIPE_EQ] = ACTIONS(5716),
    [anon_sym_u22a8] = ACTIONS(5716),
    [anon_sym_DASH_PIPE] = ACTIONS(5716),
    [anon_sym_u22a3] = ACTIONS(5716),
    [anon_sym_EQ_PIPE] = ACTIONS(5716),
    [anon_sym_u2ae4] = ACTIONS(5716),
    [anon_sym_BSLASHasymp] = ACTIONS(5716),
    [anon_sym_u224d] = ACTIONS(5716),
    [anon_sym_BSLASHcong] = ACTIONS(5716),
    [anon_sym_u2245] = ACTIONS(5716),
    [anon_sym_BSLASHdoteq] = ACTIONS(5716),
    [anon_sym_u2250] = ACTIONS(5716),
    [anon_sym_BSLASHgg] = ACTIONS(5716),
    [anon_sym_u226b] = ACTIONS(5716),
    [anon_sym_BSLASHll] = ACTIONS(5716),
    [anon_sym_u226a] = ACTIONS(5716),
    [anon_sym_BSLASHnotin] = ACTIONS(5716),
    [anon_sym_u2209] = ACTIONS(5716),
    [anon_sym_BSLASHprec] = ACTIONS(5718),
    [anon_sym_u227a] = ACTIONS(5716),
    [anon_sym_BSLASHsucc] = ACTIONS(5718),
    [anon_sym_u227b] = ACTIONS(5716),
    [anon_sym_BSLASHpreceq] = ACTIONS(5716),
    [anon_sym_u2aaf] = ACTIONS(5716),
    [anon_sym_BSLASHsucceq] = ACTIONS(5716),
    [anon_sym_u2ab0] = ACTIONS(5716),
    [anon_sym_BSLASHpropto] = ACTIONS(5716),
    [anon_sym_u221d] = ACTIONS(5716),
    [anon_sym_BSLASHsim] = ACTIONS(5718),
    [anon_sym_u223c] = ACTIONS(5716),
    [anon_sym_BSLASHsimeq] = ACTIONS(5716),
    [anon_sym_u2243] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5718),
    [anon_sym_u228f] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5718),
    [anon_sym_u2290] = ACTIONS(5716),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5716),
    [anon_sym_u2291] = ACTIONS(5716),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5716),
    [anon_sym_u2292] = ACTIONS(5716),
    [anon_sym_BSLASHsubset] = ACTIONS(5718),
    [anon_sym_u2282] = ACTIONS(5716),
    [anon_sym_BSLASHsupset] = ACTIONS(5718),
    [anon_sym_u2283] = ACTIONS(5716),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5716),
    [anon_sym_u2286] = ACTIONS(5716),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5716),
    [anon_sym_u2287] = ACTIONS(5716),
    [sym_compose] = ACTIONS(5716),
    [sym_map_to] = ACTIONS(5716),
    [sym_map_from] = ACTIONS(5716),
    [sym_setminus] = ACTIONS(5718),
    [anon_sym_BSLASHcap] = ACTIONS(5716),
    [anon_sym_BSLASHintersect] = ACTIONS(5716),
    [anon_sym_u2229] = ACTIONS(5716),
    [anon_sym_BSLASHcup] = ACTIONS(5716),
    [anon_sym_BSLASHunion] = ACTIONS(5716),
    [anon_sym_u222a] = ACTIONS(5716),
    [anon_sym_DOT_DOT] = ACTIONS(5718),
    [anon_sym_u2025] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5716),
    [anon_sym_u2026] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5718),
    [sym_plusplus] = ACTIONS(5716),
    [anon_sym_BSLASHoplus] = ACTIONS(5716),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5716),
    [anon_sym_u2295] = ACTIONS(5716),
    [anon_sym_BSLASHominus] = ACTIONS(5716),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2296] = ACTIONS(5716),
    [sym_mod] = ACTIONS(5718),
    [sym_modmod] = ACTIONS(5716),
    [sym_vert] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_u2016] = ACTIONS(5716),
    [sym_minusminus] = ACTIONS(5716),
    [sym_amp] = ACTIONS(5718),
    [sym_ampamp] = ACTIONS(5716),
    [anon_sym_BSLASHodot] = ACTIONS(5716),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5716),
    [anon_sym_u2299] = ACTIONS(5716),
    [anon_sym_BSLASHoslash] = ACTIONS(5716),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5716),
    [anon_sym_u2298] = ACTIONS(5716),
    [anon_sym_BSLASHotimes] = ACTIONS(5716),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5716),
    [anon_sym_u2297] = ACTIONS(5716),
    [sym_mul] = ACTIONS(5718),
    [sym_mulmul] = ACTIONS(5716),
    [sym_slash] = ACTIONS(5718),
    [sym_slashslash] = ACTIONS(5716),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5716),
    [anon_sym_u25ef] = ACTIONS(5716),
    [anon_sym_BSLASHbullet] = ACTIONS(5716),
    [anon_sym_u25cf] = ACTIONS(5716),
    [anon_sym_BSLASHdiv] = ACTIONS(5716),
    [anon_sym_u00f7] = ACTIONS(5716),
    [anon_sym_BSLASHcirc] = ACTIONS(5716),
    [anon_sym_u2218] = ACTIONS(5716),
    [anon_sym_BSLASHstar] = ACTIONS(5716),
    [anon_sym_u22c6] = ACTIONS(5716),
    [anon_sym_u203c] = ACTIONS(5716),
    [sym_hashhash] = ACTIONS(5716),
    [sym_dol] = ACTIONS(5718),
    [sym_doldol] = ACTIONS(5716),
    [anon_sym_QMARK_QMARK] = ACTIONS(5716),
    [anon_sym_u2047] = ACTIONS(5716),
    [anon_sym_BSLASHsqcap] = ACTIONS(5716),
    [anon_sym_u2293] = ACTIONS(5716),
    [anon_sym_BSLASHsqcup] = ACTIONS(5716),
    [anon_sym_u2294] = ACTIONS(5716),
    [anon_sym_BSLASHuplus] = ACTIONS(5716),
    [anon_sym_u228e] = ACTIONS(5716),
    [anon_sym_BSLASHX] = ACTIONS(5716),
    [anon_sym_BSLASHtimes] = ACTIONS(5716),
    [anon_sym_u00d7] = ACTIONS(5716),
    [anon_sym_BSLASHwr] = ACTIONS(5716),
    [anon_sym_u2240] = ACTIONS(5716),
    [anon_sym_BSLASHcdot] = ACTIONS(5716),
    [anon_sym_u22c5] = ACTIONS(5716),
    [sym_pow] = ACTIONS(5718),
    [sym_powpow] = ACTIONS(5716),
    [anon_sym_CARET_PLUS] = ACTIONS(5716),
    [anon_sym_u207a] = ACTIONS(5716),
    [sym_asterisk] = ACTIONS(5716),
    [sym_sup_hash] = ACTIONS(5716),
    [sym_prime] = ACTIONS(5716),
    [sym__bullet] = ACTIONS(5716),
    [sym__dedent] = ACTIONS(5716),
    [sym__double_excl] = ACTIONS(5716),
  },
  [3347] = {
    [sym_block_comment] = STATE(3347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5720),
    [anon_sym_u2208] = ACTIONS(5722),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5722),
    [anon_sym_u25a1] = ACTIONS(5722),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5722),
    [anon_sym_u2227] = ACTIONS(5722),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5722),
    [anon_sym_u2228] = ACTIONS(5722),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_BSLASHo] = ACTIONS(5720),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27f9] = ACTIONS(5722),
    [anon_sym_u21d2] = ACTIONS(5722),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5722),
    [anon_sym_u21f8] = ACTIONS(5722),
    [anon_sym_u2945] = ACTIONS(5722),
    [anon_sym_BSLASHequiv] = ACTIONS(5722),
    [anon_sym_u2261] = ACTIONS(5722),
    [anon_sym_LT_EQ_GT] = ACTIONS(5722),
    [anon_sym_u27fa] = ACTIONS(5722),
    [anon_sym_u21d4] = ACTIONS(5722),
    [anon_sym_TILDE_GT] = ACTIONS(5722),
    [anon_sym_u21dd] = ACTIONS(5722),
    [anon_sym_u219d] = ACTIONS(5722),
    [anon_sym_BSLASHland] = ACTIONS(5722),
    [anon_sym_BSLASHlor] = ACTIONS(5722),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2254] = ACTIONS(5722),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5722),
    [anon_sym_u2a74] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_POUND] = ACTIONS(5720),
    [anon_sym_u2260] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5720),
    [sym_gt] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_EQ_LT] = ACTIONS(5722),
    [anon_sym_BSLASHleq] = ACTIONS(5722),
    [anon_sym_u2264] = ACTIONS(5722),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_BSLASHgeq] = ACTIONS(5722),
    [anon_sym_u2265] = ACTIONS(5722),
    [anon_sym_BSLASHapprox] = ACTIONS(5722),
    [anon_sym_u2248] = ACTIONS(5722),
    [anon_sym_PIPE_DASH] = ACTIONS(5722),
    [anon_sym_u22a2] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_u22a8] = ACTIONS(5722),
    [anon_sym_DASH_PIPE] = ACTIONS(5722),
    [anon_sym_u22a3] = ACTIONS(5722),
    [anon_sym_EQ_PIPE] = ACTIONS(5722),
    [anon_sym_u2ae4] = ACTIONS(5722),
    [anon_sym_BSLASHasymp] = ACTIONS(5722),
    [anon_sym_u224d] = ACTIONS(5722),
    [anon_sym_BSLASHcong] = ACTIONS(5722),
    [anon_sym_u2245] = ACTIONS(5722),
    [anon_sym_BSLASHdoteq] = ACTIONS(5722),
    [anon_sym_u2250] = ACTIONS(5722),
    [anon_sym_BSLASHgg] = ACTIONS(5722),
    [anon_sym_u226b] = ACTIONS(5722),
    [anon_sym_BSLASHll] = ACTIONS(5722),
    [anon_sym_u226a] = ACTIONS(5722),
    [anon_sym_BSLASHnotin] = ACTIONS(5722),
    [anon_sym_u2209] = ACTIONS(5722),
    [anon_sym_BSLASHprec] = ACTIONS(5720),
    [anon_sym_u227a] = ACTIONS(5722),
    [anon_sym_BSLASHsucc] = ACTIONS(5720),
    [anon_sym_u227b] = ACTIONS(5722),
    [anon_sym_BSLASHpreceq] = ACTIONS(5722),
    [anon_sym_u2aaf] = ACTIONS(5722),
    [anon_sym_BSLASHsucceq] = ACTIONS(5722),
    [anon_sym_u2ab0] = ACTIONS(5722),
    [anon_sym_BSLASHpropto] = ACTIONS(5722),
    [anon_sym_u221d] = ACTIONS(5722),
    [anon_sym_BSLASHsim] = ACTIONS(5720),
    [anon_sym_u223c] = ACTIONS(5722),
    [anon_sym_BSLASHsimeq] = ACTIONS(5722),
    [anon_sym_u2243] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5720),
    [anon_sym_u228f] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5720),
    [anon_sym_u2290] = ACTIONS(5722),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5722),
    [anon_sym_u2291] = ACTIONS(5722),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5722),
    [anon_sym_u2292] = ACTIONS(5722),
    [anon_sym_BSLASHsubset] = ACTIONS(5720),
    [anon_sym_u2282] = ACTIONS(5722),
    [anon_sym_BSLASHsupset] = ACTIONS(5720),
    [anon_sym_u2283] = ACTIONS(5722),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5722),
    [anon_sym_u2286] = ACTIONS(5722),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5722),
    [anon_sym_u2287] = ACTIONS(5722),
    [sym_compose] = ACTIONS(5722),
    [sym_map_to] = ACTIONS(5722),
    [sym_map_from] = ACTIONS(5722),
    [sym_setminus] = ACTIONS(5720),
    [anon_sym_BSLASHcap] = ACTIONS(5722),
    [anon_sym_BSLASHintersect] = ACTIONS(5722),
    [anon_sym_u2229] = ACTIONS(5722),
    [anon_sym_BSLASHcup] = ACTIONS(5722),
    [anon_sym_BSLASHunion] = ACTIONS(5722),
    [anon_sym_u222a] = ACTIONS(5722),
    [anon_sym_DOT_DOT] = ACTIONS(5720),
    [anon_sym_u2025] = ACTIONS(5722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5722),
    [anon_sym_u2026] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5720),
    [sym_plusplus] = ACTIONS(5722),
    [anon_sym_BSLASHoplus] = ACTIONS(5722),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5722),
    [anon_sym_u2295] = ACTIONS(5722),
    [anon_sym_BSLASHominus] = ACTIONS(5722),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2296] = ACTIONS(5722),
    [sym_mod] = ACTIONS(5720),
    [sym_modmod] = ACTIONS(5722),
    [sym_vert] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(5722),
    [anon_sym_u2016] = ACTIONS(5722),
    [sym_minusminus] = ACTIONS(5722),
    [sym_amp] = ACTIONS(5720),
    [sym_ampamp] = ACTIONS(5722),
    [anon_sym_BSLASHodot] = ACTIONS(5722),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5722),
    [anon_sym_u2299] = ACTIONS(5722),
    [anon_sym_BSLASHoslash] = ACTIONS(5722),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5722),
    [anon_sym_u2298] = ACTIONS(5722),
    [anon_sym_BSLASHotimes] = ACTIONS(5722),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5722),
    [anon_sym_u2297] = ACTIONS(5722),
    [sym_mul] = ACTIONS(5720),
    [sym_mulmul] = ACTIONS(5722),
    [sym_slash] = ACTIONS(5720),
    [sym_slashslash] = ACTIONS(5722),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5722),
    [anon_sym_u25ef] = ACTIONS(5722),
    [anon_sym_BSLASHbullet] = ACTIONS(5722),
    [anon_sym_u25cf] = ACTIONS(5722),
    [anon_sym_BSLASHdiv] = ACTIONS(5722),
    [anon_sym_u00f7] = ACTIONS(5722),
    [anon_sym_BSLASHcirc] = ACTIONS(5722),
    [anon_sym_u2218] = ACTIONS(5722),
    [anon_sym_BSLASHstar] = ACTIONS(5722),
    [anon_sym_u22c6] = ACTIONS(5722),
    [anon_sym_u203c] = ACTIONS(5722),
    [sym_hashhash] = ACTIONS(5722),
    [sym_dol] = ACTIONS(5720),
    [sym_doldol] = ACTIONS(5722),
    [anon_sym_QMARK_QMARK] = ACTIONS(5722),
    [anon_sym_u2047] = ACTIONS(5722),
    [anon_sym_BSLASHsqcap] = ACTIONS(5722),
    [anon_sym_u2293] = ACTIONS(5722),
    [anon_sym_BSLASHsqcup] = ACTIONS(5722),
    [anon_sym_u2294] = ACTIONS(5722),
    [anon_sym_BSLASHuplus] = ACTIONS(5722),
    [anon_sym_u228e] = ACTIONS(5722),
    [anon_sym_BSLASHX] = ACTIONS(5722),
    [anon_sym_BSLASHtimes] = ACTIONS(5722),
    [anon_sym_u00d7] = ACTIONS(5722),
    [anon_sym_BSLASHwr] = ACTIONS(5722),
    [anon_sym_u2240] = ACTIONS(5722),
    [anon_sym_BSLASHcdot] = ACTIONS(5722),
    [anon_sym_u22c5] = ACTIONS(5722),
    [sym_pow] = ACTIONS(5720),
    [sym_powpow] = ACTIONS(5722),
    [anon_sym_CARET_PLUS] = ACTIONS(5722),
    [anon_sym_u207a] = ACTIONS(5722),
    [sym_asterisk] = ACTIONS(5722),
    [sym_sup_hash] = ACTIONS(5722),
    [sym_prime] = ACTIONS(5722),
    [sym__bullet] = ACTIONS(5722),
    [sym__dedent] = ACTIONS(5722),
    [sym__double_excl] = ACTIONS(5722),
  },
  [3348] = {
    [sym_block_comment] = STATE(3348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__bullet] = ACTIONS(5690),
    [sym__dedent] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3349] = {
    [sym_block_comment] = STATE(3349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BANG] = ACTIONS(5692),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__bullet] = ACTIONS(5690),
    [sym__dedent] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3350] = {
    [sym_block_comment] = STATE(3350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5714),
    [anon_sym_u2208] = ACTIONS(5712),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5712),
    [anon_sym_u25a1] = ACTIONS(5712),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5712),
    [anon_sym_u2227] = ACTIONS(5712),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5712),
    [anon_sym_u2228] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_BANG] = ACTIONS(5712),
    [anon_sym_BSLASHo] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [anon_sym_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27f9] = ACTIONS(5712),
    [anon_sym_u21d2] = ACTIONS(5712),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5712),
    [anon_sym_u21f8] = ACTIONS(5712),
    [anon_sym_u2945] = ACTIONS(5712),
    [anon_sym_BSLASHequiv] = ACTIONS(5712),
    [anon_sym_u2261] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_u27fa] = ACTIONS(5712),
    [anon_sym_u21d4] = ACTIONS(5712),
    [anon_sym_TILDE_GT] = ACTIONS(5712),
    [anon_sym_u21dd] = ACTIONS(5712),
    [anon_sym_u219d] = ACTIONS(5712),
    [anon_sym_BSLASHland] = ACTIONS(5712),
    [anon_sym_BSLASHlor] = ACTIONS(5712),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2254] = ACTIONS(5712),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5712),
    [anon_sym_u2a74] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_POUND] = ACTIONS(5714),
    [anon_sym_u2260] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [sym_gt] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5714),
    [anon_sym_EQ_LT] = ACTIONS(5712),
    [anon_sym_BSLASHleq] = ACTIONS(5712),
    [anon_sym_u2264] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_BSLASHgeq] = ACTIONS(5712),
    [anon_sym_u2265] = ACTIONS(5712),
    [anon_sym_BSLASHapprox] = ACTIONS(5712),
    [anon_sym_u2248] = ACTIONS(5712),
    [anon_sym_PIPE_DASH] = ACTIONS(5712),
    [anon_sym_u22a2] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_u22a8] = ACTIONS(5712),
    [anon_sym_DASH_PIPE] = ACTIONS(5712),
    [anon_sym_u22a3] = ACTIONS(5712),
    [anon_sym_EQ_PIPE] = ACTIONS(5712),
    [anon_sym_u2ae4] = ACTIONS(5712),
    [anon_sym_BSLASHasymp] = ACTIONS(5712),
    [anon_sym_u224d] = ACTIONS(5712),
    [anon_sym_BSLASHcong] = ACTIONS(5712),
    [anon_sym_u2245] = ACTIONS(5712),
    [anon_sym_BSLASHdoteq] = ACTIONS(5712),
    [anon_sym_u2250] = ACTIONS(5712),
    [anon_sym_BSLASHgg] = ACTIONS(5712),
    [anon_sym_u226b] = ACTIONS(5712),
    [anon_sym_BSLASHll] = ACTIONS(5712),
    [anon_sym_u226a] = ACTIONS(5712),
    [anon_sym_BSLASHnotin] = ACTIONS(5712),
    [anon_sym_u2209] = ACTIONS(5712),
    [anon_sym_BSLASHprec] = ACTIONS(5714),
    [anon_sym_u227a] = ACTIONS(5712),
    [anon_sym_BSLASHsucc] = ACTIONS(5714),
    [anon_sym_u227b] = ACTIONS(5712),
    [anon_sym_BSLASHpreceq] = ACTIONS(5712),
    [anon_sym_u2aaf] = ACTIONS(5712),
    [anon_sym_BSLASHsucceq] = ACTIONS(5712),
    [anon_sym_u2ab0] = ACTIONS(5712),
    [anon_sym_BSLASHpropto] = ACTIONS(5712),
    [anon_sym_u221d] = ACTIONS(5712),
    [anon_sym_BSLASHsim] = ACTIONS(5714),
    [anon_sym_u223c] = ACTIONS(5712),
    [anon_sym_BSLASHsimeq] = ACTIONS(5712),
    [anon_sym_u2243] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5714),
    [anon_sym_u228f] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5714),
    [anon_sym_u2290] = ACTIONS(5712),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5712),
    [anon_sym_u2291] = ACTIONS(5712),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5712),
    [anon_sym_u2292] = ACTIONS(5712),
    [anon_sym_BSLASHsubset] = ACTIONS(5714),
    [anon_sym_u2282] = ACTIONS(5712),
    [anon_sym_BSLASHsupset] = ACTIONS(5714),
    [anon_sym_u2283] = ACTIONS(5712),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5712),
    [anon_sym_u2286] = ACTIONS(5712),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5712),
    [anon_sym_u2287] = ACTIONS(5712),
    [sym_compose] = ACTIONS(5712),
    [sym_map_to] = ACTIONS(5712),
    [sym_map_from] = ACTIONS(5712),
    [sym_setminus] = ACTIONS(5714),
    [anon_sym_BSLASHcap] = ACTIONS(5712),
    [anon_sym_BSLASHintersect] = ACTIONS(5712),
    [anon_sym_u2229] = ACTIONS(5712),
    [anon_sym_BSLASHcup] = ACTIONS(5712),
    [anon_sym_BSLASHunion] = ACTIONS(5712),
    [anon_sym_u222a] = ACTIONS(5712),
    [anon_sym_DOT_DOT] = ACTIONS(5714),
    [anon_sym_u2025] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_u2026] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [sym_plusplus] = ACTIONS(5712),
    [anon_sym_BSLASHoplus] = ACTIONS(5712),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5712),
    [anon_sym_u2295] = ACTIONS(5712),
    [anon_sym_BSLASHominus] = ACTIONS(5712),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2296] = ACTIONS(5712),
    [sym_mod] = ACTIONS(5714),
    [sym_modmod] = ACTIONS(5712),
    [sym_vert] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_u2016] = ACTIONS(5712),
    [sym_minusminus] = ACTIONS(5712),
    [sym_amp] = ACTIONS(5714),
    [sym_ampamp] = ACTIONS(5712),
    [anon_sym_BSLASHodot] = ACTIONS(5712),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5712),
    [anon_sym_u2299] = ACTIONS(5712),
    [anon_sym_BSLASHoslash] = ACTIONS(5712),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5712),
    [anon_sym_u2298] = ACTIONS(5712),
    [anon_sym_BSLASHotimes] = ACTIONS(5712),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5712),
    [anon_sym_u2297] = ACTIONS(5712),
    [sym_mul] = ACTIONS(5714),
    [sym_mulmul] = ACTIONS(5712),
    [sym_slash] = ACTIONS(5714),
    [sym_slashslash] = ACTIONS(5712),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5712),
    [anon_sym_u25ef] = ACTIONS(5712),
    [anon_sym_BSLASHbullet] = ACTIONS(5712),
    [anon_sym_u25cf] = ACTIONS(5712),
    [anon_sym_BSLASHdiv] = ACTIONS(5712),
    [anon_sym_u00f7] = ACTIONS(5712),
    [anon_sym_BSLASHcirc] = ACTIONS(5712),
    [anon_sym_u2218] = ACTIONS(5712),
    [anon_sym_BSLASHstar] = ACTIONS(5712),
    [anon_sym_u22c6] = ACTIONS(5712),
    [anon_sym_u203c] = ACTIONS(5712),
    [sym_hashhash] = ACTIONS(5712),
    [sym_dol] = ACTIONS(5714),
    [sym_doldol] = ACTIONS(5712),
    [anon_sym_QMARK_QMARK] = ACTIONS(5712),
    [anon_sym_u2047] = ACTIONS(5712),
    [anon_sym_BSLASHsqcap] = ACTIONS(5712),
    [anon_sym_u2293] = ACTIONS(5712),
    [anon_sym_BSLASHsqcup] = ACTIONS(5712),
    [anon_sym_u2294] = ACTIONS(5712),
    [anon_sym_BSLASHuplus] = ACTIONS(5712),
    [anon_sym_u228e] = ACTIONS(5712),
    [anon_sym_BSLASHX] = ACTIONS(5712),
    [anon_sym_BSLASHtimes] = ACTIONS(5712),
    [anon_sym_u00d7] = ACTIONS(5712),
    [anon_sym_BSLASHwr] = ACTIONS(5712),
    [anon_sym_u2240] = ACTIONS(5712),
    [anon_sym_BSLASHcdot] = ACTIONS(5712),
    [anon_sym_u22c5] = ACTIONS(5712),
    [sym_pow] = ACTIONS(5714),
    [sym_powpow] = ACTIONS(5712),
    [anon_sym_CARET_PLUS] = ACTIONS(5712),
    [anon_sym_u207a] = ACTIONS(5712),
    [sym_asterisk] = ACTIONS(5712),
    [sym_sup_hash] = ACTIONS(5712),
    [sym_prime] = ACTIONS(5712),
    [sym__bullet] = ACTIONS(5712),
    [sym__dedent] = ACTIONS(5712),
    [sym__double_excl] = ACTIONS(5712),
  },
  [3351] = {
    [sym_block_comment] = STATE(3351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5710),
    [anon_sym_u2208] = ACTIONS(5708),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_u25a1] = ACTIONS(5708),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5708),
    [anon_sym_u2227] = ACTIONS(5708),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5708),
    [anon_sym_u2228] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_BANG] = ACTIONS(5708),
    [anon_sym_BSLASHo] = ACTIONS(5710),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27f9] = ACTIONS(5708),
    [anon_sym_u21d2] = ACTIONS(5708),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5708),
    [anon_sym_u21f8] = ACTIONS(5708),
    [anon_sym_u2945] = ACTIONS(5708),
    [anon_sym_BSLASHequiv] = ACTIONS(5708),
    [anon_sym_u2261] = ACTIONS(5708),
    [anon_sym_LT_EQ_GT] = ACTIONS(5708),
    [anon_sym_u27fa] = ACTIONS(5708),
    [anon_sym_u21d4] = ACTIONS(5708),
    [anon_sym_TILDE_GT] = ACTIONS(5708),
    [anon_sym_u21dd] = ACTIONS(5708),
    [anon_sym_u219d] = ACTIONS(5708),
    [anon_sym_BSLASHland] = ACTIONS(5708),
    [anon_sym_BSLASHlor] = ACTIONS(5708),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2254] = ACTIONS(5708),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5708),
    [anon_sym_u2a74] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_u2260] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [sym_gt] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_EQ_LT] = ACTIONS(5708),
    [anon_sym_BSLASHleq] = ACTIONS(5708),
    [anon_sym_u2264] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_BSLASHgeq] = ACTIONS(5708),
    [anon_sym_u2265] = ACTIONS(5708),
    [anon_sym_BSLASHapprox] = ACTIONS(5708),
    [anon_sym_u2248] = ACTIONS(5708),
    [anon_sym_PIPE_DASH] = ACTIONS(5708),
    [anon_sym_u22a2] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_u22a8] = ACTIONS(5708),
    [anon_sym_DASH_PIPE] = ACTIONS(5708),
    [anon_sym_u22a3] = ACTIONS(5708),
    [anon_sym_EQ_PIPE] = ACTIONS(5708),
    [anon_sym_u2ae4] = ACTIONS(5708),
    [anon_sym_BSLASHasymp] = ACTIONS(5708),
    [anon_sym_u224d] = ACTIONS(5708),
    [anon_sym_BSLASHcong] = ACTIONS(5708),
    [anon_sym_u2245] = ACTIONS(5708),
    [anon_sym_BSLASHdoteq] = ACTIONS(5708),
    [anon_sym_u2250] = ACTIONS(5708),
    [anon_sym_BSLASHgg] = ACTIONS(5708),
    [anon_sym_u226b] = ACTIONS(5708),
    [anon_sym_BSLASHll] = ACTIONS(5708),
    [anon_sym_u226a] = ACTIONS(5708),
    [anon_sym_BSLASHnotin] = ACTIONS(5708),
    [anon_sym_u2209] = ACTIONS(5708),
    [anon_sym_BSLASHprec] = ACTIONS(5710),
    [anon_sym_u227a] = ACTIONS(5708),
    [anon_sym_BSLASHsucc] = ACTIONS(5710),
    [anon_sym_u227b] = ACTIONS(5708),
    [anon_sym_BSLASHpreceq] = ACTIONS(5708),
    [anon_sym_u2aaf] = ACTIONS(5708),
    [anon_sym_BSLASHsucceq] = ACTIONS(5708),
    [anon_sym_u2ab0] = ACTIONS(5708),
    [anon_sym_BSLASHpropto] = ACTIONS(5708),
    [anon_sym_u221d] = ACTIONS(5708),
    [anon_sym_BSLASHsim] = ACTIONS(5710),
    [anon_sym_u223c] = ACTIONS(5708),
    [anon_sym_BSLASHsimeq] = ACTIONS(5708),
    [anon_sym_u2243] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5710),
    [anon_sym_u228f] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5710),
    [anon_sym_u2290] = ACTIONS(5708),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5708),
    [anon_sym_u2291] = ACTIONS(5708),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5708),
    [anon_sym_u2292] = ACTIONS(5708),
    [anon_sym_BSLASHsubset] = ACTIONS(5710),
    [anon_sym_u2282] = ACTIONS(5708),
    [anon_sym_BSLASHsupset] = ACTIONS(5710),
    [anon_sym_u2283] = ACTIONS(5708),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5708),
    [anon_sym_u2286] = ACTIONS(5708),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5708),
    [anon_sym_u2287] = ACTIONS(5708),
    [sym_compose] = ACTIONS(5708),
    [sym_map_to] = ACTIONS(5708),
    [sym_map_from] = ACTIONS(5708),
    [sym_setminus] = ACTIONS(5710),
    [anon_sym_BSLASHcap] = ACTIONS(5708),
    [anon_sym_BSLASHintersect] = ACTIONS(5708),
    [anon_sym_u2229] = ACTIONS(5708),
    [anon_sym_BSLASHcup] = ACTIONS(5708),
    [anon_sym_BSLASHunion] = ACTIONS(5708),
    [anon_sym_u222a] = ACTIONS(5708),
    [anon_sym_DOT_DOT] = ACTIONS(5710),
    [anon_sym_u2025] = ACTIONS(5708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5708),
    [anon_sym_u2026] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [sym_plusplus] = ACTIONS(5708),
    [anon_sym_BSLASHoplus] = ACTIONS(5708),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5708),
    [anon_sym_u2295] = ACTIONS(5708),
    [anon_sym_BSLASHominus] = ACTIONS(5708),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2296] = ACTIONS(5708),
    [sym_mod] = ACTIONS(5710),
    [sym_modmod] = ACTIONS(5708),
    [sym_vert] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_u2016] = ACTIONS(5708),
    [sym_minusminus] = ACTIONS(5708),
    [sym_amp] = ACTIONS(5710),
    [sym_ampamp] = ACTIONS(5708),
    [anon_sym_BSLASHodot] = ACTIONS(5708),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5708),
    [anon_sym_u2299] = ACTIONS(5708),
    [anon_sym_BSLASHoslash] = ACTIONS(5708),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5708),
    [anon_sym_u2298] = ACTIONS(5708),
    [anon_sym_BSLASHotimes] = ACTIONS(5708),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5708),
    [anon_sym_u2297] = ACTIONS(5708),
    [sym_mul] = ACTIONS(5710),
    [sym_mulmul] = ACTIONS(5708),
    [sym_slash] = ACTIONS(5710),
    [sym_slashslash] = ACTIONS(5708),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5708),
    [anon_sym_u25ef] = ACTIONS(5708),
    [anon_sym_BSLASHbullet] = ACTIONS(5708),
    [anon_sym_u25cf] = ACTIONS(5708),
    [anon_sym_BSLASHdiv] = ACTIONS(5708),
    [anon_sym_u00f7] = ACTIONS(5708),
    [anon_sym_BSLASHcirc] = ACTIONS(5708),
    [anon_sym_u2218] = ACTIONS(5708),
    [anon_sym_BSLASHstar] = ACTIONS(5708),
    [anon_sym_u22c6] = ACTIONS(5708),
    [anon_sym_u203c] = ACTIONS(5708),
    [sym_hashhash] = ACTIONS(5708),
    [sym_dol] = ACTIONS(5710),
    [sym_doldol] = ACTIONS(5708),
    [anon_sym_QMARK_QMARK] = ACTIONS(5708),
    [anon_sym_u2047] = ACTIONS(5708),
    [anon_sym_BSLASHsqcap] = ACTIONS(5708),
    [anon_sym_u2293] = ACTIONS(5708),
    [anon_sym_BSLASHsqcup] = ACTIONS(5708),
    [anon_sym_u2294] = ACTIONS(5708),
    [anon_sym_BSLASHuplus] = ACTIONS(5708),
    [anon_sym_u228e] = ACTIONS(5708),
    [anon_sym_BSLASHX] = ACTIONS(5708),
    [anon_sym_BSLASHtimes] = ACTIONS(5708),
    [anon_sym_u00d7] = ACTIONS(5708),
    [anon_sym_BSLASHwr] = ACTIONS(5708),
    [anon_sym_u2240] = ACTIONS(5708),
    [anon_sym_BSLASHcdot] = ACTIONS(5708),
    [anon_sym_u22c5] = ACTIONS(5708),
    [sym_pow] = ACTIONS(5710),
    [sym_powpow] = ACTIONS(5708),
    [anon_sym_CARET_PLUS] = ACTIONS(5708),
    [anon_sym_u207a] = ACTIONS(5708),
    [sym_asterisk] = ACTIONS(5708),
    [sym_sup_hash] = ACTIONS(5708),
    [sym_prime] = ACTIONS(5708),
    [sym__bullet] = ACTIONS(5708),
    [sym__dedent] = ACTIONS(5708),
    [sym__double_excl] = ACTIONS(5708),
  },
  [3352] = {
    [sym_block_comment] = STATE(3352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BANG] = ACTIONS(5694),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__bullet] = ACTIONS(5704),
    [sym__dedent] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [3353] = {
    [sym_block_comment] = STATE(3353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5702),
    [anon_sym_u2208] = ACTIONS(5700),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5700),
    [anon_sym_u25a1] = ACTIONS(5700),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5700),
    [anon_sym_u2227] = ACTIONS(5700),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5700),
    [anon_sym_u2228] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(6116),
    [anon_sym_LBRACK] = ACTIONS(5702),
    [anon_sym_BSLASHo] = ACTIONS(5702),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27f9] = ACTIONS(5700),
    [anon_sym_u21d2] = ACTIONS(5700),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5700),
    [anon_sym_u21f8] = ACTIONS(5700),
    [anon_sym_u2945] = ACTIONS(5700),
    [anon_sym_BSLASHequiv] = ACTIONS(5700),
    [anon_sym_u2261] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5700),
    [anon_sym_u27fa] = ACTIONS(5700),
    [anon_sym_u21d4] = ACTIONS(5700),
    [anon_sym_TILDE_GT] = ACTIONS(5700),
    [anon_sym_u21dd] = ACTIONS(5700),
    [anon_sym_u219d] = ACTIONS(5700),
    [anon_sym_BSLASHland] = ACTIONS(5700),
    [anon_sym_BSLASHlor] = ACTIONS(5700),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2254] = ACTIONS(5700),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5700),
    [anon_sym_u2a74] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_POUND] = ACTIONS(5702),
    [anon_sym_u2260] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [sym_gt] = ACTIONS(5702),
    [anon_sym_LT_EQ] = ACTIONS(5702),
    [anon_sym_EQ_LT] = ACTIONS(5700),
    [anon_sym_BSLASHleq] = ACTIONS(5700),
    [anon_sym_u2264] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_BSLASHgeq] = ACTIONS(5700),
    [anon_sym_u2265] = ACTIONS(5700),
    [anon_sym_BSLASHapprox] = ACTIONS(5700),
    [anon_sym_u2248] = ACTIONS(5700),
    [anon_sym_PIPE_DASH] = ACTIONS(5700),
    [anon_sym_u22a2] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_u22a8] = ACTIONS(5700),
    [anon_sym_DASH_PIPE] = ACTIONS(5700),
    [anon_sym_u22a3] = ACTIONS(5700),
    [anon_sym_EQ_PIPE] = ACTIONS(5700),
    [anon_sym_u2ae4] = ACTIONS(5700),
    [anon_sym_BSLASHasymp] = ACTIONS(5700),
    [anon_sym_u224d] = ACTIONS(5700),
    [anon_sym_BSLASHcong] = ACTIONS(5700),
    [anon_sym_u2245] = ACTIONS(5700),
    [anon_sym_BSLASHdoteq] = ACTIONS(5700),
    [anon_sym_u2250] = ACTIONS(5700),
    [anon_sym_BSLASHgg] = ACTIONS(5700),
    [anon_sym_u226b] = ACTIONS(5700),
    [anon_sym_BSLASHll] = ACTIONS(5700),
    [anon_sym_u226a] = ACTIONS(5700),
    [anon_sym_BSLASHnotin] = ACTIONS(5700),
    [anon_sym_u2209] = ACTIONS(5700),
    [anon_sym_BSLASHprec] = ACTIONS(5702),
    [anon_sym_u227a] = ACTIONS(5700),
    [anon_sym_BSLASHsucc] = ACTIONS(5702),
    [anon_sym_u227b] = ACTIONS(5700),
    [anon_sym_BSLASHpreceq] = ACTIONS(5700),
    [anon_sym_u2aaf] = ACTIONS(5700),
    [anon_sym_BSLASHsucceq] = ACTIONS(5700),
    [anon_sym_u2ab0] = ACTIONS(5700),
    [anon_sym_BSLASHpropto] = ACTIONS(5700),
    [anon_sym_u221d] = ACTIONS(5700),
    [anon_sym_BSLASHsim] = ACTIONS(5702),
    [anon_sym_u223c] = ACTIONS(5700),
    [anon_sym_BSLASHsimeq] = ACTIONS(5700),
    [anon_sym_u2243] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5702),
    [anon_sym_u228f] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5702),
    [anon_sym_u2290] = ACTIONS(5700),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5700),
    [anon_sym_u2291] = ACTIONS(5700),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5700),
    [anon_sym_u2292] = ACTIONS(5700),
    [anon_sym_BSLASHsubset] = ACTIONS(5702),
    [anon_sym_u2282] = ACTIONS(5700),
    [anon_sym_BSLASHsupset] = ACTIONS(5702),
    [anon_sym_u2283] = ACTIONS(5700),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5700),
    [anon_sym_u2286] = ACTIONS(5700),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5700),
    [anon_sym_u2287] = ACTIONS(5700),
    [sym_compose] = ACTIONS(5700),
    [sym_map_to] = ACTIONS(5700),
    [sym_map_from] = ACTIONS(5700),
    [sym_setminus] = ACTIONS(5702),
    [anon_sym_BSLASHcap] = ACTIONS(5700),
    [anon_sym_BSLASHintersect] = ACTIONS(5700),
    [anon_sym_u2229] = ACTIONS(5700),
    [anon_sym_BSLASHcup] = ACTIONS(5700),
    [anon_sym_BSLASHunion] = ACTIONS(5700),
    [anon_sym_u222a] = ACTIONS(5700),
    [anon_sym_DOT_DOT] = ACTIONS(5702),
    [anon_sym_u2025] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5700),
    [anon_sym_u2026] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [sym_plusplus] = ACTIONS(5700),
    [anon_sym_BSLASHoplus] = ACTIONS(5700),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5700),
    [anon_sym_u2295] = ACTIONS(5700),
    [anon_sym_BSLASHominus] = ACTIONS(5700),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2296] = ACTIONS(5700),
    [sym_mod] = ACTIONS(5702),
    [sym_modmod] = ACTIONS(5700),
    [sym_vert] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5700),
    [anon_sym_u2016] = ACTIONS(5700),
    [sym_minusminus] = ACTIONS(5700),
    [sym_amp] = ACTIONS(5702),
    [sym_ampamp] = ACTIONS(5700),
    [anon_sym_BSLASHodot] = ACTIONS(5700),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5700),
    [anon_sym_u2299] = ACTIONS(5700),
    [anon_sym_BSLASHoslash] = ACTIONS(5700),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5700),
    [anon_sym_u2298] = ACTIONS(5700),
    [anon_sym_BSLASHotimes] = ACTIONS(5700),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5700),
    [anon_sym_u2297] = ACTIONS(5700),
    [sym_mul] = ACTIONS(5702),
    [sym_mulmul] = ACTIONS(5700),
    [sym_slash] = ACTIONS(5702),
    [sym_slashslash] = ACTIONS(5700),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5700),
    [anon_sym_u25ef] = ACTIONS(5700),
    [anon_sym_BSLASHbullet] = ACTIONS(5700),
    [anon_sym_u25cf] = ACTIONS(5700),
    [anon_sym_BSLASHdiv] = ACTIONS(5700),
    [anon_sym_u00f7] = ACTIONS(5700),
    [anon_sym_BSLASHcirc] = ACTIONS(5700),
    [anon_sym_u2218] = ACTIONS(5700),
    [anon_sym_BSLASHstar] = ACTIONS(5700),
    [anon_sym_u22c6] = ACTIONS(5700),
    [anon_sym_u203c] = ACTIONS(5700),
    [sym_hashhash] = ACTIONS(5700),
    [sym_dol] = ACTIONS(5702),
    [sym_doldol] = ACTIONS(5700),
    [anon_sym_QMARK_QMARK] = ACTIONS(5700),
    [anon_sym_u2047] = ACTIONS(5700),
    [anon_sym_BSLASHsqcap] = ACTIONS(5700),
    [anon_sym_u2293] = ACTIONS(5700),
    [anon_sym_BSLASHsqcup] = ACTIONS(5700),
    [anon_sym_u2294] = ACTIONS(5700),
    [anon_sym_BSLASHuplus] = ACTIONS(5700),
    [anon_sym_u228e] = ACTIONS(5700),
    [anon_sym_BSLASHX] = ACTIONS(5700),
    [anon_sym_BSLASHtimes] = ACTIONS(5700),
    [anon_sym_u00d7] = ACTIONS(5700),
    [anon_sym_BSLASHwr] = ACTIONS(5700),
    [anon_sym_u2240] = ACTIONS(5700),
    [anon_sym_BSLASHcdot] = ACTIONS(5700),
    [anon_sym_u22c5] = ACTIONS(5700),
    [sym_pow] = ACTIONS(5702),
    [sym_powpow] = ACTIONS(5700),
    [anon_sym_CARET_PLUS] = ACTIONS(5700),
    [anon_sym_u207a] = ACTIONS(5700),
    [sym_asterisk] = ACTIONS(5700),
    [sym_sup_hash] = ACTIONS(5700),
    [sym_prime] = ACTIONS(5700),
    [sym__bullet] = ACTIONS(5700),
    [sym__dedent] = ACTIONS(5700),
    [sym__double_excl] = ACTIONS(5700),
  },
  [3354] = {
    [sym_block_comment] = STATE(3354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5898),
    [anon_sym_u2208] = ACTIONS(5896),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5896),
    [anon_sym_u25a1] = ACTIONS(5896),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5896),
    [anon_sym_u2227] = ACTIONS(5896),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5896),
    [anon_sym_u2228] = ACTIONS(5896),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_BSLASHo] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5898),
    [anon_sym_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27f9] = ACTIONS(5896),
    [anon_sym_u21d2] = ACTIONS(5896),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5896),
    [anon_sym_u21f8] = ACTIONS(5896),
    [anon_sym_u2945] = ACTIONS(5896),
    [anon_sym_BSLASHequiv] = ACTIONS(5896),
    [anon_sym_u2261] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5896),
    [anon_sym_u27fa] = ACTIONS(5896),
    [anon_sym_u21d4] = ACTIONS(5896),
    [anon_sym_TILDE_GT] = ACTIONS(5896),
    [anon_sym_u21dd] = ACTIONS(5896),
    [anon_sym_u219d] = ACTIONS(5896),
    [anon_sym_BSLASHland] = ACTIONS(5896),
    [anon_sym_BSLASHlor] = ACTIONS(5896),
    [anon_sym_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2254] = ACTIONS(5896),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5896),
    [anon_sym_u2a74] = ACTIONS(5896),
    [anon_sym_SLASH_EQ] = ACTIONS(5896),
    [anon_sym_POUND] = ACTIONS(5898),
    [anon_sym_u2260] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5898),
    [sym_gt] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5898),
    [anon_sym_EQ_LT] = ACTIONS(5896),
    [anon_sym_BSLASHleq] = ACTIONS(5896),
    [anon_sym_u2264] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_BSLASHgeq] = ACTIONS(5896),
    [anon_sym_u2265] = ACTIONS(5896),
    [anon_sym_BSLASHapprox] = ACTIONS(5896),
    [anon_sym_u2248] = ACTIONS(5896),
    [anon_sym_PIPE_DASH] = ACTIONS(5896),
    [anon_sym_u22a2] = ACTIONS(5896),
    [anon_sym_PIPE_EQ] = ACTIONS(5896),
    [anon_sym_u22a8] = ACTIONS(5896),
    [anon_sym_DASH_PIPE] = ACTIONS(5896),
    [anon_sym_u22a3] = ACTIONS(5896),
    [anon_sym_EQ_PIPE] = ACTIONS(5896),
    [anon_sym_u2ae4] = ACTIONS(5896),
    [anon_sym_BSLASHasymp] = ACTIONS(5896),
    [anon_sym_u224d] = ACTIONS(5896),
    [anon_sym_BSLASHcong] = ACTIONS(5896),
    [anon_sym_u2245] = ACTIONS(5896),
    [anon_sym_BSLASHdoteq] = ACTIONS(5896),
    [anon_sym_u2250] = ACTIONS(5896),
    [anon_sym_BSLASHgg] = ACTIONS(5896),
    [anon_sym_u226b] = ACTIONS(5896),
    [anon_sym_BSLASHll] = ACTIONS(5896),
    [anon_sym_u226a] = ACTIONS(5896),
    [anon_sym_BSLASHnotin] = ACTIONS(5896),
    [anon_sym_u2209] = ACTIONS(5896),
    [anon_sym_BSLASHprec] = ACTIONS(5898),
    [anon_sym_u227a] = ACTIONS(5896),
    [anon_sym_BSLASHsucc] = ACTIONS(5898),
    [anon_sym_u227b] = ACTIONS(5896),
    [anon_sym_BSLASHpreceq] = ACTIONS(5896),
    [anon_sym_u2aaf] = ACTIONS(5896),
    [anon_sym_BSLASHsucceq] = ACTIONS(5896),
    [anon_sym_u2ab0] = ACTIONS(5896),
    [anon_sym_BSLASHpropto] = ACTIONS(5896),
    [anon_sym_u221d] = ACTIONS(5896),
    [anon_sym_BSLASHsim] = ACTIONS(5898),
    [anon_sym_u223c] = ACTIONS(5896),
    [anon_sym_BSLASHsimeq] = ACTIONS(5896),
    [anon_sym_u2243] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5898),
    [anon_sym_u228f] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5898),
    [anon_sym_u2290] = ACTIONS(5896),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5896),
    [anon_sym_u2291] = ACTIONS(5896),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5896),
    [anon_sym_u2292] = ACTIONS(5896),
    [anon_sym_BSLASHsubset] = ACTIONS(5898),
    [anon_sym_u2282] = ACTIONS(5896),
    [anon_sym_BSLASHsupset] = ACTIONS(5898),
    [anon_sym_u2283] = ACTIONS(5896),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5896),
    [anon_sym_u2286] = ACTIONS(5896),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5896),
    [anon_sym_u2287] = ACTIONS(5896),
    [sym_compose] = ACTIONS(5896),
    [sym_map_to] = ACTIONS(5896),
    [sym_map_from] = ACTIONS(5896),
    [sym_setminus] = ACTIONS(5898),
    [anon_sym_BSLASHcap] = ACTIONS(5896),
    [anon_sym_BSLASHintersect] = ACTIONS(5896),
    [anon_sym_u2229] = ACTIONS(5896),
    [anon_sym_BSLASHcup] = ACTIONS(5896),
    [anon_sym_BSLASHunion] = ACTIONS(5896),
    [anon_sym_u222a] = ACTIONS(5896),
    [anon_sym_DOT_DOT] = ACTIONS(5898),
    [anon_sym_u2025] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5896),
    [anon_sym_u2026] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5898),
    [sym_plusplus] = ACTIONS(5896),
    [anon_sym_BSLASHoplus] = ACTIONS(5896),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5896),
    [anon_sym_u2295] = ACTIONS(5896),
    [anon_sym_BSLASHominus] = ACTIONS(5896),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2296] = ACTIONS(5896),
    [sym_mod] = ACTIONS(5898),
    [sym_modmod] = ACTIONS(5896),
    [sym_vert] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5896),
    [anon_sym_u2016] = ACTIONS(5896),
    [sym_minusminus] = ACTIONS(5896),
    [sym_amp] = ACTIONS(5898),
    [sym_ampamp] = ACTIONS(5896),
    [anon_sym_BSLASHodot] = ACTIONS(5896),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5896),
    [anon_sym_u2299] = ACTIONS(5896),
    [anon_sym_BSLASHoslash] = ACTIONS(5896),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5896),
    [anon_sym_u2298] = ACTIONS(5896),
    [anon_sym_BSLASHotimes] = ACTIONS(5896),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5896),
    [anon_sym_u2297] = ACTIONS(5896),
    [sym_mul] = ACTIONS(5898),
    [sym_mulmul] = ACTIONS(5896),
    [sym_slash] = ACTIONS(5898),
    [sym_slashslash] = ACTIONS(5896),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5896),
    [anon_sym_u25ef] = ACTIONS(5896),
    [anon_sym_BSLASHbullet] = ACTIONS(5896),
    [anon_sym_u25cf] = ACTIONS(5896),
    [anon_sym_BSLASHdiv] = ACTIONS(5896),
    [anon_sym_u00f7] = ACTIONS(5896),
    [anon_sym_BSLASHcirc] = ACTIONS(5896),
    [anon_sym_u2218] = ACTIONS(5896),
    [anon_sym_BSLASHstar] = ACTIONS(5896),
    [anon_sym_u22c6] = ACTIONS(5896),
    [anon_sym_u203c] = ACTIONS(5896),
    [sym_hashhash] = ACTIONS(5896),
    [sym_dol] = ACTIONS(5898),
    [sym_doldol] = ACTIONS(5896),
    [anon_sym_QMARK_QMARK] = ACTIONS(5896),
    [anon_sym_u2047] = ACTIONS(5896),
    [anon_sym_BSLASHsqcap] = ACTIONS(5896),
    [anon_sym_u2293] = ACTIONS(5896),
    [anon_sym_BSLASHsqcup] = ACTIONS(5896),
    [anon_sym_u2294] = ACTIONS(5896),
    [anon_sym_BSLASHuplus] = ACTIONS(5896),
    [anon_sym_u228e] = ACTIONS(5896),
    [anon_sym_BSLASHX] = ACTIONS(5896),
    [anon_sym_BSLASHtimes] = ACTIONS(5896),
    [anon_sym_u00d7] = ACTIONS(5896),
    [anon_sym_BSLASHwr] = ACTIONS(5896),
    [anon_sym_u2240] = ACTIONS(5896),
    [anon_sym_BSLASHcdot] = ACTIONS(5896),
    [anon_sym_u22c5] = ACTIONS(5896),
    [sym_pow] = ACTIONS(5898),
    [sym_powpow] = ACTIONS(5896),
    [anon_sym_CARET_PLUS] = ACTIONS(5896),
    [anon_sym_u207a] = ACTIONS(5896),
    [sym_asterisk] = ACTIONS(5896),
    [sym_sup_hash] = ACTIONS(5896),
    [sym_prime] = ACTIONS(5896),
    [sym__bullet] = ACTIONS(5896),
    [sym__dedent] = ACTIONS(5896),
    [sym__double_excl] = ACTIONS(5896),
  },
  [3355] = {
    [sym_block_comment] = STATE(3355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5886),
    [anon_sym_u2208] = ACTIONS(5884),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5884),
    [anon_sym_u25a1] = ACTIONS(5884),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5884),
    [anon_sym_u2227] = ACTIONS(5884),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5884),
    [anon_sym_u2228] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_BSLASHo] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27f9] = ACTIONS(5884),
    [anon_sym_u21d2] = ACTIONS(5884),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5884),
    [anon_sym_u21f8] = ACTIONS(5884),
    [anon_sym_u2945] = ACTIONS(5884),
    [anon_sym_BSLASHequiv] = ACTIONS(5884),
    [anon_sym_u2261] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5884),
    [anon_sym_u27fa] = ACTIONS(5884),
    [anon_sym_u21d4] = ACTIONS(5884),
    [anon_sym_TILDE_GT] = ACTIONS(5884),
    [anon_sym_u21dd] = ACTIONS(5884),
    [anon_sym_u219d] = ACTIONS(5884),
    [anon_sym_BSLASHland] = ACTIONS(5884),
    [anon_sym_BSLASHlor] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2254] = ACTIONS(5884),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5884),
    [anon_sym_u2a74] = ACTIONS(5884),
    [anon_sym_SLASH_EQ] = ACTIONS(5884),
    [anon_sym_POUND] = ACTIONS(5886),
    [anon_sym_u2260] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5886),
    [sym_gt] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5886),
    [anon_sym_EQ_LT] = ACTIONS(5884),
    [anon_sym_BSLASHleq] = ACTIONS(5884),
    [anon_sym_u2264] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_BSLASHgeq] = ACTIONS(5884),
    [anon_sym_u2265] = ACTIONS(5884),
    [anon_sym_BSLASHapprox] = ACTIONS(5884),
    [anon_sym_u2248] = ACTIONS(5884),
    [anon_sym_PIPE_DASH] = ACTIONS(5884),
    [anon_sym_u22a2] = ACTIONS(5884),
    [anon_sym_PIPE_EQ] = ACTIONS(5884),
    [anon_sym_u22a8] = ACTIONS(5884),
    [anon_sym_DASH_PIPE] = ACTIONS(5884),
    [anon_sym_u22a3] = ACTIONS(5884),
    [anon_sym_EQ_PIPE] = ACTIONS(5884),
    [anon_sym_u2ae4] = ACTIONS(5884),
    [anon_sym_BSLASHasymp] = ACTIONS(5884),
    [anon_sym_u224d] = ACTIONS(5884),
    [anon_sym_BSLASHcong] = ACTIONS(5884),
    [anon_sym_u2245] = ACTIONS(5884),
    [anon_sym_BSLASHdoteq] = ACTIONS(5884),
    [anon_sym_u2250] = ACTIONS(5884),
    [anon_sym_BSLASHgg] = ACTIONS(5884),
    [anon_sym_u226b] = ACTIONS(5884),
    [anon_sym_BSLASHll] = ACTIONS(5884),
    [anon_sym_u226a] = ACTIONS(5884),
    [anon_sym_BSLASHnotin] = ACTIONS(5884),
    [anon_sym_u2209] = ACTIONS(5884),
    [anon_sym_BSLASHprec] = ACTIONS(5886),
    [anon_sym_u227a] = ACTIONS(5884),
    [anon_sym_BSLASHsucc] = ACTIONS(5886),
    [anon_sym_u227b] = ACTIONS(5884),
    [anon_sym_BSLASHpreceq] = ACTIONS(5884),
    [anon_sym_u2aaf] = ACTIONS(5884),
    [anon_sym_BSLASHsucceq] = ACTIONS(5884),
    [anon_sym_u2ab0] = ACTIONS(5884),
    [anon_sym_BSLASHpropto] = ACTIONS(5884),
    [anon_sym_u221d] = ACTIONS(5884),
    [anon_sym_BSLASHsim] = ACTIONS(5886),
    [anon_sym_u223c] = ACTIONS(5884),
    [anon_sym_BSLASHsimeq] = ACTIONS(5884),
    [anon_sym_u2243] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5886),
    [anon_sym_u228f] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5886),
    [anon_sym_u2290] = ACTIONS(5884),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5884),
    [anon_sym_u2291] = ACTIONS(5884),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5884),
    [anon_sym_u2292] = ACTIONS(5884),
    [anon_sym_BSLASHsubset] = ACTIONS(5886),
    [anon_sym_u2282] = ACTIONS(5884),
    [anon_sym_BSLASHsupset] = ACTIONS(5886),
    [anon_sym_u2283] = ACTIONS(5884),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5884),
    [anon_sym_u2286] = ACTIONS(5884),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5884),
    [anon_sym_u2287] = ACTIONS(5884),
    [sym_compose] = ACTIONS(5884),
    [sym_map_to] = ACTIONS(5884),
    [sym_map_from] = ACTIONS(5884),
    [sym_setminus] = ACTIONS(5886),
    [anon_sym_BSLASHcap] = ACTIONS(5884),
    [anon_sym_BSLASHintersect] = ACTIONS(5884),
    [anon_sym_u2229] = ACTIONS(5884),
    [anon_sym_BSLASHcup] = ACTIONS(5884),
    [anon_sym_BSLASHunion] = ACTIONS(5884),
    [anon_sym_u222a] = ACTIONS(5884),
    [anon_sym_DOT_DOT] = ACTIONS(5886),
    [anon_sym_u2025] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5884),
    [anon_sym_u2026] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5886),
    [sym_plusplus] = ACTIONS(5884),
    [anon_sym_BSLASHoplus] = ACTIONS(5884),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5884),
    [anon_sym_u2295] = ACTIONS(5884),
    [anon_sym_BSLASHominus] = ACTIONS(5884),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2296] = ACTIONS(5884),
    [sym_mod] = ACTIONS(5886),
    [sym_modmod] = ACTIONS(5884),
    [sym_vert] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_u2016] = ACTIONS(5884),
    [sym_minusminus] = ACTIONS(5884),
    [sym_amp] = ACTIONS(5886),
    [sym_ampamp] = ACTIONS(5884),
    [anon_sym_BSLASHodot] = ACTIONS(5884),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5884),
    [anon_sym_u2299] = ACTIONS(5884),
    [anon_sym_BSLASHoslash] = ACTIONS(5884),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5884),
    [anon_sym_u2298] = ACTIONS(5884),
    [anon_sym_BSLASHotimes] = ACTIONS(5884),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5884),
    [anon_sym_u2297] = ACTIONS(5884),
    [sym_mul] = ACTIONS(5886),
    [sym_mulmul] = ACTIONS(5884),
    [sym_slash] = ACTIONS(5886),
    [sym_slashslash] = ACTIONS(5884),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5884),
    [anon_sym_u25ef] = ACTIONS(5884),
    [anon_sym_BSLASHbullet] = ACTIONS(5884),
    [anon_sym_u25cf] = ACTIONS(5884),
    [anon_sym_BSLASHdiv] = ACTIONS(5884),
    [anon_sym_u00f7] = ACTIONS(5884),
    [anon_sym_BSLASHcirc] = ACTIONS(5884),
    [anon_sym_u2218] = ACTIONS(5884),
    [anon_sym_BSLASHstar] = ACTIONS(5884),
    [anon_sym_u22c6] = ACTIONS(5884),
    [anon_sym_u203c] = ACTIONS(5884),
    [sym_hashhash] = ACTIONS(5884),
    [sym_dol] = ACTIONS(5886),
    [sym_doldol] = ACTIONS(5884),
    [anon_sym_QMARK_QMARK] = ACTIONS(5884),
    [anon_sym_u2047] = ACTIONS(5884),
    [anon_sym_BSLASHsqcap] = ACTIONS(5884),
    [anon_sym_u2293] = ACTIONS(5884),
    [anon_sym_BSLASHsqcup] = ACTIONS(5884),
    [anon_sym_u2294] = ACTIONS(5884),
    [anon_sym_BSLASHuplus] = ACTIONS(5884),
    [anon_sym_u228e] = ACTIONS(5884),
    [anon_sym_BSLASHX] = ACTIONS(5884),
    [anon_sym_BSLASHtimes] = ACTIONS(5884),
    [anon_sym_u00d7] = ACTIONS(5884),
    [anon_sym_BSLASHwr] = ACTIONS(5884),
    [anon_sym_u2240] = ACTIONS(5884),
    [anon_sym_BSLASHcdot] = ACTIONS(5884),
    [anon_sym_u22c5] = ACTIONS(5884),
    [sym_pow] = ACTIONS(5886),
    [sym_powpow] = ACTIONS(5884),
    [anon_sym_CARET_PLUS] = ACTIONS(5884),
    [anon_sym_u207a] = ACTIONS(5884),
    [sym_asterisk] = ACTIONS(5884),
    [sym_sup_hash] = ACTIONS(5884),
    [sym_prime] = ACTIONS(5884),
    [sym__bullet] = ACTIONS(5884),
    [sym__dedent] = ACTIONS(5884),
    [sym__double_excl] = ACTIONS(5884),
  },
  [3356] = {
    [sym_block_comment] = STATE(3356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5738),
    [anon_sym_u2208] = ACTIONS(5736),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5736),
    [anon_sym_u25a1] = ACTIONS(5736),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5736),
    [anon_sym_u2227] = ACTIONS(5736),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5736),
    [anon_sym_u2228] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_BSLASHo] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27f9] = ACTIONS(5736),
    [anon_sym_u21d2] = ACTIONS(5736),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5736),
    [anon_sym_u21f8] = ACTIONS(5736),
    [anon_sym_u2945] = ACTIONS(5736),
    [anon_sym_BSLASHequiv] = ACTIONS(5736),
    [anon_sym_u2261] = ACTIONS(5736),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_u27fa] = ACTIONS(5736),
    [anon_sym_u21d4] = ACTIONS(5736),
    [anon_sym_TILDE_GT] = ACTIONS(5736),
    [anon_sym_u21dd] = ACTIONS(5736),
    [anon_sym_u219d] = ACTIONS(5736),
    [anon_sym_BSLASHland] = ACTIONS(5736),
    [anon_sym_BSLASHlor] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2254] = ACTIONS(5736),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5736),
    [anon_sym_u2a74] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_POUND] = ACTIONS(5738),
    [anon_sym_u2260] = ACTIONS(5736),
    [anon_sym_LT] = ACTIONS(5738),
    [sym_gt] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5738),
    [anon_sym_EQ_LT] = ACTIONS(5736),
    [anon_sym_BSLASHleq] = ACTIONS(5736),
    [anon_sym_u2264] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_BSLASHgeq] = ACTIONS(5736),
    [anon_sym_u2265] = ACTIONS(5736),
    [anon_sym_BSLASHapprox] = ACTIONS(5736),
    [anon_sym_u2248] = ACTIONS(5736),
    [anon_sym_PIPE_DASH] = ACTIONS(5736),
    [anon_sym_u22a2] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_u22a8] = ACTIONS(5736),
    [anon_sym_DASH_PIPE] = ACTIONS(5736),
    [anon_sym_u22a3] = ACTIONS(5736),
    [anon_sym_EQ_PIPE] = ACTIONS(5736),
    [anon_sym_u2ae4] = ACTIONS(5736),
    [anon_sym_BSLASHasymp] = ACTIONS(5736),
    [anon_sym_u224d] = ACTIONS(5736),
    [anon_sym_BSLASHcong] = ACTIONS(5736),
    [anon_sym_u2245] = ACTIONS(5736),
    [anon_sym_BSLASHdoteq] = ACTIONS(5736),
    [anon_sym_u2250] = ACTIONS(5736),
    [anon_sym_BSLASHgg] = ACTIONS(5736),
    [anon_sym_u226b] = ACTIONS(5736),
    [anon_sym_BSLASHll] = ACTIONS(5736),
    [anon_sym_u226a] = ACTIONS(5736),
    [anon_sym_BSLASHnotin] = ACTIONS(5736),
    [anon_sym_u2209] = ACTIONS(5736),
    [anon_sym_BSLASHprec] = ACTIONS(5738),
    [anon_sym_u227a] = ACTIONS(5736),
    [anon_sym_BSLASHsucc] = ACTIONS(5738),
    [anon_sym_u227b] = ACTIONS(5736),
    [anon_sym_BSLASHpreceq] = ACTIONS(5736),
    [anon_sym_u2aaf] = ACTIONS(5736),
    [anon_sym_BSLASHsucceq] = ACTIONS(5736),
    [anon_sym_u2ab0] = ACTIONS(5736),
    [anon_sym_BSLASHpropto] = ACTIONS(5736),
    [anon_sym_u221d] = ACTIONS(5736),
    [anon_sym_BSLASHsim] = ACTIONS(5738),
    [anon_sym_u223c] = ACTIONS(5736),
    [anon_sym_BSLASHsimeq] = ACTIONS(5736),
    [anon_sym_u2243] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5738),
    [anon_sym_u228f] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5738),
    [anon_sym_u2290] = ACTIONS(5736),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5736),
    [anon_sym_u2291] = ACTIONS(5736),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5736),
    [anon_sym_u2292] = ACTIONS(5736),
    [anon_sym_BSLASHsubset] = ACTIONS(5738),
    [anon_sym_u2282] = ACTIONS(5736),
    [anon_sym_BSLASHsupset] = ACTIONS(5738),
    [anon_sym_u2283] = ACTIONS(5736),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5736),
    [anon_sym_u2286] = ACTIONS(5736),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5736),
    [anon_sym_u2287] = ACTIONS(5736),
    [sym_compose] = ACTIONS(5736),
    [sym_map_to] = ACTIONS(5736),
    [sym_map_from] = ACTIONS(5736),
    [sym_setminus] = ACTIONS(5738),
    [anon_sym_BSLASHcap] = ACTIONS(5736),
    [anon_sym_BSLASHintersect] = ACTIONS(5736),
    [anon_sym_u2229] = ACTIONS(5736),
    [anon_sym_BSLASHcup] = ACTIONS(5736),
    [anon_sym_BSLASHunion] = ACTIONS(5736),
    [anon_sym_u222a] = ACTIONS(5736),
    [anon_sym_DOT_DOT] = ACTIONS(5738),
    [anon_sym_u2025] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_u2026] = ACTIONS(5736),
    [anon_sym_PLUS] = ACTIONS(5738),
    [sym_plusplus] = ACTIONS(5736),
    [anon_sym_BSLASHoplus] = ACTIONS(5736),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5736),
    [anon_sym_u2295] = ACTIONS(5736),
    [anon_sym_BSLASHominus] = ACTIONS(5736),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2296] = ACTIONS(5736),
    [sym_mod] = ACTIONS(5738),
    [sym_modmod] = ACTIONS(5736),
    [sym_vert] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_u2016] = ACTIONS(5736),
    [sym_minusminus] = ACTIONS(5736),
    [sym_amp] = ACTIONS(5738),
    [sym_ampamp] = ACTIONS(5736),
    [anon_sym_BSLASHodot] = ACTIONS(5736),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5736),
    [anon_sym_u2299] = ACTIONS(5736),
    [anon_sym_BSLASHoslash] = ACTIONS(5736),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5736),
    [anon_sym_u2298] = ACTIONS(5736),
    [anon_sym_BSLASHotimes] = ACTIONS(5736),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5736),
    [anon_sym_u2297] = ACTIONS(5736),
    [sym_mul] = ACTIONS(5738),
    [sym_mulmul] = ACTIONS(5736),
    [sym_slash] = ACTIONS(5738),
    [sym_slashslash] = ACTIONS(5736),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5736),
    [anon_sym_u25ef] = ACTIONS(5736),
    [anon_sym_BSLASHbullet] = ACTIONS(5736),
    [anon_sym_u25cf] = ACTIONS(5736),
    [anon_sym_BSLASHdiv] = ACTIONS(5736),
    [anon_sym_u00f7] = ACTIONS(5736),
    [anon_sym_BSLASHcirc] = ACTIONS(5736),
    [anon_sym_u2218] = ACTIONS(5736),
    [anon_sym_BSLASHstar] = ACTIONS(5736),
    [anon_sym_u22c6] = ACTIONS(5736),
    [anon_sym_u203c] = ACTIONS(5736),
    [sym_hashhash] = ACTIONS(5736),
    [sym_dol] = ACTIONS(5738),
    [sym_doldol] = ACTIONS(5736),
    [anon_sym_QMARK_QMARK] = ACTIONS(5736),
    [anon_sym_u2047] = ACTIONS(5736),
    [anon_sym_BSLASHsqcap] = ACTIONS(5736),
    [anon_sym_u2293] = ACTIONS(5736),
    [anon_sym_BSLASHsqcup] = ACTIONS(5736),
    [anon_sym_u2294] = ACTIONS(5736),
    [anon_sym_BSLASHuplus] = ACTIONS(5736),
    [anon_sym_u228e] = ACTIONS(5736),
    [anon_sym_BSLASHX] = ACTIONS(5736),
    [anon_sym_BSLASHtimes] = ACTIONS(5736),
    [anon_sym_u00d7] = ACTIONS(5736),
    [anon_sym_BSLASHwr] = ACTIONS(5736),
    [anon_sym_u2240] = ACTIONS(5736),
    [anon_sym_BSLASHcdot] = ACTIONS(5736),
    [anon_sym_u22c5] = ACTIONS(5736),
    [sym_pow] = ACTIONS(5738),
    [sym_powpow] = ACTIONS(5736),
    [anon_sym_CARET_PLUS] = ACTIONS(5736),
    [anon_sym_u207a] = ACTIONS(5736),
    [sym_asterisk] = ACTIONS(5736),
    [sym_sup_hash] = ACTIONS(5736),
    [sym_prime] = ACTIONS(5736),
    [sym__bullet] = ACTIONS(5736),
    [sym__dedent] = ACTIONS(5736),
    [sym__double_excl] = ACTIONS(5736),
  },
  [3357] = {
    [sym_block_comment] = STATE(3357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5665),
    [anon_sym_u2208] = ACTIONS(5663),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5663),
    [anon_sym_u25a1] = ACTIONS(5663),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5663),
    [anon_sym_u2227] = ACTIONS(5663),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5663),
    [anon_sym_u2228] = ACTIONS(5663),
    [anon_sym_LBRACK] = ACTIONS(5665),
    [anon_sym_BSLASHo] = ACTIONS(5665),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_EQ] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5665),
    [anon_sym_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27f9] = ACTIONS(5663),
    [anon_sym_u21d2] = ACTIONS(5663),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5663),
    [anon_sym_u21f8] = ACTIONS(5663),
    [anon_sym_u2945] = ACTIONS(5663),
    [anon_sym_BSLASHequiv] = ACTIONS(5663),
    [anon_sym_u2261] = ACTIONS(5663),
    [anon_sym_LT_EQ_GT] = ACTIONS(5663),
    [anon_sym_u27fa] = ACTIONS(5663),
    [anon_sym_u21d4] = ACTIONS(5663),
    [anon_sym_TILDE_GT] = ACTIONS(5663),
    [anon_sym_u21dd] = ACTIONS(5663),
    [anon_sym_u219d] = ACTIONS(5663),
    [anon_sym_BSLASHland] = ACTIONS(5663),
    [anon_sym_BSLASHlor] = ACTIONS(5663),
    [anon_sym_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2254] = ACTIONS(5663),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5663),
    [anon_sym_u2a74] = ACTIONS(5663),
    [anon_sym_SLASH_EQ] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(5665),
    [anon_sym_u2260] = ACTIONS(5663),
    [anon_sym_LT] = ACTIONS(5665),
    [sym_gt] = ACTIONS(5665),
    [anon_sym_LT_EQ] = ACTIONS(5665),
    [anon_sym_EQ_LT] = ACTIONS(5663),
    [anon_sym_BSLASHleq] = ACTIONS(5663),
    [anon_sym_u2264] = ACTIONS(5663),
    [anon_sym_GT_EQ] = ACTIONS(5663),
    [anon_sym_BSLASHgeq] = ACTIONS(5663),
    [anon_sym_u2265] = ACTIONS(5663),
    [anon_sym_BSLASHapprox] = ACTIONS(5663),
    [anon_sym_u2248] = ACTIONS(5663),
    [anon_sym_PIPE_DASH] = ACTIONS(5663),
    [anon_sym_u22a2] = ACTIONS(5663),
    [anon_sym_PIPE_EQ] = ACTIONS(5663),
    [anon_sym_u22a8] = ACTIONS(5663),
    [anon_sym_DASH_PIPE] = ACTIONS(5663),
    [anon_sym_u22a3] = ACTIONS(5663),
    [anon_sym_EQ_PIPE] = ACTIONS(5663),
    [anon_sym_u2ae4] = ACTIONS(5663),
    [anon_sym_BSLASHasymp] = ACTIONS(5663),
    [anon_sym_u224d] = ACTIONS(5663),
    [anon_sym_BSLASHcong] = ACTIONS(5663),
    [anon_sym_u2245] = ACTIONS(5663),
    [anon_sym_BSLASHdoteq] = ACTIONS(5663),
    [anon_sym_u2250] = ACTIONS(5663),
    [anon_sym_BSLASHgg] = ACTIONS(5663),
    [anon_sym_u226b] = ACTIONS(5663),
    [anon_sym_BSLASHll] = ACTIONS(5663),
    [anon_sym_u226a] = ACTIONS(5663),
    [anon_sym_BSLASHnotin] = ACTIONS(5663),
    [anon_sym_u2209] = ACTIONS(5663),
    [anon_sym_BSLASHprec] = ACTIONS(5665),
    [anon_sym_u227a] = ACTIONS(5663),
    [anon_sym_BSLASHsucc] = ACTIONS(5665),
    [anon_sym_u227b] = ACTIONS(5663),
    [anon_sym_BSLASHpreceq] = ACTIONS(5663),
    [anon_sym_u2aaf] = ACTIONS(5663),
    [anon_sym_BSLASHsucceq] = ACTIONS(5663),
    [anon_sym_u2ab0] = ACTIONS(5663),
    [anon_sym_BSLASHpropto] = ACTIONS(5663),
    [anon_sym_u221d] = ACTIONS(5663),
    [anon_sym_BSLASHsim] = ACTIONS(5665),
    [anon_sym_u223c] = ACTIONS(5663),
    [anon_sym_BSLASHsimeq] = ACTIONS(5663),
    [anon_sym_u2243] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5665),
    [anon_sym_u228f] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5665),
    [anon_sym_u2290] = ACTIONS(5663),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5663),
    [anon_sym_u2291] = ACTIONS(5663),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5663),
    [anon_sym_u2292] = ACTIONS(5663),
    [anon_sym_BSLASHsubset] = ACTIONS(5665),
    [anon_sym_u2282] = ACTIONS(5663),
    [anon_sym_BSLASHsupset] = ACTIONS(5665),
    [anon_sym_u2283] = ACTIONS(5663),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5663),
    [anon_sym_u2286] = ACTIONS(5663),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5663),
    [anon_sym_u2287] = ACTIONS(5663),
    [sym_compose] = ACTIONS(5663),
    [sym_map_to] = ACTIONS(5663),
    [sym_map_from] = ACTIONS(5663),
    [sym_setminus] = ACTIONS(5665),
    [anon_sym_BSLASHcap] = ACTIONS(5663),
    [anon_sym_BSLASHintersect] = ACTIONS(5663),
    [anon_sym_u2229] = ACTIONS(5663),
    [anon_sym_BSLASHcup] = ACTIONS(5663),
    [anon_sym_BSLASHunion] = ACTIONS(5663),
    [anon_sym_u222a] = ACTIONS(5663),
    [anon_sym_DOT_DOT] = ACTIONS(5665),
    [anon_sym_u2025] = ACTIONS(5663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5663),
    [anon_sym_u2026] = ACTIONS(5663),
    [anon_sym_PLUS] = ACTIONS(5665),
    [sym_plusplus] = ACTIONS(5663),
    [anon_sym_BSLASHoplus] = ACTIONS(5663),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5663),
    [anon_sym_u2295] = ACTIONS(5663),
    [anon_sym_BSLASHominus] = ACTIONS(5663),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2296] = ACTIONS(5663),
    [sym_mod] = ACTIONS(5665),
    [sym_modmod] = ACTIONS(5663),
    [sym_vert] = ACTIONS(5665),
    [anon_sym_PIPE_PIPE] = ACTIONS(5663),
    [anon_sym_u2016] = ACTIONS(5663),
    [sym_minusminus] = ACTIONS(5663),
    [sym_amp] = ACTIONS(5665),
    [sym_ampamp] = ACTIONS(5663),
    [anon_sym_BSLASHodot] = ACTIONS(5663),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5663),
    [anon_sym_u2299] = ACTIONS(5663),
    [anon_sym_BSLASHoslash] = ACTIONS(5663),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5663),
    [anon_sym_u2298] = ACTIONS(5663),
    [anon_sym_BSLASHotimes] = ACTIONS(5663),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5663),
    [anon_sym_u2297] = ACTIONS(5663),
    [sym_mul] = ACTIONS(5665),
    [sym_mulmul] = ACTIONS(5663),
    [sym_slash] = ACTIONS(5665),
    [sym_slashslash] = ACTIONS(5663),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5663),
    [anon_sym_u25ef] = ACTIONS(5663),
    [anon_sym_BSLASHbullet] = ACTIONS(5663),
    [anon_sym_u25cf] = ACTIONS(5663),
    [anon_sym_BSLASHdiv] = ACTIONS(5663),
    [anon_sym_u00f7] = ACTIONS(5663),
    [anon_sym_BSLASHcirc] = ACTIONS(5663),
    [anon_sym_u2218] = ACTIONS(5663),
    [anon_sym_BSLASHstar] = ACTIONS(5663),
    [anon_sym_u22c6] = ACTIONS(5663),
    [anon_sym_u203c] = ACTIONS(5663),
    [sym_hashhash] = ACTIONS(5663),
    [sym_dol] = ACTIONS(5665),
    [sym_doldol] = ACTIONS(5663),
    [anon_sym_QMARK_QMARK] = ACTIONS(5663),
    [anon_sym_u2047] = ACTIONS(5663),
    [anon_sym_BSLASHsqcap] = ACTIONS(5663),
    [anon_sym_u2293] = ACTIONS(5663),
    [anon_sym_BSLASHsqcup] = ACTIONS(5663),
    [anon_sym_u2294] = ACTIONS(5663),
    [anon_sym_BSLASHuplus] = ACTIONS(5663),
    [anon_sym_u228e] = ACTIONS(5663),
    [anon_sym_BSLASHX] = ACTIONS(5663),
    [anon_sym_BSLASHtimes] = ACTIONS(5663),
    [anon_sym_u00d7] = ACTIONS(5663),
    [anon_sym_BSLASHwr] = ACTIONS(5663),
    [anon_sym_u2240] = ACTIONS(5663),
    [anon_sym_BSLASHcdot] = ACTIONS(5663),
    [anon_sym_u22c5] = ACTIONS(5663),
    [sym_pow] = ACTIONS(5665),
    [sym_powpow] = ACTIONS(5663),
    [anon_sym_CARET_PLUS] = ACTIONS(5663),
    [anon_sym_u207a] = ACTIONS(5663),
    [sym_asterisk] = ACTIONS(5663),
    [sym_sup_hash] = ACTIONS(5663),
    [sym_prime] = ACTIONS(5663),
    [sym__bullet] = ACTIONS(5663),
    [sym__dedent] = ACTIONS(5663),
    [sym__double_excl] = ACTIONS(5663),
  },
  [3358] = {
    [sym_block_comment] = STATE(3358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5788),
    [anon_sym_u2208] = ACTIONS(5786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5786),
    [anon_sym_u25a1] = ACTIONS(5786),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5786),
    [anon_sym_u2227] = ACTIONS(5786),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5786),
    [anon_sym_u2228] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5788),
    [anon_sym_BSLASHo] = ACTIONS(5788),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_DASH] = ACTIONS(5788),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27f9] = ACTIONS(5786),
    [anon_sym_u21d2] = ACTIONS(5786),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5786),
    [anon_sym_u21f8] = ACTIONS(5786),
    [anon_sym_u2945] = ACTIONS(5786),
    [anon_sym_BSLASHequiv] = ACTIONS(5786),
    [anon_sym_u2261] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_u27fa] = ACTIONS(5786),
    [anon_sym_u21d4] = ACTIONS(5786),
    [anon_sym_TILDE_GT] = ACTIONS(5786),
    [anon_sym_u21dd] = ACTIONS(5786),
    [anon_sym_u219d] = ACTIONS(5786),
    [anon_sym_BSLASHland] = ACTIONS(5786),
    [anon_sym_BSLASHlor] = ACTIONS(5786),
    [anon_sym_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2254] = ACTIONS(5786),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5786),
    [anon_sym_u2a74] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5788),
    [anon_sym_u2260] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5788),
    [sym_gt] = ACTIONS(5788),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_EQ_LT] = ACTIONS(5786),
    [anon_sym_BSLASHleq] = ACTIONS(5786),
    [anon_sym_u2264] = ACTIONS(5786),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_BSLASHgeq] = ACTIONS(5786),
    [anon_sym_u2265] = ACTIONS(5786),
    [anon_sym_BSLASHapprox] = ACTIONS(5786),
    [anon_sym_u2248] = ACTIONS(5786),
    [anon_sym_PIPE_DASH] = ACTIONS(5786),
    [anon_sym_u22a2] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_u22a8] = ACTIONS(5786),
    [anon_sym_DASH_PIPE] = ACTIONS(5786),
    [anon_sym_u22a3] = ACTIONS(5786),
    [anon_sym_EQ_PIPE] = ACTIONS(5786),
    [anon_sym_u2ae4] = ACTIONS(5786),
    [anon_sym_BSLASHasymp] = ACTIONS(5786),
    [anon_sym_u224d] = ACTIONS(5786),
    [anon_sym_BSLASHcong] = ACTIONS(5786),
    [anon_sym_u2245] = ACTIONS(5786),
    [anon_sym_BSLASHdoteq] = ACTIONS(5786),
    [anon_sym_u2250] = ACTIONS(5786),
    [anon_sym_BSLASHgg] = ACTIONS(5786),
    [anon_sym_u226b] = ACTIONS(5786),
    [anon_sym_BSLASHll] = ACTIONS(5786),
    [anon_sym_u226a] = ACTIONS(5786),
    [anon_sym_BSLASHnotin] = ACTIONS(5786),
    [anon_sym_u2209] = ACTIONS(5786),
    [anon_sym_BSLASHprec] = ACTIONS(5788),
    [anon_sym_u227a] = ACTIONS(5786),
    [anon_sym_BSLASHsucc] = ACTIONS(5788),
    [anon_sym_u227b] = ACTIONS(5786),
    [anon_sym_BSLASHpreceq] = ACTIONS(5786),
    [anon_sym_u2aaf] = ACTIONS(5786),
    [anon_sym_BSLASHsucceq] = ACTIONS(5786),
    [anon_sym_u2ab0] = ACTIONS(5786),
    [anon_sym_BSLASHpropto] = ACTIONS(5786),
    [anon_sym_u221d] = ACTIONS(5786),
    [anon_sym_BSLASHsim] = ACTIONS(5788),
    [anon_sym_u223c] = ACTIONS(5786),
    [anon_sym_BSLASHsimeq] = ACTIONS(5786),
    [anon_sym_u2243] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5788),
    [anon_sym_u228f] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5788),
    [anon_sym_u2290] = ACTIONS(5786),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5786),
    [anon_sym_u2291] = ACTIONS(5786),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5786),
    [anon_sym_u2292] = ACTIONS(5786),
    [anon_sym_BSLASHsubset] = ACTIONS(5788),
    [anon_sym_u2282] = ACTIONS(5786),
    [anon_sym_BSLASHsupset] = ACTIONS(5788),
    [anon_sym_u2283] = ACTIONS(5786),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5786),
    [anon_sym_u2286] = ACTIONS(5786),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5786),
    [anon_sym_u2287] = ACTIONS(5786),
    [sym_compose] = ACTIONS(5786),
    [sym_map_to] = ACTIONS(5786),
    [sym_map_from] = ACTIONS(5786),
    [sym_setminus] = ACTIONS(5788),
    [anon_sym_BSLASHcap] = ACTIONS(5786),
    [anon_sym_BSLASHintersect] = ACTIONS(5786),
    [anon_sym_u2229] = ACTIONS(5786),
    [anon_sym_BSLASHcup] = ACTIONS(5786),
    [anon_sym_BSLASHunion] = ACTIONS(5786),
    [anon_sym_u222a] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_u2025] = ACTIONS(5786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_u2026] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5788),
    [sym_plusplus] = ACTIONS(5786),
    [anon_sym_BSLASHoplus] = ACTIONS(5786),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5786),
    [anon_sym_u2295] = ACTIONS(5786),
    [anon_sym_BSLASHominus] = ACTIONS(5786),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2296] = ACTIONS(5786),
    [sym_mod] = ACTIONS(5788),
    [sym_modmod] = ACTIONS(5786),
    [sym_vert] = ACTIONS(5788),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_u2016] = ACTIONS(5786),
    [sym_minusminus] = ACTIONS(5786),
    [sym_amp] = ACTIONS(5788),
    [sym_ampamp] = ACTIONS(5786),
    [anon_sym_BSLASHodot] = ACTIONS(5786),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5786),
    [anon_sym_u2299] = ACTIONS(5786),
    [anon_sym_BSLASHoslash] = ACTIONS(5786),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5786),
    [anon_sym_u2298] = ACTIONS(5786),
    [anon_sym_BSLASHotimes] = ACTIONS(5786),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5786),
    [anon_sym_u2297] = ACTIONS(5786),
    [sym_mul] = ACTIONS(5788),
    [sym_mulmul] = ACTIONS(5786),
    [sym_slash] = ACTIONS(5788),
    [sym_slashslash] = ACTIONS(5786),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5786),
    [anon_sym_u25ef] = ACTIONS(5786),
    [anon_sym_BSLASHbullet] = ACTIONS(5786),
    [anon_sym_u25cf] = ACTIONS(5786),
    [anon_sym_BSLASHdiv] = ACTIONS(5786),
    [anon_sym_u00f7] = ACTIONS(5786),
    [anon_sym_BSLASHcirc] = ACTIONS(5786),
    [anon_sym_u2218] = ACTIONS(5786),
    [anon_sym_BSLASHstar] = ACTIONS(5786),
    [anon_sym_u22c6] = ACTIONS(5786),
    [anon_sym_u203c] = ACTIONS(5786),
    [sym_hashhash] = ACTIONS(5786),
    [sym_dol] = ACTIONS(5788),
    [sym_doldol] = ACTIONS(5786),
    [anon_sym_QMARK_QMARK] = ACTIONS(5786),
    [anon_sym_u2047] = ACTIONS(5786),
    [anon_sym_BSLASHsqcap] = ACTIONS(5786),
    [anon_sym_u2293] = ACTIONS(5786),
    [anon_sym_BSLASHsqcup] = ACTIONS(5786),
    [anon_sym_u2294] = ACTIONS(5786),
    [anon_sym_BSLASHuplus] = ACTIONS(5786),
    [anon_sym_u228e] = ACTIONS(5786),
    [anon_sym_BSLASHX] = ACTIONS(5786),
    [anon_sym_BSLASHtimes] = ACTIONS(5786),
    [anon_sym_u00d7] = ACTIONS(5786),
    [anon_sym_BSLASHwr] = ACTIONS(5786),
    [anon_sym_u2240] = ACTIONS(5786),
    [anon_sym_BSLASHcdot] = ACTIONS(5786),
    [anon_sym_u22c5] = ACTIONS(5786),
    [sym_pow] = ACTIONS(5788),
    [sym_powpow] = ACTIONS(5786),
    [anon_sym_CARET_PLUS] = ACTIONS(5786),
    [anon_sym_u207a] = ACTIONS(5786),
    [sym_asterisk] = ACTIONS(5786),
    [sym_sup_hash] = ACTIONS(5786),
    [sym_prime] = ACTIONS(5786),
    [sym__bullet] = ACTIONS(5786),
    [sym__dedent] = ACTIONS(5786),
    [sym__double_excl] = ACTIONS(5786),
  },
  [3359] = {
    [sym_block_comment] = STATE(3359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5792),
    [anon_sym_u2208] = ACTIONS(5790),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5790),
    [anon_sym_u25a1] = ACTIONS(5790),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5790),
    [anon_sym_u2227] = ACTIONS(5790),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5790),
    [anon_sym_u2228] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5792),
    [anon_sym_BSLASHo] = ACTIONS(5792),
    [anon_sym_DOT] = ACTIONS(5792),
    [anon_sym_EQ] = ACTIONS(5792),
    [anon_sym_DASH] = ACTIONS(5792),
    [anon_sym_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27f9] = ACTIONS(5790),
    [anon_sym_u21d2] = ACTIONS(5790),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5790),
    [anon_sym_u21f8] = ACTIONS(5790),
    [anon_sym_u2945] = ACTIONS(5790),
    [anon_sym_BSLASHequiv] = ACTIONS(5790),
    [anon_sym_u2261] = ACTIONS(5790),
    [anon_sym_LT_EQ_GT] = ACTIONS(5790),
    [anon_sym_u27fa] = ACTIONS(5790),
    [anon_sym_u21d4] = ACTIONS(5790),
    [anon_sym_TILDE_GT] = ACTIONS(5790),
    [anon_sym_u21dd] = ACTIONS(5790),
    [anon_sym_u219d] = ACTIONS(5790),
    [anon_sym_BSLASHland] = ACTIONS(5790),
    [anon_sym_BSLASHlor] = ACTIONS(5790),
    [anon_sym_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2254] = ACTIONS(5790),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5790),
    [anon_sym_u2a74] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5790),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_u2260] = ACTIONS(5790),
    [anon_sym_LT] = ACTIONS(5792),
    [sym_gt] = ACTIONS(5792),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_EQ_LT] = ACTIONS(5790),
    [anon_sym_BSLASHleq] = ACTIONS(5790),
    [anon_sym_u2264] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5790),
    [anon_sym_BSLASHgeq] = ACTIONS(5790),
    [anon_sym_u2265] = ACTIONS(5790),
    [anon_sym_BSLASHapprox] = ACTIONS(5790),
    [anon_sym_u2248] = ACTIONS(5790),
    [anon_sym_PIPE_DASH] = ACTIONS(5790),
    [anon_sym_u22a2] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5790),
    [anon_sym_u22a8] = ACTIONS(5790),
    [anon_sym_DASH_PIPE] = ACTIONS(5790),
    [anon_sym_u22a3] = ACTIONS(5790),
    [anon_sym_EQ_PIPE] = ACTIONS(5790),
    [anon_sym_u2ae4] = ACTIONS(5790),
    [anon_sym_BSLASHasymp] = ACTIONS(5790),
    [anon_sym_u224d] = ACTIONS(5790),
    [anon_sym_BSLASHcong] = ACTIONS(5790),
    [anon_sym_u2245] = ACTIONS(5790),
    [anon_sym_BSLASHdoteq] = ACTIONS(5790),
    [anon_sym_u2250] = ACTIONS(5790),
    [anon_sym_BSLASHgg] = ACTIONS(5790),
    [anon_sym_u226b] = ACTIONS(5790),
    [anon_sym_BSLASHll] = ACTIONS(5790),
    [anon_sym_u226a] = ACTIONS(5790),
    [anon_sym_BSLASHnotin] = ACTIONS(5790),
    [anon_sym_u2209] = ACTIONS(5790),
    [anon_sym_BSLASHprec] = ACTIONS(5792),
    [anon_sym_u227a] = ACTIONS(5790),
    [anon_sym_BSLASHsucc] = ACTIONS(5792),
    [anon_sym_u227b] = ACTIONS(5790),
    [anon_sym_BSLASHpreceq] = ACTIONS(5790),
    [anon_sym_u2aaf] = ACTIONS(5790),
    [anon_sym_BSLASHsucceq] = ACTIONS(5790),
    [anon_sym_u2ab0] = ACTIONS(5790),
    [anon_sym_BSLASHpropto] = ACTIONS(5790),
    [anon_sym_u221d] = ACTIONS(5790),
    [anon_sym_BSLASHsim] = ACTIONS(5792),
    [anon_sym_u223c] = ACTIONS(5790),
    [anon_sym_BSLASHsimeq] = ACTIONS(5790),
    [anon_sym_u2243] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5792),
    [anon_sym_u228f] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5792),
    [anon_sym_u2290] = ACTIONS(5790),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5790),
    [anon_sym_u2291] = ACTIONS(5790),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5790),
    [anon_sym_u2292] = ACTIONS(5790),
    [anon_sym_BSLASHsubset] = ACTIONS(5792),
    [anon_sym_u2282] = ACTIONS(5790),
    [anon_sym_BSLASHsupset] = ACTIONS(5792),
    [anon_sym_u2283] = ACTIONS(5790),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5790),
    [anon_sym_u2286] = ACTIONS(5790),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5790),
    [anon_sym_u2287] = ACTIONS(5790),
    [sym_compose] = ACTIONS(5790),
    [sym_map_to] = ACTIONS(5790),
    [sym_map_from] = ACTIONS(5790),
    [sym_setminus] = ACTIONS(5792),
    [anon_sym_BSLASHcap] = ACTIONS(5790),
    [anon_sym_BSLASHintersect] = ACTIONS(5790),
    [anon_sym_u2229] = ACTIONS(5790),
    [anon_sym_BSLASHcup] = ACTIONS(5790),
    [anon_sym_BSLASHunion] = ACTIONS(5790),
    [anon_sym_u222a] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5792),
    [anon_sym_u2025] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5790),
    [anon_sym_u2026] = ACTIONS(5790),
    [anon_sym_PLUS] = ACTIONS(5792),
    [sym_plusplus] = ACTIONS(5790),
    [anon_sym_BSLASHoplus] = ACTIONS(5790),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5790),
    [anon_sym_u2295] = ACTIONS(5790),
    [anon_sym_BSLASHominus] = ACTIONS(5790),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2296] = ACTIONS(5790),
    [sym_mod] = ACTIONS(5792),
    [sym_modmod] = ACTIONS(5790),
    [sym_vert] = ACTIONS(5792),
    [anon_sym_PIPE_PIPE] = ACTIONS(5790),
    [anon_sym_u2016] = ACTIONS(5790),
    [sym_minusminus] = ACTIONS(5790),
    [sym_amp] = ACTIONS(5792),
    [sym_ampamp] = ACTIONS(5790),
    [anon_sym_BSLASHodot] = ACTIONS(5790),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5790),
    [anon_sym_u2299] = ACTIONS(5790),
    [anon_sym_BSLASHoslash] = ACTIONS(5790),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5790),
    [anon_sym_u2298] = ACTIONS(5790),
    [anon_sym_BSLASHotimes] = ACTIONS(5790),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5790),
    [anon_sym_u2297] = ACTIONS(5790),
    [sym_mul] = ACTIONS(5792),
    [sym_mulmul] = ACTIONS(5790),
    [sym_slash] = ACTIONS(5792),
    [sym_slashslash] = ACTIONS(5790),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5790),
    [anon_sym_u25ef] = ACTIONS(5790),
    [anon_sym_BSLASHbullet] = ACTIONS(5790),
    [anon_sym_u25cf] = ACTIONS(5790),
    [anon_sym_BSLASHdiv] = ACTIONS(5790),
    [anon_sym_u00f7] = ACTIONS(5790),
    [anon_sym_BSLASHcirc] = ACTIONS(5790),
    [anon_sym_u2218] = ACTIONS(5790),
    [anon_sym_BSLASHstar] = ACTIONS(5790),
    [anon_sym_u22c6] = ACTIONS(5790),
    [anon_sym_u203c] = ACTIONS(5790),
    [sym_hashhash] = ACTIONS(5790),
    [sym_dol] = ACTIONS(5792),
    [sym_doldol] = ACTIONS(5790),
    [anon_sym_QMARK_QMARK] = ACTIONS(5790),
    [anon_sym_u2047] = ACTIONS(5790),
    [anon_sym_BSLASHsqcap] = ACTIONS(5790),
    [anon_sym_u2293] = ACTIONS(5790),
    [anon_sym_BSLASHsqcup] = ACTIONS(5790),
    [anon_sym_u2294] = ACTIONS(5790),
    [anon_sym_BSLASHuplus] = ACTIONS(5790),
    [anon_sym_u228e] = ACTIONS(5790),
    [anon_sym_BSLASHX] = ACTIONS(5790),
    [anon_sym_BSLASHtimes] = ACTIONS(5790),
    [anon_sym_u00d7] = ACTIONS(5790),
    [anon_sym_BSLASHwr] = ACTIONS(5790),
    [anon_sym_u2240] = ACTIONS(5790),
    [anon_sym_BSLASHcdot] = ACTIONS(5790),
    [anon_sym_u22c5] = ACTIONS(5790),
    [sym_pow] = ACTIONS(5792),
    [sym_powpow] = ACTIONS(5790),
    [anon_sym_CARET_PLUS] = ACTIONS(5790),
    [anon_sym_u207a] = ACTIONS(5790),
    [sym_asterisk] = ACTIONS(5790),
    [sym_sup_hash] = ACTIONS(5790),
    [sym_prime] = ACTIONS(5790),
    [sym__bullet] = ACTIONS(5790),
    [sym__dedent] = ACTIONS(5790),
    [sym__double_excl] = ACTIONS(5790),
  },
  [3360] = {
    [sym_block_comment] = STATE(3360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5804),
    [anon_sym_u2208] = ACTIONS(5802),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5802),
    [anon_sym_u25a1] = ACTIONS(5802),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5802),
    [anon_sym_u2227] = ACTIONS(5802),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5802),
    [anon_sym_u2228] = ACTIONS(5802),
    [anon_sym_LBRACK] = ACTIONS(5804),
    [anon_sym_BSLASHo] = ACTIONS(5804),
    [anon_sym_DOT] = ACTIONS(5804),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_DASH] = ACTIONS(5804),
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27f9] = ACTIONS(5802),
    [anon_sym_u21d2] = ACTIONS(5802),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5802),
    [anon_sym_u21f8] = ACTIONS(5802),
    [anon_sym_u2945] = ACTIONS(5802),
    [anon_sym_BSLASHequiv] = ACTIONS(5802),
    [anon_sym_u2261] = ACTIONS(5802),
    [anon_sym_LT_EQ_GT] = ACTIONS(5802),
    [anon_sym_u27fa] = ACTIONS(5802),
    [anon_sym_u21d4] = ACTIONS(5802),
    [anon_sym_TILDE_GT] = ACTIONS(5802),
    [anon_sym_u21dd] = ACTIONS(5802),
    [anon_sym_u219d] = ACTIONS(5802),
    [anon_sym_BSLASHland] = ACTIONS(5802),
    [anon_sym_BSLASHlor] = ACTIONS(5802),
    [anon_sym_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2254] = ACTIONS(5802),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5802),
    [anon_sym_u2a74] = ACTIONS(5802),
    [anon_sym_SLASH_EQ] = ACTIONS(5802),
    [anon_sym_POUND] = ACTIONS(5804),
    [anon_sym_u2260] = ACTIONS(5802),
    [anon_sym_LT] = ACTIONS(5804),
    [sym_gt] = ACTIONS(5804),
    [anon_sym_LT_EQ] = ACTIONS(5804),
    [anon_sym_EQ_LT] = ACTIONS(5802),
    [anon_sym_BSLASHleq] = ACTIONS(5802),
    [anon_sym_u2264] = ACTIONS(5802),
    [anon_sym_GT_EQ] = ACTIONS(5802),
    [anon_sym_BSLASHgeq] = ACTIONS(5802),
    [anon_sym_u2265] = ACTIONS(5802),
    [anon_sym_BSLASHapprox] = ACTIONS(5802),
    [anon_sym_u2248] = ACTIONS(5802),
    [anon_sym_PIPE_DASH] = ACTIONS(5802),
    [anon_sym_u22a2] = ACTIONS(5802),
    [anon_sym_PIPE_EQ] = ACTIONS(5802),
    [anon_sym_u22a8] = ACTIONS(5802),
    [anon_sym_DASH_PIPE] = ACTIONS(5802),
    [anon_sym_u22a3] = ACTIONS(5802),
    [anon_sym_EQ_PIPE] = ACTIONS(5802),
    [anon_sym_u2ae4] = ACTIONS(5802),
    [anon_sym_BSLASHasymp] = ACTIONS(5802),
    [anon_sym_u224d] = ACTIONS(5802),
    [anon_sym_BSLASHcong] = ACTIONS(5802),
    [anon_sym_u2245] = ACTIONS(5802),
    [anon_sym_BSLASHdoteq] = ACTIONS(5802),
    [anon_sym_u2250] = ACTIONS(5802),
    [anon_sym_BSLASHgg] = ACTIONS(5802),
    [anon_sym_u226b] = ACTIONS(5802),
    [anon_sym_BSLASHll] = ACTIONS(5802),
    [anon_sym_u226a] = ACTIONS(5802),
    [anon_sym_BSLASHnotin] = ACTIONS(5802),
    [anon_sym_u2209] = ACTIONS(5802),
    [anon_sym_BSLASHprec] = ACTIONS(5804),
    [anon_sym_u227a] = ACTIONS(5802),
    [anon_sym_BSLASHsucc] = ACTIONS(5804),
    [anon_sym_u227b] = ACTIONS(5802),
    [anon_sym_BSLASHpreceq] = ACTIONS(5802),
    [anon_sym_u2aaf] = ACTIONS(5802),
    [anon_sym_BSLASHsucceq] = ACTIONS(5802),
    [anon_sym_u2ab0] = ACTIONS(5802),
    [anon_sym_BSLASHpropto] = ACTIONS(5802),
    [anon_sym_u221d] = ACTIONS(5802),
    [anon_sym_BSLASHsim] = ACTIONS(5804),
    [anon_sym_u223c] = ACTIONS(5802),
    [anon_sym_BSLASHsimeq] = ACTIONS(5802),
    [anon_sym_u2243] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5804),
    [anon_sym_u228f] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5804),
    [anon_sym_u2290] = ACTIONS(5802),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5802),
    [anon_sym_u2291] = ACTIONS(5802),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5802),
    [anon_sym_u2292] = ACTIONS(5802),
    [anon_sym_BSLASHsubset] = ACTIONS(5804),
    [anon_sym_u2282] = ACTIONS(5802),
    [anon_sym_BSLASHsupset] = ACTIONS(5804),
    [anon_sym_u2283] = ACTIONS(5802),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5802),
    [anon_sym_u2286] = ACTIONS(5802),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5802),
    [anon_sym_u2287] = ACTIONS(5802),
    [sym_compose] = ACTIONS(5802),
    [sym_map_to] = ACTIONS(5802),
    [sym_map_from] = ACTIONS(5802),
    [sym_setminus] = ACTIONS(5804),
    [anon_sym_BSLASHcap] = ACTIONS(5802),
    [anon_sym_BSLASHintersect] = ACTIONS(5802),
    [anon_sym_u2229] = ACTIONS(5802),
    [anon_sym_BSLASHcup] = ACTIONS(5802),
    [anon_sym_BSLASHunion] = ACTIONS(5802),
    [anon_sym_u222a] = ACTIONS(5802),
    [anon_sym_DOT_DOT] = ACTIONS(5804),
    [anon_sym_u2025] = ACTIONS(5802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5802),
    [anon_sym_u2026] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5804),
    [sym_plusplus] = ACTIONS(5802),
    [anon_sym_BSLASHoplus] = ACTIONS(5802),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5802),
    [anon_sym_u2295] = ACTIONS(5802),
    [anon_sym_BSLASHominus] = ACTIONS(5802),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2296] = ACTIONS(5802),
    [sym_mod] = ACTIONS(5804),
    [sym_modmod] = ACTIONS(5802),
    [sym_vert] = ACTIONS(5804),
    [anon_sym_PIPE_PIPE] = ACTIONS(5802),
    [anon_sym_u2016] = ACTIONS(5802),
    [sym_minusminus] = ACTIONS(5802),
    [sym_amp] = ACTIONS(5804),
    [sym_ampamp] = ACTIONS(5802),
    [anon_sym_BSLASHodot] = ACTIONS(5802),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5802),
    [anon_sym_u2299] = ACTIONS(5802),
    [anon_sym_BSLASHoslash] = ACTIONS(5802),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5802),
    [anon_sym_u2298] = ACTIONS(5802),
    [anon_sym_BSLASHotimes] = ACTIONS(5802),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5802),
    [anon_sym_u2297] = ACTIONS(5802),
    [sym_mul] = ACTIONS(5804),
    [sym_mulmul] = ACTIONS(5802),
    [sym_slash] = ACTIONS(5804),
    [sym_slashslash] = ACTIONS(5802),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5802),
    [anon_sym_u25ef] = ACTIONS(5802),
    [anon_sym_BSLASHbullet] = ACTIONS(5802),
    [anon_sym_u25cf] = ACTIONS(5802),
    [anon_sym_BSLASHdiv] = ACTIONS(5802),
    [anon_sym_u00f7] = ACTIONS(5802),
    [anon_sym_BSLASHcirc] = ACTIONS(5802),
    [anon_sym_u2218] = ACTIONS(5802),
    [anon_sym_BSLASHstar] = ACTIONS(5802),
    [anon_sym_u22c6] = ACTIONS(5802),
    [anon_sym_u203c] = ACTIONS(5802),
    [sym_hashhash] = ACTIONS(5802),
    [sym_dol] = ACTIONS(5804),
    [sym_doldol] = ACTIONS(5802),
    [anon_sym_QMARK_QMARK] = ACTIONS(5802),
    [anon_sym_u2047] = ACTIONS(5802),
    [anon_sym_BSLASHsqcap] = ACTIONS(5802),
    [anon_sym_u2293] = ACTIONS(5802),
    [anon_sym_BSLASHsqcup] = ACTIONS(5802),
    [anon_sym_u2294] = ACTIONS(5802),
    [anon_sym_BSLASHuplus] = ACTIONS(5802),
    [anon_sym_u228e] = ACTIONS(5802),
    [anon_sym_BSLASHX] = ACTIONS(5802),
    [anon_sym_BSLASHtimes] = ACTIONS(5802),
    [anon_sym_u00d7] = ACTIONS(5802),
    [anon_sym_BSLASHwr] = ACTIONS(5802),
    [anon_sym_u2240] = ACTIONS(5802),
    [anon_sym_BSLASHcdot] = ACTIONS(5802),
    [anon_sym_u22c5] = ACTIONS(5802),
    [sym_pow] = ACTIONS(5804),
    [sym_powpow] = ACTIONS(5802),
    [anon_sym_CARET_PLUS] = ACTIONS(5802),
    [anon_sym_u207a] = ACTIONS(5802),
    [sym_asterisk] = ACTIONS(5802),
    [sym_sup_hash] = ACTIONS(5802),
    [sym_prime] = ACTIONS(5802),
    [sym__bullet] = ACTIONS(5802),
    [sym__dedent] = ACTIONS(5802),
    [sym__double_excl] = ACTIONS(5802),
  },
  [3361] = {
    [sym_block_comment] = STATE(3361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5882),
    [anon_sym_u2208] = ACTIONS(5880),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5880),
    [anon_sym_u25a1] = ACTIONS(5880),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5880),
    [anon_sym_u2227] = ACTIONS(5880),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5880),
    [anon_sym_u2228] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_BSLASHo] = ACTIONS(5882),
    [anon_sym_DOT] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [anon_sym_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27f9] = ACTIONS(5880),
    [anon_sym_u21d2] = ACTIONS(5880),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5880),
    [anon_sym_u21f8] = ACTIONS(5880),
    [anon_sym_u2945] = ACTIONS(5880),
    [anon_sym_BSLASHequiv] = ACTIONS(5880),
    [anon_sym_u2261] = ACTIONS(5880),
    [anon_sym_LT_EQ_GT] = ACTIONS(5880),
    [anon_sym_u27fa] = ACTIONS(5880),
    [anon_sym_u21d4] = ACTIONS(5880),
    [anon_sym_TILDE_GT] = ACTIONS(5880),
    [anon_sym_u21dd] = ACTIONS(5880),
    [anon_sym_u219d] = ACTIONS(5880),
    [anon_sym_BSLASHland] = ACTIONS(5880),
    [anon_sym_BSLASHlor] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2254] = ACTIONS(5880),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5880),
    [anon_sym_u2a74] = ACTIONS(5880),
    [anon_sym_SLASH_EQ] = ACTIONS(5880),
    [anon_sym_POUND] = ACTIONS(5882),
    [anon_sym_u2260] = ACTIONS(5880),
    [anon_sym_LT] = ACTIONS(5882),
    [sym_gt] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_EQ_LT] = ACTIONS(5880),
    [anon_sym_BSLASHleq] = ACTIONS(5880),
    [anon_sym_u2264] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5880),
    [anon_sym_BSLASHgeq] = ACTIONS(5880),
    [anon_sym_u2265] = ACTIONS(5880),
    [anon_sym_BSLASHapprox] = ACTIONS(5880),
    [anon_sym_u2248] = ACTIONS(5880),
    [anon_sym_PIPE_DASH] = ACTIONS(5880),
    [anon_sym_u22a2] = ACTIONS(5880),
    [anon_sym_PIPE_EQ] = ACTIONS(5880),
    [anon_sym_u22a8] = ACTIONS(5880),
    [anon_sym_DASH_PIPE] = ACTIONS(5880),
    [anon_sym_u22a3] = ACTIONS(5880),
    [anon_sym_EQ_PIPE] = ACTIONS(5880),
    [anon_sym_u2ae4] = ACTIONS(5880),
    [anon_sym_BSLASHasymp] = ACTIONS(5880),
    [anon_sym_u224d] = ACTIONS(5880),
    [anon_sym_BSLASHcong] = ACTIONS(5880),
    [anon_sym_u2245] = ACTIONS(5880),
    [anon_sym_BSLASHdoteq] = ACTIONS(5880),
    [anon_sym_u2250] = ACTIONS(5880),
    [anon_sym_BSLASHgg] = ACTIONS(5880),
    [anon_sym_u226b] = ACTIONS(5880),
    [anon_sym_BSLASHll] = ACTIONS(5880),
    [anon_sym_u226a] = ACTIONS(5880),
    [anon_sym_BSLASHnotin] = ACTIONS(5880),
    [anon_sym_u2209] = ACTIONS(5880),
    [anon_sym_BSLASHprec] = ACTIONS(5882),
    [anon_sym_u227a] = ACTIONS(5880),
    [anon_sym_BSLASHsucc] = ACTIONS(5882),
    [anon_sym_u227b] = ACTIONS(5880),
    [anon_sym_BSLASHpreceq] = ACTIONS(5880),
    [anon_sym_u2aaf] = ACTIONS(5880),
    [anon_sym_BSLASHsucceq] = ACTIONS(5880),
    [anon_sym_u2ab0] = ACTIONS(5880),
    [anon_sym_BSLASHpropto] = ACTIONS(5880),
    [anon_sym_u221d] = ACTIONS(5880),
    [anon_sym_BSLASHsim] = ACTIONS(5882),
    [anon_sym_u223c] = ACTIONS(5880),
    [anon_sym_BSLASHsimeq] = ACTIONS(5880),
    [anon_sym_u2243] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5882),
    [anon_sym_u228f] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5882),
    [anon_sym_u2290] = ACTIONS(5880),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5880),
    [anon_sym_u2291] = ACTIONS(5880),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5880),
    [anon_sym_u2292] = ACTIONS(5880),
    [anon_sym_BSLASHsubset] = ACTIONS(5882),
    [anon_sym_u2282] = ACTIONS(5880),
    [anon_sym_BSLASHsupset] = ACTIONS(5882),
    [anon_sym_u2283] = ACTIONS(5880),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5880),
    [anon_sym_u2286] = ACTIONS(5880),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5880),
    [anon_sym_u2287] = ACTIONS(5880),
    [sym_compose] = ACTIONS(5880),
    [sym_map_to] = ACTIONS(5880),
    [sym_map_from] = ACTIONS(5880),
    [sym_setminus] = ACTIONS(5882),
    [anon_sym_BSLASHcap] = ACTIONS(5880),
    [anon_sym_BSLASHintersect] = ACTIONS(5880),
    [anon_sym_u2229] = ACTIONS(5880),
    [anon_sym_BSLASHcup] = ACTIONS(5880),
    [anon_sym_BSLASHunion] = ACTIONS(5880),
    [anon_sym_u222a] = ACTIONS(5880),
    [anon_sym_DOT_DOT] = ACTIONS(5882),
    [anon_sym_u2025] = ACTIONS(5880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5880),
    [anon_sym_u2026] = ACTIONS(5880),
    [anon_sym_PLUS] = ACTIONS(5882),
    [sym_plusplus] = ACTIONS(5880),
    [anon_sym_BSLASHoplus] = ACTIONS(5880),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5880),
    [anon_sym_u2295] = ACTIONS(5880),
    [anon_sym_BSLASHominus] = ACTIONS(5880),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2296] = ACTIONS(5880),
    [sym_mod] = ACTIONS(5882),
    [sym_modmod] = ACTIONS(5880),
    [sym_vert] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_u2016] = ACTIONS(5880),
    [sym_minusminus] = ACTIONS(5880),
    [sym_amp] = ACTIONS(5882),
    [sym_ampamp] = ACTIONS(5880),
    [anon_sym_BSLASHodot] = ACTIONS(5880),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5880),
    [anon_sym_u2299] = ACTIONS(5880),
    [anon_sym_BSLASHoslash] = ACTIONS(5880),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5880),
    [anon_sym_u2298] = ACTIONS(5880),
    [anon_sym_BSLASHotimes] = ACTIONS(5880),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5880),
    [anon_sym_u2297] = ACTIONS(5880),
    [sym_mul] = ACTIONS(5882),
    [sym_mulmul] = ACTIONS(5880),
    [sym_slash] = ACTIONS(5882),
    [sym_slashslash] = ACTIONS(5880),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5880),
    [anon_sym_u25ef] = ACTIONS(5880),
    [anon_sym_BSLASHbullet] = ACTIONS(5880),
    [anon_sym_u25cf] = ACTIONS(5880),
    [anon_sym_BSLASHdiv] = ACTIONS(5880),
    [anon_sym_u00f7] = ACTIONS(5880),
    [anon_sym_BSLASHcirc] = ACTIONS(5880),
    [anon_sym_u2218] = ACTIONS(5880),
    [anon_sym_BSLASHstar] = ACTIONS(5880),
    [anon_sym_u22c6] = ACTIONS(5880),
    [anon_sym_u203c] = ACTIONS(5880),
    [sym_hashhash] = ACTIONS(5880),
    [sym_dol] = ACTIONS(5882),
    [sym_doldol] = ACTIONS(5880),
    [anon_sym_QMARK_QMARK] = ACTIONS(5880),
    [anon_sym_u2047] = ACTIONS(5880),
    [anon_sym_BSLASHsqcap] = ACTIONS(5880),
    [anon_sym_u2293] = ACTIONS(5880),
    [anon_sym_BSLASHsqcup] = ACTIONS(5880),
    [anon_sym_u2294] = ACTIONS(5880),
    [anon_sym_BSLASHuplus] = ACTIONS(5880),
    [anon_sym_u228e] = ACTIONS(5880),
    [anon_sym_BSLASHX] = ACTIONS(5880),
    [anon_sym_BSLASHtimes] = ACTIONS(5880),
    [anon_sym_u00d7] = ACTIONS(5880),
    [anon_sym_BSLASHwr] = ACTIONS(5880),
    [anon_sym_u2240] = ACTIONS(5880),
    [anon_sym_BSLASHcdot] = ACTIONS(5880),
    [anon_sym_u22c5] = ACTIONS(5880),
    [sym_pow] = ACTIONS(5882),
    [sym_powpow] = ACTIONS(5880),
    [anon_sym_CARET_PLUS] = ACTIONS(5880),
    [anon_sym_u207a] = ACTIONS(5880),
    [sym_asterisk] = ACTIONS(5880),
    [sym_sup_hash] = ACTIONS(5880),
    [sym_prime] = ACTIONS(5880),
    [sym__bullet] = ACTIONS(5880),
    [sym__dedent] = ACTIONS(5880),
    [sym__double_excl] = ACTIONS(5880),
  },
  [3362] = {
    [sym_block_comment] = STATE(3362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5750),
    [anon_sym_u2208] = ACTIONS(5748),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5748),
    [anon_sym_u25a1] = ACTIONS(5748),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5748),
    [anon_sym_u2227] = ACTIONS(5748),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5748),
    [anon_sym_u2228] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_BSLASHo] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27f9] = ACTIONS(5748),
    [anon_sym_u21d2] = ACTIONS(5748),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5748),
    [anon_sym_u21f8] = ACTIONS(5748),
    [anon_sym_u2945] = ACTIONS(5748),
    [anon_sym_BSLASHequiv] = ACTIONS(5748),
    [anon_sym_u2261] = ACTIONS(5748),
    [anon_sym_LT_EQ_GT] = ACTIONS(5748),
    [anon_sym_u27fa] = ACTIONS(5748),
    [anon_sym_u21d4] = ACTIONS(5748),
    [anon_sym_TILDE_GT] = ACTIONS(5748),
    [anon_sym_u21dd] = ACTIONS(5748),
    [anon_sym_u219d] = ACTIONS(5748),
    [anon_sym_BSLASHland] = ACTIONS(5748),
    [anon_sym_BSLASHlor] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2254] = ACTIONS(5748),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5748),
    [anon_sym_u2a74] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(5748),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_u2260] = ACTIONS(5748),
    [anon_sym_LT] = ACTIONS(5750),
    [sym_gt] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5750),
    [anon_sym_EQ_LT] = ACTIONS(5748),
    [anon_sym_BSLASHleq] = ACTIONS(5748),
    [anon_sym_u2264] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5748),
    [anon_sym_BSLASHgeq] = ACTIONS(5748),
    [anon_sym_u2265] = ACTIONS(5748),
    [anon_sym_BSLASHapprox] = ACTIONS(5748),
    [anon_sym_u2248] = ACTIONS(5748),
    [anon_sym_PIPE_DASH] = ACTIONS(5748),
    [anon_sym_u22a2] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(5748),
    [anon_sym_u22a8] = ACTIONS(5748),
    [anon_sym_DASH_PIPE] = ACTIONS(5748),
    [anon_sym_u22a3] = ACTIONS(5748),
    [anon_sym_EQ_PIPE] = ACTIONS(5748),
    [anon_sym_u2ae4] = ACTIONS(5748),
    [anon_sym_BSLASHasymp] = ACTIONS(5748),
    [anon_sym_u224d] = ACTIONS(5748),
    [anon_sym_BSLASHcong] = ACTIONS(5748),
    [anon_sym_u2245] = ACTIONS(5748),
    [anon_sym_BSLASHdoteq] = ACTIONS(5748),
    [anon_sym_u2250] = ACTIONS(5748),
    [anon_sym_BSLASHgg] = ACTIONS(5748),
    [anon_sym_u226b] = ACTIONS(5748),
    [anon_sym_BSLASHll] = ACTIONS(5748),
    [anon_sym_u226a] = ACTIONS(5748),
    [anon_sym_BSLASHnotin] = ACTIONS(5748),
    [anon_sym_u2209] = ACTIONS(5748),
    [anon_sym_BSLASHprec] = ACTIONS(5750),
    [anon_sym_u227a] = ACTIONS(5748),
    [anon_sym_BSLASHsucc] = ACTIONS(5750),
    [anon_sym_u227b] = ACTIONS(5748),
    [anon_sym_BSLASHpreceq] = ACTIONS(5748),
    [anon_sym_u2aaf] = ACTIONS(5748),
    [anon_sym_BSLASHsucceq] = ACTIONS(5748),
    [anon_sym_u2ab0] = ACTIONS(5748),
    [anon_sym_BSLASHpropto] = ACTIONS(5748),
    [anon_sym_u221d] = ACTIONS(5748),
    [anon_sym_BSLASHsim] = ACTIONS(5750),
    [anon_sym_u223c] = ACTIONS(5748),
    [anon_sym_BSLASHsimeq] = ACTIONS(5748),
    [anon_sym_u2243] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5750),
    [anon_sym_u228f] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5750),
    [anon_sym_u2290] = ACTIONS(5748),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5748),
    [anon_sym_u2291] = ACTIONS(5748),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5748),
    [anon_sym_u2292] = ACTIONS(5748),
    [anon_sym_BSLASHsubset] = ACTIONS(5750),
    [anon_sym_u2282] = ACTIONS(5748),
    [anon_sym_BSLASHsupset] = ACTIONS(5750),
    [anon_sym_u2283] = ACTIONS(5748),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5748),
    [anon_sym_u2286] = ACTIONS(5748),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5748),
    [anon_sym_u2287] = ACTIONS(5748),
    [sym_compose] = ACTIONS(5748),
    [sym_map_to] = ACTIONS(5748),
    [sym_map_from] = ACTIONS(5748),
    [sym_setminus] = ACTIONS(5750),
    [anon_sym_BSLASHcap] = ACTIONS(5748),
    [anon_sym_BSLASHintersect] = ACTIONS(5748),
    [anon_sym_u2229] = ACTIONS(5748),
    [anon_sym_BSLASHcup] = ACTIONS(5748),
    [anon_sym_BSLASHunion] = ACTIONS(5748),
    [anon_sym_u222a] = ACTIONS(5748),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_u2025] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_u2026] = ACTIONS(5748),
    [anon_sym_PLUS] = ACTIONS(5750),
    [sym_plusplus] = ACTIONS(5748),
    [anon_sym_BSLASHoplus] = ACTIONS(5748),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5748),
    [anon_sym_u2295] = ACTIONS(5748),
    [anon_sym_BSLASHominus] = ACTIONS(5748),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2296] = ACTIONS(5748),
    [sym_mod] = ACTIONS(5750),
    [sym_modmod] = ACTIONS(5748),
    [sym_vert] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_u2016] = ACTIONS(5748),
    [sym_minusminus] = ACTIONS(5748),
    [sym_amp] = ACTIONS(5750),
    [sym_ampamp] = ACTIONS(5748),
    [anon_sym_BSLASHodot] = ACTIONS(5748),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5748),
    [anon_sym_u2299] = ACTIONS(5748),
    [anon_sym_BSLASHoslash] = ACTIONS(5748),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5748),
    [anon_sym_u2298] = ACTIONS(5748),
    [anon_sym_BSLASHotimes] = ACTIONS(5748),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5748),
    [anon_sym_u2297] = ACTIONS(5748),
    [sym_mul] = ACTIONS(5750),
    [sym_mulmul] = ACTIONS(5748),
    [sym_slash] = ACTIONS(5750),
    [sym_slashslash] = ACTIONS(5748),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5748),
    [anon_sym_u25ef] = ACTIONS(5748),
    [anon_sym_BSLASHbullet] = ACTIONS(5748),
    [anon_sym_u25cf] = ACTIONS(5748),
    [anon_sym_BSLASHdiv] = ACTIONS(5748),
    [anon_sym_u00f7] = ACTIONS(5748),
    [anon_sym_BSLASHcirc] = ACTIONS(5748),
    [anon_sym_u2218] = ACTIONS(5748),
    [anon_sym_BSLASHstar] = ACTIONS(5748),
    [anon_sym_u22c6] = ACTIONS(5748),
    [anon_sym_u203c] = ACTIONS(5748),
    [sym_hashhash] = ACTIONS(5748),
    [sym_dol] = ACTIONS(5750),
    [sym_doldol] = ACTIONS(5748),
    [anon_sym_QMARK_QMARK] = ACTIONS(5748),
    [anon_sym_u2047] = ACTIONS(5748),
    [anon_sym_BSLASHsqcap] = ACTIONS(5748),
    [anon_sym_u2293] = ACTIONS(5748),
    [anon_sym_BSLASHsqcup] = ACTIONS(5748),
    [anon_sym_u2294] = ACTIONS(5748),
    [anon_sym_BSLASHuplus] = ACTIONS(5748),
    [anon_sym_u228e] = ACTIONS(5748),
    [anon_sym_BSLASHX] = ACTIONS(5748),
    [anon_sym_BSLASHtimes] = ACTIONS(5748),
    [anon_sym_u00d7] = ACTIONS(5748),
    [anon_sym_BSLASHwr] = ACTIONS(5748),
    [anon_sym_u2240] = ACTIONS(5748),
    [anon_sym_BSLASHcdot] = ACTIONS(5748),
    [anon_sym_u22c5] = ACTIONS(5748),
    [sym_pow] = ACTIONS(5750),
    [sym_powpow] = ACTIONS(5748),
    [anon_sym_CARET_PLUS] = ACTIONS(5748),
    [anon_sym_u207a] = ACTIONS(5748),
    [sym_asterisk] = ACTIONS(5748),
    [sym_sup_hash] = ACTIONS(5748),
    [sym_prime] = ACTIONS(5748),
    [sym__bullet] = ACTIONS(5748),
    [sym__dedent] = ACTIONS(5748),
    [sym__double_excl] = ACTIONS(5748),
  },
  [3363] = {
    [sym_block_comment] = STATE(3363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5850),
    [anon_sym_u2208] = ACTIONS(5852),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5852),
    [anon_sym_u25a1] = ACTIONS(5852),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5852),
    [anon_sym_u2227] = ACTIONS(5852),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5852),
    [anon_sym_u2228] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_BSLASHo] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27f9] = ACTIONS(5852),
    [anon_sym_u21d2] = ACTIONS(5852),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5852),
    [anon_sym_u21f8] = ACTIONS(5852),
    [anon_sym_u2945] = ACTIONS(5852),
    [anon_sym_BSLASHequiv] = ACTIONS(5852),
    [anon_sym_u2261] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_u27fa] = ACTIONS(5852),
    [anon_sym_u21d4] = ACTIONS(5852),
    [anon_sym_TILDE_GT] = ACTIONS(5852),
    [anon_sym_u21dd] = ACTIONS(5852),
    [anon_sym_u219d] = ACTIONS(5852),
    [anon_sym_BSLASHland] = ACTIONS(5852),
    [anon_sym_BSLASHlor] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2254] = ACTIONS(5852),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5852),
    [anon_sym_u2a74] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_POUND] = ACTIONS(5850),
    [anon_sym_u2260] = ACTIONS(5852),
    [anon_sym_LT] = ACTIONS(5850),
    [sym_gt] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_EQ_LT] = ACTIONS(5852),
    [anon_sym_BSLASHleq] = ACTIONS(5852),
    [anon_sym_u2264] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_BSLASHgeq] = ACTIONS(5852),
    [anon_sym_u2265] = ACTIONS(5852),
    [anon_sym_BSLASHapprox] = ACTIONS(5852),
    [anon_sym_u2248] = ACTIONS(5852),
    [anon_sym_PIPE_DASH] = ACTIONS(5852),
    [anon_sym_u22a2] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_u22a8] = ACTIONS(5852),
    [anon_sym_DASH_PIPE] = ACTIONS(5852),
    [anon_sym_u22a3] = ACTIONS(5852),
    [anon_sym_EQ_PIPE] = ACTIONS(5852),
    [anon_sym_u2ae4] = ACTIONS(5852),
    [anon_sym_BSLASHasymp] = ACTIONS(5852),
    [anon_sym_u224d] = ACTIONS(5852),
    [anon_sym_BSLASHcong] = ACTIONS(5852),
    [anon_sym_u2245] = ACTIONS(5852),
    [anon_sym_BSLASHdoteq] = ACTIONS(5852),
    [anon_sym_u2250] = ACTIONS(5852),
    [anon_sym_BSLASHgg] = ACTIONS(5852),
    [anon_sym_u226b] = ACTIONS(5852),
    [anon_sym_BSLASHll] = ACTIONS(5852),
    [anon_sym_u226a] = ACTIONS(5852),
    [anon_sym_BSLASHnotin] = ACTIONS(5852),
    [anon_sym_u2209] = ACTIONS(5852),
    [anon_sym_BSLASHprec] = ACTIONS(5850),
    [anon_sym_u227a] = ACTIONS(5852),
    [anon_sym_BSLASHsucc] = ACTIONS(5850),
    [anon_sym_u227b] = ACTIONS(5852),
    [anon_sym_BSLASHpreceq] = ACTIONS(5852),
    [anon_sym_u2aaf] = ACTIONS(5852),
    [anon_sym_BSLASHsucceq] = ACTIONS(5852),
    [anon_sym_u2ab0] = ACTIONS(5852),
    [anon_sym_BSLASHpropto] = ACTIONS(5852),
    [anon_sym_u221d] = ACTIONS(5852),
    [anon_sym_BSLASHsim] = ACTIONS(5850),
    [anon_sym_u223c] = ACTIONS(5852),
    [anon_sym_BSLASHsimeq] = ACTIONS(5852),
    [anon_sym_u2243] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5850),
    [anon_sym_u228f] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5850),
    [anon_sym_u2290] = ACTIONS(5852),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5852),
    [anon_sym_u2291] = ACTIONS(5852),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5852),
    [anon_sym_u2292] = ACTIONS(5852),
    [anon_sym_BSLASHsubset] = ACTIONS(5850),
    [anon_sym_u2282] = ACTIONS(5852),
    [anon_sym_BSLASHsupset] = ACTIONS(5850),
    [anon_sym_u2283] = ACTIONS(5852),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5852),
    [anon_sym_u2286] = ACTIONS(5852),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5852),
    [anon_sym_u2287] = ACTIONS(5852),
    [sym_compose] = ACTIONS(5852),
    [sym_map_to] = ACTIONS(5852),
    [sym_map_from] = ACTIONS(5852),
    [sym_setminus] = ACTIONS(5850),
    [anon_sym_BSLASHcap] = ACTIONS(5852),
    [anon_sym_BSLASHintersect] = ACTIONS(5852),
    [anon_sym_u2229] = ACTIONS(5852),
    [anon_sym_BSLASHcup] = ACTIONS(5852),
    [anon_sym_BSLASHunion] = ACTIONS(5852),
    [anon_sym_u222a] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5850),
    [anon_sym_u2025] = ACTIONS(5852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_u2026] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5850),
    [sym_plusplus] = ACTIONS(5852),
    [anon_sym_BSLASHoplus] = ACTIONS(5852),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5852),
    [anon_sym_u2295] = ACTIONS(5852),
    [anon_sym_BSLASHominus] = ACTIONS(5852),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2296] = ACTIONS(5852),
    [sym_mod] = ACTIONS(5850),
    [sym_modmod] = ACTIONS(5852),
    [sym_vert] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_u2016] = ACTIONS(5852),
    [sym_minusminus] = ACTIONS(5852),
    [sym_amp] = ACTIONS(5850),
    [sym_ampamp] = ACTIONS(5852),
    [anon_sym_BSLASHodot] = ACTIONS(5852),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5852),
    [anon_sym_u2299] = ACTIONS(5852),
    [anon_sym_BSLASHoslash] = ACTIONS(5852),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5852),
    [anon_sym_u2298] = ACTIONS(5852),
    [anon_sym_BSLASHotimes] = ACTIONS(5852),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5852),
    [anon_sym_u2297] = ACTIONS(5852),
    [sym_mul] = ACTIONS(5850),
    [sym_mulmul] = ACTIONS(5852),
    [sym_slash] = ACTIONS(5850),
    [sym_slashslash] = ACTIONS(5852),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5852),
    [anon_sym_u25ef] = ACTIONS(5852),
    [anon_sym_BSLASHbullet] = ACTIONS(5852),
    [anon_sym_u25cf] = ACTIONS(5852),
    [anon_sym_BSLASHdiv] = ACTIONS(5852),
    [anon_sym_u00f7] = ACTIONS(5852),
    [anon_sym_BSLASHcirc] = ACTIONS(5852),
    [anon_sym_u2218] = ACTIONS(5852),
    [anon_sym_BSLASHstar] = ACTIONS(5852),
    [anon_sym_u22c6] = ACTIONS(5852),
    [anon_sym_u203c] = ACTIONS(5852),
    [sym_hashhash] = ACTIONS(5852),
    [sym_dol] = ACTIONS(5850),
    [sym_doldol] = ACTIONS(5852),
    [anon_sym_QMARK_QMARK] = ACTIONS(5852),
    [anon_sym_u2047] = ACTIONS(5852),
    [anon_sym_BSLASHsqcap] = ACTIONS(5852),
    [anon_sym_u2293] = ACTIONS(5852),
    [anon_sym_BSLASHsqcup] = ACTIONS(5852),
    [anon_sym_u2294] = ACTIONS(5852),
    [anon_sym_BSLASHuplus] = ACTIONS(5852),
    [anon_sym_u228e] = ACTIONS(5852),
    [anon_sym_BSLASHX] = ACTIONS(5852),
    [anon_sym_BSLASHtimes] = ACTIONS(5852),
    [anon_sym_u00d7] = ACTIONS(5852),
    [anon_sym_BSLASHwr] = ACTIONS(5852),
    [anon_sym_u2240] = ACTIONS(5852),
    [anon_sym_BSLASHcdot] = ACTIONS(5852),
    [anon_sym_u22c5] = ACTIONS(5852),
    [sym_pow] = ACTIONS(5850),
    [sym_powpow] = ACTIONS(5852),
    [anon_sym_CARET_PLUS] = ACTIONS(5852),
    [anon_sym_u207a] = ACTIONS(5852),
    [sym_asterisk] = ACTIONS(5852),
    [sym_sup_hash] = ACTIONS(5852),
    [sym_prime] = ACTIONS(5852),
    [sym__bullet] = ACTIONS(5852),
    [sym__dedent] = ACTIONS(5852),
    [sym__double_excl] = ACTIONS(5852),
  },
  [3364] = {
    [sym_block_comment] = STATE(3364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5808),
    [anon_sym_u2208] = ACTIONS(5806),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5806),
    [anon_sym_u25a1] = ACTIONS(5806),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5806),
    [anon_sym_u2227] = ACTIONS(5806),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5806),
    [anon_sym_u2228] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5808),
    [anon_sym_BSLASHo] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_DASH] = ACTIONS(5808),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27f9] = ACTIONS(5806),
    [anon_sym_u21d2] = ACTIONS(5806),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5806),
    [anon_sym_u21f8] = ACTIONS(5806),
    [anon_sym_u2945] = ACTIONS(5806),
    [anon_sym_BSLASHequiv] = ACTIONS(5806),
    [anon_sym_u2261] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_u27fa] = ACTIONS(5806),
    [anon_sym_u21d4] = ACTIONS(5806),
    [anon_sym_TILDE_GT] = ACTIONS(5806),
    [anon_sym_u21dd] = ACTIONS(5806),
    [anon_sym_u219d] = ACTIONS(5806),
    [anon_sym_BSLASHland] = ACTIONS(5806),
    [anon_sym_BSLASHlor] = ACTIONS(5806),
    [anon_sym_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2254] = ACTIONS(5806),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5806),
    [anon_sym_u2a74] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_POUND] = ACTIONS(5808),
    [anon_sym_u2260] = ACTIONS(5806),
    [anon_sym_LT] = ACTIONS(5808),
    [sym_gt] = ACTIONS(5808),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_EQ_LT] = ACTIONS(5806),
    [anon_sym_BSLASHleq] = ACTIONS(5806),
    [anon_sym_u2264] = ACTIONS(5806),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_BSLASHgeq] = ACTIONS(5806),
    [anon_sym_u2265] = ACTIONS(5806),
    [anon_sym_BSLASHapprox] = ACTIONS(5806),
    [anon_sym_u2248] = ACTIONS(5806),
    [anon_sym_PIPE_DASH] = ACTIONS(5806),
    [anon_sym_u22a2] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_u22a8] = ACTIONS(5806),
    [anon_sym_DASH_PIPE] = ACTIONS(5806),
    [anon_sym_u22a3] = ACTIONS(5806),
    [anon_sym_EQ_PIPE] = ACTIONS(5806),
    [anon_sym_u2ae4] = ACTIONS(5806),
    [anon_sym_BSLASHasymp] = ACTIONS(5806),
    [anon_sym_u224d] = ACTIONS(5806),
    [anon_sym_BSLASHcong] = ACTIONS(5806),
    [anon_sym_u2245] = ACTIONS(5806),
    [anon_sym_BSLASHdoteq] = ACTIONS(5806),
    [anon_sym_u2250] = ACTIONS(5806),
    [anon_sym_BSLASHgg] = ACTIONS(5806),
    [anon_sym_u226b] = ACTIONS(5806),
    [anon_sym_BSLASHll] = ACTIONS(5806),
    [anon_sym_u226a] = ACTIONS(5806),
    [anon_sym_BSLASHnotin] = ACTIONS(5806),
    [anon_sym_u2209] = ACTIONS(5806),
    [anon_sym_BSLASHprec] = ACTIONS(5808),
    [anon_sym_u227a] = ACTIONS(5806),
    [anon_sym_BSLASHsucc] = ACTIONS(5808),
    [anon_sym_u227b] = ACTIONS(5806),
    [anon_sym_BSLASHpreceq] = ACTIONS(5806),
    [anon_sym_u2aaf] = ACTIONS(5806),
    [anon_sym_BSLASHsucceq] = ACTIONS(5806),
    [anon_sym_u2ab0] = ACTIONS(5806),
    [anon_sym_BSLASHpropto] = ACTIONS(5806),
    [anon_sym_u221d] = ACTIONS(5806),
    [anon_sym_BSLASHsim] = ACTIONS(5808),
    [anon_sym_u223c] = ACTIONS(5806),
    [anon_sym_BSLASHsimeq] = ACTIONS(5806),
    [anon_sym_u2243] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5808),
    [anon_sym_u228f] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5808),
    [anon_sym_u2290] = ACTIONS(5806),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5806),
    [anon_sym_u2291] = ACTIONS(5806),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5806),
    [anon_sym_u2292] = ACTIONS(5806),
    [anon_sym_BSLASHsubset] = ACTIONS(5808),
    [anon_sym_u2282] = ACTIONS(5806),
    [anon_sym_BSLASHsupset] = ACTIONS(5808),
    [anon_sym_u2283] = ACTIONS(5806),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5806),
    [anon_sym_u2286] = ACTIONS(5806),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5806),
    [anon_sym_u2287] = ACTIONS(5806),
    [sym_compose] = ACTIONS(5806),
    [sym_map_to] = ACTIONS(5806),
    [sym_map_from] = ACTIONS(5806),
    [sym_setminus] = ACTIONS(5808),
    [anon_sym_BSLASHcap] = ACTIONS(5806),
    [anon_sym_BSLASHintersect] = ACTIONS(5806),
    [anon_sym_u2229] = ACTIONS(5806),
    [anon_sym_BSLASHcup] = ACTIONS(5806),
    [anon_sym_BSLASHunion] = ACTIONS(5806),
    [anon_sym_u222a] = ACTIONS(5806),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_u2025] = ACTIONS(5806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_u2026] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [sym_plusplus] = ACTIONS(5806),
    [anon_sym_BSLASHoplus] = ACTIONS(5806),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5806),
    [anon_sym_u2295] = ACTIONS(5806),
    [anon_sym_BSLASHominus] = ACTIONS(5806),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2296] = ACTIONS(5806),
    [sym_mod] = ACTIONS(5808),
    [sym_modmod] = ACTIONS(5806),
    [sym_vert] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5806),
    [anon_sym_u2016] = ACTIONS(5806),
    [sym_minusminus] = ACTIONS(5806),
    [sym_amp] = ACTIONS(5808),
    [sym_ampamp] = ACTIONS(5806),
    [anon_sym_BSLASHodot] = ACTIONS(5806),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5806),
    [anon_sym_u2299] = ACTIONS(5806),
    [anon_sym_BSLASHoslash] = ACTIONS(5806),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5806),
    [anon_sym_u2298] = ACTIONS(5806),
    [anon_sym_BSLASHotimes] = ACTIONS(5806),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5806),
    [anon_sym_u2297] = ACTIONS(5806),
    [sym_mul] = ACTIONS(5808),
    [sym_mulmul] = ACTIONS(5806),
    [sym_slash] = ACTIONS(5808),
    [sym_slashslash] = ACTIONS(5806),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5806),
    [anon_sym_u25ef] = ACTIONS(5806),
    [anon_sym_BSLASHbullet] = ACTIONS(5806),
    [anon_sym_u25cf] = ACTIONS(5806),
    [anon_sym_BSLASHdiv] = ACTIONS(5806),
    [anon_sym_u00f7] = ACTIONS(5806),
    [anon_sym_BSLASHcirc] = ACTIONS(5806),
    [anon_sym_u2218] = ACTIONS(5806),
    [anon_sym_BSLASHstar] = ACTIONS(5806),
    [anon_sym_u22c6] = ACTIONS(5806),
    [anon_sym_u203c] = ACTIONS(5806),
    [sym_hashhash] = ACTIONS(5806),
    [sym_dol] = ACTIONS(5808),
    [sym_doldol] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK] = ACTIONS(5806),
    [anon_sym_u2047] = ACTIONS(5806),
    [anon_sym_BSLASHsqcap] = ACTIONS(5806),
    [anon_sym_u2293] = ACTIONS(5806),
    [anon_sym_BSLASHsqcup] = ACTIONS(5806),
    [anon_sym_u2294] = ACTIONS(5806),
    [anon_sym_BSLASHuplus] = ACTIONS(5806),
    [anon_sym_u228e] = ACTIONS(5806),
    [anon_sym_BSLASHX] = ACTIONS(5806),
    [anon_sym_BSLASHtimes] = ACTIONS(5806),
    [anon_sym_u00d7] = ACTIONS(5806),
    [anon_sym_BSLASHwr] = ACTIONS(5806),
    [anon_sym_u2240] = ACTIONS(5806),
    [anon_sym_BSLASHcdot] = ACTIONS(5806),
    [anon_sym_u22c5] = ACTIONS(5806),
    [sym_pow] = ACTIONS(5808),
    [sym_powpow] = ACTIONS(5806),
    [anon_sym_CARET_PLUS] = ACTIONS(5806),
    [anon_sym_u207a] = ACTIONS(5806),
    [sym_asterisk] = ACTIONS(5806),
    [sym_sup_hash] = ACTIONS(5806),
    [sym_prime] = ACTIONS(5806),
    [sym__bullet] = ACTIONS(5806),
    [sym__dedent] = ACTIONS(5806),
    [sym__double_excl] = ACTIONS(5806),
  },
  [3365] = {
    [sym_block_comment] = STATE(3365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5854),
    [anon_sym_u2208] = ACTIONS(5856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5856),
    [anon_sym_u25a1] = ACTIONS(5856),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5856),
    [anon_sym_u2227] = ACTIONS(5856),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5856),
    [anon_sym_u2228] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5854),
    [anon_sym_BSLASHo] = ACTIONS(5854),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_DASH] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27f9] = ACTIONS(5856),
    [anon_sym_u21d2] = ACTIONS(5856),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5856),
    [anon_sym_u21f8] = ACTIONS(5856),
    [anon_sym_u2945] = ACTIONS(5856),
    [anon_sym_BSLASHequiv] = ACTIONS(5856),
    [anon_sym_u2261] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_u27fa] = ACTIONS(5856),
    [anon_sym_u21d4] = ACTIONS(5856),
    [anon_sym_TILDE_GT] = ACTIONS(5856),
    [anon_sym_u21dd] = ACTIONS(5856),
    [anon_sym_u219d] = ACTIONS(5856),
    [anon_sym_BSLASHland] = ACTIONS(5856),
    [anon_sym_BSLASHlor] = ACTIONS(5856),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2254] = ACTIONS(5856),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5856),
    [anon_sym_u2a74] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_POUND] = ACTIONS(5854),
    [anon_sym_u2260] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5854),
    [sym_gt] = ACTIONS(5854),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_EQ_LT] = ACTIONS(5856),
    [anon_sym_BSLASHleq] = ACTIONS(5856),
    [anon_sym_u2264] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_BSLASHgeq] = ACTIONS(5856),
    [anon_sym_u2265] = ACTIONS(5856),
    [anon_sym_BSLASHapprox] = ACTIONS(5856),
    [anon_sym_u2248] = ACTIONS(5856),
    [anon_sym_PIPE_DASH] = ACTIONS(5856),
    [anon_sym_u22a2] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_u22a8] = ACTIONS(5856),
    [anon_sym_DASH_PIPE] = ACTIONS(5856),
    [anon_sym_u22a3] = ACTIONS(5856),
    [anon_sym_EQ_PIPE] = ACTIONS(5856),
    [anon_sym_u2ae4] = ACTIONS(5856),
    [anon_sym_BSLASHasymp] = ACTIONS(5856),
    [anon_sym_u224d] = ACTIONS(5856),
    [anon_sym_BSLASHcong] = ACTIONS(5856),
    [anon_sym_u2245] = ACTIONS(5856),
    [anon_sym_BSLASHdoteq] = ACTIONS(5856),
    [anon_sym_u2250] = ACTIONS(5856),
    [anon_sym_BSLASHgg] = ACTIONS(5856),
    [anon_sym_u226b] = ACTIONS(5856),
    [anon_sym_BSLASHll] = ACTIONS(5856),
    [anon_sym_u226a] = ACTIONS(5856),
    [anon_sym_BSLASHnotin] = ACTIONS(5856),
    [anon_sym_u2209] = ACTIONS(5856),
    [anon_sym_BSLASHprec] = ACTIONS(5854),
    [anon_sym_u227a] = ACTIONS(5856),
    [anon_sym_BSLASHsucc] = ACTIONS(5854),
    [anon_sym_u227b] = ACTIONS(5856),
    [anon_sym_BSLASHpreceq] = ACTIONS(5856),
    [anon_sym_u2aaf] = ACTIONS(5856),
    [anon_sym_BSLASHsucceq] = ACTIONS(5856),
    [anon_sym_u2ab0] = ACTIONS(5856),
    [anon_sym_BSLASHpropto] = ACTIONS(5856),
    [anon_sym_u221d] = ACTIONS(5856),
    [anon_sym_BSLASHsim] = ACTIONS(5854),
    [anon_sym_u223c] = ACTIONS(5856),
    [anon_sym_BSLASHsimeq] = ACTIONS(5856),
    [anon_sym_u2243] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5854),
    [anon_sym_u228f] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5854),
    [anon_sym_u2290] = ACTIONS(5856),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5856),
    [anon_sym_u2291] = ACTIONS(5856),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5856),
    [anon_sym_u2292] = ACTIONS(5856),
    [anon_sym_BSLASHsubset] = ACTIONS(5854),
    [anon_sym_u2282] = ACTIONS(5856),
    [anon_sym_BSLASHsupset] = ACTIONS(5854),
    [anon_sym_u2283] = ACTIONS(5856),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5856),
    [anon_sym_u2286] = ACTIONS(5856),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5856),
    [anon_sym_u2287] = ACTIONS(5856),
    [sym_compose] = ACTIONS(5856),
    [sym_map_to] = ACTIONS(5856),
    [sym_map_from] = ACTIONS(5856),
    [sym_setminus] = ACTIONS(5854),
    [anon_sym_BSLASHcap] = ACTIONS(5856),
    [anon_sym_BSLASHintersect] = ACTIONS(5856),
    [anon_sym_u2229] = ACTIONS(5856),
    [anon_sym_BSLASHcup] = ACTIONS(5856),
    [anon_sym_BSLASHunion] = ACTIONS(5856),
    [anon_sym_u222a] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_u2025] = ACTIONS(5856),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_u2026] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5854),
    [sym_plusplus] = ACTIONS(5856),
    [anon_sym_BSLASHoplus] = ACTIONS(5856),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5856),
    [anon_sym_u2295] = ACTIONS(5856),
    [anon_sym_BSLASHominus] = ACTIONS(5856),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2296] = ACTIONS(5856),
    [sym_mod] = ACTIONS(5854),
    [sym_modmod] = ACTIONS(5856),
    [sym_vert] = ACTIONS(5854),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_u2016] = ACTIONS(5856),
    [sym_minusminus] = ACTIONS(5856),
    [sym_amp] = ACTIONS(5854),
    [sym_ampamp] = ACTIONS(5856),
    [anon_sym_BSLASHodot] = ACTIONS(5856),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5856),
    [anon_sym_u2299] = ACTIONS(5856),
    [anon_sym_BSLASHoslash] = ACTIONS(5856),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5856),
    [anon_sym_u2298] = ACTIONS(5856),
    [anon_sym_BSLASHotimes] = ACTIONS(5856),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5856),
    [anon_sym_u2297] = ACTIONS(5856),
    [sym_mul] = ACTIONS(5854),
    [sym_mulmul] = ACTIONS(5856),
    [sym_slash] = ACTIONS(5854),
    [sym_slashslash] = ACTIONS(5856),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5856),
    [anon_sym_u25ef] = ACTIONS(5856),
    [anon_sym_BSLASHbullet] = ACTIONS(5856),
    [anon_sym_u25cf] = ACTIONS(5856),
    [anon_sym_BSLASHdiv] = ACTIONS(5856),
    [anon_sym_u00f7] = ACTIONS(5856),
    [anon_sym_BSLASHcirc] = ACTIONS(5856),
    [anon_sym_u2218] = ACTIONS(5856),
    [anon_sym_BSLASHstar] = ACTIONS(5856),
    [anon_sym_u22c6] = ACTIONS(5856),
    [anon_sym_u203c] = ACTIONS(5856),
    [sym_hashhash] = ACTIONS(5856),
    [sym_dol] = ACTIONS(5854),
    [sym_doldol] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_u2047] = ACTIONS(5856),
    [anon_sym_BSLASHsqcap] = ACTIONS(5856),
    [anon_sym_u2293] = ACTIONS(5856),
    [anon_sym_BSLASHsqcup] = ACTIONS(5856),
    [anon_sym_u2294] = ACTIONS(5856),
    [anon_sym_BSLASHuplus] = ACTIONS(5856),
    [anon_sym_u228e] = ACTIONS(5856),
    [anon_sym_BSLASHX] = ACTIONS(5856),
    [anon_sym_BSLASHtimes] = ACTIONS(5856),
    [anon_sym_u00d7] = ACTIONS(5856),
    [anon_sym_BSLASHwr] = ACTIONS(5856),
    [anon_sym_u2240] = ACTIONS(5856),
    [anon_sym_BSLASHcdot] = ACTIONS(5856),
    [anon_sym_u22c5] = ACTIONS(5856),
    [sym_pow] = ACTIONS(5854),
    [sym_powpow] = ACTIONS(5856),
    [anon_sym_CARET_PLUS] = ACTIONS(5856),
    [anon_sym_u207a] = ACTIONS(5856),
    [sym_asterisk] = ACTIONS(5856),
    [sym_sup_hash] = ACTIONS(5856),
    [sym_prime] = ACTIONS(5856),
    [sym__bullet] = ACTIONS(5856),
    [sym__dedent] = ACTIONS(5856),
    [sym__double_excl] = ACTIONS(5856),
  },
  [3366] = {
    [sym_block_comment] = STATE(3366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5820),
    [anon_sym_u2208] = ACTIONS(5818),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5818),
    [anon_sym_u25a1] = ACTIONS(5818),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5818),
    [anon_sym_u2227] = ACTIONS(5818),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5818),
    [anon_sym_u2228] = ACTIONS(5818),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_BSLASHo] = ACTIONS(5820),
    [anon_sym_DOT] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [anon_sym_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27f9] = ACTIONS(5818),
    [anon_sym_u21d2] = ACTIONS(5818),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5818),
    [anon_sym_u21f8] = ACTIONS(5818),
    [anon_sym_u2945] = ACTIONS(5818),
    [anon_sym_BSLASHequiv] = ACTIONS(5818),
    [anon_sym_u2261] = ACTIONS(5818),
    [anon_sym_LT_EQ_GT] = ACTIONS(5818),
    [anon_sym_u27fa] = ACTIONS(5818),
    [anon_sym_u21d4] = ACTIONS(5818),
    [anon_sym_TILDE_GT] = ACTIONS(5818),
    [anon_sym_u21dd] = ACTIONS(5818),
    [anon_sym_u219d] = ACTIONS(5818),
    [anon_sym_BSLASHland] = ACTIONS(5818),
    [anon_sym_BSLASHlor] = ACTIONS(5818),
    [anon_sym_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2254] = ACTIONS(5818),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5818),
    [anon_sym_u2a74] = ACTIONS(5818),
    [anon_sym_SLASH_EQ] = ACTIONS(5818),
    [anon_sym_POUND] = ACTIONS(5820),
    [anon_sym_u2260] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5820),
    [sym_gt] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_EQ_LT] = ACTIONS(5818),
    [anon_sym_BSLASHleq] = ACTIONS(5818),
    [anon_sym_u2264] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5818),
    [anon_sym_BSLASHgeq] = ACTIONS(5818),
    [anon_sym_u2265] = ACTIONS(5818),
    [anon_sym_BSLASHapprox] = ACTIONS(5818),
    [anon_sym_u2248] = ACTIONS(5818),
    [anon_sym_PIPE_DASH] = ACTIONS(5818),
    [anon_sym_u22a2] = ACTIONS(5818),
    [anon_sym_PIPE_EQ] = ACTIONS(5818),
    [anon_sym_u22a8] = ACTIONS(5818),
    [anon_sym_DASH_PIPE] = ACTIONS(5818),
    [anon_sym_u22a3] = ACTIONS(5818),
    [anon_sym_EQ_PIPE] = ACTIONS(5818),
    [anon_sym_u2ae4] = ACTIONS(5818),
    [anon_sym_BSLASHasymp] = ACTIONS(5818),
    [anon_sym_u224d] = ACTIONS(5818),
    [anon_sym_BSLASHcong] = ACTIONS(5818),
    [anon_sym_u2245] = ACTIONS(5818),
    [anon_sym_BSLASHdoteq] = ACTIONS(5818),
    [anon_sym_u2250] = ACTIONS(5818),
    [anon_sym_BSLASHgg] = ACTIONS(5818),
    [anon_sym_u226b] = ACTIONS(5818),
    [anon_sym_BSLASHll] = ACTIONS(5818),
    [anon_sym_u226a] = ACTIONS(5818),
    [anon_sym_BSLASHnotin] = ACTIONS(5818),
    [anon_sym_u2209] = ACTIONS(5818),
    [anon_sym_BSLASHprec] = ACTIONS(5820),
    [anon_sym_u227a] = ACTIONS(5818),
    [anon_sym_BSLASHsucc] = ACTIONS(5820),
    [anon_sym_u227b] = ACTIONS(5818),
    [anon_sym_BSLASHpreceq] = ACTIONS(5818),
    [anon_sym_u2aaf] = ACTIONS(5818),
    [anon_sym_BSLASHsucceq] = ACTIONS(5818),
    [anon_sym_u2ab0] = ACTIONS(5818),
    [anon_sym_BSLASHpropto] = ACTIONS(5818),
    [anon_sym_u221d] = ACTIONS(5818),
    [anon_sym_BSLASHsim] = ACTIONS(5820),
    [anon_sym_u223c] = ACTIONS(5818),
    [anon_sym_BSLASHsimeq] = ACTIONS(5818),
    [anon_sym_u2243] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5820),
    [anon_sym_u228f] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5820),
    [anon_sym_u2290] = ACTIONS(5818),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5818),
    [anon_sym_u2291] = ACTIONS(5818),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5818),
    [anon_sym_u2292] = ACTIONS(5818),
    [anon_sym_BSLASHsubset] = ACTIONS(5820),
    [anon_sym_u2282] = ACTIONS(5818),
    [anon_sym_BSLASHsupset] = ACTIONS(5820),
    [anon_sym_u2283] = ACTIONS(5818),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5818),
    [anon_sym_u2286] = ACTIONS(5818),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5818),
    [anon_sym_u2287] = ACTIONS(5818),
    [sym_compose] = ACTIONS(5818),
    [sym_map_to] = ACTIONS(5818),
    [sym_map_from] = ACTIONS(5818),
    [sym_setminus] = ACTIONS(5820),
    [anon_sym_BSLASHcap] = ACTIONS(5818),
    [anon_sym_BSLASHintersect] = ACTIONS(5818),
    [anon_sym_u2229] = ACTIONS(5818),
    [anon_sym_BSLASHcup] = ACTIONS(5818),
    [anon_sym_BSLASHunion] = ACTIONS(5818),
    [anon_sym_u222a] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5820),
    [anon_sym_u2025] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5818),
    [anon_sym_u2026] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5820),
    [sym_plusplus] = ACTIONS(5818),
    [anon_sym_BSLASHoplus] = ACTIONS(5818),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5818),
    [anon_sym_u2295] = ACTIONS(5818),
    [anon_sym_BSLASHominus] = ACTIONS(5818),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2296] = ACTIONS(5818),
    [sym_mod] = ACTIONS(5820),
    [sym_modmod] = ACTIONS(5818),
    [sym_vert] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_u2016] = ACTIONS(5818),
    [sym_minusminus] = ACTIONS(5818),
    [sym_amp] = ACTIONS(5820),
    [sym_ampamp] = ACTIONS(5818),
    [anon_sym_BSLASHodot] = ACTIONS(5818),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5818),
    [anon_sym_u2299] = ACTIONS(5818),
    [anon_sym_BSLASHoslash] = ACTIONS(5818),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5818),
    [anon_sym_u2298] = ACTIONS(5818),
    [anon_sym_BSLASHotimes] = ACTIONS(5818),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5818),
    [anon_sym_u2297] = ACTIONS(5818),
    [sym_mul] = ACTIONS(5820),
    [sym_mulmul] = ACTIONS(5818),
    [sym_slash] = ACTIONS(5820),
    [sym_slashslash] = ACTIONS(5818),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5818),
    [anon_sym_u25ef] = ACTIONS(5818),
    [anon_sym_BSLASHbullet] = ACTIONS(5818),
    [anon_sym_u25cf] = ACTIONS(5818),
    [anon_sym_BSLASHdiv] = ACTIONS(5818),
    [anon_sym_u00f7] = ACTIONS(5818),
    [anon_sym_BSLASHcirc] = ACTIONS(5818),
    [anon_sym_u2218] = ACTIONS(5818),
    [anon_sym_BSLASHstar] = ACTIONS(5818),
    [anon_sym_u22c6] = ACTIONS(5818),
    [anon_sym_u203c] = ACTIONS(5818),
    [sym_hashhash] = ACTIONS(5818),
    [sym_dol] = ACTIONS(5820),
    [sym_doldol] = ACTIONS(5818),
    [anon_sym_QMARK_QMARK] = ACTIONS(5818),
    [anon_sym_u2047] = ACTIONS(5818),
    [anon_sym_BSLASHsqcap] = ACTIONS(5818),
    [anon_sym_u2293] = ACTIONS(5818),
    [anon_sym_BSLASHsqcup] = ACTIONS(5818),
    [anon_sym_u2294] = ACTIONS(5818),
    [anon_sym_BSLASHuplus] = ACTIONS(5818),
    [anon_sym_u228e] = ACTIONS(5818),
    [anon_sym_BSLASHX] = ACTIONS(5818),
    [anon_sym_BSLASHtimes] = ACTIONS(5818),
    [anon_sym_u00d7] = ACTIONS(5818),
    [anon_sym_BSLASHwr] = ACTIONS(5818),
    [anon_sym_u2240] = ACTIONS(5818),
    [anon_sym_BSLASHcdot] = ACTIONS(5818),
    [anon_sym_u22c5] = ACTIONS(5818),
    [sym_pow] = ACTIONS(5820),
    [sym_powpow] = ACTIONS(5818),
    [anon_sym_CARET_PLUS] = ACTIONS(5818),
    [anon_sym_u207a] = ACTIONS(5818),
    [sym_asterisk] = ACTIONS(5818),
    [sym_sup_hash] = ACTIONS(5818),
    [sym_prime] = ACTIONS(5818),
    [sym__bullet] = ACTIONS(5818),
    [sym__dedent] = ACTIONS(5818),
    [sym__double_excl] = ACTIONS(5818),
  },
  [3367] = {
    [sym_block_comment] = STATE(3367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5858),
    [anon_sym_u2208] = ACTIONS(5860),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5860),
    [anon_sym_u25a1] = ACTIONS(5860),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5860),
    [anon_sym_u2227] = ACTIONS(5860),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5860),
    [anon_sym_u2228] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_BSLASHo] = ACTIONS(5858),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27f9] = ACTIONS(5860),
    [anon_sym_u21d2] = ACTIONS(5860),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5860),
    [anon_sym_u21f8] = ACTIONS(5860),
    [anon_sym_u2945] = ACTIONS(5860),
    [anon_sym_BSLASHequiv] = ACTIONS(5860),
    [anon_sym_u2261] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_u27fa] = ACTIONS(5860),
    [anon_sym_u21d4] = ACTIONS(5860),
    [anon_sym_TILDE_GT] = ACTIONS(5860),
    [anon_sym_u21dd] = ACTIONS(5860),
    [anon_sym_u219d] = ACTIONS(5860),
    [anon_sym_BSLASHland] = ACTIONS(5860),
    [anon_sym_BSLASHlor] = ACTIONS(5860),
    [anon_sym_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2254] = ACTIONS(5860),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5860),
    [anon_sym_u2a74] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_u2260] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5858),
    [sym_gt] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ_LT] = ACTIONS(5860),
    [anon_sym_BSLASHleq] = ACTIONS(5860),
    [anon_sym_u2264] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_BSLASHgeq] = ACTIONS(5860),
    [anon_sym_u2265] = ACTIONS(5860),
    [anon_sym_BSLASHapprox] = ACTIONS(5860),
    [anon_sym_u2248] = ACTIONS(5860),
    [anon_sym_PIPE_DASH] = ACTIONS(5860),
    [anon_sym_u22a2] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_u22a8] = ACTIONS(5860),
    [anon_sym_DASH_PIPE] = ACTIONS(5860),
    [anon_sym_u22a3] = ACTIONS(5860),
    [anon_sym_EQ_PIPE] = ACTIONS(5860),
    [anon_sym_u2ae4] = ACTIONS(5860),
    [anon_sym_BSLASHasymp] = ACTIONS(5860),
    [anon_sym_u224d] = ACTIONS(5860),
    [anon_sym_BSLASHcong] = ACTIONS(5860),
    [anon_sym_u2245] = ACTIONS(5860),
    [anon_sym_BSLASHdoteq] = ACTIONS(5860),
    [anon_sym_u2250] = ACTIONS(5860),
    [anon_sym_BSLASHgg] = ACTIONS(5860),
    [anon_sym_u226b] = ACTIONS(5860),
    [anon_sym_BSLASHll] = ACTIONS(5860),
    [anon_sym_u226a] = ACTIONS(5860),
    [anon_sym_BSLASHnotin] = ACTIONS(5860),
    [anon_sym_u2209] = ACTIONS(5860),
    [anon_sym_BSLASHprec] = ACTIONS(5858),
    [anon_sym_u227a] = ACTIONS(5860),
    [anon_sym_BSLASHsucc] = ACTIONS(5858),
    [anon_sym_u227b] = ACTIONS(5860),
    [anon_sym_BSLASHpreceq] = ACTIONS(5860),
    [anon_sym_u2aaf] = ACTIONS(5860),
    [anon_sym_BSLASHsucceq] = ACTIONS(5860),
    [anon_sym_u2ab0] = ACTIONS(5860),
    [anon_sym_BSLASHpropto] = ACTIONS(5860),
    [anon_sym_u221d] = ACTIONS(5860),
    [anon_sym_BSLASHsim] = ACTIONS(5858),
    [anon_sym_u223c] = ACTIONS(5860),
    [anon_sym_BSLASHsimeq] = ACTIONS(5860),
    [anon_sym_u2243] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5858),
    [anon_sym_u228f] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5858),
    [anon_sym_u2290] = ACTIONS(5860),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5860),
    [anon_sym_u2291] = ACTIONS(5860),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5860),
    [anon_sym_u2292] = ACTIONS(5860),
    [anon_sym_BSLASHsubset] = ACTIONS(5858),
    [anon_sym_u2282] = ACTIONS(5860),
    [anon_sym_BSLASHsupset] = ACTIONS(5858),
    [anon_sym_u2283] = ACTIONS(5860),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5860),
    [anon_sym_u2286] = ACTIONS(5860),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5860),
    [anon_sym_u2287] = ACTIONS(5860),
    [sym_compose] = ACTIONS(5860),
    [sym_map_to] = ACTIONS(5860),
    [sym_map_from] = ACTIONS(5860),
    [sym_setminus] = ACTIONS(5858),
    [anon_sym_BSLASHcap] = ACTIONS(5860),
    [anon_sym_BSLASHintersect] = ACTIONS(5860),
    [anon_sym_u2229] = ACTIONS(5860),
    [anon_sym_BSLASHcup] = ACTIONS(5860),
    [anon_sym_BSLASHunion] = ACTIONS(5860),
    [anon_sym_u222a] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_u2025] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_u2026] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5858),
    [sym_plusplus] = ACTIONS(5860),
    [anon_sym_BSLASHoplus] = ACTIONS(5860),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5860),
    [anon_sym_u2295] = ACTIONS(5860),
    [anon_sym_BSLASHominus] = ACTIONS(5860),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2296] = ACTIONS(5860),
    [sym_mod] = ACTIONS(5858),
    [sym_modmod] = ACTIONS(5860),
    [sym_vert] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_u2016] = ACTIONS(5860),
    [sym_minusminus] = ACTIONS(5860),
    [sym_amp] = ACTIONS(5858),
    [sym_ampamp] = ACTIONS(5860),
    [anon_sym_BSLASHodot] = ACTIONS(5860),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5860),
    [anon_sym_u2299] = ACTIONS(5860),
    [anon_sym_BSLASHoslash] = ACTIONS(5860),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5860),
    [anon_sym_u2298] = ACTIONS(5860),
    [anon_sym_BSLASHotimes] = ACTIONS(5860),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5860),
    [anon_sym_u2297] = ACTIONS(5860),
    [sym_mul] = ACTIONS(5858),
    [sym_mulmul] = ACTIONS(5860),
    [sym_slash] = ACTIONS(5858),
    [sym_slashslash] = ACTIONS(5860),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5860),
    [anon_sym_u25ef] = ACTIONS(5860),
    [anon_sym_BSLASHbullet] = ACTIONS(5860),
    [anon_sym_u25cf] = ACTIONS(5860),
    [anon_sym_BSLASHdiv] = ACTIONS(5860),
    [anon_sym_u00f7] = ACTIONS(5860),
    [anon_sym_BSLASHcirc] = ACTIONS(5860),
    [anon_sym_u2218] = ACTIONS(5860),
    [anon_sym_BSLASHstar] = ACTIONS(5860),
    [anon_sym_u22c6] = ACTIONS(5860),
    [anon_sym_u203c] = ACTIONS(5860),
    [sym_hashhash] = ACTIONS(5860),
    [sym_dol] = ACTIONS(5858),
    [sym_doldol] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_u2047] = ACTIONS(5860),
    [anon_sym_BSLASHsqcap] = ACTIONS(5860),
    [anon_sym_u2293] = ACTIONS(5860),
    [anon_sym_BSLASHsqcup] = ACTIONS(5860),
    [anon_sym_u2294] = ACTIONS(5860),
    [anon_sym_BSLASHuplus] = ACTIONS(5860),
    [anon_sym_u228e] = ACTIONS(5860),
    [anon_sym_BSLASHX] = ACTIONS(5860),
    [anon_sym_BSLASHtimes] = ACTIONS(5860),
    [anon_sym_u00d7] = ACTIONS(5860),
    [anon_sym_BSLASHwr] = ACTIONS(5860),
    [anon_sym_u2240] = ACTIONS(5860),
    [anon_sym_BSLASHcdot] = ACTIONS(5860),
    [anon_sym_u22c5] = ACTIONS(5860),
    [sym_pow] = ACTIONS(5858),
    [sym_powpow] = ACTIONS(5860),
    [anon_sym_CARET_PLUS] = ACTIONS(5860),
    [anon_sym_u207a] = ACTIONS(5860),
    [sym_asterisk] = ACTIONS(5860),
    [sym_sup_hash] = ACTIONS(5860),
    [sym_prime] = ACTIONS(5860),
    [sym__bullet] = ACTIONS(5860),
    [sym__dedent] = ACTIONS(5860),
    [sym__double_excl] = ACTIONS(5860),
  },
  [3368] = {
    [sym_block_comment] = STATE(3368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5840),
    [anon_sym_u2208] = ACTIONS(5838),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5838),
    [anon_sym_u25a1] = ACTIONS(5838),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5838),
    [anon_sym_u2227] = ACTIONS(5838),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5838),
    [anon_sym_u2228] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_BSLASHo] = ACTIONS(5840),
    [anon_sym_DOT] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_DASH] = ACTIONS(5840),
    [anon_sym_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27f9] = ACTIONS(5838),
    [anon_sym_u21d2] = ACTIONS(5838),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5838),
    [anon_sym_u21f8] = ACTIONS(5838),
    [anon_sym_u2945] = ACTIONS(5838),
    [anon_sym_BSLASHequiv] = ACTIONS(5838),
    [anon_sym_u2261] = ACTIONS(5838),
    [anon_sym_LT_EQ_GT] = ACTIONS(5838),
    [anon_sym_u27fa] = ACTIONS(5838),
    [anon_sym_u21d4] = ACTIONS(5838),
    [anon_sym_TILDE_GT] = ACTIONS(5838),
    [anon_sym_u21dd] = ACTIONS(5838),
    [anon_sym_u219d] = ACTIONS(5838),
    [anon_sym_BSLASHland] = ACTIONS(5838),
    [anon_sym_BSLASHlor] = ACTIONS(5838),
    [anon_sym_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2254] = ACTIONS(5838),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5838),
    [anon_sym_u2a74] = ACTIONS(5838),
    [anon_sym_SLASH_EQ] = ACTIONS(5838),
    [anon_sym_POUND] = ACTIONS(5840),
    [anon_sym_u2260] = ACTIONS(5838),
    [anon_sym_LT] = ACTIONS(5840),
    [sym_gt] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_EQ_LT] = ACTIONS(5838),
    [anon_sym_BSLASHleq] = ACTIONS(5838),
    [anon_sym_u2264] = ACTIONS(5838),
    [anon_sym_GT_EQ] = ACTIONS(5838),
    [anon_sym_BSLASHgeq] = ACTIONS(5838),
    [anon_sym_u2265] = ACTIONS(5838),
    [anon_sym_BSLASHapprox] = ACTIONS(5838),
    [anon_sym_u2248] = ACTIONS(5838),
    [anon_sym_PIPE_DASH] = ACTIONS(5838),
    [anon_sym_u22a2] = ACTIONS(5838),
    [anon_sym_PIPE_EQ] = ACTIONS(5838),
    [anon_sym_u22a8] = ACTIONS(5838),
    [anon_sym_DASH_PIPE] = ACTIONS(5838),
    [anon_sym_u22a3] = ACTIONS(5838),
    [anon_sym_EQ_PIPE] = ACTIONS(5838),
    [anon_sym_u2ae4] = ACTIONS(5838),
    [anon_sym_BSLASHasymp] = ACTIONS(5838),
    [anon_sym_u224d] = ACTIONS(5838),
    [anon_sym_BSLASHcong] = ACTIONS(5838),
    [anon_sym_u2245] = ACTIONS(5838),
    [anon_sym_BSLASHdoteq] = ACTIONS(5838),
    [anon_sym_u2250] = ACTIONS(5838),
    [anon_sym_BSLASHgg] = ACTIONS(5838),
    [anon_sym_u226b] = ACTIONS(5838),
    [anon_sym_BSLASHll] = ACTIONS(5838),
    [anon_sym_u226a] = ACTIONS(5838),
    [anon_sym_BSLASHnotin] = ACTIONS(5838),
    [anon_sym_u2209] = ACTIONS(5838),
    [anon_sym_BSLASHprec] = ACTIONS(5840),
    [anon_sym_u227a] = ACTIONS(5838),
    [anon_sym_BSLASHsucc] = ACTIONS(5840),
    [anon_sym_u227b] = ACTIONS(5838),
    [anon_sym_BSLASHpreceq] = ACTIONS(5838),
    [anon_sym_u2aaf] = ACTIONS(5838),
    [anon_sym_BSLASHsucceq] = ACTIONS(5838),
    [anon_sym_u2ab0] = ACTIONS(5838),
    [anon_sym_BSLASHpropto] = ACTIONS(5838),
    [anon_sym_u221d] = ACTIONS(5838),
    [anon_sym_BSLASHsim] = ACTIONS(5840),
    [anon_sym_u223c] = ACTIONS(5838),
    [anon_sym_BSLASHsimeq] = ACTIONS(5838),
    [anon_sym_u2243] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5840),
    [anon_sym_u228f] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5840),
    [anon_sym_u2290] = ACTIONS(5838),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5838),
    [anon_sym_u2291] = ACTIONS(5838),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5838),
    [anon_sym_u2292] = ACTIONS(5838),
    [anon_sym_BSLASHsubset] = ACTIONS(5840),
    [anon_sym_u2282] = ACTIONS(5838),
    [anon_sym_BSLASHsupset] = ACTIONS(5840),
    [anon_sym_u2283] = ACTIONS(5838),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5838),
    [anon_sym_u2286] = ACTIONS(5838),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5838),
    [anon_sym_u2287] = ACTIONS(5838),
    [sym_compose] = ACTIONS(5838),
    [sym_map_to] = ACTIONS(5838),
    [sym_map_from] = ACTIONS(5838),
    [sym_setminus] = ACTIONS(5840),
    [anon_sym_BSLASHcap] = ACTIONS(5838),
    [anon_sym_BSLASHintersect] = ACTIONS(5838),
    [anon_sym_u2229] = ACTIONS(5838),
    [anon_sym_BSLASHcup] = ACTIONS(5838),
    [anon_sym_BSLASHunion] = ACTIONS(5838),
    [anon_sym_u222a] = ACTIONS(5838),
    [anon_sym_DOT_DOT] = ACTIONS(5840),
    [anon_sym_u2025] = ACTIONS(5838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5838),
    [anon_sym_u2026] = ACTIONS(5838),
    [anon_sym_PLUS] = ACTIONS(5840),
    [sym_plusplus] = ACTIONS(5838),
    [anon_sym_BSLASHoplus] = ACTIONS(5838),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5838),
    [anon_sym_u2295] = ACTIONS(5838),
    [anon_sym_BSLASHominus] = ACTIONS(5838),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2296] = ACTIONS(5838),
    [sym_mod] = ACTIONS(5840),
    [sym_modmod] = ACTIONS(5838),
    [sym_vert] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE] = ACTIONS(5838),
    [anon_sym_u2016] = ACTIONS(5838),
    [sym_minusminus] = ACTIONS(5838),
    [sym_amp] = ACTIONS(5840),
    [sym_ampamp] = ACTIONS(5838),
    [anon_sym_BSLASHodot] = ACTIONS(5838),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5838),
    [anon_sym_u2299] = ACTIONS(5838),
    [anon_sym_BSLASHoslash] = ACTIONS(5838),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5838),
    [anon_sym_u2298] = ACTIONS(5838),
    [anon_sym_BSLASHotimes] = ACTIONS(5838),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5838),
    [anon_sym_u2297] = ACTIONS(5838),
    [sym_mul] = ACTIONS(5840),
    [sym_mulmul] = ACTIONS(5838),
    [sym_slash] = ACTIONS(5840),
    [sym_slashslash] = ACTIONS(5838),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5838),
    [anon_sym_u25ef] = ACTIONS(5838),
    [anon_sym_BSLASHbullet] = ACTIONS(5838),
    [anon_sym_u25cf] = ACTIONS(5838),
    [anon_sym_BSLASHdiv] = ACTIONS(5838),
    [anon_sym_u00f7] = ACTIONS(5838),
    [anon_sym_BSLASHcirc] = ACTIONS(5838),
    [anon_sym_u2218] = ACTIONS(5838),
    [anon_sym_BSLASHstar] = ACTIONS(5838),
    [anon_sym_u22c6] = ACTIONS(5838),
    [anon_sym_u203c] = ACTIONS(5838),
    [sym_hashhash] = ACTIONS(5838),
    [sym_dol] = ACTIONS(5840),
    [sym_doldol] = ACTIONS(5838),
    [anon_sym_QMARK_QMARK] = ACTIONS(5838),
    [anon_sym_u2047] = ACTIONS(5838),
    [anon_sym_BSLASHsqcap] = ACTIONS(5838),
    [anon_sym_u2293] = ACTIONS(5838),
    [anon_sym_BSLASHsqcup] = ACTIONS(5838),
    [anon_sym_u2294] = ACTIONS(5838),
    [anon_sym_BSLASHuplus] = ACTIONS(5838),
    [anon_sym_u228e] = ACTIONS(5838),
    [anon_sym_BSLASHX] = ACTIONS(5838),
    [anon_sym_BSLASHtimes] = ACTIONS(5838),
    [anon_sym_u00d7] = ACTIONS(5838),
    [anon_sym_BSLASHwr] = ACTIONS(5838),
    [anon_sym_u2240] = ACTIONS(5838),
    [anon_sym_BSLASHcdot] = ACTIONS(5838),
    [anon_sym_u22c5] = ACTIONS(5838),
    [sym_pow] = ACTIONS(5840),
    [sym_powpow] = ACTIONS(5838),
    [anon_sym_CARET_PLUS] = ACTIONS(5838),
    [anon_sym_u207a] = ACTIONS(5838),
    [sym_asterisk] = ACTIONS(5838),
    [sym_sup_hash] = ACTIONS(5838),
    [sym_prime] = ACTIONS(5838),
    [sym__bullet] = ACTIONS(5838),
    [sym__dedent] = ACTIONS(5838),
    [sym__double_excl] = ACTIONS(5838),
  },
  [3369] = {
    [sym_block_comment] = STATE(3369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5844),
    [anon_sym_u2208] = ACTIONS(5842),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5842),
    [anon_sym_u25a1] = ACTIONS(5842),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5842),
    [anon_sym_u2227] = ACTIONS(5842),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5842),
    [anon_sym_u2228] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_BSLASHo] = ACTIONS(5844),
    [anon_sym_DOT] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5844),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27f9] = ACTIONS(5842),
    [anon_sym_u21d2] = ACTIONS(5842),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5842),
    [anon_sym_u21f8] = ACTIONS(5842),
    [anon_sym_u2945] = ACTIONS(5842),
    [anon_sym_BSLASHequiv] = ACTIONS(5842),
    [anon_sym_u2261] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5842),
    [anon_sym_u27fa] = ACTIONS(5842),
    [anon_sym_u21d4] = ACTIONS(5842),
    [anon_sym_TILDE_GT] = ACTIONS(5842),
    [anon_sym_u21dd] = ACTIONS(5842),
    [anon_sym_u219d] = ACTIONS(5842),
    [anon_sym_BSLASHland] = ACTIONS(5842),
    [anon_sym_BSLASHlor] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2254] = ACTIONS(5842),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5842),
    [anon_sym_u2a74] = ACTIONS(5842),
    [anon_sym_SLASH_EQ] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5844),
    [anon_sym_u2260] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [sym_gt] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5844),
    [anon_sym_EQ_LT] = ACTIONS(5842),
    [anon_sym_BSLASHleq] = ACTIONS(5842),
    [anon_sym_u2264] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5842),
    [anon_sym_BSLASHgeq] = ACTIONS(5842),
    [anon_sym_u2265] = ACTIONS(5842),
    [anon_sym_BSLASHapprox] = ACTIONS(5842),
    [anon_sym_u2248] = ACTIONS(5842),
    [anon_sym_PIPE_DASH] = ACTIONS(5842),
    [anon_sym_u22a2] = ACTIONS(5842),
    [anon_sym_PIPE_EQ] = ACTIONS(5842),
    [anon_sym_u22a8] = ACTIONS(5842),
    [anon_sym_DASH_PIPE] = ACTIONS(5842),
    [anon_sym_u22a3] = ACTIONS(5842),
    [anon_sym_EQ_PIPE] = ACTIONS(5842),
    [anon_sym_u2ae4] = ACTIONS(5842),
    [anon_sym_BSLASHasymp] = ACTIONS(5842),
    [anon_sym_u224d] = ACTIONS(5842),
    [anon_sym_BSLASHcong] = ACTIONS(5842),
    [anon_sym_u2245] = ACTIONS(5842),
    [anon_sym_BSLASHdoteq] = ACTIONS(5842),
    [anon_sym_u2250] = ACTIONS(5842),
    [anon_sym_BSLASHgg] = ACTIONS(5842),
    [anon_sym_u226b] = ACTIONS(5842),
    [anon_sym_BSLASHll] = ACTIONS(5842),
    [anon_sym_u226a] = ACTIONS(5842),
    [anon_sym_BSLASHnotin] = ACTIONS(5842),
    [anon_sym_u2209] = ACTIONS(5842),
    [anon_sym_BSLASHprec] = ACTIONS(5844),
    [anon_sym_u227a] = ACTIONS(5842),
    [anon_sym_BSLASHsucc] = ACTIONS(5844),
    [anon_sym_u227b] = ACTIONS(5842),
    [anon_sym_BSLASHpreceq] = ACTIONS(5842),
    [anon_sym_u2aaf] = ACTIONS(5842),
    [anon_sym_BSLASHsucceq] = ACTIONS(5842),
    [anon_sym_u2ab0] = ACTIONS(5842),
    [anon_sym_BSLASHpropto] = ACTIONS(5842),
    [anon_sym_u221d] = ACTIONS(5842),
    [anon_sym_BSLASHsim] = ACTIONS(5844),
    [anon_sym_u223c] = ACTIONS(5842),
    [anon_sym_BSLASHsimeq] = ACTIONS(5842),
    [anon_sym_u2243] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5844),
    [anon_sym_u228f] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5844),
    [anon_sym_u2290] = ACTIONS(5842),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5842),
    [anon_sym_u2291] = ACTIONS(5842),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5842),
    [anon_sym_u2292] = ACTIONS(5842),
    [anon_sym_BSLASHsubset] = ACTIONS(5844),
    [anon_sym_u2282] = ACTIONS(5842),
    [anon_sym_BSLASHsupset] = ACTIONS(5844),
    [anon_sym_u2283] = ACTIONS(5842),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5842),
    [anon_sym_u2286] = ACTIONS(5842),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5842),
    [anon_sym_u2287] = ACTIONS(5842),
    [sym_compose] = ACTIONS(5842),
    [sym_map_to] = ACTIONS(5842),
    [sym_map_from] = ACTIONS(5842),
    [sym_setminus] = ACTIONS(5844),
    [anon_sym_BSLASHcap] = ACTIONS(5842),
    [anon_sym_BSLASHintersect] = ACTIONS(5842),
    [anon_sym_u2229] = ACTIONS(5842),
    [anon_sym_BSLASHcup] = ACTIONS(5842),
    [anon_sym_BSLASHunion] = ACTIONS(5842),
    [anon_sym_u222a] = ACTIONS(5842),
    [anon_sym_DOT_DOT] = ACTIONS(5844),
    [anon_sym_u2025] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5842),
    [anon_sym_u2026] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5844),
    [sym_plusplus] = ACTIONS(5842),
    [anon_sym_BSLASHoplus] = ACTIONS(5842),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5842),
    [anon_sym_u2295] = ACTIONS(5842),
    [anon_sym_BSLASHominus] = ACTIONS(5842),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2296] = ACTIONS(5842),
    [sym_mod] = ACTIONS(5844),
    [sym_modmod] = ACTIONS(5842),
    [sym_vert] = ACTIONS(5844),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_u2016] = ACTIONS(5842),
    [sym_minusminus] = ACTIONS(5842),
    [sym_amp] = ACTIONS(5844),
    [sym_ampamp] = ACTIONS(5842),
    [anon_sym_BSLASHodot] = ACTIONS(5842),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5842),
    [anon_sym_u2299] = ACTIONS(5842),
    [anon_sym_BSLASHoslash] = ACTIONS(5842),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5842),
    [anon_sym_u2298] = ACTIONS(5842),
    [anon_sym_BSLASHotimes] = ACTIONS(5842),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5842),
    [anon_sym_u2297] = ACTIONS(5842),
    [sym_mul] = ACTIONS(5844),
    [sym_mulmul] = ACTIONS(5842),
    [sym_slash] = ACTIONS(5844),
    [sym_slashslash] = ACTIONS(5842),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5842),
    [anon_sym_u25ef] = ACTIONS(5842),
    [anon_sym_BSLASHbullet] = ACTIONS(5842),
    [anon_sym_u25cf] = ACTIONS(5842),
    [anon_sym_BSLASHdiv] = ACTIONS(5842),
    [anon_sym_u00f7] = ACTIONS(5842),
    [anon_sym_BSLASHcirc] = ACTIONS(5842),
    [anon_sym_u2218] = ACTIONS(5842),
    [anon_sym_BSLASHstar] = ACTIONS(5842),
    [anon_sym_u22c6] = ACTIONS(5842),
    [anon_sym_u203c] = ACTIONS(5842),
    [sym_hashhash] = ACTIONS(5842),
    [sym_dol] = ACTIONS(5844),
    [sym_doldol] = ACTIONS(5842),
    [anon_sym_QMARK_QMARK] = ACTIONS(5842),
    [anon_sym_u2047] = ACTIONS(5842),
    [anon_sym_BSLASHsqcap] = ACTIONS(5842),
    [anon_sym_u2293] = ACTIONS(5842),
    [anon_sym_BSLASHsqcup] = ACTIONS(5842),
    [anon_sym_u2294] = ACTIONS(5842),
    [anon_sym_BSLASHuplus] = ACTIONS(5842),
    [anon_sym_u228e] = ACTIONS(5842),
    [anon_sym_BSLASHX] = ACTIONS(5842),
    [anon_sym_BSLASHtimes] = ACTIONS(5842),
    [anon_sym_u00d7] = ACTIONS(5842),
    [anon_sym_BSLASHwr] = ACTIONS(5842),
    [anon_sym_u2240] = ACTIONS(5842),
    [anon_sym_BSLASHcdot] = ACTIONS(5842),
    [anon_sym_u22c5] = ACTIONS(5842),
    [sym_pow] = ACTIONS(5844),
    [sym_powpow] = ACTIONS(5842),
    [anon_sym_CARET_PLUS] = ACTIONS(5842),
    [anon_sym_u207a] = ACTIONS(5842),
    [sym_asterisk] = ACTIONS(5842),
    [sym_sup_hash] = ACTIONS(5842),
    [sym_prime] = ACTIONS(5842),
    [sym__bullet] = ACTIONS(5842),
    [sym__dedent] = ACTIONS(5842),
    [sym__double_excl] = ACTIONS(5842),
  },
  [3370] = {
    [sym_block_comment] = STATE(3370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5770),
    [anon_sym_u2208] = ACTIONS(5768),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5768),
    [anon_sym_u25a1] = ACTIONS(5768),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5768),
    [anon_sym_u2227] = ACTIONS(5768),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5768),
    [anon_sym_u2228] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(5770),
    [anon_sym_BSLASHo] = ACTIONS(5770),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27f9] = ACTIONS(5768),
    [anon_sym_u21d2] = ACTIONS(5768),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5768),
    [anon_sym_u21f8] = ACTIONS(5768),
    [anon_sym_u2945] = ACTIONS(5768),
    [anon_sym_BSLASHequiv] = ACTIONS(5768),
    [anon_sym_u2261] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5768),
    [anon_sym_u27fa] = ACTIONS(5768),
    [anon_sym_u21d4] = ACTIONS(5768),
    [anon_sym_TILDE_GT] = ACTIONS(5768),
    [anon_sym_u21dd] = ACTIONS(5768),
    [anon_sym_u219d] = ACTIONS(5768),
    [anon_sym_BSLASHland] = ACTIONS(5768),
    [anon_sym_BSLASHlor] = ACTIONS(5768),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2254] = ACTIONS(5768),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5768),
    [anon_sym_u2a74] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_u2260] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [sym_gt] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_EQ_LT] = ACTIONS(5768),
    [anon_sym_BSLASHleq] = ACTIONS(5768),
    [anon_sym_u2264] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_BSLASHgeq] = ACTIONS(5768),
    [anon_sym_u2265] = ACTIONS(5768),
    [anon_sym_BSLASHapprox] = ACTIONS(5768),
    [anon_sym_u2248] = ACTIONS(5768),
    [anon_sym_PIPE_DASH] = ACTIONS(5768),
    [anon_sym_u22a2] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_u22a8] = ACTIONS(5768),
    [anon_sym_DASH_PIPE] = ACTIONS(5768),
    [anon_sym_u22a3] = ACTIONS(5768),
    [anon_sym_EQ_PIPE] = ACTIONS(5768),
    [anon_sym_u2ae4] = ACTIONS(5768),
    [anon_sym_BSLASHasymp] = ACTIONS(5768),
    [anon_sym_u224d] = ACTIONS(5768),
    [anon_sym_BSLASHcong] = ACTIONS(5768),
    [anon_sym_u2245] = ACTIONS(5768),
    [anon_sym_BSLASHdoteq] = ACTIONS(5768),
    [anon_sym_u2250] = ACTIONS(5768),
    [anon_sym_BSLASHgg] = ACTIONS(5768),
    [anon_sym_u226b] = ACTIONS(5768),
    [anon_sym_BSLASHll] = ACTIONS(5768),
    [anon_sym_u226a] = ACTIONS(5768),
    [anon_sym_BSLASHnotin] = ACTIONS(5768),
    [anon_sym_u2209] = ACTIONS(5768),
    [anon_sym_BSLASHprec] = ACTIONS(5770),
    [anon_sym_u227a] = ACTIONS(5768),
    [anon_sym_BSLASHsucc] = ACTIONS(5770),
    [anon_sym_u227b] = ACTIONS(5768),
    [anon_sym_BSLASHpreceq] = ACTIONS(5768),
    [anon_sym_u2aaf] = ACTIONS(5768),
    [anon_sym_BSLASHsucceq] = ACTIONS(5768),
    [anon_sym_u2ab0] = ACTIONS(5768),
    [anon_sym_BSLASHpropto] = ACTIONS(5768),
    [anon_sym_u221d] = ACTIONS(5768),
    [anon_sym_BSLASHsim] = ACTIONS(5770),
    [anon_sym_u223c] = ACTIONS(5768),
    [anon_sym_BSLASHsimeq] = ACTIONS(5768),
    [anon_sym_u2243] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5770),
    [anon_sym_u228f] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5770),
    [anon_sym_u2290] = ACTIONS(5768),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5768),
    [anon_sym_u2291] = ACTIONS(5768),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5768),
    [anon_sym_u2292] = ACTIONS(5768),
    [anon_sym_BSLASHsubset] = ACTIONS(5770),
    [anon_sym_u2282] = ACTIONS(5768),
    [anon_sym_BSLASHsupset] = ACTIONS(5770),
    [anon_sym_u2283] = ACTIONS(5768),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5768),
    [anon_sym_u2286] = ACTIONS(5768),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5768),
    [anon_sym_u2287] = ACTIONS(5768),
    [sym_compose] = ACTIONS(5768),
    [sym_map_to] = ACTIONS(5768),
    [sym_map_from] = ACTIONS(5768),
    [sym_setminus] = ACTIONS(5770),
    [anon_sym_BSLASHcap] = ACTIONS(5768),
    [anon_sym_BSLASHintersect] = ACTIONS(5768),
    [anon_sym_u2229] = ACTIONS(5768),
    [anon_sym_BSLASHcup] = ACTIONS(5768),
    [anon_sym_BSLASHunion] = ACTIONS(5768),
    [anon_sym_u222a] = ACTIONS(5768),
    [anon_sym_DOT_DOT] = ACTIONS(5770),
    [anon_sym_u2025] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5768),
    [anon_sym_u2026] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [sym_plusplus] = ACTIONS(5768),
    [anon_sym_BSLASHoplus] = ACTIONS(5768),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5768),
    [anon_sym_u2295] = ACTIONS(5768),
    [anon_sym_BSLASHominus] = ACTIONS(5768),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2296] = ACTIONS(5768),
    [sym_mod] = ACTIONS(5770),
    [sym_modmod] = ACTIONS(5768),
    [sym_vert] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5768),
    [anon_sym_u2016] = ACTIONS(5768),
    [sym_minusminus] = ACTIONS(5768),
    [sym_amp] = ACTIONS(5770),
    [sym_ampamp] = ACTIONS(5768),
    [anon_sym_BSLASHodot] = ACTIONS(5768),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5768),
    [anon_sym_u2299] = ACTIONS(5768),
    [anon_sym_BSLASHoslash] = ACTIONS(5768),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5768),
    [anon_sym_u2298] = ACTIONS(5768),
    [anon_sym_BSLASHotimes] = ACTIONS(5768),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5768),
    [anon_sym_u2297] = ACTIONS(5768),
    [sym_mul] = ACTIONS(5770),
    [sym_mulmul] = ACTIONS(5768),
    [sym_slash] = ACTIONS(5770),
    [sym_slashslash] = ACTIONS(5768),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5768),
    [anon_sym_u25ef] = ACTIONS(5768),
    [anon_sym_BSLASHbullet] = ACTIONS(5768),
    [anon_sym_u25cf] = ACTIONS(5768),
    [anon_sym_BSLASHdiv] = ACTIONS(5768),
    [anon_sym_u00f7] = ACTIONS(5768),
    [anon_sym_BSLASHcirc] = ACTIONS(5768),
    [anon_sym_u2218] = ACTIONS(5768),
    [anon_sym_BSLASHstar] = ACTIONS(5768),
    [anon_sym_u22c6] = ACTIONS(5768),
    [anon_sym_u203c] = ACTIONS(5768),
    [sym_hashhash] = ACTIONS(5768),
    [sym_dol] = ACTIONS(5770),
    [sym_doldol] = ACTIONS(5768),
    [anon_sym_QMARK_QMARK] = ACTIONS(5768),
    [anon_sym_u2047] = ACTIONS(5768),
    [anon_sym_BSLASHsqcap] = ACTIONS(5768),
    [anon_sym_u2293] = ACTIONS(5768),
    [anon_sym_BSLASHsqcup] = ACTIONS(5768),
    [anon_sym_u2294] = ACTIONS(5768),
    [anon_sym_BSLASHuplus] = ACTIONS(5768),
    [anon_sym_u228e] = ACTIONS(5768),
    [anon_sym_BSLASHX] = ACTIONS(5768),
    [anon_sym_BSLASHtimes] = ACTIONS(5768),
    [anon_sym_u00d7] = ACTIONS(5768),
    [anon_sym_BSLASHwr] = ACTIONS(5768),
    [anon_sym_u2240] = ACTIONS(5768),
    [anon_sym_BSLASHcdot] = ACTIONS(5768),
    [anon_sym_u22c5] = ACTIONS(5768),
    [sym_pow] = ACTIONS(5770),
    [sym_powpow] = ACTIONS(5768),
    [anon_sym_CARET_PLUS] = ACTIONS(5768),
    [anon_sym_u207a] = ACTIONS(5768),
    [sym_asterisk] = ACTIONS(5768),
    [sym_sup_hash] = ACTIONS(5768),
    [sym_prime] = ACTIONS(5768),
    [sym__bullet] = ACTIONS(5768),
    [sym__dedent] = ACTIONS(5768),
    [sym__double_excl] = ACTIONS(5768),
  },
  [3371] = {
    [sym_block_comment] = STATE(3371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5864),
    [anon_sym_u2208] = ACTIONS(5862),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5862),
    [anon_sym_u25a1] = ACTIONS(5862),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5862),
    [anon_sym_u2227] = ACTIONS(5862),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5862),
    [anon_sym_u2228] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_BSLASHo] = ACTIONS(5864),
    [anon_sym_DOT] = ACTIONS(5864),
    [anon_sym_EQ] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5864),
    [anon_sym_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27f9] = ACTIONS(5862),
    [anon_sym_u21d2] = ACTIONS(5862),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5862),
    [anon_sym_u21f8] = ACTIONS(5862),
    [anon_sym_u2945] = ACTIONS(5862),
    [anon_sym_BSLASHequiv] = ACTIONS(5862),
    [anon_sym_u2261] = ACTIONS(5862),
    [anon_sym_LT_EQ_GT] = ACTIONS(5862),
    [anon_sym_u27fa] = ACTIONS(5862),
    [anon_sym_u21d4] = ACTIONS(5862),
    [anon_sym_TILDE_GT] = ACTIONS(5862),
    [anon_sym_u21dd] = ACTIONS(5862),
    [anon_sym_u219d] = ACTIONS(5862),
    [anon_sym_BSLASHland] = ACTIONS(5862),
    [anon_sym_BSLASHlor] = ACTIONS(5862),
    [anon_sym_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2254] = ACTIONS(5862),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5862),
    [anon_sym_u2a74] = ACTIONS(5862),
    [anon_sym_SLASH_EQ] = ACTIONS(5862),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_u2260] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5864),
    [sym_gt] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_EQ_LT] = ACTIONS(5862),
    [anon_sym_BSLASHleq] = ACTIONS(5862),
    [anon_sym_u2264] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5862),
    [anon_sym_BSLASHgeq] = ACTIONS(5862),
    [anon_sym_u2265] = ACTIONS(5862),
    [anon_sym_BSLASHapprox] = ACTIONS(5862),
    [anon_sym_u2248] = ACTIONS(5862),
    [anon_sym_PIPE_DASH] = ACTIONS(5862),
    [anon_sym_u22a2] = ACTIONS(5862),
    [anon_sym_PIPE_EQ] = ACTIONS(5862),
    [anon_sym_u22a8] = ACTIONS(5862),
    [anon_sym_DASH_PIPE] = ACTIONS(5862),
    [anon_sym_u22a3] = ACTIONS(5862),
    [anon_sym_EQ_PIPE] = ACTIONS(5862),
    [anon_sym_u2ae4] = ACTIONS(5862),
    [anon_sym_BSLASHasymp] = ACTIONS(5862),
    [anon_sym_u224d] = ACTIONS(5862),
    [anon_sym_BSLASHcong] = ACTIONS(5862),
    [anon_sym_u2245] = ACTIONS(5862),
    [anon_sym_BSLASHdoteq] = ACTIONS(5862),
    [anon_sym_u2250] = ACTIONS(5862),
    [anon_sym_BSLASHgg] = ACTIONS(5862),
    [anon_sym_u226b] = ACTIONS(5862),
    [anon_sym_BSLASHll] = ACTIONS(5862),
    [anon_sym_u226a] = ACTIONS(5862),
    [anon_sym_BSLASHnotin] = ACTIONS(5862),
    [anon_sym_u2209] = ACTIONS(5862),
    [anon_sym_BSLASHprec] = ACTIONS(5864),
    [anon_sym_u227a] = ACTIONS(5862),
    [anon_sym_BSLASHsucc] = ACTIONS(5864),
    [anon_sym_u227b] = ACTIONS(5862),
    [anon_sym_BSLASHpreceq] = ACTIONS(5862),
    [anon_sym_u2aaf] = ACTIONS(5862),
    [anon_sym_BSLASHsucceq] = ACTIONS(5862),
    [anon_sym_u2ab0] = ACTIONS(5862),
    [anon_sym_BSLASHpropto] = ACTIONS(5862),
    [anon_sym_u221d] = ACTIONS(5862),
    [anon_sym_BSLASHsim] = ACTIONS(5864),
    [anon_sym_u223c] = ACTIONS(5862),
    [anon_sym_BSLASHsimeq] = ACTIONS(5862),
    [anon_sym_u2243] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5864),
    [anon_sym_u228f] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5864),
    [anon_sym_u2290] = ACTIONS(5862),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5862),
    [anon_sym_u2291] = ACTIONS(5862),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5862),
    [anon_sym_u2292] = ACTIONS(5862),
    [anon_sym_BSLASHsubset] = ACTIONS(5864),
    [anon_sym_u2282] = ACTIONS(5862),
    [anon_sym_BSLASHsupset] = ACTIONS(5864),
    [anon_sym_u2283] = ACTIONS(5862),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5862),
    [anon_sym_u2286] = ACTIONS(5862),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5862),
    [anon_sym_u2287] = ACTIONS(5862),
    [sym_compose] = ACTIONS(5862),
    [sym_map_to] = ACTIONS(5862),
    [sym_map_from] = ACTIONS(5862),
    [sym_setminus] = ACTIONS(5864),
    [anon_sym_BSLASHcap] = ACTIONS(5862),
    [anon_sym_BSLASHintersect] = ACTIONS(5862),
    [anon_sym_u2229] = ACTIONS(5862),
    [anon_sym_BSLASHcup] = ACTIONS(5862),
    [anon_sym_BSLASHunion] = ACTIONS(5862),
    [anon_sym_u222a] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_u2025] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5862),
    [anon_sym_u2026] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5864),
    [sym_plusplus] = ACTIONS(5862),
    [anon_sym_BSLASHoplus] = ACTIONS(5862),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5862),
    [anon_sym_u2295] = ACTIONS(5862),
    [anon_sym_BSLASHominus] = ACTIONS(5862),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2296] = ACTIONS(5862),
    [sym_mod] = ACTIONS(5864),
    [sym_modmod] = ACTIONS(5862),
    [sym_vert] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_u2016] = ACTIONS(5862),
    [sym_minusminus] = ACTIONS(5862),
    [sym_amp] = ACTIONS(5864),
    [sym_ampamp] = ACTIONS(5862),
    [anon_sym_BSLASHodot] = ACTIONS(5862),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5862),
    [anon_sym_u2299] = ACTIONS(5862),
    [anon_sym_BSLASHoslash] = ACTIONS(5862),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5862),
    [anon_sym_u2298] = ACTIONS(5862),
    [anon_sym_BSLASHotimes] = ACTIONS(5862),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5862),
    [anon_sym_u2297] = ACTIONS(5862),
    [sym_mul] = ACTIONS(5864),
    [sym_mulmul] = ACTIONS(5862),
    [sym_slash] = ACTIONS(5864),
    [sym_slashslash] = ACTIONS(5862),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5862),
    [anon_sym_u25ef] = ACTIONS(5862),
    [anon_sym_BSLASHbullet] = ACTIONS(5862),
    [anon_sym_u25cf] = ACTIONS(5862),
    [anon_sym_BSLASHdiv] = ACTIONS(5862),
    [anon_sym_u00f7] = ACTIONS(5862),
    [anon_sym_BSLASHcirc] = ACTIONS(5862),
    [anon_sym_u2218] = ACTIONS(5862),
    [anon_sym_BSLASHstar] = ACTIONS(5862),
    [anon_sym_u22c6] = ACTIONS(5862),
    [anon_sym_u203c] = ACTIONS(5862),
    [sym_hashhash] = ACTIONS(5862),
    [sym_dol] = ACTIONS(5864),
    [sym_doldol] = ACTIONS(5862),
    [anon_sym_QMARK_QMARK] = ACTIONS(5862),
    [anon_sym_u2047] = ACTIONS(5862),
    [anon_sym_BSLASHsqcap] = ACTIONS(5862),
    [anon_sym_u2293] = ACTIONS(5862),
    [anon_sym_BSLASHsqcup] = ACTIONS(5862),
    [anon_sym_u2294] = ACTIONS(5862),
    [anon_sym_BSLASHuplus] = ACTIONS(5862),
    [anon_sym_u228e] = ACTIONS(5862),
    [anon_sym_BSLASHX] = ACTIONS(5862),
    [anon_sym_BSLASHtimes] = ACTIONS(5862),
    [anon_sym_u00d7] = ACTIONS(5862),
    [anon_sym_BSLASHwr] = ACTIONS(5862),
    [anon_sym_u2240] = ACTIONS(5862),
    [anon_sym_BSLASHcdot] = ACTIONS(5862),
    [anon_sym_u22c5] = ACTIONS(5862),
    [sym_pow] = ACTIONS(5864),
    [sym_powpow] = ACTIONS(5862),
    [anon_sym_CARET_PLUS] = ACTIONS(5862),
    [anon_sym_u207a] = ACTIONS(5862),
    [sym_asterisk] = ACTIONS(5862),
    [sym_sup_hash] = ACTIONS(5862),
    [sym_prime] = ACTIONS(5862),
    [sym__bullet] = ACTIONS(5862),
    [sym__dedent] = ACTIONS(5862),
    [sym__double_excl] = ACTIONS(5862),
  },
  [3372] = {
    [sym_block_comment] = STATE(3372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5874),
    [anon_sym_u2208] = ACTIONS(5872),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5872),
    [anon_sym_u25a1] = ACTIONS(5872),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5872),
    [anon_sym_u2227] = ACTIONS(5872),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5872),
    [anon_sym_u2228] = ACTIONS(5872),
    [anon_sym_LBRACK] = ACTIONS(5874),
    [anon_sym_BSLASHo] = ACTIONS(5874),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [anon_sym_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27f9] = ACTIONS(5872),
    [anon_sym_u21d2] = ACTIONS(5872),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5872),
    [anon_sym_u21f8] = ACTIONS(5872),
    [anon_sym_u2945] = ACTIONS(5872),
    [anon_sym_BSLASHequiv] = ACTIONS(5872),
    [anon_sym_u2261] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5872),
    [anon_sym_u27fa] = ACTIONS(5872),
    [anon_sym_u21d4] = ACTIONS(5872),
    [anon_sym_TILDE_GT] = ACTIONS(5872),
    [anon_sym_u21dd] = ACTIONS(5872),
    [anon_sym_u219d] = ACTIONS(5872),
    [anon_sym_BSLASHland] = ACTIONS(5872),
    [anon_sym_BSLASHlor] = ACTIONS(5872),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2254] = ACTIONS(5872),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5872),
    [anon_sym_u2a74] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_POUND] = ACTIONS(5874),
    [anon_sym_u2260] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [sym_gt] = ACTIONS(5874),
    [anon_sym_LT_EQ] = ACTIONS(5874),
    [anon_sym_EQ_LT] = ACTIONS(5872),
    [anon_sym_BSLASHleq] = ACTIONS(5872),
    [anon_sym_u2264] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_BSLASHgeq] = ACTIONS(5872),
    [anon_sym_u2265] = ACTIONS(5872),
    [anon_sym_BSLASHapprox] = ACTIONS(5872),
    [anon_sym_u2248] = ACTIONS(5872),
    [anon_sym_PIPE_DASH] = ACTIONS(5872),
    [anon_sym_u22a2] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_u22a8] = ACTIONS(5872),
    [anon_sym_DASH_PIPE] = ACTIONS(5872),
    [anon_sym_u22a3] = ACTIONS(5872),
    [anon_sym_EQ_PIPE] = ACTIONS(5872),
    [anon_sym_u2ae4] = ACTIONS(5872),
    [anon_sym_BSLASHasymp] = ACTIONS(5872),
    [anon_sym_u224d] = ACTIONS(5872),
    [anon_sym_BSLASHcong] = ACTIONS(5872),
    [anon_sym_u2245] = ACTIONS(5872),
    [anon_sym_BSLASHdoteq] = ACTIONS(5872),
    [anon_sym_u2250] = ACTIONS(5872),
    [anon_sym_BSLASHgg] = ACTIONS(5872),
    [anon_sym_u226b] = ACTIONS(5872),
    [anon_sym_BSLASHll] = ACTIONS(5872),
    [anon_sym_u226a] = ACTIONS(5872),
    [anon_sym_BSLASHnotin] = ACTIONS(5872),
    [anon_sym_u2209] = ACTIONS(5872),
    [anon_sym_BSLASHprec] = ACTIONS(5874),
    [anon_sym_u227a] = ACTIONS(5872),
    [anon_sym_BSLASHsucc] = ACTIONS(5874),
    [anon_sym_u227b] = ACTIONS(5872),
    [anon_sym_BSLASHpreceq] = ACTIONS(5872),
    [anon_sym_u2aaf] = ACTIONS(5872),
    [anon_sym_BSLASHsucceq] = ACTIONS(5872),
    [anon_sym_u2ab0] = ACTIONS(5872),
    [anon_sym_BSLASHpropto] = ACTIONS(5872),
    [anon_sym_u221d] = ACTIONS(5872),
    [anon_sym_BSLASHsim] = ACTIONS(5874),
    [anon_sym_u223c] = ACTIONS(5872),
    [anon_sym_BSLASHsimeq] = ACTIONS(5872),
    [anon_sym_u2243] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5874),
    [anon_sym_u228f] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5874),
    [anon_sym_u2290] = ACTIONS(5872),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5872),
    [anon_sym_u2291] = ACTIONS(5872),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5872),
    [anon_sym_u2292] = ACTIONS(5872),
    [anon_sym_BSLASHsubset] = ACTIONS(5874),
    [anon_sym_u2282] = ACTIONS(5872),
    [anon_sym_BSLASHsupset] = ACTIONS(5874),
    [anon_sym_u2283] = ACTIONS(5872),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5872),
    [anon_sym_u2286] = ACTIONS(5872),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5872),
    [anon_sym_u2287] = ACTIONS(5872),
    [sym_compose] = ACTIONS(5872),
    [sym_map_to] = ACTIONS(5872),
    [sym_map_from] = ACTIONS(5872),
    [sym_setminus] = ACTIONS(5874),
    [anon_sym_BSLASHcap] = ACTIONS(5872),
    [anon_sym_BSLASHintersect] = ACTIONS(5872),
    [anon_sym_u2229] = ACTIONS(5872),
    [anon_sym_BSLASHcup] = ACTIONS(5872),
    [anon_sym_BSLASHunion] = ACTIONS(5872),
    [anon_sym_u222a] = ACTIONS(5872),
    [anon_sym_DOT_DOT] = ACTIONS(5874),
    [anon_sym_u2025] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5872),
    [anon_sym_u2026] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [sym_plusplus] = ACTIONS(5872),
    [anon_sym_BSLASHoplus] = ACTIONS(5872),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5872),
    [anon_sym_u2295] = ACTIONS(5872),
    [anon_sym_BSLASHominus] = ACTIONS(5872),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2296] = ACTIONS(5872),
    [sym_mod] = ACTIONS(5874),
    [sym_modmod] = ACTIONS(5872),
    [sym_vert] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5872),
    [anon_sym_u2016] = ACTIONS(5872),
    [sym_minusminus] = ACTIONS(5872),
    [sym_amp] = ACTIONS(5874),
    [sym_ampamp] = ACTIONS(5872),
    [anon_sym_BSLASHodot] = ACTIONS(5872),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5872),
    [anon_sym_u2299] = ACTIONS(5872),
    [anon_sym_BSLASHoslash] = ACTIONS(5872),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5872),
    [anon_sym_u2298] = ACTIONS(5872),
    [anon_sym_BSLASHotimes] = ACTIONS(5872),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5872),
    [anon_sym_u2297] = ACTIONS(5872),
    [sym_mul] = ACTIONS(5874),
    [sym_mulmul] = ACTIONS(5872),
    [sym_slash] = ACTIONS(5874),
    [sym_slashslash] = ACTIONS(5872),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5872),
    [anon_sym_u25ef] = ACTIONS(5872),
    [anon_sym_BSLASHbullet] = ACTIONS(5872),
    [anon_sym_u25cf] = ACTIONS(5872),
    [anon_sym_BSLASHdiv] = ACTIONS(5872),
    [anon_sym_u00f7] = ACTIONS(5872),
    [anon_sym_BSLASHcirc] = ACTIONS(5872),
    [anon_sym_u2218] = ACTIONS(5872),
    [anon_sym_BSLASHstar] = ACTIONS(5872),
    [anon_sym_u22c6] = ACTIONS(5872),
    [anon_sym_u203c] = ACTIONS(5872),
    [sym_hashhash] = ACTIONS(5872),
    [sym_dol] = ACTIONS(5874),
    [sym_doldol] = ACTIONS(5872),
    [anon_sym_QMARK_QMARK] = ACTIONS(5872),
    [anon_sym_u2047] = ACTIONS(5872),
    [anon_sym_BSLASHsqcap] = ACTIONS(5872),
    [anon_sym_u2293] = ACTIONS(5872),
    [anon_sym_BSLASHsqcup] = ACTIONS(5872),
    [anon_sym_u2294] = ACTIONS(5872),
    [anon_sym_BSLASHuplus] = ACTIONS(5872),
    [anon_sym_u228e] = ACTIONS(5872),
    [anon_sym_BSLASHX] = ACTIONS(5872),
    [anon_sym_BSLASHtimes] = ACTIONS(5872),
    [anon_sym_u00d7] = ACTIONS(5872),
    [anon_sym_BSLASHwr] = ACTIONS(5872),
    [anon_sym_u2240] = ACTIONS(5872),
    [anon_sym_BSLASHcdot] = ACTIONS(5872),
    [anon_sym_u22c5] = ACTIONS(5872),
    [sym_pow] = ACTIONS(5874),
    [sym_powpow] = ACTIONS(5872),
    [anon_sym_CARET_PLUS] = ACTIONS(5872),
    [anon_sym_u207a] = ACTIONS(5872),
    [sym_asterisk] = ACTIONS(5872),
    [sym_sup_hash] = ACTIONS(5872),
    [sym_prime] = ACTIONS(5872),
    [sym__bullet] = ACTIONS(5872),
    [sym__dedent] = ACTIONS(5872),
    [sym__double_excl] = ACTIONS(5872),
  },
  [3373] = {
    [sym_block_comment] = STATE(3373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5878),
    [anon_sym_u2208] = ACTIONS(5876),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5876),
    [anon_sym_u25a1] = ACTIONS(5876),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5876),
    [anon_sym_u2227] = ACTIONS(5876),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5876),
    [anon_sym_u2228] = ACTIONS(5876),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_BSLASHo] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27f9] = ACTIONS(5876),
    [anon_sym_u21d2] = ACTIONS(5876),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5876),
    [anon_sym_u21f8] = ACTIONS(5876),
    [anon_sym_u2945] = ACTIONS(5876),
    [anon_sym_BSLASHequiv] = ACTIONS(5876),
    [anon_sym_u2261] = ACTIONS(5876),
    [anon_sym_LT_EQ_GT] = ACTIONS(5876),
    [anon_sym_u27fa] = ACTIONS(5876),
    [anon_sym_u21d4] = ACTIONS(5876),
    [anon_sym_TILDE_GT] = ACTIONS(5876),
    [anon_sym_u21dd] = ACTIONS(5876),
    [anon_sym_u219d] = ACTIONS(5876),
    [anon_sym_BSLASHland] = ACTIONS(5876),
    [anon_sym_BSLASHlor] = ACTIONS(5876),
    [anon_sym_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2254] = ACTIONS(5876),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5876),
    [anon_sym_u2a74] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_POUND] = ACTIONS(5878),
    [anon_sym_u2260] = ACTIONS(5876),
    [anon_sym_LT] = ACTIONS(5878),
    [sym_gt] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_EQ_LT] = ACTIONS(5876),
    [anon_sym_BSLASHleq] = ACTIONS(5876),
    [anon_sym_u2264] = ACTIONS(5876),
    [anon_sym_GT_EQ] = ACTIONS(5876),
    [anon_sym_BSLASHgeq] = ACTIONS(5876),
    [anon_sym_u2265] = ACTIONS(5876),
    [anon_sym_BSLASHapprox] = ACTIONS(5876),
    [anon_sym_u2248] = ACTIONS(5876),
    [anon_sym_PIPE_DASH] = ACTIONS(5876),
    [anon_sym_u22a2] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_u22a8] = ACTIONS(5876),
    [anon_sym_DASH_PIPE] = ACTIONS(5876),
    [anon_sym_u22a3] = ACTIONS(5876),
    [anon_sym_EQ_PIPE] = ACTIONS(5876),
    [anon_sym_u2ae4] = ACTIONS(5876),
    [anon_sym_BSLASHasymp] = ACTIONS(5876),
    [anon_sym_u224d] = ACTIONS(5876),
    [anon_sym_BSLASHcong] = ACTIONS(5876),
    [anon_sym_u2245] = ACTIONS(5876),
    [anon_sym_BSLASHdoteq] = ACTIONS(5876),
    [anon_sym_u2250] = ACTIONS(5876),
    [anon_sym_BSLASHgg] = ACTIONS(5876),
    [anon_sym_u226b] = ACTIONS(5876),
    [anon_sym_BSLASHll] = ACTIONS(5876),
    [anon_sym_u226a] = ACTIONS(5876),
    [anon_sym_BSLASHnotin] = ACTIONS(5876),
    [anon_sym_u2209] = ACTIONS(5876),
    [anon_sym_BSLASHprec] = ACTIONS(5878),
    [anon_sym_u227a] = ACTIONS(5876),
    [anon_sym_BSLASHsucc] = ACTIONS(5878),
    [anon_sym_u227b] = ACTIONS(5876),
    [anon_sym_BSLASHpreceq] = ACTIONS(5876),
    [anon_sym_u2aaf] = ACTIONS(5876),
    [anon_sym_BSLASHsucceq] = ACTIONS(5876),
    [anon_sym_u2ab0] = ACTIONS(5876),
    [anon_sym_BSLASHpropto] = ACTIONS(5876),
    [anon_sym_u221d] = ACTIONS(5876),
    [anon_sym_BSLASHsim] = ACTIONS(5878),
    [anon_sym_u223c] = ACTIONS(5876),
    [anon_sym_BSLASHsimeq] = ACTIONS(5876),
    [anon_sym_u2243] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5878),
    [anon_sym_u228f] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5878),
    [anon_sym_u2290] = ACTIONS(5876),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5876),
    [anon_sym_u2291] = ACTIONS(5876),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5876),
    [anon_sym_u2292] = ACTIONS(5876),
    [anon_sym_BSLASHsubset] = ACTIONS(5878),
    [anon_sym_u2282] = ACTIONS(5876),
    [anon_sym_BSLASHsupset] = ACTIONS(5878),
    [anon_sym_u2283] = ACTIONS(5876),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5876),
    [anon_sym_u2286] = ACTIONS(5876),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5876),
    [anon_sym_u2287] = ACTIONS(5876),
    [sym_compose] = ACTIONS(5876),
    [sym_map_to] = ACTIONS(5876),
    [sym_map_from] = ACTIONS(5876),
    [sym_setminus] = ACTIONS(5878),
    [anon_sym_BSLASHcap] = ACTIONS(5876),
    [anon_sym_BSLASHintersect] = ACTIONS(5876),
    [anon_sym_u2229] = ACTIONS(5876),
    [anon_sym_BSLASHcup] = ACTIONS(5876),
    [anon_sym_BSLASHunion] = ACTIONS(5876),
    [anon_sym_u222a] = ACTIONS(5876),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_u2025] = ACTIONS(5876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5876),
    [anon_sym_u2026] = ACTIONS(5876),
    [anon_sym_PLUS] = ACTIONS(5878),
    [sym_plusplus] = ACTIONS(5876),
    [anon_sym_BSLASHoplus] = ACTIONS(5876),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5876),
    [anon_sym_u2295] = ACTIONS(5876),
    [anon_sym_BSLASHominus] = ACTIONS(5876),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2296] = ACTIONS(5876),
    [sym_mod] = ACTIONS(5878),
    [sym_modmod] = ACTIONS(5876),
    [sym_vert] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5876),
    [anon_sym_u2016] = ACTIONS(5876),
    [sym_minusminus] = ACTIONS(5876),
    [sym_amp] = ACTIONS(5878),
    [sym_ampamp] = ACTIONS(5876),
    [anon_sym_BSLASHodot] = ACTIONS(5876),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5876),
    [anon_sym_u2299] = ACTIONS(5876),
    [anon_sym_BSLASHoslash] = ACTIONS(5876),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5876),
    [anon_sym_u2298] = ACTIONS(5876),
    [anon_sym_BSLASHotimes] = ACTIONS(5876),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5876),
    [anon_sym_u2297] = ACTIONS(5876),
    [sym_mul] = ACTIONS(5878),
    [sym_mulmul] = ACTIONS(5876),
    [sym_slash] = ACTIONS(5878),
    [sym_slashslash] = ACTIONS(5876),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5876),
    [anon_sym_u25ef] = ACTIONS(5876),
    [anon_sym_BSLASHbullet] = ACTIONS(5876),
    [anon_sym_u25cf] = ACTIONS(5876),
    [anon_sym_BSLASHdiv] = ACTIONS(5876),
    [anon_sym_u00f7] = ACTIONS(5876),
    [anon_sym_BSLASHcirc] = ACTIONS(5876),
    [anon_sym_u2218] = ACTIONS(5876),
    [anon_sym_BSLASHstar] = ACTIONS(5876),
    [anon_sym_u22c6] = ACTIONS(5876),
    [anon_sym_u203c] = ACTIONS(5876),
    [sym_hashhash] = ACTIONS(5876),
    [sym_dol] = ACTIONS(5878),
    [sym_doldol] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK] = ACTIONS(5876),
    [anon_sym_u2047] = ACTIONS(5876),
    [anon_sym_BSLASHsqcap] = ACTIONS(5876),
    [anon_sym_u2293] = ACTIONS(5876),
    [anon_sym_BSLASHsqcup] = ACTIONS(5876),
    [anon_sym_u2294] = ACTIONS(5876),
    [anon_sym_BSLASHuplus] = ACTIONS(5876),
    [anon_sym_u228e] = ACTIONS(5876),
    [anon_sym_BSLASHX] = ACTIONS(5876),
    [anon_sym_BSLASHtimes] = ACTIONS(5876),
    [anon_sym_u00d7] = ACTIONS(5876),
    [anon_sym_BSLASHwr] = ACTIONS(5876),
    [anon_sym_u2240] = ACTIONS(5876),
    [anon_sym_BSLASHcdot] = ACTIONS(5876),
    [anon_sym_u22c5] = ACTIONS(5876),
    [sym_pow] = ACTIONS(5878),
    [sym_powpow] = ACTIONS(5876),
    [anon_sym_CARET_PLUS] = ACTIONS(5876),
    [anon_sym_u207a] = ACTIONS(5876),
    [sym_asterisk] = ACTIONS(5876),
    [sym_sup_hash] = ACTIONS(5876),
    [sym_prime] = ACTIONS(5876),
    [sym__bullet] = ACTIONS(5876),
    [sym__dedent] = ACTIONS(5876),
    [sym__double_excl] = ACTIONS(5876),
  },
  [3374] = {
    [sym_block_comment] = STATE(3374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5936),
    [anon_sym_u2208] = ACTIONS(5938),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5938),
    [anon_sym_u25a1] = ACTIONS(5938),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5938),
    [anon_sym_u2227] = ACTIONS(5938),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5938),
    [anon_sym_u2228] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5936),
    [anon_sym_BSLASHo] = ACTIONS(5936),
    [anon_sym_DOT] = ACTIONS(5936),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_DASH] = ACTIONS(5936),
    [anon_sym_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27f9] = ACTIONS(5938),
    [anon_sym_u21d2] = ACTIONS(5938),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5938),
    [anon_sym_u21f8] = ACTIONS(5938),
    [anon_sym_u2945] = ACTIONS(5938),
    [anon_sym_BSLASHequiv] = ACTIONS(5938),
    [anon_sym_u2261] = ACTIONS(5938),
    [anon_sym_LT_EQ_GT] = ACTIONS(5938),
    [anon_sym_u27fa] = ACTIONS(5938),
    [anon_sym_u21d4] = ACTIONS(5938),
    [anon_sym_TILDE_GT] = ACTIONS(5938),
    [anon_sym_u21dd] = ACTIONS(5938),
    [anon_sym_u219d] = ACTIONS(5938),
    [anon_sym_BSLASHland] = ACTIONS(5938),
    [anon_sym_BSLASHlor] = ACTIONS(5938),
    [anon_sym_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2254] = ACTIONS(5938),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5938),
    [anon_sym_u2a74] = ACTIONS(5938),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_POUND] = ACTIONS(5936),
    [anon_sym_u2260] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [sym_gt] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5936),
    [anon_sym_EQ_LT] = ACTIONS(5938),
    [anon_sym_BSLASHleq] = ACTIONS(5938),
    [anon_sym_u2264] = ACTIONS(5938),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_BSLASHgeq] = ACTIONS(5938),
    [anon_sym_u2265] = ACTIONS(5938),
    [anon_sym_BSLASHapprox] = ACTIONS(5938),
    [anon_sym_u2248] = ACTIONS(5938),
    [anon_sym_PIPE_DASH] = ACTIONS(5938),
    [anon_sym_u22a2] = ACTIONS(5938),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_u22a8] = ACTIONS(5938),
    [anon_sym_DASH_PIPE] = ACTIONS(5938),
    [anon_sym_u22a3] = ACTIONS(5938),
    [anon_sym_EQ_PIPE] = ACTIONS(5938),
    [anon_sym_u2ae4] = ACTIONS(5938),
    [anon_sym_BSLASHasymp] = ACTIONS(5938),
    [anon_sym_u224d] = ACTIONS(5938),
    [anon_sym_BSLASHcong] = ACTIONS(5938),
    [anon_sym_u2245] = ACTIONS(5938),
    [anon_sym_BSLASHdoteq] = ACTIONS(5938),
    [anon_sym_u2250] = ACTIONS(5938),
    [anon_sym_BSLASHgg] = ACTIONS(5938),
    [anon_sym_u226b] = ACTIONS(5938),
    [anon_sym_BSLASHll] = ACTIONS(5938),
    [anon_sym_u226a] = ACTIONS(5938),
    [anon_sym_BSLASHnotin] = ACTIONS(5938),
    [anon_sym_u2209] = ACTIONS(5938),
    [anon_sym_BSLASHprec] = ACTIONS(5936),
    [anon_sym_u227a] = ACTIONS(5938),
    [anon_sym_BSLASHsucc] = ACTIONS(5936),
    [anon_sym_u227b] = ACTIONS(5938),
    [anon_sym_BSLASHpreceq] = ACTIONS(5938),
    [anon_sym_u2aaf] = ACTIONS(5938),
    [anon_sym_BSLASHsucceq] = ACTIONS(5938),
    [anon_sym_u2ab0] = ACTIONS(5938),
    [anon_sym_BSLASHpropto] = ACTIONS(5938),
    [anon_sym_u221d] = ACTIONS(5938),
    [anon_sym_BSLASHsim] = ACTIONS(5936),
    [anon_sym_u223c] = ACTIONS(5938),
    [anon_sym_BSLASHsimeq] = ACTIONS(5938),
    [anon_sym_u2243] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5936),
    [anon_sym_u228f] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5936),
    [anon_sym_u2290] = ACTIONS(5938),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5938),
    [anon_sym_u2291] = ACTIONS(5938),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5938),
    [anon_sym_u2292] = ACTIONS(5938),
    [anon_sym_BSLASHsubset] = ACTIONS(5936),
    [anon_sym_u2282] = ACTIONS(5938),
    [anon_sym_BSLASHsupset] = ACTIONS(5936),
    [anon_sym_u2283] = ACTIONS(5938),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5938),
    [anon_sym_u2286] = ACTIONS(5938),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5938),
    [anon_sym_u2287] = ACTIONS(5938),
    [sym_compose] = ACTIONS(5938),
    [sym_map_to] = ACTIONS(5938),
    [sym_map_from] = ACTIONS(5938),
    [sym_setminus] = ACTIONS(5936),
    [anon_sym_BSLASHcap] = ACTIONS(5938),
    [anon_sym_BSLASHintersect] = ACTIONS(5938),
    [anon_sym_u2229] = ACTIONS(5938),
    [anon_sym_BSLASHcup] = ACTIONS(5938),
    [anon_sym_BSLASHunion] = ACTIONS(5938),
    [anon_sym_u222a] = ACTIONS(5938),
    [anon_sym_DOT_DOT] = ACTIONS(5936),
    [anon_sym_u2025] = ACTIONS(5938),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5938),
    [anon_sym_u2026] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [sym_plusplus] = ACTIONS(5938),
    [anon_sym_BSLASHoplus] = ACTIONS(5938),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5938),
    [anon_sym_u2295] = ACTIONS(5938),
    [anon_sym_BSLASHominus] = ACTIONS(5938),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2296] = ACTIONS(5938),
    [sym_mod] = ACTIONS(5936),
    [sym_modmod] = ACTIONS(5938),
    [sym_vert] = ACTIONS(5936),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_u2016] = ACTIONS(5938),
    [sym_minusminus] = ACTIONS(5938),
    [sym_amp] = ACTIONS(5936),
    [sym_ampamp] = ACTIONS(5938),
    [anon_sym_BSLASHodot] = ACTIONS(5938),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5938),
    [anon_sym_u2299] = ACTIONS(5938),
    [anon_sym_BSLASHoslash] = ACTIONS(5938),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5938),
    [anon_sym_u2298] = ACTIONS(5938),
    [anon_sym_BSLASHotimes] = ACTIONS(5938),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5938),
    [anon_sym_u2297] = ACTIONS(5938),
    [sym_mul] = ACTIONS(5936),
    [sym_mulmul] = ACTIONS(5938),
    [sym_slash] = ACTIONS(5936),
    [sym_slashslash] = ACTIONS(5938),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5938),
    [anon_sym_u25ef] = ACTIONS(5938),
    [anon_sym_BSLASHbullet] = ACTIONS(5938),
    [anon_sym_u25cf] = ACTIONS(5938),
    [anon_sym_BSLASHdiv] = ACTIONS(5938),
    [anon_sym_u00f7] = ACTIONS(5938),
    [anon_sym_BSLASHcirc] = ACTIONS(5938),
    [anon_sym_u2218] = ACTIONS(5938),
    [anon_sym_BSLASHstar] = ACTIONS(5938),
    [anon_sym_u22c6] = ACTIONS(5938),
    [anon_sym_u203c] = ACTIONS(5938),
    [sym_hashhash] = ACTIONS(5938),
    [sym_dol] = ACTIONS(5936),
    [sym_doldol] = ACTIONS(5938),
    [anon_sym_QMARK_QMARK] = ACTIONS(5938),
    [anon_sym_u2047] = ACTIONS(5938),
    [anon_sym_BSLASHsqcap] = ACTIONS(5938),
    [anon_sym_u2293] = ACTIONS(5938),
    [anon_sym_BSLASHsqcup] = ACTIONS(5938),
    [anon_sym_u2294] = ACTIONS(5938),
    [anon_sym_BSLASHuplus] = ACTIONS(5938),
    [anon_sym_u228e] = ACTIONS(5938),
    [anon_sym_BSLASHX] = ACTIONS(5938),
    [anon_sym_BSLASHtimes] = ACTIONS(5938),
    [anon_sym_u00d7] = ACTIONS(5938),
    [anon_sym_BSLASHwr] = ACTIONS(5938),
    [anon_sym_u2240] = ACTIONS(5938),
    [anon_sym_BSLASHcdot] = ACTIONS(5938),
    [anon_sym_u22c5] = ACTIONS(5938),
    [sym_pow] = ACTIONS(5936),
    [sym_powpow] = ACTIONS(5938),
    [anon_sym_CARET_PLUS] = ACTIONS(5938),
    [anon_sym_u207a] = ACTIONS(5938),
    [sym_asterisk] = ACTIONS(5938),
    [sym_sup_hash] = ACTIONS(5938),
    [sym_prime] = ACTIONS(5938),
    [sym__bullet] = ACTIONS(5938),
    [sym__dedent] = ACTIONS(5938),
    [sym__double_excl] = ACTIONS(5938),
  },
  [3375] = {
    [sym_block_comment] = STATE(3375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5688),
    [anon_sym_u2208] = ACTIONS(5690),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5690),
    [anon_sym_u25a1] = ACTIONS(5690),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5690),
    [anon_sym_u2227] = ACTIONS(5690),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5690),
    [anon_sym_u2228] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_BSLASHo] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27f9] = ACTIONS(5690),
    [anon_sym_u21d2] = ACTIONS(5690),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5690),
    [anon_sym_u21f8] = ACTIONS(5690),
    [anon_sym_u2945] = ACTIONS(5690),
    [anon_sym_BSLASHequiv] = ACTIONS(5690),
    [anon_sym_u2261] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5690),
    [anon_sym_u27fa] = ACTIONS(5690),
    [anon_sym_u21d4] = ACTIONS(5690),
    [anon_sym_TILDE_GT] = ACTIONS(5690),
    [anon_sym_u21dd] = ACTIONS(5690),
    [anon_sym_u219d] = ACTIONS(5690),
    [anon_sym_BSLASHland] = ACTIONS(5690),
    [anon_sym_BSLASHlor] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2254] = ACTIONS(5690),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5690),
    [anon_sym_u2a74] = ACTIONS(5690),
    [anon_sym_SLASH_EQ] = ACTIONS(5690),
    [anon_sym_POUND] = ACTIONS(5688),
    [anon_sym_u2260] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5688),
    [sym_gt] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_EQ_LT] = ACTIONS(5690),
    [anon_sym_BSLASHleq] = ACTIONS(5690),
    [anon_sym_u2264] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5690),
    [anon_sym_BSLASHgeq] = ACTIONS(5690),
    [anon_sym_u2265] = ACTIONS(5690),
    [anon_sym_BSLASHapprox] = ACTIONS(5690),
    [anon_sym_u2248] = ACTIONS(5690),
    [anon_sym_PIPE_DASH] = ACTIONS(5690),
    [anon_sym_u22a2] = ACTIONS(5690),
    [anon_sym_PIPE_EQ] = ACTIONS(5690),
    [anon_sym_u22a8] = ACTIONS(5690),
    [anon_sym_DASH_PIPE] = ACTIONS(5690),
    [anon_sym_u22a3] = ACTIONS(5690),
    [anon_sym_EQ_PIPE] = ACTIONS(5690),
    [anon_sym_u2ae4] = ACTIONS(5690),
    [anon_sym_BSLASHasymp] = ACTIONS(5690),
    [anon_sym_u224d] = ACTIONS(5690),
    [anon_sym_BSLASHcong] = ACTIONS(5690),
    [anon_sym_u2245] = ACTIONS(5690),
    [anon_sym_BSLASHdoteq] = ACTIONS(5690),
    [anon_sym_u2250] = ACTIONS(5690),
    [anon_sym_BSLASHgg] = ACTIONS(5690),
    [anon_sym_u226b] = ACTIONS(5690),
    [anon_sym_BSLASHll] = ACTIONS(5690),
    [anon_sym_u226a] = ACTIONS(5690),
    [anon_sym_BSLASHnotin] = ACTIONS(5690),
    [anon_sym_u2209] = ACTIONS(5690),
    [anon_sym_BSLASHprec] = ACTIONS(5688),
    [anon_sym_u227a] = ACTIONS(5690),
    [anon_sym_BSLASHsucc] = ACTIONS(5688),
    [anon_sym_u227b] = ACTIONS(5690),
    [anon_sym_BSLASHpreceq] = ACTIONS(5690),
    [anon_sym_u2aaf] = ACTIONS(5690),
    [anon_sym_BSLASHsucceq] = ACTIONS(5690),
    [anon_sym_u2ab0] = ACTIONS(5690),
    [anon_sym_BSLASHpropto] = ACTIONS(5690),
    [anon_sym_u221d] = ACTIONS(5690),
    [anon_sym_BSLASHsim] = ACTIONS(5688),
    [anon_sym_u223c] = ACTIONS(5690),
    [anon_sym_BSLASHsimeq] = ACTIONS(5690),
    [anon_sym_u2243] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5688),
    [anon_sym_u228f] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5688),
    [anon_sym_u2290] = ACTIONS(5690),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5690),
    [anon_sym_u2291] = ACTIONS(5690),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5690),
    [anon_sym_u2292] = ACTIONS(5690),
    [anon_sym_BSLASHsubset] = ACTIONS(5688),
    [anon_sym_u2282] = ACTIONS(5690),
    [anon_sym_BSLASHsupset] = ACTIONS(5688),
    [anon_sym_u2283] = ACTIONS(5690),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5690),
    [anon_sym_u2286] = ACTIONS(5690),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5690),
    [anon_sym_u2287] = ACTIONS(5690),
    [sym_compose] = ACTIONS(5690),
    [sym_map_to] = ACTIONS(5690),
    [sym_map_from] = ACTIONS(5690),
    [sym_setminus] = ACTIONS(5688),
    [anon_sym_BSLASHcap] = ACTIONS(5690),
    [anon_sym_BSLASHintersect] = ACTIONS(5690),
    [anon_sym_u2229] = ACTIONS(5690),
    [anon_sym_BSLASHcup] = ACTIONS(5690),
    [anon_sym_BSLASHunion] = ACTIONS(5690),
    [anon_sym_u222a] = ACTIONS(5690),
    [anon_sym_DOT_DOT] = ACTIONS(5688),
    [anon_sym_u2025] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5690),
    [anon_sym_u2026] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5688),
    [sym_plusplus] = ACTIONS(5690),
    [anon_sym_BSLASHoplus] = ACTIONS(5690),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5690),
    [anon_sym_u2295] = ACTIONS(5690),
    [anon_sym_BSLASHominus] = ACTIONS(5690),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2296] = ACTIONS(5690),
    [sym_mod] = ACTIONS(5688),
    [sym_modmod] = ACTIONS(5690),
    [sym_vert] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_u2016] = ACTIONS(5690),
    [sym_minusminus] = ACTIONS(5690),
    [sym_amp] = ACTIONS(5688),
    [sym_ampamp] = ACTIONS(5690),
    [anon_sym_BSLASHodot] = ACTIONS(5690),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5690),
    [anon_sym_u2299] = ACTIONS(5690),
    [anon_sym_BSLASHoslash] = ACTIONS(5690),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5690),
    [anon_sym_u2298] = ACTIONS(5690),
    [anon_sym_BSLASHotimes] = ACTIONS(5690),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5690),
    [anon_sym_u2297] = ACTIONS(5690),
    [sym_mul] = ACTIONS(5688),
    [sym_mulmul] = ACTIONS(5690),
    [sym_slash] = ACTIONS(5688),
    [sym_slashslash] = ACTIONS(5690),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5690),
    [anon_sym_u25ef] = ACTIONS(5690),
    [anon_sym_BSLASHbullet] = ACTIONS(5690),
    [anon_sym_u25cf] = ACTIONS(5690),
    [anon_sym_BSLASHdiv] = ACTIONS(5690),
    [anon_sym_u00f7] = ACTIONS(5690),
    [anon_sym_BSLASHcirc] = ACTIONS(5690),
    [anon_sym_u2218] = ACTIONS(5690),
    [anon_sym_BSLASHstar] = ACTIONS(5690),
    [anon_sym_u22c6] = ACTIONS(5690),
    [anon_sym_u203c] = ACTIONS(5690),
    [sym_hashhash] = ACTIONS(5690),
    [sym_dol] = ACTIONS(5688),
    [sym_doldol] = ACTIONS(5690),
    [anon_sym_QMARK_QMARK] = ACTIONS(5690),
    [anon_sym_u2047] = ACTIONS(5690),
    [anon_sym_BSLASHsqcap] = ACTIONS(5690),
    [anon_sym_u2293] = ACTIONS(5690),
    [anon_sym_BSLASHsqcup] = ACTIONS(5690),
    [anon_sym_u2294] = ACTIONS(5690),
    [anon_sym_BSLASHuplus] = ACTIONS(5690),
    [anon_sym_u228e] = ACTIONS(5690),
    [anon_sym_BSLASHX] = ACTIONS(5690),
    [anon_sym_BSLASHtimes] = ACTIONS(5690),
    [anon_sym_u00d7] = ACTIONS(5690),
    [anon_sym_BSLASHwr] = ACTIONS(5690),
    [anon_sym_u2240] = ACTIONS(5690),
    [anon_sym_BSLASHcdot] = ACTIONS(5690),
    [anon_sym_u22c5] = ACTIONS(5690),
    [sym_pow] = ACTIONS(5688),
    [sym_powpow] = ACTIONS(5690),
    [anon_sym_CARET_PLUS] = ACTIONS(5690),
    [anon_sym_u207a] = ACTIONS(5690),
    [sym_asterisk] = ACTIONS(5690),
    [sym_sup_hash] = ACTIONS(5690),
    [sym_prime] = ACTIONS(5690),
    [sym__bullet] = ACTIONS(5690),
    [sym__dedent] = ACTIONS(5690),
    [sym__double_excl] = ACTIONS(5690),
  },
  [3376] = {
    [sym_block_comment] = STATE(3376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5784),
    [anon_sym_u2208] = ACTIONS(5782),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5782),
    [anon_sym_u25a1] = ACTIONS(5782),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5782),
    [anon_sym_u2227] = ACTIONS(5782),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5782),
    [anon_sym_u2228] = ACTIONS(5782),
    [anon_sym_LBRACK] = ACTIONS(5784),
    [anon_sym_BSLASHo] = ACTIONS(5784),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [anon_sym_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27f9] = ACTIONS(5782),
    [anon_sym_u21d2] = ACTIONS(5782),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5782),
    [anon_sym_u21f8] = ACTIONS(5782),
    [anon_sym_u2945] = ACTIONS(5782),
    [anon_sym_BSLASHequiv] = ACTIONS(5782),
    [anon_sym_u2261] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5782),
    [anon_sym_u27fa] = ACTIONS(5782),
    [anon_sym_u21d4] = ACTIONS(5782),
    [anon_sym_TILDE_GT] = ACTIONS(5782),
    [anon_sym_u21dd] = ACTIONS(5782),
    [anon_sym_u219d] = ACTIONS(5782),
    [anon_sym_BSLASHland] = ACTIONS(5782),
    [anon_sym_BSLASHlor] = ACTIONS(5782),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2254] = ACTIONS(5782),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5782),
    [anon_sym_u2a74] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_POUND] = ACTIONS(5784),
    [anon_sym_u2260] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [sym_gt] = ACTIONS(5784),
    [anon_sym_LT_EQ] = ACTIONS(5784),
    [anon_sym_EQ_LT] = ACTIONS(5782),
    [anon_sym_BSLASHleq] = ACTIONS(5782),
    [anon_sym_u2264] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_BSLASHgeq] = ACTIONS(5782),
    [anon_sym_u2265] = ACTIONS(5782),
    [anon_sym_BSLASHapprox] = ACTIONS(5782),
    [anon_sym_u2248] = ACTIONS(5782),
    [anon_sym_PIPE_DASH] = ACTIONS(5782),
    [anon_sym_u22a2] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_u22a8] = ACTIONS(5782),
    [anon_sym_DASH_PIPE] = ACTIONS(5782),
    [anon_sym_u22a3] = ACTIONS(5782),
    [anon_sym_EQ_PIPE] = ACTIONS(5782),
    [anon_sym_u2ae4] = ACTIONS(5782),
    [anon_sym_BSLASHasymp] = ACTIONS(5782),
    [anon_sym_u224d] = ACTIONS(5782),
    [anon_sym_BSLASHcong] = ACTIONS(5782),
    [anon_sym_u2245] = ACTIONS(5782),
    [anon_sym_BSLASHdoteq] = ACTIONS(5782),
    [anon_sym_u2250] = ACTIONS(5782),
    [anon_sym_BSLASHgg] = ACTIONS(5782),
    [anon_sym_u226b] = ACTIONS(5782),
    [anon_sym_BSLASHll] = ACTIONS(5782),
    [anon_sym_u226a] = ACTIONS(5782),
    [anon_sym_BSLASHnotin] = ACTIONS(5782),
    [anon_sym_u2209] = ACTIONS(5782),
    [anon_sym_BSLASHprec] = ACTIONS(5784),
    [anon_sym_u227a] = ACTIONS(5782),
    [anon_sym_BSLASHsucc] = ACTIONS(5784),
    [anon_sym_u227b] = ACTIONS(5782),
    [anon_sym_BSLASHpreceq] = ACTIONS(5782),
    [anon_sym_u2aaf] = ACTIONS(5782),
    [anon_sym_BSLASHsucceq] = ACTIONS(5782),
    [anon_sym_u2ab0] = ACTIONS(5782),
    [anon_sym_BSLASHpropto] = ACTIONS(5782),
    [anon_sym_u221d] = ACTIONS(5782),
    [anon_sym_BSLASHsim] = ACTIONS(5784),
    [anon_sym_u223c] = ACTIONS(5782),
    [anon_sym_BSLASHsimeq] = ACTIONS(5782),
    [anon_sym_u2243] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5784),
    [anon_sym_u228f] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5784),
    [anon_sym_u2290] = ACTIONS(5782),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5782),
    [anon_sym_u2291] = ACTIONS(5782),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5782),
    [anon_sym_u2292] = ACTIONS(5782),
    [anon_sym_BSLASHsubset] = ACTIONS(5784),
    [anon_sym_u2282] = ACTIONS(5782),
    [anon_sym_BSLASHsupset] = ACTIONS(5784),
    [anon_sym_u2283] = ACTIONS(5782),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5782),
    [anon_sym_u2286] = ACTIONS(5782),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5782),
    [anon_sym_u2287] = ACTIONS(5782),
    [sym_compose] = ACTIONS(5782),
    [sym_map_to] = ACTIONS(5782),
    [sym_map_from] = ACTIONS(5782),
    [sym_setminus] = ACTIONS(5784),
    [anon_sym_BSLASHcap] = ACTIONS(5782),
    [anon_sym_BSLASHintersect] = ACTIONS(5782),
    [anon_sym_u2229] = ACTIONS(5782),
    [anon_sym_BSLASHcup] = ACTIONS(5782),
    [anon_sym_BSLASHunion] = ACTIONS(5782),
    [anon_sym_u222a] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5784),
    [anon_sym_u2025] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5782),
    [anon_sym_u2026] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [sym_plusplus] = ACTIONS(5782),
    [anon_sym_BSLASHoplus] = ACTIONS(5782),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5782),
    [anon_sym_u2295] = ACTIONS(5782),
    [anon_sym_BSLASHominus] = ACTIONS(5782),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2296] = ACTIONS(5782),
    [sym_mod] = ACTIONS(5784),
    [sym_modmod] = ACTIONS(5782),
    [sym_vert] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5782),
    [anon_sym_u2016] = ACTIONS(5782),
    [sym_minusminus] = ACTIONS(5782),
    [sym_amp] = ACTIONS(5784),
    [sym_ampamp] = ACTIONS(5782),
    [anon_sym_BSLASHodot] = ACTIONS(5782),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5782),
    [anon_sym_u2299] = ACTIONS(5782),
    [anon_sym_BSLASHoslash] = ACTIONS(5782),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5782),
    [anon_sym_u2298] = ACTIONS(5782),
    [anon_sym_BSLASHotimes] = ACTIONS(5782),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5782),
    [anon_sym_u2297] = ACTIONS(5782),
    [sym_mul] = ACTIONS(5784),
    [sym_mulmul] = ACTIONS(5782),
    [sym_slash] = ACTIONS(5784),
    [sym_slashslash] = ACTIONS(5782),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5782),
    [anon_sym_u25ef] = ACTIONS(5782),
    [anon_sym_BSLASHbullet] = ACTIONS(5782),
    [anon_sym_u25cf] = ACTIONS(5782),
    [anon_sym_BSLASHdiv] = ACTIONS(5782),
    [anon_sym_u00f7] = ACTIONS(5782),
    [anon_sym_BSLASHcirc] = ACTIONS(5782),
    [anon_sym_u2218] = ACTIONS(5782),
    [anon_sym_BSLASHstar] = ACTIONS(5782),
    [anon_sym_u22c6] = ACTIONS(5782),
    [anon_sym_u203c] = ACTIONS(5782),
    [sym_hashhash] = ACTIONS(5782),
    [sym_dol] = ACTIONS(5784),
    [sym_doldol] = ACTIONS(5782),
    [anon_sym_QMARK_QMARK] = ACTIONS(5782),
    [anon_sym_u2047] = ACTIONS(5782),
    [anon_sym_BSLASHsqcap] = ACTIONS(5782),
    [anon_sym_u2293] = ACTIONS(5782),
    [anon_sym_BSLASHsqcup] = ACTIONS(5782),
    [anon_sym_u2294] = ACTIONS(5782),
    [anon_sym_BSLASHuplus] = ACTIONS(5782),
    [anon_sym_u228e] = ACTIONS(5782),
    [anon_sym_BSLASHX] = ACTIONS(5782),
    [anon_sym_BSLASHtimes] = ACTIONS(5782),
    [anon_sym_u00d7] = ACTIONS(5782),
    [anon_sym_BSLASHwr] = ACTIONS(5782),
    [anon_sym_u2240] = ACTIONS(5782),
    [anon_sym_BSLASHcdot] = ACTIONS(5782),
    [anon_sym_u22c5] = ACTIONS(5782),
    [sym_pow] = ACTIONS(5784),
    [sym_powpow] = ACTIONS(5782),
    [anon_sym_CARET_PLUS] = ACTIONS(5782),
    [anon_sym_u207a] = ACTIONS(5782),
    [sym_asterisk] = ACTIONS(5782),
    [sym_sup_hash] = ACTIONS(5782),
    [sym_prime] = ACTIONS(5782),
    [sym__bullet] = ACTIONS(5782),
    [sym__dedent] = ACTIONS(5782),
    [sym__double_excl] = ACTIONS(5782),
  },
  [3377] = {
    [sym_block_comment] = STATE(3377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5754),
    [anon_sym_u2208] = ACTIONS(5752),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5752),
    [anon_sym_u25a1] = ACTIONS(5752),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5752),
    [anon_sym_u2227] = ACTIONS(5752),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5752),
    [anon_sym_u2228] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(5754),
    [anon_sym_BSLASHo] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27f9] = ACTIONS(5752),
    [anon_sym_u21d2] = ACTIONS(5752),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5752),
    [anon_sym_u21f8] = ACTIONS(5752),
    [anon_sym_u2945] = ACTIONS(5752),
    [anon_sym_BSLASHequiv] = ACTIONS(5752),
    [anon_sym_u2261] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_u27fa] = ACTIONS(5752),
    [anon_sym_u21d4] = ACTIONS(5752),
    [anon_sym_TILDE_GT] = ACTIONS(5752),
    [anon_sym_u21dd] = ACTIONS(5752),
    [anon_sym_u219d] = ACTIONS(5752),
    [anon_sym_BSLASHland] = ACTIONS(5752),
    [anon_sym_BSLASHlor] = ACTIONS(5752),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2254] = ACTIONS(5752),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5752),
    [anon_sym_u2a74] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_POUND] = ACTIONS(5754),
    [anon_sym_u2260] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [sym_gt] = ACTIONS(5754),
    [anon_sym_LT_EQ] = ACTIONS(5754),
    [anon_sym_EQ_LT] = ACTIONS(5752),
    [anon_sym_BSLASHleq] = ACTIONS(5752),
    [anon_sym_u2264] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_BSLASHgeq] = ACTIONS(5752),
    [anon_sym_u2265] = ACTIONS(5752),
    [anon_sym_BSLASHapprox] = ACTIONS(5752),
    [anon_sym_u2248] = ACTIONS(5752),
    [anon_sym_PIPE_DASH] = ACTIONS(5752),
    [anon_sym_u22a2] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_u22a8] = ACTIONS(5752),
    [anon_sym_DASH_PIPE] = ACTIONS(5752),
    [anon_sym_u22a3] = ACTIONS(5752),
    [anon_sym_EQ_PIPE] = ACTIONS(5752),
    [anon_sym_u2ae4] = ACTIONS(5752),
    [anon_sym_BSLASHasymp] = ACTIONS(5752),
    [anon_sym_u224d] = ACTIONS(5752),
    [anon_sym_BSLASHcong] = ACTIONS(5752),
    [anon_sym_u2245] = ACTIONS(5752),
    [anon_sym_BSLASHdoteq] = ACTIONS(5752),
    [anon_sym_u2250] = ACTIONS(5752),
    [anon_sym_BSLASHgg] = ACTIONS(5752),
    [anon_sym_u226b] = ACTIONS(5752),
    [anon_sym_BSLASHll] = ACTIONS(5752),
    [anon_sym_u226a] = ACTIONS(5752),
    [anon_sym_BSLASHnotin] = ACTIONS(5752),
    [anon_sym_u2209] = ACTIONS(5752),
    [anon_sym_BSLASHprec] = ACTIONS(5754),
    [anon_sym_u227a] = ACTIONS(5752),
    [anon_sym_BSLASHsucc] = ACTIONS(5754),
    [anon_sym_u227b] = ACTIONS(5752),
    [anon_sym_BSLASHpreceq] = ACTIONS(5752),
    [anon_sym_u2aaf] = ACTIONS(5752),
    [anon_sym_BSLASHsucceq] = ACTIONS(5752),
    [anon_sym_u2ab0] = ACTIONS(5752),
    [anon_sym_BSLASHpropto] = ACTIONS(5752),
    [anon_sym_u221d] = ACTIONS(5752),
    [anon_sym_BSLASHsim] = ACTIONS(5754),
    [anon_sym_u223c] = ACTIONS(5752),
    [anon_sym_BSLASHsimeq] = ACTIONS(5752),
    [anon_sym_u2243] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5754),
    [anon_sym_u228f] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5754),
    [anon_sym_u2290] = ACTIONS(5752),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5752),
    [anon_sym_u2291] = ACTIONS(5752),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5752),
    [anon_sym_u2292] = ACTIONS(5752),
    [anon_sym_BSLASHsubset] = ACTIONS(5754),
    [anon_sym_u2282] = ACTIONS(5752),
    [anon_sym_BSLASHsupset] = ACTIONS(5754),
    [anon_sym_u2283] = ACTIONS(5752),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5752),
    [anon_sym_u2286] = ACTIONS(5752),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5752),
    [anon_sym_u2287] = ACTIONS(5752),
    [sym_compose] = ACTIONS(5752),
    [sym_map_to] = ACTIONS(5752),
    [sym_map_from] = ACTIONS(5752),
    [sym_setminus] = ACTIONS(5754),
    [anon_sym_BSLASHcap] = ACTIONS(5752),
    [anon_sym_BSLASHintersect] = ACTIONS(5752),
    [anon_sym_u2229] = ACTIONS(5752),
    [anon_sym_BSLASHcup] = ACTIONS(5752),
    [anon_sym_BSLASHunion] = ACTIONS(5752),
    [anon_sym_u222a] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5754),
    [anon_sym_u2025] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5752),
    [anon_sym_u2026] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [sym_plusplus] = ACTIONS(5752),
    [anon_sym_BSLASHoplus] = ACTIONS(5752),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5752),
    [anon_sym_u2295] = ACTIONS(5752),
    [anon_sym_BSLASHominus] = ACTIONS(5752),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2296] = ACTIONS(5752),
    [sym_mod] = ACTIONS(5754),
    [sym_modmod] = ACTIONS(5752),
    [sym_vert] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_u2016] = ACTIONS(5752),
    [sym_minusminus] = ACTIONS(5752),
    [sym_amp] = ACTIONS(5754),
    [sym_ampamp] = ACTIONS(5752),
    [anon_sym_BSLASHodot] = ACTIONS(5752),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5752),
    [anon_sym_u2299] = ACTIONS(5752),
    [anon_sym_BSLASHoslash] = ACTIONS(5752),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5752),
    [anon_sym_u2298] = ACTIONS(5752),
    [anon_sym_BSLASHotimes] = ACTIONS(5752),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5752),
    [anon_sym_u2297] = ACTIONS(5752),
    [sym_mul] = ACTIONS(5754),
    [sym_mulmul] = ACTIONS(5752),
    [sym_slash] = ACTIONS(5754),
    [sym_slashslash] = ACTIONS(5752),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5752),
    [anon_sym_u25ef] = ACTIONS(5752),
    [anon_sym_BSLASHbullet] = ACTIONS(5752),
    [anon_sym_u25cf] = ACTIONS(5752),
    [anon_sym_BSLASHdiv] = ACTIONS(5752),
    [anon_sym_u00f7] = ACTIONS(5752),
    [anon_sym_BSLASHcirc] = ACTIONS(5752),
    [anon_sym_u2218] = ACTIONS(5752),
    [anon_sym_BSLASHstar] = ACTIONS(5752),
    [anon_sym_u22c6] = ACTIONS(5752),
    [anon_sym_u203c] = ACTIONS(5752),
    [sym_hashhash] = ACTIONS(5752),
    [sym_dol] = ACTIONS(5754),
    [sym_doldol] = ACTIONS(5752),
    [anon_sym_QMARK_QMARK] = ACTIONS(5752),
    [anon_sym_u2047] = ACTIONS(5752),
    [anon_sym_BSLASHsqcap] = ACTIONS(5752),
    [anon_sym_u2293] = ACTIONS(5752),
    [anon_sym_BSLASHsqcup] = ACTIONS(5752),
    [anon_sym_u2294] = ACTIONS(5752),
    [anon_sym_BSLASHuplus] = ACTIONS(5752),
    [anon_sym_u228e] = ACTIONS(5752),
    [anon_sym_BSLASHX] = ACTIONS(5752),
    [anon_sym_BSLASHtimes] = ACTIONS(5752),
    [anon_sym_u00d7] = ACTIONS(5752),
    [anon_sym_BSLASHwr] = ACTIONS(5752),
    [anon_sym_u2240] = ACTIONS(5752),
    [anon_sym_BSLASHcdot] = ACTIONS(5752),
    [anon_sym_u22c5] = ACTIONS(5752),
    [sym_pow] = ACTIONS(5754),
    [sym_powpow] = ACTIONS(5752),
    [anon_sym_CARET_PLUS] = ACTIONS(5752),
    [anon_sym_u207a] = ACTIONS(5752),
    [sym_asterisk] = ACTIONS(5752),
    [sym_sup_hash] = ACTIONS(5752),
    [sym_prime] = ACTIONS(5752),
    [sym__bullet] = ACTIONS(5752),
    [sym__dedent] = ACTIONS(5752),
    [sym__double_excl] = ACTIONS(5752),
  },
  [3378] = {
    [sym_block_comment] = STATE(3378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5758),
    [anon_sym_u2208] = ACTIONS(5756),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5756),
    [anon_sym_u25a1] = ACTIONS(5756),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5756),
    [anon_sym_u2227] = ACTIONS(5756),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5756),
    [anon_sym_u2228] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_BSLASHo] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27f9] = ACTIONS(5756),
    [anon_sym_u21d2] = ACTIONS(5756),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5756),
    [anon_sym_u21f8] = ACTIONS(5756),
    [anon_sym_u2945] = ACTIONS(5756),
    [anon_sym_BSLASHequiv] = ACTIONS(5756),
    [anon_sym_u2261] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_u27fa] = ACTIONS(5756),
    [anon_sym_u21d4] = ACTIONS(5756),
    [anon_sym_TILDE_GT] = ACTIONS(5756),
    [anon_sym_u21dd] = ACTIONS(5756),
    [anon_sym_u219d] = ACTIONS(5756),
    [anon_sym_BSLASHland] = ACTIONS(5756),
    [anon_sym_BSLASHlor] = ACTIONS(5756),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2254] = ACTIONS(5756),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5756),
    [anon_sym_u2a74] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_POUND] = ACTIONS(5758),
    [anon_sym_u2260] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [sym_gt] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_EQ_LT] = ACTIONS(5756),
    [anon_sym_BSLASHleq] = ACTIONS(5756),
    [anon_sym_u2264] = ACTIONS(5756),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_BSLASHgeq] = ACTIONS(5756),
    [anon_sym_u2265] = ACTIONS(5756),
    [anon_sym_BSLASHapprox] = ACTIONS(5756),
    [anon_sym_u2248] = ACTIONS(5756),
    [anon_sym_PIPE_DASH] = ACTIONS(5756),
    [anon_sym_u22a2] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_u22a8] = ACTIONS(5756),
    [anon_sym_DASH_PIPE] = ACTIONS(5756),
    [anon_sym_u22a3] = ACTIONS(5756),
    [anon_sym_EQ_PIPE] = ACTIONS(5756),
    [anon_sym_u2ae4] = ACTIONS(5756),
    [anon_sym_BSLASHasymp] = ACTIONS(5756),
    [anon_sym_u224d] = ACTIONS(5756),
    [anon_sym_BSLASHcong] = ACTIONS(5756),
    [anon_sym_u2245] = ACTIONS(5756),
    [anon_sym_BSLASHdoteq] = ACTIONS(5756),
    [anon_sym_u2250] = ACTIONS(5756),
    [anon_sym_BSLASHgg] = ACTIONS(5756),
    [anon_sym_u226b] = ACTIONS(5756),
    [anon_sym_BSLASHll] = ACTIONS(5756),
    [anon_sym_u226a] = ACTIONS(5756),
    [anon_sym_BSLASHnotin] = ACTIONS(5756),
    [anon_sym_u2209] = ACTIONS(5756),
    [anon_sym_BSLASHprec] = ACTIONS(5758),
    [anon_sym_u227a] = ACTIONS(5756),
    [anon_sym_BSLASHsucc] = ACTIONS(5758),
    [anon_sym_u227b] = ACTIONS(5756),
    [anon_sym_BSLASHpreceq] = ACTIONS(5756),
    [anon_sym_u2aaf] = ACTIONS(5756),
    [anon_sym_BSLASHsucceq] = ACTIONS(5756),
    [anon_sym_u2ab0] = ACTIONS(5756),
    [anon_sym_BSLASHpropto] = ACTIONS(5756),
    [anon_sym_u221d] = ACTIONS(5756),
    [anon_sym_BSLASHsim] = ACTIONS(5758),
    [anon_sym_u223c] = ACTIONS(5756),
    [anon_sym_BSLASHsimeq] = ACTIONS(5756),
    [anon_sym_u2243] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5758),
    [anon_sym_u228f] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5758),
    [anon_sym_u2290] = ACTIONS(5756),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5756),
    [anon_sym_u2291] = ACTIONS(5756),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5756),
    [anon_sym_u2292] = ACTIONS(5756),
    [anon_sym_BSLASHsubset] = ACTIONS(5758),
    [anon_sym_u2282] = ACTIONS(5756),
    [anon_sym_BSLASHsupset] = ACTIONS(5758),
    [anon_sym_u2283] = ACTIONS(5756),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5756),
    [anon_sym_u2286] = ACTIONS(5756),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5756),
    [anon_sym_u2287] = ACTIONS(5756),
    [sym_compose] = ACTIONS(5756),
    [sym_map_to] = ACTIONS(5756),
    [sym_map_from] = ACTIONS(5756),
    [sym_setminus] = ACTIONS(5758),
    [anon_sym_BSLASHcap] = ACTIONS(5756),
    [anon_sym_BSLASHintersect] = ACTIONS(5756),
    [anon_sym_u2229] = ACTIONS(5756),
    [anon_sym_BSLASHcup] = ACTIONS(5756),
    [anon_sym_BSLASHunion] = ACTIONS(5756),
    [anon_sym_u222a] = ACTIONS(5756),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_u2025] = ACTIONS(5756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_u2026] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [sym_plusplus] = ACTIONS(5756),
    [anon_sym_BSLASHoplus] = ACTIONS(5756),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5756),
    [anon_sym_u2295] = ACTIONS(5756),
    [anon_sym_BSLASHominus] = ACTIONS(5756),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2296] = ACTIONS(5756),
    [sym_mod] = ACTIONS(5758),
    [sym_modmod] = ACTIONS(5756),
    [sym_vert] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_u2016] = ACTIONS(5756),
    [sym_minusminus] = ACTIONS(5756),
    [sym_amp] = ACTIONS(5758),
    [sym_ampamp] = ACTIONS(5756),
    [anon_sym_BSLASHodot] = ACTIONS(5756),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5756),
    [anon_sym_u2299] = ACTIONS(5756),
    [anon_sym_BSLASHoslash] = ACTIONS(5756),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5756),
    [anon_sym_u2298] = ACTIONS(5756),
    [anon_sym_BSLASHotimes] = ACTIONS(5756),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5756),
    [anon_sym_u2297] = ACTIONS(5756),
    [sym_mul] = ACTIONS(5758),
    [sym_mulmul] = ACTIONS(5756),
    [sym_slash] = ACTIONS(5758),
    [sym_slashslash] = ACTIONS(5756),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5756),
    [anon_sym_u25ef] = ACTIONS(5756),
    [anon_sym_BSLASHbullet] = ACTIONS(5756),
    [anon_sym_u25cf] = ACTIONS(5756),
    [anon_sym_BSLASHdiv] = ACTIONS(5756),
    [anon_sym_u00f7] = ACTIONS(5756),
    [anon_sym_BSLASHcirc] = ACTIONS(5756),
    [anon_sym_u2218] = ACTIONS(5756),
    [anon_sym_BSLASHstar] = ACTIONS(5756),
    [anon_sym_u22c6] = ACTIONS(5756),
    [anon_sym_u203c] = ACTIONS(5756),
    [sym_hashhash] = ACTIONS(5756),
    [sym_dol] = ACTIONS(5758),
    [sym_doldol] = ACTIONS(5756),
    [anon_sym_QMARK_QMARK] = ACTIONS(5756),
    [anon_sym_u2047] = ACTIONS(5756),
    [anon_sym_BSLASHsqcap] = ACTIONS(5756),
    [anon_sym_u2293] = ACTIONS(5756),
    [anon_sym_BSLASHsqcup] = ACTIONS(5756),
    [anon_sym_u2294] = ACTIONS(5756),
    [anon_sym_BSLASHuplus] = ACTIONS(5756),
    [anon_sym_u228e] = ACTIONS(5756),
    [anon_sym_BSLASHX] = ACTIONS(5756),
    [anon_sym_BSLASHtimes] = ACTIONS(5756),
    [anon_sym_u00d7] = ACTIONS(5756),
    [anon_sym_BSLASHwr] = ACTIONS(5756),
    [anon_sym_u2240] = ACTIONS(5756),
    [anon_sym_BSLASHcdot] = ACTIONS(5756),
    [anon_sym_u22c5] = ACTIONS(5756),
    [sym_pow] = ACTIONS(5758),
    [sym_powpow] = ACTIONS(5756),
    [anon_sym_CARET_PLUS] = ACTIONS(5756),
    [anon_sym_u207a] = ACTIONS(5756),
    [sym_asterisk] = ACTIONS(5756),
    [sym_sup_hash] = ACTIONS(5756),
    [sym_prime] = ACTIONS(5756),
    [sym__bullet] = ACTIONS(5756),
    [sym__dedent] = ACTIONS(5756),
    [sym__double_excl] = ACTIONS(5756),
  },
  [3379] = {
    [sym_block_comment] = STATE(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5894),
    [anon_sym_u2208] = ACTIONS(5892),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5892),
    [anon_sym_u25a1] = ACTIONS(5892),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5892),
    [anon_sym_u2227] = ACTIONS(5892),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5892),
    [anon_sym_u2228] = ACTIONS(5892),
    [anon_sym_LBRACK] = ACTIONS(5894),
    [anon_sym_BSLASHo] = ACTIONS(5894),
    [anon_sym_DOT] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5894),
    [anon_sym_DASH] = ACTIONS(5894),
    [anon_sym_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27f9] = ACTIONS(5892),
    [anon_sym_u21d2] = ACTIONS(5892),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5892),
    [anon_sym_u21f8] = ACTIONS(5892),
    [anon_sym_u2945] = ACTIONS(5892),
    [anon_sym_BSLASHequiv] = ACTIONS(5892),
    [anon_sym_u2261] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_u27fa] = ACTIONS(5892),
    [anon_sym_u21d4] = ACTIONS(5892),
    [anon_sym_TILDE_GT] = ACTIONS(5892),
    [anon_sym_u21dd] = ACTIONS(5892),
    [anon_sym_u219d] = ACTIONS(5892),
    [anon_sym_BSLASHland] = ACTIONS(5892),
    [anon_sym_BSLASHlor] = ACTIONS(5892),
    [anon_sym_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2254] = ACTIONS(5892),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5892),
    [anon_sym_u2a74] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_u2260] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5894),
    [sym_gt] = ACTIONS(5894),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ_LT] = ACTIONS(5892),
    [anon_sym_BSLASHleq] = ACTIONS(5892),
    [anon_sym_u2264] = ACTIONS(5892),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_BSLASHgeq] = ACTIONS(5892),
    [anon_sym_u2265] = ACTIONS(5892),
    [anon_sym_BSLASHapprox] = ACTIONS(5892),
    [anon_sym_u2248] = ACTIONS(5892),
    [anon_sym_PIPE_DASH] = ACTIONS(5892),
    [anon_sym_u22a2] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_u22a8] = ACTIONS(5892),
    [anon_sym_DASH_PIPE] = ACTIONS(5892),
    [anon_sym_u22a3] = ACTIONS(5892),
    [anon_sym_EQ_PIPE] = ACTIONS(5892),
    [anon_sym_u2ae4] = ACTIONS(5892),
    [anon_sym_BSLASHasymp] = ACTIONS(5892),
    [anon_sym_u224d] = ACTIONS(5892),
    [anon_sym_BSLASHcong] = ACTIONS(5892),
    [anon_sym_u2245] = ACTIONS(5892),
    [anon_sym_BSLASHdoteq] = ACTIONS(5892),
    [anon_sym_u2250] = ACTIONS(5892),
    [anon_sym_BSLASHgg] = ACTIONS(5892),
    [anon_sym_u226b] = ACTIONS(5892),
    [anon_sym_BSLASHll] = ACTIONS(5892),
    [anon_sym_u226a] = ACTIONS(5892),
    [anon_sym_BSLASHnotin] = ACTIONS(5892),
    [anon_sym_u2209] = ACTIONS(5892),
    [anon_sym_BSLASHprec] = ACTIONS(5894),
    [anon_sym_u227a] = ACTIONS(5892),
    [anon_sym_BSLASHsucc] = ACTIONS(5894),
    [anon_sym_u227b] = ACTIONS(5892),
    [anon_sym_BSLASHpreceq] = ACTIONS(5892),
    [anon_sym_u2aaf] = ACTIONS(5892),
    [anon_sym_BSLASHsucceq] = ACTIONS(5892),
    [anon_sym_u2ab0] = ACTIONS(5892),
    [anon_sym_BSLASHpropto] = ACTIONS(5892),
    [anon_sym_u221d] = ACTIONS(5892),
    [anon_sym_BSLASHsim] = ACTIONS(5894),
    [anon_sym_u223c] = ACTIONS(5892),
    [anon_sym_BSLASHsimeq] = ACTIONS(5892),
    [anon_sym_u2243] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5894),
    [anon_sym_u228f] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5894),
    [anon_sym_u2290] = ACTIONS(5892),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5892),
    [anon_sym_u2291] = ACTIONS(5892),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5892),
    [anon_sym_u2292] = ACTIONS(5892),
    [anon_sym_BSLASHsubset] = ACTIONS(5894),
    [anon_sym_u2282] = ACTIONS(5892),
    [anon_sym_BSLASHsupset] = ACTIONS(5894),
    [anon_sym_u2283] = ACTIONS(5892),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5892),
    [anon_sym_u2286] = ACTIONS(5892),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5892),
    [anon_sym_u2287] = ACTIONS(5892),
    [sym_compose] = ACTIONS(5892),
    [sym_map_to] = ACTIONS(5892),
    [sym_map_from] = ACTIONS(5892),
    [sym_setminus] = ACTIONS(5894),
    [anon_sym_BSLASHcap] = ACTIONS(5892),
    [anon_sym_BSLASHintersect] = ACTIONS(5892),
    [anon_sym_u2229] = ACTIONS(5892),
    [anon_sym_BSLASHcup] = ACTIONS(5892),
    [anon_sym_BSLASHunion] = ACTIONS(5892),
    [anon_sym_u222a] = ACTIONS(5892),
    [anon_sym_DOT_DOT] = ACTIONS(5894),
    [anon_sym_u2025] = ACTIONS(5892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_u2026] = ACTIONS(5892),
    [anon_sym_PLUS] = ACTIONS(5894),
    [sym_plusplus] = ACTIONS(5892),
    [anon_sym_BSLASHoplus] = ACTIONS(5892),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5892),
    [anon_sym_u2295] = ACTIONS(5892),
    [anon_sym_BSLASHominus] = ACTIONS(5892),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2296] = ACTIONS(5892),
    [sym_mod] = ACTIONS(5894),
    [sym_modmod] = ACTIONS(5892),
    [sym_vert] = ACTIONS(5894),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_u2016] = ACTIONS(5892),
    [sym_minusminus] = ACTIONS(5892),
    [sym_amp] = ACTIONS(5894),
    [sym_ampamp] = ACTIONS(5892),
    [anon_sym_BSLASHodot] = ACTIONS(5892),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5892),
    [anon_sym_u2299] = ACTIONS(5892),
    [anon_sym_BSLASHoslash] = ACTIONS(5892),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5892),
    [anon_sym_u2298] = ACTIONS(5892),
    [anon_sym_BSLASHotimes] = ACTIONS(5892),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5892),
    [anon_sym_u2297] = ACTIONS(5892),
    [sym_mul] = ACTIONS(5894),
    [sym_mulmul] = ACTIONS(5892),
    [sym_slash] = ACTIONS(5894),
    [sym_slashslash] = ACTIONS(5892),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5892),
    [anon_sym_u25ef] = ACTIONS(5892),
    [anon_sym_BSLASHbullet] = ACTIONS(5892),
    [anon_sym_u25cf] = ACTIONS(5892),
    [anon_sym_BSLASHdiv] = ACTIONS(5892),
    [anon_sym_u00f7] = ACTIONS(5892),
    [anon_sym_BSLASHcirc] = ACTIONS(5892),
    [anon_sym_u2218] = ACTIONS(5892),
    [anon_sym_BSLASHstar] = ACTIONS(5892),
    [anon_sym_u22c6] = ACTIONS(5892),
    [anon_sym_u203c] = ACTIONS(5892),
    [sym_hashhash] = ACTIONS(5892),
    [sym_dol] = ACTIONS(5894),
    [sym_doldol] = ACTIONS(5892),
    [anon_sym_QMARK_QMARK] = ACTIONS(5892),
    [anon_sym_u2047] = ACTIONS(5892),
    [anon_sym_BSLASHsqcap] = ACTIONS(5892),
    [anon_sym_u2293] = ACTIONS(5892),
    [anon_sym_BSLASHsqcup] = ACTIONS(5892),
    [anon_sym_u2294] = ACTIONS(5892),
    [anon_sym_BSLASHuplus] = ACTIONS(5892),
    [anon_sym_u228e] = ACTIONS(5892),
    [anon_sym_BSLASHX] = ACTIONS(5892),
    [anon_sym_BSLASHtimes] = ACTIONS(5892),
    [anon_sym_u00d7] = ACTIONS(5892),
    [anon_sym_BSLASHwr] = ACTIONS(5892),
    [anon_sym_u2240] = ACTIONS(5892),
    [anon_sym_BSLASHcdot] = ACTIONS(5892),
    [anon_sym_u22c5] = ACTIONS(5892),
    [sym_pow] = ACTIONS(5894),
    [sym_powpow] = ACTIONS(5892),
    [anon_sym_CARET_PLUS] = ACTIONS(5892),
    [anon_sym_u207a] = ACTIONS(5892),
    [sym_asterisk] = ACTIONS(5892),
    [sym_sup_hash] = ACTIONS(5892),
    [sym_prime] = ACTIONS(5892),
    [sym__bullet] = ACTIONS(5892),
    [sym__dedent] = ACTIONS(5892),
    [sym__double_excl] = ACTIONS(5892),
  },
  [3380] = {
    [sym_block_comment] = STATE(3380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5762),
    [anon_sym_u2208] = ACTIONS(5760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5760),
    [anon_sym_u25a1] = ACTIONS(5760),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5760),
    [anon_sym_u2227] = ACTIONS(5760),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5760),
    [anon_sym_u2228] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_BSLASHo] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27f9] = ACTIONS(5760),
    [anon_sym_u21d2] = ACTIONS(5760),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5760),
    [anon_sym_u21f8] = ACTIONS(5760),
    [anon_sym_u2945] = ACTIONS(5760),
    [anon_sym_BSLASHequiv] = ACTIONS(5760),
    [anon_sym_u2261] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_u27fa] = ACTIONS(5760),
    [anon_sym_u21d4] = ACTIONS(5760),
    [anon_sym_TILDE_GT] = ACTIONS(5760),
    [anon_sym_u21dd] = ACTIONS(5760),
    [anon_sym_u219d] = ACTIONS(5760),
    [anon_sym_BSLASHland] = ACTIONS(5760),
    [anon_sym_BSLASHlor] = ACTIONS(5760),
    [anon_sym_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2254] = ACTIONS(5760),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5760),
    [anon_sym_u2a74] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_POUND] = ACTIONS(5762),
    [anon_sym_u2260] = ACTIONS(5760),
    [anon_sym_LT] = ACTIONS(5762),
    [sym_gt] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_EQ_LT] = ACTIONS(5760),
    [anon_sym_BSLASHleq] = ACTIONS(5760),
    [anon_sym_u2264] = ACTIONS(5760),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_BSLASHgeq] = ACTIONS(5760),
    [anon_sym_u2265] = ACTIONS(5760),
    [anon_sym_BSLASHapprox] = ACTIONS(5760),
    [anon_sym_u2248] = ACTIONS(5760),
    [anon_sym_PIPE_DASH] = ACTIONS(5760),
    [anon_sym_u22a2] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_u22a8] = ACTIONS(5760),
    [anon_sym_DASH_PIPE] = ACTIONS(5760),
    [anon_sym_u22a3] = ACTIONS(5760),
    [anon_sym_EQ_PIPE] = ACTIONS(5760),
    [anon_sym_u2ae4] = ACTIONS(5760),
    [anon_sym_BSLASHasymp] = ACTIONS(5760),
    [anon_sym_u224d] = ACTIONS(5760),
    [anon_sym_BSLASHcong] = ACTIONS(5760),
    [anon_sym_u2245] = ACTIONS(5760),
    [anon_sym_BSLASHdoteq] = ACTIONS(5760),
    [anon_sym_u2250] = ACTIONS(5760),
    [anon_sym_BSLASHgg] = ACTIONS(5760),
    [anon_sym_u226b] = ACTIONS(5760),
    [anon_sym_BSLASHll] = ACTIONS(5760),
    [anon_sym_u226a] = ACTIONS(5760),
    [anon_sym_BSLASHnotin] = ACTIONS(5760),
    [anon_sym_u2209] = ACTIONS(5760),
    [anon_sym_BSLASHprec] = ACTIONS(5762),
    [anon_sym_u227a] = ACTIONS(5760),
    [anon_sym_BSLASHsucc] = ACTIONS(5762),
    [anon_sym_u227b] = ACTIONS(5760),
    [anon_sym_BSLASHpreceq] = ACTIONS(5760),
    [anon_sym_u2aaf] = ACTIONS(5760),
    [anon_sym_BSLASHsucceq] = ACTIONS(5760),
    [anon_sym_u2ab0] = ACTIONS(5760),
    [anon_sym_BSLASHpropto] = ACTIONS(5760),
    [anon_sym_u221d] = ACTIONS(5760),
    [anon_sym_BSLASHsim] = ACTIONS(5762),
    [anon_sym_u223c] = ACTIONS(5760),
    [anon_sym_BSLASHsimeq] = ACTIONS(5760),
    [anon_sym_u2243] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5762),
    [anon_sym_u228f] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5762),
    [anon_sym_u2290] = ACTIONS(5760),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5760),
    [anon_sym_u2291] = ACTIONS(5760),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5760),
    [anon_sym_u2292] = ACTIONS(5760),
    [anon_sym_BSLASHsubset] = ACTIONS(5762),
    [anon_sym_u2282] = ACTIONS(5760),
    [anon_sym_BSLASHsupset] = ACTIONS(5762),
    [anon_sym_u2283] = ACTIONS(5760),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5760),
    [anon_sym_u2286] = ACTIONS(5760),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5760),
    [anon_sym_u2287] = ACTIONS(5760),
    [sym_compose] = ACTIONS(5760),
    [sym_map_to] = ACTIONS(5760),
    [sym_map_from] = ACTIONS(5760),
    [sym_setminus] = ACTIONS(5762),
    [anon_sym_BSLASHcap] = ACTIONS(5760),
    [anon_sym_BSLASHintersect] = ACTIONS(5760),
    [anon_sym_u2229] = ACTIONS(5760),
    [anon_sym_BSLASHcup] = ACTIONS(5760),
    [anon_sym_BSLASHunion] = ACTIONS(5760),
    [anon_sym_u222a] = ACTIONS(5760),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_u2025] = ACTIONS(5760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_u2026] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5762),
    [sym_plusplus] = ACTIONS(5760),
    [anon_sym_BSLASHoplus] = ACTIONS(5760),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5760),
    [anon_sym_u2295] = ACTIONS(5760),
    [anon_sym_BSLASHominus] = ACTIONS(5760),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2296] = ACTIONS(5760),
    [sym_mod] = ACTIONS(5762),
    [sym_modmod] = ACTIONS(5760),
    [sym_vert] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_u2016] = ACTIONS(5760),
    [sym_minusminus] = ACTIONS(5760),
    [sym_amp] = ACTIONS(5762),
    [sym_ampamp] = ACTIONS(5760),
    [anon_sym_BSLASHodot] = ACTIONS(5760),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5760),
    [anon_sym_u2299] = ACTIONS(5760),
    [anon_sym_BSLASHoslash] = ACTIONS(5760),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5760),
    [anon_sym_u2298] = ACTIONS(5760),
    [anon_sym_BSLASHotimes] = ACTIONS(5760),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5760),
    [anon_sym_u2297] = ACTIONS(5760),
    [sym_mul] = ACTIONS(5762),
    [sym_mulmul] = ACTIONS(5760),
    [sym_slash] = ACTIONS(5762),
    [sym_slashslash] = ACTIONS(5760),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5760),
    [anon_sym_u25ef] = ACTIONS(5760),
    [anon_sym_BSLASHbullet] = ACTIONS(5760),
    [anon_sym_u25cf] = ACTIONS(5760),
    [anon_sym_BSLASHdiv] = ACTIONS(5760),
    [anon_sym_u00f7] = ACTIONS(5760),
    [anon_sym_BSLASHcirc] = ACTIONS(5760),
    [anon_sym_u2218] = ACTIONS(5760),
    [anon_sym_BSLASHstar] = ACTIONS(5760),
    [anon_sym_u22c6] = ACTIONS(5760),
    [anon_sym_u203c] = ACTIONS(5760),
    [sym_hashhash] = ACTIONS(5760),
    [sym_dol] = ACTIONS(5762),
    [sym_doldol] = ACTIONS(5760),
    [anon_sym_QMARK_QMARK] = ACTIONS(5760),
    [anon_sym_u2047] = ACTIONS(5760),
    [anon_sym_BSLASHsqcap] = ACTIONS(5760),
    [anon_sym_u2293] = ACTIONS(5760),
    [anon_sym_BSLASHsqcup] = ACTIONS(5760),
    [anon_sym_u2294] = ACTIONS(5760),
    [anon_sym_BSLASHuplus] = ACTIONS(5760),
    [anon_sym_u228e] = ACTIONS(5760),
    [anon_sym_BSLASHX] = ACTIONS(5760),
    [anon_sym_BSLASHtimes] = ACTIONS(5760),
    [anon_sym_u00d7] = ACTIONS(5760),
    [anon_sym_BSLASHwr] = ACTIONS(5760),
    [anon_sym_u2240] = ACTIONS(5760),
    [anon_sym_BSLASHcdot] = ACTIONS(5760),
    [anon_sym_u22c5] = ACTIONS(5760),
    [sym_pow] = ACTIONS(5762),
    [sym_powpow] = ACTIONS(5760),
    [anon_sym_CARET_PLUS] = ACTIONS(5760),
    [anon_sym_u207a] = ACTIONS(5760),
    [sym_asterisk] = ACTIONS(5760),
    [sym_sup_hash] = ACTIONS(5760),
    [sym_prime] = ACTIONS(5760),
    [sym__bullet] = ACTIONS(5760),
    [sym__dedent] = ACTIONS(5760),
    [sym__double_excl] = ACTIONS(5760),
  },
  [3381] = {
    [sym_block_comment] = STATE(3381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5766),
    [anon_sym_u2208] = ACTIONS(5764),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5764),
    [anon_sym_u25a1] = ACTIONS(5764),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5764),
    [anon_sym_u2227] = ACTIONS(5764),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5764),
    [anon_sym_u2228] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_BSLASHo] = ACTIONS(5766),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [anon_sym_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27f9] = ACTIONS(5764),
    [anon_sym_u21d2] = ACTIONS(5764),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5764),
    [anon_sym_u21f8] = ACTIONS(5764),
    [anon_sym_u2945] = ACTIONS(5764),
    [anon_sym_BSLASHequiv] = ACTIONS(5764),
    [anon_sym_u2261] = ACTIONS(5764),
    [anon_sym_LT_EQ_GT] = ACTIONS(5764),
    [anon_sym_u27fa] = ACTIONS(5764),
    [anon_sym_u21d4] = ACTIONS(5764),
    [anon_sym_TILDE_GT] = ACTIONS(5764),
    [anon_sym_u21dd] = ACTIONS(5764),
    [anon_sym_u219d] = ACTIONS(5764),
    [anon_sym_BSLASHland] = ACTIONS(5764),
    [anon_sym_BSLASHlor] = ACTIONS(5764),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2254] = ACTIONS(5764),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5764),
    [anon_sym_u2a74] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_u2260] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [sym_gt] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5766),
    [anon_sym_EQ_LT] = ACTIONS(5764),
    [anon_sym_BSLASHleq] = ACTIONS(5764),
    [anon_sym_u2264] = ACTIONS(5764),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_BSLASHgeq] = ACTIONS(5764),
    [anon_sym_u2265] = ACTIONS(5764),
    [anon_sym_BSLASHapprox] = ACTIONS(5764),
    [anon_sym_u2248] = ACTIONS(5764),
    [anon_sym_PIPE_DASH] = ACTIONS(5764),
    [anon_sym_u22a2] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_u22a8] = ACTIONS(5764),
    [anon_sym_DASH_PIPE] = ACTIONS(5764),
    [anon_sym_u22a3] = ACTIONS(5764),
    [anon_sym_EQ_PIPE] = ACTIONS(5764),
    [anon_sym_u2ae4] = ACTIONS(5764),
    [anon_sym_BSLASHasymp] = ACTIONS(5764),
    [anon_sym_u224d] = ACTIONS(5764),
    [anon_sym_BSLASHcong] = ACTIONS(5764),
    [anon_sym_u2245] = ACTIONS(5764),
    [anon_sym_BSLASHdoteq] = ACTIONS(5764),
    [anon_sym_u2250] = ACTIONS(5764),
    [anon_sym_BSLASHgg] = ACTIONS(5764),
    [anon_sym_u226b] = ACTIONS(5764),
    [anon_sym_BSLASHll] = ACTIONS(5764),
    [anon_sym_u226a] = ACTIONS(5764),
    [anon_sym_BSLASHnotin] = ACTIONS(5764),
    [anon_sym_u2209] = ACTIONS(5764),
    [anon_sym_BSLASHprec] = ACTIONS(5766),
    [anon_sym_u227a] = ACTIONS(5764),
    [anon_sym_BSLASHsucc] = ACTIONS(5766),
    [anon_sym_u227b] = ACTIONS(5764),
    [anon_sym_BSLASHpreceq] = ACTIONS(5764),
    [anon_sym_u2aaf] = ACTIONS(5764),
    [anon_sym_BSLASHsucceq] = ACTIONS(5764),
    [anon_sym_u2ab0] = ACTIONS(5764),
    [anon_sym_BSLASHpropto] = ACTIONS(5764),
    [anon_sym_u221d] = ACTIONS(5764),
    [anon_sym_BSLASHsim] = ACTIONS(5766),
    [anon_sym_u223c] = ACTIONS(5764),
    [anon_sym_BSLASHsimeq] = ACTIONS(5764),
    [anon_sym_u2243] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5766),
    [anon_sym_u228f] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5766),
    [anon_sym_u2290] = ACTIONS(5764),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5764),
    [anon_sym_u2291] = ACTIONS(5764),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5764),
    [anon_sym_u2292] = ACTIONS(5764),
    [anon_sym_BSLASHsubset] = ACTIONS(5766),
    [anon_sym_u2282] = ACTIONS(5764),
    [anon_sym_BSLASHsupset] = ACTIONS(5766),
    [anon_sym_u2283] = ACTIONS(5764),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5764),
    [anon_sym_u2286] = ACTIONS(5764),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5764),
    [anon_sym_u2287] = ACTIONS(5764),
    [sym_compose] = ACTIONS(5764),
    [sym_map_to] = ACTIONS(5764),
    [sym_map_from] = ACTIONS(5764),
    [sym_setminus] = ACTIONS(5766),
    [anon_sym_BSLASHcap] = ACTIONS(5764),
    [anon_sym_BSLASHintersect] = ACTIONS(5764),
    [anon_sym_u2229] = ACTIONS(5764),
    [anon_sym_BSLASHcup] = ACTIONS(5764),
    [anon_sym_BSLASHunion] = ACTIONS(5764),
    [anon_sym_u222a] = ACTIONS(5764),
    [anon_sym_DOT_DOT] = ACTIONS(5766),
    [anon_sym_u2025] = ACTIONS(5764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5764),
    [anon_sym_u2026] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [sym_plusplus] = ACTIONS(5764),
    [anon_sym_BSLASHoplus] = ACTIONS(5764),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5764),
    [anon_sym_u2295] = ACTIONS(5764),
    [anon_sym_BSLASHominus] = ACTIONS(5764),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2296] = ACTIONS(5764),
    [sym_mod] = ACTIONS(5766),
    [sym_modmod] = ACTIONS(5764),
    [sym_vert] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5764),
    [anon_sym_u2016] = ACTIONS(5764),
    [sym_minusminus] = ACTIONS(5764),
    [sym_amp] = ACTIONS(5766),
    [sym_ampamp] = ACTIONS(5764),
    [anon_sym_BSLASHodot] = ACTIONS(5764),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5764),
    [anon_sym_u2299] = ACTIONS(5764),
    [anon_sym_BSLASHoslash] = ACTIONS(5764),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5764),
    [anon_sym_u2298] = ACTIONS(5764),
    [anon_sym_BSLASHotimes] = ACTIONS(5764),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5764),
    [anon_sym_u2297] = ACTIONS(5764),
    [sym_mul] = ACTIONS(5766),
    [sym_mulmul] = ACTIONS(5764),
    [sym_slash] = ACTIONS(5766),
    [sym_slashslash] = ACTIONS(5764),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5764),
    [anon_sym_u25ef] = ACTIONS(5764),
    [anon_sym_BSLASHbullet] = ACTIONS(5764),
    [anon_sym_u25cf] = ACTIONS(5764),
    [anon_sym_BSLASHdiv] = ACTIONS(5764),
    [anon_sym_u00f7] = ACTIONS(5764),
    [anon_sym_BSLASHcirc] = ACTIONS(5764),
    [anon_sym_u2218] = ACTIONS(5764),
    [anon_sym_BSLASHstar] = ACTIONS(5764),
    [anon_sym_u22c6] = ACTIONS(5764),
    [anon_sym_u203c] = ACTIONS(5764),
    [sym_hashhash] = ACTIONS(5764),
    [sym_dol] = ACTIONS(5766),
    [sym_doldol] = ACTIONS(5764),
    [anon_sym_QMARK_QMARK] = ACTIONS(5764),
    [anon_sym_u2047] = ACTIONS(5764),
    [anon_sym_BSLASHsqcap] = ACTIONS(5764),
    [anon_sym_u2293] = ACTIONS(5764),
    [anon_sym_BSLASHsqcup] = ACTIONS(5764),
    [anon_sym_u2294] = ACTIONS(5764),
    [anon_sym_BSLASHuplus] = ACTIONS(5764),
    [anon_sym_u228e] = ACTIONS(5764),
    [anon_sym_BSLASHX] = ACTIONS(5764),
    [anon_sym_BSLASHtimes] = ACTIONS(5764),
    [anon_sym_u00d7] = ACTIONS(5764),
    [anon_sym_BSLASHwr] = ACTIONS(5764),
    [anon_sym_u2240] = ACTIONS(5764),
    [anon_sym_BSLASHcdot] = ACTIONS(5764),
    [anon_sym_u22c5] = ACTIONS(5764),
    [sym_pow] = ACTIONS(5766),
    [sym_powpow] = ACTIONS(5764),
    [anon_sym_CARET_PLUS] = ACTIONS(5764),
    [anon_sym_u207a] = ACTIONS(5764),
    [sym_asterisk] = ACTIONS(5764),
    [sym_sup_hash] = ACTIONS(5764),
    [sym_prime] = ACTIONS(5764),
    [sym__bullet] = ACTIONS(5764),
    [sym__dedent] = ACTIONS(5764),
    [sym__double_excl] = ACTIONS(5764),
  },
  [3382] = {
    [sym_block_comment] = STATE(3382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5726),
    [anon_sym_u2208] = ACTIONS(5724),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5724),
    [anon_sym_u25a1] = ACTIONS(5724),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5724),
    [anon_sym_u2227] = ACTIONS(5724),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5724),
    [anon_sym_u2228] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_BSLASHo] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_DASH] = ACTIONS(5726),
    [anon_sym_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27f9] = ACTIONS(5724),
    [anon_sym_u21d2] = ACTIONS(5724),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5724),
    [anon_sym_u21f8] = ACTIONS(5724),
    [anon_sym_u2945] = ACTIONS(5724),
    [anon_sym_BSLASHequiv] = ACTIONS(5724),
    [anon_sym_u2261] = ACTIONS(5724),
    [anon_sym_LT_EQ_GT] = ACTIONS(5724),
    [anon_sym_u27fa] = ACTIONS(5724),
    [anon_sym_u21d4] = ACTIONS(5724),
    [anon_sym_TILDE_GT] = ACTIONS(5724),
    [anon_sym_u21dd] = ACTIONS(5724),
    [anon_sym_u219d] = ACTIONS(5724),
    [anon_sym_BSLASHland] = ACTIONS(5724),
    [anon_sym_BSLASHlor] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2254] = ACTIONS(5724),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5724),
    [anon_sym_u2a74] = ACTIONS(5724),
    [anon_sym_SLASH_EQ] = ACTIONS(5724),
    [anon_sym_POUND] = ACTIONS(5726),
    [anon_sym_u2260] = ACTIONS(5724),
    [anon_sym_LT] = ACTIONS(5726),
    [sym_gt] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_EQ_LT] = ACTIONS(5724),
    [anon_sym_BSLASHleq] = ACTIONS(5724),
    [anon_sym_u2264] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5724),
    [anon_sym_BSLASHgeq] = ACTIONS(5724),
    [anon_sym_u2265] = ACTIONS(5724),
    [anon_sym_BSLASHapprox] = ACTIONS(5724),
    [anon_sym_u2248] = ACTIONS(5724),
    [anon_sym_PIPE_DASH] = ACTIONS(5724),
    [anon_sym_u22a2] = ACTIONS(5724),
    [anon_sym_PIPE_EQ] = ACTIONS(5724),
    [anon_sym_u22a8] = ACTIONS(5724),
    [anon_sym_DASH_PIPE] = ACTIONS(5724),
    [anon_sym_u22a3] = ACTIONS(5724),
    [anon_sym_EQ_PIPE] = ACTIONS(5724),
    [anon_sym_u2ae4] = ACTIONS(5724),
    [anon_sym_BSLASHasymp] = ACTIONS(5724),
    [anon_sym_u224d] = ACTIONS(5724),
    [anon_sym_BSLASHcong] = ACTIONS(5724),
    [anon_sym_u2245] = ACTIONS(5724),
    [anon_sym_BSLASHdoteq] = ACTIONS(5724),
    [anon_sym_u2250] = ACTIONS(5724),
    [anon_sym_BSLASHgg] = ACTIONS(5724),
    [anon_sym_u226b] = ACTIONS(5724),
    [anon_sym_BSLASHll] = ACTIONS(5724),
    [anon_sym_u226a] = ACTIONS(5724),
    [anon_sym_BSLASHnotin] = ACTIONS(5724),
    [anon_sym_u2209] = ACTIONS(5724),
    [anon_sym_BSLASHprec] = ACTIONS(5726),
    [anon_sym_u227a] = ACTIONS(5724),
    [anon_sym_BSLASHsucc] = ACTIONS(5726),
    [anon_sym_u227b] = ACTIONS(5724),
    [anon_sym_BSLASHpreceq] = ACTIONS(5724),
    [anon_sym_u2aaf] = ACTIONS(5724),
    [anon_sym_BSLASHsucceq] = ACTIONS(5724),
    [anon_sym_u2ab0] = ACTIONS(5724),
    [anon_sym_BSLASHpropto] = ACTIONS(5724),
    [anon_sym_u221d] = ACTIONS(5724),
    [anon_sym_BSLASHsim] = ACTIONS(5726),
    [anon_sym_u223c] = ACTIONS(5724),
    [anon_sym_BSLASHsimeq] = ACTIONS(5724),
    [anon_sym_u2243] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5726),
    [anon_sym_u228f] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5726),
    [anon_sym_u2290] = ACTIONS(5724),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5724),
    [anon_sym_u2291] = ACTIONS(5724),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5724),
    [anon_sym_u2292] = ACTIONS(5724),
    [anon_sym_BSLASHsubset] = ACTIONS(5726),
    [anon_sym_u2282] = ACTIONS(5724),
    [anon_sym_BSLASHsupset] = ACTIONS(5726),
    [anon_sym_u2283] = ACTIONS(5724),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5724),
    [anon_sym_u2286] = ACTIONS(5724),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5724),
    [anon_sym_u2287] = ACTIONS(5724),
    [sym_compose] = ACTIONS(5724),
    [sym_map_to] = ACTIONS(5724),
    [sym_map_from] = ACTIONS(5724),
    [sym_setminus] = ACTIONS(5726),
    [anon_sym_BSLASHcap] = ACTIONS(5724),
    [anon_sym_BSLASHintersect] = ACTIONS(5724),
    [anon_sym_u2229] = ACTIONS(5724),
    [anon_sym_BSLASHcup] = ACTIONS(5724),
    [anon_sym_BSLASHunion] = ACTIONS(5724),
    [anon_sym_u222a] = ACTIONS(5724),
    [anon_sym_DOT_DOT] = ACTIONS(5726),
    [anon_sym_u2025] = ACTIONS(5724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5724),
    [anon_sym_u2026] = ACTIONS(5724),
    [anon_sym_PLUS] = ACTIONS(5726),
    [sym_plusplus] = ACTIONS(5724),
    [anon_sym_BSLASHoplus] = ACTIONS(5724),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5724),
    [anon_sym_u2295] = ACTIONS(5724),
    [anon_sym_BSLASHominus] = ACTIONS(5724),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2296] = ACTIONS(5724),
    [sym_mod] = ACTIONS(5726),
    [sym_modmod] = ACTIONS(5724),
    [sym_vert] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_u2016] = ACTIONS(5724),
    [sym_minusminus] = ACTIONS(5724),
    [sym_amp] = ACTIONS(5726),
    [sym_ampamp] = ACTIONS(5724),
    [anon_sym_BSLASHodot] = ACTIONS(5724),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5724),
    [anon_sym_u2299] = ACTIONS(5724),
    [anon_sym_BSLASHoslash] = ACTIONS(5724),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5724),
    [anon_sym_u2298] = ACTIONS(5724),
    [anon_sym_BSLASHotimes] = ACTIONS(5724),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5724),
    [anon_sym_u2297] = ACTIONS(5724),
    [sym_mul] = ACTIONS(5726),
    [sym_mulmul] = ACTIONS(5724),
    [sym_slash] = ACTIONS(5726),
    [sym_slashslash] = ACTIONS(5724),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5724),
    [anon_sym_u25ef] = ACTIONS(5724),
    [anon_sym_BSLASHbullet] = ACTIONS(5724),
    [anon_sym_u25cf] = ACTIONS(5724),
    [anon_sym_BSLASHdiv] = ACTIONS(5724),
    [anon_sym_u00f7] = ACTIONS(5724),
    [anon_sym_BSLASHcirc] = ACTIONS(5724),
    [anon_sym_u2218] = ACTIONS(5724),
    [anon_sym_BSLASHstar] = ACTIONS(5724),
    [anon_sym_u22c6] = ACTIONS(5724),
    [anon_sym_u203c] = ACTIONS(5724),
    [sym_hashhash] = ACTIONS(5724),
    [sym_dol] = ACTIONS(5726),
    [sym_doldol] = ACTIONS(5724),
    [anon_sym_QMARK_QMARK] = ACTIONS(5724),
    [anon_sym_u2047] = ACTIONS(5724),
    [anon_sym_BSLASHsqcap] = ACTIONS(5724),
    [anon_sym_u2293] = ACTIONS(5724),
    [anon_sym_BSLASHsqcup] = ACTIONS(5724),
    [anon_sym_u2294] = ACTIONS(5724),
    [anon_sym_BSLASHuplus] = ACTIONS(5724),
    [anon_sym_u228e] = ACTIONS(5724),
    [anon_sym_BSLASHX] = ACTIONS(5724),
    [anon_sym_BSLASHtimes] = ACTIONS(5724),
    [anon_sym_u00d7] = ACTIONS(5724),
    [anon_sym_BSLASHwr] = ACTIONS(5724),
    [anon_sym_u2240] = ACTIONS(5724),
    [anon_sym_BSLASHcdot] = ACTIONS(5724),
    [anon_sym_u22c5] = ACTIONS(5724),
    [sym_pow] = ACTIONS(5726),
    [sym_powpow] = ACTIONS(5724),
    [anon_sym_CARET_PLUS] = ACTIONS(5724),
    [anon_sym_u207a] = ACTIONS(5724),
    [sym_asterisk] = ACTIONS(5724),
    [sym_sup_hash] = ACTIONS(5724),
    [sym_prime] = ACTIONS(5724),
    [sym__bullet] = ACTIONS(5724),
    [sym__dedent] = ACTIONS(5724),
    [sym__double_excl] = ACTIONS(5724),
  },
  [3383] = {
    [sym_block_comment] = STATE(3383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5848),
    [anon_sym_u2208] = ACTIONS(5846),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5846),
    [anon_sym_u25a1] = ACTIONS(5846),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5846),
    [anon_sym_u2227] = ACTIONS(5846),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5846),
    [anon_sym_u2228] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_BSLASHo] = ACTIONS(5848),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27f9] = ACTIONS(5846),
    [anon_sym_u21d2] = ACTIONS(5846),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5846),
    [anon_sym_u21f8] = ACTIONS(5846),
    [anon_sym_u2945] = ACTIONS(5846),
    [anon_sym_BSLASHequiv] = ACTIONS(5846),
    [anon_sym_u2261] = ACTIONS(5846),
    [anon_sym_LT_EQ_GT] = ACTIONS(5846),
    [anon_sym_u27fa] = ACTIONS(5846),
    [anon_sym_u21d4] = ACTIONS(5846),
    [anon_sym_TILDE_GT] = ACTIONS(5846),
    [anon_sym_u21dd] = ACTIONS(5846),
    [anon_sym_u219d] = ACTIONS(5846),
    [anon_sym_BSLASHland] = ACTIONS(5846),
    [anon_sym_BSLASHlor] = ACTIONS(5846),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2254] = ACTIONS(5846),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5846),
    [anon_sym_u2a74] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_POUND] = ACTIONS(5848),
    [anon_sym_u2260] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [sym_gt] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_EQ_LT] = ACTIONS(5846),
    [anon_sym_BSLASHleq] = ACTIONS(5846),
    [anon_sym_u2264] = ACTIONS(5846),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_BSLASHgeq] = ACTIONS(5846),
    [anon_sym_u2265] = ACTIONS(5846),
    [anon_sym_BSLASHapprox] = ACTIONS(5846),
    [anon_sym_u2248] = ACTIONS(5846),
    [anon_sym_PIPE_DASH] = ACTIONS(5846),
    [anon_sym_u22a2] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_u22a8] = ACTIONS(5846),
    [anon_sym_DASH_PIPE] = ACTIONS(5846),
    [anon_sym_u22a3] = ACTIONS(5846),
    [anon_sym_EQ_PIPE] = ACTIONS(5846),
    [anon_sym_u2ae4] = ACTIONS(5846),
    [anon_sym_BSLASHasymp] = ACTIONS(5846),
    [anon_sym_u224d] = ACTIONS(5846),
    [anon_sym_BSLASHcong] = ACTIONS(5846),
    [anon_sym_u2245] = ACTIONS(5846),
    [anon_sym_BSLASHdoteq] = ACTIONS(5846),
    [anon_sym_u2250] = ACTIONS(5846),
    [anon_sym_BSLASHgg] = ACTIONS(5846),
    [anon_sym_u226b] = ACTIONS(5846),
    [anon_sym_BSLASHll] = ACTIONS(5846),
    [anon_sym_u226a] = ACTIONS(5846),
    [anon_sym_BSLASHnotin] = ACTIONS(5846),
    [anon_sym_u2209] = ACTIONS(5846),
    [anon_sym_BSLASHprec] = ACTIONS(5848),
    [anon_sym_u227a] = ACTIONS(5846),
    [anon_sym_BSLASHsucc] = ACTIONS(5848),
    [anon_sym_u227b] = ACTIONS(5846),
    [anon_sym_BSLASHpreceq] = ACTIONS(5846),
    [anon_sym_u2aaf] = ACTIONS(5846),
    [anon_sym_BSLASHsucceq] = ACTIONS(5846),
    [anon_sym_u2ab0] = ACTIONS(5846),
    [anon_sym_BSLASHpropto] = ACTIONS(5846),
    [anon_sym_u221d] = ACTIONS(5846),
    [anon_sym_BSLASHsim] = ACTIONS(5848),
    [anon_sym_u223c] = ACTIONS(5846),
    [anon_sym_BSLASHsimeq] = ACTIONS(5846),
    [anon_sym_u2243] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5848),
    [anon_sym_u228f] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5848),
    [anon_sym_u2290] = ACTIONS(5846),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5846),
    [anon_sym_u2291] = ACTIONS(5846),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5846),
    [anon_sym_u2292] = ACTIONS(5846),
    [anon_sym_BSLASHsubset] = ACTIONS(5848),
    [anon_sym_u2282] = ACTIONS(5846),
    [anon_sym_BSLASHsupset] = ACTIONS(5848),
    [anon_sym_u2283] = ACTIONS(5846),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5846),
    [anon_sym_u2286] = ACTIONS(5846),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5846),
    [anon_sym_u2287] = ACTIONS(5846),
    [sym_compose] = ACTIONS(5846),
    [sym_map_to] = ACTIONS(5846),
    [sym_map_from] = ACTIONS(5846),
    [sym_setminus] = ACTIONS(5848),
    [anon_sym_BSLASHcap] = ACTIONS(5846),
    [anon_sym_BSLASHintersect] = ACTIONS(5846),
    [anon_sym_u2229] = ACTIONS(5846),
    [anon_sym_BSLASHcup] = ACTIONS(5846),
    [anon_sym_BSLASHunion] = ACTIONS(5846),
    [anon_sym_u222a] = ACTIONS(5846),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_u2025] = ACTIONS(5846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5846),
    [anon_sym_u2026] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [sym_plusplus] = ACTIONS(5846),
    [anon_sym_BSLASHoplus] = ACTIONS(5846),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5846),
    [anon_sym_u2295] = ACTIONS(5846),
    [anon_sym_BSLASHominus] = ACTIONS(5846),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2296] = ACTIONS(5846),
    [sym_mod] = ACTIONS(5848),
    [sym_modmod] = ACTIONS(5846),
    [sym_vert] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5846),
    [anon_sym_u2016] = ACTIONS(5846),
    [sym_minusminus] = ACTIONS(5846),
    [sym_amp] = ACTIONS(5848),
    [sym_ampamp] = ACTIONS(5846),
    [anon_sym_BSLASHodot] = ACTIONS(5846),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5846),
    [anon_sym_u2299] = ACTIONS(5846),
    [anon_sym_BSLASHoslash] = ACTIONS(5846),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5846),
    [anon_sym_u2298] = ACTIONS(5846),
    [anon_sym_BSLASHotimes] = ACTIONS(5846),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5846),
    [anon_sym_u2297] = ACTIONS(5846),
    [sym_mul] = ACTIONS(5848),
    [sym_mulmul] = ACTIONS(5846),
    [sym_slash] = ACTIONS(5848),
    [sym_slashslash] = ACTIONS(5846),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5846),
    [anon_sym_u25ef] = ACTIONS(5846),
    [anon_sym_BSLASHbullet] = ACTIONS(5846),
    [anon_sym_u25cf] = ACTIONS(5846),
    [anon_sym_BSLASHdiv] = ACTIONS(5846),
    [anon_sym_u00f7] = ACTIONS(5846),
    [anon_sym_BSLASHcirc] = ACTIONS(5846),
    [anon_sym_u2218] = ACTIONS(5846),
    [anon_sym_BSLASHstar] = ACTIONS(5846),
    [anon_sym_u22c6] = ACTIONS(5846),
    [anon_sym_u203c] = ACTIONS(5846),
    [sym_hashhash] = ACTIONS(5846),
    [sym_dol] = ACTIONS(5848),
    [sym_doldol] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK] = ACTIONS(5846),
    [anon_sym_u2047] = ACTIONS(5846),
    [anon_sym_BSLASHsqcap] = ACTIONS(5846),
    [anon_sym_u2293] = ACTIONS(5846),
    [anon_sym_BSLASHsqcup] = ACTIONS(5846),
    [anon_sym_u2294] = ACTIONS(5846),
    [anon_sym_BSLASHuplus] = ACTIONS(5846),
    [anon_sym_u228e] = ACTIONS(5846),
    [anon_sym_BSLASHX] = ACTIONS(5846),
    [anon_sym_BSLASHtimes] = ACTIONS(5846),
    [anon_sym_u00d7] = ACTIONS(5846),
    [anon_sym_BSLASHwr] = ACTIONS(5846),
    [anon_sym_u2240] = ACTIONS(5846),
    [anon_sym_BSLASHcdot] = ACTIONS(5846),
    [anon_sym_u22c5] = ACTIONS(5846),
    [sym_pow] = ACTIONS(5848),
    [sym_powpow] = ACTIONS(5846),
    [anon_sym_CARET_PLUS] = ACTIONS(5846),
    [anon_sym_u207a] = ACTIONS(5846),
    [sym_asterisk] = ACTIONS(5846),
    [sym_sup_hash] = ACTIONS(5846),
    [sym_prime] = ACTIONS(5846),
    [sym__bullet] = ACTIONS(5846),
    [sym__dedent] = ACTIONS(5846),
    [sym__double_excl] = ACTIONS(5846),
  },
  [3384] = {
    [sym_block_comment] = STATE(3384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5902),
    [anon_sym_u2208] = ACTIONS(5900),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5900),
    [anon_sym_u25a1] = ACTIONS(5900),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5900),
    [anon_sym_u2227] = ACTIONS(5900),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5900),
    [anon_sym_u2228] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_BSLASHo] = ACTIONS(5902),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27f9] = ACTIONS(5900),
    [anon_sym_u21d2] = ACTIONS(5900),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5900),
    [anon_sym_u21f8] = ACTIONS(5900),
    [anon_sym_u2945] = ACTIONS(5900),
    [anon_sym_BSLASHequiv] = ACTIONS(5900),
    [anon_sym_u2261] = ACTIONS(5900),
    [anon_sym_LT_EQ_GT] = ACTIONS(5900),
    [anon_sym_u27fa] = ACTIONS(5900),
    [anon_sym_u21d4] = ACTIONS(5900),
    [anon_sym_TILDE_GT] = ACTIONS(5900),
    [anon_sym_u21dd] = ACTIONS(5900),
    [anon_sym_u219d] = ACTIONS(5900),
    [anon_sym_BSLASHland] = ACTIONS(5900),
    [anon_sym_BSLASHlor] = ACTIONS(5900),
    [anon_sym_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2254] = ACTIONS(5900),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5900),
    [anon_sym_u2a74] = ACTIONS(5900),
    [anon_sym_SLASH_EQ] = ACTIONS(5900),
    [anon_sym_POUND] = ACTIONS(5902),
    [anon_sym_u2260] = ACTIONS(5900),
    [anon_sym_LT] = ACTIONS(5902),
    [sym_gt] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_EQ_LT] = ACTIONS(5900),
    [anon_sym_BSLASHleq] = ACTIONS(5900),
    [anon_sym_u2264] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5900),
    [anon_sym_BSLASHgeq] = ACTIONS(5900),
    [anon_sym_u2265] = ACTIONS(5900),
    [anon_sym_BSLASHapprox] = ACTIONS(5900),
    [anon_sym_u2248] = ACTIONS(5900),
    [anon_sym_PIPE_DASH] = ACTIONS(5900),
    [anon_sym_u22a2] = ACTIONS(5900),
    [anon_sym_PIPE_EQ] = ACTIONS(5900),
    [anon_sym_u22a8] = ACTIONS(5900),
    [anon_sym_DASH_PIPE] = ACTIONS(5900),
    [anon_sym_u22a3] = ACTIONS(5900),
    [anon_sym_EQ_PIPE] = ACTIONS(5900),
    [anon_sym_u2ae4] = ACTIONS(5900),
    [anon_sym_BSLASHasymp] = ACTIONS(5900),
    [anon_sym_u224d] = ACTIONS(5900),
    [anon_sym_BSLASHcong] = ACTIONS(5900),
    [anon_sym_u2245] = ACTIONS(5900),
    [anon_sym_BSLASHdoteq] = ACTIONS(5900),
    [anon_sym_u2250] = ACTIONS(5900),
    [anon_sym_BSLASHgg] = ACTIONS(5900),
    [anon_sym_u226b] = ACTIONS(5900),
    [anon_sym_BSLASHll] = ACTIONS(5900),
    [anon_sym_u226a] = ACTIONS(5900),
    [anon_sym_BSLASHnotin] = ACTIONS(5900),
    [anon_sym_u2209] = ACTIONS(5900),
    [anon_sym_BSLASHprec] = ACTIONS(5902),
    [anon_sym_u227a] = ACTIONS(5900),
    [anon_sym_BSLASHsucc] = ACTIONS(5902),
    [anon_sym_u227b] = ACTIONS(5900),
    [anon_sym_BSLASHpreceq] = ACTIONS(5900),
    [anon_sym_u2aaf] = ACTIONS(5900),
    [anon_sym_BSLASHsucceq] = ACTIONS(5900),
    [anon_sym_u2ab0] = ACTIONS(5900),
    [anon_sym_BSLASHpropto] = ACTIONS(5900),
    [anon_sym_u221d] = ACTIONS(5900),
    [anon_sym_BSLASHsim] = ACTIONS(5902),
    [anon_sym_u223c] = ACTIONS(5900),
    [anon_sym_BSLASHsimeq] = ACTIONS(5900),
    [anon_sym_u2243] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5902),
    [anon_sym_u228f] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5902),
    [anon_sym_u2290] = ACTIONS(5900),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5900),
    [anon_sym_u2291] = ACTIONS(5900),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5900),
    [anon_sym_u2292] = ACTIONS(5900),
    [anon_sym_BSLASHsubset] = ACTIONS(5902),
    [anon_sym_u2282] = ACTIONS(5900),
    [anon_sym_BSLASHsupset] = ACTIONS(5902),
    [anon_sym_u2283] = ACTIONS(5900),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5900),
    [anon_sym_u2286] = ACTIONS(5900),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5900),
    [anon_sym_u2287] = ACTIONS(5900),
    [sym_compose] = ACTIONS(5900),
    [sym_map_to] = ACTIONS(5900),
    [sym_map_from] = ACTIONS(5900),
    [sym_setminus] = ACTIONS(5902),
    [anon_sym_BSLASHcap] = ACTIONS(5900),
    [anon_sym_BSLASHintersect] = ACTIONS(5900),
    [anon_sym_u2229] = ACTIONS(5900),
    [anon_sym_BSLASHcup] = ACTIONS(5900),
    [anon_sym_BSLASHunion] = ACTIONS(5900),
    [anon_sym_u222a] = ACTIONS(5900),
    [anon_sym_DOT_DOT] = ACTIONS(5902),
    [anon_sym_u2025] = ACTIONS(5900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5900),
    [anon_sym_u2026] = ACTIONS(5900),
    [anon_sym_PLUS] = ACTIONS(5902),
    [sym_plusplus] = ACTIONS(5900),
    [anon_sym_BSLASHoplus] = ACTIONS(5900),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5900),
    [anon_sym_u2295] = ACTIONS(5900),
    [anon_sym_BSLASHominus] = ACTIONS(5900),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2296] = ACTIONS(5900),
    [sym_mod] = ACTIONS(5902),
    [sym_modmod] = ACTIONS(5900),
    [sym_vert] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5900),
    [anon_sym_u2016] = ACTIONS(5900),
    [sym_minusminus] = ACTIONS(5900),
    [sym_amp] = ACTIONS(5902),
    [sym_ampamp] = ACTIONS(5900),
    [anon_sym_BSLASHodot] = ACTIONS(5900),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5900),
    [anon_sym_u2299] = ACTIONS(5900),
    [anon_sym_BSLASHoslash] = ACTIONS(5900),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5900),
    [anon_sym_u2298] = ACTIONS(5900),
    [anon_sym_BSLASHotimes] = ACTIONS(5900),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5900),
    [anon_sym_u2297] = ACTIONS(5900),
    [sym_mul] = ACTIONS(5902),
    [sym_mulmul] = ACTIONS(5900),
    [sym_slash] = ACTIONS(5902),
    [sym_slashslash] = ACTIONS(5900),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5900),
    [anon_sym_u25ef] = ACTIONS(5900),
    [anon_sym_BSLASHbullet] = ACTIONS(5900),
    [anon_sym_u25cf] = ACTIONS(5900),
    [anon_sym_BSLASHdiv] = ACTIONS(5900),
    [anon_sym_u00f7] = ACTIONS(5900),
    [anon_sym_BSLASHcirc] = ACTIONS(5900),
    [anon_sym_u2218] = ACTIONS(5900),
    [anon_sym_BSLASHstar] = ACTIONS(5900),
    [anon_sym_u22c6] = ACTIONS(5900),
    [anon_sym_u203c] = ACTIONS(5900),
    [sym_hashhash] = ACTIONS(5900),
    [sym_dol] = ACTIONS(5902),
    [sym_doldol] = ACTIONS(5900),
    [anon_sym_QMARK_QMARK] = ACTIONS(5900),
    [anon_sym_u2047] = ACTIONS(5900),
    [anon_sym_BSLASHsqcap] = ACTIONS(5900),
    [anon_sym_u2293] = ACTIONS(5900),
    [anon_sym_BSLASHsqcup] = ACTIONS(5900),
    [anon_sym_u2294] = ACTIONS(5900),
    [anon_sym_BSLASHuplus] = ACTIONS(5900),
    [anon_sym_u228e] = ACTIONS(5900),
    [anon_sym_BSLASHX] = ACTIONS(5900),
    [anon_sym_BSLASHtimes] = ACTIONS(5900),
    [anon_sym_u00d7] = ACTIONS(5900),
    [anon_sym_BSLASHwr] = ACTIONS(5900),
    [anon_sym_u2240] = ACTIONS(5900),
    [anon_sym_BSLASHcdot] = ACTIONS(5900),
    [anon_sym_u22c5] = ACTIONS(5900),
    [sym_pow] = ACTIONS(5902),
    [sym_powpow] = ACTIONS(5900),
    [anon_sym_CARET_PLUS] = ACTIONS(5900),
    [anon_sym_u207a] = ACTIONS(5900),
    [sym_asterisk] = ACTIONS(5900),
    [sym_sup_hash] = ACTIONS(5900),
    [sym_prime] = ACTIONS(5900),
    [sym__bullet] = ACTIONS(5900),
    [sym__dedent] = ACTIONS(5900),
    [sym__double_excl] = ACTIONS(5900),
  },
  [3385] = {
    [sym_block_comment] = STATE(3385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5836),
    [anon_sym_u2208] = ACTIONS(5834),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5834),
    [anon_sym_u25a1] = ACTIONS(5834),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5834),
    [anon_sym_u2227] = ACTIONS(5834),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5834),
    [anon_sym_u2228] = ACTIONS(5834),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_BSLASHo] = ACTIONS(5836),
    [anon_sym_DOT] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [anon_sym_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27f9] = ACTIONS(5834),
    [anon_sym_u21d2] = ACTIONS(5834),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5834),
    [anon_sym_u21f8] = ACTIONS(5834),
    [anon_sym_u2945] = ACTIONS(5834),
    [anon_sym_BSLASHequiv] = ACTIONS(5834),
    [anon_sym_u2261] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5834),
    [anon_sym_u27fa] = ACTIONS(5834),
    [anon_sym_u21d4] = ACTIONS(5834),
    [anon_sym_TILDE_GT] = ACTIONS(5834),
    [anon_sym_u21dd] = ACTIONS(5834),
    [anon_sym_u219d] = ACTIONS(5834),
    [anon_sym_BSLASHland] = ACTIONS(5834),
    [anon_sym_BSLASHlor] = ACTIONS(5834),
    [anon_sym_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2254] = ACTIONS(5834),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5834),
    [anon_sym_u2a74] = ACTIONS(5834),
    [anon_sym_SLASH_EQ] = ACTIONS(5834),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_u2260] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5836),
    [sym_gt] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ_LT] = ACTIONS(5834),
    [anon_sym_BSLASHleq] = ACTIONS(5834),
    [anon_sym_u2264] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5834),
    [anon_sym_BSLASHgeq] = ACTIONS(5834),
    [anon_sym_u2265] = ACTIONS(5834),
    [anon_sym_BSLASHapprox] = ACTIONS(5834),
    [anon_sym_u2248] = ACTIONS(5834),
    [anon_sym_PIPE_DASH] = ACTIONS(5834),
    [anon_sym_u22a2] = ACTIONS(5834),
    [anon_sym_PIPE_EQ] = ACTIONS(5834),
    [anon_sym_u22a8] = ACTIONS(5834),
    [anon_sym_DASH_PIPE] = ACTIONS(5834),
    [anon_sym_u22a3] = ACTIONS(5834),
    [anon_sym_EQ_PIPE] = ACTIONS(5834),
    [anon_sym_u2ae4] = ACTIONS(5834),
    [anon_sym_BSLASHasymp] = ACTIONS(5834),
    [anon_sym_u224d] = ACTIONS(5834),
    [anon_sym_BSLASHcong] = ACTIONS(5834),
    [anon_sym_u2245] = ACTIONS(5834),
    [anon_sym_BSLASHdoteq] = ACTIONS(5834),
    [anon_sym_u2250] = ACTIONS(5834),
    [anon_sym_BSLASHgg] = ACTIONS(5834),
    [anon_sym_u226b] = ACTIONS(5834),
    [anon_sym_BSLASHll] = ACTIONS(5834),
    [anon_sym_u226a] = ACTIONS(5834),
    [anon_sym_BSLASHnotin] = ACTIONS(5834),
    [anon_sym_u2209] = ACTIONS(5834),
    [anon_sym_BSLASHprec] = ACTIONS(5836),
    [anon_sym_u227a] = ACTIONS(5834),
    [anon_sym_BSLASHsucc] = ACTIONS(5836),
    [anon_sym_u227b] = ACTIONS(5834),
    [anon_sym_BSLASHpreceq] = ACTIONS(5834),
    [anon_sym_u2aaf] = ACTIONS(5834),
    [anon_sym_BSLASHsucceq] = ACTIONS(5834),
    [anon_sym_u2ab0] = ACTIONS(5834),
    [anon_sym_BSLASHpropto] = ACTIONS(5834),
    [anon_sym_u221d] = ACTIONS(5834),
    [anon_sym_BSLASHsim] = ACTIONS(5836),
    [anon_sym_u223c] = ACTIONS(5834),
    [anon_sym_BSLASHsimeq] = ACTIONS(5834),
    [anon_sym_u2243] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5836),
    [anon_sym_u228f] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5836),
    [anon_sym_u2290] = ACTIONS(5834),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5834),
    [anon_sym_u2291] = ACTIONS(5834),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5834),
    [anon_sym_u2292] = ACTIONS(5834),
    [anon_sym_BSLASHsubset] = ACTIONS(5836),
    [anon_sym_u2282] = ACTIONS(5834),
    [anon_sym_BSLASHsupset] = ACTIONS(5836),
    [anon_sym_u2283] = ACTIONS(5834),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5834),
    [anon_sym_u2286] = ACTIONS(5834),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5834),
    [anon_sym_u2287] = ACTIONS(5834),
    [sym_compose] = ACTIONS(5834),
    [sym_map_to] = ACTIONS(5834),
    [sym_map_from] = ACTIONS(5834),
    [sym_setminus] = ACTIONS(5836),
    [anon_sym_BSLASHcap] = ACTIONS(5834),
    [anon_sym_BSLASHintersect] = ACTIONS(5834),
    [anon_sym_u2229] = ACTIONS(5834),
    [anon_sym_BSLASHcup] = ACTIONS(5834),
    [anon_sym_BSLASHunion] = ACTIONS(5834),
    [anon_sym_u222a] = ACTIONS(5834),
    [anon_sym_DOT_DOT] = ACTIONS(5836),
    [anon_sym_u2025] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5834),
    [anon_sym_u2026] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5836),
    [sym_plusplus] = ACTIONS(5834),
    [anon_sym_BSLASHoplus] = ACTIONS(5834),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5834),
    [anon_sym_u2295] = ACTIONS(5834),
    [anon_sym_BSLASHominus] = ACTIONS(5834),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2296] = ACTIONS(5834),
    [sym_mod] = ACTIONS(5836),
    [sym_modmod] = ACTIONS(5834),
    [sym_vert] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5834),
    [anon_sym_u2016] = ACTIONS(5834),
    [sym_minusminus] = ACTIONS(5834),
    [sym_amp] = ACTIONS(5836),
    [sym_ampamp] = ACTIONS(5834),
    [anon_sym_BSLASHodot] = ACTIONS(5834),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5834),
    [anon_sym_u2299] = ACTIONS(5834),
    [anon_sym_BSLASHoslash] = ACTIONS(5834),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5834),
    [anon_sym_u2298] = ACTIONS(5834),
    [anon_sym_BSLASHotimes] = ACTIONS(5834),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5834),
    [anon_sym_u2297] = ACTIONS(5834),
    [sym_mul] = ACTIONS(5836),
    [sym_mulmul] = ACTIONS(5834),
    [sym_slash] = ACTIONS(5836),
    [sym_slashslash] = ACTIONS(5834),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5834),
    [anon_sym_u25ef] = ACTIONS(5834),
    [anon_sym_BSLASHbullet] = ACTIONS(5834),
    [anon_sym_u25cf] = ACTIONS(5834),
    [anon_sym_BSLASHdiv] = ACTIONS(5834),
    [anon_sym_u00f7] = ACTIONS(5834),
    [anon_sym_BSLASHcirc] = ACTIONS(5834),
    [anon_sym_u2218] = ACTIONS(5834),
    [anon_sym_BSLASHstar] = ACTIONS(5834),
    [anon_sym_u22c6] = ACTIONS(5834),
    [anon_sym_u203c] = ACTIONS(5834),
    [sym_hashhash] = ACTIONS(5834),
    [sym_dol] = ACTIONS(5836),
    [sym_doldol] = ACTIONS(5834),
    [anon_sym_QMARK_QMARK] = ACTIONS(5834),
    [anon_sym_u2047] = ACTIONS(5834),
    [anon_sym_BSLASHsqcap] = ACTIONS(5834),
    [anon_sym_u2293] = ACTIONS(5834),
    [anon_sym_BSLASHsqcup] = ACTIONS(5834),
    [anon_sym_u2294] = ACTIONS(5834),
    [anon_sym_BSLASHuplus] = ACTIONS(5834),
    [anon_sym_u228e] = ACTIONS(5834),
    [anon_sym_BSLASHX] = ACTIONS(5834),
    [anon_sym_BSLASHtimes] = ACTIONS(5834),
    [anon_sym_u00d7] = ACTIONS(5834),
    [anon_sym_BSLASHwr] = ACTIONS(5834),
    [anon_sym_u2240] = ACTIONS(5834),
    [anon_sym_BSLASHcdot] = ACTIONS(5834),
    [anon_sym_u22c5] = ACTIONS(5834),
    [sym_pow] = ACTIONS(5836),
    [sym_powpow] = ACTIONS(5834),
    [anon_sym_CARET_PLUS] = ACTIONS(5834),
    [anon_sym_u207a] = ACTIONS(5834),
    [sym_asterisk] = ACTIONS(5834),
    [sym_sup_hash] = ACTIONS(5834),
    [sym_prime] = ACTIONS(5834),
    [sym__bullet] = ACTIONS(5834),
    [sym__dedent] = ACTIONS(5834),
    [sym__double_excl] = ACTIONS(5834),
  },
  [3386] = {
    [sym_block_comment] = STATE(3386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5349),
    [anon_sym_u2208] = ACTIONS(5351),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5351),
    [anon_sym_u25a1] = ACTIONS(5351),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5351),
    [anon_sym_u2227] = ACTIONS(5351),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5351),
    [anon_sym_u2228] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_BSLASHo] = ACTIONS(5349),
    [anon_sym_DOT] = ACTIONS(5349),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5349),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27f9] = ACTIONS(5351),
    [anon_sym_u21d2] = ACTIONS(5351),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5351),
    [anon_sym_u21f8] = ACTIONS(5351),
    [anon_sym_u2945] = ACTIONS(5351),
    [anon_sym_BSLASHequiv] = ACTIONS(5351),
    [anon_sym_u2261] = ACTIONS(5351),
    [anon_sym_LT_EQ_GT] = ACTIONS(5351),
    [anon_sym_u27fa] = ACTIONS(5351),
    [anon_sym_u21d4] = ACTIONS(5351),
    [anon_sym_TILDE_GT] = ACTIONS(5351),
    [anon_sym_u21dd] = ACTIONS(5351),
    [anon_sym_u219d] = ACTIONS(5351),
    [anon_sym_BSLASHland] = ACTIONS(5351),
    [anon_sym_BSLASHlor] = ACTIONS(5351),
    [anon_sym_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2254] = ACTIONS(5351),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5351),
    [anon_sym_u2a74] = ACTIONS(5351),
    [anon_sym_SLASH_EQ] = ACTIONS(5351),
    [anon_sym_POUND] = ACTIONS(5349),
    [anon_sym_u2260] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5349),
    [sym_gt] = ACTIONS(5349),
    [anon_sym_LT_EQ] = ACTIONS(5349),
    [anon_sym_EQ_LT] = ACTIONS(5351),
    [anon_sym_BSLASHleq] = ACTIONS(5351),
    [anon_sym_u2264] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_BSLASHgeq] = ACTIONS(5351),
    [anon_sym_u2265] = ACTIONS(5351),
    [anon_sym_BSLASHapprox] = ACTIONS(5351),
    [anon_sym_u2248] = ACTIONS(5351),
    [anon_sym_PIPE_DASH] = ACTIONS(5351),
    [anon_sym_u22a2] = ACTIONS(5351),
    [anon_sym_PIPE_EQ] = ACTIONS(5351),
    [anon_sym_u22a8] = ACTIONS(5351),
    [anon_sym_DASH_PIPE] = ACTIONS(5351),
    [anon_sym_u22a3] = ACTIONS(5351),
    [anon_sym_EQ_PIPE] = ACTIONS(5351),
    [anon_sym_u2ae4] = ACTIONS(5351),
    [anon_sym_BSLASHasymp] = ACTIONS(5351),
    [anon_sym_u224d] = ACTIONS(5351),
    [anon_sym_BSLASHcong] = ACTIONS(5351),
    [anon_sym_u2245] = ACTIONS(5351),
    [anon_sym_BSLASHdoteq] = ACTIONS(5351),
    [anon_sym_u2250] = ACTIONS(5351),
    [anon_sym_BSLASHgg] = ACTIONS(5351),
    [anon_sym_u226b] = ACTIONS(5351),
    [anon_sym_BSLASHll] = ACTIONS(5351),
    [anon_sym_u226a] = ACTIONS(5351),
    [anon_sym_BSLASHnotin] = ACTIONS(5351),
    [anon_sym_u2209] = ACTIONS(5351),
    [anon_sym_BSLASHprec] = ACTIONS(5349),
    [anon_sym_u227a] = ACTIONS(5351),
    [anon_sym_BSLASHsucc] = ACTIONS(5349),
    [anon_sym_u227b] = ACTIONS(5351),
    [anon_sym_BSLASHpreceq] = ACTIONS(5351),
    [anon_sym_u2aaf] = ACTIONS(5351),
    [anon_sym_BSLASHsucceq] = ACTIONS(5351),
    [anon_sym_u2ab0] = ACTIONS(5351),
    [anon_sym_BSLASHpropto] = ACTIONS(5351),
    [anon_sym_u221d] = ACTIONS(5351),
    [anon_sym_BSLASHsim] = ACTIONS(5349),
    [anon_sym_u223c] = ACTIONS(5351),
    [anon_sym_BSLASHsimeq] = ACTIONS(5351),
    [anon_sym_u2243] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5349),
    [anon_sym_u228f] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5349),
    [anon_sym_u2290] = ACTIONS(5351),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5351),
    [anon_sym_u2291] = ACTIONS(5351),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5351),
    [anon_sym_u2292] = ACTIONS(5351),
    [anon_sym_BSLASHsubset] = ACTIONS(5349),
    [anon_sym_u2282] = ACTIONS(5351),
    [anon_sym_BSLASHsupset] = ACTIONS(5349),
    [anon_sym_u2283] = ACTIONS(5351),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5351),
    [anon_sym_u2286] = ACTIONS(5351),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5351),
    [anon_sym_u2287] = ACTIONS(5351),
    [sym_compose] = ACTIONS(5351),
    [sym_map_to] = ACTIONS(5351),
    [sym_map_from] = ACTIONS(5351),
    [sym_setminus] = ACTIONS(5349),
    [anon_sym_BSLASHcap] = ACTIONS(5351),
    [anon_sym_BSLASHintersect] = ACTIONS(5351),
    [anon_sym_u2229] = ACTIONS(5351),
    [anon_sym_BSLASHcup] = ACTIONS(5351),
    [anon_sym_BSLASHunion] = ACTIONS(5351),
    [anon_sym_u222a] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5349),
    [anon_sym_u2025] = ACTIONS(5351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5351),
    [anon_sym_u2026] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5349),
    [sym_plusplus] = ACTIONS(5351),
    [anon_sym_BSLASHoplus] = ACTIONS(5351),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5351),
    [anon_sym_u2295] = ACTIONS(5351),
    [anon_sym_BSLASHominus] = ACTIONS(5351),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2296] = ACTIONS(5351),
    [sym_mod] = ACTIONS(5349),
    [sym_modmod] = ACTIONS(5351),
    [sym_vert] = ACTIONS(5349),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_u2016] = ACTIONS(5351),
    [sym_minusminus] = ACTIONS(5351),
    [sym_amp] = ACTIONS(5349),
    [sym_ampamp] = ACTIONS(5351),
    [anon_sym_BSLASHodot] = ACTIONS(5351),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5351),
    [anon_sym_u2299] = ACTIONS(5351),
    [anon_sym_BSLASHoslash] = ACTIONS(5351),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5351),
    [anon_sym_u2298] = ACTIONS(5351),
    [anon_sym_BSLASHotimes] = ACTIONS(5351),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5351),
    [anon_sym_u2297] = ACTIONS(5351),
    [sym_mul] = ACTIONS(5349),
    [sym_mulmul] = ACTIONS(5351),
    [sym_slash] = ACTIONS(5349),
    [sym_slashslash] = ACTIONS(5351),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5351),
    [anon_sym_u25ef] = ACTIONS(5351),
    [anon_sym_BSLASHbullet] = ACTIONS(5351),
    [anon_sym_u25cf] = ACTIONS(5351),
    [anon_sym_BSLASHdiv] = ACTIONS(5351),
    [anon_sym_u00f7] = ACTIONS(5351),
    [anon_sym_BSLASHcirc] = ACTIONS(5351),
    [anon_sym_u2218] = ACTIONS(5351),
    [anon_sym_BSLASHstar] = ACTIONS(5351),
    [anon_sym_u22c6] = ACTIONS(5351),
    [anon_sym_u203c] = ACTIONS(5351),
    [sym_hashhash] = ACTIONS(5351),
    [sym_dol] = ACTIONS(5349),
    [sym_doldol] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_u2047] = ACTIONS(5351),
    [anon_sym_BSLASHsqcap] = ACTIONS(5351),
    [anon_sym_u2293] = ACTIONS(5351),
    [anon_sym_BSLASHsqcup] = ACTIONS(5351),
    [anon_sym_u2294] = ACTIONS(5351),
    [anon_sym_BSLASHuplus] = ACTIONS(5351),
    [anon_sym_u228e] = ACTIONS(5351),
    [anon_sym_BSLASHX] = ACTIONS(5351),
    [anon_sym_BSLASHtimes] = ACTIONS(5351),
    [anon_sym_u00d7] = ACTIONS(5351),
    [anon_sym_BSLASHwr] = ACTIONS(5351),
    [anon_sym_u2240] = ACTIONS(5351),
    [anon_sym_BSLASHcdot] = ACTIONS(5351),
    [anon_sym_u22c5] = ACTIONS(5351),
    [sym_pow] = ACTIONS(5349),
    [sym_powpow] = ACTIONS(5351),
    [anon_sym_CARET_PLUS] = ACTIONS(5351),
    [anon_sym_u207a] = ACTIONS(5351),
    [sym_asterisk] = ACTIONS(5351),
    [sym_sup_hash] = ACTIONS(5351),
    [sym_prime] = ACTIONS(5351),
    [sym__bullet] = ACTIONS(5351),
    [sym__dedent] = ACTIONS(5351),
    [sym__double_excl] = ACTIONS(5351),
  },
  [3387] = {
    [sym_block_comment] = STATE(3387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5940),
    [anon_sym_u2208] = ACTIONS(5942),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5942),
    [anon_sym_u25a1] = ACTIONS(5942),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5942),
    [anon_sym_u2227] = ACTIONS(5942),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5942),
    [anon_sym_u2228] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5940),
    [anon_sym_BSLASHo] = ACTIONS(5940),
    [anon_sym_DOT] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_DASH] = ACTIONS(5940),
    [anon_sym_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27f9] = ACTIONS(5942),
    [anon_sym_u21d2] = ACTIONS(5942),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5942),
    [anon_sym_u21f8] = ACTIONS(5942),
    [anon_sym_u2945] = ACTIONS(5942),
    [anon_sym_BSLASHequiv] = ACTIONS(5942),
    [anon_sym_u2261] = ACTIONS(5942),
    [anon_sym_LT_EQ_GT] = ACTIONS(5942),
    [anon_sym_u27fa] = ACTIONS(5942),
    [anon_sym_u21d4] = ACTIONS(5942),
    [anon_sym_TILDE_GT] = ACTIONS(5942),
    [anon_sym_u21dd] = ACTIONS(5942),
    [anon_sym_u219d] = ACTIONS(5942),
    [anon_sym_BSLASHland] = ACTIONS(5942),
    [anon_sym_BSLASHlor] = ACTIONS(5942),
    [anon_sym_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2254] = ACTIONS(5942),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5942),
    [anon_sym_u2a74] = ACTIONS(5942),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_u2260] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [sym_gt] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5940),
    [anon_sym_EQ_LT] = ACTIONS(5942),
    [anon_sym_BSLASHleq] = ACTIONS(5942),
    [anon_sym_u2264] = ACTIONS(5942),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_BSLASHgeq] = ACTIONS(5942),
    [anon_sym_u2265] = ACTIONS(5942),
    [anon_sym_BSLASHapprox] = ACTIONS(5942),
    [anon_sym_u2248] = ACTIONS(5942),
    [anon_sym_PIPE_DASH] = ACTIONS(5942),
    [anon_sym_u22a2] = ACTIONS(5942),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_u22a8] = ACTIONS(5942),
    [anon_sym_DASH_PIPE] = ACTIONS(5942),
    [anon_sym_u22a3] = ACTIONS(5942),
    [anon_sym_EQ_PIPE] = ACTIONS(5942),
    [anon_sym_u2ae4] = ACTIONS(5942),
    [anon_sym_BSLASHasymp] = ACTIONS(5942),
    [anon_sym_u224d] = ACTIONS(5942),
    [anon_sym_BSLASHcong] = ACTIONS(5942),
    [anon_sym_u2245] = ACTIONS(5942),
    [anon_sym_BSLASHdoteq] = ACTIONS(5942),
    [anon_sym_u2250] = ACTIONS(5942),
    [anon_sym_BSLASHgg] = ACTIONS(5942),
    [anon_sym_u226b] = ACTIONS(5942),
    [anon_sym_BSLASHll] = ACTIONS(5942),
    [anon_sym_u226a] = ACTIONS(5942),
    [anon_sym_BSLASHnotin] = ACTIONS(5942),
    [anon_sym_u2209] = ACTIONS(5942),
    [anon_sym_BSLASHprec] = ACTIONS(5940),
    [anon_sym_u227a] = ACTIONS(5942),
    [anon_sym_BSLASHsucc] = ACTIONS(5940),
    [anon_sym_u227b] = ACTIONS(5942),
    [anon_sym_BSLASHpreceq] = ACTIONS(5942),
    [anon_sym_u2aaf] = ACTIONS(5942),
    [anon_sym_BSLASHsucceq] = ACTIONS(5942),
    [anon_sym_u2ab0] = ACTIONS(5942),
    [anon_sym_BSLASHpropto] = ACTIONS(5942),
    [anon_sym_u221d] = ACTIONS(5942),
    [anon_sym_BSLASHsim] = ACTIONS(5940),
    [anon_sym_u223c] = ACTIONS(5942),
    [anon_sym_BSLASHsimeq] = ACTIONS(5942),
    [anon_sym_u2243] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5940),
    [anon_sym_u228f] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5940),
    [anon_sym_u2290] = ACTIONS(5942),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5942),
    [anon_sym_u2291] = ACTIONS(5942),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5942),
    [anon_sym_u2292] = ACTIONS(5942),
    [anon_sym_BSLASHsubset] = ACTIONS(5940),
    [anon_sym_u2282] = ACTIONS(5942),
    [anon_sym_BSLASHsupset] = ACTIONS(5940),
    [anon_sym_u2283] = ACTIONS(5942),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5942),
    [anon_sym_u2286] = ACTIONS(5942),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5942),
    [anon_sym_u2287] = ACTIONS(5942),
    [sym_compose] = ACTIONS(5942),
    [sym_map_to] = ACTIONS(5942),
    [sym_map_from] = ACTIONS(5942),
    [sym_setminus] = ACTIONS(5940),
    [anon_sym_BSLASHcap] = ACTIONS(5942),
    [anon_sym_BSLASHintersect] = ACTIONS(5942),
    [anon_sym_u2229] = ACTIONS(5942),
    [anon_sym_BSLASHcup] = ACTIONS(5942),
    [anon_sym_BSLASHunion] = ACTIONS(5942),
    [anon_sym_u222a] = ACTIONS(5942),
    [anon_sym_DOT_DOT] = ACTIONS(5940),
    [anon_sym_u2025] = ACTIONS(5942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5942),
    [anon_sym_u2026] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [sym_plusplus] = ACTIONS(5942),
    [anon_sym_BSLASHoplus] = ACTIONS(5942),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5942),
    [anon_sym_u2295] = ACTIONS(5942),
    [anon_sym_BSLASHominus] = ACTIONS(5942),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2296] = ACTIONS(5942),
    [sym_mod] = ACTIONS(5940),
    [sym_modmod] = ACTIONS(5942),
    [sym_vert] = ACTIONS(5940),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_u2016] = ACTIONS(5942),
    [sym_minusminus] = ACTIONS(5942),
    [sym_amp] = ACTIONS(5940),
    [sym_ampamp] = ACTIONS(5942),
    [anon_sym_BSLASHodot] = ACTIONS(5942),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5942),
    [anon_sym_u2299] = ACTIONS(5942),
    [anon_sym_BSLASHoslash] = ACTIONS(5942),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5942),
    [anon_sym_u2298] = ACTIONS(5942),
    [anon_sym_BSLASHotimes] = ACTIONS(5942),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5942),
    [anon_sym_u2297] = ACTIONS(5942),
    [sym_mul] = ACTIONS(5940),
    [sym_mulmul] = ACTIONS(5942),
    [sym_slash] = ACTIONS(5940),
    [sym_slashslash] = ACTIONS(5942),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5942),
    [anon_sym_u25ef] = ACTIONS(5942),
    [anon_sym_BSLASHbullet] = ACTIONS(5942),
    [anon_sym_u25cf] = ACTIONS(5942),
    [anon_sym_BSLASHdiv] = ACTIONS(5942),
    [anon_sym_u00f7] = ACTIONS(5942),
    [anon_sym_BSLASHcirc] = ACTIONS(5942),
    [anon_sym_u2218] = ACTIONS(5942),
    [anon_sym_BSLASHstar] = ACTIONS(5942),
    [anon_sym_u22c6] = ACTIONS(5942),
    [anon_sym_u203c] = ACTIONS(5942),
    [sym_hashhash] = ACTIONS(5942),
    [sym_dol] = ACTIONS(5940),
    [sym_doldol] = ACTIONS(5942),
    [anon_sym_QMARK_QMARK] = ACTIONS(5942),
    [anon_sym_u2047] = ACTIONS(5942),
    [anon_sym_BSLASHsqcap] = ACTIONS(5942),
    [anon_sym_u2293] = ACTIONS(5942),
    [anon_sym_BSLASHsqcup] = ACTIONS(5942),
    [anon_sym_u2294] = ACTIONS(5942),
    [anon_sym_BSLASHuplus] = ACTIONS(5942),
    [anon_sym_u228e] = ACTIONS(5942),
    [anon_sym_BSLASHX] = ACTIONS(5942),
    [anon_sym_BSLASHtimes] = ACTIONS(5942),
    [anon_sym_u00d7] = ACTIONS(5942),
    [anon_sym_BSLASHwr] = ACTIONS(5942),
    [anon_sym_u2240] = ACTIONS(5942),
    [anon_sym_BSLASHcdot] = ACTIONS(5942),
    [anon_sym_u22c5] = ACTIONS(5942),
    [sym_pow] = ACTIONS(5940),
    [sym_powpow] = ACTIONS(5942),
    [anon_sym_CARET_PLUS] = ACTIONS(5942),
    [anon_sym_u207a] = ACTIONS(5942),
    [sym_asterisk] = ACTIONS(5942),
    [sym_sup_hash] = ACTIONS(5942),
    [sym_prime] = ACTIONS(5942),
    [sym__bullet] = ACTIONS(5942),
    [sym__dedent] = ACTIONS(5942),
    [sym__double_excl] = ACTIONS(5942),
  },
  [3388] = {
    [sym_block_comment] = STATE(3388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5868),
    [anon_sym_u2208] = ACTIONS(5870),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5870),
    [anon_sym_u25a1] = ACTIONS(5870),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5870),
    [anon_sym_u2227] = ACTIONS(5870),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5870),
    [anon_sym_u2228] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_BSLASHo] = ACTIONS(5868),
    [anon_sym_DOT] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27f9] = ACTIONS(5870),
    [anon_sym_u21d2] = ACTIONS(5870),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5870),
    [anon_sym_u21f8] = ACTIONS(5870),
    [anon_sym_u2945] = ACTIONS(5870),
    [anon_sym_BSLASHequiv] = ACTIONS(5870),
    [anon_sym_u2261] = ACTIONS(5870),
    [anon_sym_LT_EQ_GT] = ACTIONS(5870),
    [anon_sym_u27fa] = ACTIONS(5870),
    [anon_sym_u21d4] = ACTIONS(5870),
    [anon_sym_TILDE_GT] = ACTIONS(5870),
    [anon_sym_u21dd] = ACTIONS(5870),
    [anon_sym_u219d] = ACTIONS(5870),
    [anon_sym_BSLASHland] = ACTIONS(5870),
    [anon_sym_BSLASHlor] = ACTIONS(5870),
    [anon_sym_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2254] = ACTIONS(5870),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5870),
    [anon_sym_u2a74] = ACTIONS(5870),
    [anon_sym_SLASH_EQ] = ACTIONS(5870),
    [anon_sym_POUND] = ACTIONS(5868),
    [anon_sym_u2260] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5868),
    [sym_gt] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5868),
    [anon_sym_EQ_LT] = ACTIONS(5870),
    [anon_sym_BSLASHleq] = ACTIONS(5870),
    [anon_sym_u2264] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_BSLASHgeq] = ACTIONS(5870),
    [anon_sym_u2265] = ACTIONS(5870),
    [anon_sym_BSLASHapprox] = ACTIONS(5870),
    [anon_sym_u2248] = ACTIONS(5870),
    [anon_sym_PIPE_DASH] = ACTIONS(5870),
    [anon_sym_u22a2] = ACTIONS(5870),
    [anon_sym_PIPE_EQ] = ACTIONS(5870),
    [anon_sym_u22a8] = ACTIONS(5870),
    [anon_sym_DASH_PIPE] = ACTIONS(5870),
    [anon_sym_u22a3] = ACTIONS(5870),
    [anon_sym_EQ_PIPE] = ACTIONS(5870),
    [anon_sym_u2ae4] = ACTIONS(5870),
    [anon_sym_BSLASHasymp] = ACTIONS(5870),
    [anon_sym_u224d] = ACTIONS(5870),
    [anon_sym_BSLASHcong] = ACTIONS(5870),
    [anon_sym_u2245] = ACTIONS(5870),
    [anon_sym_BSLASHdoteq] = ACTIONS(5870),
    [anon_sym_u2250] = ACTIONS(5870),
    [anon_sym_BSLASHgg] = ACTIONS(5870),
    [anon_sym_u226b] = ACTIONS(5870),
    [anon_sym_BSLASHll] = ACTIONS(5870),
    [anon_sym_u226a] = ACTIONS(5870),
    [anon_sym_BSLASHnotin] = ACTIONS(5870),
    [anon_sym_u2209] = ACTIONS(5870),
    [anon_sym_BSLASHprec] = ACTIONS(5868),
    [anon_sym_u227a] = ACTIONS(5870),
    [anon_sym_BSLASHsucc] = ACTIONS(5868),
    [anon_sym_u227b] = ACTIONS(5870),
    [anon_sym_BSLASHpreceq] = ACTIONS(5870),
    [anon_sym_u2aaf] = ACTIONS(5870),
    [anon_sym_BSLASHsucceq] = ACTIONS(5870),
    [anon_sym_u2ab0] = ACTIONS(5870),
    [anon_sym_BSLASHpropto] = ACTIONS(5870),
    [anon_sym_u221d] = ACTIONS(5870),
    [anon_sym_BSLASHsim] = ACTIONS(5868),
    [anon_sym_u223c] = ACTIONS(5870),
    [anon_sym_BSLASHsimeq] = ACTIONS(5870),
    [anon_sym_u2243] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5868),
    [anon_sym_u228f] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5868),
    [anon_sym_u2290] = ACTIONS(5870),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5870),
    [anon_sym_u2291] = ACTIONS(5870),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5870),
    [anon_sym_u2292] = ACTIONS(5870),
    [anon_sym_BSLASHsubset] = ACTIONS(5868),
    [anon_sym_u2282] = ACTIONS(5870),
    [anon_sym_BSLASHsupset] = ACTIONS(5868),
    [anon_sym_u2283] = ACTIONS(5870),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5870),
    [anon_sym_u2286] = ACTIONS(5870),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5870),
    [anon_sym_u2287] = ACTIONS(5870),
    [sym_compose] = ACTIONS(5870),
    [sym_map_to] = ACTIONS(5870),
    [sym_map_from] = ACTIONS(5870),
    [sym_setminus] = ACTIONS(5868),
    [anon_sym_BSLASHcap] = ACTIONS(5870),
    [anon_sym_BSLASHintersect] = ACTIONS(5870),
    [anon_sym_u2229] = ACTIONS(5870),
    [anon_sym_BSLASHcup] = ACTIONS(5870),
    [anon_sym_BSLASHunion] = ACTIONS(5870),
    [anon_sym_u222a] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5868),
    [anon_sym_u2025] = ACTIONS(5870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5870),
    [anon_sym_u2026] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5868),
    [sym_plusplus] = ACTIONS(5870),
    [anon_sym_BSLASHoplus] = ACTIONS(5870),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5870),
    [anon_sym_u2295] = ACTIONS(5870),
    [anon_sym_BSLASHominus] = ACTIONS(5870),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2296] = ACTIONS(5870),
    [sym_mod] = ACTIONS(5868),
    [sym_modmod] = ACTIONS(5870),
    [sym_vert] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_u2016] = ACTIONS(5870),
    [sym_minusminus] = ACTIONS(5870),
    [sym_amp] = ACTIONS(5868),
    [sym_ampamp] = ACTIONS(5870),
    [anon_sym_BSLASHodot] = ACTIONS(5870),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5870),
    [anon_sym_u2299] = ACTIONS(5870),
    [anon_sym_BSLASHoslash] = ACTIONS(5870),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5870),
    [anon_sym_u2298] = ACTIONS(5870),
    [anon_sym_BSLASHotimes] = ACTIONS(5870),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5870),
    [anon_sym_u2297] = ACTIONS(5870),
    [sym_mul] = ACTIONS(5868),
    [sym_mulmul] = ACTIONS(5870),
    [sym_slash] = ACTIONS(5868),
    [sym_slashslash] = ACTIONS(5870),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5870),
    [anon_sym_u25ef] = ACTIONS(5870),
    [anon_sym_BSLASHbullet] = ACTIONS(5870),
    [anon_sym_u25cf] = ACTIONS(5870),
    [anon_sym_BSLASHdiv] = ACTIONS(5870),
    [anon_sym_u00f7] = ACTIONS(5870),
    [anon_sym_BSLASHcirc] = ACTIONS(5870),
    [anon_sym_u2218] = ACTIONS(5870),
    [anon_sym_BSLASHstar] = ACTIONS(5870),
    [anon_sym_u22c6] = ACTIONS(5870),
    [anon_sym_u203c] = ACTIONS(5870),
    [sym_hashhash] = ACTIONS(5870),
    [sym_dol] = ACTIONS(5868),
    [sym_doldol] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_u2047] = ACTIONS(5870),
    [anon_sym_BSLASHsqcap] = ACTIONS(5870),
    [anon_sym_u2293] = ACTIONS(5870),
    [anon_sym_BSLASHsqcup] = ACTIONS(5870),
    [anon_sym_u2294] = ACTIONS(5870),
    [anon_sym_BSLASHuplus] = ACTIONS(5870),
    [anon_sym_u228e] = ACTIONS(5870),
    [anon_sym_BSLASHX] = ACTIONS(5870),
    [anon_sym_BSLASHtimes] = ACTIONS(5870),
    [anon_sym_u00d7] = ACTIONS(5870),
    [anon_sym_BSLASHwr] = ACTIONS(5870),
    [anon_sym_u2240] = ACTIONS(5870),
    [anon_sym_BSLASHcdot] = ACTIONS(5870),
    [anon_sym_u22c5] = ACTIONS(5870),
    [sym_pow] = ACTIONS(5868),
    [sym_powpow] = ACTIONS(5870),
    [anon_sym_CARET_PLUS] = ACTIONS(5870),
    [anon_sym_u207a] = ACTIONS(5870),
    [sym_asterisk] = ACTIONS(5870),
    [sym_sup_hash] = ACTIONS(5870),
    [sym_prime] = ACTIONS(5870),
    [sym__bullet] = ACTIONS(5870),
    [sym__dedent] = ACTIONS(5870),
    [sym__double_excl] = ACTIONS(5870),
  },
  [3389] = {
    [sym_block_comment] = STATE(3389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5824),
    [anon_sym_u2208] = ACTIONS(5822),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5822),
    [anon_sym_u25a1] = ACTIONS(5822),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5822),
    [anon_sym_u2227] = ACTIONS(5822),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5822),
    [anon_sym_u2228] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_BSLASHo] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27f9] = ACTIONS(5822),
    [anon_sym_u21d2] = ACTIONS(5822),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5822),
    [anon_sym_u21f8] = ACTIONS(5822),
    [anon_sym_u2945] = ACTIONS(5822),
    [anon_sym_BSLASHequiv] = ACTIONS(5822),
    [anon_sym_u2261] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_u27fa] = ACTIONS(5822),
    [anon_sym_u21d4] = ACTIONS(5822),
    [anon_sym_TILDE_GT] = ACTIONS(5822),
    [anon_sym_u21dd] = ACTIONS(5822),
    [anon_sym_u219d] = ACTIONS(5822),
    [anon_sym_BSLASHland] = ACTIONS(5822),
    [anon_sym_BSLASHlor] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2254] = ACTIONS(5822),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5822),
    [anon_sym_u2a74] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_u2260] = ACTIONS(5822),
    [anon_sym_LT] = ACTIONS(5824),
    [sym_gt] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_EQ_LT] = ACTIONS(5822),
    [anon_sym_BSLASHleq] = ACTIONS(5822),
    [anon_sym_u2264] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_BSLASHgeq] = ACTIONS(5822),
    [anon_sym_u2265] = ACTIONS(5822),
    [anon_sym_BSLASHapprox] = ACTIONS(5822),
    [anon_sym_u2248] = ACTIONS(5822),
    [anon_sym_PIPE_DASH] = ACTIONS(5822),
    [anon_sym_u22a2] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_u22a8] = ACTIONS(5822),
    [anon_sym_DASH_PIPE] = ACTIONS(5822),
    [anon_sym_u22a3] = ACTIONS(5822),
    [anon_sym_EQ_PIPE] = ACTIONS(5822),
    [anon_sym_u2ae4] = ACTIONS(5822),
    [anon_sym_BSLASHasymp] = ACTIONS(5822),
    [anon_sym_u224d] = ACTIONS(5822),
    [anon_sym_BSLASHcong] = ACTIONS(5822),
    [anon_sym_u2245] = ACTIONS(5822),
    [anon_sym_BSLASHdoteq] = ACTIONS(5822),
    [anon_sym_u2250] = ACTIONS(5822),
    [anon_sym_BSLASHgg] = ACTIONS(5822),
    [anon_sym_u226b] = ACTIONS(5822),
    [anon_sym_BSLASHll] = ACTIONS(5822),
    [anon_sym_u226a] = ACTIONS(5822),
    [anon_sym_BSLASHnotin] = ACTIONS(5822),
    [anon_sym_u2209] = ACTIONS(5822),
    [anon_sym_BSLASHprec] = ACTIONS(5824),
    [anon_sym_u227a] = ACTIONS(5822),
    [anon_sym_BSLASHsucc] = ACTIONS(5824),
    [anon_sym_u227b] = ACTIONS(5822),
    [anon_sym_BSLASHpreceq] = ACTIONS(5822),
    [anon_sym_u2aaf] = ACTIONS(5822),
    [anon_sym_BSLASHsucceq] = ACTIONS(5822),
    [anon_sym_u2ab0] = ACTIONS(5822),
    [anon_sym_BSLASHpropto] = ACTIONS(5822),
    [anon_sym_u221d] = ACTIONS(5822),
    [anon_sym_BSLASHsim] = ACTIONS(5824),
    [anon_sym_u223c] = ACTIONS(5822),
    [anon_sym_BSLASHsimeq] = ACTIONS(5822),
    [anon_sym_u2243] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5824),
    [anon_sym_u228f] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5824),
    [anon_sym_u2290] = ACTIONS(5822),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5822),
    [anon_sym_u2291] = ACTIONS(5822),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5822),
    [anon_sym_u2292] = ACTIONS(5822),
    [anon_sym_BSLASHsubset] = ACTIONS(5824),
    [anon_sym_u2282] = ACTIONS(5822),
    [anon_sym_BSLASHsupset] = ACTIONS(5824),
    [anon_sym_u2283] = ACTIONS(5822),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5822),
    [anon_sym_u2286] = ACTIONS(5822),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5822),
    [anon_sym_u2287] = ACTIONS(5822),
    [sym_compose] = ACTIONS(5822),
    [sym_map_to] = ACTIONS(5822),
    [sym_map_from] = ACTIONS(5822),
    [sym_setminus] = ACTIONS(5824),
    [anon_sym_BSLASHcap] = ACTIONS(5822),
    [anon_sym_BSLASHintersect] = ACTIONS(5822),
    [anon_sym_u2229] = ACTIONS(5822),
    [anon_sym_BSLASHcup] = ACTIONS(5822),
    [anon_sym_BSLASHunion] = ACTIONS(5822),
    [anon_sym_u222a] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_u2025] = ACTIONS(5822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_u2026] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [sym_plusplus] = ACTIONS(5822),
    [anon_sym_BSLASHoplus] = ACTIONS(5822),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5822),
    [anon_sym_u2295] = ACTIONS(5822),
    [anon_sym_BSLASHominus] = ACTIONS(5822),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2296] = ACTIONS(5822),
    [sym_mod] = ACTIONS(5824),
    [sym_modmod] = ACTIONS(5822),
    [sym_vert] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_u2016] = ACTIONS(5822),
    [sym_minusminus] = ACTIONS(5822),
    [sym_amp] = ACTIONS(5824),
    [sym_ampamp] = ACTIONS(5822),
    [anon_sym_BSLASHodot] = ACTIONS(5822),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5822),
    [anon_sym_u2299] = ACTIONS(5822),
    [anon_sym_BSLASHoslash] = ACTIONS(5822),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5822),
    [anon_sym_u2298] = ACTIONS(5822),
    [anon_sym_BSLASHotimes] = ACTIONS(5822),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5822),
    [anon_sym_u2297] = ACTIONS(5822),
    [sym_mul] = ACTIONS(5824),
    [sym_mulmul] = ACTIONS(5822),
    [sym_slash] = ACTIONS(5824),
    [sym_slashslash] = ACTIONS(5822),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5822),
    [anon_sym_u25ef] = ACTIONS(5822),
    [anon_sym_BSLASHbullet] = ACTIONS(5822),
    [anon_sym_u25cf] = ACTIONS(5822),
    [anon_sym_BSLASHdiv] = ACTIONS(5822),
    [anon_sym_u00f7] = ACTIONS(5822),
    [anon_sym_BSLASHcirc] = ACTIONS(5822),
    [anon_sym_u2218] = ACTIONS(5822),
    [anon_sym_BSLASHstar] = ACTIONS(5822),
    [anon_sym_u22c6] = ACTIONS(5822),
    [anon_sym_u203c] = ACTIONS(5822),
    [sym_hashhash] = ACTIONS(5822),
    [sym_dol] = ACTIONS(5824),
    [sym_doldol] = ACTIONS(5822),
    [anon_sym_QMARK_QMARK] = ACTIONS(5822),
    [anon_sym_u2047] = ACTIONS(5822),
    [anon_sym_BSLASHsqcap] = ACTIONS(5822),
    [anon_sym_u2293] = ACTIONS(5822),
    [anon_sym_BSLASHsqcup] = ACTIONS(5822),
    [anon_sym_u2294] = ACTIONS(5822),
    [anon_sym_BSLASHuplus] = ACTIONS(5822),
    [anon_sym_u228e] = ACTIONS(5822),
    [anon_sym_BSLASHX] = ACTIONS(5822),
    [anon_sym_BSLASHtimes] = ACTIONS(5822),
    [anon_sym_u00d7] = ACTIONS(5822),
    [anon_sym_BSLASHwr] = ACTIONS(5822),
    [anon_sym_u2240] = ACTIONS(5822),
    [anon_sym_BSLASHcdot] = ACTIONS(5822),
    [anon_sym_u22c5] = ACTIONS(5822),
    [sym_pow] = ACTIONS(5824),
    [sym_powpow] = ACTIONS(5822),
    [anon_sym_CARET_PLUS] = ACTIONS(5822),
    [anon_sym_u207a] = ACTIONS(5822),
    [sym_asterisk] = ACTIONS(5822),
    [sym_sup_hash] = ACTIONS(5822),
    [sym_prime] = ACTIONS(5822),
    [sym__bullet] = ACTIONS(5822),
    [sym__dedent] = ACTIONS(5822),
    [sym__double_excl] = ACTIONS(5822),
  },
  [3390] = {
    [sym_block_comment] = STATE(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5888),
    [anon_sym_u2208] = ACTIONS(5890),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5890),
    [anon_sym_u25a1] = ACTIONS(5890),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5890),
    [anon_sym_u2227] = ACTIONS(5890),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5890),
    [anon_sym_u2228] = ACTIONS(5890),
    [anon_sym_LBRACK] = ACTIONS(5888),
    [anon_sym_BSLASHo] = ACTIONS(5888),
    [anon_sym_DOT] = ACTIONS(5888),
    [anon_sym_EQ] = ACTIONS(5888),
    [anon_sym_DASH] = ACTIONS(5888),
    [anon_sym_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27f9] = ACTIONS(5890),
    [anon_sym_u21d2] = ACTIONS(5890),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5890),
    [anon_sym_u21f8] = ACTIONS(5890),
    [anon_sym_u2945] = ACTIONS(5890),
    [anon_sym_BSLASHequiv] = ACTIONS(5890),
    [anon_sym_u2261] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5890),
    [anon_sym_u27fa] = ACTIONS(5890),
    [anon_sym_u21d4] = ACTIONS(5890),
    [anon_sym_TILDE_GT] = ACTIONS(5890),
    [anon_sym_u21dd] = ACTIONS(5890),
    [anon_sym_u219d] = ACTIONS(5890),
    [anon_sym_BSLASHland] = ACTIONS(5890),
    [anon_sym_BSLASHlor] = ACTIONS(5890),
    [anon_sym_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2254] = ACTIONS(5890),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5890),
    [anon_sym_u2a74] = ACTIONS(5890),
    [anon_sym_SLASH_EQ] = ACTIONS(5890),
    [anon_sym_POUND] = ACTIONS(5888),
    [anon_sym_u2260] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5888),
    [sym_gt] = ACTIONS(5888),
    [anon_sym_LT_EQ] = ACTIONS(5888),
    [anon_sym_EQ_LT] = ACTIONS(5890),
    [anon_sym_BSLASHleq] = ACTIONS(5890),
    [anon_sym_u2264] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_BSLASHgeq] = ACTIONS(5890),
    [anon_sym_u2265] = ACTIONS(5890),
    [anon_sym_BSLASHapprox] = ACTIONS(5890),
    [anon_sym_u2248] = ACTIONS(5890),
    [anon_sym_PIPE_DASH] = ACTIONS(5890),
    [anon_sym_u22a2] = ACTIONS(5890),
    [anon_sym_PIPE_EQ] = ACTIONS(5890),
    [anon_sym_u22a8] = ACTIONS(5890),
    [anon_sym_DASH_PIPE] = ACTIONS(5890),
    [anon_sym_u22a3] = ACTIONS(5890),
    [anon_sym_EQ_PIPE] = ACTIONS(5890),
    [anon_sym_u2ae4] = ACTIONS(5890),
    [anon_sym_BSLASHasymp] = ACTIONS(5890),
    [anon_sym_u224d] = ACTIONS(5890),
    [anon_sym_BSLASHcong] = ACTIONS(5890),
    [anon_sym_u2245] = ACTIONS(5890),
    [anon_sym_BSLASHdoteq] = ACTIONS(5890),
    [anon_sym_u2250] = ACTIONS(5890),
    [anon_sym_BSLASHgg] = ACTIONS(5890),
    [anon_sym_u226b] = ACTIONS(5890),
    [anon_sym_BSLASHll] = ACTIONS(5890),
    [anon_sym_u226a] = ACTIONS(5890),
    [anon_sym_BSLASHnotin] = ACTIONS(5890),
    [anon_sym_u2209] = ACTIONS(5890),
    [anon_sym_BSLASHprec] = ACTIONS(5888),
    [anon_sym_u227a] = ACTIONS(5890),
    [anon_sym_BSLASHsucc] = ACTIONS(5888),
    [anon_sym_u227b] = ACTIONS(5890),
    [anon_sym_BSLASHpreceq] = ACTIONS(5890),
    [anon_sym_u2aaf] = ACTIONS(5890),
    [anon_sym_BSLASHsucceq] = ACTIONS(5890),
    [anon_sym_u2ab0] = ACTIONS(5890),
    [anon_sym_BSLASHpropto] = ACTIONS(5890),
    [anon_sym_u221d] = ACTIONS(5890),
    [anon_sym_BSLASHsim] = ACTIONS(5888),
    [anon_sym_u223c] = ACTIONS(5890),
    [anon_sym_BSLASHsimeq] = ACTIONS(5890),
    [anon_sym_u2243] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5888),
    [anon_sym_u228f] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5888),
    [anon_sym_u2290] = ACTIONS(5890),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5890),
    [anon_sym_u2291] = ACTIONS(5890),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5890),
    [anon_sym_u2292] = ACTIONS(5890),
    [anon_sym_BSLASHsubset] = ACTIONS(5888),
    [anon_sym_u2282] = ACTIONS(5890),
    [anon_sym_BSLASHsupset] = ACTIONS(5888),
    [anon_sym_u2283] = ACTIONS(5890),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5890),
    [anon_sym_u2286] = ACTIONS(5890),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5890),
    [anon_sym_u2287] = ACTIONS(5890),
    [sym_compose] = ACTIONS(5890),
    [sym_map_to] = ACTIONS(5890),
    [sym_map_from] = ACTIONS(5890),
    [sym_setminus] = ACTIONS(5888),
    [anon_sym_BSLASHcap] = ACTIONS(5890),
    [anon_sym_BSLASHintersect] = ACTIONS(5890),
    [anon_sym_u2229] = ACTIONS(5890),
    [anon_sym_BSLASHcup] = ACTIONS(5890),
    [anon_sym_BSLASHunion] = ACTIONS(5890),
    [anon_sym_u222a] = ACTIONS(5890),
    [anon_sym_DOT_DOT] = ACTIONS(5888),
    [anon_sym_u2025] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5890),
    [anon_sym_u2026] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5888),
    [sym_plusplus] = ACTIONS(5890),
    [anon_sym_BSLASHoplus] = ACTIONS(5890),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5890),
    [anon_sym_u2295] = ACTIONS(5890),
    [anon_sym_BSLASHominus] = ACTIONS(5890),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2296] = ACTIONS(5890),
    [sym_mod] = ACTIONS(5888),
    [sym_modmod] = ACTIONS(5890),
    [sym_vert] = ACTIONS(5888),
    [anon_sym_PIPE_PIPE] = ACTIONS(5890),
    [anon_sym_u2016] = ACTIONS(5890),
    [sym_minusminus] = ACTIONS(5890),
    [sym_amp] = ACTIONS(5888),
    [sym_ampamp] = ACTIONS(5890),
    [anon_sym_BSLASHodot] = ACTIONS(5890),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5890),
    [anon_sym_u2299] = ACTIONS(5890),
    [anon_sym_BSLASHoslash] = ACTIONS(5890),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5890),
    [anon_sym_u2298] = ACTIONS(5890),
    [anon_sym_BSLASHotimes] = ACTIONS(5890),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5890),
    [anon_sym_u2297] = ACTIONS(5890),
    [sym_mul] = ACTIONS(5888),
    [sym_mulmul] = ACTIONS(5890),
    [sym_slash] = ACTIONS(5888),
    [sym_slashslash] = ACTIONS(5890),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5890),
    [anon_sym_u25ef] = ACTIONS(5890),
    [anon_sym_BSLASHbullet] = ACTIONS(5890),
    [anon_sym_u25cf] = ACTIONS(5890),
    [anon_sym_BSLASHdiv] = ACTIONS(5890),
    [anon_sym_u00f7] = ACTIONS(5890),
    [anon_sym_BSLASHcirc] = ACTIONS(5890),
    [anon_sym_u2218] = ACTIONS(5890),
    [anon_sym_BSLASHstar] = ACTIONS(5890),
    [anon_sym_u22c6] = ACTIONS(5890),
    [anon_sym_u203c] = ACTIONS(5890),
    [sym_hashhash] = ACTIONS(5890),
    [sym_dol] = ACTIONS(5888),
    [sym_doldol] = ACTIONS(5890),
    [anon_sym_QMARK_QMARK] = ACTIONS(5890),
    [anon_sym_u2047] = ACTIONS(5890),
    [anon_sym_BSLASHsqcap] = ACTIONS(5890),
    [anon_sym_u2293] = ACTIONS(5890),
    [anon_sym_BSLASHsqcup] = ACTIONS(5890),
    [anon_sym_u2294] = ACTIONS(5890),
    [anon_sym_BSLASHuplus] = ACTIONS(5890),
    [anon_sym_u228e] = ACTIONS(5890),
    [anon_sym_BSLASHX] = ACTIONS(5890),
    [anon_sym_BSLASHtimes] = ACTIONS(5890),
    [anon_sym_u00d7] = ACTIONS(5890),
    [anon_sym_BSLASHwr] = ACTIONS(5890),
    [anon_sym_u2240] = ACTIONS(5890),
    [anon_sym_BSLASHcdot] = ACTIONS(5890),
    [anon_sym_u22c5] = ACTIONS(5890),
    [sym_pow] = ACTIONS(5888),
    [sym_powpow] = ACTIONS(5890),
    [anon_sym_CARET_PLUS] = ACTIONS(5890),
    [anon_sym_u207a] = ACTIONS(5890),
    [sym_asterisk] = ACTIONS(5890),
    [sym_sup_hash] = ACTIONS(5890),
    [sym_prime] = ACTIONS(5890),
    [sym__bullet] = ACTIONS(5890),
    [sym__dedent] = ACTIONS(5890),
    [sym__double_excl] = ACTIONS(5890),
  },
  [3391] = {
    [sym_block_comment] = STATE(3391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5832),
    [anon_sym_u2208] = ACTIONS(5830),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5830),
    [anon_sym_u25a1] = ACTIONS(5830),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5830),
    [anon_sym_u2227] = ACTIONS(5830),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5830),
    [anon_sym_u2228] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5832),
    [anon_sym_BSLASHo] = ACTIONS(5832),
    [anon_sym_DOT] = ACTIONS(5832),
    [anon_sym_EQ] = ACTIONS(5832),
    [anon_sym_DASH] = ACTIONS(5832),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27f9] = ACTIONS(5830),
    [anon_sym_u21d2] = ACTIONS(5830),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5830),
    [anon_sym_u21f8] = ACTIONS(5830),
    [anon_sym_u2945] = ACTIONS(5830),
    [anon_sym_BSLASHequiv] = ACTIONS(5830),
    [anon_sym_u2261] = ACTIONS(5830),
    [anon_sym_LT_EQ_GT] = ACTIONS(5830),
    [anon_sym_u27fa] = ACTIONS(5830),
    [anon_sym_u21d4] = ACTIONS(5830),
    [anon_sym_TILDE_GT] = ACTIONS(5830),
    [anon_sym_u21dd] = ACTIONS(5830),
    [anon_sym_u219d] = ACTIONS(5830),
    [anon_sym_BSLASHland] = ACTIONS(5830),
    [anon_sym_BSLASHlor] = ACTIONS(5830),
    [anon_sym_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2254] = ACTIONS(5830),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5830),
    [anon_sym_u2a74] = ACTIONS(5830),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5832),
    [anon_sym_u2260] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5832),
    [sym_gt] = ACTIONS(5832),
    [anon_sym_LT_EQ] = ACTIONS(5832),
    [anon_sym_EQ_LT] = ACTIONS(5830),
    [anon_sym_BSLASHleq] = ACTIONS(5830),
    [anon_sym_u2264] = ACTIONS(5830),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_BSLASHgeq] = ACTIONS(5830),
    [anon_sym_u2265] = ACTIONS(5830),
    [anon_sym_BSLASHapprox] = ACTIONS(5830),
    [anon_sym_u2248] = ACTIONS(5830),
    [anon_sym_PIPE_DASH] = ACTIONS(5830),
    [anon_sym_u22a2] = ACTIONS(5830),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_u22a8] = ACTIONS(5830),
    [anon_sym_DASH_PIPE] = ACTIONS(5830),
    [anon_sym_u22a3] = ACTIONS(5830),
    [anon_sym_EQ_PIPE] = ACTIONS(5830),
    [anon_sym_u2ae4] = ACTIONS(5830),
    [anon_sym_BSLASHasymp] = ACTIONS(5830),
    [anon_sym_u224d] = ACTIONS(5830),
    [anon_sym_BSLASHcong] = ACTIONS(5830),
    [anon_sym_u2245] = ACTIONS(5830),
    [anon_sym_BSLASHdoteq] = ACTIONS(5830),
    [anon_sym_u2250] = ACTIONS(5830),
    [anon_sym_BSLASHgg] = ACTIONS(5830),
    [anon_sym_u226b] = ACTIONS(5830),
    [anon_sym_BSLASHll] = ACTIONS(5830),
    [anon_sym_u226a] = ACTIONS(5830),
    [anon_sym_BSLASHnotin] = ACTIONS(5830),
    [anon_sym_u2209] = ACTIONS(5830),
    [anon_sym_BSLASHprec] = ACTIONS(5832),
    [anon_sym_u227a] = ACTIONS(5830),
    [anon_sym_BSLASHsucc] = ACTIONS(5832),
    [anon_sym_u227b] = ACTIONS(5830),
    [anon_sym_BSLASHpreceq] = ACTIONS(5830),
    [anon_sym_u2aaf] = ACTIONS(5830),
    [anon_sym_BSLASHsucceq] = ACTIONS(5830),
    [anon_sym_u2ab0] = ACTIONS(5830),
    [anon_sym_BSLASHpropto] = ACTIONS(5830),
    [anon_sym_u221d] = ACTIONS(5830),
    [anon_sym_BSLASHsim] = ACTIONS(5832),
    [anon_sym_u223c] = ACTIONS(5830),
    [anon_sym_BSLASHsimeq] = ACTIONS(5830),
    [anon_sym_u2243] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5832),
    [anon_sym_u228f] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5832),
    [anon_sym_u2290] = ACTIONS(5830),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5830),
    [anon_sym_u2291] = ACTIONS(5830),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5830),
    [anon_sym_u2292] = ACTIONS(5830),
    [anon_sym_BSLASHsubset] = ACTIONS(5832),
    [anon_sym_u2282] = ACTIONS(5830),
    [anon_sym_BSLASHsupset] = ACTIONS(5832),
    [anon_sym_u2283] = ACTIONS(5830),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5830),
    [anon_sym_u2286] = ACTIONS(5830),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5830),
    [anon_sym_u2287] = ACTIONS(5830),
    [sym_compose] = ACTIONS(5830),
    [sym_map_to] = ACTIONS(5830),
    [sym_map_from] = ACTIONS(5830),
    [sym_setminus] = ACTIONS(5832),
    [anon_sym_BSLASHcap] = ACTIONS(5830),
    [anon_sym_BSLASHintersect] = ACTIONS(5830),
    [anon_sym_u2229] = ACTIONS(5830),
    [anon_sym_BSLASHcup] = ACTIONS(5830),
    [anon_sym_BSLASHunion] = ACTIONS(5830),
    [anon_sym_u222a] = ACTIONS(5830),
    [anon_sym_DOT_DOT] = ACTIONS(5832),
    [anon_sym_u2025] = ACTIONS(5830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_u2026] = ACTIONS(5830),
    [anon_sym_PLUS] = ACTIONS(5832),
    [sym_plusplus] = ACTIONS(5830),
    [anon_sym_BSLASHoplus] = ACTIONS(5830),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5830),
    [anon_sym_u2295] = ACTIONS(5830),
    [anon_sym_BSLASHominus] = ACTIONS(5830),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2296] = ACTIONS(5830),
    [sym_mod] = ACTIONS(5832),
    [sym_modmod] = ACTIONS(5830),
    [sym_vert] = ACTIONS(5832),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_u2016] = ACTIONS(5830),
    [sym_minusminus] = ACTIONS(5830),
    [sym_amp] = ACTIONS(5832),
    [sym_ampamp] = ACTIONS(5830),
    [anon_sym_BSLASHodot] = ACTIONS(5830),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5830),
    [anon_sym_u2299] = ACTIONS(5830),
    [anon_sym_BSLASHoslash] = ACTIONS(5830),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5830),
    [anon_sym_u2298] = ACTIONS(5830),
    [anon_sym_BSLASHotimes] = ACTIONS(5830),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5830),
    [anon_sym_u2297] = ACTIONS(5830),
    [sym_mul] = ACTIONS(5832),
    [sym_mulmul] = ACTIONS(5830),
    [sym_slash] = ACTIONS(5832),
    [sym_slashslash] = ACTIONS(5830),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5830),
    [anon_sym_u25ef] = ACTIONS(5830),
    [anon_sym_BSLASHbullet] = ACTIONS(5830),
    [anon_sym_u25cf] = ACTIONS(5830),
    [anon_sym_BSLASHdiv] = ACTIONS(5830),
    [anon_sym_u00f7] = ACTIONS(5830),
    [anon_sym_BSLASHcirc] = ACTIONS(5830),
    [anon_sym_u2218] = ACTIONS(5830),
    [anon_sym_BSLASHstar] = ACTIONS(5830),
    [anon_sym_u22c6] = ACTIONS(5830),
    [anon_sym_u203c] = ACTIONS(5830),
    [sym_hashhash] = ACTIONS(5830),
    [sym_dol] = ACTIONS(5832),
    [sym_doldol] = ACTIONS(5830),
    [anon_sym_QMARK_QMARK] = ACTIONS(5830),
    [anon_sym_u2047] = ACTIONS(5830),
    [anon_sym_BSLASHsqcap] = ACTIONS(5830),
    [anon_sym_u2293] = ACTIONS(5830),
    [anon_sym_BSLASHsqcup] = ACTIONS(5830),
    [anon_sym_u2294] = ACTIONS(5830),
    [anon_sym_BSLASHuplus] = ACTIONS(5830),
    [anon_sym_u228e] = ACTIONS(5830),
    [anon_sym_BSLASHX] = ACTIONS(5830),
    [anon_sym_BSLASHtimes] = ACTIONS(5830),
    [anon_sym_u00d7] = ACTIONS(5830),
    [anon_sym_BSLASHwr] = ACTIONS(5830),
    [anon_sym_u2240] = ACTIONS(5830),
    [anon_sym_BSLASHcdot] = ACTIONS(5830),
    [anon_sym_u22c5] = ACTIONS(5830),
    [sym_pow] = ACTIONS(5832),
    [sym_powpow] = ACTIONS(5830),
    [anon_sym_CARET_PLUS] = ACTIONS(5830),
    [anon_sym_u207a] = ACTIONS(5830),
    [sym_asterisk] = ACTIONS(5830),
    [sym_sup_hash] = ACTIONS(5830),
    [sym_prime] = ACTIONS(5830),
    [sym__bullet] = ACTIONS(5830),
    [sym__dedent] = ACTIONS(5830),
    [sym__double_excl] = ACTIONS(5830),
  },
  [3392] = {
    [sym_block_comment] = STATE(3392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5730),
    [anon_sym_u2208] = ACTIONS(5728),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5728),
    [anon_sym_u25a1] = ACTIONS(5728),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5728),
    [anon_sym_u2227] = ACTIONS(5728),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5728),
    [anon_sym_u2228] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_BSLASHo] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_DASH] = ACTIONS(5730),
    [anon_sym_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27f9] = ACTIONS(5728),
    [anon_sym_u21d2] = ACTIONS(5728),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5728),
    [anon_sym_u21f8] = ACTIONS(5728),
    [anon_sym_u2945] = ACTIONS(5728),
    [anon_sym_BSLASHequiv] = ACTIONS(5728),
    [anon_sym_u2261] = ACTIONS(5728),
    [anon_sym_LT_EQ_GT] = ACTIONS(5728),
    [anon_sym_u27fa] = ACTIONS(5728),
    [anon_sym_u21d4] = ACTIONS(5728),
    [anon_sym_TILDE_GT] = ACTIONS(5728),
    [anon_sym_u21dd] = ACTIONS(5728),
    [anon_sym_u219d] = ACTIONS(5728),
    [anon_sym_BSLASHland] = ACTIONS(5728),
    [anon_sym_BSLASHlor] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2254] = ACTIONS(5728),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5728),
    [anon_sym_u2a74] = ACTIONS(5728),
    [anon_sym_SLASH_EQ] = ACTIONS(5728),
    [anon_sym_POUND] = ACTIONS(5730),
    [anon_sym_u2260] = ACTIONS(5728),
    [anon_sym_LT] = ACTIONS(5730),
    [sym_gt] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_EQ_LT] = ACTIONS(5728),
    [anon_sym_BSLASHleq] = ACTIONS(5728),
    [anon_sym_u2264] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5728),
    [anon_sym_BSLASHgeq] = ACTIONS(5728),
    [anon_sym_u2265] = ACTIONS(5728),
    [anon_sym_BSLASHapprox] = ACTIONS(5728),
    [anon_sym_u2248] = ACTIONS(5728),
    [anon_sym_PIPE_DASH] = ACTIONS(5728),
    [anon_sym_u22a2] = ACTIONS(5728),
    [anon_sym_PIPE_EQ] = ACTIONS(5728),
    [anon_sym_u22a8] = ACTIONS(5728),
    [anon_sym_DASH_PIPE] = ACTIONS(5728),
    [anon_sym_u22a3] = ACTIONS(5728),
    [anon_sym_EQ_PIPE] = ACTIONS(5728),
    [anon_sym_u2ae4] = ACTIONS(5728),
    [anon_sym_BSLASHasymp] = ACTIONS(5728),
    [anon_sym_u224d] = ACTIONS(5728),
    [anon_sym_BSLASHcong] = ACTIONS(5728),
    [anon_sym_u2245] = ACTIONS(5728),
    [anon_sym_BSLASHdoteq] = ACTIONS(5728),
    [anon_sym_u2250] = ACTIONS(5728),
    [anon_sym_BSLASHgg] = ACTIONS(5728),
    [anon_sym_u226b] = ACTIONS(5728),
    [anon_sym_BSLASHll] = ACTIONS(5728),
    [anon_sym_u226a] = ACTIONS(5728),
    [anon_sym_BSLASHnotin] = ACTIONS(5728),
    [anon_sym_u2209] = ACTIONS(5728),
    [anon_sym_BSLASHprec] = ACTIONS(5730),
    [anon_sym_u227a] = ACTIONS(5728),
    [anon_sym_BSLASHsucc] = ACTIONS(5730),
    [anon_sym_u227b] = ACTIONS(5728),
    [anon_sym_BSLASHpreceq] = ACTIONS(5728),
    [anon_sym_u2aaf] = ACTIONS(5728),
    [anon_sym_BSLASHsucceq] = ACTIONS(5728),
    [anon_sym_u2ab0] = ACTIONS(5728),
    [anon_sym_BSLASHpropto] = ACTIONS(5728),
    [anon_sym_u221d] = ACTIONS(5728),
    [anon_sym_BSLASHsim] = ACTIONS(5730),
    [anon_sym_u223c] = ACTIONS(5728),
    [anon_sym_BSLASHsimeq] = ACTIONS(5728),
    [anon_sym_u2243] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5730),
    [anon_sym_u228f] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5730),
    [anon_sym_u2290] = ACTIONS(5728),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5728),
    [anon_sym_u2291] = ACTIONS(5728),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5728),
    [anon_sym_u2292] = ACTIONS(5728),
    [anon_sym_BSLASHsubset] = ACTIONS(5730),
    [anon_sym_u2282] = ACTIONS(5728),
    [anon_sym_BSLASHsupset] = ACTIONS(5730),
    [anon_sym_u2283] = ACTIONS(5728),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5728),
    [anon_sym_u2286] = ACTIONS(5728),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5728),
    [anon_sym_u2287] = ACTIONS(5728),
    [sym_compose] = ACTIONS(5728),
    [sym_map_to] = ACTIONS(5728),
    [sym_map_from] = ACTIONS(5728),
    [sym_setminus] = ACTIONS(5730),
    [anon_sym_BSLASHcap] = ACTIONS(5728),
    [anon_sym_BSLASHintersect] = ACTIONS(5728),
    [anon_sym_u2229] = ACTIONS(5728),
    [anon_sym_BSLASHcup] = ACTIONS(5728),
    [anon_sym_BSLASHunion] = ACTIONS(5728),
    [anon_sym_u222a] = ACTIONS(5728),
    [anon_sym_DOT_DOT] = ACTIONS(5730),
    [anon_sym_u2025] = ACTIONS(5728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5728),
    [anon_sym_u2026] = ACTIONS(5728),
    [anon_sym_PLUS] = ACTIONS(5730),
    [sym_plusplus] = ACTIONS(5728),
    [anon_sym_BSLASHoplus] = ACTIONS(5728),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5728),
    [anon_sym_u2295] = ACTIONS(5728),
    [anon_sym_BSLASHominus] = ACTIONS(5728),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2296] = ACTIONS(5728),
    [sym_mod] = ACTIONS(5730),
    [sym_modmod] = ACTIONS(5728),
    [sym_vert] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_u2016] = ACTIONS(5728),
    [sym_minusminus] = ACTIONS(5728),
    [sym_amp] = ACTIONS(5730),
    [sym_ampamp] = ACTIONS(5728),
    [anon_sym_BSLASHodot] = ACTIONS(5728),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5728),
    [anon_sym_u2299] = ACTIONS(5728),
    [anon_sym_BSLASHoslash] = ACTIONS(5728),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5728),
    [anon_sym_u2298] = ACTIONS(5728),
    [anon_sym_BSLASHotimes] = ACTIONS(5728),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5728),
    [anon_sym_u2297] = ACTIONS(5728),
    [sym_mul] = ACTIONS(5730),
    [sym_mulmul] = ACTIONS(5728),
    [sym_slash] = ACTIONS(5730),
    [sym_slashslash] = ACTIONS(5728),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5728),
    [anon_sym_u25ef] = ACTIONS(5728),
    [anon_sym_BSLASHbullet] = ACTIONS(5728),
    [anon_sym_u25cf] = ACTIONS(5728),
    [anon_sym_BSLASHdiv] = ACTIONS(5728),
    [anon_sym_u00f7] = ACTIONS(5728),
    [anon_sym_BSLASHcirc] = ACTIONS(5728),
    [anon_sym_u2218] = ACTIONS(5728),
    [anon_sym_BSLASHstar] = ACTIONS(5728),
    [anon_sym_u22c6] = ACTIONS(5728),
    [anon_sym_u203c] = ACTIONS(5728),
    [sym_hashhash] = ACTIONS(5728),
    [sym_dol] = ACTIONS(5730),
    [sym_doldol] = ACTIONS(5728),
    [anon_sym_QMARK_QMARK] = ACTIONS(5728),
    [anon_sym_u2047] = ACTIONS(5728),
    [anon_sym_BSLASHsqcap] = ACTIONS(5728),
    [anon_sym_u2293] = ACTIONS(5728),
    [anon_sym_BSLASHsqcup] = ACTIONS(5728),
    [anon_sym_u2294] = ACTIONS(5728),
    [anon_sym_BSLASHuplus] = ACTIONS(5728),
    [anon_sym_u228e] = ACTIONS(5728),
    [anon_sym_BSLASHX] = ACTIONS(5728),
    [anon_sym_BSLASHtimes] = ACTIONS(5728),
    [anon_sym_u00d7] = ACTIONS(5728),
    [anon_sym_BSLASHwr] = ACTIONS(5728),
    [anon_sym_u2240] = ACTIONS(5728),
    [anon_sym_BSLASHcdot] = ACTIONS(5728),
    [anon_sym_u22c5] = ACTIONS(5728),
    [sym_pow] = ACTIONS(5730),
    [sym_powpow] = ACTIONS(5728),
    [anon_sym_CARET_PLUS] = ACTIONS(5728),
    [anon_sym_u207a] = ACTIONS(5728),
    [sym_asterisk] = ACTIONS(5728),
    [sym_sup_hash] = ACTIONS(5728),
    [sym_prime] = ACTIONS(5728),
    [sym__bullet] = ACTIONS(5728),
    [sym__dedent] = ACTIONS(5728),
    [sym__double_excl] = ACTIONS(5728),
  },
  [3393] = {
    [sym_block_comment] = STATE(3393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5774),
    [anon_sym_u2208] = ACTIONS(5772),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5772),
    [anon_sym_u25a1] = ACTIONS(5772),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5772),
    [anon_sym_u2227] = ACTIONS(5772),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5772),
    [anon_sym_u2228] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(5774),
    [anon_sym_BSLASHo] = ACTIONS(5774),
    [anon_sym_DOT] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_DASH] = ACTIONS(5774),
    [anon_sym_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27f9] = ACTIONS(5772),
    [anon_sym_u21d2] = ACTIONS(5772),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5772),
    [anon_sym_u21f8] = ACTIONS(5772),
    [anon_sym_u2945] = ACTIONS(5772),
    [anon_sym_BSLASHequiv] = ACTIONS(5772),
    [anon_sym_u2261] = ACTIONS(5772),
    [anon_sym_LT_EQ_GT] = ACTIONS(5772),
    [anon_sym_u27fa] = ACTIONS(5772),
    [anon_sym_u21d4] = ACTIONS(5772),
    [anon_sym_TILDE_GT] = ACTIONS(5772),
    [anon_sym_u21dd] = ACTIONS(5772),
    [anon_sym_u219d] = ACTIONS(5772),
    [anon_sym_BSLASHland] = ACTIONS(5772),
    [anon_sym_BSLASHlor] = ACTIONS(5772),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2254] = ACTIONS(5772),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5772),
    [anon_sym_u2a74] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_POUND] = ACTIONS(5774),
    [anon_sym_u2260] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5774),
    [sym_gt] = ACTIONS(5774),
    [anon_sym_LT_EQ] = ACTIONS(5774),
    [anon_sym_EQ_LT] = ACTIONS(5772),
    [anon_sym_BSLASHleq] = ACTIONS(5772),
    [anon_sym_u2264] = ACTIONS(5772),
    [anon_sym_GT_EQ] = ACTIONS(5772),
    [anon_sym_BSLASHgeq] = ACTIONS(5772),
    [anon_sym_u2265] = ACTIONS(5772),
    [anon_sym_BSLASHapprox] = ACTIONS(5772),
    [anon_sym_u2248] = ACTIONS(5772),
    [anon_sym_PIPE_DASH] = ACTIONS(5772),
    [anon_sym_u22a2] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_u22a8] = ACTIONS(5772),
    [anon_sym_DASH_PIPE] = ACTIONS(5772),
    [anon_sym_u22a3] = ACTIONS(5772),
    [anon_sym_EQ_PIPE] = ACTIONS(5772),
    [anon_sym_u2ae4] = ACTIONS(5772),
    [anon_sym_BSLASHasymp] = ACTIONS(5772),
    [anon_sym_u224d] = ACTIONS(5772),
    [anon_sym_BSLASHcong] = ACTIONS(5772),
    [anon_sym_u2245] = ACTIONS(5772),
    [anon_sym_BSLASHdoteq] = ACTIONS(5772),
    [anon_sym_u2250] = ACTIONS(5772),
    [anon_sym_BSLASHgg] = ACTIONS(5772),
    [anon_sym_u226b] = ACTIONS(5772),
    [anon_sym_BSLASHll] = ACTIONS(5772),
    [anon_sym_u226a] = ACTIONS(5772),
    [anon_sym_BSLASHnotin] = ACTIONS(5772),
    [anon_sym_u2209] = ACTIONS(5772),
    [anon_sym_BSLASHprec] = ACTIONS(5774),
    [anon_sym_u227a] = ACTIONS(5772),
    [anon_sym_BSLASHsucc] = ACTIONS(5774),
    [anon_sym_u227b] = ACTIONS(5772),
    [anon_sym_BSLASHpreceq] = ACTIONS(5772),
    [anon_sym_u2aaf] = ACTIONS(5772),
    [anon_sym_BSLASHsucceq] = ACTIONS(5772),
    [anon_sym_u2ab0] = ACTIONS(5772),
    [anon_sym_BSLASHpropto] = ACTIONS(5772),
    [anon_sym_u221d] = ACTIONS(5772),
    [anon_sym_BSLASHsim] = ACTIONS(5774),
    [anon_sym_u223c] = ACTIONS(5772),
    [anon_sym_BSLASHsimeq] = ACTIONS(5772),
    [anon_sym_u2243] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5774),
    [anon_sym_u228f] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5774),
    [anon_sym_u2290] = ACTIONS(5772),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5772),
    [anon_sym_u2291] = ACTIONS(5772),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5772),
    [anon_sym_u2292] = ACTIONS(5772),
    [anon_sym_BSLASHsubset] = ACTIONS(5774),
    [anon_sym_u2282] = ACTIONS(5772),
    [anon_sym_BSLASHsupset] = ACTIONS(5774),
    [anon_sym_u2283] = ACTIONS(5772),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5772),
    [anon_sym_u2286] = ACTIONS(5772),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5772),
    [anon_sym_u2287] = ACTIONS(5772),
    [sym_compose] = ACTIONS(5772),
    [sym_map_to] = ACTIONS(5772),
    [sym_map_from] = ACTIONS(5772),
    [sym_setminus] = ACTIONS(5774),
    [anon_sym_BSLASHcap] = ACTIONS(5772),
    [anon_sym_BSLASHintersect] = ACTIONS(5772),
    [anon_sym_u2229] = ACTIONS(5772),
    [anon_sym_BSLASHcup] = ACTIONS(5772),
    [anon_sym_BSLASHunion] = ACTIONS(5772),
    [anon_sym_u222a] = ACTIONS(5772),
    [anon_sym_DOT_DOT] = ACTIONS(5774),
    [anon_sym_u2025] = ACTIONS(5772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5772),
    [anon_sym_u2026] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(5774),
    [sym_plusplus] = ACTIONS(5772),
    [anon_sym_BSLASHoplus] = ACTIONS(5772),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5772),
    [anon_sym_u2295] = ACTIONS(5772),
    [anon_sym_BSLASHominus] = ACTIONS(5772),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2296] = ACTIONS(5772),
    [sym_mod] = ACTIONS(5774),
    [sym_modmod] = ACTIONS(5772),
    [sym_vert] = ACTIONS(5774),
    [anon_sym_PIPE_PIPE] = ACTIONS(5772),
    [anon_sym_u2016] = ACTIONS(5772),
    [sym_minusminus] = ACTIONS(5772),
    [sym_amp] = ACTIONS(5774),
    [sym_ampamp] = ACTIONS(5772),
    [anon_sym_BSLASHodot] = ACTIONS(5772),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5772),
    [anon_sym_u2299] = ACTIONS(5772),
    [anon_sym_BSLASHoslash] = ACTIONS(5772),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5772),
    [anon_sym_u2298] = ACTIONS(5772),
    [anon_sym_BSLASHotimes] = ACTIONS(5772),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5772),
    [anon_sym_u2297] = ACTIONS(5772),
    [sym_mul] = ACTIONS(5774),
    [sym_mulmul] = ACTIONS(5772),
    [sym_slash] = ACTIONS(5774),
    [sym_slashslash] = ACTIONS(5772),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5772),
    [anon_sym_u25ef] = ACTIONS(5772),
    [anon_sym_BSLASHbullet] = ACTIONS(5772),
    [anon_sym_u25cf] = ACTIONS(5772),
    [anon_sym_BSLASHdiv] = ACTIONS(5772),
    [anon_sym_u00f7] = ACTIONS(5772),
    [anon_sym_BSLASHcirc] = ACTIONS(5772),
    [anon_sym_u2218] = ACTIONS(5772),
    [anon_sym_BSLASHstar] = ACTIONS(5772),
    [anon_sym_u22c6] = ACTIONS(5772),
    [anon_sym_u203c] = ACTIONS(5772),
    [sym_hashhash] = ACTIONS(5772),
    [sym_dol] = ACTIONS(5774),
    [sym_doldol] = ACTIONS(5772),
    [anon_sym_QMARK_QMARK] = ACTIONS(5772),
    [anon_sym_u2047] = ACTIONS(5772),
    [anon_sym_BSLASHsqcap] = ACTIONS(5772),
    [anon_sym_u2293] = ACTIONS(5772),
    [anon_sym_BSLASHsqcup] = ACTIONS(5772),
    [anon_sym_u2294] = ACTIONS(5772),
    [anon_sym_BSLASHuplus] = ACTIONS(5772),
    [anon_sym_u228e] = ACTIONS(5772),
    [anon_sym_BSLASHX] = ACTIONS(5772),
    [anon_sym_BSLASHtimes] = ACTIONS(5772),
    [anon_sym_u00d7] = ACTIONS(5772),
    [anon_sym_BSLASHwr] = ACTIONS(5772),
    [anon_sym_u2240] = ACTIONS(5772),
    [anon_sym_BSLASHcdot] = ACTIONS(5772),
    [anon_sym_u22c5] = ACTIONS(5772),
    [sym_pow] = ACTIONS(5774),
    [sym_powpow] = ACTIONS(5772),
    [anon_sym_CARET_PLUS] = ACTIONS(5772),
    [anon_sym_u207a] = ACTIONS(5772),
    [sym_asterisk] = ACTIONS(5772),
    [sym_sup_hash] = ACTIONS(5772),
    [sym_prime] = ACTIONS(5772),
    [sym__bullet] = ACTIONS(5772),
    [sym__dedent] = ACTIONS(5772),
    [sym__double_excl] = ACTIONS(5772),
  },
  [3394] = {
    [sym_block_comment] = STATE(3394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5734),
    [anon_sym_u2208] = ACTIONS(5732),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5732),
    [anon_sym_u25a1] = ACTIONS(5732),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5732),
    [anon_sym_u2227] = ACTIONS(5732),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5732),
    [anon_sym_u2228] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_BSLASHo] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_DASH] = ACTIONS(5734),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27f9] = ACTIONS(5732),
    [anon_sym_u21d2] = ACTIONS(5732),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5732),
    [anon_sym_u21f8] = ACTIONS(5732),
    [anon_sym_u2945] = ACTIONS(5732),
    [anon_sym_BSLASHequiv] = ACTIONS(5732),
    [anon_sym_u2261] = ACTIONS(5732),
    [anon_sym_LT_EQ_GT] = ACTIONS(5732),
    [anon_sym_u27fa] = ACTIONS(5732),
    [anon_sym_u21d4] = ACTIONS(5732),
    [anon_sym_TILDE_GT] = ACTIONS(5732),
    [anon_sym_u21dd] = ACTIONS(5732),
    [anon_sym_u219d] = ACTIONS(5732),
    [anon_sym_BSLASHland] = ACTIONS(5732),
    [anon_sym_BSLASHlor] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2254] = ACTIONS(5732),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5732),
    [anon_sym_u2a74] = ACTIONS(5732),
    [anon_sym_SLASH_EQ] = ACTIONS(5732),
    [anon_sym_POUND] = ACTIONS(5734),
    [anon_sym_u2260] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(5734),
    [sym_gt] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_EQ_LT] = ACTIONS(5732),
    [anon_sym_BSLASHleq] = ACTIONS(5732),
    [anon_sym_u2264] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5732),
    [anon_sym_BSLASHgeq] = ACTIONS(5732),
    [anon_sym_u2265] = ACTIONS(5732),
    [anon_sym_BSLASHapprox] = ACTIONS(5732),
    [anon_sym_u2248] = ACTIONS(5732),
    [anon_sym_PIPE_DASH] = ACTIONS(5732),
    [anon_sym_u22a2] = ACTIONS(5732),
    [anon_sym_PIPE_EQ] = ACTIONS(5732),
    [anon_sym_u22a8] = ACTIONS(5732),
    [anon_sym_DASH_PIPE] = ACTIONS(5732),
    [anon_sym_u22a3] = ACTIONS(5732),
    [anon_sym_EQ_PIPE] = ACTIONS(5732),
    [anon_sym_u2ae4] = ACTIONS(5732),
    [anon_sym_BSLASHasymp] = ACTIONS(5732),
    [anon_sym_u224d] = ACTIONS(5732),
    [anon_sym_BSLASHcong] = ACTIONS(5732),
    [anon_sym_u2245] = ACTIONS(5732),
    [anon_sym_BSLASHdoteq] = ACTIONS(5732),
    [anon_sym_u2250] = ACTIONS(5732),
    [anon_sym_BSLASHgg] = ACTIONS(5732),
    [anon_sym_u226b] = ACTIONS(5732),
    [anon_sym_BSLASHll] = ACTIONS(5732),
    [anon_sym_u226a] = ACTIONS(5732),
    [anon_sym_BSLASHnotin] = ACTIONS(5732),
    [anon_sym_u2209] = ACTIONS(5732),
    [anon_sym_BSLASHprec] = ACTIONS(5734),
    [anon_sym_u227a] = ACTIONS(5732),
    [anon_sym_BSLASHsucc] = ACTIONS(5734),
    [anon_sym_u227b] = ACTIONS(5732),
    [anon_sym_BSLASHpreceq] = ACTIONS(5732),
    [anon_sym_u2aaf] = ACTIONS(5732),
    [anon_sym_BSLASHsucceq] = ACTIONS(5732),
    [anon_sym_u2ab0] = ACTIONS(5732),
    [anon_sym_BSLASHpropto] = ACTIONS(5732),
    [anon_sym_u221d] = ACTIONS(5732),
    [anon_sym_BSLASHsim] = ACTIONS(5734),
    [anon_sym_u223c] = ACTIONS(5732),
    [anon_sym_BSLASHsimeq] = ACTIONS(5732),
    [anon_sym_u2243] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5734),
    [anon_sym_u228f] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5734),
    [anon_sym_u2290] = ACTIONS(5732),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5732),
    [anon_sym_u2291] = ACTIONS(5732),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5732),
    [anon_sym_u2292] = ACTIONS(5732),
    [anon_sym_BSLASHsubset] = ACTIONS(5734),
    [anon_sym_u2282] = ACTIONS(5732),
    [anon_sym_BSLASHsupset] = ACTIONS(5734),
    [anon_sym_u2283] = ACTIONS(5732),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5732),
    [anon_sym_u2286] = ACTIONS(5732),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5732),
    [anon_sym_u2287] = ACTIONS(5732),
    [sym_compose] = ACTIONS(5732),
    [sym_map_to] = ACTIONS(5732),
    [sym_map_from] = ACTIONS(5732),
    [sym_setminus] = ACTIONS(5734),
    [anon_sym_BSLASHcap] = ACTIONS(5732),
    [anon_sym_BSLASHintersect] = ACTIONS(5732),
    [anon_sym_u2229] = ACTIONS(5732),
    [anon_sym_BSLASHcup] = ACTIONS(5732),
    [anon_sym_BSLASHunion] = ACTIONS(5732),
    [anon_sym_u222a] = ACTIONS(5732),
    [anon_sym_DOT_DOT] = ACTIONS(5734),
    [anon_sym_u2025] = ACTIONS(5732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5732),
    [anon_sym_u2026] = ACTIONS(5732),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_plusplus] = ACTIONS(5732),
    [anon_sym_BSLASHoplus] = ACTIONS(5732),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5732),
    [anon_sym_u2295] = ACTIONS(5732),
    [anon_sym_BSLASHominus] = ACTIONS(5732),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2296] = ACTIONS(5732),
    [sym_mod] = ACTIONS(5734),
    [sym_modmod] = ACTIONS(5732),
    [sym_vert] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_u2016] = ACTIONS(5732),
    [sym_minusminus] = ACTIONS(5732),
    [sym_amp] = ACTIONS(5734),
    [sym_ampamp] = ACTIONS(5732),
    [anon_sym_BSLASHodot] = ACTIONS(5732),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5732),
    [anon_sym_u2299] = ACTIONS(5732),
    [anon_sym_BSLASHoslash] = ACTIONS(5732),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5732),
    [anon_sym_u2298] = ACTIONS(5732),
    [anon_sym_BSLASHotimes] = ACTIONS(5732),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5732),
    [anon_sym_u2297] = ACTIONS(5732),
    [sym_mul] = ACTIONS(5734),
    [sym_mulmul] = ACTIONS(5732),
    [sym_slash] = ACTIONS(5734),
    [sym_slashslash] = ACTIONS(5732),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5732),
    [anon_sym_u25ef] = ACTIONS(5732),
    [anon_sym_BSLASHbullet] = ACTIONS(5732),
    [anon_sym_u25cf] = ACTIONS(5732),
    [anon_sym_BSLASHdiv] = ACTIONS(5732),
    [anon_sym_u00f7] = ACTIONS(5732),
    [anon_sym_BSLASHcirc] = ACTIONS(5732),
    [anon_sym_u2218] = ACTIONS(5732),
    [anon_sym_BSLASHstar] = ACTIONS(5732),
    [anon_sym_u22c6] = ACTIONS(5732),
    [anon_sym_u203c] = ACTIONS(5732),
    [sym_hashhash] = ACTIONS(5732),
    [sym_dol] = ACTIONS(5734),
    [sym_doldol] = ACTIONS(5732),
    [anon_sym_QMARK_QMARK] = ACTIONS(5732),
    [anon_sym_u2047] = ACTIONS(5732),
    [anon_sym_BSLASHsqcap] = ACTIONS(5732),
    [anon_sym_u2293] = ACTIONS(5732),
    [anon_sym_BSLASHsqcup] = ACTIONS(5732),
    [anon_sym_u2294] = ACTIONS(5732),
    [anon_sym_BSLASHuplus] = ACTIONS(5732),
    [anon_sym_u228e] = ACTIONS(5732),
    [anon_sym_BSLASHX] = ACTIONS(5732),
    [anon_sym_BSLASHtimes] = ACTIONS(5732),
    [anon_sym_u00d7] = ACTIONS(5732),
    [anon_sym_BSLASHwr] = ACTIONS(5732),
    [anon_sym_u2240] = ACTIONS(5732),
    [anon_sym_BSLASHcdot] = ACTIONS(5732),
    [anon_sym_u22c5] = ACTIONS(5732),
    [sym_pow] = ACTIONS(5734),
    [sym_powpow] = ACTIONS(5732),
    [anon_sym_CARET_PLUS] = ACTIONS(5732),
    [anon_sym_u207a] = ACTIONS(5732),
    [sym_asterisk] = ACTIONS(5732),
    [sym_sup_hash] = ACTIONS(5732),
    [sym_prime] = ACTIONS(5732),
    [sym__bullet] = ACTIONS(5732),
    [sym__dedent] = ACTIONS(5732),
    [sym__double_excl] = ACTIONS(5732),
  },
  [3395] = {
    [sym_block_comment] = STATE(3395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5796),
    [anon_sym_u2208] = ACTIONS(5794),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5794),
    [anon_sym_u25a1] = ACTIONS(5794),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5794),
    [anon_sym_u2227] = ACTIONS(5794),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5794),
    [anon_sym_u2228] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_BSLASHo] = ACTIONS(5796),
    [anon_sym_DOT] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5796),
    [anon_sym_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27f9] = ACTIONS(5794),
    [anon_sym_u21d2] = ACTIONS(5794),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5794),
    [anon_sym_u21f8] = ACTIONS(5794),
    [anon_sym_u2945] = ACTIONS(5794),
    [anon_sym_BSLASHequiv] = ACTIONS(5794),
    [anon_sym_u2261] = ACTIONS(5794),
    [anon_sym_LT_EQ_GT] = ACTIONS(5794),
    [anon_sym_u27fa] = ACTIONS(5794),
    [anon_sym_u21d4] = ACTIONS(5794),
    [anon_sym_TILDE_GT] = ACTIONS(5794),
    [anon_sym_u21dd] = ACTIONS(5794),
    [anon_sym_u219d] = ACTIONS(5794),
    [anon_sym_BSLASHland] = ACTIONS(5794),
    [anon_sym_BSLASHlor] = ACTIONS(5794),
    [anon_sym_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2254] = ACTIONS(5794),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5794),
    [anon_sym_u2a74] = ACTIONS(5794),
    [anon_sym_SLASH_EQ] = ACTIONS(5794),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_u2260] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(5796),
    [sym_gt] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ_LT] = ACTIONS(5794),
    [anon_sym_BSLASHleq] = ACTIONS(5794),
    [anon_sym_u2264] = ACTIONS(5794),
    [anon_sym_GT_EQ] = ACTIONS(5794),
    [anon_sym_BSLASHgeq] = ACTIONS(5794),
    [anon_sym_u2265] = ACTIONS(5794),
    [anon_sym_BSLASHapprox] = ACTIONS(5794),
    [anon_sym_u2248] = ACTIONS(5794),
    [anon_sym_PIPE_DASH] = ACTIONS(5794),
    [anon_sym_u22a2] = ACTIONS(5794),
    [anon_sym_PIPE_EQ] = ACTIONS(5794),
    [anon_sym_u22a8] = ACTIONS(5794),
    [anon_sym_DASH_PIPE] = ACTIONS(5794),
    [anon_sym_u22a3] = ACTIONS(5794),
    [anon_sym_EQ_PIPE] = ACTIONS(5794),
    [anon_sym_u2ae4] = ACTIONS(5794),
    [anon_sym_BSLASHasymp] = ACTIONS(5794),
    [anon_sym_u224d] = ACTIONS(5794),
    [anon_sym_BSLASHcong] = ACTIONS(5794),
    [anon_sym_u2245] = ACTIONS(5794),
    [anon_sym_BSLASHdoteq] = ACTIONS(5794),
    [anon_sym_u2250] = ACTIONS(5794),
    [anon_sym_BSLASHgg] = ACTIONS(5794),
    [anon_sym_u226b] = ACTIONS(5794),
    [anon_sym_BSLASHll] = ACTIONS(5794),
    [anon_sym_u226a] = ACTIONS(5794),
    [anon_sym_BSLASHnotin] = ACTIONS(5794),
    [anon_sym_u2209] = ACTIONS(5794),
    [anon_sym_BSLASHprec] = ACTIONS(5796),
    [anon_sym_u227a] = ACTIONS(5794),
    [anon_sym_BSLASHsucc] = ACTIONS(5796),
    [anon_sym_u227b] = ACTIONS(5794),
    [anon_sym_BSLASHpreceq] = ACTIONS(5794),
    [anon_sym_u2aaf] = ACTIONS(5794),
    [anon_sym_BSLASHsucceq] = ACTIONS(5794),
    [anon_sym_u2ab0] = ACTIONS(5794),
    [anon_sym_BSLASHpropto] = ACTIONS(5794),
    [anon_sym_u221d] = ACTIONS(5794),
    [anon_sym_BSLASHsim] = ACTIONS(5796),
    [anon_sym_u223c] = ACTIONS(5794),
    [anon_sym_BSLASHsimeq] = ACTIONS(5794),
    [anon_sym_u2243] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5796),
    [anon_sym_u228f] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5796),
    [anon_sym_u2290] = ACTIONS(5794),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5794),
    [anon_sym_u2291] = ACTIONS(5794),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5794),
    [anon_sym_u2292] = ACTIONS(5794),
    [anon_sym_BSLASHsubset] = ACTIONS(5796),
    [anon_sym_u2282] = ACTIONS(5794),
    [anon_sym_BSLASHsupset] = ACTIONS(5796),
    [anon_sym_u2283] = ACTIONS(5794),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5794),
    [anon_sym_u2286] = ACTIONS(5794),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5794),
    [anon_sym_u2287] = ACTIONS(5794),
    [sym_compose] = ACTIONS(5794),
    [sym_map_to] = ACTIONS(5794),
    [sym_map_from] = ACTIONS(5794),
    [sym_setminus] = ACTIONS(5796),
    [anon_sym_BSLASHcap] = ACTIONS(5794),
    [anon_sym_BSLASHintersect] = ACTIONS(5794),
    [anon_sym_u2229] = ACTIONS(5794),
    [anon_sym_BSLASHcup] = ACTIONS(5794),
    [anon_sym_BSLASHunion] = ACTIONS(5794),
    [anon_sym_u222a] = ACTIONS(5794),
    [anon_sym_DOT_DOT] = ACTIONS(5796),
    [anon_sym_u2025] = ACTIONS(5794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5794),
    [anon_sym_u2026] = ACTIONS(5794),
    [anon_sym_PLUS] = ACTIONS(5796),
    [sym_plusplus] = ACTIONS(5794),
    [anon_sym_BSLASHoplus] = ACTIONS(5794),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5794),
    [anon_sym_u2295] = ACTIONS(5794),
    [anon_sym_BSLASHominus] = ACTIONS(5794),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2296] = ACTIONS(5794),
    [sym_mod] = ACTIONS(5796),
    [sym_modmod] = ACTIONS(5794),
    [sym_vert] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5794),
    [anon_sym_u2016] = ACTIONS(5794),
    [sym_minusminus] = ACTIONS(5794),
    [sym_amp] = ACTIONS(5796),
    [sym_ampamp] = ACTIONS(5794),
    [anon_sym_BSLASHodot] = ACTIONS(5794),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5794),
    [anon_sym_u2299] = ACTIONS(5794),
    [anon_sym_BSLASHoslash] = ACTIONS(5794),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5794),
    [anon_sym_u2298] = ACTIONS(5794),
    [anon_sym_BSLASHotimes] = ACTIONS(5794),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5794),
    [anon_sym_u2297] = ACTIONS(5794),
    [sym_mul] = ACTIONS(5796),
    [sym_mulmul] = ACTIONS(5794),
    [sym_slash] = ACTIONS(5796),
    [sym_slashslash] = ACTIONS(5794),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5794),
    [anon_sym_u25ef] = ACTIONS(5794),
    [anon_sym_BSLASHbullet] = ACTIONS(5794),
    [anon_sym_u25cf] = ACTIONS(5794),
    [anon_sym_BSLASHdiv] = ACTIONS(5794),
    [anon_sym_u00f7] = ACTIONS(5794),
    [anon_sym_BSLASHcirc] = ACTIONS(5794),
    [anon_sym_u2218] = ACTIONS(5794),
    [anon_sym_BSLASHstar] = ACTIONS(5794),
    [anon_sym_u22c6] = ACTIONS(5794),
    [anon_sym_u203c] = ACTIONS(5794),
    [sym_hashhash] = ACTIONS(5794),
    [sym_dol] = ACTIONS(5796),
    [sym_doldol] = ACTIONS(5794),
    [anon_sym_QMARK_QMARK] = ACTIONS(5794),
    [anon_sym_u2047] = ACTIONS(5794),
    [anon_sym_BSLASHsqcap] = ACTIONS(5794),
    [anon_sym_u2293] = ACTIONS(5794),
    [anon_sym_BSLASHsqcup] = ACTIONS(5794),
    [anon_sym_u2294] = ACTIONS(5794),
    [anon_sym_BSLASHuplus] = ACTIONS(5794),
    [anon_sym_u228e] = ACTIONS(5794),
    [anon_sym_BSLASHX] = ACTIONS(5794),
    [anon_sym_BSLASHtimes] = ACTIONS(5794),
    [anon_sym_u00d7] = ACTIONS(5794),
    [anon_sym_BSLASHwr] = ACTIONS(5794),
    [anon_sym_u2240] = ACTIONS(5794),
    [anon_sym_BSLASHcdot] = ACTIONS(5794),
    [anon_sym_u22c5] = ACTIONS(5794),
    [sym_pow] = ACTIONS(5796),
    [sym_powpow] = ACTIONS(5794),
    [anon_sym_CARET_PLUS] = ACTIONS(5794),
    [anon_sym_u207a] = ACTIONS(5794),
    [sym_asterisk] = ACTIONS(5794),
    [sym_sup_hash] = ACTIONS(5794),
    [sym_prime] = ACTIONS(5794),
    [sym__bullet] = ACTIONS(5794),
    [sym__dedent] = ACTIONS(5794),
    [sym__double_excl] = ACTIONS(5794),
  },
  [3396] = {
    [sym_block_comment] = STATE(3396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5706),
    [anon_sym_u2208] = ACTIONS(5704),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5704),
    [anon_sym_u25a1] = ACTIONS(5704),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5704),
    [anon_sym_u2227] = ACTIONS(5704),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5704),
    [anon_sym_u2228] = ACTIONS(5704),
    [anon_sym_LBRACK] = ACTIONS(5706),
    [anon_sym_BSLASHo] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27f9] = ACTIONS(5704),
    [anon_sym_u21d2] = ACTIONS(5704),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5704),
    [anon_sym_u21f8] = ACTIONS(5704),
    [anon_sym_u2945] = ACTIONS(5704),
    [anon_sym_BSLASHequiv] = ACTIONS(5704),
    [anon_sym_u2261] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5704),
    [anon_sym_u27fa] = ACTIONS(5704),
    [anon_sym_u21d4] = ACTIONS(5704),
    [anon_sym_TILDE_GT] = ACTIONS(5704),
    [anon_sym_u21dd] = ACTIONS(5704),
    [anon_sym_u219d] = ACTIONS(5704),
    [anon_sym_BSLASHland] = ACTIONS(5704),
    [anon_sym_BSLASHlor] = ACTIONS(5704),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2254] = ACTIONS(5704),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5704),
    [anon_sym_u2a74] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_POUND] = ACTIONS(5706),
    [anon_sym_u2260] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [sym_gt] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5706),
    [anon_sym_EQ_LT] = ACTIONS(5704),
    [anon_sym_BSLASHleq] = ACTIONS(5704),
    [anon_sym_u2264] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_BSLASHgeq] = ACTIONS(5704),
    [anon_sym_u2265] = ACTIONS(5704),
    [anon_sym_BSLASHapprox] = ACTIONS(5704),
    [anon_sym_u2248] = ACTIONS(5704),
    [anon_sym_PIPE_DASH] = ACTIONS(5704),
    [anon_sym_u22a2] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_u22a8] = ACTIONS(5704),
    [anon_sym_DASH_PIPE] = ACTIONS(5704),
    [anon_sym_u22a3] = ACTIONS(5704),
    [anon_sym_EQ_PIPE] = ACTIONS(5704),
    [anon_sym_u2ae4] = ACTIONS(5704),
    [anon_sym_BSLASHasymp] = ACTIONS(5704),
    [anon_sym_u224d] = ACTIONS(5704),
    [anon_sym_BSLASHcong] = ACTIONS(5704),
    [anon_sym_u2245] = ACTIONS(5704),
    [anon_sym_BSLASHdoteq] = ACTIONS(5704),
    [anon_sym_u2250] = ACTIONS(5704),
    [anon_sym_BSLASHgg] = ACTIONS(5704),
    [anon_sym_u226b] = ACTIONS(5704),
    [anon_sym_BSLASHll] = ACTIONS(5704),
    [anon_sym_u226a] = ACTIONS(5704),
    [anon_sym_BSLASHnotin] = ACTIONS(5704),
    [anon_sym_u2209] = ACTIONS(5704),
    [anon_sym_BSLASHprec] = ACTIONS(5706),
    [anon_sym_u227a] = ACTIONS(5704),
    [anon_sym_BSLASHsucc] = ACTIONS(5706),
    [anon_sym_u227b] = ACTIONS(5704),
    [anon_sym_BSLASHpreceq] = ACTIONS(5704),
    [anon_sym_u2aaf] = ACTIONS(5704),
    [anon_sym_BSLASHsucceq] = ACTIONS(5704),
    [anon_sym_u2ab0] = ACTIONS(5704),
    [anon_sym_BSLASHpropto] = ACTIONS(5704),
    [anon_sym_u221d] = ACTIONS(5704),
    [anon_sym_BSLASHsim] = ACTIONS(5706),
    [anon_sym_u223c] = ACTIONS(5704),
    [anon_sym_BSLASHsimeq] = ACTIONS(5704),
    [anon_sym_u2243] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5706),
    [anon_sym_u228f] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5706),
    [anon_sym_u2290] = ACTIONS(5704),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5704),
    [anon_sym_u2291] = ACTIONS(5704),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5704),
    [anon_sym_u2292] = ACTIONS(5704),
    [anon_sym_BSLASHsubset] = ACTIONS(5706),
    [anon_sym_u2282] = ACTIONS(5704),
    [anon_sym_BSLASHsupset] = ACTIONS(5706),
    [anon_sym_u2283] = ACTIONS(5704),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5704),
    [anon_sym_u2286] = ACTIONS(5704),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5704),
    [anon_sym_u2287] = ACTIONS(5704),
    [sym_compose] = ACTIONS(5704),
    [sym_map_to] = ACTIONS(5704),
    [sym_map_from] = ACTIONS(5704),
    [sym_setminus] = ACTIONS(5706),
    [anon_sym_BSLASHcap] = ACTIONS(5704),
    [anon_sym_BSLASHintersect] = ACTIONS(5704),
    [anon_sym_u2229] = ACTIONS(5704),
    [anon_sym_BSLASHcup] = ACTIONS(5704),
    [anon_sym_BSLASHunion] = ACTIONS(5704),
    [anon_sym_u222a] = ACTIONS(5704),
    [anon_sym_DOT_DOT] = ACTIONS(5706),
    [anon_sym_u2025] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5704),
    [anon_sym_u2026] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [sym_plusplus] = ACTIONS(5704),
    [anon_sym_BSLASHoplus] = ACTIONS(5704),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5704),
    [anon_sym_u2295] = ACTIONS(5704),
    [anon_sym_BSLASHominus] = ACTIONS(5704),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2296] = ACTIONS(5704),
    [sym_mod] = ACTIONS(5706),
    [sym_modmod] = ACTIONS(5704),
    [sym_vert] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5704),
    [anon_sym_u2016] = ACTIONS(5704),
    [sym_minusminus] = ACTIONS(5704),
    [sym_amp] = ACTIONS(5706),
    [sym_ampamp] = ACTIONS(5704),
    [anon_sym_BSLASHodot] = ACTIONS(5704),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5704),
    [anon_sym_u2299] = ACTIONS(5704),
    [anon_sym_BSLASHoslash] = ACTIONS(5704),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5704),
    [anon_sym_u2298] = ACTIONS(5704),
    [anon_sym_BSLASHotimes] = ACTIONS(5704),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5704),
    [anon_sym_u2297] = ACTIONS(5704),
    [sym_mul] = ACTIONS(5706),
    [sym_mulmul] = ACTIONS(5704),
    [sym_slash] = ACTIONS(5706),
    [sym_slashslash] = ACTIONS(5704),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5704),
    [anon_sym_u25ef] = ACTIONS(5704),
    [anon_sym_BSLASHbullet] = ACTIONS(5704),
    [anon_sym_u25cf] = ACTIONS(5704),
    [anon_sym_BSLASHdiv] = ACTIONS(5704),
    [anon_sym_u00f7] = ACTIONS(5704),
    [anon_sym_BSLASHcirc] = ACTIONS(5704),
    [anon_sym_u2218] = ACTIONS(5704),
    [anon_sym_BSLASHstar] = ACTIONS(5704),
    [anon_sym_u22c6] = ACTIONS(5704),
    [anon_sym_u203c] = ACTIONS(5704),
    [sym_hashhash] = ACTIONS(5704),
    [sym_dol] = ACTIONS(5706),
    [sym_doldol] = ACTIONS(5704),
    [anon_sym_QMARK_QMARK] = ACTIONS(5704),
    [anon_sym_u2047] = ACTIONS(5704),
    [anon_sym_BSLASHsqcap] = ACTIONS(5704),
    [anon_sym_u2293] = ACTIONS(5704),
    [anon_sym_BSLASHsqcup] = ACTIONS(5704),
    [anon_sym_u2294] = ACTIONS(5704),
    [anon_sym_BSLASHuplus] = ACTIONS(5704),
    [anon_sym_u228e] = ACTIONS(5704),
    [anon_sym_BSLASHX] = ACTIONS(5704),
    [anon_sym_BSLASHtimes] = ACTIONS(5704),
    [anon_sym_u00d7] = ACTIONS(5704),
    [anon_sym_BSLASHwr] = ACTIONS(5704),
    [anon_sym_u2240] = ACTIONS(5704),
    [anon_sym_BSLASHcdot] = ACTIONS(5704),
    [anon_sym_u22c5] = ACTIONS(5704),
    [sym_pow] = ACTIONS(5706),
    [sym_powpow] = ACTIONS(5704),
    [anon_sym_CARET_PLUS] = ACTIONS(5704),
    [anon_sym_u207a] = ACTIONS(5704),
    [sym_asterisk] = ACTIONS(5704),
    [sym_sup_hash] = ACTIONS(5704),
    [sym_prime] = ACTIONS(5704),
    [sym__bullet] = ACTIONS(5704),
    [sym__dedent] = ACTIONS(5704),
    [sym__double_excl] = ACTIONS(5704),
  },
  [3397] = {
    [sym_block_comment] = STATE(3397),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5746),
    [anon_sym_u2208] = ACTIONS(5744),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5744),
    [anon_sym_u25a1] = ACTIONS(5744),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5744),
    [anon_sym_u2227] = ACTIONS(5744),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5744),
    [anon_sym_u2228] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_BSLASHo] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27f9] = ACTIONS(5744),
    [anon_sym_u21d2] = ACTIONS(5744),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5744),
    [anon_sym_u21f8] = ACTIONS(5744),
    [anon_sym_u2945] = ACTIONS(5744),
    [anon_sym_BSLASHequiv] = ACTIONS(5744),
    [anon_sym_u2261] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_u27fa] = ACTIONS(5744),
    [anon_sym_u21d4] = ACTIONS(5744),
    [anon_sym_TILDE_GT] = ACTIONS(5744),
    [anon_sym_u21dd] = ACTIONS(5744),
    [anon_sym_u219d] = ACTIONS(5744),
    [anon_sym_BSLASHland] = ACTIONS(5744),
    [anon_sym_BSLASHlor] = ACTIONS(5744),
    [anon_sym_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2254] = ACTIONS(5744),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5744),
    [anon_sym_u2a74] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_POUND] = ACTIONS(5746),
    [anon_sym_u2260] = ACTIONS(5744),
    [anon_sym_LT] = ACTIONS(5746),
    [sym_gt] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_EQ_LT] = ACTIONS(5744),
    [anon_sym_BSLASHleq] = ACTIONS(5744),
    [anon_sym_u2264] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_BSLASHgeq] = ACTIONS(5744),
    [anon_sym_u2265] = ACTIONS(5744),
    [anon_sym_BSLASHapprox] = ACTIONS(5744),
    [anon_sym_u2248] = ACTIONS(5744),
    [anon_sym_PIPE_DASH] = ACTIONS(5744),
    [anon_sym_u22a2] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_u22a8] = ACTIONS(5744),
    [anon_sym_DASH_PIPE] = ACTIONS(5744),
    [anon_sym_u22a3] = ACTIONS(5744),
    [anon_sym_EQ_PIPE] = ACTIONS(5744),
    [anon_sym_u2ae4] = ACTIONS(5744),
    [anon_sym_BSLASHasymp] = ACTIONS(5744),
    [anon_sym_u224d] = ACTIONS(5744),
    [anon_sym_BSLASHcong] = ACTIONS(5744),
    [anon_sym_u2245] = ACTIONS(5744),
    [anon_sym_BSLASHdoteq] = ACTIONS(5744),
    [anon_sym_u2250] = ACTIONS(5744),
    [anon_sym_BSLASHgg] = ACTIONS(5744),
    [anon_sym_u226b] = ACTIONS(5744),
    [anon_sym_BSLASHll] = ACTIONS(5744),
    [anon_sym_u226a] = ACTIONS(5744),
    [anon_sym_BSLASHnotin] = ACTIONS(5744),
    [anon_sym_u2209] = ACTIONS(5744),
    [anon_sym_BSLASHprec] = ACTIONS(5746),
    [anon_sym_u227a] = ACTIONS(5744),
    [anon_sym_BSLASHsucc] = ACTIONS(5746),
    [anon_sym_u227b] = ACTIONS(5744),
    [anon_sym_BSLASHpreceq] = ACTIONS(5744),
    [anon_sym_u2aaf] = ACTIONS(5744),
    [anon_sym_BSLASHsucceq] = ACTIONS(5744),
    [anon_sym_u2ab0] = ACTIONS(5744),
    [anon_sym_BSLASHpropto] = ACTIONS(5744),
    [anon_sym_u221d] = ACTIONS(5744),
    [anon_sym_BSLASHsim] = ACTIONS(5746),
    [anon_sym_u223c] = ACTIONS(5744),
    [anon_sym_BSLASHsimeq] = ACTIONS(5744),
    [anon_sym_u2243] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5746),
    [anon_sym_u228f] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5746),
    [anon_sym_u2290] = ACTIONS(5744),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5744),
    [anon_sym_u2291] = ACTIONS(5744),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5744),
    [anon_sym_u2292] = ACTIONS(5744),
    [anon_sym_BSLASHsubset] = ACTIONS(5746),
    [anon_sym_u2282] = ACTIONS(5744),
    [anon_sym_BSLASHsupset] = ACTIONS(5746),
    [anon_sym_u2283] = ACTIONS(5744),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5744),
    [anon_sym_u2286] = ACTIONS(5744),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5744),
    [anon_sym_u2287] = ACTIONS(5744),
    [sym_compose] = ACTIONS(5744),
    [sym_map_to] = ACTIONS(5744),
    [sym_map_from] = ACTIONS(5744),
    [sym_setminus] = ACTIONS(5746),
    [anon_sym_BSLASHcap] = ACTIONS(5744),
    [anon_sym_BSLASHintersect] = ACTIONS(5744),
    [anon_sym_u2229] = ACTIONS(5744),
    [anon_sym_BSLASHcup] = ACTIONS(5744),
    [anon_sym_BSLASHunion] = ACTIONS(5744),
    [anon_sym_u222a] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_u2025] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_u2026] = ACTIONS(5744),
    [anon_sym_PLUS] = ACTIONS(5746),
    [sym_plusplus] = ACTIONS(5744),
    [anon_sym_BSLASHoplus] = ACTIONS(5744),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5744),
    [anon_sym_u2295] = ACTIONS(5744),
    [anon_sym_BSLASHominus] = ACTIONS(5744),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2296] = ACTIONS(5744),
    [sym_mod] = ACTIONS(5746),
    [sym_modmod] = ACTIONS(5744),
    [sym_vert] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_u2016] = ACTIONS(5744),
    [sym_minusminus] = ACTIONS(5744),
    [sym_amp] = ACTIONS(5746),
    [sym_ampamp] = ACTIONS(5744),
    [anon_sym_BSLASHodot] = ACTIONS(5744),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5744),
    [anon_sym_u2299] = ACTIONS(5744),
    [anon_sym_BSLASHoslash] = ACTIONS(5744),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5744),
    [anon_sym_u2298] = ACTIONS(5744),
    [anon_sym_BSLASHotimes] = ACTIONS(5744),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5744),
    [anon_sym_u2297] = ACTIONS(5744),
    [sym_mul] = ACTIONS(5746),
    [sym_mulmul] = ACTIONS(5744),
    [sym_slash] = ACTIONS(5746),
    [sym_slashslash] = ACTIONS(5744),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5744),
    [anon_sym_u25ef] = ACTIONS(5744),
    [anon_sym_BSLASHbullet] = ACTIONS(5744),
    [anon_sym_u25cf] = ACTIONS(5744),
    [anon_sym_BSLASHdiv] = ACTIONS(5744),
    [anon_sym_u00f7] = ACTIONS(5744),
    [anon_sym_BSLASHcirc] = ACTIONS(5744),
    [anon_sym_u2218] = ACTIONS(5744),
    [anon_sym_BSLASHstar] = ACTIONS(5744),
    [anon_sym_u22c6] = ACTIONS(5744),
    [anon_sym_u203c] = ACTIONS(5744),
    [sym_hashhash] = ACTIONS(5744),
    [sym_dol] = ACTIONS(5746),
    [sym_doldol] = ACTIONS(5744),
    [anon_sym_QMARK_QMARK] = ACTIONS(5744),
    [anon_sym_u2047] = ACTIONS(5744),
    [anon_sym_BSLASHsqcap] = ACTIONS(5744),
    [anon_sym_u2293] = ACTIONS(5744),
    [anon_sym_BSLASHsqcup] = ACTIONS(5744),
    [anon_sym_u2294] = ACTIONS(5744),
    [anon_sym_BSLASHuplus] = ACTIONS(5744),
    [anon_sym_u228e] = ACTIONS(5744),
    [anon_sym_BSLASHX] = ACTIONS(5744),
    [anon_sym_BSLASHtimes] = ACTIONS(5744),
    [anon_sym_u00d7] = ACTIONS(5744),
    [anon_sym_BSLASHwr] = ACTIONS(5744),
    [anon_sym_u2240] = ACTIONS(5744),
    [anon_sym_BSLASHcdot] = ACTIONS(5744),
    [anon_sym_u22c5] = ACTIONS(5744),
    [sym_pow] = ACTIONS(5746),
    [sym_powpow] = ACTIONS(5744),
    [anon_sym_CARET_PLUS] = ACTIONS(5744),
    [anon_sym_u207a] = ACTIONS(5744),
    [sym_asterisk] = ACTIONS(5744),
    [sym_sup_hash] = ACTIONS(5744),
    [sym_prime] = ACTIONS(5744),
    [sym__bullet] = ACTIONS(5744),
    [sym__dedent] = ACTIONS(5744),
    [sym__double_excl] = ACTIONS(5744),
  },
  [3398] = {
    [sym_block_comment] = STATE(3398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5910),
    [anon_sym_u2208] = ACTIONS(5908),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5908),
    [anon_sym_u25a1] = ACTIONS(5908),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5908),
    [anon_sym_u2227] = ACTIONS(5908),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5908),
    [anon_sym_u2228] = ACTIONS(5908),
    [anon_sym_LBRACK] = ACTIONS(5910),
    [anon_sym_BSLASHo] = ACTIONS(5910),
    [anon_sym_DOT] = ACTIONS(5910),
    [anon_sym_EQ] = ACTIONS(5910),
    [anon_sym_DASH] = ACTIONS(5910),
    [anon_sym_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27f9] = ACTIONS(5908),
    [anon_sym_u21d2] = ACTIONS(5908),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5908),
    [anon_sym_u21f8] = ACTIONS(5908),
    [anon_sym_u2945] = ACTIONS(5908),
    [anon_sym_BSLASHequiv] = ACTIONS(5908),
    [anon_sym_u2261] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_u27fa] = ACTIONS(5908),
    [anon_sym_u21d4] = ACTIONS(5908),
    [anon_sym_TILDE_GT] = ACTIONS(5908),
    [anon_sym_u21dd] = ACTIONS(5908),
    [anon_sym_u219d] = ACTIONS(5908),
    [anon_sym_BSLASHland] = ACTIONS(5908),
    [anon_sym_BSLASHlor] = ACTIONS(5908),
    [anon_sym_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2254] = ACTIONS(5908),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5908),
    [anon_sym_u2a74] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_POUND] = ACTIONS(5910),
    [anon_sym_u2260] = ACTIONS(5908),
    [anon_sym_LT] = ACTIONS(5910),
    [sym_gt] = ACTIONS(5910),
    [anon_sym_LT_EQ] = ACTIONS(5910),
    [anon_sym_EQ_LT] = ACTIONS(5908),
    [anon_sym_BSLASHleq] = ACTIONS(5908),
    [anon_sym_u2264] = ACTIONS(5908),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_BSLASHgeq] = ACTIONS(5908),
    [anon_sym_u2265] = ACTIONS(5908),
    [anon_sym_BSLASHapprox] = ACTIONS(5908),
    [anon_sym_u2248] = ACTIONS(5908),
    [anon_sym_PIPE_DASH] = ACTIONS(5908),
    [anon_sym_u22a2] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_u22a8] = ACTIONS(5908),
    [anon_sym_DASH_PIPE] = ACTIONS(5908),
    [anon_sym_u22a3] = ACTIONS(5908),
    [anon_sym_EQ_PIPE] = ACTIONS(5908),
    [anon_sym_u2ae4] = ACTIONS(5908),
    [anon_sym_BSLASHasymp] = ACTIONS(5908),
    [anon_sym_u224d] = ACTIONS(5908),
    [anon_sym_BSLASHcong] = ACTIONS(5908),
    [anon_sym_u2245] = ACTIONS(5908),
    [anon_sym_BSLASHdoteq] = ACTIONS(5908),
    [anon_sym_u2250] = ACTIONS(5908),
    [anon_sym_BSLASHgg] = ACTIONS(5908),
    [anon_sym_u226b] = ACTIONS(5908),
    [anon_sym_BSLASHll] = ACTIONS(5908),
    [anon_sym_u226a] = ACTIONS(5908),
    [anon_sym_BSLASHnotin] = ACTIONS(5908),
    [anon_sym_u2209] = ACTIONS(5908),
    [anon_sym_BSLASHprec] = ACTIONS(5910),
    [anon_sym_u227a] = ACTIONS(5908),
    [anon_sym_BSLASHsucc] = ACTIONS(5910),
    [anon_sym_u227b] = ACTIONS(5908),
    [anon_sym_BSLASHpreceq] = ACTIONS(5908),
    [anon_sym_u2aaf] = ACTIONS(5908),
    [anon_sym_BSLASHsucceq] = ACTIONS(5908),
    [anon_sym_u2ab0] = ACTIONS(5908),
    [anon_sym_BSLASHpropto] = ACTIONS(5908),
    [anon_sym_u221d] = ACTIONS(5908),
    [anon_sym_BSLASHsim] = ACTIONS(5910),
    [anon_sym_u223c] = ACTIONS(5908),
    [anon_sym_BSLASHsimeq] = ACTIONS(5908),
    [anon_sym_u2243] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5910),
    [anon_sym_u228f] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5910),
    [anon_sym_u2290] = ACTIONS(5908),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5908),
    [anon_sym_u2291] = ACTIONS(5908),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5908),
    [anon_sym_u2292] = ACTIONS(5908),
    [anon_sym_BSLASHsubset] = ACTIONS(5910),
    [anon_sym_u2282] = ACTIONS(5908),
    [anon_sym_BSLASHsupset] = ACTIONS(5910),
    [anon_sym_u2283] = ACTIONS(5908),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5908),
    [anon_sym_u2286] = ACTIONS(5908),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5908),
    [anon_sym_u2287] = ACTIONS(5908),
    [sym_compose] = ACTIONS(5908),
    [sym_map_to] = ACTIONS(5908),
    [sym_map_from] = ACTIONS(5908),
    [sym_setminus] = ACTIONS(5910),
    [anon_sym_BSLASHcap] = ACTIONS(5908),
    [anon_sym_BSLASHintersect] = ACTIONS(5908),
    [anon_sym_u2229] = ACTIONS(5908),
    [anon_sym_BSLASHcup] = ACTIONS(5908),
    [anon_sym_BSLASHunion] = ACTIONS(5908),
    [anon_sym_u222a] = ACTIONS(5908),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_u2025] = ACTIONS(5908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_u2026] = ACTIONS(5908),
    [anon_sym_PLUS] = ACTIONS(5910),
    [sym_plusplus] = ACTIONS(5908),
    [anon_sym_BSLASHoplus] = ACTIONS(5908),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5908),
    [anon_sym_u2295] = ACTIONS(5908),
    [anon_sym_BSLASHominus] = ACTIONS(5908),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2296] = ACTIONS(5908),
    [sym_mod] = ACTIONS(5910),
    [sym_modmod] = ACTIONS(5908),
    [sym_vert] = ACTIONS(5910),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_u2016] = ACTIONS(5908),
    [sym_minusminus] = ACTIONS(5908),
    [sym_amp] = ACTIONS(5910),
    [sym_ampamp] = ACTIONS(5908),
    [anon_sym_BSLASHodot] = ACTIONS(5908),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5908),
    [anon_sym_u2299] = ACTIONS(5908),
    [anon_sym_BSLASHoslash] = ACTIONS(5908),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5908),
    [anon_sym_u2298] = ACTIONS(5908),
    [anon_sym_BSLASHotimes] = ACTIONS(5908),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5908),
    [anon_sym_u2297] = ACTIONS(5908),
    [sym_mul] = ACTIONS(5910),
    [sym_mulmul] = ACTIONS(5908),
    [sym_slash] = ACTIONS(5910),
    [sym_slashslash] = ACTIONS(5908),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5908),
    [anon_sym_u25ef] = ACTIONS(5908),
    [anon_sym_BSLASHbullet] = ACTIONS(5908),
    [anon_sym_u25cf] = ACTIONS(5908),
    [anon_sym_BSLASHdiv] = ACTIONS(5908),
    [anon_sym_u00f7] = ACTIONS(5908),
    [anon_sym_BSLASHcirc] = ACTIONS(5908),
    [anon_sym_u2218] = ACTIONS(5908),
    [anon_sym_BSLASHstar] = ACTIONS(5908),
    [anon_sym_u22c6] = ACTIONS(5908),
    [anon_sym_u203c] = ACTIONS(5908),
    [sym_hashhash] = ACTIONS(5908),
    [sym_dol] = ACTIONS(5910),
    [sym_doldol] = ACTIONS(5908),
    [anon_sym_QMARK_QMARK] = ACTIONS(5908),
    [anon_sym_u2047] = ACTIONS(5908),
    [anon_sym_BSLASHsqcap] = ACTIONS(5908),
    [anon_sym_u2293] = ACTIONS(5908),
    [anon_sym_BSLASHsqcup] = ACTIONS(5908),
    [anon_sym_u2294] = ACTIONS(5908),
    [anon_sym_BSLASHuplus] = ACTIONS(5908),
    [anon_sym_u228e] = ACTIONS(5908),
    [anon_sym_BSLASHX] = ACTIONS(5908),
    [anon_sym_BSLASHtimes] = ACTIONS(5908),
    [anon_sym_u00d7] = ACTIONS(5908),
    [anon_sym_BSLASHwr] = ACTIONS(5908),
    [anon_sym_u2240] = ACTIONS(5908),
    [anon_sym_BSLASHcdot] = ACTIONS(5908),
    [anon_sym_u22c5] = ACTIONS(5908),
    [sym_pow] = ACTIONS(5910),
    [sym_powpow] = ACTIONS(5908),
    [anon_sym_CARET_PLUS] = ACTIONS(5908),
    [anon_sym_u207a] = ACTIONS(5908),
    [sym_asterisk] = ACTIONS(5908),
    [sym_sup_hash] = ACTIONS(5908),
    [sym_prime] = ACTIONS(5908),
    [sym__bullet] = ACTIONS(5908),
    [sym__dedent] = ACTIONS(5908),
    [sym__double_excl] = ACTIONS(5908),
  },
  [3399] = {
    [sym_block_comment] = STATE(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5914),
    [anon_sym_u2208] = ACTIONS(5912),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5912),
    [anon_sym_u25a1] = ACTIONS(5912),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5912),
    [anon_sym_u2227] = ACTIONS(5912),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5912),
    [anon_sym_u2228] = ACTIONS(5912),
    [anon_sym_LBRACK] = ACTIONS(5914),
    [anon_sym_BSLASHo] = ACTIONS(5914),
    [anon_sym_DOT] = ACTIONS(5914),
    [anon_sym_EQ] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5914),
    [anon_sym_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27f9] = ACTIONS(5912),
    [anon_sym_u21d2] = ACTIONS(5912),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5912),
    [anon_sym_u21f8] = ACTIONS(5912),
    [anon_sym_u2945] = ACTIONS(5912),
    [anon_sym_BSLASHequiv] = ACTIONS(5912),
    [anon_sym_u2261] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_u27fa] = ACTIONS(5912),
    [anon_sym_u21d4] = ACTIONS(5912),
    [anon_sym_TILDE_GT] = ACTIONS(5912),
    [anon_sym_u21dd] = ACTIONS(5912),
    [anon_sym_u219d] = ACTIONS(5912),
    [anon_sym_BSLASHland] = ACTIONS(5912),
    [anon_sym_BSLASHlor] = ACTIONS(5912),
    [anon_sym_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2254] = ACTIONS(5912),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5912),
    [anon_sym_u2a74] = ACTIONS(5912),
    [anon_sym_SLASH_EQ] = ACTIONS(5912),
    [anon_sym_POUND] = ACTIONS(5914),
    [anon_sym_u2260] = ACTIONS(5912),
    [anon_sym_LT] = ACTIONS(5914),
    [sym_gt] = ACTIONS(5914),
    [anon_sym_LT_EQ] = ACTIONS(5914),
    [anon_sym_EQ_LT] = ACTIONS(5912),
    [anon_sym_BSLASHleq] = ACTIONS(5912),
    [anon_sym_u2264] = ACTIONS(5912),
    [anon_sym_GT_EQ] = ACTIONS(5912),
    [anon_sym_BSLASHgeq] = ACTIONS(5912),
    [anon_sym_u2265] = ACTIONS(5912),
    [anon_sym_BSLASHapprox] = ACTIONS(5912),
    [anon_sym_u2248] = ACTIONS(5912),
    [anon_sym_PIPE_DASH] = ACTIONS(5912),
    [anon_sym_u22a2] = ACTIONS(5912),
    [anon_sym_PIPE_EQ] = ACTIONS(5912),
    [anon_sym_u22a8] = ACTIONS(5912),
    [anon_sym_DASH_PIPE] = ACTIONS(5912),
    [anon_sym_u22a3] = ACTIONS(5912),
    [anon_sym_EQ_PIPE] = ACTIONS(5912),
    [anon_sym_u2ae4] = ACTIONS(5912),
    [anon_sym_BSLASHasymp] = ACTIONS(5912),
    [anon_sym_u224d] = ACTIONS(5912),
    [anon_sym_BSLASHcong] = ACTIONS(5912),
    [anon_sym_u2245] = ACTIONS(5912),
    [anon_sym_BSLASHdoteq] = ACTIONS(5912),
    [anon_sym_u2250] = ACTIONS(5912),
    [anon_sym_BSLASHgg] = ACTIONS(5912),
    [anon_sym_u226b] = ACTIONS(5912),
    [anon_sym_BSLASHll] = ACTIONS(5912),
    [anon_sym_u226a] = ACTIONS(5912),
    [anon_sym_BSLASHnotin] = ACTIONS(5912),
    [anon_sym_u2209] = ACTIONS(5912),
    [anon_sym_BSLASHprec] = ACTIONS(5914),
    [anon_sym_u227a] = ACTIONS(5912),
    [anon_sym_BSLASHsucc] = ACTIONS(5914),
    [anon_sym_u227b] = ACTIONS(5912),
    [anon_sym_BSLASHpreceq] = ACTIONS(5912),
    [anon_sym_u2aaf] = ACTIONS(5912),
    [anon_sym_BSLASHsucceq] = ACTIONS(5912),
    [anon_sym_u2ab0] = ACTIONS(5912),
    [anon_sym_BSLASHpropto] = ACTIONS(5912),
    [anon_sym_u221d] = ACTIONS(5912),
    [anon_sym_BSLASHsim] = ACTIONS(5914),
    [anon_sym_u223c] = ACTIONS(5912),
    [anon_sym_BSLASHsimeq] = ACTIONS(5912),
    [anon_sym_u2243] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5914),
    [anon_sym_u228f] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5914),
    [anon_sym_u2290] = ACTIONS(5912),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5912),
    [anon_sym_u2291] = ACTIONS(5912),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5912),
    [anon_sym_u2292] = ACTIONS(5912),
    [anon_sym_BSLASHsubset] = ACTIONS(5914),
    [anon_sym_u2282] = ACTIONS(5912),
    [anon_sym_BSLASHsupset] = ACTIONS(5914),
    [anon_sym_u2283] = ACTIONS(5912),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5912),
    [anon_sym_u2286] = ACTIONS(5912),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5912),
    [anon_sym_u2287] = ACTIONS(5912),
    [sym_compose] = ACTIONS(5912),
    [sym_map_to] = ACTIONS(5912),
    [sym_map_from] = ACTIONS(5912),
    [sym_setminus] = ACTIONS(5914),
    [anon_sym_BSLASHcap] = ACTIONS(5912),
    [anon_sym_BSLASHintersect] = ACTIONS(5912),
    [anon_sym_u2229] = ACTIONS(5912),
    [anon_sym_BSLASHcup] = ACTIONS(5912),
    [anon_sym_BSLASHunion] = ACTIONS(5912),
    [anon_sym_u222a] = ACTIONS(5912),
    [anon_sym_DOT_DOT] = ACTIONS(5914),
    [anon_sym_u2025] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_u2026] = ACTIONS(5912),
    [anon_sym_PLUS] = ACTIONS(5914),
    [sym_plusplus] = ACTIONS(5912),
    [anon_sym_BSLASHoplus] = ACTIONS(5912),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5912),
    [anon_sym_u2295] = ACTIONS(5912),
    [anon_sym_BSLASHominus] = ACTIONS(5912),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2296] = ACTIONS(5912),
    [sym_mod] = ACTIONS(5914),
    [sym_modmod] = ACTIONS(5912),
    [sym_vert] = ACTIONS(5914),
    [anon_sym_PIPE_PIPE] = ACTIONS(5912),
    [anon_sym_u2016] = ACTIONS(5912),
    [sym_minusminus] = ACTIONS(5912),
    [sym_amp] = ACTIONS(5914),
    [sym_ampamp] = ACTIONS(5912),
    [anon_sym_BSLASHodot] = ACTIONS(5912),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5912),
    [anon_sym_u2299] = ACTIONS(5912),
    [anon_sym_BSLASHoslash] = ACTIONS(5912),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5912),
    [anon_sym_u2298] = ACTIONS(5912),
    [anon_sym_BSLASHotimes] = ACTIONS(5912),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5912),
    [anon_sym_u2297] = ACTIONS(5912),
    [sym_mul] = ACTIONS(5914),
    [sym_mulmul] = ACTIONS(5912),
    [sym_slash] = ACTIONS(5914),
    [sym_slashslash] = ACTIONS(5912),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5912),
    [anon_sym_u25ef] = ACTIONS(5912),
    [anon_sym_BSLASHbullet] = ACTIONS(5912),
    [anon_sym_u25cf] = ACTIONS(5912),
    [anon_sym_BSLASHdiv] = ACTIONS(5912),
    [anon_sym_u00f7] = ACTIONS(5912),
    [anon_sym_BSLASHcirc] = ACTIONS(5912),
    [anon_sym_u2218] = ACTIONS(5912),
    [anon_sym_BSLASHstar] = ACTIONS(5912),
    [anon_sym_u22c6] = ACTIONS(5912),
    [anon_sym_u203c] = ACTIONS(5912),
    [sym_hashhash] = ACTIONS(5912),
    [sym_dol] = ACTIONS(5914),
    [sym_doldol] = ACTIONS(5912),
    [anon_sym_QMARK_QMARK] = ACTIONS(5912),
    [anon_sym_u2047] = ACTIONS(5912),
    [anon_sym_BSLASHsqcap] = ACTIONS(5912),
    [anon_sym_u2293] = ACTIONS(5912),
    [anon_sym_BSLASHsqcup] = ACTIONS(5912),
    [anon_sym_u2294] = ACTIONS(5912),
    [anon_sym_BSLASHuplus] = ACTIONS(5912),
    [anon_sym_u228e] = ACTIONS(5912),
    [anon_sym_BSLASHX] = ACTIONS(5912),
    [anon_sym_BSLASHtimes] = ACTIONS(5912),
    [anon_sym_u00d7] = ACTIONS(5912),
    [anon_sym_BSLASHwr] = ACTIONS(5912),
    [anon_sym_u2240] = ACTIONS(5912),
    [anon_sym_BSLASHcdot] = ACTIONS(5912),
    [anon_sym_u22c5] = ACTIONS(5912),
    [sym_pow] = ACTIONS(5914),
    [sym_powpow] = ACTIONS(5912),
    [anon_sym_CARET_PLUS] = ACTIONS(5912),
    [anon_sym_u207a] = ACTIONS(5912),
    [sym_asterisk] = ACTIONS(5912),
    [sym_sup_hash] = ACTIONS(5912),
    [sym_prime] = ACTIONS(5912),
    [sym__bullet] = ACTIONS(5912),
    [sym__dedent] = ACTIONS(5912),
    [sym__double_excl] = ACTIONS(5912),
  },
  [3400] = {
    [sym_block_comment] = STATE(3400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5918),
    [anon_sym_u2208] = ACTIONS(5916),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5916),
    [anon_sym_u25a1] = ACTIONS(5916),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5916),
    [anon_sym_u2227] = ACTIONS(5916),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5916),
    [anon_sym_u2228] = ACTIONS(5916),
    [anon_sym_LBRACK] = ACTIONS(5918),
    [anon_sym_BSLASHo] = ACTIONS(5918),
    [anon_sym_DOT] = ACTIONS(5918),
    [anon_sym_EQ] = ACTIONS(5918),
    [anon_sym_DASH] = ACTIONS(5918),
    [anon_sym_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27f9] = ACTIONS(5916),
    [anon_sym_u21d2] = ACTIONS(5916),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5916),
    [anon_sym_u21f8] = ACTIONS(5916),
    [anon_sym_u2945] = ACTIONS(5916),
    [anon_sym_BSLASHequiv] = ACTIONS(5916),
    [anon_sym_u2261] = ACTIONS(5916),
    [anon_sym_LT_EQ_GT] = ACTIONS(5916),
    [anon_sym_u27fa] = ACTIONS(5916),
    [anon_sym_u21d4] = ACTIONS(5916),
    [anon_sym_TILDE_GT] = ACTIONS(5916),
    [anon_sym_u21dd] = ACTIONS(5916),
    [anon_sym_u219d] = ACTIONS(5916),
    [anon_sym_BSLASHland] = ACTIONS(5916),
    [anon_sym_BSLASHlor] = ACTIONS(5916),
    [anon_sym_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2254] = ACTIONS(5916),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5916),
    [anon_sym_u2a74] = ACTIONS(5916),
    [anon_sym_SLASH_EQ] = ACTIONS(5916),
    [anon_sym_POUND] = ACTIONS(5918),
    [anon_sym_u2260] = ACTIONS(5916),
    [anon_sym_LT] = ACTIONS(5918),
    [sym_gt] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5918),
    [anon_sym_EQ_LT] = ACTIONS(5916),
    [anon_sym_BSLASHleq] = ACTIONS(5916),
    [anon_sym_u2264] = ACTIONS(5916),
    [anon_sym_GT_EQ] = ACTIONS(5916),
    [anon_sym_BSLASHgeq] = ACTIONS(5916),
    [anon_sym_u2265] = ACTIONS(5916),
    [anon_sym_BSLASHapprox] = ACTIONS(5916),
    [anon_sym_u2248] = ACTIONS(5916),
    [anon_sym_PIPE_DASH] = ACTIONS(5916),
    [anon_sym_u22a2] = ACTIONS(5916),
    [anon_sym_PIPE_EQ] = ACTIONS(5916),
    [anon_sym_u22a8] = ACTIONS(5916),
    [anon_sym_DASH_PIPE] = ACTIONS(5916),
    [anon_sym_u22a3] = ACTIONS(5916),
    [anon_sym_EQ_PIPE] = ACTIONS(5916),
    [anon_sym_u2ae4] = ACTIONS(5916),
    [anon_sym_BSLASHasymp] = ACTIONS(5916),
    [anon_sym_u224d] = ACTIONS(5916),
    [anon_sym_BSLASHcong] = ACTIONS(5916),
    [anon_sym_u2245] = ACTIONS(5916),
    [anon_sym_BSLASHdoteq] = ACTIONS(5916),
    [anon_sym_u2250] = ACTIONS(5916),
    [anon_sym_BSLASHgg] = ACTIONS(5916),
    [anon_sym_u226b] = ACTIONS(5916),
    [anon_sym_BSLASHll] = ACTIONS(5916),
    [anon_sym_u226a] = ACTIONS(5916),
    [anon_sym_BSLASHnotin] = ACTIONS(5916),
    [anon_sym_u2209] = ACTIONS(5916),
    [anon_sym_BSLASHprec] = ACTIONS(5918),
    [anon_sym_u227a] = ACTIONS(5916),
    [anon_sym_BSLASHsucc] = ACTIONS(5918),
    [anon_sym_u227b] = ACTIONS(5916),
    [anon_sym_BSLASHpreceq] = ACTIONS(5916),
    [anon_sym_u2aaf] = ACTIONS(5916),
    [anon_sym_BSLASHsucceq] = ACTIONS(5916),
    [anon_sym_u2ab0] = ACTIONS(5916),
    [anon_sym_BSLASHpropto] = ACTIONS(5916),
    [anon_sym_u221d] = ACTIONS(5916),
    [anon_sym_BSLASHsim] = ACTIONS(5918),
    [anon_sym_u223c] = ACTIONS(5916),
    [anon_sym_BSLASHsimeq] = ACTIONS(5916),
    [anon_sym_u2243] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5918),
    [anon_sym_u228f] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5918),
    [anon_sym_u2290] = ACTIONS(5916),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5916),
    [anon_sym_u2291] = ACTIONS(5916),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5916),
    [anon_sym_u2292] = ACTIONS(5916),
    [anon_sym_BSLASHsubset] = ACTIONS(5918),
    [anon_sym_u2282] = ACTIONS(5916),
    [anon_sym_BSLASHsupset] = ACTIONS(5918),
    [anon_sym_u2283] = ACTIONS(5916),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5916),
    [anon_sym_u2286] = ACTIONS(5916),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5916),
    [anon_sym_u2287] = ACTIONS(5916),
    [sym_compose] = ACTIONS(5916),
    [sym_map_to] = ACTIONS(5916),
    [sym_map_from] = ACTIONS(5916),
    [sym_setminus] = ACTIONS(5918),
    [anon_sym_BSLASHcap] = ACTIONS(5916),
    [anon_sym_BSLASHintersect] = ACTIONS(5916),
    [anon_sym_u2229] = ACTIONS(5916),
    [anon_sym_BSLASHcup] = ACTIONS(5916),
    [anon_sym_BSLASHunion] = ACTIONS(5916),
    [anon_sym_u222a] = ACTIONS(5916),
    [anon_sym_DOT_DOT] = ACTIONS(5918),
    [anon_sym_u2025] = ACTIONS(5916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5916),
    [anon_sym_u2026] = ACTIONS(5916),
    [anon_sym_PLUS] = ACTIONS(5918),
    [sym_plusplus] = ACTIONS(5916),
    [anon_sym_BSLASHoplus] = ACTIONS(5916),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5916),
    [anon_sym_u2295] = ACTIONS(5916),
    [anon_sym_BSLASHominus] = ACTIONS(5916),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2296] = ACTIONS(5916),
    [sym_mod] = ACTIONS(5918),
    [sym_modmod] = ACTIONS(5916),
    [sym_vert] = ACTIONS(5918),
    [anon_sym_PIPE_PIPE] = ACTIONS(5916),
    [anon_sym_u2016] = ACTIONS(5916),
    [sym_minusminus] = ACTIONS(5916),
    [sym_amp] = ACTIONS(5918),
    [sym_ampamp] = ACTIONS(5916),
    [anon_sym_BSLASHodot] = ACTIONS(5916),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5916),
    [anon_sym_u2299] = ACTIONS(5916),
    [anon_sym_BSLASHoslash] = ACTIONS(5916),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5916),
    [anon_sym_u2298] = ACTIONS(5916),
    [anon_sym_BSLASHotimes] = ACTIONS(5916),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5916),
    [anon_sym_u2297] = ACTIONS(5916),
    [sym_mul] = ACTIONS(5918),
    [sym_mulmul] = ACTIONS(5916),
    [sym_slash] = ACTIONS(5918),
    [sym_slashslash] = ACTIONS(5916),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5916),
    [anon_sym_u25ef] = ACTIONS(5916),
    [anon_sym_BSLASHbullet] = ACTIONS(5916),
    [anon_sym_u25cf] = ACTIONS(5916),
    [anon_sym_BSLASHdiv] = ACTIONS(5916),
    [anon_sym_u00f7] = ACTIONS(5916),
    [anon_sym_BSLASHcirc] = ACTIONS(5916),
    [anon_sym_u2218] = ACTIONS(5916),
    [anon_sym_BSLASHstar] = ACTIONS(5916),
    [anon_sym_u22c6] = ACTIONS(5916),
    [anon_sym_u203c] = ACTIONS(5916),
    [sym_hashhash] = ACTIONS(5916),
    [sym_dol] = ACTIONS(5918),
    [sym_doldol] = ACTIONS(5916),
    [anon_sym_QMARK_QMARK] = ACTIONS(5916),
    [anon_sym_u2047] = ACTIONS(5916),
    [anon_sym_BSLASHsqcap] = ACTIONS(5916),
    [anon_sym_u2293] = ACTIONS(5916),
    [anon_sym_BSLASHsqcup] = ACTIONS(5916),
    [anon_sym_u2294] = ACTIONS(5916),
    [anon_sym_BSLASHuplus] = ACTIONS(5916),
    [anon_sym_u228e] = ACTIONS(5916),
    [anon_sym_BSLASHX] = ACTIONS(5916),
    [anon_sym_BSLASHtimes] = ACTIONS(5916),
    [anon_sym_u00d7] = ACTIONS(5916),
    [anon_sym_BSLASHwr] = ACTIONS(5916),
    [anon_sym_u2240] = ACTIONS(5916),
    [anon_sym_BSLASHcdot] = ACTIONS(5916),
    [anon_sym_u22c5] = ACTIONS(5916),
    [sym_pow] = ACTIONS(5918),
    [sym_powpow] = ACTIONS(5916),
    [anon_sym_CARET_PLUS] = ACTIONS(5916),
    [anon_sym_u207a] = ACTIONS(5916),
    [sym_asterisk] = ACTIONS(5916),
    [sym_sup_hash] = ACTIONS(5916),
    [sym_prime] = ACTIONS(5916),
    [sym__bullet] = ACTIONS(5916),
    [sym__dedent] = ACTIONS(5916),
    [sym__double_excl] = ACTIONS(5916),
  },
  [3401] = {
    [sym_block_comment] = STATE(3401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5922),
    [anon_sym_u2208] = ACTIONS(5920),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5920),
    [anon_sym_u25a1] = ACTIONS(5920),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5920),
    [anon_sym_u2227] = ACTIONS(5920),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5920),
    [anon_sym_u2228] = ACTIONS(5920),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_BSLASHo] = ACTIONS(5922),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5922),
    [anon_sym_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27f9] = ACTIONS(5920),
    [anon_sym_u21d2] = ACTIONS(5920),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5920),
    [anon_sym_u21f8] = ACTIONS(5920),
    [anon_sym_u2945] = ACTIONS(5920),
    [anon_sym_BSLASHequiv] = ACTIONS(5920),
    [anon_sym_u2261] = ACTIONS(5920),
    [anon_sym_LT_EQ_GT] = ACTIONS(5920),
    [anon_sym_u27fa] = ACTIONS(5920),
    [anon_sym_u21d4] = ACTIONS(5920),
    [anon_sym_TILDE_GT] = ACTIONS(5920),
    [anon_sym_u21dd] = ACTIONS(5920),
    [anon_sym_u219d] = ACTIONS(5920),
    [anon_sym_BSLASHland] = ACTIONS(5920),
    [anon_sym_BSLASHlor] = ACTIONS(5920),
    [anon_sym_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2254] = ACTIONS(5920),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5920),
    [anon_sym_u2a74] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5920),
    [anon_sym_POUND] = ACTIONS(5922),
    [anon_sym_u2260] = ACTIONS(5920),
    [anon_sym_LT] = ACTIONS(5922),
    [sym_gt] = ACTIONS(5922),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_EQ_LT] = ACTIONS(5920),
    [anon_sym_BSLASHleq] = ACTIONS(5920),
    [anon_sym_u2264] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5920),
    [anon_sym_BSLASHgeq] = ACTIONS(5920),
    [anon_sym_u2265] = ACTIONS(5920),
    [anon_sym_BSLASHapprox] = ACTIONS(5920),
    [anon_sym_u2248] = ACTIONS(5920),
    [anon_sym_PIPE_DASH] = ACTIONS(5920),
    [anon_sym_u22a2] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5920),
    [anon_sym_u22a8] = ACTIONS(5920),
    [anon_sym_DASH_PIPE] = ACTIONS(5920),
    [anon_sym_u22a3] = ACTIONS(5920),
    [anon_sym_EQ_PIPE] = ACTIONS(5920),
    [anon_sym_u2ae4] = ACTIONS(5920),
    [anon_sym_BSLASHasymp] = ACTIONS(5920),
    [anon_sym_u224d] = ACTIONS(5920),
    [anon_sym_BSLASHcong] = ACTIONS(5920),
    [anon_sym_u2245] = ACTIONS(5920),
    [anon_sym_BSLASHdoteq] = ACTIONS(5920),
    [anon_sym_u2250] = ACTIONS(5920),
    [anon_sym_BSLASHgg] = ACTIONS(5920),
    [anon_sym_u226b] = ACTIONS(5920),
    [anon_sym_BSLASHll] = ACTIONS(5920),
    [anon_sym_u226a] = ACTIONS(5920),
    [anon_sym_BSLASHnotin] = ACTIONS(5920),
    [anon_sym_u2209] = ACTIONS(5920),
    [anon_sym_BSLASHprec] = ACTIONS(5922),
    [anon_sym_u227a] = ACTIONS(5920),
    [anon_sym_BSLASHsucc] = ACTIONS(5922),
    [anon_sym_u227b] = ACTIONS(5920),
    [anon_sym_BSLASHpreceq] = ACTIONS(5920),
    [anon_sym_u2aaf] = ACTIONS(5920),
    [anon_sym_BSLASHsucceq] = ACTIONS(5920),
    [anon_sym_u2ab0] = ACTIONS(5920),
    [anon_sym_BSLASHpropto] = ACTIONS(5920),
    [anon_sym_u221d] = ACTIONS(5920),
    [anon_sym_BSLASHsim] = ACTIONS(5922),
    [anon_sym_u223c] = ACTIONS(5920),
    [anon_sym_BSLASHsimeq] = ACTIONS(5920),
    [anon_sym_u2243] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5922),
    [anon_sym_u228f] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5922),
    [anon_sym_u2290] = ACTIONS(5920),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5920),
    [anon_sym_u2291] = ACTIONS(5920),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5920),
    [anon_sym_u2292] = ACTIONS(5920),
    [anon_sym_BSLASHsubset] = ACTIONS(5922),
    [anon_sym_u2282] = ACTIONS(5920),
    [anon_sym_BSLASHsupset] = ACTIONS(5922),
    [anon_sym_u2283] = ACTIONS(5920),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5920),
    [anon_sym_u2286] = ACTIONS(5920),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5920),
    [anon_sym_u2287] = ACTIONS(5920),
    [sym_compose] = ACTIONS(5920),
    [sym_map_to] = ACTIONS(5920),
    [sym_map_from] = ACTIONS(5920),
    [sym_setminus] = ACTIONS(5922),
    [anon_sym_BSLASHcap] = ACTIONS(5920),
    [anon_sym_BSLASHintersect] = ACTIONS(5920),
    [anon_sym_u2229] = ACTIONS(5920),
    [anon_sym_BSLASHcup] = ACTIONS(5920),
    [anon_sym_BSLASHunion] = ACTIONS(5920),
    [anon_sym_u222a] = ACTIONS(5920),
    [anon_sym_DOT_DOT] = ACTIONS(5922),
    [anon_sym_u2025] = ACTIONS(5920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5920),
    [anon_sym_u2026] = ACTIONS(5920),
    [anon_sym_PLUS] = ACTIONS(5922),
    [sym_plusplus] = ACTIONS(5920),
    [anon_sym_BSLASHoplus] = ACTIONS(5920),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5920),
    [anon_sym_u2295] = ACTIONS(5920),
    [anon_sym_BSLASHominus] = ACTIONS(5920),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2296] = ACTIONS(5920),
    [sym_mod] = ACTIONS(5922),
    [sym_modmod] = ACTIONS(5920),
    [sym_vert] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5920),
    [anon_sym_u2016] = ACTIONS(5920),
    [sym_minusminus] = ACTIONS(5920),
    [sym_amp] = ACTIONS(5922),
    [sym_ampamp] = ACTIONS(5920),
    [anon_sym_BSLASHodot] = ACTIONS(5920),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5920),
    [anon_sym_u2299] = ACTIONS(5920),
    [anon_sym_BSLASHoslash] = ACTIONS(5920),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5920),
    [anon_sym_u2298] = ACTIONS(5920),
    [anon_sym_BSLASHotimes] = ACTIONS(5920),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5920),
    [anon_sym_u2297] = ACTIONS(5920),
    [sym_mul] = ACTIONS(5922),
    [sym_mulmul] = ACTIONS(5920),
    [sym_slash] = ACTIONS(5922),
    [sym_slashslash] = ACTIONS(5920),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5920),
    [anon_sym_u25ef] = ACTIONS(5920),
    [anon_sym_BSLASHbullet] = ACTIONS(5920),
    [anon_sym_u25cf] = ACTIONS(5920),
    [anon_sym_BSLASHdiv] = ACTIONS(5920),
    [anon_sym_u00f7] = ACTIONS(5920),
    [anon_sym_BSLASHcirc] = ACTIONS(5920),
    [anon_sym_u2218] = ACTIONS(5920),
    [anon_sym_BSLASHstar] = ACTIONS(5920),
    [anon_sym_u22c6] = ACTIONS(5920),
    [anon_sym_u203c] = ACTIONS(5920),
    [sym_hashhash] = ACTIONS(5920),
    [sym_dol] = ACTIONS(5922),
    [sym_doldol] = ACTIONS(5920),
    [anon_sym_QMARK_QMARK] = ACTIONS(5920),
    [anon_sym_u2047] = ACTIONS(5920),
    [anon_sym_BSLASHsqcap] = ACTIONS(5920),
    [anon_sym_u2293] = ACTIONS(5920),
    [anon_sym_BSLASHsqcup] = ACTIONS(5920),
    [anon_sym_u2294] = ACTIONS(5920),
    [anon_sym_BSLASHuplus] = ACTIONS(5920),
    [anon_sym_u228e] = ACTIONS(5920),
    [anon_sym_BSLASHX] = ACTIONS(5920),
    [anon_sym_BSLASHtimes] = ACTIONS(5920),
    [anon_sym_u00d7] = ACTIONS(5920),
    [anon_sym_BSLASHwr] = ACTIONS(5920),
    [anon_sym_u2240] = ACTIONS(5920),
    [anon_sym_BSLASHcdot] = ACTIONS(5920),
    [anon_sym_u22c5] = ACTIONS(5920),
    [sym_pow] = ACTIONS(5922),
    [sym_powpow] = ACTIONS(5920),
    [anon_sym_CARET_PLUS] = ACTIONS(5920),
    [anon_sym_u207a] = ACTIONS(5920),
    [sym_asterisk] = ACTIONS(5920),
    [sym_sup_hash] = ACTIONS(5920),
    [sym_prime] = ACTIONS(5920),
    [sym__bullet] = ACTIONS(5920),
    [sym__dedent] = ACTIONS(5920),
    [sym__double_excl] = ACTIONS(5920),
  },
  [3402] = {
    [sym_block_comment] = STATE(3402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5780),
    [anon_sym_u2208] = ACTIONS(5778),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5778),
    [anon_sym_u25a1] = ACTIONS(5778),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5778),
    [anon_sym_u2227] = ACTIONS(5778),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5778),
    [anon_sym_u2228] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_BSLASHo] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27f9] = ACTIONS(5778),
    [anon_sym_u21d2] = ACTIONS(5778),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5778),
    [anon_sym_u21f8] = ACTIONS(5778),
    [anon_sym_u2945] = ACTIONS(5778),
    [anon_sym_BSLASHequiv] = ACTIONS(5778),
    [anon_sym_u2261] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5778),
    [anon_sym_u27fa] = ACTIONS(5778),
    [anon_sym_u21d4] = ACTIONS(5778),
    [anon_sym_TILDE_GT] = ACTIONS(5778),
    [anon_sym_u21dd] = ACTIONS(5778),
    [anon_sym_u219d] = ACTIONS(5778),
    [anon_sym_BSLASHland] = ACTIONS(5778),
    [anon_sym_BSLASHlor] = ACTIONS(5778),
    [anon_sym_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2254] = ACTIONS(5778),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5778),
    [anon_sym_u2a74] = ACTIONS(5778),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5780),
    [anon_sym_u2260] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [sym_gt] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5780),
    [anon_sym_EQ_LT] = ACTIONS(5778),
    [anon_sym_BSLASHleq] = ACTIONS(5778),
    [anon_sym_u2264] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_BSLASHgeq] = ACTIONS(5778),
    [anon_sym_u2265] = ACTIONS(5778),
    [anon_sym_BSLASHapprox] = ACTIONS(5778),
    [anon_sym_u2248] = ACTIONS(5778),
    [anon_sym_PIPE_DASH] = ACTIONS(5778),
    [anon_sym_u22a2] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_u22a8] = ACTIONS(5778),
    [anon_sym_DASH_PIPE] = ACTIONS(5778),
    [anon_sym_u22a3] = ACTIONS(5778),
    [anon_sym_EQ_PIPE] = ACTIONS(5778),
    [anon_sym_u2ae4] = ACTIONS(5778),
    [anon_sym_BSLASHasymp] = ACTIONS(5778),
    [anon_sym_u224d] = ACTIONS(5778),
    [anon_sym_BSLASHcong] = ACTIONS(5778),
    [anon_sym_u2245] = ACTIONS(5778),
    [anon_sym_BSLASHdoteq] = ACTIONS(5778),
    [anon_sym_u2250] = ACTIONS(5778),
    [anon_sym_BSLASHgg] = ACTIONS(5778),
    [anon_sym_u226b] = ACTIONS(5778),
    [anon_sym_BSLASHll] = ACTIONS(5778),
    [anon_sym_u226a] = ACTIONS(5778),
    [anon_sym_BSLASHnotin] = ACTIONS(5778),
    [anon_sym_u2209] = ACTIONS(5778),
    [anon_sym_BSLASHprec] = ACTIONS(5780),
    [anon_sym_u227a] = ACTIONS(5778),
    [anon_sym_BSLASHsucc] = ACTIONS(5780),
    [anon_sym_u227b] = ACTIONS(5778),
    [anon_sym_BSLASHpreceq] = ACTIONS(5778),
    [anon_sym_u2aaf] = ACTIONS(5778),
    [anon_sym_BSLASHsucceq] = ACTIONS(5778),
    [anon_sym_u2ab0] = ACTIONS(5778),
    [anon_sym_BSLASHpropto] = ACTIONS(5778),
    [anon_sym_u221d] = ACTIONS(5778),
    [anon_sym_BSLASHsim] = ACTIONS(5780),
    [anon_sym_u223c] = ACTIONS(5778),
    [anon_sym_BSLASHsimeq] = ACTIONS(5778),
    [anon_sym_u2243] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5780),
    [anon_sym_u228f] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5780),
    [anon_sym_u2290] = ACTIONS(5778),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5778),
    [anon_sym_u2291] = ACTIONS(5778),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5778),
    [anon_sym_u2292] = ACTIONS(5778),
    [anon_sym_BSLASHsubset] = ACTIONS(5780),
    [anon_sym_u2282] = ACTIONS(5778),
    [anon_sym_BSLASHsupset] = ACTIONS(5780),
    [anon_sym_u2283] = ACTIONS(5778),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5778),
    [anon_sym_u2286] = ACTIONS(5778),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5778),
    [anon_sym_u2287] = ACTIONS(5778),
    [sym_compose] = ACTIONS(5778),
    [sym_map_to] = ACTIONS(5778),
    [sym_map_from] = ACTIONS(5778),
    [sym_setminus] = ACTIONS(5780),
    [anon_sym_BSLASHcap] = ACTIONS(5778),
    [anon_sym_BSLASHintersect] = ACTIONS(5778),
    [anon_sym_u2229] = ACTIONS(5778),
    [anon_sym_BSLASHcup] = ACTIONS(5778),
    [anon_sym_BSLASHunion] = ACTIONS(5778),
    [anon_sym_u222a] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_u2025] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_u2026] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [sym_plusplus] = ACTIONS(5778),
    [anon_sym_BSLASHoplus] = ACTIONS(5778),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5778),
    [anon_sym_u2295] = ACTIONS(5778),
    [anon_sym_BSLASHominus] = ACTIONS(5778),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2296] = ACTIONS(5778),
    [sym_mod] = ACTIONS(5780),
    [sym_modmod] = ACTIONS(5778),
    [sym_vert] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_u2016] = ACTIONS(5778),
    [sym_minusminus] = ACTIONS(5778),
    [sym_amp] = ACTIONS(5780),
    [sym_ampamp] = ACTIONS(5778),
    [anon_sym_BSLASHodot] = ACTIONS(5778),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5778),
    [anon_sym_u2299] = ACTIONS(5778),
    [anon_sym_BSLASHoslash] = ACTIONS(5778),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5778),
    [anon_sym_u2298] = ACTIONS(5778),
    [anon_sym_BSLASHotimes] = ACTIONS(5778),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5778),
    [anon_sym_u2297] = ACTIONS(5778),
    [sym_mul] = ACTIONS(5780),
    [sym_mulmul] = ACTIONS(5778),
    [sym_slash] = ACTIONS(5780),
    [sym_slashslash] = ACTIONS(5778),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5778),
    [anon_sym_u25ef] = ACTIONS(5778),
    [anon_sym_BSLASHbullet] = ACTIONS(5778),
    [anon_sym_u25cf] = ACTIONS(5778),
    [anon_sym_BSLASHdiv] = ACTIONS(5778),
    [anon_sym_u00f7] = ACTIONS(5778),
    [anon_sym_BSLASHcirc] = ACTIONS(5778),
    [anon_sym_u2218] = ACTIONS(5778),
    [anon_sym_BSLASHstar] = ACTIONS(5778),
    [anon_sym_u22c6] = ACTIONS(5778),
    [anon_sym_u203c] = ACTIONS(5778),
    [sym_hashhash] = ACTIONS(5778),
    [sym_dol] = ACTIONS(5780),
    [sym_doldol] = ACTIONS(5778),
    [anon_sym_QMARK_QMARK] = ACTIONS(5778),
    [anon_sym_u2047] = ACTIONS(5778),
    [anon_sym_BSLASHsqcap] = ACTIONS(5778),
    [anon_sym_u2293] = ACTIONS(5778),
    [anon_sym_BSLASHsqcup] = ACTIONS(5778),
    [anon_sym_u2294] = ACTIONS(5778),
    [anon_sym_BSLASHuplus] = ACTIONS(5778),
    [anon_sym_u228e] = ACTIONS(5778),
    [anon_sym_BSLASHX] = ACTIONS(5778),
    [anon_sym_BSLASHtimes] = ACTIONS(5778),
    [anon_sym_u00d7] = ACTIONS(5778),
    [anon_sym_BSLASHwr] = ACTIONS(5778),
    [anon_sym_u2240] = ACTIONS(5778),
    [anon_sym_BSLASHcdot] = ACTIONS(5778),
    [anon_sym_u22c5] = ACTIONS(5778),
    [sym_pow] = ACTIONS(5780),
    [sym_powpow] = ACTIONS(5778),
    [anon_sym_CARET_PLUS] = ACTIONS(5778),
    [anon_sym_u207a] = ACTIONS(5778),
    [sym_asterisk] = ACTIONS(5778),
    [sym_sup_hash] = ACTIONS(5778),
    [sym_prime] = ACTIONS(5778),
    [sym__bullet] = ACTIONS(5778),
    [sym__dedent] = ACTIONS(5778),
    [sym__double_excl] = ACTIONS(5778),
  },
  [3403] = {
    [sym_block_comment] = STATE(3403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5924),
    [anon_sym_u2208] = ACTIONS(5926),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5926),
    [anon_sym_u25a1] = ACTIONS(5926),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5926),
    [anon_sym_u2227] = ACTIONS(5926),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5926),
    [anon_sym_u2228] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5924),
    [anon_sym_BSLASHo] = ACTIONS(5924),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27f9] = ACTIONS(5926),
    [anon_sym_u21d2] = ACTIONS(5926),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5926),
    [anon_sym_u21f8] = ACTIONS(5926),
    [anon_sym_u2945] = ACTIONS(5926),
    [anon_sym_BSLASHequiv] = ACTIONS(5926),
    [anon_sym_u2261] = ACTIONS(5926),
    [anon_sym_LT_EQ_GT] = ACTIONS(5926),
    [anon_sym_u27fa] = ACTIONS(5926),
    [anon_sym_u21d4] = ACTIONS(5926),
    [anon_sym_TILDE_GT] = ACTIONS(5926),
    [anon_sym_u21dd] = ACTIONS(5926),
    [anon_sym_u219d] = ACTIONS(5926),
    [anon_sym_BSLASHland] = ACTIONS(5926),
    [anon_sym_BSLASHlor] = ACTIONS(5926),
    [anon_sym_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2254] = ACTIONS(5926),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5926),
    [anon_sym_u2a74] = ACTIONS(5926),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_POUND] = ACTIONS(5924),
    [anon_sym_u2260] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [sym_gt] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5924),
    [anon_sym_EQ_LT] = ACTIONS(5926),
    [anon_sym_BSLASHleq] = ACTIONS(5926),
    [anon_sym_u2264] = ACTIONS(5926),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_BSLASHgeq] = ACTIONS(5926),
    [anon_sym_u2265] = ACTIONS(5926),
    [anon_sym_BSLASHapprox] = ACTIONS(5926),
    [anon_sym_u2248] = ACTIONS(5926),
    [anon_sym_PIPE_DASH] = ACTIONS(5926),
    [anon_sym_u22a2] = ACTIONS(5926),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_u22a8] = ACTIONS(5926),
    [anon_sym_DASH_PIPE] = ACTIONS(5926),
    [anon_sym_u22a3] = ACTIONS(5926),
    [anon_sym_EQ_PIPE] = ACTIONS(5926),
    [anon_sym_u2ae4] = ACTIONS(5926),
    [anon_sym_BSLASHasymp] = ACTIONS(5926),
    [anon_sym_u224d] = ACTIONS(5926),
    [anon_sym_BSLASHcong] = ACTIONS(5926),
    [anon_sym_u2245] = ACTIONS(5926),
    [anon_sym_BSLASHdoteq] = ACTIONS(5926),
    [anon_sym_u2250] = ACTIONS(5926),
    [anon_sym_BSLASHgg] = ACTIONS(5926),
    [anon_sym_u226b] = ACTIONS(5926),
    [anon_sym_BSLASHll] = ACTIONS(5926),
    [anon_sym_u226a] = ACTIONS(5926),
    [anon_sym_BSLASHnotin] = ACTIONS(5926),
    [anon_sym_u2209] = ACTIONS(5926),
    [anon_sym_BSLASHprec] = ACTIONS(5924),
    [anon_sym_u227a] = ACTIONS(5926),
    [anon_sym_BSLASHsucc] = ACTIONS(5924),
    [anon_sym_u227b] = ACTIONS(5926),
    [anon_sym_BSLASHpreceq] = ACTIONS(5926),
    [anon_sym_u2aaf] = ACTIONS(5926),
    [anon_sym_BSLASHsucceq] = ACTIONS(5926),
    [anon_sym_u2ab0] = ACTIONS(5926),
    [anon_sym_BSLASHpropto] = ACTIONS(5926),
    [anon_sym_u221d] = ACTIONS(5926),
    [anon_sym_BSLASHsim] = ACTIONS(5924),
    [anon_sym_u223c] = ACTIONS(5926),
    [anon_sym_BSLASHsimeq] = ACTIONS(5926),
    [anon_sym_u2243] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5924),
    [anon_sym_u228f] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5924),
    [anon_sym_u2290] = ACTIONS(5926),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5926),
    [anon_sym_u2291] = ACTIONS(5926),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5926),
    [anon_sym_u2292] = ACTIONS(5926),
    [anon_sym_BSLASHsubset] = ACTIONS(5924),
    [anon_sym_u2282] = ACTIONS(5926),
    [anon_sym_BSLASHsupset] = ACTIONS(5924),
    [anon_sym_u2283] = ACTIONS(5926),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5926),
    [anon_sym_u2286] = ACTIONS(5926),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5926),
    [anon_sym_u2287] = ACTIONS(5926),
    [sym_compose] = ACTIONS(5926),
    [sym_map_to] = ACTIONS(5926),
    [sym_map_from] = ACTIONS(5926),
    [sym_setminus] = ACTIONS(5924),
    [anon_sym_BSLASHcap] = ACTIONS(5926),
    [anon_sym_BSLASHintersect] = ACTIONS(5926),
    [anon_sym_u2229] = ACTIONS(5926),
    [anon_sym_BSLASHcup] = ACTIONS(5926),
    [anon_sym_BSLASHunion] = ACTIONS(5926),
    [anon_sym_u222a] = ACTIONS(5926),
    [anon_sym_DOT_DOT] = ACTIONS(5924),
    [anon_sym_u2025] = ACTIONS(5926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_u2026] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [sym_plusplus] = ACTIONS(5926),
    [anon_sym_BSLASHoplus] = ACTIONS(5926),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5926),
    [anon_sym_u2295] = ACTIONS(5926),
    [anon_sym_BSLASHominus] = ACTIONS(5926),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2296] = ACTIONS(5926),
    [sym_mod] = ACTIONS(5924),
    [sym_modmod] = ACTIONS(5926),
    [sym_vert] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_u2016] = ACTIONS(5926),
    [sym_minusminus] = ACTIONS(5926),
    [sym_amp] = ACTIONS(5924),
    [sym_ampamp] = ACTIONS(5926),
    [anon_sym_BSLASHodot] = ACTIONS(5926),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5926),
    [anon_sym_u2299] = ACTIONS(5926),
    [anon_sym_BSLASHoslash] = ACTIONS(5926),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5926),
    [anon_sym_u2298] = ACTIONS(5926),
    [anon_sym_BSLASHotimes] = ACTIONS(5926),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5926),
    [anon_sym_u2297] = ACTIONS(5926),
    [sym_mul] = ACTIONS(5924),
    [sym_mulmul] = ACTIONS(5926),
    [sym_slash] = ACTIONS(5924),
    [sym_slashslash] = ACTIONS(5926),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5926),
    [anon_sym_u25ef] = ACTIONS(5926),
    [anon_sym_BSLASHbullet] = ACTIONS(5926),
    [anon_sym_u25cf] = ACTIONS(5926),
    [anon_sym_BSLASHdiv] = ACTIONS(5926),
    [anon_sym_u00f7] = ACTIONS(5926),
    [anon_sym_BSLASHcirc] = ACTIONS(5926),
    [anon_sym_u2218] = ACTIONS(5926),
    [anon_sym_BSLASHstar] = ACTIONS(5926),
    [anon_sym_u22c6] = ACTIONS(5926),
    [anon_sym_u203c] = ACTIONS(5926),
    [sym_hashhash] = ACTIONS(5926),
    [sym_dol] = ACTIONS(5924),
    [sym_doldol] = ACTIONS(5926),
    [anon_sym_QMARK_QMARK] = ACTIONS(5926),
    [anon_sym_u2047] = ACTIONS(5926),
    [anon_sym_BSLASHsqcap] = ACTIONS(5926),
    [anon_sym_u2293] = ACTIONS(5926),
    [anon_sym_BSLASHsqcup] = ACTIONS(5926),
    [anon_sym_u2294] = ACTIONS(5926),
    [anon_sym_BSLASHuplus] = ACTIONS(5926),
    [anon_sym_u228e] = ACTIONS(5926),
    [anon_sym_BSLASHX] = ACTIONS(5926),
    [anon_sym_BSLASHtimes] = ACTIONS(5926),
    [anon_sym_u00d7] = ACTIONS(5926),
    [anon_sym_BSLASHwr] = ACTIONS(5926),
    [anon_sym_u2240] = ACTIONS(5926),
    [anon_sym_BSLASHcdot] = ACTIONS(5926),
    [anon_sym_u22c5] = ACTIONS(5926),
    [sym_pow] = ACTIONS(5924),
    [sym_powpow] = ACTIONS(5926),
    [anon_sym_CARET_PLUS] = ACTIONS(5926),
    [anon_sym_u207a] = ACTIONS(5926),
    [sym_asterisk] = ACTIONS(5926),
    [sym_sup_hash] = ACTIONS(5926),
    [sym_prime] = ACTIONS(5926),
    [sym__bullet] = ACTIONS(5926),
    [sym__dedent] = ACTIONS(5926),
    [sym__double_excl] = ACTIONS(5926),
  },
  [3404] = {
    [sym_block_comment] = STATE(3404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5928),
    [anon_sym_u2208] = ACTIONS(5930),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5930),
    [anon_sym_u25a1] = ACTIONS(5930),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5930),
    [anon_sym_u2227] = ACTIONS(5930),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5930),
    [anon_sym_u2228] = ACTIONS(5930),
    [anon_sym_LBRACK] = ACTIONS(5928),
    [anon_sym_BSLASHo] = ACTIONS(5928),
    [anon_sym_DOT] = ACTIONS(5928),
    [anon_sym_EQ] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5928),
    [anon_sym_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27f9] = ACTIONS(5930),
    [anon_sym_u21d2] = ACTIONS(5930),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5930),
    [anon_sym_u21f8] = ACTIONS(5930),
    [anon_sym_u2945] = ACTIONS(5930),
    [anon_sym_BSLASHequiv] = ACTIONS(5930),
    [anon_sym_u2261] = ACTIONS(5930),
    [anon_sym_LT_EQ_GT] = ACTIONS(5930),
    [anon_sym_u27fa] = ACTIONS(5930),
    [anon_sym_u21d4] = ACTIONS(5930),
    [anon_sym_TILDE_GT] = ACTIONS(5930),
    [anon_sym_u21dd] = ACTIONS(5930),
    [anon_sym_u219d] = ACTIONS(5930),
    [anon_sym_BSLASHland] = ACTIONS(5930),
    [anon_sym_BSLASHlor] = ACTIONS(5930),
    [anon_sym_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2254] = ACTIONS(5930),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5930),
    [anon_sym_u2a74] = ACTIONS(5930),
    [anon_sym_SLASH_EQ] = ACTIONS(5930),
    [anon_sym_POUND] = ACTIONS(5928),
    [anon_sym_u2260] = ACTIONS(5930),
    [anon_sym_LT] = ACTIONS(5928),
    [sym_gt] = ACTIONS(5928),
    [anon_sym_LT_EQ] = ACTIONS(5928),
    [anon_sym_EQ_LT] = ACTIONS(5930),
    [anon_sym_BSLASHleq] = ACTIONS(5930),
    [anon_sym_u2264] = ACTIONS(5930),
    [anon_sym_GT_EQ] = ACTIONS(5930),
    [anon_sym_BSLASHgeq] = ACTIONS(5930),
    [anon_sym_u2265] = ACTIONS(5930),
    [anon_sym_BSLASHapprox] = ACTIONS(5930),
    [anon_sym_u2248] = ACTIONS(5930),
    [anon_sym_PIPE_DASH] = ACTIONS(5930),
    [anon_sym_u22a2] = ACTIONS(5930),
    [anon_sym_PIPE_EQ] = ACTIONS(5930),
    [anon_sym_u22a8] = ACTIONS(5930),
    [anon_sym_DASH_PIPE] = ACTIONS(5930),
    [anon_sym_u22a3] = ACTIONS(5930),
    [anon_sym_EQ_PIPE] = ACTIONS(5930),
    [anon_sym_u2ae4] = ACTIONS(5930),
    [anon_sym_BSLASHasymp] = ACTIONS(5930),
    [anon_sym_u224d] = ACTIONS(5930),
    [anon_sym_BSLASHcong] = ACTIONS(5930),
    [anon_sym_u2245] = ACTIONS(5930),
    [anon_sym_BSLASHdoteq] = ACTIONS(5930),
    [anon_sym_u2250] = ACTIONS(5930),
    [anon_sym_BSLASHgg] = ACTIONS(5930),
    [anon_sym_u226b] = ACTIONS(5930),
    [anon_sym_BSLASHll] = ACTIONS(5930),
    [anon_sym_u226a] = ACTIONS(5930),
    [anon_sym_BSLASHnotin] = ACTIONS(5930),
    [anon_sym_u2209] = ACTIONS(5930),
    [anon_sym_BSLASHprec] = ACTIONS(5928),
    [anon_sym_u227a] = ACTIONS(5930),
    [anon_sym_BSLASHsucc] = ACTIONS(5928),
    [anon_sym_u227b] = ACTIONS(5930),
    [anon_sym_BSLASHpreceq] = ACTIONS(5930),
    [anon_sym_u2aaf] = ACTIONS(5930),
    [anon_sym_BSLASHsucceq] = ACTIONS(5930),
    [anon_sym_u2ab0] = ACTIONS(5930),
    [anon_sym_BSLASHpropto] = ACTIONS(5930),
    [anon_sym_u221d] = ACTIONS(5930),
    [anon_sym_BSLASHsim] = ACTIONS(5928),
    [anon_sym_u223c] = ACTIONS(5930),
    [anon_sym_BSLASHsimeq] = ACTIONS(5930),
    [anon_sym_u2243] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5928),
    [anon_sym_u228f] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5928),
    [anon_sym_u2290] = ACTIONS(5930),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5930),
    [anon_sym_u2291] = ACTIONS(5930),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5930),
    [anon_sym_u2292] = ACTIONS(5930),
    [anon_sym_BSLASHsubset] = ACTIONS(5928),
    [anon_sym_u2282] = ACTIONS(5930),
    [anon_sym_BSLASHsupset] = ACTIONS(5928),
    [anon_sym_u2283] = ACTIONS(5930),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5930),
    [anon_sym_u2286] = ACTIONS(5930),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5930),
    [anon_sym_u2287] = ACTIONS(5930),
    [sym_compose] = ACTIONS(5930),
    [sym_map_to] = ACTIONS(5930),
    [sym_map_from] = ACTIONS(5930),
    [sym_setminus] = ACTIONS(5928),
    [anon_sym_BSLASHcap] = ACTIONS(5930),
    [anon_sym_BSLASHintersect] = ACTIONS(5930),
    [anon_sym_u2229] = ACTIONS(5930),
    [anon_sym_BSLASHcup] = ACTIONS(5930),
    [anon_sym_BSLASHunion] = ACTIONS(5930),
    [anon_sym_u222a] = ACTIONS(5930),
    [anon_sym_DOT_DOT] = ACTIONS(5928),
    [anon_sym_u2025] = ACTIONS(5930),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5930),
    [anon_sym_u2026] = ACTIONS(5930),
    [anon_sym_PLUS] = ACTIONS(5928),
    [sym_plusplus] = ACTIONS(5930),
    [anon_sym_BSLASHoplus] = ACTIONS(5930),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5930),
    [anon_sym_u2295] = ACTIONS(5930),
    [anon_sym_BSLASHominus] = ACTIONS(5930),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2296] = ACTIONS(5930),
    [sym_mod] = ACTIONS(5928),
    [sym_modmod] = ACTIONS(5930),
    [sym_vert] = ACTIONS(5928),
    [anon_sym_PIPE_PIPE] = ACTIONS(5930),
    [anon_sym_u2016] = ACTIONS(5930),
    [sym_minusminus] = ACTIONS(5930),
    [sym_amp] = ACTIONS(5928),
    [sym_ampamp] = ACTIONS(5930),
    [anon_sym_BSLASHodot] = ACTIONS(5930),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5930),
    [anon_sym_u2299] = ACTIONS(5930),
    [anon_sym_BSLASHoslash] = ACTIONS(5930),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5930),
    [anon_sym_u2298] = ACTIONS(5930),
    [anon_sym_BSLASHotimes] = ACTIONS(5930),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5930),
    [anon_sym_u2297] = ACTIONS(5930),
    [sym_mul] = ACTIONS(5928),
    [sym_mulmul] = ACTIONS(5930),
    [sym_slash] = ACTIONS(5928),
    [sym_slashslash] = ACTIONS(5930),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5930),
    [anon_sym_u25ef] = ACTIONS(5930),
    [anon_sym_BSLASHbullet] = ACTIONS(5930),
    [anon_sym_u25cf] = ACTIONS(5930),
    [anon_sym_BSLASHdiv] = ACTIONS(5930),
    [anon_sym_u00f7] = ACTIONS(5930),
    [anon_sym_BSLASHcirc] = ACTIONS(5930),
    [anon_sym_u2218] = ACTIONS(5930),
    [anon_sym_BSLASHstar] = ACTIONS(5930),
    [anon_sym_u22c6] = ACTIONS(5930),
    [anon_sym_u203c] = ACTIONS(5930),
    [sym_hashhash] = ACTIONS(5930),
    [sym_dol] = ACTIONS(5928),
    [sym_doldol] = ACTIONS(5930),
    [anon_sym_QMARK_QMARK] = ACTIONS(5930),
    [anon_sym_u2047] = ACTIONS(5930),
    [anon_sym_BSLASHsqcap] = ACTIONS(5930),
    [anon_sym_u2293] = ACTIONS(5930),
    [anon_sym_BSLASHsqcup] = ACTIONS(5930),
    [anon_sym_u2294] = ACTIONS(5930),
    [anon_sym_BSLASHuplus] = ACTIONS(5930),
    [anon_sym_u228e] = ACTIONS(5930),
    [anon_sym_BSLASHX] = ACTIONS(5930),
    [anon_sym_BSLASHtimes] = ACTIONS(5930),
    [anon_sym_u00d7] = ACTIONS(5930),
    [anon_sym_BSLASHwr] = ACTIONS(5930),
    [anon_sym_u2240] = ACTIONS(5930),
    [anon_sym_BSLASHcdot] = ACTIONS(5930),
    [anon_sym_u22c5] = ACTIONS(5930),
    [sym_pow] = ACTIONS(5928),
    [sym_powpow] = ACTIONS(5930),
    [anon_sym_CARET_PLUS] = ACTIONS(5930),
    [anon_sym_u207a] = ACTIONS(5930),
    [sym_asterisk] = ACTIONS(5930),
    [sym_sup_hash] = ACTIONS(5930),
    [sym_prime] = ACTIONS(5930),
    [sym__bullet] = ACTIONS(5930),
    [sym__dedent] = ACTIONS(5930),
    [sym__double_excl] = ACTIONS(5930),
  },
  [3405] = {
    [sym_block_comment] = STATE(3405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5932),
    [anon_sym_u2208] = ACTIONS(5934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5934),
    [anon_sym_u25a1] = ACTIONS(5934),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5934),
    [anon_sym_u2227] = ACTIONS(5934),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5934),
    [anon_sym_u2228] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5932),
    [anon_sym_BSLASHo] = ACTIONS(5932),
    [anon_sym_DOT] = ACTIONS(5932),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27f9] = ACTIONS(5934),
    [anon_sym_u21d2] = ACTIONS(5934),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5934),
    [anon_sym_u21f8] = ACTIONS(5934),
    [anon_sym_u2945] = ACTIONS(5934),
    [anon_sym_BSLASHequiv] = ACTIONS(5934),
    [anon_sym_u2261] = ACTIONS(5934),
    [anon_sym_LT_EQ_GT] = ACTIONS(5934),
    [anon_sym_u27fa] = ACTIONS(5934),
    [anon_sym_u21d4] = ACTIONS(5934),
    [anon_sym_TILDE_GT] = ACTIONS(5934),
    [anon_sym_u21dd] = ACTIONS(5934),
    [anon_sym_u219d] = ACTIONS(5934),
    [anon_sym_BSLASHland] = ACTIONS(5934),
    [anon_sym_BSLASHlor] = ACTIONS(5934),
    [anon_sym_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2254] = ACTIONS(5934),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5934),
    [anon_sym_u2a74] = ACTIONS(5934),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_POUND] = ACTIONS(5932),
    [anon_sym_u2260] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [sym_gt] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5932),
    [anon_sym_EQ_LT] = ACTIONS(5934),
    [anon_sym_BSLASHleq] = ACTIONS(5934),
    [anon_sym_u2264] = ACTIONS(5934),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_BSLASHgeq] = ACTIONS(5934),
    [anon_sym_u2265] = ACTIONS(5934),
    [anon_sym_BSLASHapprox] = ACTIONS(5934),
    [anon_sym_u2248] = ACTIONS(5934),
    [anon_sym_PIPE_DASH] = ACTIONS(5934),
    [anon_sym_u22a2] = ACTIONS(5934),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_u22a8] = ACTIONS(5934),
    [anon_sym_DASH_PIPE] = ACTIONS(5934),
    [anon_sym_u22a3] = ACTIONS(5934),
    [anon_sym_EQ_PIPE] = ACTIONS(5934),
    [anon_sym_u2ae4] = ACTIONS(5934),
    [anon_sym_BSLASHasymp] = ACTIONS(5934),
    [anon_sym_u224d] = ACTIONS(5934),
    [anon_sym_BSLASHcong] = ACTIONS(5934),
    [anon_sym_u2245] = ACTIONS(5934),
    [anon_sym_BSLASHdoteq] = ACTIONS(5934),
    [anon_sym_u2250] = ACTIONS(5934),
    [anon_sym_BSLASHgg] = ACTIONS(5934),
    [anon_sym_u226b] = ACTIONS(5934),
    [anon_sym_BSLASHll] = ACTIONS(5934),
    [anon_sym_u226a] = ACTIONS(5934),
    [anon_sym_BSLASHnotin] = ACTIONS(5934),
    [anon_sym_u2209] = ACTIONS(5934),
    [anon_sym_BSLASHprec] = ACTIONS(5932),
    [anon_sym_u227a] = ACTIONS(5934),
    [anon_sym_BSLASHsucc] = ACTIONS(5932),
    [anon_sym_u227b] = ACTIONS(5934),
    [anon_sym_BSLASHpreceq] = ACTIONS(5934),
    [anon_sym_u2aaf] = ACTIONS(5934),
    [anon_sym_BSLASHsucceq] = ACTIONS(5934),
    [anon_sym_u2ab0] = ACTIONS(5934),
    [anon_sym_BSLASHpropto] = ACTIONS(5934),
    [anon_sym_u221d] = ACTIONS(5934),
    [anon_sym_BSLASHsim] = ACTIONS(5932),
    [anon_sym_u223c] = ACTIONS(5934),
    [anon_sym_BSLASHsimeq] = ACTIONS(5934),
    [anon_sym_u2243] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5932),
    [anon_sym_u228f] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5932),
    [anon_sym_u2290] = ACTIONS(5934),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5934),
    [anon_sym_u2291] = ACTIONS(5934),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5934),
    [anon_sym_u2292] = ACTIONS(5934),
    [anon_sym_BSLASHsubset] = ACTIONS(5932),
    [anon_sym_u2282] = ACTIONS(5934),
    [anon_sym_BSLASHsupset] = ACTIONS(5932),
    [anon_sym_u2283] = ACTIONS(5934),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5934),
    [anon_sym_u2286] = ACTIONS(5934),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5934),
    [anon_sym_u2287] = ACTIONS(5934),
    [sym_compose] = ACTIONS(5934),
    [sym_map_to] = ACTIONS(5934),
    [sym_map_from] = ACTIONS(5934),
    [sym_setminus] = ACTIONS(5932),
    [anon_sym_BSLASHcap] = ACTIONS(5934),
    [anon_sym_BSLASHintersect] = ACTIONS(5934),
    [anon_sym_u2229] = ACTIONS(5934),
    [anon_sym_BSLASHcup] = ACTIONS(5934),
    [anon_sym_BSLASHunion] = ACTIONS(5934),
    [anon_sym_u222a] = ACTIONS(5934),
    [anon_sym_DOT_DOT] = ACTIONS(5932),
    [anon_sym_u2025] = ACTIONS(5934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5934),
    [anon_sym_u2026] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [sym_plusplus] = ACTIONS(5934),
    [anon_sym_BSLASHoplus] = ACTIONS(5934),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5934),
    [anon_sym_u2295] = ACTIONS(5934),
    [anon_sym_BSLASHominus] = ACTIONS(5934),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2296] = ACTIONS(5934),
    [sym_mod] = ACTIONS(5932),
    [sym_modmod] = ACTIONS(5934),
    [sym_vert] = ACTIONS(5932),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_u2016] = ACTIONS(5934),
    [sym_minusminus] = ACTIONS(5934),
    [sym_amp] = ACTIONS(5932),
    [sym_ampamp] = ACTIONS(5934),
    [anon_sym_BSLASHodot] = ACTIONS(5934),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5934),
    [anon_sym_u2299] = ACTIONS(5934),
    [anon_sym_BSLASHoslash] = ACTIONS(5934),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5934),
    [anon_sym_u2298] = ACTIONS(5934),
    [anon_sym_BSLASHotimes] = ACTIONS(5934),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5934),
    [anon_sym_u2297] = ACTIONS(5934),
    [sym_mul] = ACTIONS(5932),
    [sym_mulmul] = ACTIONS(5934),
    [sym_slash] = ACTIONS(5932),
    [sym_slashslash] = ACTIONS(5934),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5934),
    [anon_sym_u25ef] = ACTIONS(5934),
    [anon_sym_BSLASHbullet] = ACTIONS(5934),
    [anon_sym_u25cf] = ACTIONS(5934),
    [anon_sym_BSLASHdiv] = ACTIONS(5934),
    [anon_sym_u00f7] = ACTIONS(5934),
    [anon_sym_BSLASHcirc] = ACTIONS(5934),
    [anon_sym_u2218] = ACTIONS(5934),
    [anon_sym_BSLASHstar] = ACTIONS(5934),
    [anon_sym_u22c6] = ACTIONS(5934),
    [anon_sym_u203c] = ACTIONS(5934),
    [sym_hashhash] = ACTIONS(5934),
    [sym_dol] = ACTIONS(5932),
    [sym_doldol] = ACTIONS(5934),
    [anon_sym_QMARK_QMARK] = ACTIONS(5934),
    [anon_sym_u2047] = ACTIONS(5934),
    [anon_sym_BSLASHsqcap] = ACTIONS(5934),
    [anon_sym_u2293] = ACTIONS(5934),
    [anon_sym_BSLASHsqcup] = ACTIONS(5934),
    [anon_sym_u2294] = ACTIONS(5934),
    [anon_sym_BSLASHuplus] = ACTIONS(5934),
    [anon_sym_u228e] = ACTIONS(5934),
    [anon_sym_BSLASHX] = ACTIONS(5934),
    [anon_sym_BSLASHtimes] = ACTIONS(5934),
    [anon_sym_u00d7] = ACTIONS(5934),
    [anon_sym_BSLASHwr] = ACTIONS(5934),
    [anon_sym_u2240] = ACTIONS(5934),
    [anon_sym_BSLASHcdot] = ACTIONS(5934),
    [anon_sym_u22c5] = ACTIONS(5934),
    [sym_pow] = ACTIONS(5932),
    [sym_powpow] = ACTIONS(5934),
    [anon_sym_CARET_PLUS] = ACTIONS(5934),
    [anon_sym_u207a] = ACTIONS(5934),
    [sym_asterisk] = ACTIONS(5934),
    [sym_sup_hash] = ACTIONS(5934),
    [sym_prime] = ACTIONS(5934),
    [sym__bullet] = ACTIONS(5934),
    [sym__dedent] = ACTIONS(5934),
    [sym__double_excl] = ACTIONS(5934),
  },
  [3406] = {
    [sym_block_comment] = STATE(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5828),
    [anon_sym_u2208] = ACTIONS(5826),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5826),
    [anon_sym_u25a1] = ACTIONS(5826),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5826),
    [anon_sym_u2227] = ACTIONS(5826),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5826),
    [anon_sym_u2228] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5828),
    [anon_sym_BSLASHo] = ACTIONS(5828),
    [anon_sym_DOT] = ACTIONS(5828),
    [anon_sym_EQ] = ACTIONS(5828),
    [anon_sym_DASH] = ACTIONS(5828),
    [anon_sym_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27f9] = ACTIONS(5826),
    [anon_sym_u21d2] = ACTIONS(5826),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5826),
    [anon_sym_u21f8] = ACTIONS(5826),
    [anon_sym_u2945] = ACTIONS(5826),
    [anon_sym_BSLASHequiv] = ACTIONS(5826),
    [anon_sym_u2261] = ACTIONS(5826),
    [anon_sym_LT_EQ_GT] = ACTIONS(5826),
    [anon_sym_u27fa] = ACTIONS(5826),
    [anon_sym_u21d4] = ACTIONS(5826),
    [anon_sym_TILDE_GT] = ACTIONS(5826),
    [anon_sym_u21dd] = ACTIONS(5826),
    [anon_sym_u219d] = ACTIONS(5826),
    [anon_sym_BSLASHland] = ACTIONS(5826),
    [anon_sym_BSLASHlor] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2254] = ACTIONS(5826),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5826),
    [anon_sym_u2a74] = ACTIONS(5826),
    [anon_sym_SLASH_EQ] = ACTIONS(5826),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_u2260] = ACTIONS(5826),
    [anon_sym_LT] = ACTIONS(5828),
    [sym_gt] = ACTIONS(5828),
    [anon_sym_LT_EQ] = ACTIONS(5828),
    [anon_sym_EQ_LT] = ACTIONS(5826),
    [anon_sym_BSLASHleq] = ACTIONS(5826),
    [anon_sym_u2264] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5826),
    [anon_sym_BSLASHgeq] = ACTIONS(5826),
    [anon_sym_u2265] = ACTIONS(5826),
    [anon_sym_BSLASHapprox] = ACTIONS(5826),
    [anon_sym_u2248] = ACTIONS(5826),
    [anon_sym_PIPE_DASH] = ACTIONS(5826),
    [anon_sym_u22a2] = ACTIONS(5826),
    [anon_sym_PIPE_EQ] = ACTIONS(5826),
    [anon_sym_u22a8] = ACTIONS(5826),
    [anon_sym_DASH_PIPE] = ACTIONS(5826),
    [anon_sym_u22a3] = ACTIONS(5826),
    [anon_sym_EQ_PIPE] = ACTIONS(5826),
    [anon_sym_u2ae4] = ACTIONS(5826),
    [anon_sym_BSLASHasymp] = ACTIONS(5826),
    [anon_sym_u224d] = ACTIONS(5826),
    [anon_sym_BSLASHcong] = ACTIONS(5826),
    [anon_sym_u2245] = ACTIONS(5826),
    [anon_sym_BSLASHdoteq] = ACTIONS(5826),
    [anon_sym_u2250] = ACTIONS(5826),
    [anon_sym_BSLASHgg] = ACTIONS(5826),
    [anon_sym_u226b] = ACTIONS(5826),
    [anon_sym_BSLASHll] = ACTIONS(5826),
    [anon_sym_u226a] = ACTIONS(5826),
    [anon_sym_BSLASHnotin] = ACTIONS(5826),
    [anon_sym_u2209] = ACTIONS(5826),
    [anon_sym_BSLASHprec] = ACTIONS(5828),
    [anon_sym_u227a] = ACTIONS(5826),
    [anon_sym_BSLASHsucc] = ACTIONS(5828),
    [anon_sym_u227b] = ACTIONS(5826),
    [anon_sym_BSLASHpreceq] = ACTIONS(5826),
    [anon_sym_u2aaf] = ACTIONS(5826),
    [anon_sym_BSLASHsucceq] = ACTIONS(5826),
    [anon_sym_u2ab0] = ACTIONS(5826),
    [anon_sym_BSLASHpropto] = ACTIONS(5826),
    [anon_sym_u221d] = ACTIONS(5826),
    [anon_sym_BSLASHsim] = ACTIONS(5828),
    [anon_sym_u223c] = ACTIONS(5826),
    [anon_sym_BSLASHsimeq] = ACTIONS(5826),
    [anon_sym_u2243] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5828),
    [anon_sym_u228f] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5828),
    [anon_sym_u2290] = ACTIONS(5826),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5826),
    [anon_sym_u2291] = ACTIONS(5826),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5826),
    [anon_sym_u2292] = ACTIONS(5826),
    [anon_sym_BSLASHsubset] = ACTIONS(5828),
    [anon_sym_u2282] = ACTIONS(5826),
    [anon_sym_BSLASHsupset] = ACTIONS(5828),
    [anon_sym_u2283] = ACTIONS(5826),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5826),
    [anon_sym_u2286] = ACTIONS(5826),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5826),
    [anon_sym_u2287] = ACTIONS(5826),
    [sym_compose] = ACTIONS(5826),
    [sym_map_to] = ACTIONS(5826),
    [sym_map_from] = ACTIONS(5826),
    [sym_setminus] = ACTIONS(5828),
    [anon_sym_BSLASHcap] = ACTIONS(5826),
    [anon_sym_BSLASHintersect] = ACTIONS(5826),
    [anon_sym_u2229] = ACTIONS(5826),
    [anon_sym_BSLASHcup] = ACTIONS(5826),
    [anon_sym_BSLASHunion] = ACTIONS(5826),
    [anon_sym_u222a] = ACTIONS(5826),
    [anon_sym_DOT_DOT] = ACTIONS(5828),
    [anon_sym_u2025] = ACTIONS(5826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5826),
    [anon_sym_u2026] = ACTIONS(5826),
    [anon_sym_PLUS] = ACTIONS(5828),
    [sym_plusplus] = ACTIONS(5826),
    [anon_sym_BSLASHoplus] = ACTIONS(5826),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5826),
    [anon_sym_u2295] = ACTIONS(5826),
    [anon_sym_BSLASHominus] = ACTIONS(5826),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2296] = ACTIONS(5826),
    [sym_mod] = ACTIONS(5828),
    [sym_modmod] = ACTIONS(5826),
    [sym_vert] = ACTIONS(5828),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_u2016] = ACTIONS(5826),
    [sym_minusminus] = ACTIONS(5826),
    [sym_amp] = ACTIONS(5828),
    [sym_ampamp] = ACTIONS(5826),
    [anon_sym_BSLASHodot] = ACTIONS(5826),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5826),
    [anon_sym_u2299] = ACTIONS(5826),
    [anon_sym_BSLASHoslash] = ACTIONS(5826),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5826),
    [anon_sym_u2298] = ACTIONS(5826),
    [anon_sym_BSLASHotimes] = ACTIONS(5826),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5826),
    [anon_sym_u2297] = ACTIONS(5826),
    [sym_mul] = ACTIONS(5828),
    [sym_mulmul] = ACTIONS(5826),
    [sym_slash] = ACTIONS(5828),
    [sym_slashslash] = ACTIONS(5826),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5826),
    [anon_sym_u25ef] = ACTIONS(5826),
    [anon_sym_BSLASHbullet] = ACTIONS(5826),
    [anon_sym_u25cf] = ACTIONS(5826),
    [anon_sym_BSLASHdiv] = ACTIONS(5826),
    [anon_sym_u00f7] = ACTIONS(5826),
    [anon_sym_BSLASHcirc] = ACTIONS(5826),
    [anon_sym_u2218] = ACTIONS(5826),
    [anon_sym_BSLASHstar] = ACTIONS(5826),
    [anon_sym_u22c6] = ACTIONS(5826),
    [anon_sym_u203c] = ACTIONS(5826),
    [sym_hashhash] = ACTIONS(5826),
    [sym_dol] = ACTIONS(5828),
    [sym_doldol] = ACTIONS(5826),
    [anon_sym_QMARK_QMARK] = ACTIONS(5826),
    [anon_sym_u2047] = ACTIONS(5826),
    [anon_sym_BSLASHsqcap] = ACTIONS(5826),
    [anon_sym_u2293] = ACTIONS(5826),
    [anon_sym_BSLASHsqcup] = ACTIONS(5826),
    [anon_sym_u2294] = ACTIONS(5826),
    [anon_sym_BSLASHuplus] = ACTIONS(5826),
    [anon_sym_u228e] = ACTIONS(5826),
    [anon_sym_BSLASHX] = ACTIONS(5826),
    [anon_sym_BSLASHtimes] = ACTIONS(5826),
    [anon_sym_u00d7] = ACTIONS(5826),
    [anon_sym_BSLASHwr] = ACTIONS(5826),
    [anon_sym_u2240] = ACTIONS(5826),
    [anon_sym_BSLASHcdot] = ACTIONS(5826),
    [anon_sym_u22c5] = ACTIONS(5826),
    [sym_pow] = ACTIONS(5828),
    [sym_powpow] = ACTIONS(5826),
    [anon_sym_CARET_PLUS] = ACTIONS(5826),
    [anon_sym_u207a] = ACTIONS(5826),
    [sym_asterisk] = ACTIONS(5826),
    [sym_sup_hash] = ACTIONS(5826),
    [sym_prime] = ACTIONS(5826),
    [sym__bullet] = ACTIONS(5826),
    [sym__dedent] = ACTIONS(5826),
    [sym__double_excl] = ACTIONS(5826),
  },
  [3407] = {
    [sym_block_comment] = STATE(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5742),
    [anon_sym_u2208] = ACTIONS(5740),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5740),
    [anon_sym_u25a1] = ACTIONS(5740),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5740),
    [anon_sym_u2227] = ACTIONS(5740),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5740),
    [anon_sym_u2228] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(5742),
    [anon_sym_BSLASHo] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5742),
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_DASH] = ACTIONS(5742),
    [anon_sym_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27f9] = ACTIONS(5740),
    [anon_sym_u21d2] = ACTIONS(5740),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5740),
    [anon_sym_u21f8] = ACTIONS(5740),
    [anon_sym_u2945] = ACTIONS(5740),
    [anon_sym_BSLASHequiv] = ACTIONS(5740),
    [anon_sym_u2261] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5740),
    [anon_sym_u27fa] = ACTIONS(5740),
    [anon_sym_u21d4] = ACTIONS(5740),
    [anon_sym_TILDE_GT] = ACTIONS(5740),
    [anon_sym_u21dd] = ACTIONS(5740),
    [anon_sym_u219d] = ACTIONS(5740),
    [anon_sym_BSLASHland] = ACTIONS(5740),
    [anon_sym_BSLASHlor] = ACTIONS(5740),
    [anon_sym_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2254] = ACTIONS(5740),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5740),
    [anon_sym_u2a74] = ACTIONS(5740),
    [anon_sym_SLASH_EQ] = ACTIONS(5740),
    [anon_sym_POUND] = ACTIONS(5742),
    [anon_sym_u2260] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5742),
    [sym_gt] = ACTIONS(5742),
    [anon_sym_LT_EQ] = ACTIONS(5742),
    [anon_sym_EQ_LT] = ACTIONS(5740),
    [anon_sym_BSLASHleq] = ACTIONS(5740),
    [anon_sym_u2264] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_BSLASHgeq] = ACTIONS(5740),
    [anon_sym_u2265] = ACTIONS(5740),
    [anon_sym_BSLASHapprox] = ACTIONS(5740),
    [anon_sym_u2248] = ACTIONS(5740),
    [anon_sym_PIPE_DASH] = ACTIONS(5740),
    [anon_sym_u22a2] = ACTIONS(5740),
    [anon_sym_PIPE_EQ] = ACTIONS(5740),
    [anon_sym_u22a8] = ACTIONS(5740),
    [anon_sym_DASH_PIPE] = ACTIONS(5740),
    [anon_sym_u22a3] = ACTIONS(5740),
    [anon_sym_EQ_PIPE] = ACTIONS(5740),
    [anon_sym_u2ae4] = ACTIONS(5740),
    [anon_sym_BSLASHasymp] = ACTIONS(5740),
    [anon_sym_u224d] = ACTIONS(5740),
    [anon_sym_BSLASHcong] = ACTIONS(5740),
    [anon_sym_u2245] = ACTIONS(5740),
    [anon_sym_BSLASHdoteq] = ACTIONS(5740),
    [anon_sym_u2250] = ACTIONS(5740),
    [anon_sym_BSLASHgg] = ACTIONS(5740),
    [anon_sym_u226b] = ACTIONS(5740),
    [anon_sym_BSLASHll] = ACTIONS(5740),
    [anon_sym_u226a] = ACTIONS(5740),
    [anon_sym_BSLASHnotin] = ACTIONS(5740),
    [anon_sym_u2209] = ACTIONS(5740),
    [anon_sym_BSLASHprec] = ACTIONS(5742),
    [anon_sym_u227a] = ACTIONS(5740),
    [anon_sym_BSLASHsucc] = ACTIONS(5742),
    [anon_sym_u227b] = ACTIONS(5740),
    [anon_sym_BSLASHpreceq] = ACTIONS(5740),
    [anon_sym_u2aaf] = ACTIONS(5740),
    [anon_sym_BSLASHsucceq] = ACTIONS(5740),
    [anon_sym_u2ab0] = ACTIONS(5740),
    [anon_sym_BSLASHpropto] = ACTIONS(5740),
    [anon_sym_u221d] = ACTIONS(5740),
    [anon_sym_BSLASHsim] = ACTIONS(5742),
    [anon_sym_u223c] = ACTIONS(5740),
    [anon_sym_BSLASHsimeq] = ACTIONS(5740),
    [anon_sym_u2243] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5742),
    [anon_sym_u228f] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5742),
    [anon_sym_u2290] = ACTIONS(5740),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5740),
    [anon_sym_u2291] = ACTIONS(5740),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5740),
    [anon_sym_u2292] = ACTIONS(5740),
    [anon_sym_BSLASHsubset] = ACTIONS(5742),
    [anon_sym_u2282] = ACTIONS(5740),
    [anon_sym_BSLASHsupset] = ACTIONS(5742),
    [anon_sym_u2283] = ACTIONS(5740),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5740),
    [anon_sym_u2286] = ACTIONS(5740),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5740),
    [anon_sym_u2287] = ACTIONS(5740),
    [sym_compose] = ACTIONS(5740),
    [sym_map_to] = ACTIONS(5740),
    [sym_map_from] = ACTIONS(5740),
    [sym_setminus] = ACTIONS(5742),
    [anon_sym_BSLASHcap] = ACTIONS(5740),
    [anon_sym_BSLASHintersect] = ACTIONS(5740),
    [anon_sym_u2229] = ACTIONS(5740),
    [anon_sym_BSLASHcup] = ACTIONS(5740),
    [anon_sym_BSLASHunion] = ACTIONS(5740),
    [anon_sym_u222a] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5742),
    [anon_sym_u2025] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5740),
    [anon_sym_u2026] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5742),
    [sym_plusplus] = ACTIONS(5740),
    [anon_sym_BSLASHoplus] = ACTIONS(5740),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5740),
    [anon_sym_u2295] = ACTIONS(5740),
    [anon_sym_BSLASHominus] = ACTIONS(5740),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2296] = ACTIONS(5740),
    [sym_mod] = ACTIONS(5742),
    [sym_modmod] = ACTIONS(5740),
    [sym_vert] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_u2016] = ACTIONS(5740),
    [sym_minusminus] = ACTIONS(5740),
    [sym_amp] = ACTIONS(5742),
    [sym_ampamp] = ACTIONS(5740),
    [anon_sym_BSLASHodot] = ACTIONS(5740),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5740),
    [anon_sym_u2299] = ACTIONS(5740),
    [anon_sym_BSLASHoslash] = ACTIONS(5740),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5740),
    [anon_sym_u2298] = ACTIONS(5740),
    [anon_sym_BSLASHotimes] = ACTIONS(5740),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5740),
    [anon_sym_u2297] = ACTIONS(5740),
    [sym_mul] = ACTIONS(5742),
    [sym_mulmul] = ACTIONS(5740),
    [sym_slash] = ACTIONS(5742),
    [sym_slashslash] = ACTIONS(5740),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5740),
    [anon_sym_u25ef] = ACTIONS(5740),
    [anon_sym_BSLASHbullet] = ACTIONS(5740),
    [anon_sym_u25cf] = ACTIONS(5740),
    [anon_sym_BSLASHdiv] = ACTIONS(5740),
    [anon_sym_u00f7] = ACTIONS(5740),
    [anon_sym_BSLASHcirc] = ACTIONS(5740),
    [anon_sym_u2218] = ACTIONS(5740),
    [anon_sym_BSLASHstar] = ACTIONS(5740),
    [anon_sym_u22c6] = ACTIONS(5740),
    [anon_sym_u203c] = ACTIONS(5740),
    [sym_hashhash] = ACTIONS(5740),
    [sym_dol] = ACTIONS(5742),
    [sym_doldol] = ACTIONS(5740),
    [anon_sym_QMARK_QMARK] = ACTIONS(5740),
    [anon_sym_u2047] = ACTIONS(5740),
    [anon_sym_BSLASHsqcap] = ACTIONS(5740),
    [anon_sym_u2293] = ACTIONS(5740),
    [anon_sym_BSLASHsqcup] = ACTIONS(5740),
    [anon_sym_u2294] = ACTIONS(5740),
    [anon_sym_BSLASHuplus] = ACTIONS(5740),
    [anon_sym_u228e] = ACTIONS(5740),
    [anon_sym_BSLASHX] = ACTIONS(5740),
    [anon_sym_BSLASHtimes] = ACTIONS(5740),
    [anon_sym_u00d7] = ACTIONS(5740),
    [anon_sym_BSLASHwr] = ACTIONS(5740),
    [anon_sym_u2240] = ACTIONS(5740),
    [anon_sym_BSLASHcdot] = ACTIONS(5740),
    [anon_sym_u22c5] = ACTIONS(5740),
    [sym_pow] = ACTIONS(5742),
    [sym_powpow] = ACTIONS(5740),
    [anon_sym_CARET_PLUS] = ACTIONS(5740),
    [anon_sym_u207a] = ACTIONS(5740),
    [sym_asterisk] = ACTIONS(5740),
    [sym_sup_hash] = ACTIONS(5740),
    [sym_prime] = ACTIONS(5740),
    [sym__bullet] = ACTIONS(5740),
    [sym__dedent] = ACTIONS(5740),
    [sym__double_excl] = ACTIONS(5740),
  },
  [3408] = {
    [sym_block_comment] = STATE(3408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5800),
    [anon_sym_u2208] = ACTIONS(5798),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5798),
    [anon_sym_u25a1] = ACTIONS(5798),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5798),
    [anon_sym_u2227] = ACTIONS(5798),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5798),
    [anon_sym_u2228] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5800),
    [anon_sym_BSLASHo] = ACTIONS(5800),
    [anon_sym_DOT] = ACTIONS(5800),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27f9] = ACTIONS(5798),
    [anon_sym_u21d2] = ACTIONS(5798),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5798),
    [anon_sym_u21f8] = ACTIONS(5798),
    [anon_sym_u2945] = ACTIONS(5798),
    [anon_sym_BSLASHequiv] = ACTIONS(5798),
    [anon_sym_u2261] = ACTIONS(5798),
    [anon_sym_LT_EQ_GT] = ACTIONS(5798),
    [anon_sym_u27fa] = ACTIONS(5798),
    [anon_sym_u21d4] = ACTIONS(5798),
    [anon_sym_TILDE_GT] = ACTIONS(5798),
    [anon_sym_u21dd] = ACTIONS(5798),
    [anon_sym_u219d] = ACTIONS(5798),
    [anon_sym_BSLASHland] = ACTIONS(5798),
    [anon_sym_BSLASHlor] = ACTIONS(5798),
    [anon_sym_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2254] = ACTIONS(5798),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5798),
    [anon_sym_u2a74] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5800),
    [anon_sym_u2260] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5800),
    [sym_gt] = ACTIONS(5800),
    [anon_sym_LT_EQ] = ACTIONS(5800),
    [anon_sym_EQ_LT] = ACTIONS(5798),
    [anon_sym_BSLASHleq] = ACTIONS(5798),
    [anon_sym_u2264] = ACTIONS(5798),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_BSLASHgeq] = ACTIONS(5798),
    [anon_sym_u2265] = ACTIONS(5798),
    [anon_sym_BSLASHapprox] = ACTIONS(5798),
    [anon_sym_u2248] = ACTIONS(5798),
    [anon_sym_PIPE_DASH] = ACTIONS(5798),
    [anon_sym_u22a2] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_u22a8] = ACTIONS(5798),
    [anon_sym_DASH_PIPE] = ACTIONS(5798),
    [anon_sym_u22a3] = ACTIONS(5798),
    [anon_sym_EQ_PIPE] = ACTIONS(5798),
    [anon_sym_u2ae4] = ACTIONS(5798),
    [anon_sym_BSLASHasymp] = ACTIONS(5798),
    [anon_sym_u224d] = ACTIONS(5798),
    [anon_sym_BSLASHcong] = ACTIONS(5798),
    [anon_sym_u2245] = ACTIONS(5798),
    [anon_sym_BSLASHdoteq] = ACTIONS(5798),
    [anon_sym_u2250] = ACTIONS(5798),
    [anon_sym_BSLASHgg] = ACTIONS(5798),
    [anon_sym_u226b] = ACTIONS(5798),
    [anon_sym_BSLASHll] = ACTIONS(5798),
    [anon_sym_u226a] = ACTIONS(5798),
    [anon_sym_BSLASHnotin] = ACTIONS(5798),
    [anon_sym_u2209] = ACTIONS(5798),
    [anon_sym_BSLASHprec] = ACTIONS(5800),
    [anon_sym_u227a] = ACTIONS(5798),
    [anon_sym_BSLASHsucc] = ACTIONS(5800),
    [anon_sym_u227b] = ACTIONS(5798),
    [anon_sym_BSLASHpreceq] = ACTIONS(5798),
    [anon_sym_u2aaf] = ACTIONS(5798),
    [anon_sym_BSLASHsucceq] = ACTIONS(5798),
    [anon_sym_u2ab0] = ACTIONS(5798),
    [anon_sym_BSLASHpropto] = ACTIONS(5798),
    [anon_sym_u221d] = ACTIONS(5798),
    [anon_sym_BSLASHsim] = ACTIONS(5800),
    [anon_sym_u223c] = ACTIONS(5798),
    [anon_sym_BSLASHsimeq] = ACTIONS(5798),
    [anon_sym_u2243] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5800),
    [anon_sym_u228f] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5800),
    [anon_sym_u2290] = ACTIONS(5798),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5798),
    [anon_sym_u2291] = ACTIONS(5798),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5798),
    [anon_sym_u2292] = ACTIONS(5798),
    [anon_sym_BSLASHsubset] = ACTIONS(5800),
    [anon_sym_u2282] = ACTIONS(5798),
    [anon_sym_BSLASHsupset] = ACTIONS(5800),
    [anon_sym_u2283] = ACTIONS(5798),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5798),
    [anon_sym_u2286] = ACTIONS(5798),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5798),
    [anon_sym_u2287] = ACTIONS(5798),
    [sym_compose] = ACTIONS(5798),
    [sym_map_to] = ACTIONS(5798),
    [sym_map_from] = ACTIONS(5798),
    [sym_setminus] = ACTIONS(5800),
    [anon_sym_BSLASHcap] = ACTIONS(5798),
    [anon_sym_BSLASHintersect] = ACTIONS(5798),
    [anon_sym_u2229] = ACTIONS(5798),
    [anon_sym_BSLASHcup] = ACTIONS(5798),
    [anon_sym_BSLASHunion] = ACTIONS(5798),
    [anon_sym_u222a] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5800),
    [anon_sym_u2025] = ACTIONS(5798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_u2026] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(5800),
    [sym_plusplus] = ACTIONS(5798),
    [anon_sym_BSLASHoplus] = ACTIONS(5798),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5798),
    [anon_sym_u2295] = ACTIONS(5798),
    [anon_sym_BSLASHominus] = ACTIONS(5798),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2296] = ACTIONS(5798),
    [sym_mod] = ACTIONS(5800),
    [sym_modmod] = ACTIONS(5798),
    [sym_vert] = ACTIONS(5800),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_u2016] = ACTIONS(5798),
    [sym_minusminus] = ACTIONS(5798),
    [sym_amp] = ACTIONS(5800),
    [sym_ampamp] = ACTIONS(5798),
    [anon_sym_BSLASHodot] = ACTIONS(5798),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5798),
    [anon_sym_u2299] = ACTIONS(5798),
    [anon_sym_BSLASHoslash] = ACTIONS(5798),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5798),
    [anon_sym_u2298] = ACTIONS(5798),
    [anon_sym_BSLASHotimes] = ACTIONS(5798),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5798),
    [anon_sym_u2297] = ACTIONS(5798),
    [sym_mul] = ACTIONS(5800),
    [sym_mulmul] = ACTIONS(5798),
    [sym_slash] = ACTIONS(5800),
    [sym_slashslash] = ACTIONS(5798),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5798),
    [anon_sym_u25ef] = ACTIONS(5798),
    [anon_sym_BSLASHbullet] = ACTIONS(5798),
    [anon_sym_u25cf] = ACTIONS(5798),
    [anon_sym_BSLASHdiv] = ACTIONS(5798),
    [anon_sym_u00f7] = ACTIONS(5798),
    [anon_sym_BSLASHcirc] = ACTIONS(5798),
    [anon_sym_u2218] = ACTIONS(5798),
    [anon_sym_BSLASHstar] = ACTIONS(5798),
    [anon_sym_u22c6] = ACTIONS(5798),
    [anon_sym_u203c] = ACTIONS(5798),
    [sym_hashhash] = ACTIONS(5798),
    [sym_dol] = ACTIONS(5800),
    [sym_doldol] = ACTIONS(5798),
    [anon_sym_QMARK_QMARK] = ACTIONS(5798),
    [anon_sym_u2047] = ACTIONS(5798),
    [anon_sym_BSLASHsqcap] = ACTIONS(5798),
    [anon_sym_u2293] = ACTIONS(5798),
    [anon_sym_BSLASHsqcup] = ACTIONS(5798),
    [anon_sym_u2294] = ACTIONS(5798),
    [anon_sym_BSLASHuplus] = ACTIONS(5798),
    [anon_sym_u228e] = ACTIONS(5798),
    [anon_sym_BSLASHX] = ACTIONS(5798),
    [anon_sym_BSLASHtimes] = ACTIONS(5798),
    [anon_sym_u00d7] = ACTIONS(5798),
    [anon_sym_BSLASHwr] = ACTIONS(5798),
    [anon_sym_u2240] = ACTIONS(5798),
    [anon_sym_BSLASHcdot] = ACTIONS(5798),
    [anon_sym_u22c5] = ACTIONS(5798),
    [sym_pow] = ACTIONS(5800),
    [sym_powpow] = ACTIONS(5798),
    [anon_sym_CARET_PLUS] = ACTIONS(5798),
    [anon_sym_u207a] = ACTIONS(5798),
    [sym_asterisk] = ACTIONS(5798),
    [sym_sup_hash] = ACTIONS(5798),
    [sym_prime] = ACTIONS(5798),
    [sym__bullet] = ACTIONS(5798),
    [sym__dedent] = ACTIONS(5798),
    [sym__double_excl] = ACTIONS(5798),
  },
  [3409] = {
    [sym_block_comment] = STATE(3409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5812),
    [anon_sym_u2208] = ACTIONS(5810),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5810),
    [anon_sym_u25a1] = ACTIONS(5810),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5810),
    [anon_sym_u2227] = ACTIONS(5810),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5810),
    [anon_sym_u2228] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5812),
    [anon_sym_BSLASHo] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27f9] = ACTIONS(5810),
    [anon_sym_u21d2] = ACTIONS(5810),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5810),
    [anon_sym_u21f8] = ACTIONS(5810),
    [anon_sym_u2945] = ACTIONS(5810),
    [anon_sym_BSLASHequiv] = ACTIONS(5810),
    [anon_sym_u2261] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_u27fa] = ACTIONS(5810),
    [anon_sym_u21d4] = ACTIONS(5810),
    [anon_sym_TILDE_GT] = ACTIONS(5810),
    [anon_sym_u21dd] = ACTIONS(5810),
    [anon_sym_u219d] = ACTIONS(5810),
    [anon_sym_BSLASHland] = ACTIONS(5810),
    [anon_sym_BSLASHlor] = ACTIONS(5810),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2254] = ACTIONS(5810),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5810),
    [anon_sym_u2a74] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_POUND] = ACTIONS(5812),
    [anon_sym_u2260] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [sym_gt] = ACTIONS(5812),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_EQ_LT] = ACTIONS(5810),
    [anon_sym_BSLASHleq] = ACTIONS(5810),
    [anon_sym_u2264] = ACTIONS(5810),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_BSLASHgeq] = ACTIONS(5810),
    [anon_sym_u2265] = ACTIONS(5810),
    [anon_sym_BSLASHapprox] = ACTIONS(5810),
    [anon_sym_u2248] = ACTIONS(5810),
    [anon_sym_PIPE_DASH] = ACTIONS(5810),
    [anon_sym_u22a2] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_u22a8] = ACTIONS(5810),
    [anon_sym_DASH_PIPE] = ACTIONS(5810),
    [anon_sym_u22a3] = ACTIONS(5810),
    [anon_sym_EQ_PIPE] = ACTIONS(5810),
    [anon_sym_u2ae4] = ACTIONS(5810),
    [anon_sym_BSLASHasymp] = ACTIONS(5810),
    [anon_sym_u224d] = ACTIONS(5810),
    [anon_sym_BSLASHcong] = ACTIONS(5810),
    [anon_sym_u2245] = ACTIONS(5810),
    [anon_sym_BSLASHdoteq] = ACTIONS(5810),
    [anon_sym_u2250] = ACTIONS(5810),
    [anon_sym_BSLASHgg] = ACTIONS(5810),
    [anon_sym_u226b] = ACTIONS(5810),
    [anon_sym_BSLASHll] = ACTIONS(5810),
    [anon_sym_u226a] = ACTIONS(5810),
    [anon_sym_BSLASHnotin] = ACTIONS(5810),
    [anon_sym_u2209] = ACTIONS(5810),
    [anon_sym_BSLASHprec] = ACTIONS(5812),
    [anon_sym_u227a] = ACTIONS(5810),
    [anon_sym_BSLASHsucc] = ACTIONS(5812),
    [anon_sym_u227b] = ACTIONS(5810),
    [anon_sym_BSLASHpreceq] = ACTIONS(5810),
    [anon_sym_u2aaf] = ACTIONS(5810),
    [anon_sym_BSLASHsucceq] = ACTIONS(5810),
    [anon_sym_u2ab0] = ACTIONS(5810),
    [anon_sym_BSLASHpropto] = ACTIONS(5810),
    [anon_sym_u221d] = ACTIONS(5810),
    [anon_sym_BSLASHsim] = ACTIONS(5812),
    [anon_sym_u223c] = ACTIONS(5810),
    [anon_sym_BSLASHsimeq] = ACTIONS(5810),
    [anon_sym_u2243] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5812),
    [anon_sym_u228f] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5812),
    [anon_sym_u2290] = ACTIONS(5810),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5810),
    [anon_sym_u2291] = ACTIONS(5810),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5810),
    [anon_sym_u2292] = ACTIONS(5810),
    [anon_sym_BSLASHsubset] = ACTIONS(5812),
    [anon_sym_u2282] = ACTIONS(5810),
    [anon_sym_BSLASHsupset] = ACTIONS(5812),
    [anon_sym_u2283] = ACTIONS(5810),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5810),
    [anon_sym_u2286] = ACTIONS(5810),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5810),
    [anon_sym_u2287] = ACTIONS(5810),
    [sym_compose] = ACTIONS(5810),
    [sym_map_to] = ACTIONS(5810),
    [sym_map_from] = ACTIONS(5810),
    [sym_setminus] = ACTIONS(5812),
    [anon_sym_BSLASHcap] = ACTIONS(5810),
    [anon_sym_BSLASHintersect] = ACTIONS(5810),
    [anon_sym_u2229] = ACTIONS(5810),
    [anon_sym_BSLASHcup] = ACTIONS(5810),
    [anon_sym_BSLASHunion] = ACTIONS(5810),
    [anon_sym_u222a] = ACTIONS(5810),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_u2025] = ACTIONS(5810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_u2026] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [sym_plusplus] = ACTIONS(5810),
    [anon_sym_BSLASHoplus] = ACTIONS(5810),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5810),
    [anon_sym_u2295] = ACTIONS(5810),
    [anon_sym_BSLASHominus] = ACTIONS(5810),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2296] = ACTIONS(5810),
    [sym_mod] = ACTIONS(5812),
    [sym_modmod] = ACTIONS(5810),
    [sym_vert] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5810),
    [anon_sym_u2016] = ACTIONS(5810),
    [sym_minusminus] = ACTIONS(5810),
    [sym_amp] = ACTIONS(5812),
    [sym_ampamp] = ACTIONS(5810),
    [anon_sym_BSLASHodot] = ACTIONS(5810),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5810),
    [anon_sym_u2299] = ACTIONS(5810),
    [anon_sym_BSLASHoslash] = ACTIONS(5810),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_u2298] = ACTIONS(5810),
    [anon_sym_BSLASHotimes] = ACTIONS(5810),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5810),
    [anon_sym_u2297] = ACTIONS(5810),
    [sym_mul] = ACTIONS(5812),
    [sym_mulmul] = ACTIONS(5810),
    [sym_slash] = ACTIONS(5812),
    [sym_slashslash] = ACTIONS(5810),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5810),
    [anon_sym_u25ef] = ACTIONS(5810),
    [anon_sym_BSLASHbullet] = ACTIONS(5810),
    [anon_sym_u25cf] = ACTIONS(5810),
    [anon_sym_BSLASHdiv] = ACTIONS(5810),
    [anon_sym_u00f7] = ACTIONS(5810),
    [anon_sym_BSLASHcirc] = ACTIONS(5810),
    [anon_sym_u2218] = ACTIONS(5810),
    [anon_sym_BSLASHstar] = ACTIONS(5810),
    [anon_sym_u22c6] = ACTIONS(5810),
    [anon_sym_u203c] = ACTIONS(5810),
    [sym_hashhash] = ACTIONS(5810),
    [sym_dol] = ACTIONS(5812),
    [sym_doldol] = ACTIONS(5810),
    [anon_sym_QMARK_QMARK] = ACTIONS(5810),
    [anon_sym_u2047] = ACTIONS(5810),
    [anon_sym_BSLASHsqcap] = ACTIONS(5810),
    [anon_sym_u2293] = ACTIONS(5810),
    [anon_sym_BSLASHsqcup] = ACTIONS(5810),
    [anon_sym_u2294] = ACTIONS(5810),
    [anon_sym_BSLASHuplus] = ACTIONS(5810),
    [anon_sym_u228e] = ACTIONS(5810),
    [anon_sym_BSLASHX] = ACTIONS(5810),
    [anon_sym_BSLASHtimes] = ACTIONS(5810),
    [anon_sym_u00d7] = ACTIONS(5810),
    [anon_sym_BSLASHwr] = ACTIONS(5810),
    [anon_sym_u2240] = ACTIONS(5810),
    [anon_sym_BSLASHcdot] = ACTIONS(5810),
    [anon_sym_u22c5] = ACTIONS(5810),
    [sym_pow] = ACTIONS(5812),
    [sym_powpow] = ACTIONS(5810),
    [anon_sym_CARET_PLUS] = ACTIONS(5810),
    [anon_sym_u207a] = ACTIONS(5810),
    [sym_asterisk] = ACTIONS(5810),
    [sym_sup_hash] = ACTIONS(5810),
    [sym_prime] = ACTIONS(5810),
    [sym__bullet] = ACTIONS(5810),
    [sym__dedent] = ACTIONS(5810),
    [sym__double_excl] = ACTIONS(5810),
  },
  [3410] = {
    [sym_block_comment] = STATE(3410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5816),
    [anon_sym_u2208] = ACTIONS(5814),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5814),
    [anon_sym_u25a1] = ACTIONS(5814),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5814),
    [anon_sym_u2227] = ACTIONS(5814),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5814),
    [anon_sym_u2228] = ACTIONS(5814),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_BSLASHo] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_DASH] = ACTIONS(5816),
    [anon_sym_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27f9] = ACTIONS(5814),
    [anon_sym_u21d2] = ACTIONS(5814),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5814),
    [anon_sym_u21f8] = ACTIONS(5814),
    [anon_sym_u2945] = ACTIONS(5814),
    [anon_sym_BSLASHequiv] = ACTIONS(5814),
    [anon_sym_u2261] = ACTIONS(5814),
    [anon_sym_LT_EQ_GT] = ACTIONS(5814),
    [anon_sym_u27fa] = ACTIONS(5814),
    [anon_sym_u21d4] = ACTIONS(5814),
    [anon_sym_TILDE_GT] = ACTIONS(5814),
    [anon_sym_u21dd] = ACTIONS(5814),
    [anon_sym_u219d] = ACTIONS(5814),
    [anon_sym_BSLASHland] = ACTIONS(5814),
    [anon_sym_BSLASHlor] = ACTIONS(5814),
    [anon_sym_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2254] = ACTIONS(5814),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5814),
    [anon_sym_u2a74] = ACTIONS(5814),
    [anon_sym_SLASH_EQ] = ACTIONS(5814),
    [anon_sym_POUND] = ACTIONS(5816),
    [anon_sym_u2260] = ACTIONS(5814),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_gt] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5816),
    [anon_sym_EQ_LT] = ACTIONS(5814),
    [anon_sym_BSLASHleq] = ACTIONS(5814),
    [anon_sym_u2264] = ACTIONS(5814),
    [anon_sym_GT_EQ] = ACTIONS(5814),
    [anon_sym_BSLASHgeq] = ACTIONS(5814),
    [anon_sym_u2265] = ACTIONS(5814),
    [anon_sym_BSLASHapprox] = ACTIONS(5814),
    [anon_sym_u2248] = ACTIONS(5814),
    [anon_sym_PIPE_DASH] = ACTIONS(5814),
    [anon_sym_u22a2] = ACTIONS(5814),
    [anon_sym_PIPE_EQ] = ACTIONS(5814),
    [anon_sym_u22a8] = ACTIONS(5814),
    [anon_sym_DASH_PIPE] = ACTIONS(5814),
    [anon_sym_u22a3] = ACTIONS(5814),
    [anon_sym_EQ_PIPE] = ACTIONS(5814),
    [anon_sym_u2ae4] = ACTIONS(5814),
    [anon_sym_BSLASHasymp] = ACTIONS(5814),
    [anon_sym_u224d] = ACTIONS(5814),
    [anon_sym_BSLASHcong] = ACTIONS(5814),
    [anon_sym_u2245] = ACTIONS(5814),
    [anon_sym_BSLASHdoteq] = ACTIONS(5814),
    [anon_sym_u2250] = ACTIONS(5814),
    [anon_sym_BSLASHgg] = ACTIONS(5814),
    [anon_sym_u226b] = ACTIONS(5814),
    [anon_sym_BSLASHll] = ACTIONS(5814),
    [anon_sym_u226a] = ACTIONS(5814),
    [anon_sym_BSLASHnotin] = ACTIONS(5814),
    [anon_sym_u2209] = ACTIONS(5814),
    [anon_sym_BSLASHprec] = ACTIONS(5816),
    [anon_sym_u227a] = ACTIONS(5814),
    [anon_sym_BSLASHsucc] = ACTIONS(5816),
    [anon_sym_u227b] = ACTIONS(5814),
    [anon_sym_BSLASHpreceq] = ACTIONS(5814),
    [anon_sym_u2aaf] = ACTIONS(5814),
    [anon_sym_BSLASHsucceq] = ACTIONS(5814),
    [anon_sym_u2ab0] = ACTIONS(5814),
    [anon_sym_BSLASHpropto] = ACTIONS(5814),
    [anon_sym_u221d] = ACTIONS(5814),
    [anon_sym_BSLASHsim] = ACTIONS(5816),
    [anon_sym_u223c] = ACTIONS(5814),
    [anon_sym_BSLASHsimeq] = ACTIONS(5814),
    [anon_sym_u2243] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5816),
    [anon_sym_u228f] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5816),
    [anon_sym_u2290] = ACTIONS(5814),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5814),
    [anon_sym_u2291] = ACTIONS(5814),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5814),
    [anon_sym_u2292] = ACTIONS(5814),
    [anon_sym_BSLASHsubset] = ACTIONS(5816),
    [anon_sym_u2282] = ACTIONS(5814),
    [anon_sym_BSLASHsupset] = ACTIONS(5816),
    [anon_sym_u2283] = ACTIONS(5814),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5814),
    [anon_sym_u2286] = ACTIONS(5814),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5814),
    [anon_sym_u2287] = ACTIONS(5814),
    [sym_compose] = ACTIONS(5814),
    [sym_map_to] = ACTIONS(5814),
    [sym_map_from] = ACTIONS(5814),
    [sym_setminus] = ACTIONS(5816),
    [anon_sym_BSLASHcap] = ACTIONS(5814),
    [anon_sym_BSLASHintersect] = ACTIONS(5814),
    [anon_sym_u2229] = ACTIONS(5814),
    [anon_sym_BSLASHcup] = ACTIONS(5814),
    [anon_sym_BSLASHunion] = ACTIONS(5814),
    [anon_sym_u222a] = ACTIONS(5814),
    [anon_sym_DOT_DOT] = ACTIONS(5816),
    [anon_sym_u2025] = ACTIONS(5814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5814),
    [anon_sym_u2026] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5816),
    [sym_plusplus] = ACTIONS(5814),
    [anon_sym_BSLASHoplus] = ACTIONS(5814),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5814),
    [anon_sym_u2295] = ACTIONS(5814),
    [anon_sym_BSLASHominus] = ACTIONS(5814),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2296] = ACTIONS(5814),
    [sym_mod] = ACTIONS(5816),
    [sym_modmod] = ACTIONS(5814),
    [sym_vert] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5814),
    [anon_sym_u2016] = ACTIONS(5814),
    [sym_minusminus] = ACTIONS(5814),
    [sym_amp] = ACTIONS(5816),
    [sym_ampamp] = ACTIONS(5814),
    [anon_sym_BSLASHodot] = ACTIONS(5814),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5814),
    [anon_sym_u2299] = ACTIONS(5814),
    [anon_sym_BSLASHoslash] = ACTIONS(5814),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5814),
    [anon_sym_u2298] = ACTIONS(5814),
    [anon_sym_BSLASHotimes] = ACTIONS(5814),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5814),
    [anon_sym_u2297] = ACTIONS(5814),
    [sym_mul] = ACTIONS(5816),
    [sym_mulmul] = ACTIONS(5814),
    [sym_slash] = ACTIONS(5816),
    [sym_slashslash] = ACTIONS(5814),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5814),
    [anon_sym_u25ef] = ACTIONS(5814),
    [anon_sym_BSLASHbullet] = ACTIONS(5814),
    [anon_sym_u25cf] = ACTIONS(5814),
    [anon_sym_BSLASHdiv] = ACTIONS(5814),
    [anon_sym_u00f7] = ACTIONS(5814),
    [anon_sym_BSLASHcirc] = ACTIONS(5814),
    [anon_sym_u2218] = ACTIONS(5814),
    [anon_sym_BSLASHstar] = ACTIONS(5814),
    [anon_sym_u22c6] = ACTIONS(5814),
    [anon_sym_u203c] = ACTIONS(5814),
    [sym_hashhash] = ACTIONS(5814),
    [sym_dol] = ACTIONS(5816),
    [sym_doldol] = ACTIONS(5814),
    [anon_sym_QMARK_QMARK] = ACTIONS(5814),
    [anon_sym_u2047] = ACTIONS(5814),
    [anon_sym_BSLASHsqcap] = ACTIONS(5814),
    [anon_sym_u2293] = ACTIONS(5814),
    [anon_sym_BSLASHsqcup] = ACTIONS(5814),
    [anon_sym_u2294] = ACTIONS(5814),
    [anon_sym_BSLASHuplus] = ACTIONS(5814),
    [anon_sym_u228e] = ACTIONS(5814),
    [anon_sym_BSLASHX] = ACTIONS(5814),
    [anon_sym_BSLASHtimes] = ACTIONS(5814),
    [anon_sym_u00d7] = ACTIONS(5814),
    [anon_sym_BSLASHwr] = ACTIONS(5814),
    [anon_sym_u2240] = ACTIONS(5814),
    [anon_sym_BSLASHcdot] = ACTIONS(5814),
    [anon_sym_u22c5] = ACTIONS(5814),
    [sym_pow] = ACTIONS(5816),
    [sym_powpow] = ACTIONS(5814),
    [anon_sym_CARET_PLUS] = ACTIONS(5814),
    [anon_sym_u207a] = ACTIONS(5814),
    [sym_asterisk] = ACTIONS(5814),
    [sym_sup_hash] = ACTIONS(5814),
    [sym_prime] = ACTIONS(5814),
    [sym__bullet] = ACTIONS(5814),
    [sym__dedent] = ACTIONS(5814),
    [sym__double_excl] = ACTIONS(5814),
  },
  [3411] = {
    [sym_block_comment] = STATE(3411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_BSLASHin] = ACTIONS(5906),
    [anon_sym_u2208] = ACTIONS(5904),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5904),
    [anon_sym_u25a1] = ACTIONS(5904),
    [anon_sym_SLASH_BSLASH] = ACTIONS(5904),
    [anon_sym_u2227] = ACTIONS(5904),
    [anon_sym_BSLASH_SLASH] = ACTIONS(5904),
    [anon_sym_u2228] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_BSLASHo] = ACTIONS(5906),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27f9] = ACTIONS(5904),
    [anon_sym_u21d2] = ACTIONS(5904),
    [anon_sym_DASH_PLUS_DASH_GT] = ACTIONS(5904),
    [anon_sym_u21f8] = ACTIONS(5904),
    [anon_sym_u2945] = ACTIONS(5904),
    [anon_sym_BSLASHequiv] = ACTIONS(5904),
    [anon_sym_u2261] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_u27fa] = ACTIONS(5904),
    [anon_sym_u21d4] = ACTIONS(5904),
    [anon_sym_TILDE_GT] = ACTIONS(5904),
    [anon_sym_u21dd] = ACTIONS(5904),
    [anon_sym_u219d] = ACTIONS(5904),
    [anon_sym_BSLASHland] = ACTIONS(5904),
    [anon_sym_BSLASHlor] = ACTIONS(5904),
    [anon_sym_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2254] = ACTIONS(5904),
    [anon_sym_COLON_COLON_EQ] = ACTIONS(5904),
    [anon_sym_u2a74] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_POUND] = ACTIONS(5906),
    [anon_sym_u2260] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [sym_gt] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_EQ_LT] = ACTIONS(5904),
    [anon_sym_BSLASHleq] = ACTIONS(5904),
    [anon_sym_u2264] = ACTIONS(5904),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_BSLASHgeq] = ACTIONS(5904),
    [anon_sym_u2265] = ACTIONS(5904),
    [anon_sym_BSLASHapprox] = ACTIONS(5904),
    [anon_sym_u2248] = ACTIONS(5904),
    [anon_sym_PIPE_DASH] = ACTIONS(5904),
    [anon_sym_u22a2] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_u22a8] = ACTIONS(5904),
    [anon_sym_DASH_PIPE] = ACTIONS(5904),
    [anon_sym_u22a3] = ACTIONS(5904),
    [anon_sym_EQ_PIPE] = ACTIONS(5904),
    [anon_sym_u2ae4] = ACTIONS(5904),
    [anon_sym_BSLASHasymp] = ACTIONS(5904),
    [anon_sym_u224d] = ACTIONS(5904),
    [anon_sym_BSLASHcong] = ACTIONS(5904),
    [anon_sym_u2245] = ACTIONS(5904),
    [anon_sym_BSLASHdoteq] = ACTIONS(5904),
    [anon_sym_u2250] = ACTIONS(5904),
    [anon_sym_BSLASHgg] = ACTIONS(5904),
    [anon_sym_u226b] = ACTIONS(5904),
    [anon_sym_BSLASHll] = ACTIONS(5904),
    [anon_sym_u226a] = ACTIONS(5904),
    [anon_sym_BSLASHnotin] = ACTIONS(5904),
    [anon_sym_u2209] = ACTIONS(5904),
    [anon_sym_BSLASHprec] = ACTIONS(5906),
    [anon_sym_u227a] = ACTIONS(5904),
    [anon_sym_BSLASHsucc] = ACTIONS(5906),
    [anon_sym_u227b] = ACTIONS(5904),
    [anon_sym_BSLASHpreceq] = ACTIONS(5904),
    [anon_sym_u2aaf] = ACTIONS(5904),
    [anon_sym_BSLASHsucceq] = ACTIONS(5904),
    [anon_sym_u2ab0] = ACTIONS(5904),
    [anon_sym_BSLASHpropto] = ACTIONS(5904),
    [anon_sym_u221d] = ACTIONS(5904),
    [anon_sym_BSLASHsim] = ACTIONS(5906),
    [anon_sym_u223c] = ACTIONS(5904),
    [anon_sym_BSLASHsimeq] = ACTIONS(5904),
    [anon_sym_u2243] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubset] = ACTIONS(5906),
    [anon_sym_u228f] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupset] = ACTIONS(5906),
    [anon_sym_u2290] = ACTIONS(5904),
    [anon_sym_BSLASHsqsubseteq] = ACTIONS(5904),
    [anon_sym_u2291] = ACTIONS(5904),
    [anon_sym_BSLASHsqsupseteq] = ACTIONS(5904),
    [anon_sym_u2292] = ACTIONS(5904),
    [anon_sym_BSLASHsubset] = ACTIONS(5906),
    [anon_sym_u2282] = ACTIONS(5904),
    [anon_sym_BSLASHsupset] = ACTIONS(5906),
    [anon_sym_u2283] = ACTIONS(5904),
    [anon_sym_BSLASHsubseteq] = ACTIONS(5904),
    [anon_sym_u2286] = ACTIONS(5904),
    [anon_sym_BSLASHsupseteq] = ACTIONS(5904),
    [anon_sym_u2287] = ACTIONS(5904),
    [sym_compose] = ACTIONS(5904),
    [sym_map_to] = ACTIONS(5904),
    [sym_map_from] = ACTIONS(5904),
    [sym_setminus] = ACTIONS(5906),
    [anon_sym_BSLASHcap] = ACTIONS(5904),
    [anon_sym_BSLASHintersect] = ACTIONS(5904),
    [anon_sym_u2229] = ACTIONS(5904),
    [anon_sym_BSLASHcup] = ACTIONS(5904),
    [anon_sym_BSLASHunion] = ACTIONS(5904),
    [anon_sym_u222a] = ACTIONS(5904),
    [anon_sym_DOT_DOT] = ACTIONS(5906),
    [anon_sym_u2025] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_u2026] = ACTIONS(5904),
    [anon_sym_PLUS] = ACTIONS(5906),
    [sym_plusplus] = ACTIONS(5904),
    [anon_sym_BSLASHoplus] = ACTIONS(5904),
    [anon_sym_LPAREN_PLUS_RPAREN] = ACTIONS(5904),
    [anon_sym_u2295] = ACTIONS(5904),
    [anon_sym_BSLASHominus] = ACTIONS(5904),
    [anon_sym_LPAREN_DASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2296] = ACTIONS(5904),
    [sym_mod] = ACTIONS(5906),
    [sym_modmod] = ACTIONS(5904),
    [sym_vert] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_u2016] = ACTIONS(5904),
    [sym_minusminus] = ACTIONS(5904),
    [sym_amp] = ACTIONS(5906),
    [sym_ampamp] = ACTIONS(5904),
    [anon_sym_BSLASHodot] = ACTIONS(5904),
    [anon_sym_LPAREN_DOT_RPAREN] = ACTIONS(5904),
    [anon_sym_u2299] = ACTIONS(5904),
    [anon_sym_BSLASHoslash] = ACTIONS(5904),
    [anon_sym_LPAREN_SLASH_RPAREN] = ACTIONS(5904),
    [anon_sym_u2298] = ACTIONS(5904),
    [anon_sym_BSLASHotimes] = ACTIONS(5904),
    [anon_sym_LPAREN_BSLASHX_RPAREN] = ACTIONS(5904),
    [anon_sym_u2297] = ACTIONS(5904),
    [sym_mul] = ACTIONS(5906),
    [sym_mulmul] = ACTIONS(5904),
    [sym_slash] = ACTIONS(5906),
    [sym_slashslash] = ACTIONS(5904),
    [anon_sym_BSLASHbigcirc] = ACTIONS(5904),
    [anon_sym_u25ef] = ACTIONS(5904),
    [anon_sym_BSLASHbullet] = ACTIONS(5904),
    [anon_sym_u25cf] = ACTIONS(5904),
    [anon_sym_BSLASHdiv] = ACTIONS(5904),
    [anon_sym_u00f7] = ACTIONS(5904),
    [anon_sym_BSLASHcirc] = ACTIONS(5904),
    [anon_sym_u2218] = ACTIONS(5904),
    [anon_sym_BSLASHstar] = ACTIONS(5904),
    [anon_sym_u22c6] = ACTIONS(5904),
    [anon_sym_u203c] = ACTIONS(5904),
    [sym_hashhash] = ACTIONS(5904),
    [sym_dol] = ACTIONS(5906),
    [sym_doldol] = ACTIONS(5904),
    [anon_sym_QMARK_QMARK] = ACTIONS(5904),
    [anon_sym_u2047] = ACTIONS(5904),
    [anon_sym_BSLASHsqcap] = ACTIONS(5904),
    [anon_sym_u2293] = ACTIONS(5904),
    [anon_sym_BSLASHsqcup] = ACTIONS(5904),
    [anon_sym_u2294] = ACTIONS(5904),
    [anon_sym_BSLASHuplus] = ACTIONS(5904),
    [anon_sym_u228e] = ACTIONS(5904),
    [anon_sym_BSLASHX] = ACTIONS(5904),
    [anon_sym_BSLASHtimes] = ACTIONS(5904),
    [anon_sym_u00d7] = ACTIONS(5904),
    [anon_sym_BSLASHwr] = ACTIONS(5904),
    [anon_sym_u2240] = ACTIONS(5904),
    [anon_sym_BSLASHcdot] = ACTIONS(5904),
    [anon_sym_u22c5] = ACTIONS(5904),
    [sym_pow] = ACTIONS(5906),
    [sym_powpow] = ACTIONS(5904),
    [anon_sym_CARET_PLUS] = ACTIONS(5904),
    [anon_sym_u207a] = ACTIONS(5904),
    [sym_asterisk] = ACTIONS(5904),
    [sym_sup_hash] = ACTIONS(5904),
    [sym_prime] = ACTIONS(5904),
    [sym__bullet] = ACTIONS(5904),
    [sym__dedent] = ACTIONS(5904),
    [sym__double_excl] = ACTIONS(5904),
  },
  [3412] = {
    [sym_block_comment] = STATE(3412),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym_double_line] = STATE(3569),
    [sym_extends] = STATE(3414),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4360),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5170),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3419),
    [sym_identifier] = ACTIONS(6118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(9),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(6120),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_EXTENDS] = ACTIONS(13),
    [anon_sym_LOCAL] = ACTIONS(6122),
    [anon_sym_VARIABLE] = ACTIONS(17),
    [anon_sym_VARIABLES] = ACTIONS(17),
    [anon_sym_CONSTANT] = ACTIONS(6124),
    [anon_sym_CONSTANTS] = ACTIONS(6124),
    [anon_sym_RECURSIVE] = ACTIONS(6126),
    [anon_sym_INSTANCE] = ACTIONS(1774),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_ASSUME] = ACTIONS(6128),
    [anon_sym_ASSUMPTION] = ACTIONS(6128),
    [anon_sym_AXIOM] = ACTIONS(6128),
    [anon_sym_THEOREM] = ACTIONS(6130),
    [anon_sym_PROPOSITION] = ACTIONS(6130),
    [anon_sym_LEMMA] = ACTIONS(6130),
    [anon_sym_COROLLARY] = ACTIONS(6130),
    [anon_sym_USE] = ACTIONS(6132),
    [anon_sym_HIDE] = ACTIONS(6132),
  },
  [3413] = {
    [sym_block_comment] = STATE(3413),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym_double_line] = STATE(3577),
    [sym_extends] = STATE(3418),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4360),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5170),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3417),
    [sym_identifier] = ACTIONS(6118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(9),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(6134),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_EXTENDS] = ACTIONS(13),
    [anon_sym_LOCAL] = ACTIONS(6122),
    [anon_sym_VARIABLE] = ACTIONS(17),
    [anon_sym_VARIABLES] = ACTIONS(17),
    [anon_sym_CONSTANT] = ACTIONS(6124),
    [anon_sym_CONSTANTS] = ACTIONS(6124),
    [anon_sym_RECURSIVE] = ACTIONS(6126),
    [anon_sym_INSTANCE] = ACTIONS(1774),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_ASSUME] = ACTIONS(6128),
    [anon_sym_ASSUMPTION] = ACTIONS(6128),
    [anon_sym_AXIOM] = ACTIONS(6128),
    [anon_sym_THEOREM] = ACTIONS(6130),
    [anon_sym_PROPOSITION] = ACTIONS(6130),
    [anon_sym_LEMMA] = ACTIONS(6130),
    [anon_sym_COROLLARY] = ACTIONS(6130),
    [anon_sym_USE] = ACTIONS(6132),
    [anon_sym_HIDE] = ACTIONS(6132),
  },
  [3414] = {
    [sym_block_comment] = STATE(3414),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym_double_line] = STATE(3596),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4360),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5170),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3416),
    [sym_identifier] = ACTIONS(6118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(9),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(6120),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_LOCAL] = ACTIONS(6122),
    [anon_sym_VARIABLE] = ACTIONS(17),
    [anon_sym_VARIABLES] = ACTIONS(17),
    [anon_sym_CONSTANT] = ACTIONS(6124),
    [anon_sym_CONSTANTS] = ACTIONS(6124),
    [anon_sym_RECURSIVE] = ACTIONS(6126),
    [anon_sym_INSTANCE] = ACTIONS(1774),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_ASSUME] = ACTIONS(6128),
    [anon_sym_ASSUMPTION] = ACTIONS(6128),
    [anon_sym_AXIOM] = ACTIONS(6128),
    [anon_sym_THEOREM] = ACTIONS(6130),
    [anon_sym_PROPOSITION] = ACTIONS(6130),
    [anon_sym_LEMMA] = ACTIONS(6130),
    [anon_sym_COROLLARY] = ACTIONS(6130),
    [anon_sym_USE] = ACTIONS(6132),
    [anon_sym_HIDE] = ACTIONS(6132),
  },
  [3415] = {
    [sym_block_comment] = STATE(3415),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym_double_line] = STATE(3584),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4360),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5170),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3423),
    [sym_identifier] = ACTIONS(6118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(9),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(6134),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_LOCAL] = ACTIONS(6122),
    [anon_sym_VARIABLE] = ACTIONS(17),
    [anon_sym_VARIABLES] = ACTIONS(17),
    [anon_sym_CONSTANT] = ACTIONS(6124),
    [anon_sym_CONSTANTS] = ACTIONS(6124),
    [anon_sym_RECURSIVE] = ACTIONS(6126),
    [anon_sym_INSTANCE] = ACTIONS(1774),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_ASSUME] = ACTIONS(6128),
    [anon_sym_ASSUMPTION] = ACTIONS(6128),
    [anon_sym_AXIOM] = ACTIONS(6128),
    [anon_sym_THEOREM] = ACTIONS(6130),
    [anon_sym_PROPOSITION] = ACTIONS(6130),
    [anon_sym_LEMMA] = ACTIONS(6130),
    [anon_sym_COROLLARY] = ACTIONS(6130),
    [anon_sym_USE] = ACTIONS(6132),
    [anon_sym_HIDE] = ACTIONS(6132),
  },
  [3416] = {
    [sym_block_comment] = STATE(3416),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym_double_line] = STATE(3580),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4360),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5170),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3423),
    [sym_identifier] = ACTIONS(6118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(9),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(6120),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_LOCAL] = ACTIONS(6122),
    [anon_sym_VARIABLE] = ACTIONS(17),
    [anon_sym_VARIABLES] = ACTIONS(17),
    [anon_sym_CONSTANT] = ACTIONS(6124),
    [anon_sym_CONSTANTS] = ACTIONS(6124),
    [anon_sym_RECURSIVE] = ACTIONS(6126),
    [anon_sym_INSTANCE] = ACTIONS(1774),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_ASSUME] = ACTIONS(6128),
    [anon_sym_ASSUMPTION] = ACTIONS(6128),
    [anon_sym_AXIOM] = ACTIONS(6128),
    [anon_sym_THEOREM] = ACTIONS(6130),
    [anon_sym_PROPOSITION] = ACTIONS(6130),
    [anon_sym_LEMMA] = ACTIONS(6130),
    [anon_sym_COROLLARY] = ACTIONS(6130),
    [anon_sym_USE] = ACTIONS(6132),
    [anon_sym_HIDE] = ACTIONS(6132),
  },
  [3417] = {
    [sym_block_comment] = STATE(3417),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym_double_line] = STATE(3583),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4360),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5170),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3423),
    [sym_identifier] = ACTIONS(6118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(9),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(6134),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_LOCAL] = ACTIONS(6122),
    [anon_sym_VARIABLE] = ACTIONS(17),
    [anon_sym_VARIABLES] = ACTIONS(17),
    [anon_sym_CONSTANT] = ACTIONS(6124),
    [anon_sym_CONSTANTS] = ACTIONS(6124),
    [anon_sym_RECURSIVE] = ACTIONS(6126),
    [anon_sym_INSTANCE] = ACTIONS(1774),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_ASSUME] = ACTIONS(6128),
    [anon_sym_ASSUMPTION] = ACTIONS(6128),
    [anon_sym_AXIOM] = ACTIONS(6128),
    [anon_sym_THEOREM] = ACTIONS(6130),
    [anon_sym_PROPOSITION] = ACTIONS(6130),
    [anon_sym_LEMMA] = ACTIONS(6130),
    [anon_sym_COROLLARY] = ACTIONS(6130),
    [anon_sym_USE] = ACTIONS(6132),
    [anon_sym_HIDE] = ACTIONS(6132),
  },
  [3418] = {
    [sym_block_comment] = STATE(3418),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym_double_line] = STATE(3583),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4360),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5170),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3415),
    [sym_identifier] = ACTIONS(6118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(9),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(6134),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_LOCAL] = ACTIONS(6122),
    [anon_sym_VARIABLE] = ACTIONS(17),
    [anon_sym_VARIABLES] = ACTIONS(17),
    [anon_sym_CONSTANT] = ACTIONS(6124),
    [anon_sym_CONSTANTS] = ACTIONS(6124),
    [anon_sym_RECURSIVE] = ACTIONS(6126),
    [anon_sym_INSTANCE] = ACTIONS(1774),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_ASSUME] = ACTIONS(6128),
    [anon_sym_ASSUMPTION] = ACTIONS(6128),
    [anon_sym_AXIOM] = ACTIONS(6128),
    [anon_sym_THEOREM] = ACTIONS(6130),
    [anon_sym_PROPOSITION] = ACTIONS(6130),
    [anon_sym_LEMMA] = ACTIONS(6130),
    [anon_sym_COROLLARY] = ACTIONS(6130),
    [anon_sym_USE] = ACTIONS(6132),
    [anon_sym_HIDE] = ACTIONS(6132),
  },
  [3419] = {
    [sym_block_comment] = STATE(3419),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym_double_line] = STATE(3596),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4360),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5170),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3423),
    [sym_identifier] = ACTIONS(6118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(9),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(6120),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_LOCAL] = ACTIONS(6122),
    [anon_sym_VARIABLE] = ACTIONS(17),
    [anon_sym_VARIABLES] = ACTIONS(17),
    [anon_sym_CONSTANT] = ACTIONS(6124),
    [anon_sym_CONSTANTS] = ACTIONS(6124),
    [anon_sym_RECURSIVE] = ACTIONS(6126),
    [anon_sym_INSTANCE] = ACTIONS(1774),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_ASSUME] = ACTIONS(6128),
    [anon_sym_ASSUMPTION] = ACTIONS(6128),
    [anon_sym_AXIOM] = ACTIONS(6128),
    [anon_sym_THEOREM] = ACTIONS(6130),
    [anon_sym_PROPOSITION] = ACTIONS(6130),
    [anon_sym_LEMMA] = ACTIONS(6130),
    [anon_sym_COROLLARY] = ACTIONS(6130),
    [anon_sym_USE] = ACTIONS(6132),
    [anon_sym_HIDE] = ACTIONS(6132),
  },
  [3420] = {
    [sym_block_comment] = STATE(3420),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4382),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5171),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3421),
    [ts_builtin_sym_end] = ACTIONS(6136),
    [sym_identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(9),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_LOCAL] = ACTIONS(15),
    [anon_sym_VARIABLE] = ACTIONS(17),
    [anon_sym_VARIABLES] = ACTIONS(17),
    [anon_sym_CONSTANT] = ACTIONS(19),
    [anon_sym_CONSTANTS] = ACTIONS(19),
    [anon_sym_RECURSIVE] = ACTIONS(21),
    [anon_sym_INSTANCE] = ACTIONS(23),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_ASSUME] = ACTIONS(45),
    [anon_sym_ASSUMPTION] = ACTIONS(45),
    [anon_sym_AXIOM] = ACTIONS(45),
    [anon_sym_THEOREM] = ACTIONS(47),
    [anon_sym_PROPOSITION] = ACTIONS(47),
    [anon_sym_LEMMA] = ACTIONS(47),
    [anon_sym_COROLLARY] = ACTIONS(47),
    [anon_sym_USE] = ACTIONS(49),
    [anon_sym_HIDE] = ACTIONS(49),
  },
  [3421] = {
    [sym_block_comment] = STATE(3421),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4382),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5171),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3421),
    [ts_builtin_sym_end] = ACTIONS(6138),
    [sym_identifier] = ACTIONS(6140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(6143),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6146),
    [anon_sym_u25a1] = ACTIONS(6146),
    [anon_sym_LOCAL] = ACTIONS(6149),
    [anon_sym_VARIABLE] = ACTIONS(6152),
    [anon_sym_VARIABLES] = ACTIONS(6152),
    [anon_sym_CONSTANT] = ACTIONS(6155),
    [anon_sym_CONSTANTS] = ACTIONS(6155),
    [anon_sym_RECURSIVE] = ACTIONS(6158),
    [anon_sym_INSTANCE] = ACTIONS(6161),
    [anon_sym_Nat] = ACTIONS(6164),
    [anon_sym_u2115] = ACTIONS(6167),
    [anon_sym_Int] = ACTIONS(6170),
    [anon_sym_u2124] = ACTIONS(6173),
    [anon_sym_Real] = ACTIONS(6176),
    [anon_sym_u211d] = ACTIONS(6179),
    [anon_sym_BSLASHlnot] = ACTIONS(6182),
    [anon_sym_BSLASHneg] = ACTIONS(6182),
    [anon_sym_TILDE] = ACTIONS(6182),
    [anon_sym_u00ac] = ACTIONS(6182),
    [sym_union] = ACTIONS(6185),
    [sym_powerset] = ACTIONS(6185),
    [sym_domain] = ACTIONS(6185),
    [sym_negative_dot] = ACTIONS(6188),
    [sym_enabled] = ACTIONS(6185),
    [sym_unchanged] = ACTIONS(6185),
    [anon_sym_LT_GT] = ACTIONS(6191),
    [anon_sym_u22c4] = ACTIONS(6191),
    [anon_sym_u25c7] = ACTIONS(6191),
    [anon_sym_ASSUME] = ACTIONS(6194),
    [anon_sym_ASSUMPTION] = ACTIONS(6194),
    [anon_sym_AXIOM] = ACTIONS(6194),
    [anon_sym_THEOREM] = ACTIONS(6197),
    [anon_sym_PROPOSITION] = ACTIONS(6197),
    [anon_sym_LEMMA] = ACTIONS(6197),
    [anon_sym_COROLLARY] = ACTIONS(6197),
    [anon_sym_USE] = ACTIONS(6200),
    [anon_sym_HIDE] = ACTIONS(6200),
  },
  [3422] = {
    [sym_block_comment] = STATE(3422),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4382),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5171),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3421),
    [ts_builtin_sym_end] = ACTIONS(6203),
    [sym_identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(9),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_LOCAL] = ACTIONS(15),
    [anon_sym_VARIABLE] = ACTIONS(17),
    [anon_sym_VARIABLES] = ACTIONS(17),
    [anon_sym_CONSTANT] = ACTIONS(19),
    [anon_sym_CONSTANTS] = ACTIONS(19),
    [anon_sym_RECURSIVE] = ACTIONS(21),
    [anon_sym_INSTANCE] = ACTIONS(23),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_ASSUME] = ACTIONS(45),
    [anon_sym_ASSUMPTION] = ACTIONS(45),
    [anon_sym_AXIOM] = ACTIONS(45),
    [anon_sym_THEOREM] = ACTIONS(47),
    [anon_sym_PROPOSITION] = ACTIONS(47),
    [anon_sym_LEMMA] = ACTIONS(47),
    [anon_sym_COROLLARY] = ACTIONS(47),
    [anon_sym_USE] = ACTIONS(49),
    [anon_sym_HIDE] = ACTIONS(49),
  },
  [3423] = {
    [sym_block_comment] = STATE(3423),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4360),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5170),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3423),
    [sym_identifier] = ACTIONS(6205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(6143),
    [anon_sym_EQ_EQ_EQ_EQ] = ACTIONS(6138),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6146),
    [anon_sym_u25a1] = ACTIONS(6146),
    [anon_sym_LOCAL] = ACTIONS(6208),
    [anon_sym_VARIABLE] = ACTIONS(6152),
    [anon_sym_VARIABLES] = ACTIONS(6152),
    [anon_sym_CONSTANT] = ACTIONS(6211),
    [anon_sym_CONSTANTS] = ACTIONS(6211),
    [anon_sym_RECURSIVE] = ACTIONS(6214),
    [anon_sym_INSTANCE] = ACTIONS(6217),
    [anon_sym_Nat] = ACTIONS(6164),
    [anon_sym_u2115] = ACTIONS(6167),
    [anon_sym_Int] = ACTIONS(6170),
    [anon_sym_u2124] = ACTIONS(6173),
    [anon_sym_Real] = ACTIONS(6176),
    [anon_sym_u211d] = ACTIONS(6179),
    [anon_sym_BSLASHlnot] = ACTIONS(6182),
    [anon_sym_BSLASHneg] = ACTIONS(6182),
    [anon_sym_TILDE] = ACTIONS(6182),
    [anon_sym_u00ac] = ACTIONS(6182),
    [sym_union] = ACTIONS(6185),
    [sym_powerset] = ACTIONS(6185),
    [sym_domain] = ACTIONS(6185),
    [sym_negative_dot] = ACTIONS(6188),
    [sym_enabled] = ACTIONS(6185),
    [sym_unchanged] = ACTIONS(6185),
    [anon_sym_LT_GT] = ACTIONS(6191),
    [anon_sym_u22c4] = ACTIONS(6191),
    [anon_sym_u25c7] = ACTIONS(6191),
    [anon_sym_ASSUME] = ACTIONS(6220),
    [anon_sym_ASSUMPTION] = ACTIONS(6220),
    [anon_sym_AXIOM] = ACTIONS(6220),
    [anon_sym_THEOREM] = ACTIONS(6223),
    [anon_sym_PROPOSITION] = ACTIONS(6223),
    [anon_sym_LEMMA] = ACTIONS(6223),
    [anon_sym_COROLLARY] = ACTIONS(6223),
    [anon_sym_USE] = ACTIONS(6226),
    [anon_sym_HIDE] = ACTIONS(6226),
  },
  [3424] = {
    [sym_block_comment] = STATE(3424),
    [sym_module] = STATE(3578),
    [sym_single_line] = STATE(3565),
    [sym__unit] = STATE(3588),
    [sym_local_definition] = STATE(3578),
    [sym__definition] = STATE(3578),
    [sym_variable_declaration] = STATE(3578),
    [sym_constant_declaration] = STATE(3578),
    [sym_recursive_declaration] = STATE(3578),
    [sym_operator_definition] = STATE(3528),
    [sym_function_definition] = STATE(3528),
    [sym_instance] = STATE(3528),
    [sym_module_definition] = STATE(3528),
    [sym__number_set] = STATE(4382),
    [sym_nat_number_set] = STATE(4546),
    [sym_int_number_set] = STATE(4546),
    [sym_real_number_set] = STATE(4546),
    [sym_lnot] = STATE(3472),
    [sym_always] = STATE(3472),
    [sym_eventually] = STATE(3472),
    [sym_prefix_op_symbol] = STATE(5171),
    [sym_assumption] = STATE(3578),
    [sym_theorem] = STATE(3578),
    [sym_use_or_hide] = STATE(3578),
    [aux_sym_source_file_repeat2] = STATE(3420),
    [sym_identifier] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LPAREN_STAR] = ACTIONS(5),
    [anon_sym_DASH_DASH_DASH_DASH] = ACTIONS(9),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11),
    [anon_sym_u25a1] = ACTIONS(11),
    [anon_sym_LOCAL] = ACTIONS(15),
    [anon_sym_VARIABLE] = ACTIONS(17),
    [anon_sym_VARIABLES] = ACTIONS(17),
    [anon_sym_CONSTANT] = ACTIONS(19),
    [anon_sym_CONSTANTS] = ACTIONS(19),
    [anon_sym_RECURSIVE] = ACTIONS(21),
    [anon_sym_INSTANCE] = ACTIONS(23),
    [anon_sym_Nat] = ACTIONS(25),
    [anon_sym_u2115] = ACTIONS(27),
    [anon_sym_Int] = ACTIONS(29),
    [anon_sym_u2124] = ACTIONS(31),
    [anon_sym_Real] = ACTIONS(33),
    [anon_sym_u211d] = ACTIONS(35),
    [anon_sym_BSLASHlnot] = ACTIONS(37),
    [anon_sym_BSLASHneg] = ACTIONS(37),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_u00ac] = ACTIONS(37),
    [sym_union] = ACTIONS(39),
    [sym_powerset] = ACTIONS(39),
    [sym_domain] = ACTIONS(39),
    [sym_negative_dot] = ACTIONS(41),
    [sym_enabled] = ACTIONS(39),
    [sym_unchanged] = ACTIONS(39),
    [anon_sym_LT_GT] = ACTIONS(43),
    [anon_sym_u22c4] = ACTIONS(43),
    [anon_sym_u25c7] = ACTIONS(43),
    [anon_sym_ASSUME] = ACTIONS(45),
    [anon_sym_ASSUMPTION] = ACTIONS(45),
    [anon_sym_AXIOM] = ACTIONS(45),
    [anon_sym_THEOREM] = ACTIONS(47),
    [anon_sym_PROPOSITION] = ACTIONS(47),
    [anon_sym_LEMMA] = ACTIONS(47),
    [anon_sym_COROLLARY] = ACTIONS(47),
    [anon_sym_USE] = ACTIONS(49),
    [anon_sym_HIDE] = ACTIONS(49),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3425), 1,
      sym_block_comment,
    ACTIONS(5942), 24,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5940), 28,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_PROVE,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [66] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3426), 1,
      sym_block_comment,
    ACTIONS(6229), 24,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6231), 28,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_PROVE,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [132] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3427), 1,
      sym_block_comment,
    ACTIONS(5467), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5465), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3428), 1,
      sym_block_comment,
    ACTIONS(5499), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5497), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [260] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3429), 1,
      sym_block_comment,
    ACTIONS(5375), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5373), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [324] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3430), 1,
      sym_block_comment,
    ACTIONS(5507), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5505), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [388] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3431), 1,
      sym_block_comment,
    ACTIONS(5383), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5381), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [452] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3432), 1,
      sym_block_comment,
    ACTIONS(5547), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5545), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3433), 1,
      sym_block_comment,
    ACTIONS(5411), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5409), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [580] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3434), 1,
      sym_block_comment,
    ACTIONS(5583), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5581), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3435), 1,
      sym_block_comment,
    ACTIONS(5503), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5501), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [708] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3436), 1,
      sym_block_comment,
    ACTIONS(5511), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5509), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3437), 1,
      sym_block_comment,
    ACTIONS(5587), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5585), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3438), 1,
      sym_block_comment,
    ACTIONS(5639), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5637), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [900] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3439), 1,
      sym_block_comment,
    ACTIONS(5419), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5417), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [964] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3440), 1,
      sym_block_comment,
    ACTIONS(5483), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5481), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1028] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3441), 1,
      sym_block_comment,
    ACTIONS(6233), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6235), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3442), 1,
      sym_block_comment,
    ACTIONS(5439), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5437), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1156] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3443), 1,
      sym_block_comment,
    ACTIONS(5595), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5593), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1220] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3444), 1,
      sym_block_comment,
    ACTIONS(5435), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5433), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1284] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3445), 1,
      sym_block_comment,
    ACTIONS(5463), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5461), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1348] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3446), 1,
      sym_block_comment,
    ACTIONS(5559), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5557), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3447), 1,
      sym_block_comment,
    ACTIONS(5515), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5513), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1476] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3448), 1,
      sym_block_comment,
    ACTIONS(5391), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5389), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3449), 1,
      sym_block_comment,
    ACTIONS(5407), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5405), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1604] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3450), 1,
      sym_block_comment,
    ACTIONS(5491), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5489), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3451), 1,
      sym_block_comment,
    ACTIONS(5527), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5525), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1732] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3452), 1,
      sym_block_comment,
    ACTIONS(5487), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5485), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3453), 1,
      sym_block_comment,
    ACTIONS(5495), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5493), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1860] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3454), 1,
      sym_block_comment,
    ACTIONS(5567), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5565), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3455), 1,
      sym_block_comment,
    ACTIONS(5591), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5589), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [1988] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3456), 1,
      sym_block_comment,
    ACTIONS(5447), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5445), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2052] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3457), 1,
      sym_block_comment,
    ACTIONS(5531), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5529), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3458), 1,
      sym_block_comment,
    ACTIONS(5395), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5393), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3459), 1,
      sym_block_comment,
    ACTIONS(5479), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5477), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3460), 1,
      sym_block_comment,
    ACTIONS(5543), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5541), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3461), 1,
      sym_block_comment,
    ACTIONS(5571), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5569), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2372] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3462), 1,
      sym_block_comment,
    ACTIONS(5603), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5601), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3463), 1,
      sym_block_comment,
    ACTIONS(5607), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5605), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3464), 1,
      sym_block_comment,
    ACTIONS(5651), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5649), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2564] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3465), 1,
      sym_block_comment,
    ACTIONS(5575), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5573), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2628] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3466), 1,
      sym_block_comment,
    ACTIONS(5523), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5521), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3467), 1,
      sym_block_comment,
    ACTIONS(5563), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5561), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3468), 1,
      sym_block_comment,
    ACTIONS(5599), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5597), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2820] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3469), 1,
      sym_block_comment,
    ACTIONS(5635), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5633), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2884] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3470), 1,
      sym_block_comment,
    ACTIONS(5443), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5441), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [2948] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3471), 1,
      sym_block_comment,
    ACTIONS(5423), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5421), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3012] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3472), 1,
      sym_block_comment,
    ACTIONS(324), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(333), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3076] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3473), 1,
      sym_block_comment,
    ACTIONS(5555), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5553), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3140] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3474), 1,
      sym_block_comment,
    ACTIONS(5387), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5385), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3204] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3475), 1,
      sym_block_comment,
    ACTIONS(5371), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5369), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3476), 1,
      sym_block_comment,
    ACTIONS(5551), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5549), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3477), 1,
      sym_block_comment,
    ACTIONS(5627), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5625), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3478), 1,
      sym_block_comment,
    ACTIONS(5379), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5377), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3479), 1,
      sym_block_comment,
    ACTIONS(5611), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5609), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3480), 1,
      sym_block_comment,
    ACTIONS(5427), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5425), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3481), 1,
      sym_block_comment,
    ACTIONS(5471), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5469), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3482), 1,
      sym_block_comment,
    ACTIONS(5647), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5645), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3716] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3483), 1,
      sym_block_comment,
    ACTIONS(5399), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5397), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3780] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3484), 1,
      sym_block_comment,
    ACTIONS(5519), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5517), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3844] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3485), 1,
      sym_block_comment,
    ACTIONS(5535), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5533), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3486), 1,
      sym_block_comment,
    ACTIONS(5539), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5537), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [3972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3487), 1,
      sym_block_comment,
    ACTIONS(5475), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5473), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [4036] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3488), 1,
      sym_block_comment,
    ACTIONS(5455), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5453), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [4100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3489), 1,
      sym_block_comment,
    ACTIONS(5579), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5577), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [4164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3490), 1,
      sym_block_comment,
    ACTIONS(5631), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5629), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [4228] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3491), 1,
      sym_block_comment,
    ACTIONS(5403), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5401), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [4292] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3492), 1,
      sym_block_comment,
    ACTIONS(5451), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5449), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [4356] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6241), 1,
      anon_sym_COMMA,
    STATE(3493), 2,
      sym_block_comment,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6237), 22,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_BSLASHin,
      anon_sym_u2208,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COLON,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6239), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [4421] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2524), 1,
      anon_sym_PROOF,
    ACTIONS(2526), 1,
      anon_sym_BY,
    ACTIONS(2530), 1,
      sym__begin_proof,
    STATE(3494), 1,
      sym_block_comment,
    STATE(3576), 1,
      sym__proof,
    ACTIONS(2528), 2,
      anon_sym_OBVIOUS,
      anon_sym_OMITTED,
    STATE(3575), 2,
      sym_terminal_proof,
      sym_non_terminal_proof,
    ACTIONS(2568), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(2570), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [4495] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2524), 1,
      anon_sym_PROOF,
    ACTIONS(2526), 1,
      anon_sym_BY,
    ACTIONS(2530), 1,
      sym__begin_proof,
    STATE(3495), 1,
      sym_block_comment,
    STATE(3574), 1,
      sym__proof,
    ACTIONS(2528), 2,
      anon_sym_OBVIOUS,
      anon_sym_OMITTED,
    STATE(3575), 2,
      sym_terminal_proof,
      sym_non_terminal_proof,
    ACTIONS(2336), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(2334), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [4569] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3496), 1,
      sym_block_comment,
    ACTIONS(6237), 23,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_BSLASHin,
      anon_sym_u2208,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6239), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [4631] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2562), 1,
      anon_sym_PROOF,
    ACTIONS(2564), 1,
      anon_sym_BY,
    ACTIONS(2566), 1,
      sym__begin_proof,
    STATE(3497), 1,
      sym_block_comment,
    STATE(3574), 1,
      sym__proof,
    ACTIONS(2528), 2,
      anon_sym_OBVIOUS,
      anon_sym_OMITTED,
    STATE(3575), 2,
      sym_terminal_proof,
      sym_non_terminal_proof,
    ACTIONS(2336), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(2334), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [4705] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2562), 1,
      anon_sym_PROOF,
    ACTIONS(2564), 1,
      anon_sym_BY,
    ACTIONS(2566), 1,
      sym__begin_proof,
    STATE(3498), 1,
      sym_block_comment,
    STATE(3572), 1,
      sym__proof,
    ACTIONS(2528), 2,
      anon_sym_OBVIOUS,
      anon_sym_OMITTED,
    STATE(3575), 2,
      sym_terminal_proof,
      sym_non_terminal_proof,
    ACTIONS(6244), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6246), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [4779] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2524), 1,
      anon_sym_PROOF,
    ACTIONS(2526), 1,
      anon_sym_BY,
    ACTIONS(2530), 1,
      sym__begin_proof,
    STATE(3499), 1,
      sym_block_comment,
    STATE(3572), 1,
      sym__proof,
    ACTIONS(2528), 2,
      anon_sym_OBVIOUS,
      anon_sym_OMITTED,
    STATE(3575), 2,
      sym_terminal_proof,
      sym_non_terminal_proof,
    ACTIONS(6244), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6246), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [4853] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2562), 1,
      anon_sym_PROOF,
    ACTIONS(2564), 1,
      anon_sym_BY,
    ACTIONS(2566), 1,
      sym__begin_proof,
    STATE(3500), 1,
      sym_block_comment,
    STATE(3576), 1,
      sym__proof,
    ACTIONS(2528), 2,
      anon_sym_OBVIOUS,
      anon_sym_OMITTED,
    STATE(3575), 2,
      sym_terminal_proof,
      sym_non_terminal_proof,
    ACTIONS(2568), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(2570), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [4927] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3501), 1,
      sym_block_comment,
    ACTIONS(3637), 19,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(3635), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [4986] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3502), 1,
      sym_block_comment,
    ACTIONS(6248), 19,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6250), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [5045] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6252), 1,
      anon_sym_COMMA,
    STATE(3503), 2,
      sym_block_comment,
      aux_sym_use_body_expr_repeat1,
    ACTIONS(3629), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(3627), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_DEF,
      anon_sym_DEFS,
  [5105] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3563), 1,
      anon_sym_COMMA,
    STATE(3504), 1,
      sym_block_comment,
    STATE(3506), 1,
      aux_sym_use_body_expr_repeat1,
    ACTIONS(6257), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6255), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_DEF,
      anon_sym_DEFS,
  [5167] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3595), 1,
      anon_sym_COMMA,
    STATE(3505), 1,
      sym_block_comment,
    STATE(3512), 1,
      aux_sym_use_body_expr_repeat1,
    ACTIONS(3561), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(3559), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_DEF,
      anon_sym_DEFS,
  [5229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      anon_sym_COMMA,
    STATE(3506), 2,
      sym_block_comment,
      aux_sym_use_body_expr_repeat1,
    ACTIONS(3629), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(3627), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_DEF,
      anon_sym_DEFS,
  [5289] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3563), 1,
      anon_sym_COMMA,
    STATE(3504), 1,
      aux_sym_use_body_expr_repeat1,
    STATE(3507), 1,
      sym_block_comment,
    ACTIONS(3561), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(3559), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_DEF,
      anon_sym_DEFS,
  [5351] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6266), 1,
      anon_sym_LPAREN,
    STATE(3508), 1,
      sym_block_comment,
    ACTIONS(6262), 18,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6264), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [5411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3509), 1,
      sym_block_comment,
    ACTIONS(6268), 18,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6270), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [5469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3510), 1,
      sym_block_comment,
    ACTIONS(6272), 18,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6274), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [5527] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6276), 1,
      aux_sym_octal_number_token1,
    STATE(3511), 1,
      sym_block_comment,
    ACTIONS(5391), 17,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5389), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [5587] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3595), 1,
      anon_sym_COMMA,
    STATE(3503), 1,
      aux_sym_use_body_expr_repeat1,
    STATE(3512), 1,
      sym_block_comment,
    ACTIONS(6257), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6255), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_DEF,
      anon_sym_DEFS,
  [5649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3513), 1,
      sym_block_comment,
    ACTIONS(6278), 18,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6280), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [5707] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3514), 1,
      sym_block_comment,
    ACTIONS(6282), 17,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6284), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_DEF,
      anon_sym_DEFS,
  [5765] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6286), 1,
      aux_sym_octal_number_token1,
    STATE(3515), 1,
      sym_block_comment,
    ACTIONS(5391), 17,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5389), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [5825] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6288), 1,
      aux_sym_proof_step_ref_token1,
    STATE(3516), 1,
      sym_block_comment,
    ACTIONS(5415), 17,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5413), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [5885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3517), 1,
      sym_block_comment,
    ACTIONS(6290), 18,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6292), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_PROVE,
      anon_sym_USE,
      anon_sym_HIDE,
  [5943] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6294), 1,
      aux_sym_proof_step_ref_token1,
    STATE(3518), 1,
      sym_block_comment,
    ACTIONS(5415), 17,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5413), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [6003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3519), 1,
      sym_block_comment,
    ACTIONS(6296), 18,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6298), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_PROVE,
      anon_sym_USE,
      anon_sym_HIDE,
  [6061] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3520), 1,
      sym_block_comment,
    ACTIONS(3629), 17,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(3627), 27,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_DEF,
      anon_sym_DEFS,
  [6119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3521), 1,
      sym_block_comment,
    ACTIONS(6300), 18,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6302), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_PROVE,
      anon_sym_USE,
      anon_sym_HIDE,
  [6177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3522), 1,
      sym_block_comment,
    ACTIONS(6304), 18,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6306), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_PROVE,
      anon_sym_USE,
      anon_sym_HIDE,
  [6235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3523), 1,
      sym_block_comment,
    ACTIONS(6308), 18,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6310), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_PROVE,
      anon_sym_USE,
      anon_sym_HIDE,
  [6293] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3524), 1,
      sym_block_comment,
    ACTIONS(6312), 17,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6314), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [6350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3525), 1,
      sym_block_comment,
    ACTIONS(6316), 17,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6318), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [6407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3526), 1,
      sym_block_comment,
    ACTIONS(6320), 17,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6322), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [6464] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(3527), 1,
      sym_block_comment,
    ACTIONS(6324), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6326), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [6525] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3528), 1,
      sym_block_comment,
    ACTIONS(6328), 17,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6330), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
      anon_sym_end,
  [6582] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    STATE(3527), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(3529), 1,
      sym_block_comment,
    ACTIONS(6332), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6334), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [6643] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3530), 1,
      sym_block_comment,
    ACTIONS(6262), 18,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6264), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [6700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3531), 1,
      sym_block_comment,
    ACTIONS(5942), 17,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(5940), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [6757] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3532), 1,
      sym_block_comment,
    ACTIONS(6229), 17,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6231), 26,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [6814] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3533), 1,
      sym_block_comment,
    STATE(3597), 1,
      sym_use_body_def,
    ACTIONS(576), 2,
      anon_sym_DEF,
      anon_sym_DEFS,
    ACTIONS(6338), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6336), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [6875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3534), 1,
      sym_block_comment,
    ACTIONS(6340), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6342), 27,
      anon_sym_MODULE,
      sym_identifier,
      anon_sym_EXTENDS,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [6932] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6344), 1,
      anon_sym_LPAREN,
    STATE(3535), 1,
      sym_block_comment,
    ACTIONS(6248), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6250), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [6993] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6346), 1,
      anon_sym_LPAREN,
    STATE(3536), 1,
      sym_block_comment,
    ACTIONS(6248), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6250), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7054] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6348), 1,
      anon_sym_LPAREN,
    STATE(3537), 1,
      sym_block_comment,
    ACTIONS(6248), 16,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6250), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7115] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3538), 1,
      sym_block_comment,
    STATE(3597), 1,
      sym_use_body_def,
    ACTIONS(600), 2,
      anon_sym_DEF,
      anon_sym_DEFS,
    ACTIONS(6338), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6336), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7176] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6354), 1,
      anon_sym_COMMA,
    STATE(3539), 2,
      sym_block_comment,
      aux_sym_extends_repeat1,
    ACTIONS(6352), 16,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6350), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3540), 1,
      sym_block_comment,
    ACTIONS(6357), 18,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6359), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6361), 1,
      anon_sym_COMMA,
    STATE(3541), 2,
      sym_block_comment,
      aux_sym_constant_declaration_repeat1,
    ACTIONS(6357), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6359), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7351] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6364), 1,
      anon_sym_LPAREN,
    STATE(3542), 1,
      sym_block_comment,
    ACTIONS(6248), 16,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6250), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7412] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6366), 1,
      anon_sym_COMMA,
    STATE(3543), 2,
      sym_block_comment,
      aux_sym_constant_declaration_repeat1,
    ACTIONS(6357), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6359), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7470] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6373), 1,
      anon_sym_COMMA,
    STATE(3544), 1,
      sym_block_comment,
    STATE(3546), 1,
      aux_sym_instance_repeat1,
    ACTIONS(6371), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6369), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7530] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    STATE(3545), 1,
      sym_block_comment,
    STATE(3568), 1,
      aux_sym_extends_repeat1,
    ACTIONS(6377), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6375), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7590] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6381), 1,
      anon_sym_COMMA,
    STATE(3546), 2,
      sym_block_comment,
      aux_sym_instance_repeat1,
    ACTIONS(6278), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6280), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7648] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    STATE(3547), 1,
      sym_block_comment,
    STATE(3549), 1,
      aux_sym_constant_declaration_repeat1,
    ACTIONS(6384), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6386), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7708] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    STATE(3548), 1,
      sym_block_comment,
    STATE(3551), 1,
      aux_sym_constant_declaration_repeat1,
    ACTIONS(6390), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6392), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7768] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    STATE(3541), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(3549), 1,
      sym_block_comment,
    ACTIONS(6394), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6396), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7828] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6402), 1,
      anon_sym_COMMA,
    STATE(3550), 1,
      sym_block_comment,
    STATE(3559), 1,
      aux_sym_use_body_def_repeat1,
    ACTIONS(6398), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6400), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7888] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    STATE(3541), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(3551), 1,
      sym_block_comment,
    ACTIONS(6404), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6406), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [7948] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6408), 1,
      anon_sym_COMMA,
    STATE(3543), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(3552), 1,
      sym_block_comment,
    ACTIONS(6394), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6396), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8008] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6373), 1,
      anon_sym_COMMA,
    STATE(3544), 1,
      aux_sym_instance_repeat1,
    STATE(3553), 1,
      sym_block_comment,
    ACTIONS(6412), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6410), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8068] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6414), 1,
      anon_sym_COMMA,
    STATE(3554), 1,
      sym_block_comment,
    STATE(3561), 1,
      aux_sym_instance_repeat1,
    ACTIONS(6371), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6369), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8128] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6416), 1,
      anon_sym_COMMA,
    STATE(3555), 1,
      sym_block_comment,
    STATE(3556), 1,
      aux_sym_use_body_def_repeat1,
    ACTIONS(6398), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6400), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8188] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6422), 1,
      anon_sym_COMMA,
    STATE(3556), 2,
      sym_block_comment,
      aux_sym_use_body_def_repeat1,
    ACTIONS(6420), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6418), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8246] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6402), 1,
      anon_sym_COMMA,
    STATE(3550), 1,
      aux_sym_use_body_def_repeat1,
    STATE(3557), 1,
      sym_block_comment,
    ACTIONS(6425), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6427), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8306] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3558), 1,
      sym_block_comment,
    ACTIONS(6420), 17,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6418), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8362] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6429), 1,
      anon_sym_COMMA,
    STATE(3559), 2,
      sym_block_comment,
      aux_sym_use_body_def_repeat1,
    ACTIONS(6420), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6418), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8420] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6408), 1,
      anon_sym_COMMA,
    STATE(3552), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(3560), 1,
      sym_block_comment,
    ACTIONS(6384), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6386), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8480] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6432), 1,
      anon_sym_COMMA,
    STATE(3561), 2,
      sym_block_comment,
      aux_sym_instance_repeat1,
    ACTIONS(6278), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6280), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6408), 1,
      anon_sym_COMMA,
    STATE(3562), 1,
      sym_block_comment,
    STATE(3567), 1,
      aux_sym_constant_declaration_repeat1,
    ACTIONS(6390), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6392), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3563), 1,
      sym_block_comment,
    ACTIONS(6437), 17,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6435), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8654] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6416), 1,
      anon_sym_COMMA,
    STATE(3555), 1,
      aux_sym_use_body_def_repeat1,
    STATE(3564), 1,
      sym_block_comment,
    ACTIONS(6425), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6427), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8714] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6443), 1,
      anon_sym_MODULE,
    STATE(3565), 1,
      sym_block_comment,
    ACTIONS(6439), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6441), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8772] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6414), 1,
      anon_sym_COMMA,
    STATE(3554), 1,
      aux_sym_instance_repeat1,
    STATE(3566), 1,
      sym_block_comment,
    ACTIONS(6412), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6410), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8832] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6408), 1,
      anon_sym_COMMA,
    STATE(3543), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(3567), 1,
      sym_block_comment,
    ACTIONS(6404), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6406), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8892] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(3568), 1,
      sym_block_comment,
    ACTIONS(6447), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6445), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [8952] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3569), 1,
      sym_block_comment,
    ACTIONS(6449), 16,
      sym_trailing_extramodular_text,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6451), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9007] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3570), 1,
      sym_block_comment,
    ACTIONS(6453), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6455), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9062] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6461), 1,
      anon_sym_WITH,
    STATE(3571), 1,
      sym_block_comment,
    ACTIONS(6457), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6459), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3572), 1,
      sym_block_comment,
    ACTIONS(6463), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6465), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3573), 1,
      sym_block_comment,
    ACTIONS(6467), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6469), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9229] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3574), 1,
      sym_block_comment,
    ACTIONS(6471), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6473), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9284] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3575), 1,
      sym_block_comment,
    ACTIONS(6475), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6477), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9339] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3576), 1,
      sym_block_comment,
    ACTIONS(6479), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6481), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9394] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3577), 1,
      sym_block_comment,
    ACTIONS(6449), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6451), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3578), 1,
      sym_block_comment,
    ACTIONS(6439), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6441), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9504] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3579), 1,
      sym_block_comment,
    ACTIONS(6483), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6485), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3580), 1,
      sym_block_comment,
    ACTIONS(6487), 16,
      sym_trailing_extramodular_text,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6489), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3581), 1,
      sym_block_comment,
    ACTIONS(6491), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6493), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3582), 1,
      sym_block_comment,
    ACTIONS(6495), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6497), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3583), 1,
      sym_block_comment,
    ACTIONS(6499), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6501), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3584), 1,
      sym_block_comment,
    ACTIONS(6487), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6489), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9834] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3585), 1,
      sym_block_comment,
    ACTIONS(6503), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6505), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6507), 1,
      anon_sym_WITH,
    STATE(3586), 1,
      sym_block_comment,
    ACTIONS(6457), 15,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6459), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [9946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3587), 1,
      sym_block_comment,
    ACTIONS(6338), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6336), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [10001] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3588), 1,
      sym_block_comment,
    ACTIONS(6509), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6511), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [10056] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3589), 1,
      sym_block_comment,
    ACTIONS(6513), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6515), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [10111] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3590), 1,
      sym_block_comment,
    ACTIONS(6517), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6519), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [10166] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6523), 1,
      sym_trailing_extramodular_text,
    STATE(3591), 1,
      sym_block_comment,
    ACTIONS(6521), 2,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
    ACTIONS(6439), 13,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6441), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [10225] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6525), 1,
      anon_sym_MODULE,
    STATE(3592), 1,
      sym_block_comment,
    ACTIONS(6439), 15,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6441), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [10282] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3593), 1,
      sym_block_comment,
    ACTIONS(6527), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6529), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [10337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3594), 1,
      sym_block_comment,
    ACTIONS(6531), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6533), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [10392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3595), 1,
      sym_block_comment,
    ACTIONS(6495), 16,
      sym_trailing_extramodular_text,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6497), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [10447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3596), 1,
      sym_block_comment,
    ACTIONS(6499), 16,
      sym_trailing_extramodular_text,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6501), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [10502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3597), 1,
      sym_block_comment,
    ACTIONS(6535), 16,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
      anon_sym_EQ_EQ_EQ_EQ,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    ACTIONS(6537), 25,
      sym_identifier,
      anon_sym_LOCAL,
      anon_sym_VARIABLE,
      anon_sym_VARIABLES,
      anon_sym_CONSTANT,
      anon_sym_CONSTANTS,
      anon_sym_RECURSIVE,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_ASSUME,
      anon_sym_ASSUMPTION,
      anon_sym_AXIOM,
      anon_sym_THEOREM,
      anon_sym_PROPOSITION,
      anon_sym_LEMMA,
      anon_sym_COROLLARY,
      anon_sym_USE,
      anon_sym_HIDE,
  [10557] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6539), 1,
      sym_identifier,
    ACTIONS(6545), 1,
      anon_sym_INSTANCE,
    ACTIONS(6548), 1,
      anon_sym_Nat,
    ACTIONS(6551), 1,
      anon_sym_u2115,
    ACTIONS(6554), 1,
      anon_sym_Int,
    ACTIONS(6557), 1,
      anon_sym_u2124,
    ACTIONS(6560), 1,
      anon_sym_Real,
    ACTIONS(6563), 1,
      anon_sym_u211d,
    ACTIONS(6566), 1,
      anon_sym_RBRACE,
    ACTIONS(6574), 1,
      sym_negative_dot,
    ACTIONS(6580), 1,
      anon_sym_end,
    STATE(3832), 1,
      sym__definition,
    STATE(4406), 1,
      sym__number_set,
    STATE(5099), 1,
      sym_prefix_op_symbol,
    ACTIONS(6542), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    STATE(3598), 2,
      sym_block_comment,
      aux_sym_pcal_p_definitions_repeat1,
    ACTIONS(6577), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(6568), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3528), 4,
      sym_operator_definition,
      sym_function_definition,
      sym_instance,
      sym_module_definition,
    ACTIONS(6571), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [10648] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(1704), 1,
      anon_sym_INSTANCE,
    ACTIONS(6582), 1,
      sym_identifier,
    ACTIONS(6584), 1,
      anon_sym_RBRACE,
    STATE(3598), 1,
      aux_sym_pcal_p_definitions_repeat1,
    STATE(3599), 1,
      sym_block_comment,
    STATE(3832), 1,
      sym__definition,
    STATE(4406), 1,
      sym__number_set,
    STATE(5099), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3528), 4,
      sym_operator_definition,
      sym_function_definition,
      sym_instance,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [10738] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(1704), 1,
      anon_sym_INSTANCE,
    ACTIONS(6582), 1,
      sym_identifier,
    ACTIONS(6586), 1,
      anon_sym_end,
    STATE(3598), 1,
      aux_sym_pcal_p_definitions_repeat1,
    STATE(3600), 1,
      sym_block_comment,
    STATE(3832), 1,
      sym__definition,
    STATE(4406), 1,
      sym__number_set,
    STATE(5099), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3528), 4,
      sym_operator_definition,
      sym_function_definition,
      sym_instance,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [10828] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6592), 1,
      anon_sym_IN,
    STATE(3601), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [10915] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6594), 1,
      anon_sym_IN,
    STATE(3602), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [11002] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6596), 1,
      anon_sym_IN,
    STATE(3603), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [11089] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6598), 1,
      anon_sym_IN,
    STATE(3604), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [11176] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6600), 1,
      anon_sym_IN,
    STATE(3605), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [11263] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(1704), 1,
      anon_sym_INSTANCE,
    ACTIONS(6582), 1,
      sym_identifier,
    STATE(3599), 1,
      aux_sym_pcal_p_definitions_repeat1,
    STATE(3606), 1,
      sym_block_comment,
    STATE(3832), 1,
      sym__definition,
    STATE(4406), 1,
      sym__number_set,
    STATE(5099), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3528), 4,
      sym_operator_definition,
      sym_function_definition,
      sym_instance,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [11350] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6602), 1,
      anon_sym_IN,
    STATE(3607), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [11437] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(1704), 1,
      anon_sym_INSTANCE,
    ACTIONS(6582), 1,
      sym_identifier,
    STATE(3600), 1,
      aux_sym_pcal_p_definitions_repeat1,
    STATE(3608), 1,
      sym_block_comment,
    STATE(3832), 1,
      sym__definition,
    STATE(4406), 1,
      sym__number_set,
    STATE(5099), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3528), 4,
      sym_operator_definition,
      sym_function_definition,
      sym_instance,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [11524] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6604), 1,
      anon_sym_IN,
    STATE(3609), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [11611] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6606), 1,
      anon_sym_IN,
    STATE(3610), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [11698] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6608), 1,
      anon_sym_IN,
    STATE(3611), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [11785] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6610), 1,
      anon_sym_IN,
    STATE(3612), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [11872] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6612), 1,
      anon_sym_IN,
    STATE(3613), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [11959] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6614), 1,
      anon_sym_IN,
    STATE(3614), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [12046] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6616), 1,
      anon_sym_IN,
    STATE(3615), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [12133] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6618), 1,
      anon_sym_IN,
    STATE(3616), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [12220] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6620), 1,
      anon_sym_IN,
    STATE(3617), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [12307] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6622), 1,
      anon_sym_IN,
    STATE(3618), 1,
      sym_block_comment,
    STATE(3619), 1,
      aux_sym_let_in_repeat1,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [12394] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6624), 1,
      sym_identifier,
    ACTIONS(6630), 1,
      anon_sym_RECURSIVE,
    ACTIONS(6633), 1,
      anon_sym_Nat,
    ACTIONS(6636), 1,
      anon_sym_u2115,
    ACTIONS(6639), 1,
      anon_sym_Int,
    ACTIONS(6642), 1,
      anon_sym_u2124,
    ACTIONS(6645), 1,
      anon_sym_Real,
    ACTIONS(6648), 1,
      anon_sym_u211d,
    ACTIONS(6651), 1,
      anon_sym_IN,
    ACTIONS(6659), 1,
      sym_negative_dot,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(6627), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    STATE(3619), 2,
      sym_block_comment,
      aux_sym_let_in_repeat1,
    ACTIONS(6662), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(6653), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(6656), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [12479] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3613), 1,
      aux_sym_let_in_repeat1,
    STATE(3620), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [12563] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(1774), 1,
      anon_sym_INSTANCE,
    ACTIONS(6118), 1,
      sym_identifier,
    STATE(3570), 1,
      sym__definition,
    STATE(3621), 1,
      sym_block_comment,
    STATE(4360), 1,
      sym__number_set,
    STATE(5170), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3528), 4,
      sym_operator_definition,
      sym_function_definition,
      sym_instance,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [12647] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3618), 1,
      aux_sym_let_in_repeat1,
    STATE(3622), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [12731] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3612), 1,
      aux_sym_let_in_repeat1,
    STATE(3623), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [12815] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3617), 1,
      aux_sym_let_in_repeat1,
    STATE(3624), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [12899] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3614), 1,
      aux_sym_let_in_repeat1,
    STATE(3625), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [12983] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3616), 1,
      aux_sym_let_in_repeat1,
    STATE(3626), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [13067] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3602), 1,
      aux_sym_let_in_repeat1,
    STATE(3627), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [13151] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3615), 1,
      aux_sym_let_in_repeat1,
    STATE(3628), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [13235] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3609), 1,
      aux_sym_let_in_repeat1,
    STATE(3629), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [13319] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3607), 1,
      aux_sym_let_in_repeat1,
    STATE(3630), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [13403] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3605), 1,
      aux_sym_let_in_repeat1,
    STATE(3631), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [13487] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3603), 1,
      aux_sym_let_in_repeat1,
    STATE(3632), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [13571] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3610), 1,
      aux_sym_let_in_repeat1,
    STATE(3633), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [13655] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3604), 1,
      aux_sym_let_in_repeat1,
    STATE(3634), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [13739] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(23), 1,
      anon_sym_INSTANCE,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    STATE(3570), 1,
      sym__definition,
    STATE(3635), 1,
      sym_block_comment,
    STATE(4382), 1,
      sym__number_set,
    STATE(5171), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3528), 4,
      sym_operator_definition,
      sym_function_definition,
      sym_instance,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [13823] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3611), 1,
      aux_sym_let_in_repeat1,
    STATE(3636), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [13907] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6588), 1,
      sym_identifier,
    ACTIONS(6590), 1,
      anon_sym_RECURSIVE,
    STATE(3601), 1,
      aux_sym_let_in_repeat1,
    STATE(3637), 1,
      sym_block_comment,
    STATE(4319), 1,
      sym__number_set,
    STATE(5440), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    STATE(3849), 4,
      sym_recursive_declaration,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [13991] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6665), 1,
      sym_identifier,
    ACTIONS(6667), 1,
      sym__begin_proof_step,
    STATE(3638), 1,
      sym_block_comment,
    STATE(3639), 1,
      aux_sym_definition_proof_step_repeat1,
    STATE(4337), 1,
      sym__number_set,
    STATE(5240), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(3862), 3,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [14074] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6669), 1,
      sym_identifier,
    ACTIONS(6675), 1,
      anon_sym_Nat,
    ACTIONS(6678), 1,
      anon_sym_u2115,
    ACTIONS(6681), 1,
      anon_sym_Int,
    ACTIONS(6684), 1,
      anon_sym_u2124,
    ACTIONS(6687), 1,
      anon_sym_Real,
    ACTIONS(6690), 1,
      anon_sym_u211d,
    ACTIONS(6699), 1,
      sym_negative_dot,
    ACTIONS(6705), 1,
      sym__begin_proof_step,
    STATE(4337), 1,
      sym__number_set,
    STATE(5240), 1,
      sym_prefix_op_symbol,
    ACTIONS(6672), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    STATE(3639), 2,
      sym_block_comment,
      aux_sym_definition_proof_step_repeat1,
    ACTIONS(6702), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(3862), 3,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(6693), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6696), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [14155] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6665), 1,
      sym_identifier,
    ACTIONS(6707), 1,
      sym__begin_proof_step,
    STATE(3639), 1,
      aux_sym_definition_proof_step_repeat1,
    STATE(3640), 1,
      sym_block_comment,
    STATE(4337), 1,
      sym__number_set,
    STATE(5240), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(3862), 3,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [14238] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(25), 1,
      anon_sym_Nat,
    ACTIONS(27), 1,
      anon_sym_u2115,
    ACTIONS(29), 1,
      anon_sym_Int,
    ACTIONS(31), 1,
      anon_sym_u2124,
    ACTIONS(33), 1,
      anon_sym_Real,
    ACTIONS(35), 1,
      anon_sym_u211d,
    ACTIONS(41), 1,
      sym_negative_dot,
    ACTIONS(6665), 1,
      sym_identifier,
    STATE(3640), 1,
      aux_sym_definition_proof_step_repeat1,
    STATE(3641), 1,
      sym_block_comment,
    STATE(4337), 1,
      sym__number_set,
    STATE(5240), 1,
      sym_prefix_op_symbol,
    ACTIONS(11), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(43), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(3472), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    STATE(3862), 3,
      sym_operator_definition,
      sym_function_definition,
      sym_module_definition,
    STATE(4546), 3,
      sym_nat_number_set,
      sym_int_number_set,
      sym_real_number_set,
    ACTIONS(37), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(39), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [14318] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6713), 1,
      anon_sym_RBRACE,
    ACTIONS(6715), 1,
      anon_sym_if,
    ACTIONS(6717), 1,
      anon_sym_while,
    ACTIONS(6719), 1,
      anon_sym_either,
    ACTIONS(6721), 1,
      anon_sym_with,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    STATE(3642), 1,
      sym_block_comment,
    STATE(3670), 1,
      sym__pcal_label,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(5011), 1,
      sym__pcal_c_stmt,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6729), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4379), 2,
      sym_pcal_c_algorithm_body,
      sym__pcal_c_unlabeled_stmt,
    STATE(4375), 11,
      sym_pcal_assign,
      sym_pcal_c_if,
      sym_pcal_c_while,
      sym_pcal_c_either,
      sym_pcal_c_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [14395] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      anon_sym_if,
    ACTIONS(6717), 1,
      anon_sym_while,
    ACTIONS(6719), 1,
      anon_sym_either,
    ACTIONS(6721), 1,
      anon_sym_with,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6735), 1,
      anon_sym_RBRACE,
    STATE(3643), 1,
      sym_block_comment,
    STATE(3670), 1,
      sym__pcal_label,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(5011), 1,
      sym__pcal_c_stmt,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6729), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4379), 2,
      sym_pcal_c_algorithm_body,
      sym__pcal_c_unlabeled_stmt,
    STATE(4375), 11,
      sym_pcal_assign,
      sym_pcal_c_if,
      sym_pcal_c_while,
      sym_pcal_c_either,
      sym_pcal_c_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [14472] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      anon_sym_if,
    ACTIONS(6717), 1,
      anon_sym_while,
    ACTIONS(6719), 1,
      anon_sym_either,
    ACTIONS(6721), 1,
      anon_sym_with,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    STATE(3644), 1,
      sym_block_comment,
    STATE(3670), 1,
      sym__pcal_label,
    STATE(4294), 1,
      sym__pcal_c_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6729), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4379), 2,
      sym_pcal_c_algorithm_body,
      sym__pcal_c_unlabeled_stmt,
    STATE(4375), 11,
      sym_pcal_assign,
      sym_pcal_c_if,
      sym_pcal_c_while,
      sym_pcal_c_either,
      sym_pcal_c_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [14546] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      anon_sym_if,
    ACTIONS(6717), 1,
      anon_sym_while,
    ACTIONS(6719), 1,
      anon_sym_either,
    ACTIONS(6721), 1,
      anon_sym_with,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    STATE(3645), 1,
      sym_block_comment,
    STATE(3670), 1,
      sym__pcal_label,
    STATE(4268), 1,
      sym__pcal_c_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6729), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4379), 2,
      sym_pcal_c_algorithm_body,
      sym__pcal_c_unlabeled_stmt,
    STATE(4375), 11,
      sym_pcal_assign,
      sym_pcal_c_if,
      sym_pcal_c_while,
      sym_pcal_c_either,
      sym_pcal_c_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [14620] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6737), 1,
      anon_sym_if,
    ACTIONS(6739), 1,
      anon_sym_while,
    ACTIONS(6741), 1,
      anon_sym_either,
    ACTIONS(6743), 1,
      anon_sym_with,
    STATE(3646), 1,
      sym_block_comment,
    STATE(3661), 1,
      aux_sym__pcal_p_stmts_repeat1,
    STATE(3755), 1,
      sym__pcal_label,
    STATE(4145), 1,
      sym__pcal_p_stmt,
    STATE(4146), 1,
      sym__pcal_p_unlabeled_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(5354), 1,
      sym__pcal_p_stmts,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6745), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4194), 11,
      sym_pcal_assign,
      sym_pcal_p_if,
      sym_pcal_p_while,
      sym_pcal_p_either,
      sym_pcal_p_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [14696] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      anon_sym_if,
    ACTIONS(6717), 1,
      anon_sym_while,
    ACTIONS(6719), 1,
      anon_sym_either,
    ACTIONS(6721), 1,
      anon_sym_with,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    STATE(3647), 1,
      sym_block_comment,
    STATE(3670), 1,
      sym__pcal_label,
    STATE(4362), 1,
      sym__pcal_c_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6729), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4379), 2,
      sym_pcal_c_algorithm_body,
      sym__pcal_c_unlabeled_stmt,
    STATE(4375), 11,
      sym_pcal_assign,
      sym_pcal_c_if,
      sym_pcal_c_while,
      sym_pcal_c_either,
      sym_pcal_c_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [14770] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6737), 1,
      anon_sym_if,
    ACTIONS(6739), 1,
      anon_sym_while,
    ACTIONS(6741), 1,
      anon_sym_either,
    ACTIONS(6743), 1,
      anon_sym_with,
    STATE(3648), 1,
      sym_block_comment,
    STATE(3661), 1,
      aux_sym__pcal_p_stmts_repeat1,
    STATE(3755), 1,
      sym__pcal_label,
    STATE(4145), 1,
      sym__pcal_p_stmt,
    STATE(4146), 1,
      sym__pcal_p_unlabeled_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(4958), 1,
      sym__pcal_p_stmts,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6745), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4194), 11,
      sym_pcal_assign,
      sym_pcal_p_if,
      sym_pcal_p_while,
      sym_pcal_p_either,
      sym_pcal_p_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [14846] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      anon_sym_if,
    ACTIONS(6717), 1,
      anon_sym_while,
    ACTIONS(6719), 1,
      anon_sym_either,
    ACTIONS(6721), 1,
      anon_sym_with,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    STATE(3649), 1,
      sym_block_comment,
    STATE(3670), 1,
      sym__pcal_label,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(4763), 1,
      sym__pcal_c_stmt,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6729), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4379), 2,
      sym_pcal_c_algorithm_body,
      sym__pcal_c_unlabeled_stmt,
    STATE(4375), 11,
      sym_pcal_assign,
      sym_pcal_c_if,
      sym_pcal_c_while,
      sym_pcal_c_either,
      sym_pcal_c_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [14920] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6737), 1,
      anon_sym_if,
    ACTIONS(6739), 1,
      anon_sym_while,
    ACTIONS(6741), 1,
      anon_sym_either,
    ACTIONS(6743), 1,
      anon_sym_with,
    STATE(3650), 1,
      sym_block_comment,
    STATE(3661), 1,
      aux_sym__pcal_p_stmts_repeat1,
    STATE(3755), 1,
      sym__pcal_label,
    STATE(4145), 1,
      sym__pcal_p_stmt,
    STATE(4146), 1,
      sym__pcal_p_unlabeled_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(4910), 1,
      sym__pcal_p_stmts,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6745), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4194), 11,
      sym_pcal_assign,
      sym_pcal_p_if,
      sym_pcal_p_while,
      sym_pcal_p_either,
      sym_pcal_p_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [14996] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      anon_sym_if,
    ACTIONS(6717), 1,
      anon_sym_while,
    ACTIONS(6719), 1,
      anon_sym_either,
    ACTIONS(6721), 1,
      anon_sym_with,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    STATE(3651), 1,
      sym_block_comment,
    STATE(3670), 1,
      sym__pcal_label,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(5032), 1,
      sym__pcal_c_stmt,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6729), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4379), 2,
      sym_pcal_c_algorithm_body,
      sym__pcal_c_unlabeled_stmt,
    STATE(4375), 11,
      sym_pcal_assign,
      sym_pcal_c_if,
      sym_pcal_c_while,
      sym_pcal_c_either,
      sym_pcal_c_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [15070] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6737), 1,
      anon_sym_if,
    ACTIONS(6739), 1,
      anon_sym_while,
    ACTIONS(6741), 1,
      anon_sym_either,
    ACTIONS(6743), 1,
      anon_sym_with,
    STATE(3652), 1,
      sym_block_comment,
    STATE(3661), 1,
      aux_sym__pcal_p_stmts_repeat1,
    STATE(3755), 1,
      sym__pcal_label,
    STATE(4145), 1,
      sym__pcal_p_stmt,
    STATE(4146), 1,
      sym__pcal_p_unlabeled_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(5152), 1,
      sym__pcal_p_stmts,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6745), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4194), 11,
      sym_pcal_assign,
      sym_pcal_p_if,
      sym_pcal_p_while,
      sym_pcal_p_either,
      sym_pcal_p_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [15146] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      anon_sym_if,
    ACTIONS(6717), 1,
      anon_sym_while,
    ACTIONS(6719), 1,
      anon_sym_either,
    ACTIONS(6721), 1,
      anon_sym_with,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    STATE(3653), 1,
      sym_block_comment,
    STATE(3670), 1,
      sym__pcal_label,
    STATE(4300), 1,
      sym__pcal_c_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6729), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4379), 2,
      sym_pcal_c_algorithm_body,
      sym__pcal_c_unlabeled_stmt,
    STATE(4375), 11,
      sym_pcal_assign,
      sym_pcal_c_if,
      sym_pcal_c_while,
      sym_pcal_c_either,
      sym_pcal_c_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [15220] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      anon_sym_if,
    ACTIONS(6717), 1,
      anon_sym_while,
    ACTIONS(6719), 1,
      anon_sym_either,
    ACTIONS(6721), 1,
      anon_sym_with,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    STATE(3654), 1,
      sym_block_comment,
    STATE(3670), 1,
      sym__pcal_label,
    STATE(4289), 1,
      sym__pcal_c_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6729), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4379), 2,
      sym_pcal_c_algorithm_body,
      sym__pcal_c_unlabeled_stmt,
    STATE(4375), 11,
      sym_pcal_assign,
      sym_pcal_c_if,
      sym_pcal_c_while,
      sym_pcal_c_either,
      sym_pcal_c_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [15294] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6737), 1,
      anon_sym_if,
    ACTIONS(6739), 1,
      anon_sym_while,
    ACTIONS(6741), 1,
      anon_sym_either,
    ACTIONS(6743), 1,
      anon_sym_with,
    STATE(3655), 1,
      sym_block_comment,
    STATE(3661), 1,
      aux_sym__pcal_p_stmts_repeat1,
    STATE(3755), 1,
      sym__pcal_label,
    STATE(4145), 1,
      sym__pcal_p_stmt,
    STATE(4146), 1,
      sym__pcal_p_unlabeled_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(5344), 1,
      sym__pcal_p_stmts,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6745), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4194), 11,
      sym_pcal_assign,
      sym_pcal_p_if,
      sym_pcal_p_while,
      sym_pcal_p_either,
      sym_pcal_p_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [15370] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6737), 1,
      anon_sym_if,
    ACTIONS(6739), 1,
      anon_sym_while,
    ACTIONS(6741), 1,
      anon_sym_either,
    ACTIONS(6743), 1,
      anon_sym_with,
    STATE(3656), 1,
      sym_block_comment,
    STATE(3661), 1,
      aux_sym__pcal_p_stmts_repeat1,
    STATE(3755), 1,
      sym__pcal_label,
    STATE(4145), 1,
      sym__pcal_p_stmt,
    STATE(4146), 1,
      sym__pcal_p_unlabeled_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(5180), 1,
      sym__pcal_p_stmts,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6745), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4194), 11,
      sym_pcal_assign,
      sym_pcal_p_if,
      sym_pcal_p_while,
      sym_pcal_p_either,
      sym_pcal_p_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [15446] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6737), 1,
      anon_sym_if,
    ACTIONS(6739), 1,
      anon_sym_while,
    ACTIONS(6741), 1,
      anon_sym_either,
    ACTIONS(6743), 1,
      anon_sym_with,
    STATE(3657), 1,
      sym_block_comment,
    STATE(3661), 1,
      aux_sym__pcal_p_stmts_repeat1,
    STATE(3755), 1,
      sym__pcal_label,
    STATE(4145), 1,
      sym__pcal_p_stmt,
    STATE(4146), 1,
      sym__pcal_p_unlabeled_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(5223), 1,
      sym__pcal_p_stmts,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6745), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4194), 11,
      sym_pcal_assign,
      sym_pcal_p_if,
      sym_pcal_p_while,
      sym_pcal_p_either,
      sym_pcal_p_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [15522] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6737), 1,
      anon_sym_if,
    ACTIONS(6739), 1,
      anon_sym_while,
    ACTIONS(6741), 1,
      anon_sym_either,
    ACTIONS(6743), 1,
      anon_sym_with,
    STATE(3658), 1,
      sym_block_comment,
    STATE(3661), 1,
      aux_sym__pcal_p_stmts_repeat1,
    STATE(3755), 1,
      sym__pcal_label,
    STATE(4145), 1,
      sym__pcal_p_stmt,
    STATE(4146), 1,
      sym__pcal_p_unlabeled_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(5004), 1,
      sym__pcal_p_stmts,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6745), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4194), 11,
      sym_pcal_assign,
      sym_pcal_p_if,
      sym_pcal_p_while,
      sym_pcal_p_either,
      sym_pcal_p_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [15598] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6737), 1,
      anon_sym_if,
    ACTIONS(6739), 1,
      anon_sym_while,
    ACTIONS(6741), 1,
      anon_sym_either,
    ACTIONS(6743), 1,
      anon_sym_with,
    STATE(3659), 1,
      sym_block_comment,
    STATE(3661), 1,
      aux_sym__pcal_p_stmts_repeat1,
    STATE(3755), 1,
      sym__pcal_label,
    STATE(4145), 1,
      sym__pcal_p_stmt,
    STATE(4146), 1,
      sym__pcal_p_unlabeled_stmt,
    STATE(4261), 1,
      sym__pcal_p_stmts,
    STATE(4637), 1,
      sym_pcal_lhs,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6745), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4194), 11,
      sym_pcal_assign,
      sym_pcal_p_if,
      sym_pcal_p_while,
      sym_pcal_p_either,
      sym_pcal_p_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [15674] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      anon_sym_if,
    ACTIONS(6717), 1,
      anon_sym_while,
    ACTIONS(6719), 1,
      anon_sym_either,
    ACTIONS(6721), 1,
      anon_sym_with,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    STATE(3660), 1,
      sym_block_comment,
    STATE(3670), 1,
      sym__pcal_label,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(5011), 1,
      sym__pcal_c_stmt,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6729), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4379), 2,
      sym_pcal_c_algorithm_body,
      sym__pcal_c_unlabeled_stmt,
    STATE(4375), 11,
      sym_pcal_assign,
      sym_pcal_c_if,
      sym_pcal_c_while,
      sym_pcal_c_either,
      sym_pcal_c_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [15748] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6737), 1,
      anon_sym_if,
    ACTIONS(6739), 1,
      anon_sym_while,
    ACTIONS(6741), 1,
      anon_sym_either,
    ACTIONS(6743), 1,
      anon_sym_with,
    STATE(3661), 1,
      sym_block_comment,
    STATE(3664), 1,
      aux_sym__pcal_p_stmts_repeat1,
    STATE(3755), 1,
      sym__pcal_label,
    STATE(4146), 1,
      sym__pcal_p_unlabeled_stmt,
    STATE(4226), 1,
      sym__pcal_p_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6745), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4194), 11,
      sym_pcal_assign,
      sym_pcal_p_if,
      sym_pcal_p_while,
      sym_pcal_p_either,
      sym_pcal_p_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [15821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6747), 1,
      aux_sym_proof_step_ref_token1,
    STATE(3662), 1,
      sym_block_comment,
    ACTIONS(5413), 12,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_end,
    ACTIONS(5415), 16,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [15866] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6749), 1,
      aux_sym_octal_number_token1,
    STATE(3663), 1,
      sym_block_comment,
    ACTIONS(5389), 12,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_end,
    ACTIONS(5391), 16,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [15911] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6751), 1,
      sym_identifier,
    ACTIONS(6754), 1,
      anon_sym_if,
    ACTIONS(6757), 1,
      anon_sym_while,
    ACTIONS(6760), 1,
      anon_sym_either,
    ACTIONS(6763), 1,
      anon_sym_with,
    ACTIONS(6769), 1,
      anon_sym_print,
    ACTIONS(6772), 1,
      anon_sym_assert,
    ACTIONS(6778), 1,
      anon_sym_goto,
    ACTIONS(6781), 1,
      anon_sym_call,
    STATE(3755), 1,
      sym__pcal_label,
    STATE(4146), 1,
      sym__pcal_p_unlabeled_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    STATE(5169), 1,
      sym__pcal_p_stmt,
    ACTIONS(6766), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6775), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(3664), 2,
      sym_block_comment,
      aux_sym__pcal_p_stmts_repeat1,
    STATE(4194), 11,
      sym_pcal_assign,
      sym_pcal_p_if,
      sym_pcal_p_while,
      sym_pcal_p_either,
      sym_pcal_p_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [15982] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6784), 1,
      anon_sym_LPAREN,
    STATE(3665), 1,
      sym_block_comment,
    ACTIONS(6250), 11,
      sym_identifier,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_end,
    ACTIONS(6248), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16028] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6786), 1,
      aux_sym_octal_number_token1,
    STATE(3666), 1,
      sym_block_comment,
    ACTIONS(5389), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5391), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16072] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6788), 1,
      sym_identifier,
    STATE(3667), 1,
      sym_block_comment,
    STATE(3874), 1,
      sym_statement_level,
    STATE(4991), 1,
      sym_operator_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(490), 5,
      anon_sym_VARIABLE,
      anon_sym_CONSTANT,
      anon_sym_STATE,
      anon_sym_ACTION,
      anon_sym_TEMPORAL,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [16134] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6798), 1,
      anon_sym_LPAREN,
    STATE(3668), 1,
      sym_block_comment,
    ACTIONS(6250), 11,
      sym_identifier,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_end,
    ACTIONS(6248), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16180] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6800), 1,
      aux_sym_proof_step_ref_token1,
    STATE(3669), 1,
      sym_block_comment,
    ACTIONS(5413), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5415), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16224] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      anon_sym_if,
    ACTIONS(6717), 1,
      anon_sym_while,
    ACTIONS(6719), 1,
      anon_sym_either,
    ACTIONS(6721), 1,
      anon_sym_with,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6802), 1,
      sym_identifier,
    STATE(3670), 1,
      sym_block_comment,
    STATE(4413), 1,
      sym_pcal_c_algorithm_body,
    STATE(4415), 1,
      sym__pcal_c_unlabeled_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6729), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4375), 11,
      sym_pcal_assign,
      sym_pcal_c_if,
      sym_pcal_c_while,
      sym_pcal_c_either,
      sym_pcal_c_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [16294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3671), 1,
      sym_block_comment,
    ACTIONS(5625), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5627), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3672), 1,
      sym_block_comment,
    ACTIONS(5493), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5495), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3673), 1,
      sym_block_comment,
    ACTIONS(5369), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5371), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16417] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3674), 1,
      sym_block_comment,
    ACTIONS(5501), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5503), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16458] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3675), 1,
      sym_block_comment,
    ACTIONS(5505), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5507), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16499] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3676), 1,
      sym_block_comment,
    ACTIONS(5509), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5511), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3677), 1,
      sym_block_comment,
    ACTIONS(5513), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5515), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3678), 1,
      sym_block_comment,
    ACTIONS(5521), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5523), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3679), 1,
      sym_block_comment,
    ACTIONS(5525), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5527), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3680), 1,
      sym_block_comment,
    ACTIONS(5529), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5531), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3681), 1,
      sym_block_comment,
    ACTIONS(5537), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5539), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16745] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3682), 1,
      sym_block_comment,
    ACTIONS(5541), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5543), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16786] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3683), 1,
      sym_block_comment,
    ACTIONS(5553), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5555), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16827] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3684), 1,
      sym_block_comment,
    ACTIONS(5557), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5559), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3685), 1,
      sym_block_comment,
    ACTIONS(5561), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5563), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3686), 1,
      sym_block_comment,
    ACTIONS(5569), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5571), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3687), 1,
      sym_block_comment,
    ACTIONS(5573), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5575), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [16991] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3688), 1,
      sym_block_comment,
    ACTIONS(5577), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5579), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3689), 1,
      sym_block_comment,
    ACTIONS(5581), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5583), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3690), 1,
      sym_block_comment,
    ACTIONS(5585), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5587), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3691), 1,
      sym_block_comment,
    ACTIONS(5589), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5591), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17155] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3692), 1,
      sym_block_comment,
    ACTIONS(5593), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5595), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3693), 1,
      sym_block_comment,
    ACTIONS(5597), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5599), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3694), 1,
      sym_block_comment,
    ACTIONS(5601), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5603), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17278] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3695), 1,
      sym_block_comment,
    ACTIONS(5605), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5607), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17319] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3696), 1,
      sym_block_comment,
    ACTIONS(333), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(324), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17360] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3697), 1,
      sym_block_comment,
    ACTIONS(5629), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5631), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3698), 1,
      sym_block_comment,
    ACTIONS(5637), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5639), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3699), 1,
      sym_block_comment,
    ACTIONS(5645), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5647), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3700), 1,
      sym_block_comment,
    ACTIONS(5517), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5519), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3701), 1,
      sym_block_comment,
    ACTIONS(5609), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5611), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3702), 1,
      sym_block_comment,
    ACTIONS(5381), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5383), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17606] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3703), 1,
      sym_block_comment,
    ACTIONS(5385), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5387), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3704), 1,
      sym_block_comment,
    ACTIONS(5393), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5395), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17688] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3705), 1,
      sym_block_comment,
    ACTIONS(5401), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5403), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3706), 1,
      sym_block_comment,
    ACTIONS(5409), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5411), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3707), 1,
      sym_block_comment,
    ACTIONS(5425), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5427), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3708), 1,
      sym_block_comment,
    ACTIONS(5633), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5635), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3709), 1,
      sym_block_comment,
    ACTIONS(5373), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5375), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3710), 1,
      sym_block_comment,
    ACTIONS(5465), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5467), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17934] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3711), 1,
      sym_block_comment,
    ACTIONS(5489), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5491), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [17975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3712), 1,
      sym_block_comment,
    ACTIONS(5433), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5435), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18016] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3713), 1,
      sym_block_comment,
    ACTIONS(5405), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5407), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3714), 1,
      sym_block_comment,
    ACTIONS(5940), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5942), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3715), 1,
      sym_block_comment,
    ACTIONS(5397), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5399), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18139] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6804), 1,
      aux_sym_octal_number_token1,
    STATE(3716), 1,
      sym_block_comment,
    ACTIONS(5389), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5391), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3717), 1,
      sym_block_comment,
    ACTIONS(5437), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5439), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18223] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6806), 1,
      anon_sym_COMMA,
    STATE(3718), 1,
      sym_block_comment,
    STATE(3725), 1,
      aux_sym_instance_repeat1,
    ACTIONS(6410), 11,
      sym_identifier,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_end,
    ACTIONS(6412), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3719), 1,
      sym_block_comment,
    ACTIONS(6235), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6233), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3720), 1,
      sym_block_comment,
    ACTIONS(5441), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5443), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3721), 1,
      sym_block_comment,
    ACTIONS(5481), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5483), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3722), 1,
      sym_block_comment,
    ACTIONS(5389), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5391), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18432] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3723), 1,
      sym_block_comment,
    ACTIONS(5453), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5455), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3724), 1,
      sym_block_comment,
    ACTIONS(5461), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5463), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18514] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6806), 1,
      anon_sym_COMMA,
    STATE(3725), 1,
      sym_block_comment,
    STATE(3728), 1,
      aux_sym_instance_repeat1,
    ACTIONS(6369), 11,
      sym_identifier,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_end,
    ACTIONS(6371), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3726), 1,
      sym_block_comment,
    ACTIONS(5469), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5471), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3727), 1,
      sym_block_comment,
    ACTIONS(5473), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5475), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18641] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6808), 1,
      anon_sym_COMMA,
    STATE(3728), 2,
      sym_block_comment,
      aux_sym_instance_repeat1,
    ACTIONS(6280), 11,
      sym_identifier,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_end,
    ACTIONS(6278), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3729), 1,
      sym_block_comment,
    ACTIONS(5649), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5651), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18725] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6811), 1,
      aux_sym_proof_step_ref_token1,
    STATE(3730), 1,
      sym_block_comment,
    ACTIONS(5413), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5415), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3731), 1,
      sym_block_comment,
    ACTIONS(5533), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5535), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18809] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3732), 1,
      sym_block_comment,
    ACTIONS(5545), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5547), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18850] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3733), 1,
      sym_block_comment,
    ACTIONS(5377), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5379), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3734), 1,
      sym_block_comment,
    ACTIONS(5449), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5451), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18932] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3735), 1,
      sym_block_comment,
    ACTIONS(5421), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5423), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [18973] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3736), 1,
      sym_block_comment,
    ACTIONS(6231), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6229), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3737), 1,
      sym_block_comment,
    ACTIONS(5549), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5551), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19055] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6813), 1,
      anon_sym_LPAREN,
    STATE(3738), 1,
      sym_block_comment,
    ACTIONS(6250), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6248), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3739), 1,
      sym_block_comment,
    ACTIONS(5565), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5567), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3740), 1,
      sym_block_comment,
    ACTIONS(5497), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5499), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3741), 1,
      sym_block_comment,
    ACTIONS(5445), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5447), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19223] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6815), 1,
      anon_sym_LPAREN,
    STATE(3742), 1,
      sym_block_comment,
    ACTIONS(6250), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6248), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3743), 1,
      sym_block_comment,
    ACTIONS(5477), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5479), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3744), 1,
      sym_block_comment,
    ACTIONS(5485), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5487), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3745), 1,
      sym_block_comment,
    ACTIONS(5417), 12,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5419), 15,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3746), 1,
      sym_block_comment,
    ACTIONS(5493), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5495), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3747), 1,
      sym_block_comment,
    ACTIONS(5481), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5483), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3748), 1,
      sym_block_comment,
    ACTIONS(5421), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5423), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19511] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6817), 1,
      anon_sym_COMMA,
    STATE(3749), 1,
      sym_block_comment,
    STATE(3758), 1,
      aux_sym_constant_declaration_repeat1,
    ACTIONS(6406), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6404), 13,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3750), 1,
      sym_block_comment,
    ACTIONS(5549), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5551), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19595] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3751), 1,
      sym_block_comment,
    ACTIONS(5565), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5567), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19635] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3752), 1,
      sym_block_comment,
    ACTIONS(5497), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5499), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19675] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3753), 1,
      sym_block_comment,
    ACTIONS(5445), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5447), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3754), 1,
      sym_block_comment,
    ACTIONS(5940), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5942), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19755] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6725), 1,
      anon_sym_print,
    ACTIONS(6727), 1,
      anon_sym_assert,
    ACTIONS(6731), 1,
      anon_sym_goto,
    ACTIONS(6733), 1,
      anon_sym_call,
    ACTIONS(6737), 1,
      anon_sym_if,
    ACTIONS(6739), 1,
      anon_sym_while,
    ACTIONS(6741), 1,
      anon_sym_either,
    ACTIONS(6743), 1,
      anon_sym_with,
    ACTIONS(6802), 1,
      sym_identifier,
    STATE(3755), 1,
      sym_block_comment,
    STATE(4221), 1,
      sym__pcal_p_unlabeled_stmt,
    STATE(4637), 1,
      sym_pcal_lhs,
    ACTIONS(6723), 2,
      anon_sym_await,
      anon_sym_when,
    ACTIONS(6745), 2,
      sym_pcal_skip,
      sym_pcal_return,
    STATE(4194), 11,
      sym_pcal_assign,
      sym_pcal_p_if,
      sym_pcal_p_while,
      sym_pcal_p_either,
      sym_pcal_p_with,
      sym_pcal_await,
      sym_pcal_print,
      sym_pcal_assert,
      sym_pcal_goto,
      sym_pcal_proc_call,
      sym_pcal_macro_call,
  [19819] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3756), 1,
      sym_block_comment,
    ACTIONS(5397), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5399), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3757), 1,
      sym_block_comment,
    ACTIONS(5477), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5479), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19899] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6819), 1,
      anon_sym_COMMA,
    STATE(3758), 2,
      sym_block_comment,
      aux_sym_constant_declaration_repeat1,
    ACTIONS(6359), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6357), 13,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19941] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6822), 1,
      anon_sym_COMMA,
    STATE(3759), 1,
      sym_block_comment,
    STATE(3765), 1,
      aux_sym_instance_repeat1,
    ACTIONS(6410), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6412), 13,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [19985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3760), 1,
      sym_block_comment,
    ACTIONS(5485), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5487), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20025] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3761), 1,
      sym_block_comment,
    ACTIONS(5489), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5491), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20065] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3762), 1,
      sym_block_comment,
    ACTIONS(5369), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5371), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3763), 1,
      sym_block_comment,
    ACTIONS(5501), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5503), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3764), 1,
      sym_block_comment,
    ACTIONS(5505), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5507), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20185] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6822), 1,
      anon_sym_COMMA,
    STATE(3765), 1,
      sym_block_comment,
    STATE(3775), 1,
      aux_sym_instance_repeat1,
    ACTIONS(6369), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6371), 13,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20229] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3766), 1,
      sym_block_comment,
    ACTIONS(5509), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5511), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3767), 1,
      sym_block_comment,
    ACTIONS(5513), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5515), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3768), 1,
      sym_block_comment,
    ACTIONS(5521), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5523), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20349] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3769), 1,
      sym_block_comment,
    ACTIONS(5525), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5527), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20389] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3770), 1,
      sym_block_comment,
    ACTIONS(5529), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5531), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20429] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3771), 1,
      sym_block_comment,
    ACTIONS(5537), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5539), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3772), 1,
      sym_block_comment,
    ACTIONS(5541), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5543), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3773), 1,
      sym_block_comment,
    ACTIONS(5389), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5391), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3774), 1,
      sym_block_comment,
    ACTIONS(5553), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5555), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20589] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6824), 1,
      anon_sym_COMMA,
    STATE(3775), 2,
      sym_block_comment,
      aux_sym_instance_repeat1,
    ACTIONS(6280), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6278), 13,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3776), 1,
      sym_block_comment,
    ACTIONS(5557), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5559), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3777), 1,
      sym_block_comment,
    ACTIONS(5561), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5563), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20711] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3778), 1,
      sym_block_comment,
    ACTIONS(5569), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5571), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3779), 1,
      sym_block_comment,
    ACTIONS(5573), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5575), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3780), 1,
      sym_block_comment,
    ACTIONS(5577), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5579), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20831] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3781), 1,
      sym_block_comment,
    ACTIONS(5581), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5583), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20871] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3782), 1,
      sym_block_comment,
    ACTIONS(5585), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5587), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3783), 1,
      sym_block_comment,
    ACTIONS(5589), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5591), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20951] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3784), 1,
      sym_block_comment,
    ACTIONS(5593), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5595), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [20991] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3785), 1,
      sym_block_comment,
    ACTIONS(5597), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5599), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21031] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3786), 1,
      sym_block_comment,
    ACTIONS(5449), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5451), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3787), 1,
      sym_block_comment,
    ACTIONS(5601), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5603), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21111] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3788), 1,
      sym_block_comment,
    ACTIONS(5605), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5607), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21151] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3789), 1,
      sym_block_comment,
    ACTIONS(5461), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5463), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3790), 1,
      sym_block_comment,
    ACTIONS(5469), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5471), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3791), 1,
      sym_block_comment,
    ACTIONS(5625), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5627), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21271] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3792), 1,
      sym_block_comment,
    ACTIONS(5629), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5631), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3793), 1,
      sym_block_comment,
    ACTIONS(5637), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5639), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3794), 1,
      sym_block_comment,
    ACTIONS(5645), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5647), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3795), 1,
      sym_block_comment,
    ACTIONS(333), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(324), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3796), 1,
      sym_block_comment,
    ACTIONS(5517), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5519), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3797), 1,
      sym_block_comment,
    ACTIONS(5609), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5611), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3798), 1,
      sym_block_comment,
    ACTIONS(5381), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5383), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21551] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3799), 1,
      sym_block_comment,
    ACTIONS(6235), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6233), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21591] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6827), 1,
      anon_sym_WITH,
    STATE(3800), 1,
      sym_block_comment,
    ACTIONS(6459), 11,
      sym_identifier,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_end,
    ACTIONS(6457), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3801), 1,
      sym_block_comment,
    ACTIONS(5437), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5439), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21673] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6829), 1,
      anon_sym_LPAREN,
    STATE(3802), 1,
      sym_block_comment,
    ACTIONS(6250), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6248), 15,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3803), 1,
      sym_block_comment,
    ACTIONS(5385), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5387), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21757] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3804), 1,
      sym_block_comment,
    ACTIONS(5393), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5395), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21797] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6831), 1,
      anon_sym_LPAREN,
    STATE(3805), 1,
      sym_block_comment,
    ACTIONS(6264), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6262), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21839] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3806), 1,
      sym_block_comment,
    ACTIONS(5401), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5403), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3807), 1,
      sym_block_comment,
    ACTIONS(5409), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5411), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21919] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3808), 1,
      sym_block_comment,
    ACTIONS(5425), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5427), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21959] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3809), 1,
      sym_block_comment,
    ACTIONS(6231), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6229), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [21999] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6817), 1,
      anon_sym_COMMA,
    STATE(3749), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(3810), 1,
      sym_block_comment,
    ACTIONS(6392), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6390), 13,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3811), 1,
      sym_block_comment,
    ACTIONS(5633), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5635), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3812), 1,
      sym_block_comment,
    ACTIONS(5373), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5375), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22123] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3813), 1,
      sym_block_comment,
    ACTIONS(5465), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5467), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22163] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3814), 1,
      sym_block_comment,
    ACTIONS(5417), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5419), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22203] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3815), 1,
      sym_block_comment,
    ACTIONS(5433), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5435), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3816), 1,
      sym_block_comment,
    ACTIONS(5405), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5407), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3817), 1,
      sym_block_comment,
    ACTIONS(5473), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5475), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3818), 1,
      sym_block_comment,
    ACTIONS(5649), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5651), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3819), 1,
      sym_block_comment,
    ACTIONS(5533), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5535), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3820), 1,
      sym_block_comment,
    ACTIONS(5545), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5547), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3821), 1,
      sym_block_comment,
    ACTIONS(5377), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5379), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3822), 1,
      sym_block_comment,
    ACTIONS(5441), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5443), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22523] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6833), 1,
      anon_sym_LPAREN,
    STATE(3823), 1,
      sym_block_comment,
    ACTIONS(6250), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6248), 15,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3824), 1,
      sym_block_comment,
    ACTIONS(5453), 10,
      sym_identifier,
      anon_sym_LPAREN,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(5455), 16,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3825), 1,
      sym_block_comment,
    ACTIONS(6302), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6300), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3826), 1,
      sym_block_comment,
    ACTIONS(6306), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6304), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3827), 1,
      sym_block_comment,
    ACTIONS(6274), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6272), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3828), 1,
      sym_block_comment,
    ACTIONS(6280), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6278), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3829), 1,
      sym_block_comment,
    ACTIONS(6270), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6268), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3830), 1,
      sym_block_comment,
    ACTIONS(6310), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6308), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3831), 1,
      sym_block_comment,
    ACTIONS(6264), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6262), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22880] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3832), 1,
      sym_block_comment,
    ACTIONS(6835), 11,
      sym_identifier,
      anon_sym_INSTANCE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
      anon_sym_end,
    ACTIONS(6837), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_RBRACE,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22919] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3833), 1,
      sym_block_comment,
    ACTIONS(6298), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6296), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22958] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6839), 1,
      anon_sym_WITH,
    STATE(3834), 1,
      sym_block_comment,
    ACTIONS(6459), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6457), 13,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [22999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3835), 1,
      sym_block_comment,
    ACTIONS(6292), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6290), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3836), 1,
      sym_block_comment,
    ACTIONS(6359), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6357), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23077] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3837), 1,
      sym_block_comment,
    ACTIONS(3635), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(3637), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3838), 1,
      sym_block_comment,
    ACTIONS(6250), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6248), 14,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6841), 1,
      anon_sym_COMMA,
    STATE(3839), 2,
      sym_block_comment,
      aux_sym_instance_repeat1,
    ACTIONS(6280), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6278), 14,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23196] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6844), 1,
      anon_sym_COMMA,
    STATE(3840), 1,
      sym_block_comment,
    STATE(3841), 1,
      aux_sym_instance_repeat1,
    ACTIONS(6410), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6412), 14,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23239] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6844), 1,
      anon_sym_COMMA,
    STATE(3839), 1,
      aux_sym_instance_repeat1,
    STATE(3841), 1,
      sym_block_comment,
    ACTIONS(6369), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6371), 14,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23282] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6846), 1,
      anon_sym_WITH,
    STATE(3842), 1,
      sym_block_comment,
    ACTIONS(6459), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6457), 14,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23322] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3843), 1,
      sym_block_comment,
    ACTIONS(3635), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(3637), 15,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23360] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3844), 1,
      sym_block_comment,
    ACTIONS(6250), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6248), 15,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23398] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3845), 1,
      sym_block_comment,
    ACTIONS(6270), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6268), 15,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3846), 1,
      sym_block_comment,
    ACTIONS(6322), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6320), 13,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23474] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3847), 1,
      sym_block_comment,
    ACTIONS(6318), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6316), 13,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23512] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3848), 1,
      sym_block_comment,
    ACTIONS(6274), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6272), 15,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3849), 1,
      sym_block_comment,
    ACTIONS(6848), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6850), 13,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3850), 1,
      sym_block_comment,
    ACTIONS(6314), 11,
      sym_identifier,
      anon_sym_RECURSIVE,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      anon_sym_IN,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6312), 13,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3851), 1,
      sym_block_comment,
    ACTIONS(6280), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6278), 15,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_COMMA,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23664] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3852), 1,
      sym_block_comment,
    STATE(4600), 1,
      sym__id_or_op_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [23719] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3853), 1,
      sym_block_comment,
    STATE(4581), 1,
      sym__id_or_op_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [23774] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3854), 1,
      sym_block_comment,
    STATE(4611), 1,
      sym__id_or_op_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [23829] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3855), 1,
      sym_block_comment,
    STATE(4624), 1,
      sym__id_or_op_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [23884] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3856), 1,
      sym_block_comment,
    ACTIONS(6318), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6316), 14,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [23921] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3857), 1,
      sym_block_comment,
    STATE(4571), 1,
      sym__id_or_op_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [23976] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    ACTIONS(6854), 1,
      sym_placeholder,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3540), 1,
      sym__id_or_op_declaration,
    STATE(3858), 1,
      sym_block_comment,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24031] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3548), 1,
      sym__id_or_op_declaration,
    STATE(3859), 1,
      sym_block_comment,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24086] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3860), 1,
      sym_block_comment,
    STATE(4802), 1,
      sym__id_or_op_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24141] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6856), 1,
      sym_identifier,
    ACTIONS(6858), 1,
      sym_placeholder,
    STATE(3831), 1,
      sym_operator_declaration,
    STATE(3836), 1,
      sym__id_or_op_declaration,
    STATE(3861), 1,
      sym_block_comment,
    STATE(5067), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3862), 1,
      sym_block_comment,
    ACTIONS(6860), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6862), 14,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [24233] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3863), 1,
      sym_block_comment,
    STATE(4628), 1,
      sym__id_or_op_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24288] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3540), 1,
      sym__id_or_op_declaration,
    STATE(3864), 1,
      sym_block_comment,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24343] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3865), 1,
      sym_block_comment,
    STATE(4640), 1,
      sym__id_or_op_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24398] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3866), 1,
      sym_block_comment,
    STATE(4645), 1,
      sym__id_or_op_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24453] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    ACTIONS(6854), 1,
      sym_placeholder,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3560), 1,
      sym__id_or_op_declaration,
    STATE(3867), 1,
      sym_block_comment,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3868), 1,
      sym_block_comment,
    ACTIONS(6322), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6320), 14,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [24545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3869), 1,
      sym_block_comment,
    ACTIONS(6314), 9,
      sym_identifier,
      anon_sym_Nat,
      anon_sym_Int,
      anon_sym_Real,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6312), 14,
      sym__begin_proof_step,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_u2115,
      anon_sym_u2124,
      anon_sym_u211d,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [24582] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3870), 1,
      sym_block_comment,
    STATE(4915), 1,
      sym__id_or_op_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24637] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6856), 1,
      sym_identifier,
    ACTIONS(6858), 1,
      sym_placeholder,
    STATE(3810), 1,
      sym__id_or_op_declaration,
    STATE(3831), 1,
      sym_operator_declaration,
    STATE(3871), 1,
      sym_block_comment,
    STATE(5067), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24692] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3547), 1,
      sym__id_or_op_declaration,
    STATE(3872), 1,
      sym_block_comment,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24747] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6852), 1,
      sym_identifier,
    ACTIONS(6854), 1,
      sym_placeholder,
    STATE(3530), 1,
      sym_operator_declaration,
    STATE(3562), 1,
      sym__id_or_op_declaration,
    STATE(3873), 1,
      sym_block_comment,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24802] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6864), 1,
      sym_identifier,
    STATE(3874), 1,
      sym_block_comment,
    STATE(5010), 1,
      sym_operator_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24854] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(678), 1,
      sym_placeholder,
    ACTIONS(682), 1,
      sym_negative_dot,
    ACTIONS(6788), 1,
      sym_identifier,
    STATE(3875), 1,
      sym_block_comment,
    STATE(4991), 1,
      sym_operator_declaration,
    STATE(5135), 1,
      sym_prefix_op_symbol,
    ACTIONS(6790), 2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
    ACTIONS(6796), 3,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
    STATE(4162), 3,
      sym_lnot,
      sym_always,
      sym_eventually,
    ACTIONS(6792), 4,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
    ACTIONS(6794), 5,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
  [24906] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4477), 1,
      anon_sym_variable,
    ACTIONS(4479), 1,
      anon_sym_variables,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6866), 1,
      anon_sym_LBRACE,
    ACTIONS(6868), 1,
      anon_sym_define,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3876), 1,
      sym_block_comment,
    STATE(3886), 1,
      sym_pcal_var_decls,
    STATE(3908), 1,
      sym_pcal_p_definitions,
    STATE(3909), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(3929), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4236), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5249), 1,
      sym_pcal_p_algorithm_body,
  [24976] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4477), 1,
      anon_sym_variable,
    ACTIONS(4479), 1,
      anon_sym_variables,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6868), 1,
      anon_sym_define,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    ACTIONS(6878), 1,
      anon_sym_LBRACE,
    STATE(3877), 1,
      sym_block_comment,
    STATE(3885), 1,
      sym_pcal_var_decls,
    STATE(3905), 1,
      sym_pcal_p_definitions,
    STATE(3906), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(3924), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4180), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5333), 1,
      sym_pcal_p_algorithm_body,
  [25046] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4477), 1,
      anon_sym_variable,
    ACTIONS(4479), 1,
      anon_sym_variables,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6880), 1,
      anon_sym_define,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3878), 1,
      sym_block_comment,
    STATE(3883), 1,
      sym_pcal_var_decls,
    STATE(3892), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(3893), 1,
      sym_pcal_c_definitions,
    STATE(3928), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4192), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5144), 1,
      sym_pcal_c_algorithm_body,
  [25113] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4477), 1,
      anon_sym_variable,
    ACTIONS(4479), 1,
      anon_sym_variables,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6880), 1,
      anon_sym_define,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3879), 1,
      sym_block_comment,
    STATE(3884), 1,
      sym_pcal_var_decls,
    STATE(3899), 1,
      sym_pcal_c_definitions,
    STATE(3900), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(3930), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4237), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5062), 1,
      sym_pcal_c_algorithm_body,
  [25180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3880), 1,
      sym_block_comment,
    ACTIONS(6888), 4,
      anon_sym_end,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
    ACTIONS(6886), 13,
      sym_identifier,
      anon_sym_if,
      anon_sym_while,
      anon_sym_either,
      anon_sym_with,
      anon_sym_await,
      anon_sym_when,
      anon_sym_print,
      anon_sym_assert,
      sym_pcal_skip,
      sym_pcal_return,
      anon_sym_goto,
      anon_sym_call,
  [25211] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3881), 1,
      sym_block_comment,
    ACTIONS(6890), 7,
      sym_placeholder,
      sym_identifier,
      sym_union,
      sym_powerset,
      sym_domain,
      sym_enabled,
      sym_unchanged,
    ACTIONS(6892), 10,
      anon_sym_LBRACK_RBRACK,
      anon_sym_u25a1,
      anon_sym_BSLASHlnot,
      anon_sym_BSLASHneg,
      anon_sym_TILDE,
      anon_sym_u00ac,
      sym_negative_dot,
      anon_sym_LT_GT,
      anon_sym_u22c4,
      anon_sym_u25c7,
  [25242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3882), 1,
      sym_block_comment,
    ACTIONS(6894), 4,
      anon_sym_end,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
    ACTIONS(6886), 13,
      sym_identifier,
      anon_sym_if,
      anon_sym_while,
      anon_sym_either,
      anon_sym_with,
      anon_sym_await,
      anon_sym_when,
      anon_sym_print,
      anon_sym_assert,
      sym_pcal_skip,
      sym_pcal_return,
      anon_sym_goto,
      anon_sym_call,
  [25273] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6880), 1,
      anon_sym_define,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3883), 1,
      sym_block_comment,
    STATE(3896), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(3897), 1,
      sym_pcal_c_definitions,
    STATE(3916), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4163), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5146), 1,
      sym_pcal_c_algorithm_body,
  [25331] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6880), 1,
      anon_sym_define,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3884), 1,
      sym_block_comment,
    STATE(3901), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(3902), 1,
      sym_pcal_c_definitions,
    STATE(3934), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4159), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5072), 1,
      sym_pcal_c_algorithm_body,
  [25389] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6868), 1,
      anon_sym_define,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3885), 1,
      sym_block_comment,
    STATE(3894), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(3895), 1,
      sym_pcal_p_definitions,
    STATE(3932), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4161), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5250), 1,
      sym_pcal_p_algorithm_body,
  [25447] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6868), 1,
      anon_sym_define,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3886), 1,
      sym_block_comment,
    STATE(3910), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(3911), 1,
      sym_pcal_p_definitions,
    STATE(3931), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4144), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5257), 1,
      sym_pcal_p_algorithm_body,
  [25505] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    STATE(3887), 1,
      sym_block_comment,
    ACTIONS(6900), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6896), 13,
      sym_identifier,
      anon_sym_if,
      anon_sym_while,
      anon_sym_either,
      anon_sym_with,
      anon_sym_await,
      anon_sym_when,
      anon_sym_print,
      anon_sym_assert,
      sym_pcal_skip,
      sym_pcal_return,
      anon_sym_goto,
      anon_sym_call,
  [25537] = 13,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6906), 1,
      anon_sym_STAR_RPAREN,
    ACTIONS(6911), 1,
      anon_sym_DASH_DASHalgorithm,
    ACTIONS(6914), 1,
      anon_sym_DASH_DASHfair,
    STATE(3951), 1,
      aux_sym_block_comment_text_repeat1,
    STATE(3977), 1,
      sym__pcal_p_algorithm,
    STATE(3992), 1,
      sym__pcal_c_algorithm,
    STATE(5092), 1,
      sym_fair,
    STATE(5513), 1,
      sym_pcal_algorithm_start,
    STATE(3888), 2,
      sym_block_comment,
      aux_sym_block_comment_repeat1,
    STATE(3985), 2,
      sym_block_comment_text,
      sym_pcal_algorithm,
    ACTIONS(6908), 4,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
  [25582] = 14,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6917), 1,
      anon_sym_STAR_RPAREN,
    ACTIONS(6921), 1,
      anon_sym_DASH_DASHalgorithm,
    ACTIONS(6923), 1,
      anon_sym_DASH_DASHfair,
    STATE(3889), 1,
      sym_block_comment,
    STATE(3890), 1,
      aux_sym_block_comment_repeat1,
    STATE(3951), 1,
      aux_sym_block_comment_text_repeat1,
    STATE(3977), 1,
      sym__pcal_p_algorithm,
    STATE(3992), 1,
      sym__pcal_c_algorithm,
    STATE(5092), 1,
      sym_fair,
    STATE(5513), 1,
      sym_pcal_algorithm_start,
    STATE(3985), 2,
      sym_block_comment_text,
      sym_pcal_algorithm,
    ACTIONS(6919), 4,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
  [25629] = 14,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6921), 1,
      anon_sym_DASH_DASHalgorithm,
    ACTIONS(6923), 1,
      anon_sym_DASH_DASHfair,
    ACTIONS(6925), 1,
      anon_sym_STAR_RPAREN,
    STATE(3888), 1,
      aux_sym_block_comment_repeat1,
    STATE(3890), 1,
      sym_block_comment,
    STATE(3951), 1,
      aux_sym_block_comment_text_repeat1,
    STATE(3977), 1,
      sym__pcal_p_algorithm,
    STATE(3992), 1,
      sym__pcal_c_algorithm,
    STATE(5092), 1,
      sym_fair,
    STATE(5513), 1,
      sym_pcal_algorithm_start,
    STATE(3985), 2,
      sym_block_comment_text,
      sym_pcal_algorithm,
    ACTIONS(6919), 4,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
  [25676] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3891), 1,
      sym_block_comment,
    STATE(3923), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(3952), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(4151), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5267), 1,
      sym_pcal_p_algorithm_body,
  [25728] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3892), 1,
      sym_block_comment,
    STATE(3916), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(3949), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(4163), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5146), 1,
      sym_pcal_c_algorithm_body,
  [25780] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3893), 1,
      sym_block_comment,
    STATE(3896), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(3916), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4163), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5146), 1,
      sym_pcal_c_algorithm_body,
  [25832] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3894), 1,
      sym_block_comment,
    STATE(3920), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(3952), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(4158), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5252), 1,
      sym_pcal_p_algorithm_body,
  [25884] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3895), 1,
      sym_block_comment,
    STATE(3904), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(3920), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4158), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5252), 1,
      sym_pcal_p_algorithm_body,
  [25936] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3896), 1,
      sym_block_comment,
    STATE(3926), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(3949), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4234), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5423), 1,
      sym_pcal_c_algorithm_body,
  [25988] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3897), 1,
      sym_block_comment,
    STATE(3898), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(3926), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4234), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5423), 1,
      sym_pcal_c_algorithm_body,
  [26040] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3898), 1,
      sym_block_comment,
    STATE(3921), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(3949), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4231), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5228), 1,
      sym_pcal_c_algorithm_body,
  [26092] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3899), 1,
      sym_block_comment,
    STATE(3901), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(3934), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4159), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5072), 1,
      sym_pcal_c_algorithm_body,
  [26144] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3900), 1,
      sym_block_comment,
    STATE(3934), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(3949), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(4159), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5072), 1,
      sym_pcal_c_algorithm_body,
  [26196] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3901), 1,
      sym_block_comment,
    STATE(3917), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(3949), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(4160), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5075), 1,
      sym_pcal_c_algorithm_body,
  [26248] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3902), 1,
      sym_block_comment,
    STATE(3903), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(3917), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4160), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5075), 1,
      sym_pcal_c_algorithm_body,
  [26300] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3903), 1,
      sym_block_comment,
    STATE(3919), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(3949), 1,
      aux_sym__pcal_c_algorithm_repeat1,
    STATE(4170), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5080), 1,
      sym_pcal_c_algorithm_body,
  [26352] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3904), 1,
      sym_block_comment,
    STATE(3914), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(3952), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4201), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5286), 1,
      sym_pcal_p_algorithm_body,
  [26404] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3894), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(3905), 1,
      sym_block_comment,
    STATE(3932), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4161), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5250), 1,
      sym_pcal_p_algorithm_body,
  [26456] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3906), 1,
      sym_block_comment,
    STATE(3932), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(3952), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(4161), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5250), 1,
      sym_pcal_p_algorithm_body,
  [26508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6929), 1,
      anon_sym_LBRACE,
    STATE(3907), 1,
      sym_block_comment,
    ACTIONS(6927), 13,
      sym_identifier,
      anon_sym_if,
      anon_sym_while,
      anon_sym_either,
      anon_sym_with,
      anon_sym_await,
      anon_sym_when,
      anon_sym_print,
      anon_sym_assert,
      sym_pcal_skip,
      sym_pcal_return,
      anon_sym_goto,
      anon_sym_call,
  [26536] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3908), 1,
      sym_block_comment,
    STATE(3910), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(3931), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4144), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5257), 1,
      sym_pcal_p_algorithm_body,
  [26588] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3909), 1,
      sym_block_comment,
    STATE(3931), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(3952), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(4144), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5257), 1,
      sym_pcal_p_algorithm_body,
  [26640] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3910), 1,
      sym_block_comment,
    STATE(3933), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(3952), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(4148), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5262), 1,
      sym_pcal_p_algorithm_body,
  [26692] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6870), 1,
      anon_sym_macro,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3891), 1,
      aux_sym__pcal_p_algorithm_repeat1,
    STATE(3911), 1,
      sym_block_comment,
    STATE(3933), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4148), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5262), 1,
      sym_pcal_p_algorithm_body,
  [26744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3912), 1,
      sym_block_comment,
    ACTIONS(6886), 13,
      sym_identifier,
      anon_sym_if,
      anon_sym_while,
      anon_sym_either,
      anon_sym_with,
      anon_sym_await,
      anon_sym_when,
      anon_sym_print,
      anon_sym_assert,
      sym_pcal_skip,
      sym_pcal_return,
      anon_sym_goto,
      anon_sym_call,
  [26769] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6935), 1,
      anon_sym_EQ,
    STATE(691), 1,
      sym_set_in,
    STATE(3913), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
    ACTIONS(6933), 9,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_define,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [26800] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3914), 1,
      sym_block_comment,
    STATE(3982), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4203), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5232), 1,
      sym_pcal_p_algorithm_body,
  [26840] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3915), 1,
      sym_block_comment,
    STATE(3927), 1,
      aux_sym_pcal_assign_repeat1,
    STATE(5041), 1,
      sym_vertvert,
    ACTIONS(259), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_u2016,
    ACTIONS(6937), 6,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [26868] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3916), 1,
      sym_block_comment,
    STATE(3968), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4234), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5423), 1,
      sym_pcal_c_algorithm_body,
  [26908] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3917), 1,
      sym_block_comment,
    STATE(3968), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4170), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5080), 1,
      sym_pcal_c_algorithm_body,
  [26948] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6939), 1,
      anon_sym_COMMA,
    ACTIONS(6943), 1,
      anon_sym_SEMI,
    STATE(3918), 1,
      sym_block_comment,
    STATE(3922), 1,
      aux_sym_pcal_var_decls_repeat1,
    ACTIONS(6941), 7,
      anon_sym_LBRACE,
      anon_sym_define,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [26976] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3919), 1,
      sym_block_comment,
    STATE(3968), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4171), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5087), 1,
      sym_pcal_c_algorithm_body,
  [27016] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3920), 1,
      sym_block_comment,
    STATE(3982), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4201), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5286), 1,
      sym_pcal_p_algorithm_body,
  [27056] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3921), 1,
      sym_block_comment,
    STATE(3968), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4185), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5407), 1,
      sym_pcal_c_algorithm_body,
  [27096] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6939), 1,
      anon_sym_COMMA,
    ACTIONS(6947), 1,
      anon_sym_SEMI,
    STATE(3922), 1,
      sym_block_comment,
    STATE(3925), 1,
      aux_sym_pcal_var_decls_repeat1,
    ACTIONS(6945), 7,
      anon_sym_LBRACE,
      anon_sym_define,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [27124] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3923), 1,
      sym_block_comment,
    STATE(3982), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4153), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5270), 1,
      sym_pcal_p_algorithm_body,
  [27164] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3924), 1,
      sym_block_comment,
    STATE(3982), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4161), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5250), 1,
      sym_pcal_p_algorithm_body,
  [27204] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6949), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3925), 2,
      sym_block_comment,
      aux_sym_pcal_var_decls_repeat1,
    ACTIONS(6952), 7,
      anon_sym_LBRACE,
      anon_sym_define,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [27228] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3926), 1,
      sym_block_comment,
    STATE(3968), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4231), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5228), 1,
      sym_pcal_c_algorithm_body,
  [27268] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5041), 1,
      sym_vertvert,
    ACTIONS(6956), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_u2016,
    STATE(3927), 2,
      sym_block_comment,
      aux_sym_pcal_assign_repeat1,
    ACTIONS(6954), 6,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [27294] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3928), 1,
      sym_block_comment,
    STATE(3968), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4163), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5146), 1,
      sym_pcal_c_algorithm_body,
  [27334] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3929), 1,
      sym_block_comment,
    STATE(3982), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4144), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5257), 1,
      sym_pcal_p_algorithm_body,
  [27374] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3930), 1,
      sym_block_comment,
    STATE(3968), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4159), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5072), 1,
      sym_pcal_c_algorithm_body,
  [27414] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3931), 1,
      sym_block_comment,
    STATE(3982), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4148), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5262), 1,
      sym_pcal_p_algorithm_body,
  [27454] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3932), 1,
      sym_block_comment,
    STATE(3982), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4158), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5252), 1,
      sym_pcal_p_algorithm_body,
  [27494] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    STATE(3933), 1,
      sym_block_comment,
    STATE(3982), 1,
      aux_sym__pcal_p_algorithm_repeat2,
    STATE(4151), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(5267), 1,
      sym_pcal_p_algorithm_body,
  [27534] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      anon_sym_procedure,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    STATE(3934), 1,
      sym_block_comment,
    STATE(3968), 1,
      aux_sym__pcal_c_algorithm_repeat2,
    STATE(4160), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(5075), 1,
      sym_pcal_c_algorithm_body,
  [27574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3935), 1,
      sym_block_comment,
    ACTIONS(6959), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_else,
      anon_sym_or,
  [27595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3936), 1,
      sym_block_comment,
    ACTIONS(6961), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_else,
      anon_sym_or,
  [27616] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4112), 1,
      anon_sym_PROOF,
    ACTIONS(4114), 1,
      anon_sym_BY,
    ACTIONS(4118), 1,
      sym__begin_proof,
    ACTIONS(6244), 1,
      sym__begin_proof_step,
    STATE(3937), 1,
      sym_block_comment,
    STATE(5155), 1,
      sym__proof,
    ACTIONS(4116), 2,
      anon_sym_OBVIOUS,
      anon_sym_OMITTED,
    STATE(5283), 2,
      sym_terminal_proof,
      sym_non_terminal_proof,
  [27649] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6945), 1,
      anon_sym_LBRACE,
    ACTIONS(6963), 1,
      sym_identifier,
    STATE(3938), 1,
      sym_block_comment,
    STATE(3940), 1,
      sym_pcal_var_decl,
    ACTIONS(6965), 6,
      anon_sym_define,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [27676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3939), 1,
      sym_block_comment,
    ACTIONS(6967), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_else,
      anon_sym_or,
  [27697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3940), 1,
      sym_block_comment,
    ACTIONS(6952), 9,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_define,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [27718] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6963), 1,
      sym_identifier,
    ACTIONS(6969), 1,
      anon_sym_LBRACE,
    STATE(3940), 1,
      sym_pcal_var_decl,
    STATE(3941), 1,
      sym_block_comment,
    ACTIONS(6971), 6,
      anon_sym_define,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [27745] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4112), 1,
      anon_sym_PROOF,
    ACTIONS(4114), 1,
      anon_sym_BY,
    ACTIONS(4118), 1,
      sym__begin_proof,
    ACTIONS(4230), 1,
      sym__begin_proof_step,
    STATE(3942), 1,
      sym_block_comment,
    STATE(5442), 1,
      sym__proof,
    ACTIONS(4116), 2,
      anon_sym_OBVIOUS,
      anon_sym_OMITTED,
    STATE(5283), 2,
      sym_terminal_proof,
      sym_non_terminal_proof,
  [27778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3943), 1,
      sym_block_comment,
    ACTIONS(6973), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_else,
      anon_sym_or,
  [27799] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4112), 1,
      anon_sym_PROOF,
    ACTIONS(4114), 1,
      anon_sym_BY,
    ACTIONS(4118), 1,
      sym__begin_proof,
    ACTIONS(4224), 1,
      sym__begin_proof_step,
    STATE(3944), 1,
      sym_block_comment,
    STATE(5235), 1,
      sym__proof,
    ACTIONS(4116), 2,
      anon_sym_OBVIOUS,
      anon_sym_OMITTED,
    STATE(5283), 2,
      sym_terminal_proof,
      sym_non_terminal_proof,
  [27832] = 5,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6977), 1,
      anon_sym_SEMI,
    STATE(3945), 1,
      sym_block_comment,
    ACTIONS(6975), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [27854] = 5,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6981), 1,
      anon_sym_SEMI,
    STATE(3946), 1,
      sym_block_comment,
    ACTIONS(6979), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [27876] = 5,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6985), 1,
      anon_sym_SEMI,
    STATE(3947), 1,
      sym_block_comment,
    ACTIONS(6983), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [27898] = 5,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6989), 1,
      anon_sym_SEMI,
    STATE(3948), 1,
      sym_block_comment,
    ACTIONS(6987), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [27920] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6993), 1,
      anon_sym_macro,
    STATE(4174), 1,
      sym_pcal_c_macro,
    STATE(4955), 1,
      sym_pcal_macro_decl,
    STATE(3949), 2,
      sym_block_comment,
      aux_sym__pcal_c_algorithm_repeat1,
    ACTIONS(6991), 4,
      anon_sym_LBRACE,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
  [27946] = 5,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6998), 1,
      anon_sym_SEMI,
    STATE(3950), 1,
      sym_block_comment,
    ACTIONS(6996), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [27968] = 6,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3951), 1,
      sym_block_comment,
    STATE(3953), 1,
      aux_sym_block_comment_text_repeat1,
    ACTIONS(7000), 3,
      anon_sym_STAR_RPAREN,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
    ACTIONS(6919), 4,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
  [27992] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7002), 1,
      anon_sym_macro,
    STATE(4165), 1,
      sym_pcal_p_macro,
    STATE(5013), 1,
      sym_pcal_macro_decl,
    STATE(3952), 2,
      sym_block_comment,
      aux_sym__pcal_p_algorithm_repeat1,
    ACTIONS(7005), 4,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [28018] = 5,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3953), 2,
      sym_block_comment,
      aux_sym_block_comment_text_repeat1,
    ACTIONS(7007), 3,
      anon_sym_STAR_RPAREN,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
    ACTIONS(7009), 4,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
  [28040] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7012), 1,
      sym_identifier,
    STATE(3954), 1,
      sym_block_comment,
    STATE(4575), 1,
      sym_quantifier_bound,
    STATE(4603), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    STATE(5181), 1,
      sym__bound_or_identifier_list,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28070] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7014), 1,
      sym_identifier,
    STATE(3955), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4773), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    STATE(5197), 1,
      sym__bound_or_identifier_list,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28100] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3956), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4851), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28127] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3957), 1,
      sym_block_comment,
    ACTIONS(6996), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [28146] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3958), 1,
      sym_block_comment,
    STATE(4443), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28173] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3959), 1,
      sym_block_comment,
    ACTIONS(7018), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [28192] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3960), 1,
      sym_block_comment,
    ACTIONS(6983), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [28211] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7020), 1,
      sym_identifier,
    STATE(3961), 1,
      sym_block_comment,
    STATE(4461), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28238] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3962), 1,
      sym_block_comment,
    ACTIONS(7022), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [28257] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3963), 1,
      sym_block_comment,
    ACTIONS(6987), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [28276] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3964), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4774), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28303] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3965), 1,
      sym_block_comment,
    ACTIONS(7024), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [28322] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3966), 1,
      sym_block_comment,
    ACTIONS(7026), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [28341] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3967), 1,
      sym_block_comment,
    STATE(4513), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28368] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7030), 1,
      anon_sym_procedure,
    STATE(4333), 1,
      sym_pcal_c_procedure,
    STATE(5000), 1,
      sym_pcal_proc_decl,
    STATE(3968), 2,
      sym_block_comment,
      aux_sym__pcal_c_algorithm_repeat2,
    ACTIONS(7028), 3,
      anon_sym_LBRACE,
      anon_sym_fair,
      anon_sym_process,
  [28393] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7033), 1,
      sym_identifier,
    STATE(3969), 1,
      sym_block_comment,
    STATE(4527), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28420] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3970), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4916), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28447] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3971), 1,
      sym_block_comment,
    STATE(4427), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28474] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3972), 1,
      sym_block_comment,
    STATE(4536), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28501] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3973), 1,
      sym_block_comment,
    STATE(4558), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28528] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3974), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4938), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28555] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3975), 1,
      sym_block_comment,
    STATE(4573), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28582] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7035), 1,
      sym_identifier,
    STATE(3976), 1,
      sym_block_comment,
    STATE(4566), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28609] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3977), 1,
      sym_block_comment,
    ACTIONS(7037), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [28628] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3978), 1,
      sym_block_comment,
    STATE(4471), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28655] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7039), 1,
      sym_identifier,
    STATE(3979), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4717), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28682] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3980), 1,
      sym_block_comment,
    STATE(4598), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28709] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7041), 1,
      sym_identifier,
    STATE(3981), 1,
      sym_block_comment,
    STATE(4482), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28736] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7043), 1,
      anon_sym_procedure,
    STATE(4327), 1,
      sym_pcal_p_procedure,
    STATE(5021), 1,
      sym_pcal_proc_decl,
    STATE(3982), 2,
      sym_block_comment,
      aux_sym__pcal_p_algorithm_repeat2,
    ACTIONS(7046), 3,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [28761] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7048), 1,
      sym_identifier,
    STATE(3983), 1,
      sym_block_comment,
    STATE(4638), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28788] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7050), 1,
      sym_identifier,
    STATE(3984), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4899), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28815] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3985), 1,
      sym_block_comment,
    ACTIONS(7052), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [28834] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3986), 1,
      sym_block_comment,
    STATE(4602), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28861] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3987), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4661), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(3988), 1,
      sym_block_comment,
    ACTIONS(7054), 7,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [28907] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3989), 1,
      sym_block_comment,
    STATE(4625), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28934] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7056), 1,
      sym_identifier,
    STATE(3990), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4695), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28961] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3991), 1,
      sym_block_comment,
    STATE(4641), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [28988] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3992), 1,
      sym_block_comment,
    ACTIONS(7037), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [29007] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7058), 1,
      sym_identifier,
    STATE(3993), 1,
      sym_block_comment,
    STATE(4603), 1,
      sym_tuple_of_identifiers,
    STATE(5020), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29034] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3988), 1,
      sym_quantifier_bound,
    STATE(3994), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29061] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7060), 1,
      sym_identifier,
    STATE(3995), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4858), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29088] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3996), 1,
      sym_block_comment,
    STATE(4491), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29115] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3997), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4696), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29142] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(3998), 1,
      sym_block_comment,
    ACTIONS(7062), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [29161] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(3999), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4718), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29188] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7064), 1,
      sym_identifier,
    STATE(4000), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4754), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29215] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7066), 1,
      sym_identifier,
    STATE(4001), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4677), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29242] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(4002), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4772), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29269] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7068), 1,
      sym_identifier,
    STATE(4003), 1,
      sym_block_comment,
    STATE(4632), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29296] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7070), 1,
      sym_identifier,
    STATE(4004), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4801), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29323] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7072), 1,
      sym_identifier,
    STATE(4005), 1,
      sym_block_comment,
    STATE(4428), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29350] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(4006), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4814), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29377] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7074), 1,
      sym_identifier,
    STATE(4007), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4837), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29404] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7016), 1,
      sym_identifier,
    STATE(4008), 1,
      sym_block_comment,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(4861), 1,
      sym_quantifier_bound,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29431] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(4009), 1,
      sym_block_comment,
    ACTIONS(6975), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [29450] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7076), 1,
      sym_identifier,
    STATE(3988), 1,
      sym_quantifier_bound,
    STATE(4010), 1,
      sym_block_comment,
    STATE(4574), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29477] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(4011), 1,
      sym_block_comment,
    ACTIONS(7078), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [29496] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7080), 1,
      anon_sym_COLON,
    ACTIONS(7082), 1,
      anon_sym_LPAREN,
    ACTIONS(7084), 1,
      anon_sym_LBRACK,
    ACTIONS(7086), 1,
      anon_sym_DOT,
    STATE(4012), 1,
      sym_block_comment,
    STATE(4212), 1,
      aux_sym_pcal_lhs_repeat1,
    ACTIONS(7088), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [29525] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7090), 1,
      sym_identifier,
    STATE(4013), 1,
      sym_block_comment,
    STATE(4503), 1,
      sym_quantifier_bound,
    STATE(4659), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29552] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    STATE(4014), 1,
      sym_block_comment,
    ACTIONS(7092), 7,
      anon_sym_STAR_RPAREN,
      aux_sym_block_comment_text_token1,
      aux_sym_block_comment_text_token2,
      aux_sym_block_comment_text_token3,
      aux_sym_block_comment_text_token4,
      anon_sym_DASH_DASHalgorithm,
      anon_sym_DASH_DASHfair,
  [29571] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(3395), 1,
      sym_rangle_bracket,
    STATE(4015), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1421), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [29595] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7094), 1,
      sym_identifier,
    STATE(4016), 1,
      sym_block_comment,
    STATE(4306), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29619] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7096), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4017), 1,
      sym_block_comment,
    STATE(4020), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [29645] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7098), 1,
      sym_identifier,
    STATE(4018), 1,
      sym_block_comment,
    STATE(4316), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4019), 1,
      sym_block_comment,
    ACTIONS(7100), 6,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [29687] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7102), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4020), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [29713] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7104), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4021), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [29739] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7106), 1,
      anon_sym_COMMA,
    ACTIONS(7108), 1,
      sym__begin_proof_step,
    STATE(728), 1,
      sym_set_in,
    STATE(4022), 1,
      sym_block_comment,
    STATE(4213), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [29765] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7110), 1,
      anon_sym_LBRACK,
    ACTIONS(7112), 1,
      anon_sym_DOT,
    STATE(4023), 1,
      sym_block_comment,
    STATE(4108), 1,
      aux_sym_except_update_specifier_repeat1,
    STATE(5381), 1,
      sym_except_update_specifier,
    STATE(4875), 2,
      sym_except_update_record_field,
      sym_except_update_fn_appl,
  [29791] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(2556), 1,
      sym_rangle_bracket,
    STATE(4024), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1435), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [29815] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7114), 1,
      sym_identifier,
    STATE(4025), 1,
      sym_block_comment,
    STATE(4409), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29839] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7116), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4026), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [29865] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(4027), 1,
      sym_block_comment,
    ACTIONS(4269), 5,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      sym_identifier,
      anon_sym_BANG,
  [29885] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(2349), 1,
      sym_rangle_bracket,
    STATE(4028), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1433), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [29909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4286), 1,
      anon_sym_LPAREN,
    STATE(4029), 1,
      sym_block_comment,
    ACTIONS(4284), 5,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      sym_identifier,
      anon_sym_BANG,
  [29929] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7118), 1,
      sym_identifier,
    STATE(4030), 1,
      sym_block_comment,
    STATE(4295), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29953] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7120), 1,
      sym_identifier,
    STATE(4031), 1,
      sym_block_comment,
    STATE(4395), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [29977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4290), 1,
      anon_sym_LPAREN,
    STATE(4032), 1,
      sym_block_comment,
    ACTIONS(4288), 5,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      sym_identifier,
      anon_sym_BANG,
  [29997] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    STATE(4033), 1,
      sym_block_comment,
    ACTIONS(4280), 5,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      sym_identifier,
      anon_sym_BANG,
  [30017] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7122), 1,
      sym_identifier,
    STATE(4034), 1,
      sym_block_comment,
    STATE(4253), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [30041] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7124), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4021), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4035), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30067] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7126), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4036), 1,
      sym_block_comment,
    STATE(4039), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30093] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6266), 1,
      anon_sym_LPAREN,
    STATE(716), 1,
      sym_set_in,
    STATE(4037), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
    ACTIONS(7128), 2,
      anon_sym_COMMA,
      anon_sym_PROVE,
  [30117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4038), 1,
      sym_block_comment,
    ACTIONS(7130), 6,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [30135] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7132), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4039), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30161] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(3048), 1,
      sym_rangle_bracket,
    STATE(4040), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1429), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [30185] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7134), 1,
      sym_identifier,
    STATE(4041), 1,
      sym_block_comment,
    STATE(4290), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [30209] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7136), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4042), 1,
      sym_block_comment,
    STATE(4046), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    STATE(4043), 1,
      sym_block_comment,
    ACTIONS(5415), 5,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
      sym_identifier,
      anon_sym_BANG,
  [30255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4044), 1,
      sym_block_comment,
    ACTIONS(7138), 6,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [30273] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7140), 1,
      sym_identifier,
    STATE(4045), 1,
      sym_block_comment,
    STATE(4422), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [30297] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7142), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4046), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30323] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7144), 1,
      sym_identifier,
    STATE(4047), 1,
      sym_block_comment,
    STATE(4359), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [30347] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7146), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4048), 1,
      sym_block_comment,
    STATE(4052), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30373] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(2421), 1,
      sym_rangle_bracket,
    STATE(4049), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1143), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [30397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7150), 1,
      anon_sym_SEMI,
    STATE(4050), 1,
      sym_block_comment,
    ACTIONS(7148), 5,
      anon_sym_LBRACE,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
  [30417] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7152), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4051), 1,
      sym_block_comment,
    STATE(4054), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30443] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7154), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4052), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30469] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7156), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4053), 1,
      sym_block_comment,
    STATE(4084), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30495] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7108), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4054), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30521] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7158), 1,
      sym_identifier,
    STATE(4055), 1,
      sym_block_comment,
    STATE(4385), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [30545] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7160), 1,
      sym_identifier,
    STATE(4056), 1,
      sym_block_comment,
    STATE(4342), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [30569] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(3098), 1,
      sym_rangle_bracket,
    STATE(4057), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(986), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [30593] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7162), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4058), 1,
      sym_block_comment,
    STATE(4062), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4059), 1,
      sym_block_comment,
    ACTIONS(7164), 6,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [30637] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7166), 1,
      sym_identifier,
    STATE(4060), 1,
      sym_block_comment,
    STATE(4412), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [30661] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(2838), 1,
      sym_rangle_bracket,
    STATE(4061), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1437), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [30685] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7168), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4062), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30711] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7170), 1,
      sym_identifier,
    STATE(4063), 1,
      sym_block_comment,
    STATE(4243), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [30735] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7174), 1,
      anon_sym_SEMI,
    STATE(4064), 1,
      sym_block_comment,
    ACTIONS(7172), 5,
      anon_sym_LBRACE,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
  [30755] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7176), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4065), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [30781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7178), 1,
      anon_sym_SEMI,
    STATE(4066), 1,
      sym_block_comment,
    ACTIONS(7180), 5,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [30801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4067), 1,
      sym_block_comment,
    ACTIONS(7182), 6,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [30819] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7082), 1,
      anon_sym_LPAREN,
    ACTIONS(7084), 1,
      anon_sym_LBRACK,
    ACTIONS(7086), 1,
      anon_sym_DOT,
    STATE(4068), 1,
      sym_block_comment,
    STATE(4212), 1,
      aux_sym_pcal_lhs_repeat1,
    ACTIONS(7088), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [30845] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(2944), 1,
      sym_rangle_bracket,
    STATE(4069), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1419), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [30869] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6266), 1,
      anon_sym_LPAREN,
    STATE(686), 1,
      sym_set_in,
    STATE(4070), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
    ACTIONS(7184), 2,
      anon_sym_COMMA,
      anon_sym_PROVE,
  [30893] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(1053), 1,
      sym_all_map_to,
    STATE(4071), 1,
      sym_block_comment,
    STATE(4079), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [30917] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(2730), 1,
      sym_rangle_bracket,
    STATE(4072), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1425), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [30941] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(814), 1,
      sym_all_map_to,
    STATE(4073), 1,
      sym_block_comment,
    STATE(4075), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [30965] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7188), 1,
      anon_sym_SEMI,
    STATE(4074), 1,
      sym_block_comment,
    ACTIONS(7190), 5,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [30985] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(819), 1,
      sym_all_map_to,
    STATE(4075), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31009] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7192), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4065), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4076), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [31035] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(2430), 1,
      sym_rangle_bracket,
    STATE(4077), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1431), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [31059] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7194), 1,
      sym_identifier,
    STATE(4078), 1,
      sym_block_comment,
    STATE(4401), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [31083] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(683), 1,
      sym_all_map_to,
    STATE(4079), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31107] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7196), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4080), 1,
      sym_block_comment,
    STATE(4081), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [31133] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7198), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4081), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [31159] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(828), 1,
      sym_all_map_to,
    STATE(4082), 1,
      sym_block_comment,
    STATE(4083), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31183] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(834), 1,
      sym_all_map_to,
    STATE(4083), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31207] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7200), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4084), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [31233] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(843), 1,
      sym_all_map_to,
    STATE(4085), 1,
      sym_block_comment,
    STATE(4086), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31257] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(849), 1,
      sym_all_map_to,
    STATE(4086), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4087), 1,
      sym_block_comment,
    ACTIONS(7202), 6,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [31299] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7204), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4088), 1,
      sym_block_comment,
    STATE(4103), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [31325] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(857), 1,
      sym_all_map_to,
    STATE(4089), 1,
      sym_block_comment,
    STATE(4090), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(862), 1,
      sym_all_map_to,
    STATE(4090), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31373] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(871), 1,
      sym_all_map_to,
    STATE(4091), 1,
      sym_block_comment,
    STATE(4093), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31397] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(2577), 1,
      sym_rangle_bracket,
    STATE(4092), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1219), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [31421] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(877), 1,
      sym_all_map_to,
    STATE(4093), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31445] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7206), 1,
      anon_sym_LBRACK,
    ACTIONS(7209), 1,
      anon_sym_DOT,
    ACTIONS(7212), 1,
      anon_sym_EQ,
    STATE(4094), 2,
      sym_block_comment,
      aux_sym_except_update_specifier_repeat1,
    STATE(4875), 2,
      sym_except_update_record_field,
      sym_except_update_fn_appl,
  [31469] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(887), 1,
      sym_all_map_to,
    STATE(4095), 1,
      sym_block_comment,
    STATE(4097), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31493] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(4096), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(5349), 1,
      sym_rangle_bracket,
    ACTIONS(1417), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [31517] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(892), 1,
      sym_all_map_to,
    STATE(4097), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31541] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(901), 1,
      sym_all_map_to,
    STATE(4098), 1,
      sym_block_comment,
    STATE(4099), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31565] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(907), 1,
      sym_all_map_to,
    STATE(4099), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31589] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(917), 1,
      sym_all_map_to,
    STATE(4100), 1,
      sym_block_comment,
    STATE(4101), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31613] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(923), 1,
      sym_all_map_to,
    STATE(4101), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31637] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(3192), 1,
      sym_rangle_bracket,
    STATE(4102), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1423), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [31661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7214), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4103), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [31687] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(932), 1,
      sym_all_map_to,
    STATE(4104), 1,
      sym_block_comment,
    STATE(4105), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31711] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(938), 1,
      sym_all_map_to,
    STATE(4105), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31735] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(947), 1,
      sym_all_map_to,
    STATE(4106), 1,
      sym_block_comment,
    STATE(4107), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31759] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(952), 1,
      sym_all_map_to,
    STATE(4107), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31783] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7110), 1,
      anon_sym_LBRACK,
    ACTIONS(7112), 1,
      anon_sym_DOT,
    ACTIONS(7216), 1,
      anon_sym_EQ,
    STATE(4094), 1,
      aux_sym_except_update_specifier_repeat1,
    STATE(4108), 1,
      sym_block_comment,
    STATE(4875), 2,
      sym_except_update_record_field,
      sym_except_update_fn_appl,
  [31809] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(960), 1,
      sym_all_map_to,
    STATE(4109), 1,
      sym_block_comment,
    STATE(4110), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31833] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(965), 1,
      sym_all_map_to,
    STATE(4110), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31857] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    STATE(4111), 1,
      sym_block_comment,
    STATE(4128), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4663), 1,
      sym_rangle_bracket,
    ACTIONS(1417), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [31881] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7218), 1,
      sym_identifier,
    STATE(4112), 1,
      sym_block_comment,
    STATE(4325), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [31905] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(975), 1,
      sym_all_map_to,
    STATE(4113), 1,
      sym_block_comment,
    STATE(4114), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31929] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(981), 1,
      sym_all_map_to,
    STATE(4114), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31953] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(990), 1,
      sym_all_map_to,
    STATE(4115), 1,
      sym_block_comment,
    STATE(4116), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [31977] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(996), 1,
      sym_all_map_to,
    STATE(4116), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [32001] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(1005), 1,
      sym_all_map_to,
    STATE(4117), 1,
      sym_block_comment,
    STATE(4118), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [32025] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(1011), 1,
      sym_all_map_to,
    STATE(4118), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [32049] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(1021), 1,
      sym_all_map_to,
    STATE(4119), 1,
      sym_block_comment,
    STATE(4121), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [32073] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      sym_rangle_bracket,
    STATE(4120), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1441), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [32097] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(1027), 1,
      sym_all_map_to,
    STATE(4121), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [32121] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7220), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4122), 1,
      sym_block_comment,
    STATE(4126), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [32147] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(1035), 1,
      sym_all_map_to,
    STATE(4123), 1,
      sym_block_comment,
    STATE(4124), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [32171] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(1037), 1,
      sym_all_map_to,
    STATE(4124), 1,
      sym_block_comment,
    STATE(4238), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [32195] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7222), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4125), 1,
      sym_block_comment,
    STATE(4131), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [32221] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7224), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4126), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [32247] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7226), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4127), 1,
      sym_block_comment,
    STATE(4129), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [32273] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4128), 1,
      sym_block_comment,
    STATE(4843), 1,
      sym_rangle_bracket,
    ACTIONS(1417), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [32297] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7228), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4129), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [32323] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7230), 1,
      sym_identifier,
    STATE(4130), 1,
      sym_block_comment,
    STATE(4381), 1,
      sym_tuple_of_identifiers,
    STATE(5143), 1,
      sym_langle_bracket,
    ACTIONS(2581), 3,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
  [32347] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7232), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4131), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [32373] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7234), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4132), 1,
      sym_block_comment,
    STATE(4135), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [32399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4133), 1,
      sym_block_comment,
    ACTIONS(7236), 6,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [32417] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(968), 1,
      sym_bullet_conj,
    STATE(969), 1,
      sym_bullet_disj,
    STATE(4134), 1,
      sym_block_comment,
    ACTIONS(7238), 2,
      anon_sym_SLASH_BSLASH,
      anon_sym_u2227,
    ACTIONS(7240), 2,
      anon_sym_BSLASH_SLASH,
      anon_sym_u2228,
  [32441] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7242), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4135), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [32467] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(3181), 1,
      sym_rangle_bracket,
    STATE(4136), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1427), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [32491] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(3321), 1,
      sym_rangle_bracket,
    STATE(4137), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1439), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [32515] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7244), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4138), 1,
      sym_block_comment,
    STATE(4141), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [32541] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7106), 1,
      anon_sym_COMMA,
    ACTIONS(7152), 1,
      sym__begin_proof_step,
    STATE(725), 1,
      sym_set_in,
    STATE(4022), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4139), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [32567] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4128), 1,
      anon_sym_COMMA,
    STATE(2270), 1,
      sym_rangle_bracket,
    STATE(4140), 1,
      sym_block_comment,
    STATE(4224), 1,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(1217), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [32591] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7246), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4141), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [32617] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7248), 1,
      anon_sym_COLON,
    STATE(837), 1,
      sym_set_in,
    STATE(4026), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4142), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [32643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4143), 1,
      sym_block_comment,
    ACTIONS(7250), 5,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [32660] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    ACTIONS(7252), 1,
      anon_sym_end,
    STATE(4144), 1,
      sym_block_comment,
    STATE(4204), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4848), 1,
      sym_pcal_p_process,
  [32685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7256), 1,
      anon_sym_SEMI,
    STATE(4145), 1,
      sym_block_comment,
    ACTIONS(7254), 4,
      anon_sym_end,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [32704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4146), 1,
      sym_block_comment,
    ACTIONS(7258), 5,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [32721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4147), 1,
      sym_block_comment,
    ACTIONS(7260), 5,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [32738] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    ACTIONS(7262), 1,
      anon_sym_end,
    STATE(4148), 1,
      sym_block_comment,
    STATE(4204), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4848), 1,
      sym_pcal_p_process,
  [32763] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4149), 1,
      sym_block_comment,
    STATE(4364), 1,
      aux_sym_conj_list_repeat1,
    STATE(4373), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [32788] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4150), 1,
      sym_block_comment,
    STATE(4353), 1,
      aux_sym_conj_list_repeat1,
    STATE(4356), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [32813] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    ACTIONS(7266), 1,
      anon_sym_end,
    STATE(4151), 1,
      sym_block_comment,
    STATE(4204), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4848), 1,
      sym_pcal_p_process,
  [32838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4152), 1,
      sym_block_comment,
    ACTIONS(7268), 5,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [32855] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    ACTIONS(7270), 1,
      anon_sym_end,
    STATE(4153), 1,
      sym_block_comment,
    STATE(4204), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4848), 1,
      sym_pcal_p_process,
  [32880] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4154), 1,
      sym_block_comment,
    STATE(4244), 1,
      aux_sym_disj_list_repeat1,
    STATE(4418), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [32905] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4155), 1,
      sym_block_comment,
    STATE(4376), 1,
      aux_sym_conj_list_repeat1,
    STATE(4377), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [32930] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7272), 1,
      anon_sym_COMMA,
    STATE(4156), 2,
      sym_block_comment,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(4571), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [32949] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(7275), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4157), 1,
      sym_block_comment,
    ACTIONS(5415), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [32970] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    ACTIONS(7277), 1,
      anon_sym_end,
    STATE(4158), 1,
      sym_block_comment,
    STATE(4204), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4848), 1,
      sym_pcal_p_process,
  [32995] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    ACTIONS(7279), 1,
      anon_sym_RBRACE,
    STATE(4159), 1,
      sym_block_comment,
    STATE(4196), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4615), 1,
      sym_pcal_c_process,
  [33020] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    ACTIONS(7281), 1,
      anon_sym_RBRACE,
    STATE(4160), 1,
      sym_block_comment,
    STATE(4196), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4615), 1,
      sym_pcal_c_process,
  [33045] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    ACTIONS(7283), 1,
      anon_sym_end,
    STATE(4161), 1,
      sym_block_comment,
    STATE(4204), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4848), 1,
      sym_pcal_p_process,
  [33070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(333), 1,
      anon_sym_LPAREN,
    STATE(4162), 1,
      sym_block_comment,
    ACTIONS(324), 4,
      sym_placeholder,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [33089] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    ACTIONS(7285), 1,
      anon_sym_RBRACE,
    STATE(4163), 1,
      sym_block_comment,
    STATE(4196), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4615), 1,
      sym_pcal_c_process,
  [33114] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    STATE(699), 1,
      sym_set_in,
    STATE(4164), 1,
      sym_block_comment,
    STATE(4208), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [33137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4165), 1,
      sym_block_comment,
    ACTIONS(7287), 5,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [33154] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(7289), 1,
      aux_sym_octal_number_token1,
    STATE(4166), 1,
      sym_block_comment,
    ACTIONS(5391), 3,
      sym__begin_proof_step,
      anon_sym_COMMA,
      anon_sym_BANG,
  [33175] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7293), 1,
      anon_sym_variable,
    ACTIONS(7295), 1,
      anon_sym_variables,
    STATE(4167), 1,
      sym_block_comment,
    STATE(5022), 1,
      sym_pcal_proc_var_decls,
    ACTIONS(7291), 2,
      anon_sym_LBRACE,
      anon_sym_begin,
  [33198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7299), 1,
      anon_sym_SEMI,
    STATE(4168), 1,
      sym_block_comment,
    ACTIONS(7297), 4,
      anon_sym_LBRACE,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
  [33217] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(7301), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4169), 1,
      sym_block_comment,
    ACTIONS(5415), 3,
      sym__begin_proof_step,
      anon_sym_COMMA,
      anon_sym_BANG,
  [33238] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    ACTIONS(7303), 1,
      anon_sym_RBRACE,
    STATE(4170), 1,
      sym_block_comment,
    STATE(4196), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4615), 1,
      sym_pcal_c_process,
  [33263] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    ACTIONS(7305), 1,
      anon_sym_RBRACE,
    STATE(4171), 1,
      sym_block_comment,
    STATE(4196), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4615), 1,
      sym_pcal_c_process,
  [33288] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7307), 1,
      sym_identifier,
    ACTIONS(7310), 1,
      anon_sym_LBRACE,
    ACTIONS(7312), 1,
      anon_sym_begin,
    STATE(4992), 1,
      sym_pcal_proc_var_decl,
    STATE(4172), 2,
      sym_block_comment,
      aux_sym_pcal_proc_var_decls_repeat1,
  [33311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4173), 1,
      sym_block_comment,
    ACTIONS(7314), 5,
      anon_sym_LBRACE,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
  [33328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4174), 1,
      sym_block_comment,
    ACTIONS(7316), 5,
      anon_sym_LBRACE,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
  [33345] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9), 1,
      anon_sym_DASH_DASH_DASH_DASH,
    ACTIONS(6136), 1,
      ts_builtin_sym_end,
    STATE(4175), 1,
      sym_block_comment,
    STATE(4229), 1,
      aux_sym_source_file_repeat1,
    STATE(4679), 1,
      sym_module,
    STATE(5402), 1,
      sym_single_line,
  [33370] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4176), 1,
      sym_block_comment,
    STATE(4313), 1,
      aux_sym_conj_list_repeat1,
    STATE(4320), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [33395] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4177), 1,
      sym_block_comment,
    STATE(4369), 1,
      aux_sym_conj_list_repeat1,
    STATE(4370), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [33420] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4178), 1,
      sym_block_comment,
    STATE(4336), 1,
      aux_sym_disj_list_repeat1,
    STATE(4372), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [33445] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9), 1,
      anon_sym_DASH_DASH_DASH_DASH,
    ACTIONS(6203), 1,
      ts_builtin_sym_end,
    STATE(4179), 1,
      sym_block_comment,
    STATE(4229), 1,
      aux_sym_source_file_repeat1,
    STATE(4679), 1,
      sym_module,
    STATE(5402), 1,
      sym_single_line,
  [33470] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    ACTIONS(7318), 1,
      anon_sym_end,
    STATE(4180), 1,
      sym_block_comment,
    STATE(4204), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4848), 1,
      sym_pcal_p_process,
  [33495] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4181), 1,
      sym_block_comment,
    STATE(4263), 1,
      aux_sym_conj_list_repeat1,
    STATE(4266), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [33520] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4491), 1,
      anon_sym_COMMA,
    ACTIONS(6255), 1,
      anon_sym_DEF,
    STATE(4182), 1,
      sym_block_comment,
    STATE(4199), 1,
      aux_sym_use_body_expr_repeat1,
    ACTIONS(6257), 2,
      sym__begin_proof_step,
      anon_sym_DEFS,
  [33543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4183), 1,
      sym_block_comment,
    ACTIONS(7320), 5,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [33560] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    STATE(725), 1,
      sym_set_in,
    STATE(4184), 1,
      sym_block_comment,
    STATE(4188), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [33583] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    ACTIONS(7322), 1,
      anon_sym_RBRACE,
    STATE(4185), 1,
      sym_block_comment,
    STATE(4196), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4615), 1,
      sym_pcal_c_process,
  [33608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4186), 1,
      sym_block_comment,
    ACTIONS(7324), 5,
      anon_sym_LBRACE,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
  [33625] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7326), 1,
      sym_identifier,
    ACTIONS(7328), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      anon_sym_begin,
    STATE(4172), 1,
      aux_sym_pcal_proc_var_decls_repeat1,
    STATE(4187), 1,
      sym_block_comment,
    STATE(4992), 1,
      sym_pcal_proc_var_decl,
  [33650] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    STATE(728), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4188), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [33673] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7293), 1,
      anon_sym_variable,
    ACTIONS(7295), 1,
      anon_sym_variables,
    STATE(4189), 1,
      sym_block_comment,
    STATE(4982), 1,
      sym_pcal_proc_var_decls,
    ACTIONS(7332), 2,
      anon_sym_LBRACE,
      anon_sym_begin,
  [33696] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4477), 1,
      anon_sym_variable,
    ACTIONS(4479), 1,
      anon_sym_variables,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    STATE(4190), 1,
      sym_block_comment,
    STATE(4271), 1,
      sym_pcal_c_algorithm_body,
    STATE(5016), 1,
      sym_pcal_var_decls,
  [33721] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7293), 1,
      anon_sym_variable,
    ACTIONS(7295), 1,
      anon_sym_variables,
    STATE(4191), 1,
      sym_block_comment,
    STATE(4978), 1,
      sym_pcal_proc_var_decls,
    ACTIONS(7334), 2,
      anon_sym_LBRACE,
      anon_sym_begin,
  [33744] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    ACTIONS(7336), 1,
      anon_sym_RBRACE,
    STATE(4192), 1,
      sym_block_comment,
    STATE(4196), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4615), 1,
      sym_pcal_c_process,
  [33769] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    STATE(628), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4193), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [33792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4194), 1,
      sym_block_comment,
    ACTIONS(7338), 5,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [33809] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3559), 1,
      anon_sym_DEF,
    ACTIONS(4491), 1,
      anon_sym_COMMA,
    STATE(4182), 1,
      aux_sym_use_body_expr_repeat1,
    STATE(4195), 1,
      sym_block_comment,
    ACTIONS(3561), 2,
      sym__begin_proof_step,
      anon_sym_DEFS,
  [33832] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7340), 1,
      anon_sym_RBRACE,
    ACTIONS(7342), 1,
      anon_sym_fair,
    ACTIONS(7345), 1,
      anon_sym_process,
    STATE(4615), 1,
      sym_pcal_c_process,
    STATE(4196), 2,
      sym_block_comment,
      aux_sym__pcal_c_algorithm_repeat3,
  [33855] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4477), 1,
      anon_sym_variable,
    ACTIONS(4479), 1,
      anon_sym_variables,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    STATE(4197), 1,
      sym_block_comment,
    STATE(4414), 1,
      sym_pcal_c_algorithm_body,
    STATE(4980), 1,
      sym_pcal_var_decls,
  [33880] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4198), 1,
      sym_block_comment,
    STATE(4397), 1,
      aux_sym_conj_list_repeat1,
    STATE(4398), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [33905] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3627), 1,
      anon_sym_DEF,
    ACTIONS(7348), 1,
      anon_sym_COMMA,
    ACTIONS(3629), 2,
      sym__begin_proof_step,
      anon_sym_DEFS,
    STATE(4199), 2,
      sym_block_comment,
      aux_sym_use_body_expr_repeat1,
  [33926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4200), 1,
      sym_block_comment,
    ACTIONS(7351), 5,
      anon_sym_macro,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [33943] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    ACTIONS(7353), 1,
      anon_sym_end,
    STATE(4201), 1,
      sym_block_comment,
    STATE(4204), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4848), 1,
      sym_pcal_p_process,
  [33968] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    STATE(837), 1,
      sym_set_in,
    STATE(4193), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4202), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [33991] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    ACTIONS(7355), 1,
      anon_sym_end,
    STATE(4203), 1,
      sym_block_comment,
    STATE(4204), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4848), 1,
      sym_pcal_p_process,
  [34016] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7357), 1,
      anon_sym_end,
    ACTIONS(7359), 1,
      anon_sym_fair,
    ACTIONS(7362), 1,
      anon_sym_process,
    STATE(4848), 1,
      sym_pcal_p_process,
    STATE(4204), 2,
      sym_block_comment,
      aux_sym__pcal_p_algorithm_repeat3,
  [34039] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4205), 1,
      sym_block_comment,
    STATE(4419), 1,
      aux_sym_conj_list_repeat1,
    STATE(4420), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [34064] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4206), 1,
      sym_block_comment,
    STATE(4281), 1,
      aux_sym_conj_list_repeat1,
    STATE(4282), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [34089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7367), 1,
      anon_sym_or,
    STATE(4207), 1,
      sym_block_comment,
    STATE(4228), 1,
      aux_sym_pcal_c_either_repeat1,
    ACTIONS(7365), 3,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
  [34110] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    STATE(704), 1,
      sym_set_in,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4208), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [34133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4209), 1,
      sym_block_comment,
    ACTIONS(7369), 5,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [34150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7371), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7374), 2,
      anon_sym_RPAREN,
      anon_sym_do,
    STATE(4210), 2,
      sym_block_comment,
      aux_sym__pcal_with_vars_repeat1,
  [34169] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5910), 1,
      anon_sym_LPAREN,
    STATE(4211), 1,
      sym_block_comment,
    ACTIONS(5908), 4,
      anon_sym_BSLASHin,
      anon_sym_u2208,
      anon_sym_COLON,
      anon_sym_BANG,
  [34188] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7084), 1,
      anon_sym_LBRACK,
    ACTIONS(7086), 1,
      anon_sym_DOT,
    STATE(4212), 1,
      sym_block_comment,
    STATE(4227), 1,
      aux_sym_pcal_lhs_repeat1,
    ACTIONS(7376), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [34211] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7378), 1,
      anon_sym_COMMA,
    STATE(4213), 2,
      sym_block_comment,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6237), 3,
      sym__begin_proof_step,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [34230] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4214), 1,
      sym_block_comment,
    STATE(4404), 1,
      aux_sym_conj_list_repeat1,
    STATE(4405), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [34255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4215), 1,
      sym_block_comment,
    ACTIONS(7381), 5,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [34272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7383), 1,
      anon_sym_SEMI,
    STATE(4216), 1,
      sym_block_comment,
    ACTIONS(7385), 4,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [34291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4217), 1,
      sym_block_comment,
    ACTIONS(7387), 5,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [34308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4218), 1,
      sym_block_comment,
    ACTIONS(7389), 5,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [34325] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4219), 1,
      sym_block_comment,
    STATE(4305), 1,
      aux_sym_conj_list_repeat1,
    STATE(4307), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [34350] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4220), 1,
      sym_block_comment,
    STATE(4366), 1,
      aux_sym_conj_list_repeat1,
    STATE(4367), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [34375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4221), 1,
      sym_block_comment,
    ACTIONS(7391), 5,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [34392] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4477), 1,
      anon_sym_variable,
    ACTIONS(4479), 1,
      anon_sym_variables,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    STATE(4222), 1,
      sym_block_comment,
    STATE(4296), 1,
      sym_pcal_c_algorithm_body,
    STATE(4970), 1,
      sym_pcal_var_decls,
  [34417] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4223), 1,
      sym_block_comment,
    STATE(4330), 1,
      aux_sym_conj_list_repeat1,
    STATE(4331), 1,
      aux_sym_disj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [34442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7393), 1,
      anon_sym_COMMA,
    STATE(4224), 2,
      sym_block_comment,
      aux_sym_finite_set_literal_repeat1,
    ACTIONS(4571), 3,
      anon_sym_GT_GT,
      anon_sym_u3009,
      anon_sym_u27e9,
  [34461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7396), 1,
      anon_sym_COMMA,
    STATE(4225), 2,
      sym_block_comment,
      aux_sym_function_definition_repeat1,
    ACTIONS(7054), 3,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [34480] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7401), 1,
      anon_sym_SEMI,
    STATE(4226), 1,
      sym_block_comment,
    ACTIONS(7399), 4,
      anon_sym_end,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_or,
  [34499] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7403), 1,
      anon_sym_LBRACK,
    ACTIONS(7406), 1,
      anon_sym_DOT,
    ACTIONS(7409), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
    STATE(4227), 2,
      sym_block_comment,
      aux_sym_pcal_lhs_repeat1,
  [34520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7413), 1,
      anon_sym_or,
    STATE(4228), 2,
      sym_block_comment,
      aux_sym_pcal_c_either_repeat1,
    ACTIONS(7411), 3,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
  [34539] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7416), 1,
      ts_builtin_sym_end,
    ACTIONS(7418), 1,
      anon_sym_DASH_DASH_DASH_DASH,
    STATE(4679), 1,
      sym_module,
    STATE(5402), 1,
      sym_single_line,
    STATE(4229), 2,
      sym_block_comment,
      aux_sym_source_file_repeat1,
  [34562] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(7421), 1,
      sym_placeholder,
    ACTIONS(7423), 1,
      anon_sym_LPAREN,
    STATE(4230), 1,
      sym_block_comment,
    ACTIONS(6248), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [34585] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    ACTIONS(7425), 1,
      anon_sym_RBRACE,
    STATE(4196), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4231), 1,
      sym_block_comment,
    STATE(4615), 1,
      sym_pcal_c_process,
  [34610] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4210), 1,
      aux_sym__pcal_with_vars_repeat1,
    STATE(4232), 1,
      sym_block_comment,
    ACTIONS(7427), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7429), 2,
      anon_sym_RPAREN,
      anon_sym_do,
  [34631] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(7431), 1,
      aux_sym_octal_number_token1,
    STATE(4233), 1,
      sym_block_comment,
    ACTIONS(5391), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [34652] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    ACTIONS(7433), 1,
      anon_sym_RBRACE,
    STATE(4196), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4234), 1,
      sym_block_comment,
    STATE(4615), 1,
      sym_pcal_c_process,
  [34677] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7084), 1,
      anon_sym_LBRACK,
    ACTIONS(7086), 1,
      anon_sym_DOT,
    STATE(4212), 1,
      aux_sym_pcal_lhs_repeat1,
    STATE(4235), 1,
      sym_block_comment,
    ACTIONS(7088), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [34700] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6874), 1,
      anon_sym_fair,
    ACTIONS(6876), 1,
      anon_sym_process,
    ACTIONS(7435), 1,
      anon_sym_end,
    STATE(4204), 1,
      aux_sym__pcal_p_algorithm_repeat3,
    STATE(4236), 1,
      sym_block_comment,
    STATE(4848), 1,
      sym_pcal_p_process,
  [34725] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6882), 1,
      anon_sym_fair,
    ACTIONS(6884), 1,
      anon_sym_process,
    ACTIONS(7437), 1,
      anon_sym_RBRACE,
    STATE(4196), 1,
      aux_sym__pcal_c_algorithm_repeat3,
    STATE(4237), 1,
      sym_block_comment,
    STATE(4615), 1,
      sym_pcal_c_process,
  [34750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7439), 1,
      anon_sym_COMMA,
    STATE(4238), 2,
      sym_block_comment,
      aux_sym_function_definition_repeat1,
    ACTIONS(7054), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [34769] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7264), 1,
      sym__bullet,
    STATE(4239), 1,
      sym_block_comment,
    STATE(4324), 1,
      aux_sym_disj_list_repeat1,
    STATE(4326), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
    STATE(5029), 1,
      sym_disj_item,
  [34794] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7444), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7446), 1,
      sym_escape_char,
    STATE(4240), 1,
      sym_block_comment,
    STATE(4318), 1,
      aux_sym_string_repeat1,
  [34816] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7448), 1,
      anon_sym_DQUOTE2,
    STATE(4241), 1,
      sym_block_comment,
    STATE(4318), 1,
      aux_sym_string_repeat1,
  [34838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4242), 1,
      sym_block_comment,
    ACTIONS(6237), 4,
      sym__begin_proof_step,
      anon_sym_BSLASHin,
      anon_sym_u2208,
      anon_sym_COMMA,
  [34854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7450), 1,
      anon_sym_COLON,
    STATE(844), 1,
      sym_set_in,
    STATE(4243), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [34874] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7454), 1,
      sym__dedent,
    STATE(4244), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [34896] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(87), 1,
      sym_gets,
    STATE(4245), 1,
      sym_block_comment,
    ACTIONS(7456), 3,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
  [34914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(44), 1,
      sym_gets,
    STATE(4246), 1,
      sym_block_comment,
    ACTIONS(7456), 3,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
  [34932] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7458), 1,
      anon_sym_BY,
    ACTIONS(7462), 1,
      sym__begin_proof,
    STATE(4247), 1,
      sym_block_comment,
    ACTIONS(7460), 2,
      anon_sym_OBVIOUS,
      anon_sym_OMITTED,
  [34952] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7464), 1,
      anon_sym_DQUOTE2,
    STATE(4248), 1,
      sym_block_comment,
    STATE(4318), 1,
      aux_sym_string_repeat1,
  [34974] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7466), 1,
      sym__begin_proof_step,
    STATE(3579), 1,
      sym_qed_step,
    STATE(4249), 1,
      sym_block_comment,
    STATE(4741), 1,
      aux_sym_non_terminal_proof_repeat1,
    STATE(5357), 1,
      sym_proof_step,
  [34996] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7466), 1,
      sym__begin_proof_step,
    STATE(3579), 1,
      sym_qed_step,
    STATE(4250), 1,
      sym_block_comment,
    STATE(4350), 1,
      aux_sym_non_terminal_proof_repeat1,
    STATE(5357), 1,
      sym_proof_step,
  [35018] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(128), 1,
      sym_gets,
    STATE(4251), 1,
      sym_block_comment,
    ACTIONS(7456), 3,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
  [35036] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(129), 1,
      sym_gets,
    STATE(4252), 1,
      sym_block_comment,
    ACTIONS(7456), 3,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
  [35054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7468), 1,
      anon_sym_COLON,
    STATE(948), 1,
      sym_set_in,
    STATE(4253), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [35074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4254), 1,
      sym_block_comment,
    ACTIONS(7470), 4,
      anon_sym_LBRACE,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
  [35090] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7472), 1,
      anon_sym_BY,
    ACTIONS(7476), 1,
      sym__begin_proof,
    STATE(4255), 1,
      sym_block_comment,
    ACTIONS(7474), 2,
      anon_sym_OBVIOUS,
      anon_sym_OMITTED,
  [35110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4256), 1,
      sym_block_comment,
    ACTIONS(7478), 4,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [35126] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7482), 1,
      anon_sym_SEMI,
    STATE(4257), 1,
      sym_block_comment,
    ACTIONS(7480), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [35144] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7484), 1,
      anon_sym_DQUOTE2,
    STATE(4258), 1,
      sym_block_comment,
    STATE(4286), 1,
      aux_sym_string_repeat1,
  [35166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7488), 1,
      anon_sym_SEMI,
    STATE(4259), 1,
      sym_block_comment,
    ACTIONS(7486), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [35184] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7490), 1,
      anon_sym_EQ,
    STATE(740), 1,
      sym_set_in,
    STATE(4260), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [35204] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7492), 1,
      anon_sym_end,
    ACTIONS(7494), 1,
      anon_sym_elsif,
    ACTIONS(7496), 1,
      anon_sym_else,
    STATE(4261), 1,
      sym_block_comment,
    STATE(4403), 1,
      aux_sym_pcal_p_if_repeat1,
  [35226] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(319), 1,
      sym_case_arrow,
    STATE(4262), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [35244] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7500), 1,
      sym__dedent,
    STATE(4263), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [35266] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7502), 1,
      anon_sym_EQ,
    STATE(772), 1,
      sym_set_in,
    STATE(4264), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [35286] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7504), 1,
      anon_sym_EQ,
    STATE(763), 1,
      sym_set_in,
    STATE(4265), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [35306] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7506), 1,
      sym__dedent,
    STATE(4266), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [35328] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(541), 1,
      sym_case_arrow,
    STATE(4267), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [35346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4268), 1,
      sym_block_comment,
    ACTIONS(7508), 4,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_or,
  [35362] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7510), 1,
      anon_sym_EQ,
    STATE(745), 1,
      sym_set_in,
    STATE(4269), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [35382] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(7423), 1,
      anon_sym_LPAREN,
    STATE(4270), 1,
      sym_block_comment,
    ACTIONS(6248), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [35402] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7514), 1,
      anon_sym_SEMI,
    STATE(4271), 1,
      sym_block_comment,
    ACTIONS(7512), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [35420] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7518), 1,
      anon_sym_SEMI,
    STATE(4272), 1,
      sym_block_comment,
    ACTIONS(7516), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [35438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(434), 1,
      sym_case_arrow,
    STATE(4273), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [35456] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7520), 1,
      anon_sym_DQUOTE2,
    STATE(4274), 1,
      sym_block_comment,
    STATE(4285), 1,
      aux_sym_string_repeat1,
  [35478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(65), 1,
      sym_gets,
    STATE(4275), 1,
      sym_block_comment,
    ACTIONS(7456), 3,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
  [35496] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(46), 1,
      sym_gets,
    STATE(4276), 1,
      sym_block_comment,
    ACTIONS(7456), 3,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
  [35514] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(381), 1,
      sym_case_arrow,
    STATE(4277), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [35532] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      sym__begin_proof_step,
    STATE(3579), 1,
      sym_qed_step,
    STATE(4278), 1,
      sym_block_comment,
    STATE(4741), 1,
      aux_sym_non_terminal_proof_repeat1,
    STATE(5357), 1,
      sym_proof_step,
  [35554] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      sym__begin_proof_step,
    STATE(3579), 1,
      sym_qed_step,
    STATE(4279), 1,
      sym_block_comment,
    STATE(4287), 1,
      aux_sym_non_terminal_proof_repeat1,
    STATE(5357), 1,
      sym_proof_step,
  [35576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7526), 1,
      anon_sym_SEMI,
    STATE(4280), 1,
      sym_block_comment,
    ACTIONS(7524), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [35594] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7528), 1,
      sym__dedent,
    STATE(4281), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [35616] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7530), 1,
      sym__dedent,
    STATE(4282), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [35638] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      sym__begin_proof_step,
    STATE(3589), 1,
      sym_qed_step,
    STATE(4278), 1,
      aux_sym_non_terminal_proof_repeat1,
    STATE(4283), 1,
      sym_block_comment,
    STATE(5357), 1,
      sym_proof_step,
  [35660] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3627), 1,
      anon_sym_DEF,
    STATE(4284), 1,
      sym_block_comment,
    ACTIONS(3629), 3,
      sym__begin_proof_step,
      anon_sym_COMMA,
      anon_sym_DEFS,
  [35678] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7532), 1,
      anon_sym_DQUOTE2,
    STATE(4285), 1,
      sym_block_comment,
    STATE(4318), 1,
      aux_sym_string_repeat1,
  [35700] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7534), 1,
      anon_sym_DQUOTE2,
    STATE(4286), 1,
      sym_block_comment,
    STATE(4318), 1,
      aux_sym_string_repeat1,
  [35722] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7522), 1,
      sym__begin_proof_step,
    STATE(3593), 1,
      sym_qed_step,
    STATE(4287), 1,
      sym_block_comment,
    STATE(4741), 1,
      aux_sym_non_terminal_proof_repeat1,
    STATE(5357), 1,
      sym_proof_step,
  [35744] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7536), 1,
      anon_sym_DQUOTE2,
    STATE(4288), 1,
      sym_block_comment,
    STATE(4315), 1,
      aux_sym_string_repeat1,
  [35766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7540), 1,
      anon_sym_else,
    STATE(4289), 1,
      sym_block_comment,
    ACTIONS(7538), 3,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_or,
  [35784] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7542), 1,
      anon_sym_COLON,
    STATE(961), 1,
      sym_set_in,
    STATE(4290), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [35804] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7544), 1,
      anon_sym_DQUOTE2,
    STATE(4291), 1,
      sym_block_comment,
    STATE(4318), 1,
      aux_sym_string_repeat1,
  [35826] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7548), 1,
      anon_sym_SEMI,
    STATE(4292), 1,
      sym_block_comment,
    ACTIONS(7546), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [35844] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7550), 1,
      anon_sym_DQUOTE2,
    STATE(4293), 1,
      sym_block_comment,
    STATE(4323), 1,
      aux_sym_string_repeat1,
  [35866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4294), 1,
      sym_block_comment,
    ACTIONS(7552), 4,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_or,
  [35882] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7554), 1,
      anon_sym_COLON,
    STATE(933), 1,
      sym_set_in,
    STATE(4295), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [35902] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7558), 1,
      anon_sym_SEMI,
    STATE(4296), 1,
      sym_block_comment,
    ACTIONS(7556), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [35920] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(47), 1,
      sym_gets,
    STATE(4297), 1,
      sym_block_comment,
    ACTIONS(7456), 3,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
  [35938] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(708), 1,
      sym_case_arrow,
    STATE(4298), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [35956] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9), 1,
      anon_sym_DASH_DASH_DASH_DASH,
    STATE(4175), 1,
      aux_sym_source_file_repeat1,
    STATE(4299), 1,
      sym_block_comment,
    STATE(4679), 1,
      sym_module,
    STATE(5402), 1,
      sym_single_line,
  [35978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4300), 1,
      sym_block_comment,
    ACTIONS(7560), 4,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_or,
  [35994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(920), 1,
      sym_case_arrow,
    STATE(4301), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [36012] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7564), 1,
      anon_sym_EQ,
    STATE(4302), 1,
      sym_block_comment,
    ACTIONS(7562), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [36030] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7566), 1,
      sym__begin_proof_step,
    STATE(4303), 1,
      sym_block_comment,
    STATE(4349), 1,
      aux_sym_non_terminal_proof_repeat1,
    STATE(5357), 1,
      sym_proof_step,
    STATE(5443), 1,
      sym_qed_step,
  [36052] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(770), 1,
      sym_all_map_to,
    STATE(4304), 1,
      sym_block_comment,
    ACTIONS(5970), 3,
      anon_sym_PIPE_DASH_GT,
      anon_sym_u27fc,
      anon_sym_u21a6,
  [36070] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7568), 1,
      sym__dedent,
    STATE(4305), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [36092] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7570), 1,
      anon_sym_COLON,
    STATE(322), 1,
      sym_set_in,
    STATE(4306), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [36112] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7572), 1,
      sym__dedent,
    STATE(4307), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [36134] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7574), 1,
      anon_sym_EQ,
    STATE(775), 1,
      sym_set_in,
    STATE(4308), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [36154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4309), 1,
      sym_block_comment,
    ACTIONS(7576), 4,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [36170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4310), 1,
      sym_block_comment,
    ACTIONS(7578), 4,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
      sym_identifier,
  [36186] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7566), 1,
      sym__begin_proof_step,
    STATE(4311), 1,
      sym_block_comment,
    STATE(4741), 1,
      aux_sym_non_terminal_proof_repeat1,
    STATE(5119), 1,
      sym_qed_step,
    STATE(5357), 1,
      sym_proof_step,
  [36208] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(486), 1,
      sym_case_arrow,
    STATE(4312), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [36226] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7580), 1,
      sym__dedent,
    STATE(4313), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [36248] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7466), 1,
      sym__begin_proof_step,
    STATE(3589), 1,
      sym_qed_step,
    STATE(4249), 1,
      aux_sym_non_terminal_proof_repeat1,
    STATE(4314), 1,
      sym_block_comment,
    STATE(5357), 1,
      sym_proof_step,
  [36270] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7582), 1,
      anon_sym_DQUOTE2,
    STATE(4315), 1,
      sym_block_comment,
    STATE(4318), 1,
      aux_sym_string_repeat1,
  [36292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7584), 1,
      anon_sym_COLON,
    STATE(902), 1,
      sym_set_in,
    STATE(4316), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [36312] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7586), 1,
      anon_sym_BY,
    ACTIONS(7588), 1,
      sym__begin_proof,
    STATE(4317), 1,
      sym_block_comment,
    ACTIONS(7474), 2,
      anon_sym_OBVIOUS,
      anon_sym_OMITTED,
  [36332] = 6,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7590), 1,
      aux_sym_string_token1,
    ACTIONS(7593), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7595), 1,
      sym_escape_char,
    STATE(4318), 2,
      sym_block_comment,
      aux_sym_string_repeat1,
  [36352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7598), 1,
      anon_sym_LPAREN,
    STATE(781), 1,
      sym_def_eq,
    STATE(4319), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [36372] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7600), 1,
      sym__dedent,
    STATE(4320), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [36394] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(67), 1,
      sym_gets,
    STATE(4321), 1,
      sym_block_comment,
    ACTIONS(7456), 3,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
  [36412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(568), 1,
      sym_case_arrow,
    STATE(4322), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [36430] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7602), 1,
      anon_sym_DQUOTE2,
    STATE(4318), 1,
      aux_sym_string_repeat1,
    STATE(4323), 1,
      sym_block_comment,
  [36452] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7604), 1,
      sym__dedent,
    STATE(4324), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [36474] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7606), 1,
      anon_sym_COLON,
    STATE(872), 1,
      sym_set_in,
    STATE(4325), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [36494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7608), 1,
      sym__dedent,
    STATE(4326), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [36516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4327), 1,
      sym_block_comment,
    ACTIONS(7610), 4,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
      anon_sym_begin,
  [36532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(351), 1,
      sym_case_arrow,
    STATE(4328), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [36550] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7612), 1,
      anon_sym_DQUOTE2,
    STATE(4329), 1,
      sym_block_comment,
    STATE(4335), 1,
      aux_sym_string_repeat1,
  [36572] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7614), 1,
      sym__dedent,
    STATE(4330), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [36594] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7616), 1,
      sym__dedent,
    STATE(4331), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [36616] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(48), 1,
      sym_gets,
    STATE(4332), 1,
      sym_block_comment,
    ACTIONS(7456), 3,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
  [36634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4333), 1,
      sym_block_comment,
    ACTIONS(7618), 4,
      anon_sym_LBRACE,
      anon_sym_procedure,
      anon_sym_fair,
      anon_sym_process,
  [36650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(49), 1,
      sym_gets,
    STATE(4334), 1,
      sym_block_comment,
    ACTIONS(7456), 3,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
  [36668] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7620), 1,
      anon_sym_DQUOTE2,
    STATE(4318), 1,
      aux_sym_string_repeat1,
    STATE(4335), 1,
      sym_block_comment,
  [36690] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7622), 1,
      sym__dedent,
    STATE(4336), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [36712] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6043), 1,
      anon_sym_LPAREN,
    STATE(751), 1,
      sym_def_eq,
    STATE(4337), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [36732] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7626), 1,
      anon_sym_SEMI,
    STATE(4338), 1,
      sym_block_comment,
    ACTIONS(7624), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [36750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7630), 1,
      anon_sym_SEMI,
    STATE(4339), 1,
      sym_block_comment,
    ACTIONS(7628), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [36768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7634), 1,
      anon_sym_SEMI,
    STATE(4340), 1,
      sym_block_comment,
    ACTIONS(7632), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [36786] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7636), 1,
      anon_sym_DQUOTE2,
    STATE(4318), 1,
      aux_sym_string_repeat1,
    STATE(4341), 1,
      sym_block_comment,
  [36808] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7638), 1,
      anon_sym_COLON,
    STATE(829), 1,
      sym_set_in,
    STATE(4342), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [36828] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7640), 1,
      anon_sym_DQUOTE2,
    STATE(4343), 1,
      sym_block_comment,
    STATE(4388), 1,
      aux_sym_string_repeat1,
  [36850] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(597), 1,
      sym_case_arrow,
    STATE(4344), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [36868] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7642), 1,
      anon_sym_EQ,
    STATE(690), 1,
      sym_set_in,
    STATE(4345), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [36888] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(408), 1,
      sym_case_arrow,
    STATE(4346), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [36906] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7644), 1,
      anon_sym_DQUOTE2,
    STATE(4347), 1,
      sym_block_comment,
    STATE(4393), 1,
      aux_sym_string_repeat1,
  [36928] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7646), 1,
      anon_sym_DQUOTE2,
    STATE(4348), 1,
      sym_block_comment,
    STATE(4358), 1,
      aux_sym_string_repeat1,
  [36950] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7566), 1,
      sym__begin_proof_step,
    STATE(4349), 1,
      sym_block_comment,
    STATE(4741), 1,
      aux_sym_non_terminal_proof_repeat1,
    STATE(5357), 1,
      sym_proof_step,
    STATE(5541), 1,
      sym_qed_step,
  [36972] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7466), 1,
      sym__begin_proof_step,
    STATE(3593), 1,
      sym_qed_step,
    STATE(4350), 1,
      sym_block_comment,
    STATE(4741), 1,
      aux_sym_non_terminal_proof_repeat1,
    STATE(5357), 1,
      sym_proof_step,
  [36994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7648), 1,
      anon_sym_EQ,
    STATE(765), 1,
      sym_set_in,
    STATE(4351), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [37014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7652), 1,
      anon_sym_elsif,
    ACTIONS(7650), 2,
      anon_sym_end,
      anon_sym_else,
    STATE(4352), 2,
      sym_block_comment,
      aux_sym_pcal_p_if_repeat1,
  [37032] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7655), 1,
      sym__dedent,
    STATE(4353), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [37054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7657), 1,
      anon_sym_EQ,
    STATE(777), 1,
      sym_set_in,
    STATE(4354), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [37074] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7659), 1,
      anon_sym_DQUOTE2,
    STATE(4240), 1,
      aux_sym_string_repeat1,
    STATE(4355), 1,
      sym_block_comment,
  [37096] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7661), 1,
      sym__dedent,
    STATE(4356), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [37118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4357), 1,
      sym_block_comment,
    ACTIONS(7663), 4,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [37134] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7665), 1,
      anon_sym_DQUOTE2,
    STATE(4318), 1,
      aux_sym_string_repeat1,
    STATE(4358), 1,
      sym_block_comment,
  [37156] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7667), 1,
      anon_sym_COLON,
    STATE(991), 1,
      sym_set_in,
    STATE(4359), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [37176] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7669), 1,
      anon_sym_LPAREN,
    STATE(733), 1,
      sym_def_eq,
    STATE(4360), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [37196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(513), 1,
      sym_case_arrow,
    STATE(4361), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [37214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4362), 1,
      sym_block_comment,
    ACTIONS(7671), 4,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_or,
  [37230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4363), 1,
      sym_block_comment,
    ACTIONS(7673), 4,
      anon_sym_LT_LT,
      anon_sym_u3008,
      anon_sym_u27e8,
      sym_identifier,
  [37246] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7675), 1,
      sym__dedent,
    STATE(4364), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [37268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(626), 1,
      sym_case_arrow,
    STATE(4365), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [37286] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7677), 1,
      sym__dedent,
    STATE(4366), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [37308] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7679), 1,
      sym__dedent,
    STATE(4367), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [37330] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7681), 1,
      anon_sym_DQUOTE2,
    STATE(4368), 1,
      sym_block_comment,
    STATE(4384), 1,
      aux_sym_string_repeat1,
  [37352] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7683), 1,
      sym__dedent,
    STATE(4369), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [37374] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7685), 1,
      sym__dedent,
    STATE(4370), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [37396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(55), 1,
      sym_gets,
    STATE(4371), 1,
      sym_block_comment,
    ACTIONS(7456), 3,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
  [37414] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7687), 1,
      sym__dedent,
    STATE(4372), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [37436] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7689), 1,
      sym__dedent,
    STATE(4373), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [37458] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(668), 1,
      anon_sym_DEF,
    ACTIONS(6338), 1,
      sym__begin_proof_step,
    ACTIONS(7691), 1,
      anon_sym_DEFS,
    STATE(4374), 1,
      sym_block_comment,
    STATE(5323), 1,
      sym_use_body_def,
  [37480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4375), 1,
      sym_block_comment,
    ACTIONS(7693), 4,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_or,
  [37496] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7695), 1,
      sym__dedent,
    STATE(4376), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [37518] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7697), 1,
      sym__dedent,
    STATE(4377), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [37540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(460), 1,
      sym_case_arrow,
    STATE(4378), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [37558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4379), 1,
      sym_block_comment,
    ACTIONS(7699), 4,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_or,
  [37574] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    STATE(4380), 1,
      sym_block_comment,
    ACTIONS(6248), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37594] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7703), 1,
      anon_sym_COLON,
    STATE(888), 1,
      sym_set_in,
    STATE(4381), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [37614] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7705), 1,
      anon_sym_LPAREN,
    STATE(488), 1,
      sym_def_eq,
    STATE(4382), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [37634] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7566), 1,
      sym__begin_proof_step,
    STATE(4311), 1,
      aux_sym_non_terminal_proof_repeat1,
    STATE(4383), 1,
      sym_block_comment,
    STATE(5357), 1,
      sym_proof_step,
    STATE(5541), 1,
      sym_qed_step,
  [37656] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7707), 1,
      anon_sym_DQUOTE2,
    STATE(4318), 1,
      aux_sym_string_repeat1,
    STATE(4384), 1,
      sym_block_comment,
  [37678] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7709), 1,
      anon_sym_COLON,
    STATE(1006), 1,
      sym_set_in,
    STATE(4385), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [37698] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7711), 1,
      anon_sym_DQUOTE2,
    STATE(4241), 1,
      aux_sym_string_repeat1,
    STATE(4386), 1,
      sym_block_comment,
  [37720] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7713), 1,
      anon_sym_DQUOTE2,
    STATE(4248), 1,
      aux_sym_string_repeat1,
    STATE(4387), 1,
      sym_block_comment,
  [37742] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7715), 1,
      anon_sym_DQUOTE2,
    STATE(4318), 1,
      aux_sym_string_repeat1,
    STATE(4388), 1,
      sym_block_comment,
  [37764] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7717), 1,
      anon_sym_DQUOTE2,
    STATE(4291), 1,
      aux_sym_string_repeat1,
    STATE(4389), 1,
      sym_block_comment,
  [37786] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(654), 1,
      sym_case_arrow,
    STATE(4390), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [37804] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7719), 1,
      anon_sym_DQUOTE2,
    STATE(4391), 1,
      sym_block_comment,
    STATE(4402), 1,
      aux_sym_string_repeat1,
  [37826] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(56), 1,
      sym_gets,
    STATE(4392), 1,
      sym_block_comment,
    ACTIONS(7456), 3,
      anon_sym_LT_DASH,
      anon_sym_u27f5,
      anon_sym_u2190,
  [37844] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7721), 1,
      anon_sym_DQUOTE2,
    STATE(4318), 1,
      aux_sym_string_repeat1,
    STATE(4393), 1,
      sym_block_comment,
  [37866] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7723), 1,
      anon_sym_DQUOTE2,
    STATE(4394), 1,
      sym_block_comment,
    STATE(4408), 1,
      aux_sym_string_repeat1,
  [37888] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7725), 1,
      anon_sym_COLON,
    STATE(815), 1,
      sym_set_in,
    STATE(4395), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [37908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4396), 1,
      sym_block_comment,
    ACTIONS(7409), 4,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [37924] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7727), 1,
      sym__dedent,
    STATE(4397), 1,
      sym_block_comment,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4967), 1,
      sym_conj_item,
  [37946] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7729), 1,
      sym__dedent,
    STATE(4398), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [37968] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6284), 1,
      anon_sym_DEF,
    STATE(4399), 1,
      sym_block_comment,
    ACTIONS(6282), 3,
      sym__begin_proof_step,
      anon_sym_COMMA,
      anon_sym_DEFS,
  [37986] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7731), 1,
      sym__bullet,
    ACTIONS(7734), 1,
      sym__dedent,
    STATE(4967), 1,
      sym_conj_item,
    STATE(4400), 2,
      sym_block_comment,
      aux_sym_conj_list_repeat1,
  [38006] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7736), 1,
      anon_sym_COLON,
    STATE(858), 1,
      sym_set_in,
    STATE(4401), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [38026] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7738), 1,
      anon_sym_DQUOTE2,
    STATE(4318), 1,
      aux_sym_string_repeat1,
    STATE(4402), 1,
      sym_block_comment,
  [38048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7494), 1,
      anon_sym_elsif,
    ACTIONS(7740), 1,
      anon_sym_end,
    ACTIONS(7742), 1,
      anon_sym_else,
    STATE(4352), 1,
      aux_sym_pcal_p_if_repeat1,
    STATE(4403), 1,
      sym_block_comment,
  [38070] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7744), 1,
      sym__dedent,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4404), 1,
      sym_block_comment,
    STATE(4967), 1,
      sym_conj_item,
  [38092] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7746), 1,
      sym__dedent,
    STATE(4405), 1,
      sym_block_comment,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(5029), 1,
      sym_disj_item,
  [38114] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7748), 1,
      anon_sym_LPAREN,
    STATE(709), 1,
      sym_def_eq,
    STATE(4406), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [38134] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7750), 1,
      sym__bullet,
    ACTIONS(7753), 1,
      sym__dedent,
    STATE(5029), 1,
      sym_disj_item,
    STATE(4407), 2,
      sym_block_comment,
      aux_sym_disj_list_repeat1,
  [38154] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7755), 1,
      anon_sym_DQUOTE2,
    STATE(4318), 1,
      aux_sym_string_repeat1,
    STATE(4408), 1,
      sym_block_comment,
  [38176] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7757), 1,
      anon_sym_COLON,
    STATE(918), 1,
      sym_set_in,
    STATE(4409), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [38196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(7759), 1,
      anon_sym_LPAREN,
    STATE(4410), 1,
      sym_block_comment,
    ACTIONS(6248), 2,
      sym__begin_proof_step,
      anon_sym_COMMA,
  [38216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(7761), 1,
      anon_sym_LPAREN,
    STATE(4411), 1,
      sym_block_comment,
    ACTIONS(6248), 2,
      sym__begin_proof_step,
      anon_sym_COMMA,
  [38236] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7763), 1,
      anon_sym_COLON,
    STATE(1022), 1,
      sym_set_in,
    STATE(4412), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [38256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4413), 1,
      sym_block_comment,
    ACTIONS(7765), 4,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_or,
  [38272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7769), 1,
      anon_sym_SEMI,
    STATE(4414), 1,
      sym_block_comment,
    ACTIONS(7767), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [38290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4415), 1,
      sym_block_comment,
    ACTIONS(7765), 4,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_or,
  [38306] = 7,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7442), 1,
      aux_sym_string_token1,
    ACTIONS(7446), 1,
      sym_escape_char,
    ACTIONS(7771), 1,
      anon_sym_DQUOTE2,
    STATE(4341), 1,
      aux_sym_string_repeat1,
    STATE(4416), 1,
      sym_block_comment,
  [38328] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7775), 1,
      anon_sym_SEMI,
    STATE(4417), 1,
      sym_block_comment,
    ACTIONS(7773), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [38346] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7777), 1,
      sym__dedent,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4418), 1,
      sym_block_comment,
    STATE(4967), 1,
      sym_conj_item,
  [38368] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 1,
      sym__bullet,
    ACTIONS(7779), 1,
      sym__dedent,
    STATE(4400), 1,
      aux_sym_conj_list_repeat1,
    STATE(4419), 1,
      sym_block_comment,
    STATE(4967), 1,
      sym_conj_item,
  [38390] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7452), 1,
      sym__bullet,
    ACTIONS(7781), 1,
      sym__dedent,
    STATE(4407), 1,
      aux_sym_disj_list_repeat1,
    STATE(4420), 1,
      sym_block_comment,
    STATE(5029), 1,
      sym_disj_item,
  [38412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(680), 1,
      sym_case_arrow,
    STATE(4421), 1,
      sym_block_comment,
    ACTIONS(4080), 3,
      anon_sym_DASH_GT,
      anon_sym_u27f6,
      anon_sym_u2192,
  [38430] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7783), 1,
      anon_sym_COLON,
    STATE(976), 1,
      sym_set_in,
    STATE(4422), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [38450] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(7785), 1,
      aux_sym_octal_number_token1,
    STATE(4423), 1,
      sym_block_comment,
  [38469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4424), 1,
      sym_block_comment,
    ACTIONS(7787), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [38484] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(782), 1,
      sym_def_eq,
    STATE(4425), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [38501] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(7791), 1,
      anon_sym_RBRACK,
    STATE(4426), 1,
      sym_block_comment,
    STATE(4942), 1,
      aux_sym_except_repeat1,
  [38520] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7795), 1,
      anon_sym_RBRACE,
    STATE(4427), 1,
      sym_block_comment,
    STATE(4465), 1,
      aux_sym_function_definition_repeat1,
  [38539] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7797), 1,
      anon_sym_COLON,
    STATE(4428), 1,
      sym_block_comment,
    STATE(4434), 1,
      aux_sym_function_definition_repeat1,
  [38558] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7198), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4429), 1,
      sym_block_comment,
  [38577] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7801), 1,
      anon_sym_RPAREN,
    STATE(4430), 1,
      sym_block_comment,
    STATE(4439), 1,
      aux_sym_bound_op_repeat1,
  [38596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4431), 1,
      sym_block_comment,
    ACTIONS(7546), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [38611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7803), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4432), 1,
      sym_block_comment,
  [38630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4433), 1,
      sym_block_comment,
    ACTIONS(7805), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [38645] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7807), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4434), 1,
      sym_block_comment,
  [38664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4435), 1,
      sym_block_comment,
    ACTIONS(7809), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [38679] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7811), 1,
      anon_sym_RPAREN,
    STATE(4436), 1,
      sym_block_comment,
    STATE(4445), 1,
      aux_sym_bound_op_repeat1,
  [38698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4437), 1,
      sym_block_comment,
    ACTIONS(7813), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [38713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(565), 1,
      sym_label_as,
    STATE(4438), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [38730] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7815), 1,
      anon_sym_RPAREN,
    STATE(4439), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [38749] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7817), 1,
      anon_sym_RPAREN,
    STATE(4440), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [38768] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(7819), 1,
      anon_sym_RBRACK,
    STATE(4441), 1,
      sym_block_comment,
    STATE(4450), 1,
      aux_sym_except_repeat1,
  [38787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7821), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4442), 1,
      sym_block_comment,
  [38806] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7823), 1,
      anon_sym_RBRACE,
    STATE(4443), 1,
      sym_block_comment,
    STATE(4452), 1,
      aux_sym_function_definition_repeat1,
  [38825] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7825), 1,
      anon_sym_RPAREN,
    STATE(4444), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [38844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7827), 1,
      anon_sym_RPAREN,
    STATE(4445), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [38863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7829), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4446), 1,
      sym_block_comment,
  [38882] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(569), 1,
      sym_label_as,
    STATE(4447), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [38899] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(7831), 1,
      anon_sym_RBRACK,
    STATE(4448), 1,
      sym_block_comment,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
  [38918] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(7833), 1,
      anon_sym_RBRACK,
    STATE(4449), 1,
      sym_block_comment,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
  [38937] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(7835), 1,
      anon_sym_RBRACK,
    STATE(4450), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [38956] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7837), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4451), 1,
      sym_block_comment,
  [38975] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7839), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4452), 1,
      sym_block_comment,
  [38994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(7841), 1,
      aux_sym_octal_number_token1,
    STATE(4453), 1,
      sym_block_comment,
  [39013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7843), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4454), 1,
      sym_block_comment,
  [39032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(742), 1,
      sym_def_eq,
    STATE(4455), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [39049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7220), 1,
      anon_sym_COLON,
    STATE(4456), 1,
      sym_block_comment,
    STATE(4462), 1,
      aux_sym_variable_declaration_repeat1,
  [39068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(352), 1,
      sym_label_as,
    STATE(4457), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [39085] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(7845), 1,
      anon_sym_RBRACK,
    STATE(4458), 1,
      sym_block_comment,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
  [39104] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(7847), 1,
      anon_sym_RBRACK,
    STATE(4459), 1,
      sym_block_comment,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
  [39123] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7196), 1,
      anon_sym_COLON,
    STATE(4429), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4460), 1,
      sym_block_comment,
  [39142] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7849), 1,
      anon_sym_COLON,
    STATE(4461), 1,
      sym_block_comment,
    STATE(4466), 1,
      aux_sym_function_definition_repeat1,
  [39161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7224), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4462), 1,
      sym_block_comment,
  [39180] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7851), 1,
      anon_sym_RPAREN,
    STATE(4463), 1,
      sym_block_comment,
    STATE(4469), 1,
      aux_sym_bound_op_repeat1,
  [39199] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7853), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4464), 1,
      sym_block_comment,
  [39218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7855), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4465), 1,
      sym_block_comment,
  [39237] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7857), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4466), 1,
      sym_block_comment,
  [39256] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7859), 1,
      anon_sym_RPAREN,
    STATE(4467), 1,
      sym_block_comment,
    STATE(4472), 1,
      aux_sym_bound_op_repeat1,
  [39275] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(594), 1,
      sym_label_as,
    STATE(4468), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [39292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7861), 1,
      anon_sym_RPAREN,
    STATE(4469), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [39311] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(7863), 1,
      anon_sym_RBRACK,
    STATE(4470), 1,
      sym_block_comment,
    STATE(4477), 1,
      aux_sym_except_repeat1,
  [39330] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7865), 1,
      anon_sym_RBRACE,
    STATE(4471), 1,
      sym_block_comment,
    STATE(4478), 1,
      aux_sym_function_definition_repeat1,
  [39349] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7867), 1,
      anon_sym_RPAREN,
    STATE(4472), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [39368] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7869), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4473), 1,
      sym_block_comment,
  [39387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(598), 1,
      sym_label_as,
    STATE(4474), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [39404] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(7871), 1,
      anon_sym_RBRACK,
    STATE(4475), 1,
      sym_block_comment,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
  [39423] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(7873), 1,
      anon_sym_RBRACK,
    STATE(4476), 1,
      sym_block_comment,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
  [39442] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(7875), 1,
      anon_sym_RBRACK,
    STATE(4477), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [39461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7877), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4478), 1,
      sym_block_comment,
  [39480] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(7879), 1,
      aux_sym_octal_number_token1,
    STATE(4479), 1,
      sym_block_comment,
  [39499] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7881), 1,
      anon_sym_COMMA,
    ACTIONS(7884), 1,
      anon_sym_RPAREN,
    STATE(4480), 2,
      sym_block_comment,
      aux_sym_pcal_macro_decl_repeat1,
  [39516] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7226), 1,
      anon_sym_COLON,
    STATE(4481), 1,
      sym_block_comment,
    STATE(4483), 1,
      aux_sym_variable_declaration_repeat1,
  [39535] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 1,
      anon_sym_COLON,
    STATE(4482), 1,
      sym_block_comment,
    STATE(4486), 1,
      aux_sym_function_definition_repeat1,
  [39554] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7228), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4483), 1,
      sym_block_comment,
  [39573] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7888), 1,
      anon_sym_RPAREN,
    STATE(4484), 1,
      sym_block_comment,
    STATE(4489), 1,
      aux_sym_bound_op_repeat1,
  [39592] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7890), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4485), 1,
      sym_block_comment,
  [39611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7892), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4486), 1,
      sym_block_comment,
  [39630] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7894), 1,
      anon_sym_RPAREN,
    STATE(4487), 1,
      sym_block_comment,
    STATE(4493), 1,
      aux_sym_bound_op_repeat1,
  [39649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(623), 1,
      sym_label_as,
    STATE(4488), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [39666] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7896), 1,
      anon_sym_RPAREN,
    STATE(4489), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [39685] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(7898), 1,
      anon_sym_RBRACK,
    STATE(4490), 1,
      sym_block_comment,
    STATE(4498), 1,
      aux_sym_except_repeat1,
  [39704] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7900), 1,
      anon_sym_RBRACE,
    STATE(4491), 1,
      sym_block_comment,
    STATE(4499), 1,
      aux_sym_function_definition_repeat1,
  [39723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7902), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4492), 1,
      sym_block_comment,
  [39742] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7904), 1,
      anon_sym_RPAREN,
    STATE(4493), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [39761] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7906), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4494), 1,
      sym_block_comment,
  [39780] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(627), 1,
      sym_label_as,
    STATE(4495), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [39797] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(7908), 1,
      anon_sym_RBRACK,
    STATE(4496), 1,
      sym_block_comment,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
  [39816] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(7910), 1,
      anon_sym_RBRACK,
    STATE(4497), 1,
      sym_block_comment,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
  [39835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(7912), 1,
      anon_sym_RBRACK,
    STATE(4498), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [39854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7914), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4499), 1,
      sym_block_comment,
  [39873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(7289), 1,
      aux_sym_octal_number_token1,
    STATE(4500), 1,
      sym_block_comment,
  [39892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7916), 1,
      anon_sym_COMMA,
    ACTIONS(7919), 1,
      anon_sym_RPAREN,
    STATE(4501), 2,
      sym_block_comment,
      aux_sym_pcal_proc_decl_repeat1,
  [39909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7234), 1,
      anon_sym_COLON,
    STATE(4502), 1,
      sym_block_comment,
    STATE(4504), 1,
      aux_sym_variable_declaration_repeat1,
  [39928] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7921), 1,
      anon_sym_COLON,
    STATE(4503), 1,
      sym_block_comment,
    STATE(4508), 1,
      aux_sym_function_definition_repeat1,
  [39947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7242), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4504), 1,
      sym_block_comment,
  [39966] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7923), 1,
      anon_sym_RPAREN,
    STATE(4505), 1,
      sym_block_comment,
    STATE(4511), 1,
      aux_sym_bound_op_repeat1,
  [39985] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7925), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4506), 1,
      sym_block_comment,
  [40004] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(752), 1,
      sym_def_eq,
    STATE(4507), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [40021] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7927), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4508), 1,
      sym_block_comment,
  [40040] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7929), 1,
      anon_sym_RPAREN,
    STATE(4509), 1,
      sym_block_comment,
    STATE(4514), 1,
      aux_sym_bound_op_repeat1,
  [40059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(651), 1,
      sym_label_as,
    STATE(4510), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [40076] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7931), 1,
      anon_sym_RPAREN,
    STATE(4511), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [40095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(7933), 1,
      anon_sym_RBRACK,
    STATE(4512), 1,
      sym_block_comment,
    STATE(4519), 1,
      aux_sym_except_repeat1,
  [40114] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7935), 1,
      anon_sym_RBRACE,
    STATE(4513), 1,
      sym_block_comment,
    STATE(4520), 1,
      aux_sym_function_definition_repeat1,
  [40133] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7937), 1,
      anon_sym_RPAREN,
    STATE(4514), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [40152] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7939), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4515), 1,
      sym_block_comment,
  [40171] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(655), 1,
      sym_label_as,
    STATE(4516), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [40188] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(7941), 1,
      anon_sym_RBRACK,
    STATE(4517), 1,
      sym_block_comment,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
  [40207] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(7943), 1,
      anon_sym_RBRACK,
    STATE(4518), 1,
      sym_block_comment,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
  [40226] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(7945), 1,
      anon_sym_RBRACK,
    STATE(4519), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [40245] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7947), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4520), 1,
      sym_block_comment,
  [40264] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(7949), 1,
      aux_sym_octal_number_token1,
    STATE(4521), 1,
      sym_block_comment,
  [40283] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(7951), 1,
      aux_sym_octal_number_token1,
    STATE(4522), 1,
      sym_block_comment,
  [40302] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7096), 1,
      anon_sym_COLON,
    STATE(4523), 1,
      sym_block_comment,
    STATE(4528), 1,
      aux_sym_variable_declaration_repeat1,
  [40321] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6412), 1,
      sym__begin_proof_step,
    ACTIONS(7953), 1,
      anon_sym_COMMA,
    STATE(4524), 1,
      sym_block_comment,
    STATE(4703), 1,
      aux_sym_instance_repeat1,
  [40340] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6398), 1,
      sym__begin_proof_step,
    ACTIONS(7955), 1,
      anon_sym_COMMA,
    STATE(4525), 1,
      sym_block_comment,
    STATE(4690), 1,
      aux_sym_use_body_def_repeat1,
  [40359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(935), 1,
      sym_def_eq,
    STATE(4526), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [40376] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7957), 1,
      anon_sym_COLON,
    STATE(4527), 1,
      sym_block_comment,
    STATE(4531), 1,
      aux_sym_function_definition_repeat1,
  [40395] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7102), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4528), 1,
      sym_block_comment,
  [40414] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7959), 1,
      anon_sym_RPAREN,
    STATE(4529), 1,
      sym_block_comment,
    STATE(4534), 1,
      aux_sym_bound_op_repeat1,
  [40433] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7961), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4530), 1,
      sym_block_comment,
  [40452] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7963), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4531), 1,
      sym_block_comment,
  [40471] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7965), 1,
      anon_sym_RPAREN,
    STATE(4532), 1,
      sym_block_comment,
    STATE(4540), 1,
      aux_sym_bound_op_repeat1,
  [40490] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(677), 1,
      sym_label_as,
    STATE(4533), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [40507] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7967), 1,
      anon_sym_RPAREN,
    STATE(4534), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [40526] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(7969), 1,
      anon_sym_RBRACK,
    STATE(4535), 1,
      sym_block_comment,
    STATE(4545), 1,
      aux_sym_except_repeat1,
  [40545] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7971), 1,
      anon_sym_RBRACE,
    STATE(4536), 1,
      sym_block_comment,
    STATE(4547), 1,
      aux_sym_function_definition_repeat1,
  [40564] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4665), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_PROVE,
    STATE(4537), 1,
      sym_block_comment,
    STATE(4739), 1,
      aux_sym_assume_prove_repeat1,
  [40583] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(753), 1,
      sym_def_eq,
    STATE(4538), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [40600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(754), 1,
      sym_def_eq,
    STATE(4539), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [40617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7975), 1,
      anon_sym_RPAREN,
    STATE(4540), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [40636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7977), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4541), 1,
      sym_block_comment,
  [40655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(681), 1,
      sym_label_as,
    STATE(4542), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [40672] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(7979), 1,
      anon_sym_RBRACK,
    STATE(4543), 1,
      sym_block_comment,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
  [40691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(7981), 1,
      anon_sym_RBRACK,
    STATE(4544), 1,
      sym_block_comment,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
  [40710] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(7983), 1,
      anon_sym_RBRACK,
    STATE(4545), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [40729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5906), 1,
      anon_sym_LPAREN,
    STATE(4546), 1,
      sym_block_comment,
    ACTIONS(5904), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [40746] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7985), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4547), 1,
      sym_block_comment,
  [40765] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7222), 1,
      anon_sym_COLON,
    STATE(4548), 1,
      sym_block_comment,
    STATE(4570), 1,
      aux_sym_variable_declaration_repeat1,
  [40784] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(941), 1,
      sym_label_as,
    STATE(4549), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [40801] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(7987), 1,
      anon_sym_RBRACK,
    STATE(4550), 1,
      sym_block_comment,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
  [40820] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(7989), 1,
      anon_sym_RBRACK,
    STATE(4551), 1,
      sym_block_comment,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
  [40839] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7991), 1,
      anon_sym_RPAREN,
    STATE(4552), 1,
      sym_block_comment,
    STATE(4556), 1,
      aux_sym_bound_op_repeat1,
  [40858] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(7993), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4553), 1,
      sym_block_comment,
  [40877] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7995), 1,
      anon_sym_RPAREN,
    STATE(4554), 1,
      sym_block_comment,
    STATE(4560), 1,
      aux_sym_bound_op_repeat1,
  [40896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(7997), 1,
      anon_sym_RBRACK,
    STATE(4555), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [40915] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7999), 1,
      anon_sym_RPAREN,
    STATE(4556), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [40934] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8001), 1,
      anon_sym_RBRACK,
    STATE(4557), 1,
      sym_block_comment,
    STATE(4563), 1,
      aux_sym_except_repeat1,
  [40953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8003), 1,
      anon_sym_RBRACE,
    STATE(4558), 1,
      sym_block_comment,
    STATE(4564), 1,
      aux_sym_function_definition_repeat1,
  [40972] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(8005), 1,
      anon_sym_COLON,
    STATE(4559), 1,
      sym_block_comment,
    STATE(4745), 1,
      aux_sym_variable_declaration_repeat1,
  [40991] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8007), 1,
      anon_sym_RPAREN,
    STATE(4560), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [41010] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(8009), 1,
      anon_sym_RBRACK,
    STATE(4561), 1,
      sym_block_comment,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
  [41029] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(8011), 1,
      anon_sym_RBRACK,
    STATE(4562), 1,
      sym_block_comment,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
  [41048] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8013), 1,
      anon_sym_RBRACK,
    STATE(4563), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [41067] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8015), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4564), 1,
      sym_block_comment,
  [41086] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8017), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4565), 1,
      sym_block_comment,
  [41105] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8019), 1,
      anon_sym_COLON,
    STATE(4566), 1,
      sym_block_comment,
    STATE(4583), 1,
      aux_sym_function_definition_repeat1,
  [41124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(195), 1,
      sym_def_eq,
    STATE(4567), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [41141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(755), 1,
      sym_def_eq,
    STATE(4568), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [41158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(874), 1,
      sym_def_eq,
    STATE(4569), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [41175] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7232), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4570), 1,
      sym_block_comment,
  [41194] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8021), 1,
      anon_sym_RPAREN,
    STATE(4571), 1,
      sym_block_comment,
    STATE(4582), 1,
      aux_sym_constant_declaration_repeat1,
  [41213] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8023), 1,
      anon_sym_RPAREN,
    STATE(4572), 1,
      sym_block_comment,
    STATE(4595), 1,
      aux_sym_bound_op_repeat1,
  [41232] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8025), 1,
      anon_sym_RBRACK,
    STATE(4573), 1,
      sym_block_comment,
    STATE(4584), 1,
      aux_sym_function_definition_repeat1,
  [41251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(699), 1,
      sym_set_in,
    STATE(4574), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [41268] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7152), 1,
      sym__begin_proof_step,
    ACTIONS(8027), 1,
      anon_sym_COMMA,
    STATE(4575), 1,
      sym_block_comment,
    STATE(4891), 1,
      aux_sym_function_definition_repeat1,
  [41287] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8029), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4576), 1,
      sym_block_comment,
  [41306] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(689), 1,
      sym_def_eq,
    STATE(4577), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [41323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8031), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(4578), 1,
      sym_block_comment,
  [41342] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7429), 1,
      anon_sym_RPAREN,
    ACTIONS(8033), 1,
      sym_identifier,
    ACTIONS(8035), 1,
      anon_sym_do,
    STATE(4579), 1,
      sym_block_comment,
  [41361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4665), 1,
      anon_sym_COMMA,
    ACTIONS(4667), 1,
      anon_sym_PROVE,
    STATE(4580), 1,
      sym_block_comment,
    STATE(4586), 1,
      aux_sym_assume_prove_repeat1,
  [41380] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8037), 1,
      anon_sym_RPAREN,
    STATE(4581), 1,
      sym_block_comment,
    STATE(4589), 1,
      aux_sym_constant_declaration_repeat1,
  [41399] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8039), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(4582), 1,
      sym_block_comment,
  [41418] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8041), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4583), 1,
      sym_block_comment,
  [41437] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8043), 1,
      anon_sym_RBRACK,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4584), 1,
      sym_block_comment,
  [41456] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8045), 1,
      anon_sym_RPAREN,
    STATE(4585), 1,
      sym_block_comment,
    STATE(4599), 1,
      aux_sym_bound_op_repeat1,
  [41475] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4665), 1,
      anon_sym_COMMA,
    ACTIONS(8047), 1,
      anon_sym_PROVE,
    STATE(4586), 1,
      sym_block_comment,
    STATE(4739), 1,
      aux_sym_assume_prove_repeat1,
  [41494] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(8049), 1,
      anon_sym_COLON,
    STATE(4587), 1,
      sym_block_comment,
    STATE(4604), 1,
      aux_sym_variable_declaration_repeat1,
  [41513] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(756), 1,
      sym_def_eq,
    STATE(4588), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [41530] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8051), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(4589), 1,
      sym_block_comment,
  [41549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(196), 1,
      sym_def_eq,
    STATE(4590), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [41566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(757), 1,
      sym_def_eq,
    STATE(4591), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [41583] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8053), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4592), 1,
      sym_block_comment,
  [41602] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8055), 1,
      anon_sym_RPAREN,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4593), 1,
      sym_block_comment,
  [41621] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(378), 1,
      sym_label_as,
    STATE(4594), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [41638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8057), 1,
      anon_sym_RPAREN,
    STATE(4595), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [41657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(776), 1,
      sym_assign,
    STATE(4596), 1,
      sym_block_comment,
    ACTIONS(2366), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [41674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8059), 1,
      anon_sym_RBRACK,
    STATE(4597), 1,
      sym_block_comment,
    STATE(4609), 1,
      aux_sym_except_repeat1,
  [41693] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8061), 1,
      anon_sym_RBRACE,
    STATE(4598), 1,
      sym_block_comment,
    STATE(4614), 1,
      aux_sym_function_definition_repeat1,
  [41712] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8063), 1,
      anon_sym_RPAREN,
    STATE(4599), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [41731] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8065), 1,
      anon_sym_RPAREN,
    STATE(4600), 1,
      sym_block_comment,
    STATE(4612), 1,
      aux_sym_constant_declaration_repeat1,
  [41750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8067), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4601), 1,
      sym_block_comment,
  [41769] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8069), 1,
      anon_sym_RBRACK,
    STATE(4602), 1,
      sym_block_comment,
    STATE(4613), 1,
      aux_sym_function_definition_repeat1,
  [41788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(725), 1,
      sym_set_in,
    STATE(4603), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [41805] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(8071), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4604), 1,
      sym_block_comment,
  [41824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(758), 1,
      sym_def_eq,
    STATE(4605), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [41841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(382), 1,
      sym_label_as,
    STATE(4606), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [41858] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(8073), 1,
      anon_sym_RBRACK,
    STATE(4607), 1,
      sym_block_comment,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
  [41877] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(8075), 1,
      anon_sym_RBRACK,
    STATE(4608), 1,
      sym_block_comment,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
  [41896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8077), 1,
      anon_sym_RBRACK,
    STATE(4609), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [41915] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4665), 1,
      anon_sym_COMMA,
    ACTIONS(4669), 1,
      anon_sym_PROVE,
    STATE(4610), 1,
      sym_block_comment,
    STATE(4619), 1,
      aux_sym_assume_prove_repeat1,
  [41934] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8079), 1,
      anon_sym_RPAREN,
    STATE(4611), 1,
      sym_block_comment,
    STATE(4620), 1,
      aux_sym_constant_declaration_repeat1,
  [41953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8081), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(4612), 1,
      sym_block_comment,
  [41972] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8083), 1,
      anon_sym_RBRACK,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4613), 1,
      sym_block_comment,
  [41991] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8085), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4614), 1,
      sym_block_comment,
  [42010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4615), 1,
      sym_block_comment,
    ACTIONS(8087), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [42025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4616), 1,
      sym_block_comment,
    ACTIONS(8089), 3,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ,
  [42040] = 5,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8091), 1,
      aux_sym_string_token1,
    STATE(4617), 1,
      sym_block_comment,
    ACTIONS(8093), 2,
      anon_sym_DQUOTE2,
      sym_escape_char,
  [42057] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(8095), 1,
      aux_sym_octal_number_token1,
    STATE(4618), 1,
      sym_block_comment,
  [42076] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4665), 1,
      anon_sym_COMMA,
    ACTIONS(8097), 1,
      anon_sym_PROVE,
    STATE(4619), 1,
      sym_block_comment,
    STATE(4739), 1,
      aux_sym_assume_prove_repeat1,
  [42095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8099), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(4620), 1,
      sym_block_comment,
  [42114] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8101), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4621), 1,
      sym_block_comment,
  [42133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(799), 1,
      sym_def_eq,
    STATE(4622), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [42150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(800), 1,
      sym_def_eq,
    STATE(4623), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [42167] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8103), 1,
      anon_sym_RPAREN,
    STATE(4624), 1,
      sym_block_comment,
    STATE(4629), 1,
      aux_sym_constant_declaration_repeat1,
  [42186] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_RBRACK,
    STATE(4625), 1,
      sym_block_comment,
    STATE(4630), 1,
      aux_sym_function_definition_repeat1,
  [42205] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7126), 1,
      anon_sym_COLON,
    STATE(4626), 1,
      sym_block_comment,
    STATE(4639), 1,
      aux_sym_variable_declaration_repeat1,
  [42224] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4665), 1,
      anon_sym_COMMA,
    ACTIONS(4671), 1,
      anon_sym_PROVE,
    STATE(4627), 1,
      sym_block_comment,
    STATE(4634), 1,
      aux_sym_assume_prove_repeat1,
  [42243] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8107), 1,
      anon_sym_RPAREN,
    STATE(4628), 1,
      sym_block_comment,
    STATE(4635), 1,
      aux_sym_constant_declaration_repeat1,
  [42262] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8109), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(4629), 1,
      sym_block_comment,
  [42281] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8111), 1,
      anon_sym_RBRACK,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4630), 1,
      sym_block_comment,
  [42300] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8113), 1,
      anon_sym_end,
    ACTIONS(8115), 1,
      anon_sym_or,
    STATE(4631), 1,
      sym_block_comment,
    STATE(4775), 1,
      aux_sym_pcal_p_either_repeat1,
  [42319] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8117), 1,
      anon_sym_COLON,
    STATE(4632), 1,
      sym_block_comment,
    STATE(4747), 1,
      aux_sym_function_definition_repeat1,
  [42338] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7124), 1,
      anon_sym_COLON,
    STATE(4633), 1,
      sym_block_comment,
    STATE(4725), 1,
      aux_sym_variable_declaration_repeat1,
  [42357] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4665), 1,
      anon_sym_COMMA,
    ACTIONS(8119), 1,
      anon_sym_PROVE,
    STATE(4634), 1,
      sym_block_comment,
    STATE(4739), 1,
      aux_sym_assume_prove_repeat1,
  [42376] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8121), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(4635), 1,
      sym_block_comment,
  [42395] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8123), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4636), 1,
      sym_block_comment,
  [42414] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(695), 1,
      sym_assign,
    STATE(4637), 1,
      sym_block_comment,
    ACTIONS(2366), 2,
      anon_sym_COLON_EQ,
      anon_sym_u2254,
  [42431] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8125), 1,
      anon_sym_COLON,
    STATE(4638), 1,
      sym_block_comment,
    STATE(4650), 1,
      aux_sym_function_definition_repeat1,
  [42450] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7132), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4639), 1,
      sym_block_comment,
  [42469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8127), 1,
      anon_sym_RPAREN,
    STATE(4640), 1,
      sym_block_comment,
    STATE(4646), 1,
      aux_sym_constant_declaration_repeat1,
  [42488] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8129), 1,
      anon_sym_RBRACK,
    STATE(4641), 1,
      sym_block_comment,
    STATE(4647), 1,
      aux_sym_function_definition_repeat1,
  [42507] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8131), 1,
      anon_sym_RPAREN,
    STATE(4642), 1,
      sym_block_comment,
    STATE(4656), 1,
      aux_sym_bound_op_repeat1,
  [42526] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7310), 1,
      anon_sym_LBRACE,
    STATE(4643), 1,
      sym_block_comment,
    ACTIONS(7312), 2,
      sym_identifier,
      anon_sym_begin,
  [42543] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8133), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4644), 1,
      sym_block_comment,
  [42562] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8135), 1,
      anon_sym_RPAREN,
    STATE(4645), 1,
      sym_block_comment,
    STATE(4652), 1,
      aux_sym_constant_declaration_repeat1,
  [42581] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8137), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(4646), 1,
      sym_block_comment,
  [42600] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8139), 1,
      anon_sym_RBRACK,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4647), 1,
      sym_block_comment,
  [42619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8141), 1,
      anon_sym_COMMA,
    ACTIONS(8144), 1,
      anon_sym_RBRACK,
    STATE(4648), 2,
      sym_block_comment,
      aux_sym_set_of_records_repeat1,
  [42636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6425), 1,
      sym__begin_proof_step,
    ACTIONS(7955), 1,
      anon_sym_COMMA,
    STATE(4525), 1,
      aux_sym_use_body_def_repeat1,
    STATE(4649), 1,
      sym_block_comment,
  [42655] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8146), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4650), 1,
      sym_block_comment,
  [42674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8148), 1,
      anon_sym_RPAREN,
    STATE(4651), 1,
      sym_block_comment,
    STATE(4666), 1,
      aux_sym_bound_op_repeat1,
  [42693] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8150), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(4652), 1,
      sym_block_comment,
  [42712] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8152), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4653), 1,
      sym_block_comment,
  [42731] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(8154), 1,
      anon_sym_COLON,
    STATE(4654), 1,
      sym_block_comment,
    STATE(4670), 1,
      aux_sym_variable_declaration_repeat1,
  [42750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(405), 1,
      sym_label_as,
    STATE(4655), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [42767] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8156), 1,
      anon_sym_RPAREN,
    STATE(4656), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [42786] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8158), 1,
      anon_sym_RBRACK,
    STATE(4657), 1,
      sym_block_comment,
    STATE(4675), 1,
      aux_sym_except_repeat1,
  [42805] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(214), 1,
      sym_def_eq,
    STATE(4658), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [42822] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(837), 1,
      sym_set_in,
    STATE(4659), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [42839] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8160), 1,
      anon_sym_COMMA,
    ACTIONS(8162), 1,
      anon_sym_RPAREN,
    STATE(4660), 1,
      sym_block_comment,
    STATE(4743), 1,
      aux_sym_pcal_proc_decl_repeat1,
  [42858] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8164), 1,
      anon_sym_RBRACE,
    STATE(4661), 1,
      sym_block_comment,
    STATE(4676), 1,
      aux_sym_function_definition_repeat1,
  [42877] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(710), 1,
      sym_def_eq,
    STATE(4662), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [42894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4663), 1,
      sym_block_comment,
    ACTIONS(8166), 3,
      anon_sym_BSLASHin,
      anon_sym_u2208,
      anon_sym_COLON,
  [42909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8168), 1,
      anon_sym_COMMA,
    ACTIONS(8171), 1,
      anon_sym_RBRACK,
    STATE(4664), 2,
      sym_block_comment,
      aux_sym_record_literal_repeat1,
  [42926] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8173), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4665), 1,
      sym_block_comment,
  [42945] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8175), 1,
      anon_sym_RPAREN,
    STATE(4666), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [42964] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(8177), 1,
      aux_sym_octal_number_token1,
    STATE(4667), 1,
      sym_block_comment,
  [42983] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8179), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4668), 1,
      sym_block_comment,
  [43002] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(698), 1,
      sym_def_eq,
    STATE(4669), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [43019] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(8181), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4670), 1,
      sym_block_comment,
  [43038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(409), 1,
      sym_label_as,
    STATE(4671), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [43055] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(8183), 1,
      anon_sym_RBRACK,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
    STATE(4672), 1,
      sym_block_comment,
  [43074] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(8185), 1,
      anon_sym_RBRACK,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
    STATE(4673), 1,
      sym_block_comment,
  [43093] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8187), 1,
      anon_sym_COMMA,
    ACTIONS(8189), 1,
      anon_sym_RPAREN,
    STATE(4674), 1,
      sym_block_comment,
    STATE(4850), 1,
      aux_sym_operator_declaration_repeat1,
  [43112] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8191), 1,
      anon_sym_RBRACK,
    STATE(4675), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [43131] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8193), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4676), 1,
      sym_block_comment,
  [43150] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8195), 1,
      anon_sym_COLON,
    STATE(4677), 1,
      sym_block_comment,
    STATE(4788), 1,
      aux_sym_function_definition_repeat1,
  [43169] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8033), 1,
      sym_identifier,
    ACTIONS(8197), 1,
      anon_sym_RPAREN,
    ACTIONS(8199), 1,
      anon_sym_do,
    STATE(4678), 1,
      sym_block_comment,
  [43188] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6523), 1,
      sym_trailing_extramodular_text,
    STATE(4679), 1,
      sym_block_comment,
    ACTIONS(6521), 2,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
  [43205] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8201), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4680), 1,
      sym_block_comment,
  [43224] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(701), 1,
      sym_label_as,
    STATE(4681), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [43241] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8203), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4682), 1,
      sym_block_comment,
  [43260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      aux_sym_octal_number_token1,
    STATE(4683), 1,
      sym_block_comment,
  [43279] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8207), 1,
      anon_sym_RPAREN,
    STATE(4684), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [43298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4685), 1,
      sym_block_comment,
    ACTIONS(8209), 3,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ,
  [43313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(712), 1,
      sym_def_eq,
    STATE(4686), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [43330] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8211), 1,
      anon_sym_RBRACK,
    STATE(4687), 1,
      sym_block_comment,
    STATE(4880), 1,
      aux_sym_except_repeat1,
  [43349] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(713), 1,
      sym_def_eq,
    STATE(4688), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [43366] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7146), 1,
      anon_sym_COLON,
    STATE(4689), 1,
      sym_block_comment,
    STATE(4697), 1,
      aux_sym_variable_declaration_repeat1,
  [43385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6420), 1,
      sym__begin_proof_step,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    STATE(4690), 2,
      sym_block_comment,
      aux_sym_use_body_def_repeat1,
  [43402] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7156), 1,
      anon_sym_COLON,
    STATE(4691), 1,
      sym_block_comment,
    STATE(4735), 1,
      aux_sym_variable_declaration_repeat1,
  [43421] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8216), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4692), 1,
      sym_block_comment,
  [43440] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5894), 1,
      anon_sym_LPAREN,
    STATE(4693), 1,
      sym_block_comment,
    ACTIONS(5892), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [43457] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(204), 1,
      sym_def_eq,
    STATE(4694), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [43474] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8218), 1,
      anon_sym_COLON,
    STATE(4695), 1,
      sym_block_comment,
    STATE(4704), 1,
      aux_sym_function_definition_repeat1,
  [43493] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8220), 1,
      anon_sym_RBRACE,
    STATE(4696), 1,
      sym_block_comment,
    STATE(4886), 1,
      aux_sym_function_definition_repeat1,
  [43512] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7154), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4697), 1,
      sym_block_comment,
  [43531] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8222), 1,
      anon_sym_RPAREN,
    STATE(4698), 1,
      sym_block_comment,
    STATE(4711), 1,
      aux_sym_bound_op_repeat1,
  [43550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7054), 1,
      sym__begin_proof_step,
    ACTIONS(8224), 1,
      anon_sym_COMMA,
    STATE(4699), 2,
      sym_block_comment,
      aux_sym_function_definition_repeat1,
  [43567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(4700), 1,
      sym_block_comment,
    ACTIONS(5896), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [43584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5902), 1,
      anon_sym_LPAREN,
    STATE(4701), 1,
      sym_block_comment,
    ACTIONS(5900), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [43601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8227), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4702), 1,
      sym_block_comment,
  [43620] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6371), 1,
      sym__begin_proof_step,
    ACTIONS(7953), 1,
      anon_sym_COMMA,
    STATE(4703), 1,
      sym_block_comment,
    STATE(4800), 1,
      aux_sym_instance_repeat1,
  [43639] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8229), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4704), 1,
      sym_block_comment,
  [43658] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8231), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4705), 1,
      sym_block_comment,
  [43677] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8233), 1,
      anon_sym_COMMA,
    ACTIONS(8235), 1,
      anon_sym_RPAREN,
    STATE(4480), 1,
      aux_sym_pcal_macro_decl_repeat1,
    STATE(4706), 1,
      sym_block_comment,
  [43696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8237), 1,
      anon_sym_RPAREN,
    STATE(4707), 1,
      sym_block_comment,
    STATE(4726), 1,
      aux_sym_bound_op_repeat1,
  [43715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(822), 1,
      sym_def_eq,
    STATE(4708), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [43732] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(8239), 1,
      anon_sym_COLON,
    STATE(4709), 1,
      sym_block_comment,
    STATE(4728), 1,
      aux_sym_variable_declaration_repeat1,
  [43751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(431), 1,
      sym_label_as,
    STATE(4710), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [43768] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8241), 1,
      anon_sym_RPAREN,
    STATE(4711), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [43787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4571), 1,
      sym__begin_proof_step,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4712), 2,
      sym_block_comment,
      aux_sym_finite_set_literal_repeat1,
  [43804] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4665), 1,
      anon_sym_COMMA,
    ACTIONS(4681), 1,
      anon_sym_PROVE,
    STATE(4537), 1,
      aux_sym_assume_prove_repeat1,
    STATE(4713), 1,
      sym_block_comment,
  [43823] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8187), 1,
      anon_sym_COMMA,
    ACTIONS(8246), 1,
      anon_sym_RPAREN,
    STATE(4714), 1,
      sym_block_comment,
    STATE(4842), 1,
      aux_sym_operator_declaration_repeat1,
  [43842] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8248), 1,
      anon_sym_RBRACK,
    STATE(4715), 1,
      sym_block_comment,
    STATE(4732), 1,
      aux_sym_except_repeat1,
  [43861] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8250), 1,
      anon_sym_RPAREN,
    STATE(4716), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [43880] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8252), 1,
      anon_sym_COLON,
    STATE(4717), 1,
      sym_block_comment,
    STATE(4742), 1,
      aux_sym_function_definition_repeat1,
  [43899] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8254), 1,
      anon_sym_RBRACE,
    STATE(4718), 1,
      sym_block_comment,
    STATE(4734), 1,
      aux_sym_function_definition_repeat1,
  [43918] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8256), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4719), 1,
      sym_block_comment,
  [43937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8258), 1,
      anon_sym_RBRACE,
    ACTIONS(8260), 1,
      anon_sym_SEMI,
    STATE(4720), 2,
      sym_block_comment,
      aux_sym_pcal_c_algorithm_body_repeat1,
  [43954] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(207), 1,
      sym_def_eq,
    STATE(4721), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [43971] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8263), 1,
      sym_identifier,
    STATE(4187), 1,
      aux_sym_pcal_proc_var_decls_repeat1,
    STATE(4722), 1,
      sym_block_comment,
    STATE(4992), 1,
      sym_pcal_proc_var_decl,
  [43990] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8265), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4723), 1,
      sym_block_comment,
  [44009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(714), 1,
      sym_def_eq,
    STATE(4724), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [44026] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7104), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4725), 1,
      sym_block_comment,
  [44045] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8267), 1,
      anon_sym_RPAREN,
    STATE(4726), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [44064] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8269), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4727), 1,
      sym_block_comment,
  [44083] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(8271), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4728), 1,
      sym_block_comment,
  [44102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(435), 1,
      sym_label_as,
    STATE(4729), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [44119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(8273), 1,
      anon_sym_RBRACK,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
    STATE(4730), 1,
      sym_block_comment,
  [44138] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(8275), 1,
      anon_sym_RBRACK,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
    STATE(4731), 1,
      sym_block_comment,
  [44157] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8277), 1,
      anon_sym_RBRACK,
    STATE(4732), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [44176] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8279), 1,
      anon_sym_RPAREN,
    STATE(4733), 1,
      sym_block_comment,
    STATE(4887), 1,
      aux_sym_bound_op_repeat1,
  [44195] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8281), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4734), 1,
      sym_block_comment,
  [44214] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7200), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4735), 1,
      sym_block_comment,
  [44233] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8283), 1,
      anon_sym_RPAREN,
    STATE(4736), 1,
      sym_block_comment,
    STATE(4764), 1,
      aux_sym_bound_op_repeat1,
  [44252] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8285), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4737), 1,
      sym_block_comment,
  [44271] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(8287), 1,
      aux_sym_octal_number_token1,
    STATE(4738), 1,
      sym_block_comment,
  [44290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4751), 1,
      anon_sym_PROVE,
    ACTIONS(8289), 1,
      anon_sym_COMMA,
    STATE(4739), 2,
      sym_block_comment,
      aux_sym_assume_prove_repeat1,
  [44307] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8292), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4740), 1,
      sym_block_comment,
  [44326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8294), 1,
      sym__begin_proof_step,
    STATE(5357), 1,
      sym_proof_step,
    STATE(4741), 2,
      sym_block_comment,
      aux_sym_non_terminal_proof_repeat1,
  [44343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8297), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4742), 1,
      sym_block_comment,
  [44362] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8160), 1,
      anon_sym_COMMA,
    ACTIONS(8299), 1,
      anon_sym_RPAREN,
    STATE(4501), 1,
      aux_sym_pcal_proc_decl_repeat1,
    STATE(4743), 1,
      sym_block_comment,
  [44381] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7204), 1,
      anon_sym_COLON,
    STATE(4744), 1,
      sym_block_comment,
    STATE(4755), 1,
      aux_sym_variable_declaration_repeat1,
  [44400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(8301), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4745), 1,
      sym_block_comment,
  [44419] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8303), 1,
      anon_sym_RPAREN,
    STATE(4746), 1,
      sym_block_comment,
    STATE(4785), 1,
      aux_sym_bound_op_repeat1,
  [44438] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8305), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4747), 1,
      sym_block_comment,
  [44457] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7192), 1,
      anon_sym_COLON,
    STATE(4748), 1,
      sym_block_comment,
    STATE(4930), 1,
      aux_sym_variable_declaration_repeat1,
  [44476] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(8307), 1,
      anon_sym_COLON,
    STATE(4749), 1,
      sym_block_comment,
    STATE(4789), 1,
      aux_sym_variable_declaration_repeat1,
  [44495] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8309), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4750), 1,
      sym_block_comment,
  [44514] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(715), 1,
      sym_def_eq,
    STATE(4751), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [44531] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(731), 1,
      sym_def_eq,
    STATE(4752), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [44548] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(208), 1,
      sym_def_eq,
    STATE(4753), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [44565] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8311), 1,
      anon_sym_COLON,
    STATE(4754), 1,
      sym_block_comment,
    STATE(4760), 1,
      aux_sym_function_definition_repeat1,
  [44584] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7214), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4755), 1,
      sym_block_comment,
  [44603] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8313), 1,
      anon_sym_RPAREN,
    STATE(4756), 1,
      sym_block_comment,
    STATE(4767), 1,
      aux_sym_bound_op_repeat1,
  [44622] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8315), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4757), 1,
      sym_block_comment,
  [44641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(717), 1,
      sym_def_eq,
    STATE(4758), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [44658] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8317), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4759), 1,
      sym_block_comment,
  [44677] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8319), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4760), 1,
      sym_block_comment,
  [44696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8321), 1,
      anon_sym_RPAREN,
    STATE(4761), 1,
      sym_block_comment,
    STATE(4776), 1,
      aux_sym_bound_op_repeat1,
  [44715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(316), 1,
      sym_label_as,
    STATE(4762), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [44732] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8323), 1,
      anon_sym_RBRACE,
    ACTIONS(8325), 1,
      anon_sym_SEMI,
    STATE(4763), 1,
      sym_block_comment,
    STATE(4934), 1,
      aux_sym_pcal_c_algorithm_body_repeat1,
  [44751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8327), 1,
      anon_sym_RPAREN,
    STATE(4764), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [44770] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8329), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4765), 1,
      sym_block_comment,
  [44789] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(457), 1,
      sym_label_as,
    STATE(4766), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [44806] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8331), 1,
      anon_sym_RPAREN,
    STATE(4767), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [44825] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8333), 1,
      anon_sym_RPAREN,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4768), 1,
      sym_block_comment,
  [44844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8335), 1,
      anon_sym_RBRACK,
    STATE(4769), 1,
      sym_block_comment,
    STATE(4783), 1,
      aux_sym_except_repeat1,
  [44863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8337), 1,
      anon_sym_RBRACK,
    STATE(4770), 1,
      sym_block_comment,
    STATE(4796), 1,
      aux_sym_except_repeat1,
  [44882] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8339), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4771), 1,
      sym_block_comment,
  [44901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8341), 1,
      anon_sym_RBRACE,
    STATE(4772), 1,
      sym_block_comment,
    STATE(4784), 1,
      aux_sym_function_definition_repeat1,
  [44920] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7152), 1,
      anon_sym_COLON,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    STATE(4773), 1,
      sym_block_comment,
    STATE(4781), 1,
      aux_sym_function_definition_repeat1,
  [44939] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8343), 1,
      anon_sym_RBRACE,
    STATE(4774), 1,
      sym_block_comment,
    STATE(4798), 1,
      aux_sym_function_definition_repeat1,
  [44958] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8345), 1,
      anon_sym_end,
    ACTIONS(8347), 1,
      anon_sym_or,
    STATE(4775), 2,
      sym_block_comment,
      aux_sym_pcal_p_either_repeat1,
  [44975] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_RPAREN,
    STATE(4776), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [44994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8352), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4777), 1,
      sym_block_comment,
  [45013] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(461), 1,
      sym_label_as,
    STATE(4778), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [45030] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8354), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4779), 1,
      sym_block_comment,
  [45049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(8356), 1,
      anon_sym_RBRACK,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
    STATE(4780), 1,
      sym_block_comment,
  [45068] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7108), 1,
      anon_sym_COLON,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4781), 1,
      sym_block_comment,
  [45087] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(8358), 1,
      anon_sym_RBRACK,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
    STATE(4782), 1,
      sym_block_comment,
  [45106] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8360), 1,
      anon_sym_RBRACK,
    STATE(4783), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [45125] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8362), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4784), 1,
      sym_block_comment,
  [45144] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8364), 1,
      anon_sym_RPAREN,
    STATE(4785), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [45163] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(8366), 1,
      aux_sym_octal_number_token1,
    STATE(4786), 1,
      sym_block_comment,
  [45182] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8368), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4787), 1,
      sym_block_comment,
  [45201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8370), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4788), 1,
      sym_block_comment,
  [45220] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(8372), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4789), 1,
      sym_block_comment,
  [45239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(718), 1,
      sym_def_eq,
    STATE(4790), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [45256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(321), 1,
      sym_label_as,
    STATE(4791), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [45273] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7244), 1,
      anon_sym_COLON,
    STATE(4792), 1,
      sym_block_comment,
    STATE(4803), 1,
      aux_sym_variable_declaration_repeat1,
  [45292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(8374), 1,
      anon_sym_RBRACK,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
    STATE(4793), 1,
      sym_block_comment,
  [45311] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8376), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4794), 1,
      sym_block_comment,
  [45330] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(8378), 1,
      anon_sym_RBRACK,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
    STATE(4795), 1,
      sym_block_comment,
  [45349] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8380), 1,
      anon_sym_RBRACK,
    STATE(4796), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [45368] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8263), 1,
      sym_identifier,
    ACTIONS(8382), 1,
      anon_sym_RPAREN,
    STATE(4660), 1,
      sym_pcal_proc_var_decl,
    STATE(4797), 1,
      sym_block_comment,
  [45387] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8384), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4798), 1,
      sym_block_comment,
  [45406] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8386), 1,
      anon_sym_RPAREN,
    STATE(4440), 1,
      aux_sym_bound_op_repeat1,
    STATE(4799), 1,
      sym_block_comment,
  [45425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6278), 1,
      sym__begin_proof_step,
    ACTIONS(8388), 1,
      anon_sym_COMMA,
    STATE(4800), 2,
      sym_block_comment,
      aux_sym_instance_repeat1,
  [45442] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8391), 1,
      anon_sym_COLON,
    STATE(4801), 1,
      sym_block_comment,
    STATE(4807), 1,
      aux_sym_function_definition_repeat1,
  [45461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8393), 1,
      anon_sym_RPAREN,
    STATE(4578), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(4802), 1,
      sym_block_comment,
  [45480] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7246), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4803), 1,
      sym_block_comment,
  [45499] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8395), 1,
      anon_sym_RPAREN,
    STATE(4804), 1,
      sym_block_comment,
    STATE(4810), 1,
      aux_sym_bound_op_repeat1,
  [45518] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8397), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4805), 1,
      sym_block_comment,
  [45537] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6379), 1,
      anon_sym_COMMA,
    ACTIONS(8399), 1,
      anon_sym_RPAREN,
    STATE(3539), 1,
      aux_sym_extends_repeat1,
    STATE(4806), 1,
      sym_block_comment,
  [45556] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8401), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4807), 1,
      sym_block_comment,
  [45575] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8403), 1,
      anon_sym_RPAREN,
    STATE(4808), 1,
      sym_block_comment,
    STATE(4819), 1,
      aux_sym_bound_op_repeat1,
  [45594] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(483), 1,
      sym_label_as,
    STATE(4809), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [45611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8405), 1,
      anon_sym_RPAREN,
    STATE(4810), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [45630] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8407), 1,
      anon_sym_RBRACK,
    STATE(4811), 1,
      sym_block_comment,
    STATE(4824), 1,
      aux_sym_except_repeat1,
  [45649] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(8409), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4812), 1,
      sym_block_comment,
  [45668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8411), 1,
      anon_sym_RPAREN,
    STATE(4716), 1,
      aux_sym_bound_op_repeat1,
    STATE(4813), 1,
      sym_block_comment,
  [45687] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8413), 1,
      anon_sym_RBRACE,
    STATE(4814), 1,
      sym_block_comment,
    STATE(4825), 1,
      aux_sym_function_definition_repeat1,
  [45706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4815), 1,
      sym_block_comment,
    ACTIONS(8415), 3,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ,
  [45721] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(8417), 1,
      anon_sym_COLON,
    STATE(4492), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4816), 1,
      sym_block_comment,
  [45740] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8419), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4817), 1,
      sym_block_comment,
  [45759] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(734), 1,
      sym_def_eq,
    STATE(4818), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [45776] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8421), 1,
      anon_sym_RPAREN,
    STATE(4819), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [45795] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8423), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4820), 1,
      sym_block_comment,
  [45814] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(487), 1,
      sym_label_as,
    STATE(4821), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [45831] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(8425), 1,
      anon_sym_RBRACK,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
    STATE(4822), 1,
      sym_block_comment,
  [45850] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(8427), 1,
      anon_sym_RBRACK,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
    STATE(4823), 1,
      sym_block_comment,
  [45869] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8429), 1,
      anon_sym_RBRACK,
    STATE(4824), 1,
      sym_block_comment,
    STATE(4828), 1,
      aux_sym_except_repeat1,
  [45888] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8431), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4825), 1,
      sym_block_comment,
  [45907] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(8433), 1,
      aux_sym_octal_number_token1,
    STATE(4826), 1,
      sym_block_comment,
  [45926] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(8435), 1,
      aux_sym_octal_number_token1,
    STATE(4827), 1,
      sym_block_comment,
  [45945] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8437), 1,
      anon_sym_COMMA,
    ACTIONS(8440), 1,
      anon_sym_RBRACK,
    STATE(4828), 2,
      sym_block_comment,
      aux_sym_except_repeat1,
  [45962] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(516), 1,
      sym_def_eq,
    STATE(4829), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [45979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(881), 1,
      sym_def_eq,
    STATE(4830), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [45996] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(735), 1,
      sym_def_eq,
    STATE(4831), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [46013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7136), 1,
      anon_sym_COLON,
    STATE(4832), 1,
      sym_block_comment,
    STATE(4839), 1,
      aux_sym_variable_declaration_repeat1,
  [46032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(736), 1,
      sym_def_eq,
    STATE(4833), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [46049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(210), 1,
      sym_def_eq,
    STATE(4834), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [46066] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7248), 1,
      anon_sym_COLON,
    STATE(4835), 1,
      sym_block_comment,
    STATE(4888), 1,
      aux_sym_variable_declaration_repeat1,
  [46085] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(895), 1,
      sym_def_eq,
    STATE(4836), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [46102] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8442), 1,
      anon_sym_COLON,
    STATE(4837), 1,
      sym_block_comment,
    STATE(4845), 1,
      aux_sym_function_definition_repeat1,
  [46121] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(8444), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4838), 1,
      sym_block_comment,
  [46140] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7142), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4839), 1,
      sym_block_comment,
  [46159] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8446), 1,
      anon_sym_RPAREN,
    STATE(4840), 1,
      sym_block_comment,
    STATE(4853), 1,
      aux_sym_bound_op_repeat1,
  [46178] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8448), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4841), 1,
      sym_block_comment,
  [46197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8187), 1,
      anon_sym_COMMA,
    ACTIONS(8450), 1,
      anon_sym_RPAREN,
    STATE(4842), 1,
      sym_block_comment,
    STATE(4850), 1,
      aux_sym_operator_declaration_repeat1,
  [46216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4843), 1,
      sym_block_comment,
    ACTIONS(8452), 3,
      anon_sym_BSLASHin,
      anon_sym_u2208,
      anon_sym_COLON,
  [46231] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(8454), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4844), 1,
      sym_block_comment,
  [46250] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8456), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4845), 1,
      sym_block_comment,
  [46269] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8458), 1,
      anon_sym_RPAREN,
    STATE(4846), 1,
      sym_block_comment,
    STATE(4869), 1,
      aux_sym_bound_op_repeat1,
  [46288] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4683), 1,
      anon_sym_COMMA,
    ACTIONS(8460), 1,
      sym__begin_proof_step,
    STATE(4712), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4847), 1,
      sym_block_comment,
  [46307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4848), 1,
      sym_block_comment,
    ACTIONS(8462), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [46322] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(8464), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4849), 1,
      sym_block_comment,
  [46341] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8466), 1,
      anon_sym_COMMA,
    ACTIONS(8469), 1,
      anon_sym_RPAREN,
    STATE(4850), 2,
      sym_block_comment,
      aux_sym_operator_declaration_repeat1,
  [46358] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8471), 1,
      anon_sym_RBRACK,
    STATE(4851), 1,
      sym_block_comment,
    STATE(4884), 1,
      aux_sym_function_definition_repeat1,
  [46377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(510), 1,
      sym_label_as,
    STATE(4852), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [46394] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8473), 1,
      anon_sym_RPAREN,
    STATE(4853), 1,
      sym_block_comment,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
  [46413] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(8475), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4854), 1,
      sym_block_comment,
  [46432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4855), 1,
      sym_block_comment,
    ACTIONS(7632), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [46447] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8477), 1,
      anon_sym_RBRACK,
    STATE(4856), 1,
      sym_block_comment,
    STATE(4877), 1,
      aux_sym_except_repeat1,
  [46466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(904), 1,
      sym_label_as,
    STATE(4857), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [46483] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8479), 1,
      anon_sym_COLON,
    STATE(4858), 1,
      sym_block_comment,
    STATE(4902), 1,
      aux_sym_function_definition_repeat1,
  [46502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(748), 1,
      sym_label_as,
    STATE(4859), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [46519] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(8481), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4860), 1,
      sym_block_comment,
  [46538] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8483), 1,
      anon_sym_RBRACE,
    STATE(4861), 1,
      sym_block_comment,
    STATE(4878), 1,
      aux_sym_function_definition_repeat1,
  [46557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(200), 1,
      sym_def_eq,
    STATE(4862), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [46574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8485), 1,
      anon_sym_COMMA,
    ACTIONS(8488), 1,
      anon_sym_RPAREN,
    STATE(4863), 2,
      sym_block_comment,
      aux_sym_bound_op_repeat1,
  [46591] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(8490), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4864), 1,
      sym_block_comment,
  [46610] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8492), 1,
      anon_sym_RPAREN,
    STATE(3541), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(4865), 1,
      sym_block_comment,
  [46629] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(323), 1,
      sym_set_in,
    STATE(4866), 1,
      sym_block_comment,
    ACTIONS(6931), 2,
      anon_sym_BSLASHin,
      anon_sym_u2208,
  [46646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(8494), 1,
      anon_sym_RBRACK,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
    STATE(4867), 1,
      sym_block_comment,
  [46665] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(8496), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4868), 1,
      sym_block_comment,
  [46684] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8498), 1,
      anon_sym_RPAREN,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
    STATE(4869), 1,
      sym_block_comment,
  [46703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(8500), 1,
      anon_sym_RBRACK,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
    STATE(4870), 1,
      sym_block_comment,
  [46722] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8502), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4871), 1,
      sym_block_comment,
  [46741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(514), 1,
      sym_label_as,
    STATE(4872), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [46758] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(8504), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4873), 1,
      sym_block_comment,
  [46777] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(8506), 1,
      anon_sym_RBRACK,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
    STATE(4874), 1,
      sym_block_comment,
  [46796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4875), 1,
      sym_block_comment,
    ACTIONS(8508), 3,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_EQ,
  [46811] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(8510), 1,
      anon_sym_RBRACK,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
    STATE(4876), 1,
      sym_block_comment,
  [46830] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8512), 1,
      anon_sym_RBRACK,
    STATE(4828), 1,
      aux_sym_except_repeat1,
    STATE(4877), 1,
      sym_block_comment,
  [46849] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8514), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4878), 1,
      sym_block_comment,
  [46868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(189), 1,
      sym_def_eq,
    STATE(4879), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [46885] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8516), 1,
      anon_sym_RBRACK,
    STATE(4828), 1,
      aux_sym_except_repeat1,
    STATE(4880), 1,
      sym_block_comment,
  [46904] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(8518), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4881), 1,
      sym_block_comment,
  [46923] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(8520), 1,
      aux_sym_octal_number_token1,
    STATE(4882), 1,
      sym_block_comment,
  [46942] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(629), 1,
      sym_def_eq,
    STATE(4883), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [46959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8522), 1,
      anon_sym_RBRACK,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4884), 1,
      sym_block_comment,
  [46978] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(738), 1,
      sym_def_eq,
    STATE(4885), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [46995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8524), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4886), 1,
      sym_block_comment,
  [47014] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8526), 1,
      anon_sym_RPAREN,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
    STATE(4887), 1,
      sym_block_comment,
  [47033] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7116), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4888), 1,
      sym_block_comment,
  [47052] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(8528), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4889), 1,
      sym_block_comment,
  [47071] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8530), 1,
      anon_sym_RPAREN,
    STATE(4890), 1,
      sym_block_comment,
    STATE(4941), 1,
      aux_sym_bound_op_repeat1,
  [47090] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7108), 1,
      sym__begin_proof_step,
    ACTIONS(8027), 1,
      anon_sym_COMMA,
    STATE(4699), 1,
      aux_sym_function_definition_repeat1,
    STATE(4891), 1,
      sym_block_comment,
  [47109] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7162), 1,
      anon_sym_COLON,
    STATE(4892), 1,
      sym_block_comment,
    STATE(4900), 1,
      aux_sym_variable_declaration_repeat1,
  [47128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(7301), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4893), 1,
      sym_block_comment,
  [47147] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8187), 1,
      anon_sym_COMMA,
    ACTIONS(8532), 1,
      anon_sym_RPAREN,
    STATE(4674), 1,
      aux_sym_operator_declaration_repeat1,
    STATE(4894), 1,
      sym_block_comment,
  [47166] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8534), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4895), 1,
      sym_block_comment,
  [47185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4896), 1,
      sym_block_comment,
    ACTIONS(7773), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [47200] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5413), 1,
      anon_sym_LPAREN,
    ACTIONS(5415), 1,
      anon_sym_BANG,
    ACTIONS(8536), 1,
      aux_sym_proof_step_ref_token1,
    STATE(4897), 1,
      sym_block_comment,
  [47219] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8233), 1,
      anon_sym_COMMA,
    ACTIONS(8538), 1,
      anon_sym_RPAREN,
    STATE(4706), 1,
      aux_sym_pcal_macro_decl_repeat1,
    STATE(4898), 1,
      sym_block_comment,
  [47238] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8540), 1,
      anon_sym_COLON,
    STATE(4899), 1,
      sym_block_comment,
    STATE(4906), 1,
      aux_sym_function_definition_repeat1,
  [47257] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7168), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4900), 1,
      sym_block_comment,
  [47276] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8542), 1,
      anon_sym_RPAREN,
    STATE(4901), 1,
      sym_block_comment,
    STATE(4912), 1,
      aux_sym_bound_op_repeat1,
  [47295] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8544), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4902), 1,
      sym_block_comment,
  [47314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8546), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4903), 1,
      sym_block_comment,
  [47333] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8548), 1,
      anon_sym_RBRACK,
    STATE(4555), 1,
      aux_sym_except_repeat1,
    STATE(4904), 1,
      sym_block_comment,
  [47352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8550), 1,
      anon_sym_RPAREN,
    STATE(4444), 1,
      aux_sym_bound_op_repeat1,
    STATE(4905), 1,
      sym_block_comment,
  [47371] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8552), 1,
      anon_sym_COLON,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4906), 1,
      sym_block_comment,
  [47390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4907), 1,
      sym_block_comment,
    ACTIONS(7486), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [47405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8554), 1,
      anon_sym_RPAREN,
    STATE(4908), 1,
      sym_block_comment,
    STATE(4921), 1,
      aux_sym_bound_op_repeat1,
  [47424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4909), 1,
      sym_block_comment,
    ACTIONS(8556), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [47439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4910), 1,
      sym_block_comment,
    ACTIONS(8558), 3,
      anon_sym_end,
      anon_sym_elsif,
      anon_sym_else,
  [47454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(538), 1,
      sym_label_as,
    STATE(4911), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [47471] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8560), 1,
      anon_sym_RPAREN,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
    STATE(4912), 1,
      sym_block_comment,
  [47490] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8562), 1,
      anon_sym_RBRACE,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4913), 1,
      sym_block_comment,
  [47509] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8564), 1,
      anon_sym_RBRACK,
    STATE(4914), 1,
      sym_block_comment,
    STATE(4927), 1,
      aux_sym_except_repeat1,
  [47528] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6388), 1,
      anon_sym_COMMA,
    ACTIONS(8566), 1,
      anon_sym_RPAREN,
    STATE(4865), 1,
      aux_sym_constant_declaration_repeat1,
    STATE(4915), 1,
      sym_block_comment,
  [47547] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8568), 1,
      anon_sym_RBRACE,
    STATE(4916), 1,
      sym_block_comment,
    STATE(4929), 1,
      aux_sym_function_definition_repeat1,
  [47566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(831), 1,
      sym_def_eq,
    STATE(4917), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [47583] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(968), 1,
      sym_bullet_conj,
    STATE(4918), 1,
      sym_block_comment,
    ACTIONS(7238), 2,
      anon_sym_SLASH_BSLASH,
      anon_sym_u2227,
  [47600] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(8570), 1,
      anon_sym_COLON,
    STATE(4454), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4919), 1,
      sym_block_comment,
  [47619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(969), 1,
      sym_bullet_disj,
    STATE(4920), 1,
      sym_block_comment,
    ACTIONS(7240), 2,
      anon_sym_BSLASH_SLASH,
      anon_sym_u2228,
  [47636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8572), 1,
      anon_sym_RPAREN,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
    STATE(4921), 1,
      sym_block_comment,
  [47655] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8574), 1,
      sym_identifier,
    ACTIONS(8576), 1,
      anon_sym_LPAREN,
    STATE(4922), 1,
      sym_block_comment,
  [47674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4535), 1,
      anon_sym_COMMA,
    ACTIONS(8578), 1,
      anon_sym_RBRACK,
    STATE(4156), 1,
      aux_sym_finite_set_literal_repeat1,
    STATE(4923), 1,
      sym_block_comment,
  [47693] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(542), 1,
      sym_label_as,
    STATE(4924), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [47710] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    ACTIONS(8580), 1,
      anon_sym_RBRACK,
    STATE(4648), 1,
      aux_sym_set_of_records_repeat1,
    STATE(4925), 1,
      sym_block_comment,
  [47729] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4633), 1,
      anon_sym_COMMA,
    ACTIONS(8582), 1,
      anon_sym_RBRACK,
    STATE(4664), 1,
      aux_sym_record_literal_repeat1,
    STATE(4926), 1,
      sym_block_comment,
  [47748] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8584), 1,
      anon_sym_RBRACK,
    STATE(4828), 1,
      aux_sym_except_repeat1,
    STATE(4927), 1,
      sym_block_comment,
  [47767] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(739), 1,
      sym_def_eq,
    STATE(4928), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [47784] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8586), 1,
      anon_sym_RBRACE,
    STATE(4225), 1,
      aux_sym_function_definition_repeat1,
    STATE(4929), 1,
      sym_block_comment,
  [47803] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(7176), 1,
      anon_sym_COLON,
    STATE(3493), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4930), 1,
      sym_block_comment,
  [47822] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8588), 1,
      anon_sym_RPAREN,
    STATE(4684), 1,
      aux_sym_bound_op_repeat1,
    STATE(4931), 1,
      sym_block_comment,
  [47841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(190), 1,
      sym_def_eq,
    STATE(4932), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [47858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4933), 1,
      sym_block_comment,
    ACTIONS(7516), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [47873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8590), 1,
      anon_sym_RBRACE,
    ACTIONS(8592), 1,
      anon_sym_SEMI,
    STATE(4720), 1,
      aux_sym_pcal_c_algorithm_body_repeat1,
    STATE(4934), 1,
      sym_block_comment,
  [47892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5389), 1,
      anon_sym_LPAREN,
    ACTIONS(5391), 1,
      anon_sym_BANG,
    ACTIONS(8594), 1,
      aux_sym_octal_number_token1,
    STATE(4935), 1,
      sym_block_comment,
  [47911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(741), 1,
      sym_def_eq,
    STATE(4936), 1,
      sym_block_comment,
    ACTIONS(3817), 2,
      anon_sym_EQ_EQ,
      anon_sym_u225c,
  [47928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4937), 1,
      sym_block_comment,
    ACTIONS(8596), 3,
      anon_sym_RBRACE,
      anon_sym_fair,
      anon_sym_process,
  [47943] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(8598), 1,
      anon_sym_RBRACE,
    STATE(4565), 1,
      aux_sym_function_definition_repeat1,
    STATE(4938), 1,
      sym_block_comment,
  [47962] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(348), 1,
      sym_label_as,
    STATE(4939), 1,
      sym_block_comment,
    ACTIONS(3827), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [47979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4940), 1,
      sym_block_comment,
    ACTIONS(7524), 3,
      anon_sym_end,
      anon_sym_fair,
      anon_sym_process,
  [47994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(8600), 1,
      anon_sym_RPAREN,
    STATE(4863), 1,
      aux_sym_bound_op_repeat1,
    STATE(4941), 1,
      sym_block_comment,
  [48013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7789), 1,
      anon_sym_COMMA,
    ACTIONS(8602), 1,
      anon_sym_RBRACK,
    STATE(4828), 1,
      aux_sym_except_repeat1,
    STATE(4942), 1,
      sym_block_comment,
  [48032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(7423), 1,
      anon_sym_LPAREN,
    STATE(4943), 1,
      sym_block_comment,
  [48048] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6344), 1,
      anon_sym_LPAREN,
    STATE(4944), 1,
      sym_block_comment,
  [48064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6346), 1,
      anon_sym_LPAREN,
    STATE(4945), 1,
      sym_block_comment,
  [48080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9), 1,
      anon_sym_DASH_DASH_DASH_DASH,
    STATE(3412), 1,
      sym_single_line,
    STATE(4946), 1,
      sym_block_comment,
  [48096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6815), 1,
      anon_sym_LPAREN,
    STATE(4947), 1,
      sym_block_comment,
  [48112] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8604), 1,
      ts_builtin_sym_end,
    ACTIONS(8606), 1,
      anon_sym_SEMI,
    STATE(4948), 1,
      sym_block_comment,
  [48128] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8608), 1,
      sym_identifier,
    STATE(3940), 1,
      sym_pcal_var_decl,
    STATE(4949), 1,
      sym_block_comment,
  [48144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8610), 1,
      anon_sym_LT,
    STATE(4), 1,
      sym_proof_step_id,
    STATE(4950), 1,
      sym_block_comment,
  [48160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4535), 1,
      sym_except_update,
    STATE(4951), 1,
      sym_block_comment,
  [48176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8614), 1,
      anon_sym_LPAREN,
    STATE(4952), 1,
      sym_block_comment,
  [48192] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3840), 1,
      anon_sym_BANG,
    ACTIONS(8616), 1,
      anon_sym_LPAREN,
    STATE(4953), 1,
      sym_block_comment,
  [48208] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    STATE(4954), 1,
      sym_block_comment,
    STATE(5498), 1,
      sym_pcal_p_algorithm_body,
  [48224] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    STATE(4050), 1,
      sym_pcal_c_algorithm_body,
    STATE(4955), 1,
      sym_block_comment,
  [48240] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8619), 1,
      ts_builtin_sym_end,
    ACTIONS(8621), 1,
      anon_sym_SEMI,
    STATE(4956), 1,
      sym_block_comment,
  [48256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8610), 1,
      anon_sym_LT,
    STATE(2), 1,
      sym_proof_step_id,
    STATE(4957), 1,
      sym_block_comment,
  [48272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8115), 1,
      anon_sym_or,
    STATE(4631), 1,
      aux_sym_pcal_p_either_repeat1,
    STATE(4958), 1,
      sym_block_comment,
  [48288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8576), 1,
      anon_sym_LPAREN,
    STATE(4959), 1,
      sym_block_comment,
  [48304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4960), 1,
      sym_block_comment,
    ACTIONS(8623), 2,
      anon_sym_LBRACE,
      anon_sym_begin,
  [48318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8625), 1,
      anon_sym_PLUS,
    ACTIONS(8627), 1,
      anon_sym_process,
    STATE(4961), 1,
      sym_block_comment,
  [48334] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4557), 1,
      sym_except_update,
    STATE(4962), 1,
      sym_block_comment,
  [48350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4715), 1,
      sym_except_update,
    STATE(4963), 1,
      sym_block_comment,
  [48366] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4964), 1,
      sym_block_comment,
    STATE(5037), 1,
      sym_except_update,
  [48382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6348), 1,
      anon_sym_LPAREN,
    STATE(4965), 1,
      sym_block_comment,
  [48398] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6457), 1,
      sym__begin_proof_step,
    ACTIONS(8629), 1,
      anon_sym_WITH,
    STATE(4966), 1,
      sym_block_comment,
  [48414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4967), 1,
      sym_block_comment,
    ACTIONS(8631), 2,
      sym__bullet,
      sym__dedent,
  [48428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8633), 1,
      ts_builtin_sym_end,
    ACTIONS(8635), 1,
      anon_sym_SEMI,
    STATE(4968), 1,
      sym_block_comment,
  [48444] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4597), 1,
      sym_except_update,
    STATE(4969), 1,
      sym_block_comment,
  [48460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    STATE(4417), 1,
      sym_pcal_c_algorithm_body,
    STATE(4970), 1,
      sym_block_comment,
  [48476] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8608), 1,
      sym_identifier,
    STATE(3918), 1,
      sym_pcal_var_decl,
    STATE(4971), 1,
      sym_block_comment,
  [48492] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8637), 1,
      anon_sym_LPAREN,
    STATE(4972), 1,
      sym_block_comment,
  [48508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4973), 1,
      sym_block_comment,
    ACTIONS(8639), 2,
      anon_sym_COMMA,
      anon_sym_PROVE,
  [48522] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8641), 1,
      anon_sym_LPAREN,
    STATE(4974), 1,
      sym_block_comment,
  [48538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4975), 1,
      sym_block_comment,
    ACTIONS(8643), 2,
      anon_sym_LBRACE,
      anon_sym_begin,
  [48552] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3840), 1,
      anon_sym_BANG,
    ACTIONS(8645), 1,
      anon_sym_LPAREN,
    STATE(4976), 1,
      sym_block_comment,
  [48568] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6798), 1,
      anon_sym_LPAREN,
    STATE(4977), 1,
      sym_block_comment,
  [48584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4978), 1,
      sym_block_comment,
    ACTIONS(7332), 2,
      anon_sym_LBRACE,
      anon_sym_begin,
  [48598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4904), 1,
      sym_except_update,
    STATE(4979), 1,
      sym_block_comment,
  [48614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    STATE(4272), 1,
      sym_pcal_c_algorithm_body,
    STATE(4980), 1,
      sym_block_comment,
  [48630] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4470), 1,
      sym_except_update,
    STATE(4981), 1,
      sym_block_comment,
  [48646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4982), 1,
      sym_block_comment,
    ACTIONS(8647), 2,
      anon_sym_LBRACE,
      anon_sym_begin,
  [48660] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8649), 1,
      anon_sym_LPAREN,
    STATE(4983), 1,
      sym_block_comment,
  [48676] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8651), 1,
      anon_sym_PLUS,
    ACTIONS(8653), 1,
      anon_sym_process,
    STATE(4984), 1,
      sym_block_comment,
  [48692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4856), 1,
      sym_except_update,
    STATE(4985), 1,
      sym_block_comment,
  [48708] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8655), 1,
      ts_builtin_sym_end,
    ACTIONS(8657), 1,
      anon_sym_SEMI,
    STATE(4986), 1,
      sym_block_comment,
  [48724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4987), 1,
      sym_block_comment,
    ACTIONS(7416), 2,
      ts_builtin_sym_end,
      anon_sym_DASH_DASH_DASH_DASH,
  [48738] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8610), 1,
      anon_sym_LT,
    STATE(3), 1,
      sym_proof_step_id,
    STATE(4988), 1,
      sym_block_comment,
  [48754] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(7759), 1,
      anon_sym_LPAREN,
    STATE(4989), 1,
      sym_block_comment,
  [48770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    STATE(4990), 1,
      sym_block_comment,
    STATE(5302), 1,
      sym_pcal_p_algorithm_body,
  [48786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4991), 1,
      sym_block_comment,
    ACTIONS(7184), 2,
      anon_sym_COMMA,
      anon_sym_PROVE,
  [48800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4992), 1,
      sym_block_comment,
    ACTIONS(8659), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [48814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4993), 1,
      sym_block_comment,
    ACTIONS(7919), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48828] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6829), 1,
      anon_sym_LPAREN,
    STATE(4994), 1,
      sym_block_comment,
  [48844] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4769), 1,
      sym_except_update,
    STATE(4995), 1,
      sym_block_comment,
  [48860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4996), 1,
      sym_block_comment,
    ACTIONS(8661), 2,
      anon_sym_COMMA,
      anon_sym_PROVE,
  [48874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(4997), 1,
      sym_block_comment,
    ACTIONS(8663), 2,
      anon_sym_LBRACE,
      anon_sym_begin,
  [48888] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8665), 1,
      sym_identifier,
    STATE(4998), 1,
      sym_block_comment,
    STATE(5221), 1,
      sym__pcal_with_vars,
  [48904] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(5706), 1,
      anon_sym_LPAREN,
    STATE(4999), 1,
      sym_block_comment,
  [48920] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    STATE(4168), 1,
      sym_pcal_c_algorithm_body,
    STATE(5000), 1,
      sym_block_comment,
  [48936] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4490), 1,
      sym_except_update,
    STATE(5001), 1,
      sym_block_comment,
  [48952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5002), 1,
      sym_block_comment,
    ACTIONS(8488), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4441), 1,
      sym_except_update,
    STATE(5003), 1,
      sym_block_comment,
  [48982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5004), 1,
      sym_block_comment,
    ACTIONS(8667), 2,
      anon_sym_end,
      anon_sym_or,
  [48996] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4426), 1,
      sym_except_update,
    STATE(5005), 1,
      sym_block_comment,
  [49012] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5696), 1,
      anon_sym_BANG,
    ACTIONS(5698), 1,
      anon_sym_LPAREN,
    STATE(5006), 1,
      sym_block_comment,
  [49028] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      ts_builtin_sym_end,
    ACTIONS(8671), 1,
      anon_sym_SEMI,
    STATE(5007), 1,
      sym_block_comment,
  [49044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4657), 1,
      sym_except_update,
    STATE(5008), 1,
      sym_block_comment,
  [49060] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8673), 1,
      anon_sym_LPAREN,
    STATE(5009), 1,
      sym_block_comment,
  [49076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5010), 1,
      sym_block_comment,
    ACTIONS(7128), 2,
      anon_sym_COMMA,
      anon_sym_PROVE,
  [49090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5011), 1,
      sym_block_comment,
    ACTIONS(8675), 2,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [49104] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4914), 1,
      sym_except_update,
    STATE(5012), 1,
      sym_block_comment,
  [49120] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    STATE(5013), 1,
      sym_block_comment,
    STATE(5265), 1,
      sym_pcal_p_algorithm_body,
  [49136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5014), 1,
      sym_block_comment,
    ACTIONS(4751), 2,
      anon_sym_COMMA,
      anon_sym_PROVE,
  [49150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5716), 1,
      anon_sym_BANG,
    ACTIONS(5718), 1,
      anon_sym_LPAREN,
    STATE(5015), 1,
      sym_block_comment,
  [49166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6711), 1,
      anon_sym_LBRACE,
    STATE(4292), 1,
      sym_pcal_c_algorithm_body,
    STATE(5016), 1,
      sym_block_comment,
  [49182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5017), 1,
      sym_block_comment,
    ACTIONS(8677), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [49196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8679), 1,
      anon_sym_LPAREN,
    STATE(5018), 1,
      sym_block_comment,
  [49212] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5712), 1,
      anon_sym_BANG,
    ACTIONS(5714), 1,
      anon_sym_LPAREN,
    STATE(5019), 1,
      sym_block_comment,
  [49228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5020), 1,
      sym_block_comment,
    ACTIONS(7054), 2,
      sym__begin_proof_step,
      anon_sym_COMMA,
  [49242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    STATE(5021), 1,
      sym_block_comment,
    STATE(5269), 1,
      sym_pcal_p_algorithm_body,
  [49258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5022), 1,
      sym_block_comment,
    ACTIONS(7334), 2,
      anon_sym_LBRACE,
      anon_sym_begin,
  [49272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8681), 1,
      anon_sym_LT,
    STATE(5), 1,
      sym_proof_step_id,
    STATE(5023), 1,
      sym_block_comment,
  [49288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5024), 1,
      sym_block_comment,
    ACTIONS(8469), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [49302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4512), 1,
      sym_except_update,
    STATE(5025), 1,
      sym_block_comment,
  [49318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5026), 1,
      sym_block_comment,
    ACTIONS(5351), 2,
      sym_identifier,
      anon_sym_BANG,
  [49332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8683), 1,
      anon_sym_LPAREN,
    STATE(5027), 1,
      sym_block_comment,
  [49348] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9), 1,
      anon_sym_DASH_DASH_DASH_DASH,
    STATE(3413), 1,
      sym_single_line,
    STATE(5028), 1,
      sym_block_comment,
  [49364] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5029), 1,
      sym_block_comment,
    ACTIONS(8685), 2,
      sym__bullet,
      sym__dedent,
  [49378] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8263), 1,
      sym_identifier,
    STATE(4993), 1,
      sym_pcal_proc_var_decl,
    STATE(5030), 1,
      sym_block_comment,
  [49394] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4811), 1,
      sym_except_update,
    STATE(5031), 1,
      sym_block_comment,
  [49410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7367), 1,
      anon_sym_or,
    STATE(4207), 1,
      aux_sym_pcal_c_either_repeat1,
    STATE(5032), 1,
      sym_block_comment,
  [49426] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8665), 1,
      sym_identifier,
    STATE(5033), 1,
      sym_block_comment,
    STATE(5454), 1,
      sym__pcal_with_vars,
  [49442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4687), 1,
      sym_except_update,
    STATE(5034), 1,
      sym_block_comment,
  [49458] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8687), 1,
      anon_sym_LPAREN,
    STATE(5035), 1,
      sym_block_comment,
  [49474] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4481), 1,
      anon_sym_begin,
    STATE(5036), 1,
      sym_block_comment,
    STATE(5316), 1,
      sym_pcal_p_algorithm_body,
  [49490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5037), 1,
      sym_block_comment,
    ACTIONS(8440), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [49504] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8689), 1,
      sym_identifier,
    ACTIONS(8691), 1,
      anon_sym_RPAREN,
    STATE(5038), 1,
      sym_block_comment,
  [49520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8612), 1,
      anon_sym_BANG,
    STATE(4770), 1,
      sym_except_update,
    STATE(5039), 1,
      sym_block_comment,
  [49536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8693), 1,
      anon_sym_LPAREN,
    STATE(5040), 1,
      sym_block_comment,
  [49552] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym_identifier,
    STATE(4596), 1,
      sym_pcal_lhs,
    STATE(5041), 1,
      sym_block_comment,
  [49568] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5720), 1,
      anon_sym_LPAREN,
    ACTIONS(5722), 1,
      anon_sym_BANG,
    STATE(5042), 1,
      sym_block_comment,
  [49584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    STATE(5043), 1,
      sym_block_comment,
  [49600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8697), 1,
      anon_sym_LPAREN,
    STATE(5044), 1,
      sym_block_comment,
  [49616] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8699), 1,
      anon_sym_LPAREN,
    STATE(5045), 1,
      sym_block_comment,
  [49632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8701), 1,
      anon_sym_LPAREN,
    STATE(5046), 1,
      sym_block_comment,
  [49648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8703), 1,
      anon_sym_LPAREN,
    STATE(5047), 1,
      sym_block_comment,
  [49664] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8705), 1,
      anon_sym_LPAREN,
    STATE(5048), 1,
      sym_block_comment,
  [49680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8707), 1,
      anon_sym_LPAREN,
    STATE(5049), 1,
      sym_block_comment,
  [49696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6813), 1,
      anon_sym_LPAREN,
    STATE(5050), 1,
      sym_block_comment,
  [49712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8709), 1,
      anon_sym_LPAREN,
    STATE(5051), 1,
      sym_block_comment,
  [49728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8711), 1,
      anon_sym_LPAREN,
    STATE(5052), 1,
      sym_block_comment,
  [49744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6364), 1,
      anon_sym_LPAREN,
    STATE(5053), 1,
      sym_block_comment,
  [49760] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8713), 1,
      anon_sym_LPAREN,
    STATE(5054), 1,
      sym_block_comment,
  [49776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6784), 1,
      anon_sym_LPAREN,
    STATE(5055), 1,
      sym_block_comment,
  [49792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(8715), 1,
      anon_sym_LPAREN,
    STATE(5056), 1,
      sym_block_comment,
  [49808] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(7761), 1,
      anon_sym_LPAREN,
    STATE(5057), 1,
      sym_block_comment,
  [49824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    ACTIONS(6833), 1,
      anon_sym_LPAREN,
    STATE(5058), 1,
      sym_block_comment,
  [49840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    STATE(5059), 1,
      sym_block_comment,
    ACTIONS(6420), 2,
      sym__begin_proof_step,
      anon_sym_COMMA,
  [49854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8717), 1,
      anon_sym_GT,
    STATE(5060), 1,
      sym_block_comment,
  [49867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5575), 1,
      sym_placeholder,
    STATE(5061), 1,
      sym_block_comment,
  [49880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7437), 1,
      anon_sym_RBRACE,
    STATE(5062), 1,
      sym_block_comment,
  [49893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8719), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5063), 1,
      sym_block_comment,
  [49906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8721), 1,
      sym_identifier,
    STATE(5064), 1,
      sym_block_comment,
  [49919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8723), 1,
      anon_sym_algorithm,
    STATE(5065), 1,
      sym_block_comment,
  [49932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8725), 1,
      anon_sym_GT,
    STATE(5066), 1,
      sym_block_comment,
  [49945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8727), 1,
      sym_placeholder,
    STATE(5067), 1,
      sym_block_comment,
  [49958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5738), 1,
      anon_sym_LPAREN,
    STATE(5068), 1,
      sym_block_comment,
  [49971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5579), 1,
      sym_placeholder,
    STATE(5069), 1,
      sym_block_comment,
  [49984] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8729), 1,
      aux_sym_proof_step_id_token2,
    STATE(5070), 1,
      sym_block_comment,
  [49997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5583), 1,
      sym_placeholder,
    STATE(5071), 1,
      sym_block_comment,
  [50010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7279), 1,
      anon_sym_RBRACE,
    STATE(5072), 1,
      sym_block_comment,
  [50023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8731), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5073), 1,
      sym_block_comment,
  [50036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8733), 1,
      anon_sym_algorithm,
    STATE(5074), 1,
      sym_block_comment,
  [50049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7281), 1,
      anon_sym_RBRACE,
    STATE(5075), 1,
      sym_block_comment,
  [50062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8735), 1,
      sym_identifier,
    STATE(5076), 1,
      sym_block_comment,
  [50075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5587), 1,
      sym_placeholder,
    STATE(5077), 1,
      sym_block_comment,
  [50088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8737), 1,
      anon_sym_algorithm,
    STATE(5078), 1,
      sym_block_comment,
  [50101] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8739), 1,
      aux_sym_proof_step_id_token2,
    STATE(5079), 1,
      sym_block_comment,
  [50114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7303), 1,
      anon_sym_RBRACE,
    STATE(5080), 1,
      sym_block_comment,
  [50127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8741), 1,
      aux_sym_binary_number_token1,
    STATE(5081), 1,
      sym_block_comment,
  [50140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5499), 1,
      sym_placeholder,
    STATE(5082), 1,
      sym_block_comment,
  [50153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8743), 1,
      anon_sym_algorithm,
    STATE(5083), 1,
      sym_block_comment,
  [50166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8287), 1,
      aux_sym_octal_number_token1,
    STATE(5084), 1,
      sym_block_comment,
  [50179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8745), 1,
      aux_sym_hex_number_token1,
    STATE(5085), 1,
      sym_block_comment,
  [50192] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8747), 1,
      sym_identifier,
    STATE(5086), 1,
      sym_block_comment,
  [50205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7305), 1,
      anon_sym_RBRACE,
    STATE(5087), 1,
      sym_block_comment,
  [50218] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5750), 1,
      anon_sym_LPAREN,
    STATE(5088), 1,
      sym_block_comment,
  [50231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8749), 1,
      anon_sym_algorithm,
    STATE(5089), 1,
      sym_block_comment,
  [50244] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8751), 1,
      aux_sym_proof_step_id_token3,
    STATE(5090), 1,
      sym_block_comment,
  [50257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8753), 1,
      aux_sym_proof_step_id_token1,
    STATE(5091), 1,
      sym_block_comment,
  [50270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8755), 1,
      sym__notify_pcal_algorithm_start,
    STATE(5092), 1,
      sym_block_comment,
  [50283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8757), 1,
      anon_sym_GT,
    STATE(5093), 1,
      sym_block_comment,
  [50296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8759), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5094), 1,
      sym_block_comment,
  [50309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8604), 1,
      ts_builtin_sym_end,
    STATE(5095), 1,
      sym_block_comment,
  [50322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5591), 1,
      sym_placeholder,
    STATE(5096), 1,
      sym_block_comment,
  [50335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5595), 1,
      sym_placeholder,
    STATE(5097), 1,
      sym_block_comment,
  [50348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8761), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5098), 1,
      sym_block_comment,
  [50361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8763), 1,
      sym_identifier,
    STATE(5099), 1,
      sym_block_comment,
  [50374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8765), 1,
      sym_identifier,
    STATE(5100), 1,
      sym_block_comment,
  [50387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8767), 1,
      anon_sym_algorithm,
    STATE(5101), 1,
      sym_block_comment,
  [50400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8769), 1,
      sym_identifier,
    STATE(5102), 1,
      sym_block_comment,
  [50413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5447), 1,
      sym_placeholder,
    STATE(5103), 1,
      sym_block_comment,
  [50426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8771), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5104), 1,
      sym_block_comment,
  [50439] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8773), 1,
      aux_sym_double_line_token1,
    STATE(5105), 1,
      sym_block_comment,
  [50452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8775), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5106), 1,
      sym_block_comment,
  [50465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8777), 1,
      anon_sym_algorithm,
    STATE(5107), 1,
      sym_block_comment,
  [50478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5599), 1,
      sym_placeholder,
    STATE(5108), 1,
      sym_block_comment,
  [50491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5603), 1,
      sym_placeholder,
    STATE(5109), 1,
      sym_block_comment,
  [50504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5607), 1,
      sym_placeholder,
    STATE(5110), 1,
      sym_block_comment,
  [50517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5479), 1,
      sym_placeholder,
    STATE(5111), 1,
      sym_block_comment,
  [50530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5627), 1,
      sym_placeholder,
    STATE(5112), 1,
      sym_block_comment,
  [50543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8779), 1,
      sym_identifier,
    STATE(5113), 1,
      sym_block_comment,
  [50556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8781), 1,
      anon_sym_LPAREN,
    STATE(5114), 1,
      sym_block_comment,
  [50569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5631), 1,
      sym_placeholder,
    STATE(5115), 1,
      sym_block_comment,
  [50582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8783), 1,
      sym_identifier,
    STATE(5116), 1,
      sym_block_comment,
  [50595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5874), 1,
      anon_sym_LPAREN,
    STATE(5117), 1,
      sym_block_comment,
  [50608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8785), 1,
      aux_sym_binary_number_token1,
    STATE(5118), 1,
      sym_block_comment,
  [50621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6527), 1,
      sym__begin_proof_step,
    STATE(5119), 1,
      sym_block_comment,
  [50634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8787), 1,
      anon_sym_GT,
    STATE(5120), 1,
      sym_block_comment,
  [50647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6531), 1,
      sym__begin_proof_step,
    STATE(5121), 1,
      sym_block_comment,
  [50660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8789), 1,
      anon_sym_LPAREN,
    STATE(5122), 1,
      sym_block_comment,
  [50673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8791), 1,
      anon_sym_end,
    STATE(5123), 1,
      sym_block_comment,
  [50686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5878), 1,
      anon_sym_LPAREN,
    STATE(5124), 1,
      sym_block_comment,
  [50699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8793), 1,
      aux_sym_binary_number_token1,
    STATE(5125), 1,
      sym_block_comment,
  [50712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8795), 1,
      anon_sym_LPAREN,
    STATE(5126), 1,
      sym_block_comment,
  [50725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8797), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5127), 1,
      sym_block_comment,
  [50738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8799), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5128), 1,
      sym_block_comment,
  [50751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7879), 1,
      aux_sym_octal_number_token1,
    STATE(5129), 1,
      sym_block_comment,
  [50764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8801), 1,
      aux_sym_hex_number_token1,
    STATE(5130), 1,
      sym_block_comment,
  [50777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8803), 1,
      sym_identifier,
    STATE(5131), 1,
      sym_block_comment,
  [50790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8805), 1,
      sym_identifier,
    STATE(5132), 1,
      sym_block_comment,
  [50803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8807), 1,
      ts_builtin_sym_end,
    STATE(5133), 1,
      sym_block_comment,
  [50816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5487), 1,
      sym_placeholder,
    STATE(5134), 1,
      sym_block_comment,
  [50829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7421), 1,
      sym_placeholder,
    STATE(5135), 1,
      sym_block_comment,
  [50842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5882), 1,
      anon_sym_LPAREN,
    STATE(5136), 1,
      sym_block_comment,
  [50855] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4284), 1,
      sym_placeholder,
    STATE(5137), 1,
      sym_block_comment,
  [50868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8809), 1,
      anon_sym_process,
    STATE(5138), 1,
      sym_block_comment,
  [50881] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5936), 1,
      anon_sym_LPAREN,
    STATE(5139), 1,
      sym_block_comment,
  [50894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8811), 1,
      sym_identifier,
    STATE(5140), 1,
      sym_block_comment,
  [50907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8813), 1,
      anon_sym_LPAREN,
    STATE(5141), 1,
      sym_block_comment,
  [50920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5639), 1,
      sym_placeholder,
    STATE(5142), 1,
      sym_block_comment,
  [50933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8815), 1,
      sym_identifier,
    STATE(5143), 1,
      sym_block_comment,
  [50946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7336), 1,
      anon_sym_RBRACE,
    STATE(5144), 1,
      sym_block_comment,
  [50959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8817), 1,
      sym_identifier,
    STATE(5145), 1,
      sym_block_comment,
  [50972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7285), 1,
      anon_sym_RBRACE,
    STATE(5146), 1,
      sym_block_comment,
  [50985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8819), 1,
      anon_sym_GT,
    STATE(5147), 1,
      sym_block_comment,
  [50998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8821), 1,
      aux_sym_binary_number_token1,
    STATE(5148), 1,
      sym_block_comment,
  [51011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5780), 1,
      anon_sym_LPAREN,
    STATE(5149), 1,
      sym_block_comment,
  [51024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8823), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5150), 1,
      sym_block_comment,
  [51037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8825), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5151), 1,
      sym_block_comment,
  [51050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8827), 1,
      anon_sym_end,
    STATE(5152), 1,
      sym_block_comment,
  [51063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8829), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5153), 1,
      sym_block_comment,
  [51076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8831), 1,
      sym_identifier,
    STATE(5154), 1,
      sym_block_comment,
  [51089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6463), 1,
      sym__begin_proof_step,
    STATE(5155), 1,
      sym_block_comment,
  [51102] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8833), 1,
      aux_sym_binary_number_token1,
    STATE(5156), 1,
      sym_block_comment,
  [51115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7949), 1,
      aux_sym_octal_number_token1,
    STATE(5157), 1,
      sym_block_comment,
  [51128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8835), 1,
      anon_sym_either,
    STATE(5158), 1,
      sym_block_comment,
  [51141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8837), 1,
      anon_sym_LPAREN,
    STATE(5159), 1,
      sym_block_comment,
  [51154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8839), 1,
      anon_sym_LPAREN,
    STATE(5160), 1,
      sym_block_comment,
  [51167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8841), 1,
      aux_sym_hex_number_token1,
    STATE(5161), 1,
      sym_block_comment,
  [51180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5491), 1,
      sym_placeholder,
    STATE(5162), 1,
      sym_block_comment,
  [51193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5886), 1,
      anon_sym_LPAREN,
    STATE(5163), 1,
      sym_block_comment,
  [51206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5647), 1,
      sym_placeholder,
    STATE(5164), 1,
      sym_block_comment,
  [51219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8843), 1,
      anon_sym_process,
    STATE(5165), 1,
      sym_block_comment,
  [51232] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8845), 1,
      sym_identifier,
    STATE(5166), 1,
      sym_block_comment,
  [51245] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8847), 1,
      sym_identifier,
    STATE(5167), 1,
      sym_block_comment,
  [51258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8095), 1,
      aux_sym_octal_number_token1,
    STATE(5168), 1,
      sym_block_comment,
  [51271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8849), 1,
      anon_sym_SEMI,
    STATE(5169), 1,
      sym_block_comment,
  [51284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8851), 1,
      sym_identifier,
    STATE(5170), 1,
      sym_block_comment,
  [51297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8853), 1,
      sym_identifier,
    STATE(5171), 1,
      sym_block_comment,
  [51310] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8855), 1,
      sym_identifier,
    STATE(5172), 1,
      sym_block_comment,
  [51323] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8857), 1,
      aux_sym_binary_number_token1,
    STATE(5173), 1,
      sym_block_comment,
  [51336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8859), 1,
      anon_sym_GT,
    STATE(5174), 1,
      sym_block_comment,
  [51349] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8861), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5175), 1,
      sym_block_comment,
  [51362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8863), 1,
      aux_sym_hex_number_token1,
    STATE(5176), 1,
      sym_block_comment,
  [51375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8366), 1,
      aux_sym_octal_number_token1,
    STATE(5177), 1,
      sym_block_comment,
  [51388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8865), 1,
      aux_sym_hex_number_token1,
    STATE(5178), 1,
      sym_block_comment,
  [51401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8867), 1,
      sym_identifier,
    STATE(5179), 1,
      sym_block_comment,
  [51414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8869), 1,
      anon_sym_end,
    STATE(5180), 1,
      sym_block_comment,
  [51427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8871), 1,
      sym__begin_proof_step,
    STATE(5181), 1,
      sym_block_comment,
  [51440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5519), 1,
      sym_placeholder,
    STATE(5182), 1,
      sym_block_comment,
  [51453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      sym_placeholder,
    STATE(5183), 1,
      sym_block_comment,
  [51466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7951), 1,
      aux_sym_octal_number_token1,
    STATE(5184), 1,
      sym_block_comment,
  [51479] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8873), 1,
      ts_builtin_sym_end,
    STATE(5185), 1,
      sym_block_comment,
  [51492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8875), 1,
      aux_sym_hex_number_token1,
    STATE(5186), 1,
      sym_block_comment,
  [51505] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4280), 1,
      sym_placeholder,
    STATE(5187), 1,
      sym_block_comment,
  [51518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8877), 1,
      anon_sym_define,
    STATE(5188), 1,
      sym_block_comment,
  [51531] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8879), 1,
      sym_identifier,
    STATE(5189), 1,
      sym_block_comment,
  [51544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8881), 1,
      sym_placeholder,
    STATE(5190), 1,
      sym_block_comment,
  [51557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8883), 1,
      anon_sym_GT,
    STATE(5191), 1,
      sym_block_comment,
  [51570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8885), 1,
      ts_builtin_sym_end,
    STATE(5192), 1,
      sym_block_comment,
  [51583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5611), 1,
      sym_placeholder,
    STATE(5193), 1,
      sym_block_comment,
  [51596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8887), 1,
      sym_identifier,
    STATE(5194), 1,
      sym_block_comment,
  [51609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8889), 1,
      anon_sym_GT,
    STATE(5195), 1,
      sym_block_comment,
  [51622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8891), 1,
      sym_identifier,
    STATE(5196), 1,
      sym_block_comment,
  [51635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8893), 1,
      anon_sym_COLON,
    STATE(5197), 1,
      sym_block_comment,
  [51648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8895), 1,
      sym_identifier,
    STATE(5198), 1,
      sym_block_comment,
  [51661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8897), 1,
      sym_identifier,
    STATE(5199), 1,
      sym_block_comment,
  [51674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8899), 1,
      sym_identifier,
    STATE(5200), 1,
      sym_block_comment,
  [51687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8901), 1,
      anon_sym_GT,
    STATE(5201), 1,
      sym_block_comment,
  [51700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5784), 1,
      anon_sym_LPAREN,
    STATE(5202), 1,
      sym_block_comment,
  [51713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5383), 1,
      sym_placeholder,
    STATE(5203), 1,
      sym_block_comment,
  [51726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5387), 1,
      sym_placeholder,
    STATE(5204), 1,
      sym_block_comment,
  [51739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      ts_builtin_sym_end,
    STATE(5205), 1,
      sym_block_comment,
  [51752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8903), 1,
      sym_identifier,
    STATE(5206), 1,
      sym_block_comment,
  [51765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8905), 1,
      anon_sym_if,
    STATE(5207), 1,
      sym_block_comment,
  [51778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8907), 1,
      aux_sym_binary_number_token1,
    STATE(5208), 1,
      sym_block_comment,
  [51791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8909), 1,
      sym_identifier,
    STATE(5209), 1,
      sym_block_comment,
  [51804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8911), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5210), 1,
      sym_block_comment,
  [51817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5495), 1,
      sym_placeholder,
    STATE(5211), 1,
      sym_block_comment,
  [51830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8913), 1,
      sym_identifier,
    STATE(5212), 1,
      sym_block_comment,
  [51843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8915), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5213), 1,
      sym_block_comment,
  [51856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8917), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5214), 1,
      sym_block_comment,
  [51869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8919), 1,
      sym_identifier,
    STATE(5215), 1,
      sym_block_comment,
  [51882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8921), 1,
      sym_identifier,
    STATE(5216), 1,
      sym_block_comment,
  [51895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8923), 1,
      ts_builtin_sym_end,
    STATE(5217), 1,
      sym_block_comment,
  [51908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8925), 1,
      sym_identifier,
    STATE(5218), 1,
      sym_block_comment,
  [51921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8927), 1,
      anon_sym_algorithm,
    STATE(5219), 1,
      sym_block_comment,
  [51934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8929), 1,
      anon_sym_GT,
    STATE(5220), 1,
      sym_block_comment,
  [51947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8931), 1,
      anon_sym_do,
    STATE(5221), 1,
      sym_block_comment,
  [51960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8933), 1,
      sym_identifier,
    STATE(5222), 1,
      sym_block_comment,
  [51973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8935), 1,
      anon_sym_end,
    STATE(5223), 1,
      sym_block_comment,
  [51986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8937), 1,
      sym_identifier,
    STATE(5224), 1,
      sym_block_comment,
  [51999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8939), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5225), 1,
      sym_block_comment,
  [52012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8941), 1,
      anon_sym_COLON,
    STATE(5226), 1,
      sym_block_comment,
  [52025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8943), 1,
      anon_sym_LPAREN,
    STATE(5227), 1,
      sym_block_comment,
  [52038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7425), 1,
      anon_sym_RBRACE,
    STATE(5228), 1,
      sym_block_comment,
  [52051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8945), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5229), 1,
      sym_block_comment,
  [52064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5371), 1,
      sym_placeholder,
    STATE(5230), 1,
      sym_block_comment,
  [52077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5395), 1,
      sym_placeholder,
    STATE(5231), 1,
      sym_block_comment,
  [52090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7355), 1,
      anon_sym_end,
    STATE(5232), 1,
      sym_block_comment,
  [52103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8947), 1,
      anon_sym_algorithm,
    STATE(5233), 1,
      sym_block_comment,
  [52116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8949), 1,
      aux_sym_hex_number_token1,
    STATE(5234), 1,
      sym_block_comment,
  [52129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4230), 1,
      sym__begin_proof_step,
    STATE(5235), 1,
      sym_block_comment,
  [52142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5403), 1,
      sym_placeholder,
    STATE(5236), 1,
      sym_block_comment,
  [52155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8951), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5237), 1,
      sym_block_comment,
  [52168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8619), 1,
      ts_builtin_sym_end,
    STATE(5238), 1,
      sym_block_comment,
  [52181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8953), 1,
      sym_identifier,
    STATE(5239), 1,
      sym_block_comment,
  [52194] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8574), 1,
      sym_identifier,
    STATE(5240), 1,
      sym_block_comment,
  [52207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8955), 1,
      sym_identifier,
    STATE(5241), 1,
      sym_block_comment,
  [52220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8957), 1,
      sym_identifier,
    STATE(5242), 1,
      sym_block_comment,
  [52233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8959), 1,
      anon_sym_COLON,
    STATE(5243), 1,
      sym_block_comment,
  [52246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8961), 1,
      anon_sym_LPAREN,
    STATE(5244), 1,
      sym_block_comment,
  [52259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8963), 1,
      anon_sym_algorithm,
    STATE(5245), 1,
      sym_block_comment,
  [52272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8641), 1,
      anon_sym_LPAREN,
    STATE(5246), 1,
      sym_block_comment,
  [52285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8965), 1,
      anon_sym_BANG,
    STATE(5247), 1,
      sym_block_comment,
  [52298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8967), 1,
      sym_identifier,
    STATE(5248), 1,
      sym_block_comment,
  [52311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7435), 1,
      anon_sym_end,
    STATE(5249), 1,
      sym_block_comment,
  [52324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7283), 1,
      anon_sym_end,
    STATE(5250), 1,
      sym_block_comment,
  [52337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8969), 1,
      sym_identifier,
    STATE(5251), 1,
      sym_block_comment,
  [52350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7277), 1,
      anon_sym_end,
    STATE(5252), 1,
      sym_block_comment,
  [52363] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8971), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5253), 1,
      sym_block_comment,
  [52376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8973), 1,
      sym_identifier,
    STATE(5254), 1,
      sym_block_comment,
  [52389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5411), 1,
      sym_placeholder,
    STATE(5255), 1,
      sym_block_comment,
  [52402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4288), 1,
      sym_placeholder,
    STATE(5256), 1,
      sym_block_comment,
  [52415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7252), 1,
      anon_sym_end,
    STATE(5257), 1,
      sym_block_comment,
  [52428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5427), 1,
      sym_placeholder,
    STATE(5258), 1,
      sym_block_comment,
  [52441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5635), 1,
      sym_placeholder,
    STATE(5259), 1,
      sym_block_comment,
  [52454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8975), 1,
      anon_sym_GT,
    STATE(5260), 1,
      sym_block_comment,
  [52467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8977), 1,
      aux_sym_binary_number_token1,
    STATE(5261), 1,
      sym_block_comment,
  [52480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7262), 1,
      anon_sym_end,
    STATE(5262), 1,
      sym_block_comment,
  [52493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8979), 1,
      sym_identifier,
    STATE(5263), 1,
      sym_block_comment,
  [52506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8981), 1,
      anon_sym_GT,
    STATE(5264), 1,
      sym_block_comment,
  [52519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8983), 1,
      anon_sym_end,
    STATE(5265), 1,
      sym_block_comment,
  [52532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8433), 1,
      aux_sym_octal_number_token1,
    STATE(5266), 1,
      sym_block_comment,
  [52545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7266), 1,
      anon_sym_end,
    STATE(5267), 1,
      sym_block_comment,
  [52558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8985), 1,
      aux_sym_binary_number_token1,
    STATE(5268), 1,
      sym_block_comment,
  [52571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8987), 1,
      anon_sym_end,
    STATE(5269), 1,
      sym_block_comment,
  [52584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7270), 1,
      anon_sym_end,
    STATE(5270), 1,
      sym_block_comment,
  [52597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8435), 1,
      aux_sym_octal_number_token1,
    STATE(5271), 1,
      sym_block_comment,
  [52610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8989), 1,
      aux_sym_hex_number_token1,
    STATE(5272), 1,
      sym_block_comment,
  [52623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8991), 1,
      aux_sym_hex_number_token1,
    STATE(5273), 1,
      sym_block_comment,
  [52636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8993), 1,
      sym_identifier,
    STATE(5274), 1,
      sym_block_comment,
  [52649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8995), 1,
      sym_identifier,
    STATE(5275), 1,
      sym_block_comment,
  [52662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5694), 1,
      anon_sym_BANG,
    STATE(5276), 1,
      sym_block_comment,
  [52675] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8997), 1,
      aux_sym_proof_step_id_token3,
    STATE(5277), 1,
      sym_block_comment,
  [52688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8999), 1,
      sym_identifier,
    STATE(5278), 1,
      sym_block_comment,
  [52701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5375), 1,
      sym_placeholder,
    STATE(5279), 1,
      sym_block_comment,
  [52714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5467), 1,
      sym_placeholder,
    STATE(5280), 1,
      sym_block_comment,
  [52727] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4269), 1,
      sym_placeholder,
    STATE(5281), 1,
      sym_block_comment,
  [52740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6467), 1,
      sym__begin_proof_step,
    STATE(5282), 1,
      sym_block_comment,
  [52753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6475), 1,
      sym__begin_proof_step,
    STATE(5283), 1,
      sym_block_comment,
  [52766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5419), 1,
      sym_placeholder,
    STATE(5284), 1,
      sym_block_comment,
  [52779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9001), 1,
      anon_sym_macro,
    STATE(5285), 1,
      sym_block_comment,
  [52792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7353), 1,
      anon_sym_end,
    STATE(5286), 1,
      sym_block_comment,
  [52805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9003), 1,
      anon_sym_COLON,
    STATE(5287), 1,
      sym_block_comment,
  [52818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9005), 1,
      anon_sym_LPAREN,
    STATE(5288), 1,
      sym_block_comment,
  [52831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9007), 1,
      anon_sym_procedure,
    STATE(5289), 1,
      sym_block_comment,
  [52844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7423), 1,
      anon_sym_LPAREN,
    STATE(5290), 1,
      sym_block_comment,
  [52857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9009), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5291), 1,
      sym_block_comment,
  [52870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9011), 1,
      ts_builtin_sym_end,
    STATE(5292), 1,
      sym_block_comment,
  [52883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9013), 1,
      sym__begin_proof_step,
    STATE(5293), 1,
      sym_block_comment,
  [52896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5435), 1,
      sym_placeholder,
    STATE(5294), 1,
      sym_block_comment,
  [52909] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9015), 1,
      sym_identifier,
    STATE(5295), 1,
      sym_block_comment,
  [52922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9017), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5296), 1,
      sym_block_comment,
  [52935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5407), 1,
      sym_placeholder,
    STATE(5297), 1,
      sym_block_comment,
  [52948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5503), 1,
      sym_placeholder,
    STATE(5298), 1,
      sym_block_comment,
  [52961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9019), 1,
      sym_identifier,
    STATE(5299), 1,
      sym_block_comment,
  [52974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9021), 1,
      anon_sym_algorithm,
    STATE(5300), 1,
      sym_block_comment,
  [52987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5798), 1,
      anon_sym_BANG,
    STATE(5301), 1,
      sym_block_comment,
  [53000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9023), 1,
      anon_sym_end,
    STATE(5302), 1,
      sym_block_comment,
  [53013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9025), 1,
      anon_sym_COLON,
    STATE(5303), 1,
      sym_block_comment,
  [53026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9027), 1,
      anon_sym_LPAREN,
    STATE(5304), 1,
      sym_block_comment,
  [53039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5399), 1,
      sym_placeholder,
    STATE(5305), 1,
      sym_block_comment,
  [53052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8673), 1,
      anon_sym_LPAREN,
    STATE(5306), 1,
      sym_block_comment,
  [53065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9029), 1,
      anon_sym_process,
    STATE(5307), 1,
      sym_block_comment,
  [53078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5507), 1,
      sym_placeholder,
    STATE(5308), 1,
      sym_block_comment,
  [53091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9031), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5309), 1,
      sym_block_comment,
  [53104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9033), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5310), 1,
      sym_block_comment,
  [53117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9035), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5311), 1,
      sym_block_comment,
  [53130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9037), 1,
      anon_sym_end,
    STATE(5312), 1,
      sym_block_comment,
  [53143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5463), 1,
      sym_placeholder,
    STATE(5313), 1,
      sym_block_comment,
  [53156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9039), 1,
      sym_identifier,
    STATE(5314), 1,
      sym_block_comment,
  [53169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9041), 1,
      anon_sym_process,
    STATE(5315), 1,
      sym_block_comment,
  [53182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9043), 1,
      anon_sym_end,
    STATE(5316), 1,
      sym_block_comment,
  [53195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9045), 1,
      anon_sym_COLON,
    STATE(5317), 1,
      sym_block_comment,
  [53208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9047), 1,
      anon_sym_LPAREN,
    STATE(5318), 1,
      sym_block_comment,
  [53221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9049), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5319), 1,
      sym_block_comment,
  [53234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8679), 1,
      anon_sym_LPAREN,
    STATE(5320), 1,
      sym_block_comment,
  [53247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5511), 1,
      sym_placeholder,
    STATE(5321), 1,
      sym_block_comment,
  [53260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9051), 1,
      anon_sym_process,
    STATE(5322), 1,
      sym_block_comment,
  [53273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6535), 1,
      sym__begin_proof_step,
    STATE(5323), 1,
      sym_block_comment,
  [53286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9053), 1,
      anon_sym_process,
    STATE(5324), 1,
      sym_block_comment,
  [53299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9055), 1,
      anon_sym_GT,
    STATE(5325), 1,
      sym_block_comment,
  [53312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5746), 1,
      anon_sym_LPAREN,
    STATE(5326), 1,
      sym_block_comment,
  [53325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5708), 1,
      anon_sym_BANG,
    STATE(5327), 1,
      sym_block_comment,
  [53338] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9057), 1,
      anon_sym_COLON,
    STATE(5328), 1,
      sym_block_comment,
  [53351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9059), 1,
      anon_sym_LPAREN,
    STATE(5329), 1,
      sym_block_comment,
  [53364] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5515), 1,
      sym_placeholder,
    STATE(5330), 1,
      sym_block_comment,
  [53377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6491), 1,
      sym__begin_proof_step,
    STATE(5331), 1,
      sym_block_comment,
  [53390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9061), 1,
      sym_identifier,
    STATE(5332), 1,
      sym_block_comment,
  [53403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7318), 1,
      anon_sym_end,
    STATE(5333), 1,
      sym_block_comment,
  [53416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9063), 1,
      sym_placeholder,
    STATE(5334), 1,
      sym_block_comment,
  [53429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9065), 1,
      aux_sym_binary_number_token1,
    STATE(5335), 1,
      sym_block_comment,
  [53442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9067), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5336), 1,
      sym_block_comment,
  [53455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5471), 1,
      sym_placeholder,
    STATE(5337), 1,
      sym_block_comment,
  [53468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5523), 1,
      sym_placeholder,
    STATE(5338), 1,
      sym_block_comment,
  [53481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9069), 1,
      anon_sym_COLON,
    STATE(5339), 1,
      sym_block_comment,
  [53494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9071), 1,
      anon_sym_LPAREN,
    STATE(5340), 1,
      sym_block_comment,
  [53507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5792), 1,
      anon_sym_LPAREN,
    STATE(5341), 1,
      sym_block_comment,
  [53520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8687), 1,
      anon_sym_LPAREN,
    STATE(5342), 1,
      sym_block_comment,
  [53533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9073), 1,
      anon_sym_if,
    STATE(5343), 1,
      sym_block_comment,
  [53546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9075), 1,
      anon_sym_end,
    STATE(5344), 1,
      sym_block_comment,
  [53559] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9077), 1,
      anon_sym_if,
    STATE(5345), 1,
      sym_block_comment,
  [53572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9079), 1,
      aux_sym_binary_number_token1,
    STATE(5346), 1,
      sym_block_comment,
  [53585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9081), 1,
      aux_sym_binary_number_token1,
    STATE(5347), 1,
      sym_block_comment,
  [53598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9083), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5348), 1,
      sym_block_comment,
  [53611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5796), 1,
      anon_sym_LPAREN,
    STATE(5349), 1,
      sym_block_comment,
  [53624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9085), 1,
      anon_sym_COLON,
    STATE(5350), 1,
      sym_block_comment,
  [53637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9087), 1,
      anon_sym_LPAREN,
    STATE(5351), 1,
      sym_block_comment,
  [53650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5846), 1,
      anon_sym_BANG,
    STATE(5352), 1,
      sym_block_comment,
  [53663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8697), 1,
      anon_sym_LPAREN,
    STATE(5353), 1,
      sym_block_comment,
  [53676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9089), 1,
      anon_sym_end,
    STATE(5354), 1,
      sym_block_comment,
  [53689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5527), 1,
      sym_placeholder,
    STATE(5355), 1,
      sym_block_comment,
  [53702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9091), 1,
      sym_identifier,
    STATE(5356), 1,
      sym_block_comment,
  [53715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9093), 1,
      sym__begin_proof_step,
    STATE(5357), 1,
      sym_block_comment,
  [53728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5531), 1,
      sym_placeholder,
    STATE(5358), 1,
      sym_block_comment,
  [53741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5475), 1,
      sym_placeholder,
    STATE(5359), 1,
      sym_block_comment,
  [53754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9095), 1,
      sym_identifier,
    STATE(5360), 1,
      sym_block_comment,
  [53767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9097), 1,
      anon_sym_COLON,
    STATE(5361), 1,
      sym_block_comment,
  [53780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9099), 1,
      anon_sym_LPAREN,
    STATE(5362), 1,
      sym_block_comment,
  [53793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5651), 1,
      sym_placeholder,
    STATE(5363), 1,
      sym_block_comment,
  [53806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6815), 1,
      anon_sym_LPAREN,
    STATE(5364), 1,
      sym_block_comment,
  [53819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9101), 1,
      sym_identifier,
    STATE(5365), 1,
      sym_block_comment,
  [53832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9103), 1,
      sym_identifier,
    STATE(5366), 1,
      sym_block_comment,
  [53845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9105), 1,
      sym_identifier,
    STATE(5367), 1,
      sym_block_comment,
  [53858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9107), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5368), 1,
      sym_block_comment,
  [53871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5539), 1,
      sym_placeholder,
    STATE(5369), 1,
      sym_block_comment,
  [53884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5543), 1,
      sym_placeholder,
    STATE(5370), 1,
      sym_block_comment,
  [53897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7841), 1,
      aux_sym_octal_number_token1,
    STATE(5371), 1,
      sym_block_comment,
  [53910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9109), 1,
      anon_sym_COLON,
    STATE(5372), 1,
      sym_block_comment,
  [53923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9111), 1,
      anon_sym_LPAREN,
    STATE(5373), 1,
      sym_block_comment,
  [53936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8177), 1,
      aux_sym_octal_number_token1,
    STATE(5374), 1,
      sym_block_comment,
  [53949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8614), 1,
      anon_sym_LPAREN,
    STATE(5375), 1,
      sym_block_comment,
  [53962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9113), 1,
      anon_sym_GT,
    STATE(5376), 1,
      sym_block_comment,
  [53975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9115), 1,
      sym_placeholder,
    STATE(5377), 1,
      sym_block_comment,
  [53988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9117), 1,
      sym_identifier,
    STATE(5378), 1,
      sym_block_comment,
  [54001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9119), 1,
      aux_sym_hex_number_token1,
    STATE(5379), 1,
      sym_block_comment,
  [54014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9121), 1,
      anon_sym_while,
    STATE(5380), 1,
      sym_block_comment,
  [54027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9123), 1,
      anon_sym_EQ,
    STATE(5381), 1,
      sym_block_comment,
  [54040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9125), 1,
      sym_identifier,
    STATE(5382), 1,
      sym_block_comment,
  [54053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9127), 1,
      anon_sym_COLON,
    STATE(5383), 1,
      sym_block_comment,
  [54066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9129), 1,
      anon_sym_LPAREN,
    STATE(5384), 1,
      sym_block_comment,
  [54079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9131), 1,
      anon_sym_LPAREN,
    STATE(5385), 1,
      sym_block_comment,
  [54092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8576), 1,
      anon_sym_LPAREN,
    STATE(5386), 1,
      sym_block_comment,
  [54105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7431), 1,
      aux_sym_octal_number_token1,
    STATE(5387), 1,
      sym_block_comment,
  [54118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5555), 1,
      sym_placeholder,
    STATE(5388), 1,
      sym_block_comment,
  [54131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8633), 1,
      ts_builtin_sym_end,
    STATE(5389), 1,
      sym_block_comment,
  [54144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9133), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5390), 1,
      sym_block_comment,
  [54157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9135), 1,
      aux_sym_hex_number_token1,
    STATE(5391), 1,
      sym_block_comment,
  [54170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5706), 1,
      anon_sym_LPAREN,
    STATE(5392), 1,
      sym_block_comment,
  [54183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9137), 1,
      aux_sym_hex_number_token1,
    STATE(5393), 1,
      sym_block_comment,
  [54196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9139), 1,
      anon_sym_COLON,
    STATE(5394), 1,
      sym_block_comment,
  [54209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9141), 1,
      anon_sym_LPAREN,
    STATE(5395), 1,
      sym_block_comment,
  [54222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9143), 1,
      aux_sym_binary_number_token1,
    STATE(5396), 1,
      sym_block_comment,
  [54235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6348), 1,
      anon_sym_LPAREN,
    STATE(5397), 1,
      sym_block_comment,
  [54248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6344), 1,
      anon_sym_LPAREN,
    STATE(5398), 1,
      sym_block_comment,
  [54261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6346), 1,
      anon_sym_LPAREN,
    STATE(5399), 1,
      sym_block_comment,
  [54274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9145), 1,
      aux_sym_binary_number_token1,
    STATE(5400), 1,
      sym_block_comment,
  [54287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5535), 1,
      sym_placeholder,
    STATE(5401), 1,
      sym_block_comment,
  [54300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9147), 1,
      anon_sym_MODULE,
    STATE(5402), 1,
      sym_block_comment,
  [54313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5547), 1,
      sym_placeholder,
    STATE(5403), 1,
      sym_block_comment,
  [54326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8520), 1,
      aux_sym_octal_number_token1,
    STATE(5404), 1,
      sym_block_comment,
  [54339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9149), 1,
      anon_sym_COLON,
    STATE(5405), 1,
      sym_block_comment,
  [54352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9151), 1,
      anon_sym_LPAREN,
    STATE(5406), 1,
      sym_block_comment,
  [54365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7322), 1,
      anon_sym_RBRACE,
    STATE(5407), 1,
      sym_block_comment,
  [54378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8637), 1,
      anon_sym_LPAREN,
    STATE(5408), 1,
      sym_block_comment,
  [54391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9153), 1,
      aux_sym_hex_number_token1,
    STATE(5409), 1,
      sym_block_comment,
  [54404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5379), 1,
      sym_placeholder,
    STATE(5410), 1,
      sym_block_comment,
  [54417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9155), 1,
      ts_builtin_sym_end,
    STATE(5411), 1,
      sym_block_comment,
  [54430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5451), 1,
      sym_placeholder,
    STATE(5412), 1,
      sym_block_comment,
  [54443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9157), 1,
      sym_identifier,
    STATE(5413), 1,
      sym_block_comment,
  [54456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9159), 1,
      sym_identifier,
    STATE(5414), 1,
      sym_block_comment,
  [54469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8205), 1,
      aux_sym_octal_number_token1,
    STATE(5415), 1,
      sym_block_comment,
  [54482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9161), 1,
      anon_sym_COLON,
    STATE(5416), 1,
      sym_block_comment,
  [54495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9163), 1,
      anon_sym_LPAREN,
    STATE(5417), 1,
      sym_block_comment,
  [54508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9165), 1,
      sym_identifier,
    STATE(5418), 1,
      sym_block_comment,
  [54521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6798), 1,
      anon_sym_LPAREN,
    STATE(5419), 1,
      sym_block_comment,
  [54534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9167), 1,
      aux_sym_hex_number_token1,
    STATE(5420), 1,
      sym_block_comment,
  [54547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9169), 1,
      sym_identifier,
    STATE(5421), 1,
      sym_block_comment,
  [54560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9171), 1,
      sym_identifier,
    STATE(5422), 1,
      sym_block_comment,
  [54573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7433), 1,
      anon_sym_RBRACE,
    STATE(5423), 1,
      sym_block_comment,
  [54586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9173), 1,
      sym_identifier,
    STATE(5424), 1,
      sym_block_comment,
  [54599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9175), 1,
      anon_sym_GT,
    STATE(5425), 1,
      sym_block_comment,
  [54612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5559), 1,
      sym_placeholder,
    STATE(5426), 1,
      sym_block_comment,
  [54625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9177), 1,
      anon_sym_COLON,
    STATE(5427), 1,
      sym_block_comment,
  [54638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9179), 1,
      anon_sym_LPAREN,
    STATE(5428), 1,
      sym_block_comment,
  [54651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9181), 1,
      sym__notify_pcal_algorithm_start,
    STATE(5429), 1,
      sym_block_comment,
  [54664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8649), 1,
      anon_sym_LPAREN,
    STATE(5430), 1,
      sym_block_comment,
  [54677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9183), 1,
      sym_identifier,
    STATE(5431), 1,
      sym_block_comment,
  [54690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5415), 1,
      sym_placeholder,
    STATE(5432), 1,
      sym_block_comment,
  [54703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9185), 1,
      sym_identifier,
    STATE(5433), 1,
      sym_block_comment,
  [54716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5439), 1,
      sym_placeholder,
    STATE(5434), 1,
      sym_block_comment,
  [54729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9187), 1,
      sym_identifier,
    STATE(5435), 1,
      sym_block_comment,
  [54742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9189), 1,
      sym_identifier,
    STATE(5436), 1,
      sym_block_comment,
  [54755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5774), 1,
      anon_sym_LPAREN,
    STATE(5437), 1,
      sym_block_comment,
  [54768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9191), 1,
      anon_sym_COLON,
    STATE(5438), 1,
      sym_block_comment,
  [54781] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9193), 1,
      anon_sym_LPAREN,
    STATE(5439), 1,
      sym_block_comment,
  [54794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9195), 1,
      sym_identifier,
    STATE(5440), 1,
      sym_block_comment,
  [54807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7759), 1,
      anon_sym_LPAREN,
    STATE(5441), 1,
      sym_block_comment,
  [54820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9197), 1,
      sym__begin_proof_step,
    STATE(5442), 1,
      sym_block_comment,
  [54833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6513), 1,
      sym__begin_proof_step,
    STATE(5443), 1,
      sym_block_comment,
  [54846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9199), 1,
      sym_identifier,
    STATE(5444), 1,
      sym_block_comment,
  [54859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6517), 1,
      sym__begin_proof_step,
    STATE(5445), 1,
      sym_block_comment,
  [54872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9201), 1,
      anon_sym_process,
    STATE(5446), 1,
      sym_block_comment,
  [54885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9203), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5447), 1,
      sym_block_comment,
  [54898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      anon_sym_COLON,
    STATE(5448), 1,
      sym_block_comment,
  [54911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6829), 1,
      anon_sym_LPAREN,
    STATE(5449), 1,
      sym_block_comment,
  [54924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5812), 1,
      anon_sym_LPAREN,
    STATE(5450), 1,
      sym_block_comment,
  [54937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9207), 1,
      sym_identifier,
    STATE(5451), 1,
      sym_block_comment,
  [54950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9209), 1,
      sym_identifier,
    STATE(5452), 1,
      sym_block_comment,
  [54963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9211), 1,
      sym_identifier,
    STATE(5453), 1,
      sym_block_comment,
  [54976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9213), 1,
      anon_sym_RPAREN,
    STATE(5454), 1,
      sym_block_comment,
  [54989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9215), 1,
      sym_identifier,
    STATE(5455), 1,
      sym_block_comment,
  [55002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9217), 1,
      aux_sym_binary_number_token1,
    STATE(5456), 1,
      sym_block_comment,
  [55015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9219), 1,
      ts_builtin_sym_end,
    STATE(5457), 1,
      sym_block_comment,
  [55028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6233), 1,
      sym_placeholder,
    STATE(5458), 1,
      sym_block_comment,
  [55041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9221), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5459), 1,
      sym_block_comment,
  [55054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      ts_builtin_sym_end,
    STATE(5460), 1,
      sym_block_comment,
  [55067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9223), 1,
      anon_sym_BANG,
    STATE(5461), 1,
      sym_block_comment,
  [55080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9225), 1,
      sym_identifier,
    STATE(5462), 1,
      sym_block_comment,
  [55093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7289), 1,
      aux_sym_octal_number_token1,
    STATE(5463), 1,
      sym_block_comment,
  [55106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9227), 1,
      aux_sym_hex_number_token1,
    STATE(5464), 1,
      sym_block_comment,
  [55119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5423), 1,
      sym_placeholder,
    STATE(5465), 1,
      sym_block_comment,
  [55132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9229), 1,
      aux_sym_proof_step_id_token1,
    STATE(5466), 1,
      sym_block_comment,
  [55145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym_identifier,
    STATE(5467), 1,
      sym_block_comment,
  [55158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5816), 1,
      anon_sym_LPAREN,
    STATE(5468), 1,
      sym_block_comment,
  [55171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5692), 1,
      anon_sym_BANG,
    STATE(5469), 1,
      sym_block_comment,
  [55184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9233), 1,
      sym_identifier,
    STATE(5470), 1,
      sym_block_comment,
  [55197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5914), 1,
      anon_sym_LPAREN,
    STATE(5471), 1,
      sym_block_comment,
  [55210] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9235), 1,
      anon_sym_GT,
    STATE(5472), 1,
      sym_block_comment,
  [55223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9237), 1,
      sym_placeholder,
    STATE(5473), 1,
      sym_block_comment,
  [55236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9239), 1,
      anon_sym_GT,
    STATE(5474), 1,
      sym_block_comment,
  [55249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      anon_sym_if,
    STATE(5475), 1,
      sym_block_comment,
  [55262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5820), 1,
      anon_sym_LPAREN,
    STATE(5476), 1,
      sym_block_comment,
  [55275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9243), 1,
      sym_placeholder,
    STATE(5477), 1,
      sym_block_comment,
  [55288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9245), 1,
      sym_identifier,
    STATE(5478), 1,
      sym_block_comment,
  [55301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5824), 1,
      anon_sym_LPAREN,
    STATE(5479), 1,
      sym_block_comment,
  [55314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9247), 1,
      anon_sym_LPAREN,
    STATE(5480), 1,
      sym_block_comment,
  [55327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9250), 1,
      ts_builtin_sym_end,
    STATE(5481), 1,
      sym_block_comment,
  [55340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5828), 1,
      anon_sym_LPAREN,
    STATE(5482), 1,
      sym_block_comment,
  [55353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9252), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5483), 1,
      sym_block_comment,
  [55366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5932), 1,
      anon_sym_LPAREN,
    STATE(5484), 1,
      sym_block_comment,
  [55379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9254), 1,
      sym__begin_proof_step,
    STATE(5485), 1,
      sym_block_comment,
  [55392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9256), 1,
      anon_sym_GT,
    STATE(5486), 1,
      sym_block_comment,
  [55405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9219), 1,
      ts_builtin_sym_end,
    STATE(5487), 1,
      sym_block_comment,
  [55418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5551), 1,
      sym_placeholder,
    STATE(5488), 1,
      sym_block_comment,
  [55431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9258), 1,
      sym__begin_proof_step,
    STATE(5489), 1,
      sym_block_comment,
  [55444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9260), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5490), 1,
      sym_block_comment,
  [55457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7785), 1,
      aux_sym_octal_number_token1,
    STATE(5491), 1,
      sym_block_comment,
  [55470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9262), 1,
      aux_sym_proof_step_ref_token2,
    STATE(5492), 1,
      sym_block_comment,
  [55483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5563), 1,
      sym_placeholder,
    STATE(5493), 1,
      sym_block_comment,
  [55496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9264), 1,
      sym_identifier,
    STATE(5494), 1,
      sym_block_comment,
  [55509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9266), 1,
      sym_identifier,
    STATE(5495), 1,
      sym_block_comment,
  [55522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9268), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5496), 1,
      sym_block_comment,
  [55535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9270), 1,
      anon_sym_end,
    STATE(5497), 1,
      sym_block_comment,
  [55548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9272), 1,
      anon_sym_end,
    STATE(5498), 1,
      sym_block_comment,
  [55561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9274), 1,
      anon_sym_COLON,
    STATE(5499), 1,
      sym_block_comment,
  [55574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9276), 1,
      sym_identifier,
    STATE(5500), 1,
      sym_block_comment,
  [55587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5832), 1,
      anon_sym_LPAREN,
    STATE(5501), 1,
      sym_block_comment,
  [55600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      anon_sym_LPAREN,
    STATE(5502), 1,
      sym_block_comment,
  [55613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9278), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5503), 1,
      sym_block_comment,
  [55626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9280), 1,
      aux_sym_binary_number_token1,
    STATE(5504), 1,
      sym_block_comment,
  [55639] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9282), 1,
      aux_sym_double_line_token1,
    STATE(5505), 1,
      sym_block_comment,
  [55652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9284), 1,
      anon_sym_process,
    STATE(5506), 1,
      sym_block_comment,
  [55665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8594), 1,
      aux_sym_octal_number_token1,
    STATE(5507), 1,
      sym_block_comment,
  [55678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9286), 1,
      aux_sym_hex_number_token1,
    STATE(5508), 1,
      sym_block_comment,
  [55691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9288), 1,
      anon_sym_LBRACE,
    STATE(5509), 1,
      sym_block_comment,
  [55704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9290), 1,
      anon_sym_LPAREN,
    STATE(5510), 1,
      sym_block_comment,
  [55717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9292), 1,
      anon_sym_GT,
    STATE(5511), 1,
      sym_block_comment,
  [55730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5916), 1,
      anon_sym_BANG,
    STATE(5512), 1,
      sym_block_comment,
  [55743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9294), 1,
      sym_identifier,
    STATE(5513), 1,
      sym_block_comment,
  [55756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5920), 1,
      anon_sym_BANG,
    STATE(5514), 1,
      sym_block_comment,
  [55769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8693), 1,
      anon_sym_LPAREN,
    STATE(5515), 1,
      sym_block_comment,
  [55782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5567), 1,
      sym_placeholder,
    STATE(5516), 1,
      sym_block_comment,
  [55795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9296), 1,
      sym_identifier,
    STATE(5517), 1,
      sym_block_comment,
  [55808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9298), 1,
      sym_identifier,
    STATE(5518), 1,
      sym_block_comment,
  [55821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7701), 1,
      anon_sym_LPAREN,
    STATE(5519), 1,
      sym_block_comment,
  [55834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5926), 1,
      anon_sym_BANG,
    STATE(5520), 1,
      sym_block_comment,
  [55847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5930), 1,
      anon_sym_BANG,
    STATE(5521), 1,
      sym_block_comment,
  [55860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8699), 1,
      anon_sym_LPAREN,
    STATE(5522), 1,
      sym_block_comment,
  [55873] = 4,
    ACTIONS(6902), 1,
      sym_comment,
    ACTIONS(6904), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9300), 1,
      aux_sym_single_line_token1,
    STATE(5523), 1,
      sym_block_comment,
  [55886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8701), 1,
      anon_sym_LPAREN,
    STATE(5524), 1,
      sym_block_comment,
  [55899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9302), 1,
      anon_sym_with,
    STATE(5525), 1,
      sym_block_comment,
  [55912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8703), 1,
      anon_sym_LPAREN,
    STATE(5526), 1,
      sym_block_comment,
  [55925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9304), 1,
      sym_identifier,
    STATE(5527), 1,
      sym_block_comment,
  [55938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8705), 1,
      anon_sym_LPAREN,
    STATE(5528), 1,
      sym_block_comment,
  [55951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9306), 1,
      anon_sym_LPAREN,
    STATE(5529), 1,
      sym_block_comment,
  [55964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8707), 1,
      anon_sym_LPAREN,
    STATE(5530), 1,
      sym_block_comment,
  [55977] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6503), 1,
      sym__begin_proof_step,
    STATE(5531), 1,
      sym_block_comment,
  [55990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6813), 1,
      anon_sym_LPAREN,
    STATE(5532), 1,
      sym_block_comment,
  [56003] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9308), 1,
      sym__notify_pcal_algorithm_end,
    STATE(5533), 1,
      sym_block_comment,
  [56016] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8709), 1,
      anon_sym_LPAREN,
    STATE(5534), 1,
      sym_block_comment,
  [56029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6338), 1,
      sym__begin_proof_step,
    STATE(5535), 1,
      sym_block_comment,
  [56042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8711), 1,
      anon_sym_LPAREN,
    STATE(5536), 1,
      sym_block_comment,
  [56055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5443), 1,
      sym_placeholder,
    STATE(5537), 1,
      sym_block_comment,
  [56068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6364), 1,
      anon_sym_LPAREN,
    STATE(5538), 1,
      sym_block_comment,
  [56081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5483), 1,
      sym_placeholder,
    STATE(5539), 1,
      sym_block_comment,
  [56094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8713), 1,
      anon_sym_LPAREN,
    STATE(5540), 1,
      sym_block_comment,
  [56107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6483), 1,
      sym__begin_proof_step,
    STATE(5541), 1,
      sym_block_comment,
  [56120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6784), 1,
      anon_sym_LPAREN,
    STATE(5542), 1,
      sym_block_comment,
  [56133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5571), 1,
      sym_placeholder,
    STATE(5543), 1,
      sym_block_comment,
  [56146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8715), 1,
      anon_sym_LPAREN,
    STATE(5544), 1,
      sym_block_comment,
  [56159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5391), 1,
      sym_placeholder,
    STATE(5545), 1,
      sym_block_comment,
  [56172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7761), 1,
      anon_sym_LPAREN,
    STATE(5546), 1,
      sym_block_comment,
  [56185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9310), 1,
      sym_identifier,
    STATE(5547), 1,
      sym_block_comment,
  [56198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6833), 1,
      anon_sym_LPAREN,
    STATE(5548), 1,
      sym_block_comment,
  [56211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8683), 1,
      anon_sym_LPAREN,
    STATE(5549), 1,
      sym_block_comment,
  [56224] = 1,
    ACTIONS(9312), 1,
      ts_builtin_sym_end,
  [56228] = 1,
    ACTIONS(9314), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(3425)] = 0,
  [SMALL_STATE(3426)] = 66,
  [SMALL_STATE(3427)] = 132,
  [SMALL_STATE(3428)] = 196,
  [SMALL_STATE(3429)] = 260,
  [SMALL_STATE(3430)] = 324,
  [SMALL_STATE(3431)] = 388,
  [SMALL_STATE(3432)] = 452,
  [SMALL_STATE(3433)] = 516,
  [SMALL_STATE(3434)] = 580,
  [SMALL_STATE(3435)] = 644,
  [SMALL_STATE(3436)] = 708,
  [SMALL_STATE(3437)] = 772,
  [SMALL_STATE(3438)] = 836,
  [SMALL_STATE(3439)] = 900,
  [SMALL_STATE(3440)] = 964,
  [SMALL_STATE(3441)] = 1028,
  [SMALL_STATE(3442)] = 1092,
  [SMALL_STATE(3443)] = 1156,
  [SMALL_STATE(3444)] = 1220,
  [SMALL_STATE(3445)] = 1284,
  [SMALL_STATE(3446)] = 1348,
  [SMALL_STATE(3447)] = 1412,
  [SMALL_STATE(3448)] = 1476,
  [SMALL_STATE(3449)] = 1540,
  [SMALL_STATE(3450)] = 1604,
  [SMALL_STATE(3451)] = 1668,
  [SMALL_STATE(3452)] = 1732,
  [SMALL_STATE(3453)] = 1796,
  [SMALL_STATE(3454)] = 1860,
  [SMALL_STATE(3455)] = 1924,
  [SMALL_STATE(3456)] = 1988,
  [SMALL_STATE(3457)] = 2052,
  [SMALL_STATE(3458)] = 2116,
  [SMALL_STATE(3459)] = 2180,
  [SMALL_STATE(3460)] = 2244,
  [SMALL_STATE(3461)] = 2308,
  [SMALL_STATE(3462)] = 2372,
  [SMALL_STATE(3463)] = 2436,
  [SMALL_STATE(3464)] = 2500,
  [SMALL_STATE(3465)] = 2564,
  [SMALL_STATE(3466)] = 2628,
  [SMALL_STATE(3467)] = 2692,
  [SMALL_STATE(3468)] = 2756,
  [SMALL_STATE(3469)] = 2820,
  [SMALL_STATE(3470)] = 2884,
  [SMALL_STATE(3471)] = 2948,
  [SMALL_STATE(3472)] = 3012,
  [SMALL_STATE(3473)] = 3076,
  [SMALL_STATE(3474)] = 3140,
  [SMALL_STATE(3475)] = 3204,
  [SMALL_STATE(3476)] = 3268,
  [SMALL_STATE(3477)] = 3332,
  [SMALL_STATE(3478)] = 3396,
  [SMALL_STATE(3479)] = 3460,
  [SMALL_STATE(3480)] = 3524,
  [SMALL_STATE(3481)] = 3588,
  [SMALL_STATE(3482)] = 3652,
  [SMALL_STATE(3483)] = 3716,
  [SMALL_STATE(3484)] = 3780,
  [SMALL_STATE(3485)] = 3844,
  [SMALL_STATE(3486)] = 3908,
  [SMALL_STATE(3487)] = 3972,
  [SMALL_STATE(3488)] = 4036,
  [SMALL_STATE(3489)] = 4100,
  [SMALL_STATE(3490)] = 4164,
  [SMALL_STATE(3491)] = 4228,
  [SMALL_STATE(3492)] = 4292,
  [SMALL_STATE(3493)] = 4356,
  [SMALL_STATE(3494)] = 4421,
  [SMALL_STATE(3495)] = 4495,
  [SMALL_STATE(3496)] = 4569,
  [SMALL_STATE(3497)] = 4631,
  [SMALL_STATE(3498)] = 4705,
  [SMALL_STATE(3499)] = 4779,
  [SMALL_STATE(3500)] = 4853,
  [SMALL_STATE(3501)] = 4927,
  [SMALL_STATE(3502)] = 4986,
  [SMALL_STATE(3503)] = 5045,
  [SMALL_STATE(3504)] = 5105,
  [SMALL_STATE(3505)] = 5167,
  [SMALL_STATE(3506)] = 5229,
  [SMALL_STATE(3507)] = 5289,
  [SMALL_STATE(3508)] = 5351,
  [SMALL_STATE(3509)] = 5411,
  [SMALL_STATE(3510)] = 5469,
  [SMALL_STATE(3511)] = 5527,
  [SMALL_STATE(3512)] = 5587,
  [SMALL_STATE(3513)] = 5649,
  [SMALL_STATE(3514)] = 5707,
  [SMALL_STATE(3515)] = 5765,
  [SMALL_STATE(3516)] = 5825,
  [SMALL_STATE(3517)] = 5885,
  [SMALL_STATE(3518)] = 5943,
  [SMALL_STATE(3519)] = 6003,
  [SMALL_STATE(3520)] = 6061,
  [SMALL_STATE(3521)] = 6119,
  [SMALL_STATE(3522)] = 6177,
  [SMALL_STATE(3523)] = 6235,
  [SMALL_STATE(3524)] = 6293,
  [SMALL_STATE(3525)] = 6350,
  [SMALL_STATE(3526)] = 6407,
  [SMALL_STATE(3527)] = 6464,
  [SMALL_STATE(3528)] = 6525,
  [SMALL_STATE(3529)] = 6582,
  [SMALL_STATE(3530)] = 6643,
  [SMALL_STATE(3531)] = 6700,
  [SMALL_STATE(3532)] = 6757,
  [SMALL_STATE(3533)] = 6814,
  [SMALL_STATE(3534)] = 6875,
  [SMALL_STATE(3535)] = 6932,
  [SMALL_STATE(3536)] = 6993,
  [SMALL_STATE(3537)] = 7054,
  [SMALL_STATE(3538)] = 7115,
  [SMALL_STATE(3539)] = 7176,
  [SMALL_STATE(3540)] = 7235,
  [SMALL_STATE(3541)] = 7292,
  [SMALL_STATE(3542)] = 7351,
  [SMALL_STATE(3543)] = 7412,
  [SMALL_STATE(3544)] = 7470,
  [SMALL_STATE(3545)] = 7530,
  [SMALL_STATE(3546)] = 7590,
  [SMALL_STATE(3547)] = 7648,
  [SMALL_STATE(3548)] = 7708,
  [SMALL_STATE(3549)] = 7768,
  [SMALL_STATE(3550)] = 7828,
  [SMALL_STATE(3551)] = 7888,
  [SMALL_STATE(3552)] = 7948,
  [SMALL_STATE(3553)] = 8008,
  [SMALL_STATE(3554)] = 8068,
  [SMALL_STATE(3555)] = 8128,
  [SMALL_STATE(3556)] = 8188,
  [SMALL_STATE(3557)] = 8246,
  [SMALL_STATE(3558)] = 8306,
  [SMALL_STATE(3559)] = 8362,
  [SMALL_STATE(3560)] = 8420,
  [SMALL_STATE(3561)] = 8480,
  [SMALL_STATE(3562)] = 8538,
  [SMALL_STATE(3563)] = 8598,
  [SMALL_STATE(3564)] = 8654,
  [SMALL_STATE(3565)] = 8714,
  [SMALL_STATE(3566)] = 8772,
  [SMALL_STATE(3567)] = 8832,
  [SMALL_STATE(3568)] = 8892,
  [SMALL_STATE(3569)] = 8952,
  [SMALL_STATE(3570)] = 9007,
  [SMALL_STATE(3571)] = 9062,
  [SMALL_STATE(3572)] = 9119,
  [SMALL_STATE(3573)] = 9174,
  [SMALL_STATE(3574)] = 9229,
  [SMALL_STATE(3575)] = 9284,
  [SMALL_STATE(3576)] = 9339,
  [SMALL_STATE(3577)] = 9394,
  [SMALL_STATE(3578)] = 9449,
  [SMALL_STATE(3579)] = 9504,
  [SMALL_STATE(3580)] = 9559,
  [SMALL_STATE(3581)] = 9614,
  [SMALL_STATE(3582)] = 9669,
  [SMALL_STATE(3583)] = 9724,
  [SMALL_STATE(3584)] = 9779,
  [SMALL_STATE(3585)] = 9834,
  [SMALL_STATE(3586)] = 9889,
  [SMALL_STATE(3587)] = 9946,
  [SMALL_STATE(3588)] = 10001,
  [SMALL_STATE(3589)] = 10056,
  [SMALL_STATE(3590)] = 10111,
  [SMALL_STATE(3591)] = 10166,
  [SMALL_STATE(3592)] = 10225,
  [SMALL_STATE(3593)] = 10282,
  [SMALL_STATE(3594)] = 10337,
  [SMALL_STATE(3595)] = 10392,
  [SMALL_STATE(3596)] = 10447,
  [SMALL_STATE(3597)] = 10502,
  [SMALL_STATE(3598)] = 10557,
  [SMALL_STATE(3599)] = 10648,
  [SMALL_STATE(3600)] = 10738,
  [SMALL_STATE(3601)] = 10828,
  [SMALL_STATE(3602)] = 10915,
  [SMALL_STATE(3603)] = 11002,
  [SMALL_STATE(3604)] = 11089,
  [SMALL_STATE(3605)] = 11176,
  [SMALL_STATE(3606)] = 11263,
  [SMALL_STATE(3607)] = 11350,
  [SMALL_STATE(3608)] = 11437,
  [SMALL_STATE(3609)] = 11524,
  [SMALL_STATE(3610)] = 11611,
  [SMALL_STATE(3611)] = 11698,
  [SMALL_STATE(3612)] = 11785,
  [SMALL_STATE(3613)] = 11872,
  [SMALL_STATE(3614)] = 11959,
  [SMALL_STATE(3615)] = 12046,
  [SMALL_STATE(3616)] = 12133,
  [SMALL_STATE(3617)] = 12220,
  [SMALL_STATE(3618)] = 12307,
  [SMALL_STATE(3619)] = 12394,
  [SMALL_STATE(3620)] = 12479,
  [SMALL_STATE(3621)] = 12563,
  [SMALL_STATE(3622)] = 12647,
  [SMALL_STATE(3623)] = 12731,
  [SMALL_STATE(3624)] = 12815,
  [SMALL_STATE(3625)] = 12899,
  [SMALL_STATE(3626)] = 12983,
  [SMALL_STATE(3627)] = 13067,
  [SMALL_STATE(3628)] = 13151,
  [SMALL_STATE(3629)] = 13235,
  [SMALL_STATE(3630)] = 13319,
  [SMALL_STATE(3631)] = 13403,
  [SMALL_STATE(3632)] = 13487,
  [SMALL_STATE(3633)] = 13571,
  [SMALL_STATE(3634)] = 13655,
  [SMALL_STATE(3635)] = 13739,
  [SMALL_STATE(3636)] = 13823,
  [SMALL_STATE(3637)] = 13907,
  [SMALL_STATE(3638)] = 13991,
  [SMALL_STATE(3639)] = 14074,
  [SMALL_STATE(3640)] = 14155,
  [SMALL_STATE(3641)] = 14238,
  [SMALL_STATE(3642)] = 14318,
  [SMALL_STATE(3643)] = 14395,
  [SMALL_STATE(3644)] = 14472,
  [SMALL_STATE(3645)] = 14546,
  [SMALL_STATE(3646)] = 14620,
  [SMALL_STATE(3647)] = 14696,
  [SMALL_STATE(3648)] = 14770,
  [SMALL_STATE(3649)] = 14846,
  [SMALL_STATE(3650)] = 14920,
  [SMALL_STATE(3651)] = 14996,
  [SMALL_STATE(3652)] = 15070,
  [SMALL_STATE(3653)] = 15146,
  [SMALL_STATE(3654)] = 15220,
  [SMALL_STATE(3655)] = 15294,
  [SMALL_STATE(3656)] = 15370,
  [SMALL_STATE(3657)] = 15446,
  [SMALL_STATE(3658)] = 15522,
  [SMALL_STATE(3659)] = 15598,
  [SMALL_STATE(3660)] = 15674,
  [SMALL_STATE(3661)] = 15748,
  [SMALL_STATE(3662)] = 15821,
  [SMALL_STATE(3663)] = 15866,
  [SMALL_STATE(3664)] = 15911,
  [SMALL_STATE(3665)] = 15982,
  [SMALL_STATE(3666)] = 16028,
  [SMALL_STATE(3667)] = 16072,
  [SMALL_STATE(3668)] = 16134,
  [SMALL_STATE(3669)] = 16180,
  [SMALL_STATE(3670)] = 16224,
  [SMALL_STATE(3671)] = 16294,
  [SMALL_STATE(3672)] = 16335,
  [SMALL_STATE(3673)] = 16376,
  [SMALL_STATE(3674)] = 16417,
  [SMALL_STATE(3675)] = 16458,
  [SMALL_STATE(3676)] = 16499,
  [SMALL_STATE(3677)] = 16540,
  [SMALL_STATE(3678)] = 16581,
  [SMALL_STATE(3679)] = 16622,
  [SMALL_STATE(3680)] = 16663,
  [SMALL_STATE(3681)] = 16704,
  [SMALL_STATE(3682)] = 16745,
  [SMALL_STATE(3683)] = 16786,
  [SMALL_STATE(3684)] = 16827,
  [SMALL_STATE(3685)] = 16868,
  [SMALL_STATE(3686)] = 16909,
  [SMALL_STATE(3687)] = 16950,
  [SMALL_STATE(3688)] = 16991,
  [SMALL_STATE(3689)] = 17032,
  [SMALL_STATE(3690)] = 17073,
  [SMALL_STATE(3691)] = 17114,
  [SMALL_STATE(3692)] = 17155,
  [SMALL_STATE(3693)] = 17196,
  [SMALL_STATE(3694)] = 17237,
  [SMALL_STATE(3695)] = 17278,
  [SMALL_STATE(3696)] = 17319,
  [SMALL_STATE(3697)] = 17360,
  [SMALL_STATE(3698)] = 17401,
  [SMALL_STATE(3699)] = 17442,
  [SMALL_STATE(3700)] = 17483,
  [SMALL_STATE(3701)] = 17524,
  [SMALL_STATE(3702)] = 17565,
  [SMALL_STATE(3703)] = 17606,
  [SMALL_STATE(3704)] = 17647,
  [SMALL_STATE(3705)] = 17688,
  [SMALL_STATE(3706)] = 17729,
  [SMALL_STATE(3707)] = 17770,
  [SMALL_STATE(3708)] = 17811,
  [SMALL_STATE(3709)] = 17852,
  [SMALL_STATE(3710)] = 17893,
  [SMALL_STATE(3711)] = 17934,
  [SMALL_STATE(3712)] = 17975,
  [SMALL_STATE(3713)] = 18016,
  [SMALL_STATE(3714)] = 18057,
  [SMALL_STATE(3715)] = 18098,
  [SMALL_STATE(3716)] = 18139,
  [SMALL_STATE(3717)] = 18182,
  [SMALL_STATE(3718)] = 18223,
  [SMALL_STATE(3719)] = 18268,
  [SMALL_STATE(3720)] = 18309,
  [SMALL_STATE(3721)] = 18350,
  [SMALL_STATE(3722)] = 18391,
  [SMALL_STATE(3723)] = 18432,
  [SMALL_STATE(3724)] = 18473,
  [SMALL_STATE(3725)] = 18514,
  [SMALL_STATE(3726)] = 18559,
  [SMALL_STATE(3727)] = 18600,
  [SMALL_STATE(3728)] = 18641,
  [SMALL_STATE(3729)] = 18684,
  [SMALL_STATE(3730)] = 18725,
  [SMALL_STATE(3731)] = 18768,
  [SMALL_STATE(3732)] = 18809,
  [SMALL_STATE(3733)] = 18850,
  [SMALL_STATE(3734)] = 18891,
  [SMALL_STATE(3735)] = 18932,
  [SMALL_STATE(3736)] = 18973,
  [SMALL_STATE(3737)] = 19014,
  [SMALL_STATE(3738)] = 19055,
  [SMALL_STATE(3739)] = 19100,
  [SMALL_STATE(3740)] = 19141,
  [SMALL_STATE(3741)] = 19182,
  [SMALL_STATE(3742)] = 19223,
  [SMALL_STATE(3743)] = 19268,
  [SMALL_STATE(3744)] = 19309,
  [SMALL_STATE(3745)] = 19350,
  [SMALL_STATE(3746)] = 19391,
  [SMALL_STATE(3747)] = 19431,
  [SMALL_STATE(3748)] = 19471,
  [SMALL_STATE(3749)] = 19511,
  [SMALL_STATE(3750)] = 19555,
  [SMALL_STATE(3751)] = 19595,
  [SMALL_STATE(3752)] = 19635,
  [SMALL_STATE(3753)] = 19675,
  [SMALL_STATE(3754)] = 19715,
  [SMALL_STATE(3755)] = 19755,
  [SMALL_STATE(3756)] = 19819,
  [SMALL_STATE(3757)] = 19859,
  [SMALL_STATE(3758)] = 19899,
  [SMALL_STATE(3759)] = 19941,
  [SMALL_STATE(3760)] = 19985,
  [SMALL_STATE(3761)] = 20025,
  [SMALL_STATE(3762)] = 20065,
  [SMALL_STATE(3763)] = 20105,
  [SMALL_STATE(3764)] = 20145,
  [SMALL_STATE(3765)] = 20185,
  [SMALL_STATE(3766)] = 20229,
  [SMALL_STATE(3767)] = 20269,
  [SMALL_STATE(3768)] = 20309,
  [SMALL_STATE(3769)] = 20349,
  [SMALL_STATE(3770)] = 20389,
  [SMALL_STATE(3771)] = 20429,
  [SMALL_STATE(3772)] = 20469,
  [SMALL_STATE(3773)] = 20509,
  [SMALL_STATE(3774)] = 20549,
  [SMALL_STATE(3775)] = 20589,
  [SMALL_STATE(3776)] = 20631,
  [SMALL_STATE(3777)] = 20671,
  [SMALL_STATE(3778)] = 20711,
  [SMALL_STATE(3779)] = 20751,
  [SMALL_STATE(3780)] = 20791,
  [SMALL_STATE(3781)] = 20831,
  [SMALL_STATE(3782)] = 20871,
  [SMALL_STATE(3783)] = 20911,
  [SMALL_STATE(3784)] = 20951,
  [SMALL_STATE(3785)] = 20991,
  [SMALL_STATE(3786)] = 21031,
  [SMALL_STATE(3787)] = 21071,
  [SMALL_STATE(3788)] = 21111,
  [SMALL_STATE(3789)] = 21151,
  [SMALL_STATE(3790)] = 21191,
  [SMALL_STATE(3791)] = 21231,
  [SMALL_STATE(3792)] = 21271,
  [SMALL_STATE(3793)] = 21311,
  [SMALL_STATE(3794)] = 21351,
  [SMALL_STATE(3795)] = 21391,
  [SMALL_STATE(3796)] = 21431,
  [SMALL_STATE(3797)] = 21471,
  [SMALL_STATE(3798)] = 21511,
  [SMALL_STATE(3799)] = 21551,
  [SMALL_STATE(3800)] = 21591,
  [SMALL_STATE(3801)] = 21633,
  [SMALL_STATE(3802)] = 21673,
  [SMALL_STATE(3803)] = 21717,
  [SMALL_STATE(3804)] = 21757,
  [SMALL_STATE(3805)] = 21797,
  [SMALL_STATE(3806)] = 21839,
  [SMALL_STATE(3807)] = 21879,
  [SMALL_STATE(3808)] = 21919,
  [SMALL_STATE(3809)] = 21959,
  [SMALL_STATE(3810)] = 21999,
  [SMALL_STATE(3811)] = 22043,
  [SMALL_STATE(3812)] = 22083,
  [SMALL_STATE(3813)] = 22123,
  [SMALL_STATE(3814)] = 22163,
  [SMALL_STATE(3815)] = 22203,
  [SMALL_STATE(3816)] = 22243,
  [SMALL_STATE(3817)] = 22283,
  [SMALL_STATE(3818)] = 22323,
  [SMALL_STATE(3819)] = 22363,
  [SMALL_STATE(3820)] = 22403,
  [SMALL_STATE(3821)] = 22443,
  [SMALL_STATE(3822)] = 22483,
  [SMALL_STATE(3823)] = 22523,
  [SMALL_STATE(3824)] = 22567,
  [SMALL_STATE(3825)] = 22607,
  [SMALL_STATE(3826)] = 22646,
  [SMALL_STATE(3827)] = 22685,
  [SMALL_STATE(3828)] = 22724,
  [SMALL_STATE(3829)] = 22763,
  [SMALL_STATE(3830)] = 22802,
  [SMALL_STATE(3831)] = 22841,
  [SMALL_STATE(3832)] = 22880,
  [SMALL_STATE(3833)] = 22919,
  [SMALL_STATE(3834)] = 22958,
  [SMALL_STATE(3835)] = 22999,
  [SMALL_STATE(3836)] = 23038,
  [SMALL_STATE(3837)] = 23077,
  [SMALL_STATE(3838)] = 23116,
  [SMALL_STATE(3839)] = 23155,
  [SMALL_STATE(3840)] = 23196,
  [SMALL_STATE(3841)] = 23239,
  [SMALL_STATE(3842)] = 23282,
  [SMALL_STATE(3843)] = 23322,
  [SMALL_STATE(3844)] = 23360,
  [SMALL_STATE(3845)] = 23398,
  [SMALL_STATE(3846)] = 23436,
  [SMALL_STATE(3847)] = 23474,
  [SMALL_STATE(3848)] = 23512,
  [SMALL_STATE(3849)] = 23550,
  [SMALL_STATE(3850)] = 23588,
  [SMALL_STATE(3851)] = 23626,
  [SMALL_STATE(3852)] = 23664,
  [SMALL_STATE(3853)] = 23719,
  [SMALL_STATE(3854)] = 23774,
  [SMALL_STATE(3855)] = 23829,
  [SMALL_STATE(3856)] = 23884,
  [SMALL_STATE(3857)] = 23921,
  [SMALL_STATE(3858)] = 23976,
  [SMALL_STATE(3859)] = 24031,
  [SMALL_STATE(3860)] = 24086,
  [SMALL_STATE(3861)] = 24141,
  [SMALL_STATE(3862)] = 24196,
  [SMALL_STATE(3863)] = 24233,
  [SMALL_STATE(3864)] = 24288,
  [SMALL_STATE(3865)] = 24343,
  [SMALL_STATE(3866)] = 24398,
  [SMALL_STATE(3867)] = 24453,
  [SMALL_STATE(3868)] = 24508,
  [SMALL_STATE(3869)] = 24545,
  [SMALL_STATE(3870)] = 24582,
  [SMALL_STATE(3871)] = 24637,
  [SMALL_STATE(3872)] = 24692,
  [SMALL_STATE(3873)] = 24747,
  [SMALL_STATE(3874)] = 24802,
  [SMALL_STATE(3875)] = 24854,
  [SMALL_STATE(3876)] = 24906,
  [SMALL_STATE(3877)] = 24976,
  [SMALL_STATE(3878)] = 25046,
  [SMALL_STATE(3879)] = 25113,
  [SMALL_STATE(3880)] = 25180,
  [SMALL_STATE(3881)] = 25211,
  [SMALL_STATE(3882)] = 25242,
  [SMALL_STATE(3883)] = 25273,
  [SMALL_STATE(3884)] = 25331,
  [SMALL_STATE(3885)] = 25389,
  [SMALL_STATE(3886)] = 25447,
  [SMALL_STATE(3887)] = 25505,
  [SMALL_STATE(3888)] = 25537,
  [SMALL_STATE(3889)] = 25582,
  [SMALL_STATE(3890)] = 25629,
  [SMALL_STATE(3891)] = 25676,
  [SMALL_STATE(3892)] = 25728,
  [SMALL_STATE(3893)] = 25780,
  [SMALL_STATE(3894)] = 25832,
  [SMALL_STATE(3895)] = 25884,
  [SMALL_STATE(3896)] = 25936,
  [SMALL_STATE(3897)] = 25988,
  [SMALL_STATE(3898)] = 26040,
  [SMALL_STATE(3899)] = 26092,
  [SMALL_STATE(3900)] = 26144,
  [SMALL_STATE(3901)] = 26196,
  [SMALL_STATE(3902)] = 26248,
  [SMALL_STATE(3903)] = 26300,
  [SMALL_STATE(3904)] = 26352,
  [SMALL_STATE(3905)] = 26404,
  [SMALL_STATE(3906)] = 26456,
  [SMALL_STATE(3907)] = 26508,
  [SMALL_STATE(3908)] = 26536,
  [SMALL_STATE(3909)] = 26588,
  [SMALL_STATE(3910)] = 26640,
  [SMALL_STATE(3911)] = 26692,
  [SMALL_STATE(3912)] = 26744,
  [SMALL_STATE(3913)] = 26769,
  [SMALL_STATE(3914)] = 26800,
  [SMALL_STATE(3915)] = 26840,
  [SMALL_STATE(3916)] = 26868,
  [SMALL_STATE(3917)] = 26908,
  [SMALL_STATE(3918)] = 26948,
  [SMALL_STATE(3919)] = 26976,
  [SMALL_STATE(3920)] = 27016,
  [SMALL_STATE(3921)] = 27056,
  [SMALL_STATE(3922)] = 27096,
  [SMALL_STATE(3923)] = 27124,
  [SMALL_STATE(3924)] = 27164,
  [SMALL_STATE(3925)] = 27204,
  [SMALL_STATE(3926)] = 27228,
  [SMALL_STATE(3927)] = 27268,
  [SMALL_STATE(3928)] = 27294,
  [SMALL_STATE(3929)] = 27334,
  [SMALL_STATE(3930)] = 27374,
  [SMALL_STATE(3931)] = 27414,
  [SMALL_STATE(3932)] = 27454,
  [SMALL_STATE(3933)] = 27494,
  [SMALL_STATE(3934)] = 27534,
  [SMALL_STATE(3935)] = 27574,
  [SMALL_STATE(3936)] = 27595,
  [SMALL_STATE(3937)] = 27616,
  [SMALL_STATE(3938)] = 27649,
  [SMALL_STATE(3939)] = 27676,
  [SMALL_STATE(3940)] = 27697,
  [SMALL_STATE(3941)] = 27718,
  [SMALL_STATE(3942)] = 27745,
  [SMALL_STATE(3943)] = 27778,
  [SMALL_STATE(3944)] = 27799,
  [SMALL_STATE(3945)] = 27832,
  [SMALL_STATE(3946)] = 27854,
  [SMALL_STATE(3947)] = 27876,
  [SMALL_STATE(3948)] = 27898,
  [SMALL_STATE(3949)] = 27920,
  [SMALL_STATE(3950)] = 27946,
  [SMALL_STATE(3951)] = 27968,
  [SMALL_STATE(3952)] = 27992,
  [SMALL_STATE(3953)] = 28018,
  [SMALL_STATE(3954)] = 28040,
  [SMALL_STATE(3955)] = 28070,
  [SMALL_STATE(3956)] = 28100,
  [SMALL_STATE(3957)] = 28127,
  [SMALL_STATE(3958)] = 28146,
  [SMALL_STATE(3959)] = 28173,
  [SMALL_STATE(3960)] = 28192,
  [SMALL_STATE(3961)] = 28211,
  [SMALL_STATE(3962)] = 28238,
  [SMALL_STATE(3963)] = 28257,
  [SMALL_STATE(3964)] = 28276,
  [SMALL_STATE(3965)] = 28303,
  [SMALL_STATE(3966)] = 28322,
  [SMALL_STATE(3967)] = 28341,
  [SMALL_STATE(3968)] = 28368,
  [SMALL_STATE(3969)] = 28393,
  [SMALL_STATE(3970)] = 28420,
  [SMALL_STATE(3971)] = 28447,
  [SMALL_STATE(3972)] = 28474,
  [SMALL_STATE(3973)] = 28501,
  [SMALL_STATE(3974)] = 28528,
  [SMALL_STATE(3975)] = 28555,
  [SMALL_STATE(3976)] = 28582,
  [SMALL_STATE(3977)] = 28609,
  [SMALL_STATE(3978)] = 28628,
  [SMALL_STATE(3979)] = 28655,
  [SMALL_STATE(3980)] = 28682,
  [SMALL_STATE(3981)] = 28709,
  [SMALL_STATE(3982)] = 28736,
  [SMALL_STATE(3983)] = 28761,
  [SMALL_STATE(3984)] = 28788,
  [SMALL_STATE(3985)] = 28815,
  [SMALL_STATE(3986)] = 28834,
  [SMALL_STATE(3987)] = 28861,
  [SMALL_STATE(3988)] = 28888,
  [SMALL_STATE(3989)] = 28907,
  [SMALL_STATE(3990)] = 28934,
  [SMALL_STATE(3991)] = 28961,
  [SMALL_STATE(3992)] = 28988,
  [SMALL_STATE(3993)] = 29007,
  [SMALL_STATE(3994)] = 29034,
  [SMALL_STATE(3995)] = 29061,
  [SMALL_STATE(3996)] = 29088,
  [SMALL_STATE(3997)] = 29115,
  [SMALL_STATE(3998)] = 29142,
  [SMALL_STATE(3999)] = 29161,
  [SMALL_STATE(4000)] = 29188,
  [SMALL_STATE(4001)] = 29215,
  [SMALL_STATE(4002)] = 29242,
  [SMALL_STATE(4003)] = 29269,
  [SMALL_STATE(4004)] = 29296,
  [SMALL_STATE(4005)] = 29323,
  [SMALL_STATE(4006)] = 29350,
  [SMALL_STATE(4007)] = 29377,
  [SMALL_STATE(4008)] = 29404,
  [SMALL_STATE(4009)] = 29431,
  [SMALL_STATE(4010)] = 29450,
  [SMALL_STATE(4011)] = 29477,
  [SMALL_STATE(4012)] = 29496,
  [SMALL_STATE(4013)] = 29525,
  [SMALL_STATE(4014)] = 29552,
  [SMALL_STATE(4015)] = 29571,
  [SMALL_STATE(4016)] = 29595,
  [SMALL_STATE(4017)] = 29619,
  [SMALL_STATE(4018)] = 29645,
  [SMALL_STATE(4019)] = 29669,
  [SMALL_STATE(4020)] = 29687,
  [SMALL_STATE(4021)] = 29713,
  [SMALL_STATE(4022)] = 29739,
  [SMALL_STATE(4023)] = 29765,
  [SMALL_STATE(4024)] = 29791,
  [SMALL_STATE(4025)] = 29815,
  [SMALL_STATE(4026)] = 29839,
  [SMALL_STATE(4027)] = 29865,
  [SMALL_STATE(4028)] = 29885,
  [SMALL_STATE(4029)] = 29909,
  [SMALL_STATE(4030)] = 29929,
  [SMALL_STATE(4031)] = 29953,
  [SMALL_STATE(4032)] = 29977,
  [SMALL_STATE(4033)] = 29997,
  [SMALL_STATE(4034)] = 30017,
  [SMALL_STATE(4035)] = 30041,
  [SMALL_STATE(4036)] = 30067,
  [SMALL_STATE(4037)] = 30093,
  [SMALL_STATE(4038)] = 30117,
  [SMALL_STATE(4039)] = 30135,
  [SMALL_STATE(4040)] = 30161,
  [SMALL_STATE(4041)] = 30185,
  [SMALL_STATE(4042)] = 30209,
  [SMALL_STATE(4043)] = 30235,
  [SMALL_STATE(4044)] = 30255,
  [SMALL_STATE(4045)] = 30273,
  [SMALL_STATE(4046)] = 30297,
  [SMALL_STATE(4047)] = 30323,
  [SMALL_STATE(4048)] = 30347,
  [SMALL_STATE(4049)] = 30373,
  [SMALL_STATE(4050)] = 30397,
  [SMALL_STATE(4051)] = 30417,
  [SMALL_STATE(4052)] = 30443,
  [SMALL_STATE(4053)] = 30469,
  [SMALL_STATE(4054)] = 30495,
  [SMALL_STATE(4055)] = 30521,
  [SMALL_STATE(4056)] = 30545,
  [SMALL_STATE(4057)] = 30569,
  [SMALL_STATE(4058)] = 30593,
  [SMALL_STATE(4059)] = 30619,
  [SMALL_STATE(4060)] = 30637,
  [SMALL_STATE(4061)] = 30661,
  [SMALL_STATE(4062)] = 30685,
  [SMALL_STATE(4063)] = 30711,
  [SMALL_STATE(4064)] = 30735,
  [SMALL_STATE(4065)] = 30755,
  [SMALL_STATE(4066)] = 30781,
  [SMALL_STATE(4067)] = 30801,
  [SMALL_STATE(4068)] = 30819,
  [SMALL_STATE(4069)] = 30845,
  [SMALL_STATE(4070)] = 30869,
  [SMALL_STATE(4071)] = 30893,
  [SMALL_STATE(4072)] = 30917,
  [SMALL_STATE(4073)] = 30941,
  [SMALL_STATE(4074)] = 30965,
  [SMALL_STATE(4075)] = 30985,
  [SMALL_STATE(4076)] = 31009,
  [SMALL_STATE(4077)] = 31035,
  [SMALL_STATE(4078)] = 31059,
  [SMALL_STATE(4079)] = 31083,
  [SMALL_STATE(4080)] = 31107,
  [SMALL_STATE(4081)] = 31133,
  [SMALL_STATE(4082)] = 31159,
  [SMALL_STATE(4083)] = 31183,
  [SMALL_STATE(4084)] = 31207,
  [SMALL_STATE(4085)] = 31233,
  [SMALL_STATE(4086)] = 31257,
  [SMALL_STATE(4087)] = 31281,
  [SMALL_STATE(4088)] = 31299,
  [SMALL_STATE(4089)] = 31325,
  [SMALL_STATE(4090)] = 31349,
  [SMALL_STATE(4091)] = 31373,
  [SMALL_STATE(4092)] = 31397,
  [SMALL_STATE(4093)] = 31421,
  [SMALL_STATE(4094)] = 31445,
  [SMALL_STATE(4095)] = 31469,
  [SMALL_STATE(4096)] = 31493,
  [SMALL_STATE(4097)] = 31517,
  [SMALL_STATE(4098)] = 31541,
  [SMALL_STATE(4099)] = 31565,
  [SMALL_STATE(4100)] = 31589,
  [SMALL_STATE(4101)] = 31613,
  [SMALL_STATE(4102)] = 31637,
  [SMALL_STATE(4103)] = 31661,
  [SMALL_STATE(4104)] = 31687,
  [SMALL_STATE(4105)] = 31711,
  [SMALL_STATE(4106)] = 31735,
  [SMALL_STATE(4107)] = 31759,
  [SMALL_STATE(4108)] = 31783,
  [SMALL_STATE(4109)] = 31809,
  [SMALL_STATE(4110)] = 31833,
  [SMALL_STATE(4111)] = 31857,
  [SMALL_STATE(4112)] = 31881,
  [SMALL_STATE(4113)] = 31905,
  [SMALL_STATE(4114)] = 31929,
  [SMALL_STATE(4115)] = 31953,
  [SMALL_STATE(4116)] = 31977,
  [SMALL_STATE(4117)] = 32001,
  [SMALL_STATE(4118)] = 32025,
  [SMALL_STATE(4119)] = 32049,
  [SMALL_STATE(4120)] = 32073,
  [SMALL_STATE(4121)] = 32097,
  [SMALL_STATE(4122)] = 32121,
  [SMALL_STATE(4123)] = 32147,
  [SMALL_STATE(4124)] = 32171,
  [SMALL_STATE(4125)] = 32195,
  [SMALL_STATE(4126)] = 32221,
  [SMALL_STATE(4127)] = 32247,
  [SMALL_STATE(4128)] = 32273,
  [SMALL_STATE(4129)] = 32297,
  [SMALL_STATE(4130)] = 32323,
  [SMALL_STATE(4131)] = 32347,
  [SMALL_STATE(4132)] = 32373,
  [SMALL_STATE(4133)] = 32399,
  [SMALL_STATE(4134)] = 32417,
  [SMALL_STATE(4135)] = 32441,
  [SMALL_STATE(4136)] = 32467,
  [SMALL_STATE(4137)] = 32491,
  [SMALL_STATE(4138)] = 32515,
  [SMALL_STATE(4139)] = 32541,
  [SMALL_STATE(4140)] = 32567,
  [SMALL_STATE(4141)] = 32591,
  [SMALL_STATE(4142)] = 32617,
  [SMALL_STATE(4143)] = 32643,
  [SMALL_STATE(4144)] = 32660,
  [SMALL_STATE(4145)] = 32685,
  [SMALL_STATE(4146)] = 32704,
  [SMALL_STATE(4147)] = 32721,
  [SMALL_STATE(4148)] = 32738,
  [SMALL_STATE(4149)] = 32763,
  [SMALL_STATE(4150)] = 32788,
  [SMALL_STATE(4151)] = 32813,
  [SMALL_STATE(4152)] = 32838,
  [SMALL_STATE(4153)] = 32855,
  [SMALL_STATE(4154)] = 32880,
  [SMALL_STATE(4155)] = 32905,
  [SMALL_STATE(4156)] = 32930,
  [SMALL_STATE(4157)] = 32949,
  [SMALL_STATE(4158)] = 32970,
  [SMALL_STATE(4159)] = 32995,
  [SMALL_STATE(4160)] = 33020,
  [SMALL_STATE(4161)] = 33045,
  [SMALL_STATE(4162)] = 33070,
  [SMALL_STATE(4163)] = 33089,
  [SMALL_STATE(4164)] = 33114,
  [SMALL_STATE(4165)] = 33137,
  [SMALL_STATE(4166)] = 33154,
  [SMALL_STATE(4167)] = 33175,
  [SMALL_STATE(4168)] = 33198,
  [SMALL_STATE(4169)] = 33217,
  [SMALL_STATE(4170)] = 33238,
  [SMALL_STATE(4171)] = 33263,
  [SMALL_STATE(4172)] = 33288,
  [SMALL_STATE(4173)] = 33311,
  [SMALL_STATE(4174)] = 33328,
  [SMALL_STATE(4175)] = 33345,
  [SMALL_STATE(4176)] = 33370,
  [SMALL_STATE(4177)] = 33395,
  [SMALL_STATE(4178)] = 33420,
  [SMALL_STATE(4179)] = 33445,
  [SMALL_STATE(4180)] = 33470,
  [SMALL_STATE(4181)] = 33495,
  [SMALL_STATE(4182)] = 33520,
  [SMALL_STATE(4183)] = 33543,
  [SMALL_STATE(4184)] = 33560,
  [SMALL_STATE(4185)] = 33583,
  [SMALL_STATE(4186)] = 33608,
  [SMALL_STATE(4187)] = 33625,
  [SMALL_STATE(4188)] = 33650,
  [SMALL_STATE(4189)] = 33673,
  [SMALL_STATE(4190)] = 33696,
  [SMALL_STATE(4191)] = 33721,
  [SMALL_STATE(4192)] = 33744,
  [SMALL_STATE(4193)] = 33769,
  [SMALL_STATE(4194)] = 33792,
  [SMALL_STATE(4195)] = 33809,
  [SMALL_STATE(4196)] = 33832,
  [SMALL_STATE(4197)] = 33855,
  [SMALL_STATE(4198)] = 33880,
  [SMALL_STATE(4199)] = 33905,
  [SMALL_STATE(4200)] = 33926,
  [SMALL_STATE(4201)] = 33943,
  [SMALL_STATE(4202)] = 33968,
  [SMALL_STATE(4203)] = 33991,
  [SMALL_STATE(4204)] = 34016,
  [SMALL_STATE(4205)] = 34039,
  [SMALL_STATE(4206)] = 34064,
  [SMALL_STATE(4207)] = 34089,
  [SMALL_STATE(4208)] = 34110,
  [SMALL_STATE(4209)] = 34133,
  [SMALL_STATE(4210)] = 34150,
  [SMALL_STATE(4211)] = 34169,
  [SMALL_STATE(4212)] = 34188,
  [SMALL_STATE(4213)] = 34211,
  [SMALL_STATE(4214)] = 34230,
  [SMALL_STATE(4215)] = 34255,
  [SMALL_STATE(4216)] = 34272,
  [SMALL_STATE(4217)] = 34291,
  [SMALL_STATE(4218)] = 34308,
  [SMALL_STATE(4219)] = 34325,
  [SMALL_STATE(4220)] = 34350,
  [SMALL_STATE(4221)] = 34375,
  [SMALL_STATE(4222)] = 34392,
  [SMALL_STATE(4223)] = 34417,
  [SMALL_STATE(4224)] = 34442,
  [SMALL_STATE(4225)] = 34461,
  [SMALL_STATE(4226)] = 34480,
  [SMALL_STATE(4227)] = 34499,
  [SMALL_STATE(4228)] = 34520,
  [SMALL_STATE(4229)] = 34539,
  [SMALL_STATE(4230)] = 34562,
  [SMALL_STATE(4231)] = 34585,
  [SMALL_STATE(4232)] = 34610,
  [SMALL_STATE(4233)] = 34631,
  [SMALL_STATE(4234)] = 34652,
  [SMALL_STATE(4235)] = 34677,
  [SMALL_STATE(4236)] = 34700,
  [SMALL_STATE(4237)] = 34725,
  [SMALL_STATE(4238)] = 34750,
  [SMALL_STATE(4239)] = 34769,
  [SMALL_STATE(4240)] = 34794,
  [SMALL_STATE(4241)] = 34816,
  [SMALL_STATE(4242)] = 34838,
  [SMALL_STATE(4243)] = 34854,
  [SMALL_STATE(4244)] = 34874,
  [SMALL_STATE(4245)] = 34896,
  [SMALL_STATE(4246)] = 34914,
  [SMALL_STATE(4247)] = 34932,
  [SMALL_STATE(4248)] = 34952,
  [SMALL_STATE(4249)] = 34974,
  [SMALL_STATE(4250)] = 34996,
  [SMALL_STATE(4251)] = 35018,
  [SMALL_STATE(4252)] = 35036,
  [SMALL_STATE(4253)] = 35054,
  [SMALL_STATE(4254)] = 35074,
  [SMALL_STATE(4255)] = 35090,
  [SMALL_STATE(4256)] = 35110,
  [SMALL_STATE(4257)] = 35126,
  [SMALL_STATE(4258)] = 35144,
  [SMALL_STATE(4259)] = 35166,
  [SMALL_STATE(4260)] = 35184,
  [SMALL_STATE(4261)] = 35204,
  [SMALL_STATE(4262)] = 35226,
  [SMALL_STATE(4263)] = 35244,
  [SMALL_STATE(4264)] = 35266,
  [SMALL_STATE(4265)] = 35286,
  [SMALL_STATE(4266)] = 35306,
  [SMALL_STATE(4267)] = 35328,
  [SMALL_STATE(4268)] = 35346,
  [SMALL_STATE(4269)] = 35362,
  [SMALL_STATE(4270)] = 35382,
  [SMALL_STATE(4271)] = 35402,
  [SMALL_STATE(4272)] = 35420,
  [SMALL_STATE(4273)] = 35438,
  [SMALL_STATE(4274)] = 35456,
  [SMALL_STATE(4275)] = 35478,
  [SMALL_STATE(4276)] = 35496,
  [SMALL_STATE(4277)] = 35514,
  [SMALL_STATE(4278)] = 35532,
  [SMALL_STATE(4279)] = 35554,
  [SMALL_STATE(4280)] = 35576,
  [SMALL_STATE(4281)] = 35594,
  [SMALL_STATE(4282)] = 35616,
  [SMALL_STATE(4283)] = 35638,
  [SMALL_STATE(4284)] = 35660,
  [SMALL_STATE(4285)] = 35678,
  [SMALL_STATE(4286)] = 35700,
  [SMALL_STATE(4287)] = 35722,
  [SMALL_STATE(4288)] = 35744,
  [SMALL_STATE(4289)] = 35766,
  [SMALL_STATE(4290)] = 35784,
  [SMALL_STATE(4291)] = 35804,
  [SMALL_STATE(4292)] = 35826,
  [SMALL_STATE(4293)] = 35844,
  [SMALL_STATE(4294)] = 35866,
  [SMALL_STATE(4295)] = 35882,
  [SMALL_STATE(4296)] = 35902,
  [SMALL_STATE(4297)] = 35920,
  [SMALL_STATE(4298)] = 35938,
  [SMALL_STATE(4299)] = 35956,
  [SMALL_STATE(4300)] = 35978,
  [SMALL_STATE(4301)] = 35994,
  [SMALL_STATE(4302)] = 36012,
  [SMALL_STATE(4303)] = 36030,
  [SMALL_STATE(4304)] = 36052,
  [SMALL_STATE(4305)] = 36070,
  [SMALL_STATE(4306)] = 36092,
  [SMALL_STATE(4307)] = 36112,
  [SMALL_STATE(4308)] = 36134,
  [SMALL_STATE(4309)] = 36154,
  [SMALL_STATE(4310)] = 36170,
  [SMALL_STATE(4311)] = 36186,
  [SMALL_STATE(4312)] = 36208,
  [SMALL_STATE(4313)] = 36226,
  [SMALL_STATE(4314)] = 36248,
  [SMALL_STATE(4315)] = 36270,
  [SMALL_STATE(4316)] = 36292,
  [SMALL_STATE(4317)] = 36312,
  [SMALL_STATE(4318)] = 36332,
  [SMALL_STATE(4319)] = 36352,
  [SMALL_STATE(4320)] = 36372,
  [SMALL_STATE(4321)] = 36394,
  [SMALL_STATE(4322)] = 36412,
  [SMALL_STATE(4323)] = 36430,
  [SMALL_STATE(4324)] = 36452,
  [SMALL_STATE(4325)] = 36474,
  [SMALL_STATE(4326)] = 36494,
  [SMALL_STATE(4327)] = 36516,
  [SMALL_STATE(4328)] = 36532,
  [SMALL_STATE(4329)] = 36550,
  [SMALL_STATE(4330)] = 36572,
  [SMALL_STATE(4331)] = 36594,
  [SMALL_STATE(4332)] = 36616,
  [SMALL_STATE(4333)] = 36634,
  [SMALL_STATE(4334)] = 36650,
  [SMALL_STATE(4335)] = 36668,
  [SMALL_STATE(4336)] = 36690,
  [SMALL_STATE(4337)] = 36712,
  [SMALL_STATE(4338)] = 36732,
  [SMALL_STATE(4339)] = 36750,
  [SMALL_STATE(4340)] = 36768,
  [SMALL_STATE(4341)] = 36786,
  [SMALL_STATE(4342)] = 36808,
  [SMALL_STATE(4343)] = 36828,
  [SMALL_STATE(4344)] = 36850,
  [SMALL_STATE(4345)] = 36868,
  [SMALL_STATE(4346)] = 36888,
  [SMALL_STATE(4347)] = 36906,
  [SMALL_STATE(4348)] = 36928,
  [SMALL_STATE(4349)] = 36950,
  [SMALL_STATE(4350)] = 36972,
  [SMALL_STATE(4351)] = 36994,
  [SMALL_STATE(4352)] = 37014,
  [SMALL_STATE(4353)] = 37032,
  [SMALL_STATE(4354)] = 37054,
  [SMALL_STATE(4355)] = 37074,
  [SMALL_STATE(4356)] = 37096,
  [SMALL_STATE(4357)] = 37118,
  [SMALL_STATE(4358)] = 37134,
  [SMALL_STATE(4359)] = 37156,
  [SMALL_STATE(4360)] = 37176,
  [SMALL_STATE(4361)] = 37196,
  [SMALL_STATE(4362)] = 37214,
  [SMALL_STATE(4363)] = 37230,
  [SMALL_STATE(4364)] = 37246,
  [SMALL_STATE(4365)] = 37268,
  [SMALL_STATE(4366)] = 37286,
  [SMALL_STATE(4367)] = 37308,
  [SMALL_STATE(4368)] = 37330,
  [SMALL_STATE(4369)] = 37352,
  [SMALL_STATE(4370)] = 37374,
  [SMALL_STATE(4371)] = 37396,
  [SMALL_STATE(4372)] = 37414,
  [SMALL_STATE(4373)] = 37436,
  [SMALL_STATE(4374)] = 37458,
  [SMALL_STATE(4375)] = 37480,
  [SMALL_STATE(4376)] = 37496,
  [SMALL_STATE(4377)] = 37518,
  [SMALL_STATE(4378)] = 37540,
  [SMALL_STATE(4379)] = 37558,
  [SMALL_STATE(4380)] = 37574,
  [SMALL_STATE(4381)] = 37594,
  [SMALL_STATE(4382)] = 37614,
  [SMALL_STATE(4383)] = 37634,
  [SMALL_STATE(4384)] = 37656,
  [SMALL_STATE(4385)] = 37678,
  [SMALL_STATE(4386)] = 37698,
  [SMALL_STATE(4387)] = 37720,
  [SMALL_STATE(4388)] = 37742,
  [SMALL_STATE(4389)] = 37764,
  [SMALL_STATE(4390)] = 37786,
  [SMALL_STATE(4391)] = 37804,
  [SMALL_STATE(4392)] = 37826,
  [SMALL_STATE(4393)] = 37844,
  [SMALL_STATE(4394)] = 37866,
  [SMALL_STATE(4395)] = 37888,
  [SMALL_STATE(4396)] = 37908,
  [SMALL_STATE(4397)] = 37924,
  [SMALL_STATE(4398)] = 37946,
  [SMALL_STATE(4399)] = 37968,
  [SMALL_STATE(4400)] = 37986,
  [SMALL_STATE(4401)] = 38006,
  [SMALL_STATE(4402)] = 38026,
  [SMALL_STATE(4403)] = 38048,
  [SMALL_STATE(4404)] = 38070,
  [SMALL_STATE(4405)] = 38092,
  [SMALL_STATE(4406)] = 38114,
  [SMALL_STATE(4407)] = 38134,
  [SMALL_STATE(4408)] = 38154,
  [SMALL_STATE(4409)] = 38176,
  [SMALL_STATE(4410)] = 38196,
  [SMALL_STATE(4411)] = 38216,
  [SMALL_STATE(4412)] = 38236,
  [SMALL_STATE(4413)] = 38256,
  [SMALL_STATE(4414)] = 38272,
  [SMALL_STATE(4415)] = 38290,
  [SMALL_STATE(4416)] = 38306,
  [SMALL_STATE(4417)] = 38328,
  [SMALL_STATE(4418)] = 38346,
  [SMALL_STATE(4419)] = 38368,
  [SMALL_STATE(4420)] = 38390,
  [SMALL_STATE(4421)] = 38412,
  [SMALL_STATE(4422)] = 38430,
  [SMALL_STATE(4423)] = 38450,
  [SMALL_STATE(4424)] = 38469,
  [SMALL_STATE(4425)] = 38484,
  [SMALL_STATE(4426)] = 38501,
  [SMALL_STATE(4427)] = 38520,
  [SMALL_STATE(4428)] = 38539,
  [SMALL_STATE(4429)] = 38558,
  [SMALL_STATE(4430)] = 38577,
  [SMALL_STATE(4431)] = 38596,
  [SMALL_STATE(4432)] = 38611,
  [SMALL_STATE(4433)] = 38630,
  [SMALL_STATE(4434)] = 38645,
  [SMALL_STATE(4435)] = 38664,
  [SMALL_STATE(4436)] = 38679,
  [SMALL_STATE(4437)] = 38698,
  [SMALL_STATE(4438)] = 38713,
  [SMALL_STATE(4439)] = 38730,
  [SMALL_STATE(4440)] = 38749,
  [SMALL_STATE(4441)] = 38768,
  [SMALL_STATE(4442)] = 38787,
  [SMALL_STATE(4443)] = 38806,
  [SMALL_STATE(4444)] = 38825,
  [SMALL_STATE(4445)] = 38844,
  [SMALL_STATE(4446)] = 38863,
  [SMALL_STATE(4447)] = 38882,
  [SMALL_STATE(4448)] = 38899,
  [SMALL_STATE(4449)] = 38918,
  [SMALL_STATE(4450)] = 38937,
  [SMALL_STATE(4451)] = 38956,
  [SMALL_STATE(4452)] = 38975,
  [SMALL_STATE(4453)] = 38994,
  [SMALL_STATE(4454)] = 39013,
  [SMALL_STATE(4455)] = 39032,
  [SMALL_STATE(4456)] = 39049,
  [SMALL_STATE(4457)] = 39068,
  [SMALL_STATE(4458)] = 39085,
  [SMALL_STATE(4459)] = 39104,
  [SMALL_STATE(4460)] = 39123,
  [SMALL_STATE(4461)] = 39142,
  [SMALL_STATE(4462)] = 39161,
  [SMALL_STATE(4463)] = 39180,
  [SMALL_STATE(4464)] = 39199,
  [SMALL_STATE(4465)] = 39218,
  [SMALL_STATE(4466)] = 39237,
  [SMALL_STATE(4467)] = 39256,
  [SMALL_STATE(4468)] = 39275,
  [SMALL_STATE(4469)] = 39292,
  [SMALL_STATE(4470)] = 39311,
  [SMALL_STATE(4471)] = 39330,
  [SMALL_STATE(4472)] = 39349,
  [SMALL_STATE(4473)] = 39368,
  [SMALL_STATE(4474)] = 39387,
  [SMALL_STATE(4475)] = 39404,
  [SMALL_STATE(4476)] = 39423,
  [SMALL_STATE(4477)] = 39442,
  [SMALL_STATE(4478)] = 39461,
  [SMALL_STATE(4479)] = 39480,
  [SMALL_STATE(4480)] = 39499,
  [SMALL_STATE(4481)] = 39516,
  [SMALL_STATE(4482)] = 39535,
  [SMALL_STATE(4483)] = 39554,
  [SMALL_STATE(4484)] = 39573,
  [SMALL_STATE(4485)] = 39592,
  [SMALL_STATE(4486)] = 39611,
  [SMALL_STATE(4487)] = 39630,
  [SMALL_STATE(4488)] = 39649,
  [SMALL_STATE(4489)] = 39666,
  [SMALL_STATE(4490)] = 39685,
  [SMALL_STATE(4491)] = 39704,
  [SMALL_STATE(4492)] = 39723,
  [SMALL_STATE(4493)] = 39742,
  [SMALL_STATE(4494)] = 39761,
  [SMALL_STATE(4495)] = 39780,
  [SMALL_STATE(4496)] = 39797,
  [SMALL_STATE(4497)] = 39816,
  [SMALL_STATE(4498)] = 39835,
  [SMALL_STATE(4499)] = 39854,
  [SMALL_STATE(4500)] = 39873,
  [SMALL_STATE(4501)] = 39892,
  [SMALL_STATE(4502)] = 39909,
  [SMALL_STATE(4503)] = 39928,
  [SMALL_STATE(4504)] = 39947,
  [SMALL_STATE(4505)] = 39966,
  [SMALL_STATE(4506)] = 39985,
  [SMALL_STATE(4507)] = 40004,
  [SMALL_STATE(4508)] = 40021,
  [SMALL_STATE(4509)] = 40040,
  [SMALL_STATE(4510)] = 40059,
  [SMALL_STATE(4511)] = 40076,
  [SMALL_STATE(4512)] = 40095,
  [SMALL_STATE(4513)] = 40114,
  [SMALL_STATE(4514)] = 40133,
  [SMALL_STATE(4515)] = 40152,
  [SMALL_STATE(4516)] = 40171,
  [SMALL_STATE(4517)] = 40188,
  [SMALL_STATE(4518)] = 40207,
  [SMALL_STATE(4519)] = 40226,
  [SMALL_STATE(4520)] = 40245,
  [SMALL_STATE(4521)] = 40264,
  [SMALL_STATE(4522)] = 40283,
  [SMALL_STATE(4523)] = 40302,
  [SMALL_STATE(4524)] = 40321,
  [SMALL_STATE(4525)] = 40340,
  [SMALL_STATE(4526)] = 40359,
  [SMALL_STATE(4527)] = 40376,
  [SMALL_STATE(4528)] = 40395,
  [SMALL_STATE(4529)] = 40414,
  [SMALL_STATE(4530)] = 40433,
  [SMALL_STATE(4531)] = 40452,
  [SMALL_STATE(4532)] = 40471,
  [SMALL_STATE(4533)] = 40490,
  [SMALL_STATE(4534)] = 40507,
  [SMALL_STATE(4535)] = 40526,
  [SMALL_STATE(4536)] = 40545,
  [SMALL_STATE(4537)] = 40564,
  [SMALL_STATE(4538)] = 40583,
  [SMALL_STATE(4539)] = 40600,
  [SMALL_STATE(4540)] = 40617,
  [SMALL_STATE(4541)] = 40636,
  [SMALL_STATE(4542)] = 40655,
  [SMALL_STATE(4543)] = 40672,
  [SMALL_STATE(4544)] = 40691,
  [SMALL_STATE(4545)] = 40710,
  [SMALL_STATE(4546)] = 40729,
  [SMALL_STATE(4547)] = 40746,
  [SMALL_STATE(4548)] = 40765,
  [SMALL_STATE(4549)] = 40784,
  [SMALL_STATE(4550)] = 40801,
  [SMALL_STATE(4551)] = 40820,
  [SMALL_STATE(4552)] = 40839,
  [SMALL_STATE(4553)] = 40858,
  [SMALL_STATE(4554)] = 40877,
  [SMALL_STATE(4555)] = 40896,
  [SMALL_STATE(4556)] = 40915,
  [SMALL_STATE(4557)] = 40934,
  [SMALL_STATE(4558)] = 40953,
  [SMALL_STATE(4559)] = 40972,
  [SMALL_STATE(4560)] = 40991,
  [SMALL_STATE(4561)] = 41010,
  [SMALL_STATE(4562)] = 41029,
  [SMALL_STATE(4563)] = 41048,
  [SMALL_STATE(4564)] = 41067,
  [SMALL_STATE(4565)] = 41086,
  [SMALL_STATE(4566)] = 41105,
  [SMALL_STATE(4567)] = 41124,
  [SMALL_STATE(4568)] = 41141,
  [SMALL_STATE(4569)] = 41158,
  [SMALL_STATE(4570)] = 41175,
  [SMALL_STATE(4571)] = 41194,
  [SMALL_STATE(4572)] = 41213,
  [SMALL_STATE(4573)] = 41232,
  [SMALL_STATE(4574)] = 41251,
  [SMALL_STATE(4575)] = 41268,
  [SMALL_STATE(4576)] = 41287,
  [SMALL_STATE(4577)] = 41306,
  [SMALL_STATE(4578)] = 41323,
  [SMALL_STATE(4579)] = 41342,
  [SMALL_STATE(4580)] = 41361,
  [SMALL_STATE(4581)] = 41380,
  [SMALL_STATE(4582)] = 41399,
  [SMALL_STATE(4583)] = 41418,
  [SMALL_STATE(4584)] = 41437,
  [SMALL_STATE(4585)] = 41456,
  [SMALL_STATE(4586)] = 41475,
  [SMALL_STATE(4587)] = 41494,
  [SMALL_STATE(4588)] = 41513,
  [SMALL_STATE(4589)] = 41530,
  [SMALL_STATE(4590)] = 41549,
  [SMALL_STATE(4591)] = 41566,
  [SMALL_STATE(4592)] = 41583,
  [SMALL_STATE(4593)] = 41602,
  [SMALL_STATE(4594)] = 41621,
  [SMALL_STATE(4595)] = 41638,
  [SMALL_STATE(4596)] = 41657,
  [SMALL_STATE(4597)] = 41674,
  [SMALL_STATE(4598)] = 41693,
  [SMALL_STATE(4599)] = 41712,
  [SMALL_STATE(4600)] = 41731,
  [SMALL_STATE(4601)] = 41750,
  [SMALL_STATE(4602)] = 41769,
  [SMALL_STATE(4603)] = 41788,
  [SMALL_STATE(4604)] = 41805,
  [SMALL_STATE(4605)] = 41824,
  [SMALL_STATE(4606)] = 41841,
  [SMALL_STATE(4607)] = 41858,
  [SMALL_STATE(4608)] = 41877,
  [SMALL_STATE(4609)] = 41896,
  [SMALL_STATE(4610)] = 41915,
  [SMALL_STATE(4611)] = 41934,
  [SMALL_STATE(4612)] = 41953,
  [SMALL_STATE(4613)] = 41972,
  [SMALL_STATE(4614)] = 41991,
  [SMALL_STATE(4615)] = 42010,
  [SMALL_STATE(4616)] = 42025,
  [SMALL_STATE(4617)] = 42040,
  [SMALL_STATE(4618)] = 42057,
  [SMALL_STATE(4619)] = 42076,
  [SMALL_STATE(4620)] = 42095,
  [SMALL_STATE(4621)] = 42114,
  [SMALL_STATE(4622)] = 42133,
  [SMALL_STATE(4623)] = 42150,
  [SMALL_STATE(4624)] = 42167,
  [SMALL_STATE(4625)] = 42186,
  [SMALL_STATE(4626)] = 42205,
  [SMALL_STATE(4627)] = 42224,
  [SMALL_STATE(4628)] = 42243,
  [SMALL_STATE(4629)] = 42262,
  [SMALL_STATE(4630)] = 42281,
  [SMALL_STATE(4631)] = 42300,
  [SMALL_STATE(4632)] = 42319,
  [SMALL_STATE(4633)] = 42338,
  [SMALL_STATE(4634)] = 42357,
  [SMALL_STATE(4635)] = 42376,
  [SMALL_STATE(4636)] = 42395,
  [SMALL_STATE(4637)] = 42414,
  [SMALL_STATE(4638)] = 42431,
  [SMALL_STATE(4639)] = 42450,
  [SMALL_STATE(4640)] = 42469,
  [SMALL_STATE(4641)] = 42488,
  [SMALL_STATE(4642)] = 42507,
  [SMALL_STATE(4643)] = 42526,
  [SMALL_STATE(4644)] = 42543,
  [SMALL_STATE(4645)] = 42562,
  [SMALL_STATE(4646)] = 42581,
  [SMALL_STATE(4647)] = 42600,
  [SMALL_STATE(4648)] = 42619,
  [SMALL_STATE(4649)] = 42636,
  [SMALL_STATE(4650)] = 42655,
  [SMALL_STATE(4651)] = 42674,
  [SMALL_STATE(4652)] = 42693,
  [SMALL_STATE(4653)] = 42712,
  [SMALL_STATE(4654)] = 42731,
  [SMALL_STATE(4655)] = 42750,
  [SMALL_STATE(4656)] = 42767,
  [SMALL_STATE(4657)] = 42786,
  [SMALL_STATE(4658)] = 42805,
  [SMALL_STATE(4659)] = 42822,
  [SMALL_STATE(4660)] = 42839,
  [SMALL_STATE(4661)] = 42858,
  [SMALL_STATE(4662)] = 42877,
  [SMALL_STATE(4663)] = 42894,
  [SMALL_STATE(4664)] = 42909,
  [SMALL_STATE(4665)] = 42926,
  [SMALL_STATE(4666)] = 42945,
  [SMALL_STATE(4667)] = 42964,
  [SMALL_STATE(4668)] = 42983,
  [SMALL_STATE(4669)] = 43002,
  [SMALL_STATE(4670)] = 43019,
  [SMALL_STATE(4671)] = 43038,
  [SMALL_STATE(4672)] = 43055,
  [SMALL_STATE(4673)] = 43074,
  [SMALL_STATE(4674)] = 43093,
  [SMALL_STATE(4675)] = 43112,
  [SMALL_STATE(4676)] = 43131,
  [SMALL_STATE(4677)] = 43150,
  [SMALL_STATE(4678)] = 43169,
  [SMALL_STATE(4679)] = 43188,
  [SMALL_STATE(4680)] = 43205,
  [SMALL_STATE(4681)] = 43224,
  [SMALL_STATE(4682)] = 43241,
  [SMALL_STATE(4683)] = 43260,
  [SMALL_STATE(4684)] = 43279,
  [SMALL_STATE(4685)] = 43298,
  [SMALL_STATE(4686)] = 43313,
  [SMALL_STATE(4687)] = 43330,
  [SMALL_STATE(4688)] = 43349,
  [SMALL_STATE(4689)] = 43366,
  [SMALL_STATE(4690)] = 43385,
  [SMALL_STATE(4691)] = 43402,
  [SMALL_STATE(4692)] = 43421,
  [SMALL_STATE(4693)] = 43440,
  [SMALL_STATE(4694)] = 43457,
  [SMALL_STATE(4695)] = 43474,
  [SMALL_STATE(4696)] = 43493,
  [SMALL_STATE(4697)] = 43512,
  [SMALL_STATE(4698)] = 43531,
  [SMALL_STATE(4699)] = 43550,
  [SMALL_STATE(4700)] = 43567,
  [SMALL_STATE(4701)] = 43584,
  [SMALL_STATE(4702)] = 43601,
  [SMALL_STATE(4703)] = 43620,
  [SMALL_STATE(4704)] = 43639,
  [SMALL_STATE(4705)] = 43658,
  [SMALL_STATE(4706)] = 43677,
  [SMALL_STATE(4707)] = 43696,
  [SMALL_STATE(4708)] = 43715,
  [SMALL_STATE(4709)] = 43732,
  [SMALL_STATE(4710)] = 43751,
  [SMALL_STATE(4711)] = 43768,
  [SMALL_STATE(4712)] = 43787,
  [SMALL_STATE(4713)] = 43804,
  [SMALL_STATE(4714)] = 43823,
  [SMALL_STATE(4715)] = 43842,
  [SMALL_STATE(4716)] = 43861,
  [SMALL_STATE(4717)] = 43880,
  [SMALL_STATE(4718)] = 43899,
  [SMALL_STATE(4719)] = 43918,
  [SMALL_STATE(4720)] = 43937,
  [SMALL_STATE(4721)] = 43954,
  [SMALL_STATE(4722)] = 43971,
  [SMALL_STATE(4723)] = 43990,
  [SMALL_STATE(4724)] = 44009,
  [SMALL_STATE(4725)] = 44026,
  [SMALL_STATE(4726)] = 44045,
  [SMALL_STATE(4727)] = 44064,
  [SMALL_STATE(4728)] = 44083,
  [SMALL_STATE(4729)] = 44102,
  [SMALL_STATE(4730)] = 44119,
  [SMALL_STATE(4731)] = 44138,
  [SMALL_STATE(4732)] = 44157,
  [SMALL_STATE(4733)] = 44176,
  [SMALL_STATE(4734)] = 44195,
  [SMALL_STATE(4735)] = 44214,
  [SMALL_STATE(4736)] = 44233,
  [SMALL_STATE(4737)] = 44252,
  [SMALL_STATE(4738)] = 44271,
  [SMALL_STATE(4739)] = 44290,
  [SMALL_STATE(4740)] = 44307,
  [SMALL_STATE(4741)] = 44326,
  [SMALL_STATE(4742)] = 44343,
  [SMALL_STATE(4743)] = 44362,
  [SMALL_STATE(4744)] = 44381,
  [SMALL_STATE(4745)] = 44400,
  [SMALL_STATE(4746)] = 44419,
  [SMALL_STATE(4747)] = 44438,
  [SMALL_STATE(4748)] = 44457,
  [SMALL_STATE(4749)] = 44476,
  [SMALL_STATE(4750)] = 44495,
  [SMALL_STATE(4751)] = 44514,
  [SMALL_STATE(4752)] = 44531,
  [SMALL_STATE(4753)] = 44548,
  [SMALL_STATE(4754)] = 44565,
  [SMALL_STATE(4755)] = 44584,
  [SMALL_STATE(4756)] = 44603,
  [SMALL_STATE(4757)] = 44622,
  [SMALL_STATE(4758)] = 44641,
  [SMALL_STATE(4759)] = 44658,
  [SMALL_STATE(4760)] = 44677,
  [SMALL_STATE(4761)] = 44696,
  [SMALL_STATE(4762)] = 44715,
  [SMALL_STATE(4763)] = 44732,
  [SMALL_STATE(4764)] = 44751,
  [SMALL_STATE(4765)] = 44770,
  [SMALL_STATE(4766)] = 44789,
  [SMALL_STATE(4767)] = 44806,
  [SMALL_STATE(4768)] = 44825,
  [SMALL_STATE(4769)] = 44844,
  [SMALL_STATE(4770)] = 44863,
  [SMALL_STATE(4771)] = 44882,
  [SMALL_STATE(4772)] = 44901,
  [SMALL_STATE(4773)] = 44920,
  [SMALL_STATE(4774)] = 44939,
  [SMALL_STATE(4775)] = 44958,
  [SMALL_STATE(4776)] = 44975,
  [SMALL_STATE(4777)] = 44994,
  [SMALL_STATE(4778)] = 45013,
  [SMALL_STATE(4779)] = 45030,
  [SMALL_STATE(4780)] = 45049,
  [SMALL_STATE(4781)] = 45068,
  [SMALL_STATE(4782)] = 45087,
  [SMALL_STATE(4783)] = 45106,
  [SMALL_STATE(4784)] = 45125,
  [SMALL_STATE(4785)] = 45144,
  [SMALL_STATE(4786)] = 45163,
  [SMALL_STATE(4787)] = 45182,
  [SMALL_STATE(4788)] = 45201,
  [SMALL_STATE(4789)] = 45220,
  [SMALL_STATE(4790)] = 45239,
  [SMALL_STATE(4791)] = 45256,
  [SMALL_STATE(4792)] = 45273,
  [SMALL_STATE(4793)] = 45292,
  [SMALL_STATE(4794)] = 45311,
  [SMALL_STATE(4795)] = 45330,
  [SMALL_STATE(4796)] = 45349,
  [SMALL_STATE(4797)] = 45368,
  [SMALL_STATE(4798)] = 45387,
  [SMALL_STATE(4799)] = 45406,
  [SMALL_STATE(4800)] = 45425,
  [SMALL_STATE(4801)] = 45442,
  [SMALL_STATE(4802)] = 45461,
  [SMALL_STATE(4803)] = 45480,
  [SMALL_STATE(4804)] = 45499,
  [SMALL_STATE(4805)] = 45518,
  [SMALL_STATE(4806)] = 45537,
  [SMALL_STATE(4807)] = 45556,
  [SMALL_STATE(4808)] = 45575,
  [SMALL_STATE(4809)] = 45594,
  [SMALL_STATE(4810)] = 45611,
  [SMALL_STATE(4811)] = 45630,
  [SMALL_STATE(4812)] = 45649,
  [SMALL_STATE(4813)] = 45668,
  [SMALL_STATE(4814)] = 45687,
  [SMALL_STATE(4815)] = 45706,
  [SMALL_STATE(4816)] = 45721,
  [SMALL_STATE(4817)] = 45740,
  [SMALL_STATE(4818)] = 45759,
  [SMALL_STATE(4819)] = 45776,
  [SMALL_STATE(4820)] = 45795,
  [SMALL_STATE(4821)] = 45814,
  [SMALL_STATE(4822)] = 45831,
  [SMALL_STATE(4823)] = 45850,
  [SMALL_STATE(4824)] = 45869,
  [SMALL_STATE(4825)] = 45888,
  [SMALL_STATE(4826)] = 45907,
  [SMALL_STATE(4827)] = 45926,
  [SMALL_STATE(4828)] = 45945,
  [SMALL_STATE(4829)] = 45962,
  [SMALL_STATE(4830)] = 45979,
  [SMALL_STATE(4831)] = 45996,
  [SMALL_STATE(4832)] = 46013,
  [SMALL_STATE(4833)] = 46032,
  [SMALL_STATE(4834)] = 46049,
  [SMALL_STATE(4835)] = 46066,
  [SMALL_STATE(4836)] = 46085,
  [SMALL_STATE(4837)] = 46102,
  [SMALL_STATE(4838)] = 46121,
  [SMALL_STATE(4839)] = 46140,
  [SMALL_STATE(4840)] = 46159,
  [SMALL_STATE(4841)] = 46178,
  [SMALL_STATE(4842)] = 46197,
  [SMALL_STATE(4843)] = 46216,
  [SMALL_STATE(4844)] = 46231,
  [SMALL_STATE(4845)] = 46250,
  [SMALL_STATE(4846)] = 46269,
  [SMALL_STATE(4847)] = 46288,
  [SMALL_STATE(4848)] = 46307,
  [SMALL_STATE(4849)] = 46322,
  [SMALL_STATE(4850)] = 46341,
  [SMALL_STATE(4851)] = 46358,
  [SMALL_STATE(4852)] = 46377,
  [SMALL_STATE(4853)] = 46394,
  [SMALL_STATE(4854)] = 46413,
  [SMALL_STATE(4855)] = 46432,
  [SMALL_STATE(4856)] = 46447,
  [SMALL_STATE(4857)] = 46466,
  [SMALL_STATE(4858)] = 46483,
  [SMALL_STATE(4859)] = 46502,
  [SMALL_STATE(4860)] = 46519,
  [SMALL_STATE(4861)] = 46538,
  [SMALL_STATE(4862)] = 46557,
  [SMALL_STATE(4863)] = 46574,
  [SMALL_STATE(4864)] = 46591,
  [SMALL_STATE(4865)] = 46610,
  [SMALL_STATE(4866)] = 46629,
  [SMALL_STATE(4867)] = 46646,
  [SMALL_STATE(4868)] = 46665,
  [SMALL_STATE(4869)] = 46684,
  [SMALL_STATE(4870)] = 46703,
  [SMALL_STATE(4871)] = 46722,
  [SMALL_STATE(4872)] = 46741,
  [SMALL_STATE(4873)] = 46758,
  [SMALL_STATE(4874)] = 46777,
  [SMALL_STATE(4875)] = 46796,
  [SMALL_STATE(4876)] = 46811,
  [SMALL_STATE(4877)] = 46830,
  [SMALL_STATE(4878)] = 46849,
  [SMALL_STATE(4879)] = 46868,
  [SMALL_STATE(4880)] = 46885,
  [SMALL_STATE(4881)] = 46904,
  [SMALL_STATE(4882)] = 46923,
  [SMALL_STATE(4883)] = 46942,
  [SMALL_STATE(4884)] = 46959,
  [SMALL_STATE(4885)] = 46978,
  [SMALL_STATE(4886)] = 46995,
  [SMALL_STATE(4887)] = 47014,
  [SMALL_STATE(4888)] = 47033,
  [SMALL_STATE(4889)] = 47052,
  [SMALL_STATE(4890)] = 47071,
  [SMALL_STATE(4891)] = 47090,
  [SMALL_STATE(4892)] = 47109,
  [SMALL_STATE(4893)] = 47128,
  [SMALL_STATE(4894)] = 47147,
  [SMALL_STATE(4895)] = 47166,
  [SMALL_STATE(4896)] = 47185,
  [SMALL_STATE(4897)] = 47200,
  [SMALL_STATE(4898)] = 47219,
  [SMALL_STATE(4899)] = 47238,
  [SMALL_STATE(4900)] = 47257,
  [SMALL_STATE(4901)] = 47276,
  [SMALL_STATE(4902)] = 47295,
  [SMALL_STATE(4903)] = 47314,
  [SMALL_STATE(4904)] = 47333,
  [SMALL_STATE(4905)] = 47352,
  [SMALL_STATE(4906)] = 47371,
  [SMALL_STATE(4907)] = 47390,
  [SMALL_STATE(4908)] = 47405,
  [SMALL_STATE(4909)] = 47424,
  [SMALL_STATE(4910)] = 47439,
  [SMALL_STATE(4911)] = 47454,
  [SMALL_STATE(4912)] = 47471,
  [SMALL_STATE(4913)] = 47490,
  [SMALL_STATE(4914)] = 47509,
  [SMALL_STATE(4915)] = 47528,
  [SMALL_STATE(4916)] = 47547,
  [SMALL_STATE(4917)] = 47566,
  [SMALL_STATE(4918)] = 47583,
  [SMALL_STATE(4919)] = 47600,
  [SMALL_STATE(4920)] = 47619,
  [SMALL_STATE(4921)] = 47636,
  [SMALL_STATE(4922)] = 47655,
  [SMALL_STATE(4923)] = 47674,
  [SMALL_STATE(4924)] = 47693,
  [SMALL_STATE(4925)] = 47710,
  [SMALL_STATE(4926)] = 47729,
  [SMALL_STATE(4927)] = 47748,
  [SMALL_STATE(4928)] = 47767,
  [SMALL_STATE(4929)] = 47784,
  [SMALL_STATE(4930)] = 47803,
  [SMALL_STATE(4931)] = 47822,
  [SMALL_STATE(4932)] = 47841,
  [SMALL_STATE(4933)] = 47858,
  [SMALL_STATE(4934)] = 47873,
  [SMALL_STATE(4935)] = 47892,
  [SMALL_STATE(4936)] = 47911,
  [SMALL_STATE(4937)] = 47928,
  [SMALL_STATE(4938)] = 47943,
  [SMALL_STATE(4939)] = 47962,
  [SMALL_STATE(4940)] = 47979,
  [SMALL_STATE(4941)] = 47994,
  [SMALL_STATE(4942)] = 48013,
  [SMALL_STATE(4943)] = 48032,
  [SMALL_STATE(4944)] = 48048,
  [SMALL_STATE(4945)] = 48064,
  [SMALL_STATE(4946)] = 48080,
  [SMALL_STATE(4947)] = 48096,
  [SMALL_STATE(4948)] = 48112,
  [SMALL_STATE(4949)] = 48128,
  [SMALL_STATE(4950)] = 48144,
  [SMALL_STATE(4951)] = 48160,
  [SMALL_STATE(4952)] = 48176,
  [SMALL_STATE(4953)] = 48192,
  [SMALL_STATE(4954)] = 48208,
  [SMALL_STATE(4955)] = 48224,
  [SMALL_STATE(4956)] = 48240,
  [SMALL_STATE(4957)] = 48256,
  [SMALL_STATE(4958)] = 48272,
  [SMALL_STATE(4959)] = 48288,
  [SMALL_STATE(4960)] = 48304,
  [SMALL_STATE(4961)] = 48318,
  [SMALL_STATE(4962)] = 48334,
  [SMALL_STATE(4963)] = 48350,
  [SMALL_STATE(4964)] = 48366,
  [SMALL_STATE(4965)] = 48382,
  [SMALL_STATE(4966)] = 48398,
  [SMALL_STATE(4967)] = 48414,
  [SMALL_STATE(4968)] = 48428,
  [SMALL_STATE(4969)] = 48444,
  [SMALL_STATE(4970)] = 48460,
  [SMALL_STATE(4971)] = 48476,
  [SMALL_STATE(4972)] = 48492,
  [SMALL_STATE(4973)] = 48508,
  [SMALL_STATE(4974)] = 48522,
  [SMALL_STATE(4975)] = 48538,
  [SMALL_STATE(4976)] = 48552,
  [SMALL_STATE(4977)] = 48568,
  [SMALL_STATE(4978)] = 48584,
  [SMALL_STATE(4979)] = 48598,
  [SMALL_STATE(4980)] = 48614,
  [SMALL_STATE(4981)] = 48630,
  [SMALL_STATE(4982)] = 48646,
  [SMALL_STATE(4983)] = 48660,
  [SMALL_STATE(4984)] = 48676,
  [SMALL_STATE(4985)] = 48692,
  [SMALL_STATE(4986)] = 48708,
  [SMALL_STATE(4987)] = 48724,
  [SMALL_STATE(4988)] = 48738,
  [SMALL_STATE(4989)] = 48754,
  [SMALL_STATE(4990)] = 48770,
  [SMALL_STATE(4991)] = 48786,
  [SMALL_STATE(4992)] = 48800,
  [SMALL_STATE(4993)] = 48814,
  [SMALL_STATE(4994)] = 48828,
  [SMALL_STATE(4995)] = 48844,
  [SMALL_STATE(4996)] = 48860,
  [SMALL_STATE(4997)] = 48874,
  [SMALL_STATE(4998)] = 48888,
  [SMALL_STATE(4999)] = 48904,
  [SMALL_STATE(5000)] = 48920,
  [SMALL_STATE(5001)] = 48936,
  [SMALL_STATE(5002)] = 48952,
  [SMALL_STATE(5003)] = 48966,
  [SMALL_STATE(5004)] = 48982,
  [SMALL_STATE(5005)] = 48996,
  [SMALL_STATE(5006)] = 49012,
  [SMALL_STATE(5007)] = 49028,
  [SMALL_STATE(5008)] = 49044,
  [SMALL_STATE(5009)] = 49060,
  [SMALL_STATE(5010)] = 49076,
  [SMALL_STATE(5011)] = 49090,
  [SMALL_STATE(5012)] = 49104,
  [SMALL_STATE(5013)] = 49120,
  [SMALL_STATE(5014)] = 49136,
  [SMALL_STATE(5015)] = 49150,
  [SMALL_STATE(5016)] = 49166,
  [SMALL_STATE(5017)] = 49182,
  [SMALL_STATE(5018)] = 49196,
  [SMALL_STATE(5019)] = 49212,
  [SMALL_STATE(5020)] = 49228,
  [SMALL_STATE(5021)] = 49242,
  [SMALL_STATE(5022)] = 49258,
  [SMALL_STATE(5023)] = 49272,
  [SMALL_STATE(5024)] = 49288,
  [SMALL_STATE(5025)] = 49302,
  [SMALL_STATE(5026)] = 49318,
  [SMALL_STATE(5027)] = 49332,
  [SMALL_STATE(5028)] = 49348,
  [SMALL_STATE(5029)] = 49364,
  [SMALL_STATE(5030)] = 49378,
  [SMALL_STATE(5031)] = 49394,
  [SMALL_STATE(5032)] = 49410,
  [SMALL_STATE(5033)] = 49426,
  [SMALL_STATE(5034)] = 49442,
  [SMALL_STATE(5035)] = 49458,
  [SMALL_STATE(5036)] = 49474,
  [SMALL_STATE(5037)] = 49490,
  [SMALL_STATE(5038)] = 49504,
  [SMALL_STATE(5039)] = 49520,
  [SMALL_STATE(5040)] = 49536,
  [SMALL_STATE(5041)] = 49552,
  [SMALL_STATE(5042)] = 49568,
  [SMALL_STATE(5043)] = 49584,
  [SMALL_STATE(5044)] = 49600,
  [SMALL_STATE(5045)] = 49616,
  [SMALL_STATE(5046)] = 49632,
  [SMALL_STATE(5047)] = 49648,
  [SMALL_STATE(5048)] = 49664,
  [SMALL_STATE(5049)] = 49680,
  [SMALL_STATE(5050)] = 49696,
  [SMALL_STATE(5051)] = 49712,
  [SMALL_STATE(5052)] = 49728,
  [SMALL_STATE(5053)] = 49744,
  [SMALL_STATE(5054)] = 49760,
  [SMALL_STATE(5055)] = 49776,
  [SMALL_STATE(5056)] = 49792,
  [SMALL_STATE(5057)] = 49808,
  [SMALL_STATE(5058)] = 49824,
  [SMALL_STATE(5059)] = 49840,
  [SMALL_STATE(5060)] = 49854,
  [SMALL_STATE(5061)] = 49867,
  [SMALL_STATE(5062)] = 49880,
  [SMALL_STATE(5063)] = 49893,
  [SMALL_STATE(5064)] = 49906,
  [SMALL_STATE(5065)] = 49919,
  [SMALL_STATE(5066)] = 49932,
  [SMALL_STATE(5067)] = 49945,
  [SMALL_STATE(5068)] = 49958,
  [SMALL_STATE(5069)] = 49971,
  [SMALL_STATE(5070)] = 49984,
  [SMALL_STATE(5071)] = 49997,
  [SMALL_STATE(5072)] = 50010,
  [SMALL_STATE(5073)] = 50023,
  [SMALL_STATE(5074)] = 50036,
  [SMALL_STATE(5075)] = 50049,
  [SMALL_STATE(5076)] = 50062,
  [SMALL_STATE(5077)] = 50075,
  [SMALL_STATE(5078)] = 50088,
  [SMALL_STATE(5079)] = 50101,
  [SMALL_STATE(5080)] = 50114,
  [SMALL_STATE(5081)] = 50127,
  [SMALL_STATE(5082)] = 50140,
  [SMALL_STATE(5083)] = 50153,
  [SMALL_STATE(5084)] = 50166,
  [SMALL_STATE(5085)] = 50179,
  [SMALL_STATE(5086)] = 50192,
  [SMALL_STATE(5087)] = 50205,
  [SMALL_STATE(5088)] = 50218,
  [SMALL_STATE(5089)] = 50231,
  [SMALL_STATE(5090)] = 50244,
  [SMALL_STATE(5091)] = 50257,
  [SMALL_STATE(5092)] = 50270,
  [SMALL_STATE(5093)] = 50283,
  [SMALL_STATE(5094)] = 50296,
  [SMALL_STATE(5095)] = 50309,
  [SMALL_STATE(5096)] = 50322,
  [SMALL_STATE(5097)] = 50335,
  [SMALL_STATE(5098)] = 50348,
  [SMALL_STATE(5099)] = 50361,
  [SMALL_STATE(5100)] = 50374,
  [SMALL_STATE(5101)] = 50387,
  [SMALL_STATE(5102)] = 50400,
  [SMALL_STATE(5103)] = 50413,
  [SMALL_STATE(5104)] = 50426,
  [SMALL_STATE(5105)] = 50439,
  [SMALL_STATE(5106)] = 50452,
  [SMALL_STATE(5107)] = 50465,
  [SMALL_STATE(5108)] = 50478,
  [SMALL_STATE(5109)] = 50491,
  [SMALL_STATE(5110)] = 50504,
  [SMALL_STATE(5111)] = 50517,
  [SMALL_STATE(5112)] = 50530,
  [SMALL_STATE(5113)] = 50543,
  [SMALL_STATE(5114)] = 50556,
  [SMALL_STATE(5115)] = 50569,
  [SMALL_STATE(5116)] = 50582,
  [SMALL_STATE(5117)] = 50595,
  [SMALL_STATE(5118)] = 50608,
  [SMALL_STATE(5119)] = 50621,
  [SMALL_STATE(5120)] = 50634,
  [SMALL_STATE(5121)] = 50647,
  [SMALL_STATE(5122)] = 50660,
  [SMALL_STATE(5123)] = 50673,
  [SMALL_STATE(5124)] = 50686,
  [SMALL_STATE(5125)] = 50699,
  [SMALL_STATE(5126)] = 50712,
  [SMALL_STATE(5127)] = 50725,
  [SMALL_STATE(5128)] = 50738,
  [SMALL_STATE(5129)] = 50751,
  [SMALL_STATE(5130)] = 50764,
  [SMALL_STATE(5131)] = 50777,
  [SMALL_STATE(5132)] = 50790,
  [SMALL_STATE(5133)] = 50803,
  [SMALL_STATE(5134)] = 50816,
  [SMALL_STATE(5135)] = 50829,
  [SMALL_STATE(5136)] = 50842,
  [SMALL_STATE(5137)] = 50855,
  [SMALL_STATE(5138)] = 50868,
  [SMALL_STATE(5139)] = 50881,
  [SMALL_STATE(5140)] = 50894,
  [SMALL_STATE(5141)] = 50907,
  [SMALL_STATE(5142)] = 50920,
  [SMALL_STATE(5143)] = 50933,
  [SMALL_STATE(5144)] = 50946,
  [SMALL_STATE(5145)] = 50959,
  [SMALL_STATE(5146)] = 50972,
  [SMALL_STATE(5147)] = 50985,
  [SMALL_STATE(5148)] = 50998,
  [SMALL_STATE(5149)] = 51011,
  [SMALL_STATE(5150)] = 51024,
  [SMALL_STATE(5151)] = 51037,
  [SMALL_STATE(5152)] = 51050,
  [SMALL_STATE(5153)] = 51063,
  [SMALL_STATE(5154)] = 51076,
  [SMALL_STATE(5155)] = 51089,
  [SMALL_STATE(5156)] = 51102,
  [SMALL_STATE(5157)] = 51115,
  [SMALL_STATE(5158)] = 51128,
  [SMALL_STATE(5159)] = 51141,
  [SMALL_STATE(5160)] = 51154,
  [SMALL_STATE(5161)] = 51167,
  [SMALL_STATE(5162)] = 51180,
  [SMALL_STATE(5163)] = 51193,
  [SMALL_STATE(5164)] = 51206,
  [SMALL_STATE(5165)] = 51219,
  [SMALL_STATE(5166)] = 51232,
  [SMALL_STATE(5167)] = 51245,
  [SMALL_STATE(5168)] = 51258,
  [SMALL_STATE(5169)] = 51271,
  [SMALL_STATE(5170)] = 51284,
  [SMALL_STATE(5171)] = 51297,
  [SMALL_STATE(5172)] = 51310,
  [SMALL_STATE(5173)] = 51323,
  [SMALL_STATE(5174)] = 51336,
  [SMALL_STATE(5175)] = 51349,
  [SMALL_STATE(5176)] = 51362,
  [SMALL_STATE(5177)] = 51375,
  [SMALL_STATE(5178)] = 51388,
  [SMALL_STATE(5179)] = 51401,
  [SMALL_STATE(5180)] = 51414,
  [SMALL_STATE(5181)] = 51427,
  [SMALL_STATE(5182)] = 51440,
  [SMALL_STATE(5183)] = 51453,
  [SMALL_STATE(5184)] = 51466,
  [SMALL_STATE(5185)] = 51479,
  [SMALL_STATE(5186)] = 51492,
  [SMALL_STATE(5187)] = 51505,
  [SMALL_STATE(5188)] = 51518,
  [SMALL_STATE(5189)] = 51531,
  [SMALL_STATE(5190)] = 51544,
  [SMALL_STATE(5191)] = 51557,
  [SMALL_STATE(5192)] = 51570,
  [SMALL_STATE(5193)] = 51583,
  [SMALL_STATE(5194)] = 51596,
  [SMALL_STATE(5195)] = 51609,
  [SMALL_STATE(5196)] = 51622,
  [SMALL_STATE(5197)] = 51635,
  [SMALL_STATE(5198)] = 51648,
  [SMALL_STATE(5199)] = 51661,
  [SMALL_STATE(5200)] = 51674,
  [SMALL_STATE(5201)] = 51687,
  [SMALL_STATE(5202)] = 51700,
  [SMALL_STATE(5203)] = 51713,
  [SMALL_STATE(5204)] = 51726,
  [SMALL_STATE(5205)] = 51739,
  [SMALL_STATE(5206)] = 51752,
  [SMALL_STATE(5207)] = 51765,
  [SMALL_STATE(5208)] = 51778,
  [SMALL_STATE(5209)] = 51791,
  [SMALL_STATE(5210)] = 51804,
  [SMALL_STATE(5211)] = 51817,
  [SMALL_STATE(5212)] = 51830,
  [SMALL_STATE(5213)] = 51843,
  [SMALL_STATE(5214)] = 51856,
  [SMALL_STATE(5215)] = 51869,
  [SMALL_STATE(5216)] = 51882,
  [SMALL_STATE(5217)] = 51895,
  [SMALL_STATE(5218)] = 51908,
  [SMALL_STATE(5219)] = 51921,
  [SMALL_STATE(5220)] = 51934,
  [SMALL_STATE(5221)] = 51947,
  [SMALL_STATE(5222)] = 51960,
  [SMALL_STATE(5223)] = 51973,
  [SMALL_STATE(5224)] = 51986,
  [SMALL_STATE(5225)] = 51999,
  [SMALL_STATE(5226)] = 52012,
  [SMALL_STATE(5227)] = 52025,
  [SMALL_STATE(5228)] = 52038,
  [SMALL_STATE(5229)] = 52051,
  [SMALL_STATE(5230)] = 52064,
  [SMALL_STATE(5231)] = 52077,
  [SMALL_STATE(5232)] = 52090,
  [SMALL_STATE(5233)] = 52103,
  [SMALL_STATE(5234)] = 52116,
  [SMALL_STATE(5235)] = 52129,
  [SMALL_STATE(5236)] = 52142,
  [SMALL_STATE(5237)] = 52155,
  [SMALL_STATE(5238)] = 52168,
  [SMALL_STATE(5239)] = 52181,
  [SMALL_STATE(5240)] = 52194,
  [SMALL_STATE(5241)] = 52207,
  [SMALL_STATE(5242)] = 52220,
  [SMALL_STATE(5243)] = 52233,
  [SMALL_STATE(5244)] = 52246,
  [SMALL_STATE(5245)] = 52259,
  [SMALL_STATE(5246)] = 52272,
  [SMALL_STATE(5247)] = 52285,
  [SMALL_STATE(5248)] = 52298,
  [SMALL_STATE(5249)] = 52311,
  [SMALL_STATE(5250)] = 52324,
  [SMALL_STATE(5251)] = 52337,
  [SMALL_STATE(5252)] = 52350,
  [SMALL_STATE(5253)] = 52363,
  [SMALL_STATE(5254)] = 52376,
  [SMALL_STATE(5255)] = 52389,
  [SMALL_STATE(5256)] = 52402,
  [SMALL_STATE(5257)] = 52415,
  [SMALL_STATE(5258)] = 52428,
  [SMALL_STATE(5259)] = 52441,
  [SMALL_STATE(5260)] = 52454,
  [SMALL_STATE(5261)] = 52467,
  [SMALL_STATE(5262)] = 52480,
  [SMALL_STATE(5263)] = 52493,
  [SMALL_STATE(5264)] = 52506,
  [SMALL_STATE(5265)] = 52519,
  [SMALL_STATE(5266)] = 52532,
  [SMALL_STATE(5267)] = 52545,
  [SMALL_STATE(5268)] = 52558,
  [SMALL_STATE(5269)] = 52571,
  [SMALL_STATE(5270)] = 52584,
  [SMALL_STATE(5271)] = 52597,
  [SMALL_STATE(5272)] = 52610,
  [SMALL_STATE(5273)] = 52623,
  [SMALL_STATE(5274)] = 52636,
  [SMALL_STATE(5275)] = 52649,
  [SMALL_STATE(5276)] = 52662,
  [SMALL_STATE(5277)] = 52675,
  [SMALL_STATE(5278)] = 52688,
  [SMALL_STATE(5279)] = 52701,
  [SMALL_STATE(5280)] = 52714,
  [SMALL_STATE(5281)] = 52727,
  [SMALL_STATE(5282)] = 52740,
  [SMALL_STATE(5283)] = 52753,
  [SMALL_STATE(5284)] = 52766,
  [SMALL_STATE(5285)] = 52779,
  [SMALL_STATE(5286)] = 52792,
  [SMALL_STATE(5287)] = 52805,
  [SMALL_STATE(5288)] = 52818,
  [SMALL_STATE(5289)] = 52831,
  [SMALL_STATE(5290)] = 52844,
  [SMALL_STATE(5291)] = 52857,
  [SMALL_STATE(5292)] = 52870,
  [SMALL_STATE(5293)] = 52883,
  [SMALL_STATE(5294)] = 52896,
  [SMALL_STATE(5295)] = 52909,
  [SMALL_STATE(5296)] = 52922,
  [SMALL_STATE(5297)] = 52935,
  [SMALL_STATE(5298)] = 52948,
  [SMALL_STATE(5299)] = 52961,
  [SMALL_STATE(5300)] = 52974,
  [SMALL_STATE(5301)] = 52987,
  [SMALL_STATE(5302)] = 53000,
  [SMALL_STATE(5303)] = 53013,
  [SMALL_STATE(5304)] = 53026,
  [SMALL_STATE(5305)] = 53039,
  [SMALL_STATE(5306)] = 53052,
  [SMALL_STATE(5307)] = 53065,
  [SMALL_STATE(5308)] = 53078,
  [SMALL_STATE(5309)] = 53091,
  [SMALL_STATE(5310)] = 53104,
  [SMALL_STATE(5311)] = 53117,
  [SMALL_STATE(5312)] = 53130,
  [SMALL_STATE(5313)] = 53143,
  [SMALL_STATE(5314)] = 53156,
  [SMALL_STATE(5315)] = 53169,
  [SMALL_STATE(5316)] = 53182,
  [SMALL_STATE(5317)] = 53195,
  [SMALL_STATE(5318)] = 53208,
  [SMALL_STATE(5319)] = 53221,
  [SMALL_STATE(5320)] = 53234,
  [SMALL_STATE(5321)] = 53247,
  [SMALL_STATE(5322)] = 53260,
  [SMALL_STATE(5323)] = 53273,
  [SMALL_STATE(5324)] = 53286,
  [SMALL_STATE(5325)] = 53299,
  [SMALL_STATE(5326)] = 53312,
  [SMALL_STATE(5327)] = 53325,
  [SMALL_STATE(5328)] = 53338,
  [SMALL_STATE(5329)] = 53351,
  [SMALL_STATE(5330)] = 53364,
  [SMALL_STATE(5331)] = 53377,
  [SMALL_STATE(5332)] = 53390,
  [SMALL_STATE(5333)] = 53403,
  [SMALL_STATE(5334)] = 53416,
  [SMALL_STATE(5335)] = 53429,
  [SMALL_STATE(5336)] = 53442,
  [SMALL_STATE(5337)] = 53455,
  [SMALL_STATE(5338)] = 53468,
  [SMALL_STATE(5339)] = 53481,
  [SMALL_STATE(5340)] = 53494,
  [SMALL_STATE(5341)] = 53507,
  [SMALL_STATE(5342)] = 53520,
  [SMALL_STATE(5343)] = 53533,
  [SMALL_STATE(5344)] = 53546,
  [SMALL_STATE(5345)] = 53559,
  [SMALL_STATE(5346)] = 53572,
  [SMALL_STATE(5347)] = 53585,
  [SMALL_STATE(5348)] = 53598,
  [SMALL_STATE(5349)] = 53611,
  [SMALL_STATE(5350)] = 53624,
  [SMALL_STATE(5351)] = 53637,
  [SMALL_STATE(5352)] = 53650,
  [SMALL_STATE(5353)] = 53663,
  [SMALL_STATE(5354)] = 53676,
  [SMALL_STATE(5355)] = 53689,
  [SMALL_STATE(5356)] = 53702,
  [SMALL_STATE(5357)] = 53715,
  [SMALL_STATE(5358)] = 53728,
  [SMALL_STATE(5359)] = 53741,
  [SMALL_STATE(5360)] = 53754,
  [SMALL_STATE(5361)] = 53767,
  [SMALL_STATE(5362)] = 53780,
  [SMALL_STATE(5363)] = 53793,
  [SMALL_STATE(5364)] = 53806,
  [SMALL_STATE(5365)] = 53819,
  [SMALL_STATE(5366)] = 53832,
  [SMALL_STATE(5367)] = 53845,
  [SMALL_STATE(5368)] = 53858,
  [SMALL_STATE(5369)] = 53871,
  [SMALL_STATE(5370)] = 53884,
  [SMALL_STATE(5371)] = 53897,
  [SMALL_STATE(5372)] = 53910,
  [SMALL_STATE(5373)] = 53923,
  [SMALL_STATE(5374)] = 53936,
  [SMALL_STATE(5375)] = 53949,
  [SMALL_STATE(5376)] = 53962,
  [SMALL_STATE(5377)] = 53975,
  [SMALL_STATE(5378)] = 53988,
  [SMALL_STATE(5379)] = 54001,
  [SMALL_STATE(5380)] = 54014,
  [SMALL_STATE(5381)] = 54027,
  [SMALL_STATE(5382)] = 54040,
  [SMALL_STATE(5383)] = 54053,
  [SMALL_STATE(5384)] = 54066,
  [SMALL_STATE(5385)] = 54079,
  [SMALL_STATE(5386)] = 54092,
  [SMALL_STATE(5387)] = 54105,
  [SMALL_STATE(5388)] = 54118,
  [SMALL_STATE(5389)] = 54131,
  [SMALL_STATE(5390)] = 54144,
  [SMALL_STATE(5391)] = 54157,
  [SMALL_STATE(5392)] = 54170,
  [SMALL_STATE(5393)] = 54183,
  [SMALL_STATE(5394)] = 54196,
  [SMALL_STATE(5395)] = 54209,
  [SMALL_STATE(5396)] = 54222,
  [SMALL_STATE(5397)] = 54235,
  [SMALL_STATE(5398)] = 54248,
  [SMALL_STATE(5399)] = 54261,
  [SMALL_STATE(5400)] = 54274,
  [SMALL_STATE(5401)] = 54287,
  [SMALL_STATE(5402)] = 54300,
  [SMALL_STATE(5403)] = 54313,
  [SMALL_STATE(5404)] = 54326,
  [SMALL_STATE(5405)] = 54339,
  [SMALL_STATE(5406)] = 54352,
  [SMALL_STATE(5407)] = 54365,
  [SMALL_STATE(5408)] = 54378,
  [SMALL_STATE(5409)] = 54391,
  [SMALL_STATE(5410)] = 54404,
  [SMALL_STATE(5411)] = 54417,
  [SMALL_STATE(5412)] = 54430,
  [SMALL_STATE(5413)] = 54443,
  [SMALL_STATE(5414)] = 54456,
  [SMALL_STATE(5415)] = 54469,
  [SMALL_STATE(5416)] = 54482,
  [SMALL_STATE(5417)] = 54495,
  [SMALL_STATE(5418)] = 54508,
  [SMALL_STATE(5419)] = 54521,
  [SMALL_STATE(5420)] = 54534,
  [SMALL_STATE(5421)] = 54547,
  [SMALL_STATE(5422)] = 54560,
  [SMALL_STATE(5423)] = 54573,
  [SMALL_STATE(5424)] = 54586,
  [SMALL_STATE(5425)] = 54599,
  [SMALL_STATE(5426)] = 54612,
  [SMALL_STATE(5427)] = 54625,
  [SMALL_STATE(5428)] = 54638,
  [SMALL_STATE(5429)] = 54651,
  [SMALL_STATE(5430)] = 54664,
  [SMALL_STATE(5431)] = 54677,
  [SMALL_STATE(5432)] = 54690,
  [SMALL_STATE(5433)] = 54703,
  [SMALL_STATE(5434)] = 54716,
  [SMALL_STATE(5435)] = 54729,
  [SMALL_STATE(5436)] = 54742,
  [SMALL_STATE(5437)] = 54755,
  [SMALL_STATE(5438)] = 54768,
  [SMALL_STATE(5439)] = 54781,
  [SMALL_STATE(5440)] = 54794,
  [SMALL_STATE(5441)] = 54807,
  [SMALL_STATE(5442)] = 54820,
  [SMALL_STATE(5443)] = 54833,
  [SMALL_STATE(5444)] = 54846,
  [SMALL_STATE(5445)] = 54859,
  [SMALL_STATE(5446)] = 54872,
  [SMALL_STATE(5447)] = 54885,
  [SMALL_STATE(5448)] = 54898,
  [SMALL_STATE(5449)] = 54911,
  [SMALL_STATE(5450)] = 54924,
  [SMALL_STATE(5451)] = 54937,
  [SMALL_STATE(5452)] = 54950,
  [SMALL_STATE(5453)] = 54963,
  [SMALL_STATE(5454)] = 54976,
  [SMALL_STATE(5455)] = 54989,
  [SMALL_STATE(5456)] = 55002,
  [SMALL_STATE(5457)] = 55015,
  [SMALL_STATE(5458)] = 55028,
  [SMALL_STATE(5459)] = 55041,
  [SMALL_STATE(5460)] = 55054,
  [SMALL_STATE(5461)] = 55067,
  [SMALL_STATE(5462)] = 55080,
  [SMALL_STATE(5463)] = 55093,
  [SMALL_STATE(5464)] = 55106,
  [SMALL_STATE(5465)] = 55119,
  [SMALL_STATE(5466)] = 55132,
  [SMALL_STATE(5467)] = 55145,
  [SMALL_STATE(5468)] = 55158,
  [SMALL_STATE(5469)] = 55171,
  [SMALL_STATE(5470)] = 55184,
  [SMALL_STATE(5471)] = 55197,
  [SMALL_STATE(5472)] = 55210,
  [SMALL_STATE(5473)] = 55223,
  [SMALL_STATE(5474)] = 55236,
  [SMALL_STATE(5475)] = 55249,
  [SMALL_STATE(5476)] = 55262,
  [SMALL_STATE(5477)] = 55275,
  [SMALL_STATE(5478)] = 55288,
  [SMALL_STATE(5479)] = 55301,
  [SMALL_STATE(5480)] = 55314,
  [SMALL_STATE(5481)] = 55327,
  [SMALL_STATE(5482)] = 55340,
  [SMALL_STATE(5483)] = 55353,
  [SMALL_STATE(5484)] = 55366,
  [SMALL_STATE(5485)] = 55379,
  [SMALL_STATE(5486)] = 55392,
  [SMALL_STATE(5487)] = 55405,
  [SMALL_STATE(5488)] = 55418,
  [SMALL_STATE(5489)] = 55431,
  [SMALL_STATE(5490)] = 55444,
  [SMALL_STATE(5491)] = 55457,
  [SMALL_STATE(5492)] = 55470,
  [SMALL_STATE(5493)] = 55483,
  [SMALL_STATE(5494)] = 55496,
  [SMALL_STATE(5495)] = 55509,
  [SMALL_STATE(5496)] = 55522,
  [SMALL_STATE(5497)] = 55535,
  [SMALL_STATE(5498)] = 55548,
  [SMALL_STATE(5499)] = 55561,
  [SMALL_STATE(5500)] = 55574,
  [SMALL_STATE(5501)] = 55587,
  [SMALL_STATE(5502)] = 55600,
  [SMALL_STATE(5503)] = 55613,
  [SMALL_STATE(5504)] = 55626,
  [SMALL_STATE(5505)] = 55639,
  [SMALL_STATE(5506)] = 55652,
  [SMALL_STATE(5507)] = 55665,
  [SMALL_STATE(5508)] = 55678,
  [SMALL_STATE(5509)] = 55691,
  [SMALL_STATE(5510)] = 55704,
  [SMALL_STATE(5511)] = 55717,
  [SMALL_STATE(5512)] = 55730,
  [SMALL_STATE(5513)] = 55743,
  [SMALL_STATE(5514)] = 55756,
  [SMALL_STATE(5515)] = 55769,
  [SMALL_STATE(5516)] = 55782,
  [SMALL_STATE(5517)] = 55795,
  [SMALL_STATE(5518)] = 55808,
  [SMALL_STATE(5519)] = 55821,
  [SMALL_STATE(5520)] = 55834,
  [SMALL_STATE(5521)] = 55847,
  [SMALL_STATE(5522)] = 55860,
  [SMALL_STATE(5523)] = 55873,
  [SMALL_STATE(5524)] = 55886,
  [SMALL_STATE(5525)] = 55899,
  [SMALL_STATE(5526)] = 55912,
  [SMALL_STATE(5527)] = 55925,
  [SMALL_STATE(5528)] = 55938,
  [SMALL_STATE(5529)] = 55951,
  [SMALL_STATE(5530)] = 55964,
  [SMALL_STATE(5531)] = 55977,
  [SMALL_STATE(5532)] = 55990,
  [SMALL_STATE(5533)] = 56003,
  [SMALL_STATE(5534)] = 56016,
  [SMALL_STATE(5535)] = 56029,
  [SMALL_STATE(5536)] = 56042,
  [SMALL_STATE(5537)] = 56055,
  [SMALL_STATE(5538)] = 56068,
  [SMALL_STATE(5539)] = 56081,
  [SMALL_STATE(5540)] = 56094,
  [SMALL_STATE(5541)] = 56107,
  [SMALL_STATE(5542)] = 56120,
  [SMALL_STATE(5543)] = 56133,
  [SMALL_STATE(5544)] = 56146,
  [SMALL_STATE(5545)] = 56159,
  [SMALL_STATE(5546)] = 56172,
  [SMALL_STATE(5547)] = 56185,
  [SMALL_STATE(5548)] = 56198,
  [SMALL_STATE(5549)] = 56211,
  [SMALL_STATE(5550)] = 56224,
  [SMALL_STATE(5551)] = 56228,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5523),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5495),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3635),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5435),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3872),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3859),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5451),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4693),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4700),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4701),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3472),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5107),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4363),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4310),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5500),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3008),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5295),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3009),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5268),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4827),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3017),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2933),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2934),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2935),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4030),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3627),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3492),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4873),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3471),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3447),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3466),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3460),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3446),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3467),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3489),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3434),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3477),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3641),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3954),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3955),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3499),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2218),
  [324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5547),
  [328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2122),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(954),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5400),
  [346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4882),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5404),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5409),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2404),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2487),
  [363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2487),
  [366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2488),
  [369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2488),
  [372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2489),
  [375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2489),
  [378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4034),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3632),
  [390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2120),
  [393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2120),
  [396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(262),
  [399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(3472),
  [402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(263),
  [405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2121),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3518),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2216),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5424),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(345),
  [422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2458),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5347),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4667),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5379),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2500),
  [447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2500),
  [450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2501),
  [453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2501),
  [456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2388),
  [459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2388),
  [462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4016),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3626),
  [474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(228),
  [477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(245),
  [480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3516),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3099),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3881),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5346),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4233),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5387),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2561),
  [516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2623),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2625),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4056),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3628),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4157),
  [546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3667),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2218),
  [554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5076),
  [556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2487),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2488),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2500),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2883),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5154),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5456),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5456),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4500),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3294),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4055),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3623),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4893),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3039),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5494),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3801),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5200),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4166),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3824),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3786),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4169),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3799),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3748),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3767),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3768),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3772),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3776),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3777),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3780),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3781),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3799),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3787),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3791),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3803),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5064),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3515),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5132),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2503),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2582),
  [911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(983),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5335),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5335),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4453),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5371),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2585),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2644),
  [939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2644),
  [942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2645),
  [945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2645),
  [948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2646),
  [951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2646),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4045),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3633),
  [966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(269),
  [969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(270),
  [972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3662),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2994),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4894),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2812),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2978),
  [990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5118),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [1002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4522),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [1012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [1014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2916),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2917),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2918),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [1026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4078),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [1032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3630),
  [1038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [1042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4849),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [1048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5274),
  [1052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3663),
  [1054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [1058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2645),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [1066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [1072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5194),
  [1076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2777),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2791),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5382),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5148),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3716),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5157),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2741),
  [1102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2747),
  [1104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2772),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [1112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [1116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4060),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [1124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3625),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [1130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3730),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [1138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(821),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [1145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2506),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5413),
  [1150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2718),
  [1152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(909),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5081),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5081),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4738),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2721),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2726),
  [1177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2669),
  [1180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2669),
  [1183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2671),
  [1186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2671),
  [1189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2672),
  [1192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2672),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4018),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3629),
  [1207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(227),
  [1210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(254),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4864),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3717),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5332),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3666),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2669),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2671),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2672),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3723),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3734),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3669),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3719),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3735),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3677),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3678),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3682),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3684),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3685),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3688),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3689),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3694),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3671),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3007),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3016),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3021),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3032),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3033),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [1463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3036),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3043),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2819),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3107),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3108),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5261),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4826),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5266),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3116),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3119),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3134),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3135),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [1511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3136),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [1515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4063),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4328),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3634),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4838),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [1537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2507),
  [1540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(1029),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4521),
  [1545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2772),
  [1548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2772),
  [1551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2773),
  [1554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2773),
  [1557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2774),
  [1560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2774),
  [1563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(284),
  [1566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(285),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4897),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2972),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4301),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4262),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5437),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4277),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4346),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4273),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4378),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4312),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4361),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4267),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4322),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4344),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4365),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4390),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4421),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4298),
  [1635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(1013),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [1640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5455),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [1646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [1648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [1650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2273),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [1654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5208),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4423),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5491),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5234),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [1666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [1668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2308),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [1682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4031),
  [1684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3620),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4812),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5452),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [1718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [1720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5504),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5504),
  [1728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4935),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5507),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [1738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [1740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2322),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [1748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4041),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3637),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4881),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5470),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2813),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3056),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3058),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3059),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2804),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5275),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5421),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2793),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2800),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2803),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2808),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2794),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2796),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2797),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2799),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2801),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2798),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [1848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(836),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2810),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2876),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2877),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5125),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4479),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5129),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2879),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4047),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3636),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4889),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2921),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5314),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3363),
  [1919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(879),
  [1922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3364),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [1928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5156),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5156),
  [1932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4618),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3367),
  [1942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3370),
  [1944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3379),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [1948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3354),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3384),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4112),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3624),
  [1968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4854),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2891),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [1982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(894),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5396),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4683),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5415),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5420),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3280),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3287),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3300),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4130),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3631),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4860),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [2039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(806),
  [2042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2866),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5462),
  [2046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3342),
  [2048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(925),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3169),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [2057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5173),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5173),
  [2061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4786),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5177),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [2069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3185),
  [2073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3173),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3215),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3250),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [2085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4025),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [2095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3622),
  [2097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4868),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [2105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(2813),
  [2108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(940),
  [2111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(967),
  [2114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(864),
  [2117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_op_symbol, 1, 0, 0), SHIFT(998),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [2124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [2132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3047),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [2138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [2140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3157),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [2144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [2146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3448),
  [2148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4029),
  [2150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4027),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4043),
  [2154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [2158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2962),
  [2160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2963),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [2164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2964),
  [2166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3353),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3400),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3401),
  [2174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [2176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3403),
  [2178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3090),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [2182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3208),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3232),
  [2186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [2188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3276),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2622),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [2194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2694),
  [2196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [2198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3131),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3343),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3253),
  [2210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [2212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3171),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2919),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3076),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [2226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2398),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2242),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [2248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3162),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3246),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3248),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3254),
  [2262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [2268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2657),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2826),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [2278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2865),
  [2280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2867),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [2284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2868),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2230),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [2304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2450),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2476),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2691),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2781),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [2328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [2334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_theorem, 2, 0, 4),
  [2336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_theorem, 2, 0, 4),
  [2338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [2350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5278),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [2354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [2372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [2376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [2378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [2420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [2426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [2430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [2454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [2466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [2474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [2516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4255),
  [2526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [2528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3573),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [2532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5422),
  [2536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [2542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [2546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [2562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4317),
  [2564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [2568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_theorem, 4, 0, 18),
  [2570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_theorem, 4, 0, 18),
  [2572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(4976),
  [2575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3442),
  [2578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3442),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5026),
  [2583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(4033),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5512),
  [2588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5514),
  [2590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3470),
  [2593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3440),
  [2596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [2598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5520),
  [2600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3448),
  [2603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0),
  [2607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3488),
  [2610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(4029),
  [2613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(4029),
  [2616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3472),
  [2619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(4027),
  [2622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3472),
  [2625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(4032),
  [2628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3445),
  [2631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3481),
  [2634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3487),
  [2637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3464),
  [2640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3485),
  [2643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3432),
  [2646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3478),
  [2649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3492),
  [2652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3492),
  [2655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(4043),
  [2658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3441),
  [2661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3471),
  [2664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3471),
  [2667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3476),
  [2670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3454),
  [2673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3428),
  [2676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3456),
  [2679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3459),
  [2682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3452),
  [2685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3450),
  [2688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3453),
  [2691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3475),
  [2694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3435),
  [2697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3430),
  [2700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3436),
  [2703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3447),
  [2706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3447),
  [2709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3466),
  [2712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3466),
  [2715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3451),
  [2718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3457),
  [2721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3486),
  [2724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3460),
  [2727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3460),
  [2730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3473),
  [2733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3446),
  [2736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3446),
  [2739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3467),
  [2742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3467),
  [2745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3461),
  [2748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3465),
  [2751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3489),
  [2754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3489),
  [2757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3434),
  [2760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3434),
  [2763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3437),
  [2766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3455),
  [2769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3441),
  [2772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3443),
  [2775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3468),
  [2778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3462),
  [2781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3462),
  [2784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3463),
  [2787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3477),
  [2790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3490),
  [2793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3438),
  [2796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3482),
  [2799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3484),
  [2802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3479),
  [2805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3431),
  [2808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3474),
  [2811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3458),
  [2814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3491),
  [2817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3448),
  [2820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3433),
  [2823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3483),
  [2826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3480),
  [2829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3469),
  [2832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3429),
  [2835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3427),
  [2838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3439),
  [2841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3444),
  [2844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3449),
  [2847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3425),
  [2850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(3426),
  [2853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(4976),
  [2856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3442),
  [2859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3442),
  [2862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(5026),
  [2865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(4211),
  [2868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(4033),
  [2871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(5512),
  [2874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(5514),
  [2877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3470),
  [2880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3440),
  [2883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(95),
  [2886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(5520),
  [2889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3448),
  [2892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0),
  [2894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0),
  [2896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3488),
  [2899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(4029),
  [2902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(4029),
  [2905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3472),
  [2908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(4027),
  [2911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3472),
  [2914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(4032),
  [2917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3445),
  [2920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3481),
  [2923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3487),
  [2926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3464),
  [2929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3485),
  [2932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3432),
  [2935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3478),
  [2938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3492),
  [2941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3492),
  [2944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(4043),
  [2947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3441),
  [2950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3471),
  [2953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3471),
  [2956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3476),
  [2959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3454),
  [2962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3428),
  [2965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3456),
  [2968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3459),
  [2971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3452),
  [2974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3450),
  [2977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3453),
  [2980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3475),
  [2983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3435),
  [2986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3430),
  [2989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3436),
  [2992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3447),
  [2995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3447),
  [2998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3466),
  [3001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3466),
  [3004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3451),
  [3007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3457),
  [3010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3486),
  [3013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3460),
  [3016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3460),
  [3019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3473),
  [3022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3446),
  [3025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3446),
  [3028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3467),
  [3031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3467),
  [3034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3461),
  [3037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3465),
  [3040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3489),
  [3043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3489),
  [3046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3434),
  [3049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3434),
  [3052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3437),
  [3055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3455),
  [3058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3441),
  [3061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3443),
  [3064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3468),
  [3067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3462),
  [3070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3462),
  [3073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3463),
  [3076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3477),
  [3079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3490),
  [3082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3438),
  [3085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3482),
  [3088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3484),
  [3091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3479),
  [3094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3431),
  [3097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3474),
  [3100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3458),
  [3103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3491),
  [3106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3448),
  [3109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3433),
  [3112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3483),
  [3115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3480),
  [3118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3469),
  [3121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3429),
  [3124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3427),
  [3127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3439),
  [3130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3444),
  [3133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3449),
  [3136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3425),
  [3139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subexpr_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(3426),
  [3142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(4976),
  [3145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3442),
  [3148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3442),
  [3151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(5026),
  [3154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(4211),
  [3157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(4033),
  [3160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(5512),
  [3163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(5514),
  [3166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3470),
  [3169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3440),
  [3172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(95),
  [3175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(5520),
  [3178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3448),
  [3181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0),
  [3183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0),
  [3185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3488),
  [3188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(4029),
  [3191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(4029),
  [3194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3472),
  [3197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(4027),
  [3200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3472),
  [3203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(4032),
  [3206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3445),
  [3209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3481),
  [3212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3487),
  [3215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3464),
  [3218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3485),
  [3221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3432),
  [3224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3478),
  [3227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3492),
  [3230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3492),
  [3233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(4043),
  [3236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3441),
  [3239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3471),
  [3242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3471),
  [3245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3476),
  [3248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3454),
  [3251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3428),
  [3254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3456),
  [3257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3459),
  [3260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3452),
  [3263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3450),
  [3266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3453),
  [3269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3475),
  [3272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3435),
  [3275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3430),
  [3278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3436),
  [3281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3447),
  [3284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3447),
  [3287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3466),
  [3290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3466),
  [3293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3451),
  [3296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3457),
  [3299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3486),
  [3302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3460),
  [3305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3460),
  [3308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3473),
  [3311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3446),
  [3314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3446),
  [3317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3467),
  [3320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3467),
  [3323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3461),
  [3326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3465),
  [3329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3489),
  [3332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3489),
  [3335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3434),
  [3338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3434),
  [3341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3437),
  [3344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3455),
  [3347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3441),
  [3350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3443),
  [3353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3468),
  [3356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3462),
  [3359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3462),
  [3362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3463),
  [3365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3477),
  [3368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3490),
  [3371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3438),
  [3374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3482),
  [3377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3484),
  [3380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3479),
  [3383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3431),
  [3386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3474),
  [3389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3458),
  [3392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3491),
  [3395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3448),
  [3398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3433),
  [3401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3483),
  [3404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3480),
  [3407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3469),
  [3410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3429),
  [3413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3427),
  [3416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3439),
  [3419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3444),
  [3422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3449),
  [3425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3425),
  [3428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 3, 0, 0), SHIFT(3426),
  [3431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(5026),
  [3434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(4211),
  [3437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(5512),
  [3440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(5514),
  [3443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(95),
  [3446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_subexpr_prefix, 2, 0, 0), SHIFT(5520),
  [3449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4953),
  [3451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [3453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [3457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4844),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [3461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [3463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2871),
  [3465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2516),
  [3467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [3469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [3471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2815),
  [3473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2954),
  [3475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3018),
  [3477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3023),
  [3479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2564),
  [3481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [3483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [3485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [3487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2897),
  [3489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [3491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bound_infix_op, 3, 0, 17),
  [3493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bound_infix_op, 3, 0, 17),
  [3495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bound_prefix_op, 2, 0, 9),
  [3497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bound_prefix_op, 2, 0, 9),
  [3499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_choose, 6, 0, 50),
  [3501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_choose, 6, 0, 50),
  [3503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_then_else, 6, 0, 52),
  [3505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_then_else, 6, 0, 52),
  [3507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_other_arm, 3, 0, 0),
  [3509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_other_arm, 3, 0, 0),
  [3511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unbounded_quantification, 5, 0, 40),
  [3513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unbounded_quantification, 5, 0, 40),
  [3515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 7, 0, 55),
  [3517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 7, 0, 55),
  [3519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assume_prove, 4, 0, 32),
  [3521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assume_prove, 4, 0, 32),
  [3523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bounded_quantification, 5, 0, 45),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bounded_quantification, 5, 0, 45),
  [3527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 6, 0, 49),
  [3529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 6, 0, 49),
  [3531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 3, 0, 15),
  [3533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 3, 0, 15),
  [3535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unbounded_quantification, 4, 0, 25),
  [3537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unbounded_quantification, 4, 0, 25),
  [3539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_choose, 4, 0, 27),
  [3541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_choose, 4, 0, 27),
  [3543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_arm, 3, 0, 0),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_arm, 3, 0, 0),
  [3547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assume_prove, 5, 0, 46),
  [3549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assume_prove, 5, 0, 46),
  [3551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_in, 4, 0, 28),
  [3553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_in, 4, 0, 28),
  [3555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bounded_quantification, 4, 0, 29),
  [3557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bounded_quantification, 4, 0, 29),
  [3559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_body_expr, 1, 0, 0),
  [3561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_body_expr, 1, 0, 0),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [3565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [3567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5453),
  [3569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [3575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [3579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [3583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [3587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [3597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [3599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5414),
  [3601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [3607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [3611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [3615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [3619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [3627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_use_body_expr_repeat1, 2, 0, 0),
  [3629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_body_expr_repeat1, 2, 0, 0),
  [3631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 4, 0, 0),
  [3633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, 0, 0),
  [3635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__op_or_expr, 1, 0, 0),
  [3637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__op_or_expr, 1, 0, 0),
  [3639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 5, 0, 0),
  [3641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 5, 0, 0),
  [3643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_definition, 3, 0, 5),
  [3645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_definition, 3, 0, 5),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_definition, 6, 0, 36),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_definition, 6, 0, 36),
  [3651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_definition, 4, 0, 14),
  [3653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_definition, 4, 0, 14),
  [3655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assumption, 4, 0, 6),
  [3657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assumption, 4, 0, 6),
  [3659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_definition, 5, 0, 23),
  [3661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_definition, 5, 0, 23),
  [3663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 38),
  [3665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 38),
  [3667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_definition, 4, 0, 19),
  [3669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_definition, 4, 0, 19),
  [3671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_definition, 7, 0, 47),
  [3673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_definition, 7, 0, 47),
  [3675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, 0, 48),
  [3677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, 0, 48),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assumption, 2, 0, 0),
  [3681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assumption, 2, 0, 0),
  [3683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5480),
  [3685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [3687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5254),
  [3689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [3695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [3699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [3703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [3707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [3715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [3717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5527),
  [3719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [3727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [3731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [3733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [3737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [3741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [3745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [3747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5116),
  [3749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [3755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [3759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [3763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [3767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [3775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [3777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5209),
  [3779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [3785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [3789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [3793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [3795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [3797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [3799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [3805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4371),
  [3807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4275),
  [3809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4276),
  [3811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4245),
  [3813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4251),
  [3815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4332),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [3819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3442),
  [3822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3442),
  [3825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [3829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3470),
  [3832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3440),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [3837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3991),
  [3840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subexpr_component, 1, 0, 3),
  [3842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3448),
  [3845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3),
  [3847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3488),
  [3850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4027),
  [3853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3445),
  [3856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3481),
  [3859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3487),
  [3862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3464),
  [3865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3485),
  [3868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3432),
  [3871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3478),
  [3874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3492),
  [3877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3492),
  [3880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4043),
  [3883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3441),
  [3886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3471),
  [3889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3471),
  [3892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3476),
  [3895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3454),
  [3898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3428),
  [3901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3456),
  [3904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3459),
  [3907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3452),
  [3910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3450),
  [3913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3453),
  [3916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3475),
  [3919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3435),
  [3922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3430),
  [3925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3436),
  [3928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3447),
  [3931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3447),
  [3934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3466),
  [3937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3466),
  [3940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3451),
  [3943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3457),
  [3946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3486),
  [3949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3460),
  [3952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3460),
  [3955] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3473),
  [3958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3446),
  [3961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3446),
  [3964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3467),
  [3967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3467),
  [3970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3461),
  [3973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3465),
  [3976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3489),
  [3979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3489),
  [3982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3434),
  [3985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3434),
  [3988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3437),
  [3991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3455),
  [3994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3441),
  [3997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3443),
  [4000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3468),
  [4003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3462),
  [4006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3462),
  [4009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3463),
  [4012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3477),
  [4015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3490),
  [4018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3438),
  [4021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3482),
  [4024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3484),
  [4027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3479),
  [4030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3431),
  [4033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3474),
  [4036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3458),
  [4039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3491),
  [4042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3448),
  [4045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3433),
  [4048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3483),
  [4051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3480),
  [4054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3469),
  [4057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3429),
  [4060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3427),
  [4063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3439),
  [4066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3444),
  [4069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3449),
  [4072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3425),
  [4075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(3426),
  [4078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [4084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5263),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [4096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [4100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [4104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5282),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [4120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_proof_step, 2, 0, 0),
  [4122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [4124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [4132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5436),
  [4134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [4140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [4144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [4152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [4160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3288),
  [4162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2771),
  [4164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2394),
  [4166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [4168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4211),
  [4170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3072),
  [4172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [4174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [4176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2641),
  [4178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3154),
  [4180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [4182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [4184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [4186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3229),
  [4188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2653),
  [4190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2926),
  [4192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [4196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5299),
  [4198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [4204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [4212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [4216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [4224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_suffices_proof_step, 1, 0, 0),
  [4226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_var_decl, 3, 0, 0),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [4230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_suffices_proof_step, 2, 0, 0),
  [4232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pick_proof_step, 4, 0, 0),
  [4234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [4238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5367),
  [4240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [4250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [4258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [4266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_negative, 1, 0, 0), REDUCE(sym_minus, 1, 0, 0),
  [4269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_minus, 1, 0, 0),
  [4271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negative, 1, 0, 0),
  [4273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negative, 1, 0, 0),
  [4275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_negative, 1, 0, 0), REDUCE(sym_minus, 1, 0, 0),
  [4278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_minus, 1, 0, 0),
  [4280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_always, 1, 0, 0),
  [4282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_always, 1, 0, 0),
  [4284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lnot, 1, 0, 0),
  [4286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lnot, 1, 0, 0),
  [4288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_eventually, 1, 0, 0),
  [4290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_eventually, 1, 0, 0),
  [4292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_assign, 3, 0, 0),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4979),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [4306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [4308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5206),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [4320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [4328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [4336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [4338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5467),
  [4340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [4342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [4348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [4352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [4360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [4372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_await, 2, 0, 0),
  [4374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_print, 2, 0, 0),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [4380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5517),
  [4384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5008),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [4400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [4406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [4410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [4414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4995),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5031),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4985),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5003),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [4442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4981),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5025),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4962),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [4462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_assert, 2, 0, 0),
  [4464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_assign_repeat1, 4, 0, 0),
  [4466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_assign_repeat1, 4, 0, 0), SHIFT(2209),
  [4469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3852),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [4473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3865),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [4477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4971),
  [4479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [4483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3855),
  [4485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [4489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_with_vars, 3, 0, 0),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [4495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3857),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [4499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3870),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [4503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [4505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5242),
  [4507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [4513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [4517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [4521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [4525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [4533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3997),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [4539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3964),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [4543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3971),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [4547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3980),
  [4549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5326),
  [4551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantifier_bound, 4, 0, 37),
  [4553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantifier_bound, 4, 0, 37),
  [4555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3987),
  [4557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [4559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3999),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [4563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4002),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [4567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4006),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [4571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_finite_set_literal_repeat1, 2, 0, 0),
  [4573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4008),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [4577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3970),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [4581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3958),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [4585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3978),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [4589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_with_vars_repeat1, 4, 0, 0),
  [4591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3996),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [4595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3967),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [4599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3972),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [4603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3973),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [4607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3974),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [4613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantifier_bound, 3, 0, 22),
  [4615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantifier_bound, 3, 0, 22),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5356),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5366),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5468),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [4681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [4685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_witness_proof_step, 2, 0, 0),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [4697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [4727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_proc_var_decl, 3, 0, 0),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [4747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_update, 4, 0, 56),
  [4749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new, 5, 0, 0),
  [4751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assume_prove_repeat1, 2, 0, 0),
  [4753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_set_of_records_repeat1, 4, 0, 0),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [4757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disj_item, 3, 0, 0),
  [4759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conj_item, 3, 0, 0),
  [4761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new, 4, 0, 0),
  [4763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_literal_repeat1, 4, 0, 0),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [4769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [4779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [4803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [4827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [4851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [4857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [4887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [4931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5019),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [4945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5479),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [4963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5502),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [4975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [5033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_have_proof_step, 2, 0, 0),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [5037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [5061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [5069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [5099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [5135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [5139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [5153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [5161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [5181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_restricted_quantifier_bound, 3, 0, 22),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [5185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5434),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5434),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5537),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [5193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5545),
  [5195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5183),
  [5197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5281),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5313),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5363),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5403),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5410),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5412),
  [5215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5412),
  [5217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5432),
  [5219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5458),
  [5221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5465),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5465),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5488),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5082),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5298),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5321),
  [5249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5330),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5330),
  [5253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5338),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [5257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5369),
  [5263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5370),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [5269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5426),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5426),
  [5273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5493),
  [5275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5543),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [5281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5069),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [5285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5071),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5071),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5458),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5108),
  [5299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5109),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5110),
  [5305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5112),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5142),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5203),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5545),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5255),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5280),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5284),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5297),
  [5345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_proof_step_id, 5, 0, 0),
  [5347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_proof_step_id, 5, 0, 0),
  [5349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_langle_bracket, 1, 0, 0),
  [5351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_langle_bracket, 1, 0, 0),
  [5353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_def_eq, 1, 0, 0),
  [5355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_def_eq, 1, 0, 0),
  [5357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_box, 1, 0, 0),
  [5359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_box, 1, 0, 0),
  [5361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label_as, 1, 0, 0),
  [5363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label_as, 1, 0, 0),
  [5365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gets, 1, 0, 0),
  [5367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gets, 1, 0, 0),
  [5369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_doteq, 1, 0, 0),
  [5371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_doteq, 1, 0, 0),
  [5373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqcup, 1, 0, 0),
  [5375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqcup, 1, 0, 0),
  [5377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bnf_rule, 1, 0, 0),
  [5379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bnf_rule, 1, 0, 0),
  [5381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_otimes, 1, 0, 0),
  [5383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_otimes, 1, 0, 0),
  [5385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bigcirc, 1, 0, 0),
  [5387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bigcirc, 1, 0, 0),
  [5389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_circ, 1, 0, 0),
  [5391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_circ, 1, 0, 0),
  [5393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bullet, 1, 0, 0),
  [5395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bullet, 1, 0, 0),
  [5397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_excl, 1, 0, 0),
  [5399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_excl, 1, 0, 0),
  [5401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_div, 1, 0, 0),
  [5403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_div, 1, 0, 0),
  [5405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cdot, 1, 0, 0),
  [5407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cdot, 1, 0, 0),
  [5409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_star, 1, 0, 0),
  [5411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_star, 1, 0, 0),
  [5413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lt, 1, 0, 0),
  [5415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lt, 1, 0, 0),
  [5417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_times, 1, 0, 0),
  [5419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_times, 1, 0, 0),
  [5421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_leq, 1, 0, 0),
  [5423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_leq, 1, 0, 0),
  [5425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qq, 1, 0, 0),
  [5427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qq, 1, 0, 0),
  [5429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_in, 1, 0, 0),
  [5431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_in, 1, 0, 0),
  [5433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_wr, 1, 0, 0),
  [5435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wr, 1, 0, 0),
  [5437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_in, 1, 0, 0),
  [5439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in, 1, 0, 0),
  [5441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_land, 1, 0, 0),
  [5443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_land, 1, 0, 0),
  [5445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rd_ttile, 1, 0, 0),
  [5447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rd_ttile, 1, 0, 0),
  [5449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_neq, 1, 0, 0),
  [5451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_neq, 1, 0, 0),
  [5453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_eq, 1, 0, 0),
  [5455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_eq, 1, 0, 0),
  [5457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_maps_to, 1, 0, 0),
  [5459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_maps_to, 1, 0, 0),
  [5461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implies, 1, 0, 0),
  [5463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implies, 1, 0, 0),
  [5465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uplus, 1, 0, 0),
  [5467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uplus, 1, 0, 0),
  [5469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_plus_arrow, 1, 0, 0),
  [5471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_plus_arrow, 1, 0, 0),
  [5473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_equiv, 1, 0, 0),
  [5475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equiv, 1, 0, 0),
  [5477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ls_ttile, 1, 0, 0),
  [5479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ls_ttile, 1, 0, 0),
  [5481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lor, 1, 0, 0),
  [5483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lor, 1, 0, 0),
  [5485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ld_ttile, 1, 0, 0),
  [5487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ld_ttile, 1, 0, 0),
  [5489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asymp, 1, 0, 0),
  [5491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asymp, 1, 0, 0),
  [5493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cong, 1, 0, 0),
  [5495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cong, 1, 0, 0),
  [5497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rs_ttile, 1, 0, 0),
  [5499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rs_ttile, 1, 0, 0),
  [5501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gg, 1, 0, 0),
  [5503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gg, 1, 0, 0),
  [5505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ll, 1, 0, 0),
  [5507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ll, 1, 0, 0),
  [5509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_notin, 1, 0, 0),
  [5511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_notin, 1, 0, 0),
  [5513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prec, 1, 0, 0),
  [5515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prec, 1, 0, 0),
  [5517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_odot, 1, 0, 0),
  [5519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_odot, 1, 0, 0),
  [5521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_succ, 1, 0, 0),
  [5523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_succ, 1, 0, 0),
  [5525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preceq, 1, 0, 0),
  [5527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preceq, 1, 0, 0),
  [5529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_succeq, 1, 0, 0),
  [5531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_succeq, 1, 0, 0),
  [5533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_leads_to, 1, 0, 0),
  [5535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_leads_to, 1, 0, 0),
  [5537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_propto, 1, 0, 0),
  [5539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_propto, 1, 0, 0),
  [5541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sim, 1, 0, 0),
  [5543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sim, 1, 0, 0),
  [5545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assign, 1, 0, 0),
  [5547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assign, 1, 0, 0),
  [5549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_geq, 1, 0, 0),
  [5551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_geq, 1, 0, 0),
  [5553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simeq, 1, 0, 0),
  [5555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simeq, 1, 0, 0),
  [5557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqsubset, 1, 0, 0),
  [5559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqsubset, 1, 0, 0),
  [5561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqsupset, 1, 0, 0),
  [5563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqsupset, 1, 0, 0),
  [5565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_approx, 1, 0, 0),
  [5567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_approx, 1, 0, 0),
  [5569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqsubseteq, 1, 0, 0),
  [5571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqsubseteq, 1, 0, 0),
  [5573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqsupseteq, 1, 0, 0),
  [5575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqsupseteq, 1, 0, 0),
  [5577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset, 1, 0, 0),
  [5579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset, 1, 0, 0),
  [5581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_supset, 1, 0, 0),
  [5583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_supset, 1, 0, 0),
  [5585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subseteq, 1, 0, 0),
  [5587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subseteq, 1, 0, 0),
  [5589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_supseteq, 1, 0, 0),
  [5591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_supseteq, 1, 0, 0),
  [5593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cap, 1, 0, 0),
  [5595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cap, 1, 0, 0),
  [5597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cup, 1, 0, 0),
  [5599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cup, 1, 0, 0),
  [5601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dots_2, 1, 0, 0),
  [5603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dots_2, 1, 0, 0),
  [5605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dots_3, 1, 0, 0),
  [5607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dots_3, 1, 0, 0),
  [5609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_oslash, 1, 0, 0),
  [5611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_oslash, 1, 0, 0),
  [5613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_arrow, 1, 0, 0),
  [5615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_arrow, 1, 0, 0),
  [5617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_all_map_to, 1, 0, 0),
  [5619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_all_map_to, 1, 0, 0),
  [5621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bullet_conj, 1, 0, 0),
  [5623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bullet_conj, 1, 0, 0),
  [5625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_plus, 1, 0, 0),
  [5627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_plus, 1, 0, 0),
  [5629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_oplus, 1, 0, 0),
  [5631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_oplus, 1, 0, 0),
  [5633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqcap, 1, 0, 0),
  [5635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqcap, 1, 0, 0),
  [5637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ominus, 1, 0, 0),
  [5639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ominus, 1, 0, 0),
  [5641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bullet_disj, 1, 0, 0),
  [5643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bullet_disj, 1, 0, 0),
  [5645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vertvert, 1, 0, 0),
  [5647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vertvert, 1, 0, 0),
  [5649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iff, 1, 0, 0),
  [5651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iff, 1, 0, 0),
  [5653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [5655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [5657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [5659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [5661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [5663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, 0, 0),
  [5665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_repeat1, 2, 0, 0),
  [5667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, 0, 0), SHIFT_REPEAT(2136),
  [5670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 3, 0, 0),
  [5672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 3, 0, 0),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [5676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__subscript_expr, 1, 0, 3),
  [5678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__subscript_expr, 1, 0, 3),
  [5680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [5682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [5684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 2, 0, 0),
  [5686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 2, 0, 0),
  [5688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr, 1, 0, 0),
  [5690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr, 1, 0, 0),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [5694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subexpr_component, 1, 0, 0),
  [5696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bound_op, 5, 0, 41),
  [5698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bound_op, 5, 0, 41),
  [5700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_op, 2, 0, 10),
  [5702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_op, 2, 0, 10),
  [5704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__subscript_expr, 1, 0, 0),
  [5706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__subscript_expr, 1, 0, 0),
  [5708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_proof_step_ref, 4, 0, 0),
  [5710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_proof_step_ref, 4, 0, 0),
  [5712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bound_nonfix_op, 4, 0, 30),
  [5714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bound_nonfix_op, 4, 0, 30),
  [5716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bound_nonfix_op, 6, 0, 30),
  [5718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bound_nonfix_op, 6, 0, 30),
  [5720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bound_op, 4, 0, 26),
  [5722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bound_op, 4, 0, 26),
  [5724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [5726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [5728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conj_list, 3, 0, 0),
  [5730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conj_list, 3, 0, 0),
  [5732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disj_list, 3, 0, 0),
  [5734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disj_list, 3, 0, 0),
  [5736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parentheses, 3, 0, 0),
  [5738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parentheses, 3, 0, 0),
  [5740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [5742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [5744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finite_set_literal, 3, 0, 0),
  [5746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finite_set_literal, 3, 0, 0),
  [5748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_literal, 3, 0, 0),
  [5750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_literal, 3, 0, 0),
  [5752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_value, 3, 0, 16),
  [5754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_value, 3, 0, 16),
  [5756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_number, 2, 0, 0),
  [5758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_number, 2, 0, 0),
  [5760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_octal_number, 2, 0, 8),
  [5762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_octal_number, 2, 0, 8),
  [5764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hex_number, 2, 0, 0),
  [5766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hex_number, 2, 0, 0),
  [5768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primitive_value_set, 1, 0, 0),
  [5770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primitive_value_set, 1, 0, 0),
  [5772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finite_set_literal, 2, 0, 0),
  [5774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finite_set_literal, 2, 0, 0),
  [5776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [5778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_step_expr_or_stutter, 4, 0, 0),
  [5780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_step_expr_or_stutter, 4, 0, 0),
  [5782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finite_set_literal, 4, 0, 0),
  [5784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finite_set_literal, 4, 0, 0),
  [5786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, 0, 0),
  [5788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, 0, 0),
  [5790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_step_expr_no_stutter, 4, 0, 0),
  [5792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_step_expr_no_stutter, 4, 0, 0),
  [5794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_literal, 4, 0, 0),
  [5796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_literal, 4, 0, 0),
  [5798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_args, 3, 0, 0),
  [5800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_args, 3, 0, 0),
  [5802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_evaluation, 4, 0, 0),
  [5804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_evaluation, 4, 0, 0),
  [5806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nat_number, 1, 0, 0),
  [5808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nat_number, 1, 0, 0),
  [5810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_of_records, 5, 0, 0),
  [5812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_of_records, 5, 0, 0),
  [5814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_literal, 5, 0, 0),
  [5816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_literal, 5, 0, 0),
  [5818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except, 5, 0, 42),
  [5820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except, 5, 0, 42),
  [5822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_of_functions, 5, 0, 0),
  [5824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_of_functions, 5, 0, 0),
  [5826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 5, 0, 0),
  [5828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 5, 0, 0),
  [5830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_map, 5, 0, 43),
  [5832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_map, 5, 0, 43),
  [5834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_filter, 5, 1, 44),
  [5836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_filter, 5, 1, 44),
  [5838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fairness, 5, 0, 0),
  [5840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fairness, 5, 0, 0),
  [5842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, 0, 0),
  [5844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, 0, 0),
  [5846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_args, 4, 0, 0),
  [5848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_args, 4, 0, 0),
  [5850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prev_func_val, 1, 0, 0),
  [5852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prev_func_val, 1, 0, 0),
  [5854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 1, 0, 0),
  [5856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 1, 0, 0),
  [5858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1, 0, 0),
  [5860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0),
  [5862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_evaluation, 5, 0, 0),
  [5864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_evaluation, 5, 0, 0),
  [5866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [5868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subexpression, 2, 0, 0),
  [5870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subexpression, 2, 0, 0),
  [5872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_of_records, 6, 0, 0),
  [5874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_of_records, 6, 0, 0),
  [5876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_literal, 6, 0, 0),
  [5878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_literal, 6, 0, 0),
  [5880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except, 6, 0, 42),
  [5882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except, 6, 0, 42),
  [5884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_map, 6, 0, 51),
  [5886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_map, 6, 0, 51),
  [5888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bound_postfix_op, 2, 0, 12),
  [5890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bound_postfix_op, 2, 0, 12),
  [5892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nat_number_set, 1, 0, 0),
  [5894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nat_number_set, 1, 0, 0),
  [5896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int_number_set, 1, 0, 0),
  [5898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int_number_set, 1, 0, 0),
  [5900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_real_number_set, 1, 0, 0),
  [5902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_real_number_set, 1, 0, 0),
  [5904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number_set, 1, 0, 0),
  [5906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number_set, 1, 0, 0),
  [5908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rangle_bracket, 1, 0, 0),
  [5910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rangle_bracket, 1, 0, 0),
  [5912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_literal, 2, 0, 0),
  [5914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_literal, 2, 0, 0),
  [5916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_colon, 1, 0, 0),
  [5918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_colon, 1, 0, 0),
  [5920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_address, 1, 0, 0),
  [5922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_address, 1, 0, 0),
  [5924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_child_id, 1, 0, 0),
  [5926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_child_id, 1, 0, 0),
  [5928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subexpr_tree_nav, 1, 0, 0),
  [5930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subexpr_tree_nav, 1, 0, 0),
  [5932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_op, 2, 0, 11),
  [5934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_op, 2, 0, 11),
  [5936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 6, 0, 0),
  [5938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 6, 0, 0),
  [5940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sup_plus, 1, 0, 0),
  [5942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sup_plus, 1, 0, 0),
  [5944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [5946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [5948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [5950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [5952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [5954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [5956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [5958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [5960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rangle_bracket_sub, 1, 0, 0),
  [5962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rangle_bracket_sub, 1, 0, 0),
  [5964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(2154),
  [5967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(2154),
  [5970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [5972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5518),
  [5976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [5978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [5980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [5982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [5986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [5988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [5990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [5992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [5994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [5996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [5998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [6000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [6002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [6004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [6006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [6008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [6010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [6012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [6014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4211),
  [6017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(5518),
  [6020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [6022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [6024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(694),
  [6027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(5212),
  [6030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), REDUCE(sym_pcal_lhs, 1, 0, 3),
  [6033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [6035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [6037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [6039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [6041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [6043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3866),
  [6045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [6047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [6049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(5251),
  [6052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4762),
  [6055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4939),
  [6058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4594),
  [6061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4655),
  [6064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4710),
  [6067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [6069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4766),
  [6072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [6074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4809),
  [6077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4911),
  [6080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4438),
  [6083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4468),
  [6086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4852),
  [6089] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__id_or_op_declaration, 1, 0, 0), REDUCE(sym__expr, 1, 0, 3), SHIFT(5251),
  [6093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [6095] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__id_or_op_declaration, 1, 0, 0), REDUCE(sym__expr, 1, 0, 3), SHIFT(4852),
  [6099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4510),
  [6102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4681),
  [6105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4533),
  [6108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4857),
  [6111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [6113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expr, 1, 0, 3), SHIFT(4488),
  [6116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [6118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [6122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3621),
  [6124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3867),
  [6126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3873),
  [6128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [6130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [6132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [6136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2, 0, 0),
  [6138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0),
  [6140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(1755),
  [6143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(5523),
  [6146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4033),
  [6149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(3635),
  [6152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(5435),
  [6155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(3872),
  [6158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(3859),
  [6161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(5451),
  [6164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4693),
  [6167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4693),
  [6170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4700),
  [6173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4700),
  [6176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4701),
  [6179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4701),
  [6182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4029),
  [6185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(3472),
  [6188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(3472),
  [6191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(4032),
  [6194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(747),
  [6197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(186),
  [6200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(27),
  [6203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [6205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(1750),
  [6208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(3621),
  [6211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(3867),
  [6214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(3873),
  [6217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(5470),
  [6220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(693),
  [6223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(188),
  [6226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 2, 0, 0), SHIFT_REPEAT(29),
  [6229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_op_symbol, 1, 0, 0),
  [6231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_op_symbol, 1, 0, 0),
  [6233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infix_op_symbol, 1, 0, 0),
  [6235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infix_op_symbol, 1, 0, 0),
  [6237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [6239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [6241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5518),
  [6244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qed_step, 3, 0, 0),
  [6246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qed_step, 3, 0, 0),
  [6248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__op, 1, 0, 0),
  [6250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__op, 1, 0, 0),
  [6252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_body_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(209),
  [6255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_body_expr, 2, 0, 0),
  [6257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_body_expr, 2, 0, 0),
  [6259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_body_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(198),
  [6262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__id_or_op_declaration, 1, 0, 0),
  [6264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__id_or_op_declaration, 1, 0, 0),
  [6266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5473),
  [6268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution, 3, 0, 0),
  [6270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution, 3, 0, 0),
  [6272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitution, 3, 0, 3),
  [6274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitution, 3, 0, 3),
  [6276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2412),
  [6278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instance_repeat1, 2, 0, 0),
  [6280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instance_repeat1, 2, 0, 0),
  [6282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_ref, 2, 0, 2),
  [6284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_ref, 2, 0, 2),
  [6286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2480),
  [6288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5195),
  [6290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 3, 0, 6),
  [6292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 3, 0, 6),
  [6294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5093),
  [6296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 4, 0, 24),
  [6298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 4, 0, 24),
  [6300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 2, 0, 7),
  [6302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 2, 0, 7),
  [6304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 5, 0, 39),
  [6306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 5, 0, 39),
  [6308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 2, 0, 6),
  [6310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 2, 0, 6),
  [6312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_definition, 6, 0, 36),
  [6314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_definition, 6, 0, 36),
  [6316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_definition, 3, 0, 5),
  [6318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_definition, 3, 0, 5),
  [6320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_definition, 7, 0, 47),
  [6322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_definition, 7, 0, 47),
  [6324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 0),
  [6326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3, 0, 0),
  [6328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__definition, 1, 0, 0),
  [6330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__definition, 1, 0, 0),
  [6332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 0),
  [6334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, 0, 0),
  [6336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_body, 1, 0, 0),
  [6338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_body, 1, 0, 0),
  [6340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_single_line, 2, 0, 0),
  [6342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_single_line, 2, 0, 0),
  [6344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [6346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [6348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [6350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_repeat1, 2, 0, 0),
  [6352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_repeat1, 2, 0, 0),
  [6354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_repeat1, 2, 0, 0), SHIFT_REPEAT(5251),
  [6357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constant_declaration_repeat1, 2, 0, 0),
  [6359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_constant_declaration_repeat1, 2, 0, 0),
  [6361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(3864),
  [6364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [6366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(3858),
  [6369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instance, 5, 0, 2),
  [6371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance, 5, 0, 2),
  [6373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [6375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends, 2, 0, 2),
  [6377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends, 2, 0, 2),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [6381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instance_repeat1, 2, 0, 0), SHIFT_REPEAT(1482),
  [6384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 2, 0, 0),
  [6386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 2, 0, 0),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [6390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_declaration, 2, 0, 0),
  [6392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_declaration, 2, 0, 0),
  [6394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 3, 0, 0),
  [6396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 3, 0, 0),
  [6398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_body_def, 3, 0, 0),
  [6400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_body_def, 3, 0, 0),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [6404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_declaration, 3, 0, 0),
  [6406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_declaration, 3, 0, 0),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [6410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instance, 4, 0, 2),
  [6412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance, 4, 0, 2),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [6418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_use_body_def_repeat1, 2, 0, 0),
  [6420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_body_def_repeat1, 2, 0, 0),
  [6422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_body_def_repeat1, 2, 0, 0), SHIFT_REPEAT(36),
  [6425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_body_def, 2, 0, 0),
  [6427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_body_def, 2, 0, 0),
  [6429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_body_def_repeat1, 2, 0, 0), SHIFT_REPEAT(35),
  [6432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instance_repeat1, 2, 0, 0), SHIFT_REPEAT(1476),
  [6435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_repeat1, 2, 0, 2),
  [6437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_repeat1, 2, 0, 2),
  [6439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unit, 1, 0, 0),
  [6441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unit, 1, 0, 0),
  [6443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5239),
  [6445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends, 3, 0, 2),
  [6447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends, 3, 0, 2),
  [6449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 5, 0, 33),
  [6451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 5, 0, 33),
  [6453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_definition, 2, 0, 0),
  [6455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_definition, 2, 0, 0),
  [6457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance, 2, 0, 2),
  [6459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instance, 2, 0, 2),
  [6461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [6463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qed_step, 4, 0, 0),
  [6465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qed_step, 4, 0, 0),
  [6467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_terminal_proof, 1, 0, 0),
  [6469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_terminal_proof, 1, 0, 0),
  [6471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_theorem, 3, 0, 13),
  [6473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_theorem, 3, 0, 13),
  [6475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__proof, 1, 0, 0),
  [6477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__proof, 1, 0, 0),
  [6479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_theorem, 5, 0, 31),
  [6481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_theorem, 5, 0, 31),
  [6483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_terminal_proof, 3, 0, 0),
  [6485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_terminal_proof, 3, 0, 0),
  [6487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 7, 0, 33),
  [6489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 7, 0, 33),
  [6491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_terminal_proof, 3, 0, 0),
  [6493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_terminal_proof, 3, 0, 0),
  [6495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double_line, 2, 0, 0),
  [6497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double_line, 2, 0, 0),
  [6499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 6, 0, 33),
  [6501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 6, 0, 33),
  [6503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_or_hide, 2, 0, 0),
  [6505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_or_hide, 2, 0, 0),
  [6507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [6509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat2, 1, 0, 0),
  [6511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat2, 1, 0, 0),
  [6513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_terminal_proof, 2, 0, 0),
  [6515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_terminal_proof, 2, 0, 0),
  [6517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_terminal_proof, 2, 0, 0),
  [6519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_terminal_proof, 2, 0, 0),
  [6521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [6523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [6525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5433),
  [6527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_terminal_proof, 4, 0, 0),
  [6529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_terminal_proof, 4, 0, 0),
  [6531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_terminal_proof, 4, 0, 0),
  [6533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_terminal_proof, 4, 0, 0),
  [6535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_body, 2, 0, 0),
  [6537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_body, 2, 0, 0),
  [6539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(1746),
  [6542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(4033),
  [6545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(5452),
  [6548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(4693),
  [6551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(4693),
  [6554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(4700),
  [6557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(4700),
  [6560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(4701),
  [6563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(4701),
  [6566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0),
  [6568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(4029),
  [6571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(3472),
  [6574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(3472),
  [6577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0), SHIFT_REPEAT(4032),
  [6580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 2, 0, 0),
  [6582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [6584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [6586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5188),
  [6588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [6590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [6592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [6594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [6596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [6598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [6600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [6602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [6604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [6606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [6608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [6610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [6612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [6614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [6616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [6618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [6620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [6622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [6624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(1754),
  [6627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(4033),
  [6630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(3871),
  [6633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(4693),
  [6636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(4693),
  [6639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(4700),
  [6642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(4700),
  [6645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(4701),
  [6648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(4701),
  [6651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0),
  [6653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(4029),
  [6656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(3472),
  [6659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(3472),
  [6662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_in_repeat1, 2, 0, 0), SHIFT_REPEAT(4032),
  [6665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [6667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition_proof_step, 1, 0, 0),
  [6669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0), SHIFT_REPEAT(1747),
  [6672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0), SHIFT_REPEAT(4033),
  [6675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0), SHIFT_REPEAT(4693),
  [6678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0), SHIFT_REPEAT(4693),
  [6681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0), SHIFT_REPEAT(4700),
  [6684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0), SHIFT_REPEAT(4700),
  [6687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0), SHIFT_REPEAT(4701),
  [6690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0), SHIFT_REPEAT(4701),
  [6693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0), SHIFT_REPEAT(4029),
  [6696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0), SHIFT_REPEAT(3472),
  [6699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0), SHIFT_REPEAT(3472),
  [6702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0), SHIFT_REPEAT(4032),
  [6705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_definition_proof_step_repeat1, 2, 0, 0),
  [6707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition_proof_step, 2, 0, 0),
  [6709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4012),
  [6711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [6713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [6715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5114),
  [6717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5122),
  [6719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3651),
  [6721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5126),
  [6723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [6725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [6727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [6729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4375),
  [6731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5216),
  [6733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5218),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [6737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [6739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [6741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3648),
  [6743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4998),
  [6745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4194),
  [6747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5147),
  [6749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2591),
  [6751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pcal_p_stmts_repeat1, 2, 0, 35), SHIFT_REPEAT(4012),
  [6754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pcal_p_stmts_repeat1, 2, 0, 35), SHIFT_REPEAT(570),
  [6757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pcal_p_stmts_repeat1, 2, 0, 35), SHIFT_REPEAT(571),
  [6760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pcal_p_stmts_repeat1, 2, 0, 35), SHIFT_REPEAT(3648),
  [6763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pcal_p_stmts_repeat1, 2, 0, 35), SHIFT_REPEAT(4998),
  [6766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pcal_p_stmts_repeat1, 2, 0, 35), SHIFT_REPEAT(593),
  [6769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pcal_p_stmts_repeat1, 2, 0, 35), SHIFT_REPEAT(599),
  [6772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pcal_p_stmts_repeat1, 2, 0, 35), SHIFT_REPEAT(600),
  [6775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pcal_p_stmts_repeat1, 2, 0, 35), SHIFT_REPEAT(4194),
  [6778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pcal_p_stmts_repeat1, 2, 0, 35), SHIFT_REPEAT(5216),
  [6781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pcal_p_stmts_repeat1, 2, 0, 35), SHIFT_REPEAT(5218),
  [6784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [6786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2668),
  [6788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4070),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5137),
  [6794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4162),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [6798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [6800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5472),
  [6802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4068),
  [6804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2756),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [6808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instance_repeat1, 2, 0, 0), SHIFT_REPEAT(1479),
  [6811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5220),
  [6813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [6815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [6819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(3861),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [6824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instance_repeat1, 2, 0, 0), SHIFT_REPEAT(1481),
  [6827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [6829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [6831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5477),
  [6833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [6835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 1, 0, 0),
  [6837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_p_definitions_repeat1, 1, 0, 0),
  [6839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [6841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instance_repeat1, 2, 0, 0), SHIFT_REPEAT(1484),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [6846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [6848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_let_in_repeat1, 1, 0, 0),
  [6850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_let_in_repeat1, 1, 0, 0),
  [6852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [6854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [6856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3805),
  [6858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [6860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_definition_proof_step_repeat1, 1, 0, 0),
  [6862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_definition_proof_step_repeat1, 1, 0, 0),
  [6864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4037),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5222),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5509),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4984),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5529),
  [6886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__pcal_p_stmts_repeat1, 2, 0, 21),
  [6888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_p_stmts, 3, 0, 35),
  [6890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_level, 1, 0, 0),
  [6892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_level, 1, 0, 0),
  [6894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_p_stmts, 2, 0, 21),
  [6896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_label, 2, 0, 34),
  [6898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_label, 2, 0, 34),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [6902] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [6904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3889),
  [6906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_comment_repeat1, 2, 0, 0),
  [6908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_comment_repeat1, 2, 0, 0), SHIFT_REPEAT(4014),
  [6911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_comment_repeat1, 2, 0, 0), SHIFT_REPEAT(5092),
  [6914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_comment_repeat1, 2, 0, 0), SHIFT_REPEAT(5107),
  [6917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5550),
  [6919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4014),
  [6921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5092),
  [6923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5107),
  [6925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5551),
  [6927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_label, 3, 0, 34),
  [6929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_label, 3, 0, 34),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [6933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_var_decl, 1, 0, 0),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [6937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_assign, 4, 0, 0),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [6941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_var_decls, 2, 0, 0),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [6945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_var_decls, 3, 0, 0),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [6949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_var_decls_repeat1, 2, 0, 0), SHIFT_REPEAT(4949),
  [6952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_var_decls_repeat1, 2, 0, 0),
  [6954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_assign_repeat1, 2, 0, 0),
  [6956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_assign_repeat1, 2, 0, 0), SHIFT_REPEAT(3482),
  [6959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_algorithm_body, 4, 0, 53),
  [6961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_algorithm_body, 3, 0, 20),
  [6963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3913),
  [6965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pcal_var_decls, 3, 0, 0),
  [6967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_algorithm_body, 5, 0, 53),
  [6969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_var_decls, 4, 0, 0),
  [6971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pcal_var_decls, 4, 0, 0),
  [6973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_algorithm_body, 4, 0, 20),
  [6975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_p_algorithm, 7, 0, 6),
  [6977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3957),
  [6979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_p_algorithm, 6, 0, 6),
  [6981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4009),
  [6983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_p_algorithm, 9, 0, 6),
  [6985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3963),
  [6987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_p_algorithm, 10, 0, 6),
  [6989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3965),
  [6991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_c_algorithm_repeat1, 2, 0, 0),
  [6993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pcal_c_algorithm_repeat1, 2, 0, 0), SHIFT_REPEAT(5215),
  [6996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_p_algorithm, 8, 0, 6),
  [6998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3960),
  [7000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_comment_text, 1, 0, 0),
  [7002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pcal_p_algorithm_repeat1, 2, 0, 0), SHIFT_REPEAT(5215),
  [7005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_p_algorithm_repeat1, 2, 0, 0),
  [7007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_comment_text_repeat1, 2, 0, 0),
  [7009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_comment_text_repeat1, 2, 0, 0), SHIFT_REPEAT(4014),
  [7012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [7014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [7018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_c_algorithm, 9, 0, 6),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [7022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_c_algorithm, 10, 0, 6),
  [7024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_p_algorithm, 11, 0, 6),
  [7026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_c_algorithm, 6, 0, 6),
  [7028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_c_algorithm_repeat2, 2, 0, 0),
  [7030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pcal_c_algorithm_repeat2, 2, 0, 0), SHIFT_REPEAT(5222),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [7037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pcal_algorithm, 1, 0, 1),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [7043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pcal_p_algorithm_repeat2, 2, 0, 0), SHIFT_REPEAT(5222),
  [7046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_p_algorithm_repeat2, 2, 0, 0),
  [7048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [7050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [7052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_comment_repeat1, 1, 0, 0),
  [7054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [7056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [7058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [7062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_c_algorithm, 7, 0, 6),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [7078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_c_algorithm, 8, 0, 6),
  [7080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3887),
  [7082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5212),
  [7088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_lhs, 1, 0, 3),
  [7090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [7092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_comment_text_repeat1, 1, 0, 0),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [7096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [7100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_proc_call, 5, 0, 6),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [7104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [7108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bound_or_identifier_list, 2, 0, 0),
  [7110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [7128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new, 3, 0, 0),
  [7130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_proc_call, 4, 0, 6),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [7138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_proc_call, 6, 0, 6),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [7148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_macro, 2, 0, 0),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [7152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bound_or_identifier_list, 1, 0, 0),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4342),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [7164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_macro_call, 5, 0, 7),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [7172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_definitions, 4, 0, 0),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [7180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_macro, 4, 0, 0),
  [7182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_goto, 2, 0, 4),
  [7184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new, 2, 0, 0),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [7190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_definitions, 4, 0, 0),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [7202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_macro_call, 4, 0, 7),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [7206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_except_update_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(702),
  [7209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_except_update_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(5378),
  [7212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_except_update_specifier_repeat1, 2, 0, 0),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [7216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_update_specifier, 1, 0, 0),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [7236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_macro_call, 3, 0, 7),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [7246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [7250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_if, 6, 0, 62),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [7254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_p_stmts, 1, 0, 21),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [7258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_p_stmt, 1, 0, 0),
  [7260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_if, 9, 0, 72),
  [7262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [7268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_macro, 5, 0, 0),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [7272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_finite_set_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(324),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [7279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5496),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5533),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5245),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [7287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_p_algorithm_repeat1, 1, 0, 0),
  [7289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [7291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_proc_decl, 4, 0, 6),
  [7293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4722),
  [7295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4722),
  [7297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_procedure, 2, 0, 0),
  [7299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [7301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [7303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [7305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5151),
  [7307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pcal_proc_var_decls_repeat1, 2, 0, 0), SHIFT_REPEAT(4302),
  [7310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_proc_var_decls_repeat1, 2, 0, 0),
  [7312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pcal_proc_var_decls_repeat1, 2, 0, 0),
  [7314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_definitions, 5, 0, 0),
  [7316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_c_algorithm_repeat1, 1, 0, 0),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [7320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_if, 7, 0, 66),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [7324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_macro, 3, 0, 0),
  [7326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4302),
  [7328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_proc_var_decls, 2, 0, 0),
  [7330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pcal_proc_var_decls, 2, 0, 0),
  [7332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_proc_decl, 6, 0, 6),
  [7334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_proc_decl, 5, 0, 6),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [7338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_p_unlabeled_stmt, 1, 0, 0),
  [7340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_c_algorithm_repeat3, 2, 0, 0),
  [7342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pcal_c_algorithm_repeat3, 2, 0, 0), SHIFT_REPEAT(4984),
  [7345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pcal_c_algorithm_repeat3, 2, 0, 0), SHIFT_REPEAT(5529),
  [7348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_body_expr_repeat1, 2, 0, 0), SHIFT_REPEAT(226),
  [7351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_definitions, 5, 0, 0),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [7355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [7357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_p_algorithm_repeat3, 2, 0, 0),
  [7359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pcal_p_algorithm_repeat3, 2, 0, 0), SHIFT_REPEAT(4961),
  [7362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pcal_p_algorithm_repeat3, 2, 0, 0), SHIFT_REPEAT(5224),
  [7365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_either, 3, 0, 53),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [7369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_while, 6, 0, 63),
  [7371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pcal_with_vars_repeat1, 2, 0, 0), SHIFT_REPEAT(5365),
  [7374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_with_vars_repeat1, 2, 0, 0),
  [7376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_lhs, 2, 0, 3),
  [7378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5189),
  [7381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_either, 5, 0, 60),
  [7383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [7385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_procedure, 4, 0, 0),
  [7387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_with, 6, 0, 64),
  [7389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_if, 8, 0, 70),
  [7391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_p_stmt, 2, 0, 21),
  [7393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_finite_set_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(700),
  [7396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3994),
  [7399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_p_stmts, 2, 0, 35),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [7403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_lhs_repeat1, 2, 0, 0), SHIFT_REPEAT(694),
  [7406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_lhs_repeat1, 2, 0, 0), SHIFT_REPEAT(5212),
  [7409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_lhs_repeat1, 2, 0, 0),
  [7411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_c_either_repeat1, 2, 0, 35),
  [7413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_c_either_repeat1, 2, 0, 35), SHIFT_REPEAT(3645),
  [7416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [7418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(5523),
  [7421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [7423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [7425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5348),
  [7427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [7429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_with_vars, 4, 0, 0),
  [7431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [7433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [7435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [7437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [7439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(4010),
  [7442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4617),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [7450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5445),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [7464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4957),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [7470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_procedure, 3, 0, 0),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [7478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_lhs_repeat1, 3, 0, 0),
  [7480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_process, 9, 0, 68),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4940),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [7486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_process, 9, 0, 65),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [7508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_c_either_repeat1, 2, 0, 20),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [7512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_process, 9, 0, 71),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [7516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_process, 9, 0, 68),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [7524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_process, 10, 0, 68),
  [7526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [7534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [7538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_if, 5, 0, 61),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [7542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [7546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_process, 10, 0, 71),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [7552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_while, 5, 0, 61),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [7556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_process, 7, 0, 65),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4896),
  [7560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_with, 5, 0, 61),
  [7562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_proc_var_decl, 1, 0, 0),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4988),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [7576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_procedure, 5, 0, 0),
  [7578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exists, 1, 0, 0),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [7582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [7590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(4617),
  [7593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [7595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(4617),
  [7598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3853),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [7610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_p_algorithm_repeat2, 1, 0, 0),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [7614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [7618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_c_algorithm_repeat2, 1, 0, 0),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [7624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_process, 8, 0, 65),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [7628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_process, 7, 0, 6),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [7632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_process, 8, 0, 6),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4909),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [7642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [7648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [7650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_p_if_repeat1, 2, 0, 35),
  [7652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_p_if_repeat1, 2, 0, 35), SHIFT_REPEAT(773),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [7663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_lhs_repeat1, 4, 0, 0),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [7669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3863),
  [7671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_if, 7, 0, 67),
  [7673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forall, 1, 0, 0),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [7693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_c_unlabeled_stmt, 1, 0, 0),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [7699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_c_stmt, 1, 0, 0),
  [7701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [7703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [7705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3860),
  [7707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [7709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [7711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [7715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [7717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [7721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [7725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [7729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [7731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_conj_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4918),
  [7734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_conj_list_repeat1, 2, 0, 0),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5345),
  [7742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [7748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3854),
  [7750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_disj_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4920),
  [7753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_disj_list_repeat1, 2, 0, 0),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [7759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [7761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [7763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [7765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_c_stmt, 2, 0, 21),
  [7767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_process, 8, 0, 68),
  [7769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4933),
  [7771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [7773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_process, 8, 0, 65),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4937),
  [7777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [7779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [7787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_process, 10, 0, 65),
  [7789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [7793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [7805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_process, 10, 0, 68),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [7809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_process, 11, 0, 68),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [7813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_process, 11, 0, 71),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [7825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [7829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [7835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [7843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [7845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [7847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [7851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [7855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [7857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [7859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [7861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [7869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [7871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [7881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_macro_decl_repeat1, 2, 0, 59), SHIFT_REPEAT(5431),
  [7884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_macro_decl_repeat1, 2, 0, 59),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [7888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [7894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [7904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [7906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [7910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [7912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [7916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_proc_decl_repeat1, 2, 0, 0), SHIFT_REPEAT(5030),
  [7919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_proc_decl_repeat1, 2, 0, 0),
  [7921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [7923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [7929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [7931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [7933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [7935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [7937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [7939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [7941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [7943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [7947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [7949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [7955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [7957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [7961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [7963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [7967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [7969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [7971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [7975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [7979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [7981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [7985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [7987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [8001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [8003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [8005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [8011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [8013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [8031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [8033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4354),
  [8035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_with_vars, 4, 0, 0),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [8045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [8051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4549),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5006),
  [8059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4758),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [8087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_c_algorithm_repeat3, 1, 0, 0),
  [8089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_update_fn_appl, 4, 0, 0),
  [8091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 1, 0, 0),
  [8093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 1, 0, 0),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4790),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4791),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4928),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4932),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4936),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [8141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_of_records_repeat1, 2, 0, 0), SHIFT_REPEAT(5356),
  [8144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_set_of_records_repeat1, 2, 0, 0),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [8150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [8160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5030),
  [8162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [8164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [8166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_of_identifiers, 3, 0, 0),
  [8168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(5366),
  [8171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_literal_repeat1, 2, 0, 0),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [8197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_with_vars, 5, 0, 0),
  [8199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pcal_with_vars, 5, 0, 0),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [8205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [8207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [8209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_update_record_field, 2, 0, 2),
  [8211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [8213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_body_def_repeat1, 2, 0, 0), SHIFT_REPEAT(38),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [8224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3993),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5431),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [8243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_finite_set_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(726),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [8252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [8258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_c_algorithm_body_repeat1, 2, 0, 35),
  [8260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_c_algorithm_body_repeat1, 2, 0, 35), SHIFT_REPEAT(3660),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [8269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [8279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [8281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [8285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [8289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assume_prove_repeat1, 2, 0, 0), SHIFT_REPEAT(12),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [8294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_non_terminal_proof_repeat1, 2, 0, 0), SHIFT_REPEAT(5023),
  [8297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [8299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [8303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [8323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [8331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [8333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [8335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [8337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [8339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [8341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [8343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [8345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_p_either_repeat1, 2, 0, 35),
  [8347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pcal_p_either_repeat1, 2, 0, 35), SHIFT_REPEAT(3658),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [8364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [8366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [8374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [8382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [8386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [8388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instance_repeat1, 2, 0, 0), SHIFT_REPEAT(1483),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [8395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [8399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [8403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [8405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5486),
  [8411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [8415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_update_fn_appl, 3, 0, 0),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [8419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [8421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [8423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [8425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [8427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [8431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [8433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [8437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_except_repeat1, 2, 0, 0), SHIFT_REPEAT(4964),
  [8440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_except_repeat1, 2, 0, 0),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3826),
  [8452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_of_identifiers, 4, 0, 0),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [8460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_witness_proof_step, 3, 0, 0),
  [8462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pcal_p_algorithm_repeat3, 1, 0, 0),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [8466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_operator_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5377),
  [8469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operator_declaration_repeat1, 2, 0, 0),
  [8471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [8473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [8475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5376),
  [8477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [8481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5425),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [8485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bound_op_repeat1, 2, 0, 0), SHIFT_REPEAT(60),
  [8488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bound_op_repeat1, 2, 0, 0),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4658),
  [8494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [8496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5511),
  [8498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [8500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [8502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5066),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [8508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_except_update_specifier_repeat1, 1, 0, 0),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [8520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [8528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [8530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4997),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [8546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [8556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_process, 9, 0, 6),
  [8558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_p_if_repeat1, 4, 0, 69),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [8572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [8574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [8576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [8578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [8582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [8586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [8588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [8590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [8592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [8594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [8596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_c_process, 9, 0, 65),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [8604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_p_algorithm, 8, 0, 6),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [8614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [8616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__subscript_expr, 1, 0, 3), SHIFT(64),
  [8619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_p_algorithm, 7, 0, 6),
  [8621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [8623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_macro_decl, 6, 0, 58),
  [8625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [8627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [8629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [8631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_conj_list_repeat1, 1, 0, 0),
  [8633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_p_algorithm, 10, 0, 6),
  [8635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [8637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [8639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inner_assume_prove, 1, 0, 0),
  [8641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [8643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_macro_decl, 4, 0, 6),
  [8645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [8647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_proc_decl, 7, 0, 6),
  [8649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [8651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5138),
  [8653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5141),
  [8655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_p_algorithm, 6, 0, 6),
  [8657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5238),
  [8659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [8661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inner_assume_prove, 3, 0, 0),
  [8663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_macro_decl, 5, 0, 54),
  [8665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [8667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_p_either_repeat1, 2, 0, 20),
  [8669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_p_algorithm, 9, 0, 6),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [8673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [8675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_c_algorithm_body_repeat1, 2, 0, 20),
  [8677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pcal_macro_decl_repeat1, 2, 0, 57),
  [8679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [8681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5466),
  [8683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [8685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_disj_list_repeat1, 1, 0, 0),
  [8687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [8693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [8697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [8699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [8701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [8703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [8705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [8707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [8709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [8711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [8713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [8715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [8725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5459),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [8729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5277),
  [8731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5503),
  [8735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5073),
  [8739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5090),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [8743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [8745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [8747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [8749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [8751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [8753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5474),
  [8755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5418),
  [8757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [8759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [8761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5007),
  [8763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [8767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [8769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [8771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [8773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3595),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [8779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [8781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [8785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [8787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [8789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5506),
  [8793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [8795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5033),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [8801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [8803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4308),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4749),
  [8807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_c_algorithm, 8, 0, 6),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4481),
  [8813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5198),
  [8815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [8821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5380),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [8835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [8837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5038),
  [8839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4797),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [8843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [8853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4917),
  [8855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [8857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [8859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5063),
  [8861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [8863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [8865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [8867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4835),
  [8869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [8871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_take_proof_step, 2, 0, 0),
  [8873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_c_algorithm, 7, 0, 6),
  [8875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [8877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [8879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [8881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [8883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5447),
  [8885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_c_algorithm, 6, 0, 6),
  [8887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [8891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [8893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [8895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [8897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [8899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [8901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [8903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [8905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [8907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [8909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [8911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [8913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [8915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [8917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4948),
  [8919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [8921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [8923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_c_algorithm, 9, 0, 6),
  [8925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [8927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5098),
  [8929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5368),
  [8931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [8933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [8935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_p_algorithm_body, 2, 0, 20),
  [8937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [8939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5292),
  [8941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [8943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [8945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4956),
  [8947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [8949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [8951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [8953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5028),
  [8955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [8957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [8959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [8961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [8963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [8965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [8967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [8969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [8971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [8973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [8975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5492),
  [8977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [8979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [8981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [8983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5285),
  [8985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [8987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [8989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [8991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [8993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [8995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [8997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [8999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [9001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [9003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [9005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [9007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [9009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [9011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_c_algorithm, 10, 0, 6),
  [9013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_proof_step, 3, 0, 0),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [9017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4986),
  [9019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5296),
  [9023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5446),
  [9025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [9027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4257),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [9033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [9035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [9037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [9041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [9043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [9045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [9047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [9049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [9051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [9053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [9055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5291),
  [9057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [9059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [9061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [9063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [9065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [9067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [9069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [9071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [9073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [9075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [9077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [9079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [9081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [9083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [9085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [9087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [9089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5475),
  [9091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [9093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_non_terminal_proof_repeat1, 1, 0, 0),
  [9095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [9097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [9099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [9101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [9103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [9105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [9107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [9109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [9111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [9113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [9115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [9117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [9119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [9121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [9123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [9125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [9127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [9129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [9131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [9133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [9135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [9137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [9139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [9141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [9143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [9145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [9147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5433),
  [9149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [9151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [9153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [9155] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [9157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [9159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [9161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [9163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [9165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_algorithm_start, 2, 0, 0),
  [9167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [9169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [9171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [9173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [9175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [9177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [9179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [9181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fair, 2, 0, 0),
  [9183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [9185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4946),
  [9187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [9189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [9191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [9193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [9195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [9197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_suffices_proof_step, 3, 0, 0),
  [9199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [9201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [9203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [9205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [9207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [9209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [9211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [9213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [9215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [9217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [9219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pcal_algorithm, 1, 0, 1),
  [9221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [9223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [9225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [9227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [9229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [9231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [9233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [9235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [9237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4894),
  [9239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5070),
  [9241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [9243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [9245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [9247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefixed_op, 2, 0, 10), SHIFT(64),
  [9250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pcal_p_algorithm, 11, 0, 6),
  [9252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4968),
  [9254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_proof_step, 3, 0, 0),
  [9256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [9258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pick_proof_step, 5, 0, 0),
  [9260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [9262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5327),
  [9264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [9266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [9270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [9272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [9276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [9282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [9284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [9286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [9288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [9290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5131),
  [9292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [9298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [9300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3534),
  [9302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [9304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [9306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5145),
  [9308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [9310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [9312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 2, 0, 0),
  [9314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_leading_extramodular_text = 0,
  ts_external_token_trailing_extramodular_text = 1,
  ts_external_token__indent = 2,
  ts_external_token__bullet = 3,
  ts_external_token__dedent = 4,
  ts_external_token__begin_proof = 5,
  ts_external_token__begin_proof_step = 6,
  ts_external_token_PROOF = 7,
  ts_external_token_BY = 8,
  ts_external_token_OBVIOUS = 9,
  ts_external_token_OMITTED = 10,
  ts_external_token_QED = 11,
  ts_external_token_WF_ = 12,
  ts_external_token_SF_ = 13,
  ts_external_token__notify_pcal_algorithm_start = 14,
  ts_external_token__notify_pcal_algorithm_end = 15,
  ts_external_token__double_excl = 16,
  ts_external_token__error_sentinel = 17,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_leading_extramodular_text] = sym_leading_extramodular_text,
  [ts_external_token_trailing_extramodular_text] = sym_trailing_extramodular_text,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__bullet] = sym__bullet,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token__begin_proof] = sym__begin_proof,
  [ts_external_token__begin_proof_step] = sym__begin_proof_step,
  [ts_external_token_PROOF] = anon_sym_PROOF,
  [ts_external_token_BY] = anon_sym_BY,
  [ts_external_token_OBVIOUS] = anon_sym_OBVIOUS,
  [ts_external_token_OMITTED] = anon_sym_OMITTED,
  [ts_external_token_QED] = anon_sym_QED,
  [ts_external_token_WF_] = anon_sym_WF_,
  [ts_external_token_SF_] = anon_sym_SF_,
  [ts_external_token__notify_pcal_algorithm_start] = sym__notify_pcal_algorithm_start,
  [ts_external_token__notify_pcal_algorithm_end] = sym__notify_pcal_algorithm_end,
  [ts_external_token__double_excl] = sym__double_excl,
  [ts_external_token__error_sentinel] = sym__error_sentinel,
};

static const bool ts_external_scanner_states[20][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_leading_extramodular_text] = true,
    [ts_external_token_trailing_extramodular_text] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__bullet] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token__begin_proof] = true,
    [ts_external_token__begin_proof_step] = true,
    [ts_external_token_PROOF] = true,
    [ts_external_token_BY] = true,
    [ts_external_token_OBVIOUS] = true,
    [ts_external_token_OMITTED] = true,
    [ts_external_token_QED] = true,
    [ts_external_token_WF_] = true,
    [ts_external_token_SF_] = true,
    [ts_external_token__notify_pcal_algorithm_start] = true,
    [ts_external_token__notify_pcal_algorithm_end] = true,
    [ts_external_token__double_excl] = true,
    [ts_external_token__error_sentinel] = true,
  },
  [2] = {
    [ts_external_token_leading_extramodular_text] = true,
  },
  [3] = {
    [ts_external_token__indent] = true,
    [ts_external_token_QED] = true,
    [ts_external_token_WF_] = true,
    [ts_external_token_SF_] = true,
    [ts_external_token__double_excl] = true,
  },
  [4] = {
    [ts_external_token__indent] = true,
    [ts_external_token_WF_] = true,
    [ts_external_token_SF_] = true,
    [ts_external_token__double_excl] = true,
  },
  [5] = {
    [ts_external_token__indent] = true,
    [ts_external_token__begin_proof_step] = true,
    [ts_external_token_WF_] = true,
    [ts_external_token_SF_] = true,
    [ts_external_token__double_excl] = true,
  },
  [6] = {
    [ts_external_token__double_excl] = true,
  },
  [7] = {
    [ts_external_token__begin_proof] = true,
    [ts_external_token_PROOF] = true,
    [ts_external_token_BY] = true,
    [ts_external_token_OBVIOUS] = true,
    [ts_external_token_OMITTED] = true,
    [ts_external_token__double_excl] = true,
  },
  [8] = {
    [ts_external_token__begin_proof_step] = true,
    [ts_external_token__double_excl] = true,
  },
  [9] = {
    [ts_external_token__begin_proof] = true,
    [ts_external_token__begin_proof_step] = true,
    [ts_external_token_PROOF] = true,
    [ts_external_token_BY] = true,
    [ts_external_token_OBVIOUS] = true,
    [ts_external_token_OMITTED] = true,
    [ts_external_token__double_excl] = true,
  },
  [10] = {
    [ts_external_token__bullet] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token__double_excl] = true,
  },
  [11] = {
    [ts_external_token__begin_proof] = true,
    [ts_external_token_PROOF] = true,
    [ts_external_token_BY] = true,
    [ts_external_token_OBVIOUS] = true,
    [ts_external_token_OMITTED] = true,
  },
  [12] = {
    [ts_external_token_trailing_extramodular_text] = true,
  },
  [13] = {
    [ts_external_token__begin_proof_step] = true,
  },
  [14] = {
    [ts_external_token__begin_proof] = true,
    [ts_external_token__begin_proof_step] = true,
    [ts_external_token_PROOF] = true,
    [ts_external_token_BY] = true,
    [ts_external_token_OBVIOUS] = true,
    [ts_external_token_OMITTED] = true,
  },
  [15] = {
    [ts_external_token__bullet] = true,
  },
  [16] = {
    [ts_external_token__bullet] = true,
    [ts_external_token__dedent] = true,
  },
  [17] = {
    [ts_external_token__begin_proof] = true,
    [ts_external_token_BY] = true,
    [ts_external_token_OBVIOUS] = true,
    [ts_external_token_OMITTED] = true,
  },
  [18] = {
    [ts_external_token__notify_pcal_algorithm_end] = true,
  },
  [19] = {
    [ts_external_token__notify_pcal_algorithm_start] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_tlaplus_external_scanner_create(void);
void tree_sitter_tlaplus_external_scanner_destroy(void *);
bool tree_sitter_tlaplus_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_tlaplus_external_scanner_serialize(void *, char *);
void tree_sitter_tlaplus_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_tlaplus(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_tlaplus_external_scanner_create,
      tree_sitter_tlaplus_external_scanner_destroy,
      tree_sitter_tlaplus_external_scanner_scan,
      tree_sitter_tlaplus_external_scanner_serialize,
      tree_sitter_tlaplus_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
